/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var te=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/log/common/log","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/base/common/path","vs/nls!vs/code/electron-main/main","vs/base/common/types","vs/nls","vs/base/common/errors","electron","vs/base/common/network","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/resources","vs/platform/configuration/common/configuration","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/arrays","vs/base/node/pfs","vs/platform/telemetry/common/telemetry","os","vs/base/common/strings","vs/platform/windows/electron-main/windows","vs/platform/workspace/common/workspace","vs/platform/environment/electron-main/environmentMainService","vs/base/common/uuid","vs/base/common/extpath","vs/platform/state/node/state","vs/platform/environment/common/environment","vs/base/common/map","vs/base/common/process","vs/platform/policy/common/policy","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","fs","vs/base/parts/ipc/electron-main/ipcMain","vs/base/common/json","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/telemetry/common/telemetryUtils","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/errorMessage","child_process","vs/platform/registry/common/platform","vs/platform/request/common/request","vs/platform/userDataProfile/electron-main/userDataProfile","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/base/common/hash","vs/platform/remote/common/remoteHosts","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/base/common/stream","vs/base/common/ternarySearchTree","vs/platform/environment/node/argvHelper","vs/platform/backup/electron-main/backup","vs/base/common/performance","vs/platform/log/electron-main/loggerService","vs/platform/configuration/common/configurationRegistry","vs/platform/utilityProcess/electron-main/utilityProcess","vs/base/common/iterator","crypto","net","vs/base/common/processes","vs/base/common/severity","vs/platform/instantiation/common/descriptors","vs/platform/credentials/common/credentials","vs/platform/files/common/watcher","vs/platform/product/common/product","vs/platform/protocol/electron-main/protocol","vs/platform/theme/electron-main/themeMainService","vs/platform/window/common/window","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/marshalling","vs/base/node/id","vs/base/node/processes","vs/base/node/unc","vs/platform/diagnostics/common/diagnostics","vs/platform/dialogs/common/dialogs","vs/platform/instantiation/common/serviceCollection","vs/platform/files/node/diskFileSystemProvider","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/storage/common/storage","vs/platform/workspaces/common/workspaces","vs/platform/workspaces/node/workspaces","vs/base/parts/ipc/node/ipc.net","vs/platform/storage/electron-main/storageMainService","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/linkedList","vs/base/node/ports","vs/base/common/glob","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/environment/node/environmentService","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagement","vs/platform/externalTerminal/common/externalTerminal","vs/platform/files/common/io","vs/platform/configuration/common/configurationModels","vs/platform/extensions/common/extensions","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/electron-main/telemetryUtils","vs/platform/tunnel/common/tunnel","vs/platform/url/common/url","vs/platform/window/electron-main/window","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/windows/electron-main/windowsFinder","vs/platform/diagnostics/electron-main/diagnosticsMainService","vs/base/common/color","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/codicons","vs/base/common/themables","vs/base/node/crypto","vs/base/node/macAddress","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/contextmenu/electron-main/contextmenu","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","util","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/node/storage","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/dialogs/common/dialogs","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderServer","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/windows/electron-main/windowImpl","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/backup/common/backup","vs/platform/backup/node/backup","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/wait","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensions/common/extensionValidator","vs/base/common/semver/semver","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/extensions/common/extensionHostStarter","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/issue/common/issue","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/files/electron-main/diskFileSystemProviderServer","vs/platform/log/common/bufferLog","vs/platform/log/common/logService","vs/platform/log/electron-main/logIpc","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/policy/common/filePolicyService","vs/platform/policy/common/policyIpc","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/profiling/electron-main/windowProfiling","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/node/wsl","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","url","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetryUtils","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/utilityProcess/common/utilityProcessWorkerService","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/code/electron-main/auth","vs/platform/credentials/electron-main/credentialsMainService","vs/platform/launch/electron-main/launchMainService","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/storage/electron-main/storageIpc","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/storage/electron-main/storageMain","vs/platform/userDataProfile/electron-main/userDataProfileStorageIpc","vs/platform/userDataProfile/node/userDataProfile","zlib","vs/platform/backup/electron-main/backupMainService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/tunnel/node/tunnelService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/platform/userDataProfile/electron-main/userDataProfilesHandler","vs/platform/extensions/electron-main/extensionHostStarter","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/utilityProcess/electron-main/utilityProcessWorkerMainService","vs/platform/windows/electron-main/windowsStateHandler","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/windowImpl","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","minimist","assert","graceful-fs","@vscode/policy-watcher","https","string_decoder","vs/code/electron-main/main"],ie=function(x){for(var e=[],E=0,M=x.length;E<M;E++)e[E]=te[x[E]];return e};define(te[126],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Color=e.HSVA=e.HSLA=e.RGBA=void 0;function E(k,h){const l=Math.pow(10,h);return Math.round(k*l)/l}class M{constructor(h,l,p,m=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,l))|0,this.b=Math.min(255,Math.max(0,p))|0,this.a=E(Math.max(Math.min(1,m),0),3)}static equals(h,l){return h.r===l.r&&h.g===l.g&&h.b===l.b&&h.a===l.a}}e.RGBA=M;class s{constructor(h,l,p,m){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=E(Math.max(Math.min(1,l),0),3),this.l=E(Math.max(Math.min(1,p),0),3),this.a=E(Math.max(Math.min(1,m),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.l===l.l&&h.a===l.a}static fromRGBA(h){const l=h.r/255,p=h.g/255,m=h.b/255,v=h.a,f=Math.max(l,p,m),y=Math.min(l,p,m);let w=0,r=0;const g=(y+f)/2,c=f-y;if(c>0){switch(r=Math.min(g<=.5?c/(2*g):c/(2-2*g),1),f){case l:w=(p-m)/c+(p<m?6:0);break;case p:w=(m-l)/c+2;break;case m:w=(l-p)/c+4;break}w*=60,w=Math.round(w)}return new s(w,r,g,v)}static i(h,l,p){return p<0&&(p+=1),p>1&&(p-=1),p<1/6?h+(l-h)*6*p:p<1/2?l:p<2/3?h+(l-h)*(2/3-p)*6:h}static toRGBA(h){const l=h.h/360,{s:p,l:m,a:v}=h;let f,y,w;if(p===0)f=y=w=m;else{const r=m<.5?m*(1+p):m+p-m*p,g=2*m-r;f=s.i(g,r,l+1/3),y=s.i(g,r,l),w=s.i(g,r,l-1/3)}return new M(Math.round(f*255),Math.round(y*255),Math.round(w*255),v)}}e.HSLA=s;class L{constructor(h,l,p,m){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=E(Math.max(Math.min(1,l),0),3),this.v=E(Math.max(Math.min(1,p),0),3),this.a=E(Math.max(Math.min(1,m),0),3)}static equals(h,l){return h.h===l.h&&h.s===l.s&&h.v===l.v&&h.a===l.a}static fromRGBA(h){const l=h.r/255,p=h.g/255,m=h.b/255,v=Math.max(l,p,m),f=Math.min(l,p,m),y=v-f,w=v===0?0:y/v;let r;return y===0?r=0:v===l?r=((p-m)/y%6+6)%6:v===p?r=(m-l)/y+2:r=(l-p)/y+4,new L(Math.round(r*60),w,v,h.a)}static toRGBA(h){const{h:l,s:p,v:m,a:v}=h,f=m*p,y=f*(1-Math.abs(l/60%2-1)),w=m-f;let[r,g,c]=[0,0,0];return l<60?(r=f,g=y):l<120?(r=y,g=f):l<180?(g=f,c=y):l<240?(g=y,c=f):l<300?(r=y,c=f):l<=360&&(r=f,c=y),r=Math.round((r+w)*255),g=Math.round((g+w)*255),c=Math.round((c+w)*255),new M(r,g,c,v)}}e.HSVA=L;class R{static fromHex(h){return R.Format.CSS.parseHex(h)||R.red}static equals(h,l){return!h&&!l?!0:!h||!l?!1:h.equals(l)}get hsla(){return this.i?this.i:s.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:L.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof M)this.rgba=h;else if(h instanceof s)this.i=h,this.rgba=s.toRGBA(h);else if(h instanceof L)this.j=h,this.rgba=L.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&M.equals(this.rgba,h.rgba)&&s.equals(this.hsla,h.hsla)&&L.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=R.k(this.rgba.r),l=R.k(this.rgba.g),p=R.k(this.rgba.b),m=.2126*h+.7152*l+.0722*p;return E(m,4)}static k(h){const l=h/255;return l<=.03928?l/12.92:Math.pow((l+.055)/1.055,2.4)}getContrastRatio(h){const l=this.getRelativeLuminance(),p=h.getRelativeLuminance();return l>p?(l+.05)/(p+.05):(p+.05)/(l+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const l=this.getRelativeLuminance(),p=h.getRelativeLuminance();return l>p}isDarkerThan(h){const l=this.getRelativeLuminance(),p=h.getRelativeLuminance();return l<p}lighten(h){return new R(new s(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new R(new s(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:l,g:p,b:m,a:v}=this.rgba;return new R(new M(l,p,m,v*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new R(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const l=h.rgba,p=this.rgba.a,m=l.a,v=p+m*(1-p);if(v<1e-6)return R.transparent;const f=this.rgba.r*p/v+l.r*m*(1-p)/v,y=this.rgba.g*p/v+l.g*m*(1-p)/v,w=this.rgba.b*p/v+l.b*m*(1-p)/v;return new R(new M(f,y,w,v))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:l,g:p,b:m,a:v}=this.rgba;return new R(new M(h.rgba.r-v*(h.rgba.r-l),h.rgba.g-v*(h.rgba.g-p),h.rgba.b-v*(h.rgba.b-m),1))}flatten(...h){const l=h.reduceRight((p,m)=>R.o(m,p));return R.o(this,l)}static o(h,l){const p=1-h.rgba.a;return new R(new M(p*l.rgba.r+h.rgba.a*h.rgba.r,p*l.rgba.g+h.rgba.a*h.rgba.g,p*l.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=R.Format.CSS.format(this)),this.u}static getLighterColor(h,l,p){if(h.isLighterThan(l))return h;p=p||.5;const m=h.getRelativeLuminance(),v=l.getRelativeLuminance();return p=p*(v-m)/v,h.lighten(p)}static getDarkerColor(h,l,p){if(h.isDarkerThan(l))return h;p=p||.5;const m=h.getRelativeLuminance(),v=l.getRelativeLuminance();return p=p*(m-v)/m,h.darken(p)}}e.Color=R,R.white=new R(new M(255,255,255,1)),R.black=new R(new M(0,0,0,1)),R.red=new R(new M(255,0,0,1)),R.blue=new R(new M(0,0,255,1)),R.green=new R(new M(0,255,0,1)),R.cyan=new R(new M(0,255,255,1)),R.lightgrey=new R(new M(211,211,211,1)),R.transparent=new R(new M(0,0,0,0)),function(k){let h;(function(l){let p;(function(m){function v(t){return t.rgba.a===1?`rgb(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b})`:k.Format.CSS.formatRGBA(t)}m.formatRGB=v;function f(t){return`rgba(${t.rgba.r}, ${t.rgba.g}, ${t.rgba.b}, ${+t.rgba.a.toFixed(2)})`}m.formatRGBA=f;function y(t){return t.hsla.a===1?`hsl(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%)`:k.Format.CSS.formatHSLA(t)}m.formatHSL=y;function w(t){return`hsla(${t.hsla.h}, ${(t.hsla.s*100).toFixed(2)}%, ${(t.hsla.l*100).toFixed(2)}%, ${t.hsla.a.toFixed(2)})`}m.formatHSLA=w;function r(t){const a=t.toString(16);return a.length!==2?"0"+a:a}function g(t){return`#${r(t.rgba.r)}${r(t.rgba.g)}${r(t.rgba.b)}`}m.formatHex=g;function c(t,a=!1){return a&&t.rgba.a===1?k.Format.CSS.formatHex(t):`#${r(t.rgba.r)}${r(t.rgba.g)}${r(t.rgba.b)}${r(Math.round(t.rgba.a*255))}`}m.formatHexA=c;function b(t){return t.isOpaque()?k.Format.CSS.formatHex(t):k.Format.CSS.formatRGBA(t)}m.format=b;function S(t){const a=t.length;if(a===0||t.charCodeAt(0)!==35)return null;if(a===7){const i=16*D(t.charCodeAt(1))+D(t.charCodeAt(2)),n=16*D(t.charCodeAt(3))+D(t.charCodeAt(4)),o=16*D(t.charCodeAt(5))+D(t.charCodeAt(6));return new k(new M(i,n,o,1))}if(a===9){const i=16*D(t.charCodeAt(1))+D(t.charCodeAt(2)),n=16*D(t.charCodeAt(3))+D(t.charCodeAt(4)),o=16*D(t.charCodeAt(5))+D(t.charCodeAt(6)),u=16*D(t.charCodeAt(7))+D(t.charCodeAt(8));return new k(new M(i,n,o,u/255))}if(a===4){const i=D(t.charCodeAt(1)),n=D(t.charCodeAt(2)),o=D(t.charCodeAt(3));return new k(new M(16*i+i,16*n+n,16*o+o))}if(a===5){const i=D(t.charCodeAt(1)),n=D(t.charCodeAt(2)),o=D(t.charCodeAt(3)),u=D(t.charCodeAt(4));return new k(new M(16*i+i,16*n+n,16*o+o,(16*u+u)/255))}return null}m.parseHex=S;function D(t){switch(t){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(p=l.CSS||(l.CSS={}))})(h=k.Format||(k.Format={}))}(R||(e.Color=R={}))}),define(te[55],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(R){return(k,h,l)=>{let p=null,m=null;if(typeof l.value=="function"?(p="value",m=l.value):typeof l.get=="function"&&(p="get",m=l.get),!m)throw new Error("not supported");l[p]=R(m,h)}}function M(R,k,h){let l=null,p=null;if(typeof h.value=="function"?(l="value",p=h.value,p.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(l="get",p=h.get),!p)throw new Error("not supported");const m=`$memoize$${k}`;h[l]=function(...v){return this.hasOwnProperty(m)||Object.defineProperty(this,m,{configurable:!1,enumerable:!1,writable:!1,value:p.apply(this,v)}),this[m]}}e.memoize=M;function s(R,k,h){return E((l,p)=>{const m=`$debounce$${p}`,v=`$debounce$result$${p}`;return function(...f){this[v]||(this[v]=h?h():void 0),clearTimeout(this[m]),k&&(this[v]=k(this[v],...f),f=[this[v]]),this[m]=setTimeout(()=>{l.apply(this,f),this[v]=h?h():void 0},R)}})}e.debounce=s;function L(R,k,h){return E((l,p)=>{const m=`$throttle$timer$${p}`,v=`$throttle$result$${p}`,f=`$throttle$lastRun$${p}`,y=`$throttle$pending$${p}`;return function(...w){if(this[v]||(this[v]=h?h():void 0),(this[f]===null||this[f]===void 0)&&(this[f]=-Number.MAX_VALUE),k&&(this[v]=k(this[v],...w)),this[y])return;const r=this[f]+R;r<=Date.now()?(this[f]=Date.now(),l.apply(this,[this[v]]),this[v]=h?h():void 0):(this[y]=!0,this[m]=setTimeout(()=>{this[y]=!1,this[f]=Date.now(),l.apply(this,[this[v]]),this[v]=h?h():void 0},r-Date.now()))}})}e.throttle=L}),define(te[13],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(a){setTimeout(()=>{throw a.stack?S.isErrorNoTelemetry(a)?new S(a.message+`

`+a.stack):new Error(a.message+`

`+a.stack):a},0)}}addListener(a){return this.b.push(a),()=>{this.d(a)}}c(a){this.b.forEach(i=>{i(a)})}d(a){this.b.splice(this.b.indexOf(a),1)}setUnexpectedErrorHandler(a){this.a=a}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(a){this.a(a),this.c(a)}onUnexpectedExternalError(a){this.a(a)}}e.ErrorHandler=E,e.errorHandler=new E;function M(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=M;function s(t){if(!t||typeof t!="object")return!1;const a=t;return a.code==="EPIPE"&&a.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=s;function L(t){l(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=L;function R(t){l(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=R;function k(t){if(t instanceof Error){const{name:a,message:i}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:a,message:i,stack:n,noTelemetry:S.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=k;const h="Canceled";function l(t){return t instanceof p?!0:t instanceof Error&&t.name===h&&t.message===h}e.isCancellationError=l;class p extends Error{constructor(){super(h),this.name=this.message}}e.CancellationError=p;function m(){const t=new Error(h);return t.name=t.message,t}e.canceled=m;function v(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=v;function f(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=f;function y(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function w(t){const a=new Error(`${t} has been disposed`);return a.name="DISPOSED",a}e.disposed=w;function r(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=r;class g extends Error{constructor(a){super("NotImplemented"),a&&(this.message=a)}}e.NotImplementedError=g;class c extends Error{constructor(a){super("NotSupported"),a&&(this.message=a)}}e.NotSupportedError=c;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class S extends Error{constructor(a){super(a),this.name="CodeExpectedError"}static fromError(a){if(a instanceof S)return a;const i=new S;return i.message=a.message,i.stack=a.stack,i}static isErrorNoTelemetry(a){return a.name==="CodeExpectedError"}}e.ErrorNoTelemetry=S;class D extends Error{constructor(a){super(a||"An unexpected bug occurred."),Object.setPrototypeOf(this,D.prototype);debugger}}e.BugIndicatingError=D}),define(te[23],ie([0,1,13]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function M(U,V=0){return U[U.length-(1+V)]}e.tail=M;function s(U){if(U.length===0)throw new Error("Invalid tail call");return[U.slice(0,U.length-1),U[U.length-1]]}e.tail2=s;function L(U,V,G=(re,ae)=>re===ae){if(U===V)return!0;if(!U||!V||U.length!==V.length)return!1;for(let re=0,ae=U.length;re<ae;re++)if(!G(U[re],V[re]))return!1;return!0}e.equals=L;function R(U,V){const G=U.length-1;V<G&&(U[V]=U[G]),U.pop()}e.removeFastWithoutKeepingOrder=R;function k(U,V,G){return h(U.length,re=>G(U[re],V))}e.binarySearch=k;function h(U,V){let G=0,re=U-1;for(;G<=re;){const ae=(G+re)/2|0,ye=V(ae);if(ye<0)G=ae+1;else if(ye>0)re=ae-1;else return ae}return-(G+1)}e.binarySearch2=h;function l(U,V){let G=0,re=U.length;if(re===0)return 0;for(;G<re;){const ae=Math.floor((G+re)/2);V(U[ae])?re=ae:G=ae+1}return G}e.findFirstInSorted=l;function p(U,V,G){if(U=U|0,U>=V.length)throw new TypeError("invalid index");const re=V[Math.floor(V.length*Math.random())],ae=[],ye=[],Ce=[];for(const Ae of V){const Me=G(Ae,re);Me<0?ae.push(Ae):Me>0?ye.push(Ae):Ce.push(Ae)}return U<ae.length?p(U,ae,G):U<ae.length+Ce.length?Ce[0]:p(U-(ae.length+Ce.length),ye,G)}e.quickSelect=p;function m(U,V){const G=[];let re;for(const ae of U.slice(0).sort(V))!re||V(re[0],ae)!==0?(re=[ae],G.push(re)):re.push(ae);return G}e.groupBy=m;function v(U,V,G){const re=[];function ae(Ae,Me,Fe){if(Me===0&&Fe.length===0)return;const ve=re[re.length-1];ve&&ve.start+ve.deleteCount===Ae?(ve.deleteCount+=Me,ve.toInsert.push(...Fe)):re.push({start:Ae,deleteCount:Me,toInsert:Fe})}let ye=0,Ce=0;for(;;){if(ye===U.length){ae(ye,0,V.slice(Ce));break}if(Ce===V.length){ae(ye,U.length-ye,[]);break}const Ae=U[ye],Me=V[Ce],Fe=G(Ae,Me);Fe===0?(ye+=1,Ce+=1):Fe<0?(ae(ye,1,[]),ye+=1):Fe>0&&(ae(ye,0,[Me]),Ce+=1)}return re}e.sortedDiff=v;function f(U,V,G){const re=v(U,V,G),ae=[],ye=[];for(const Ce of re)ae.push(...U.slice(Ce.start,Ce.start+Ce.deleteCount)),ye.push(...Ce.toInsert);return{removed:ae,added:ye}}e.delta=f;function y(U,V,G){if(G===0)return[];const re=U.slice(0,G).sort(V);return r(U,V,re,G,U.length),re}e.top=y;function w(U,V,G,re,ae){return G===0?Promise.resolve([]):new Promise((ye,Ce)=>{(async()=>{const Ae=U.length,Me=U.slice(0,G).sort(V);for(let Fe=G,ve=Math.min(G+re,Ae);Fe<Ae;Fe=ve,ve=Math.min(ve+re,Ae)){if(Fe>G&&await new Promise(we=>setTimeout(we)),ae&&ae.isCancellationRequested)throw new E.CancellationError;r(U,V,Me,Fe,ve)}return Me})().then(ye,Ce)})}e.topAsync=w;function r(U,V,G,re,ae){for(const ye=G.length;re<ae;re++){const Ce=U[re];if(V(Ce,G[ye-1])<0){G.pop();const Ae=l(G,Me=>V(Ce,Me)<0);G.splice(Ae,0,Ce)}}}function g(U){return U.filter(V=>!!V)}e.coalesce=g;function c(U){let V=0;for(let G=0;G<U.length;G++)U[G]&&(U[V]=U[G],V+=1);U.length=V}e.coalesceInPlace=c;function b(U,V,G){U.splice(G,0,U.splice(V,1)[0])}e.move=b;function S(U){return!Array.isArray(U)||U.length===0}e.isFalsyOrEmpty=S;function D(U){return Array.isArray(U)&&U.length>0}e.isNonEmptyArray=D;function t(U,V=G=>G){const G=new Set;return U.filter(re=>{const ae=V(re);return G.has(ae)?!1:(G.add(ae),!0)})}e.distinct=t;function a(U){const V=new Set;return G=>{const re=U(G);return V.has(re)?!1:(V.add(re),!0)}}e.uniqueFilter=a;function i(U,V){const G=n(U,V);if(G!==-1)return U[G]}e.findLast=i;function n(U,V){for(let G=U.length-1;G>=0;G--){const re=U[G];if(V(re))return G}return-1}e.lastIndex=n;function o(U,V){return U.length>0?U[0]:V}e.firstOrDefault=o;function u(U,V){return U.length>0?U[U.length-1]:V}e.lastOrDefault=u;function d(U,V,G=(re,ae)=>re===ae){let re=0;for(let ae=0,ye=Math.min(U.length,V.length);ae<ye&&G(U[ae],V[ae]);ae++)re++;return re}e.commonPrefixLength=d;function I(U){return[].concat(...U)}e.flatten=I;function A(U,V){let G=typeof V=="number"?U:0;typeof V=="number"?G=U:(G=0,V=U);const re=[];if(G<=V)for(let ae=G;ae<V;ae++)re.push(ae);else for(let ae=G;ae>V;ae--)re.push(ae);return re}e.range=A;function C(U,V,G){return U.reduce((re,ae)=>(re[V(ae)]=G?G(ae):ae,re),Object.create(null))}e.index=C;function T(U,V){return U.push(V),()=>W(U,V)}e.insert=T;function W(U,V){const G=U.indexOf(V);if(G>-1)return U.splice(G,1),V}e.remove=W;function $(U,V,G){const re=U.slice(0,V),ae=U.slice(V);return re.concat(G,ae)}e.arrayInsert=$;function H(U,V){let G;if(typeof V=="number"){let re=V;G=()=>{const ae=Math.sin(re++)*179426549;return ae-Math.floor(ae)}}else G=Math.random;for(let re=U.length-1;re>0;re-=1){const ae=Math.floor(G()*(re+1)),ye=U[re];U[re]=U[ae],U[ae]=ye}}e.shuffle=H;function Z(U,V){const G=U.indexOf(V);G>-1&&(U.splice(G,1),U.unshift(V))}e.pushToStart=Z;function ne(U,V){const G=U.indexOf(V);G>-1&&(U.splice(G,1),U.push(V))}e.pushToEnd=ne;function se(U,V){for(const G of V)U.push(G)}e.pushMany=se;function ue(U,V){return Array.isArray(U)?U.map(V):V(U)}e.mapArrayOrNot=ue;function ce(U){return Array.isArray(U)?U:[U]}e.asArray=ce;function X(U){return U[Math.floor(Math.random()*U.length)]}e.getRandomElement=X;function q(U,V){for(const G of U){const re=V(G);if(re!==void 0)return re}}e.mapFind=q;function B(U,V,G){const re=K(U,V),ae=U.length,ye=G.length;U.length=ae+ye;for(let Ce=ae-1;Ce>=re;Ce--)U[Ce+ye]=U[Ce];for(let Ce=0;Ce<ye;Ce++)U[Ce+re]=G[Ce]}e.insertInto=B;function z(U,V,G,re){const ae=K(U,V),ye=U.splice(ae,G);return B(U,ae,re),ye}e.splice=z;function K(U,V){return V<0?Math.max(V+U.length,0):Math.min(V,U.length)}var ee;(function(U){function V(ae){return ae<0}U.isLessThan=V;function G(ae){return ae>0}U.isGreaterThan=G;function re(ae){return ae===0}U.isNeitherLessOrGreaterThan=re,U.greaterThan=1,U.lessThan=-1,U.neitherLessOrGreaterThan=0})(ee||(e.CompareResult=ee={}));function oe(U,V){return(G,re)=>V(U(G),U(re))}e.compareBy=oe;function le(...U){return(V,G)=>{for(const re of U){const ae=re(V,G);if(!ee.isNeitherLessOrGreaterThan(ae))return ae}return ee.neitherLessOrGreaterThan}}e.tieBreakComparators=le;const Y=(U,V)=>U-V;e.numberComparator=Y;function O(U,V){if(U.length===0)return;let G=U[0];for(let re=1;re<U.length;re++){const ae=U[re];V(ae,G)>0&&(G=ae)}return G}e.findMaxBy=O;function P(U,V){if(U.length===0)return;let G=U[0];for(let re=1;re<U.length;re++){const ae=U[re];V(ae,G)>=0&&(G=ae)}return G}e.findLastMaxBy=P;function F(U,V){return O(U,(G,re)=>-V(G,re))}e.findMinBy=F;class N{constructor(V){this.f=V,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(V){let G=this.c;for(;G<this.f.length&&V(this.f[G]);)G++;const re=G===this.c?null:this.f.slice(this.c,G);return this.c=G,re}takeFromEndWhile(V){let G=this.d;for(;G>=0&&V(this.f[G]);)G--;const re=G===this.d?null:this.f.slice(G+1,this.d+1);return this.d=G,re}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const V=this.f[this.c];return this.c++,V}removeLast(){const V=this.f[this.d];return this.d--,V}takeCount(V){const G=this.f.slice(this.c,this.c+V);return this.c+=V,G}}e.ArrayQueue=N;class j{constructor(V){this.iterate=V}forEach(V){this.iterate(G=>(V(G),!0))}toArray(){const V=[];return this.iterate(G=>(V.push(G),!0)),V}filter(V){return new j(G=>this.iterate(re=>V(re)?G(re):!0))}map(V){return new j(G=>this.iterate(re=>G(V(re))))}some(V){let G=!1;return this.iterate(re=>(G=V(re),!G)),G}findFirst(V){let G;return this.iterate(re=>V(re)?(G=re,!1):!0),G}findLast(V){let G;return this.iterate(re=>(V(re)&&(G=re),!0)),G}findLastMaxBy(V){let G,re=!0;return this.iterate(ae=>((re||ee.isGreaterThan(V(ae,G)))&&(re=!1,G=ae),!0)),G}}e.CallbackIterable=j,j.empty=new j(U=>{})}),define(te[127],ie([0,1,13]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function M(h,l){if(!h)throw new Error(l?`Assertion failed (${l})`:"Assertion Failed")}e.ok=M;function s(h,l="Unreachable"){throw new Error(l)}e.assertNever=s;function L(h){if(!h)throw new E.BugIndicatingError("Assertion Failed")}e.assert=L;function R(h){if(!h()){debugger;h(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=R;function k(h,l){let p=0;for(;p<h.length-1;){const m=h[p],v=h[p+1];if(!l(m,v))return!1;p++}return!0}e.checkAdjacentItems=k}),define(te[48],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(M){const s=this;let L=!1,R;return function(){return L||(L=!0,R=M.apply(s,arguments)),R}}e.once=E}),define(te[68],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(M){function s(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}M.is=s;const L=Object.freeze([]);function R(){return L}M.empty=R;function*k(S){yield S}M.single=k;function h(S){return s(S)?S:k(S)}M.wrap=h;function l(S){return S||L}M.from=l;function p(S){return!S||S[Symbol.iterator]().next().done===!0}M.isEmpty=p;function m(S){return S[Symbol.iterator]().next().value}M.first=m;function v(S,D){for(const t of S)if(D(t))return!0;return!1}M.some=v;function f(S,D){for(const t of S)if(D(t))return t}M.find=f;function*y(S,D){for(const t of S)D(t)&&(yield t)}M.filter=y;function*w(S,D){let t=0;for(const a of S)yield D(a,t++)}M.map=w;function*r(...S){for(const D of S)for(const t of D)yield t}M.concat=r;function g(S,D,t){let a=t;for(const i of S)a=D(a,i);return a}M.reduce=g;function*c(S,D,t=S.length){for(D<0&&(D+=S.length),t<0?t+=S.length:t>S.length&&(t=S.length);D<t;D++)yield S[D]}M.slice=c;function b(S,D=Number.POSITIVE_INFINITY){const t=[];if(D===0)return[t,S];const a=S[Symbol.iterator]();for(let i=0;i<D;i++){const n=a.next();if(n.done)return[t,M.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return a}}]}M.consume=b})(E||(e.Iterable=E={}))}),define(te[43],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E||(e.ScanError=E={}));var M;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(M||(e.SyntaxKind=M={}));var s;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(s||(e.ParseErrorCode=s={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(t,a=!1){let i=0;const n=t.length;let o="",u=0,d=16,I=0;function A(ne){let se=0,ue=0;for(;se<ne;){const ce=t.charCodeAt(i);if(ce>=48&&ce<=57)ue=ue*16+ce-48;else if(ce>=65&&ce<=70)ue=ue*16+ce-65+10;else if(ce>=97&&ce<=102)ue=ue*16+ce-97+10;else break;i++,se++}return se<ne&&(ue=-1),ue}function C(ne){i=ne,o="",u=0,d=16,I=0}function T(){const ne=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&l(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&l(t.charCodeAt(i)))for(i++;i<t.length&&l(t.charCodeAt(i));)i++;else return I=3,t.substring(ne,i);let se=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&l(t.charCodeAt(i))){for(i++;i<t.length&&l(t.charCodeAt(i));)i++;se=i}else I=3;return t.substring(ne,se)}function W(){let ne="",se=i;for(;;){if(i>=n){ne+=t.substring(se,i),I=2;break}const ue=t.charCodeAt(i);if(ue===34){ne+=t.substring(se,i),i++;break}if(ue===92){if(ne+=t.substring(se,i),i++,i>=n){I=2;break}switch(t.charCodeAt(i++)){case 34:ne+='"';break;case 92:ne+="\\";break;case 47:ne+="/";break;case 98:ne+="\b";break;case 102:ne+="\f";break;case 110:ne+=`
`;break;case 114:ne+="\r";break;case 116:ne+="	";break;case 117:{const X=A(4);X>=0?ne+=String.fromCharCode(X):I=4;break}default:I=5}se=i;continue}if(ue>=0&&ue<=31)if(h(ue)){ne+=t.substring(se,i),I=2;break}else I=6;i++}return ne}function $(){if(o="",I=0,u=i,i>=n)return u=n,d=17;let ne=t.charCodeAt(i);if(k(ne)){do i++,o+=String.fromCharCode(ne),ne=t.charCodeAt(i);while(k(ne));return d=15}if(h(ne))return i++,o+=String.fromCharCode(ne),ne===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),d=14;switch(ne){case 123:return i++,d=1;case 125:return i++,d=2;case 91:return i++,d=3;case 93:return i++,d=4;case 58:return i++,d=6;case 44:return i++,d=5;case 34:return i++,o=W(),d=10;case 47:{const se=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!h(t.charCodeAt(i));)i++;return o=t.substring(se,i),d=12}if(t.charCodeAt(i+1)===42){i+=2;const ue=n-1;let ce=!1;for(;i<ue;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,ce=!0;break}i++}return ce||(i++,I=1),o=t.substring(se,i),d=13}return o+=String.fromCharCode(ne),i++,d=16}case 45:if(o+=String.fromCharCode(ne),i++,i===n||!l(t.charCodeAt(i)))return d=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=T(),d=11;default:for(;i<n&&H(ne);)i++,ne=t.charCodeAt(i);if(u!==i){switch(o=t.substring(u,i),o){case"true":return d=8;case"false":return d=9;case"null":return d=7}return d=16}return o+=String.fromCharCode(ne),i++,d=16}}function H(ne){if(k(ne)||h(ne))return!1;switch(ne){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Z(){let ne;do ne=$();while(ne>=12&&ne<=15);return ne}return{setPosition:C,getPosition:()=>i,scan:a?Z:$,getToken:()=>d,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>i-u,getTokenError:()=>I}}e.createScanner=R;function k(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function h(t){return t===10||t===13||t===8232||t===8233}function l(t){return t>=48&&t<=57}var p;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(p||(p={}));function m(t,a){const i=[],n=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let d=!1;function I(A,C,T,W){u.value=A,u.offset=C,u.length=T,u.type=W,u.colonOffset=void 0,o=u}try{b(t,{onObjectBegin:(A,C)=>{if(a<=A)throw n;o=void 0,d=a>A,i.push("")},onObjectProperty:(A,C,T)=>{if(a<C||(I(A,C,T,"property"),i[i.length-1]=A,a<=C+T))throw n},onObjectEnd:(A,C)=>{if(a<=A)throw n;o=void 0,i.pop()},onArrayBegin:(A,C)=>{if(a<=A)throw n;o=void 0,i.push(0)},onArrayEnd:(A,C)=>{if(a<=A)throw n;o=void 0,i.pop()},onLiteralValue:(A,C,T)=>{if(a<C||(I(A,C,T,D(A)),a<=C+T))throw n},onSeparator:(A,C,T)=>{if(a<=C)throw n;if(A===":"&&o&&o.type==="property")o.colonOffset=C,d=!1,o=void 0;else if(A===","){const W=i[i.length-1];typeof W=="number"?i[i.length-1]=W+1:(d=!0,i[i.length-1]=""),o=void 0}}})}catch(A){if(A!==n)throw A}return{path:i,previousNode:o,isAtPropertyKey:d,matches:A=>{let C=0;for(let T=0;C<A.length&&T<i.length;T++)if(A[C]===i[T]||A[C]==="*")C++;else if(A[C]!=="**")return!1;return C===A.length}}}e.getLocation=m;function v(t,a=[],i=L.DEFAULT){let n=null,o=[];const u=[];function d(A){Array.isArray(o)?o.push(A):n!==null&&(o[n]=A)}return b(t,{onObjectBegin:()=>{const A={};d(A),u.push(o),o=A,n=null},onObjectProperty:A=>{n=A},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const A=[];d(A),u.push(o),o=A,n=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:d,onError:(A,C,T)=>{a.push({error:A,offset:C,length:T})}},i),o[0]}e.parse=v;function f(t,a=[],i=L.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(A){n.type==="property"&&(n.length=A-n.offset,n=n.parent)}function u(A){return n.children.push(A),A}b(t,{onObjectBegin:A=>{n=u({type:"object",offset:A,length:-1,parent:n,children:[]})},onObjectProperty:(A,C,T)=>{n=u({type:"property",offset:C,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:A,offset:C,length:T,parent:n})},onObjectEnd:(A,C)=>{n.length=A+C-n.offset,n=n.parent,o(A+C)},onArrayBegin:(A,C)=>{n=u({type:"array",offset:A,length:-1,parent:n,children:[]})},onArrayEnd:(A,C)=>{n.length=A+C-n.offset,n=n.parent,o(A+C)},onLiteralValue:(A,C,T)=>{u({type:D(A),offset:C,length:T,parent:n,value:A}),o(C+T)},onSeparator:(A,C,T)=>{n.type==="property"&&(A===":"?n.colonOffset=C:A===","&&o(C))},onError:(A,C,T)=>{a.push({error:A,offset:C,length:T})}},i);const I=n.children[0];return I&&delete I.parent,I}e.parseTree=f;function y(t,a){if(!t)return;let i=t;for(const n of a)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const u of i.children)if(Array.isArray(u.children)&&u.children[0].value===n){i=u.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=y;function w(t){if(!t.parent||!t.parent.children)return[];const a=w(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;a.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&a.push(i)}return a}e.getNodePath=w;function r(t){switch(t.type){case"array":return t.children.map(r);case"object":{const a=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(a[i.children[0].value]=r(n))}return a}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=r;function g(t,a,i=!1){return a>=t.offset&&a<t.offset+t.length||i&&a===t.offset+t.length}e.contains=g;function c(t,a,i=!1){if(g(t,a,i)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=a;o++){const u=c(n[o],a,i);if(u)return u}return t}}e.findNodeAtOffset=c;function b(t,a,i=L.DEFAULT){const n=R(t,!1);function o(oe){return oe?()=>oe(n.getTokenOffset(),n.getTokenLength()):()=>!0}function u(oe){return oe?le=>oe(le,n.getTokenOffset(),n.getTokenLength()):()=>!0}const d=o(a.onObjectBegin),I=u(a.onObjectProperty),A=o(a.onObjectEnd),C=o(a.onArrayBegin),T=o(a.onArrayEnd),W=u(a.onLiteralValue),$=u(a.onSeparator),H=o(a.onComment),Z=u(a.onError),ne=i&&i.disallowComments,se=i&&i.allowTrailingComma;function ue(){for(;;){const oe=n.scan();switch(n.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:ne||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(oe){case 12:case 13:ne?ce(10):H();break;case 16:ce(1);break;case 15:case 14:break;default:return oe}}}function ce(oe,le=[],Y=[]){if(Z(oe),le.length+Y.length>0){let O=n.getToken();for(;O!==17;){if(le.indexOf(O)!==-1){ue();break}else if(Y.indexOf(O)!==-1)break;O=ue()}}}function X(oe){const le=n.getTokenValue();return oe?W(le):I(le),ue(),!0}function q(){switch(n.getToken()){case 11:{let oe=0;try{oe=JSON.parse(n.getTokenValue()),typeof oe!="number"&&(ce(2),oe=0)}catch{ce(2)}W(oe);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return ue(),!0}function B(){return n.getToken()!==10?(ce(3,[],[2,5]),!1):(X(!1),n.getToken()===6?($(":"),ue(),ee()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function z(){d(),ue();let oe=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(oe||ce(4,[],[]),$(","),ue(),n.getToken()===2&&se)break}else oe&&ce(6,[],[]);B()||ce(4,[],[2,5]),oe=!0}return A(),n.getToken()!==2?ce(7,[2],[]):ue(),!0}function K(){C(),ue();let oe=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(oe||ce(4,[],[]),$(","),ue(),n.getToken()===4&&se)break}else oe&&ce(6,[],[]);ee()||ce(4,[],[4,5]),oe=!0}return T(),n.getToken()!==4?ce(8,[4],[]):ue(),!0}function ee(){switch(n.getToken()){case 3:return K();case 1:return z();case 10:return X(!0);default:return q()}}return ue(),n.getToken()===17?i.allowEmptyContent?!0:(ce(4,[],[]),!1):ee()?(n.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}e.visit=b;function S(t,a){const i=R(t),n=[];let o,u=0,d;do switch(d=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:u!==d&&n.push(t.substring(u,d)),a!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,a)),u=i.getPosition();break}while(o!==17);return n.join("")}e.stripComments=S;function D(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=D}),define(te[128],ie([0,1,43]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function M(l,p,m){let v,f,y,w,r;if(p){for(w=p.offset,r=w+p.length,y=w;y>0&&!h(l,y-1);)y--;let d=r;for(;d<l.length&&!h(l,d);)d++;f=l.substring(y,d),v=R(f,m)}else f=l,v=0,y=0,w=0,r=l.length;const g=k(m,l);let c=!1,b=0,S;m.insertSpaces?S=L(" ",m.tabSize||4):S="	";const D=(0,E.createScanner)(f,!1);let t=!1;function a(){return g+L(S,v+b)}function i(){let d=D.scan();for(c=!1;d===15||d===14;)c=c||d===14,d=D.scan();return t=d===16||D.getTokenError()!==0,d}const n=[];function o(d,I,A){!t&&I<r&&A>w&&l.substring(I,A)!==d&&n.push({offset:I,length:A-I,content:d})}let u=i();if(u!==17){const d=D.getTokenOffset()+y,I=L(S,v);o(I,y,d)}for(;u!==17;){let d=D.getTokenOffset()+D.getTokenLength()+y,I=i(),A="";for(;!c&&(I===12||I===13);){const T=D.getTokenOffset()+y;o(" ",d,T),d=D.getTokenOffset()+D.getTokenLength()+y,A=I===12?a():"",I=i()}if(I===2)u!==1&&(b--,A=a());else if(I===4)u!==3&&(b--,A=a());else{switch(u){case 3:case 1:b++,A=a();break;case 5:case 12:A=a();break;case 13:c?A=a():A=" ";break;case 6:A=" ";break;case 10:if(I===6){A="";break}case 7:case 8:case 9:case 11:case 2:case 4:I===12||I===13?A=" ":I!==5&&I!==17&&(t=!0);break;case 16:t=!0;break}c&&(I===12||I===13)&&(A=a())}const C=D.getTokenOffset()+y;o(A,d,C),u=I}return n}e.format=M;function s(l,p){const m=JSON.stringify(l,void 0,p.insertSpaces?p.tabSize||4:"	");return p.eol!==void 0?m.replace(/\r\n|\r|\n/g,p.eol):m}e.toFormattedString=s;function L(l,p){let m="";for(let v=0;v<p;v++)m+=l;return m}function R(l,p){let m=0,v=0;const f=p.tabSize||4;for(;m<l.length;){const y=l.charAt(m);if(y===" ")v++;else if(y==="	")v+=f;else break;m++}return Math.floor(v/f)}function k(l,p){for(let m=0;m<p.length;m++){const v=p.charAt(m);if(v==="\r")return m+1<p.length&&p.charAt(m+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return l&&l.eol||`
`}e.getEOL=k;function h(l,p){return`\r
`.indexOf(l.charAt(p))!==-1}e.isEOL=h}),define(te[129],ie([0,1,43,128]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function s(l,p,m){return L(l,p,void 0,m)}e.removeProperty=s;function L(l,p,m,v,f){const y=p.slice(),w=[],r=(0,E.parseTree)(l,w);let g,c;for(;y.length>0&&(c=y.pop(),g=(0,E.findNodeAtLocation)(r,y),g===void 0&&m!==void 0);)typeof c=="string"?m={[c]:m}:m=[m];if(g)if(g.type==="object"&&typeof c=="string"&&Array.isArray(g.children)){const b=(0,E.findNodeAtLocation)(g,[c]);if(b!==void 0)if(m===void 0){if(!b.parent)throw new Error("Malformed AST");const S=g.children.indexOf(b.parent);let D,t=b.parent.offset+b.parent.length;if(S>0){const a=g.children[S-1];D=a.offset+a.length}else D=g.offset+1,g.children.length>1&&(t=g.children[1].offset);return R(l,{offset:D,length:t-D,content:""},v)}else return R(l,{offset:b.offset,length:b.length,content:JSON.stringify(m)},v);else{if(m===void 0)return[];const S=`${JSON.stringify(c)}: ${JSON.stringify(m)}`,D=f?f(g.children.map(a=>a.children[0].value)):g.children.length;let t;if(D>0){const a=g.children[D-1];t={offset:a.offset+a.length,length:0,content:","+S}}else g.children.length===0?t={offset:g.offset+1,length:0,content:S}:t={offset:g.offset+1,length:0,content:S+","};return R(l,t,v)}}else if(g.type==="array"&&typeof c=="number"&&Array.isArray(g.children))if(m!==void 0){const b=`${JSON.stringify(m)}`;let S;if(g.children.length===0||c===0)S={offset:g.offset+1,length:0,content:g.children.length===0?b:b+","};else{const D=c===-1||c>g.children.length?g.children.length:c,t=g.children[D-1];S={offset:t.offset+t.length,length:0,content:","+b}}return R(l,S,v)}else{const b=c,S=g.children[b];let D;if(g.children.length===1)D={offset:g.offset+1,length:g.length-2,content:""};else if(g.children.length-1===b){const t=g.children[b-1],a=t.offset+t.length,i=g.offset+g.length;D={offset:a,length:i-2-a,content:""}}else D={offset:S.offset,length:g.children[b+1].offset-S.offset,content:""};return R(l,D,v)}else throw new Error(`Can not add ${typeof c!="number"?"index":"property"} to parent of type ${g.type}`);else{if(m===void 0)throw new Error("Can not delete in empty document");return R(l,{offset:r?r.offset:0,length:r?r.length:0,content:JSON.stringify(m)},v)}}e.setProperty=L;function R(l,p,m){let v=k(l,p),f=p.offset,y=p.offset+p.content.length;if(p.length===0||p.content.length===0){for(;f>0&&!(0,M.isEOL)(v,f-1);)f--;for(;y<v.length&&!(0,M.isEOL)(v,y);)y++}const w=(0,M.format)(v,{offset:f,length:y-f},m);for(let g=w.length-1;g>=0;g--){const c=w[g];v=k(v,c),f=Math.min(f,c.offset),y=Math.max(y,c.offset+c.length),y+=c.content.length-c.length}const r=l.length-(v.length-y)-f;return[{offset:f,length:r,content:v.substring(f,y)}]}e.withFormatting=R;function k(l,p){return l.substring(0,p.offset)+p.content+l.substring(p.offset+p.length)}e.applyEdit=k;function h(l,p){const m=p.slice(0).sort((f,y)=>{const w=f.offset-y.offset;return w===0?f.length-y.length:w});let v=l.length;for(let f=m.length-1;f>=0;f--){const y=m[f];if(y.offset+y.length<=v)l=k(l,y);else throw new Error("Overlapping edit");v=y.offset}return l}e.applyEdits=h}),define(te[130],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(s){this.d=s,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(s){this.c=s}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=E}),define(te[2],ie([0,1,48,68]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const s=!1;let L=null;function R(u){L=u}if(e.setDisposableTracker=R,s){const u="__is_disposable_tracked__";R(new class{trackDisposable(d){const I=new Error("Potentially leaked disposable").stack;setTimeout(()=>{d[u]||console.log(I)},3e3)}setParent(d,I){if(d&&d!==c.None)try{d[u]=!0}catch{}}markAsDisposed(d){if(d&&d!==c.None)try{d[u]=!0}catch{}}markAsSingleton(d){}})}function k(u){return L?.trackDisposable(u),u}function h(u){L?.markAsDisposed(u)}function l(u,d){L?.setParent(u,d)}function p(u,d){if(L)for(const I of u)L.setParent(I,d)}function m(u){return L?.markAsSingleton(u),u}e.markAsSingleton=m;function v(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=v;function f(u){if(M.Iterable.is(u)){const d=[];for(const I of u)if(I)try{I.dispose()}catch(A){d.push(A)}if(d.length===1)throw d[0];if(d.length>1)throw new AggregateError(d,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.dispose=f;function y(u){for(const d of u)v(d)&&d.dispose();return[]}e.disposeIfDisposable=y;function w(...u){const d=r(()=>f(u));return p(u,d),d}e.combinedDisposable=w;function r(u){const d=k({dispose:(0,E.once)(()=>{h(d),u()})});return d}e.toDisposable=r;class g{constructor(){this.f=new Set,this.g=!1,k(this)}dispose(){this.g||(h(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{f(this.f)}finally{this.f.clear()}}add(d){if(!d)return d;if(d===this)throw new Error("Cannot register a disposable on itself!");return l(d,this),this.g?g.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(d),d}}e.DisposableStore=g,g.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this.q=new g,k(this),l(this.q,this)}dispose(){h(this),this.q.dispose()}B(d){if(d===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(d)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class b{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(d){this.b||d===this.a||(this.a?.dispose(),d&&l(d,this),this.a=d)}clear(){this.value=void 0}dispose(){this.b=!0,h(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const d=this.a;return this.a=void 0,d&&l(d,null),d}}e.MutableDisposable=b;class S{constructor(d){this.b=d,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=S;class D{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(d){let I=d;return this.unset=()=>I=void 0,this.isset=()=>I!==void 0,this.dispose=()=>{I&&(I(),I=void 0,h(this))},this}}e.SafeDisposable=D;class t{constructor(){this.a=new Map}acquire(d,...I){let A=this.a.get(d);A||(A={counter:0,object:this.b(d,...I)},this.a.set(d,A));const{object:C}=A,T=(0,E.once)(()=>{--A.counter===0&&(this.c(d,A.object),this.a.delete(d))});return A.counter++,{object:C,dispose:T}}}e.ReferenceCollection=t;class a{constructor(d){this.a=d}async acquire(d,...I){const A=this.a.acquire(d,...I);try{return{object:await A.object,dispose:()=>A.dispose()}}catch(C){throw A.dispose(),C}}}e.AsyncReferenceCollection=a;class i{constructor(d){this.object=d}dispose(){}}e.ImmortalReference=i;function n(u){const d=new g;try{u(d)}finally{d.dispose()}}e.disposeOnReturn=n;class o{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){h(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{f(this.a.values())}finally{this.a.clear()}}has(d){return this.a.has(d)}get(d){return this.a.get(d)}set(d,I,A=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),A||this.a.get(d)?.dispose(),this.a.set(d,I)}deleteAndDispose(d){this.a.get(d)?.dispose(),this.a.delete(d)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(te[100],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(L){this.element=L,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class M{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let L=this.a;for(;L!==E.Undefined;){const R=L.next;L.prev=E.Undefined,L.next=E.Undefined,L=R}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,R){const k=new E(L);if(this.a===E.Undefined)this.a=k,this.b=k;else if(R){const l=this.b;this.b=k,k.prev=l,l.next=k}else{const l=this.a;this.a=k,k.next=l,l.prev=k}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(k))}}shift(){if(this.a!==E.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==E.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==E.Undefined&&L.next!==E.Undefined){const R=L.prev;R.next=L.next,L.next.prev=R}else L.prev===E.Undefined&&L.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):L.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):L.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==E.Undefined;)yield L.element,L=L.next}}e.LinkedList=M}),define(te[35],ie([0,1]),function(x,e){"use strict";var E,M,s;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(w,r,g){let c=w.get(r);return c===void 0&&(c=g,w.set(r,c)),c}e.getOrSet=L;function R(w){const r=[];return w.forEach((g,c)=>{r.push(`${c} => ${g}`)}),`Map(${w.size}) {${r.join(", ")}}`}e.mapToString=R;function k(w){const r=[];return w.forEach(g=>{r.push(g)}),`Set(${w.size}) {${r.join(", ")}}`}e.setToString=k;class h{constructor(r,g){this.uri=r,this.value=g}}class l{constructor(r,g){this[E]="ResourceMap",r instanceof l?(this.b=new Map(r.b),this.c=g??l.a):(this.b=new Map,this.c=r??l.a)}set(r,g){return this.b.set(this.c(r),new h(r,g)),this}get(r){return this.b.get(this.c(r))?.value}has(r){return this.b.has(this.c(r))}get size(){return this.b.size}clear(){this.b.clear()}delete(r){return this.b.delete(this.c(r))}forEach(r,g){typeof g<"u"&&(r=r.bind(g));for(const[c,b]of this.b)r(b.value,b.uri,this)}*values(){for(const r of this.b.values())yield r.value}*keys(){for(const r of this.b.values())yield r.uri}*entries(){for(const r of this.b.values())yield[r.uri,r.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.b)yield[r.uri,r.value]}}e.ResourceMap=l,l.a=w=>w.toString();class p{constructor(r,g){this[M]="ResourceSet",!r||typeof r=="function"?this.a=new l(r):(this.a=new l(g),r.forEach(this.add,this))}get size(){return this.a.size}add(r){return this.a.set(r,r),this}clear(){this.a.clear()}delete(r){return this.a.delete(r)}forEach(r,g){this.a.forEach((c,b)=>r.call(g,b,b,this))}has(r){return this.a.has(r)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=p;var m;(function(w){w[w.None=0]="None",w[w.AsOld=1]="AsOld",w[w.AsNew=2]="AsNew"})(m||(e.Touch=m={}));class v{constructor(){this[s]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(r){return this.a.has(r)}get(r,g=0){const c=this.a.get(r);if(c)return g!==0&&this.j(c,g),c.value}set(r,g,c=0){let b=this.a.get(r);if(b)b.value=g,c!==0&&this.j(b,c);else{switch(b={key:r,value:g,next:void 0,previous:void 0},c){case 0:this.h(b);break;case 1:this.g(b);break;case 2:this.h(b);break;default:this.h(b);break}this.a.set(r,b),this.d++}return this}delete(r){return!!this.remove(r)}remove(r){const g=this.a.get(r);if(g)return this.a.delete(r),this.i(g),this.d--,g.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const r=this.b;return this.a.delete(r.key),this.i(r),this.d--,r.value}forEach(r,g){const c=this.e;let b=this.b;for(;b;){if(g?r.bind(g)(b.value,b.key,this):r(b.value,b.key,this),this.e!==c)throw new Error("LinkedMap got modified during iteration.");b=b.next}}keys(){const r=this,g=this.e;let c=this.b;const b={[Symbol.iterator](){return b},next(){if(r.e!==g)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:c.key,done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return b}values(){const r=this,g=this.e;let c=this.b;const b={[Symbol.iterator](){return b},next(){if(r.e!==g)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:c.value,done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return b}entries(){const r=this,g=this.e;let c=this.b;const b={[Symbol.iterator](){return b},next(){if(r.e!==g)throw new Error("LinkedMap got modified during iteration.");if(c){const S={value:[c.key,c.value],done:!1};return c=c.next,S}else return{value:void 0,done:!0}}};return b}[(s=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(r){if(r>=this.size)return;if(r===0){this.clear();return}let g=this.b,c=this.size;for(;g&&c>r;)this.a.delete(g.key),g=g.next,c--;this.b=g,this.d=c,g&&(g.previous=void 0),this.e++}g(r){if(!this.b&&!this.c)this.c=r;else if(this.b)r.next=this.b,this.b.previous=r;else throw new Error("Invalid list");this.b=r,this.e++}h(r){if(!this.b&&!this.c)this.b=r;else if(this.c)r.previous=this.c,this.c.next=r;else throw new Error("Invalid list");this.c=r,this.e++}i(r){if(r===this.b&&r===this.c)this.b=void 0,this.c=void 0;else if(r===this.b){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this.b=r.next}else if(r===this.c){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this.c=r.previous}else{const g=r.next,c=r.previous;if(!g||!c)throw new Error("Invalid list");g.previous=c,c.next=g}r.next=void 0,r.previous=void 0,this.e++}j(r,g){if(!this.b||!this.c)throw new Error("Invalid list");if(!(g!==1&&g!==2)){if(g===1){if(r===this.b)return;const c=r.next,b=r.previous;r===this.c?(b.next=void 0,this.c=b):(c.previous=b,b.next=c),r.previous=void 0,r.next=this.b,this.b.previous=r,this.b=r,this.e++}else if(g===2){if(r===this.c)return;const c=r.next,b=r.previous;r===this.b?(c.previous=void 0,this.b=c):(c.previous=b,b.next=c),r.next=void 0,r.previous=this.c,this.c.next=r,this.c=r,this.e++}}}toJSON(){const r=[];return this.forEach((g,c)=>{r.push([c,g])}),r}fromJSON(r){this.clear();for(const[g,c]of r)this.set(g,c)}}e.LinkedMap=v;class f extends v{constructor(r,g=1){super(),this.k=r,this.l=Math.min(Math.max(0,g),1)}get limit(){return this.k}set limit(r){this.k=r,this.m()}get ratio(){return this.l}set ratio(r){this.l=Math.min(Math.max(0,r),1),this.m()}get(r,g=2){return super.get(r,g)}peek(r){return super.get(r,0)}set(r,g){return super.set(r,g,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=f;class y{constructor(){this.a=new Map}add(r){return this.a.set(r,(this.a.get(r)||0)+1),this}delete(r){let g=this.a.get(r)||0;return g===0?!1:(g--,g===0?this.a.delete(r):this.a.set(r,g),!0)}has(r){return this.a.has(r)}}e.CounterSet=y}),define(te[82],ie([0,1,35]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const M=new E.LRUCache(1e4);function s(l){return h(l,"NFC",M)}e.normalizeNFC=s;const L=new E.LRUCache(1e4);function R(l){return h(l,"NFD",L)}e.normalizeNFD=R;const k=/[^\u0000-\u0080]/;function h(l,p,m){if(!l)return l;const v=m.get(l);if(v)return v;let f;return k.test(l)?f=l.normalize(p):f=l,m.set(l,f),f}e.removeAccents=function(){const l=/[\u0300-\u036f]/g;return function(p){return R(p).replace(l,"")}}()}),define(te[131],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(k,h,l){return Math.min(Math.max(k,h),l)}e.clamp=E;function M(k,h){return(h+k%h)%h}e.rot=M;class s{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=s;class L{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=L;class R{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const l=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=l,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=R}),function(){function x(s){const L=[];typeof s=="number"&&L.push("code/timeOrigin",s);function R(h){L.push(h,Date.now())}function k(){const h=[];for(let l=0;l<L.length;l+=2)h.push({name:L[l],startTime:L[l+1]});return h}return{mark:R,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(s){performance.mark(s)},getMarks(){let s=performance.timeOrigin;typeof s!="number"&&(s=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(s)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(s+R.startTime)});return L}};if(typeof process=="object"){const s=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(s)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function E(s){return s.MonacoPerformanceMarks||(s.MonacoPerformanceMarks=e()),s.MonacoPerformanceMarks}var M;typeof global=="object"?M=global:typeof self=="object"?M=self:M={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(M)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(M):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),M.perf=E(M))}(),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var M in E)(typeof exports=="object"?exports:x)[M]=E[M]}}(typeof self<"u"?self:this,function(){return function(x){var e={};function E(M){if(e[M])return e[M].exports;var s=e[M]={i:M,l:!1,exports:{}};return x[M].call(s.exports,s,s.exports,E),s.l=!0,s.exports}return E.m=x,E.c=e,E.d=function(M,s,L){E.o(M,s)||Object.defineProperty(M,s,{enumerable:!0,get:L})},E.r=function(M){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(M,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(M,"__esModule",{value:!0})},E.t=function(M,s){if(1&s&&(M=E(M)),8&s||4&s&&typeof M=="object"&&M&&M.__esModule)return M;var L=Object.create(null);if(E.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:M}),2&s&&typeof M!="string")for(var R in M)E.d(L,R,function(k){return M[k]}.bind(null,R));return L},E.n=function(M){var s=M&&M.__esModule?function(){return M.default}:function(){return M};return E.d(s,"a",s),s},E.o=function(M,s){return Object.prototype.hasOwnProperty.call(M,s)},E.p="",E(E.s=0)}([function(x,e,E){(function(M){var s;e=x.exports=Y,s=typeof M=="object"&&M.env&&M.env.NODE_DEBUG&&/\bsemver\b/i.test(M.env.NODE_DEBUG)?function(){var _=Array.prototype.slice.call(arguments,0);_.unshift("SEMVER"),console.log.apply(console,_)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],h=e.src=[],l=0,p=l++;h[p]="0|[1-9]\\d*";var m=l++;h[m]="[0-9]+";var v=l++;h[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var f=l++;h[f]="("+h[p]+")\\.("+h[p]+")\\.("+h[p]+")";var y=l++;h[y]="("+h[m]+")\\.("+h[m]+")\\.("+h[m]+")";var w=l++;h[w]="(?:"+h[p]+"|"+h[v]+")";var r=l++;h[r]="(?:"+h[m]+"|"+h[v]+")";var g=l++;h[g]="(?:-("+h[w]+"(?:\\."+h[w]+")*))";var c=l++;h[c]="(?:-?("+h[r]+"(?:\\."+h[r]+")*))";var b=l++;h[b]="[0-9A-Za-z-]+";var S=l++;h[S]="(?:\\+("+h[b]+"(?:\\."+h[b]+")*))";var D=l++,t="v?"+h[f]+h[g]+"?"+h[S]+"?";h[D]="^"+t+"$";var a="[v=\\s]*"+h[y]+h[c]+"?"+h[S]+"?",i=l++;h[i]="^"+a+"$";var n=l++;h[n]="((?:<|>)?=?)";var o=l++;h[o]=h[m]+"|x|X|\\*";var u=l++;h[u]=h[p]+"|x|X|\\*";var d=l++;h[d]="[v=\\s]*("+h[u]+")(?:\\.("+h[u]+")(?:\\.("+h[u]+")(?:"+h[g]+")?"+h[S]+"?)?)?";var I=l++;h[I]="[v=\\s]*("+h[o]+")(?:\\.("+h[o]+")(?:\\.("+h[o]+")(?:"+h[c]+")?"+h[S]+"?)?)?";var A=l++;h[A]="^"+h[n]+"\\s*"+h[d]+"$";var C=l++;h[C]="^"+h[n]+"\\s*"+h[I]+"$";var T=l++;h[T]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=l++;h[W]="(?:~>?)";var $=l++;h[$]="(\\s*)"+h[W]+"\\s+",k[$]=new RegExp(h[$],"g");var H=l++;h[H]="^"+h[W]+h[d]+"$";var Z=l++;h[Z]="^"+h[W]+h[I]+"$";var ne=l++;h[ne]="(?:\\^)";var se=l++;h[se]="(\\s*)"+h[ne]+"\\s+",k[se]=new RegExp(h[se],"g");var ue=l++;h[ue]="^"+h[ne]+h[d]+"$";var ce=l++;h[ce]="^"+h[ne]+h[I]+"$";var X=l++;h[X]="^"+h[n]+"\\s*("+a+")$|^$";var q=l++;h[q]="^"+h[n]+"\\s*("+t+")$|^$";var B=l++;h[B]="(\\s*)"+h[n]+"\\s*("+a+"|"+h[d]+")",k[B]=new RegExp(h[B],"g");var z=l++;h[z]="^\\s*("+h[d]+")\\s+-\\s+("+h[d]+")\\s*$";var K=l++;h[K]="^\\s*("+h[I]+")\\s+-\\s+("+h[I]+")\\s*$";var ee=l++;h[ee]="(<|>)?=?\\s*\\*";for(var oe=0;oe<35;oe++)s(oe,h[oe]),k[oe]||(k[oe]=new RegExp(h[oe]));function le(_,he){if(_ instanceof Y)return _;if(typeof _!="string"||_.length>L||!(he?k[i]:k[D]).test(_))return null;try{return new Y(_,he)}catch{return null}}function Y(_,he){if(_ instanceof Y){if(_.loose===he)return _;_=_.version}else if(typeof _!="string")throw new TypeError("Invalid Version: "+_);if(_.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof Y))return new Y(_,he);s("SemVer",_,he),this.loose=he;var fe=_.trim().match(he?k[i]:k[D]);if(!fe)throw new TypeError("Invalid Version: "+_);if(this.raw=_,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(Ee){if(/^[0-9]+$/.test(Ee)){var ke=+Ee;if(ke>=0&&ke<R)return ke}return Ee}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=le,e.valid=function(_,he){var fe=le(_,he);return fe?fe.version:null},e.clean=function(_,he){var fe=le(_.trim().replace(/^[=v]+/,""),he);return fe?fe.version:null},e.SemVer=Y,Y.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Y.prototype.toString=function(){return this.version},Y.prototype.compare=function(_){return s("SemVer.compare",this.version,this.loose,_),_ instanceof Y||(_=new Y(_,this.loose)),this.compareMain(_)||this.comparePre(_)},Y.prototype.compareMain=function(_){return _ instanceof Y||(_=new Y(_,this.loose)),P(this.major,_.major)||P(this.minor,_.minor)||P(this.patch,_.patch)},Y.prototype.comparePre=function(_){if(_ instanceof Y||(_=new Y(_,this.loose)),this.prerelease.length&&!_.prerelease.length)return-1;if(!this.prerelease.length&&_.prerelease.length)return 1;if(!this.prerelease.length&&!_.prerelease.length)return 0;var he=0;do{var fe=this.prerelease[he],Ee=_.prerelease[he];if(s("prerelease compare",he,fe,Ee),fe===void 0&&Ee===void 0)return 0;if(Ee===void 0)return 1;if(fe===void 0)return-1;if(fe!==Ee)return P(fe,Ee)}while(++he)},Y.prototype.inc=function(_,he){switch(_){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",he);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",he);break;case"prepatch":this.prerelease.length=0,this.inc("patch",he),this.inc("pre",he);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",he),this.inc("pre",he);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}he&&(this.prerelease[0]===he?isNaN(this.prerelease[1])&&(this.prerelease=[he,0]):this.prerelease=[he,0]);break;default:throw new Error("invalid increment argument: "+_)}return this.format(),this.raw=this.version,this},e.inc=function(_,he,fe,Ee){typeof fe=="string"&&(Ee=fe,fe=void 0);try{return new Y(_,fe).inc(he,Ee).version}catch{return null}},e.diff=function(_,he){if(U(_,he))return null;var fe=le(_),Ee=le(he);if(fe.prerelease.length||Ee.prerelease.length){for(var ke in fe)if((ke==="major"||ke==="minor"||ke==="patch")&&fe[ke]!==Ee[ke])return"pre"+ke;return"prerelease"}for(var ke in fe)if((ke==="major"||ke==="minor"||ke==="patch")&&fe[ke]!==Ee[ke])return ke},e.compareIdentifiers=P;var O=/^[0-9]+$/;function P(_,he){var fe=O.test(_),Ee=O.test(he);return fe&&Ee&&(_=+_,he=+he),fe&&!Ee?-1:Ee&&!fe?1:_<he?-1:_>he?1:0}function F(_,he,fe){return new Y(_,fe).compare(new Y(he,fe))}function N(_,he,fe){return F(_,he,fe)>0}function j(_,he,fe){return F(_,he,fe)<0}function U(_,he,fe){return F(_,he,fe)===0}function V(_,he,fe){return F(_,he,fe)!==0}function G(_,he,fe){return F(_,he,fe)>=0}function re(_,he,fe){return F(_,he,fe)<=0}function ae(_,he,fe,Ee){var ke;switch(he){case"===":typeof _=="object"&&(_=_.version),typeof fe=="object"&&(fe=fe.version),ke=_===fe;break;case"!==":typeof _=="object"&&(_=_.version),typeof fe=="object"&&(fe=fe.version),ke=_!==fe;break;case"":case"=":case"==":ke=U(_,fe,Ee);break;case"!=":ke=V(_,fe,Ee);break;case">":ke=N(_,fe,Ee);break;case">=":ke=G(_,fe,Ee);break;case"<":ke=j(_,fe,Ee);break;case"<=":ke=re(_,fe,Ee);break;default:throw new TypeError("Invalid operator: "+he)}return ke}function ye(_,he){if(_ instanceof ye){if(_.loose===he)return _;_=_.value}if(!(this instanceof ye))return new ye(_,he);s("comparator",_,he),this.loose=he,this.parse(_),this.semver===Ce?this.value="":this.value=this.operator+this.semver.version,s("comp",this)}e.rcompareIdentifiers=function(_,he){return P(he,_)},e.major=function(_,he){return new Y(_,he).major},e.minor=function(_,he){return new Y(_,he).minor},e.patch=function(_,he){return new Y(_,he).patch},e.compare=F,e.compareLoose=function(_,he){return F(_,he,!0)},e.rcompare=function(_,he,fe){return F(he,_,fe)},e.sort=function(_,he){return _.sort(function(fe,Ee){return e.compare(fe,Ee,he)})},e.rsort=function(_,he){return _.sort(function(fe,Ee){return e.rcompare(fe,Ee,he)})},e.gt=N,e.lt=j,e.eq=U,e.neq=V,e.gte=G,e.lte=re,e.cmp=ae,e.Comparator=ye;var Ce={};function Ae(_,he){if(_ instanceof Ae)return _.loose===he?_:new Ae(_.raw,he);if(_ instanceof ye)return new Ae(_.value,he);if(!(this instanceof Ae))return new Ae(_,he);if(this.loose=he,this.raw=_,this.set=_.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+_);this.format()}function Me(_){return!_||_.toLowerCase()==="x"||_==="*"}function Fe(_,he,fe,Ee,ke,Oe,We,He,Ne,ze,qe,Ue,J){return((he=Me(fe)?"":Me(Ee)?">="+fe+".0.0":Me(ke)?">="+fe+"."+Ee+".0":">="+he)+" "+(He=Me(Ne)?"":Me(ze)?"<"+(+Ne+1)+".0.0":Me(qe)?"<"+Ne+"."+(+ze+1)+".0":Ue?"<="+Ne+"."+ze+"."+qe+"-"+Ue:"<="+He)).trim()}function ve(_,he){for(var fe=0;fe<_.length;fe++)if(!_[fe].test(he))return!1;if(he.prerelease.length){for(fe=0;fe<_.length;fe++)if(s(_[fe].semver),_[fe].semver!==Ce&&_[fe].semver.prerelease.length>0){var Ee=_[fe].semver;if(Ee.major===he.major&&Ee.minor===he.minor&&Ee.patch===he.patch)return!0}return!1}return!0}function we(_,he,fe){try{he=new Ae(he,fe)}catch{return!1}return he.test(_)}function Pe(_,he,fe,Ee){var ke,Oe,We,He,Ne;switch(_=new Y(_,Ee),he=new Ae(he,Ee),fe){case">":ke=N,Oe=re,We=j,He=">",Ne=">=";break;case"<":ke=j,Oe=G,We=N,He="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(_,he,Ee))return!1;for(var ze=0;ze<he.set.length;++ze){var qe=he.set[ze],Ue=null,J=null;if(qe.forEach(function(de){de.semver===Ce&&(de=new ye(">=0.0.0")),Ue=Ue||de,J=J||de,ke(de.semver,Ue.semver,Ee)?Ue=de:We(de.semver,J.semver,Ee)&&(J=de)}),Ue.operator===He||Ue.operator===Ne||(!J.operator||J.operator===He)&&Oe(_,J.semver)||J.operator===Ne&&We(_,J.semver))return!1}return!0}ye.prototype.parse=function(_){var he=this.loose?k[X]:k[q],fe=_.match(he);if(!fe)throw new TypeError("Invalid comparator: "+_);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new Y(fe[2],this.loose):this.semver=Ce},ye.prototype.toString=function(){return this.value},ye.prototype.test=function(_){return s("Comparator.test",_,this.loose),this.semver===Ce||(typeof _=="string"&&(_=new Y(_,this.loose)),ae(_,this.operator,this.semver,this.loose))},ye.prototype.intersects=function(_,he){if(!(_ instanceof ye))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Ae(_.value,he),we(this.value,fe,he);if(_.operator==="")return fe=new Ae(this.value,he),we(_.semver,fe,he);var Ee=!(this.operator!==">="&&this.operator!==">"||_.operator!==">="&&_.operator!==">"),ke=!(this.operator!=="<="&&this.operator!=="<"||_.operator!=="<="&&_.operator!=="<"),Oe=this.semver.version===_.semver.version,We=!(this.operator!==">="&&this.operator!=="<="||_.operator!==">="&&_.operator!=="<="),He=ae(this.semver,"<",_.semver,he)&&(this.operator===">="||this.operator===">")&&(_.operator==="<="||_.operator==="<"),Ne=ae(this.semver,">",_.semver,he)&&(this.operator==="<="||this.operator==="<")&&(_.operator===">="||_.operator===">");return Ee||ke||Oe&&We||He||Ne},e.Range=Ae,Ae.prototype.format=function(){return this.range=this.set.map(function(_){return _.join(" ").trim()}).join("||").trim(),this.range},Ae.prototype.toString=function(){return this.range},Ae.prototype.parseRange=function(_){var he=this.loose;_=_.trim(),s("range",_,he);var fe=he?k[K]:k[z];_=_.replace(fe,Fe),s("hyphen replace",_),_=_.replace(k[B],"$1$2$3"),s("comparator trim",_,k[B]),_=(_=(_=_.replace(k[$],"$1~")).replace(k[se],"$1^")).split(/\s+/).join(" ");var Ee=he?k[X]:k[q],ke=_.split(" ").map(function(Oe){return function(We,He){return s("comp",We),We=function(Ne,ze){return Ne.trim().split(/\s+/).map(function(qe){return function(Ue,J){s("caret",Ue,J);var de=J?k[ce]:k[ue];return Ue.replace(de,function(ge,me,Se,Le,je){var Ke;return s("caret",Ue,ge,me,Se,Le,je),Me(me)?Ke="":Me(Se)?Ke=">="+me+".0.0 <"+(+me+1)+".0.0":Me(Le)?Ke=me==="0"?">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0":">="+me+"."+Se+".0 <"+(+me+1)+".0.0":je?(s("replaceCaret pr",je),je.charAt(0)!=="-"&&(je="-"+je),Ke=me==="0"?Se==="0"?">="+me+"."+Se+"."+Le+je+" <"+me+"."+Se+"."+(+Le+1):">="+me+"."+Se+"."+Le+je+" <"+me+"."+(+Se+1)+".0":">="+me+"."+Se+"."+Le+je+" <"+(+me+1)+".0.0"):(s("no pr"),Ke=me==="0"?Se==="0"?">="+me+"."+Se+"."+Le+" <"+me+"."+Se+"."+(+Le+1):">="+me+"."+Se+"."+Le+" <"+me+"."+(+Se+1)+".0":">="+me+"."+Se+"."+Le+" <"+(+me+1)+".0.0"),s("caret return",Ke),Ke})}(qe,ze)}).join(" ")}(We,He),s("caret",We),We=function(Ne,ze){return Ne.trim().split(/\s+/).map(function(qe){return function(Ue,J){var de=J?k[Z]:k[H];return Ue.replace(de,function(ge,me,Se,Le,je){var Ke;return s("tilde",Ue,ge,me,Se,Le,je),Me(me)?Ke="":Me(Se)?Ke=">="+me+".0.0 <"+(+me+1)+".0.0":Me(Le)?Ke=">="+me+"."+Se+".0 <"+me+"."+(+Se+1)+".0":je?(s("replaceTilde pr",je),je.charAt(0)!=="-"&&(je="-"+je),Ke=">="+me+"."+Se+"."+Le+je+" <"+me+"."+(+Se+1)+".0"):Ke=">="+me+"."+Se+"."+Le+" <"+me+"."+(+Se+1)+".0",s("tilde return",Ke),Ke})}(qe,ze)}).join(" ")}(We,He),s("tildes",We),We=function(Ne,ze){return s("replaceXRanges",Ne,ze),Ne.split(/\s+/).map(function(qe){return function(Ue,J){Ue=Ue.trim();var de=J?k[C]:k[A];return Ue.replace(de,function(ge,me,Se,Le,je,Ke){s("xRange",Ue,ge,me,Se,Le,je,Ke);var Ze=Me(Se),Ge=Ze||Me(Le),Ye=Ge||Me(je);return me==="="&&Ye&&(me=""),Ze?ge=me===">"||me==="<"?"<0.0.0":"*":me&&Ye?(Ge&&(Le=0),Ye&&(je=0),me===">"?(me=">=",Ge?(Se=+Se+1,Le=0,je=0):Ye&&(Le=+Le+1,je=0)):me==="<="&&(me="<",Ge?Se=+Se+1:Le=+Le+1),ge=me+Se+"."+Le+"."+je):Ge?ge=">="+Se+".0.0 <"+(+Se+1)+".0.0":Ye&&(ge=">="+Se+"."+Le+".0 <"+Se+"."+(+Le+1)+".0"),s("xRange return",ge),ge})}(qe,ze)}).join(" ")}(We,He),s("xrange",We),We=function(Ne,ze){return s("replaceStars",Ne,ze),Ne.trim().replace(k[ee],"")}(We,He),s("stars",We),We}(Oe,he)}).join(" ").split(/\s+/);return this.loose&&(ke=ke.filter(function(Oe){return!!Oe.match(Ee)})),ke=ke.map(function(Oe){return new ye(Oe,he)})},Ae.prototype.intersects=function(_,he){if(!(_ instanceof Ae))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(Ee){return _.set.some(function(ke){return ke.every(function(Oe){return Ee.intersects(Oe,he)})})})})},e.toComparators=function(_,he){return new Ae(_,he).set.map(function(fe){return fe.map(function(Ee){return Ee.value}).join(" ").trim().split(" ")})},Ae.prototype.test=function(_){if(!_)return!1;typeof _=="string"&&(_=new Y(_,this.loose));for(var he=0;he<this.set.length;he++)if(ve(this.set[he],_))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(_,he,fe){var Ee=null,ke=null;try{var Oe=new Ae(he,fe)}catch{return null}return _.forEach(function(We){Oe.test(We)&&(Ee&&ke.compare(We)!==-1||(ke=new Y(Ee=We,fe)))}),Ee},e.minSatisfying=function(_,he,fe){var Ee=null,ke=null;try{var Oe=new Ae(he,fe)}catch{return null}return _.forEach(function(We){Oe.test(We)&&(Ee&&ke.compare(We)!==1||(ke=new Y(Ee=We,fe)))}),Ee},e.validRange=function(_,he){try{return new Ae(_,he).range||"*"}catch{return null}},e.ltr=function(_,he,fe){return Pe(_,he,"<",fe)},e.gtr=function(_,he,fe){return Pe(_,he,">",fe)},e.outside=Pe,e.prerelease=function(_,he){var fe=le(_,he);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(_,he,fe){return _=new Ae(_,fe),he=new Ae(he,fe),_.intersects(he)},e.coerce=function(_){if(_ instanceof Y)return _;if(typeof _!="string")return null;var he=_.match(k[T]);return he==null?null:le((he[1]||"0")+"."+(he[2]||"0")+"."+(he[3]||"0"))}}).call(this,E(1))},function(x,e){var E,M,s=x.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function k(r){if(E===setTimeout)return setTimeout(r,0);if((E===L||!E)&&setTimeout)return E=setTimeout,setTimeout(r,0);try{return E(r,0)}catch{try{return E.call(null,r,0)}catch{return E.call(this,r,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:L}catch{E=L}try{M=typeof clearTimeout=="function"?clearTimeout:R}catch{M=R}})();var h,l=[],p=!1,m=-1;function v(){p&&h&&(p=!1,h.length?l=h.concat(l):m=-1,l.length&&f())}function f(){if(!p){var r=k(v);p=!0;for(var g=l.length;g;){for(h=l,l=[];++m<g;)h&&h[m].run();m=-1,g=l.length}h=null,p=!1,function(c){if(M===clearTimeout)return clearTimeout(c);if((M===R||!M)&&clearTimeout)return M=clearTimeout,clearTimeout(c);try{M(c)}catch{try{return M.call(null,c)}catch{return M.call(this,c)}}}(r)}}function y(r,g){this.fun=r,this.array=g}function w(){}s.nextTick=function(r){var g=new Array(arguments.length-1);if(arguments.length>1)for(var c=1;c<arguments.length;c++)g[c-1]=arguments[c];l.push(new y(r,g)),l.length!==1||p||k(f)},y.prototype.run=function(){this.fun.apply(null,this.array)},s.title="browser",s.browser=!0,s.env={},s.argv=[],s.version="",s.versions={},s.on=w,s.addListener=w,s.once=w,s.off=w,s.removeListener=w,s.removeAllListeners=w,s.emit=w,s.prependListener=w,s.prependOnceListener=w,s.listeners=function(r){return[]},s.binding=function(r){throw new Error("process.binding is not supported")},s.cwd=function(){return"/"},s.chdir=function(r){throw new Error("process.chdir is not supported")},s.umask=function(){return 0}}])}),define(te[132],ie([0,1]),function(x,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class M{constructor(k,h,l){this.level=k,this.key=h,this.value=l,this.forward=[]}}const s=void 0;class L{constructor(k,h=2**16){this.comparator=k,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(h)|0),this.e=new M(this.c,s,s)}get size(){return this.f}clear(){this.e=new M(this.c,s,s)}has(k){return!!L.g(this,k,this.comparator)}get(k){return L.g(this,k,this.comparator)?.value}set(k,h){return L.h(this,k,h,this.comparator)&&(this.f+=1),this}delete(k){const h=L.k(this,k,this.comparator);return h&&(this.f-=1),h}forEach(k,h){let l=this.e.forward[0];for(;l;)k.call(h,l.value,l.key,this),l=l.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",h=this.e.forward[0];for(;h;)k+=`node(${h.key}, ${h.value}, lvl:${h.level})`,h=h.forward[0];return k}static g(k,h,l){let p=k.e;for(let m=k.d-1;m>=0;m--)for(;p.forward[m]&&l(p.forward[m].key,h)<0;)p=p.forward[m];if(p=p.forward[0],p&&l(p.key,h)===0)return p}static h(k,h,l,p){const m=[];let v=k.e;for(let f=k.d-1;f>=0;f--){for(;v.forward[f]&&p(v.forward[f].key,h)<0;)v=v.forward[f];m[f]=v}if(v=v.forward[0],v&&p(v.key,h)===0)return v.value=l,!1;{const f=L.j(k);if(f>k.d){for(let y=k.d;y<f;y++)m[y]=k.e;k.d=f}v=new M(f,h,l);for(let y=0;y<f;y++)v.forward[y]=m[y].forward[y],m[y].forward[y]=v;return!0}}static j(k,h=.5){let l=1;for(;Math.random()<h&&l<k.c;)l+=1;return l}static k(k,h,l){const p=[];let m=k.e;for(let v=k.d-1;v>=0;v--){for(;m.forward[v]&&l(m.forward[v].key,h)<0;)m=m.forward[v];p[v]=m}if(m=m.forward[0],!m||l(m.key,h)!==0)return!1;for(let v=0;v<k.d&&p[v].forward[v]===m;v++)p[v].forward[v]=m.forward[v];for(;k.d>0&&k.e.forward[k.d-1]===s;)k.d-=1;return!0}}e.SkipList=L}),define(te[60],ie([0,1,13,2]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function s(S){const D=S;return D?typeof D.read=="function":!1}e.isReadable=s;function L(S){const D=S;return D?[D.on,D.pause,D.resume,D.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=L;function R(S){const D=S;return D?L(D.stream)&&Array.isArray(D.buffer)&&typeof D.ended=="boolean":!1}e.isReadableBufferedStream=R;function k(S,D){return new h(S,D)}e.newWriteableStream=k;class h{constructor(D,t){this.e=D,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(D){if(!this.a.destroyed){if(this.a.flowing)this.g(D);else if(this.b.data.push(D),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(D){this.a.destroyed||(this.a.flowing?this.h(D):this.b.error.push(D))}end(D){this.a.destroyed||(typeof D<"u"&&this.write(D),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(D){this.c.data.slice(0).forEach(t=>t(D))}h(D){this.c.error.length===0?(0,E.onUnexpectedError)(D):this.c.error.slice(0).forEach(t=>t(D))}i(){this.c.end.slice(0).forEach(D=>D())}on(D,t){if(!this.a.destroyed)switch(D){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(D,t){if(this.a.destroyed)return;let a;switch(D){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const i=a.indexOf(t);i>=0&&a.splice(i,1)}}j(){if(this.b.data.length>0){const D=this.e(this.b.data);this.g(D),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const D of this.b.error)this.h(D);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function l(S,D){const t=[];let a;for(;(a=S.read())!==null;)t.push(a);return D(t)}e.consumeReadable=l;function p(S,D,t){const a=[];let i;for(;(i=S.read())!==null&&a.length<t;)a.push(i);return i===null&&a.length>0?D(a):{read:()=>{if(a.length>0)return a.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return S.read()}}}e.peekReadable=p;function m(S,D){return new Promise((t,a)=>{const i=[];v(S,{onData:n=>{D&&i.push(n)},onError:n=>{D?a(n):t(void 0)},onEnd:()=>{t(D?D(i):void 0)}})})}e.consumeStream=m;function v(S,D){let t=!1;return S.on("error",a=>{t||D.onError(a)}),S.on("end",()=>{t||D.onEnd()}),S.on("data",a=>{t||D.onData(a)}),(0,M.toDisposable)(()=>t=!0)}e.listenStream=v;function f(S,D){return new Promise((t,a)=>{const i=new M.DisposableStore,n=[],o=I=>{if(n.push(I),n.length>D)return i.dispose(),S.pause(),t({stream:S,buffer:n,ended:!1})},u=I=>a(I),d=()=>t({stream:S,buffer:n,ended:!0});i.add((0,M.toDisposable)(()=>S.removeListener("error",u))),S.on("error",u),i.add((0,M.toDisposable)(()=>S.removeListener("end",d))),S.on("end",d),i.add((0,M.toDisposable)(()=>S.removeListener("data",o))),S.on("data",o)})}e.peekStream=f;function y(S,D){const t=k(D);return t.end(S),t}e.toStream=y;function w(){const S=k(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=w;function r(S){let D=!1;return{read:()=>D?null:(D=!0,S)}}e.toReadable=r;function g(S,D,t){const a=k(t);return v(S,{onData:i=>a.write(D.data(i)),onError:i=>a.error(D.error?D.error(i):i),onEnd:()=>a.end()}),a}e.transform=g;function c(S,D,t){let a=!1;return{read:()=>{const i=D.read();return a?i:(a=!0,i!==null?t([S,i]):S)}}}e.prefixedReadable=c;function b(S,D,t){let a=!1;const i=k(t);return v(D,{onData:n=>a?i.write(n):(a=!0,i.write(t([S,n]))),onError:n=>i.error(n),onEnd:()=>{a||(a=!0,i.write(S)),i.end()}}),i}e.prefixedStream=b}),define(te[17],ie([0,1,60]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const M=typeof Buffer<"u";let s,L;class R{static alloc(I){return M?new R(Buffer.allocUnsafe(I)):new R(new Uint8Array(I))}static wrap(I){return M&&!Buffer.isBuffer(I)&&(I=Buffer.from(I.buffer,I.byteOffset,I.byteLength)),new R(I)}static fromString(I,A){return!(A?.dontUseNodeBuffer||!1)&&M?new R(Buffer.from(I)):(s||(s=new TextEncoder),new R(s.encode(I)))}static fromByteArray(I){const A=R.alloc(I.length);for(let C=0,T=I.length;C<T;C++)A.buffer[C]=I[C];return A}static concat(I,A){if(typeof A>"u"){A=0;for(let W=0,$=I.length;W<$;W++)A+=I[W].byteLength}const C=R.alloc(A);let T=0;for(let W=0,$=I.length;W<$;W++){const H=I[W];C.set(H,T),T+=H.byteLength}return C}constructor(I){this.buffer=I,this.byteLength=this.buffer.byteLength}clone(){const I=R.alloc(this.byteLength);return I.set(this),I}toString(){return M?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(I,A){return new R(this.buffer.subarray(I,A))}set(I,A){if(I instanceof R)this.buffer.set(I.buffer,A);else if(I instanceof Uint8Array)this.buffer.set(I,A);else if(I instanceof ArrayBuffer)this.buffer.set(new Uint8Array(I),A);else if(ArrayBuffer.isView(I))this.buffer.set(new Uint8Array(I.buffer,I.byteOffset,I.byteLength),A);else throw new Error("Unknown argument 'array'")}readUInt32BE(I){return l(this.buffer,I)}writeUInt32BE(I,A){p(this.buffer,I,A)}readUInt32LE(I){return m(this.buffer,I)}writeUInt32LE(I,A){v(this.buffer,I,A)}readUInt8(I){return f(this.buffer,I)}writeUInt8(I,A){y(this.buffer,I,A)}}e.VSBuffer=R;function k(d,I){return d[I+0]<<0>>>0|d[I+1]<<8>>>0}e.readUInt16LE=k;function h(d,I,A){d[A+0]=I&255,I=I>>>8,d[A+1]=I&255}e.writeUInt16LE=h;function l(d,I){return d[I]*2**24+d[I+1]*2**16+d[I+2]*2**8+d[I+3]}e.readUInt32BE=l;function p(d,I,A){d[A+3]=I,I=I>>>8,d[A+2]=I,I=I>>>8,d[A+1]=I,I=I>>>8,d[A]=I}e.writeUInt32BE=p;function m(d,I){return d[I+0]<<0>>>0|d[I+1]<<8>>>0|d[I+2]<<16>>>0|d[I+3]<<24>>>0}e.readUInt32LE=m;function v(d,I,A){d[A+0]=I&255,I=I>>>8,d[A+1]=I&255,I=I>>>8,d[A+2]=I&255,I=I>>>8,d[A+3]=I&255}e.writeUInt32LE=v;function f(d,I){return d[I]}e.readUInt8=f;function y(d,I,A){d[A]=I}e.writeUInt8=y;function w(d){return E.consumeReadable(d,I=>R.concat(I))}e.readableToBuffer=w;function r(d){return E.toReadable(d)}e.bufferToReadable=r;function g(d){return E.consumeStream(d,I=>R.concat(I))}e.streamToBuffer=g;async function c(d){return d.ended?R.concat(d.buffer):R.concat([...d.buffer,await g(d.stream)])}e.bufferedStreamToBuffer=c;function b(d){return E.toStream(d,I=>R.concat(I))}e.bufferToStream=b;function S(d){return E.transform(d,{data:I=>typeof I=="string"?R.fromString(I):R.wrap(I)},I=>R.concat(I))}e.streamToBufferReadableStream=S;function D(d){return E.newWriteableStream(I=>R.concat(I),d)}e.newWriteableBufferStream=D;function t(d,I){return E.prefixedReadable(d,I,A=>R.concat(A))}e.prefixedBufferReadable=t;function a(d,I){return E.prefixedStream(d,I,A=>R.concat(A))}e.prefixedBufferStream=a;function i(d){let I=0,A=0,C=0;const T=new Uint8Array(Math.floor(d.length/4*3)),W=H=>{switch(A){case 3:T[C++]=I|H,A=0;break;case 2:T[C++]=I|H>>>2,I=H<<6,A=3;break;case 1:T[C++]=I|H>>>4,I=H<<4,A=2;break;default:I=H<<2,A=1}};for(let H=0;H<d.length;H++){const Z=d.charCodeAt(H);if(Z>=65&&Z<=90)W(Z-65);else if(Z>=97&&Z<=122)W(Z-97+26);else if(Z>=48&&Z<=57)W(Z-48+52);else if(Z===43||Z===45)W(62);else if(Z===47||Z===95)W(63);else{if(Z===61)break;throw new SyntaxError(`Unexpected base64 character ${d[H]}`)}}const $=C;for(;A>0;)W(0);return R.wrap(T).slice(0,$)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:d},I=!0,A=!1){const C=A?o:n;let T="";const W=d.byteLength%3;let $=0;for(;$<d.byteLength-W;$+=3){const H=d[$+0],Z=d[$+1],ne=d[$+2];T+=C[H>>>2],T+=C[(H<<4|Z>>>4)&63],T+=C[(Z<<2|ne>>>6)&63],T+=C[ne&63]}if(W===1){const H=d[$+0];T+=C[H>>>2],T+=C[H<<4&63],I&&(T+="==")}else if(W===2){const H=d[$+0],Z=d[$+1];T+=C[H>>>2],T+=C[(H<<4|Z>>>4)&63],T+=C[Z<<2&63],I&&(T+="=")}return T}e.encodeBase64=u}),define(te[133],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(te[11],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(a){return typeof a=="string"}e.isString=E;function M(a){return Array.isArray(a)&&a.every(i=>E(i))}e.isStringArray=M;function s(a){return typeof a=="object"&&a!==null&&!Array.isArray(a)&&!(a instanceof RegExp)&&!(a instanceof Date)}e.isObject=s;function L(a){const i=Object.getPrototypeOf(Uint8Array);return typeof a=="object"&&a instanceof i}e.isTypedArray=L;function R(a){return typeof a=="number"&&!isNaN(a)}e.isNumber=R;function k(a){return!!a&&typeof a[Symbol.iterator]=="function"}e.isIterable=k;function h(a){return a===!0||a===!1}e.isBoolean=h;function l(a){return typeof a>"u"}e.isUndefined=l;function p(a){return!m(a)}e.isDefined=p;function m(a){return l(a)||a===null}e.isUndefinedOrNull=m;function v(a,i){if(!a)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=v;function f(a){if(m(a))throw new Error("Assertion Failed: argument is undefined or null");return a}e.assertIsDefined=f;function y(...a){const i=[];for(let n=0;n<a.length;n++){const o=a[n];if(m(o))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(o)}return i}e.assertAllDefined=y;const w=Object.prototype.hasOwnProperty;function r(a){if(!s(a))return!1;for(const i in a)if(w.call(a,i))return!1;return!0}e.isEmptyObject=r;function g(a){return typeof a=="function"}e.isFunction=g;function c(...a){return a.length>0&&a.every(g)}e.areFunctions=c;function b(a,i){const n=Math.min(a.length,i.length);for(let o=0;o<n;o++)S(a[o],i[o])}e.validateConstraints=b;function S(a,i){if(E(i)){if(typeof a!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(g(i)){try{if(a instanceof i)return}catch{}if(!m(a)&&a.constructor===i||i.length===1&&i.call(void 0,a)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function D(a){return a===null?void 0:a}e.withNullAsUndefined=D;function t(a){return typeof a>"u"?null:a}e.withUndefinedAsNull=t}),define(te[134],ie([0,1,11]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const M=Object.create(null);function s(k,h){if((0,E.isString)(h)){const l=M[h];if(l===void 0)throw new Error(`${k} references an unknown codicon: ${h}`);h=l}return M[k]=h,{id:k}}function L(){return M}e.getCodiconFontCharacters=L;function R(){return Object.values(e.Codicon)}e.getAllCodicons=R,e.Codicon={add:s("add",6e4),plus:s("plus",6e4),gistNew:s("gist-new",6e4),repoCreate:s("repo-create",6e4),lightbulb:s("lightbulb",60001),lightBulb:s("light-bulb",60001),repo:s("repo",60002),repoDelete:s("repo-delete",60002),gistFork:s("gist-fork",60003),repoForked:s("repo-forked",60003),gitPullRequest:s("git-pull-request",60004),gitPullRequestAbandoned:s("git-pull-request-abandoned",60004),recordKeys:s("record-keys",60005),keyboard:s("keyboard",60005),tag:s("tag",60006),tagAdd:s("tag-add",60006),tagRemove:s("tag-remove",60006),person:s("person",60007),personFollow:s("person-follow",60007),personOutline:s("person-outline",60007),personFilled:s("person-filled",60007),gitBranch:s("git-branch",60008),gitBranchCreate:s("git-branch-create",60008),gitBranchDelete:s("git-branch-delete",60008),sourceControl:s("source-control",60008),mirror:s("mirror",60009),mirrorPublic:s("mirror-public",60009),star:s("star",60010),starAdd:s("star-add",60010),starDelete:s("star-delete",60010),starEmpty:s("star-empty",60010),comment:s("comment",60011),commentAdd:s("comment-add",60011),alert:s("alert",60012),warning:s("warning",60012),search:s("search",60013),searchSave:s("search-save",60013),logOut:s("log-out",60014),signOut:s("sign-out",60014),logIn:s("log-in",60015),signIn:s("sign-in",60015),eye:s("eye",60016),eyeUnwatch:s("eye-unwatch",60016),eyeWatch:s("eye-watch",60016),circleFilled:s("circle-filled",60017),primitiveDot:s("primitive-dot",60017),closeDirty:s("close-dirty",60017),debugBreakpoint:s("debug-breakpoint",60017),debugBreakpointDisabled:s("debug-breakpoint-disabled",60017),debugHint:s("debug-hint",60017),primitiveSquare:s("primitive-square",60018),edit:s("edit",60019),pencil:s("pencil",60019),info:s("info",60020),issueOpened:s("issue-opened",60020),gistPrivate:s("gist-private",60021),gitForkPrivate:s("git-fork-private",60021),lock:s("lock",60021),mirrorPrivate:s("mirror-private",60021),close:s("close",60022),removeClose:s("remove-close",60022),x:s("x",60022),repoSync:s("repo-sync",60023),sync:s("sync",60023),clone:s("clone",60024),desktopDownload:s("desktop-download",60024),beaker:s("beaker",60025),microscope:s("microscope",60025),vm:s("vm",60026),deviceDesktop:s("device-desktop",60026),file:s("file",60027),fileText:s("file-text",60027),more:s("more",60028),ellipsis:s("ellipsis",60028),kebabHorizontal:s("kebab-horizontal",60028),mailReply:s("mail-reply",60029),reply:s("reply",60029),organization:s("organization",60030),organizationFilled:s("organization-filled",60030),organizationOutline:s("organization-outline",60030),newFile:s("new-file",60031),fileAdd:s("file-add",60031),newFolder:s("new-folder",60032),fileDirectoryCreate:s("file-directory-create",60032),trash:s("trash",60033),trashcan:s("trashcan",60033),history:s("history",60034),clock:s("clock",60034),folder:s("folder",60035),fileDirectory:s("file-directory",60035),symbolFolder:s("symbol-folder",60035),logoGithub:s("logo-github",60036),markGithub:s("mark-github",60036),github:s("github",60036),terminal:s("terminal",60037),console:s("console",60037),repl:s("repl",60037),zap:s("zap",60038),symbolEvent:s("symbol-event",60038),error:s("error",60039),stop:s("stop",60039),variable:s("variable",60040),symbolVariable:s("symbol-variable",60040),array:s("array",60042),symbolArray:s("symbol-array",60042),symbolModule:s("symbol-module",60043),symbolPackage:s("symbol-package",60043),symbolNamespace:s("symbol-namespace",60043),symbolObject:s("symbol-object",60043),symbolMethod:s("symbol-method",60044),symbolFunction:s("symbol-function",60044),symbolConstructor:s("symbol-constructor",60044),symbolBoolean:s("symbol-boolean",60047),symbolNull:s("symbol-null",60047),symbolNumeric:s("symbol-numeric",60048),symbolNumber:s("symbol-number",60048),symbolStructure:s("symbol-structure",60049),symbolStruct:s("symbol-struct",60049),symbolParameter:s("symbol-parameter",60050),symbolTypeParameter:s("symbol-type-parameter",60050),symbolKey:s("symbol-key",60051),symbolText:s("symbol-text",60051),symbolReference:s("symbol-reference",60052),goToFile:s("go-to-file",60052),symbolEnum:s("symbol-enum",60053),symbolValue:s("symbol-value",60053),symbolRuler:s("symbol-ruler",60054),symbolUnit:s("symbol-unit",60054),activateBreakpoints:s("activate-breakpoints",60055),archive:s("archive",60056),arrowBoth:s("arrow-both",60057),arrowDown:s("arrow-down",60058),arrowLeft:s("arrow-left",60059),arrowRight:s("arrow-right",60060),arrowSmallDown:s("arrow-small-down",60061),arrowSmallLeft:s("arrow-small-left",60062),arrowSmallRight:s("arrow-small-right",60063),arrowSmallUp:s("arrow-small-up",60064),arrowUp:s("arrow-up",60065),bell:s("bell",60066),bold:s("bold",60067),book:s("book",60068),bookmark:s("bookmark",60069),debugBreakpointConditionalUnverified:s("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:s("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:s("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:s("debug-breakpoint-data-unverified",60072),debugBreakpointData:s("debug-breakpoint-data",60073),debugBreakpointDataDisabled:s("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:s("debug-breakpoint-log-unverified",60074),debugBreakpointLog:s("debug-breakpoint-log",60075),debugBreakpointLogDisabled:s("debug-breakpoint-log-disabled",60075),briefcase:s("briefcase",60076),broadcast:s("broadcast",60077),browser:s("browser",60078),bug:s("bug",60079),calendar:s("calendar",60080),caseSensitive:s("case-sensitive",60081),check:s("check",60082),checklist:s("checklist",60083),chevronDown:s("chevron-down",60084),dropDownButton:s("drop-down-button",60084),chevronLeft:s("chevron-left",60085),chevronRight:s("chevron-right",60086),chevronUp:s("chevron-up",60087),chromeClose:s("chrome-close",60088),chromeMaximize:s("chrome-maximize",60089),chromeMinimize:s("chrome-minimize",60090),chromeRestore:s("chrome-restore",60091),circle:s("circle",60092),circleOutline:s("circle-outline",60092),debugBreakpointUnverified:s("debug-breakpoint-unverified",60092),circleSlash:s("circle-slash",60093),circuitBoard:s("circuit-board",60094),clearAll:s("clear-all",60095),clippy:s("clippy",60096),closeAll:s("close-all",60097),cloudDownload:s("cloud-download",60098),cloudUpload:s("cloud-upload",60099),code:s("code",60100),collapseAll:s("collapse-all",60101),colorMode:s("color-mode",60102),commentDiscussion:s("comment-discussion",60103),compareChanges:s("compare-changes",60157),creditCard:s("credit-card",60105),dash:s("dash",60108),dashboard:s("dashboard",60109),database:s("database",60110),debugContinue:s("debug-continue",60111),debugDisconnect:s("debug-disconnect",60112),debugPause:s("debug-pause",60113),debugRestart:s("debug-restart",60114),debugStart:s("debug-start",60115),debugStepInto:s("debug-step-into",60116),debugStepOut:s("debug-step-out",60117),debugStepOver:s("debug-step-over",60118),debugStop:s("debug-stop",60119),debug:s("debug",60120),deviceCameraVideo:s("device-camera-video",60121),deviceCamera:s("device-camera",60122),deviceMobile:s("device-mobile",60123),diffAdded:s("diff-added",60124),diffIgnored:s("diff-ignored",60125),diffModified:s("diff-modified",60126),diffRemoved:s("diff-removed",60127),diffRenamed:s("diff-renamed",60128),diff:s("diff",60129),discard:s("discard",60130),editorLayout:s("editor-layout",60131),emptyWindow:s("empty-window",60132),exclude:s("exclude",60133),extensions:s("extensions",60134),eyeClosed:s("eye-closed",60135),fileBinary:s("file-binary",60136),fileCode:s("file-code",60137),fileMedia:s("file-media",60138),filePdf:s("file-pdf",60139),fileSubmodule:s("file-submodule",60140),fileSymlinkDirectory:s("file-symlink-directory",60141),fileSymlinkFile:s("file-symlink-file",60142),fileZip:s("file-zip",60143),files:s("files",60144),filter:s("filter",60145),flame:s("flame",60146),foldDown:s("fold-down",60147),foldUp:s("fold-up",60148),fold:s("fold",60149),folderActive:s("folder-active",60150),folderOpened:s("folder-opened",60151),gear:s("gear",60152),gift:s("gift",60153),gistSecret:s("gist-secret",60154),gist:s("gist",60155),gitCommit:s("git-commit",60156),gitCompare:s("git-compare",60157),gitMerge:s("git-merge",60158),githubAction:s("github-action",60159),githubAlt:s("github-alt",60160),globe:s("globe",60161),grabber:s("grabber",60162),graph:s("graph",60163),gripper:s("gripper",60164),heart:s("heart",60165),home:s("home",60166),horizontalRule:s("horizontal-rule",60167),hubot:s("hubot",60168),inbox:s("inbox",60169),issueClosed:s("issue-closed",60324),issueReopened:s("issue-reopened",60171),issues:s("issues",60172),italic:s("italic",60173),jersey:s("jersey",60174),json:s("json",60175),bracket:s("bracket",60175),kebabVertical:s("kebab-vertical",60176),key:s("key",60177),law:s("law",60178),lightbulbAutofix:s("lightbulb-autofix",60179),linkExternal:s("link-external",60180),link:s("link",60181),listOrdered:s("list-ordered",60182),listUnordered:s("list-unordered",60183),liveShare:s("live-share",60184),loading:s("loading",60185),location:s("location",60186),mailRead:s("mail-read",60187),mail:s("mail",60188),markdown:s("markdown",60189),megaphone:s("megaphone",60190),mention:s("mention",60191),milestone:s("milestone",60192),mortarBoard:s("mortar-board",60193),move:s("move",60194),multipleWindows:s("multiple-windows",60195),mute:s("mute",60196),noNewline:s("no-newline",60197),note:s("note",60198),octoface:s("octoface",60199),openPreview:s("open-preview",60200),package_:s("package",60201),paintcan:s("paintcan",60202),pin:s("pin",60203),play:s("play",60204),run:s("run",60204),plug:s("plug",60205),preserveCase:s("preserve-case",60206),preview:s("preview",60207),project:s("project",60208),pulse:s("pulse",60209),question:s("question",60210),quote:s("quote",60211),radioTower:s("radio-tower",60212),reactions:s("reactions",60213),references:s("references",60214),refresh:s("refresh",60215),regex:s("regex",60216),remoteExplorer:s("remote-explorer",60217),remote:s("remote",60218),remove:s("remove",60219),replaceAll:s("replace-all",60220),replace:s("replace",60221),repoClone:s("repo-clone",60222),repoForcePush:s("repo-force-push",60223),repoPull:s("repo-pull",60224),repoPush:s("repo-push",60225),report:s("report",60226),requestChanges:s("request-changes",60227),rocket:s("rocket",60228),rootFolderOpened:s("root-folder-opened",60229),rootFolder:s("root-folder",60230),rss:s("rss",60231),ruby:s("ruby",60232),saveAll:s("save-all",60233),saveAs:s("save-as",60234),save:s("save",60235),screenFull:s("screen-full",60236),screenNormal:s("screen-normal",60237),searchStop:s("search-stop",60238),server:s("server",60240),settingsGear:s("settings-gear",60241),settings:s("settings",60242),shield:s("shield",60243),smiley:s("smiley",60244),sortPrecedence:s("sort-precedence",60245),splitHorizontal:s("split-horizontal",60246),splitVertical:s("split-vertical",60247),squirrel:s("squirrel",60248),starFull:s("star-full",60249),starHalf:s("star-half",60250),symbolClass:s("symbol-class",60251),symbolColor:s("symbol-color",60252),symbolCustomColor:s("symbol-customcolor",60252),symbolConstant:s("symbol-constant",60253),symbolEnumMember:s("symbol-enum-member",60254),symbolField:s("symbol-field",60255),symbolFile:s("symbol-file",60256),symbolInterface:s("symbol-interface",60257),symbolKeyword:s("symbol-keyword",60258),symbolMisc:s("symbol-misc",60259),symbolOperator:s("symbol-operator",60260),symbolProperty:s("symbol-property",60261),wrench:s("wrench",60261),wrenchSubaction:s("wrench-subaction",60261),symbolSnippet:s("symbol-snippet",60262),tasklist:s("tasklist",60263),telescope:s("telescope",60264),textSize:s("text-size",60265),threeBars:s("three-bars",60266),thumbsdown:s("thumbsdown",60267),thumbsup:s("thumbsup",60268),tools:s("tools",60269),triangleDown:s("triangle-down",60270),triangleLeft:s("triangle-left",60271),triangleRight:s("triangle-right",60272),triangleUp:s("triangle-up",60273),twitter:s("twitter",60274),unfold:s("unfold",60275),unlock:s("unlock",60276),unmute:s("unmute",60277),unverified:s("unverified",60278),verified:s("verified",60279),versions:s("versions",60280),vmActive:s("vm-active",60281),vmOutline:s("vm-outline",60282),vmRunning:s("vm-running",60283),watch:s("watch",60284),whitespace:s("whitespace",60285),wholeWord:s("whole-word",60286),window:s("window",60287),wordWrap:s("word-wrap",60288),zoomIn:s("zoom-in",60289),zoomOut:s("zoom-out",60290),listFilter:s("list-filter",60291),listFlat:s("list-flat",60292),listSelection:s("list-selection",60293),selection:s("selection",60293),listTree:s("list-tree",60294),debugBreakpointFunctionUnverified:s("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:s("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:s("debug-breakpoint-function-disabled",60296),debugStackframeActive:s("debug-stackframe-active",60297),circleSmallFilled:s("circle-small-filled",60298),debugStackframeDot:s("debug-stackframe-dot",60298),debugStackframe:s("debug-stackframe",60299),debugStackframeFocused:s("debug-stackframe-focused",60299),debugBreakpointUnsupported:s("debug-breakpoint-unsupported",60300),symbolString:s("symbol-string",60301),debugReverseContinue:s("debug-reverse-continue",60302),debugStepBack:s("debug-step-back",60303),debugRestartFrame:s("debug-restart-frame",60304),callIncoming:s("call-incoming",60306),callOutgoing:s("call-outgoing",60307),menu:s("menu",60308),expandAll:s("expand-all",60309),feedback:s("feedback",60310),groupByRefType:s("group-by-ref-type",60311),ungroupByRefType:s("ungroup-by-ref-type",60312),account:s("account",60313),bellDot:s("bell-dot",60314),debugConsole:s("debug-console",60315),library:s("library",60316),output:s("output",60317),runAll:s("run-all",60318),syncIgnored:s("sync-ignored",60319),pinned:s("pinned",60320),githubInverted:s("github-inverted",60321),debugAlt:s("debug-alt",60305),serverProcess:s("server-process",60322),serverEnvironment:s("server-environment",60323),pass:s("pass",60324),stopCircle:s("stop-circle",60325),playCircle:s("play-circle",60326),record:s("record",60327),debugAltSmall:s("debug-alt-small",60328),vmConnect:s("vm-connect",60329),cloud:s("cloud",60330),merge:s("merge",60331),exportIcon:s("export",60332),graphLeft:s("graph-left",60333),magnet:s("magnet",60334),notebook:s("notebook",60335),redo:s("redo",60336),checkAll:s("check-all",60337),pinnedDirty:s("pinned-dirty",60338),passFilled:s("pass-filled",60339),circleLargeFilled:s("circle-large-filled",60340),circleLarge:s("circle-large",60341),circleLargeOutline:s("circle-large-outline",60341),combine:s("combine",60342),gather:s("gather",60342),table:s("table",60343),variableGroup:s("variable-group",60344),typeHierarchy:s("type-hierarchy",60345),typeHierarchySub:s("type-hierarchy-sub",60346),typeHierarchySuper:s("type-hierarchy-super",60347),gitPullRequestCreate:s("git-pull-request-create",60348),runAbove:s("run-above",60349),runBelow:s("run-below",60350),notebookTemplate:s("notebook-template",60351),debugRerun:s("debug-rerun",60352),workspaceTrusted:s("workspace-trusted",60353),workspaceUntrusted:s("workspace-untrusted",60354),workspaceUnspecified:s("workspace-unspecified",60355),terminalCmd:s("terminal-cmd",60356),terminalDebian:s("terminal-debian",60357),terminalLinux:s("terminal-linux",60358),terminalPowershell:s("terminal-powershell",60359),terminalTmux:s("terminal-tmux",60360),terminalUbuntu:s("terminal-ubuntu",60361),terminalBash:s("terminal-bash",60362),arrowSwap:s("arrow-swap",60363),copy:s("copy",60364),personAdd:s("person-add",60365),filterFilled:s("filter-filled",60366),wand:s("wand",60367),debugLineByLine:s("debug-line-by-line",60368),inspect:s("inspect",60369),layers:s("layers",60370),layersDot:s("layers-dot",60371),layersActive:s("layers-active",60372),compass:s("compass",60373),compassDot:s("compass-dot",60374),compassActive:s("compass-active",60375),azure:s("azure",60376),issueDraft:s("issue-draft",60377),gitPullRequestClosed:s("git-pull-request-closed",60378),gitPullRequestDraft:s("git-pull-request-draft",60379),debugAll:s("debug-all",60380),debugCoverage:s("debug-coverage",60381),runErrors:s("run-errors",60382),folderLibrary:s("folder-library",60383),debugContinueSmall:s("debug-continue-small",60384),beakerStop:s("beaker-stop",60385),graphLine:s("graph-line",60386),graphScatter:s("graph-scatter",60387),pieChart:s("pie-chart",60388),bracketDot:s("bracket-dot",60389),bracketError:s("bracket-error",60390),lockSmall:s("lock-small",60391),azureDevops:s("azure-devops",60392),verifiedFilled:s("verified-filled",60393),newLine:s("newline",60394),layout:s("layout",60395),layoutActivitybarLeft:s("layout-activitybar-left",60396),layoutActivitybarRight:s("layout-activitybar-right",60397),layoutPanelLeft:s("layout-panel-left",60398),layoutPanelCenter:s("layout-panel-center",60399),layoutPanelJustify:s("layout-panel-justify",60400),layoutPanelRight:s("layout-panel-right",60401),layoutPanel:s("layout-panel",60402),layoutSidebarLeft:s("layout-sidebar-left",60403),layoutSidebarRight:s("layout-sidebar-right",60404),layoutStatusbar:s("layout-statusbar",60405),layoutMenubar:s("layout-menubar",60406),layoutCentered:s("layout-centered",60407),layoutSidebarRightOff:s("layout-sidebar-right-off",60416),layoutPanelOff:s("layout-panel-off",60417),layoutSidebarLeftOff:s("layout-sidebar-left-off",60418),target:s("target",60408),indent:s("indent",60409),recordSmall:s("record-small",60410),errorSmall:s("error-small",60411),arrowCircleDown:s("arrow-circle-down",60412),arrowCircleLeft:s("arrow-circle-left",60413),arrowCircleRight:s("arrow-circle-right",60414),arrowCircleUp:s("arrow-circle-up",60415),heartFilled:s("heart-filled",60420),map:s("map",60421),mapFilled:s("map-filled",60422),circleSmall:s("circle-small",60423),bellSlash:s("bell-slash",60424),bellSlashDot:s("bell-slash-dot",60425),commentUnresolved:s("comment-unresolved",60426),gitPullRequestGoToChanges:s("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:s("git-pull-request-new-changes",60428),searchFuzzy:s("search-fuzzy",60429),commentDraft:s("comment-draft",60430),send:s("send",60431),sparkle:s("sparkle",60432),insert:s("insert",60433),dialogError:s("dialog-error","error"),dialogWarning:s("dialog-warning","warning"),dialogInfo:s("dialog-info","info"),dialogClose:s("dialog-close","close"),treeItemExpanded:s("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:s("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:s("tree-filter-on-type-off","list-selection"),treeFilterClear:s("tree-filter-clear","close"),treeItemLoading:s("tree-item-loading","loading"),menuSelection:s("menu-selection","check"),menuSubmenu:s("menu-submenu","chevron-right"),menuBarMore:s("menubar-more","more"),scrollbarButtonLeft:s("scrollbar-button-left","triangle-left"),scrollbarButtonRight:s("scrollbar-button-right","triangle-right"),scrollbarButtonUp:s("scrollbar-button-up","triangle-up"),scrollbarButtonDown:s("scrollbar-button-down","triangle-down"),toolBarMore:s("toolbar-more","more"),quickInputBack:s("quick-input-back","arrow-left")}}),define(te[40],ie([0,1,11]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function M(g){if(!g||typeof g!="object"||g instanceof RegExp)return g;const c=Array.isArray(g)?[]:{};return Object.entries(g).forEach(([b,S])=>{c[b]=S&&typeof S=="object"?M(S):S}),c}e.deepClone=M;function s(g){if(!g||typeof g!="object")return g;const c=[g];for(;c.length>0;){const b=c.shift();Object.freeze(b);for(const S in b)if(L.call(b,S)){const D=b[S];typeof D=="object"&&!Object.isFrozen(D)&&!(0,E.isTypedArray)(D)&&c.push(D)}}return g}e.deepFreeze=s;const L=Object.prototype.hasOwnProperty;function R(g,c){return k(g,c,new Set)}e.cloneAndChange=R;function k(g,c,b){if((0,E.isUndefinedOrNull)(g))return g;const S=c(g);if(typeof S<"u")return S;if(Array.isArray(g)){const D=[];for(const t of g)D.push(k(t,c,b));return D}if((0,E.isObject)(g)){if(b.has(g))throw new Error("Cannot clone recursive data-structure");b.add(g);const D={};for(const t in g)L.call(g,t)&&(D[t]=k(g[t],c,b));return b.delete(g),D}return g}function h(g,c,b=!0){return(0,E.isObject)(g)?((0,E.isObject)(c)&&Object.keys(c).forEach(S=>{S in g?b&&((0,E.isObject)(g[S])&&(0,E.isObject)(c[S])?h(g[S],c[S],b):g[S]=c[S]):g[S]=c[S]}),g):c}e.mixin=h;function l(g,c){if(g===c)return!0;if(g==null||c===null||c===void 0||typeof g!=typeof c||typeof g!="object"||Array.isArray(g)!==Array.isArray(c))return!1;let b,S;if(Array.isArray(g)){if(g.length!==c.length)return!1;for(b=0;b<g.length;b++)if(!l(g[b],c[b]))return!1}else{const D=[];for(S in g)D.push(S);D.sort();const t=[];for(S in c)t.push(S);if(t.sort(),!l(D,t))return!1;for(b=0;b<D.length;b++)if(!l(g[D[b]],c[D[b]]))return!1}return!0}e.equals=l;function p(g){const c=new Set;return JSON.stringify(g,(b,S)=>{if((0,E.isObject)(S)||Array.isArray(S)){if(c.has(S))return"[Circular]";c.add(S)}return S})}e.safeStringify=p;function m(g,c){const b=Object.create(null);return!g||!c||Object.keys(c).forEach(D=>{const t=g[D],a=c[D];l(t,a)||(b[D]=a)}),b}e.distinct=m;function v(g,c){const b=c.toLowerCase(),S=Object.keys(g).find(D=>D.toLowerCase()===b);return S?g[S]:g[c]}e.getCaseInsensitive=v;function f(g,c){const b=Object.create(null);for(const[S,D]of Object.entries(g))c(S,D)&&(b[S]=D);return b}e.filter=f;function y(g){let c=[],b=Object.getPrototypeOf(g);for(;Object.prototype!==b;)c=c.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return c}e.getAllPropertyNames=y;function w(g){const c=[];for(const b of y(g))typeof g[b]=="function"&&c.push(b);return c}e.getAllMethodNames=w;function r(g,c){const b=D=>function(){const t=Array.prototype.slice.call(arguments,0);return c(D,t)},S={};for(const D of g)S[D]=b(D);return S}e.createProxyObject=r}),define(te[135],ie([0,1,134]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var M;(function(R){function k(h){return h&&typeof h=="object"&&typeof h.id=="string"}R.isThemeColor=k})(M||(e.ThemeColor=M={}));function s(R){return{id:R}}e.themeColorFromId=s;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function h(c){const b=k.exec(c.id);if(!b)return h(E.Codicon.error);const[,S,D]=b,t=["codicon","codicon-"+S];return D&&t.push("codicon-modifier-"+D.substring(1)),t}R.asClassNameArray=h;function l(c){return h(c).join(" ")}R.asClassName=l;function p(c){return"."+h(c).join(".")}R.asCSSSelector=p;function m(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(typeof c.color>"u"||M.isThemeColor(c.color))}R.isThemeIcon=m;const v=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function f(c){const b=v.exec(c);if(!b)return;const[,S]=b;return{id:S}}R.fromString=f;function y(c){return{id:c}}R.fromId=y;function w(c,b){let S=c.id;const D=S.lastIndexOf("~");return D!==-1&&(S=S.substring(0,D)),b&&(S=`${S}~${b}`),{id:S}}R.modify=w;function r(c){const b=c.id.lastIndexOf("~");if(b!==-1)return c.id.substring(b+1)}R.getModifier=r;function g(c,b){return c.id===b.id&&c.color?.id===b.color?.id}R.isEqual=g})(L||(e.ThemeIcon=L={}))}),define(te[31],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function M(s){return E.test(s)}e.isUUID=M,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let s;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?s=crypto.getRandomValues.bind(crypto):s=function(k){for(let h=0;h<k.length;h++)k[h]=Math.floor(Math.random()*256);return k};const L=new Uint8Array(16),R=[];for(let k=0;k<256;k++)R.push(k.toString(16).padStart(2,"0"));return function(){s(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let h=0,l="";return l+=R[L[h++]],l+=R[L[h++]],l+=R[L[h++]],l+=R[L[h++]],l+="-",l+=R[L[h++]],l+=R[L[h++]],l+="-",l+=R[L[h++]],l+=R[L[h++]],l+="-",l+=R[L[h++]],l+=R[L[h++]],l+="-",l+=R[L[h++]],l+=R[L[h++]],l+=R[L[h++]],l+=R[L[h++]],l+=R[L[h++]],l+=R[L[h++]],l}}()}),define(te[136],ie([0,1,69,41,48]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function L(R,k){if(await new Promise((p,m)=>{const v=M.createReadStream(R),f=E.createHash("sha1");v.pipe(f);const y=(0,s.once)((w,r)=>{v.removeAllListeners(),f.removeAllListeners(),w?m(w):p(r)});v.once("error",y),v.once("end",y),f.once("error",y),f.once("data",w=>y(void 0,w.toString("hex")))})!==k)throw new Error("Hash mismatch")}e.checksum=L}),define(te[137],ie([0,1,26]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const M=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function s(R){const k=R.replace(/\-/g,":").toLowerCase();return!M.has(k)}function L(){const R=(0,E.networkInterfaces)();for(const k in R){const h=R[k];if(h){for(const{mac:l}of h)if(s(l))return l}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(te[101],ie([0,1,70]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function M(k,h,l,p=1){let m=!1;return new Promise(v=>{const f=setTimeout(()=>{if(!m)return m=!0,v(0)},l);s(k,h,p,y=>{if(!m)return m=!0,clearTimeout(f),v(y)})})}e.findFreePort=M;function s(k,h,l,p){if(h===0)return p(0);const m=new E.Socket;m.once("connect",()=>(R(m),s(k+l,h-1,l,p))),m.once("data",()=>{}),m.once("error",v=>(R(m),v.code!=="ECONNREFUSED"?s(k+l,h-1,l,p):p(k))),m.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(k,h,l,p="127.0.0.1"){let m=!1,v,f=1;const y=E.createServer({pauseOnConnect:!0});function w(r,g){m||(m=!0,y.removeAllListeners(),y.close(),v&&clearTimeout(v),g(r))}return new Promise(r=>{v=setTimeout(()=>{w(0,r)},l),y.on("listening",()=>{w(k,r)}),y.on("error",g=>{g&&(g.code==="EADDRINUSE"||g.code==="EACCES")&&f<h?(k++,f++,y.listen(k,p)):w(0,r)}),y.on("close",()=>{w(0,r)}),y.listen(k,p)})}e.findFreePortFaster=L;function R(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(h){console.error(h)}}}),define(te[138],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(te[139],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class E{constructor(s,L){this.a=s,this.onMessage=L}send(s){try{this.a.send("vscode:message",s.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}e.Protocol=E}),define(te[42],ie([0,1,14,13]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.validatedIpcMain=void 0;class s{constructor(){this.a=new WeakMap}on(R,k){const h=(l,...p)=>{this.b(R,l)&&k(l,...p)};return this.a.set(k,h),E.ipcMain.on(R,h),this}once(R,k){return E.ipcMain.once(R,(h,...l)=>{this.b(R,h)&&k(h,...l)}),this}handle(R,k){return E.ipcMain.handle(R,(h,...l)=>this.b(R,h)?k(h,...l):Promise.reject(`Invalid channel '${R}' or sender for ipcMain.handle() usage.`)),this}removeHandler(R){return E.ipcMain.removeHandler(R),this}removeListener(R,k){const h=this.a.get(k);return h&&(E.ipcMain.removeListener(R,h),this.a.delete(k)),this}b(R,k){if(!R||!R.startsWith("vscode:"))return(0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because the channel is unknown.`),!1;const h=k.senderFrame,l=h.url;if(!l)return!0;let p="unknown";try{p=new URL(l).host}catch{return(0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a malformed URL '${l}'.`),!1}return p!=="vscode-app"?((0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because of a bad origin of '${p}'.`),!1):h.parent!==null?((0,M.onUnexpectedError)(`Refused to handle ipcMain event for channel '${R}' because sender of origin '${p}' is not a main frame.`),!1):!0}}e.validatedIpcMain=new s}),define(te[140],ie([0,1,14,42,11,138]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function R(){M.validatedIpcMain.on(L.CONTEXT_MENU_CHANNEL,(h,l,p,m,v)=>{const f=k(h,m,p);f.popup({window:(0,s.withNullAsUndefined)(E.BrowserWindow.fromWebContents(h.sender)),x:v?v.x:void 0,y:v?v.y:void 0,positioningItem:v?v.positioningItem:void 0,callback:()=>{f&&h.sender.send(L.CONTEXT_MENU_CLOSE_CHANNEL,l)}})})}e.registerContextMenuListener=R;function k(h,l,p){const m=new E.Menu;return p.forEach(v=>{let f;v.type==="separator"?f=new E.MenuItem({type:v.type}):Array.isArray(v.submenu)?f=new E.MenuItem({submenu:k(h,l,v.submenu),label:v.label}):f=new E.MenuItem({label:v.label,type:v.type,accelerator:v.accelerator,checked:v.checked,enabled:v.enabled,visible:v.visible,click:(y,w,r)=>h.sender.send(l,v.id,r)}),m.append(f)}),m}}),define(te[141],ie([12,10]),function(x,e){return x.create("vs/base/common/date",e)}),define(te[142],ie([0,1,141]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const M=60,s=M*60,L=s*24,R=L*7,k=L*30,h=L*365;function l(m,v,f,y){typeof m!="number"&&(m=m.getTime());const w=Math.round((new Date().getTime()-m)/1e3);if(w<-30)return(0,E.localize)(0,null,l(new Date().getTime()+w*1e3,!1));if(!y&&w<30)return(0,E.localize)(1,null);let r;return w<M?(r=w,v?r===1?f?(0,E.localize)(2,null,r):(0,E.localize)(3,null,r):f?(0,E.localize)(4,null,r):(0,E.localize)(5,null,r):r===1?f?(0,E.localize)(6,null,r):(0,E.localize)(7,null,r):f?(0,E.localize)(8,null,r):(0,E.localize)(9,null,r)):w<s?(r=Math.floor(w/M),v?r===1?f?(0,E.localize)(10,null,r):(0,E.localize)(11,null,r):f?(0,E.localize)(12,null,r):(0,E.localize)(13,null,r):r===1?f?(0,E.localize)(14,null,r):(0,E.localize)(15,null,r):f?(0,E.localize)(16,null,r):(0,E.localize)(17,null,r)):w<L?(r=Math.floor(w/s),v?r===1?f?(0,E.localize)(18,null,r):(0,E.localize)(19,null,r):f?(0,E.localize)(20,null,r):(0,E.localize)(21,null,r):r===1?f?(0,E.localize)(22,null,r):(0,E.localize)(23,null,r):f?(0,E.localize)(24,null,r):(0,E.localize)(25,null,r)):w<R?(r=Math.floor(w/L),v?r===1?(0,E.localize)(26,null,r):(0,E.localize)(27,null,r):r===1?(0,E.localize)(28,null,r):(0,E.localize)(29,null,r)):w<k?(r=Math.floor(w/R),v?r===1?f?(0,E.localize)(30,null,r):(0,E.localize)(31,null,r):f?(0,E.localize)(32,null,r):(0,E.localize)(33,null,r):r===1?f?(0,E.localize)(34,null,r):(0,E.localize)(35,null,r):f?(0,E.localize)(36,null,r):(0,E.localize)(37,null,r)):w<h?(r=Math.floor(w/k),v?r===1?f?(0,E.localize)(38,null,r):(0,E.localize)(39,null,r):f?(0,E.localize)(40,null,r):(0,E.localize)(41,null,r):r===1?f?(0,E.localize)(42,null,r):(0,E.localize)(43,null,r):f?(0,E.localize)(44,null,r):(0,E.localize)(45,null,r)):(r=Math.floor(w/h),v?r===1?f?(0,E.localize)(46,null,r):(0,E.localize)(47,null,r):f?(0,E.localize)(48,null,r):(0,E.localize)(49,null,r):r===1?f?(0,E.localize)(50,null,r):(0,E.localize)(51,null,r):f?(0,E.localize)(52,null,r):(0,E.localize)(53,null,r))}e.fromNow=l;function p(m){return m.getFullYear()+"-"+String(m.getMonth()+1).padStart(2,"0")+"-"+String(m.getDate()).padStart(2,"0")+"T"+String(m.getHours()).padStart(2,"0")+":"+String(m.getMinutes()).padStart(2,"0")+":"+String(m.getSeconds()).padStart(2,"0")+"."+(m.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=p}),define(te[143],ie([12,10]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(te[49],ie([0,1,23,11,143]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(m,v){return v&&(m.stack||m.stacktrace)?s.localize(0,null,k(m),R(m.stack)||R(m.stacktrace)):k(m)}function R(m){return Array.isArray(m)?m.join(`
`):m}function k(m){return m.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${m.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof m.code=="string"&&typeof m.errno=="number"&&typeof m.syscall=="string"?s.localize(1,null,m.message):m.message||s.localize(2,null)}function h(m=null,v=!1){if(!m)return s.localize(3,null);if(Array.isArray(m)){const f=E.coalesce(m),y=h(f[0],v);return f.length>1?s.localize(4,null,y,f.length):y}if(M.isString(m))return m;if(m.detail){const f=m.detail;if(f.error)return L(f.error,v);if(f.exception)return L(f.exception,v)}return m.stack?L(m,v):m.message?m.message:s.localize(5,null)}e.toErrorMessage=h;function l(m){const v=m;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=l;function p(m,v){let f;return typeof m=="string"?f=new Error(m):f=m,f.actions=v,f}e.createErrorWithActions=p}),define(te[144],ie([12,10]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(te[145],ie([0,1,144]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function M(s){switch(s){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=M}),define(te[146],ie([12,10]),function(x,e){return x.create("vs/base/common/platform",e)}),define(te[3],ie([0,1,146]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let M=!1,s=!1,L=!1,R=!1,k=!1,h=!1,l=!1,p=!1,m=!1,v=!1,f,y=e.LANGUAGE_DEFAULT,w=e.LANGUAGE_DEFAULT,r,g;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?c=e.globals.vscode.process:typeof process<"u"&&(c=process);const b=typeof c?.versions?.electron=="string",S=b&&c?.type==="renderer";if(typeof navigator=="object"&&!S)g=navigator.userAgent,M=g.indexOf("Windows")>=0,s=g.indexOf("Macintosh")>=0,p=(g.indexOf("Macintosh")>=0||g.indexOf("iPad")>=0||g.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=g.indexOf("Linux")>=0,v=g?.indexOf("Mobi")>=0,h=!0,f=E.getConfiguredDefaultLocale(E.localize(0,null))||e.LANGUAGE_DEFAULT,y=f,w=navigator.language;else if(typeof c=="object"){M=c.platform==="win32",s=c.platform==="darwin",L=c.platform==="linux",R=L&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,l=b,m=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,f=e.LANGUAGE_DEFAULT,y=e.LANGUAGE_DEFAULT;const I=c.env.VSCODE_NLS_CONFIG;if(I)try{const A=JSON.parse(I),C=A.availableLanguages["*"];f=A.locale,w=A.osLocale,y=C||e.LANGUAGE_DEFAULT,r=A._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var D;(function(I){I[I.Web=0]="Web",I[I.Mac=1]="Mac",I[I.Linux=2]="Linux",I[I.Windows=3]="Windows"})(D||(e.Platform=D={}));function t(I){switch(I){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let a=0;s?a=1:M?a=3:L&&(a=2),e.isWindows=M,e.isMacintosh=s,e.isLinux=L,e.isLinuxSnap=R,e.isNative=k,e.isElectron=l,e.isWeb=h,e.isWebWorker=h&&typeof e.globals.importScripts=="function",e.isIOS=p,e.isMobile=v,e.isCI=m,e.platform=a,e.userAgent=g,e.language=y;var i;(function(I){function A(){return e.language}I.value=A;function C(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}I.isDefaultVariant=C;function T(){return e.language==="en"}I.isDefault=T})(i||(e.Language=i={})),e.locale=f,e.platformLocale=w,e.translationsConfigFile=r,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const I=[];e.globals.addEventListener("message",C=>{if(C.data&&C.data.vscodeScheduleAsyncWork)for(let T=0,W=I.length;T<W;T++){const $=I[T];if($.id===C.data.vscodeScheduleAsyncWork){I.splice(T,1),$.callback();return}}});let A=0;return C=>{const T=++A;I.push({id:T,callback:C}),e.globals.postMessage({vscodeScheduleAsyncWork:T},"*")}}return I=>setTimeout(I)})();var n;(function(I){I[I.Windows=1]="Windows",I[I.Macintosh=2]="Macintosh",I[I.Linux=3]="Linux"})(n||(e.OperatingSystem=n={})),e.OS=s||p?2:M?1:3;let o=!0,u=!1;function d(){if(!u){u=!0;const I=new Uint8Array(2);I[0]=1,I[1]=2,o=new Uint16Array(I.buffer)[0]===(2<<8)+1}return o}e.isLittleEndian=d,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(te[36],ie([0,1,3]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let M;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const s=E.globals.vscode.process;M={get platform(){return s.platform},get arch(){return s.arch},get env(){return s.env},cwd(){return s.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=M.cwd,e.env=M.env,e.platform=M.platform,e.arch=M.arch}),define(te[9],ie([0,1,36]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const M=65,s=97,L=90,R=122,k=46,h=47,l=92,p=58,m=63;class v extends Error{constructor(a,i,n){let o;typeof i=="string"&&i.indexOf("not ")===0?(o="must not be",i=i.replace(/^not /,"")):o="must be";const u=a.indexOf(".")!==-1?"property":"argument";let d=`The "${a}" ${u} ${o} of type ${i}`;d+=`. Received type ${typeof n}`,super(d),this.code="ERR_INVALID_ARG_TYPE"}}function f(t,a){if(t===null||typeof t!="object")throw new v(a,"Object",t)}function y(t,a){if(typeof t!="string")throw new v(a,"string",t)}const w=E.platform==="win32";function r(t){return t===h||t===l}function g(t){return t===h}function c(t){return t>=M&&t<=L||t>=s&&t<=R}function b(t,a,i,n){let o="",u=0,d=-1,I=0,A=0;for(let C=0;C<=t.length;++C){if(C<t.length)A=t.charCodeAt(C);else{if(n(A))break;A=h}if(n(A)){if(!(d===C-1||I===1))if(I===2){if(o.length<2||u!==2||o.charCodeAt(o.length-1)!==k||o.charCodeAt(o.length-2)!==k){if(o.length>2){const T=o.lastIndexOf(i);T===-1?(o="",u=0):(o=o.slice(0,T),u=o.length-1-o.lastIndexOf(i)),d=C,I=0;continue}else if(o.length!==0){o="",u=0,d=C,I=0;continue}}a&&(o+=o.length>0?`${i}..`:"..",u=2)}else o.length>0?o+=`${i}${t.slice(d+1,C)}`:o=t.slice(d+1,C),u=C-d-1;d=C,I=0}else A===k&&I!==-1?++I:I=-1}return o}function S(t,a){f(a,"pathObject");const i=a.dir||a.root,n=a.base||`${a.name||""}${a.ext||""}`;return i?i===a.root?`${i}${n}`:`${i}${t}${n}`:n}e.win32={resolve(...t){let a="",i="",n=!1;for(let o=t.length-1;o>=-1;o--){let u;if(o>=0){if(u=t[o],y(u,"path"),u.length===0)continue}else a.length===0?u=E.cwd():(u=E.env[`=${a}`]||E.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==a.toLowerCase()&&u.charCodeAt(2)===l)&&(u=`${a}\\`));const d=u.length;let I=0,A="",C=!1;const T=u.charCodeAt(0);if(d===1)r(T)&&(I=1,C=!0);else if(r(T))if(C=!0,r(u.charCodeAt(1))){let W=2,$=W;for(;W<d&&!r(u.charCodeAt(W));)W++;if(W<d&&W!==$){const H=u.slice($,W);for($=W;W<d&&r(u.charCodeAt(W));)W++;if(W<d&&W!==$){for($=W;W<d&&!r(u.charCodeAt(W));)W++;(W===d||W!==$)&&(A=`\\\\${H}\\${u.slice($,W)}`,I=W)}}}else I=1;else c(T)&&u.charCodeAt(1)===p&&(A=u.slice(0,2),I=2,d>2&&r(u.charCodeAt(2))&&(C=!0,I=3));if(A.length>0)if(a.length>0){if(A.toLowerCase()!==a.toLowerCase())continue}else a=A;if(n){if(a.length>0)break}else if(i=`${u.slice(I)}\\${i}`,n=C,C&&a.length>0)break}return i=b(i,!n,"\\",r),n?`${a}\\${i}`:`${a}${i}`||"."},normalize(t){y(t,"path");const a=t.length;if(a===0)return".";let i=0,n,o=!1;const u=t.charCodeAt(0);if(a===1)return g(u)?"\\":t;if(r(u))if(o=!0,r(t.charCodeAt(1))){let I=2,A=I;for(;I<a&&!r(t.charCodeAt(I));)I++;if(I<a&&I!==A){const C=t.slice(A,I);for(A=I;I<a&&r(t.charCodeAt(I));)I++;if(I<a&&I!==A){for(A=I;I<a&&!r(t.charCodeAt(I));)I++;if(I===a)return`\\\\${C}\\${t.slice(A)}\\`;I!==A&&(n=`\\\\${C}\\${t.slice(A,I)}`,i=I)}}}else i=1;else c(u)&&t.charCodeAt(1)===p&&(n=t.slice(0,2),i=2,a>2&&r(t.charCodeAt(2))&&(o=!0,i=3));let d=i<a?b(t.slice(i),!o,"\\",r):"";return d.length===0&&!o&&(d="."),d.length>0&&r(t.charCodeAt(a-1))&&(d+="\\"),n===void 0?o?`\\${d}`:d:o?`${n}\\${d}`:`${n}${d}`},isAbsolute(t){y(t,"path");const a=t.length;if(a===0)return!1;const i=t.charCodeAt(0);return r(i)||a>2&&c(i)&&t.charCodeAt(1)===p&&r(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let a,i;for(let u=0;u<t.length;++u){const d=t[u];y(d,"path"),d.length>0&&(a===void 0?a=i=d:a+=`\\${d}`)}if(a===void 0)return".";let n=!0,o=0;if(typeof i=="string"&&r(i.charCodeAt(0))){++o;const u=i.length;u>1&&r(i.charCodeAt(1))&&(++o,u>2&&(r(i.charCodeAt(2))?++o:n=!1))}if(n){for(;o<a.length&&r(a.charCodeAt(o));)o++;o>=2&&(a=`\\${a.slice(o)}`)}return e.win32.normalize(a)},relative(t,a){if(y(t,"from"),y(a,"to"),t===a)return"";const i=e.win32.resolve(t),n=e.win32.resolve(a);if(i===n||(t=i.toLowerCase(),a=n.toLowerCase(),t===a))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===l;)o++;let u=t.length;for(;u-1>o&&t.charCodeAt(u-1)===l;)u--;const d=u-o;let I=0;for(;I<a.length&&a.charCodeAt(I)===l;)I++;let A=a.length;for(;A-1>I&&a.charCodeAt(A-1)===l;)A--;const C=A-I,T=d<C?d:C;let W=-1,$=0;for(;$<T;$++){const Z=t.charCodeAt(o+$);if(Z!==a.charCodeAt(I+$))break;Z===l&&(W=$)}if($!==T){if(W===-1)return n}else{if(C>T){if(a.charCodeAt(I+$)===l)return n.slice(I+$+1);if($===2)return n.slice(I+$)}d>T&&(t.charCodeAt(o+$)===l?W=$:$===2&&(W=3)),W===-1&&(W=0)}let H="";for($=o+W+1;$<=u;++$)($===u||t.charCodeAt($)===l)&&(H+=H.length===0?"..":"\\..");return I+=W,H.length>0?`${H}${n.slice(I,A)}`:(n.charCodeAt(I)===l&&++I,n.slice(I,A))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const a=e.win32.resolve(t);if(a.length<=2)return t;if(a.charCodeAt(0)===l){if(a.charCodeAt(1)===l){const i=a.charCodeAt(2);if(i!==m&&i!==k)return`\\\\?\\UNC\\${a.slice(2)}`}}else if(c(a.charCodeAt(0))&&a.charCodeAt(1)===p&&a.charCodeAt(2)===l)return`\\\\?\\${a}`;return t},dirname(t){y(t,"path");const a=t.length;if(a===0)return".";let i=-1,n=0;const o=t.charCodeAt(0);if(a===1)return r(o)?t:".";if(r(o)){if(i=n=1,r(t.charCodeAt(1))){let I=2,A=I;for(;I<a&&!r(t.charCodeAt(I));)I++;if(I<a&&I!==A){for(A=I;I<a&&r(t.charCodeAt(I));)I++;if(I<a&&I!==A){for(A=I;I<a&&!r(t.charCodeAt(I));)I++;if(I===a)return t;I!==A&&(i=n=I+1)}}}}else c(o)&&t.charCodeAt(1)===p&&(i=a>2&&r(t.charCodeAt(2))?3:2,n=i);let u=-1,d=!0;for(let I=a-1;I>=n;--I)if(r(t.charCodeAt(I))){if(!d){u=I;break}}else d=!1;if(u===-1){if(i===-1)return".";u=i}return t.slice(0,u)},basename(t,a){a!==void 0&&y(a,"ext"),y(t,"path");let i=0,n=-1,o=!0,u;if(t.length>=2&&c(t.charCodeAt(0))&&t.charCodeAt(1)===p&&(i=2),a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let d=a.length-1,I=-1;for(u=t.length-1;u>=i;--u){const A=t.charCodeAt(u);if(r(A)){if(!o){i=u+1;break}}else I===-1&&(o=!1,I=u+1),d>=0&&(A===a.charCodeAt(d)?--d===-1&&(n=u):(d=-1,n=I))}return i===n?n=I:n===-1&&(n=t.length),t.slice(i,n)}for(u=t.length-1;u>=i;--u)if(r(t.charCodeAt(u))){if(!o){i=u+1;break}}else n===-1&&(o=!1,n=u+1);return n===-1?"":t.slice(i,n)},extname(t){y(t,"path");let a=0,i=-1,n=0,o=-1,u=!0,d=0;t.length>=2&&t.charCodeAt(1)===p&&c(t.charCodeAt(0))&&(a=n=2);for(let I=t.length-1;I>=a;--I){const A=t.charCodeAt(I);if(r(A)){if(!u){n=I+1;break}continue}o===-1&&(u=!1,o=I+1),A===k?i===-1?i=I:d!==1&&(d=1):i!==-1&&(d=-1)}return i===-1||o===-1||d===0||d===1&&i===o-1&&i===n+1?"":t.slice(i,o)},format:S.bind(null,"\\"),parse(t){y(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.length;let n=0,o=t.charCodeAt(0);if(i===1)return r(o)?(a.root=a.dir=t,a):(a.base=a.name=t,a);if(r(o)){if(n=1,r(t.charCodeAt(1))){let W=2,$=W;for(;W<i&&!r(t.charCodeAt(W));)W++;if(W<i&&W!==$){for($=W;W<i&&r(t.charCodeAt(W));)W++;if(W<i&&W!==$){for($=W;W<i&&!r(t.charCodeAt(W));)W++;W===i?n=W:W!==$&&(n=W+1)}}}}else if(c(o)&&t.charCodeAt(1)===p){if(i<=2)return a.root=a.dir=t,a;if(n=2,r(t.charCodeAt(2))){if(i===3)return a.root=a.dir=t,a;n=3}}n>0&&(a.root=t.slice(0,n));let u=-1,d=n,I=-1,A=!0,C=t.length-1,T=0;for(;C>=n;--C){if(o=t.charCodeAt(C),r(o)){if(!A){d=C+1;break}continue}I===-1&&(A=!1,I=C+1),o===k?u===-1?u=C:T!==1&&(T=1):u!==-1&&(T=-1)}return I!==-1&&(u===-1||T===0||T===1&&u===I-1&&u===d+1?a.base=a.name=t.slice(d,I):(a.name=t.slice(d,u),a.base=t.slice(d,I),a.ext=t.slice(u,I))),d>0&&d!==n?a.dir=t.slice(0,d-1):a.dir=a.root,a},sep:"\\",delimiter:";",win32:null,posix:null};const D=(()=>{if(w){const t=/\\/g;return()=>{const a=E.cwd().replace(t,"/");return a.slice(a.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...t){let a="",i=!1;for(let n=t.length-1;n>=-1&&!i;n--){const o=n>=0?t[n]:D();y(o,"path"),o.length!==0&&(a=`${o}/${a}`,i=o.charCodeAt(0)===h)}return a=b(a,!i,"/",g),i?`/${a}`:a.length>0?a:"."},normalize(t){if(y(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===h,i=t.charCodeAt(t.length-1)===h;return t=b(t,!a,"/",g),t.length===0?a?"/":i?"./":".":(i&&(t+="/"),a?`/${t}`:t)},isAbsolute(t){return y(t,"path"),t.length>0&&t.charCodeAt(0)===h},join(...t){if(t.length===0)return".";let a;for(let i=0;i<t.length;++i){const n=t[i];y(n,"path"),n.length>0&&(a===void 0?a=n:a+=`/${n}`)}return a===void 0?".":e.posix.normalize(a)},relative(t,a){if(y(t,"from"),y(a,"to"),t===a||(t=e.posix.resolve(t),a=e.posix.resolve(a),t===a))return"";const i=1,n=t.length,o=n-i,u=1,d=a.length-u,I=o<d?o:d;let A=-1,C=0;for(;C<I;C++){const W=t.charCodeAt(i+C);if(W!==a.charCodeAt(u+C))break;W===h&&(A=C)}if(C===I)if(d>I){if(a.charCodeAt(u+C)===h)return a.slice(u+C+1);if(C===0)return a.slice(u+C)}else o>I&&(t.charCodeAt(i+C)===h?A=C:C===0&&(A=0));let T="";for(C=i+A+1;C<=n;++C)(C===n||t.charCodeAt(C)===h)&&(T+=T.length===0?"..":"/..");return`${T}${a.slice(u+A)}`},toNamespacedPath(t){return t},dirname(t){if(y(t,"path"),t.length===0)return".";const a=t.charCodeAt(0)===h;let i=-1,n=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===h){if(!n){i=o;break}}else n=!1;return i===-1?a?"/":".":a&&i===1?"//":t.slice(0,i)},basename(t,a){a!==void 0&&y(a,"ext"),y(t,"path");let i=0,n=-1,o=!0,u;if(a!==void 0&&a.length>0&&a.length<=t.length){if(a===t)return"";let d=a.length-1,I=-1;for(u=t.length-1;u>=0;--u){const A=t.charCodeAt(u);if(A===h){if(!o){i=u+1;break}}else I===-1&&(o=!1,I=u+1),d>=0&&(A===a.charCodeAt(d)?--d===-1&&(n=u):(d=-1,n=I))}return i===n?n=I:n===-1&&(n=t.length),t.slice(i,n)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===h){if(!o){i=u+1;break}}else n===-1&&(o=!1,n=u+1);return n===-1?"":t.slice(i,n)},extname(t){y(t,"path");let a=-1,i=0,n=-1,o=!0,u=0;for(let d=t.length-1;d>=0;--d){const I=t.charCodeAt(d);if(I===h){if(!o){i=d+1;break}continue}n===-1&&(o=!1,n=d+1),I===k?a===-1?a=d:u!==1&&(u=1):a!==-1&&(u=-1)}return a===-1||n===-1||u===0||u===1&&a===n-1&&a===i+1?"":t.slice(a,n)},format:S.bind(null,"/"),parse(t){y(t,"path");const a={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return a;const i=t.charCodeAt(0)===h;let n;i?(a.root="/",n=1):n=0;let o=-1,u=0,d=-1,I=!0,A=t.length-1,C=0;for(;A>=n;--A){const T=t.charCodeAt(A);if(T===h){if(!I){u=A+1;break}continue}d===-1&&(I=!1,d=A+1),T===k?o===-1?o=A:C!==1&&(C=1):o!==-1&&(C=-1)}if(d!==-1){const T=u===0&&i?1:u;o===-1||C===0||C===1&&o===d-1&&o===u+1?a.base=a.name=t.slice(T,d):(a.name=t.slice(T,o),a.base=t.slice(T,d),a.ext=t.slice(o,d))}return u>0?a.dir=t.slice(0,u-1):i&&(a.dir="/"),a},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=w?e.win32.normalize:e.posix.normalize,e.isAbsolute=w?e.win32.isAbsolute:e.posix.isAbsolute,e.join=w?e.win32.join:e.posix.join,e.resolve=w?e.win32.resolve:e.posix.resolve,e.relative=w?e.win32.relative:e.posix.relative,e.dirname=w?e.win32.dirname:e.posix.dirname,e.basename=w?e.win32.basename:e.posix.basename,e.extname=w?e.win32.extname:e.posix.extname,e.format=w?e.win32.format:e.posix.format,e.parse=w?e.win32.parse:e.posix.parse,e.toNamespacedPath=w?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=w?e.win32.sep:e.posix.sep,e.delimiter=w?e.win32.delimiter:e.posix.delimiter}),define(te[71],ie([0,1,3]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var M;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(M||(e.Source=M={}));var s;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(s||(e.TerminateResponseCode=s={}));function L(k,...h){const l=h.reduce((v,f)=>(v[f]=!0,v),{}),p=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(v=>!l[v]).forEach(v=>{for(let f=0;f<p.length;f++)if(v.search(p[f])!==-1){delete k[v];break}})}e.sanitizeProcessEnvironment=L;function R(k){k&&(delete k.DEBUG,E.isMacintosh&&delete k.DYLD_LIBRARY_PATH,E.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=R}),define(te[83],ie([0,1,3]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const M=E.globals.performance&&typeof E.globals.performance.now=="function";class s{static create(R=!0){return new s(R)}constructor(R){this.a=M&&R,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}e.StopWatch=s}),define(te[4],ie([0,1,13,48,2,100,83]),function(x,e,E,M,s,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,h=!1;var l;(function(u){u.None=()=>s.Disposable.None;function d(N){if(h){const{onDidAddListener:j}=N,U=y.create();let V=0;N.onDidAddListener=()=>{++V===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),j?.()}}}function I(N,j){return se(N,()=>{},0,void 0,!0,void 0,j)}u.defer=I;function A(N){return(j,U=null,V)=>{let G=!1,re;return re=N(ae=>{if(!G)return re?re.dispose():G=!0,j.call(U,ae)},null,V),G&&re.dispose(),re}}u.once=A;function C(N,j,U){return ne((V,G=null,re)=>N(ae=>V.call(G,j(ae)),null,re),U)}u.map=C;function T(N,j,U){return ne((V,G=null,re)=>N(ae=>{j(ae),V.call(G,ae)},null,re),U)}u.forEach=T;function W(N,j,U){return ne((V,G=null,re)=>N(ae=>j(ae)&&V.call(G,ae),null,re),U)}u.filter=W;function $(N){return N}u.signal=$;function H(...N){return(j,U=null,V)=>(0,s.combinedDisposable)(...N.map(G=>G(re=>j.call(U,re),null,V)))}u.any=H;function Z(N,j,U,V){let G=U;return C(N,re=>(G=j(G,re),G),V)}u.reduce=Z;function ne(N,j){let U;const V={onWillAddFirstListener(){U=N(G.fire,G)},onDidRemoveLastListener(){U?.dispose()}};j||d(V);const G=new r(V);return j?.add(G),G.event}function se(N,j,U=100,V=!1,G=!1,re,ae){let ye,Ce,Ae,Me=0,Fe;const ve={leakWarningThreshold:re,onWillAddFirstListener(){ye=N(Pe=>{Me++,Ce=j(Ce,Pe),V&&!Ae&&(we.fire(Ce),Ce=void 0),Fe=()=>{const _=Ce;Ce=void 0,Ae=void 0,(!V||Me>1)&&we.fire(_),Me=0},typeof U=="number"?(clearTimeout(Ae),Ae=setTimeout(Fe,U)):Ae===void 0&&(Ae=0,queueMicrotask(Fe))})},onWillRemoveListener(){G&&Me>0&&Fe?.()},onDidRemoveLastListener(){Fe=void 0,ye.dispose()}};ae||d(ve);const we=new r(ve);return ae?.add(we),we.event}u.debounce=se;function ue(N,j=0,U){return u.debounce(N,(V,G)=>V?(V.push(G),V):[G],j,void 0,!0,void 0,U)}u.accumulate=ue;function ce(N,j=(V,G)=>V===G,U){let V=!0,G;return W(N,re=>{const ae=V||!j(re,G);return V=!1,G=re,ae},U)}u.latch=ce;function X(N,j,U){return[u.filter(N,j,U),u.filter(N,V=>!j(V),U)]}u.split=X;function q(N,j=!1,U=[]){let V=U.slice(),G=N(ye=>{V?V.push(ye):ae.fire(ye)});const re=()=>{V?.forEach(ye=>ae.fire(ye)),V=null},ae=new r({onWillAddFirstListener(){G||(G=N(ye=>ae.fire(ye)))},onDidAddFirstListener(){V&&(j?setTimeout(re):re())},onDidRemoveLastListener(){G&&G.dispose(),G=null}});return ae.event}u.buffer=q;class B{constructor(j){this.event=j,this.c=new s.DisposableStore}map(j){return new B(C(this.event,j,this.c))}forEach(j){return new B(T(this.event,j,this.c))}filter(j){return new B(W(this.event,j,this.c))}reduce(j,U){return new B(Z(this.event,j,U,this.c))}latch(){return new B(ce(this.event,void 0,this.c))}debounce(j,U=100,V=!1,G=!1,re){return new B(se(this.event,j,U,V,G,re,this.c))}on(j,U,V){return this.event(j,U,V)}once(j,U,V){return A(this.event)(j,U,V)}dispose(){this.c.dispose()}}function z(N){return new B(N)}u.chain=z;function K(N,j,U=V=>V){const V=(...ye)=>ae.fire(U(...ye)),G=()=>N.on(j,V),re=()=>N.removeListener(j,V),ae=new r({onWillAddFirstListener:G,onDidRemoveLastListener:re});return ae.event}u.fromNodeEventEmitter=K;function ee(N,j,U=V=>V){const V=(...ye)=>ae.fire(U(...ye)),G=()=>N.addEventListener(j,V),re=()=>N.removeEventListener(j,V),ae=new r({onWillAddFirstListener:G,onDidRemoveLastListener:re});return ae.event}u.fromDOMEventEmitter=ee;function oe(N){return new Promise(j=>A(N)(j))}u.toPromise=oe;function le(N,j){return j(void 0),N(U=>j(U))}u.runAndSubscribe=le;function Y(N,j){let U=null;function V(re){U?.dispose(),U=new s.DisposableStore,j(re,U)}V(void 0);const G=N(re=>V(re));return(0,s.toDisposable)(()=>{G.dispose(),U?.dispose()})}u.runAndSubscribeWithStore=Y;class O{constructor(j,U){this._observable=j,this.c=0,this.d=!1;const V={onWillAddFirstListener:()=>{j.addObserver(this)},onDidRemoveLastListener:()=>{j.removeObserver(this)}};U||d(V),this.emitter=new r(V),U&&U.add(this.emitter)}beginUpdate(j){this.c++}handlePossibleChange(j){}handleChange(j,U){this.d=!0}endUpdate(j){this.c--,this.c===0&&(this._observable.reportChanges(),this.d&&(this.d=!1,this.emitter.fire(this._observable.get())))}}function P(N,j){return new O(N,j).emitter.event}u.fromObservable=P;function F(N){return j=>{let U=0,V=!1;const G={beginUpdate(){U++},endUpdate(){U--,U===0&&(N.reportChanges(),V&&(V=!1,j()))},handlePossibleChange(){},handleChange(){V=!0}};return N.addObserver(G),{dispose(){N.removeObserver(G)}}}}u.fromObservableLight=F})(l||(e.Event=l={}));class p{constructor(d){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${d}_${p.c++}`,p.all.add(this)}start(d){this.d=new R.StopWatch(!0),this.listenerCount=d}stop(){if(this.d){const d=this.d.elapsed();this.durations.push(d),this.elapsedOverall+=d,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=p,p.all=new Set,p.c=0;let m=-1;function v(u){const d=m;return m=u,{dispose(){m=d}}}e.setGlobalLeakWarningThreshold=v;class f{constructor(d,I=Math.random().toString(18).slice(2,5)){this.threshold=d,this.name=I,this.d=0}dispose(){this.c?.clear()}check(d,I){const A=this.threshold;if(A<=0||I<A)return;this.c||(this.c=new Map);const C=this.c.get(d.value)||0;if(this.c.set(d.value,C+1),this.d-=1,this.d<=0){this.d=A*.5;let T,W=0;for(const[$,H]of this.c)(!T||W<H)&&(T=$,W=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${I} listeners already. MOST frequent listener (${W}):`),console.warn(T)}return()=>{const T=this.c.get(d.value)||0;this.c.set(d.value,T-1)}}}class y{static create(){return new y(new Error().stack??"")}constructor(d){this.value=d}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class w{constructor(d,I,A){this.callback=d,this.callbackThis=I,this.stack=A,this.subscription=new s.SafeDisposable}invoke(d){this.callback.call(this.callbackThis,d)}}class r{constructor(d){this.j=!1,this.d=d,this.f=m>0||this.d?.leakWarningThreshold?new f(this.d?.leakWarningThreshold??m):void 0,this.g=this.d?._profName?new p(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(k){const d=Array.from(this.q);queueMicrotask(()=>{for(const I of d)I.subscription.isset()&&(I.subscription.unset(),I.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(d,I,A)=>{if(this.q||(this.q=new L.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),s.Disposable.None;const C=this.q.isEmpty();C&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let T,W;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(W=y.create(),T=this.f.check(W,this.q.size+1)),k&&(W=W??y.create());const $=new w(d,I,W),H=this.q.push($);C&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,d,I);const Z=$.subscription.set(()=>{T?.(),this.j||(this.d?.onWillRemoveListener?.(this),H(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return A instanceof s.DisposableStore?A.add(Z):Array.isArray(A)&&A.push(Z),Z}),this.l}fire(d){if(this.q){this.m||(this.m=new c(this.d?.onListenerError));for(const I of this.q)this.m.push(this,I,d);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=r;class g{constructor(d=E.onUnexpectedError){this.d=d,this.c=new L.LinkedList}get size(){return this.c.size}push(d,I,A){this.c.push(new b(d,I,A))}clear(d){const I=new L.LinkedList;for(const A of this.c)A.emitter!==d&&I.push(A);this.c=I}deliver(){for(;this.c.size>0;){const d=this.c.shift();try{d.listener.invoke(d.event)}catch(I){this.d(I)}}}}e.EventDeliveryQueue=g;class c extends g{clear(d){this.c.clear()}}class b{constructor(d,I,A){this.emitter=d,this.listener=I,this.event=A}}class S extends r{async fireAsync(d,I,A){if(this.q){this.c||(this.c=new L.LinkedList);for(const C of this.q)this.c.push([C,d]);for(;this.c.size>0&&!I.isCancellationRequested;){const[C,T]=this.c.shift(),W=[],$={...T,token:I,waitUntil:H=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");A&&(H=A(H,C.callback)),W.push(H)}};try{C.invoke($)}catch(H){(0,E.onUnexpectedError)(H);continue}Object.freeze(W),await Promise.allSettled(W).then(H=>{for(const Z of H)Z.status==="rejected"&&(0,E.onUnexpectedError)(Z.reason)})}}}}e.AsyncEmitter=S;class D extends r{constructor(d){super(d),this.h=0,this.s=new L.LinkedList,this.t=d?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const d=Array.from(this.s);this.s.clear(),super.fire(this.t(d))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(d){this.q&&(this.h!==0?this.s.push(d):super.fire(d))}}e.PauseableEmitter=D;class t extends D{constructor(d){super(d),this.c=d.delay??100}fire(d){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(d)}}e.DebounceEmitter=t;class a extends r{constructor(d){super(d),this.c=[],this.h=d?.merge}fire(d){this.hasListeners()&&(this.c.push(d),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(I=>super.fire(I)),this.c=[]}))}}e.MicrotaskEmitter=a;class i{constructor(){this.d=!1,this.f=[],this.c=new r({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(d){const I={event:d,listener:null};this.f.push(I),this.d&&this.j(I);const A=()=>{this.d&&this.k(I);const C=this.f.indexOf(I);this.f.splice(C,1)};return(0,s.toDisposable)((0,M.once)(A))}g(){this.d=!0,this.f.forEach(d=>this.j(d))}h(){this.d=!1,this.f.forEach(d=>this.k(d))}j(d){d.listener=d.event(I=>this.c.fire(I))}k(d){d.listener&&d.listener.dispose(),d.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.c=[]}wrapEvent(d){return(I,A,C)=>d(T=>{const W=this.c[this.c.length-1];W?W.push(()=>I.call(A,T)):I.call(A,T)},void 0,C)}bufferEvents(d){const I=[];this.c.push(I);const A=d();return this.c.pop(),I.forEach(C=>C()),A}}e.EventBufferer=n;class o{constructor(){this.c=!1,this.d=l.None,this.f=s.Disposable.None,this.g=new r({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(d){this.d=d,this.c&&(this.f.dispose(),this.f=d(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(te[22],ie([0,1,4]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const M=Object.freeze(function(k,h){const l=setTimeout(k.bind(h),0);return{dispose(){clearTimeout(l)}}});var s;(function(k){function h(l){return l===k.None||l===k.Cancelled||l instanceof L?!0:!l||typeof l!="object"?!1:typeof l.isCancellationRequested=="boolean"&&typeof l.onCancellationRequested=="function"}k.isCancellationToken=h,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(s||(e.CancellationToken=s={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class R{constructor(h){this.a=void 0,this.b=void 0,this.b=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new L),this.a}cancel(){this.a?this.a instanceof L&&this.a.cancel():this.a=s.Cancelled}dispose(h=!1){h&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof L&&this.a.dispose():this.a=s.None}}e.CancellationTokenSource=R}),define(te[147],ie([0,1,22]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class M{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new E.CancellationTokenSource,h=this.b(k.token);return this.a={promise:h,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.Cache=M;class s{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const h=JSON.stringify(k);return this.b!==h&&(this.b=h,this.a=this.c(k)),this.a}}e.LRUCachedFunction=s;class L{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const h=this.b(k);return this.a.set(k,h),h}}e.CachedFunction=L}),define(te[27],ie([0,1,147,130]),function(x,e,E,M){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(J){return!J||typeof J!="string"?!0:J.trim().length===0}e.isFalsyOrWhitespace=L;const R=/{(\d+)}/g;function k(J,...de){return de.length===0?J:J.replace(R,function(ge,me){const Se=parseInt(me,10);return isNaN(Se)||Se<0||Se>=de.length?ge:de[Se]})}e.format=k;const h=/{([^}]+)}/g;function l(J,de){return J.replace(h,(ge,me)=>de[me]??ge)}e.format2=l;function p(J){return J.replace(/[<>&]/g,function(de){switch(de){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return de}})}e.escape=p;function m(J){return J.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=m;function v(J,de){let ge=0;const me=de.charCodeAt(0);for(let Se=J.length-1;Se>=0;Se--)J.charCodeAt(Se)===me&&ge++;return ge}e.count=v;function f(J,de,ge="\u2026"){return J.length<=de?J:`${J.substr(0,de)}${ge}`}e.truncate=f;function y(J,de=" "){const ge=w(J,de);return r(ge,de)}e.trim=y;function w(J,de){if(!J||!de)return J;const ge=de.length;if(ge===0||J.length===0)return J;let me=0;for(;J.indexOf(de,me)===me;)me=me+ge;return J.substring(me)}e.ltrim=w;function r(J,de){if(!J||!de)return J;const ge=de.length,me=J.length;if(ge===0||me===0)return J;let Se=me,Le=-1;for(;Le=J.lastIndexOf(de,Se-1),!(Le===-1||Le+ge!==Se);){if(Le===0)return"";Se=Le}return J.substring(0,Se)}e.rtrim=r;function g(J){return J.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=g;function c(J){return J.replace(/\*/g,"")}e.stripWildcards=c;function b(J,de,ge={}){if(!J)throw new Error("Cannot create regex from empty string");de||(J=m(J)),ge.wholeWord&&(/\B/.test(J.charAt(0))||(J="\\b"+J),/\B/.test(J.charAt(J.length-1))||(J=J+"\\b"));let me="";return ge.global&&(me+="g"),ge.matchCase||(me+="i"),ge.multiline&&(me+="m"),ge.unicode&&(me+="u"),new RegExp(J,me)}e.createRegExp=b;function S(J){return J.source==="^"||J.source==="^$"||J.source==="$"||J.source==="^\\s*$"?!1:!!(J.exec("")&&J.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function D(J){return!!J.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=D;function t(J){return(J.global?"g":"")+(J.ignoreCase?"i":"")+(J.multiline?"m":"")+(J.unicode?"u":"")}e.regExpFlags=t;function a(J){return J.split(/\r\n|\r|\n/)}e.splitLines=a;function i(J){for(let de=0,ge=J.length;de<ge;de++){const me=J.charCodeAt(de);if(me!==32&&me!==9)return de}return-1}e.firstNonWhitespaceIndex=i;function n(J,de=0,ge=J.length){for(let me=de;me<ge;me++){const Se=J.charCodeAt(me);if(Se!==32&&Se!==9)return J.substring(de,me)}return J.substring(de,ge)}e.getLeadingWhitespace=n;function o(J,de=J.length-1){for(let ge=de;ge>=0;ge--){const me=J.charCodeAt(ge);if(me!==32&&me!==9)return ge}return-1}e.lastNonWhitespaceIndex=o;function u(J,de,ge){const me=[];let Se=0;for(const Le of J.matchAll(de)){if(me.push(J.slice(Se,Le.index)),Le.index===void 0)throw new Error("match.index should be defined");Se=Le.index+Le[0].length,me.push(ge(Le[0],...Le.slice(1),Le.index,J,Le.groups))}return me.push(J.slice(Se)),Promise.all(me).then(Le=>Le.join(""))}e.replaceAsync=u;function d(J,de){return J<de?-1:J>de?1:0}e.compare=d;function I(J,de,ge=0,me=J.length,Se=0,Le=de.length){for(;ge<me&&Se<Le;ge++,Se++){const Ze=J.charCodeAt(ge),Ge=de.charCodeAt(Se);if(Ze<Ge)return-1;if(Ze>Ge)return 1}const je=me-ge,Ke=Le-Se;return je<Ke?-1:je>Ke?1:0}e.compareSubstring=I;function A(J,de){return C(J,de,0,J.length,0,de.length)}e.compareIgnoreCase=A;function C(J,de,ge=0,me=J.length,Se=0,Le=de.length){for(;ge<me&&Se<Le;ge++,Se++){let Ze=J.charCodeAt(ge),Ge=de.charCodeAt(Se);if(Ze===Ge)continue;if(Ze>=128||Ge>=128)return I(J.toLowerCase(),de.toLowerCase(),ge,me,Se,Le);W(Ze)&&(Ze-=32),W(Ge)&&(Ge-=32);const Ye=Ze-Ge;if(Ye!==0)return Ye}const je=me-ge,Ke=Le-Se;return je<Ke?-1:je>Ke?1:0}e.compareSubstringIgnoreCase=C;function T(J){return J>=48&&J<=57}e.isAsciiDigit=T;function W(J){return J>=97&&J<=122}e.isLowerAsciiLetter=W;function $(J){return J>=65&&J<=90}e.isUpperAsciiLetter=$;function H(J,de){return J.length===de.length&&C(J,de)===0}e.equalsIgnoreCase=H;function Z(J,de){const ge=de.length;return de.length>J.length?!1:C(J,de,0,ge)===0}e.startsWithIgnoreCase=Z;function ne(J,de){const ge=Math.min(J.length,de.length);let me;for(me=0;me<ge;me++)if(J.charCodeAt(me)!==de.charCodeAt(me))return me;return ge}e.commonPrefixLength=ne;function se(J,de){const ge=Math.min(J.length,de.length);let me;const Se=J.length-1,Le=de.length-1;for(me=0;me<ge;me++)if(J.charCodeAt(Se-me)!==de.charCodeAt(Le-me))return me;return ge}e.commonSuffixLength=se;function ue(J){return 55296<=J&&J<=56319}e.isHighSurrogate=ue;function ce(J){return 56320<=J&&J<=57343}e.isLowSurrogate=ce;function X(J,de){return(J-55296<<10)+(de-56320)+65536}e.computeCodePoint=X;function q(J,de,ge){const me=J.charCodeAt(ge);if(ue(me)&&ge+1<de){const Se=J.charCodeAt(ge+1);if(ce(Se))return X(me,Se)}return me}e.getNextCodePoint=q;function B(J,de){const ge=J.charCodeAt(de-1);if(ce(ge)&&de>1){const me=J.charCodeAt(de-2);if(ue(me))return X(me,ge)}return ge}class z{get offset(){return this.e}constructor(de,ge=0){this.c=de,this.d=de.length,this.e=ge}setOffset(de){this.e=de}prevCodePoint(){const de=B(this.c,this.e);return this.e-=de>=65536?2:1,de}nextCodePoint(){const de=q(this.c,this.d,this.e);return this.e+=de>=65536?2:1,de}eol(){return this.e>=this.d}}e.CodePointIterator=z;class K{get offset(){return this.c.offset}constructor(de,ge=0){this.c=new z(de,ge)}nextGraphemeLength(){const de=ke.getInstance(),ge=this.c,me=ge.offset;let Se=de.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Le=ge.offset,je=de.getGraphemeBreakType(ge.nextCodePoint());if(fe(Se,je)){ge.setOffset(Le);break}Se=je}return ge.offset-me}prevGraphemeLength(){const de=ke.getInstance(),ge=this.c,me=ge.offset;let Se=de.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Le=ge.offset,je=de.getGraphemeBreakType(ge.prevCodePoint());if(fe(je,Se)){ge.setOffset(Le);break}Se=je}return me-ge.offset}eol(){return this.c.eol()}}e.GraphemeIterator=K;function ee(J,de){return new K(J,de).nextGraphemeLength()}e.nextCharLength=ee;function oe(J,de){return new K(J,de).prevGraphemeLength()}e.prevCharLength=oe;function le(J,de){de>0&&ce(J.charCodeAt(de))&&de--;const ge=de+ee(J,de);return[ge-oe(J,ge),ge]}e.getCharContainingOffset=le;function Y(J){const de=new K(J);let ge=0;for(;!de.eol();)ge++,de.nextGraphemeLength();return ge}e.charCount=Y;let O;function P(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function F(J){return O||(O=P()),O.test(J)}e.containsRTL=F;const N=/^[\t\n\r\x20-\x7E]*$/;function j(J){return N.test(J)}e.isBasicASCII=j,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function U(J){return e.UNUSUAL_LINE_TERMINATORS.test(J)}e.containsUnusualLineTerminators=U;function V(J){return J>=11904&&J<=55215||J>=63744&&J<=64255||J>=65281&&J<=65374}e.isFullWidthCharacter=V;function G(J){return J>=127462&&J<=127487||J===8986||J===8987||J===9200||J===9203||J>=9728&&J<=10175||J===11088||J===11093||J>=127744&&J<=128591||J>=128640&&J<=128764||J>=128992&&J<=129008||J>=129280&&J<=129535||J>=129648&&J<=129782}e.isEmojiImprecise=G;function re(J,de){if(J.length<de)return J;const ge=/\b/g;let me=0;for(;ge.test(J)&&!(J.length-ge.lastIndex<de);)me=ge.lastIndex,ge.lastIndex+=1;return J.substring(me).replace(/^\s/,"")}e.lcut=re;const ae=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,ye=/\x1b\].*?\x07/g;function Ce(J){return J&&(J=J.replace(ae,"").replace(ye,"")),J}e.removeAnsiEscapeCodes=Ce,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ae(J){return!!(J&&J.length>0&&J.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ae;function Me(J){return Ae(J)?J.substr(1):J}e.stripUTF8BOM=Me;function Fe(J,de){if(!J||!de||J.length<de.length)return!1;const ge=de.length,me=J.toLowerCase();let Se=0,Le=-1;for(;Se<ge;){const je=me.indexOf(de[Se],Le+1);if(je<0)return!1;Le=je,Se++}return!0}e.fuzzyContains=Fe;function ve(J,de=!1){return J?(de&&(J=J.replace(/\\./g,"")),J.toLowerCase()!==J):!1}e.containsUppercaseCharacter=ve;function we(J){return J.charAt(0).toUpperCase()+J.slice(1)}e.uppercaseFirstLetter=we;function Pe(J,de=1){if(de===0)return"";let ge=-1;do ge=J.indexOf(`
`,ge+1),de--;while(de>0&&ge>=0);return ge===-1?J:(J[ge-1]==="\r"&&ge--,J.substr(0,ge))}e.getNLines=Pe;function _(J){return J=J%(2*26),J<26?String.fromCharCode(97+J):String.fromCharCode(65+J-26)}e.singleLetterHash=_;function he(J){return ke.getInstance().getGraphemeBreakType(J)}e.getGraphemeBreakType=he;function fe(J,de){return J===0?de!==5&&de!==7:J===2&&de===3?!1:J===4||J===2||J===3||de===4||de===2||de===3?!0:!(J===8&&(de===8||de===9||de===11||de===12)||(J===11||J===9)&&(de===9||de===10)||(J===12||J===10)&&de===10||de===5||de===13||de===7||J===1||J===13&&de===14||J===6&&de===6)}var Ee;(function(J){J[J.Other=0]="Other",J[J.Prepend=1]="Prepend",J[J.CR=2]="CR",J[J.LF=3]="LF",J[J.Control=4]="Control",J[J.Extend=5]="Extend",J[J.Regional_Indicator=6]="Regional_Indicator",J[J.SpacingMark=7]="SpacingMark",J[J.L=8]="L",J[J.V=9]="V",J[J.T=10]="T",J[J.LV=11]="LV",J[J.LVT=12]="LVT",J[J.ZWJ=13]="ZWJ",J[J.Extended_Pictographic=14]="Extended_Pictographic"})(Ee||(e.GraphemeBreakType=Ee={}));class ke{static getInstance(){return ke.c||(ke.c=new ke),ke.c}constructor(){this.d=Oe()}getGraphemeBreakType(de){if(de<32)return de===10?3:de===13?2:4;if(de<127)return 0;const ge=this.d,me=ge.length/3;let Se=1;for(;Se<=me;)if(de<ge[3*Se])Se=2*Se;else if(de>ge[3*Se+1])Se=2*Se+1;else return ge[3*Se+2];return 0}}ke.c=null;function Oe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function We(J,de){if(J===0)return 0;const ge=He(J,de);if(ge!==void 0)return ge;const me=new z(de,J);return me.prevCodePoint(),me.offset}e.getLeftDeleteOffset=We;function He(J,de){const ge=new z(de,J);let me=ge.prevCodePoint();for(;Ne(me)||me===65039||me===8419;){if(ge.offset===0)return;me=ge.prevCodePoint()}if(!G(me))return;let Se=ge.offset;return Se>0&&ge.prevCodePoint()===8205&&(Se=ge.offset),Se}function Ne(J){return 127995<=J&&J<=127999}var ze;(function(J){J[J.zwj=8205]="zwj",J[J.emojiVariantSelector=65039]="emojiVariantSelector",J[J.enclosingKeyCap=8419]="enclosingKeyCap"})(ze||(ze={})),e.noBreakWhitespace="\xA0";class qe{static getInstance(de){return qe.d.get(Array.from(de))}static getLocales(){return qe.e.value}constructor(de){this.f=de}isAmbiguous(de){return this.f.has(de)}getPrimaryConfusable(de){return this.f.get(de)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=qe,s=qe,qe.c=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),qe.d=new E.LRUCachedFunction(J=>{function de(Ge){const Ye=new Map;for(let tt=0;tt<Ge.length;tt+=2)Ye.set(Ge[tt],Ge[tt+1]);return Ye}function ge(Ge,Ye){const tt=new Map(Ge);for(const[ot,lt]of Ye)tt.set(ot,lt);return tt}function me(Ge,Ye){if(!Ge)return Ye;const tt=new Map;for(const[ot,lt]of Ge)Ye.has(ot)&&tt.set(ot,lt);return tt}const Se=s.c.value;let Le=J.filter(Ge=>!Ge.startsWith("_")&&Ge in Se);Le.length===0&&(Le=["_default"]);let je;for(const Ge of Le){const Ye=de(Se[Ge]);je=me(je,Ye)}const Ke=de(Se._common),Ze=ge(Ke,je);return new qe(Ze)}),qe.e=new M.Lazy(()=>Object.keys(qe.c.value).filter(J=>!J.startsWith("_")));class Ue{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ue.c())),this.d}static isInvisibleCharacter(de){return Ue.e().has(de)}static get codePoints(){return Ue.e()}}e.InvisibleCharacters=Ue,Ue.d=void 0}),define(te[32],ie([0,1,9,3,27,11]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(u){return u===47||u===92}e.isPathSeparator=R;function k(u){return u.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=k;function h(u){return u.indexOf("/")===-1&&(u=k(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.toPosixPath=h;function l(u,d=E.posix.sep){if(!u)return"";const I=u.length,A=u.charCodeAt(0);if(R(A)){if(R(u.charCodeAt(1))&&!R(u.charCodeAt(2))){let T=3;const W=T;for(;T<I&&!R(u.charCodeAt(T));T++);if(W!==T&&!R(u.charCodeAt(T+1))){for(T+=1;T<I;T++)if(R(u.charCodeAt(T)))return u.slice(0,T+1).replace(/[\\/]/g,d)}}return d}else if(g(A)&&u.charCodeAt(1)===58)return R(u.charCodeAt(2))?u.slice(0,2)+d:u.slice(0,2);let C=u.indexOf("://");if(C!==-1){for(C+=3;C<I;C++)if(R(u.charCodeAt(C)))return u.slice(0,C+1)}return""}e.getRoot=l;function p(u){if(!M.isWindows||!u||u.length<5)return!1;let d=u.charCodeAt(0);if(d!==92||(d=u.charCodeAt(1),d!==92))return!1;let I=2;const A=I;for(;I<u.length&&(d=u.charCodeAt(I),d!==92);I++);return!(A===I||(d=u.charCodeAt(I+1),isNaN(d)||d===92))}e.isUNC=p;const m=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,f=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function y(u,d=M.isWindows){const I=d?m:v;return!(!u||u.length===0||/^\s+$/.test(u)||(I.lastIndex=0,I.test(u))||d&&f.test(u)||u==="."||u===".."||d&&u[u.length-1]==="."||d&&u.length!==u.trim().length||u.length>255)}e.isValidBasename=y;function w(u,d,I){const A=u===d;return!I||A?A:!u||!d?!1:(0,s.equalsIgnoreCase)(u,d)}e.isEqual=w;function r(u,d,I,A=E.sep){if(u===d)return!0;if(!u||!d||d.length>u.length)return!1;if(I){if(!(0,s.startsWithIgnoreCase)(u,d))return!1;if(d.length===u.length)return!0;let T=d.length;return d.charAt(d.length-1)===A&&T--,u.charAt(T)===A}return d.charAt(d.length-1)!==A&&(d+=A),u.indexOf(d)===0}e.isEqualOrParent=r;function g(u){return u>=65&&u<=90||u>=97&&u<=122}e.isWindowsDriveLetter=g;function c(u,d){return M.isWindows&&u.endsWith(":")&&(u+=E.sep),(0,E.isAbsolute)(u)||(u=(0,E.join)(d,u)),u=(0,E.normalize)(u),M.isWindows?(u=(0,s.rtrim)(u,E.sep),u.endsWith(":")&&(u+=E.sep)):(u=(0,s.rtrim)(u,E.sep),u||(u=E.sep)),u}e.sanitizeFilePath=c;function b(u){const d=(0,E.normalize)(u);return M.isWindows?u.length>3?!1:S(d)&&(u.length===2||d.charCodeAt(2)===92):d===E.posix.sep}e.isRootOrDriveLetter=b;function S(u,d=M.isWindows){return d?g(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function D(u){return S(u)?u[0]:void 0}e.getDriveLetter=D;function t(u,d,I){return d.length>u.length?-1:u===d?0:(I&&(u=u.toLowerCase(),d=d.toLowerCase()),u.indexOf(d))}e.indexOfPath=t;function a(u){const d=u.split(":");let I,A,C;for(const T of d){const W=Number(T);(0,L.isNumber)(W)?A===void 0?A=W:C===void 0&&(C=W):I=I?[I,T].join(":"):T}if(!I)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:I,line:A!==void 0?A:void 0,column:C!==void 0?C:A!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",n="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function o(u,d,I=8){let A="";for(let T=0;T<I;T++){let W;T===0&&M.isWindows&&!d&&(I===3||I===4)?W=n:W=i,A+=W.charAt(Math.floor(Math.random()*W.length))}let C;return d?C=`${d}-${A}`:C=A,u?(0,E.join)(u,C):C}e.randomPath=o}),define(te[56],ie([0,1,27]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function M(g){return s(g,0)}e.hash=M;function s(g,c){switch(typeof g){case"object":return g===null?L(349,c):Array.isArray(g)?h(g,c):l(g,c);case"string":return k(g,c);case"boolean":return R(g,c);case"number":return L(g,c);case"undefined":return L(937,c);default:return L(617,c)}}e.doHash=s;function L(g,c){return(c<<5)-c+g|0}e.numberHash=L;function R(g,c){return L(g?433:863,c)}function k(g,c){c=L(149417,c);for(let b=0,S=g.length;b<S;b++)c=L(g.charCodeAt(b),c);return c}e.stringHash=k;function h(g,c){return c=L(104579,c),g.reduce((b,S)=>s(S,b),c)}function l(g,c){return c=L(181387,c),Object.keys(g).sort().reduce((b,S)=>(b=k(S,b),s(g[S],b)),c)}class p{constructor(){this.g=0}get value(){return this.g}hash(c){return this.g=s(c,this.g),this.g}}e.Hasher=p;var m;(function(g){g[g.BLOCK_SIZE=64]="BLOCK_SIZE",g[g.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(m||(m={}));function v(g,c,b=32){const S=b-c,D=~((1<<S)-1);return(g<<c|(D&g)>>>S)>>>0}function f(g,c=0,b=g.byteLength,S=0){for(let D=0;D<b;D++)g[c+D]=S}function y(g,c,b="0"){for(;g.length<c;)g=b+g;return g}function w(g,c=32){return g instanceof ArrayBuffer?Array.from(new Uint8Array(g)).map(b=>b.toString(16).padStart(2,"0")).join(""):y((g>>>0).toString(16),c/4)}e.toHexString=w;class r{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(c){const b=c.length;if(b===0)return;const S=this.p;let D=this.r,t=this.u,a,i;for(t!==0?(a=t,i=-1,t=0):(a=c.charCodeAt(0),i=0);;){let n=a;if(E.isHighSurrogate(a))if(i+1<b){const o=c.charCodeAt(i+1);E.isLowSurrogate(o)?(i++,n=E.computeCodePoint(a,o)):n=65533}else{t=a;break}else E.isLowSurrogate(a)&&(n=65533);if(D=this.w(S,D,n),i++,i<b)a=c.charCodeAt(i);else break}this.r=D,this.u=t}w(c,b,S){return S<128?c[b++]=S:S<2048?(c[b++]=192|(S&1984)>>>6,c[b++]=128|(S&63)>>>0):S<65536?(c[b++]=224|(S&61440)>>>12,c[b++]=128|(S&4032)>>>6,c[b++]=128|(S&63)>>>0):(c[b++]=240|(S&1835008)>>>18,c[b++]=128|(S&258048)>>>12,c[b++]=128|(S&4032)>>>6,c[b++]=128|(S&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,c[0]=c[64+0],c[1]=c[64+1],c[2]=c[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),w(this.h)+w(this.l)+w(this.m)+w(this.n)+w(this.o)}x(){this.p[this.r++]=128,f(this.p,this.r),this.r>56&&(this.y(),f(this.p));const c=8*this.t;this.q.setUint32(56,Math.floor(c/4294967296),!1),this.q.setUint32(60,c%4294967296,!1),this.y()}y(){const c=r.g,b=this.q;for(let d=0;d<64;d+=4)c.setUint32(d,b.getUint32(d,!1),!1);for(let d=64;d<320;d+=4)c.setUint32(d,v(c.getUint32(d-12,!1)^c.getUint32(d-32,!1)^c.getUint32(d-56,!1)^c.getUint32(d-64,!1),1),!1);let S=this.h,D=this.l,t=this.m,a=this.n,i=this.o,n,o,u;for(let d=0;d<80;d++)d<20?(n=D&t|~D&a,o=1518500249):d<40?(n=D^t^a,o=1859775393):d<60?(n=D&t|D&a|t&a,o=2400959708):(n=D^t^a,o=3395469782),u=v(S,5)+n+i+o+c.getUint32(d*4,!1)&4294967295,i=a,a=t,t=v(D,30),D=S,S=u;this.h=this.h+S&4294967295,this.l=this.l+D&4294967295,this.m=this.m+t&4294967295,this.n=this.n+a&4294967295,this.o=this.o+i&4294967295}}e.StringSHA1=r,r.g=new DataView(new ArrayBuffer(320))}),define(te[72],ie([0,1,27]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var M;(function(s){s[s.Ignore=0]="Ignore",s[s.Info=1]="Info",s[s.Warning=2]="Warning",s[s.Error=3]="Error"})(M||(M={})),function(s){const L="error",R="warning",k="warn",h="info",l="ignore";function p(v){return v?E.equalsIgnoreCase(L,v)?s.Error:E.equalsIgnoreCase(R,v)||E.equalsIgnoreCase(k,v)?s.Warning:E.equalsIgnoreCase(h,v)?s.Info:s.Ignore:s.Ignore}s.fromValue=p;function m(v){switch(v){case s.Error:return L;case s.Warning:return R;case s.Info:return h;default:return l}}s.toString=m}(M||(M={})),e.default=M}),define(te[61],ie([0,1,23,27]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class s{constructor(){this.b="",this.c=0}reset(f){return this.b=f,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(f){const y=f.charCodeAt(0),w=this.b.charCodeAt(this.c);return y-w}value(){return this.b[this.c]}}e.StringIterator=s;class L{constructor(f=!0){this.e=f}reset(f){return this.b=f,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let f=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(f)this.c++;else break;else f=!1;return this}cmp(f){return this.e?(0,M.compareSubstring)(f,this.b,0,f.length,this.c,this.d):(0,M.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=L;class R{constructor(f=!0,y=!0){this.f=f,this.g=y}reset(f){this.d=0,this.e=0,this.b=f,this.c=f.length;for(let y=f.length-1;y>=0;y--,this.c--){const w=this.b.charCodeAt(y);if(!(w===47||this.f&&w===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let f=!0;for(;this.e<this.c;this.e++){const y=this.b.charCodeAt(this.e);if(y===47||this.f&&y===92)if(f)this.d++;else break;else f=!1}return this}cmp(f){return this.g?(0,M.compareSubstring)(f,this.b,0,f.length,this.d,this.e):(0,M.compareSubstringIgnoreCase)(f,this.b,0,f.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=R;var k;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(k||(k={}));class h{constructor(f,y){this.f=f,this.g=y,this.d=[],this.e=0}reset(f){return this.c=f,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(f)),this.b.reset(f.path),this.b.value()&&this.d.push(3)),this.g(f)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(f){if(this.d[this.e]===1)return(0,M.compareIgnoreCase)(f,this.c.scheme);if(this.d[this.e]===2)return(0,M.compareIgnoreCase)(f,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(f);if(this.d[this.e]===4)return(0,M.compare)(f,this.c.query);if(this.d[this.e]===5)return(0,M.compare)(f,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=h;class l{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const f=this.right;return this.right=f.left,f.left=this,this.updateHeight(),f.updateHeight(),f}rotateRight(){const f=this.left;return this.left=f.right,f.right=this,this.updateHeight(),f.updateHeight(),f}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var p;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(p||(p={}));class m{static forUris(f=()=>!1,y=()=>!1){return new m(new h(f,y))}static forPaths(f=!1){return new m(new R(void 0,!f))}static forStrings(){return new m(new s)}static forConfigKeys(){return new m(new L)}constructor(f){this.b=f}clear(){this.c=void 0}fill(f,y){if(y){const w=y.slice(0);(0,E.shuffle)(w);for(const r of w)this.set(r,f)}else{const w=f.slice(0);(0,E.shuffle)(w);for(const r of w)this.set(r[0],r[1])}}set(f,y){const w=this.b.reset(f);let r;this.c||(this.c=new l,this.c.segment=w.value());const g=[];for(r=this.c;;){const b=w.cmp(r.segment);if(b>0)r.left||(r.left=new l,r.left.segment=w.value()),g.push([-1,r]),r=r.left;else if(b<0)r.right||(r.right=new l,r.right.segment=w.value()),g.push([1,r]),r=r.right;else if(w.hasNext())w.next(),r.mid||(r.mid=new l,r.mid.segment=w.value()),g.push([0,r]),r=r.mid;else break}const c=r.value;r.value=y,r.key=f;for(let b=g.length-1;b>=0;b--){const S=g[b][1];S.updateHeight();const D=S.balanceFactor();if(D<-1||D>1){const t=g[b][0],a=g[b+1][0];if(t===1&&a===1)g[b][1]=S.rotateLeft();else if(t===-1&&a===-1)g[b][1]=S.rotateRight();else if(t===1&&a===-1)S.right=g[b+1][1]=g[b+1][1].rotateRight(),g[b][1]=S.rotateLeft();else if(t===-1&&a===1)S.left=g[b+1][1]=g[b+1][1].rotateLeft(),g[b][1]=S.rotateRight();else throw new Error;if(b>0)switch(g[b-1][0]){case-1:g[b-1][1].left=g[b][1];break;case 1:g[b-1][1].right=g[b][1];break;case 0:g[b-1][1].mid=g[b][1];break}else this.c=g[0][1]}}return c}get(f){return this.d(f)?.value}d(f){const y=this.b.reset(f);let w=this.c;for(;w;){const r=y.cmp(w.segment);if(r>0)w=w.left;else if(r<0)w=w.right;else if(y.hasNext())y.next(),w=w.mid;else break}return w}has(f){const y=this.d(f);return!(y?.value===void 0&&y?.mid===void 0)}delete(f){return this.e(f,!1)}deleteSuperstr(f){return this.e(f,!0)}e(f,y){const w=this.b.reset(f),r=[];let g=this.c;for(;g;){const c=w.cmp(g.segment);if(c>0)r.push([-1,g]),g=g.left;else if(c<0)r.push([1,g]),g=g.right;else if(w.hasNext())w.next(),r.push([0,g]),g=g.mid;else break}if(g){if(y?(g.left=void 0,g.mid=void 0,g.right=void 0,g.height=1):(g.key=void 0,g.value=void 0),!g.mid&&!g.value)if(g.left&&g.right){const c=this.f(g.right);if(c.key){const{key:b,value:S,segment:D}=c;this.e(c.key,!1),g.key=b,g.value=S,g.segment=D}}else{const c=g.left??g.right;if(r.length>0){const[b,S]=r[r.length-1];switch(b){case-1:S.left=c;break;case 0:S.mid=c;break;case 1:S.right=c;break}}else this.c=c}for(let c=r.length-1;c>=0;c--){const b=r[c][1];b.updateHeight();const S=b.balanceFactor();if(S>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),r[c][1]=b.rotateLeft()):S<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),r[c][1]=b.rotateRight()),c>0)switch(r[c-1][0]){case-1:r[c-1][1].left=r[c][1];break;case 1:r[c-1][1].right=r[c][1];break;case 0:r[c-1][1].mid=r[c][1];break}else this.c=r[0][1]}}}f(f){for(;f.left;)f=f.left;return f}findSubstr(f){const y=this.b.reset(f);let w=this.c,r;for(;w;){const g=y.cmp(w.segment);if(g>0)w=w.left;else if(g<0)w=w.right;else if(y.hasNext())y.next(),r=w.value||r,w=w.mid;else break}return w&&w.value||r}findSuperstr(f){return this.g(f,!1)}g(f,y){const w=this.b.reset(f);let r=this.c;for(;r;){const g=w.cmp(r.segment);if(g>0)r=r.left;else if(g<0)r=r.right;else if(w.hasNext())w.next(),r=r.mid;else return r.mid?this.h(r.mid):y?r.value:void 0}}hasElementOrSubtree(f){return this.g(f,!0)!==void 0}forEach(f){for(const[y,w]of this)f(w,y)}*[Symbol.iterator](){yield*this.h(this.c)}h(f){const y=[];return this.j(f,y),y[Symbol.iterator]()}j(f,y){f&&(f.left&&this.j(f.left,y),f.value&&y.push([f.key,f.value]),f.mid&&this.j(f.mid,y),f.right&&this.j(f.right,y))}_isBalanced(){const f=y=>{if(!y)return!0;const w=y.balanceFactor();return w<-1||w>1?!1:f(y.left)&&f(y.right)};return f(this.c)}}e.TernarySearchTree=m}),define(te[8],ie([0,1,9,3]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const s=/^\w[\w\d+.-]*$/,L=/^\//,R=/^\/\//;function k(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!s.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!L.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(R.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(i,n){return!i&&!n?"file":i}function l(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==m&&(n=m+n):n=m;break}return n}const p="",m="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class f{static isUri(n){return n instanceof f?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,u,d,I,A=!1){typeof n=="object"?(this.scheme=n.scheme||p,this.authority=n.authority||p,this.path=n.path||p,this.query=n.query||p,this.fragment=n.fragment||p):(this.scheme=h(n,A),this.authority=o||p,this.path=l(this.scheme,u||p),this.query=d||p,this.fragment=I||p,k(this,A))}get fsPath(){return b(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:u,path:d,query:I,fragment:A}=n;return o===void 0?o=this.scheme:o===null&&(o=p),u===void 0?u=this.authority:u===null&&(u=p),d===void 0?d=this.path:d===null&&(d=p),I===void 0?I=this.query:I===null&&(I=p),A===void 0?A=this.fragment:A===null&&(A=p),o===this.scheme&&u===this.authority&&d===this.path&&I===this.query&&A===this.fragment?this:new w(o,u,d,I,A)}static parse(n,o=!1){const u=v.exec(n);return u?new w(u[2]||p,a(u[4]||p),a(u[5]||p),a(u[7]||p),a(u[9]||p),o):new w(p,p,p,p,p)}static file(n){let o=p;if(M.isWindows&&(n=n.replace(/\\/g,m)),n[0]===m&&n[1]===m){const u=n.indexOf(m,2);u===-1?(o=n.substring(2),n=m):(o=n.substring(2,u),n=n.substring(u)||m)}return new w("file",o,n,p,p)}static from(n){const o=new w(n.scheme,n.authority,n.path,n.query,n.fragment);return k(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return M.isWindows&&n.scheme==="file"?u=f.file(E.win32.join(b(n,!0),...o)).path:u=E.posix.join(n.path,...o),n.with({path:u})}toString(n=!1){return S(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof f)return n;{const o=new w(n);return o._formatted=n.external,o._fsPath=n._sep===y?n.fsPath:null,o}}else return n}}e.URI=f;const y=M.isWindows?1:void 0;class w extends f{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(n=!1){return n?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=y),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const r={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function g(i,n,o){let u,d=-1;for(let I=0;I<i.length;I++){const A=i.charCodeAt(I);if(A>=97&&A<=122||A>=65&&A<=90||A>=48&&A<=57||A===45||A===46||A===95||A===126||n&&A===47||o&&A===91||o&&A===93||o&&A===58)d!==-1&&(u+=encodeURIComponent(i.substring(d,I)),d=-1),u!==void 0&&(u+=i.charAt(I));else{u===void 0&&(u=i.substr(0,I));const C=r[A];C!==void 0?(d!==-1&&(u+=encodeURIComponent(i.substring(d,I)),d=-1),u+=C):d===-1&&(d=I)}}return d!==-1&&(u+=encodeURIComponent(i.substring(d))),u!==void 0?u:i}function c(i){let n;for(let o=0;o<i.length;o++){const u=i.charCodeAt(o);u===35||u===63?(n===void 0&&(n=i.substr(0,o)),n+=r[u]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function b(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,M.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=b;function S(i,n){const o=n?c:g;let u="",{scheme:d,authority:I,path:A,query:C,fragment:T}=i;if(d&&(u+=d,u+=":"),(I||d==="file")&&(u+=m,u+=m),I){let W=I.indexOf("@");if(W!==-1){const $=I.substr(0,W);I=I.substr(W+1),W=$.lastIndexOf(":"),W===-1?u+=o($,!1,!1):(u+=o($.substr(0,W),!1,!1),u+=":",u+=o($.substr(W+1),!1,!0)),u+="@"}I=I.toLowerCase(),W=I.lastIndexOf(":"),W===-1?u+=o(I,!1,!0):(u+=o(I.substr(0,W),!1,!0),u+=I.substr(W))}if(A){if(A.length>=3&&A.charCodeAt(0)===47&&A.charCodeAt(2)===58){const W=A.charCodeAt(1);W>=65&&W<=90&&(A=`/${String.fromCharCode(W+32)}:${A.substr(3)}`)}else if(A.length>=2&&A.charCodeAt(1)===58){const W=A.charCodeAt(0);W>=65&&W<=90&&(A=`${String.fromCharCode(W+32)}:${A.substr(2)}`)}u+=o(A,!0,!1)}return C&&(u+="?",u+=o(C,!1,!1)),T&&(u+="#",u+=n?T:g(T,!1,!1)),u}function D(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+D(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function a(i){return i.match(t)?i.replace(t,n=>D(n)):i}}),define(te[148],ie([0,1,8]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function M(l){const p=l;return p&&typeof p.type=="string"&&typeof p.severity=="string"}e.isRemoteConsoleLog=M;function s(l){const p=[];let m;try{const v=JSON.parse(l.arguments),f=v[v.length-1];f&&f.__$stack&&(v.pop(),m=f.__$stack),p.push(...v)}catch{p.push("Unable to log remote console arguments",l.arguments)}return{args:p,stack:m}}e.parse=s;function L(l){if(typeof l!="string")return L(s(l).stack);const p=l;if(p){const m=R(p),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(m||"");if(v&&v.length===4)return{uri:E.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=L;function R(l){if(!l)return l;const p=l.indexOf(`
`);return p===-1?l:l.substring(0,p)}function k(l,p){const{args:m,stack:v}=s(l),f=typeof m[0]=="string"&&m.length===1;let y=R(v);y&&(y=`(${y.trim()})`);let w=[];if(typeof m[0]=="string"?y&&f?w=[`%c[${p}] %c${m[0]} %c${y}`,h("blue"),h(""),h("grey")]:w=[`%c[${p}] %c${m[0]}`,h("blue"),h(""),...m.slice(1)]:w=[`%c[${p}]%`,h("blue"),...m],y&&!f&&w.push(y),typeof console[l.severity]!="function")throw new Error("Unknown console method");console[l.severity].apply(console,w)}e.log=k;function h(l){return`color: ${l}`}}),define(te[84],ie([0,1,17,27,8]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(l){return JSON.stringify(l,k)}e.stringify=L;function R(l){let p=JSON.parse(l);return p=h(p),p}e.parse=R;function k(l,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,M.regExpFlags)(p)}:p}function h(l,p=0){if(!l||p>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return s.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 16:return new Date(l.source)}if(l instanceof E.VSBuffer||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let m=0;m<l.length;++m)l[m]=h(l[m],p+1);else for(const m in l)Object.hasOwnProperty.call(l,m)&&(l[m]=h(l[m],p+1))}return l}e.revive=h}),define(te[15],ie([0,1,13,3,8]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(l){l.inMemory="inmemory",l.vscode="vscode",l.internal="private",l.walkThrough="walkThrough",l.walkThroughSnippet="walkThroughSnippet",l.http="http",l.https="https",l.file="file",l.mailto="mailto",l.untitled="untitled",l.data="data",l.command="command",l.vscodeRemote="vscode-remote",l.vscodeRemoteResource="vscode-remote-resource",l.vscodeUserData="vscode-userdata",l.vscodeCustomEditor="vscode-custom-editor",l.vscodeNotebookCell="vscode-notebook-cell",l.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",l.vscodeNotebookCellOutput="vscode-notebook-cell-output",l.vscodeInteractive="vscode-interactive",l.vscodeInteractiveInput="vscode-interactive-input",l.vscodeSettings="vscode-settings",l.vscodeWorkspaceTrust="vscode-workspace-trust",l.vscodeTerminal="vscode-terminal",l.vscodeInteractiveSesssion="vscode-chat-editor",l.webviewPanel="webview-panel",l.vscodeWebview="vscode-webview",l.extension="extension",l.vscodeFileResource="vscode-file",l.tmp="tmp",l.vsls="vsls",l.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(p){this.d=p}setDelegate(p){this.e=p}setServerRootPath(p){this.f=`${p}/${L.vscodeRemoteResource}`}set(p,m,v){this.a[p]=m,this.b[p]=v}setConnectionToken(p,m){this.c[p]=m}getPreferredWebSchema(){return this.d}rewrite(p){if(this.e)try{return this.e(p)}catch(r){return E.onUnexpectedError(r),p}const m=p.authority;let v=this.a[m];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const f=this.b[m],y=this.c[m];let w=`path=${encodeURIComponent(p.path)}`;return typeof y=="string"&&(w+=`&${e.connectionTokenQueryName}=${encodeURIComponent(y)}`),s.URI.from({scheme:M.isWeb?this.d:L.vscodeRemoteResource,authority:`${v}:${f}`,path:this.f,query:w})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(p){const m=this.b(p,x);return this.uriToBrowserUri(m)}uriToBrowserUri(p){return p.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(p):p.scheme===L.file&&(M.isNative||M.isWebWorker&&M.globals.origin===`${L.vscodeFileResource}://${k.a}`)?p.with({scheme:L.vscodeFileResource,authority:p.authority||k.a,query:null,fragment:null}):p}asFileUri(p){const m=this.b(p,x);return this.uriToFileUri(m)}uriToFileUri(p){return p.scheme===L.vscodeFileResource?p.with({scheme:L.file,authority:p.authority!==k.a?p.authority:null,query:null,fragment:null}):p}b(p,m){return s.URI.isUri(p)?p:s.URI.parse(m.toUrl(p))}}k.a="vscode-app",e.FileAccess=new k;var h;(function(l){const p=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);l.CoopAndCoep=Object.freeze(p.get("3"));const m="vscode-coi";function v(y){let w;typeof y=="string"?w=new URL(y).searchParams:y instanceof URL?w=y.searchParams:s.URI.isUri(y)&&(w=new URL(y.toString(!0)).searchParams);const r=w?.get(m);if(r)return p.get(r)}l.getHeadersFromQuery=v;function f(y,w,r){if(!globalThis.crossOriginIsolated)return;const g=w&&r?"3":r?"2":"1";y instanceof URLSearchParams?y.set(m,g):y[m]=g}l.addSearchParam=f})(h||(e.COI=h={}))}),define(te[18],ie([0,1,32,15,9,3,27,8]),function(x,e,E,M,s,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function h(f){return(0,k.uriToFsPath)(f,!0)}e.originalFSPath=h;class l{constructor(y){this.a=y}compare(y,w,r=!1){return y===w?0:(0,R.compare)(this.getComparisonKey(y,r),this.getComparisonKey(w,r))}isEqual(y,w,r=!1){return y===w?!0:!y||!w?!1:this.getComparisonKey(y,r)===this.getComparisonKey(w,r)}getComparisonKey(y,w=!1){return y.with({path:this.a(y)?y.path.toLowerCase():void 0,fragment:w?null:void 0}).toString()}ignorePathCasing(y){return this.a(y)}isEqualOrParent(y,w,r=!1){if(y.scheme===w.scheme){if(y.scheme===M.Schemas.file)return E.isEqualOrParent(h(y),h(w),this.a(y))&&y.query===w.query&&(r||y.fragment===w.fragment);if((0,e.isEqualAuthority)(y.authority,w.authority))return E.isEqualOrParent(y.path,w.path,this.a(y),"/")&&y.query===w.query&&(r||y.fragment===w.fragment)}return!1}joinPath(y,...w){return k.URI.joinPath(y,...w)}basenameOrAuthority(y){return(0,e.basename)(y)||y.authority}basename(y){return s.posix.basename(y.path)}extname(y){return s.posix.extname(y.path)}dirname(y){if(y.path.length===0)return y;let w;return y.scheme===M.Schemas.file?w=k.URI.file(s.dirname(h(y))).path:(w=s.posix.dirname(y.path),y.authority&&w.length&&w.charCodeAt(0)!==47&&(console.error(`dirname("${y.toString})) resulted in a relative path`),w="/")),y.with({path:w})}normalizePath(y){if(!y.path.length)return y;let w;return y.scheme===M.Schemas.file?w=k.URI.file(s.normalize(h(y))).path:w=s.posix.normalize(y.path),y.with({path:w})}relativePath(y,w){if(y.scheme!==w.scheme||!(0,e.isEqualAuthority)(y.authority,w.authority))return;if(y.scheme===M.Schemas.file){const c=s.relative(h(y),h(w));return L.isWindows?E.toSlashes(c):c}let r=y.path||"/";const g=w.path||"/";if(this.a(y)){let c=0;for(const b=Math.min(r.length,g.length);c<b&&!(r.charCodeAt(c)!==g.charCodeAt(c)&&r.charAt(c).toLowerCase()!==g.charAt(c).toLowerCase());c++);r=g.substr(0,c)+r.substr(c)}return s.posix.relative(r,g)}resolvePath(y,w){if(y.scheme===M.Schemas.file){const r=k.URI.file(s.resolve(h(y),w));return y.with({authority:r.authority,path:r.path})}return w=E.toPosixPath(w),y.with({path:s.posix.resolve(y.path,w)})}isAbsolutePath(y){return!!y.path&&y.path[0]==="/"}isEqualAuthority(y,w){return y===w||y!==void 0&&w!==void 0&&(0,R.equalsIgnoreCase)(y,w)}hasTrailingPathSeparator(y,w=s.sep){if(y.scheme===M.Schemas.file){const r=h(y);return r.length>E.getRoot(r).length&&r[r.length-1]===w}else{const r=y.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(y.fsPath)}}removeTrailingPathSeparator(y,w=s.sep){return(0,e.hasTrailingPathSeparator)(y,w)?y.with({path:y.path.substr(0,y.path.length-1)}):y}addTrailingPathSeparator(y,w=s.sep){let r=!1;if(y.scheme===M.Schemas.file){const g=h(y);r=g!==void 0&&g.length===E.getRoot(g).length&&g[g.length-1]===w}else{w="/";const g=y.path;r=g.length===1&&g.charCodeAt(g.length-1)===47}return!r&&!(0,e.hasTrailingPathSeparator)(y,w)?y.with({path:y.path+"/"}):y}}e.ExtUri=l,e.extUri=new l(()=>!1),e.extUriBiasedIgnorePathCase=new l(f=>f.scheme===M.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new l(f=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function p(f,y){const w=[];for(let r=0;r<f.length;r++){const g=y(f[r]);f.some((c,b)=>b===r?!1:(0,e.isEqualOrParent)(g,y(c)))||w.push(f[r])}return w}e.distinctParents=p;var m;(function(f){f.META_DATA_LABEL="label",f.META_DATA_DESCRIPTION="description",f.META_DATA_SIZE="size",f.META_DATA_MIME="mime";function y(w){const r=new Map;w.path.substring(w.path.indexOf(";")+1,w.path.lastIndexOf(";")).split(";").forEach(b=>{const[S,D]=b.split(":");S&&D&&r.set(S,D)});const c=w.path.substring(0,w.path.indexOf(";"));return c&&r.set(f.META_DATA_MIME,c),r}f.parseMetaData=y})(m||(e.DataUri=m={}));function v(f,y,w){if(y){let r=f.path;return r&&r[0]!==s.posix.sep&&(r=s.posix.sep+r),f.with({scheme:w,authority:y,path:r})}return f.with({scheme:w})}e.toLocalResource=v}),define(te[7],ie([0,1,22,13,4,2,18,3,133]),function(x,e,E,M,s,L,R,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function l(Y){return!!Y&&typeof Y.then=="function"}e.isThenable=l;function p(Y){const O=new E.CancellationTokenSource,P=Y(O.token),F=new Promise((N,j)=>{const U=O.token.onCancellationRequested(()=>{U.dispose(),O.dispose(),j(new M.CancellationError)});Promise.resolve(P).then(V=>{U.dispose(),O.dispose(),N(V)},V=>{U.dispose(),O.dispose(),j(V)})});return new class{cancel(){O.cancel()}then(N,j){return F.then(N,j)}catch(N){return this.then(void 0,N)}finally(N){return F.finally(N)}}}e.createCancelablePromise=p;function m(Y,O,P){return new Promise((F,N)=>{const j=O.onCancellationRequested(()=>{j.dispose(),F(P)});Y.then(F,N).finally(()=>j.dispose())})}e.raceCancellation=m;function v(Y,O){return new Promise((P,F)=>{const N=O.onCancellationRequested(()=>{N.dispose(),F(new M.CancellationError)});Y.then(P,F).finally(()=>N.dispose())})}e.raceCancellationError=v;async function f(Y){let O=-1;const P=Y.map((F,N)=>F.then(j=>(O=N,j)));try{return await Promise.race(P)}finally{Y.forEach((F,N)=>{N!==O&&F.cancel()})}}e.raceCancellablePromises=f;function y(Y,O,P){let F;const N=setTimeout(()=>{F?.(void 0),P?.()},O);return Promise.race([Y.finally(()=>clearTimeout(N)),new Promise(j=>F=j)])}e.raceTimeout=y;function w(Y){return new Promise((O,P)=>{const F=Y();l(F)?F.then(O,P):O(F)})}e.asPromise=w;class r{constructor(){this.a=null,this.b=null,this.d=null}queue(O){if(this.a){if(this.d=O,!this.b){const P=()=>{this.b=null;const F=this.queue(this.d);return this.d=null,F};this.b=new Promise(F=>{this.a.then(P,P).then(F)})}return new Promise((P,F)=>{this.b.then(P,F)})}return this.a=O(),new Promise((P,F)=>{this.a.then(N=>{this.a=null,P(N)},N=>{this.a=null,F(N)})})}}e.Throttler=r;class g{constructor(){this.a=Promise.resolve(null)}queue(O){return this.a=this.a.then(()=>O(),()=>O())}}e.Sequencer=g;class c{constructor(){this.a=new Map}queue(O,P){const N=(this.a.get(O)??Promise.resolve()).catch(()=>{}).then(P).finally(()=>{this.a.get(O)===N&&this.a.delete(O)});return this.a.set(O,N),N}}e.SequencerByKey=c;const b=(Y,O)=>{let P=!0;const F=setTimeout(()=>{P=!1,O()},Y);return{isTriggered:()=>P,dispose:()=>{clearTimeout(F),P=!1}}},S=Y=>{let O=!0;return queueMicrotask(()=>{O&&(O=!1,Y())}),{isTriggered:()=>O,dispose:()=>{O=!1}}};class D{constructor(O){this.defaultDelay=O,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(O,P=this.defaultDelay){this.g=O,this.h(),this.b||(this.b=new Promise((N,j)=>{this.d=N,this.f=j}).then(()=>{if(this.b=null,this.d=null,this.g){const N=this.g;return this.g=null,N()}}));const F=()=>{this.a=null,this.d?.(null)};return this.a=P===h.MicrotaskDelay?S(F):b(P,F),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=D;class t{constructor(O){this.a=new D(O),this.b=new r}trigger(O,P){return this.a.trigger(()=>this.b.queue(O),P)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class a{constructor(){this.a=!1,this.b=new Promise((O,P)=>{this.d=O})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=a;class i extends a{constructor(O){super(),this.f=setTimeout(()=>this.open(),O)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function n(Y,O){return O?new Promise((P,F)=>{const N=setTimeout(()=>{j.dispose(),P()},Y),j=O.onCancellationRequested(()=>{clearTimeout(N),j.dispose(),F(new M.CancellationError)})}):p(P=>n(Y,P))}e.timeout=n;function o(Y,O=0){const P=setTimeout(Y,O);return(0,L.toDisposable)(()=>clearTimeout(P))}e.disposableTimeout=o;function u(Y){const O=[];let P=0;const F=Y.length;function N(){return P<F?Y[P++]():null}function j(U){U!=null&&O.push(U);const V=N();return V?V.then(j):Promise.resolve(O)}return Promise.resolve(null).then(j)}e.sequence=u;function d(Y,O=F=>!!F,P=null){let F=0;const N=Y.length,j=()=>{if(F>=N)return Promise.resolve(P);const U=Y[F++];return Promise.resolve(U()).then(G=>O(G)?Promise.resolve(G):j())};return j()}e.first=d;function I(Y,O=F=>!!F,P=null){if(Y.length===0)return Promise.resolve(P);let F=Y.length;const N=()=>{F=-1;for(const j of Y)j.cancel?.()};return new Promise((j,U)=>{for(const V of Y)V.then(G=>{--F>=0&&O(G)?(N(),j(G)):F===0&&j(P)}).catch(G=>{--F>=0&&(N(),U(G))})})}e.firstParallel=I;class A{constructor(O){this.a=0,this.d=O,this.f=[],this.b=0,this.g=new s.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(O){return this.a++,new Promise((P,F)=>{this.f.push({factory:O,c:P,e:F}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const O=this.f.shift();this.b++;const P=O.factory();P.then(O.c,O.e),P.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=A;class C extends A{constructor(){super(1)}}e.Queue=C;class T{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const O=new B;return this.b.add(O),O.p}d(){for(const[,O]of this.a)if(O.size>0)return!1;return!0}queueFor(O,P=R.extUri){const F=P.getComparisonKey(O);let N=this.a.get(F);return N||(N=new C,s.Event.once(N.onDrained)(()=>{N?.dispose(),this.a.delete(F),this.f()}),this.a.set(F,N)),N}f(){this.d()&&this.g()}g(){for(const O of this.b)O.complete();this.b.clear()}dispose(){for(const[,O]of this.a)O.dispose();this.a.clear(),this.g()}}e.ResourceQueue=T;class W{constructor(O,P){this.a=-1,typeof O=="function"&&typeof P=="number"&&this.setIfNotSet(O,P)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(O,P){this.cancel(),this.a=setTimeout(()=>{this.a=-1,O()},P)}setIfNotSet(O,P){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,O()},P))}}e.TimeoutTimer=W;class ${constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(O,P){this.cancel(),this.a=setInterval(()=>{O()},P)}}e.IntervalTimer=$;class H{constructor(O,P){this.b=-1,this.a=O,this.d=P,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(O=this.d){this.cancel(),this.b=setTimeout(this.f,O)}get delay(){return this.d}set delay(O){this.d=O}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=H;class Z{constructor(O,P){P%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${P}ms is not a multiple of 1000ms.`),this.a=O,this.b=P,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(O=this.b){O%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${O}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(O/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=Z;class ne extends H{constructor(O,P){super(O,P),this.j=[]}work(O){this.j.push(O),this.isScheduled()||this.schedule()}h(){const O=this.j;this.j=[],this.a?.(O)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=ne;class se extends L.Disposable{constructor(O,P){super(),this.g=O,this.h=P,this.a=[],this.b=this.B(new L.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(O){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+O.length>this.g.maxBufferedWork)return!1}else if(this.pending+O.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const P of O)this.a.push(P);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new H(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=se,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=Y=>{(0,k.setTimeout0)(()=>{if(O)return;const P=Date.now()+15;Y(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,P-Date.now())}}))});let O=!1;return{dispose(){O||(O=!0)}}}:e.runWhenIdle=(Y,O)=>{const P=requestIdleCallback(Y,typeof O=="number"?{timeout:O}:void 0);let F=!1;return{dispose(){F||(F=!0,cancelIdleCallback(P))}}}}();class ue{constructor(O){this.d=!1,this.a=()=>{try{this.f=O()}catch(P){this.g=P}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ue;async function ce(Y,O,P){let F;for(let N=0;N<P;N++)try{return await Y()}catch(j){F=j,await n(O)}throw F}e.retry=ce;class X{hasPending(O){return this.a?typeof O=="number"?this.a.taskId===O:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(O,P,F){return this.a={taskId:O,cancel:()=>F?.(),promise:P},P.then(()=>this.d(O),()=>this.d(O)),P}d(O){this.a&&O===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const O=this.b;this.b=void 0,O.run().then(O.promiseResolve,O.promiseReject)}}setNext(O){if(this.b)this.b.run=O;else{let P,F;const N=new Promise((j,U)=>{P=j,F=U});this.b={run:O,promise:N,promiseResolve:P,promiseReject:F}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=X;class q{constructor(O,P=()=>Date.now()){this.d=O,this.f=P,this.a=0,this.b=0}increment(){const O=this.f();return O-this.a>this.d&&(this.a=O,this.b=0),this.b++,this.b}}e.IntervalCounter=q;class B{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((O,P)=>{this.a=O,this.b=P})}complete(O){return new Promise(P=>{this.a(O),this.f=!0,P()})}error(O){return new Promise(P=>{this.b(O),this.d=!0,P()})}cancel(){new Promise(O=>{this.b(new M.CancellationError),this.d=!0,O()})}}e.DeferredPromise=B;var z;(function(Y){async function O(F){let N;const j=await Promise.all(F.map(U=>U.then(V=>V,V=>{N||(N=V)})));if(typeof N<"u")throw N;return j}Y.settled=O;function P(F){return new Promise(async(N,j)=>{try{await F(N,j)}catch(U){j(U)}})}Y.withAsyncBody=P})(z||(e.Promises=z={}));var K;(function(Y){Y[Y.Initial=0]="Initial",Y[Y.DoneOK=1]="DoneOK",Y[Y.DoneError=2]="DoneError"})(K||(K={}));class ee{static fromArray(O){return new ee(P=>{P.emitMany(O)})}static fromPromise(O){return new ee(async P=>{P.emitMany(await O)})}static fromPromises(O){return new ee(async P=>{await Promise.all(O.map(async F=>P.emitOne(await F)))})}static merge(O){return new ee(async P=>{await Promise.all(O.map(async F=>{for await(const N of F)P.emitOne(N)}))})}constructor(O){this.a=0,this.b=[],this.d=null,this.f=new s.Emitter,queueMicrotask(async()=>{const P={emitOne:F=>this.g(F),emitMany:F=>this.h(F),reject:F=>this.k(F)};try{await Promise.resolve(O(P)),this.j()}catch(F){this.k(F)}finally{P.emitOne=void 0,P.emitMany=void 0,P.reject=void 0}})}[Symbol.asyncIterator](){let O=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(O<this.b.length)return{done:!1,value:this.b[O++]};if(this.a===1)return{done:!0,value:void 0};await s.Event.toPromise(this.f.event)}while(!0)}}}static map(O,P){return new ee(async F=>{for await(const N of O)F.emitOne(P(N))})}map(O){return ee.map(this,O)}static filter(O,P){return new ee(async F=>{for await(const N of O)P(N)&&F.emitOne(N)})}filter(O){return ee.filter(this,O)}static coalesce(O){return ee.filter(O,P=>!!P)}coalesce(){return ee.coalesce(this)}static async toPromise(O){const P=[];for await(const F of O)P.push(F);return P}toPromise(){return ee.toPromise(this)}g(O){this.a===0&&(this.b.push(O),this.f.fire())}h(O){this.a===0&&(this.b=this.b.concat(O),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(O){this.a===0&&(this.a=2,this.d=O,this.f.fire())}}e.AsyncIterableObject=ee,ee.EMPTY=ee.fromArray([]);class oe extends ee{constructor(O,P){super(P),this.l=O}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=oe;function le(Y){const O=new E.CancellationTokenSource,P=Y(O.token);return new oe(O,async F=>{const N=O.token.onCancellationRequested(()=>{N.dispose(),O.dispose(),F.reject(new M.CancellationError)});try{for await(const j of P){if(O.token.isCancellationRequested)return;F.emitOne(j)}N.dispose(),O.dispose()}catch(j){N.dispose(),O.dispose(),F.reject(j)}})}e.createCancelableAsyncIterable=le}),define(te[102],ie([0,1,23,7,32,35,9,3,27]),function(x,e,E,M,s,L,R,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function l(){return Object.create(null)}e.getEmptyExpression=l,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const p="[/\\\\]",m="[^/\\\\]",v=/\//g;function f(q,B){switch(q){case 0:return"";case 1:return`${m}*?`;default:return`(?:${p}|${m}+${p}${B?`|${p}${m}+`:""})*?`}}function y(q,B){if(!q)return[];const z=[];let K=!1,ee=!1,oe="";for(const le of q){switch(le){case B:if(!K&&!ee){z.push(oe),oe="";continue}break;case"{":K=!0;break;case"}":K=!1;break;case"[":ee=!0;break;case"]":ee=!1;break}oe+=le}return oe&&z.push(oe),z}e.splitGlobAware=y;function w(q){if(!q)return"";let B="";const z=y(q,e.GLOB_SPLIT);if(z.every(K=>K===e.GLOBSTAR))B=".*";else{let K=!1;z.forEach((ee,oe)=>{if(ee===e.GLOBSTAR){if(K)return;B+=f(2,oe===z.length-1)}else{let le=!1,Y="",O=!1,P="";for(const F of ee){if(F!=="}"&&le){Y+=F;continue}if(O&&(F!=="]"||!P)){let N;F==="-"?N=F:(F==="^"||F==="!")&&!P?N="^":F===e.GLOB_SPLIT?N="":N=(0,h.escapeRegExpCharacters)(F),P+=N;continue}switch(F){case"{":le=!0;continue;case"[":O=!0;continue;case"}":{const j=`(?:${y(Y,",").map(U=>w(U)).join("|")})`;B+=j,le=!1,Y="";break}case"]":{B+="["+P+"]",O=!1,P="";break}case"?":B+=m;continue;case"*":B+=f(1);continue;default:B+=(0,h.escapeRegExpCharacters)(F)}}oe<z.length-1&&(z[oe+1]!==e.GLOBSTAR||oe+2<z.length)&&(B+=p)}K=ee===e.GLOBSTAR})}return B}const r=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,c=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,D=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.LRUCache(1e4),a=function(){return!1},i=function(){return null};function n(q,B){if(!q)return i;let z;typeof q!="string"?z=q.pattern:z=q,z=z.trim();const K=`${z}_${!!B.trimForExclusions}`;let ee=t.get(K);if(ee)return o(ee,q);let oe;return r.test(z)?ee=d(z.substr(4),z):(oe=g.exec(u(z,B)))?ee=I(oe[1],z):(B.trimForExclusions?b:c).test(z)?ee=A(z,B):(oe=S.exec(u(z,B)))?ee=C(oe[1].substr(1),z,!0):(oe=D.exec(u(z,B)))?ee=C(oe[1],z,!1):ee=T(z),t.set(K,ee),o(ee,q)}function o(q,B){if(typeof B=="string")return q;const z=function(K,ee){return(0,s.isEqualOrParent)(K,B.base,!k.isLinux)?q((0,h.ltrim)(K.substr(B.base.length),R.sep),ee):null};return z.allBasenames=q.allBasenames,z.allPaths=q.allPaths,z.basenames=q.basenames,z.patterns=q.patterns,z}function u(q,B){return B.trimForExclusions&&q.endsWith("/**")?q.substr(0,q.length-2):q}function d(q,B){return function(z,K){return typeof z=="string"&&z.endsWith(q)?B:null}}function I(q,B){const z=`/${q}`,K=`\\${q}`,ee=function(le,Y){return typeof le!="string"?null:Y?Y===q?B:null:le===q||le.endsWith(z)||le.endsWith(K)?B:null},oe=[q];return ee.basenames=oe,ee.patterns=[B],ee.allBasenames=oe,ee}function A(q,B){const z=ce(q.slice(1,-1).split(",").map(Y=>n(Y,B)).filter(Y=>Y!==i),q),K=z.length;if(!K)return i;if(K===1)return z[0];const ee=function(Y,O){for(let P=0,F=z.length;P<F;P++)if(z[P](Y,O))return q;return null},oe=z.find(Y=>!!Y.allBasenames);oe&&(ee.allBasenames=oe.allBasenames);const le=z.reduce((Y,O)=>O.allPaths?Y.concat(O.allPaths):Y,[]);return le.length&&(ee.allPaths=le),ee}function C(q,B,z){const K=R.sep===R.posix.sep,ee=K?q:q.replace(v,R.sep),oe=R.sep+ee,le=R.posix.sep+q;let Y;return z?Y=function(O,P){return typeof O=="string"&&(O===ee||O.endsWith(oe)||!K&&(O===q||O.endsWith(le)))?B:null}:Y=function(O,P){return typeof O=="string"&&(O===ee||!K&&O===q)?B:null},Y.allPaths=[(z?"*/":"./")+q],Y}function T(q){try{const B=new RegExp(`^${w(q)}$`);return function(z){return B.lastIndex=0,typeof z=="string"&&B.test(z)?q:null}}catch{return i}}function W(q,B,z){return!q||typeof B!="string"?!1:$(q)(B,void 0,z)}e.match=W;function $(q,B={}){if(!q)return a;if(typeof q=="string"||H(q)){const z=n(q,B);if(z===i)return a;const K=function(ee,oe){return!!z(ee,oe)};return z.allBasenames&&(K.allBasenames=z.allBasenames),z.allPaths&&(K.allPaths=z.allPaths),K}return se(q,B)}e.parse=$;function H(q){const B=q;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=H;function Z(q){return q.allBasenames||[]}e.getBasenameTerms=Z;function ne(q){return q.allPaths||[]}e.getPathTerms=ne;function se(q,B){const z=ce(Object.getOwnPropertyNames(q).map(Y=>ue(Y,q[Y],B)).filter(Y=>Y!==i)),K=z.length;if(!K)return i;if(!z.some(Y=>!!Y.requiresSiblings)){if(K===1)return z[0];const Y=function(F,N){let j;for(let U=0,V=z.length;U<V;U++){const G=z[U](F,N);if(typeof G=="string")return G;(0,M.isThenable)(G)&&(j||(j=[]),j.push(G))}return j?(async()=>{for(const U of j){const V=await U;if(typeof V=="string")return V}return null})():null},O=z.find(F=>!!F.allBasenames);O&&(Y.allBasenames=O.allBasenames);const P=z.reduce((F,N)=>N.allPaths?F.concat(N.allPaths):F,[]);return P.length&&(Y.allPaths=P),Y}const ee=function(Y,O,P){let F,N;for(let j=0,U=z.length;j<U;j++){const V=z[j];V.requiresSiblings&&P&&(O||(O=(0,R.basename)(Y)),F||(F=O.substr(0,O.length-(0,R.extname)(Y).length)));const G=V(Y,O,F,P);if(typeof G=="string")return G;(0,M.isThenable)(G)&&(N||(N=[]),N.push(G))}return N?(async()=>{for(const j of N){const U=await j;if(typeof U=="string")return U}return null})():null},oe=z.find(Y=>!!Y.allBasenames);oe&&(ee.allBasenames=oe.allBasenames);const le=z.reduce((Y,O)=>O.allPaths?Y.concat(O.allPaths):Y,[]);return le.length&&(ee.allPaths=le),ee}function ue(q,B,z){if(B===!1)return i;const K=n(q,z);if(K===i)return i;if(typeof B=="boolean")return K;if(B){const ee=B.when;if(typeof ee=="string"){const oe=(le,Y,O,P)=>{if(!P||!K(le,Y))return null;const F=ee.replace("$(basename)",()=>O),N=P(F);return(0,M.isThenable)(N)?N.then(j=>j?q:null):N?q:null};return oe.requiresSiblings=!0,oe}}return K}function ce(q,B){const z=q.filter(Y=>!!Y.basenames);if(z.length<2)return q;const K=z.reduce((Y,O)=>{const P=O.basenames;return P?Y.concat(P):Y},[]);let ee;if(B){ee=[];for(let Y=0,O=K.length;Y<O;Y++)ee.push(B)}else ee=z.reduce((Y,O)=>{const P=O.patterns;return P?Y.concat(P):Y},[]);const oe=function(Y,O){if(typeof Y!="string")return null;if(!O){let F;for(F=Y.length;F>0;F--){const N=Y.charCodeAt(F-1);if(N===47||N===92)break}O=Y.substr(F)}const P=K.indexOf(O);return P!==-1?ee[P]:null};oe.basenames=K,oe.patterns=ee,oe.allBasenames=K;const le=q.filter(Y=>!Y.basenames);return le.push(oe),le}function X(q,B){return(0,E.equals)(q,B,(z,K)=>typeof z=="string"&&typeof K=="string"?z===K:typeof z!="string"&&typeof K!="string"?z.base===K.base&&z.pattern===K.pattern:!1)}e.patternsEquals=X}),define(te[44],ie([0,1,23,32,9,3,18,27]),function(x,e,E,M,s,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function h(i,n){const{os:o,tildify:u,relative:d}=n;if(d){const C=l(i,d,o);if(typeof C=="string")return C}let I=i.fsPath;if(o===1&&!L.isWindows?I=I.replace(/\//g,"\\"):o!==1&&L.isWindows&&(I=I.replace(/\\/g,"/")),o!==1&&u?.userHome){const C=u.userHome.fsPath;let T;i.scheme!==u.userHome.scheme&&i.path.startsWith(s.posix.sep)?T=u.userHome.with({path:i.path}).fsPath:T=i.fsPath,I=v(T,C,o)}return(o===1?s.win32:s.posix).normalize(p(I,o===1))}e.getPathLabel=h;function l(i,n,o){const u=o===1?s.win32:s.posix,d=o===3?R.extUri:R.extUriIgnorePathCase,I=n.getWorkspace(),A=(0,E.firstOrDefault)(I.folders);if(!A)return;i.scheme!==A.uri.scheme&&i.path.startsWith(s.posix.sep)&&(i=A.uri.with({path:i.path}));const C=n.getWorkspaceFolder(i);if(!C)return;let T;if(d.isEqual(C.uri,i)?T="":T=d.relativePath(C.uri,i)??"",T&&(T=u.normalize(T)),I.folders.length>1&&!n.noPrefix){const W=C.name?C.name:d.basenameOrAuthority(C.uri);T=T?`${W} \u2022 ${T}`:W}return T}function p(i,n=L.isWindows){return(0,M.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=p;let m=Object.create(null);function v(i,n,o=L.OS){if(o===1||!i||!n)return i;let u=m.original===n?m.normalized:void 0;u||(u=n,L.isWindows&&(u=(0,M.toSlashes)(u)),u=`${(0,k.rtrim)(u,s.posix.sep)}${s.posix.sep}`,m={original:n,normalized:u});let d=i;return L.isWindows&&(d=(0,M.toSlashes)(d)),(o===3?d.startsWith(u):(0,k.startsWithIgnoreCase)(d,u))?`~/${d.substr(u.length)}`:i}e.tildify=v;function f(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=f;const y="\u2026",w="\\\\",r="~";function g(i,n=s.sep){const o=new Array(i.length);let u=!1;for(let d=0;d<i.length;d++){const I=i[d];if(I===""){o[d]=`.${n}`;continue}if(!I){o[d]=I;continue}u=!0;let A="",C=I;C.indexOf(w)===0?(A=C.substr(0,C.indexOf(w)+w.length),C=C.substr(C.indexOf(w)+w.length)):C.indexOf(n)===0?(A=C.substr(0,C.indexOf(n)+n.length),C=C.substr(C.indexOf(n)+n.length)):C.indexOf(r)===0&&(A=C.substr(0,C.indexOf(r)+r.length),C=C.substr(C.indexOf(r)+r.length));const T=C.split(n);for(let W=1;u&&W<=T.length;W++)for(let $=T.length-W;u&&$>=0;$--){u=!1;let H=T.slice($,$+W).join(n);for(let Z=0;!u&&Z<i.length;Z++)if(Z!==d&&i[Z]&&i[Z].indexOf(H)>-1){const ne=$+W===T.length,se=$>0&&i[Z].indexOf(n)>-1?n+H:H,ue=i[Z].endsWith(se);u=!ne||ue}if(!u){let Z="";(T[0].endsWith(":")||A!=="")&&($===1&&($=0,W++,H=T[0]+n+H),$>0&&(Z=T[0]+n),Z=A+Z),$>0&&(Z=Z+y+n),Z=Z+H,$+W<T.length&&(Z=Z+n+y),o[d]=Z}}u&&(o[d]=I)}return o}e.shorten=g;var c;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function b(i,n=Object.create(null)){const o=[];let u=!1,d="";for(const I of i)if(I==="$"||u&&I==="{")d&&o.push({value:d,type:c.TEXT}),d="",u=!0;else if(I==="}"&&u){const A=n[d];if(typeof A=="string")A.length&&o.push({value:A,type:c.VARIABLE});else if(A){const C=o[o.length-1];(!C||C.type!==c.SEPARATOR)&&o.push({value:A.label,type:c.SEPARATOR})}d="",u=!1}else d+=I;return d&&!u&&o.push({value:d,type:c.TEXT}),o.filter((I,A)=>{if(I.type===c.SEPARATOR){const C=o[A-1],T=o[A+1];return[C,T].every(W=>W&&(W.type===c.VARIABLE||W.type===c.TEXT)&&W.value.length>0)}return!0}).map(I=>I.value).join("")}e.template=b;function S(i,n){return L.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function D(i,n){return L.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):L.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=D;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function a(i){const n=i.indexOf("/")!==-1?s.posix:s.win32,o=n.basename(i),u=n.dirname(i);return o.length?{name:o,parentPath:u}:{name:u,parentPath:""}}e.splitName=a}),define(te[149],ie([0,1,17,8]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function s(m){return m.toJSON()}class L{constructor(v){this.a=v}transformIncoming(v){const f=this.a.transformIncoming(v);return f===v?v:s(M.URI.from(f))}transformOutgoing(v){const f=this.a.transformOutgoing(v);return f===v?v:s(M.URI.from(f))}transformOutgoingURI(v){const f=this.a.transformOutgoing(v);return f===v?v:M.URI.from(f)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(m){return m}transformOutgoing(m){return m}transformOutgoingURI(m){return m}transformOutgoingScheme(m){return m}};function R(m,v,f){if(!m||f>200)return null;if(typeof m=="object"){if(m instanceof M.URI)return v.transformOutgoing(m);for(const y in m)if(Object.hasOwnProperty.call(m,y)){const w=R(m[y],v,f+1);w!==null&&(m[y]=w)}}return null}function k(m,v){const f=R(m,v,0);return f===null?m:f}e.transformOutgoingURIs=k;function h(m,v,f,y){if(!m||y>200)return null;if(typeof m=="object"){if(m.$mid===1)return f?M.URI.revive(v.transformIncoming(m)):v.transformIncoming(m);if(m instanceof E.VSBuffer)return null;for(const w in m)if(Object.hasOwnProperty.call(m,w)){const r=h(m[w],v,f,y+1);r!==null&&(m[w]=r)}}return null}function l(m,v){const f=h(m,v,!1,0);return f===null?m:f}e.transformIncomingURIs=l;function p(m,v){const f=h(m,v,!0,0);return f===null?m:f}e.transformAndReviveIncomingURIs=p}),define(te[85],ie([0,1,26,61,31,137]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(l){return this.a||(this.a=M.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(l)}value(){if(this.b===void 0){let l=0,p=0;const m=(0,E.networkInterfaces)();for(const v in m){const f=m[v];if(f)for(const{mac:y,internal:w}of f)w||(p+=1,this.c(y.toUpperCase())&&(l+=1))}this.b=p>0?l/p:0}return this.b}};let R;async function k(l){return R||(R=(async()=>await h(l)||s.generateUuid())()),R}e.getMachineId=k;async function h(l){try{const p=await new Promise((v,f)=>{x(["crypto"],v,f)}),m=(0,L.getMac)();return p.createHash("sha256").update(m,"utf8").digest("hex")}catch(p){l(p);return}}}),define(te[24],ie([0,1,41,26,150,7,32,82,9,3,18,8]),function(x,e,E,M,s,L,R,k,h,l,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(se){se[se.UNLINK=0]="UNLINK",se[se.MOVE=1]="MOVE"})(v||(e.RimRafMode=v={}));async function f(se,ue=v.UNLINK){if((0,R.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");return ue===v.UNLINK?w(se):y(se)}async function y(se){try{const ue=(0,R.randomPath)((0,M.tmpdir)());try{await E.promises.rename(se,ue)}catch(ce){return ce.code==="ENOENT"?void 0:w(se)}w(ue).catch(ce=>{})}catch(ue){if(ue.code!=="ENOENT")throw ue}}async function w(se){return(0,s.promisify)(E.rm)(se,{recursive:!0,force:!0,maxRetries:3})}function r(se){if((0,R.isRootOrDriveLetter)(se))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(se,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=r;async function g(se,ue){return S(await(ue?c(se):(0,s.promisify)(E.readdir)(se)))}async function c(se){try{return await(0,s.promisify)(E.readdir)(se,{withFileTypes:!0})}catch(X){console.warn("[node.js fs] readdir with filetypes failed with error: ",X)}const ue=[],ce=await g(se);for(const X of ce){let q=!1,B=!1,z=!1;try{const K=await e.Promises.lstat((0,h.join)(se,X));q=K.isFile(),B=K.isDirectory(),z=K.isSymbolicLink()}catch(K){console.warn("[node.js fs] unexpected error from lstat after readdir: ",K)}ue.push({name:X,isFile:()=>q,isDirectory:()=>B,isSymbolicLink:()=>z})}return ue}function b(se){return S(E.readdirSync(se))}e.readdirSync=b;function S(se){return se.map(ue=>typeof ue=="string"?l.isMacintosh?(0,k.normalizeNFC)(ue):ue:(ue.name=l.isMacintosh?(0,k.normalizeNFC)(ue.name):ue.name,ue))}async function D(se){const ue=await g(se),ce=[];for(const X of ue)await a.existsDirectory((0,h.join)(se,X))&&ce.push(X);return ce}function t(se,ue=1e3){return new Promise(ce=>{let X=!1;const q=setInterval(()=>{X||(X=!0,E.access(se,B=>{X=!1,B&&(clearInterval(q),ce(void 0))}))},ue)})}e.whenDeleted=t;var a;(function(se){async function ue(q){let B;try{if(B=await e.Promises.lstat(q),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(q),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(z){if(z.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(l.isWindows&&z.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(q)),symbolicLink:{dangling:!1}}}catch(K){if(K.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw K}throw z}}se.stat=ue;async function ce(q){try{const{stat:B,symbolicLink:z}=await se.stat(q);return B.isFile()&&z?.dangling!==!0}catch{}return!1}se.existsFile=ce;async function X(q){try{const{stat:B,symbolicLink:z}=await se.stat(q);return B.isDirectory()&&z?.dangling!==!0}catch{}return!1}se.existsDirectory=X})(a||(e.SymlinkSupport=a={}));const i=new L.ResourceQueue;function n(se,ue,ce){return i.queueFor(m.URI.file(se),p.extUriBiasedIgnorePathCase).queue(()=>{const X=A(ce);return new Promise((q,B)=>d(se,ue,X,z=>z?B(z):q()))})}let o=!0;function u(se){o=se}e.configureFlushOnWrite=u;function d(se,ue,ce,X){if(!o)return E.writeFile(se,ue,{mode:ce.mode,flag:ce.flag},X);E.open(se,ce.flag,ce.mode,(q,B)=>{if(q)return X(q);E.writeFile(B,ue,z=>{if(z)return E.close(B,()=>X(z));E.fdatasync(B,K=>(K&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",K),u(!1)),E.close(B,ee=>X(ee))))})})}function I(se,ue,ce){const X=A(ce);if(!o)return E.writeFileSync(se,ue,{mode:X.mode,flag:X.flag});const q=E.openSync(se,X.flag,X.mode);try{E.writeFileSync(q,ue);try{E.fdatasyncSync(q)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),u(!1)}}finally{E.closeSync(q)}}e.writeFileSync=I;function A(se){return se?{mode:typeof se.mode=="number"?se.mode:438,flag:typeof se.flag=="string"?se.flag:"w"}:{mode:438,flag:"w"}}async function C(se,ue){if(se!==ue)try{await e.Promises.rename(se,ue)}catch(ce){if(se.toLowerCase()!==ue.toLowerCase()&&ce.code==="EXDEV"||se.endsWith("."))await T(se,ue,{preserveSymlinks:!1}),await f(se,v.MOVE);else throw ce}}async function T(se,ue,ce){return $(se,ue,{root:{source:se,target:ue},options:ce,handledSourcePaths:new Set})}const W=511;async function $(se,ue,ce){if(ce.handledSourcePaths.has(se))return;ce.handledSourcePaths.add(se);const{stat:X,symbolicLink:q}=await a.stat(se);if(q){if(ce.options.preserveSymlinks)try{return await ne(se,ue,ce)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(q.dangling)return}return X.isDirectory()?H(se,ue,X.mode&W,ce):Z(se,ue,X.mode&W)}async function H(se,ue,ce,X){await e.Promises.mkdir(ue,{recursive:!0,mode:ce});const q=await g(se);for(const B of q)await $((0,h.join)(se,B),(0,h.join)(ue,B),X)}async function Z(se,ue,ce){await e.Promises.copyFile(se,ue),await e.Promises.chmod(ue,ce)}async function ne(se,ue,ce){let X=await e.Promises.readlink(se);(0,R.isEqualOrParent)(X,ce.root.source,!l.isLinux)&&(X=(0,h.join)(ce.root.target,X.substr(ce.root.source.length+1))),await e.Promises.symlink(X,ue)}e.Promises=new class{get access(){return(0,s.promisify)(E.access)}get stat(){return(0,s.promisify)(E.stat)}get lstat(){return(0,s.promisify)(E.lstat)}get utimes(){return(0,s.promisify)(E.utimes)}get read(){return(se,ue,ce,X,q)=>new Promise((B,z)=>{E.read(se,ue,ce,X,q,(K,ee,oe)=>K?z(K):B({bytesRead:ee,buffer:oe}))})}get readFile(){return(0,s.promisify)(E.readFile)}get write(){return(se,ue,ce,X,q)=>new Promise((B,z)=>{E.write(se,ue,ce,X,q,(K,ee,oe)=>K?z(K):B({bytesWritten:ee,buffer:oe}))})}get appendFile(){return(0,s.promisify)(E.appendFile)}get fdatasync(){return(0,s.promisify)(E.fdatasync)}get truncate(){return(0,s.promisify)(E.truncate)}get rename(){return(0,s.promisify)(E.rename)}get copyFile(){return(0,s.promisify)(E.copyFile)}get open(){return(0,s.promisify)(E.open)}get close(){return(0,s.promisify)(E.close)}get symlink(){return(0,s.promisify)(E.symlink)}get readlink(){return(0,s.promisify)(E.readlink)}get chmod(){return(0,s.promisify)(E.chmod)}get mkdir(){return(0,s.promisify)(E.mkdir)}get unlink(){return(0,s.promisify)(E.unlink)}get rmdir(){return(0,s.promisify)(E.rmdir)}get realpath(){return(0,s.promisify)(E.realpath)}async exists(se){try{return await e.Promises.access(se),!0}catch{return!1}}get readdir(){return g}get readDirsInDir(){return D}get writeFile(){return n}get rm(){return f}get move(){return C}get copy(){return T}}}),define(te[103],ie([0,1,41,9,3,27,24]),function(x,e,E,M,s,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(v){if(s.isLinux)return v;const f=(0,M.dirname)(v);if(v===f)return v;const y=((0,M.basename)(v)||v).toLowerCase();try{const r=(0,R.readdirSync)(f).filter(g=>g.toLowerCase()===y);if(r.length===1){const g=k(f);if(g)return(0,M.join)(g,r[0])}else if(r.length>1){const g=r.indexOf(y);if(g>=0){const c=k(f);if(c)return(0,M.join)(c,r[g])}}}catch{}return null}e.realcaseSync=k;async function h(v){if(s.isLinux)return v;const f=(0,M.dirname)(v);if(v===f)return v;const y=((0,M.basename)(v)||v).toLowerCase();try{const r=(await R.Promises.readdir(f)).filter(g=>g.toLowerCase()===y);if(r.length===1){const g=await h(f);if(g)return(0,M.join)(g,r[0])}else if(r.length>1){const g=r.indexOf(y);if(g>=0){const c=await h(f);if(c)return(0,M.join)(c,r[g])}}}catch{}return null}e.realcase=h;async function l(v){try{return await R.Promises.realpath(v)}catch{const y=m(v);return await R.Promises.access(y,E.constants.R_OK),y}}e.realpath=l;function p(v){try{return E.realpathSync(v)}catch{const y=m(v);return E.accessSync(y,E.constants.R_OK),y}}e.realpathSync=p;function m(v){return(0,L.rtrim)((0,M.normalize)(v),M.sep)}}),define(te[151],ie([0,1,26,9,24]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,R=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var h;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(h||(h={}));let l;switch(process.arch){case"ia32":case"x32":l=1;break;case"arm":case"arm64":l=2;break;default:l=0;break}let p;process.env.PROCESSOR_ARCHITEW6432?p=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?p=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?p=1:p=0;class m{constructor(D,t,a){this.exePath=D,this.displayName=t,this.a=a}async exists(){return this.a===void 0&&(this.a=await s.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:S=!1}={}){return S?l===0?process.env["ProgramFiles(x86)"]||null:p===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function f({useAlternateBitness:S=!1,findPreview:D=!1}={}){const t=v({useAlternateBitness:S});if(!t)return null;const a=M.join(t,"PowerShell");if(!await s.SymlinkSupport.existsDirectory(a))return null;let i=-1,n=null;for(const d of await s.Promises.readdir(a)){let I=-1;if(D){const C=d.indexOf("-");if(C<0)continue;const T=d.substring(0,C);if(!L.test(T)||d.substring(C+1)!=="preview")continue;I=parseInt(T,10)}else{if(!L.test(d))continue;I=parseInt(d,10)}if(I<=i)continue;const A=M.join(a,d,"pwsh.exe");await s.SymlinkSupport.existsFile(A)&&(n=A,i=I)}if(!n)return null;const o=t.includes("x86")?" (x86)":"",u=D?" Preview":"";return new m(n,`PowerShell${u}${o}`,!0)}async function y({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const D=M.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await s.SymlinkSupport.existsDirectory(D))return null;const{pwshMsixDirRegex:t,pwshMsixName:a}=S?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:R,pwshMsixName:"PowerShell (Store)"};for(const i of await s.Promises.readdir(D))if(t.test(i)){const n=M.join(D,i,"pwsh.exe");return new m(n,a)}return null}function w(){const S=M.join(E.homedir(),".dotnet","tools","pwsh.exe");return new m(S,".NET Core PowerShell Global Tool")}function r(){const S=M.join(process.env.windir,l===1&&p!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new m(S,"Windows PowerShell",!0)}async function*g(){let S=await f();S&&(yield S),S=await f({useAlternateBitness:!0}),S&&(yield S),S=await y(),S&&(yield S),S=w(),S&&(yield S),S=await f({findPreview:!0}),S&&(yield S),S=await y({findPreview:!0}),S&&(yield S),S=await f({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=r(),S&&(yield S)}async function*c(){for await(const S of g())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=c;async function b(){for await(const S of c())return S;return null}e.getFirstAvailablePowerShellInstallation=b}),define(te[86],ie([0,1,9,3,36,71,11,24]),function(x,e,E,M,s,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function h(m=s.env){return m.comspec||"cmd.exe"}e.getWindowsShell=h;function l(m){let v=[],f=!1;const y=function(w){if(f){v.push(w);return}(!m.send(w,g=>{if(g&&console.error(g),f=!1,v.length>0){const c=v.slice(0);v=[],c.forEach(b=>y(b))}})||M.isWindows)&&(f=!0)};return{send:y}}e.createQueuedSender=l;var p;(function(m){async function v(f,y,w){if(E.isAbsolute(f))return f;if(y===void 0&&(y=s.cwd()),E.dirname(f)!=="."||(w===void 0&&R.isString(s.env.PATH)&&(w=s.env.PATH.split(E.delimiter)),w===void 0||w.length===0))return E.join(y,f);async function g(c){if(await k.Promises.exists(c)){let b;try{b=await k.Promises.stat(c)}catch(S){S.message.startsWith("EACCES")&&(b=await k.Promises.lstat(c))}return b?!b.isDirectory():!1}return!1}for(const c of w){let b;if(E.isAbsolute(c)?b=E.join(c,f):b=E.join(y,c,f),await g(b))return b;let S=b+".com";if(await g(S)||(S=b+".exe",await g(S)))return S}return E.join(y,f)}m.findExecutable=v})(p||(e.win32=p={}))}),define(te[104],ie([0,1,50,15]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function s(R){return new Promise((k,h)=>{let l;const p=new Map;function m(f,y,w,r,g){const c=p.get(y);if(f===R||c){const b={name:v(w),cmd:w,pid:f,ppid:y,load:r,mem:g};p.set(f,b),f===R&&(l=b),c&&(c.children||(c.children=[]),c.children.push(b),c.children.length>1&&(c.children=c.children.sort((S,D)=>S.pid-D.pid)))}}function v(f){const y=/--utility-sub-type=network/i,w=/--ms-enable-electron-run-as-node/i,r=/--crashes-directory/i,g=/\\pipe\\winpty-control/i,c=/conhost\.exe/i,b=/--type=([a-zA-Z-]+)/;if(r.exec(f))return"electron-crash-reporter";if(g.exec(f))return"winpty-process";if(c.exec(f))return"console-window-host (Windows internal process)";let S=b.exec(f);if(S&&S.length===2)return S[1]==="renderer"?"window":S[1]==="utility"?y.exec(f)?"utility-network-service":"utility-process":S[1]==="extensionHost"?"extension-host":S[1];const D=/[a-zA-Z-]+\.js/g;let t="";do S=D.exec(f),S&&(t+=S+" ");while(S);return t&&f.indexOf("node ")<0&&f.indexOf("node.exe")<0?`electron-nodejs (${t})`:w.exec(f)?`electron-nodejs (${f})`:f}if(process.platform==="win32"){const f=y=>y.indexOf("\\\\?\\")===0||y.indexOf("\\??\\")===0?y.substr(4):y.indexOf('"\\\\?\\')===0||y.indexOf('"\\??\\')===0?'"'+y.substr(5):y;new Promise((y,w)=>{x(["@vscode/windows-process-tree"],y,w)}).then(y=>{y.getProcessList(R,w=>{if(!w){h(new Error(`Root process ${R} not found`));return}y.getProcessCpuUsage(w,r=>{const g=new Map;r.forEach(c=>{const b=f(c.commandLine||"");g.set(c.pid,{name:v(b),cmd:b,pid:c.pid,ppid:c.ppid,load:c.cpu||0,mem:c.memory||0})}),l=g.get(R),l?(g.forEach(c=>{const b=g.get(c.ppid);b&&(b.children||(b.children=[]),b.children.push(c))}),g.forEach(c=>{c.children&&(c.children=c.children.sort((b,S)=>b.pid-S.pid))}),k(l)):h(new Error(`Root process ${R} not found`))})},y.ProcessDataFlag.CommandLine|y.ProcessDataFlag.Memory)})}else{let f=function(){let y=[l];const w=[];for(;y.length;){const g=y.shift();g&&(w.push(g.pid),g.children&&(y=y.concat(g.children)))}let r=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);r+=" "+w.join(" "),(0,E.exec)(r,{},(g,c,b)=>{if(g||b)h(g||new Error(b.toString()));else{const S=c.toString().split(`
`);for(let D=0;D<w.length;D++){const t=p.get(w[D]);t.load=parseFloat(S[D])}if(!l){h(new Error(`Root process ${R} not found`));return}k(l)}})};(0,E.exec)("which ps",{},(y,w,r)=>{if(y||r)if(process.platform!=="linux")h(y||new Error(r.toString()));else{const g=JSON.stringify(M.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(g,{},(c,b,S)=>{c||S?h(c||new Error(S.toString())):(L(b,m),f())})}else{const g=w.toString().trim(),c="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${g} ${c}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(b,S,D)=>{b||D&&!D.includes("screen size is bogus")?h(b||new Error(D.toString())):(L(S,m),process.platform==="linux"?f():l?k(l):h(new Error(`Root process ${R} not found`)))})}})}})}e.listProcesses=s;function L(R,k){const h=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,l=R.toString().split(`
`);for(const p of l){const m=h.exec(p.trim());m&&m.length===6&&k(parseInt(m[1]),parseInt(m[2]),m[5],parseFloat(m[3]),parseFloat(m[4]))}}}),define(te[152],ie([0,1,26,3,151,86]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function R(m,v){return m===1?M.isWindows?p():L.getWindowsShell(v):h(m,v)}e.getSystemShell=R;let k=null;function h(m,v){if(M.isLinux&&m===2||M.isMacintosh&&m===3)return"/bin/bash";if(!k){let f;if(M.isWindows)f="/bin/bash";else{if(f=v.SHELL,!f)try{f=(0,E.userInfo)().shell}catch{}f||(f="sh"),f==="/bin/false"&&(f="/bin/bash")}k=f}return k}let l=null;async function p(){return l||(l=(await(0,s.getFirstAvailablePowerShellInstallation)()).exePath),l}}),define(te[87],ie([0,1,3]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUNCHostAllowlist=e.addUNCHostToAllowlist=e.getUNCHostAllowlist=e.setUNCHostAllowlist=void 0;function M(){return process.uncHostAllowlist}function s(h){if(!E.isWindows)return;const l=M();if(l)for(const p of h)l.add(p)}e.setUNCHostAllowlist=s;function L(){const h=M();return h?Array.from(h):[]}e.getUNCHostAllowlist=L;function R(h){if(!E.isWindows)return;const l=M();l&&l.add(h)}e.addUNCHostToAllowlist=R;function k(h){const l=new Set;if(Array.isArray(h))for(const p of h)typeof p=="string"&&l.add(p);return Array.from(l)}e.toUNCHostAllowlist=k});var be=this&&this.__decorate||function(x,e,E,M){var s=arguments.length,L=s<3?e:M===null?M=Object.getOwnPropertyDescriptor(e,E):M,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(x,e,E,M);else for(var k=x.length-1;k>=0;k--)(R=x[k])&&(L=(s<3?R(L):s>3?R(e,E,L):R(e,E))||L);return s>3&&L&&Object.defineProperty(e,E,L),L};define(te[45],ie([0,1,23,7,17,22,55,13,4,2,84,27,11]),function(x,e,E,M,s,L,R,k,h,l,p,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var f;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(f||(f={}));function y(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var w;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(w||(w={}));function r(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var g;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(g||(g={}));function c(B){let z=0;for(let K=0;;K+=7){const ee=B.read(1);if(z|=(ee.buffer[0]&127)<<K,!(ee.buffer[0]&128))return z}}const b=i(0);function S(B,z){if(z===0){B.write(b);return}let K=0;for(let oe=z;oe!==0;oe=oe>>>7)K++;const ee=s.VSBuffer.alloc(K);for(let oe=0;z!==0;oe++)ee.buffer[oe]=z&127,z=z>>>7,z>0&&(ee.buffer[oe]|=128);B.write(ee)}class D{constructor(z){this.b=z,this.a=0}read(z){const K=this.b.slice(this.a,this.a+z);return this.a+=K.byteLength,K}}e.BufferReader=D;class t{constructor(){this.a=[]}get buffer(){return s.VSBuffer.concat(this.a)}write(z){this.a.push(z)}}e.BufferWriter=t;var a;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(a||(a={}));function i(B){const z=s.VSBuffer.alloc(1);return z.writeUInt8(B,0),z}const n={Undefined:i(a.Undefined),String:i(a.String),Buffer:i(a.Buffer),VSBuffer:i(a.VSBuffer),Array:i(a.Array),Object:i(a.Object),Uint:i(a.Int)},o=typeof Buffer<"u";function u(B,z){if(typeof z>"u")B.write(n.Undefined);else if(typeof z=="string"){const K=s.VSBuffer.fromString(z);B.write(n.String),S(B,K.byteLength),B.write(K)}else if(o&&Buffer.isBuffer(z)){const K=s.VSBuffer.wrap(z);B.write(n.Buffer),S(B,K.byteLength),B.write(K)}else if(z instanceof s.VSBuffer)B.write(n.VSBuffer),S(B,z.byteLength),B.write(z);else if(Array.isArray(z)){B.write(n.Array),S(B,z.length);for(const K of z)u(B,K)}else if(typeof z=="number"&&(z|0)===z)B.write(n.Uint),S(B,z);else{const K=s.VSBuffer.fromString(JSON.stringify(z));B.write(n.Object),S(B,K.byteLength),B.write(K)}}e.serialize=u;function d(B){switch(B.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return B.read(c(B)).toString();case a.Buffer:return B.read(c(B)).buffer;case a.VSBuffer:return B.read(c(B));case a.Array:{const K=c(B),ee=[];for(let oe=0;oe<K;oe++)ee.push(d(B));return ee}case a.Object:return JSON.parse(B.read(c(B)).toString());case a.Int:return c(B)}}e.deserialize=d;class I{constructor(z,K,ee=null,oe=1e3){this.h=z,this.j=K,this.k=ee,this.l=oe,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(le=>this.q(le)),this.m({type:200})}registerChannel(z,K){this.b.set(z,K),setTimeout(()=>this.w(z),0)}m(z){switch(z.type){case 200:{const K=this.o([z.type]);this.k?.logOutgoing(K,0,1,r(z.type));return}case 201:case 202:case 204:case 203:{const K=this.o([z.type,z.id],z.data);this.k?.logOutgoing(K,z.id,1,r(z.type),z.data);return}}}o(z,K=void 0){const ee=new t;return u(ee,z),u(ee,K),this.p(ee.buffer)}p(z){try{return this.h.send(z),z.byteLength}catch{return 0}}q(z){const K=new D(z),ee=d(K),oe=d(K),le=ee[0];switch(le){case 100:return this.k?.logIncoming(z.byteLength,ee[1],1,`${y(le)}: ${ee[2]}.${ee[3]}`,oe),this.s({type:le,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 102:return this.k?.logIncoming(z.byteLength,ee[1],1,`${y(le)}: ${ee[2]}.${ee[3]}`,oe),this.t({type:le,id:ee[1],channelName:ee[2],name:ee[3],arg:oe});case 101:return this.k?.logIncoming(z.byteLength,ee[1],1,`${y(le)}`),this.u({type:le,id:ee[1]});case 103:return this.k?.logIncoming(z.byteLength,ee[1],1,`${y(le)}`),this.u({type:le,id:ee[1]})}}s(z){const K=this.b.get(z.channelName);if(!K){this.v(z);return}const ee=new L.CancellationTokenSource;let oe;try{oe=K.call(this.j,z.name,z.arg,ee.token)}catch(O){oe=Promise.reject(O)}const le=z.id;oe.then(O=>{this.m({id:le,data:O,type:201}),this.d.delete(z.id)},O=>{O instanceof Error?this.m({id:le,data:{message:O.message,name:O.name,stack:O.stack?O.stack.split?O.stack.split(`
`):O.stack:void 0},type:202}):this.m({id:le,data:O,type:203}),this.d.delete(z.id)});const Y=(0,l.toDisposable)(()=>ee.cancel());this.d.set(z.id,Y)}t(z){const K=this.b.get(z.channelName);if(!K){this.v(z);return}const ee=z.id,le=K.listen(this.j,z.name,z.arg)(Y=>this.m({id:ee,data:Y,type:204}));this.d.set(z.id,le)}u(z){const K=this.d.get(z.id);K&&(K.dispose(),this.d.delete(z.id))}v(z){let K=this.g.get(z.channelName);K||(K=[],this.g.set(z.channelName,K));const ee=setTimeout(()=>{console.error(`Unknown channel: ${z.channelName}`),z.type===100&&this.m({id:z.id,data:{name:"Unknown channel",message:`Channel name '${z.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);K.push({request:z,timeoutTimer:ee})}w(z){const K=this.g.get(z);if(K){for(const ee of K)switch(clearTimeout(ee.timeoutTimer),ee.request.type){case 100:this.s(ee.request);break;case 102:this.t(ee.request);break}this.g.delete(z)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,l.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=I;var A;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(A||(e.RequestInitiator=A={}));class C{constructor(z,K=null){this.l=z,this.a=!1,this.b=g.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ee=>this.s(ee)),this.j=K}getChannel(z){const K=this;return{call(ee,oe,le){return K.a?Promise.reject(new k.CancellationError):K.m(z,ee,oe,le)},listen(ee,oe){return K.a?h.Event.None:K.o(z,ee,oe)}}}m(z,K,ee,oe=L.CancellationToken.None){const le=this.g++,O={id:le,type:100,channelName:z,name:K,arg:ee};if(oe.isCancellationRequested)return Promise.reject(new k.CancellationError);let P;return new Promise((N,j)=>{if(oe.isCancellationRequested)return j(new k.CancellationError);const U=()=>{const ae=ye=>{switch(ye.type){case 201:this.f.delete(le),N(ye.data);break;case 202:{this.f.delete(le);const Ce=new Error(ye.data.message);Ce.stack=Array.isArray(ye.data.stack)?ye.data.stack.join(`
`):ye.data.stack,Ce.name=ye.data.name,j(Ce);break}case 203:this.f.delete(le),j(ye.data);break}};this.f.set(le,ae),this.p(O)};let V=null;this.b===g.Idle?U():(V=(0,M.createCancelablePromise)(ae=>this.u()),V.then(()=>{V=null,U()}));const G=()=>{V?(V.cancel(),V=null):this.p({id:le,type:101}),j(new k.CancellationError)},re=oe.onCancellationRequested(G);P=(0,l.combinedDisposable)((0,l.toDisposable)(G),re),this.d.add(P)}).finally(()=>{this.d.delete(P)})}o(z,K,ee){const oe=this.g++,Y={id:oe,type:102,channelName:z,name:K,arg:ee};let O=null;const P=new h.Emitter({onWillAddFirstListener:()=>{O=(0,M.createCancelablePromise)(N=>this.u()),O.then(()=>{O=null,this.d.add(P),this.p(Y)})},onDidRemoveLastListener:()=>{O?(O.cancel(),O=null):(this.d.delete(P),this.p({id:oe,type:103}))}}),F=N=>P.fire(N.data);return this.f.set(oe,F),P.event}p(z){switch(z.type){case 100:case 102:{const K=this.q([z.type,z.id,z.channelName,z.name],z.arg);this.j?.logOutgoing(K,z.id,0,`${y(z.type)}: ${z.channelName}.${z.name}`,z.arg);return}case 101:case 103:{const K=this.q([z.type,z.id]);this.j?.logOutgoing(K,z.id,0,y(z.type));return}}}q(z,K=void 0){const ee=new t;return u(ee,z),u(ee,K),this.r(ee.buffer)}r(z){try{return this.l.send(z),z.byteLength}catch{return 0}}s(z){const K=new D(z),ee=d(K),oe=d(K),le=ee[0];switch(le){case 200:return this.j?.logIncoming(z.byteLength,0,0,r(le)),this.t({type:ee[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(z.byteLength,ee[1],0,r(le),oe),this.t({type:ee[0],id:ee[1],data:oe})}}t(z){if(z.type===200){this.b=g.Idle,this.k.fire();return}this.f.get(z.id)?.(z)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===g.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,l.dispose)(this.d.values()),this.d.clear()}}e.ChannelClient=C,be([R.memoize],C.prototype,"onDidInitializePromise",null);class T{get connections(){const z=[];return this.f.forEach(K=>z.push(K)),z}constructor(z){this.a=new Map,this.f=new Set,this.g=new h.Emitter,this.onDidAddConnection=this.g.event,this.h=new h.Emitter,this.onDidRemoveConnection=this.h.event,z(({protocol:K,onDidClientDisconnect:ee})=>{h.Event.once(K.onMessage)(le=>{const Y=new D(le),O=d(Y),P=new I(K,O),F=new C(K);this.a.forEach((j,U)=>P.registerChannel(U,j));const N={channelServer:P,channelClient:F,ctx:O};this.f.add(N),this.g.fire(N),ee(()=>{P.dispose(),F.dispose(),this.f.delete(N),this.h.fire(N)})})})}getChannel(z,K){const ee=this;return{call(oe,le,Y){let O;if((0,v.isFunction)(K)){const F=(0,E.getRandomElement)(ee.connections.filter(K));O=F?Promise.resolve(F):h.Event.toPromise(h.Event.filter(ee.onDidAddConnection,K))}else O=K.routeCall(ee,oe,le);const P=O.then(F=>F.channelClient.getChannel(z));return $(P).call(oe,le,Y)},listen(oe,le){if((0,v.isFunction)(K))return ee.j(z,K,oe,le);const Y=K.routeEvent(ee,oe,le).then(O=>O.channelClient.getChannel(z));return $(Y).listen(oe,le)}}}j(z,K,ee,oe){const le=this;let Y=new l.DisposableStore;const O=new h.Emitter({onWillAddFirstListener:()=>{Y=new l.DisposableStore;const P=new h.EventMultiplexer,F=new Map,N=U=>{const G=U.channelClient.getChannel(z).listen(ee,oe),re=P.add(G);F.set(U,re)},j=U=>{const V=F.get(U);V&&(V.dispose(),F.delete(U))};le.connections.filter(K).forEach(N),h.Event.filter(le.onDidAddConnection,K)(N,void 0,Y),le.onDidRemoveConnection(j,void 0,Y),P.event(O.fire,O,Y),Y.add(P)},onDidRemoveLastListener:()=>{Y.dispose()}});return O.event}registerChannel(z,K){this.a.set(z,K),this.f.forEach(ee=>{ee.channelServer.registerChannel(z,K)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=T;class W{constructor(z,K,ee=null){const oe=new t;u(oe,K),z.send(oe.buffer),this.a=new C(z,ee),this.d=new I(z,K,ee)}getChannel(z){return this.a.getChannel(z)}registerChannel(z,K){this.d.registerChannel(z,K)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=W;function $(B){return{call(z,K,ee){return B.then(oe=>oe.call(z,K,ee))},listen(z,K){const ee=new h.Relay;return B.then(oe=>ee.input=oe.listen(z,K)),ee.event}}}e.getDelayedChannel=$;function H(B){let z=!1;return{call(K,ee,oe){return z?B.call(K,ee,oe):(0,M.timeout)(0).then(()=>z=!0).then(()=>B.call(K,ee,oe))},listen(K,ee){if(z)return B.listen(K,ee);const oe=new h.Relay;return(0,M.timeout)(0).then(()=>z=!0).then(()=>oe.input=B.listen(K,ee)),oe.event}}}e.getNextTickChannel=H;class Z{constructor(z){this.a=z}routeCall(z){return this.b(z)}routeEvent(z){return this.b(z)}async b(z){for(const K of z.connections)if(await Promise.resolve(this.a(K.ctx)))return Promise.resolve(K);return await h.Event.toPromise(z.onDidAddConnection),await this.b(z)}}e.StaticRouter=Z;var ne;(function(B){function z(le,Y){const O=le,P=Y&&Y.disableMarshalling,F=new Map;for(const N in O)ee(N)&&F.set(N,h.Event.buffer(O[N],!0));return new class{listen(N,j,U){const V=F.get(j);if(V)return V;if(oe(j)){const G=O[j];if(typeof G=="function")return G.call(O,U)}throw new Error(`Event not found: ${j}`)}call(N,j,U){const V=O[j];if(typeof V=="function"){if(!P&&Array.isArray(U))for(let G=0;G<U.length;G++)U[G]=(0,p.revive)(U[G]);return V.apply(O,U)}throw new Error(`Method not found: ${j}`)}}}B.fromService=z;function K(le,Y){const O=Y&&Y.disableMarshalling;return new Proxy({},{get(P,F){if(typeof F=="string")return Y?.properties?.has(F)?Y.properties.get(F):oe(F)?function(N){return le.listen(F,N)}:ee(F)?le.listen(F):async function(...N){let j;Y&&!(0,v.isUndefinedOrNull)(Y.context)?j=[Y.context,...N]:j=N;const U=await le.call(F,j);return O?U:(0,p.revive)(U)};throw new Error(`Property not found: ${String(F)}`)}})}B.toService=K;function ee(le){return le[0]==="o"&&le[1]==="n"&&m.isUpperAsciiLetter(le.charCodeAt(2))}function oe(le){return/^onDynamic/.test(le)&&m.isUpperAsciiLetter(le.charCodeAt(9))}})(ne||(e.ProxyChannel=ne={}));const se=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ue(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const z=B.toString();if(z!=="[object Object]")return z}return B}function ce(B){return Array.isArray(B)?B.map(ue):ue(B)}function X(B,z,K,ee,oe,le,Y){Y=ce(Y);const O=se[oe],P=O[ee%O.length];let F=[`%c[${B}]%c[${String(z).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(ee).padStart(5," ")} - ${le}`,"color: darkgreen","color: grey","color: grey",`color: ${P}`];/\($/.test(le)?(F=F.concat(Y),F.push(")")):F.push(Y),console.log.apply(console,F)}class q{constructor(z,K){this.d=z,this.f=K,this.a=0,this.b=0}logOutgoing(z,K,ee,oe,le){this.b+=z,X(this.d,this.b,z,K,ee,oe,le)}logIncoming(z,K,ee,oe,le){this.a+=z,X(this.f,this.a,z,K,ee,oe,le)}}e.IPCLogger=q}),define(te[153],ie([0,1,17,4,45]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(h){this.a=h,this.onMessage=M.Event.fromDOMEventEmitter(this.a,"message",l=>E.VSBuffer.wrap(l.data)),h.start()}send(h){this.a.postMessage(h.buffer)}disconnect(){this.a.close()}}e.Protocol=L;class R extends s.IPCClient{constructor(h,l){const p=new L(h);super(p,l),this.b=p}dispose(){this.b.disconnect()}}e.Client=R}),define(te[105],ie([0,1,7,17,4,2,45]),function(x,e,E,M,s,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(C){C.Created="created",C.Read="read",C.Write="write",C.Open="open",C.Error="error",C.Close="close",C.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",C.NodeEndReceived="nodeEndReceived",C.NodeEndSent="nodeEndSent",C.NodeDrainBegin="nodeDrainBegin",C.NodeDrainEnd="nodeDrainEnd",C.zlibInflateError="zlibInflateError",C.zlibInflateData="zlibInflateData",C.zlibInflateInitialWrite="zlibInflateInitialWrite",C.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",C.zlibInflateWrite="zlibInflateWrite",C.zlibInflateFlushFired="zlibInflateFlushFired",C.zlibDeflateError="zlibDeflateError",C.zlibDeflateData="zlibDeflateData",C.zlibDeflateWrite="zlibDeflateWrite",C.zlibDeflateFlushFired="zlibDeflateFlushFired",C.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",C.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",C.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",C.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",C.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",C.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",C.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",C.ProtocolHeaderRead="protocolHeaderRead",C.ProtocolMessageRead="protocolMessageRead",C.ProtocolHeaderWrite="protocolHeaderWrite",C.ProtocolMessageWrite="protocolMessageWrite",C.ProtocolWrite="protocolWrite"})(k||(e.SocketDiagnosticsEventType=k={}));var h;(function(C){C.enableDiagnostics=!1,C.records=[];const T=new WeakMap;let W=0;function $(Z,ne){if(!T.has(Z)){const se=String(++W);T.set(Z,se)}return T.get(Z)}function H(Z,ne,se,ue){if(!C.enableDiagnostics)return;const ce=$(Z,ne);if(ue instanceof M.VSBuffer||ue instanceof Uint8Array||ue instanceof ArrayBuffer||ArrayBuffer.isView(ue)){const X=M.VSBuffer.alloc(ue.byteLength);X.set(ue),C.records.push({timestamp:Date.now(),id:ce,label:ne,type:se,buff:X})}else C.records.push({timestamp:Date.now(),id:ce,label:ne,type:se,data:ue})}C.traceSocketEvent=H})(h||(e.SocketDiagnostics=h={}));var l;(function(C){C[C.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",C[C.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(l||(e.SocketCloseEventType=l={}));let p=null;function m(){return p||(p=M.VSBuffer.alloc(0)),p}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(T){this.a.push(T),this.b+=T.byteLength}read(T){return this.c(T,!0)}peek(T){return this.c(T,!1)}c(T,W){if(T===0)return m();if(T>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===T){const ne=this.a[0];return W&&(this.a.shift(),this.b-=T),ne}if(this.a[0].byteLength>T){const ne=this.a[0].slice(0,T);return W&&(this.a[0]=this.a[0].slice(T),this.b-=T),ne}const $=M.VSBuffer.alloc(T);let H=0,Z=0;for(;T>0;){const ne=this.a[Z];if(ne.byteLength>T){const se=ne.slice(0,T);$.set(se,H),H+=T,W&&(this.a[Z]=ne.slice(T),this.b-=T),T-=T}else $.set(ne,H),H+=ne.byteLength,W?(this.a.shift(),this.b-=ne.byteLength):Z++,T-=ne.byteLength}return $}}e.ChunkStream=v;var f;(function(C){C[C.None=0]="None",C[C.Regular=1]="Regular",C[C.Control=2]="Control",C[C.Ack=3]="Ack",C[C.Disconnect=5]="Disconnect",C[C.ReplayRequest=6]="ReplayRequest",C[C.Pause=7]="Pause",C[C.Resume=8]="Resume",C[C.KeepAlive=9]="KeepAlive",C[C.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",C[C.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(f||(f={}));function y(C){switch(C){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var w;(function(C){C[C.HeaderLength=13]="HeaderLength",C[C.AcknowledgeTime=2e3]="AcknowledgeTime",C[C.TimeoutTime=2e4]="TimeoutTime",C[C.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",C[C.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",C[C.KeepAliveSendTime=5e3]="KeepAliveSendTime",C[C.LatencySampleTime=6e4]="LatencySampleTime",C[C.LatencySampleCount=5]="LatencySampleCount",C[C.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",C[C.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(w||(e.ProtocolConstants=w={}));class r{constructor(T,W,$,H){this.type=T,this.id=W,this.ack=$,this.data=H,this.writtenTime=0}get size(){return this.data.byteLength}}class g extends L.Disposable{constructor(T){super(),this.f=this.B(new s.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=T,this.b=!1,this.c=new v,this.B(this.a.onData(W=>this.acceptChunk(W))),this.lastReadTime=Date.now()}acceptChunk(T){if(!(!T||T.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(T);this.c.byteLength>=this.g.readLen;){const W=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=W.readUInt32BE(9),this.g.messageType=W.readUInt8(0),this.g.id=W.readUInt32BE(1),this.g.ack=W.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:y(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const $=this.g.messageType,H=this.g.id,Z=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",W),this.f.fire(new r($,H,Z,W)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class c{constructor(T){this.k=null,this.a=!1,this.b=!1,this.c=T,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(T){if(this.a)return;T.writtenTime=Date.now(),this.lastWriteTime=Date.now();const W=M.VSBuffer.alloc(13);W.writeUInt8(T.type,0),W.writeUInt32BE(T.id,1),W.writeUInt32BE(T.ack,5),W.writeUInt32BE(T.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:y(T.type),id:T.id,ack:T.ack,messageSize:T.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",T.data),this.j(W,T.data)}g(T,W){const $=this.f===0;return this.d.push(T,W),this.f+=T.byteLength+W.byteLength,$}h(){const T=M.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,T}j(T,W){this.g(T,W)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const T=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:T.byteLength}),this.c.write(T)}}class b extends L.Disposable{constructor(T){super(),this.f=new s.Emitter,this.onMessage=this.f.event,this.g=new s.Emitter,this.onDidDispose=this.g.event,this.a=T,this.b=this.B(new c(this.a)),this.c=this.B(new g(this.a)),this.B(this.c.onMessage(W=>{W.type===1&&this.f.fire(W.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(T){this.b.write(new r(1,0,0,T))}}e.Protocol=b;class S extends R.IPCClient{static fromSocket(T,W){return new S(new b(T),W)}get onDidDispose(){return this.b.onDidDispose}constructor(T,W,$=null){super(T,W,$),this.b=T}dispose(){super.dispose();const T=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),T.end()}}e.Client=S;class D{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new s.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(T){this.b?this.d.length>0?this.d.push(T):this.a.fire(T):this.d.push(T)}flushBuffer(){this.d=[]}}e.BufferedEmitter=D;class t{constructor(T){this.data=T,this.next=null}}class a{constructor(){this.a=null,this.b=null}length(){let T=0,W=this.a;for(;W;)W=W.next,T++;return T}peek(){return this.a?this.a.data:null}toArray(){const T=[];let W=0,$=this.a;for(;$;)T[W++]=$.data,$=$.next;return T}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(T){const W=new t(T);if(!this.a){this.a=W,this.b=W;return}this.b.next=W,this.b=W}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const T=Date.now();for(let W=0;W<i.a;W++)this.c[W]=T-1e3*W;setInterval(()=>{for(let W=i.a;W>=1;W--)this.c[W]=this.c[W-1];this.c[0]=Date.now()},1e3)}d(){const T=Date.now(),W=(1+i.a)*1e3;let $=0;for(let H=0;H<i.a;H++)T-this.c[H]<=W&&$++;return 1-$/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var n;(function(C){C[C.Good=0]="Good",C[C.Poor=1]="Poor"})(n||(e.ConnectionHealth=n={}));function o(C){switch(C){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class u{constructor(T){this.connectionHealth=T}}e.ConnectionHealthChangedEvent=u;class d{constructor(T,W){this.roundTripTime=T,this.recentHighRoundTripCount=W}}e.HighRoundTripTimeEvent=d;class I{get unacknowledgedCount(){return this.c-this.d}constructor(T){this.x=new D,this.onControlMessage=this.x.event,this.y=new D,this.onMessage=this.y.event,this.z=new D,this.onDidDispose=this.z.event,this.A=new D,this.onSocketClose=this.A.event,this.B=new D,this.onSocketTimeout=this.B.event,this.C=new D,this.onHighRoundTripTime=this.C.event,this.D=new D,this.onDidChangeConnectionHealth=this.D.event,this.u=T.loadEstimator??i.getInstance(),this.v=T.measureRoundTripTime??!1,this.w=T.sendKeepAlive??!0,this.a=!1,this.b=new a,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new L.DisposableStore,this.o=T.socket,this.p=this.t.add(new c(this.o)),this.q=this.t.add(new g(this.o)),this.t.add(this.q.onMessage(W=>this.E(W))),this.t.add(this.o.onClose(W=>this.A.fire(W))),this.r=this.t.add(new A),this.t.add(this.r.onSendLatencyRequest(W=>this.J(W))),this.t.add(this.r.onHighRoundTripTime(W=>this.C.fire(W))),this.t.add(this.r.onDidChangeConnectionHealth(W=>this.D.fire(W))),this.v&&this.r.start(),T.initialChunk&&this.q.acceptChunk(T.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const T=new r(5,0,0,m());this.p.write(T),this.p.flush()}sendPause(){const T=new r(7,0,0,m());this.p.write(T)}sendResume(){const T=new r(8,0,0,m());this.p.write(T)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(T,W){this.a=!0,this.t.dispose(),this.t=new L.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=T,this.p=this.t.add(new c(this.o)),this.q=this.t.add(new g(this.o)),this.t.add(this.q.onMessage($=>this.E($))),this.t.add(this.o.onClose($=>this.A.fire($))),this.r=this.t.add(new A),this.t.add(this.r.onSendLatencyRequest($=>this.J($))),this.t.add(this.r.onHighRoundTripTime($=>this.C.fire($))),this.t.add(this.r.onDidChangeConnectionHealth($=>this.D.fire($))),this.q.acceptChunk(W)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const T=new r(3,0,this.h,m());this.p.write(T);const W=this.b.toArray();for(let $=0,H=W.length;$<H;$++)this.p.write(W[$]);this.G()}acceptDisconnect(){this.z.fire()}E(T){if(T.ack>this.d){this.d=T.ack;do{const W=this.b.peek();if(W&&W.id<=T.ack)this.b.pop();else break}while(!0)}switch(T.type){case 0:break;case 1:{if(T.id>this.g)if(T.id!==this.g+1){const W=Date.now();W-this.m>1e4&&(this.m=W,this.p.write(new r(6,0,0,m())))}else this.g=T.id,this.j=Date.now(),this.F(),this.y.fire(T.data);break}case 2:{this.x.fire(T.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const W=this.b.toArray();for(let $=0,H=W.length;$<H;$++)this.p.write(W[$]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(T.data);break}case 11:{this.r.handleResponse(T.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(T){const W=++this.c;this.h=this.g;const $=new r(1,W,this.h,T);this.b.push($),this.a||(this.p.write($),this.G())}sendControl(T){const W=new r(2,0,0,T);this.p.write(W)}F(){if(this.g<=this.h||this.k)return;const T=Date.now()-this.j;if(T>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-T+5)}G(){if(this.c<=this.d||this.f||this.a)return;const T=this.b.peek(),W=Date.now()-T.writtenTime,$=Date.now()-this.q.lastReadTime,H=Date.now()-this.n;if(W>=2e4&&$>=2e4&&H>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:W,timeSinceLastReceivedSomeData:$});return}const Z=Math.max(2e4-W,2e4-$,2e4-H,500);this.f=setTimeout(()=>{this.f=null,this.G()},Z)}H(){if(this.g<=this.h)return;this.h=this.g;const T=new r(3,0,this.h,m());this.p.write(T)}I(){this.h=this.g;const T=new r(9,0,this.h,m());this.p.write(T)}J(T){this.h=this.g;const W=new r(10,0,this.h,T);this.p.write(W)}K(T){this.h=this.g;const W=new r(11,0,this.h,T);this.p.write(W)}}e.PersistentProtocol=I;class A extends L.Disposable{constructor(){super(),this.a=this.B(new s.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new s.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new s.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new E.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},T=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const T=++this.h,W=M.VSBuffer.alloc(4);W.writeUInt32BE(T,0),this.a.fire(W)},6e4)}handleResponse(T){if(T.byteLength!==4)return;const W=T.readUInt32BE(0);if(this.g<=0||W!==this.h)return;const $=Date.now()-this.g,H=this.k++;this.j[H%this.j.length]=$;const Z=this.l,ne=this.j.filter(se=>se>=1e3).length;this.l=ne>=3?1:0,$>1e3&&this.b.fire(new d($,ne)),Z!==this.l&&this.c.fire(this.l)}}}),define(te[154],ie([0,1,42,17,4,2,45,139]),function(x,e,E,M,s,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function h(p,m){const v=s.Event.fromNodeEventEmitter(E.validatedIpcMain,m,(y,w)=>({event:y,message:w})),f=s.Event.filter(v,({event:y})=>y.sender.id===p);return s.Event.map(f,({message:y})=>y&&M.VSBuffer.wrap(y))}class l extends R.IPCServer{static d(){const m=s.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:hello",({sender:v})=>v);return s.Event.map(m,v=>{const f=v.id;l.b.get(f)?.dispose();const w=new s.Emitter;l.b.set(f,(0,L.toDisposable)(()=>w.fire()));const r=h(f,"vscode:message"),g=s.Event.any(s.Event.signal(h(f,"vscode:disconnect")),w.event);return{protocol:new k.Protocol(v,r),onDidClientDisconnect:g}})}constructor(){super(l.d())}}e.Server=l,l.b=new Map}),define(te[155],ie([0,1,42,4,31,153]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class R extends L.Client{constructor(l,p){super({addEventListener:(m,v)=>l.addListener(m,v),removeEventListener:(m,v)=>l.removeListener(m,v),postMessage:m=>l.postMessage(m),start:()=>l.start(),close:()=>l.close()},p)}}e.Client=R;async function k(h){if(h.isDestroyed()||h.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const l=(0,s.generateUuid)();h.webContents.send("vscode:createMessageChannel",l);const p=M.Event.fromNodeEventEmitter(E.validatedIpcMain,"vscode:createMessageChannelResult",(v,f)=>({nonce:f,port:v.ports[0]})),{port:m}=await M.Event.toPromise(M.Event.once(M.Event.filter(p,v=>v.nonce===l)));return m}e.connect=k}),define(te[156],ie([0,1,50,7,17,22,148,13,4,2,40,86,71,45]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class y extends f.ChannelServer{constructor(g){super({send:c=>{try{process.send?.(c.buffer.toString("base64"))}catch{}},onMessage:h.Event.fromNodeEventEmitter(process,"message",c=>s.VSBuffer.wrap(Buffer.from(c,"base64")))},g),process.once("disconnect",()=>this.dispose())}}e.Server=y;class w{constructor(g,c){this.i=g,this.j=c,this.c=new Set,this.g=new Map,this.h=new h.Emitter,this.onDidProcessExit=this.h.event;const b=c&&c.timeout?c.timeout:6e4;this.b=new M.Delayer(b),this.d=null,this.f=null}getChannel(g){const c=this;return{call(b,S,D){return c.k(g,b,S,D)},listen(b,S){return c.l(g,b,S)}}}k(g,c,b,S=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(k.canceled());this.b.cancel();const D=this.n(g),t=(0,M.createCancelablePromise)(n=>D.call(c,b,n)),a=S.onCancellationRequested(()=>t.cancel()),i=(0,l.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{a.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(g,c,b){if(!this.b)return h.Event.None;this.b.cancel();let S;const D=new h.Emitter({onWillAddFirstListener:()=>{S=this.n(g).listen(c,b)(D.fire,D),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return D.event}get m(){if(!this.f){const g=this.j&&this.j.args?this.j.args:[],c=Object.create(null);c.env={...(0,p.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(c.env={...c.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(c.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(c.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(c.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),c.execArgv===void 0&&(c.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(c.env),this.d=(0,E.fork)(this.i,g,c);const b=new h.Emitter;h.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,R.isRemoteConsoleLog)(o)){(0,R.log)(o,`IPC Library: ${this.j.serverName}`);return}b.fire(s.VSBuffer.wrap(Buffer.from(o,"base64")))});const D=this.j.useQueue?(0,m.createQueuedSender)(this.d):this.d,t=o=>this.d&&this.d.connected&&D.send(o.buffer.toString("base64")),a=b.event,i={send:t,onMessage:a};this.f=new f.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,u)=>{process.removeListener("exit",n),this.c.forEach(d=>(0,l.dispose)(d)),this.c.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:u})})}return this.f}n(g){let c=this.g.get(g);return c||(c=this.m.getChannel(g),this.g.set(g,c)),c}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=w}),define(te[106],ie([0,1,7,4,2,11]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var R;(function(m){m[m.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",m[m.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(R||(e.StorageHint=R={}));function k(m){const v=m;return v?.changed instanceof Map||v?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var h;(function(m){m[m.None=0]="None",m[m.Initialized=1]="Initialized",m[m.Closed=2]="Closed"})(h||(e.StorageState=h={}));class l extends s.Disposable{constructor(v,f=Object.create(null)){super(),this.m=v,this.n=f,this.b=this.B(new M.Emitter),this.onDidChangeStorage=this.b.event,this.c=h.None,this.f=new Map,this.g=new E.ThrottledDelayer(l.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(v=>this.r(v)))}r(v){v.changed?.forEach((f,y)=>this.s(y,f)),v.deleted?.forEach(f=>this.s(f,void 0))}s(v,f){if(this.c===h.Closed)return;let y=!1;(0,L.isUndefinedOrNull)(f)?y=this.f.delete(v):this.f.get(v)!==f&&(this.f.set(v,f),y=!0),y&&this.b.fire(v)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===h.None&&(this.c=h.Initialized,this.n.hint!==R.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(v,f){const y=this.f.get(v);return(0,L.isUndefinedOrNull)(y)?f:y}getBoolean(v,f){const y=this.get(v);return(0,L.isUndefinedOrNull)(y)?f:y==="true"}getNumber(v,f){const y=this.get(v);return(0,L.isUndefinedOrNull)(y)?f:parseInt(y,10)}async set(v,f){if(this.c===h.Closed)return;if((0,L.isUndefinedOrNull)(f))return this.delete(v);const y=String(f);if(this.f.get(v)!==y)return this.f.set(v,y),this.j.set(v,y),this.h.delete(v),this.b.fire(v),this.w()}async delete(v){if(!(this.c===h.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire(v),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=h.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(v).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(v){if(this.u)return this.w(v)}async w(v){return this.g.trigger(()=>this.v(),v)}async whenFlushed(){if(this.u)return new Promise(v=>this.l.push(v))}isInMemory(){return this.n.hint===R.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=l,l.a=100;class p{constructor(){this.onDidChangeItemsExternal=M.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((f,y)=>this.a.set(y,f)),v.delete?.forEach(f=>this.a.delete(f))}async close(){}}e.InMemoryStorageDatabase=p}),define(te[157],ie([0,1,7,4,35,9,24]),function(x,e,E,M,s,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class k{get onDidChangeItemsExternal(){return M.Event.None}constructor(p,m=Object.create(null)){this.g=p,this.h=m,this.c=(0,L.basename)(this.g),this.d=new h(this.h.logging),this.f=this.n(this.g)}async getItems(){const p=await this.f,m=new Map;return(await this.s(p,"SELECT * FROM ItemTable")).forEach(f=>m.set(f.key,f.value)),this.d.isTracing&&this.d.trace(`[storage ${this.c}] getItems(): ${m.size} rows`),m}async updateItems(p){const m=await this.f;return this.j(m,p)}j(p,m){return this.d.isTracing&&this.d.trace(`[storage ${this.c}] updateItems(): insert(${m.insert?(0,s.mapToString)(m.insert):"0"}), delete(${m.delete?(0,s.setToString)(m.delete):"0"})`),this.t(p,()=>{const v=m.insert,f=m.delete;if(v&&v.size>0){const y=[];y.push([]);let w=0;v.forEach((r,g)=>{let c=y[w];c.length>k.b&&(w++,c=[],y.push(c)),c.push(g,r)}),y.forEach(r=>{this.u(p,`INSERT INTO ItemTable VALUES ${new Array(r.length/2).fill("(?,?)").join(",")}`,g=>g.run(r),()=>{const g=[];let c=0;return v.forEach((b,S)=>{g.push(S),c+=b.length}),`Keys: ${g.join(", ")} Length: ${c}`})})}if(f&&f.size){const y=[];y.push([]);let w=0;f.forEach(r=>{let g=y[w];g.length>k.b&&(w++,g=[],y.push(g)),g.push(r)}),y.forEach(r=>{this.u(p,`DELETE FROM ItemTable WHERE key IN (${new Array(r.length).fill("?").join(",")})`,g=>g.run(r),()=>{const g=[];return f.forEach(c=>{g.push(c)}),`Keys: ${g.join(", ")}`})})}})}async close(p){this.d.trace(`[storage ${this.c}] close()`);const m=await this.f;return this.k(m,p)}k(p,m){return new Promise((v,f)=>{p.db.close(y=>(y&&this.o(p,`[storage ${this.c}] close(): ${y}`),this.g===k.IN_MEMORY_PATH?v():!p.isErroneous&&!p.isInMemory?this.l().then(v,w=>(this.d.error(`[storage ${this.c}] backup(): ${w}`),v())):typeof m=="function"?R.Promises.unlink(this.g).then(()=>this.p(this.g).then(w=>{const r=()=>this.k(w,void 0);return this.j(w,{insert:m()}).then(()=>r(),g=>(r(),Promise.reject(g)))})).then(v,f):f(y||new Error("Database has errors or is in-memory without recovery option"))))})}l(){const p=this.m(this.g);return R.Promises.copy(this.g,p,{preserveSymlinks:!1})}m(p){return`${p}.backup`}async checkIntegrity(p){this.d.trace(`[storage ${this.c}] checkIntegrity(full: ${p})`);const m=await this.f,v=await this.r(m,p?"PRAGMA integrity_check":"PRAGMA quick_check"),f=p?v.integrity_check:v.quick_check;return m.isErroneous?`${f} (last error: ${m.lastError})`:m.isInMemory?`${f} (in-memory!)`:f}async n(p,m=!0){this.d.trace(`[storage ${this.c}] open(${p}, retryOnBusy: ${m})`);try{return await this.p(p)}catch(v){if(this.d.error(`[storage ${this.c}] open(): Unable to open DB due to ${v}`),v.code==="SQLITE_BUSY"&&m)return await(0,E.timeout)(k.a),this.n(p,!1);try{await R.Promises.unlink(p);try{await R.Promises.rename(this.m(p),p)}catch{}return await this.p(p)}catch(f){return this.d.error(`[storage ${this.c}] open(): Unable to use backup due to ${f}`),this.p(k.IN_MEMORY_PATH)}}}o(p,m){p.isErroneous=!0,p.lastError=m,this.d.error(m)}p(p){return new Promise((m,v)=>{new Promise((f,y)=>{x(["@vscode/sqlite3"],f,y)}).then(f=>{const y={db:new(this.d.isTracing?f.verbose().Database:f.Database)(p,w=>w?y.db&&w.code!=="SQLITE_CANTOPEN"?y.db.close(()=>v(w)):v(w):this.q(y,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>m(y),r=>y.db.close(()=>v(r)))),isInMemory:p===k.IN_MEMORY_PATH};y.db.on("error",w=>this.o(y,`[storage ${this.c}] Error (event): ${w}`)),this.d.isTracing&&y.db.on("trace",w=>this.d.trace(`[storage ${this.c}] Trace (event): ${w}`))},v)})}q(p,m){return new Promise((v,f)=>{p.db.exec(m,y=>y?(this.o(p,`[storage ${this.c}] exec(): ${y}`),f(y)):v())})}r(p,m){return new Promise((v,f)=>{p.db.get(m,(y,w)=>y?(this.o(p,`[storage ${this.c}] get(): ${y}`),f(y)):v(w))})}s(p,m){return new Promise((v,f)=>{p.db.all(m,(y,w)=>y?(this.o(p,`[storage ${this.c}] all(): ${y}`),f(y)):v(w))})}t(p,m){return new Promise((v,f)=>{p.db.serialize(()=>{p.db.run("BEGIN TRANSACTION"),m(),p.db.run("END TRANSACTION",y=>y?(this.o(p,`[storage ${this.c}] transaction(): ${y}`),f(y)):v())})})}u(p,m,v,f){const y=p.db.prepare(m),w=r=>{this.o(p,`[storage ${this.c}] prepare(): ${r} (${m}). Details: ${f()}`)};y.on("error",w),v(y),y.finalize(r=>{r&&w(r),y.removeListener("error",w)})}}e.SQLiteStorageDatabase=k,k.IN_MEMORY_PATH=":memory:",k.a=2e3,k.b=256;class h{constructor(p){p&&typeof p.logTrace=="function"&&process.env[h.VSCODE_TRACE_STORAGE]&&(this.a=p.logTrace),p&&typeof p.logError=="function"&&(this.b=p.logError)}get isTracing(){return!!this.a}trace(p){this.a?.(p)}error(p){this.b?.(p)}}h.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(te[158],ie([12,10]),function(x,e){return x.create("vs/code/electron-main/app",e)}),define(te[159],ie([12,10]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(te[160],ie([12,10]),function(x,e){return x.create("vs/platform/contextkey/common/contextkey",e)}),define(te[161],ie([12,10]),function(x,e){return x.create("vs/platform/contextkey/common/scanner",e)}),define(te[162],ie([12,10]),function(x,e){return x.create("vs/platform/dialogs/common/dialogs",e)}),define(te[163],ie([12,10]),function(x,e){return x.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(te[164],ie([12,10]),function(x,e){return x.create("vs/platform/environment/node/argv",e)}),define(te[165],ie([12,10]),function(x,e){return x.create("vs/platform/environment/node/argvHelper",e)}),define(te[166],ie([12,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(te[167],ie([12,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(te[168],ie([12,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(te[169],ie([12,10]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(te[170],ie([12,10]),function(x,e){return x.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(te[171],ie([12,10]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(te[172],ie([12,10]),function(x,e){return x.create("vs/platform/files/common/files",e)}),define(te[173],ie([12,10]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(te[174],ie([12,10]),function(x,e){return x.create("vs/platform/files/electron-main/diskFileSystemProviderServer",e)}),define(te[175],ie([12,10]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(te[176],ie([12,10]),function(x,e){return x.create("vs/platform/issue/electron-main/issueMainService",e)}),define(te[177],ie([12,10]),function(x,e){return x.create("vs/platform/menubar/electron-main/menubar",e)}),define(te[178],ie([12,10]),function(x,e){return x.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(te[179],ie([12,10]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(te[180],ie([12,10]),function(x,e){return x.create("vs/platform/shell/node/shellEnv",e)}),define(te[181],ie([12,10]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(te[182],ie([12,10]),function(x,e){return x.create("vs/platform/update/common/update.config.contribution",e)}),define(te[183],ie([12,10]),function(x,e){return x.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(te[184],ie([12,10]),function(x,e){return x.create("vs/platform/windows/electron-main/windowImpl",e)}),define(te[185],ie([12,10]),function(x,e){return x.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(te[186],ie([12,10]),function(x,e){return x.create("vs/platform/workspace/common/workspace",e)}),define(te[187],ie([12,10]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(te[188],ie([12,10]),function(x,e){return x.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(te[189],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.isFolderBackupInfo=void 0;function E(s){return s&&s.hasOwnProperty("folderUri")}e.isFolderBackupInfo=E;function M(s){return s&&s.hasOwnProperty("workspace")}e.isWorkspaceBackupInfo=M}),define(te[190],ie([0,1,8]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeFolderInfos=e.deserializeWorkspaceInfos=e.isEmptyWindowBackupInfo=void 0;function M(R){return typeof R?.backupFolder=="string"}e.isEmptyWindowBackupInfo=M;function s(R){let k=[];try{Array.isArray(R.workspaces)&&(k=R.workspaces.map(h=>({workspace:{id:h.id,configPath:E.URI.parse(h.configURIPath)},remoteAuthority:h.remoteAuthority})))}catch{}return k}e.deserializeWorkspaceInfos=s;function L(R){let k=[];try{Array.isArray(R.folders)&&(k=R.folders.map(h=>({folderUri:E.URI.parse(h.folderUri),remoteAuthority:h.remoteAuthority})))}catch{}return k}e.deserializeFolderInfos=L}),define(te[191],ie([0,1,13,161]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var s;(function(l){l[l.LParen=0]="LParen",l[l.RParen=1]="RParen",l[l.Neg=2]="Neg",l[l.Eq=3]="Eq",l[l.NotEq=4]="NotEq",l[l.Lt=5]="Lt",l[l.LtEq=6]="LtEq",l[l.Gt=7]="Gt",l[l.GtEq=8]="GtEq",l[l.RegexOp=9]="RegexOp",l[l.RegexStr=10]="RegexStr",l[l.True=11]="True",l[l.False=12]="False",l[l.In=13]="In",l[l.Not=14]="Not",l[l.And=15]="And",l[l.Or=16]="Or",l[l.Str=17]="Str",l[l.QuotedStr=18]="QuotedStr",l[l.Error=19]="Error",l[l.EOF=20]="EOF"})(s||(e.TokenType=s={}));function L(...l){switch(l.length){case 1:return(0,M.localize)(0,null,l[0]);case 2:return(0,M.localize)(1,null,l[0],l[1]);case 3:return(0,M.localize)(2,null,l[0],l[1],l[2]);default:return}}const R=(0,M.localize)(3,null),k=(0,M.localize)(4,null);class h{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(p){switch(p.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return p.isTripleEq?"===":"==";case 4:return p.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return p.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return p.lexeme;case 18:return p.lexeme;case 19:return p.lexeme;case 20:return"EOF";default:throw(0,E.illegalState)(`unhandled token type: ${JSON.stringify(p)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(p){return this.c=p,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const m=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:m})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const m=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:m})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(p){return this.r()||this.c.charCodeAt(this.e)!==p?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(p){this.f.push({type:p,offset:this.d})}l(p){const m=this.d,v=this.c.substring(this.d,this.e),f={type:19,offset:this.d,lexeme:v};this.g.push({offset:m,lexeme:v,additionalInfo:p}),this.f.push(f)}n(){this.m.lastIndex=this.d;const p=this.m.exec(this.c);if(p){this.e=this.d+p[0].length;const m=this.c.substring(this.d,this.e),v=h.b.get(m);v?this.k(v):this.f.push({type:17,lexeme:m,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let p=this.e,m=!1,v=!1;for(;;){if(p>=this.c.length){this.e=p,this.l(k);return}const y=this.c.charCodeAt(p);if(m)m=!1;else if(y===47&&!v){p++;break}else y===91?v=!0:y===92?m=!0:y===93&&(v=!1);p++}for(;p<this.c.length&&h.a.has(this.c.charCodeAt(p));)p++;this.e=p;const f=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:f,offset:this.d})}r(){return this.e>=this.c.length}}e.Scanner=h,h.a=new Set(["i","g","s","m","y","u"].map(l=>l.charCodeAt(0))),h.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(te[192],ie([0,1,4,2]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class s{constructor(){this.a=new E.Emitter,this.b=new E.Emitter,this.c=new E.Emitter,this.d=new E.Emitter}call(k,h,l){switch(h){case"close":return Promise.resolve(this.a.fire({sessionId:l[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:l[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:l[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:l[0],port:l[1],subId:l[2]}))}throw new Error("Method not implemented.")}listen(k,h,l){switch(h){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=s,s.ChannelName="extensionhostdebugservice";class L extends M.Disposable{constructor(k){super(),this.b=k}reload(k){this.b.call("reload",[k])}get onReload(){return this.b.listen("reload")}close(k){this.b.call("close",[k])}get onClose(){return this.b.listen("close")}attachSession(k,h,l){this.b.call("attach",[k,h,l])}get onAttachSession(){return this.b.listen("attach")}terminateSession(k,h){this.b.call("terminate",[k,h])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(k,h){return this.b.call("openExtensionDevelopmentHostWindow",[k,h])}}e.ExtensionHostDebugChannelClient=L}),define(te[193],ie([0,1,142,55,15,9,36,18,8]),function(x,e,E,M,s,L,R,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class l{get appRoot(){return(0,L.dirname)(s.FileAccess.asFileUri("").fsPath)}get userHome(){return h.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return h.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return h.URI.file(this.b.tmpDir)}get cacheHome(){return h.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const f=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",f)}return h.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(h.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=R.env.VSCODE_PORTABLE;return f?h.URI.file((0,L.join)(f,"argv.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return h.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?(0,L.resolve)(f):(0,L.normalize)((0,L.join)(s.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const f=this.args["extensions-download-dir"];return f?h.URI.file((0,L.resolve)(f)):h.URI.file((0,L.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return(0,L.resolve)(f);const y=R.env.VSCODE_EXTENSIONS;if(y)return y;const w=R.env.VSCODE_PORTABLE;return w?(0,L.join)(w,"extensions"):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(y=>/^[^:/?#]+?:\/\//.test(y)?h.URI.parse(y):h.URI.file((0,L.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(f=>f==="ui"||f==="workspace"||f==="web"?f:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?h.URI.parse(f):h.URI.file((0,L.normalize)(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return p(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!R.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(f=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(f))}get extensionLogLevel(){const f=[];for(const y of this.args.log||[]){const w=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(y);w&&w[1]&&w[2]&&f.push([w[1],w[2]])}return f.length?f:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(h.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const f=R.env.VSCODE_PORTABLE;return f?h.URI.file((0,L.join)(f,"policy.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(f){this.args.continueOn=f}get args(){return this.a}constructor(f,y,w){this.a=f,this.b=y,this.c=w,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=l,be([M.memoize],l.prototype,"appRoot",null),be([M.memoize],l.prototype,"userHome",null),be([M.memoize],l.prototype,"userDataPath",null),be([M.memoize],l.prototype,"appSettingsHome",null),be([M.memoize],l.prototype,"tmpDir",null),be([M.memoize],l.prototype,"cacheHome",null),be([M.memoize],l.prototype,"stateResource",null),be([M.memoize],l.prototype,"userRoamingDataHome",null),be([M.memoize],l.prototype,"userDataSyncHome",null),be([M.memoize],l.prototype,"sync",null),be([M.memoize],l.prototype,"machineSettingsResource",null),be([M.memoize],l.prototype,"workspaceStorageHome",null),be([M.memoize],l.prototype,"localHistoryHome",null),be([M.memoize],l.prototype,"keyboardLayoutResource",null),be([M.memoize],l.prototype,"argvResource",null),be([M.memoize],l.prototype,"isExtensionDevelopment",null),be([M.memoize],l.prototype,"untitledWorkspacesHome",null),be([M.memoize],l.prototype,"builtinExtensionsPath",null),be([M.memoize],l.prototype,"extensionsPath",null),be([M.memoize],l.prototype,"extensionDevelopmentLocationURI",null),be([M.memoize],l.prototype,"extensionDevelopmentKind",null),be([M.memoize],l.prototype,"extensionTestsLocationURI",null),be([M.memoize],l.prototype,"debugExtensionHost",null),be([M.memoize],l.prototype,"logLevel",null),be([M.memoize],l.prototype,"extensionLogLevel",null),be([M.memoize],l.prototype,"serviceMachineIdResource",null),be([M.memoize],l.prototype,"disableTelemetry",null),be([M.memoize],l.prototype,"disableWorkspaceTrust",null),be([M.memoize],l.prototype,"policyFile",null);function p(v,f){return m(v["inspect-extensions"],v["inspect-brk-extensions"],5870,f,v.debugId,v.extensionEnvironment)}e.parseExtensionHostDebugPort=p;function m(v,f,y,w,r,g){const b=Number(f||v)||(w?null:y),S=b?!!f:!1;let D;if(g)try{D=JSON.parse(g)}catch{}return{port:b,break:S,debugId:r,env:D}}e.parseDebugParams=m}),define(te[107],ie([0,1,292,3,164]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,s.localize)(0,null),e:(0,s.localize)(1,null),t:(0,s.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,s.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,s.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,s.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,s.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,s.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,s.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,s.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,s.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,s.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,s.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,s.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,s.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,s.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,s.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,s.localize)(17,null)},category:{type:"string",cat:"e",description:(0,s.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,s.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,s.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,s.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,s.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,s.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,s.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,s.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,s.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,s.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,s.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,s.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,s.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,s.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,s.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,s.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,s.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const R={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(w,r,g=R){const c=w.find(u=>u.length>0&&u[0]!=="-"),b={},S=["_"],D=[],t={};let a;for(const u in r){const d=r[u];d.type==="subcommand"?u===c&&(a=d):(d.alias&&(b[u]=d.alias),d.type==="string"||d.type==="string[]"?(S.push(u),d.deprecates&&S.push(...d.deprecates)):d.type==="boolean"&&(D.push(u),d.deprecates&&D.push(...d.deprecates)),d.global&&(t[u]=d))}if(a&&c){const u=t;for(const C in a.options)u[C]=a.options[C];const d=w.filter(C=>C!==c),I=g.getSubcommandReporter?g.getSubcommandReporter(c):void 0,A=k(d,u,I);return{[c]:A,_:[]}}const i=E(w,{string:S,boolean:D,alias:b}),n={},o=i;n._=i._.map(u=>String(u)).filter(u=>u.length>0),delete o._;for(const u in r){const d=r[u];if(d.type==="subcommand")continue;d.alias&&delete o[d.alias];let I=o[u];if(d.deprecates)for(const A of d.deprecates)o.hasOwnProperty(A)&&(I||(I=o[A],I&&g.onDeprecatedOption(A,d.deprecationMessage||(0,s.localize)(35,null,u))),delete o[A]);if(typeof I<"u"){if(d.type==="string[]"){if(Array.isArray(I)||(I=[I]),!d.allowEmptyValue){const A=I.filter(C=>C.length>0);A.length!==I.length&&(g.onEmptyValue(u),I=A.length>0?A:void 0)}}else d.type==="string"&&(Array.isArray(I)?(I=I.pop(),g.onMultipleValues(u,I)):!I&&!d.allowEmptyValue&&(g.onEmptyValue(u),I=void 0));n[u]=I,d.deprecationMessage&&g.onDeprecatedOption(u,d.deprecationMessage)}delete o[u]}for(const u in o)g.onUnknownOption(u);return n}e.parseArgs=k;function h(w,r){let g="";return r.args&&(Array.isArray(r.args)?g=` <${r.args.join("> <")}>`:g=` <${r.args}>`),r.alias?`-${r.alias} --${w}${g}`:`--${w}${g}`}function l(w,r){const g=[];for(const c in w){const b=w[c],S=h(c,b);g.push([S,b.description])}return p(g,r)}e.formatOptions=l;function p(w,r){const c=w.reduce((D,t)=>Math.max(D,t[0].length),12)+2+1;if(r-c<25)return w.reduce((D,t)=>D.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const b=r-c-1,S=[];for(const D of w){const t=D[0],a=v(D[1],b),i=m(c-t.length-2);S.push("  "+t+i+a[0]);for(let n=1;n<a.length;n++)S.push(m(c)+a[n])}return S}function m(w){return" ".repeat(w)}function v(w,r){const g=[];for(;w.length;){const c=w.length<r?w.length:w.lastIndexOf(" ",r),b=w.slice(0,c).trim();w=w.slice(c),g.push(b)}return g}function f(w,r,g,c,b){const S=process.stdout.isTTY&&process.stdout.columns||80,D=b?.noInputFiles!==!0?`[${(0,s.localize)(36,null)}...]`:"",t=[`${w} ${g}`];t.push(""),t.push(`${(0,s.localize)(37,null)}: ${r} [${(0,s.localize)(38,null)}]${D}`),t.push(""),b?.noPipe!==!0&&(M.isWindows?t.push((0,s.localize)(39,null,r)):t.push((0,s.localize)(40,null,r)),t.push(""));const a={},i=[];for(const n in c){const o=c[n];if(o.type==="subcommand")o.description&&i.push({command:n,description:o.description});else if(o.description&&o.cat){let u=a[o.cat];u||(a[o.cat]=u={}),u[n]=o}}for(const n in a){const o=n,u=a[o];u&&(t.push(L[o]),t.push(...l(u,S)),t.push(""))}return i.length&&(t.push((0,s.localize)(41,null)),t.push(...p(i.map(n=>[n.command,n.description]),S)),t.push("")),t.join(`
`)}e.buildHelpMessage=f;function y(w,r){return`${w||(0,s.localize)(42,null)}
${r||(0,s.localize)(43,null)}
${process.arch}`}e.buildVersionMessage=y}),define(te[194],ie([0,1,70,192,107]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class L extends M.ExtensionHostDebugBroadcastChannel{constructor(k){super(),this.f=k}call(k,h,l){return h==="openExtensionDevelopmentHostWindow"?this.g(l[0],l[1]):super.call(k,h,l)}async g(k,h){const l=(0,s.parseArgs)(k,s.OPTIONS);l.debugRenderer=h;const p=l.extensionDevelopmentPath;if(!p)return{success:!1};const[m]=await this.f.openExtensionDevelopmentHostWindow(p,{context:5,cli:l,forceProfile:l.profile,forceTempProfile:l["profile-temp"]});if(!h)return{success:!0};const v=m.win;if(!v)return{success:!0};const f=v.webContents.debugger;let y=f.isAttached()?1/0:0;const w=(0,E.createServer)(r=>{y++===0&&f.attach();let g=!1;const c=D=>{g||r.write(JSON.stringify(D)+"\0")},b=(D,t,a,i)=>c({method:t,params:a,sessionId:i});v.on("close",()=>{f.removeListener("message",b),r.end(),g=!0}),f.addListener("message",b);let S=Buffer.alloc(0);r.on("data",D=>{S=Buffer.concat([S,D]);for(let t=S.indexOf(0);t!==-1;t=S.indexOf(0)){let a;try{const i=S.slice(0,t).toString("utf8");S=S.slice(t+1),a=JSON.parse(i)}catch(i){console.error("error reading cdp line",i)}f.sendCommand(a.method,a.params,a.sessionId).then(i=>c({id:a.id,sessionId:a.sessionId,result:i})).catch(i=>c({id:a.id,sessionId:a.sessionId,error:{code:0,message:i.message}}))}}),r.on("error",D=>{console.error("error on cdp pipe:",D)}),r.on("close",()=>{g=!0,--y===0&&f.detach()})});return await new Promise(r=>w.listen(0,r)),v.on("close",()=>w.close()),{rendererDebugPort:w.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=L}),define(te[62],ie([0,1,293,165,107]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function L(m,v){const f=(b,S)=>{console.warn((0,M.localize)(0,null,b,S))},y=b=>{console.warn((0,M.localize)(1,null,b))},w=(b,S)=>{console.warn((0,M.localize)(2,null,b,S))},r=b=>({onUnknownOption:S=>{b!=="tunnel"&&console.warn((0,M.localize)(3,null,S,b))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:b!=="tunnel"?r:void 0}),g={onUnknownOption:b=>{console.warn((0,M.localize)(4,null,b))},onMultipleValues:f,onEmptyValue:y,onDeprecatedOption:w,getSubcommandReporter:r},c=(0,s.parseArgs)(m,s.OPTIONS,v?g:void 0);return c.goto&&c._.forEach(b=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(b),(0,M.localize)(5,null))),c}function R(m){const v=m.findIndex(f=>!/^-/.test(f));if(v>-1)return[...m.slice(0,v),...m.slice(v+1)]}function k(m){let[,...v]=m;process.env.VSCODE_DEV&&(v=R(v)||[]);const f=!p(process.env);return L(v,f)}e.parseMainProcessArgv=k;function h(m){let[,,...v]=m;return process.env.VSCODE_DEV&&(v=R(v)||[]),L(v,!0)}e.parseCLIProcessArgv=h;function l(m,...v){const f=m.indexOf("--");return f===-1?m.push(...v):m.splice(f,0,...v),m}e.addArg=l;function p(m){return m.VSCODE_CLI==="1"}e.isLaunchedFromCli=p}),function(){"use strict";function x(e,E,M){function s(R,k){const h=L(R,k),l=[h];return e.isAbsolute(h)||l.unshift(M),e.resolve(...l)}function L(R,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const h=process.env.VSCODE_PORTABLE;if(h)return e.join(h,"user-data");let l=process.env.VSCODE_APPDATA;if(l)return e.join(l,k);const p=R["user-data-dir"];if(p)return p;switch(process.platform){case"win32":if(l=process.env.APPDATA,!l){const m=process.env.USERPROFILE;if(typeof m!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");l=e.join(m,"AppData","Roaming")}break;case"darwin":l=e.join(E.homedir(),"Library","Application Support");break;case"linux":l=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(l,k)}return{getUserDataPath:s}}if(typeof define=="function")define(te[195],ie([196,26,36]),function(e,E,M){return x(e,E,M.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=x(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(te[108],ie([0,1,26,193,195]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class L extends M.AbstractNativeEnvironmentService{constructor(l,p){super(l,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,s.getUserDataPath)(l,p.nameShort)},p)}}e.NativeEnvironmentService=L;function R(h,l){return(0,M.parseDebugParams)(h["inspect-ptyhost"],h["inspect-brk-ptyhost"],5877,l,h.extensionEnvironment)}e.parsePtyHostDebugPort=R;function k(h,l){return(0,M.parseDebugParams)(h["inspect-sharedprocess"],h["inspect-brk-sharedprocess"],5879,l,h.extensionEnvironment)}e.parseSharedProcessDebugPort=k}),define(te[197],ie([0,1,41,26,32]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFileSync=void 0;function L(R){const k=(0,s.randomPath)((0,M.tmpdir)());try{return(0,E.writeFileSync)(k,""),R&&console.log(`Marker file for --wait created: ${k}`),k}catch(h){R&&console.error(`Failed to create marker file for --wait: ${h}`);return}}e.createWaitMarkerFileSync=L}),define(te[198],ie([0,1,11,167]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function s(R,k,h){try{L(R,k,h)}catch(l){console.error(l?.message??l)}return R}e.localizeManifest=s;function L(R,k,h){const l=(p,m,v)=>{const f=p[m];if((0,E.isString)(f)){const y=f,w=y.length;if(w>1&&y[0]==="%"&&y[w-1]==="%"){const r=y.substr(1,w-2);let g=k[r];g===void 0&&h&&(g=h[r]);const c=typeof g=="string"?g:g?.message,b=h?.[r],S=typeof b=="string"?b:b?.message;if(!c){S||console.warn(`[${R.name}]: ${(0,M.localize)(0,null,r)}`);return}if(v&&(m==="title"||m==="category")&&S&&S!==c){const D={value:c,original:S};p[m]=D}else p[m]=c}}else if((0,E.isObject)(f))for(const y in f)f.hasOwnProperty(y)&&(y==="commands"?l(f,y,!0):l(f,y,v));else if(Array.isArray(f))for(let y=0;y<f.length;y++)l(f,y,v)};for(const p in R)R.hasOwnProperty(p)&&l(R,p)}}),define(te[199],ie([0,1,18,72,169,200]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function h(g){return g=g.trim(),g==="*"||R.test(g)}e.isValidVersionStr=h;function l(g){if(!h(g))return null;if(g=g.trim(),g==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const c=g.match(R);return c?{hasCaret:c[1]==="^",hasGreaterEquals:c[1]===">=",majorBase:c[2]==="x"?0:parseInt(c[2],10),majorMustEqual:c[2]!=="x",minorBase:c[4]==="x"?0:parseInt(c[4],10),minorMustEqual:c[4]!=="x",patchBase:c[6]==="x"?0:parseInt(c[6],10),patchMustEqual:c[6]!=="x",preRelease:c[8]||null}:null}e.parseVersion=l;function p(g){if(!g)return null;const c=g.majorBase,b=g.majorMustEqual,S=g.minorBase;let D=g.minorMustEqual;const t=g.patchBase;let a=g.patchMustEqual;g.hasCaret&&(c===0||(D=!1),a=!1);let i=0;if(g.preRelease){const n=k.exec(g.preRelease);if(n){const[,o,u,d]=n;i=Date.UTC(Number(o),Number(u)-1,Number(d))}}return{majorBase:c,majorMustEqual:b,minorBase:S,minorMustEqual:D,patchBase:t,patchMustEqual:a,isMinimum:g.hasGreaterEquals,notBefore:i}}e.normalizeVersion=p;function m(g,c,b){let S;typeof g=="string"?S=p(l(g)):S=g;let D;c instanceof Date?D=c.getTime():typeof c=="string"&&(D=new Date(c).getTime());let t;if(typeof b=="string"?t=p(l(b)):t=b,!S||!t)return!1;const a=S.majorBase,i=S.minorBase,n=S.patchBase;let o=t.majorBase,u=t.minorBase,d=t.patchBase;const I=t.notBefore;let A=t.majorMustEqual,C=t.minorMustEqual,T=t.patchMustEqual;return t.isMinimum?a>o?!0:a<o?!1:i>u?!0:i<u||D&&D<I?!1:n>=d:(a===1&&o===0&&(!A||!C||!T)&&(o=1,u=0,d=0,A=!0,C=!1,T=!1),a<o?!1:a>o?!A:i<u?!1:i>u?!C:n<d?!1:n>d?!T:!(D&&D<I))}e.isValidVersion=m;function v(g,c,b,S,D){const t=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return t.push([M.default.Error,s.localize(0,null)]),t;if(typeof S.name!="string")return t.push([M.default.Error,s.localize(1,null,"name")]),t;if(typeof S.version!="string")return t.push([M.default.Error,s.localize(2,null,"version")]),t;if(!S.engines)return t.push([M.default.Error,s.localize(3,null,"engines")]),t;if(typeof S.engines.vscode!="string")return t.push([M.default.Error,s.localize(4,null,"engines.vscode")]),t;if(typeof S.extensionDependencies<"u"&&!r(S.extensionDependencies))return t.push([M.default.Error,s.localize(5,null,"extensionDependencies")]),t;if(typeof S.activationEvents<"u"){if(!r(S.activationEvents))return t.push([M.default.Error,s.localize(6,null,"activationEvents")]),t;if(typeof S.main>"u"&&typeof S.browser>"u")return t.push([M.default.Error,s.localize(7,null,"activationEvents","main","browser")]),t}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&t.push([M.default.Warning,s.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return t.push([M.default.Error,s.localize(9,null,"main")]),t;{const n=(0,E.joinPath)(b,S.main);(0,E.isEqualOrParent)(n,b)||t.push([M.default.Warning,s.localize(10,null,n.path,b.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return t.push([M.default.Error,s.localize(11,null,"browser")]),t;{const n=(0,E.joinPath)(b,S.browser);(0,E.isEqualOrParent)(n,b)||t.push([M.default.Warning,s.localize(12,null,n.path,b.path)])}}if(!L.valid(S.version))return t.push([M.default.Error,s.localize(13,null)]),t;const a=[];if(!f(g,c,S,D,a))for(const n of a)t.push([M.default.Error,n]);return t}e.validateExtensionManifest=v;function f(g,c,b,S,D){return S||typeof b.main>"u"&&typeof b.browser>"u"?!0:w(g,c,b.engines.vscode,D)}e.isValidExtensionVersion=f;function y(g,c,b){return g==="*"||w(c,b,g)}e.isEngineValid=y;function w(g,c,b,S=[]){const D=p(l(b));if(!D)return S.push(s.localize(14,null,b)),!1;if(D.majorBase===0){if(!D.majorMustEqual||!D.minorMustEqual)return S.push(s.localize(15,null,b)),!1}else if(!D.majorMustEqual)return S.push(s.localize(16,null,b)),!1;return m(g,c,D)?!0:(S.push(s.localize(17,null,g,b)),!1)}function r(g){if(!Array.isArray(g))return!1;for(let c=0,b=g.length;c<b;c++)if(typeof g[c]!="string")return!1;return!0}}),define(te[201],ie([0,1,17,31]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function s(L,R,k){let h=k&&k.get("storage.serviceMachineId",-1)||null;if(h)return h;try{const p=(await R.readFile(L.serviceMachineIdResource)).value.toString();h=(0,M.isUUID)(p)?p:null}catch{h=null}if(!h){h=(0,M.generateUuid)();try{await R.writeFile(L.serviceMachineIdResource,E.VSBuffer.fromString(h))}catch{}}return k?.store("storage.serviceMachineId",h,-1,1),h}e.getServiceMachineId=s}),define(te[73],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(s,L=[],R=!1){this.ctor=s,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=E}),define(te[202],ie([0,1,73]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const M=[];var s;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(s||(e.InstantiationType=s={}));function L(k,h,l){h instanceof E.SyncDescriptor||(h=new E.SyncDescriptor(h,[],!!l)),M.push([k,h])}e.registerSingleton=L;function R(){return M}e.getSingletonServiceDescriptors=R}),define(te[203],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class M{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const k=this.lookupOrInsertNode(L),h=this.lookupOrInsertNode(R);k.outgoing.set(h.key,h),h.incoming.set(k.key,k)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const k of this.a.values())k.outgoing.delete(R),k.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let k=this.a.get(R);return k||(k=new E(R,L),this.a.set(R,k)),k}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,k]of this.a)L.push(`${R}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const k=new Set([L]),h=this.c(R,k);if(h)return h}}c(L,R){for(const[k,h]of L.outgoing){if(R.has(k))return[...R,k].join(" -> ");R.add(k);const l=this.c(h,R);if(l)return l;R.delete(k)}}}e.Graph=M}),define(te[6],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function k(h){return h[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=k})(E||(e._util=E={})),e.IInstantiationService=s("instantiationService");function M(R,k,h){k[E.DI_TARGET]===k?k[E.DI_DEPENDENCIES].push({id:R,index:h}):(k[E.DI_DEPENDENCIES]=[{id:R,index:h}],k[E.DI_TARGET]=k)}function s(R){if(E.serviceIds.has(R))return E.serviceIds.get(R);const k=function(h,l,p){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(k,h,p)};return k.toString=()=>R,E.serviceIds.set(R,k),k}e.createDecorator=s;function L(R){return R}e.refineServiceDecorator=L}),define(te[63],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBackupMainService=void 0,e.IBackupMainService=(0,E.createDecorator)("backupMainService")}),define(te[19],ie([0,1,11,8,6]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,s.createDecorator)("configurationService");function L(r){return r&&typeof r=="object"&&(!r.overrideIdentifier||typeof r.overrideIdentifier=="string")&&(!r.resource||r.resource instanceof M.URI)}e.isConfigurationOverrides=L;function R(r){return r&&typeof r=="object"&&(!r.overrideIdentifiers||Array.isArray(r.overrideIdentifiers))&&!r.overrideIdentifier&&(!r.resource||r.resource instanceof M.URI)}e.isConfigurationUpdateOverrides=R;var k;(function(r){r[r.APPLICATION=1]="APPLICATION",r[r.USER=2]="USER",r[r.USER_LOCAL=3]="USER_LOCAL",r[r.USER_REMOTE=4]="USER_REMOTE",r[r.WORKSPACE=5]="WORKSPACE",r[r.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",r[r.DEFAULT=7]="DEFAULT",r[r.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function h(r){switch(r){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=h;function l(r,g){const c=Object.create(null);for(const b in r)p(c,b,r[b],g);return c}e.toValuesTree=l;function p(r,g,c,b){const S=g.split("."),D=S.pop();let t=r;for(let a=0;a<S.length;a++){const i=S[a];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:b(`Ignoring ${g} as ${S.slice(0,a+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[D]=c}catch{b(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(t)}`)}else b(`Ignoring ${g} as ${S.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=p;function m(r,g){const c=g.split(".");v(r,c)}e.removeFromValueTree=m;function v(r,g){const c=g.shift();if(g.length===0){delete r[c];return}if(Object.keys(r).indexOf(c)!==-1){const b=r[c];typeof b=="object"&&!Array.isArray(b)&&(v(b,g),Object.keys(b).length===0&&delete r[c])}}function f(r,g,c){function b(t,a){let i=t;for(const n of a){if(typeof i!="object"||i===null)return;i=i[n]}return i}const S=g.split("."),D=b(r,S);return typeof D>"u"?c:D}e.getConfigurationValue=f;function y(r,g,c){Object.keys(g).forEach(b=>{b!=="__proto__"&&(b in r?E.isObject(r[b])&&E.isObject(g[b])?y(r[b],g[b],c):c&&(r[b]=g[b]):r[b]=g[b])})}e.merge=y;function w(r){return r.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=w}),define(te[204],ie([0,1,3,27,191,6,160,13]),function(x,e,E,M,s,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const h=new Map;h.set("false",!1),h.set("true",!0),h.set("isMac",E.isMacintosh),h.set("isLinux",E.isLinux),h.set("isWindows",E.isWindows),h.set("isWeb",E.isWeb),h.set("isMacNative",E.isMacintosh&&!E.isWeb),h.set("isEdge",E.isEdge),h.set("isFirefox",E.isFirefox),h.set("isChrome",E.isChrome),h.set("isSafari",E.isSafari);function l(O,P){if(h.get(O)!==void 0)throw(0,k.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");h.set(O,P)}e.setConstant=l;const p=Object.prototype.hasOwnProperty;var m;(function(O){O[O.False=0]="False",O[O.True=1]="True",O[O.Defined=2]="Defined",O[O.Not=3]="Not",O[O.Equals=4]="Equals",O[O.NotEquals=5]="NotEquals",O[O.And=6]="And",O[O.Regex=7]="Regex",O[O.NotRegex=8]="NotRegex",O[O.Or=9]="Or",O[O.In=10]="In",O[O.NotIn=11]="NotIn",O[O.Greater=12]="Greater",O[O.GreaterEquals=13]="GreaterEquals",O[O.Smaller=14]="Smaller",O[O.SmallerEquals=15]="SmallerEquals"})(m||(e.ContextKeyExprType=m={}));const v={regexParsingWithErrorRecovery:!0},f=(0,R.localize)(0,null),y=(0,R.localize)(1,null),w=(0,R.localize)(2,null),r=(0,R.localize)(3,null),g=(0,R.localize)(4,null),c=(0,R.localize)(5,null),b=(0,R.localize)(6,null),S=(0,R.localize)(7,null);class D{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(P=v){this.k=P,this.d=new s.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(P){if(P===""){this.h.push({message:f,offset:0,lexeme:"",additionalInfo:y});return}this.f=this.d.reset(P).scan(),this.g=0,this.h=[];try{const F=this.l();if(!this.E()){const N=this.D(),j=N.type===17?c:void 0;throw this.h.push({message:g,offset:N.offset,lexeme:s.Scanner.getLexeme(N),additionalInfo:j}),D.c}return F}catch(F){if(F!==D.c)throw F;return}}l(){return this.m()}m(){const P=[this.o()];for(;this.y(16);){const F=this.o();P.push(F)}return P.length===1?P[0]:t.or(...P)}o(){const P=[this.s()];for(;this.y(15);){const F=this.s();P.push(F)}return P.length===1?P[0]:t.and(...P)}s(){if(this.y(2)){const P=this.D();switch(P.type){case 11:return this.z(),o.INSTANCE;case 12:return this.z(),u.INSTANCE;case 0:{this.z();const F=this.l();return this.A(1,r),F?.negate()}case 17:return this.z(),W.create(P.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",P)}}return this.t()}t(){const P=this.D();switch(P.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const F=this.l();return this.A(1,r),F}case 17:{const F=P.lexeme;if(this.z(),this.y(9)){const j=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),j.type!==10)throw this.B("REGEX",j);const U=j.lexeme,V=U.lastIndexOf("/"),G=V===U.length-1?void 0:this.w(U.substring(V+1));let re;try{re=new RegExp(U.substring(1,V),G)}catch{throw this.B("REGEX",j)}return ue.create(F,re)}switch(j.type){case 10:case 19:{const U=[j.lexeme];this.z();let V=this.D(),G=0;for(let Ae=0;Ae<j.lexeme.length;Ae++)j.lexeme.charCodeAt(Ae)===40?G++:j.lexeme.charCodeAt(Ae)===41&&G--;for(;!this.E()&&V.type!==15&&V.type!==16;){switch(V.type){case 0:G++;break;case 1:G--;break;case 10:case 18:for(let Ae=0;Ae<V.lexeme.length;Ae++)V.lexeme.charCodeAt(Ae)===40?G++:j.lexeme.charCodeAt(Ae)===41&&G--}if(G<0)break;U.push(s.Scanner.getLexeme(V)),this.z(),V=this.D()}const re=U.join(""),ae=re.lastIndexOf("/"),ye=ae===re.length-1?void 0:this.w(re.substring(ae+1));let Ce;try{Ce=new RegExp(re.substring(1,ae),ye)}catch{throw this.B("REGEX",j)}return t.regex(F,Ce)}case 18:{const U=j.lexeme;this.z();let V=null;if(!(0,M.isFalsyOrWhitespace)(U)){const G=U.indexOf("/"),re=U.lastIndexOf("/");if(G!==re&&G>=0){const ae=U.slice(G+1,re),ye=U[re+1]==="i"?"i":"";try{V=new RegExp(ae,ye)}catch{throw this.B("REGEX",j)}}}if(V===null)throw this.B("REGEX",j);return ue.create(F,V)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,w);const j=this.u();return t.notIn(F,j)}switch(this.D().type){case 3:{this.z();const j=this.u();if(this.x().type===18)return t.equals(F,j);switch(j){case"true":return t.has(F);case"false":return t.not(F);default:return t.equals(F,j)}}case 4:{this.z();const j=this.u();if(this.x().type===18)return t.notEquals(F,j);switch(j){case"true":return t.not(F);case"false":return t.has(F);default:return t.notEquals(F,j)}}case 5:return this.z(),ne.create(F,this.u());case 6:return this.z(),se.create(F,this.u());case 7:return this.z(),H.create(F,this.u());case 8:return this.z(),Z.create(F,this.u());case 13:return this.z(),t.in(F,this.u());default:return t.has(F)}}case 20:throw this.h.push({message:b,offset:P.offset,lexeme:"",additionalInfo:S}),D.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const P=this.D();switch(P.type){case 17:case 18:return this.z(),P.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(P){return P.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(P){return this.C(P)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(P,F){if(this.C(P))return this.z();throw this.B(F,this.D())}B(P,F,N){const j=(0,R.localize)(8,null,P,s.Scanner.getLexeme(F)),U=F.offset,V=s.Scanner.getLexeme(F);return this.h.push({message:j,offset:U,lexeme:V,additionalInfo:N}),D.c}C(P){return this.D().type===P}D(){return this.f[this.g]}E(){return this.D().type===20}}e.Parser=D,D.c=new Error;class t{static false(){return o.INSTANCE}static true(){return u.INSTANCE}static has(P){return d.create(P)}static equals(P,F){return I.create(P,F)}static notEquals(P,F){return T.create(P,F)}static regex(P,F){return ue.create(P,F)}static in(P,F){return A.create(P,F)}static notIn(P,F){return C.create(P,F)}static not(P){return W.create(P)}static and(...P){return q.create(P,null,!0)}static or(...P){return B.create(P,null,!0)}static greater(P,F){return H.create(P,F)}static greaterEquals(P,F){return Z.create(P,F)}static smaller(P,F){return ne.create(P,F)}static smallerEquals(P,F){return se.create(P,F)}static deserialize(P){return P==null?void 0:this.c.parse(P)}}e.ContextKeyExpr=t,t.c=new D({regexParsingWithErrorRecovery:!1});function a(O){const P=new D({regexParsingWithErrorRecovery:!1});return O.map(F=>(P.parse(F),P.lexingErrors.length>0?P.lexingErrors.map(N=>({errorMessage:N.additionalInfo?(0,R.localize)(9,null,N.additionalInfo):(0,R.localize)(10,null),offset:N.offset,length:N.lexeme.length})):P.parsingErrors.length>0?P.parsingErrors.map(N=>({errorMessage:N.additionalInfo?`${N.message}. ${N.additionalInfo}`:N.message,offset:N.offset,length:N.lexeme.length})):[]))}e.validateWhenClauses=a;function i(O,P){const F=O?O.substituteConstants():void 0,N=P?P.substituteConstants():void 0;return!F&&!N?!0:!F||!N?!1:F.equals(N)}e.expressionsAreEqualWithConstantSubstitution=i;function n(O,P){return O.cmp(P)}class o{constructor(){this.type=0}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!1}serialize(){return"false"}keys(){return[]}map(P){return this}negate(){return u.INSTANCE}}e.ContextKeyFalseExpr=o,o.INSTANCE=new o;class u{constructor(){this.type=1}cmp(P){return this.type-P.type}equals(P){return P.type===this.type}substituteConstants(){return this}evaluate(P){return!0}serialize(){return"true"}keys(){return[]}map(P){return this}negate(){return o.INSTANCE}}e.ContextKeyTrueExpr=u,u.INSTANCE=new u;class d{static create(P,F=null){const N=h.get(P);return typeof N=="boolean"?N?u.INSTANCE:o.INSTANCE:new d(P,F)}constructor(P,F){this.key=P,this.c=F,this.type=2}cmp(P){return P.type!==this.type?this.type-P.type:K(this.key,P.key)}equals(P){return P.type===this.type?this.key===P.key:!1}substituteConstants(){const P=h.get(this.key);return typeof P=="boolean"?P?u.INSTANCE:o.INSTANCE:this}evaluate(P){return!!P.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(P){return P.mapDefined(this.key)}negate(){return this.c||(this.c=W.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=d;class I{static create(P,F,N=null){if(typeof F=="boolean")return F?d.create(P,N):W.create(P,N);const j=h.get(P);return typeof j=="boolean"?F===(j?"true":"false")?u.INSTANCE:o.INSTANCE:new I(P,F,N)}constructor(P,F,N){this.c=P,this.d=F,this.f=N,this.type=4}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=h.get(this.c);if(typeof P=="boolean"){const F=P?"true":"false";return this.d===F?u.INSTANCE:o.INSTANCE}return this}evaluate(P){return P.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(P){return P.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=T.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=I;class A{static create(P,F){return new A(P,F)}constructor(P,F){this.d=P,this.f=F,this.type=10,this.c=null}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.d,this.f,P.d,P.f)}equals(P){return P.type===this.type?this.d===P.d&&this.f===P.f:!1}substituteConstants(){return this}evaluate(P){const F=P.getValue(this.f),N=P.getValue(this.d);return Array.isArray(F)?F.includes(N):typeof N=="string"&&typeof F=="object"&&F!==null?p.call(F,N):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(P){return P.mapIn(this.d,this.f)}negate(){return this.c||(this.c=C.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=A;class C{static create(P,F){return new C(P,F)}constructor(P,F){this.d=P,this.f=F,this.type=11,this.c=A.create(P,F)}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(P){return P.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=C;class T{static create(P,F,N=null){if(typeof F=="boolean")return F?W.create(P,N):d.create(P,N);const j=h.get(P);return typeof j=="boolean"?F===(j?"true":"false")?o.INSTANCE:u.INSTANCE:new T(P,F,N)}constructor(P,F,N){this.c=P,this.d=F,this.f=N,this.type=5}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){const P=h.get(this.c);if(typeof P=="boolean"){const F=P?"true":"false";return this.d===F?o.INSTANCE:u.INSTANCE}return this}evaluate(P){return P.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(P){return P.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=I.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=T;class W{static create(P,F=null){const N=h.get(P);return typeof N=="boolean"?N?o.INSTANCE:u.INSTANCE:new W(P,F)}constructor(P,F){this.c=P,this.d=F,this.type=3}cmp(P){return P.type!==this.type?this.type-P.type:K(this.c,P.c)}equals(P){return P.type===this.type?this.c===P.c:!1}substituteConstants(){const P=h.get(this.c);return typeof P=="boolean"?P?o.INSTANCE:u.INSTANCE:this}evaluate(P){return!P.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(P){return P.mapNot(this.c)}negate(){return this.d||(this.d=d.create(this.c,this)),this.d}}e.ContextKeyNotExpr=W;function $(O,P){if(typeof O=="string"){const F=parseFloat(O);isNaN(F)||(O=F)}return typeof O=="string"||typeof O=="number"?P(O):o.INSTANCE}class H{static create(P,F,N=null){return $(F,j=>new H(P,j,N))}constructor(P,F,N){this.c=P,this.d=F,this.f=N,this.type=12}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=se.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=H;class Z{static create(P,F,N=null){return $(F,j=>new Z(P,j,N))}constructor(P,F,N){this.c=P,this.d=F,this.f=N,this.type=13}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(P){return P.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=Z;class ne{static create(P,F,N=null){return $(F,j=>new ne(P,j,N))}constructor(P,F,N){this.c=P,this.d=F,this.f=N,this.type=14}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=Z.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=ne;class se{static create(P,F,N=null){return $(F,j=>new se(P,j,N))}constructor(P,F,N){this.c=P,this.d=F,this.f=N,this.type=15}cmp(P){return P.type!==this.type?this.type-P.type:ee(this.c,this.d,P.c,P.d)}equals(P){return P.type===this.type?this.c===P.c&&this.d===P.d:!1}substituteConstants(){return this}evaluate(P){return typeof this.d=="string"?!1:parseFloat(P.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(P){return P.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=se;class ue{static create(P,F){return new ue(P,F)}constructor(P,F){this.d=P,this.f=F,this.type=7,this.c=null}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.d<P.d)return-1;if(this.d>P.d)return 1;const F=this.f?this.f.source:"",N=P.f?P.f.source:"";return F<N?-1:F>N?1:0}equals(P){if(P.type===this.type){const F=this.f?this.f.source:"",N=P.f?P.f.source:"";return this.d===P.d&&F===N}return!1}substituteConstants(){return this}evaluate(P){const F=P.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const P=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${P}`}keys(){return[this.d]}map(P){return P.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.ContextKeyRegexExpr=ue;class ce{static create(P){return new ce(P)}constructor(P){this.c=P,this.type=8}cmp(P){return P.type!==this.type?this.type-P.type:this.c.cmp(P.c)}equals(P){return P.type===this.type?this.c.equals(P.c):!1}substituteConstants(){return this}evaluate(P){return!this.c.evaluate(P)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(P){return new ce(this.c.map(P))}negate(){return this.c}}e.ContextKeyNotRegexExpr=ce;function X(O){let P=null;for(let F=0,N=O.length;F<N;F++){const j=O[F].substituteConstants();if(O[F]!==j&&P===null){P=[];for(let U=0;U<F;U++)P[U]=O[U]}P!==null&&(P[F]=j)}return P===null?O:P}class q{static create(P,F,N){return q.d(P,F,N)}constructor(P,F){this.expr=P,this.c=F,this.type=6}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const j=n(this.expr[F],P.expr[F]);if(j!==0)return j}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(P.expr[F]))return!1;return!0}return!1}substituteConstants(){const P=X(this.expr);return P===this.expr?this:q.create(P,this.c,!1)}evaluate(P){for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].evaluate(P))return!1;return!0}static d(P,F,N){const j=[];let U=!1;for(const V of P)if(V){if(V.type===1){U=!0;continue}if(V.type===0)return o.INSTANCE;if(V.type===6){j.push(...V.expr);continue}j.push(V)}if(j.length===0&&U)return u.INSTANCE;if(j.length!==0){if(j.length===1)return j[0];j.sort(n);for(let V=1;V<j.length;V++)j[V-1].equals(j[V])&&(j.splice(V,1),V--);if(j.length===1)return j[0];for(;j.length>1;){const V=j[j.length-1];if(V.type!==9)break;j.pop();const G=j.pop(),re=j.length===0,ae=B.create(V.expr.map(ye=>q.create([ye,G],null,N)),null,re);ae&&(j.push(ae),j.sort(n))}if(j.length===1)return j[0];if(N){for(let V=0;V<j.length;V++)for(let G=V+1;G<j.length;G++)if(j[V].negate().equals(j[G]))return o.INSTANCE;if(j.length===1)return j[0]}return new q(j,F)}}serialize(){return this.expr.map(P=>P.serialize()).join(" && ")}keys(){const P=[];for(const F of this.expr)P.push(...F.keys());return P}map(P){return new q(this.expr.map(F=>F.map(P)),null)}negate(){if(!this.c){const P=[];for(const F of this.expr)P.push(F.negate());this.c=B.create(P,this,!0)}return this.c}}e.ContextKeyAndExpr=q;class B{static create(P,F,N){return B.d(P,F,N)}constructor(P,F){this.expr=P,this.c=F,this.type=9}cmp(P){if(P.type!==this.type)return this.type-P.type;if(this.expr.length<P.expr.length)return-1;if(this.expr.length>P.expr.length)return 1;for(let F=0,N=this.expr.length;F<N;F++){const j=n(this.expr[F],P.expr[F]);if(j!==0)return j}return 0}equals(P){if(P.type===this.type){if(this.expr.length!==P.expr.length)return!1;for(let F=0,N=this.expr.length;F<N;F++)if(!this.expr[F].equals(P.expr[F]))return!1;return!0}return!1}substituteConstants(){const P=X(this.expr);return P===this.expr?this:B.create(P,this.c,!1)}evaluate(P){for(let F=0,N=this.expr.length;F<N;F++)if(this.expr[F].evaluate(P))return!0;return!1}static d(P,F,N){let j=[],U=!1;if(P){for(let V=0,G=P.length;V<G;V++){const re=P[V];if(re){if(re.type===0){U=!0;continue}if(re.type===1)return u.INSTANCE;if(re.type===9){j=j.concat(re.expr);continue}j.push(re)}}if(j.length===0&&U)return o.INSTANCE;j.sort(n)}if(j.length!==0){if(j.length===1)return j[0];for(let V=1;V<j.length;V++)j[V-1].equals(j[V])&&(j.splice(V,1),V--);if(j.length===1)return j[0];if(N){for(let V=0;V<j.length;V++)for(let G=V+1;G<j.length;G++)if(j[V].negate().equals(j[G]))return u.INSTANCE;if(j.length===1)return j[0]}return new B(j,F)}}serialize(){return this.expr.map(P=>P.serialize()).join(" || ")}keys(){const P=[];for(const F of this.expr)P.push(...F.keys());return P}map(P){return new B(this.expr.map(F=>F.map(P)),null)}negate(){if(!this.c){const P=[];for(const F of this.expr)P.push(F.negate());for(;P.length>1;){const F=P.shift(),N=P.shift(),j=[];for(const U of Y(F))for(const V of Y(N))j.push(q.create([U,V],null,!1));P.unshift(B.create(j,null,!1))}this.c=B.create(P,this,!0)}return this.c}}e.ContextKeyOrExpr=B;class z extends d{static all(){return z.d.values()}constructor(P,F,N){super(P,null),this.f=F,typeof N=="object"?z.d.push({...N,key:P}):N!==!0&&z.d.push({key:P,description:N,type:F!=null?typeof F:void 0})}bindTo(P){return P.createKey(this.key,this.f)}getValue(P){return P.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(P){return I.create(this.key,P)}notEqualsTo(P){return T.create(this.key,P)}}e.RawContextKey=z,z.d=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService");function K(O,P){return O<P?-1:O>P?1:0}function ee(O,P,F,N){return O<F?-1:O>F?1:P<N?-1:P>N?1:0}function oe(O,P){if(O.type===0||P.type===1)return!0;if(O.type===9)return P.type===9?le(O.expr,P.expr):!1;if(P.type===9){for(const F of P.expr)if(oe(O,F))return!0;return!1}if(O.type===6){if(P.type===6)return le(P.expr,O.expr);for(const F of O.expr)if(oe(F,P))return!0;return!1}return O.equals(P)}e.implies=oe;function le(O,P){let F=0,N=0;for(;F<O.length&&N<P.length;){const j=O[F].cmp(P[N]);if(j<0)return!1;j===0&&F++,N++}return F===O.length}function Y(O){return O.type===9?O.expr:[O]}}),define(te[74],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class M{constructor(){this.a={}}async getPassword(L,R){return this.a[L]?.[R]??null}async setPassword(L,R,k){this.a[L]=this.a[L]??{},this.a[L][R]=k}async deletePassword(L,R){return this.a[L]?.[R]?(delete this.a[L][R],Object.keys(this.a[L]).length===0&&delete this.a[L],!0):!1}async findPassword(L){return JSON.stringify(this.a[L])??null}async findCredentials(L){const R=[];for(const k of Object.keys(this.a[L]||{}))R.push({account:k,password:this.a[L][k]});return R}async clear(){this.a={}}}e.InMemoryCredentialsProvider=M}),define(te[88],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function M(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=M;class s{async getPerformanceInfo(R,k){return{}}async getSystemInfo(R,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(R,k){return""}async getWorkspaceFileExtensions(R){return{extensions:[]}}async reportWorkspaceStats(R){}}e.NullDiagnosticsService=s}),define(te[89],ie([0,1,18,72,162,6,44,3,40]),function(x,e,E,M,s,L,R,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.massageMessageBoxOptions=e.getFileNamesMessage=e.ConfirmResult=e.IFileDialogService=e.AbstractDialogHandler=e.IDialogService=void 0,e.IDialogService=(0,L.createDecorator)("dialogService");var l;(function(w){w[w.Confirmation=1]="Confirmation",w[w.Prompt=2]="Prompt",w[w.Input=3]="Input"})(l||(l={}));class p{a(r){return this.d(r,l.Confirmation)}b(r){return this.d(r,l.Prompt)}c(r){return this.d(r,l.Input)}d(r,g){const c=[];switch(g){case l.Confirmation:{const b=r;b.primaryButton?c.push(b.primaryButton):c.push((0,s.localize)(0,null)),b.cancelButton?c.push(b.cancelButton):c.push((0,s.localize)(1,null));break}case l.Prompt:{const b=r;Array.isArray(b.buttons)&&b.buttons.length>0&&c.push(...b.buttons.map(S=>S.label)),b.cancelButton&&(b.cancelButton===!0?c.push((0,s.localize)(2,null)):typeof b.cancelButton=="string"?c.push(b.cancelButton):b.cancelButton.label?c.push(b.cancelButton.label):c.push((0,s.localize)(3,null))),c.length===0&&c.push((0,s.localize)(4,null));break}case l.Input:{const b=r;b.primaryButton?c.push(b.primaryButton):c.push((0,s.localize)(5,null)),b.cancelButton?c.push(b.cancelButton):c.push((0,s.localize)(6,null));break}}return c}e(r){if(typeof r=="string")return r;if(typeof r=="number")return r===M.default.Info?"info":r===M.default.Error?"error":r===M.default.Warning?"warning":"none"}async f(r,g,c){const b=[...r.buttons??[]];return r.cancelButton&&typeof r.cancelButton!="string"&&typeof r.cancelButton!="boolean"&&b.push(r.cancelButton),{result:await b[g]?.run({checkboxChecked:c}),checkboxChecked:c}}}e.AbstractDialogHandler=p,e.IFileDialogService=(0,L.createDecorator)("fileDialogService");var m;(function(w){w[w.SAVE=0]="SAVE",w[w.DONT_SAVE=1]="DONT_SAVE",w[w.CANCEL=2]="CANCEL"})(m||(e.ConfirmResult=m={}));const v=10;function f(w){const r=[];return r.push(...w.slice(0,v).map(g=>typeof g=="string"?g:(0,E.basename)(g))),w.length>v&&(w.length-v===1?r.push((0,s.localize)(7,null)):r.push((0,s.localize)(8,null,w.length-v))),r.push(""),r.join(`
`)}e.getFileNamesMessage=f;function y(w,r){const g=(0,h.deepClone)(w);let c=(g.buttons??[]).map(t=>(0,R.mnemonicButtonLabel)(t)),b=(w.buttons||[]).map((t,a)=>a),S=0,D=g.cancelId??c.length-1;if(c.length>1){const t=typeof D=="number"?c[D]:void 0;if(k.isLinux||k.isMacintosh){if(typeof t=="string"&&c.length>1&&D!==1){c.splice(D,1),c.splice(1,0,t);const a=b[D];b.splice(D,1),b.splice(1,0,a),D=1}k.isLinux&&c.length>1&&(c=c.reverse(),b=b.reverse(),S=c.length-1,typeof t=="string"&&(D=S-1))}else if(k.isWindows&&typeof t=="string"&&c.length>1&&D!==c.length-1){c.splice(D,1),c.push(t);const a=b[D];b.splice(D,1),b.push(a),D=c.length-1}}return g.buttons=c,g.defaultId=S,g.cancelId=D,g.noLink=!0,g.title=g.title||r.nameLong,{options:g,buttonIndeces:b}}e.massageMessageBoxOptions=y}),define(te[109],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(te[34],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(te[110],ie([0,1,166,6]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function s(c){switch(c){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=s;function L(c){switch(c){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function R(c,b){switch(c){case 3:return b==="x64"?"win32-x64":b==="ia32"?"win32-ia32":b==="arm64"?"win32-arm64":"unknown";case 2:return b==="x64"?"linux-x64":b==="arm64"?"linux-arm64":b==="arm"?"linux-armhf":"unknown";case"alpine":return b==="x64"?"alpine-x64":b==="arm64"?"alpine-arm64":"unknown";case 1:return b==="x64"?"darwin-x64":b==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function k(c,b){return b==="web"&&!c.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function h(c,b,S){return k(b,S)?!1:c==="undefined"||c==="universal"?!0:c==="unknown"?!1:c===S?!0:l(S).includes(c)}e.isTargetPlatformCompatible=h;function l(c){switch(c){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=l;function p(c){return c&&typeof c=="object"&&typeof c.id=="string"&&(!c.uuid||typeof c.uuid=="string")}e.isIExtensionIdentifier=p;var m;(function(c){c[c.NoneOrRelevance=0]="NoneOrRelevance",c[c.LastUpdatedDate=1]="LastUpdatedDate",c[c.Title=2]="Title",c[c.PublisherName=3]="PublisherName",c[c.InstallCount=4]="InstallCount",c[c.PublishedDate=10]="PublishedDate",c[c.AverageRating=6]="AverageRating",c[c.WeightedRating=12]="WeightedRating"})(m||(e.SortBy=m={}));var v;(function(c){c[c.Default=0]="Default",c[c.Ascending=1]="Ascending",c[c.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var f;(function(c){c.Install="install",c.Uninstall="uninstall"})(f||(e.StatisticType=f={}));var y;(function(c){c[c.None=1]="None",c[c.Install=2]="Install",c[c.Update=3]="Update",c[c.Migrate=4]="Migrate"})(y||(e.InstallOperation=y={})),e.IExtensionGalleryService=(0,M.createDecorator)("extensionGalleryService");var w;(function(c){c.Unsupported="Unsupported",c.Deprecated="Deprecated",c.Malicious="Malicious",c.Incompatible="Incompatible",c.IncompatiblePreRelease="IncompatiblePreRelease",c.IncompatibleTargetPlatform="IncompatibleTargetPlatform",c.ReleaseVersionNotFound="ReleaseVersionNotFound",c.Invalid="Invalid",c.Download="Download",c.Extract="Extract",c.Delete="Delete",c.Rename="Rename",c.CorruptZip="CorruptZip",c.IncompleteZip="IncompleteZip",c.Signature="Signature",c.Internal="Internal"})(w||(e.ExtensionManagementErrorCode=w={}));var r;(function(c){c.UnknownError="UnknownError",c.PackageIsInvalidZip="PackageIsInvalidZip",c.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(r||(e.ExtensionSignaturetErrorCode=r={}));class g extends Error{constructor(b,S){super(b),this.code=S,this.name=S}}e.ExtensionManagementError=g,e.IExtensionManagementService=(0,M.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,M.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,M.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,E.localize)(1,null),original:"Preferences"}}),define(te[205],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,E.createDecorator)("extensionUrlTrustService")}),define(te[206],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcExtensionHostStarterChannelName=e.IExtensionHostStarter=void 0,e.IExtensionHostStarter=(0,E.createDecorator)("extensionHostStarter"),e.ipcExtensionHostStarterChannelName="extensionHostStarter"}),define(te[111],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,E.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,E.createDecorator)("externalTerminal")}),define(te[207],ie([0,1,50,15,9,3,71,24,86,170,111]),function(x,e,E,M,s,L,R,k,h,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const m=l.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:f.getDefaultTerminalWindows(),linux:await w.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class f extends v{openTerminal(S,D){return this.spawnTerminal(E,S,h.getWindowsShell(),D)}spawnTerminal(S,D,t,a){const i=D.windowsExec||f.getDefaultTerminalWindows();a&&a[1]===":"&&(a=a[0].toUpperCase()+a.substr(1));const n=s.basename(i,".exe").toLowerCase();if(n==="cmder")return S.spawn(i,a?[a]:void 0),Promise.resolve(void 0);const o=["/c","start","/wait"];return i.indexOf(" ")>=0&&o.push('""'),o.push(i),n==="wt"&&o.push("-d ."),new Promise((u,d)=>{const I=r(process),A=S.spawn(t,o,{cwd:a,env:I});A.on("error",d),A.on("exit",()=>u())})}runInTerminal(S,D,t,a,i){const n="windowsExec"in i&&i.windowsExec?i.windowsExec:f.getDefaultTerminalWindows();return new Promise((o,u)=>{const d=`"${D} - ${m}"`,I=`""${t.join('" "')}" & pause"`,A=Object.assign({},r(process),a);Object.keys(A).filter(H=>A[H]===null).forEach(H=>delete A[H]);const C={cwd:D,env:A,windowsVerbatimArguments:!0};let T,W;s.basename(n,".exe")==="wt"?(T=n,W=["-d",".",f.b,"/c",I]):(T=f.b,W=["/c","start",d,"/wait",n,"/c",I]),E.spawn(T,W,C).on("error",H=>{u(g(H))}),o(void 0)})}static getDefaultTerminalWindows(){if(!f.d){const S=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");f.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${S?"Sysnative":"System32"}\\cmd.exe`}return f.d}}e.WindowsExternalTerminalService=f,f.b="cmd.exe";class y extends v{openTerminal(S,D){return this.spawnTerminal(E,S,D)}runInTerminal(S,D,t,a,i){const n=i.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((o,u)=>{if(n===p.DEFAULT_TERMINAL_OSX||n==="iTerm.app"){const d=n===p.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",A=[M.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${d}.scpt`).fsPath,"-t",S||m,"-w",D];for(const W of t)A.push("-a"),A.push(W);if(a){const W=Object.assign({},r(process),a);for(const $ in W){const H=W[$];H===null?(A.push("-u"),A.push($)):(A.push("-e"),A.push(`${$}=${H}`))}}let C="";const T=E.spawn(y.b,A);T.on("error",W=>{u(g(W))}),T.stderr.on("data",W=>{C+=W.toString()}),T.on("exit",W=>{if(W===0)o(void 0);else if(C){const $=C.split(`
`,1);u(new Error($[0]))}else u(new Error(l.localize(1,null,d,W)))})}else u(new Error(l.localize(2,null,n)))})}spawnTerminal(S,D,t){const a=D.osxExec||p.DEFAULT_TERMINAL_OSX;return new Promise((i,n)=>{const o=["-a",a];t&&o.push(t);const u=r(process),d=S.spawn("/usr/bin/open",o,{cwd:t,env:u});d.on("error",n),d.on("exit",()=>i())})}}e.MacExternalTerminalService=y,y.b="/usr/bin/osascript";class w extends v{openTerminal(S,D){return this.spawnTerminal(E,S,D)}runInTerminal(S,D,t,a,i){const n=i.linuxExec?Promise.resolve(i.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((o,u)=>{const d=[];n.then(I=>{I.indexOf("gnome-terminal")>=0?d.push("-x"):d.push("-e"),d.push("bash"),d.push("-c");const A=`${c(t)}; echo; read -p "${w.b}" -n1;`;d.push(`''${A}''`);const C=Object.assign({},r(process),a);Object.keys(C).filter(H=>C[H]===null).forEach(H=>delete C[H]);const T={cwd:D,env:C};let W="";const $=E.spawn(I,d,T);$.on("error",H=>{u(g(H))}),$.stderr.on("data",H=>{W+=H.toString()}),$.on("exit",H=>{if(H===0)o(void 0);else if(W){const Z=W.split(`
`,1);u(new Error(Z[0]))}else u(new Error(l.localize(4,null,I,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!w.d)if(!L.isLinux)w.d=Promise.resolve("xterm");else{const S=await k.Promises.exists("/etc/debian_version");w.d=new Promise(D=>{S?D("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?D("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?D("konsole"):process.env.COLORTERM?D(process.env.COLORTERM):process.env.TERM?D(process.env.TERM):D("xterm")})}return w.d}spawnTerminal(S,D,t){const a=D.linuxExec?Promise.resolve(D.linuxExec):w.getDefaultTerminalLinuxReady();return new Promise((i,n)=>{a.then(o=>{const u=r(process),d=S.spawn(o,[],{cwd:t,env:u});d.on("error",n),d.on("exit",()=>i())})})}}e.LinuxExternalTerminalService=w,w.b=l.localize(3,null);function r(b){const S={...b.env};return(0,R.sanitizeProcessEnvironment)(S),S}function g(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(l.localize(5,null,b.path)):b}function c(b){let S="";for(const D of b)D.indexOf(" ")>=0?S+='"'+D+'"':S+=D,S+=" ";return S}}),define(te[16],ie([0,1,61,9,27,11,8,172,6,3,15]),function(x,e,E,M,s,L,R,k,h,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,h.createDecorator)("fileService");function m(q){return q.create===!0}e.isFileOpenForWriteOptions=m;var v;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(v||(e.FileType=v={}));var f;(function(q){q[q.Readonly=1]="Readonly"})(f||(e.FilePermission=f={}));var y;(function(q){q[q.None=0]="None",q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock",q[q.FileAtomicRead=16384]="FileAtomicRead",q[q.FileClone=32768]="FileClone"})(y||(e.FileSystemProviderCapabilities=y={}));function w(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=w;function r(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=r;function g(q){return!!(q.capabilities&32768)}e.hasFileCloneCapability=g;function c(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function b(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=b;function S(q){return w(q)?!!(q.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var D;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsStorageQuota="EntryExceedsStorageQuota",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(D||(e.FileSystemProviderErrorCode=D={}));class t extends Error{static create(B,z){const K=new t(B.toString(),z);return n(K,z),K}constructor(B,z){super(B),this.code=z}}e.FileSystemProviderError=t;function a(q,B){return t.create(q,B)}e.createFileSystemProviderError=a;function i(q){return q||a((0,k.localize)(0,null),D.Unknown)}e.ensureFileSystemProviderError=i;function n(q,B){return q.name=B?`${B} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=n;function o(q){if(!q)return D.Unknown;if(q instanceof t)return q.code;const B=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!B)return D.Unknown;switch(B[1]){case D.FileExists:return D.FileExists;case D.FileIsADirectory:return D.FileIsADirectory;case D.FileNotADirectory:return D.FileNotADirectory;case D.FileNotFound:return D.FileNotFound;case D.FileTooLarge:return D.FileTooLarge;case D.FileWriteLocked:return D.FileWriteLocked;case D.NoPermissions:return D.NoPermissions;case D.Unavailable:return D.Unavailable}return D.Unknown}e.toFileSystemProviderErrorCode=o;function u(q){if(q instanceof W)return q.fileOperationResult;switch(o(q)){case D.FileNotFound:return 1;case D.FileIsADirectory:return 0;case D.FileNotADirectory:return 9;case D.FileWriteLocked:return 5;case D.NoPermissions:return 6;case D.FileExists:return 4;case D.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=u;var d;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY",q[q.WRITE=4]="WRITE"})(d||(e.FileOperation=d={}));class I{constructor(B,z,K){this.resource=B,this.operation=z,this.target=K}isOperation(B){return this.operation===B}}e.FileOperationEvent=I;var A;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(A||(e.FileChangeType=A={}));class C{constructor(B,z){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const K=new Map;for(const ee of B){const oe=K.get(ee.type);switch(oe?oe.push([ee.resource,ee]):K.set(ee.type,[[ee.resource,ee]]),ee.type){case 1:this.rawAdded.push(ee.resource);break;case 0:this.rawUpdated.push(ee.resource);break;case 2:this.rawDeleted.push(ee.resource);break}}for(const[ee,oe]of K)switch(ee){case 1:this.a=E.TernarySearchTree.forUris(()=>z),this.a.fill(oe);break;case 0:this.b=E.TernarySearchTree.forUris(()=>z),this.b.fill(oe);break;case 2:this.c=E.TernarySearchTree.forUris(()=>z),this.c.fill(oe);break}}contains(B,...z){return this.d(B,{includeChildren:!1},...z)}affects(B,...z){return this.d(B,{includeChildren:!0},...z)}d(B,z,...K){if(!B)return!1;const ee=K.length>0;return!!((!ee||K.includes(1))&&(this.a?.get(B)||z.includeChildren&&this.a?.findSuperstr(B))||(!ee||K.includes(0))&&(this.b?.get(B)||z.includeChildren&&this.b?.findSuperstr(B))||(!ee||K.includes(2))&&(this.c?.findSubstr(B)||z.includeChildren&&this.c?.findSuperstr(B)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=C;function T(q,B,z){return!q||!B||q===B||B.length>q.length?!1:(B.charAt(B.length-1)!==M.sep&&(B+=M.sep),z?(0,s.startsWithIgnoreCase)(q,B):q.indexOf(B)===0)}e.isParent=T;class W extends Error{constructor(B,z,K){super(B),this.fileOperationResult=z,this.options=K}}e.FileOperationError=W;class $ extends W{constructor(B,z,K,ee){super(B,z,ee),this.fileOperationResult=z,this.size=K}}e.TooLargeFileOperationError=$;class H extends W{constructor(B,z,K){super(B,2,K),this.stat=z}}e.NotModifiedSinceFileOperationError=H;var Z;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(Z||(e.FileOperationResult=Z={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ne;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(ne||(e.FileKind=ne={})),e.ETAG_DISABLED="";function se(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=se;async function ue(q,B){if(!B.hasProvider(R.URI.from({scheme:q.scheme})))return new Promise(z=>{const K=B.onDidChangeFileSystemProviderRegistrations(ee=>{ee.scheme===q.scheme&&ee.added&&(K.dispose(),z())})})}e.whenProviderRegistered=ue;class ce{static formatSize(B){return(0,L.isNumber)(B)||(B=0),B<ce.KB?(0,k.localize)(1,null,B.toFixed(0)):B<ce.MB?(0,k.localize)(2,null,(B/ce.KB).toFixed(2)):B<ce.GB?(0,k.localize)(3,null,(B/ce.MB).toFixed(2)):B<ce.TB?(0,k.localize)(4,null,(B/ce.GB).toFixed(2)):(0,k.localize)(5,null,(B/ce.TB).toFixed(2))}}e.ByteSize=ce,ce.KB=1024,ce.MB=ce.KB*ce.KB,ce.GB=ce.MB*ce.KB,ce.TB=ce.GB*ce.KB;function X(q){const B=typeof q=="string"||q?.scheme===p.Schemas.vscodeRemote;return typeof q!="string"&&q?.scheme===p.Schemas.file?1024*ce.MB:B?10*ce.MB:l.isWeb?50*ce.MB:1024*ce.MB}e.getLargeFileConfirmationLimit=X}),define(te[208],ie([0,1,17,49,13,4,2,60,8,31,16]),function(x,e,E,M,s,L,R,k,h,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class m extends R.Disposable{constructor(f,y){super(),this.a=f,this.b=y,this.onDidChangeCapabilities=L.Event.None,this.f=this.B(new L.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new L.Emitter),this.onDidWatchError=this.g.event,this.h=(0,l.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(f){return this.a.call("stat",[f])}readdir(f){return this.a.call("readdir",[f])}async readFile(f,y){const{buffer:w}=await this.a.call("readFile",[f,y]);return w}readFileStream(f,y,w){const r=(0,k.newWriteableStream)(c=>E.VSBuffer.concat(c.map(b=>E.VSBuffer.wrap(b))).buffer),g=this.a.listen("readFileStream",[f,y])(c=>{if(c instanceof E.VSBuffer)r.write(c.buffer);else{if(c==="end")r.end();else{let b;if(c instanceof Error)b=c;else{const S=c;b=(0,p.createFileSystemProviderError)(S.message??(0,M.toErrorMessage)(S),S.code??p.FileSystemProviderErrorCode.Unknown)}r.error(b),r.end()}g.dispose()}});return w.onCancellationRequested(()=>{r.error((0,s.canceled)()),r.end(),g.dispose()}),r}writeFile(f,y,w){return this.a.call("writeFile",[f,E.VSBuffer.wrap(y),w])}open(f,y){return this.a.call("open",[f,y])}close(f){return this.a.call("close",[f])}async read(f,y,w,r,g){const[c,b]=await this.a.call("read",[f,y,g]);return w.set(c.buffer.slice(0,b),r),b}write(f,y,w,r,g){return this.a.call("write",[f,y,E.VSBuffer.wrap(w),r,g])}mkdir(f){return this.a.call("mkdir",[f])}delete(f,y){return this.a.call("delete",[f,y])}rename(f,y,w){return this.a.call("rename",[f,y,w])}copy(f,y,w){return this.a.call("copy",[f,y,w])}cloneFile(f,y){return this.a.call("cloneFile",[f,y])}i(){this.B(this.a.listen("fileChange",[this.h])(f=>{if(Array.isArray(f)){const y=f;this.f.fire(y.map(w=>({resource:h.URI.revive(w.resource),type:w.type})))}else{const y=f;this.g.fire(y)}}))}watch(f,y){const w=(0,l.generateUuid)();return this.a.call("watch",[this.h,w,f,y]),(0,R.toDisposable)(()=>this.a.call("unwatch",[this.h,w]))}}e.DiskFileSystemProviderClient=m}),define(te[112],ie([0,1,17,13,173,16]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function R(p,m,v,f,y,w){let r;try{await k(p,m,v,f,y,w)}catch(g){r=g}finally{r&&y.errorTransformer&&(r=y.errorTransformer(r)),typeof r<"u"&&v.error(r),v.end()}}e.readFileIntoStream=R;async function k(p,m,v,f,y,w){h(w);const r=await p.open(m,{create:!1});try{h(w);let g=0,c=0,b=y&&typeof y.length=="number"?y.length:void 0,S=E.VSBuffer.alloc(Math.min(y.bufferSize,typeof b=="number"?b:y.bufferSize)),D=y&&typeof y.position=="number"?y.position:0,t=0;do c=await p.read(r,D,S.buffer,t,S.byteLength-t),D+=c,t+=c,g+=c,typeof b=="number"&&(b-=c),t===S.byteLength&&(await v.write(f(S)),S=E.VSBuffer.alloc(Math.min(y.bufferSize,typeof b=="number"?b:y.bufferSize)),t=0);while(c>0&&(typeof b!="number"||b>0)&&h(w)&&l(g,y));if(t>0){let a=t;typeof b=="number"&&(a=Math.min(t,b)),v.write(f(S.slice(0,a)))}}catch(g){throw(0,L.ensureFileSystemProviderError)(g)}finally{await p.close(r)}}function h(p){if(p.isCancellationRequested)throw(0,M.canceled)();return!0}function l(p,m){if(typeof m?.limits?.size=="number"&&p>m.limits.size)throw(0,L.createFileSystemProviderError)((0,s.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(te[75],ie([0,1,102,2,9,3,8,16]),function(x,e,E,M,s,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function h(g){return g.recursive===!0}e.isRecursiveWatchRequest=h;class l extends M.Disposable{constructor(c,b,S,D){super(),this.h=c,this.i=b,this.j=S,this.k=D,this.c=this.B(new M.MutableDisposable),this.f=void 0,this.g=0}m(){const c=new M.DisposableStore;this.c.value=c,this.b=this.l(c),this.b.setVerboseLogging(this.j),c.add(this.b.onDidChangeFile(b=>this.h(b))),c.add(this.b.onDidLogMessage(b=>this.i(b))),c.add(this.b.onDidError(b=>this.n(b)))}n(c){this.k.restartOnError?this.g<l.a&&this.f?(this.r(`restarting watcher after error: ${c}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${c}`):this.r(c)}p(c){this.g++,this.m(),this.watch(c)}async watch(c){this.f=c,await this.b?.watch(c)}async setVerboseLogging(c){this.j=c,await this.b?.setVerboseLogging(c)}r(c){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${c}`})}s(c){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${c}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=l,l.a=5;class p extends l{constructor(c,b,S){super(c,b,S,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=p;class m extends l{constructor(c,b,S){super(c,b,S,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=m;function v(g){return g.map(c=>({type:c.type,resource:R.URI.file(c.path)}))}e.toFileChanges=v;function f(g){const c=new r;for(const b of g)c.processEvent(b);return c.coalesce()}e.coalesceEvents=f;function y(g,c){return typeof c=="string"&&!c.startsWith(E.GLOBSTAR)&&!(0,s.isAbsolute)(c)?{base:g,pattern:c}:c}e.normalizeWatcherPattern=y;function w(g,c){const b=[];for(const S of c)b.push((0,E.parse)(y(g,S)));return b}e.parseWatcherPatterns=w;class r{constructor(){this.a=new Set,this.b=new Map}c(c){return L.isLinux?c.path:c.path.toLowerCase()}processEvent(c){const b=this.b.get(this.c(c));let S=!1;if(b){const D=b.type,t=c.type;b.path!==c.path&&(c.type===2||c.type===1)?S=!0:D===1&&t===2?(this.b.delete(this.c(c)),this.a.delete(b)):D===2&&t===1?b.type=0:D===1&&t===0||(b.type=t)}else S=!0;S&&(this.a.add(c),this.b.set(this.c(c),c))}coalesce(){const c=[],b=[];return Array.from(this.a).filter(S=>S.type!==2?(c.push(S),!1):!0).sort((S,D)=>S.path.length-D.path.length).filter(S=>b.some(D=>(0,k.isParent)(S.path,D,!L.isLinux))?!1:(b.push(S.path),!0)).concat(c)}}}),define(te[209],ie([0,1,41,7,22,32,2,82,9,3,103,24,75]),function(x,e,E,M,s,L,R,k,h,l,p,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class f extends R.Disposable{constructor(r,g,c,b){super(),this.j=r,this.k=g,this.l=c,this.m=b,this.c=this.B(new M.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},S=>this.k(S))),this.f=this.B(new M.RunOnceWorker(S=>this.u(S),f.b)),this.g=(0,v.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,v.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new s.CancellationTokenSource,this.ready=this.n()}async n(){try{const r=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const g=await m.Promises.stat(r);this.B(await this.s(r,g.isDirectory()))}catch(r){r.code!=="ENOENT"?this.w(r):this.z(r)}}async r(r){let g=r.path;try{g=await m.Promises.realpath(r.path),r.path===g&&(g=await(0,p.realcase)(r.path)??r.path),r.path!==g&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${r.path}, real: ${g})`)}catch{}return g}async s(r,g){if(l.isMacintosh&&(0,L.isEqualOrParent)(r,"/Volumes/",!0))return this.w(`Refusing to watch ${r} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),R.Disposable.None;const c=new s.CancellationTokenSource(this.i.token),b=new R.DisposableStore;try{const S=(0,h.basename)(r),D=(0,E.watch)(r);b.add((0,R.toDisposable)(()=>{D.removeAllListeners(),D.close()})),this.z(`Started watching: '${r}'`);const t=new Set;if(g)try{for(const i of await m.Promises.readdir(r))t.add(i)}catch(i){this.w(i)}const a=new Map;b.add((0,R.toDisposable)(()=>{for(const[,i]of a)i.dispose();a.clear()})),D.on("error",(i,n)=>{this.w(`Failed to watch ${r} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),D.on("change",(i,n)=>{if(c.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${n}`);let o="";if(n&&(o=n.toString(),l.isMacintosh&&(o=(0,k.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(g)if(i==="rename"){a.get(o)?.dispose();const u=setTimeout(async()=>{if(a.delete(o),o===S&&!await m.Promises.exists(r)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const d=await this.v((0,h.join)(r,o));if(c.token.isCancellationRequested)return;let I;d?t.has(o)?I=0:(I=1,t.add(o)):(t.delete(o),I=2),this.t({path:(0,h.join)(this.j.path,o),type:I})},f.a);a.set(o,(0,R.toDisposable)(()=>clearTimeout(u)))}else{let u;t.has(o)?u=0:(u=1,t.add(o)),this.t({path:(0,h.join)(this.j.path,o),type:u})}else if(i==="rename"||o!==S){const u=setTimeout(async()=>{const d=await m.Promises.exists(r);c.token.isCancellationRequested||(d?(this.t({path:this.j.path,type:0},!0),b.add(await this.s(r,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},f.a);b.clear(),b.add((0,R.toDisposable)(()=>clearTimeout(u)))}else this.t({path:this.j.path,type:0},!0)})}catch(S){await m.Promises.exists(r)&&!c.token.isCancellationRequested&&this.w(`Failed to watch ${r} for changes using fs.watch() (${S.toString()})`)}return(0,R.toDisposable)(()=>{c.dispose(!0),b.dispose()})}t(r,g=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${r.type===1?"[ADDED]":r.type===2?"[DELETED]":"[CHANGED]"} ${r.path}`),!g&&this.g.some(c=>c(r.path))?this.m&&this.z(` >> ignored (excluded) ${r.path}`):!g&&this.h&&this.h.length>0&&!this.h.some(c=>c(r.path))?this.m&&this.z(` >> ignored (not included) ${r.path}`):this.f.work(r))}u(r){const g=(0,v.coalesceEvents)(r);if(g.length>0){if(this.m)for(const b of g)this.z(`>> normalized ${b.type===1?"[ADDED]":b.type===2?"[DELETED]":"[CHANGED]"} ${b.path}`);this.c.work(g)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${g.length}, most recent change: ${g[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(r){if(l.isLinux)return m.Promises.exists(r);try{const g=(0,h.basename)(r);return(await m.Promises.readdir((0,h.dirname)(r))).some(b=>b===g)}catch(g){return this.z(g),!1}}setVerboseLogging(r){this.m=r}w(r){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${r}`})}y(r){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${r}`})}z(r){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${r}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=f,f.a=100,f.b=75;async function y(w,r,g,c,b=512){const S=await m.Promises.open(w,"r"),D=Buffer.allocUnsafe(b),t=new s.CancellationTokenSource(c);let a,i=!1;const n={path:w,excludes:[],recursive:!1},o=new f(n,u=>{(async()=>{for(const{type:d}of u)if(d===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:I}=await m.Promises.read(S,D,0,b,null);if(!I||t.token.isCancellationRequested)break;r(D.slice(0,I))}}catch(I){a=new Error(I),t.dispose(!0)}finally{i=!1}}})()});return await o.ready,g(),new Promise((u,d)=>{t.token.onCancellationRequested(async()=>{o.dispose();try{await m.Promises.close(S)}catch(I){a=new Error(I)}a?d(a):u()})})}e.watchFileContents=y}),define(te[210],ie([0,1,4,102,2,3,209]),function(x,e,E,M,s,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends s.Disposable{constructor(){super(...arguments),this.a=this.B(new E.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new E.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(l){const p=this.i(l),m=p.filter(f=>{const y=this.c.get(f.path);return y?!(0,M.patternsEquals)(y.request.excludes,f.excludes)||!(0,M.patternsEquals)(y.request.includes,f.includes):!0}),v=Array.from(this.c.values()).filter(({request:f})=>!p.find(y=>y.path===f.path&&(0,M.patternsEquals)(y.excludes,f.excludes)&&(0,M.patternsEquals)(y.includes,f.includes))).map(({request:f})=>f.path);m.length&&this.j(`Request to start watching: ${m.map(f=>`${f.path} (excludes: ${f.excludes.length>0?f.excludes:"<none>"}, includes: ${f.includes&&f.includes.length>0?JSON.stringify(f.includes):"<all>"})`).join(",")}`),v.length&&this.j(`Request to stop watching: ${v.join(",")}`);for(const f of v)this.h(f);for(const f of m)this.g(f)}g(l){const p=new R.NodeJSFileWatcherLibrary(l,v=>this.a.fire(v),v=>this.b.fire(v),this.f),m={request:l,instance:p};this.c.set(l.path,m)}async stop(){for(const[l]of this.c)this.h(l);this.c.clear()}h(l){const p=this.c.get(l);p&&(this.c.delete(l),p.instance.dispose())}i(l){const p=new Map;for(const m of l){const v=L.isLinux?m.path:m.path.toLowerCase();p.set(v,m)}return Array.from(p.values())}async setVerboseLogging(l){this.f=l;for(const[,p]of this.c)p.instance.setVerboseLogging(l)}j(l){this.f&&this.b.fire({type:"trace",message:this.k(l)})}k(l,p){return p?`[File Watcher (node.js)] ${l} (path: ${p.request.path})`:`[File Watcher (node.js)] ${l}`}}e.NodeJSWatcher=k}),define(te[211],ie([0,1,75,210]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class s extends E.AbstractNonRecursiveWatcherClient{constructor(R,k,h){super(R,k,h),this.m()}l(){return new M.NodeJSWatcher}}e.NodeJSWatcherClient=s}),define(te[212],ie([0,1,15,45,156,75]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class R extends L.AbstractUniversalWatcherClient{constructor(h,l,p){super(h,l,p),this.m()}l(h){const l=h.add(new s.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return h.add(l.onDidProcessExit(({code:p,signal:m})=>this.n(`terminated by itself with code ${p}, signal: ${m}`))),M.ProxyChannel.toService((0,M.getNextTickChannel)(l.getChannel("watcher")))}}e.UniversalWatcherClient=R}),define(te[90],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...s){this.a=new Map;for(const[L,R]of s)this.set(L,R)}set(s,L){const R=this.a.get(s);return this.a.set(s,L),R}has(s){return this.a.has(s)}get(s){return this.a.get(s)}}e.ServiceCollection=E}),define(te[213],ie([0,1,7,13,2,73,203,6,90,100]),function(x,e,E,M,s,L,R,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const p=!1;class m extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class v{constructor(r=new h.ServiceCollection,g=!1,c,b=p){this.f=r,this.g=g,this.h=c,this.i=b,this.o=new Set,this.f.set(k.IInstantiationService,this),this._globalGraph=b?c?._globalGraph??new R.Graph(S=>S):void 0}createChild(r){return new v(r,this.g,this,this.i)}invokeFunction(r,...g){const c=y.traceInvocation(this.i,r);let b=!1;try{return r({get:D=>{if(b)throw(0,M.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(D,c);if(!t)throw new Error(`[invokeFunction] unknown service '${D}'`);return t}},...g)}finally{b=!0,c.stop()}}createInstance(r,...g){let c,b;return r instanceof L.SyncDescriptor?(c=y.traceCreation(this.i,r.ctor),b=this.j(r.ctor,r.staticArguments.concat(g),c)):(c=y.traceCreation(this.i,r),b=this.j(r,g,c)),c.stop(),b}j(r,g=[],c){const b=k._util.getServiceDependencies(r).sort((t,a)=>t.index-a.index),S=[];for(const t of b){const a=this.m(t.id,c);a||this.u(`[createInstance] ${r.name} depends on UNKNOWN service ${t.id}.`,!1),S.push(a)}const D=b.length>0?b[0].index:g.length;if(g.length!==D){console.trace(`[createInstance] First service dependency of ${r.name} at position ${D+1} conflicts with ${g.length} static arguments`);const t=D-g.length;t>0?g=g.concat(new Array(t)):g=g.slice(0,D)}return Reflect.construct(r,g.concat(S))}k(r,g){if(this.f.get(r)instanceof L.SyncDescriptor)this.f.set(r,g);else if(this.h)this.h.k(r,g);else throw new Error("illegalState - setting UNKNOWN service instance")}l(r){const g=this.f.get(r);return!g&&this.h?this.h.l(r):g}m(r,g){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const c=this.l(r);return c instanceof L.SyncDescriptor?this.q(r,c,g.branch(r,!0)):(g.branch(r,!1),c)}q(r,g,c){if(this.o.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.o.add(r);try{return this.r(r,g,c)}finally{this.o.delete(r)}}r(r,g,c){const b=new R.Graph(t=>t.id.toString());let S=0;const D=[{id:r,desc:g,_trace:c}];for(;D.length;){const t=D.pop();if(b.lookupOrInsertNode(t),S++>1e3)throw new m(b);for(const a of k._util.getServiceDependencies(t.desc.ctor)){const i=this.l(a.id);if(i||this.u(`[createInstance] ${r} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(a.id)),i instanceof L.SyncDescriptor){const n={id:a.id,desc:i,_trace:t._trace.branch(a.id,!0)};b.insertEdge(t,n),D.push(n)}}}for(;;){const t=b.roots();if(t.length===0){if(!b.isEmpty())throw new m(b);break}for(const{data:a}of t){if(this.l(a.id)instanceof L.SyncDescriptor){const n=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,n)}b.removeNode(a)}}return this.l(r)}s(r,g,c=[],b,S){if(this.f.get(r)instanceof L.SyncDescriptor)return this.t(r,g,c,b,S);if(this.h)return this.h.s(r,g,c,b,S);throw new Error(`illegalState - creating UNKNOWN service instance ${g.name}`)}t(r,g,c=[],b,S){if(b){const D=new v(void 0,this.g,this,this.i);D.c=String(r);const t=new Map,a=new E.IdleValue(()=>{const i=D.j(g,c,S);for(const[n,o]of t){const u=i[n];if(typeof u=="function")for(const d of o)u.apply(i,d)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!a.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let d=t.get(n);return d||(d=new l.LinkedList,t.set(n,d)),(A,C,T)=>{const W=d.push([A,C,T]);return(0,s.toDisposable)(W)}}if(n in i)return i[n];const o=a.value;let u=o[n];return typeof u!="function"||(u=u.bind(o),i[n]=u),u},set(i,n,o){return a.value[n]=o,!0},getPrototypeOf(i){return g.prototype}})}else return this.j(g,c,S)}u(r,g){if(g&&console.warn(r),this.g)throw new Error(r)}}e.InstantiationService=v;var f;(function(w){w[w.None=0]="None",w[w.Creation=1]="Creation",w[w.Invocation=2]="Invocation",w[w.Branch=3]="Branch"})(f||(f={}));class y{static traceInvocation(r,g){return r?new y(2,g.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):y.c}static traceCreation(r,g){return r?new y(1,g.name):y.c}constructor(r,g){this.type=r,this.name=g,this.g=Date.now(),this.h=[]}branch(r,g){const c=new y(3,r.toString());return this.h.push([r,g,c]),c}stop(){const r=Date.now()-this.g;y.f+=r;let g=!1;function c(S,D){const t=[],a=new Array(S+1).join("	");for(const[i,n,o]of D.h)if(n&&o){g=!0,t.push(`${a}CREATES -> ${i}`);const u=c(S+1,o);u&&t.push(u)}else t.push(`${a}uses -> ${i}`);return t.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${c(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${y.f.toFixed(2)}ms)`];(r>2||g)&&y.all.add(b.join(`
`))}}e.Trace=y,y.all=new Set,y.c=new class extends y{constructor(){super(0,null)}stop(){}branch(){return this}},y.f=0}),define(te[214],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IIssueMainService=e.IssueType=void 0;var M;(function(s){s[s.Bug=0]="Bug",s[s.PerformanceIssue=1]="PerformanceIssue",s[s.FeatureRequest=2]="FeatureRequest"})(M||(e.IssueType=M={})),e.IIssueMainService=(0,E.createDecorator)("issueService")}),define(te[5],ie([0,1,49,4,56,2,35,3,18,11,8,204,6]),function(x,e,E,M,s,L,R,k,h,l,p,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,v.createDecorator)("logService"),e.ILoggerService=(0,v.createDecorator)("loggerService");function f(){return new Date().toISOString()}function y(A){return(0,l.isNumber)(A)}e.isLogLevel=y;var w;(function(A){A[A.Off=0]="Off",A[A.Trace=1]="Trace",A[A.Debug=2]="Debug",A[A.Info=3]="Info",A[A.Warning=4]="Warning",A[A.Error=5]="Error"})(w||(e.LogLevel=w={})),e.DEFAULT_LOG_LEVEL=w.Info;function r(A,C,T){switch(C){case w.Trace:A.trace(T);break;case w.Debug:A.debug(T);break;case w.Info:A.info(T);break;case w.Warning:A.warn(T);break;case w.Error:A.error(T);break;case w.Off:break;default:throw new Error(`Invalid log level ${C}`)}}e.log=r;function g(A,C=!1){let T="";for(let W=0;W<A.length;W++){let $=A[W];if($ instanceof Error&&($=(0,E.toErrorMessage)($,C)),typeof $=="object")try{$=JSON.stringify($)}catch{}T+=(W>0?" ":"")+$}return T}class c extends L.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new M.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(C){this.b!==C&&(this.b=C,this.c.fire(this.b))}getLevel(){return this.b}f(C){return this.b!==w.Off&&this.b<=C}}e.AbstractLogger=c;class b extends c{constructor(C){super(),this.h=C}f(C){return this.h||super.f(C)}trace(C,...T){this.f(w.Trace)&&this.g(w.Trace,g([C,...T],!0))}debug(C,...T){this.f(w.Debug)&&this.g(w.Debug,g([C,...T]))}info(C,...T){this.f(w.Info)&&this.g(w.Info,g([C,...T]))}warn(C,...T){this.f(w.Warning)&&this.g(w.Warning,g([C,...T]))}error(C,...T){if(this.f(w.Error))if(C instanceof Error){const W=Array.prototype.slice.call(arguments);W[0]=C.stack,this.g(w.Error,g(W))}else this.g(w.Error,g([C,...T]))}flush(){}}e.AbstractMessageLogger=b;class S extends c{constructor(C=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(C),this.g=!k.isWindows}trace(C,...T){this.f(w.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,C,...T):console.log(`[main ${f()}]`,C,...T))}debug(C,...T){this.f(w.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,C,...T):console.log(`[main ${f()}]`,C,...T))}info(C,...T){this.f(w.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,C,...T):console.log(`[main ${f()}]`,C,...T))}warn(C,...T){this.f(w.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,C,...T):console.warn(`[main ${f()}]`,C,...T))}error(C,...T){this.f(w.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,C,...T):console.error(`[main ${f()}]`,C,...T))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class D extends c{constructor(C=e.DEFAULT_LOG_LEVEL,T=!0){super(),this.g=T,this.setLevel(C)}trace(C,...T){this.f(w.Trace)&&(this.g?console.log("%cTRACE","color: #888",C,...T):console.log(C,...T))}debug(C,...T){this.f(w.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",C,...T):console.log(C,...T))}info(C,...T){this.f(w.Info)&&(this.g?console.log("%c INFO","color: #33f",C,...T):console.log(C,...T))}warn(C,...T){this.f(w.Warning)&&(this.g?console.log("%c WARN","color: #993",C,...T):console.log(C,...T))}error(C,...T){this.f(w.Error)&&(this.g?console.log("%c  ERR","color: #f33",C,...T):console.error(C,...T))}dispose(){}flush(){}}e.ConsoleLogger=D;class t extends c{constructor(C,T=e.DEFAULT_LOG_LEVEL){super(),this.g=C,this.setLevel(T)}trace(C,...T){this.f(w.Trace)&&this.g.log(w.Trace,[this.h(C),...T])}debug(C,...T){this.f(w.Debug)&&this.g.log(w.Debug,[this.h(C),...T])}info(C,...T){this.f(w.Info)&&this.g.log(w.Info,[this.h(C),...T])}warn(C,...T){this.f(w.Warning)&&this.g.log(w.Warning,[this.h(C),...T])}error(C,...T){this.f(w.Error)&&this.g.log(w.Error,[this.h(C),...T])}h(C){return typeof C=="string"?C:(0,E.toErrorMessage)(C,this.f(w.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class a extends c{constructor(C){super(),this.g=C,C.length&&this.setLevel(C[0].getLevel())}setLevel(C){for(const T of this.g)T.setLevel(C);super.setLevel(C)}trace(C,...T){for(const W of this.g)W.trace(C,...T)}debug(C,...T){for(const W of this.g)W.debug(C,...T)}info(C,...T){for(const W of this.g)W.info(C,...T)}warn(C,...T){for(const W of this.g)W.warn(C,...T)}error(C,...T){for(const W of this.g)W.error(C,...T)}flush(){for(const C of this.g)C.flush()}dispose(){for(const C of this.g)C.dispose()}}e.MultiplexLogger=a;class i extends L.Disposable{constructor(C,T,W){if(super(),this.h=C,this.j=T,this.b=new R.ResourceMap,this.c=this.B(new M.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.Emitter),this.onDidChangeVisibility=this.g.event,W)for(const $ of W)this.b.set($.resource,{logger:void 0,info:$})}k(C){return(0,l.isString)(C)?[...this.b.values()].find(T=>T.info.id===C):this.b.get(C)}getLogger(C){return this.k(C)?.logger}createLogger(C,T){const W=this.l(C),$=(0,l.isString)(C)?C:T?.id??(0,s.hash)(W.toString()).toString(16);let H=this.b.get(W)?.logger;const Z=T?.logLevel==="always"?w.Trace:T?.logLevel;H||(H=this.m(W,Z??this.getLogLevel(W)??this.h,{...T,id:$}));const ne={logger:H,info:{resource:W,id:$,logLevel:Z,name:T?.name,hidden:T?.hidden,extensionId:T?.extensionId,when:T?.when}};return this.registerLogger(ne.info),this.b.set(W,ne),H}l(C){return(0,l.isString)(C)?(0,h.joinPath)(this.j,`${C}.log`):C}setLogLevel(C,T){if(p.URI.isUri(C)){const W=C,$=T,H=this.b.get(W);H&&$!==H.info.logLevel&&(H.info.logLevel=$===this.h?void 0:$,H.logger?.setLevel($),this.b.set(H.info.resource,H),this.f.fire([W,$]))}else{this.h=C;for(const[W,$]of this.b.entries())this.b.get(W)?.info.logLevel===void 0&&$.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(C,T){const W=this.k(C);W&&T!==!W.info.hidden&&(W.info.hidden=!T,this.b.set(W.info.resource,W),this.g.fire([W.info.resource,T]))}getLogLevel(C){let T;return C&&(T=this.b.get(C)?.info.logLevel),T??this.h}registerLogger(C){const T=this.b.get(C.resource);T?T.info.hidden!==C.hidden&&this.setVisibility(C.resource,!C.hidden):(this.b.set(C.resource,{info:C,logger:void 0}),this.c.fire({added:[C],removed:[]}))}deregisterLogger(C){const T=this.b.get(C);T&&(T.logger&&T.logger.dispose(),this.b.delete(C),this.c.fire({added:[],removed:[T.info]}))}*getRegisteredLoggers(){for(const C of this.b.values())yield C.info}getRegisteredLogger(C){return this.b.get(C)?.info}dispose(){this.b.forEach(C=>C.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=i;class n{constructor(){this.onDidChangeLogLevel=new M.Emitter().event}setLevel(C){}getLevel(){return w.Info}trace(C,...T){}debug(C,...T){}info(C,...T){}warn(C,...T){}error(C,...T){}critical(C,...T){}dispose(){}flush(){}}e.NullLogger=n;class o extends n{}e.NullLogService=o;function u(A){if(A.verbose)return w.Trace;if(typeof A.logLevel=="string"){const C=I(A.logLevel.toLowerCase());if(C!==void 0)return C}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=u;function d(A){switch(A){case w.Trace:return"trace";case w.Debug:return"debug";case w.Info:return"info";case w.Warning:return"warn";case w.Error:return"error";case w.Off:return"off"}}e.LogLevelToString=d;function I(A){switch(A){case"trace":return w.Trace;case"debug":return w.Debug;case"info":return w.Info;case"warn":return w.Warning;case"error":return w.Error;case"critical":return w.Error;case"off":return w.Off}}e.parseLogLevel=I,e.CONTEXT_LOG_LEVEL=new m.RawContextKey("logLevel",d(w.Info))});var Q=this&&this.__param||function(x,e){return function(E,M){e(E,M,x)}};define(te[215],ie([0,1,74,4,2,5,3,7]),function(x,e,E,M,s,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let h=e.BaseCredentialsMainService=class dt extends s.Disposable{constructor(p){super(),this.h=p,this.c=this.B(new M.Emitter),this.onDidChangePassword=this.c.event,this.g=new k.SequencerByKey}async getPassword(p,m){this.h.trace("Going to get password from keytar:",p,m);let v;try{v=await this.i()}catch{return null}return await this.g.queue(p+m,()=>this.k(v,p,m))}async k(p,m,v){this.h.trace("Doing get password from keytar:",m,v);const f=await(0,k.retry)(()=>p.getPassword(m,v),50,3);if(!f)return this.h.trace("Did not get a password from keytar for account:",v),f;let y,w;try{const r=JSON.parse(f);y=r.content,w=r.hasNextChunk}catch{}if(!y||!w)return this.h.trace("Got password from keytar for account:",v),f;try{let r=1;for(;w;){const g=await(0,k.retry)(()=>p.getPassword(m,`${v}-${r}`),50,3),c=JSON.parse(g);y+=c.content,w=c.hasNextChunk,r++}return this.h.trace(`Got ${r}-chunked password from keytar for account:`,v),y}catch(r){return this.h.error(r),f}}async setPassword(p,m,v){this.h.trace("Going to set password using keytar:",p,m);let f;try{f=await this.i()}catch(y){throw this.j?.(y),y}await this.g.queue(p+m,()=>this.l(f,p,m,v)),this.c.fire({service:p,account:m})}async l(p,m,v,f){if(this.h.trace("Doing set password from keytar:",m,v),!R.isWindows){await(0,k.retry)(()=>p.setPassword(m,v,f),50,3),this.h.trace("Set password from keytar for account:",v);return}if(await this.m(p,m,v),f.length<=dt.b){await(0,k.retry)(()=>p.setPassword(m,v,f),50,3),this.h.trace("Set password from keytar for account:",v);return}let y=0,w=0,r=!0;for(;r;){const g=f.substring(y,y+dt.b);y+=dt.b,r=f.length-y>0;const c={content:g,hasNextChunk:r};await(0,k.retry)(()=>p.setPassword(m,w?`${v}-${w}`:v,JSON.stringify(c)),50,3),w++}this.h.trace(`Set${w?` ${w}-chunked`:""} password from keytar for account:`,v)}async deletePassword(p,m){this.h.trace("Going to delete password using keytar:",p,m);let v;try{v=await this.i()}catch(y){throw this.j?.(y),y}const f=await this.g.queue(p+m,()=>this.m(v,p,m));return f&&this.c.fire({service:p,account:m}),f}async m(p,m,v){this.h.trace("Doing delete password from keytar:",m,v);const f=await p.getPassword(m,v);if(!f)return this.h.trace("Did not get a password to delete from keytar for account:",v),!1;let y,w;try{const g=JSON.parse(f);y=g.content,w=g.hasNextChunk}catch{}let r=0;if(y&&w)try{for(r++;w;){const g=`${v}-${r}`,c=await p.getPassword(m,g);await p.deletePassword(m,g),w=JSON.parse(c).hasNextChunk,r++}}catch(g){this.h.error(g)}return await p.deletePassword(m,v)?(this.h.trace(`Deleted${r?` ${r}-chunked`:""} password from keytar for account:`,v),!0):(this.h.trace(`Keytar failed to delete${r?` ${r}-chunked`:""} password for account:`,v),!1)}async findPassword(p){let m;try{m=await this.i()}catch{return null}return await m.findPassword(p)}async findCredentials(p){let m;try{m=await this.i()}catch{return[]}return await m.findCredentials(p)}clear(){return this.f instanceof E.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};h.a=2500,h.b=h.a-100,e.BaseCredentialsMainService=h=be([Q(0,L.ILogService)],h)}),define(te[216],ie([0,1,5]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let M=e.EncryptionMainService=class{constructor(L,R){this.a=L,this.b=R}c(){return new Promise((L,R)=>x(["vscode-encrypt"],L,R))}async encrypt(L){let R;try{R=await this.c()}catch{return L}try{return R.encrypt(this.a,L)}catch(k){return this.b.error(k),L}}async decrypt(L){let R;try{R=await this.c()}catch{return L}try{return R.decrypt(this.a,L)}catch(k){return this.b.error(k),L}}};e.EncryptionMainService=M=be([Q(1,E.ILogService)],M)}),define(te[217],ie([0,1,23,7,13,4,2,9,75,5]),function(x,e,E,M,s,L,R,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class p extends R.Disposable{constructor(v,f){super(),this.a=v,this.b=f,this.c=this.B(new L.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new L.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new M.ThrottledDelayer(0)),this.s=[],this.t=this.B(new M.ThrottledDelayer(0))}watch(v,f){return f.recursive||this.b?.watcher?.forceUniversal?this.l(v,f):this.u(v,f)}l(v,f){const y={path:this.C(v),excludes:f.excludes,includes:f.includes,recursive:f.recursive},w=(0,E.insert)(this.j,y);return this.m(),(0,R.toDisposable)(()=>{w(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(v=>(0,s.onUnexpectedError)(v))}n(){this.h||(this.h=this.B(this.p(f=>this.c.fire((0,h.toFileChanges)(f)),f=>this.z(f),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const f of this.j)(0,h.isRecursiveWatchRequest)(f)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const f of this.j)(0,h.isRecursiveWatchRequest)(f)&&v.includes(f.path)&&(f.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(v,f){const y={path:this.C(v),excludes:f.excludes,includes:f.includes,recursive:!1},w=(0,E.insert)(this.s,y);return this.v(),(0,R.toDisposable)(()=>{w(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(v=>(0,s.onUnexpectedError)(v))}w(){return this.r||(this.r=this.B(this.y(v=>this.c.fire((0,h.toFileChanges)(v)),v=>this.z(v),this.a.getLevel()===l.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===l.LogLevel.Trace)}))),this.r.watch(this.s)}z(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}C(v){return(0,k.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=p}),define(te[218],ie([0,1,23,7,17,22,4,56,68,2,61,15,64,18,60,171,16,112,5,13]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g,c,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=e.FileService=class extends l.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new R.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new R.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new R.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new R.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new R.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new M.ResourceQueue)}registerProvider(t,a){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${t}`);const i=new l.DisposableStore;return this.h.set(t,a),this.c.fire({added:!0,scheme:t,provider:a}),i.add(a.onDidChangeFile(n=>this.R.fire(new r.FileChangesEvent(n,!this.O(a))))),typeof a.onDidWatchError=="function"&&i.add(a.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(a.onDidChangeCapabilities(()=>this.g.fire({provider:a,scheme:t}))),(0,l.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:a}),this.h.delete(t),(0,l.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const a=[];this.f.fire({scheme:t,join(i){a.push(i)}}),!this.h.has(t)&&await M.Promises.settled(a)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,a){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&a)}listCapabilities(){return h.Iterable.map(this.h,([t,a])=>({scheme:t,capabilities:a.capabilities}))}async j(t){if(!(0,f.isAbsolutePath)(t))throw new r.FileOperationError((0,w.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const a=this.h.get(t.scheme);if(!a){const i=new b.ErrorNoTelemetry;throw i.message=(0,w.localize)(1,null,t.toString()),i}return a}async k(t){const a=await this.j(t);if((0,r.hasOpenReadWriteCloseCapability)(a)||(0,r.hasReadWriteCapability)(a)||(0,r.hasFileReadStreamCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const a=await this.j(t);if((0,r.hasOpenReadWriteCloseCapability)(a)||(0,r.hasReadWriteCapability)(a))return a;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,a){try{return await this.n(t,a)}catch(i){throw(0,r.toFileSystemProviderErrorCode)(i)===r.FileSystemProviderErrorCode.FileNotFound?new r.FileOperationError((0,w.localize)(2,null,this.nb(t)),1):(0,r.ensureFileSystemProviderError)(i)}}async n(t,a){const i=await this.j(t),n=this.O(i),o=a?.resolveTo,u=a?.resolveSingleChildDescendants,d=a?.resolveMetadata,I=await i.stat(t);let A;return this.p(i,t,I,void 0,!!d,(C,T)=>(A||(A=p.TernarySearchTree.forUris(()=>!n),A.set(t,!0),o&&A.fill(!0,o)),A.get(C.resource)||A.findSuperstr(C.resource.with({query:null,fragment:null}))?!0:C.isDirectory&&u?T===1:!1))}async p(t,a,i,n,o,u){const{providerExtUri:d}=this.N(t),I={resource:a,name:d.basename(a),isFile:(i.type&r.FileType.File)!==0,isDirectory:(i.type&r.FileType.Directory)!==0,isSymbolicLink:(i.type&r.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:!!((i.permissions??0)&r.FilePermission.Readonly)||!!(t.capabilities&2048),etag:(0,r.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(I.isDirectory&&u(I,n)){try{const A=await t.readdir(a),C=await M.Promises.settled(A.map(async([T,W])=>{try{const $=d.joinPath(a,T),H=o?await t.stat($):{type:W};return await this.p(t,$,H,A.length,o,u)}catch($){return this.b.trace($),null}}));I.children=(0,E.coalesce)(C)}catch(A){this.b.trace(A),I.children=[]}return I}return I}async resolveAll(t){return M.Promises.settled(t.map(async a=>{try{return{stat:await this.n(a.resource,a.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const a=await this.j(t),i=await a.stat(t);return this.p(a,t,i,void 0,!0,()=>!1)}async exists(t){const a=await this.j(t);try{return!!await a.stat(t)}catch{return!1}}async canCreateFile(t,a){try{await this.r(t,a)}catch(i){return i}return!0}async r(t,a){if(!a?.overwrite&&await this.exists(t))throw new r.FileOperationError((0,w.localize)(3,null,this.nb(t)),3,a)}async createFile(t,a=s.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,a);return this.m.fire(new r.FileOperationEvent(t,0,n)),n}async writeFile(t,a,i){const n=this.lb(await this.l(t),t),{providerExtUri:o}=this.N(n);try{await this.s(n,t,i)||await this.P(n,o.dirname(t));let d;if((0,r.hasReadWriteCapability)(n)&&!(a instanceof s.VSBuffer))if((0,y.isReadableStream)(a)){const I=await(0,y.peekStream)(a,3);I.ended?d=s.VSBuffer.concat(I.buffer):d=I}else d=(0,y.peekReadable)(a,I=>s.VSBuffer.concat(I),3);else d=a;!(0,r.hasOpenReadWriteCloseCapability)(n)||(0,r.hasReadWriteCapability)(n)&&d instanceof s.VSBuffer?await this.cb(n,t,i,d):await this.Y(n,t,i,d instanceof s.VSBuffer?(0,s.bufferToReadable)(d):d),this.m.fire(new r.FileOperationEvent(t,4))}catch(u){throw new r.FileOperationError((0,w.localize)(4,null,this.nb(t),(0,r.ensureFileSystemProviderError)(u).toString()),(0,r.toFileOperationResult)(u),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,a,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,w.localize)(5,null,this.nb(a)));let o;try{o=await t.stat(a)}catch{return}if(o.type&r.FileType.Directory)throw new r.FileOperationError((0,w.localize)(6,null,this.nb(a)),0,i);if(this.mb(a,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==r.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,r.etag)({mtime:i.mtime,size:o.size}))throw new r.FileOperationError((0,w.localize)(7,null),3,i);return o}async readFile(t,a,i){const n=await this.k(t);return a?.atomic?this.t(n,t,a,i):this.u(n,t,a,i)}async t(t,a,i,n){return new Promise((o,u)=>{this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{try{const d=await this.u(t,a,i,n);o(d)}catch(d){u(d)}})})}async u(t,a,i,n){const o=await this.v(t,a,{...i,preferUnbuffered:!0},n);return{...o,value:await(0,s.streamToBuffer)(o.value)}}async readFileStream(t,a,i){const n=await this.k(t);return this.v(n,t,a,i)}async v(t,a,i,n){const o=new L.CancellationTokenSource(n),u=this.F(a,i).then(I=>I,I=>{throw o.cancel(),I});let d;try{return typeof i?.etag=="string"&&i.etag!==r.ETAG_DISABLED&&await u,i?.atomic&&(0,r.hasFileAtomicReadCapability)(t)||!((0,r.hasOpenReadWriteCloseCapability)(t)||(0,r.hasFileReadStreamCapability)(t))||(0,r.hasReadWriteCapability)(t)&&i?.preferUnbuffered?d=this.D(t,a,i):(0,r.hasFileReadStreamCapability)(t)?d=this.z(t,a,o.token,i):d=this.C(t,a,o.token,i),{...await u,value:d}}catch(I){throw d&&await(0,y.consumeStream)(d),this.w(I,a,i)}}w(t,a,i){const n=(0,w.localize)(8,null,this.nb(a),(0,r.ensureFileSystemProviderError)(t).toString());return t instanceof r.NotModifiedSinceFileOperationError?new r.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof r.TooLargeFileOperationError?new r.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new r.FileOperationError(n,(0,r.toFileOperationResult)(t),i)}z(t,a,i,n=Object.create(null)){const o=t.readFileStream(a,n,i);return(0,y.transform)(o,{data:u=>u instanceof s.VSBuffer?u:s.VSBuffer.wrap(u),error:u=>this.w(u,a,n)},u=>s.VSBuffer.concat(u))}C(t,a,i,n=Object.create(null)){const o=(0,s.newWriteableBufferStream)();return(0,g.readFileIntoStream)(t,a,o,u=>u,{...n,bufferSize:this.a,errorTransformer:u=>this.w(u,a,n)},i),o}D(t,a,i){const n=(0,y.newWriteableStream)(o=>s.VSBuffer.concat(o));return(async()=>{try{let o;i?.atomic&&(0,r.hasFileAtomicReadCapability)(t)?o=await t.readFile(a,{atomic:!0}):o=await t.readFile(a),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.G(a,o.byteLength,i),n.end(s.VSBuffer.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async F(t,a){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new r.FileOperationError((0,w.localize)(9,null,this.nb(t)),0,a);if(typeof a?.etag=="string"&&a.etag!==r.ETAG_DISABLED&&a.etag===i.etag)throw new r.NotModifiedSinceFileOperationError((0,w.localize)(10,null),i,a);return this.G(t,i.size,a),i}G(t,a,i){if(typeof i?.limits?.size=="number"&&a>i.limits.size)throw new r.TooLargeFileOperationError((0,w.localize)(11,null,this.nb(t)),7,a,i)}async canMove(t,a,i){return this.H(t,a,"move",i)}async canCopy(t,a,i){return this.H(t,a,"copy",i)}async H(t,a,i,n){if(t.toString()!==a.toString())try{const o=i==="move"?this.lb(await this.l(t),t):await this.k(t),u=this.lb(await this.l(a),a);await this.M(o,t,u,a,i,n)}catch(o){return o}return!0}async move(t,a,i){const n=this.lb(await this.l(t),t),o=this.lb(await this.l(a),a),u=await this.I(n,t,o,a,"move",!!i),d=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,u==="move"?2:3,d)),d}async copy(t,a,i){const n=await this.k(t),o=this.lb(await this.l(a),a),u=await this.I(n,t,o,a,"copy",!!i),d=await this.resolve(a,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,u==="copy"?3:2,d)),d}async I(t,a,i,n,o,u){if(a.toString()===n.toString())return o;const{exists:d,isSameResourceWithDifferentPathCase:I}=await this.M(t,a,i,n,o,u);if(d&&!I&&u&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),o==="copy"){if(t===i&&(0,r.hasFileFolderCopyCapability)(t))await t.copy(a,n,{overwrite:u});else{const A=await this.resolve(a);A.isDirectory?await this.L(t,A,i,n):await this.J(t,a,i,n)}return o}else return t===i?(await t.rename(a,n,{overwrite:u}),o):(await this.I(t,a,i,n,"copy",u),await this.del(a,{recursive:!0}),"copy")}async J(t,a,i,n){if((0,r.hasOpenReadWriteCloseCapability)(t)&&(0,r.hasOpenReadWriteCloseCapability)(i))return this.eb(t,a,i,n);if((0,r.hasOpenReadWriteCloseCapability)(t)&&(0,r.hasReadWriteCapability)(i))return this.kb(t,a,i,n);if((0,r.hasReadWriteCapability)(t)&&(0,r.hasOpenReadWriteCloseCapability)(i))return this.ib(t,a,i,n);if((0,r.hasReadWriteCapability)(t)&&(0,r.hasReadWriteCapability)(i))return this.gb(t,a,i,n)}async L(t,a,i,n){await i.mkdir(n),Array.isArray(a.children)&&await M.Promises.settled(a.children.map(async o=>{const u=this.N(i).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.L(t,await this.resolve(o.resource),i,u):this.J(t,o.resource,i,u)}))}async M(t,a,i,n,o,u){let d=!1;if(t===i){const{providerExtUri:A,isPathCaseSensitive:C}=this.N(t);if(C||(d=A.isEqual(a,n)),d&&o==="copy")throw new Error((0,w.localize)(12,null,this.nb(a),this.nb(n)));if(!d&&A.isEqualOrParent(n,a))throw new Error((0,w.localize)(13,null,this.nb(a),this.nb(n)))}const I=await this.exists(n);if(I&&!d){if(!u)throw new r.FileOperationError((0,w.localize)(14,null,this.nb(a),this.nb(n)),4);if(t===i){const{providerExtUri:A}=this.N(t);if(A.isEqualOrParent(a,n))throw new Error((0,w.localize)(15,null,this.nb(a),this.nb(n)))}}return{exists:I,isSameResourceWithDifferentPathCase:d}}N(t){const a=this.O(t);return{providerExtUri:a?f.extUri:f.extUriIgnorePathCase,isPathCaseSensitive:a}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const a=this.lb(await this.j(t),t);await this.P(a,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new r.FileOperationEvent(t,0,i)),i}async P(t,a){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(a,n.dirname(a));)try{if(!((await t.stat(a)).type&r.FileType.Directory))throw new Error((0,w.localize)(16,null,this.nb(a)));break}catch(o){if((0,r.toFileSystemProviderErrorCode)(o)!==r.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(n.basename(a)),a=n.dirname(a)}for(let o=i.length-1;o>=0;o--){a=n.joinPath(a,i[o]);try{await t.mkdir(a)}catch(u){if((0,r.toFileSystemProviderErrorCode)(u)!==r.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(t,a){try{await this.Q(t,a)}catch(i){return i}return!0}async Q(t,a){const i=this.lb(await this.j(t),t);if(!!a?.useTrash&&!(i.capabilities&4096))throw new Error((0,w.localize)(17,null,this.nb(t)));let o;try{o=await i.stat(t)}catch{}if(o)this.mb(t,o);else throw new r.FileOperationError((0,w.localize)(18,null,this.nb(t)),1);if(!!!a?.recursive){const d=await this.resolve(t);if(d.isDirectory&&Array.isArray(d.children)&&d.children.length>0)throw new Error((0,w.localize)(19,null,this.nb(t)))}return i}async del(t,a){const i=await this.Q(t,a),n=!!a?.useTrash,o=!!a?.recursive;await i.delete(t,{recursive:o,useTrash:n}),this.m.fire(new r.FileOperationEvent(t,1))}async cloneFile(t,a){const i=await this.j(t),n=this.lb(await this.l(a),a);if(i===n&&this.N(i).providerExtUri.isEqual(t,a))return;if(i===n&&(0,r.hasFileCloneCapability)(i))return i.cloneFile(t,a);await this.P(n,this.N(n).providerExtUri.dirname(a));const o=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,r.hasFileFolderCopyCapability)(i)?o.queue(()=>i.copy(t,a,{overwrite:!0})):o.queue(()=>this.J(i,t,n,a))}watch(t,a={recursive:!1,excludes:[]}){const i=new l.DisposableStore;let n=!1,o=()=>{n=!0};return i.add((0,l.toDisposable)(()=>o())),(async()=>{try{const u=await this.W(t,a);n?(0,l.dispose)(u):o=()=>(0,l.dispose)(u)}catch(u){this.b.error(u)}})(),i}async W(t,a){const i=await this.j(t),n=(0,k.hash)([this.N(i).providerExtUri.getComparisonKey(t),a]);let o=this.U.get(n);return o||(o={count:0,disposable:i.watch(t,a)},this.U.set(n,o)),o.count+=1,(0,l.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,l.dispose)(o.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,l.dispose)(t.disposable);this.U.clear()}async Y(t,a,i,n){return this.X.queueFor(a,this.N(t).providerExtUri).queue(async()=>{const o=await t.open(a,{create:!0,unlock:i?.unlock??!1});try{(0,y.isReadableStream)(n)||(0,y.isReadableBufferedStream)(n)?await this.Z(t,o,n):await this.ab(t,o,n)}catch(u){throw(0,r.ensureFileSystemProviderError)(u)}finally{await t.close(o)}})}async Z(t,a,i){let n=0,o;if((0,y.isReadableBufferedStream)(i)){if(i.buffer.length>0){const u=s.VSBuffer.concat(i.buffer);await this.bb(t,a,u,u.byteLength,n,0),n+=u.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((u,d)=>{(0,y.listenStream)(o,{onData:async I=>{o.pause();try{await this.bb(t,a,I,I.byteLength,n,0)}catch(A){return d(A)}n+=I.byteLength,setTimeout(()=>o.resume())},onError:I=>d(I),onEnd:()=>u()})})}async ab(t,a,i){let n=0,o;for(;(o=i.read())!==null;)await this.bb(t,a,o,o.byteLength,n,0),n+=o.byteLength}async bb(t,a,i,n,o,u){let d=0;for(;d<n;){const I=await t.write(a,o+d,i.buffer,u+d,n-d);d+=I}}async cb(t,a,i,n){return this.X.queueFor(a,this.N(t).providerExtUri).queue(()=>this.db(t,a,i,n))}async db(t,a,i,n){let o;n instanceof s.VSBuffer?o=n:(0,y.isReadableStream)(n)?o=await(0,s.streamToBuffer)(n):(0,y.isReadableBufferedStream)(n)?o=await(0,s.bufferedStreamToBuffer)(n):o=(0,s.readableToBuffer)(n),await t.writeFile(a,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,a,i,n))}async fb(t,a,i,n){let o,u;try{o=await t.open(a,{create:!1}),u=await i.open(n,{create:!0,unlock:!1});const d=s.VSBuffer.alloc(this.a);let I=0,A=0,C=0;do C=await t.read(o,I,d.buffer,A,d.byteLength-A),await this.bb(i,u,d,C,I,A),I+=C,A+=C,A===d.byteLength&&(A=0);while(C>0)}catch(d){throw(0,r.ensureFileSystemProviderError)(d)}finally{await M.Promises.settled([typeof o=="number"?t.close(o):Promise.resolve(),typeof u=="number"?i.close(u):Promise.resolve()])}}async gb(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,a,i,n))}async hb(t,a,i,n){return i.writeFile(n,await t.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async ib(t,a,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,a,i,n))}async jb(t,a,i,n){const o=await i.open(n,{create:!0,unlock:!1});try{const u=await t.readFile(a);await this.bb(i,o,s.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,r.ensureFileSystemProviderError)(u)}finally{await i.close(o)}}async kb(t,a,i,n){const o=await(0,s.streamToBuffer)(this.C(t,a,L.CancellationToken.None));await this.cb(i,n,void 0,o)}lb(t,a){if(t.capabilities&2048)throw new r.FileOperationError((0,w.localize)(20,null,this.nb(a)),6);return t}mb(t,a){if((a.permissions??0)&r.FilePermission.Readonly)throw new r.FileOperationError((0,w.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===m.Schemas.file?t.fsPath:t.toString(!0)}};e.FileService=S=be([Q(0,c.ILogService)],S)}),define(te[91],ie([0,1,41,294,7,35,17,4,32,2,9,3,18,60,24,175,16,112,217,49,212,211]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g,c,b,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,M.gracefulify)(E)}catch(a){console.error(`Error enabling graceful-fs: ${(0,b.toErrorMessage)(a)}`)}})();class t extends c.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=k.Event.None,this.H=new L.ResourceMap(o=>v.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,m.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:o}=await y.SymlinkSupport.stat(this.C(i));return{type:this.G(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await y.Promises.readdir(this.C(i),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async u=>{try{let d;u.isSymbolicLink()?d=(await this.stat((0,v.joinPath)(i,u.name))).type:d=this.G(u),o.push([u.name,d])}catch(d){this.a.trace(d)}})),o}catch(n){throw this.Y(n)}}G(i,n){let o;return n?.dangling?o=r.FileType.Unknown:i.isFile()?o=r.FileType.File:i.isDirectory()?o=r.FileType.Directory:o=r.FileType.Unknown,n&&(o|=r.FileType.SymbolicLink),o}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const u=new s.Barrier;return this.H.set(i,u),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,l.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===u&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),u.open()})}async readFile(i,n){let o;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),o=await this.I(i));const u=this.C(i);return await y.Promises.readFile(u)}catch(u){throw this.Y(u)}finally{o?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,o){const u=(0,f.newWriteableStream)(d=>R.VSBuffer.concat(d.map(I=>R.VSBuffer.wrap(I))).buffer);return(0,g.readFileIntoStream)(this,i,u,d=>d.buffer,{...n,bufferSize:256*1024},o),u}async writeFile(i,n,o){let u;try{const d=this.C(i);if(!o.create||!o.overwrite){if(await y.Promises.exists(d)){if(!o.overwrite)throw(0,r.createFileSystemProviderError)((0,w.localize)(0,null),r.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,r.createFileSystemProviderError)((0,w.localize)(1,null),r.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(u,0,n,0,n.byteLength)}catch(d){throw await this.Z(i,d)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const o=this.C(i);let u;(0,r.isFileOpenForWriteOptions)(n)&&(u=await this.I(i));let d;try{if((0,r.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:A}=await y.SymlinkSupport.stat(o);A.mode&128||await y.Promises.chmod(o,A.mode|128)}catch(A){this.a.trace(A)}let I;if((0,r.isFileOpenForWriteOptions)(n)){if(m.isWindows)try{await y.Promises.truncate(o,0),I="r+"}catch(A){A.code!=="ENOENT"&&this.a.trace(A)}I||(I="w")}else I="r";d=await y.Promises.open(o,I)}catch(I){throw u?.dispose(),(0,r.isFileOpenForWriteOptions)(n)?await this.Z(i,I):this.Y(I)}if(this.L.set(d,0),(0,r.isFileOpenForWriteOptions)(n)&&this.N.set(d,i),u){const I=this.M.get(d);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${d} (${o})`),this.M.set(d,u),I&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${d} (${o})`),I.dispose())}return d}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await y.Promises.fdatasync(i)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await y.Promises.close(i)}catch(o){throw this.Y(o)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,o,u,d){const I=this.P(i,n);let A=null;try{A=(await y.Promises.read(i,o,u,d,I)).bytesRead}catch(C){throw this.Y(C)}finally{this.Q(i,I,A)}return A}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,o){const u=this.L.get(i);typeof u=="number"&&(typeof n=="number"||(typeof o=="number"?this.L.set(i,u+o):this.L.delete(i)))}async write(i,n,o,u,d){return(0,s.retry)(()=>this.R(i,n,o,u,d),100,3)}async R(i,n,o,u,d){const I=this.P(i,n);let A=null;try{A=(await y.Promises.write(i,o,u,d,I)).bytesWritten}catch(C){throw await this.Z(this.N.get(i),C)}finally{this.Q(i,I,A)}return A}async mkdir(i){try{await y.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const o=this.C(i);n.recursive?await y.Promises.rm(o,y.RimRafMode.MOVE):await y.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(i,n,o){const u=this.C(i),d=this.C(n);if(u!==d)try{await this.S(i,n,"move",o.overwrite),await y.Promises.move(u,d)}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,w.localize)(2,null,(0,p.basename)(u),(0,p.basename)((0,p.dirname)(d)),I.toString()))),this.Y(I)}}async copy(i,n,o){const u=this.C(i),d=this.C(n);if(u!==d)try{await this.S(i,n,"copy",o.overwrite),await y.Promises.copy(u,d,{preserveSymlinks:!0})}catch(I){throw(I.code==="EINVAL"||I.code==="EBUSY"||I.code==="ENAMETOOLONG")&&(I=new Error((0,w.localize)(3,null,(0,p.basename)(u),(0,p.basename)((0,p.dirname)(d)),I.toString()))),this.Y(I)}}async S(i,n,o,u){const d=this.C(i),I=this.C(n);let A=!1;if(!!(this.capabilities&1024)||(A=(0,h.isEqual)(d,I,!0)),A&&o==="copy")throw(0,r.createFileSystemProviderError)((0,w.localize)(4,null),r.FileSystemProviderErrorCode.FileExists);if(!A&&await y.Promises.exists(I)){if(!u)throw(0,r.createFileSystemProviderError)((0,w.localize)(5,null),r.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,o){const u=this.C(i),d=this.C(n),I=!!(this.capabilities&1024);if((0,h.isEqual)(u,d,!I))return;const A=new l.DisposableStore;try{const[C,T]=await Promise.all([this.I(i),this.I(n)]);A.add(C),A.add(T),o&&await y.Promises.mkdir((0,p.dirname)(d),{recursive:!0}),await y.Promises.copyFile(u,d)}catch(C){if(C.code==="ENOENT"&&!o)return this.U(i,n,!0);throw this.Y(C)}finally{A.dispose()}}p(i,n,o){return new S.UniversalWatcherClient(u=>i(u),u=>n(u),o)}y(i,n,o){return new D.NodeJSWatcherClient(u=>i(u),u=>n(u),o)}Y(i){if(i instanceof r.FileSystemProviderError)return i;let n=i,o;switch(i.code){case"ENOENT":o=r.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":o=r.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":o=r.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":o=r.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":o=r.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":n=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,o=r.FileSystemProviderErrorCode.Unknown;break;default:o=r.FileSystemProviderErrorCode.Unknown}return(0,r.createFileSystemProviderError)(n,o)}async Z(i,n){let o=this.Y(n);if(i&&o.code===r.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await y.SymlinkSupport.stat(this.C(i));u.mode&128||(o=(0,r.createFileSystemProviderError)(n,r.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return o}}e.DiskFileSystemProvider=t,t.D=!1,t.O=!0}),define(te[219],ie([0,1,4,91,2,17,60,22]),function(x,e,E,M,s,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class h extends s.Disposable{constructor(m,v){super(),this.a=m,this.b=v,this.w=new Map,this.y=new Map}call(m,v,f){const y=this.c(m);switch(v){case"stat":return this.g(y,f[0]);case"readdir":return this.h(y,f[0]);case"open":return this.l(y,f[0],f[1]);case"close":return this.m(f[0]);case"read":return this.n(f[0],f[1],f[2]);case"readFile":return this.i(y,f[0],f[1]);case"write":return this.p(f[0],f[1],f[2],f[3],f[4]);case"writeFile":return this.k(y,f[0],f[1],f[2]);case"rename":return this.t(y,f[0],f[1],f[2]);case"copy":return this.u(y,f[0],f[1],f[2]);case"cloneFile":return this.v(y,f[0],f[1]);case"mkdir":return this.r(y,f[0]);case"delete":return this.s(y,f[0],f[1]);case"watch":return this.C(y,f[0],f[1],f[2],f[3]);case"unwatch":return this.D(f[0],f[1])}throw new Error(`IPC Command ${v} not found`)}listen(m,v,f){const y=this.c(m);switch(v){case"fileChange":return this.z(y,f[0]);case"readFileStream":return this.j(y,f[0],f[1])}throw new Error(`Unknown event ${v}`)}g(m,v){const f=this.f(m,v,!0);return this.a.stat(f)}h(m,v){const f=this.f(m,v);return this.a.readdir(f)}async i(m,v,f){const y=this.f(m,v,!0),w=await this.a.readFile(y,f);return L.VSBuffer.wrap(w)}j(m,v,f){const y=this.f(m,v,!0),w=new k.CancellationTokenSource,r=new E.Emitter({onDidRemoveLastListener:()=>{w.cancel()}}),g=this.a.readFileStream(y,f,w.token);return(0,R.listenStream)(g,{onData:c=>r.fire(L.VSBuffer.wrap(c)),onError:c=>r.fire(c),onEnd:()=>{r.fire("end"),r.dispose(),w.dispose()}}),r.event}k(m,v,f,y){const w=this.f(m,v);return this.a.writeFile(w,f.buffer,y)}l(m,v,f){const y=this.f(m,v,!0);return this.a.open(y,f)}m(m){return this.a.close(m)}async n(m,v,f){const y=L.VSBuffer.alloc(f),w=0,r=await this.a.read(m,v,y.buffer,w,f);return[y,r]}p(m,v,f,y,w){return this.a.write(m,v,f.buffer,y,w)}r(m,v){const f=this.f(m,v);return this.a.mkdir(f)}s(m,v,f){const y=this.f(m,v);return this.a.delete(y,f)}t(m,v,f,y){const w=this.f(m,v),r=this.f(m,f);return this.a.rename(w,r,y)}u(m,v,f,y){const w=this.f(m,v),r=this.f(m,f);return this.a.copy(w,r,y)}v(m,v,f){const y=this.f(m,v),w=this.f(m,f);return this.a.cloneFile(y,w)}z(m,v){const f=new E.Emitter({onWillAddFirstListener:()=>{this.w.set(v,this.F(m,f))},onDidRemoveLastListener:()=>{(0,s.dispose)(this.w.get(v)),this.w.delete(v)}});return f.event}async C(m,v,f,y,w){const r=this.w.get(v);if(r){const g=this.f(m,y),c=r.watch(f,g,w);this.y.set(v+f,c)}}async D(m,v){const f=m+v,y=this.y.get(f);y&&((0,s.dispose)(y),this.y.delete(f))}dispose(){super.dispose();for(const[,m]of this.y)m.dispose();this.y.clear();for(const[,m]of this.w)m.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=h;class l extends s.Disposable{constructor(m,v,f,y){super(),this.c=m,this.f=f,this.g=y,this.a=new Map,this.b=this.B(new M.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(v)}h(m){const v=this.B(new E.Emitter);this.B(v.event(f=>{m.fire(f.map(y=>({resource:this.c.transformOutgoingURI(y.resource),type:y.type})))})),this.B(this.b.onDidChangeFile(f=>v.fire(f))),this.B(this.b.onDidWatchError(f=>m.fire(f)))}i(m){}j(m){}watch(m,v,f){const y=this.j(this.g);return Array.isArray(y)&&(f.excludes=[...f.excludes,...y]),this.a.set(m,this.b.watch(v,f)),(0,s.toDisposable)(()=>{(0,s.dispose)(this.a.get(m)),this.a.delete(m)})}dispose(){super.dispose();for(const[,m]of this.a)m.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=l}),define(te[220],ie([0,1,14,174,3,8,16,9,219,149]),function(x,e,E,M,s,L,R,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class p extends h.AbstractDiskFileSystemProviderChannel{constructor(f,y,w){super(f,y),this.G=w}c(f){return l.DefaultURITransformer}f(f,y){return L.URI.revive(y)}async s(f,y,w){if(!w.useTrash)return super.s(f,y,w);const r=this.f(f,y),g=(0,k.normalize)(r.fsPath);try{await E.shell.trashItem(g)}catch{throw(0,R.createFileSystemProviderError)(s.isWindows?(0,M.localize)(0,null,(0,k.basename)(g)):(0,M.localize)(1,null,(0,k.basename)(g)),R.FileSystemProviderErrorCode.Unknown)}}F(f,y){return new m(f,y,this.b,this.G)}}e.DiskFileSystemProviderChannel=p;class m extends h.AbstractSessionFileWatcher{watch(f,y,w){if(w.recursive)throw(0,R.createFileSystemProviderError)("Recursive file watching is not supported from main process for performance reasons.",R.FileSystemProviderErrorCode.Unavailable);return super.watch(f,y,w)}}}),define(te[221],ie([0,1,5]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogger=void 0;class M extends E.AbstractMessageLogger{constructor(L=E.DEFAULT_LOG_LEVEL){super(),this.k=[],this.l=void 0,this.setLevel(L),this.B(this.onDidChangeLogLevel(R=>{this.l?.setLevel(R)}))}set logger(L){this.l=L;for(const{level:R,message:k}of this.k)(0,E.log)(L,R,k);this.k=[]}g(L,R){this.l?(0,E.log)(this.l,L,R):this.getLevel()<=L&&this.k.push({level:L,message:R})}dispose(){this.l?.dispose()}flush(){this.l?.flush()}}e.BufferLogger=M}),define(te[222],ie([0,1,2,5]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class s extends E.Disposable{constructor(R,k=[]){super(),this.a=new M.MultiplexLogger([R,...k]),this.B(R.onDidChangeLogLevel(h=>this.setLevel(h)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...k){this.a.trace(R,...k)}debug(R,...k){this.a.debug(R,...k)}info(R,...k){this.a.info(R,...k)}warn(R,...k){this.a.warn(R,...k)}error(R,...k){this.a.error(R,...k)}flush(){this.a.flush()}}e.LogService=s}),define(te[223],ie([0,1,35,8,5]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerChannel=void 0;class L{constructor(k){this.b=k,this.a=new E.ResourceMap}listen(k,h,l){switch(h){case"onDidChangeLoggers":return l?this.b.getOnDidChangeLoggersEvent(l):this.b.onDidChangeLoggers;case"onDidChangeLogLevel":return l?this.b.getOnDidChangeLogLevelEvent(l):this.b.onDidChangeLogLevel;case"onDidChangeVisibility":return l?this.b.getOnDidChangeVisibilityEvent(l):this.b.onDidChangeVisibility}throw new Error(`Event not found: ${h}`)}async call(k,h,l){switch(h){case"createLogger":this.c(M.URI.revive(l[0]),l[1],l[2]);return;case"log":return this.e(M.URI.revive(l[0]),l[1]);case"consoleLog":return this.d(l[0],l[1]);case"setLogLevel":return(0,s.isLogLevel)(l[0])?this.b.setLogLevel(l[0]):this.b.setLogLevel(M.URI.revive(l[0]),l[1]);case"setVisibility":return this.b.setVisibility(M.URI.revive(l[0]),l[1]);case"registerLogger":return this.b.registerLogger({...l[0],resource:M.URI.revive(l[0].resource)},l[1]);case"deregisterLogger":return this.b.deregisterLogger(M.URI.revive(l[0]))}throw new Error(`Call not found: ${h}`)}c(k,h,l){this.a.set(k,this.b.createLogger(k,h,l))}d(k,h){let l=console.log;switch(k){case s.LogLevel.Error:l=console.error;break;case s.LogLevel.Warning:l=console.warn;break;case s.LogLevel.Info:l=console.info;break}l.call(console,...h)}e(k,h){const l=this.a.get(k);if(!l)throw new Error("Create the logger before logging");for(const[p,m]of h)(0,s.log)(l,p,m)}}e.LoggerChannel=L}),define(te[224],ie([0,1,16,5]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var s;(function(l){l[l.Trace=0]="Trace",l[l.Debug=1]="Debug",l[l.Info=2]="Info",l[l.Warning=3]="Warning",l[l.Error=4]="Error",l[l.Critical=5]="Critical",l[l.Off=6]="Off"})(s||(s={}));async function L(l,p,m,v,f){try{const y=await new Promise((r,g)=>{x(["@vscode/spdlog"],r,g)});y.setFlushOn(s.Trace);const w=await y.createAsyncRotatingLogger(l,p,m,v);return f?w.clearFormatters():w.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),w}catch(y){console.error(y)}return null}function R(l,p,m){switch(p){case M.LogLevel.Trace:l.trace(m);break;case M.LogLevel.Debug:l.debug(m);break;case M.LogLevel.Info:l.info(m);break;case M.LogLevel.Warning:l.warn(m);break;case M.LogLevel.Error:l.error(m);break;case M.LogLevel.Off:break;default:throw new Error(`Invalid log level ${p}`)}}function k(l,p){switch(p){case M.LogLevel.Trace:l.setLevel(s.Trace);break;case M.LogLevel.Debug:l.setLevel(s.Debug);break;case M.LogLevel.Info:l.setLevel(s.Info);break;case M.LogLevel.Warning:l.setLevel(s.Warning);break;case M.LogLevel.Error:l.setLevel(s.Error);break;case M.LogLevel.Off:l.setLevel(s.Off);break;default:throw new Error(`Invalid log level ${p}`)}}class h extends M.AbstractMessageLogger{constructor(p,m,v,f,y){super(),this.k=[],this.setLevel(y),this.l=this.n(p,m,v,f),this.B(this.onDidChangeLogLevel(w=>{this.m&&k(this.m,w)}))}async n(p,m,v,f){const y=v?6:1,w=30/y*E.ByteSize.MB,r=await L(p,m,w,y,f);if(r){this.m=r,k(this.m,this.getLevel());for(const{level:g,message:c}of this.k)R(this.m,g,c);this.k=[]}}g(p,m){this.m?R(this.m,p,m):this.getLevel()<=p&&this.k.push({level:p,message:m})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=h}),define(te[225],ie([0,1,31,5,224]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class L extends M.AbstractLoggerService{m(k,h,l){return new s.SpdLogLogger((0,E.generateUuid)(),k.fsPath,!l?.donotRotate,!!l?.donotUseFormatters,h)}}e.LoggerService=L}),define(te[65],ie([0,1,35,4,6,5,225]),function(x,e,E,M,s,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerMainService=e.ILoggerMainService=void 0,e.ILoggerMainService=(0,s.refineServiceDecorator)(L.ILoggerService);class k extends R.LoggerService{constructor(){super(...arguments),this.p=new E.ResourceMap}createLogger(l,p,m){m!==void 0&&this.p.set(this.l(l),m);try{return super.createLogger(l,p)}catch(v){throw this.p.delete(this.l(l)),v}}registerLogger(l,p){p!==void 0&&this.p.set(l.resource,p),super.registerLogger(l)}deregisterLogger(l){this.p.delete(l),super.deregisterLogger(l)}getRegisteredLoggers(l){const p=[];for(const m of super.getRegisteredLoggers())l===this.p.get(m.resource)&&p.push(m);return p}getOnDidChangeLogLevelEvent(l){return M.Event.filter(this.onDidChangeLogLevel,p=>(0,L.isLogLevel)(p)||this.s(p[0],l))}getOnDidChangeVisibilityEvent(l){return M.Event.filter(this.onDidChangeVisibility,([p])=>this.s(p,l))}getOnDidChangeLoggersEvent(l){return M.Event.filter(M.Event.map(this.onDidChangeLoggers,p=>({added:[...p.added].filter(v=>this.s(v.resource,l)),removed:[...p.removed].filter(v=>this.s(v.resource,l))})),p=>p.added.length>0||p.removed.length>0)}deregisterLoggers(l){for(const[p,m]of this.p)m===l&&this.deregisterLogger(p)}s(l,p){const m=this.p.get(l);return m===void 0||m===p}dispose(){super.dispose(),this.p.clear()}}e.LoggerMainService=k}),define(te[226],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function E(R){return R.submenu!==void 0}e.isMenubarMenuItemSubmenu=E;function M(R){return R.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=M;function s(R){return R.uri!==void 0}e.isMenubarMenuItemRecentAction=s;function L(R){return!E(R)&&!M(R)&&!s(R)}e.isMenubarMenuItemAction=L}),define(te[37],ie([0,1,4,68,2,6]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class R extends s.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(l){const p=Object.keys(this.f).length;return this.f={...l,...this.f},p!==Object.keys(this.f).length&&await this.i(l),M.Iterable.reduce(this.g.entries(),(m,[v,f])=>({...m,[v]:f}),{})}getPolicyValue(l){return this.g.get(l)}serialize(){return M.Iterable.reduce(Object.entries(this.f),(l,[p,m])=>({...l,[p]:{definition:m,value:this.g.get(p)}}),{})}}e.AbstractPolicyService=R;class k{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(te[227],ie([0,1,7,4,68,11,16,5,37]),function(x,e,E,M,s,L,R,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FilePolicyService=void 0;function l(m,v){const f=[];for(const y of new Set(s.Iterable.concat(m.keys(),v.keys())))m.get(y)!==v.get(y)&&f.push(y);return f}let p=e.FilePolicyService=class extends h.AbstractPolicyService{constructor(v,f,y){super(),this.j=v,this.k=f,this.l=y,this.c=this.B(new E.ThrottledDelayer(500));const w=M.Event.filter(f.onDidFilesChange,r=>r.affects(v));this.B(f.watch(v)),this.B(w(()=>this.c.trigger(()=>this.p())))}async i(){await this.p()}async n(){const v=new Map;try{const f=await this.k.readFile(this.j),y=JSON.parse(f.value.toString());if(!(0,L.isObject)(y))throw new Error("Policy file isn't a JSON object");for(const w of Object.keys(y))this.f[w]&&v.set(w,y[w])}catch(f){f.fileOperationResult!==1&&this.l.error("[FilePolicyService] Failed to read policies",f)}return v}async p(){const v=await this.n(),f=l(this.g,v);this.g=v,f.length>0&&this.h.fire(f)}};e.FilePolicyService=p=be([Q(1,R.IFileService),Q(2,k.ILogService)],p)}),define(te[228],ie([0,1,4,2,37]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(h){this.b=h,this.a=new M.DisposableStore}listen(h,l){switch(l){case"onDidChange":return E.Event.map(this.b.onDidChange,p=>p.reduce((m,v)=>({...m,[v]:this.b.getPolicyValue(v)??null}),{}),this.a)}throw new Error(`Event not found: ${l}`)}call(h,l,p){switch(l){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(p)}throw new Error(`Call not found: ${l}`)}dispose(){this.a.dispose()}}e.PolicyChannel=L;class R extends s.AbstractPolicyService{constructor(h,l){super(),this.a=l;for(const p in h){const{definition:m,value:v}=h[p];this.f[p]=m,v!==void 0&&this.g.set(p,v)}this.a.listen("onDidChange")(p=>{for(const m in p){const v=p[m];v===null?this.g.delete(m):this.g.set(m,v)}this.h.fire(Object.keys(p))})}async i(h){const l=await this.a.call("updatePolicyDefinitions",h);for(const p in l)this.g.set(p,l[p])}}e.PolicyChannelClient=R}),define(te[229],ie([0,1,37,7,295,2,5]),function(x,e,E,M,s,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativePolicyService=void 0;let k=e.NativePolicyService=class extends E.AbstractPolicyService{constructor(l,p){super(),this.j=l,this.k=p,this.a=new M.Throttler,this.b=this.B(new L.MutableDisposable)}async i(l){this.j.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`),await this.a.queue(()=>new Promise((p,m)=>{try{this.b.value=(0,s.createWatcher)(this.k,l,v=>{this.m(v),p()})}catch(v){this.j.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),m(v)}}))}m(l){this.j.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const p in l){const m=l[p];m===void 0?this.g.delete(p):this.g.set(p,m)}this.h.fire(Object.keys(l))}};e.NativePolicyService=k=be([Q(0,R.ILogService)],k)}),define(te[76],ie([0,1,3,36]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let s;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const L=E.globals.vscode.context.configuration();if(L)s=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(s=globalThis._VSCODE_PRODUCT_JSON,M.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`,serverDataFolderName:s.serverDataFolderName?`${s.serverDataFolderName}-dev`:void 0}),!s.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(s,{version:L.version})}}else s={},Object.keys(s).length===0&&Object.assign(s,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=s}),define(te[21],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(te[230],ie([0,1,69,5,21]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let L=e.ExtensionUrlTrustService=class{constructor(k,h){this.b=k,this.c=h,this.a=new Map}async isExtensionUrlTrusted(k,h){if(!this.b.trustedExtensionUrlPublicKeys)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const l=/^(.*)#([^#]+)$/.exec(h);if(!l)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",h),!1;const[,p,m]=l;let v=this.a.get(k);if(!v){if(v=this.b.trustedExtensionUrlPublicKeys[k],!v||v.length===0)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",k),!1;this.a.set(k,[...v])}const f=Buffer.from(decodeURIComponent(m),"base64");if(f.length<=6)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",h),!1;const y=f.slice(0,6),w=f.readUIntBE(0,6),r=Date.now()-w;if(r<0||r>36e5)return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",h),!1;const g=f.slice(6),c=E.createVerify("SHA256");c.write(y),c.write(Buffer.from(p)),c.end();for(let b=0;b<v.length;b++){let S=v[b];if(S!==null){if(typeof S=="string")try{S=E.createPublicKey({key:Buffer.from(S,"base64"),format:"der",type:"spki"}),v[b]=S}catch(D){this.c.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${b+1} for ${k}:`,D),v[b]=null;continue}if(c.verify(S,g))return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",h),!0}}return this.c.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",h),!1}};e.ExtensionUrlTrustService=L=be([Q(0,s.IProductService),Q(1,M.ILogService)],L)}),define(te[231],ie([0,1,7,5]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowProfiler=void 0;let s=e.WindowProfiler=class{constructor(R,k,h){this.a=R,this.b=k,this.c=h}async inspect(R){await this.d();const k=this.a.webContents.debugger;await k.sendCommand("Profiler.start"),this.c.warn("[perf] profiling STARTED",this.b),await(0,E.timeout)(R);const h=await k.sendCommand("Profiler.stop");return this.c.warn("[perf] profiling DONE",this.b),await this.e(),h.profile}async d(){const R=this.a.webContents.debugger;R.attach(),await R.sendCommand("Profiler.enable")}async e(){const R=this.a.webContents.debugger;await R.sendCommand("Profiler.disable"),R.detach()}};e.WindowProfiler=s=be([Q(2,M.ILogService)],s)}),define(te[77],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,E.createDecorator)("protocolMainService")}),define(te[51],ie([0,1,127,11]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class s{constructor(){this.a=new Map}add(R,k){E.ok(M.isString(R)),E.ok(M.isObject(k)),E.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,k)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.Registry=new s}),define(te[232],ie([0,1,4,51]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function s(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class L{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,l){this.a[s(h)]=l,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const R=new L;M.Registry.add(e.Extensions.JSONContribution,R)}),define(te[66],ie([0,1,23,4,11,159,19,232,51]),function(x,e,E,M,s,L,R,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var l;(function(D){D.Multiline="multilineText",D.Singleline="singlelineText"})(l||(e.EditPresentationTypes=l={})),e.Extensions={Configuration:"base.contributions.configuration"};var p;(function(D){D[D.APPLICATION=1]="APPLICATION",D[D.MACHINE=2]="MACHINE",D[D.WINDOW=3]="WINDOW",D[D.RESOURCE=4]="RESOURCE",D[D.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",D[D.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(p||(e.ConfigurationScope=p={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const m=h.Registry.as(k.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new M.Emitter,this.onDidSchemaChange=this.i.event,this.j=new M.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,a=!0){this.registerConfigurations([t],a)}registerConfigurations(t,a=!0){const i=new Set;this.n(t,a,i),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const a=new Set;this.o(t,a),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:t,remove:a}){const i=new Set;this.o(a,i),this.n(t,!1,i),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const a=new Set;this.k(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(t,a){const i=[];for(const{overrides:n,source:o}of t)for(const u in n)if(a.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const d=this.a.get(u),I=d?.valuesSources??new Map;if(o)for(const W of Object.keys(n[u]))I.set(W,o);const A={...d?.value||{},...n[u]};this.a.set(u,{source:o,value:A,valuesSources:I});const C=(0,R.getLanguageTagSettingPlainKey)(u),T={type:"object",default:A,description:L.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:A,source:s.isString(o)?void 0:o,defaultValueSource:o};i.push(...w(u)),this.d[u]=T,this.b.properties[u]=T}else{this.a.set(u,{value:n[u],source:o});const d=this.d[u];d&&(this.w(u,d),this.r(u,d))}this.m(i)}deregisterDefaultConfigurations(t){const a=new Set;this.l(t,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(t,a){for(const{overrides:i,source:n}of t)for(const o in i){const u=this.a.get(o),d=s.isString(n)?n:n?.id,I=s.isString(u?.source)?u?.source:u?.source?.id;if(d===I)if(a.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const A=this.d[o];A&&(this.w(o,A),this.r(o,A))}}this.u()}deltaConfiguration(t){let a=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),a=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),a=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const a of t)this.h.add(a);this.u()}n(t,a,i){t.forEach(n=>{this.p(n,a,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,a){const i=n=>{if(n.properties)for(const o in n.properties){a.add(o);const u=this.d[o];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[o],this.s(o,n.properties[o])}n.allOf?.forEach(o=>i(o))};for(const n of t){i(n);const o=this.c.indexOf(n);o!==-1&&this.c.splice(o,1)}}p(t,a=!0,i,n,o=3,u){o=s.isUndefinedOrNull(t.scope)?o:t.scope;const d=t.properties;if(d)for(const A in d){const C=d[A];if(a&&b(A,C)){delete d[A];continue}if(C.source=i,C.defaultDefaultValue=d[A].default,this.w(A,C),e.OVERRIDE_PROPERTY_REGEX.test(A)?C.scope=void 0:(C.scope=s.isUndefinedOrNull(C.scope)?o:C.scope,C.restricted=s.isUndefinedOrNull(C.restricted)?!!n?.includes(A):C.restricted),d[A].hasOwnProperty("included")&&!d[A].included){this.f[A]=d[A],delete d[A];continue}else this.d[A]=d[A],d[A].policy?.name&&this.e.set(d[A].policy.name,A);!d[A].deprecationMessage&&d[A].markdownDeprecationMessage&&(d[A].deprecationMessage=d[A].markdownDeprecationMessage),u.add(A)}const I=t.allOf;if(I)for(const A of I)this.p(A,a,i,n,o,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const a=i=>{const n=i.properties;if(n)for(const u in n)this.r(u,n[u]);i.allOf?.forEach(a)};a(t)}r(t,a){switch(e.allSettings.properties[t]=a,a.scope){case 1:e.applicationSettings.properties[t]=a;break;case 2:e.machineSettings.properties[t]=a;break;case 6:e.machineOverridableSettings.properties[t]=a;break;case 3:e.windowSettings.properties[t]=a;break;case 4:e.resourceSettings.properties[t]=a;break;case 5:e.resourceSettings.properties[t]=a,this.g.properties[t]=a;break}}s(t,a){switch(delete e.allSettings.properties[t],a.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const a=`[${t}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,i),e.allSettings.properties[a]=i,e.applicationSettings.properties[a]=i,e.machineSettings.properties[a]=i,e.machineOverridableSettings.properties[a]=i,e.windowSettings.properties[a]=i,e.resourceSettings.properties[a]=i}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,a){const i=this.a.get(t);let n=i?.value,o=i?.source;s.isUndefined(n)&&(n=a.defaultDefaultValue,o=void 0),s.isUndefined(n)&&(n=g(a.type)),a.default=n,a.defaultValueSource=o}}const f="\\[([^\\]]+)\\]",y=new RegExp(f,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${f})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function w(D){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(D)){let a=y.exec(D);for(;a?.length;){const i=a[1].trim();i&&t.push(i),a=y.exec(D)}}return(0,E.distinct)(t)}e.overrideIdentifiersFromKey=w;function r(D){return D.reduce((t,a)=>`${t}[${a}]`,"")}e.keyFromOverrideIdentifiers=r;function g(D){switch(Array.isArray(D)?D[0]:D){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=g;const c=new v;h.Registry.add(e.Extensions.Configuration,c);function b(D,t){return D.trim()?e.OVERRIDE_PROPERTY_REGEX.test(D)?L.localize(7,null,D):c.getConfigurationProperties()[D]!==void 0?L.localize(8,null,D):t.policy?.name&&c.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,D,t.policy?.name,c.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.validateProperty=b;function S(){const D=[],t=c.getConfigurationProperties();for(const a of Object.keys(t))D.push([a,t[a].scope]);return D.push(["launch",4]),D.push(["task",4]),D}e.getScopes=S}),define(te[113],ie([0,1,23,4,43,2,35,40,11,8,19,66,51]),function(x,e,E,M,s,L,R,k,h,l,p,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function f(a){return Object.isFrozen(a)?a:k.deepFreeze(a)}class y{constructor(i={},n=[],o=[],u){this.b=i,this.c=n,this.d=o,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof y)return n;const o=new w("");return o.parseRaw(n),o.configurationModel});this.f=i.reduce((n,o)=>o===n?o:n.merge(o),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,p.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const o=this.rawConfiguration.getValue(i),u=n?this.rawConfiguration.getOverrideValue(i,n):void 0,d=n?this.rawConfiguration.override(n).getValue(i):o;return{value:o,override:u,merged:d}}getOverrideValue(i,n){const o=this.i(n);return o?i?(0,p.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const o of this.overrides)o.identifiers.includes(i)&&n.push(...o.keys);return E.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return E.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=k.deepClone(this.contents),o=k.deepClone(this.overrides),u=[...this.keys],d=this.raw?.length?[...this.raw]:[this];for(const I of i)if(d.push(...I.raw?.length?I.raw:[I]),!I.isEmpty()){this.h(n,I.contents);for(const A of I.overrides){const[C]=o.filter(T=>E.equals(T.identifiers,A.identifiers));C?(this.h(C.contents,A.contents),C.keys.push(...A.keys),C.keys=E.distinct(C.keys)):o.push(k.deepClone(A))}for(const A of I.keys)u.indexOf(A)===-1&&u.push(A)}return new y(n,u,o,d.every(I=>I instanceof y)?void 0:d)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const u of E.distinct([...Object.keys(this.contents),...Object.keys(n)])){let d=this.contents[u];const I=n[u];I&&(typeof d=="object"&&typeof I=="object"?(d=k.deepClone(d),this.h(d,I)):d=I),o[u]=d}return new y(o,this.keys,this.overrides)}h(i,n){for(const o of Object.keys(n)){if(o in i&&h.isObject(i[o])&&h.isObject(n[o])){this.h(i[o],n[o]);continue}i[o]=k.deepClone(n[o])}}i(i){let n=null,o=null;const u=d=>{d&&(o?this.h(o,d):o=k.deepClone(d))};for(const d of this.overrides)E.equals(d.identifiers,[i])?n=d.contents:d.identifiers.includes(i)&&u(d.contents);return u(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,p.removeFromValueTree)(this.contents,i),m.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>E.equals(o.identifiers,(0,m.overrideIdentifiersFromKey)(i))),1))}j(i,n,o){(0,p.addToValueTree)(this.contents,i,n,u=>console.error(u)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),m.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,m.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,p.toValuesTree)(this.contents[i],u=>console.error(u))})}}e.ConfigurationModel=y;class w{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new y}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!h.isUndefinedOrNull(i)){const o=this.g(i);this.parseRaw(o,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:o,keys:u,overrides:d,restricted:I,hasExcludedProperties:A}=this.h(i,n);this.b=new y(o,u,d,A?[i]:void 0),this.c=I||[]}g(i){let n={},o=null,u=[];const d=[],I=[];function A(T){Array.isArray(u)?u.push(T):o!==null&&(u[o]=T)}const C={onObjectBegin:()=>{const T={};A(T),d.push(u),u=T,o=null},onObjectProperty:T=>{o=T},onObjectEnd:()=>{u=d.pop()},onArrayBegin:()=>{const T=[];A(T),d.push(u),u=T,o=null},onArrayEnd:()=>{u=d.pop()},onLiteralValue:A,onError:(T,W,$)=>{I.push({error:T,offset:W,length:$})}};if(i)try{s.visit(i,C),n=u[0]||{}}catch(T){console.error(`Error while parsing settings file ${this.f}: ${T}`),this.d=[T]}return n}h(i,n){const o=v.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),u=this.i(i,o,!0,n);i=u.raw;const d=(0,p.toValuesTree)(i,C=>console.error(`Conflict in settings file ${this.f}: ${C}`)),I=Object.keys(i),A=this.j(i,C=>console.error(`Conflict in settings file ${this.f}: ${C}`));return{contents:d,keys:I,overrides:A,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(i,n,o,u){let d=!1;if(!u?.scopes&&!u?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:d};const I={},A=[];for(const C in i)if(m.OVERRIDE_PROPERTY_REGEX.test(C)&&o){const T=this.i(i[C],n,!1,u);I[C]=T.raw,d=d||T.hasExcludedProperties,A.push(...T.restricted)}else{const T=n[C],W=T?typeof T.scope<"u"?T.scope:3:void 0;T?.restricted&&A.push(C),(W===void 0||u.scopes===void 0||u.scopes.includes(W))&&!(u.skipRestricted&&T?.restricted)?I[C]=i[C]:d=!0}return{raw:I,restricted:A,hasExcludedProperties:d}}j(i,n){const o=[];for(const u of Object.keys(i))if(m.OVERRIDE_PROPERTY_REGEX.test(u)){const d={};for(const I in i[u])d[I]=i[u][I];o.push({identifiers:(0,m.overrideIdentifiersFromKey)(u),keys:Object.keys(d),contents:(0,p.toValuesTree)(d,n)})}return o}}e.ConfigurationModelParser=w;class r extends L.Disposable{constructor(i,n,o,u){super(),this.f=i,this.g=n,this.h=u,this.c=this.B(new M.Emitter),this.onDidChange=this.c.event,this.a=new w(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(M.Event.any(M.Event.filter(this.h.onDidFilesChange,d=>d.contains(this.f)),M.Event.filter(this.h.onDidRunOperation,d=>(d.isOperation(0)||d.isOperation(3)||d.isOperation(1)||d.isOperation(4))&&o.isEqual(d.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new y}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=r;class g{constructor(i,n,o,u,d,I,A,C,T,W,$,H,Z){this.a=i,this.b=n,this.c=o,this.overrideIdentifiers=u,this.d=d,this.f=I,this.g=A,this.h=C,this.i=T,this.j=W,this.k=$,this.l=H,this.m=Z}get value(){return f(this.c)}n(i,n,o){const u=i.inspect(n,o);return{get value(){return f(u.value)},get override(){return f(u.override)},get merged(){return f(u.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class c{constructor(i,n,o,u,d=new y,I=new y,A=new R.ResourceMap,C=new y,T=new R.ResourceMap){this.c=i,this.d=n,this.f=o,this.g=u,this.h=d,this.i=I,this.j=A,this.l=C,this.m=T,this.a=null,this.b=new R.ResourceMap,this.n=null}getValue(i,n,o){return this.q(i,n,o).getValue(i)}updateValue(i,n,o={}){let u;o.resource?(u=this.m.get(o.resource),u||(u=new y,this.m.set(o.resource,u))):u=this.l,n===void 0?u.removeValue(i):u.setValue(i,n),o.resource||(this.a=null)}inspect(i,n,o){const u=this.q(i,n,o),d=this.u(n.resource,o),I=n.resource?this.m.get(n.resource)||this.l:this.l,A=new Set;for(const C of u.overrides)for(const T of C.identifiers)u.getOverrideValue(i,T)!==void 0&&A.add(T);return new g(i,n,u.getValue(i),A.size?[...A]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,d||void 0,I)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const o=[];if(!n){const{added:u,updated:d,removed:I}=D(this.c,i);n=[...u,...d,...I]}for(const u of n)for(const d of(0,m.overrideIdentifiersFromKey)(u)){const I=this.c.getKeysForOverrideIdentifier(d),A=i.getKeysForOverrideIdentifier(d),C=[...A.filter(T=>I.indexOf(T)===-1),...I.filter(T=>A.indexOf(T)===-1),...I.filter(T=>!k.equals(this.c.override(d).getValue(T),i.override(d).getValue(T)))];o.push([d,C])}return this.updateDefaultConfiguration(i),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:o,removed:u}=D(this.d,i),d=[...n,...o,...u];return d.length&&this.updatePolicyConfiguration(i),{keys:d,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:o,removed:u,overrides:d}=D(this.applicationConfiguration,i),I=[...n,...o,...u];return I.length&&this.updateApplicationConfiguration(i),{keys:I,overrides:d}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:o,removed:u,overrides:d}=D(this.localUserConfiguration,i),I=[...n,...o,...u];return I.length&&this.updateLocalUserConfiguration(i),{keys:I,overrides:d}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:o,removed:u,overrides:d}=D(this.remoteUserConfiguration,i),I=[...n,...o,...u];return I.length&&this.updateRemoteUserConfiguration(i),{keys:I,overrides:d}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:o,removed:u,overrides:d}=D(this.workspaceConfiguration,i),I=[...n,...o,...u];return I.length&&this.updateWorkspaceConfiguration(i),{keys:I,overrides:d}}compareAndUpdateFolderConfiguration(i,n){const o=this.p.get(i),{added:u,updated:d,removed:I,overrides:A}=D(o,n),C=[...u,...d,...I];return(C.length||!o)&&this.updateFolderConfiguration(i,n),{keys:C,overrides:A}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:u,removed:d,overrides:I}=D(n,void 0);return{keys:[...o,...u,...d],overrides:I}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,o){let u=this.r(n,o);return n.overrideIdentifier&&(u=u.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(u=u.merge(this.d)),u}r({resource:i},n){let o=this.s();if(n&&i){const u=n.getFolder(i);u&&(o=this.t(u.uri)||o);const d=this.m.get(i);d&&(o=o.merge(d))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const o=this.s(),u=this.j.get(i);u?(n=o.merge(u),this.b.set(i,n)):n=o}return n}u(i,n){if(n&&i){const o=n.getFolder(i);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:o,overrides:u,keys:d}=this.j.get(n);return i.push([n,{contents:o,overrides:u,keys:d}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(o=>i.add(o))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.i.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(u=>n.add(u))),[...n.values()]}static parse(i){const n=this.x(i.defaults),o=this.x(i.policy),u=this.x(i.application),d=this.x(i.user),I=this.x(i.workspace),A=i.folders.reduce((C,T)=>(C.set(l.URI.revive(T[0]),this.x(T[1])),C),new R.ResourceMap);return new c(n,o,u,d,new y,I,A,new y,new R.ResourceMap)}static x(i){return new y(i.contents,i.keys,i.overrides)}}e.Configuration=c;function b(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const i=new Set,n=new Map;for(const u of a)u.keys.forEach(d=>i.add(d)),u.overrides.forEach(([d,I])=>{const A=(0,R.getOrSet)(n,d,new Set);I.forEach(C=>A.add(C))});const o=[];return n.forEach((u,d)=>o.push([d,[...u.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=b;class S{constructor(i,n,o,u){this.change=i,this.f=n,this.g=o,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const d of i.keys)this.affectedKeys.add(d);for(const[,d]of i.overrides)for(const I of d)this.affectedKeys.add(I);this.d=this.a;for(const d of this.affectedKeys)this.d+=d+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=c.parse(this.f.data)),this.i}affectsConfiguration(i,n){const o=this.a+i,u=this.d.indexOf(o);if(u<0)return!1;const d=u+o.length;if(d>=this.d.length)return!1;const I=this.d.charCodeAt(d);if(I!==this.b&&I!==this.c)return!1;if(n){const A=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,C=this.g.getValue(i,n,this.h);return!k.equals(A,C)}return!0}}e.ConfigurationChangeEvent=S;function D(a,i){const{added:n,removed:o,updated:u}=t(i?.rawConfiguration,a?.rawConfiguration),d=[],I=a?.getAllOverrideIdentifiers()||[],A=i?.getAllOverrideIdentifiers()||[];if(i){const C=A.filter(T=>!I.includes(T));for(const T of C)d.push([T,i.getKeysForOverrideIdentifier(T)])}if(a){const C=I.filter(T=>!A.includes(T));for(const T of C)d.push([T,a.getKeysForOverrideIdentifier(T)])}if(i&&a){for(const C of I)if(A.includes(C)){const T=t({contents:a.getOverrideValue(void 0,C)||{},keys:a.getKeysForOverrideIdentifier(C)},{contents:i.getOverrideValue(void 0,C)||{},keys:i.getKeysForOverrideIdentifier(C)});d.push([C,[...T.added,...T.removed,...T.updated]])}}return{added:n,removed:o,updated:u,overrides:d}}function t(a,i){const n=a?i?a.keys.filter(d=>i.keys.indexOf(d)===-1):[...a.keys]:[],o=i?a?i.keys.filter(d=>a.keys.indexOf(d)===-1):[...i.keys]:[],u=[];if(a&&i){for(const d of i.keys)if(a.keys.indexOf(d)!==-1){const I=(0,p.getConfigurationValue)(i.contents,d),A=(0,p.getConfigurationValue)(a.contents,d);k.equals(I,A)||u.push(d)}}return{added:n,removed:o,updated:u}}}),define(te[233],ie([0,1,23,4,2,40,11,113,66,5,37,51]),function(x,e,E,M,s,L,R,k,h,l,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class v extends s.Disposable{constructor(){super(...arguments),this.a=this.B(new M.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(m.Registry.as(h.Extensions.Configuration).onDidUpdateConfiguration(({properties:r,defaultsOverrides:g})=>this.c(Array.from(r),g))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(r,g){this.h(r,m.Registry.as(h.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:r})}f(){return{}}g(){this.b=new k.ConfigurationModel;const r=m.Registry.as(h.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(r),r)}h(r,g){const c=this.f();for(const b of r){const S=c[b],D=g[b];S!==void 0?this.b.addValue(b,S):D?this.b.addValue(b,D.default):this.b.removeValue(b)}}}e.DefaultConfiguration=v;class f{constructor(){this.onDidChangeConfiguration=M.Event.None,this.configurationModel=new k.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=f;let y=e.PolicyConfiguration=class extends s.Disposable{get configurationModel(){return this.b}constructor(r,g,c){super(),this.c=r,this.f=g,this.g=c,this.a=this.B(new M.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(r=>this.i(r))),this.B(this.c.onDidChangeConfiguration(async({properties:r})=>this.j(await this.h(r),!0))),this.b}async h(r){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",r);const g={},c=[],b=m.Registry.as(h.Extensions.Configuration).getConfigurationProperties();for(const S of r){const D=b[S];if(!D){c.push(S);continue}if(D.policy){if(D.type!=="string"&&D.type!=="number"){this.g.warn(`Policy ${D.policy.name} has unsupported type ${D.type}`);continue}c.push(S),g[D.policy.name]={type:D.type}}}return(0,R.isEmptyObject)(g)||await this.f.updatePolicyDefinitions(g),c}i(r){this.g.trace("PolicyConfiguration#onDidChangePolicies",r);const g=m.Registry.as(h.Extensions.Configuration).getPolicyConfigurations(),c=(0,E.coalesce)(r.map(b=>g.get(b)));this.j(c,!0)}j(r,g){this.g.trace("PolicyConfiguration#update",r);const c=m.Registry.as(h.Extensions.Configuration).getConfigurationProperties(),b=[],S=this.b.isEmpty();for(const D of r){const t=c[D]?.policy?.name;if(t){const a=this.f.getPolicyValue(t);(S?a!==void 0:!(0,L.equals)(this.b.getValue(D),a))&&b.push([D,a])}else this.b.getValue(D)!==void 0&&b.push([D,void 0])}if(b.length){this.g.trace("PolicyConfiguration#changed",b);const D=this.b;this.b=new k.ConfigurationModel;for(const t of D.keys)this.b.setValue(t,D.getValue(t));for(const[t,a]of b)a===void 0?this.b.removeValue(t):this.b.setValue(t,a);g&&this.a.fire(this.b)}}};e.PolicyConfiguration=y=be([Q(1,p.IPolicyService),Q(2,l.ILogService)],y)}),define(te[234],ie([0,1,7,4,2,18,19,113,233,37]),function(x,e,E,M,s,L,R,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class p extends s.Disposable{constructor(v,f,y,w){super(),this.i=v,this.h=this.B(new M.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new h.DefaultConfiguration),this.c=y instanceof l.NullPolicyService?new h.NullPolicyConfiguration:this.B(new h.PolicyConfiguration(this.b,y,w)),this.f=this.B(new k.UserSettings(this.i,void 0,L.extUriBiasedIgnorePathCase,f)),this.a=new k.Configuration(this.b.configurationModel,this.c.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.g=this.B(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:r,properties:g})=>this.k(r,g))),this.B(this.c.onDidChangeConfiguration(r=>this.l(r))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[v,f,y]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new k.Configuration(v,f,new k.ConfigurationModel,y)}getConfigurationData(){return this.a.toData()}getValue(v,f){const y=typeof v=="string"?v:void 0,w=(0,R.isConfigurationOverrides)(v)?v:(0,R.isConfigurationOverrides)(f)?f:{};return this.a.getValue(y,w,void 0)}updateValue(v,f,y,w){return Promise.reject(new Error("not supported"))}inspect(v){return this.a.inspect(v,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const v=await this.f.loadConfiguration();this.j(v)}j(v){const f=this.a.toData(),y=this.a.compareAndUpdateLocalUserConfiguration(v);this.m(y,f,2)}k(v,f){const y=this.a.toData(),w=this.a.compareAndUpdateDefaultConfiguration(v,f);this.m(w,y,7)}l(v){const f=this.a.toData(),y=this.a.compareAndUpdatePolicyConfiguration(v);this.m(y,f,7)}m(v,f,y){const w=new k.ConfigurationChangeEvent(v,{data:f},this.a);w.source=y,w.sourceConfig=this.n(y),this.h.fire(w)}n(v){switch(v){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=p}),define(te[235],ie([0,1,13,6]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,M.createDecorator)("remoteAuthorityResolverService");var s;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(s||(e.RemoteAuthorityResolverErrorCode=s={}));class L extends E.ErrorNoTelemetry{static isNotAvailable(h){return h instanceof L&&h._code===s.NotAvailable}static isTemporarilyNotAvailable(h){return h instanceof L&&h._code===s.TemporarilyNotAvailable}static isNoResolverFound(h){return h instanceof L&&h._code===s.NoResolverFound}static isHandled(h){return h instanceof L&&h.isHandled}constructor(h,l=s.Unknown,p){super(h),this._message=h,this._code=l,this._detail=p,this.isHandled=l===s.NotAvailable&&p===!0,Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L;function R(k){const h=k.indexOf("+");return h===-1?k:k.substring(0,h)}e.getRemoteAuthorityPrefix=R}),define(te[57],ie([0,1,15]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function M(l){return l.scheme===E.Schemas.vscodeRemote?l.authority:void 0}e.getRemoteAuthority=M;function s(l){if(!l)return;const p=l.indexOf("+");return p<0?l:l.substr(0,p)}e.getRemoteName=s;function L(l){return`/${l.quality??"oss"}-${l.commit??"dev"}`}e.getRemoteServerRootPath=L;function R(l){const{host:p,port:m}=h(l);if(typeof m>"u")throw new Error("Remote authority doesn't contain a port!");return{host:p,port:m}}e.parseAuthorityWithPort=R;function k(l,p){let{host:m,port:v}=h(l);return typeof v>"u"&&(v=p),{host:m,port:v}}e.parseAuthorityWithOptionalPort=k;function h(l){const p=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(p)return{host:p[1],port:parseInt(p[2],10)};const m=l.match(/^(\[[0-9a-z:]+\])$/);if(m)return{host:m[1],port:void 0};const v=l.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:l,port:void 0}}}),define(te[114],ie([0,1,27,6,57]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(w){if(typeof w=="object"&&w!==null&&w.supported!==!0)return w.description}e.getWorkspaceSupportTypeMessage=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(w){w[w.System=0]="System",w[w.User=1]="User"})(R||(e.ExtensionType=R={}));var k;(function(w){w.WIN32_X64="win32-x64",w.WIN32_IA32="win32-ia32",w.WIN32_ARM64="win32-arm64",w.LINUX_X64="linux-x64",w.LINUX_ARM64="linux-arm64",w.LINUX_ARMHF="linux-armhf",w.ALPINE_X64="alpine-x64",w.ALPINE_ARM64="alpine-arm64",w.DARWIN_X64="darwin-x64",w.DARWIN_ARM64="darwin-arm64",w.WEB="web",w.UNIVERSAL="universal",w.UNKNOWN="unknown",w.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class h{constructor(r){this.value=r,this.c=r.toLowerCase()}static equals(r,g){if(typeof r>"u"||r===null)return typeof g>"u"||g===null;if(typeof g>"u"||g===null)return!1;if(typeof r=="string"||typeof g=="string"){const c=typeof r=="string"?r:r.value,b=typeof g=="string"?g:g.value;return E.equalsIgnoreCase(c,b)}return r.c===g.c}static toKey(r){return typeof r=="string"?r.toLowerCase():r.c}}e.ExtensionIdentifier=h;class l{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const g of r)this.add(g)}add(r){this.c.add(h.toKey(r))}delete(r){return this.c.delete(h.toKey(r))}has(r){return this.c.has(h.toKey(r))}}e.ExtensionIdentifierSet=l;class p{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(h.toKey(r))}get(r){return this.c.get(h.toKey(r))}has(r){return this.c.has(h.toKey(r))}set(r,g){this.c.set(h.toKey(r),g)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=p;function m(w){return v(w)}e.isApplicationScopedExtension=m;function v(w){return w.contributes&&w.contributes.localizations?w.contributes.localizations.length>0:!1}e.isLanguagePackExtension=v;function f(w){return w.contributes&&w.contributes.authentication?w.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=f;function y(w,r){if(r){const g=`onResolveRemoteAuthority:${(0,s.getRemoteName)(r)}`;return!!w.activationEvents?.includes(g)}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,M.createDecorator)("IBuiltinExtensionsScannerService")}),define(te[236],ie([0,1,7,17,22,13,4,2,64,83,31,105,235,57]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const y=30*1e3;var w;(function(P){P[P.Management=1]="Management",P[P.ExtensionHost=2]="ExtensionHost",P[P.Tunnel=3]="Tunnel"})(w||(e.ConnectionType=w={}));function r(P){switch(P){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function g(P){const F=new s.CancellationTokenSource;return setTimeout(()=>F.cancel(),P),F.token}function c(P,F){if(P.isCancellationRequested||F.isCancellationRequested)return s.CancellationToken.Cancelled;const N=new s.CancellationTokenSource;return P.onCancellationRequested(()=>N.cancel()),F.onCancellationRequested(()=>N.cancel()),N.token}class b{get didTimeout(){return this.c==="timedout"}constructor(F){this.c="pending",this.d=new k.DisposableStore,this.promise=new Promise((N,j)=>{this.f=N,this.g=j}),F.isCancellationRequested?this.h():this.d.add(F.onCancellationRequested(()=>this.h()))}registerDisposable(F){this.c==="pending"?this.d.add(F):F.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const F=new Error("Time limit reached");return F.code="ETIMEDOUT",F.syscall="connect",F}resolve(F){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(F))}reject(F){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(F))}}function S(P,F){const N=new b(F);return N.registerDisposable(P.onControlMessage(j=>{const U=JSON.parse(j.toString()),V=K(U);V?N.reject(V):N.resolve(U)})),N.promise}function D(P,F,N,j,U,V,G,re,ae){const ye=new b(ae),Ce=l.StopWatch.create(!1);return P.info(`Creating a socket (${re})...`),h.mark(`code/willCreateSocket/${G}`),F.connect(N,j,U,V,re,(Ae,Me)=>{ye.didTimeout?(h.mark(`code/didCreateSocketError/${G}`),P.info(`Creating a socket (${re}) finished after ${Ce.elapsed()} ms, but this is too late and has timed out already.`),Ae&&P.error(Ae),Me?.dispose()):Ae||!Me?(h.mark(`code/didCreateSocketError/${G}`),P.info(`Creating a socket (${re}) returned an error after ${Ce.elapsed()} ms.`),ye.reject(Ae)):(h.mark(`code/didCreateSocketOK/${G}`),P.info(`Creating a socket (${re}) was successful after ${Ce.elapsed()} ms.`),ye.resolve(Me))}),ye.promise}function t(P,F){const N=new b(F);return P.then(j=>{N.didTimeout||N.resolve(j)},j=>{N.didTimeout||N.reject(j)}),N.promise}async function a(P,F,N,j){const U=Y(P,F);P.logService.trace(`${U} 1/6. invoking socketFactory.connect().`);let V;try{V=await D(P.logService,P.socketFactory,P.host,P.port,(0,f.getRemoteServerRootPath)(P),`reconnectionToken=${P.reconnectionToken}&reconnection=${P.reconnectionProtocol?"true":"false"}`,r(F),`renderer-${r(F)}-${P.reconnectionToken}`,j)}catch(Ce){throw P.logService.error(`${U} socketFactory.connect() failed or timed out. Error:`),P.logService.error(Ce),Ce}P.logService.trace(`${U} 2/6. socketFactory.connect() was successful.`);let G,re;P.reconnectionProtocol?(P.reconnectionProtocol.beginAcceptReconnection(V,null),G=P.reconnectionProtocol,re=!1):(G=new m.PersistentProtocol({socket:V,measureRoundTripTime:!0}),re=!0),P.logService.trace(`${U} 3/6. sending AuthRequest control message.`);const ae=await t(P.signService.createNewMessage((0,p.generateUuid)()),j),ye={type:"auth",auth:P.connectionToken||"00000000000000000000",data:ae.data};G.sendControl(M.VSBuffer.fromString(JSON.stringify(ye)));try{const Ce=await S(G,c(j,g(1e4)));if(Ce.type!=="sign"||typeof Ce.data!="string"){const ve=new Error("Unexpected handshake message");throw ve.code="VSCODE_CONNECTION_ERROR",ve}if(P.logService.trace(`${U} 4/6. received SignRequest control message.`),!await t(P.signService.validate(ae,Ce.signedData),j)){const ve=new Error("Refused to connect to unsupported server");throw ve.code="VSCODE_CONNECTION_ERROR",ve}const Me=await t(P.signService.sign(Ce.data),j),Fe={type:"connectionType",commit:P.commit,signedData:Me,desiredConnectionType:F};return N&&(Fe.args=N),P.logService.trace(`${U} 5/6. sending ConnectionTypeRequest control message.`),G.sendControl(M.VSBuffer.fromString(JSON.stringify(Fe))),{protocol:G,ownsProtocol:re}}catch(Ce){throw Ce&&Ce.code==="ETIMEDOUT"&&(P.logService.error(`${U} the handshake timed out. Error:`),P.logService.error(Ce)),Ce&&Ce.code==="VSCODE_CONNECTION_ERROR"&&(P.logService.error(`${U} received error control message when negotiating connection. Error:`),P.logService.error(Ce)),re&&z(G),Ce}}async function i(P,F,N,j){const U=Date.now(),V=Y(P,F),{protocol:G,ownsProtocol:re}=await a(P,F,N,j),ae=new b(j);return ae.registerDisposable(G.onControlMessage(ye=>{const Ce=JSON.parse(ye.toString()),Ae=K(Ce);Ae?(P.logService.error(`${V} received error control message when negotiating connection. Error:`),P.logService.error(Ae),re&&z(G),ae.reject(Ae)):(P.reconnectionProtocol?.endAcceptReconnection(),P.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${O(U)}!`),ae.resolve({protocol:G,firstMessage:Ce}))})),ae.promise}async function n(P,F){const{protocol:N}=await i(P,1,void 0,F);return{protocol:N}}async function o(P,F,N){const{protocol:j,firstMessage:U}=await i(P,2,F,N),V=U&&U.debugPort;return{protocol:j,debugPort:V}}async function u(P,F,N){const j=Date.now(),U=Y(P,3),{protocol:V}=await a(P,3,F,N);return P.logService.trace(`${U} 6/6. handshake finished, connection is up and running after ${O(j)}!`),V}async function d(P,F,N){const{host:j,port:U,connectionToken:V}=await P.addressProvider.getAddress();return{commit:P.commit,quality:P.quality,host:j,port:U,connectionToken:V,reconnectionToken:F,reconnectionProtocol:N,socketFactory:P.socketFactory,signService:P.signService,logService:P.logService}}async function I(P,F,N){return C(P,async j=>{const{protocol:U}=await n(j,s.CancellationToken.None);return new q(P,F,N,j.reconnectionToken,U)})}e.connectRemoteAgentManagement=I;async function A(P,F){return C(P,async N=>{const{protocol:j,debugPort:U}=await o(N,F,s.CancellationToken.None);return new B(P,F,N.reconnectionToken,j,U)})}e.connectRemoteAgentExtensionHost=A;async function C(P,F){for(let j=1;;j++)try{const U=(0,p.generateUuid)(),V=await d(P,U,null);return await F(V)}catch(U){if(j<5)P.logService.error(`[remote-connection][attempt ${j}] An error occurred in initial connection! Will retry... Error:`),P.logService.error(U);else throw P.logService.error(`[remote-connection][attempt ${j}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),P.logService.error(U),X.triggerPermanentFailure(0,0,v.RemoteAuthorityResolverError.isHandled(U)),U}}async function T(P,F,N){const j=await d(P,(0,p.generateUuid)(),null);return await u(j,{host:F,port:N},s.CancellationToken.None)}e.connectRemoteAgentTunnel=T;function W(P){return(0,E.createCancelablePromise)(F=>new Promise((N,j)=>{const U=setTimeout(N,P*1e3);F.onCancellationRequested(()=>{clearTimeout(U),N()})}))}var $;(function(P){P[P.ConnectionLost=0]="ConnectionLost",P[P.ReconnectionWait=1]="ReconnectionWait",P[P.ReconnectionRunning=2]="ReconnectionRunning",P[P.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",P[P.ConnectionGain=4]="ConnectionGain",P[P.ConnectionHealthChanged=5]="ConnectionHealthChanged"})($||(e.PersistentConnectionEventType=$={}));class H{constructor(F,N){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.type=0}}e.ConnectionLostEvent=H;class Z{constructor(F,N,j,U){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.durationSeconds=j,this.c=U,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=Z;class ne{constructor(F,N,j){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.attempt=j,this.type=2}}e.ReconnectionRunningEvent=ne;class se{constructor(F,N,j){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.attempt=j,this.type=4}}e.ConnectionGainEvent=se;class ue{constructor(F,N){this.reconnectionToken=F,this.connectionHealth=N,this.type=5}}e.ConnectionHealthChangedEvent=ue;class ce{constructor(F,N,j,U){this.reconnectionToken=F,this.millisSinceLastIncomingData=N,this.attempt=j,this.handled=U,this.type=3}}e.ReconnectionPermanentFailureEvent=ce;class X extends k.Disposable{static triggerPermanentFailure(F,N,j){this._permanentFailure=!0,this.f=F,this.g=N,this.h=j,this.i.forEach(U=>U.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(F=>F.s())}static debugPauseSocketWriting(){this.i.forEach(F=>F.w())}get k(){return this.c||X._permanentFailure}constructor(F,N,j,U,V){super(),this.n=F,this.p=N,this.reconnectionToken=j,this.protocol=U,this.r=V,this.j=this.B(new R.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new se(this.reconnectionToken,0,0)),this.B(U.onSocketClose(G=>{const re=le(this.n,this.reconnectionToken,!0);G?G.type===0?(this.p.logService.info(`${re} received socket close event (hadError: ${G.hadError}).`),G.error&&this.p.logService.error(G.error)):(this.p.logService.info(`${re} received socket close event (wasClean: ${G.wasClean}, code: ${G.code}, reason: ${G.reason}).`),G.event&&this.p.logService.error(G.event)):this.p.logService.info(`${re} received socket close event.`),this.s()})),this.B(U.onSocketTimeout(G=>{const re=le(this.n,this.reconnectionToken,!0);this.p.logService.info(`${re} received socket timeout event (unacknowledgedMsgCount: ${G.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${G.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${G.timeSinceLastReceivedSomeData}).`),this.s()})),this.B(U.onHighRoundTripTime(G=>{const re=oe(this.n,this.reconnectionToken);this.p.logService.info(`${re} high roundtrip time: ${G.roundTripTime}ms (${G.recentHighRoundTripCount} of 5 recent samples)`)})),this.B(U.onDidChangeConnectionHealth(G=>{this.j.fire(new ue(this.reconnectionToken,G))})),X.i.push(this),this.B((0,k.toDisposable)(()=>{const G=X.i.indexOf(this);G>=0&&X.i.splice(G,1)})),this.k&&this.v(X.f,X.g,X.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const F=le(this.n,this.reconnectionToken,!0);this.p.logService.info(`${F} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const N=[0,5,5,10,10,10,10,10,30];let j=-1;do{j++;const U=j<N.length?N[j]:N[N.length-1];try{if(U>0){const G=W(U);this.j.fire(new Z(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U,G)),this.p.logService.info(`${F} waiting for ${U} seconds before reconnecting...`);try{await G}catch{}}if(this.k){this.p.logService.error(`${F} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new ne(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1)),this.p.logService.info(`${F} resolving connection...`);const V=await d(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${F} connecting to ${V.host}:${V.port}...`),await this.y(V,g(y)),this.p.logService.info(`${F} reconnected!`),this.j.fire(new se(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),j+1));break}catch(V){if(V.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${F} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(V),this.u(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(j>360){this.p.logService.error(`${F} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(V),this.u(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}if(v.RemoteAuthorityResolverError.isTemporarilyNotAvailable(V)){this.p.logService.info(`${F} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(V);continue}if((V.code==="ETIMEDOUT"||V.code==="ENETUNREACH"||V.code==="ECONNREFUSED"||V.code==="ECONNRESET")&&V.syscall==="connect"){this.p.logService.info(`${F} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(V);continue}if((0,L.isCancellationError)(V)){this.p.logService.info(`${F} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(V);continue}if(V instanceof v.RemoteAuthorityResolverError){this.p.logService.error(`${F} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(V),this.u(this.protocol.getMillisSinceLastIncomingData(),j+1,v.RemoteAuthorityResolverError.isHandled(V));break}this.p.logService.error(`${F} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(V),this.u(this.protocol.getMillisSinceLastIncomingData(),j+1,!1);break}}while(!this.k&&!this.m)}u(F,N,j){this.r?X.triggerPermanentFailure(F,N,j):this.v(F,N,j)}v(F,N,j){this.j.fire(new ce(this.reconnectionToken,F,N,j)),z(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=X,X._permanentFailure=!1,X.f=0,X.g=0,X.h=!1,X.i=[];class q extends X{constructor(F,N,j,U,V){super(1,F,U,V,!0),this.client=this.B(new m.Client(V,{remoteAuthority:N,clientId:j},F.ipcLogger))}async y(F,N){await n(F,N)}}e.ManagementPersistentConnection=q;class B extends X{constructor(F,N,j,U,V){super(2,F,j,U,!1),this.z=N,this.debugPort=V}async y(F,N){await o(F,this.z,N)}}e.ExtensionHostPersistentConnection=B;function z(P){try{P.acceptDisconnect();const F=P.getSocket();P.dispose(),F.dispose()}catch(F){(0,L.onUnexpectedError)(F)}}function K(P){if(P&&P.type==="error"){const F=new Error(`Connection error: ${P.reason}`);return F.code="VSCODE_CONNECTION_ERROR",F}return null}function ee(P,F){for(;P.length<F;)P+=" ";return P}function oe(P,F){return`[remote-connection][${ee(r(P),13)}][${F.substr(0,5)}\u2026]`}function le(P,F,N){return`${oe(P,F)}[${N?"reconnect":"initial"}]`}function Y(P,F){return`${le(F,P.reconnectionToken,!!P.reconnectionProtocol)}[${P.host}:${P.port}]`}function O(P){return`${Date.now()-P} ms`}}),define(te[237],ie([0,1,26,50,41,196]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWSLFeatureInstalled=void 0;let R;async function k(f=!1){return(R===void 0||f)&&(R=h()),R}e.hasWSLFeatureInstalled=k;async function h(){const f=l();if(f===void 0)return!1;if(f>=22e3){const y=m();if(y)return new Promise(w=>{M.execFile(y,["--status"],r=>w(!r))})}else{const y=v();if(y)try{if((await s.promises.stat(y)).isFile())return!0}catch{}}return!1}function l(){const f=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());if(f)return parseInt(f[3])}function p(f){const y=process.env.SystemRoot;if(y){const w=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");return L.join(y,w?"Sysnative":"System32",f)}}function m(){return p("wsl.exe")}function v(){return p("lxss\\LxssManager.dll")}}),define(te[52],ie([0,1,17,13,2,179,66,6,5,51]),function(x,e,E,M,s,L,R,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");class p{constructor(D){this.b=D}toJSON(){if(!this.a){const D=Object.create(null);for(const t in this.b)t.toLowerCase()==="authorization"||t.toLowerCase()==="proxy-authorization"?D[t]="*****":D[t]=this.b[t];this.a=D}return this.a}}class m extends s.Disposable{constructor(D,t){super(),this.b=0,this.a=t.createLogger(D?"remotenetwork":"network",{name:D?(0,L.localize)(0,null):(0,L.localize)(1,null),when:h.CONTEXT_LOG_LEVEL.isEqualTo((0,h.LogLevelToString)(h.LogLevel.Trace)).serialize()})}async c(D,t,a){const i=`${D} #${++this.b}: ${t.url}`;this.a.trace(`${i} - begin`,t.type,new p(t.headers??{}));try{const n=await a();return this.a.trace(`${i} - end`,t.type,n.res.statusCode,n.res.headers),n}catch(n){throw this.a.error(`${i} - error`,t.type,(0,M.getErrorMessage)(n)),n}}}e.AbstractRequestService=m;function v(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=v;function f(S){return S.res.statusCode===204}async function y(S){return f(S)?null:(await(0,E.streamToBuffer)(S.stream)).toString()}e.asText=y;async function w(S){if(!v(S))throw new Error("Server returned "+S.res.statusCode);return y(S)}e.asTextOrError=w;async function r(S){if(!v(S))throw new Error("Server returned "+S.res.statusCode);if(f(S))return null;const t=(await(0,E.streamToBuffer)(S.stream)).toString();try{return JSON.parse(t)}catch(a){throw a.message+=`:
`+t,a}}e.asJson=r;function g(S){b(S)}e.updateProxyConfigurationsScope=g;let c;function b(S){const D=l.Registry.as(R.Extensions.Configuration),t=c;c={id:"http",order:15,title:(0,L.localize)(2,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0}}},D.updateConfigurations({add:[c],remove:t?[t]:[]})}b(1)}),define(te[238],ie([0,1,17,22]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class s{constructor(k){this.a=k}listen(k,h){throw new Error("Invalid listen")}call(k,h,l,p=M.CancellationToken.None){switch(h){case"request":return this.a.request(l[0],p).then(async({res:m,stream:v})=>{const f=await(0,E.streamToBuffer)(v);return[{statusCode:m.statusCode,headers:m.headers},f]});case"resolveProxy":return this.a.resolveProxy(l[0])}throw new Error("Invalid call")}}e.RequestChannel=s;class L{constructor(k){this.a=k}async request(k,h){const[l,p]=await this.a.call("request",[k],h);return{res:l,stream:(0,E.bufferToStream)(p)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}}e.RequestChannelClient=L}),define(te[239],ie([0,1,240,11]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function s(R,k){return R.protocol==="http:"?k.HTTP_PROXY||k.http_proxy||null:R.protocol==="https:"&&(k.HTTPS_PROXY||k.https_proxy||k.HTTP_PROXY||k.http_proxy)||null}async function L(R,k,h={}){const l=(0,E.parse)(R),p=h.proxyUrl||s(l,k);if(!p)return null;const m=(0,E.parse)(p);if(!/^https?:$/.test(m.protocol||""))return null;const v={host:m.hostname||"",port:m.port||(m.protocol==="https"?"443":"80"),auth:m.auth,rejectUnauthorized:(0,M.isBoolean)(h.strictSSL)?h.strictSSL:!0};return l.protocol==="http:"?new(await new Promise((f,y)=>{x(["http-proxy-agent"],f,y)}))(v):new(await new Promise((f,y)=>{x(["https-proxy-agent"],f,y)}))(v)}e.getProxyAgent=L}),define(te[115],ie([0,1,50,9,180,22,49,13,3,31,152,62,7,131]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let y;async function w(g,c,b,S){return b["force-disable-user-env"]?(c.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):h.isWindows?(c.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,m.isLaunchedFromCli)(S)&&!b["force-user-env"]?(c.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,m.isLaunchedFromCli)(S)?c.trace("resolveShellEnv(): running (--force-user-env)"):c.trace("resolveShellEnv(): running (macOS/Linux)"),y||(y=v.Promises.withAsyncBody(async(D,t)=>{const a=new L.CancellationTokenSource;let i=1e4;const n=g.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,f.clamp)(n,1,120)*1e3);const o=setTimeout(()=>{a.dispose(!0),t(new Error((0,s.localize)(0,null)))},i);try{D(await r(c,a.token))}catch(u){!(0,k.isCancellationError)(u)&&!a.token.isCancellationRequested?t(new Error((0,s.localize)(1,null,(0,R.toErrorMessage)(u)))):D({})}finally{clearTimeout(o),a.dispose()}})),y)}e.getResolvedShellEnv=w;async function r(g,c){const b=process.env.ELECTRON_RUN_AS_NODE;g.trace("getUnixShellEnvironment#runAsNode",b);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;g.trace("getUnixShellEnvironment#noAttach",S);const D=(0,l.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(D+"({.*})"+D),a={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};g.trace("getUnixShellEnvironment#env",a);const i=await(0,p.getSystemShell)(h.OS,a);return g.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(c.isCancellationRequested)return o(new k.CancellationError);const u=(0,M.basename)(i);let d,I;const A=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(d=`& '${process.execPath}' ${A} -p '''${D}'' + JSON.stringify(process.env) + ''${D}'''`,I=["-Login","-Command"]):(d=`'${process.execPath}' ${A} -p '"${D}" + JSON.stringify(process.env) + "${D}"'`,u==="tcsh"||u==="csh"?I=["-ic"]:I=["-i","-l","-c"]),g.trace("getUnixShellEnvironment#spawn",JSON.stringify(I),d);const C=(0,E.spawn)(i,[...I,d],{detached:!0,stdio:["ignore","pipe","pipe"],env:a});c.onCancellationRequested(()=>(C.kill(),o(new k.CancellationError))),C.on("error",$=>{g.error("getUnixShellEnvironment#errorChildProcess",(0,R.toErrorMessage)($)),o($)});const T=[];C.stdout.on("data",$=>T.push($));const W=[];C.stderr.on("data",$=>W.push($)),C.on("close",($,H)=>{const Z=Buffer.concat(T).toString("utf8");g.trace("getUnixShellEnvironment#raw",Z);const ne=Buffer.concat(W).toString("utf8");if(ne.trim()&&g.trace("getUnixShellEnvironment#stderr",ne),$||H)return o(new Error((0,s.localize)(2,null,$,H)));const se=t.exec(Z),ue=se?se[1]:"{}";try{const ce=JSON.parse(ue);b?ce.ELECTRON_RUN_AS_NODE=b:delete ce.ELECTRON_RUN_AS_NODE,S?ce.ELECTRON_NO_ATTACH_CONSOLE=S:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,g.trace("getUnixShellEnvironment#result",ce),n(ce)}catch(ce){g.error("getUnixShellEnvironment#errorCaught",(0,R.toErrorMessage)(ce)),o(ce)}})})}}),define(te[92],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,E.createDecorator)(e.SIGN_SERVICE_ID)}),define(te[241],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class E{constructor(){this.b=new Map}c(){return new Promise((s,L)=>x(["vsda"],s,L))}async createNewMessage(s){try{const L=await this.c(),R=new L.validator;if(R){const k=String(E.a++);return this.b.set(k,R),{id:k,data:R.createNewMessage(s)}}}catch{}return{id:"",data:s}}async validate(s,L){if(!s.id)return!0;const R=this.b.get(s.id);if(!R)return!1;this.b.delete(s.id);try{return R.validate(L)==="ok"}catch{return!1}}async sign(s){try{const L=await this.c(),R=new L.signer;if(R)return R.sign(s)}catch{}return s}}e.SignService=E,E.a=1}),define(te[33],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,E.createDecorator)("stateReadService"),e.IStateService=(0,E.createDecorator)("stateService")}),define(te[116],ie([0,1,7,17,11,34,16,5]),function(x,e,E,M,s,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var h;(function(v){v[v.IMMEDIATE=0]="IMMEDIATE",v[v.DELAYED=1]="DELAYED"})(h||(e.SaveStrategy=h={}));class l{constructor(f,y,w,r){this.f=f,this.g=w,this.h=r,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=y===0?void 0:new E.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(f){f.fileOperationResult!==1&&this.g.error(f)}}getItem(f,y){const w=this.a[f];return(0,s.isUndefinedOrNull)(w)?y:w}setItem(f,y){this.setItems([{key:f,data:y}])}setItems(f){let y=!1;for(const{key:w,data:r}of f)this.a[w]!==r&&((0,s.isUndefinedOrNull)(r)?(0,s.isUndefined)(this.a[w])||(this.a[w]=void 0,y=!0):(this.a[w]=r,y=!0));y&&this.j()}removeItem(f){(0,s.isUndefined)(this.a[f])||(this.a[f]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const f=JSON.stringify(this.a,null,4);if(f!==this.b)try{await this.h.writeFile(this.f,M.VSBuffer.fromString(f)),this.b=f}catch(y){this.g.error(y)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=l;let p=e.StateReadonlyService=class{constructor(f,y,w,r){this.a=new l(y.stateResource,f,w,r)}async init(){await this.a.init()}getItem(f,y){return this.a.getItem(f,y)}};e.StateReadonlyService=p=be([Q(1,L.IEnvironmentService),Q(2,k.ILogService),Q(3,R.IFileService)],p);class m extends p{setItem(f,y){this.a.setItem(f,y)}setItems(f){this.a.setItems(f)}removeItem(f){this.a.removeItem(f)}close(){return this.a.close()}}e.StateService=m}),define(te[93],ie([0,1,3,36,31]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(h){if(E.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}function R(h,l,p,m,v,f,y,w){const r=Object.create(null);r["common.machineId"]=f,r.sessionID=(0,s.generateUuid)()+Date.now(),r.commitHash=m,r.version=v,r["common.platformVersion"]=(h||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),r["common.platform"]=(0,E.PlatformToString)(E.platform),r["common.nodePlatform"]=M.platform,r["common.nodeArch"]=p,r["common.product"]=w||"desktop",y&&(r["common.msftInternal"]=y);let g=0;const c=Date.now();Object.defineProperties(r,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-c,enumerable:!0},"common.sequence":{get:()=>g++,enumerable:!0}}),E.isLinuxSnap&&(r["common.snap"]="true");const b=L(l);return b&&(r["common.platformDetail"]=b),r}e.resolveCommonProperties=R;function k(h){const l=M.env.USERDNSDOMAIN;if(!l)return!1;const p=l.toLowerCase();return h.some(m=>p===m)}e.verifyMicrosoftInternalDomain=k}),define(te[25],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var M;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(M||(e.TelemetryLevel=M={}));var s;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(s||(e.TelemetryConfiguration=s={}))}),define(te[242],ie([0,1,26,7,43,15,9,3,8,85,24,104,88,16,21,25]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const r=new Map;async function g(t,a){const i=`${t}::${a.join(":")}`,n=r.get(i);if(n)return n;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,d=new Map,I=2e4;function A(T,W,$,H){const Z=W.substring(T.length+1);return M.Promises.withAsyncBody(async ne=>{let se;try{se=await p.Promises.readdir(W,{withFileTypes:!0})}catch{ne();return}if(H.count>=I){H.count+=se.length,H.maxReached=!0,ne();return}let ue=se.length;if(ue===0){ne();return}let ce=se;H.count+se.length>I&&(H.maxReached=!0,ue=I-H.count,ce=se.slice(0,ue)),H.count+=se.length;for(const X of ce)if(X.isDirectory()){if($.includes(X.name)||await A(T,(0,R.join)(W,X.name),$,H),--ue===0){ne();return}}else{const q=X.name.lastIndexOf(".");if(q>=0){const B=X.name.substring(q+1);B&&u.set(B,(u.get(B)??0)+1)}for(const B of o)B.relativePathPattern?.test(Z)!==!1&&B.filePattern.test(X.name)&&d.set(B.tag,(d.get(B.tag)??0)+1);if(--ue===0){ne();return}}})}const C=M.Promises.withAsyncBody(async T=>{const W={count:0,maxReached:!1};await A(t,t,a,W);const $=await S(t);T({configFiles:c(d),fileTypes:c(u),fileCount:W.count,maxFilesReached:W.maxReached,launchConfigFiles:$})});return r.set(i,C),C}e.collectWorkspaceStats=g;function c(t){return Array.from(t.entries(),([a,i])=>({name:a,count:i})).sort((a,i)=>i.count-a.count)}function b(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(l.virtualMachineHint.value()*100)}%`},a=E.cpus();return a&&a.length>0&&(t.cpus=`${a[0].model} (${a.length} x ${a[0].speed})`),t}e.getMachineInfo=b;async function S(t){try{const a=new Map,i=(0,R.join)(t,".vscode","launch.json"),n=await p.Promises.readFile(i),o=[],u=(0,s.parse)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,s.getNodeType)(u)==="object"&&u.configurations)for(const d of u.configurations){const I=d.type;I&&(a.has(I)?a.set(I,a.get(I)+1):a.set(I,1))}return c(a)}catch{return[]}}e.collectLaunchConfigs=S;let D=e.DiagnosticsService=class{constructor(a,i){this.c=a,this.d=i}f(a){const i=[];return i.push(`OS Version:       ${a.os}`),i.push(`CPUs:             ${a.cpus}`),i.push(`Memory (System):  ${a.memory}`),i.push(`VM:               ${a.vmHint}`),i.join(`
`)}g(a){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const n=E.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(E.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||i.push(`Load (avg):       ${E.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(l.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${a.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${a.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(a.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(a,i){return Promise.all([(0,m.listProcesses)(a.mainPID),this.k(a)]).then(async n=>{let[o,u]=n,d=this.m(a,o);return i.forEach(I=>{if((0,v.isRemoteDiagnosticError)(I))d+=`
${I.errorMessage}`,u+=`
${I.errorMessage}`;else if(d+=`

Remote: ${I.hostName}`,I.processes&&(d+=`
${this.m(a,I.processes)}`),I.workspaceMetadata){u+=`
|  Remote: ${I.hostName}`;for(const A of Object.keys(I.workspaceMetadata)){const C=I.workspaceMetadata[A];let T=`${C.fileCount} files`;C.maxFilesReached&&(T=`more than ${T}`),u+=`|    Folder (${A}): ${T}`,u+=this.h(C)}}}),{processInfo:d,workspaceInfo:u}})}async getSystemInfo(a,i){const{memory:n,vmHint:o,os:u,cpus:d}=b(),I={os:u,memory:n,cpus:d,vmHint:o,processArgs:`${a.mainArguments.join(" ")}`,gpuStatus:a.gpuFeatureStatus,screenReader:`${a.screenReader?"yes":"no"}`,remoteData:i};return k.isWindows||(I.load=`${E.loadavg().map(A=>Math.round(A)).join(", ")}`),k.isLinux&&(I.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(I)}async getDiagnostics(a,i){const n=[];return(0,m.listProcesses)(a.mainPID).then(async o=>(n.push(""),n.push(this.g(a)),n.push(""),n.push(this.m(a,o)),a.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(a))),i.forEach(u=>{if((0,v.isRemoteDiagnosticError)(u))n.push(`
${u.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${u.hostName}`),n.push(this.f(u.machineInfo)),u.processes&&n.push(this.m(a,u.processes)),u.workspaceMetadata)for(const d of Object.keys(u.workspaceMetadata)){const I=u.workspaceMetadata[d];let A=`${I.fileCount} files`;I.maxFilesReached&&(A=`more than ${A}`),n.push(`Folder (${d}): ${A}`),n.push(this.h(I))}}),n.push(""),n.push(""),n.join(`
`)))}h(a){const i=[];let o=0;const u=(C,T)=>{const W=` ${C}(${T})`;o+W.length>60?(i.push(d),d="|                 ",o=d.length):o+=W.length,d+=W};let d="|      File types:";const I=10,A=a.fileTypes.length>I?I:a.fileTypes.length;for(let C=0;C<A;C++){const T=a.fileTypes[C];u(T.name,T.count)}if(i.push(d),a.configFiles.length>=0&&(d="|      Conf files:",o=0,a.configFiles.forEach(C=>{u(C.name,C.count)}),i.push(d)),a.launchConfigFiles.length>0){let C="|      Launch Configs:";a.launchConfigFiles.forEach(T=>{const W=T.count>1?` ${T.name}(${T.count})`:` ${T.name}`;C+=W}),i.push(C)}return i.join(`
`)}j(a){const i=Math.max(...Object.keys(a).map(n=>n.length));return Object.keys(a).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${a[n]}`).join(`
                  `)}k(a){const i=[],n=[];return a.windows.forEach(o=>{o.folderURIs.length===0||o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const d=h.URI.revive(u);if(d.scheme===L.Schemas.file){const I=d.fsPath;n.push(g(I,["node_modules",".git"]).then(A=>{let C=`${A.fileCount} files`;A.maxFilesReached&&(C=`more than ${C}`),i.push(`|    Folder (${(0,R.basename)(I)}): ${C}`),i.push(this.h(A))}).catch(A=>{i.push(`|      Error: Unable to collect workspace stats for folder ${I} (${A.toString()})`)}))}else i.push(`|    Folder (${d.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(a,i){const n=new Map;a.windows.forEach(u=>n.set(u.pid,`window [${u.id}] (${u.title})`)),a.pidToNames.forEach(({pid:u,name:d})=>n.set(u,d));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.n(a.mainPID,n,o,i,0),o.join(`
`)}n(a,i,n,o,u){const d=u===0;let I;d?I=o.pid===a?`${this.d.applicationName} main`:"remote agent":i.has(o.pid)?I=i.get(o.pid):I=`${"  ".repeat(u)} ${o.name}`;const A=process.platform==="win32"?o.mem:E.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(A/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${I}`),Array.isArray(o.children)&&o.children.forEach(C=>this.n(a,i,n,C,u+1))}async getWorkspaceFileExtensions(a){const i=new Set;for(const{uri:n}of a.folders){const o=h.URI.revive(n);if(o.scheme!==L.Schemas.file)continue;const u=o.fsPath;try{(await g(u,["node_modules",".git"])).fileTypes.forEach(I=>i.add(I.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(a){for(const{uri:i}of a.folders){const n=h.URI.revive(i);if(n.scheme!==L.Schemas.file)continue;const o=n.fsPath;try{const u=await g(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":a.telemetryId,rendererSessionId:a.rendererSessionId}),u.fileTypes.forEach(d=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:a.rendererSessionId,type:d.name,count:d.count})}),u.launchConfigFiles.forEach(d=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:a.rendererSessionId,type:d.name,count:d.count})}),u.configFiles.forEach(d=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:a.rendererSessionId,type:d.name,count:d.count})})}catch{}}}};e.DiagnosticsService=D=be([Q(0,w.ITelemetryService),Q(1,y.IProductService)],D)}),define(te[243],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class E{constructor(L){this.b=L}listen(L,R){throw new Error(`Event not found: ${R}`)}call(L,R,{eventName:k,data:h}){return this.b.forEach(l=>l.log(k,h)),Promise.resolve(null)}}e.TelemetryAppenderChannel=E;class M{constructor(L){this.b=L}log(L,R){return this.b.call("log",{eventName:L,data:R}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=M}),define(te[46],ie([0,1,40,11,4,19,57,93,25]),function(x,e,E,M,s,L,R,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class l{constructor(o){this.value=o,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=l;class p{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=p,e.NullTelemetryService=new p;class m{async publicLog(o,u,d){}async publicLogError(o,u,d){}}e.NullEndpointTelemetryService=m,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(n,o){return s.Event.debounce(o.onDidChangeConfiguration,(d,I)=>{const A=d?new Set([...d.affectedKeys,...I.affectedKeys]):I.affectedKeys;return{...I,affectedKeys:A}},1e3,!0)(d=>{d.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(d.source),configurationKeys:Array.from(d.affectedKeys)})})}e.configurationTelemetry=v;function f(n,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!n.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=f;function y(n,o){return!(o.isBuilt||o.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.isLoggingOnly=y;function w(n){const o=n.getValue(h.TELEMETRY_SETTING_ID),u=n.getValue(h.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(n.getValue(h.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=w;function r(n){const o={},u={},d={};b(n,d);for(let I in d){I=I.length>150?I.substr(I.length-149):I;const A=d[I];typeof A=="number"?u[I]=A:typeof A=="boolean"?u[I]=A?1:0:typeof A=="string"?(A.length>8192&&console.warn(`Telemetry property: ${I} has been trimmed to 8192, the original length is ${A.length}`),o[I]=A.substring(0,8191)):typeof A<"u"&&A!==null&&(o[I]=A)}return{properties:o,measurements:u}}e.validateTelemetryData=r;const g=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function c(n){if(!n)return"none";const o=(0,R.getRemoteName)(n);return g.has(o)?o:"other"}e.cleanRemoteAuthority=c;function b(n,o,u=0,d){if(n)for(const I of Object.getOwnPropertyNames(n)){const A=n[I],C=d?d+I:I;Array.isArray(A)?o[C]=(0,E.safeStringify)(A):A instanceof Date?o[C]=A.toISOString():(0,M.isObject)(A)?u<2?b(A,o,u+1,C+"."):o[C]=(0,E.safeStringify)(A):o[C]=A}}function S(n,o){const u=n.msftInternalDomains||[],d=o.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(u)||d}e.isInternalTelemetry=S;function D(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=D;function t(n,o){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let u=n;const d=[];for(const T of o)for(;;){const W=T.exec(n);if(!W)break;d.push([W.index,T.lastIndex])}const I=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,A=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let C=0;for(u="";;){const T=A.exec(n);if(!T)break;const W=d.some(([$,H])=>T.index<H&&$<A.lastIndex);!I.test(T[0])&&!W&&(u+=n.substring(C,T.index)+"<REDACTED: user-file-path>",C=A.lastIndex)}return C<n.length&&(u+=n.substr(C)),u}function a(n){if(!n)return n;const o=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const u of o)if(u.regex.test(n))return`<REDACTED: ${u.label}>`;return n}function i(n,o){return(0,E.cloneAndChange)(n,u=>{if(u instanceof l||Object.hasOwnProperty.call(u,"isTrustedTelemetryValue"))return u.value;if(typeof u=="string"){let d=u.replaceAll("%20"," ");d=t(d,o);for(const I of o)d=d.replace(I,"");return d=a(d),d}})}e.cleanData=i}),define(te[117],ie([0,1,27,110,114,3,8,13,36,46]),function(x,e,E,M,s,L,R,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function p(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,E.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=p;const m=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(n){const o=n.manifest?n.manifest.version:n.version,u=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new v(n.identifier,o,u)}static parse(n){const o=m.exec(n);return o&&o[1]&&o[2]?new v({id:o[1]},o[2],o[4]||void 0):null}constructor(n,o,u="undefined"){this.version=o,this.targetPlatform=u,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof v?p(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=v;const f=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(i){const n=f.exec(i);return n&&n[1]?[r(n[1]),n[2]]:[r(i),void 0]}e.getIdAndVersion=y;function w(i,n){return`${i}.${n}`}e.getExtensionId=w;function r(i){return i.toLowerCase()}e.adoptToGalleryExtensionId=r;function g(i,n){return r(w(i??s.UNDEFINED_PUBLISHER,n))}e.getGalleryExtensionId=g;function c(i,n){const o=[],u=d=>{for(const I of o)if(I.some(A=>p(n(A),n(d))))return I;return null};for(const d of i){const I=u(d);I?I.push(d):o.push([d])}return o}e.groupByExtension=c;function b(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function S(i){return{id:new l.TelemetryTrustedValue(i.identifier.id),name:new l.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new s.ExtensionIdentifier("pprice.better-merge");function D(i,n){const o=[],u=n.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const d=u.shift();if(d&&o.every(I=>!p(I.identifier,{id:d}))){const I=i.filter(A=>p(A.identifier,{id:d}));I.length===1&&(o.push(I[0]),u.push(...I[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=D;async function t(i,n){if(!L.isLinux)return!1;let o;try{o=(await i.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await i.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(d){n.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(d))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(i,n){const o=await t(i,n),u=(0,M.getTargetPlatform)(o?"alpine":L.platform,h.arch);return n.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=a}),define(te[244],ie([0,1,201,46]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function s(L,R,k,h,l,p,m){const v={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${R.nameShort})`};if((0,M.supportsTelemetry)(R,k)&&(0,M.getTelemetryLevel)(h)===3){const f=await(0,E.getServiceMachineId)(k,l,p);v["X-Market-User-Id"]=f,v["VSCode-SessionId"]=m.machineId||f}return v}e.resolveMarketplaceHeaders=s}),define(te[245],ie([0,1,13,40,46]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://0.0.0.0/OneCollector/1.0",R="https://0.0.0.0/ping";async function k(l,p,m){const v=await new Promise((g,c)=>{x(["@microsoft/1ds-core-js"],g,c)}),f=await new Promise((g,c)=>{x(["@microsoft/1ds-post-js"],g,c)}),y=new v.AppInsightsCore,w=new f.PostChannel,r={instrumentationKey:l,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[w]]};if(m){r.extensionConfig={};const g={alwaysUseXhrOverride:!0,httpXHROverride:m};r.extensionConfig[w.identifier]=g}return y.initialize(r,[]),y.addTelemetryInitializer(g=>{p&&(g.ext=g.ext??{},g.ext.utc=g.ext.utc??{},g.ext.utc.flags=8462029)}),y}class h{constructor(p,m,v,f,y){this.e=p,this.f=m,this.g=v,this.h=y,this.c=L,this.d=R,this.g||(this.g={}),typeof f=="function"?this.a=f():this.a=f,this.b=null}i(p){if(this.a){if(typeof this.a!="string"){p(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(m=>{p(m)},m=>{(0,E.onUnexpectedError)(m),console.error(m)})}}log(p,m){if(!this.a)return;m=(0,M.mixin)(m,this.g),m=(0,s.validateTelemetryData)(m);const v=this.f+"/"+p;try{this.i(f=>{f.pluginVersionString=m?.properties.version??"Unknown",f.track({name:v,baseData:{name:v,properties:m?.properties,measurements:m?.measurements}})})}catch{}}flush(){return this.a?new Promise(p=>{this.i(m=>{m.unload(!0,()=>{this.a=void 0,p(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=h}),define(te[118],ie([0,1,2,40,3,27,181,19,66,76,21,51,25,46]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let y=e.TelemetryService=class{constructor(g,c,b){this.k=c,this.l=b,this.d={},this.i=new E.DisposableStore,this.j=[],this.b=g.appenders,this.c=g.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=g.piiPaths||[],this.g=3,this.h=!!g.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,L.escapeRegExpCharacters)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.escapeRegExpCharacters)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(v.TELEMETRY_SETTING_ID)||S.affectsConfiguration(v.TELEMETRY_OLD_SETTING_ID)||S.affectsConfiguration(v.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(g,c){this.d[g]=c}m(){let g=(0,f.getTelemetryLevel)(this.k);const c=this.l.enabledTelemetryLevels;if(c){this.h=this.sendErrorTelemetry?c.error:!1;const b=c.usage?3:c.error?2:0;g=Math.min(g,b)}this.g=g}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(g,c,b){this.g<c||(b=(0,M.mixin)(b,this.d),b=(0,f.cleanData)(b,this.j),b=(0,M.mixin)(b,this.c),this.b.forEach(S=>S.log(g,b)))}publicLog(g,c){this.n(g,3,c)}publicLog2(g,c){this.publicLog(g,c)}publicLogError(g,c){this.h&&this.n(g,2,c)}publicLogError2(g,c){this.publicLogError(g,c)}};y.IDLE_START_EVENT_NAME="UserIdleStart",y.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=y=be([Q(1,k.IConfigurationService),Q(2,p.IProductService)],y);function w(){const r=(0,R.localize)(0,null,l.default.nameLong),g=l.default.privacyStatementUrl?(0,R.localize)(2,null,"https://aka.ms/vscode-telemetry",l.default.privacyStatementUrl):(0,R.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=s.isWeb?"":(0,R.localize)(3,null),b=(0,R.localize)(4,null),S=(0,R.localize)(5,null),D=(0,R.localize)(6,null),t=(0,R.localize)(7,null),a=`
|       | ${b} | ${S} | ${D} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,R.localize)(8,null);return`
${r} ${g} ${c}

&nbsp;

${t}
${a}

&nbsp;

${i}
`}m.Registry.as(h.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,R.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,R.localize)(10,null),(0,R.localize)(11,null),(0,R.localize)(12,null),(0,R.localize)(13,null)],markdownDescription:w(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),m.Registry.as(h.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,R.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:l.default.privacyStatementUrl?(0,R.localize)(16,null,l.default.nameLong,l.default.privacyStatementUrl):(0,R.localize)(15,null,l.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,R.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(te[246],ie([0,1,296,245]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class s extends M.AbstractOneDataSystemAppender{constructor(R,k,h,l){const p={sendPOST:(m,v)=>{const f={method:"POST",headers:{...m.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(m.data)}};try{const y=E.request(m.urlString,f,w=>{w.on("data",function(r){v(w.statusCode??200,w.headers,r.toString())}),w.on("error",function(r){v(0,{})})});y.write(m.data),y.end()}catch{v(0,{})}}};super(R,k,h,l,p)}}e.OneDataSystemAppender=s}),define(te[247],ie([0,1,3,85,25]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function L(R,k){let h=R.getItem(s.machineIdKey);return(typeof h!="string"||E.isMacintosh&&h==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(h=await(0,M.getMachineId)(k.error.bind(k))),h}e.resolveMachineId=L}),define(te[119],ie([0,1,25,247]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMachineId=void 0;async function s(L,R){const k=await(0,M.resolveMachineId)(L,R);return L.setItem(E.machineIdKey,k),k}e.resolveMachineId=s}),define(te[78],ie([0,1,14,4,2,3,19,6,33]),function(x,e,E,M,s,L,R,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const l="#FFFFFF",p="#1E1E1E",m="#000000",v="#FFFFFF",f="theme",y="themeBackground",w="windowSplash";e.IThemeMainService=(0,k.createDecorator)("themeMainService");let r=e.ThemeMainService=class extends s.Disposable{constructor(c,b){super(),this.b=c,this.c=b,this.a=this.B(new M.Emitter),this.onDidChangeColorScheme=this.a.event,E.nativeTheme.on("updated",()=>{this.a.fire(this.getColorScheme())})}getColorScheme(){if(L.isWindows){if(E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseInvertedColorScheme,highContrast:!0}}else if(L.isMacintosh){if(E.nativeTheme.shouldUseInvertedColorScheme||E.nativeTheme.shouldUseHighContrastColors)return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!0}}else if(L.isLinux&&E.nativeTheme.shouldUseHighContrastColors)return{dark:!0,highContrast:!0};return{dark:E.nativeTheme.shouldUseDarkColors,highContrast:!1}}getBackgroundColor(){const c=this.getColorScheme();if(c.highContrast&&this.c.getValue("window.autoDetectHighContrast"))return c.dark?m:v;let b=this.b.getItem(y,null);if(!b)switch(this.b.getItem(f,"vs-dark").split(" ")[0]){case"vs":b=l;break;case"hc-black":b=m;break;case"hc-light":b=v;break;default:b=p}return L.isMacintosh&&b.toUpperCase()===p&&(b="#171717"),b}saveWindowSplash(c,b){this.b.setItems([{key:f,data:b.baseTheme},{key:y,data:b.colorInfo.background},{key:w,data:b}]),typeof c=="number"&&this.f(c,b)}f(c,b){for(const S of E.BrowserWindow.getAllWindows())if(S.id===c){S.setBackgroundColor(b.colorInfo.background);break}}getWindowSplash(){return this.b.getItem(w)}};e.ThemeMainService=r=be([Q(0,h.IStateService),Q(1,R.IConfigurationService)],r)}),define(te[120],ie([0,1,4,19,6,5]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,s.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,s.createDecorator)("sharedTunnelsService");var R;(function(w){w.Http="http",w.Https="https"})(R||(e.TunnelProtocol=R={}));var k;(function(w){w.ConstantPrivate="constantPrivate",w.Private="private",w.Public="public"})(k||(e.TunnelPrivacyId=k={}));var h;(function(w){w[w.Notify=1]="Notify",w[w.OpenBrowser=2]="OpenBrowser",w[w.OpenPreview=3]="OpenPreview",w[w.Silent=4]="Silent",w[w.Ignore=5]="Ignore",w[w.OpenBrowserOnce=6]="OpenBrowserOnce"})(h||(e.ProvidedOnAutoForward=h={}));function l(w){if(w.scheme!=="http"&&w.scheme!=="https")return;const r=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(w.authority);if(r)return{address:r[1],port:+r[2]}}e.extractLocalHostUriMetaDataForPortMapping=l,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function p(w){return e.LOCALHOST_ADDRESSES.indexOf(w)>=0}e.isLocalhost=p,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function m(w){return e.ALL_INTERFACES_ADDRESSES.indexOf(w)>=0}e.isAllInterfaces=m;function v(w,r,g,c){if(g===1)return!1;if(g===2&&m(r)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(c);if(b?.length===4&&parseInt(b[1])>=18)return!1}return w<1024}e.isPortPrivileged=v;class f{constructor(r,g,c){this.remoteAddress=r,this.localAddress=g,this.b=c,this.a=new E.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=f;let y=e.AbstractTunnelService=class{constructor(r,g){this.i=r,this.j=g,this.a=new E.Emitter,this.onTunnelOpened=this.a.event,this.b=new E.Emitter,this.onTunnelClosed=this.b.event,this.c=new E.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const r=this.j.getValue("remote.localPortHost");return!r||r==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(r){return this.e=r,r?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(r){this.f=r.elevation,this.g=r.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const r=[],g=Array.from(this.d.values());for(const c of g){const b=Array.from(c.values());for(const S of b){const D=await S.value;D&&r.push(D)}}return r}async dispose(){for(const r of this.d.values()){for(const{value:g}of r.values())await g.then(c=>c?.dispose());r.clear()}this.d.clear()}setEnvironmentTunnel(r,g,c,b,S){this.o(r,g,Promise.resolve({tunnelRemoteHost:r,tunnelRemotePort:g,localAddress:c,privacy:b,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(r,g){(m(r)||p(r))&&(r=e.LOCALHOST_ADDRESSES[0]);const c=this.q(r,g);if(c)return++c.refcount,c.value}openTunnel(r,g,c,b,S,D=!1,t,a){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${g}:${c} on local port ${S}.`),!r)return;if(g||(g="localhost"),b||(b=this.k),this.e&&this.h.has(c)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const i=this.r(r,g,c,b,S,D,t,a);return i?i.then(n=>{if(!n){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(g,c);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const o=this.m(n);return(n.tunnelRemoteHost!==g||n.tunnelRemotePort!==c)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(o),o}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),i)}m(r){return{tunnelRemotePort:r.tunnelRemotePort,tunnelRemoteHost:r.tunnelRemoteHost,tunnelLocalPort:r.tunnelLocalPort,localAddress:r.localAddress,privacy:r.privacy,protocol:r.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${r.tunnelRemoteHost}:${r.tunnelRemotePort} `);const g=this.d.get(r.tunnelRemoteHost);if(g){const c=g.get(r.tunnelRemotePort);c&&(c.refcount--,await this.n(r.tunnelRemoteHost,r.tunnelRemotePort,c))}}}}async n(r,g,c){if(c.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${r}:${g}.`);const b=c.value.then(async S=>{S&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.d.has(r)&&this.d.get(r).delete(g),b}}async closeTunnel(r,g){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${r}:${g} `);const c=this.d.get(r);if(c&&c.has(g)){const b=c.get(g);b.refcount=0,await this.n(r,g,b)}}o(r,g,c){this.d.has(r)||this.d.set(r,new Map),this.d.get(r).set(g,{refcount:1,value:c})}async p(r,g){const c=this.d.get(r);c&&(await c.get(g)||c.delete(g),c.size===0&&this.d.delete(r))}q(r,g){const c=[r];p(r)?(c.push(...e.LOCALHOST_ADDRESSES),c.push(...e.ALL_INTERFACES_ADDRESSES)):m(r)&&c.push(...e.ALL_INTERFACES_ADDRESSES);const b=c.map(S=>this.d.get(S));for(const S of b){const D=S?.get(g);if(D)return D}}canTunnel(r){return!!l(r)}s(r,g,c,b,S,D,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${g}:${c} on local port ${b}.`);const a=c;this.h.add(a);const i=b===void 0?c:b,n={elevationRequired:S?this.isPortPrivileged(i):!1},o={remoteAddress:{host:g,port:c},localAddressPort:b,privacy:D,public:D?D!==k.Private:void 0,protocol:t},u=r.forwardPort(o,n);return u?(this.o(g,c,u),u.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(a)})):this.h.delete(a),u}};e.AbstractTunnelService=y=be([Q(0,L.ILogService),Q(1,M.IConfigurationService)],y)}),define(te[47],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var M;(function(L){L.Uninitialized="uninitialized",L.Idle="idle",L.CheckingForUpdates="checking for updates",L.AvailableForDownload="available for download",L.Downloading="downloading",L.Downloaded="downloaded",L.Updating="updating",L.Ready="ready"})(M||(e.StateType=M={}));var s;(function(L){L[L.Setup=0]="Setup",L[L.Archive=1]="Archive",L[L.Snap=2]="Snap"})(s||(e.UpdateType=s={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(L,R)=>({type:"idle",updateType:L,error:R}),CheckingForUpdates:L=>({type:"checking for updates",explicit:L}),AvailableForDownload:L=>({type:"available for download",update:L}),Downloading:L=>({type:"downloading",update:L}),Downloaded:L=>({type:"downloaded",update:L}),Updating:L=>({type:"updating",update:L}),Ready:L=>({type:"ready",update:L})},e.IUpdateService=(0,E.createDecorator)("updateService")}),define(te[248],ie([0,1,3,182,66,51]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),L.Registry.as(s.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,M.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,M.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,M.localize)(2,null),(0,M.localize)(3,null),(0,M.localize)(4,null),(0,M.localize)(5,null)],policy:{name:"UpdateMode",minimumVersion:"1.67"}},"update.channel":{type:"string",default:"default",scope:1,description:(0,M.localize)(6,null),deprecationMessage:(0,M.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,M.localize)(8,null),description:(0,M.localize)(9,null),included:E.isWindows&&!E.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,M.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(te[249],ie([0,1,4,47]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class s{constructor(k){this.a=k}listen(k,h){switch(h){case"onStateChange":return this.a.onStateChange}throw new Error(`Event not found: ${h}`)}call(k,h,l){switch(h){case"checkForUpdates":return this.a.checkForUpdates(l);case"downloadUpdate":return this.a.downloadUpdate();case"applyUpdate":return this.a.applyUpdate();case"quitAndInstall":return this.a.quitAndInstall();case"_getInitialState":return Promise.resolve(this.a.state);case"isLatestVersion":return this.a.isLatestVersion();case"_applySpecificUpdate":return this.a._applySpecificUpdate(l)}throw new Error(`Call not found: ${h}`)}}e.UpdateChannel=s;class L{get state(){return this.b}set state(k){this.b=k,this.a.fire(k)}constructor(k){this.c=k,this.a=new E.Emitter,this.onStateChange=this.a.event,this.b=M.State.Uninitialized,this.c.listen("onStateChange")(h=>this.state=h),this.c.call("_getInitialState").then(h=>this.state=h)}checkForUpdates(k){return this.c.call("checkForUpdates",k)}downloadUpdate(){return this.c.call("downloadUpdate")}applyUpdate(){return this.c.call("applyUpdate")}quitAndInstall(){return this.c.call("quitAndInstall")}isLatestVersion(){return this.c.call("isLatestVersion")}_applySpecificUpdate(k){return this.c.call("_applySpecificUpdate",k)}}e.UpdateChannelClient=L}),define(te[38],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(te[250],ie([0,1,38,202,16,18,132,4,2]),function(x,e,E,M,s,L,R,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class l{constructor(v){this.uri=v,this.time=l._clock++}touch(){return this.time=l._clock++,this}}l._clock=0;let p=e.UriIdentityService=class{constructor(v){this.g=v,this.c=new h.DisposableStore,this.f=2**16;const f=new Map,y=w=>{let r=f.get(w.scheme);return r===void 0&&(r=v.hasProvider(w)&&!this.g.hasCapability(w,1024),f.set(w.scheme,r)),r};this.c.add(k.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(w=>{f.delete(w.scheme)})),this.extUri=new L.ExtUri(y),this.d=new R.SkipList((w,r)=>this.extUri.compare(w,r,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,L.normalizePath)(v));const f=this.d.get(v);return f?f.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new l(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((y,w)=>y[1].time<w[1].time?1:y[1].time>w[1].time?-1:0);l._clock=0,this.d.clear();const f=this.f*.5;for(let y=0;y<f;y++)this.d.set(v[y][0],v[y][1].touch())}};e.UriIdentityService=p=be([Q(0,s.IFileService)],p),(0,M.registerSingleton)(E.IUriIdentityService,p,1)}),define(te[121],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,E.createDecorator)("urlService")}),define(te[251],ie([0,1,8]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class M{constructor(k){this.a=k}listen(k,h){throw new Error(`Event not found: ${h}`)}call(k,h,l){switch(h){case"handleURL":return this.a.handleURL(E.URI.revive(l[0]),l[1])}throw new Error(`Call not found: ${h}`)}}e.URLHandlerChannel=M;class s{constructor(k){this.a=k}handleURL(k,h){return this.a.call("handleURL",[k.toJSON(),h])}}e.URLHandlerChannelClient=s;class L{constructor(k,h){this.a=k,this.b=h}async routeCall(k,h,l,p){if(h!=="handleURL")throw new Error(`Call not found: ${h}`);if(Array.isArray(l)&&l.length>0){const m=E.URI.revive(l[0]);if(this.b.trace("URLHandlerRouter#routeCall() with URI argument",m.toString(!0)),m.query){const v=/\bwindowId=(\d+)/.exec(m.query);if(v){const f=v[1];this.b.trace(`URLHandlerRouter#routeCall(): found windowId query parameter with value "${f}"`,m.toString(!0));const y=new RegExp(`window:${f}`),w=k.connections.find(r=>(this.b.trace("URLHandlerRouter#routeCall(): testing connection",r.ctx),y.test(r.ctx)));if(w)return this.b.trace("URLHandlerRouter#routeCall(): found a connection to route",m.toString(!0)),w;this.b.trace("URLHandlerRouter#routeCall(): did not find a connection to route",m.toString(!0))}else this.b.trace("URLHandlerRouter#routeCall(): did not find windowId query parameter",m.toString(!0))}}else this.b.trace("URLHandlerRouter#routeCall() without URI argument");return this.a.routeCall(k,h,l,p)}routeEvent(k,h){throw new Error(`Event not found: ${h}`)}}e.URLHandlerRouter=L}),define(te[252],ie([0,1,7,2,8,21]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class R extends M.Disposable{constructor(){super(...arguments),this.a=new Set}open(l,p){const m=[...this.a.values()];return(0,E.first)(m.map(v=>()=>v.handleURL(l,p)),void 0,!1).then(v=>v||!1)}registerHandler(l){return this.a.add(l),(0,M.toDisposable)(()=>this.a.delete(l))}}e.AbstractURLService=R;let k=e.NativeURLService=class extends R{constructor(l){super(),this.b=l}create(l){let{authority:p,path:m,query:v,fragment:f}=l||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return p&&m&&m.indexOf("/")!==0&&(m=`/${m}`),s.URI.from({scheme:this.b.urlProtocol,authority:p,path:m,query:v,fragment:f})}};e.NativeURLService=k=be([Q(0,L.IProductService)],k)}),define(te[253],ie([0,1,14,7,4,2,3,8]),function(x,e,E,M,s,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;class h{constructor(p,m,v,f,y,w){if(this.f=m,this.g=w,this.a=[],this.b=0,this.c=L.Disposable.None,this.d=new L.DisposableStore,p&&(w.trace("ElectronURLListener initialUrisToHandle:",p.map(c=>c.originalUrl)),this.a=p),R.isWindows){const c=f.isBuilt?[]:[`"${f.appRoot}"`];c.push("--open-url","--"),E.app.setAsDefaultProtocolClient(y.urlProtocol,process.execPath,c)}const r=s.Event.map(s.Event.fromNodeEventEmitter(E.app,"open-url",(c,b)=>({event:c,url:b})),({event:c,url:b})=>(c.preventDefault(),b));this.d.add(r(c=>{const b=this.h(c);b&&this.f.open(b,{originalUrl:c})})),v.getWindows().filter(c=>c.isReady).length>0?(w.trace("ElectronURLListener: window is ready to handle URLs"),this.i()):(w.trace("ElectronURLListener: waiting for window to be ready to handle URLs..."),s.Event.once(v.onDidSignalReadyWindow)(this.i,this,this.d))}h(p){try{return k.URI.parse(p)}catch{return}}async i(){if(this.b++>10){this.g.trace("ElectronURLListener#flush(): giving up after 10 retries");return}this.g.trace("ElectronURLListener#flush(): flushing URLs");const p=[];for(const m of this.a)await this.f.open(m.uri,{originalUrl:m.originalUrl})?this.g.trace("ElectronURLListener#flush(): URL was handled",m.originalUrl):(this.g.trace("ElectronURLListener#flush(): URL was not yet handled",m.originalUrl),p.push(m));p.length!==0&&(this.a=p,this.c=(0,M.disposableTimeout)(()=>this.i(),500))}dispose(){this.d.dispose(),this.c.dispose()}}e.ElectronURLListener=h}),define(te[254],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcUtilityProcessWorkerChannelName=void 0,e.ipcUtilityProcessWorkerChannelName="utilityProcessWorker"}),define(te[255],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,E.createDecorator)("webviewManagerService")}),define(te[256],ie([0,1,14,2,15,8]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class R extends M.Disposable{constructor(){super();const h=this.b.bind(this);E.protocol.registerFileProtocol(s.Schemas.vscodeWebview,h)}b(h,l){try{const p=L.URI.parse(h.url),m=R.a.get(p.path);if(typeof m=="string"){const v=`vs/workbench/contrib/webview/browser/pre/${m}`,f=s.FileAccess.asFileUri(v);return l({path:f.fsPath,headers:{...s.COI.getHeadersFromQuery(h.url),"Cross-Origin-Resource-Policy":"cross-origin"}})}else return l({error:-10})}catch{}return l({error:-2})}}e.WebviewProtocolProvider=R,R.a=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/service-worker.js","service-worker.js"]])}),define(te[79],ie([0,1,3]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.useWindowControlsOverlay=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function M(p){return!!p.workspaceUri}e.isWorkspaceToOpen=M;function s(p){return!!p.folderUri}e.isFolderToOpen=s;function L(p){return!!p.fileUri}e.isFileToOpen=L;function R(p){const m=k(p),v=p.getValue("window.menuBarVisibility");return v==="default"||m==="native"&&v==="compact"||E.isMacintosh&&E.isNative?"classic":v}e.getMenuBarVisibility=R;function k(p){if(E.isWeb)return"custom";const m=p.getValue("window");if(m){if(E.isMacintosh&&m.nativeTabs===!0||E.isMacintosh&&m.nativeFullScreen===!1)return"native";const y=m.titleBarStyle;if(y==="native"||y==="custom")return y}return E.isLinux?"native":"custom"}e.getTitleBarStyle=k;function h(p){if(!E.isWindows||E.isWeb||k(p)==="native")return!1;const m=p.getValue("window.experimental.windowControlsOverlay.enabled");return typeof m=="boolean"?m:!0}e.useWindowControlsOverlay=h;function l(p=0){return Math.pow(1.2,p)}e.zoomLevelToZoomFactor=l}),define(te[122],ie([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowError=e.WindowMode=e.defaultWindowState=e.UnloadReason=e.LoadReason=void 0;var E;(function(k){k[k.INITIAL=1]="INITIAL",k[k.LOAD=2]="LOAD",k[k.RELOAD=3]="RELOAD"})(E||(e.LoadReason=E={}));var M;(function(k){k[k.CLOSE=1]="CLOSE",k[k.QUIT=2]="QUIT",k[k.RELOAD=3]="RELOAD",k[k.LOAD=4]="LOAD"})(M||(e.UnloadReason=M={}));const s=function(k=1){return{width:1024,height:768,mode:k}};e.defaultWindowState=s;var L;(function(k){k[k.Maximized=0]="Maximized",k[k.Normal=1]="Normal",k[k.Minimized=2]="Minimized",k[k.Fullscreen=3]="Fullscreen"})(L||(e.WindowMode=L={}));var R;(function(k){k[k.UNRESPONSIVE=1]="UNRESPONSIVE",k[k.PROCESS_GONE=2]="PROCESS_GONE",k[k.LOAD=3]="LOAD"})(R||(e.WindowError=R={}))}),define(te[28],ie([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenContext=e.IWindowsMainService=void 0,e.IWindowsMainService=(0,E.createDecorator)("windowsMainService");var M;(function(s){s[s.CLI=0]="CLI",s[s.DOCK=1]="DOCK",s[s.MENU=2]="MENU",s[s.DIALOG=3]="DIALOG",s[s.DESKTOP=4]="DESKTOP",s[s.API=5]="API"})(M||(e.OpenContext=M={}))}),define(te[257],ie([0,1,14,22,4,56,2,31,74,109,5,21,28]),function(x,e,E,M,s,L,R,k,h,l,p,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var f;(function(w){w[w.Initial=1]="Initial",w[w.StoredCredentialsUsed=2]="StoredCredentialsUsed",w[w.LoginDialogShown=3]="LoginDialogShown"})(f||(f={}));let y=e.ProxyAuthHandler=class extends R.Disposable{constructor(r,g,c,b,S){super(),this.g=r,this.h=g,this.i=c,this.j=b,this.k=S,this.a=`${this.k.urlProtocol}.proxy-credentials`,this.b=void 0,this.c=f.Initial,this.f=void 0,this.l()}l(){const r=s.Event.fromNodeEventEmitter(E.app,"login",(g,c,b,S,D)=>({event:g,webContents:c,req:b,authInfo:S,callback:D}));this.B(r(this.m,this))}async m({event:r,authInfo:g,req:c,callback:b}){if(!g.isProxy)return;if(!this.b&&this.c===f.LoginDialogShown&&c.firstAuthAttempt){this.g.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}r.preventDefault();let S;if(this.b)this.g.trace("auth#onLogin (proxy) - pending proxy handling found"),S=await this.b;else{this.g.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.b=this.n(g);try{S=await this.b}finally{this.b=void 0}}b(S?.username,S?.password)}async n(r){this.g.trace("auth#resolveProxyCredentials (proxy) - enter");try{const g=await this.p(r);if(g)return this.g.trace("auth#resolveProxyCredentials (proxy) - got credentials"),g;this.g.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.g.trace("auth#resolveProxyCredentials (proxy) - exit")}}async p(r){this.g.trace("auth#doResolveProxyCredentials - enter",r);const g=String((0,L.hash)({scheme:r.scheme,host:r.host,port:r.port}));let c,b;try{const a=await this.i.getPassword(this.a,g);if(a){const i=JSON.parse(await this.j.decrypt(a));c=i.username,b=i.password}}catch(a){this.g.error(a)}if(this.c!==f.StoredCredentialsUsed&&typeof c=="string"&&typeof b=="string")return this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.c=f.StoredCredentialsUsed,{username:c,password:b};const S=this.h.getFocusedWindow()||this.h.getLastActiveWindow();if(!S){this.g.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.g.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${S.id} to handle proxy login`);const D={authInfo:r,username:this.f?.username??c,password:this.f?.password??b,replyChannel:`vscode:proxyAuthResponse:${(0,k.generateUuid)()}`};S.sendWhenReady("vscode:openProxyAuthenticationDialog",M.CancellationToken.None,D),this.c=f.LoginDialogShown;const t=await new Promise(a=>{const i=async(n,o,u)=>{if(o===D.replyChannel)if(this.g.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${S.id}`),S.win?.webContents.off("ipc-message",i),u){const d={username:u.username,password:u.password};try{if(u.remember){const I=await this.j.encrypt(JSON.stringify(d));await this.i.setPassword(this.a,g,I)}else await this.i.deletePassword(this.a,g)}catch(I){this.g.error(I)}a({username:d.username,password:d.password})}else a(void 0)};S.win?.webContents.on("ipc-message",i)});return this.f=t,t}};e.ProxyAuthHandler=y=be([Q(0,p.ILogService),Q(1,v.IWindowsMainService),Q(2,h.ICredentialsMainService),Q(3,l.IEncryptionMainService),Q(4,m.IProductService)],y)}),define(te[258],ie([0,1,74,5,34,21,28,215]),function(x,e,E,M,s,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsNativeMainService=void 0;let h=e.CredentialsNativeMainService=class extends k.BaseCredentialsMainService{constructor(p,m,v,f){super(p),this.n=m,this.p=v,this.r=f,this.j=y=>{this.r.sendToFocused("vscode:showCredentialsError",y.message??y)}}async getSecretStoragePrefix(){return Promise.resolve(this.p.urlProtocol)}async i(){if(this.f)return this.f;if(this.n.disableKeytar)return this.h.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.InMemoryCredentialsProvider,this.f;const p=await new Promise((m,v)=>{x(["keytar"],m,v)});return await p.findCredentials("test-keytar-loads"),this.f=p,this.f}};e.CredentialsNativeMainService=h=be([Q(0,M.ILogService),Q(1,s.INativeEnvironmentService),Q(2,L.IProductService),Q(3,R.IWindowsMainService)],h)}),define(te[259],ie([0,1,14,23,3,8,24,19,62,6,5,121,28]),function(x,e,E,M,s,L,R,k,h,l,p,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,l.createDecorator)(e.ID);let f=e.LaunchMainService=class{constructor(w,r,g,c){this.a=w,this.b=r,this.c=g,this.d=c}async start(w,r){this.a.trace("Received data from other instance: ",w,r),s.isMacintosh&&E.app.focus({steal:!0});const g=this.e(w);if(g.length){let c=Promise.resolve();if(this.b.getWindowCount()===0){const b=(0,M.firstOrDefault)(await this.b.openEmptyWindow({context:4}));b&&(c=b.ready())}c.then(()=>{for(const{uri:b,originalUrl:S}of g)this.c.open(b,{originalUrl:S})})}else return this.f(w,r)}e(w){return w["open-url"]&&w._urls&&w._urls.length>0?(0,M.coalesce)(w._urls.map(r=>{try{return{uri:L.URI.parse(r),originalUrl:r}}catch{return null}})):[]}async f(w,r){const g=(0,h.isLaunchedFromCli)(r)?0:4;let c=[];const b=w.wait&&w.waitMarkerFilePath?L.URI.file(w.waitMarkerFilePath):void 0,S=w.remote||void 0,D={context:g,cli:w,userEnv:r,waitMarkerFileURI:b,remoteAuthority:S,forceProfile:w.profile,forceTempProfile:w["profile-temp"]};if(w.extensionDevelopmentPath)await this.b.openExtensionDevelopmentHostWindow(w.extensionDevelopmentPath,D);else if(!w._.length&&!w["folder-uri"]&&!w["file-uri"]){let t=!1;if(w["new-window"]||w["unity-launch"]||D.forceProfile||D.forceTempProfile)t=!0;else if(w["reuse-window"])t=!1;else switch(this.d.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":t=!0;break;case"off":t=!1;break;default:t=!s.isMacintosh}if(t)c=await this.b.open({...D,forceNewWindow:!0,forceEmpty:!0});else{const a=this.b.getLastActiveWindow();a?(this.b.openExistingWindow(a,D),c=[a]):c=await this.b.open({...D,forceEmpty:!0})}}else c=await this.b.open({...D,forceNewWindow:w["new-window"],preferNewWindow:!w["reuse-window"]&&!w.wait,forceReuseWindow:w["reuse-window"],diffMode:w.diff,mergeMode:w.merge,addMode:w.add,noRecentEntry:!!w["skip-add-to-recently-opened"],gotoLineMode:w.goto});if(b&&c.length===1&&c[0])return Promise.race([c[0].whenClosedOrLoaded,(0,R.whenDeleted)(b.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.a.trace("Received request for process ID from other instance."),process.pid}};e.LaunchMainService=f=be([Q(0,p.ILogService),Q(1,v.IWindowsMainService),Q(2,m.IURLService),Q(3,k.IConfigurationService)],f)}),define(te[260],ie([0,1,14,4,2,256,28]),function(x,e,E,M,s,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let k=e.WebviewMainService=class extends s.Disposable{constructor(l){super(),this.b=l,this.a=this.B(new M.Emitter),this.onFoundInFrame=this.a.event,this.B(new L.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(l,p){let m;if(typeof l.windowId=="number"){const{windowId:v}=l,f=this.b.getWindowById(v);if(!f?.win)throw new Error(`Invalid windowId: ${v}`);m=f.win.webContents}else{const{webContentsId:v}=l;if(m=E.webContents.fromId(v),!m)throw new Error(`Invalid webContentsId: ${v}`)}m.isDestroyed()||m.setIgnoreMenuShortcuts(p)}async findInFrame(l,p,m,v){const y=this.c(l,p);if(typeof y.findInFrame=="function"){y.findInFrame(m,{findNext:v.findNext,forward:v.forward});const w=(r,g)=>{g.finalUpdate&&(this.a.fire(g),y.removeListener("found-in-frame",w))};y.on("found-in-frame",w)}}async stopFindInFrame(l,p,m){const f=this.c(l,p);typeof f.stopFindInFrame=="function"&&f.stopFindInFrame(m.keepSelection?"keepSelection":"clearSelection")}c(l,p){const m=this.b.getWindowById(l.windowId);if(!m?.win)throw new Error(`Invalid windowId: ${l}`);const v=m.win.webContents.mainFrame.framesInSubtree.find(f=>f.name===p);if(!v)throw new Error(`Unknown frame: ${p}`);return v}};e.WebviewMainService=k=be([Q(0,R.IWindowsMainService)],k)}),define(te[261],ie([0,1,7,4,2]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends s.Disposable{constructor({onDidOpenWindow:k,onDidFocusWindow:h,getActiveWindowId:l}){super(),this.a=this.B(new s.DisposableStore),M.Event.latch(M.Event.any(k,h))(this.f,this,this.a),this.b=(0,E.createCancelablePromise)(()=>l()),(async()=>{try{const m=await this.b;this.c=typeof this.c=="number"?this.c:m}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=L}),define(te[29],ie([0,1,186,9,61,18,8,6,15]),function(x,e,E,M,s,L,R,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function l(n){const o=n;return typeof o?.id=="string"&&R.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=l;function p(n){return typeof n?.id=="string"&&!l(n)&&!v(n)}e.isEmptyWorkspaceIdentifier=p,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function m(n,o){if(typeof n=="string"||typeof n>"u")return typeof n=="string"?{id:(0,M.basename)(n)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const u=n;return u.configuration?{id:u.id,configPath:u.configuration}:u.folders.length===1?{id:u.id,uri:u.folders[0].uri}:{id:u.id}}e.toWorkspaceIdentifier=m;function v(n){const o=n;return typeof o?.id=="string"&&R.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=v;function f(n){const o=n;if(o?.uri)return{id:o.id,uri:R.URI.revive(o.uri)};const u=n;if(u?.configPath)return{id:u.id,configPath:R.URI.revive(u.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=f;var y;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(y||(e.WorkbenchState=y={}));function w(n){const o=n;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=w;function r(n){const o=n;return!!(o&&typeof o=="object"&&R.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=r;class g{constructor(o,u,d,I,A){this.h=o,this.j=d,this.k=I,this.l=A,this.c=s.TernarySearchTree.forUris(this.l,()=>!0),this.folders=u}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=s.TernarySearchTree.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class c{constructor(o,u){this.raw=u,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,L.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=c;function b(n){return new c({uri:n,index:0,name:(0,L.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(n,o){return L.extUriBiasedIgnorePathCase.isEqualOrParent(n,o.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function D(n){let o;return R.URI.isUri(n)?o=n:o=n.configuration,o?.scheme===h.Schemas.tmp}e.isTemporaryWorkspace=D,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(n){return n.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function a(n,o){return!S(n,o)&&!D(n)}e.isSavedWorkspace=a;function i(n){return(typeof n=="string"?(0,M.extname)(n):(0,L.extname)(n))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=i}),define(te[58],ie([0,1,14,7,56,44,2,82,3,11,24,163,89,6,5,21,29]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,f.createDecorator)("dialogMainService");let g=e.DialogMainService=class{constructor(b,S){this.d=b,this.e=S,this.a=new Map,this.b=new Map,this.c=new M.Queue}pickFileFolder(b,S){return this.f({...b,pickFolders:!0,pickFiles:!0,title:(0,m.localize)(0,null)},S)}pickFolder(b,S){return this.f({...b,pickFolders:!0,title:(0,m.localize)(1,null)},S)}pickFile(b,S){return this.f({...b,pickFiles:!0,title:(0,m.localize)(2,null)},S)}pickWorkspace(b,S){const D=(0,m.localize)(3,null),t=(0,L.mnemonicButtonLabel)((0,m.localize)(4,null)),a=r.WORKSPACE_FILTER;return this.f({...b,pickFiles:!0,title:D,filters:a,buttonLabel:t},S)}async f(b,S){const D={title:b.title,buttonLabel:b.buttonLabel,filters:b.filters,defaultPath:b.defaultPath};(typeof b.pickFiles=="boolean"||typeof b.pickFolders=="boolean")&&(D.properties=void 0,b.pickFiles&&b.pickFolders&&(D.properties=["multiSelections","openDirectory","openFile","createDirectory"])),D.properties||(D.properties=["multiSelections",b.pickFolders?"openDirectory":"openFile","createDirectory"]),h.isMacintosh&&D.properties.push("treatPackageAsDirectory");const t=await this.showOpenDialog(D,(0,l.withNullAsUndefined)(S||E.BrowserWindow.getFocusedWindow()));if(t&&t.filePaths&&t.filePaths.length>0)return t.filePaths}g(b){if(b){let S=this.b.get(b.id);return S||(S=new M.Queue,this.b.set(b.id,S)),S}else return this.c}showMessageBox(b,S){return this.g(S).queue(async()=>{const{options:D,buttonIndeces:t}=(0,v.massageMessageBoxOptions)(b,this.e);let a;return S?a=await E.dialog.showMessageBox(S,D):a=await E.dialog.showMessageBox(D),{response:t[a.response],checkboxChecked:a.checkboxChecked}})}async showSaveDialog(b,S){const D=this.j(b,S);if(!D)return this.d.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.g(S).queue(async()=>{let t;return S?t=await E.dialog.showSaveDialog(S,b):t=await E.dialog.showSaveDialog(b),t.filePath=this.h(t.filePath),t})}finally{(0,R.dispose)(D)}}h(b){return b&&h.isMacintosh&&(b=(0,k.normalizeNFC)(b)),b}i(b){return b.map(S=>this.h(S))}async showOpenDialog(b,S){b.defaultPath&&(await p.Promises.exists(b.defaultPath)||(b.defaultPath=void 0));const D=this.j(b,S);if(!D)return this.d.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.g(S).queue(async()=>{let t;return S?t=await E.dialog.showOpenDialog(S,b):t=await E.dialog.showOpenDialog(b),t.filePaths=this.i(t.filePaths),t})}finally{(0,R.dispose)(D)}}j(b,S){if(!S)return R.Disposable.None;this.d.trace("[DialogMainService]: request to acquire file dialog lock",b);let D=this.a.get(S.id);D||(D=new Set,this.a.set(S.id,D));const t=(0,s.hash)(b);if(!D.has(t))return this.d.trace("[DialogMainService]: new file dialog lock created",b),D.add(t),(0,R.toDisposable)(()=>{this.d.trace("[DialogMainService]: file dialog lock disposed",b),D?.delete(t),D?.size===0&&this.a.delete(S.id)})}};e.DialogMainService=g=be([Q(0,y.ILogService),Q(1,w.IProductService)],g)}),define(te[262],ie([0,1,4,2,84,29]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class R extends M.Disposable{constructor(h,l){super(),this.f=h,this.g=l,this.b=this.B(new E.Emitter),this.c=new Map,this.h(l.applicationStorage,this.b)}h(h,l){this.B(E.Event.debounce(h.onDidChangeStorage,(p,m)=>(p?p.push(m):p=[m],p),R.a)(p=>{p.length&&l.fire(this.i(p,h))}))}i(h,l){const p=new Map,m=new Set;return h.forEach(v=>{const f=l.get(v.key);typeof f=="string"?p.set(v.key,f):m.add(v.key)}),{changed:Array.from(p.entries()),deleted:Array.from(m.values())}}listen(h,l,p){switch(l){case"onDidChangeStorage":{const m=p.profile?(0,s.revive)(p.profile):void 0;if(!m)return this.b.event;let v=this.c.get(m.id);return v||(v=this.B(new E.Emitter),this.h(this.g.profileStorage(m),v),this.c.set(m.id,v)),v.event}}throw new Error(`Event not found: ${l}`)}async call(h,l,p){const m=p.profile?(0,s.revive)(p.profile):void 0,v=(0,L.reviveIdentifier)(p.workspace),f=await this.j(m,v);switch(l){case"getItems":return Array.from(f.items.entries());case"updateItems":{const y=p;if(y.insert)for(const[w,r]of y.insert)f.set(w,r);y.delete?.forEach(w=>f.delete(w));break}case"isUsed":{const y=p.payload;if(typeof y=="string")return this.g.isUsed(y)}default:throw new Error(`Call not found: ${l}`)}}async j(h,l){let p;l?p=this.g.workspaceStorage(l):h?p=this.g.profileStorage(h):p=this.g.applicationStorage;try{await p.init()}catch(m){this.f.error(`StorageIPC#init: Unable to init ${l?"workspace":h?"profile":"application"} storage due to ${m}`)}return p}}e.StorageDatabaseChannel=R,R.a=100}),define(te[39],ie([0,1,56,4,2,18,8,183,34,16,6,5,29,35,38,7,31,27,11]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function b(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&R.URI.isUri(n.location)&&R.URI.isUri(n.globalStorageHome)&&R.URI.isUri(n.settingsResource)&&R.URI.isUri(n.keybindingsResource)&&R.URI.isUri(n.tasksResource)&&R.URI.isUri(n.snippetsHome)&&R.URI.isUri(n.extensionsResource))}e.isUserDataProfile=b,e.IUserDataProfilesService=(0,p.createDecorator)("IUserDataProfilesService");function S(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:R.URI.revive(i.location).with({scheme:n}),globalStorageHome:R.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:R.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:R.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:R.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:R.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:R.URI.revive(i.extensionsResource).with({scheme:n}),cacheHome:R.URI.revive(i.cacheHome).with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=S;function D(i,n,o,u,d){return{id:i,name:n,location:o,isDefault:!1,shortName:d?.shortName,globalStorageHome:(0,L.joinPath)(o,"globalStorage"),settingsResource:(0,L.joinPath)(o,"settings.json"),keybindingsResource:(0,L.joinPath)(o,"keybindings.json"),tasksResource:(0,L.joinPath)(o,"tasks.json"),snippetsHome:(0,L.joinPath)(o,"snippets"),extensionsResource:(0,L.joinPath)(o,"extensions.json"),cacheHome:(0,L.joinPath)(u,i),useDefaultFlags:d?.useDefaultFlags,isTransient:d?.transient}}e.toUserDataProfile=D;let t=e.UserDataProfilesService=class extends s.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(n,o,u,d){super(),this.n=n,this.r=o,this.s=u,this.t=d,this.f=!0,this.h=this.B(new M.Emitter),this.onDidChangeProfiles=this.h.event,this.i=this.B(new M.Emitter),this.onWillCreateProfile=this.i.event,this.j=this.B(new M.Emitter),this.onWillRemoveProfile=this.j.event,this.k=this.B(new M.Emitter),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new f.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,L.joinPath)(this.n.userRoamingDataHome,"profiles"),this.g=(0,L.joinPath)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(n){this.f!==n&&(this.u=void 0,this.f=n)}isEnabled(){return this.f}get v(){if(!this.u){const n=[];if(this.f)try{for(const I of this.J()){if(!I.name||!(0,c.isString)(I.name)||!I.location){this.t.warn("Skipping the invalid stored profile",I.location||I.name);continue}n.push(D((0,L.basename)(I.location),I.name,I.location,this.g,{shortName:I.shortName,useDefaultFlags:I.useDefaultFlags}))}}catch(I){this.t.error(I)}const o=new f.ResourceMap,u=new Map,d=this.w();if(n.unshift({...d,extensionsResource:this.O()??d.extensionsResource,isDefault:!0}),n.length)try{const I=this.M();if(I.workspaces)for(const[A,C]of Object.entries(I.workspaces)){const T=R.URI.parse(A),W=n.find($=>$.id===C);W&&o.set(T,W)}if(I.emptyWindows)for(const[A,C]of Object.entries(I.emptyWindows)){const T=n.find(W=>W.id===C);T&&u.set(A,T)}}catch(I){this.t.error(I)}this.u={profiles:n,workspaces:o,emptyWindows:u}}return this.u}w(){return D("__default__profile__",(0,k.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(n){const o="Temp",u=new RegExp(`${(0,g.escapeRegExpCharacters)(o)}\\s(\\d+)`);let d=0;for(const A of this.profiles){const C=u.exec(A.name),T=C?parseInt(C[1]):0;d=T>d?T:d}const I=`${o} ${d+1}`;return this.createProfile((0,E.hash)((0,r.generateUuid)()).toString(16),I,{transient:!0},n)}async createNamedProfile(n,o,u){return this.createProfile((0,E.hash)((0,r.generateUuid)()).toString(16),n,o,u)}async createProfile(n,o,u,d){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const I=await this.y(n,o,u);return d&&await this.setProfileForWorkspace(d,I),I}async y(n,o,u){if(!(0,c.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let d=this.l.get(o);return d||(d=(async()=>{try{const I=this.profiles.find(T=>T.name===o||T.id===n);if(I)return I;const A=D(n,o,(0,L.joinPath)(this.profilesHome,n),this.g,u);await this.r.createFolder(A.location);const C=[];return this.i.fire({profile:A,join(T){C.push(T)}}),await w.Promises.settled(C),this.D([A],[],[]),A}finally{this.l.delete(o)}})(),this.l.set(o,d)),d}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(d=>d.id===n.id);if(!u)throw new Error(`Profile '${n.name}' does not exist`);return u=D(u.id,o.name??u.name,u.location,this.g,{shortName:o.shortName??u.shortName,transient:o.transient??u.isTransient,useDefaultFlags:o.useDefaultFlags??u.useDefaultFlags}),this.D([],[],[u]),u}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(d=>d.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const u=[];this.j.fire({profile:o,join(d){u.push(d)}});try{await Promise.allSettled(u)}catch(d){this.t.error(d)}for(const d of[...this.v.emptyWindows.keys()])o.id===this.v.emptyWindows.get(d)?.id&&this.v.emptyWindows.delete(d);for(const d of[...this.v.workspaces.keys()])o.id===this.v.workspaces.get(d)?.id&&this.v.workspaces.delete(d);this.H(),this.D([],[o],[]);try{await this.r.del(o.cacheHome,{recursive:!0})}catch(d){(0,l.toFileOperationResult)(d)!==1&&this.t.error(d)}try{this.profiles.length===1?await this.r.del(this.profilesHome,{recursive:!0}):await this.r.del(o.location,{recursive:!0})}catch(d){this.t.error(d)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(d=>d.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.G(n,u)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(n,void 0,o)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const n=await this.r.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.s.extUri.isEqual(u.location,o.resource))).map(o=>this.r.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.m.profiles.filter(o=>!this.C(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.z(n);return R.URI.isUri(o)?this.m.workspaces.get(o)??this.v.workspaces.get(o):this.m.emptyWindows.get(o)??this.v.emptyWindows.get(o)}z(n){return(0,v.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,v.isWorkspaceIdentifier)(n)?n.configPath:n.id}C(n){return!!([...this.m.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.m.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.v.emptyWindows.values()].some(o=>this.s.extUri.isEqual(o.location,n.location))||[...this.v.workspaces.values()].some(o=>this.s.extUri.isEqual(o.location,n.location)))}D(n,o,u){const d=[...this.profiles,...n],I=[];this.m.profiles=[];for(let A of d)A.isDefault||o.some(C=>A.id===C.id)||(A=u.find(C=>A.id===C.id)??A,A.isTransient?this.m.profiles.push(A):I.push({location:A.location,name:A.name,shortName:A.shortName,useDefaultFlags:A.useDefaultFlags}));this.L(I),this.u=void 0,this.F(n,o,u)}F(n,o,u){this.h.fire({added:n,removed:o,updated:u,all:this.profiles})}G(n,o,u){u=o?.isTransient?!0:u,u||this.G(n,void 0,!0);const d=this.z(n),I=u?this.m:this.v;R.URI.isUri(d)?(I.workspaces.delete(d),o&&I.workspaces.set(d,o)):(I.emptyWindows.delete(d),o&&I.emptyWindows.set(d,o)),u||this.H()}H(){const n={};for(const[u,d]of this.v.workspaces.entries())n[u.toString()]=d.id;const o={};for(const[u,d]of this.v.emptyWindows.entries())o[u.toString()]=d.id;this.N({workspaces:n,emptyWindows:o}),this.u=void 0}I(n){const o={},u=this.w();if(n.workspaces)for(const[I,A]of Object.entries(n.workspaces)){const C=R.URI.parse(A);o[I]=this.s.extUri.isEqual(C,u.location)?u.id:this.s.extUri.basename(C)}const d={};if(n.emptyWindows)for(const[I,A]of Object.entries(n.emptyWindows)){const C=R.URI.parse(A);d[I]=this.s.extUri.isEqual(C,u.location)?u.id:this.s.extUri.basename(C)}return{workspaces:o,emptyWindows:d}}J(){return[]}L(n){throw new Error("not implemented")}M(){return{}}N(n){throw new Error("not implemented")}O(){}};t.b="userDataProfiles",t.c="profileAssociations",e.UserDataProfilesService=t=be([Q(0,h.IEnvironmentService),Q(1,l.IFileService),Q(2,y.IUriIdentityService),Q(3,m.ILogService)],t);class a extends t{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(n){this.a=n}M(){return this.R}N(n){this.R=n}}e.InMemoryUserDataProfilesService=a}),define(te[80],ie([0,1,7,17,2,4,35,8,110,117,16,6,5,39,38,11,13,25]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var c;(function(a){a.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",a.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(c||(e.ExtensionsProfileScanningErrorCode=c={}));class b extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=b,e.IExtensionsProfileScannerService=(0,m.createDecorator)("IExtensionsProfileScannerService");let S=e.AbstractExtensionsProfileScannerService=class extends s.Disposable{constructor(i,n,o,u,d,I){super(),this.i=i,this.j=n,this.k=o,this.l=u,this.m=d,this.n=I,this.b=this.B(new L.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new L.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new R.ResourceMap}scanProfileExtensions(i,n){return this.p(i,void 0,n)}async addExtensionsToProfile(i,n){const o=[],u=[];try{return await this.p(n,d=>{const I=[];for(const A of d)i.some(([C])=>(0,l.areSameExtensions)(C.identifier,A.identifier)&&C.manifest.version!==A.version)?o.push(A):I.push(A);for(const[A,C]of i)if(!I.some(T=>(0,l.areSameExtensions)(T.identifier,A.identifier)&&T.version===A.manifest.version)){const T={identifier:A.identifier,version:A.manifest.version,location:A.location,metadata:C};u.push(T),I.push(T)}return u.length&&this.b.fire({extensions:u,profileLocation:n}),o.length&&this.f.fire({extensions:o,profileLocation:n}),I}),u.length&&this.c.fire({extensions:u,profileLocation:n}),o.length&&this.g.fire({extensions:o,profileLocation:n}),u}catch(d){throw u.length&&this.c.fire({extensions:u,error:d,profileLocation:n}),o.length&&this.g.fire({extensions:o,error:d,profileLocation:n}),d}}async updateMetadata(i,n){const o=[];return await this.p(n,u=>{const d=[];for(const I of u){const A=i.find(([C])=>(0,l.areSameExtensions)(C.identifier,I.identifier)&&C.manifest.version===I.version);A&&(I.metadata={...I.metadata,...A[1]},o.push(I)),d.push(I)}return d}),o}async removeExtensionFromProfile(i,n){const o=[];this.f.fire({extensions:o,profileLocation:n});try{await this.p(n,u=>{const d=[];for(const I of u)(0,l.areSameExtensions)(I.identifier,i.identifier)?o.push(I):d.push(I);return o.length&&this.f.fire({extensions:o,profileLocation:n}),d}),o.length&&this.g.fire({extensions:o,profileLocation:n})}catch(u){throw o.length&&this.g.fire({extensions:o,error:u,profileLocation:n}),u}}async p(i,n,o){return this.w(i).queue(async()=>{let u=[],d;try{const I=await this.j.readFile(i);d=JSON.parse(I.value.toString().trim()||"[]")}catch(I){if((0,p.toFileOperationResult)(I)!==1)throw I;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(d=await this.v()),!d&&o?.bailOutWhenFileNotFound)throw new b((0,r.getErrorMessage)(I),"ERROR_PROFILE_NOT_FOUND")}if(d){Array.isArray(d)||this.r(i);let I=!1;for(const A of d){D(A)||this.r(i);let C;if((0,w.isString)(A.relativeLocation)&&A.relativeLocation)C=this.t(A.relativeLocation);else if((0,w.isString)(A.location))C=this.t(A.location),I=!0,A.relativeLocation=A.location,A.location=C.toJSON();else{C=k.URI.revive(A.location);const T=this.s(C);T&&(I=!0,A.relativeLocation=T)}u.push({identifier:A.identifier,location:C,version:A.version,metadata:A.metadata})}I&&await this.j.writeFile(i,M.VSBuffer.fromString(JSON.stringify(d)))}if(n){u=n(u);const I=u.map(A=>({identifier:A.identifier,version:A.version,location:A.location.toJSON(),relativeLocation:this.s(A.location),metadata:A.metadata}));await this.j.writeFile(i,M.VSBuffer.fromString(JSON.stringify(I)))}return u})}r(i){const n=new b(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let o;try{o=(await this.j.readFile(i)).value.toString()}catch(d){if((0,p.toFileOperationResult)(d)===1)return;throw d}this.n.info("Migrating extensions from old default profile location",i.toString());let u;try{const d=JSON.parse(o);Array.isArray(d)&&d.every(I=>D(I))?u=d:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",d)}catch(d){this.n.error(d)}if(u)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,M.VSBuffer.fromString(JSON.stringify(u)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(d){if((0,p.toFileOperationResult)(d)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw d}try{await this.j.del(i)}catch(d){(0,p.toFileOperationResult)(d)!==1&&this.n.error(d)}try{await this.j.del(n)}catch(d){(0,p.toFileOperationResult)(d)!==1&&this.n.error(d)}return u})()),this.u}w(i){let n=this.h.get(i);return n||(n=new E.Queue,this.h.set(i,n)),n}};e.AbstractExtensionsProfileScannerService=S=be([Q(1,p.IFileService),Q(2,f.IUserDataProfilesService),Q(3,y.IUriIdentityService),Q(4,g.ITelemetryService),Q(5,v.ILogService)],S);function D(a){return(0,w.isObject)(a)&&(0,h.isIExtensionIdentifier)(a.identifier)&&(t(a.location)||(0,w.isString)(a.location)&&a.location)&&((0,w.isUndefined)(a.relativeLocation)||(0,w.isString)(a.relativeLocation))&&a.version&&(0,w.isString)(a.version)}function t(a){return a?(0,w.isString)(a.path)&&(0,w.isString)(a.scheme):!1}}),define(te[123],ie([0,1,23,7,40,17,13,43,145,2,15,9,3,18,200,72,11,8,168,34,117,114,199,16,6,5,21,4,84,80,39,38,198]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g,c,b,S,D,t,a,i,n,o,u,d,I,A,C,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var W;(function(ce){function X(q,B){if(q===B)return!0;const z=Object.keys(q),K=new Set;for(const ee of Object.keys(B))K.add(ee);if(z.length!==K.size)return!1;for(const ee of z){if(q[ee]!==B[ee])return!1;K.delete(ee)}return K.size===0}ce.equals=X})(W||(e.Translations=W={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let $=e.AbstractExtensionsScannerService=class extends l.Disposable{constructor(X,q,B,z,K,ee,oe,le,Y,O,P,F){super(),this.systemExtensionsLocation=X,this.userExtensionsLocation=q,this.l=B,this.m=z,this.n=K,this.r=ee,this.s=oe,this.t=le,this.u=Y,this.v=O,this.w=P,this.y=F,this.g=this.B(new u.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,f.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(ne,this.m,this.h)),this.j=this.B(this.y.createInstance(ne,this.m,this.h)),this.k=this.B(this.y.createInstance(Z,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,S.computeTargetPlatform)(this.s,this.t)),this.z}async scanAllExtensions(X,q,B){const[z,K]=await Promise.all([this.scanSystemExtensions(X),this.scanUserExtensions(q)]),ee=B?await this.scanExtensionsUnderDevelopment(X,[...z,...K]):[];return this.G(z,K,ee,await this.getTargetPlatform(),!0)}async scanSystemExtensions(X){const q=[];q.push(this.H(!!X.useCache,X.language)),q.push(this.I(X.language,!!X.checkControlFile));const[B,z]=await Promise.all(q);return this.F([...B,...z],0,X,!1)}async scanUserExtensions(X){const q=X.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",q);const B=this.w.extUri.isEqual(X.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,z=await this.L(q,!!X.profileLocation,1,!X.includeUninstalled,X.language,!0,B),K=X.useCache&&!z.devMode&&z.excludeObsolete?this.j:this.k;let ee;try{ee=await K.scanExtensions(z)}catch(oe){if(oe instanceof I.ExtensionsProfileScanningError&&oe.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),ee=await K.scanExtensions(z);else throw oe}return ee=await this.F(ee,1,X,!0),this.t.trace("Scanned user extensions:",ee.length),ee}async scanExtensionsUnderDevelopment(X,q){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const B=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(z=>z.scheme===p.Schemas.file).map(async z=>{const K=await this.L(z,!1,1,!0,X.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(K)).map(oe=>(oe.type=q.find(le=>(0,S.areSameExtensions)(le.identifier,oe.identifier))?.type??oe.type,this.k.validate(oe,K)))}))).flat();return this.F(B,"development",X,!0)}return[]}async scanExistingExtension(X,q,B){const z=await this.L(X,!1,q,!0,B.language,!0,void 0),K=await this.k.scanExtension(z);return!K||!B.includeInvalid&&!K.isValid?null:K}async scanOneOrMultipleExtensions(X,q,B){const z=await this.L(X,!1,q,!0,B.language,!0,void 0),K=await this.k.scanOneOrMultipleExtensions(z);return this.F(K,q,B,!0)}async scanMetadata(X){const q=(0,f.joinPath)(X,"package.json"),B=(await this.s.readFile(q)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(X,q){const B=(0,f.joinPath)(X,"package.json"),z=(await this.s.readFile(B)).value.toString(),K=JSON.parse(z);q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,K.__metadata={...K.__metadata,...q},await this.s.writeFile((0,f.joinPath)(X,"package.json"),L.VSBuffer.fromString(JSON.stringify(K,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(X){if(X instanceof I.ExtensionsProfileScanningError&&X.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw X}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const X=await this.scanUserExtensions({includeInvalid:!0});if(X.length)await this.r.addExtensionsToProfile(X.map(q=>[q,q.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,L.VSBuffer.fromString(JSON.stringify([])))}catch(q){(0,a.toFileOperationResult)(q)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,R.getErrorMessage)(q))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(X){this.t.error(X)}finally{this.C=void 0}})()),this.C}async F(X,q,B,z){return B.includeAllVersions||(X=this.G(q===0?X:void 0,q===1?X:void 0,q==="development"?X:void 0,await this.getTargetPlatform(),z)),B.includeInvalid||(X=X.filter(K=>K.isValid)),X.sort((K,ee)=>{const oe=m.basename(K.location.fsPath),le=m.basename(ee.location.fsPath);return oe<le?-1:oe>le?1:0})}G(X,q,B,z,K){const ee=(le,Y,O)=>{if(le.isValid&&!Y.isValid)return!1;if(le.isValid===Y.isValid){if(K&&y.gt(le.manifest.version,Y.manifest.version))return this.t.debug(`Skipping extension ${Y.location.path} with lower version ${Y.manifest.version} in favour of ${le.location.path} with version ${le.manifest.version}`),!1;if(y.eq(le.manifest.version,Y.manifest.version)){if(le.type===0)return this.t.debug(`Skipping extension ${Y.location.path} in favour of system extension ${le.location.path} with same version`),!1;if(le.targetPlatform===z)return this.t.debug(`Skipping extension ${Y.location.path} from different target platform ${Y.targetPlatform}`),!1}}return O?this.t.warn(`Overwriting user extension ${le.location.path} with ${Y.location.path}.`):this.t.debug(`Overwriting user extension ${le.location.path} with ${Y.location.path}.`),!0},oe=new D.ExtensionIdentifierMap;return X?.forEach(le=>{const Y=oe.get(le.identifier.id);(!Y||ee(Y,le,!1))&&oe.set(le.identifier.id,le)}),q?.forEach(le=>{const Y=oe.get(le.identifier.id);if(!Y&&X&&le.type===0){this.t.debug(`Skipping obsolete system extension ${le.location.path}.`);return}(!Y||ee(Y,le,!1))&&oe.set(le.identifier.id,le)}),B?.forEach(le=>{const Y=oe.get(le.identifier.id);(!Y||ee(Y,le,!0))&&oe.set(le.identifier.id,le),oe.set(le.identifier.id,le)}),[...oe.values()]}async H(X,q){this.t.trace("Started scanning system extensions");const B=await this.L(this.systemExtensionsLocation,!1,0,!0,q,!0,void 0),K=await(X&&!B.devMode?this.i:this.k).scanExtensions(B);return this.t.trace("Scanned system extensions:",K.length),K}async I(X,q){const B=this.u.isBuilt?[]:this.v.builtInExtensions;if(!B?.length)return[];this.t.trace("Started scanning dev system extensions");const z=q?await this.J():{},K=[],ee=g.URI.file(m.normalize(m.join(p.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const le of B){const Y=z[le.name]||"marketplace";switch(Y){case"disabled":break;case"marketplace":K.push((0,f.joinPath)(ee,le.name));break;default:K.push(g.URI.file(Y));break}}const oe=await Promise.all(K.map(async le=>this.k.scanExtension(await this.L(le,!1,0,!0,X,!0,void 0))));return this.t.trace("Scanned dev system extensions:",oe.length),(0,E.coalesce)(oe)}async J(){try{const X=await this.s.readFile(this.l);return JSON.parse(X.value.toString())}catch{return{}}}async L(X,q,B,z,K,ee,oe){const le=await this.f(K??v.language),Y=await this.M(X),O=q&&!this.w.extUri.isEqual(X,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,P=O?await this.M(O):void 0;return new H(X,Y,O,P,q,oe,B,z,ee,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,K,le)}async M(X){try{const q=await this.s.stat(X);if(typeof q.mtime=="number")return q.mtime}catch{}}};e.AbstractExtensionsScannerService=$=be([Q(4,A.IUserDataProfilesService),Q(5,I.IExtensionsProfileScannerService),Q(6,a.IFileService),Q(7,n.ILogService),Q(8,b.IEnvironmentService),Q(9,o.IProductService),Q(10,C.IUriIdentityService),Q(11,i.IInstantiationService)],$);class H{constructor(X,q,B,z,K,ee,oe,le,Y,O,P,F,N,j,U){this.location=X,this.mtime=q,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=z,this.profile=K,this.profileScanOptions=ee,this.type=oe,this.excludeObsolete=le,this.validate=Y,this.productVersion=O,this.productDate=P,this.productCommit=F,this.devMode=N,this.language=j,this.translations=U}static createNlsConfiguration(X){return{language:X.language,pseudo:X.language==="pseudo",devMode:X.devMode,translations:X.translations}}static equals(X,q){return(0,f.isEqual)(X.location,q.location)&&X.mtime===q.mtime&&(0,f.isEqual)(X.applicationExtensionslocation,q.applicationExtensionslocation)&&X.applicationExtensionslocationMtime===q.applicationExtensionslocationMtime&&X.profile===q.profile&&s.equals(X.profileScanOptions,q.profileScanOptions)&&X.type===q.type&&X.excludeObsolete===q.excludeObsolete&&X.validate===q.validate&&X.productVersion===q.productVersion&&X.productDate===q.productDate&&X.productCommit===q.productCommit&&X.devMode===q.devMode&&X.language===q.language&&W.equals(X.translations,q.translations)}}e.ExtensionScannerInput=H;let Z=class extends l.Disposable{constructor(X,q,B,z,K){super(),this.f=X,this.g=q,this.h=B,this.i=z,this.j=K}async scanExtensions(X){const q=X.profile?await this.l(X):await this.k(X);let B={};if(X.excludeObsolete&&X.type===1)try{const z=(await this.i.readFile(this.f)).value.toString();B=JSON.parse(z)}catch{}return(0,r.isEmptyObject)(B)?q:q.filter(z=>!B[S.ExtensionKey.create(z).toString()])}async k(X){const q=await this.i.resolve(X.location);if(!q.children?.length)return[];const B=await Promise.all(q.children.map(async z=>{if(!z.isDirectory||X.type===1&&(0,f.basename)(z.resource).indexOf(".")===0)return null;const K=new H(z.resource,X.mtime,X.applicationExtensionslocation,X.applicationExtensionslocationMtime,X.profile,X.profileScanOptions,X.type,X.excludeObsolete,X.validate,X.productVersion,X.productDate,X.productCommit,X.devMode,X.language,X.translations);return this.scanExtension(K)}));return(0,E.coalesce)(B).sort((z,K)=>z.location.path<K.location.path?-1:1)}async l(X){let q=await this.m(X.location,()=>!0,X);if(X.applicationExtensionslocation&&!this.h.extUri.isEqual(X.location,X.applicationExtensionslocation)){q=q.filter(z=>!z.metadata?.isApplicationScoped);const B=await this.m(X.applicationExtensionslocation,z=>!!z.metadata?.isBuiltin||!!z.metadata?.isApplicationScoped,X);q.push(...B)}return q}async m(X,q,B){const z=await this.g.scanProfileExtensions(X,B.profileScanOptions);if(!z.length)return[];const K=await Promise.all(z.map(async ee=>{if(q(ee)){const oe=new H(ee.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(oe,ee.metadata)}return null}));return(0,E.coalesce)(K)}async scanOneOrMultipleExtensions(X){try{if(await this.i.exists((0,f.joinPath)(X.location,"package.json"))){const q=await this.scanExtension(X);return q?[q]:[]}else return await this.scanExtensions(X)}catch(q){return this.j.error(`Error scanning extensions at ${X.location.path}:`,(0,R.getErrorMessage)(q)),[]}}async scanExtension(X,q){try{let B=await this.scanExtensionManifest(X.location);if(B){B.publisher||(B.publisher=D.UNDEFINED_PUBLISHER),q=q??B.__metadata,delete B.__metadata;const z=(0,S.getGalleryExtensionId)(B.publisher,B.name),K=q?.id?{id:z,uuid:q.id}:{id:z},ee=q?.isSystem?0:X.type,oe=ee===0||!!q?.isBuiltin;B=await this.n(X.location,B,H.createNlsConfiguration(X));const le={type:ee,identifier:K,manifest:B,location:X.location,isBuiltin:oe,targetPlatform:q?.targetPlatform??"undefined",metadata:q,isValid:!0,validations:[]};return X.validate?this.validate(le,X):le}}catch(B){X.type!==0&&this.j.error(B)}return null}validate(X,q){let B=!0;const z=(0,t.validateExtensionManifest)(q.productVersion,q.productDate,q.location,X.manifest,X.isBuiltin);for(const[K,ee]of z)K===w.default.Error&&(B=!1,this.j.error(this.u(q.location,ee)));return X.isValid=B,X.validations=z,X}async scanExtensionManifest(X){const q=(0,f.joinPath)(X,"package.json");let B;try{B=(await this.i.readFile(q)).value.toString()}catch(K){return(0,a.toFileOperationResult)(K)!==1&&this.j.error(this.u(X,(0,c.localize)(0,null,q.path,K.message))),null}let z;try{z=JSON.parse(B)}catch{const ee=[];(0,k.parse)(B,ee);for(const oe of ee)this.j.error(this.u(X,(0,c.localize)(1,null,q.path,oe.offset,oe.length,(0,h.getParseErrorMessage)(oe.error))));return null}return(0,k.getNodeType)(z)!=="object"?(this.j.error(this.u(X,(0,c.localize)(2,null,q.path))),null):z}async n(X,q,B){const z=await this.r(X,q,B);if(z)try{const K=[],ee=await this.s(z.default,K);if(K.length>0)return K.forEach(le=>{this.j.error(this.u(X,(0,c.localize)(3,null,z.default?.path,(0,h.getParseErrorMessage)(le.error))))}),q;if((0,k.getNodeType)(z)!=="object")return this.j.error(this.u(X,(0,c.localize)(4,null,z.default?.path))),q;const oe=z.values||Object.create(null);return(0,T.localizeManifest)(q,oe,ee)}catch{}return q}async r(X,q,B){const z=(0,f.joinPath)(X,"package.nls.json"),K=(Y,O)=>{O.forEach(P=>{this.j.error(this.u(X,(0,c.localize)(5,null,Y?.path,(0,h.getParseErrorMessage)(P.error))))})},ee=Y=>{this.j.error(this.u(X,(0,c.localize)(6,null,Y?.path)))},oe=`${q.publisher}.${q.name}`,le=B.translations[oe];if(le)try{const Y=g.URI.file(le),O=(await this.i.readFile(Y)).value.toString(),P=[],F=(0,k.parse)(O,P);return P.length>0?(K(Y,P),{values:void 0,default:z}):(0,k.getNodeType)(F)!=="object"?(ee(Y),{values:void 0,default:z}):{values:F.contents?F.contents.package:void 0,default:z}}catch{return{values:void 0,default:z}}else{if(!await this.i.exists(z))return;let O;try{O=await this.t(X,B)}catch{return}if(!O.localized)return{values:void 0,default:O.original};try{const P=(await this.i.readFile(O.localized)).value.toString(),F=[],N=(0,k.parse)(P,F);return F.length>0?(K(O.localized,F),{values:void 0,default:O.original}):(0,k.getNodeType)(N)!=="object"?(ee(O.localized),{values:void 0,default:O.original}):{values:N,default:O.original}}catch{return{values:void 0,default:O.original}}}}async s(X,q){if(X)try{const B=(await this.i.readFile(X)).value.toString();return(0,k.parse)(B,q)}catch{}}t(X,q){return new Promise((B,z)=>{const K=ee=>{const oe=(0,f.joinPath)(X,`package.nls.${ee}.json`);this.i.exists(oe).then(le=>{le&&B({localized:oe,original:(0,f.joinPath)(X,"package.nls.json")});const Y=ee.lastIndexOf("-");Y===-1?B({localized:(0,f.joinPath)(X,"package.nls.json"),original:null}):(ee=ee.substring(0,Y),K(ee))})};if(q.devMode||q.pseudo||!q.language)return B({localized:(0,f.joinPath)(X,"package.nls.json"),original:null});K(q.language)})}u(X,q){return`[${X.path}]: ${q}`}};Z=be([Q(1,I.IExtensionsProfileScannerService),Q(2,C.IUriIdentityService),Q(3,a.IFileService),Q(4,n.ILogService)],Z);let ne=class extends Z{constructor(X,q,B,z,K,ee,oe){super(q,z,K,ee,oe),this.z=X,this.C=B,this.w=this.B(new M.ThrottledDelayer(3e3)),this.y=this.B(new u.Emitter),this.onDidChangeCache=this.y.event}async scanExtensions(X){const q=this.H(X),B=await this.D(q);if(this.v=X,B&&B.input&&H.equals(B.input,this.v))return this.j.debug("Using cached extensions scan result",X.location.toString()),this.w.trigger(()=>this.G()),B.result.map(K=>(K.location=g.URI.revive(K.location),K));const z=await super.scanExtensions(X);return await this.F(q,{input:X,result:z}),z}async D(X){try{const q=await this.i.readFile(X),B=JSON.parse(q.value.toString());return{result:B.result,input:(0,d.revive)(B.input)}}catch(q){this.j.debug("Error while reading the extension cache file:",X.path,(0,R.getErrorMessage)(q))}return null}async F(X,q){try{await this.i.writeFile(X,L.VSBuffer.fromString(JSON.stringify(q)))}catch(B){this.j.debug("Error while writing the extension cache file:",X.path,(0,R.getErrorMessage)(B))}}async G(){if(!this.v)return;const X=this.H(this.v),q=await this.D(X);if(!q)return;const B=q.result,z=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!s.equals(z,B))try{this.j.info("Invalidating Cache",B,z),await this.i.del(X),this.y.fire()}catch(K){this.j.error(K)}}H(X){const q=this.I(X);return this.h.extUri.joinPath(q.cacheHome,X.type===0?D.BUILTIN_MANIFEST_CACHE_FILE:D.USER_MANIFEST_CACHE_FILE)}I(X){return X.type===0?this.C.defaultProfile:X.profile?this.h.extUri.isEqual(X.location,this.z.extensionsResource)?this.z:this.C.profiles.find(q=>this.h.extUri.isEqual(X.location,q.extensionsResource))??this.z:this.C.defaultProfile}};ne=be([Q(2,A.IUserDataProfilesService),Q(3,I.IExtensionsProfileScannerService),Q(4,C.IUriIdentityService),Q(5,a.IFileService),Q(6,n.ILogService)],ne);function se(ce,X){const q=(0,S.getExtensionId)(ce.manifest.publisher,ce.manifest.name);return{id:q,identifier:new D.ExtensionIdentifier(q),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:X,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,...ce.manifest}}e.toExtensionDescription=se;class ue extends ${constructor(X,q,B,z,K,ee,oe,le,Y,O,P,F){super(X,q,(0,f.joinPath)(B,".vscode-oss-dev","extensions","control.json"),z,K,ee,oe,le,Y,O,P,F),this.N=(async()=>{if(v.translationsConfigFile)try{const N=await this.s.readFile(g.URI.file(v.translationsConfigFile));return JSON.parse(N.value.toString())}catch{}return Object.create(null)})()}f(X){return this.N}}e.NativeExtensionsScannerService=ue}),define(te[263],ie([0,1,5,39,38,25,80,16,34,8]),function(x,e,E,M,s,L,R,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let p=e.ExtensionsProfileScannerService=class extends R.AbstractExtensionsProfileScannerService{constructor(v,f,y,w,r,g){super(l.URI.file(v.extensionsPath),f,y,w,r,g)}};e.ExtensionsProfileScannerService=p=be([Q(0,h.INativeEnvironmentService),Q(1,k.IFileService),Q(2,M.IUserDataProfilesService),Q(3,s.IUriIdentityService),Q(4,L.ITelemetryService),Q(5,E.ILogService)],p)}),define(te[264],ie([0,1,8,34,80,123,16,6,5,21,38,39]),function(x,e,E,M,s,L,R,k,h,l,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let v=e.ExtensionsScannerService=class extends L.NativeExtensionsScannerService{constructor(y,w,r,g,c,b,S,D){super(E.URI.file(c.builtinExtensionsPath),E.URI.file(c.extensionsPath),c.userHome,y.defaultProfile,y,w,r,g,c,b,S,D)}};e.ExtensionsScannerService=v=be([Q(0,m.IUserDataProfilesService),Q(1,s.IExtensionsProfileScannerService),Q(2,R.IFileService),Q(3,h.ILogService),Q(4,M.INativeEnvironmentService),Q(5,l.IProductService),Q(6,p.IUriIdentityService),Q(7,k.IInstantiationService)],v)}),define(te[265],ie([0,1,14,2,15,9,3,61,8,31,42,34,5,39]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let y=e.ProtocolMainService=class extends M.Disposable{constructor(r,g,c){super(),this.c=r,this.f=c,this.a=k.TernarySearchTree.forPaths(!R.isLinux),this.b=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp",".webp"]),this.addValidFileRoot(r.appRoot),this.addValidFileRoot(r.extensionsPath),this.addValidFileRoot(g.defaultProfile.globalStorageHome.fsPath),this.addValidFileRoot(r.workspaceStorageHome.fsPath),this.g()}g(){const{defaultSession:r}=E.session;r.protocol.registerFileProtocol(s.Schemas.vscodeFileResource,(g,c)=>this.i(g,c)),r.protocol.interceptFileProtocol(s.Schemas.file,(g,c)=>this.h(g,c)),this.B((0,M.toDisposable)(()=>{r.protocol.unregisterProtocol(s.Schemas.vscodeFileResource),r.protocol.uninterceptProtocol(s.Schemas.file)}))}addValidFileRoot(r){const g=(0,L.normalize)(r);return this.a.get(g)?M.Disposable.None:(this.a.set(g,!0),(0,M.toDisposable)(()=>this.a.delete(g)))}h(r,g){const c=h.URI.parse(r.url);return this.f.error(`Refused to load resource ${c.fsPath} from ${s.Schemas.file}: protocol (original URL: ${r.url})`),g({error:-3})}i(r,g){const c=this.j(r);let b;return this.c.crossOriginIsolated&&((0,L.basename)(c)==="workbench.html"||(0,L.basename)(c)==="workbench-dev.html"?b=s.COI.CoopAndCoep:b=s.COI.getHeadersFromQuery(r.url)),this.a.findSubstr(c)?g({path:c,headers:b}):this.b.has((0,L.extname)(c).toLowerCase())?g({path:c}):(this.f.error(`${s.Schemas.vscodeFileResource}: Refused to load resource ${c} from ${s.Schemas.vscodeFileResource}: protocol (original URL: ${r.url})`),g({error:-3}))}j(r){const g=h.URI.parse(r.url),c=s.FileAccess.uriToFileUri(g);return(0,L.normalize)(c.fsPath)}createIPCObjectUrl(){let r;const g=h.URI.from({scheme:"vscode",path:(0,l.generateUuid)()}),c=g.toString(),b=async()=>r;return p.validatedIpcMain.handle(c,b),this.f.trace(`IPC Object URL: Registered new channel ${c}.`),{resource:g,update:S=>r=S,dispose:()=>{this.f.trace(`IPC Object URL: Removed channel ${c}.`),p.validatedIpcMain.removeHandler(c)}}}};e.ProtocolMainService=y=be([Q(0,m.INativeEnvironmentService),Q(1,f.IUserDataProfilesService),Q(2,v.ILogService)],y)}),define(te[94],ie([0,1,7,4,2,64,11,106,6,39]),function(x,e,E,M,s,L,R,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,h.createDecorator)("storageService");var p;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(p||(e.WillSaveStateReason=p={}));var m;(function(c){c[c.APPLICATION=-1]="APPLICATION",c[c.PROFILE=0]="PROFILE",c[c.WORKSPACE=1]="WORKSPACE"})(m||(e.StorageScope=m={}));var v;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function f(c){const b=c.get(e.TARGET_KEY);if(b)try{return JSON.parse(b)}catch{}return Object.create(null)}e.loadKeyTargets=f;class y extends s.Disposable{constructor(b={flushInterval:y.a}){super(),this.j=b,this.b=this.B(new M.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new M.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new M.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new E.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new s.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,E.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,s.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.J()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(b,S){if(S===e.TARGET_KEY){switch(b){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:b})}else this.b.fire({scope:b,key:S,target:this.F(b)[S]})}r(b){this.f.fire({reason:b})}get(b,S,D){return this.L(S)?.get(b,D)}getBoolean(b,S,D){return this.L(S)?.getBoolean(b,D)}getNumber(b,S,D){return this.L(S)?.getNumber(b,D)}store(b,S,D,t){if((0,R.isUndefinedOrNull)(S)){this.remove(b,D);return}this.t(()=>{this.u(b,D,t),this.L(D)?.set(b,S)})}remove(b,S){this.t(()=>{this.u(b,S,void 0),this.L(S)?.delete(b)})}t(b){this.b.pause(),this.c.pause();try{b()}finally{this.b.resume(),this.c.resume()}}keys(b,S){const D=[],t=this.F(b);for(const a of Object.keys(t))t[a]===S&&D.push(a);return D}u(b,S,D){const t=this.F(S);typeof D=="number"?t[b]!==D&&(t[b]=D,this.L(S)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[b]=="number"&&(delete t[b],this.L(S)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(b){switch(b){case-1:return this.D;case 0:return this.z;default:return this.w}}G(b){const S=this.L(b);return S?f(S):Object.create(null)}isNew(b){return this.getBoolean(e.IS_NEW_KEY,b)===!0}async flush(b=p.NONE){this.f.fire({reason:b});const S=this.L(-1),D=this.L(0),t=this.L(1);switch(b){case p.NONE:await E.Promises.settled([S?.whenFlushed()??Promise.resolve(),D?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case p.SHUTDOWN:await E.Promises.settled([S?.flush(0)??Promise.resolve(),D?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const b=this.L(-1)?.items??new Map,S=this.L(0)?.items??new Map,D=this.L(1)?.items??new Map;return g(b,S,D,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(b,S){return this.r(p.NONE),(0,l.isUserDataProfile)(b)?this.N(b,S):this.O(b,S)}H(b,S){return!(b.id===S.id||w(S)&&w(b))}I(b,S,D,t){this.t(()=>{if(t)for(const[a,i]of b)S.set(a,i);else{const a=new Set;for(const[i,n]of b)a.add(i),S.get(i)!==n&&this.n(D,i);for(const[i]of S.items)a.has(i)||this.n(D,i)}})}}e.AbstractStorageService=y,y.a=60*1e3;function w(c){return c.isDefault||!!c.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=w;class r extends y{constructor(){super(),this.p=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(b=>this.n(1,b))),this.B(this.P.onDidChangeStorage(b=>this.n(0,b))),this.B(this.p.onDidChangeStorage(b=>this.n(-1,b)))}L(b){switch(b){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(b){switch(b){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(b){return!1}}e.InMemoryStorageService=r;async function g(c,b,S,D,t,a){const i=W=>{try{return JSON.parse(W)}catch{return W}},n=new Map,o=new Map;c.forEach((W,$)=>{n.set($,W),o.set($,i(W))});const u=new Map,d=new Map;b.forEach((W,$)=>{u.set($,W),d.set($,i(W))});const I=new Map,A=new Map;S.forEach((W,$)=>{I.set($,W),A.set($,i(W))}),console.group(D!==t?`Storage: Application (path: ${D})`:`Storage: Application & Profile (path: ${D}, default profile)`);const C=[];if(n.forEach((W,$)=>{C.push({key:$,value:W})}),console.table(C),console.groupEnd(),console.log(o),D!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const W=[];u.forEach(($,H)=>{W.push({key:H,value:$})}),console.table(W),console.groupEnd(),console.log(d)}console.group(`Storage: Workspace (path: ${a})`);const T=[];I.forEach((W,$)=>{T.push({key:$,value:W})}),console.table(T),console.groupEnd(),console.log(A)}e.logStorage=g}),define(te[266],ie([0,1,23,7,4,2,9,83,8,24,106,157,5,94,25,29]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageMain=e.WorkspaceStorageMain=e.ApplicationStorageMain=e.ProfileStorageMain=void 0;class r extends L.Disposable{get storage(){return this.f}constructor(a,i){super(),this.j=a,this.k=i,this.b=this.B(new s.Emitter),this.onDidChangeStorage=this.b.event,this.c=this.B(new s.Emitter),this.onDidCloseStorage=this.c.event,this.f=new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY}),this.g=void 0,this.h=new M.DeferredPromise,this.whenInit=this.h.p,this.i=p.StorageState.None}isInMemory(){return this.f.isInMemory()}init(){return this.g||(this.g=(async()=>{if(this.i===p.StorageState.None)try{const a=await this.n();this.f.dispose(),this.f=a,this.B(a.onDidChangeStorage(n=>this.b.fire({key:n}))),await this.m(a);const i=a.getBoolean(f.IS_NEW_KEY);i===void 0?a.set(f.IS_NEW_KEY,!0):i&&a.set(f.IS_NEW_KEY,!1)}catch(a){this.j.error(`[storage main] initialize(): Unable to init storage due to ${a}`)}finally{this.i=p.StorageState.Initialized,this.h.complete()}})()),this.g}l(){return{logTrace:this.j.getLevel()===v.LogLevel.Trace?a=>this.j.trace(a):void 0,logError:a=>this.j.error(a)}}m(a){return a.init()}get items(){return this.f.items}get(a,i){return this.f.get(a,i)}set(a,i){return this.f.set(a,i)}delete(a){return this.f.delete(a)}async close(){const a=new k.StopWatch(!1);await this.s(),a.stop(),a.elapsed()>r.a&&await this.r(a),this.c.fire()}async r(a){if(this.path)try{const i=(0,E.top)(Array.from(this.f.items.entries()).map(([o,u])=>({key:o,length:u.length})),(o,u)=>u.length-o.length,5).map(o=>`${o.key}:${o.length}`).join(", "),n=(await this.k.stat(h.URI.file(this.path))).size;this.j.warn(`[storage main] detected slow close() operation: Time: ${a.elapsed()}ms, DB size: ${n}b, Large Keys: ${i}`)}catch(i){this.j.error("[storage main] figuring out stats for slow DB on close() resulted in an error",i)}}async s(){this.g&&await this.g,this.i=p.StorageState.Closed,await this.f.close()}}r.a=2e3;class g extends r{get path(){if(!this.v.useInMemoryStorage)return(0,R.join)(this.u.globalStorageHome.fsPath,g.t)}constructor(a,i,n,o){super(n,o),this.u=a,this.v=i}async n(){return new p.Storage(new m.SQLiteStorageDatabase(this.path??m.SQLiteStorageDatabase.IN_MEMORY_PATH,{logging:this.l()}),this.path?void 0:{hint:p.StorageHint.STORAGE_IN_MEMORY})}}g.t="state.vscdb";class c extends g{constructor(a,i,n,o){super(a,i,n,o)}}e.ProfileStorageMain=c;class b extends g{constructor(a,i,n,o){super(i.defaultProfile,a,n,o)}async m(a){await super.m(a),this.z(a)}z(a){a.get(y.firstSessionDateStorageKey,void 0)===void 0&&a.set(y.firstSessionDateStorageKey,new Date().toUTCString());const n=a.get(y.currentSessionDateStorageKey,void 0),o=new Date().toUTCString();a.set(y.lastSessionDateStorageKey,typeof n>"u"?null:n),a.set(y.currentSessionDateStorageKey,o)}}e.ApplicationStorageMain=b;class S extends r{get path(){if(!this.w.useInMemoryStorage)return(0,R.join)(this.y.workspaceStorageHome.fsPath,this.v.id,S.t)}constructor(a,i,n,o,u){super(n,u),this.v=a,this.w=i,this.y=o}async n(){const{storageFilePath:a,wasCreated:i}=await this.C();return new p.Storage(new m.SQLiteStorageDatabase(a,{logging:this.l()}),{hint:this.w.useInMemoryStorage?p.StorageHint.STORAGE_IN_MEMORY:i?p.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async C(){if(this.w.useInMemoryStorage)return{storageFilePath:m.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const a=(0,R.join)(this.y.workspaceStorageHome.fsPath,this.v.id),i=(0,R.join)(a,S.t);return await l.Promises.exists(a)?{storageFilePath:i,wasCreated:!1}:(await l.Promises.mkdir(a,{recursive:!0}),this.D(a),{storageFilePath:i,wasCreated:!0})}async D(a){let i;if((0,w.isSingleFolderWorkspaceIdentifier)(this.v)?i={folder:this.v.uri.toString()}:(0,w.isWorkspaceIdentifier)(this.v)&&(i={workspace:this.v.configPath.toString()}),i)try{const n=(0,R.join)(a,S.u);await l.Promises.exists(n)||await l.Promises.writeFile(n,JSON.stringify(i,void 0,2))}catch(n){this.j.error(`[storage main] ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${n}`)}}}e.WorkspaceStorageMain=S,S.t="state.vscdb",S.u="workspace.json";class D extends r{get path(){}async n(){return new p.Storage(new p.InMemoryStorageDatabase,{hint:p.StorageHint.STORAGE_IN_MEMORY})}}e.InMemoryStorageMain=D}),define(te[267],ie([0,1,4,2,94]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileStorageChangesListenerChannel=void 0;class L extends M.Disposable{constructor(k,h,l){super(),this.b=k,this.c=h,this.f=l;const p=this.B(new M.MutableDisposable);this.a=this.B(new E.Emitter({onWillAddFirstListener:()=>p.value=this.g(),onDidRemoveLastListener:()=>p.value=void 0}))}g(){this.f.debug("ProfileStorageChangesListenerChannel#registerStorageChangeListeners");const k=new M.DisposableStore;return k.add(E.Event.debounce(this.b.applicationStorage.onDidChangeStorage,(h,l)=>(h?h.push(l.key):h=[l.key],h),100)(h=>this.h(h))),k.add(E.Event.debounce(this.b.onDidChangeProfileStorage,(h,l)=>{h||(h=new Map);let p=h.get(l.profile.id);return p||h.set(l.profile.id,p={profile:l.profile,keys:[],storage:l.storage}),p.keys.push(l.key),h},100)(h=>this.i(h))),k}h(k){const h=k.includes(s.TARGET_KEY)?[this.c.defaultProfile]:[],l=[];if(k=k.filter(p=>p!==s.TARGET_KEY),k.length){const p=(0,s.loadKeyTargets)(this.b.applicationStorage.storage);l.push({profile:this.c.defaultProfile,changes:k.map(m=>({key:m,scope:0,target:p[m]}))})}this.j(h,l)}i(k){const h=[],l=new Map;for(const[p,m]of k.entries()){m.keys.includes(s.TARGET_KEY)&&h.push(m.profile);const v=m.keys.filter(f=>f!==s.TARGET_KEY);if(v.length){const f=(0,s.loadKeyTargets)(m.storage.storage);l.set(p,{profile:m.profile,changes:v.map(y=>({key:y,scope:0,target:f[y]}))})}}this.j(h,[...l.values()])}j(k,h){(k.length||h.length)&&this.a.fire({valueChanges:h,targetChanges:k})}listen(k,h,l){switch(h){case"onDidChange":return this.a.event}throw new Error(`Event not found: ${h}`)}async call(k,h){throw new Error(`Call not found: ${h}`)}}e.ProfileStorageChangesListenerChannel=L}),define(te[268],ie([0,1,8,34,16,5,33,38,39,11,116]),function(x,e,E,M,s,L,R,k,h,l,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let m=e.UserDataProfilesReadonlyService=class ft extends h.UserDataProfilesService{constructor(w,r,g,c,b){super(g,c,r,b),this.P=w,this.Q=g}J(){return this.P.getItem(ft.b,[]).map(r=>({...r,location:(0,l.isString)(r.location)?this.s.extUri.joinPath(this.profilesHome,r.location):E.URI.revive(r.location)}))}M(){const w=this.P.getItem(ft.c,{});return this.P.getItem(ft.a,!1)?w:this.I(w)}O(){return this.s.extUri.joinPath(E.URI.file(this.Q.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};m.a="profileAssociationsMigration",e.UserDataProfilesReadonlyService=m=be([Q(0,R.IStateReadService),Q(1,k.IUriIdentityService),Q(2,M.INativeEnvironmentService),Q(3,s.IFileService),Q(4,L.ILogService)],m);let v=e.UserDataProfilesService=class st extends m{constructor(w,r,g,c,b){super(w,r,g,c,b),this.W=w}L(w){w.length?this.W.setItem(st.b,w.map(r=>({...r,location:this.s.extUri.basename(r.location)}))):this.W.removeItem(st.b)}J(){const w=super.J();return this.W.getItem("userDataProfilesMigration",!1)||(this.L(w),this.W.setItem("userDataProfilesMigration",!0)),w}N(w){w.emptyWindows||w.workspaces?this.W.setItem(st.c,w):this.W.removeItem(st.c)}M(){const w="workspaceAndProfileInfo",r=this.W.getItem(w,void 0);if(r){this.W.removeItem(w);const c=r.reduce((b,{workspace:S,profile:D})=>(b[E.URI.revive(S).toString()]=E.URI.revive(D).toString(),b),{});this.W.setItem(st.c,{workspaces:c})}const g=super.M();return this.W.getItem(st.a,!1)||(this.N(g),this.W.setItem(st.a,!0)),g}};e.UserDataProfilesService=v=be([Q(0,R.IStateService),Q(1,k.IUriIdentityService),Q(2,M.INativeEnvironmentService),Q(3,s.IFileService),Q(4,L.ILogService)],v);let f=e.ServerUserDataProfilesService=class extends v{constructor(w,r,g,c){super(new p.StateService(0,r,c,g),w,r,g,c)}async init(){return await this.W.init(),super.init()}};e.ServerUserDataProfilesService=f=be([Q(0,k.IUriIdentityService),Q(1,M.INativeEnvironmentService),Q(2,s.IFileService),Q(3,L.ILogService)],f)}),define(te[53],ie([0,1,34,16,6,5,38,39,268,33]),function(x,e,E,M,s,L,R,k,h,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesMainService=e.IUserDataProfilesMainService=void 0,e.IUserDataProfilesMainService=(0,s.refineServiceDecorator)(k.IUserDataProfilesService);let p=e.UserDataProfilesMainService=class extends h.UserDataProfilesService{constructor(v,f,y,w,r){super(v,f,y,w,r)}getAssociatedEmptyWindows(){const v=[];for(const f of this.v.emptyWindows.keys())v.push({id:f});return v}};e.UserDataProfilesMainService=p=be([Q(0,l.IStateService),Q(1,R.IUriIdentityService),Q(2,E.INativeEnvironmentService),Q(3,M.IFileService),Q(4,L.ILogService)],p)}),define(te[124],ie([0,1,18,8,29]),function(x,e,E,M,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;async function L(h,l,p){for(const v of h){const f=v.openedWorkspace;if((0,s.isWorkspaceIdentifier)(f)){const y=await p(f);if(y){if(y.folders.some(w=>E.extUriBiasedIgnorePathCase.isEqualOrParent(l,w.uri)))return v}else if(E.extUriBiasedIgnorePathCase.isEqualOrParent(l,f.configPath))return v}}const m=h.filter(v=>(0,s.isSingleFolderWorkspaceIdentifier)(v.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqualOrParent(l,v.openedWorkspace.uri));if(m.length)return m.sort((v,f)=>-(v.openedWorkspace.uri.path.length-f.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=L;function R(h,l){for(const p of h)if((0,s.isWorkspaceIdentifier)(p.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.configPath,l)||(0,s.isSingleFolderWorkspaceIdentifier)(p.openedWorkspace)&&E.extUriBiasedIgnorePathCase.isEqual(p.openedWorkspace.uri,l))return p}e.findWindowOnWorkspaceOrFolder=R;function k(h,l){const p=m=>l.some(v=>E.extUriBiasedIgnorePathCase.isEqual(M.URI.file(v),M.URI.file(m)));for(const m of h)if(m.config?.extensionDevelopmentPath?.some(v=>p(v)))return m}e.findWindowOnExtensionDevelopmentPath=k}),define(te[95],ie([0,1,32,43,129,44,15,9,3,18,8,6,57,29]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isStoredWorkspaceFolder=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=void 0,e.IWorkspacesService=(0,m.createDecorator)("workspacesService");function y(A){return A.hasOwnProperty("workspace")}e.isRecentWorkspace=y;function w(A){return A.hasOwnProperty("folderUri")}e.isRecentFolder=w;function r(A){return A.hasOwnProperty("fileUri")}e.isRecentFile=r;function g(A){return c(A)||b(A)}e.isStoredWorkspaceFolder=g;function c(A){const C=A;return typeof C?.path=="string"&&(!C.name||typeof C.name=="string")}function b(A){const C=A;return typeof C?.uri=="string"&&(!C.name||typeof C.name=="string")}function S(A,C,T,W,$){if(A.scheme!==W.scheme)return{name:T,uri:A.toString(!0)};let H=C?void 0:$.relativePath(W,A);if(H!==void 0)H.length===0?H=".":h.isWindows&&(H=D(H));else if(A.scheme===R.Schemas.file)H=A.fsPath,h.isWindows&&(H=D(H));else if($.isEqualAuthority(A.authority,W.authority))H=A.path;else return{name:T,uri:A.toString(!0)};return{name:T,path:H}}e.getStoredWorkspaceFolder=S;function D(A){return A=(0,L.normalizeDriveLetter)(A),(0,E.isUNC)(A)||(A=(0,E.toSlashes)(A)),A}function t(A,C,T){const W=[],$=new Set,H=T.dirname(C);for(const Z of A){let ne;if(c(Z))Z.path&&(ne=T.resolvePath(H,Z.path));else if(b(Z))try{ne=p.URI.parse(Z.uri),ne.path[0]!==k.posix.sep&&(ne=ne.with({path:k.posix.sep+ne.path}))}catch(se){console.warn(se)}if(ne){const se=T.getComparisonKey(ne);if(!$.has(se)){$.add(se);const ue=Z.name||T.basenameOrAuthority(ne);W.push(new f.WorkspaceFolder({uri:ne,name:ue,index:W.length},Z))}}}return W}e.toWorkspaceFolders=t;function a(A,C,T,W,$){const H=i(C,A),Z=$.dirname(C),ne=$.dirname(W),se=[];for(const q of H.folders){const B=c(q)?$.resolvePath(Z,q.path):p.URI.parse(q.uri);let z;T?z=!1:z=!c(q)||(0,k.isAbsolute)(q.path),se.push(S(B,z,q.name,ne,$))}const ue={insertSpaces:!1,tabSize:4,eol:h.isLinux||h.isMacintosh?`
`:`\r
`},ce=s.setProperty(A,["folders"],se,ue);let X=s.applyEdits(A,ce);return(0,l.isEqualAuthority)(H.remoteAuthority,(0,v.getRemoteAuthority)(W))&&(X=s.applyEdits(X,s.removeProperty(X,["remoteAuthority"],ue))),X}e.rewriteWorkspaceFileForNewLocation=a;function i(A,C){const T=M.parse(C);if(T&&Array.isArray(T.folders))T.folders=T.folders.filter(W=>g(W));else throw new Error(`${A} looks like an invalid workspace file.`);return T}function n(A){return A.workspace&&typeof A.workspace=="object"&&typeof A.workspace.id=="string"&&typeof A.workspace.configPath=="string"}function o(A){return typeof A.folderUri=="string"}function u(A){return typeof A.fileUri=="string"}function d(A,C){const T={workspaces:[],files:[]};if(A){const W=function(H,Z){for(let ne=0;ne<H.length;ne++)try{Z(H[ne],ne)}catch(se){C.warn(`Error restoring recent entry ${JSON.stringify(H[ne])}: ${se.toString()}. Skip entry.`)}},$=A;Array.isArray($.entries)&&W($.entries,H=>{const Z=H.label,ne=H.remoteAuthority;n(H)?T.workspaces.push({label:Z,remoteAuthority:ne,workspace:{id:H.workspace.id,configPath:p.URI.parse(H.workspace.configPath)}}):o(H)?T.workspaces.push({label:Z,remoteAuthority:ne,folderUri:p.URI.parse(H.folderUri)}):u(H)&&T.files.push({label:Z,remoteAuthority:ne,fileUri:p.URI.parse(H.fileUri)})})}return T}e.restoreRecentlyOpened=d;function I(A){const C={entries:[]};for(const T of A.workspaces)w(T)?C.entries.push({folderUri:T.folderUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority}):C.entries.push({workspace:{id:T.workspace.id,configPath:T.workspace.configPath.toString()},label:T.label,remoteAuthority:T.remoteAuthority});for(const T of A.files)C.entries.push({fileUri:T.fileUri.toString(),label:T.label,remoteAuthority:T.remoteAuthority});return C}e.toStoreData=I}),define(te[96],ie([0,1,69,15,3,18]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function R(l){function p(){let m=l.scheme===M.Schemas.file?(0,L.originalFSPath)(l):l.toString();return s.isLinux||(m=m.toLowerCase()),(0,E.createHash)("md5").update(m).digest("hex")}return{id:p(),configPath:l}}e.getWorkspaceIdentifier=R;function k(l,p){function m(){if(l.scheme!==M.Schemas.file)return(0,E.createHash)("md5").update(l.toString()).digest("hex");if(!p)return;let f;return s.isLinux?f=p.ino:s.isMacintosh?f=p.birthtime.getTime():s.isWindows&&(typeof p.birthtimeMs=="number"?f=Math.floor(p.birthtimeMs):f=p.birthtime.getTime()),(0,E.createHash)("md5").update(l.fsPath).update(f?String(f):"").digest("hex")}const v=m();if(typeof v=="string")return{id:v,uri:l}}e.getSingleFolderWorkspaceIdentifier=k;function h(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=h}),define(te[97],ie([0,1,69,70,26,269,17,13,4,2,9,3,31,45,105]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class w{traceSocketEvent(C,T){y.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,C,T)}constructor(C,T=""){this.f=!0,this.debugLabel=T,this.socket=C,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=W=>{if(this.traceSocketEvent("error",{code:W?.code,message:W?.message}),W){if(W.code==="EPIPE")return;(0,k.onUnexpectedError)(W)}},this.socket.on("error",this.a),this.b=W=>{this.traceSocketEvent("close",{hadError:W}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(C){const T=W=>{this.traceSocketEvent("read",W),C(R.VSBuffer.wrap(W))};return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(C){const T=W=>{C({type:0,hadError:W,error:void 0})};return this.socket.on("close",T),{dispose:()=>this.socket.off("close",T)}}onEnd(C){const T=()=>{C()};return this.socket.on("end",T),{dispose:()=>this.socket.off("end",T)}}write(C){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",C),this.socket.write(C.buffer,T=>{if(T){if(T.code==="EPIPE")return;(0,k.onUnexpectedError)(T)}})}catch(T){if(T.code==="EPIPE")return;(0,k.onUnexpectedError)(T)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((C,T)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),C();return}const W=()=>{this.socket.off("close",W),this.socket.off("end",W),this.socket.off("error",W),this.socket.off("timeout",W),this.socket.off("drain",W),this.traceSocketEvent("nodeDrainEnd"),C()};this.socket.on("close",W),this.socket.on("end",W),this.socket.on("error",W),this.socket.on("timeout",W),this.socket.on("drain",W)})}}e.NodeSocket=w;var r;(function(A){A[A.MinHeaderByteSize=2]="MinHeaderByteSize",A[A.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(r||(r={}));var g;(function(A){A[A.PeekHeader=1]="PeekHeader",A[A.ReadHeader=2]="ReadHeader",A[A.ReadBody=3]="ReadBody",A[A.Fin=4]="Fin"})(g||(g={}));class c extends l.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(C,T){this.socket.traceSocketEvent(C,T)}constructor(C,T,W,$){super(),this.f=this.B(new h.Emitter),this.g=this.B(new h.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=C,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:T,inflateBytesLength:W?.byteLength||0,recordInflateBytes:$}),this.a=this.B(new b(this,T,W,$,this.f,(H,Z)=>this.k(H,Z))),this.B(this.a.onError(H=>{console.error(H),(0,k.onUnexpectedError)(H),this.g.fire({type:0,hadError:!0,error:H})})),this.b=new y.ChunkStream,this.B(this.socket.onData(H=>this.l(H))),this.B(this.socket.onClose(async H=>{this.a.isProcessingReadQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(H)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(C){return this.f.event(C)}onClose(C){return this.g.event(C)}onEnd(C){return this.socket.onEnd(C)}write(C){let T=0;for(;T<C.byteLength;)this.a.writeMessage(C.slice(T,Math.min(T+262144,C.byteLength))),T+=262144}k(C,T){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",C);let W=2;C.byteLength<126?W+=0:C.byteLength<2**16?W+=2:W+=8;const $=R.VSBuffer.alloc(W);if(T?$.writeUInt8(194,0):$.writeUInt8(130,0),C.byteLength<126)$.writeUInt8(C.byteLength,1);else if(C.byteLength<2**16){$.writeUInt8(126,1);let H=1;$.writeUInt8(C.byteLength>>>8&255,++H),$.writeUInt8(C.byteLength>>>0&255,++H)}else{$.writeUInt8(127,1);let H=1;$.writeUInt8(0,++H),$.writeUInt8(0,++H),$.writeUInt8(0,++H),$.writeUInt8(0,++H),$.writeUInt8(C.byteLength>>>24&255,++H),$.writeUInt8(C.byteLength>>>16&255,++H),$.writeUInt8(C.byteLength>>>8&255,++H),$.writeUInt8(C.byteLength>>>0&255,++H)}this.socket.write(R.VSBuffer.concat([$,C]))}end(){this.h=!0,this.socket.end()}l(C){if(C.byteLength!==0){for(this.b.acceptChunk(C);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const T=this.b.peek(this.j.readLen),W=T.readUInt8(0),$=(W&128)>>>7,H=(W&64)>>>6,Z=T.readUInt8(1),ne=(Z&128)>>>7,se=Z&127;this.j.state=2,this.j.readLen=2+(ne?4:0)+(se===126?2:0)+(se===127?8:0),this.j.fin=$,this.j.firstFrameOfMessage&&(this.j.compressed=!!H),this.j.firstFrameOfMessage=!!$,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const T=this.b.read(this.j.readLen),W=T.readUInt8(1),$=(W&128)>>>7;let H=W&127,Z=1;H===126?H=T.readUInt8(++Z)*2**8+T.readUInt8(++Z):H===127&&(H=T.readUInt8(++Z)*0+T.readUInt8(++Z)*0+T.readUInt8(++Z)*0+T.readUInt8(++Z)*0+T.readUInt8(++Z)*2**24+T.readUInt8(++Z)*2**16+T.readUInt8(++Z)*2**8+T.readUInt8(++Z));let ne=0;$&&(ne=T.readUInt8(++Z)*2**24+T.readUInt8(++Z)*2**16+T.readUInt8(++Z)*2**8+T.readUInt8(++Z)),this.j.state=3,this.j.readLen=H,this.j.mask=ne,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const T=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",T),t(T,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",T),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(T,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await h.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=c;class b extends l.Disposable{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:R.VSBuffer.alloc(0)}constructor(C,T,W,$,H,Z){super(),this.l=C,this.m=H,this.n=Z,this.a=this.B(new h.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new h.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new h.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,T?(this.b=this.B(new S(this.l,$,W,{windowBits:15})),this.f=this.B(new D(this.l,{windowBits:15})),this.B(this.b.onError(ne=>this.a.fire(ne))),this.B(this.f.onError(ne=>this.a.fire(ne)))):(this.b=null,this.f=null)}writeMessage(C){this.g.push(C),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const C=this.g.shift();if(this.f){const T=await this.s(this.f,C);this.n(T,!0)}else this.n(C,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(C,T){return new Promise((W,$)=>{C.write(T),C.flush(H=>W(H))})}acceptFrame(C,T,W){this.h.push({data:C,isCompressed:T,isLastFrameOfMessage:W}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const C=this.h.shift();if(this.b&&C.isCompressed){const T=await this.w(this.b,C.data,C.isLastFrameOfMessage);this.m.fire(T)}else this.m.fire(C.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(C,T,W){return new Promise(($,H)=>{C.write(T),W&&C.write(R.VSBuffer.fromByteArray([0,0,255,255])),C.flush(Z=>$(Z))})}}class S extends l.Disposable{get recordedInflateBytes(){return this.j?R.VSBuffer.concat(this.f):R.VSBuffer.alloc(0)}constructor(C,T,W,$){super(),this.h=C,this.j=T,this.a=this.B(new h.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)($),this.b.on("error",H=>{this.h.traceSocketEvent("zlibInflateError",{message:H?.message,code:H?.code}),this.a.fire(H)}),this.b.on("data",H=>{this.h.traceSocketEvent("zlibInflateData",H),this.g.push(R.VSBuffer.wrap(H))}),W&&(this.h.traceSocketEvent("zlibInflateInitialWrite",W.buffer),this.b.write(W.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(C){this.j&&this.f.push(C.clone()),this.h.traceSocketEvent("zlibInflateWrite",C),this.b.write(C.buffer)}flush(C){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const T=R.VSBuffer.concat(this.g);this.g.length=0,C(T)})}}class D extends l.Disposable{constructor(C,T){super(),this.g=C,this.a=this.B(new h.Emitter),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",W=>{this.g.traceSocketEvent("zlibDeflateError",{message:W?.message,code:W?.code}),this.a.fire(W)}),this.b.on("data",W=>{this.g.traceSocketEvent("zlibDeflateData",W),this.f.push(R.VSBuffer.wrap(W))})}write(C){this.g.traceSocketEvent("zlibDeflateWrite",C.buffer),this.b.write(C.buffer)}flush(C){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let T=R.VSBuffer.concat(this.f);this.f.length=0,T=T.slice(0,T.byteLength-4),C(T)})}}function t(A,C){if(C===0)return;const T=A.byteLength>>>2;for(let se=0;se<T;se++){const ue=A.readUInt32BE(se*4);A.writeUInt32BE(ue^C,se*4)}const W=T*4,$=A.byteLength-W,H=C>>>24&255,Z=C>>>16&255,ne=C>>>8&255;$>=1&&A.writeUInt8(A.readUInt8(W)^H,W),$>=2&&A.writeUInt8(A.readUInt8(W+1)^Z,W+1),$>=3&&A.writeUInt8(A.readUInt8(W+2)^ne,W+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const a={[2]:107,[1]:103};function i(){const A=(0,v.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${A}-sock`;const C=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,s.tmpdir)(),T=(0,p.join)(C,`vscode-ipc-${A}.sock`);return o(T),T}e.createRandomIPCHandle=i;function n(A,C,T){const W=(0,E.createHash)("md5").update(A).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${W}-${T}-${C}-sock`;const $=T.substr(0,4),H=C.substr(0,6),Z=W.substr(0,8);let ne;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?ne=(0,p.join)(e.XDG_RUNTIME_DIR,`vscode-${Z}-${$}-${H}.sock`):ne=(0,p.join)(A,`${$}-${H}.sock`),o(ne),ne}e.createStaticIPCHandle=n;function o(A){const C=a[m.platform];typeof C=="number"&&A.length>=C&&console.warn(`WARNING: IPC handle "${A}" is longer than ${C} chars, try a shorter --user-data-dir`)}class u extends f.IPCServer{static b(C){const T=h.Event.fromNodeEventEmitter(C,"connection");return h.Event.map(T,W=>({protocol:new y.Protocol(new w(W,"ipc-server-connection")),onDidClientDisconnect:h.Event.once(h.Event.fromNodeEventEmitter(W,"close"))}))}constructor(C){super(u.b(C)),this.d=C}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=u;function d(A){return new Promise((C,T)=>{const W=(0,M.createServer)();W.on("error",T),W.listen(A,()=>{W.removeListener("error",T),C(new u(W))})})}e.serve=d;function I(A,C){return new Promise((T,W)=>{const $=(0,M.createConnection)(A,()=>{$.removeListener("error",W),T(y.Client.fromSocket(new w($,`ipc-client${C}`),C))});$.once("error",W)})}e.connect=I}),define(te[30],ie([0,1,55,9,97,34,108,6]),function(x,e,E,M,s,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,k.refineServiceDecorator)(L.IEnvironmentService);class h extends R.NativeEnvironmentService{get cachedLanguagesPath(){return(0,M.join)(this.userDataPath,"clp")}get backupHome(){return(0,M.join)(this.userDataPath,"Backups")}get mainIPCHandle(){return(0,s.createStaticIPCHandle)(this.userDataPath,"main",this.c.version)}get mainLockfile(){return(0,M.join)(this.userDataPath,"code.lock")}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get crossOriginIsolated(){return!!this.args["enable-coi"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}e.EnvironmentMainService=h,be([E.memoize],h.prototype,"cachedLanguagesPath",null),be([E.memoize],h.prototype,"backupHome",null),be([E.memoize],h.prototype,"mainIPCHandle",null),be([E.memoize],h.prototype,"mainLockfile",null),be([E.memoize],h.prototype,"disableUpdates",null),be([E.memoize],h.prototype,"disableKeytar",null),be([E.memoize],h.prototype,"crossOriginIsolated",null),be([E.memoize],h.prototype,"codeCachePath",null),be([E.memoize],h.prototype,"useCodeCache",null)}),define(te[270],ie([0,1,69,32,15,9,3,18,24,190,19,30,33,16,5,189,29,96]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let c=e.BackupMainService=class vt{constructor(S,D,t,a){this.j=S,this.k=D,this.l=t,this.m=a,this.c=this.j.backupHome,this.d=[],this.e=[],this.g=[],this.h=k.extUriBiasedIgnorePathCase,this.i={isEqual:(i,n)=>(0,M.isEqual)(i,n,!R.isLinux)}}async initialize(){const S=this.m.getItem(vt.a)??{workspaces:[],folders:[],emptyWindows:[]};this.g=await this.w(S.emptyWindows),this.d=await this.u((0,l.deserializeWorkspaceInfos)(S)),this.e=await this.v((0,l.deserializeFolderInfos)(S)),this.C()}n(){return this.q()?[]:this.d.slice(0)}o(){return this.q()?[]:this.e.slice(0)}isHotExitEnabled(){return this.s()!==f.HotExitConfiguration.OFF}q(){return this.s()===f.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}s(){return this.k.getValue()?.files?.hotExit||f.HotExitConfiguration.ON_EXIT}getEmptyWindowBackups(){return this.g.slice(0)}registerWorkspaceBackup(S,D){this.d.some(a=>S.workspace.id===a.workspace.id)||(this.d.push(S),this.C());const t=(0,L.join)(this.c,S.workspace.id);return D?this.t(t,D).then(()=>t):t}async t(S,D){if(await h.Promises.exists(S)&&await this.z(S),await h.Promises.exists(D))try{await h.Promises.rename(D,S)}catch(t){this.l.error(`Backup: Could not move backup folder to new location: ${t.toString()}`)}}registerFolderBackup(S){return this.e.some(D=>this.h.isEqual(S.folderUri,D.folderUri))||(this.e.push(S),this.C()),(0,L.join)(this.c,this.D(S))}registerEmptyWindowBackup(S){return this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,S.backupFolder))||(this.g.push(S),this.C()),(0,L.join)(this.c,S.backupFolder)}async u(S){if(!Array.isArray(S))return[];const D=new Set,t=[];for(const a of S){const i=a.workspace;if(!(0,r.isWorkspaceIdentifier)(i))return[];if(!D.has(i.id)){D.add(i.id);const n=(0,L.join)(this.c,i.id);await this.B(n)?i.configPath.scheme!==s.Schemas.file||await h.Promises.exists(i.configPath.fsPath)?t.push(a):await this.z(n):await this.x(n)}}return t}async v(S){if(!Array.isArray(S))return[];const D=[],t=new Set;for(const a of S){const i=a.folderUri,n=this.h.getComparisonKey(i);if(!t.has(n)){t.add(n);const o=(0,L.join)(this.c,this.D(a));await this.B(o)?i.scheme!==s.Schemas.file||await h.Promises.exists(i.fsPath)?D.push(a):await this.z(o):await this.x(o)}}return D}async w(S){if(!Array.isArray(S))return[];const D=[],t=new Set;for(const a of S){const i=a.backupFolder;if(typeof i!="string")return[];if(!t.has(i)){t.add(i);const n=(0,L.join)(this.c,i);await this.B(n)?D.push(a):await this.x(n)}}return D}async x(S){try{await h.Promises.rm(S,h.RimRafMode.MOVE)}catch(D){this.l.error(`Backup: Could not delete stale backup: ${D.toString()}`)}}y(){let S=(0,g.createEmptyWorkspaceIdentifier)();for(;this.g.some(D=>!!D.backupFolder&&this.i.isEqual(D.backupFolder,S.id));)S=(0,g.createEmptyWorkspaceIdentifier)();return{backupFolder:S.id}}async z(S){const D=this.y(),t=(0,L.join)(this.c,D.backupFolder);try{await h.Promises.rename(S,t)}catch(a){return this.l.error(`Backup: Could not rename backup folder: ${a.toString()}`),!1}return this.g.push(D),!0}async getDirtyWorkspaces(){const S=[];for(const D of this.d)await this.A(D)&&S.push(D);for(const D of this.e)await this.A(D)&&S.push(D);return S}A(S){let D;return(0,l.isEmptyWindowBackupInfo)(S)?D=(0,L.join)(this.c,S.backupFolder):(0,w.isFolderBackupInfo)(S)?D=(0,L.join)(this.c,this.D(S)):D=(0,L.join)(this.c,S.workspace.id),this.B(D)}async B(S){try{const D=await h.Promises.readdir(S);for(const t of D)try{if((await h.Promises.readdir((0,L.join)(S,t))).length>0)return!0}catch{}}catch{}return!1}C(){const S={workspaces:this.d.map(({workspace:D,remoteAuthority:t})=>{const a={id:D.id,configURIPath:D.configPath.toString()};return t&&(a.remoteAuthority=t),a}),folders:this.e.map(({folderUri:D,remoteAuthority:t})=>{const a={folderUri:D.toString()};return t&&(a.remoteAuthority=t),a}),emptyWindows:this.g.map(({backupFolder:D,remoteAuthority:t})=>{const a={backupFolder:D};return t&&(a.remoteAuthority=t),a})};this.m.setItem(vt.a,S)}D(S){const D=S.folderUri;let t;return D.scheme===s.Schemas.file?t=R.isLinux?D.fsPath:D.fsPath.toLowerCase():t=D.toString().toLowerCase(),(0,E.createHash)("md5").update(t).digest("hex")}};c.a="backupWorkspaces",e.BackupMainService=c=be([Q(0,m.IEnvironmentMainService),Q(1,p.IConfigurationService),Q(2,y.ILogService),Q(3,v.IStateService)],c)}),define(te[20],ie([0,1,14,42,7,4,2,3,36,11,6,5,33,30]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ShutdownReason=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,p.createDecorator)("lifecycleMainService");var y;(function(g){g[g.QUIT=1]="QUIT",g[g.KILL=2]="KILL"})(y||(e.ShutdownReason=y={}));var w;(function(g){g[g.Starting=1]="Starting",g[g.Ready=2]="Ready",g[g.AfterWindowOpen=3]="AfterWindowOpen",g[g.Eventually=4]="Eventually"})(w||(e.LifecycleMainPhase=w={}));let r=e.LifecycleMainService=class gt extends R.Disposable{get quitRequested(){return this.i}get wasRestarted(){return this.j}get phase(){return this.k}constructor(c,b,S){super(),this.v=c,this.w=b,this.y=S,this.c=this.B(new L.Emitter),this.onBeforeShutdown=this.c.event,this.f=this.B(new L.Emitter),this.onWillShutdown=this.f.event,this.g=this.B(new L.Emitter),this.onWillLoadWindow=this.g.event,this.h=this.B(new L.Emitter),this.onBeforeCloseWindow=this.h.event,this.i=!1,this.j=!1,this.k=1,this.l=new Set,this.m=0,this.n=0,this.p=void 0,this.r=void 0,this.s=void 0,this.t=new Map,this.u=new Map,this.z(),this.when(2).then(()=>this.C())}z(){this.j=!!this.w.getItem(gt.b),this.j&&this.w.removeItem(gt.b)}C(){const c=()=>{this.i||(this.L("Lifecycle#app.on(before-quit)"),this.i=!0,this.L("Lifecycle#onBeforeShutdown.fire()"),this.c.fire(),k.isMacintosh&&this.n===0&&this.D(1))};E.app.addListener("before-quit",c);const b=()=>{this.L("Lifecycle#app.on(window-all-closed)"),(this.i||!k.isMacintosh)&&E.app.quit()};E.app.addListener("window-all-closed",b),E.app.once("will-quit",S=>{this.L("Lifecycle#app.on(will-quit) - begin"),S.preventDefault(),this.D(1).finally(()=>{this.L("Lifecycle#app.on(will-quit) - after fireOnWillShutdown"),this.H(!1),E.app.removeListener("before-quit",c),E.app.removeListener("window-all-closed",b),this.L("Lifecycle#app.on(will-quit) - calling app.quit()"),E.app.quit()})})}D(c){if(this.s)return this.s;const b=this.v;this.L("Lifecycle#onWillShutdown.fire()");const S=[];return this.f.fire({reason:c,join(D,t){b.trace(`Lifecycle#onWillShutdown - begin '${D}'`),S.push(t.finally(()=>{b.trace(`Lifecycle#onWillShutdown - end '${D}'`)}))}}),this.s=(async()=>{try{await s.Promises.settled(S)}catch(D){this.v.error(D)}try{await this.w.close()}catch(D){this.v.error(D)}})(),this.s}set phase(c){if(c<this.phase)throw new Error("Lifecycle cannot go backwards");if(this.k===c)return;this.L(`lifecycle (main): phase changed (value: ${c})`),this.k=c;const b=this.u.get(this.k);b&&(b.open(),this.u.delete(this.k))}async when(c){if(c<=this.k)return;let b=this.u.get(c);b||(b=new s.Barrier,this.u.set(c,b)),await b.wait()}registerWindow(c){const b=new R.DisposableStore;this.n++,b.add(c.onWillLoad(D=>this.g.fire({window:c,workspace:D.workspace,reason:D.reason})));const S=(0,l.assertIsDefined)(c.win);S.on("close",D=>{const t=c.id;if(this.l.has(t)){this.l.delete(t);return}this.L(`Lifecycle#window.on('close') - window ID ${c.id}`),D.preventDefault(),this.unload(c,1).then(a=>{if(a){this.l.delete(t);return}this.l.add(t),this.L(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${t}`),this.h.fire(c),c.close()})}),S.on("closed",()=>{this.L(`Lifecycle#window.on('closed') - window ID ${c.id}`),this.n--,b.dispose(),this.n===0&&(!k.isMacintosh||this.i)&&this.D(1)})}async reload(c,b){await this.unload(c,3)||c.reload(b)}unload(c,b){const S=this.t.get(c.id);if(S)return S;const D=this.F(c,b).finally(()=>{this.t.delete(c.id)});return this.t.set(c.id,D),D}async F(c,b){if(!c.isReady)return!1;this.L(`Lifecycle#unload() - window ID ${c.id}`);const S=this.i?2:b,D=await this.I(c,S);return D?(this.L(`Lifecycle#unload() - veto in renderer (window ID ${c.id})`),this.G(D)):(await this.J(c,S),!1)}G(c){return c?(this.H(!0),this.i=!1,!0):!1}H(c){this.r&&(this.r(c),this.r=void 0,this.p=void 0)}I(c,b){return new Promise(S=>{const D=this.m++,t=`vscode:ok${D}`,a=`vscode:cancel${D}`;M.validatedIpcMain.once(t,()=>{S(!1)}),M.validatedIpcMain.once(a,()=>{S(!0)}),c.send("vscode:onBeforeUnload",{okChannel:t,cancelChannel:a,reason:b})})}J(c,b){return new Promise(S=>{const t=`vscode:reply${this.m++}`;M.validatedIpcMain.once(t,()=>S()),c.send("vscode:onWillUnload",{replyChannel:t,reason:b})})}quit(c){return this.L(`Lifecycle#quit() - begin (willRestart: ${c})`),this.p?(this.L("Lifecycle#quit() - returning pending quit promise"),this.p):(c&&this.w.setItem(gt.b,!0),this.p=new Promise(b=>{this.r=b,this.L("Lifecycle#quit() - calling app.quit()"),E.app.quit()}),this.p)}L(c){this.y.args["enable-smoke-test-driver"]?this.v.info(c):this.v.trace(c)}async relaunch(c){this.L("Lifecycle#relaunch()");const b=process.argv.slice(1);if(c?.addArgs&&b.push(...c.addArgs),c?.removeArgs)for(const t of c.removeArgs){const a=b.indexOf(t);a>=0&&b.splice(a,1)}const S=()=>{try{if(k.isWindows){const t=(0,h.cwd)();t!==process.cwd()&&process.chdir(t)}}catch(t){this.v.error(t)}this.L("Lifecycle#relaunch() - calling app.relaunch()"),E.app.relaunch({args:b})};E.app.once("quit",S),await this.quit(!0)&&E.app.removeListener("quit",S)}async kill(c){this.L("Lifecycle#kill()"),await this.D(2),await Promise.race([(0,s.timeout)(1e3),(async()=>{for(const b of E.BrowserWindow.getAllWindows())if(b&&!b.isDestroyed()){let S;b.webContents&&!b.webContents.isDestroyed()?S=new Promise(D=>b.once("closed",D)):S=Promise.resolve(),b.destroy(),await S}})()]),E.app.exit(c)}};r.b="lifecycle.quitAndRestart",e.LifecycleMainService=r=be([Q(0,m.ILogService),Q(1,v.IStateService),Q(2,f.IEnvironmentMainService)],r)}),define(te[271],ie([0,1,3,4,2,6,20]),function(x,e,E,M,s,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,L.createDecorator)("keyboardLayoutMainService");let k=e.KeyboardLayoutMainService=class extends s.Disposable{constructor(p){super(),this.a=this.B(new M.Emitter),this.onDidChangeKeyboardLayout=this.a.event,this.b=null,this.c=null,p.when(3).then(()=>this.f())}f(){return this.b||(this.b=this.g()),this.b}async g(){const p=await new Promise((m,v)=>{x(["native-keymap"],m,v)});this.c=h(p),E.isCI||p.onDidChangeKeyboardLayout(()=>{this.c=h(p),this.a.fire(this.c)})}async getKeyboardLayoutData(){return await this.f(),this.c}};e.KeyboardLayoutMainService=k=be([Q(0,R.ILifecycleMainService)],k);function h(l){const p=l.getKeyMap(),m=l.getCurrentKeyboardLayout();return{keyboardMapping:p,keyboardLayoutInfo:m}}}),define(te[272],ie([0,1,70,97]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(s,L,R,k,h,l){const p=v=>l(v,void 0),m=E.createConnection({host:s,port:L},()=>{m.removeListener("error",p);const v=Buffer.alloc(16);for(let r=0;r<16;r++)v[r]=Math.round(Math.random()*256);const f=v.toString("base64"),y=[`GET ws://${/:/.test(s)?`[${s}]`:s}:${L}${R}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${f}`];m.write(y.join(`\r
`)+`\r
\r
`);const w=r=>{r.toString().indexOf(`\r
\r
`)>=0&&(m.off("data",w),l(void 0,new M.NodeSocket(m,h)))};m.on("data",w)});m.setNoDelay(!0),m.once("error",p)}}}),define(te[273],ie([0,1,240,7,17,13,11,19,34,115,5,52,239,269]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeRequest=e.RequestService=void 0;let y=e.RequestService=class extends m.AbstractRequestService{constructor(c,b,S,D){super(!!b.isRemoteServer,D),this.j=c,this.k=b,this.l=S,this.m(),this.B(c.onDidChangeConfiguration(t=>{t.affectsConfiguration("http")&&this.m()}))}m(){const c=this.j.getValue("http");this.f=c?.proxy,this.g=!!c?.proxyStrictSSL,this.h=c?.proxyAuthorization}async request(c,b){const{f:S,g:D}=this;let t;try{t=await(0,l.getResolvedShellEnv)(this.j,this.l,this.k.args,process.env)}catch(n){this.i||(this.i=!0,this.l.error("resolving shell environment failed",(0,L.getErrorMessage)(n)))}const a={...process.env,...t},i=c.agent?c.agent:await(0,v.getProxyAgent)(c.url||"",a,{proxyUrl:S,strictSSL:D});return c.agent=i,c.strictSSL=D,this.h&&(c.headers={...c.headers||{},"Proxy-Authorization":this.h}),this.c(c.isChromiumNetwork?"electron":"node",c,()=>r(c,b))}async resolveProxy(c){}};e.RequestService=y=be([Q(0,k.IConfigurationService),Q(1,h.INativeEnvironmentService),Q(2,p.ILogService),Q(3,p.ILoggerService)],y);async function w(g){return((0,E.parse)(g.url).protocol==="https:"?await new Promise((S,D)=>{x(["https"],S,D)}):await new Promise((S,D)=>{x(["http"],S,D)})).request}async function r(g,c){return M.Promises.withAsyncBody(async(b,S)=>{const D=(0,E.parse)(g.url),t=g.getRawRequest?g.getRawRequest(g):await w(g),a={hostname:D.hostname,port:D.port?parseInt(D.port):D.protocol==="https:"?443:80,protocol:D.protocol,path:D.path,method:g.type||"GET",headers:g.headers,agent:g.agent,rejectUnauthorized:(0,R.isBoolean)(g.strictSSL)?g.strictSSL:!0};g.user&&g.password&&(a.auth=g.user+":"+g.password);const i=t(a,n=>{const o=(0,R.isNumber)(g.followRedirects)?g.followRedirects:3;if(n.statusCode&&n.statusCode>=300&&n.statusCode<400&&o>0&&n.headers.location)r({...g,url:n.headers.location,followRedirects:o-1},c).then(b,S);else{let u=n;!g.isChromiumNetwork&&n.headers["content-encoding"]==="gzip"&&(u=n.pipe((0,f.createGunzip)())),b({res:n,stream:(0,s.streamToBufferReadableStream)(u)})}});i.on("error",S),g.timeout&&i.setTimeout(g.timeout),g.isChromiumNetwork&&i.removeHeader("Content-Length"),g.data&&typeof g.data=="string"&&i.write(g.data),i.end(),c.onCancellationRequested(()=>{i.abort(),S(new L.CancellationError)})})}e.nodeRequest=r}),define(te[274],ie([0,1,14,273]),function(x,e,E,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function s(R){return E.net.request}class L extends M.RequestService{request(k,h){return super.request({...k||{},getRawRequest:s,isChromiumNetwork:!0},h)}}e.RequestMainService=L}),define(te[98],ie([0,1,8,48,4,2,34,16,6,20,5,94,266,39,53,38]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplicationStorageMainService=e.IApplicationStorageMainService=e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,h.createDecorator)("storageMainService");let r=e.StorageMainService=class extends L.Disposable{constructor(b,S,D,t,a,i){super(),this.c=b,this.f=S,this.g=D,this.h=t,this.i=a,this.j=i,this.a=void 0,this.b=this.B(new s.Emitter),this.onDidChangeProfileStorage=this.b.event,this.applicationStorage=this.m(),this.n=new Map,this.r=new Map,this.l()}k(){return{useInMemoryStorage:!!this.f.extensionTestsLocationURI}}l(){(async()=>(await this.h.when(3),this.applicationStorage.init()))(),this.B(this.h.onWillLoadWindow(b=>{b.window.profile&&this.profileStorage(b.window.profile).init(),b.workspace&&this.workspaceStorage(b.workspace).init()})),this.B(this.h.onWillShutdown(b=>{this.c.trace("storageMainService#onWillShutdown()"),this.a=b.reason,b.join("applicationStorage",this.applicationStorage.close());for(const[,S]of this.n)b.join("profileStorage",S.close());for(const[,S]of this.r)b.join("workspaceStorage",S.close())})),this.B(this.g.onWillCreateProfile(b=>{b.join((async()=>{await this.i.exists(b.profile.globalStorageHome)||await this.i.createFolder(b.profile.globalStorageHome)})())})),this.B(this.g.onWillRemoveProfile(b=>{const S=this.n.get(b.profile.id);S&&b.join(S.close())}))}m(){this.c.trace("StorageMainService: creating application storage");const b=new v.ApplicationStorageMain(this.k(),this.g,this.c,this.i);return(0,M.once)(b.onDidCloseStorage)(()=>{this.c.trace("StorageMainService: closed application storage")}),b}profileStorage(b){if((0,m.isProfileUsingDefaultStorage)(b))return this.applicationStorage;let S=this.n.get(b.id);if(!S){this.c.trace(`StorageMainService: creating profile storage (${b.name})`),S=this.p(b),this.n.set(b.id,S);const D=this.B(S.onDidChangeStorage(t=>this.b.fire({...t,storage:S,profile:b})));(0,M.once)(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed profile storage (${b.name})`),this.n.delete(b.id),D.dispose()})}return S}p(b){return this.a===2?new v.InMemoryStorageMain(this.c,this.i):new v.ProfileStorageMain(b,this.k(),this.c,this.i)}workspaceStorage(b){let S=this.r.get(b.id);return S||(this.c.trace(`StorageMainService: creating workspace storage (${b.id})`),S=this.s(b),this.r.set(b.id,S),(0,M.once)(S.onDidCloseStorage)(()=>{this.c.trace(`StorageMainService: closed workspace storage (${b.id})`),this.r.delete(b.id)})),S}s(b){return this.a===2?new v.InMemoryStorageMain(this.c,this.i):new v.WorkspaceStorageMain(b,this.k(),this.c,this.f,this.i)}isUsed(b){const S=E.URI.file(b);for(const D of[this.applicationStorage,...this.n.values(),...this.r.values()])if(D.path&&this.j.extUri.isEqualOrParent(E.URI.file(D.path),S))return!0;return!1}};e.StorageMainService=r=be([Q(0,p.ILogService),Q(1,R.IEnvironmentService),Q(2,y.IUserDataProfilesMainService),Q(3,l.ILifecycleMainService),Q(4,k.IFileService),Q(5,w.IUriIdentityService)],r),e.IApplicationStorageMainService=(0,h.createDecorator)("applicationStorageMainService");let g=e.ApplicationStorageMainService=class extends m.AbstractStorageService{constructor(b,S){super(),this.p=b,this.s=S,this.whenReady=this.s.applicationStorage.whenInit}J(){return this.s.applicationStorage.whenInit}L(b){if(b===-1)return this.s.applicationStorage.storage}M(b){if(b===-1)return this.p.defaultProfile.globalStorageHome.fsPath}l(){return!1}switch(){throw new Error("Migrating storage is unsupported from main process")}N(){throw new Error("Switching storage profile is unsupported from main process")}O(){throw new Error("Switching storage workspace is unsupported from main process")}hasScope(){throw new Error("Main process is never profile or workspace scoped")}};e.ApplicationStorageMainService=g=be([Q(0,f.IUserDataProfilesService),Q(1,e.IStorageMainService)],g)}),define(te[275],ie([0,1,70,26,101,272,7,2,19,5,21,236,120,92,3]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function w(S,D,t,a,i){let n;for(let o=3;o&&(n?.dispose(),n=await new r(S,D,t,a,i).waitForReady(),!(i&&s.BROWSER_RESTRICTED_PORTS[i]||!s.BROWSER_RESTRICTED_PORTS[n.tunnelLocalPort]));o--);return n}class r extends k.Disposable{constructor(D,t,a,i,n){super(),this.j=t,this.k=n,this.privacy=v.TunnelPrivacyId.Private,this.i=new Map,this.a=D,this.b=E.createServer(),this.c=new R.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=o=>this.l(o),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=i,this.tunnelRemoteHost=a}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(t=>{t()})}async waitForReady(){const D=this.k??this.tunnelRemotePort,t=(0,v.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let a=await(0,s.findFreePortFaster)(D,2,1e3,t),i=null;return this.b.listen(a,this.j),await this.c.wait(),i=this.b.address(),i||(a=0,this.b.listen(a,this.j),await this.c.wait(),i=this.b.address()),this.tunnelLocalPort=i.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${i.port}`,this}async l(D){D.pause();const t=(0,v.isLocalhost)(this.tunnelRemoteHost)||(0,v.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,a=await(0,m.connectRemoteAgentTunnel)(this.a,t,this.tunnelRemotePort),i=a.getSocket().socket,n=a.readEntireBuffer();a.dispose(),n.byteLength>0&&D.write(n.buffer),D.on("end",()=>{D.localAddress&&this.i.delete(D.localAddress),i.end()}),D.on("close",()=>i.end()),D.on("error",()=>{D.localAddress&&this.i.delete(D.localAddress),i.destroy()}),i.on("end",()=>D.end()),i.on("close",()=>D.end()),i.on("error",()=>{D.destroy()}),D.pipe(i),i.pipe(D),D.localAddress&&this.i.set(D.localAddress,()=>{D.end(),i.end()})}}let g=e.BaseTunnelService=class extends v.AbstractTunnelService{constructor(D,t,a,i,n){super(t,n),this.t=D,this.u=a,this.v=i}isPortPrivileged(D){return(0,v.isPortPrivileged)(D,this.k,y.OS,M.release())}r(D,t,a,i,n,o,u,d){const I=this.q(t,a);if(I)return++I.refcount,I.value;if(this.e)return this.s(this.e,t,a,n,o,u,d);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${t}:${a} on local port ${n}.`);const A={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:D,signService:this.u,logService:this.i,ipcLogger:null},C=w(A,i,t,a,n);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(t,a,C),C}}};e.BaseTunnelService=g=be([Q(1,l.ILogService),Q(2,f.ISignService),Q(3,p.IProductService),Q(4,h.IConfigurationService)],g);let c=e.TunnelService=class extends g{constructor(D,t,a,i){super(L.nodeSocketFactory,D,t,a,i)}};e.TunnelService=c=be([Q(0,l.ILogService),Q(1,f.ISignService),Q(2,p.IProductService),Q(3,h.IConfigurationService)],c);let b=e.SharedTunnelsService=class extends k.Disposable{constructor(D,t,a,i){super(),this.b=D,this.c=t,this.f=a,this.g=i,this.a=new Map}async openTunnel(D,t,a,i,n,o,u,d,I){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${a}:${i} on local port ${o}.`),!this.a.has(D)){const A=new c(this.b,this.f,this.c,this.g);this.B(A),this.a.set(D,A),A.onTunnelClosed(async()=>{(await A.tunnels).length===0&&(A.dispose(),this.a.delete(D))})}return this.a.get(D).openTunnel(t,a,i,n,o,u,d,I)}};e.SharedTunnelsService=b=be([Q(0,l.ILogService),Q(1,p.IProductService),Q(2,f.ISignService),Q(3,h.IConfigurationService)],b)}),define(te[99],ie([0,1,7,22,4,19,30,20,5,21,52,47]),function(x,e,E,M,s,L,R,k,h,l,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function v(y,w,r){return`${r.updateUrl}/api/update/${y}/${w}/${r.commit}`}e.createUpdateURL=v;let f=e.AbstractUpdateService=class{get state(){return this.b}d(w){this.j.info("update#setState",w.type),this.b=w,this.c.fire(w)}constructor(w,r,g,c,b,S){this.f=w,this.g=r,this.h=g,this.i=c,this.j=b,this.k=S,this.b=m.State.Uninitialized,this.c=new s.Emitter,this.onStateChange=this.c.event,w.when(3).finally(()=>this.l())}async l(){if(!this.h.isBuilt)return;if(this.h.disableUpdates){this.j.info("update#ctor - updates are disabled by the environment");return}if(!this.k.updateUrl||!this.k.commit){this.j.info("update#ctor - updates are disabled as there is no update URL");return}const w=this.g.getValue("update.mode"),r=this.m(w);if(!r){this.j.info("update#ctor - updates are disabled by user preference");return}if(this.a=this.s(r),!this.a){this.j.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.d(m.State.Idle(this.q())),w==="manual"){this.j.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}w==="start"?(this.j.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.n(30*1e3).then(void 0,g=>this.j.error(g))}m(w){return w==="none"?void 0:this.k.quality}n(w=60*60*1e3){return(0,E.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.n(60*60*1e3))}async checkForUpdates(w){this.j.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.t(w)}async downloadUpdate(){this.j.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.o(this.state)}async o(w){}async applyUpdate(){this.j.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.p()}async p(){}quitAndInstall(){return this.j.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.j.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.j.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.r())})),Promise.resolve(void 0)}async isLatestVersion(){if(!this.a)return;if(this.g.getValue("update.mode")==="none")return!1;try{return(await this.i.request({url:this.a},M.CancellationToken.None)).res.statusCode===204}catch(r){this.j.error("update#isLatestVersion(): failed to check for updates"),this.j.error(r);return}}async _applySpecificUpdate(w){}q(){return 1}r(){}};e.AbstractUpdateService=f=be([Q(0,k.ILifecycleMainService),Q(1,L.IConfigurationService),Q(2,R.IEnvironmentMainService),Q(3,p.IRequestService),Q(4,h.ILogService),Q(5,l.IProductService)],f)}),define(te[276],ie([0,1,14,55,4,2,19,30,20,5,21,52,25,47,99]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let w=e.DarwinUpdateService=class extends y.AbstractUpdateService{get v(){return s.Event.fromNodeEventEmitter(E.autoUpdater,"error",(g,c)=>c)}get w(){return s.Event.fromNodeEventEmitter(E.autoUpdater,"update-not-available")}get x(){return s.Event.fromNodeEventEmitter(E.autoUpdater,"update-available",(g,c,b)=>({url:c,version:b,productVersion:b}))}get y(){return s.Event.fromNodeEventEmitter(E.autoUpdater,"update-downloaded",(g,c,b,S)=>({releaseNotes:c,version:b,productVersion:b,date:S}))}constructor(g,c,b,S,D,t,a){super(g,c,S,D,t,a),this.z=b,this.u=new L.DisposableStore}async l(){await super.l(),this.v(this.B,this,this.u),this.x(this.E,this,this.u),this.y(this.F,this,this.u),this.w(this.G,this,this.u)}B(g){this.j.error("UpdateService error:",g);const b=(this.state.type==="checking for updates"?this.state.explicit:!0)?g:void 0;this.d(f.State.Idle(1,b))}s(g){let c;this.k.darwinUniversalAssetId?c=this.k.darwinUniversalAssetId:c=process.arch==="x64"?"darwin":"darwin-arm64";const b=(0,y.createUpdateURL)(c,g,this.k);try{E.autoUpdater.setFeedURL({url:b})}catch(S){this.j.error("Failed to set update feed URL",S);return}return b}t(g){this.d(f.State.CheckingForUpdates(g)),E.autoUpdater.checkForUpdates()}E(g){this.state.type==="checking for updates"&&this.d(f.State.Downloading(g))}F(g){this.state.type==="downloading"&&(this.z.publicLog2("update:downloaded",{version:g.version}),this.d(f.State.Ready(g)))}G(){this.state.type==="checking for updates"&&(this.z.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.d(f.State.Idle(1)))}r(){this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),E.autoUpdater.quitAndInstall()}dispose(){this.u.dispose()}};be([M.memoize],w.prototype,"v",null),be([M.memoize],w.prototype,"w",null),be([M.memoize],w.prototype,"x",null),be([M.memoize],w.prototype,"y",null),e.DarwinUpdateService=w=be([Q(0,h.ILifecycleMainService),Q(1,R.IConfigurationService),Q(2,v.ITelemetryService),Q(3,k.IEnvironmentMainService),Q(4,m.IRequestService),Q(5,l.ILogService),Q(6,p.IProductService)],w)}),define(te[277],ie([0,1,50,41,7,4,9,30,20,5,25,47]),function(x,e,E,M,s,L,R,k,h,l,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let v=class{get state(){return this.a}d(w){this.g.info("update#setState",w.type),this.a=w,this.b.fire(w)}constructor(w,r,g){if(this.f=w,this.g=g,this.a=m.State.Uninitialized,this.b=new L.Emitter,this.onStateChange=this.b.event,r.disableUpdates){this.g.info("update#ctor - updates are disabled");return}this.d(m.State.Idle(this.k())),this.h(30*1e3).then(void 0,c=>this.g.error(c))}h(w=60*60*1e3){return(0,s.timeout)(w).then(()=>this.checkForUpdates(!1)).then(()=>this.h(60*60*1e3))}async checkForUpdates(w){this.g.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.m(w)}async downloadUpdate(){this.g.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.i(this.state)}i(w){return Promise.resolve(void 0)}async applyUpdate(){this.g.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.j()}j(){return Promise.resolve(void 0)}quitAndInstall(){return this.g.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.g.trace("update#quitAndInstall(): before lifecycle quit()"),this.f.quit(!0).then(w=>{this.g.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${w}`),!w&&(this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.l())})),Promise.resolve(void 0)}k(){return 2}l(){}async _applySpecificUpdate(w){}};v=be([Q(0,h.ILifecycleMainService),Q(1,k.IEnvironmentMainService),Q(2,l.ILogService)],v);let f=e.SnapUpdateService=class extends v{constructor(w,r,g,c,b,S){super(g,c,b),this.o=w,this.p=r,this.q=S;const D=(0,M.watch)(R.dirname(this.o)),t=L.Event.fromNodeEventEmitter(D,"change",(o,u)=>u),a=L.Event.filter(t,o=>o==="current"),n=L.Event.debounce(a,(o,u)=>u,2e3)(()=>this.checkForUpdates(!1));g.onWillShutdown(()=>{n.dispose(),D.close()})}m(){this.d(m.State.CheckingForUpdates(!1)),this.u().then(w=>{w?this.d(m.State.Ready({version:"something",productVersion:"something"})):(this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(m.State.Idle(2)))},w=>{this.g.error(w),this.q.publicLog2("update:notAvailable",{explicit:!1}),this.d(m.State.Idle(2,w.message||w))})}l(){this.g.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,E.spawn)("sleep 3 && "+R.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async u(){const w=await new Promise((g,c)=>(0,M.realpath)(`${R.dirname(this.o)}/current`,(b,S)=>b?c(b):g(S))),r=R.basename(w);return this.p!==r}isLatestVersion(){return this.u().then(void 0,w=>{this.g.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};e.SnapUpdateService=f=be([Q(2,h.ILifecycleMainService),Q(3,k.IEnvironmentMainService),Q(4,l.ILogService),Q(5,p.ITelemetryService)],f)}),define(te[278],ie([0,1,2,20,53,29,7,28]),function(x,e,E,M,s,L,R,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesHandler=void 0;let h=e.UserDataProfilesHandler=class extends E.Disposable{constructor(p,m,v){super(),this.a=m,this.b=v,this.B(p.onWillLoadWindow(f=>{f.reason===2&&this.c(f.window)})),this.B(p.onBeforeCloseWindow(f=>this.c(f))),this.B(new R.RunOnceScheduler(()=>this.g(),30*1e3)).schedule()}async c(p){const m=this.f(p),v=this.a.getProfileForWorkspace(m);v?.isTransient&&(this.a.unsetWorkspace(m,v.isTransient),v.isTransient&&await this.a.cleanUpTransientProfiles())}f(p){return p.openedWorkspace??(0,L.toWorkspaceIdentifier)(p.backupPath,p.isExtensionDevelopmentHost)}g(){const p=this.a.getAssociatedEmptyWindows();if(p.length===0)return;const m=this.b.getWindows().map(v=>this.f(v));for(const v of p)m.some(f=>f.id===v.id)||this.a.unsetWorkspace(v,!1)}};e.UserDataProfilesHandler=h=be([Q(0,M.ILifecycleMainService),Q(1,s.IUserDataProfilesMainService),Q(2,k.IWindowsMainService)],h)}),define(te[67],ie([0,1,14,2,4,5,297,7,15,28,72,25,20,71,40,3,87]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowUtilityProcess=e.UtilityProcess=void 0;function g(S){return typeof S.responseWindowId=="number"}let c=e.UtilityProcess=class ht extends M.Disposable{static getAll(){return Array.from(ht.b.values())}constructor(D,t,a){super(),this.n=D,this.p=t,this.r=a,this.c=String(++ht.a),this.f=this.B(new s.Emitter),this.onStdout=this.f.event,this.g=this.B(new s.Emitter),this.onStderr=this.g.event,this.h=this.B(new s.Emitter),this.onMessage=this.h.event,this.i=this.B(new s.Emitter),this.onExit=this.i.event,this.j=this.B(new s.Emitter),this.onCrash=this.j.event,this.k=void 0,this.l=void 0,this.m=void 0}s(D,t){let a;switch(this.m?.correlationId?a=`[UtilityProcess id: ${this.m?.correlationId}, type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${D}`:a=`[UtilityProcess type: ${this.m?.type}, pid: ${this.l??"<none>"}]: ${D}`,t){case p.default.Error:this.n.error(a);break;case p.default.Warning:this.n.warn(a);break;case p.default.Info:this.n.trace(a);break}}t(){return this.k?(this.s("Cannot start utility process because it is already running...",p.default.Error),!1):!0}start(D){const t=this.u(D,!1);return t&&D.payload&&this.postMessage(D.payload),t}u(D,t){if(!this.t())return!1;this.m=D;const a=`${this.m.type}-${this.c}`,i=h.FileAccess.asFileUri("bootstrap-fork.js").fsPath,n=this.m.args??[],o=this.m.execArgv??[],u=this.m.allowLoadingUnsignedLibraries,d=this.m.forceAllocationsToV8Sandbox,I="pipe",A=this.v(D,t);return this.s("creating new...",p.default.Info),this.k=E.utilityProcess.fork(i,n,{serviceName:a,env:A,execArgv:o,allowLoadingUnsignedLibraries:u,forceAllocationsToV8Sandbox:d,stdio:I}),this.w(this.k,this.m,a,t),!0}v(D,t){const a=D.env?{...D.env}:{...(0,y.deepClone)(process.env)};a.VSCODE_AMD_ENTRYPOINT=D.entryPoint,typeof D.parentLifecycleBound=="number"&&(a.VSCODE_PARENT_PID=String(D.parentLifecycleBound)),t&&(a.VSCODE_CRASH_REPORTER_SANDBOXED_HINT="1"),a.VSCODE_CRASH_REPORTER_PROCESS_TYPE=D.type,w.isWindows&&(a.NODE_UNC_HOST_ALLOWLIST=(0,r.getUNCHostAllowlist)().join("\\")),(0,f.removeDangerousEnvVariables)(a);for(const i of Object.keys(a))a[i]=String(a[i]);return a}w(D,t,a,i){if(D.stdout){const n=new R.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(D.stdout,"data")(o=>this.f.fire(typeof o=="string"?o:n.write(o))))}if(D.stderr){const n=new R.StringDecoder("utf-8");this.B(s.Event.fromNodeEventEmitter(D.stderr,"data")(o=>this.g.fire(typeof o=="string"?o:n.write(o))))}this.B(s.Event.fromNodeEventEmitter(D,"message")(n=>this.h.fire(n))),this.B(s.Event.fromNodeEventEmitter(D,"spawn")(()=>{this.l=D.pid,typeof D.pid=="number"&&ht.b.set(D.pid,{pid:D.pid,name:g(t)?`${t.type} [${t.responseWindowId}]`:t.type}),this.s("successfully created",p.default.Info)})),this.B(s.Event.fromNodeEventEmitter(D,"exit")(n=>{this.s(`received exit event with code ${n}`,p.default.Info),this.i.fire({pid:this.l,code:n,signal:"unknown"}),this.y()})),this.B(s.Event.fromNodeEventEmitter(E.app,"child-process-gone",(n,o)=>({event:n,details:o}))(({details:n})=>{n.type==="Utility"&&n.name===a&&(this.s(`crashed with code ${n.exitCode} and reason '${n.reason}'`,p.default.Error),this.p.publicLog2("utilityprocesscrash",{type:t.type,reason:n.reason,code:n.exitCode,sandboxed:i?"1":"0"}),this.j.fire({pid:this.l,code:n.exitCode,reason:n.reason}),this.y())}))}once(D,t){const a=this.B(this.h.event(i=>{i===D&&(a.dispose(),t())}))}postMessage(D,t){this.k&&this.k.postMessage(D,t)}connect(D){const{port1:t,port2:a}=new E.MessageChannelMain;return this.postMessage(D,[a]),t}enableInspectPort(){if(!this.k||typeof this.l!="number")return!1;this.s("enabling inspect port",p.default.Info);const D=process;return typeof D._debugProcess=="function"?(D._debugProcess(this.l),!0):!1}kill(){if(!this.k)return;this.s("attempting to kill the process...",p.default.Info),this.k.kill()?(this.s("successfully killed the process",p.default.Info),this.y()):this.s("unable to kill the process",p.default.Warning)}y(){typeof this.l=="number"&&ht.b.delete(this.l),this.k=void 0}async waitForExit(D){this.k&&(this.s("waiting to exit...",p.default.Info),await Promise.race([s.Event.toPromise(this.onExit),(0,k.timeout)(D)]),this.k&&(this.s(`did not exit within ${D}ms, will kill it now...`,p.default.Info),this.kill()))}};c.a=0,c.b=new Map,e.UtilityProcess=c=be([Q(0,L.ILogService),Q(1,m.ITelemetryService),Q(2,v.ILifecycleMainService)],c);let b=e.WindowUtilityProcess=class extends c{constructor(D,t,a,i){super(D,a,i),this.z=t}start(D){const t=this.z.getWindowById(D.responseWindowId);if(!t?.win||t.win.isDestroyed()||t.win.webContents.isDestroyed())return this.s("Refusing to start utility process because requesting window cannot be found or is destroyed...",p.default.Error),!0;if(!super.u(D,t.isSandboxed))return!1;this.C(t.win,D);const i=this.connect(D.payload);return t.win.webContents.postMessage(D.responseChannel,D.responseNonce,[i]),!0}C(D,t){t.windowLifecycleBound&&(this.B(s.Event.filter(this.r.onWillLoadWindow,a=>a.window.win===D)(()=>this.kill())),this.B(s.Event.fromNodeEventEmitter(D,"closed")(()=>this.kill())))}};e.WindowUtilityProcess=b=be([Q(0,L.ILogService),Q(1,l.IWindowsMainService),Q(2,m.ITelemetryService),Q(3,v.ILifecycleMainService)],b)}),define(te[279],ie([0,1,13,5,20,7,67,28,25]),function(x,e,E,M,s,L,R,k,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStarter=void 0;let l=e.ExtensionHostStarter=class Dt{constructor(m,v,f,y){this.d=m,this.f=v,this.g=f,this.h=y,this.b=new Map,this.c=!1,this.f.onWillShutdown(w=>{this.c=!0,w.join("extHostStarter",this._waitForAllExit(6e3))})}dispose(){}i(m){const v=this.b.get(m);if(!v)throw new Error("Unknown extension host!");return v}onDynamicStdout(m){return this.i(m).onStdout}onDynamicStderr(m){return this.i(m).onStderr}onDynamicMessage(m){return this.i(m).onMessage}onDynamicExit(m){return this.i(m).onExit}async createExtensionHost(){if(this.c)throw(0,E.canceled)();const m=String(++Dt.a),v=new R.WindowUtilityProcess(this.d,this.g,this.h,this.f);return this.b.set(m,v),v.onExit(({pid:f,code:y,signal:w})=>{this.d.info(`Extension host with pid ${f} exited with code: ${y}, signal: ${w}.`),setTimeout(()=>{v.dispose(),this.b.delete(m)})}),{id:m}}async start(m,v){if(this.c)throw(0,E.canceled)();this.i(m).start({...v,type:"extensionHost",entryPoint:"vs/workbench/api/node/extensionHostProcess",args:["--skipWorkspaceStorageLock"],execArgv:v.execArgv,allowLoadingUnsignedLibraries:!0,forceAllocationsToV8Sandbox:!0,correlationId:m})}async enableInspectPort(m){if(this.c)throw(0,E.canceled)();const v=this.b.get(m);return v?v.enableInspectPort():!1}async kill(m){if(this.c)throw(0,E.canceled)();const v=this.b.get(m);v&&v.kill()}async _killAllNow(){for(const[,m]of this.b)m.kill()}async _waitForAllExit(m){const v=[];for(const[,f]of this.b)v.push(f.waitForExit(m));return L.Promises.settled(v).then(()=>{})}};l.a=0,e.ExtensionHostStarter=l=be([Q(0,M.ILogService),Q(1,s.ILifecycleMainService),Q(2,k.IWindowsMainService),Q(3,h.ITelemetryService)],l)}),define(te[280],ie([0,1,42,7,2,30,20,5,39,37,65,67,46,108,11]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let w=e.SharedProcess=class extends s.Disposable{constructor(g,c,b,S,D,t,a){super(),this.c=g,this.f=c,this.g=b,this.h=S,this.i=D,this.j=t,this.k=a,this.a=new M.Barrier,this.b=void 0,this.r=void 0,this.s=void 0,this.l()}l(){E.validatedIpcMain.on("vscode:createSharedProcessMessageChannel",(g,c)=>this.m(g,c)),this.B(this.h.onWillShutdown(()=>this.n()))}async m(g,c){this.i.trace("[SharedProcess] on vscode:createSharedProcessMessageChannel"),this.a.isOpen()||this.a.open(),await this.whenReady();const b=await this.connect();if(g.sender.isDestroyed())return b.close();g.sender.postMessage("vscode:createSharedProcessMessageChannelResult",c,[b])}n(){this.i.trace("[SharedProcess] onWillShutdown"),this.b?.postMessage("vscode:electron-main->shared-process=exit"),this.b=void 0}whenReady(){return this.r||(this.r=(async()=>{await this.t;const g=new M.DeferredPromise;this.b?this.b.once("vscode:shared-process->electron-main=init-done",()=>g.complete()):E.validatedIpcMain.once("vscode:shared-process->electron-main=init-done",()=>g.complete()),await g.p,this.i.trace("[SharedProcess] Overall ready")})()),this.r}get t(){return this.s||(this.s=(async()=>{await this.a.wait(),this.u();const g=new M.DeferredPromise;this.b?this.b.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()):E.validatedIpcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>g.complete()),await g.p,this.i.trace("[SharedProcess] IPC ready")})()),this.s}u(){this.b=this.B(new m.UtilityProcess(this.i,v.NullTelemetryService,this.h));const g=(0,f.parseSharedProcessDebugPort)(this.f.args,this.f.isBuilt);let c;g.port&&(c=["--nolazy"],g.break?c.push(`--inspect-brk=${g.port}`):c.push(`--inspect=${g.port}`)),this.b.start({type:"shared-process",entryPoint:"vs/code/node/sharedProcess/sharedProcessMain",payload:this.v(),execArgv:c})}v(){return{machineId:this.c,codeCachePath:this.f.codeCachePath,profiles:{home:this.g.profilesHome,all:this.g.profiles},args:this.f.args,logLevel:this.j.getLogLevel(),loggers:this.j.getRegisteredLoggers(),policiesData:this.k.serialize()}}async connect(){return await this.t,(0,y.assertIsDefined)(this.b).connect()}};e.SharedProcess=w=be([Q(1,L.IEnvironmentMainService),Q(2,h.IUserDataProfilesService),Q(3,R.ILifecycleMainService),Q(4,k.ILogService),Q(5,p.ILoggerMainService),Q(6,l.IPolicyService)],w)}),define(te[281],ie([0,1,2,6,5,28,67,25,56,4,7,20]),function(x,e,E,M,s,L,R,k,h,l,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UtilityProcessWorkerMainService=e.IUtilityProcessWorkerMainService=void 0,e.IUtilityProcessWorkerMainService=(0,M.createDecorator)("utilityProcessWorker");let v=e.UtilityProcessWorkerMainService=class extends E.Disposable{constructor(w,r,g,c){super(),this.b=w,this.c=r,this.f=g,this.g=c,this.a=new Map}async createWorker(w){const r=`window: ${w.reply.windowId}, moduleId: ${w.process.moduleId}`;this.b.trace(`[UtilityProcessWorker]: createWorker(${r})`);const g=this.h(w);this.a.has(g)&&(this.b.warn(`[UtilityProcessWorker]: createWorker() found an existing worker that will be terminated (${r})`),this.disposeWorker(w));const c=new f(this.b,this.c,this.f,this.g,w);if(!c.spawn())return{reason:{code:1,signal:"EINVALID"}};this.a.set(g,c);const b=new p.DeferredPromise;return l.Event.once(c.onDidTerminate)(S=>{S.code===0?this.b.trace(`[UtilityProcessWorker]: terminated normally with code ${S.code}, signal: ${S.signal}`):this.b.error(`[UtilityProcessWorker]: terminated unexpectedly with code ${S.code}, signal: ${S.signal}`),this.a.delete(g),b.complete({reason:S})}),b.p}h(w){return(0,h.hash)({moduleId:w.process.moduleId,windowId:w.reply.windowId})}async disposeWorker(w){const r=this.h(w),g=this.a.get(r);g&&(this.b.trace(`[UtilityProcessWorker]: disposeWorker(window: ${w.reply.windowId}, moduleId: ${w.process.moduleId})`),g.kill(),this.a.delete(r))}};e.UtilityProcessWorkerMainService=v=be([Q(0,s.ILogService),Q(1,L.IWindowsMainService),Q(2,k.ITelemetryService),Q(3,m.ILifecycleMainService)],v);let f=class extends E.Disposable{constructor(w,r,g,c,b){super(),this.c=w,this.f=r,this.g=g,this.h=c,this.i=b,this.a=this.B(new l.Emitter),this.onDidTerminate=this.a.event,this.b=new R.WindowUtilityProcess(this.c,this.f,this.g,this.h),this.j()}j(){this.B(this.b.onExit(w=>this.a.fire({code:w.code,signal:w.signal}))),this.B(this.b.onCrash(w=>this.a.fire({code:w.code,signal:"ECRASH"})))}spawn(){const r=this.f.getWindowById(this.i.reply.windowId)?.win?.webContents.getOSProcessId();return this.b.start({type:this.i.process.type,entryPoint:this.i.process.moduleId,parentLifecycleBound:r,windowLifecycleBound:!0,correlationId:`${this.i.reply.windowId}`,responseWindowId:this.i.reply.windowId,responseChannel:this.i.reply.channel,responseNonce:this.i.reply.nonce})}kill(){this.b.kill()}};f=be([Q(0,s.ILogService),Q(1,L.IWindowsMainService),Q(2,k.ITelemetryService),Q(3,m.ILifecycleMainService)],f)}),define(te[282],ie([0,1,14,2,3,18,8,19,20,5,33,28,122,29]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let y=e.WindowsStateHandler=class yt extends M.Disposable{get state(){return this.b}constructor(S,D,t,a,i){super(),this.g=S,this.h=D,this.i=t,this.j=a,this.k=i,this.b=w(this.h.getItem(yt.a)),this.c=void 0,this.f=!1,this.l()}l(){E.app.on("browser-window-blur",()=>{this.f||this.n()}),this.i.onBeforeCloseWindow(S=>this.p(S)),this.i.onBeforeShutdown(()=>this.m()),this.g.onDidChangeWindowsCount(S=>{S.newCount-S.oldCount>0&&(this.c=void 0)}),this.g.onDidDestroyWindow(S=>this.p(S))}m(){this.f=!0,this.n()}n(){const S=new Set,D={openedWindows:[],lastPluginDevelopmentHostWindow:this.b.lastPluginDevelopmentHostWindow,lastActiveWindow:this.c};if(!D.lastActiveWindow){let i=this.g.getLastActiveWindow();(!i||i.isExtensionDevelopmentHost)&&(i=this.g.getWindows().find(n=>!n.isExtensionDevelopmentHost)),i&&(D.lastActiveWindow=this.r(i),D.lastActiveWindow.uiState.mode===3&&S.add(D.lastActiveWindow.uiState.display))}const t=this.g.getWindows().find(i=>i.isExtensionDevelopmentHost&&!i.isExtensionTestHost);t&&(D.lastPluginDevelopmentHostWindow=this.r(t),D.lastPluginDevelopmentHostWindow.uiState.mode===3&&(S.has(D.lastPluginDevelopmentHostWindow.uiState.display)?s.isMacintosh&&!t.win?.isSimpleFullScreen()&&(D.lastPluginDevelopmentHostWindow.uiState.mode=1):S.add(D.lastPluginDevelopmentHostWindow.uiState.display))),this.g.getWindowCount()>1&&(D.openedWindows=this.g.getWindows().filter(i=>!i.isExtensionDevelopmentHost).map(i=>{const n=this.r(i);return n.uiState.mode===3&&(S.has(n.uiState.display)?s.isMacintosh&&n.windowId!==D.lastActiveWindow?.windowId&&!i.win?.isSimpleFullScreen()&&(n.uiState.mode=1):S.add(n.uiState.display)),n}));const a=g(D);this.h.setItem(yt.a,a),this.f&&this.j.trace("[WindowsStateHandler] onBeforeShutdown",a)}p(S){if(this.i.quitRequested)return;const D=this.r(S);S.isExtensionDevelopmentHost&&!S.isExtensionTestHost?this.b.lastPluginDevelopmentHostWindow=D:!S.isExtensionDevelopmentHost&&S.openedWorkspace&&this.b.openedWindows.forEach(t=>{const a=(0,f.isWorkspaceIdentifier)(S.openedWorkspace)&&t.workspace?.id===S.openedWorkspace.id,i=(0,f.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&t.folderUri&&L.extUriBiasedIgnorePathCase.isEqual(t.folderUri,S.openedWorkspace.uri);(a||i)&&(t.uiState=D.uiState)}),this.g.getWindowCount()===1&&(this.c=D)}r(S){return{windowId:S.id,workspace:(0,f.isWorkspaceIdentifier)(S.openedWorkspace)?S.openedWorkspace:void 0,folderUri:(0,f.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)?S.openedWorkspace.uri:void 0,backupPath:S.backupPath,remoteAuthority:S.remoteAuthority,uiState:S.serializeWindowState()}}getNewWindowState(S){const D=this.s(S),t=this.k.getValue("window");if(D.mode===3){let a;D.hasDefaultState?a=!!(t?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(t.newWindowDimensions)>=0):a=!!(this.i.wasRestarted||t?.restoreFullscreen),a||(D.mode=1)}return D}s(S){const D=this.g.getLastActiveWindow();if(!S.extensionTestsPath){if(S.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const u=S.workspace;if((0,f.isWorkspaceIdentifier)(u)){const I=this.state.openedWindows.filter(A=>A.workspace&&A.workspace.id===u.id).map(A=>A.uiState);if(I.length)return I[0]}if((0,f.isSingleFolderWorkspaceIdentifier)(u)){const I=this.state.openedWindows.filter(A=>A.folderUri&&L.extUriBiasedIgnorePathCase.isEqual(A.folderUri,u.uri)).map(A=>A.uiState);if(I.length)return I[0]}else if(S.backupPath){const I=this.state.openedWindows.filter(A=>A.backupPath===S.backupPath).map(A=>A.uiState);if(I.length)return I[0]}const d=this.c||this.state.lastActiveWindow;if(!D&&d)return d.uiState}let t;const a=E.screen.getAllDisplays();if(a.length===1)t=a[0];else{if(s.isMacintosh){const u=E.screen.getCursorScreenPoint();t=E.screen.getDisplayNearestPoint(u)}!t&&D&&(t=E.screen.getDisplayMatching(D.getBounds())),t||(t=E.screen.getPrimaryDisplay()||a[0])}let i=(0,v.defaultWindowState)();i.x=Math.round(t.bounds.x+t.bounds.width/2-i.width/2),i.y=Math.round(t.bounds.y+t.bounds.height/2-i.height/2);const n=this.k.getValue("window");let o=!0;if(n?.newWindowDimensions){if(n.newWindowDimensions==="maximized")i.mode=0,o=!1;else if(n.newWindowDimensions==="fullscreen")i.mode=3,o=!1;else if((n.newWindowDimensions==="inherit"||n.newWindowDimensions==="offset")&&D){const u=D.serializeWindowState();u.mode===3?i.mode=3:i=u,o=i.mode!==3&&n.newWindowDimensions==="offset"}}return o&&(i=this.t(i)),i.hasDefaultState=!0,i}t(S){if(this.g.getWindows().length===0)return S;S.x=typeof S.x=="number"?S.x:0,S.y=typeof S.y=="number"?S.y:0;const D=this.g.getWindows().map(t=>t.getBounds());for(;D.some(t=>t.x===S.x||t.y===S.y);)S.x+=30,S.y+=30;return S}};y.a="windowsState",e.WindowsStateHandler=y=be([Q(0,m.IWindowsMainService),Q(1,p.IStateService),Q(2,h.ILifecycleMainService),Q(3,l.ILogService),Q(4,k.IConfigurationService)],y);function w(b){const S={openedWindows:[]},D=b||{openedWindows:[]};return D.lastActiveWindow&&(S.lastActiveWindow=r(D.lastActiveWindow)),D.lastPluginDevelopmentHostWindow&&(S.lastPluginDevelopmentHostWindow=r(D.lastPluginDevelopmentHostWindow)),Array.isArray(D.openedWindows)&&(S.openedWindows=D.openedWindows.map(t=>r(t))),S}e.restoreWindowsState=w;function r(b){const S={uiState:b.uiState};return b.backupPath&&(S.backupPath=b.backupPath),b.remoteAuthority&&(S.remoteAuthority=b.remoteAuthority),b.folder&&(S.folderUri=R.URI.parse(b.folder)),b.workspaceIdentifier&&(S.workspace={id:b.workspaceIdentifier.id,configPath:R.URI.parse(b.workspaceIdentifier.configURIPath)}),S}function g(b){return{lastActiveWindow:b.lastActiveWindow&&c(b.lastActiveWindow),lastPluginDevelopmentHostWindow:b.lastPluginDevelopmentHostWindow&&c(b.lastPluginDevelopmentHostWindow),openedWindows:b.openedWindows.map(S=>c(S))}}e.getWindowsStateStoreData=g;function c(b){return{workspaceIdentifier:b.workspace&&{id:b.workspace.id,configURIPath:b.workspace.configPath.toString()},folder:b.folderUri&&b.folderUri.toString(),backupPath:b.backupPath,remoteAuthority:b.remoteAuthority,uiState:b.uiState}}}),define(te[54],ie([0,1,14,4,43,2,15,9,18,11,24,188,63,58,30,6,5,53,124,29,95,96]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g,c,b,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,w.createDecorator)("workspacesManagementMainService");let t=e.WorkspacesManagementMainService=class extends L.Disposable{constructor(i,n,o,u,d){super(),this.g=i,this.h=n,this.i=o,this.j=u,this.k=d,this.a=this.B(new M.Emitter),this.onDidDeleteUntitledWorkspace=this.a.event,this.b=this.B(new M.Emitter),this.onDidEnterWorkspace=this.b.event,this.c=this.g.untitledWorkspacesHome,this.f=[]}async initialize(){this.f=[];try{const i=(await p.Promises.readdir(this.c.fsPath)).map(n=>(0,h.joinPath)(this.c,n,b.UNTITLED_WORKSPACE_NAME));for(const n of i){const o=(0,D.getWorkspaceIdentifier)(n),u=await this.resolveLocalWorkspace(n);u?this.f.push({workspace:o,remoteAuthority:u.remoteAuthority}):await this.deleteUntitledWorkspace(o)}}catch(i){i.code!=="ENOENT"&&this.h.warn(`Unable to read folders in ${this.c} (${i}).`)}}resolveLocalWorkspace(i){return this.l(i,n=>p.Promises.readFile(n,"utf8"))}l(i,n){if(this.m(i)&&i.scheme===R.Schemas.file)try{const o=n(i.fsPath);return o instanceof Promise?o.then(u=>this.n(i,u),u=>{}):this.n(i,o)}catch{return}}m(i){return(0,b.isUntitledWorkspace)(i,this.g)||(0,b.hasWorkspaceFileExtension)(i)}n(i,n){try{const o=this.p(i,n),u=(0,D.getWorkspaceIdentifier)(i);return{id:u.id,configPath:u.configPath,folders:(0,S.toWorkspaceFolders)(o.folders,u.configPath,h.extUriBiasedIgnorePathCase),remoteAuthority:o.remoteAuthority,transient:o.transient}}catch(o){this.h.warn(o.toString())}}p(i,n){const o=(0,s.parse)(n);if(o&&Array.isArray(o.folders))o.folders=o.folders.filter(u=>(0,S.isStoredWorkspaceFolder)(u));else throw new Error(`${i.toString(!0)} looks like an invalid workspace file.`);return o}async createUntitledWorkspace(i,n){const{workspace:o,storedWorkspace:u}=this.r(i,n),d=o.configPath.fsPath;return await p.Promises.mkdir((0,k.dirname)(d),{recursive:!0}),await p.Promises.writeFile(d,JSON.stringify(u,null,"	")),this.f.push({workspace:o,remoteAuthority:n}),o}r(i=[],n){const o=(Date.now()+Math.round(Math.random()*1e3)).toString(),u=(0,h.joinPath)(this.c,o),d=(0,h.joinPath)(u,b.UNTITLED_WORKSPACE_NAME),I=[];for(const A of i)I.push((0,S.getStoredWorkspaceFolder)(A.uri,!0,A.name,u,h.extUriBiasedIgnorePathCase));return{workspace:(0,D.getWorkspaceIdentifier)(d),storedWorkspace:{folders:I,remoteAuthority:n}}}async getWorkspaceIdentifier(i){return(0,D.getWorkspaceIdentifier)(i)}isUntitledWorkspace(i){return(0,b.isUntitledWorkspace)(i.configPath,this.g)}async deleteUntitledWorkspace(i){this.isUntitledWorkspace(i)&&(await this.s(i),this.i.isEnabled()&&this.i.unsetWorkspace(i),this.a.fire(i))}async s(i){const n=(0,h.originalFSPath)(i.configPath);try{await p.Promises.rm((0,k.dirname)(n));const o=(0,k.join)(this.g.workspaceStorageHome.fsPath,i.id);await p.Promises.exists(o)&&await p.Promises.writeFile((0,k.join)(o,"obsolete"),""),this.f=this.f.filter(u=>u.workspace.id!==i.id)}catch(o){this.h.warn(`Unable to delete untitled workspace ${n} (${o}).`)}}getUntitledWorkspaces(){return this.f}async enterWorkspace(i,n,o){if(!i||!i.win||!i.isReady||!await this.t(i,n,o))return;const d=await this.u(i,(0,D.getWorkspaceIdentifier)(o));if(d)return this.b.fire({window:i,workspace:d.workspace}),d}async t(i,n,o){return o?(0,b.isWorkspaceIdentifier)(i.openedWorkspace)&&h.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,o)?!1:(0,c.findWindowOnWorkspaceOrFolder)(n,o)?(await this.k.showMessageBox({type:"info",buttons:[(0,m.localize)(0,null)],message:(0,m.localize)(1,null,(0,h.basename)(o)),detail:(0,m.localize)(2,null)},(0,l.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),!1):!0:!0}async u(i,n){if(!i.config)return;i.focus();let o;return i.config.extensionDevelopmentPath||(i.config.backupPath?o=await this.j.registerWorkspaceBackup({workspace:n,remoteAuthority:i.remoteAuthority},i.config.backupPath):o=this.j.registerWorkspaceBackup({workspace:n,remoteAuthority:i.remoteAuthority})),(0,b.isWorkspaceIdentifier)(i.openedWorkspace)&&this.isUntitledWorkspace(i.openedWorkspace)&&await this.deleteUntitledWorkspace(i.openedWorkspace),i.config.workspace=n,i.config.backupPath=o,{workspace:n,backupPath:o}}};e.WorkspacesManagementMainService=t=be([Q(0,y.IEnvironmentMainService),Q(1,r.ILogService),Q(2,g.IUserDataProfilesMainService),Q(3,v.IBackupMainService),Q(4,f.IDialogMainService)],t)}),define(te[125],ie([0,1,14,42,22,6,28,29,54,11,5,67]),function(x,e,E,M,s,L,R,k,h,l,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsMainService=e.IDiagnosticsMainService=e.ID=void 0,e.ID="diagnosticsMainService",e.IDiagnosticsMainService=(0,L.createDecorator)(e.ID);let v=e.DiagnosticsMainService=class{constructor(y,w,r){this.a=y,this.b=w,this.c=r}async getRemoteDiagnostics(y){const w=this.a.getWindows();return(await Promise.all(w.map(async g=>{const c=g.remoteAuthority;if(!c)return;const b=`vscode:getDiagnosticInfoResponse${g.id}`,S={includeProcesses:y.includeProcesses,folders:y.includeWorkspaceMetadata?await this.f(g):void 0};return new Promise(D=>{g.sendWhenReady("vscode:getDiagnosticInfo",s.CancellationToken.None,{replyChannel:b,args:S}),M.validatedIpcMain.once(b,(t,a)=>{a||D({hostName:c,errorMessage:`Unable to resolve connection to '${c}'.`}),D(a)}),setTimeout(()=>{D({hostName:c,errorMessage:`Connection to '${c}' could not be established`})},5e3)})}))).filter(g=>!!g)}async getMainDiagnostics(){this.c.trace("Received request for main process info from other instance.");const y=[];for(const r of E.BrowserWindow.getAllWindows()){const g=this.a.getWindowById(r.id);g?y.push(await this.d(g)):y.push(this.e(r))}const w=[];for(const{pid:r,name:g}of m.UtilityProcess.getAll())w.push({pid:r,name:g});return{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:y,pidToNames:w,screenReader:!!E.app.accessibilitySupportEnabled,gpuFeatureStatus:E.app.getGPUFeatureStatus()}}async d(y){const w=await this.f(y),r=(0,l.assertIsDefined)(y.win);return this.e(r,w,y.remoteAuthority)}e(y,w=[],r){return{id:y.id,pid:y.webContents.getOSProcessId(),title:y.getTitle(),folderURIs:w,remoteAuthority:r}}async f(y){const w=[],r=y.openedWorkspace;if((0,k.isSingleFolderWorkspaceIdentifier)(r))w.push(r.uri);else if((0,k.isWorkspaceIdentifier)(r)){const g=await this.b.resolveLocalWorkspace(r.configPath);g&&g.folders.forEach(b=>{w.push(b.uri)})}return w}};e.DiagnosticsMainService=v=be([Q(0,R.IWindowsMainService),Q(1,h.IWorkspacesManagementMainService),Q(2,p.ILogService)],v)}),define(te[59],ie([0,1,50,14,26,150,55,4,2,15,9,3,8,103,85,24,101,178,58,30,6,20,5,21,78,28,29,54,17,237,231,33]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g,c,b,S,D,t,a,i,n,o,u,d,I,A,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,S.createDecorator)("nativeHostMainService");let T=e.NativeHostMainService=class extends h.Disposable{constructor($,H,Z,ne,se,ue,ce,X,q){super(),this.a=$,this.b=H,this.c=Z,this.f=ne,this.g=se,this.h=ue,this.i=ce,this.j=X,this.k=q,this.onDidOpenWindow=k.Event.map(this.a.onDidOpenWindow,B=>B.id),this.onDidTriggerSystemContextMenu=k.Event.filter(k.Event.map(this.a.onDidTriggerSystemContextMenu,({window:B,x:z,y:K})=>({windowId:B.id,x:z,y:K})),({windowId:B})=>!!this.a.getWindowById(B)),this.onDidMaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-maximize",(B,z)=>z.id),B=>!!this.a.getWindowById(B)),this.onDidUnmaximizeWindow=k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-unmaximize",(B,z)=>z.id),B=>!!this.a.getWindowById(B)),this.onDidBlurWindow=k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-blur",(B,z)=>z.id),B=>!!this.a.getWindowById(B)),this.onDidFocusWindow=k.Event.any(k.Event.map(k.Event.filter(k.Event.map(this.a.onDidChangeWindowsCount,()=>this.a.getLastActiveWindow()),B=>!!B),B=>B.id),k.Event.filter(k.Event.fromNodeEventEmitter(M.app,"browser-window-focus",(B,z)=>z.id),B=>!!this.a.getWindowById(B))),this.onDidResumeOS=k.Event.fromNodeEventEmitter(M.powerMonitor,"resume"),this.onDidChangeColorScheme=this.i.onDidChangeColorScheme,this.l=this.B(new k.Emitter),this.onDidChangePassword=this.l.event,this.onDidChangeDisplay=k.Event.debounce(k.Event.any(k.Event.filter(k.Event.fromNodeEventEmitter(M.screen,"display-metrics-changed",(B,z,K)=>K),B=>!(Array.isArray(B)&&B.length===1&&B[0]==="workArea")),k.Event.fromNodeEventEmitter(M.screen,"display-added"),k.Event.fromNodeEventEmitter(M.screen,"display-removed")),()=>{},100)}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.a.getWindows().map(H=>({id:H.id,workspace:H.openedWorkspace??(0,o.toWorkspaceIdentifier)(H.backupPath,H.isExtensionDevelopmentHost),title:H.win?.getTitle()??"",filename:H.getRepresentedFilename(),dirty:H.isDocumentEdited()}))}async getWindowCount($){return this.a.getWindowCount()}async getActiveWindowId($){const H=M.BrowserWindow.getFocusedWindow()||this.a.getLastActiveWindow();if(H)return H.id}openWindow($,H,Z){return Array.isArray(H)?this.m($,H,Z):this.n($,H)}async m($,H,Z=Object.create(null)){H.length>0&&await this.a.open({context:5,contextWindowId:$,urisToOpen:H,cli:this.f.args,forceNewWindow:Z.forceNewWindow,forceReuseWindow:Z.forceReuseWindow,preferNewWindow:Z.preferNewWindow,diffMode:Z.diffMode,mergeMode:Z.mergeMode,addMode:Z.addMode,gotoLineMode:Z.gotoLineMode,noRecentEntry:Z.noRecentEntry,waitMarkerFileURI:Z.waitMarkerFileURI,remoteAuthority:Z.remoteAuthority||void 0,forceProfile:Z.forceProfile,forceTempProfile:Z.forceTempProfile})}async n($,H){await this.a.openEmptyWindow({context:5,contextWindowId:$},H)}async toggleFullScreen($){this.v($)?.toggleFullScreen()}async handleTitleDoubleClick($){this.v($)?.handleTitleDoubleClick()}async isMaximized($){const H=this.v($);return H?.win?H.win.isMaximized():!1}async maximizeWindow($){const H=this.v($);H?.win&&H.win.maximize()}async unmaximizeWindow($){const H=this.v($);H?.win&&H.win.unmaximize()}async minimizeWindow($){const H=this.v($);H?.win&&H.win.minimize()}async updateWindowControls($,H){const Z=this.v($);Z&&Z.updateWindowControls(H)}async focusWindow($,H){H&&typeof H.windowId=="number"&&($=H.windowId),this.v($)?.focus({force:H?.force??!1})}async setMinimumSize($,H,Z){const ne=this.v($);if(ne?.win){const[se,ue]=ne.win.getSize(),[ce,X]=ne.win.getMinimumSize(),[q,B]=[H??ce,Z??X],[z,K]=[Math.max(se,q),Math.max(ue,B)];(ce!==q||X!==B)&&ne.win.setMinimumSize(q,B),(se!==z||ue!==K)&&ne.win.setSize(z,K)}}async saveWindowSplash($,H){this.i.saveWindowSplash($,H)}async installShellCommand($){const{source:H,target:Z}=await this.p();try{const{symbolicLink:ne}=await w.SymlinkSupport.stat(H);if(ne&&!ne.dangling){const se=await(0,f.realpath)(H);if(Z===se)return}await w.Promises.unlink(H)}catch(ne){if(ne.code!=="ENOENT")throw ne}try{await w.Promises.symlink(Z,H)}catch(ne){if(ne.code!=="EACCES"&&ne.code!=="ENOENT")throw ne;const{response:se}=await this.showMessageBox($,{type:"info",message:(0,g.localize)(0,null,this.h.nameShort),buttons:[(0,g.localize)(1,null),(0,g.localize)(2,null)]});if(se===0)try{const ue=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${Z}' '${H}'\\" with administrator privileges"`;await(0,L.promisify)(E.exec)(ue)}catch{throw new Error((0,g.localize)(3,null,H))}}}async uninstallShellCommand($){const{source:H}=await this.p();try{await w.Promises.unlink(H)}catch(Z){switch(Z.code){case"EACCES":{const{response:ne}=await this.showMessageBox($,{type:"info",message:(0,g.localize)(4,null,this.h.nameShort),buttons:[(0,g.localize)(5,null),(0,g.localize)(6,null)]});if(ne===0)try{const se=`osascript -e "do shell script \\"rm '${H}'\\" with administrator privileges"`;await(0,L.promisify)(E.exec)(se)}catch{throw new Error((0,g.localize)(7,null,H))}break}case"ENOENT":break;default:throw Z}}}async p(){const $=(0,p.resolve)(this.f.appRoot,"bin","code"),H=`/usr/local/bin/${this.h.applicationName}`;if(!await w.Promises.exists($))throw new Error((0,g.localize)(8,null,$));return{source:H,target:$}}async showMessageBox($,H){return this.b.showMessageBox(H,this.r($))}async showSaveDialog($,H){return this.b.showSaveDialog(H,this.r($))}async showOpenDialog($,H){return this.b.showOpenDialog(H,this.r($))}r($){const H=this.v($);if(H?.win)return H.win}async pickFileFolderAndOpen($,H){const Z=await this.b.pickFileFolder(H);Z&&await this.s(await Promise.all(Z.map(async ne=>await w.SymlinkSupport.existsDirectory(ne)?{folderUri:v.URI.file(ne)}:{fileUri:v.URI.file(ne)})),H,$)}async pickFolderAndOpen($,H){const Z=await this.b.pickFolder(H);Z&&await this.s(Z.map(ne=>({folderUri:v.URI.file(ne)})),H,$)}async pickFileAndOpen($,H){const Z=await this.b.pickFile(H);Z&&await this.s(Z.map(ne=>({fileUri:v.URI.file(ne)})),H,$)}async pickWorkspaceAndOpen($,H){const Z=await this.b.pickWorkspace(H);Z&&await this.s(Z.map(ne=>({workspaceUri:v.URI.file(ne)})),H,$)}async s($,H,Z){await this.a.open({context:3,contextWindowId:Z,cli:this.f.args,urisToOpen:$,forceNewWindow:H.forceNewWindow})}async showItemInFolder($,H){M.shell.showItemInFolder(H)}async setRepresentedFilename($,H){this.v($)?.setRepresentedFilename(H)}async setDocumentEdited($,H){this.v($)?.setDocumentEdited(H)}async openExternal($,H){return m.isLinuxSnap?this.t(H):M.shell.openExternal(H),!0}t($){const H=process.env.GDK_PIXBUF_MODULE_FILE,Z=process.env.GDK_PIXBUF_MODULEDIR,ne=process.env.GTK_IM_MODULE_FILE,se=process.env.GDK_BACKEND,ue=process.env.GIO_MODULE_DIR,ce=process.env.GTK_EXE_PREFIX,X=process.env.GSETTINGS_SCHEMA_DIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,delete process.env.GTK_IM_MODULE_FILE,delete process.env.GDK_BACKEND,delete process.env.GIO_MODULE_DIR,delete process.env.GTK_EXE_PREFIX,delete process.env.GSETTINGS_SCHEMA_DIR,M.shell.openExternal($),process.env.GDK_PIXBUF_MODULE_FILE=H,process.env.GDK_PIXBUF_MODULEDIR=Z,process.env.GTK_IM_MODULE_FILE=ne,process.env.GDK_BACKEND=se,process.env.GIO_MODULE_DIR=ue,process.env.GTK_EXE_PREFIX=ce,process.env.GSETTINGS_SCHEMA_DIR=X}moveItemToTrash($,H){return M.shell.trashItem(H)}async isAdmin(){let $;return m.isWindows?$=(await new Promise((H,Z)=>{x(["native-is-elevated"],H,Z)}))():$=process.getuid()===0,$}async writeElevated($,H,Z,ne){const se=await new Promise((ue,ce)=>{x(["@vscode/sudo-prompt"],ue,ce)});return new Promise((ue,ce)=>{const X=[`"${this.u}"`];ne?.unlock&&X.push("--file-chmod"),X.push("--file-write",`"${H.fsPath}"`,`"${Z.fsPath}"`);const q={name:this.h.nameLong.replace("-",""),icns:m.isMacintosh&&this.f.isBuilt?(0,p.join)((0,p.dirname)(this.f.appRoot),`${this.h.nameShort}.icns`):void 0};se.exec(X.join(" "),q,(B,z,K)=>{z&&this.g.trace(`[sudo-prompt] received stdout: ${z}`),K&&this.g.trace(`[sudo-prompt] received stderr: ${K}`),B?ce(B):ue(void 0)})})}get u(){return m.isWindows?this.f.isBuilt?(0,p.join)((0,p.dirname)(process.execPath),"bin",`${this.h.applicationName}.cmd`):(0,p.join)(this.f.appRoot,"scripts","code-cli.bat"):m.isLinux?this.f.isBuilt?(0,p.join)((0,p.dirname)(process.execPath),"bin",`${this.h.applicationName}`):(0,p.join)(this.f.appRoot,"scripts","code-cli.sh"):this.f.isBuilt?(0,p.join)(this.f.appRoot,"bin","code"):(0,p.join)(this.f.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,s.totalmem)(),freemem:(0,s.freemem)(),loadavg:(0,s.loadavg)()}}async getOSProperties(){return{arch:(0,s.arch)(),platform:(0,s.platform)(),release:(0,s.release)(),type:(0,s.type)(),cpus:(0,s.cpus)()}}async getOSVirtualMachineHint(){return y.virtualMachineHint.value()}async getOSColorScheme(){return this.i.getColorScheme()}async hasWSLFeatureInstalled(){return m.isWindows&&(0,I.hasWSLFeatureInstalled)()}async killProcess($,H,Z){process.kill(H,Z)}async readClipboardText($,H){return M.clipboard.readText(H)}async writeClipboardText($,H,Z){return M.clipboard.writeText(H,Z)}async readClipboardFindText($){return M.clipboard.readFindText()}async writeClipboardFindText($,H){return M.clipboard.writeFindText(H)}async writeClipboardBuffer($,H,Z,ne){return M.clipboard.writeBuffer(H,Buffer.from(Z.buffer),ne)}async readClipboardBuffer($,H){return d.VSBuffer.wrap(M.clipboard.readBuffer(H))}async hasClipboard($,H,Z){return M.clipboard.has(H,Z)}async newWindowTab(){await this.a.open({context:5,cli:this.f.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.f.args.remote||void 0})}async showPreviousWindowTab(){M.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){M.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){M.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){M.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){M.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar($,H){this.v($)?.updateTouchBar(H)}async notifyReady($){this.v($)?.setReady()}async relaunch($,H){return this.c.relaunch(H)}async reload($,H){const Z=this.v($);if(Z){if((0,o.isWorkspaceIdentifier)(Z.openedWorkspace)){const ne=Z.openedWorkspace.configPath;if(ne.scheme===l.Schemas.file&&(await this.k.resolveLocalWorkspace(ne))?.transient)return this.openWindow(Z.id,{forceReuseWindow:!0})}return this.c.reload(Z,H?.disableExtensions!==void 0?{_:[],"disable-extensions":H.disableExtensions}:void 0)}}async closeWindow($){this.closeWindowById($,$)}async closeWindowById($,H){const Z=this.v(H);if(Z?.win)return Z.win.close()}async quit($){const H=this.a.getLastActiveWindow();H?.isExtensionDevelopmentHost&&this.a.getWindowCount()>1&&H.win?H.win.close():this.c.quit()}async exit($,H){await this.c.kill(H)}async resolveProxy($,H){return this.v($)?.win?.webContents?.session?.resolveProxy(H)}findFreePort($,H,Z,ne,se=1){return(0,r.findFreePort)(H,Z,ne,se)}async openDevTools($,H){const Z=this.v($);Z?.win&&Z.win.webContents.openDevTools(H)}async toggleDevTools($){const H=this.v($);H?.win&&H.win.webContents.toggleDevTools()}async sendInputEvent($,H){const Z=this.v($);Z?.win&&(H.type==="mouseDown"||H.type==="mouseUp")&&Z.win.webContents.sendInputEvent(H)}async enableSandbox($,H){H?this.j.setItem("window.experimental.useSandbox",!0):this.j.removeItem("window.experimental.useSandbox")}async profileRenderer($,H,Z){const ne=this.v($);if(!ne||!ne.win)throw new Error;return await new A.WindowProfiler(ne.win,H,this.g).inspect(Z)}async windowsGetStringRegKey($,H,Z,ne){if(!m.isWindows)return;const se=await new Promise((ue,ce)=>{x(["@vscode/windows-registry"],ue,ce)});try{return se.GetStringRegKey(H,Z,ne)}catch{return}}v($){if(typeof $=="number")return this.a.getWindowById($)}};be([R.memoize],T.prototype,"u",null),e.NativeHostMainService=T=be([Q(0,n.IWindowsMainService),Q(1,c.IDialogMainService),Q(2,D.ILifecycleMainService),Q(3,b.IEnvironmentMainService),Q(4,t.ILogService),Q(5,a.IProductService),Q(6,i.IThemeMainService),Q(7,C.IStateService),Q(8,u.IWorkspacesManagementMainService)],T)}),define(te[283],ie([0,1,14,42,26,2,15,3,104,176,88,125,58,30,5,59,76,21,77,79,32,11,33,67,22,8,28,7]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g,c,b,S,D,t,a,i,n,o,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=void 0;const d="issue.processExplorerWindowState";let I=e.IssueMainService=class Ct{constructor(T,W,$,H,Z,ne,se,ue,ce,X,q){this.g=T,this.h=W,this.i=$,this.j=H,this.k=Z,this.l=ne,this.m=se,this.n=ue,this.o=ce,this.p=X,this.q=q,this.b=null,this.c=null,this.d=null,this.f=null,this.r()}r(){M.validatedIpcMain.on("vscode:listProcesses",async T=>{const W=[];try{W.push({name:(0,l.localize)(0,null),rootProcess:await(0,h.listProcesses)(process.pid)}),(await this.k.getRemoteDiagnostics({includeProcesses:!0})).forEach(H=>{(0,p.isRemoteDiagnosticError)(H)?W.push({name:H.hostName,rootProcess:H}):H.processes&&W.push({name:H.hostName,rootProcess:H.processes})})}catch($){this.i.error(`Listing processes failed: ${$}`)}this.t(T,"vscode:listProcessesResponse",W)}),M.validatedIpcMain.on("vscode:workbenchCommand",(T,W)=>{const{id:$,from:H,args:Z}=W;let ne;switch(H){case"processExplorer":ne=this.f;break;default:throw new Error(`Unexpected command source: ${H}`)}ne?.webContents.send("vscode:runAction",{id:$,from:H,args:Z})}),M.validatedIpcMain.on("vscode:closeProcessExplorer",T=>{this.d?.close()}),M.validatedIpcMain.on("vscode:pidToNameRequest",async T=>{const W=await this.k.getMainDiagnostics(),$=[];for(const H of W.windows)$.push([H.pid,`window [${H.id}] (${H.title})`]);for(const{pid:H,name:Z}of a.UtilityProcess.getAll())$.push([H,Z]);this.t(T,"vscode:pidToNameResponse",$)})}async openReporter(T){if(!this.b&&(this.c=E.BrowserWindow.getFocusedWindow(),this.c)){const W=new L.DisposableStore,$=W.add(this.n.createIPCObjectUrl()),H=this.v(this.c,700,800);this.b=this.u(H,$,{backgroundColor:T.styles.backgroundColor,title:(0,l.localize)(1,null),zoomLevel:T.zoomLevel,alwaysOnTop:!1},"issue-reporter"),$.update({appRoot:this.h.appRoot,windowId:this.b.id,userEnv:this.g,data:T,disableExtensions:!!this.h.disableExtensions,os:{type:(0,s.type)(),arch:(0,s.arch)(),release:(0,s.release)()},product:r.default}),this.b.loadURL(R.FileAccess.asBrowserUri(`vs/code/electron-sandbox/issue/issueReporter${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.b.on("close",()=>{this.b=null,W.dispose()}),this.c.on("closed",()=>{this.b&&(this.b.close(),this.b=null,W.dispose())})}this.b&&this.s(this.b)}async openProcessExplorer(T){if(!this.d&&(this.f=E.BrowserWindow.getFocusedWindow(),this.f)){const W=new L.DisposableStore,$=W.add(this.n.createIPCObjectUrl()),H=this.p.getItem(d,void 0),Z=A(H)?H:this.v(this.f,800,500);this.d=this.u(Z,$,{backgroundColor:T.styles.backgroundColor,title:(0,l.localize)(2,null),zoomLevel:T.zoomLevel,alwaysOnTop:!0},"process-explorer"),$.update({appRoot:this.h.appRoot,windowId:this.d.id,userEnv:this.g,data:T,product:r.default}),this.d.loadURL(R.FileAccess.asBrowserUri(`vs/code/electron-sandbox/processExplorer/processExplorer${this.h.isBuilt?"":"-dev"}.html`).toString(!0)),this.d.on("close",()=>{this.d=null,W.dispose()}),this.f.on("close",()=>{this.d&&(this.d.close(),this.d=null,W.dispose())});const ne=()=>{if(!this.d)return;const se=this.d.getSize(),ue=this.d.getPosition();if(!se||!ue)return;const ce={width:se[0],height:se[1],x:ue[0],y:ue[1]};this.p.setItem(d,ce)};this.d.on("moved",ne),this.d.on("resized",ne)}this.d&&this.s(this.d)}async stopTracing(){if(!this.h.args.trace)return;const T=await E.contentTracing.stopRecording(`${(0,S.randomPath)(this.h.userHome.fsPath,this.o.applicationName)}.trace.txt`);await this.l.showMessageBox({type:"info",message:(0,l.localize)(3,null),detail:(0,l.localize)(4,null,T),buttons:[(0,l.localize)(5,null)]},(0,D.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow())),this.m.showItemInFolder(void 0,T)}async getSystemStatus(){const[T,W]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.j.getDiagnostics(T,W)}async $getSystemInfo(){const[T,W]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return await this.j.getSystemInfo(T,W)}async $getPerformanceInfo(){try{const[T,W]=await Promise.all([this.k.getMainDiagnostics(),this.k.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.j.getPerformanceInfo(T,W)}catch(T){throw this.i.warn("issueService#getPerformanceInfo ",T.message),T}}async $reloadWithExtensionsDisabled(){if(this.c)try{await this.m.reload(this.c.id,{disableExtensions:!0})}catch(T){this.i.error(T)}}async $showConfirmCloseDialog(){if(this.b){const{response:T}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(6,null),buttons:[(0,l.localize)(7,null),(0,l.localize)(8,null)]},this.b);T===0&&this.b&&(this.b.destroy(),this.b=null)}}async $showClipboardDialog(){if(this.b){const{response:T}=await this.l.showMessageBox({type:"warning",message:(0,l.localize)(9,null),buttons:[(0,l.localize)(10,null),(0,l.localize)(11,null)]},this.b);return T===0}return!1}async $getIssueReporterUri(T){if(!this.c)throw new Error("Issue reporter window not available");const W=this.q.getWindowById(this.c.id);if(!W)throw new Error("Window not found");const $=`vscode:triggerIssueUriRequestHandlerResponse${W.id}`;return u.Promises.withAsyncBody(async(H,Z)=>{const ne=new i.CancellationTokenSource;W.sendWhenReady("vscode:triggerIssueUriRequestHandler",ne.token,{replyChannel:$,extensionId:T}),M.validatedIpcMain.once($,(se,ue)=>{H(n.URI.parse(ue))});try{await(0,u.timeout)(5e3),ne.cancel(),Z(new Error("Timed out waiting for issue reporter URI"))}finally{M.validatedIpcMain.removeHandler($)}})}async $closeReporter(){this.b?.close()}async closeProcessExplorer(){this.d?.close()}s(T){T.isMinimized()&&T.restore(),T.focus()}t(T,W,...$){T.sender.isDestroyed()||T.sender.send(W,...$)}u(T,W,$,H){const Z=new E.BrowserWindow({fullscreen:!1,skipTaskbar:!1,resizable:!0,width:T.width,height:T.height,minWidth:300,minHeight:200,x:T.x,y:T.y,title:$.title,backgroundColor:$.backgroundColor||Ct.a,webPreferences:{preload:R.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${W.resource.toString()}`],v8CacheOptions:this.h.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,b.zoomLevelToZoomFactor)($.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:$.alwaysOnTop,experimentalDarkMode:!0});return Z.setMenuBarVisibility(!1),Z}v(T,W,$){let H;const Z=E.screen.getAllDisplays();if(Z.length===1)H=Z[0];else{if(k.isMacintosh){const ue=E.screen.getCursorScreenPoint();H=E.screen.getDisplayNearestPoint(ue)}!H&&T&&(H=E.screen.getDisplayMatching(T.getBounds())),H||(H=E.screen.getPrimaryDisplay()||Z[0])}const ne=H.bounds,se={width:W,height:$,x:ne.x+ne.width/2-W/2,y:ne.y+ne.height/2-$/2};return ne.width>0&&ne.height>0&&(se.x<ne.x&&(se.x=ne.x),se.y<ne.y&&(se.y=ne.y),se.x>ne.x+ne.width&&(se.x=ne.x),se.y>ne.y+ne.height&&(se.y=ne.y),se.width>ne.width&&(se.width=ne.width),se.height>ne.height&&(se.height=ne.height)),se}};I.a="#1E1E1E",e.IssueMainService=I=be([Q(1,f.IEnvironmentMainService),Q(2,y.ILogService),Q(3,p.IDiagnosticsService),Q(4,m.IDiagnosticsMainService),Q(5,v.IDialogMainService),Q(6,w.INativeHostMainService),Q(7,c.IProtocolMainService),Q(8,g.IProductService),Q(9,t.IStateService),Q(10,o.IWindowsMainService)],I);function A(C){return typeof C!="object"||C===null?!1:"x"in C&&"y"in C&&"width"in C&&"height"in C}}),define(te[284],ie([0,1,22,19,30,20,5,59,21,52,25,47,99]),function(x,e,E,M,s,L,R,k,h,l,p,m,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let f=e.LinuxUpdateService=class extends v.AbstractUpdateService{constructor(w,r,g,c,b,S,D,t){super(w,r,c,b,S,t),this.e=g,this.u=D}s(w){return(0,v.createUpdateURL)(`linux-${process.arch}`,w,this.k)}t(w){this.a&&(this.d(m.State.CheckingForUpdates(w)),this.i.request({url:this.a},E.CancellationToken.None).then(l.asJson).then(r=>{!r||!r.url||!r.version||!r.productVersion?(this.e.publicLog2("update:notAvailable",{explicit:!!w}),this.d(m.State.Idle(1))):this.d(m.State.AvailableForDownload(r))}).then(void 0,r=>{this.j.error(r),this.e.publicLog2("update:notAvailable",{explicit:!!w});const g=w?r.message||r:void 0;this.d(m.State.Idle(1,g))}))}async o(w){this.k.downloadUrl&&this.k.downloadUrl.length>0?this.u.openExternal(void 0,this.k.downloadUrl):w.update.url&&this.u.openExternal(void 0,w.update.url),this.d(m.State.Idle(1))}};e.LinuxUpdateService=f=be([Q(0,L.ILifecycleMainService),Q(1,M.IConfigurationService),Q(2,p.ITelemetryService),Q(3,s.IEnvironmentMainService),Q(4,l.IRequestService),Q(5,R.ILogService),Q(6,k.INativeHostMainService),Q(7,h.IProductService)],f)}),define(te[285],ie([0,1,50,41,26,7,22,55,9,8,136,24,19,30,16,20,5,59,21,52,25,47,99]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g,c,b,S,D,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function a(u,d=1e3){for(;!u();)await(0,L.timeout)(d)}let i;function n(){return typeof i>"u"&&(i=M.existsSync(h.join(h.dirname(process.execPath),"unins000.exe"))?0:1),i}let o=e.Win32UpdateService=class extends t.AbstractUpdateService{get cachePath(){const d=h.join((0,s.tmpdir)(),`vscode-update-${this.k.target}-${process.arch}`);return m.Promises.mkdir(d,{recursive:!0}).then(()=>d)}constructor(d,I,A,C,T,W,$,H,Z){super(d,I,C,T,W,Z),this.u=A,this.v=$,this.w=H}async l(){if(this.k.target==="user"&&await this.w.isAdmin(void 0)){this.j.info("update#ctor - updates are disabled due to running as Admin in user setup");return}await super.l()}s(d){let I="win32";return process.arch!=="ia32"&&(I+=`-${process.arch}`),n()===1?I+="-archive":this.k.target==="user"&&(I+="-user"),(0,t.createUpdateURL)(I,d,this.k)}t(d){this.a&&(this.d(D.State.CheckingForUpdates(d)),this.i.request({url:this.a},R.CancellationToken.None).then(b.asJson).then(I=>{const A=n();return!I||!I.url||!I.version||!I.productVersion?(this.u.publicLog2("update:notAvailable",{explicit:!!d}),this.d(D.State.Idle(A)),Promise.resolve(null)):A===1?(this.d(D.State.AvailableForDownload(I)),Promise.resolve(null)):(this.d(D.State.Downloading(I)),this.C(I.version).then(()=>this.B(I.version).then(C=>m.Promises.exists(C).then(T=>{if(T)return Promise.resolve(C);const W=I.url,$=I.hash,H=`${C}.tmp`;return this.i.request({url:W},R.CancellationToken.None).then(Z=>this.v.writeFile(l.URI.file(H),Z.stream)).then($?()=>(0,p.checksum)(H,I.hash):()=>{}).then(()=>m.Promises.rename(H,C)).then(()=>C)})).then(C=>{const T=this.g.getValue("update.enableWindowsBackgroundUpdates");this.e={packagePath:C},T&&I.supportsFastUpdate?this.k.target==="user"?this.p():this.d(D.State.Downloaded(I)):this.d(D.State.Ready(I))})))}).then(void 0,I=>{this.j.error(I),this.u.publicLog2("update:notAvailable",{explicit:!!d});const A=d?I.message||I:void 0;this.d(D.State.Idle(n(),A))}))}async o(d){d.update.url&&this.w.openExternal(void 0,d.update.url),this.d(D.State.Idle(n()))}async B(d){const I=await this.cachePath;return h.join(I,`CodeSetup-${this.k.quality}-${d}.exe`)}async C(d=null){const I=d?W=>!new RegExp(`${this.k.quality}-${d}\\.exe$`).test(W):()=>!0,A=await this.cachePath,T=(await m.Promises.readdir(A)).filter(I).map(async W=>{try{await m.Promises.unlink(h.join(A,W))}catch{}});await Promise.all(T)}async p(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.e)return Promise.resolve(void 0);const d=this.state.update;this.d(D.State.Updating(d));const I=await this.cachePath;this.e.updateFilePath=h.join(I,`CodeSetup-${this.k.quality}-${d.version}.flag`),await m.Promises.writeFile(this.e.updateFilePath,"flag"),(0,E.spawn)(this.e.packagePath,["/verysilent",`/update="${this.e.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.e=void 0,this.d(D.State.Idle(n()))});const C=`${this.k.win32MutexName}-ready`,T=await new Promise((W,$)=>{x(["@vscode/windows-mutex"],W,$)});a(()=>T.isActive(C)).then(()=>this.d(D.State.Ready(d)))}r(){this.state.type!=="ready"||!this.e||(this.j.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.e.updateFilePath?M.unlinkSync(this.e.updateFilePath):(0,E.spawn)(this.e.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}q(){return n()}async _applySpecificUpdate(d){if(this.state.type!=="idle")return;const I=this.g.getValue("update.enableWindowsBackgroundUpdates"),A={version:"unknown",productVersion:"unknown",supportsFastUpdate:!!I};this.d(D.State.Downloading(A)),this.e={packagePath:d},I?this.k.target==="user"?this.p():this.d(D.State.Downloaded(A)):this.d(D.State.Ready(A))}};be([k.memoize],o.prototype,"cachePath",null),e.Win32UpdateService=o=be([Q(0,w.ILifecycleMainService),Q(1,v.IConfigurationService),Q(2,S.ITelemetryService),Q(3,f.IEnvironmentMainService),Q(4,b.IRequestService),Q(5,r.ILogService),Q(6,y.IFileService),Q(7,g.INativeHostMainService),Q(8,c.IProductService)],o)}),define(te[286],ie([0,1,14,7,22,49,4,2,15,9,64,3,8,184,63,19,58,30,62,16,20,5,21,77,244,98,25,135,78,79,28,29,54,122,126,37,33,53,59,246,118,46,93,26,119,65,23]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g,c,b,S,D,t,a,i,n,o,u,d,I,A,C,T,W,$,H,Z,ne,se,ue,ce,X,q,B,z,K,ee){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var oe;(function(Y){Y[Y.NONE=0]="NONE",Y[Y.NAVIGATING=1]="NAVIGATING",Y[Y.READY=2]="READY"})(oe||(oe={}));let le=e.CodeWindow=class at extends k.Disposable{get id(){return this.k}get win(){return this.l}get lastFocusTime(){return this.m}get isSandboxed(){return this.n}get backupPath(){return this.r?.backupPath}get openedWorkspace(){return this.r?.workspace}get profile(){if(!this.config)return;const O=this.Q.profiles.find(P=>P.id===this.config?.profiles.profile.id);return this.isExtensionDevelopmentHost&&O?O:this.Q.getProfileForWorkspace(this.config.workspace??(0,C.toWorkspaceIdentifier)(this.backupPath,this.isExtensionDevelopmentHost))??this.Q.defaultProfile}get remoteAuthority(){return this.r?.remoteAuthority}get config(){return this.r}get isExtensionDevelopmentHost(){return!!this.r?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.r?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.r?.debugId}constructor(O,P,F,N,j,U,V,G,re,ae,ye,Ce,Ae,Me,Fe,ve,we,Pe,_,he,fe){super(),this.M=P,this.N=F,this.O=N,this.P=j,this.Q=U,this.R=V,this.S=G,this.U=re,this.W=ae,this.X=ye,this.Y=Ce,this.Z=Ae,this.ab=Me,this.bb=Fe,this.db=ve,this.eb=we,this.fb=Pe,this.gb=_,this.hb=he,this.ib=fe,this.c=this.B(new R.Emitter),this.onWillLoad=this.c.event,this.f=this.B(new R.Emitter),this.onDidSignalReady=this.f.event,this.g=this.B(new R.Emitter),this.onDidTriggerSystemContextMenu=this.g.event,this.h=this.B(new R.Emitter),this.onDidClose=this.h.event,this.j=this.B(new R.Emitter),this.onDidDestroy=this.j.event,this.m=-1,this.n=!1,this.u=void 0,this.v=void 0,this.C=!1,this.D=[],this.F=[],this.G=void 0,this.H=void 0,this.I=this.B(this.fb.createIPCObjectUrl()),this.L=!1,this.jb=0;let Ee=!1;{const[ke,Oe]=this.ub(O.state);this.s=ke,this.M.trace("window#ctor: using window state",ke);const We=this.s.mode===0||this.s.mode===3;typeof at.b>"u"&&(at.b=this.hb.getItem("window.experimental.useSandbox",!1));const He=this.W.getValue("window");typeof He?.experimental?.useSandbox=="boolean"?Ee=He.experimental.useSandbox:this.eb.quality==="stable"&&at.b?Ee=!0:Ee=this.eb.quality!=="stable",this.n=Ee;const Ne={width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y,backgroundColor:this.X.getBackgroundColor(),minWidth:I.WindowMinimumSize.WIDTH,minHeight:I.WindowMinimumSize.HEIGHT,show:!We,title:this.eb.nameLong,webPreferences:{preload:h.FileAccess.asFileUri("vs/base/parts/sandbox/electron-sandbox/preload.js").fsPath,additionalArguments:[`--vscode-window-config=${this.I.resource.toString()}`],v8CacheOptions:this.O.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,zoomFactor:(0,I.zoomLevelToZoomFactor)(He?.zoomLevel),autoplayPolicy:"user-gesture-required",enableBlinkFeatures:"HighlightAPI",...Ee?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}},experimentalDarkMode:!0};m.isLinux?Ne.icon=(0,l.join)(this.O.appRoot,"resources/linux/code.png"):m.isWindows&&!this.O.isBuilt&&(Ne.icon=(0,l.join)(this.O.appRoot,"resources/win32/code_150x150.png")),m.isMacintosh&&!this.Bb()&&(Ne.fullscreenable=!1),m.isMacintosh&&(Ne.acceptFirstMouse=!0,He?.clickThroughInactive===!1&&(Ne.acceptFirstMouse=!1));const ze=m.isMacintosh&&He?.nativeTabs===!0;ze&&(Ne.tabbingIdentifier=this.eb.nameShort);const qe=(0,I.getTitleBarStyle)(this.W)==="custom";if(qe&&(Ne.titleBarStyle="hidden",m.isMacintosh||(Ne.frame=!1),(0,I.useWindowControlsOverlay)(this.W))){const Ue=this.X.getWindowSplash()?.colorInfo.titleBarBackground??this.X.getBackgroundColor(),J=$.Color.fromHex(Ue).isDarker()?"#FFFFFF":"#000000";Ne.titleBarOverlay={height:29,color:Ue,symbolColor:J},this.C=!0}if((0,p.mark)("code/willCreateCodeBrowserWindow"),this.l=new E.BrowserWindow(Ne),(0,p.mark)("code/didCreateCodeBrowserWindow"),this.k=this.l.id,m.isMacintosh&&qe&&this.l.setSheetOffset(22),qe&&(m.isWindows&&(0,I.useWindowControlsOverlay)(this.W)||m.isMacintosh)){const Ue=this.hb.getItem(at.a);Ue&&this.updateWindowControls({height:Ue})}m.isWindows&&qe&&this.l.hookWindowMessage(278,()=>{const[J,de]=this.l.getPosition(),ge=E.screen.getCursorScreenPoint(),me=ge.x-J,Se=ge.y-de;return(()=>!(me>30&&Se>=0&&Se<=Math.max(this.l.getBounds().height*.15,35)))()||(this.l.setEnabled(!1),this.l.setEnabled(!0),this.g.fire({x:me,y:Se})),0}),(m.isMacintosh||m.isWindows)&&Oe&&(!ze||E.BrowserWindow.getAllWindows().length===1)&&[this.s.width,this.s.height,this.s.x,this.s.y].every(Ue=>typeof Ue=="number")&&this.l.setBounds({width:this.s.width,height:this.s.height,x:this.s.x,y:this.s.y}),We&&((0,p.mark)("code/willMaximizeCodeWindow"),this.l.maximize(),this.s.mode===3&&this.xb(!0),this.l.show(),(0,p.mark)("code/didMaximizeCodeWindow")),this.m=Date.now()}this.O.args["open-devtools"]===!0&&this.l.webContents.openDevTools(),this.rb(),this.Fb(),this.kb(Ee)}setRepresentedFilename(O){m.isMacintosh?this.l.setRepresentedFilename(O):this.w=O}getRepresentedFilename(){return m.isMacintosh?this.l.getRepresentedFilename():this.w}setDocumentEdited(O){m.isMacintosh&&this.l.setDocumentEdited(O),this.z=O}isDocumentEdited(){return m.isMacintosh?this.l.isDocumentEdited():!!this.z}focus(O){m.isMacintosh&&O?.force&&E.app.focus({steal:!0}),this.l&&(this.l.isMinimized()&&this.l.restore(),this.l.focus())}setReady(){for(this.M.trace(`window#load: window reported ready (id: ${this.k})`),this.jb=2;this.D.length;)this.D.pop()(this);this.f.fire()}ready(){return new Promise(O=>{if(this.isReady)return O(this);this.D.push(O)})}get isReady(){return this.jb===2}get whenClosedOrLoaded(){return new Promise(O=>{function P(){F.dispose(),N.dispose(),O()}const F=this.onDidClose(()=>P()),N=this.onWillLoad(()=>P())})}kb(O){this.l.on("unresponsive",()=>this.nb(1,{sandboxed:O})),this.l.webContents.on("render-process-gone",(F,N)=>this.nb(2,{...N,sandboxed:O})),this.l.webContents.on("did-fail-load",(F,N,j)=>this.nb(3,{reason:j,exitCode:N,sandboxed:O})),this.l.webContents.on("will-prevent-unload",F=>{F.preventDefault()}),this.l.on("closed",()=>{this.h.fire(),this.dispose()}),this.l.webContents.on("did-finish-load",()=>{this.J&&(this.r=this.J,this.J=void 0)}),this.l.on("focus",()=>{this.m=Date.now()}),this.l.on("maximize",F=>{this.r&&(this.r.maximized=!0),E.app.emit("browser-window-maximize",F,this.l)}),this.l.on("unmaximize",F=>{this.r&&(this.r.maximized=!1),E.app.emit("browser-window-unmaximize",F,this.l)}),this.l.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",s.CancellationToken.None),this.v?.complete(),this.v=void 0}),this.l.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",s.CancellationToken.None),this.v?.complete(),this.v=void 0}),this.B(this.W.onDidChangeConfiguration(F=>this.rb(F))),this.B(this.Y.onDidDeleteUntitledWorkspace(F=>this.qb(F)));const P=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this.l.webContents.session.webRequest.onBeforeSendHeaders({urls:P},async(F,N)=>{const j=await this.mb();N({cancel:!1,requestHeaders:Object.assign(F.requestHeaders,j)})})}mb(){return this.lb||(this.lb=(0,i.resolveMarketplaceHeaders)(this.eb.version,this.eb,this.O,this.W,this.R,this.S,this.ab)),this.lb}async nb(O,P){switch(O){case 2:this.M.error(`CodeWindow: renderer process gone (reason: ${P?.reason||"<unknown>"}, code: ${P?.exitCode||"<unknown>"})`);break;case 1:this.M.error("CodeWindow: detected unresponsive");break;case 3:this.M.error(`CodeWindow: failed to load (reason: ${P?.reason||"<unknown>"}, code: ${P?.exitCode||"<unknown>"})`);break}switch(this.ab.publicLog2("windowerror",{type:O,reason:P?.reason,code:P?.exitCode,sandboxed:P?.sandboxed?"1":"0"}),O){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.db.kill(1);return}if(this.O.args["enable-smoke-test-driver"]){await this.pb(!1,!1),this.db.quit();return}if(O===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this.l&&this.l.webContents&&this.l.webContents.isDevToolsOpened())return;const{response:F,checkboxChecked:N}=await this.bb.showMessageBox({type:"warning",buttons:[(0,f.localize)(0,null),(0,f.localize)(1,null),(0,f.localize)(2,null)],message:(0,f.localize)(3,null),detail:(0,f.localize)(4,null),checkboxLabel:this.r?.workspace?(0,f.localize)(5,null):void 0},this.l);if(F!==2){const j=F===0;await this.pb(j,N)}}else if(O===2)if(m.isWindows&&P?.reason==="launch-failed"&&P.exitCode===18&&await this.ib.isAdmin(void 0))await this.ob(P);else{let F;P?F=(0,f.localize)(7,null,P.reason,P.exitCode??"<unknown>"):F=(0,f.localize)(6,null);const{response:N,checkboxChecked:j}=await this.bb.showMessageBox({type:"warning",buttons:[this.r?.workspace?(0,f.localize)(8,null):(0,f.localize)(9,null),(0,f.localize)(10,null)],message:F,detail:this.r?.workspace?(0,f.localize)(11,null):(0,f.localize)(12,null),checkboxLabel:this.r?.workspace?(0,f.localize)(13,null):void 0},this.l),U=N===0;await this.pb(U,j)}break}}async ob(O){const P=[],F=(0,X.isInternalTelemetry)(this.eb,this.W);if((0,X.supportsTelemetry)(this.eb,this.O)){this.eb.aiConfig&&this.eb.aiConfig.ariaKey&&P.push(new ue.OneDataSystemAppender(F,"monacoworkbench",null,this.eb.aiConfig.ariaKey));const j=await(0,z.resolveMachineId)(this.hb,this.M),U={appenders:P,sendErrorTelemetry:!1,commonProperties:(0,q.resolveCommonProperties)((0,B.release)(),(0,B.hostname)(),process.arch,this.eb.commit,this.eb.version,j,F),piiPaths:(0,X.getPiiPathsFromEnvironment)(this.O)};await new ce.TelemetryService(U,this.W,this.eb).publicLog2("windowadminerror",{reason:O.reason,code:O.exitCode})}const{response:N}=await this.bb.showMessageBox({type:"error",buttons:[(0,f.localize)(14,null),(0,f.localize)(15,null)],message:(0,f.localize)(16,null),detail:(0,f.localize)(17,null,this.eb.nameLong)},this.l);N===0&&await this.ib.openExternal(void 0,"https://go.microsoft.com/fwlink/?linkid=2220179"),await Promise.all(P.map(j=>j.flush())),await this.pb(!1,!1)}async pb(O,P){const F=this.r?.workspace;if(P&&F)try{const N=this.U.workspaceStorage(F);await N.init(),N.delete("memento/workbench.parts.editor"),await N.close()}catch(N){this.M.error(N)}if(this.j.fire(),this.l?.destroy(),O&&this.r){let N,j;(0,C.isSingleFolderWorkspaceIdentifier)(F)?N={folderUri:F.uri}:(0,C.isWorkspaceIdentifier)(F)?N={workspaceUri:F.configPath}:j=!0,(0,ee.firstOrDefault)(await this.gb.open({context:5,userEnv:this.r.userEnv,cli:{...this.O.args,_:[]},urisToOpen:N?[N]:void 0,forceEmpty:j,forceNewWindow:!0,remoteAuthority:this.remoteAuthority}))?.focus()}}qb(O){this.r?.workspace?.id===O.id&&(this.r.workspace=void 0)}rb(O){if(!O||O.affectsConfiguration("window.menuBarVisibility")){const P=this.Cb();P!==this.t&&(this.t=P,this.Db(P))}if(!O||O.affectsConfiguration("http.proxy")){let P=(this.W.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;P?.endsWith("/")&&(P=P.substr(0,P.length-1));const F=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((P||"").indexOf("@")===-1&&(P!==this.G||F!==this.H)){this.G=P,this.H=F;const N=P||"",j=F?`${F},<local>`:"<local>";this.M.trace(`Setting proxy to '${N}', bypassing '${j}'`),this.l.webContents.session.setProxy({proxyRules:N,proxyBypassRules:j,pacScript:""})}}}addTabbedWindow(O){m.isMacintosh&&O.win&&this.l.addTabbedWindow(O.win)}load(O,P=Object.create(null)){this.M.trace(`window#load: attempt to load window (id: ${this.k})`),this.isDocumentEdited()&&(!P.isReload||!this.Z.isHotExitEnabled())&&this.setDocumentEdited(!1),P.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this.l.setTitle(this.eb.nameLong)),this.sb(O,P),this.jb===0?this.r=O:this.J=O,this.jb=1,this.l.loadURL(h.FileAccess.asBrowserUri(`vs/code/electron-sandbox/workbench/workbench${this.O.isBuilt?"":"-dev"}.html`).toString(!0));const F=this.L;this.L=!0,!this.O.isBuilt&&!this.O.extensionTestsLocationURI&&this.B(new M.RunOnceScheduler(()=>{this.l&&!this.l.isVisible()&&!this.l.isMinimized()&&(this.l.show(),this.focus({force:!0}),this.l.webContents.openDevTools())},1e4)).schedule(),this.c.fire({workspace:O.workspace,reason:P.isReload?3:F?2:1})}sb(O,P){const F=(this.r??this.J)?.userEnv;if(F){const N=(0,c.isLaunchedFromCli)(F)&&!(0,c.isLaunchedFromCli)(O.userEnv),j=this.isExtensionDevelopmentHost;(N||j)&&(O.userEnv={...F,...O.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(O.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),P.disableExtensions!==void 0&&(O["disable-extensions"]=P.disableExtensions),O.fullscreen=this.isFullScreen,O.maximized=this.l.isMaximized(),O.partsSplash=this.X.getWindowSplash(),(0,p.mark)("code/willOpenNewWindow"),O.perfMarks=(0,p.getMarks)(),this.I.update(O)}async reload(O){const P=Object.assign({},this.r);P.workspace=await this.tb(P),delete P.filesToOpenOrCreate,delete P.filesToDiff,delete P.filesToMerge,delete P.filesToWait,this.isExtensionDevelopmentHost&&O&&(P.verbose=O.verbose,P.debugId=O.debugId,P.extensionEnvironment=O.extensionEnvironment,P["inspect-extensions"]=O["inspect-extensions"],P["inspect-brk-extensions"]=O["inspect-brk-extensions"],P["extensions-dir"]=O["extensions-dir"]),P.accessibilitySupport=E.app.isAccessibilitySupportEnabled(),P.isInitialStartup=!1,P.policiesData=this.P.serialize(),P.continueOn=this.O.continueOn,P.profiles={all:this.Q.profiles,profile:this.profile||this.Q.defaultProfile,home:this.Q.profilesHome},P.logLevel=this.N.getLogLevel(),P.loggers={window:this.N.getRegisteredLoggers(this.id),global:this.N.getRegisteredLoggers()},this.load(P,{isReload:!0,disableExtensions:O?.["disable-extensions"]})}async tb(O){if((0,C.isWorkspaceIdentifier)(O.workspace)){const P=O.workspace.configPath;if(P.scheme===h.Schemas.file&&!await this.R.exists(P))return}else if((0,C.isSingleFolderWorkspaceIdentifier)(O.workspace)){const P=O.workspace.uri;if(P.scheme===h.Schemas.file&&!await this.R.exists(P))return}return O.workspace}serializeWindowState(){if(!this.l)return(0,W.defaultWindowState)();if(this.isFullScreen){let F;try{F=E.screen.getDisplayMatching(this.getBounds())}catch{}const N=(0,W.defaultWindowState)();return{mode:3,display:F?F.id:void 0,width:this.s.width||N.width,height:this.s.height||N.height,x:this.s.x||0,y:this.s.y||0}}const O=Object.create(null);let P;if(!m.isMacintosh&&this.l.isMaximized()?P=0:P=1,P===0?O.mode=0:O.mode=1,P===1||P===0){let F;P===1?F=this.getBounds():F=this.l.getNormalBounds(),O.x=F.x,O.y=F.y,O.width=F.width,O.height=F.height}return O}updateWindowControls(O){if(O.height&&this.hb.setItem(at.a,O.height),m.isWindows&&this.C)this.l.setTitleBarOverlay({color:O.backgroundColor?.trim()===""?void 0:O.backgroundColor,symbolColor:O.foregroundColor?.trim()===""?void 0:O.foregroundColor,height:O.height?O.height-1:void 0});else if(m.isMacintosh&&O.height!==void 0){const P=(O.height-15)/2;this.l.setTrafficLightPosition({x:P,y:P})}}ub(O){(0,p.mark)("code/willRestoreCodeWindowState");let P=!1;if(O)try{const F=E.screen.getAllDisplays();P=F.length>1,O=this.vb(O,F)}catch(F){this.M.warn(`Unexpected error validating window state: ${F}
${F.stack}`)}return(0,p.mark)("code/didRestoreCodeWindowState"),[O||(0,W.defaultWindowState)(),P]}vb(O,P){if(this.M.trace(`window#validateWindowState: validating window state on ${P.length} display(s)`,O),typeof O.x!="number"||typeof O.y!="number"||typeof O.width!="number"||typeof O.height!="number"){this.M.trace("window#validateWindowState: unexpected type of state values");return}if(O.width<=0||O.height<=0){this.M.trace("window#validateWindowState: unexpected negative values");return}if(P.length===1){const j=this.wb(P[0]);if(j){let U=function(){!O||typeof O.x!="number"||typeof O.y!="number"||!j||(O.x<j.x&&(O.x=j.x),O.y<j.y&&(O.y=j.y))};this.M.trace("window#validateWindowState: 1 monitor working area",j),U(),O.width>j.width&&(O.width=j.width),O.height>j.height&&(O.height=j.height),O.x>j.x+j.width-128&&(O.x=j.x+j.width-O.width),O.y>j.y+j.height-128&&(O.y=j.y+j.height-O.height),U()}return O}if(O.display&&O.mode===3){const j=P.find(U=>U.id===O.display);if(j&&typeof j.bounds?.x=="number"&&typeof j.bounds?.y=="number"){this.M.trace("window#validateWindowState: restoring fullscreen to previous display");const U=(0,W.defaultWindowState)(3);return U.x=j.bounds.x,U.y=j.bounds.y,U}}let F,N;try{F=E.screen.getDisplayMatching({x:O.x,y:O.y,width:O.width,height:O.height}),N=this.wb(F)}catch{}if(F&&N&&O.x+O.width>N.x&&O.y+O.height>N.y&&O.x<N.x+N.width&&O.y<N.y+N.height)return this.M.trace("window#validateWindowState: multi-monitor working area",N),O}wb(O){if(O.workArea.width>0&&O.workArea.height>0)return O.workArea;if(O.bounds.width>0&&O.bounds.height>0)return O.bounds}getBounds(){const[O,P]=this.l.getPosition(),[F,N]=this.l.getSize();return{x:O,y:P,width:F,height:N}}toggleFullScreen(){this.xb(!this.isFullScreen)}xb(O){this.Bb()?this.yb(O):this.Ab(O),this.sendWhenReady(O?"vscode:enterFullScreen":"vscode:leaveFullScreen",s.CancellationToken.None),this.t&&this.Db(this.t,!1)}get isFullScreen(){return m.isMacintosh&&typeof this.u=="boolean"?this.u:this.l.isFullScreen()||this.l.isSimpleFullScreen()}yb(O){this.l.isSimpleFullScreen()&&this.l.setSimpleFullScreen(!1),this.zb(O)}zb(O){m.isMacintosh&&(this.u=O,this.v=new M.DeferredPromise,Promise.race([this.v.p,(0,M.timeout)(1e3)]).finally(()=>this.u=void 0)),this.l.setFullScreen(O)}Ab(O){this.l.isFullScreen()&&this.zb(!1),this.l.setSimpleFullScreen(O),this.l.webContents.focus()}Bb(){const O=this.W.getValue("window");return!O||typeof O.nativeFullScreen!="boolean"||O.nativeTabs?!0:O.nativeFullScreen!==!1}isMinimized(){return this.l.isMinimized()}Cb(){let O=(0,I.getMenuBarVisibility)(this.W);return["visible","toggle","hidden"].indexOf(O)<0&&(O="classic"),O}Db(O,P=!0){m.isMacintosh||(O==="toggle"&&P&&this.send("vscode:showInfoMessage",(0,f.localize)(18,null)),O==="hidden"?setTimeout(()=>{this.Eb(O)}):this.Eb(O))}Eb(O){const P=this.isFullScreen;switch(O){case"classic":this.l.setMenuBarVisibility(!P),this.l.autoHideMenuBar=P;break;case"visible":this.l.setMenuBarVisibility(!0),this.l.autoHideMenuBar=!1;break;case"toggle":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!0;break;case"hidden":this.l.setMenuBarVisibility(!1),this.l.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(m.isMacintosh)switch(E.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this.l.minimize();break;case"None":break;case"Maximize":default:this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}else this.l.isMaximized()?this.l.unmaximize():this.l.maximize()}close(){this.l?.close()}sendWhenReady(O,P,...F){this.isReady?this.send(O,...F):this.ready().then(()=>{P.isCancellationRequested||this.send(O,...F)})}send(O,...P){if(this.l){if(this.l.isDestroyed()||this.l.webContents.isDestroyed()){this.M.warn(`Sending IPC message to channel '${O}' for window that is destroyed`);return}try{this.l.webContents.send(O,...P)}catch(F){this.M.warn(`Error sending IPC message to channel '${O}' of window ${this.k}: ${(0,L.toErrorMessage)(F)}`)}}}updateTouchBar(O){m.isMacintosh&&this.F.forEach((P,F)=>{const N=O[F];P.segments=this.Hb(N)})}Fb(){if(m.isMacintosh){for(let O=0;O<10;O++){const P=this.Gb();this.F.push(P)}this.l.setTouchBar(new E.TouchBar({items:this.F}))}}Gb(O=[]){const P=this.Hb(O),F=new E.TouchBar.TouchBarSegmentedControl({segments:P,mode:"buttons",segmentStyle:"automatic",change:N=>{this.sendWhenReady("vscode:runAction",s.CancellationToken.None,{id:F.segments[N].id,from:"touchbar"})}});return F}Hb(O=[]){return O.map(F=>{let N;F.icon&&!u.ThemeIcon.isThemeIcon(F.icon)&&F.icon?.dark?.scheme===h.Schemas.file&&(N=E.nativeImage.createFromPath(v.URI.revive(F.icon.dark).fsPath),N.isEmpty()&&(N=void 0));let j;return typeof F.title=="string"?j=F.title:j=F.title.value,{id:F.id,label:N?void 0:j,icon:N}})}dispose(){super.dispose(),this.N.deregisterLoggers(this.id),this.l=null}};le.a="windowControlHeight",le.b=void 0,e.CodeWindow=le=be([Q(1,D.ILogService),Q(2,K.ILoggerMainService),Q(3,g.IEnvironmentMainService),Q(4,H.IPolicyService),Q(5,ne.IUserDataProfilesMainService),Q(6,b.IFileService),Q(7,n.IApplicationStorageMainService),Q(8,n.IStorageMainService),Q(9,w.IConfigurationService),Q(10,d.IThemeMainService),Q(11,T.IWorkspacesManagementMainService),Q(12,y.IBackupMainService),Q(13,o.ITelemetryService),Q(14,r.IDialogMainService),Q(15,S.ILifecycleMainService),Q(16,t.IProductService),Q(17,a.IProtocolMainService),Q(18,A.IWindowsMainService),Q(19,Z.IStateService),Q(20,se.INativeHostMainService)],le)}),define(te[81],ie([0,1,14,23,7,4,44,2,15,3,18,8,24,187,6,20,5,98,95,29,54,35]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g,c,b,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,y.createDecorator)("workspacesHistoryMainService");let t=e.WorkspacesHistoryMainService=class it extends k.Disposable{constructor(i,n,o,u){super(),this.f=i,this.g=n,this.h=o,this.j=u,this.c=this.B(new L.Emitter),this.onDidChangeRecentlyOpened=this.c.event,this.z=this.B(new s.ThrottledDelayer(800)),this.k()}k(){this.h.when(4).then(()=>this.C()),this.B(this.g.onDidEnterWorkspace(i=>this.addRecentlyOpened([{workspace:i.workspace,remoteAuthority:i.window.remoteAuthority}])))}async addRecentlyOpened(i){let n=[],o=[];for(const d of i)if((0,c.isRecentWorkspace)(d))!this.g.isUntitledWorkspace(d.workspace)&&!this.r(n,d.workspace)&&n.push(d);else if((0,c.isRecentFolder)(d))this.s(n,d.folderUri)||n.push(d);else{const I=this.t(o,d.fileUri),A=d.fileUri.scheme===h.Schemas.file&&it.y.indexOf((0,p.basename)(d.fileUri))>=0;!I&&!A&&(o.push(d),l.isWindows&&d.fileUri.scheme===h.Schemas.file&&E.app.addRecentDocument(d.fileUri.fsPath))}const u=await this.l({workspaces:n,files:o});n=u.workspaces,o=u.files,n.length>it.a&&(n.length=it.a),o.length>it.a&&(o.length=it.a),await this.n({workspaces:n,files:o}),this.c.fire(),l.isMacintosh&&this.z.trigger(()=>this.H())}async removeRecentlyOpened(i){const n=I=>{const A=this.p(I);for(const C of i)if(p.extUriBiasedIgnorePathCase.isEqual(C,A))return!1;return!0},o=await this.getRecentlyOpened(),u=o.workspaces.filter(n),d=o.files.filter(n);(u.length!==o.workspaces.length||d.length!==o.files.length)&&(await this.n({files:d,workspaces:u}),this.c.fire(),l.isMacintosh&&this.z.trigger(()=>this.H()))}async clearRecentlyOpened(){await this.n({workspaces:[],files:[]}),E.app.clearRecentDocuments(),this.c.fire()}async getRecentlyOpened(){return this.l()}async l(i){const n=new D.ResourceMap(d=>p.extUriBiasedIgnorePathCase.getComparisonKey(d));if(i?.workspaces)for(const d of i.workspaces)n.set(this.p(d),d);const o=new D.ResourceMap(d=>p.extUriBiasedIgnorePathCase.getComparisonKey(d));if(i?.files)for(const d of i.files)o.set(this.p(d),d);const u=await this.m();for(const d of u.workspaces){const I=n.get(this.p(d));I?I.label=I.label??d.label:n.set(this.p(d),d)}for(const d of u.files){const I=o.get(this.p(d));I?I.label=I.label??d.label:o.set(this.p(d),d)}return{workspaces:[...n.values()],files:[...o.values()]}}async m(){await this.j.whenReady;let i;const n=this.j.get(it.b,-1);if(typeof n=="string")try{i=JSON.parse(n)}catch(o){this.f.error("Unexpected error parsing opened paths list",o)}return(0,c.restoreRecentlyOpened)(i,this.f)}async n(i){await this.j.whenReady,this.j.store(it.b,JSON.stringify((0,c.toStoreData)(i)),-1,1)}p(i){return(0,c.isRecentFolder)(i)?i.folderUri:(0,c.isRecentFile)(i)?i.fileUri:i.workspace.configPath}r(i,n){return!!i.find(o=>(0,c.isRecentWorkspace)(o)&&o.workspace.id===n.id)}s(i,n){return!!i.find(o=>(0,c.isRecentFolder)(o)&&p.extUriBiasedIgnorePathCase.isEqual(o.folderUri,n))}t(i,n){return!!i.find(o=>p.extUriBiasedIgnorePathCase.isEqual(o.fileUri,n))}async C(){l.isWindows&&(await this.D(),this.B(this.onDidChangeRecentlyOpened(()=>this.D())))}async D(){if(!l.isWindows)return;const i=[];if(i.push({type:"tasks",items:[{type:"task",title:(0,f.localize)(0,null),description:(0,f.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),(await this.getRecentlyOpened()).workspaces.length>0){const n=[];for(const d of E.app.getJumpListSettings().removedItems){const I=d.args;if(I){const A=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(I);A&&n.push(m.URI.parse(A[2]))}}await this.removeRecentlyOpened(n);let o=!1;const u=(0,M.coalesce)((await this.getRecentlyOpened()).workspaces.slice(0,it.w).map(d=>{const I=(0,c.isRecentWorkspace)(d)?d.workspace:d.folderUri,{title:A,description:C}=this.F(I,d.label);let T;return m.URI.isUri(I)?T=`--folder-uri "${I.toString()}"`:(o=!0,T=`--file-uri "${I.configPath.toString()}"`),{type:"task",title:A.substr(0,255),description:C.substr(0,255),program:process.execPath,args:T,iconPath:"explorer.exe",iconIndex:0}}));u.length>0&&i.push({type:"custom",name:o?(0,f.localize)(2,null):(0,f.localize)(3,null),items:u})}i.push({type:"recent"});try{const n=E.app.setJumpList(i);n&&n!=="ok"&&this.f.warn(`updateWindowsJumpList#setJumpList unexpected result: ${n}`)}catch(n){this.f.warn("updateWindowsJumpList#setJumpList",n)}}F(i,n){if(n)return{title:(0,R.splitName)(n).name,description:n};if(m.URI.isUri(i))return{title:(0,p.basename)(i),description:this.G(i)};if(this.g.isUntitledWorkspace(i))return{title:(0,f.localize)(4,null),description:""};let o=(0,p.basename)(i.configPath);return o.endsWith(b.WORKSPACE_EXTENSION)&&(o=o.substr(0,o.length-b.WORKSPACE_EXTENSION.length-1)),{title:(0,f.localize)(5,null,o),description:this.G(i.configPath)}}G(i){return i.scheme==="file"?(0,R.normalizeDriveLetter)(i.fsPath):i.toString()}async H(){if(!l.isMacintosh)return;E.app.clearRecentDocuments();const i=await this.getRecentlyOpened(),n=[];let o=0;for(let d=0;d<i.workspaces.length&&o<it.u;d++){const I=this.p(i.workspaces[d]);if(I.scheme===h.Schemas.file){const A=(0,p.originalFSPath)(I);await v.Promises.exists(A)&&(n.push(A),o++)}}const u=[];for(let d=0;d<i.files.length&&o<it.v;d++){const I=this.p(i.files[d]);if(I.scheme===h.Schemas.file){const A=(0,p.originalFSPath)(I);if(it.y.includes((0,p.basename)(I))||n.includes(A))continue;await v.Promises.exists(A)&&(u.push(A),o++)}}u.reverse().forEach(d=>E.app.addRecentDocument(d)),n.reverse().forEach(d=>E.app.addRecentDocument(d))}};t.a=500,t.b="history.recentlyOpenedPathsList",t.u=7,t.v=10,t.w=7,t.y=["COMMIT_EDITMSG","MERGE_MSG"],e.WorkspacesHistoryMainService=t=be([Q(0,r.ILogService),Q(1,S.IWorkspacesManagementMainService),Q(2,w.ILifecycleMainService),Q(3,g.IApplicationStorageMainService)],t)}),define(te[287],ie([0,1,14,7,22,44,3,8,177,19,30,20,5,226,59,21,33,25,47,79,28,81]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g,c,b,S,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const t="menu";let a=e.Menubar=class bt{constructor(o,u,d,I,A,C,T,W,$,H,Z){this.n=o,this.o=u,this.p=d,this.q=I,this.r=A,this.s=C,this.t=T,this.u=W,this.v=$,this.w=H,this.x=Z,this.m=Object.create(null),this.g=new M.RunOnceScheduler(()=>this.E(),0),this.h=new M.RunOnceScheduler(()=>{this.j=[]},1e4),this.k=Object.create(null),this.l=Object.create(null),(R.isMacintosh||(0,b.getTitleBarStyle)(this.o)==="native")&&this.y(),this.z(),this.d=!1,this.f=!1,this.j=[],this.H(),this.A()}y(){const o=this.t.getItem(bt.a);o&&(o.menus&&(this.k=o.menus),o.keybindings&&(this.l=o.keybindings))}z(){this.m["workbench.action.files.newUntitledFile"]=(C,T,W)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.newWindow"]=(C,T,W)=>this.p.openEmptyWindow({context:2,contextWindowId:T?.id}),this.m["workbench.action.files.openFileFolder"]=(C,T,W)=>this.w.pickFileFolderAndOpen(void 0,{forceNewWindow:this.P(W),telemetryExtraData:{from:t}}),this.m["workbench.action.files.openFolder"]=(C,T,W)=>this.w.pickFolderAndOpen(void 0,{forceNewWindow:this.P(W),telemetryExtraData:{from:t}}),this.m["workbench.action.openWorkspace"]=(C,T,W)=>this.w.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.P(W),telemetryExtraData:{from:t}}),this.m["workbench.action.clearRecentFiles"]=()=>this.s.clearRecentlyOpened();const o=this.x.twitterUrl;o&&(this.m["workbench.action.openTwitterUrl"]=()=>this.Z(o,"openTwitterUrl"));const u=this.x.requestFeatureUrl;u&&(this.m["workbench.action.openRequestFeatureUrl"]=()=>this.Z(u,"openUserVoiceUrl"));const d=this.x.reportIssueUrl;d&&(this.m["workbench.action.openIssueReporter"]=()=>this.Z(d,"openReportIssues"));const I=this.x.licenseUrl;I&&(this.m["workbench.action.openLicenseUrl"]=()=>{if(R.language){const C=I.indexOf("?")>0?"&":"?";this.Z(`${I}${C}lang=${R.language}`,"openLicenseUrl")}else this.Z(I,"openLicenseUrl")});const A=this.x.privacyStatementUrl;A&&I&&(this.m["workbench.action.openPrivacyStatementUrl"]=()=>{this.Z(A,"openPrivacyStatement")})}A(){this.u.onWillShutdown(()=>this.b=!0),this.p.onDidChangeWindowsCount(o=>this.F(o)),this.w.onDidBlurWindow(()=>this.G()),this.w.onDidFocusWindow(()=>this.G())}get B(){const o=this.o.getValue("window.enableMenuBarMnemonics");return typeof o!="boolean"?!0:o}get C(){if(!R.isMacintosh)return!1;const o=this.o.getValue("window.nativeTabs");return typeof o!="boolean"?!1:o}updateMenu(o,u){this.k=o.menus,this.l=o.keybindings,this.t.setItem(bt.a,o),this.D()}D(){this.g.schedule()}E(){this.b||setTimeout(()=>{this.b||this.H()},10)}F(o){R.isMacintosh&&(o.oldCount===0&&o.newCount>0||o.oldCount>0&&o.newCount===0)&&(this.d=o.newCount===0,this.D())}G(){R.isMacintosh&&(this.f=!E.BrowserWindow.getFocusedWindow(),this.D())}H(){const o=E.Menu.getApplicationMenu();if(o&&this.j.push(o),Object.keys(this.k).length===0){E.Menu.setApplicationMenu(R.isMacintosh?new E.Menu:null);return}const u=new E.Menu;let d;if(R.isMacintosh){const A=new E.Menu;d=new E.MenuItem({label:this.x.nameShort,submenu:A}),this.I(A),u.append(d)}if(R.isMacintosh&&!this.c){this.c=!0;const A=new E.Menu;A.append(new E.MenuItem({label:this.bb(h.localize(0,null)),click:()=>this.p.openEmptyWindow({context:1})})),E.app.dock.setMenu(A)}if(this.K("File")){const A=new E.Menu,C=new E.MenuItem({label:this.bb(h.localize(1,null)),submenu:A});this.M(A,"File"),u.append(C)}if(this.K("Edit")){const A=new E.Menu,C=new E.MenuItem({label:this.bb(h.localize(2,null)),submenu:A});this.M(A,"Edit"),u.append(C)}if(this.K("Selection")){const A=new E.Menu,C=new E.MenuItem({label:this.bb(h.localize(3,null)),submenu:A});this.M(A,"Selection"),u.append(C)}if(this.K("View")){const A=new E.Menu,C=new E.MenuItem({label:this.bb(h.localize(4,null)),submenu:A});this.M(A,"View"),u.append(C)}if(this.K("Go")){const A=new E.Menu,C=new E.MenuItem({label:this.bb(h.localize(5,null)),submenu:A});this.M(A,"Go"),u.append(C)}if(this.K("Run")){const A=new E.Menu,C=new E.MenuItem({label:this.bb(h.localize(6,null)),submenu:A});this.M(A,"Run"),u.append(C)}if(this.K("Terminal")){const A=new E.Menu,C=new E.MenuItem({label:this.bb(h.localize(7,null)),submenu:A});this.M(A,"Terminal"),u.append(C)}let I;if(this.K("Window")){const A=new E.Menu;I=new E.MenuItem({label:this.bb(h.localize(8,null)),submenu:A,role:"window"}),this.S(A)}if(I&&u.append(I),this.K("Help")){const A=new E.Menu,C=new E.MenuItem({label:this.bb(h.localize(9,null)),submenu:A,role:"help"});this.M(A,"Help"),u.append(C)}u.items&&u.items.length>0?E.Menu.setApplicationMenu(u):E.Menu.setApplicationMenu(null),this.h.schedule()}I(o){const u=this.U(h.localize(10,null,this.x.nameLong),"workbench.action.showAboutDialog"),d=this.T();let I;if(this.K("Preferences")){const ne=new E.Menu;this.M(ne,"Preferences"),I=new E.MenuItem({label:this.bb(h.localize(11,null)),submenu:ne})}const A=new E.Menu,C=new E.MenuItem({label:h.localize(12,null),role:"services",submenu:A}),T=new E.MenuItem({label:h.localize(13,null,this.x.nameLong),role:"hide",accelerator:"Command+H"}),W=new E.MenuItem({label:h.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),$=new E.MenuItem({label:h.localize(15,null),role:"unhide"}),H=new E.MenuItem(this.Y("workbench.action.quit",{label:h.localize(16,null,this.x.nameLong),click:async(ne,se,ue)=>{const ce=this.p.getLastActiveWindow();(this.p.getWindowCount()===0||E.BrowserWindow.getFocusedWindow()||ce?.isMinimized())&&await this.J(ue)&&this.w.quit(void 0)}})),Z=[u];Z.push(...d),I&&Z.push(i(),I),Z.push(i(),C,i(),T,W,$,i(),H),Z.forEach(ne=>o.append(ne))}async J(o){if(this.p.getWindowCount()===0)return!0;const u=this.o.getValue("window.confirmBeforeClose");if(u==="always"||u==="keyboardOnly"&&this.Q(o)){const{response:d}=await this.w.showMessageBox(this.p.getFocusedWindow()?.id,{type:"question",buttons:[h.localize(17,null),h.localize(18,null)],message:h.localize(19,null)});return d===0}return!0}K(o){if(!R.isMacintosh&&(0,b.getTitleBarStyle)(this.o)==="custom")return!1;switch(o){case"File":case"Help":if(R.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k&&!!this.k[o];case"Window":if(R.isMacintosh)return this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f||!!this.k;default:return this.p.getWindowCount()>0&&!!this.k&&!!this.k[o]}}L(o,u){u.forEach(d=>{if((0,f.isMenubarMenuItemSeparator)(d))o.append(i());else if((0,f.isMenubarMenuItemSubmenu)(d)){const I=new E.Menu,A=new E.MenuItem({label:this.bb(d.label),submenu:I});this.L(I,d.submenu.items),o.append(A)}else(0,f.isMenubarMenuItemRecentAction)(d)?o.append(this.O(d)):(0,f.isMenubarMenuItemAction)(d)&&(d.id==="workbench.action.showAboutDialog"&&this.N(o),R.isMacintosh?this.p.getWindowCount()===0&&this.d||this.p.getWindowCount()>0&&this.f?this.m[d.id]?o.append(new E.MenuItem(this.Y(d.id,{label:this.bb(d.label),click:this.m[d.id]}))):o.append(this.U(d.label,d.id,!1,d.checked)):o.append(this.U(d.label,d.id,d.enabled!==!1,!!d.checked)):o.append(this.U(d.label,d.id,d.enabled!==!1,!!d.checked)))})}M(o,u){this.k&&this.k[u]&&this.L(o,this.k[u].items)}N(o){const u=this.T();u.length&&(u.forEach(d=>o.append(d)),o.append(i()))}O(o){const u=k.URI.revive(o.uri),d=o.id,I=d==="openRecentFile"?{fileUri:u}:d==="openRecentWorkspace"?{workspaceUri:u}:{folderUri:u};return new E.MenuItem(this.Y(d,{label:o.label,click:async(A,C,T)=>{const W=this.P(T);(await this.p.open({context:2,cli:this.q.args,urisToOpen:[I],forceNewWindow:W,gotoLineMode:!1,remoteAuthority:o.remoteAuthority})).length>0||await this.s.removeRecentlyOpened([u])}},!1))}P(o){return!!(o&&(!R.isMacintosh&&(o.ctrlKey||o.shiftKey)||R.isMacintosh&&(o.metaKey||o.altKey)))}Q(o){return!!(o.triggeredByAccelerator||o.altKey||o.ctrlKey||o.metaKey||o.shiftKey)}R(o,u,d){const I={label:this.bb(o),role:d,enabled:!0};return new E.MenuItem(this.X(u,I))}S(o){const u=new E.MenuItem({label:h.localize(20,null),role:"minimize",accelerator:"Command+M",enabled:this.p.getWindowCount()>0}),d=new E.MenuItem({label:h.localize(21,null),role:"zoom",enabled:this.p.getWindowCount()>0}),I=new E.MenuItem({label:h.localize(22,null),role:"front",enabled:this.p.getWindowCount()>0}),A=this.U(h.localize(23,null),"workbench.action.switchWindow"),C=[];this.C&&(C.push(i()),C.push(this.U(h.localize(24,null),"workbench.action.newWindowTab")),C.push(this.R(h.localize(25,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),C.push(this.R(h.localize(26,null),"workbench.action.showNextWindowTab","selectNextTab")),C.push(this.R(h.localize(27,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),C.push(this.R(h.localize(28,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[u,d,i(),A,...C,i(),I].forEach(T=>o.append(T))}T(){switch(this.n.state.type){case"uninitialized":return[];case"idle":return[new E.MenuItem({label:this.bb(h.localize(29,null)),click:()=>setTimeout(()=>{this.ab("CheckForUpdate"),this.n.checkForUpdates(!0)},0)})];case"checking for updates":return[new E.MenuItem({label:h.localize(30,null),enabled:!1})];case"available for download":return[new E.MenuItem({label:this.bb(h.localize(31,null)),click:()=>{this.n.downloadUpdate()}})];case"downloading":return[new E.MenuItem({label:h.localize(32,null),enabled:!1})];case"downloaded":return[new E.MenuItem({label:this.bb(h.localize(33,null)),click:()=>{this.ab("InstallUpdate"),this.n.applyUpdate()}})];case"updating":return[new E.MenuItem({label:h.localize(34,null),enabled:!1})];case"ready":return[new E.MenuItem({label:this.bb(h.localize(35,null)),click:()=>{this.ab("RestartToUpdate"),this.n.quitAndInstall()}})]}}U(o,u,d,I){const A=this.bb(o),C=typeof u=="function"?u:(Z,ne,se)=>{const ue=Z?Z.userSettingsLabel:null;let ce=u;Array.isArray(u)&&(ce=this.P(se)?u[1]:u[0]),ue&&se.triggeredByAccelerator?this.W({type:"keybinding",userSettingsLabel:ue}):this.W({type:"commandId",commandId:ce})},T=typeof d=="boolean"?d:this.p.getWindowCount()>0,W=typeof I=="boolean"?I:!1,$={label:A,click:C,enabled:T};W&&($.type="checkbox",$.checked=W);let H;return typeof u=="string"?H=u:Array.isArray(u)&&(H=u[0]),R.isMacintosh&&(H==="editor.action.clipboardCutAction"?$.role="cut":H==="editor.action.clipboardCopyAction"?$.role="copy":H==="editor.action.clipboardPasteAction"&&($.role="paste"),H==="undo"?$.click=this.V(C,{inDevTools:Z=>Z.undo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("undo:")}):H==="redo"?$.click=this.V(C,{inDevTools:Z=>Z.redo(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("redo:")}):H==="editor.action.selectAll"&&($.click=this.V(C,{inDevTools:Z=>Z.selectAll(),inNoWindow:()=>E.Menu.sendActionToFirstResponder("selectAll:")}))),new E.MenuItem(this.X(H,$))}V(o,u){return(d,I,A)=>{const C=E.BrowserWindow.getFocusedWindow();if(!C)return u.inNoWindow();if(C.webContents.isDevToolsFocused()&&C.webContents.devToolsWebContents)return u.inDevTools(C.webContents.devToolsWebContents);o(d,I||C,A)}}W(o){let u=E.BrowserWindow.getFocusedWindow();if(!u){const I=this.p.getLastActiveWindow();I?.isMinimized()&&(u=I.win)}const d=u?this.p.getWindowById(u.id):void 0;if(d){if(this.v.trace("menubar#runActionInRenderer",o),R.isMacintosh&&!this.q.isBuilt&&!d.isReady&&(o.type==="commandId"&&o.commandId==="workbench.action.toggleDevTools"||o.type!=="commandId"&&o.userSettingsLabel==="alt+cmd+i"))return;if(o.type==="commandId"){const I={id:o.commandId,from:"menu"};d.sendWhenReady("vscode:runAction",s.CancellationToken.None,I)}else{const I={userSettingsLabel:o.userSettingsLabel};d.sendWhenReady("vscode:runKeybinding",s.CancellationToken.None,I)}}else this.v.trace("menubar#runActionInRenderer: no active window found",o)}X(o,u){const d=typeof o=="string"?this.l[o]:void 0;if(d?.label){if(d.isNative!==!1)u.accelerator=d.label,u.userSettingsLabel=d.userSettingsLabel;else if(typeof u.label=="string"){const I=u.label.indexOf("[");I>=0?u.label=`${u.label.substr(0,I)} [${d.label}]`:u.label=`${u.label} [${d.label}]`}}else u.accelerator=void 0;return u}Y(o,u,d=!u.accelerator){d&&(u=this.X(o,u));const I=u.click;return u.click=(A,C,T)=>{this.ab(o),I?.(A,C,T)},u}Z(o,u){this.w.openExternal(void 0,o),this.ab(u)}ab(o){this.r.publicLog2("workbenchActionExecuted",{id:o,from:t})}bb(o){return(0,L.mnemonicMenuLabel)(o,!this.B)}};a.a="lastKnownMenubarData",e.Menubar=a=be([Q(0,c.IUpdateService),Q(1,l.IConfigurationService),Q(2,S.IWindowsMainService),Q(3,p.IEnvironmentMainService),Q(4,g.ITelemetryService),Q(5,D.IWorkspacesHistoryMainService),Q(6,r.IStateService),Q(7,m.ILifecycleMainService),Q(8,v.ILogService),Q(9,y.INativeHostMainService),Q(10,w.IProductService)],a);function i(){return new E.MenuItem({type:"separator"})}}),define(te[288],ie([0,1,6,20,5,287]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,E.createDecorator)("menubarMainService");let R=e.MenubarMainService=class{constructor(h,l,p){this.b=h,this.c=l,this.d=p,this.a=this.e()}async e(){return await this.c.when(3),this.b.createInstance(L.Menubar)}async updateMenubar(h,l){this.d.trace("menubarService#updateMenubar",h),(await this.a).updateMenu(l,h)}};e.MenubarMainService=R=be([Q(0,E.IInstantiationService),Q(1,M.ILifecycleMainService),Q(2,s.ILogService)],R)}),define(te[289],ie([0,1,14,24,87,26,23,22,4,32,48,44,2,15,9,64,3,36,18,11,8,185,63,19,58,30,16,6,20,5,76,77,57,33,79,286,124,282,29,96,81,54,78,37,53,65]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g,c,b,S,D,t,a,i,n,o,u,d,I,A,C,T,W,$,H,Z,ne,se,ue,ce,X,q,B,z,K){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function ee(Y){return(0,se.isWorkspaceIdentifier)(Y?.workspace)}function oe(Y){return(0,se.isSingleFolderWorkspaceIdentifier)(Y?.workspace)}let le=e.WindowsMainService=class ct extends v.Disposable{constructor(O,P,F,N,j,U,V,G,re,ae,ye,Ce,Ae,Me,Fe,ve,we,Pe){super(),this.k=O,this.l=P,this.m=F,this.n=N,this.r=j,this.s=U,this.t=V,this.u=G,this.v=re,this.w=ae,this.z=ye,this.C=Ce,this.D=Ae,this.F=Me,this.G=Fe,this.H=ve,this.I=we,this.J=Pe,this.b=this.B(new h.Emitter),this.onDidOpenWindow=this.b.event,this.c=this.B(new h.Emitter),this.onDidSignalReadyWindow=this.c.event,this.f=this.B(new h.Emitter),this.onDidDestroyWindow=this.f.event,this.g=this.B(new h.Emitter),this.onDidChangeWindowsCount=this.g.event,this.h=this.B(new h.Emitter),this.onDidTriggerSystemContextMenu=this.h.event,this.j=this.B(new ne.WindowsStateHandler(this,this.r,this.v,this.m,this.z)),this.L()}L(){this.B(this.D.onDidEnterWorkspace(O=>this.c.fire(O.window))),this.B(this.onDidSignalReadyWindow(O=>{if(O.config?.extensionDevelopmentPath||O.config?.extensionTestsPath){const P=new v.DisposableStore;if(P.add(h.Event.any(O.onDidClose,O.onDidDestroy)(()=>P.dispose())),O.config.extensionDevelopmentPath)for(const F of O.config.extensionDevelopmentPath)P.add(this.I.addValidFileRoot(F));O.config.extensionTestsPath&&P.add(this.I.addValidFileRoot(O.config.extensionTestsPath))}}))}openEmptyWindow(O,P){const F=this.t.args,N=P?.remoteAuthority||void 0,j=!0,U=P?.forceReuseWindow,V=!U;return this.open({...O,cli:F,forceEmpty:j,forceNewWindow:V,forceReuseWindow:U,remoteAuthority:N})}openExistingWindow(O,P){O.focus(),this.M(P,[O])}async open(O){this.m.trace("windowsManager#open"),O.addMode&&(O.initialStartup||!this.getLastActiveWindow())&&(O.addMode=!1);const P=[],F=[],N=[],j=[],U=[];let V,G=0;const re=await this.S(O);this.m.trace("windowsManager#open pathsToOpen",re);for(const Me of re)oe(Me)?O.addMode?P.push(Me):F.push(Me):ee(Me)?N.push(Me):Me.fileUri?(V||(V={filesToOpenOrCreate:[],filesToDiff:[],filesToMerge:[],remoteAuthority:Me.remoteAuthority}),V.filesToOpenOrCreate.push(Me)):Me.backupPath?U.push({backupFolder:(0,y.basename)(Me.backupPath),remoteAuthority:Me.remoteAuthority}):G++;O.diffMode&&V&&V.filesToOpenOrCreate.length>=2&&(V.filesToDiff=V.filesToOpenOrCreate.slice(0,2),V.filesToOpenOrCreate=[]),O.mergeMode&&V&&V.filesToOpenOrCreate.length===4&&(V.filesToMerge=V.filesToOpenOrCreate.slice(0,4),V.filesToOpenOrCreate=[],V.filesToDiff=[]),V&&O.waitMarkerFileURI&&(V.filesToWait={paths:(0,R.coalesce)([...V.filesToDiff,V.filesToMerge[3],...V.filesToOpenOrCreate]),waitMarkerFileUri:O.waitMarkerFileURI}),O.initialStartup?(j.push(...this.D.getUntitledWorkspaces()),N.push(...j),U.push(...this.w.getEmptyWindowBackups())):U.length=0;const{windows:ae,filesOpenedInWindow:ye}=await this.N(O,N,F,U,G,V,P);if(this.m.trace(`windowsManager#open used window count ${ae.length} (workspacesToOpen: ${N.length}, foldersToOpen: ${F.length}, emptyToRestore: ${U.length}, emptyToOpen: ${G})`),ae.length>1)if(ye)ye.focus();else{const Me=this.j.state.lastActiveWindow&&!O.forceEmpty&&!O.cli._.length&&!O.cli["file-uri"]&&!O.cli["folder-uri"]&&!(O.urisToOpen&&O.urisToOpen.length);let Fe=!0,ve=!0;if(Me){const we=ae.filter(Pe=>this.j.state.lastActiveWindow&&Pe.backupPath===this.j.state.lastActiveWindow.backupPath);we.length&&(we[0].focus(),Fe=!1,ve=!1)}if(Fe)for(let we=ae.length-1;we>=0;we--){const Pe=ae[we];if(!(Pe.openedWorkspace&&j.some(_=>Pe.openedWorkspace&&_.workspace.id===Pe.openedWorkspace.id)||Pe.backupPath&&U.some(_=>Pe.backupPath&&_.backupFolder===(0,y.basename)(Pe.backupPath)))){Pe.focus(),ve=!1;break}}ve&&ae[ae.length-1].focus()}const Ce=V&&V.filesToDiff.length>0,Ae=V&&V.filesToMerge.length>0;if(!ae.some(Me=>Me.isExtensionDevelopmentHost)&&!Ce&&!Ae&&!O.noRecentEntry){const Me=[];for(const Fe of re)ee(Fe)&&!Fe.transient?Me.push({label:Fe.label,workspace:Fe.workspace,remoteAuthority:Fe.remoteAuthority}):oe(Fe)?Me.push({label:Fe.label,folderUri:Fe.workspace.uri,remoteAuthority:Fe.remoteAuthority}):Fe.fileUri&&Me.push({label:Fe.label,fileUri:Fe.fileUri,remoteAuthority:Fe.remoteAuthority});this.C.addRecentlyOpened(Me)}return this.M(O,ae),ae}M(O,P){const F=O.waitMarkerFileURI;O.context===0&&F&&P.length===1&&P[0]&&(async()=>{await P[0].whenClosedOrLoaded;try{await this.H.del(F)}catch{}})()}async N(O,P,F,N,j,U,V){const G=[];let re;function ae(we,Pe){G.push(we),Pe&&(re=we,U=void 0)}let{openFolderInNewWindow:ye,openFilesInNewWindow:Ce}=this.gb(O);if(!O.initialStartup&&V.length>0){const we=V[0].remoteAuthority,Pe=this.lb(we);Pe&&ae(this.P(Pe,V.map(_=>_.workspace.uri)))}const Ae=F.length+P.length+N.length;if(U&&Ae===0){const we=U.filesToOpenOrCreate[0]||U.filesToDiff[0]||U.filesToMerge[3],Pe=this.getWindows().filter(he=>U&&(0,c.isEqualAuthority)(he.remoteAuthority,U.remoteAuthority));let _;we?.fileUri&&!Ce&&((O.context===4||O.context===0||O.context===1)&&(_=await(0,Z.findWindowOnFile)(Pe,we.fileUri,async he=>he.configPath.scheme===f.Schemas.file?this.D.resolveLocalWorkspace(he.configPath):void 0)),_||(_=this.mb(Pe))),_?(0,se.isWorkspaceIdentifier)(_.openedWorkspace)?P.push({workspace:_.openedWorkspace,remoteAuthority:_.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(_.openedWorkspace)?F.push({workspace:_.openedWorkspace,remoteAuthority:_.remoteAuthority}):ae(this.O(O,_,U),!0):ae(await this.hb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,filesToOpen:U,forceNewWindow:!0,remoteAuthority:U.remoteAuthority,forceNewTabbedWindow:O.forceNewTabbedWindow,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile}),!0)}const Me=(0,R.distinct)(P,we=>we.workspace.id);if(Me.length>0){const we=(0,R.coalesce)(Me.map(Pe=>(0,Z.findWindowOnWorkspaceOrFolder)(this.getWindows(),Pe.workspace.configPath)));if(we.length>0){const Pe=we[0],_=(0,c.isEqualAuthority)(U?.remoteAuthority,Pe.remoteAuthority)?U:void 0;ae(this.O(O,Pe,_),!!_),ye=!0}for(const Pe of Me){if(we.some(fe=>fe.openedWorkspace&&fe.openedWorkspace.id===Pe.workspace.id))continue;const _=Pe.remoteAuthority,he=(0,c.isEqualAuthority)(U?.remoteAuthority,_)?U:void 0;ae(await this.R(O,Pe,ye,he),!!he),ye=!0}}const Fe=(0,R.distinct)(F,we=>c.extUriBiasedIgnorePathCase.getComparisonKey(we.workspace.uri));if(Fe.length>0){const we=(0,R.coalesce)(Fe.map(Pe=>(0,Z.findWindowOnWorkspaceOrFolder)(this.getWindows(),Pe.workspace.uri)));if(we.length>0){const Pe=we[0],_=(0,c.isEqualAuthority)(U?.remoteAuthority,Pe.remoteAuthority)?U:void 0;ae(this.O(O,Pe,_),!!_),ye=!0}for(const Pe of Fe){if(we.some(fe=>(0,se.isSingleFolderWorkspaceIdentifier)(fe.openedWorkspace)&&c.extUriBiasedIgnorePathCase.isEqual(fe.openedWorkspace.uri,Pe.workspace.uri)))continue;const _=Pe.remoteAuthority,he=(0,c.isEqualAuthority)(U?.remoteAuthority,_)?U:void 0;ae(await this.R(O,Pe,ye,he),!!he),ye=!0}}const ve=(0,R.distinct)(N,we=>we.backupFolder);if(ve.length>0)for(const we of ve){const Pe=we.remoteAuthority,_=(0,c.isEqualAuthority)(U?.remoteAuthority,Pe)?U:void 0;ae(await this.Q(O,!0,Pe,_,we),!!_),ye=!0}if(G.length===0||U){U&&!j&&j++;const we=U?U.remoteAuthority:O.remoteAuthority;for(let Pe=0;Pe<j;Pe++)ae(await this.Q(O,ye,we,U),!!U),ye=!0}return{windows:(0,R.distinct)(G),filesOpenedInWindow:re}}O(O,P,F){this.m.trace("windowsManager#doOpenFilesInExistingWindow",{filesToOpen:F}),P.focus();const N={filesToOpenOrCreate:F?.filesToOpenOrCreate,filesToDiff:F?.filesToDiff,filesToMerge:F?.filesToMerge,filesToWait:F?.filesToWait,termProgram:O?.userEnv?.TERM_PROGRAM};return P.sendWhenReady("vscode:openFiles",k.CancellationToken.None,N),P}P(O,P){this.m.trace("windowsManager#doAddFoldersToExistingWindow",{foldersToAdd:P}),O.focus();const F={foldersToAdd:P};return O.sendWhenReady("vscode:addFolders",k.CancellationToken.None,F),O}Q(O,P,F,N,j){this.m.trace("windowsManager#doOpenEmpty",{restore:!!j,remoteAuthority:F,filesToOpen:N,forceNewWindow:P});let U;return!P&&typeof O.contextWindowId=="number"&&(U=this.getWindowById(O.contextWindowId)),this.hb({userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:F,forceNewWindow:P,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:N,windowToUse:U,emptyWindowBackupInfo:j,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}R(O,P,F,N,j){return this.m.trace("windowsManager#doOpenFolderOrWorkspace",{folderOrWorkspace:P,filesToOpen:N}),!F&&!j&&typeof O.contextWindowId=="number"&&(j=this.getWindowById(O.contextWindowId)),this.hb({workspace:P.workspace,userEnv:O.userEnv,cli:O.cli,initialStartup:O.initialStartup,remoteAuthority:P.remoteAuthority,forceNewWindow:F,forceNewTabbedWindow:O.forceNewTabbedWindow,filesToOpen:N,windowToUse:j,forceProfile:O.forceProfile,forceTempProfile:O.forceTempProfile})}async S(O){let P,F=!1,N=!1;if(O.urisToOpen&&O.urisToOpen.length>0?(P=await this.U(O),F=!0):O.forceEmpty?P=[Object.create(null)]:O.cli._.length||O.cli["folder-uri"]||O.cli["file-uri"]?(P=await this.W(O.cli),P.length===0&&P.push(Object.create(null)),F=!0):(P=await this.Y(),P.length===0&&P.push(Object.create(null)),N=!0),!O.addMode&&F){const j=P.filter(U=>oe(U));if(j.length>1){const U=j[0].remoteAuthority;if(j.every(V=>(0,c.isEqualAuthority)(V.remoteAuthority,U))){const V=await this.D.createUntitledWorkspace(j.map(G=>({uri:G.workspace.uri})));P.push({workspace:V,remoteAuthority:U}),P=P.filter(G=>!oe(G))}}}if(O.initialStartup&&!N&&this.z.getValue("window")?.restoreWindows==="preserve"){const j=await this.Y();P.unshift(...j.filter(U=>ee(U)||oe(U)||U.backupPath))}return P}async U(O){const P={gotoLineMode:O.gotoLineMode,remoteAuthority:O.remoteAuthority},F=await Promise.all((0,R.coalesce)(O.urisToOpen||[]).map(async N=>{const j=await this.ab(N,P);if(j)return j.label=N.label,j;const U=this.cb(N);this.G.showMessageBox({type:"info",buttons:[(0,D.localize)(0,null)],message:U.scheme===f.Schemas.file?(0,D.localize)(1,null):(0,D.localize)(2,null),detail:U.scheme===f.Schemas.file?(0,D.localize)(3,null,(0,m.getPathLabel)(U,{os:r.OS,tildify:this.t})):(0,D.localize)(4,null,U.toString(!0))},(0,b.withNullAsUndefined)(E.BrowserWindow.getFocusedWindow()))}));return(0,R.coalesce)(F)}async W(O){const P=[],F={ignoreFileNotFound:!0,gotoLineMode:O.goto,remoteAuthority:O.remote||void 0,forceOpenWorkspaceAsFile:O.diff&&O._.length===2||O.merge&&O._.length===4},N=O["folder-uri"];if(N){const V=await Promise.all(N.map(G=>{const re=this.X(G);if(re)return this.ab({folderUri:re},F)}));P.push(...(0,R.coalesce)(V))}const j=O["file-uri"];if(j){const V=await Promise.all(j.map(G=>{const re=this.X(G);if(re)return this.ab((0,se.hasWorkspaceFileExtension)(G)?{workspaceUri:re}:{fileUri:re},F)}));P.push(...(0,R.coalesce)(V))}const U=await Promise.all(O._.map(V=>F.remoteAuthority?this.fb(V,F):this.db(V,F)));return P.push(...(0,R.coalesce)(U)),P}X(O){try{const P=S.URI.parse(O);if(!P.scheme){this.m.error(`Invalid URI input string, scheme missing: ${O}`);return}return P}catch(P){this.m.error(`Invalid URI input string: ${O}, ${P.message}`)}}async Y(){const O=this.Z();switch(O){case"none":return[];case"one":case"all":case"preserve":case"folders":{const P=[];O!=="one"&&P.push(...this.j.state.openedWindows),this.j.state.lastActiveWindow&&P.push(this.j.state.lastActiveWindow);const F=await Promise.all(P.map(async N=>{if(N.workspace){const j=await this.ab({workspaceUri:N.workspace.configPath},{remoteAuthority:N.remoteAuthority,rejectTransientWorkspaces:!0});if(ee(j))return j}else if(N.folderUri){const j=await this.ab({folderUri:N.folderUri},{remoteAuthority:N.remoteAuthority});if(oe(j))return j}else if(O!=="folders"&&N.backupPath)return{backupPath:N.backupPath,remoteAuthority:N.remoteAuthority}}));return(0,R.coalesce)(F)}}}Z(){let O;return this.v.wasRestarted?O="all":(O=this.z.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(O)||(O="all")),O}async ab(O,P=Object.create(null)){const F=this.cb(O);return F.scheme===f.Schemas.file?((0,$.isFileToOpen)(O)&&(P={...P,forceOpenWorkspaceAsFile:!0}),this.db(F.fsPath,P)):this.bb(O,P)}bb(O,P){let F=this.cb(O);const N=(0,T.getRemoteAuthority)(F)||P.remoteAuthority;if(F=(0,c.removeTrailingPathSeparator)((0,c.normalizePath)(F)),(0,$.isFileToOpen)(O)){if(P.gotoLineMode){const{path:j,line:U,column:V}=(0,l.parseLineAndColumnAware)(F.path);return{fileUri:F.with({path:j}),options:{selection:U?{startLineNumber:U,startColumn:V||1}:void 0},remoteAuthority:N}}return{fileUri:F,remoteAuthority:N}}else if((0,$.isWorkspaceToOpen)(O))return{workspace:(0,ue.getWorkspaceIdentifier)(F),remoteAuthority:N};return{workspace:(0,ue.getSingleFolderWorkspaceIdentifier)(F),remoteAuthority:N}}cb(O){return(0,$.isWorkspaceToOpen)(O)?O.workspaceUri:(0,$.isFolderToOpen)(O)?O.folderUri:O.fileUri}async db(O,P,F){let N,j;P.gotoLineMode&&({path:O,line:N,column:j}=(0,l.parseLineAndColumnAware)(O)),O=(0,l.sanitizeFilePath)((0,y.normalize)(O),(0,g.cwd)());try{const U=await M.Promises.stat(O);if(U.isFile()){if(!P.forceOpenWorkspaceAsFile){const V=await this.D.resolveLocalWorkspace(S.URI.file(O));if(V)return V.transient&&P.rejectTransientWorkspaces?void 0:{workspace:{id:V.id,configPath:V.configPath},type:o.FileType.File,exists:!0,remoteAuthority:V.remoteAuthority,transient:V.transient}}return{fileUri:S.URI.file(O),type:o.FileType.File,exists:!0,options:{selection:N?{startLineNumber:N,startColumn:j||1}:void 0}}}else{if(U.isDirectory())return{workspace:(0,ue.getSingleFolderWorkspaceIdentifier)(S.URI.file(O),U),type:o.FileType.Directory,exists:!0};if(!r.isWindows&&O==="/dev/null")return{fileUri:S.URI.file(O),type:o.FileType.File,exists:!0}}}catch(U){if(U.code==="ERR_UNC_HOST_NOT_ALLOWED"&&!F)return this.eb(O,P);const V=S.URI.file(O);if(this.C.removeRecentlyOpened([V]),P.ignoreFileNotFound)return{fileUri:V,type:o.FileType.File,exists:!1}}}async eb(O,P){const F=S.URI.file(O),{response:N}=await this.G.showMessageBox({type:"warning",buttons:[(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],message:(0,D.localize)(8,null,F.authority),detail:(0,D.localize)(9,null,(0,m.getPathLabel)(F,{os:r.OS,tildify:this.t}))});if(N===0)return(0,s.addUNCHostToAllowlist)(F.authority),this.db(O,P,!0);N===2&&E.shell.openExternal("https://aka.ms/vscode-windows-unc")}fb(O,P){const F=O.charCodeAt(0),N=P.remoteAuthority;let j,U;P.gotoLineMode&&({path:O,line:j,column:U}=(0,l.parseLineAndColumnAware)(O)),F!==47&&((0,l.isWindowsDriveLetter)(F)&&O.charCodeAt(O.charCodeAt(1))===58&&(O=(0,l.toSlashes)(O)),O=`/${O}`);const V=S.URI.from({scheme:f.Schemas.vscodeRemote,authority:N,path:O});if(O.charCodeAt(O.length-1)!==47){if((0,se.hasWorkspaceFileExtension)(O))return P.forceOpenWorkspaceAsFile?{fileUri:V,options:{selection:j?{startLineNumber:j,startColumn:U||1}:void 0},remoteAuthority:P.remoteAuthority}:{workspace:(0,ue.getWorkspaceIdentifier)(V),remoteAuthority:N};if(P.gotoLineMode||y.posix.basename(O).indexOf(".")!==-1)return{fileUri:V,options:{selection:j?{startLineNumber:j,startColumn:U||1}:void 0},remoteAuthority:N}}return{workspace:(0,ue.getSingleFolderWorkspaceIdentifier)(V),remoteAuthority:N}}gb(O){const P=this.z.getValue("window"),F=P?.openFoldersInNewWindow||"default",N=P?.openFilesInNewWindow||"off";let j=(O.preferNewWindow||O.forceNewWindow)&&!O.forceReuseWindow;!O.forceNewWindow&&!O.forceReuseWindow&&(F==="on"||F==="off")&&(j=F==="on");let U=!1;return O.forceNewWindow||O.forceReuseWindow?U=!!O.forceNewWindow&&!O.forceReuseWindow:(r.isMacintosh?O.context===1&&(U=!0):O.context!==3&&O.context!==2&&!(O.userEnv&&O.userEnv.TERM_PROGRAM==="vscode")&&(U=!0),!O.cli.extensionDevelopmentPath&&(N==="on"||N==="off")&&(U=N==="on")),{openFolderInNewWindow:!!j,openFilesInNewWindow:U}}async openExtensionDevelopmentHostWindow(O,P){const F=(0,Z.findWindowOnExtensionDevelopmentPath)(this.getWindows(),O);if(F)return this.v.reload(F,P.cli),F.focus(),[F];let N=P.cli["folder-uri"]||[],j=P.cli["file-uri"]||[],U=P.cli._;if(!U.length&&!N.length&&!j.length&&!P.cli.extensionTestsPath){const re=this.j.state.lastPluginDevelopmentHostWindow,ae=re?.workspace??re?.folderUri;ae&&(S.URI.isUri(ae)?ae.scheme===f.Schemas.file?U=[ae.fsPath]:N=[ae.toString()]:ae.configPath.scheme===f.Schemas.file?U=[(0,c.originalFSPath)(ae.configPath)]:j=[ae.configPath.toString()])}let V=P.remoteAuthority;for(const re of O)if(re.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ae=S.URI.parse(re),ye=(0,T.getRemoteAuthority)(ae);ye&&(V?(0,c.isEqualAuthority)(ye,V)||this.m.error("more than one extension development path authority"):V=ye)}U=U.filter(re=>{const ae=S.URI.file(re);return(0,Z.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:(0,c.isEqualAuthority)((0,T.getRemoteAuthority)(ae),V)}),N=N.filter(re=>{const ae=this.X(re);return ae&&(0,Z.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,c.isEqualAuthority)((0,T.getRemoteAuthority)(ae),V):!1}),j=j.filter(re=>{const ae=this.X(re);return ae&&(0,Z.findWindowOnWorkspaceOrFolder)(this.getWindows(),ae)?!1:ae?(0,c.isEqualAuthority)((0,T.getRemoteAuthority)(ae),V):!1}),P.cli._=U,P.cli["folder-uri"]=N,P.cli["file-uri"]=j;const G={context:P.context,cli:P.cli,forceNewWindow:!0,forceEmpty:!U.length&&!N.length&&!j.length,userEnv:P.userEnv,noRecentEntry:!0,waitMarkerFileURI:P.waitMarkerFileURI,remoteAuthority:V,forceProfile:P.forceProfile,forceTempProfile:P.forceTempProfile};return this.open(G)}async hb(O){const P=this.z.getValue("window"),F=this.getLastActiveWindow(),N=F?.profile??this.u.defaultProfile;let j;!O.forceNewWindow&&!O.forceNewTabbedWindow&&(j=O.windowToUse||F,j&&j.focus());const U={...this.t.args,...O.cli,machineId:this.k,windowId:-1,mainPid:process.pid,appRoot:this.t.appRoot,execPath:process.execPath,codeCachePath:this.t.codeCachePath,backupPath:O.emptyWindowBackupInfo?(0,y.join)(this.t.backupHome,O.emptyWindowBackupInfo.backupFolder):void 0,profiles:{home:this.u.profilesHome,all:this.u.profiles,profile:N},homeDir:this.t.userHome.fsPath,tmpDir:this.t.tmpDir.fsPath,userDataDir:this.t.userDataPath,remoteAuthority:O.remoteAuthority,workspace:O.workspace,userEnv:{...this.l,...O.userEnv},filesToOpenOrCreate:O.filesToOpen?.filesToOpenOrCreate,filesToDiff:O.filesToOpen?.filesToDiff,filesToMerge:O.filesToOpen?.filesToMerge,filesToWait:O.filesToOpen?.filesToWait,logLevel:this.n.getLogLevel(),loggers:{window:[],global:this.n.getRegisteredLoggers()},logsPath:this.t.logsHome.fsPath,product:A.default,isInitialStartup:O.initialStartup,perfMarks:(0,w.getMarks)(),os:{release:(0,L.release)(),hostname:(0,L.hostname)()},zoomLevel:typeof P?.zoomLevel=="number"?P.zoomLevel:void 0,autoDetectHighContrast:P?.autoDetectHighContrast??!0,autoDetectColorScheme:P?.autoDetectColorScheme??!1,accessibilitySupport:E.app.accessibilitySupportEnabled,colorScheme:this.J.getColorScheme(),policiesData:this.s.serialize(),continueOn:this.t.continueOn};if(j){const V=j.config;!U.extensionDevelopmentPath&&V?.extensionDevelopmentPath&&(U.extensionDevelopmentPath=V.extensionDevelopmentPath,U.extensionDevelopmentKind=V.extensionDevelopmentKind,U["enable-proposed-api"]=V["enable-proposed-api"],U.verbose=V.verbose,U["inspect-extensions"]=V["inspect-extensions"],U["inspect-brk-extensions"]=V["inspect-brk-extensions"],U.debugId=V.debugId,U.extensionEnvironment=V.extensionEnvironment,U["extensions-dir"]=V["extensions-dir"],U["disable-extensions"]=V["disable-extensions"]),U.loggers={global:U.loggers.global,window:V?.loggers.window??U.loggers.window}}else{const V=this.j.getNewWindowState(U);(0,w.mark)("code/willCreateCodeWindow");const G=j=this.F.createInstance(H.CodeWindow,{state:V,extensionDevelopmentPath:U.extensionDevelopmentPath,isExtensionTestHost:!!U.extensionTestsPath});(0,w.mark)("code/didCreateCodeWindow"),O.forceNewTabbedWindow&&this.getLastActiveWindow()?.addTabbedWindow(G),ct.a.push(G),this.b.fire(G),this.g.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,p.once)(G.onDidSignalReady)(()=>this.c.fire(G)),(0,p.once)(G.onDidClose)(()=>this.kb(G)),(0,p.once)(G.onDidDestroy)(()=>this.f.fire(G)),G.onDidTriggerSystemContextMenu(({x:ae,y:ye})=>this.h.fire({window:G,x:ae,y:ye}));const re=(0,b.assertIsDefined)(G.win?.webContents);re.removeAllListeners("devtools-reload-page"),re.on("devtools-reload-page",()=>this.v.reload(G)),this.v.registerWindow(G)}return U.windowId=j.id,j.isReady?this.v.unload(j,4).then(async V=>{V||await this.ib(j,U,O,N)}):await this.ib(j,U,O,N),j}async ib(O,P,F,N){if(P.extensionDevelopmentPath||((0,se.isWorkspaceIdentifier)(P.workspace)?P.backupPath=this.w.registerWorkspaceBackup({workspace:P.workspace,remoteAuthority:P.remoteAuthority}):(0,se.isSingleFolderWorkspaceIdentifier)(P.workspace)?P.backupPath=this.w.registerFolderBackup({folderUri:P.workspace.uri,remoteAuthority:P.remoteAuthority}):P.backupPath=this.w.registerEmptyWindowBackup({backupFolder:F.emptyWindowBackupInfo?.backupFolder??(0,ue.createEmptyWorkspaceIdentifier)().id,remoteAuthority:P.remoteAuthority})),this.u.isEnabled()){const j=P.workspace??(0,se.toWorkspaceIdentifier)(P.backupPath,!1),U=this.jb(F,j,N),V=U instanceof Promise?await U:U;P.profiles.profile=V,P.extensionDevelopmentPath||await this.u.setProfileForWorkspace(j,V)}O.load(P)}jb(O,P,F){return O.forceProfile?this.u.profiles.find(N=>N.name===O.forceProfile)??this.u.createNamedProfile(O.forceProfile):O.forceTempProfile?this.u.createTransientProfile():this.u.getProfileForWorkspace(P)??F}kb(O){const P=ct.a.indexOf(O);ct.a.splice(P,1),this.g.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const O=E.BrowserWindow.getFocusedWindow();if(O)return this.getWindowById(O.id)}getLastActiveWindow(){return this.mb(this.getWindows())}lb(O){return this.mb(this.getWindows().filter(P=>(0,c.isEqualAuthority)(P.remoteAuthority,O)))}mb(O){const P=Math.max.apply(Math,O.map(F=>F.lastFocusTime));return O.find(F=>F.lastFocusTime===P)}sendToFocused(O,...P){(this.getFocusedWindow()||this.getLastActiveWindow())?.sendWhenReady(O,k.CancellationToken.None,...P)}sendToAll(O,P,F){for(const N of this.getWindows())F&&F.indexOf(N.id)>=0||N.sendWhenReady(O,k.CancellationToken.None,P)}getWindows(){return ct.a}getWindowCount(){return ct.a.length}getWindowById(O){const P=this.getWindows().filter(F=>F.id===O);return(0,R.firstOrDefault)(P)}getWindowByWebContents(O){const P=E.BrowserWindow.fromWebContents(O);if(P)return this.getWindowById(P.id)}};le.a=[],e.WindowsMainService=le=be([Q(2,I.ILogService),Q(3,K.ILoggerMainService),Q(4,W.IStateService),Q(5,B.IPolicyService),Q(6,n.IEnvironmentMainService),Q(7,z.IUserDataProfilesMainService),Q(8,d.ILifecycleMainService),Q(9,t.IBackupMainService),Q(10,a.IConfigurationService),Q(11,ce.IWorkspacesHistoryMainService),Q(12,X.IWorkspacesManagementMainService),Q(13,u.IInstantiationService),Q(14,i.IDialogMainService),Q(15,o.IFileService),Q(16,C.IProtocolMainService),Q(17,q.IThemeMainService)],le)}),define(te[290],ie([0,1,63,28,81,54]),function(x,e,E,M,s,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let R=e.WorkspacesMainService=class{constructor(h,l,p,m){this.a=h,this.b=l,this.c=p,this.d=m,this.onDidChangeRecentlyOpened=this.c.onDidChangeRecentlyOpened}async enterWorkspace(h,l){const p=this.b.getWindowById(h);if(p)return this.a.enterWorkspace(p,this.b.getWindows(),l)}createUntitledWorkspace(h,l,p){return this.a.createUntitledWorkspace(l,p)}deleteUntitledWorkspace(h,l){return this.a.deleteUntitledWorkspace(l)}getWorkspaceIdentifier(h,l){return this.a.getWorkspaceIdentifier(l)}getRecentlyOpened(h){return this.c.getRecentlyOpened()}addRecentlyOpened(h,l){return this.c.addRecentlyOpened(l)}removeRecentlyOpened(h,l){return this.c.removeRecentlyOpened(l)}clearRecentlyOpened(h){return this.c.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.d.getDirtyWorkspaces()}};e.WorkspacesMainService=R=be([Q(0,L.IWorkspacesManagementMainService),Q(1,M.IWindowsMainService),Q(2,s.IWorkspacesHistoryMainService),Q(3,E.IBackupMainService)],R)}),define(te[291],ie([0,1,14,87,42,26,17,49,13,32,48,43,44,2,15,9,3,11,8,31,140,45,154,155,257,158,63,270,19,74,194,88,125,58,109,216,30,62,115,205,230,206,279,111,207,208,16,220,91,73,6,90,214,283,271,259,20,5,288,59,21,57,280,92,33,262,98,93,25,243,118,46,47,249,276,284,277,285,121,251,252,253,255,260,28,289,261,29,95,81,290,54,258,37,228,53,238,52,80,123,264,278,267,7,119,263,223,65,89,281,254,23]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g,c,b,S,D,t,a,i,n,o,u,d,I,A,C,T,W,$,H,Z,ne,se,ue,ce,X,q,B,z,K,ee,oe,le,Y,O,P,F,N,j,U,V,G,re,ae,ye,Ce,Ae,Me,Fe,ve,we,Pe,_,he,fe,Ee,ke,Oe,We,He,Ne,ze,qe,Ue,J,de,ge,me,Se,Le,je,Ke,Ze,Ge,Ye,tt,ot,lt,Rt,mt,At,Mt,Lt,Ot,Tt,Ft,Wt,pt,Ut,Nt,Bt,jt,$t,wt,zt,St){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let Et=e.CodeApplication=class extends f.Disposable{constructor(De,Ie,pe,Te,Re,$e,Je,Qe,Be,Ve,xe){super(),this.c=De,this.f=Ie,this.g=pe,this.h=Te,this.i=Re,this.j=$e,this.k=Je,this.l=Qe,this.m=Be,this.n=Ve,this.p=xe,this.r(),this.s()}r(){const De=Be=>Be?.startsWith(`${y.Schemas.vscodeWebview}://`),Ie=new Set(["clipboard-read","clipboard-sanitized-write"]);E.session.defaultSession.setPermissionRequestHandler((Be,Ve,xe,Xe)=>De(Xe.requestingUrl)?xe(Ie.has(Ve)):xe(!1)),E.session.defaultSession.setPermissionCheckHandler((Be,Ve,xe,Xe)=>De(Xe.requestingUrl)?Ie.has(Ve):!1);const pe=new Set([y.Schemas.file,y.Schemas.vscodeFileResource,y.Schemas.vscodeRemoteResource,"devtools"]),Te=Be=>{for(let Ve=Be;Ve;Ve=Ve.parent)if(Ve.url.startsWith(`${y.Schemas.vscodeWebview}://`))return!0;return!1},Re=Be=>Be.resourceType==="xhr"||Te(Be.frame),$e=Be=>{const Ve=Be.frame;if(!Ve||!this.a)return!1;const xe=E.BrowserWindow.getAllWindows();for(const Xe of xe)if(Ve.processId===Xe.webContents.mainFrame.processId)return!0;return!1},Je=(Be,Ve)=>{if(Be.path!=="/index.html")return!0;const xe=Ve.frame;if(!xe||!this.a)return!1;for(const Xe of this.a.getWindows())if(Xe.win&&xe.processId===Xe.win.webContents.mainFrame.processId)return!0;return!1};E.session.defaultSession.webRequest.onBeforeRequest((Be,Ve)=>{const xe=c.URI.parse(Be.url);return xe.scheme===y.Schemas.vscodeWebview&&!Je(xe,Be)?(this.h.error("Blocked vscode-webview request",Be.url),Ve({cancel:!0})):xe.scheme===y.Schemas.vscodeFileResource&&!$e(Be)?(this.h.error("Blocked vscode-file request",Be.url),Ve({cancel:!0})):xe.path.endsWith(".svg")&&!pe.has(xe.scheme)?Ve({cancel:!Re(Be)}):Ve({cancel:!1})}),E.session.defaultSession.webRequest.onHeadersReceived((Be,Ve)=>{const xe=Be.responseHeaders,Xe=xe["content-type"]||xe["Content-Type"];if(Xe&&Array.isArray(Xe)){const _e=c.URI.parse(Be.url);if(_e.path.endsWith(".svg")&&pe.has(_e.scheme))return xe["Content-Type"]=["image/svg+xml"],Ve({cancel:!1,responseHeaders:xe});if(!_e.path.endsWith(y.Schemas.vscodeRemoteResource)&&Xe.some(rt=>rt.toLowerCase().includes("image/svg")))return Ve({cancel:!Re(Be)})}return Ve({cancel:!1})});const Qe=E.session.defaultSession;typeof Qe.setCodeCachePath=="function"&&this.i.codeCachePath&&Qe.setCodeCachePath((0,w.join)(this.i.codeCachePath,"chrome")),r.isWindows&&(0,M.setUNCHostAllowlist)((0,M.toUNCHostAllowlist)(this.k.getValue("security.allowedUNCHosts")))}s(){(0,h.setUnexpectedErrorHandler)(pe=>this.u(pe)),process.on("uncaughtException",pe=>(0,h.onUnexpectedError)(pe)),process.on("unhandledRejection",pe=>(0,h.onUnexpectedError)(pe)),this.j.onWillShutdown(()=>this.dispose()),(0,S.registerContextMenuListener)(),E.app.on("accessibility-support-changed",(pe,Te)=>{this.a?.sendToAll("vscode:accessibilitySupportChanged",Te)}),E.app.on("activate",async(pe,Te)=>{this.h.trace("app#activate"),Te||await this.a?.openEmptyWindow({context:1})}),E.app.on("web-contents-created",(pe,Te)=>{Te.on("will-navigate",Re=>{this.h.error("webContents#will-navigate: Prevented webcontent navigation"),Re.preventDefault()}),Te.setWindowOpenHandler(({url:Re})=>(this.b?.openExternal(void 0,Re),{action:"deny"}))});let De=[],Ie;E.app.on("open-file",(pe,Te)=>{this.h.trace("app#open-file: ",Te),pe.preventDefault(),De.push((0,Ke.hasWorkspaceFileExtension)(Te)?{workspaceUri:c.URI.file(Te)}:{fileUri:c.URI.file(Te)}),Ie!==void 0&&(clearTimeout(Ie),Ie=void 0),Ie=setTimeout(async()=>{await this.a?.open({context:1,cli:this.i.args,urisToOpen:De,gotoLineMode:!1,preferNewWindow:!0}),De=[],Ie=void 0},100)}),E.app.on("new-window-for-tab",async()=>{await this.a?.openEmptyWindow({context:4})}),s.validatedIpcMain.handle("vscode:fetchShellEnv",pe=>{const Te=this.a?.getWindowByWebContents(pe.sender);let Re,$e;return Te?.config?(Re=Te.config,$e={...process.env,...Te.config.userEnv}):(Re=this.i.args,$e=process.env),this.L(Re,$e,!1)}),s.validatedIpcMain.handle("vscode:writeNlsFile",(pe,Te,Re)=>{const $e=this.t([Te]);if(!$e||typeof Re!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.m.writeFile($e,R.VSBuffer.fromString(Re))}),s.validatedIpcMain.handle("vscode:readNlsFile",async(pe,...Te)=>{const Re=this.t(Te);if(!Re)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.m.readFile(Re)).value.toString()}),s.validatedIpcMain.on("vscode:toggleDevTools",pe=>pe.sender.toggleDevTools()),s.validatedIpcMain.on("vscode:openDevTools",pe=>pe.sender.openDevTools()),s.validatedIpcMain.on("vscode:reloadWindow",pe=>pe.sender.reload())}t(De){let Ie;for(const pe of De)typeof pe=="string"&&(typeof Ie!="string"?Ie=pe:Ie=(0,w.join)(Ie,pe));if(!(typeof Ie!="string"||!(0,w.isAbsolute)(Ie)||!(0,l.isEqualOrParent)(Ie,this.i.cachedLanguagesPath,!r.isLinux)))return c.URI.file(Ie)}u(De){if(De){const Ie={message:`[uncaught exception in main]: ${De.message}`,stack:De.stack};this.a?.sendToFocused("vscode:reportError",JSON.stringify(Ie))}this.h.error(`[uncaught exception in main]: ${De}`),De.stack&&this.h.error(De.stack)}async startup(){this.h.debug("Starting VS Code"),this.h.debug(`from: ${this.i.appRoot}`),this.h.debug("args:",this.i.args);const De=this.n.win32AppUserModelId;r.isWindows&&De&&E.app.setAppUserModelId(De);try{r.isMacintosh&&this.k.getValue("window.nativeTabs")===!0&&!E.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&E.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Be){this.h.error(Be)}const Ie=new t.Server;this.j.onWillShutdown(Be=>{Be.reason===2&&Ie.dispose()}),this.h.trace("Resolving machine identifier...");const pe=await(0,Ut.resolveMachineId)(this.l,this.h);this.h.trace(`Resolved machine identifier: ${pe}`);const{sharedProcessReady:Te,sharedProcessClient:Re}=this.D(pe),$e=await this.F(pe,Te);this.B($e.createInstance(i.ProxyAuthHandler)),this.B($e.createInstance(Ft.UserDataProfilesHandler)),$e.invokeFunction(Be=>this.G(Be,Ie,Re));const Je=$e.invokeFunction(Be=>this.v(Be,Ie));this.j.phase=2,await $e.invokeFunction(Be=>this.H(Be,Je)),this.j.phase=3,this.I(),this.B(new pt.RunOnceScheduler(()=>{this.B((0,pt.runWhenIdle)(()=>this.j.phase=4,2500))},2500)).schedule()}v(De,Ie){const pe=this.a=De.get(Se.IWindowsMainService),Te=De.get(qe.IURLService),Re=this.b=De.get(ae.INativeHostMainService),$e=this;Te.registerHandler({async handleURL(Xe,_e){return $e.C(pe,Te,Xe,_e)}});const Je=this.B(new je.ActiveWindowManager({onDidOpenWindow:Re.onDidOpenWindow,onDidFocusWindow:Re.onDidFocusWindow,getActiveWindowId:()=>Re.getActiveWindowId(-1)})),Qe=new D.StaticRouter(Xe=>Je.getActiveClientId().then(_e=>Xe===_e)),Be=new Ue.URLHandlerRouter(Qe,this.h),Ve=Ie.getChannel("urlHandler",Be);Te.registerHandler(new Ue.URLHandlerChannelClient(Ve));const xe=this.w();return this.B(new de.ElectronURLListener(xe?.urls,Te,pe,this.i,this.n,this.h)),xe}w(){const De=this.i.args["open-url"]?this.i.args._urls||[]:[];De.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from command line:",De);const Ie=global.getOpenUrls()||[];if(Ie.length>0&&this.h.trace("app#resolveInitialProtocolUrls() protocol urls from macOS 'open-url' event:",Ie),De.length+Ie.length===0)return;const pe=[];return{urls:[...De,...Ie].map(Re=>{try{return{uri:c.URI.parse(Re),originalUrl:Re}}catch{this.h.trace("app#resolveInitialProtocolUrls() protocol url failed to parse:",Re);return}}).filter(Re=>{if(!Re)return!1;if(this.y(Re.uri))return this.h.trace("app#resolveInitialProtocolUrls() protocol url was blocked:",Re.uri.toString(!0)),!1;const $e=this.z(Re.uri);return $e?(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be handled as window to open:",Re.uri.toString(!0),$e),pe.push($e),!1):(this.h.trace("app#resolveInitialProtocolUrls() protocol url will be passed to active window for handling:",Re.uri.toString(!0)),!0)}),openables:pe}}y(De){if(De.authority===y.Schemas.file&&r.isWindows){const{options:Ie,buttonIndeces:pe}=(0,$t.massageMessageBoxOptions)({type:"warning",buttons:[(0,n.localize)(0,null),(0,n.localize)(1,null)],message:(0,n.localize)(2,null,(0,v.getPathLabel)(De,{os:r.OS,tildify:this.i}),this.n.nameShort),detail:(0,n.localize)(3,null)},this.n);if(pe[E.dialog.showMessageBoxSync(Ie)]===1)return!0}return!1}z(De){if(De.path){if(De.authority===y.Schemas.file){const Ie=c.URI.file(De.fsPath);return(0,Ke.hasWorkspaceFileExtension)(Ie)?{workspaceUri:Ie}:{fileUri:Ie}}else if(De.authority===y.Schemas.vscodeRemote){const Ie=De.path.indexOf(w.posix.sep,1);if(Ie!==-1){const pe=De.path.substring(1,Ie),Te=De.path.substring(Ie),Re=c.URI.from({scheme:y.Schemas.vscodeRemote,authority:pe,path:Te,query:De.query,fragment:De.fragment});return(0,Ke.hasWorkspaceFileExtension)(Te)?{workspaceUri:Re}:/:[\d]+$/.test(Te)?{fileUri:Re}:{folderUri:Re}}}}}async C(De,Ie,pe,Te){if(this.h.trace("app#handleProtocolUrl():",pe.toString(!0),Te),pe.scheme===this.n.urlProtocol&&pe.path==="workspace"&&(pe=pe.with({authority:"file",path:c.URI.parse(pe.query).path,query:""})),this.y(pe))return this.h.trace("app#handleProtocolUrl() protocol url was blocked:",pe.toString(!0)),!0;let Re=!1;const $e=new URLSearchParams(pe.query);$e.get("windowId")==="_blank"?(this.h.trace("app#handleProtocolUrl() found 'windowId=_blank' as parameter, setting shouldOpenInNewWindow=true:",pe.toString(!0)),$e.delete("windowId"),pe=pe.with({query:$e.toString()}),Re=!0):r.isMacintosh&&De.getWindowCount()===0&&(this.h.trace("app#handleProtocolUrl() running on macOS with no window open, setting shouldOpenInNewWindow=true:",pe.toString(!0)),Re=!0);const Je=$e.get("continueOn");Je!==null&&(this.h.trace("app#handleProtocolUrl() found 'continueOn' as parameter:",pe.toString(!0)),$e.delete("continueOn"),pe=pe.with({query:$e.toString()}),this.i.continueOn=Je??void 0);const Qe=this.z(pe);return Qe?(this.h.trace("app#handleProtocolUrl() opening protocol url as window:",Qe,pe.toString(!0)),(0,St.firstOrDefault)(await De.open({context:5,cli:{...this.i.args},urisToOpen:[Qe],forceNewWindow:Re,gotoLineMode:!0}))?.focus(),!0):Re?(this.h.trace("app#handleProtocolUrl() opening empty window and passing in protocol url:",pe.toString(!0)),await(0,St.firstOrDefault)(await De.open({context:5,cli:{...this.i.args},forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,Ce.getRemoteAuthority)(pe)}))?.ready(),Ie.open(pe,Te)):(this.h.trace("app#handleProtocolUrl(): not handled",pe.toString(!0),Te),!1)}D(De){const Ie=this.B(this.g.createInstance(Ae.SharedProcess,De)),pe=(async()=>{this.h.trace("Main->SharedProcess#connect");const Re=await Ie.connect();return this.h.trace("Main->SharedProcess#connect: connection established"),new a.Client(Re,"main")})();return{sharedProcessReady:(async()=>(await Ie.whenReady(),pe))(),sharedProcessClient:pe}}async F(De,Ie){const pe=new P.ServiceCollection;switch(process.platform){case"win32":pe.set(ke.IUpdateService,new Y.SyncDescriptor(ze.Win32UpdateService));break;case"linux":r.isLinuxSnap?pe.set(ke.IUpdateService,new Y.SyncDescriptor(Ne.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(ke.IUpdateService,new Y.SyncDescriptor(He.LinuxUpdateService));break;case"darwin":pe.set(ke.IUpdateService,new Y.SyncDescriptor(We.DarwinUpdateService));break}pe.set(Se.IWindowsMainService,new Y.SyncDescriptor(Le.WindowsMainService,[De,this.f],!1));const Te=new W.DialogMainService(this.h,this.n);pe.set(W.IDialogMainService,Te),pe.set(U.ILaunchMainService,new Y.SyncDescriptor(U.LaunchMainService,void 0,!1)),pe.set(T.IDiagnosticsMainService,new Y.SyncDescriptor(T.DiagnosticsMainService,void 0,!1)),pe.set(C.IDiagnosticsService,D.ProxyChannel.toService((0,D.getDelayedChannel)(Ie.then(Je=>Je.getChannel("diagnostics"))))),pe.set(F.IIssueMainService,new Y.SyncDescriptor(N.IssueMainService,[this.f])),pe.set($.IEncryptionMainService,new Y.SyncDescriptor(H.EncryptionMainService,[De])),pe.set(j.IKeyboardLayoutMainService,new Y.SyncDescriptor(j.KeyboardLayoutMainService)),pe.set(ae.INativeHostMainService,new Y.SyncDescriptor(ae.NativeHostMainService,void 0,!1)),pe.set(I.ICredentialsMainService,new Y.SyncDescriptor(ot.CredentialsNativeMainService)),pe.set(ge.IWebviewManagerService,new Y.SyncDescriptor(me.WebviewMainService)),pe.set(re.IMenubarMainService,new Y.SyncDescriptor(re.MenubarMainService)),pe.set(ue.IExtensionUrlTrustService,new Y.SyncDescriptor(ce.ExtensionUrlTrustService)),pe.set(X.IExtensionHostStarter,new Y.SyncDescriptor(q.ExtensionHostStarter)),pe.set(we.IStorageMainService,new Y.SyncDescriptor(we.StorageMainService)),pe.set(we.IApplicationStorageMainService,new Y.SyncDescriptor(we.ApplicationStorageMainService)),r.isWindows?pe.set(B.IExternalTerminalMainService,new Y.SyncDescriptor(z.WindowsExternalTerminalService)):r.isMacintosh?pe.set(B.IExternalTerminalMainService,new Y.SyncDescriptor(z.MacExternalTerminalService)):r.isLinux&&pe.set(B.IExternalTerminalMainService,new Y.SyncDescriptor(z.LinuxExternalTerminalService));const Re=new u.BackupMainService(this.i,this.k,this.h,this.l);pe.set(o.IBackupMainService,Re);const $e=new tt.WorkspacesManagementMainService(this.i,this.h,this.p,Re,Te);if(pe.set(tt.IWorkspacesManagementMainService,$e),pe.set(Ze.IWorkspacesService,new Y.SyncDescriptor(Ye.WorkspacesMainService,void 0,!1)),pe.set(Ge.IWorkspacesHistoryMainService,new Y.SyncDescriptor(Ge.WorkspacesHistoryMainService,void 0,!1)),pe.set(qe.IURLService,new Y.SyncDescriptor(J.NativeURLService,void 0,!1)),(0,Ee.supportsTelemetry)(this.n,this.i)){const Je=(0,Ee.isInternalTelemetry)(this.n,this.k),Qe=(0,D.getDelayedChannel)(Ie.then(_e=>_e.getChannel("telemetryAppender"))),Be=new he.TelemetryAppenderClient(Qe),Ve=(0,Pe.resolveCommonProperties)((0,L.release)(),(0,L.hostname)(),process.arch,this.n.commit,this.n.version,De,Je),xe=(0,Ee.getPiiPathsFromEnvironment)(this.i),Xe={appenders:[Be],commonProperties:Ve,piiPaths:xe,sendErrorTelemetry:!0};pe.set(_.ITelemetryService,new Y.SyncDescriptor(fe.TelemetryService,[Xe],!1))}else pe.set(_.ITelemetryService,Ee.NullTelemetryService);return pe.set(Lt.IExtensionsProfileScannerService,new Y.SyncDescriptor(Nt.ExtensionsProfileScannerService,void 0,!0)),pe.set(Ot.IExtensionsScannerService,new Y.SyncDescriptor(Tt.ExtensionsScannerService,void 0,!0)),pe.set(wt.IUtilityProcessWorkerMainService,new Y.SyncDescriptor(wt.UtilityProcessWorkerMainService,void 0,!0)),await pt.Promises.settled([Re.initialize(),$e.initialize()]),this.g.createChild(pe)}G(De,Ie,pe){const Te=D.ProxyChannel.fromService(De.get(U.ILaunchMainService),{disableMarshalling:!0});this.c.registerChannel("launch",Te);const Re=D.ProxyChannel.fromService(De.get(T.IDiagnosticsMainService),{disableMarshalling:!0});this.c.registerChannel("diagnostics",Re);const $e=new Rt.PolicyChannel(De.get(lt.IPolicyService));Ie.registerChannel("policy",$e),pe.then(et=>et.registerChannel("policy",$e));const Je=this.m.getProvider(y.Schemas.file);(0,g.assertType)(Je instanceof le.DiskFileSystemProvider);const Qe=new oe.DiskFileSystemProviderChannel(Je,this.h,this.i);Ie.registerChannel(K.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe),pe.then(et=>et.registerChannel(K.LOCAL_FILE_SYSTEM_CHANNEL_NAME,Qe));const Be=D.ProxyChannel.fromService(De.get(mt.IUserDataProfilesMainService));Ie.registerChannel("userDataProfiles",Be),pe.then(et=>et.registerChannel("userDataProfiles",Be));const Ve=new At.RequestChannel(De.get(Mt.IRequestService));pe.then(et=>et.registerChannel("request",Ve));const xe=new Oe.UpdateChannel(De.get(ke.IUpdateService));Ie.registerChannel("update",xe);const Xe=D.ProxyChannel.fromService(De.get(F.IIssueMainService));Ie.registerChannel("issue",Xe);const _e=D.ProxyChannel.fromService(De.get($.IEncryptionMainService));Ie.registerChannel("encryption",_e);const rt=D.ProxyChannel.fromService(De.get(I.ICredentialsMainService));Ie.registerChannel("credentials",rt);const nt=D.ProxyChannel.fromService(De.get(Me.ISignService));Ie.registerChannel("sign",nt);const ut=D.ProxyChannel.fromService(De.get(j.IKeyboardLayoutMainService));Ie.registerChannel("keyboardLayout",ut),this.b=De.get(ae.INativeHostMainService);const It=D.ProxyChannel.fromService(this.b);Ie.registerChannel("nativeHost",It),pe.then(et=>et.registerChannel("nativeHost",It));const qt=D.ProxyChannel.fromService(De.get(Ze.IWorkspacesService));Ie.registerChannel("workspaces",qt);const Ht=D.ProxyChannel.fromService(De.get(re.IMenubarMainService));Ie.registerChannel("menubar",Ht);const Vt=D.ProxyChannel.fromService(De.get(qe.IURLService));Ie.registerChannel("url",Vt);const xt=D.ProxyChannel.fromService(De.get(ue.IExtensionUrlTrustService));Ie.registerChannel("extensionUrlTrust",xt);const Gt=D.ProxyChannel.fromService(De.get(ge.IWebviewManagerService));Ie.registerChannel("webview",Gt);const Pt=this.B(new ve.StorageDatabaseChannel(this.h,De.get(we.IStorageMainService)));Ie.registerChannel("storage",Pt),pe.then(et=>et.registerChannel("storage",Pt));const Kt=this.B(new Wt.ProfileStorageChangesListenerChannel(De.get(we.IStorageMainService),De.get(mt.IUserDataProfilesMainService),this.h));pe.then(et=>et.registerChannel("profileStorageListener",Kt));const Xt=D.ProxyChannel.fromService(De.get(B.IExternalTerminalMainService));Ie.registerChannel("externalTerminal",Xt);const kt=new Bt.LoggerChannel(De.get(jt.ILoggerMainService));Ie.registerChannel("logger",kt),pe.then(et=>et.registerChannel("logger",kt));const Jt=new A.ElectronExtensionHostDebugBroadcastChannel(De.get(Se.IWindowsMainService));Ie.registerChannel("extensionhostdebugservice",Jt);const Yt=D.ProxyChannel.fromService(De.get(X.IExtensionHostStarter));Ie.registerChannel(X.ipcExtensionHostStarterChannelName,Yt);const Qt=D.ProxyChannel.fromService(De.get(wt.IUtilityProcessWorkerMainService));Ie.registerChannel(zt.ipcUtilityProcessWorkerChannelName,Qt)}async H(De,Ie){const pe=this.a=De.get(Se.IWindowsMainService),Te=(0,ne.isLaunchedFromCli)(process.env)?0:4,Re=this.i.args;if(Ie){if(Ie.openables.length>0)return pe.open({context:Te,cli:Re,urisToOpen:Ie.openables,gotoLineMode:!0,initialStartup:!0});if(Ie.urls.length>0)for(const nt of Ie.urls){const ut=new URLSearchParams(nt.uri.query);if(ut.get("windowId")==="_blank")return ut.delete("windowId"),nt.originalUrl=nt.uri.toString(!0),nt.uri=nt.uri.with({query:ut.toString()}),pe.open({context:Te,cli:Re,forceNewWindow:!0,forceEmpty:!0,gotoLineMode:!0,initialStartup:!0})}}const $e=global.macOpenFiles,Je=Re._.length,Qe=!!Re["folder-uri"],Be=!!Re["file-uri"],Ve=Re["skip-add-to-recently-opened"]===!0,xe=Re.wait&&Re.waitMarkerFilePath?c.URI.file(Re.waitMarkerFilePath):void 0,Xe=Re.remote||void 0,_e=Re.profile,rt=Re["profile-temp"];if(!Je&&!Qe&&!Be){if(Re["new-window"]||_e||rt)return pe.open({context:Te,cli:Re,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Ve,waitMarkerFileURI:xe,initialStartup:!0,remoteAuthority:Xe,forceProfile:_e,forceTempProfile:rt});if($e.length)return pe.open({context:1,cli:Re,urisToOpen:$e.map(nt=>(0,Ke.hasWorkspaceFileExtension)(nt)?{workspaceUri:c.URI.file(nt)}:{fileUri:c.URI.file(nt)}),noRecentEntry:Ve,waitMarkerFileURI:xe,initialStartup:!0})}return pe.open({context:Te,cli:Re,forceNewWindow:Re["new-window"]||!Je&&Re["unity-launch"],diffMode:Re.diff,mergeMode:Re.merge,noRecentEntry:Ve,waitMarkerFileURI:xe,gotoLineMode:Re.goto,initialStartup:!0,remoteAuthority:Xe,forceProfile:_e,forceTempProfile:rt})}I(){this.J(),E.protocol.registerHttpProtocol(y.Schemas.vscodeRemoteResource,(De,Ie)=>{Ie({url:De.url.replace(/^vscode-remote-resource:/,"http:"),method:De.method})}),this.L(this.i.args,process.env,!0),this.M()}async J(){const De=this.n.win32MutexName;if(r.isWindows&&De)try{const Ie=await new Promise((Te,Re)=>{x(["@vscode/windows-mutex"],Te,Re)}),pe=new Ie.Mutex(De);(0,p.once)(this.j.onWillShutdown)(()=>pe.release())}catch(Ie){this.h.error(Ie)}}async L(De,Ie,pe){try{return await(0,se.getResolvedShellEnv)(this.k,this.h,De,Ie)}catch(Te){const Re=(0,k.toErrorMessage)(Te);pe?this.a?.sendToFocused("vscode:showResolveShellEnvError",Re):this.h.error(Re)}return{}}async M(){try{const Ie=(await this.m.readFile(this.i.argvResource)).value.toString(),pe=JSON.parse((0,m.stripComments)(Ie)),Re=(0,Ee.getTelemetryLevel)(this.k)>=1;if(pe["enable-crash-reporter"]===void 0){const $e=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Re},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,b.generateUuid)()}"`,"}"],Je=Ie.substring(0,Ie.length-2).concat(`,
`,$e.join(`
`));await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString(Je))}else{const $e=Ie.replace(/"enable-crash-reporter": .*,/,`"enable-crash-reporter": ${Re},`);$e!==Ie&&await this.m.writeFile(this.i.argvResource,R.VSBuffer.fromString($e))}}catch(De){this.h.error(De)}}};e.CodeApplication=Et=be([Q(2,O.IInstantiationService),Q(3,G.ILogService),Q(4,Z.IEnvironmentMainService),Q(5,V.ILifecycleMainService),Q(6,d.IConfigurationService),Q(7,Fe.IStateService),Q(8,ee.IFileService),Q(9,ye.IProductService),Q(10,mt.IUserDataProfilesMainService)],Et)}),define(te[298],ie([0,1,14,41,8,23,7,49,13,32,48,44,15,9,64,3,36,27,24,45,97,291,10,19,234,242,30,62,197,16,218,91,73,213,90,20,221,5,76,21,77,265,120,275,52,274,92,241,33,46,78,53,37,229,227,2,38,250,65,222,89,116,248]),function(x,e,E,M,s,L,R,k,h,l,p,m,v,f,y,w,r,g,c,b,S,D,t,a,i,n,o,u,d,I,A,C,T,W,$,H,Z,ne,se,ue,ce,X,q,B,z,K,ee,oe,le,Y,O,P,F,N,j,U,V,G,re,ae,ye,Ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class Ae{main(){try{this.a()}catch(ve){console.error(ve.message),E.app.exit(1)}}async a(){(0,h.setUnexpectedErrorHandler)(Oe=>console.error(Oe));const[ve,we,Pe,_,he,fe,Ee,ke]=this.b();try{try{await this.d(Pe,ke,_,he,Ee)}catch(Oe){throw this.f(Pe,Ee,Oe),Oe}await ve.invokeFunction(async Oe=>{const We=Oe.get(ne.ILogService),He=Oe.get(H.ILifecycleMainService),Ne=Oe.get(I.IFileService),ze=Oe.get(ne.ILoggerService),qe=await this.e(We,Pe,He,ve,Ee,!0);return c.Promises.writeFile(Pe.mainLockfile,String(process.pid)).catch(Ue=>{We.warn(`app#startup(): Error writing main lockfile: ${Ue.stack}`)}),fe.logger=ze.createLogger("main",{name:(0,t.localize)(0,null)}),(0,p.once)(He.onWillShutdown)(Ue=>{Ne.dispose(),_.dispose(),Ue.join("instanceLockfile",c.Promises.unlink(Pe.mainLockfile).catch(()=>{}))}),ve.createInstance(D.CodeApplication,qe,we).startup()})}catch(Oe){ve.invokeFunction(this.i,Oe)}}b(){const ve=new $.ServiceCollection,we=new U.DisposableStore;process.once("exit",()=>we.dispose());const Pe={_serviceBrand:void 0,...se.default};ve.set(ue.IProductService,Pe);const _=new o.EnvironmentMainService(this.j(),Pe),he=this.c(_);ve.set(o.IEnvironmentMainService,_);const fe=new re.LoggerMainService((0,ne.getLogLevel)(_),_.logsHome);ve.set(re.ILoggerMainService,fe);const Ee=new Z.BufferLogger(fe.getLogLevel()),ke=we.add(new ae.LogService(Ee,[new ne.ConsoleMainLogger(fe.getLogLevel())]));ve.set(ne.ILogService,ke);const Oe=new A.FileService(ke);ve.set(I.IFileService,Oe);const We=new C.DiskFileSystemProvider(ke);Oe.registerProvider(v.Schemas.file,We);const He=new G.UriIdentityService(Oe);ve.set(V.IUriIdentityService,He);const Ne=new Ce.StateService(1,_,ke,Oe);ve.set(le.IStateReadService,Ne),ve.set(le.IStateService,Ne);const ze=new P.UserDataProfilesMainService(Ne,He,_,Oe,ke);ve.set(P.IUserDataProfilesMainService,ze);const qe=w.isWindows&&Pe.win32RegValueName?we.add(new N.NativePolicyService(ke,Pe.win32RegValueName)):_.policyFile?we.add(new j.FilePolicyService(_.policyFile,Oe,ke)):new F.NullPolicyService;ve.set(F.IPolicyService,qe);const Ue=new i.ConfigurationService(ze.defaultProfile.settingsResource,Oe,qe,ke);return ve.set(a.IConfigurationService,Ue),ve.set(H.ILifecycleMainService,new T.SyncDescriptor(H.LifecycleMainService,void 0,!1)),ve.set(z.IRequestService,new T.SyncDescriptor(K.RequestMainService,void 0,!0)),ve.set(O.IThemeMainService,new T.SyncDescriptor(O.ThemeMainService)),ve.set(ee.ISignService,new T.SyncDescriptor(oe.SignService,void 0,!1)),ve.set(q.ITunnelService,new T.SyncDescriptor(B.TunnelService)),ve.set(ce.IProtocolMainService,new X.ProtocolMainService(_,ze,ke)),[new W.InstantiationService(ve,!0),he,_,Ue,Ne,Ee,Pe,ze]}c(ve){const we={VSCODE_IPC_HOOK:ve.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(Pe=>{const _=process.env[Pe];typeof _=="string"&&(we[Pe]=_)}),Object.assign(process.env,we),we}async d(ve,we,Pe,_,he){await R.Promises.settled([Promise.all([ve.extensionsPath,ve.codeCachePath,ve.logsHome.fsPath,we.defaultProfile.globalStorageHome.fsPath,ve.workspaceStorageHome.fsPath,ve.localHistoryHome.fsPath,ve.backupHome].map(fe=>fe?c.Promises.mkdir(fe,{recursive:!0}):void 0)),_.init(),Pe.initialize()]),we.init()}async e(ve,we,Pe,_,he,fe){let Ee;try{(0,y.mark)("code/willStartMainServer"),Ee=await(0,S.serve)(we.mainIPCHandle),(0,y.mark)("code/didStartMainServer"),(0,p.once)(Pe.onWillShutdown)(()=>Ee.dispose())}catch(ke){if(ke.code!=="EADDRINUSE")throw this.f(we,he,ke),ke;let Oe;try{Oe=await(0,S.connect)(we.mainIPCHandle,"main")}catch(ze){if(!fe||w.isWindows||ze.code!=="ECONNREFUSED")throw ze.code==="EPERM"&&this.g((0,t.localize)(1,null,he.nameShort),(0,t.localize)(2,null),he),ze;try{(0,M.unlinkSync)(we.mainIPCHandle)}catch(qe){throw ve.warn("Could not delete obsolete instance handle",qe),qe}return this.e(ve,we,Pe,_,he,!1)}if(we.extensionTestsLocationURI&&!we.debugExtensionHost.break){const ze=`Running extension tests from the command line is currently only supported if no other instance of ${he.nameShort} is running.`;throw ve.error(ze),Oe.dispose(),new Error(ze)}let We;!we.args.wait&&!we.args.status&&(We=setTimeout(()=>{this.g((0,t.localize)(3,null,he.nameShort),(0,t.localize)(4,null),he)},1e4));const He=b.ProxyChannel.toService(Oe.getChannel("launch"),{disableMarshalling:!0}),Ne=b.ProxyChannel.toService(Oe.getChannel("diagnostics"),{disableMarshalling:!0});if(we.args.status)return _.invokeFunction(async()=>{const ze=new n.DiagnosticsService(Y.NullTelemetryService,he),qe=await Ne.getMainDiagnostics(),Ue=await Ne.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),J=await ze.getDiagnostics(qe,Ue);throw console.log(J),new h.ExpectedError});throw w.isWindows&&await this.h(He,ve),ve.trace("Sending env to running instance..."),await He.start(we.args,process.env),Oe.dispose(),We&&clearTimeout(We),new h.ExpectedError("Sent env to running instance. Terminating...")}if(we.args.status)throw ve.warn("Warning: The --status argument can only be used if {0} is already running. Please run it again after {0} has started.",he.nameShort),new h.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),Ee}f(ve,we,Pe){if(Pe.code==="EACCES"||Pe.code==="EPERM"){const _=(0,L.coalesce)([ve.userDataPath,ve.extensionsPath,S.XDG_RUNTIME_DIR]).map(he=>(0,m.getPathLabel)(s.URI.file(he),{os:w.OS,tildify:ve}));this.g((0,t.localize)(5,null),(0,t.localize)(6,null,(0,k.toErrorMessage)(Pe),_.join(`
`)),we)}}g(ve,we,Pe){E.dialog.showMessageBoxSync((0,ye.massageMessageBoxOptions)({type:"warning",buttons:[(0,t.localize)(7,null)],message:ve,detail:we},Pe).options)}async h(ve,we){if(w.isWindows){const Pe=await ve.getMainProcessId();we.trace("Sending some foreground love to the running instance:",Pe);try{(await new Promise((_,he)=>{x(["windows-foreground-love"],_,he)})).allowSetForegroundWindow(Pe)}catch(_){we.error(_)}}}i(ve,we){const Pe=ve.get(ne.ILogService),_=ve.get(H.ILifecycleMainService);let he=0;we&&(we.isExpected?we.message&&Pe.trace(we.message):(he=1,we.stack?Pe.error(we.stack):Pe.error(`Startup error: ${we.toString()}`))),_.kill(he)}j(){const ve=this.k((0,u.parseMainProcessArgv)(process.argv));if(ve.wait&&!ve.waitMarkerFilePath){const we=(0,d.createWaitMarkerFileSync)(ve.verbose);we&&((0,u.addArg)(process.argv,"--waitMarkerFilePath",we),ve.waitMarkerFilePath=we)}return ve}k(ve){if(ve["open-url"]&&(ve._urls=ve._,ve._=[]),!ve.remote){const we=this.l(ve._,ve.goto);ve._=we}return ve}l(ve,we){const Pe=(0,r.cwd)(),_=ve.map(Ee=>{let ke=String(Ee),Oe;we&&(Oe=(0,l.parseLineAndColumnAware)(ke),ke=Oe.path),ke&&(ke=this.m(Pe,ke));const We=(0,l.sanitizeFilePath)(ke,Pe),He=(0,f.basename)(We);return He&&!(0,l.isValidBasename)(He)?null:we&&Oe?(Oe.path=We,this.n(Oe)):We}),he=w.isWindows||w.isMacintosh,fe=(0,L.distinct)(_,Ee=>Ee&&he?Ee.toLowerCase():Ee||"");return(0,L.coalesce)(fe)}m(ve,we){return w.isWindows&&(we=(0,g.rtrim)(we,'"')),we=(0,g.trim)((0,g.trim)(we," "),"	"),w.isWindows&&(we=(0,f.resolve)(ve,we),we=(0,g.rtrim)(we,".")),we}n(ve){const we=[ve.path];return typeof ve.line=="number"&&we.push(String(ve.line)),typeof ve.column=="number"&&we.push(String(ve.column)),we.join(":")}}new Ae().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/electron-main/main.js.map
