/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/base/common/errors","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/nls","vs/base/common/arrays","vs/base/browser/keyboardEvent","vs/base/common/uri","vs/base/common/codicons","vs/base/common/themables","vs/base/browser/browser","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/cancellation","vs/base/common/network","vs/base/parts/sandbox/electron-sandbox/globals","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/browser/ui/list/listWidget","vs/platform/instantiation/common/instantiation","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/numbers","vs/base/common/range","vs/base/common/symbols","vs/base/common/objects","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/toggle/toggle","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/collections","vs/base/common/color","vs/base/common/diff/diffChange","vs/base/common/assert","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/map","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/common/ternarySearchTree","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/common/mainProcessService","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],be=function(te){for(var t=[],y=0,M=te.length;y<M;y++)t[y]=me[te[y]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function _t(te){if(Array.isArray(te)){for(var t=0,y=Array(te.length);t<te.length;t++)y[t]=te[t];return y}else return Array.from(te)}var jt=Object.hasOwnProperty,Nt=Object.setPrototypeOf,Vt=Object.isFrozen,qt=Object.getPrototypeOf,Kt=Object.getOwnPropertyDescriptor,tt=Object.freeze,at=Object.seal,Gt=Object.create,It=typeof Reflect<"u"&&Reflect,wt=It.apply,At=It.construct;wt||(wt=function(t,y,M){return t.apply(y,M)}),tt||(tt=function(t){return t}),at||(at=function(t){return t}),At||(At=function(t,y){return new(Function.prototype.bind.apply(t,[null].concat(_t(y))))});var Yt=st(Array.prototype.forEach),Mt=st(Array.prototype.pop),gt=st(Array.prototype.push),ht=st(String.prototype.toLowerCase),Pt=st(String.prototype.match),ut=st(String.prototype.replace),Xt=st(String.prototype.indexOf),Zt=st(String.prototype.trim),lt=st(RegExp.prototype.test),Rt=Qt(TypeError);function st(te){return function(t){for(var y=arguments.length,M=Array(y>1?y-1:0),i=1;i<y;i++)M[i-1]=arguments[i];return wt(te,t,M)}}function Qt(te){return function(){for(var t=arguments.length,y=Array(t),M=0;M<t;M++)y[M]=arguments[M];return At(te,y)}}function He(te,t){Nt&&Nt(te,null);for(var y=t.length;y--;){var M=t[y];if(typeof M=="string"){var i=ht(M);i!==M&&(Vt(t)||(t[y]=i),M=i)}te[M]=!0}return te}function ct(te){var t=Gt(null),y=void 0;for(y in te)wt(jt,te,[y])&&(t[y]=te[y]);return t}function Dt(te,t){for(;te!==null;){var y=Kt(te,t);if(y){if(y.get)return st(y.get);if(typeof y.value=="function")return st(y.value)}te=qt(te)}function M(i){return console.warn("fallback value for",i),null}return M}var Ot=tt(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),St=tt(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=tt(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Jt=tt(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),Ft=tt(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),ei=tt(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Bt=tt(["#text"]),Ht=tt(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),kt=tt(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),zt=tt(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),yt=tt(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ti=at(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ii=at(/<%[\s\S]*|[\s\S]*%>/gm),ni=at(/^data-[\-\w.\u00B7-\uFFFF]/),si=at(/^aria-[\-\w]+$/),ri=at(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),oi=at(/^(?:\w+script|data):/i),ai=at(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),mt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(te){return typeof te}:function(te){return te&&typeof Symbol=="function"&&te.constructor===Symbol&&te!==Symbol.prototype?"symbol":typeof te};function ot(te){if(Array.isArray(te)){for(var t=0,y=Array(te.length);t<te.length;t++)y[t]=te[t];return y}else return Array.from(te)}var li=function(){return typeof window>"u"?null:window},ui=function(t,y){if((typeof t>"u"?"undefined":mt(t))!=="object"||typeof t.createPolicy!="function")return null;var M=null,i="data-tt-policy-suffix";y.currentScript&&y.currentScript.hasAttribute(i)&&(M=y.currentScript.getAttribute(i));var W="dompurify"+(M?"#"+M:"");try{return t.createPolicy(W,{createHTML:function(A){return A}})}catch{return console.warn("TrustedTypes policy "+W+" could not be created."),null}};function Ut(){var te=arguments.length>0&&arguments[0]!==void 0?arguments[0]:li(),t=function(he){return Ut(he)};if(t.version="2.3.1",t.removed=[],!te||!te.document||te.document.nodeType!==9)return t.isSupported=!1,t;var y=te.document,M=te.document,i=te.DocumentFragment,W=te.HTMLTemplateElement,p=te.Node,A=te.Element,h=te.NodeFilter,a=te.NamedNodeMap,c=a===void 0?te.NamedNodeMap||te.MozNamedAttrMap:a,P=te.Text,r=te.Comment,l=te.DOMParser,e=te.trustedTypes,o=A.prototype,n=Dt(o,"cloneNode"),u=Dt(o,"nextSibling"),s=Dt(o,"childNodes"),w=Dt(o,"parentNode");if(typeof W=="function"){var D=M.createElement("template");D.content&&D.content.ownerDocument&&(M=D.content.ownerDocument)}var S=ui(e,y),f=S&&Z?S.createHTML(""):"",v=M,L=v.implementation,N=v.createNodeIterator,E=v.createDocumentFragment,g=v.getElementsByTagName,m=y.importNode,b={};try{b=ct(M).documentMode?M.documentMode:{}}catch{}var B={};t.isSupported=typeof w=="function"&&L&&typeof L.createHTMLDocument<"u"&&b!==9;var G=ti,J=ii,ie=ni,le=si,ge=oi,ue=ai,de=ri,ce=null,Se=He({},[].concat(ot(Ot),ot(St),ot(Ct),ot(Ft),ot(Bt))),Ae=null,Be=He({},[].concat(ot(Ht),ot(kt),ot(zt),ot(yt))),re=null,ne=null,Q=!0,oe=!0,j=!1,V=!1,F=!1,x=!1,I=!1,d=!1,R=!1,_=!0,Z=!1,k=!0,T=!0,H=!1,C={},U=null,z=He({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),O=null,$=He({},["audio","video","img","source","image","track"]),q=null,ee=He({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),se="http://www.w3.org/1998/Math/MathML",ve="http://www.w3.org/2000/svg",De="http://www.w3.org/1999/xhtml",Ie=De,Fe=!1,we=null,Pe=M.createElement("form"),Ne=function(he){we&&we===he||((!he||(typeof he>"u"?"undefined":mt(he))!=="object")&&(he={}),he=ct(he),ce="ALLOWED_TAGS"in he?He({},he.ALLOWED_TAGS):Se,Ae="ALLOWED_ATTR"in he?He({},he.ALLOWED_ATTR):Be,q="ADD_URI_SAFE_ATTR"in he?He(ct(ee),he.ADD_URI_SAFE_ATTR):ee,O="ADD_DATA_URI_TAGS"in he?He(ct($),he.ADD_DATA_URI_TAGS):$,U="FORBID_CONTENTS"in he?He({},he.FORBID_CONTENTS):z,re="FORBID_TAGS"in he?He({},he.FORBID_TAGS):{},ne="FORBID_ATTR"in he?He({},he.FORBID_ATTR):{},C="USE_PROFILES"in he?he.USE_PROFILES:!1,Q=he.ALLOW_ARIA_ATTR!==!1,oe=he.ALLOW_DATA_ATTR!==!1,j=he.ALLOW_UNKNOWN_PROTOCOLS||!1,V=he.SAFE_FOR_TEMPLATES||!1,F=he.WHOLE_DOCUMENT||!1,d=he.RETURN_DOM||!1,R=he.RETURN_DOM_FRAGMENT||!1,_=he.RETURN_DOM_IMPORT!==!1,Z=he.RETURN_TRUSTED_TYPE||!1,I=he.FORCE_BODY||!1,k=he.SANITIZE_DOM!==!1,T=he.KEEP_CONTENT!==!1,H=he.IN_PLACE||!1,de=he.ALLOWED_URI_REGEXP||de,Ie=he.NAMESPACE||De,V&&(oe=!1),R&&(d=!0),C&&(ce=He({},[].concat(ot(Bt))),Ae=[],C.html===!0&&(He(ce,Ot),He(Ae,Ht)),C.svg===!0&&(He(ce,St),He(Ae,kt),He(Ae,yt)),C.svgFilters===!0&&(He(ce,Ct),He(Ae,kt),He(Ae,yt)),C.mathMl===!0&&(He(ce,Ft),He(Ae,zt),He(Ae,yt))),he.ADD_TAGS&&(ce===Se&&(ce=ct(ce)),He(ce,he.ADD_TAGS)),he.ADD_ATTR&&(Ae===Be&&(Ae=ct(Ae)),He(Ae,he.ADD_ATTR)),he.ADD_URI_SAFE_ATTR&&He(q,he.ADD_URI_SAFE_ATTR),he.FORBID_CONTENTS&&(U===z&&(U=ct(U)),He(U,he.FORBID_CONTENTS)),T&&(ce["#text"]=!0),F&&He(ce,["html","head","body"]),ce.table&&(He(ce,["tbody"]),delete re.tbody),tt&&tt(he),we=he)},Ve=He({},["mi","mo","mn","ms","mtext"]),ze=He({},["foreignobject","desc","title","annotation-xml"]),We=He({},St);He(We,Ct),He(We,Jt);var Je=He({},Ft);He(Je,ei);var it=function(he){var Ee=w(he);(!Ee||!Ee.tagName)&&(Ee={namespaceURI:De,tagName:"template"});var Me=ht(he.tagName),Ue=ht(Ee.tagName);if(he.namespaceURI===ve)return Ee.namespaceURI===De?Me==="svg":Ee.namespaceURI===se?Me==="svg"&&(Ue==="annotation-xml"||Ve[Ue]):!!We[Me];if(he.namespaceURI===se)return Ee.namespaceURI===De?Me==="math":Ee.namespaceURI===ve?Me==="math"&&ze[Ue]:!!Je[Me];if(he.namespaceURI===De){if(Ee.namespaceURI===ve&&!ze[Ue]||Ee.namespaceURI===se&&!Ve[Ue])return!1;var Xe=He({},["title","style","font","a","script"]);return!Je[Me]&&(Xe[Me]||!We[Me])}return!1},Oe=function(he){gt(t.removed,{element:he});try{he.parentNode.removeChild(he)}catch{try{he.outerHTML=f}catch{he.remove()}}},je=function(he,Ee){try{gt(t.removed,{attribute:Ee.getAttributeNode(he),from:Ee})}catch{gt(t.removed,{attribute:null,from:Ee})}if(Ee.removeAttribute(he),he==="is"&&!Ae[he])if(d||R)try{Oe(Ee)}catch{}else try{Ee.setAttribute(he,"")}catch{}},K=function(he){var Ee=void 0,Me=void 0;if(I)he="<remove></remove>"+he;else{var Ue=Pt(he,/^[\r\n\t ]+/);Me=Ue&&Ue[0]}var Xe=S?S.createHTML(he):he;if(Ie===De)try{Ee=new l().parseFromString(Xe,"text/html")}catch{}if(!Ee||!Ee.documentElement){Ee=L.createDocument(Ie,"template",null);try{Ee.documentElement.innerHTML=Fe?"":Xe}catch{}}var Ze=Ee.body||Ee.documentElement;return he&&Me&&Ze.insertBefore(M.createTextNode(Me),Ze.childNodes[0]||null),Ie===De?g.call(Ee,F?"html":"body")[0]:F?Ee.documentElement:Ze},ae=function(he){return N.call(he.ownerDocument||he,he,h.SHOW_ELEMENT|h.SHOW_COMMENT|h.SHOW_TEXT,null,!1)},pe=function(he){return he instanceof P||he instanceof r?!1:typeof he.nodeName!="string"||typeof he.textContent!="string"||typeof he.removeChild!="function"||!(he.attributes instanceof c)||typeof he.removeAttribute!="function"||typeof he.setAttribute!="function"||typeof he.namespaceURI!="string"||typeof he.insertBefore!="function"},ye=function(he){return(typeof p>"u"?"undefined":mt(p))==="object"?he instanceof p:he&&(typeof he>"u"?"undefined":mt(he))==="object"&&typeof he.nodeType=="number"&&typeof he.nodeName=="string"},Ce=function(he,Ee,Me){B[he]&&Yt(B[he],function(Ue){Ue.call(t,Ee,Me,we)})},Re=function(he){var Ee=void 0;if(Ce("beforeSanitizeElements",he,null),pe(he)||Pt(he.nodeName,/[\u0080-\uFFFF]/))return Oe(he),!0;var Me=ht(he.nodeName);if(Ce("uponSanitizeElement",he,{tagName:Me,allowedTags:ce}),!ye(he.firstElementChild)&&(!ye(he.content)||!ye(he.content.firstElementChild))&&lt(/<[/\w]/g,he.innerHTML)&&lt(/<[/\w]/g,he.textContent)||Me==="select"&&lt(/<template/i,he.innerHTML))return Oe(he),!0;if(!ce[Me]||re[Me]){if(T&&!U[Me]){var Ue=w(he)||he.parentNode,Xe=s(he)||he.childNodes;if(Xe&&Ue)for(var Ze=Xe.length,Qe=Ze-1;Qe>=0;--Qe)Ue.insertBefore(n(Xe[Qe],!0),u(he))}return Oe(he),!0}return he instanceof A&&!it(he)||(Me==="noscript"||Me==="noembed")&&lt(/<\/no(script|embed)/i,he.innerHTML)?(Oe(he),!0):(V&&he.nodeType===3&&(Ee=he.textContent,Ee=ut(Ee,G," "),Ee=ut(Ee,J," "),he.textContent!==Ee&&(gt(t.removed,{element:he.cloneNode()}),he.textContent=Ee)),Ce("afterSanitizeElements",he,null),!1)},$e=function(he,Ee,Me){if(k&&(Ee==="id"||Ee==="name")&&(Me in M||Me in Pe))return!1;if(!(oe&&!ne[Ee]&&lt(ie,Ee))){if(!(Q&&lt(le,Ee))){if(!Ae[Ee]||ne[Ee])return!1;if(!q[Ee]){if(!lt(de,ut(Me,ue,""))){if(!((Ee==="src"||Ee==="xlink:href"||Ee==="href")&&he!=="script"&&Xt(Me,"data:")===0&&O[he])){if(!(j&&!lt(ge,ut(Me,ue,"")))){if(Me)return!1}}}}}}return!0},Ge=function(he){var Ee=void 0,Me=void 0,Ue=void 0,Xe=void 0;Ce("beforeSanitizeAttributes",he,null);var Ze=he.attributes;if(Ze){var Qe={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:Ae};for(Xe=Ze.length;Xe--;){Ee=Ze[Xe];var rt=Ee,dt=rt.name,bt=rt.namespaceURI;if(Me=Zt(Ee.value),Ue=ht(dt),Qe.attrName=Ue,Qe.attrValue=Me,Qe.keepAttr=!0,Qe.forceKeepAttr=void 0,Ce("uponSanitizeAttribute",he,Qe),Me=Qe.attrValue,!Qe.forceKeepAttr&&(je(dt,he),!!Qe.keepAttr)){if(lt(/\/>/i,Me)){je(dt,he);continue}V&&(Me=ut(Me,G," "),Me=ut(Me,J," "));var Tt=he.nodeName.toLowerCase();if($e(Tt,Ue,Me))try{bt?he.setAttributeNS(bt,dt,Me):he.setAttribute(dt,Me),Mt(t.removed)}catch{}}}Ce("afterSanitizeAttributes",he,null)}},et=function Te(he){var Ee=void 0,Me=ae(he);for(Ce("beforeSanitizeShadowDOM",he,null);Ee=Me.nextNode();)Ce("uponSanitizeShadowNode",Ee,null),!Re(Ee)&&(Ee.content instanceof i&&Te(Ee.content),Ge(Ee));Ce("afterSanitizeShadowDOM",he,null)};return t.sanitize=function(Te,he){var Ee=void 0,Me=void 0,Ue=void 0,Xe=void 0,Ze=void 0;if(Fe=!Te,Fe&&(Te="<!-->"),typeof Te!="string"&&!ye(Te)){if(typeof Te.toString!="function")throw Rt("toString is not a function");if(Te=Te.toString(),typeof Te!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(mt(te.toStaticHTML)==="object"||typeof te.toStaticHTML=="function"){if(typeof Te=="string")return te.toStaticHTML(Te);if(ye(Te))return te.toStaticHTML(Te.outerHTML)}return Te}if(x||Ne(he),t.removed=[],typeof Te=="string"&&(H=!1),!H)if(Te instanceof p)Ee=K("<!---->"),Me=Ee.ownerDocument.importNode(Te,!0),Me.nodeType===1&&Me.nodeName==="BODY"||Me.nodeName==="HTML"?Ee=Me:Ee.appendChild(Me);else{if(!d&&!V&&!F&&Te.indexOf("<")===-1)return S&&Z?S.createHTML(Te):Te;if(Ee=K(Te),!Ee)return d?null:f}Ee&&I&&Oe(Ee.firstChild);for(var Qe=ae(H?Te:Ee);Ue=Qe.nextNode();)Ue.nodeType===3&&Ue===Xe||Re(Ue)||(Ue.content instanceof i&&et(Ue.content),Ge(Ue),Xe=Ue);if(Xe=null,H)return Te;if(d){if(R)for(Ze=E.call(Ee.ownerDocument);Ee.firstChild;)Ze.appendChild(Ee.firstChild);else Ze=Ee;return _&&(Ze=m.call(y,Ze,!0)),Ze}var rt=F?Ee.outerHTML:Ee.innerHTML;return V&&(rt=ut(rt,G," "),rt=ut(rt,J," ")),S&&Z?S.createHTML(rt):rt},t.setConfig=function(Te){Ne(Te),x=!0},t.clearConfig=function(){we=null,x=!1},t.isValidAttribute=function(Te,he,Ee){we||Ne({});var Me=ht(Te),Ue=ht(he);return $e(Me,Ue,Ee)},t.addHook=function(Te,he){typeof he=="function"&&(B[Te]=B[Te]||[],gt(B[Te],he))},t.removeHook=function(Te){B[Te]&&Mt(B[Te])},t.removeHooks=function(Te){B[Te]&&(B[Te]=[])},t.removeAllHooks=function(){B={}},t}var hi=Ut();define("vs/base/browser/dompurify/dompurify",function(){return hi}),define(me[38],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class y{constructor(p){this.domNode=p,this.a="",this.b="",this.c="",this.d="",this.e="",this.f="",this.g="",this.h="",this.i="",this.j="",this.k="",this.l="",this.m="",this.n="",this.o="",this.p="",this.q="",this.r="",this.s="",this.t="",this.u="",this.v="",this.w="",this.x="",this.y="",this.z="",this.A=!1,this.B="none",this.C=""}setMaxWidth(p){const A=M(p);this.a!==A&&(this.a=A,this.domNode.style.maxWidth=this.a)}setWidth(p){const A=M(p);this.b!==A&&(this.b=A,this.domNode.style.width=this.b)}setHeight(p){const A=M(p);this.c!==A&&(this.c=A,this.domNode.style.height=this.c)}setTop(p){const A=M(p);this.d!==A&&(this.d=A,this.domNode.style.top=this.d)}setLeft(p){const A=M(p);this.e!==A&&(this.e=A,this.domNode.style.left=this.e)}setBottom(p){const A=M(p);this.f!==A&&(this.f=A,this.domNode.style.bottom=this.f)}setRight(p){const A=M(p);this.g!==A&&(this.g=A,this.domNode.style.right=this.g)}setPaddingTop(p){const A=M(p);this.h!==A&&(this.h=A,this.domNode.style.paddingTop=this.h)}setPaddingLeft(p){const A=M(p);this.i!==A&&(this.i=A,this.domNode.style.paddingLeft=this.i)}setPaddingBottom(p){const A=M(p);this.j!==A&&(this.j=A,this.domNode.style.paddingBottom=this.j)}setPaddingRight(p){const A=M(p);this.k!==A&&(this.k=A,this.domNode.style.paddingRight=this.k)}setFontFamily(p){this.l!==p&&(this.l=p,this.domNode.style.fontFamily=this.l)}setFontWeight(p){this.m!==p&&(this.m=p,this.domNode.style.fontWeight=this.m)}setFontSize(p){const A=M(p);this.n!==A&&(this.n=A,this.domNode.style.fontSize=this.n)}setFontStyle(p){this.o!==p&&(this.o=p,this.domNode.style.fontStyle=this.o)}setFontFeatureSettings(p){this.p!==p&&(this.p=p,this.domNode.style.fontFeatureSettings=this.p)}setFontVariationSettings(p){this.q!==p&&(this.q=p,this.domNode.style.fontVariationSettings=this.q)}setTextDecoration(p){this.r!==p&&(this.r=p,this.domNode.style.textDecoration=this.r)}setLineHeight(p){const A=M(p);this.s!==A&&(this.s=A,this.domNode.style.lineHeight=this.s)}setLetterSpacing(p){const A=M(p);this.t!==A&&(this.t=A,this.domNode.style.letterSpacing=this.t)}setClassName(p){this.u!==p&&(this.u=p,this.domNode.className=this.u)}toggleClassName(p,A){this.domNode.classList.toggle(p,A),this.u=this.domNode.className}setDisplay(p){this.v!==p&&(this.v=p,this.domNode.style.display=this.v)}setPosition(p){this.w!==p&&(this.w=p,this.domNode.style.position=this.w)}setVisibility(p){this.x!==p&&(this.x=p,this.domNode.style.visibility=this.x)}setColor(p){this.y!==p&&(this.y=p,this.domNode.style.color=this.y)}setBackgroundColor(p){this.z!==p&&(this.z=p,this.domNode.style.backgroundColor=this.z)}setLayerHinting(p){this.A!==p&&(this.A=p,this.domNode.style.transform=this.A?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(p){this.C!==p&&(this.C=p,this.domNode.style.boxShadow=p)}setContain(p){this.B!==p&&(this.B=p,this.domNode.style.contain=this.B)}setAttribute(p,A){this.domNode.setAttribute(p,A)}removeAttribute(p){this.domNode.removeAttribute(p)}appendChild(p){this.domNode.appendChild(p.domNode)}removeChild(p){this.domNode.removeChild(p.domNode)}}t.FastDomNode=y;function M(W){return typeof W=="number"?`${W}px`:W}function i(W){return new y(W)}t.createFastDomNode=i}),define(me[66],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let y=!1,M=null;function i(p){if(!p.parent||p.parent===p)return null;try{const A=p.location,h=p.parent.location;if(A.origin!=="null"&&h.origin!=="null"&&A.origin!==h.origin)return y=!0,null}catch{return y=!0,null}return p.parent}class W{static getSameOriginWindowChain(){if(!M){M=[];let A=window,h;do h=i(A),h?M.push({window:A,iframeElement:A.frameElement||null}):M.push({window:A,iframeElement:null}),A=h;while(A)}return M.slice(0)}static hasDifferentOriginAncestor(){return M||this.getSameOriginWindowChain(),y}static getPositionOfChildWindowRelativeToAncestorWindow(A,h){if(!h||A===h)return{top:0,left:0};let a=0,c=0;const P=this.getSameOriginWindowChain();for(const r of P){if(a+=r.window.scrollY,c+=r.window.scrollX,r.window===h||!r.iframeElement)break;const l=r.iframeElement.getBoundingClientRect();a+=l.top,c+=l.left}return{top:a,left:c}}}t.IframeUtils=W}),define(me[67],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var y;(function(W){W[W.Copy=0]="Copy",W[W.Move=1]="Move"})(y||(t.ListDragOverEffect=y={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class M extends Error{constructor(p,A){super(`ListError [${p}] ${A}`)}}t.ListError=M;class i{constructor(){this.c=new WeakMap}getHeight(p){return this.c.get(p)??this.d(p)}setDynamicHeight(p,A){A>0&&this.c.set(p,A)}}t.CachedListVirtualDelegate=i}),define(me[68],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class y{constructor(i){this.a=i}splice(i,W,p){this.a.forEach(A=>A.splice(i,W,p))}}t.CombinedSpliceable=y}),define(me[39],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const y=20;class M{constructor(W,p,A,h,a,c){this.a=Math.round(p),this.b=Math.round(A),this.c=Math.round(W),this.d=h,this.e=a,this.f=c,this.g=0,this.h=!1,this.i=0,this.j=0,this.k=0,this.m()}clone(){return new M(this.c,this.a,this.b,this.d,this.e,this.f)}setVisibleSize(W){const p=Math.round(W);return this.d!==p?(this.d=p,this.m(),!0):!1}setScrollSize(W){const p=Math.round(W);return this.e!==p?(this.e=p,this.m(),!0):!1}setScrollPosition(W){const p=Math.round(W);return this.f!==p?(this.f=p,this.m(),!0):!1}setScrollbarSize(W){this.a=Math.round(W)}setOppositeScrollbarSize(W){this.b=Math.round(W)}static l(W,p,A,h,a){const c=Math.max(0,A-W),P=Math.max(0,c-2*p),r=h>0&&h>A;if(!r)return{computedAvailableSize:Math.round(c),computedIsNeeded:r,computedSliderSize:Math.round(P),computedSliderRatio:0,computedSliderPosition:0};const l=Math.round(Math.max(y,Math.floor(A*P/h))),e=(P-l)/(h-A),o=a*e;return{computedAvailableSize:Math.round(c),computedIsNeeded:r,computedSliderSize:Math.round(l),computedSliderRatio:e,computedSliderPosition:Math.round(o)}}m(){const W=M.l(this.b,this.c,this.d,this.e,this.f);this.g=W.computedAvailableSize,this.h=W.computedIsNeeded,this.i=W.computedSliderSize,this.j=W.computedSliderRatio,this.k=W.computedSliderPosition}getArrowSize(){return this.c}getScrollPosition(){return this.f}getRectangleLargeSize(){return this.g}getRectangleSmallSize(){return this.a}isNeeded(){return this.h}getSliderSize(){return this.i}getSliderPosition(){return this.k}getDesiredScrollPositionFromOffset(W){if(!this.h)return 0;const p=W-this.c-this.i/2;return Math.round(p/this.j)}getDesiredScrollPositionFromOffsetPaged(W){if(!this.h)return 0;const p=W-this.c;let A=this.f;return p<this.k?A-=this.d:A+=this.d,A}getDesiredScrollPositionFromDelta(W){if(!this.h)return 0;const p=this.k+W;return Math.round(p/this.j)}}t.ScrollbarState=M}),define(me[24],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.ObjectTreeElementCollapseState=t.TreeVisibility=void 0;var y;(function(h){h[h.Hidden=0]="Hidden",h[h.Visible=1]="Visible",h[h.Recurse=2]="Recurse"})(y||(t.TreeVisibility=y={}));var M;(function(h){h[h.Expanded=0]="Expanded",h[h.Collapsed=1]="Collapsed",h[h.PreserveOrExpanded=2]="PreserveOrExpanded",h[h.PreserveOrCollapsed=3]="PreserveOrCollapsed"})(M||(t.ObjectTreeElementCollapseState=M={}));var i;(function(h){h[h.Unknown=0]="Unknown",h[h.Twistie=1]="Twistie",h[h.Element=2]="Element",h[h.Filter=3]="Filter"})(i||(t.TreeMouseEventTarget=i={}));var W;(function(h){h[h.Down=0]="Down",h[h.Up=1]="Up"})(W||(t.TreeDragOverBubble=W={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(h=!1){return{accept:!0,bubble:0,autoExpand:h}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(h=!1){return{accept:!0,bubble:0,effect:0,autoExpand:h}}};class p extends Error{constructor(a,c){super(`TreeError [${a}] ${c}`)}}t.TreeError=p;class A{constructor(a){this.a=a,this.b=new WeakMap}map(a){let c=this.b.get(a);return c||(c=this.a(a),this.b.set(a,c)),c}}t.WeakMapper=A}),define(me[69],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function y(p,A){const h=Object.create(null);for(const a of p){const c=A(a);let P=h[c];P||(P=h[c]=[]),P.push(a)}return h}t.groupBy=y;function M(p,A){const h=[],a=[];for(const c of p)A.has(c)||h.push(c);for(const c of A)p.has(c)||a.push(c);return{removed:h,added:a}}t.diffSets=M;function i(p,A){const h=[],a=[];for(const[c,P]of p)A.has(c)||h.push(P);for(const[c,P]of A)p.has(c)||a.push(P);return{removed:h,added:a}}t.diffMaps=i;class W{constructor(){this.a=new Map}add(A,h){let a=this.a.get(A);a||(a=new Set,this.a.set(A,a)),a.add(h)}delete(A,h){const a=this.a.get(A);a&&(a.delete(h),a.size===0&&this.a.delete(A))}forEach(A,h){const a=this.a.get(A);a&&a.forEach(h)}}t.SetMap=W}),define(me[70],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function y(A,h){const a=Math.pow(10,h);return Math.round(A*a)/a}class M{constructor(h,a,c,P=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,h))|0,this.g=Math.min(255,Math.max(0,a))|0,this.b=Math.min(255,Math.max(0,c))|0,this.a=y(Math.max(Math.min(1,P),0),3)}static equals(h,a){return h.r===a.r&&h.g===a.g&&h.b===a.b&&h.a===a.a}}t.RGBA=M;class i{constructor(h,a,c,P){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=y(Math.max(Math.min(1,a),0),3),this.l=y(Math.max(Math.min(1,c),0),3),this.a=y(Math.max(Math.min(1,P),0),3)}static equals(h,a){return h.h===a.h&&h.s===a.s&&h.l===a.l&&h.a===a.a}static fromRGBA(h){const a=h.r/255,c=h.g/255,P=h.b/255,r=h.a,l=Math.max(a,c,P),e=Math.min(a,c,P);let o=0,n=0;const u=(e+l)/2,s=l-e;if(s>0){switch(n=Math.min(u<=.5?s/(2*u):s/(2-2*u),1),l){case a:o=(c-P)/s+(c<P?6:0);break;case c:o=(P-a)/s+2;break;case P:o=(a-c)/s+4;break}o*=60,o=Math.round(o)}return new i(o,n,u,r)}static i(h,a,c){return c<0&&(c+=1),c>1&&(c-=1),c<1/6?h+(a-h)*6*c:c<1/2?a:c<2/3?h+(a-h)*(2/3-c)*6:h}static toRGBA(h){const a=h.h/360,{s:c,l:P,a:r}=h;let l,e,o;if(c===0)l=e=o=P;else{const n=P<.5?P*(1+c):P+c-P*c,u=2*P-n;l=i.i(u,n,a+1/3),e=i.i(u,n,a),o=i.i(u,n,a-1/3)}return new M(Math.round(l*255),Math.round(e*255),Math.round(o*255),r)}}t.HSLA=i;class W{constructor(h,a,c,P){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,h),0)|0,this.s=y(Math.max(Math.min(1,a),0),3),this.v=y(Math.max(Math.min(1,c),0),3),this.a=y(Math.max(Math.min(1,P),0),3)}static equals(h,a){return h.h===a.h&&h.s===a.s&&h.v===a.v&&h.a===a.a}static fromRGBA(h){const a=h.r/255,c=h.g/255,P=h.b/255,r=Math.max(a,c,P),l=Math.min(a,c,P),e=r-l,o=r===0?0:e/r;let n;return e===0?n=0:r===a?n=((c-P)/e%6+6)%6:r===c?n=(P-a)/e+2:n=(a-c)/e+4,new W(Math.round(n*60),o,r,h.a)}static toRGBA(h){const{h:a,s:c,v:P,a:r}=h,l=P*c,e=l*(1-Math.abs(a/60%2-1)),o=P-l;let[n,u,s]=[0,0,0];return a<60?(n=l,u=e):a<120?(n=e,u=l):a<180?(u=l,s=e):a<240?(u=e,s=l):a<300?(n=e,s=l):a<=360&&(n=l,s=e),n=Math.round((n+o)*255),u=Math.round((u+o)*255),s=Math.round((s+o)*255),new M(n,u,s,r)}}t.HSVA=W;class p{static fromHex(h){return p.Format.CSS.parseHex(h)||p.red}static equals(h,a){return!h&&!a?!0:!h||!a?!1:h.equals(a)}get hsla(){return this.i?this.i:i.fromRGBA(this.rgba)}get hsva(){return this.j?this.j:W.fromRGBA(this.rgba)}constructor(h){if(h)if(h instanceof M)this.rgba=h;else if(h instanceof i)this.i=h,this.rgba=i.toRGBA(h);else if(h instanceof W)this.j=h,this.rgba=W.toRGBA(h);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}equals(h){return!!h&&M.equals(this.rgba,h.rgba)&&i.equals(this.hsla,h.hsla)&&W.equals(this.hsva,h.hsva)}getRelativeLuminance(){const h=p.k(this.rgba.r),a=p.k(this.rgba.g),c=p.k(this.rgba.b),P=.2126*h+.7152*a+.0722*c;return y(P,4)}static k(h){const a=h/255;return a<=.03928?a/12.92:Math.pow((a+.055)/1.055,2.4)}getContrastRatio(h){const a=this.getRelativeLuminance(),c=h.getRelativeLuminance();return a>c?(a+.05)/(c+.05):(c+.05)/(a+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(h){const a=this.getRelativeLuminance(),c=h.getRelativeLuminance();return a>c}isDarkerThan(h){const a=this.getRelativeLuminance(),c=h.getRelativeLuminance();return a<c}lighten(h){return new p(new i(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*h,this.hsla.a))}darken(h){return new p(new i(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*h,this.hsla.a))}transparent(h){const{r:a,g:c,b:P,a:r}=this.rgba;return new p(new M(a,c,P,r*h))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new p(new M(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(h){const a=h.rgba,c=this.rgba.a,P=a.a,r=c+P*(1-c);if(r<1e-6)return p.transparent;const l=this.rgba.r*c/r+a.r*P*(1-c)/r,e=this.rgba.g*c/r+a.g*P*(1-c)/r,o=this.rgba.b*c/r+a.b*P*(1-c)/r;return new p(new M(l,e,o,r))}makeOpaque(h){if(this.isOpaque()||h.rgba.a!==1)return this;const{r:a,g:c,b:P,a:r}=this.rgba;return new p(new M(h.rgba.r-r*(h.rgba.r-a),h.rgba.g-r*(h.rgba.g-c),h.rgba.b-r*(h.rgba.b-P),1))}flatten(...h){const a=h.reduceRight((c,P)=>p.o(P,c));return p.o(this,a)}static o(h,a){const c=1-h.rgba.a;return new p(new M(c*a.rgba.r+h.rgba.a*h.rgba.r,c*a.rgba.g+h.rgba.a*h.rgba.g,c*a.rgba.b+h.rgba.a*h.rgba.b))}toString(){return this.u||(this.u=p.Format.CSS.format(this)),this.u}static getLighterColor(h,a,c){if(h.isLighterThan(a))return h;c=c||.5;const P=h.getRelativeLuminance(),r=a.getRelativeLuminance();return c=c*(r-P)/r,h.lighten(c)}static getDarkerColor(h,a,c){if(h.isDarkerThan(a))return h;c=c||.5;const P=h.getRelativeLuminance(),r=a.getRelativeLuminance();return c=c*(P-r)/P,h.darken(c)}}t.Color=p,p.white=new p(new M(255,255,255,1)),p.black=new p(new M(0,0,0,1)),p.red=new p(new M(255,0,0,1)),p.blue=new p(new M(0,0,255,1)),p.green=new p(new M(0,255,0,1)),p.cyan=new p(new M(0,255,255,1)),p.lightgrey=new p(new M(211,211,211,1)),p.transparent=new p(new M(0,0,0,0)),function(A){let h;(function(a){let c;(function(P){function r(f){return f.rgba.a===1?`rgb(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b})`:A.Format.CSS.formatRGBA(f)}P.formatRGB=r;function l(f){return`rgba(${f.rgba.r}, ${f.rgba.g}, ${f.rgba.b}, ${+f.rgba.a.toFixed(2)})`}P.formatRGBA=l;function e(f){return f.hsla.a===1?`hsl(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%)`:A.Format.CSS.formatHSLA(f)}P.formatHSL=e;function o(f){return`hsla(${f.hsla.h}, ${(f.hsla.s*100).toFixed(2)}%, ${(f.hsla.l*100).toFixed(2)}%, ${f.hsla.a.toFixed(2)})`}P.formatHSLA=o;function n(f){const v=f.toString(16);return v.length!==2?"0"+v:v}function u(f){return`#${n(f.rgba.r)}${n(f.rgba.g)}${n(f.rgba.b)}`}P.formatHex=u;function s(f,v=!1){return v&&f.rgba.a===1?A.Format.CSS.formatHex(f):`#${n(f.rgba.r)}${n(f.rgba.g)}${n(f.rgba.b)}${n(Math.round(f.rgba.a*255))}`}P.formatHexA=s;function w(f){return f.isOpaque()?A.Format.CSS.formatHex(f):A.Format.CSS.formatRGBA(f)}P.format=w;function D(f){const v=f.length;if(v===0||f.charCodeAt(0)!==35)return null;if(v===7){const L=16*S(f.charCodeAt(1))+S(f.charCodeAt(2)),N=16*S(f.charCodeAt(3))+S(f.charCodeAt(4)),E=16*S(f.charCodeAt(5))+S(f.charCodeAt(6));return new A(new M(L,N,E,1))}if(v===9){const L=16*S(f.charCodeAt(1))+S(f.charCodeAt(2)),N=16*S(f.charCodeAt(3))+S(f.charCodeAt(4)),E=16*S(f.charCodeAt(5))+S(f.charCodeAt(6)),g=16*S(f.charCodeAt(7))+S(f.charCodeAt(8));return new A(new M(L,N,E,g/255))}if(v===4){const L=S(f.charCodeAt(1)),N=S(f.charCodeAt(2)),E=S(f.charCodeAt(3));return new A(new M(16*L+L,16*N+N,16*E+E))}if(v===5){const L=S(f.charCodeAt(1)),N=S(f.charCodeAt(2)),E=S(f.charCodeAt(3)),g=S(f.charCodeAt(4));return new A(new M(16*L+L,16*N+N,16*E+E,(16*g+g)/255))}return null}P.parseHex=D;function S(f){switch(f){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(c=a.CSS||(a.CSS={}))})(h=A.Format||(A.Format={}))}(p||(t.Color=p={}))}),define(me[25],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=void 0;function y(p){return(A,h,a)=>{let c=null,P=null;if(typeof a.value=="function"?(c="value",P=a.value):typeof a.get=="function"&&(c="get",P=a.get),!P)throw new Error("not supported");a[c]=p(P,h)}}function M(p,A,h){let a=null,c=null;if(typeof h.value=="function"?(a="value",c=h.value,c.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof h.get=="function"&&(a="get",c=h.get),!c)throw new Error("not supported");const P=`$memoize$${A}`;h[a]=function(...r){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:c.apply(this,r)}),this[P]}}t.memoize=M;function i(p,A,h){return y((a,c)=>{const P=`$debounce$${c}`,r=`$debounce$result$${c}`;return function(...l){this[r]||(this[r]=h?h():void 0),clearTimeout(this[P]),A&&(this[r]=A(this[r],...l),l=[this[r]]),this[P]=setTimeout(()=>{a.apply(this,l),this[r]=h?h():void 0},p)}})}t.debounce=i;function W(p,A,h){return y((a,c)=>{const P=`$throttle$timer$${c}`,r=`$throttle$result$${c}`,l=`$throttle$lastRun$${c}`,e=`$throttle$pending$${c}`;return function(...o){if(this[r]||(this[r]=h?h():void 0),(this[l]===null||this[l]===void 0)&&(this[l]=-Number.MAX_VALUE),A&&(this[r]=A(this[r],...o)),this[e])return;const n=this[l]+p;n<=Date.now()?(this[l]=Date.now(),a.apply(this,[this[r]]),this[r]=h?h():void 0):(this[e]=!0,this[P]=setTimeout(()=>{this[e]=!1,this[l]=Date.now(),a.apply(this,[this[r]]),this[r]=h?h():void 0},n-Date.now()))}})}t.throttle=W}),define(me[71],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class y{constructor(i,W,p,A){this.originalStart=i,this.originalLength=W,this.modifiedStart=p,this.modifiedLength=A}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=y}),define(me[7],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.isSigPipeError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class y{constructor(){this.b=[],this.a=function(v){setTimeout(()=>{throw v.stack?D.isErrorNoTelemetry(v)?new D(v.message+`

`+v.stack):new Error(v.message+`

`+v.stack):v},0)}}addListener(v){return this.b.push(v),()=>{this.d(v)}}c(v){this.b.forEach(L=>{L(v)})}d(v){this.b.splice(this.b.indexOf(v),1)}setUnexpectedErrorHandler(v){this.a=v}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(v){this.a(v),this.c(v)}onUnexpectedExternalError(v){this.a(v)}}t.ErrorHandler=y,t.errorHandler=new y;function M(f){t.errorHandler.setUnexpectedErrorHandler(f)}t.setUnexpectedErrorHandler=M;function i(f){if(!f||typeof f!="object")return!1;const v=f;return v.code==="EPIPE"&&v.syscall?.toUpperCase()==="WRITE"}t.isSigPipeError=i;function W(f){a(f)||t.errorHandler.onUnexpectedError(f)}t.onUnexpectedError=W;function p(f){a(f)||t.errorHandler.onUnexpectedExternalError(f)}t.onUnexpectedExternalError=p;function A(f){if(f instanceof Error){const{name:v,message:L}=f,N=f.stacktrace||f.stack;return{$isError:!0,name:v,message:L,stack:N,noTelemetry:D.isErrorNoTelemetry(f)}}return f}t.transformErrorForSerialization=A;const h="Canceled";function a(f){return f instanceof c?!0:f instanceof Error&&f.name===h&&f.message===h}t.isCancellationError=a;class c extends Error{constructor(){super(h),this.name=this.message}}t.CancellationError=c;function P(){const f=new Error(h);return f.name=f.message,f}t.canceled=P;function r(f){return f?new Error(`Illegal argument: ${f}`):new Error("Illegal argument")}t.illegalArgument=r;function l(f){return f?new Error(`Illegal state: ${f}`):new Error("Illegal state")}t.illegalState=l;function e(f){return f?new Error(`readonly property '${f} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=e;function o(f){const v=new Error(`${f} has been disposed`);return v.name="DISPOSED",v}t.disposed=o;function n(f){return f?f.message?f.message:f.stack?f.stack.split(`
`)[0]:String(f):"Error"}t.getErrorMessage=n;class u extends Error{constructor(v){super("NotImplemented"),v&&(this.message=v)}}t.NotImplementedError=u;class s extends Error{constructor(v){super("NotSupported"),v&&(this.message=v)}}t.NotSupportedError=s;class w extends Error{constructor(){super(...arguments),this.isExpected=!0}}t.ExpectedError=w;class D extends Error{constructor(v){super(v),this.name="CodeExpectedError"}static fromError(v){if(v instanceof D)return v;const L=new D;return L.message=v.message,L.stack=v.stack,L}static isErrorNoTelemetry(v){return v.name==="CodeExpectedError"}}t.ErrorNoTelemetry=D;class S extends Error{constructor(v){super(v||"An unexpected bug occurred."),Object.setPrototypeOf(this,S.prototype);debugger}}t.BugIndicatingError=S}),define(me[13],be([1,0,7]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function M(k,T=0){return k[k.length-(1+T)]}t.tail=M;function i(k){if(k.length===0)throw new Error("Invalid tail call");return[k.slice(0,k.length-1),k[k.length-1]]}t.tail2=i;function W(k,T,H=(C,U)=>C===U){if(k===T)return!0;if(!k||!T||k.length!==T.length)return!1;for(let C=0,U=k.length;C<U;C++)if(!H(k[C],T[C]))return!1;return!0}t.equals=W;function p(k,T){const H=k.length-1;T<H&&(k[T]=k[H]),k.pop()}t.removeFastWithoutKeepingOrder=p;function A(k,T,H){return h(k.length,C=>H(k[C],T))}t.binarySearch=A;function h(k,T){let H=0,C=k-1;for(;H<=C;){const U=(H+C)/2|0,z=T(U);if(z<0)H=U+1;else if(z>0)C=U-1;else return U}return-(H+1)}t.binarySearch2=h;function a(k,T){let H=0,C=k.length;if(C===0)return 0;for(;H<C;){const U=Math.floor((H+C)/2);T(k[U])?C=U:H=U+1}return H}t.findFirstInSorted=a;function c(k,T,H){if(k=k|0,k>=T.length)throw new TypeError("invalid index");const C=T[Math.floor(T.length*Math.random())],U=[],z=[],O=[];for(const $ of T){const q=H($,C);q<0?U.push($):q>0?z.push($):O.push($)}return k<U.length?c(k,U,H):k<U.length+O.length?O[0]:c(k-(U.length+O.length),z,H)}t.quickSelect=c;function P(k,T){const H=[];let C;for(const U of k.slice(0).sort(T))!C||T(C[0],U)!==0?(C=[U],H.push(C)):C.push(U);return H}t.groupBy=P;function r(k,T,H){const C=[];function U($,q,ee){if(q===0&&ee.length===0)return;const se=C[C.length-1];se&&se.start+se.deleteCount===$?(se.deleteCount+=q,se.toInsert.push(...ee)):C.push({start:$,deleteCount:q,toInsert:ee})}let z=0,O=0;for(;;){if(z===k.length){U(z,0,T.slice(O));break}if(O===T.length){U(z,k.length-z,[]);break}const $=k[z],q=T[O],ee=H($,q);ee===0?(z+=1,O+=1):ee<0?(U(z,1,[]),z+=1):ee>0&&(U(z,0,[q]),O+=1)}return C}t.sortedDiff=r;function l(k,T,H){const C=r(k,T,H),U=[],z=[];for(const O of C)U.push(...k.slice(O.start,O.start+O.deleteCount)),z.push(...O.toInsert);return{removed:U,added:z}}t.delta=l;function e(k,T,H){if(H===0)return[];const C=k.slice(0,H).sort(T);return n(k,T,C,H,k.length),C}t.top=e;function o(k,T,H,C,U){return H===0?Promise.resolve([]):new Promise((z,O)=>{(async()=>{const $=k.length,q=k.slice(0,H).sort(T);for(let ee=H,se=Math.min(H+C,$);ee<$;ee=se,se=Math.min(se+C,$)){if(ee>H&&await new Promise(ve=>setTimeout(ve)),U&&U.isCancellationRequested)throw new y.CancellationError;n(k,T,q,ee,se)}return q})().then(z,O)})}t.topAsync=o;function n(k,T,H,C,U){for(const z=H.length;C<U;C++){const O=k[C];if(T(O,H[z-1])<0){H.pop();const $=a(H,q=>T(O,q)<0);H.splice($,0,O)}}}function u(k){return k.filter(T=>!!T)}t.coalesce=u;function s(k){let T=0;for(let H=0;H<k.length;H++)k[H]&&(k[T]=k[H],T+=1);k.length=T}t.coalesceInPlace=s;function w(k,T,H){k.splice(H,0,k.splice(T,1)[0])}t.move=w;function D(k){return!Array.isArray(k)||k.length===0}t.isFalsyOrEmpty=D;function S(k){return Array.isArray(k)&&k.length>0}t.isNonEmptyArray=S;function f(k,T=H=>H){const H=new Set;return k.filter(C=>{const U=T(C);return H.has(U)?!1:(H.add(U),!0)})}t.distinct=f;function v(k){const T=new Set;return H=>{const C=k(H);return T.has(C)?!1:(T.add(C),!0)}}t.uniqueFilter=v;function L(k,T){const H=N(k,T);if(H!==-1)return k[H]}t.findLast=L;function N(k,T){for(let H=k.length-1;H>=0;H--){const C=k[H];if(T(C))return H}return-1}t.lastIndex=N;function E(k,T){return k.length>0?k[0]:T}t.firstOrDefault=E;function g(k,T){return k.length>0?k[k.length-1]:T}t.lastOrDefault=g;function m(k,T,H=(C,U)=>C===U){let C=0;for(let U=0,z=Math.min(k.length,T.length);U<z&&H(k[U],T[U]);U++)C++;return C}t.commonPrefixLength=m;function b(k){return[].concat(...k)}t.flatten=b;function B(k,T){let H=typeof T=="number"?k:0;typeof T=="number"?H=k:(H=0,T=k);const C=[];if(H<=T)for(let U=H;U<T;U++)C.push(U);else for(let U=H;U>T;U--)C.push(U);return C}t.range=B;function G(k,T,H){return k.reduce((C,U)=>(C[T(U)]=H?H(U):U,C),Object.create(null))}t.index=G;function J(k,T){return k.push(T),()=>ie(k,T)}t.insert=J;function ie(k,T){const H=k.indexOf(T);if(H>-1)return k.splice(H,1),T}t.remove=ie;function le(k,T,H){const C=k.slice(0,T),U=k.slice(T);return C.concat(H,U)}t.arrayInsert=le;function ge(k,T){let H;if(typeof T=="number"){let C=T;H=()=>{const U=Math.sin(C++)*179426549;return U-Math.floor(U)}}else H=Math.random;for(let C=k.length-1;C>0;C-=1){const U=Math.floor(H()*(C+1)),z=k[C];k[C]=k[U],k[U]=z}}t.shuffle=ge;function ue(k,T){const H=k.indexOf(T);H>-1&&(k.splice(H,1),k.unshift(T))}t.pushToStart=ue;function de(k,T){const H=k.indexOf(T);H>-1&&(k.splice(H,1),k.push(T))}t.pushToEnd=de;function ce(k,T){for(const H of T)k.push(H)}t.pushMany=ce;function Se(k,T){return Array.isArray(k)?k.map(T):T(k)}t.mapArrayOrNot=Se;function Ae(k){return Array.isArray(k)?k:[k]}t.asArray=Ae;function Be(k){return k[Math.floor(Math.random()*k.length)]}t.getRandomElement=Be;function re(k,T){for(const H of k){const C=T(H);if(C!==void 0)return C}}t.mapFind=re;function ne(k,T,H){const C=oe(k,T),U=k.length,z=H.length;k.length=U+z;for(let O=U-1;O>=C;O--)k[O+z]=k[O];for(let O=0;O<z;O++)k[O+C]=H[O]}t.insertInto=ne;function Q(k,T,H,C){const U=oe(k,T),z=k.splice(U,H);return ne(k,U,C),z}t.splice=Q;function oe(k,T){return T<0?Math.max(T+k.length,0):Math.min(T,k.length)}var j;(function(k){function T(U){return U<0}k.isLessThan=T;function H(U){return U>0}k.isGreaterThan=H;function C(U){return U===0}k.isNeitherLessOrGreaterThan=C,k.greaterThan=1,k.lessThan=-1,k.neitherLessOrGreaterThan=0})(j||(t.CompareResult=j={}));function V(k,T){return(H,C)=>T(k(H),k(C))}t.compareBy=V;function F(...k){return(T,H)=>{for(const C of k){const U=C(T,H);if(!j.isNeitherLessOrGreaterThan(U))return U}return j.neitherLessOrGreaterThan}}t.tieBreakComparators=F;const x=(k,T)=>k-T;t.numberComparator=x;function I(k,T){if(k.length===0)return;let H=k[0];for(let C=1;C<k.length;C++){const U=k[C];T(U,H)>0&&(H=U)}return H}t.findMaxBy=I;function d(k,T){if(k.length===0)return;let H=k[0];for(let C=1;C<k.length;C++){const U=k[C];T(U,H)>=0&&(H=U)}return H}t.findLastMaxBy=d;function R(k,T){return I(k,(H,C)=>-T(H,C))}t.findMinBy=R;class _{constructor(T){this.f=T,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(T){let H=this.c;for(;H<this.f.length&&T(this.f[H]);)H++;const C=H===this.c?null:this.f.slice(this.c,H);return this.c=H,C}takeFromEndWhile(T){let H=this.d;for(;H>=0&&T(this.f[H]);)H--;const C=H===this.d?null:this.f.slice(H+1,this.d+1);return this.d=H,C}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const T=this.f[this.c];return this.c++,T}removeLast(){const T=this.f[this.d];return this.d--,T}takeCount(T){const H=this.f.slice(this.c,this.c+T);return this.c+=T,H}}t.ArrayQueue=_;class Z{constructor(T){this.iterate=T}forEach(T){this.iterate(H=>(T(H),!0))}toArray(){const T=[];return this.iterate(H=>(T.push(H),!0)),T}filter(T){return new Z(H=>this.iterate(C=>T(C)?H(C):!0))}map(T){return new Z(H=>this.iterate(C=>H(T(C))))}some(T){let H=!1;return this.iterate(C=>(H=T(C),!H)),H}findFirst(T){let H;return this.iterate(C=>T(C)?(H=C,!1):!0),H}findLast(T){let H;return this.iterate(C=>(T(C)&&(H=C),!0)),H}findLastMaxBy(T){let H,C=!0;return this.iterate(U=>((C||j.isGreaterThan(T(U,H)))&&(C=!1,H=U),!0)),H}}t.CallbackIterable=Z,Z.empty=new Z(k=>{})}),define(me[72],be([1,0,7]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.checkAdjacentItems=t.assertFn=t.assert=t.assertNever=t.ok=void 0;function M(h,a){if(!h)throw new Error(a?`Assertion failed (${a})`:"Assertion Failed")}t.ok=M;function i(h,a="Unreachable"){throw new Error(a)}t.assertNever=i;function W(h){if(!h)throw new y.BugIndicatingError("Assertion Failed")}t.assert=W;function p(h){if(!h()){debugger;h(),(0,y.onUnexpectedError)(new y.BugIndicatingError("Assertion Failed"))}}t.assertFn=p;function A(h,a){let c=0;for(;c<h.length-1;){const P=h[c],r=h[c+1];if(!a(P,r))return!1;c++}return!0}t.checkAdjacentItems=A}),define(me[40],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function y(M){const i=this;let W=!1,p;return function(){return W||(W=!0,p=M.apply(i,arguments)),p}}t.once=y}),define(me[73],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class y{constructor(i){this.a=i,this.b=0}nextId(){return this.a+ ++this.b}}t.IdGenerator=y,t.defaultGenerator=new y("id#")}),define(me[26],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var y;(function(M){function i(D){return D&&typeof D=="object"&&typeof D[Symbol.iterator]=="function"}M.is=i;const W=Object.freeze([]);function p(){return W}M.empty=p;function*A(D){yield D}M.single=A;function h(D){return i(D)?D:A(D)}M.wrap=h;function a(D){return D||W}M.from=a;function c(D){return!D||D[Symbol.iterator]().next().done===!0}M.isEmpty=c;function P(D){return D[Symbol.iterator]().next().value}M.first=P;function r(D,S){for(const f of D)if(S(f))return!0;return!1}M.some=r;function l(D,S){for(const f of D)if(S(f))return f}M.find=l;function*e(D,S){for(const f of D)S(f)&&(yield f)}M.filter=e;function*o(D,S){let f=0;for(const v of D)yield S(v,f++)}M.map=o;function*n(...D){for(const S of D)for(const f of S)yield f}M.concat=n;function u(D,S,f){let v=f;for(const L of D)v=S(v,L);return v}M.reduce=u;function*s(D,S,f=D.length){for(S<0&&(S+=D.length),f<0?f+=D.length:f>D.length&&(f=D.length);S<f;S++)yield D[S]}M.slice=s;function w(D,S=Number.POSITIVE_INFINITY){const f=[];if(S===0)return[f,D];const v=D[Symbol.iterator]();for(let L=0;L<S;L++){const N=v.next();if(N.done)return[f,M.empty()];f.push(N.value)}return[f,{[Symbol.iterator](){return v}}]}M.consume=w})(y||(t.Iterable=y={}))}),define(me[41],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var y;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.F20=78]="F20",e[e.F21=79]="F21",e[e.F22=80]="F22",e[e.F23=81]="F23",e[e.F24=82]="F24",e[e.NumLock=83]="NumLock",e[e.ScrollLock=84]="ScrollLock",e[e.Semicolon=85]="Semicolon",e[e.Equal=86]="Equal",e[e.Comma=87]="Comma",e[e.Minus=88]="Minus",e[e.Period=89]="Period",e[e.Slash=90]="Slash",e[e.Backquote=91]="Backquote",e[e.BracketLeft=92]="BracketLeft",e[e.Backslash=93]="Backslash",e[e.BracketRight=94]="BracketRight",e[e.Quote=95]="Quote",e[e.OEM_8=96]="OEM_8",e[e.IntlBackslash=97]="IntlBackslash",e[e.Numpad0=98]="Numpad0",e[e.Numpad1=99]="Numpad1",e[e.Numpad2=100]="Numpad2",e[e.Numpad3=101]="Numpad3",e[e.Numpad4=102]="Numpad4",e[e.Numpad5=103]="Numpad5",e[e.Numpad6=104]="Numpad6",e[e.Numpad7=105]="Numpad7",e[e.Numpad8=106]="Numpad8",e[e.Numpad9=107]="Numpad9",e[e.NumpadMultiply=108]="NumpadMultiply",e[e.NumpadAdd=109]="NumpadAdd",e[e.NUMPAD_SEPARATOR=110]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=111]="NumpadSubtract",e[e.NumpadDecimal=112]="NumpadDecimal",e[e.NumpadDivide=113]="NumpadDivide",e[e.KEY_IN_COMPOSITION=114]="KEY_IN_COMPOSITION",e[e.ABNT_C1=115]="ABNT_C1",e[e.ABNT_C2=116]="ABNT_C2",e[e.AudioVolumeMute=117]="AudioVolumeMute",e[e.AudioVolumeUp=118]="AudioVolumeUp",e[e.AudioVolumeDown=119]="AudioVolumeDown",e[e.BrowserSearch=120]="BrowserSearch",e[e.BrowserHome=121]="BrowserHome",e[e.BrowserBack=122]="BrowserBack",e[e.BrowserForward=123]="BrowserForward",e[e.MediaTrackNext=124]="MediaTrackNext",e[e.MediaTrackPrevious=125]="MediaTrackPrevious",e[e.MediaStop=126]="MediaStop",e[e.MediaPlayPause=127]="MediaPlayPause",e[e.LaunchMediaPlayer=128]="LaunchMediaPlayer",e[e.LaunchMail=129]="LaunchMail",e[e.LaunchApp2=130]="LaunchApp2",e[e.Clear=131]="Clear",e[e.MAX_VALUE=132]="MAX_VALUE"})(y||(t.KeyCode=y={}));var M;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(M||(t.ScanCode=M={}));class i{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(o,n){this._keyCodeToStr[o]=n,this._strToKeyCode[n.toLowerCase()]=o}keyCodeToStr(o){return this._keyCodeToStr[o]}strToKeyCode(o){return this._strToKeyCode[o.toLowerCase()]||0}}const W=new i,p=new i,A=new i;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const h=[],a=Object.create(null),c=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>c[e]||0,toEnum:e=>a[e]||0,toString:e=>h[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=132;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",o=[[1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[1,1,"Hyper",0,e,0,e,e,e],[1,2,"Super",0,e,0,e,e,e],[1,3,"Fn",0,e,0,e,e,e],[1,4,"FnLock",0,e,0,e,e,e],[1,5,"Suspend",0,e,0,e,e,e],[1,6,"Resume",0,e,0,e,e,e],[1,7,"Turbo",0,e,0,e,e,e],[1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[1,9,"WakeUp",0,e,0,e,e,e],[0,10,"KeyA",31,"A",65,"VK_A",e,e],[0,11,"KeyB",32,"B",66,"VK_B",e,e],[0,12,"KeyC",33,"C",67,"VK_C",e,e],[0,13,"KeyD",34,"D",68,"VK_D",e,e],[0,14,"KeyE",35,"E",69,"VK_E",e,e],[0,15,"KeyF",36,"F",70,"VK_F",e,e],[0,16,"KeyG",37,"G",71,"VK_G",e,e],[0,17,"KeyH",38,"H",72,"VK_H",e,e],[0,18,"KeyI",39,"I",73,"VK_I",e,e],[0,19,"KeyJ",40,"J",74,"VK_J",e,e],[0,20,"KeyK",41,"K",75,"VK_K",e,e],[0,21,"KeyL",42,"L",76,"VK_L",e,e],[0,22,"KeyM",43,"M",77,"VK_M",e,e],[0,23,"KeyN",44,"N",78,"VK_N",e,e],[0,24,"KeyO",45,"O",79,"VK_O",e,e],[0,25,"KeyP",46,"P",80,"VK_P",e,e],[0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[0,27,"KeyR",48,"R",82,"VK_R",e,e],[0,28,"KeyS",49,"S",83,"VK_S",e,e],[0,29,"KeyT",50,"T",84,"VK_T",e,e],[0,30,"KeyU",51,"U",85,"VK_U",e,e],[0,31,"KeyV",52,"V",86,"VK_V",e,e],[0,32,"KeyW",53,"W",87,"VK_W",e,e],[0,33,"KeyX",54,"X",88,"VK_X",e,e],[0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[0,36,"Digit1",22,"1",49,"VK_1",e,e],[0,37,"Digit2",23,"2",50,"VK_2",e,e],[0,38,"Digit3",24,"3",51,"VK_3",e,e],[0,39,"Digit4",25,"4",52,"VK_4",e,e],[0,40,"Digit5",26,"5",53,"VK_5",e,e],[0,41,"Digit6",27,"6",54,"VK_6",e,e],[0,42,"Digit7",28,"7",55,"VK_7",e,e],[0,43,"Digit8",29,"8",56,"VK_8",e,e],[0,44,"Digit9",30,"9",57,"VK_9",e,e],[0,45,"Digit0",21,"0",48,"VK_0",e,e],[1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[0,51,"Minus",88,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[0,52,"Equal",86,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[0,53,"BracketLeft",92,"[",219,"VK_OEM_4","[","OEM_4"],[0,54,"BracketRight",94,"]",221,"VK_OEM_6","]","OEM_6"],[0,55,"Backslash",93,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,56,"IntlHash",0,e,0,e,e,e],[0,57,"Semicolon",85,";",186,"VK_OEM_1",";","OEM_1"],[0,58,"Quote",95,"'",222,"VK_OEM_7","'","OEM_7"],[0,59,"Backquote",91,"`",192,"VK_OEM_3","`","OEM_3"],[0,60,"Comma",87,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[0,61,"Period",89,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[0,62,"Slash",90,"/",191,"VK_OEM_2","/","OEM_2"],[1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[1,64,"F1",59,"F1",112,"VK_F1",e,e],[1,65,"F2",60,"F2",113,"VK_F2",e,e],[1,66,"F3",61,"F3",114,"VK_F3",e,e],[1,67,"F4",62,"F4",115,"VK_F4",e,e],[1,68,"F5",63,"F5",116,"VK_F5",e,e],[1,69,"F6",64,"F6",117,"VK_F6",e,e],[1,70,"F7",65,"F7",118,"VK_F7",e,e],[1,71,"F8",66,"F8",119,"VK_F8",e,e],[1,72,"F9",67,"F9",120,"VK_F9",e,e],[1,73,"F10",68,"F10",121,"VK_F10",e,e],[1,74,"F11",69,"F11",122,"VK_F11",e,e],[1,75,"F12",70,"F12",123,"VK_F12",e,e],[1,76,"PrintScreen",0,e,0,e,e,e],[1,77,"ScrollLock",84,"ScrollLock",145,"VK_SCROLL",e,e],[1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[1,80,"Home",14,"Home",36,"VK_HOME",e,e],[1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[1,83,"End",13,"End",35,"VK_END",e,e],[1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[1,89,"NumLock",83,"NumLock",144,"VK_NUMLOCK",e,e],[1,90,"NumpadDivide",113,"NumPad_Divide",111,"VK_DIVIDE",e,e],[1,91,"NumpadMultiply",108,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[1,92,"NumpadSubtract",111,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[1,93,"NumpadAdd",109,"NumPad_Add",107,"VK_ADD",e,e],[1,94,"NumpadEnter",3,e,0,e,e,e],[1,95,"Numpad1",99,"NumPad1",97,"VK_NUMPAD1",e,e],[1,96,"Numpad2",100,"NumPad2",98,"VK_NUMPAD2",e,e],[1,97,"Numpad3",101,"NumPad3",99,"VK_NUMPAD3",e,e],[1,98,"Numpad4",102,"NumPad4",100,"VK_NUMPAD4",e,e],[1,99,"Numpad5",103,"NumPad5",101,"VK_NUMPAD5",e,e],[1,100,"Numpad6",104,"NumPad6",102,"VK_NUMPAD6",e,e],[1,101,"Numpad7",105,"NumPad7",103,"VK_NUMPAD7",e,e],[1,102,"Numpad8",106,"NumPad8",104,"VK_NUMPAD8",e,e],[1,103,"Numpad9",107,"NumPad9",105,"VK_NUMPAD9",e,e],[1,104,"Numpad0",98,"NumPad0",96,"VK_NUMPAD0",e,e],[1,105,"NumpadDecimal",112,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[0,106,"IntlBackslash",97,"OEM_102",226,"VK_OEM_102",e,e],[1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[1,108,"Power",0,e,0,e,e,e],[1,109,"NumpadEqual",0,e,0,e,e,e],[1,110,"F13",71,"F13",124,"VK_F13",e,e],[1,111,"F14",72,"F14",125,"VK_F14",e,e],[1,112,"F15",73,"F15",126,"VK_F15",e,e],[1,113,"F16",74,"F16",127,"VK_F16",e,e],[1,114,"F17",75,"F17",128,"VK_F17",e,e],[1,115,"F18",76,"F18",129,"VK_F18",e,e],[1,116,"F19",77,"F19",130,"VK_F19",e,e],[1,117,"F20",78,"F20",0,"VK_F20",e,e],[1,118,"F21",79,"F21",0,"VK_F21",e,e],[1,119,"F22",80,"F22",0,"VK_F22",e,e],[1,120,"F23",81,"F23",0,"VK_F23",e,e],[1,121,"F24",82,"F24",0,"VK_F24",e,e],[1,122,"Open",0,e,0,e,e,e],[1,123,"Help",0,e,0,e,e,e],[1,124,"Select",0,e,0,e,e,e],[1,125,"Again",0,e,0,e,e,e],[1,126,"Undo",0,e,0,e,e,e],[1,127,"Cut",0,e,0,e,e,e],[1,128,"Copy",0,e,0,e,e,e],[1,129,"Paste",0,e,0,e,e,e],[1,130,"Find",0,e,0,e,e,e],[1,131,"AudioVolumeMute",117,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[1,132,"AudioVolumeUp",118,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[1,133,"AudioVolumeDown",119,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[1,134,"NumpadComma",110,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[0,135,"IntlRo",115,"ABNT_C1",193,"VK_ABNT_C1",e,e],[1,136,"KanaMode",0,e,0,e,e,e],[0,137,"IntlYen",0,e,0,e,e,e],[1,138,"Convert",0,e,0,e,e,e],[1,139,"NonConvert",0,e,0,e,e,e],[1,140,"Lang1",0,e,0,e,e,e],[1,141,"Lang2",0,e,0,e,e,e],[1,142,"Lang3",0,e,0,e,e,e],[1,143,"Lang4",0,e,0,e,e,e],[1,144,"Lang5",0,e,0,e,e,e],[1,145,"Abort",0,e,0,e,e,e],[1,146,"Props",0,e,0,e,e,e],[1,147,"NumpadParenLeft",0,e,0,e,e,e],[1,148,"NumpadParenRight",0,e,0,e,e,e],[1,149,"NumpadBackspace",0,e,0,e,e,e],[1,150,"NumpadMemoryStore",0,e,0,e,e,e],[1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[1,152,"NumpadMemoryClear",0,e,0,e,e,e],[1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[1,155,"NumpadClear",131,"Clear",12,"VK_CLEAR",e,e],[1,156,"NumpadClearEntry",0,e,0,e,e,e],[1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[1,0,e,6,"Alt",18,"VK_MENU",e,e],[1,0,e,57,"Meta",91,"VK_COMMAND",e,e],[1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[1,165,"BrightnessUp",0,e,0,e,e,e],[1,166,"BrightnessDown",0,e,0,e,e,e],[1,167,"MediaPlay",0,e,0,e,e,e],[1,168,"MediaRecord",0,e,0,e,e,e],[1,169,"MediaFastForward",0,e,0,e,e,e],[1,170,"MediaRewind",0,e,0,e,e,e],[1,171,"MediaTrackNext",124,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[1,172,"MediaTrackPrevious",125,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[1,173,"MediaStop",126,"MediaStop",178,"VK_MEDIA_STOP",e,e],[1,174,"Eject",0,e,0,e,e,e],[1,175,"MediaPlayPause",127,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[1,176,"MediaSelect",128,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[1,177,"LaunchMail",129,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[1,178,"LaunchApp2",130,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[1,180,"SelectTask",0,e,0,e,e,e],[1,181,"LaunchScreenSaver",0,e,0,e,e,e],[1,182,"BrowserSearch",120,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[1,183,"BrowserHome",121,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[1,184,"BrowserBack",122,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[1,185,"BrowserForward",123,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[1,189,"ZoomToggle",0,e,0,e,e,e],[1,190,"MailReply",0,e,0,e,e,e],[1,191,"MailForward",0,e,0,e,e,e],[1,192,"MailSend",0,e,0,e,e,e],[1,0,e,114,"KeyInComposition",229,e,e,e],[1,0,e,116,"ABNT_C2",194,"VK_ABNT_C2",e,e],[1,0,e,96,"OEM_8",223,"VK_OEM_8",e,e],[1,0,e,0,e,0,"VK_KANA",e,e],[1,0,e,0,e,0,"VK_HANGUL",e,e],[1,0,e,0,e,0,"VK_JUNJA",e,e],[1,0,e,0,e,0,"VK_FINAL",e,e],[1,0,e,0,e,0,"VK_HANJA",e,e],[1,0,e,0,e,0,"VK_KANJI",e,e],[1,0,e,0,e,0,"VK_CONVERT",e,e],[1,0,e,0,e,0,"VK_NONCONVERT",e,e],[1,0,e,0,e,0,"VK_ACCEPT",e,e],[1,0,e,0,e,0,"VK_MODECHANGE",e,e],[1,0,e,0,e,0,"VK_SELECT",e,e],[1,0,e,0,e,0,"VK_PRINT",e,e],[1,0,e,0,e,0,"VK_EXECUTE",e,e],[1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[1,0,e,0,e,0,"VK_HELP",e,e],[1,0,e,0,e,0,"VK_APPS",e,e],[1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[1,0,e,0,e,0,"VK_PACKET",e,e],[1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[1,0,e,0,e,0,"VK_ATTN",e,e],[1,0,e,0,e,0,"VK_CRSEL",e,e],[1,0,e,0,e,0,"VK_EXSEL",e,e],[1,0,e,0,e,0,"VK_EREOF",e,e],[1,0,e,0,e,0,"VK_PLAY",e,e],[1,0,e,0,e,0,"VK_ZOOM",e,e],[1,0,e,0,e,0,"VK_NONAME",e,e],[1,0,e,0,e,0,"VK_PA1",e,e],[1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],n=[],u=[];for(const s of o){const[w,D,S,f,v,L,N,E,g]=s;if(u[D]||(u[D]=!0,h[D]=S,a[S]=D,c[S.toLowerCase()]=D,w&&(t.IMMUTABLE_CODE_TO_KEY_CODE[D]=f,f!==0&&f!==3&&f!==5&&f!==4&&f!==6&&f!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[f]=D))),!n[f]){if(n[f]=!0,!v)throw new Error(`String representation missing for key code ${f} around scan code ${S}`);W.define(f,v),p.define(f,E||v),A.define(f,g||E||v)}L&&(t.EVENT_KEY_CODE_MAP[L]=f),N&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[N]=f)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var P;(function(e){function o(S){return W.keyCodeToStr(S)}e.toString=o;function n(S){return W.strToKeyCode(S)}e.fromString=n;function u(S){return p.keyCodeToStr(S)}e.toUserSettingsUS=u;function s(S){return A.keyCodeToStr(S)}e.toUserSettingsGeneral=s;function w(S){return p.strToKeyCode(S)||A.strToKeyCode(S)}e.fromUserSettings=w;function D(S){if(S>=98&&S<=113)return null;switch(S){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return W.keyCodeToStr(S)}e.toElectronAccelerator=D})(P||(t.KeyCodeUtils=P={}));var r;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(r||(t.KeyMod=r={}));function l(e,o){const n=(o&65535)<<16>>>0;return(e|n)>>>0}t.KeyChord=l}),define(me[74],be([1,0,7]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedChord=t.Keybinding=t.ScanCodeChord=t.KeyCodeChord=t.createSimpleKeybinding=t.decodeKeybinding=void 0;var M;(function(P){P[P.CtrlCmd=2048]="CtrlCmd",P[P.Shift=1024]="Shift",P[P.Alt=512]="Alt",P[P.WinCtrl=256]="WinCtrl",P[P.KeyCode=255]="KeyCode"})(M||(M={}));function i(P,r){if(typeof P=="number"){if(P===0)return null;const l=(P&65535)>>>0,e=(P&4294901760)>>>16;return e!==0?new h([W(l,r),W(e,r)]):new h([W(l,r)])}else{const l=[];for(let e=0;e<P.length;e++)l.push(W(P[e],r));return new h(l)}}t.decodeKeybinding=i;function W(P,r){const l=!!(P&2048),e=!!(P&256),o=r===2?e:l,n=!!(P&1024),u=!!(P&512),s=r===2?l:e,w=P&255;return new p(o,n,u,s,w)}t.createSimpleKeybinding=W;class p{constructor(r,l,e,o,n){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=o,this.keyCode=n}equals(r){return r instanceof p&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.keyCode===r.keyCode}getHashCode(){const r=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",o=this.metaKey?"1":"0";return`K${r}${l}${e}${o}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toKeybinding(){return new h([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.KeyCodeChord=p;class A{constructor(r,l,e,o,n){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=o,this.scanCode=n}equals(r){return r instanceof A&&this.ctrlKey===r.ctrlKey&&this.shiftKey===r.shiftKey&&this.altKey===r.altKey&&this.metaKey===r.metaKey&&this.scanCode===r.scanCode}getHashCode(){const r=this.ctrlKey?"1":"0",l=this.shiftKey?"1":"0",e=this.altKey?"1":"0",o=this.metaKey?"1":"0";return`S${r}${l}${e}${o}${this.scanCode}`}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeChord=A;class h{constructor(r){if(r.length===0)throw(0,y.illegalArgument)("chords");this.chords=r}getHashCode(){let r="";for(let l=0,e=this.chords.length;l<e;l++)l!==0&&(r+=";"),r+=this.chords[l].getHashCode();return r}equals(r){if(r===null||this.chords.length!==r.chords.length)return!1;for(let l=0;l<this.chords.length;l++)if(!this.chords[l].equals(r.chords[l]))return!1;return!0}}t.Keybinding=h;class a{constructor(r,l,e,o,n,u){this.ctrlKey=r,this.shiftKey=l,this.altKey=e,this.metaKey=o,this.keyLabel=n,this.keyAriaLabel=u}}t.ResolvedChord=a;class c{}t.ResolvedKeybinding=c}),define(me[42],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class y{constructor(i){this.d=i,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(i){this.c=i}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}t.Lazy=y}),define(me[2],be([1,0,40,26]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DisposableMap=t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.disposeIfDisposable=t.dispose=t.isDisposable=t.markAsSingleton=t.setDisposableTracker=void 0;const i=!1;let W=null;function p(g){W=g}if(t.setDisposableTracker=p,i){const g="__is_disposable_tracked__";p(new class{trackDisposable(m){const b=new Error("Potentially leaked disposable").stack;setTimeout(()=>{m[g]||console.log(b)},3e3)}setParent(m,b){if(m&&m!==s.None)try{m[g]=!0}catch{}}markAsDisposed(m){if(m&&m!==s.None)try{m[g]=!0}catch{}}markAsSingleton(m){}})}function A(g){return W?.trackDisposable(g),g}function h(g){W?.markAsDisposed(g)}function a(g,m){W?.setParent(g,m)}function c(g,m){if(W)for(const b of g)W.setParent(b,m)}function P(g){return W?.markAsSingleton(g),g}t.markAsSingleton=P;function r(g){return typeof g.dispose=="function"&&g.dispose.length===0}t.isDisposable=r;function l(g){if(M.Iterable.is(g)){const m=[];for(const b of g)if(b)try{b.dispose()}catch(B){m.push(B)}if(m.length===1)throw m[0];if(m.length>1)throw new AggregateError(m,"Encountered errors while disposing of store");return Array.isArray(g)?[]:g}else if(g)return g.dispose(),g}t.dispose=l;function e(g){for(const m of g)r(m)&&m.dispose();return[]}t.disposeIfDisposable=e;function o(...g){const m=n(()=>l(g));return c(g,m),m}t.combinedDisposable=o;function n(g){const m=A({dispose:(0,y.once)(()=>{h(m),g()})});return m}t.toDisposable=n;class u{constructor(){this.f=new Set,this.g=!1,A(this)}dispose(){this.g||(h(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{l(this.f)}finally{this.f.clear()}}add(m){if(!m)return m;if(m===this)throw new Error("Cannot register a disposable on itself!");return a(m,this),this.g?u.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(m),m}}t.DisposableStore=u,u.DISABLE_DISPOSED_WARNING=!1;class s{constructor(){this.q=new u,A(this),a(this.q,this)}dispose(){h(this),this.q.dispose()}B(m){if(m===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(m)}}t.Disposable=s,s.None=Object.freeze({dispose(){}});class w{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(m){this.b||m===this.a||(this.a?.dispose(),m&&a(m,this),this.a=m)}clear(){this.value=void 0}dispose(){this.b=!0,h(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const m=this.a;return this.a=void 0,m&&a(m,null),m}}t.MutableDisposable=w;class D{constructor(m){this.b=m,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}t.RefCountedDisposable=D;class S{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(m){let b=m;return this.unset=()=>b=void 0,this.isset=()=>b!==void 0,this.dispose=()=>{b&&(b(),b=void 0,h(this))},this}}t.SafeDisposable=S;class f{constructor(){this.a=new Map}acquire(m,...b){let B=this.a.get(m);B||(B={counter:0,object:this.b(m,...b)},this.a.set(m,B));const{object:G}=B,J=(0,y.once)(()=>{--B.counter===0&&(this.c(m,B.object),this.a.delete(m))});return B.counter++,{object:G,dispose:J}}}t.ReferenceCollection=f;class v{constructor(m){this.a=m}async acquire(m,...b){const B=this.a.acquire(m,...b);try{return{object:await B.object,dispose:()=>B.dispose()}}catch(G){throw B.dispose(),G}}}t.AsyncReferenceCollection=v;class L{constructor(m){this.object=m}dispose(){}}t.ImmortalReference=L;function N(g){const m=new u;try{g(m)}finally{m.dispose()}}t.disposeOnReturn=N;class E{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){h(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{l(this.a.values())}finally{this.a.clear()}}has(m){return this.a.has(m)}get(m){return this.a.get(m)}set(m,b,B=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),B||this.a.get(m)?.dispose(),this.a.set(m,b)}deleteAndDispose(m){this.a.get(m)?.dispose(),this.a.delete(m)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}t.DisposableMap=E}),define(me[43],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class y{constructor(W){this.element=W,this.next=y.Undefined,this.prev=y.Undefined}}y.Undefined=new y(void 0);class M{constructor(){this.a=y.Undefined,this.b=y.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===y.Undefined}clear(){let W=this.a;for(;W!==y.Undefined;){const p=W.next;W.prev=y.Undefined,W.next=y.Undefined,W=p}this.a=y.Undefined,this.b=y.Undefined,this.c=0}unshift(W){return this.d(W,!1)}push(W){return this.d(W,!0)}d(W,p){const A=new y(W);if(this.a===y.Undefined)this.a=A,this.b=A;else if(p){const a=this.b;this.b=A,A.prev=a,a.next=A}else{const a=this.a;this.a=A,A.next=a,a.prev=A}this.c+=1;let h=!1;return()=>{h||(h=!0,this.e(A))}}shift(){if(this.a!==y.Undefined){const W=this.a.element;return this.e(this.a),W}}pop(){if(this.b!==y.Undefined){const W=this.b.element;return this.e(this.b),W}}e(W){if(W.prev!==y.Undefined&&W.next!==y.Undefined){const p=W.prev;p.next=W.next,W.next.prev=p}else W.prev===y.Undefined&&W.next===y.Undefined?(this.a=y.Undefined,this.b=y.Undefined):W.next===y.Undefined?(this.b=this.b.prev,this.b.next=y.Undefined):W.prev===y.Undefined&&(this.a=this.a.next,this.a.prev=y.Undefined);this.c-=1}*[Symbol.iterator](){let W=this.a;for(;W!==y.Undefined;)yield W.element,W=W.next}}t.LinkedList=M}),define(me[75],be([1,0]),function(te,t){"use strict";var y,M,i;Object.defineProperty(t,"__esModule",{value:!0}),t.CounterSet=t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.setToString=t.mapToString=t.getOrSet=void 0;function W(o,n,u){let s=o.get(n);return s===void 0&&(s=u,o.set(n,s)),s}t.getOrSet=W;function p(o){const n=[];return o.forEach((u,s)=>{n.push(`${s} => ${u}`)}),`Map(${o.size}) {${n.join(", ")}}`}t.mapToString=p;function A(o){const n=[];return o.forEach(u=>{n.push(u)}),`Set(${o.size}) {${n.join(", ")}}`}t.setToString=A;class h{constructor(n,u){this.uri=n,this.value=u}}class a{constructor(n,u){this[y]="ResourceMap",n instanceof a?(this.b=new Map(n.b),this.c=u??a.a):(this.b=new Map,this.c=n??a.a)}set(n,u){return this.b.set(this.c(n),new h(n,u)),this}get(n){return this.b.get(this.c(n))?.value}has(n){return this.b.has(this.c(n))}get size(){return this.b.size}clear(){this.b.clear()}delete(n){return this.b.delete(this.c(n))}forEach(n,u){typeof u<"u"&&(n=n.bind(u));for(const[s,w]of this.b)n(w.value,w.uri,this)}*values(){for(const n of this.b.values())yield n.value}*keys(){for(const n of this.b.values())yield n.uri}*entries(){for(const n of this.b.values())yield[n.uri,n.value]}*[(y=Symbol.toStringTag,Symbol.iterator)](){for(const[,n]of this.b)yield[n.uri,n.value]}}t.ResourceMap=a,a.a=o=>o.toString();class c{constructor(n,u){this[M]="ResourceSet",!n||typeof n=="function"?this.a=new a(n):(this.a=new a(u),n.forEach(this.add,this))}get size(){return this.a.size}add(n){return this.a.set(n,n),this}clear(){this.a.clear()}delete(n){return this.a.delete(n)}forEach(n,u){this.a.forEach((s,w)=>n.call(u,w,w,this))}has(n){return this.a.has(n)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(M=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=c;var P;(function(o){o[o.None=0]="None",o[o.AsOld=1]="AsOld",o[o.AsNew=2]="AsNew"})(P||(t.Touch=P={}));class r{constructor(){this[i]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(n){return this.a.has(n)}get(n,u=0){const s=this.a.get(n);if(s)return u!==0&&this.j(s,u),s.value}set(n,u,s=0){let w=this.a.get(n);if(w)w.value=u,s!==0&&this.j(w,s);else{switch(w={key:n,value:u,next:void 0,previous:void 0},s){case 0:this.h(w);break;case 1:this.g(w);break;case 2:this.h(w);break;default:this.h(w);break}this.a.set(n,w),this.d++}return this}delete(n){return!!this.remove(n)}remove(n){const u=this.a.get(n);if(u)return this.a.delete(n),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const n=this.b;return this.a.delete(n.key),this.i(n),this.d--,n.value}forEach(n,u){const s=this.e;let w=this.b;for(;w;){if(u?n.bind(u)(w.value,w.key,this):n(w.value,w.key,this),this.e!==s)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const n=this,u=this.e;let s=this.b;const w={[Symbol.iterator](){return w},next(){if(n.e!==u)throw new Error("LinkedMap got modified during iteration.");if(s){const D={value:s.key,done:!1};return s=s.next,D}else return{value:void 0,done:!0}}};return w}values(){const n=this,u=this.e;let s=this.b;const w={[Symbol.iterator](){return w},next(){if(n.e!==u)throw new Error("LinkedMap got modified during iteration.");if(s){const D={value:s.value,done:!1};return s=s.next,D}else return{value:void 0,done:!0}}};return w}entries(){const n=this,u=this.e;let s=this.b;const w={[Symbol.iterator](){return w},next(){if(n.e!==u)throw new Error("LinkedMap got modified during iteration.");if(s){const D={value:[s.key,s.value],done:!1};return s=s.next,D}else return{value:void 0,done:!0}}};return w}[(i=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(n){if(n>=this.size)return;if(n===0){this.clear();return}let u=this.b,s=this.size;for(;u&&s>n;)this.a.delete(u.key),u=u.next,s--;this.b=u,this.d=s,u&&(u.previous=void 0),this.e++}g(n){if(!this.b&&!this.c)this.c=n;else if(this.b)n.next=this.b,this.b.previous=n;else throw new Error("Invalid list");this.b=n,this.e++}h(n){if(!this.b&&!this.c)this.b=n;else if(this.c)n.previous=this.c,this.c.next=n;else throw new Error("Invalid list");this.c=n,this.e++}i(n){if(n===this.b&&n===this.c)this.b=void 0,this.c=void 0;else if(n===this.b){if(!n.next)throw new Error("Invalid list");n.next.previous=void 0,this.b=n.next}else if(n===this.c){if(!n.previous)throw new Error("Invalid list");n.previous.next=void 0,this.c=n.previous}else{const u=n.next,s=n.previous;if(!u||!s)throw new Error("Invalid list");u.previous=s,s.next=u}n.next=void 0,n.previous=void 0,this.e++}j(n,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(n===this.b)return;const s=n.next,w=n.previous;n===this.c?(w.next=void 0,this.c=w):(s.previous=w,w.next=s),n.previous=void 0,n.next=this.b,this.b.previous=n,this.b=n,this.e++}else if(u===2){if(n===this.c)return;const s=n.next,w=n.previous;n===this.b?(s.previous=void 0,this.b=s):(s.previous=w,w.next=s),n.next=void 0,n.previous=this.c,this.c.next=n,this.c=n,this.e++}}}toJSON(){const n=[];return this.forEach((u,s)=>{n.push([s,u])}),n}fromJSON(n){this.clear();for(const[u,s]of n)this.set(u,s)}}t.LinkedMap=r;class l extends r{constructor(n,u=1){super(),this.k=n,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(n){this.k=n,this.m()}get ratio(){return this.l}set ratio(n){this.l=Math.min(Math.max(0,n),1),this.m()}get(n,u=2){return super.get(n,u)}peek(n){return super.get(n,0)}set(n,u){return super.set(n,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}t.LRUCache=l;class e{constructor(){this.a=new Map}add(n){return this.a.set(n,(this.a.get(n)||0)+1),this}delete(n){let u=this.a.get(n)||0;return u===0?!1:(u--,u===0?this.a.delete(n):this.a.set(n,u),!0)}has(n){return this.a.has(n)}}t.CounterSet=e}),function(te,t){typeof define=="function"&&define.amd?define(me[76],be([0]),t):typeof exports=="object"&&typeof module<"u"?t(exports):(te=typeof globalThis<"u"?globalThis:te||self,t(te.marked={}))}(this,function(te){"use strict";function t(k,T){for(var H=0;H<T.length;H++){var C=T[H];C.enumerable=C.enumerable||!1,C.configurable=!0,"value"in C&&(C.writable=!0),Object.defineProperty(k,C.key,C)}}function y(k,T,H){return T&&t(k.prototype,T),H&&t(k,H),Object.defineProperty(k,"prototype",{writable:!1}),k}function M(k,T){if(k){if(typeof k=="string")return i(k,T);var H=Object.prototype.toString.call(k).slice(8,-1);if(H==="Object"&&k.constructor&&(H=k.constructor.name),H==="Map"||H==="Set")return Array.from(k);if(H==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(H))return i(k,T)}}function i(k,T){(T==null||T>k.length)&&(T=k.length);for(var H=0,C=new Array(T);H<T;H++)C[H]=k[H];return C}function W(k,T){var H=typeof Symbol<"u"&&k[Symbol.iterator]||k["@@iterator"];if(H)return(H=H.call(k)).next.bind(H);if(Array.isArray(k)||(H=M(k))||T&&k&&typeof k.length=="number"){H&&(k=H);var C=0;return function(){return C>=k.length?{done:!0}:{done:!1,value:k[C++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function p(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=p();function A(k){te.defaults=k}var h=/[&<>"']/,a=/[&<>"']/g,c=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},l=function(T){return r[T]};function e(k,T){if(T){if(h.test(k))return k.replace(a,l)}else if(c.test(k))return k.replace(P,l);return k}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function n(k){return k.replace(o,function(T,H){return H=H.toLowerCase(),H==="colon"?":":H.charAt(0)==="#"?H.charAt(1)==="x"?String.fromCharCode(parseInt(H.substring(2),16)):String.fromCharCode(+H.substring(1)):""})}var u=/(^|[^\[])\^/g;function s(k,T){k=typeof k=="string"?k:k.source,T=T||"";var H={replace:function(U,z){return z=z.source||z,z=z.replace(u,"$1"),k=k.replace(U,z),H},getRegex:function(){return new RegExp(k,T)}};return H}var w=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(k,T,H){if(k){var C;try{C=decodeURIComponent(n(H)).replace(w,"").toLowerCase()}catch{return null}if(C.indexOf("javascript:")===0||C.indexOf("vbscript:")===0||C.indexOf("data:")===0)return null}T&&!D.test(H)&&(H=E(T,H));try{H=encodeURI(H).replace(/%25/g,"%")}catch{return null}return H}var f={},v=/^[^:]+:\/*[^/]*$/,L=/^([^:]+:)[\s\S]*$/,N=/^([^:]+:\/*[^/]*)[\s\S]*$/;function E(k,T){f[" "+k]||(v.test(k)?f[" "+k]=k+"/":f[" "+k]=B(k,"/",!0)),k=f[" "+k];var H=k.indexOf(":")===-1;return T.substring(0,2)==="//"?H?T:k.replace(L,"$1")+T:T.charAt(0)==="/"?H?T:k.replace(N,"$1")+T:k+T}var g={exec:function(){}};function m(k){for(var T=1,H,C;T<arguments.length;T++){H=arguments[T];for(C in H)Object.prototype.hasOwnProperty.call(H,C)&&(k[C]=H[C])}return k}function b(k,T){var H=k.replace(/\|/g,function(z,O,$){for(var q=!1,ee=O;--ee>=0&&$[ee]==="\\";)q=!q;return q?"|":" |"}),C=H.split(/ \|/),U=0;if(C[0].trim()||C.shift(),C.length>0&&!C[C.length-1].trim()&&C.pop(),C.length>T)C.splice(T);else for(;C.length<T;)C.push("");for(;U<C.length;U++)C[U]=C[U].trim().replace(/\\\|/g,"|");return C}function B(k,T,H){var C=k.length;if(C===0)return"";for(var U=0;U<C;){var z=k.charAt(C-U-1);if(z===T&&!H)U++;else if(z!==T&&H)U++;else break}return k.slice(0,C-U)}function G(k,T){if(k.indexOf(T[1])===-1)return-1;for(var H=k.length,C=0,U=0;U<H;U++)if(k[U]==="\\")U++;else if(k[U]===T[0])C++;else if(k[U]===T[1]&&(C--,C<0))return U;return-1}function J(k){k&&k.sanitize&&!k.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function ie(k,T){if(T<1)return"";for(var H="";T>1;)T&1&&(H+=k),T>>=1,k+=k;return H+k}function le(k,T,H,C){var U=T.href,z=T.title?e(T.title):null,O=k[1].replace(/\\([\[\]])/g,"$1");if(k[0].charAt(0)!=="!"){C.state.inLink=!0;var $={type:"link",raw:H,href:U,title:z,text:O,tokens:C.inlineTokens(O)};return C.state.inLink=!1,$}return{type:"image",raw:H,href:U,title:z,text:e(O)}}function ge(k,T){var H=k.match(/^(\s+)(?:```)/);if(H===null)return T;var C=H[1];return T.split(`
`).map(function(U){var z=U.match(/^\s+/);if(z===null)return U;var O=z[0];return O.length>=C.length?U.slice(C.length):U}).join(`
`)}var ue=function(){function k(H){this.options=H||te.defaults}var T=k.prototype;return T.space=function(C){var U=this.rules.block.newline.exec(C);if(U&&U[0].length>0)return{type:"space",raw:U[0]}},T.code=function(C){var U=this.rules.block.code.exec(C);if(U){var z=U[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:U[0],codeBlockStyle:"indented",text:this.options.pedantic?z:B(z,`
`)}}},T.fences=function(C){var U=this.rules.block.fences.exec(C);if(U){var z=U[0],O=ge(z,U[3]||"");return{type:"code",raw:z,lang:U[2]?U[2].trim():U[2],text:O}}},T.heading=function(C){var U=this.rules.block.heading.exec(C);if(U){var z=U[2].trim();if(/#$/.test(z)){var O=B(z,"#");(this.options.pedantic||!O||/ $/.test(O))&&(z=O.trim())}return{type:"heading",raw:U[0],depth:U[1].length,text:z,tokens:this.lexer.inline(z)}}},T.hr=function(C){var U=this.rules.block.hr.exec(C);if(U)return{type:"hr",raw:U[0]}},T.blockquote=function(C){var U=this.rules.block.blockquote.exec(C);if(U){var z=U[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:U[0],tokens:this.lexer.blockTokens(z,[]),text:z}}},T.list=function(C){var U=this.rules.block.list.exec(C);if(U){var z,O,$,q,ee,se,ve,De,Ie,Fe,we,Pe,Ne=U[1].trim(),Ve=Ne.length>1,ze={type:"list",raw:"",ordered:Ve,start:Ve?+Ne.slice(0,-1):"",loose:!1,items:[]};Ne=Ve?"\\d{1,9}\\"+Ne.slice(-1):"\\"+Ne,this.options.pedantic&&(Ne=Ve?Ne:"[*+-]");for(var We=new RegExp("^( {0,3}"+Ne+")((?:[	 ][^\\n]*)?(?:\\n|$))");C&&(Pe=!1,!(!(U=We.exec(C))||this.rules.block.hr.test(C)));){if(z=U[0],C=C.substring(z.length),De=U[2].split(`
`,1)[0],Ie=C.split(`
`,1)[0],this.options.pedantic?(q=2,we=De.trimLeft()):(q=U[2].search(/[^ ]/),q=q>4?1:q,we=De.slice(q),q+=U[1].length),se=!1,!De&&/^ *$/.test(Ie)&&(z+=Ie+`
`,C=C.substring(Ie.length+1),Pe=!0),!Pe)for(var Je=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),it=new RegExp("^ {0,"+Math.min(3,q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Oe=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:```|~~~)"),je=new RegExp("^ {0,"+Math.min(3,q-1)+"}#");C&&(Fe=C.split(`
`,1)[0],De=Fe,this.options.pedantic&&(De=De.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Oe.test(De)||je.test(De)||Je.test(De)||it.test(C)));){if(De.search(/[^ ]/)>=q||!De.trim())we+=`
`+De.slice(q);else if(!se)we+=`
`+De;else break;!se&&!De.trim()&&(se=!0),z+=Fe+`
`,C=C.substring(Fe.length+1)}ze.loose||(ve?ze.loose=!0:/\n *\n *$/.test(z)&&(ve=!0)),this.options.gfm&&(O=/^\[[ xX]\] /.exec(we),O&&($=O[0]!=="[ ] ",we=we.replace(/^\[[ xX]\] +/,""))),ze.items.push({type:"list_item",raw:z,task:!!O,checked:$,loose:!1,text:we}),ze.raw+=z}ze.items[ze.items.length-1].raw=z.trimRight(),ze.items[ze.items.length-1].text=we.trimRight(),ze.raw=ze.raw.trimRight();var K=ze.items.length;for(ee=0;ee<K;ee++){this.lexer.state.top=!1,ze.items[ee].tokens=this.lexer.blockTokens(ze.items[ee].text,[]);var ae=ze.items[ee].tokens.filter(function(ye){return ye.type==="space"}),pe=ae.every(function(ye){for(var Ce=ye.raw.split(""),Re=0,$e=W(Ce),Ge;!(Ge=$e()).done;){var et=Ge.value;if(et===`
`&&(Re+=1),Re>1)return!0}return!1});!ze.loose&&ae.length&&pe&&(ze.loose=!0,ze.items[ee].loose=!0)}return ze}},T.html=function(C){var U=this.rules.block.html.exec(C);if(U){var z={type:"html",raw:U[0],pre:!this.options.sanitizer&&(U[1]==="pre"||U[1]==="script"||U[1]==="style"),text:U[0]};if(this.options.sanitize){var O=this.options.sanitizer?this.options.sanitizer(U[0]):e(U[0]);z.type="paragraph",z.text=O,z.tokens=this.lexer.inline(O)}return z}},T.def=function(C){var U=this.rules.block.def.exec(C);if(U){U[3]&&(U[3]=U[3].substring(1,U[3].length-1));var z=U[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:z,raw:U[0],href:U[2],title:U[3]}}},T.table=function(C){var U=this.rules.block.table.exec(C);if(U){var z={type:"table",header:b(U[1]).map(function(ve){return{text:ve}}),align:U[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:U[3]&&U[3].trim()?U[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(z.header.length===z.align.length){z.raw=U[0];var O=z.align.length,$,q,ee,se;for($=0;$<O;$++)/^ *-+: *$/.test(z.align[$])?z.align[$]="right":/^ *:-+: *$/.test(z.align[$])?z.align[$]="center":/^ *:-+ *$/.test(z.align[$])?z.align[$]="left":z.align[$]=null;for(O=z.rows.length,$=0;$<O;$++)z.rows[$]=b(z.rows[$],z.header.length).map(function(ve){return{text:ve}});for(O=z.header.length,q=0;q<O;q++)z.header[q].tokens=this.lexer.inline(z.header[q].text);for(O=z.rows.length,q=0;q<O;q++)for(se=z.rows[q],ee=0;ee<se.length;ee++)se[ee].tokens=this.lexer.inline(se[ee].text);return z}}},T.lheading=function(C){var U=this.rules.block.lheading.exec(C);if(U)return{type:"heading",raw:U[0],depth:U[2].charAt(0)==="="?1:2,text:U[1],tokens:this.lexer.inline(U[1])}},T.paragraph=function(C){var U=this.rules.block.paragraph.exec(C);if(U){var z=U[1].charAt(U[1].length-1)===`
`?U[1].slice(0,-1):U[1];return{type:"paragraph",raw:U[0],text:z,tokens:this.lexer.inline(z)}}},T.text=function(C){var U=this.rules.block.text.exec(C);if(U)return{type:"text",raw:U[0],text:U[0],tokens:this.lexer.inline(U[0])}},T.escape=function(C){var U=this.rules.inline.escape.exec(C);if(U)return{type:"escape",raw:U[0],text:e(U[1])}},T.tag=function(C){var U=this.rules.inline.tag.exec(C);if(U)return!this.lexer.state.inLink&&/^<a /i.test(U[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(U[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(U[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(U[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:U[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(U[0]):e(U[0]):U[0]}},T.link=function(C){var U=this.rules.inline.link.exec(C);if(U){var z=U[2].trim();if(!this.options.pedantic&&/^</.test(z)){if(!/>$/.test(z))return;var O=B(z.slice(0,-1),"\\");if((z.length-O.length)%2===0)return}else{var $=G(U[2],"()");if($>-1){var q=U[0].indexOf("!")===0?5:4,ee=q+U[1].length+$;U[2]=U[2].substring(0,$),U[0]=U[0].substring(0,ee).trim(),U[3]=""}}var se=U[2],ve="";if(this.options.pedantic){var De=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(se);De&&(se=De[1],ve=De[3])}else ve=U[3]?U[3].slice(1,-1):"";return se=se.trim(),/^</.test(se)&&(this.options.pedantic&&!/>$/.test(z)?se=se.slice(1):se=se.slice(1,-1)),le(U,{href:se&&se.replace(this.rules.inline._escapes,"$1"),title:ve&&ve.replace(this.rules.inline._escapes,"$1")},U[0],this.lexer)}},T.reflink=function(C,U){var z;if((z=this.rules.inline.reflink.exec(C))||(z=this.rules.inline.nolink.exec(C))){var O=(z[2]||z[1]).replace(/\s+/g," ");if(O=U[O.toLowerCase()],!O||!O.href){var $=z[0].charAt(0);return{type:"text",raw:$,text:$}}return le(z,O,z[0],this.lexer)}},T.emStrong=function(C,U,z){z===void 0&&(z="");var O=this.rules.inline.emStrong.lDelim.exec(C);if(O&&!(O[3]&&z.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var $=O[1]||O[2]||"";if(!$||$&&(z===""||this.rules.inline.punctuation.exec(z))){var q=O[0].length-1,ee,se,ve=q,De=0,Ie=O[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ie.lastIndex=0,U=U.slice(-1*C.length+q);(O=Ie.exec(U))!=null;)if(ee=O[1]||O[2]||O[3]||O[4]||O[5]||O[6],!!ee){if(se=ee.length,O[3]||O[4]){ve+=se;continue}else if((O[5]||O[6])&&q%3&&!((q+se)%3)){De+=se;continue}if(ve-=se,!(ve>0)){if(se=Math.min(se,se+ve+De),Math.min(q,se)%2){var Fe=C.slice(1,q+O.index+se);return{type:"em",raw:C.slice(0,q+O.index+se+1),text:Fe,tokens:this.lexer.inlineTokens(Fe)}}var we=C.slice(2,q+O.index+se-1);return{type:"strong",raw:C.slice(0,q+O.index+se+1),text:we,tokens:this.lexer.inlineTokens(we)}}}}}},T.codespan=function(C){var U=this.rules.inline.code.exec(C);if(U){var z=U[2].replace(/\n/g," "),O=/[^ ]/.test(z),$=/^ /.test(z)&&/ $/.test(z);return O&&$&&(z=z.substring(1,z.length-1)),z=e(z,!0),{type:"codespan",raw:U[0],text:z}}},T.br=function(C){var U=this.rules.inline.br.exec(C);if(U)return{type:"br",raw:U[0]}},T.del=function(C){var U=this.rules.inline.del.exec(C);if(U)return{type:"del",raw:U[0],text:U[2],tokens:this.lexer.inlineTokens(U[2])}},T.autolink=function(C,U){var z=this.rules.inline.autolink.exec(C);if(z){var O,$;return z[2]==="@"?(O=e(this.options.mangle?U(z[1]):z[1]),$="mailto:"+O):(O=e(z[1]),$=O),{type:"link",raw:z[0],text:O,href:$,tokens:[{type:"text",raw:O,text:O}]}}},T.url=function(C,U){var z;if(z=this.rules.inline.url.exec(C)){var O,$;if(z[2]==="@")O=e(this.options.mangle?U(z[0]):z[0]),$="mailto:"+O;else{var q;do q=z[0],z[0]=this.rules.inline._backpedal.exec(z[0])[0];while(q!==z[0]);O=e(z[0]),z[1]==="www."?$="http://"+O:$=O}return{type:"link",raw:z[0],text:O,href:$,tokens:[{type:"text",raw:O,text:O}]}}},T.inlineText=function(C,U){var z=this.rules.inline.text.exec(C);if(z){var O;return this.lexer.state.inRawBlock?O=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(z[0]):e(z[0]):z[0]:O=e(this.options.smartypants?U(z[0]):z[0]),{type:"text",raw:z[0],text:O}}},k}(),de={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};de._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,de._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,de.def=s(de.def).replace("label",de._label).replace("title",de._title).getRegex(),de.bullet=/(?:[*+-]|\d{1,9}[.)])/,de.listItemStart=s(/^( *)(bull) */).replace("bull",de.bullet).getRegex(),de.list=s(de.list).replace(/bull/g,de.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+de.def.source+")").getRegex(),de._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",de._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,de.html=s(de.html,"i").replace("comment",de._comment).replace("tag",de._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),de.paragraph=s(de._paragraph).replace("hr",de.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",de._tag).getRegex(),de.blockquote=s(de.blockquote).replace("paragraph",de.paragraph).getRegex(),de.normal=m({},de),de.gfm=m({},de.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),de.gfm.table=s(de.gfm.table).replace("hr",de.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",de._tag).getRegex(),de.gfm.paragraph=s(de._paragraph).replace("hr",de.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",de.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",de._tag).getRegex(),de.pedantic=m({},de.normal,{html:s(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",de._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:g,paragraph:s(de.normal._paragraph).replace("hr",de.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",de.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ce={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ce._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ce.punctuation=s(ce.punctuation).replace(/punctuation/g,ce._punctuation).getRegex(),ce.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ce.escapedEmSt=/\\\*|\\_/g,ce._comment=s(de._comment).replace("(?:-->|$)","-->").getRegex(),ce.emStrong.lDelim=s(ce.emStrong.lDelim).replace(/punct/g,ce._punctuation).getRegex(),ce.emStrong.rDelimAst=s(ce.emStrong.rDelimAst,"g").replace(/punct/g,ce._punctuation).getRegex(),ce.emStrong.rDelimUnd=s(ce.emStrong.rDelimUnd,"g").replace(/punct/g,ce._punctuation).getRegex(),ce._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ce._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ce._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ce.autolink=s(ce.autolink).replace("scheme",ce._scheme).replace("email",ce._email).getRegex(),ce._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ce.tag=s(ce.tag).replace("comment",ce._comment).replace("attribute",ce._attribute).getRegex(),ce._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ce._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ce._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ce.link=s(ce.link).replace("label",ce._label).replace("href",ce._href).replace("title",ce._title).getRegex(),ce.reflink=s(ce.reflink).replace("label",ce._label).replace("ref",de._label).getRegex(),ce.nolink=s(ce.nolink).replace("ref",de._label).getRegex(),ce.reflinkSearch=s(ce.reflinkSearch,"g").replace("reflink",ce.reflink).replace("nolink",ce.nolink).getRegex(),ce.normal=m({},ce),ce.pedantic=m({},ce.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:s(/^!?\[(label)\]\((.*?)\)/).replace("label",ce._label).getRegex(),reflink:s(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ce._label).getRegex()}),ce.gfm=m({},ce.normal,{escape:s(ce.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ce.gfm.url=s(ce.gfm.url,"i").replace("email",ce.gfm._extended_email).getRegex(),ce.breaks=m({},ce.gfm,{br:s(ce.br).replace("{2,}","*").getRegex(),text:s(ce.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function Se(k){return k.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Ae(k){var T="",H,C,U=k.length;for(H=0;H<U;H++)C=k.charCodeAt(H),Math.random()>.5&&(C="x"+C.toString(16)),T+="&#"+C+";";return T}var Be=function(){function k(H){this.tokens=[],this.tokens.links=Object.create(null),this.options=H||te.defaults,this.options.tokenizer=this.options.tokenizer||new ue,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var C={block:de.normal,inline:ce.normal};this.options.pedantic?(C.block=de.pedantic,C.inline=ce.pedantic):this.options.gfm&&(C.block=de.gfm,this.options.breaks?C.inline=ce.breaks:C.inline=ce.gfm),this.tokenizer.rules=C}k.lex=function(C,U){var z=new k(U);return z.lex(C)},k.lexInline=function(C,U){var z=new k(U);return z.inlineTokens(C)};var T=k.prototype;return T.lex=function(C){C=C.replace(/\r\n|\r/g,`
`),this.blockTokens(C,this.tokens);for(var U;U=this.inlineQueue.shift();)this.inlineTokens(U.src,U.tokens);return this.tokens},T.blockTokens=function(C,U){var z=this;U===void 0&&(U=[]),this.options.pedantic?C=C.replace(/\t/g,"    ").replace(/^ +$/gm,""):C=C.replace(/^( *)(\t+)/gm,function(ve,De,Ie){return De+"    ".repeat(Ie.length)});for(var O,$,q,ee;C;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ve){return(O=ve.call({lexer:z},C,U))?(C=C.substring(O.raw.length),U.push(O),!0):!1}))){if(O=this.tokenizer.space(C)){C=C.substring(O.raw.length),O.raw.length===1&&U.length>0?U[U.length-1].raw+=`
`:U.push(O);continue}if(O=this.tokenizer.code(C)){C=C.substring(O.raw.length),$=U[U.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+O.raw,$.text+=`
`+O.text,this.inlineQueue[this.inlineQueue.length-1].src=$.text):U.push(O);continue}if(O=this.tokenizer.fences(C)){C=C.substring(O.raw.length),U.push(O);continue}if(O=this.tokenizer.heading(C)){C=C.substring(O.raw.length),U.push(O);continue}if(O=this.tokenizer.hr(C)){C=C.substring(O.raw.length),U.push(O);continue}if(O=this.tokenizer.blockquote(C)){C=C.substring(O.raw.length),U.push(O);continue}if(O=this.tokenizer.list(C)){C=C.substring(O.raw.length),U.push(O);continue}if(O=this.tokenizer.html(C)){C=C.substring(O.raw.length),U.push(O);continue}if(O=this.tokenizer.def(C)){C=C.substring(O.raw.length),$=U[U.length-1],$&&($.type==="paragraph"||$.type==="text")?($.raw+=`
`+O.raw,$.text+=`
`+O.raw,this.inlineQueue[this.inlineQueue.length-1].src=$.text):this.tokens.links[O.tag]||(this.tokens.links[O.tag]={href:O.href,title:O.title});continue}if(O=this.tokenizer.table(C)){C=C.substring(O.raw.length),U.push(O);continue}if(O=this.tokenizer.lheading(C)){C=C.substring(O.raw.length),U.push(O);continue}if(q=C,this.options.extensions&&this.options.extensions.startBlock&&function(){var ve=1/0,De=C.slice(1),Ie=void 0;z.options.extensions.startBlock.forEach(function(Fe){Ie=Fe.call({lexer:this},De),typeof Ie=="number"&&Ie>=0&&(ve=Math.min(ve,Ie))}),ve<1/0&&ve>=0&&(q=C.substring(0,ve+1))}(),this.state.top&&(O=this.tokenizer.paragraph(q))){$=U[U.length-1],ee&&$.type==="paragraph"?($.raw+=`
`+O.raw,$.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):U.push(O),ee=q.length!==C.length,C=C.substring(O.raw.length);continue}if(O=this.tokenizer.text(C)){C=C.substring(O.raw.length),$=U[U.length-1],$&&$.type==="text"?($.raw+=`
`+O.raw,$.text+=`
`+O.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=$.text):U.push(O);continue}if(C){var se="Infinite loop on byte: "+C.charCodeAt(0);if(this.options.silent){console.error(se);break}else throw new Error(se)}}return this.state.top=!0,U},T.inline=function(C,U){return U===void 0&&(U=[]),this.inlineQueue.push({src:C,tokens:U}),U},T.inlineTokens=function(C,U){var z=this;U===void 0&&(U=[]);var O,$,q,ee=C,se,ve,De;if(this.tokens.links){var Ie=Object.keys(this.tokens.links);if(Ie.length>0)for(;(se=this.tokenizer.rules.inline.reflinkSearch.exec(ee))!=null;)Ie.includes(se[0].slice(se[0].lastIndexOf("[")+1,-1))&&(ee=ee.slice(0,se.index)+"["+ie("a",se[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(se=this.tokenizer.rules.inline.blockSkip.exec(ee))!=null;)ee=ee.slice(0,se.index)+"["+ie("a",se[0].length-2)+"]"+ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(se=this.tokenizer.rules.inline.escapedEmSt.exec(ee))!=null;)ee=ee.slice(0,se.index)+"++"+ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;C;)if(ve||(De=""),ve=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(we){return(O=we.call({lexer:z},C,U))?(C=C.substring(O.raw.length),U.push(O),!0):!1}))){if(O=this.tokenizer.escape(C)){C=C.substring(O.raw.length),U.push(O);continue}if(O=this.tokenizer.tag(C)){C=C.substring(O.raw.length),$=U[U.length-1],$&&O.type==="text"&&$.type==="text"?($.raw+=O.raw,$.text+=O.text):U.push(O);continue}if(O=this.tokenizer.link(C)){C=C.substring(O.raw.length),U.push(O);continue}if(O=this.tokenizer.reflink(C,this.tokens.links)){C=C.substring(O.raw.length),$=U[U.length-1],$&&O.type==="text"&&$.type==="text"?($.raw+=O.raw,$.text+=O.text):U.push(O);continue}if(O=this.tokenizer.emStrong(C,ee,De)){C=C.substring(O.raw.length),U.push(O);continue}if(O=this.tokenizer.codespan(C)){C=C.substring(O.raw.length),U.push(O);continue}if(O=this.tokenizer.br(C)){C=C.substring(O.raw.length),U.push(O);continue}if(O=this.tokenizer.del(C)){C=C.substring(O.raw.length),U.push(O);continue}if(O=this.tokenizer.autolink(C,Ae)){C=C.substring(O.raw.length),U.push(O);continue}if(!this.state.inLink&&(O=this.tokenizer.url(C,Ae))){C=C.substring(O.raw.length),U.push(O);continue}if(q=C,this.options.extensions&&this.options.extensions.startInline&&function(){var we=1/0,Pe=C.slice(1),Ne=void 0;z.options.extensions.startInline.forEach(function(Ve){Ne=Ve.call({lexer:this},Pe),typeof Ne=="number"&&Ne>=0&&(we=Math.min(we,Ne))}),we<1/0&&we>=0&&(q=C.substring(0,we+1))}(),O=this.tokenizer.inlineText(q,Se)){C=C.substring(O.raw.length),O.raw.slice(-1)!=="_"&&(De=O.raw.slice(-1)),ve=!0,$=U[U.length-1],$&&$.type==="text"?($.raw+=O.raw,$.text+=O.text):U.push(O);continue}if(C){var Fe="Infinite loop on byte: "+C.charCodeAt(0);if(this.options.silent){console.error(Fe);break}else throw new Error(Fe)}}return U},y(k,null,[{key:"rules",get:function(){return{block:de,inline:ce}}}]),k}(),re=function(){function k(H){this.options=H||te.defaults}var T=k.prototype;return T.code=function(C,U,z){var O=(U||"").match(/\S*/)[0];if(this.options.highlight){var $=this.options.highlight(C,O);$!=null&&$!==C&&(z=!0,C=$)}return C=C.replace(/\n$/,"")+`
`,O?'<pre><code class="'+this.options.langPrefix+e(O,!0)+'">'+(z?C:e(C,!0))+`</code></pre>
`:"<pre><code>"+(z?C:e(C,!0))+`</code></pre>
`},T.blockquote=function(C){return`<blockquote>
`+C+`</blockquote>
`},T.html=function(C){return C},T.heading=function(C,U,z,O){if(this.options.headerIds){var $=this.options.headerPrefix+O.slug(z);return"<h"+U+' id="'+$+'">'+C+"</h"+U+`>
`}return"<h"+U+">"+C+"</h"+U+`>
`},T.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},T.list=function(C,U,z){var O=U?"ol":"ul",$=U&&z!==1?' start="'+z+'"':"";return"<"+O+$+`>
`+C+"</"+O+`>
`},T.listitem=function(C){return"<li>"+C+`</li>
`},T.checkbox=function(C){return"<input "+(C?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},T.paragraph=function(C){return"<p>"+C+`</p>
`},T.table=function(C,U){return U&&(U="<tbody>"+U+"</tbody>"),`<table>
<thead>
`+C+`</thead>
`+U+`</table>
`},T.tablerow=function(C){return`<tr>
`+C+`</tr>
`},T.tablecell=function(C,U){var z=U.header?"th":"td",O=U.align?"<"+z+' align="'+U.align+'">':"<"+z+">";return O+C+("</"+z+`>
`)},T.strong=function(C){return"<strong>"+C+"</strong>"},T.em=function(C){return"<em>"+C+"</em>"},T.codespan=function(C){return"<code>"+C+"</code>"},T.br=function(){return this.options.xhtml?"<br/>":"<br>"},T.del=function(C){return"<del>"+C+"</del>"},T.link=function(C,U,z){if(C=S(this.options.sanitize,this.options.baseUrl,C),C===null)return z;var O='<a href="'+e(C)+'"';return U&&(O+=' title="'+U+'"'),O+=">"+z+"</a>",O},T.image=function(C,U,z){if(C=S(this.options.sanitize,this.options.baseUrl,C),C===null)return z;var O='<img src="'+C+'" alt="'+z+'"';return U&&(O+=' title="'+U+'"'),O+=this.options.xhtml?"/>":">",O},T.text=function(C){return C},k}(),ne=function(){function k(){}var T=k.prototype;return T.strong=function(C){return C},T.em=function(C){return C},T.codespan=function(C){return C},T.del=function(C){return C},T.html=function(C){return C},T.text=function(C){return C},T.link=function(C,U,z){return""+z},T.image=function(C,U,z){return""+z},T.br=function(){return""},k}(),Q=function(){function k(){this.seen={}}var T=k.prototype;return T.serialize=function(C){return C.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},T.getNextSafeSlug=function(C,U){var z=C,O=0;if(this.seen.hasOwnProperty(z)){O=this.seen[C];do O++,z=C+"-"+O;while(this.seen.hasOwnProperty(z))}return U||(this.seen[C]=O,this.seen[z]=0),z},T.slug=function(C,U){U===void 0&&(U={});var z=this.serialize(C);return this.getNextSafeSlug(z,U.dryrun)},k}(),oe=function(){function k(H){this.options=H||te.defaults,this.options.renderer=this.options.renderer||new re,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ne,this.slugger=new Q}k.parse=function(C,U){var z=new k(U);return z.parse(C)},k.parseInline=function(C,U){var z=new k(U);return z.parseInline(C)};var T=k.prototype;return T.parse=function(C,U){U===void 0&&(U=!0);var z="",O,$,q,ee,se,ve,De,Ie,Fe,we,Pe,Ne,Ve,ze,We,Je,it,Oe,je,K=C.length;for(O=0;O<K;O++){if(we=C[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[we.type]&&(je=this.options.extensions.renderers[we.type].call({parser:this},we),je!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(we.type))){z+=je||"";continue}switch(we.type){case"space":continue;case"hr":{z+=this.renderer.hr();continue}case"heading":{z+=this.renderer.heading(this.parseInline(we.tokens),we.depth,n(this.parseInline(we.tokens,this.textRenderer)),this.slugger);continue}case"code":{z+=this.renderer.code(we.text,we.lang,we.escaped);continue}case"table":{for(Ie="",De="",ee=we.header.length,$=0;$<ee;$++)De+=this.renderer.tablecell(this.parseInline(we.header[$].tokens),{header:!0,align:we.align[$]});for(Ie+=this.renderer.tablerow(De),Fe="",ee=we.rows.length,$=0;$<ee;$++){for(ve=we.rows[$],De="",se=ve.length,q=0;q<se;q++)De+=this.renderer.tablecell(this.parseInline(ve[q].tokens),{header:!1,align:we.align[q]});Fe+=this.renderer.tablerow(De)}z+=this.renderer.table(Ie,Fe);continue}case"blockquote":{Fe=this.parse(we.tokens),z+=this.renderer.blockquote(Fe);continue}case"list":{for(Pe=we.ordered,Ne=we.start,Ve=we.loose,ee=we.items.length,Fe="",$=0;$<ee;$++)We=we.items[$],Je=We.checked,it=We.task,ze="",We.task&&(Oe=this.renderer.checkbox(Je),Ve?We.tokens.length>0&&We.tokens[0].type==="paragraph"?(We.tokens[0].text=Oe+" "+We.tokens[0].text,We.tokens[0].tokens&&We.tokens[0].tokens.length>0&&We.tokens[0].tokens[0].type==="text"&&(We.tokens[0].tokens[0].text=Oe+" "+We.tokens[0].tokens[0].text)):We.tokens.unshift({type:"text",text:Oe}):ze+=Oe),ze+=this.parse(We.tokens,Ve),Fe+=this.renderer.listitem(ze,it,Je);z+=this.renderer.list(Fe,Pe,Ne);continue}case"html":{z+=this.renderer.html(we.text);continue}case"paragraph":{z+=this.renderer.paragraph(this.parseInline(we.tokens));continue}case"text":{for(Fe=we.tokens?this.parseInline(we.tokens):we.text;O+1<K&&C[O+1].type==="text";)we=C[++O],Fe+=`
`+(we.tokens?this.parseInline(we.tokens):we.text);z+=U?this.renderer.paragraph(Fe):Fe;continue}default:{var ae='Token with "'+we.type+'" type was not found.';if(this.options.silent){console.error(ae);return}else throw new Error(ae)}}}return z},T.parseInline=function(C,U){U=U||this.renderer;var z="",O,$,q,ee=C.length;for(O=0;O<ee;O++){if($=C[O],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[$.type]&&(q=this.options.extensions.renderers[$.type].call({parser:this},$),q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes($.type))){z+=q||"";continue}switch($.type){case"escape":{z+=U.text($.text);break}case"html":{z+=U.html($.text);break}case"link":{z+=U.link($.href,$.title,this.parseInline($.tokens,U));break}case"image":{z+=U.image($.href,$.title,$.text);break}case"strong":{z+=U.strong(this.parseInline($.tokens,U));break}case"em":{z+=U.em(this.parseInline($.tokens,U));break}case"codespan":{z+=U.codespan($.text);break}case"br":{z+=U.br();break}case"del":{z+=U.del(this.parseInline($.tokens,U));break}case"text":{z+=U.text($.text);break}default:{var se='Token with "'+$.type+'" type was not found.';if(this.options.silent){console.error(se);return}else throw new Error(se)}}}return z},k}();function j(k,T,H){if(typeof k>"u"||k===null)throw new Error("marked(): input parameter is undefined or null");if(typeof k!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(k)+", string expected");if(typeof T=="function"&&(H=T,T=null),T=m({},j.defaults,T||{}),J(T),H){var C=T.highlight,U;try{U=Be.lex(k,T)}catch(ee){return H(ee)}var z=function(se){var ve;if(!se)try{T.walkTokens&&j.walkTokens(U,T.walkTokens),ve=oe.parse(U,T)}catch(De){se=De}return T.highlight=C,se?H(se):H(null,ve)};if(!C||C.length<3||(delete T.highlight,!U.length))return z();var O=0;j.walkTokens(U,function(ee){ee.type==="code"&&(O++,setTimeout(function(){C(ee.text,ee.lang,function(se,ve){if(se)return z(se);ve!=null&&ve!==ee.text&&(ee.text=ve,ee.escaped=!0),O--,O===0&&z()})},0))}),O===0&&z();return}function $(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,T.silent)return"<p>An error occurred:</p><pre>"+e(ee.message+"",!0)+"</pre>";throw ee}try{var q=Be.lex(k,T);if(T.walkTokens){if(T.async)return Promise.all(j.walkTokens(q,T.walkTokens)).then(function(){return oe.parse(q,T)}).catch($);j.walkTokens(q,T.walkTokens)}return oe.parse(q,T)}catch(ee){$(ee)}}j.options=j.setOptions=function(k){return m(j.defaults,k),A(j.defaults),j},j.getDefaults=p,j.defaults=te.defaults,j.use=function(){for(var k=arguments.length,T=new Array(k),H=0;H<k;H++)T[H]=arguments[H];var C=m.apply(void 0,[{}].concat(T)),U=j.defaults.extensions||{renderers:{},childTokens:{}},z;T.forEach(function(O){if(O.extensions&&(z=!0,O.extensions.forEach(function(q){if(!q.name)throw new Error("extension name required");if(q.renderer){var ee=U.renderers?U.renderers[q.name]:null;ee?U.renderers[q.name]=function(){for(var se=arguments.length,ve=new Array(se),De=0;De<se;De++)ve[De]=arguments[De];var Ie=q.renderer.apply(this,ve);return Ie===!1&&(Ie=ee.apply(this,ve)),Ie}:U.renderers[q.name]=q.renderer}if(q.tokenizer){if(!q.level||q.level!=="block"&&q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");U[q.level]?U[q.level].unshift(q.tokenizer):U[q.level]=[q.tokenizer],q.start&&(q.level==="block"?U.startBlock?U.startBlock.push(q.start):U.startBlock=[q.start]:q.level==="inline"&&(U.startInline?U.startInline.push(q.start):U.startInline=[q.start]))}q.childTokens&&(U.childTokens[q.name]=q.childTokens)})),O.renderer&&function(){var q=j.defaults.renderer||new re,ee=function(De){var Ie=q[De];q[De]=function(){for(var Fe=arguments.length,we=new Array(Fe),Pe=0;Pe<Fe;Pe++)we[Pe]=arguments[Pe];var Ne=O.renderer[De].apply(q,we);return Ne===!1&&(Ne=Ie.apply(q,we)),Ne}};for(var se in O.renderer)ee(se);C.renderer=q}(),O.tokenizer&&function(){var q=j.defaults.tokenizer||new ue,ee=function(De){var Ie=q[De];q[De]=function(){for(var Fe=arguments.length,we=new Array(Fe),Pe=0;Pe<Fe;Pe++)we[Pe]=arguments[Pe];var Ne=O.tokenizer[De].apply(q,we);return Ne===!1&&(Ne=Ie.apply(q,we)),Ne}};for(var se in O.tokenizer)ee(se);C.tokenizer=q}(),O.walkTokens){var $=j.defaults.walkTokens;C.walkTokens=function(q){var ee=[];return ee.push(O.walkTokens.call(this,q)),$&&(ee=ee.concat($.call(this,q))),ee}}z&&(C.extensions=U),j.setOptions(C)})},j.walkTokens=function(k,T){for(var H=[],C=function(){var $=z.value;switch(H=H.concat(T.call(j,$)),$.type){case"table":{for(var q=W($.header),ee;!(ee=q()).done;){var se=ee.value;H=H.concat(j.walkTokens(se.tokens,T))}for(var ve=W($.rows),De;!(De=ve()).done;)for(var Ie=De.value,Fe=W(Ie),we;!(we=Fe()).done;){var Pe=we.value;H=H.concat(j.walkTokens(Pe.tokens,T))}break}case"list":{H=H.concat(j.walkTokens($.items,T));break}default:j.defaults.extensions&&j.defaults.extensions.childTokens&&j.defaults.extensions.childTokens[$.type]?j.defaults.extensions.childTokens[$.type].forEach(function(Ne){H=H.concat(j.walkTokens($[Ne],T))}):$.tokens&&(H=H.concat(j.walkTokens($.tokens,T)))}},U=W(k),z;!(z=U()).done;)C();return H},j.parseInline=function(k,T){if(typeof k>"u"||k===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof k!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(k)+", string expected");T=m({},j.defaults,T||{}),J(T);try{var H=Be.lexInline(k,T);return T.walkTokens&&j.walkTokens(H,T.walkTokens),oe.parseInline(H,T)}catch(C){if(C.message+=`
Please report this to https://github.com/markedjs/marked.`,T.silent)return"<p>An error occurred:</p><pre>"+e(C.message+"",!0)+"</pre>";throw C}},j.Parser=oe,j.parser=oe.parse,j.Renderer=re,j.TextRenderer=ne,j.Lexer=Be,j.lexer=Be.lex,j.Tokenizer=ue,j.Slugger=Q,j.parse=j;var V=j.options,F=j.setOptions,x=j.use,I=j.walkTokens,d=j.parseInline,R=j,_=oe.parse,Z=Be.lex;te.Lexer=Be,te.Parser=oe,te.Renderer=re,te.Slugger=Q,te.TextRenderer=ne,te.Tokenizer=ue,te.getDefaults=p,te.lexer=Z,te.marked=j,te.options=V,te.parse=R,te.parseInline=d,te.parser=_,te.setOptions=F,te.use=x,te.walkTokens=I,Object.defineProperty(te,"__esModule",{value:!0})}),define(me[77],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class y{constructor(i,W=0,p=i.length,A=W-1){this.a=i,this.b=W,this.c=p,this.d=A}current(){return this.d===this.b-1||this.d===this.c?null:this.a[this.d]}next(){return this.d=Math.min(this.d+1,this.c),this.current()}previous(){return this.d=Math.max(this.d-1,this.b-1),this.current()}first(){return this.d=this.b,this.current()}last(){return this.d=this.c-1,this.current()}}t.ArrayNavigator=y}),define(me[78],be([1,0,77]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class M{constructor(p=[],A=10){this.h(p),this.b=A,this.d()}getHistory(){return this.j}add(p){this.a.delete(p),this.a.add(p),this.d()}next(){return this.c.next()}previous(){return this.g()!==0?this.c.previous():null}current(){return this.c.current()}first(){return this.c.first()}last(){return this.c.last()}isFirst(){return this.g()===0}isLast(){return this.g()>=this.j.length-1}isNowhere(){return this.c.current()===null}has(p){return this.a.has(p)}clear(){this.h([]),this.d()}d(){this.f();const p=this.j;this.c=new y.ArrayNavigator(p,0,p.length,p.length)}f(){const p=this.j;p.length>this.b&&this.h(p.slice(p.length-this.b))}g(){const p=this.c.current();return p?this.j.indexOf(p):-1}h(p){this.a=new Set;for(const A of p)this.a.add(A)}get j(){const p=[];return this.a.forEach(A=>p.push(A)),p}}t.HistoryNavigator=M;class i{constructor(p,A=10){if(this.g=A,p.length<1)throw new Error("not supported");this.f=1,this.b=this.c=this.d={value:p[0],previous:void 0,next:void 0},this.a=new Set([p[0]]);for(let h=1;h<p.length;h++)this.add(p[h])}add(p){const A={value:p,previous:this.c,next:void 0};for(this.c.next=A,this.c=A,this.d=this.c,this.f++,this.a.has(p)?this.h(p):this.a.add(p);this.f>this.g;)this.a.delete(this.b.value),this.b=this.b.next,this.b.previous=void 0,this.f--}replaceLast(p){if(this.c.value===p)return p;const A=this.c.value;return this.a.delete(A),this.c.value=p,this.a.has(p)?this.h(p):this.a.add(p),A}isAtEnd(){return this.d===this.c}current(){return this.d.value}previous(){return this.d.previous&&(this.d=this.d.previous),this.d.value}next(){return this.d.next&&(this.d=this.d.next),this.d.value}has(p){return this.a.has(p)}resetCursor(){return this.d=this.c,this.d.value}*[Symbol.iterator](){let p=this.b;for(;p;)yield p.value,p=p.next}h(p){let A=this.b;for(;A!==this.c;)A.value===p&&(A===this.b?(this.b=this.b.next,this.b.previous=void 0):(A.previous.next=A.next,A.next.previous=A.previous),this.f--),A=A.next}}t.HistoryNavigator2=i}),define(me[44],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function y(A,h,a){return Math.min(Math.max(A,h),a)}t.clamp=y;function M(A,h){return(h+A%h)%h}t.rot=M;class i{constructor(){this.a=0}getNext(){return this.a++}}t.Counter=i;class W{constructor(){this.a=1,this.b=0}update(h){return this.b=this.b+(h-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}t.MovingAverage=W;class p{constructor(h){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(h),this.c.fill(0,0,h)}update(h){const a=this.c[this.d];return this.c[this.d]=h,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=h,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}t.SlidingWindowAverage=p}),define(me[45],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var y;(function(M){function i(h,a){if(h.start>=a.end||a.start>=h.end)return{start:0,end:0};const c=Math.max(h.start,a.start),P=Math.min(h.end,a.end);return P-c<=0?{start:0,end:0}:{start:c,end:P}}M.intersect=i;function W(h){return h.end-h.start<=0}M.isEmpty=W;function p(h,a){return!W(i(h,a))}M.intersects=p;function A(h,a){const c=[],P={start:h.start,end:Math.min(a.start,h.end)},r={start:Math.max(a.end,h.start),end:h.end};return W(P)||c.push(P),W(r)||c.push(r),c}M.relativeComplement=A})(y||(t.Range=y={}))}),define(me[79],be([1,0,45]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function M(h,a){const c=[];for(const P of a){if(h.start>=P.range.end)continue;if(h.end<P.range.start)break;const r=y.Range.intersect(h,P.range);y.Range.isEmpty(r)||c.push({range:r,size:P.size})}return c}t.groupIntersect=M;function i({start:h,end:a},c){return{start:h+c,end:a+c}}t.shift=i;function W(h){const a=[];let c=null;for(const P of h){const r=P.range.start,l=P.range.end,e=P.size;if(c&&e===c.size){c.range.end=l;continue}c={range:{start:r,end:l},size:e},a.push(c)}return a}t.consolidate=W;function p(...h){return W(h.reduce((a,c)=>a.concat(c),[]))}class A{constructor(){this.a=[],this.b=0}splice(a,c,P=[]){const r=P.length-c,l=M({start:0,end:a},this.a),e=M({start:a+c,end:Number.POSITIVE_INFINITY},this.a).map(n=>({range:i(n.range,r),size:n.size})),o=P.map((n,u)=>({range:{start:a+u,end:a+u+1},size:n.size}));this.a=p(l,o,e),this.b=this.a.reduce((n,u)=>n+u.size*(u.range.end-u.range.start),0)}get count(){const a=this.a.length;return a?this.a[a-1].range.end:0}get size(){return this.b}indexAt(a){if(a<0)return-1;let c=0,P=0;for(const r of this.a){const l=r.range.end-r.range.start,e=P+l*r.size;if(a<e)return c+Math.floor((a-P)/r.size);c+=l,P=e}return c}indexAfter(a){return Math.min(this.indexAt(a)+1,this.count)}positionAt(a){if(a<0)return-1;let c=0,P=0;for(const r of this.a){const l=r.range.end-r.range.start,e=P+l;if(a<e)return c+(a-P)*r.size;c+=l*r.size,P=e}return-1}}t.RangeMap=A}),define(me[80],be([1,0,7,2]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function i(D){const S=D;return S?typeof S.read=="function":!1}t.isReadable=i;function W(D){const S=D;return S?[S.on,S.pause,S.resume,S.destroy].every(f=>typeof f=="function"):!1}t.isReadableStream=W;function p(D){const S=D;return S?W(S.stream)&&Array.isArray(S.buffer)&&typeof S.ended=="boolean":!1}t.isReadableBufferedStream=p;function A(D,S){return new h(D,S)}t.newWriteableStream=A;class h{constructor(S,f){this.e=S,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(S){if(!this.a.destroyed){if(this.a.flowing)this.g(S);else if(this.b.data.push(S),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(S){this.a.destroyed||(this.a.flowing?this.h(S):this.b.error.push(S))}end(S){this.a.destroyed||(typeof S<"u"&&this.write(S),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(S){this.c.data.slice(0).forEach(f=>f(S))}h(S){this.c.error.length===0?(0,y.onUnexpectedError)(S):this.c.error.slice(0).forEach(f=>f(S))}i(){this.c.end.slice(0).forEach(S=>S())}on(S,f){if(!this.a.destroyed)switch(S){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(S,f){if(this.a.destroyed)return;let v;switch(S){case"data":v=this.c.data;break;case"end":v=this.c.end;break;case"error":v=this.c.error;break}if(v){const L=v.indexOf(f);L>=0&&v.splice(L,1)}}j(){if(this.b.data.length>0){const S=this.e(this.b.data);this.g(S),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(v=>v())}}k(){if(this.c.error.length>0){for(const S of this.b.error)this.h(S);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(D,S){const f=[];let v;for(;(v=D.read())!==null;)f.push(v);return S(f)}t.consumeReadable=a;function c(D,S,f){const v=[];let L;for(;(L=D.read())!==null&&v.length<f;)v.push(L);return L===null&&v.length>0?S(v):{read:()=>{if(v.length>0)return v.shift();if(typeof L<"u"){const N=L;return L=void 0,N}return D.read()}}}t.peekReadable=c;function P(D,S){return new Promise((f,v)=>{const L=[];r(D,{onData:N=>{S&&L.push(N)},onError:N=>{S?v(N):f(void 0)},onEnd:()=>{f(S?S(L):void 0)}})})}t.consumeStream=P;function r(D,S){let f=!1;return D.on("error",v=>{f||S.onError(v)}),D.on("end",()=>{f||S.onEnd()}),D.on("data",v=>{f||S.onData(v)}),(0,M.toDisposable)(()=>f=!0)}t.listenStream=r;function l(D,S){return new Promise((f,v)=>{const L=new M.DisposableStore,N=[],E=b=>{if(N.push(b),N.length>S)return L.dispose(),D.pause(),f({stream:D,buffer:N,ended:!1})},g=b=>v(b),m=()=>f({stream:D,buffer:N,ended:!0});L.add((0,M.toDisposable)(()=>D.removeListener("error",g))),D.on("error",g),L.add((0,M.toDisposable)(()=>D.removeListener("end",m))),D.on("end",m),L.add((0,M.toDisposable)(()=>D.removeListener("data",E))),D.on("data",E)})}t.peekStream=l;function e(D,S){const f=A(S);return f.end(D),f}t.toStream=e;function o(){const D=A(()=>{throw new Error("not supported")});return D.end(),D}t.emptyStream=o;function n(D){let S=!1;return{read:()=>S?null:(S=!0,D)}}t.toReadable=n;function u(D,S,f){const v=A(f);return r(D,{onData:L=>v.write(S.data(L)),onError:L=>v.error(S.error?S.error(L):L),onEnd:()=>v.end()}),v}t.transform=u;function s(D,S,f){let v=!1;return{read:()=>{const L=S.read();return v?L:(v=!0,L!==null?f([D,L]):D)}}}t.prefixedReadable=s;function w(D,S,f){let v=!1;const L=A(f);return r(S,{onData:N=>v?L.write(N):(v=!0,L.write(f([D,N]))),onError:N=>L.error(N),onEnd:()=>{v||(v=!0,L.write(D)),L.end()}}),L}t.prefixedStream=w}),define(me[30],be([1,0,80]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const M=typeof Buffer<"u";let i,W;class p{static alloc(b){return M?new p(Buffer.allocUnsafe(b)):new p(new Uint8Array(b))}static wrap(b){return M&&!Buffer.isBuffer(b)&&(b=Buffer.from(b.buffer,b.byteOffset,b.byteLength)),new p(b)}static fromString(b,B){return!(B?.dontUseNodeBuffer||!1)&&M?new p(Buffer.from(b)):(i||(i=new TextEncoder),new p(i.encode(b)))}static fromByteArray(b){const B=p.alloc(b.length);for(let G=0,J=b.length;G<J;G++)B.buffer[G]=b[G];return B}static concat(b,B){if(typeof B>"u"){B=0;for(let ie=0,le=b.length;ie<le;ie++)B+=b[ie].byteLength}const G=p.alloc(B);let J=0;for(let ie=0,le=b.length;ie<le;ie++){const ge=b[ie];G.set(ge,J),J+=ge.byteLength}return G}constructor(b){this.buffer=b,this.byteLength=this.buffer.byteLength}clone(){const b=p.alloc(this.byteLength);return b.set(this),b}toString(){return M?this.buffer.toString():(W||(W=new TextDecoder),W.decode(this.buffer))}slice(b,B){return new p(this.buffer.subarray(b,B))}set(b,B){if(b instanceof p)this.buffer.set(b.buffer,B);else if(b instanceof Uint8Array)this.buffer.set(b,B);else if(b instanceof ArrayBuffer)this.buffer.set(new Uint8Array(b),B);else if(ArrayBuffer.isView(b))this.buffer.set(new Uint8Array(b.buffer,b.byteOffset,b.byteLength),B);else throw new Error("Unknown argument 'array'")}readUInt32BE(b){return a(this.buffer,b)}writeUInt32BE(b,B){c(this.buffer,b,B)}readUInt32LE(b){return P(this.buffer,b)}writeUInt32LE(b,B){r(this.buffer,b,B)}readUInt8(b){return l(this.buffer,b)}writeUInt8(b,B){e(this.buffer,b,B)}}t.VSBuffer=p;function A(m,b){return m[b+0]<<0>>>0|m[b+1]<<8>>>0}t.readUInt16LE=A;function h(m,b,B){m[B+0]=b&255,b=b>>>8,m[B+1]=b&255}t.writeUInt16LE=h;function a(m,b){return m[b]*2**24+m[b+1]*2**16+m[b+2]*2**8+m[b+3]}t.readUInt32BE=a;function c(m,b,B){m[B+3]=b,b=b>>>8,m[B+2]=b,b=b>>>8,m[B+1]=b,b=b>>>8,m[B]=b}t.writeUInt32BE=c;function P(m,b){return m[b+0]<<0>>>0|m[b+1]<<8>>>0|m[b+2]<<16>>>0|m[b+3]<<24>>>0}t.readUInt32LE=P;function r(m,b,B){m[B+0]=b&255,b=b>>>8,m[B+1]=b&255,b=b>>>8,m[B+2]=b&255,b=b>>>8,m[B+3]=b&255}t.writeUInt32LE=r;function l(m,b){return m[b]}t.readUInt8=l;function e(m,b,B){m[B]=b}t.writeUInt8=e;function o(m){return y.consumeReadable(m,b=>p.concat(b))}t.readableToBuffer=o;function n(m){return y.toReadable(m)}t.bufferToReadable=n;function u(m){return y.consumeStream(m,b=>p.concat(b))}t.streamToBuffer=u;async function s(m){return m.ended?p.concat(m.buffer):p.concat([...m.buffer,await u(m.stream)])}t.bufferedStreamToBuffer=s;function w(m){return y.toStream(m,b=>p.concat(b))}t.bufferToStream=w;function D(m){return y.transform(m,{data:b=>typeof b=="string"?p.fromString(b):p.wrap(b)},b=>p.concat(b))}t.streamToBufferReadableStream=D;function S(m){return y.newWriteableStream(b=>p.concat(b),m)}t.newWriteableBufferStream=S;function f(m,b){return y.prefixedReadable(m,b,B=>p.concat(B))}t.prefixedBufferReadable=f;function v(m,b){return y.prefixedStream(m,b,B=>p.concat(B))}t.prefixedBufferStream=v;function L(m){let b=0,B=0,G=0;const J=new Uint8Array(Math.floor(m.length/4*3)),ie=ge=>{switch(B){case 3:J[G++]=b|ge,B=0;break;case 2:J[G++]=b|ge>>>2,b=ge<<6,B=3;break;case 1:J[G++]=b|ge>>>4,b=ge<<4,B=2;break;default:b=ge<<2,B=1}};for(let ge=0;ge<m.length;ge++){const ue=m.charCodeAt(ge);if(ue>=65&&ue<=90)ie(ue-65);else if(ue>=97&&ue<=122)ie(ue-97+26);else if(ue>=48&&ue<=57)ie(ue-48+52);else if(ue===43||ue===45)ie(62);else if(ue===47||ue===95)ie(63);else{if(ue===61)break;throw new SyntaxError(`Unexpected base64 character ${m[ge]}`)}}const le=G;for(;B>0;)ie(0);return p.wrap(J).slice(0,le)}t.decodeBase64=L;const N="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function g({buffer:m},b=!0,B=!1){const G=B?E:N;let J="";const ie=m.byteLength%3;let le=0;for(;le<m.byteLength-ie;le+=3){const ge=m[le+0],ue=m[le+1],de=m[le+2];J+=G[ge>>>2],J+=G[(ge<<4|ue>>>4)&63],J+=G[(ue<<2|de>>>6)&63],J+=G[de&63]}if(ie===1){const ge=m[le+0];J+=G[ge>>>2],J+=G[ge<<4&63],b&&(J+="==")}else if(ie===2){const ge=m[le+0],ue=m[le+1];J+=G[ge>>>2],J+=G[(ge<<4|ue>>>4)&63],J+=G[ue<<2&63],b&&(J+="=")}return J}t.encodeBase64=g}),define(me[46],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MicrotaskDelay=void 0,t.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(me[6],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function y(v){return typeof v=="string"}t.isString=y;function M(v){return Array.isArray(v)&&v.every(L=>y(L))}t.isStringArray=M;function i(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}t.isObject=i;function W(v){const L=Object.getPrototypeOf(Uint8Array);return typeof v=="object"&&v instanceof L}t.isTypedArray=W;function p(v){return typeof v=="number"&&!isNaN(v)}t.isNumber=p;function A(v){return!!v&&typeof v[Symbol.iterator]=="function"}t.isIterable=A;function h(v){return v===!0||v===!1}t.isBoolean=h;function a(v){return typeof v>"u"}t.isUndefined=a;function c(v){return!P(v)}t.isDefined=c;function P(v){return a(v)||v===null}t.isUndefinedOrNull=P;function r(v,L){if(!v)throw new Error(L?`Unexpected type, expected '${L}'`:"Unexpected type")}t.assertType=r;function l(v){if(P(v))throw new Error("Assertion Failed: argument is undefined or null");return v}t.assertIsDefined=l;function e(...v){const L=[];for(let N=0;N<v.length;N++){const E=v[N];if(P(E))throw new Error(`Assertion Failed: argument at index ${N} is undefined or null`);L.push(E)}return L}t.assertAllDefined=e;const o=Object.prototype.hasOwnProperty;function n(v){if(!i(v))return!1;for(const L in v)if(o.call(v,L))return!1;return!0}t.isEmptyObject=n;function u(v){return typeof v=="function"}t.isFunction=u;function s(...v){return v.length>0&&v.every(u)}t.areFunctions=s;function w(v,L){const N=Math.min(v.length,L.length);for(let E=0;E<N;E++)D(v[E],L[E])}t.validateConstraints=w;function D(v,L){if(y(L)){if(typeof v!==L)throw new Error(`argument does not match constraint: typeof ${L}`)}else if(u(L)){try{if(v instanceof L)return}catch{}if(!P(v)&&v.constructor===L||L.length===1&&L.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=D;function S(v){return v===null?void 0:v}t.withNullAsUndefined=S;function f(v){return typeof v>"u"?null:v}t.withUndefinedAsNull=f}),define(me[16],be([1,0,6]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Codicon=t.getAllCodicons=t.getCodiconFontCharacters=void 0;const M=Object.create(null);function i(A,h){if((0,y.isString)(h)){const a=M[h];if(a===void 0)throw new Error(`${A} references an unknown codicon: ${h}`);h=a}return M[A]=h,{id:A}}function W(){return M}t.getCodiconFontCharacters=W;function p(){return Object.values(t.Codicon)}t.getAllCodicons=p,t.Codicon={add:i("add",6e4),plus:i("plus",6e4),gistNew:i("gist-new",6e4),repoCreate:i("repo-create",6e4),lightbulb:i("lightbulb",60001),lightBulb:i("light-bulb",60001),repo:i("repo",60002),repoDelete:i("repo-delete",60002),gistFork:i("gist-fork",60003),repoForked:i("repo-forked",60003),gitPullRequest:i("git-pull-request",60004),gitPullRequestAbandoned:i("git-pull-request-abandoned",60004),recordKeys:i("record-keys",60005),keyboard:i("keyboard",60005),tag:i("tag",60006),tagAdd:i("tag-add",60006),tagRemove:i("tag-remove",60006),person:i("person",60007),personFollow:i("person-follow",60007),personOutline:i("person-outline",60007),personFilled:i("person-filled",60007),gitBranch:i("git-branch",60008),gitBranchCreate:i("git-branch-create",60008),gitBranchDelete:i("git-branch-delete",60008),sourceControl:i("source-control",60008),mirror:i("mirror",60009),mirrorPublic:i("mirror-public",60009),star:i("star",60010),starAdd:i("star-add",60010),starDelete:i("star-delete",60010),starEmpty:i("star-empty",60010),comment:i("comment",60011),commentAdd:i("comment-add",60011),alert:i("alert",60012),warning:i("warning",60012),search:i("search",60013),searchSave:i("search-save",60013),logOut:i("log-out",60014),signOut:i("sign-out",60014),logIn:i("log-in",60015),signIn:i("sign-in",60015),eye:i("eye",60016),eyeUnwatch:i("eye-unwatch",60016),eyeWatch:i("eye-watch",60016),circleFilled:i("circle-filled",60017),primitiveDot:i("primitive-dot",60017),closeDirty:i("close-dirty",60017),debugBreakpoint:i("debug-breakpoint",60017),debugBreakpointDisabled:i("debug-breakpoint-disabled",60017),debugHint:i("debug-hint",60017),primitiveSquare:i("primitive-square",60018),edit:i("edit",60019),pencil:i("pencil",60019),info:i("info",60020),issueOpened:i("issue-opened",60020),gistPrivate:i("gist-private",60021),gitForkPrivate:i("git-fork-private",60021),lock:i("lock",60021),mirrorPrivate:i("mirror-private",60021),close:i("close",60022),removeClose:i("remove-close",60022),x:i("x",60022),repoSync:i("repo-sync",60023),sync:i("sync",60023),clone:i("clone",60024),desktopDownload:i("desktop-download",60024),beaker:i("beaker",60025),microscope:i("microscope",60025),vm:i("vm",60026),deviceDesktop:i("device-desktop",60026),file:i("file",60027),fileText:i("file-text",60027),more:i("more",60028),ellipsis:i("ellipsis",60028),kebabHorizontal:i("kebab-horizontal",60028),mailReply:i("mail-reply",60029),reply:i("reply",60029),organization:i("organization",60030),organizationFilled:i("organization-filled",60030),organizationOutline:i("organization-outline",60030),newFile:i("new-file",60031),fileAdd:i("file-add",60031),newFolder:i("new-folder",60032),fileDirectoryCreate:i("file-directory-create",60032),trash:i("trash",60033),trashcan:i("trashcan",60033),history:i("history",60034),clock:i("clock",60034),folder:i("folder",60035),fileDirectory:i("file-directory",60035),symbolFolder:i("symbol-folder",60035),logoGithub:i("logo-github",60036),markGithub:i("mark-github",60036),github:i("github",60036),terminal:i("terminal",60037),console:i("console",60037),repl:i("repl",60037),zap:i("zap",60038),symbolEvent:i("symbol-event",60038),error:i("error",60039),stop:i("stop",60039),variable:i("variable",60040),symbolVariable:i("symbol-variable",60040),array:i("array",60042),symbolArray:i("symbol-array",60042),symbolModule:i("symbol-module",60043),symbolPackage:i("symbol-package",60043),symbolNamespace:i("symbol-namespace",60043),symbolObject:i("symbol-object",60043),symbolMethod:i("symbol-method",60044),symbolFunction:i("symbol-function",60044),symbolConstructor:i("symbol-constructor",60044),symbolBoolean:i("symbol-boolean",60047),symbolNull:i("symbol-null",60047),symbolNumeric:i("symbol-numeric",60048),symbolNumber:i("symbol-number",60048),symbolStructure:i("symbol-structure",60049),symbolStruct:i("symbol-struct",60049),symbolParameter:i("symbol-parameter",60050),symbolTypeParameter:i("symbol-type-parameter",60050),symbolKey:i("symbol-key",60051),symbolText:i("symbol-text",60051),symbolReference:i("symbol-reference",60052),goToFile:i("go-to-file",60052),symbolEnum:i("symbol-enum",60053),symbolValue:i("symbol-value",60053),symbolRuler:i("symbol-ruler",60054),symbolUnit:i("symbol-unit",60054),activateBreakpoints:i("activate-breakpoints",60055),archive:i("archive",60056),arrowBoth:i("arrow-both",60057),arrowDown:i("arrow-down",60058),arrowLeft:i("arrow-left",60059),arrowRight:i("arrow-right",60060),arrowSmallDown:i("arrow-small-down",60061),arrowSmallLeft:i("arrow-small-left",60062),arrowSmallRight:i("arrow-small-right",60063),arrowSmallUp:i("arrow-small-up",60064),arrowUp:i("arrow-up",60065),bell:i("bell",60066),bold:i("bold",60067),book:i("book",60068),bookmark:i("bookmark",60069),debugBreakpointConditionalUnverified:i("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:i("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:i("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:i("debug-breakpoint-data-unverified",60072),debugBreakpointData:i("debug-breakpoint-data",60073),debugBreakpointDataDisabled:i("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:i("debug-breakpoint-log-unverified",60074),debugBreakpointLog:i("debug-breakpoint-log",60075),debugBreakpointLogDisabled:i("debug-breakpoint-log-disabled",60075),briefcase:i("briefcase",60076),broadcast:i("broadcast",60077),browser:i("browser",60078),bug:i("bug",60079),calendar:i("calendar",60080),caseSensitive:i("case-sensitive",60081),check:i("check",60082),checklist:i("checklist",60083),chevronDown:i("chevron-down",60084),dropDownButton:i("drop-down-button",60084),chevronLeft:i("chevron-left",60085),chevronRight:i("chevron-right",60086),chevronUp:i("chevron-up",60087),chromeClose:i("chrome-close",60088),chromeMaximize:i("chrome-maximize",60089),chromeMinimize:i("chrome-minimize",60090),chromeRestore:i("chrome-restore",60091),circle:i("circle",60092),circleOutline:i("circle-outline",60092),debugBreakpointUnverified:i("debug-breakpoint-unverified",60092),circleSlash:i("circle-slash",60093),circuitBoard:i("circuit-board",60094),clearAll:i("clear-all",60095),clippy:i("clippy",60096),closeAll:i("close-all",60097),cloudDownload:i("cloud-download",60098),cloudUpload:i("cloud-upload",60099),code:i("code",60100),collapseAll:i("collapse-all",60101),colorMode:i("color-mode",60102),commentDiscussion:i("comment-discussion",60103),compareChanges:i("compare-changes",60157),creditCard:i("credit-card",60105),dash:i("dash",60108),dashboard:i("dashboard",60109),database:i("database",60110),debugContinue:i("debug-continue",60111),debugDisconnect:i("debug-disconnect",60112),debugPause:i("debug-pause",60113),debugRestart:i("debug-restart",60114),debugStart:i("debug-start",60115),debugStepInto:i("debug-step-into",60116),debugStepOut:i("debug-step-out",60117),debugStepOver:i("debug-step-over",60118),debugStop:i("debug-stop",60119),debug:i("debug",60120),deviceCameraVideo:i("device-camera-video",60121),deviceCamera:i("device-camera",60122),deviceMobile:i("device-mobile",60123),diffAdded:i("diff-added",60124),diffIgnored:i("diff-ignored",60125),diffModified:i("diff-modified",60126),diffRemoved:i("diff-removed",60127),diffRenamed:i("diff-renamed",60128),diff:i("diff",60129),discard:i("discard",60130),editorLayout:i("editor-layout",60131),emptyWindow:i("empty-window",60132),exclude:i("exclude",60133),extensions:i("extensions",60134),eyeClosed:i("eye-closed",60135),fileBinary:i("file-binary",60136),fileCode:i("file-code",60137),fileMedia:i("file-media",60138),filePdf:i("file-pdf",60139),fileSubmodule:i("file-submodule",60140),fileSymlinkDirectory:i("file-symlink-directory",60141),fileSymlinkFile:i("file-symlink-file",60142),fileZip:i("file-zip",60143),files:i("files",60144),filter:i("filter",60145),flame:i("flame",60146),foldDown:i("fold-down",60147),foldUp:i("fold-up",60148),fold:i("fold",60149),folderActive:i("folder-active",60150),folderOpened:i("folder-opened",60151),gear:i("gear",60152),gift:i("gift",60153),gistSecret:i("gist-secret",60154),gist:i("gist",60155),gitCommit:i("git-commit",60156),gitCompare:i("git-compare",60157),gitMerge:i("git-merge",60158),githubAction:i("github-action",60159),githubAlt:i("github-alt",60160),globe:i("globe",60161),grabber:i("grabber",60162),graph:i("graph",60163),gripper:i("gripper",60164),heart:i("heart",60165),home:i("home",60166),horizontalRule:i("horizontal-rule",60167),hubot:i("hubot",60168),inbox:i("inbox",60169),issueClosed:i("issue-closed",60324),issueReopened:i("issue-reopened",60171),issues:i("issues",60172),italic:i("italic",60173),jersey:i("jersey",60174),json:i("json",60175),bracket:i("bracket",60175),kebabVertical:i("kebab-vertical",60176),key:i("key",60177),law:i("law",60178),lightbulbAutofix:i("lightbulb-autofix",60179),linkExternal:i("link-external",60180),link:i("link",60181),listOrdered:i("list-ordered",60182),listUnordered:i("list-unordered",60183),liveShare:i("live-share",60184),loading:i("loading",60185),location:i("location",60186),mailRead:i("mail-read",60187),mail:i("mail",60188),markdown:i("markdown",60189),megaphone:i("megaphone",60190),mention:i("mention",60191),milestone:i("milestone",60192),mortarBoard:i("mortar-board",60193),move:i("move",60194),multipleWindows:i("multiple-windows",60195),mute:i("mute",60196),noNewline:i("no-newline",60197),note:i("note",60198),octoface:i("octoface",60199),openPreview:i("open-preview",60200),package_:i("package",60201),paintcan:i("paintcan",60202),pin:i("pin",60203),play:i("play",60204),run:i("run",60204),plug:i("plug",60205),preserveCase:i("preserve-case",60206),preview:i("preview",60207),project:i("project",60208),pulse:i("pulse",60209),question:i("question",60210),quote:i("quote",60211),radioTower:i("radio-tower",60212),reactions:i("reactions",60213),references:i("references",60214),refresh:i("refresh",60215),regex:i("regex",60216),remoteExplorer:i("remote-explorer",60217),remote:i("remote",60218),remove:i("remove",60219),replaceAll:i("replace-all",60220),replace:i("replace",60221),repoClone:i("repo-clone",60222),repoForcePush:i("repo-force-push",60223),repoPull:i("repo-pull",60224),repoPush:i("repo-push",60225),report:i("report",60226),requestChanges:i("request-changes",60227),rocket:i("rocket",60228),rootFolderOpened:i("root-folder-opened",60229),rootFolder:i("root-folder",60230),rss:i("rss",60231),ruby:i("ruby",60232),saveAll:i("save-all",60233),saveAs:i("save-as",60234),save:i("save",60235),screenFull:i("screen-full",60236),screenNormal:i("screen-normal",60237),searchStop:i("search-stop",60238),server:i("server",60240),settingsGear:i("settings-gear",60241),settings:i("settings",60242),shield:i("shield",60243),smiley:i("smiley",60244),sortPrecedence:i("sort-precedence",60245),splitHorizontal:i("split-horizontal",60246),splitVertical:i("split-vertical",60247),squirrel:i("squirrel",60248),starFull:i("star-full",60249),starHalf:i("star-half",60250),symbolClass:i("symbol-class",60251),symbolColor:i("symbol-color",60252),symbolCustomColor:i("symbol-customcolor",60252),symbolConstant:i("symbol-constant",60253),symbolEnumMember:i("symbol-enum-member",60254),symbolField:i("symbol-field",60255),symbolFile:i("symbol-file",60256),symbolInterface:i("symbol-interface",60257),symbolKeyword:i("symbol-keyword",60258),symbolMisc:i("symbol-misc",60259),symbolOperator:i("symbol-operator",60260),symbolProperty:i("symbol-property",60261),wrench:i("wrench",60261),wrenchSubaction:i("wrench-subaction",60261),symbolSnippet:i("symbol-snippet",60262),tasklist:i("tasklist",60263),telescope:i("telescope",60264),textSize:i("text-size",60265),threeBars:i("three-bars",60266),thumbsdown:i("thumbsdown",60267),thumbsup:i("thumbsup",60268),tools:i("tools",60269),triangleDown:i("triangle-down",60270),triangleLeft:i("triangle-left",60271),triangleRight:i("triangle-right",60272),triangleUp:i("triangle-up",60273),twitter:i("twitter",60274),unfold:i("unfold",60275),unlock:i("unlock",60276),unmute:i("unmute",60277),unverified:i("unverified",60278),verified:i("verified",60279),versions:i("versions",60280),vmActive:i("vm-active",60281),vmOutline:i("vm-outline",60282),vmRunning:i("vm-running",60283),watch:i("watch",60284),whitespace:i("whitespace",60285),wholeWord:i("whole-word",60286),window:i("window",60287),wordWrap:i("word-wrap",60288),zoomIn:i("zoom-in",60289),zoomOut:i("zoom-out",60290),listFilter:i("list-filter",60291),listFlat:i("list-flat",60292),listSelection:i("list-selection",60293),selection:i("selection",60293),listTree:i("list-tree",60294),debugBreakpointFunctionUnverified:i("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:i("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:i("debug-breakpoint-function-disabled",60296),debugStackframeActive:i("debug-stackframe-active",60297),circleSmallFilled:i("circle-small-filled",60298),debugStackframeDot:i("debug-stackframe-dot",60298),debugStackframe:i("debug-stackframe",60299),debugStackframeFocused:i("debug-stackframe-focused",60299),debugBreakpointUnsupported:i("debug-breakpoint-unsupported",60300),symbolString:i("symbol-string",60301),debugReverseContinue:i("debug-reverse-continue",60302),debugStepBack:i("debug-step-back",60303),debugRestartFrame:i("debug-restart-frame",60304),callIncoming:i("call-incoming",60306),callOutgoing:i("call-outgoing",60307),menu:i("menu",60308),expandAll:i("expand-all",60309),feedback:i("feedback",60310),groupByRefType:i("group-by-ref-type",60311),ungroupByRefType:i("ungroup-by-ref-type",60312),account:i("account",60313),bellDot:i("bell-dot",60314),debugConsole:i("debug-console",60315),library:i("library",60316),output:i("output",60317),runAll:i("run-all",60318),syncIgnored:i("sync-ignored",60319),pinned:i("pinned",60320),githubInverted:i("github-inverted",60321),debugAlt:i("debug-alt",60305),serverProcess:i("server-process",60322),serverEnvironment:i("server-environment",60323),pass:i("pass",60324),stopCircle:i("stop-circle",60325),playCircle:i("play-circle",60326),record:i("record",60327),debugAltSmall:i("debug-alt-small",60328),vmConnect:i("vm-connect",60329),cloud:i("cloud",60330),merge:i("merge",60331),exportIcon:i("export",60332),graphLeft:i("graph-left",60333),magnet:i("magnet",60334),notebook:i("notebook",60335),redo:i("redo",60336),checkAll:i("check-all",60337),pinnedDirty:i("pinned-dirty",60338),passFilled:i("pass-filled",60339),circleLargeFilled:i("circle-large-filled",60340),circleLarge:i("circle-large",60341),circleLargeOutline:i("circle-large-outline",60341),combine:i("combine",60342),gather:i("gather",60342),table:i("table",60343),variableGroup:i("variable-group",60344),typeHierarchy:i("type-hierarchy",60345),typeHierarchySub:i("type-hierarchy-sub",60346),typeHierarchySuper:i("type-hierarchy-super",60347),gitPullRequestCreate:i("git-pull-request-create",60348),runAbove:i("run-above",60349),runBelow:i("run-below",60350),notebookTemplate:i("notebook-template",60351),debugRerun:i("debug-rerun",60352),workspaceTrusted:i("workspace-trusted",60353),workspaceUntrusted:i("workspace-untrusted",60354),workspaceUnspecified:i("workspace-unspecified",60355),terminalCmd:i("terminal-cmd",60356),terminalDebian:i("terminal-debian",60357),terminalLinux:i("terminal-linux",60358),terminalPowershell:i("terminal-powershell",60359),terminalTmux:i("terminal-tmux",60360),terminalUbuntu:i("terminal-ubuntu",60361),terminalBash:i("terminal-bash",60362),arrowSwap:i("arrow-swap",60363),copy:i("copy",60364),personAdd:i("person-add",60365),filterFilled:i("filter-filled",60366),wand:i("wand",60367),debugLineByLine:i("debug-line-by-line",60368),inspect:i("inspect",60369),layers:i("layers",60370),layersDot:i("layers-dot",60371),layersActive:i("layers-active",60372),compass:i("compass",60373),compassDot:i("compass-dot",60374),compassActive:i("compass-active",60375),azure:i("azure",60376),issueDraft:i("issue-draft",60377),gitPullRequestClosed:i("git-pull-request-closed",60378),gitPullRequestDraft:i("git-pull-request-draft",60379),debugAll:i("debug-all",60380),debugCoverage:i("debug-coverage",60381),runErrors:i("run-errors",60382),folderLibrary:i("folder-library",60383),debugContinueSmall:i("debug-continue-small",60384),beakerStop:i("beaker-stop",60385),graphLine:i("graph-line",60386),graphScatter:i("graph-scatter",60387),pieChart:i("pie-chart",60388),bracketDot:i("bracket-dot",60389),bracketError:i("bracket-error",60390),lockSmall:i("lock-small",60391),azureDevops:i("azure-devops",60392),verifiedFilled:i("verified-filled",60393),newLine:i("newline",60394),layout:i("layout",60395),layoutActivitybarLeft:i("layout-activitybar-left",60396),layoutActivitybarRight:i("layout-activitybar-right",60397),layoutPanelLeft:i("layout-panel-left",60398),layoutPanelCenter:i("layout-panel-center",60399),layoutPanelJustify:i("layout-panel-justify",60400),layoutPanelRight:i("layout-panel-right",60401),layoutPanel:i("layout-panel",60402),layoutSidebarLeft:i("layout-sidebar-left",60403),layoutSidebarRight:i("layout-sidebar-right",60404),layoutStatusbar:i("layout-statusbar",60405),layoutMenubar:i("layout-menubar",60406),layoutCentered:i("layout-centered",60407),layoutSidebarRightOff:i("layout-sidebar-right-off",60416),layoutPanelOff:i("layout-panel-off",60417),layoutSidebarLeftOff:i("layout-sidebar-left-off",60418),target:i("target",60408),indent:i("indent",60409),recordSmall:i("record-small",60410),errorSmall:i("error-small",60411),arrowCircleDown:i("arrow-circle-down",60412),arrowCircleLeft:i("arrow-circle-left",60413),arrowCircleRight:i("arrow-circle-right",60414),arrowCircleUp:i("arrow-circle-up",60415),heartFilled:i("heart-filled",60420),map:i("map",60421),mapFilled:i("map-filled",60422),circleSmall:i("circle-small",60423),bellSlash:i("bell-slash",60424),bellSlashDot:i("bell-slash-dot",60425),commentUnresolved:i("comment-unresolved",60426),gitPullRequestGoToChanges:i("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:i("git-pull-request-new-changes",60428),searchFuzzy:i("search-fuzzy",60429),commentDraft:i("comment-draft",60430),send:i("send",60431),sparkle:i("sparkle",60432),insert:i("insert",60433),dialogError:i("dialog-error","error"),dialogWarning:i("dialog-warning","warning"),dialogInfo:i("dialog-info","info"),dialogClose:i("dialog-close","close"),treeItemExpanded:i("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:i("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:i("tree-filter-on-type-off","list-selection"),treeFilterClear:i("tree-filter-clear","close"),treeItemLoading:i("tree-item-loading","loading"),menuSelection:i("menu-selection","check"),menuSubmenu:i("menu-submenu","chevron-right"),menuBarMore:i("menubar-more","more"),scrollbarButtonLeft:i("scrollbar-button-left","triangle-left"),scrollbarButtonRight:i("scrollbar-button-right","triangle-right"),scrollbarButtonUp:i("scrollbar-button-up","triangle-up"),scrollbarButtonDown:i("scrollbar-button-down","triangle-down"),toolBarMore:i("toolbar-more","more"),quickInputBack:i("quick-input-back","arrow-left")}}),define(me[47],be([1,0,6]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function M(u){if(!u||typeof u!="object"||u instanceof RegExp)return u;const s=Array.isArray(u)?[]:{};return Object.entries(u).forEach(([w,D])=>{s[w]=D&&typeof D=="object"?M(D):D}),s}t.deepClone=M;function i(u){if(!u||typeof u!="object")return u;const s=[u];for(;s.length>0;){const w=s.shift();Object.freeze(w);for(const D in w)if(W.call(w,D)){const S=w[D];typeof S=="object"&&!Object.isFrozen(S)&&!(0,y.isTypedArray)(S)&&s.push(S)}}return u}t.deepFreeze=i;const W=Object.prototype.hasOwnProperty;function p(u,s){return A(u,s,new Set)}t.cloneAndChange=p;function A(u,s,w){if((0,y.isUndefinedOrNull)(u))return u;const D=s(u);if(typeof D<"u")return D;if(Array.isArray(u)){const S=[];for(const f of u)S.push(A(f,s,w));return S}if((0,y.isObject)(u)){if(w.has(u))throw new Error("Cannot clone recursive data-structure");w.add(u);const S={};for(const f in u)W.call(u,f)&&(S[f]=A(u[f],s,w));return w.delete(u),S}return u}function h(u,s,w=!0){return(0,y.isObject)(u)?((0,y.isObject)(s)&&Object.keys(s).forEach(D=>{D in u?w&&((0,y.isObject)(u[D])&&(0,y.isObject)(s[D])?h(u[D],s[D],w):u[D]=s[D]):u[D]=s[D]}),u):s}t.mixin=h;function a(u,s){if(u===s)return!0;if(u==null||s===null||s===void 0||typeof u!=typeof s||typeof u!="object"||Array.isArray(u)!==Array.isArray(s))return!1;let w,D;if(Array.isArray(u)){if(u.length!==s.length)return!1;for(w=0;w<u.length;w++)if(!a(u[w],s[w]))return!1}else{const S=[];for(D in u)S.push(D);S.sort();const f=[];for(D in s)f.push(D);if(f.sort(),!a(S,f))return!1;for(w=0;w<S.length;w++)if(!a(u[S[w]],s[S[w]]))return!1}return!0}t.equals=a;function c(u){const s=new Set;return JSON.stringify(u,(w,D)=>{if((0,y.isObject)(D)||Array.isArray(D)){if(s.has(D))return"[Circular]";s.add(D)}return D})}t.safeStringify=c;function P(u,s){const w=Object.create(null);return!u||!s||Object.keys(s).forEach(S=>{const f=u[S],v=s[S];a(f,v)||(w[S]=v)}),w}t.distinct=P;function r(u,s){const w=s.toLowerCase(),D=Object.keys(u).find(S=>S.toLowerCase()===w);return D?u[D]:u[s]}t.getCaseInsensitive=r;function l(u,s){const w=Object.create(null);for(const[D,S]of Object.entries(u))s(D,S)&&(w[D]=S);return w}t.filter=l;function e(u){let s=[],w=Object.getPrototypeOf(u);for(;Object.prototype!==w;)s=s.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return s}t.getAllPropertyNames=e;function o(u){const s=[];for(const w of e(u))typeof u[w]=="function"&&s.push(w);return s}t.getAllMethodNames=o;function n(u,s){const w=S=>function(){const f=Array.prototype.slice.call(arguments,0);return s(S,f)},D={};for(const S of u)D[S]=w(S);return D}t.createProxyObject=n}),define(me[17],be([1,0,16]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ThemeIcon=t.themeColorFromId=t.ThemeColor=void 0;var M;(function(p){function A(h){return h&&typeof h=="object"&&typeof h.id=="string"}p.isThemeColor=A})(M||(t.ThemeColor=M={}));function i(p){return{id:p}}t.themeColorFromId=i;var W;(function(p){p.iconNameSegment="[A-Za-z0-9]+",p.iconNameExpression="[A-Za-z0-9-]+",p.iconModifierExpression="~[A-Za-z]+",p.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${p.iconNameExpression})(${p.iconModifierExpression})?$`);function h(s){const w=A.exec(s.id);if(!w)return h(y.Codicon.error);const[,D,S]=w,f=["codicon","codicon-"+D];return S&&f.push("codicon-modifier-"+S.substring(1)),f}p.asClassNameArray=h;function a(s){return h(s).join(" ")}p.asClassName=a;function c(s){return"."+h(s).join(".")}p.asCSSSelector=c;function P(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color>"u"||M.isThemeColor(s.color))}p.isThemeIcon=P;const r=new RegExp(`^\\$\\((${p.iconNameExpression}(?:${p.iconModifierExpression})?)\\)$`);function l(s){const w=r.exec(s);if(!w)return;const[,D]=w;return{id:D}}p.fromString=l;function e(s){return{id:s}}p.fromId=e;function o(s,w){let D=s.id;const S=D.lastIndexOf("~");return S!==-1&&(D=D.substring(0,S)),w&&(D=`${D}~${w}`),{id:D}}p.modify=o;function n(s){const w=s.id.lastIndexOf("~");if(w!==-1)return s.id.substring(w+1)}p.getModifier=n;function u(s,w){return s.id===w.id&&s.color?.id===w.color?.id}p.isEqual=u})(W||(t.ThemeIcon=W={}))}),define(me[81],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(me[82],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class y{constructor(i,W){this.a=i,this.onMessage=W}send(i){try{this.a.send("vscode:message",i.buffer)}catch{}}disconnect(){this.a.send("vscode:disconnect",null)}}t.Protocol=y}),define(me[48],be([8]),{}),define(me[83],be([8]),{}),define(me[84],be([8]),{}),define(me[85],be([8]),{}),define(me[86],be([1,0,84,85]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0})}),define(me[87],be([8]),{}),define(me[88],be([8]),{}),define(me[89],be([8]),{}),define(me[90],be([8]),{}),define(me[91],be([8]),{}),define(me[92],be([8]),{}),define(me[93],be([8]),{}),define(me[94],be([8]),{}),define(me[95],be([8]),{}),define(me[96],be([12,10]),function(te,t){return te.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[97],be([12,10]),function(te,t){return te.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[98],be([12,10]),function(te,t){return te.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[99],be([12,10]),function(te,t){return te.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(me[100],be([12,10]),function(te,t){return te.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[101],be([12,10]),function(te,t){return te.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[102],be([12,10]),function(te,t){return te.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[103],be([12,10]),function(te,t){return te.create("vs/base/common/actions",t)}),define(me[104],be([12,10]),function(te,t){return te.create("vs/base/common/platform",t)}),define(me[5],be([1,0,104]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.platformLocale=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isMobile=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=t.LANGUAGE_DEFAULT=void 0,t.LANGUAGE_DEFAULT="en";let M=!1,i=!1,W=!1,p=!1,A=!1,h=!1,a=!1,c=!1,P=!1,r=!1,l,e=t.LANGUAGE_DEFAULT,o=t.LANGUAGE_DEFAULT,n,u;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let s;typeof t.globals.vscode<"u"&&typeof t.globals.vscode.process<"u"?s=t.globals.vscode.process:typeof process<"u"&&(s=process);const w=typeof s?.versions?.electron=="string",D=w&&s?.type==="renderer";if(typeof navigator=="object"&&!D)u=navigator.userAgent,M=u.indexOf("Windows")>=0,i=u.indexOf("Macintosh")>=0,c=(u.indexOf("Macintosh")>=0||u.indexOf("iPad")>=0||u.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,W=u.indexOf("Linux")>=0,r=u?.indexOf("Mobi")>=0,h=!0,l=y.getConfiguredDefaultLocale(y.localize(0,null))||t.LANGUAGE_DEFAULT,e=l,o=navigator.language;else if(typeof s=="object"){M=s.platform==="win32",i=s.platform==="darwin",W=s.platform==="linux",p=W&&!!s.env.SNAP&&!!s.env.SNAP_REVISION,a=w,P=!!s.env.CI||!!s.env.BUILD_ARTIFACTSTAGINGDIRECTORY,l=t.LANGUAGE_DEFAULT,e=t.LANGUAGE_DEFAULT;const b=s.env.VSCODE_NLS_CONFIG;if(b)try{const B=JSON.parse(b),G=B.availableLanguages["*"];l=B.locale,o=B.osLocale,e=G||t.LANGUAGE_DEFAULT,n=B._translationsConfigFile}catch{}A=!0}else console.error("Unable to resolve platform.");var S;(function(b){b[b.Web=0]="Web",b[b.Mac=1]="Mac",b[b.Linux=2]="Linux",b[b.Windows=3]="Windows"})(S||(t.Platform=S={}));function f(b){switch(b){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=f;let v=0;i?v=1:M?v=3:W&&(v=2),t.isWindows=M,t.isMacintosh=i,t.isLinux=W,t.isLinuxSnap=p,t.isNative=A,t.isElectron=a,t.isWeb=h,t.isWebWorker=h&&typeof t.globals.importScripts=="function",t.isIOS=c,t.isMobile=r,t.isCI=P,t.platform=v,t.userAgent=u,t.language=e;var L;(function(b){function B(){return t.language}b.value=B;function G(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}b.isDefaultVariant=G;function J(){return t.language==="en"}b.isDefault=J})(L||(t.Language=L={})),t.locale=l,t.platformLocale=o,t.translationsConfigFile=n,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const b=[];t.globals.addEventListener("message",G=>{if(G.data&&G.data.vscodeScheduleAsyncWork)for(let J=0,ie=b.length;J<ie;J++){const le=b[J];if(le.id===G.data.vscodeScheduleAsyncWork){b.splice(J,1),le.callback();return}}});let B=0;return G=>{const J=++B;b.push({id:J,callback:G}),t.globals.postMessage({vscodeScheduleAsyncWork:J},"*")}}return b=>setTimeout(b)})();var N;(function(b){b[b.Windows=1]="Windows",b[b.Macintosh=2]="Macintosh",b[b.Linux=3]="Linux"})(N||(t.OperatingSystem=N={})),t.OS=i||c?2:M?1:3;let E=!0,g=!1;function m(){if(!g){g=!0;const b=new Uint8Array(2);b[0]=1,b[1]=2,E=new Uint16Array(b.buffer)[0]===(2<<8)+1}return E}t.isLittleEndian=m,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(me[105],be([1,0,5]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let M;if(typeof y.globals.vscode<"u"&&typeof y.globals.vscode.process<"u"){const i=y.globals.vscode.process;M={get platform(){return i.platform},get arch(){return i.arch},get env(){return i.env},cwd(){return i.cwd()}}}else typeof process<"u"?M={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:M={get platform(){return y.isWindows?"win32":y.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=M.cwd,t.env=M.env,t.platform=M.platform,t.arch=M.arch}),define(me[22],be([1,0,105]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const M=65,i=97,W=90,p=122,A=46,h=47,a=92,c=58,P=63;class r extends Error{constructor(v,L,N){let E;typeof L=="string"&&L.indexOf("not ")===0?(E="must not be",L=L.replace(/^not /,"")):E="must be";const g=v.indexOf(".")!==-1?"property":"argument";let m=`The "${v}" ${g} ${E} of type ${L}`;m+=`. Received type ${typeof N}`,super(m),this.code="ERR_INVALID_ARG_TYPE"}}function l(f,v){if(f===null||typeof f!="object")throw new r(v,"Object",f)}function e(f,v){if(typeof f!="string")throw new r(v,"string",f)}const o=y.platform==="win32";function n(f){return f===h||f===a}function u(f){return f===h}function s(f){return f>=M&&f<=W||f>=i&&f<=p}function w(f,v,L,N){let E="",g=0,m=-1,b=0,B=0;for(let G=0;G<=f.length;++G){if(G<f.length)B=f.charCodeAt(G);else{if(N(B))break;B=h}if(N(B)){if(!(m===G-1||b===1))if(b===2){if(E.length<2||g!==2||E.charCodeAt(E.length-1)!==A||E.charCodeAt(E.length-2)!==A){if(E.length>2){const J=E.lastIndexOf(L);J===-1?(E="",g=0):(E=E.slice(0,J),g=E.length-1-E.lastIndexOf(L)),m=G,b=0;continue}else if(E.length!==0){E="",g=0,m=G,b=0;continue}}v&&(E+=E.length>0?`${L}..`:"..",g=2)}else E.length>0?E+=`${L}${f.slice(m+1,G)}`:E=f.slice(m+1,G),g=G-m-1;m=G,b=0}else B===A&&b!==-1?++b:b=-1}return E}function D(f,v){l(v,"pathObject");const L=v.dir||v.root,N=v.base||`${v.name||""}${v.ext||""}`;return L?L===v.root?`${L}${N}`:`${L}${f}${N}`:N}t.win32={resolve(...f){let v="",L="",N=!1;for(let E=f.length-1;E>=-1;E--){let g;if(E>=0){if(g=f[E],e(g,"path"),g.length===0)continue}else v.length===0?g=y.cwd():(g=y.env[`=${v}`]||y.cwd(),(g===void 0||g.slice(0,2).toLowerCase()!==v.toLowerCase()&&g.charCodeAt(2)===a)&&(g=`${v}\\`));const m=g.length;let b=0,B="",G=!1;const J=g.charCodeAt(0);if(m===1)n(J)&&(b=1,G=!0);else if(n(J))if(G=!0,n(g.charCodeAt(1))){let ie=2,le=ie;for(;ie<m&&!n(g.charCodeAt(ie));)ie++;if(ie<m&&ie!==le){const ge=g.slice(le,ie);for(le=ie;ie<m&&n(g.charCodeAt(ie));)ie++;if(ie<m&&ie!==le){for(le=ie;ie<m&&!n(g.charCodeAt(ie));)ie++;(ie===m||ie!==le)&&(B=`\\\\${ge}\\${g.slice(le,ie)}`,b=ie)}}}else b=1;else s(J)&&g.charCodeAt(1)===c&&(B=g.slice(0,2),b=2,m>2&&n(g.charCodeAt(2))&&(G=!0,b=3));if(B.length>0)if(v.length>0){if(B.toLowerCase()!==v.toLowerCase())continue}else v=B;if(N){if(v.length>0)break}else if(L=`${g.slice(b)}\\${L}`,N=G,G&&v.length>0)break}return L=w(L,!N,"\\",n),N?`${v}\\${L}`:`${v}${L}`||"."},normalize(f){e(f,"path");const v=f.length;if(v===0)return".";let L=0,N,E=!1;const g=f.charCodeAt(0);if(v===1)return u(g)?"\\":f;if(n(g))if(E=!0,n(f.charCodeAt(1))){let b=2,B=b;for(;b<v&&!n(f.charCodeAt(b));)b++;if(b<v&&b!==B){const G=f.slice(B,b);for(B=b;b<v&&n(f.charCodeAt(b));)b++;if(b<v&&b!==B){for(B=b;b<v&&!n(f.charCodeAt(b));)b++;if(b===v)return`\\\\${G}\\${f.slice(B)}\\`;b!==B&&(N=`\\\\${G}\\${f.slice(B,b)}`,L=b)}}}else L=1;else s(g)&&f.charCodeAt(1)===c&&(N=f.slice(0,2),L=2,v>2&&n(f.charCodeAt(2))&&(E=!0,L=3));let m=L<v?w(f.slice(L),!E,"\\",n):"";return m.length===0&&!E&&(m="."),m.length>0&&n(f.charCodeAt(v-1))&&(m+="\\"),N===void 0?E?`\\${m}`:m:E?`${N}\\${m}`:`${N}${m}`},isAbsolute(f){e(f,"path");const v=f.length;if(v===0)return!1;const L=f.charCodeAt(0);return n(L)||v>2&&s(L)&&f.charCodeAt(1)===c&&n(f.charCodeAt(2))},join(...f){if(f.length===0)return".";let v,L;for(let g=0;g<f.length;++g){const m=f[g];e(m,"path"),m.length>0&&(v===void 0?v=L=m:v+=`\\${m}`)}if(v===void 0)return".";let N=!0,E=0;if(typeof L=="string"&&n(L.charCodeAt(0))){++E;const g=L.length;g>1&&n(L.charCodeAt(1))&&(++E,g>2&&(n(L.charCodeAt(2))?++E:N=!1))}if(N){for(;E<v.length&&n(v.charCodeAt(E));)E++;E>=2&&(v=`\\${v.slice(E)}`)}return t.win32.normalize(v)},relative(f,v){if(e(f,"from"),e(v,"to"),f===v)return"";const L=t.win32.resolve(f),N=t.win32.resolve(v);if(L===N||(f=L.toLowerCase(),v=N.toLowerCase(),f===v))return"";let E=0;for(;E<f.length&&f.charCodeAt(E)===a;)E++;let g=f.length;for(;g-1>E&&f.charCodeAt(g-1)===a;)g--;const m=g-E;let b=0;for(;b<v.length&&v.charCodeAt(b)===a;)b++;let B=v.length;for(;B-1>b&&v.charCodeAt(B-1)===a;)B--;const G=B-b,J=m<G?m:G;let ie=-1,le=0;for(;le<J;le++){const ue=f.charCodeAt(E+le);if(ue!==v.charCodeAt(b+le))break;ue===a&&(ie=le)}if(le!==J){if(ie===-1)return N}else{if(G>J){if(v.charCodeAt(b+le)===a)return N.slice(b+le+1);if(le===2)return N.slice(b+le)}m>J&&(f.charCodeAt(E+le)===a?ie=le:le===2&&(ie=3)),ie===-1&&(ie=0)}let ge="";for(le=E+ie+1;le<=g;++le)(le===g||f.charCodeAt(le)===a)&&(ge+=ge.length===0?"..":"\\..");return b+=ie,ge.length>0?`${ge}${N.slice(b,B)}`:(N.charCodeAt(b)===a&&++b,N.slice(b,B))},toNamespacedPath(f){if(typeof f!="string"||f.length===0)return f;const v=t.win32.resolve(f);if(v.length<=2)return f;if(v.charCodeAt(0)===a){if(v.charCodeAt(1)===a){const L=v.charCodeAt(2);if(L!==P&&L!==A)return`\\\\?\\UNC\\${v.slice(2)}`}}else if(s(v.charCodeAt(0))&&v.charCodeAt(1)===c&&v.charCodeAt(2)===a)return`\\\\?\\${v}`;return f},dirname(f){e(f,"path");const v=f.length;if(v===0)return".";let L=-1,N=0;const E=f.charCodeAt(0);if(v===1)return n(E)?f:".";if(n(E)){if(L=N=1,n(f.charCodeAt(1))){let b=2,B=b;for(;b<v&&!n(f.charCodeAt(b));)b++;if(b<v&&b!==B){for(B=b;b<v&&n(f.charCodeAt(b));)b++;if(b<v&&b!==B){for(B=b;b<v&&!n(f.charCodeAt(b));)b++;if(b===v)return f;b!==B&&(L=N=b+1)}}}}else s(E)&&f.charCodeAt(1)===c&&(L=v>2&&n(f.charCodeAt(2))?3:2,N=L);let g=-1,m=!0;for(let b=v-1;b>=N;--b)if(n(f.charCodeAt(b))){if(!m){g=b;break}}else m=!1;if(g===-1){if(L===-1)return".";g=L}return f.slice(0,g)},basename(f,v){v!==void 0&&e(v,"ext"),e(f,"path");let L=0,N=-1,E=!0,g;if(f.length>=2&&s(f.charCodeAt(0))&&f.charCodeAt(1)===c&&(L=2),v!==void 0&&v.length>0&&v.length<=f.length){if(v===f)return"";let m=v.length-1,b=-1;for(g=f.length-1;g>=L;--g){const B=f.charCodeAt(g);if(n(B)){if(!E){L=g+1;break}}else b===-1&&(E=!1,b=g+1),m>=0&&(B===v.charCodeAt(m)?--m===-1&&(N=g):(m=-1,N=b))}return L===N?N=b:N===-1&&(N=f.length),f.slice(L,N)}for(g=f.length-1;g>=L;--g)if(n(f.charCodeAt(g))){if(!E){L=g+1;break}}else N===-1&&(E=!1,N=g+1);return N===-1?"":f.slice(L,N)},extname(f){e(f,"path");let v=0,L=-1,N=0,E=-1,g=!0,m=0;f.length>=2&&f.charCodeAt(1)===c&&s(f.charCodeAt(0))&&(v=N=2);for(let b=f.length-1;b>=v;--b){const B=f.charCodeAt(b);if(n(B)){if(!g){N=b+1;break}continue}E===-1&&(g=!1,E=b+1),B===A?L===-1?L=b:m!==1&&(m=1):L!==-1&&(m=-1)}return L===-1||E===-1||m===0||m===1&&L===E-1&&L===N+1?"":f.slice(L,E)},format:D.bind(null,"\\"),parse(f){e(f,"path");const v={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return v;const L=f.length;let N=0,E=f.charCodeAt(0);if(L===1)return n(E)?(v.root=v.dir=f,v):(v.base=v.name=f,v);if(n(E)){if(N=1,n(f.charCodeAt(1))){let ie=2,le=ie;for(;ie<L&&!n(f.charCodeAt(ie));)ie++;if(ie<L&&ie!==le){for(le=ie;ie<L&&n(f.charCodeAt(ie));)ie++;if(ie<L&&ie!==le){for(le=ie;ie<L&&!n(f.charCodeAt(ie));)ie++;ie===L?N=ie:ie!==le&&(N=ie+1)}}}}else if(s(E)&&f.charCodeAt(1)===c){if(L<=2)return v.root=v.dir=f,v;if(N=2,n(f.charCodeAt(2))){if(L===3)return v.root=v.dir=f,v;N=3}}N>0&&(v.root=f.slice(0,N));let g=-1,m=N,b=-1,B=!0,G=f.length-1,J=0;for(;G>=N;--G){if(E=f.charCodeAt(G),n(E)){if(!B){m=G+1;break}continue}b===-1&&(B=!1,b=G+1),E===A?g===-1?g=G:J!==1&&(J=1):g!==-1&&(J=-1)}return b!==-1&&(g===-1||J===0||J===1&&g===b-1&&g===m+1?v.base=v.name=f.slice(m,b):(v.name=f.slice(m,g),v.base=f.slice(m,b),v.ext=f.slice(g,b))),m>0&&m!==N?v.dir=f.slice(0,m-1):v.dir=v.root,v},sep:"\\",delimiter:";",win32:null,posix:null};const S=(()=>{if(o){const f=/\\/g;return()=>{const v=y.cwd().replace(f,"/");return v.slice(v.indexOf("/"))}}return()=>y.cwd()})();t.posix={resolve(...f){let v="",L=!1;for(let N=f.length-1;N>=-1&&!L;N--){const E=N>=0?f[N]:S();e(E,"path"),E.length!==0&&(v=`${E}/${v}`,L=E.charCodeAt(0)===h)}return v=w(v,!L,"/",u),L?`/${v}`:v.length>0?v:"."},normalize(f){if(e(f,"path"),f.length===0)return".";const v=f.charCodeAt(0)===h,L=f.charCodeAt(f.length-1)===h;return f=w(f,!v,"/",u),f.length===0?v?"/":L?"./":".":(L&&(f+="/"),v?`/${f}`:f)},isAbsolute(f){return e(f,"path"),f.length>0&&f.charCodeAt(0)===h},join(...f){if(f.length===0)return".";let v;for(let L=0;L<f.length;++L){const N=f[L];e(N,"path"),N.length>0&&(v===void 0?v=N:v+=`/${N}`)}return v===void 0?".":t.posix.normalize(v)},relative(f,v){if(e(f,"from"),e(v,"to"),f===v||(f=t.posix.resolve(f),v=t.posix.resolve(v),f===v))return"";const L=1,N=f.length,E=N-L,g=1,m=v.length-g,b=E<m?E:m;let B=-1,G=0;for(;G<b;G++){const ie=f.charCodeAt(L+G);if(ie!==v.charCodeAt(g+G))break;ie===h&&(B=G)}if(G===b)if(m>b){if(v.charCodeAt(g+G)===h)return v.slice(g+G+1);if(G===0)return v.slice(g+G)}else E>b&&(f.charCodeAt(L+G)===h?B=G:G===0&&(B=0));let J="";for(G=L+B+1;G<=N;++G)(G===N||f.charCodeAt(G)===h)&&(J+=J.length===0?"..":"/..");return`${J}${v.slice(g+B)}`},toNamespacedPath(f){return f},dirname(f){if(e(f,"path"),f.length===0)return".";const v=f.charCodeAt(0)===h;let L=-1,N=!0;for(let E=f.length-1;E>=1;--E)if(f.charCodeAt(E)===h){if(!N){L=E;break}}else N=!1;return L===-1?v?"/":".":v&&L===1?"//":f.slice(0,L)},basename(f,v){v!==void 0&&e(v,"ext"),e(f,"path");let L=0,N=-1,E=!0,g;if(v!==void 0&&v.length>0&&v.length<=f.length){if(v===f)return"";let m=v.length-1,b=-1;for(g=f.length-1;g>=0;--g){const B=f.charCodeAt(g);if(B===h){if(!E){L=g+1;break}}else b===-1&&(E=!1,b=g+1),m>=0&&(B===v.charCodeAt(m)?--m===-1&&(N=g):(m=-1,N=b))}return L===N?N=b:N===-1&&(N=f.length),f.slice(L,N)}for(g=f.length-1;g>=0;--g)if(f.charCodeAt(g)===h){if(!E){L=g+1;break}}else N===-1&&(E=!1,N=g+1);return N===-1?"":f.slice(L,N)},extname(f){e(f,"path");let v=-1,L=0,N=-1,E=!0,g=0;for(let m=f.length-1;m>=0;--m){const b=f.charCodeAt(m);if(b===h){if(!E){L=m+1;break}continue}N===-1&&(E=!1,N=m+1),b===A?v===-1?v=m:g!==1&&(g=1):v!==-1&&(g=-1)}return v===-1||N===-1||g===0||g===1&&v===N-1&&v===L+1?"":f.slice(v,N)},format:D.bind(null,"/"),parse(f){e(f,"path");const v={root:"",dir:"",base:"",ext:"",name:""};if(f.length===0)return v;const L=f.charCodeAt(0)===h;let N;L?(v.root="/",N=1):N=0;let E=-1,g=0,m=-1,b=!0,B=f.length-1,G=0;for(;B>=N;--B){const J=f.charCodeAt(B);if(J===h){if(!b){g=B+1;break}continue}m===-1&&(b=!1,m=B+1),J===A?E===-1?E=B:G!==1&&(G=1):E!==-1&&(G=-1)}if(m!==-1){const J=g===0&&L?1:g;E===-1||G===0||G===1&&E===m-1&&E===g+1?v.base=v.name=f.slice(J,m):(v.name=f.slice(J,E),v.base=f.slice(J,m),v.ext=f.slice(E,m))}return g>0?v.dir=f.slice(0,g-1):L&&(v.dir="/"),v},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=o?t.win32.normalize:t.posix.normalize,t.isAbsolute=o?t.win32.isAbsolute:t.posix.isAbsolute,t.join=o?t.win32.join:t.posix.join,t.resolve=o?t.win32.resolve:t.posix.resolve,t.relative=o?t.win32.relative:t.posix.relative,t.dirname=o?t.win32.dirname:t.posix.dirname,t.basename=o?t.win32.basename:t.posix.basename,t.extname=o?t.win32.extname:t.posix.extname,t.format=o?t.win32.format:t.posix.format,t.parse=o?t.win32.parse:t.posix.parse,t.toNamespacedPath=o?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=o?t.win32.sep:t.posix.sep,t.delimiter=o?t.win32.delimiter:t.posix.delimiter}),define(me[106],be([1,0,22]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const M={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},i={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function W(c){const P=(0,y.extname)(c),r=M[P.toLowerCase()];return r!==void 0?r:p(c)}t.getMediaOrTextMime=W;function p(c){const P=(0,y.extname)(c);return i[P.toLowerCase()]}t.getMediaMime=p;function A(c){for(const P in i)if(i[P]===c)return P}t.getExtensionForMimeType=A;const h=/^(.+)\/(.+?)(;.+)?$/;function a(c,P){const r=h.exec(c);return r?`${r[1].toLowerCase()}/${r[2].toLowerCase()}${r[3]??""}`:P?void 0:c}t.normalizeMimeType=a}),define(me[107],be([1,0,5]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const M=y.globals.performance&&typeof y.globals.performance.now=="function";class i{static create(p=!0){return new i(p)}constructor(p){this.a=M&&p,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?y.globals.performance.now():Date.now()}}t.StopWatch=i}),define(me[3],be([1,0,7,40,2,43,107]),function(te,t,y,M,i,W,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.EventProfiling=t.Event=void 0;const A=!1,h=!1;var a;(function(g){g.None=()=>i.Disposable.None;function m(_){if(h){const{onDidAddListener:Z}=_,k=e.create();let T=0;_.onDidAddListener=()=>{++T===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),k.print()),Z?.()}}}function b(_,Z){return ce(_,()=>{},0,void 0,!0,void 0,Z)}g.defer=b;function B(_){return(Z,k=null,T)=>{let H=!1,C;return C=_(U=>{if(!H)return C?C.dispose():H=!0,Z.call(k,U)},null,T),H&&C.dispose(),C}}g.once=B;function G(_,Z,k){return de((T,H=null,C)=>_(U=>T.call(H,Z(U)),null,C),k)}g.map=G;function J(_,Z,k){return de((T,H=null,C)=>_(U=>{Z(U),T.call(H,U)},null,C),k)}g.forEach=J;function ie(_,Z,k){return de((T,H=null,C)=>_(U=>Z(U)&&T.call(H,U),null,C),k)}g.filter=ie;function le(_){return _}g.signal=le;function ge(..._){return(Z,k=null,T)=>(0,i.combinedDisposable)(..._.map(H=>H(C=>Z.call(k,C),null,T)))}g.any=ge;function ue(_,Z,k,T){let H=k;return G(_,C=>(H=Z(H,C),H),T)}g.reduce=ue;function de(_,Z){let k;const T={onWillAddFirstListener(){k=_(H.fire,H)},onDidRemoveLastListener(){k?.dispose()}};Z||m(T);const H=new n(T);return Z?.add(H),H.event}function ce(_,Z,k=100,T=!1,H=!1,C,U){let z,O,$,q=0,ee;const se={leakWarningThreshold:C,onWillAddFirstListener(){z=_(De=>{q++,O=Z(O,De),T&&!$&&(ve.fire(O),O=void 0),ee=()=>{const Ie=O;O=void 0,$=void 0,(!T||q>1)&&ve.fire(Ie),q=0},typeof k=="number"?(clearTimeout($),$=setTimeout(ee,k)):$===void 0&&($=0,queueMicrotask(ee))})},onWillRemoveListener(){H&&q>0&&ee?.()},onDidRemoveLastListener(){ee=void 0,z.dispose()}};U||m(se);const ve=new n(se);return U?.add(ve),ve.event}g.debounce=ce;function Se(_,Z=0,k){return g.debounce(_,(T,H)=>T?(T.push(H),T):[H],Z,void 0,!0,void 0,k)}g.accumulate=Se;function Ae(_,Z=(T,H)=>T===H,k){let T=!0,H;return ie(_,C=>{const U=T||!Z(C,H);return T=!1,H=C,U},k)}g.latch=Ae;function Be(_,Z,k){return[g.filter(_,Z,k),g.filter(_,T=>!Z(T),k)]}g.split=Be;function re(_,Z=!1,k=[]){let T=k.slice(),H=_(z=>{T?T.push(z):U.fire(z)});const C=()=>{T?.forEach(z=>U.fire(z)),T=null},U=new n({onWillAddFirstListener(){H||(H=_(z=>U.fire(z)))},onDidAddFirstListener(){T&&(Z?setTimeout(C):C())},onDidRemoveLastListener(){H&&H.dispose(),H=null}});return U.event}g.buffer=re;class ne{constructor(Z){this.event=Z,this.c=new i.DisposableStore}map(Z){return new ne(G(this.event,Z,this.c))}forEach(Z){return new ne(J(this.event,Z,this.c))}filter(Z){return new ne(ie(this.event,Z,this.c))}reduce(Z,k){return new ne(ue(this.event,Z,k,this.c))}latch(){return new ne(Ae(this.event,void 0,this.c))}debounce(Z,k=100,T=!1,H=!1,C){return new ne(ce(this.event,Z,k,T,H,C,this.c))}on(Z,k,T){return this.event(Z,k,T)}once(Z,k,T){return B(this.event)(Z,k,T)}dispose(){this.c.dispose()}}function Q(_){return new ne(_)}g.chain=Q;function oe(_,Z,k=T=>T){const T=(...z)=>U.fire(k(...z)),H=()=>_.on(Z,T),C=()=>_.removeListener(Z,T),U=new n({onWillAddFirstListener:H,onDidRemoveLastListener:C});return U.event}g.fromNodeEventEmitter=oe;function j(_,Z,k=T=>T){const T=(...z)=>U.fire(k(...z)),H=()=>_.addEventListener(Z,T),C=()=>_.removeEventListener(Z,T),U=new n({onWillAddFirstListener:H,onDidRemoveLastListener:C});return U.event}g.fromDOMEventEmitter=j;function V(_){return new Promise(Z=>B(_)(Z))}g.toPromise=V;function F(_,Z){return Z(void 0),_(k=>Z(k))}g.runAndSubscribe=F;function x(_,Z){let k=null;function T(C){k?.dispose(),k=new i.DisposableStore,Z(C,k)}T(void 0);const H=_(C=>T(C));return(0,i.toDisposable)(()=>{H.dispose(),k?.dispose()})}g.runAndSubscribeWithStore=x;class I{constructor(Z,k){this._observable=Z,this.c=0,this.d=!1;const T={onWillAddFirstListener:()=>{Z.addObserver(this)},onDidRemoveLastListener:()=>{Z.removeObserver(this)}};k||m(T),this.emitter=new n(T),k&&k.add(this.emitter)}beginUpdate(Z){this.c++}handlePossibleChange(Z){}handleChange(Z,k){this.d=!0}endUpdate(Z){this.c--,this.c===0&&(this._observable.reportChanges(),this.d&&(this.d=!1,this.emitter.fire(this._observable.get())))}}function d(_,Z){return new I(_,Z).emitter.event}g.fromObservable=d;function R(_){return Z=>{let k=0,T=!1;const H={beginUpdate(){k++},endUpdate(){k--,k===0&&(_.reportChanges(),T&&(T=!1,Z()))},handlePossibleChange(){},handleChange(){T=!0}};return _.addObserver(H),{dispose(){_.removeObserver(H)}}}}g.fromObservableLight=R})(a||(t.Event=a={}));class c{constructor(m){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${m}_${c.c++}`,c.all.add(this)}start(m){this.d=new p.StopWatch(!0),this.listenerCount=m}stop(){if(this.d){const m=this.d.elapsed();this.durations.push(m),this.elapsedOverall+=m,this.invocationCount+=1,this.d=void 0}}}t.EventProfiling=c,c.all=new Set,c.c=0;let P=-1;function r(g){const m=P;return P=g,{dispose(){P=m}}}t.setGlobalLeakWarningThreshold=r;class l{constructor(m,b=Math.random().toString(18).slice(2,5)){this.threshold=m,this.name=b,this.d=0}dispose(){this.c?.clear()}check(m,b){const B=this.threshold;if(B<=0||b<B)return;this.c||(this.c=new Map);const G=this.c.get(m.value)||0;if(this.c.set(m.value,G+1),this.d-=1,this.d<=0){this.d=B*.5;let J,ie=0;for(const[le,ge]of this.c)(!J||ie<ge)&&(J=le,ie=ge);console.warn(`[${this.name}] potential listener LEAK detected, having ${b} listeners already. MOST frequent listener (${ie}):`),console.warn(J)}return()=>{const J=this.c.get(m.value)||0;this.c.set(m.value,J-1)}}}class e{static create(){return new e(new Error().stack??"")}constructor(m){this.value=m}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class o{constructor(m,b,B){this.callback=m,this.callbackThis=b,this.stack=B,this.subscription=new i.SafeDisposable}invoke(m){this.callback.call(this.callbackThis,m)}}class n{constructor(m){this.j=!1,this.d=m,this.f=P>0||this.d?.leakWarningThreshold?new l(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new c(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const m=Array.from(this.q);queueMicrotask(()=>{for(const b of m)b.subscription.isset()&&(b.subscription.unset(),b.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(m,b,B)=>{if(this.q||(this.q=new W.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),i.Disposable.None;const G=this.q.isEmpty();G&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let J,ie;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(ie=e.create(),J=this.f.check(ie,this.q.size+1)),A&&(ie=ie??e.create());const le=new o(m,b,ie),ge=this.q.push(le);G&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,m,b);const ue=le.subscription.set(()=>{J?.(),this.j||(this.d?.onWillRemoveListener?.(this),ge(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return B instanceof i.DisposableStore?B.add(ue):Array.isArray(B)&&B.push(ue),ue}),this.l}fire(m){if(this.q){this.m||(this.m=new s(this.d?.onListenerError));for(const b of this.q)this.m.push(this,b,m);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}t.Emitter=n;class u{constructor(m=y.onUnexpectedError){this.d=m,this.c=new W.LinkedList}get size(){return this.c.size}push(m,b,B){this.c.push(new w(m,b,B))}clear(m){const b=new W.LinkedList;for(const B of this.c)B.emitter!==m&&b.push(B);this.c=b}deliver(){for(;this.c.size>0;){const m=this.c.shift();try{m.listener.invoke(m.event)}catch(b){this.d(b)}}}}t.EventDeliveryQueue=u;class s extends u{clear(m){this.c.clear()}}class w{constructor(m,b,B){this.emitter=m,this.listener=b,this.event=B}}class D extends n{async fireAsync(m,b,B){if(this.q){this.c||(this.c=new W.LinkedList);for(const G of this.q)this.c.push([G,m]);for(;this.c.size>0&&!b.isCancellationRequested;){const[G,J]=this.c.shift(),ie=[],le={...J,token:b,waitUntil:ge=>{if(Object.isFrozen(ie))throw new Error("waitUntil can NOT be called asynchronous");B&&(ge=B(ge,G.callback)),ie.push(ge)}};try{G.invoke(le)}catch(ge){(0,y.onUnexpectedError)(ge);continue}Object.freeze(ie),await Promise.allSettled(ie).then(ge=>{for(const ue of ge)ue.status==="rejected"&&(0,y.onUnexpectedError)(ue.reason)})}}}}t.AsyncEmitter=D;class S extends n{constructor(m){super(m),this.h=0,this.s=new W.LinkedList,this.t=m?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const m=Array.from(this.s);this.s.clear(),super.fire(this.t(m))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(m){this.q&&(this.h!==0?this.s.push(m):super.fire(m))}}t.PauseableEmitter=S;class f extends S{constructor(m){super(m),this.c=m.delay??100}fire(m){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(m)}}t.DebounceEmitter=f;class v extends n{constructor(m){super(m),this.c=[],this.h=m?.merge}fire(m){this.hasListeners()&&(this.c.push(m),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(b=>super.fire(b)),this.c=[]}))}}t.MicrotaskEmitter=v;class L{constructor(){this.d=!1,this.f=[],this.c=new n({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(m){const b={event:m,listener:null};this.f.push(b),this.d&&this.j(b);const B=()=>{this.d&&this.k(b);const G=this.f.indexOf(b);this.f.splice(G,1)};return(0,i.toDisposable)((0,M.once)(B))}g(){this.d=!0,this.f.forEach(m=>this.j(m))}h(){this.d=!1,this.f.forEach(m=>this.k(m))}j(m){m.listener=m.event(b=>this.c.fire(b))}k(m){m.listener&&m.listener.dispose(),m.listener=null}dispose(){this.c.dispose()}}t.EventMultiplexer=L;class N{constructor(){this.c=[]}wrapEvent(m){return(b,B,G)=>m(J=>{const ie=this.c[this.c.length-1];ie?ie.push(()=>b.call(B,J)):b.call(B,J)},void 0,G)}bufferEvents(m){const b=[];this.c.push(b);const B=m();return this.c.pop(),b.forEach(G=>G()),B}}t.EventBufferer=N;class E{constructor(){this.c=!1,this.d=a.None,this.f=i.Disposable.None,this.g=new n({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(m){this.d=m,this.c&&(this.f.dispose(),this.f=m(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}t.Relay=E}),define(me[18],be([1,0,3,2]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isWCOEnabled=t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class i{constructor(){this.a=0,this.b=1,this.c=!1,this.d=new y.Emitter,this.onDidChangeFullscreen=this.d.event}getZoomLevel(){return this.a}setZoomLevel(D,S){this.a!==D&&(this.a=D)}getZoomFactor(){return this.b}setZoomFactor(D){this.b=D}setFullscreen(D){this.c!==D&&(this.c=D,this.d.fire())}isFullscreen(){return this.c}}i.INSTANCE=new i;class W extends M.Disposable{constructor(){super(),this.a=this.B(new y.Emitter),this.onDidChange=this.a.event,this.b=()=>this.f(!0),this.c=null,this.f(!1)}f(D){this.c?.removeEventListener("change",this.b),this.c=window.matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this.c.addEventListener("change",this.b),D&&this.a.fire()}}class p extends M.Disposable{get value(){return this.b}constructor(){super(),this.a=this.B(new y.Emitter),this.onDidChange=this.a.event,this.b=this.c();const D=this.B(new W);this.B(D.onDidChange(()=>{this.b=this.c(),this.a.fire(this.b)}))}c(){const D=document.createElement("canvas").getContext("2d"),S=window.devicePixelRatio||1,f=D.webkitBackingStorePixelRatio||D.mozBackingStorePixelRatio||D.msBackingStorePixelRatio||D.oBackingStorePixelRatio||D.backingStorePixelRatio||1;return S/f}}class A{constructor(){this.a=null}b(){return this.a||(this.a=(0,M.markAsSingleton)(new p)),this.a}get value(){return this.b().value}get onDidChange(){return this.b().onDidChange}}function h(w,D){typeof w=="string"&&(w=window.matchMedia(w)),w.addEventListener("change",D)}t.addMatchMediaChangeListener=h,t.PixelRatio=new A;function a(w,D){i.INSTANCE.setZoomLevel(w,D)}t.setZoomLevel=a;function c(){return i.INSTANCE.getZoomLevel()}t.getZoomLevel=c;function P(){return i.INSTANCE.getZoomFactor()}t.getZoomFactor=P;function r(w){i.INSTANCE.setZoomFactor(w)}t.setZoomFactor=r;function l(w){i.INSTANCE.setFullscreen(w)}t.setFullscreen=l;function e(){return i.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=i.INSTANCE.onDidChangeFullscreen;const o=navigator.userAgent;t.isFirefox=o.indexOf("Firefox")>=0,t.isWebKit=o.indexOf("AppleWebKit")>=0,t.isChrome=o.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&o.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=o.indexOf("Electron/")>=0,t.isAndroid=o.indexOf("Android")>=0;let n=!1;if(window.matchMedia){const w=window.matchMedia("(display-mode: standalone) or (display-mode: window-controls-overlay)"),D=window.matchMedia("(display-mode: fullscreen)");n=w.matches,h(w,({matches:S})=>{n&&D.matches||(n=S)})}function u(){return n}t.isStandalone=u;function s(){return navigator?.windowControlsOverlay?.visible}t.isWCOEnabled=s}),define(me[108],be([1,0,18,5]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var i;(function(W){W[W.Always=0]="Always",W[W.FullScreen=1]="FullScreen",W[W.None=2]="None"})(i||(t.KeyboardSupport=i={})),t.BrowserFeatures={clipboard:{writeText:M.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:M.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>M.isNative||y.isStandalone()?0:navigator.keyboard||y.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(me[20],be([1,0,3]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomEmitter=void 0;class M{get event(){return this.a.event}constructor(W,p,A){const h=a=>this.a.fire(a);this.a=new y.Emitter({onWillAddFirstListener:()=>W.addEventListener(p,h,A),onDidRemoveLastListener:()=>W.removeEventListener(p,h,A)})}dispose(){this.a.dispose()}}t.DomEmitter=M}),define(me[14],be([1,0,18,41,74,5]),function(te,t,y,M,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function p(e){if(e.charCode){const n=String.fromCharCode(e.charCode).toUpperCase();return M.KeyCodeUtils.fromString(n)}const o=e.keyCode;if(o===3)return 7;if(y.isFirefox)switch(o){case 59:return 85;case 60:if(W.isLinux)return 97;break;case 61:return 86;case 107:return 109;case 109:return 111;case 173:return 88;case 224:if(W.isMacintosh)return 57;break}else if(y.isWebKit){if(W.isMacintosh&&o===93)return 57;if(!W.isMacintosh&&o===92)return 57}return M.EVENT_KEY_CODE_MAP[o]||0}const A=W.isMacintosh?256:2048,h=512,a=1024,c=W.isMacintosh?2048:256;function P(e){const o=[];return e.ctrlKey&&o.push("ctrl"),e.shiftKey&&o.push("shift"),e.altKey&&o.push("alt"),e.metaKey&&o.push("meta"),`modifiers: [${o.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=P;function r(e){const o=[];return e.ctrlKey&&o.push("ctrl"),e.shiftKey&&o.push("shift"),e.altKey&&o.push("alt"),e.metaKey&&o.push("meta"),`modifiers: [${o.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${M.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=r;class l{constructor(o){this._standardKeyboardEventBrand=!0;const n=o;this.browserEvent=n,this.target=n.target,this.ctrlKey=n.ctrlKey,this.shiftKey=n.shiftKey,this.altKey=n.altKey,this.metaKey=n.metaKey,this.altGraphKey=n.getModifierState("AltGraph"),this.keyCode=p(n),this.code=n.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this.a=this.c(),this.b=this.d()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeyCodeChord(){return this.b}equals(o){return this.a===o}c(){let o=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(o=this.keyCode);let n=0;return this.ctrlKey&&(n|=A),this.altKey&&(n|=h),this.shiftKey&&(n|=a),this.metaKey&&(n|=c),n|=o,n}d(){let o=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(o=this.keyCode),new i.KeyCodeChord(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,o)}}t.StandardKeyboardEvent=l}),define(me[21],be([1,0,18,66,5]),function(te,t,y,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class W{constructor(a){this.timestamp=Date.now(),this.browserEvent=a,this.leftButton=a.button===0,this.middleButton=a.button===1,this.rightButton=a.button===2,this.buttons=a.buttons,this.target=a.target,this.detail=a.detail||1,a.type==="dblclick"&&(this.detail=2),this.ctrlKey=a.ctrlKey,this.shiftKey=a.shiftKey,this.altKey=a.altKey,this.metaKey=a.metaKey,typeof a.pageX=="number"?(this.posx=a.pageX,this.posy=a.pageY):(this.posx=a.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=a.clientY+document.body.scrollTop+document.documentElement.scrollTop);const c=M.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(window,a.view);this.posx-=c.left,this.posy-=c.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=W;class p extends W{constructor(a){super(a),this.dataTransfer=a.dataTransfer}}t.DragMouseEvent=p;class A{constructor(a,c=0,P=0){if(this.browserEvent=a||null,this.target=a?a.target||a.targetNode||a.srcElement:null,this.deltaY=P,this.deltaX=c,a){const r=a,l=a;if(typeof r.wheelDeltaY<"u")this.deltaY=r.wheelDeltaY/120;else if(typeof l.VERTICAL_AXIS<"u"&&l.axis===l.VERTICAL_AXIS)this.deltaY=-l.detail/3;else if(a.type==="wheel"){const e=a;e.deltaMode===e.DOM_DELTA_LINE?y.isFirefox&&!i.isMacintosh?this.deltaY=-a.deltaY/3:this.deltaY=-a.deltaY:this.deltaY=-a.deltaY/40}if(typeof r.wheelDeltaX<"u")y.isSafari&&i.isWindows?this.deltaX=-(r.wheelDeltaX/120):this.deltaX=r.wheelDeltaX/120;else if(typeof l.HORIZONTAL_AXIS<"u"&&l.axis===l.HORIZONTAL_AXIS)this.deltaX=-a.detail/3;else if(a.type==="wheel"){const e=a;e.deltaMode===e.DOM_DELTA_LINE?y.isFirefox&&!i.isMacintosh?this.deltaX=-a.deltaX/3:this.deltaX=-a.deltaX:this.deltaX=-a.deltaX/40}this.deltaY===0&&this.deltaX===0&&a.wheelDelta&&(this.deltaY=a.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=A}),define(me[31],be([1,0,3,2,103]),function(te,t,y,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class W extends M.Disposable{constructor(r,l="",e="",o=!0,n){super(),this.h=this.B(new y.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=r,this.m=l,this.u=e,this.w=o,this.C=n}get id(){return this.j}get label(){return this.m}set label(r){this.D(r)}D(r){this.m!==r&&(this.m=r,this.h.fire({label:r}))}get tooltip(){return this.n||""}set tooltip(r){this.F(r)}F(r){this.n!==r&&(this.n=r,this.h.fire({tooltip:r}))}get class(){return this.u}set class(r){this.G(r)}G(r){this.u!==r&&(this.u=r,this.h.fire({class:r}))}get enabled(){return this.w}set enabled(r){this.H(r)}H(r){this.w!==r&&(this.w=r,this.h.fire({enabled:r}))}get checked(){return this.z}set checked(r){this.I(r)}I(r){this.z!==r&&(this.z=r,this.h.fire({checked:r}))}async run(r,l){this.C&&await this.C(r)}}t.Action=W;class p extends M.Disposable{constructor(){super(...arguments),this.f=this.B(new y.Emitter),this.onWillRun=this.f.event,this.h=this.B(new y.Emitter),this.onDidRun=this.h.event}async run(r,l){if(!r.enabled)return;this.f.fire({action:r});let e;try{await this.k(r,l)}catch(o){e=o}this.h.fire({action:r,error:e})}async k(r,l){await r.run(l)}}t.ActionRunner=p;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...r){let l=[];for(const e of r)e.length&&(l.length?l=[...l,new A,...e]:l=e);return l}async run(){}}t.Separator=A,A.ID="vs.actions.separator";class h{get actions(){return this.a}constructor(r,l,e,o){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=r,this.label=l,this.class=o,this.a=e}async run(){}}t.SubmenuAction=h;class a extends W{constructor(){super(a.ID,i.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=a,a.ID="vs.actions.empty";function c(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async()=>P.run(),tooltip:P.label}}t.toAction=c}),define(me[27],be([1,0,3]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const M=Object.freeze(function(A,h){const a=setTimeout(A.bind(h),0);return{dispose(){clearTimeout(a)}}});var i;(function(A){function h(a){return a===A.None||a===A.Cancelled||a instanceof W?!0:!a||typeof a!="object"?!1:typeof a.isCancellationRequested=="boolean"&&typeof a.onCancellationRequested=="function"}A.isCancellationToken=h,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:y.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:M})})(i||(t.CancellationToken=i={}));class W{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?M:(this.b||(this.b=new y.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class p{constructor(h){this.a=void 0,this.b=void 0,this.b=h&&h.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new W),this.a}cancel(){this.a?this.a instanceof W&&this.a.cancel():this.a=i.Cancelled}dispose(h=!1){h&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof W&&this.a.dispose():this.a=i.None}}t.CancellationTokenSource=p}),define(me[109],be([1,0,27]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class M{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new y.CancellationTokenSource,h=this.b(A.token);return this.a={promise:h,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}t.Cache=M;class i{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const h=JSON.stringify(A);return this.b!==h&&(this.b=h,this.a=this.c(A)),this.a}}t.LRUCachedFunction=i;class W{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const h=this.b(A);return this.a.set(A,h),h}}t.CachedFunction=W}),define(me[49],be([1,0,3,2]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var i;(function(l){l[l.Auto=1]="Auto",l[l.Hidden=2]="Hidden",l[l.Visible=3]="Visible"})(i||(t.ScrollbarVisibility=i={}));class W{constructor(e,o,n,u,s,w,D){this.c=e,this._scrollStateBrand=void 0,this.c&&(o=o|0,n=n|0,u=u|0,s=s|0,w=w|0,D=D|0),this.rawScrollLeft=u,this.rawScrollTop=D,o<0&&(o=0),u+o>n&&(u=n-o),u<0&&(u=0),s<0&&(s=0),D+s>w&&(D=w-s),D<0&&(D=0),this.width=o,this.scrollWidth=n,this.scrollLeft=u,this.height=s,this.scrollHeight=w,this.scrollTop=D}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,o){return new W(this.c,typeof e.width<"u"?e.width:this.width,typeof e.scrollWidth<"u"?e.scrollWidth:this.scrollWidth,o?this.rawScrollLeft:this.scrollLeft,typeof e.height<"u"?e.height:this.height,typeof e.scrollHeight<"u"?e.scrollHeight:this.scrollHeight,o?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new W(this.c,this.width,this.scrollWidth,typeof e.scrollLeft<"u"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop<"u"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,o){const n=this.width!==e.width,u=this.scrollWidth!==e.scrollWidth,s=this.scrollLeft!==e.scrollLeft,w=this.height!==e.height,D=this.scrollHeight!==e.scrollHeight,S=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:o,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:n,scrollWidthChanged:u,scrollLeftChanged:s,heightChanged:w,scrollHeightChanged:D,scrollTopChanged:S}}}t.ScrollState=W;class p extends M.Disposable{constructor(e){super(),this._scrollableBrand=void 0,this.i=this.B(new y.Emitter),this.onScroll=this.i.event,this.c=e.smoothScrollDuration,this.f=e.scheduleAtNextAnimationFrame,this.g=new W(e.forceIntegerValues,0,0,0,0,0,0),this.h=null}dispose(){this.h&&(this.h.dispose(),this.h=null),super.dispose()}setSmoothScrollDuration(e){this.c=e}validateScrollPosition(e){return this.g.withScrollPosition(e)}getScrollDimensions(){return this.g}setScrollDimensions(e,o){const n=this.g.withScrollDimensions(e,o);this.k(n,!!this.h),this.h?.acceptScrollDimensions(this.g)}getFutureScrollPosition(){return this.h?this.h.to:this.g}getCurrentScrollPosition(){return this.g}setScrollPositionNow(e){const o=this.g.withScrollPosition(e);this.h&&(this.h.dispose(),this.h=null),this.k(o,!1)}setScrollPositionSmooth(e,o){if(this.c===0)return this.setScrollPositionNow(e);if(this.h){e={scrollLeft:typeof e.scrollLeft>"u"?this.h.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop>"u"?this.h.to.scrollTop:e.scrollTop};const n=this.g.withScrollPosition(e);if(this.h.to.scrollLeft===n.scrollLeft&&this.h.to.scrollTop===n.scrollTop)return;let u;o?u=new c(this.h.from,n,this.h.startTime,this.h.duration):u=this.h.combine(this.g,n,this.c),this.h.dispose(),this.h=u}else{const n=this.g.withScrollPosition(e);this.h=c.start(this.g,n,this.c)}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.j())})}hasPendingScrollAnimation(){return!!this.h}j(){if(!this.h)return;const e=this.h.tick(),o=this.g.withScrollPosition(e);if(this.k(o,!0),!!this.h){if(e.isDone){this.h.dispose(),this.h=null;return}this.h.animationFrameDisposable=this.f(()=>{this.h&&(this.h.animationFrameDisposable=null,this.j())})}}k(e,o){const n=this.g;n.equals(e)||(this.g=e,this.i.fire(this.g.createScrollEvent(n,o)))}}t.Scrollable=p;class A{constructor(e,o,n){this.scrollLeft=e,this.scrollTop=o,this.isDone=n}}t.SmoothScrollingUpdate=A;function h(l,e){const o=e-l;return function(n){return l+o*r(n)}}function a(l,e,o){return function(n){return n<o?l(n/o):e((n-o)/(1-o))}}class c{constructor(e,o,n,u){this.from=e,this.to=o,this.duration=u,this.startTime=n,this.animationFrameDisposable=null,this.e()}e(){this.c=this.f(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.d=this.f(this.from.scrollTop,this.to.scrollTop,this.to.height)}f(e,o,n){if(Math.abs(e-o)>2.5*n){let s,w;return e<o?(s=e+.75*n,w=o-.75*n):(s=e-.75*n,w=o+.75*n),a(h(e,s),h(w,o),.33)}return h(e,o)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this.e()}tick(){return this.g(Date.now())}g(e){const o=(e-this.startTime)/this.duration;if(o<1){const n=this.c(o),u=this.d(o);return new A(n,u,!1)}return new A(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,o,n){return c.start(e,o,n)}static start(e,o,n){n=n+10;const u=Date.now()-10;return new c(e,o,u,n)}}t.SmoothScrollingOperation=c;function P(l){return Math.pow(l,3)}function r(l){return 1-P(1-l)}}),define(me[11],be([1,0,109,42]),function(te,t,y,M){"use strict";var i;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.charCount=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function W(K){return!K||typeof K!="string"?!0:K.trim().length===0}t.isFalsyOrWhitespace=W;const p=/{(\d+)}/g;function A(K,...ae){return ae.length===0?K:K.replace(p,function(pe,ye){const Ce=parseInt(ye,10);return isNaN(Ce)||Ce<0||Ce>=ae.length?pe:ae[Ce]})}t.format=A;const h=/{([^}]+)}/g;function a(K,ae){return K.replace(h,(pe,ye)=>ae[ye]??pe)}t.format2=a;function c(K){return K.replace(/[<>&]/g,function(ae){switch(ae){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return ae}})}t.escape=c;function P(K){return K.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=P;function r(K,ae){let pe=0;const ye=ae.charCodeAt(0);for(let Ce=K.length-1;Ce>=0;Ce--)K.charCodeAt(Ce)===ye&&pe++;return pe}t.count=r;function l(K,ae,pe="\u2026"){return K.length<=ae?K:`${K.substr(0,ae)}${pe}`}t.truncate=l;function e(K,ae=" "){const pe=o(K,ae);return n(pe,ae)}t.trim=e;function o(K,ae){if(!K||!ae)return K;const pe=ae.length;if(pe===0||K.length===0)return K;let ye=0;for(;K.indexOf(ae,ye)===ye;)ye=ye+pe;return K.substring(ye)}t.ltrim=o;function n(K,ae){if(!K||!ae)return K;const pe=ae.length,ye=K.length;if(pe===0||ye===0)return K;let Ce=ye,Re=-1;for(;Re=K.lastIndexOf(ae,Ce-1),!(Re===-1||Re+pe!==Ce);){if(Re===0)return"";Ce=Re}return K.substring(0,Ce)}t.rtrim=n;function u(K){return K.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=u;function s(K){return K.replace(/\*/g,"")}t.stripWildcards=s;function w(K,ae,pe={}){if(!K)throw new Error("Cannot create regex from empty string");ae||(K=P(K)),pe.wholeWord&&(/\B/.test(K.charAt(0))||(K="\\b"+K),/\B/.test(K.charAt(K.length-1))||(K=K+"\\b"));let ye="";return pe.global&&(ye+="g"),pe.matchCase||(ye+="i"),pe.multiline&&(ye+="m"),pe.unicode&&(ye+="u"),new RegExp(K,ye)}t.createRegExp=w;function D(K){return K.source==="^"||K.source==="^$"||K.source==="$"||K.source==="^\\s*$"?!1:!!(K.exec("")&&K.lastIndex===0)}t.regExpLeadsToEndlessLoop=D;function S(K){return!!K.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=S;function f(K){return(K.global?"g":"")+(K.ignoreCase?"i":"")+(K.multiline?"m":"")+(K.unicode?"u":"")}t.regExpFlags=f;function v(K){return K.split(/\r\n|\r|\n/)}t.splitLines=v;function L(K){for(let ae=0,pe=K.length;ae<pe;ae++){const ye=K.charCodeAt(ae);if(ye!==32&&ye!==9)return ae}return-1}t.firstNonWhitespaceIndex=L;function N(K,ae=0,pe=K.length){for(let ye=ae;ye<pe;ye++){const Ce=K.charCodeAt(ye);if(Ce!==32&&Ce!==9)return K.substring(ae,ye)}return K.substring(ae,pe)}t.getLeadingWhitespace=N;function E(K,ae=K.length-1){for(let pe=ae;pe>=0;pe--){const ye=K.charCodeAt(pe);if(ye!==32&&ye!==9)return pe}return-1}t.lastNonWhitespaceIndex=E;function g(K,ae,pe){const ye=[];let Ce=0;for(const Re of K.matchAll(ae)){if(ye.push(K.slice(Ce,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Ce=Re.index+Re[0].length,ye.push(pe(Re[0],...Re.slice(1),Re.index,K,Re.groups))}return ye.push(K.slice(Ce)),Promise.all(ye).then(Re=>Re.join(""))}t.replaceAsync=g;function m(K,ae){return K<ae?-1:K>ae?1:0}t.compare=m;function b(K,ae,pe=0,ye=K.length,Ce=0,Re=ae.length){for(;pe<ye&&Ce<Re;pe++,Ce++){const et=K.charCodeAt(pe),Te=ae.charCodeAt(Ce);if(et<Te)return-1;if(et>Te)return 1}const $e=ye-pe,Ge=Re-Ce;return $e<Ge?-1:$e>Ge?1:0}t.compareSubstring=b;function B(K,ae){return G(K,ae,0,K.length,0,ae.length)}t.compareIgnoreCase=B;function G(K,ae,pe=0,ye=K.length,Ce=0,Re=ae.length){for(;pe<ye&&Ce<Re;pe++,Ce++){let et=K.charCodeAt(pe),Te=ae.charCodeAt(Ce);if(et===Te)continue;if(et>=128||Te>=128)return b(K.toLowerCase(),ae.toLowerCase(),pe,ye,Ce,Re);ie(et)&&(et-=32),ie(Te)&&(Te-=32);const he=et-Te;if(he!==0)return he}const $e=ye-pe,Ge=Re-Ce;return $e<Ge?-1:$e>Ge?1:0}t.compareSubstringIgnoreCase=G;function J(K){return K>=48&&K<=57}t.isAsciiDigit=J;function ie(K){return K>=97&&K<=122}t.isLowerAsciiLetter=ie;function le(K){return K>=65&&K<=90}t.isUpperAsciiLetter=le;function ge(K,ae){return K.length===ae.length&&G(K,ae)===0}t.equalsIgnoreCase=ge;function ue(K,ae){const pe=ae.length;return ae.length>K.length?!1:G(K,ae,0,pe)===0}t.startsWithIgnoreCase=ue;function de(K,ae){const pe=Math.min(K.length,ae.length);let ye;for(ye=0;ye<pe;ye++)if(K.charCodeAt(ye)!==ae.charCodeAt(ye))return ye;return pe}t.commonPrefixLength=de;function ce(K,ae){const pe=Math.min(K.length,ae.length);let ye;const Ce=K.length-1,Re=ae.length-1;for(ye=0;ye<pe;ye++)if(K.charCodeAt(Ce-ye)!==ae.charCodeAt(Re-ye))return ye;return pe}t.commonSuffixLength=ce;function Se(K){return 55296<=K&&K<=56319}t.isHighSurrogate=Se;function Ae(K){return 56320<=K&&K<=57343}t.isLowSurrogate=Ae;function Be(K,ae){return(K-55296<<10)+(ae-56320)+65536}t.computeCodePoint=Be;function re(K,ae,pe){const ye=K.charCodeAt(pe);if(Se(ye)&&pe+1<ae){const Ce=K.charCodeAt(pe+1);if(Ae(Ce))return Be(ye,Ce)}return ye}t.getNextCodePoint=re;function ne(K,ae){const pe=K.charCodeAt(ae-1);if(Ae(pe)&&ae>1){const ye=K.charCodeAt(ae-2);if(Se(ye))return Be(ye,pe)}return pe}class Q{get offset(){return this.e}constructor(ae,pe=0){this.c=ae,this.d=ae.length,this.e=pe}setOffset(ae){this.e=ae}prevCodePoint(){const ae=ne(this.c,this.e);return this.e-=ae>=65536?2:1,ae}nextCodePoint(){const ae=re(this.c,this.d,this.e);return this.e+=ae>=65536?2:1,ae}eol(){return this.e>=this.d}}t.CodePointIterator=Q;class oe{get offset(){return this.c.offset}constructor(ae,pe=0){this.c=new Q(ae,pe)}nextGraphemeLength(){const ae=Ne.getInstance(),pe=this.c,ye=pe.offset;let Ce=ae.getGraphemeBreakType(pe.nextCodePoint());for(;!pe.eol();){const Re=pe.offset,$e=ae.getGraphemeBreakType(pe.nextCodePoint());if(we(Ce,$e)){pe.setOffset(Re);break}Ce=$e}return pe.offset-ye}prevGraphemeLength(){const ae=Ne.getInstance(),pe=this.c,ye=pe.offset;let Ce=ae.getGraphemeBreakType(pe.prevCodePoint());for(;pe.offset>0;){const Re=pe.offset,$e=ae.getGraphemeBreakType(pe.prevCodePoint());if(we($e,Ce)){pe.setOffset(Re);break}Ce=$e}return ye-pe.offset}eol(){return this.c.eol()}}t.GraphemeIterator=oe;function j(K,ae){return new oe(K,ae).nextGraphemeLength()}t.nextCharLength=j;function V(K,ae){return new oe(K,ae).prevGraphemeLength()}t.prevCharLength=V;function F(K,ae){ae>0&&Ae(K.charCodeAt(ae))&&ae--;const pe=ae+j(K,ae);return[pe-V(K,pe),pe]}t.getCharContainingOffset=F;function x(K){const ae=new oe(K);let pe=0;for(;!ae.eol();)pe++,ae.nextGraphemeLength();return pe}t.charCount=x;let I;function d(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function R(K){return I||(I=d()),I.test(K)}t.containsRTL=R;const _=/^[\t\n\r\x20-\x7E]*$/;function Z(K){return _.test(K)}t.isBasicASCII=Z,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function k(K){return t.UNUSUAL_LINE_TERMINATORS.test(K)}t.containsUnusualLineTerminators=k;function T(K){return K>=11904&&K<=55215||K>=63744&&K<=64255||K>=65281&&K<=65374}t.isFullWidthCharacter=T;function H(K){return K>=127462&&K<=127487||K===8986||K===8987||K===9200||K===9203||K>=9728&&K<=10175||K===11088||K===11093||K>=127744&&K<=128591||K>=128640&&K<=128764||K>=128992&&K<=129008||K>=129280&&K<=129535||K>=129648&&K<=129782}t.isEmojiImprecise=H;function C(K,ae){if(K.length<ae)return K;const pe=/\b/g;let ye=0;for(;pe.test(K)&&!(K.length-pe.lastIndex<ae);)ye=pe.lastIndex,pe.lastIndex+=1;return K.substring(ye).replace(/^\s/,"")}t.lcut=C;const U=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,z=/\x1b\].*?\x07/g;function O(K){return K&&(K=K.replace(U,"").replace(z,"")),K}t.removeAnsiEscapeCodes=O,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function $(K){return!!(K&&K.length>0&&K.charCodeAt(0)===65279)}t.startsWithUTF8BOM=$;function q(K){return $(K)?K.substr(1):K}t.stripUTF8BOM=q;function ee(K,ae){if(!K||!ae||K.length<ae.length)return!1;const pe=ae.length,ye=K.toLowerCase();let Ce=0,Re=-1;for(;Ce<pe;){const $e=ye.indexOf(ae[Ce],Re+1);if($e<0)return!1;Re=$e,Ce++}return!0}t.fuzzyContains=ee;function se(K,ae=!1){return K?(ae&&(K=K.replace(/\\./g,"")),K.toLowerCase()!==K):!1}t.containsUppercaseCharacter=se;function ve(K){return K.charAt(0).toUpperCase()+K.slice(1)}t.uppercaseFirstLetter=ve;function De(K,ae=1){if(ae===0)return"";let pe=-1;do pe=K.indexOf(`
`,pe+1),ae--;while(ae>0&&pe>=0);return pe===-1?K:(K[pe-1]==="\r"&&pe--,K.substr(0,pe))}t.getNLines=De;function Ie(K){return K=K%(2*26),K<26?String.fromCharCode(97+K):String.fromCharCode(65+K-26)}t.singleLetterHash=Ie;function Fe(K){return Ne.getInstance().getGraphemeBreakType(K)}t.getGraphemeBreakType=Fe;function we(K,ae){return K===0?ae!==5&&ae!==7:K===2&&ae===3?!1:K===4||K===2||K===3||ae===4||ae===2||ae===3?!0:!(K===8&&(ae===8||ae===9||ae===11||ae===12)||(K===11||K===9)&&(ae===9||ae===10)||(K===12||K===10)&&ae===10||ae===5||ae===13||ae===7||K===1||K===13&&ae===14||K===6&&ae===6)}var Pe;(function(K){K[K.Other=0]="Other",K[K.Prepend=1]="Prepend",K[K.CR=2]="CR",K[K.LF=3]="LF",K[K.Control=4]="Control",K[K.Extend=5]="Extend",K[K.Regional_Indicator=6]="Regional_Indicator",K[K.SpacingMark=7]="SpacingMark",K[K.L=8]="L",K[K.V=9]="V",K[K.T=10]="T",K[K.LV=11]="LV",K[K.LVT=12]="LVT",K[K.ZWJ=13]="ZWJ",K[K.Extended_Pictographic=14]="Extended_Pictographic"})(Pe||(t.GraphemeBreakType=Pe={}));class Ne{static getInstance(){return Ne.c||(Ne.c=new Ne),Ne.c}constructor(){this.d=Ve()}getGraphemeBreakType(ae){if(ae<32)return ae===10?3:ae===13?2:4;if(ae<127)return 0;const pe=this.d,ye=pe.length/3;let Ce=1;for(;Ce<=ye;)if(ae<pe[3*Ce])Ce=2*Ce;else if(ae>pe[3*Ce+1])Ce=2*Ce+1;else return pe[3*Ce+2];return 0}}Ne.c=null;function Ve(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function ze(K,ae){if(K===0)return 0;const pe=We(K,ae);if(pe!==void 0)return pe;const ye=new Q(ae,K);return ye.prevCodePoint(),ye.offset}t.getLeftDeleteOffset=ze;function We(K,ae){const pe=new Q(ae,K);let ye=pe.prevCodePoint();for(;Je(ye)||ye===65039||ye===8419;){if(pe.offset===0)return;ye=pe.prevCodePoint()}if(!H(ye))return;let Ce=pe.offset;return Ce>0&&pe.prevCodePoint()===8205&&(Ce=pe.offset),Ce}function Je(K){return 127995<=K&&K<=127999}var it;(function(K){K[K.zwj=8205]="zwj",K[K.emojiVariantSelector=65039]="emojiVariantSelector",K[K.enclosingKeyCap=8419]="enclosingKeyCap"})(it||(it={})),t.noBreakWhitespace="\xA0";class Oe{static getInstance(ae){return Oe.d.get(Array.from(ae))}static getLocales(){return Oe.e.value}constructor(ae){this.f=ae}isAmbiguous(ae){return this.f.has(ae)}getPrimaryConfusable(ae){return this.f.get(ae)}getConfusableCodePoints(){return new Set(this.f.keys())}}t.AmbiguousCharacters=Oe,i=Oe,Oe.c=new M.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Oe.d=new y.LRUCachedFunction(K=>{function ae(Te){const he=new Map;for(let Ee=0;Ee<Te.length;Ee+=2)he.set(Te[Ee],Te[Ee+1]);return he}function pe(Te,he){const Ee=new Map(Te);for(const[Me,Ue]of he)Ee.set(Me,Ue);return Ee}function ye(Te,he){if(!Te)return he;const Ee=new Map;for(const[Me,Ue]of Te)he.has(Me)&&Ee.set(Me,Ue);return Ee}const Ce=i.c.value;let Re=K.filter(Te=>!Te.startsWith("_")&&Te in Ce);Re.length===0&&(Re=["_default"]);let $e;for(const Te of Re){const he=ae(Ce[Te]);$e=ye($e,he)}const Ge=ae(Ce._common),et=pe(Ge,$e);return new Oe(et)}),Oe.e=new M.Lazy(()=>Object.keys(Oe.c.value).filter(K=>!K.startsWith("_")));class je{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(je.c())),this.d}static isInvisibleCharacter(ae){return je.e().has(ae)}static get codePoints(){return je.e()}}t.InvisibleCharacters=je,je.d=void 0}),define(me[110],be([1,0,22,5,11,6]),function(te,t,y,M,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function p(g){return g===47||g===92}t.isPathSeparator=p;function A(g){return g.replace(/[\\/]/g,y.posix.sep)}t.toSlashes=A;function h(g){return g.indexOf("/")===-1&&(g=A(g)),/^[a-zA-Z]:(\/|$)/.test(g)&&(g="/"+g),g}t.toPosixPath=h;function a(g,m=y.posix.sep){if(!g)return"";const b=g.length,B=g.charCodeAt(0);if(p(B)){if(p(g.charCodeAt(1))&&!p(g.charCodeAt(2))){let J=3;const ie=J;for(;J<b&&!p(g.charCodeAt(J));J++);if(ie!==J&&!p(g.charCodeAt(J+1))){for(J+=1;J<b;J++)if(p(g.charCodeAt(J)))return g.slice(0,J+1).replace(/[\\/]/g,m)}}return m}else if(u(B)&&g.charCodeAt(1)===58)return p(g.charCodeAt(2))?g.slice(0,2)+m:g.slice(0,2);let G=g.indexOf("://");if(G!==-1){for(G+=3;G<b;G++)if(p(g.charCodeAt(G)))return g.slice(0,G+1)}return""}t.getRoot=a;function c(g){if(!M.isWindows||!g||g.length<5)return!1;let m=g.charCodeAt(0);if(m!==92||(m=g.charCodeAt(1),m!==92))return!1;let b=2;const B=b;for(;b<g.length&&(m=g.charCodeAt(b),m!==92);b++);return!(B===b||(m=g.charCodeAt(b+1),isNaN(m)||m===92))}t.isUNC=c;const P=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(g,m=M.isWindows){const b=m?P:r;return!(!g||g.length===0||/^\s+$/.test(g)||(b.lastIndex=0,b.test(g))||m&&l.test(g)||g==="."||g===".."||m&&g[g.length-1]==="."||m&&g.length!==g.trim().length||g.length>255)}t.isValidBasename=e;function o(g,m,b){const B=g===m;return!b||B?B:!g||!m?!1:(0,i.equalsIgnoreCase)(g,m)}t.isEqual=o;function n(g,m,b,B=y.sep){if(g===m)return!0;if(!g||!m||m.length>g.length)return!1;if(b){if(!(0,i.startsWithIgnoreCase)(g,m))return!1;if(m.length===g.length)return!0;let J=m.length;return m.charAt(m.length-1)===B&&J--,g.charAt(J)===B}return m.charAt(m.length-1)!==B&&(m+=B),g.indexOf(m)===0}t.isEqualOrParent=n;function u(g){return g>=65&&g<=90||g>=97&&g<=122}t.isWindowsDriveLetter=u;function s(g,m){return M.isWindows&&g.endsWith(":")&&(g+=y.sep),(0,y.isAbsolute)(g)||(g=(0,y.join)(m,g)),g=(0,y.normalize)(g),M.isWindows?(g=(0,i.rtrim)(g,y.sep),g.endsWith(":")&&(g+=y.sep)):(g=(0,i.rtrim)(g,y.sep),g||(g=y.sep)),g}t.sanitizeFilePath=s;function w(g){const m=(0,y.normalize)(g);return M.isWindows?g.length>3?!1:D(m)&&(g.length===2||m.charCodeAt(2)===92):m===y.posix.sep}t.isRootOrDriveLetter=w;function D(g,m=M.isWindows){return m?u(g.charCodeAt(0))&&g.charCodeAt(1)===58:!1}t.hasDriveLetter=D;function S(g){return D(g)?g[0]:void 0}t.getDriveLetter=S;function f(g,m,b){return m.length>g.length?-1:g===m?0:(b&&(g=g.toLowerCase(),m=m.toLowerCase()),g.indexOf(m))}t.indexOfPath=f;function v(g){const m=g.split(":");let b,B,G;for(const J of m){const ie=Number(J);(0,W.isNumber)(ie)?B===void 0?B=ie:G===void 0&&(G=ie):b=b?[b,J].join(":"):J}if(!b)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:b,line:B!==void 0?B:void 0,column:G!==void 0?G:B!==void 0?1:void 0}}t.parseLineAndColumnAware=v;const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",N="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(g,m,b=8){let B="";for(let J=0;J<b;J++){let ie;J===0&&M.isWindows&&!m&&(b===3||b===4)?ie=N:ie=L,B+=ie.charAt(Math.floor(Math.random()*ie.length))}let G;return m?G=`${m}-${B}`:G=B,g?(0,y.join)(g,G):G}t.randomPath=E}),define(me[32],be([1,0,75,11]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function i(...z){return function(O,$){for(let q=0,ee=z.length;q<ee;q++){const se=z[q](O,$);if(se)return se}return null}}t.or=i,t.matchesStrictPrefix=W.bind(void 0,!1),t.matchesPrefix=W.bind(void 0,!0);function W(z,O,$){if(!$||$.length<O.length)return null;let q;return z?q=M.startsWithIgnoreCase($,O):q=$.indexOf(O)===0,q?O.length>0?[{start:0,end:O.length}]:[]:null}function p(z,O){const $=O.toLowerCase().indexOf(z.toLowerCase());return $===-1?null:[{start:$,end:$+z.length}]}t.matchesContiguousSubString=p;function A(z,O){return h(z.toLowerCase(),O.toLowerCase(),0,0)}t.matchesSubString=A;function h(z,O,$,q){if($===z.length)return[];if(q===O.length)return null;if(z[$]===O[q]){let ee=null;return(ee=h(z,O,$+1,q+1))?u({start:q,end:q+1},ee):null}return h(z,O,$,q+1)}function a(z){return 97<=z&&z<=122}function c(z){return 65<=z&&z<=90}t.isUpper=c;function P(z){return 48<=z&&z<=57}function r(z){return z===32||z===9||z===10||z===13}const l=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(z=>l.add(z.charCodeAt(0)));function e(z){return r(z)||l.has(z)}function o(z,O){return z===O||e(z)&&e(O)}function n(z){return a(z)||c(z)||P(z)}function u(z,O){return O.length===0?O=[z]:z.end===O[0].start?O[0].start=z.start:O.unshift(z),O}function s(z,O){for(let $=O;$<z.length;$++){const q=z.charCodeAt($);if(c(q)||P(q)||$>0&&!n(z.charCodeAt($-1)))return $}return z.length}function w(z,O,$,q){if($===z.length)return[];if(q===O.length)return null;if(z[$]!==O[q].toLowerCase())return null;{let ee=null,se=q+1;for(ee=w(z,O,$+1,q+1);!ee&&(se=s(O,se))<O.length;)ee=w(z,O,$+1,se),se++;return ee===null?null:u({start:q,end:q+1},ee)}}function D(z){let O=0,$=0,q=0,ee=0,se=0;for(let we=0;we<z.length;we++)se=z.charCodeAt(we),c(se)&&O++,a(se)&&$++,n(se)&&q++,P(se)&&ee++;const ve=O/z.length,De=$/z.length,Ie=q/z.length,Fe=ee/z.length;return{upperPercent:ve,lowerPercent:De,alphaPercent:Ie,numericPercent:Fe}}function S(z){const{upperPercent:O,lowerPercent:$}=z;return $===0&&O>.6}function f(z){const{upperPercent:O,lowerPercent:$,alphaPercent:q,numericPercent:ee}=z;return $>.2&&O<.8&&q>.6&&ee<.2}function v(z){let O=0,$=0,q=0,ee=0;for(let se=0;se<z.length;se++)q=z.charCodeAt(se),c(q)&&O++,a(q)&&$++,r(q)&&ee++;return(O===0||$===0)&&ee===0?z.length<=30:O<=5}function L(z,O){if(!O||(O=O.trim(),O.length===0)||!v(z)||O.length>60)return null;const $=D(O);if(!f($)){if(!S($))return null;O=O.toLowerCase()}let q=null,ee=0;for(z=z.toLowerCase();ee<O.length&&(q=w(z,O,0,ee))===null;)ee=s(O,ee+1);return q}t.matchesCamelCase=L;function N(z,O,$=!1){if(!O||O.length===0)return null;let q=null,ee=0;for(z=z.toLowerCase(),O=O.toLowerCase();ee<O.length&&(q=E(z,O,0,ee,$))===null;)ee=g(O,ee+1);return q}t.matchesWords=N;function E(z,O,$,q,ee){if($===z.length)return[];if(q===O.length)return null;if(o(z.charCodeAt($),O.charCodeAt(q))){let se=null,ve=q+1;if(se=E(z,O,$+1,q+1,ee),!ee)for(;!se&&(ve=g(O,ve))<O.length;)se=E(z,O,$+1,ve,ee),ve++;return se?z.charCodeAt($)!==O.charCodeAt(q)?se:u({start:q,end:q+1},se):null}else return null}function g(z,O){for(let $=O;$<z.length;$++)if(e(z.charCodeAt($))||$>0&&e(z.charCodeAt($-1)))return $;return z.length}const m=i(t.matchesPrefix,L,p),b=i(t.matchesPrefix,L,A),B=new y.LRUCache(1e4);function G(z,O,$=!1){if(typeof z!="string"||typeof O!="string")return null;let q=B.get(z);q||(q=new RegExp(M.convertSimple2RegExpPattern(z),"i"),B.set(z,q));const ee=q.exec(O);return ee?[{start:ee.index,end:ee.index+ee[0].length}]:$?b(z,O):m(z,O)}t.matchesFuzzy=G;function J(z,O){const $=_(z,z.toLowerCase(),0,O,O.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return $?le($):null}t.matchesFuzzy2=J;function ie(z,O,$,q,ee,se){const ve=Math.min(13,z.length);for(;$<ve;$++){const De=_(z,O,$,q,ee,se,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(De)return De}return[0,se]}t.anyScore=ie;function le(z){if(typeof z>"u")return[];const O=[],$=z[1];for(let q=z.length-1;q>1;q--){const ee=z[q]+$,se=O[O.length-1];se&&se.end===ee?se.end=ee+1:O.push({start:ee,end:ee+1})}return O}t.createMatches=le;const ge=128;function ue(){const z=[],O=[];for(let $=0;$<=ge;$++)O[$]=0;for(let $=0;$<=ge;$++)z.push(O.slice(0));return z}function de(z){const O=[];for(let $=0;$<=z;$++)O[$]=0;return O}const ce=de(2*ge),Se=de(2*ge),Ae=ue(),Be=ue(),re=ue(),ne=!1;function Q(z,O,$,q,ee){function se(De,Ie,Fe=" "){for(;De.length<Ie;)De=Fe+De;return De}let ve=` |   |${q.split("").map(De=>se(De,3)).join("|")}
`;for(let De=0;De<=$;De++)De===0?ve+=" |":ve+=`${O[De-1]}|`,ve+=z[De].slice(0,ee+1).map(Ie=>se(Ie.toString(),3)).join("|")+`
`;return ve}function oe(z,O,$,q){z=z.substr(O),$=$.substr(q),console.log(Q(Be,z,z.length,$,$.length)),console.log(Q(re,z,z.length,$,$.length)),console.log(Q(Ae,z,z.length,$,$.length))}function j(z,O){if(O<0||O>=z.length)return!1;const $=z.codePointAt(O);switch($){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.isEmojiImprecise($)}}function V(z,O){if(O<0||O>=z.length)return!1;switch(z.charCodeAt(O)){case 32:case 9:return!0;default:return!1}}function F(z,O,$){return O[z]!==$[z]}function x(z,O,$,q,ee,se,ve=!1){for(;O<$&&ee<se;)z[O]===q[ee]&&(ve&&(ce[O]=ee),O+=1),ee+=1;return O===$}t.isPatternInWord=x;var I;(function(z){z[z.Diag=1]="Diag",z[z.Left=2]="Left",z[z.LeftLeft=3]="LeftLeft"})(I||(I={}));var d;(function(z){z.Default=[-100,0];function O($){return!$||$.length===2&&$[0]===-100&&$[1]===0}z.isDefault=O})(d||(t.FuzzyScore=d={}));class R{constructor(O,$){this.firstMatchCanBeWeak=O,this.boostFullMatch=$}}t.FuzzyScoreOptions=R,R.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function _(z,O,$,q,ee,se,ve=R.default){const De=z.length>ge?ge:z.length,Ie=q.length>ge?ge:q.length;if($>=De||se>=Ie||De-$>Ie-se||!x(O,$,De,ee,se,Ie,!0))return;Z(De,Ie,$,se,O,ee);let Fe=1,we=1,Pe=$,Ne=se;const Ve=[!1];for(Fe=1,Pe=$;Pe<De;Fe++,Pe++){const Oe=ce[Pe],je=Se[Pe],K=Pe+1<De?Se[Pe+1]:Ie;for(we=Oe-se+1,Ne=Oe;Ne<K;we++,Ne++){let ae=Number.MIN_SAFE_INTEGER,pe=!1;Ne<=je&&(ae=k(z,O,Pe,$,q,ee,Ne,Ie,se,Ae[Fe-1][we-1]===0,Ve));let ye=0;ae!==Number.MAX_SAFE_INTEGER&&(pe=!0,ye=ae+Be[Fe-1][we-1]);const Ce=Ne>Oe,Re=Ce?Be[Fe][we-1]+(Ae[Fe][we-1]>0?-5:0):0,$e=Ne>Oe+1&&Ae[Fe][we-1]>0,Ge=$e?Be[Fe][we-2]+(Ae[Fe][we-2]>0?-5:0):0;if($e&&(!Ce||Ge>=Re)&&(!pe||Ge>=ye))Be[Fe][we]=Ge,re[Fe][we]=3,Ae[Fe][we]=0;else if(Ce&&(!pe||Re>=ye))Be[Fe][we]=Re,re[Fe][we]=2,Ae[Fe][we]=0;else if(pe)Be[Fe][we]=ye,re[Fe][we]=1,Ae[Fe][we]=Ae[Fe-1][we-1]+1;else throw new Error("not possible")}}if(ne&&oe(z,$,q,se),!Ve[0]&&!ve.firstMatchCanBeWeak)return;Fe--,we--;const ze=[Be[Fe][we],se];let We=0,Je=0;for(;Fe>=1;){let Oe=we;do{const je=re[Fe][Oe];if(je===3)Oe=Oe-2;else if(je===2)Oe=Oe-1;else break}while(Oe>=1);We>1&&O[$+Fe-1]===ee[se+we-1]&&!F(Oe+se-1,q,ee)&&We+1>Ae[Fe][Oe]&&(Oe=we),Oe===we?We++:We=1,Je||(Je=Oe),Fe--,we=Oe-1,ze.push(we)}Ie===De&&ve.boostFullMatch&&(ze[0]+=2);const it=Je-De;return ze[0]-=it,ze}t.fuzzyScore=_;function Z(z,O,$,q,ee,se){let ve=z-1,De=O-1;for(;ve>=$&&De>=q;)ee[ve]===se[De]&&(Se[ve]=De,ve--),De--}function k(z,O,$,q,ee,se,ve,De,Ie,Fe,we){if(O[$]!==se[ve])return Number.MIN_SAFE_INTEGER;let Pe=1,Ne=!1;return ve===$-q?Pe=z[$]===ee[ve]?7:5:F(ve,ee,se)&&(ve===0||!F(ve-1,ee,se))?(Pe=z[$]===ee[ve]?7:5,Ne=!0):j(se,ve)&&(ve===0||!j(se,ve-1))?Pe=5:(j(se,ve-1)||V(se,ve-1))&&(Pe=5,Ne=!0),Pe>1&&$===q&&(we[0]=!0),Ne||(Ne=F(ve,ee,se)||j(se,ve-1)||V(se,ve-1)),$===q?ve>Ie&&(Pe-=Ne?3:5):Fe?Pe+=Ne?2:0:Pe+=Ne?0:1,ve+1===De&&(Pe-=Ne?3:5),Pe}function T(z,O,$,q,ee,se,ve){return C(z,O,$,q,ee,se,!0,ve)}t.fuzzyScoreGracefulAggressive=T;function H(z,O,$,q,ee,se,ve){return C(z,O,$,q,ee,se,!1,ve)}t.fuzzyScoreGraceful=H;function C(z,O,$,q,ee,se,ve,De){let Ie=_(z,O,$,q,ee,se,De);if(Ie&&!ve)return Ie;if(z.length>=3){const Fe=Math.min(7,z.length-1);for(let we=$+1;we<Fe;we++){const Pe=U(z,we);if(Pe){const Ne=_(Pe,Pe.toLowerCase(),$,q,ee,se,De);Ne&&(Ne[0]-=3,(!Ie||Ne[0]>Ie[0])&&(Ie=Ne))}}}return Ie}function U(z,O){if(O+1>=z.length)return;const $=z[O],q=z[O+1];if($!==q)return z.slice(0,O)+q+$+z.slice(O+2)}}),define(me[111],be([1,0,11]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function M(u){return i(u,0)}t.hash=M;function i(u,s){switch(typeof u){case"object":return u===null?W(349,s):Array.isArray(u)?h(u,s):a(u,s);case"string":return A(u,s);case"boolean":return p(u,s);case"number":return W(u,s);case"undefined":return W(937,s);default:return W(617,s)}}t.doHash=i;function W(u,s){return(s<<5)-s+u|0}t.numberHash=W;function p(u,s){return W(u?433:863,s)}function A(u,s){s=W(149417,s);for(let w=0,D=u.length;w<D;w++)s=W(u.charCodeAt(w),s);return s}t.stringHash=A;function h(u,s){return s=W(104579,s),u.reduce((w,D)=>i(D,w),s)}function a(u,s){return s=W(181387,s),Object.keys(u).sort().reduce((w,D)=>(w=A(D,w),i(u[D],w)),s)}class c{constructor(){this.g=0}get value(){return this.g}hash(s){return this.g=i(s,this.g),this.g}}t.Hasher=c;var P;(function(u){u[u.BLOCK_SIZE=64]="BLOCK_SIZE",u[u.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function r(u,s,w=32){const D=w-s,S=~((1<<D)-1);return(u<<s|(S&u)>>>D)>>>0}function l(u,s=0,w=u.byteLength,D=0){for(let S=0;S<w;S++)u[s+S]=D}function e(u,s,w="0"){for(;u.length<s;)u=w+u;return u}function o(u,s=32){return u instanceof ArrayBuffer?Array.from(new Uint8Array(u)).map(w=>w.toString(16).padStart(2,"0")).join(""):e((u>>>0).toString(16),s/4)}t.toHexString=o;class n{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(s){const w=s.length;if(w===0)return;const D=this.p;let S=this.r,f=this.u,v,L;for(f!==0?(v=f,L=-1,f=0):(v=s.charCodeAt(0),L=0);;){let N=v;if(y.isHighSurrogate(v))if(L+1<w){const E=s.charCodeAt(L+1);y.isLowSurrogate(E)?(L++,N=y.computeCodePoint(v,E)):N=65533}else{f=v;break}else y.isLowSurrogate(v)&&(N=65533);if(S=this.w(D,S,N),L++,L<w)v=s.charCodeAt(L);else break}this.r=S,this.u=f}w(s,w,D){return D<128?s[w++]=D:D<2048?(s[w++]=192|(D&1984)>>>6,s[w++]=128|(D&63)>>>0):D<65536?(s[w++]=224|(D&61440)>>>12,s[w++]=128|(D&4032)>>>6,s[w++]=128|(D&63)>>>0):(s[w++]=240|(D&1835008)>>>18,s[w++]=128|(D&258048)>>>12,s[w++]=128|(D&4032)>>>6,s[w++]=128|(D&63)>>>0),w>=64&&(this.y(),w-=64,this.t+=64,s[0]=s[64+0],s[1]=s[64+1],s[2]=s[64+2]),w}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),o(this.h)+o(this.l)+o(this.m)+o(this.n)+o(this.o)}x(){this.p[this.r++]=128,l(this.p,this.r),this.r>56&&(this.y(),l(this.p));const s=8*this.t;this.q.setUint32(56,Math.floor(s/4294967296),!1),this.q.setUint32(60,s%4294967296,!1),this.y()}y(){const s=n.g,w=this.q;for(let m=0;m<64;m+=4)s.setUint32(m,w.getUint32(m,!1),!1);for(let m=64;m<320;m+=4)s.setUint32(m,r(s.getUint32(m-12,!1)^s.getUint32(m-32,!1)^s.getUint32(m-56,!1)^s.getUint32(m-64,!1),1),!1);let D=this.h,S=this.l,f=this.m,v=this.n,L=this.o,N,E,g;for(let m=0;m<80;m++)m<20?(N=S&f|~S&v,E=1518500249):m<40?(N=S^f^v,E=1859775393):m<60?(N=S&f|S&v|f&v,E=2400959708):(N=S^f^v,E=3395469782),g=r(D,5)+N+L+E+s.getUint32(m*4,!1)&4294967295,L=v,v=f,f=r(S,30),S=D,D=g;this.h=this.h+D&4294967295,this.l=this.l+S&4294967295,this.m=this.m+f&4294967295,this.n=this.n+v&4294967295,this.o=this.o+L&4294967295}}t.StringSHA1=n,n.g=new DataView(new ArrayBuffer(320))}),define(me[112],be([1,0,71,111]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.stringDiff=t.StringDiffSequence=void 0;class i{constructor(r){this.a=r}getElements(){const r=this.a,l=new Int32Array(r.length);for(let e=0,o=r.length;e<o;e++)l[e]=r.charCodeAt(e);return l}}t.StringDiffSequence=i;function W(P,r,l){return new c(new i(P),new i(r)).ComputeDiff(l).changes}t.stringDiff=W;class p{static Assert(r,l){if(!r)throw new Error(l)}}class A{static Copy(r,l,e,o,n){for(let u=0;u<n;u++)e[o+u]=r[l+u]}static Copy2(r,l,e,o,n){for(let u=0;u<n;u++)e[o+u]=r[l+u]}}var h;(function(P){P[P.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(h||(h={}));class a{constructor(){this.a=[],this.b=1073741824,this.c=1073741824,this.d=0,this.e=0}MarkNextChange(){(this.d>0||this.e>0)&&this.a.push(new y.DiffChange(this.b,this.d,this.c,this.e)),this.d=0,this.e=0,this.b=1073741824,this.c=1073741824}AddOriginalElement(r,l){this.b=Math.min(this.b,r),this.c=Math.min(this.c,l),this.d++}AddModifiedElement(r,l){this.b=Math.min(this.b,r),this.c=Math.min(this.c,l),this.e++}getChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a}getReverseChanges(){return(this.d>0||this.e>0)&&this.MarkNextChange(),this.a.reverse(),this.a}}class c{constructor(r,l,e=null){this.a=e,this.b=r,this.c=l;const[o,n,u]=c.o(r),[s,w,D]=c.o(l);this.d=u&&D,this.e=o,this.f=n,this.g=s,this.h=w,this.k=[],this.m=[]}static n(r){return r.length>0&&typeof r[0]=="string"}static o(r){const l=r.getElements();if(c.n(l)){const e=new Int32Array(l.length);for(let o=0,n=l.length;o<n;o++)e[o]=(0,M.stringHash)(l[o],0);return[l,e,!0]}return l instanceof Int32Array?[[],l,!1]:[[],new Int32Array(l),!1]}p(r,l){return this.f[r]!==this.h[l]?!1:this.d?this.e[r]===this.g[l]:!0}q(r,l){if(!this.p(r,l))return!1;const e=c.r(this.b,r),o=c.r(this.c,l);return e===o}static r(r,l){return typeof r.getStrictElement=="function"?r.getStrictElement(l):null}s(r,l){return this.f[r]!==this.f[l]?!1:this.d?this.e[r]===this.e[l]:!0}u(r,l){return this.h[r]!==this.h[l]?!1:this.d?this.g[r]===this.g[l]:!0}ComputeDiff(r){return this.v(0,this.f.length-1,0,this.h.length-1,r)}v(r,l,e,o,n){const u=[!1];let s=this.w(r,l,e,o,u);return n&&(s=this.z(s)),{quitEarly:u[0],changes:s}}w(r,l,e,o,n){for(n[0]=!1;r<=l&&e<=o&&this.p(r,e);)r++,e++;for(;l>=r&&o>=e&&this.p(l,o);)l--,o--;if(r>l||e>o){let f;return e<=o?(p.Assert(r===l+1,"originalStart should only be one more than originalEnd"),f=[new y.DiffChange(r,0,e,o-e+1)]):r<=l?(p.Assert(e===o+1,"modifiedStart should only be one more than modifiedEnd"),f=[new y.DiffChange(r,l-r+1,e,0)]):(p.Assert(r===l+1,"originalStart should only be one more than originalEnd"),p.Assert(e===o+1,"modifiedStart should only be one more than modifiedEnd"),f=[]),f}const u=[0],s=[0],w=this.y(r,l,e,o,u,s,n),D=u[0],S=s[0];if(w!==null)return w;if(!n[0]){const f=this.w(r,D,e,S,n);let v=[];return n[0]?v=[new y.DiffChange(D+1,l-(D+1)+1,S+1,o-(S+1)+1)]:v=this.w(D+1,l,S+1,o,n),this.H(f,v)}return[new y.DiffChange(r,l-r+1,e,o-e+1)]}x(r,l,e,o,n,u,s,w,D,S,f,v,L,N,E,g,m,b){let B=null,G=null,J=new a,ie=l,le=e,ge=L[0]-g[0]-o,ue=-1073741824,de=this.k.length-1;do{const ce=ge+r;ce===ie||ce<le&&D[ce-1]<D[ce+1]?(f=D[ce+1],N=f-ge-o,f<ue&&J.MarkNextChange(),ue=f,J.AddModifiedElement(f+1,N),ge=ce+1-r):(f=D[ce-1]+1,N=f-ge-o,f<ue&&J.MarkNextChange(),ue=f-1,J.AddOriginalElement(f,N+1),ge=ce-1-r),de>=0&&(D=this.k[de],r=D[0],ie=1,le=D.length-1)}while(--de>=-1);if(B=J.getReverseChanges(),b[0]){let ce=L[0]+1,Se=g[0]+1;if(B!==null&&B.length>0){const Ae=B[B.length-1];ce=Math.max(ce,Ae.getOriginalEnd()),Se=Math.max(Se,Ae.getModifiedEnd())}G=[new y.DiffChange(ce,v-ce+1,Se,E-Se+1)]}else{J=new a,ie=u,le=s,ge=L[0]-g[0]-w,ue=1073741824,de=m?this.m.length-1:this.m.length-2;do{const ce=ge+n;ce===ie||ce<le&&S[ce-1]>=S[ce+1]?(f=S[ce+1]-1,N=f-ge-w,f>ue&&J.MarkNextChange(),ue=f+1,J.AddOriginalElement(f+1,N+1),ge=ce+1-n):(f=S[ce-1],N=f-ge-w,f>ue&&J.MarkNextChange(),ue=f,J.AddModifiedElement(f+1,N+1),ge=ce-1-n),de>=0&&(S=this.m[de],n=S[0],ie=1,le=S.length-1)}while(--de>=-1);G=J.getChanges()}return this.H(B,G)}y(r,l,e,o,n,u,s){let w=0,D=0,S=0,f=0,v=0,L=0;r--,e--,n[0]=0,u[0]=0,this.k=[],this.m=[];const N=l-r+(o-e),E=N+1,g=new Int32Array(E),m=new Int32Array(E),b=o-e,B=l-r,G=r-e,J=l-o,le=(B-b)%2===0;g[b]=r,m[B]=l,s[0]=!1;for(let ge=1;ge<=N/2+1;ge++){let ue=0,de=0;S=this.J(b-ge,ge,b,E),f=this.J(b+ge,ge,b,E);for(let Se=S;Se<=f;Se+=2){Se===S||Se<f&&g[Se-1]<g[Se+1]?w=g[Se+1]:w=g[Se-1]+1,D=w-(Se-b)-G;const Ae=w;for(;w<l&&D<o&&this.p(w+1,D+1);)w++,D++;if(g[Se]=w,w+D>ue+de&&(ue=w,de=D),!le&&Math.abs(Se-B)<=ge-1&&w>=m[Se])return n[0]=w,u[0]=D,Ae<=m[Se]&&1447>0&&ge<=1447+1?this.x(b,S,f,G,B,v,L,J,g,m,w,l,n,D,o,u,le,s):null}const ce=(ue-r+(de-e)-ge)/2;if(this.a!==null&&!this.a(ue,ce))return s[0]=!0,n[0]=ue,u[0]=de,ce>0&&1447>0&&ge<=1447+1?this.x(b,S,f,G,B,v,L,J,g,m,w,l,n,D,o,u,le,s):(r++,e++,[new y.DiffChange(r,l-r+1,e,o-e+1)]);v=this.J(B-ge,ge,B,E),L=this.J(B+ge,ge,B,E);for(let Se=v;Se<=L;Se+=2){Se===v||Se<L&&m[Se-1]>=m[Se+1]?w=m[Se+1]-1:w=m[Se-1],D=w-(Se-B)-J;const Ae=w;for(;w>r&&D>e&&this.p(w,D);)w--,D--;if(m[Se]=w,le&&Math.abs(Se-b)<=ge&&w<=g[Se])return n[0]=w,u[0]=D,Ae>=g[Se]&&1447>0&&ge<=1447+1?this.x(b,S,f,G,B,v,L,J,g,m,w,l,n,D,o,u,le,s):null}if(ge<=1447){let Se=new Int32Array(f-S+2);Se[0]=b-S+1,A.Copy2(g,S,Se,1,f-S+1),this.k.push(Se),Se=new Int32Array(L-v+2),Se[0]=B-v+1,A.Copy2(m,v,Se,1,L-v+1),this.m.push(Se)}}return this.x(b,S,f,G,B,v,L,J,g,m,w,l,n,D,o,u,le,s)}z(r){for(let l=0;l<r.length;l++){const e=r[l],o=l<r.length-1?r[l+1].originalStart:this.f.length,n=l<r.length-1?r[l+1].modifiedStart:this.h.length,u=e.originalLength>0,s=e.modifiedLength>0;for(;e.originalStart+e.originalLength<o&&e.modifiedStart+e.modifiedLength<n&&(!u||this.s(e.originalStart,e.originalStart+e.originalLength))&&(!s||this.u(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const D=this.q(e.originalStart,e.modifiedStart);if(this.q(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!D)break;e.originalStart++,e.modifiedStart++}const w=[null];if(l<r.length-1&&this.I(r[l],r[l+1],w)){r[l]=w[0],r.splice(l+1,1),l--;continue}}for(let l=r.length-1;l>=0;l--){const e=r[l];let o=0,n=0;if(l>0){const f=r[l-1];o=f.originalStart+f.originalLength,n=f.modifiedStart+f.modifiedLength}const u=e.originalLength>0,s=e.modifiedLength>0;let w=0,D=this.G(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let f=1;;f++){const v=e.originalStart-f,L=e.modifiedStart-f;if(v<o||L<n||u&&!this.s(v,v+e.originalLength)||s&&!this.u(L,L+e.modifiedLength))break;const E=(v===o&&L===n?5:0)+this.G(v,e.originalLength,L,e.modifiedLength);E>D&&(D=E,w=f)}e.originalStart-=w,e.modifiedStart-=w;const S=[null];if(l>0&&this.I(r[l-1],r[l],S)){r[l-1]=S[0],r.splice(l,1),l++;continue}}if(this.d)for(let l=1,e=r.length;l<e;l++){const o=r[l-1],n=r[l],u=n.originalStart-o.originalStart-o.originalLength,s=o.originalStart,w=n.originalStart+n.originalLength,D=w-s,S=o.modifiedStart,f=n.modifiedStart+n.modifiedLength,v=f-S;if(u<5&&D<20&&v<20){const L=this.A(s,D,S,v,u);if(L){const[N,E]=L;(N!==o.originalStart+o.originalLength||E!==o.modifiedStart+o.modifiedLength)&&(o.originalLength=N-o.originalStart,o.modifiedLength=E-o.modifiedStart,n.originalStart=N+u,n.modifiedStart=E+u,n.originalLength=w-n.originalStart,n.modifiedLength=f-n.modifiedStart)}}}return r}A(r,l,e,o,n){if(l<n||o<n)return null;const u=r+l-n+1,s=e+o-n+1;let w=0,D=0,S=0;for(let f=r;f<u;f++)for(let v=e;v<s;v++){const L=this.B(f,v,n);L>0&&L>w&&(w=L,D=f,S=v)}return w>0?[D,S]:null}B(r,l,e){let o=0;for(let n=0;n<e;n++){if(!this.p(r+n,l+n))return 0;o+=this.e[r+n].length}return o}C(r){return r<=0||r>=this.f.length-1?!0:this.d&&/^\s*$/.test(this.e[r])}D(r,l){if(this.C(r)||this.C(r-1))return!0;if(l>0){const e=r+l;if(this.C(e-1)||this.C(e))return!0}return!1}E(r){return r<=0||r>=this.h.length-1?!0:this.d&&/^\s*$/.test(this.g[r])}F(r,l){if(this.E(r)||this.E(r-1))return!0;if(l>0){const e=r+l;if(this.E(e-1)||this.E(e))return!0}return!1}G(r,l,e,o){const n=this.D(r,l)?1:0,u=this.F(e,o)?1:0;return n+u}H(r,l){const e=[];if(r.length===0||l.length===0)return l.length>0?l:r;if(this.I(r[r.length-1],l[0],e)){const o=new Array(r.length+l.length-1);return A.Copy(r,0,o,0,r.length-1),o[r.length-1]=e[0],A.Copy(l,1,o,r.length,l.length-1),o}else{const o=new Array(r.length+l.length);return A.Copy(r,0,o,0,r.length),A.Copy(l,0,o,r.length,l.length),o}}I(r,l,e){if(p.Assert(r.originalStart<=l.originalStart,"Left change is not less than or equal to right change"),p.Assert(r.modifiedStart<=l.modifiedStart,"Left change is not less than or equal to right change"),r.originalStart+r.originalLength>=l.originalStart||r.modifiedStart+r.modifiedLength>=l.modifiedStart){const o=r.originalStart;let n=r.originalLength;const u=r.modifiedStart;let s=r.modifiedLength;return r.originalStart+r.originalLength>=l.originalStart&&(n=l.originalStart+l.originalLength-r.originalStart),r.modifiedStart+r.modifiedLength>=l.modifiedStart&&(s=l.modifiedStart+l.modifiedLength-r.modifiedStart),e[0]=new y.DiffChange(o,n,u,s),!0}else return e[0]=null,!1}J(r,l,e,o){if(r>=0&&r<o)return r;const n=e,u=o-e-1,s=l%2===0;if(r<0){const w=n%2===0;return s===w?0:1}else{const w=u%2===0;return s===w?o-1:o-2}}}t.LcsDiff=c}),define(me[33],be([1,0,32,11,17]),function(te,t,y,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.getCodiconAriaLabel=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=void 0;const W="$(",p=new RegExp(`\\$\\(${i.ThemeIcon.iconNameExpression}(?:${i.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${p.source}`,"g");function h(u){return u.replace(A,(s,w)=>w?s:`\\${s}`)}t.escapeIcons=h;const a=new RegExp(`\\\\${p.source}`,"g");function c(u){return u.replace(a,s=>`\\${s}`)}t.markdownEscapeEscapedIcons=c;const P=new RegExp(`(\\s)?(\\\\)?${p.source}(\\s)?`,"g");function r(u){return u.indexOf(W)===-1?u:u.replace(P,(s,w,D,S)=>D?s:w||S||"")}t.stripIcons=r;function l(u){return u?u.replace(/\$\((.*?)\)/g,(s,w)=>` ${w} `).trim():""}t.getCodiconAriaLabel=l;const e=new RegExp(`\\$\\(${i.ThemeIcon.iconNameCharacter}+\\)`,"g");function o(u){e.lastIndex=0;let s="";const w=[];let D=0;for(;;){const S=e.lastIndex,f=e.exec(u),v=u.substring(S,f?.index);if(v.length>0){s+=v;for(let L=0;L<v.length;L++)w.push(D)}if(!f)break;D+=f[0].length}return{text:s,iconOffsets:w}}t.parseLabelWithIcons=o;function n(u,s,w=!1){const{text:D,iconOffsets:S}=s;if(!S||S.length===0)return(0,y.matchesFuzzy)(u,D,w);const f=(0,M.ltrim)(D," "),v=D.length-f.length,L=(0,y.matchesFuzzy)(u,f,w);if(L)for(const N of L){const E=S[N.start+v]+v;N.start+=E,N.end+=E}return L}t.matchesFuzzyIconAware=n}),define(me[113],be([1,0,13,11]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=void 0;class i{constructor(){this.b="",this.c=0}reset(l){return this.b=l,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(l){const e=l.charCodeAt(0),o=this.b.charCodeAt(this.c);return e-o}value(){return this.b[this.c]}}t.StringIterator=i;class W{constructor(l=!0){this.e=l}reset(l){return this.b=l,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let l=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(l)this.c++;else break;else l=!1;return this}cmp(l){return this.e?(0,M.compareSubstring)(l,this.b,0,l.length,this.c,this.d):(0,M.compareSubstringIgnoreCase)(l,this.b,0,l.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}t.ConfigKeysIterator=W;class p{constructor(l=!0,e=!0){this.f=l,this.g=e}reset(l){this.d=0,this.e=0,this.b=l,this.c=l.length;for(let e=l.length-1;e>=0;e--,this.c--){const o=this.b.charCodeAt(e);if(!(o===47||this.f&&o===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let l=!0;for(;this.e<this.c;this.e++){const e=this.b.charCodeAt(this.e);if(e===47||this.f&&e===92)if(l)this.d++;else break;else l=!1}return this}cmp(l){return this.g?(0,M.compareSubstring)(l,this.b,0,l.length,this.d,this.e):(0,M.compareSubstringIgnoreCase)(l,this.b,0,l.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}t.PathIterator=p;var A;(function(r){r[r.Scheme=1]="Scheme",r[r.Authority=2]="Authority",r[r.Path=3]="Path",r[r.Query=4]="Query",r[r.Fragment=5]="Fragment"})(A||(A={}));class h{constructor(l,e){this.f=l,this.g=e,this.d=[],this.e=0}reset(l){return this.c=l,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new p(!1,!this.f(l)),this.b.reset(l.path),this.b.value()&&this.d.push(3)),this.g(l)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(l){if(this.d[this.e]===1)return(0,M.compareIgnoreCase)(l,this.c.scheme);if(this.d[this.e]===2)return(0,M.compareIgnoreCase)(l,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(l);if(this.d[this.e]===4)return(0,M.compare)(l,this.c.query);if(this.d[this.e]===5)return(0,M.compare)(l,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}t.UriIterator=h;class a{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const l=this.right;return this.right=l.left,l.left=this,this.updateHeight(),l.updateHeight(),l}rotateRight(){const l=this.left;return this.left=l.right,l.right=this,this.updateHeight(),l.updateHeight(),l}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var c;(function(r){r[r.Left=-1]="Left",r[r.Mid=0]="Mid",r[r.Right=1]="Right"})(c||(c={}));class P{static forUris(l=()=>!1,e=()=>!1){return new P(new h(l,e))}static forPaths(l=!1){return new P(new p(void 0,!l))}static forStrings(){return new P(new i)}static forConfigKeys(){return new P(new W)}constructor(l){this.b=l}clear(){this.c=void 0}fill(l,e){if(e){const o=e.slice(0);(0,y.shuffle)(o);for(const n of o)this.set(n,l)}else{const o=l.slice(0);(0,y.shuffle)(o);for(const n of o)this.set(n[0],n[1])}}set(l,e){const o=this.b.reset(l);let n;this.c||(this.c=new a,this.c.segment=o.value());const u=[];for(n=this.c;;){const w=o.cmp(n.segment);if(w>0)n.left||(n.left=new a,n.left.segment=o.value()),u.push([-1,n]),n=n.left;else if(w<0)n.right||(n.right=new a,n.right.segment=o.value()),u.push([1,n]),n=n.right;else if(o.hasNext())o.next(),n.mid||(n.mid=new a,n.mid.segment=o.value()),u.push([0,n]),n=n.mid;else break}const s=n.value;n.value=e,n.key=l;for(let w=u.length-1;w>=0;w--){const D=u[w][1];D.updateHeight();const S=D.balanceFactor();if(S<-1||S>1){const f=u[w][0],v=u[w+1][0];if(f===1&&v===1)u[w][1]=D.rotateLeft();else if(f===-1&&v===-1)u[w][1]=D.rotateRight();else if(f===1&&v===-1)D.right=u[w+1][1]=u[w+1][1].rotateRight(),u[w][1]=D.rotateLeft();else if(f===-1&&v===1)D.left=u[w+1][1]=u[w+1][1].rotateLeft(),u[w][1]=D.rotateRight();else throw new Error;if(w>0)switch(u[w-1][0]){case-1:u[w-1][1].left=u[w][1];break;case 1:u[w-1][1].right=u[w][1];break;case 0:u[w-1][1].mid=u[w][1];break}else this.c=u[0][1]}}return s}get(l){return this.d(l)?.value}d(l){const e=this.b.reset(l);let o=this.c;for(;o;){const n=e.cmp(o.segment);if(n>0)o=o.left;else if(n<0)o=o.right;else if(e.hasNext())e.next(),o=o.mid;else break}return o}has(l){const e=this.d(l);return!(e?.value===void 0&&e?.mid===void 0)}delete(l){return this.e(l,!1)}deleteSuperstr(l){return this.e(l,!0)}e(l,e){const o=this.b.reset(l),n=[];let u=this.c;for(;u;){const s=o.cmp(u.segment);if(s>0)n.push([-1,u]),u=u.left;else if(s<0)n.push([1,u]),u=u.right;else if(o.hasNext())o.next(),n.push([0,u]),u=u.mid;else break}if(u){if(e?(u.left=void 0,u.mid=void 0,u.right=void 0,u.height=1):(u.key=void 0,u.value=void 0),!u.mid&&!u.value)if(u.left&&u.right){const s=this.f(u.right);if(s.key){const{key:w,value:D,segment:S}=s;this.e(s.key,!1),u.key=w,u.value=D,u.segment=S}}else{const s=u.left??u.right;if(n.length>0){const[w,D]=n[n.length-1];switch(w){case-1:D.left=s;break;case 0:D.mid=s;break;case 1:D.right=s;break}}else this.c=s}for(let s=n.length-1;s>=0;s--){const w=n[s][1];w.updateHeight();const D=w.balanceFactor();if(D>1?(w.right.balanceFactor()>=0||(w.right=w.right.rotateRight()),n[s][1]=w.rotateLeft()):D<-1&&(w.left.balanceFactor()<=0||(w.left=w.left.rotateLeft()),n[s][1]=w.rotateRight()),s>0)switch(n[s-1][0]){case-1:n[s-1][1].left=n[s][1];break;case 1:n[s-1][1].right=n[s][1];break;case 0:n[s-1][1].mid=n[s][1];break}else this.c=n[0][1]}}}f(l){for(;l.left;)l=l.left;return l}findSubstr(l){const e=this.b.reset(l);let o=this.c,n;for(;o;){const u=e.cmp(o.segment);if(u>0)o=o.left;else if(u<0)o=o.right;else if(e.hasNext())e.next(),n=o.value||n,o=o.mid;else break}return o&&o.value||n}findSuperstr(l){return this.g(l,!1)}g(l,e){const o=this.b.reset(l);let n=this.c;for(;n;){const u=o.cmp(n.segment);if(u>0)n=n.left;else if(u<0)n=n.right;else if(o.hasNext())o.next(),n=n.mid;else return n.mid?this.h(n.mid):e?n.value:void 0}}hasElementOrSubtree(l){return this.g(l,!0)!==void 0}forEach(l){for(const[e,o]of this)l(o,e)}*[Symbol.iterator](){yield*this.h(this.c)}h(l){const e=[];return this.j(l,e),e[Symbol.iterator]()}j(l,e){l&&(l.left&&this.j(l.left,e),l.value&&e.push([l.key,l.value]),l.mid&&this.j(l.mid,e),l.right&&this.j(l.right,e))}_isBalanced(){const l=e=>{if(!e)return!0;const o=e.balanceFactor();return o<-1||o>1?!1:l(e.left)&&l(e.right)};return l(this.c)}}t.TernarySearchTree=P}),define(me[15],be([1,0,22,5]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const i=/^\w[\w\d+.-]*$/,W=/^\//,p=/^\/\//;function A(L,N){if(!L.scheme&&N)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${L.authority}", path: "${L.path}", query: "${L.query}", fragment: "${L.fragment}"}`);if(L.scheme&&!i.test(L.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(L.path){if(L.authority){if(!W.test(L.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(p.test(L.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function h(L,N){return!L&&!N?"file":L}function a(L,N){switch(L){case"https":case"http":case"file":N?N[0]!==P&&(N=P+N):N=P;break}return N}const c="",P="/",r=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class l{static isUri(N){return N instanceof l?!0:N?typeof N.authority=="string"&&typeof N.fragment=="string"&&typeof N.path=="string"&&typeof N.query=="string"&&typeof N.scheme=="string"&&typeof N.fsPath=="string"&&typeof N.with=="function"&&typeof N.toString=="function":!1}constructor(N,E,g,m,b,B=!1){typeof N=="object"?(this.scheme=N.scheme||c,this.authority=N.authority||c,this.path=N.path||c,this.query=N.query||c,this.fragment=N.fragment||c):(this.scheme=h(N,B),this.authority=E||c,this.path=a(this.scheme,g||c),this.query=m||c,this.fragment=b||c,A(this,B))}get fsPath(){return w(this,!1)}with(N){if(!N)return this;let{scheme:E,authority:g,path:m,query:b,fragment:B}=N;return E===void 0?E=this.scheme:E===null&&(E=c),g===void 0?g=this.authority:g===null&&(g=c),m===void 0?m=this.path:m===null&&(m=c),b===void 0?b=this.query:b===null&&(b=c),B===void 0?B=this.fragment:B===null&&(B=c),E===this.scheme&&g===this.authority&&m===this.path&&b===this.query&&B===this.fragment?this:new o(E,g,m,b,B)}static parse(N,E=!1){const g=r.exec(N);return g?new o(g[2]||c,v(g[4]||c),v(g[5]||c),v(g[7]||c),v(g[9]||c),E):new o(c,c,c,c,c)}static file(N){let E=c;if(M.isWindows&&(N=N.replace(/\\/g,P)),N[0]===P&&N[1]===P){const g=N.indexOf(P,2);g===-1?(E=N.substring(2),N=P):(E=N.substring(2,g),N=N.substring(g)||P)}return new o("file",E,N,c,c)}static from(N){const E=new o(N.scheme,N.authority,N.path,N.query,N.fragment);return A(E,!0),E}static joinPath(N,...E){if(!N.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return M.isWindows&&N.scheme==="file"?g=l.file(y.win32.join(w(N,!0),...E)).path:g=y.posix.join(N.path,...E),N.with({path:g})}toString(N=!1){return D(this,N)}toJSON(){return this}static revive(N){if(N){if(N instanceof l)return N;{const E=new o(N);return E._formatted=N.external,E._fsPath=N._sep===e?N.fsPath:null,E}}else return N}}t.URI=l;const e=M.isWindows?1:void 0;class o extends l{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=w(this,!1)),this._fsPath}toString(N=!1){return N?D(this,!0):(this._formatted||(this._formatted=D(this,!1)),this._formatted)}toJSON(){const N={$mid:1};return this._fsPath&&(N.fsPath=this._fsPath,N._sep=e),this._formatted&&(N.external=this._formatted),this.path&&(N.path=this.path),this.scheme&&(N.scheme=this.scheme),this.authority&&(N.authority=this.authority),this.query&&(N.query=this.query),this.fragment&&(N.fragment=this.fragment),N}}const n={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function u(L,N,E){let g,m=-1;for(let b=0;b<L.length;b++){const B=L.charCodeAt(b);if(B>=97&&B<=122||B>=65&&B<=90||B>=48&&B<=57||B===45||B===46||B===95||B===126||N&&B===47||E&&B===91||E&&B===93||E&&B===58)m!==-1&&(g+=encodeURIComponent(L.substring(m,b)),m=-1),g!==void 0&&(g+=L.charAt(b));else{g===void 0&&(g=L.substr(0,b));const G=n[B];G!==void 0?(m!==-1&&(g+=encodeURIComponent(L.substring(m,b)),m=-1),g+=G):m===-1&&(m=b)}}return m!==-1&&(g+=encodeURIComponent(L.substring(m))),g!==void 0?g:L}function s(L){let N;for(let E=0;E<L.length;E++){const g=L.charCodeAt(E);g===35||g===63?(N===void 0&&(N=L.substr(0,E)),N+=n[g]):N!==void 0&&(N+=L[E])}return N!==void 0?N:L}function w(L,N){let E;return L.authority&&L.path.length>1&&L.scheme==="file"?E=`//${L.authority}${L.path}`:L.path.charCodeAt(0)===47&&(L.path.charCodeAt(1)>=65&&L.path.charCodeAt(1)<=90||L.path.charCodeAt(1)>=97&&L.path.charCodeAt(1)<=122)&&L.path.charCodeAt(2)===58?N?E=L.path.substr(1):E=L.path[1].toLowerCase()+L.path.substr(2):E=L.path,M.isWindows&&(E=E.replace(/\//g,"\\")),E}t.uriToFsPath=w;function D(L,N){const E=N?s:u;let g="",{scheme:m,authority:b,path:B,query:G,fragment:J}=L;if(m&&(g+=m,g+=":"),(b||m==="file")&&(g+=P,g+=P),b){let ie=b.indexOf("@");if(ie!==-1){const le=b.substr(0,ie);b=b.substr(ie+1),ie=le.lastIndexOf(":"),ie===-1?g+=E(le,!1,!1):(g+=E(le.substr(0,ie),!1,!1),g+=":",g+=E(le.substr(ie+1),!1,!0)),g+="@"}b=b.toLowerCase(),ie=b.lastIndexOf(":"),ie===-1?g+=E(b,!1,!0):(g+=E(b.substr(0,ie),!1,!0),g+=b.substr(ie))}if(B){if(B.length>=3&&B.charCodeAt(0)===47&&B.charCodeAt(2)===58){const ie=B.charCodeAt(1);ie>=65&&ie<=90&&(B=`/${String.fromCharCode(ie+32)}:${B.substr(3)}`)}else if(B.length>=2&&B.charCodeAt(1)===58){const ie=B.charCodeAt(0);ie>=65&&ie<=90&&(B=`${String.fromCharCode(ie+32)}:${B.substr(2)}`)}g+=E(B,!0,!1)}return G&&(g+="?",g+=E(G,!1,!1)),J&&(g+="#",g+=N?J:u(J,!1,!1)),g}function S(L){try{return decodeURIComponent(L)}catch{return L.length>3?L.substr(0,3)+S(L.substr(3)):L}}const f=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function v(L){return L.match(f)?L.replace(f,N=>S(N)):L}}),define(me[50],be([1,0,30,11,15]),function(te,t,y,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function W(a){return JSON.stringify(a,A)}t.stringify=W;function p(a){let c=JSON.parse(a);return c=h(c),c}t.parse=p;function A(a,c){return c instanceof RegExp?{$mid:2,source:c.source,flags:(0,M.regExpFlags)(c)}:c}function h(a,c=0){if(!a||c>200)return a;if(typeof a=="object"){switch(a.$mid){case 1:return i.URI.revive(a);case 2:return new RegExp(a.source,a.flags);case 16:return new Date(a.source)}if(a instanceof y.VSBuffer||a instanceof Uint8Array)return a;if(Array.isArray(a))for(let P=0;P<a.length;++P)a[P]=h(a[P],c+1);else for(const P in a)Object.hasOwnProperty.call(a,P)&&(a[P]=h(a[P],c+1))}return a}t.revive=h}),define(me[28],be([1,0,7,5,15]),function(te,t,y,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.COI=t.FileAccess=t.nodeModulesAsarUnpackedPath=t.nodeModulesAsarPath=t.nodeModulesPath=t.builtinExtensionsPath=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var W;(function(a){a.inMemory="inmemory",a.vscode="vscode",a.internal="private",a.walkThrough="walkThrough",a.walkThroughSnippet="walkThroughSnippet",a.http="http",a.https="https",a.file="file",a.mailto="mailto",a.untitled="untitled",a.data="data",a.command="command",a.vscodeRemote="vscode-remote",a.vscodeRemoteResource="vscode-remote-resource",a.vscodeUserData="vscode-userdata",a.vscodeCustomEditor="vscode-custom-editor",a.vscodeNotebookCell="vscode-notebook-cell",a.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",a.vscodeNotebookCellOutput="vscode-notebook-cell-output",a.vscodeInteractive="vscode-interactive",a.vscodeInteractiveInput="vscode-interactive-input",a.vscodeSettings="vscode-settings",a.vscodeWorkspaceTrust="vscode-workspace-trust",a.vscodeTerminal="vscode-terminal",a.vscodeInteractiveSesssion="vscode-chat-editor",a.webviewPanel="webview-panel",a.vscodeWebview="vscode-webview",a.extension="extension",a.vscodeFileResource="vscode-file",a.tmp="tmp",a.vsls="vsls",a.vscodeSourceControl="vscode-scm"})(W||(t.Schemas=W={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class p{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${W.vscodeRemoteResource}`}setPreferredWebSchema(c){this.d=c}setDelegate(c){this.e=c}setServerRootPath(c){this.f=`${c}/${W.vscodeRemoteResource}`}set(c,P,r){this.a[c]=P,this.b[c]=r}setConnectionToken(c,P){this.c[c]=P}getPreferredWebSchema(){return this.d}rewrite(c){if(this.e)try{return this.e(c)}catch(n){return y.onUnexpectedError(n),c}const P=c.authority;let r=this.a[P];r&&r.indexOf(":")!==-1&&r.indexOf("[")===-1&&(r=`[${r}]`);const l=this.b[P],e=this.c[P];let o=`path=${encodeURIComponent(c.path)}`;return typeof e=="string"&&(o+=`&${t.connectionTokenQueryName}=${encodeURIComponent(e)}`),i.URI.from({scheme:M.isWeb?this.d:W.vscodeRemoteResource,authority:`${r}:${l}`,path:this.f,query:o})}}t.RemoteAuthorities=new p,t.builtinExtensionsPath="vs/../../extensions",t.nodeModulesPath="vs/../../node_modules",t.nodeModulesAsarPath="vs/../../node_modules.asar",t.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(c){const P=this.b(c,te);return this.uriToBrowserUri(P)}uriToBrowserUri(c){return c.scheme===W.vscodeRemote?t.RemoteAuthorities.rewrite(c):c.scheme===W.file&&(M.isNative||M.isWebWorker&&M.globals.origin===`${W.vscodeFileResource}://${A.a}`)?c.with({scheme:W.vscodeFileResource,authority:c.authority||A.a,query:null,fragment:null}):c}asFileUri(c){const P=this.b(c,te);return this.uriToFileUri(P)}uriToFileUri(c){return c.scheme===W.vscodeFileResource?c.with({scheme:W.file,authority:c.authority!==A.a?c.authority:null,query:null,fragment:null}):c}b(c,P){return i.URI.isUri(c)?c:i.URI.parse(P.toUrl(c))}}A.a="vscode-app",t.FileAccess=new A;var h;(function(a){const c=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);a.CoopAndCoep=Object.freeze(c.get("3"));const P="vscode-coi";function r(e){let o;typeof e=="string"?o=new URL(e).searchParams:e instanceof URL?o=e.searchParams:i.URI.isUri(e)&&(o=new URL(e.toString(!0)).searchParams);const n=o?.get(P);if(n)return c.get(n)}a.getHeadersFromQuery=r;function l(e,o,n){if(!globalThis.crossOriginIsolated)return;const u=o&&n?"3":n?"2":"1";e instanceof URLSearchParams?e.set(P,u):e[P]=u}a.addSearchParam=l})(h||(t.COI=h={}))}),define(me[34],be([1,0,110,28,22,5,11,15]),function(te,t,y,M,i,W,p,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function h(l){return(0,A.uriToFsPath)(l,!0)}t.originalFSPath=h;class a{constructor(e){this.a=e}compare(e,o,n=!1){return e===o?0:(0,p.compare)(this.getComparisonKey(e,n),this.getComparisonKey(o,n))}isEqual(e,o,n=!1){return e===o?!0:!e||!o?!1:this.getComparisonKey(e,n)===this.getComparisonKey(o,n)}getComparisonKey(e,o=!1){return e.with({path:this.a(e)?e.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(e){return this.a(e)}isEqualOrParent(e,o,n=!1){if(e.scheme===o.scheme){if(e.scheme===M.Schemas.file)return y.isEqualOrParent(h(e),h(o),this.a(e))&&e.query===o.query&&(n||e.fragment===o.fragment);if((0,t.isEqualAuthority)(e.authority,o.authority))return y.isEqualOrParent(e.path,o.path,this.a(e),"/")&&e.query===o.query&&(n||e.fragment===o.fragment)}return!1}joinPath(e,...o){return A.URI.joinPath(e,...o)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return i.posix.basename(e.path)}extname(e){return i.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let o;return e.scheme===M.Schemas.file?o=A.URI.file(i.dirname(h(e))).path:(o=i.posix.dirname(e.path),e.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),o="/")),e.with({path:o})}normalizePath(e){if(!e.path.length)return e;let o;return e.scheme===M.Schemas.file?o=A.URI.file(i.normalize(h(e))).path:o=i.posix.normalize(e.path),e.with({path:o})}relativePath(e,o){if(e.scheme!==o.scheme||!(0,t.isEqualAuthority)(e.authority,o.authority))return;if(e.scheme===M.Schemas.file){const s=i.relative(h(e),h(o));return W.isWindows?y.toSlashes(s):s}let n=e.path||"/";const u=o.path||"/";if(this.a(e)){let s=0;for(const w=Math.min(n.length,u.length);s<w&&!(n.charCodeAt(s)!==u.charCodeAt(s)&&n.charAt(s).toLowerCase()!==u.charAt(s).toLowerCase());s++);n=u.substr(0,s)+n.substr(s)}return i.posix.relative(n,u)}resolvePath(e,o){if(e.scheme===M.Schemas.file){const n=A.URI.file(i.resolve(h(e),o));return e.with({authority:n.authority,path:n.path})}return o=y.toPosixPath(o),e.with({path:i.posix.resolve(e.path,o)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,o){return e===o||e!==void 0&&o!==void 0&&(0,p.equalsIgnoreCase)(e,o)}hasTrailingPathSeparator(e,o=i.sep){if(e.scheme===M.Schemas.file){const n=h(e);return n.length>y.getRoot(n).length&&n[n.length-1]===o}else{const n=e.path;return n.length>1&&n.charCodeAt(n.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,o=i.sep){return(0,t.hasTrailingPathSeparator)(e,o)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,o=i.sep){let n=!1;if(e.scheme===M.Schemas.file){const u=h(e);n=u!==void 0&&u.length===y.getRoot(u).length&&u[u.length-1]===o}else{o="/";const u=e.path;n=u.length===1&&u.charCodeAt(u.length-1)===47}return!n&&!(0,t.hasTrailingPathSeparator)(e,o)?e.with({path:e.path+"/"}):e}}t.ExtUri=a,t.extUri=new a(()=>!1),t.extUriBiasedIgnorePathCase=new a(l=>l.scheme===M.Schemas.file?!W.isLinux:!0),t.extUriIgnorePathCase=new a(l=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function c(l,e){const o=[];for(let n=0;n<l.length;n++){const u=e(l[n]);l.some((s,w)=>w===n?!1:(0,t.isEqualOrParent)(u,e(s)))||o.push(l[n])}return o}t.distinctParents=c;var P;(function(l){l.META_DATA_LABEL="label",l.META_DATA_DESCRIPTION="description",l.META_DATA_SIZE="size",l.META_DATA_MIME="mime";function e(o){const n=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(w=>{const[D,S]=w.split(":");D&&S&&n.set(D,S)});const s=o.path.substring(0,o.path.indexOf(";"));return s&&n.set(l.META_DATA_MIME,s),n}l.parseMetaData=e})(P||(t.DataUri=P={}));function r(l,e,o){if(e){let n=l.path;return n&&n[0]!==i.posix.sep&&(n=i.posix.sep+n),l.with({scheme:o,authority:e,path:n})}return l.with({scheme:o})}t.toLocalResource=r}),define(me[9],be([1,0,27,7,3,2,34,5,46]),function(te,t,y,M,i,W,p,A,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function a(x){return!!x&&typeof x.then=="function"}t.isThenable=a;function c(x){const I=new y.CancellationTokenSource,d=x(I.token),R=new Promise((_,Z)=>{const k=I.token.onCancellationRequested(()=>{k.dispose(),I.dispose(),Z(new M.CancellationError)});Promise.resolve(d).then(T=>{k.dispose(),I.dispose(),_(T)},T=>{k.dispose(),I.dispose(),Z(T)})});return new class{cancel(){I.cancel()}then(_,Z){return R.then(_,Z)}catch(_){return this.then(void 0,_)}finally(_){return R.finally(_)}}}t.createCancelablePromise=c;function P(x,I,d){return new Promise((R,_)=>{const Z=I.onCancellationRequested(()=>{Z.dispose(),R(d)});x.then(R,_).finally(()=>Z.dispose())})}t.raceCancellation=P;function r(x,I){return new Promise((d,R)=>{const _=I.onCancellationRequested(()=>{_.dispose(),R(new M.CancellationError)});x.then(d,R).finally(()=>_.dispose())})}t.raceCancellationError=r;async function l(x){let I=-1;const d=x.map((R,_)=>R.then(Z=>(I=_,Z)));try{return await Promise.race(d)}finally{x.forEach((R,_)=>{_!==I&&R.cancel()})}}t.raceCancellablePromises=l;function e(x,I,d){let R;const _=setTimeout(()=>{R?.(void 0),d?.()},I);return Promise.race([x.finally(()=>clearTimeout(_)),new Promise(Z=>R=Z)])}t.raceTimeout=e;function o(x){return new Promise((I,d)=>{const R=x();a(R)?R.then(I,d):I(R)})}t.asPromise=o;class n{constructor(){this.a=null,this.b=null,this.d=null}queue(I){if(this.a){if(this.d=I,!this.b){const d=()=>{this.b=null;const R=this.queue(this.d);return this.d=null,R};this.b=new Promise(R=>{this.a.then(d,d).then(R)})}return new Promise((d,R)=>{this.b.then(d,R)})}return this.a=I(),new Promise((d,R)=>{this.a.then(_=>{this.a=null,d(_)},_=>{this.a=null,R(_)})})}}t.Throttler=n;class u{constructor(){this.a=Promise.resolve(null)}queue(I){return this.a=this.a.then(()=>I(),()=>I())}}t.Sequencer=u;class s{constructor(){this.a=new Map}queue(I,d){const _=(this.a.get(I)??Promise.resolve()).catch(()=>{}).then(d).finally(()=>{this.a.get(I)===_&&this.a.delete(I)});return this.a.set(I,_),_}}t.SequencerByKey=s;const w=(x,I)=>{let d=!0;const R=setTimeout(()=>{d=!1,I()},x);return{isTriggered:()=>d,dispose:()=>{clearTimeout(R),d=!1}}},D=x=>{let I=!0;return queueMicrotask(()=>{I&&(I=!1,x())}),{isTriggered:()=>I,dispose:()=>{I=!1}}};class S{constructor(I){this.defaultDelay=I,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(I,d=this.defaultDelay){this.g=I,this.h(),this.b||(this.b=new Promise((_,Z)=>{this.d=_,this.f=Z}).then(()=>{if(this.b=null,this.d=null,this.g){const _=this.g;return this.g=null,_()}}));const R=()=>{this.a=null,this.d?.(null)};return this.a=d===h.MicrotaskDelay?D(R):w(d,R),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new M.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}t.Delayer=S;class f{constructor(I){this.a=new S(I),this.b=new n}trigger(I,d){return this.a.trigger(()=>this.b.queue(I),d)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}t.ThrottledDelayer=f;class v{constructor(){this.a=!1,this.b=new Promise((I,d)=>{this.d=I})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}t.Barrier=v;class L extends v{constructor(I){super(),this.f=setTimeout(()=>this.open(),I)}open(){clearTimeout(this.f),super.open()}}t.AutoOpenBarrier=L;function N(x,I){return I?new Promise((d,R)=>{const _=setTimeout(()=>{Z.dispose(),d()},x),Z=I.onCancellationRequested(()=>{clearTimeout(_),Z.dispose(),R(new M.CancellationError)})}):c(d=>N(x,d))}t.timeout=N;function E(x,I=0){const d=setTimeout(x,I);return(0,W.toDisposable)(()=>clearTimeout(d))}t.disposableTimeout=E;function g(x){const I=[];let d=0;const R=x.length;function _(){return d<R?x[d++]():null}function Z(k){k!=null&&I.push(k);const T=_();return T?T.then(Z):Promise.resolve(I)}return Promise.resolve(null).then(Z)}t.sequence=g;function m(x,I=R=>!!R,d=null){let R=0;const _=x.length,Z=()=>{if(R>=_)return Promise.resolve(d);const k=x[R++];return Promise.resolve(k()).then(H=>I(H)?Promise.resolve(H):Z())};return Z()}t.first=m;function b(x,I=R=>!!R,d=null){if(x.length===0)return Promise.resolve(d);let R=x.length;const _=()=>{R=-1;for(const Z of x)Z.cancel?.()};return new Promise((Z,k)=>{for(const T of x)T.then(H=>{--R>=0&&I(H)?(_(),Z(H)):R===0&&Z(d)}).catch(H=>{--R>=0&&(_(),k(H))})})}t.firstParallel=b;class B{constructor(I){this.a=0,this.d=I,this.f=[],this.b=0,this.g=new i.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(I){return this.a++,new Promise((d,R)=>{this.f.push({factory:I,c:d,e:R}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const I=this.f.shift();this.b++;const d=I.factory();d.then(I.c,I.e),d.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}t.Limiter=B;class G extends B{constructor(){super(1)}}t.Queue=G;class J{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const I=new ne;return this.b.add(I),I.p}d(){for(const[,I]of this.a)if(I.size>0)return!1;return!0}queueFor(I,d=p.extUri){const R=d.getComparisonKey(I);let _=this.a.get(R);return _||(_=new G,i.Event.once(_.onDrained)(()=>{_?.dispose(),this.a.delete(R),this.f()}),this.a.set(R,_)),_}f(){this.d()&&this.g()}g(){for(const I of this.b)I.complete();this.b.clear()}dispose(){for(const[,I]of this.a)I.dispose();this.a.clear(),this.g()}}t.ResourceQueue=J;class ie{constructor(I,d){this.a=-1,typeof I=="function"&&typeof d=="number"&&this.setIfNotSet(I,d)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(I,d){this.cancel(),this.a=setTimeout(()=>{this.a=-1,I()},d)}setIfNotSet(I,d){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,I()},d))}}t.TimeoutTimer=ie;class le{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(I,d){this.cancel(),this.a=setInterval(()=>{I()},d)}}t.IntervalTimer=le;class ge{constructor(I,d){this.b=-1,this.a=I,this.d=d,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(I=this.d){this.cancel(),this.b=setTimeout(this.f,I)}get delay(){return this.d}set delay(I){this.d=I}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}t.RunOnceScheduler=ge;class ue{constructor(I,d){d%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${d}ms is not a multiple of 1000ms.`),this.a=I,this.b=d,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(I=this.b){I%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${I}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(I/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}t.ProcessTimeRunOnceScheduler=ue;class de extends ge{constructor(I,d){super(I,d),this.j=[]}work(I){this.j.push(I),this.isScheduled()||this.schedule()}h(){const I=this.j;this.j=[],this.a?.(I)}dispose(){this.j=[],super.dispose()}}t.RunOnceWorker=de;class ce extends W.Disposable{constructor(I,d){super(),this.g=I,this.h=d,this.a=[],this.b=this.B(new W.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(I){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+I.length>this.g.maxBufferedWork)return!1}else if(this.pending+I.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const d of I)this.a.push(d);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new ge(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}t.ThrottledWorker=ce,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=x=>{(0,A.setTimeout0)(()=>{if(I)return;const d=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,d-Date.now())}}))});let I=!1;return{dispose(){I||(I=!0)}}}:t.runWhenIdle=(x,I)=>{const d=requestIdleCallback(x,typeof I=="number"?{timeout:I}:void 0);let R=!1;return{dispose(){R||(R=!0,cancelIdleCallback(d))}}}}();class Se{constructor(I){this.d=!1,this.a=()=>{try{this.f=I()}catch(d){this.g=d}finally{this.d=!0}},this.b=(0,t.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}t.IdleValue=Se;async function Ae(x,I,d){let R;for(let _=0;_<d;_++)try{return await x()}catch(Z){R=Z,await N(I)}throw R}t.retry=Ae;class Be{hasPending(I){return this.a?typeof I=="number"?this.a.taskId===I:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(I,d,R){return this.a={taskId:I,cancel:()=>R?.(),promise:d},d.then(()=>this.d(I),()=>this.d(I)),d}d(I){this.a&&I===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const I=this.b;this.b=void 0,I.run().then(I.promiseResolve,I.promiseReject)}}setNext(I){if(this.b)this.b.run=I;else{let d,R;const _=new Promise((Z,k)=>{d=Z,R=k});this.b={run:I,promise:_,promiseResolve:d,promiseReject:R}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}t.TaskSequentializer=Be;class re{constructor(I,d=()=>Date.now()){this.d=I,this.f=d,this.a=0,this.b=0}increment(){const I=this.f();return I-this.a>this.d&&(this.a=I,this.b=0),this.b++,this.b}}t.IntervalCounter=re;class ne{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((I,d)=>{this.a=I,this.b=d})}complete(I){return new Promise(d=>{this.a(I),this.f=!0,d()})}error(I){return new Promise(d=>{this.b(I),this.d=!0,d()})}cancel(){new Promise(I=>{this.b(new M.CancellationError),this.d=!0,I()})}}t.DeferredPromise=ne;var Q;(function(x){async function I(R){let _;const Z=await Promise.all(R.map(k=>k.then(T=>T,T=>{_||(_=T)})));if(typeof _<"u")throw _;return Z}x.settled=I;function d(R){return new Promise(async(_,Z)=>{try{await R(_,Z)}catch(k){Z(k)}})}x.withAsyncBody=d})(Q||(t.Promises=Q={}));var oe;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(oe||(oe={}));class j{static fromArray(I){return new j(d=>{d.emitMany(I)})}static fromPromise(I){return new j(async d=>{d.emitMany(await I)})}static fromPromises(I){return new j(async d=>{await Promise.all(I.map(async R=>d.emitOne(await R)))})}static merge(I){return new j(async d=>{await Promise.all(I.map(async R=>{for await(const _ of R)d.emitOne(_)}))})}constructor(I){this.a=0,this.b=[],this.d=null,this.f=new i.Emitter,queueMicrotask(async()=>{const d={emitOne:R=>this.g(R),emitMany:R=>this.h(R),reject:R=>this.k(R)};try{await Promise.resolve(I(d)),this.j()}catch(R){this.k(R)}finally{d.emitOne=void 0,d.emitMany=void 0,d.reject=void 0}})}[Symbol.asyncIterator](){let I=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(I<this.b.length)return{done:!1,value:this.b[I++]};if(this.a===1)return{done:!0,value:void 0};await i.Event.toPromise(this.f.event)}while(!0)}}}static map(I,d){return new j(async R=>{for await(const _ of I)R.emitOne(d(_))})}map(I){return j.map(this,I)}static filter(I,d){return new j(async R=>{for await(const _ of I)d(_)&&R.emitOne(_)})}filter(I){return j.filter(this,I)}static coalesce(I){return j.filter(I,d=>!!d)}coalesce(){return j.coalesce(this)}static async toPromise(I){const d=[];for await(const R of I)d.push(R);return d}toPromise(){return j.toPromise(this)}g(I){this.a===0&&(this.b.push(I),this.f.fire())}h(I){this.a===0&&(this.b=this.b.concat(I),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(I){this.a===0&&(this.a=2,this.d=I,this.f.fire())}}t.AsyncIterableObject=j,j.EMPTY=j.fromArray([]);class V extends j{constructor(I,d){super(d),this.l=I}cancel(){this.l.cancel()}}t.CancelableAsyncIterableObject=V;function F(x){const I=new y.CancellationTokenSource,d=x(I.token);return new V(I,async R=>{const _=I.token.onCancellationRequested(()=>{_.dispose(),I.dispose(),R.reject(new M.CancellationError)});try{for await(const Z of d){if(I.token.isCancellationRequested)return;R.emitOne(Z)}_.dispose(),I.dispose()}catch(Z){_.dispose(),I.dispose(),R.reject(Z)}})}t.createCancelableAsyncIterable=F}),define(me[4],be([1,0,18,108,14,21,9,7,3,114,2,28,5,6,15]),function(te,t,y,M,i,W,p,A,h,a,c,P,r,l,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.basicMarkupHtmlTags=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCssValueWithDefault=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.setVisibility=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.isEventLike=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function o(X){for(;X.firstChild;)X.firstChild.remove()}t.clearNode=o;function n(X){return X?.isConnected??!1}t.isInDOM=n;class u{constructor(Y,fe,ke,Le){this.f=Y,this.g=fe,this.d=ke,this.j=Le||!1,this.f.addEventListener(this.g,this.d,this.j)}dispose(){this.d&&(this.f.removeEventListener(this.g,this.d,this.j),this.f=null,this.d=null)}}function s(X,Y,fe,ke){return new u(X,Y,fe,ke)}t.addDisposableListener=s;function w(X){return function(Y){return X(new W.StandardMouseEvent(Y))}}function D(X){return function(Y){return X(new i.StandardKeyboardEvent(Y))}}const S=function(Y,fe,ke,Le){let _e=ke;return fe==="click"||fe==="mousedown"?_e=w(ke):(fe==="keydown"||fe==="keypress"||fe==="keyup")&&(_e=D(ke)),s(Y,fe,_e,Le)};t.addStandardDisposableListener=S;const f=function(Y,fe,ke){const Le=w(fe);return L(Y,Le,ke)};t.addStandardDisposableGenericMouseDownListener=f;const v=function(Y,fe,ke){const Le=w(fe);return E(Y,Le,ke)};t.addStandardDisposableGenericMouseUpListener=v;function L(X,Y,fe){return s(X,r.isIOS&&M.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,Y,fe)}t.addDisposableGenericMouseDownListener=L;function N(X,Y,fe){return s(X,r.isIOS&&M.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,Y,fe)}t.addDisposableGenericMouseMoveListener=N;function E(X,Y,fe){return s(X,r.isIOS&&M.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,Y,fe)}t.addDisposableGenericMouseUpListener=E;class g{constructor(Y,fe=0){this.d=Y,this.priority=fe,this.f=!1}dispose(){this.f=!0}execute(){if(!this.f)try{this.d()}catch(Y){(0,A.onUnexpectedError)(Y)}}static sort(Y,fe){return fe.priority-Y.priority}}(function(){let X=[],Y=null,fe=!1,ke=!1;const Le=()=>{for(fe=!1,Y=X,X=[],ke=!0;Y.length>0;)Y.sort(g.sort),Y.shift().execute();ke=!1};t.scheduleAtNextAnimationFrame=(_e,xe=0)=>{const Ye=new g(_e,xe);return X.push(Ye),fe||(fe=!0,requestAnimationFrame(Le)),Ye},t.runAtThisOrScheduleAtNextAnimationFrame=(_e,xe)=>{if(ke){const Ye=new g(_e,xe);return Y.push(Ye),Ye}else return(0,t.scheduleAtNextAnimationFrame)(_e,xe)}})();function m(X){return(0,t.scheduleAtNextAnimationFrame)(X,1e4)}t.measure=m;function b(X){return(0,t.scheduleAtNextAnimationFrame)(X,-1e4)}t.modify=b;const B=8,G=function(X,Y){return Y};class J extends c.Disposable{constructor(Y,fe,ke,Le=G,_e=B){super();let xe=null,Ye=0;const nt=this.B(new p.TimeoutTimer),Ke=()=>{Ye=new Date().getTime(),ke(xe),xe=null};this.B(s(Y,fe,vt=>{xe=Le(xe,vt);const Et=new Date().getTime()-Ye;Et>=_e?(nt.cancel(),Ke()):nt.setIfNotSet(Ke,_e-Et)}))}}function ie(X,Y,fe,ke,Le){return new J(X,Y,fe,ke,Le)}t.addDisposableThrottledListener=ie;function le(X){return document.defaultView.getComputedStyle(X,null)}t.getComputedStyle=le;function ge(X){if(X!==document.body)return new de(X.clientWidth,X.clientHeight);if(r.isIOS&&window.visualViewport)return new de(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new de(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new de(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new de(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=ge;class ue{static d(Y,fe){return parseFloat(fe)||0}static f(Y,fe,ke){const Le=le(Y),_e=Le?Le.getPropertyValue(fe):"0";return ue.d(Y,_e)}static getBorderLeftWidth(Y){return ue.f(Y,"border-left-width","borderLeftWidth")}static getBorderRightWidth(Y){return ue.f(Y,"border-right-width","borderRightWidth")}static getBorderTopWidth(Y){return ue.f(Y,"border-top-width","borderTopWidth")}static getBorderBottomWidth(Y){return ue.f(Y,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(Y){return ue.f(Y,"padding-left","paddingLeft")}static getPaddingRight(Y){return ue.f(Y,"padding-right","paddingRight")}static getPaddingTop(Y){return ue.f(Y,"padding-top","paddingTop")}static getPaddingBottom(Y){return ue.f(Y,"padding-bottom","paddingBottom")}static getMarginLeft(Y){return ue.f(Y,"margin-left","marginLeft")}static getMarginTop(Y){return ue.f(Y,"margin-top","marginTop")}static getMarginRight(Y){return ue.f(Y,"margin-right","marginRight")}static getMarginBottom(Y){return ue.f(Y,"margin-bottom","marginBottom")}}class de{constructor(Y,fe){this.width=Y,this.height=fe}with(Y=this.width,fe=this.height){return Y!==this.width||fe!==this.height?new de(Y,fe):this}static is(Y){return typeof Y=="object"&&typeof Y.height=="number"&&typeof Y.width=="number"}static lift(Y){return Y instanceof de?Y:new de(Y.width,Y.height)}static equals(Y,fe){return Y===fe?!0:!Y||!fe?!1:Y.width===fe.width&&Y.height===fe.height}}t.Dimension=de,de.None=new de(0,0);function ce(X){let Y=X.offsetParent,fe=X.offsetTop,ke=X.offsetLeft;for(;(X=X.parentNode)!==null&&X!==document.body&&X!==document.documentElement;){fe-=X.scrollTop;const Le=H(X)?null:le(X);Le&&(ke-=Le.direction!=="rtl"?X.scrollLeft:-X.scrollLeft),X===Y&&(ke+=ue.getBorderLeftWidth(X),fe+=ue.getBorderTopWidth(X),fe+=X.offsetTop,ke+=X.offsetLeft,Y=X.offsetParent)}return{left:ke,top:fe}}t.getTopLeftOffset=ce;function Se(X,Y,fe){typeof Y=="number"&&(X.style.width=`${Y}px`),typeof fe=="number"&&(X.style.height=`${fe}px`)}t.size=Se;function Ae(X,Y,fe,ke,Le,_e="absolute"){typeof Y=="number"&&(X.style.top=`${Y}px`),typeof fe=="number"&&(X.style.right=`${fe}px`),typeof ke=="number"&&(X.style.bottom=`${ke}px`),typeof Le=="number"&&(X.style.left=`${Le}px`),X.style.position=_e}t.position=Ae;function Be(X){const Y=X.getBoundingClientRect();return{left:Y.left+window.scrollX,top:Y.top+window.scrollY,width:Y.width,height:Y.height}}t.getDomNodePagePosition=Be;function re(X){let Y=X,fe=1;do{const ke=le(Y).zoom;ke!=null&&ke!=="1"&&(fe*=ke),Y=Y.parentElement}while(Y!==null&&Y!==document.documentElement);return fe}t.getDomNodeZoomLevel=re;function ne(X){const Y=ue.getMarginLeft(X)+ue.getMarginRight(X);return X.offsetWidth+Y}t.getTotalWidth=ne;function Q(X){const Y=ue.getBorderLeftWidth(X)+ue.getBorderRightWidth(X),fe=ue.getPaddingLeft(X)+ue.getPaddingRight(X);return X.offsetWidth-Y-fe}t.getContentWidth=Q;function oe(X){const Y=ue.getMarginLeft(X)+ue.getMarginRight(X);return X.scrollWidth+Y}t.getTotalScrollWidth=oe;function j(X){const Y=ue.getBorderTopWidth(X)+ue.getBorderBottomWidth(X),fe=ue.getPaddingTop(X)+ue.getPaddingBottom(X);return X.offsetHeight-Y-fe}t.getContentHeight=j;function V(X){const Y=ue.getMarginTop(X)+ue.getMarginBottom(X);return X.offsetHeight+Y}t.getTotalHeight=V;function F(X,Y){if(X===null)return 0;const fe=ce(X),ke=ce(Y);return fe.left-ke.left}function x(X,Y){const fe=Y.map(Le=>Math.max(oe(Le),ne(Le))+F(Le,X)||0);return Math.max(...fe)}t.getLargestChildWidth=x;function I(X,Y){for(;X;){if(X===Y)return!0;X=X.parentNode}return!1}t.isAncestor=I;const d="parentFlowToElementId";function R(X,Y){X.dataset[d]=Y.id}t.setParentFlowTo=R;function _(X){const Y=X.dataset[d];return typeof Y=="string"?document.getElementById(Y):null}function Z(X,Y){let fe=X;for(;fe;){if(fe===Y)return!0;if(fe instanceof HTMLElement){const ke=_(fe);if(ke){fe=ke;continue}}fe=fe.parentNode}return!1}t.isAncestorUsingFlowTo=Z;function k(X,Y,fe){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X.classList.contains(Y))return X;if(fe){if(typeof fe=="string"){if(X.classList.contains(fe))return null}else if(X===fe)return null}X=X.parentNode}return null}t.findParentWithClass=k;function T(X,Y,fe){return!!k(X,Y,fe)}t.hasParentWithClass=T;function H(X){return X&&!!X.host&&!!X.mode}t.isShadowRoot=H;function C(X){return!!U(X)}t.isInShadowDOM=C;function U(X){for(;X.parentNode;){if(X===document.body)return null;X=X.parentNode}return H(X)?X:null}t.getShadowRoot=U;function z(){let X=document.activeElement;for(;X?.shadowRoot;)X=X.shadowRoot.activeElement;return X}t.getActiveElement=z;function O(X=document.getElementsByTagName("head")[0],Y){const fe=document.createElement("style");return fe.type="text/css",fe.media="screen",Y?.(fe),X.appendChild(fe),fe}t.createStyleSheet=O;function $(X=document.getElementsByTagName("head")[0]){const Y=document.createElement("meta");return X.appendChild(Y),Y}t.createMetaElement=$;let q=null;function ee(){return q||(q=O()),q}function se(X){return X?.sheet?.rules?X.sheet.rules:X?.sheet?.cssRules?X.sheet.cssRules:[]}function ve(X,Y,fe=ee()){!fe||!Y||fe.sheet.insertRule(X+"{"+Y+"}",0)}t.createCSSRule=ve;function De(X,Y=ee()){if(!Y)return;const fe=se(Y),ke=[];for(let Le=0;Le<fe.length;Le++)fe[Le].selectorText.indexOf(X)!==-1&&ke.push(Le);for(let Le=ke.length-1;Le>=0;Le--)Y.sheet.deleteRule(ke[Le])}t.removeCSSRulesContainingSelector=De;function Ie(X){return typeof HTMLElement=="object"?X instanceof HTMLElement:X&&typeof X=="object"&&X.nodeType===1&&typeof X.nodeName=="string"}t.isHTMLElement=Ie,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:y.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:y.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:y.isWebKit?"webkitAnimationIteration":"animationiteration"};function Fe(X){const Y=X;return!!(Y&&typeof Y.preventDefault=="function"&&typeof Y.stopPropagation=="function")}t.isEventLike=Fe,t.EventHelper={stop:(X,Y)=>(X.preventDefault(),Y&&X.stopPropagation(),X)};function we(X){const Y=[];for(let fe=0;X&&X.nodeType===X.ELEMENT_NODE;fe++)Y[fe]=X.scrollTop,X=X.parentNode;return Y}t.saveParentsScrollTop=we;function Pe(X,Y){for(let fe=0;X&&X.nodeType===X.ELEMENT_NODE;fe++)X.scrollTop!==Y[fe]&&(X.scrollTop=Y[fe]),X=X.parentNode}t.restoreParentsScrollTop=Pe;class Ne extends c.Disposable{static l(Y){const fe=U(Y),ke=fe?fe.activeElement:document.activeElement;return I(ke,Y)}constructor(Y){super(),this.f=this.B(new h.Emitter),this.onDidFocus=this.f.event,this.g=this.B(new h.Emitter),this.onDidBlur=this.g.event;let fe=Ne.l(Y),ke=!1;const Le=()=>{ke=!1,fe||(fe=!0,this.f.fire())},_e=()=>{fe&&(ke=!0,window.setTimeout(()=>{ke&&(ke=!1,fe=!1,this.g.fire())},0))};this.j=()=>{Ne.l(Y)!==fe&&(fe?_e():Le())},this.B(s(Y,t.EventType.FOCUS,Le,!0)),this.B(s(Y,t.EventType.BLUR,_e,!0)),this.B(s(Y,t.EventType.FOCUS_IN,()=>this.j())),this.B(s(Y,t.EventType.FOCUS_OUT,()=>this.j()))}refreshState(){this.j()}}function Ve(X){return new Ne(X)}t.trackFocus=Ve;function ze(X,Y){return X.after(Y),Y}t.after=ze;function We(X,...Y){if(X.append(...Y),Y.length===1&&typeof Y[0]!="string")return Y[0]}t.append=We;function Je(X,Y){return X.insertBefore(Y,X.firstChild),Y}t.prepend=Je;function it(X,...Y){X.innerText="",We(X,...Y)}t.reset=it;const Oe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var je;(function(X){X.HTML="http://www.w3.org/1999/xhtml",X.SVG="http://www.w3.org/2000/svg"})(je||(t.Namespace=je={}));function K(X,Y,fe,...ke){const Le=Oe.exec(Y);if(!Le)throw new Error("Bad use of emmet");const _e=Le[1]||"div";let xe;return X!==je.HTML?xe=document.createElementNS(X,_e):xe=document.createElement(_e),Le[3]&&(xe.id=Le[3]),Le[4]&&(xe.className=Le[4].replace(/\./g," ").trim()),fe&&Object.entries(fe).forEach(([Ye,nt])=>{typeof nt>"u"||(/^on\w+$/.test(Ye)?xe[Ye]=nt:Ye==="selected"?nt&&xe.setAttribute(Ye,"true"):xe.setAttribute(Ye,nt))}),xe.append(...ke),xe}function ae(X,Y,...fe){return K(je.HTML,X,Y,...fe)}t.$=ae,ae.SVG=function(X,Y,...fe){return K(je.SVG,X,Y,...fe)};function pe(X,Y){const fe=[];return X.forEach((ke,Le)=>{Le>0&&(Y instanceof Node?fe.push(Y.cloneNode()):fe.push(document.createTextNode(Y))),fe.push(ke)}),fe}t.join=pe;function ye(X,...Y){X?Ce(...Y):Re(...Y)}t.setVisibility=ye;function Ce(...X){for(const Y of X)Y.style.display="",Y.removeAttribute("aria-hidden")}t.show=Ce;function Re(...X){for(const Y of X)Y.style.display="none",Y.setAttribute("aria-hidden","true")}t.hide=Re;function $e(X,Y){for(;X&&X.nodeType===X.ELEMENT_NODE;){if(X instanceof HTMLElement&&X.hasAttribute(Y))return X;X=X.parentNode}return null}function Ge(X){!X||!X.hasAttribute("tabIndex")||(document.activeElement===X&&$e(X.parentElement,"tabIndex")?.focus(),X.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=Ge;function et(X){return Y=>{Y.preventDefault(),Y.stopPropagation(),X(Y)}}t.finalHandler=et;function Te(){return new Promise(X=>{document.readyState==="complete"||document&&document.body!==null?X(void 0):window.addEventListener("DOMContentLoaded",X,!1)})}t.domContentLoaded=Te;function he(X){const Y=window.devicePixelRatio*X;return Math.max(1,Math.floor(Y))/window.devicePixelRatio}t.computeScreenAwareSize=he;function Ee(X){window.open(X,"_blank","noopener")}t.windowOpenNoOpener=Ee;const Me=780,Ue=640;function Xe(X){const Y=Math.floor(window.screenLeft+window.innerWidth/2-Me/2),fe=Math.floor(window.screenTop+window.innerHeight/2-Ue/2);window.open(X,"_blank",`width=${Me},height=${Ue},top=${fe},left=${Y}`)}t.windowOpenPopup=Xe;function Ze(X,Y=!0){const fe=window.open();return fe?(Y&&(fe.opener=null),fe.location.href=X,!0):!1}t.windowOpenWithSuccess=Ze;function Qe(X){const Y=()=>{X(),fe=(0,t.scheduleAtNextAnimationFrame)(Y)};let fe=(0,t.scheduleAtNextAnimationFrame)(Y);return(0,c.toDisposable)(()=>fe.dispose())}t.animate=Qe,P.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function rt(X){return X?`url('${P.FileAccess.uriToBrowserUri(X).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=rt;function dt(X){return`'${X.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=dt;function bt(X,Y){if(X!==void 0){const fe=X.match(/^\s*var\((.+)\)$/);if(fe){const ke=fe[1].split(",",2);return ke.length===2&&(Y=bt(ke[1].trim(),Y)),`var(${ke[0]}, ${Y})`}return X}return Y}t.asCssValueWithDefault=bt;function Tt(X,Y){let fe;if(e.URI.isUri(X))fe=X.toString(!0);else{const Le=new Blob([X]);fe=URL.createObjectURL(Le),setTimeout(()=>URL.revokeObjectURL(fe))}const ke=document.createElement("a");document.body.appendChild(ke),ke.download=Y,ke.href=fe,ke.click(),setTimeout(()=>document.body.removeChild(ke))}t.triggerDownload=Tt;function Wt(){return new Promise(X=>{const Y=document.createElement("input");document.body.appendChild(Y),Y.type="file",Y.multiple=!0,h.Event.once(h.Event.fromDOMEventEmitter(Y,"input"))(()=>{X((0,l.withNullAsUndefined)(Y.files))}),Y.click(),setTimeout(()=>document.body.removeChild(Y))})}t.triggerUpload=Wt;var pt;(function(X){X[X.DOCUMENT=1]="DOCUMENT",X[X.BROWSER=2]="BROWSER"})(pt||(t.DetectedFullscreenMode=pt={}));function di(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:pt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:pt.BROWSER,guess:!1}:(r.isMacintosh||r.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:pt.BROWSER,guess:!0}:null}t.detectFullscreen=di;function xt(X,Y=!1){const fe=document.createElement("a");return a.addHook("afterSanitizeAttributes",ke=>{for(const Le of["href","src"])if(ke.hasAttribute(Le)){const _e=ke.getAttribute(Le);if(Le==="href"&&_e.startsWith("#"))continue;if(fe.href=_e,!X.includes(fe.protocol.replace(/:$/,""))){if(Y&&Le==="src"&&fe.href.startsWith("data:"))continue;ke.removeAttribute(Le)}}}),(0,c.toDisposable)(()=>{a.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=xt;const fi=[P.Schemas.http,P.Schemas.https,P.Schemas.command];t.basicMarkupHtmlTags=Object.freeze(["a","abbr","b","bdo","blockquote","br","caption","cite","code","col","colgroup","dd","del","details","dfn","div","dl","dt","em","figcaption","figure","h1","h2","h3","h4","h5","h6","hr","i","img","ins","kbd","label","li","mark","ol","p","pre","q","rp","rt","ruby","samp","small","small","source","span","strike","strong","sub","summary","sup","table","tbody","td","tfoot","th","thead","time","tr","tt","u","ul","var","video","wbr"]);const gi=Object.freeze({ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type","start"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1,RETURN_TRUSTED_TYPE:!0});function mi(X,Y){const fe=xt(fi);try{const ke=a.sanitize(Y,gi);X.innerHTML=ke}finally{fe.dispose()}}t.safeInnerHtml=mi;function bi(X){const Y=new Uint16Array(X.length);for(let Le=0;Le<Y.length;Le++)Y[Le]=X.charCodeAt(Le);let fe="";const ke=new Uint8Array(Y.buffer);for(let Le=0;Le<ke.length;Le++)fe+=String.fromCharCode(ke[Le]);return fe}function pi(X){return btoa(bi(X))}t.multibyteAwareBtoa=pi;class ft extends h.Emitter{constructor(){super(),this.s=new c.DisposableStore,this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this.s.add(s(window,"keydown",Y=>{if(Y.defaultPrevented)return;const fe=new i.StandardKeyboardEvent(Y);if(!(fe.keyCode===6&&Y.repeat)){if(Y.altKey&&!this.t.altKey)this.t.lastKeyPressed="alt";else if(Y.ctrlKey&&!this.t.ctrlKey)this.t.lastKeyPressed="ctrl";else if(Y.metaKey&&!this.t.metaKey)this.t.lastKeyPressed="meta";else if(Y.shiftKey&&!this.t.shiftKey)this.t.lastKeyPressed="shift";else if(fe.keyCode!==6)this.t.lastKeyPressed=void 0;else return;this.t.altKey=Y.altKey,this.t.ctrlKey=Y.ctrlKey,this.t.metaKey=Y.metaKey,this.t.shiftKey=Y.shiftKey,this.t.lastKeyPressed&&(this.t.event=Y,this.fire(this.t))}},!0)),this.s.add(s(window,"keyup",Y=>{Y.defaultPrevented||(!Y.altKey&&this.t.altKey?this.t.lastKeyReleased="alt":!Y.ctrlKey&&this.t.ctrlKey?this.t.lastKeyReleased="ctrl":!Y.metaKey&&this.t.metaKey?this.t.lastKeyReleased="meta":!Y.shiftKey&&this.t.shiftKey?this.t.lastKeyReleased="shift":this.t.lastKeyReleased=void 0,this.t.lastKeyPressed!==this.t.lastKeyReleased&&(this.t.lastKeyPressed=void 0),this.t.altKey=Y.altKey,this.t.ctrlKey=Y.ctrlKey,this.t.metaKey=Y.metaKey,this.t.shiftKey=Y.shiftKey,this.t.lastKeyReleased&&(this.t.event=Y,this.fire(this.t)))},!0)),this.s.add(s(document.body,"mousedown",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(s(document.body,"mouseup",()=>{this.t.lastKeyPressed=void 0},!0)),this.s.add(s(document.body,"mousemove",Y=>{Y.buttons&&(this.t.lastKeyPressed=void 0)},!0)),this.s.add(s(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this.t}get isModifierPressed(){return this.t.altKey||this.t.ctrlKey||this.t.metaKey||this.t.shiftKey}resetKeyStatus(){this.v(),this.fire(this.t)}v(){this.t={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return ft.u||(ft.u=new ft),ft.u}dispose(){super.dispose(),this.s.dispose()}}t.ModifierKeyEmitter=ft;function vi(X){const Y=document.cookie.match("(^|[^;]+)\\s*"+X+"\\s*=\\s*([^;]+)");return Y?Y.pop():void 0}t.getCookieValue=vi;class wi extends c.Disposable{constructor(Y,fe){super(),this.j=Y,this.l=fe,this.f=0,this.g=0,this.m()}m(){this.B(s(this.j,t.EventType.DRAG_ENTER,Y=>{this.f++,this.g=Y.timeStamp,this.l.onDragEnter(Y)})),this.B(s(this.j,t.EventType.DRAG_OVER,Y=>{Y.preventDefault(),this.l.onDragOver?.(Y,Y.timeStamp-this.g)})),this.B(s(this.j,t.EventType.DRAG_LEAVE,Y=>{this.f--,this.f===0&&(this.g=0,this.l.onDragLeave(Y))})),this.B(s(this.j,t.EventType.DRAG_END,Y=>{this.f=0,this.g=0,this.l.onDragEnd(Y)})),this.B(s(this.j,t.EventType.DROP,Y=>{this.f=0,this.g=0,this.l.onDrop(Y)}))}}t.DragAndDropObserver=wi;const Di=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function yi(X,...Y){let fe,ke;Array.isArray(Y[0])?(fe={},ke=Y[0]):(fe=Y[0]||{},ke=Y[1]);const Le=Di.exec(X);if(!Le||!Le.groups)throw new Error("Bad use of h");const _e=Le.groups.tag||"div",xe=document.createElement(_e);Le.groups.id&&(xe.id=Le.groups.id);const Ye=[];if(Le.groups.class)for(const Ke of Le.groups.class.split("."))Ke!==""&&Ye.push(Ke);if(fe.className!==void 0)for(const Ke of fe.className.split("."))Ke!==""&&Ye.push(Ke);Ye.length>0&&(xe.className=Ye.join(" "));const nt={};if(Le.groups.name&&(nt[Le.groups.name]=xe),ke)for(const Ke of ke)Ke instanceof HTMLElement?xe.appendChild(Ke):typeof Ke=="string"?xe.append(Ke):(Object.assign(nt,Ke),xe.appendChild(Ke.root));for(const[Ke,vt]of Object.entries(fe))if(Ke!=="className")if(Ke==="style")for(const[Et,Lt]of Object.entries(vt))xe.style.setProperty($t(Et),typeof Lt=="number"?Lt+"px":""+Lt);else Ke==="tabIndex"?xe.tabIndex=vt:xe.setAttribute($t(Ke),vt.toString());return nt.root=xe,nt}t.h=yi;function $t(X){return X.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(me[51],be([1,0,4,2,106]),function(te,t,y,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class W extends M.Disposable{constructor(h,a){super(),this.B((0,y.addDisposableListener)(h,"dragover",c=>{c.preventDefault(),this.a||(this.a=setTimeout(()=>{a(),this.a=null},800))})),["dragleave","drop","dragend"].forEach(c=>{this.B((0,y.addDisposableListener)(h,c,()=>{this.b()}))})}b(){this.a&&(clearTimeout(this.a),this.a=null)}dispose(){super.dispose(),this.b()}}t.DelayedDragHandler=W,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:i.Mimes.text};function p(A,h,a,c,P){const r=document.createElement("div");r.className=a,r.textContent=h,P&&(r.style.color=P),c&&(r.style.background=c),A.dataTransfer&&(document.body.appendChild(r),A.dataTransfer.setDragImage(r,-10,-10),setTimeout(()=>document.body.removeChild(r),0))}t.applyDragImage=p}),define(me[52],be([1,0,4]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function M(r,l={}){const e=W(l);return e.textContent=r,e}t.renderText=M;function i(r,l={}){const e=W(l);return h(e,a(r,!!l.renderCodeSegments),l.actionHandler,l.renderCodeSegments),e}t.renderFormattedText=i;function W(r){const l=r.inline?"span":"div",e=document.createElement(l);return r.className&&(e.className=r.className),e}t.createElement=W;class p{constructor(l){this.b=l,this.c=0}eos(){return this.c>=this.b.length}next(){const l=this.peek();return this.advance(),l}peek(){return this.b[this.c]}advance(){this.c++}}var A;(function(r){r[r.Invalid=0]="Invalid",r[r.Root=1]="Root",r[r.Text=2]="Text",r[r.Bold=3]="Bold",r[r.Italics=4]="Italics",r[r.Action=5]="Action",r[r.ActionClose=6]="ActionClose",r[r.Code=7]="Code",r[r.NewLine=8]="NewLine"})(A||(A={}));function h(r,l,e,o){let n;if(l.type===2)n=document.createTextNode(l.content||"");else if(l.type===3)n=document.createElement("b");else if(l.type===4)n=document.createElement("i");else if(l.type===7&&o)n=document.createElement("code");else if(l.type===5&&e){const u=document.createElement("a");e.disposables.add(y.addStandardDisposableListener(u,"click",s=>{e.callback(String(l.index),s)})),n=u}else l.type===8?n=document.createElement("br"):l.type===1&&(n=r);n&&r!==n&&r.appendChild(n),n&&Array.isArray(l.children)&&l.children.forEach(u=>{h(n,u,e,o)})}function a(r,l){const e={type:1,children:[]};let o=0,n=e;const u=[],s=new p(r);for(;!s.eos();){let w=s.next();const D=w==="\\"&&P(s.peek(),l)!==0;if(D&&(w=s.next()),!D&&c(w,l)&&w===s.peek()){s.advance(),n.type===2&&(n=u.pop());const S=P(w,l);if(n.type===S||n.type===5&&S===6)n=u.pop();else{const f={type:S,children:[]};S===5&&(f.index=o,o++),n.children.push(f),u.push(n),n=f}}else if(w===`
`)n.type===2&&(n=u.pop()),n.children.push({type:8});else if(n.type!==2){const S={type:2,content:w};n.children.push(S),u.push(n),n=S}else n.content+=w}return n.type===2&&(n=u.pop()),u.length,e}function c(r,l){return P(r,l)!==0}function P(r,l){switch(r){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return l?7:0;default:return 0}}}),define(me[53],be([1,0,4,2]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class i{constructor(){this.a=new M.DisposableStore,this.b=null,this.c=null}dispose(){this.stopMonitoring(!1),this.a.dispose()}stopMonitoring(p,A){if(!this.isMonitoring())return;this.a.clear(),this.b=null;const h=this.c;this.c=null,p&&h&&h(A)}isMonitoring(){return!!this.b}startMonitoring(p,A,h,a,c){this.isMonitoring()&&this.stopMonitoring(!1),this.b=a,this.c=c;let P=p;try{p.setPointerCapture(A),this.a.add((0,M.toDisposable)(()=>{try{p.releasePointerCapture(A)}catch{}}))}catch{P=window}this.a.add(y.addDisposableListener(P,y.EventType.POINTER_MOVE,r=>{if(r.buttons!==h){this.stopMonitoring(!0);return}r.preventDefault(),this.b(r)})),this.a.add(y.addDisposableListener(P,y.EventType.POINTER_UP,r=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=i});var qe=this&&this.__decorate||function(te,t,y,M){var i=arguments.length,W=i<3?t:M===null?M=Object.getOwnPropertyDescriptor(t,y):M,p;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")W=Reflect.decorate(te,t,y,M);else for(var A=te.length-1;A>=0;A--)(p=te[A])&&(W=(i<3?p(W):i>3?p(t,y,W):p(t,y))||W);return i>3&&W&&Object.defineProperty(t,y,W),W};define(me[23],be([1,0,4,13,25,2,43]),function(te,t,y,M,i,W,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var A;(function(a){a.Tap="-monaco-gesturetap",a.Change="-monaco-gesturechange",a.Start="-monaco-gesturestart",a.End="-monaco-gesturesend",a.Contextmenu="-monaco-gesturecontextmenu"})(A||(t.EventType=A={}));class h extends W.Disposable{constructor(){super(),this.f=!1,this.g=new p.LinkedList,this.h=new p.LinkedList,this.k={},this.j=null,this.l=0,this.B(y.addDisposableListener(document,"touchstart",c=>this.n(c),{passive:!1})),this.B(y.addDisposableListener(document,"touchend",c=>this.p(c))),this.B(y.addDisposableListener(document,"touchmove",c=>this.v(c),{passive:!1}))}static addTarget(c){if(!h.isTouchDevice())return W.Disposable.None;h.b||(h.b=new h);const P=h.b.g.push(c);return(0,W.toDisposable)(P)}static ignoreTarget(c){if(!h.isTouchDevice())return W.Disposable.None;h.b||(h.b=new h);const P=h.b.h.push(c);return(0,W.toDisposable)(P)}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.j&&(this.j.dispose(),this.j=null),super.dispose()}n(c){const P=Date.now();this.j&&(this.j.dispose(),this.j=null);for(let r=0,l=c.targetTouches.length;r<l;r++){const e=c.targetTouches.item(r);this.k[e.identifier]={id:e.identifier,initialTarget:e.target,initialTimeStamp:P,initialPageX:e.pageX,initialPageY:e.pageY,rollingTimestamps:[P],rollingPageX:[e.pageX],rollingPageY:[e.pageY]};const o=this.r(A.Start,e.target);o.pageX=e.pageX,o.pageY=e.pageY,this.s(o)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}p(c){const P=Date.now(),r=Object.keys(this.k).length;for(let l=0,e=c.changedTouches.length;l<e;l++){const o=c.changedTouches.item(l);if(!this.k.hasOwnProperty(String(o.identifier))){console.warn("move of an UNKNOWN touch",o);continue}const n=this.k[o.identifier],u=Date.now()-n.initialTimeStamp;if(u<h.c&&Math.abs(n.initialPageX-M.tail(n.rollingPageX))<30&&Math.abs(n.initialPageY-M.tail(n.rollingPageY))<30){const s=this.r(A.Tap,n.initialTarget);s.pageX=M.tail(n.rollingPageX),s.pageY=M.tail(n.rollingPageY),this.s(s)}else if(u>=h.c&&Math.abs(n.initialPageX-M.tail(n.rollingPageX))<30&&Math.abs(n.initialPageY-M.tail(n.rollingPageY))<30){const s=this.r(A.Contextmenu,n.initialTarget);s.pageX=M.tail(n.rollingPageX),s.pageY=M.tail(n.rollingPageY),this.s(s)}else if(r===1){const s=M.tail(n.rollingPageX),w=M.tail(n.rollingPageY),D=M.tail(n.rollingTimestamps)-n.rollingTimestamps[0],S=s-n.rollingPageX[0],f=w-n.rollingPageY[0],v=[...this.g].filter(L=>n.initialTarget instanceof Node&&L.contains(n.initialTarget));this.u(v,P,Math.abs(S)/D,S>0?1:-1,s,Math.abs(f)/D,f>0?1:-1,w)}this.s(this.r(A.End,n.initialTarget)),delete this.k[o.identifier]}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}r(c,P){const r=document.createEvent("CustomEvent");return r.initEvent(c,!1,!0),r.initialTarget=P,r.tapCount=0,r}s(c){if(c.type===A.Tap){const P=new Date().getTime();let r=0;P-this.l>h.m?r=1:r=2,this.l=P,c.tapCount=r}else(c.type===A.Change||c.type===A.Contextmenu)&&(this.l=0);if(c.initialTarget instanceof Node){for(const P of this.h)if(P.contains(c.initialTarget))return;for(const P of this.g)P.contains(c.initialTarget)&&(P.dispatchEvent(c),this.f=!0)}}u(c,P,r,l,e,o,n,u){this.j=y.scheduleAtNextAnimationFrame(()=>{const s=Date.now(),w=s-P;let D=0,S=0,f=!0;r+=h.a*w,o+=h.a*w,r>0&&(f=!1,D=l*r*w),o>0&&(f=!1,S=n*o*w);const v=this.r(A.Change);v.translationX=D,v.translationY=S,c.forEach(L=>L.dispatchEvent(v)),f||this.u(c,s,r,l,e+D,o,n,u+S)})}v(c){const P=Date.now();for(let r=0,l=c.changedTouches.length;r<l;r++){const e=c.changedTouches.item(r);if(!this.k.hasOwnProperty(String(e.identifier))){console.warn("end of an UNKNOWN touch",e);continue}const o=this.k[e.identifier],n=this.r(A.Change,o.initialTarget);n.translationX=e.pageX-M.tail(o.rollingPageX),n.translationY=e.pageY-M.tail(o.rollingPageY),n.pageX=e.pageX,n.pageY=e.pageY,this.s(n),o.rollingPageX.length>3&&(o.rollingPageX.shift(),o.rollingPageY.shift(),o.rollingTimestamps.shift()),o.rollingPageX.push(e.pageX),o.rollingPageY.push(e.pageY),o.rollingTimestamps.push(P)}this.f&&(c.preventDefault(),c.stopPropagation(),this.f=!1)}}t.Gesture=h,h.a=-.005,h.c=700,h.m=400,qe([i.memoize],h,"isTouchDevice",null)}),define(me[54],be([1,0,4,5,83]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const i=2e4;let W,p,A,h,a;function c(e){W=document.createElement("div"),W.className="monaco-aria-container";const o=()=>{const u=document.createElement("div");return u.className="monaco-alert",u.setAttribute("role","alert"),u.setAttribute("aria-atomic","true"),W.appendChild(u),u};p=o(),A=o();const n=()=>{const u=document.createElement("div");return u.className="monaco-status",u.setAttribute("role","complementary"),u.setAttribute("aria-live","polite"),u.setAttribute("aria-atomic","true"),W.appendChild(u),u};h=n(),a=n(),e.appendChild(W)}t.setARIAContainer=c;function P(e){W&&(p.textContent!==e?(y.clearNode(A),l(p,e)):(y.clearNode(p),l(A,e)))}t.alert=P;function r(e){W&&(M.isMacintosh?P(e):h.textContent!==e?(y.clearNode(a),l(h,e)):(y.clearNode(h),l(a,e)))}t.status=r;function l(e,o){y.clearNode(e),o.length>i&&(o=o.substr(0,i)),e.textContent=o,e.style.visibility="hidden",e.style.visibility="visible"}}),define(me[115],be([1,0,4,17]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const i=new RegExp(`(\\\\)?\\$\\((${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?)\\)`,"g");function W(A){const h=new Array;let a,c=0,P=0;for(;(a=i.exec(A))!==null;){P=a.index||0,c<P&&h.push(A.substring(c,P)),c=(a.index||0)+a[0].length;const[,r,l]=a;h.push(r?`$(${l})`:p({id:l}))}return c<A.length&&h.push(A.substring(c)),h}t.renderLabelWithIcons=W;function p(A){const h=y.$("span");return h.classList.add(...M.ThemeIcon.asClassNameArray(A)),h}t.renderIcon=p}),define(me[116],be([1,0,4]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function M(W){try{W.parentElement?.removeChild(W)}catch{}}class i{constructor(p){this.d=p,this.a=new Map,this.b=new Set,this.c=!1}alloc(p){let A=this.h(p).pop(),h=!1;if(A)h=this.b.has(A.domNode),h&&this.b.delete(A.domNode);else{const a=(0,y.$)(".monaco-list-row"),P=this.i(p).renderTemplate(a);A={domNode:a,templateId:p,templateData:P}}return{row:A,isReusingConnectedDomNode:h}}release(p){p&&this.f(p)}transact(p){if(this.c)throw new Error("Already in transaction");this.c=!0;try{p()}finally{for(const A of this.b)this.g(A);this.b.clear(),this.c=!1}}f(p){const{domNode:A,templateId:h}=p;A&&(this.c?this.b.add(A):this.g(A)),this.h(h).push(p)}g(p){p.classList.remove("scrolling"),M(p)}h(p){let A=this.a.get(p);return A||(A=[],this.a.set(p,A)),A}dispose(){this.a.forEach((p,A)=>{for(const h of p)this.i(A).disposeTemplate(h.templateData),h.templateData=null}),this.a.clear(),this.b.clear()}i(p){const A=this.d.get(p);if(!A)throw new Error(`No renderer found for ${p}`);return A}}t.RowCache=i}),define(me[117],be([1,0,9,2]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class i extends M.Disposable{constructor(p,A,h){super(),this.a=p,this.b=A,this.c=h,this.f=null,this.j=!1,this.i=!1,this.g=!1,this.h=!1,this.k=this.B(new y.TimeoutTimer)}setVisibility(p){this.a!==p&&(this.a=p,this.m())}setShouldBeVisible(p){this.g=p,this.m()}l(){return this.a===2?!1:this.a===3?!0:this.g}m(){const p=this.l();this.h!==p&&(this.h=p,this.ensureVisibility())}setIsNeeded(p){this.i!==p&&(this.i=p,this.ensureVisibility())}setDomNode(p){this.f=p,this.f.setClassName(this.c),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this.i){this.p(!1);return}this.h?this.n():this.p(!0)}n(){this.j||(this.j=!0,this.k.setIfNotSet(()=>{this.f?.setClassName(this.b)},0))}p(p){this.k.cancel(),this.j&&(this.j=!1,this.f?.setClassName(this.c+(p?" fade":"")))}}t.ScrollbarVisibilityController=i}),define(me[118],be([1,0,4,23,13,3,2,5]),function(te,t,y,M,i,W,p,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class h extends p.Disposable{constructor(c,P,r,l){super(),this.f=0,this.b=l||Object.create(null),this.c=[],this.a=document.createElement("select"),this.a.className="monaco-select-box",typeof this.b.ariaLabel=="string"&&this.a.setAttribute("aria-label",this.b.ariaLabel),typeof this.b.ariaDescription=="string"&&this.a.setAttribute("aria-description",this.b.ariaDescription),this.g=this.B(new W.Emitter),this.h=r,this.i(),this.setOptions(c,P)}i(){this.B(M.Gesture.addTarget(this.a)),[M.EventType.Tap].forEach(c=>{this.B(y.addDisposableListener(this.a,c,P=>{this.a.focus()}))}),this.B(y.addStandardDisposableListener(this.a,"click",c=>{y.EventHelper.stop(c,!0)})),this.B(y.addStandardDisposableListener(this.a,"change",c=>{this.a.title=c.target.value,this.g.fire({index:c.target.selectedIndex,selected:c.target.value})})),this.B(y.addStandardDisposableListener(this.a,"keydown",c=>{let P=!1;A.isMacintosh?(c.keyCode===18||c.keyCode===16||c.keyCode===10)&&(P=!0):(c.keyCode===18&&c.altKey||c.keyCode===10||c.keyCode===3)&&(P=!0),P&&c.stopPropagation()}))}get onDidSelect(){return this.g.event}setOptions(c,P){(!this.c||!i.equals(this.c,c))&&(this.c=c,this.a.options.length=0,this.c.forEach((r,l)=>{this.a.add(this.j(r.text,l,r.isDisabled))})),P!==void 0&&this.select(P)}select(c){this.c.length===0?this.f=0:c>=0&&c<this.c.length?this.f=c:c>this.c.length-1?this.select(this.c.length-1):this.f<0&&(this.f=0),this.a.selectedIndex=this.f,this.f<this.c.length&&typeof this.c[this.f].text=="string"?this.a.title=this.c[this.f].text:this.a.title=""}setAriaLabel(c){this.b.ariaLabel=c,this.a.setAttribute("aria-label",c)}focus(){this.a&&(this.a.tabIndex=0,this.a.focus())}blur(){this.a&&(this.a.tabIndex=-1,this.a.blur())}setFocusable(c){this.a.tabIndex=c?0:-1}render(c){c.classList.add("select-container"),c.appendChild(this.a),this.setOptions(this.c,this.f),this.applyStyles()}style(c){this.h=c,this.applyStyles()}applyStyles(){this.a&&(this.a.style.backgroundColor=this.h.selectBackground??"",this.a.style.color=this.h.selectForeground??"",this.a.style.borderColor=this.h.selectBorder??"")}j(c,P,r){const l=document.createElement("option");return l.value=c,l.text=c,l.disabled=!!r,l}}t.SelectBoxNative=h}),define(me[55],be([1,0,24,13,9,46,112,3,26]),function(te,t,y,M,i,W,p,A,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function a(l){return typeof l=="object"&&"visibility"in l&&"data"in l}t.isFilterResult=a;function c(l){switch(l){case!0:return 1;case!1:return 0;default:return l}}t.getVisibleState=c;function P(l){return typeof l.collapsible=="boolean"}class r{constructor(e,o,n,u={}){this.o=e,this.p=o,this.rootRef=[],this.d=new A.EventBufferer,this.f=new A.Emitter,this.onDidChangeCollapseState=this.d.wrapEvent(this.f.event),this.g=new A.Emitter,this.onDidChangeRenderNodeCount=this.d.wrapEvent(this.g.event),this.l=new A.Emitter,this.onDidSplice=this.l.event,this.m=new i.Delayer(W.MicrotaskDelay),this.h=typeof u.collapseByDefault>"u"?!1:u.collapseByDefault,this.j=u.filter,this.k=typeof u.autoExpandSingleChildren>"u"?!1:u.autoExpandSingleChildren,this.c={parent:void 0,element:n,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(e,o,n=h.Iterable.empty(),u={}){if(e.length===0)throw new y.TreeError(this.o,"Invalid tree location");u.diffIdentityProvider?this.q(u.diffIdentityProvider,e,o,n,u):this.s(e,o,n,u)}q(e,o,n,u=h.Iterable.empty(),s,w=s.diffDepth??0){const{parentNode:D}=this.G(o);if(!D.lastDiffIds)return this.s(o,n,u,s);const S=[...u],f=o[o.length-1],v=new p.LcsDiff({getElements:()=>D.lastDiffIds},{getElements:()=>[...D.children.slice(0,f),...S,...D.children.slice(f+n)].map(m=>e.getId(m.element).toString())}).ComputeDiff(!1);if(v.quitEarly)return D.lastDiffIds=void 0,this.s(o,n,S,s);const L=o.slice(0,-1),N=(m,b,B)=>{if(w>0)for(let G=0;G<B;G++)m--,b--,this.q(e,[...L,m,0],Number.MAX_SAFE_INTEGER,S[b].children,s,w-1)};let E=Math.min(D.children.length,f+n),g=S.length;for(const m of v.changes.sort((b,B)=>B.originalStart-b.originalStart))N(E,g,E-(m.originalStart+m.originalLength)),E=m.originalStart,g=m.modifiedStart-f,this.s([...L,E],m.originalLength,h.Iterable.slice(S,g,g+m.modifiedLength),s);N(E,g,E)}s(e,o,n=h.Iterable.empty(),{onDidCreateNode:u,onDidDeleteNode:s,diffIdentityProvider:w}){const{parentNode:D,listIndex:S,revealed:f,visible:v}=this.G(e),L=[],N=h.Iterable.map(n,ue=>this.w(ue,D,D.visible?1:0,f,L,u)),E=e[e.length-1],g=D.children.length>0;let m=0;for(let ue=E;ue>=0&&ue<D.children.length;ue--){const de=D.children[ue];if(de.visible){m=de.visibleChildIndex;break}}const b=[];let B=0,G=0;for(const ue of N)b.push(ue),G+=ue.renderNodeCount,ue.visible&&(ue.visibleChildIndex=m+B++);const J=(0,M.splice)(D.children,E,o,b);w?D.lastDiffIds?(0,M.splice)(D.lastDiffIds,E,o,b.map(ue=>w.getId(ue.element).toString())):D.lastDiffIds=D.children.map(ue=>w.getId(ue.element).toString()):D.lastDiffIds=void 0;let ie=0;for(const ue of J)ue.visible&&ie++;if(ie!==0)for(let ue=E+b.length;ue<D.children.length;ue++){const de=D.children[ue];de.visible&&(de.visibleChildIndex-=ie)}if(D.visibleChildrenCount+=B-ie,f&&v){const ue=J.reduce((de,ce)=>de+(ce.visible?ce.renderNodeCount:0),0);this.B(D,G-ue),this.p.splice(S,ue,L)}if(J.length>0&&s){const ue=de=>{s(de),de.children.forEach(ue)};J.forEach(ue)}this.l.fire({insertedNodes:b,deletedNodes:J});const le=D.children.length>0;g!==le&&this.setCollapsible(e.slice(0,-1),le);let ge=D;for(;ge;){if(ge.visibility===2){this.m.trigger(()=>this.refilter());break}ge=ge.parent}}rerender(e){if(e.length===0)throw new y.TreeError(this.o,"Invalid tree location");const{node:o,listIndex:n,revealed:u}=this.F(e);o.visible&&u&&this.p.splice(n,1,[o])}updateElementHeight(e,o){if(e.length===0)throw new y.TreeError(this.o,"Invalid tree location");const{listIndex:n}=this.F(e);this.p.updateElementHeight(n,o)}has(e){return this.D(e)}getListIndex(e){const{listIndex:o,visible:n,revealed:u}=this.F(e);return n&&u?o:-1}getListRenderCount(e){return this.E(e).renderNodeCount}isCollapsible(e){return this.E(e).collapsible}setCollapsible(e,o){const n=this.E(e);typeof o>"u"&&(o=!n.collapsible);const u={collapsible:o};return this.d.bufferEvents(()=>this.t(e,u))}isCollapsed(e){return this.E(e).collapsed}setCollapsed(e,o,n){const u=this.E(e);typeof o>"u"&&(o=!u.collapsed);const s={collapsed:o,recursive:n||!1};return this.d.bufferEvents(()=>this.t(e,s))}t(e,o){const{node:n,listIndex:u,revealed:s}=this.F(e),w=this.u(n,u,s,o);if(n!==this.c&&this.k&&w&&!P(o)&&n.collapsible&&!n.collapsed&&!o.recursive){let D=-1;for(let S=0;S<n.children.length;S++)if(n.children[S].visible)if(D>-1){D=-1;break}else D=S;D>-1&&this.t([...e,D],o)}return w}u(e,o,n,u){const s=this.v(e,u,!1);if(!n||!e.visible||!s)return s;const w=e.renderNodeCount,D=this.x(e),S=w-(o===-1?0:1);return this.p.splice(o+1,S,D.slice(1)),s}v(e,o,n){let u;if(e===this.c?u=!1:(P(o)?(u=e.collapsible!==o.collapsible,e.collapsible=o.collapsible):e.collapsible?(u=e.collapsed!==o.collapsed,e.collapsed=o.collapsed):u=!1,u&&this.f.fire({node:e,deep:n})),!P(o)&&o.recursive)for(const s of e.children)u=this.v(s,o,!0)||u;return u}expandTo(e){this.d.bufferEvents(()=>{let o=this.E(e);for(;o.parent;)o=o.parent,e=e.slice(0,e.length-1),o.collapsed&&this.t(e,{collapsed:!1,recursive:!1})})}refilter(){const e=this.c.renderNodeCount,o=this.z(this.c);this.p.splice(0,e,o),this.m.cancel()}w(e,o,n,u,s,w){const D={parent:o,element:e.element,children:[],depth:o.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof e.collapsible=="boolean"?e.collapsible:typeof e.collapsed<"u",collapsed:typeof e.collapsed>"u"?this.h:e.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},S=this.C(D,n);D.visibility=S,u&&s.push(D);const f=e.children||h.Iterable.empty(),v=u&&S!==0&&!D.collapsed;let L=0,N=1;for(const E of f){const g=this.w(E,D,S,v,s,w);D.children.push(g),N+=g.renderNodeCount,g.visible&&(g.visibleChildIndex=L++)}return D.collapsible=D.collapsible||D.children.length>0,D.visibleChildrenCount=L,D.visible=S===2?L>0:S===1,D.visible?D.collapsed||(D.renderNodeCount=N):(D.renderNodeCount=0,u&&s.pop()),w?.(D),D}x(e){const o=e.renderNodeCount,n=[];return this.y(e,n),this.B(e.parent,n.length-o),n}y(e,o){if(e.visible===!1)return 0;if(o.push(e),e.renderNodeCount=1,!e.collapsed)for(const n of e.children)e.renderNodeCount+=this.y(n,o);return this.g.fire(e),e.renderNodeCount}z(e){const o=e.renderNodeCount,n=[];return this.A(e,e.visible?1:0,n),this.B(e.parent,n.length-o),n}A(e,o,n,u=!0){let s;if(e!==this.c){if(s=this.C(e,o),s===0)return e.visible=!1,e.renderNodeCount=0,!1;u&&n.push(e)}const w=n.length;e.renderNodeCount=e===this.c?0:1;let D=!1;if(!e.collapsed||s!==0){let S=0;for(const f of e.children)D=this.A(f,s,n,u&&!e.collapsed)||D,f.visible&&(f.visibleChildIndex=S++);e.visibleChildrenCount=S}else e.visibleChildrenCount=0;return e!==this.c&&(e.visible=s===2?D:s===1,e.visibility=s),e.visible?e.collapsed||(e.renderNodeCount+=n.length-w):(e.renderNodeCount=0,u&&n.pop()),this.g.fire(e),e.visible}B(e,o){if(o!==0)for(;e;)e.renderNodeCount+=o,this.g.fire(e),e=e.parent}C(e,o){const n=this.j?this.j.filter(e.element,o):1;return typeof n=="boolean"?(e.filterData=void 0,n?1:0):a(n)?(e.filterData=n.data,c(n.visibility)):(e.filterData=void 0,c(n))}D(e,o=this.c){if(!e||e.length===0)return!0;const[n,...u]=e;return n<0||n>o.children.length?!1:this.D(u,o.children[n])}E(e,o=this.c){if(!e||e.length===0)return o;const[n,...u]=e;if(n<0||n>o.children.length)throw new y.TreeError(this.o,"Invalid tree location");return this.E(u,o.children[n])}F(e){if(e.length===0)return{node:this.c,listIndex:-1,revealed:!0,visible:!1};const{parentNode:o,listIndex:n,revealed:u,visible:s}=this.G(e),w=e[e.length-1];if(w<0||w>o.children.length)throw new y.TreeError(this.o,"Invalid tree location");const D=o.children[w];return{node:D,listIndex:n,revealed:u,visible:s&&D.visible}}G(e,o=this.c,n=0,u=!0,s=!0){const[w,...D]=e;if(w<0||w>o.children.length)throw new y.TreeError(this.o,"Invalid tree location");for(let S=0;S<w;S++)n+=o.children[S].renderNodeCount;return u=u&&!o.collapsed,s=s&&o.visible,D.length===0?{parentNode:o,listIndex:n,revealed:u,visible:s}:this.G(D,o.children[w],n+1,u,s)}getNode(e=[]){return this.E(e)}getNodeLocation(e){const o=[];let n=e;for(;n.parent;)o.push(n.parent.children.indexOf(n)),n=n.parent;return o.reverse()}getParentNodeLocation(e){if(e.length!==0)return e.length===1?[]:(0,M.tail2)(e)[0]}getFirstElementChild(e){const o=this.E(e);if(o.children.length!==0)return o.children[0].element}getLastElementAncestor(e=[]){const o=this.E(e);if(o.children.length!==0)return this.H(o)}H(e){return e.children.length===0?e.element:this.H(e.children[e.children.length-1])}}t.IndexTreeModel=r}),define(me[119],be([1,0,55,24,26]),function(te,t,y,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class W{get size(){return this.d.size}constructor(A,h,a={}){this.k=A,this.rootRef=null,this.d=new Map,this.f=new Map,this.c=new y.IndexTreeModel(A,h,null,a),this.onDidSplice=this.c.onDidSplice,this.onDidChangeCollapseState=this.c.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.c.onDidChangeRenderNodeCount,a.sorter&&(this.j={compare(c,P){return a.sorter.compare(c.element,P.element)}}),this.h=a.identityProvider}setChildren(A,h=i.Iterable.empty(),a={}){const c=this.o(A);this.l(c,this.m(h),a)}l(A,h=i.Iterable.empty(),a){const c=new Set,P=new Set,r=e=>{if(e.element===null)return;const o=e;if(c.add(o.element),this.d.set(o.element,o),this.h){const n=this.h.getId(o.element).toString();P.add(n),this.f.set(n,o)}a.onDidCreateNode?.(o)},l=e=>{if(e.element===null)return;const o=e;if(c.has(o.element)||this.d.delete(o.element),this.h){const n=this.h.getId(o.element).toString();P.has(n)||this.f.delete(n)}a.onDidDeleteNode?.(o)};this.c.splice([...A,0],Number.MAX_VALUE,h,{...a,onDidCreateNode:r,onDidDeleteNode:l})}m(A=i.Iterable.empty()){return this.j&&(A=[...A].sort(this.j.compare.bind(this.j))),i.Iterable.map(A,h=>{let a=this.d.get(h.element);if(!a&&this.h){const r=this.h.getId(h.element).toString();a=this.f.get(r)}if(!a){let r;return typeof h.collapsed>"u"?r=void 0:h.collapsed===M.ObjectTreeElementCollapseState.Collapsed||h.collapsed===M.ObjectTreeElementCollapseState.PreserveOrCollapsed?r=!0:h.collapsed===M.ObjectTreeElementCollapseState.Expanded||h.collapsed===M.ObjectTreeElementCollapseState.PreserveOrExpanded?r=!1:r=!!h.collapsed,{...h,children:this.m(h.children),collapsed:r}}const c=typeof h.collapsible=="boolean"?h.collapsible:a.collapsible;let P;return typeof h.collapsed>"u"||h.collapsed===M.ObjectTreeElementCollapseState.PreserveOrCollapsed||h.collapsed===M.ObjectTreeElementCollapseState.PreserveOrExpanded?P=a.collapsed:h.collapsed===M.ObjectTreeElementCollapseState.Collapsed?P=!0:h.collapsed===M.ObjectTreeElementCollapseState.Expanded?P=!1:P=!!h.collapsed,{...h,collapsible:c,collapsed:P,children:this.m(h.children)}})}rerender(A){const h=this.o(A);this.c.rerender(h)}updateElementHeight(A,h){const a=this.o(A);this.c.updateElementHeight(a,h)}resort(A=null,h=!0){if(!this.j)return;const a=this.o(A),c=this.c.getNode(a);this.l(a,this.n(c,h),{})}n(A,h,a=!0){let c=[...A.children];return(h||a)&&(c=c.sort(this.j.compare.bind(this.j))),i.Iterable.map(c,P=>({element:P.element,collapsible:P.collapsible,collapsed:P.collapsed,children:this.n(P,h,!1)}))}getFirstElementChild(A=null){const h=this.o(A);return this.c.getFirstElementChild(h)}getLastElementAncestor(A=null){const h=this.o(A);return this.c.getLastElementAncestor(h)}has(A){return this.d.has(A)}getListIndex(A){const h=this.o(A);return this.c.getListIndex(h)}getListRenderCount(A){const h=this.o(A);return this.c.getListRenderCount(h)}isCollapsible(A){const h=this.o(A);return this.c.isCollapsible(h)}setCollapsible(A,h){const a=this.o(A);return this.c.setCollapsible(a,h)}isCollapsed(A){const h=this.o(A);return this.c.isCollapsed(h)}setCollapsed(A,h,a){const c=this.o(A);return this.c.setCollapsed(c,h,a)}expandTo(A){const h=this.o(A);this.c.expandTo(h)}refilter(){this.c.refilter()}getNode(A=null){if(A===null)return this.c.getNode(this.c.rootRef);const h=this.d.get(A);if(!h)throw new M.TreeError(this.k,`Tree element not found: ${A}`);return h}getNodeLocation(A){return A.element}getParentNodeLocation(A){if(A===null)throw new M.TreeError(this.k,"Invalid getParentNodeLocation call");const h=this.d.get(A);if(!h)throw new M.TreeError(this.k,`Tree element not found: ${A}`);const a=this.c.getNodeLocation(h),c=this.c.getParentNodeLocation(a);return this.c.getNode(c).element}o(A){if(A===null)return[];const h=this.d.get(A);if(!h)throw new M.TreeError(this.k,`Tree element not found: ${A}`);return this.c.getNodeLocation(h)}}t.ObjectTreeModel=W}),define(me[19],be([1,0,4,14,21,23,2]),function(te,t,y,M,i,W,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class A extends p.Disposable{f(a,c){this.B(y.addDisposableListener(a,y.EventType.CLICK,P=>c(new i.StandardMouseEvent(P))))}j(a,c){this.B(y.addDisposableListener(a,y.EventType.MOUSE_DOWN,P=>c(new i.StandardMouseEvent(P))))}k(a,c){this.B(y.addDisposableListener(a,y.EventType.MOUSE_OVER,P=>c(new i.StandardMouseEvent(P))))}m(a,c){this.B(y.addDisposableListener(a,y.EventType.MOUSE_LEAVE,P=>c(new i.StandardMouseEvent(P))))}p(a,c){this.B(y.addDisposableListener(a,y.EventType.KEY_DOWN,P=>c(new M.StandardKeyboardEvent(P))))}u(a,c){this.B(y.addDisposableListener(a,y.EventType.KEY_UP,P=>c(new M.StandardKeyboardEvent(P))))}z(a,c){this.B(y.addDisposableListener(a,y.EventType.INPUT,c))}C(a,c){this.B(y.addDisposableListener(a,y.EventType.BLUR,c))}D(a,c){this.B(y.addDisposableListener(a,y.EventType.FOCUS,c))}F(a,c){this.B(y.addDisposableListener(a,y.EventType.CHANGE,c))}G(a){return W.Gesture.ignoreTarget(a)}}t.Widget=A}),define(me[35],be([1,0,53,19,9,17,4]),function(te,t,y,M,i,W,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class A extends M.Widget{constructor(a){super(),this.a=a.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=a.bgWidth+"px",this.bgDomNode.style.height=a.bgHeight+"px",typeof a.top<"u"&&(this.bgDomNode.style.top="0px"),typeof a.left<"u"&&(this.bgDomNode.style.left="0px"),typeof a.bottom<"u"&&(this.bgDomNode.style.bottom="0px"),typeof a.right<"u"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=a.className,this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(a.icon)),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof a.top<"u"&&(this.domNode.style.top=a.top+"px"),typeof a.left<"u"&&(this.domNode.style.left=a.left+"px"),typeof a.bottom<"u"&&(this.domNode.style.bottom=a.bottom+"px"),typeof a.right<"u"&&(this.domNode.style.right=a.right+"px"),this.g=this.B(new y.GlobalPointerMoveMonitor),this.B(p.addStandardDisposableListener(this.bgDomNode,p.EventType.POINTER_DOWN,c=>this.h(c))),this.B(p.addStandardDisposableListener(this.domNode,p.EventType.POINTER_DOWN,c=>this.h(c))),this.b=this.B(new i.IntervalTimer),this.c=this.B(new i.TimeoutTimer)}h(a){if(!a.target||!(a.target instanceof Element))return;const c=()=>{this.b.cancelAndSet(()=>this.a(),1e3/24)};this.a(),this.b.cancel(),this.c.cancelAndSet(c,200),this.g.startMonitoring(a.target,a.pointerId,a.buttons,P=>{},()=>{this.b.cancel(),this.c.cancel()}),a.preventDefault()}}t.ScrollbarArrow=A}),define(me[56],be([1,0,4,38,53,35,117,19,5]),function(te,t,y,M,i,W,p,A,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const a=140;class c extends A.Widget{constructor(r){super(),this.g=r.lazyRender,this.a=r.host,this.b=r.scrollable,this.c=r.scrollByPage,this.h=r.scrollbarState,this.i=this.B(new p.ScrollbarVisibilityController(r.visibility,"visible scrollbar "+r.extraScrollbarClassName,"invisible scrollbar "+r.extraScrollbarClassName)),this.i.setIsNeeded(this.h.isNeeded()),this.l=this.B(new i.GlobalPointerMoveMonitor),this.n=!0,this.domNode=(0,M.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this.i.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this.B(y.addDisposableListener(this.domNode.domNode,y.EventType.POINTER_DOWN,l=>this.y(l)))}r(r){const l=this.B(new W.ScrollbarArrow(r));this.domNode.domNode.appendChild(l.bgDomNode),this.domNode.domNode.appendChild(l.domNode)}s(r,l,e,o){this.slider=(0,M.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(r),this.slider.setLeft(l),typeof e=="number"&&this.slider.setWidth(e),typeof o=="number"&&this.slider.setHeight(o),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this.B(y.addDisposableListener(this.slider.domNode,y.EventType.POINTER_DOWN,n=>{n.button===0&&(n.preventDefault(),this.I(n))})),this.f(this.slider.domNode,n=>{n.leftButton&&n.stopPropagation()})}t(r){return this.h.setVisibleSize(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}v(r){return this.h.setScrollSize(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}w(r){return this.h.setScrollPosition(r)&&(this.i.setIsNeeded(this.h.isNeeded()),this.n=!0,this.g||this.render()),this.n}beginReveal(){this.i.setShouldBeVisible(!0)}beginHide(){this.i.setShouldBeVisible(!1)}render(){this.n&&(this.n=!1,this.L(this.h.getRectangleLargeSize(),this.h.getRectangleSmallSize()),this.M(this.h.getSliderSize(),this.h.getArrowSize()+this.h.getSliderPosition()))}y(r){r.target===this.domNode.domNode&&this.H(r)}delegatePointerDown(r){const l=this.domNode.domNode.getClientRects()[0].top,e=l+this.h.getSliderPosition(),o=l+this.h.getSliderPosition()+this.h.getSliderSize(),n=this.O(r);e<=n&&n<=o?r.button===0&&(r.preventDefault(),this.I(r)):this.H(r)}H(r){let l,e;if(r.target===this.domNode.domNode&&typeof r.offsetX=="number"&&typeof r.offsetY=="number")l=r.offsetX,e=r.offsetY;else{const n=y.getDomNodePagePosition(this.domNode.domNode);l=r.pageX-n.left,e=r.pageY-n.top}const o=this.N(l,e);this.J(this.c?this.h.getDesiredScrollPositionFromOffsetPaged(o):this.h.getDesiredScrollPositionFromOffset(o)),r.button===0&&(r.preventDefault(),this.I(r))}I(r){if(!r.target||!(r.target instanceof Element))return;const l=this.O(r),e=this.P(r),o=this.h.clone();this.slider.toggleClassName("active",!0),this.l.startMonitoring(r.target,r.pointerId,r.buttons,n=>{const u=this.P(n),s=Math.abs(u-e);if(h.isWindows&&s>a){this.J(o.getScrollPosition());return}const D=this.O(n)-l;this.J(o.getDesiredScrollPositionFromDelta(D))},()=>{this.slider.toggleClassName("active",!1),this.a.onDragEnd()}),this.a.onDragStart()}J(r){const l={};this.writeScrollPosition(l,r),this.b.setScrollPositionNow(l)}updateScrollbarSize(r){this.Q(r),this.h.setScrollbarSize(r),this.n=!0,this.g||this.render()}isNeeded(){return this.h.isNeeded()}}t.AbstractScrollbar=c}),define(me[120],be([1,0,21,56,35,39,16]),function(te,t,y,M,i,W,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class A extends M.AbstractScrollbar{constructor(a,c,P){const r=a.getScrollDimensions(),l=a.getCurrentScrollPosition();if(super({lazyRender:c.lazyRender,host:P,scrollbarState:new W.ScrollbarState(c.horizontalHasArrows?c.arrowSize:0,c.horizontal===2?0:c.horizontalScrollbarSize,c.vertical===2?0:c.verticalScrollbarSize,r.width,r.scrollWidth,l.scrollLeft),visibility:c.horizontal,extraScrollbarClassName:"horizontal",scrollable:a,scrollByPage:c.scrollByPage}),c.horizontalHasArrows){const e=(c.arrowSize-i.ARROW_IMG_SIZE)/2,o=(c.horizontalScrollbarSize-i.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:p.Codicon.scrollbarButtonLeft,top:o,left:e,bottom:void 0,right:void 0,bgWidth:c.arrowSize,bgHeight:c.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.StandardWheelEvent(null,1,0))}),this.r({className:"scra",icon:p.Codicon.scrollbarButtonRight,top:o,left:void 0,bottom:void 0,right:e,bgWidth:c.arrowSize,bgHeight:c.horizontalScrollbarSize,onActivate:()=>this.a.onMouseWheel(new y.StandardWheelEvent(null,-1,0))})}this.s(Math.floor((c.horizontalScrollbarSize-c.horizontalSliderSize)/2),0,void 0,c.horizontalSliderSize)}M(a,c){this.slider.setWidth(a),this.slider.setLeft(c)}L(a,c){this.domNode.setWidth(a),this.domNode.setHeight(c),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(a){return this.n=this.v(a.scrollWidth)||this.n,this.n=this.w(a.scrollLeft)||this.n,this.n=this.t(a.width)||this.n,this.n}N(a,c){return a}O(a){return a.pageX}P(a){return a.pageY}Q(a){this.slider.setHeight(a)}writeScrollPosition(a,c){a.scrollLeft=c}updateOptions(a){this.updateScrollbarSize(a.horizontal===2?0:a.horizontalScrollbarSize),this.h.setOppositeScrollbarSize(a.vertical===2?0:a.verticalScrollbarSize),this.i.setVisibility(a.horizontal),this.c=a.scrollByPage}}t.HorizontalScrollbar=A}),define(me[121],be([1,0,21,56,35,39,16]),function(te,t,y,M,i,W,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class A extends M.AbstractScrollbar{constructor(a,c,P){const r=a.getScrollDimensions(),l=a.getCurrentScrollPosition();if(super({lazyRender:c.lazyRender,host:P,scrollbarState:new W.ScrollbarState(c.verticalHasArrows?c.arrowSize:0,c.vertical===2?0:c.verticalScrollbarSize,0,r.height,r.scrollHeight,l.scrollTop),visibility:c.vertical,extraScrollbarClassName:"vertical",scrollable:a,scrollByPage:c.scrollByPage}),c.verticalHasArrows){const e=(c.arrowSize-i.ARROW_IMG_SIZE)/2,o=(c.verticalScrollbarSize-i.ARROW_IMG_SIZE)/2;this.r({className:"scra",icon:p.Codicon.scrollbarButtonUp,top:e,left:o,bottom:void 0,right:void 0,bgWidth:c.verticalScrollbarSize,bgHeight:c.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.StandardWheelEvent(null,0,1))}),this.r({className:"scra",icon:p.Codicon.scrollbarButtonDown,top:void 0,left:o,bottom:e,right:void 0,bgWidth:c.verticalScrollbarSize,bgHeight:c.arrowSize,onActivate:()=>this.a.onMouseWheel(new y.StandardWheelEvent(null,0,-1))})}this.s(0,Math.floor((c.verticalScrollbarSize-c.verticalSliderSize)/2),c.verticalSliderSize,void 0)}M(a,c){this.slider.setHeight(a),this.slider.setTop(c)}L(a,c){this.domNode.setWidth(c),this.domNode.setHeight(a),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(a){return this.n=this.v(a.scrollHeight)||this.n,this.n=this.w(a.scrollTop)||this.n,this.n=this.t(a.height)||this.n,this.n}N(a,c){return c}O(a){return a.pageY}P(a){return a.pageX}Q(a){this.slider.setWidth(a)}writeScrollPosition(a,c){a.scrollTop=c}updateOptions(a){this.updateScrollbarSize(a.vertical===2?0:a.verticalScrollbarSize),this.h.setOppositeScrollbarSize(0),this.i.setVisibility(a.vertical),this.c=a.scrollByPage}}t.VerticalScrollbar=A}),define(me[57],be([1,0,18,4,38,21,120,121,19,9,3,2,5,49,90]),function(te,t,y,M,i,W,p,A,h,a,c,P,r,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,o=50,n=!0;class u{constructor(N,E,g){this.timestamp=N,this.deltaX=E,this.deltaY=g,this.score=0}}class s{constructor(){this.a=5,this.b=[],this.c=-1,this.d=-1}isPhysicalMouseWheel(){if(this.c===-1&&this.d===-1)return!1;let N=1,E=0,g=1,m=this.d;do{const b=m===this.c?N:Math.pow(2,-g);if(N-=b,E+=this.b[m].score*b,m===this.c)break;m=(this.a+m-1)%this.a,g++}while(!0);return E<=.5}acceptStandardWheelEvent(N){const E=window.devicePixelRatio/(0,y.getZoomFactor)();r.isWindows||r.isLinux?this.accept(Date.now(),N.deltaX/E,N.deltaY/E):this.accept(Date.now(),N.deltaX,N.deltaY)}accept(N,E,g){const m=new u(N,E,g);m.score=this.f(m),this.c===-1&&this.d===-1?(this.b[0]=m,this.c=0,this.d=0):(this.d=(this.d+1)%this.a,this.d===this.c&&(this.c=(this.c+1)%this.a),this.b[this.d]=m)}f(N){if(Math.abs(N.deltaX)>0&&Math.abs(N.deltaY)>0)return 1;let E=.5;const g=this.c===-1&&this.d===-1?null:this.b[this.d];return(!this.g(N.deltaX)||!this.g(N.deltaY))&&(E+=.25),Math.min(Math.max(E,0),1)}g(N){return Math.abs(Math.round(N)-N)<.01}}t.MouseWheelClassifier=s,s.INSTANCE=new s;class w extends h.Widget{get options(){return this.a}constructor(N,E,g){super(),this.I=this.B(new c.Emitter),this.onScroll=this.I.event,this.J=this.B(new c.Emitter),this.onWillScroll=this.J.event,N.style.overflow="hidden",this.a=v(E),this.b=g,this.B(this.b.onScroll(b=>{this.J.fire(b),this.N(b),this.I.fire(b)}));const m={onMouseWheel:b=>this.M(b),onDragStart:()=>this.P(),onDragEnd:()=>this.Q()};this.c=this.B(new A.VerticalScrollbar(this.b,this.a,m)),this.g=this.B(new p.HorizontalScrollbar(this.b,this.a,m)),this.h=document.createElement("div"),this.h.className="monaco-scrollable-element "+this.a.className,this.h.setAttribute("role","presentation"),this.h.style.position="relative",this.h.style.overflow="hidden",this.h.appendChild(N),this.h.appendChild(this.g.domNode.domNode),this.h.appendChild(this.c.domNode.domNode),this.a.useShadows?(this.i=(0,i.createFastDomNode)(document.createElement("div")),this.i.setClassName("shadow"),this.h.appendChild(this.i.domNode),this.l=(0,i.createFastDomNode)(document.createElement("div")),this.l.setClassName("shadow"),this.h.appendChild(this.l.domNode),this.n=(0,i.createFastDomNode)(document.createElement("div")),this.n.setClassName("shadow"),this.h.appendChild(this.n.domNode)):(this.i=null,this.l=null,this.n=null),this.r=this.a.listenOnDomNode||this.h,this.s=[],this.L(this.a.handleMouseWheel),this.k(this.r,b=>this.S(b)),this.m(this.r,b=>this.R(b)),this.w=this.B(new a.TimeoutTimer),this.t=!1,this.v=!1,this.y=!0,this.H=!0}dispose(){this.s=(0,P.dispose)(this.s),super.dispose()}getDomNode(){return this.h}getOverviewRulerLayoutInfo(){return{parent:this.h,insertBefore:this.c.domNode.domNode}}delegateVerticalScrollbarPointerDown(N){this.c.delegatePointerDown(N)}getScrollDimensions(){return this.b.getScrollDimensions()}setScrollDimensions(N){this.b.setScrollDimensions(N,!1)}updateClassName(N){this.a.className=N,r.isMacintosh&&(this.a.className+=" mac"),this.h.className="monaco-scrollable-element "+this.a.className}updateOptions(N){typeof N.handleMouseWheel<"u"&&(this.a.handleMouseWheel=N.handleMouseWheel,this.L(this.a.handleMouseWheel)),typeof N.mouseWheelScrollSensitivity<"u"&&(this.a.mouseWheelScrollSensitivity=N.mouseWheelScrollSensitivity),typeof N.fastScrollSensitivity<"u"&&(this.a.fastScrollSensitivity=N.fastScrollSensitivity),typeof N.scrollPredominantAxis<"u"&&(this.a.scrollPredominantAxis=N.scrollPredominantAxis),typeof N.horizontal<"u"&&(this.a.horizontal=N.horizontal),typeof N.vertical<"u"&&(this.a.vertical=N.vertical),typeof N.horizontalScrollbarSize<"u"&&(this.a.horizontalScrollbarSize=N.horizontalScrollbarSize),typeof N.verticalScrollbarSize<"u"&&(this.a.verticalScrollbarSize=N.verticalScrollbarSize),typeof N.scrollByPage<"u"&&(this.a.scrollByPage=N.scrollByPage),this.g.updateOptions(this.a),this.c.updateOptions(this.a),this.a.lazyRender||this.O()}setRevealOnScroll(N){this.H=N}delegateScrollFromMouseWheelEvent(N){this.M(new W.StandardWheelEvent(N))}L(N){if(this.s.length>0!==N&&(this.s=(0,P.dispose)(this.s),N)){const g=m=>{this.M(new W.StandardWheelEvent(m))};this.s.push(M.addDisposableListener(this.r,M.EventType.MOUSE_WHEEL,g,{passive:!1}))}}M(N){const E=s.INSTANCE;n&&E.acceptStandardWheelEvent(N);let g=!1;if(N.deltaY||N.deltaX){let b=N.deltaY*this.a.mouseWheelScrollSensitivity,B=N.deltaX*this.a.mouseWheelScrollSensitivity;this.a.scrollPredominantAxis&&(Math.abs(b)>=Math.abs(B)?B=0:b=0),this.a.flipAxes&&([b,B]=[B,b]);const G=!r.isMacintosh&&N.browserEvent&&N.browserEvent.shiftKey;(this.a.scrollYToX||G)&&!B&&(B=b,b=0),N.browserEvent&&N.browserEvent.altKey&&(B=B*this.a.fastScrollSensitivity,b=b*this.a.fastScrollSensitivity);const J=this.b.getFutureScrollPosition();let ie={};if(b){const le=o*b,ge=J.scrollTop-(le<0?Math.floor(le):Math.ceil(le));this.c.writeScrollPosition(ie,ge)}if(B){const le=o*B,ge=J.scrollLeft-(le<0?Math.floor(le):Math.ceil(le));this.g.writeScrollPosition(ie,ge)}ie=this.b.validateScrollPosition(ie),(J.scrollLeft!==ie.scrollLeft||J.scrollTop!==ie.scrollTop)&&(n&&this.a.mouseWheelSmoothScroll&&E.isPhysicalMouseWheel()?this.b.setScrollPositionSmooth(ie):this.b.setScrollPositionNow(ie),g=!0)}let m=g;!m&&this.a.alwaysConsumeMouseWheel&&(m=!0),!m&&this.a.consumeMouseWheelIfScrollbarIsNeeded&&(this.c.isNeeded()||this.g.isNeeded())&&(m=!0),m&&(N.preventDefault(),N.stopPropagation())}N(N){this.y=this.g.onDidScroll(N)||this.y,this.y=this.c.onDidScroll(N)||this.y,this.a.useShadows&&(this.y=!0),this.H&&this.U(),this.a.lazyRender||this.O()}renderNow(){if(!this.a.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this.O()}O(){if(this.y&&(this.y=!1,this.g.render(),this.c.render(),this.a.useShadows)){const N=this.b.getCurrentScrollPosition(),E=N.scrollTop>0,g=N.scrollLeft>0,m=g?" left":"",b=E?" top":"",B=g||E?" top-left-corner":"";this.i.setClassName(`shadow${m}`),this.l.setClassName(`shadow${b}`),this.n.setClassName(`shadow${B}${b}${m}`)}}P(){this.t=!0,this.U()}Q(){this.t=!1,this.W()}R(N){this.v=!1,this.W()}S(N){this.v=!0,this.U()}U(){this.c.beginReveal(),this.g.beginReveal(),this.X()}W(){!this.v&&!this.t&&(this.c.beginHide(),this.g.beginHide())}X(){!this.v&&!this.t&&this.w.cancelAndSet(()=>this.W(),e)}}t.AbstractScrollableElement=w;class D extends w{constructor(N,E){E=E||{},E.mouseWheelSmoothScroll=!1;const g=new l.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:m=>M.scheduleAtNextAnimationFrame(m)});super(N,E,g),this.B(g)}setScrollPosition(N){this.b.setScrollPositionNow(N)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.ScrollableElement=D;class S extends w{constructor(N,E,g){super(N,E,g)}setScrollPosition(N){N.reuseAnimation?this.b.setScrollPositionSmooth(N,N.reuseAnimation):this.b.setScrollPositionNow(N)}getScrollPosition(){return this.b.getCurrentScrollPosition()}}t.SmoothScrollableElement=S;class f extends w{constructor(N,E){E=E||{},E.mouseWheelSmoothScroll=!1;const g=new l.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:m=>M.scheduleAtNextAnimationFrame(m)});super(N,E,g),this.B(g),this.Y=N,this.onScroll(m=>{m.scrollTopChanged&&(this.Y.scrollTop=m.scrollTop),m.scrollLeftChanged&&(this.Y.scrollLeft=m.scrollLeft)}),this.scanDomNode()}setScrollPosition(N){this.b.setScrollPositionNow(N)}getScrollPosition(){return this.b.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this.Y.clientWidth,scrollWidth:this.Y.scrollWidth,height:this.Y.clientHeight,scrollHeight:this.Y.scrollHeight}),this.setScrollPosition({scrollLeft:this.Y.scrollLeft,scrollTop:this.Y.scrollTop})}}t.DomScrollableElement=f;function v(L){const N={lazyRender:typeof L.lazyRender<"u"?L.lazyRender:!1,className:typeof L.className<"u"?L.className:"",useShadows:typeof L.useShadows<"u"?L.useShadows:!0,handleMouseWheel:typeof L.handleMouseWheel<"u"?L.handleMouseWheel:!0,flipAxes:typeof L.flipAxes<"u"?L.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof L.consumeMouseWheelIfScrollbarIsNeeded<"u"?L.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof L.alwaysConsumeMouseWheel<"u"?L.alwaysConsumeMouseWheel:!1,scrollYToX:typeof L.scrollYToX<"u"?L.scrollYToX:!1,mouseWheelScrollSensitivity:typeof L.mouseWheelScrollSensitivity<"u"?L.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof L.fastScrollSensitivity<"u"?L.fastScrollSensitivity:5,scrollPredominantAxis:typeof L.scrollPredominantAxis<"u"?L.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof L.mouseWheelSmoothScroll<"u"?L.mouseWheelSmoothScroll:!0,arrowSize:typeof L.arrowSize<"u"?L.arrowSize:11,listenOnDomNode:typeof L.listenOnDomNode<"u"?L.listenOnDomNode:null,horizontal:typeof L.horizontal<"u"?L.horizontal:1,horizontalScrollbarSize:typeof L.horizontalScrollbarSize<"u"?L.horizontalScrollbarSize:10,horizontalSliderSize:typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:0,horizontalHasArrows:typeof L.horizontalHasArrows<"u"?L.horizontalHasArrows:!1,vertical:typeof L.vertical<"u"?L.vertical:1,verticalScrollbarSize:typeof L.verticalScrollbarSize<"u"?L.verticalScrollbarSize:10,verticalHasArrows:typeof L.verticalHasArrows<"u"?L.verticalHasArrows:!1,verticalSliderSize:typeof L.verticalSliderSize<"u"?L.verticalSliderSize:0,scrollByPage:typeof L.scrollByPage<"u"?L.scrollByPage:!1};return N.horizontalSliderSize=typeof L.horizontalSliderSize<"u"?L.horizontalSliderSize:N.horizontalScrollbarSize,N.verticalSliderSize=typeof L.verticalSliderSize<"u"?L.verticalSliderSize:N.verticalScrollbarSize,r.isMacintosh&&(N.className+=" mac"),N}}),define(me[58],be([1,0,51,4,20,23,57,13,9,25,3,2,45,49,79,116,7]),function(te,t,y,M,i,W,p,A,h,a,c,P,r,l,e,o,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const u={CurrentDragAndDropData:void 0},s={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(N){return[N]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class w{get context(){return this.d}set context(E){this.d=E}constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=w;class D{constructor(E){this.elements=E}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=D;class S{constructor(){this.types=[],this.files=[]}update(E){if(E.types&&this.types.splice(0,this.types.length,...E.types),E.files){this.files.splice(0,this.files.length);for(let g=0;g<E.files.length;g++){const m=E.files.item(g);m&&(m.size||m.type)&&this.files.push(m)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=S;function f(N,E){return Array.isArray(N)&&Array.isArray(E)?(0,A.equals)(N,E):N===E}class v{constructor(E){E?.getSetSize?this.getSetSize=E.getSetSize.bind(E):this.getSetSize=(g,m,b)=>b,E?.getPosInSet?this.getPosInSet=E.getPosInSet.bind(E):this.getPosInSet=(g,m)=>m+1,E?.getRole?this.getRole=E.getRole.bind(E):this.getRole=g=>"listitem",E?.isChecked?this.isChecked=E.isChecked.bind(E):this.isChecked=g=>{}}}class L{get contentHeight(){return this.g.size}get onDidScroll(){return this.q.onScroll}get onWillScroll(){return this.q.onWillScroll}get containerDomNode(){return this.o}get scrollableElementDomNode(){return this.q.getDomNode()}get O(){return this.N}set O(E){if(E!==this.N){if(E&&this.B)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this.N=E,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.N){for(const g of this.d)this.X(g);this.U(),this.q.setScrollDimensions({width:(0,M.getContentWidth)(this.domNode)}),this.o.style.width=`${Math.max(this.E||0,this.n)}px`}else this.u.cancel(),this.q.setScrollDimensions({width:this.n,scrollWidth:this.n}),this.o.style.width=""}}constructor(E,g,m,b=s){if(this.P=g,this.domId=`list_id_${++L.c}`,this.j=new Map,this.n=0,this.s=0,this.t=null,this.u=new h.Delayer(50),this.v=!1,this.x=P.Disposable.None,this.y=0,this.G=!1,this.J=P.Disposable.None,this.K=P.Disposable.None,this.L=new P.DisposableStore,this.M=new c.Emitter,this.onDidChangeContentHeight=c.Event.latch(this.M.event,void 0,this.L),this.N=!1,b.horizontalScrolling&&b.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.d=[],this.f=0,this.g=new e.RangeMap;for(const G of m)this.j.set(G.templateId,G);this.h=this.L.add(new o.RowCache(this.j)),this.k=0,this.m=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof b.mouseSupport=="boolean"?b.mouseSupport:!0),this.N=b.horizontalScrolling??s.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this.N),this.C=typeof b.additionalScrollHeight>"u"?0:b.additionalScrollHeight,this.D=new v(b.accessibilityProvider),this.o=document.createElement("div"),this.o.className="monaco-list-rows",(b.transformOptimization??s.transformOptimization)&&(this.o.style.transform="translate3d(0px, 0px, 0px)",this.o.style.overflow="hidden",this.o.style.contain="strict"),this.L.add(W.Gesture.addTarget(this.o)),this.p=new l.Scrollable({forceIntegerValues:!0,smoothScrollDuration:b.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:G=>(0,M.scheduleAtNextAnimationFrame)(G)}),this.q=this.L.add(new p.SmoothScrollableElement(this.o,{alwaysConsumeMouseWheel:b.alwaysConsumeMouseWheel??s.alwaysConsumeMouseWheel,horizontal:1,vertical:b.verticalScrollMode??s.verticalScrollMode,useShadows:b.useShadows??s.useShadows,mouseWheelScrollSensitivity:b.mouseWheelScrollSensitivity,fastScrollSensitivity:b.fastScrollSensitivity,scrollByPage:b.scrollByPage},this.p)),this.domNode.appendChild(this.q.getDomNode()),E.appendChild(this.domNode),this.q.onScroll(this.fb,this,this.L),this.L.add((0,M.addDisposableListener)(this.o,W.EventType.Change,G=>this.gb(G))),this.L.add((0,M.addDisposableListener)(this.q.getDomNode(),"scroll",G=>G.target.scrollTop=0)),this.L.add((0,M.addDisposableListener)(this.domNode,"dragover",G=>this.ib(this.eb(G)))),this.L.add((0,M.addDisposableListener)(this.domNode,"drop",G=>this.kb(this.eb(G)))),this.L.add((0,M.addDisposableListener)(this.domNode,"dragleave",G=>this.jb(this.eb(G)))),this.L.add((0,M.addDisposableListener)(this.domNode,"dragend",G=>this.lb(G))),this.z=b.setRowLineHeight??s.setRowLineHeight,this.A=b.setRowHeight??s.setRowHeight,this.B=b.supportDynamicHeights??s.supportDynamicHeights,this.F=b.dnd??s.dnd,this.layout(b.initialSize?.height,b.initialSize?.width)}updateOptions(E){E.additionalScrollHeight!==void 0&&(this.C=E.additionalScrollHeight,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),E.smoothScrolling!==void 0&&this.p.setSmoothScrollDuration(E.smoothScrolling?125:0),E.horizontalScrolling!==void 0&&(this.O=E.horizontalScrolling);let g;E.scrollByPage!==void 0&&(g={...g??{},scrollByPage:E.scrollByPage}),E.mouseWheelScrollSensitivity!==void 0&&(g={...g??{},mouseWheelScrollSensitivity:E.mouseWheelScrollSensitivity}),E.fastScrollSensitivity!==void 0&&(g={...g??{},fastScrollSensitivity:E.fastScrollSensitivity}),g&&this.q.updateOptions(g)}delegateScrollFromMouseWheelEvent(E){this.q.delegateScrollFromMouseWheelEvent(E)}delegateVerticalScrollbarPointerDown(E){this.q.delegateVerticalScrollbarPointerDown(E)}updateElementHeight(E,g,m){if(E<0||E>=this.d.length)return;const b=this.d[E].size;if(typeof g>"u"){if(!this.B){console.warn("Dynamic heights not supported");return}this.d[E].lastDynamicHeightWidth=void 0,g=b+this.tb(E)}if(b===g)return;const B=this.rb(this.k,this.m);let G=0;E<B.start||m!==null&&m>E&&m<=B.end?G=g-b:G=0,this.g.splice(E,1,[{size:g}]),this.d[E].size=g,this.V(B,Math.max(0,this.k+G),this.m,void 0,void 0,!0),this.setScrollTop(this.k),this.R(),this.B&&this.sb(this.k,this.m)}splice(E,g,m=[]){if(this.v)throw new Error("Can't run recursive splices.");this.v=!0;try{return this.Q(E,g,m)}finally{this.v=!1,this.M.fire(this.contentHeight)}}Q(E,g,m=[]){const b=this.rb(this.k,this.m),B={start:E,end:E+g},G=r.Range.intersect(b,B),J=new Map;for(let V=G.end-1;V>=G.start;V--){const F=this.d[V];if(F.dragStartDisposable.dispose(),F.checkedDisposable.dispose(),F.row){let x=J.get(F.templateId);x||(x=[],J.set(F.templateId,x));const I=this.j.get(F.templateId);I&&I.disposeElement&&I.disposeElement(F.element,V,F.row.templateData,F.size),x.push(F.row)}F.row=null}const ie={start:E+g,end:this.d.length},le=r.Range.intersect(ie,b),ge=r.Range.relativeComplement(ie,b),ue=m.map(V=>({id:String(this.f++),element:V,templateId:this.P.getTemplateId(V),size:this.P.getHeight(V),width:void 0,hasDynamicHeight:!!this.P.hasDynamicHeight&&this.P.hasDynamicHeight(V),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:P.Disposable.None,checkedDisposable:P.Disposable.None}));let de;E===0&&g>=this.d.length?(this.g=new e.RangeMap,this.g.splice(0,0,ue),de=this.d,this.d=ue):(this.g.splice(E,g,ue),de=this.d.splice(E,g,...ue));const ce=m.length-g,Se=this.rb(this.k,this.m),Ae=(0,e.shift)(le,ce),Be=r.Range.intersect(Se,Ae);for(let V=Be.start;V<Be.end;V++)this.Y(this.d[V],V);const re=r.Range.relativeComplement(Ae,Se);for(const V of re)for(let F=V.start;F<V.end;F++)this.Z(F);const ne=ge.map(V=>(0,e.shift)(V,ce)),oe=[{start:E,end:E+m.length},...ne].map(V=>r.Range.intersect(Se,V)),j=this.ub(oe);for(const V of oe)for(let F=V.start;F<V.end;F++){const x=this.d[F],d=J.get(x.templateId)?.pop();this.W(F,j,d)}for(const V of J.values())for(const F of V)this.h.release(F);return this.R(),this.B&&this.sb(this.scrollTop,this.renderHeight),de.map(V=>V.element)}R(){this.s=this.contentHeight,this.o.style.height=`${this.s}px`,this.t||(this.t=(0,M.scheduleAtNextAnimationFrame)(()=>{this.q.setScrollDimensions({scrollHeight:this.scrollHeight}),this.U(),this.t=null}))}S(){if(!this.O){this.u.cancel();return}this.u.trigger(()=>this.U())}U(){if(!this.O)return;let E=0;for(const g of this.d)typeof g.width<"u"&&(E=Math.max(E,g.width));this.E=E,this.q.setScrollDimensions({scrollWidth:E===0?0:E+10})}updateWidth(E){if(!this.O||typeof this.E>"u")return;const g=this.d[E];this.X(g),typeof g.width<"u"&&g.width>this.E&&(this.E=g.width,this.q.setScrollDimensions({scrollWidth:this.E+10}))}rerender(){if(this.B){for(const E of this.d)E.lastDynamicHeightWidth=void 0;this.sb(this.k,this.m)}}get length(){return this.d.length}get renderHeight(){return this.q.getScrollDimensions().height}get firstVisibleIndex(){const E=this.rb(this.k,this.m),g=this.g.positionAt(E.start),m=this.g.positionAt(E.start+1);return m!==-1&&(m-g)/2+g<this.scrollTop?E.start+1:E.start}get lastVisibleIndex(){return this.rb(this.k,this.m).end-1}element(E){return this.d[E].element}indexOf(E){return this.d.findIndex(g=>g.element===E)}domElement(E){const g=this.d[E].row;return g&&g.domNode}elementHeight(E){return this.d[E].size}elementTop(E){return this.g.positionAt(E)}indexAt(E){return this.g.indexAt(E)}indexAfter(E){return this.g.indexAfter(E)}layout(E,g){const m={height:typeof E=="number"?E:(0,M.getContentHeight)(this.domNode)};this.t&&(this.t.dispose(),this.t=null,m.scrollHeight=this.scrollHeight),this.q.setScrollDimensions(m),typeof g<"u"&&(this.n=g,this.B&&this.sb(this.scrollTop,this.renderHeight)),this.O&&this.q.setScrollDimensions({width:typeof g=="number"?g:(0,M.getContentWidth)(this.domNode)})}V(E,g,m,b,B,G=!1){const J=this.rb(g,m),ie=r.Range.relativeComplement(J,E),le=r.Range.relativeComplement(E,J),ge=this.ub(ie);if(G){const ue=r.Range.intersect(E,J);for(let de=ue.start;de<ue.end;de++)this.Y(this.d[de],de)}this.h.transact(()=>{for(const ue of le)for(let de=ue.start;de<ue.end;de++)this.Z(de);for(const ue of ie)for(let de=ue.start;de<ue.end;de++)this.W(de,ge)}),b!==void 0&&(this.o.style.left=`-${b}px`),this.o.style.top=`-${g}px`,this.O&&B!==void 0&&(this.o.style.width=`${Math.max(B,this.n)}px`),this.k=g,this.m=m}W(E,g,m){const b=this.d[E];let B=!1;if(!b.row)if(m)b.row=m;else{const ge=this.h.alloc(b.templateId);b.row=ge.row,B=ge.isReusingConnectedDomNode}const G=this.D.getRole(b.element)||"listitem";b.row.domNode.setAttribute("role",G);const J=this.D.isChecked(b.element);if(typeof J=="boolean")b.row.domNode.setAttribute("aria-checked",String(!!J));else if(J){const ge=ue=>b.row.domNode.setAttribute("aria-checked",String(!!ue));ge(J.value),b.checkedDisposable=J.onDidChange(ge)}(B||!b.row.domNode.parentElement)&&(g?this.o.insertBefore(b.row.domNode,g):this.o.appendChild(b.row.domNode)),this.Y(b,E);const ie=this.j.get(b.templateId);if(!ie)throw new Error(`No renderer found for template id ${b.templateId}`);ie?.renderElement(b.element,E,b.row.templateData,b.size);const le=this.F.getDragURI(b.element);b.dragStartDisposable.dispose(),b.row.domNode.draggable=!!le,le&&(b.dragStartDisposable=(0,M.addDisposableListener)(b.row.domNode,"dragstart",ge=>this.hb(b.element,le,ge))),this.O&&(this.X(b),this.S())}X(E){if(!E.row||!E.row.domNode)return;E.row.domNode.style.width="fit-content",E.width=(0,M.getContentWidth)(E.row.domNode);const g=window.getComputedStyle(E.row.domNode);g.paddingLeft&&(E.width+=parseFloat(g.paddingLeft)),g.paddingRight&&(E.width+=parseFloat(g.paddingRight)),E.row.domNode.style.width=""}Y(E,g){E.row.domNode.style.top=`${this.elementTop(g)}px`,this.A&&(E.row.domNode.style.height=`${E.size}px`),this.z&&(E.row.domNode.style.lineHeight=`${E.size}px`),E.row.domNode.setAttribute("data-index",`${g}`),E.row.domNode.setAttribute("data-last-element",g===this.length-1?"true":"false"),E.row.domNode.setAttribute("data-parity",g%2===0?"even":"odd"),E.row.domNode.setAttribute("aria-setsize",String(this.D.getSetSize(E.element,g,this.length))),E.row.domNode.setAttribute("aria-posinset",String(this.D.getPosInSet(E.element,g))),E.row.domNode.setAttribute("id",this.getElementDomId(g)),E.row.domNode.classList.toggle("drop-target",E.dropTarget)}Z(E){const g=this.d[E];if(g.dragStartDisposable.dispose(),g.checkedDisposable.dispose(),g.row){const m=this.j.get(g.templateId);m&&m.disposeElement&&m.disposeElement(g.element,E,g.row.templateData,g.size),this.h.release(g.row),g.row=null}this.O&&this.S()}getScrollTop(){return this.q.getScrollPosition().scrollTop}setScrollTop(E,g){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollHeight:this.scrollHeight})),this.q.setScrollPosition({scrollTop:E,reuseAnimation:g})}getScrollLeft(){return this.q.getScrollPosition().scrollLeft}setScrollLeft(E){this.t&&(this.t.dispose(),this.t=null,this.q.setScrollDimensions({scrollWidth:this.E})),this.q.setScrollPosition({scrollLeft:E})}get scrollTop(){return this.getScrollTop()}set scrollTop(E){this.setScrollTop(E)}get scrollHeight(){return this.s+(this.O?10:0)+this.C}get onMouseClick(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"click")).event,E=>this.ab(E),this.L)}get onMouseDblClick(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"dblclick")).event,E=>this.ab(E),this.L)}get onMouseMiddleClick(){return c.Event.filter(c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"auxclick")).event,E=>this.ab(E),this.L),E=>E.browserEvent.button===1,this.L)}get onMouseUp(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mouseup")).event,E=>this.ab(E),this.L)}get onMouseDown(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mousedown")).event,E=>this.ab(E),this.L)}get onMouseOver(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mouseover")).event,E=>this.ab(E),this.L)}get onMouseMove(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mousemove")).event,E=>this.ab(E),this.L)}get onMouseOut(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"mouseout")).event,E=>this.ab(E),this.L)}get onContextMenu(){return c.Event.any(c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"contextmenu")).event,E=>this.ab(E),this.L),c.Event.map(this.L.add(new i.DomEmitter(this.domNode,W.EventType.Contextmenu)).event,E=>this.db(E),this.L))}get onTouchStart(){return c.Event.map(this.L.add(new i.DomEmitter(this.domNode,"touchstart")).event,E=>this.bb(E),this.L)}get onTap(){return c.Event.map(this.L.add(new i.DomEmitter(this.o,W.EventType.Tap)).event,E=>this.db(E),this.L)}ab(E){const g=this.qb(E.target||null),m=typeof g>"u"?void 0:this.d[g],b=m&&m.element;return{browserEvent:E,index:g,element:b}}bb(E){const g=this.qb(E.target||null),m=typeof g>"u"?void 0:this.d[g],b=m&&m.element;return{browserEvent:E,index:g,element:b}}db(E){const g=this.qb(E.initialTarget||null),m=typeof g>"u"?void 0:this.d[g],b=m&&m.element;return{browserEvent:E,index:g,element:b}}eb(E){const g=this.qb(E.target||null),m=typeof g>"u"?void 0:this.d[g],b=m&&m.element;return{browserEvent:E,index:g,element:b}}fb(E){try{const g=this.rb(this.k,this.m);this.V(g,E.scrollTop,E.height,E.scrollLeft,E.scrollWidth),this.B&&this.sb(E.scrollTop,E.height,E.inSmoothScrolling)}catch(g){throw console.error("Got bad scroll event:",E),g}}gb(E){E.preventDefault(),E.stopPropagation(),this.scrollTop-=E.translationY}hb(E,g,m){if(!m.dataTransfer)return;const b=this.F.getDragElements(E);if(m.dataTransfer.effectAllowed="copyMove",m.dataTransfer.setData(y.DataTransfers.TEXT,g),m.dataTransfer.setDragImage){let B;this.F.getDragLabel&&(B=this.F.getDragLabel(b,m)),typeof B>"u"&&(B=String(b.length));const G=(0,M.$)(".monaco-drag-image");G.textContent=B;const ie=(le=>{for(;le&&!le.classList.contains("monaco-workbench");)le=le.parentElement;return le||document.body})(this.domNode);ie.appendChild(G),m.dataTransfer.setDragImage(G,-10,-10),setTimeout(()=>ie.removeChild(G),0)}this.domNode.classList.add("dragging"),this.H=new w(b),u.CurrentDragAndDropData=new D(b),this.F.onDragStart?.(this.H,m)}ib(E){if(E.browserEvent.preventDefault(),this.K.dispose(),u.CurrentDragAndDropData&&u.CurrentDragAndDropData.getData()==="vscode-ui"||(this.nb(E.browserEvent),!E.browserEvent.dataTransfer))return!1;if(!this.H)if(u.CurrentDragAndDropData)this.H=u.CurrentDragAndDropData;else{if(!E.browserEvent.dataTransfer.types)return!1;this.H=new S}const g=this.F.onDragOver(this.H,E.element,E.index,E.browserEvent);if(this.G=typeof g=="boolean"?g:g.accept,!this.G)return this.I=void 0,this.J.dispose(),!1;E.browserEvent.dataTransfer.dropEffect=typeof g!="boolean"&&g.effect===0?"copy":"move";let m;if(typeof g!="boolean"&&g.feedback?m=g.feedback:typeof E.index>"u"?m=[-1]:m=[E.index],m=(0,A.distinct)(m).filter(b=>b>=-1&&b<this.length).sort((b,B)=>b-B),m=m[0]===-1?[-1]:m,f(this.I,m))return!0;if(this.I=m,this.J.dispose(),m[0]===-1)this.domNode.classList.add("drop-target"),this.o.classList.add("drop-target"),this.J=(0,P.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.o.classList.remove("drop-target")});else{for(const b of m){const B=this.d[b];B.dropTarget=!0,B.row?.domNode.classList.add("drop-target")}this.J=(0,P.toDisposable)(()=>{for(const b of m){const B=this.d[b];B.dropTarget=!1,B.row?.domNode.classList.remove("drop-target")}})}return!0}jb(E){this.K.dispose(),this.K=(0,h.disposableTimeout)(()=>this.mb(),100),this.H&&this.F.onDragLeave?.(this.H,E.element,E.index,E.browserEvent)}kb(E){if(!this.G)return;const g=this.H;this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,u.CurrentDragAndDropData=void 0,!(!g||!E.browserEvent.dataTransfer)&&(E.browserEvent.preventDefault(),g.update(E.browserEvent.dataTransfer),this.F.drop(g,E.element,E.index,E.browserEvent))}lb(E){this.G=!1,this.pb(),this.mb(),this.domNode.classList.remove("dragging"),this.H=void 0,u.CurrentDragAndDropData=void 0,this.F.onDragEnd?.(E)}mb(){this.I=void 0,this.J.dispose(),this.J=P.Disposable.None}nb(E){if(!this.w){const g=(0,M.getTopLeftOffset)(this.domNode).top;this.w=(0,M.animate)(this.ob.bind(this,g))}this.x.dispose(),this.x=(0,h.disposableTimeout)(()=>{this.w&&(this.w.dispose(),this.w=void 0)},1e3),this.y=E.pageY}ob(E){if(this.y===void 0)return;const g=this.y-E,m=this.renderHeight-35;g<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(g-35))):g>m&&(this.scrollTop+=Math.min(14,Math.floor(.3*(g-m))))}pb(){this.x.dispose(),this.w&&(this.w.dispose(),this.w=void 0)}qb(E){const g=this.q.getDomNode();let m=E;for(;m instanceof HTMLElement&&m!==this.o&&g.contains(m);){const b=m.getAttribute("data-index");if(b){const B=Number(b);if(!isNaN(B))return B}m=m.parentElement}}rb(E,g){return{start:this.g.indexAt(E),end:this.g.indexAfter(E+g-1)}}sb(E,g,m){const b=this.rb(E,g);let B,G;E===this.elementTop(b.start)?(B=b.start,G=0):b.end-b.start>1&&(B=b.start+1,G=this.elementTop(B)-E);let J=0;for(;;){const ie=this.rb(E,g);let le=!1;for(let ge=ie.start;ge<ie.end;ge++){const ue=this.tb(ge);ue!==0&&this.g.splice(ge,1,[this.d[ge]]),J+=ue,le=le||ue!==0}if(!le){J!==0&&this.R();const ge=r.Range.relativeComplement(b,ie);for(const de of ge)for(let ce=de.start;ce<de.end;ce++)this.d[ce].row&&this.Z(ce);const ue=r.Range.relativeComplement(ie,b);for(const de of ue)for(let ce=de.start;ce<de.end;ce++){const Se=ce+1,Ae=Se<this.d.length?this.d[Se].row:null,Be=Ae?Ae.domNode:null;this.W(ce,Be)}for(let de=ie.start;de<ie.end;de++)this.d[de].row&&this.Y(this.d[de],de);if(typeof B=="number"){const de=this.p.getFutureScrollPosition().scrollTop-E,ce=this.elementTop(B)-G+de;this.setScrollTop(ce,m)}this.M.fire(this.contentHeight);return}}}tb(E){const g=this.d[E];if(this.P.getDynamicHeight){const G=this.P.getDynamicHeight(g.element);if(G!==null){const J=g.size;return g.size=G,g.lastDynamicHeightWidth=this.n,G-J}}if(!g.hasDynamicHeight||g.lastDynamicHeightWidth===this.n||this.P.hasDynamicHeight&&!this.P.hasDynamicHeight(g.element))return 0;const m=g.size;if(g.row)return g.row.domNode.style.height="",g.size=g.row.domNode.offsetHeight,g.lastDynamicHeightWidth=this.n,g.size-m;const{row:b}=this.h.alloc(g.templateId);b.domNode.style.height="",this.o.appendChild(b.domNode);const B=this.j.get(g.templateId);if(!B)throw new n.BugIndicatingError("Missing renderer for templateId: "+g.templateId);return B.renderElement(g.element,E,b.templateData,void 0),g.size=b.domNode.offsetHeight,B.disposeElement?.(g.element,E,b.templateData,void 0),this.P.setDynamicHeight?.(g.element,g.size),g.lastDynamicHeightWidth=this.n,this.o.removeChild(b.domNode),this.h.release(b),g.size-m}ub(E){const g=E[E.length-1];if(!g)return null;const m=this.d[g.end];return!m||!m.row?null:m.row.domNode}getElementDomId(E){return`${this.domId}_${E}`}dispose(){if(this.d){for(const E of this.d)if(E.row){const g=this.j.get(E.row.templateId);g&&(g.disposeElement?.(E.element,-1,E.row.templateData,void 0),g.disposeTemplate(E.row.templateData))}this.d=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,P.dispose)(this.L)}}t.ListView=L,L.c=0,qe([a.memoize],L.prototype,"onMouseClick",null),qe([a.memoize],L.prototype,"onMouseDblClick",null),qe([a.memoize],L.prototype,"onMouseMiddleClick",null),qe([a.memoize],L.prototype,"onMouseUp",null),qe([a.memoize],L.prototype,"onMouseDown",null),qe([a.memoize],L.prototype,"onMouseOver",null),qe([a.memoize],L.prototype,"onMouseMove",null),qe([a.memoize],L.prototype,"onMouseOut",null),qe([a.memoize],L.prototype,"onContextMenu",null),qe([a.memoize],L.prototype,"onTouchStart",null),qe([a.memoize],L.prototype,"onTap",null)}),define(me[36],be([1,0,4,20,14,23,54,68,13,9,70,25,3,32,2,44,5,6,67,58,89]),function(te,t,y,M,i,W,p,A,h,a,c,P,r,l,e,o,n,u,s,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.unthemedListStyles=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class D{constructor(F){this.d=F,this.c=[]}get templateId(){return`template:${this.d.name}`}renderTemplate(F){return F}renderElement(F,x,I){const d=this.c.findIndex(R=>R.templateData===I);if(d>=0){const R=this.c[d];this.d.unrender(I),R.index=x}else{const R={index:x,templateData:I};this.c.push(R)}this.d.renderIndex(x,I)}splice(F,x,I){const d=[];for(const R of this.c)R.index<F?d.push(R):R.index>=F+x&&d.push({index:R.index+I-x,templateData:R.templateData});this.c=d}renderIndexes(F){for(const{index:x,templateData:I}of this.c)F.indexOf(x)>-1&&this.d.renderIndex(x,I)}disposeTemplate(F){const x=this.c.findIndex(I=>I.templateData===F);x<0||this.c.splice(x,1)}}class S{get name(){return this.h}get renderer(){return new D(this)}constructor(F){this.h=F,this.c=0,this.d=[],this.f=[],this.g=new r.Emitter,this.onChange=this.g.event}splice(F,x,I){x=Math.max(0,Math.min(x,this.c-F));const d=I.length-x,R=F+x,_=[...this.f.filter(k=>k<F),...I.map((k,T)=>k?T+F:-1).filter(k=>k!==-1),...this.f.filter(k=>k>=R).map(k=>k+d)],Z=this.c+d;if(this.f.length>0&&_.length===0&&Z>0){const k=this.f.find(T=>T>=F)??Z-1;_.push(Math.min(k,Z-1))}this.renderer.splice(F,x,I.length),this.k(_,_),this.c=Z}renderIndex(F,x){x.classList.toggle(this.h,this.contains(F))}unrender(F){F.classList.remove(this.h)}set(F,x){return this.k(F,[...F].sort(re),x)}k(F,x,I){const d=this.d,R=this.f;this.d=F,this.f=x;const _=Ae(R,F);return this.renderer.renderIndexes(_),this.g.fire({indexes:F,browserEvent:I}),d}get(){return this.d}contains(F){return(0,h.binarySearch)(this.f,F,re)>=0}dispose(){(0,e.dispose)(this.g)}}qe([P.memoize],S.prototype,"renderer",null);class f extends S{constructor(F){super("selected"),this.l=F}renderIndex(F,x){super.renderIndex(F,x),this.l&&(this.contains(F)?x.setAttribute("aria-selected","true"):x.setAttribute("aria-selected","false"))}}class v{constructor(F,x,I){this.c=F,this.d=x,this.f=I}splice(F,x,I){if(!this.f)return this.c.splice(F,x,I.map(()=>!1));const d=this.c.get().map(_=>this.f.getId(this.d.element(_)).toString()),R=I.map(_=>d.indexOf(this.f.getId(_).toString())>-1);this.c.splice(F,x,R)}}function L(V){return V.tagName==="INPUT"||V.tagName==="TEXTAREA"}t.isInputElement=L;function N(V){return V.classList.contains("monaco-editor")?!0:V.classList.contains("monaco-list")||!V.parentElement?!1:N(V.parentElement)}t.isMonacoEditor=N;function E(V){return V.tagName==="A"&&V.classList.contains("monaco-button")||V.tagName==="DIV"&&V.classList.contains("monaco-button-dropdown")?!0:V.classList.contains("monaco-list")||!V.parentElement?!1:E(V.parentElement)}t.isButton=E;class g{get f(){return this.c.add(r.Event.chain(this.c.add(new M.DomEmitter(this.h.domNode,"keydown")).event).filter(F=>!L(F.target)).map(F=>new i.StandardKeyboardEvent(F)))}constructor(F,x,I){this.g=F,this.h=x,this.c=new e.DisposableStore,this.d=new e.DisposableStore,this.f.filter(d=>d.keyCode===3).on(this.k,this,this.c),this.f.filter(d=>d.keyCode===16).on(this.l,this,this.c),this.f.filter(d=>d.keyCode===18).on(this.o,this,this.c),this.f.filter(d=>d.keyCode===11).on(this.p,this,this.c),this.f.filter(d=>d.keyCode===12).on(this.q,this,this.c),this.f.filter(d=>d.keyCode===9).on(this.t,this,this.c),I.multipleSelectionSupport!==!1&&this.f.filter(d=>(n.isMacintosh?d.metaKey:d.ctrlKey)&&d.keyCode===31).on(this.s,this,this.d)}updateOptions(F){F.multipleSelectionSupport!==void 0&&(this.d.clear(),F.multipleSelectionSupport&&this.f.filter(x=>(n.isMacintosh?x.metaKey:x.ctrlKey)&&x.keyCode===31).on(this.s,this,this.d))}k(F){F.preventDefault(),F.stopPropagation(),this.g.setSelection(this.g.getFocus(),F.browserEvent)}l(F){F.preventDefault(),F.stopPropagation(),this.g.focusPrevious(1,!1,F.browserEvent);const x=this.g.getFocus()[0];this.g.setAnchor(x),this.g.reveal(x),this.h.domNode.focus()}o(F){F.preventDefault(),F.stopPropagation(),this.g.focusNext(1,!1,F.browserEvent);const x=this.g.getFocus()[0];this.g.setAnchor(x),this.g.reveal(x),this.h.domNode.focus()}p(F){F.preventDefault(),F.stopPropagation(),this.g.focusPreviousPage(F.browserEvent);const x=this.g.getFocus()[0];this.g.setAnchor(x),this.g.reveal(x),this.h.domNode.focus()}q(F){F.preventDefault(),F.stopPropagation(),this.g.focusNextPage(F.browserEvent);const x=this.g.getFocus()[0];this.g.setAnchor(x),this.g.reveal(x),this.h.domNode.focus()}s(F){F.preventDefault(),F.stopPropagation(),this.g.setSelection((0,h.range)(this.g.length),F.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus()}t(F){this.g.getSelection().length&&(F.preventDefault(),F.stopPropagation(),this.g.setSelection([],F.browserEvent),this.g.setAnchor(void 0),this.h.domNode.focus())}dispose(){this.c.dispose(),this.d.dispose()}}qe([P.memoize],g.prototype,"f",null);var m;(function(V){V[V.Automatic=0]="Automatic",V[V.Trigger=1]="Trigger"})(m||(t.TypeNavigationMode=m={}));var b;(function(V){V[V.Idle=0]="Idle",V[V.Typing=1]="Typing"})(b||(b={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(V){return V.ctrlKey||V.metaKey||V.altKey?!1:V.keyCode>=31&&V.keyCode<=56||V.keyCode>=21&&V.keyCode<=30||V.keyCode>=98&&V.keyCode<=107||V.keyCode>=85&&V.keyCode<=95}};class B{constructor(F,x,I,d,R){this.o=F,this.p=x,this.q=I,this.s=d,this.t=R,this.c=!1,this.d=b.Idle,this.f=m.Automatic,this.g=!1,this.h=-1,this.k=new e.DisposableStore,this.l=new e.DisposableStore,this.updateOptions(F.options)}updateOptions(F){F.typeNavigationEnabled??!0?this.u():this.v(),this.f=F.typeNavigationMode??m.Automatic}trigger(){this.g=!this.g}u(){if(this.c)return;let F=!1;const x=this.k.add(r.Event.chain(this.k.add(new M.DomEmitter(this.p.domNode,"keydown")).event)).filter(R=>!L(R.target)).filter(()=>this.f===m.Automatic||this.g).map(R=>new i.StandardKeyboardEvent(R)).filter(R=>F||this.s(R)).filter(R=>this.t.mightProducePrintableCharacter(R)).forEach(R=>y.EventHelper.stop(R,!0)).map(R=>R.browserEvent.key).event,I=r.Event.debounce(x,()=>null,800,void 0,void 0,void 0,this.k);r.Event.reduce(r.Event.any(x,I),(R,_)=>_===null?null:(R||"")+_,void 0,this.k)(this.z,this,this.k),I(this.w,this,this.k),x(()=>F=!0,void 0,this.k),I(()=>F=!1,void 0,this.k),this.c=!0,this.g=!1}v(){this.c&&(this.k.clear(),this.c=!1,this.g=!1)}w(){const F=this.o.getFocus();if(F.length>0&&F[0]===this.h){const x=this.o.options.accessibilityProvider?.getAriaLabel(this.o.element(F[0]));x&&(0,p.alert)(x)}this.h=-1}z(F){if(!F){this.d=b.Idle,this.g=!1;return}const x=this.o.getFocus(),I=x.length>0?x[0]:0,d=this.d===b.Idle?1:0;this.d=b.Typing;for(let R=0;R<this.o.length;R++){const _=(I+R+d)%this.o.length,Z=this.q.getKeyboardNavigationLabel(this.p.element(_)),k=Z&&Z.toString();if(typeof k>"u"||(0,l.matchesPrefix)(F,k)){this.h=I,this.o.setFocus([_]),this.o.reveal(_);return}}}dispose(){this.v(),this.k.dispose(),this.l.dispose()}}class G{constructor(F,x){this.d=F,this.f=x,this.c=new e.DisposableStore,this.c.add(r.Event.chain(this.c.add(new M.DomEmitter(x.domNode,"keydown")).event)).filter(d=>!L(d.target)).map(d=>new i.StandardKeyboardEvent(d)).filter(d=>d.keyCode===2&&!d.ctrlKey&&!d.metaKey&&!d.shiftKey&&!d.altKey).on(this.g,this,this.c)}g(F){if(F.target!==this.f.domNode)return;const x=this.d.getFocus();if(x.length===0)return;const I=this.f.domElement(x[0]);if(!I)return;const d=I.querySelector("[tabIndex]");if(!d||!(d instanceof HTMLElement)||d.tabIndex===-1)return;const R=window.getComputedStyle(d);R.visibility==="hidden"||R.display==="none"||(F.preventDefault(),F.stopPropagation(),d.focus())}dispose(){this.c.dispose()}}function J(V){return n.isMacintosh?V.browserEvent.metaKey:V.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=J;function ie(V){return V.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=ie;function le(V){return V instanceof MouseEvent&&V.button===2}const ge={isSelectionSingleChangeEvent:J,isSelectionRangeChangeEvent:ie};class ue{constructor(F){this.k=F,this.f=new e.DisposableStore,this.g=new r.Emitter,this.onPointer=this.g.event,F.options.multipleSelectionSupport!==!1&&(this.c=this.k.options.multipleSelectionController||ge),this.d=typeof F.options.mouseSupport>"u"||!!F.options.mouseSupport,this.d&&(F.onMouseDown(this.s,this,this.f),F.onContextMenu(this.t,this,this.f),F.onMouseDblClick(this.v,this,this.f),F.onTouchStart(this.s,this,this.f),this.f.add(W.Gesture.addTarget(F.getHTMLElement()))),r.Event.any(F.onMouseClick,F.onMouseMiddleClick,F.onTap)(this.u,this,this.f)}updateOptions(F){F.multipleSelectionSupport!==void 0&&(this.c=void 0,F.multipleSelectionSupport&&(this.c=this.k.options.multipleSelectionController||ge))}o(F){return this.c?this.c.isSelectionSingleChangeEvent(F):!1}p(F){return this.c?this.c.isSelectionRangeChangeEvent(F):!1}q(F){return this.o(F)||this.p(F)}s(F){N(F.browserEvent.target)||document.activeElement!==F.browserEvent.target&&this.k.domFocus()}t(F){if(L(F.browserEvent.target)||N(F.browserEvent.target))return;const x=typeof F.index>"u"?[]:[F.index];this.k.setFocus(x,F.browserEvent)}u(F){if(!this.d||L(F.browserEvent.target)||N(F.browserEvent.target))return;const x=F.index;if(typeof x>"u"){this.k.setFocus([],F.browserEvent),this.k.setSelection([],F.browserEvent),this.k.setAnchor(void 0);return}if(this.p(F))return this.w(F);if(this.q(F))return this.w(F);this.k.setFocus([x],F.browserEvent),this.k.setAnchor(x),le(F.browserEvent)||this.k.setSelection([x],F.browserEvent),this.g.fire(F)}v(F){if(L(F.browserEvent.target)||N(F.browserEvent.target)||this.q(F))return;const x=this.k.getFocus();this.k.setSelection(x,F.browserEvent)}w(F){const x=F.index;let I=this.k.getAnchor();if(this.p(F)){typeof I>"u"&&(I=this.k.getFocus()[0]??x,this.k.setAnchor(I));const d=Math.min(I,x),R=Math.max(I,x),_=(0,h.range)(d,R+1),Z=this.k.getSelection(),k=Se(Ae(Z,[I]),I);if(k.length===0)return;const T=Ae(_,Be(Z,k));this.k.setSelection(T,F.browserEvent),this.k.setFocus([x],F.browserEvent)}else if(this.o(F)){const d=this.k.getSelection(),R=d.filter(_=>_!==x);this.k.setFocus([x]),this.k.setAnchor(x),d.length===R.length?this.k.setSelection([...R,x],F.browserEvent):this.k.setSelection(R,F.browserEvent)}}dispose(){this.f.dispose()}}t.MouseController=ue;class de{constructor(F,x){this.c=F,this.d=x}style(F){const x=this.d&&`.${this.d}`,I=[];F.listBackground&&I.push(`.monaco-list${x} .monaco-list-rows { background: ${F.listBackground}; }`),F.listFocusBackground&&(I.push(`.monaco-list${x}:focus .monaco-list-row.focused { background-color: ${F.listFocusBackground}; }`),I.push(`.monaco-list${x}:focus .monaco-list-row.focused:hover { background-color: ${F.listFocusBackground}; }`)),F.listFocusForeground&&I.push(`.monaco-list${x}:focus .monaco-list-row.focused { color: ${F.listFocusForeground}; }`),F.listActiveSelectionBackground&&(I.push(`.monaco-list${x}:focus .monaco-list-row.selected { background-color: ${F.listActiveSelectionBackground}; }`),I.push(`.monaco-list${x}:focus .monaco-list-row.selected:hover { background-color: ${F.listActiveSelectionBackground}; }`)),F.listActiveSelectionForeground&&I.push(`.monaco-list${x}:focus .monaco-list-row.selected { color: ${F.listActiveSelectionForeground}; }`),F.listActiveSelectionIconForeground&&I.push(`.monaco-list${x}:focus .monaco-list-row.selected .codicon { color: ${F.listActiveSelectionIconForeground}; }`),F.listFocusAndSelectionBackground&&I.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.selected.focused { background-color: ${F.listFocusAndSelectionBackground}; }
			`),F.listFocusAndSelectionForeground&&I.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.selected.focused { color: ${F.listFocusAndSelectionForeground}; }
			`),F.listInactiveFocusForeground&&(I.push(`.monaco-list${x} .monaco-list-row.focused { color:  ${F.listInactiveFocusForeground}; }`),I.push(`.monaco-list${x} .monaco-list-row.focused:hover { color:  ${F.listInactiveFocusForeground}; }`)),F.listInactiveSelectionIconForeground&&I.push(`.monaco-list${x} .monaco-list-row.focused .codicon { color:  ${F.listInactiveSelectionIconForeground}; }`),F.listInactiveFocusBackground&&(I.push(`.monaco-list${x} .monaco-list-row.focused { background-color:  ${F.listInactiveFocusBackground}; }`),I.push(`.monaco-list${x} .monaco-list-row.focused:hover { background-color:  ${F.listInactiveFocusBackground}; }`)),F.listInactiveSelectionBackground&&(I.push(`.monaco-list${x} .monaco-list-row.selected { background-color:  ${F.listInactiveSelectionBackground}; }`),I.push(`.monaco-list${x} .monaco-list-row.selected:hover { background-color:  ${F.listInactiveSelectionBackground}; }`)),F.listInactiveSelectionForeground&&I.push(`.monaco-list${x} .monaco-list-row.selected { color: ${F.listInactiveSelectionForeground}; }`),F.listHoverBackground&&I.push(`.monaco-list${x}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${F.listHoverBackground}; }`),F.listHoverForeground&&I.push(`.monaco-list${x}:not(.drop-target):not(.dragging) .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${F.listHoverForeground}; }`);const d=(0,y.asCssValueWithDefault)(F.listFocusAndSelectionOutline,(0,y.asCssValueWithDefault)(F.listSelectionOutline,F.listFocusOutline??""));d&&I.push(`.monaco-list${x}:focus .monaco-list-row.focused.selected { outline: 1px solid ${d}; outline-offset: -1px;}`),F.listFocusOutline&&I.push(`
				.monaco-drag-image,
				.monaco-list${x}:focus .monaco-list-row.focused { outline: 1px solid ${F.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${x}.last-focused .monaco-list-row.focused { outline: 1px solid ${F.listFocusOutline}; outline-offset: -1px; }
			`);const R=(0,y.asCssValueWithDefault)(F.listSelectionOutline,F.listInactiveFocusOutline??"");R&&I.push(`.monaco-list${x} .monaco-list-row.focused.selected { outline: 1px dotted ${R}; outline-offset: -1px; }`),F.listSelectionOutline&&I.push(`.monaco-list${x} .monaco-list-row.selected { outline: 1px dotted ${F.listSelectionOutline}; outline-offset: -1px; }`),F.listInactiveFocusOutline&&I.push(`.monaco-list${x} .monaco-list-row.focused { outline: 1px dotted ${F.listInactiveFocusOutline}; outline-offset: -1px; }`),F.listHoverOutline&&I.push(`.monaco-list${x} .monaco-list-row:hover { outline: 1px dashed ${F.listHoverOutline}; outline-offset: -1px; }`),F.listDropBackground&&I.push(`
				.monaco-list${x}.drop-target,
				.monaco-list${x} .monaco-list-rows.drop-target,
				.monaco-list${x} .monaco-list-row.drop-target { background-color: ${F.listDropBackground} !important; color: inherit !important; }
			`),F.tableColumnsBorder&&I.push(`
				.monaco-table > .monaco-split-view2,
				.monaco-table > .monaco-split-view2 .monaco-sash.vertical::before,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${F.tableColumnsBorder};
				}

				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2,
				.monaco-workbench:not(.reduce-motion) .monaco-table > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: transparent;
				}
			`),F.tableOddRowsBackgroundColor&&I.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${F.tableOddRowsBackgroundColor};
				}
			`),this.c.textContent=I.join(`
`)}}t.DefaultStyleController=de,t.unthemedListStyles={listFocusBackground:"#7FB0D0",listActiveSelectionBackground:"#0E639C",listActiveSelectionForeground:"#FFFFFF",listActiveSelectionIconForeground:"#FFFFFF",listFocusAndSelectionOutline:"#90C2F9",listFocusAndSelectionBackground:"#094771",listFocusAndSelectionForeground:"#FFFFFF",listInactiveSelectionBackground:"#3F3F46",listInactiveSelectionIconForeground:"#FFFFFF",listHoverBackground:"#2A2D2E",listDropBackground:"#383B3D",treeIndentGuidesStroke:"#a9a9a9",treeInactiveIndentGuidesStroke:c.Color.fromHex("#a9a9a9").transparent(.4).toString(),tableColumnsBorder:c.Color.fromHex("#cccccc").transparent(.2).toString(),tableOddRowsBackgroundColor:c.Color.fromHex("#cccccc").transparent(.04).toString(),listBackground:void 0,listFocusForeground:void 0,listInactiveSelectionForeground:void 0,listInactiveFocusForeground:void 0,listInactiveFocusBackground:void 0,listHoverForeground:void 0,listFocusOutline:void 0,listInactiveFocusOutline:void 0,listSelectionOutline:void 0,listHoverOutline:void 0};const ce={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function Se(V,F){const x=V.indexOf(F);if(x===-1)return[];const I=[];let d=x-1;for(;d>=0&&V[d]===F-(x-d);)I.push(V[d--]);for(I.reverse(),d=x;d<V.length&&V[d]===F+(d-x);)I.push(V[d++]);return I}function Ae(V,F){const x=[];let I=0,d=0;for(;I<V.length||d<F.length;)if(I>=V.length)x.push(F[d++]);else if(d>=F.length)x.push(V[I++]);else if(V[I]===F[d]){x.push(V[I]),I++,d++;continue}else V[I]<F[d]?x.push(V[I++]):x.push(F[d++]);return x}function Be(V,F){const x=[];let I=0,d=0;for(;I<V.length||d<F.length;)if(I>=V.length)x.push(F[d++]);else if(d>=F.length)x.push(V[I++]);else if(V[I]===F[d]){I++,d++;continue}else V[I]<F[d]?x.push(V[I++]):d++;return x}const re=(V,F)=>V-F;class ne{constructor(F,x){this.c=F,this.d=x}get templateId(){return this.c}renderTemplate(F){return this.d.map(x=>x.renderTemplate(F))}renderElement(F,x,I,d){let R=0;for(const _ of this.d)_.renderElement(F,x,I[R++],d)}disposeElement(F,x,I,d){let R=0;for(const _ of this.d)_.disposeElement?.(F,x,I[R],d),R+=1}disposeTemplate(F){let x=0;for(const I of this.d)I.disposeTemplate(F[x++])}}class Q{constructor(F){this.c=F,this.templateId="a18n"}renderTemplate(F){return F}renderElement(F,x,I){const d=this.c.getAriaLabel(F);d?I.setAttribute("aria-label",d):I.removeAttribute("aria-label");const R=this.c.getAriaLevel&&this.c.getAriaLevel(F);typeof R=="number"?I.setAttribute("aria-level",`${R}`):I.removeAttribute("aria-level")}disposeTemplate(F){}}class oe{constructor(F,x){this.c=F,this.d=x}getDragElements(F){const x=this.c.getSelectedElements();return x.indexOf(F)>-1?x:[F]}getDragURI(F){return this.d.getDragURI(F)}getDragLabel(F,x){if(this.d.getDragLabel)return this.d.getDragLabel(F,x)}onDragStart(F,x){this.d.onDragStart?.(F,x)}onDragOver(F,x,I,d){return this.d.onDragOver(F,x,I,d)}onDragLeave(F,x,I,d){this.d.onDragLeave?.(F,x,I,d)}onDragEnd(F){this.d.onDragEnd?.(F)}drop(F,x,I,d){this.d.drop(F,x,I,d)}}class j{get onDidChangeFocus(){return r.Event.map(this.g.wrapEvent(this.c.onChange),F=>this.I(F),this.A)}get onDidChangeSelection(){return r.Event.map(this.g.wrapEvent(this.d.onChange),F=>this.I(F),this.A)}get domId(){return this.k.domId}get onDidScroll(){return this.k.onDidScroll}get onMouseClick(){return this.k.onMouseClick}get onMouseDblClick(){return this.k.onMouseDblClick}get onMouseMiddleClick(){return this.k.onMouseMiddleClick}get onPointer(){return this.w.onPointer}get onMouseUp(){return this.k.onMouseUp}get onMouseDown(){return this.k.onMouseDown}get onMouseOver(){return this.k.onMouseOver}get onMouseMove(){return this.k.onMouseMove}get onMouseOut(){return this.k.onMouseOut}get onTouchStart(){return this.k.onTouchStart}get onTap(){return this.k.onTap}get onContextMenu(){let F=!1;const x=this.A.add(r.Event.chain(this.A.add(new M.DomEmitter(this.k.domNode,"keydown")).event)).map(R=>new i.StandardKeyboardEvent(R)).filter(R=>F=R.keyCode===58||R.shiftKey&&R.keyCode===68).map(R=>y.EventHelper.stop(R,!0)).filter(()=>!1).event,I=this.A.add(r.Event.chain(this.A.add(new M.DomEmitter(this.k.domNode,"keyup")).event)).forEach(()=>F=!1).map(R=>new i.StandardKeyboardEvent(R)).filter(R=>R.keyCode===58||R.shiftKey&&R.keyCode===68).map(R=>y.EventHelper.stop(R,!0)).map(({browserEvent:R})=>{const _=this.getFocus(),Z=_.length?_[0]:void 0,k=typeof Z<"u"?this.k.element(Z):void 0,T=typeof Z<"u"?this.k.domElement(Z):this.k.domNode;return{index:Z,element:k,anchor:T,browserEvent:R}}).event,d=this.A.add(r.Event.chain(this.k.onContextMenu)).filter(R=>!F).map(({element:R,index:_,browserEvent:Z})=>({element:R,index:_,anchor:{x:Z.pageX+1,y:Z.pageY},browserEvent:Z})).event;return r.Event.any(x,I,d)}get onKeyDown(){return this.A.add(new M.DomEmitter(this.k.domNode,"keydown")).event}get onKeyUp(){return this.A.add(new M.DomEmitter(this.k.domNode,"keyup")).event}get onKeyPress(){return this.A.add(new M.DomEmitter(this.k.domNode,"keypress")).event}get onDidFocus(){return r.Event.signal(this.A.add(new M.DomEmitter(this.k.domNode,"focus",!0)).event)}get onDidBlur(){return r.Event.signal(this.A.add(new M.DomEmitter(this.k.domNode,"blur",!0)).event)}constructor(F,x,I,d,R=ce){this.C=F,this.D=R,this.c=new S("focused"),this.f=new S("anchor"),this.g=new r.EventBufferer,this.z="",this.A=new e.DisposableStore,this.B=new r.Emitter,this.onDidDispose=this.B.event;const _=this.D.accessibilityProvider&&this.D.accessibilityProvider.getWidgetRole?this.D.accessibilityProvider?.getWidgetRole():"list";this.d=new f(_!=="listbox");const Z=[this.c.renderer,this.d.renderer];this.u=R.accessibilityProvider,this.u&&(Z.push(new Q(this.u)),this.u.onDidChangeActiveDescendant?.(this.K,this,this.A)),d=d.map(T=>new ne(T.templateId,[...Z,T]));const k={...R,dnd:R.dnd&&new oe(this,R.dnd)};if(this.k=this.E(x,I,d,k),this.k.domNode.setAttribute("role",_),R.styleController)this.q=R.styleController(this.k.domId);else{const T=(0,y.createStyleSheet)(this.k.domNode);this.q=new de(T,this.k.domId)}if(this.o=new A.CombinedSpliceable([new v(this.c,this.k,R.identityProvider),new v(this.d,this.k,R.identityProvider),new v(this.f,this.k,R.identityProvider),this.k]),this.A.add(this.c),this.A.add(this.d),this.A.add(this.f),this.A.add(this.k),this.A.add(this.B),this.A.add(new G(this,this.k)),(typeof R.keyboardSupport!="boolean"||R.keyboardSupport)&&(this.v=new g(this,this.k,R),this.A.add(this.v)),R.keyboardNavigationLabelProvider){const T=R.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.t=new B(this,this.k,R.keyboardNavigationLabelProvider,R.keyboardNavigationEventFilter??(()=>!0),T),this.A.add(this.t)}this.w=this.F(R),this.A.add(this.w),this.onDidChangeFocus(this.J,this,this.A),this.onDidChangeSelection(this.L,this,this.A),this.u&&(this.ariaLabel=this.u.getWidgetAriaLabel()),this.D.multipleSelectionSupport!==!1&&this.k.domNode.setAttribute("aria-multiselectable","true")}E(F,x,I,d){return new w.ListView(F,x,I,d)}F(F){return new ue(this)}updateOptions(F={}){this.D={...this.D,...F},this.t?.updateOptions(this.D),this.D.multipleSelectionController!==void 0&&(this.D.multipleSelectionSupport?this.k.domNode.setAttribute("aria-multiselectable","true"):this.k.domNode.removeAttribute("aria-multiselectable")),this.w.updateOptions(F),this.v?.updateOptions(F),this.k.updateOptions(F)}get options(){return this.D}splice(F,x,I=[]){if(F<0||F>this.k.length)throw new s.ListError(this.C,`Invalid start index: ${F}`);if(x<0)throw new s.ListError(this.C,`Invalid delete count: ${x}`);x===0&&I.length===0||this.g.bufferEvents(()=>this.o.splice(F,x,I))}updateWidth(F){this.k.updateWidth(F)}updateElementHeight(F,x){this.k.updateElementHeight(F,x,null)}rerender(){this.k.rerender()}element(F){return this.k.element(F)}indexOf(F){return this.k.indexOf(F)}get length(){return this.k.length}get contentHeight(){return this.k.contentHeight}get onDidChangeContentHeight(){return this.k.onDidChangeContentHeight}get scrollTop(){return this.k.getScrollTop()}set scrollTop(F){this.k.setScrollTop(F)}get scrollLeft(){return this.k.getScrollLeft()}set scrollLeft(F){this.k.setScrollLeft(F)}get scrollHeight(){return this.k.scrollHeight}get renderHeight(){return this.k.renderHeight}get firstVisibleIndex(){return this.k.firstVisibleIndex}get lastVisibleIndex(){return this.k.lastVisibleIndex}get ariaLabel(){return this.z}set ariaLabel(F){this.z=F,this.k.domNode.setAttribute("aria-label",F)}domFocus(){this.k.domNode.focus({preventScroll:!0})}layout(F,x){this.k.layout(F,x)}triggerTypeNavigation(){this.t?.trigger()}setSelection(F,x){for(const I of F)if(I<0||I>=this.length)throw new s.ListError(this.C,`Invalid index ${I}`);this.d.set(F,x)}getSelection(){return this.d.get()}getSelectedElements(){return this.getSelection().map(F=>this.k.element(F))}setAnchor(F){if(typeof F>"u"){this.f.set([]);return}if(F<0||F>=this.length)throw new s.ListError(this.C,`Invalid index ${F}`);this.f.set([F])}getAnchor(){return(0,h.firstOrDefault)(this.f.get(),void 0)}getAnchorElement(){const F=this.getAnchor();return typeof F>"u"?void 0:this.element(F)}setFocus(F,x){for(const I of F)if(I<0||I>=this.length)throw new s.ListError(this.C,`Invalid index ${I}`);this.c.set(F,x)}focusNext(F=1,x=!1,I,d){if(this.length===0)return;const R=this.c.get(),_=this.G(R.length>0?R[0]+F:0,x,d);_>-1&&this.setFocus([_],I)}focusPrevious(F=1,x=!1,I,d){if(this.length===0)return;const R=this.c.get(),_=this.H(R.length>0?R[0]-F:0,x,d);_>-1&&this.setFocus([_],I)}async focusNextPage(F,x){let I=this.k.indexAt(this.k.getScrollTop()+this.k.renderHeight);I=I===0?0:I-1;const d=this.getFocus()[0];if(d!==I&&(d===void 0||I>d)){const R=this.H(I,!1,x);R>-1&&d!==R?this.setFocus([R],F):this.setFocus([I],F)}else{const R=this.k.getScrollTop();let _=R+this.k.renderHeight;I>d&&(_-=this.k.elementHeight(I)),this.k.setScrollTop(_),this.k.getScrollTop()!==R&&(this.setFocus([]),await(0,a.timeout)(0),await this.focusNextPage(F,x))}}async focusPreviousPage(F,x){let I;const d=this.k.getScrollTop();d===0?I=this.k.indexAt(d):I=this.k.indexAfter(d-1);const R=this.getFocus()[0];if(R!==I&&(R===void 0||R>=I)){const _=this.G(I,!1,x);_>-1&&R!==_?this.setFocus([_],F):this.setFocus([I],F)}else{const _=d;this.k.setScrollTop(d-this.k.renderHeight),this.k.getScrollTop()!==_&&(this.setFocus([]),await(0,a.timeout)(0),await this.focusPreviousPage(F,x))}}focusLast(F,x){if(this.length===0)return;const I=this.H(this.length-1,!1,x);I>-1&&this.setFocus([I],F)}focusFirst(F,x){this.focusNth(0,F,x)}focusNth(F,x,I){if(this.length===0)return;const d=this.G(F,!1,I);d>-1&&this.setFocus([d],x)}G(F,x=!1,I){for(let d=0;d<this.length;d++){if(F>=this.length&&!x)return-1;if(F=F%this.length,!I||I(this.element(F)))return F;F++}return-1}H(F,x=!1,I){for(let d=0;d<this.length;d++){if(F<0&&!x)return-1;if(F=(this.length+F%this.length)%this.length,!I||I(this.element(F)))return F;F--}return-1}getFocus(){return this.c.get()}getFocusedElements(){return this.getFocus().map(F=>this.k.element(F))}reveal(F,x){if(F<0||F>=this.length)throw new s.ListError(this.C,`Invalid index ${F}`);const I=this.k.getScrollTop(),d=this.k.elementTop(F),R=this.k.elementHeight(F);if((0,u.isNumber)(x)){const _=R-this.k.renderHeight;this.k.setScrollTop(_*(0,o.clamp)(x,0,1)+d)}else{const _=d+R,Z=I+this.k.renderHeight;d<I&&_>=Z||(d<I||_>=Z&&R>=this.k.renderHeight?this.k.setScrollTop(d):_>=Z&&this.k.setScrollTop(_-this.k.renderHeight))}}getRelativeTop(F){if(F<0||F>=this.length)throw new s.ListError(this.C,`Invalid index ${F}`);const x=this.k.getScrollTop(),I=this.k.elementTop(F),d=this.k.elementHeight(F);if(I<x||I+d>x+this.k.renderHeight)return null;const R=d-this.k.renderHeight;return Math.abs((x-I)/R)}isDOMFocused(){return this.k.domNode===document.activeElement}getHTMLElement(){return this.k.domNode}getElementID(F){return this.k.getElementDomId(F)}style(F){this.q.style(F)}I({indexes:F,browserEvent:x}){return{indexes:F,elements:F.map(I=>this.k.element(I)),browserEvent:x}}J(){const F=this.c.get();this.k.domNode.classList.toggle("element-focused",F.length>0),this.K()}K(){const F=this.c.get();if(F.length>0){let x;this.u?.getActiveDescendantId&&(x=this.u.getActiveDescendantId(this.k.element(F[0]))),this.k.domNode.setAttribute("aria-activedescendant",x||this.k.getElementDomId(F[0]))}else this.k.domNode.removeAttribute("aria-activedescendant")}L(){const F=this.d.get();this.k.domNode.classList.toggle("selection-none",F.length===0),this.k.domNode.classList.toggle("selection-single",F.length===1),this.k.domNode.classList.toggle("selection-multiple",F.length>1)}dispose(){this.B.fire(),this.A.dispose(),this.B.dispose()}}t.List=j,qe([P.memoize],j.prototype,"onDidChangeFocus",null),qe([P.memoize],j.prototype,"onDidChangeSelection",null),qe([P.memoize],j.prototype,"onContextMenu",null),qe([P.memoize],j.prototype,"onKeyDown",null),qe([P.memoize],j.prototype,"onKeyUp",null),qe([P.memoize],j.prototype,"onKeyPress",null),qe([P.memoize],j.prototype,"onDidFocus",null),qe([P.memoize],j.prototype,"onDidBlur",null)}),define(me[59],be([1,0,7,33,34,11,15]),function(te,t,y,M,i,W,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var A;(function(n){n[n.Paragraph=0]="Paragraph",n[n.Break=1]="Break"})(A||(t.MarkdownStringTextNewlineStyle=A={}));class h{constructor(u="",s=!1){if(this.value=u,typeof this.value!="string")throw(0,y.illegalArgument)("value");typeof s=="boolean"?(this.isTrusted=s,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=s.isTrusted??void 0,this.supportThemeIcons=s.supportThemeIcons??!1,this.supportHtml=s.supportHtml??!1)}appendText(u,s=0){return this.value+=r(this.supportThemeIcons?(0,M.escapeIcons)(u):u).replace(/([ \t]+)/g,(w,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,s===1?`\\
`:`

`),this}appendMarkdown(u){return this.value+=u,this}appendCodeblock(u,s){return this.value+="\n```",this.value+=u,this.value+=`
`,this.value+=s,this.value+="\n```\n",this}appendLink(u,s,w){return this.value+="[",this.value+=this.c(s,"]"),this.value+="](",this.value+=this.c(String(u),")"),w&&(this.value+=` "${this.c(this.c(w,'"'),")")}"`),this.value+=")",this}c(u,s){const w=new RegExp((0,W.escapeRegExpCharacters)(s),"g");return u.replace(w,(D,S)=>u.charAt(S-1)!=="\\"?`\\${D}`:D)}}t.MarkdownString=h;function a(n){return c(n)?!n.value:Array.isArray(n)?n.every(a):!0}t.isEmptyMarkdownString=a;function c(n){return n instanceof h?!0:n&&typeof n=="object"?typeof n.value=="string"&&(typeof n.isTrusted=="boolean"||typeof n.isTrusted=="object"||n.isTrusted===void 0)&&(typeof n.supportThemeIcons=="boolean"||n.supportThemeIcons===void 0):!1}t.isMarkdownString=c;function P(n,u){return n===u?!0:!n||!u?!1:n.value===u.value&&n.isTrusted===u.isTrusted&&n.supportThemeIcons===u.supportThemeIcons&&n.supportHtml===u.supportHtml&&(n.baseUri===u.baseUri||!!n.baseUri&&!!u.baseUri&&(0,i.isEqual)(p.URI.from(n.baseUri),p.URI.from(u.baseUri)))}t.markdownStringEqual=P;function r(n){return n.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=r;function l(n){return n.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=l;function e(n){return n&&n.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}t.removeMarkdownEscapes=e;function o(n){const u=[],s=n.split("|").map(D=>D.trim());n=s[0];const w=s[1];if(w){const D=/height=(\d+)/.exec(w),S=/width=(\d+)/.exec(w),f=D?D[1]:"",v=S?S[1]:"",L=isFinite(parseInt(v)),N=isFinite(parseInt(f));L&&u.push(`width="${v}"`),N&&u.push(`height="${f}"`)}return{href:n,dimensions:u}}t.parseHrefAndDimensions=o}),define(me[122],be([1,0,4,114,20,52,14,21,115,7,3,59,33,73,42,2,76,50,28,47,34,11,15]),function(te,t,y,M,i,W,p,A,h,a,c,P,r,l,e,o,n,u,s,w,D,S,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fillInIncompleteTokens=t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.allowedMarkdownAttr=t.renderMarkdown=void 0;const v=Object.freeze({image:(j,V,F)=>{let x=[],I=[];return j&&({href:j,dimensions:x}=(0,P.parseHrefAndDimensions)(j),I.push(`src="${(0,P.escapeDoubleQuotes)(j)}"`)),F&&I.push(`alt="${(0,P.escapeDoubleQuotes)(F)}"`),V&&I.push(`title="${(0,P.escapeDoubleQuotes)(V)}"`),x.length&&(I=I.concat(x)),"<img "+I.join(" ")+">"},paragraph:j=>`<p>${j}</p>`,link:(j,V,F)=>typeof j!="string"?"":(j===F&&(F=(0,P.removeMarkdownEscapes)(F)),V=typeof V=="string"?(0,P.escapeDoubleQuotes)((0,P.removeMarkdownEscapes)(V)):"",j=(0,P.removeMarkdownEscapes)(j),j=j.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${j}" title="${V||j}">${F}</a>`)});function L(j,V={},F={}){const x=new o.DisposableStore;let I=!1;const d=(0,W.createElement)(V),R=function(O){let $;try{$=(0,u.parse)(decodeURIComponent(O))}catch{}return $?($=(0,w.cloneAndChange)($,q=>{if(j.uris&&j.uris[q])return f.URI.revive(j.uris[q])}),encodeURIComponent(JSON.stringify($))):O},_=function(O,$){const q=j.uris&&j.uris[O];let ee=f.URI.revive(q);return $?O.startsWith(s.Schemas.data+":")?O:(ee||(ee=f.URI.parse(O)),s.FileAccess.uriToBrowserUri(ee).toString(!0)):!ee||f.URI.parse(O).toString()===ee.toString()?O:(ee.query&&(ee=ee.with({query:R(ee.query)})),ee.toString())},Z=new n.marked.Renderer;Z.image=v.image,Z.link=v.link,Z.paragraph=v.paragraph;const k=[],T=[];if(V.codeBlockRendererSync?Z.code=(O,$)=>{const q=l.defaultGenerator.nextId(),ee=V.codeBlockRendererSync(N($),O);return T.push([q,ee]),`<div class="code" data-code="${q}">${(0,S.escape)(O)}</div>`}:V.codeBlockRenderer&&(Z.code=(O,$)=>{const q=l.defaultGenerator.nextId(),ee=V.codeBlockRenderer(N($),O);return k.push(ee.then(se=>[q,se])),`<div class="code" data-code="${q}">${(0,S.escape)(O)}</div>`}),V.actionHandler){const O=function(ee){let se=ee.target;if(!(se.tagName!=="A"&&(se=se.parentElement,!se||se.tagName!=="A")))try{let ve=se.dataset.href;ve&&(j.baseUri&&(ve=E(f.URI.from(j.baseUri),ve)),V.actionHandler.callback(ve,ee))}catch(ve){(0,a.onUnexpectedError)(ve)}finally{ee.preventDefault()}},$=V.actionHandler.disposables.add(new i.DomEmitter(d,"click")),q=V.actionHandler.disposables.add(new i.DomEmitter(d,"auxclick"));V.actionHandler.disposables.add(c.Event.any($.event,q.event)(ee=>{const se=new A.StandardMouseEvent(ee);!se.leftButton&&!se.middleButton||O(se)})),V.actionHandler.disposables.add(y.addDisposableListener(d,"keydown",ee=>{const se=new p.StandardKeyboardEvent(ee);!se.equals(10)&&!se.equals(3)||O(se)}))}j.supportHtml||(F.sanitizer=O=>(j.isTrusted?O.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?O:"",F.sanitize=!0,F.silent=!0),F.renderer=Z;let H=j.value??"";H.length>1e5&&(H=`${H.substr(0,1e5)}\u2026`),j.supportThemeIcons&&(H=(0,r.markdownEscapeEscapedIcons)(H));let C;if(V.fillInIncompleteTokens){const O={...n.marked.defaults,...F},$=n.marked.lexer(H,O),q=ge($);C=n.marked.parser(q,O)}else C=n.marked.parse(H,F);j.supportThemeIcons&&(C=(0,h.renderLabelWithIcons)(C).map($=>typeof $=="string"?$:$.outerHTML).join(""));const z=new DOMParser().parseFromString(g(j,C),"text/html");if(z.body.querySelectorAll("img").forEach(O=>{const $=O.getAttribute("src");if($){let q=$;try{j.baseUri&&(q=E(f.URI.from(j.baseUri),q))}catch{}O.src=_(q,!0)}}),z.body.querySelectorAll("a").forEach(O=>{const $=O.getAttribute("href");if(O.setAttribute("href",""),!$||/^data:|javascript:/i.test($)||/^command:/i.test($)&&!j.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test($))O.replaceWith(...O.childNodes);else{let q=_($,!1);j.baseUri&&(q=E(f.URI.from(j.baseUri),$)),O.dataset.href=q}}),d.innerHTML=g(j,z.body.innerHTML),k.length>0)Promise.all(k).then(O=>{if(I)return;const $=new Map(O),q=d.querySelectorAll("div[data-code]");for(const ee of q){const se=$.get(ee.dataset.code??"");se&&y.reset(ee,se)}V.asyncRenderCallback?.()});else if(T.length>0){const O=new Map(T),$=d.querySelectorAll("div[data-code]");for(const q of $){const ee=O.get(q.dataset.code??"");ee&&y.reset(q,ee)}}if(V.asyncRenderCallback)for(const O of d.getElementsByTagName("img")){const $=x.add(y.addDisposableListener(O,"load",()=>{$.dispose(),V.asyncRenderCallback()}))}return{element:d,dispose:()=>{I=!0,x.dispose()}}}t.renderMarkdown=L;function N(j){if(!j)return"";const V=j.split(/[\s+|:|,|\{|\?]/,1);return V.length?V[0]:j}function E(j,V){return/^\w[\w\d+.-]*:/.test(V)?V:j.path.endsWith("/")?(0,D.resolvePath)(j,V).toString():(0,D.resolvePath)((0,D.dirname)(j),V).toString()}function g(j,V){const{config:F,allowedSchemes:x}=m(j);M.addHook("uponSanitizeAttribute",(d,R)=>{if(R.attrName==="style"||R.attrName==="class"){if(d.tagName==="SPAN"){if(R.attrName==="style"){R.keepAttr=/^(color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?(background-color\:(#[0-9a-fA-F]+|var\(--vscode(-[a-zA-Z]+)+\));)?$/.test(R.attrValue);return}else if(R.attrName==="class"){R.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(R.attrValue);return}}R.keepAttr=!1;return}});const I=y.hookDomPurifyHrefAndSrcSanitizer(x);try{return M.sanitize(V,{...F,RETURN_TRUSTED_TYPE:!0})}finally{M.removeHook("uponSanitizeAttribute"),I.dispose()}}t.allowedMarkdownAttr=["align","autoplay","alt","class","controls","data-code","data-href","height","href","loop","muted","playsinline","poster","src","style","target","title","width","start"];function m(j){const V=[s.Schemas.http,s.Schemas.https,s.Schemas.mailto,s.Schemas.data,s.Schemas.file,s.Schemas.vscodeFileResource,s.Schemas.vscodeRemote,s.Schemas.vscodeRemoteResource];return j.isTrusted&&V.push(s.Schemas.command),{config:{ALLOWED_TAGS:[...y.basicMarkupHtmlTags],ALLOWED_ATTR:t.allowedMarkdownAttr,ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:V}}function b(j){return typeof j=="string"?j:B(j)}t.renderStringAsPlaintext=b;function B(j){let V=j.value??"";V.length>1e5&&(V=`${V.substr(0,1e5)}\u2026`);const F=n.marked.parse(V,{renderer:J.value}).replace(/&(#\d+|[a-zA-Z]+);/g,x=>G.get(x)??x);return g({isTrusted:!1},F).toString()}t.renderMarkdownAsPlaintext=B;const G=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),J=new e.Lazy(()=>{const j=new n.marked.Renderer;return j.code=V=>V,j.blockquote=V=>V,j.html=V=>"",j.heading=(V,F,x)=>V+`
`,j.hr=()=>"",j.list=(V,F)=>V,j.listitem=V=>V+`
`,j.paragraph=V=>V+`
`,j.table=(V,F)=>V+F+`
`,j.tablerow=V=>V,j.tablecell=(V,F)=>V+" ",j.strong=V=>V,j.em=V=>V,j.codespan=V=>V,j.br=()=>`
`,j.del=V=>V,j.image=(V,F,x)=>"",j.text=V=>V,j.link=(V,F,x)=>x,j});function ie(j){let V="";return j.forEach(F=>{V+=F.raw}),V}function le(j){const V=j.tokens[0];if(V.type==="text"){const F=V.raw.split(`
`),x=F[F.length-1];if(x.includes("`"))return de(j);if(x.includes("**"))return re(j);if(x.match(/\*\w/))return ce(j);if(x.match(/(^|\s)__\w/))return ne(j);if(x.match(/(^|\s)_\w/))return Se(j);if(x.match(/(^|\s)\[.*\]\(\w*/))return Ae(j);if(x.match(/(^|\s)\[\w/))return Be(j)}}function ge(j){let V,F;for(V=0;V<j.length;V++){const x=j[V];if(x.type==="paragraph"&&x.raw.match(/(\n|^)```/)){F=ue(j.slice(V));break}if(x.type==="paragraph"&&x.raw.match(/(\n|^)\|/)){F=oe(j.slice(V));break}if(V===j.length-1&&x.type==="paragraph"){const I=le(x);if(I){F=[I];break}}}if(F){const x=[...j.slice(0,V),...F];return x.links=j.links,x}return j}t.fillInIncompleteTokens=ge;function ue(j){const V=ie(j);return n.marked.lexer(V+"\n```")}function de(j){return Q(j,"`")}function ce(j){return Q(j,"*")}function Se(j){return Q(j,"_")}function Ae(j){return Q(j,")")}function Be(j){return Q(j,"](about:blank)")}function re(j){return Q(j,"**")}function ne(j){return Q(j,"__")}function Q(j,V){const F=ie(Array.isArray(j)?j:[j]);return n.marked.lexer(F+V)[0]}function oe(j){const V=ie(j),F=V.split(`
`);let x,I=!1;for(let d=0;d<F.length;d++){const R=F[d].trim();if(typeof x>"u"&&R.match(/^\s*\|/)){const _=R.match(/(\|[^\|]+)(?=\||$)/g);_&&(x=_.length)}else if(typeof x=="number")if(R.match(/^\s*\|/)){if(d!==F.length-1)return;I=!0}else return}if(typeof x=="number"&&x>0){const d=I?F.slice(0,-1).join(`
`):V,R=!!d.match(/\|\s*$/),_=d+(R?"":"|")+`
|${" --- |".repeat(x)}`;return n.marked.lexer(_)}}}),define(me[123],be([1,0,4,9,27,59,33,2,6,99]),function(te,t,y,M,i,W,p,A,h,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function c(l,e){(0,h.isString)(e)?l.title=(0,p.stripIcons)(e):e?.markdownNotSupportedFallback?l.title=e.markdownNotSupportedFallback:l.removeAttribute("title")}t.setupNativeHover=c;class P{constructor(e,o,n){this.c=e,this.d=o,this.f=n}async update(e,o,n){if(this.b&&(this.b.dispose(!0),this.b=void 0),this.isDisposed)return;let u;if(e===void 0||(0,h.isString)(e)||e instanceof HTMLElement)u=e;else if(!(0,h.isFunction)(e.markdown))u=e.markdown??e.markdownNotSupportedFallback;else{this.a||this.g((0,a.localize)(0,null),o),this.b=new i.CancellationTokenSource;const s=this.b.token;if(u=await e.markdown(s),u===void 0&&(u=e.markdownNotSupportedFallback),this.isDisposed||s.isCancellationRequested)return}this.g(u,o,n)}g(e,o,n){const u=this.a;if(this.h(e)){const s={content:e,target:this.d,showPointer:this.c.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.f||!!u,...n};this.a=this.c.showHover(s,o)}u?.dispose()}h(e){return e?(0,W.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this.a?.isDisposed}dispose(){this.a?.dispose(),this.b?.dispose(!0),this.b=void 0}}function r(l,e,o,n){let u,s;const w=(L,N)=>{const E=s!==void 0;L&&(s?.dispose(),s=void 0),N&&(u?.dispose(),u=void 0),E&&l.onDidHideHover?.()},D=(L,N,E)=>new M.TimeoutTimer(async()=>{(!s||s.isDisposed)&&(s=new P(l,E||e,L>0),await s.update(o,N,n))},L),S=()=>{if(u)return;const L=new A.DisposableStore,N=m=>w(!1,m.fromElement===e);L.add(y.addDisposableListener(e,y.EventType.MOUSE_LEAVE,N,!0));const E=()=>w(!0,!0);L.add(y.addDisposableListener(e,y.EventType.MOUSE_DOWN,E,!0));const g={targetElements:[e],dispose:()=>{}};if(l.placement===void 0||l.placement==="mouse"){const m=b=>{g.x=b.x+10,b.target instanceof HTMLElement&&b.target.classList.contains("action-label")&&w(!0,!0)};L.add(y.addDisposableListener(e,y.EventType.MOUSE_MOVE,m,!0))}L.add(D(l.delay,!1,g)),u=L},f=y.addDisposableListener(e,y.EventType.MOUSE_OVER,S,!0);return{show:L=>{w(!1,!0),D(0,L)},hide:()=>{w(!0,!0)},update:async(L,N)=>{o=L,await s?.update(o,void 0,N)},dispose:()=>{f.dispose(),w(!0,!0)}}}t.setupCustomHover=r}),define(me[124],be([1,0,4,20,14,122,36,13,3,41,2,5,101,92]),function(te,t,y,M,i,W,p,A,h,a,c,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const l=y.$,e="selectOption.entry.template";class o{get templateId(){return e}renderTemplate(s){const w=Object.create(null);return w.root=s,w.text=y.append(s,l(".option-text")),w.detail=y.append(s,l(".option-detail")),w.decoratorRight=y.append(s,l(".option-decorator-right")),w}renderElement(s,w,D){const S=D,f=s.text,v=s.detail,L=s.decoratorRight,N=s.isDisabled;S.text.textContent=f,S.detail.textContent=v||"",S.decoratorRight.innerText=L||"",N?S.root.classList.add("option-disabled"):S.root.classList.remove("option-disabled")}disposeTemplate(s){}}class n extends c.Disposable{constructor(s,w,D,S,f){super(),this.k=[],this.y=0,this.C=!1,this.F=!1,this.H=!1,this.f=!1,this.n=S,this.g=f||Object.create(null),typeof this.g.minBottomMargin!="number"?this.g.minBottomMargin=n.a:this.g.minBottomMargin<0&&(this.g.minBottomMargin=0),this.h=document.createElement("select"),this.h.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.g.ariaLabel=="string"&&this.h.setAttribute("aria-label",this.g.ariaLabel),typeof this.g.ariaDescription=="string"&&this.h.setAttribute("aria-description",this.g.ariaDescription),this.m=new h.Emitter,this.B(this.m),this.J(),this.I(D),this.l=w||0,s&&this.setOptions(s,w),this.M()}getHeight(){return 22}getTemplateId(){return e}I(s){this.r=s,this.s=y.$(".monaco-select-box-dropdown-container"),this.s.classList.add("monaco-select-box-dropdown-padding"),this.D=y.append(this.s,l(".select-box-details-pane"));const w=y.append(this.s,l(".select-box-dropdown-container-width-control")),D=y.append(w,l(".width-control-div"));this.w=document.createElement("span"),this.w.className="option-text-width-control",y.append(D,this.w),this.z=0,this.t=y.createStyleSheet(this.s),this.s.setAttribute("draggable","true"),this.B(y.addDisposableListener(this.s,y.EventType.DRAG_START,S=>{y.EventHelper.stop(S,!0)}))}J(){this.B(y.addStandardDisposableListener(this.h,"change",w=>{this.l=w.target.selectedIndex,this.m.fire({index:w.target.selectedIndex,selected:w.target.value}),this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)})),this.B(y.addDisposableListener(this.h,y.EventType.CLICK,w=>{y.EventHelper.stop(w),this.f?this.R(!0):this.Q()})),this.B(y.addDisposableListener(this.h,y.EventType.MOUSE_DOWN,w=>{y.EventHelper.stop(w)}));let s;this.B(y.addDisposableListener(this.h,"touchstart",w=>{s=this.f})),this.B(y.addDisposableListener(this.h,"touchend",w=>{y.EventHelper.stop(w),s?this.R(!0):this.Q()})),this.B(y.addDisposableListener(this.h,y.EventType.KEY_DOWN,w=>{const D=new i.StandardKeyboardEvent(w);let S=!1;P.isMacintosh?(D.keyCode===18||D.keyCode===16||D.keyCode===10||D.keyCode===3)&&(S=!0):(D.keyCode===18&&D.altKey||D.keyCode===16&&D.altKey||D.keyCode===10||D.keyCode===3)&&(S=!0),S&&(this.Q(),y.EventHelper.stop(w,!0))}))}get onDidSelect(){return this.m.event}setOptions(s,w){A.equals(this.k,s)||(this.k=s,this.h.options.length=0,this.C=!1,this.G=void 0,this.k.forEach((D,S)=>{this.h.add(this.P(D.text,S,D.isDisabled)),typeof D.description=="string"&&(this.C=!0)})),w!==void 0&&(this.select(w),this.y=this.l)}L(){this.u?.splice(0,this.u.length,this.k)}select(s){s>=0&&s<this.k.length?this.l=s:s>this.k.length-1?this.select(this.k.length-1):this.l<0&&(this.l=0),this.h.selectedIndex=this.l,this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)}setAriaLabel(s){this.g.ariaLabel=s,this.h.setAttribute("aria-label",this.g.ariaLabel)}focus(){this.h&&(this.h.tabIndex=0,this.h.focus())}blur(){this.h&&(this.h.tabIndex=-1,this.h.blur())}setFocusable(s){this.h.tabIndex=s?0:-1}render(s){this.j=s,s.classList.add("select-container"),s.appendChild(this.h),this.N()}M(){const s=[];this.n.listFocusBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.n.listFocusBackground} !important; }`),this.n.listFocusForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.n.listFocusForeground} !important; }`),this.n.decoratorRightForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.n.decoratorRightForeground}; }`),this.n.selectBackground&&this.n.selectBorder&&this.n.selectBorder!==this.n.selectBackground?(s.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.n.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectBorder} } `)):this.n.selectListBorder&&(s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.n.selectListBorder} } `),s.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.n.selectListBorder} } `)),this.n.listHoverForeground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.n.listHoverForeground} !important; }`),this.n.listHoverBackground&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.n.listHoverBackground} !important; }`),this.n.listFocusOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.n.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.n.listHoverOutline&&s.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.n.listHoverOutline} !important; outline-offset: -1.6px !important; }`),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),s.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.t.textContent=s.join(`
`)}N(){const s=this.n.selectBackground??"",w=this.n.selectForeground??"",D=this.n.selectBorder??"";this.h.style.backgroundColor=s,this.h.style.color=w,this.h.style.borderColor=D}O(){const s=this.n.selectBackground??"",w=y.asCssValueWithDefault(this.n.selectListBackground,s);this.v.style.backgroundColor=w,this.D.style.backgroundColor=w;const D=this.n.focusBorder??"";this.s.style.outlineColor=D,this.s.style.outlineOffset="-1px",this.u.style(this.n)}P(s,w,D){const S=document.createElement("option");return S.value=s,S.text=s,S.disabled=!!D,S}Q(){this.D.innerText="",!(!this.r||this.f)&&(this.Y(this.s),this.L(),this.r.showContextView({getAnchor:()=>this.h,render:s=>this.S(s,!0),layout:()=>{this.W()},onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.f=!0,this.R(!1),this.r.showContextView({getAnchor:()=>this.h,render:s=>this.S(s),layout:()=>this.W(),onHide:()=>{this.s.classList.remove("visible"),this.h.classList.remove("synthetic-focus")},anchorPosition:this.z},this.g.optionsAsChildren?this.j:void 0),this.y=this.l,this.f=!0,this.h.setAttribute("aria-expanded","true"))}R(s){!this.r||!this.f||(this.f=!1,this.h.setAttribute("aria-expanded","false"),s&&this.h.focus(),this.r.hideContextView())}S(s,w){return s.appendChild(this.s),this.W(w),{dispose:()=>{try{s.removeChild(this.s)}catch{}}}}U(){let s=0;return this.k.forEach((w,D)=>{this.db(D),this.D.offsetHeight>s&&(s=this.D.offsetHeight)}),s}W(s){if(this.F)return!1;if(this.u){this.s.classList.add("visible");const w=y.getDomNodePagePosition(this.h),D=getComputedStyle(this.h),S=parseFloat(D.getPropertyValue("--dropdown-padding-top"))+parseFloat(D.getPropertyValue("--dropdown-padding-bottom")),f=window.innerHeight-w.top-w.height-(this.g.minBottomMargin||0),v=w.top-n.b,L=this.h.offsetWidth,N=this.X(this.w),E=Math.max(N,Math.round(L)).toString()+"px";this.s.style.width=E,this.u.getHTMLElement().style.height="",this.u.layout();let g=this.u.contentHeight;this.C&&this.G===void 0&&(this.G=this.U());const m=this.C?this.G:0,b=g+S+m,B=Math.floor((f-S-m)/this.getHeight()),G=Math.floor((v-S-m)/this.getHeight());if(s)return w.top+w.height>window.innerHeight-22||w.top<n.b||B<1&&G<1?!1:(B<n.c&&G>B&&this.k.length>B?(this.z=1,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.D),this.s.appendChild(this.v),this.D.classList.remove("border-top"),this.D.classList.add("border-bottom")):(this.z=0,this.s.removeChild(this.v),this.s.removeChild(this.D),this.s.appendChild(this.v),this.s.appendChild(this.D),this.D.classList.remove("border-bottom"),this.D.classList.add("border-top")),!0);if(w.top+w.height>window.innerHeight-22||w.top<n.b||this.z===0&&B<1||this.z===1&&G<1)return this.R(!0),!1;if(this.z===0){if(this.f&&B+G<1)return this.R(!0),!1;b>f&&(g=B*this.getHeight())}else b>v&&(g=G*this.getHeight());return this.u.layout(g),this.u.domFocus(),this.u.length>0&&(this.u.setFocus([this.l||0]),this.u.reveal(this.u.getFocus()[0]||0)),this.C?(this.u.getHTMLElement().style.height=g+S+"px",this.s.style.height=""):this.s.style.height=g+S+"px",this.db(this.l),this.s.style.width=E,this.v.setAttribute("tabindex","0"),this.h.classList.add("synthetic-focus"),this.s.classList.add("synthetic-focus"),!0}else return!1}X(s){let w=0;if(s){let D=0,S=0;this.k.forEach((f,v)=>{const L=f.detail?f.detail.length:0,N=f.decoratorRight?f.decoratorRight.length:0,E=f.text.length+L+N;E>S&&(D=v,S=E)}),s.textContent=this.k[D].text+(this.k[D].decoratorRight?this.k[D].decoratorRight+" ":""),w=y.getTotalWidth(s)}return w}Y(s){if(this.u)return;this.v=y.append(s,l(".select-box-dropdown-list-container")),this.p=new o,this.u=new p.List("SelectBoxCustom",this.v,this,[this.p],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:S=>{let f=S.text;return S.detail&&(f+=`. ${S.detail}`),S.decoratorRight&&(f+=`. ${S.decoratorRight}`),S.description&&(f+=`. ${S.description}`),f},getWidgetAriaLabel:()=>(0,r.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.g.ariaLabel&&(this.u.ariaLabel=this.g.ariaLabel);const w=this.B(new M.DomEmitter(this.v,"keydown")),D=h.Event.chain(w.event).filter(()=>this.u.length>0).map(S=>new i.StandardKeyboardEvent(S));this.B(D.filter(S=>S.keyCode===3).on(S=>this.fb(S),this)),this.B(D.filter(S=>S.keyCode===2).on(S=>this.fb(S),this)),this.B(D.filter(S=>S.keyCode===9).on(S=>this.eb(S),this)),this.B(D.filter(S=>S.keyCode===16).on(S=>this.hb(S),this)),this.B(D.filter(S=>S.keyCode===18).on(S=>this.gb(S),this)),this.B(D.filter(S=>S.keyCode===12).on(this.jb,this)),this.B(D.filter(S=>S.keyCode===11).on(this.ib,this)),this.B(D.filter(S=>S.keyCode===14).on(this.kb,this)),this.B(D.filter(S=>S.keyCode===13).on(this.lb,this)),this.B(D.filter(S=>S.keyCode>=21&&S.keyCode<=56||S.keyCode>=85&&S.keyCode<=113).on(this.mb,this)),this.B(y.addDisposableListener(this.u.getHTMLElement(),y.EventType.POINTER_UP,S=>this.Z(S))),this.B(this.u.onMouseOver(S=>typeof S.index<"u"&&this.u.setFocus([S.index]))),this.B(this.u.onDidChangeFocus(S=>this.cb(S))),this.B(y.addDisposableListener(this.s,y.EventType.FOCUS_OUT,S=>{!this.f||y.isAncestor(S.relatedTarget,this.s)||this.ab()})),this.u.getHTMLElement().setAttribute("aria-label",this.g.ariaLabel||""),this.u.getHTMLElement().setAttribute("aria-expanded","true"),this.O()}Z(s){if(!this.u.length)return;y.EventHelper.stop(s);const w=s.target;if(!w||w.classList.contains("slider"))return;const D=w.closest(".monaco-list-row");if(!D)return;const S=Number(D.getAttribute("data-index")),f=D.classList.contains("option-disabled");S>=0&&S<this.k.length&&!f&&(this.l=S,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.R(!0))}ab(){this.H||(this.l!==this.y&&this.select(this.y),this.R(!1))}bb(s,w){const D=f=>{for(let v=0;v<f.childNodes.length;v++){const L=f.childNodes.item(v);(L.tagName&&L.tagName.toLowerCase())==="img"?f.removeChild(L):D(L)}},S=(0,W.renderMarkdown)({value:s,supportThemeIcons:!0},{actionHandler:w});return S.element.classList.add("select-box-description-markdown"),D(S.element),S.element}cb(s){!this.f||!this.C||this.db(s.indexes[0])}db(s){this.D.innerText="";const w=this.k[s],D=w?.description??"",S=w?.descriptionIsMarkdown??!1;if(D){if(S){const f=w.descriptionMarkdownActionHandler;this.D.appendChild(this.bb(D,f))}else this.D.innerText=D;this.D.style.display="block"}else this.D.style.display="none";this.F=!0,this.r.layout(),this.F=!1}eb(s){y.EventHelper.stop(s),this.select(this.y),this.R(!0)}fb(s){y.EventHelper.stop(s),this.l!==this.y&&(this.y=this.l,this.m.fire({index:this.h.selectedIndex,selected:this.k[this.l].text}),this.k[this.l]&&this.k[this.l].text&&(this.h.title=this.k[this.l].text)),this.R(!0)}gb(s){if(this.l<this.k.length-1){y.EventHelper.stop(s,!0);const w=this.k[this.l+1].isDisabled;if(w&&this.k.length>this.l+2)this.l+=2;else{if(w)return;this.l++}this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0])}}hb(s){this.l>0&&(y.EventHelper.stop(s,!0),this.k[this.l-1].isDisabled&&this.l>1?this.l-=2:this.l--,this.select(this.l),this.u.setFocus([this.l]),this.u.reveal(this.u.getFocus()[0]))}ib(s){y.EventHelper.stop(s),this.u.focusPreviousPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l<this.k.length-1&&(this.l++,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}jb(s){y.EventHelper.stop(s),this.u.focusNextPage(),setTimeout(()=>{this.l=this.u.getFocus()[0],this.k[this.l].isDisabled&&this.l>0&&(this.l--,this.u.setFocus([this.l])),this.u.reveal(this.l),this.select(this.l)},1)}kb(s){y.EventHelper.stop(s),!(this.k.length<2)&&(this.l=0,this.k[this.l].isDisabled&&this.l>1&&this.l++,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}lb(s){y.EventHelper.stop(s),!(this.k.length<2)&&(this.l=this.k.length-1,this.k[this.l].isDisabled&&this.l>1&&this.l--,this.u.setFocus([this.l]),this.u.reveal(this.l),this.select(this.l))}mb(s){const w=a.KeyCodeUtils.toString(s.keyCode);let D=-1;for(let S=0;S<this.k.length-1;S++)if(D=(S+this.l+1)%this.k.length,this.k[D].text.charAt(0).toUpperCase()===w&&!this.k[D].isDisabled){this.select(D),this.u.setFocus([D]),this.u.reveal(this.u.getFocus()[0]),y.EventHelper.stop(s);break}}dispose(){this.R(!1),super.dispose()}}t.SelectBoxList=n,n.a=32,n.b=2,n.c=3}),define(me[125],be([1,0,36,124,118,19,5,91]),function(te,t,y,M,i,W,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.unthemedSelectBoxStyles=void 0,t.unthemedSelectBoxStyles={...y.unthemedListStyles,selectBackground:"#3C3C3C",selectForeground:"#F0F0F0",selectBorder:"#3C3C3C",decoratorRightForeground:void 0,selectListBackground:void 0,selectListBorder:void 0,focusBorder:void 0};class A extends W.Widget{constructor(a,c,P,r,l){super(),p.isMacintosh&&!l?.useCustomDrawn?this.a=new i.SelectBoxNative(a,c,r,l):this.a=new M.SelectBoxList(a,c,P,r,l),this.B(this.a)}get onDidSelect(){return this.a.onDidSelect}setOptions(a,c){this.a.setOptions(a,c)}select(a){this.a.select(a)}setAriaLabel(a){this.a.setAriaLabel(a)}focus(){this.a.focus()}blur(){this.a.blur()}setFocusable(a){this.a.setFocusable(a)}render(a){this.a.render(a)}}t.SelectBox=A}),define(me[60],be([1,0,18,51,4,23,123,125,31,2,5,6,96,48]),function(te,t,y,M,i,W,p,A,h,a,c,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class l extends a.Disposable{get action(){return this._action}constructor(u,s,w={}){super(),this.m=w,this._context=u||this,this._action=s,s instanceof h.Action&&this.B(s.onDidChange(D=>{this.element&&this.t(D)}))}t(u){u.enabled!==void 0&&this.u(),u.checked!==void 0&&this.G(),u.class!==void 0&&this.F(),u.label!==void 0&&(this.w(),this.C()),u.tooltip!==void 0&&this.C()}get actionRunner(){return this.j||(this.j=this.B(new h.ActionRunner)),this.j}set actionRunner(u){this.j=u}isEnabled(){return this._action.enabled}setActionContext(u){this._context=u}render(u){const s=this.element=u;this.B(W.Gesture.addTarget(u));const w=this.m&&this.m.draggable;w&&(u.draggable=!0,y.isFirefox&&this.B((0,i.addDisposableListener)(u,i.EventType.DRAG_START,D=>D.dataTransfer?.setData(M.DataTransfers.TEXT,this._action.label)))),this.B((0,i.addDisposableListener)(s,W.EventType.Tap,D=>this.onClick(D,!0))),this.B((0,i.addDisposableListener)(s,i.EventType.MOUSE_DOWN,D=>{w||i.EventHelper.stop(D,!0),this._action.enabled&&D.button===0&&s.classList.add("active")})),c.isMacintosh&&this.B((0,i.addDisposableListener)(s,i.EventType.CONTEXT_MENU,D=>{D.button===0&&D.ctrlKey===!0&&this.onClick(D)})),this.B((0,i.addDisposableListener)(s,i.EventType.CLICK,D=>{i.EventHelper.stop(D,!0),this.m&&this.m.isMenu||this.onClick(D)})),this.B((0,i.addDisposableListener)(s,i.EventType.DBLCLICK,D=>{i.EventHelper.stop(D,!0)})),[i.EventType.MOUSE_UP,i.EventType.MOUSE_OUT].forEach(D=>{this.B((0,i.addDisposableListener)(s,D,S=>{i.EventHelper.stop(S),s.classList.remove("active")}))})}onClick(u,s=!1){i.EventHelper.stop(u,!0);const w=P.isUndefinedOrNull(this._context)?this.m?.useEventAsContext?u:{preserveFocus:s}:this._context;this.actionRunner.run(this._action,w)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(u){this.element&&(this.element.tabIndex=u?0:-1)}get trapsArrowNavigation(){return!1}u(){}w(){}z(){return this.action.tooltip}C(){if(!this.element)return;const u=this.z()??"";this.D(),this.m.hoverDelegate?(this.element.title="",this.f?this.f.update(u):(this.f=(0,p.setupCustomHover)(this.m.hoverDelegate,this.element,u),this.q.add(this.f))):this.element.title=u}D(){if(this.element){const u=this.z()??"";this.element.setAttribute("aria-label",u)}}F(){}G(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),this._context=void 0,super.dispose()}}t.BaseActionViewItem=l;class e extends l{constructor(u,s,w){super(u,s,w),this.m=w,this.m.icon=w.icon!==void 0?w.icon:!1,this.m.label=w.label!==void 0?w.label:!0,this.I=""}render(u){super.render(u),this.element&&(this.p=(0,i.append)(this.element,(0,i.$)("a.action-label"))),this.p&&(this._action.id===h.Separator.ID?this.p.setAttribute("role","presentation"):this.m.isMenu?this.p.setAttribute("role","menuitem"):this.p.setAttribute("role","button")),this.m.label&&this.m.keybinding&&this.element&&((0,i.append)(this.element,(0,i.$)("span.keybinding")).textContent=this.m.keybinding),this.F(),this.w(),this.C(),this.u(),this.G()}focus(){this.p&&(this.p.tabIndex=0,this.p.focus())}isFocused(){return!!this.p&&this.p?.tabIndex===0}blur(){this.p&&(this.p.tabIndex=-1)}setFocusable(u){this.p&&(this.p.tabIndex=u?0:-1)}w(){this.m.label&&this.p&&(this.p.textContent=this.action.label)}z(){let u=null;return this.action.tooltip?u=this.action.tooltip:!this.m.label&&this.action.label&&this.m.icon&&(u=this.action.label,this.m.keybinding&&(u=r.localize(0,null,u,this.m.keybinding))),u??void 0}F(){this.I&&this.p&&this.p.classList.remove(...this.I.split(" ")),this.m.icon?(this.I=this.action.class,this.p&&(this.p.classList.add("codicon"),this.I&&this.p.classList.add(...this.I.split(" "))),this.u()):this.p?.classList.remove("codicon")}u(){this.action.enabled?(this.p&&(this.p.removeAttribute("aria-disabled"),this.p.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.p&&(this.p.setAttribute("aria-disabled","true"),this.p.classList.add("disabled")),this.element?.classList.add("disabled"))}D(){if(this.p){const u=this.z()??"";this.p.setAttribute("aria-label",u)}}G(){this.p&&(this.action.checked?this.p.classList.add("checked"):this.p.classList.remove("checked"))}}t.ActionViewItem=e;class o extends l{constructor(u,s,w,D,S,f,v){super(u,s),this.b=new A.SelectBox(w,D,S,f,v),this.b.setFocusable(!1),this.B(this.b),this.g()}setOptions(u,s){this.b.setOptions(u,s)}select(u){this.b.select(u)}g(){this.B(this.b.onDidSelect(u=>this.k(u.selected,u.index)))}k(u,s){this.actionRunner.run(this._action,this.n(u,s))}n(u,s){return u}setFocusable(u){this.b.setFocusable(u)}focus(){this.b?.focus()}blur(){this.b?.blur()}render(u){this.b.render(u)}}t.SelectActionViewItem=o}),define(me[61],be([1,0,4,14,60,31,3,2,6,48]),function(te,t,y,M,i,W,p,A,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var a;(function(r){r[r.HORIZONTAL=0]="HORIZONTAL",r[r.VERTICAL=1]="VERTICAL"})(a||(t.ActionsOrientation=a={}));class c extends A.Disposable{constructor(l,e={}){super(),this.g=this.B(new A.DisposableStore),this.n=this.B(new A.DisposableMap),this.t=!1,this.u=!0,this.w=this.B(new p.Emitter),this.onDidBlur=this.w.event,this.y=this.B(new p.Emitter({onWillAddFirstListener:()=>this.z=!0})),this.onDidCancel=this.y.event,this.z=!1,this.C=this.B(new p.Emitter),this.onDidRun=this.C.event,this.D=this.B(new p.Emitter),this.onWillRun=this.D.event,this.b=e,this.j=e.context??null,this.l=this.b.orientation??0,this.m={keyDown:this.b.triggerKeys?.keyDown??!1,keys:this.b.triggerKeys?.keys??[3,10]},this.b.actionRunner?this.f=this.b.actionRunner:(this.f=new W.ActionRunner,this.g.add(this.f)),this.g.add(this.f.onDidRun(u=>this.C.fire(u))),this.g.add(this.f.onWillRun(u=>this.D.fire(u))),this.viewItems=[],this.r=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let o,n;switch(this.l){case 0:o=[15],n=[17];break;case 1:o=[16],n=[18],this.domNode.className+=" vertical";break}this.B(y.addDisposableListener(this.domNode,y.EventType.KEY_DOWN,u=>{const s=new M.StandardKeyboardEvent(u);let w=!0;const D=typeof this.r=="number"?this.viewItems[this.r]:void 0;o&&(s.equals(o[0])||s.equals(o[1]))?w=this.M():n&&(s.equals(n[0])||s.equals(n[1]))?w=this.L():s.equals(9)&&this.z?this.y.fire():s.equals(14)?w=this.I():s.equals(13)?w=this.J():s.equals(2)&&D instanceof i.BaseActionViewItem&&D.trapsArrowNavigation?w=this.L():this.G(s)?this.m.keyDown?this.O(s):this.t=!0:w=!1,w&&(s.preventDefault(),s.stopPropagation())})),this.B(y.addDisposableListener(this.domNode,y.EventType.KEY_UP,u=>{const s=new M.StandardKeyboardEvent(u);this.G(s)?(!this.m.keyDown&&this.t&&(this.t=!1,this.O(s)),s.preventDefault(),s.stopPropagation()):(s.equals(2)||s.equals(1026))&&this.H()})),this.s=this.B(y.trackFocus(this.domNode)),this.B(this.s.onDidBlur(()=>{(y.getActiveElement()===this.domNode||!y.isAncestor(y.getActiveElement(),this.domNode))&&(this.w.fire(),this.r=void 0,this.p=void 0,this.t=!1)})),this.B(this.s.onDidFocus(()=>this.H())),this.v=document.createElement("ul"),this.v.className="actions-container",this.v.setAttribute("role",this.b.ariaRole||"toolbar"),this.b.ariaLabel&&this.v.setAttribute("aria-label",this.b.ariaLabel),this.domNode.appendChild(this.v),l.appendChild(this.domNode)}F(){this.length()>=2?this.v.setAttribute("role",this.b.ariaRole||"toolbar"):this.v.setAttribute("role","presentation")}setAriaLabel(l){l?this.v.setAttribute("aria-label",l):this.v.removeAttribute("aria-label")}setFocusable(l){if(this.u=l,this.u){const e=this.viewItems.find(o=>o instanceof i.BaseActionViewItem&&o.isEnabled());e instanceof i.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof i.BaseActionViewItem&&e.setFocusable(!1)})}G(l){let e=!1;return this.m.keys.forEach(o=>{e=e||l.equals(o)}),e}H(){for(let l=0;l<this.v.children.length;l++){const e=this.v.children[l];if(y.isAncestor(y.getActiveElement(),e)){this.r=l;break}}}get context(){return this.j}set context(l){this.j=l,this.viewItems.forEach(e=>e.setActionContext(l))}get actionRunner(){return this.f}set actionRunner(l){this.f=l,this.g.clear(),this.g.add(this.f.onDidRun(e=>this.C.fire(e))),this.g.add(this.f.onWillRun(e=>this.D.fire(e))),this.viewItems.forEach(e=>e.actionRunner=l)}getContainer(){return this.domNode}hasAction(l){return this.viewItems.findIndex(e=>e.action.id===l.id)!==-1}getAction(l){if(typeof l=="number")return this.viewItems[l]?.action;if(l instanceof HTMLElement){for(;l.parentElement!==this.v;){if(!l.parentElement)return;l=l.parentElement}for(let e=0;e<this.v.childNodes.length;e++)if(this.v.childNodes[e]===l)return this.viewItems[e].action}}push(l,e={}){const o=Array.isArray(l)?l:[l];let n=h.isNumber(e.index)?e.index:null;o.forEach(u=>{const s=document.createElement("li");s.className="action-item",s.setAttribute("role","presentation");let w;const D={hoverDelegate:this.b.hoverDelegate,...e};this.b.actionViewItemProvider&&(w=this.b.actionViewItemProvider(u,D)),w||(w=new i.ActionViewItem(this.context,u,D)),this.b.allowContextMenu||this.n.set(w,y.addDisposableListener(s,y.EventType.CONTEXT_MENU,S=>{y.EventHelper.stop(S,!0)})),w.actionRunner=this.f,w.setActionContext(this.context),w.render(s),this.u&&w instanceof i.BaseActionViewItem&&this.viewItems.length===0&&w.setFocusable(!0),n===null||n<0||n>=this.v.children.length?(this.v.appendChild(s),this.viewItems.push(w)):(this.v.insertBefore(s,this.v.children[n]),this.viewItems.splice(n,0,w),n++)}),typeof this.r=="number"&&this.focus(this.r),this.F()}getWidth(l){if(l>=0&&l<this.v.children.length){const e=this.v.children.item(l);if(e)return e.clientWidth}return 0}getHeight(l){if(l>=0&&l<this.v.children.length){const e=this.v.children.item(l);if(e)return e.clientHeight}return 0}pull(l){l>=0&&l<this.viewItems.length&&(this.v.removeChild(this.v.childNodes[l]),this.n.deleteAndDispose(this.viewItems[l]),(0,A.dispose)(this.viewItems.splice(l,1)),this.F())}clear(){this.isEmpty()||(this.viewItems=(0,A.dispose)(this.viewItems),this.n.clearAndDisposeAll(),y.clearNode(this.v),this.F())}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(l){let e=!1,o;if(l===void 0?e=!0:typeof l=="number"?o=l:typeof l=="boolean"&&(e=l),e&&typeof this.r>"u"){const n=this.viewItems.findIndex(u=>u.isEnabled());this.r=n===-1?void 0:n,this.N(void 0,void 0,!0)}else o!==void 0&&(this.r=o),this.N(void 0,void 0,!0)}I(){return this.r=this.length()-1,this.L(!0)}J(){return this.r=0,this.M(!0)}L(l){if(typeof this.r>"u")this.r=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.r;let o;do{if(!l&&this.b.preventLoopNavigation&&this.r+1>=this.viewItems.length)return this.r=e,!1;this.r=(this.r+1)%this.viewItems.length,o=this.viewItems[this.r]}while(this.r!==e&&(this.b.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===W.Separator.ID));return this.N(),!0}M(l){if(typeof this.r>"u")this.r=0;else if(this.viewItems.length<=1)return!1;const e=this.r;let o;do{if(this.r=this.r-1,this.r<0){if(!l&&this.b.preventLoopNavigation)return this.r=e,!1;this.r=this.viewItems.length-1}o=this.viewItems[this.r]}while(this.r!==e&&(this.b.focusOnlyEnabledItems&&!o.isEnabled()||o.action.id===W.Separator.ID));return this.N(!0),!0}N(l,e,o=!1){typeof this.r>"u"&&this.v.focus({preventScroll:e}),this.p!==void 0&&this.p!==this.r&&this.viewItems[this.p]?.blur();const n=this.r!==void 0&&this.viewItems[this.r];if(n){let u=!0;h.isFunction(n.focus)||(u=!1),this.b.focusOnlyEnabledItems&&h.isFunction(n.isEnabled)&&!n.isEnabled()&&(u=!1),n.action.id===W.Separator.ID&&(u=!1),u?(o||this.p!==this.r)&&(n.focus(l),this.p=this.r):(this.v.focus({preventScroll:e}),this.p=void 0)}}O(l){if(typeof this.r>"u")return;const e=this.viewItems[this.r];if(e instanceof i.BaseActionViewItem){const o=e._context===null||e._context===void 0?l:e._context;this.run(e._action,o)}}async run(l,e){await this.f.run(l,e)}dispose(){this.j=void 0,this.viewItems=(0,A.dispose)(this.viewItems),this.getContainer().remove(),super.dispose()}}t.ActionBar=c;function P(r){if(!r.length)return r;let l=-1;for(let o=0;o<r.length;o++)if(r[o].id!==W.Separator.ID){l=o;break}if(l===-1)return[];r=r.slice(l);for(let o=r.length-1;o>=0&&r[o].id===W.Separator.ID;o--)r.splice(o,1);let e=!1;for(let o=r.length-1;o>=0;o--){const n=r[o].id===W.Separator.ID;n&&!e?r.splice(o,1):n?n&&(e=!1):e=!0}return r}t.prepareActions=P}),define(me[62],be([1,0,4,20,52,61,54,57,19,3,78,47,100,88]),function(te,t,y,M,i,W,p,A,h,a,c,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.unthemedInboxStyles=t.MessageType=void 0;const l=y.$;var e;(function(u){u[u.INFO=1]="INFO",u[u.WARNING=2]="WARNING",u[u.ERROR=3]="ERROR"})(e||(t.MessageType=e={})),t.unthemedInboxStyles={inputBackground:"#3C3C3C",inputForeground:"#CCCCCC",inputValidationInfoBorder:"#55AAFF",inputValidationInfoBackground:"#063B49",inputValidationWarningBorder:"#B89500",inputValidationWarningBackground:"#352A05",inputValidationErrorBorder:"#BE1100",inputValidationErrorBackground:"#5A1D1D",inputBorder:void 0,inputValidationErrorForeground:void 0,inputValidationInfoForeground:void 0,inputValidationWarningForeground:void 0};class o extends h.Widget{constructor(s,w,D){super(),this.s="idle",this.y=Number.POSITIVE_INFINITY,this.I=this.B(new a.Emitter),this.onDidChange=this.I.event,this.J=this.B(new a.Emitter),this.onDidHeightChange=this.J.event,this.a=w,this.g=D,this.h=null,this.i=this.g.placeholder||"",this.l=this.g.tooltip??(this.i||""),this.n=this.g.ariaLabel||"",this.g.validationOptions&&(this.r=this.g.validationOptions.validation),this.element=y.append(s,l(".monaco-inputbox.idle"));const S=this.g.flexibleHeight?"textarea":"input",f=y.append(this.element,l(".ibwrapper"));if(this.b=y.append(f,l(S+".input.empty")),this.b.setAttribute("autocorrect","off"),this.b.setAttribute("autocapitalize","off"),this.b.setAttribute("spellcheck","false"),this.D(this.b,()=>this.element.classList.add("synthetic-focus")),this.C(this.b,()=>this.element.classList.remove("synthetic-focus")),this.g.flexibleHeight){this.y=typeof this.g.flexibleMaxHeight=="number"?this.g.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.t=y.append(f,l("div.mirror")),this.t.innerText="\xA0",this.H=new A.ScrollableElement(this.element,{vertical:1}),this.g.flexibleWidth&&(this.b.setAttribute("wrap","off"),this.t.style.whiteSpace="pre",this.t.style.wordWrap="initial"),y.append(s,this.H.getDomNode()),this.B(this.H),this.B(this.H.onScroll(N=>this.b.scrollTop=N.scrollTop));const v=this.B(new M.DomEmitter(document,"selectionchange")),L=a.Event.filter(v.event,()=>document.getSelection()?.anchorNode===f);this.B(L(this.N,this)),this.B(this.onDidHeightChange(this.N,this))}else this.b.type=this.g.type||"text",this.b.setAttribute("wrap","off");this.n&&this.b.setAttribute("aria-label",this.n),this.i&&!this.g.showPlaceholderOnFocus&&this.setPlaceHolder(this.i),this.l&&this.setTooltip(this.l),this.z(this.b,()=>this.R()),this.C(this.b,()=>this.L()),this.D(this.b,()=>this.M()),this.B(this.G(this.b)),setTimeout(()=>this.S(),0),this.g.actions&&(this.c=this.B(new W.ActionBar(this.element)),this.c.push(this.g.actions,{icon:!0,label:!1})),this.U()}L(){this.Q(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder","")}M(){this.P(),this.g.showPlaceholderOnFocus&&this.b.setAttribute("placeholder",this.i||"")}setPlaceHolder(s){this.i=s,this.b.setAttribute("placeholder",s)}setTooltip(s){this.l=s,this.b.title=s}setAriaLabel(s){this.n=s,s?this.b.setAttribute("aria-label",this.n):this.b.removeAttribute("aria-label")}getAriaLabel(){return this.n}get mirrorElement(){return this.t}get inputElement(){return this.b}get value(){return this.b.value}set value(s){this.b.value!==s&&(this.b.value=s,this.R())}get step(){return this.b.step}set step(s){this.b.step=s}get height(){return typeof this.v=="number"?this.v:y.getTotalHeight(this.element)}focus(){this.b.focus()}blur(){this.b.blur()}hasFocus(){return document.activeElement===this.b}select(s=null){this.b.select(),s&&(this.b.setSelectionRange(s.start,s.end),s.end===this.b.value.length&&(this.b.scrollLeft=this.b.scrollWidth))}isSelectionAtEnd(){return this.b.selectionEnd===this.b.value.length&&this.b.selectionStart===this.b.selectionEnd}enable(){this.b.removeAttribute("disabled")}disable(){this.blur(),this.b.disabled=!0,this.Q()}setEnabled(s){s?this.enable():this.disable()}get width(){return y.getTotalWidth(this.b)}set width(s){if(this.g.flexibleHeight&&this.g.flexibleWidth){let w=0;if(this.t){const D=parseFloat(this.t.style.paddingLeft||"")||0,S=parseFloat(this.t.style.paddingRight||"")||0;w=D+S}this.b.style.width=s-w+"px"}else this.b.style.width=s+"px";this.t&&(this.t.style.width=s+"px")}set paddingRight(s){this.b.style.width=`calc(100% - ${s}px)`,this.t&&(this.t.style.paddingRight=s+"px")}N(){if(typeof this.w!="number"||typeof this.v!="number"||!this.H)return;const s=this.w,w=this.v,D=this.b.scrollTop;this.H.setScrollDimensions({scrollHeight:s,height:w}),this.H.setScrollPosition({scrollTop:D})}showMessage(s,w){if(this.s==="open"&&(0,P.equals)(this.h,s))return;this.h=s,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.O(s.type));const D=this.stylesForType(this.h.type);this.element.style.border=`1px solid ${y.asCssValueWithDefault(D.border,"transparent")}`,this.h.content&&(this.hasFocus()||w)&&this.P()}hideMessage(){this.h=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this.Q(),this.U()}isInputValid(){return!!this.r&&!this.r(this.value)}validate(){let s=null;return this.r&&(s=this.r(this.value),s?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(s)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),s?.type}stylesForType(s){const w=this.g.inputBoxStyles;switch(s){case 1:return{border:w.inputValidationInfoBorder,background:w.inputValidationInfoBackground,foreground:w.inputValidationInfoForeground};case 2:return{border:w.inputValidationWarningBorder,background:w.inputValidationWarningBackground,foreground:w.inputValidationWarningForeground};default:return{border:w.inputValidationErrorBorder,background:w.inputValidationErrorBackground,foreground:w.inputValidationErrorForeground}}}O(s){switch(s){case 1:return"info";case 2:return"warning";default:return"error"}}P(){if(!this.a||!this.h)return;let s;const w=()=>s.style.width=y.getTotalWidth(this.element)+"px";this.a.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:S=>{if(!this.h)return null;s=y.append(S,l(".monaco-inputbox-container")),w();const f={inline:!0,className:"monaco-inputbox-message"},v=this.h.formatContent?(0,i.renderFormattedText)(this.h.content,f):(0,i.renderText)(this.h.content,f);v.classList.add(this.O(this.h.type));const L=this.stylesForType(this.h.type);return v.style.backgroundColor=L.background??"",v.style.color=L.foreground??"",v.style.border=L.border?`1px solid ${L.border}`:"",y.append(s,v),null},onHide:()=>{this.s="closed"},layout:w});let D;this.h.type===3?D=r.localize(0,null,this.h.content):this.h.type===2?D=r.localize(1,null,this.h.content):D=r.localize(2,null,this.h.content),p.alert(D),this.s="open"}Q(){this.a&&(this.s==="open"&&this.a.hideContextView(),this.s="idle")}R(){this.I.fire(this.value),this.validate(),this.S(),this.b.classList.toggle("empty",!this.value),this.s==="open"&&this.a&&this.a.layout()}S(){if(!this.t)return;const s=this.value,D=s.charCodeAt(s.length-1)===10?" ":"";(s+D).replace(/\u000c/g,"")?this.t.textContent=s+D:this.t.innerText="\xA0",this.layout()}U(){const s=this.g.inputBoxStyles,w=s.inputBackground??"",D=s.inputForeground??"",S=s.inputBorder??"";this.element.style.backgroundColor=w,this.element.style.color=D,this.b.style.backgroundColor="inherit",this.b.style.color=D,this.element.style.border=`1px solid ${y.asCssValueWithDefault(S,"transparent")}`}layout(){if(!this.t)return;const s=this.w;this.w=y.getTotalHeight(this.t),s!==this.w&&(this.v=Math.min(this.w,this.y),this.b.style.height=this.v+"px",this.J.fire(this.w))}insertAtCursor(s){const w=this.inputElement,D=w.selectionStart,S=w.selectionEnd,f=w.value;D!==null&&S!==null&&(this.value=f.substr(0,D)+s+f.substr(S),w.setSelectionRange(D+1,D+1),this.layout())}dispose(){this.Q(),this.h=null,this.c?.dispose(),super.dispose()}}t.InputBox=o;class n extends o{constructor(s,w,D){const S=r.localize(3,null),f=` or \u21C5 ${S}`,v=` (\u21C5 ${S})`;super(s,w,D),this.Y=this.B(new a.Emitter),this.onDidFocus=this.Y.event,this.Z=this.B(new a.Emitter),this.onDidBlur=this.Z.event,this.W=new c.HistoryNavigator(D.history,100);const L=()=>{if(D.showHistoryHint&&D.showHistoryHint()&&!this.i.endsWith(f)&&!this.i.endsWith(v)&&this.W.getHistory().length){const N=this.i.endsWith(")")?f:v,E=this.i+N;D.showPlaceholderOnFocus&&document.activeElement!==this.b?this.i=E:this.setPlaceHolder(E)}};this.X=new MutationObserver((N,E)=>{N.forEach(g=>{g.target.textContent||L()})}),this.X.observe(this.b,{attributeFilter:["class"]}),this.D(this.b,()=>L()),this.C(this.b,()=>{const N=E=>{if(this.i.endsWith(E)){const g=this.i.slice(0,this.i.length-E.length);return D.showPlaceholderOnFocus?this.i=g:this.setPlaceHolder(g),!0}else return!1};N(v)||N(f)})}dispose(){super.dispose(),this.X&&(this.X.disconnect(),this.X=void 0)}addToHistory(s){this.value&&(s||this.value!==this.cb())&&this.W.add(this.value)}getHistory(){return this.W.getHistory()}isAtFirstInHistory(){return this.W.isFirst()}isAtLastInHistory(){return this.W.isLast()}isNowhereInHistory(){return this.W.isNowhere()}showNextValue(){this.W.has(this.value)||this.addToHistory();let s=this.eb();s&&(s=s===this.value?this.eb():s),this.value=s??"",p.status(this.value?this.value:r.localize(4,null))}showPreviousValue(){this.W.has(this.value)||this.addToHistory();let s=this.db();s&&(s=s===this.value?this.db():s),s&&(this.value=s,p.status(this.value))}clearHistory(){this.W.clear()}L(){super.L(),this.Z.fire()}M(){super.M(),this.Y.fire()}cb(){let s=this.W.current();return s||(s=this.W.last(),this.W.next()),s}db(){return this.W.previous()||this.W.first()}eb(){return this.W.next()}}t.HistoryInputBox=n}),define(me[63],be([1,0,60,19,16,17,3,93]),function(te,t,y,M,i,W,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=t.unthemedToggleStyles=void 0,t.unthemedToggleStyles={inputActiveOptionBorder:"#007ACC00",inputActiveOptionForeground:"#FFFFFF",inputActiveOptionBackground:"#0E639C50"};class A extends y.BaseActionViewItem{constructor(P,r,l){super(P,r,l),this.a=this.B(new h({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.m.keybinding?`${this._action.label} (${this.m.keybinding})`:this._action.label,notFocusable:!0,inputActiveOptionBackground:l.toggleStyles?.inputActiveOptionBackground,inputActiveOptionBorder:l.toggleStyles?.inputActiveOptionBorder,inputActiveOptionForeground:l.toggleStyles?.inputActiveOptionForeground})),this.B(this.a.onChange(()=>this._action.checked=!!this.a&&this.a.checked))}render(P){this.element=P,this.element.appendChild(this.a.domNode)}u(){this.a&&(this.isEnabled()?this.a.enable():this.a.disable())}G(){this.a.checked=!!this._action.checked}focus(){this.a.domNode.tabIndex=0,this.a.focus()}blur(){this.a.domNode.tabIndex=-1,this.a.domNode.blur()}setFocusable(P){this.a.domNode.tabIndex=P?0:-1}}t.ToggleActionViewItem=A;class h extends M.Widget{constructor(P){super(),this.a=this.B(new p.Emitter),this.onChange=this.a.event,this.b=this.B(new p.Emitter),this.onKeyDown=this.b.event,this.c=P,this.s=this.c.isChecked;const r=["monaco-custom-toggle"];this.c.icon&&(this.g=this.c.icon,r.push(...W.ThemeIcon.asClassNameArray(this.g))),this.c.actionClassName&&r.push(...this.c.actionClassName.split(" ")),this.s&&r.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this.c.title,this.domNode.classList.add(...r),this.c.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.setAttribute("aria-label",this.c.title),this.t(),this.f(this.domNode,l=>{this.enabled&&(this.checked=!this.s,this.a.fire(!1),l.preventDefault())}),this.B(this.G(this.domNode)),this.p(this.domNode,l=>{if(l.keyCode===10||l.keyCode===3){this.checked=!this.s,this.a.fire(!0),l.preventDefault(),l.stopPropagation();return}this.b.fire(l)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this.s}set checked(P){this.s=P,this.domNode.setAttribute("aria-checked",String(this.s)),this.domNode.classList.toggle("checked",this.s),this.t()}setIcon(P){this.g&&this.domNode.classList.remove(...W.ThemeIcon.asClassNameArray(this.g)),this.g=P,this.g&&this.domNode.classList.add(...W.ThemeIcon.asClassNameArray(this.g))}width(){return 2+2+2+16}t(){this.domNode&&(this.domNode.style.borderColor=this.s&&this.c.inputActiveOptionBorder||"",this.domNode.style.color=this.s&&this.c.inputActiveOptionForeground||"inherit",this.domNode.style.backgroundColor=this.s&&this.c.inputActiveOptionBackground||"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(P){this.domNode.title=P,this.domNode.setAttribute("aria-label",P)}}t.Toggle=h;class a extends M.Widget{constructor(P,r,l){super(),this.c=P,this.g=r,this.a=new h({title:this.c,isChecked:this.g,icon:i.Codicon.check,actionClassName:"monaco-checkbox",...t.unthemedToggleStyles}),this.domNode=this.a.domNode,this.b=l,this.h(),this.B(this.a.onChange(()=>this.h()))}get checked(){return this.a.checked}set checked(P){this.a.checked=P,this.h()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}h(){this.domNode.style.color=this.b.checkboxForeground||"",this.domNode.style.backgroundColor=this.b.checkboxBackground||"",this.domNode.style.borderColor=this.b.checkboxBorder||""}}t.Checkbox=a}),define(me[126],be([1,0,63,16,98]),function(te,t,y,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const W=i.localize(0,null),p=i.localize(1,null),A=i.localize(2,null);class h extends y.Toggle{constructor(r){super({icon:M.Codicon.caseSensitive,title:W+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.CaseSensitiveToggle=h;class a extends y.Toggle{constructor(r){super({icon:M.Codicon.wholeWord,title:p+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.WholeWordsToggle=a;class c extends y.Toggle{constructor(r){super({icon:M.Codicon.regex,title:A+r.appendTitle,isChecked:r.isChecked,inputActiveOptionBorder:r.inputActiveOptionBorder,inputActiveOptionForeground:r.inputActiveOptionForeground,inputActiveOptionBackground:r.inputActiveOptionBackground})}}t.RegexToggle=c}),define(me[127],be([1,0,4,126,62,19,3,97,2,87]),function(te,t,y,M,i,W,p,A,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const a=A.localize(0,null);class c extends W.Widget{constructor(r,l,e){super(),this.i=!0,this.l=!1,this.n=new h.DisposableStore,this.H=[],this.I=this.B(new p.Emitter),this.onDidOptionChange=this.I.event,this.J=this.B(new p.Emitter),this.onKeyDown=this.J.event,this.L=this.B(new p.Emitter),this.onMouseDown=this.L.event,this.M=this.B(new p.Emitter),this.onInput=this.M.event,this.N=this.B(new p.Emitter),this.onKeyUp=this.N.event,this.O=this.B(new p.Emitter),this.onCaseSensitiveKeyDown=this.O.event,this.P=this.B(new p.Emitter),this.onRegexKeyDown=this.P.event,this.R=0,this.a=e.placeholder||"",this.b=e.validation,this.c=e.label||a,this.h=!!e.showCommonFindToggles;const o=e.appendCaseSensitiveLabel||"",n=e.appendWholeWordsLabel||"",u=e.appendRegexLabel||"",s=e.history||[],w=!!e.flexibleHeight,D=!!e.flexibleWidth,S=e.flexibleMaxHeight;if(this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this.B(new i.HistoryInputBox(this.domNode,l,{placeholder:this.a||"",ariaLabel:this.c||"",validationOptions:{validation:this.b},history:s,showHistoryHint:e.showHistoryHint,flexibleHeight:w,flexibleWidth:D,flexibleMaxHeight:S,inputBoxStyles:e.inputBoxStyles})),this.h){this.v=this.B(new M.RegexToggle({appendTitle:u,isChecked:!1,...e.toggleStyles})),this.B(this.v.onChange(v=>{this.I.fire(v),!v&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.v.onKeyDown(v=>{this.P.fire(v)})),this.w=this.B(new M.WholeWordsToggle({appendTitle:n,isChecked:!1,...e.toggleStyles})),this.B(this.w.onChange(v=>{this.I.fire(v),!v&&this.i&&this.inputBox.focus(),this.validate()})),this.y=this.B(new M.CaseSensitiveToggle({appendTitle:o,isChecked:!1,...e.toggleStyles})),this.B(this.y.onChange(v=>{this.I.fire(v),!v&&this.i&&this.inputBox.focus(),this.validate()})),this.B(this.y.onKeyDown(v=>{this.O.fire(v)}));const f=[this.y.domNode,this.w.domNode,this.v.domNode];this.p(this.domNode,v=>{if(v.equals(15)||v.equals(17)||v.equals(9)){const L=f.indexOf(document.activeElement);if(L>=0){let N=-1;v.equals(17)?N=(L+1)%f.length:v.equals(15)&&(L===0?N=f.length-1:N=L-1),v.equals(9)?(f[L].blur(),this.inputBox.focus()):N>=0&&f[N].focus(),y.EventHelper.stop(v,!0)}}})}this.s=document.createElement("div"),this.s.className="controls",this.s.style.display=this.h?"":"none",this.y&&this.s.append(this.y.domNode),this.w&&this.s.appendChild(this.w.domNode),this.v&&this.s.appendChild(this.v.domNode),this.setAdditionalToggles(e?.additionalToggles),this.s&&this.domNode.appendChild(this.s),r?.appendChild(this.domNode),this.B(y.addDisposableListener(this.inputBox.inputElement,"compositionstart",f=>{this.l=!0})),this.B(y.addDisposableListener(this.inputBox.inputElement,"compositionend",f=>{this.l=!1,this.M.fire()})),this.p(this.inputBox.inputElement,f=>this.J.fire(f)),this.u(this.inputBox.inputElement,f=>this.N.fire(f)),this.z(this.inputBox.inputElement,f=>this.M.fire()),this.j(this.inputBox.inputElement,f=>this.L.fire(f))}get isImeSessionInProgress(){return this.l}get onDidChange(){return this.inputBox.onDidChange}layout(r){this.inputBox.layout(),this.Q(r.collapsedFindWidget)}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.v?.enable(),this.w?.enable(),this.y?.enable();for(const r of this.H)r.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.v?.disable(),this.w?.disable(),this.y?.disable();for(const r of this.H)r.disable()}setFocusInputOnOptionClick(r){this.i=r}setEnabled(r){r?this.enable():this.disable()}setAdditionalToggles(r){for(const l of this.H)l.domNode.remove();this.H=[],this.n.dispose(),this.n=new h.DisposableStore;for(const l of r??[])this.n.add(l),this.s.appendChild(l.domNode),this.n.add(l.onChange(e=>{this.I.fire(e),!e&&this.i&&this.inputBox.focus()})),this.H.push(l);this.H.length>0&&(this.s.style.display=""),this.Q()}Q(r=!1){r?this.inputBox.paddingRight=0:this.inputBox.paddingRight=(this.y?.width()??0)+(this.w?.width()??0)+(this.v?.width()??0)+this.H.reduce((l,e)=>l+e.width(),0)}clear(){this.S(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(r){this.inputBox.value!==r&&(this.inputBox.value=r)}onSearchSubmit(){this.inputBox.addToHistory()}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.y?.checked??!1}setCaseSensitive(r){this.y&&(this.y.checked=r)}getWholeWords(){return this.w?.checked??!1}setWholeWords(r){this.w&&(this.w.checked=r)}getRegex(){return this.v?.checked??!1}setRegex(r){this.v&&(this.v.checked=r,this.validate())}focusOnCaseSensitive(){this.y?.focus()}focusOnRegex(){this.v?.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this.R),this.R=1-this.R,this.domNode.classList.add("highlight-"+this.R)}validate(){this.inputBox.validate()}showMessage(r){this.inputBox.showMessage(r)}clearMessage(){this.inputBox.hideMessage()}S(){this.inputBox.hideMessage()}}t.FindInput=c,c.OPTION_CHANGE="optionChange"}),define(me[128],be([1,0,4,20,14,61,127,62,58,36,63,55,24,31,13,9,16,17,69,3,32,2,44,6,102,94]),function(te,t,y,M,i,W,p,A,h,a,c,P,r,l,e,o,n,u,s,w,D,S,f,v,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMatchType=t.TreeFindMode=t.FuzzyToggle=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class N extends h.ElementsDragAndDropData{set context(d){this.c.context=d}get context(){return this.c.context}constructor(d){super(d.elements.map(R=>R.element)),this.c=d}}function E(I){return I instanceof h.ElementsDragAndDropData?new N(I):I}class g{constructor(d,R){this.c=d,this.d=R,this.b=S.Disposable.None}getDragURI(d){return this.d.getDragURI(d.element)}getDragLabel(d,R){if(this.d.getDragLabel)return this.d.getDragLabel(d.map(_=>_.element),R)}onDragStart(d,R){this.d.onDragStart?.(E(d),R)}onDragOver(d,R,_,Z,k=!0){const T=this.d.onDragOver(E(d),R&&R.element,_,Z),H=this.a!==R;if(H&&(this.b.dispose(),this.a=R),typeof R>"u")return T;if(H&&typeof T!="boolean"&&T.autoExpand&&(this.b=(0,o.disposableTimeout)(()=>{const $=this.c(),q=$.getNodeLocation(R);$.isCollapsed(q)&&$.setCollapsed(q,!1),this.a=void 0},500)),typeof T=="boolean"||!T.accept||typeof T.bubble>"u"||T.feedback){if(!k){const $=typeof T=="boolean"?T:T.accept,q=typeof T=="boolean"?void 0:T.effect;return{accept:$,effect:q,feedback:[_]}}return T}if(T.bubble===1){const $=this.c(),q=$.getNodeLocation(R),ee=$.getParentNodeLocation(q),se=$.getNode(ee),ve=ee&&$.getListIndex(ee);return this.onDragOver(d,se,ve,Z,!1)}const C=this.c(),U=C.getNodeLocation(R),z=C.getListIndex(U),O=C.getListRenderCount(U);return{...T,feedback:(0,e.range)(z,z+O)}}drop(d,R,_,Z){this.b.dispose(),this.a=void 0,this.d.drop(E(d),R&&R.element,_,Z)}onDragEnd(d){this.d.onDragEnd?.(d)}}function m(I,d){return d&&{...d,identityProvider:d.identityProvider&&{getId(R){return d.identityProvider.getId(R.element)}},dnd:d.dnd&&new g(I,d.dnd),multipleSelectionController:d.multipleSelectionController&&{isSelectionSingleChangeEvent(R){return d.multipleSelectionController.isSelectionSingleChangeEvent({...R,element:R.element})},isSelectionRangeChangeEvent(R){return d.multipleSelectionController.isSelectionRangeChangeEvent({...R,element:R.element})}},accessibilityProvider:d.accessibilityProvider&&{...d.accessibilityProvider,getSetSize(R){const _=I(),Z=_.getNodeLocation(R),k=_.getParentNodeLocation(Z);return _.getNode(k).visibleChildrenCount},getPosInSet(R){return R.visibleChildIndex+1},isChecked:d.accessibilityProvider&&d.accessibilityProvider.isChecked?R=>d.accessibilityProvider.isChecked(R.element):void 0,getRole:d.accessibilityProvider&&d.accessibilityProvider.getRole?R=>d.accessibilityProvider.getRole(R.element):()=>"treeitem",getAriaLabel(R){return d.accessibilityProvider.getAriaLabel(R.element)},getWidgetAriaLabel(){return d.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:d.accessibilityProvider&&d.accessibilityProvider.getWidgetRole?()=>d.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:d.accessibilityProvider&&d.accessibilityProvider.getAriaLevel?R=>d.accessibilityProvider.getAriaLevel(R.element):R=>R.depth,getActiveDescendantId:d.accessibilityProvider.getActiveDescendantId&&(R=>d.accessibilityProvider.getActiveDescendantId(R.element))},keyboardNavigationLabelProvider:d.keyboardNavigationLabelProvider&&{...d.keyboardNavigationLabelProvider,getKeyboardNavigationLabel(R){return d.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(R.element)}}}}class b{constructor(d){this.a=d}getHeight(d){return this.a.getHeight(d.element)}getTemplateId(d){return this.a.getTemplateId(d.element)}hasDynamicHeight(d){return!!this.a.hasDynamicHeight&&this.a.hasDynamicHeight(d.element)}setDynamicHeight(d,R){this.a.setDynamicHeight?.(d.element,R)}}t.ComposedTreeDelegate=b;class B{static lift(d){return d instanceof B?d:new B(d)}static empty(d=0){return new B({focus:[],selection:[],expanded:Object.create(null),scrollTop:d})}constructor(d){if(this.focus=new Set(d.focus),this.selection=new Set(d.selection),d.expanded instanceof Array){this.expanded=Object.create(null);for(const R of d.expanded)this.expanded[R]=1}else this.expanded=d.expanded;this.expanded=d.expanded,this.scrollTop=d.scrollTop}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=B;var G;(function(I){I.None="none",I.OnHover="onHover",I.Always="always"})(G||(t.RenderIndentGuides=G={}));class J{get elements(){return this.b}constructor(d,R=[]){this.b=R,this.a=new S.DisposableStore,this.onDidChange=w.Event.forEach(d,_=>this.b=_,this.a)}dispose(){this.a.dispose()}}class ie{constructor(d,R,_,Z,k,T={}){this.o=d,this.p=R,this.q=Z,this.s=k,this.b=new Map,this.c=new Map,this.d=ie.a,this.f=!1,this.g=!1,this.j=new Set,this.k=S.Disposable.None,this.m=new S.DisposableStore,this.templateId=d.templateId,this.updateOptions(T),w.Event.map(_,H=>H.node)(this.u,this,this.m),d.onDidChangeTwistieState?.(this.t,this,this.m)}updateOptions(d={}){if(typeof d.indent<"u"){const R=(0,f.clamp)(d.indent,0,40);if(R!==this.d){this.d=R;for(const[_,Z]of this.c)this.v(_,Z)}}if(typeof d.renderIndentGuides<"u"){const R=d.renderIndentGuides!==G.None;if(R!==this.g){this.g=R;for(const[_,Z]of this.c)this.w(_,Z);if(this.k.dispose(),R){const _=new S.DisposableStore;this.q.onDidChange(this.x,this,_),this.k=_,this.x(this.q.elements)}}}typeof d.hideTwistiesOfChildlessElements<"u"&&(this.f=d.hideTwistiesOfChildlessElements)}renderTemplate(d){const R=(0,y.append)(d,(0,y.$)(".monaco-tl-row")),_=(0,y.append)(R,(0,y.$)(".monaco-tl-indent")),Z=(0,y.append)(R,(0,y.$)(".monaco-tl-twistie")),k=(0,y.append)(R,(0,y.$)(".monaco-tl-contents")),T=this.o.renderTemplate(k);return{container:d,indent:_,twistie:Z,indentGuidesDisposable:S.Disposable.None,templateData:T}}renderElement(d,R,_,Z){this.c.set(d,_),this.b.set(d.element,d),this.v(d,_),this.o.renderElement(d,R,_.templateData,Z)}disposeElement(d,R,_,Z){_.indentGuidesDisposable.dispose(),this.o.disposeElement?.(d,R,_.templateData,Z),typeof Z=="number"&&(this.c.delete(d),this.b.delete(d.element))}disposeTemplate(d){this.o.disposeTemplate(d.templateData)}t(d){const R=this.b.get(d);R&&this.u(R)}u(d){const R=this.c.get(d);R&&(this.x(this.q.elements),this.v(d,R))}v(d,R){const _=ie.a+(d.depth-1)*this.d;R.twistie.style.paddingLeft=`${_}px`,R.indent.style.width=`${_+this.d-16}px`,d.collapsible?R.container.setAttribute("aria-expanded",String(!d.collapsed)):R.container.removeAttribute("aria-expanded"),R.twistie.classList.remove(...u.ThemeIcon.asClassNameArray(n.Codicon.treeItemExpanded));let Z=!1;this.o.renderTwistie&&(Z=this.o.renderTwistie(d.element,R.twistie)),d.collapsible&&(!this.f||d.visibleChildrenCount>0)?(Z||R.twistie.classList.add(...u.ThemeIcon.asClassNameArray(n.Codicon.treeItemExpanded)),R.twistie.classList.add("collapsible"),R.twistie.classList.toggle("collapsed",d.collapsed)):R.twistie.classList.remove("collapsible","collapsed"),this.w(d,R)}w(d,R){if((0,y.clearNode)(R.indent),R.indentGuidesDisposable.dispose(),!this.g)return;const _=new S.DisposableStore,Z=this.p();for(;;){const k=Z.getNodeLocation(d),T=Z.getParentNodeLocation(k);if(!T)break;const H=Z.getNode(T),C=(0,y.$)(".indent-guide",{style:`width: ${this.d}px`});this.j.has(H)&&C.classList.add("active"),R.indent.childElementCount===0?R.indent.appendChild(C):R.indent.insertBefore(C,R.indent.firstElementChild),this.s.add(H,C),_.add((0,S.toDisposable)(()=>this.s.delete(H,C))),d=H}R.indentGuidesDisposable=_}x(d){if(!this.g)return;const R=new Set,_=this.p();d.forEach(Z=>{const k=_.getNodeLocation(Z);try{const T=_.getParentNodeLocation(k);Z.collapsible&&Z.children.length>0&&!Z.collapsed?R.add(Z):T&&R.add(_.getNode(T))}catch{}}),this.j.forEach(Z=>{R.has(Z)||this.s.forEach(Z,k=>k.classList.remove("active"))}),R.forEach(Z=>{this.j.has(Z)||this.s.forEach(Z,k=>k.classList.add("active"))}),this.j=R}dispose(){this.c.clear(),this.b.clear(),this.k.dispose(),(0,S.dispose)(this.m)}}ie.a=8;class le{get totalCount(){return this.a}get matchCount(){return this.b}set pattern(d){this.c=d,this.d=d.toLowerCase()}constructor(d,R,_){this.g=d,this.j=R,this.k=_,this.a=0,this.b=0,this.c="",this.d="",this.f=new S.DisposableStore,d.onWillRefilter(this.m,this,this.f)}filter(d,R){let _=1;if(this.k){const T=this.k.filter(d,R);if(typeof T=="boolean"?_=T?1:0:(0,P.isFilterResult)(T)?_=(0,P.getVisibleState)(T.visibility):_=T,_===0)return!1}if(this.a++,!this.c)return this.b++,{data:D.FuzzyScore.Default,visibility:_};const Z=this.j.getKeyboardNavigationLabel(d),k=Array.isArray(Z)?Z:[Z];for(const T of k){const H=T&&T.toString();if(typeof H>"u")return{data:D.FuzzyScore.Default,visibility:_};let C;if(this.g.findMatchType===Se.Contiguous){const U=H.toLowerCase().indexOf(this.d);if(U>-1){C=[Number.MAX_SAFE_INTEGER,0];for(let z=this.d.length;z>0;z--)C.push(U+z-1)}}else C=(0,D.fuzzyScore)(this.c,this.d,0,H,H.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(C)return this.b++,k.length===1?{data:C,visibility:_}:{data:{label:H,score:C},visibility:_}}return this.g.findMode===ce.Filter?typeof this.g.options.defaultFindVisibility=="number"?this.g.options.defaultFindVisibility:this.g.options.defaultFindVisibility?this.g.options.defaultFindVisibility(d):2:{data:D.FuzzyScore.Default,visibility:_}}m(){this.a=0,this.b=0}dispose(){(0,S.dispose)(this.f)}}class ge extends c.Toggle{constructor(d){super({icon:n.Codicon.listFilter,title:(0,L.localize)(0,null),isChecked:d.isChecked??!1,inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.ModeToggle=ge;class ue extends c.Toggle{constructor(d){super({icon:n.Codicon.searchFuzzy,title:(0,L.localize)(1,null),isChecked:d.isChecked??!1,inputActiveOptionBorder:d.inputActiveOptionBorder,inputActiveOptionForeground:d.inputActiveOptionForeground,inputActiveOptionBackground:d.inputActiveOptionBackground})}}t.FuzzyToggle=ue;const de={inputBoxStyles:A.unthemedInboxStyles,toggleStyles:c.unthemedToggleStyles,listFilterWidgetBackground:void 0,listFilterWidgetNoMatchesOutline:void 0,listFilterWidgetOutline:void 0,listFilterWidgetShadow:void 0};var ce;(function(I){I[I.Highlight=0]="Highlight",I[I.Filter=1]="Filter"})(ce||(t.TreeFindMode=ce={}));var Se;(function(I){I[I.Fuzzy=0]="Fuzzy",I[I.Contiguous=1]="Contiguous"})(Se||(t.TreeFindMatchType=Se={}));class Ae extends S.Disposable{set mode(d){this.b.checked=d===ce.Filter,this.f.inputBox.setPlaceHolder(d===ce.Filter?(0,L.localize)(2,null):(0,L.localize)(3,null))}set matchType(d){this.c.checked=d===Se.Fuzzy}get value(){return this.f.inputBox.value}set value(d){this.f.inputBox.value=d}constructor(d,R,_,Z,k,T){super(),this.p=R,this.a=(0,y.h)(".monaco-tree-type-filter",[(0,y.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,y.h)(".monaco-tree-type-filter-input@findInput"),(0,y.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.j=0,this.k=0,this.m=0,this._onDidDisable=new w.Emitter,this.onDidDisable=this._onDidDisable.event,d.appendChild(this.a.root),this.B((0,S.toDisposable)(()=>d.removeChild(this.a.root)));const H=T?.styles??de;H.listFilterWidgetBackground&&(this.a.root.style.backgroundColor=H.listFilterWidgetBackground),H.listFilterWidgetShadow&&(this.a.root.style.boxShadow=`0 0 8px 2px ${H.listFilterWidgetShadow}`),this.b=this.B(new ge({...H.toggleStyles,isChecked:Z===ce.Filter})),this.c=this.B(new ue({...H.toggleStyles,isChecked:k===Se.Fuzzy})),this.onDidChangeMode=w.Event.map(this.b.onChange,()=>this.b.checked?ce.Filter:ce.Highlight,this.q),this.onDidChangeMatchType=w.Event.map(this.c.onChange,()=>this.c.checked?Se.Fuzzy:Se.Contiguous,this.q),this.f=this.B(new p.FindInput(this.a.findInput,_,{label:(0,L.localize)(4,null),additionalToggles:[this.b,this.c],showCommonFindToggles:!1,inputBoxStyles:H.inputBoxStyles,toggleStyles:H.toggleStyles,history:T?.history})),this.g=this.B(new W.ActionBar(this.a.actionbar)),this.mode=Z;const C=this.B(new M.DomEmitter(this.f.inputBox.inputElement,"keydown")),U=this.B(w.Event.chain(C.event)).map(q=>new i.StandardKeyboardEvent(q)).event;this.B(U(q=>{if(q.equals(3)){q.preventDefault(),q.stopPropagation(),this.f.inputBox.addToHistory(),this.p.domFocus();return}if(q.equals(18)){q.preventDefault(),q.stopPropagation(),this.f.inputBox.isAtLastInHistory()||this.f.inputBox.isNowhereInHistory()?(this.f.inputBox.addToHistory(),this.p.domFocus()):this.f.inputBox.showNextValue();return}if(q.equals(16)){q.preventDefault(),q.stopPropagation(),this.f.inputBox.showPreviousValue();return}}));const z=this.B(new l.Action("close",(0,L.localize)(5,null),"codicon codicon-close",!0,()=>this.dispose()));this.g.push(z,{icon:!0,label:!1});const O=this.B(new M.DomEmitter(this.a.grab,"mousedown"));this.B(O.event(q=>{const ee=new S.DisposableStore,se=ee.add(new M.DomEmitter(window,"mousemove")),ve=ee.add(new M.DomEmitter(window,"mouseup")),De=this.k,Ie=q.pageX,Fe=this.m,we=q.pageY;this.a.grab.classList.add("grabbing");const Pe=this.a.root.style.transition;this.a.root.style.transition="unset";const Ne=Ve=>{const ze=Ve.pageX-Ie;this.k=De-ze;const We=Ve.pageY-we;this.m=Fe+We,this.layout()};ee.add(se.event(Ne)),ee.add(ve.event(Ve=>{Ne(Ve),this.a.grab.classList.remove("grabbing"),this.a.root.style.transition=Pe,ee.dispose()}))}));const $=this.B(w.Event.chain(this.B(new M.DomEmitter(this.a.grab,"keydown")).event)).map(q=>new i.StandardKeyboardEvent(q)).event;this.B($(q=>{let ee,se;if(q.keyCode===15?ee=Number.POSITIVE_INFINITY:q.keyCode===17?ee=0:q.keyCode===10&&(ee=this.k===0?Number.POSITIVE_INFINITY:0),q.keyCode===16?se=0:q.keyCode===18&&(se=Number.POSITIVE_INFINITY),ee!==void 0&&(q.preventDefault(),q.stopPropagation(),this.k=ee,this.layout()),se!==void 0){q.preventDefault(),q.stopPropagation(),this.m=se;const ve=this.a.root.style.transition;this.a.root.style.transition="unset",this.layout(),setTimeout(()=>{this.a.root.style.transition=ve},0)}})),this.onDidChangeValue=this.f.onDidChange}getHistory(){return this.f.inputBox.getHistory()}focus(){this.f.focus()}select(){this.f.select(),this.f.inputBox.addToHistory(!0)}layout(d=this.j){this.j=d,this.k=(0,f.clamp)(this.k,0,Math.max(0,d-212)),this.a.root.style.right=`${this.k}px`,this.m=(0,f.clamp)(this.m,0,24),this.a.root.style.top=`${this.m}px`}showMessage(d){this.f.showMessage(d)}clearMessage(){this.f.clearMessage()}async dispose(){this._onDidDisable.fire(),this.a.root.classList.add("disabled"),await(0,o.timeout)(300),super.dispose()}}class Be{get pattern(){return this.b}get mode(){return this.d}set mode(d){d!==this.d&&(this.d=d,this.g&&(this.g.mode=this.d),this.t.refilter(),this.A(),this.k.fire(d))}get matchType(){return this.f}set matchType(d){d!==this.f&&(this.f=d,this.g&&(this.g.matchType=this.f),this.t.refilter(),this.A(),this.m.fire(d))}constructor(d,R,_,Z,k,T={}){this.t=d,this.u=_,this.v=Z,this.w=k,this.x=T,this.b="",this.c="",this.j=0,this.k=new w.Emitter,this.onDidChangeMode=this.k.event,this.m=new w.Emitter,this.onDidChangeMatchType=this.m.event,this.o=new w.Emitter,this.onDidChangePattern=this.o.event,this.p=new w.Emitter,this.onDidChangeOpenState=this.p.event,this.q=new S.DisposableStore,this.s=new S.DisposableStore,this.d=d.options.defaultFindMode??ce.Highlight,this.f=d.options.defaultFindMatchType??Se.Fuzzy,R.onDidSplice(this.z,this,this.s)}updateOptions(d={}){d.defaultFindMode!==void 0&&(this.mode=d.defaultFindMode),d.defaultFindMatchType!==void 0&&(this.matchType=d.defaultFindMatchType)}open(){if(this.g){this.g.focus(),this.g.select();return}this.g=new Ae(this.u.getHTMLElement(),this.t,this.w,this.mode,this.matchType,{...this.x,history:this.a}),this.q.add(this.g),this.g.onDidChangeValue(this.y,this,this.q),this.g.onDidChangeMode(d=>this.mode=d,void 0,this.q),this.g.onDidChangeMatchType(d=>this.matchType=d,void 0,this.q),this.g.onDidDisable(this.close,this,this.q),this.g.layout(this.j),this.g.focus(),this.g.value=this.c,this.g.select(),this.p.fire(!0)}close(){this.g&&(this.a=this.g.getHistory(),this.g=void 0,this.q.dispose(),this.q=new S.DisposableStore,this.c=this.pattern,this.y(""),this.t.domFocus(),this.p.fire(!1))}y(d){this.b=d,this.o.fire(d),this.v.pattern=d,this.t.refilter(),d&&this.t.focusNext(0,!0,void 0,_=>!D.FuzzyScore.isDefault(_.filterData));const R=this.t.getFocus();if(R.length>0){const _=R[0];this.t.getRelativeTop(_)===null&&this.t.reveal(_,.5)}this.A()}z(){!this.g||this.pattern.length===0||(this.t.refilter(),this.A())}A(){const d=this.v.totalCount>0&&this.v.matchCount===0;this.pattern&&d?this.t.options.showNotFoundMessage??!0?this.g?.showMessage({type:2,content:(0,L.localize)(6,null)}):this.g?.showMessage({type:2}):this.g?.clearMessage()}shouldAllowFocus(d){return!this.g||!this.pattern||this.d===ce.Filter||this.v.totalCount>0&&this.v.matchCount<=1?!0:!D.FuzzyScore.isDefault(d.filterData)}layout(d){this.j=d,this.g?.layout(d)}dispose(){this.a=void 0,this.o.dispose(),this.q.dispose(),this.s.dispose()}}function re(I){let d=r.TreeMouseEventTarget.Unknown;return(0,y.hasParentWithClass)(I.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?d=r.TreeMouseEventTarget.Twistie:(0,y.hasParentWithClass)(I.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?d=r.TreeMouseEventTarget.Element:(0,y.hasParentWithClass)(I.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(d=r.TreeMouseEventTarget.Filter),{browserEvent:I.browserEvent,element:I.element?I.element.element:null,target:d}}function ne(I){return{element:I.element?I.element.element:null,browserEvent:I.browserEvent,anchor:I.anchor}}function Q(I,d){d(I),I.children.forEach(R=>Q(R,d))}class oe{get f(){return this.d||(this.d=this.m()),this.d}constructor(d,R){this.g=d,this.j=R,this.a=[],this.c=new w.Emitter,this.onDidChange=this.c.event}set(d,R){!R?.__forceEvent&&(0,e.equals)(this.a,d)||this.k(d,!1,R)}k(d,R,_){if(this.a=[...d],this.b=void 0,this.d=void 0,!R){const Z=this;this.c.fire({get elements(){return Z.get()},browserEvent:_})}}get(){return this.b||(this.b=this.a.map(d=>d.element)),[...this.b]}getNodes(){return this.a}has(d){return this.f.has(d)}onDidModelSplice({insertedNodes:d,deletedNodes:R}){if(!this.j){const C=this.m(),U=z=>C.delete(z);R.forEach(z=>Q(z,U)),this.set([...C.values()]);return}const _=new Set,Z=C=>_.add(this.j.getId(C.element).toString());R.forEach(C=>Q(C,Z));const k=new Map,T=C=>k.set(this.j.getId(C.element).toString(),C);d.forEach(C=>Q(C,T));const H=[];for(const C of this.a){const U=this.j.getId(C.element).toString();if(!_.has(U))H.push(C);else{const O=k.get(U);O&&O.visible&&H.push(O)}}if(this.a.length>0&&H.length===0){const C=this.g();C&&H.push(C)}this.k(H,!0)}m(){const d=new Set;for(const R of this.a)d.add(R);return d}}class j extends a.MouseController{constructor(d,R){super(d),this.z=R}u(d){if((0,a.isButton)(d.browserEvent.target)||(0,a.isInputElement)(d.browserEvent.target)||(0,a.isMonacoEditor)(d.browserEvent.target))return;const R=d.element;if(!R)return super.u(d);if(this.p(d)||this.o(d))return super.u(d);const _=d.browserEvent.target,Z=_.classList.contains("monaco-tl-twistie")||_.classList.contains("monaco-icon-label")&&_.classList.contains("folder-icon")&&d.browserEvent.offsetX<16;let k=!1;if(typeof this.z.expandOnlyOnTwistieClick=="function"?k=this.z.expandOnlyOnTwistieClick(R.element):k=!!this.z.expandOnlyOnTwistieClick,k&&!Z&&d.browserEvent.detail!==2)return super.u(d);if(!this.z.expandOnDoubleClick&&d.browserEvent.detail===2)return super.u(d);if(R.collapsible){const T=this.z.getNodeLocation(R),H=d.browserEvent.altKey;if(this.z.setFocus([T]),this.z.toggleCollapsed(T,H),k&&Z)return}super.u(d)}v(d){d.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.z.expandOnDoubleClick||super.v(d)}}class V extends a.List{constructor(d,R,_,Z,k,T,H,C){super(d,R,_,Z,C),this.p=k,this.s=T,this.M=H}F(d){return new j(this,d.tree)}splice(d,R,_=[]){if(super.splice(d,R,_),_.length===0)return;const Z=[],k=[];let T;_.forEach((H,C)=>{this.p.has(H)&&Z.push(d+C),this.s.has(H)&&k.push(d+C),this.M.has(H)&&(T=d+C)}),Z.length>0&&super.setFocus((0,e.distinct)([...super.getFocus(),...Z])),k.length>0&&super.setSelection((0,e.distinct)([...super.getSelection(),...k])),typeof T=="number"&&super.setAnchor(T)}setFocus(d,R,_=!1){super.setFocus(d,R),_||this.p.set(d.map(Z=>this.element(Z)),R)}setSelection(d,R,_=!1){super.setSelection(d,R),_||this.s.set(d.map(Z=>this.element(Z)),R)}setAnchor(d,R=!1){super.setAnchor(d),R||(typeof d>"u"?this.M.set([]):this.M.set([this.element(d)]))}}class F{get onDidScroll(){return this.j.onDidScroll}get onDidChangeFocus(){return this.w.wrapEvent(this.p.onDidChange)}get onDidChangeSelection(){return this.w.wrapEvent(this.q.onDidChange)}get onMouseClick(){return w.Event.map(this.j.onMouseClick,re)}get onMouseDblClick(){return w.Event.filter(w.Event.map(this.j.onMouseDblClick,re),d=>d.target!==r.TreeMouseEventTarget.Filter)}get onContextMenu(){return w.Event.map(this.j.onContextMenu,ne)}get onTap(){return w.Event.map(this.j.onTap,re)}get onPointer(){return w.Event.map(this.j.onPointer,re)}get onKeyDown(){return this.j.onKeyDown}get onKeyUp(){return this.j.onKeyUp}get onKeyPress(){return this.j.onKeyPress}get onDidFocus(){return this.j.onDidFocus}get onDidBlur(){return this.j.onDidBlur}get onDidChangeModel(){return w.Event.signal(this.o.onDidSplice)}get onDidChangeCollapseState(){return this.o.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.o.onDidChangeRenderNodeCount}get findMode(){return this.x?.mode??ce.Highlight}set findMode(d){this.x&&(this.x.mode=d)}get findMatchType(){return this.x?.matchType??Se.Fuzzy}set findMatchType(d){this.x&&(this.x.matchType=d)}get onDidChangeFindPattern(){return this.x?this.x.onDidChangePattern:w.Event.None}get expandOnDoubleClick(){return typeof this.E.expandOnDoubleClick>"u"?!0:this.E.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this.E.expandOnlyOnTwistieClick>"u"?!0:this.E.expandOnlyOnTwistieClick}get onDidDispose(){return this.j.onDidDispose}constructor(d,R,_,Z,k={}){this.D=d,this.E=k,this.w=new w.EventBufferer,this.onDidChangeFindOpenState=w.Event.None,this.A=new S.DisposableStore,this.B=new w.Emitter,this.onWillRefilter=this.B.event,this.C=new w.Emitter,this.onDidUpdateOptions=this.C.event;const T=new b(_),H=new w.Relay,C=new w.Relay,U=this.A.add(new J(C.event)),z=new s.SetMap;this.k=Z.map(q=>new ie(q,()=>this.o,H.event,U,z,k));for(const q of this.k)this.A.add(q);let O;k.keyboardNavigationLabelProvider&&(O=new le(this,k.keyboardNavigationLabelProvider,k.filter),k={...k,filter:O},this.A.add(O)),this.p=new oe(()=>this.j.getFocusedElements()[0],k.identityProvider),this.q=new oe(()=>this.j.getSelectedElements()[0],k.identityProvider),this.u=new oe(()=>this.j.getAnchorElement(),k.identityProvider),this.j=new V(d,R,T,this.k,this.p,this.q,this.u,{...m(()=>this.o,k),tree:this}),this.o=this.I(d,this.j,k),H.input=this.o.onDidChangeCollapseState;const $=w.Event.forEach(this.o.onDidSplice,q=>{this.w.bufferEvents(()=>{this.p.onDidModelSplice(q),this.q.onDidModelSplice(q)})},this.A);if($(()=>null,null,this.A),C.input=w.Event.chain(w.Event.any($,this.p.onDidChange,this.q.onDidChange)).debounce(()=>null,0).map(()=>{const q=new Set;for(const ee of this.p.getNodes())q.add(ee);for(const ee of this.q.getNodes())q.add(ee);return[...q.values()]}).event,k.keyboardSupport!==!1){const q=w.Event.chain(this.j.onKeyDown).filter(ee=>!(0,a.isInputElement)(ee.target)).map(ee=>new i.StandardKeyboardEvent(ee));q.filter(ee=>ee.keyCode===15).on(this.F,this,this.A),q.filter(ee=>ee.keyCode===17).on(this.G,this,this.A),q.filter(ee=>ee.keyCode===10).on(this.H,this,this.A)}if((k.findWidgetEnabled??!0)&&k.keyboardNavigationLabelProvider&&k.contextViewProvider){const q=this.options.findWidgetStyles?{styles:this.options.findWidgetStyles}:void 0;this.x=new Be(this,this.o,this.j,O,k.contextViewProvider,q),this.y=ee=>this.x.shouldAllowFocus(ee),this.onDidChangeFindOpenState=this.x.onDidChangeOpenState,this.A.add(this.x),this.onDidChangeFindMode=this.x.onDidChangeMode,this.onDidChangeFindMatchType=this.x.onDidChangeMatchType}else this.onDidChangeFindMode=w.Event.None,this.onDidChangeFindMatchType=w.Event.None;this.z=(0,y.createStyleSheet)(this.j.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===G.Always)}updateOptions(d={}){this.E={...this.E,...d};for(const R of this.k)R.updateOptions(d);this.j.updateOptions(this.E),this.x?.updateOptions(d),this.C.fire(this.E),this.getHTMLElement().classList.toggle("always",this.E.renderIndentGuides===G.Always)}get options(){return this.E}updateWidth(d){const R=this.o.getListIndex(d);R!==-1&&this.j.updateWidth(R)}getHTMLElement(){return this.j.getHTMLElement()}get contentHeight(){return this.j.contentHeight}get onDidChangeContentHeight(){return this.j.onDidChangeContentHeight}get scrollTop(){return this.j.scrollTop}set scrollTop(d){this.j.scrollTop=d}get scrollLeft(){return this.j.scrollLeft}set scrollLeft(d){this.j.scrollLeft=d}get scrollHeight(){return this.j.scrollHeight}get renderHeight(){return this.j.renderHeight}get firstVisibleElement(){const d=this.j.firstVisibleIndex;return d<0||d>=this.j.length?void 0:this.j.element(d).element}get lastVisibleElement(){const d=this.j.lastVisibleIndex;return this.j.element(d).element}get ariaLabel(){return this.j.ariaLabel}set ariaLabel(d){this.j.ariaLabel=d}domFocus(){this.j.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(d,R){this.j.layout(d,R),(0,v.isNumber)(R)&&this.x?.layout(R)}style(d){const R=`.${this.j.domId}`,_=[];d.treeIndentGuidesStroke&&(_.push(`.monaco-list${R}:hover .monaco-tl-indent > .indent-guide, .monaco-list${R}.always .monaco-tl-indent > .indent-guide  { border-color: ${d.treeInactiveIndentGuidesStroke}; }`),_.push(`.monaco-list${R} .monaco-tl-indent > .indent-guide.active { border-color: ${d.treeIndentGuidesStroke}; }`)),this.z.textContent=_.join(`
`),this.j.style(d)}getParentElement(d){const R=this.o.getParentNodeLocation(d);return this.o.getNode(R).element}getFirstElementChild(d){return this.o.getFirstElementChild(d)}getNode(d){return this.o.getNode(d)}getNodeLocation(d){return this.o.getNodeLocation(d)}collapse(d,R=!1){return this.o.setCollapsed(d,!0,R)}expand(d,R=!1){return this.o.setCollapsed(d,!1,R)}toggleCollapsed(d,R=!1){return this.o.setCollapsed(d,void 0,R)}expandAll(){this.o.setCollapsed(this.o.rootRef,!1,!0)}collapseAll(){this.o.setCollapsed(this.o.rootRef,!0,!0)}isCollapsible(d){return this.o.isCollapsible(d)}setCollapsible(d,R){return this.o.setCollapsible(d,R)}isCollapsed(d){return this.o.isCollapsed(d)}triggerTypeNavigation(){this.j.triggerTypeNavigation()}openFind(){this.x?.open()}closeFind(){this.x?.close()}refilter(){this.B.fire(void 0),this.o.refilter()}setAnchor(d){if(typeof d>"u")return this.j.setAnchor(void 0);const R=this.o.getNode(d);this.u.set([R]);const _=this.o.getListIndex(d);_>-1&&this.j.setAnchor(_,!0)}getAnchor(){return(0,e.firstOrDefault)(this.u.get(),void 0)}setSelection(d,R){const _=d.map(k=>this.o.getNode(k));this.q.set(_,R);const Z=d.map(k=>this.o.getListIndex(k)).filter(k=>k>-1);this.j.setSelection(Z,R,!0)}getSelection(){return this.q.get()}setFocus(d,R){const _=d.map(k=>this.o.getNode(k));this.p.set(_,R);const Z=d.map(k=>this.o.getListIndex(k)).filter(k=>k>-1);this.j.setFocus(Z,R,!0)}focusNext(d=1,R=!1,_,Z=this.y){this.j.focusNext(d,R,_,Z)}focusPrevious(d=1,R=!1,_,Z=this.y){this.j.focusPrevious(d,R,_,Z)}focusNextPage(d,R=this.y){return this.j.focusNextPage(d,R)}focusPreviousPage(d,R=this.y){return this.j.focusPreviousPage(d,R)}focusLast(d,R=this.y){this.j.focusLast(d,R)}focusFirst(d,R=this.y){this.j.focusFirst(d,R)}getFocus(){return this.p.get()}reveal(d,R){this.o.expandTo(d);const _=this.o.getListIndex(d);_!==-1&&this.j.reveal(_,R)}getRelativeTop(d){const R=this.o.getListIndex(d);return R===-1?null:this.j.getRelativeTop(R)}getViewState(d=this.options.identityProvider){if(!d)throw new r.TreeError(this.D,"Can't get tree view state without an identity provider");const R=T=>d.getId(T).toString(),_=B.empty(this.scrollTop);for(const T of this.getFocus())_.focus.add(R(T));for(const T of this.getSelection())_.selection.add(R(T));const Z=this.o.getNode(),k=[Z];for(;k.length>0;){const T=k.shift();T!==Z&&T.collapsible&&(_.expanded[R(T.element)]=T.collapsed?0:1),k.push(...T.children)}return _}F(d){d.preventDefault(),d.stopPropagation();const R=this.j.getFocusedElements();if(R.length===0)return;const _=R[0],Z=this.o.getNodeLocation(_);if(!this.o.setCollapsed(Z,!0)){const T=this.o.getParentNodeLocation(Z);if(!T)return;const H=this.o.getListIndex(T);this.j.reveal(H),this.j.setFocus([H])}}G(d){d.preventDefault(),d.stopPropagation();const R=this.j.getFocusedElements();if(R.length===0)return;const _=R[0],Z=this.o.getNodeLocation(_);if(!this.o.setCollapsed(Z,!1)){if(!_.children.some(C=>C.visible))return;const[T]=this.j.getFocus(),H=T+1;this.j.reveal(H),this.j.setFocus([H])}}H(d){d.preventDefault(),d.stopPropagation();const R=this.j.getFocusedElements();if(R.length===0)return;const _=R[0],Z=this.o.getNodeLocation(_),k=d.browserEvent.altKey;this.o.setCollapsed(Z,void 0,k)}navigate(d){return new x(this.j,this.o,d)}dispose(){(0,S.dispose)(this.A),this.j.dispose()}}t.AbstractTree=F;class x{constructor(d,R,_){this.b=d,this.c=R,_?this.a=this.c.getListIndex(_):this.a=-1}current(){return this.a<0||this.a>=this.b.length?null:this.b.element(this.a).element}previous(){return this.a--,this.current()}next(){return this.a++,this.current()}first(){return this.a=0,this.current()}last(){return this.a=this.b.length-1,this.current()}}}),define(me[129],be([1,0,128,119,24,26]),function(te,t,y,M,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class p extends y.AbstractTree{constructor(h,a,c,P,r,l={}){super(h,a,c,P,l),this.f=h,this.g=r,this.d=new Map,this.c=l.identityProvider}getInput(){return this.b}setInput(h,a){if(a&&!this.c)throw new i.TreeError(this.f,"Can't restore tree view state without an identity provider");if(this.b=h,!h){this.d.clear(),this.o.setChildren(null,W.Iterable.empty());return}if(!a){this.m(h);return}const c=[],P=[],r=e=>{const o=this.c.getId(e).toString();return!a.expanded[o]},l=e=>{const o=this.c.getId(e.element).toString();a.focus.has(o)&&c.push(e.element),a.selection.has(o)&&P.push(e.element)};this.m(h,r,l),this.setFocus(c),this.setSelection(P),a&&typeof a.scrollTop=="number"&&(this.scrollTop=a.scrollTop)}updateChildren(h=this.b){if(typeof this.b>"u")throw new i.TreeError(this.f,"Tree input not set");let a;this.c&&(a=c=>{const P=this.c.getId(c).toString(),r=this.d.get(P);if(r)return r.collapsed}),this.m(h,a)}resort(h=this.b,a=!0){this.o.resort(h===this.b?null:h,a)}refresh(h){if(h===void 0){this.j.rerender();return}this.o.rerender(h)}m(h,a,c){let P;if(this.c){const r=new Set,l=c;c=e=>{const o=this.c.getId(e.element).toString();r.add(o),this.d.set(o,e),l?.(e)},P=e=>{const o=this.c.getId(e.element).toString();r.has(o)||this.d.delete(o)}}this.o.setChildren(h===this.b?null:h,this.s(h,a).elements,{onDidCreateNode:c,onDidDeleteNode:P})}s(h,a){const c=[...this.g.getChildren(h)];return{elements:W.Iterable.map(c,r=>{const{elements:l,size:e}=this.s(r,a),o=this.g.hasChildren?this.g.hasChildren(r):void 0,n=e===0?void 0:a&&a(r);return{element:r,children:l,collapsible:o,collapsed:n}}),size:c.length}}I(h,a,c){return new M.ObjectTreeModel(h,a,c)}}t.DataTree=p}),define(me[64],be([1,0,13,9,30,27,25,7,3,2,50,11,6]),function(te,t,y,M,i,W,p,A,h,a,c,P,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.deserialize=t.serialize=t.BufferWriter=t.BufferReader=void 0;var l;(function(ne){ne[ne.Promise=100]="Promise",ne[ne.PromiseCancel=101]="PromiseCancel",ne[ne.EventListen=102]="EventListen",ne[ne.EventDispose=103]="EventDispose"})(l||(l={}));function e(ne){switch(ne){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var o;(function(ne){ne[ne.Initialize=200]="Initialize",ne[ne.PromiseSuccess=201]="PromiseSuccess",ne[ne.PromiseError=202]="PromiseError",ne[ne.PromiseErrorObj=203]="PromiseErrorObj",ne[ne.EventFire=204]="EventFire"})(o||(o={}));function n(ne){switch(ne){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var u;(function(ne){ne[ne.Uninitialized=0]="Uninitialized",ne[ne.Idle=1]="Idle"})(u||(u={}));function s(ne){let Q=0;for(let oe=0;;oe+=7){const j=ne.read(1);if(Q|=(j.buffer[0]&127)<<oe,!(j.buffer[0]&128))return Q}}const w=L(0);function D(ne,Q){if(Q===0){ne.write(w);return}let oe=0;for(let V=Q;V!==0;V=V>>>7)oe++;const j=i.VSBuffer.alloc(oe);for(let V=0;Q!==0;V++)j.buffer[V]=Q&127,Q=Q>>>7,Q>0&&(j.buffer[V]|=128);ne.write(j)}class S{constructor(Q){this.b=Q,this.a=0}read(Q){const oe=this.b.slice(this.a,this.a+Q);return this.a+=oe.byteLength,oe}}t.BufferReader=S;class f{constructor(){this.a=[]}get buffer(){return i.VSBuffer.concat(this.a)}write(Q){this.a.push(Q)}}t.BufferWriter=f;var v;(function(ne){ne[ne.Undefined=0]="Undefined",ne[ne.String=1]="String",ne[ne.Buffer=2]="Buffer",ne[ne.VSBuffer=3]="VSBuffer",ne[ne.Array=4]="Array",ne[ne.Object=5]="Object",ne[ne.Int=6]="Int"})(v||(v={}));function L(ne){const Q=i.VSBuffer.alloc(1);return Q.writeUInt8(ne,0),Q}const N={Undefined:L(v.Undefined),String:L(v.String),Buffer:L(v.Buffer),VSBuffer:L(v.VSBuffer),Array:L(v.Array),Object:L(v.Object),Uint:L(v.Int)},E=typeof Buffer<"u";function g(ne,Q){if(typeof Q>"u")ne.write(N.Undefined);else if(typeof Q=="string"){const oe=i.VSBuffer.fromString(Q);ne.write(N.String),D(ne,oe.byteLength),ne.write(oe)}else if(E&&Buffer.isBuffer(Q)){const oe=i.VSBuffer.wrap(Q);ne.write(N.Buffer),D(ne,oe.byteLength),ne.write(oe)}else if(Q instanceof i.VSBuffer)ne.write(N.VSBuffer),D(ne,Q.byteLength),ne.write(Q);else if(Array.isArray(Q)){ne.write(N.Array),D(ne,Q.length);for(const oe of Q)g(ne,oe)}else if(typeof Q=="number"&&(Q|0)===Q)ne.write(N.Uint),D(ne,Q);else{const oe=i.VSBuffer.fromString(JSON.stringify(Q));ne.write(N.Object),D(ne,oe.byteLength),ne.write(oe)}}t.serialize=g;function m(ne){switch(ne.read(1).readUInt8(0)){case v.Undefined:return;case v.String:return ne.read(s(ne)).toString();case v.Buffer:return ne.read(s(ne)).buffer;case v.VSBuffer:return ne.read(s(ne));case v.Array:{const oe=s(ne),j=[];for(let V=0;V<oe;V++)j.push(m(ne));return j}case v.Object:return JSON.parse(ne.read(s(ne)).toString());case v.Int:return s(ne)}}t.deserialize=m;class b{constructor(Q,oe,j=null,V=1e3){this.h=Q,this.j=oe,this.k=j,this.l=V,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(F=>this.q(F)),this.m({type:200})}registerChannel(Q,oe){this.b.set(Q,oe),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const oe=this.o([Q.type]);this.k?.logOutgoing(oe,0,1,n(Q.type));return}case 201:case 202:case 204:case 203:{const oe=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(oe,Q.id,1,n(Q.type),Q.data);return}}}o(Q,oe=void 0){const j=new f;return g(j,Q),g(j,oe),this.p(j.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const oe=new S(Q),j=m(oe),V=m(oe),F=j[0];switch(F){case 100:return this.k?.logIncoming(Q.byteLength,j[1],1,`${e(F)}: ${j[2]}.${j[3]}`,V),this.s({type:F,id:j[1],channelName:j[2],name:j[3],arg:V});case 102:return this.k?.logIncoming(Q.byteLength,j[1],1,`${e(F)}: ${j[2]}.${j[3]}`,V),this.t({type:F,id:j[1],channelName:j[2],name:j[3],arg:V});case 101:return this.k?.logIncoming(Q.byteLength,j[1],1,`${e(F)}`),this.u({type:F,id:j[1]});case 103:return this.k?.logIncoming(Q.byteLength,j[1],1,`${e(F)}`),this.u({type:F,id:j[1]})}}s(Q){const oe=this.b.get(Q.channelName);if(!oe){this.v(Q);return}const j=new W.CancellationTokenSource;let V;try{V=oe.call(this.j,Q.name,Q.arg,j.token)}catch(I){V=Promise.reject(I)}const F=Q.id;V.then(I=>{this.m({id:F,data:I,type:201}),this.d.delete(Q.id)},I=>{I instanceof Error?this.m({id:F,data:{message:I.message,name:I.name,stack:I.stack?I.stack.split?I.stack.split(`
`):I.stack:void 0},type:202}):this.m({id:F,data:I,type:203}),this.d.delete(Q.id)});const x=(0,a.toDisposable)(()=>j.cancel());this.d.set(Q.id,x)}t(Q){const oe=this.b.get(Q.channelName);if(!oe){this.v(Q);return}const j=Q.id,F=oe.listen(this.j,Q.name,Q.arg)(x=>this.m({id:j,data:x,type:204}));this.d.set(Q.id,F)}u(Q){const oe=this.d.get(Q.id);oe&&(oe.dispose(),this.d.delete(Q.id))}v(Q){let oe=this.g.get(Q.channelName);oe||(oe=[],this.g.set(Q.channelName,oe));const j=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);oe.push({request:Q,timeoutTimer:j})}w(Q){const oe=this.g.get(Q);if(oe){for(const j of oe)switch(clearTimeout(j.timeoutTimer),j.request.type){case 100:this.s(j.request);break;case 102:this.t(j.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.dispose)(this.d.values()),this.d.clear()}}t.ChannelServer=b;var B;(function(ne){ne[ne.LocalSide=0]="LocalSide",ne[ne.OtherSide=1]="OtherSide"})(B||(t.RequestInitiator=B={}));class G{constructor(Q,oe=null){this.l=Q,this.a=!1,this.b=u.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new h.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(j=>this.s(j)),this.j=oe}getChannel(Q){const oe=this;return{call(j,V,F){return oe.a?Promise.reject(new A.CancellationError):oe.m(Q,j,V,F)},listen(j,V){return oe.a?h.Event.None:oe.o(Q,j,V)}}}m(Q,oe,j,V=W.CancellationToken.None){const F=this.g++,I={id:F,type:100,channelName:Q,name:oe,arg:j};if(V.isCancellationRequested)return Promise.reject(new A.CancellationError);let d;return new Promise((_,Z)=>{if(V.isCancellationRequested)return Z(new A.CancellationError);const k=()=>{const U=z=>{switch(z.type){case 201:this.f.delete(F),_(z.data);break;case 202:{this.f.delete(F);const O=new Error(z.data.message);O.stack=Array.isArray(z.data.stack)?z.data.stack.join(`
`):z.data.stack,O.name=z.data.name,Z(O);break}case 203:this.f.delete(F),Z(z.data);break}};this.f.set(F,U),this.p(I)};let T=null;this.b===u.Idle?k():(T=(0,M.createCancelablePromise)(U=>this.u()),T.then(()=>{T=null,k()}));const H=()=>{T?(T.cancel(),T=null):this.p({id:F,type:101}),Z(new A.CancellationError)},C=V.onCancellationRequested(H);d=(0,a.combinedDisposable)((0,a.toDisposable)(H),C),this.d.add(d)}).finally(()=>{this.d.delete(d)})}o(Q,oe,j){const V=this.g++,x={id:V,type:102,channelName:Q,name:oe,arg:j};let I=null;const d=new h.Emitter({onWillAddFirstListener:()=>{I=(0,M.createCancelablePromise)(_=>this.u()),I.then(()=>{I=null,this.d.add(d),this.p(x)})},onDidRemoveLastListener:()=>{I?(I.cancel(),I=null):(this.d.delete(d),this.p({id:V,type:103}))}}),R=_=>d.fire(_.data);return this.f.set(V,R),d.event}p(Q){switch(Q.type){case 100:case 102:{const oe=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(oe,Q.id,0,`${e(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const oe=this.q([Q.type,Q.id]);this.j?.logOutgoing(oe,Q.id,0,e(Q.type));return}}}q(Q,oe=void 0){const j=new f;return g(j,Q),g(j,oe),this.r(j.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const oe=new S(Q),j=m(oe),V=m(oe),F=j[0];switch(F){case 200:return this.j?.logIncoming(Q.byteLength,0,0,n(F)),this.t({type:j[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,j[1],0,n(F),V),this.t({type:j[0],id:j[1],data:V})}}t(Q){if(Q.type===200){this.b=u.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return h.Event.toPromise(this.onDidInitialize)}u(){return this.b===u.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.dispose)(this.d.values()),this.d.clear()}}t.ChannelClient=G,qe([p.memoize],G.prototype,"onDidInitializePromise",null);class J{get connections(){const Q=[];return this.f.forEach(oe=>Q.push(oe)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new h.Emitter,this.onDidAddConnection=this.g.event,this.h=new h.Emitter,this.onDidRemoveConnection=this.h.event,Q(({protocol:oe,onDidClientDisconnect:j})=>{h.Event.once(oe.onMessage)(F=>{const x=new S(F),I=m(x),d=new b(oe,I),R=new G(oe);this.a.forEach((Z,k)=>d.registerChannel(k,Z));const _={channelServer:d,channelClient:R,ctx:I};this.f.add(_),this.g.fire(_),j(()=>{d.dispose(),R.dispose(),this.f.delete(_),this.h.fire(_)})})})}getChannel(Q,oe){const j=this;return{call(V,F,x){let I;if((0,r.isFunction)(oe)){const R=(0,y.getRandomElement)(j.connections.filter(oe));I=R?Promise.resolve(R):h.Event.toPromise(h.Event.filter(j.onDidAddConnection,oe))}else I=oe.routeCall(j,V,F);const d=I.then(R=>R.channelClient.getChannel(Q));return le(d).call(V,F,x)},listen(V,F){if((0,r.isFunction)(oe))return j.j(Q,oe,V,F);const x=oe.routeEvent(j,V,F).then(I=>I.channelClient.getChannel(Q));return le(x).listen(V,F)}}}j(Q,oe,j,V){const F=this;let x=new a.DisposableStore;const I=new h.Emitter({onWillAddFirstListener:()=>{x=new a.DisposableStore;const d=new h.EventMultiplexer,R=new Map,_=k=>{const H=k.channelClient.getChannel(Q).listen(j,V),C=d.add(H);R.set(k,C)},Z=k=>{const T=R.get(k);T&&(T.dispose(),R.delete(k))};F.connections.filter(oe).forEach(_),h.Event.filter(F.onDidAddConnection,oe)(_,void 0,x),F.onDidRemoveConnection(Z,void 0,x),d.event(I.fire,I,x),x.add(d)},onDidRemoveLastListener:()=>{x.dispose()}});return I.event}registerChannel(Q,oe){this.a.set(Q,oe),this.f.forEach(j=>{j.channelServer.registerChannel(Q,oe)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}t.IPCServer=J;class ie{constructor(Q,oe,j=null){const V=new f;g(V,oe),Q.send(V.buffer),this.a=new G(Q,j),this.d=new b(Q,oe,j)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,oe){this.d.registerChannel(Q,oe)}dispose(){this.a.dispose(),this.d.dispose()}}t.IPCClient=ie;function le(ne){return{call(Q,oe,j){return ne.then(V=>V.call(Q,oe,j))},listen(Q,oe){const j=new h.Relay;return ne.then(V=>j.input=V.listen(Q,oe)),j.event}}}t.getDelayedChannel=le;function ge(ne){let Q=!1;return{call(oe,j,V){return Q?ne.call(oe,j,V):(0,M.timeout)(0).then(()=>Q=!0).then(()=>ne.call(oe,j,V))},listen(oe,j){if(Q)return ne.listen(oe,j);const V=new h.Relay;return(0,M.timeout)(0).then(()=>Q=!0).then(()=>V.input=ne.listen(oe,j)),V.event}}}t.getNextTickChannel=ge;class ue{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const oe of Q.connections)if(await Promise.resolve(this.a(oe.ctx)))return Promise.resolve(oe);return await h.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}t.StaticRouter=ue;var de;(function(ne){function Q(F,x){const I=F,d=x&&x.disableMarshalling,R=new Map;for(const _ in I)j(_)&&R.set(_,h.Event.buffer(I[_],!0));return new class{listen(_,Z,k){const T=R.get(Z);if(T)return T;if(V(Z)){const H=I[Z];if(typeof H=="function")return H.call(I,k)}throw new Error(`Event not found: ${Z}`)}call(_,Z,k){const T=I[Z];if(typeof T=="function"){if(!d&&Array.isArray(k))for(let H=0;H<k.length;H++)k[H]=(0,c.revive)(k[H]);return T.apply(I,k)}throw new Error(`Method not found: ${Z}`)}}}ne.fromService=Q;function oe(F,x){const I=x&&x.disableMarshalling;return new Proxy({},{get(d,R){if(typeof R=="string")return x?.properties?.has(R)?x.properties.get(R):V(R)?function(_){return F.listen(R,_)}:j(R)?F.listen(R):async function(..._){let Z;x&&!(0,r.isUndefinedOrNull)(x.context)?Z=[x.context,..._]:Z=_;const k=await F.call(R,Z);return I?k:(0,c.revive)(k)};throw new Error(`Property not found: ${String(R)}`)}})}ne.toService=oe;function j(F){return F[0]==="o"&&F[1]==="n"&&P.isUpperAsciiLetter(F.charCodeAt(2))}function V(F){return/^onDynamic/.test(F)&&P.isUpperAsciiLetter(F.charCodeAt(9))}})(de||(t.ProxyChannel=de={}));const ce=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Se(ne){if(Array.isArray(ne))return ne;if(ne&&typeof ne=="object"&&typeof ne.toString=="function"){const Q=ne.toString();if(Q!=="[object Object]")return Q}return ne}function Ae(ne){return Array.isArray(ne)?ne.map(Se):Se(ne)}function Be(ne,Q,oe,j,V,F,x){x=Ae(x);const I=ce[V],d=I[j%I.length];let R=[`%c[${ne}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(oe).padStart(5," ")}]%c${String(j).padStart(5," ")} - ${F}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(F)?(R=R.concat(x),R.push(")")):R.push(x),console.log.apply(console,R)}class re{constructor(Q,oe){this.d=Q,this.f=oe,this.a=0,this.b=0}logOutgoing(Q,oe,j,V,F){this.b+=Q,Be(this.d,this.b,Q,oe,j,V,F)}logIncoming(Q,oe,j,V,F){this.a+=Q,Be(this.f,this.a,Q,oe,j,V,F)}}t.IPCLogger=re}),define(me[29],be([1,0,5]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=y.globals.vscode.ipcRenderer,t.ipcMessagePort=y.globals.vscode.ipcMessagePort,t.webFrame=y.globals.vscode.webFrame,t.process=y.globals.vscode.process,t.context=y.globals.vscode.context}),define(me[130],be([1,0,81,29]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let i=0;function W(A,h,a){const c=[],P=i++,r=`vscode:onContextMenu${P}`,l=(e,o,n)=>{c[o].click?.(n)};M.ipcRenderer.once(r,l),M.ipcRenderer.once(y.CONTEXT_MENU_CLOSE_CHANNEL,(e,o)=>{o===P&&(M.ipcRenderer.removeListener(r,l),a?.())}),M.ipcRenderer.send(y.CONTEXT_MENU_CHANNEL,P,A.map(e=>p(e,c)),r,h)}t.popup=W;function p(A,h){const a={id:h.length,label:A.label,type:A.type,accelerator:A.accelerator,checked:A.checked,enabled:typeof A.enabled=="boolean"?A.enabled:!0,visible:typeof A.visible=="boolean"?A.visible:!0};return h.push(A),Array.isArray(A.submenu)&&(a.submenu=A.submenu.map(c=>p(c,h))),a}}),define(me[131],be([1,0,30,3,64,82,29]),function(te,t,y,M,i,W,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class A extends i.IPCClient{static f(){const a=M.Event.fromNodeEventEmitter(p.ipcRenderer,"vscode:message",(c,P)=>y.VSBuffer.wrap(P));return p.ipcRenderer.send("vscode:hello"),new W.Protocol(p.ipcRenderer,a)}constructor(a){const c=A.f();super(c,a),this.b=c}dispose(){this.b.disconnect()}}t.Client=A}),define(me[132],be([12,10]),function(te,t){return te.create("vs/platform/files/common/files",t)}),define(me[133],be([12,10]),function(te,t){return te.create("vs/platform/theme/common/iconRegistry",t)}),define(me[37],be([1,0]),function(te,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var y;(function(p){p.serviceIds=new Map,p.DI_TARGET="$di$target",p.DI_DEPENDENCIES="$di$dependencies";function A(h){return h[p.DI_DEPENDENCIES]||[]}p.getServiceDependencies=A})(y||(t._util=y={})),t.IInstantiationService=i("instantiationService");function M(p,A,h){A[y.DI_TARGET]===A?A[y.DI_DEPENDENCIES].push({id:p,index:h}):(A[y.DI_DEPENDENCIES]=[{id:p,index:h}],A[y.DI_TARGET]=A)}function i(p){if(y.serviceIds.has(p))return y.serviceIds.get(p);const A=function(h,a,c){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");M(A,h,c)};return A.toString=()=>p,y.serviceIds.set(p,A),A}t.createDecorator=i;function W(p){return p}t.refineServiceDecorator=W}),define(me[134],be([1,0,37]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,y.createDecorator)(t.ID);function M(W){return!!W.hostName&&!!W.errorMessage}t.isRemoteDiagnosticError=M;class i{async getPerformanceInfo(p,A){return{}}async getSystemInfo(p,A){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(p,A){return""}async getWorkspaceFileExtensions(p){return{extensions:[]}}async reportWorkspaceStats(p){}}t.NullDiagnosticsService=i}),define(me[135],be([1,0,113,22,11,6,15,132,37,5,28]),function(te,t,y,M,i,W,p,A,h,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLargeFileConfirmationLimit=t.ByteSize=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.TooLargeFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,h.createDecorator)("fileService");function P(re){return re.create===!0}t.isFileOpenForWriteOptions=P;var r;(function(re){re[re.Unknown=0]="Unknown",re[re.File=1]="File",re[re.Directory=2]="Directory",re[re.SymbolicLink=64]="SymbolicLink"})(r||(t.FileType=r={}));var l;(function(re){re[re.Readonly=1]="Readonly"})(l||(t.FilePermission=l={}));var e;(function(re){re[re.None=0]="None",re[re.FileReadWrite=2]="FileReadWrite",re[re.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",re[re.FileReadStream=16]="FileReadStream",re[re.FileFolderCopy=8]="FileFolderCopy",re[re.PathCaseSensitive=1024]="PathCaseSensitive",re[re.Readonly=2048]="Readonly",re[re.Trash=4096]="Trash",re[re.FileWriteUnlock=8192]="FileWriteUnlock",re[re.FileAtomicRead=16384]="FileAtomicRead",re[re.FileClone=32768]="FileClone"})(e||(t.FileSystemProviderCapabilities=e={}));function o(re){return!!(re.capabilities&2)}t.hasReadWriteCapability=o;function n(re){return!!(re.capabilities&8)}t.hasFileFolderCopyCapability=n;function u(re){return!!(re.capabilities&32768)}t.hasFileCloneCapability=u;function s(re){return!!(re.capabilities&4)}t.hasOpenReadWriteCloseCapability=s;function w(re){return!!(re.capabilities&16)}t.hasFileReadStreamCapability=w;function D(re){return o(re)?!!(re.capabilities&16384):!1}t.hasFileAtomicReadCapability=D;var S;(function(re){re.FileExists="EntryExists",re.FileNotFound="EntryNotFound",re.FileNotADirectory="EntryNotADirectory",re.FileIsADirectory="EntryIsADirectory",re.FileExceedsStorageQuota="EntryExceedsStorageQuota",re.FileTooLarge="EntryTooLarge",re.FileWriteLocked="EntryWriteLocked",re.NoPermissions="NoPermissions",re.Unavailable="Unavailable",re.Unknown="Unknown"})(S||(t.FileSystemProviderErrorCode=S={}));class f extends Error{static create(ne,Q){const oe=new f(ne.toString(),Q);return N(oe,Q),oe}constructor(ne,Q){super(ne),this.code=Q}}t.FileSystemProviderError=f;function v(re,ne){return f.create(re,ne)}t.createFileSystemProviderError=v;function L(re){return re||v((0,A.localize)(0,null),S.Unknown)}t.ensureFileSystemProviderError=L;function N(re,ne){return re.name=ne?`${ne} (FileSystemError)`:"FileSystemError",re}t.markAsFileSystemProviderError=N;function E(re){if(!re)return S.Unknown;if(re instanceof f)return re.code;const ne=/^(.+) \(FileSystemError\)$/.exec(re.name);if(!ne)return S.Unknown;switch(ne[1]){case S.FileExists:return S.FileExists;case S.FileIsADirectory:return S.FileIsADirectory;case S.FileNotADirectory:return S.FileNotADirectory;case S.FileNotFound:return S.FileNotFound;case S.FileTooLarge:return S.FileTooLarge;case S.FileWriteLocked:return S.FileWriteLocked;case S.NoPermissions:return S.NoPermissions;case S.Unavailable:return S.Unavailable}return S.Unknown}t.toFileSystemProviderErrorCode=E;function g(re){if(re instanceof ie)return re.fileOperationResult;switch(E(re)){case S.FileNotFound:return 1;case S.FileIsADirectory:return 0;case S.FileNotADirectory:return 9;case S.FileWriteLocked:return 5;case S.NoPermissions:return 6;case S.FileExists:return 4;case S.FileTooLarge:return 7;default:return 10}}t.toFileOperationResult=g;var m;(function(re){re[re.CREATE=0]="CREATE",re[re.DELETE=1]="DELETE",re[re.MOVE=2]="MOVE",re[re.COPY=3]="COPY",re[re.WRITE=4]="WRITE"})(m||(t.FileOperation=m={}));class b{constructor(ne,Q,oe){this.resource=ne,this.operation=Q,this.target=oe}isOperation(ne){return this.operation===ne}}t.FileOperationEvent=b;var B;(function(re){re[re.UPDATED=0]="UPDATED",re[re.ADDED=1]="ADDED",re[re.DELETED=2]="DELETED"})(B||(t.FileChangeType=B={}));class G{constructor(ne,Q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const oe=new Map;for(const j of ne){const V=oe.get(j.type);switch(V?V.push([j.resource,j]):oe.set(j.type,[[j.resource,j]]),j.type){case 1:this.rawAdded.push(j.resource);break;case 0:this.rawUpdated.push(j.resource);break;case 2:this.rawDeleted.push(j.resource);break}}for(const[j,V]of oe)switch(j){case 1:this.a=y.TernarySearchTree.forUris(()=>Q),this.a.fill(V);break;case 0:this.b=y.TernarySearchTree.forUris(()=>Q),this.b.fill(V);break;case 2:this.c=y.TernarySearchTree.forUris(()=>Q),this.c.fill(V);break}}contains(ne,...Q){return this.d(ne,{includeChildren:!1},...Q)}affects(ne,...Q){return this.d(ne,{includeChildren:!0},...Q)}d(ne,Q,...oe){if(!ne)return!1;const j=oe.length>0;return!!((!j||oe.includes(1))&&(this.a?.get(ne)||Q.includeChildren&&this.a?.findSuperstr(ne))||(!j||oe.includes(0))&&(this.b?.get(ne)||Q.includeChildren&&this.b?.findSuperstr(ne))||(!j||oe.includes(2))&&(this.c?.findSubstr(ne)||Q.includeChildren&&this.c?.findSuperstr(ne)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}t.FileChangesEvent=G;function J(re,ne,Q){return!re||!ne||re===ne||ne.length>re.length?!1:(ne.charAt(ne.length-1)!==M.sep&&(ne+=M.sep),Q?(0,i.startsWithIgnoreCase)(re,ne):re.indexOf(ne)===0)}t.isParent=J;class ie extends Error{constructor(ne,Q,oe){super(ne),this.fileOperationResult=Q,this.options=oe}}t.FileOperationError=ie;class le extends ie{constructor(ne,Q,oe,j){super(ne,Q,j),this.fileOperationResult=Q,this.size=oe}}t.TooLargeFileOperationError=le;class ge extends ie{constructor(ne,Q,oe){super(ne,2,oe),this.stat=Q}}t.NotModifiedSinceFileOperationError=ge;var ue;(function(re){re[re.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",re[re.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",re[re.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",re[re.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",re[re.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",re[re.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",re[re.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",re[re.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",re[re.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",re[re.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",re[re.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(ue||(t.FileOperationResult=ue={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var de;(function(re){re[re.FILE=0]="FILE",re[re.FOLDER=1]="FOLDER",re[re.ROOT_FOLDER=2]="ROOT_FOLDER"})(de||(t.FileKind=de={})),t.ETAG_DISABLED="";function ce(re){if(!(typeof re.size!="number"||typeof re.mtime!="number"))return re.mtime.toString(29)+re.size.toString(31)}t.etag=ce;async function Se(re,ne){if(!ne.hasProvider(p.URI.from({scheme:re.scheme})))return new Promise(Q=>{const oe=ne.onDidChangeFileSystemProviderRegistrations(j=>{j.scheme===re.scheme&&j.added&&(oe.dispose(),Q())})})}t.whenProviderRegistered=Se;class Ae{static formatSize(ne){return(0,W.isNumber)(ne)||(ne=0),ne<Ae.KB?(0,A.localize)(1,null,ne.toFixed(0)):ne<Ae.MB?(0,A.localize)(2,null,(ne/Ae.KB).toFixed(2)):ne<Ae.GB?(0,A.localize)(3,null,(ne/Ae.MB).toFixed(2)):ne<Ae.TB?(0,A.localize)(4,null,(ne/Ae.GB).toFixed(2)):(0,A.localize)(5,null,(ne/Ae.TB).toFixed(2))}}t.ByteSize=Ae,Ae.KB=1024,Ae.MB=Ae.KB*Ae.KB,Ae.GB=Ae.MB*Ae.KB,Ae.TB=Ae.GB*Ae.KB;function Be(re){const ne=typeof re=="string"||re?.scheme===c.Schemas.vscodeRemote;return typeof re!="string"&&re?.scheme===c.Schemas.file?1024*Ae.MB:ne?10*Ae.MB:a.isWeb?50*Ae.MB:1024*Ae.MB}t.getLargeFileConfirmationLimit=Be}),define(me[136],be([1,0,37]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MainProcessService=t.IMainProcessService=void 0,t.IMainProcessService=(0,y.createDecorator)("mainProcessService");class M{constructor(W,p){this.a=W,this.b=p}getChannel(W){return this.a.getChannel(W,this.b)}registerChannel(W,p){this.a.registerChannel(W,p)}}t.MainProcessService=M}),define(me[137],be([1,0,2,131]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class i extends y.Disposable{constructor(p){super(),this.a=this.B(new M.Client(`window:${p}`))}getChannel(p){return this.a.getChannel(p)}registerChannel(p,A){this.a.registerChannel(p,A)}}t.ElectronIPCMainProcessService=i});var ci=this&&this.__param||function(te,t){return function(y,M){t(y,M,te)}};define(me[138],be([1,0,64,136]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let i=t.NativeHostService=class{constructor(p,A){return this.windowId=p,y.ProxyChannel.toService(A.getChannel("nativeHost"),{context:p,properties:(()=>{const h=new Map;return h.set("windowId",p),h})()})}};t.NativeHostService=i=qe([ci(1,M.IMainProcessService)],i)}),define(me[65],be([1,0,72,6]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class i{constructor(){this.a=new Map}add(p,A){y.ok(M.isString(p)),y.ok(M.isObject(A)),y.ok(!this.a.has(p),"There is already an extension with this id"),this.a.set(p,A)}knows(p){return this.a.has(p)}as(p){return this.a.get(p)||null}}t.Registry=new i}),define(me[139],be([1,0,3,65]),function(te,t,y,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function i(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class W{constructor(){this.b=new y.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(h,a){this.a[i(h)]=a,this.b.fire(h)}notifySchemaChanged(h){this.b.fire(h)}getSchemaContributions(){return{schemas:this.a}}}const p=new W;M.Registry.add(t.Extensions.JSONContribution,p)}),define(me[140],be([1,0,9,16,17,3,6,15,133,139,65]),function(te,t,y,M,i,W,p,A,h,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var P;(function(D){function S(f,v){let L=f.defaults;for(;i.ThemeIcon.isThemeIcon(L);){const N=e.getIcon(L.id);if(!N)return;L=N.defaults}return L}D.getDefinition=S})(P||(t.IconContribution=P={}));var r;(function(D){function S(v){return{weight:v.weight,style:v.style,src:v.src.map(L=>({format:L.format,location:L.location.toString()}))}}D.toJSONObject=S;function f(v){const L=N=>(0,p.isString)(N)?N:void 0;if(v&&Array.isArray(v.src)&&v.src.every(N=>(0,p.isString)(N.format)&&(0,p.isString)(N.location)))return{weight:L(v.weight),style:L(v.style),src:v.src.map(N=>({format:N.format,location:A.URI.parse(N.location)}))}}D.fromJSONObject=f})(r||(t.IconFontDefinition=r={}));class l{constructor(){this.a=new W.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,h.localize)(0,null)},fontCharacter:{type:"string",description:(0,h.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${i.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(S,f,v,L){const N=this.b[S];if(N){if(v&&!N.description){N.description=v,this.d.properties[S].markdownDescription=`${v} $(${S})`;const m=this.e.enum.indexOf(S);m!==-1&&(this.e.enumDescriptions[m]=v),this.a.fire()}return N}const E={id:S,description:v,defaults:f,deprecationMessage:L};this.b[S]=E;const g={$ref:"#/definitions/icons"};return L&&(g.deprecationMessage=L),v&&(g.markdownDescription=`${v}: $(${S})`),this.d.properties[S]=g,this.e.enum.push(S),this.e.enumDescriptions.push(v||""),this.a.fire(),{id:S}}deregisterIcon(S){delete this.b[S],delete this.d.properties[S];const f=this.e.enum.indexOf(S);f!==-1&&(this.e.enum.splice(f,1),this.e.enumDescriptions.splice(f,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(S=>this.b[S])}getIcon(S){return this.b[S]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(S,f){const v=this.f[S];return v||(this.f[S]=f,this.a.fire(),f)}deregisterIconFont(S){delete this.f[S]}getIconFont(S){return this.f[S]}toString(){const S=(N,E)=>N.id.localeCompare(E.id),f=N=>{for(;i.ThemeIcon.isThemeIcon(N.defaults);)N=this.b[N.defaults.id];return`codicon codicon-${N?N.id:""}`},v=[];v.push("| preview     | identifier                        | default codicon ID                | description"),v.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const L=Object.keys(this.b).map(N=>this.b[N]);for(const N of L.filter(E=>!!E.description).sort(S))v.push(`|<i class="${f(N)}"></i>|${N.id}|${i.ThemeIcon.isThemeIcon(N.defaults)?N.defaults.id:N.id}|${N.description||""}|`);v.push("| preview     | identifier                        "),v.push("| ----------- | --------------------------------- |");for(const N of L.filter(E=>!i.ThemeIcon.isThemeIcon(E.defaults)).sort(S))v.push(`|<i class="${f(N)}"></i>|${N.id}|`);return v.join(`
`)}}const e=new l;c.Registry.add(t.Extensions.IconContribution,e);function o(D,S,f,v){return e.registerIcon(D,S,f,v)}t.registerIcon=o;function n(){return e}t.getIconRegistry=n;function u(){const D=(0,M.getCodiconFontCharacters)();for(const S in D){const f="\\"+D[S].toString(16);e.registerIcon(S,{fontCharacter:f})}}u(),t.iconsSchemaId="vscode://schemas/icons";const s=c.Registry.as(a.Extensions.JSONContribution);s.registerSchema(t.iconsSchemaId,e.getIconSchema());const w=new y.RunOnceScheduler(()=>s.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{w.isScheduled()||w.schedule()}),t.widgetClose=o("widget-close",M.Codicon.close,(0,h.localize)(2,null)),t.gotoPreviousLocation=o("goto-previous-location",M.Codicon.arrowUp,(0,h.localize)(3,null)),t.gotoNextLocation=o("goto-next-location",M.Codicon.arrowDown,(0,h.localize)(4,null)),t.syncing=i.ThemeIcon.modify(M.Codicon.sync,"spin"),t.spinningLoading=i.ThemeIcon.modify(M.Codicon.loading,"spin")}),define(me[141],be([1,0,4,3,17,140]),function(te,t,y,M,i,W){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function p(h){const a=new M.Emitter,c=(0,W.getIconRegistry)();return c.onDidChange(()=>a.fire()),h?.onDidProductIconThemeChange(()=>a.fire()),{onDidChange:a.event,getCSS(){const P=h?h.getProductIconTheme():new A,r={},l=o=>{const n=P.getIcon(o);if(!n)return;const u=n.font;return u?(r[u.id]=u.definition,`.codicon-${o.id}:before { content: '${n.fontCharacter}'; font-family: ${(0,y.asCSSPropertyValue)(u.id)}; }`):`.codicon-${o.id}:before { content: '${n.fontCharacter}'; }`},e=[];for(const o of c.getIcons()){const n=l(o);n&&e.push(n)}for(const o in r){const n=r[o],u=n.weight?`font-weight: ${n.weight};`:"",s=n.style?`font-style: ${n.style};`:"",w=n.src.map(D=>`${(0,y.asCSSUrl)(D.location)} format('${D.format}')`).join(", ");e.push(`@font-face { src: ${w}; font-family: ${(0,y.asCSSPropertyValue)(o)};${u}${s} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=p;class A{getIcon(a){const c=(0,W.getIconRegistry)();let P=a.defaults;for(;i.ThemeIcon.isThemeIcon(P);){const r=c.getIcon(P.id);if(!r)return;P=r.defaults}return P}}t.UnthemedProductIconTheme=A}),define(me[142],be([1,0,5]),function(te,t,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function M(c){return!!c.workspaceUri}t.isWorkspaceToOpen=M;function i(c){return!!c.folderUri}t.isFolderToOpen=i;function W(c){return!!c.fileUri}t.isFileToOpen=W;function p(c){const P=A(c),r=c.getValue("window.menuBarVisibility");return r==="default"||P==="native"&&r==="compact"||y.isMacintosh&&y.isNative?"classic":r}t.getMenuBarVisibility=p;function A(c){if(y.isWeb)return"custom";const P=c.getValue("window");if(P){if(y.isMacintosh&&P.nativeTabs===!0||y.isMacintosh&&P.nativeFullScreen===!1)return"native";const e=P.titleBarStyle;if(e==="native"||e==="custom")return e}return y.isLinux?"native":"custom"}t.getTitleBarStyle=A;function h(c){if(!y.isWindows||y.isWeb||A(c)==="native")return!1;const P=c.getValue("window.experimental.windowControlsOverlay.enabled");return typeof P=="boolean"?P:!0}t.useWindowControlsOverlay=h;function a(c=0){return Math.pow(1.2,c)}t.zoomLevelToZoomFactor=a}),define(me[143],be([1,0,18,29,142]),function(te,t,y,M,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function W(h){M.webFrame.setZoomLevel(h),(0,y.setZoomFactor)((0,i.zoomLevelToZoomFactor)(h)),(0,y.setZoomLevel)(h,!1)}t.applyZoom=W;function p(){W((0,y.getZoomLevel)()+1)}t.zoomIn=p;function A(){W((0,y.getZoomLevel)()-1)}t.zoomOut=A}),define(me[144],be([1,0,10,4,129,9,130,29,134,135,137,138,141,143,14,95,86]),function(te,t,y,M,i,W,p,A,h,a,c,P,r,l,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const o=/\s--inspect(?:-brk|port)?=(?<port>\d+)?/,n=/\s--inspect-port=(?<port>\d+)/;class u{getHeight(B){return 22}getTemplateId(B){return N(B)?"process":v(B)?"machine":(0,h.isRemoteDiagnosticError)(B)?"error":L(B)?"header":""}}class s{hasChildren(B){return(0,h.isRemoteDiagnosticError)(B)?!1:N(B)?!!B.children?.length:!0}getChildren(B){return N(B)?B.children?B.children:[]:(0,h.isRemoteDiagnosticError)(B)?[]:L(B)?B.processRoots.length>1?B.processRoots:[B.processRoots[0].rootProcess]:v(B)?[B.rootProcess]:[B.processes]}}class w{constructor(){this.templateId="header"}renderTemplate(B){const G=(0,M.append)(B,(0,M.$)(".row")),J=(0,M.append)(G,(0,M.$)(".nameLabel")),ie=(0,M.append)(G,(0,M.$)(".cpu")),le=(0,M.append)(G,(0,M.$)(".memory")),ge=(0,M.append)(G,(0,M.$)(".pid"));return{name:J,CPU:ie,memory:le,PID:ge}}renderElement(B,G,J,ie){J.name.textContent=(0,y.localize)(0,null),J.CPU.textContent=(0,y.localize)(1,null),J.PID.textContent=(0,y.localize)(2,null),J.memory.textContent=(0,y.localize)(3,null)}disposeTemplate(B){}}class D{constructor(){this.templateId="machine"}renderTemplate(B){const G=Object.create(null),J=(0,M.append)(B,(0,M.$)(".row"));return G.name=(0,M.append)(J,(0,M.$)(".nameLabel")),G}renderElement(B,G,J,ie){J.name.textContent=B.element.name}disposeTemplate(B){}}class S{constructor(){this.templateId="error"}renderTemplate(B){const G=Object.create(null),J=(0,M.append)(B,(0,M.$)(".row"));return G.name=(0,M.append)(J,(0,M.$)(".nameLabel")),G}renderElement(B,G,J,ie){J.name.textContent=B.element.errorMessage}disposeTemplate(B){}}class f{constructor(B,G,J){this.a=B,this.b=G,this.c=J,this.templateId="process"}renderTemplate(B){const G=(0,M.append)(B,(0,M.$)(".row")),J=(0,M.append)(G,(0,M.$)(".nameLabel")),ie=(0,M.append)(G,(0,M.$)(".cpu")),le=(0,M.append)(G,(0,M.$)(".memory")),ge=(0,M.append)(G,(0,M.$)(".pid"));return{name:J,CPU:ie,PID:ge,memory:le}}renderElement(B,G,J,ie){const{element:le}=B,ge=le.pid.toFixed(0);let ue=le.name;this.c.has(le.pid)&&(ue=this.c.get(le.pid)),J.name.textContent=ue,J.name.title=le.cmd,J.CPU.textContent=le.load.toFixed(0),J.PID.textContent=ge,J.PID.parentElement.id=`pid-${ge}`;const de=this.a==="win32"?le.mem:this.b*(le.mem/100);J.memory.textContent=(de/a.ByteSize.MB).toFixed(0)}disposeTemplate(B){}}function v(b){return!!b.name&&!!b.rootProcess}function L(b){return!!b.processRoots}function N(b){return!!b.pid}class E{constructor(B,G){this.f=G,this.b=new Map;const J=new c.ElectronIPCMainProcessService(B);this.c=new P.NativeHostService(B,J),this.k(G.styles),this.g(G),A.ipcRenderer.on("vscode:pidToNameResponse",(ie,le)=>{this.b=new Map;for(const[ge,ue]of le)this.b.set(ge,ue)}),A.ipcRenderer.on("vscode:listProcessesResponse",async(ie,le)=>{le.forEach((ge,ue)=>{N(ge.rootProcess)&&(ge.rootProcess.name=ue===0?`${this.f.applicationName} main`:"remote agent")}),this.d?(this.d.setInput({processes:{processRoots:le}}),this.d.layout(window.innerHeight,window.innerWidth)):await this.h(le),this.m(0)}),this.a=Date.now(),A.ipcRenderer.send("vscode:pidToNameRequest"),A.ipcRenderer.send("vscode:listProcesses")}g(B){document.onkeydown=G=>{const J=B.platform==="darwin"?G.metaKey:G.ctrlKey;J&&G.keyCode===87&&(G.stopPropagation(),G.preventDefault(),A.ipcRenderer.send("vscode:closeProcessExplorer")),J&&G.keyCode===187&&(0,l.zoomIn)(),J&&G.keyCode===189&&(0,l.zoomOut)()}}async h(B){const G=document.getElementById("process-list");if(!G)return;const{totalmem:J}=await this.c.getOSStatistics(),ie=[new f(this.f.platform,J,this.b),new w,new D,new S];this.d=new i.DataTree("processExplorer",G,new u,ie,new s,{identityProvider:{getId:le=>N(le)?le.pid.toString():(0,h.isRemoteDiagnosticError)(le)?le.hostName:L(le)?"processes":v(le)?le.name:"header"}}),this.d.setInput({processes:{processRoots:B}}),this.d.layout(window.innerHeight,window.innerWidth),this.d.onKeyDown(le=>{const ge=new e.StandardKeyboardEvent(le);if(ge.keyCode===35&&ge.altKey){const ue=this.n();Promise.all(ue.map(de=>this.c.killProcess(de,"SIGTERM"))).then(()=>this.d?.refresh())}}),this.d.onContextMenu(le=>{N(le.element)&&this.l(le.element,!0)}),G.style.height=`${window.innerHeight}px`,window.addEventListener("resize",()=>{G.style.height=`${window.innerHeight}px`,this.d?.layout(window.innerHeight,window.innerWidth)})}i(B){const G=o.exec(B);return G&&G.groups.port!=="0"||B.indexOf("node ")>=0||B.indexOf("node.exe")>=0}j(B){const G={type:"node",request:"attach",name:`process ${B.pid}`};let J=o.exec(B.cmd);J?G.port=Number(J.groups.port):G.processId=String(B.pid),J=n.exec(B.cmd),J&&(G.port=Number(J.groups.port)),A.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[G]})}k(B){const G=(0,M.createStyleSheet)(),J=[];B.listFocusBackground&&(J.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${B.listFocusBackground}; }`),J.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${B.listFocusBackground}; }`)),B.listFocusForeground&&J.push(`.monaco-list:focus .monaco-list-row.focused { color: ${B.listFocusForeground}; }`),B.listActiveSelectionBackground&&(J.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${B.listActiveSelectionBackground}; }`),J.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${B.listActiveSelectionBackground}; }`)),B.listActiveSelectionForeground&&J.push(`.monaco-list:focus .monaco-list-row.selected { color: ${B.listActiveSelectionForeground}; }`),B.listHoverBackground&&J.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${B.listHoverBackground}; }`),B.listHoverForeground&&J.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${B.listHoverForeground}; }`),B.listFocusOutline&&J.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${B.listFocusOutline}; outline-offset: -1px; }`),B.listHoverOutline&&J.push(`.monaco-list-row:hover { outline: 1px dashed ${B.listHoverOutline}; outline-offset: -1px; }`),B.scrollbarShadowColor&&J.push(`
				.monaco-scrollable-element > .shadow.top {
					box-shadow: ${B.scrollbarShadowColor} 0 6px 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.left {
					box-shadow: ${B.scrollbarShadowColor} 6px 0 6px -6px inset;
				}

				.monaco-scrollable-element > .shadow.top.left {
					box-shadow: ${B.scrollbarShadowColor} 6px 6px 6px -6px inset;
				}
			`),B.scrollbarSliderBackgroundColor&&J.push(`
				.monaco-scrollable-element > .scrollbar > .slider {
					background: ${B.scrollbarSliderBackgroundColor};
				}
			`),B.scrollbarSliderHoverBackgroundColor&&J.push(`
				.monaco-scrollable-element > .scrollbar > .slider:hover {
					background: ${B.scrollbarSliderHoverBackgroundColor};
				}
			`),B.scrollbarSliderActiveBackgroundColor&&J.push(`
				.monaco-scrollable-element > .scrollbar > .slider.active {
					background: ${B.scrollbarSliderActiveBackgroundColor};
				}
			`),G.textContent=J.join(`
`),B.color&&(document.body.style.color=B.color)}l(B,G){const J=[],ie=Number(B.pid);G&&(J.push({accelerator:"Alt+E",label:(0,y.localize)(4,null),click:()=>{this.c.killProcess(ie,"SIGTERM")}}),J.push({label:(0,y.localize)(5,null),click:()=>{this.c.killProcess(ie,"SIGKILL")}}),J.push({type:"separator"})),J.push({label:(0,y.localize)(6,null),click:()=>{const le=this.n();le?.includes(ie)||(le.length=0,le.push(ie));const ge=le?.map(ue=>document.getElementById(`pid-${ue}`)).filter(ue=>!!ue);if(ge){const ue=ge.map(de=>de.innerText).filter(de=>!!de);this.c.writeClipboardText(ue.join(`
`))}}}),J.push({label:(0,y.localize)(7,null),click:()=>{const le=document.getElementById("process-list");le&&this.c.writeClipboardText(le.innerText)}}),B&&G&&this.i(B.cmd)&&(J.push({type:"separator"}),J.push({label:(0,y.localize)(8,null),click:()=>{this.j(B)}})),(0,p.popup)(J)}m(B){setTimeout(()=>{const G=Date.now(),J=B+G-this.a;this.a=G,J>1e3?(A.ipcRenderer.send("vscode:pidToNameRequest"),A.ipcRenderer.send("vscode:listProcesses")):this.m(J)},200)}n(){return this.d?.getSelection()?.map(B=>{if(!(!B||!("pid"in B)))return B.pid}).filter(B=>!!B)}}function g(){const b=(0,M.createStyleSheet)();b.id="codiconStyles";const B=(0,r.getIconsStyleSheet)(void 0);function G(){b.textContent=B.getCSS()}const J=new W.RunOnceScheduler(G,0);B.onDidChange(()=>J.schedule()),J.schedule()}function m(b){const B=b.data.platform==="win32"?"windows":b.data.platform==="linux"?"linux":"mac";document.body.classList.add(B),g(),(0,l.applyZoom)(b.data.zoomLevel),new E(b.windowId,b.data)}t.startup=m})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
