/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var oe=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/nls!vs/code/node/sharedProcess/sharedProcessMain","vs/nls","vs/base/common/errors","vs/platform/log/common/log","vs/base/common/types","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/path","vs/platform/environment/common/environment","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","vs/base/common/resources","vs/platform/userDataSync/common/userDataSync","vs/base/common/network","vs/platform/product/common/productService","vs/base/common/cancellation","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/objects","vs/base/common/uuid","vs/platform/extensionManagement/common/extensionManagementUtil","os","vs/base/common/json","vs/base/common/process","vs/base/common/map","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/parts/ipc/common/ipc","vs/base/common/jsonFormatter","vs/base/common/stream","vs/platform/externalServices/common/serviceMachineId","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/ternarySearchTree","child_process","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/codicons","fs","vs/base/common/semver/semver","vs/platform/files/common/watcher","vs/platform/native/common/native","vs/platform/policy/common/policy","vs/platform/request/common/request","vs/platform/userDataSync/common/content","vs/platform/userDataProfile/common/userDataProfileStorageService","vs/base/common/decorators","vs/base/common/iterator","net","vs/base/common/date","vs/base/common/hash","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","crypto","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/common/mainProcessService","vs/platform/languagePacks/common/languagePacks","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/storage/common/storageIpc","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/node/zip","vs/base/common/functional","vs/base/common/jsonEdit","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/uriIpc","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","vs/platform/environment/node/environmentService","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/base/common/performance","vs/platform/lifecycle/node/sharedProcessLifecycleService","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remoteTunnel/common/remoteTunnel","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/terminal","vs/platform/userDataSync/common/ignoredExtensions","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataProfilesManifestSync","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/symbols","vs/base/common/themables","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/sandbox/node/electronTypes","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/cache","vs/base/common/console","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/node/ipc.mp","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/remoteTunnel/common/remoteTunnel","vs/nls!vs/platform/remoteTunnel/node/remoteTunnelService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryLogAppender","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncLog","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","path","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionRecommendations/common/extensionRecommendationsIpc","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/code/node/sharedProcess/contrib/localizationsUpdater","vs/code/node/sharedProcess/contrib/logsDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/policy/common/policyIpc","vs/code/node/sharedProcess/contrib/codeCacheCleaner","vs/code/node/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/userDataProfilesManifestMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/windows/node/windowTracker","vs/code/node/sharedProcess/contrib/userDataProfilesCleaner","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/node/extensionTipsService","vs/platform/remoteTunnel/node/remoteTunnelService","vs/platform/storage/common/storageService","vs/platform/userDataProfile/common/userDataProfileIpc","vs/platform/userDataProfile/node/userDataProfileStorageService","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncResourceProvider","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/node/userDataAutoSyncService","vs/platform/workspaces/node/workspaces","vs/code/node/sharedProcess/contrib/storageDataCleaner","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/node/sharedProcess/contrib/extensions","vs/base/parts/ipc/node/ipc.net","vs/platform/remote/node/nodeSocketFactory","vs/platform/tunnel/node/tunnelService","util","minimist","assert","graceful-fs","https","yauzl","yazl","zlib","vs/code/node/sharedProcess/sharedProcessMain"],ae=function(ie){for(var e=[],A=0,N=ie.length;A<N;A++)e[A]=oe[ie[A]];return e};define(oe[61],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function A(T){return(k,I,v)=>{let R=null,b=null;if(typeof v.value=="function"?(R="value",b=v.value):typeof v.get=="function"&&(R="get",b=v.get),!b)throw new Error("not supported");v[R]=T(b,I)}}function N(T,k,I){let v=null,R=null;if(typeof I.value=="function"?(v="value",R=I.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof I.get=="function"&&(v="get",R=I.get),!R)throw new Error("not supported");const b=`$memoize$${k}`;I[v]=function(...m){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,m)}),this[b]}}e.memoize=N;function l(T,k,I){return A((v,R)=>{const b=`$debounce$${R}`,m=`$debounce$result$${R}`;return function(...g){this[m]||(this[m]=I?I():void 0),clearTimeout(this[b]),k&&(this[m]=k(this[m],...g),g=[this[m]]),this[b]=setTimeout(()=>{v.apply(this,g),this[m]=I?I():void 0},T)}})}e.debounce=l;function O(T,k,I){return A((v,R)=>{const b=`$throttle$timer$${R}`,m=`$throttle$result$${R}`,g=`$throttle$lastRun$${R}`,p=`$throttle$pending$${R}`;return function(...E){if(this[m]||(this[m]=I?I():void 0),(this[g]===null||this[g]===void 0)&&(this[g]=-Number.MAX_VALUE),k&&(this[m]=k(this[m],...E)),this[p])return;const a=this[g]+T;a<=Date.now()?(this[g]=Date.now(),v.apply(this,[this[m]]),this[m]=I?I():void 0):(this[p]=!0,this[b]=setTimeout(()=>{this[p]=!1,this[g]=Date.now(),v.apply(this,[this[m]]),this[m]=I?I():void 0},a-Date.now()))}})}e.throttle=O}),define(oe[9],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class A{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?S.isErrorNoTelemetry(r)?new S(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(t=>{t(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.ErrorHandler=A,e.errorHandler=new A;function N(n){e.errorHandler.setUnexpectedErrorHandler(n)}e.setUnexpectedErrorHandler=N;function l(n){if(!n||typeof n!="object")return!1;const r=n;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function O(n){v(n)||e.errorHandler.onUnexpectedError(n)}e.onUnexpectedError=O;function T(n){v(n)||e.errorHandler.onUnexpectedExternalError(n)}e.onUnexpectedExternalError=T;function k(n){if(n instanceof Error){const{name:r,message:t}=n,i=n.stacktrace||n.stack;return{$isError:!0,name:r,message:t,stack:i,noTelemetry:S.isErrorNoTelemetry(n)}}return n}e.transformErrorForSerialization=k;const I="Canceled";function v(n){return n instanceof R?!0:n instanceof Error&&n.name===I&&n.message===I}e.isCancellationError=v;class R extends Error{constructor(){super(I),this.name=this.message}}e.CancellationError=R;function b(){const n=new Error(I);return n.name=n.message,n}e.canceled=b;function m(n){return n?new Error(`Illegal argument: ${n}`):new Error("Illegal argument")}e.illegalArgument=m;function g(n){return n?new Error(`Illegal state: ${n}`):new Error("Illegal state")}e.illegalState=g;function p(n){return n?new Error(`readonly property '${n} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=p;function E(n){const r=new Error(`${n} has been disposed`);return r.name="DISPOSED",r}e.disposed=E;function a(n){return n?n.message?n.message:n.stack?n.stack.split(`
`)[0]:String(n):"Error"}e.getErrorMessage=a;class h extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=h;class u extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=u;class d extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=d;class S extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof S)return r;const t=new S;return t.message=r.message,t.stack=r.stack,t}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=S;class L extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,L.prototype);debugger}}e.BugIndicatingError=L}),define(oe[21],ae([0,1,9]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function N(V,Z=0){return V[V.length-(1+Z)]}e.tail=N;function l(V){if(V.length===0)throw new Error("Invalid tail call");return[V.slice(0,V.length-1),V[V.length-1]]}e.tail2=l;function O(V,Z,ee=(ce,ue)=>ce===ue){if(V===Z)return!0;if(!V||!Z||V.length!==Z.length)return!1;for(let ce=0,ue=V.length;ce<ue;ce++)if(!ee(V[ce],Z[ce]))return!1;return!0}e.equals=O;function T(V,Z){const ee=V.length-1;Z<ee&&(V[Z]=V[ee]),V.pop()}e.removeFastWithoutKeepingOrder=T;function k(V,Z,ee){return I(V.length,ce=>ee(V[ce],Z))}e.binarySearch=k;function I(V,Z){let ee=0,ce=V-1;for(;ee<=ce;){const ue=(ee+ce)/2|0,de=Z(ue);if(de<0)ee=ue+1;else if(de>0)ce=ue-1;else return ue}return-(ee+1)}e.binarySearch2=I;function v(V,Z){let ee=0,ce=V.length;if(ce===0)return 0;for(;ee<ce;){const ue=Math.floor((ee+ce)/2);Z(V[ue])?ce=ue:ee=ue+1}return ee}e.findFirstInSorted=v;function R(V,Z,ee){if(V=V|0,V>=Z.length)throw new TypeError("invalid index");const ce=Z[Math.floor(Z.length*Math.random())],ue=[],de=[],ye=[];for(const Se of Z){const Ee=ee(Se,ce);Ee<0?ue.push(Se):Ee>0?de.push(Se):ye.push(Se)}return V<ue.length?R(V,ue,ee):V<ue.length+ye.length?ye[0]:R(V-(ue.length+ye.length),de,ee)}e.quickSelect=R;function b(V,Z){const ee=[];let ce;for(const ue of V.slice(0).sort(Z))!ce||Z(ce[0],ue)!==0?(ce=[ue],ee.push(ce)):ce.push(ue);return ee}e.groupBy=b;function m(V,Z,ee){const ce=[];function ue(Se,Ee,Re){if(Ee===0&&Re.length===0)return;const ke=ce[ce.length-1];ke&&ke.start+ke.deleteCount===Se?(ke.deleteCount+=Ee,ke.toInsert.push(...Re)):ce.push({start:Se,deleteCount:Ee,toInsert:Re})}let de=0,ye=0;for(;;){if(de===V.length){ue(de,0,Z.slice(ye));break}if(ye===Z.length){ue(de,V.length-de,[]);break}const Se=V[de],Ee=Z[ye],Re=ee(Se,Ee);Re===0?(de+=1,ye+=1):Re<0?(ue(de,1,[]),de+=1):Re>0&&(ue(de,0,[Ee]),ye+=1)}return ce}e.sortedDiff=m;function g(V,Z,ee){const ce=m(V,Z,ee),ue=[],de=[];for(const ye of ce)ue.push(...V.slice(ye.start,ye.start+ye.deleteCount)),de.push(...ye.toInsert);return{removed:ue,added:de}}e.delta=g;function p(V,Z,ee){if(ee===0)return[];const ce=V.slice(0,ee).sort(Z);return a(V,Z,ce,ee,V.length),ce}e.top=p;function E(V,Z,ee,ce,ue){return ee===0?Promise.resolve([]):new Promise((de,ye)=>{(async()=>{const Se=V.length,Ee=V.slice(0,ee).sort(Z);for(let Re=ee,ke=Math.min(ee+ce,Se);Re<Se;Re=ke,ke=Math.min(ke+ce,Se)){if(Re>ee&&await new Promise(Be=>setTimeout(Be)),ue&&ue.isCancellationRequested)throw new A.CancellationError;a(V,Z,Ee,Re,ke)}return Ee})().then(de,ye)})}e.topAsync=E;function a(V,Z,ee,ce,ue){for(const de=ee.length;ce<ue;ce++){const ye=V[ce];if(Z(ye,ee[de-1])<0){ee.pop();const Se=v(ee,Ee=>Z(ye,Ee)<0);ee.splice(Se,0,ye)}}}function h(V){return V.filter(Z=>!!Z)}e.coalesce=h;function u(V){let Z=0;for(let ee=0;ee<V.length;ee++)V[ee]&&(V[Z]=V[ee],Z+=1);V.length=Z}e.coalesceInPlace=u;function d(V,Z,ee){V.splice(ee,0,V.splice(Z,1)[0])}e.move=d;function S(V){return!Array.isArray(V)||V.length===0}e.isFalsyOrEmpty=S;function L(V){return Array.isArray(V)&&V.length>0}e.isNonEmptyArray=L;function n(V,Z=ee=>ee){const ee=new Set;return V.filter(ce=>{const ue=Z(ce);return ee.has(ue)?!1:(ee.add(ue),!0)})}e.distinct=n;function r(V){const Z=new Set;return ee=>{const ce=V(ee);return Z.has(ce)?!1:(Z.add(ce),!0)}}e.uniqueFilter=r;function t(V,Z){const ee=i(V,Z);if(ee!==-1)return V[ee]}e.findLast=t;function i(V,Z){for(let ee=V.length-1;ee>=0;ee--){const ce=V[ee];if(Z(ce))return ee}return-1}e.lastIndex=i;function s(V,Z){return V.length>0?V[0]:Z}e.firstOrDefault=s;function o(V,Z){return V.length>0?V[V.length-1]:Z}e.lastOrDefault=o;function c(V,Z,ee=(ce,ue)=>ce===ue){let ce=0;for(let ue=0,de=Math.min(V.length,Z.length);ue<de&&ee(V[ue],Z[ue]);ue++)ce++;return ce}e.commonPrefixLength=c;function y(V){return[].concat(...V)}e.flatten=y;function w(V,Z){let ee=typeof Z=="number"?V:0;typeof Z=="number"?ee=V:(ee=0,Z=V);const ce=[];if(ee<=Z)for(let ue=ee;ue<Z;ue++)ce.push(ue);else for(let ue=ee;ue>Z;ue--)ce.push(ue);return ce}e.range=w;function f(V,Z,ee){return V.reduce((ce,ue)=>(ce[Z(ue)]=ee?ee(ue):ue,ce),Object.create(null))}e.index=f;function P(V,Z){return V.push(Z),()=>D(V,Z)}e.insert=P;function D(V,Z){const ee=V.indexOf(Z);if(ee>-1)return V.splice(ee,1),Z}e.remove=D;function M(V,Z,ee){const ce=V.slice(0,Z),ue=V.slice(Z);return ce.concat(ee,ue)}e.arrayInsert=M;function j(V,Z){let ee;if(typeof Z=="number"){let ce=Z;ee=()=>{const ue=Math.sin(ce++)*179426549;return ue-Math.floor(ue)}}else ee=Math.random;for(let ce=V.length-1;ce>0;ce-=1){const ue=Math.floor(ee()*(ce+1)),de=V[ce];V[ce]=V[ue],V[ue]=de}}e.shuffle=j;function B(V,Z){const ee=V.indexOf(Z);ee>-1&&(V.splice(ee,1),V.unshift(Z))}e.pushToStart=B;function W(V,Z){const ee=V.indexOf(Z);ee>-1&&(V.splice(ee,1),V.push(Z))}e.pushToEnd=W;function H(V,Z){for(const ee of Z)V.push(ee)}e.pushMany=H;function Q(V,Z){return Array.isArray(V)?V.map(Z):Z(V)}e.mapArrayOrNot=Q;function _(V){return Array.isArray(V)?V:[V]}e.asArray=_;function Y(V){return V[Math.floor(Math.random()*V.length)]}e.getRandomElement=Y;function $(V,Z){for(const ee of V){const ce=Z(ee);if(ce!==void 0)return ce}}e.mapFind=$;function z(V,Z,ee){const ce=te(V,Z),ue=V.length,de=ee.length;V.length=ue+de;for(let ye=ue-1;ye>=ce;ye--)V[ye+de]=V[ye];for(let ye=0;ye<de;ye++)V[ye+ce]=ee[ye]}e.insertInto=z;function x(V,Z,ee,ce){const ue=te(V,Z),de=V.splice(ue,ee);return z(V,ue,ce),de}e.splice=x;function te(V,Z){return Z<0?Math.max(Z+V.length,0):Math.min(Z,V.length)}var ne;(function(V){function Z(ue){return ue<0}V.isLessThan=Z;function ee(ue){return ue>0}V.isGreaterThan=ee;function ce(ue){return ue===0}V.isNeitherLessOrGreaterThan=ce,V.greaterThan=1,V.lessThan=-1,V.neitherLessOrGreaterThan=0})(ne||(e.CompareResult=ne={}));function re(V,Z){return(ee,ce)=>Z(V(ee),V(ce))}e.compareBy=re;function X(...V){return(Z,ee)=>{for(const ce of V){const ue=ce(Z,ee);if(!ne.isNeitherLessOrGreaterThan(ue))return ue}return ne.neitherLessOrGreaterThan}}e.tieBreakComparators=X;const K=(V,Z)=>V-Z;e.numberComparator=K;function F(V,Z){if(V.length===0)return;let ee=V[0];for(let ce=1;ce<V.length;ce++){const ue=V[ce];Z(ue,ee)>0&&(ee=ue)}return ee}e.findMaxBy=F;function C(V,Z){if(V.length===0)return;let ee=V[0];for(let ce=1;ce<V.length;ce++){const ue=V[ce];Z(ue,ee)>=0&&(ee=ue)}return ee}e.findLastMaxBy=C;function U(V,Z){return F(V,(ee,ce)=>-Z(ee,ce))}e.findMinBy=U;class q{constructor(Z){this.f=Z,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(Z){let ee=this.c;for(;ee<this.f.length&&Z(this.f[ee]);)ee++;const ce=ee===this.c?null:this.f.slice(this.c,ee);return this.c=ee,ce}takeFromEndWhile(Z){let ee=this.d;for(;ee>=0&&Z(this.f[ee]);)ee--;const ce=ee===this.d?null:this.f.slice(ee+1,this.d+1);return this.d=ee,ce}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const Z=this.f[this.c];return this.c++,Z}removeLast(){const Z=this.f[this.d];return this.d--,Z}takeCount(Z){const ee=this.f.slice(this.c,this.c+Z);return this.c+=Z,ee}}e.ArrayQueue=q;class G{constructor(Z){this.iterate=Z}forEach(Z){this.iterate(ee=>(Z(ee),!0))}toArray(){const Z=[];return this.iterate(ee=>(Z.push(ee),!0)),Z}filter(Z){return new G(ee=>this.iterate(ce=>Z(ce)?ee(ce):!0))}map(Z){return new G(ee=>this.iterate(ce=>ee(Z(ce))))}some(Z){let ee=!1;return this.iterate(ce=>(ee=Z(ce),!ee)),ee}findFirst(Z){let ee;return this.iterate(ce=>Z(ce)?(ee=ce,!1):!0),ee}findLast(Z){let ee;return this.iterate(ce=>(Z(ce)&&(ee=ce),!0)),ee}findLastMaxBy(Z){let ee,ce=!0;return this.iterate(ue=>((ce||ne.isGreaterThan(Z(ue,ee)))&&(ce=!1,ee=ue),!0)),ee}}e.CallbackIterable=G,G.empty=new G(V=>{})}),define(oe[127],ae([0,1,9]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function N(I,v){if(!I)throw new Error(v?`Assertion failed (${v})`:"Assertion Failed")}e.ok=N;function l(I,v="Unreachable"){throw new Error(v)}e.assertNever=l;function O(I){if(!I)throw new A.BugIndicatingError("Assertion Failed")}e.assert=O;function T(I){if(!I()){debugger;I(),(0,A.onUnexpectedError)(new A.BugIndicatingError("Assertion Failed"))}}e.assertFn=T;function k(I,v){let R=0;for(;R<I.length-1;){const b=I[R],m=I[R+1];if(!v(b,m))return!1;R++}return!0}e.checkAdjacentItems=k}),define(oe[84],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function A(N){const l=this;let O=!1,T;return function(){return O||(O=!0,T=N.apply(l,arguments)),T}}e.once=A}),define(oe[62],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var A;(function(N){function l(S){return S&&typeof S=="object"&&typeof S[Symbol.iterator]=="function"}N.is=l;const O=Object.freeze([]);function T(){return O}N.empty=T;function*k(S){yield S}N.single=k;function I(S){return l(S)?S:k(S)}N.wrap=I;function v(S){return S||O}N.from=v;function R(S){return!S||S[Symbol.iterator]().next().done===!0}N.isEmpty=R;function b(S){return S[Symbol.iterator]().next().value}N.first=b;function m(S,L){for(const n of S)if(L(n))return!0;return!1}N.some=m;function g(S,L){for(const n of S)if(L(n))return n}N.find=g;function*p(S,L){for(const n of S)L(n)&&(yield n)}N.filter=p;function*E(S,L){let n=0;for(const r of S)yield L(r,n++)}N.map=E;function*a(...S){for(const L of S)for(const n of L)yield n}N.concat=a;function h(S,L,n){let r=n;for(const t of S)r=L(r,t);return r}N.reduce=h;function*u(S,L,n=S.length){for(L<0&&(L+=S.length),n<0?n+=S.length:n>S.length&&(n=S.length);L<n;L++)yield S[L]}N.slice=u;function d(S,L=Number.POSITIVE_INFINITY){const n=[];if(L===0)return[n,S];const r=S[Symbol.iterator]();for(let t=0;t<L;t++){const i=r.next();if(i.done)return[n,N.empty()];n.push(i.value)}return[n,{[Symbol.iterator](){return r}}]}N.consume=d})(A||(e.Iterable=A={}))}),define(oe[35],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var A;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(A||(e.ScanError=A={}));var N;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var l;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(l||(e.ParseErrorCode=l={}));var O;(function(n){n.DEFAULT={allowTrailingComma:!0}})(O||(e.ParseOptions=O={}));function T(n,r=!1){let t=0;const i=n.length;let s="",o=0,c=16,y=0;function w(W){let H=0,Q=0;for(;H<W;){const _=n.charCodeAt(t);if(_>=48&&_<=57)Q=Q*16+_-48;else if(_>=65&&_<=70)Q=Q*16+_-65+10;else if(_>=97&&_<=102)Q=Q*16+_-97+10;else break;t++,H++}return H<W&&(Q=-1),Q}function f(W){t=W,s="",o=0,c=16,y=0}function P(){const W=t;if(n.charCodeAt(t)===48)t++;else for(t++;t<n.length&&v(n.charCodeAt(t));)t++;if(t<n.length&&n.charCodeAt(t)===46)if(t++,t<n.length&&v(n.charCodeAt(t)))for(t++;t<n.length&&v(n.charCodeAt(t));)t++;else return y=3,n.substring(W,t);let H=t;if(t<n.length&&(n.charCodeAt(t)===69||n.charCodeAt(t)===101))if(t++,(t<n.length&&n.charCodeAt(t)===43||n.charCodeAt(t)===45)&&t++,t<n.length&&v(n.charCodeAt(t))){for(t++;t<n.length&&v(n.charCodeAt(t));)t++;H=t}else y=3;return n.substring(W,H)}function D(){let W="",H=t;for(;;){if(t>=i){W+=n.substring(H,t),y=2;break}const Q=n.charCodeAt(t);if(Q===34){W+=n.substring(H,t),t++;break}if(Q===92){if(W+=n.substring(H,t),t++,t>=i){y=2;break}switch(n.charCodeAt(t++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const Y=w(4);Y>=0?W+=String.fromCharCode(Y):y=4;break}default:y=5}H=t;continue}if(Q>=0&&Q<=31)if(I(Q)){W+=n.substring(H,t),y=2;break}else y=6;t++}return W}function M(){if(s="",y=0,o=t,t>=i)return o=i,c=17;let W=n.charCodeAt(t);if(k(W)){do t++,s+=String.fromCharCode(W),W=n.charCodeAt(t);while(k(W));return c=15}if(I(W))return t++,s+=String.fromCharCode(W),W===13&&n.charCodeAt(t)===10&&(t++,s+=`
`),c=14;switch(W){case 123:return t++,c=1;case 125:return t++,c=2;case 91:return t++,c=3;case 93:return t++,c=4;case 58:return t++,c=6;case 44:return t++,c=5;case 34:return t++,s=D(),c=10;case 47:{const H=t-1;if(n.charCodeAt(t+1)===47){for(t+=2;t<i&&!I(n.charCodeAt(t));)t++;return s=n.substring(H,t),c=12}if(n.charCodeAt(t+1)===42){t+=2;const Q=i-1;let _=!1;for(;t<Q;){if(n.charCodeAt(t)===42&&n.charCodeAt(t+1)===47){t+=2,_=!0;break}t++}return _||(t++,y=1),s=n.substring(H,t),c=13}return s+=String.fromCharCode(W),t++,c=16}case 45:if(s+=String.fromCharCode(W),t++,t===i||!v(n.charCodeAt(t)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=P(),c=11;default:for(;t<i&&j(W);)t++,W=n.charCodeAt(t);if(o!==t){switch(s=n.substring(o,t),s){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return s+=String.fromCharCode(W),t++,c=16}}function j(W){if(k(W)||I(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function B(){let W;do W=M();while(W>=12&&W<=15);return W}return{setPosition:f,getPosition:()=>t,scan:r?B:M,getToken:()=>c,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>t-o,getTokenError:()=>y}}e.createScanner=T;function k(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function I(n){return n===10||n===13||n===8232||n===8233}function v(n){return n>=48&&n<=57}var R;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(R||(R={}));function b(n,r){const t=[],i=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function y(w,f,P,D){o.value=w,o.offset=f,o.length=P,o.type=D,o.colonOffset=void 0,s=o}try{d(n,{onObjectBegin:(w,f)=>{if(r<=w)throw i;s=void 0,c=r>w,t.push("")},onObjectProperty:(w,f,P)=>{if(r<f||(y(w,f,P,"property"),t[t.length-1]=w,r<=f+P))throw i},onObjectEnd:(w,f)=>{if(r<=w)throw i;s=void 0,t.pop()},onArrayBegin:(w,f)=>{if(r<=w)throw i;s=void 0,t.push(0)},onArrayEnd:(w,f)=>{if(r<=w)throw i;s=void 0,t.pop()},onLiteralValue:(w,f,P)=>{if(r<f||(y(w,f,P,L(w)),r<=f+P))throw i},onSeparator:(w,f,P)=>{if(r<=f)throw i;if(w===":"&&s&&s.type==="property")s.colonOffset=f,c=!1,s=void 0;else if(w===","){const D=t[t.length-1];typeof D=="number"?t[t.length-1]=D+1:(c=!0,t[t.length-1]=""),s=void 0}}})}catch(w){if(w!==i)throw w}return{path:t,previousNode:s,isAtPropertyKey:c,matches:w=>{let f=0;for(let P=0;f<w.length&&P<t.length;P++)if(w[f]===t[P]||w[f]==="*")f++;else if(w[f]!=="**")return!1;return f===w.length}}}e.getLocation=b;function m(n,r=[],t=O.DEFAULT){let i=null,s=[];const o=[];function c(w){Array.isArray(s)?s.push(w):i!==null&&(s[i]=w)}return d(n,{onObjectBegin:()=>{const w={};c(w),o.push(s),s=w,i=null},onObjectProperty:w=>{i=w},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const w=[];c(w),o.push(s),s=w,i=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:c,onError:(w,f,P)=>{r.push({error:w,offset:f,length:P})}},t),s[0]}e.parse=m;function g(n,r=[],t=O.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(w){i.type==="property"&&(i.length=w-i.offset,i=i.parent)}function o(w){return i.children.push(w),w}d(n,{onObjectBegin:w=>{i=o({type:"object",offset:w,length:-1,parent:i,children:[]})},onObjectProperty:(w,f,P)=>{i=o({type:"property",offset:f,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:w,offset:f,length:P,parent:i})},onObjectEnd:(w,f)=>{i.length=w+f-i.offset,i=i.parent,s(w+f)},onArrayBegin:(w,f)=>{i=o({type:"array",offset:w,length:-1,parent:i,children:[]})},onArrayEnd:(w,f)=>{i.length=w+f-i.offset,i=i.parent,s(w+f)},onLiteralValue:(w,f,P)=>{o({type:L(w),offset:f,length:P,parent:i,value:w}),s(f+P)},onSeparator:(w,f,P)=>{i.type==="property"&&(w===":"?i.colonOffset=f:w===","&&s(f))},onError:(w,f,P)=>{r.push({error:w,offset:f,length:P})}},t);const y=i.children[0];return y&&delete y.parent,y}e.parseTree=g;function p(n,r){if(!n)return;let t=n;for(const i of r)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let s=!1;for(const o of t.children)if(Array.isArray(o.children)&&o.children[0].value===i){t=o.children[1],s=!0;break}if(!s)return}else{const s=i;if(t.type!=="array"||s<0||!Array.isArray(t.children)||s>=t.children.length)return;t=t.children[s]}return t}e.findNodeAtLocation=p;function E(n){if(!n.parent||!n.parent.children)return[];const r=E(n.parent);if(n.parent.type==="property"){const t=n.parent.children[0].value;r.push(t)}else if(n.parent.type==="array"){const t=n.parent.children.indexOf(n);t!==-1&&r.push(t)}return r}e.getNodePath=E;function a(n){switch(n.type){case"array":return n.children.map(a);case"object":{const r=Object.create(null);for(const t of n.children){const i=t.children[1];i&&(r[t.children[0].value]=a(i))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=a;function h(n,r,t=!1){return r>=n.offset&&r<n.offset+n.length||t&&r===n.offset+n.length}e.contains=h;function u(n,r,t=!1){if(h(n,r,t)){const i=n.children;if(Array.isArray(i))for(let s=0;s<i.length&&i[s].offset<=r;s++){const o=u(i[s],r,t);if(o)return o}return n}}e.findNodeAtOffset=u;function d(n,r,t=O.DEFAULT){const i=T(n,!1);function s(re){return re?()=>re(i.getTokenOffset(),i.getTokenLength()):()=>!0}function o(re){return re?X=>re(X,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=s(r.onObjectBegin),y=o(r.onObjectProperty),w=s(r.onObjectEnd),f=s(r.onArrayBegin),P=s(r.onArrayEnd),D=o(r.onLiteralValue),M=o(r.onSeparator),j=s(r.onComment),B=o(r.onError),W=t&&t.disallowComments,H=t&&t.allowTrailingComma;function Q(){for(;;){const re=i.scan();switch(i.getTokenError()){case 4:_(14);break;case 5:_(15);break;case 3:_(13);break;case 1:W||_(11);break;case 2:_(12);break;case 6:_(16);break}switch(re){case 12:case 13:W?_(10):j();break;case 16:_(1);break;case 15:case 14:break;default:return re}}}function _(re,X=[],K=[]){if(B(re),X.length+K.length>0){let F=i.getToken();for(;F!==17;){if(X.indexOf(F)!==-1){Q();break}else if(K.indexOf(F)!==-1)break;F=Q()}}}function Y(re){const X=i.getTokenValue();return re?D(X):y(X),Q(),!0}function $(){switch(i.getToken()){case 11:{let re=0;try{re=JSON.parse(i.getTokenValue()),typeof re!="number"&&(_(2),re=0)}catch{_(2)}D(re);break}case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return Q(),!0}function z(){return i.getToken()!==10?(_(3,[],[2,5]),!1):(Y(!1),i.getToken()===6?(M(":"),Q(),ne()||_(4,[],[2,5])):_(5,[],[2,5]),!0)}function x(){c(),Q();let re=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(re||_(4,[],[]),M(","),Q(),i.getToken()===2&&H)break}else re&&_(6,[],[]);z()||_(4,[],[2,5]),re=!0}return w(),i.getToken()!==2?_(7,[2],[]):Q(),!0}function te(){f(),Q();let re=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(re||_(4,[],[]),M(","),Q(),i.getToken()===4&&H)break}else re&&_(6,[],[]);ne()||_(4,[],[4,5]),re=!0}return P(),i.getToken()!==4?_(8,[4],[]):Q(),!0}function ne(){switch(i.getToken()){case 3:return te();case 1:return x();case 10:return Y(!0);default:return $()}}return Q(),i.getToken()===17?t.allowEmptyContent?!0:(_(4,[],[]),!1):ne()?(i.getToken()!==17&&_(9,[],[]),!0):(_(4,[],[]),!1)}e.visit=d;function S(n,r){const t=T(n),i=[];let s,o=0,c;do switch(c=t.getPosition(),s=t.scan(),s){case 12:case 13:case 17:o!==c&&i.push(n.substring(o,c)),r!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,r)),o=t.getPosition();break}while(s!==17);return i.join("")}e.stripComments=S;function L(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=L}),define(oe[42],ae([0,1,35]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function N(v,R,b){let m,g,p,E,a;if(R){for(E=R.offset,a=E+R.length,p=E;p>0&&!I(v,p-1);)p--;let c=a;for(;c<v.length&&!I(v,c);)c++;g=v.substring(p,c),m=T(g,b)}else g=v,m=0,p=0,E=0,a=v.length;const h=k(b,v);let u=!1,d=0,S;b.insertSpaces?S=O(" ",b.tabSize||4):S="	";const L=(0,A.createScanner)(g,!1);let n=!1;function r(){return h+O(S,m+d)}function t(){let c=L.scan();for(u=!1;c===15||c===14;)u=u||c===14,c=L.scan();return n=c===16||L.getTokenError()!==0,c}const i=[];function s(c,y,w){!n&&y<a&&w>E&&v.substring(y,w)!==c&&i.push({offset:y,length:w-y,content:c})}let o=t();if(o!==17){const c=L.getTokenOffset()+p,y=O(S,m);s(y,p,c)}for(;o!==17;){let c=L.getTokenOffset()+L.getTokenLength()+p,y=t(),w="";for(;!u&&(y===12||y===13);){const P=L.getTokenOffset()+p;s(" ",c,P),c=L.getTokenOffset()+L.getTokenLength()+p,w=y===12?r():"",y=t()}if(y===2)o!==1&&(d--,w=r());else if(y===4)o!==3&&(d--,w=r());else{switch(o){case 3:case 1:d++,w=r();break;case 5:case 12:w=r();break;case 13:u?w=r():w=" ";break;case 6:w=" ";break;case 10:if(y===6){w="";break}case 7:case 8:case 9:case 11:case 2:case 4:y===12||y===13?w=" ":y!==5&&y!==17&&(n=!0);break;case 16:n=!0;break}u&&(y===12||y===13)&&(w=r())}const f=L.getTokenOffset()+p;s(w,c,f),o=y}return i}e.format=N;function l(v,R){const b=JSON.stringify(v,void 0,R.insertSpaces?R.tabSize||4:"	");return R.eol!==void 0?b.replace(/\r\n|\r|\n/g,R.eol):b}e.toFormattedString=l;function O(v,R){let b="";for(let m=0;m<R;m++)b+=v;return b}function T(v,R){let b=0,m=0;const g=R.tabSize||4;for(;b<v.length;){const p=v.charAt(b);if(p===" ")m++;else if(p==="	")m+=g;else break;b++}return Math.floor(m/g)}function k(v,R){for(let b=0;b<R.length;b++){const m=R.charAt(b);if(m==="\r")return b+1<R.length&&R.charAt(b+1)===`
`?`\r
`:"\r";if(m===`
`)return`
`}return v&&v.eol||`
`}e.getEOL=k;function I(v,R){return`\r
`.indexOf(v.charAt(R))!==-1}e.isEOL=I}),define(oe[85],ae([0,1,35,42]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function l(v,R,b){return O(v,R,void 0,b)}e.removeProperty=l;function O(v,R,b,m,g){const p=R.slice(),E=[],a=(0,A.parseTree)(v,E);let h,u;for(;p.length>0&&(u=p.pop(),h=(0,A.findNodeAtLocation)(a,p),h===void 0&&b!==void 0);)typeof u=="string"?b={[u]:b}:b=[b];if(h)if(h.type==="object"&&typeof u=="string"&&Array.isArray(h.children)){const d=(0,A.findNodeAtLocation)(h,[u]);if(d!==void 0)if(b===void 0){if(!d.parent)throw new Error("Malformed AST");const S=h.children.indexOf(d.parent);let L,n=d.parent.offset+d.parent.length;if(S>0){const r=h.children[S-1];L=r.offset+r.length}else L=h.offset+1,h.children.length>1&&(n=h.children[1].offset);return T(v,{offset:L,length:n-L,content:""},m)}else return T(v,{offset:d.offset,length:d.length,content:JSON.stringify(b)},m);else{if(b===void 0)return[];const S=`${JSON.stringify(u)}: ${JSON.stringify(b)}`,L=g?g(h.children.map(r=>r.children[0].value)):h.children.length;let n;if(L>0){const r=h.children[L-1];n={offset:r.offset+r.length,length:0,content:","+S}}else h.children.length===0?n={offset:h.offset+1,length:0,content:S}:n={offset:h.offset+1,length:0,content:S+","};return T(v,n,m)}}else if(h.type==="array"&&typeof u=="number"&&Array.isArray(h.children))if(b!==void 0){const d=`${JSON.stringify(b)}`;let S;if(h.children.length===0||u===0)S={offset:h.offset+1,length:0,content:h.children.length===0?d:d+","};else{const L=u===-1||u>h.children.length?h.children.length:u,n=h.children[L-1];S={offset:n.offset+n.length,length:0,content:","+d}}return T(v,S,m)}else{const d=u,S=h.children[d];let L;if(h.children.length===1)L={offset:h.offset+1,length:h.length-2,content:""};else if(h.children.length-1===d){const n=h.children[d-1],r=n.offset+n.length,t=h.offset+h.length;L={offset:r,length:t-2-r,content:""}}else L={offset:S.offset,length:h.children[d+1].offset-S.offset,content:""};return T(v,L,m)}else throw new Error(`Can not add ${typeof u!="number"?"index":"property"} to parent of type ${h.type}`);else{if(b===void 0)throw new Error("Can not delete in empty document");return T(v,{offset:a?a.offset:0,length:a?a.length:0,content:JSON.stringify(b)},m)}}e.setProperty=O;function T(v,R,b){let m=k(v,R),g=R.offset,p=R.offset+R.content.length;if(R.length===0||R.content.length===0){for(;g>0&&!(0,N.isEOL)(m,g-1);)g--;for(;p<m.length&&!(0,N.isEOL)(m,p);)p++}const E=(0,N.format)(m,{offset:g,length:p-g},b);for(let h=E.length-1;h>=0;h--){const u=E[h];m=k(m,u),g=Math.min(g,u.offset),p=Math.max(p,u.offset+u.length),p+=u.content.length-u.length}const a=v.length-(m.length-p)-g;return[{offset:g,length:a,content:m.substring(g,p)}]}e.withFormatting=T;function k(v,R){return v.substring(0,R.offset)+R.content+v.substring(R.offset+R.length)}e.applyEdit=k;function I(v,R){const b=R.slice(0).sort((g,p)=>{const E=g.offset-p.offset;return E===0?g.length-p.length:E});let m=v.length;for(let g=b.length-1;g>=0;g--){const p=b[g];if(p.offset+p.length<=m)v=k(v,p);else throw new Error("Overlapping edit");m=p.offset}return v}e.applyEdits=I}),define(oe[128],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class A{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=A}),define(oe[2],ae([0,1,84,62]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let O=null;function T(o){O=o}if(e.setDisposableTracker=T,l){const o="__is_disposable_tracked__";T(new class{trackDisposable(c){const y=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[o]||console.log(y)},3e3)}setParent(c,y){if(c&&c!==u.None)try{c[o]=!0}catch{}}markAsDisposed(c){if(c&&c!==u.None)try{c[o]=!0}catch{}}markAsSingleton(c){}})}function k(o){return O?.trackDisposable(o),o}function I(o){O?.markAsDisposed(o)}function v(o,c){O?.setParent(o,c)}function R(o,c){if(O)for(const y of o)O.setParent(y,c)}function b(o){return O?.markAsSingleton(o),o}e.markAsSingleton=b;function m(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=m;function g(o){if(N.Iterable.is(o)){const c=[];for(const y of o)if(y)try{y.dispose()}catch(w){c.push(w)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=g;function p(o){for(const c of o)m(c)&&c.dispose();return[]}e.disposeIfDisposable=p;function E(...o){const c=a(()=>g(o));return R(o,c),c}e.combinedDisposable=E;function a(o){const c=k({dispose:(0,A.once)(()=>{I(c),o()})});return c}e.toDisposable=a;class h{constructor(){this.f=new Set,this.g=!1,k(this)}dispose(){this.g||(I(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{g(this.f)}finally{this.f.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return v(c,this),this.g?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(c),c}}e.DisposableStore=h,h.DISABLE_DISPOSED_WARNING=!1;class u{constructor(){this.q=new h,k(this),v(this.q,this)}dispose(){I(this),this.q.dispose()}B(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(c)}}e.Disposable=u,u.None=Object.freeze({dispose(){}});class d{constructor(){this.b=!1,k(this)}get value(){return this.b?void 0:this.a}set value(c){this.b||c===this.a||(this.a?.dispose(),c&&v(c,this),this.a=c)}clear(){this.value=void 0}dispose(){this.b=!0,I(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const c=this.a;return this.a=void 0,c&&v(c,null),c}}e.MutableDisposable=d;class S{constructor(c){this.b=c,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=S;class L{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,k(this)}set(c){let y=c;return this.unset=()=>y=void 0,this.isset=()=>y!==void 0,this.dispose=()=>{y&&(y(),y=void 0,I(this))},this}}e.SafeDisposable=L;class n{constructor(){this.a=new Map}acquire(c,...y){let w=this.a.get(c);w||(w={counter:0,object:this.b(c,...y)},this.a.set(c,w));const{object:f}=w,P=(0,A.once)(()=>{--w.counter===0&&(this.c(c,w.object),this.a.delete(c))});return w.counter++,{object:f,dispose:P}}}e.ReferenceCollection=n;class r{constructor(c){this.a=c}async acquire(c,...y){const w=this.a.acquire(c,...y);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(f){throw w.dispose(),f}}}e.AsyncReferenceCollection=r;class t{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=t;function i(o){const c=new h;try{o(c)}finally{c.dispose()}}e.disposeOnReturn=i;class s{constructor(){this.a=new Map,this.b=!1,k(this)}dispose(){I(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{g(this.a.values())}finally{this.a.clear()}}has(c){return this.a.has(c)}get(c){return this.a.get(c)}set(c,y,w=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),w||this.a.get(c)?.dispose(),this.a.set(c,y)}deleteAndDispose(c){this.a.get(c)?.dispose(),this.a.delete(c)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=s}),define(oe[86],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class A{constructor(O){this.element=O,this.next=A.Undefined,this.prev=A.Undefined}}A.Undefined=new A(void 0);class N{constructor(){this.a=A.Undefined,this.b=A.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===A.Undefined}clear(){let O=this.a;for(;O!==A.Undefined;){const T=O.next;O.prev=A.Undefined,O.next=A.Undefined,O=T}this.a=A.Undefined,this.b=A.Undefined,this.c=0}unshift(O){return this.d(O,!1)}push(O){return this.d(O,!0)}d(O,T){const k=new A(O);if(this.a===A.Undefined)this.a=k,this.b=k;else if(T){const v=this.b;this.b=k,k.prev=v,v.next=k}else{const v=this.a;this.a=k,k.next=v,v.prev=k}this.c+=1;let I=!1;return()=>{I||(I=!0,this.e(k))}}shift(){if(this.a!==A.Undefined){const O=this.a.element;return this.e(this.a),O}}pop(){if(this.b!==A.Undefined){const O=this.b.element;return this.e(this.b),O}}e(O){if(O.prev!==A.Undefined&&O.next!==A.Undefined){const T=O.prev;T.next=O.next,O.next.prev=T}else O.prev===A.Undefined&&O.next===A.Undefined?(this.a=A.Undefined,this.b=A.Undefined):O.next===A.Undefined?(this.b=this.b.prev,this.b.next=A.Undefined):O.prev===A.Undefined&&(this.a=this.a.next,this.a.prev=A.Undefined);this.c-=1}*[Symbol.iterator](){let O=this.a;for(;O!==A.Undefined;)yield O.element,O=O.next}}e.LinkedList=N}),define(oe[37],ae([0,1]),function(ie,e){"use strict";var A,N,l;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function O(E,a,h){let u=E.get(a);return u===void 0&&(u=h,E.set(a,u)),u}e.getOrSet=O;function T(E){const a=[];return E.forEach((h,u)=>{a.push(`${u} => ${h}`)}),`Map(${E.size}) {${a.join(", ")}}`}e.mapToString=T;function k(E){const a=[];return E.forEach(h=>{a.push(h)}),`Set(${E.size}) {${a.join(", ")}}`}e.setToString=k;class I{constructor(a,h){this.uri=a,this.value=h}}class v{constructor(a,h){this[A]="ResourceMap",a instanceof v?(this.b=new Map(a.b),this.c=h??v.a):(this.b=new Map,this.c=a??v.a)}set(a,h){return this.b.set(this.c(a),new I(a,h)),this}get(a){return this.b.get(this.c(a))?.value}has(a){return this.b.has(this.c(a))}get size(){return this.b.size}clear(){this.b.clear()}delete(a){return this.b.delete(this.c(a))}forEach(a,h){typeof h<"u"&&(a=a.bind(h));for(const[u,d]of this.b)a(d.value,d.uri,this)}*values(){for(const a of this.b.values())yield a.value}*keys(){for(const a of this.b.values())yield a.uri}*entries(){for(const a of this.b.values())yield[a.uri,a.value]}*[(A=Symbol.toStringTag,Symbol.iterator)](){for(const[,a]of this.b)yield[a.uri,a.value]}}e.ResourceMap=v,v.a=E=>E.toString();class R{constructor(a,h){this[N]="ResourceSet",!a||typeof a=="function"?this.a=new v(a):(this.a=new v(h),a.forEach(this.add,this))}get size(){return this.a.size}add(a){return this.a.set(a,a),this}clear(){this.a.clear()}delete(a){return this.a.delete(a)}forEach(a,h){this.a.forEach((u,d)=>a.call(h,d,d,this))}has(a){return this.a.has(a)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(N=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=R;var b;(function(E){E[E.None=0]="None",E[E.AsOld=1]="AsOld",E[E.AsNew=2]="AsNew"})(b||(e.Touch=b={}));class m{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(a){return this.a.has(a)}get(a,h=0){const u=this.a.get(a);if(u)return h!==0&&this.j(u,h),u.value}set(a,h,u=0){let d=this.a.get(a);if(d)d.value=h,u!==0&&this.j(d,u);else{switch(d={key:a,value:h,next:void 0,previous:void 0},u){case 0:this.h(d);break;case 1:this.g(d);break;case 2:this.h(d);break;default:this.h(d);break}this.a.set(a,d),this.d++}return this}delete(a){return!!this.remove(a)}remove(a){const h=this.a.get(a);if(h)return this.a.delete(a),this.i(h),this.d--,h.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const a=this.b;return this.a.delete(a.key),this.i(a),this.d--,a.value}forEach(a,h){const u=this.e;let d=this.b;for(;d;){if(h?a.bind(h)(d.value,d.key,this):a(d.value,d.key,this),this.e!==u)throw new Error("LinkedMap got modified during iteration.");d=d.next}}keys(){const a=this,h=this.e;let u=this.b;const d={[Symbol.iterator](){return d},next(){if(a.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const S={value:u.key,done:!1};return u=u.next,S}else return{value:void 0,done:!0}}};return d}values(){const a=this,h=this.e;let u=this.b;const d={[Symbol.iterator](){return d},next(){if(a.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const S={value:u.value,done:!1};return u=u.next,S}else return{value:void 0,done:!0}}};return d}entries(){const a=this,h=this.e;let u=this.b;const d={[Symbol.iterator](){return d},next(){if(a.e!==h)throw new Error("LinkedMap got modified during iteration.");if(u){const S={value:[u.key,u.value],done:!1};return u=u.next,S}else return{value:void 0,done:!0}}};return d}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(a){if(a>=this.size)return;if(a===0){this.clear();return}let h=this.b,u=this.size;for(;h&&u>a;)this.a.delete(h.key),h=h.next,u--;this.b=h,this.d=u,h&&(h.previous=void 0),this.e++}g(a){if(!this.b&&!this.c)this.c=a;else if(this.b)a.next=this.b,this.b.previous=a;else throw new Error("Invalid list");this.b=a,this.e++}h(a){if(!this.b&&!this.c)this.b=a;else if(this.c)a.previous=this.c,this.c.next=a;else throw new Error("Invalid list");this.c=a,this.e++}i(a){if(a===this.b&&a===this.c)this.b=void 0,this.c=void 0;else if(a===this.b){if(!a.next)throw new Error("Invalid list");a.next.previous=void 0,this.b=a.next}else if(a===this.c){if(!a.previous)throw new Error("Invalid list");a.previous.next=void 0,this.c=a.previous}else{const h=a.next,u=a.previous;if(!h||!u)throw new Error("Invalid list");h.previous=u,u.next=h}a.next=void 0,a.previous=void 0,this.e++}j(a,h){if(!this.b||!this.c)throw new Error("Invalid list");if(!(h!==1&&h!==2)){if(h===1){if(a===this.b)return;const u=a.next,d=a.previous;a===this.c?(d.next=void 0,this.c=d):(u.previous=d,d.next=u),a.previous=void 0,a.next=this.b,this.b.previous=a,this.b=a,this.e++}else if(h===2){if(a===this.c)return;const u=a.next,d=a.previous;a===this.b?(u.previous=void 0,this.b=u):(u.previous=d,d.next=u),a.next=void 0,a.previous=this.c,this.c.next=a,this.c=a,this.e++}}}toJSON(){const a=[];return this.forEach((h,u)=>{a.push([u,h])}),a}fromJSON(a){this.clear();for(const[h,u]of a)this.set(h,u)}}e.LinkedMap=m;class g extends m{constructor(a,h=1){super(),this.k=a,this.l=Math.min(Math.max(0,h),1)}get limit(){return this.k}set limit(a){this.k=a,this.m()}get ratio(){return this.l}set ratio(a){this.l=Math.min(Math.max(0,a),1),this.m()}get(a,h=2){return super.get(a,h)}peek(a){return super.get(a,0)}set(a,h){return super.set(a,h,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=g;class p{constructor(){this.a=new Map}add(a){return this.a.set(a,(this.a.get(a)||0)+1),this}delete(a){let h=this.a.get(a)||0;return h===0?!1:(h--,h===0?this.a.delete(a):this.a.set(a,h),!0)}has(a){return this.a.has(a)}}e.CounterSet=p}),define(oe[87],ae([0,1,37]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const N=new A.LRUCache(1e4);function l(v){return I(v,"NFC",N)}e.normalizeNFC=l;const O=new A.LRUCache(1e4);function T(v){return I(v,"NFD",O)}e.normalizeNFD=T;const k=/[^\u0000-\u0080]/;function I(v,R,b){if(!v)return v;const m=b.get(v);if(m)return m;let g;return k.test(v)?g=v.normalize(R):g=v,b.set(v,g),g}e.removeAccents=function(){const v=/[\u0300-\u036f]/g;return function(R){return T(R).replace(v,"")}}()}),define(oe[129],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function A(k,I,v){return Math.min(Math.max(k,I),v)}e.clamp=A;function N(k,I){return(I+k%I)%I}e.rot=N;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class O{constructor(){this.a=1,this.b=0}update(I){return this.b=this.b+(I-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=O;class T{constructor(I){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(I),this.c.fill(0,0,I)}update(I){const v=this.c[this.d];return this.c[this.d]=I,this.d=(this.d+1)%this.c.length,this.e-=v,this.e+=I,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=T}),function(){function ie(l){const O=[];typeof l=="number"&&O.push("code/timeOrigin",l);function T(I){O.push(I,Date.now())}function k(){const I=[];for(let v=0;v<O.length;v+=2)I.push({name:O[v],startTime:O[v+1]});return I}return{mark:T,getMarks:k}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ie():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const T of performance.getEntriesByType("mark"))O.push({name:T.name,startTime:Math.round(l+T.startTime)});return O}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ie(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),ie()}function A(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return A(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=A(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=A(N))}(),function(ie,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var A=e();for(var N in A)(typeof exports=="object"?exports:ie)[N]=A[N]}}(typeof self<"u"?self:this,function(){return function(ie){var e={};function A(N){if(e[N])return e[N].exports;var l=e[N]={i:N,l:!1,exports:{}};return ie[N].call(l.exports,l,l.exports,A),l.l=!0,l.exports}return A.m=ie,A.c=e,A.d=function(N,l,O){A.o(N,l)||Object.defineProperty(N,l,{enumerable:!0,get:O})},A.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},A.t=function(N,l){if(1&l&&(N=A(N)),8&l||4&l&&typeof N=="object"&&N&&N.__esModule)return N;var O=Object.create(null);if(A.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:N}),2&l&&typeof N!="string")for(var T in N)A.d(O,T,function(k){return N[k]}.bind(null,T));return O},A.n=function(N){var l=N&&N.__esModule?function(){return N.default}:function(){return N};return A.d(l,"a",l),l},A.o=function(N,l){return Object.prototype.hasOwnProperty.call(N,l)},A.p="",A(A.s=0)}([function(ie,e,A){(function(N){var l;e=ie.exports=K,l=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var le=Array.prototype.slice.call(arguments,0);le.unshift("SEMVER"),console.log.apply(console,le)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var O=256,T=Number.MAX_SAFE_INTEGER||9007199254740991,k=e.re=[],I=e.src=[],v=0,R=v++;I[R]="0|[1-9]\\d*";var b=v++;I[b]="[0-9]+";var m=v++;I[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var g=v++;I[g]="("+I[R]+")\\.("+I[R]+")\\.("+I[R]+")";var p=v++;I[p]="("+I[b]+")\\.("+I[b]+")\\.("+I[b]+")";var E=v++;I[E]="(?:"+I[R]+"|"+I[m]+")";var a=v++;I[a]="(?:"+I[b]+"|"+I[m]+")";var h=v++;I[h]="(?:-("+I[E]+"(?:\\."+I[E]+")*))";var u=v++;I[u]="(?:-?("+I[a]+"(?:\\."+I[a]+")*))";var d=v++;I[d]="[0-9A-Za-z-]+";var S=v++;I[S]="(?:\\+("+I[d]+"(?:\\."+I[d]+")*))";var L=v++,n="v?"+I[g]+I[h]+"?"+I[S]+"?";I[L]="^"+n+"$";var r="[v=\\s]*"+I[p]+I[u]+"?"+I[S]+"?",t=v++;I[t]="^"+r+"$";var i=v++;I[i]="((?:<|>)?=?)";var s=v++;I[s]=I[b]+"|x|X|\\*";var o=v++;I[o]=I[R]+"|x|X|\\*";var c=v++;I[c]="[v=\\s]*("+I[o]+")(?:\\.("+I[o]+")(?:\\.("+I[o]+")(?:"+I[h]+")?"+I[S]+"?)?)?";var y=v++;I[y]="[v=\\s]*("+I[s]+")(?:\\.("+I[s]+")(?:\\.("+I[s]+")(?:"+I[u]+")?"+I[S]+"?)?)?";var w=v++;I[w]="^"+I[i]+"\\s*"+I[c]+"$";var f=v++;I[f]="^"+I[i]+"\\s*"+I[y]+"$";var P=v++;I[P]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var D=v++;I[D]="(?:~>?)";var M=v++;I[M]="(\\s*)"+I[D]+"\\s+",k[M]=new RegExp(I[M],"g");var j=v++;I[j]="^"+I[D]+I[c]+"$";var B=v++;I[B]="^"+I[D]+I[y]+"$";var W=v++;I[W]="(?:\\^)";var H=v++;I[H]="(\\s*)"+I[W]+"\\s+",k[H]=new RegExp(I[H],"g");var Q=v++;I[Q]="^"+I[W]+I[c]+"$";var _=v++;I[_]="^"+I[W]+I[y]+"$";var Y=v++;I[Y]="^"+I[i]+"\\s*("+r+")$|^$";var $=v++;I[$]="^"+I[i]+"\\s*("+n+")$|^$";var z=v++;I[z]="(\\s*)"+I[i]+"\\s*("+r+"|"+I[c]+")",k[z]=new RegExp(I[z],"g");var x=v++;I[x]="^\\s*("+I[c]+")\\s+-\\s+("+I[c]+")\\s*$";var te=v++;I[te]="^\\s*("+I[y]+")\\s+-\\s+("+I[y]+")\\s*$";var ne=v++;I[ne]="(<|>)?=?\\s*\\*";for(var re=0;re<35;re++)l(re,I[re]),k[re]||(k[re]=new RegExp(I[re]));function X(le,fe){if(le instanceof K)return le;if(typeof le!="string"||le.length>O||!(fe?k[t]:k[L]).test(le))return null;try{return new K(le,fe)}catch{return null}}function K(le,fe){if(le instanceof K){if(le.loose===fe)return le;le=le.version}else if(typeof le!="string")throw new TypeError("Invalid Version: "+le);if(le.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof K))return new K(le,fe);l("SemVer",le,fe),this.loose=fe;var ge=le.trim().match(fe?k[t]:k[L]);if(!ge)throw new TypeError("Invalid Version: "+le);if(this.raw=le,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>T||this.major<0)throw new TypeError("Invalid major version");if(this.minor>T||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>T||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ie){if(/^[0-9]+$/.test(Ie)){var Pe=+Ie;if(Pe>=0&&Pe<T)return Pe}return Ie}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=X,e.valid=function(le,fe){var ge=X(le,fe);return ge?ge.version:null},e.clean=function(le,fe){var ge=X(le.trim().replace(/^[=v]+/,""),fe);return ge?ge.version:null},e.SemVer=K,K.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},K.prototype.toString=function(){return this.version},K.prototype.compare=function(le){return l("SemVer.compare",this.version,this.loose,le),le instanceof K||(le=new K(le,this.loose)),this.compareMain(le)||this.comparePre(le)},K.prototype.compareMain=function(le){return le instanceof K||(le=new K(le,this.loose)),C(this.major,le.major)||C(this.minor,le.minor)||C(this.patch,le.patch)},K.prototype.comparePre=function(le){if(le instanceof K||(le=new K(le,this.loose)),this.prerelease.length&&!le.prerelease.length)return-1;if(!this.prerelease.length&&le.prerelease.length)return 1;if(!this.prerelease.length&&!le.prerelease.length)return 0;var fe=0;do{var ge=this.prerelease[fe],Ie=le.prerelease[fe];if(l("prerelease compare",fe,ge,Ie),ge===void 0&&Ie===void 0)return 0;if(Ie===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ie)return C(ge,Ie)}while(++fe)},K.prototype.inc=function(le,fe){switch(le){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",fe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",fe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",fe),this.inc("pre",fe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",fe),this.inc("pre",fe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}fe&&(this.prerelease[0]===fe?isNaN(this.prerelease[1])&&(this.prerelease=[fe,0]):this.prerelease=[fe,0]);break;default:throw new Error("invalid increment argument: "+le)}return this.format(),this.raw=this.version,this},e.inc=function(le,fe,ge,Ie){typeof ge=="string"&&(Ie=ge,ge=void 0);try{return new K(le,ge).inc(fe,Ie).version}catch{return null}},e.diff=function(le,fe){if(V(le,fe))return null;var ge=X(le),Ie=X(fe);if(ge.prerelease.length||Ie.prerelease.length){for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ie[Pe])return"pre"+Pe;return"prerelease"}for(var Pe in ge)if((Pe==="major"||Pe==="minor"||Pe==="patch")&&ge[Pe]!==Ie[Pe])return Pe},e.compareIdentifiers=C;var F=/^[0-9]+$/;function C(le,fe){var ge=F.test(le),Ie=F.test(fe);return ge&&Ie&&(le=+le,fe=+fe),ge&&!Ie?-1:Ie&&!ge?1:le<fe?-1:le>fe?1:0}function U(le,fe,ge){return new K(le,ge).compare(new K(fe,ge))}function q(le,fe,ge){return U(le,fe,ge)>0}function G(le,fe,ge){return U(le,fe,ge)<0}function V(le,fe,ge){return U(le,fe,ge)===0}function Z(le,fe,ge){return U(le,fe,ge)!==0}function ee(le,fe,ge){return U(le,fe,ge)>=0}function ce(le,fe,ge){return U(le,fe,ge)<=0}function ue(le,fe,ge,Ie){var Pe;switch(fe){case"===":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Pe=le===ge;break;case"!==":typeof le=="object"&&(le=le.version),typeof ge=="object"&&(ge=ge.version),Pe=le!==ge;break;case"":case"=":case"==":Pe=V(le,ge,Ie);break;case"!=":Pe=Z(le,ge,Ie);break;case">":Pe=q(le,ge,Ie);break;case">=":Pe=ee(le,ge,Ie);break;case"<":Pe=G(le,ge,Ie);break;case"<=":Pe=ce(le,ge,Ie);break;default:throw new TypeError("Invalid operator: "+fe)}return Pe}function de(le,fe){if(le instanceof de){if(le.loose===fe)return le;le=le.value}if(!(this instanceof de))return new de(le,fe);l("comparator",le,fe),this.loose=fe,this.parse(le),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(le,fe){return C(fe,le)},e.major=function(le,fe){return new K(le,fe).major},e.minor=function(le,fe){return new K(le,fe).minor},e.patch=function(le,fe){return new K(le,fe).patch},e.compare=U,e.compareLoose=function(le,fe){return U(le,fe,!0)},e.rcompare=function(le,fe,ge){return U(fe,le,ge)},e.sort=function(le,fe){return le.sort(function(ge,Ie){return e.compare(ge,Ie,fe)})},e.rsort=function(le,fe){return le.sort(function(ge,Ie){return e.rcompare(ge,Ie,fe)})},e.gt=q,e.lt=G,e.eq=V,e.neq=Z,e.gte=ee,e.lte=ce,e.cmp=ue,e.Comparator=de;var ye={};function Se(le,fe){if(le instanceof Se)return le.loose===fe?le:new Se(le.raw,fe);if(le instanceof de)return new Se(le.value,fe);if(!(this instanceof Se))return new Se(le,fe);if(this.loose=fe,this.raw=le,this.set=le.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+le);this.format()}function Ee(le){return!le||le.toLowerCase()==="x"||le==="*"}function Re(le,fe,ge,Ie,Pe,Fe,Le,ze,Ne,je,Me,Ae,se){return((fe=Ee(ge)?"":Ee(Ie)?">="+ge+".0.0":Ee(Pe)?">="+ge+"."+Ie+".0":">="+fe)+" "+(ze=Ee(Ne)?"":Ee(je)?"<"+(+Ne+1)+".0.0":Ee(Me)?"<"+Ne+"."+(+je+1)+".0":Ae?"<="+Ne+"."+je+"."+Me+"-"+Ae:"<="+ze)).trim()}function ke(le,fe){for(var ge=0;ge<le.length;ge++)if(!le[ge].test(fe))return!1;if(fe.prerelease.length){for(ge=0;ge<le.length;ge++)if(l(le[ge].semver),le[ge].semver!==ye&&le[ge].semver.prerelease.length>0){var Ie=le[ge].semver;if(Ie.major===fe.major&&Ie.minor===fe.minor&&Ie.patch===fe.patch)return!0}return!1}return!0}function Be(le,fe,ge){try{fe=new Se(fe,ge)}catch{return!1}return fe.test(le)}function Ye(le,fe,ge,Ie){var Pe,Fe,Le,ze,Ne;switch(le=new K(le,Ie),fe=new Se(fe,Ie),ge){case">":Pe=q,Fe=ce,Le=G,ze=">",Ne=">=";break;case"<":Pe=G,Fe=ee,Le=q,ze="<",Ne="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Be(le,fe,Ie))return!1;for(var je=0;je<fe.set.length;++je){var Me=fe.set[je],Ae=null,se=null;if(Me.forEach(function(he){he.semver===ye&&(he=new de(">=0.0.0")),Ae=Ae||he,se=se||he,Pe(he.semver,Ae.semver,Ie)?Ae=he:Le(he.semver,se.semver,Ie)&&(se=he)}),Ae.operator===ze||Ae.operator===Ne||(!se.operator||se.operator===ze)&&Fe(le,se.semver)||se.operator===Ne&&Le(le,se.semver))return!1}return!0}de.prototype.parse=function(le){var fe=this.loose?k[Y]:k[$],ge=le.match(fe);if(!ge)throw new TypeError("Invalid comparator: "+le);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new K(ge[2],this.loose):this.semver=ye},de.prototype.toString=function(){return this.value},de.prototype.test=function(le){return l("Comparator.test",le,this.loose),this.semver===ye||(typeof le=="string"&&(le=new K(le,this.loose)),ue(le,this.operator,this.semver,this.loose))},de.prototype.intersects=function(le,fe){if(!(le instanceof de))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new Se(le.value,fe),Be(this.value,ge,fe);if(le.operator==="")return ge=new Se(this.value,fe),Be(le.semver,ge,fe);var Ie=!(this.operator!==">="&&this.operator!==">"||le.operator!==">="&&le.operator!==">"),Pe=!(this.operator!=="<="&&this.operator!=="<"||le.operator!=="<="&&le.operator!=="<"),Fe=this.semver.version===le.semver.version,Le=!(this.operator!==">="&&this.operator!=="<="||le.operator!==">="&&le.operator!=="<="),ze=ue(this.semver,"<",le.semver,fe)&&(this.operator===">="||this.operator===">")&&(le.operator==="<="||le.operator==="<"),Ne=ue(this.semver,">",le.semver,fe)&&(this.operator==="<="||this.operator==="<")&&(le.operator===">="||le.operator===">");return Ie||Pe||Fe&&Le||ze||Ne},e.Range=Se,Se.prototype.format=function(){return this.range=this.set.map(function(le){return le.join(" ").trim()}).join("||").trim(),this.range},Se.prototype.toString=function(){return this.range},Se.prototype.parseRange=function(le){var fe=this.loose;le=le.trim(),l("range",le,fe);var ge=fe?k[te]:k[x];le=le.replace(ge,Re),l("hyphen replace",le),le=le.replace(k[z],"$1$2$3"),l("comparator trim",le,k[z]),le=(le=(le=le.replace(k[M],"$1~")).replace(k[H],"$1^")).split(/\s+/).join(" ");var Ie=fe?k[Y]:k[$],Pe=le.split(" ").map(function(Fe){return function(Le,ze){return l("comp",Le),Le=function(Ne,je){return Ne.trim().split(/\s+/).map(function(Me){return function(Ae,se){l("caret",Ae,se);var he=se?k[_]:k[Q];return Ae.replace(he,function(me,pe,we,Ce,De){var Te;return l("caret",Ae,me,pe,we,Ce,De),Ee(pe)?Te="":Ee(we)?Te=">="+pe+".0.0 <"+(+pe+1)+".0.0":Ee(Ce)?Te=pe==="0"?">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+".0 <"+(+pe+1)+".0.0":De?(l("replaceCaret pr",De),De.charAt(0)!=="-"&&(De="-"+De),Te=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ce+De+" <"+pe+"."+we+"."+(+Ce+1):">="+pe+"."+we+"."+Ce+De+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ce+De+" <"+(+pe+1)+".0.0"):(l("no pr"),Te=pe==="0"?we==="0"?">="+pe+"."+we+"."+Ce+" <"+pe+"."+we+"."+(+Ce+1):">="+pe+"."+we+"."+Ce+" <"+pe+"."+(+we+1)+".0":">="+pe+"."+we+"."+Ce+" <"+(+pe+1)+".0.0"),l("caret return",Te),Te})}(Me,je)}).join(" ")}(Le,ze),l("caret",Le),Le=function(Ne,je){return Ne.trim().split(/\s+/).map(function(Me){return function(Ae,se){var he=se?k[B]:k[j];return Ae.replace(he,function(me,pe,we,Ce,De){var Te;return l("tilde",Ae,me,pe,we,Ce,De),Ee(pe)?Te="":Ee(we)?Te=">="+pe+".0.0 <"+(+pe+1)+".0.0":Ee(Ce)?Te=">="+pe+"."+we+".0 <"+pe+"."+(+we+1)+".0":De?(l("replaceTilde pr",De),De.charAt(0)!=="-"&&(De="-"+De),Te=">="+pe+"."+we+"."+Ce+De+" <"+pe+"."+(+we+1)+".0"):Te=">="+pe+"."+we+"."+Ce+" <"+pe+"."+(+we+1)+".0",l("tilde return",Te),Te})}(Me,je)}).join(" ")}(Le,ze),l("tildes",Le),Le=function(Ne,je){return l("replaceXRanges",Ne,je),Ne.split(/\s+/).map(function(Me){return function(Ae,se){Ae=Ae.trim();var he=se?k[f]:k[w];return Ae.replace(he,function(me,pe,we,Ce,De,Te){l("xRange",Ae,me,pe,we,Ce,De,Te);var qe=Ee(we),Oe=qe||Ee(Ce),$e=Oe||Ee(De);return pe==="="&&$e&&(pe=""),qe?me=pe===">"||pe==="<"?"<0.0.0":"*":pe&&$e?(Oe&&(Ce=0),$e&&(De=0),pe===">"?(pe=">=",Oe?(we=+we+1,Ce=0,De=0):$e&&(Ce=+Ce+1,De=0)):pe==="<="&&(pe="<",Oe?we=+we+1:Ce=+Ce+1),me=pe+we+"."+Ce+"."+De):Oe?me=">="+we+".0.0 <"+(+we+1)+".0.0":$e&&(me=">="+we+"."+Ce+".0 <"+we+"."+(+Ce+1)+".0"),l("xRange return",me),me})}(Me,je)}).join(" ")}(Le,ze),l("xrange",Le),Le=function(Ne,je){return l("replaceStars",Ne,je),Ne.trim().replace(k[ne],"")}(Le,ze),l("stars",Le),Le}(Fe,fe)}).join(" ").split(/\s+/);return this.loose&&(Pe=Pe.filter(function(Fe){return!!Fe.match(Ie)})),Pe=Pe.map(function(Fe){return new de(Fe,fe)})},Se.prototype.intersects=function(le,fe){if(!(le instanceof Se))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ie){return le.set.some(function(Pe){return Pe.every(function(Fe){return Ie.intersects(Fe,fe)})})})})},e.toComparators=function(le,fe){return new Se(le,fe).set.map(function(ge){return ge.map(function(Ie){return Ie.value}).join(" ").trim().split(" ")})},Se.prototype.test=function(le){if(!le)return!1;typeof le=="string"&&(le=new K(le,this.loose));for(var fe=0;fe<this.set.length;fe++)if(ke(this.set[fe],le))return!0;return!1},e.satisfies=Be,e.maxSatisfying=function(le,fe,ge){var Ie=null,Pe=null;try{var Fe=new Se(fe,ge)}catch{return null}return le.forEach(function(Le){Fe.test(Le)&&(Ie&&Pe.compare(Le)!==-1||(Pe=new K(Ie=Le,ge)))}),Ie},e.minSatisfying=function(le,fe,ge){var Ie=null,Pe=null;try{var Fe=new Se(fe,ge)}catch{return null}return le.forEach(function(Le){Fe.test(Le)&&(Ie&&Pe.compare(Le)!==1||(Pe=new K(Ie=Le,ge)))}),Ie},e.validRange=function(le,fe){try{return new Se(le,fe).range||"*"}catch{return null}},e.ltr=function(le,fe,ge){return Ye(le,fe,"<",ge)},e.gtr=function(le,fe,ge){return Ye(le,fe,">",ge)},e.outside=Ye,e.prerelease=function(le,fe){var ge=X(le,fe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(le,fe,ge){return le=new Se(le,ge),fe=new Se(fe,ge),le.intersects(fe)},e.coerce=function(le){if(le instanceof K)return le;if(typeof le!="string")return null;var fe=le.match(k[P]);return fe==null?null:X((fe[1]||"0")+"."+(fe[2]||"0")+"."+(fe[3]||"0"))}}).call(this,A(1))},function(ie,e){var A,N,l=ie.exports={};function O(){throw new Error("setTimeout has not been defined")}function T(){throw new Error("clearTimeout has not been defined")}function k(a){if(A===setTimeout)return setTimeout(a,0);if((A===O||!A)&&setTimeout)return A=setTimeout,setTimeout(a,0);try{return A(a,0)}catch{try{return A.call(null,a,0)}catch{return A.call(this,a,0)}}}(function(){try{A=typeof setTimeout=="function"?setTimeout:O}catch{A=O}try{N=typeof clearTimeout=="function"?clearTimeout:T}catch{N=T}})();var I,v=[],R=!1,b=-1;function m(){R&&I&&(R=!1,I.length?v=I.concat(v):b=-1,v.length&&g())}function g(){if(!R){var a=k(m);R=!0;for(var h=v.length;h;){for(I=v,v=[];++b<h;)I&&I[b].run();b=-1,h=v.length}I=null,R=!1,function(u){if(N===clearTimeout)return clearTimeout(u);if((N===T||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(u);try{N(u)}catch{try{return N.call(null,u)}catch{return N.call(this,u)}}}(a)}}function p(a,h){this.fun=a,this.array=h}function E(){}l.nextTick=function(a){var h=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)h[u-1]=arguments[u];v.push(new p(a,h)),v.length!==1||R||k(g)},p.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=E,l.addListener=E,l.once=E,l.off=E,l.removeListener=E,l.removeAllListeners=E,l.emit=E,l.prependListener=E,l.prependOnceListener=E,l.listeners=function(a){return[]},l.binding=function(a){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(a){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(oe[130],ae([0,1]),function(ie,e){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class N{constructor(k,I,v){this.level=k,this.key=I,this.value=v,this.forward=[]}}const l=void 0;class O{constructor(k,I=2**16){this.comparator=k,this[A]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(I)|0),this.e=new N(this.c,l,l)}get size(){return this.f}clear(){this.e=new N(this.c,l,l)}has(k){return!!O.g(this,k,this.comparator)}get(k){return O.g(this,k,this.comparator)?.value}set(k,I){return O.h(this,k,I,this.comparator)&&(this.f+=1),this}delete(k){const I=O.k(this,k,this.comparator);return I&&(this.f-=1),I}forEach(k,I){let v=this.e.forward[0];for(;v;)k.call(I,v.value,v.key,this),v=v.forward[0]}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let k=this.e.forward[0];for(;k;)yield[k.key,k.value],k=k.forward[0]}*keys(){let k=this.e.forward[0];for(;k;)yield k.key,k=k.forward[0]}*values(){let k=this.e.forward[0];for(;k;)yield k.value,k=k.forward[0]}toString(){let k="[SkipList]:",I=this.e.forward[0];for(;I;)k+=`node(${I.key}, ${I.value}, lvl:${I.level})`,I=I.forward[0];return k}static g(k,I,v){let R=k.e;for(let b=k.d-1;b>=0;b--)for(;R.forward[b]&&v(R.forward[b].key,I)<0;)R=R.forward[b];if(R=R.forward[0],R&&v(R.key,I)===0)return R}static h(k,I,v,R){const b=[];let m=k.e;for(let g=k.d-1;g>=0;g--){for(;m.forward[g]&&R(m.forward[g].key,I)<0;)m=m.forward[g];b[g]=m}if(m=m.forward[0],m&&R(m.key,I)===0)return m.value=v,!1;{const g=O.j(k);if(g>k.d){for(let p=k.d;p<g;p++)b[p]=k.e;k.d=g}m=new N(g,I,v);for(let p=0;p<g;p++)m.forward[p]=b[p].forward[p],b[p].forward[p]=m;return!0}}static j(k,I=.5){let v=1;for(;Math.random()<I&&v<k.c;)v+=1;return v}static k(k,I,v){const R=[];let b=k.e;for(let m=k.d-1;m>=0;m--){for(;b.forward[m]&&v(b.forward[m].key,I)<0;)b=b.forward[m];R[m]=b}if(b=b.forward[0],!b||v(b.key,I)!==0)return!1;for(let m=0;m<k.d&&R[m].forward[m]===b;m++)R[m].forward[m]=b.forward[m];for(;k.d>0&&k.e.forward[k.d-1]===l;)k.d-=1;return!0}}e.SkipList=O}),define(oe[43],ae([0,1,9,2]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(S){const L=S;return L?typeof L.read=="function":!1}e.isReadable=l;function O(S){const L=S;return L?[L.on,L.pause,L.resume,L.destroy].every(n=>typeof n=="function"):!1}e.isReadableStream=O;function T(S){const L=S;return L?O(L.stream)&&Array.isArray(L.buffer)&&typeof L.ended=="boolean":!1}e.isReadableBufferedStream=T;function k(S,L){return new I(S,L)}e.newWriteableStream=k;class I{constructor(L,n){this.e=L,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(L){if(!this.a.destroyed){if(this.a.flowing)this.g(L);else if(this.b.data.push(L),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(L){this.a.destroyed||(this.a.flowing?this.h(L):this.b.error.push(L))}end(L){this.a.destroyed||(typeof L<"u"&&this.write(L),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(L){this.c.data.slice(0).forEach(n=>n(L))}h(L){this.c.error.length===0?(0,A.onUnexpectedError)(L):this.c.error.slice(0).forEach(n=>n(L))}i(){this.c.end.slice(0).forEach(L=>L())}on(L,n){if(!this.a.destroyed)switch(L){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(L,n){if(this.a.destroyed)return;let r;switch(L){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const t=r.indexOf(n);t>=0&&r.splice(t,1)}}j(){if(this.b.data.length>0){const L=this.e(this.b.data);this.g(L),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const L of this.b.error)this.h(L);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function v(S,L){const n=[];let r;for(;(r=S.read())!==null;)n.push(r);return L(n)}e.consumeReadable=v;function R(S,L,n){const r=[];let t;for(;(t=S.read())!==null&&r.length<n;)r.push(t);return t===null&&r.length>0?L(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t<"u"){const i=t;return t=void 0,i}return S.read()}}}e.peekReadable=R;function b(S,L){return new Promise((n,r)=>{const t=[];m(S,{onData:i=>{L&&t.push(i)},onError:i=>{L?r(i):n(void 0)},onEnd:()=>{n(L?L(t):void 0)}})})}e.consumeStream=b;function m(S,L){let n=!1;return S.on("error",r=>{n||L.onError(r)}),S.on("end",()=>{n||L.onEnd()}),S.on("data",r=>{n||L.onData(r)}),(0,N.toDisposable)(()=>n=!0)}e.listenStream=m;function g(S,L){return new Promise((n,r)=>{const t=new N.DisposableStore,i=[],s=y=>{if(i.push(y),i.length>L)return t.dispose(),S.pause(),n({stream:S,buffer:i,ended:!1})},o=y=>r(y),c=()=>n({stream:S,buffer:i,ended:!0});t.add((0,N.toDisposable)(()=>S.removeListener("error",o))),S.on("error",o),t.add((0,N.toDisposable)(()=>S.removeListener("end",c))),S.on("end",c),t.add((0,N.toDisposable)(()=>S.removeListener("data",s))),S.on("data",s)})}e.peekStream=g;function p(S,L){const n=k(L);return n.end(S),n}e.toStream=p;function E(){const S=k(()=>{throw new Error("not supported")});return S.end(),S}e.emptyStream=E;function a(S){let L=!1;return{read:()=>L?null:(L=!0,S)}}e.toReadable=a;function h(S,L,n){const r=k(n);return m(S,{onData:t=>r.write(L.data(t)),onError:t=>r.error(L.error?L.error(t):t),onEnd:()=>r.end()}),r}e.transform=h;function u(S,L,n){let r=!1;return{read:()=>{const t=L.read();return r?t:(r=!0,t!==null?n([S,t]):S)}}}e.prefixedReadable=u;function d(S,L,n){let r=!1;const t=k(n);return m(L,{onData:i=>r?t.write(i):(r=!0,t.write(n([S,i]))),onError:i=>t.error(i),onEnd:()=>{r||(r=!0,t.write(S)),t.end()}}),t}e.prefixedStream=d}),define(oe[16],ae([0,1,43]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const N=typeof Buffer<"u";let l,O;class T{static alloc(y){return N?new T(Buffer.allocUnsafe(y)):new T(new Uint8Array(y))}static wrap(y){return N&&!Buffer.isBuffer(y)&&(y=Buffer.from(y.buffer,y.byteOffset,y.byteLength)),new T(y)}static fromString(y,w){return!(w?.dontUseNodeBuffer||!1)&&N?new T(Buffer.from(y)):(l||(l=new TextEncoder),new T(l.encode(y)))}static fromByteArray(y){const w=T.alloc(y.length);for(let f=0,P=y.length;f<P;f++)w.buffer[f]=y[f];return w}static concat(y,w){if(typeof w>"u"){w=0;for(let D=0,M=y.length;D<M;D++)w+=y[D].byteLength}const f=T.alloc(w);let P=0;for(let D=0,M=y.length;D<M;D++){const j=y[D];f.set(j,P),P+=j.byteLength}return f}constructor(y){this.buffer=y,this.byteLength=this.buffer.byteLength}clone(){const y=T.alloc(this.byteLength);return y.set(this),y}toString(){return N?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(y,w){return new T(this.buffer.subarray(y,w))}set(y,w){if(y instanceof T)this.buffer.set(y.buffer,w);else if(y instanceof Uint8Array)this.buffer.set(y,w);else if(y instanceof ArrayBuffer)this.buffer.set(new Uint8Array(y),w);else if(ArrayBuffer.isView(y))this.buffer.set(new Uint8Array(y.buffer,y.byteOffset,y.byteLength),w);else throw new Error("Unknown argument 'array'")}readUInt32BE(y){return v(this.buffer,y)}writeUInt32BE(y,w){R(this.buffer,y,w)}readUInt32LE(y){return b(this.buffer,y)}writeUInt32LE(y,w){m(this.buffer,y,w)}readUInt8(y){return g(this.buffer,y)}writeUInt8(y,w){p(this.buffer,y,w)}}e.VSBuffer=T;function k(c,y){return c[y+0]<<0>>>0|c[y+1]<<8>>>0}e.readUInt16LE=k;function I(c,y,w){c[w+0]=y&255,y=y>>>8,c[w+1]=y&255}e.writeUInt16LE=I;function v(c,y){return c[y]*2**24+c[y+1]*2**16+c[y+2]*2**8+c[y+3]}e.readUInt32BE=v;function R(c,y,w){c[w+3]=y,y=y>>>8,c[w+2]=y,y=y>>>8,c[w+1]=y,y=y>>>8,c[w]=y}e.writeUInt32BE=R;function b(c,y){return c[y+0]<<0>>>0|c[y+1]<<8>>>0|c[y+2]<<16>>>0|c[y+3]<<24>>>0}e.readUInt32LE=b;function m(c,y,w){c[w+0]=y&255,y=y>>>8,c[w+1]=y&255,y=y>>>8,c[w+2]=y&255,y=y>>>8,c[w+3]=y&255}e.writeUInt32LE=m;function g(c,y){return c[y]}e.readUInt8=g;function p(c,y,w){c[w]=y}e.writeUInt8=p;function E(c){return A.consumeReadable(c,y=>T.concat(y))}e.readableToBuffer=E;function a(c){return A.toReadable(c)}e.bufferToReadable=a;function h(c){return A.consumeStream(c,y=>T.concat(y))}e.streamToBuffer=h;async function u(c){return c.ended?T.concat(c.buffer):T.concat([...c.buffer,await h(c.stream)])}e.bufferedStreamToBuffer=u;function d(c){return A.toStream(c,y=>T.concat(y))}e.bufferToStream=d;function S(c){return A.transform(c,{data:y=>typeof y=="string"?T.fromString(y):T.wrap(y)},y=>T.concat(y))}e.streamToBufferReadableStream=S;function L(c){return A.newWriteableStream(y=>T.concat(y),c)}e.newWriteableBufferStream=L;function n(c,y){return A.prefixedReadable(c,y,w=>T.concat(w))}e.prefixedBufferReadable=n;function r(c,y){return A.prefixedStream(c,y,w=>T.concat(w))}e.prefixedBufferStream=r;function t(c){let y=0,w=0,f=0;const P=new Uint8Array(Math.floor(c.length/4*3)),D=j=>{switch(w){case 3:P[f++]=y|j,w=0;break;case 2:P[f++]=y|j>>>2,y=j<<6,w=3;break;case 1:P[f++]=y|j>>>4,y=j<<4,w=2;break;default:y=j<<2,w=1}};for(let j=0;j<c.length;j++){const B=c.charCodeAt(j);if(B>=65&&B<=90)D(B-65);else if(B>=97&&B<=122)D(B-97+26);else if(B>=48&&B<=57)D(B-48+52);else if(B===43||B===45)D(62);else if(B===47||B===95)D(63);else{if(B===61)break;throw new SyntaxError(`Unexpected base64 character ${c[j]}`)}}const M=f;for(;w>0;)D(0);return T.wrap(P).slice(0,M)}e.decodeBase64=t;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function o({buffer:c},y=!0,w=!1){const f=w?s:i;let P="";const D=c.byteLength%3;let M=0;for(;M<c.byteLength-D;M+=3){const j=c[M+0],B=c[M+1],W=c[M+2];P+=f[j>>>2],P+=f[(j<<4|B>>>4)&63],P+=f[(B<<2|W>>>6)&63],P+=f[W&63]}if(D===1){const j=c[M+0];P+=f[j>>>2],P+=f[j<<4&63],y&&(P+="==")}else if(D===2){const j=c[M+0],B=c[M+1];P+=f[j>>>2],P+=f[(j<<4|B>>>4)&63],P+=f[B<<2&63],y&&(P+="=")}return P}e.encodeBase64=o}),define(oe[131],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(oe[11],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function A(r){return typeof r=="string"}e.isString=A;function N(r){return Array.isArray(r)&&r.every(t=>A(t))}e.isStringArray=N;function l(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=l;function O(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}e.isTypedArray=O;function T(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=T;function k(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=k;function I(r){return r===!0||r===!1}e.isBoolean=I;function v(r){return typeof r>"u"}e.isUndefined=v;function R(r){return!b(r)}e.isDefined=R;function b(r){return v(r)||r===null}e.isUndefinedOrNull=b;function m(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=m;function g(r){if(b(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=g;function p(...r){const t=[];for(let i=0;i<r.length;i++){const s=r[i];if(b(s))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(s)}return t}e.assertAllDefined=p;const E=Object.prototype.hasOwnProperty;function a(r){if(!l(r))return!1;for(const t in r)if(E.call(r,t))return!1;return!0}e.isEmptyObject=a;function h(r){return typeof r=="function"}e.isFunction=h;function u(...r){return r.length>0&&r.every(h)}e.areFunctions=u;function d(r,t){const i=Math.min(r.length,t.length);for(let s=0;s<i;s++)S(r[s],t[s])}e.validateConstraints=d;function S(r,t){if(A(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(h(t)){try{if(r instanceof t)return}catch{}if(!b(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=S;function L(r){return r===null?void 0:r}e.withNullAsUndefined=L;function n(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=n}),define(oe[52],ae([0,1,11]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const N=Object.create(null);function l(k,I){if((0,A.isString)(I)){const v=N[I];if(v===void 0)throw new Error(`${k} references an unknown codicon: ${I}`);I=v}return N[k]=I,{id:k}}function O(){return N}e.getCodiconFontCharacters=O;function T(){return Object.values(e.Codicon)}e.getAllCodicons=T,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),send:l("send",60431),sparkle:l("sparkle",60432),insert:l("insert",60433),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(oe[31],ae([0,1,11]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function N(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const u=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([d,S])=>{u[d]=S&&typeof S=="object"?N(S):S}),u}e.deepClone=N;function l(h){if(!h||typeof h!="object")return h;const u=[h];for(;u.length>0;){const d=u.shift();Object.freeze(d);for(const S in d)if(O.call(d,S)){const L=d[S];typeof L=="object"&&!Object.isFrozen(L)&&!(0,A.isTypedArray)(L)&&u.push(L)}}return h}e.deepFreeze=l;const O=Object.prototype.hasOwnProperty;function T(h,u){return k(h,u,new Set)}e.cloneAndChange=T;function k(h,u,d){if((0,A.isUndefinedOrNull)(h))return h;const S=u(h);if(typeof S<"u")return S;if(Array.isArray(h)){const L=[];for(const n of h)L.push(k(n,u,d));return L}if((0,A.isObject)(h)){if(d.has(h))throw new Error("Cannot clone recursive data-structure");d.add(h);const L={};for(const n in h)O.call(h,n)&&(L[n]=k(h[n],u,d));return d.delete(h),L}return h}function I(h,u,d=!0){return(0,A.isObject)(h)?((0,A.isObject)(u)&&Object.keys(u).forEach(S=>{S in h?d&&((0,A.isObject)(h[S])&&(0,A.isObject)(u[S])?I(h[S],u[S],d):h[S]=u[S]):h[S]=u[S]}),h):u}e.mixin=I;function v(h,u){if(h===u)return!0;if(h==null||u===null||u===void 0||typeof h!=typeof u||typeof h!="object"||Array.isArray(h)!==Array.isArray(u))return!1;let d,S;if(Array.isArray(h)){if(h.length!==u.length)return!1;for(d=0;d<h.length;d++)if(!v(h[d],u[d]))return!1}else{const L=[];for(S in h)L.push(S);L.sort();const n=[];for(S in u)n.push(S);if(n.sort(),!v(L,n))return!1;for(d=0;d<L.length;d++)if(!v(h[L[d]],u[L[d]]))return!1}return!0}e.equals=v;function R(h){const u=new Set;return JSON.stringify(h,(d,S)=>{if((0,A.isObject)(S)||Array.isArray(S)){if(u.has(S))return"[Circular]";u.add(S)}return S})}e.safeStringify=R;function b(h,u){const d=Object.create(null);return!h||!u||Object.keys(u).forEach(L=>{const n=h[L],r=u[L];v(n,r)||(d[L]=r)}),d}e.distinct=b;function m(h,u){const d=u.toLowerCase(),S=Object.keys(h).find(L=>L.toLowerCase()===d);return S?h[S]:h[u]}e.getCaseInsensitive=m;function g(h,u){const d=Object.create(null);for(const[S,L]of Object.entries(h))u(S,L)&&(d[S]=L);return d}e.filter=g;function p(h){let u=[],d=Object.getPrototypeOf(h);for(;Object.prototype!==d;)u=u.concat(Object.getOwnPropertyNames(d)),d=Object.getPrototypeOf(d);return u}e.getAllPropertyNames=p;function E(h){const u=[];for(const d of p(h))typeof h[d]=="function"&&u.push(d);return u}e.getAllMethodNames=E;function a(h,u){const d=L=>function(){const n=Array.prototype.slice.call(arguments,0);return u(L,n)},S={};for(const L of h)S[L]=d(L);return S}e.createProxyObject=a}),define(oe[132],ae([0,1,52]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var N;(function(T){function k(I){return I&&typeof I=="object"&&typeof I.id=="string"}T.isThemeColor=k})(N||(e.ThemeColor=N={}));function l(T){return{id:T}}e.themeColorFromId=l;var O;(function(T){T.iconNameSegment="[A-Za-z0-9]+",T.iconNameExpression="[A-Za-z0-9-]+",T.iconModifierExpression="~[A-Za-z]+",T.iconNameCharacter="[A-Za-z0-9~-]";const k=new RegExp(`^(${T.iconNameExpression})(${T.iconModifierExpression})?$`);function I(u){const d=k.exec(u.id);if(!d)return I(A.Codicon.error);const[,S,L]=d,n=["codicon","codicon-"+S];return L&&n.push("codicon-modifier-"+L.substring(1)),n}T.asClassNameArray=I;function v(u){return I(u).join(" ")}T.asClassName=v;function R(u){return"."+I(u).join(".")}T.asCSSSelector=R;function b(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(typeof u.color>"u"||N.isThemeColor(u.color))}T.isThemeIcon=b;const m=new RegExp(`^\\$\\((${T.iconNameExpression}(?:${T.iconModifierExpression})?)\\)$`);function g(u){const d=m.exec(u);if(!d)return;const[,S]=d;return{id:S}}T.fromString=g;function p(u){return{id:u}}T.fromId=p;function E(u,d){let S=u.id;const L=S.lastIndexOf("~");return L!==-1&&(S=S.substring(0,L)),d&&(S=`${S}~${d}`),{id:S}}T.modify=E;function a(u){const d=u.id.lastIndexOf("~");if(d!==-1)return u.id.substring(d+1)}T.getModifier=a;function h(u,d){return u.id===d.id&&u.color?.id===d.color?.id}T.isEqual=h})(O||(e.ThemeIcon=O={}))}),define(oe[32],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const A=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(l){return A.test(l)}e.isUUID=N,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(k){for(let I=0;I<k.length;I++)k[I]=Math.floor(Math.random()*256);return k};const O=new Uint8Array(16),T=[];for(let k=0;k<256;k++)T.push(k.toString(16).padStart(2,"0"));return function(){l(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let I=0,v="";return v+=T[O[I++]],v+=T[O[I++]],v+=T[O[I++]],v+=T[O[I++]],v+="-",v+=T[O[I++]],v+=T[O[I++]],v+="-",v+=T[O[I++]],v+=T[O[I++]],v+="-",v+=T[O[I++]],v+=T[O[I++]],v+="-",v+=T[O[I++]],v+=T[O[I++]],v+=T[O[I++]],v+=T[O[I++]],v+=T[O[I++]],v+=T[O[I++]],v}}()}),define(oe[133],ae([0,1,34]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const N=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function l(T){const k=T.replace(/\-/g,":").toLowerCase();return!N.has(k)}function O(){const T=(0,A.networkInterfaces)();for(const k in T){const I=T[k];if(I){for(const{mac:v}of I)if(l(v))return v}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=O}),define(oe[134],ae([0,1,63]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function N(k,I,v,R=1){let b=!1;return new Promise(m=>{const g=setTimeout(()=>{if(!b)return b=!0,m(0)},v);l(k,I,R,p=>{if(!b)return b=!0,clearTimeout(g),m(p)})})}e.findFreePort=N;function l(k,I,v,R){if(I===0)return R(0);const b=new A.Socket;b.once("connect",()=>(T(b),l(k+v,I-1,v,R))),b.once("data",()=>{}),b.once("error",m=>(T(b),m.code!=="ECONNREFUSED"?l(k+v,I-1,v,R):R(k))),b.connect(k,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function O(k,I,v,R="127.0.0.1"){let b=!1,m,g=1;const p=A.createServer({pauseOnConnect:!0});function E(a,h){b||(b=!0,p.removeAllListeners(),p.close(),m&&clearTimeout(m),h(a))}return new Promise(a=>{m=setTimeout(()=>{E(0,a)},v),p.on("listening",()=>{E(k,a)}),p.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&g<I?(k++,g++,p.listen(k,R)):E(0,a)}),p.on("close",()=>{E(0,a)}),p.listen(k,R)})}e.findFreePortFaster=O;function T(k){try{k.removeAllListeners("connect"),k.removeAllListeners("error"),k.end(),k.destroy(),k.unref()}catch(I){console.error(I)}}}),define(oe[135],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUtilityProcess=void 0;function A(N){return!!N.parentPort}e.isUtilityProcess=A}),define(oe[136],ae([8,7]),function(ie,e){return ie.create("vs/base/common/date",e)}),define(oe[64],ae([0,1,136]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const N=60,l=N*60,O=l*24,T=O*7,k=O*30,I=O*365;function v(b,m,g,p){typeof b!="number"&&(b=b.getTime());const E=Math.round((new Date().getTime()-b)/1e3);if(E<-30)return(0,A.localize)(0,null,v(new Date().getTime()+E*1e3,!1));if(!p&&E<30)return(0,A.localize)(1,null);let a;return E<N?(a=E,m?a===1?g?(0,A.localize)(2,null,a):(0,A.localize)(3,null,a):g?(0,A.localize)(4,null,a):(0,A.localize)(5,null,a):a===1?g?(0,A.localize)(6,null,a):(0,A.localize)(7,null,a):g?(0,A.localize)(8,null,a):(0,A.localize)(9,null,a)):E<l?(a=Math.floor(E/N),m?a===1?g?(0,A.localize)(10,null,a):(0,A.localize)(11,null,a):g?(0,A.localize)(12,null,a):(0,A.localize)(13,null,a):a===1?g?(0,A.localize)(14,null,a):(0,A.localize)(15,null,a):g?(0,A.localize)(16,null,a):(0,A.localize)(17,null,a)):E<O?(a=Math.floor(E/l),m?a===1?g?(0,A.localize)(18,null,a):(0,A.localize)(19,null,a):g?(0,A.localize)(20,null,a):(0,A.localize)(21,null,a):a===1?g?(0,A.localize)(22,null,a):(0,A.localize)(23,null,a):g?(0,A.localize)(24,null,a):(0,A.localize)(25,null,a)):E<T?(a=Math.floor(E/O),m?a===1?(0,A.localize)(26,null,a):(0,A.localize)(27,null,a):a===1?(0,A.localize)(28,null,a):(0,A.localize)(29,null,a)):E<k?(a=Math.floor(E/T),m?a===1?g?(0,A.localize)(30,null,a):(0,A.localize)(31,null,a):g?(0,A.localize)(32,null,a):(0,A.localize)(33,null,a):a===1?g?(0,A.localize)(34,null,a):(0,A.localize)(35,null,a):g?(0,A.localize)(36,null,a):(0,A.localize)(37,null,a)):E<I?(a=Math.floor(E/k),m?a===1?g?(0,A.localize)(38,null,a):(0,A.localize)(39,null,a):g?(0,A.localize)(40,null,a):(0,A.localize)(41,null,a):a===1?g?(0,A.localize)(42,null,a):(0,A.localize)(43,null,a):g?(0,A.localize)(44,null,a):(0,A.localize)(45,null,a)):(a=Math.floor(E/I),m?a===1?g?(0,A.localize)(46,null,a):(0,A.localize)(47,null,a):g?(0,A.localize)(48,null,a):(0,A.localize)(49,null,a):a===1?g?(0,A.localize)(50,null,a):(0,A.localize)(51,null,a):g?(0,A.localize)(52,null,a):(0,A.localize)(53,null,a))}e.fromNow=v;function R(b){return b.getFullYear()+"-"+String(b.getMonth()+1).padStart(2,"0")+"-"+String(b.getDate()).padStart(2,"0")+"T"+String(b.getHours()).padStart(2,"0")+":"+String(b.getMinutes()).padStart(2,"0")+":"+String(b.getSeconds()).padStart(2,"0")+"."+(b.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(oe[137],ae([8,7]),function(ie,e){return ie.create("vs/base/common/errorMessage",e)}),define(oe[38],ae([0,1,21,11,137]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function O(b,m){return m&&(b.stack||b.stacktrace)?l.localize(0,null,k(b),T(b.stack)||T(b.stacktrace)):k(b)}function T(b){return Array.isArray(b)?b.join(`
`):b}function k(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?l.localize(1,null,b.message):b.message||l.localize(2,null)}function I(b=null,m=!1){if(!b)return l.localize(3,null);if(Array.isArray(b)){const g=A.coalesce(b),p=I(g[0],m);return g.length>1?l.localize(4,null,p,g.length):p}if(N.isString(b))return b;if(b.detail){const g=b.detail;if(g.error)return O(g.error,m);if(g.exception)return O(g.exception,m)}return b.stack?O(b,m):b.message?b.message:l.localize(5,null)}e.toErrorMessage=I;function v(b){const m=b;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=v;function R(b,m){let g;return typeof b=="string"?g=new Error(b):g=b,g.actions=m,g}e.createErrorWithActions=R}),define(oe[138],ae([8,7]),function(ie,e){return ie.create("vs/base/common/jsonErrorMessages",e)}),define(oe[139],ae([0,1,138]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function N(l){switch(l){case 1:return(0,A.localize)(0,null);case 2:return(0,A.localize)(1,null);case 3:return(0,A.localize)(2,null);case 4:return(0,A.localize)(3,null);case 5:return(0,A.localize)(4,null);case 6:return(0,A.localize)(5,null);case 7:return(0,A.localize)(6,null);case 8:return(0,A.localize)(7,null);case 9:return(0,A.localize)(8,null);default:return""}}e.getParseErrorMessage=N}),define(oe[140],ae([8,7]),function(ie,e){return ie.create("vs/base/common/platform",e)}),define(oe[4],ae([0,1,140]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let N=!1,l=!1,O=!1,T=!1,k=!1,I=!1,v=!1,R=!1,b=!1,m=!1,g,p=e.LANGUAGE_DEFAULT,E=e.LANGUAGE_DEFAULT,a,h;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const d=typeof u?.versions?.electron=="string",S=d&&u?.type==="renderer";if(typeof navigator=="object"&&!S)h=navigator.userAgent,N=h.indexOf("Windows")>=0,l=h.indexOf("Macintosh")>=0,R=(h.indexOf("Macintosh")>=0||h.indexOf("iPad")>=0||h.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,O=h.indexOf("Linux")>=0,m=h?.indexOf("Mobi")>=0,I=!0,g=A.getConfiguredDefaultLocale(A.localize(0,null))||e.LANGUAGE_DEFAULT,p=g,E=navigator.language;else if(typeof u=="object"){N=u.platform==="win32",l=u.platform==="darwin",O=u.platform==="linux",T=O&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,v=d,b=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,g=e.LANGUAGE_DEFAULT,p=e.LANGUAGE_DEFAULT;const y=u.env.VSCODE_NLS_CONFIG;if(y)try{const w=JSON.parse(y),f=w.availableLanguages["*"];g=w.locale,E=w.osLocale,p=f||e.LANGUAGE_DEFAULT,a=w._translationsConfigFile}catch{}k=!0}else console.error("Unable to resolve platform.");var L;(function(y){y[y.Web=0]="Web",y[y.Mac=1]="Mac",y[y.Linux=2]="Linux",y[y.Windows=3]="Windows"})(L||(e.Platform=L={}));function n(y){switch(y){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=n;let r=0;l?r=1:N?r=3:O&&(r=2),e.isWindows=N,e.isMacintosh=l,e.isLinux=O,e.isLinuxSnap=T,e.isNative=k,e.isElectron=v,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=R,e.isMobile=m,e.isCI=b,e.platform=r,e.userAgent=h,e.language=p;var t;(function(y){function w(){return e.language}y.value=w;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}y.isDefaultVariant=f;function P(){return e.language==="en"}y.isDefault=P})(t||(e.Language=t={})),e.locale=g,e.platformLocale=E,e.translationsConfigFile=a,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const y=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let P=0,D=y.length;P<D;P++){const M=y[P];if(M.id===f.data.vscodeScheduleAsyncWork){y.splice(P,1),M.callback();return}}});let w=0;return f=>{const P=++w;y.push({id:P,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:P},"*")}}return y=>setTimeout(y)})();var i;(function(y){y[y.Windows=1]="Windows",y[y.Macintosh=2]="Macintosh",y[y.Linux=3]="Linux"})(i||(e.OperatingSystem=i={})),e.OS=l||R?2:N?1:3;let s=!0,o=!1;function c(){if(!o){o=!0;const y=new Uint8Array(2);y[0]=1,y[1]=2,s=new Uint16Array(y.buffer)[0]===(2<<8)+1}return s}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(oe[36],ae([0,1,4]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let N;if(typeof A.globals.vscode<"u"&&typeof A.globals.vscode.process<"u"){const l=A.globals.vscode.process;N={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?N={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:N={get platform(){return A.isWindows?"win32":A.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=N.cwd,e.env=N.env,e.platform=N.platform,e.arch=N.arch}),define(oe[14],ae([0,1,36]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const N=65,l=97,O=90,T=122,k=46,I=47,v=92,R=58,b=63;class m extends Error{constructor(r,t,i){let s;typeof t=="string"&&t.indexOf("not ")===0?(s="must not be",t=t.replace(/^not /,"")):s="must be";const o=r.indexOf(".")!==-1?"property":"argument";let c=`The "${r}" ${o} ${s} of type ${t}`;c+=`. Received type ${typeof i}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function g(n,r){if(n===null||typeof n!="object")throw new m(r,"Object",n)}function p(n,r){if(typeof n!="string")throw new m(r,"string",n)}const E=A.platform==="win32";function a(n){return n===I||n===v}function h(n){return n===I}function u(n){return n>=N&&n<=O||n>=l&&n<=T}function d(n,r,t,i){let s="",o=0,c=-1,y=0,w=0;for(let f=0;f<=n.length;++f){if(f<n.length)w=n.charCodeAt(f);else{if(i(w))break;w=I}if(i(w)){if(!(c===f-1||y===1))if(y===2){if(s.length<2||o!==2||s.charCodeAt(s.length-1)!==k||s.charCodeAt(s.length-2)!==k){if(s.length>2){const P=s.lastIndexOf(t);P===-1?(s="",o=0):(s=s.slice(0,P),o=s.length-1-s.lastIndexOf(t)),c=f,y=0;continue}else if(s.length!==0){s="",o=0,c=f,y=0;continue}}r&&(s+=s.length>0?`${t}..`:"..",o=2)}else s.length>0?s+=`${t}${n.slice(c+1,f)}`:s=n.slice(c+1,f),o=f-c-1;c=f,y=0}else w===k&&y!==-1?++y:y=-1}return s}function S(n,r){g(r,"pathObject");const t=r.dir||r.root,i=r.base||`${r.name||""}${r.ext||""}`;return t?t===r.root?`${t}${i}`:`${t}${n}${i}`:i}e.win32={resolve(...n){let r="",t="",i=!1;for(let s=n.length-1;s>=-1;s--){let o;if(s>=0){if(o=n[s],p(o,"path"),o.length===0)continue}else r.length===0?o=A.cwd():(o=A.env[`=${r}`]||A.cwd(),(o===void 0||o.slice(0,2).toLowerCase()!==r.toLowerCase()&&o.charCodeAt(2)===v)&&(o=`${r}\\`));const c=o.length;let y=0,w="",f=!1;const P=o.charCodeAt(0);if(c===1)a(P)&&(y=1,f=!0);else if(a(P))if(f=!0,a(o.charCodeAt(1))){let D=2,M=D;for(;D<c&&!a(o.charCodeAt(D));)D++;if(D<c&&D!==M){const j=o.slice(M,D);for(M=D;D<c&&a(o.charCodeAt(D));)D++;if(D<c&&D!==M){for(M=D;D<c&&!a(o.charCodeAt(D));)D++;(D===c||D!==M)&&(w=`\\\\${j}\\${o.slice(M,D)}`,y=D)}}}else y=1;else u(P)&&o.charCodeAt(1)===R&&(w=o.slice(0,2),y=2,c>2&&a(o.charCodeAt(2))&&(f=!0,y=3));if(w.length>0)if(r.length>0){if(w.toLowerCase()!==r.toLowerCase())continue}else r=w;if(i){if(r.length>0)break}else if(t=`${o.slice(y)}\\${t}`,i=f,f&&r.length>0)break}return t=d(t,!i,"\\",a),i?`${r}\\${t}`:`${r}${t}`||"."},normalize(n){p(n,"path");const r=n.length;if(r===0)return".";let t=0,i,s=!1;const o=n.charCodeAt(0);if(r===1)return h(o)?"\\":n;if(a(o))if(s=!0,a(n.charCodeAt(1))){let y=2,w=y;for(;y<r&&!a(n.charCodeAt(y));)y++;if(y<r&&y!==w){const f=n.slice(w,y);for(w=y;y<r&&a(n.charCodeAt(y));)y++;if(y<r&&y!==w){for(w=y;y<r&&!a(n.charCodeAt(y));)y++;if(y===r)return`\\\\${f}\\${n.slice(w)}\\`;y!==w&&(i=`\\\\${f}\\${n.slice(w,y)}`,t=y)}}}else t=1;else u(o)&&n.charCodeAt(1)===R&&(i=n.slice(0,2),t=2,r>2&&a(n.charCodeAt(2))&&(s=!0,t=3));let c=t<r?d(n.slice(t),!s,"\\",a):"";return c.length===0&&!s&&(c="."),c.length>0&&a(n.charCodeAt(r-1))&&(c+="\\"),i===void 0?s?`\\${c}`:c:s?`${i}\\${c}`:`${i}${c}`},isAbsolute(n){p(n,"path");const r=n.length;if(r===0)return!1;const t=n.charCodeAt(0);return a(t)||r>2&&u(t)&&n.charCodeAt(1)===R&&a(n.charCodeAt(2))},join(...n){if(n.length===0)return".";let r,t;for(let o=0;o<n.length;++o){const c=n[o];p(c,"path"),c.length>0&&(r===void 0?r=t=c:r+=`\\${c}`)}if(r===void 0)return".";let i=!0,s=0;if(typeof t=="string"&&a(t.charCodeAt(0))){++s;const o=t.length;o>1&&a(t.charCodeAt(1))&&(++s,o>2&&(a(t.charCodeAt(2))?++s:i=!1))}if(i){for(;s<r.length&&a(r.charCodeAt(s));)s++;s>=2&&(r=`\\${r.slice(s)}`)}return e.win32.normalize(r)},relative(n,r){if(p(n,"from"),p(r,"to"),n===r)return"";const t=e.win32.resolve(n),i=e.win32.resolve(r);if(t===i||(n=t.toLowerCase(),r=i.toLowerCase(),n===r))return"";let s=0;for(;s<n.length&&n.charCodeAt(s)===v;)s++;let o=n.length;for(;o-1>s&&n.charCodeAt(o-1)===v;)o--;const c=o-s;let y=0;for(;y<r.length&&r.charCodeAt(y)===v;)y++;let w=r.length;for(;w-1>y&&r.charCodeAt(w-1)===v;)w--;const f=w-y,P=c<f?c:f;let D=-1,M=0;for(;M<P;M++){const B=n.charCodeAt(s+M);if(B!==r.charCodeAt(y+M))break;B===v&&(D=M)}if(M!==P){if(D===-1)return i}else{if(f>P){if(r.charCodeAt(y+M)===v)return i.slice(y+M+1);if(M===2)return i.slice(y+M)}c>P&&(n.charCodeAt(s+M)===v?D=M:M===2&&(D=3)),D===-1&&(D=0)}let j="";for(M=s+D+1;M<=o;++M)(M===o||n.charCodeAt(M)===v)&&(j+=j.length===0?"..":"\\..");return y+=D,j.length>0?`${j}${i.slice(y,w)}`:(i.charCodeAt(y)===v&&++y,i.slice(y,w))},toNamespacedPath(n){if(typeof n!="string"||n.length===0)return n;const r=e.win32.resolve(n);if(r.length<=2)return n;if(r.charCodeAt(0)===v){if(r.charCodeAt(1)===v){const t=r.charCodeAt(2);if(t!==b&&t!==k)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(u(r.charCodeAt(0))&&r.charCodeAt(1)===R&&r.charCodeAt(2)===v)return`\\\\?\\${r}`;return n},dirname(n){p(n,"path");const r=n.length;if(r===0)return".";let t=-1,i=0;const s=n.charCodeAt(0);if(r===1)return a(s)?n:".";if(a(s)){if(t=i=1,a(n.charCodeAt(1))){let y=2,w=y;for(;y<r&&!a(n.charCodeAt(y));)y++;if(y<r&&y!==w){for(w=y;y<r&&a(n.charCodeAt(y));)y++;if(y<r&&y!==w){for(w=y;y<r&&!a(n.charCodeAt(y));)y++;if(y===r)return n;y!==w&&(t=i=y+1)}}}}else u(s)&&n.charCodeAt(1)===R&&(t=r>2&&a(n.charCodeAt(2))?3:2,i=t);let o=-1,c=!0;for(let y=r-1;y>=i;--y)if(a(n.charCodeAt(y))){if(!c){o=y;break}}else c=!1;if(o===-1){if(t===-1)return".";o=t}return n.slice(0,o)},basename(n,r){r!==void 0&&p(r,"ext"),p(n,"path");let t=0,i=-1,s=!0,o;if(n.length>=2&&u(n.charCodeAt(0))&&n.charCodeAt(1)===R&&(t=2),r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let c=r.length-1,y=-1;for(o=n.length-1;o>=t;--o){const w=n.charCodeAt(o);if(a(w)){if(!s){t=o+1;break}}else y===-1&&(s=!1,y=o+1),c>=0&&(w===r.charCodeAt(c)?--c===-1&&(i=o):(c=-1,i=y))}return t===i?i=y:i===-1&&(i=n.length),n.slice(t,i)}for(o=n.length-1;o>=t;--o)if(a(n.charCodeAt(o))){if(!s){t=o+1;break}}else i===-1&&(s=!1,i=o+1);return i===-1?"":n.slice(t,i)},extname(n){p(n,"path");let r=0,t=-1,i=0,s=-1,o=!0,c=0;n.length>=2&&n.charCodeAt(1)===R&&u(n.charCodeAt(0))&&(r=i=2);for(let y=n.length-1;y>=r;--y){const w=n.charCodeAt(y);if(a(w)){if(!o){i=y+1;break}continue}s===-1&&(o=!1,s=y+1),w===k?t===-1?t=y:c!==1&&(c=1):t!==-1&&(c=-1)}return t===-1||s===-1||c===0||c===1&&t===s-1&&t===i+1?"":n.slice(t,s)},format:S.bind(null,"\\"),parse(n){p(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const t=n.length;let i=0,s=n.charCodeAt(0);if(t===1)return a(s)?(r.root=r.dir=n,r):(r.base=r.name=n,r);if(a(s)){if(i=1,a(n.charCodeAt(1))){let D=2,M=D;for(;D<t&&!a(n.charCodeAt(D));)D++;if(D<t&&D!==M){for(M=D;D<t&&a(n.charCodeAt(D));)D++;if(D<t&&D!==M){for(M=D;D<t&&!a(n.charCodeAt(D));)D++;D===t?i=D:D!==M&&(i=D+1)}}}}else if(u(s)&&n.charCodeAt(1)===R){if(t<=2)return r.root=r.dir=n,r;if(i=2,a(n.charCodeAt(2))){if(t===3)return r.root=r.dir=n,r;i=3}}i>0&&(r.root=n.slice(0,i));let o=-1,c=i,y=-1,w=!0,f=n.length-1,P=0;for(;f>=i;--f){if(s=n.charCodeAt(f),a(s)){if(!w){c=f+1;break}continue}y===-1&&(w=!1,y=f+1),s===k?o===-1?o=f:P!==1&&(P=1):o!==-1&&(P=-1)}return y!==-1&&(o===-1||P===0||P===1&&o===y-1&&o===c+1?r.base=r.name=n.slice(c,y):(r.name=n.slice(c,o),r.base=n.slice(c,y),r.ext=n.slice(o,y))),c>0&&c!==i?r.dir=n.slice(0,c-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const L=(()=>{if(E){const n=/\\/g;return()=>{const r=A.cwd().replace(n,"/");return r.slice(r.indexOf("/"))}}return()=>A.cwd()})();e.posix={resolve(...n){let r="",t=!1;for(let i=n.length-1;i>=-1&&!t;i--){const s=i>=0?n[i]:L();p(s,"path"),s.length!==0&&(r=`${s}/${r}`,t=s.charCodeAt(0)===I)}return r=d(r,!t,"/",h),t?`/${r}`:r.length>0?r:"."},normalize(n){if(p(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===I,t=n.charCodeAt(n.length-1)===I;return n=d(n,!r,"/",h),n.length===0?r?"/":t?"./":".":(t&&(n+="/"),r?`/${n}`:n)},isAbsolute(n){return p(n,"path"),n.length>0&&n.charCodeAt(0)===I},join(...n){if(n.length===0)return".";let r;for(let t=0;t<n.length;++t){const i=n[t];p(i,"path"),i.length>0&&(r===void 0?r=i:r+=`/${i}`)}return r===void 0?".":e.posix.normalize(r)},relative(n,r){if(p(n,"from"),p(r,"to"),n===r||(n=e.posix.resolve(n),r=e.posix.resolve(r),n===r))return"";const t=1,i=n.length,s=i-t,o=1,c=r.length-o,y=s<c?s:c;let w=-1,f=0;for(;f<y;f++){const D=n.charCodeAt(t+f);if(D!==r.charCodeAt(o+f))break;D===I&&(w=f)}if(f===y)if(c>y){if(r.charCodeAt(o+f)===I)return r.slice(o+f+1);if(f===0)return r.slice(o+f)}else s>y&&(n.charCodeAt(t+f)===I?w=f:f===0&&(w=0));let P="";for(f=t+w+1;f<=i;++f)(f===i||n.charCodeAt(f)===I)&&(P+=P.length===0?"..":"/..");return`${P}${r.slice(o+w)}`},toNamespacedPath(n){return n},dirname(n){if(p(n,"path"),n.length===0)return".";const r=n.charCodeAt(0)===I;let t=-1,i=!0;for(let s=n.length-1;s>=1;--s)if(n.charCodeAt(s)===I){if(!i){t=s;break}}else i=!1;return t===-1?r?"/":".":r&&t===1?"//":n.slice(0,t)},basename(n,r){r!==void 0&&p(r,"ext"),p(n,"path");let t=0,i=-1,s=!0,o;if(r!==void 0&&r.length>0&&r.length<=n.length){if(r===n)return"";let c=r.length-1,y=-1;for(o=n.length-1;o>=0;--o){const w=n.charCodeAt(o);if(w===I){if(!s){t=o+1;break}}else y===-1&&(s=!1,y=o+1),c>=0&&(w===r.charCodeAt(c)?--c===-1&&(i=o):(c=-1,i=y))}return t===i?i=y:i===-1&&(i=n.length),n.slice(t,i)}for(o=n.length-1;o>=0;--o)if(n.charCodeAt(o)===I){if(!s){t=o+1;break}}else i===-1&&(s=!1,i=o+1);return i===-1?"":n.slice(t,i)},extname(n){p(n,"path");let r=-1,t=0,i=-1,s=!0,o=0;for(let c=n.length-1;c>=0;--c){const y=n.charCodeAt(c);if(y===I){if(!s){t=c+1;break}continue}i===-1&&(s=!1,i=c+1),y===k?r===-1?r=c:o!==1&&(o=1):r!==-1&&(o=-1)}return r===-1||i===-1||o===0||o===1&&r===i-1&&r===t+1?"":n.slice(r,i)},format:S.bind(null,"/"),parse(n){p(n,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(n.length===0)return r;const t=n.charCodeAt(0)===I;let i;t?(r.root="/",i=1):i=0;let s=-1,o=0,c=-1,y=!0,w=n.length-1,f=0;for(;w>=i;--w){const P=n.charCodeAt(w);if(P===I){if(!y){o=w+1;break}continue}c===-1&&(y=!1,c=w+1),P===k?s===-1?s=w:f!==1&&(f=1):s!==-1&&(f=-1)}if(c!==-1){const P=o===0&&t?1:o;s===-1||f===0||f===1&&s===c-1&&s===o+1?r.base=r.name=n.slice(P,c):(r.name=n.slice(P,s),r.base=n.slice(P,c),r.ext=n.slice(s,c))}return o>0?r.dir=n.slice(0,o-1):t&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E?e.win32.normalize:e.posix.normalize,e.isAbsolute=E?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E?e.win32.join:e.posix.join,e.resolve=E?e.win32.resolve:e.posix.resolve,e.relative=E?e.win32.relative:e.posix.relative,e.dirname=E?e.win32.dirname:e.posix.dirname,e.basename=E?e.win32.basename:e.posix.basename,e.extname=E?e.win32.extname:e.posix.extname,e.format=E?e.win32.format:e.posix.format,e.parse=E?e.win32.parse:e.posix.parse,e.toNamespacedPath=E?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E?e.win32.sep:e.posix.sep,e.delimiter=E?e.win32.delimiter:e.posix.delimiter}),define(oe[141],ae([0,1,14]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(R){const b=(0,A.extname)(R),m=N[b.toLowerCase()];return m!==void 0?m:T(R)}e.getMediaOrTextMime=O;function T(R){const b=(0,A.extname)(R);return l[b.toLowerCase()]}e.getMediaMime=T;function k(R){for(const b in l)if(l[b]===R)return b}e.getExtensionForMimeType=k;const I=/^(.+)\/(.+?)(;.+)?$/;function v(R,b){const m=I.exec(R);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:b?void 0:R}e.normalizeMimeType=v}),define(oe[88],ae([0,1,4]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var N;(function(k){k[k.stdout=0]="stdout",k[k.stderr=1]="stderr"})(N||(e.Source=N={}));var l;(function(k){k[k.Success=0]="Success",k[k.Unknown=1]="Unknown",k[k.AccessDenied=2]="AccessDenied",k[k.ProcessNotFound=3]="ProcessNotFound"})(l||(e.TerminateResponseCode=l={}));function O(k,...I){const v=I.reduce((m,g)=>(m[g]=!0,m),{}),R=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(k).filter(m=>!v[m]).forEach(m=>{for(let g=0;g<R.length;g++)if(m.search(R[g])!==-1){delete k[m];break}})}e.sanitizeProcessEnvironment=O;function T(k){k&&(delete k.DEBUG,A.isMacintosh&&delete k.DYLD_LIBRARY_PATH,A.isLinux&&delete k.LD_PRELOAD)}e.removeDangerousEnvVariables=T}),define(oe[89],ae([0,1,4]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const N=A.globals.performance&&typeof A.globals.performance.now=="function";class l{static create(T=!0){return new l(T)}constructor(T){this.a=N&&T,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?A.globals.performance.now():Date.now()}}e.StopWatch=l}),define(oe[3],ae([0,1,9,84,2,86,89]),function(ie,e,A,N,l,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const k=!1,I=!1;var v;(function(o){o.None=()=>l.Disposable.None;function c(q){if(I){const{onDidAddListener:G}=q,V=p.create();let Z=0;q.onDidAddListener=()=>{++Z===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),V.print()),G?.()}}}function y(q,G){return H(q,()=>{},0,void 0,!0,void 0,G)}o.defer=y;function w(q){return(G,V=null,Z)=>{let ee=!1,ce;return ce=q(ue=>{if(!ee)return ce?ce.dispose():ee=!0,G.call(V,ue)},null,Z),ee&&ce.dispose(),ce}}o.once=w;function f(q,G,V){return W((Z,ee=null,ce)=>q(ue=>Z.call(ee,G(ue)),null,ce),V)}o.map=f;function P(q,G,V){return W((Z,ee=null,ce)=>q(ue=>{G(ue),Z.call(ee,ue)},null,ce),V)}o.forEach=P;function D(q,G,V){return W((Z,ee=null,ce)=>q(ue=>G(ue)&&Z.call(ee,ue),null,ce),V)}o.filter=D;function M(q){return q}o.signal=M;function j(...q){return(G,V=null,Z)=>(0,l.combinedDisposable)(...q.map(ee=>ee(ce=>G.call(V,ce),null,Z)))}o.any=j;function B(q,G,V,Z){let ee=V;return f(q,ce=>(ee=G(ee,ce),ee),Z)}o.reduce=B;function W(q,G){let V;const Z={onWillAddFirstListener(){V=q(ee.fire,ee)},onDidRemoveLastListener(){V?.dispose()}};G||c(Z);const ee=new a(Z);return G?.add(ee),ee.event}function H(q,G,V=100,Z=!1,ee=!1,ce,ue){let de,ye,Se,Ee=0,Re;const ke={leakWarningThreshold:ce,onWillAddFirstListener(){de=q(Ye=>{Ee++,ye=G(ye,Ye),Z&&!Se&&(Be.fire(ye),ye=void 0),Re=()=>{const le=ye;ye=void 0,Se=void 0,(!Z||Ee>1)&&Be.fire(le),Ee=0},typeof V=="number"?(clearTimeout(Se),Se=setTimeout(Re,V)):Se===void 0&&(Se=0,queueMicrotask(Re))})},onWillRemoveListener(){ee&&Ee>0&&Re?.()},onDidRemoveLastListener(){Re=void 0,de.dispose()}};ue||c(ke);const Be=new a(ke);return ue?.add(Be),Be.event}o.debounce=H;function Q(q,G=0,V){return o.debounce(q,(Z,ee)=>Z?(Z.push(ee),Z):[ee],G,void 0,!0,void 0,V)}o.accumulate=Q;function _(q,G=(Z,ee)=>Z===ee,V){let Z=!0,ee;return D(q,ce=>{const ue=Z||!G(ce,ee);return Z=!1,ee=ce,ue},V)}o.latch=_;function Y(q,G,V){return[o.filter(q,G,V),o.filter(q,Z=>!G(Z),V)]}o.split=Y;function $(q,G=!1,V=[]){let Z=V.slice(),ee=q(de=>{Z?Z.push(de):ue.fire(de)});const ce=()=>{Z?.forEach(de=>ue.fire(de)),Z=null},ue=new a({onWillAddFirstListener(){ee||(ee=q(de=>ue.fire(de)))},onDidAddFirstListener(){Z&&(G?setTimeout(ce):ce())},onDidRemoveLastListener(){ee&&ee.dispose(),ee=null}});return ue.event}o.buffer=$;class z{constructor(G){this.event=G,this.c=new l.DisposableStore}map(G){return new z(f(this.event,G,this.c))}forEach(G){return new z(P(this.event,G,this.c))}filter(G){return new z(D(this.event,G,this.c))}reduce(G,V){return new z(B(this.event,G,V,this.c))}latch(){return new z(_(this.event,void 0,this.c))}debounce(G,V=100,Z=!1,ee=!1,ce){return new z(H(this.event,G,V,Z,ee,ce,this.c))}on(G,V,Z){return this.event(G,V,Z)}once(G,V,Z){return w(this.event)(G,V,Z)}dispose(){this.c.dispose()}}function x(q){return new z(q)}o.chain=x;function te(q,G,V=Z=>Z){const Z=(...de)=>ue.fire(V(...de)),ee=()=>q.on(G,Z),ce=()=>q.removeListener(G,Z),ue=new a({onWillAddFirstListener:ee,onDidRemoveLastListener:ce});return ue.event}o.fromNodeEventEmitter=te;function ne(q,G,V=Z=>Z){const Z=(...de)=>ue.fire(V(...de)),ee=()=>q.addEventListener(G,Z),ce=()=>q.removeEventListener(G,Z),ue=new a({onWillAddFirstListener:ee,onDidRemoveLastListener:ce});return ue.event}o.fromDOMEventEmitter=ne;function re(q){return new Promise(G=>w(q)(G))}o.toPromise=re;function X(q,G){return G(void 0),q(V=>G(V))}o.runAndSubscribe=X;function K(q,G){let V=null;function Z(ce){V?.dispose(),V=new l.DisposableStore,G(ce,V)}Z(void 0);const ee=q(ce=>Z(ce));return(0,l.toDisposable)(()=>{ee.dispose(),V?.dispose()})}o.runAndSubscribeWithStore=K;class F{constructor(G,V){this._observable=G,this.c=0,this.d=!1;const Z={onWillAddFirstListener:()=>{G.addObserver(this)},onDidRemoveLastListener:()=>{G.removeObserver(this)}};V||c(Z),this.emitter=new a(Z),V&&V.add(this.emitter)}beginUpdate(G){this.c++}handlePossibleChange(G){}handleChange(G,V){this.d=!0}endUpdate(G){this.c--,this.c===0&&(this._observable.reportChanges(),this.d&&(this.d=!1,this.emitter.fire(this._observable.get())))}}function C(q,G){return new F(q,G).emitter.event}o.fromObservable=C;function U(q){return G=>{let V=0,Z=!1;const ee={beginUpdate(){V++},endUpdate(){V--,V===0&&(q.reportChanges(),Z&&(Z=!1,G()))},handlePossibleChange(){},handleChange(){Z=!0}};return q.addObserver(ee),{dispose(){q.removeObserver(ee)}}}}o.fromObservableLight=U})(v||(e.Event=v={}));class R{constructor(c){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${c}_${R.c++}`,R.all.add(this)}start(c){this.d=new T.StopWatch(!0),this.listenerCount=c}stop(){if(this.d){const c=this.d.elapsed();this.durations.push(c),this.elapsedOverall+=c,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=R,R.all=new Set,R.c=0;let b=-1;function m(o){const c=b;return b=o,{dispose(){b=c}}}e.setGlobalLeakWarningThreshold=m;class g{constructor(c,y=Math.random().toString(18).slice(2,5)){this.threshold=c,this.name=y,this.d=0}dispose(){this.c?.clear()}check(c,y){const w=this.threshold;if(w<=0||y<w)return;this.c||(this.c=new Map);const f=this.c.get(c.value)||0;if(this.c.set(c.value,f+1),this.d-=1,this.d<=0){this.d=w*.5;let P,D=0;for(const[M,j]of this.c)(!P||D<j)&&(P=M,D=j);console.warn(`[${this.name}] potential listener LEAK detected, having ${y} listeners already. MOST frequent listener (${D}):`),console.warn(P)}return()=>{const P=this.c.get(c.value)||0;this.c.set(c.value,P-1)}}}class p{static create(){return new p(new Error().stack??"")}constructor(c){this.value=c}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class E{constructor(c,y,w){this.callback=c,this.callbackThis=y,this.stack=w,this.subscription=new l.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class a{constructor(c){this.j=!1,this.d=c,this.f=b>0||this.d?.leakWarningThreshold?new g(this.d?.leakWarningThreshold??b):void 0,this.g=this.d?._profName?new R(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(k){const c=Array.from(this.q);queueMicrotask(()=>{for(const y of c)y.subscription.isset()&&(y.subscription.unset(),y.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(c,y,w)=>{if(this.q||(this.q=new O.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const f=this.q.isEmpty();f&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let P,D;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(D=p.create(),P=this.f.check(D,this.q.size+1)),k&&(D=D??p.create());const M=new E(c,y,D),j=this.q.push(M);f&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,c,y);const B=M.subscription.set(()=>{P?.(),this.j||(this.d?.onWillRemoveListener?.(this),j(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return w instanceof l.DisposableStore?w.add(B):Array.isArray(w)&&w.push(B),B}),this.l}fire(c){if(this.q){this.m||(this.m=new u(this.d?.onListenerError));for(const y of this.q)this.m.push(this,y,c);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=a;class h{constructor(c=A.onUnexpectedError){this.d=c,this.c=new O.LinkedList}get size(){return this.c.size}push(c,y,w){this.c.push(new d(c,y,w))}clear(c){const y=new O.LinkedList;for(const w of this.c)w.emitter!==c&&y.push(w);this.c=y}deliver(){for(;this.c.size>0;){const c=this.c.shift();try{c.listener.invoke(c.event)}catch(y){this.d(y)}}}}e.EventDeliveryQueue=h;class u extends h{clear(c){this.c.clear()}}class d{constructor(c,y,w){this.emitter=c,this.listener=y,this.event=w}}class S extends a{async fireAsync(c,y,w){if(this.q){this.c||(this.c=new O.LinkedList);for(const f of this.q)this.c.push([f,c]);for(;this.c.size>0&&!y.isCancellationRequested;){const[f,P]=this.c.shift(),D=[],M={...P,token:y,waitUntil:j=>{if(Object.isFrozen(D))throw new Error("waitUntil can NOT be called asynchronous");w&&(j=w(j,f.callback)),D.push(j)}};try{f.invoke(M)}catch(j){(0,A.onUnexpectedError)(j);continue}Object.freeze(D),await Promise.allSettled(D).then(j=>{for(const B of j)B.status==="rejected"&&(0,A.onUnexpectedError)(B.reason)})}}}}e.AsyncEmitter=S;class L extends a{constructor(c){super(c),this.h=0,this.s=new O.LinkedList,this.t=c?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const c=Array.from(this.s);this.s.clear(),super.fire(this.t(c))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(c){this.q&&(this.h!==0?this.s.push(c):super.fire(c))}}e.PauseableEmitter=L;class n extends L{constructor(c){super(c),this.c=c.delay??100}fire(c){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(c)}}e.DebounceEmitter=n;class r extends a{constructor(c){super(c),this.c=[],this.h=c?.merge}fire(c){this.hasListeners()&&(this.c.push(c),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(y=>super.fire(y)),this.c=[]}))}}e.MicrotaskEmitter=r;class t{constructor(){this.d=!1,this.f=[],this.c=new a({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(c){const y={event:c,listener:null};this.f.push(y),this.d&&this.j(y);const w=()=>{this.d&&this.k(y);const f=this.f.indexOf(y);this.f.splice(f,1)};return(0,l.toDisposable)((0,N.once)(w))}g(){this.d=!0,this.f.forEach(c=>this.j(c))}h(){this.d=!1,this.f.forEach(c=>this.k(c))}j(c){c.listener=c.event(y=>this.c.fire(y))}k(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=t;class i{constructor(){this.c=[]}wrapEvent(c){return(y,w,f)=>c(P=>{const D=this.c[this.c.length-1];D?D.push(()=>y.call(w,P)):y.call(w,P)},void 0,f)}bufferEvents(c){const y=[];this.c.push(y);const w=c();return this.c.pop(),y.forEach(f=>f()),w}}e.EventBufferer=i;class s{constructor(){this.c=!1,this.d=v.None,this.f=l.Disposable.None,this.g=new a({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(c){this.d=c,this.c&&(this.f.dispose(),this.f=c(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=s}),define(oe[26],ae([0,1,3]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const N=Object.freeze(function(k,I){const v=setTimeout(k.bind(I),0);return{dispose(){clearTimeout(v)}}});var l;(function(k){function I(v){return v===k.None||v===k.Cancelled||v instanceof O?!0:!v||typeof v!="object"?!1:typeof v.isCancellationRequested=="boolean"&&typeof v.onCancellationRequested=="function"}k.isCancellationToken=I,k.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:A.Event.None}),k.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:N})})(l||(e.CancellationToken=l={}));class O{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?N:(this.b||(this.b=new A.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class T{constructor(I){this.a=void 0,this.b=void 0,this.b=I&&I.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new O),this.a}cancel(){this.a?this.a instanceof O&&this.a.cancel():this.a=l.Cancelled}dispose(I=!1){I&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof O&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=T}),define(oe[142],ae([0,1,26]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class N{constructor(k){this.b=k,this.a=null}get(){if(this.a)return this.a;const k=new A.CancellationTokenSource,I=this.b(k.token);return this.a={promise:I,dispose:()=>{this.a=null,k.cancel(),k.dispose()}},this.a}}e.Cache=N;class l{constructor(k){this.c=k,this.a=void 0,this.b=void 0}get(k){const I=JSON.stringify(k);return this.b!==I&&(this.b=I,this.a=this.c(k)),this.a}}e.LRUCachedFunction=l;class O{get cachedValues(){return this.a}constructor(k){this.b=k,this.a=new Map}get(k){if(this.a.has(k))return this.a.get(k);const I=this.b(k);return this.a.set(k,I),I}}e.CachedFunction=O}),define(oe[27],ae([0,1,142,128]),function(ie,e,A,N){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function O(se){return!se||typeof se!="string"?!0:se.trim().length===0}e.isFalsyOrWhitespace=O;const T=/{(\d+)}/g;function k(se,...he){return he.length===0?se:se.replace(T,function(me,pe){const we=parseInt(pe,10);return isNaN(we)||we<0||we>=he.length?me:he[we]})}e.format=k;const I=/{([^}]+)}/g;function v(se,he){return se.replace(I,(me,pe)=>he[pe]??me)}e.format2=v;function R(se){return se.replace(/[<>&]/g,function(he){switch(he){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return he}})}e.escape=R;function b(se){return se.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=b;function m(se,he){let me=0;const pe=he.charCodeAt(0);for(let we=se.length-1;we>=0;we--)se.charCodeAt(we)===pe&&me++;return me}e.count=m;function g(se,he,me="\u2026"){return se.length<=he?se:`${se.substr(0,he)}${me}`}e.truncate=g;function p(se,he=" "){const me=E(se,he);return a(me,he)}e.trim=p;function E(se,he){if(!se||!he)return se;const me=he.length;if(me===0||se.length===0)return se;let pe=0;for(;se.indexOf(he,pe)===pe;)pe=pe+me;return se.substring(pe)}e.ltrim=E;function a(se,he){if(!se||!he)return se;const me=he.length,pe=se.length;if(me===0||pe===0)return se;let we=pe,Ce=-1;for(;Ce=se.lastIndexOf(he,we-1),!(Ce===-1||Ce+me!==we);){if(Ce===0)return"";we=Ce}return se.substring(0,we)}e.rtrim=a;function h(se){return se.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function u(se){return se.replace(/\*/g,"")}e.stripWildcards=u;function d(se,he,me={}){if(!se)throw new Error("Cannot create regex from empty string");he||(se=b(se)),me.wholeWord&&(/\B/.test(se.charAt(0))||(se="\\b"+se),/\B/.test(se.charAt(se.length-1))||(se=se+"\\b"));let pe="";return me.global&&(pe+="g"),me.matchCase||(pe+="i"),me.multiline&&(pe+="m"),me.unicode&&(pe+="u"),new RegExp(se,pe)}e.createRegExp=d;function S(se){return se.source==="^"||se.source==="^$"||se.source==="$"||se.source==="^\\s*$"?!1:!!(se.exec("")&&se.lastIndex===0)}e.regExpLeadsToEndlessLoop=S;function L(se){return!!se.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=L;function n(se){return(se.global?"g":"")+(se.ignoreCase?"i":"")+(se.multiline?"m":"")+(se.unicode?"u":"")}e.regExpFlags=n;function r(se){return se.split(/\r\n|\r|\n/)}e.splitLines=r;function t(se){for(let he=0,me=se.length;he<me;he++){const pe=se.charCodeAt(he);if(pe!==32&&pe!==9)return he}return-1}e.firstNonWhitespaceIndex=t;function i(se,he=0,me=se.length){for(let pe=he;pe<me;pe++){const we=se.charCodeAt(pe);if(we!==32&&we!==9)return se.substring(he,pe)}return se.substring(he,me)}e.getLeadingWhitespace=i;function s(se,he=se.length-1){for(let me=he;me>=0;me--){const pe=se.charCodeAt(me);if(pe!==32&&pe!==9)return me}return-1}e.lastNonWhitespaceIndex=s;function o(se,he,me){const pe=[];let we=0;for(const Ce of se.matchAll(he)){if(pe.push(se.slice(we,Ce.index)),Ce.index===void 0)throw new Error("match.index should be defined");we=Ce.index+Ce[0].length,pe.push(me(Ce[0],...Ce.slice(1),Ce.index,se,Ce.groups))}return pe.push(se.slice(we)),Promise.all(pe).then(Ce=>Ce.join(""))}e.replaceAsync=o;function c(se,he){return se<he?-1:se>he?1:0}e.compare=c;function y(se,he,me=0,pe=se.length,we=0,Ce=he.length){for(;me<pe&&we<Ce;me++,we++){const qe=se.charCodeAt(me),Oe=he.charCodeAt(we);if(qe<Oe)return-1;if(qe>Oe)return 1}const De=pe-me,Te=Ce-we;return De<Te?-1:De>Te?1:0}e.compareSubstring=y;function w(se,he){return f(se,he,0,se.length,0,he.length)}e.compareIgnoreCase=w;function f(se,he,me=0,pe=se.length,we=0,Ce=he.length){for(;me<pe&&we<Ce;me++,we++){let qe=se.charCodeAt(me),Oe=he.charCodeAt(we);if(qe===Oe)continue;if(qe>=128||Oe>=128)return y(se.toLowerCase(),he.toLowerCase(),me,pe,we,Ce);D(qe)&&(qe-=32),D(Oe)&&(Oe-=32);const $e=qe-Oe;if($e!==0)return $e}const De=pe-me,Te=Ce-we;return De<Te?-1:De>Te?1:0}e.compareSubstringIgnoreCase=f;function P(se){return se>=48&&se<=57}e.isAsciiDigit=P;function D(se){return se>=97&&se<=122}e.isLowerAsciiLetter=D;function M(se){return se>=65&&se<=90}e.isUpperAsciiLetter=M;function j(se,he){return se.length===he.length&&f(se,he)===0}e.equalsIgnoreCase=j;function B(se,he){const me=he.length;return he.length>se.length?!1:f(se,he,0,me)===0}e.startsWithIgnoreCase=B;function W(se,he){const me=Math.min(se.length,he.length);let pe;for(pe=0;pe<me;pe++)if(se.charCodeAt(pe)!==he.charCodeAt(pe))return pe;return me}e.commonPrefixLength=W;function H(se,he){const me=Math.min(se.length,he.length);let pe;const we=se.length-1,Ce=he.length-1;for(pe=0;pe<me;pe++)if(se.charCodeAt(we-pe)!==he.charCodeAt(Ce-pe))return pe;return me}e.commonSuffixLength=H;function Q(se){return 55296<=se&&se<=56319}e.isHighSurrogate=Q;function _(se){return 56320<=se&&se<=57343}e.isLowSurrogate=_;function Y(se,he){return(se-55296<<10)+(he-56320)+65536}e.computeCodePoint=Y;function $(se,he,me){const pe=se.charCodeAt(me);if(Q(pe)&&me+1<he){const we=se.charCodeAt(me+1);if(_(we))return Y(pe,we)}return pe}e.getNextCodePoint=$;function z(se,he){const me=se.charCodeAt(he-1);if(_(me)&&he>1){const pe=se.charCodeAt(he-2);if(Q(pe))return Y(pe,me)}return me}class x{get offset(){return this.e}constructor(he,me=0){this.c=he,this.d=he.length,this.e=me}setOffset(he){this.e=he}prevCodePoint(){const he=z(this.c,this.e);return this.e-=he>=65536?2:1,he}nextCodePoint(){const he=$(this.c,this.d,this.e);return this.e+=he>=65536?2:1,he}eol(){return this.e>=this.d}}e.CodePointIterator=x;class te{get offset(){return this.c.offset}constructor(he,me=0){this.c=new x(he,me)}nextGraphemeLength(){const he=Pe.getInstance(),me=this.c,pe=me.offset;let we=he.getGraphemeBreakType(me.nextCodePoint());for(;!me.eol();){const Ce=me.offset,De=he.getGraphemeBreakType(me.nextCodePoint());if(ge(we,De)){me.setOffset(Ce);break}we=De}return me.offset-pe}prevGraphemeLength(){const he=Pe.getInstance(),me=this.c,pe=me.offset;let we=he.getGraphemeBreakType(me.prevCodePoint());for(;me.offset>0;){const Ce=me.offset,De=he.getGraphemeBreakType(me.prevCodePoint());if(ge(De,we)){me.setOffset(Ce);break}we=De}return pe-me.offset}eol(){return this.c.eol()}}e.GraphemeIterator=te;function ne(se,he){return new te(se,he).nextGraphemeLength()}e.nextCharLength=ne;function re(se,he){return new te(se,he).prevGraphemeLength()}e.prevCharLength=re;function X(se,he){he>0&&_(se.charCodeAt(he))&&he--;const me=he+ne(se,he);return[me-re(se,me),me]}e.getCharContainingOffset=X;function K(se){const he=new te(se);let me=0;for(;!he.eol();)me++,he.nextGraphemeLength();return me}e.charCount=K;let F;function C(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function U(se){return F||(F=C()),F.test(se)}e.containsRTL=U;const q=/^[\t\n\r\x20-\x7E]*$/;function G(se){return q.test(se)}e.isBasicASCII=G,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function V(se){return e.UNUSUAL_LINE_TERMINATORS.test(se)}e.containsUnusualLineTerminators=V;function Z(se){return se>=11904&&se<=55215||se>=63744&&se<=64255||se>=65281&&se<=65374}e.isFullWidthCharacter=Z;function ee(se){return se>=127462&&se<=127487||se===8986||se===8987||se===9200||se===9203||se>=9728&&se<=10175||se===11088||se===11093||se>=127744&&se<=128591||se>=128640&&se<=128764||se>=128992&&se<=129008||se>=129280&&se<=129535||se>=129648&&se<=129782}e.isEmojiImprecise=ee;function ce(se,he){if(se.length<he)return se;const me=/\b/g;let pe=0;for(;me.test(se)&&!(se.length-me.lastIndex<he);)pe=me.lastIndex,me.lastIndex+=1;return se.substring(pe).replace(/^\s/,"")}e.lcut=ce;const ue=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,de=/\x1b\].*?\x07/g;function ye(se){return se&&(se=se.replace(ue,"").replace(de,"")),se}e.removeAnsiEscapeCodes=ye,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Se(se){return!!(se&&se.length>0&&se.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Se;function Ee(se){return Se(se)?se.substr(1):se}e.stripUTF8BOM=Ee;function Re(se,he){if(!se||!he||se.length<he.length)return!1;const me=he.length,pe=se.toLowerCase();let we=0,Ce=-1;for(;we<me;){const De=pe.indexOf(he[we],Ce+1);if(De<0)return!1;Ce=De,we++}return!0}e.fuzzyContains=Re;function ke(se,he=!1){return se?(he&&(se=se.replace(/\\./g,"")),se.toLowerCase()!==se):!1}e.containsUppercaseCharacter=ke;function Be(se){return se.charAt(0).toUpperCase()+se.slice(1)}e.uppercaseFirstLetter=Be;function Ye(se,he=1){if(he===0)return"";let me=-1;do me=se.indexOf(`
`,me+1),he--;while(he>0&&me>=0);return me===-1?se:(se[me-1]==="\r"&&me--,se.substr(0,me))}e.getNLines=Ye;function le(se){return se=se%(2*26),se<26?String.fromCharCode(97+se):String.fromCharCode(65+se-26)}e.singleLetterHash=le;function fe(se){return Pe.getInstance().getGraphemeBreakType(se)}e.getGraphemeBreakType=fe;function ge(se,he){return se===0?he!==5&&he!==7:se===2&&he===3?!1:se===4||se===2||se===3||he===4||he===2||he===3?!0:!(se===8&&(he===8||he===9||he===11||he===12)||(se===11||se===9)&&(he===9||he===10)||(se===12||se===10)&&he===10||he===5||he===13||he===7||se===1||se===13&&he===14||se===6&&he===6)}var Ie;(function(se){se[se.Other=0]="Other",se[se.Prepend=1]="Prepend",se[se.CR=2]="CR",se[se.LF=3]="LF",se[se.Control=4]="Control",se[se.Extend=5]="Extend",se[se.Regional_Indicator=6]="Regional_Indicator",se[se.SpacingMark=7]="SpacingMark",se[se.L=8]="L",se[se.V=9]="V",se[se.T=10]="T",se[se.LV=11]="LV",se[se.LVT=12]="LVT",se[se.ZWJ=13]="ZWJ",se[se.Extended_Pictographic=14]="Extended_Pictographic"})(Ie||(e.GraphemeBreakType=Ie={}));class Pe{static getInstance(){return Pe.c||(Pe.c=new Pe),Pe.c}constructor(){this.d=Fe()}getGraphemeBreakType(he){if(he<32)return he===10?3:he===13?2:4;if(he<127)return 0;const me=this.d,pe=me.length/3;let we=1;for(;we<=pe;)if(he<me[3*we])we=2*we;else if(he>me[3*we+1])we=2*we+1;else return me[3*we+2];return 0}}Pe.c=null;function Fe(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Le(se,he){if(se===0)return 0;const me=ze(se,he);if(me!==void 0)return me;const pe=new x(he,se);return pe.prevCodePoint(),pe.offset}e.getLeftDeleteOffset=Le;function ze(se,he){const me=new x(he,se);let pe=me.prevCodePoint();for(;Ne(pe)||pe===65039||pe===8419;){if(me.offset===0)return;pe=me.prevCodePoint()}if(!ee(pe))return;let we=me.offset;return we>0&&me.prevCodePoint()===8205&&(we=me.offset),we}function Ne(se){return 127995<=se&&se<=127999}var je;(function(se){se[se.zwj=8205]="zwj",se[se.emojiVariantSelector=65039]="emojiVariantSelector",se[se.enclosingKeyCap=8419]="enclosingKeyCap"})(je||(je={})),e.noBreakWhitespace="\xA0";class Me{static getInstance(he){return Me.d.get(Array.from(he))}static getLocales(){return Me.e.value}constructor(he){this.f=he}isAmbiguous(he){return this.f.has(he)}getPrimaryConfusable(he){return this.f.get(he)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=Me,l=Me,Me.c=new N.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Me.d=new A.LRUCachedFunction(se=>{function he(Oe){const $e=new Map;for(let xe=0;xe<Oe.length;xe+=2)$e.set(Oe[xe],Oe[xe+1]);return $e}function me(Oe,$e){const xe=new Map(Oe);for(const[et,nt]of $e)xe.set(et,nt);return xe}function pe(Oe,$e){if(!Oe)return $e;const xe=new Map;for(const[et,nt]of Oe)$e.has(et)&&xe.set(et,nt);return xe}const we=l.c.value;let Ce=se.filter(Oe=>!Oe.startsWith("_")&&Oe in we);Ce.length===0&&(Ce=["_default"]);let De;for(const Oe of Ce){const $e=he(we[Oe]);De=pe(De,$e)}const Te=he(we._common),qe=me(Te,De);return new Me(qe)}),Me.e=new N.Lazy(()=>Object.keys(Me.c.value).filter(se=>!se.startsWith("_")));class Ae{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ae.c())),this.d}static isInvisibleCharacter(he){return Ae.e().has(he)}static get codePoints(){return Ae.e()}}e.InvisibleCharacters=Ae,Ae.d=void 0}),define(oe[47],ae([0,1,14,4,27,11]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function T(o){return o===47||o===92}e.isPathSeparator=T;function k(o){return o.replace(/[\\/]/g,A.posix.sep)}e.toSlashes=k;function I(o){return o.indexOf("/")===-1&&(o=k(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=I;function v(o,c=A.posix.sep){if(!o)return"";const y=o.length,w=o.charCodeAt(0);if(T(w)){if(T(o.charCodeAt(1))&&!T(o.charCodeAt(2))){let P=3;const D=P;for(;P<y&&!T(o.charCodeAt(P));P++);if(D!==P&&!T(o.charCodeAt(P+1))){for(P+=1;P<y;P++)if(T(o.charCodeAt(P)))return o.slice(0,P+1).replace(/[\\/]/g,c)}}return c}else if(h(w)&&o.charCodeAt(1)===58)return T(o.charCodeAt(2))?o.slice(0,2)+c:o.slice(0,2);let f=o.indexOf("://");if(f!==-1){for(f+=3;f<y;f++)if(T(o.charCodeAt(f)))return o.slice(0,f+1)}return""}e.getRoot=v;function R(o){if(!N.isWindows||!o||o.length<5)return!1;let c=o.charCodeAt(0);if(c!==92||(c=o.charCodeAt(1),c!==92))return!1;let y=2;const w=y;for(;y<o.length&&(c=o.charCodeAt(y),c!==92);y++);return!(w===y||(c=o.charCodeAt(y+1),isNaN(c)||c===92))}e.isUNC=R;const b=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,g=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(o,c=N.isWindows){const y=c?b:m;return!(!o||o.length===0||/^\s+$/.test(o)||(y.lastIndex=0,y.test(o))||c&&g.test(o)||o==="."||o===".."||c&&o[o.length-1]==="."||c&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=p;function E(o,c,y){const w=o===c;return!y||w?w:!o||!c?!1:(0,l.equalsIgnoreCase)(o,c)}e.isEqual=E;function a(o,c,y,w=A.sep){if(o===c)return!0;if(!o||!c||c.length>o.length)return!1;if(y){if(!(0,l.startsWithIgnoreCase)(o,c))return!1;if(c.length===o.length)return!0;let P=c.length;return c.charAt(c.length-1)===w&&P--,o.charAt(P)===w}return c.charAt(c.length-1)!==w&&(c+=w),o.indexOf(c)===0}e.isEqualOrParent=a;function h(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=h;function u(o,c){return N.isWindows&&o.endsWith(":")&&(o+=A.sep),(0,A.isAbsolute)(o)||(o=(0,A.join)(c,o)),o=(0,A.normalize)(o),N.isWindows?(o=(0,l.rtrim)(o,A.sep),o.endsWith(":")&&(o+=A.sep)):(o=(0,l.rtrim)(o,A.sep),o||(o=A.sep)),o}e.sanitizeFilePath=u;function d(o){const c=(0,A.normalize)(o);return N.isWindows?o.length>3?!1:S(c)&&(o.length===2||c.charCodeAt(2)===92):c===A.posix.sep}e.isRootOrDriveLetter=d;function S(o,c=N.isWindows){return c?h(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=S;function L(o){return S(o)?o[0]:void 0}e.getDriveLetter=L;function n(o,c,y){return c.length>o.length?-1:o===c?0:(y&&(o=o.toLowerCase(),c=c.toLowerCase()),o.indexOf(c))}e.indexOfPath=n;function r(o){const c=o.split(":");let y,w,f;for(const P of c){const D=Number(P);(0,O.isNumber)(D)?w===void 0?w=D:f===void 0&&(f=D):y=y?[y,P].join(":"):P}if(!y)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:y,line:w!==void 0?w:void 0,column:f!==void 0?f:w!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",i="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function s(o,c,y=8){let w="";for(let P=0;P<y;P++){let D;P===0&&N.isWindows&&!c&&(y===3||y===4)?D=i:D=t,w+=D.charAt(Math.floor(Math.random()*D.length))}let f;return c?f=`${c}-${w}`:f=w,o?(0,A.join)(o,f):f}e.randomPath=s}),define(oe[65],ae([0,1,27]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function N(h){return l(h,0)}e.hash=N;function l(h,u){switch(typeof h){case"object":return h===null?O(349,u):Array.isArray(h)?I(h,u):v(h,u);case"string":return k(h,u);case"boolean":return T(h,u);case"number":return O(h,u);case"undefined":return O(937,u);default:return O(617,u)}}e.doHash=l;function O(h,u){return(u<<5)-u+h|0}e.numberHash=O;function T(h,u){return O(h?433:863,u)}function k(h,u){u=O(149417,u);for(let d=0,S=h.length;d<S;d++)u=O(h.charCodeAt(d),u);return u}e.stringHash=k;function I(h,u){return u=O(104579,u),h.reduce((d,S)=>l(S,d),u)}function v(h,u){return u=O(181387,u),Object.keys(h).sort().reduce((d,S)=>(d=k(S,d),l(h[S],d)),u)}class R{constructor(){this.g=0}get value(){return this.g}hash(u){return this.g=l(u,this.g),this.g}}e.Hasher=R;var b;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function m(h,u,d=32){const S=d-u,L=~((1<<S)-1);return(h<<u|(L&h)>>>S)>>>0}function g(h,u=0,d=h.byteLength,S=0){for(let L=0;L<d;L++)h[u+L]=S}function p(h,u,d="0"){for(;h.length<u;)h=d+h;return h}function E(h,u=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(d=>d.toString(16).padStart(2,"0")).join(""):p((h>>>0).toString(16),u/4)}e.toHexString=E;class a{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(u){const d=u.length;if(d===0)return;const S=this.p;let L=this.r,n=this.u,r,t;for(n!==0?(r=n,t=-1,n=0):(r=u.charCodeAt(0),t=0);;){let i=r;if(A.isHighSurrogate(r))if(t+1<d){const s=u.charCodeAt(t+1);A.isLowSurrogate(s)?(t++,i=A.computeCodePoint(r,s)):i=65533}else{n=r;break}else A.isLowSurrogate(r)&&(i=65533);if(L=this.w(S,L,i),t++,t<d)r=u.charCodeAt(t);else break}this.r=L,this.u=n}w(u,d,S){return S<128?u[d++]=S:S<2048?(u[d++]=192|(S&1984)>>>6,u[d++]=128|(S&63)>>>0):S<65536?(u[d++]=224|(S&61440)>>>12,u[d++]=128|(S&4032)>>>6,u[d++]=128|(S&63)>>>0):(u[d++]=240|(S&1835008)>>>18,u[d++]=128|(S&258048)>>>12,u[d++]=128|(S&4032)>>>6,u[d++]=128|(S&63)>>>0),d>=64&&(this.y(),d-=64,this.t+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),d}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),E(this.h)+E(this.l)+E(this.m)+E(this.n)+E(this.o)}x(){this.p[this.r++]=128,g(this.p,this.r),this.r>56&&(this.y(),g(this.p));const u=8*this.t;this.q.setUint32(56,Math.floor(u/4294967296),!1),this.q.setUint32(60,u%4294967296,!1),this.y()}y(){const u=a.g,d=this.q;for(let c=0;c<64;c+=4)u.setUint32(c,d.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)u.setUint32(c,m(u.getUint32(c-12,!1)^u.getUint32(c-32,!1)^u.getUint32(c-56,!1)^u.getUint32(c-64,!1),1),!1);let S=this.h,L=this.l,n=this.m,r=this.n,t=this.o,i,s,o;for(let c=0;c<80;c++)c<20?(i=L&n|~L&r,s=1518500249):c<40?(i=L^n^r,s=1859775393):c<60?(i=L&n|L&r|n&r,s=2400959708):(i=L^n^r,s=3395469782),o=m(S,5)+i+t+s+u.getUint32(c*4,!1)&4294967295,t=r,r=n,n=m(L,30),L=S,S=o;this.h=this.h+S&4294967295,this.l=this.l+L&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+t&4294967295}}e.StringSHA1=a,a.g=new DataView(new ArrayBuffer(320))}),define(oe[90],ae([0,1,27]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(N||(N={})),function(l){const O="error",T="warning",k="warn",I="info",v="ignore";function R(m){return m?A.equalsIgnoreCase(O,m)?l.Error:A.equalsIgnoreCase(T,m)||A.equalsIgnoreCase(k,m)?l.Warning:A.equalsIgnoreCase(I,m)?l.Info:l.Ignore:l.Ignore}l.fromValue=R;function b(m){switch(m){case l.Error:return O;case l.Warning:return T;case l.Info:return I;default:return v}}l.toString=b}(N||(N={})),e.default=N}),define(oe[48],ae([0,1,21,27]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(g){return this.b=g,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(g){const p=g.charCodeAt(0),E=this.b.charCodeAt(this.c);return p-E}value(){return this.b[this.c]}}e.StringIterator=l;class O{constructor(g=!0){this.e=g}reset(g){return this.b=g,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let g=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(g)this.c++;else break;else g=!1;return this}cmp(g){return this.e?(0,N.compareSubstring)(g,this.b,0,g.length,this.c,this.d):(0,N.compareSubstringIgnoreCase)(g,this.b,0,g.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=O;class T{constructor(g=!0,p=!0){this.f=g,this.g=p}reset(g){this.d=0,this.e=0,this.b=g,this.c=g.length;for(let p=g.length-1;p>=0;p--,this.c--){const E=this.b.charCodeAt(p);if(!(E===47||this.f&&E===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let g=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(g)this.d++;else break;else g=!1}return this}cmp(g){return this.g?(0,N.compareSubstring)(g,this.b,0,g.length,this.d,this.e):(0,N.compareSubstringIgnoreCase)(g,this.b,0,g.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=T;var k;(function(m){m[m.Scheme=1]="Scheme",m[m.Authority=2]="Authority",m[m.Path=3]="Path",m[m.Query=4]="Query",m[m.Fragment=5]="Fragment"})(k||(k={}));class I{constructor(g,p){this.f=g,this.g=p,this.d=[],this.e=0}reset(g){return this.c=g,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new T(!1,!this.f(g)),this.b.reset(g.path),this.b.value()&&this.d.push(3)),this.g(g)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(g){if(this.d[this.e]===1)return(0,N.compareIgnoreCase)(g,this.c.scheme);if(this.d[this.e]===2)return(0,N.compareIgnoreCase)(g,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(g);if(this.d[this.e]===4)return(0,N.compare)(g,this.c.query);if(this.d[this.e]===5)return(0,N.compare)(g,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=I;class v{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const g=this.right;return this.right=g.left,g.left=this,this.updateHeight(),g.updateHeight(),g}rotateRight(){const g=this.left;return this.left=g.right,g.right=this,this.updateHeight(),g.updateHeight(),g}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var R;(function(m){m[m.Left=-1]="Left",m[m.Mid=0]="Mid",m[m.Right=1]="Right"})(R||(R={}));class b{static forUris(g=()=>!1,p=()=>!1){return new b(new I(g,p))}static forPaths(g=!1){return new b(new T(void 0,!g))}static forStrings(){return new b(new l)}static forConfigKeys(){return new b(new O)}constructor(g){this.b=g}clear(){this.c=void 0}fill(g,p){if(p){const E=p.slice(0);(0,A.shuffle)(E);for(const a of E)this.set(a,g)}else{const E=g.slice(0);(0,A.shuffle)(E);for(const a of E)this.set(a[0],a[1])}}set(g,p){const E=this.b.reset(g);let a;this.c||(this.c=new v,this.c.segment=E.value());const h=[];for(a=this.c;;){const d=E.cmp(a.segment);if(d>0)a.left||(a.left=new v,a.left.segment=E.value()),h.push([-1,a]),a=a.left;else if(d<0)a.right||(a.right=new v,a.right.segment=E.value()),h.push([1,a]),a=a.right;else if(E.hasNext())E.next(),a.mid||(a.mid=new v,a.mid.segment=E.value()),h.push([0,a]),a=a.mid;else break}const u=a.value;a.value=p,a.key=g;for(let d=h.length-1;d>=0;d--){const S=h[d][1];S.updateHeight();const L=S.balanceFactor();if(L<-1||L>1){const n=h[d][0],r=h[d+1][0];if(n===1&&r===1)h[d][1]=S.rotateLeft();else if(n===-1&&r===-1)h[d][1]=S.rotateRight();else if(n===1&&r===-1)S.right=h[d+1][1]=h[d+1][1].rotateRight(),h[d][1]=S.rotateLeft();else if(n===-1&&r===1)S.left=h[d+1][1]=h[d+1][1].rotateLeft(),h[d][1]=S.rotateRight();else throw new Error;if(d>0)switch(h[d-1][0]){case-1:h[d-1][1].left=h[d][1];break;case 1:h[d-1][1].right=h[d][1];break;case 0:h[d-1][1].mid=h[d][1];break}else this.c=h[0][1]}}return u}get(g){return this.d(g)?.value}d(g){const p=this.b.reset(g);let E=this.c;for(;E;){const a=p.cmp(E.segment);if(a>0)E=E.left;else if(a<0)E=E.right;else if(p.hasNext())p.next(),E=E.mid;else break}return E}has(g){const p=this.d(g);return!(p?.value===void 0&&p?.mid===void 0)}delete(g){return this.e(g,!1)}deleteSuperstr(g){return this.e(g,!0)}e(g,p){const E=this.b.reset(g),a=[];let h=this.c;for(;h;){const u=E.cmp(h.segment);if(u>0)a.push([-1,h]),h=h.left;else if(u<0)a.push([1,h]),h=h.right;else if(E.hasNext())E.next(),a.push([0,h]),h=h.mid;else break}if(h){if(p?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const u=this.f(h.right);if(u.key){const{key:d,value:S,segment:L}=u;this.e(u.key,!1),h.key=d,h.value=S,h.segment=L}}else{const u=h.left??h.right;if(a.length>0){const[d,S]=a[a.length-1];switch(d){case-1:S.left=u;break;case 0:S.mid=u;break;case 1:S.right=u;break}}else this.c=u}for(let u=a.length-1;u>=0;u--){const d=a[u][1];d.updateHeight();const S=d.balanceFactor();if(S>1?(d.right.balanceFactor()>=0||(d.right=d.right.rotateRight()),a[u][1]=d.rotateLeft()):S<-1&&(d.left.balanceFactor()<=0||(d.left=d.left.rotateLeft()),a[u][1]=d.rotateRight()),u>0)switch(a[u-1][0]){case-1:a[u-1][1].left=a[u][1];break;case 1:a[u-1][1].right=a[u][1];break;case 0:a[u-1][1].mid=a[u][1];break}else this.c=a[0][1]}}}f(g){for(;g.left;)g=g.left;return g}findSubstr(g){const p=this.b.reset(g);let E=this.c,a;for(;E;){const h=p.cmp(E.segment);if(h>0)E=E.left;else if(h<0)E=E.right;else if(p.hasNext())p.next(),a=E.value||a,E=E.mid;else break}return E&&E.value||a}findSuperstr(g){return this.g(g,!1)}g(g,p){const E=this.b.reset(g);let a=this.c;for(;a;){const h=E.cmp(a.segment);if(h>0)a=a.left;else if(h<0)a=a.right;else if(E.hasNext())E.next(),a=a.mid;else return a.mid?this.h(a.mid):p?a.value:void 0}}hasElementOrSubtree(g){return this.g(g,!0)!==void 0}forEach(g){for(const[p,E]of this)g(E,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(g){const p=[];return this.j(g,p),p[Symbol.iterator]()}j(g,p){g&&(g.left&&this.j(g.left,p),g.value&&p.push([g.key,g.value]),g.mid&&this.j(g.mid,p),g.right&&this.j(g.right,p))}_isBalanced(){const g=p=>{if(!p)return!0;const E=p.balanceFactor();return E<-1||E>1?!1:g(p.left)&&g(p.right)};return g(this.c)}}e.TernarySearchTree=b}),define(oe[12],ae([0,1,14,4]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,O=/^\//,T=/^\/\//;function k(t,i){if(!t.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!l.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!O.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(T.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function I(t,i){return!t&&!i?"file":t}function v(t,i){switch(t){case"https":case"http":case"file":i?i[0]!==b&&(i=b+i):i=b;break}return i}const R="",b="/",m=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class g{static isUri(i){return i instanceof g?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}constructor(i,s,o,c,y,w=!1){typeof i=="object"?(this.scheme=i.scheme||R,this.authority=i.authority||R,this.path=i.path||R,this.query=i.query||R,this.fragment=i.fragment||R):(this.scheme=I(i,w),this.authority=s||R,this.path=v(this.scheme,o||R),this.query=c||R,this.fragment=y||R,k(this,w))}get fsPath(){return d(this,!1)}with(i){if(!i)return this;let{scheme:s,authority:o,path:c,query:y,fragment:w}=i;return s===void 0?s=this.scheme:s===null&&(s=R),o===void 0?o=this.authority:o===null&&(o=R),c===void 0?c=this.path:c===null&&(c=R),y===void 0?y=this.query:y===null&&(y=R),w===void 0?w=this.fragment:w===null&&(w=R),s===this.scheme&&o===this.authority&&c===this.path&&y===this.query&&w===this.fragment?this:new E(s,o,c,y,w)}static parse(i,s=!1){const o=m.exec(i);return o?new E(o[2]||R,r(o[4]||R),r(o[5]||R),r(o[7]||R),r(o[9]||R),s):new E(R,R,R,R,R)}static file(i){let s=R;if(N.isWindows&&(i=i.replace(/\\/g,b)),i[0]===b&&i[1]===b){const o=i.indexOf(b,2);o===-1?(s=i.substring(2),i=b):(s=i.substring(2,o),i=i.substring(o)||b)}return new E("file",s,i,R,R)}static from(i){const s=new E(i.scheme,i.authority,i.path,i.query,i.fragment);return k(s,!0),s}static joinPath(i,...s){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let o;return N.isWindows&&i.scheme==="file"?o=g.file(A.win32.join(d(i,!0),...s)).path:o=A.posix.join(i.path,...s),i.with({path:o})}toString(i=!1){return S(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof g)return i;{const s=new E(i);return s._formatted=i.external,s._fsPath=i._sep===p?i.fsPath:null,s}}else return i}}e.URI=g;const p=N.isWindows?1:void 0;class E extends g{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=d(this,!1)),this._fsPath}toString(i=!1){return i?S(this,!0):(this._formatted||(this._formatted=S(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=p),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const a={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(t,i,s){let o,c=-1;for(let y=0;y<t.length;y++){const w=t.charCodeAt(y);if(w>=97&&w<=122||w>=65&&w<=90||w>=48&&w<=57||w===45||w===46||w===95||w===126||i&&w===47||s&&w===91||s&&w===93||s&&w===58)c!==-1&&(o+=encodeURIComponent(t.substring(c,y)),c=-1),o!==void 0&&(o+=t.charAt(y));else{o===void 0&&(o=t.substr(0,y));const f=a[w];f!==void 0?(c!==-1&&(o+=encodeURIComponent(t.substring(c,y)),c=-1),o+=f):c===-1&&(c=y)}}return c!==-1&&(o+=encodeURIComponent(t.substring(c))),o!==void 0?o:t}function u(t){let i;for(let s=0;s<t.length;s++){const o=t.charCodeAt(s);o===35||o===63?(i===void 0&&(i=t.substr(0,s)),i+=a[o]):i!==void 0&&(i+=t[s])}return i!==void 0?i:t}function d(t,i){let s;return t.authority&&t.path.length>1&&t.scheme==="file"?s=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?i?s=t.path.substr(1):s=t.path[1].toLowerCase()+t.path.substr(2):s=t.path,N.isWindows&&(s=s.replace(/\//g,"\\")),s}e.uriToFsPath=d;function S(t,i){const s=i?u:h;let o="",{scheme:c,authority:y,path:w,query:f,fragment:P}=t;if(c&&(o+=c,o+=":"),(y||c==="file")&&(o+=b,o+=b),y){let D=y.indexOf("@");if(D!==-1){const M=y.substr(0,D);y=y.substr(D+1),D=M.lastIndexOf(":"),D===-1?o+=s(M,!1,!1):(o+=s(M.substr(0,D),!1,!1),o+=":",o+=s(M.substr(D+1),!1,!0)),o+="@"}y=y.toLowerCase(),D=y.lastIndexOf(":"),D===-1?o+=s(y,!1,!0):(o+=s(y.substr(0,D),!1,!0),o+=y.substr(D))}if(w){if(w.length>=3&&w.charCodeAt(0)===47&&w.charCodeAt(2)===58){const D=w.charCodeAt(1);D>=65&&D<=90&&(w=`/${String.fromCharCode(D+32)}:${w.substr(3)}`)}else if(w.length>=2&&w.charCodeAt(1)===58){const D=w.charCodeAt(0);D>=65&&D<=90&&(w=`${String.fromCharCode(D+32)}:${w.substr(2)}`)}o+=s(w,!0,!1)}return f&&(o+="?",o+=s(f,!1,!1)),P&&(o+="#",o+=i?P:h(P,!1,!1)),o}function L(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+L(t.substr(3)):t}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(n)?t.replace(n,i=>L(i)):t}}),define(oe[143],ae([0,1,12]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function N(v){const R=v;return R&&typeof R.type=="string"&&typeof R.severity=="string"}e.isRemoteConsoleLog=N;function l(v){const R=[];let b;try{const m=JSON.parse(v.arguments),g=m[m.length-1];g&&g.__$stack&&(m.pop(),b=g.__$stack),R.push(...m)}catch{R.push("Unable to log remote console arguments",v.arguments)}return{args:R,stack:b}}e.parse=l;function O(v){if(typeof v!="string")return O(l(v).stack);const R=v;if(R){const b=T(R),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(m&&m.length===4)return{uri:A.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}e.getFirstFrame=O;function T(v){if(!v)return v;const R=v.indexOf(`
`);return R===-1?v:v.substring(0,R)}function k(v,R){const{args:b,stack:m}=l(v),g=typeof b[0]=="string"&&b.length===1;let p=T(m);p&&(p=`(${p.trim()})`);let E=[];if(typeof b[0]=="string"?p&&g?E=[`%c[${R}] %c${b[0]} %c${p}`,I("blue"),I(""),I("grey")]:E=[`%c[${R}] %c${b[0]}`,I("blue"),I(""),...b.slice(1)]:E=[`%c[${R}]%`,I("blue"),...b],p&&!g&&E.push(p),typeof console[v.severity]!="function")throw new Error("Unknown console method");console[v.severity].apply(console,E)}e.log=k;function I(v){return`color: ${v}`}}),define(oe[91],ae([0,1,16,27,12]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function O(v){return JSON.stringify(v,k)}e.stringify=O;function T(v){let R=JSON.parse(v);return R=I(R),R}e.parse=T;function k(v,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,N.regExpFlags)(R)}:R}function I(v,R=0){if(!v||R>200)return v;if(typeof v=="object"){switch(v.$mid){case 1:return l.URI.revive(v);case 2:return new RegExp(v.source,v.flags);case 16:return new Date(v.source)}if(v instanceof A.VSBuffer||v instanceof Uint8Array)return v;if(Array.isArray(v))for(let b=0;b<v.length;++b)v[b]=I(v[b],R+1);else for(const b in v)Object.hasOwnProperty.call(v,b)&&(v[b]=I(v[b],R+1))}return v}e.revive=I}),define(oe[24],ae([0,1,9,4,12]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var O;(function(v){v.inMemory="inmemory",v.vscode="vscode",v.internal="private",v.walkThrough="walkThrough",v.walkThroughSnippet="walkThroughSnippet",v.http="http",v.https="https",v.file="file",v.mailto="mailto",v.untitled="untitled",v.data="data",v.command="command",v.vscodeRemote="vscode-remote",v.vscodeRemoteResource="vscode-remote-resource",v.vscodeUserData="vscode-userdata",v.vscodeCustomEditor="vscode-custom-editor",v.vscodeNotebookCell="vscode-notebook-cell",v.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",v.vscodeNotebookCellOutput="vscode-notebook-cell-output",v.vscodeInteractive="vscode-interactive",v.vscodeInteractiveInput="vscode-interactive-input",v.vscodeSettings="vscode-settings",v.vscodeWorkspaceTrust="vscode-workspace-trust",v.vscodeTerminal="vscode-terminal",v.vscodeInteractiveSesssion="vscode-chat-editor",v.webviewPanel="webview-panel",v.vscodeWebview="vscode-webview",v.extension="extension",v.vscodeFileResource="vscode-file",v.tmp="tmp",v.vsls="vsls",v.vscodeSourceControl="vscode-scm"})(O||(e.Schemas=O={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class T{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${O.vscodeRemoteResource}`}setPreferredWebSchema(R){this.d=R}setDelegate(R){this.e=R}setServerRootPath(R){this.f=`${R}/${O.vscodeRemoteResource}`}set(R,b,m){this.a[R]=b,this.b[R]=m}setConnectionToken(R,b){this.c[R]=b}getPreferredWebSchema(){return this.d}rewrite(R){if(this.e)try{return this.e(R)}catch(a){return A.onUnexpectedError(a),R}const b=R.authority;let m=this.a[b];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const g=this.b[b],p=this.c[b];let E=`path=${encodeURIComponent(R.path)}`;return typeof p=="string"&&(E+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),l.URI.from({scheme:N.isWeb?this.d:O.vscodeRemoteResource,authority:`${m}:${g}`,path:this.f,query:E})}}e.RemoteAuthorities=new T,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class k{asBrowserUri(R){const b=this.b(R,ie);return this.uriToBrowserUri(b)}uriToBrowserUri(R){return R.scheme===O.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===O.file&&(N.isNative||N.isWebWorker&&N.globals.origin===`${O.vscodeFileResource}://${k.a}`)?R.with({scheme:O.vscodeFileResource,authority:R.authority||k.a,query:null,fragment:null}):R}asFileUri(R){const b=this.b(R,ie);return this.uriToFileUri(b)}uriToFileUri(R){return R.scheme===O.vscodeFileResource?R.with({scheme:O.file,authority:R.authority!==k.a?R.authority:null,query:null,fragment:null}):R}b(R,b){return l.URI.isUri(R)?R:l.URI.parse(b.toUrl(R))}}k.a="vscode-app",e.FileAccess=new k;var I;(function(v){const R=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);v.CoopAndCoep=Object.freeze(R.get("3"));const b="vscode-coi";function m(p){let E;typeof p=="string"?E=new URL(p).searchParams:p instanceof URL?E=p.searchParams:l.URI.isUri(p)&&(E=new URL(p.toString(!0)).searchParams);const a=E?.get(b);if(a)return R.get(a)}v.getHeadersFromQuery=m;function g(p,E,a){if(!globalThis.crossOriginIsolated)return;const h=E&&a?"3":a?"2":"1";p instanceof URLSearchParams?p.set(b,h):p[b]=h}v.addSearchParam=g})(I||(e.COI=I={}))}),define(oe[22],ae([0,1,47,24,14,4,27,12]),function(ie,e,A,N,l,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function I(g){return(0,k.uriToFsPath)(g,!0)}e.originalFSPath=I;class v{constructor(p){this.a=p}compare(p,E,a=!1){return p===E?0:(0,T.compare)(this.getComparisonKey(p,a),this.getComparisonKey(E,a))}isEqual(p,E,a=!1){return p===E?!0:!p||!E?!1:this.getComparisonKey(p,a)===this.getComparisonKey(E,a)}getComparisonKey(p,E=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:E?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,E,a=!1){if(p.scheme===E.scheme){if(p.scheme===N.Schemas.file)return A.isEqualOrParent(I(p),I(E),this.a(p))&&p.query===E.query&&(a||p.fragment===E.fragment);if((0,e.isEqualAuthority)(p.authority,E.authority))return A.isEqualOrParent(p.path,E.path,this.a(p),"/")&&p.query===E.query&&(a||p.fragment===E.fragment)}return!1}joinPath(p,...E){return k.URI.joinPath(p,...E)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return l.posix.basename(p.path)}extname(p){return l.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let E;return p.scheme===N.Schemas.file?E=k.URI.file(l.dirname(I(p))).path:(E=l.posix.dirname(p.path),p.authority&&E.length&&E.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),E="/")),p.with({path:E})}normalizePath(p){if(!p.path.length)return p;let E;return p.scheme===N.Schemas.file?E=k.URI.file(l.normalize(I(p))).path:E=l.posix.normalize(p.path),p.with({path:E})}relativePath(p,E){if(p.scheme!==E.scheme||!(0,e.isEqualAuthority)(p.authority,E.authority))return;if(p.scheme===N.Schemas.file){const u=l.relative(I(p),I(E));return O.isWindows?A.toSlashes(u):u}let a=p.path||"/";const h=E.path||"/";if(this.a(p)){let u=0;for(const d=Math.min(a.length,h.length);u<d&&!(a.charCodeAt(u)!==h.charCodeAt(u)&&a.charAt(u).toLowerCase()!==h.charAt(u).toLowerCase());u++);a=h.substr(0,u)+a.substr(u)}return l.posix.relative(a,h)}resolvePath(p,E){if(p.scheme===N.Schemas.file){const a=k.URI.file(l.resolve(I(p),E));return p.with({authority:a.authority,path:a.path})}return E=A.toPosixPath(E),p.with({path:l.posix.resolve(p.path,E)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,E){return p===E||p!==void 0&&E!==void 0&&(0,T.equalsIgnoreCase)(p,E)}hasTrailingPathSeparator(p,E=l.sep){if(p.scheme===N.Schemas.file){const a=I(p);return a.length>A.getRoot(a).length&&a[a.length-1]===E}else{const a=p.path;return a.length>1&&a.charCodeAt(a.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,E=l.sep){return(0,e.hasTrailingPathSeparator)(p,E)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,E=l.sep){let a=!1;if(p.scheme===N.Schemas.file){const h=I(p);a=h!==void 0&&h.length===A.getRoot(h).length&&h[h.length-1]===E}else{E="/";const h=p.path;a=h.length===1&&h.charCodeAt(h.length-1)===47}return!a&&!(0,e.hasTrailingPathSeparator)(p,E)?p.with({path:p.path+"/"}):p}}e.ExtUri=v,e.extUri=new v(()=>!1),e.extUriBiasedIgnorePathCase=new v(g=>g.scheme===N.Schemas.file?!O.isLinux:!0),e.extUriIgnorePathCase=new v(g=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(g,p){const E=[];for(let a=0;a<g.length;a++){const h=p(g[a]);g.some((u,d)=>d===a?!1:(0,e.isEqualOrParent)(h,p(u)))||E.push(g[a])}return E}e.distinctParents=R;var b;(function(g){g.META_DATA_LABEL="label",g.META_DATA_DESCRIPTION="description",g.META_DATA_SIZE="size",g.META_DATA_MIME="mime";function p(E){const a=new Map;E.path.substring(E.path.indexOf(";")+1,E.path.lastIndexOf(";")).split(";").forEach(d=>{const[S,L]=d.split(":");S&&L&&a.set(S,L)});const u=E.path.substring(0,E.path.indexOf(";"));return u&&a.set(g.META_DATA_MIME,u),a}g.parseMetaData=p})(b||(e.DataUri=b={}));function m(g,p,E){if(p){let a=g.path;return a&&a[0]!==l.posix.sep&&(a=l.posix.sep+a),g.with({scheme:E,authority:p,path:a})}return g.with({scheme:E})}e.toLocalResource=m}),define(oe[6],ae([0,1,26,9,3,2,22,4,131]),function(ie,e,A,N,l,O,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function v(K){return!!K&&typeof K.then=="function"}e.isThenable=v;function R(K){const F=new A.CancellationTokenSource,C=K(F.token),U=new Promise((q,G)=>{const V=F.token.onCancellationRequested(()=>{V.dispose(),F.dispose(),G(new N.CancellationError)});Promise.resolve(C).then(Z=>{V.dispose(),F.dispose(),q(Z)},Z=>{V.dispose(),F.dispose(),G(Z)})});return new class{cancel(){F.cancel()}then(q,G){return U.then(q,G)}catch(q){return this.then(void 0,q)}finally(q){return U.finally(q)}}}e.createCancelablePromise=R;function b(K,F,C){return new Promise((U,q)=>{const G=F.onCancellationRequested(()=>{G.dispose(),U(C)});K.then(U,q).finally(()=>G.dispose())})}e.raceCancellation=b;function m(K,F){return new Promise((C,U)=>{const q=F.onCancellationRequested(()=>{q.dispose(),U(new N.CancellationError)});K.then(C,U).finally(()=>q.dispose())})}e.raceCancellationError=m;async function g(K){let F=-1;const C=K.map((U,q)=>U.then(G=>(F=q,G)));try{return await Promise.race(C)}finally{K.forEach((U,q)=>{q!==F&&U.cancel()})}}e.raceCancellablePromises=g;function p(K,F,C){let U;const q=setTimeout(()=>{U?.(void 0),C?.()},F);return Promise.race([K.finally(()=>clearTimeout(q)),new Promise(G=>U=G)])}e.raceTimeout=p;function E(K){return new Promise((F,C)=>{const U=K();v(U)?U.then(F,C):F(U)})}e.asPromise=E;class a{constructor(){this.a=null,this.b=null,this.d=null}queue(F){if(this.a){if(this.d=F,!this.b){const C=()=>{this.b=null;const U=this.queue(this.d);return this.d=null,U};this.b=new Promise(U=>{this.a.then(C,C).then(U)})}return new Promise((C,U)=>{this.b.then(C,U)})}return this.a=F(),new Promise((C,U)=>{this.a.then(q=>{this.a=null,C(q)},q=>{this.a=null,U(q)})})}}e.Throttler=a;class h{constructor(){this.a=Promise.resolve(null)}queue(F){return this.a=this.a.then(()=>F(),()=>F())}}e.Sequencer=h;class u{constructor(){this.a=new Map}queue(F,C){const q=(this.a.get(F)??Promise.resolve()).catch(()=>{}).then(C).finally(()=>{this.a.get(F)===q&&this.a.delete(F)});return this.a.set(F,q),q}}e.SequencerByKey=u;const d=(K,F)=>{let C=!0;const U=setTimeout(()=>{C=!1,F()},K);return{isTriggered:()=>C,dispose:()=>{clearTimeout(U),C=!1}}},S=K=>{let F=!0;return queueMicrotask(()=>{F&&(F=!1,K())}),{isTriggered:()=>F,dispose:()=>{F=!1}}};class L{constructor(F){this.defaultDelay=F,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(F,C=this.defaultDelay){this.g=F,this.h(),this.b||(this.b=new Promise((q,G)=>{this.d=q,this.f=G}).then(()=>{if(this.b=null,this.d=null,this.g){const q=this.g;return this.g=null,q()}}));const U=()=>{this.a=null,this.d?.(null)};return this.a=C===I.MicrotaskDelay?S(U):d(C,U),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=L;class n{constructor(F){this.a=new L(F),this.b=new a}trigger(F,C){return this.a.trigger(()=>this.b.queue(F),C)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=n;class r{constructor(){this.a=!1,this.b=new Promise((F,C)=>{this.d=F})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=r;class t extends r{constructor(F){super(),this.f=setTimeout(()=>this.open(),F)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=t;function i(K,F){return F?new Promise((C,U)=>{const q=setTimeout(()=>{G.dispose(),C()},K),G=F.onCancellationRequested(()=>{clearTimeout(q),G.dispose(),U(new N.CancellationError)})}):R(C=>i(K,C))}e.timeout=i;function s(K,F=0){const C=setTimeout(K,F);return(0,O.toDisposable)(()=>clearTimeout(C))}e.disposableTimeout=s;function o(K){const F=[];let C=0;const U=K.length;function q(){return C<U?K[C++]():null}function G(V){V!=null&&F.push(V);const Z=q();return Z?Z.then(G):Promise.resolve(F)}return Promise.resolve(null).then(G)}e.sequence=o;function c(K,F=U=>!!U,C=null){let U=0;const q=K.length,G=()=>{if(U>=q)return Promise.resolve(C);const V=K[U++];return Promise.resolve(V()).then(ee=>F(ee)?Promise.resolve(ee):G())};return G()}e.first=c;function y(K,F=U=>!!U,C=null){if(K.length===0)return Promise.resolve(C);let U=K.length;const q=()=>{U=-1;for(const G of K)G.cancel?.()};return new Promise((G,V)=>{for(const Z of K)Z.then(ee=>{--U>=0&&F(ee)?(q(),G(ee)):U===0&&G(C)}).catch(ee=>{--U>=0&&(q(),V(ee))})})}e.firstParallel=y;class w{constructor(F){this.a=0,this.d=F,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(F){return this.a++,new Promise((C,U)=>{this.f.push({factory:F,c:C,e:U}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const F=this.f.shift();this.b++;const C=F.factory();C.then(F.c,F.e),C.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=w;class f extends w{constructor(){super(1)}}e.Queue=f;class P{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const F=new z;return this.b.add(F),F.p}d(){for(const[,F]of this.a)if(F.size>0)return!1;return!0}queueFor(F,C=T.extUri){const U=C.getComparisonKey(F);let q=this.a.get(U);return q||(q=new f,l.Event.once(q.onDrained)(()=>{q?.dispose(),this.a.delete(U),this.f()}),this.a.set(U,q)),q}f(){this.d()&&this.g()}g(){for(const F of this.b)F.complete();this.b.clear()}dispose(){for(const[,F]of this.a)F.dispose();this.a.clear(),this.g()}}e.ResourceQueue=P;class D{constructor(F,C){this.a=-1,typeof F=="function"&&typeof C=="number"&&this.setIfNotSet(F,C)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(F,C){this.cancel(),this.a=setTimeout(()=>{this.a=-1,F()},C)}setIfNotSet(F,C){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,F()},C))}}e.TimeoutTimer=D;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(F,C){this.cancel(),this.a=setInterval(()=>{F()},C)}}e.IntervalTimer=M;class j{constructor(F,C){this.b=-1,this.a=F,this.d=C,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(F=this.d){this.cancel(),this.b=setTimeout(this.f,F)}get delay(){return this.d}set delay(F){this.d=F}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=j;class B{constructor(F,C){C%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${C}ms is not a multiple of 1000ms.`),this.a=F,this.b=C,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(F=this.b){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(F/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=B;class W extends j{constructor(F,C){super(F,C),this.j=[]}work(F){this.j.push(F),this.isScheduled()||this.schedule()}h(){const F=this.j;this.j=[],this.a?.(F)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=W;class H extends O.Disposable{constructor(F,C){super(),this.g=F,this.h=C,this.a=[],this.b=this.B(new O.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(F){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+F.length>this.g.maxBufferedWork)return!1}else if(this.pending+F.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const C of F)this.a.push(C);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new j(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=K=>{(0,k.setTimeout0)(()=>{if(F)return;const C=Date.now()+15;K(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,C-Date.now())}}))});let F=!1;return{dispose(){F||(F=!0)}}}:e.runWhenIdle=(K,F)=>{const C=requestIdleCallback(K,typeof F=="number"?{timeout:F}:void 0);let U=!1;return{dispose(){U||(U=!0,cancelIdleCallback(C))}}}}();class Q{constructor(F){this.d=!1,this.a=()=>{try{this.f=F()}catch(C){this.g=C}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=Q;async function _(K,F,C){let U;for(let q=0;q<C;q++)try{return await K()}catch(G){U=G,await i(F)}throw U}e.retry=_;class Y{hasPending(F){return this.a?typeof F=="number"?this.a.taskId===F:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(F,C,U){return this.a={taskId:F,cancel:()=>U?.(),promise:C},C.then(()=>this.d(F),()=>this.d(F)),C}d(F){this.a&&F===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const F=this.b;this.b=void 0,F.run().then(F.promiseResolve,F.promiseReject)}}setNext(F){if(this.b)this.b.run=F;else{let C,U;const q=new Promise((G,V)=>{C=G,U=V});this.b={run:F,promise:q,promiseResolve:C,promiseReject:U}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=Y;class ${constructor(F,C=()=>Date.now()){this.d=F,this.f=C,this.a=0,this.b=0}increment(){const F=this.f();return F-this.a>this.d&&(this.a=F,this.b=0),this.b++,this.b}}e.IntervalCounter=$;class z{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((F,C)=>{this.a=F,this.b=C})}complete(F){return new Promise(C=>{this.a(F),this.f=!0,C()})}error(F){return new Promise(C=>{this.b(F),this.d=!0,C()})}cancel(){new Promise(F=>{this.b(new N.CancellationError),this.d=!0,F()})}}e.DeferredPromise=z;var x;(function(K){async function F(U){let q;const G=await Promise.all(U.map(V=>V.then(Z=>Z,Z=>{q||(q=Z)})));if(typeof q<"u")throw q;return G}K.settled=F;function C(U){return new Promise(async(q,G)=>{try{await U(q,G)}catch(V){G(V)}})}K.withAsyncBody=C})(x||(e.Promises=x={}));var te;(function(K){K[K.Initial=0]="Initial",K[K.DoneOK=1]="DoneOK",K[K.DoneError=2]="DoneError"})(te||(te={}));class ne{static fromArray(F){return new ne(C=>{C.emitMany(F)})}static fromPromise(F){return new ne(async C=>{C.emitMany(await F)})}static fromPromises(F){return new ne(async C=>{await Promise.all(F.map(async U=>C.emitOne(await U)))})}static merge(F){return new ne(async C=>{await Promise.all(F.map(async U=>{for await(const q of U)C.emitOne(q)}))})}constructor(F){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const C={emitOne:U=>this.g(U),emitMany:U=>this.h(U),reject:U=>this.k(U)};try{await Promise.resolve(F(C)),this.j()}catch(U){this.k(U)}finally{C.emitOne=void 0,C.emitMany=void 0,C.reject=void 0}})}[Symbol.asyncIterator](){let F=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(F<this.b.length)return{done:!1,value:this.b[F++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(F,C){return new ne(async U=>{for await(const q of F)U.emitOne(C(q))})}map(F){return ne.map(this,F)}static filter(F,C){return new ne(async U=>{for await(const q of F)C(q)&&U.emitOne(q)})}filter(F){return ne.filter(this,F)}static coalesce(F){return ne.filter(F,C=>!!C)}coalesce(){return ne.coalesce(this)}static async toPromise(F){const C=[];for await(const U of F)C.push(U);return C}toPromise(){return ne.toPromise(this)}g(F){this.a===0&&(this.b.push(F),this.f.fire())}h(F){this.a===0&&(this.b=this.b.concat(F),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(F){this.a===0&&(this.a=2,this.d=F,this.f.fire())}}e.AsyncIterableObject=ne,ne.EMPTY=ne.fromArray([]);class re extends ne{constructor(F,C){super(C),this.l=F}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=re;function X(K){const F=new A.CancellationTokenSource,C=K(F.token);return new re(F,async U=>{const q=F.token.onCancellationRequested(()=>{q.dispose(),F.dispose(),U.reject(new N.CancellationError)});try{for await(const G of C){if(F.token.isCancellationRequested)return;U.emitOne(G)}q.dispose(),F.dispose()}catch(G){q.dispose(),F.dispose(),U.reject(G)}})}e.createCancelableAsyncIterable=X}),define(oe[92],ae([0,1,21,6,47,37,14,4,27]),function(ie,e,A,N,l,O,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function v(){return Object.create(null)}e.getEmptyExpression=v,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",b="[^/\\\\]",m=/\//g;function g($,z){switch($){case 0:return"";case 1:return`${b}*?`;default:return`(?:${R}|${b}+${R}${z?`|${R}${b}+`:""})*?`}}function p($,z){if(!$)return[];const x=[];let te=!1,ne=!1,re="";for(const X of $){switch(X){case z:if(!te&&!ne){x.push(re),re="";continue}break;case"{":te=!0;break;case"}":te=!1;break;case"[":ne=!0;break;case"]":ne=!1;break}re+=X}return re&&x.push(re),x}e.splitGlobAware=p;function E($){if(!$)return"";let z="";const x=p($,e.GLOB_SPLIT);if(x.every(te=>te===e.GLOBSTAR))z=".*";else{let te=!1;x.forEach((ne,re)=>{if(ne===e.GLOBSTAR){if(te)return;z+=g(2,re===x.length-1)}else{let X=!1,K="",F=!1,C="";for(const U of ne){if(U!=="}"&&X){K+=U;continue}if(F&&(U!=="]"||!C)){let q;U==="-"?q=U:(U==="^"||U==="!")&&!C?q="^":U===e.GLOB_SPLIT?q="":q=(0,I.escapeRegExpCharacters)(U),C+=q;continue}switch(U){case"{":X=!0;continue;case"[":F=!0;continue;case"}":{const G=`(?:${p(K,",").map(V=>E(V)).join("|")})`;z+=G,X=!1,K="";break}case"]":{z+="["+C+"]",F=!1,C="";break}case"?":z+=b;continue;case"*":z+=g(1);continue;default:z+=(0,I.escapeRegExpCharacters)(U)}}re<x.length-1&&(x[re+1]!==e.GLOBSTAR||re+2<x.length)&&(z+=R)}te=ne===e.GLOBSTAR})}return z}const a=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,u=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,d=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,S=/^\*\*((\/[\w\.-]+)+)\/?$/,L=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,n=new O.LRUCache(1e4),r=function(){return!1},t=function(){return null};function i($,z){if(!$)return t;let x;typeof $!="string"?x=$.pattern:x=$,x=x.trim();const te=`${x}_${!!z.trimForExclusions}`;let ne=n.get(te);if(ne)return s(ne,$);let re;return a.test(x)?ne=c(x.substr(4),x):(re=h.exec(o(x,z)))?ne=y(re[1],x):(z.trimForExclusions?d:u).test(x)?ne=w(x,z):(re=S.exec(o(x,z)))?ne=f(re[1].substr(1),x,!0):(re=L.exec(o(x,z)))?ne=f(re[1],x,!1):ne=P(x),n.set(te,ne),s(ne,$)}function s($,z){if(typeof z=="string")return $;const x=function(te,ne){return(0,l.isEqualOrParent)(te,z.base,!k.isLinux)?$((0,I.ltrim)(te.substr(z.base.length),T.sep),ne):null};return x.allBasenames=$.allBasenames,x.allPaths=$.allPaths,x.basenames=$.basenames,x.patterns=$.patterns,x}function o($,z){return z.trimForExclusions&&$.endsWith("/**")?$.substr(0,$.length-2):$}function c($,z){return function(x,te){return typeof x=="string"&&x.endsWith($)?z:null}}function y($,z){const x=`/${$}`,te=`\\${$}`,ne=function(X,K){return typeof X!="string"?null:K?K===$?z:null:X===$||X.endsWith(x)||X.endsWith(te)?z:null},re=[$];return ne.basenames=re,ne.patterns=[z],ne.allBasenames=re,ne}function w($,z){const x=_($.slice(1,-1).split(",").map(K=>i(K,z)).filter(K=>K!==t),$),te=x.length;if(!te)return t;if(te===1)return x[0];const ne=function(K,F){for(let C=0,U=x.length;C<U;C++)if(x[C](K,F))return $;return null},re=x.find(K=>!!K.allBasenames);re&&(ne.allBasenames=re.allBasenames);const X=x.reduce((K,F)=>F.allPaths?K.concat(F.allPaths):K,[]);return X.length&&(ne.allPaths=X),ne}function f($,z,x){const te=T.sep===T.posix.sep,ne=te?$:$.replace(m,T.sep),re=T.sep+ne,X=T.posix.sep+$;let K;return x?K=function(F,C){return typeof F=="string"&&(F===ne||F.endsWith(re)||!te&&(F===$||F.endsWith(X)))?z:null}:K=function(F,C){return typeof F=="string"&&(F===ne||!te&&F===$)?z:null},K.allPaths=[(x?"*/":"./")+$],K}function P($){try{const z=new RegExp(`^${E($)}$`);return function(x){return z.lastIndex=0,typeof x=="string"&&z.test(x)?$:null}}catch{return t}}function D($,z,x){return!$||typeof z!="string"?!1:M($)(z,void 0,x)}e.match=D;function M($,z={}){if(!$)return r;if(typeof $=="string"||j($)){const x=i($,z);if(x===t)return r;const te=function(ne,re){return!!x(ne,re)};return x.allBasenames&&(te.allBasenames=x.allBasenames),x.allPaths&&(te.allPaths=x.allPaths),te}return H($,z)}e.parse=M;function j($){const z=$;return z?typeof z.base=="string"&&typeof z.pattern=="string":!1}e.isRelativePattern=j;function B($){return $.allBasenames||[]}e.getBasenameTerms=B;function W($){return $.allPaths||[]}e.getPathTerms=W;function H($,z){const x=_(Object.getOwnPropertyNames($).map(K=>Q(K,$[K],z)).filter(K=>K!==t)),te=x.length;if(!te)return t;if(!x.some(K=>!!K.requiresSiblings)){if(te===1)return x[0];const K=function(U,q){let G;for(let V=0,Z=x.length;V<Z;V++){const ee=x[V](U,q);if(typeof ee=="string")return ee;(0,N.isThenable)(ee)&&(G||(G=[]),G.push(ee))}return G?(async()=>{for(const V of G){const Z=await V;if(typeof Z=="string")return Z}return null})():null},F=x.find(U=>!!U.allBasenames);F&&(K.allBasenames=F.allBasenames);const C=x.reduce((U,q)=>q.allPaths?U.concat(q.allPaths):U,[]);return C.length&&(K.allPaths=C),K}const ne=function(K,F,C){let U,q;for(let G=0,V=x.length;G<V;G++){const Z=x[G];Z.requiresSiblings&&C&&(F||(F=(0,T.basename)(K)),U||(U=F.substr(0,F.length-(0,T.extname)(K).length)));const ee=Z(K,F,U,C);if(typeof ee=="string")return ee;(0,N.isThenable)(ee)&&(q||(q=[]),q.push(ee))}return q?(async()=>{for(const G of q){const V=await G;if(typeof V=="string")return V}return null})():null},re=x.find(K=>!!K.allBasenames);re&&(ne.allBasenames=re.allBasenames);const X=x.reduce((K,F)=>F.allPaths?K.concat(F.allPaths):K,[]);return X.length&&(ne.allPaths=X),ne}function Q($,z,x){if(z===!1)return t;const te=i($,x);if(te===t)return t;if(typeof z=="boolean")return te;if(z){const ne=z.when;if(typeof ne=="string"){const re=(X,K,F,C)=>{if(!C||!te(X,K))return null;const U=ne.replace("$(basename)",()=>F),q=C(U);return(0,N.isThenable)(q)?q.then(G=>G?$:null):q?$:null};return re.requiresSiblings=!0,re}}return te}function _($,z){const x=$.filter(K=>!!K.basenames);if(x.length<2)return $;const te=x.reduce((K,F)=>{const C=F.basenames;return C?K.concat(C):K},[]);let ne;if(z){ne=[];for(let K=0,F=te.length;K<F;K++)ne.push(z)}else ne=x.reduce((K,F)=>{const C=F.patterns;return C?K.concat(C):K},[]);const re=function(K,F){if(typeof K!="string")return null;if(!F){let U;for(U=K.length;U>0;U--){const q=K.charCodeAt(U-1);if(q===47||q===92)break}F=K.substr(U)}const C=te.indexOf(F);return C!==-1?ne[C]:null};re.basenames=te,re.patterns=ne,re.allBasenames=te;const X=$.filter(K=>!K.basenames);return X.push(re),X}function Y($,z){return(0,A.equals)($,z,(x,te)=>typeof x=="string"&&typeof te=="string"?x===te:typeof x!="string"&&typeof te!="string"?x.base===te.base&&x.pattern===te.pattern:!1)}e.patternsEquals=Y}),define(oe[93],ae([0,1,16,12]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(b){return b.toJSON()}class O{constructor(m){this.a=m}transformIncoming(m){const g=this.a.transformIncoming(m);return g===m?m:l(N.URI.from(g))}transformOutgoing(m){const g=this.a.transformOutgoing(m);return g===m?m:l(N.URI.from(g))}transformOutgoingURI(m){const g=this.a.transformOutgoing(m);return g===m?m:N.URI.from(g)}transformOutgoingScheme(m){return this.a.transformOutgoingScheme(m)}}e.URITransformer=O,e.DefaultURITransformer=new class{transformIncoming(b){return b}transformOutgoing(b){return b}transformOutgoingURI(b){return b}transformOutgoingScheme(b){return b}};function T(b,m,g){if(!b||g>200)return null;if(typeof b=="object"){if(b instanceof N.URI)return m.transformOutgoing(b);for(const p in b)if(Object.hasOwnProperty.call(b,p)){const E=T(b[p],m,g+1);E!==null&&(b[p]=E)}}return null}function k(b,m){const g=T(b,m,0);return g===null?b:g}e.transformOutgoingURIs=k;function I(b,m,g,p){if(!b||p>200)return null;if(typeof b=="object"){if(b.$mid===1)return g?N.URI.revive(m.transformIncoming(b)):m.transformIncoming(b);if(b instanceof A.VSBuffer)return null;for(const E in b)if(Object.hasOwnProperty.call(b,E)){const a=I(b[E],m,g,p+1);a!==null&&(b[E]=a)}}return null}function v(b,m){const g=I(b,m,!1,0);return g===null?b:g}e.transformIncomingURIs=v;function R(b,m){const g=I(b,m,!0,0);return g===null?b:g}e.transformAndReviveIncomingURIs=R}),define(oe[144],ae([0,1,34,48,32,133]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(v){return this.a||(this.a=N.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(v)}value(){if(this.b===void 0){let v=0,R=0;const b=(0,A.networkInterfaces)();for(const m in b){const g=b[m];if(g)for(const{mac:p,internal:E}of g)E||(R+=1,this.c(p.toUpperCase())&&(v+=1))}this.b=R>0?v/R:0}return this.b}};let T;async function k(v){return T||(T=(async()=>await I(v)||l.generateUuid())()),T}e.getMachineId=k;async function I(v){try{const R=await new Promise((m,g)=>{ie(["crypto"],m,g)}),b=(0,O.getMac)();return R.createHash("sha256").update(b,"utf8").digest("hex")}catch(R){v(R);return}}}),define(oe[28],ae([0,1,53,34,283,6,47,87,14,4,22,12]),function(ie,e,A,N,l,O,T,k,I,v,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(H){H[H.UNLINK=0]="UNLINK",H[H.MOVE=1]="MOVE"})(m||(e.RimRafMode=m={}));async function g(H,Q=m.UNLINK){if((0,T.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");return Q===m.UNLINK?E(H):p(H)}async function p(H){try{const Q=(0,T.randomPath)((0,N.tmpdir)());try{await A.promises.rename(H,Q)}catch(_){return _.code==="ENOENT"?void 0:E(H)}E(Q).catch(_=>{})}catch(Q){if(Q.code!=="ENOENT")throw Q}}async function E(H){return(0,l.promisify)(A.rm)(H,{recursive:!0,force:!0,maxRetries:3})}function a(H){if((0,T.isRootOrDriveLetter)(H))throw new Error("rimraf - will refuse to recursively delete root");A.rmSync(H,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=a;async function h(H,Q){return S(await(Q?u(H):(0,l.promisify)(A.readdir)(H)))}async function u(H){try{return await(0,l.promisify)(A.readdir)(H,{withFileTypes:!0})}catch(Y){console.warn("[node.js fs] readdir with filetypes failed with error: ",Y)}const Q=[],_=await h(H);for(const Y of _){let $=!1,z=!1,x=!1;try{const te=await e.Promises.lstat((0,I.join)(H,Y));$=te.isFile(),z=te.isDirectory(),x=te.isSymbolicLink()}catch(te){console.warn("[node.js fs] unexpected error from lstat after readdir: ",te)}Q.push({name:Y,isFile:()=>$,isDirectory:()=>z,isSymbolicLink:()=>x})}return Q}function d(H){return S(A.readdirSync(H))}e.readdirSync=d;function S(H){return H.map(Q=>typeof Q=="string"?v.isMacintosh?(0,k.normalizeNFC)(Q):Q:(Q.name=v.isMacintosh?(0,k.normalizeNFC)(Q.name):Q.name,Q))}async function L(H){const Q=await h(H),_=[];for(const Y of Q)await r.existsDirectory((0,I.join)(H,Y))&&_.push(Y);return _}function n(H,Q=1e3){return new Promise(_=>{let Y=!1;const $=setInterval(()=>{Y||(Y=!0,A.access(H,z=>{Y=!1,z&&(clearInterval($),_(void 0))}))},Q)})}e.whenDeleted=n;var r;(function(H){async function Q($){let z;try{if(z=await e.Promises.lstat($),!z.isSymbolicLink())return{stat:z}}catch{}try{return{stat:await e.Promises.stat($),symbolicLink:z?.isSymbolicLink()?{dangling:!1}:void 0}}catch(x){if(x.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};if(v.isWindows&&x.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink($)),symbolicLink:{dangling:!1}}}catch(te){if(te.code==="ENOENT"&&z)return{stat:z,symbolicLink:{dangling:!0}};throw te}throw x}}H.stat=Q;async function _($){try{const{stat:z,symbolicLink:x}=await H.stat($);return z.isFile()&&x?.dangling!==!0}catch{}return!1}H.existsFile=_;async function Y($){try{const{stat:z,symbolicLink:x}=await H.stat($);return z.isDirectory()&&x?.dangling!==!0}catch{}return!1}H.existsDirectory=Y})(r||(e.SymlinkSupport=r={}));const t=new O.ResourceQueue;function i(H,Q,_){return t.queueFor(b.URI.file(H),R.extUriBiasedIgnorePathCase).queue(()=>{const Y=w(_);return new Promise(($,z)=>c(H,Q,Y,x=>x?z(x):$()))})}let s=!0;function o(H){s=H}e.configureFlushOnWrite=o;function c(H,Q,_,Y){if(!s)return A.writeFile(H,Q,{mode:_.mode,flag:_.flag},Y);A.open(H,_.flag,_.mode,($,z)=>{if($)return Y($);A.writeFile(z,Q,x=>{if(x)return A.close(z,()=>Y(x));A.fdatasync(z,te=>(te&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",te),o(!1)),A.close(z,ne=>Y(ne))))})})}function y(H,Q,_){const Y=w(_);if(!s)return A.writeFileSync(H,Q,{mode:Y.mode,flag:Y.flag});const $=A.openSync(H,Y.flag,Y.mode);try{A.writeFileSync($,Q);try{A.fdatasyncSync($)}catch(z){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",z),o(!1)}}finally{A.closeSync($)}}e.writeFileSync=y;function w(H){return H?{mode:typeof H.mode=="number"?H.mode:438,flag:typeof H.flag=="string"?H.flag:"w"}:{mode:438,flag:"w"}}async function f(H,Q){if(H!==Q)try{await e.Promises.rename(H,Q)}catch(_){if(H.toLowerCase()!==Q.toLowerCase()&&_.code==="EXDEV"||H.endsWith("."))await P(H,Q,{preserveSymlinks:!1}),await g(H,m.MOVE);else throw _}}async function P(H,Q,_){return M(H,Q,{root:{source:H,target:Q},options:_,handledSourcePaths:new Set})}const D=511;async function M(H,Q,_){if(_.handledSourcePaths.has(H))return;_.handledSourcePaths.add(H);const{stat:Y,symbolicLink:$}=await r.stat(H);if($){if(_.options.preserveSymlinks)try{return await W(H,Q,_)}catch(z){console.warn("[node.js fs] copy of symlink failed: ",z)}if($.dangling)return}return Y.isDirectory()?j(H,Q,Y.mode&D,_):B(H,Q,Y.mode&D)}async function j(H,Q,_,Y){await e.Promises.mkdir(Q,{recursive:!0,mode:_});const $=await h(H);for(const z of $)await M((0,I.join)(H,z),(0,I.join)(Q,z),Y)}async function B(H,Q,_){await e.Promises.copyFile(H,Q),await e.Promises.chmod(Q,_)}async function W(H,Q,_){let Y=await e.Promises.readlink(H);(0,T.isEqualOrParent)(Y,_.root.source,!v.isLinux)&&(Y=(0,I.join)(_.root.target,Y.substr(_.root.source.length+1))),await e.Promises.symlink(Y,Q)}e.Promises=new class{get access(){return(0,l.promisify)(A.access)}get stat(){return(0,l.promisify)(A.stat)}get lstat(){return(0,l.promisify)(A.lstat)}get utimes(){return(0,l.promisify)(A.utimes)}get read(){return(H,Q,_,Y,$)=>new Promise((z,x)=>{A.read(H,Q,_,Y,$,(te,ne,re)=>te?x(te):z({bytesRead:ne,buffer:re}))})}get readFile(){return(0,l.promisify)(A.readFile)}get write(){return(H,Q,_,Y,$)=>new Promise((z,x)=>{A.write(H,Q,_,Y,$,(te,ne,re)=>te?x(te):z({bytesWritten:ne,buffer:re}))})}get appendFile(){return(0,l.promisify)(A.appendFile)}get fdatasync(){return(0,l.promisify)(A.fdatasync)}get truncate(){return(0,l.promisify)(A.truncate)}get rename(){return(0,l.promisify)(A.rename)}get copyFile(){return(0,l.promisify)(A.copyFile)}get open(){return(0,l.promisify)(A.open)}get close(){return(0,l.promisify)(A.close)}get symlink(){return(0,l.promisify)(A.symlink)}get readlink(){return(0,l.promisify)(A.readlink)}get chmod(){return(0,l.promisify)(A.chmod)}get mkdir(){return(0,l.promisify)(A.mkdir)}get unlink(){return(0,l.promisify)(A.unlink)}get rmdir(){return(0,l.promisify)(A.rmdir)}get realpath(){return(0,l.promisify)(A.realpath)}async exists(H){try{return await e.Promises.access(H),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return L}get writeFile(){return i}get rm(){return g}get move(){return f}get copy(){return P}}}),define(oe[145],ae([0,1,53,14,4,27,28]),function(ie,e,A,N,l,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function k(m){if(l.isLinux)return m;const g=(0,N.dirname)(m);if(m===g)return m;const p=((0,N.basename)(m)||m).toLowerCase();try{const a=(0,T.readdirSync)(g).filter(h=>h.toLowerCase()===p);if(a.length===1){const h=k(g);if(h)return(0,N.join)(h,a[0])}else if(a.length>1){const h=a.indexOf(p);if(h>=0){const u=k(g);if(u)return(0,N.join)(u,a[h])}}}catch{}return null}e.realcaseSync=k;async function I(m){if(l.isLinux)return m;const g=(0,N.dirname)(m);if(m===g)return m;const p=((0,N.basename)(m)||m).toLowerCase();try{const a=(await T.Promises.readdir(g)).filter(h=>h.toLowerCase()===p);if(a.length===1){const h=await I(g);if(h)return(0,N.join)(h,a[0])}else if(a.length>1){const h=a.indexOf(p);if(h>=0){const u=await I(g);if(u)return(0,N.join)(u,a[h])}}}catch{}return null}e.realcase=I;async function v(m){try{return await T.Promises.realpath(m)}catch{const p=b(m);return await T.Promises.access(p,A.constants.R_OK),p}}e.realpath=v;function R(m){try{return A.realpathSync(m)}catch{const p=b(m);return A.accessSync(p,A.constants.R_OK),p}}e.realpathSync=R;function b(m){return(0,O.rtrim)((0,N.normalize)(m),N.sep)}}),define(oe[94],ae([0,1,34,14,28]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const O=/^\d+$/,T=/^Microsoft.PowerShell_.*/,k=/^Microsoft.PowerShellPreview_.*/;var I;(function(S){S[S.x64=0]="x64",S[S.x86=1]="x86",S[S.ARM=2]="ARM"})(I||(I={}));let v;switch(process.arch){case"ia32":case"x32":v=1;break;case"arm":case"arm64":v=2;break;default:v=0;break}let R;process.env.PROCESSOR_ARCHITEW6432?R=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?R=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?R=1:R=0;class b{constructor(L,n,r){this.exePath=L,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await l.SymlinkSupport.existsFile(this.exePath)),this.a}}function m({useAlternateBitness:S=!1}={}){return S?v===0?process.env["ProgramFiles(x86)"]||null:R===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function g({useAlternateBitness:S=!1,findPreview:L=!1}={}){const n=m({useAlternateBitness:S});if(!n)return null;const r=N.join(n,"PowerShell");if(!await l.SymlinkSupport.existsDirectory(r))return null;let t=-1,i=null;for(const c of await l.Promises.readdir(r)){let y=-1;if(L){const f=c.indexOf("-");if(f<0)continue;const P=c.substring(0,f);if(!O.test(P)||c.substring(f+1)!=="preview")continue;y=parseInt(P,10)}else{if(!O.test(c))continue;y=parseInt(c,10)}if(y<=t)continue;const w=N.join(r,c,"pwsh.exe");await l.SymlinkSupport.existsFile(w)&&(i=w,t=y)}if(!i)return null;const s=n.includes("x86")?" (x86)":"",o=L?" Preview":"";return new b(i,`PowerShell${o}${s}`,!0)}async function p({findPreview:S}={}){if(!process.env.LOCALAPPDATA)return null;const L=N.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await l.SymlinkSupport.existsDirectory(L))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=S?{pwshMsixDirRegex:k,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:T,pwshMsixName:"PowerShell (Store)"};for(const t of await l.Promises.readdir(L))if(n.test(t)){const i=N.join(L,t,"pwsh.exe");return new b(i,r)}return null}function E(){const S=N.join(A.homedir(),".dotnet","tools","pwsh.exe");return new b(S,".NET Core PowerShell Global Tool")}function a(){const S=N.join(process.env.windir,v===1&&R!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(S,"Windows PowerShell",!0)}async function*h(){let S=await g();S&&(yield S),S=await g({useAlternateBitness:!0}),S&&(yield S),S=await p(),S&&(yield S),S=E(),S&&(yield S),S=await g({findPreview:!0}),S&&(yield S),S=await p({findPreview:!0}),S&&(yield S),S=await g({useAlternateBitness:!0,findPreview:!0}),S&&(yield S),S=a(),S&&(yield S)}async function*u(){for await(const S of h())await S.exists()&&(yield S)}e.enumeratePowerShellInstallations=u;async function d(){for await(const S of u())return S;return null}e.getFirstAvailablePowerShellInstallation=d}),define(oe[95],ae([0,1,14,4,36,88,11,28]),function(ie,e,A,N,l,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function I(b=l.env){return b.comspec||"cmd.exe"}e.getWindowsShell=I;function v(b){let m=[],g=!1;const p=function(E){if(g){m.push(E);return}(!b.send(E,h=>{if(h&&console.error(h),g=!1,m.length>0){const u=m.slice(0);m=[],u.forEach(d=>p(d))}})||N.isWindows)&&(g=!0)};return{send:p}}e.createQueuedSender=v;var R;(function(b){async function m(g,p,E){if(A.isAbsolute(g))return g;if(p===void 0&&(p=l.cwd()),A.dirname(g)!=="."||(E===void 0&&T.isString(l.env.PATH)&&(E=l.env.PATH.split(A.delimiter)),E===void 0||E.length===0))return A.join(p,g);async function h(u){if(await k.Promises.exists(u)){let d;try{d=await k.Promises.stat(u)}catch(S){S.message.startsWith("EACCES")&&(d=await k.Promises.lstat(u))}return d?!d.isDirectory():!1}return!1}for(const u of E){let d;if(A.isAbsolute(u)?d=A.join(u,g):d=A.join(p,u,g),await h(d))return d;let S=d+".com";if(await h(S)||(S=d+".exe",await h(S)))return S}return A.join(p,g)}b.findExecutable=m})(R||(e.win32=R={}))}),define(oe[146],ae([0,1,49,24]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function l(T){return new Promise((k,I)=>{let v;const R=new Map;function b(g,p,E,a,h){const u=R.get(p);if(g===T||u){const d={name:m(E),cmd:E,pid:g,ppid:p,load:a,mem:h};R.set(g,d),g===T&&(v=d),u&&(u.children||(u.children=[]),u.children.push(d),u.children.length>1&&(u.children=u.children.sort((S,L)=>S.pid-L.pid)))}}function m(g){const p=/--utility-sub-type=network/i,E=/--ms-enable-electron-run-as-node/i,a=/--crashes-directory/i,h=/\\pipe\\winpty-control/i,u=/conhost\.exe/i,d=/--type=([a-zA-Z-]+)/;if(a.exec(g))return"electron-crash-reporter";if(h.exec(g))return"winpty-process";if(u.exec(g))return"console-window-host (Windows internal process)";let S=d.exec(g);if(S&&S.length===2)return S[1]==="renderer"?"window":S[1]==="utility"?p.exec(g)?"utility-network-service":"utility-process":S[1]==="extensionHost"?"extension-host":S[1];const L=/[a-zA-Z-]+\.js/g;let n="";do S=L.exec(g),S&&(n+=S+" ");while(S);return n&&g.indexOf("node ")<0&&g.indexOf("node.exe")<0?`electron-nodejs (${n})`:E.exec(g)?`electron-nodejs (${g})`:g}if(process.platform==="win32"){const g=p=>p.indexOf("\\\\?\\")===0||p.indexOf("\\??\\")===0?p.substr(4):p.indexOf('"\\\\?\\')===0||p.indexOf('"\\??\\')===0?'"'+p.substr(5):p;new Promise((p,E)=>{ie(["@vscode/windows-process-tree"],p,E)}).then(p=>{p.getProcessList(T,E=>{if(!E){I(new Error(`Root process ${T} not found`));return}p.getProcessCpuUsage(E,a=>{const h=new Map;a.forEach(u=>{const d=g(u.commandLine||"");h.set(u.pid,{name:m(d),cmd:d,pid:u.pid,ppid:u.ppid,load:u.cpu||0,mem:u.memory||0})}),v=h.get(T),v?(h.forEach(u=>{const d=h.get(u.ppid);d&&(d.children||(d.children=[]),d.children.push(u))}),h.forEach(u=>{u.children&&(u.children=u.children.sort((d,S)=>d.pid-S.pid))}),k(v)):I(new Error(`Root process ${T} not found`))})},p.ProcessDataFlag.CommandLine|p.ProcessDataFlag.Memory)})}else{let g=function(){let p=[v];const E=[];for(;p.length;){const h=p.shift();h&&(E.push(h.pid),h.children&&(p=p.concat(h.children)))}let a=JSON.stringify(N.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);a+=" "+E.join(" "),(0,A.exec)(a,{},(h,u,d)=>{if(h||d)I(h||new Error(d.toString()));else{const S=u.toString().split(`
`);for(let L=0;L<E.length;L++){const n=R.get(E[L]);n.load=parseFloat(S[L])}if(!v){I(new Error(`Root process ${T} not found`));return}k(v)}})};(0,A.exec)("which ps",{},(p,E,a)=>{if(p||a)if(process.platform!=="linux")I(p||new Error(a.toString()));else{const h=JSON.stringify(N.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,A.exec)(h,{},(u,d,S)=>{u||S?I(u||new Error(S.toString())):(O(d,b),g())})}else{const h=E.toString().trim(),u="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,A.exec)(`${h} ${u}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(d,S,L)=>{d||L&&!L.includes("screen size is bogus")?I(d||new Error(L.toString())):(O(S,b),process.platform==="linux"?g():v?k(v):I(new Error(`Root process ${T} not found`)))})}})}})}e.listProcesses=l;function O(T,k){const I=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,v=T.toString().split(`
`);for(const R of v){const b=I.exec(R.trim());b&&b.length===6&&k(parseInt(b[1]),parseInt(b[2]),b[5],parseFloat(b[3]),parseFloat(b[4]))}}}),define(oe[147],ae([0,1,34,4,94,95]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function T(b,m){return b===1?N.isWindows?R():O.getWindowsShell(m):I(b,m)}e.getSystemShell=T;let k=null;function I(b,m){if(N.isLinux&&b===2||N.isMacintosh&&b===3)return"/bin/bash";if(!k){let g;if(N.isWindows)g="/bin/bash";else{if(g=m.SHELL,!g)try{g=(0,A.userInfo)().shell}catch{}g||(g="sh"),g==="/bin/false"&&(g="/bin/bash")}k=g}return k}let v=null;async function R(){return v||(v=(await(0,l.getFirstAvailablePowerShellInstallation)()).exePath),v}});var ve=this&&this.__decorate||function(ie,e,A,N){var l=arguments.length,O=l<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,A):N,T;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(ie,e,A,N);else for(var k=ie.length-1;k>=0;k--)(T=ie[k])&&(O=(l<3?T(O):l>3?T(e,A,O):T(e,A))||O);return l>3&&O&&Object.defineProperty(e,A,O),O};define(oe[41],ae([0,1,21,6,16,26,61,9,3,2,91,27,11]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var g;(function(z){z[z.Promise=100]="Promise",z[z.PromiseCancel=101]="PromiseCancel",z[z.EventListen=102]="EventListen",z[z.EventDispose=103]="EventDispose"})(g||(g={}));function p(z){switch(z){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var E;(function(z){z[z.Initialize=200]="Initialize",z[z.PromiseSuccess=201]="PromiseSuccess",z[z.PromiseError=202]="PromiseError",z[z.PromiseErrorObj=203]="PromiseErrorObj",z[z.EventFire=204]="EventFire"})(E||(E={}));function a(z){switch(z){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(z){z[z.Uninitialized=0]="Uninitialized",z[z.Idle=1]="Idle"})(h||(h={}));function u(z){let x=0;for(let te=0;;te+=7){const ne=z.read(1);if(x|=(ne.buffer[0]&127)<<te,!(ne.buffer[0]&128))return x}}const d=t(0);function S(z,x){if(x===0){z.write(d);return}let te=0;for(let re=x;re!==0;re=re>>>7)te++;const ne=l.VSBuffer.alloc(te);for(let re=0;x!==0;re++)ne.buffer[re]=x&127,x=x>>>7,x>0&&(ne.buffer[re]|=128);z.write(ne)}class L{constructor(x){this.b=x,this.a=0}read(x){const te=this.b.slice(this.a,this.a+x);return this.a+=te.byteLength,te}}e.BufferReader=L;class n{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write(x){this.a.push(x)}}e.BufferWriter=n;var r;(function(z){z[z.Undefined=0]="Undefined",z[z.String=1]="String",z[z.Buffer=2]="Buffer",z[z.VSBuffer=3]="VSBuffer",z[z.Array=4]="Array",z[z.Object=5]="Object",z[z.Int=6]="Int"})(r||(r={}));function t(z){const x=l.VSBuffer.alloc(1);return x.writeUInt8(z,0),x}const i={Undefined:t(r.Undefined),String:t(r.String),Buffer:t(r.Buffer),VSBuffer:t(r.VSBuffer),Array:t(r.Array),Object:t(r.Object),Uint:t(r.Int)},s=typeof Buffer<"u";function o(z,x){if(typeof x>"u")z.write(i.Undefined);else if(typeof x=="string"){const te=l.VSBuffer.fromString(x);z.write(i.String),S(z,te.byteLength),z.write(te)}else if(s&&Buffer.isBuffer(x)){const te=l.VSBuffer.wrap(x);z.write(i.Buffer),S(z,te.byteLength),z.write(te)}else if(x instanceof l.VSBuffer)z.write(i.VSBuffer),S(z,x.byteLength),z.write(x);else if(Array.isArray(x)){z.write(i.Array),S(z,x.length);for(const te of x)o(z,te)}else if(typeof x=="number"&&(x|0)===x)z.write(i.Uint),S(z,x);else{const te=l.VSBuffer.fromString(JSON.stringify(x));z.write(i.Object),S(z,te.byteLength),z.write(te)}}e.serialize=o;function c(z){switch(z.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return z.read(u(z)).toString();case r.Buffer:return z.read(u(z)).buffer;case r.VSBuffer:return z.read(u(z));case r.Array:{const te=u(z),ne=[];for(let re=0;re<te;re++)ne.push(c(z));return ne}case r.Object:return JSON.parse(z.read(u(z)).toString());case r.Int:return u(z)}}e.deserialize=c;class y{constructor(x,te,ne=null,re=1e3){this.h=x,this.j=te,this.k=ne,this.l=re,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(x,te){this.b.set(x,te),setTimeout(()=>this.w(x),0)}m(x){switch(x.type){case 200:{const te=this.o([x.type]);this.k?.logOutgoing(te,0,1,a(x.type));return}case 201:case 202:case 204:case 203:{const te=this.o([x.type,x.id],x.data);this.k?.logOutgoing(te,x.id,1,a(x.type),x.data);return}}}o(x,te=void 0){const ne=new n;return o(ne,x),o(ne,te),this.p(ne.buffer)}p(x){try{return this.h.send(x),x.byteLength}catch{return 0}}q(x){const te=new L(x),ne=c(te),re=c(te),X=ne[0];switch(X){case 100:return this.k?.logIncoming(x.byteLength,ne[1],1,`${p(X)}: ${ne[2]}.${ne[3]}`,re),this.s({type:X,id:ne[1],channelName:ne[2],name:ne[3],arg:re});case 102:return this.k?.logIncoming(x.byteLength,ne[1],1,`${p(X)}: ${ne[2]}.${ne[3]}`,re),this.t({type:X,id:ne[1],channelName:ne[2],name:ne[3],arg:re});case 101:return this.k?.logIncoming(x.byteLength,ne[1],1,`${p(X)}`),this.u({type:X,id:ne[1]});case 103:return this.k?.logIncoming(x.byteLength,ne[1],1,`${p(X)}`),this.u({type:X,id:ne[1]})}}s(x){const te=this.b.get(x.channelName);if(!te){this.v(x);return}const ne=new O.CancellationTokenSource;let re;try{re=te.call(this.j,x.name,x.arg,ne.token)}catch(F){re=Promise.reject(F)}const X=x.id;re.then(F=>{this.m({id:X,data:F,type:201}),this.d.delete(x.id)},F=>{F instanceof Error?this.m({id:X,data:{message:F.message,name:F.name,stack:F.stack?F.stack.split?F.stack.split(`
`):F.stack:void 0},type:202}):this.m({id:X,data:F,type:203}),this.d.delete(x.id)});const K=(0,v.toDisposable)(()=>ne.cancel());this.d.set(x.id,K)}t(x){const te=this.b.get(x.channelName);if(!te){this.v(x);return}const ne=x.id,X=te.listen(this.j,x.name,x.arg)(K=>this.m({id:ne,data:K,type:204}));this.d.set(x.id,X)}u(x){const te=this.d.get(x.id);te&&(te.dispose(),this.d.delete(x.id))}v(x){let te=this.g.get(x.channelName);te||(te=[],this.g.set(x.channelName,te));const ne=setTimeout(()=>{console.error(`Unknown channel: ${x.channelName}`),x.type===100&&this.m({id:x.id,data:{name:"Unknown channel",message:`Channel name '${x.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);te.push({request:x,timeoutTimer:ne})}w(x){const te=this.g.get(x);if(te){for(const ne of te)switch(clearTimeout(ne.timeoutTimer),ne.request.type){case 100:this.s(ne.request);break;case 102:this.t(ne.request);break}this.g.delete(x)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,v.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=y;var w;(function(z){z[z.LocalSide=0]="LocalSide",z[z.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));class f{constructor(x,te=null){this.l=x,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new I.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ne=>this.s(ne)),this.j=te}getChannel(x){const te=this;return{call(ne,re,X){return te.a?Promise.reject(new k.CancellationError):te.m(x,ne,re,X)},listen(ne,re){return te.a?I.Event.None:te.o(x,ne,re)}}}m(x,te,ne,re=O.CancellationToken.None){const X=this.g++,F={id:X,type:100,channelName:x,name:te,arg:ne};if(re.isCancellationRequested)return Promise.reject(new k.CancellationError);let C;return new Promise((q,G)=>{if(re.isCancellationRequested)return G(new k.CancellationError);const V=()=>{const ue=de=>{switch(de.type){case 201:this.f.delete(X),q(de.data);break;case 202:{this.f.delete(X);const ye=new Error(de.data.message);ye.stack=Array.isArray(de.data.stack)?de.data.stack.join(`
`):de.data.stack,ye.name=de.data.name,G(ye);break}case 203:this.f.delete(X),G(de.data);break}};this.f.set(X,ue),this.p(F)};let Z=null;this.b===h.Idle?V():(Z=(0,N.createCancelablePromise)(ue=>this.u()),Z.then(()=>{Z=null,V()}));const ee=()=>{Z?(Z.cancel(),Z=null):this.p({id:X,type:101}),G(new k.CancellationError)},ce=re.onCancellationRequested(ee);C=(0,v.combinedDisposable)((0,v.toDisposable)(ee),ce),this.d.add(C)}).finally(()=>{this.d.delete(C)})}o(x,te,ne){const re=this.g++,K={id:re,type:102,channelName:x,name:te,arg:ne};let F=null;const C=new I.Emitter({onWillAddFirstListener:()=>{F=(0,N.createCancelablePromise)(q=>this.u()),F.then(()=>{F=null,this.d.add(C),this.p(K)})},onDidRemoveLastListener:()=>{F?(F.cancel(),F=null):(this.d.delete(C),this.p({id:re,type:103}))}}),U=q=>C.fire(q.data);return this.f.set(re,U),C.event}p(x){switch(x.type){case 100:case 102:{const te=this.q([x.type,x.id,x.channelName,x.name],x.arg);this.j?.logOutgoing(te,x.id,0,`${p(x.type)}: ${x.channelName}.${x.name}`,x.arg);return}case 101:case 103:{const te=this.q([x.type,x.id]);this.j?.logOutgoing(te,x.id,0,p(x.type));return}}}q(x,te=void 0){const ne=new n;return o(ne,x),o(ne,te),this.r(ne.buffer)}r(x){try{return this.l.send(x),x.byteLength}catch{return 0}}s(x){const te=new L(x),ne=c(te),re=c(te),X=ne[0];switch(X){case 200:return this.j?.logIncoming(x.byteLength,0,0,a(X)),this.t({type:ne[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(x.byteLength,ne[1],0,a(X),re),this.t({type:ne[0],id:ne[1],data:re})}}t(x){if(x.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(x.id)?.(x)}get onDidInitializePromise(){return I.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,v.dispose)(this.d.values()),this.d.clear()}}e.ChannelClient=f,ve([T.memoize],f.prototype,"onDidInitializePromise",null);class P{get connections(){const x=[];return this.f.forEach(te=>x.push(te)),x}constructor(x){this.a=new Map,this.f=new Set,this.g=new I.Emitter,this.onDidAddConnection=this.g.event,this.h=new I.Emitter,this.onDidRemoveConnection=this.h.event,x(({protocol:te,onDidClientDisconnect:ne})=>{I.Event.once(te.onMessage)(X=>{const K=new L(X),F=c(K),C=new y(te,F),U=new f(te);this.a.forEach((G,V)=>C.registerChannel(V,G));const q={channelServer:C,channelClient:U,ctx:F};this.f.add(q),this.g.fire(q),ne(()=>{C.dispose(),U.dispose(),this.f.delete(q),this.h.fire(q)})})})}getChannel(x,te){const ne=this;return{call(re,X,K){let F;if((0,m.isFunction)(te)){const U=(0,A.getRandomElement)(ne.connections.filter(te));F=U?Promise.resolve(U):I.Event.toPromise(I.Event.filter(ne.onDidAddConnection,te))}else F=te.routeCall(ne,re,X);const C=F.then(U=>U.channelClient.getChannel(x));return M(C).call(re,X,K)},listen(re,X){if((0,m.isFunction)(te))return ne.j(x,te,re,X);const K=te.routeEvent(ne,re,X).then(F=>F.channelClient.getChannel(x));return M(K).listen(re,X)}}}j(x,te,ne,re){const X=this;let K=new v.DisposableStore;const F=new I.Emitter({onWillAddFirstListener:()=>{K=new v.DisposableStore;const C=new I.EventMultiplexer,U=new Map,q=V=>{const ee=V.channelClient.getChannel(x).listen(ne,re),ce=C.add(ee);U.set(V,ce)},G=V=>{const Z=U.get(V);Z&&(Z.dispose(),U.delete(V))};X.connections.filter(te).forEach(q),I.Event.filter(X.onDidAddConnection,te)(q,void 0,K),X.onDidRemoveConnection(G,void 0,K),C.event(F.fire,F,K),K.add(C)},onDidRemoveLastListener:()=>{K.dispose()}});return F.event}registerChannel(x,te){this.a.set(x,te),this.f.forEach(ne=>{ne.channelServer.registerChannel(x,te)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=P;class D{constructor(x,te,ne=null){const re=new n;o(re,te),x.send(re.buffer),this.a=new f(x,ne),this.d=new y(x,te,ne)}getChannel(x){return this.a.getChannel(x)}registerChannel(x,te){this.d.registerChannel(x,te)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=D;function M(z){return{call(x,te,ne){return z.then(re=>re.call(x,te,ne))},listen(x,te){const ne=new I.Relay;return z.then(re=>ne.input=re.listen(x,te)),ne.event}}}e.getDelayedChannel=M;function j(z){let x=!1;return{call(te,ne,re){return x?z.call(te,ne,re):(0,N.timeout)(0).then(()=>x=!0).then(()=>z.call(te,ne,re))},listen(te,ne){if(x)return z.listen(te,ne);const re=new I.Relay;return(0,N.timeout)(0).then(()=>x=!0).then(()=>re.input=z.listen(te,ne)),re.event}}}e.getNextTickChannel=j;class B{constructor(x){this.a=x}routeCall(x){return this.b(x)}routeEvent(x){return this.b(x)}async b(x){for(const te of x.connections)if(await Promise.resolve(this.a(te.ctx)))return Promise.resolve(te);return await I.Event.toPromise(x.onDidAddConnection),await this.b(x)}}e.StaticRouter=B;var W;(function(z){function x(X,K){const F=X,C=K&&K.disableMarshalling,U=new Map;for(const q in F)ne(q)&&U.set(q,I.Event.buffer(F[q],!0));return new class{listen(q,G,V){const Z=U.get(G);if(Z)return Z;if(re(G)){const ee=F[G];if(typeof ee=="function")return ee.call(F,V)}throw new Error(`Event not found: ${G}`)}call(q,G,V){const Z=F[G];if(typeof Z=="function"){if(!C&&Array.isArray(V))for(let ee=0;ee<V.length;ee++)V[ee]=(0,R.revive)(V[ee]);return Z.apply(F,V)}throw new Error(`Method not found: ${G}`)}}}z.fromService=x;function te(X,K){const F=K&&K.disableMarshalling;return new Proxy({},{get(C,U){if(typeof U=="string")return K?.properties?.has(U)?K.properties.get(U):re(U)?function(q){return X.listen(U,q)}:ne(U)?X.listen(U):async function(...q){let G;K&&!(0,m.isUndefinedOrNull)(K.context)?G=[K.context,...q]:G=q;const V=await X.call(U,G);return F?V:(0,R.revive)(V)};throw new Error(`Property not found: ${String(U)}`)}})}z.toService=te;function ne(X){return X[0]==="o"&&X[1]==="n"&&b.isUpperAsciiLetter(X.charCodeAt(2))}function re(X){return/^onDynamic/.test(X)&&b.isUpperAsciiLetter(X.charCodeAt(9))}})(W||(e.ProxyChannel=W={}));const H=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function Q(z){if(Array.isArray(z))return z;if(z&&typeof z=="object"&&typeof z.toString=="function"){const x=z.toString();if(x!=="[object Object]")return x}return z}function _(z){return Array.isArray(z)?z.map(Q):Q(z)}function Y(z,x,te,ne,re,X,K){K=_(K);const F=H[re],C=F[ne%F.length];let U=[`%c[${z}]%c[${String(x).padStart(7," ")}]%c[len: ${String(te).padStart(5," ")}]%c${String(ne).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${C}`];/\($/.test(X)?(U=U.concat(K),U.push(")")):U.push(K),console.log.apply(console,U)}class ${constructor(x,te){this.d=x,this.f=te,this.a=0,this.b=0}logOutgoing(x,te,ne,re,X){this.b+=x,Y(this.d,this.b,x,te,ne,re,X)}logIncoming(x,te,ne,re,X){this.a+=x,Y(this.f,this.a,x,te,ne,re,X)}}e.IPCLogger=$}),define(oe[96],ae([0,1,6,16,3,2,41]),function(ie,e,A,N,l,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var k;(function(f){f.Created="created",f.Read="read",f.Write="write",f.Open="open",f.Error="error",f.Close="close",f.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",f.NodeEndReceived="nodeEndReceived",f.NodeEndSent="nodeEndSent",f.NodeDrainBegin="nodeDrainBegin",f.NodeDrainEnd="nodeDrainEnd",f.zlibInflateError="zlibInflateError",f.zlibInflateData="zlibInflateData",f.zlibInflateInitialWrite="zlibInflateInitialWrite",f.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",f.zlibInflateWrite="zlibInflateWrite",f.zlibInflateFlushFired="zlibInflateFlushFired",f.zlibDeflateError="zlibDeflateError",f.zlibDeflateData="zlibDeflateData",f.zlibDeflateWrite="zlibDeflateWrite",f.zlibDeflateFlushFired="zlibDeflateFlushFired",f.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",f.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",f.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",f.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",f.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",f.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",f.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",f.ProtocolHeaderRead="protocolHeaderRead",f.ProtocolMessageRead="protocolMessageRead",f.ProtocolHeaderWrite="protocolHeaderWrite",f.ProtocolMessageWrite="protocolMessageWrite",f.ProtocolWrite="protocolWrite"})(k||(e.SocketDiagnosticsEventType=k={}));var I;(function(f){f.enableDiagnostics=!1,f.records=[];const P=new WeakMap;let D=0;function M(B,W){if(!P.has(B)){const H=String(++D);P.set(B,H)}return P.get(B)}function j(B,W,H,Q){if(!f.enableDiagnostics)return;const _=M(B,W);if(Q instanceof N.VSBuffer||Q instanceof Uint8Array||Q instanceof ArrayBuffer||ArrayBuffer.isView(Q)){const Y=N.VSBuffer.alloc(Q.byteLength);Y.set(Q),f.records.push({timestamp:Date.now(),id:_,label:W,type:H,buff:Y})}else f.records.push({timestamp:Date.now(),id:_,label:W,type:H,data:Q})}f.traceSocketEvent=j})(I||(e.SocketDiagnostics=I={}));var v;(function(f){f[f.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",f[f.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(v||(e.SocketCloseEventType=v={}));let R=null;function b(){return R||(R=N.VSBuffer.alloc(0)),R}class m{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(P){this.a.push(P),this.b+=P.byteLength}read(P){return this.c(P,!0)}peek(P){return this.c(P,!1)}c(P,D){if(P===0)return b();if(P>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===P){const W=this.a[0];return D&&(this.a.shift(),this.b-=P),W}if(this.a[0].byteLength>P){const W=this.a[0].slice(0,P);return D&&(this.a[0]=this.a[0].slice(P),this.b-=P),W}const M=N.VSBuffer.alloc(P);let j=0,B=0;for(;P>0;){const W=this.a[B];if(W.byteLength>P){const H=W.slice(0,P);M.set(H,j),j+=P,D&&(this.a[B]=W.slice(P),this.b-=P),P-=P}else M.set(W,j),j+=W.byteLength,D?(this.a.shift(),this.b-=W.byteLength):B++,P-=W.byteLength}return M}}e.ChunkStream=m;var g;(function(f){f[f.None=0]="None",f[f.Regular=1]="Regular",f[f.Control=2]="Control",f[f.Ack=3]="Ack",f[f.Disconnect=5]="Disconnect",f[f.ReplayRequest=6]="ReplayRequest",f[f.Pause=7]="Pause",f[f.Resume=8]="Resume",f[f.KeepAlive=9]="KeepAlive",f[f.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",f[f.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(g||(g={}));function p(f){switch(f){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var E;(function(f){f[f.HeaderLength=13]="HeaderLength",f[f.AcknowledgeTime=2e3]="AcknowledgeTime",f[f.TimeoutTime=2e4]="TimeoutTime",f[f.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",f[f.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",f[f.KeepAliveSendTime=5e3]="KeepAliveSendTime",f[f.LatencySampleTime=6e4]="LatencySampleTime",f[f.LatencySampleCount=5]="LatencySampleCount",f[f.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",f[f.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(E||(e.ProtocolConstants=E={}));class a{constructor(P,D,M,j){this.type=P,this.id=D,this.ack=M,this.data=j,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends O.Disposable{constructor(P){super(),this.f=this.B(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=P,this.b=!1,this.c=new m,this.B(this.a.onData(D=>this.acceptChunk(D))),this.lastReadTime=Date.now()}acceptChunk(P){if(!(!P||P.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(P);this.c.byteLength>=this.g.readLen;){const D=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=D.readUInt32BE(9),this.g.messageType=D.readUInt8(0),this.g.id=D.readUInt32BE(1),this.g.ack=D.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:p(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const M=this.g.messageType,j=this.g.id,B=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",D),this.f.fire(new a(M,j,B,D)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class u{constructor(P){this.k=null,this.a=!1,this.b=!1,this.c=P,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(P){if(this.a)return;P.writtenTime=Date.now(),this.lastWriteTime=Date.now();const D=N.VSBuffer.alloc(13);D.writeUInt8(P.type,0),D.writeUInt32BE(P.id,1),D.writeUInt32BE(P.ack,5),D.writeUInt32BE(P.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:p(P.type),id:P.id,ack:P.ack,messageSize:P.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",P.data),this.j(D,P.data)}g(P,D){const M=this.f===0;return this.d.push(P,D),this.f+=P.byteLength+D.byteLength,M}h(){const P=N.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,P}j(P,D){this.g(P,D)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const P=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:P.byteLength}),this.c.write(P)}}class d extends O.Disposable{constructor(P){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=P,this.b=this.B(new u(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(D=>{D.type===1&&this.f.fire(D.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(P){this.b.write(new a(1,0,0,P))}}e.Protocol=d;class S extends T.IPCClient{static fromSocket(P,D){return new S(new d(P),D)}get onDidDispose(){return this.b.onDidDispose}constructor(P,D,M=null){super(P,D,M),this.b=P}dispose(){super.dispose();const P=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),P.end()}}e.Client=S;class L{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(P){this.b?this.d.length>0?this.d.push(P):this.a.fire(P):this.d.push(P)}flushBuffer(){this.d=[]}}e.BufferedEmitter=L;class n{constructor(P){this.data=P,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let P=0,D=this.a;for(;D;)D=D.next,P++;return P}peek(){return this.a?this.a.data:null}toArray(){const P=[];let D=0,M=this.a;for(;M;)P[D++]=M.data,M=M.next;return P}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(P){const D=new n(P);if(!this.a){this.a=D,this.b=D;return}this.b.next=D,this.b=D}}class t{static getInstance(){return t.b||(t.b=new t),t.b}constructor(){this.c=[];const P=Date.now();for(let D=0;D<t.a;D++)this.c[D]=P-1e3*D;setInterval(()=>{for(let D=t.a;D>=1;D--)this.c[D]=this.c[D-1];this.c[0]=Date.now()},1e3)}d(){const P=Date.now(),D=(1+t.a)*1e3;let M=0;for(let j=0;j<t.a;j++)P-this.c[j]<=D&&M++;return 1-M/t.a}hasHighLoad(){return this.d()>=.5}}t.a=10,t.b=null;var i;(function(f){f[f.Good=0]="Good",f[f.Poor=1]="Poor"})(i||(e.ConnectionHealth=i={}));function s(f){switch(f){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=s;class o{constructor(P){this.connectionHealth=P}}e.ConnectionHealthChangedEvent=o;class c{constructor(P,D){this.roundTripTime=P,this.recentHighRoundTripCount=D}}e.HighRoundTripTimeEvent=c;class y{get unacknowledgedCount(){return this.c-this.d}constructor(P){this.x=new L,this.onControlMessage=this.x.event,this.y=new L,this.onMessage=this.y.event,this.z=new L,this.onDidDispose=this.z.event,this.A=new L,this.onSocketClose=this.A.event,this.B=new L,this.onSocketTimeout=this.B.event,this.C=new L,this.onHighRoundTripTime=this.C.event,this.D=new L,this.onDidChangeConnectionHealth=this.D.event,this.u=P.loadEstimator??t.getInstance(),this.v=P.measureRoundTripTime??!1,this.w=P.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new O.DisposableStore,this.o=P.socket,this.p=this.t.add(new u(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(D=>this.E(D))),this.t.add(this.o.onClose(D=>this.A.fire(D))),this.r=this.t.add(new w),this.t.add(this.r.onSendLatencyRequest(D=>this.J(D))),this.t.add(this.r.onHighRoundTripTime(D=>this.C.fire(D))),this.t.add(this.r.onDidChangeConnectionHealth(D=>this.D.fire(D))),this.v&&this.r.start(),P.initialChunk&&this.q.acceptChunk(P.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const P=new a(5,0,0,b());this.p.write(P),this.p.flush()}sendPause(){const P=new a(7,0,0,b());this.p.write(P)}sendResume(){const P=new a(8,0,0,b());this.p.write(P)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(P,D){this.a=!0,this.t.dispose(),this.t=new O.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=P,this.p=this.t.add(new u(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(M=>this.E(M))),this.t.add(this.o.onClose(M=>this.A.fire(M))),this.r=this.t.add(new w),this.t.add(this.r.onSendLatencyRequest(M=>this.J(M))),this.t.add(this.r.onHighRoundTripTime(M=>this.C.fire(M))),this.t.add(this.r.onDidChangeConnectionHealth(M=>this.D.fire(M))),this.q.acceptChunk(D)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const P=new a(3,0,this.h,b());this.p.write(P);const D=this.b.toArray();for(let M=0,j=D.length;M<j;M++)this.p.write(D[M]);this.G()}acceptDisconnect(){this.z.fire()}E(P){if(P.ack>this.d){this.d=P.ack;do{const D=this.b.peek();if(D&&D.id<=P.ack)this.b.pop();else break}while(!0)}switch(P.type){case 0:break;case 1:{if(P.id>this.g)if(P.id!==this.g+1){const D=Date.now();D-this.m>1e4&&(this.m=D,this.p.write(new a(6,0,0,b())))}else this.g=P.id,this.j=Date.now(),this.F(),this.y.fire(P.data);break}case 2:{this.x.fire(P.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const D=this.b.toArray();for(let M=0,j=D.length;M<j;M++)this.p.write(D[M]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(P.data);break}case 11:{this.r.handleResponse(P.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(P){const D=++this.c;this.h=this.g;const M=new a(1,D,this.h,P);this.b.push(M),this.a||(this.p.write(M),this.G())}sendControl(P){const D=new a(2,0,0,P);this.p.write(D)}F(){if(this.g<=this.h||this.k)return;const P=Date.now()-this.j;if(P>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-P+5)}G(){if(this.c<=this.d||this.f||this.a)return;const P=this.b.peek(),D=Date.now()-P.writtenTime,M=Date.now()-this.q.lastReadTime,j=Date.now()-this.n;if(D>=2e4&&M>=2e4&&j>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:D,timeSinceLastReceivedSomeData:M});return}const B=Math.max(2e4-D,2e4-M,2e4-j,500);this.f=setTimeout(()=>{this.f=null,this.G()},B)}H(){if(this.g<=this.h)return;this.h=this.g;const P=new a(3,0,this.h,b());this.p.write(P)}I(){this.h=this.g;const P=new a(9,0,this.h,b());this.p.write(P)}J(P){this.h=this.g;const D=new a(10,0,this.h,P);this.p.write(D)}K(P){this.h=this.g;const D=new a(11,0,this.h,P);this.p.write(D)}}e.PersistentProtocol=y;class w extends O.Disposable{constructor(){super(),this.a=this.B(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new A.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},P=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const P=++this.h,D=N.VSBuffer.alloc(4);D.writeUInt32BE(P,0),this.a.fire(D)},6e4)}handleResponse(P){if(P.byteLength!==4)return;const D=P.readUInt32BE(0);if(this.g<=0||D!==this.h)return;const M=Date.now()-this.g,j=this.k++;this.j[j%this.j.length]=M;const B=this.l,W=this.j.filter(H=>H>=1e3).length;this.l=W>=3?1:0,M>1e3&&this.b.fire(new c(M,W)),B!==this.l&&this.c.fire(this.l)}}}),define(oe[66],ae([0,1,49,6,16,26,143,9,3,2,31,95,88,41]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class p extends g.ChannelServer{constructor(h){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:I.Event.fromNodeEventEmitter(process,"message",u=>l.VSBuffer.wrap(Buffer.from(u,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=p;class E{constructor(h,u){this.i=h,this.j=u,this.c=new Set,this.g=new Map,this.h=new I.Emitter,this.onDidProcessExit=this.h.event;const d=u&&u.timeout?u.timeout:6e4;this.b=new N.Delayer(d),this.d=null,this.f=null}getChannel(h){const u=this;return{call(d,S,L){return u.k(h,d,S,L)},listen(d,S){return u.l(h,d,S)}}}k(h,u,d,S=O.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(S.isCancellationRequested)return Promise.reject(k.canceled());this.b.cancel();const L=this.n(h),n=(0,N.createCancelablePromise)(i=>L.call(u,d,i)),r=S.onCancellationRequested(()=>n.cancel()),t=(0,v.toDisposable)(()=>n.cancel());return this.c.add(t),n.finally(()=>{r.dispose(),this.c.delete(t),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(h,u,d){if(!this.b)return I.Event.None;this.b.cancel();let S;const L=new I.Emitter({onWillAddFirstListener:()=>{S=this.n(h).listen(u,d)(L.fire,L),this.c.add(S)},onDidRemoveLastListener:()=>{this.c.delete(S),S.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return L.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],u=Object.create(null);u.env={...(0,R.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(u.env={...u.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(u.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(s=>!/^--inspect(-brk)?=/.test(s)).filter(s=>!s.startsWith("--vscode-"))),(0,m.removeDangerousEnvVariables)(u.env),this.d=(0,A.fork)(this.i,h,u);const d=new I.Emitter;I.Event.fromNodeEventEmitter(this.d,"message",s=>s)(s=>{if((0,T.isRemoteConsoleLog)(s)){(0,T.log)(s,`IPC Library: ${this.j.serverName}`);return}d.fire(l.VSBuffer.wrap(Buffer.from(s,"base64")))});const L=this.j.useQueue?(0,b.createQueuedSender)(this.d):this.d,n=s=>this.d&&this.d.connected&&L.send(s.buffer.toString("base64")),r=d.event,t={send:n,onMessage:r};this.f=new g.ChannelClient(t);const i=()=>this.o();process.once("exit",i),this.d.on("error",s=>console.warn('IPC "'+this.j.serverName+'" errored with '+s)),this.d.on("exit",(s,o)=>{process.removeListener("exit",i),this.c.forEach(c=>(0,v.dispose)(c)),this.c.clear(),s!==0&&o!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+s+" and signal "+o),this.b?.cancel(),this.o(),this.h.fire({code:s,signal:o})})}return this.f}n(h){let u=this.g.get(h);return u||(u=this.m.getChannel(h),this.g.set(h,u)),u}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=E}),define(oe[148],ae([0,1,135,16,41,3,11,21]),function(ie,e,A,N,l,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=e.Server=void 0;class I{constructor(m){this.a=m,this.onMessage=O.Event.fromNodeEventEmitter(this.a,"message",g=>N.VSBuffer.wrap(g.data)),m.start()}send(m){this.a.postMessage(m.buffer)}disconnect(){this.a.close()}}class v extends l.IPCServer{static b(){(0,T.assertType)((0,A.isUtilityProcess)(process),"Electron Utility Process");const m=new O.Emitter;return process.parentPort.on("message",g=>{const p=(0,k.firstOrDefault)(g.ports);p&&m.fire(p)}),O.Event.map(m.event,g=>({protocol:new I(g),onDidClientDisconnect:O.Event.fromNodeEventEmitter(g,"close")}))}constructor(){super(v.b())}}e.Server=v;function R(b,m,g){const p=E=>{E.data===m&&(b.removeListener("message",p),g())};b.on("message",p)}e.once=R}),define(oe[67],ae([0,1,6,3,2,11]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var T;(function(b){b[b.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",b[b.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(T||(e.StorageHint=T={}));function k(b){const m=b;return m?.changed instanceof Map||m?.deleted instanceof Set}e.isStorageItemsChangeEvent=k;var I;(function(b){b[b.None=0]="None",b[b.Initialized=1]="Initialized",b[b.Closed=2]="Closed"})(I||(e.StorageState=I={}));class v extends l.Disposable{constructor(m,g=Object.create(null)){super(),this.m=m,this.n=g,this.b=this.B(new N.Emitter),this.onDidChangeStorage=this.b.event,this.c=I.None,this.f=new Map,this.g=new A.ThrottledDelayer(v.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(m=>this.r(m)))}r(m){m.changed?.forEach((g,p)=>this.s(p,g)),m.deleted?.forEach(g=>this.s(g,void 0))}s(m,g){if(this.c===I.Closed)return;let p=!1;(0,O.isUndefinedOrNull)(g)?p=this.f.delete(m):this.f.get(m)!==g&&(this.f.set(m,g),p=!0),p&&this.b.fire(m)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===I.None&&(this.c=I.Initialized,this.n.hint!==T.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(m,g){const p=this.f.get(m);return(0,O.isUndefinedOrNull)(p)?g:p}getBoolean(m,g){const p=this.get(m);return(0,O.isUndefinedOrNull)(p)?g:p==="true"}getNumber(m,g){const p=this.get(m);return(0,O.isUndefinedOrNull)(p)?g:parseInt(p,10)}async set(m,g){if(this.c===I.Closed)return;if((0,O.isUndefinedOrNull)(g))return this.delete(m);const p=String(g);if(this.f.get(m)!==p)return this.f.set(m,p),this.j.set(m,p),this.h.delete(m),this.b.fire(m),this.w()}async delete(m){if(!(this.c===I.Closed||!this.f.delete(m)))return this.h.has(m)||this.h.add(m),this.j.delete(m),this.b.fire(m),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=I.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const m={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(m).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(m){if(this.u)return this.w(m)}async w(m){return this.g.trigger(()=>this.v(),m)}async whenFlushed(){if(this.u)return new Promise(m=>this.l.push(m))}isInMemory(){return this.n.hint===T.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}e.Storage=v,v.a=100;class R{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(m){m.insert?.forEach((g,p)=>this.a.set(p,g)),m.delete?.forEach(g=>this.a.delete(g))}async close(){}}e.InMemoryStorageDatabase=R}),define(oe[149],ae([8,7]),function(ie,e){return ie.create("vs/base/node/zip",e)}),define(oe[150],ae([8,7]),function(ie,e){return ie.create("vs/platform/configuration/common/configurationRegistry",e)}),define(oe[151],ae([8,7]),function(ie,e){return ie.create("vs/platform/contextkey/common/contextkey",e)}),define(oe[152],ae([8,7]),function(ie,e){return ie.create("vs/platform/contextkey/common/scanner",e)}),define(oe[153],ae([8,7]),function(ie,e){return ie.create("vs/platform/environment/node/argv",e)}),define(oe[154],ae([8,7]),function(ie,e){return ie.create("vs/platform/environment/node/argvHelper",e)}),define(oe[155],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(oe[156],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(oe[157],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(oe[158],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(oe[159],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(oe[160],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(oe[161],ae([8,7]),function(ie,e){return ie.create("vs/platform/extensions/common/extensionValidator",e)}),define(oe[162],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/common/fileService",e)}),define(oe[163],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/common/files",e)}),define(oe[164],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/common/io",e)}),define(oe[165],ae([8,7]),function(ie,e){return ie.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(oe[166],ae([8,7]),function(ie,e){return ie.create("vs/platform/languagePacks/common/languagePacks",e)}),define(oe[167],ae([8,7]),function(ie,e){return ie.create("vs/platform/remoteTunnel/common/remoteTunnel",e)}),define(oe[168],ae([8,7]),function(ie,e){return ie.create("vs/platform/remoteTunnel/node/remoteTunnelService",e)}),define(oe[169],ae([8,7]),function(ie,e){return ie.create("vs/platform/request/common/request",e)}),define(oe[170],ae([8,7]),function(ie,e){return ie.create("vs/platform/shell/node/shellEnv",e)}),define(oe[171],ae([8,7]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryLogAppender",e)}),define(oe[172],ae([8,7]),function(ie,e){return ie.create("vs/platform/telemetry/common/telemetryService",e)}),define(oe[173],ae([8,7]),function(ie,e){return ie.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(oe[174],ae([8,7]),function(ie,e){return ie.create("vs/platform/terminal/common/terminalProfiles",e)}),define(oe[175],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(oe[176],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(oe[177],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(oe[178],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/settingsSync",e)}),define(oe[179],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(oe[180],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSync",e)}),define(oe[181],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncLog",e)}),define(oe[182],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(oe[183],ae([8,7]),function(ie,e){return ie.create("vs/platform/userDataSync/common/userDataSyncResourceProvider",e)}),define(oe[184],ae([8,7]),function(ie,e){return ie.create("vs/platform/workspace/common/workspace",e)}),define(oe[185],ae([0,1,9,152]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var l;(function(v){v[v.LParen=0]="LParen",v[v.RParen=1]="RParen",v[v.Neg=2]="Neg",v[v.Eq=3]="Eq",v[v.NotEq=4]="NotEq",v[v.Lt=5]="Lt",v[v.LtEq=6]="LtEq",v[v.Gt=7]="Gt",v[v.GtEq=8]="GtEq",v[v.RegexOp=9]="RegexOp",v[v.RegexStr=10]="RegexStr",v[v.True=11]="True",v[v.False=12]="False",v[v.In=13]="In",v[v.Not=14]="Not",v[v.And=15]="And",v[v.Or=16]="Or",v[v.Str=17]="Str",v[v.QuotedStr=18]="QuotedStr",v[v.Error=19]="Error",v[v.EOF=20]="EOF"})(l||(e.TokenType=l={}));function O(...v){switch(v.length){case 1:return(0,N.localize)(0,null,v[0]);case 2:return(0,N.localize)(1,null,v[0],v[1]);case 3:return(0,N.localize)(2,null,v[0],v[1],v[2]);default:return}}const T=(0,N.localize)(3,null),k=(0,N.localize)(4,null);class I{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(R){switch(R.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return R.isTripleEq?"===":"==";case 4:return R.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return R.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return R.lexeme;case 18:return R.lexeme;case 19:return R.lexeme;case 20:return"EOF";default:throw(0,A.illegalState)(`unhandled token type: ${JSON.stringify(R)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(R){return this.c=R,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(O("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(O("&&"));break;case 124:this.h(124)?this.k(16):this.l(O("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(R){return this.r()||this.c.charCodeAt(this.e)!==R?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(R){this.f.push({type:R,offset:this.d})}l(R){const b=this.d,m=this.c.substring(this.d,this.e),g={type:19,offset:this.d,lexeme:m};this.g.push({offset:b,lexeme:m,additionalInfo:R}),this.f.push(g)}n(){this.m.lastIndex=this.d;const R=this.m.exec(this.c);if(R){this.e=this.d+R[0].length;const b=this.c.substring(this.d,this.e),m=I.b.get(b);m?this.k(m):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(T);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let R=this.e,b=!1,m=!1;for(;;){if(R>=this.c.length){this.e=R,this.l(k);return}const p=this.c.charCodeAt(R);if(b)b=!1;else if(p===47&&!m){R++;break}else p===91?m=!0:p===92?b=!0:p===93&&(m=!1);R++}for(;R<this.c.length&&I.a.has(this.c.charCodeAt(R));)R++;this.e=R;const g=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:g,offset:this.d})}r(){return this.e>=this.c.length}}e.Scanner=I,I.a=new Set(["i","g","s","m","y","u"].map(v=>v.charCodeAt(0))),I.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(oe[186],ae([0,1,64,61,24,14,36,22,12]),function(ie,e,A,N,l,O,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class v{get appRoot(){return(0,O.dirname)(l.FileAccess.asFileUri("").fsPath)}get userHome(){return I.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return I.URI.file((0,O.join)(this.userDataPath,"User"))}get tmpDir(){return I.URI.file(this.b.tmpDir)}get cacheHome(){return I.URI.file(this.userDataPath)}get stateResource(){return(0,k.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,k.joinPath)(this.userRoamingDataHome,"sync")}get logsHome(){if(!this.args.logsPath){const g=(0,A.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.join)(this.userDataPath,"logs",g)}return I.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,k.joinPath)(I.URI.file((0,O.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,k.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,k.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,k.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const g=T.env.VSCODE_PORTABLE;return g?I.URI.file((0,O.join)(g,"argv.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return I.URI.file((0,O.join)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const g=this.args["builtin-extensions-dir"];return g?(0,O.resolve)(g):(0,O.normalize)((0,O.join)(l.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const g=this.args["extensions-download-dir"];return g?I.URI.file((0,O.resolve)(g)):I.URI.file((0,O.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const g=this.args["extensions-dir"];if(g)return(0,O.resolve)(g);const p=T.env.VSCODE_EXTENSIONS;if(p)return p;const E=T.env.VSCODE_PORTABLE;return E?(0,O.join)(E,"extensions"):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const g=this.args.extensionDevelopmentPath;if(Array.isArray(g))return g.map(p=>/^[^:/?#]+?:\/\//.test(p)?I.URI.parse(p):I.URI.file((0,O.normalize)(p)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(g=>g==="ui"||g==="workspace"||g==="web"?g:"workspace")}get extensionTestsLocationURI(){const g=this.args.extensionTestsPath;if(g)return/^[^:/?#]+?:\/\//.test(g)?I.URI.parse(g):I.URI.file((0,O.normalize)(g))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const g=this.args["disable-extension"];if(g){if(typeof g=="string")return[g];if(Array.isArray(g)&&g.length>0)return g}return!1}get debugExtensionHost(){return R(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!T.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(g=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(g))}get extensionLogLevel(){const g=[];for(const p of this.args.log||[]){const E=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(p);E&&E[1]&&E[2]&&g.push([E[1],E[2]])}return g.length?g:void 0}get serviceMachineIdResource(){return(0,k.joinPath)(I.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const g=T.env.VSCODE_PORTABLE;return g?I.URI.file((0,O.join)(g,"policy.json")):(0,k.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(g){this.args.continueOn=g}get args(){return this.a}constructor(g,p,E){this.a=g,this.b=p,this.c=E,this.editSessionId=this.args.editSessionId}}e.AbstractNativeEnvironmentService=v,ve([N.memoize],v.prototype,"appRoot",null),ve([N.memoize],v.prototype,"userHome",null),ve([N.memoize],v.prototype,"userDataPath",null),ve([N.memoize],v.prototype,"appSettingsHome",null),ve([N.memoize],v.prototype,"tmpDir",null),ve([N.memoize],v.prototype,"cacheHome",null),ve([N.memoize],v.prototype,"stateResource",null),ve([N.memoize],v.prototype,"userRoamingDataHome",null),ve([N.memoize],v.prototype,"userDataSyncHome",null),ve([N.memoize],v.prototype,"sync",null),ve([N.memoize],v.prototype,"machineSettingsResource",null),ve([N.memoize],v.prototype,"workspaceStorageHome",null),ve([N.memoize],v.prototype,"localHistoryHome",null),ve([N.memoize],v.prototype,"keyboardLayoutResource",null),ve([N.memoize],v.prototype,"argvResource",null),ve([N.memoize],v.prototype,"isExtensionDevelopment",null),ve([N.memoize],v.prototype,"untitledWorkspacesHome",null),ve([N.memoize],v.prototype,"builtinExtensionsPath",null),ve([N.memoize],v.prototype,"extensionsPath",null),ve([N.memoize],v.prototype,"extensionDevelopmentLocationURI",null),ve([N.memoize],v.prototype,"extensionDevelopmentKind",null),ve([N.memoize],v.prototype,"extensionTestsLocationURI",null),ve([N.memoize],v.prototype,"debugExtensionHost",null),ve([N.memoize],v.prototype,"logLevel",null),ve([N.memoize],v.prototype,"extensionLogLevel",null),ve([N.memoize],v.prototype,"serviceMachineIdResource",null),ve([N.memoize],v.prototype,"disableTelemetry",null),ve([N.memoize],v.prototype,"disableWorkspaceTrust",null),ve([N.memoize],v.prototype,"policyFile",null);function R(m,g){return b(m["inspect-extensions"],m["inspect-brk-extensions"],5870,g,m.debugId,m.extensionEnvironment)}e.parseExtensionHostDebugPort=R;function b(m,g,p,E,a,h){const d=Number(g||m)||(E?null:p),S=d?!!g:!1;let L;if(h)try{L=JSON.parse(h)}catch{}return{port:d,break:S,debugId:a,env:L}}e.parseDebugParams=b}),define(oe[187],ae([0,1,284,4,153]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const O={o:(0,l.localize)(0,null),e:(0,l.localize)(1,null),t:(0,l.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,l.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,l.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,l.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,l.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,l.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,l.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,l.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,l.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,l.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,l.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,l.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,l.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,l.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,l.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,l.localize)(17,null)},category:{type:"string",cat:"e",description:(0,l.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,l.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,l.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,l.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,l.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,l.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,l.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,l.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,l.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,l.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,l.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,l.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,l.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,l.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,l.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,l.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},telemetry:{type:"boolean",cat:"t",description:(0,l.localize)(34,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const T={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function k(E,a,h=T){const u=E.find(o=>o.length>0&&o[0]!=="-"),d={},S=["_"],L=[],n={};let r;for(const o in a){const c=a[o];c.type==="subcommand"?o===u&&(r=c):(c.alias&&(d[o]=c.alias),c.type==="string"||c.type==="string[]"?(S.push(o),c.deprecates&&S.push(...c.deprecates)):c.type==="boolean"&&(L.push(o),c.deprecates&&L.push(...c.deprecates)),c.global&&(n[o]=c))}if(r&&u){const o=n;for(const f in r.options)o[f]=r.options[f];const c=E.filter(f=>f!==u),y=h.getSubcommandReporter?h.getSubcommandReporter(u):void 0,w=k(c,o,y);return{[u]:w,_:[]}}const t=A(E,{string:S,boolean:L,alias:d}),i={},s=t;i._=t._.map(o=>String(o)).filter(o=>o.length>0),delete s._;for(const o in a){const c=a[o];if(c.type==="subcommand")continue;c.alias&&delete s[c.alias];let y=s[o];if(c.deprecates)for(const w of c.deprecates)s.hasOwnProperty(w)&&(y||(y=s[w],y&&h.onDeprecatedOption(w,c.deprecationMessage||(0,l.localize)(35,null,o))),delete s[w]);if(typeof y<"u"){if(c.type==="string[]"){if(Array.isArray(y)||(y=[y]),!c.allowEmptyValue){const w=y.filter(f=>f.length>0);w.length!==y.length&&(h.onEmptyValue(o),y=w.length>0?w:void 0)}}else c.type==="string"&&(Array.isArray(y)?(y=y.pop(),h.onMultipleValues(o,y)):!y&&!c.allowEmptyValue&&(h.onEmptyValue(o),y=void 0));i[o]=y,c.deprecationMessage&&h.onDeprecatedOption(o,c.deprecationMessage)}delete s[o]}for(const o in s)h.onUnknownOption(o);return i}e.parseArgs=k;function I(E,a){let h="";return a.args&&(Array.isArray(a.args)?h=` <${a.args.join("> <")}>`:h=` <${a.args}>`),a.alias?`-${a.alias} --${E}${h}`:`--${E}${h}`}function v(E,a){const h=[];for(const u in E){const d=E[u],S=I(u,d);h.push([S,d.description])}return R(h,a)}e.formatOptions=v;function R(E,a){const u=E.reduce((L,n)=>Math.max(L,n[0].length),12)+2+1;if(a-u<25)return E.reduce((L,n)=>L.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);const d=a-u-1,S=[];for(const L of E){const n=L[0],r=m(L[1],d),t=b(u-n.length-2);S.push("  "+n+t+r[0]);for(let i=1;i<r.length;i++)S.push(b(u)+r[i])}return S}function b(E){return" ".repeat(E)}function m(E,a){const h=[];for(;E.length;){const u=E.length<a?E.length:E.lastIndexOf(" ",a),d=E.slice(0,u).trim();E=E.slice(u),h.push(d)}return h}function g(E,a,h,u,d){const S=process.stdout.isTTY&&process.stdout.columns||80,L=d?.noInputFiles!==!0?`[${(0,l.localize)(36,null)}...]`:"",n=[`${E} ${h}`];n.push(""),n.push(`${(0,l.localize)(37,null)}: ${a} [${(0,l.localize)(38,null)}]${L}`),n.push(""),d?.noPipe!==!0&&(N.isWindows?n.push((0,l.localize)(39,null,a)):n.push((0,l.localize)(40,null,a)),n.push(""));const r={},t=[];for(const i in u){const s=u[i];if(s.type==="subcommand")s.description&&t.push({command:i,description:s.description});else if(s.description&&s.cat){let o=r[s.cat];o||(r[s.cat]=o={}),o[i]=s}}for(const i in r){const s=i,o=r[s];o&&(n.push(O[s]),n.push(...v(o,S)),n.push(""))}return t.length&&(n.push((0,l.localize)(41,null)),n.push(...R(t.map(i=>[i.command,i.description]),S)),n.push("")),n.join(`
`)}e.buildHelpMessage=g;function p(E,a){return`${E||(0,l.localize)(42,null)}
${a||(0,l.localize)(43,null)}
${process.arch}`}e.buildVersionMessage=p}),define(oe[188],ae([0,1,285,154,187]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function O(b,m){const g=(d,S)=>{console.warn((0,N.localize)(0,null,d,S))},p=d=>{console.warn((0,N.localize)(1,null,d))},E=(d,S)=>{console.warn((0,N.localize)(2,null,d,S))},a=d=>({onUnknownOption:S=>{d!=="tunnel"&&console.warn((0,N.localize)(3,null,S,d))},onMultipleValues:g,onEmptyValue:p,onDeprecatedOption:E,getSubcommandReporter:d!=="tunnel"?a:void 0}),h={onUnknownOption:d=>{console.warn((0,N.localize)(4,null,d))},onMultipleValues:g,onEmptyValue:p,onDeprecatedOption:E,getSubcommandReporter:a},u=(0,l.parseArgs)(b,l.OPTIONS,m?h:void 0);return u.goto&&u._.forEach(d=>A(/^(\w:)?[^:]+(:\d*){0,2}$/.test(d),(0,N.localize)(5,null))),u}function T(b){const m=b.findIndex(g=>!/^-/.test(g));if(m>-1)return[...b.slice(0,m),...b.slice(m+1)]}function k(b){let[,...m]=b;process.env.VSCODE_DEV&&(m=T(m)||[]);const g=!R(process.env);return O(m,g)}e.parseMainProcessArgv=k;function I(b){let[,,...m]=b;return process.env.VSCODE_DEV&&(m=T(m)||[]),O(m,!0)}e.parseCLIProcessArgv=I;function v(b,...m){const g=b.indexOf("--");return g===-1?b.push(...m):b.splice(g,0,...m),b}e.addArg=v;function R(b){return b.VSCODE_CLI==="1"}e.isLaunchedFromCli=R}),function(){"use strict";function ie(e,A,N){function l(T,k){const I=O(T,k),v=[I];return e.isAbsolute(I)||v.unshift(N),e.resolve(...v)}function O(T,k){process.env.VSCODE_DEV&&(k="code-oss-dev");const I=process.env.VSCODE_PORTABLE;if(I)return e.join(I,"user-data");let v=process.env.VSCODE_APPDATA;if(v)return e.join(v,k);const R=T["user-data-dir"];if(R)return R;switch(process.platform){case"win32":if(v=process.env.APPDATA,!v){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");v=e.join(b,"AppData","Roaming")}break;case"darwin":v=e.join(A.homedir(),"Library","Application Support");break;case"linux":v=process.env.XDG_CONFIG_HOME||e.join(A.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(v,k)}return{getUserDataPath:l}}if(typeof define=="function")define(oe[189],ae([190,34,36]),function(e,A,N){return ie(e,A,N.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),A=require("os");module.exports=ie(e,A,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(oe[97],ae([0,1,34,186,189]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class O extends N.AbstractNativeEnvironmentService{constructor(v,R){super(v,{homeDir:(0,A.homedir)(),tmpDir:(0,A.tmpdir)(),userDataDir:(0,l.getUserDataPath)(v,R.nameShort)},R)}}e.NativeEnvironmentService=O;function T(I,v){return(0,N.parseDebugParams)(I["inspect-ptyhost"],I["inspect-brk-ptyhost"],5877,v,I.extensionEnvironment)}e.parsePtyHostDebugPort=T;function k(I,v){return(0,N.parseDebugParams)(I["inspect-sharedprocess"],I["inspect-brk-sharedprocess"],5879,v,I.extensionEnvironment)}e.parseSharedProcessDebugPort=k}),define(oe[191],ae([0,1,11,157]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function l(T,k,I){try{O(T,k,I)}catch(v){console.error(v?.message??v)}return T}e.localizeManifest=l;function O(T,k,I){const v=(R,b,m)=>{const g=R[b];if((0,A.isString)(g)){const p=g,E=p.length;if(E>1&&p[0]==="%"&&p[E-1]==="%"){const a=p.substr(1,E-2);let h=k[a];h===void 0&&I&&(h=I[a]);const u=typeof h=="string"?h:h?.message,d=I?.[a],S=typeof d=="string"?d:d?.message;if(!u){S||console.warn(`[${T.name}]: ${(0,N.localize)(0,null,a)}`);return}if(m&&(b==="title"||b==="category")&&S&&S!==u){const L={value:u,original:S};R[b]=L}else R[b]=u}}else if((0,A.isObject)(g))for(const p in g)g.hasOwnProperty(p)&&(p==="commands"?v(g,p,!0):v(g,p,m));else if(Array.isArray(g))for(let p=0;p<g.length;p++)v(g,p,m)};for(const R in T)T.hasOwnProperty(R)&&v(T,R)}}),define(oe[192],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class A{constructor(O){this.a=O}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(O){return this.a.call("promptImportantExtensionsInstallNotification",[O])}promptWorkspaceRecommendations(O){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=A;class N{constructor(O){this.a=O}listen(O,T){throw new Error(`Event not found: ${T}`)}call(O,T,k){switch(T){case"promptImportantExtensionsInstallNotification":return this.a.promptImportantExtensionsInstallNotification(k[0])}throw new Error(`Call not found: ${T}`)}}e.ExtensionRecommendationNotificationServiceChannel=N}),define(oe[68],ae([0,1,22,90,161,54]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const T=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,k=/^-(\d{4})(\d{2})(\d{2})$/;function I(h){return h=h.trim(),h==="*"||T.test(h)}e.isValidVersionStr=I;function v(h){if(!I(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=h.match(T);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}e.parseVersion=v;function R(h){if(!h)return null;const u=h.majorBase,d=h.majorMustEqual,S=h.minorBase;let L=h.minorMustEqual;const n=h.patchBase;let r=h.patchMustEqual;h.hasCaret&&(u===0||(L=!1),r=!1);let t=0;if(h.preRelease){const i=k.exec(h.preRelease);if(i){const[,s,o,c]=i;t=Date.UTC(Number(s),Number(o)-1,Number(c))}}return{majorBase:u,majorMustEqual:d,minorBase:S,minorMustEqual:L,patchBase:n,patchMustEqual:r,isMinimum:h.hasGreaterEquals,notBefore:t}}e.normalizeVersion=R;function b(h,u,d){let S;typeof h=="string"?S=R(v(h)):S=h;let L;u instanceof Date?L=u.getTime():typeof u=="string"&&(L=new Date(u).getTime());let n;if(typeof d=="string"?n=R(v(d)):n=d,!S||!n)return!1;const r=S.majorBase,t=S.minorBase,i=S.patchBase;let s=n.majorBase,o=n.minorBase,c=n.patchBase;const y=n.notBefore;let w=n.majorMustEqual,f=n.minorMustEqual,P=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:t>o?!0:t<o||L&&L<y?!1:i>=c:(r===1&&s===0&&(!w||!f||!P)&&(s=1,o=0,c=0,w=!0,f=!1,P=!1),r<s?!1:r>s?!w:t<o?!1:t>o?!f:i<c?!1:i>c?!P:!(L&&L<y))}e.isValidVersion=b;function m(h,u,d,S,L){const n=[];if(typeof S.publisher<"u"&&typeof S.publisher!="string")return n.push([N.default.Error,l.localize(0,null)]),n;if(typeof S.name!="string")return n.push([N.default.Error,l.localize(1,null,"name")]),n;if(typeof S.version!="string")return n.push([N.default.Error,l.localize(2,null,"version")]),n;if(!S.engines)return n.push([N.default.Error,l.localize(3,null,"engines")]),n;if(typeof S.engines.vscode!="string")return n.push([N.default.Error,l.localize(4,null,"engines.vscode")]),n;if(typeof S.extensionDependencies<"u"&&!a(S.extensionDependencies))return n.push([N.default.Error,l.localize(5,null,"extensionDependencies")]),n;if(typeof S.activationEvents<"u"){if(!a(S.activationEvents))return n.push([N.default.Error,l.localize(6,null,"activationEvents")]),n;if(typeof S.main>"u"&&typeof S.browser>"u")return n.push([N.default.Error,l.localize(7,null,"activationEvents","main","browser")]),n}if(typeof S.extensionKind<"u"&&typeof S.main>"u"&&n.push([N.default.Warning,l.localize(8,null,"extensionKind")]),typeof S.main<"u"){if(typeof S.main!="string")return n.push([N.default.Error,l.localize(9,null,"main")]),n;{const i=(0,A.joinPath)(d,S.main);(0,A.isEqualOrParent)(i,d)||n.push([N.default.Warning,l.localize(10,null,i.path,d.path)])}}if(typeof S.browser<"u"){if(typeof S.browser!="string")return n.push([N.default.Error,l.localize(11,null,"browser")]),n;{const i=(0,A.joinPath)(d,S.browser);(0,A.isEqualOrParent)(i,d)||n.push([N.default.Warning,l.localize(12,null,i.path,d.path)])}}if(!O.valid(S.version))return n.push([N.default.Error,l.localize(13,null)]),n;const r=[];if(!g(h,u,S,L,r))for(const i of r)n.push([N.default.Error,i]);return n}e.validateExtensionManifest=m;function g(h,u,d,S,L){return S||typeof d.main>"u"&&typeof d.browser>"u"?!0:E(h,u,d.engines.vscode,L)}e.isValidExtensionVersion=g;function p(h,u,d){return h==="*"||E(u,d,h)}e.isEngineValid=p;function E(h,u,d,S=[]){const L=R(v(d));if(!L)return S.push(l.localize(14,null,d)),!1;if(L.majorBase===0){if(!L.majorMustEqual||!L.minorMustEqual)return S.push(l.localize(15,null,d)),!1}else if(!L.majorMustEqual)return S.push(l.localize(16,null,d)),!1;return b(h,u,L)?!0:(S.push(l.localize(17,null,h,d)),!1)}function a(h){if(!Array.isArray(h))return!1;for(let u=0,d=h.length;u<d;u++)if(typeof h[u]!="string")return!1;return!0}}),define(oe[44],ae([0,1,16,32]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function l(O,T,k){let I=k&&k.get("storage.serviceMachineId",-1)||null;if(I)return I;try{const R=(await T.readFile(O.serviceMachineIdResource)).value.toString();I=(0,N.isUUID)(R)?R:null}catch{I=null}if(!I){I=(0,N.generateUuid)();try{await T.writeFile(O.serviceMachineIdResource,A.VSBuffer.fromString(I))}catch{}}return k?.store("storage.serviceMachineId",I,-1,1),I}e.getServiceMachineId=l}),define(oe[69],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class A{constructor(l,O=[],T=!1){this.ctor=l,this.staticArguments=O,this.supportsDelayedInstantiation=T}}e.SyncDescriptor=A}),define(oe[193],ae([0,1,69]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const N=[];var l;(function(k){k[k.Eager=0]="Eager",k[k.Delayed=1]="Delayed"})(l||(e.InstantiationType=l={}));function O(k,I,v){I instanceof A.SyncDescriptor||(I=new A.SyncDescriptor(I,[],!!v)),N.push([k,I])}e.registerSingleton=O;function T(){return N}e.getSingletonServiceDescriptors=T}),define(oe[194],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class A{constructor(O,T){this.key=O,this.data=T,this.incoming=new Map,this.outgoing=new Map}}e.Node=A;class N{constructor(O){this.b=O,this.a=new Map}roots(){const O=[];for(const T of this.a.values())T.outgoing.size===0&&O.push(T);return O}insertEdge(O,T){const k=this.lookupOrInsertNode(O),I=this.lookupOrInsertNode(T);k.outgoing.set(I.key,I),I.incoming.set(k.key,k)}removeNode(O){const T=this.b(O);this.a.delete(T);for(const k of this.a.values())k.outgoing.delete(T),k.incoming.delete(T)}lookupOrInsertNode(O){const T=this.b(O);let k=this.a.get(T);return k||(k=new A(T,O),this.a.set(T,k)),k}lookup(O){return this.a.get(this.b(O))}isEmpty(){return this.a.size===0}toString(){const O=[];for(const[T,k]of this.a)O.push(`${T}
	(-> incoming)[${[...k.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...k.outgoing.keys()].join(",")}]
`);return O.join(`
`)}findCycleSlow(){for(const[O,T]of this.a){const k=new Set([O]),I=this.c(T,k);if(I)return I}}c(O,T){for(const[k,I]of O.outgoing){if(T.has(k))return[...T,k].join(" -> ");T.add(k);const v=this.c(I,T);if(v)return v;T.delete(k)}}}e.Graph=N}),define(oe[5],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var A;(function(T){T.serviceIds=new Map,T.DI_TARGET="$di$target",T.DI_DEPENDENCIES="$di$dependencies";function k(I){return I[T.DI_DEPENDENCIES]||[]}T.getServiceDependencies=k})(A||(e._util=A={})),e.IInstantiationService=l("instantiationService");function N(T,k,I){k[A.DI_TARGET]===k?k[A.DI_DEPENDENCIES].push({id:T,index:I}):(k[A.DI_DEPENDENCIES]=[{id:T,index:I}],k[A.DI_TARGET]=k)}function l(T){if(A.serviceIds.has(T))return A.serviceIds.get(T);const k=function(I,v,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(k,I,R)};return k.toString=()=>T,A.serviceIds.set(T,k),k}e.createDecorator=l;function O(T){return T}e.refineServiceDecorator=O}),define(oe[195],ae([0,1,5]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,A.createDecorator)("checksumService")}),define(oe[17],ae([0,1,11,12,5]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function O(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof N.URI)}e.isConfigurationOverrides=O;function T(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof N.URI)}e.isConfigurationUpdateOverrides=T;var k;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(k||(e.ConfigurationTarget=k={}));function I(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=I;function v(a,h){const u=Object.create(null);for(const d in a)R(u,d,a[d],h);return u}e.toValuesTree=v;function R(a,h,u,d){const S=h.split("."),L=S.pop();let n=a;for(let r=0;r<S.length;r++){const t=S[r];let i=n[t];switch(typeof i){case"undefined":i=n[t]=Object.create(null);break;case"object":break;default:d(`Ignoring ${h} as ${S.slice(0,r+1).join(".")} is ${JSON.stringify(i)}`);return}n=i}if(typeof n=="object"&&n!==null)try{n[L]=u}catch{d(`Ignoring ${h} as ${S.join(".")} is ${JSON.stringify(n)}`)}else d(`Ignoring ${h} as ${S.join(".")} is ${JSON.stringify(n)}`)}e.addToValueTree=R;function b(a,h){const u=h.split(".");m(a,u)}e.removeFromValueTree=b;function m(a,h){const u=h.shift();if(h.length===0){delete a[u];return}if(Object.keys(a).indexOf(u)!==-1){const d=a[u];typeof d=="object"&&!Array.isArray(d)&&(m(d,h),Object.keys(d).length===0&&delete a[u])}}function g(a,h,u){function d(n,r){let t=n;for(const i of r){if(typeof t!="object"||t===null)return;t=t[i]}return t}const S=h.split("."),L=d(a,S);return typeof L>"u"?u:L}e.getConfigurationValue=g;function p(a,h,u){Object.keys(h).forEach(d=>{d!=="__proto__"&&(d in a?A.isObject(a[d])&&A.isObject(h[d])?p(a[d],h[d],u):u&&(a[d]=h[d]):a[d]=h[d])})}e.merge=p;function E(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=E}),define(oe[70],ae([0,1,4,27,185,5,151,9]),function(ie,e,A,N,l,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",A.isMacintosh),I.set("isLinux",A.isLinux),I.set("isWindows",A.isWindows),I.set("isWeb",A.isWeb),I.set("isMacNative",A.isMacintosh&&!A.isWeb),I.set("isEdge",A.isEdge),I.set("isFirefox",A.isFirefox),I.set("isChrome",A.isChrome),I.set("isSafari",A.isSafari);function v(F,C){if(I.get(F)!==void 0)throw(0,k.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");I.set(F,C)}e.setConstant=v;const R=Object.prototype.hasOwnProperty;var b;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const m={regexParsingWithErrorRecovery:!0},g=(0,T.localize)(0,null),p=(0,T.localize)(1,null),E=(0,T.localize)(2,null),a=(0,T.localize)(3,null),h=(0,T.localize)(4,null),u=(0,T.localize)(5,null),d=(0,T.localize)(6,null),S=(0,T.localize)(7,null);class L{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(C=m){this.k=C,this.d=new l.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(C){if(C===""){this.h.push({message:g,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(C).scan(),this.g=0,this.h=[];try{const U=this.l();if(!this.E()){const q=this.D(),G=q.type===17?u:void 0;throw this.h.push({message:h,offset:q.offset,lexeme:l.Scanner.getLexeme(q),additionalInfo:G}),L.c}return U}catch(U){if(U!==L.c)throw U;return}}l(){return this.m()}m(){const C=[this.o()];for(;this.y(16);){const U=this.o();C.push(U)}return C.length===1?C[0]:n.or(...C)}o(){const C=[this.s()];for(;this.y(15);){const U=this.s();C.push(U)}return C.length===1?C[0]:n.and(...C)}s(){if(this.y(2)){const C=this.D();switch(C.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const U=this.l();return this.A(1,a),U?.negate()}case 17:return this.z(),D.create(C.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",C)}}return this.t()}t(){const C=this.D();switch(C.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const U=this.l();return this.A(1,a),U}case 17:{const U=C.lexeme;if(this.z(),this.y(9)){const G=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),G.type!==10)throw this.B("REGEX",G);const V=G.lexeme,Z=V.lastIndexOf("/"),ee=Z===V.length-1?void 0:this.w(V.substring(Z+1));let ce;try{ce=new RegExp(V.substring(1,Z),ee)}catch{throw this.B("REGEX",G)}return Q.create(U,ce)}switch(G.type){case 10:case 19:{const V=[G.lexeme];this.z();let Z=this.D(),ee=0;for(let Se=0;Se<G.lexeme.length;Se++)G.lexeme.charCodeAt(Se)===40?ee++:G.lexeme.charCodeAt(Se)===41&&ee--;for(;!this.E()&&Z.type!==15&&Z.type!==16;){switch(Z.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let Se=0;Se<Z.lexeme.length;Se++)Z.lexeme.charCodeAt(Se)===40?ee++:G.lexeme.charCodeAt(Se)===41&&ee--}if(ee<0)break;V.push(l.Scanner.getLexeme(Z)),this.z(),Z=this.D()}const ce=V.join(""),ue=ce.lastIndexOf("/"),de=ue===ce.length-1?void 0:this.w(ce.substring(ue+1));let ye;try{ye=new RegExp(ce.substring(1,ue),de)}catch{throw this.B("REGEX",G)}return n.regex(U,ye)}case 18:{const V=G.lexeme;this.z();let Z=null;if(!(0,N.isFalsyOrWhitespace)(V)){const ee=V.indexOf("/"),ce=V.lastIndexOf("/");if(ee!==ce&&ee>=0){const ue=V.slice(ee+1,ce),de=V[ce+1]==="i"?"i":"";try{Z=new RegExp(ue,de)}catch{throw this.B("REGEX",G)}}}if(Z===null)throw this.B("REGEX",G);return Q.create(U,Z)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,E);const G=this.u();return n.notIn(U,G)}switch(this.D().type){case 3:{this.z();const G=this.u();if(this.x().type===18)return n.equals(U,G);switch(G){case"true":return n.has(U);case"false":return n.not(U);default:return n.equals(U,G)}}case 4:{this.z();const G=this.u();if(this.x().type===18)return n.notEquals(U,G);switch(G){case"true":return n.not(U);case"false":return n.has(U);default:return n.notEquals(U,G)}}case 5:return this.z(),W.create(U,this.u());case 6:return this.z(),H.create(U,this.u());case 7:return this.z(),j.create(U,this.u());case 8:return this.z(),B.create(U,this.u());case 13:return this.z(),n.in(U,this.u());default:return n.has(U)}}case 20:throw this.h.push({message:d,offset:C.offset,lexeme:"",additionalInfo:S}),L.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const C=this.D();switch(C.type){case 17:case 18:return this.z(),C.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(C){return C.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(C){return this.C(C)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(C,U){if(this.C(C))return this.z();throw this.B(U,this.D())}B(C,U,q){const G=(0,T.localize)(8,null,C,l.Scanner.getLexeme(U)),V=U.offset,Z=l.Scanner.getLexeme(U);return this.h.push({message:G,offset:V,lexeme:Z,additionalInfo:q}),L.c}C(C){return this.D().type===C}D(){return this.f[this.g]}E(){return this.D().type===20}}e.Parser=L,L.c=new Error;class n{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(C){return c.create(C)}static equals(C,U){return y.create(C,U)}static notEquals(C,U){return P.create(C,U)}static regex(C,U){return Q.create(C,U)}static in(C,U){return w.create(C,U)}static notIn(C,U){return f.create(C,U)}static not(C){return D.create(C)}static and(...C){return $.create(C,null,!0)}static or(...C){return z.create(C,null,!0)}static greater(C,U){return j.create(C,U)}static greaterEquals(C,U){return B.create(C,U)}static smaller(C,U){return W.create(C,U)}static smallerEquals(C,U){return H.create(C,U)}static deserialize(C){return C==null?void 0:this.c.parse(C)}}e.ContextKeyExpr=n,n.c=new L({regexParsingWithErrorRecovery:!1});function r(F){const C=new L({regexParsingWithErrorRecovery:!1});return F.map(U=>(C.parse(U),C.lexingErrors.length>0?C.lexingErrors.map(q=>({errorMessage:q.additionalInfo?(0,T.localize)(9,null,q.additionalInfo):(0,T.localize)(10,null),offset:q.offset,length:q.lexeme.length})):C.parsingErrors.length>0?C.parsingErrors.map(q=>({errorMessage:q.additionalInfo?`${q.message}. ${q.additionalInfo}`:q.message,offset:q.offset,length:q.lexeme.length})):[]))}e.validateWhenClauses=r;function t(F,C){const U=F?F.substituteConstants():void 0,q=C?C.substituteConstants():void 0;return!U&&!q?!0:!U||!q?!1:U.equals(q)}e.expressionsAreEqualWithConstantSubstitution=t;function i(F,C){return F.cmp(C)}class s{constructor(){this.type=0}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!1}serialize(){return"false"}keys(){return[]}map(C){return this}negate(){return o.INSTANCE}}e.ContextKeyFalseExpr=s,s.INSTANCE=new s;class o{constructor(){this.type=1}cmp(C){return this.type-C.type}equals(C){return C.type===this.type}substituteConstants(){return this}evaluate(C){return!0}serialize(){return"true"}keys(){return[]}map(C){return this}negate(){return s.INSTANCE}}e.ContextKeyTrueExpr=o,o.INSTANCE=new o;class c{static create(C,U=null){const q=I.get(C);return typeof q=="boolean"?q?o.INSTANCE:s.INSTANCE:new c(C,U)}constructor(C,U){this.key=C,this.c=U,this.type=2}cmp(C){return C.type!==this.type?this.type-C.type:te(this.key,C.key)}equals(C){return C.type===this.type?this.key===C.key:!1}substituteConstants(){const C=I.get(this.key);return typeof C=="boolean"?C?o.INSTANCE:s.INSTANCE:this}evaluate(C){return!!C.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(C){return C.mapDefined(this.key)}negate(){return this.c||(this.c=D.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=c;class y{static create(C,U,q=null){if(typeof U=="boolean")return U?c.create(C,q):D.create(C,q);const G=I.get(C);return typeof G=="boolean"?U===(G?"true":"false")?o.INSTANCE:s.INSTANCE:new y(C,U,q)}constructor(C,U,q){this.c=C,this.d=U,this.f=q,this.type=4}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=I.get(this.c);if(typeof C=="boolean"){const U=C?"true":"false";return this.d===U?o.INSTANCE:s.INSTANCE}return this}evaluate(C){return C.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(C){return C.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=P.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=y;class w{static create(C,U){return new w(C,U)}constructor(C,U){this.d=C,this.f=U,this.type=10,this.c=null}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.d,this.f,C.d,C.f)}equals(C){return C.type===this.type?this.d===C.d&&this.f===C.f:!1}substituteConstants(){return this}evaluate(C){const U=C.getValue(this.f),q=C.getValue(this.d);return Array.isArray(U)?U.includes(q):typeof q=="string"&&typeof U=="object"&&U!==null?R.call(U,q):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(C){return C.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=w;class f{static create(C,U){return new f(C,U)}constructor(C,U){this.d=C,this.f=U,this.type=11,this.c=w.create(C,U)}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(C){return C.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=f;class P{static create(C,U,q=null){if(typeof U=="boolean")return U?D.create(C,q):c.create(C,q);const G=I.get(C);return typeof G=="boolean"?U===(G?"true":"false")?s.INSTANCE:o.INSTANCE:new P(C,U,q)}constructor(C,U,q){this.c=C,this.d=U,this.f=q,this.type=5}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){const C=I.get(this.c);if(typeof C=="boolean"){const U=C?"true":"false";return this.d===U?s.INSTANCE:o.INSTANCE}return this}evaluate(C){return C.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(C){return C.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=P;class D{static create(C,U=null){const q=I.get(C);return typeof q=="boolean"?q?s.INSTANCE:o.INSTANCE:new D(C,U)}constructor(C,U){this.c=C,this.d=U,this.type=3}cmp(C){return C.type!==this.type?this.type-C.type:te(this.c,C.c)}equals(C){return C.type===this.type?this.c===C.c:!1}substituteConstants(){const C=I.get(this.c);return typeof C=="boolean"?C?s.INSTANCE:o.INSTANCE:this}evaluate(C){return!C.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(C){return C.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.ContextKeyNotExpr=D;function M(F,C){if(typeof F=="string"){const U=parseFloat(F);isNaN(U)||(F=U)}return typeof F=="string"||typeof F=="number"?C(F):s.INSTANCE}class j{static create(C,U,q=null){return M(U,G=>new j(C,G,q))}constructor(C,U,q){this.c=C,this.d=U,this.f=q,this.type=12}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=j;class B{static create(C,U,q=null){return M(U,G=>new B(C,G,q))}constructor(C,U,q){this.c=C,this.d=U,this.f=q,this.type=13}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(C){return C.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=B;class W{static create(C,U,q=null){return M(U,G=>new W(C,G,q))}constructor(C,U,q){this.c=C,this.d=U,this.f=q,this.type=14}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=W;class H{static create(C,U,q=null){return M(U,G=>new H(C,G,q))}constructor(C,U,q){this.c=C,this.d=U,this.f=q,this.type=15}cmp(C){return C.type!==this.type?this.type-C.type:ne(this.c,this.d,C.c,C.d)}equals(C){return C.type===this.type?this.c===C.c&&this.d===C.d:!1}substituteConstants(){return this}evaluate(C){return typeof this.d=="string"?!1:parseFloat(C.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(C){return C.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=j.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=H;class Q{static create(C,U){return new Q(C,U)}constructor(C,U){this.d=C,this.f=U,this.type=7,this.c=null}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.d<C.d)return-1;if(this.d>C.d)return 1;const U=this.f?this.f.source:"",q=C.f?C.f.source:"";return U<q?-1:U>q?1:0}equals(C){if(C.type===this.type){const U=this.f?this.f.source:"",q=C.f?C.f.source:"";return this.d===C.d&&U===q}return!1}substituteConstants(){return this}evaluate(C){const U=C.getValue(this.d);return this.f?this.f.test(U):!1}serialize(){const C=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${C}`}keys(){return[this.d]}map(C){return C.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=_.create(this)),this.c}}e.ContextKeyRegexExpr=Q;class _{static create(C){return new _(C)}constructor(C){this.c=C,this.type=8}cmp(C){return C.type!==this.type?this.type-C.type:this.c.cmp(C.c)}equals(C){return C.type===this.type?this.c.equals(C.c):!1}substituteConstants(){return this}evaluate(C){return!this.c.evaluate(C)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(C){return new _(this.c.map(C))}negate(){return this.c}}e.ContextKeyNotRegexExpr=_;function Y(F){let C=null;for(let U=0,q=F.length;U<q;U++){const G=F[U].substituteConstants();if(F[U]!==G&&C===null){C=[];for(let V=0;V<U;V++)C[V]=F[V]}C!==null&&(C[U]=G)}return C===null?F:C}class ${static create(C,U,q){return $.d(C,U,q)}constructor(C,U){this.expr=C,this.c=U,this.type=6}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let U=0,q=this.expr.length;U<q;U++){const G=i(this.expr[U],C.expr[U]);if(G!==0)return G}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let U=0,q=this.expr.length;U<q;U++)if(!this.expr[U].equals(C.expr[U]))return!1;return!0}return!1}substituteConstants(){const C=Y(this.expr);return C===this.expr?this:$.create(C,this.c,!1)}evaluate(C){for(let U=0,q=this.expr.length;U<q;U++)if(!this.expr[U].evaluate(C))return!1;return!0}static d(C,U,q){const G=[];let V=!1;for(const Z of C)if(Z){if(Z.type===1){V=!0;continue}if(Z.type===0)return s.INSTANCE;if(Z.type===6){G.push(...Z.expr);continue}G.push(Z)}if(G.length===0&&V)return o.INSTANCE;if(G.length!==0){if(G.length===1)return G[0];G.sort(i);for(let Z=1;Z<G.length;Z++)G[Z-1].equals(G[Z])&&(G.splice(Z,1),Z--);if(G.length===1)return G[0];for(;G.length>1;){const Z=G[G.length-1];if(Z.type!==9)break;G.pop();const ee=G.pop(),ce=G.length===0,ue=z.create(Z.expr.map(de=>$.create([de,ee],null,q)),null,ce);ue&&(G.push(ue),G.sort(i))}if(G.length===1)return G[0];if(q){for(let Z=0;Z<G.length;Z++)for(let ee=Z+1;ee<G.length;ee++)if(G[Z].negate().equals(G[ee]))return s.INSTANCE;if(G.length===1)return G[0]}return new $(G,U)}}serialize(){return this.expr.map(C=>C.serialize()).join(" && ")}keys(){const C=[];for(const U of this.expr)C.push(...U.keys());return C}map(C){return new $(this.expr.map(U=>U.map(C)),null)}negate(){if(!this.c){const C=[];for(const U of this.expr)C.push(U.negate());this.c=z.create(C,this,!0)}return this.c}}e.ContextKeyAndExpr=$;class z{static create(C,U,q){return z.d(C,U,q)}constructor(C,U){this.expr=C,this.c=U,this.type=9}cmp(C){if(C.type!==this.type)return this.type-C.type;if(this.expr.length<C.expr.length)return-1;if(this.expr.length>C.expr.length)return 1;for(let U=0,q=this.expr.length;U<q;U++){const G=i(this.expr[U],C.expr[U]);if(G!==0)return G}return 0}equals(C){if(C.type===this.type){if(this.expr.length!==C.expr.length)return!1;for(let U=0,q=this.expr.length;U<q;U++)if(!this.expr[U].equals(C.expr[U]))return!1;return!0}return!1}substituteConstants(){const C=Y(this.expr);return C===this.expr?this:z.create(C,this.c,!1)}evaluate(C){for(let U=0,q=this.expr.length;U<q;U++)if(this.expr[U].evaluate(C))return!0;return!1}static d(C,U,q){let G=[],V=!1;if(C){for(let Z=0,ee=C.length;Z<ee;Z++){const ce=C[Z];if(ce){if(ce.type===0){V=!0;continue}if(ce.type===1)return o.INSTANCE;if(ce.type===9){G=G.concat(ce.expr);continue}G.push(ce)}}if(G.length===0&&V)return s.INSTANCE;G.sort(i)}if(G.length!==0){if(G.length===1)return G[0];for(let Z=1;Z<G.length;Z++)G[Z-1].equals(G[Z])&&(G.splice(Z,1),Z--);if(G.length===1)return G[0];if(q){for(let Z=0;Z<G.length;Z++)for(let ee=Z+1;ee<G.length;ee++)if(G[Z].negate().equals(G[ee]))return o.INSTANCE;if(G.length===1)return G[0]}return new z(G,U)}}serialize(){return this.expr.map(C=>C.serialize()).join(" || ")}keys(){const C=[];for(const U of this.expr)C.push(...U.keys());return C}map(C){return new z(this.expr.map(U=>U.map(C)),null)}negate(){if(!this.c){const C=[];for(const U of this.expr)C.push(U.negate());for(;C.length>1;){const U=C.shift(),q=C.shift(),G=[];for(const V of K(U))for(const Z of K(q))G.push($.create([V,Z],null,!1));C.unshift(z.create(G,null,!1))}this.c=z.create(C,this,!0)}return this.c}}e.ContextKeyOrExpr=z;class x extends c{static all(){return x.d.values()}constructor(C,U,q){super(C,null),this.f=U,typeof q=="object"?x.d.push({...q,key:C}):q!==!0&&x.d.push({key:C,description:q,type:U!=null?typeof U:void 0})}bindTo(C){return C.createKey(this.key,this.f)}getValue(C){return C.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(C){return y.create(this.key,C)}notEqualsTo(C){return P.create(this.key,C)}}e.RawContextKey=x,x.d=[],e.IContextKeyService=(0,O.createDecorator)("contextKeyService");function te(F,C){return F<C?-1:F>C?1:0}function ne(F,C,U,q){return F<U?-1:F>U?1:C<q?-1:C>q?1:0}function re(F,C){if(F.type===0||C.type===1)return!0;if(F.type===9)return C.type===9?X(F.expr,C.expr):!1;if(C.type===9){for(const U of C.expr)if(re(F,U))return!0;return!1}if(F.type===6){if(C.type===6)return X(C.expr,F.expr);for(const U of F.expr)if(re(U,C))return!0;return!1}return F.equals(C)}e.implies=re;function X(F,C){let U=0,q=0;for(;U<F.length&&q<C.length;){const G=F[U].cmp(C[q]);if(G<0)return!1;G===0&&U++,q++}return U===F.length}function K(F){return F.type===9?F.expr:[F]}}),define(oe[98],ae([0,1,5]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,A.createDecorator)(e.ID);function N(O){return!!O.hostName&&!!O.errorMessage}e.isRemoteDiagnosticError=N;class l{async getPerformanceInfo(T,k){return{}}async getSystemInfo(T,k){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(T,k){return""}async getWorkspaceFileExtensions(T){return{extensions:[]}}async reportWorkspaceStats(T){}}e.NullDiagnosticsService=l}),define(oe[99],ae([0,1,5]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,A.createDecorator)("downloadService")}),define(oe[15],ae([0,1,5]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,A.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,A.refineServiceDecorator)(e.IEnvironmentService)}),define(oe[29],ae([0,1,156,5]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(u){switch(u){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function O(u){switch(u){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=O;function T(u,d){switch(u){case 3:return d==="x64"?"win32-x64":d==="ia32"?"win32-ia32":d==="arm64"?"win32-arm64":"unknown";case 2:return d==="x64"?"linux-x64":d==="arm64"?"linux-arm64":d==="arm"?"linux-armhf":"unknown";case"alpine":return d==="x64"?"alpine-x64":d==="arm64"?"alpine-arm64":"unknown";case 1:return d==="x64"?"darwin-x64":d==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=T;function k(u,d){return d==="web"&&!u.includes("web")}e.isNotWebExtensionInWebTargetPlatform=k;function I(u,d,S){return k(d,S)?!1:u==="undefined"||u==="universal"?!0:u==="unknown"?!1:u===S?!0:v(S).includes(u)}e.isTargetPlatformCompatible=I;function v(u){switch(u){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=v;function R(u){return u&&typeof u=="object"&&typeof u.id=="string"&&(!u.uuid||typeof u.uuid=="string")}e.isIExtensionIdentifier=R;var b;(function(u){u[u.NoneOrRelevance=0]="NoneOrRelevance",u[u.LastUpdatedDate=1]="LastUpdatedDate",u[u.Title=2]="Title",u[u.PublisherName=3]="PublisherName",u[u.InstallCount=4]="InstallCount",u[u.PublishedDate=10]="PublishedDate",u[u.AverageRating=6]="AverageRating",u[u.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var m;(function(u){u[u.Default=0]="Default",u[u.Ascending=1]="Ascending",u[u.Descending=2]="Descending"})(m||(e.SortOrder=m={}));var g;(function(u){u.Install="install",u.Uninstall="uninstall"})(g||(e.StatisticType=g={}));var p;(function(u){u[u.None=1]="None",u[u.Install=2]="Install",u[u.Update=3]="Update",u[u.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.IExtensionGalleryService=(0,N.createDecorator)("extensionGalleryService");var E;(function(u){u.Unsupported="Unsupported",u.Deprecated="Deprecated",u.Malicious="Malicious",u.Incompatible="Incompatible",u.IncompatiblePreRelease="IncompatiblePreRelease",u.IncompatibleTargetPlatform="IncompatibleTargetPlatform",u.ReleaseVersionNotFound="ReleaseVersionNotFound",u.Invalid="Invalid",u.Download="Download",u.Extract="Extract",u.Delete="Delete",u.Rename="Rename",u.CorruptZip="CorruptZip",u.IncompleteZip="IncompleteZip",u.Signature="Signature",u.Internal="Internal"})(E||(e.ExtensionManagementErrorCode=E={}));var a;(function(u){u.UnknownError="UnknownError",u.PackageIsInvalidZip="PackageIsInvalidZip",u.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(a||(e.ExtensionSignaturetErrorCode=a={}));class h extends Error{constructor(d,S){super(d),this.code=S,this.name=S}}e.ExtensionManagementError=h,e.IExtensionManagementService=(0,N.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,N.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,N.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,A.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,A.localize)(1,null),original:"Preferences"}}),define(oe[196],ae([0,1,3,2,31,12,93,29]),function(ie,e,A,N,l,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(a,h){return a?O.URI.revive(h?h.transformIncoming(a):a):void 0}function v(a,h){return h?h.transformOutgoingURI(a):a}function R(a,h){h=h||T.DefaultURITransformer;const u=a.manifest;return{...(0,T.transformAndReviveIncomingURIs)({...a,manifest:void 0},h),manifest:u}}function b(a,h){return a?.profileLocation?(0,T.transformAndReviveIncomingURIs)(a,h??T.DefaultURITransformer):a}function m(a,h){return h?(0,l.cloneAndChange)(a,u=>u instanceof O.URI?h.transformOutgoingURI(u):void 0):a}class g{constructor(h,u){this.a=h,this.b=u,this.onInstallExtension=A.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=A.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=A.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=A.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=A.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,u){const d=this.b(h);switch(u){case"onInstallExtension":return A.Event.map(this.onInstallExtension,S=>({...S,profileLocation:S.profileLocation?v(S.profileLocation,d):S.profileLocation}));case"onDidInstallExtensions":return A.Event.map(this.onDidInstallExtensions,S=>S.map(L=>({...L,local:L.local?m(L.local,d):L.local,profileLocation:L.profileLocation?v(L.profileLocation,d):L.profileLocation})));case"onUninstallExtension":return A.Event.map(this.onUninstallExtension,S=>({...S,profileLocation:S.profileLocation?v(S.profileLocation,d):S.profileLocation}));case"onDidUninstallExtension":return A.Event.map(this.onDidUninstallExtension,S=>({...S,profileLocation:S.profileLocation?v(S.profileLocation,d):S.profileLocation}));case"onDidUpdateExtensionMetadata":return A.Event.map(this.onDidUpdateExtensionMetadata,S=>m(S,d))}throw new Error("Invalid listen")}async call(h,u,d){const S=this.b(h);switch(u){case"zip":{const L=R(d[0],S),n=await this.a.zip(L);return v(n,S)}case"unzip":return this.a.unzip(I(d[0],S));case"install":return this.a.install(I(d[0],S),b(d[1],S));case"installFromLocation":return this.a.installFromLocation(I(d[0],S),I(d[1],S));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(d[0],I(d[1],S),I(d[2],S));case"getManifest":return this.a.getManifest(I(d[0],S));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(d[0]);case"installFromGallery":return this.a.installFromGallery(d[0],b(d[1],S));case"uninstall":return this.a.uninstall(R(d[0],S),b(d[1],S));case"reinstallFromGallery":return this.a.reinstallFromGallery(R(d[0],S));case"getInstalled":return(await this.a.getInstalled(d[0],I(d[1],S))).map(n=>m(n,S));case"copyExtensions":return this.a.copyExtensions(I(d[0],S),I(d[1],S));case"updateMetadata":{const L=await this.a.updateMetadata(R(d[0],S),d[1],I(d[2],S));return m(L,S)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(d[0],d[1],d[2]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=g;class p extends N.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.k=h,this.c=this.B(new A.Emitter),this.f=this.B(new A.Emitter),this.g=this.B(new A.Emitter),this.h=this.B(new A.Emitter),this.j=this.B(new A.Emitter),this.B(this.k.listen("onInstallExtension")(u=>this.l(this.c,{...u,source:this.m(u.source)?O.URI.revive(u.source):u.source,profileLocation:O.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(u=>this.l(this.f,u.map(d=>({...d,local:d.local?R(d.local,null):d.local,source:this.m(d.source)?O.URI.revive(d.source):d.source,profileLocation:O.URI.revive(d.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(u=>this.l(this.g,{...u,profileLocation:O.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(u=>this.l(this.h,{...u,profileLocation:O.URI.revive(u.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(u=>this.j.fire(R(u,null))))}l(h,u){h.fire(u)}m(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(h){const u=await this.getTargetPlatform();return h.allTargetPlatforms.some(d=>(0,k.isTargetPlatformCompatible)(d,h.allTargetPlatforms,u))}zip(h){return Promise.resolve(this.k.call("zip",[h]).then(u=>O.URI.revive(u)))}unzip(h){return Promise.resolve(this.k.call("unzip",[h]))}install(h,u){return Promise.resolve(this.k.call("install",[h,u])).then(d=>R(d,null))}installFromLocation(h,u){return Promise.resolve(this.k.call("installFromLocation",[h,u])).then(d=>R(d,null))}async installExtensionsFromProfile(h,u,d){return(await this.k.call("installExtensionsFromProfile",[h,u,d])).map(L=>R(L,null))}getManifest(h){return Promise.resolve(this.k.call("getManifest",[h]))}installFromGallery(h,u){return Promise.resolve(this.k.call("installFromGallery",[h,u])).then(d=>R(d,null))}uninstall(h,u){return Promise.resolve(this.k.call("uninstall",[h,u]))}reinstallFromGallery(h){return Promise.resolve(this.k.call("reinstallFromGallery",[h])).then(u=>R(u,null))}getInstalled(h=null,u){return Promise.resolve(this.k.call("getInstalled",[h,u])).then(d=>d.map(S=>R(S,null)))}updateMetadata(h,u,d){return Promise.resolve(this.k.call("updateMetadata",[h,u,d])).then(S=>R(S,null))}copyExtensions(h,u){return this.k.call("copyExtensions",[h,u])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(h,u,d){const S=await this.k.call("download",[h,u,d]);return O.URI.revive(S)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=p;class E{constructor(h){this.a=h}listen(h,u){throw new Error("Invalid listen")}call(h,u,d){switch(u){case"getConfigBasedTips":return this.a.getConfigBasedTips(O.URI.revive(d[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=E}),define(oe[100],ae([0,1,5]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,A.createDecorator)("IExtensionSignatureVerificationService");class N{b(){return this.a||(this.a=new Promise((O,T)=>ie(["node-vsce-sign"],async k=>O(k),T))),this.a}async verify(O,T,k){let I;try{I=await this.b()}catch{return!1}return I.verify(O,T,k)}}e.ExtensionSignatureVerificationService=N}),define(oe[101],ae([0,1,5]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var N;(function(T){T[T.FILE=1]="FILE",T[T.WORKSPACE=2]="WORKSPACE",T[T.EXE=3]="EXE"})(N||(e.RecommendationSource=N={}));function l(T){switch(T){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=l;var O;(function(T){T.Ignored="ignored",T.Cancelled="cancelled",T.TooMany="toomany",T.IncompatibleWindow="incompatibleWindow",T.Accepted="reacted"})(O||(e.RecommendationsNotificationResult=O={})),e.IExtensionRecommendationNotificationService=(0,A.createDecorator)("IExtensionRecommendationNotificationService")}),define(oe[13],ae([0,1,48,14,27,11,12,163,5,4,24]),function(ie,e,A,N,l,O,T,k,I,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,I.createDecorator)("fileService");function b($){return $.create===!0}e.isFileOpenForWriteOptions=b;var m;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(m||(e.FileType=m={}));var g;(function($){$[$.Readonly=1]="Readonly"})(g||(e.FilePermission=g={}));var p;(function($){$[$.None=0]="None",$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileClone=32768]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function E($){return!!($.capabilities&2)}e.hasReadWriteCapability=E;function a($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=a;function h($){return!!($.capabilities&32768)}e.hasFileCloneCapability=h;function u($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=u;function d($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=d;function S($){return E($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=S;var L;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsStorageQuota="EntryExceedsStorageQuota",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(L||(e.FileSystemProviderErrorCode=L={}));class n extends Error{static create(z,x){const te=new n(z.toString(),x);return i(te,x),te}constructor(z,x){super(z),this.code=x}}e.FileSystemProviderError=n;function r($,z){return n.create($,z)}e.createFileSystemProviderError=r;function t($){return $||r((0,k.localize)(0,null),L.Unknown)}e.ensureFileSystemProviderError=t;function i($,z){return $.name=z?`${z} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=i;function s($){if(!$)return L.Unknown;if($ instanceof n)return $.code;const z=/^(.+) \(FileSystemError\)$/.exec($.name);if(!z)return L.Unknown;switch(z[1]){case L.FileExists:return L.FileExists;case L.FileIsADirectory:return L.FileIsADirectory;case L.FileNotADirectory:return L.FileNotADirectory;case L.FileNotFound:return L.FileNotFound;case L.FileTooLarge:return L.FileTooLarge;case L.FileWriteLocked:return L.FileWriteLocked;case L.NoPermissions:return L.NoPermissions;case L.Unavailable:return L.Unavailable}return L.Unknown}e.toFileSystemProviderErrorCode=s;function o($){if($ instanceof D)return $.fileOperationResult;switch(s($)){case L.FileNotFound:return 1;case L.FileIsADirectory:return 0;case L.FileNotADirectory:return 9;case L.FileWriteLocked:return 5;case L.NoPermissions:return 6;case L.FileExists:return 4;case L.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=o;var c;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(c||(e.FileOperation=c={}));class y{constructor(z,x,te){this.resource=z,this.operation=x,this.target=te}isOperation(z){return this.operation===z}}e.FileOperationEvent=y;var w;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(w||(e.FileChangeType=w={}));class f{constructor(z,x){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const te=new Map;for(const ne of z){const re=te.get(ne.type);switch(re?re.push([ne.resource,ne]):te.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,re]of te)switch(ne){case 1:this.a=A.TernarySearchTree.forUris(()=>x),this.a.fill(re);break;case 0:this.b=A.TernarySearchTree.forUris(()=>x),this.b.fill(re);break;case 2:this.c=A.TernarySearchTree.forUris(()=>x),this.c.fill(re);break}}contains(z,...x){return this.d(z,{includeChildren:!1},...x)}affects(z,...x){return this.d(z,{includeChildren:!0},...x)}d(z,x,...te){if(!z)return!1;const ne=te.length>0;return!!((!ne||te.includes(1))&&(this.a?.get(z)||x.includeChildren&&this.a?.findSuperstr(z))||(!ne||te.includes(0))&&(this.b?.get(z)||x.includeChildren&&this.b?.findSuperstr(z))||(!ne||te.includes(2))&&(this.c?.findSubstr(z)||x.includeChildren&&this.c?.findSuperstr(z)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=f;function P($,z,x){return!$||!z||$===z||z.length>$.length?!1:(z.charAt(z.length-1)!==N.sep&&(z+=N.sep),x?(0,l.startsWithIgnoreCase)($,z):$.indexOf(z)===0)}e.isParent=P;class D extends Error{constructor(z,x,te){super(z),this.fileOperationResult=x,this.options=te}}e.FileOperationError=D;class M extends D{constructor(z,x,te,ne){super(z,x,ne),this.fileOperationResult=x,this.size=te}}e.TooLargeFileOperationError=M;class j extends D{constructor(z,x,te){super(z,2,te),this.stat=x}}e.NotModifiedSinceFileOperationError=j;var B;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(B||(e.FileOperationResult=B={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var W;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(W||(e.FileKind=W={})),e.ETAG_DISABLED="";function H($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=H;async function Q($,z){if(!z.hasProvider(T.URI.from({scheme:$.scheme})))return new Promise(x=>{const te=z.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===$.scheme&&ne.added&&(te.dispose(),x())})})}e.whenProviderRegistered=Q;class _{static formatSize(z){return(0,O.isNumber)(z)||(z=0),z<_.KB?(0,k.localize)(1,null,z.toFixed(0)):z<_.MB?(0,k.localize)(2,null,(z/_.KB).toFixed(2)):z<_.GB?(0,k.localize)(3,null,(z/_.MB).toFixed(2)):z<_.TB?(0,k.localize)(4,null,(z/_.GB).toFixed(2)):(0,k.localize)(5,null,(z/_.TB).toFixed(2))}}e.ByteSize=_,_.KB=1024,_.MB=_.KB*_.KB,_.GB=_.MB*_.KB,_.TB=_.GB*_.KB;function Y($){const z=typeof $=="string"||$?.scheme===R.Schemas.vscodeRemote;return typeof $!="string"&&$?.scheme===R.Schemas.file?1024*_.MB:z?10*_.MB:v.isWeb?50*_.MB:1024*_.MB}e.getLargeFileConfirmationLimit=Y});var J=this&&this.__param||function(ie,e){return function(A,N){e(A,N,ie)}};define(oe[197],ae([0,1,71,43,13]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let O=e.ChecksumService=class{constructor(k){this.a=k}async checksum(k){const I=(await this.a.readFileStream(k)).value;return new Promise((v,R)=>{const b=(0,A.createHash)("md5");(0,N.listenStream)(I,{onData:m=>b.update(m.buffer),onError:m=>R(m),onEnd:()=>v(b.digest("base64").replace(/=+$/,""))})})}};e.ChecksumService=O=ve([J(0,l.IFileService)],O)}),define(oe[198],ae([0,1,16,38,9,3,2,43,12,32,13]),function(ie,e,A,N,l,O,T,k,I,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class b extends T.Disposable{constructor(g,p){super(),this.a=g,this.b=p,this.onDidChangeCapabilities=O.Event.None,this.f=this.B(new O.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new O.Emitter),this.onDidWatchError=this.g.event,this.h=(0,v.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(g){return this.a.call("stat",[g])}readdir(g){return this.a.call("readdir",[g])}async readFile(g,p){const{buffer:E}=await this.a.call("readFile",[g,p]);return E}readFileStream(g,p,E){const a=(0,k.newWriteableStream)(u=>A.VSBuffer.concat(u.map(d=>A.VSBuffer.wrap(d))).buffer),h=this.a.listen("readFileStream",[g,p])(u=>{if(u instanceof A.VSBuffer)a.write(u.buffer);else{if(u==="end")a.end();else{let d;if(u instanceof Error)d=u;else{const S=u;d=(0,R.createFileSystemProviderError)(S.message??(0,N.toErrorMessage)(S),S.code??R.FileSystemProviderErrorCode.Unknown)}a.error(d),a.end()}h.dispose()}});return E.onCancellationRequested(()=>{a.error((0,l.canceled)()),a.end(),h.dispose()}),a}writeFile(g,p,E){return this.a.call("writeFile",[g,A.VSBuffer.wrap(p),E])}open(g,p){return this.a.call("open",[g,p])}close(g){return this.a.call("close",[g])}async read(g,p,E,a,h){const[u,d]=await this.a.call("read",[g,p,h]);return E.set(u.buffer.slice(0,d),a),d}write(g,p,E,a,h){return this.a.call("write",[g,p,A.VSBuffer.wrap(E),a,h])}mkdir(g){return this.a.call("mkdir",[g])}delete(g,p){return this.a.call("delete",[g,p])}rename(g,p,E){return this.a.call("rename",[g,p,E])}copy(g,p,E){return this.a.call("copy",[g,p,E])}cloneFile(g,p){return this.a.call("cloneFile",[g,p])}i(){this.B(this.a.listen("fileChange",[this.h])(g=>{if(Array.isArray(g)){const p=g;this.f.fire(p.map(E=>({resource:I.URI.revive(E.resource),type:E.type})))}else{const p=g;this.g.fire(p)}}))}watch(g,p){const E=(0,v.generateUuid)();return this.a.call("watch",[this.h,E,g,p]),(0,T.toDisposable)(()=>this.a.call("unwatch",[this.h,E]))}}e.DiskFileSystemProviderClient=b}),define(oe[102],ae([0,1,16,9,164,13]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function T(R,b,m,g,p,E){let a;try{await k(R,b,m,g,p,E)}catch(h){a=h}finally{a&&p.errorTransformer&&(a=p.errorTransformer(a)),typeof a<"u"&&m.error(a),m.end()}}e.readFileIntoStream=T;async function k(R,b,m,g,p,E){I(E);const a=await R.open(b,{create:!1});try{I(E);let h=0,u=0,d=p&&typeof p.length=="number"?p.length:void 0,S=A.VSBuffer.alloc(Math.min(p.bufferSize,typeof d=="number"?d:p.bufferSize)),L=p&&typeof p.position=="number"?p.position:0,n=0;do u=await R.read(a,L,S.buffer,n,S.byteLength-n),L+=u,n+=u,h+=u,typeof d=="number"&&(d-=u),n===S.byteLength&&(await m.write(g(S)),S=A.VSBuffer.alloc(Math.min(p.bufferSize,typeof d=="number"?d:p.bufferSize)),n=0);while(u>0&&(typeof d!="number"||d>0)&&I(E)&&v(h,p));if(n>0){let r=n;typeof d=="number"&&(r=Math.min(n,d)),m.write(g(S.slice(0,r)))}}catch(h){throw(0,O.ensureFileSystemProviderError)(h)}finally{await R.close(a)}}function I(R){if(R.isCancellationRequested)throw(0,N.canceled)();return!0}function v(R,b){if(typeof b?.limits?.size=="number"&&R>b.limits.size)throw(0,O.createFileSystemProviderError)((0,l.localize)(0,null),O.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(oe[55],ae([0,1,92,2,14,4,12,13]),function(ie,e,A,N,l,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function I(h){return h.recursive===!0}e.isRecursiveWatchRequest=I;class v extends N.Disposable{constructor(u,d,S,L){super(),this.h=u,this.i=d,this.j=S,this.k=L,this.c=this.B(new N.MutableDisposable),this.f=void 0,this.g=0}m(){const u=new N.DisposableStore;this.c.value=u,this.b=this.l(u),this.b.setVerboseLogging(this.j),u.add(this.b.onDidChangeFile(d=>this.h(d))),u.add(this.b.onDidLogMessage(d=>this.i(d))),u.add(this.b.onDidError(d=>this.n(d)))}n(u){this.k.restartOnError?this.g<v.a&&this.f?(this.r(`restarting watcher after error: ${u}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${u}`):this.r(u)}p(u){this.g++,this.m(),this.watch(u)}async watch(u){this.f=u,await this.b?.watch(u)}async setVerboseLogging(u){this.j=u,await this.b?.setVerboseLogging(u)}r(u){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${u}`})}s(u){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${u}`})}dispose(){return this.b=void 0,super.dispose()}}e.AbstractWatcherClient=v,v.a=5;class R extends v{constructor(u,d,S){super(u,d,S,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=R;class b extends v{constructor(u,d,S){super(u,d,S,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=b;function m(h){return h.map(u=>({type:u.type,resource:T.URI.file(u.path)}))}e.toFileChanges=m;function g(h){const u=new a;for(const d of h)u.processEvent(d);return u.coalesce()}e.coalesceEvents=g;function p(h,u){return typeof u=="string"&&!u.startsWith(A.GLOBSTAR)&&!(0,l.isAbsolute)(u)?{base:h,pattern:u}:u}e.normalizeWatcherPattern=p;function E(h,u){const d=[];for(const S of u)d.push((0,A.parse)(p(h,S)));return d}e.parseWatcherPatterns=E;class a{constructor(){this.a=new Set,this.b=new Map}c(u){return O.isLinux?u.path:u.path.toLowerCase()}processEvent(u){const d=this.b.get(this.c(u));let S=!1;if(d){const L=d.type,n=u.type;d.path!==u.path&&(u.type===2||u.type===1)?S=!0:L===1&&n===2?(this.b.delete(this.c(u)),this.a.delete(d)):L===2&&n===1?d.type=0:L===1&&n===0||(d.type=n)}else S=!0;S&&(this.a.add(u),this.b.set(this.c(u),u))}coalesce(){const u=[],d=[];return Array.from(this.a).filter(S=>S.type!==2?(u.push(S),!1):!0).sort((S,L)=>S.path.length-L.path.length).filter(S=>d.some(L=>(0,k.isParent)(S.path,L,!O.isLinux))?!1:(d.push(S.path),!0)).concat(u)}}}),define(oe[199],ae([0,1,53,6,26,47,2,87,14,4,145,28,55]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class g extends T.Disposable{constructor(a,h,u,d){super(),this.j=a,this.k=h,this.l=u,this.m=d,this.c=this.B(new N.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},S=>this.k(S))),this.f=this.B(new N.RunOnceWorker(S=>this.u(S),g.b)),this.g=(0,m.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,m.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new l.CancellationTokenSource,this.ready=this.n()}async n(){try{const a=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const h=await b.Promises.stat(a);this.B(await this.s(a,h.isDirectory()))}catch(a){a.code!=="ENOENT"?this.w(a):this.z(a)}}async r(a){let h=a.path;try{h=await b.Promises.realpath(a.path),a.path===h&&(h=await(0,R.realcase)(a.path)??a.path),a.path!==h&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${a.path}, real: ${h})`)}catch{}return h}async s(a,h){if(v.isMacintosh&&(0,O.isEqualOrParent)(a,"/Volumes/",!0))return this.w(`Refusing to watch ${a} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),T.Disposable.None;const u=new l.CancellationTokenSource(this.i.token),d=new T.DisposableStore;try{const S=(0,I.basename)(a),L=(0,A.watch)(a);d.add((0,T.toDisposable)(()=>{L.removeAllListeners(),L.close()})),this.z(`Started watching: '${a}'`);const n=new Set;if(h)try{for(const t of await b.Promises.readdir(a))n.add(t)}catch(t){this.w(t)}const r=new Map;d.add((0,T.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),L.on("error",(t,i)=>{this.w(`Failed to watch ${a} for changes using fs.watch() (${t}, ${i})`),this.dispose()}),L.on("change",(t,i)=>{if(u.token.isCancellationRequested)return;this.z(`[raw] ["${t}"] ${i}`);let s="";if(i&&(s=i.toString(),v.isMacintosh&&(s=(0,k.normalizeNFC)(s))),!(!s||t!=="change"&&t!=="rename"))if(h)if(t==="rename"){r.get(s)?.dispose();const o=setTimeout(async()=>{if(r.delete(s),s===S&&!await b.Promises.exists(a)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const c=await this.v((0,I.join)(a,s));if(u.token.isCancellationRequested)return;let y;c?n.has(s)?y=0:(y=1,n.add(s)):(n.delete(s),y=2),this.t({path:(0,I.join)(this.j.path,s),type:y})},g.a);r.set(s,(0,T.toDisposable)(()=>clearTimeout(o)))}else{let o;n.has(s)?o=0:(o=1,n.add(s)),this.t({path:(0,I.join)(this.j.path,s),type:o})}else if(t==="rename"||s!==S){const o=setTimeout(async()=>{const c=await b.Promises.exists(a);u.token.isCancellationRequested||(c?(this.t({path:this.j.path,type:0},!0),d.add(await this.s(a,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},g.a);d.clear(),d.add((0,T.toDisposable)(()=>clearTimeout(o)))}else this.t({path:this.j.path,type:0},!0)})}catch(S){await b.Promises.exists(a)&&!u.token.isCancellationRequested&&this.w(`Failed to watch ${a} for changes using fs.watch() (${S.toString()})`)}return(0,T.toDisposable)(()=>{u.dispose(!0),d.dispose()})}t(a,h=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`),!h&&this.g.some(u=>u(a.path))?this.m&&this.z(` >> ignored (excluded) ${a.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(u=>u(a.path))?this.m&&this.z(` >> ignored (not included) ${a.path}`):this.f.work(a))}u(a){const h=(0,m.coalesceEvents)(a);if(h.length>0){if(this.m)for(const d of h)this.z(`>> normalized ${d.type===1?"[ADDED]":d.type===2?"[DELETED]":"[CHANGED]"} ${d.path}`);this.c.work(h)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(a){if(v.isLinux)return b.Promises.exists(a);try{const h=(0,I.basename)(a);return(await b.Promises.readdir((0,I.dirname)(a))).some(d=>d===h)}catch(h){return this.z(h),!1}}setVerboseLogging(a){this.m=a}w(a){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${a}`})}y(a){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${a}`})}z(a){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${a}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=g,g.a=100,g.b=75;async function p(E,a,h,u,d=512){const S=await b.Promises.open(E,"r"),L=Buffer.allocUnsafe(d),n=new l.CancellationTokenSource(u);let r,t=!1;const i={path:E,excludes:[],recursive:!1},s=new g(i,o=>{(async()=>{for(const{type:c}of o)if(c===0){if(t)return;t=!0;try{for(;!n.token.isCancellationRequested;){const{bytesRead:y}=await b.Promises.read(S,L,0,d,null);if(!y||n.token.isCancellationRequested)break;a(L.slice(0,y))}}catch(y){r=new Error(y),n.dispose(!0)}finally{t=!1}}})()});return await s.ready,h(),new Promise((o,c)=>{n.token.onCancellationRequested(async()=>{s.dispose();try{await b.Promises.close(S)}catch(y){r=new Error(y)}r?c(r):o()})})}e.watchFileContents=p}),define(oe[200],ae([0,1,3,92,2,4,199]),function(ie,e,A,N,l,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class k extends l.Disposable{constructor(){super(...arguments),this.a=this.B(new A.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new A.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=A.Event.None,this.c=new Map,this.f=!1}async watch(v){const R=this.i(v),b=R.filter(g=>{const p=this.c.get(g.path);return p?!(0,N.patternsEquals)(p.request.excludes,g.excludes)||!(0,N.patternsEquals)(p.request.includes,g.includes):!0}),m=Array.from(this.c.values()).filter(({request:g})=>!R.find(p=>p.path===g.path&&(0,N.patternsEquals)(p.excludes,g.excludes)&&(0,N.patternsEquals)(p.includes,g.includes))).map(({request:g})=>g.path);b.length&&this.j(`Request to start watching: ${b.map(g=>`${g.path} (excludes: ${g.excludes.length>0?g.excludes:"<none>"}, includes: ${g.includes&&g.includes.length>0?JSON.stringify(g.includes):"<all>"})`).join(",")}`),m.length&&this.j(`Request to stop watching: ${m.join(",")}`);for(const g of m)this.h(g);for(const g of b)this.g(g)}g(v){const R=new T.NodeJSFileWatcherLibrary(v,m=>this.a.fire(m),m=>this.b.fire(m),this.f),b={request:v,instance:R};this.c.set(v.path,b)}async stop(){for(const[v]of this.c)this.h(v);this.c.clear()}h(v){const R=this.c.get(v);R&&(this.c.delete(v),R.instance.dispose())}i(v){const R=new Map;for(const b of v){const m=O.isLinux?b.path:b.path.toLowerCase();R.set(m,b)}return Array.from(R.values())}async setVerboseLogging(v){this.f=v;for(const[,R]of this.c)R.instance.setVerboseLogging(v)}j(v){this.f&&this.b.fire({type:"trace",message:this.k(v)})}k(v,R){return R?`[File Watcher (node.js)] ${v} (path: ${R.request.path})`:`[File Watcher (node.js)] ${v}`}}e.NodeJSWatcher=k}),define(oe[201],ae([0,1,55,200]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class l extends A.AbstractNonRecursiveWatcherClient{constructor(T,k,I){super(T,k,I),this.m()}l(){return new N.NodeJSWatcher}}e.NodeJSWatcherClient=l}),define(oe[202],ae([0,1,24,41,66,55]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class T extends O.AbstractUniversalWatcherClient{constructor(I,v,R){super(I,v,R),this.m()}l(I){const v=I.add(new l.Client(A.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return I.add(v.onDidProcessExit(({code:R,signal:b})=>this.n(`terminated by itself with code ${R}, signal: ${b}`))),N.ProxyChannel.toService((0,N.getNextTickChannel)(v.getChannel("watcher")))}}e.UniversalWatcherClient=T}),define(oe[72],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class A{constructor(...l){this.a=new Map;for(const[O,T]of l)this.set(O,T)}set(l,O){const T=this.a.get(l);return this.a.set(l,O),T}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=A}),define(oe[203],ae([0,1,6,9,2,69,194,5,72,86]),function(ie,e,A,N,l,O,T,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const R=!1;class b extends Error{constructor(a){super("cyclic dependency between services"),this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class m{constructor(a=new I.ServiceCollection,h=!1,u,d=R){this.f=a,this.g=h,this.h=u,this.i=d,this.o=new Set,this.f.set(k.IInstantiationService,this),this._globalGraph=d?u?._globalGraph??new T.Graph(S=>S):void 0}createChild(a){return new m(a,this.g,this,this.i)}invokeFunction(a,...h){const u=p.traceInvocation(this.i,a);let d=!1;try{return a({get:L=>{if(d)throw(0,N.illegalState)("service accessor is only valid during the invocation of its target method");const n=this.m(L,u);if(!n)throw new Error(`[invokeFunction] unknown service '${L}'`);return n}},...h)}finally{d=!0,u.stop()}}createInstance(a,...h){let u,d;return a instanceof O.SyncDescriptor?(u=p.traceCreation(this.i,a.ctor),d=this.j(a.ctor,a.staticArguments.concat(h),u)):(u=p.traceCreation(this.i,a),d=this.j(a,h,u)),u.stop(),d}j(a,h=[],u){const d=k._util.getServiceDependencies(a).sort((n,r)=>n.index-r.index),S=[];for(const n of d){const r=this.m(n.id,u);r||this.u(`[createInstance] ${a.name} depends on UNKNOWN service ${n.id}.`,!1),S.push(r)}const L=d.length>0?d[0].index:h.length;if(h.length!==L){console.trace(`[createInstance] First service dependency of ${a.name} at position ${L+1} conflicts with ${h.length} static arguments`);const n=L-h.length;n>0?h=h.concat(new Array(n)):h=h.slice(0,L)}return Reflect.construct(a,h.concat(S))}k(a,h){if(this.f.get(a)instanceof O.SyncDescriptor)this.f.set(a,h);else if(this.h)this.h.k(a,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(a){const h=this.f.get(a);return!h&&this.h?this.h.l(a):h}m(a,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(a));const u=this.l(a);return u instanceof O.SyncDescriptor?this.q(a,u,h.branch(a,!0)):(h.branch(a,!1),u)}q(a,h,u){if(this.o.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this.o.add(a);try{return this.r(a,h,u)}finally{this.o.delete(a)}}r(a,h,u){const d=new T.Graph(n=>n.id.toString());let S=0;const L=[{id:a,desc:h,_trace:u}];for(;L.length;){const n=L.pop();if(d.lookupOrInsertNode(n),S++>1e3)throw new b(d);for(const r of k._util.getServiceDependencies(n.desc.ctor)){const t=this.l(r.id);if(t||this.u(`[createInstance] ${a} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),t instanceof O.SyncDescriptor){const i={id:r.id,desc:t,_trace:n._trace.branch(r.id,!0)};d.insertEdge(n,i),L.push(i)}}}for(;;){const n=d.roots();if(n.length===0){if(!d.isEmpty())throw new b(d);break}for(const{data:r}of n){if(this.l(r.id)instanceof O.SyncDescriptor){const i=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,i)}d.removeNode(r)}}return this.l(a)}s(a,h,u=[],d,S){if(this.f.get(a)instanceof O.SyncDescriptor)return this.t(a,h,u,d,S);if(this.h)return this.h.s(a,h,u,d,S);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(a,h,u=[],d,S){if(d){const L=new m(void 0,this.g,this,this.i);L.c=String(a);const n=new Map,r=new A.IdleValue(()=>{const t=L.j(h,u,S);for(const[i,s]of n){const o=t[i];if(typeof o=="function")for(const c of s)o.apply(t,c)}return n.clear(),t});return new Proxy(Object.create(null),{get(t,i){if(!r.isInitialized&&typeof i=="string"&&(i.startsWith("onDid")||i.startsWith("onWill"))){let c=n.get(i);return c||(c=new v.LinkedList,n.set(i,c)),(w,f,P)=>{const D=c.push([w,f,P]);return(0,l.toDisposable)(D)}}if(i in t)return t[i];const s=r.value;let o=s[i];return typeof o!="function"||(o=o.bind(s),t[i]=o),o},set(t,i,s){return r.value[i]=s,!0},getPrototypeOf(t){return h.prototype}})}else return this.j(h,u,S)}u(a,h){if(h&&console.warn(a),this.g)throw new Error(a)}}e.InstantiationService=m;var g;(function(E){E[E.None=0]="None",E[E.Creation=1]="Creation",E[E.Invocation=2]="Invocation",E[E.Branch=3]="Branch"})(g||(g={}));class p{static traceInvocation(a,h){return a?new p(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(a,h){return a?new p(1,h.name):p.c}constructor(a,h){this.type=a,this.name=h,this.g=Date.now(),this.h=[]}branch(a,h){const u=new p(3,a.toString());return this.h.push([a,h,u]),u}stop(){const a=Date.now()-this.g;p.f+=a;let h=!1;function u(S,L){const n=[],r=new Array(S+1).join("	");for(const[t,i,s]of L.h)if(i&&s){h=!0,n.push(`${r}CREATES -> ${t}`);const o=u(S+1,s);o&&n.push(o)}else n.push(`${r}uses -> ${t}`);return n.join(`
`)}const d=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${u(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(a>2||h)&&p.all.add(d.join(`
`))}}e.Trace=p,p.all=new Set,p.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p.f=0}),define(oe[73],ae([0,1,5]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MainProcessService=e.IMainProcessService=void 0,e.IMainProcessService=(0,A.createDecorator)("mainProcessService");class N{constructor(O,T){this.a=O,this.b=T}getChannel(O){return this.a.getChannel(O,this.b)}registerChannel(O,T){this.a.registerChannel(O,T)}}e.MainProcessService=N}),define(oe[74],ae([0,1,26,2,4,166,29,5]),function(ie,e,A,N,l,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function I(R){return R.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=I,e.ILanguagePackService=(0,k.createDecorator)("languagePackService");let v=e.LanguagePackBaseService=class extends N.Disposable{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new A.CancellationTokenSource;setTimeout(()=>b.cancel(),1e3);let m;try{m=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const p=m.firstPage.filter(E=>E.properties.localizedLanguages?.length&&E.tags.some(a=>a.startsWith("lp-"))).map(E=>{const a=E.properties.localizedLanguages?.[0],h=I(E);return{...this.f(h,a,E),extensionId:E.identifier.id,galleryExtension:E}});return p.push(this.f("en","English")),p}f(b,m,g){const p=m??b;let E;if(p!==b&&(E=`(${b})`),b.toLowerCase()===l.language.toLowerCase()&&(E??="",E+=(0,O.localize)(0,null)),g?.installCount){E??="";const a=g.installCount;let h;a>1e6?h=`${Math.floor(a/1e5)/10}M`:a>1e3?h=`${Math.floor(a/1e3)}K`:h=String(a),E+=` $(cloud-download) ${h}`}return{id:b,label:p,description:E}}};e.LanguagePackBaseService=v=ve([J(0,T.IExtensionGalleryService)],v)}),define(oe[204],ae([0,1,2,74]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let l=e.LocalizationsUpdater=class extends A.Disposable{constructor(T){super(),this.a=T,this.b()}b(){this.a.update()}};e.LocalizationsUpdater=l=ve([J(0,N.ILanguagePackService)],l)}),define(oe[10],ae([0,1,38,3,65,2,37,4,22,11,12,70,5]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,m.createDecorator)("logService"),e.ILoggerService=(0,m.createDecorator)("loggerService");function g(){return new Date().toISOString()}function p(w){return(0,v.isNumber)(w)}e.isLogLevel=p;var E;(function(w){w[w.Off=0]="Off",w[w.Trace=1]="Trace",w[w.Debug=2]="Debug",w[w.Info=3]="Info",w[w.Warning=4]="Warning",w[w.Error=5]="Error"})(E||(e.LogLevel=E={})),e.DEFAULT_LOG_LEVEL=E.Info;function a(w,f,P){switch(f){case E.Trace:w.trace(P);break;case E.Debug:w.debug(P);break;case E.Info:w.info(P);break;case E.Warning:w.warn(P);break;case E.Error:w.error(P);break;case E.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=a;function h(w,f=!1){let P="";for(let D=0;D<w.length;D++){let M=w[D];if(M instanceof Error&&(M=(0,A.toErrorMessage)(M,f)),typeof M=="object")try{M=JSON.stringify(M)}catch{}P+=(D>0?" ":"")+M}return P}class u extends O.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new N.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==E.Off&&this.b<=f}}e.AbstractLogger=u;class d extends u{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...P){this.f(E.Trace)&&this.g(E.Trace,h([f,...P],!0))}debug(f,...P){this.f(E.Debug)&&this.g(E.Debug,h([f,...P]))}info(f,...P){this.f(E.Info)&&this.g(E.Info,h([f,...P]))}warn(f,...P){this.f(E.Warning)&&this.g(E.Warning,h([f,...P]))}error(f,...P){if(this.f(E.Error))if(f instanceof Error){const D=Array.prototype.slice.call(arguments);D[0]=f.stack,this.g(E.Error,h(D))}else this.g(E.Error,h([f,...P]))}flush(){}}e.AbstractMessageLogger=d;class S extends u{constructor(f=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(f),this.g=!k.isWindows}trace(f,...P){this.f(E.Trace)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,f,...P):console.log(`[main ${g()}]`,f,...P))}debug(f,...P){this.f(E.Debug)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,f,...P):console.log(`[main ${g()}]`,f,...P))}info(f,...P){this.f(E.Info)&&(this.g?console.log(`\x1B[90m[main ${g()}]\x1B[0m`,f,...P):console.log(`[main ${g()}]`,f,...P))}warn(f,...P){this.f(E.Warning)&&(this.g?console.warn(`\x1B[93m[main ${g()}]\x1B[0m`,f,...P):console.warn(`[main ${g()}]`,f,...P))}error(f,...P){this.f(E.Error)&&(this.g?console.error(`\x1B[91m[main ${g()}]\x1B[0m`,f,...P):console.error(`[main ${g()}]`,f,...P))}dispose(){}flush(){}}e.ConsoleMainLogger=S;class L extends u{constructor(f=e.DEFAULT_LOG_LEVEL,P=!0){super(),this.g=P,this.setLevel(f)}trace(f,...P){this.f(E.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...P):console.log(f,...P))}debug(f,...P){this.f(E.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...P):console.log(f,...P))}info(f,...P){this.f(E.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...P):console.log(f,...P))}warn(f,...P){this.f(E.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...P):console.log(f,...P))}error(f,...P){this.f(E.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...P):console.error(f,...P))}dispose(){}flush(){}}e.ConsoleLogger=L;class n extends u{constructor(f,P=e.DEFAULT_LOG_LEVEL){super(),this.g=f,this.setLevel(P)}trace(f,...P){this.f(E.Trace)&&this.g.log(E.Trace,[this.h(f),...P])}debug(f,...P){this.f(E.Debug)&&this.g.log(E.Debug,[this.h(f),...P])}info(f,...P){this.f(E.Info)&&this.g.log(E.Info,[this.h(f),...P])}warn(f,...P){this.f(E.Warning)&&this.g.log(E.Warning,[this.h(f),...P])}error(f,...P){this.f(E.Error)&&this.g.log(E.Error,[this.h(f),...P])}h(f){return typeof f=="string"?f:(0,A.toErrorMessage)(f,this.f(E.Trace))}dispose(){}flush(){}}e.AdapterLogger=n;class r extends u{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const P of this.g)P.setLevel(f);super.setLevel(f)}trace(f,...P){for(const D of this.g)D.trace(f,...P)}debug(f,...P){for(const D of this.g)D.debug(f,...P)}info(f,...P){for(const D of this.g)D.info(f,...P)}warn(f,...P){for(const D of this.g)D.warn(f,...P)}error(f,...P){for(const D of this.g)D.error(f,...P)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.MultiplexLogger=r;class t extends O.Disposable{constructor(f,P,D){if(super(),this.h=f,this.j=P,this.b=new T.ResourceMap,this.c=this.B(new N.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new N.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new N.Emitter),this.onDidChangeVisibility=this.g.event,D)for(const M of D)this.b.set(M.resource,{logger:void 0,info:M})}k(f){return(0,v.isString)(f)?[...this.b.values()].find(P=>P.info.id===f):this.b.get(f)}getLogger(f){return this.k(f)?.logger}createLogger(f,P){const D=this.l(f),M=(0,v.isString)(f)?f:P?.id??(0,l.hash)(D.toString()).toString(16);let j=this.b.get(D)?.logger;const B=P?.logLevel==="always"?E.Trace:P?.logLevel;j||(j=this.m(D,B??this.getLogLevel(D)??this.h,{...P,id:M}));const W={logger:j,info:{resource:D,id:M,logLevel:B,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(W.info),this.b.set(D,W),j}l(f){return(0,v.isString)(f)?(0,I.joinPath)(this.j,`${f}.log`):f}setLogLevel(f,P){if(R.URI.isUri(f)){const D=f,M=P,j=this.b.get(D);j&&M!==j.info.logLevel&&(j.info.logLevel=M===this.h?void 0:M,j.logger?.setLevel(M),this.b.set(j.info.resource,j),this.f.fire([D,M]))}else{this.h=f;for(const[D,M]of this.b.entries())this.b.get(D)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,P){const D=this.k(f);D&&P!==!D.info.hidden&&(D.info.hidden=!P,this.b.set(D.info.resource,D),this.g.fire([D.info.resource,P]))}getLogLevel(f){let P;return f&&(P=this.b.get(f)?.info.logLevel),P??this.h}registerLogger(f){const P=this.b.get(f.resource);P?P.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const P=this.b.get(f);P&&(P.logger&&P.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=t;class i{constructor(){this.onDidChangeLogLevel=new N.Emitter().event}setLevel(f){}getLevel(){return E.Info}trace(f,...P){}debug(f,...P){}info(f,...P){}warn(f,...P){}error(f,...P){}critical(f,...P){}dispose(){}flush(){}}e.NullLogger=i;class s extends i{}e.NullLogService=s;function o(w){if(w.verbose)return E.Trace;if(typeof w.logLevel=="string"){const f=y(w.logLevel.toLowerCase());if(f!==void 0)return f}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function c(w){switch(w){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Off:return"off"}}e.LogLevelToString=c;function y(w){switch(w){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Error;case"off":return E.Off}}e.parseLogLevel=y,e.CONTEXT_LOG_LEVEL=new b.RawContextKey("logLevel",c(E.Info))}),define(oe[205],ae([0,1,6,9,2,22,28,15,10]),function(ie,e,A,N,l,O,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let v=e.LogsDataCleaner=class extends l.Disposable{constructor(b,m){super(),this.a=b,this.b=m,this.B(new A.RunOnceScheduler(()=>{this.c()},10*1e3)).schedule()}async c(){this.b.trace("[logs cleanup]: Starting to clean up old logs.");try{const b=(0,O.basename)(this.a.logsHome),m=(0,O.dirname)(this.a.logsHome),E=(await T.Promises.readdir(m.fsPath)).filter(h=>/^\d{8}T\d{6}$/.test(h)).sort().filter(h=>h!==b),a=E.slice(0,Math.max(0,E.length-9));a.length>0&&(this.b.trace(`[logs cleanup]: Removing log folders '${a.join(", ")}'`),await Promise.all(a.map(h=>T.Promises.rm((0,O.joinPath)(m,h).fsPath))))}catch(b){(0,N.onUnexpectedError)(b)}}};e.LogsDataCleaner=v=ve([J(0,k.IEnvironmentService),J(1,I.ILogService)],v)}),define(oe[206],ae([0,1,21,6,9,3,2,14,55,10]),function(ie,e,A,N,l,O,T,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class R extends T.Disposable{constructor(m,g){super(),this.a=m,this.b=g,this.c=this.B(new O.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new O.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new N.ThrottledDelayer(0)),this.s=[],this.t=this.B(new N.ThrottledDelayer(0))}watch(m,g){return g.recursive||this.b?.watcher?.forceUniversal?this.l(m,g):this.u(m,g)}l(m,g){const p={path:this.C(m),excludes:g.excludes,includes:g.includes,recursive:g.recursive},E=(0,A.insert)(this.j,p);return this.m(),(0,T.toDisposable)(()=>{E(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(m=>(0,l.onUnexpectedError)(m))}n(){this.h||(this.h=this.B(this.p(g=>this.c.fire((0,I.toFileChanges)(g)),g=>this.z(g),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)})));const m=this.b?.watcher?.recursive?.usePolling;if(m===!0)for(const g of this.j)(0,I.isRecursiveWatchRequest)(g)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(m))for(const g of this.j)(0,I.isRecursiveWatchRequest)(g)&&m.includes(g.path)&&(g.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(m,g){const p={path:this.C(m),excludes:g.excludes,includes:g.includes,recursive:!1},E=(0,A.insert)(this.s,p);return this.v(),(0,T.toDisposable)(()=>{E(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(m=>(0,l.onUnexpectedError)(m))}w(){return this.r||(this.r=this.B(this.y(m=>this.c.fire((0,I.toFileChanges)(m)),m=>this.z(m),this.a.getLevel()===v.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===v.LogLevel.Trace)}))),this.r.watch(this.s)}z(m){m.type==="error"&&this.g.fire(m.message),this.a[m.type](m.message)}C(m){return(0,k.normalize)(m.fsPath)}}e.AbstractDiskFileSystemProvider=R}),define(oe[207],ae([0,1,21,6,16,26,3,65,62,2,48,24,103,22,43,162,13,102,10,9]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let S=e.FileService=class extends v.Disposable{constructor(n){super(),this.b=n,this.a=256*1024,this.c=this.B(new T.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new T.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new T.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new T.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new T.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new T.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new N.ResourceQueue)}registerProvider(n,r){if(this.h.has(n))throw new Error(`A filesystem provider for the scheme '${n}' is already registered.`);(0,m.mark)(`code/registerFilesystem/${n}`);const t=new v.DisposableStore;return this.h.set(n,r),this.c.fire({added:!0,scheme:n,provider:r}),t.add(r.onDidChangeFile(i=>this.R.fire(new a.FileChangesEvent(i,!this.O(r))))),typeof r.onDidWatchError=="function"&&t.add(r.onDidWatchError(i=>this.S.fire(new Error(i)))),t.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:n}))),(0,v.toDisposable)(()=>{this.c.fire({added:!1,scheme:n,provider:r}),this.h.delete(n),(0,v.dispose)(t)})}getProvider(n){return this.h.get(n)}async activateProvider(n){const r=[];this.f.fire({scheme:n,join(t){r.push(t)}}),!this.h.has(n)&&await N.Promises.settled(r)}async canHandleResource(n){return await this.activateProvider(n.scheme),this.hasProvider(n)}hasProvider(n){return this.h.has(n.scheme)}hasCapability(n,r){const t=this.h.get(n.scheme);return!!(t&&t.capabilities&r)}listCapabilities(){return I.Iterable.map(this.h,([n,r])=>({scheme:n,capabilities:r.capabilities}))}async j(n){if(!(0,g.isAbsolutePath)(n))throw new a.FileOperationError((0,E.localize)(0,null,this.nb(n)),8);await this.activateProvider(n.scheme);const r=this.h.get(n.scheme);if(!r){const t=new d.ErrorNoTelemetry;throw t.message=(0,E.localize)(1,null,n.toString()),t}return r}async k(n){const r=await this.j(n);if((0,a.hasOpenReadWriteCloseCapability)(r)||(0,a.hasReadWriteCapability)(r)||(0,a.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(n){const r=await this.j(n);if((0,a.hasOpenReadWriteCloseCapability)(r)||(0,a.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${n.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(n,r){try{return await this.n(n,r)}catch(t){throw(0,a.toFileSystemProviderErrorCode)(t)===a.FileSystemProviderErrorCode.FileNotFound?new a.FileOperationError((0,E.localize)(2,null,this.nb(n)),1):(0,a.ensureFileSystemProviderError)(t)}}async n(n,r){const t=await this.j(n),i=this.O(t),s=r?.resolveTo,o=r?.resolveSingleChildDescendants,c=r?.resolveMetadata,y=await t.stat(n);let w;return this.p(t,n,y,void 0,!!c,(f,P)=>(w||(w=R.TernarySearchTree.forUris(()=>!i),w.set(n,!0),s&&w.fill(!0,s)),w.get(f.resource)||w.findSuperstr(f.resource.with({query:null,fragment:null}))?!0:f.isDirectory&&o?P===1:!1))}async p(n,r,t,i,s,o){const{providerExtUri:c}=this.N(n),y={resource:r,name:c.basename(r),isFile:(t.type&a.FileType.File)!==0,isDirectory:(t.type&a.FileType.Directory)!==0,isSymbolicLink:(t.type&a.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&a.FilePermission.Readonly)||!!(n.capabilities&2048),etag:(0,a.etag)({mtime:t.mtime,size:t.size}),children:void 0};if(y.isDirectory&&o(y,i)){try{const w=await n.readdir(r),f=await N.Promises.settled(w.map(async([P,D])=>{try{const M=c.joinPath(r,P),j=s?await n.stat(M):{type:D};return await this.p(n,M,j,w.length,s,o)}catch(M){return this.b.trace(M),null}}));y.children=(0,A.coalesce)(f)}catch(w){this.b.trace(w),y.children=[]}return y}return y}async resolveAll(n){return N.Promises.settled(n.map(async r=>{try{return{stat:await this.n(r.resource,r.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(n){const r=await this.j(n),t=await r.stat(n);return this.p(r,n,t,void 0,!0,()=>!1)}async exists(n){const r=await this.j(n);try{return!!await r.stat(n)}catch{return!1}}async canCreateFile(n,r){try{await this.r(n,r)}catch(t){return t}return!0}async r(n,r){if(!r?.overwrite&&await this.exists(n))throw new a.FileOperationError((0,E.localize)(3,null,this.nb(n)),3,r)}async createFile(n,r=l.VSBuffer.fromString(""),t){await this.r(n,t);const i=await this.writeFile(n,r);return this.m.fire(new a.FileOperationEvent(n,0,i)),i}async writeFile(n,r,t){const i=this.lb(await this.l(n),n),{providerExtUri:s}=this.N(i);try{await this.s(i,n,t)||await this.P(i,s.dirname(n));let c;if((0,a.hasReadWriteCapability)(i)&&!(r instanceof l.VSBuffer))if((0,p.isReadableStream)(r)){const y=await(0,p.peekStream)(r,3);y.ended?c=l.VSBuffer.concat(y.buffer):c=y}else c=(0,p.peekReadable)(r,y=>l.VSBuffer.concat(y),3);else c=r;!(0,a.hasOpenReadWriteCloseCapability)(i)||(0,a.hasReadWriteCapability)(i)&&c instanceof l.VSBuffer?await this.cb(i,n,t,c):await this.Y(i,n,t,c instanceof l.VSBuffer?(0,l.bufferToReadable)(c):c),this.m.fire(new a.FileOperationEvent(n,4))}catch(o){throw new a.FileOperationError((0,E.localize)(4,null,this.nb(n),(0,a.ensureFileSystemProviderError)(o).toString()),(0,a.toFileOperationResult)(o),t)}return this.resolve(n,{resolveMetadata:!0})}async s(n,r,t){if(!!t?.unlock&&!(n.capabilities&8192))throw new Error((0,E.localize)(5,null,this.nb(r)));let s;try{s=await n.stat(r)}catch{return}if(s.type&a.FileType.Directory)throw new a.FileOperationError((0,E.localize)(6,null,this.nb(r)),0,t);if(this.mb(r,s),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==a.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&t.mtime<s.mtime&&t.etag!==(0,a.etag)({mtime:t.mtime,size:s.size}))throw new a.FileOperationError((0,E.localize)(7,null),3,t);return s}async readFile(n,r,t){const i=await this.k(n);return r?.atomic?this.t(i,n,r,t):this.u(i,n,r,t)}async t(n,r,t,i){return new Promise((s,o)=>{this.X.queueFor(r,this.N(n).providerExtUri).queue(async()=>{try{const c=await this.u(n,r,t,i);s(c)}catch(c){o(c)}})})}async u(n,r,t,i){const s=await this.v(n,r,{...t,preferUnbuffered:!0},i);return{...s,value:await(0,l.streamToBuffer)(s.value)}}async readFileStream(n,r,t){const i=await this.k(n);return this.v(i,n,r,t)}async v(n,r,t,i){const s=new O.CancellationTokenSource(i),o=this.F(r,t).then(y=>y,y=>{throw s.cancel(),y});let c;try{return typeof t?.etag=="string"&&t.etag!==a.ETAG_DISABLED&&await o,t?.atomic&&(0,a.hasFileAtomicReadCapability)(n)||!((0,a.hasOpenReadWriteCloseCapability)(n)||(0,a.hasFileReadStreamCapability)(n))||(0,a.hasReadWriteCapability)(n)&&t?.preferUnbuffered?c=this.D(n,r,t):(0,a.hasFileReadStreamCapability)(n)?c=this.z(n,r,s.token,t):c=this.C(n,r,s.token,t),{...await o,value:c}}catch(y){throw c&&await(0,p.consumeStream)(c),this.w(y,r,t)}}w(n,r,t){const i=(0,E.localize)(8,null,this.nb(r),(0,a.ensureFileSystemProviderError)(n).toString());return n instanceof a.NotModifiedSinceFileOperationError?new a.NotModifiedSinceFileOperationError(i,n.stat,t):n instanceof a.TooLargeFileOperationError?new a.TooLargeFileOperationError(i,n.fileOperationResult,n.size,n.options):new a.FileOperationError(i,(0,a.toFileOperationResult)(n),t)}z(n,r,t,i=Object.create(null)){const s=n.readFileStream(r,i,t);return(0,p.transform)(s,{data:o=>o instanceof l.VSBuffer?o:l.VSBuffer.wrap(o),error:o=>this.w(o,r,i)},o=>l.VSBuffer.concat(o))}C(n,r,t,i=Object.create(null)){const s=(0,l.newWriteableBufferStream)();return(0,h.readFileIntoStream)(n,r,s,o=>o,{...i,bufferSize:this.a,errorTransformer:o=>this.w(o,r,i)},t),s}D(n,r,t){const i=(0,p.newWriteableStream)(s=>l.VSBuffer.concat(s));return(async()=>{try{let s;t?.atomic&&(0,a.hasFileAtomicReadCapability)(n)?s=await n.readFile(r,{atomic:!0}):s=await n.readFile(r),typeof t?.position=="number"&&(s=s.slice(t.position)),typeof t?.length=="number"&&(s=s.slice(0,t.length)),this.G(r,s.byteLength,t),i.end(l.VSBuffer.wrap(s))}catch(s){i.error(s),i.end()}})(),i}async F(n,r){const t=await this.resolve(n,{resolveMetadata:!0});if(t.isDirectory)throw new a.FileOperationError((0,E.localize)(9,null,this.nb(n)),0,r);if(typeof r?.etag=="string"&&r.etag!==a.ETAG_DISABLED&&r.etag===t.etag)throw new a.NotModifiedSinceFileOperationError((0,E.localize)(10,null),t,r);return this.G(n,t.size,r),t}G(n,r,t){if(typeof t?.limits?.size=="number"&&r>t.limits.size)throw new a.TooLargeFileOperationError((0,E.localize)(11,null,this.nb(n)),7,r,t)}async canMove(n,r,t){return this.H(n,r,"move",t)}async canCopy(n,r,t){return this.H(n,r,"copy",t)}async H(n,r,t,i){if(n.toString()!==r.toString())try{const s=t==="move"?this.lb(await this.l(n),n):await this.k(n),o=this.lb(await this.l(r),r);await this.M(s,n,o,r,t,i)}catch(s){return s}return!0}async move(n,r,t){const i=this.lb(await this.l(n),n),s=this.lb(await this.l(r),r),o=await this.I(i,n,s,r,"move",!!t),c=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(n,o==="move"?2:3,c)),c}async copy(n,r,t){const i=await this.k(n),s=this.lb(await this.l(r),r),o=await this.I(i,n,s,r,"copy",!!t),c=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(n,o==="copy"?3:2,c)),c}async I(n,r,t,i,s,o){if(r.toString()===i.toString())return s;const{exists:c,isSameResourceWithDifferentPathCase:y}=await this.M(n,r,t,i,s,o);if(c&&!y&&o&&await this.del(i,{recursive:!0}),await this.P(t,this.N(t).providerExtUri.dirname(i)),s==="copy"){if(n===t&&(0,a.hasFileFolderCopyCapability)(n))await n.copy(r,i,{overwrite:o});else{const w=await this.resolve(r);w.isDirectory?await this.L(n,w,t,i):await this.J(n,r,t,i)}return s}else return n===t?(await n.rename(r,i,{overwrite:o}),s):(await this.I(n,r,t,i,"copy",o),await this.del(r,{recursive:!0}),"copy")}async J(n,r,t,i){if((0,a.hasOpenReadWriteCloseCapability)(n)&&(0,a.hasOpenReadWriteCloseCapability)(t))return this.eb(n,r,t,i);if((0,a.hasOpenReadWriteCloseCapability)(n)&&(0,a.hasReadWriteCapability)(t))return this.kb(n,r,t,i);if((0,a.hasReadWriteCapability)(n)&&(0,a.hasOpenReadWriteCloseCapability)(t))return this.ib(n,r,t,i);if((0,a.hasReadWriteCapability)(n)&&(0,a.hasReadWriteCapability)(t))return this.gb(n,r,t,i)}async L(n,r,t,i){await t.mkdir(i),Array.isArray(r.children)&&await N.Promises.settled(r.children.map(async s=>{const o=this.N(t).providerExtUri.joinPath(i,s.name);return s.isDirectory?this.L(n,await this.resolve(s.resource),t,o):this.J(n,s.resource,t,o)}))}async M(n,r,t,i,s,o){let c=!1;if(n===t){const{providerExtUri:w,isPathCaseSensitive:f}=this.N(n);if(f||(c=w.isEqual(r,i)),c&&s==="copy")throw new Error((0,E.localize)(12,null,this.nb(r),this.nb(i)));if(!c&&w.isEqualOrParent(i,r))throw new Error((0,E.localize)(13,null,this.nb(r),this.nb(i)))}const y=await this.exists(i);if(y&&!c){if(!o)throw new a.FileOperationError((0,E.localize)(14,null,this.nb(r),this.nb(i)),4);if(n===t){const{providerExtUri:w}=this.N(n);if(w.isEqualOrParent(r,i))throw new Error((0,E.localize)(15,null,this.nb(r),this.nb(i)))}}return{exists:y,isSameResourceWithDifferentPathCase:c}}N(n){const r=this.O(n);return{providerExtUri:r?g.extUri:g.extUriIgnorePathCase,isPathCaseSensitive:r}}O(n){return!!(n.capabilities&1024)}async createFolder(n){const r=this.lb(await this.j(n),n);await this.P(r,n);const t=await this.resolve(n,{resolveMetadata:!0});return this.m.fire(new a.FileOperationEvent(n,0,t)),t}async P(n,r){const t=[],{providerExtUri:i}=this.N(n);for(;!i.isEqual(r,i.dirname(r));)try{if(!((await n.stat(r)).type&a.FileType.Directory))throw new Error((0,E.localize)(16,null,this.nb(r)));break}catch(s){if((0,a.toFileSystemProviderErrorCode)(s)!==a.FileSystemProviderErrorCode.FileNotFound)throw s;t.push(i.basename(r)),r=i.dirname(r)}for(let s=t.length-1;s>=0;s--){r=i.joinPath(r,t[s]);try{await n.mkdir(r)}catch(o){if((0,a.toFileSystemProviderErrorCode)(o)!==a.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(n,r){try{await this.Q(n,r)}catch(t){return t}return!0}async Q(n,r){const t=this.lb(await this.j(n),n);if(!!r?.useTrash&&!(t.capabilities&4096))throw new Error((0,E.localize)(17,null,this.nb(n)));let s;try{s=await t.stat(n)}catch{}if(s)this.mb(n,s);else throw new a.FileOperationError((0,E.localize)(18,null,this.nb(n)),1);if(!!!r?.recursive){const c=await this.resolve(n);if(c.isDirectory&&Array.isArray(c.children)&&c.children.length>0)throw new Error((0,E.localize)(19,null,this.nb(n)))}return t}async del(n,r){const t=await this.Q(n,r),i=!!r?.useTrash,s=!!r?.recursive;await t.delete(n,{recursive:s,useTrash:i}),this.m.fire(new a.FileOperationEvent(n,1))}async cloneFile(n,r){const t=await this.j(n),i=this.lb(await this.l(r),r);if(t===i&&this.N(t).providerExtUri.isEqual(n,r))return;if(t===i&&(0,a.hasFileCloneCapability)(t))return t.cloneFile(n,r);await this.P(i,this.N(i).providerExtUri.dirname(r));const s=this.X.queueFor(n,this.N(t).providerExtUri);return t===i&&(0,a.hasFileFolderCopyCapability)(t)?s.queue(()=>t.copy(n,r,{overwrite:!0})):s.queue(()=>this.J(t,n,i,r))}watch(n,r={recursive:!1,excludes:[]}){const t=new v.DisposableStore;let i=!1,s=()=>{i=!0};return t.add((0,v.toDisposable)(()=>s())),(async()=>{try{const o=await this.W(n,r);i?(0,v.dispose)(o):s=()=>(0,v.dispose)(o)}catch(o){this.b.error(o)}})(),t}async W(n,r){const t=await this.j(n),i=(0,k.hash)([this.N(t).providerExtUri.getComparisonKey(n),r]);let s=this.U.get(i);return s||(s={count:0,disposable:t.watch(n,r)},this.U.set(i,s)),s.count+=1,(0,v.toDisposable)(()=>{s&&(s.count--,s.count===0&&((0,v.dispose)(s.disposable),this.U.delete(i)))})}dispose(){super.dispose();for(const[,n]of this.U)(0,v.dispose)(n.disposable);this.U.clear()}async Y(n,r,t,i){return this.X.queueFor(r,this.N(n).providerExtUri).queue(async()=>{const s=await n.open(r,{create:!0,unlock:t?.unlock??!1});try{(0,p.isReadableStream)(i)||(0,p.isReadableBufferedStream)(i)?await this.Z(n,s,i):await this.ab(n,s,i)}catch(o){throw(0,a.ensureFileSystemProviderError)(o)}finally{await n.close(s)}})}async Z(n,r,t){let i=0,s;if((0,p.isReadableBufferedStream)(t)){if(t.buffer.length>0){const o=l.VSBuffer.concat(t.buffer);await this.bb(n,r,o,o.byteLength,i,0),i+=o.byteLength}if(t.ended)return;s=t.stream}else s=t;return new Promise((o,c)=>{(0,p.listenStream)(s,{onData:async y=>{s.pause();try{await this.bb(n,r,y,y.byteLength,i,0)}catch(w){return c(w)}i+=y.byteLength,setTimeout(()=>s.resume())},onError:y=>c(y),onEnd:()=>o()})})}async ab(n,r,t){let i=0,s;for(;(s=t.read())!==null;)await this.bb(n,r,s,s.byteLength,i,0),i+=s.byteLength}async bb(n,r,t,i,s,o){let c=0;for(;c<i;){const y=await n.write(r,s+c,t.buffer,o+c,i-c);c+=y}}async cb(n,r,t,i){return this.X.queueFor(r,this.N(n).providerExtUri).queue(()=>this.db(n,r,t,i))}async db(n,r,t,i){let s;i instanceof l.VSBuffer?s=i:(0,p.isReadableStream)(i)?s=await(0,l.streamToBuffer)(i):(0,p.isReadableBufferedStream)(i)?s=await(0,l.bufferedStreamToBuffer)(i):s=(0,l.readableToBuffer)(i),await n.writeFile(r,s.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1})}async eb(n,r,t,i){return this.X.queueFor(i,this.N(t).providerExtUri).queue(()=>this.fb(n,r,t,i))}async fb(n,r,t,i){let s,o;try{s=await n.open(r,{create:!1}),o=await t.open(i,{create:!0,unlock:!1});const c=l.VSBuffer.alloc(this.a);let y=0,w=0,f=0;do f=await n.read(s,y,c.buffer,w,c.byteLength-w),await this.bb(t,o,c,f,y,w),y+=f,w+=f,w===c.byteLength&&(w=0);while(f>0)}catch(c){throw(0,a.ensureFileSystemProviderError)(c)}finally{await N.Promises.settled([typeof s=="number"?n.close(s):Promise.resolve(),typeof o=="number"?t.close(o):Promise.resolve()])}}async gb(n,r,t,i){return this.X.queueFor(i,this.N(t).providerExtUri).queue(()=>this.hb(n,r,t,i))}async hb(n,r,t,i){return t.writeFile(i,await n.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async ib(n,r,t,i){return this.X.queueFor(i,this.N(t).providerExtUri).queue(()=>this.jb(n,r,t,i))}async jb(n,r,t,i){const s=await t.open(i,{create:!0,unlock:!1});try{const o=await n.readFile(r);await this.bb(t,s,l.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,a.ensureFileSystemProviderError)(o)}finally{await t.close(s)}}async kb(n,r,t,i){const s=await(0,l.streamToBuffer)(this.C(n,r,O.CancellationToken.None));await this.cb(t,i,void 0,s)}lb(n,r){if(n.capabilities&2048)throw new a.FileOperationError((0,E.localize)(20,null,this.nb(r)),6);return n}mb(n,r){if((r.permissions??0)&a.FilePermission.Readonly)throw new a.FileOperationError((0,E.localize)(21,null,this.nb(n)),6)}nb(n){return n.scheme===b.Schemas.file?n.fsPath:n.toString(!0)}};e.FileService=S=ve([J(0,u.ILogService)],S)}),define(oe[208],ae([0,1,53,286,6,37,16,3,47,2,14,4,22,43,28,165,13,102,206,38,202,201]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u,d,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,N.gracefulify)(A)}catch(r){console.error(`Error enabling graceful-fs: ${(0,d.toErrorMessage)(r)}`)}})();class n extends u.AbstractDiskFileSystemProvider{constructor(t,i){super(t,i),this.onDidChangeCapabilities=k.Event.None,this.H=new O.ResourceMap(s=>m.extUriBiasedIgnorePathCase.getComparisonKey(s)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,b.isLinux&&(this.F|=1024)),this.F}async stat(t){try{const{stat:i,symbolicLink:s}=await p.SymlinkSupport.stat(this.C(t));return{type:this.G(i,s),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.Y(i)}}async readdir(t){try{const i=await p.Promises.readdir(this.C(t),{withFileTypes:!0}),s=[];return await Promise.all(i.map(async o=>{try{let c;o.isSymbolicLink()?c=(await this.stat((0,m.joinPath)(t,o.name))).type:c=this.G(o),s.push([o.name,c])}catch(c){this.a.trace(c)}})),s}catch(i){throw this.Y(i)}}G(t,i){let s;return i?.dangling?s=a.FileType.Unknown:t.isFile()?s=a.FileType.File:t.isDirectory()?s=a.FileType.Directory:s=a.FileType.Unknown,i&&(s|=a.FileType.SymbolicLink),s}async I(t){const i=this.C(t);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let s;for(;s=this.H.get(t);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await s.wait();const o=new l.Barrier;return this.H.set(t,o),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,v.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.H.get(t)===o&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.H.delete(t)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),o.open()})}async readFile(t,i){let s;try{i?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(t)})`),s=await this.I(t));const o=this.C(t);return await p.Promises.readFile(o)}catch(o){throw this.Y(o)}finally{s?.dispose()}}J(t){n.D&&this.a.trace(t)}readFileStream(t,i,s){const o=(0,g.newWriteableStream)(c=>T.VSBuffer.concat(c.map(y=>T.VSBuffer.wrap(y))).buffer);return(0,h.readFileIntoStream)(this,t,o,c=>c.buffer,{...i,bufferSize:256*1024},s),o}async writeFile(t,i,s){let o;try{const c=this.C(t);if(!s.create||!s.overwrite){if(await p.Promises.exists(c)){if(!s.overwrite)throw(0,a.createFileSystemProviderError)((0,E.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,a.createFileSystemProviderError)((0,E.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}o=await this.open(t,{create:!0,unlock:s.unlock}),await this.write(o,0,i,0,i.byteLength)}catch(c){throw await this.Z(t,c)}finally{typeof o=="number"&&await this.close(o)}}static configureFlushOnWrite(t){n.O=t}async open(t,i){const s=this.C(t);let o;(0,a.isFileOpenForWriteOptions)(i)&&(o=await this.I(t));let c;try{if((0,a.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:w}=await p.SymlinkSupport.stat(s);w.mode&128||await p.Promises.chmod(s,w.mode|128)}catch(w){this.a.trace(w)}let y;if((0,a.isFileOpenForWriteOptions)(i)){if(b.isWindows)try{await p.Promises.truncate(s,0),y="r+"}catch(w){w.code!=="ENOENT"&&this.a.trace(w)}y||(y="w")}else y="r";c=await p.Promises.open(s,y)}catch(y){throw o?.dispose(),(0,a.isFileOpenForWriteOptions)(i)?await this.Z(t,y):this.Y(y)}if(this.L.set(c,0),(0,a.isFileOpenForWriteOptions)(i)&&this.N.set(c,t),o){const y=this.M.get(c);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${c} (${s})`),this.M.set(c,o),y&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${c} (${s})`),y.dispose())}return c}async close(t){const i=this.M.get(t);try{if(this.L.delete(t),this.N.delete(t)&&n.O)try{await p.Promises.fdatasync(t)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await p.Promises.close(t)}catch(s){throw this.Y(s)}finally{i&&(this.M.get(t)===i&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.M.delete(t)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,s,o,c){const y=this.P(t,i);let w=null;try{w=(await p.Promises.read(t,s,o,c,y)).bytesRead}catch(f){throw this.Y(f)}finally{this.Q(t,y,w)}return w}P(t,i){return i===this.L.get(t)?null:i}Q(t,i,s){const o=this.L.get(t);typeof o=="number"&&(typeof i=="number"||(typeof s=="number"?this.L.set(t,o+s):this.L.delete(t)))}async write(t,i,s,o,c){return(0,l.retry)(()=>this.R(t,i,s,o,c),100,3)}async R(t,i,s,o,c){const y=this.P(t,i);let w=null;try{w=(await p.Promises.write(t,s,o,c,y)).bytesWritten}catch(f){throw await this.Z(this.N.get(t),f)}finally{this.Q(t,y,w)}return w}async mkdir(t){try{await p.Promises.mkdir(this.C(t))}catch(i){throw this.Y(i)}}async delete(t,i){try{const s=this.C(t);i.recursive?await p.Promises.rm(s,p.RimRafMode.MOVE):await p.Promises.unlink(s)}catch(s){throw this.Y(s)}}async rename(t,i,s){const o=this.C(t),c=this.C(i);if(o!==c)try{await this.S(t,i,"move",s.overwrite),await p.Promises.move(o,c)}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,E.localize)(2,null,(0,R.basename)(o),(0,R.basename)((0,R.dirname)(c)),y.toString()))),this.Y(y)}}async copy(t,i,s){const o=this.C(t),c=this.C(i);if(o!==c)try{await this.S(t,i,"copy",s.overwrite),await p.Promises.copy(o,c,{preserveSymlinks:!0})}catch(y){throw(y.code==="EINVAL"||y.code==="EBUSY"||y.code==="ENAMETOOLONG")&&(y=new Error((0,E.localize)(3,null,(0,R.basename)(o),(0,R.basename)((0,R.dirname)(c)),y.toString()))),this.Y(y)}}async S(t,i,s,o){const c=this.C(t),y=this.C(i);let w=!1;if(!!(this.capabilities&1024)||(w=(0,I.isEqual)(c,y,!0)),w&&s==="copy")throw(0,a.createFileSystemProviderError)((0,E.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!w&&await p.Promises.exists(y)){if(!o)throw(0,a.createFileSystemProviderError)((0,E.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(t,i){return this.U(t,i,!1)}async U(t,i,s){const o=this.C(t),c=this.C(i),y=!!(this.capabilities&1024);if((0,I.isEqual)(o,c,!y))return;const w=new v.DisposableStore;try{const[f,P]=await Promise.all([this.I(t),this.I(i)]);w.add(f),w.add(P),s&&await p.Promises.mkdir((0,R.dirname)(c),{recursive:!0}),await p.Promises.copyFile(o,c)}catch(f){if(f.code==="ENOENT"&&!s)return this.U(t,i,!0);throw this.Y(f)}finally{w.dispose()}}p(t,i,s){return new S.UniversalWatcherClient(o=>t(o),o=>i(o),s)}y(t,i,s){return new L.NodeJSWatcherClient(o=>t(o),o=>i(o),s)}Y(t){if(t instanceof a.FileSystemProviderError)return t;let i=t,s;switch(t.code){case"ENOENT":s=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=a.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":i=`${t.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=a.FileSystemProviderErrorCode.Unknown;break;default:s=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(i,s)}async Z(t,i){let s=this.Y(i);if(t&&s.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await p.SymlinkSupport.stat(this.C(t));o.mode&128||(s=(0,a.createFileSystemProviderError)(i,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.DiskFileSystemProvider=n,n.D=!1,n.O=!0}),define(oe[104],ae([0,1,3,2,5,10]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessLifecycleService=e.ISharedProcessLifecycleService=void 0,e.ISharedProcessLifecycleService=(0,l.createDecorator)("sharedProcessLifecycleService");let T=e.SharedProcessLifecycleService=class extends N.Disposable{constructor(I){super(),this.b=I,this.a=this.B(new A.Emitter),this.onWillShutdown=this.a.event}fireOnWillShutdown(){this.b.trace("Lifecycle#onWillShutdown.fire()"),this.a.fire()}};e.SharedProcessLifecycleService=T=ve([J(0,O.ILogService)],T)}),define(oe[105],ae([0,1,12,3,10,2]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class T extends l.AbstractLoggerService{constructor(b,m,g,p,E){super(m,g,p),this.n=b,this.p=E,this.B(E.listen("onDidChangeLogLevel",b)(a=>{(0,l.isLogLevel)(a)?super.setLogLevel(a):super.setLogLevel(A.URI.revive(a[0]),a[1])})),this.B(E.listen("onDidChangeVisibility",b)(([a,h])=>super.setVisibility(A.URI.revive(a),h))),this.B(E.listen("onDidChangeLoggers",b)(({added:a,removed:h})=>{for(const u of a)super.registerLogger({...u,resource:A.URI.revive(u.resource)});for(const u of h)super.deregisterLogger(u.resource)}))}createConsoleMainLogger(){return new l.AdapterLogger({log:(b,m)=>{this.p.call("consoleLog",[b,m])}})}registerLogger(b){super.registerLogger(b),this.p.call("registerLogger",[b,this.n])}deregisterLogger(b){super.deregisterLogger(b),this.p.call("deregisterLogger",[b,this.n])}setLogLevel(b,m){super.setLogLevel(b,m),this.p.call("setLogLevel",[b,m])}setVisibility(b,m){super.setVisibility(b,m),this.p.call("setVisibility",[this.l(b),m])}m(b,m,g){return new k(this.p,b,m,g,this.n)}static setLogLevel(b,m,g){return b.call("setLogLevel",[m,g])}}e.LoggerChannelClient=T;class k extends l.AbstractMessageLogger{constructor(b,m,g,p,E){super(p?.logLevel==="always"),this.m=b,this.n=m,this.k=!1,this.l=[],this.setLevel(g),this.m.call("createLogger",[m,p,E]).then(()=>{this.r(this.l),this.k=!0})}g(b,m){const g=[[b,m]];this.k?this.r(g):this.l.push(...g)}r(b){this.m.call("log",[this.n,b])}}class I{constructor(b,m){this.a=b,this.b=m}listen(b,m){const g=this.b(b);switch(m){case"onDidChangeLoggers":return N.Event.map(this.a.onDidChangeLoggers,p=>({added:[...p.added].map(E=>this.c(E,g)),removed:[...p.removed].map(E=>this.c(E,g))}));case"onDidChangeVisibility":return N.Event.map(this.a.onDidChangeVisibility,p=>[g.transformOutgoingURI(p[0]),p[1]]);case"onDidChangeLogLevel":return N.Event.map(this.a.onDidChangeLogLevel,p=>(0,l.isLogLevel)(p)?p:[g.transformOutgoingURI(p[0]),p[1]])}throw new Error(`Event not found: ${m}`)}async call(b,m,g){const p=this.b(b);switch(m){case"setLogLevel":return(0,l.isLogLevel)(g[0])?this.a.setLogLevel(g[0]):this.a.setLogLevel(A.URI.revive(p.transformIncoming(g[0][0])),g[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(E=>this.c(E,p)))}throw new Error(`Call not found: ${m}`)}c(b,m){return{...b,resource:m.transformOutgoingURI(b.resource)}}}e.LoggerChannel=I;class v extends O.Disposable{constructor(b,m){super(),m.call("setLogLevel",[b.getLogLevel()]),this.B(b.onDidChangeLogLevel(g=>m.call("setLogLevel",[g]))),m.call("getRegisteredLoggers").then(g=>{for(const p of g)b.registerLogger({...p,resource:A.URI.revive(p.resource)})}),this.B(m.listen("onDidChangeVisibility")(([g,p])=>b.setVisibility(A.URI.revive(g),p))),this.B(m.listen("onDidChangeLoggers")(({added:g,removed:p})=>{for(const E of g)b.registerLogger({...E,resource:A.URI.revive(E.resource)});for(const E of p)b.deregisterLogger(E.resource)}))}}e.RemoteLoggerChannelClient=v}),define(oe[209],ae([0,1,2,10]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends A.Disposable{constructor(T,k=[]){super(),this.a=new N.MultiplexLogger([T,...k]),this.B(T.onDidChangeLogLevel(I=>this.setLevel(I)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(T){this.a.setLevel(T)}getLevel(){return this.a.getLevel()}trace(T,...k){this.a.trace(T,...k)}debug(T,...k){this.a.debug(T,...k)}info(T,...k){this.a.info(T,...k)}warn(T,...k){this.a.warn(T,...k)}error(T,...k){this.a.error(T,...k)}flush(){this.a.flush()}}e.LogService=l}),define(oe[56],ae([0,1,5]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,A.createDecorator)("nativeHostService")}),define(oe[57],ae([0,1,3,62,2,5]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,O.createDecorator)("policy");class T extends l.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new A.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(v){const R=Object.keys(this.f).length;return this.f={...v,...this.f},R!==Object.keys(this.f).length&&await this.i(v),N.Iterable.reduce(this.g.entries(),(b,[m,g])=>({...b,[m]:g}),{})}getPolicyValue(v){return this.g.get(v)}serialize(){return N.Iterable.reduce(Object.entries(this.f),(v,[R,b])=>({...v,[R]:{definition:b,value:this.g.get(R)}}),{})}}e.AbstractPolicyService=T;class k{constructor(){this.onDidChange=A.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=k}),define(oe[210],ae([0,1,3,2,57]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class O{constructor(I){this.b=I,this.a=new N.DisposableStore}listen(I,v){switch(v){case"onDidChange":return A.Event.map(this.b.onDidChange,R=>R.reduce((b,m)=>({...b,[m]:this.b.getPolicyValue(m)??null}),{}),this.a)}throw new Error(`Event not found: ${v}`)}call(I,v,R){switch(v){case"updatePolicyDefinitions":return this.b.updatePolicyDefinitions(R)}throw new Error(`Call not found: ${v}`)}dispose(){this.a.dispose()}}e.PolicyChannel=O;class T extends l.AbstractPolicyService{constructor(I,v){super(),this.a=v;for(const R in I){const{definition:b,value:m}=I[R];this.f[R]=b,m!==void 0&&this.g.set(R,m)}this.a.listen("onDidChange")(R=>{for(const b in R){const m=R[b];m===null?this.g.delete(b):this.g.set(b,m)}this.h.fire(Object.keys(R))})}async i(I){const v=await this.a.call("updatePolicyDefinitions",I);for(const R in v)this.g.set(R,v[R])}}e.PolicyChannelClient=T}),define(oe[106],ae([0,1,4,36]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof A.globals.vscode<"u"&&typeof A.globals.vscode.context<"u"){const O=A.globals.vscode.context.configuration();if(O)l=O.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,N.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const O=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:O.version})}}else l={},Object.keys(l).length===0&&Object.assign(l,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(oe[25],ae([0,1,5]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,A.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(oe[211],ae([0,1,6,9,2,14,28,10,25]),function(ie,e,A,N,l,O,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let v=e.CodeCacheCleaner=class extends l.Disposable{constructor(b,m,g){super(),this.b=m,this.c=g,this.a=this.b.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,b&&this.B(new A.RunOnceScheduler(()=>{this.f(b)},3e4)).schedule()}async f(b){this.c.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const m=Date.now(),g=(0,O.dirname)(b),p=(0,O.basename)(b),E=await T.Promises.readdir(g);await Promise.all(E.map(async a=>{if(a===p)return;const h=(0,O.join)(g,a),u=await T.Promises.stat(h);if(u.isDirectory()&&m-u.mtime.getTime()>this.a)return this.c.trace(`[code cache cleanup]: Removing code cache folder ${a}.`),T.Promises.rm(h)}))}catch(m){(0,N.onUnexpectedError)(m)}}};e.CodeCacheCleaner=v=ve([J(1,I.IProductService),J(2,k.ILogService)],v)}),define(oe[212],ae([0,1,6,9,2,14,28,15,10,25]),function(ie,e,A,N,l,O,T,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let R=e.LanguagePackCachedDataCleaner=class extends l.Disposable{constructor(m,g,p){super(),this.b=m,this.c=g,this.f=p,this.a=this.f.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.b.isBuilt&&this.B(new A.RunOnceScheduler(()=>{this.g()},4e4)).schedule()}async g(){this.c.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const m=Object.create(null),g=JSON.parse(await T.Promises.readFile((0,O.join)(this.b.userDataPath,"languagepacks.json"),"utf8"));for(const u of Object.keys(g)){const d=g[u];m[`${d.hash}.${u}`]=!0}const p=(0,O.join)(this.b.userDataPath,"clp");if(!await T.Promises.exists(p))return;const a=await T.Promises.readdir(p);for(const u of a){if(m[u]){this.c.trace(`[language pack cache cleanup]: Skipping folder ${u}. Language pack still in use.`);continue}this.c.trace(`[language pack cache cleanup]: Removing unused language pack: ${u}`),await T.Promises.rm((0,O.join)(p,u))}const h=Date.now();for(const u of Object.keys(m)){const d=(0,O.join)(p,u),S=await T.Promises.readdir(d);for(const L of S){if(L==="tcf.json")continue;const n=(0,O.join)(d,L),r=await T.Promises.stat(n);r.isDirectory()&&h-r.mtime.getTime()>this.a&&(this.c.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,O.join)(u,L)}`),await T.Promises.rm(n))}}}catch(m){(0,N.onUnexpectedError)(m)}}};e.LanguagePackCachedDataCleaner=R=ve([J(0,k.INativeEnvironmentService),J(1,I.ILogService),J(2,v.IProductService)],R)}),define(oe[213],ae([0,1,14,5]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,N.createDecorator)("IV8InspectProfilingService");var l;(function(O){function T(I){return!!(I.samples&&I.timeDeltas)}O.isValidProfile=T;function k(I,v="noAbsolutePaths"){for(const R of I.nodes)R.callFrame&&R.callFrame.url&&((0,A.isAbsolute)(R.callFrame.url)||/^\w[\w\d+.-]*:\/\/\/?/.test(R.callFrame.url))&&(R.callFrame.url=(0,A.join)(v,(0,A.basename)(R.callFrame.url)));return I}O.rewriteAbsolutePaths=k})(l||(e.Utils=l={}))}),define(oe[214],ae([0,1,32]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class N{constructor(){this.a=new Map}async startProfiling(O){const k=await(await new Promise((v,R)=>{ie(["v8-inspect-profiler"],v,R)})).startProfiling({port:O.port,checkForPaused:!0}),I=(0,A.generateUuid)();return this.a.set(I,k),I}async stopProfiling(O){const T=this.a.get(O);if(!T)throw new Error(`UNKNOWN session '${O}'`);const k=await T.stop();return this.a.delete(O),k.profile}}e.InspectProfilingService=N}),define(oe[39],ae([0,1,127,11]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(T,k){A.ok(N.isString(T)),A.ok(N.isObject(k)),A.ok(!this.a.has(T),"There is already an extension with this id"),this.a.set(T,k)}knows(T){return this.a.has(T)}as(T){return this.a.get(T)||null}}e.Registry=new l}),define(oe[107],ae([0,1,3,39]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(k){return k.length>0&&k.charAt(k.length-1)==="#"?k.substring(0,k.length-1):k}class O{constructor(){this.b=new A.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(I,v){this.a[l(I)]=v,this.b.fire(I)}notifySchemaChanged(I){this.b.fire(I)}getSchemaContributions(){return{schemas:this.a}}}const T=new O;N.Registry.add(e.Extensions.JSONContribution,T)}),define(oe[45],ae([0,1,21,3,11,150,17,107,39]),function(ie,e,A,N,l,O,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var v;(function(L){L.Multiline="multilineText",L.Singleline="singlelineText"})(v||(e.EditPresentationTypes=v={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(L){L[L.APPLICATION=1]="APPLICATION",L[L.MACHINE=2]="MACHINE",L[L.WINDOW=3]="WINDOW",L[L.RESOURCE=4]="RESOURCE",L[L.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",L[L.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R||(e.ConfigurationScope=R={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const b=I.Registry.as(k.Extensions.JSONContribution);class m{constructor(){this.h=new Set,this.i=new N.Emitter,this.onDidSchemaChange=this.i.event,this.j=new N.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const t=new Set;this.n(n,r,t),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}deregisterConfigurations(n){const r=new Set;this.o(n,r),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const t=new Set;this.o(r,t),this.n(n,!1,t),b.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:t})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const t=[];for(const{overrides:i,source:s}of n)for(const o in i)if(r.add(o),e.OVERRIDE_PROPERTY_REGEX.test(o)){const c=this.a.get(o),y=c?.valuesSources??new Map;if(s)for(const D of Object.keys(i[o]))y.set(D,s);const w={...c?.value||{},...i[o]};this.a.set(o,{source:s,value:w,valuesSources:y});const f=(0,T.getLanguageTagSettingPlainKey)(o),P={type:"object",default:w,description:O.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:w,source:l.isString(s)?void 0:s,defaultValueSource:s};t.push(...E(o)),this.d[o]=P,this.b.properties[o]=P}else{this.a.set(o,{value:i[o],source:s});const c=this.d[o];c&&(this.w(o,c),this.r(o,c))}this.m(t)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:t,source:i}of n)for(const s in t){const o=this.a.get(s),c=l.isString(i)?i:i?.id,y=l.isString(o?.source)?o?.source:o?.source?.id;if(c===y)if(r.add(s),this.a.delete(s),e.OVERRIDE_PROPERTY_REGEX.test(s))delete this.d[s],delete this.b.properties[s];else{const w=this.d[s];w&&(this.w(s,w),this.r(s,w))}}this.u()}deltaConfiguration(n){let r=!1;const t=new Set;n.removedDefaults&&(this.l(n.removedDefaults,t),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,t),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,t),n.addedConfigurations&&this.n(n.addedConfigurations,!1,t),this.i.fire(),this.j.fire({properties:t,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,t){n.forEach(i=>{this.p(i,r,i.extensionInfo,i.restrictedProperties,void 0,t),this.c.push(i),this.q(i)})}o(n,r){const t=i=>{if(i.properties)for(const s in i.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,i.properties[s])}i.allOf?.forEach(s=>t(s))};for(const i of n){t(i);const s=this.c.indexOf(i);s!==-1&&this.c.splice(s,1)}}p(n,r=!0,t,i,s=3,o){s=l.isUndefinedOrNull(n.scope)?s:n.scope;const c=n.properties;if(c)for(const w in c){const f=c[w];if(r&&d(w,f)){delete c[w];continue}if(f.source=t,f.defaultDefaultValue=c[w].default,this.w(w,f),e.OVERRIDE_PROPERTY_REGEX.test(w)?f.scope=void 0:(f.scope=l.isUndefinedOrNull(f.scope)?s:f.scope,f.restricted=l.isUndefinedOrNull(f.restricted)?!!i?.includes(w):f.restricted),c[w].hasOwnProperty("included")&&!c[w].included){this.f[w]=c[w],delete c[w];continue}else this.d[w]=c[w],c[w].policy?.name&&this.e.set(c[w].policy.name,w);!c[w].deprecationMessage&&c[w].markdownDeprecationMessage&&(c[w].deprecationMessage=c[w].markdownDeprecationMessage),o.add(w)}const y=n.allOf;if(y)for(const w of y)this.p(w,r,t,i,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=t=>{const i=t.properties;if(i)for(const o in i)this.r(o,i[o]);t.allOf?.forEach(r)};r(n)}r(n,r){switch(e.allSettings.properties[n]=r,r.scope){case 1:e.applicationSettings.properties[n]=r;break;case 2:e.machineSettings.properties[n]=r;break;case 6:e.machineOverridableSettings.properties[n]=r;break;case 3:e.windowSettings.properties[n]=r;break;case 4:e.resourceSettings.properties[n]=r;break;case 5:e.resourceSettings.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.allSettings.properties[n],r.scope){case 1:delete e.applicationSettings.properties[n];break;case 2:delete e.machineSettings.properties[n];break;case 6:delete e.machineOverridableSettings.properties[n];break;case 3:delete e.windowSettings.properties[n];break;case 4:case 5:delete e.resourceSettings.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,t={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}}v(){const n={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=n,this.i.fire()}w(n,r){const t=this.a.get(n);let i=t?.value,s=t?.source;l.isUndefined(i)&&(i=r.defaultDefaultValue,s=void 0),l.isUndefined(i)&&(i=h(r.type)),r.default=i,r.defaultValueSource=s}}const g="\\[([^\\]]+)\\]",p=new RegExp(g,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${g})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function E(L){const n=[];if(e.OVERRIDE_PROPERTY_REGEX.test(L)){let r=p.exec(L);for(;r?.length;){const t=r[1].trim();t&&n.push(t),r=p.exec(L)}}return(0,A.distinct)(n)}e.overrideIdentifiersFromKey=E;function a(L){return L.reduce((n,r)=>`${n}[${r}]`,"")}e.keyFromOverrideIdentifiers=a;function h(L){switch(Array.isArray(L)?L[0]:L){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const u=new m;I.Registry.add(e.Extensions.Configuration,u);function d(L,n){return L.trim()?e.OVERRIDE_PROPERTY_REGEX.test(L)?O.localize(7,null,L):u.getConfigurationProperties()[L]!==void 0?O.localize(8,null,L):n.policy?.name&&u.getPolicyConfigurations().get(n.policy?.name)!==void 0?O.localize(9,null,L,n.policy?.name,u.getPolicyConfigurations().get(n.policy?.name)):null:O.localize(6,null)}e.validateProperty=d;function S(){const L=[],n=u.getConfigurationProperties();for(const r of Object.keys(n))L.push([r,n[r].scope]);return L.push(["launch",4]),L.push(["task",4]),L}e.getScopes=S}),define(oe[75],ae([0,1,21,3,35,2,37,31,11,12,17,45,39]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function g(r){return Object.isFrozen(r)?r:k.deepFreeze(r)}class p{constructor(t={},i=[],s=[],o){this.b=t,this.c=i,this.d=s,this.raw=o,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const t=this.raw.map(i=>{if(i instanceof p)return i;const s=new E("");return s.parseRaw(i),s.configurationModel});this.f=t.reduce((i,s)=>s===i?s:i.merge(s),t[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(t){return t?(0,R.getConfigurationValue)(this.contents,t):this.contents}inspect(t,i){const s=this.rawConfiguration.getValue(t),o=i?this.rawConfiguration.getOverrideValue(t,i):void 0,c=i?this.rawConfiguration.override(i).getValue(t):s;return{value:s,override:o,merged:c}}getOverrideValue(t,i){const s=this.i(i);return s?t?(0,R.getConfigurationValue)(s,t):s:void 0}getKeysForOverrideIdentifier(t){const i=[];for(const s of this.overrides)s.identifiers.includes(t)&&i.push(...s.keys);return A.distinct(i)}getAllOverrideIdentifiers(){const t=[];for(const i of this.overrides)t.push(...i.identifiers);return A.distinct(t)}override(t){let i=this.a.get(t);return i||(i=this.g(t),this.a.set(t,i)),i}merge(...t){const i=k.deepClone(this.contents),s=k.deepClone(this.overrides),o=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const y of t)if(c.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.h(i,y.contents);for(const w of y.overrides){const[f]=s.filter(P=>A.equals(P.identifiers,w.identifiers));f?(this.h(f.contents,w.contents),f.keys.push(...w.keys),f.keys=A.distinct(f.keys)):s.push(k.deepClone(w))}for(const w of y.keys)o.indexOf(w)===-1&&o.push(w)}return new p(i,o,s,c.every(y=>y instanceof p)?void 0:c)}g(t){const i=this.i(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;const s={};for(const o of A.distinct([...Object.keys(this.contents),...Object.keys(i)])){let c=this.contents[o];const y=i[o];y&&(typeof c=="object"&&typeof y=="object"?(c=k.deepClone(c),this.h(c,y)):c=y),s[o]=c}return new p(s,this.keys,this.overrides)}h(t,i){for(const s of Object.keys(i)){if(s in t&&I.isObject(t[s])&&I.isObject(i[s])){this.h(t[s],i[s]);continue}t[s]=k.deepClone(i[s])}}i(t){let i=null,s=null;const o=c=>{c&&(s?this.h(s,c):s=k.deepClone(c))};for(const c of this.overrides)A.equals(c.identifiers,[t])?i=c.contents:c.identifiers.includes(t)&&o(c.contents);return o(i),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(t,i){this.j(t,i,!0)}setValue(t,i){this.j(t,i,!1)}removeValue(t){const i=this.keys.indexOf(t);i!==-1&&(this.keys.splice(i,1),(0,R.removeFromValueTree)(this.contents,t),b.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.splice(this.overrides.findIndex(s=>A.equals(s.identifiers,(0,b.overrideIdentifiersFromKey)(t))),1))}j(t,i,s){(0,R.addToValueTree)(this.contents,t,i,o=>console.error(o)),s=s||this.keys.indexOf(t)===-1,s&&this.keys.push(t),b.OVERRIDE_PROPERTY_REGEX.test(t)&&this.overrides.push({identifiers:(0,b.overrideIdentifiersFromKey)(t),keys:Object.keys(this.contents[t]),contents:(0,R.toValuesTree)(this.contents[t],o=>console.error(o))})}}e.ConfigurationModel=p;class E{constructor(t){this.f=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(t,i){if(!I.isUndefinedOrNull(t)){const s=this.g(t);this.parseRaw(s,i)}}reparse(t){this.a&&this.parseRaw(this.a,t)}parseRaw(t,i){this.a=t;const{contents:s,keys:o,overrides:c,restricted:y,hasExcludedProperties:w}=this.h(t,i);this.b=new p(s,o,c,w?[t]:void 0),this.c=y||[]}g(t){let i={},s=null,o=[];const c=[],y=[];function w(P){Array.isArray(o)?o.push(P):s!==null&&(o[s]=P)}const f={onObjectBegin:()=>{const P={};w(P),c.push(o),o=P,s=null},onObjectProperty:P=>{s=P},onObjectEnd:()=>{o=c.pop()},onArrayBegin:()=>{const P=[];w(P),c.push(o),o=P,s=null},onArrayEnd:()=>{o=c.pop()},onLiteralValue:w,onError:(P,D,M)=>{y.push({error:P,offset:D,length:M})}};if(t)try{l.visit(t,f),i=o[0]||{}}catch(P){console.error(`Error while parsing settings file ${this.f}: ${P}`),this.d=[P]}return i}h(t,i){const s=m.Registry.as(b.Extensions.Configuration).getConfigurationProperties(),o=this.i(t,s,!0,i);t=o.raw;const c=(0,R.toValuesTree)(t,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),y=Object.keys(t),w=this.j(t,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:c,keys:y,overrides:w,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}i(t,i,s,o){let c=!1;if(!o?.scopes&&!o?.skipRestricted)return{raw:t,restricted:[],hasExcludedProperties:c};const y={},w=[];for(const f in t)if(b.OVERRIDE_PROPERTY_REGEX.test(f)&&s){const P=this.i(t[f],i,!1,o);y[f]=P.raw,c=c||P.hasExcludedProperties,w.push(...P.restricted)}else{const P=i[f],D=P?typeof P.scope<"u"?P.scope:3:void 0;P?.restricted&&w.push(f),(D===void 0||o.scopes===void 0||o.scopes.includes(D))&&!(o.skipRestricted&&P?.restricted)?y[f]=t[f]:c=!0}return{raw:y,restricted:w,hasExcludedProperties:c}}j(t,i){const s=[];for(const o of Object.keys(t))if(b.OVERRIDE_PROPERTY_REGEX.test(o)){const c={};for(const y in t[o])c[y]=t[o][y];s.push({identifiers:(0,b.overrideIdentifiersFromKey)(o),keys:Object.keys(c),contents:(0,R.toValuesTree)(c,i)})}return s}}e.ConfigurationModelParser=E;class a extends O.Disposable{constructor(t,i,s,o){super(),this.f=t,this.g=i,this.h=o,this.c=this.B(new N.Emitter),this.onDidChange=this.c.event,this.a=new E(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(s.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(N.Event.any(N.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),N.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&s.isEqual(c.resource,t)))(()=>this.c.fire()))}async loadConfiguration(){try{const t=await this.h.readFile(this.f);return this.a.parse(t.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=a;class h{constructor(t,i,s,o,c,y,w,f,P,D,M,j,B){this.a=t,this.b=i,this.c=s,this.overrideIdentifiers=o,this.d=c,this.f=y,this.g=w,this.h=f,this.i=P,this.j=D,this.k=M,this.l=j,this.m=B}get value(){return g(this.c)}n(t,i,s){const o=t.inspect(i,s);return{get value(){return g(o.value)},get override(){return g(o.override)},get merged(){return g(o.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class u{constructor(t,i,s,o,c=new p,y=new p,w=new T.ResourceMap,f=new p,P=new T.ResourceMap){this.c=t,this.d=i,this.f=s,this.g=o,this.h=c,this.i=y,this.j=w,this.l=f,this.m=P,this.a=null,this.b=new T.ResourceMap,this.n=null}getValue(t,i,s){return this.q(t,i,s).getValue(t)}updateValue(t,i,s={}){let o;s.resource?(o=this.m.get(s.resource),o||(o=new p,this.m.set(s.resource,o))):o=this.l,i===void 0?o.removeValue(t):o.setValue(t,i),s.resource||(this.a=null)}inspect(t,i,s){const o=this.q(t,i,s),c=this.u(i.resource,s),y=i.resource?this.m.get(i.resource)||this.l:this.l,w=new Set;for(const f of o.overrides)for(const P of f.identifiers)o.getOverrideValue(t,P)!==void 0&&w.add(P);return new h(t,i,o.getValue(t),w.size?[...w]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.i:void 0,c||void 0,y)}keys(t){const i=this.u(void 0,t);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:i?i.keys.slice(0):[]}}updateDefaultConfiguration(t){this.c=t,this.a=null,this.b.clear()}updatePolicyConfiguration(t){this.d=t}updateApplicationConfiguration(t){this.f=t,this.a=null,this.b.clear()}updateLocalUserConfiguration(t){this.g=t,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(t){this.h=t,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(t){this.i=t,this.a=null,this.b.clear()}updateFolderConfiguration(t,i){this.j.set(t,i),this.b.delete(t)}deleteFolderConfiguration(t){this.p.delete(t),this.b.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const s=[];if(!i){const{added:o,updated:c,removed:y}=L(this.c,t);i=[...o,...c,...y]}for(const o of i)for(const c of(0,b.overrideIdentifiersFromKey)(o)){const y=this.c.getKeysForOverrideIdentifier(c),w=t.getKeysForOverrideIdentifier(c),f=[...w.filter(P=>y.indexOf(P)===-1),...y.filter(P=>w.indexOf(P)===-1),...y.filter(P=>!k.equals(this.c.override(c).getValue(P),t.override(c).getValue(P)))];s.push([c,f])}return this.updateDefaultConfiguration(t),{keys:i,overrides:s}}compareAndUpdatePolicyConfiguration(t){const{added:i,updated:s,removed:o}=L(this.d,t),c=[...i,...s,...o];return c.length&&this.updatePolicyConfiguration(t),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(t){const{added:i,updated:s,removed:o,overrides:c}=L(this.applicationConfiguration,t),y=[...i,...s,...o];return y.length&&this.updateApplicationConfiguration(t),{keys:y,overrides:c}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:c}=L(this.localUserConfiguration,t),y=[...i,...s,...o];return y.length&&this.updateLocalUserConfiguration(t),{keys:y,overrides:c}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:s,removed:o,overrides:c}=L(this.remoteUserConfiguration,t),y=[...i,...s,...o];return y.length&&this.updateRemoteUserConfiguration(t),{keys:y,overrides:c}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:s,removed:o,overrides:c}=L(this.workspaceConfiguration,t),y=[...i,...s,...o];return y.length&&this.updateWorkspaceConfiguration(t),{keys:y,overrides:c}}compareAndUpdateFolderConfiguration(t,i){const s=this.p.get(t),{added:o,updated:c,removed:y,overrides:w}=L(s,i),f=[...o,...c,...y];return(f.length||!s)&&this.updateFolderConfiguration(t,i),{keys:f,overrides:w}}compareAndDeleteFolderConfiguration(t){const i=this.p.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:s,updated:o,removed:c,overrides:y}=L(i,void 0);return{keys:[...s,...o,...c],overrides:y}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(t,i,s){let o=this.r(i,s);return i.overrideIdentifier&&(o=o.override(i.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(t)!==void 0&&(o=o.merge(this.d)),o}r({resource:t},i){let s=this.s();if(i&&t){const o=i.getFolder(t);o&&(s=this.t(o.uri)||s);const c=this.m.get(t);c&&(s=s.merge(c))}return s}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(t){let i=this.b.get(t);if(!i){const s=this.s(),o=this.j.get(t);o?(i=s.merge(o),this.b.set(t,i)):i=s}return i}u(t,i){if(i&&t){const s=i.getFolder(t);if(s)return this.j.get(s.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((t,i)=>{const{contents:s,overrides:o,keys:c}=this.j.get(i);return t.push([i,{contents:s,overrides:o,keys:c}]),t},[])}}allKeys(){const t=new Set;return this.c.keys.forEach(i=>t.add(i)),this.userConfiguration.keys.forEach(i=>t.add(i)),this.i.keys.forEach(i=>t.add(i)),this.j.forEach(i=>i.keys.forEach(s=>t.add(s))),[...t.values()]}v(){const t=new Set;return this.c.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.userConfiguration.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.i.getAllOverrideIdentifiers().forEach(i=>t.add(i)),this.j.forEach(i=>i.getAllOverrideIdentifiers().forEach(s=>t.add(s))),[...t.values()]}w(t){const i=new Set;return this.c.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.i.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s)),this.j.forEach(s=>s.getKeysForOverrideIdentifier(t).forEach(o=>i.add(o))),[...i.values()]}static parse(t){const i=this.x(t.defaults),s=this.x(t.policy),o=this.x(t.application),c=this.x(t.user),y=this.x(t.workspace),w=t.folders.reduce((f,P)=>(f.set(v.URI.revive(P[0]),this.x(P[1])),f),new T.ResourceMap);return new u(i,s,o,c,new p,y,w,new p,new T.ResourceMap)}static x(t){return new p(t.contents,t.keys,t.overrides)}}e.Configuration=u;function d(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const t=new Set,i=new Map;for(const o of r)o.keys.forEach(c=>t.add(c)),o.overrides.forEach(([c,y])=>{const w=(0,T.getOrSet)(i,c,new Set);y.forEach(f=>w.add(f))});const s=[];return i.forEach((o,c)=>s.push([c,[...o.values()]])),{keys:[...t.values()],overrides:s}}e.mergeChanges=d;class S{constructor(t,i,s,o){this.change=t,this.f=i,this.g=s,this.h=o,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of t.keys)this.affectedKeys.add(c);for(const[,c]of t.overrides)for(const y of c)this.affectedKeys.add(y);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=u.parse(this.f.data)),this.i}affectsConfiguration(t,i){const s=this.a+t,o=this.d.indexOf(s);if(o<0)return!1;const c=o+s.length;if(c>=this.d.length)return!1;const y=this.d.charCodeAt(c);if(y!==this.b&&y!==this.c)return!1;if(i){const w=this.previousConfiguration?this.previousConfiguration.getValue(t,i,this.f?.workspace):void 0,f=this.g.getValue(t,i,this.h);return!k.equals(w,f)}return!0}}e.ConfigurationChangeEvent=S;function L(r,t){const{added:i,removed:s,updated:o}=n(t?.rawConfiguration,r?.rawConfiguration),c=[],y=r?.getAllOverrideIdentifiers()||[],w=t?.getAllOverrideIdentifiers()||[];if(t){const f=w.filter(P=>!y.includes(P));for(const P of f)c.push([P,t.getKeysForOverrideIdentifier(P)])}if(r){const f=y.filter(P=>!w.includes(P));for(const P of f)c.push([P,r.getKeysForOverrideIdentifier(P)])}if(t&&r){for(const f of y)if(w.includes(f)){const P=n({contents:r.getOverrideValue(void 0,f)||{},keys:r.getKeysForOverrideIdentifier(f)},{contents:t.getOverrideValue(void 0,f)||{},keys:t.getKeysForOverrideIdentifier(f)});c.push([f,[...P.added,...P.removed,...P.updated]])}}return{added:i,removed:s,updated:o,overrides:c}}function n(r,t){const i=r?t?r.keys.filter(c=>t.keys.indexOf(c)===-1):[...r.keys]:[],s=t?r?t.keys.filter(c=>r.keys.indexOf(c)===-1):[...t.keys]:[],o=[];if(r&&t){for(const c of t.keys)if(r.keys.indexOf(c)!==-1){const y=(0,R.getConfigurationValue)(t.contents,c),w=(0,R.getConfigurationValue)(r.contents,c);k.equals(y,w)||o.push(c)}}return{added:i,removed:s,updated:o}}}),define(oe[215],ae([0,1,21,3,2,31,11,75,45,10,57,39]),function(ie,e,A,N,l,O,T,k,I,v,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class m extends l.Disposable{constructor(){super(...arguments),this.a=this.B(new N.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(b.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:a,defaultsOverrides:h})=>this.c(Array.from(a),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(a,h){this.h(a,b.Registry.as(I.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:a})}f(){return{}}g(){this.b=new k.ConfigurationModel;const a=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(a),a)}h(a,h){const u=this.f();for(const d of a){const S=u[d],L=h[d];S!==void 0?this.b.addValue(d,S):L?this.b.addValue(d,L.default):this.b.removeValue(d)}}}e.DefaultConfiguration=m;class g{constructor(){this.onDidChangeConfiguration=N.Event.None,this.configurationModel=new k.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=g;let p=e.PolicyConfiguration=class extends l.Disposable{get configurationModel(){return this.b}constructor(a,h,u){super(),this.c=a,this.f=h,this.g=u,this.a=this.B(new N.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new k.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(a=>this.i(a))),this.B(this.c.onDidChangeConfiguration(async({properties:a})=>this.j(await this.h(a),!0))),this.b}async h(a){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",a);const h={},u=[],d=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const S of a){const L=d[S];if(!L){u.push(S);continue}if(L.policy){if(L.type!=="string"&&L.type!=="number"){this.g.warn(`Policy ${L.policy.name} has unsupported type ${L.type}`);continue}u.push(S),h[L.policy.name]={type:L.type}}}return(0,T.isEmptyObject)(h)||await this.f.updatePolicyDefinitions(h),u}i(a){this.g.trace("PolicyConfiguration#onDidChangePolicies",a);const h=b.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),u=(0,A.coalesce)(a.map(d=>h.get(d)));this.j(u,!0)}j(a,h){this.g.trace("PolicyConfiguration#update",a);const u=b.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),d=[],S=this.b.isEmpty();for(const L of a){const n=u[L]?.policy?.name;if(n){const r=this.f.getPolicyValue(n);(S?r!==void 0:!(0,O.equals)(this.b.getValue(L),r))&&d.push([L,r])}else this.b.getValue(L)!==void 0&&d.push([L,void 0])}if(d.length){this.g.trace("PolicyConfiguration#changed",d);const L=this.b;this.b=new k.ConfigurationModel;for(const n of L.keys)this.b.setValue(n,L.getValue(n));for(const[n,r]of d)r===void 0?this.b.removeValue(n):this.b.setValue(n,r);h&&this.a.fire(this.b)}}};e.PolicyConfiguration=p=ve([J(1,R.IPolicyService),J(2,v.ILogService)],p)}),define(oe[216],ae([0,1,6,3,2,22,17,75,215,57]),function(ie,e,A,N,l,O,T,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class R extends l.Disposable{constructor(m,g,p,E){super(),this.i=m,this.h=this.B(new N.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new I.DefaultConfiguration),this.c=p instanceof v.NullPolicyService?new I.NullPolicyConfiguration:this.B(new I.PolicyConfiguration(this.b,p,E)),this.f=this.B(new k.UserSettings(this.i,void 0,O.extUriBiasedIgnorePathCase,g)),this.a=new k.Configuration(this.b.configurationModel,this.c.configurationModel,new k.ConfigurationModel,new k.ConfigurationModel),this.g=this.B(new A.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:a,properties:h})=>this.k(a,h))),this.B(this.c.onDidChangeConfiguration(a=>this.l(a))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[m,g,p]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new k.Configuration(m,g,new k.ConfigurationModel,p)}getConfigurationData(){return this.a.toData()}getValue(m,g){const p=typeof m=="string"?m:void 0,E=(0,T.isConfigurationOverrides)(m)?m:(0,T.isConfigurationOverrides)(g)?g:{};return this.a.getValue(p,E,void 0)}updateValue(m,g,p,E){return Promise.reject(new Error("not supported"))}inspect(m){return this.a.inspect(m,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const m=await this.f.loadConfiguration();this.j(m)}j(m){const g=this.a.toData(),p=this.a.compareAndUpdateLocalUserConfiguration(m);this.m(p,g,2)}k(m,g){const p=this.a.toData(),E=this.a.compareAndUpdateDefaultConfiguration(m,g);this.m(E,p,7)}l(m){const g=this.a.toData(),p=this.a.compareAndUpdatePolicyConfiguration(m);this.m(p,g,7)}m(m,g,p){const E=new k.ConfigurationChangeEvent(m,{data:g},this.a);E.source=p,E.sourceConfig=this.n(p),this.h.fire(E)}n(m){switch(m){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=R}),define(oe[217],ae([0,1,9,5]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,N.createDecorator)("remoteAuthorityResolverService");var l;(function(k){k.Unknown="Unknown",k.NotAvailable="NotAvailable",k.TemporarilyNotAvailable="TemporarilyNotAvailable",k.NoResolverFound="NoResolverFound"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class O extends A.ErrorNoTelemetry{static isNotAvailable(I){return I instanceof O&&I._code===l.NotAvailable}static isTemporarilyNotAvailable(I){return I instanceof O&&I._code===l.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof O&&I._code===l.NoResolverFound}static isHandled(I){return I instanceof O&&I.isHandled}constructor(I,v=l.Unknown,R){super(I),this._message=I,this._code=v,this._detail=R,this.isHandled=v===l.NotAvailable&&R===!0,Object.setPrototypeOf(this,O.prototype)}}e.RemoteAuthorityResolverError=O;function T(k){const I=k.indexOf("+");return I===-1?k:k.substring(0,I)}e.getRemoteAuthorityPrefix=T}),define(oe[76],ae([0,1,24]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function N(v){return v.scheme===A.Schemas.vscodeRemote?v.authority:void 0}e.getRemoteAuthority=N;function l(v){if(!v)return;const R=v.indexOf("+");return R<0?v:v.substr(0,R)}e.getRemoteName=l;function O(v){return`/${v.quality??"oss"}-${v.commit??"dev"}`}e.getRemoteServerRootPath=O;function T(v){const{host:R,port:b}=I(v);if(typeof b>"u")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:b}}e.parseAuthorityWithPort=T;function k(v,R){let{host:b,port:m}=I(v);return typeof m>"u"&&(m=R),{host:b,port:m}}e.parseAuthorityWithOptionalPort=k;function I(v){const R=v.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const b=v.match(/^(\[[0-9a-z:]+\])$/);if(b)return{host:b[1],port:void 0};const m=v.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:v,port:void 0}}}),define(oe[50],ae([0,1,27,5,76]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(E){if(typeof E=="object"&&E!==null&&E.supported!==!0)return E.description}e.getWorkspaceSupportTypeMessage=O,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(E){E[E.System=0]="System",E[E.User=1]="User"})(T||(e.ExtensionType=T={}));var k;(function(E){E.WIN32_X64="win32-x64",E.WIN32_IA32="win32-ia32",E.WIN32_ARM64="win32-arm64",E.LINUX_X64="linux-x64",E.LINUX_ARM64="linux-arm64",E.LINUX_ARMHF="linux-armhf",E.ALPINE_X64="alpine-x64",E.ALPINE_ARM64="alpine-arm64",E.DARWIN_X64="darwin-x64",E.DARWIN_ARM64="darwin-arm64",E.WEB="web",E.UNIVERSAL="universal",E.UNKNOWN="unknown",E.UNDEFINED="undefined"})(k||(e.TargetPlatform=k={}));class I{constructor(a){this.value=a,this.c=a.toLowerCase()}static equals(a,h){if(typeof a>"u"||a===null)return typeof h>"u"||h===null;if(typeof h>"u"||h===null)return!1;if(typeof a=="string"||typeof h=="string"){const u=typeof a=="string"?a:a.value,d=typeof h=="string"?h:h.value;return A.equalsIgnoreCase(u,d)}return a.c===h.c}static toKey(a){return typeof a=="string"?a.toLowerCase():a.c}}e.ExtensionIdentifier=I;class v{get size(){return this.c.size}constructor(a){if(this.c=new Set,a)for(const h of a)this.add(h)}add(a){this.c.add(I.toKey(a))}delete(a){return this.c.delete(I.toKey(a))}has(a){return this.c.has(I.toKey(a))}}e.ExtensionIdentifierSet=v;class R{constructor(){this.c=new Map}clear(){this.c.clear()}delete(a){this.c.delete(I.toKey(a))}get(a){return this.c.get(I.toKey(a))}has(a){return this.c.has(I.toKey(a))}set(a,h){this.c.set(I.toKey(a),h)}values(){return this.c.values()}forEach(a){this.c.forEach(a)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=R;function b(E){return m(E)}e.isApplicationScopedExtension=b;function m(E){return E.contributes&&E.contributes.localizations?E.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function g(E){return E.contributes&&E.contributes.authentication?E.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=g;function p(E,a){if(a){const h=`onResolveRemoteAuthority:${(0,l.getRemoteName)(a)}`;return!!E.activationEvents?.includes(h)}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,N.createDecorator)("IBuiltinExtensionsScannerService")}),define(oe[218],ae([0,1,2,50,13]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class O extends A.Disposable{constructor(k,I,v,R,b){super(),this.a=k,this.b=I,this.c=v,this.f=b,this.B(R.onDidInstallExtensions(m=>this.g(m))),this.B(R.onDidUninstallExtension(m=>this.h(m)))}g(k){for(const I of k)I.local&&this.invalidate(I.profileLocation)}h(k){k.error||this.invalidate(k.profileLocation)}async invalidate(k){if(k)for(const I of this.a.profiles)this.c.extUri.isEqual(I.extensionsResource,k)&&await this.i(I);else await this.i(this.a.defaultProfile)}async i(k){try{await this.b.del(this.c.extUri.joinPath(k.cacheHome,N.USER_MANIFEST_CACHE_FILE))}catch(I){(0,l.toFileOperationResult)(I)!==1&&this.f.error(I)}}}e.ExtensionsManifestCache=O}),define(oe[219],ae([0,1,6,16,26,9,3,2,103,89,32,96,217,76]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionHealthChangedEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const p=30*1e3;var E;(function(C){C[C.Management=1]="Management",C[C.ExtensionHost=2]="ExtensionHost",C[C.Tunnel=3]="Tunnel"})(E||(e.ConnectionType=E={}));function a(C){switch(C){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function h(C){const U=new l.CancellationTokenSource;return setTimeout(()=>U.cancel(),C),U.token}function u(C,U){if(C.isCancellationRequested||U.isCancellationRequested)return l.CancellationToken.Cancelled;const q=new l.CancellationTokenSource;return C.onCancellationRequested(()=>q.cancel()),U.onCancellationRequested(()=>q.cancel()),q.token}class d{get didTimeout(){return this.c==="timedout"}constructor(U){this.c="pending",this.d=new k.DisposableStore,this.promise=new Promise((q,G)=>{this.f=q,this.g=G}),U.isCancellationRequested?this.h():this.d.add(U.onCancellationRequested(()=>this.h()))}registerDisposable(U){this.c==="pending"?this.d.add(U):U.dispose()}h(){this.c==="pending"&&(this.d.dispose(),this.c="timedout",this.g(this.i()))}i(){const U=new Error("Time limit reached");return U.code="ETIMEDOUT",U.syscall="connect",U}resolve(U){this.c==="pending"&&(this.d.dispose(),this.c="resolved",this.f(U))}reject(U){this.c==="pending"&&(this.d.dispose(),this.c="rejected",this.g(U))}}function S(C,U){const q=new d(U);return q.registerDisposable(C.onControlMessage(G=>{const V=JSON.parse(G.toString()),Z=te(V);Z?q.reject(Z):q.resolve(V)})),q.promise}function L(C,U,q,G,V,Z,ee,ce,ue){const de=new d(ue),ye=v.StopWatch.create(!1);return C.info(`Creating a socket (${ce})...`),I.mark(`code/willCreateSocket/${ee}`),U.connect(q,G,V,Z,ce,(Se,Ee)=>{de.didTimeout?(I.mark(`code/didCreateSocketError/${ee}`),C.info(`Creating a socket (${ce}) finished after ${ye.elapsed()} ms, but this is too late and has timed out already.`),Se&&C.error(Se),Ee?.dispose()):Se||!Ee?(I.mark(`code/didCreateSocketError/${ee}`),C.info(`Creating a socket (${ce}) returned an error after ${ye.elapsed()} ms.`),de.reject(Se)):(I.mark(`code/didCreateSocketOK/${ee}`),C.info(`Creating a socket (${ce}) was successful after ${ye.elapsed()} ms.`),de.resolve(Ee))}),de.promise}function n(C,U){const q=new d(U);return C.then(G=>{q.didTimeout||q.resolve(G)},G=>{q.didTimeout||q.reject(G)}),q.promise}async function r(C,U,q,G){const V=K(C,U);C.logService.trace(`${V} 1/6. invoking socketFactory.connect().`);let Z;try{Z=await L(C.logService,C.socketFactory,C.host,C.port,(0,g.getRemoteServerRootPath)(C),`reconnectionToken=${C.reconnectionToken}&reconnection=${C.reconnectionProtocol?"true":"false"}`,a(U),`renderer-${a(U)}-${C.reconnectionToken}`,G)}catch(ye){throw C.logService.error(`${V} socketFactory.connect() failed or timed out. Error:`),C.logService.error(ye),ye}C.logService.trace(`${V} 2/6. socketFactory.connect() was successful.`);let ee,ce;C.reconnectionProtocol?(C.reconnectionProtocol.beginAcceptReconnection(Z,null),ee=C.reconnectionProtocol,ce=!1):(ee=new b.PersistentProtocol({socket:Z,measureRoundTripTime:!0}),ce=!0),C.logService.trace(`${V} 3/6. sending AuthRequest control message.`);const ue=await n(C.signService.createNewMessage((0,R.generateUuid)()),G),de={type:"auth",auth:C.connectionToken||"00000000000000000000",data:ue.data};ee.sendControl(N.VSBuffer.fromString(JSON.stringify(de)));try{const ye=await S(ee,u(G,h(1e4)));if(ye.type!=="sign"||typeof ye.data!="string"){const ke=new Error("Unexpected handshake message");throw ke.code="VSCODE_CONNECTION_ERROR",ke}if(C.logService.trace(`${V} 4/6. received SignRequest control message.`),!await n(C.signService.validate(ue,ye.signedData),G)){const ke=new Error("Refused to connect to unsupported server");throw ke.code="VSCODE_CONNECTION_ERROR",ke}const Ee=await n(C.signService.sign(ye.data),G),Re={type:"connectionType",commit:C.commit,signedData:Ee,desiredConnectionType:U};return q&&(Re.args=q),C.logService.trace(`${V} 5/6. sending ConnectionTypeRequest control message.`),ee.sendControl(N.VSBuffer.fromString(JSON.stringify(Re))),{protocol:ee,ownsProtocol:ce}}catch(ye){throw ye&&ye.code==="ETIMEDOUT"&&(C.logService.error(`${V} the handshake timed out. Error:`),C.logService.error(ye)),ye&&ye.code==="VSCODE_CONNECTION_ERROR"&&(C.logService.error(`${V} received error control message when negotiating connection. Error:`),C.logService.error(ye)),ce&&x(ee),ye}}async function t(C,U,q,G){const V=Date.now(),Z=K(C,U),{protocol:ee,ownsProtocol:ce}=await r(C,U,q,G),ue=new d(G);return ue.registerDisposable(ee.onControlMessage(de=>{const ye=JSON.parse(de.toString()),Se=te(ye);Se?(C.logService.error(`${Z} received error control message when negotiating connection. Error:`),C.logService.error(Se),ce&&x(ee),ue.reject(Se)):(C.reconnectionProtocol?.endAcceptReconnection(),C.logService.trace(`${Z} 6/6. handshake finished, connection is up and running after ${F(V)}!`),ue.resolve({protocol:ee,firstMessage:ye}))})),ue.promise}async function i(C,U){const{protocol:q}=await t(C,1,void 0,U);return{protocol:q}}async function s(C,U,q){const{protocol:G,firstMessage:V}=await t(C,2,U,q),Z=V&&V.debugPort;return{protocol:G,debugPort:Z}}async function o(C,U,q){const G=Date.now(),V=K(C,3),{protocol:Z}=await r(C,3,U,q);return C.logService.trace(`${V} 6/6. handshake finished, connection is up and running after ${F(G)}!`),Z}async function c(C,U,q){const{host:G,port:V,connectionToken:Z}=await C.addressProvider.getAddress();return{commit:C.commit,quality:C.quality,host:G,port:V,connectionToken:Z,reconnectionToken:U,reconnectionProtocol:q,socketFactory:C.socketFactory,signService:C.signService,logService:C.logService}}async function y(C,U,q){return f(C,async G=>{const{protocol:V}=await i(G,l.CancellationToken.None);return new $(C,U,q,G.reconnectionToken,V)})}e.connectRemoteAgentManagement=y;async function w(C,U){return f(C,async q=>{const{protocol:G,debugPort:V}=await s(q,U,l.CancellationToken.None);return new z(C,U,q.reconnectionToken,G,V)})}e.connectRemoteAgentExtensionHost=w;async function f(C,U){for(let G=1;;G++)try{const V=(0,R.generateUuid)(),Z=await c(C,V,null);return await U(Z)}catch(V){if(G<5)C.logService.error(`[remote-connection][attempt ${G}] An error occurred in initial connection! Will retry... Error:`),C.logService.error(V);else throw C.logService.error(`[remote-connection][attempt ${G}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),C.logService.error(V),Y.triggerPermanentFailure(0,0,m.RemoteAuthorityResolverError.isHandled(V)),V}}async function P(C,U,q){const G=await c(C,(0,R.generateUuid)(),null);return await o(G,{host:U,port:q},l.CancellationToken.None)}e.connectRemoteAgentTunnel=P;function D(C){return(0,A.createCancelablePromise)(U=>new Promise((q,G)=>{const V=setTimeout(q,C*1e3);U.onCancellationRequested(()=>{clearTimeout(V),q()})}))}var M;(function(C){C[C.ConnectionLost=0]="ConnectionLost",C[C.ReconnectionWait=1]="ReconnectionWait",C[C.ReconnectionRunning=2]="ReconnectionRunning",C[C.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",C[C.ConnectionGain=4]="ConnectionGain",C[C.ConnectionHealthChanged=5]="ConnectionHealthChanged"})(M||(e.PersistentConnectionEventType=M={}));class j{constructor(U,q){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.type=0}}e.ConnectionLostEvent=j;class B{constructor(U,q,G,V){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.durationSeconds=G,this.c=V,this.type=1}skipWait(){this.c.cancel()}}e.ReconnectionWaitEvent=B;class W{constructor(U,q,G){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.attempt=G,this.type=2}}e.ReconnectionRunningEvent=W;class H{constructor(U,q,G){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.attempt=G,this.type=4}}e.ConnectionGainEvent=H;class Q{constructor(U,q){this.reconnectionToken=U,this.connectionHealth=q,this.type=5}}e.ConnectionHealthChangedEvent=Q;class _{constructor(U,q,G,V){this.reconnectionToken=U,this.millisSinceLastIncomingData=q,this.attempt=G,this.handled=V,this.type=3}}e.ReconnectionPermanentFailureEvent=_;class Y extends k.Disposable{static triggerPermanentFailure(U,q,G){this._permanentFailure=!0,this.f=U,this.g=q,this.h=G,this.i.forEach(V=>V.v(this.f,this.g,this.h))}static debugTriggerReconnection(){this.i.forEach(U=>U.s())}static debugPauseSocketWriting(){this.i.forEach(U=>U.w())}get k(){return this.c||Y._permanentFailure}constructor(U,q,G,V,Z){super(),this.n=U,this.p=q,this.reconnectionToken=G,this.protocol=V,this.r=Z,this.j=this.B(new T.Emitter),this.onDidStateChange=this.j.event,this.c=!1,this.l=!1,this.m=!1,this.j.fire(new H(this.reconnectionToken,0,0)),this.B(V.onSocketClose(ee=>{const ce=X(this.n,this.reconnectionToken,!0);ee?ee.type===0?(this.p.logService.info(`${ce} received socket close event (hadError: ${ee.hadError}).`),ee.error&&this.p.logService.error(ee.error)):(this.p.logService.info(`${ce} received socket close event (wasClean: ${ee.wasClean}, code: ${ee.code}, reason: ${ee.reason}).`),ee.event&&this.p.logService.error(ee.event)):this.p.logService.info(`${ce} received socket close event.`),this.s()})),this.B(V.onSocketTimeout(ee=>{const ce=X(this.n,this.reconnectionToken,!0);this.p.logService.info(`${ce} received socket timeout event (unacknowledgedMsgCount: ${ee.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${ee.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${ee.timeSinceLastReceivedSomeData}).`),this.s()})),this.B(V.onHighRoundTripTime(ee=>{const ce=re(this.n,this.reconnectionToken);this.p.logService.info(`${ce} high roundtrip time: ${ee.roundTripTime}ms (${ee.recentHighRoundTripCount} of 5 recent samples)`)})),this.B(V.onDidChangeConnectionHealth(ee=>{this.j.fire(new Q(this.reconnectionToken,ee))})),Y.i.push(this),this.B((0,k.toDisposable)(()=>{const ee=Y.i.indexOf(this);ee>=0&&Y.i.splice(ee,1)})),this.k&&this.v(Y.f,Y.g,Y.h)}dispose(){super.dispose(),this.m=!0}async s(){if(!this.l)try{this.l=!0,await this.t()}finally{this.l=!1}}async t(){if(this.k||this.m)return;const U=X(this.n,this.reconnectionToken,!0);this.p.logService.info(`${U} starting reconnecting loop. You can get more information with the trace log level.`),this.j.fire(new j(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const q=[0,5,5,10,10,10,10,10,30];let G=-1;do{G++;const V=G<q.length?q[G]:q[q.length-1];try{if(V>0){const ee=D(V);this.j.fire(new B(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),V,ee)),this.p.logService.info(`${U} waiting for ${V} seconds before reconnecting...`);try{await ee}catch{}}if(this.k){this.p.logService.error(`${U} permanent failure occurred while running the reconnecting loop.`);break}this.j.fire(new W(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1)),this.p.logService.info(`${U} resolving connection...`);const Z=await c(this.p,this.reconnectionToken,this.protocol);this.p.logService.info(`${U} connecting to ${Z.host}:${Z.port}...`),await this.y(Z,h(p)),this.p.logService.info(`${U} reconnected!`),this.j.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),G+1));break}catch(Z){if(Z.code==="VSCODE_CONNECTION_ERROR"){this.p.logService.error(`${U} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(G>360){this.p.logService.error(`${U} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}if(m.RemoteAuthorityResolverError.isTemporarilyNotAvailable(Z)){this.p.logService.info(`${U} A temporarily not available error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Z);continue}if((Z.code==="ETIMEDOUT"||Z.code==="ENETUNREACH"||Z.code==="ECONNREFUSED"||Z.code==="ECONNRESET")&&Z.syscall==="connect"){this.p.logService.info(`${U} A network error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Z);continue}if((0,O.isCancellationError)(Z)){this.p.logService.info(`${U} A promise cancelation error occurred while trying to reconnect, will try again...`),this.p.logService.trace(Z);continue}if(Z instanceof m.RemoteAuthorityResolverError){this.p.logService.error(`${U} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),G+1,m.RemoteAuthorityResolverError.isHandled(Z));break}this.p.logService.error(`${U} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this.p.logService.error(Z),this.u(this.protocol.getMillisSinceLastIncomingData(),G+1,!1);break}}while(!this.k&&!this.m)}u(U,q,G){this.r?Y.triggerPermanentFailure(U,q,G):this.v(U,q,G)}v(U,q,G){this.j.fire(new _(this.reconnectionToken,U,q,G)),x(this.protocol)}w(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=Y,Y._permanentFailure=!1,Y.f=0,Y.g=0,Y.h=!1,Y.i=[];class $ extends Y{constructor(U,q,G,V,Z){super(1,U,V,Z,!0),this.client=this.B(new b.Client(Z,{remoteAuthority:q,clientId:G},U.ipcLogger))}async y(U,q){await i(U,q)}}e.ManagementPersistentConnection=$;class z extends Y{constructor(U,q,G,V,Z){super(2,U,G,V,!1),this.z=q,this.debugPort=Z}async y(U,q){await s(U,this.z,q)}}e.ExtensionHostPersistentConnection=z;function x(C){try{C.acceptDisconnect();const U=C.getSocket();C.dispose(),U.dispose()}catch(U){(0,O.onUnexpectedError)(U)}}function te(C){if(C&&C.type==="error"){const U=new Error(`Connection error: ${C.reason}`);return U.code="VSCODE_CONNECTION_ERROR",U}return null}function ne(C,U){for(;C.length<U;)C+=" ";return C}function re(C,U){return`[remote-connection][${ne(a(C),13)}][${U.substr(0,5)}\u2026]`}function X(C,U,q){return`${re(C,U)}[${q?"reconnect":"initial"}]`}function K(C,U){return`${X(U,C.reconnectionToken,!!C.reconnectionProtocol)}[${C.host}:${C.port}]`}function F(C){return`${Date.now()-C} ms`}}),define(oe[220],ae([0,1,5]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,A.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(oe[108],ae([0,1,5,167]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LOGGER_NAME=e.LOG_ID=e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX=e.TunnelStates=e.IRemoteTunnelService=void 0,e.IRemoteTunnelService=(0,A.createDecorator)("IRemoteTunnelService");var l;(function(O){O.disconnected=T=>({type:"disconnected",onTokenFailed:T}),O.connected=T=>({type:"connected",info:T}),O.connecting=T=>({type:"connecting",progress:T}),O.uninitialized={type:"uninitialized"}})(l||(e.TunnelStates=l={})),e.CONFIGURATION_KEY_PREFIX="remote.tunnels.access",e.CONFIGURATION_KEY_HOST_NAME=e.CONFIGURATION_KEY_PREFIX+".hostNameOverride",e.CONFIGURATION_KEY_PREVENT_SLEEP=e.CONFIGURATION_KEY_PREFIX+".preventSleep",e.LOG_ID="remoteTunnelService",e.LOGGER_NAME=(0,N.localize)(0,null)}),define(oe[58],ae([0,1,16,9,2,169,45,5,10,39]),function(ie,e,A,N,l,O,T,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.AbstractRequestService=e.IRequestService=void 0,e.IRequestService=(0,k.createDecorator)("requestService");class R{constructor(L){this.b=L}toJSON(){if(!this.a){const L=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?L[n]="*****":L[n]=this.b[n];this.a=L}return this.a}}class b extends l.Disposable{constructor(L,n){super(),this.b=0,this.a=n.createLogger(L?"remotenetwork":"network",{name:L?(0,O.localize)(0,null):(0,O.localize)(1,null),when:I.CONTEXT_LOG_LEVEL.isEqualTo((0,I.LogLevelToString)(I.LogLevel.Trace)).serialize()})}async c(L,n,r){const t=`${L} #${++this.b}: ${n.url}`;this.a.trace(`${t} - begin`,n.type,new R(n.headers??{}));try{const i=await r();return this.a.trace(`${t} - end`,n.type,i.res.statusCode,i.res.headers),i}catch(i){throw this.a.error(`${t} - error`,n.type,(0,N.getErrorMessage)(i)),i}}}e.AbstractRequestService=b;function m(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=m;function g(S){return S.res.statusCode===204}async function p(S){return g(S)?null:(await(0,A.streamToBuffer)(S.stream)).toString()}e.asText=p;async function E(S){if(!m(S))throw new Error("Server returned "+S.res.statusCode);return p(S)}e.asTextOrError=E;async function a(S){if(!m(S))throw new Error("Server returned "+S.res.statusCode);if(g(S))return null;const n=(await(0,A.streamToBuffer)(S.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}e.asJson=a;function h(S){d(S)}e.updateProxyConfigurationsScope=h;let u;function d(S){const L=v.Registry.as(T.Extensions.Configuration),n=u;u={id:"http",order:15,title:(0,O.localize)(2,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,O.localize)(3,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,O.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,O.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,O.localize)(6,null),(0,O.localize)(7,null),(0,O.localize)(8,null),(0,O.localize)(9,null)],default:"override",description:(0,O.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,O.localize)(11,null),restricted:!0}}},L.updateConfigurations({add:[u],remove:n?[n]:[]})}d(1)}),define(oe[221],ae([0,1,26,24,13,58]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let T=e.DownloadService=class{constructor(I,v){this.a=I,this.b=v}async download(I,v,R=A.CancellationToken.None){if(I.scheme===N.Schemas.file||I.scheme===N.Schemas.vscodeRemote){await this.b.copy(I,v);return}const b={type:"GET",url:I.toString(!0)},m=await this.a.request(b,R);if(m.res.statusCode===200)await this.b.writeFile(v,m.stream);else{const g=await(0,O.asTextOrError)(m);throw new Error(`Expected 200, got back ${m.res.statusCode} instead.

${g}`)}}};e.DownloadService=T=ve([J(0,O.IRequestService),J(1,l.IFileService)],T)}),define(oe[222],ae([0,1,16,26]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class l{constructor(k){this.a=k}listen(k,I){throw new Error("Invalid listen")}call(k,I,v,R=N.CancellationToken.None){switch(I){case"request":return this.a.request(v[0],R).then(async({res:b,stream:m})=>{const g=await(0,A.streamToBuffer)(m);return[{statusCode:b.statusCode,headers:b.headers},g]});case"resolveProxy":return this.a.resolveProxy(v[0])}throw new Error("Invalid call")}}e.RequestChannel=l;class O{constructor(k){this.a=k}async request(k,I){const[v,R]=await this.a.call("request",[k],I);return{res:v,stream:(0,A.bufferToStream)(R)}}async resolveProxy(k){return this.a.call("resolveProxy",[k])}}e.RequestChannelClient=O}),define(oe[223],ae([0,1,61,24,97]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class O extends l.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:N.Schemas.vscodeUserData})}}e.SharedProcessEnvironmentService=O,ve([A.memoize],O.prototype,"userRoamingDataHome",null)}),define(oe[224],ae([0,1,49,14,170,26,38,9,4,32,147,188,6,129]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let p;async function E(h,u,d,S){return d["force-disable-user-env"]?(u.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):I.isWindows?(u.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.isLaunchedFromCli)(S)&&!d["force-user-env"]?(u.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.isLaunchedFromCli)(S)?u.trace("resolveShellEnv(): running (--force-user-env)"):u.trace("resolveShellEnv(): running (macOS/Linux)"),p||(p=m.Promises.withAsyncBody(async(L,n)=>{const r=new O.CancellationTokenSource;let t=1e4;const i=h.getValue("application.shellEnvironmentResolutionTimeout");typeof i=="number"&&(t=(0,g.clamp)(i,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),n(new Error((0,l.localize)(0,null)))},t);try{L(await a(u,r.token))}catch(o){!(0,k.isCancellationError)(o)&&!r.token.isCancellationRequested?n(new Error((0,l.localize)(1,null,(0,T.toErrorMessage)(o)))):L({})}finally{clearTimeout(s),r.dispose()}})),p)}e.getResolvedShellEnv=E;async function a(h,u){const d=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",d);const S=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",S);const L=(0,v.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(L+"({.*})"+L),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",r);const t=await(0,R.getSystemShell)(I.OS,r);return h.trace("getUnixShellEnvironment#shell",t),new Promise((i,s)=>{if(u.isCancellationRequested)return s(new k.CancellationError);const o=(0,N.basename)(t);let c,y;const w=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(o)?(c=`& '${process.execPath}' ${w} -p '''${L}'' + JSON.stringify(process.env) + ''${L}'''`,y=["-Login","-Command"]):(c=`'${process.execPath}' ${w} -p '"${L}" + JSON.stringify(process.env) + "${L}"'`,o==="tcsh"||o==="csh"?y=["-ic"]:y=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(y),c);const f=(0,A.spawn)(t,[...y,c],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});u.onCancellationRequested(()=>(f.kill(),s(new k.CancellationError))),f.on("error",M=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,T.toErrorMessage)(M)),s(M)});const P=[];f.stdout.on("data",M=>P.push(M));const D=[];f.stderr.on("data",M=>D.push(M)),f.on("close",(M,j)=>{const B=Buffer.concat(P).toString("utf8");h.trace("getUnixShellEnvironment#raw",B);const W=Buffer.concat(D).toString("utf8");if(W.trim()&&h.trace("getUnixShellEnvironment#stderr",W),M||j)return s(new Error((0,l.localize)(2,null,M,j)));const H=n.exec(B),Q=H?H[1]:"{}";try{const _=JSON.parse(Q);d?_.ELECTRON_RUN_AS_NODE=d:delete _.ELECTRON_RUN_AS_NODE,S?_.ELECTRON_NO_ATTACH_CONSOLE=S:delete _.ELECTRON_NO_ATTACH_CONSOLE,delete _.VSCODE_RESOLVING_ENVIRONMENT,delete _.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",_),i(_)}catch(_){h.error("getUnixShellEnvironment#errorCaught",(0,T.toErrorMessage)(_)),s(_)}})})}}),define(oe[109],ae([0,1,5]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,A.createDecorator)(e.SIGN_SERVICE_ID)}),define(oe[225],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class A{constructor(){this.b=new Map}c(){return new Promise((l,O)=>ie(["vsda"],l,O))}async createNewMessage(l){try{const O=await this.c(),T=new O.validator;if(T){const k=String(A.a++);return this.b.set(k,T),{id:k,data:T.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,O){if(!l.id)return!0;const T=this.b.get(l.id);if(!T)return!1;this.b.delete(l.id);try{return T.validate(O)==="ok"}catch{return!1}}async sign(l){try{const O=await this.c(),T=new O.signer;if(T)return T.sign(l)}catch{}return l}}e.SignService=A,A.a=1}),define(oe[77],ae([0,1,3,2]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageClient=e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class l extends N.Disposable{constructor(b,m,g){super(),this.a=b,this.b=m,this.c=g}async getItems(){const b={profile:this.b,workspace:this.c},m=await this.a.call("getItems",b);return new Map(m)}updateItems(b){const m={profile:this.b,workspace:this.c};return b.insert&&(m.insert=Array.from(b.insert.entries())),b.delete&&(m.delete=Array.from(b.delete.values())),this.a.call("updateItems",m)}}class O extends l{constructor(b,m){super(b,m,void 0),this.f=this.B(new A.Emitter),this.onDidChangeItemsExternal=this.f.event,this.g()}g(){this.B(this.a.listen("onDidChangeStorage",{profile:this.b})(b=>this.h(b)))}h(b){(Array.isArray(b.changed)||Array.isArray(b.deleted))&&this.f.fire({changed:b.changed?new Map(b.changed):void 0,deleted:b.deleted?new Set(b.deleted):void 0})}}class T extends O{constructor(b){super(b,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=T;class k extends O{constructor(b,m){super(b,m)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=k;class I extends l{constructor(b,m){super(b,void 0,m),this.onDidChangeItemsExternal=A.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=I;class v{constructor(b){this.a=b}isUsed(b){const m={payload:b,profile:void 0,workspace:void 0};return this.a.call("isUsed",m)}}e.StorageClient=v}),define(oe[110],ae([0,1,4,36,32]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function O(I){if(A.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}function T(I,v,R,b,m,g,p,E){const a=Object.create(null);a["common.machineId"]=g,a.sessionID=(0,l.generateUuid)()+Date.now(),a.commitHash=b,a.version=m,a["common.platformVersion"]=(I||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),a["common.platform"]=(0,A.PlatformToString)(A.platform),a["common.nodePlatform"]=N.platform,a["common.nodeArch"]=R,a["common.product"]=E||"desktop",p&&(a["common.msftInternal"]=p);let h=0;const u=Date.now();Object.defineProperties(a,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>h++,enumerable:!0}}),A.isLinuxSnap&&(a["common.snap"]="true");const d=O(v);return d&&(a["common.platformDetail"]=d),a}e.resolveCommonProperties=T;function k(I){const v=N.env.USERDNSDOMAIN;if(!v)return!1;const R=v.toLowerCase();return I.some(b=>R===b)}e.verifyMicrosoftInternalDomain=k}),define(oe[20],ae([0,1,5]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,A.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,A.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var N;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var l;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(l||(e.TelemetryConfiguration=l={}))}),define(oe[226],ae([0,1,34,6,35,24,14,4,12,144,28,146,98,13,25,20]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const a=new Map;async function h(n,r){const t=`${n}::${r.join(":")}`,i=a.get(t);if(i)return i;const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],o=new Map,c=new Map,y=2e4;function w(P,D,M,j){const B=D.substring(P.length+1);return N.Promises.withAsyncBody(async W=>{let H;try{H=await R.Promises.readdir(D,{withFileTypes:!0})}catch{W();return}if(j.count>=y){j.count+=H.length,j.maxReached=!0,W();return}let Q=H.length;if(Q===0){W();return}let _=H;j.count+H.length>y&&(j.maxReached=!0,Q=y-j.count,_=H.slice(0,Q)),j.count+=H.length;for(const Y of _)if(Y.isDirectory()){if(M.includes(Y.name)||await w(P,(0,T.join)(D,Y.name),M,j),--Q===0){W();return}}else{const $=Y.name.lastIndexOf(".");if($>=0){const z=Y.name.substring($+1);z&&o.set(z,(o.get(z)??0)+1)}for(const z of s)z.relativePathPattern?.test(B)!==!1&&z.filePattern.test(Y.name)&&c.set(z.tag,(c.get(z.tag)??0)+1);if(--Q===0){W();return}}})}const f=N.Promises.withAsyncBody(async P=>{const D={count:0,maxReached:!1};await w(n,n,r,D);const M=await S(n);P({configFiles:u(c),fileTypes:u(o),fileCount:D.count,maxFilesReached:D.maxReached,launchConfigFiles:M})});return a.set(t,f),f}e.collectWorkspaceStats=h;function u(n){return Array.from(n.entries(),([r,t])=>({name:r,count:t})).sort((r,t)=>t.count-r.count)}function d(){const n={os:`${A.type()} ${A.arch()} ${A.release()}`,memory:`${(A.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(A.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(v.virtualMachineHint.value()*100)}%`},r=A.cpus();return r&&r.length>0&&(n.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),n}e.getMachineInfo=d;async function S(n){try{const r=new Map,t=(0,T.join)(n,".vscode","launch.json"),i=await R.Promises.readFile(t),s=[],o=(0,l.parse)(i.toString(),s);if(s.length)return console.log(`Unable to parse ${t}`),[];if((0,l.getNodeType)(o)==="object"&&o.configurations)for(const c of o.configurations){const y=c.type;y&&(r.has(y)?r.set(y,r.get(y)+1):r.set(y,1))}return u(r)}catch{return[]}}e.collectLaunchConfigs=S;let L=e.DiagnosticsService=class{constructor(r,t){this.c=r,this.d=t}f(r){const t=[];return t.push(`OS Version:       ${r.os}`),t.push(`CPUs:             ${r.cpus}`),t.push(`Memory (System):  ${r.memory}`),t.push(`VM:               ${r.vmHint}`),t.join(`
`)}g(r){const t=[];t.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),t.push(`OS Version:       ${A.type()} ${A.arch()} ${A.release()}`);const i=A.cpus();return i&&i.length>0&&t.push(`CPUs:             ${i[0].model} (${i.length} x ${i[0].speed})`),t.push(`Memory (System):  ${(A.totalmem()/g.ByteSize.GB).toFixed(2)}GB (${(A.freemem()/g.ByteSize.GB).toFixed(2)}GB free)`),k.isWindows||t.push(`Load (avg):       ${A.loadavg().map(s=>Math.round(s)).join(", ")}`),t.push(`VM:               ${Math.round(v.virtualMachineHint.value()*100)}%`),t.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),t.push(`Process Argv:     ${r.mainArguments.join(" ")}`),t.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),t.join(`
`)}async getPerformanceInfo(r,t){return Promise.all([(0,b.listProcesses)(r.mainPID),this.k(r)]).then(async i=>{let[s,o]=i,c=this.m(r,s);return t.forEach(y=>{if((0,m.isRemoteDiagnosticError)(y))c+=`
${y.errorMessage}`,o+=`
${y.errorMessage}`;else if(c+=`

Remote: ${y.hostName}`,y.processes&&(c+=`
${this.m(r,y.processes)}`),y.workspaceMetadata){o+=`
|  Remote: ${y.hostName}`;for(const w of Object.keys(y.workspaceMetadata)){const f=y.workspaceMetadata[w];let P=`${f.fileCount} files`;f.maxFilesReached&&(P=`more than ${P}`),o+=`|    Folder (${w}): ${P}`,o+=this.h(f)}}}),{processInfo:c,workspaceInfo:o}})}async getSystemInfo(r,t){const{memory:i,vmHint:s,os:o,cpus:c}=d(),y={os:o,memory:i,cpus:c,vmHint:s,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:t};return k.isWindows||(y.load=`${A.loadavg().map(w=>Math.round(w)).join(", ")}`),k.isLinux&&(y.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(y)}async getDiagnostics(r,t){const i=[];return(0,b.listProcesses)(r.mainPID).then(async s=>(i.push(""),i.push(this.g(r)),i.push(""),i.push(this.m(r,s)),r.windows.some(o=>o.folderURIs&&o.folderURIs.length>0&&!o.remoteAuthority)&&(i.push(""),i.push("Workspace Stats: "),i.push(await this.k(r))),t.forEach(o=>{if((0,m.isRemoteDiagnosticError)(o))i.push(`
${o.errorMessage}`);else if(i.push(`

`),i.push(`Remote:           ${o.hostName}`),i.push(this.f(o.machineInfo)),o.processes&&i.push(this.m(r,o.processes)),o.workspaceMetadata)for(const c of Object.keys(o.workspaceMetadata)){const y=o.workspaceMetadata[c];let w=`${y.fileCount} files`;y.maxFilesReached&&(w=`more than ${w}`),i.push(`Folder (${c}): ${w}`),i.push(this.h(y))}}),i.push(""),i.push(""),i.join(`
`)))}h(r){const t=[];let s=0;const o=(f,P)=>{const D=` ${f}(${P})`;s+D.length>60?(t.push(c),c="|                 ",s=c.length):s+=D.length,c+=D};let c="|      File types:";const y=10,w=r.fileTypes.length>y?y:r.fileTypes.length;for(let f=0;f<w;f++){const P=r.fileTypes[f];o(P.name,P.count)}if(t.push(c),r.configFiles.length>=0&&(c="|      Conf files:",s=0,r.configFiles.forEach(f=>{o(f.name,f.count)}),t.push(c)),r.launchConfigFiles.length>0){let f="|      Launch Configs:";r.launchConfigFiles.forEach(P=>{const D=P.count>1?` ${P.name}(${P.count})`:` ${P.name}`;f+=D}),t.push(f)}return t.join(`
`)}j(r){const t=Math.max(...Object.keys(r).map(i=>i.length));return Object.keys(r).map(i=>`${i}:  ${" ".repeat(t-i.length)}  ${r[i]}`).join(`
                  `)}k(r){const t=[],i=[];return r.windows.forEach(s=>{s.folderURIs.length===0||s.remoteAuthority||(t.push(`|  Window (${s.title})`),s.folderURIs.forEach(o=>{const c=I.URI.revive(o);if(c.scheme===O.Schemas.file){const y=c.fsPath;i.push(h(y,["node_modules",".git"]).then(w=>{let f=`${w.fileCount} files`;w.maxFilesReached&&(f=`more than ${f}`),t.push(`|    Folder (${(0,T.basename)(y)}): ${f}`),t.push(this.h(w))}).catch(w=>{t.push(`|      Error: Unable to collect workspace stats for folder ${y} (${w.toString()})`)}))}else t.push(`|    Folder (${c.toString()}): Workspace stats not available.`)}))}),Promise.all(i).then(s=>t.join(`
`)).catch(s=>`Unable to collect workspace stats: ${s}`)}m(r,t){const i=new Map;r.windows.forEach(o=>i.set(o.pid,`window [${o.id}] (${o.title})`)),r.pidToNames.forEach(({pid:o,name:c})=>i.set(o,c));const s=[];return s.push("CPU %	Mem MB	   PID	Process"),t&&this.n(r.mainPID,i,s,t,0),s.join(`
`)}n(r,t,i,s,o){const c=o===0;let y;c?y=s.pid===r?`${this.d.applicationName} main`:"remote agent":t.has(s.pid)?y=t.get(s.pid):y=`${"  ".repeat(o)} ${s.name}`;const w=process.platform==="win32"?s.mem:A.totalmem()*(s.mem/100);i.push(`${s.load.toFixed(0).padStart(5," ")}	${(w/g.ByteSize.MB).toFixed(0).padStart(6," ")}	${s.pid.toFixed(0).padStart(6," ")}	${y}`),Array.isArray(s.children)&&s.children.forEach(f=>this.n(r,t,i,f,o+1))}async getWorkspaceFileExtensions(r){const t=new Set;for(const{uri:i}of r.folders){const s=I.URI.revive(i);if(s.scheme!==O.Schemas.file)continue;const o=s.fsPath;try{(await h(o,["node_modules",".git"])).fileTypes.forEach(y=>t.add(y.name))}catch{}}return{extensions:[...t]}}async reportWorkspaceStats(r){for(const{uri:t}of r.folders){const i=I.URI.revive(t);if(i.scheme!==O.Schemas.file)continue;const s=i.fsPath;try{const o=await h(s,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),o.fileTypes.forEach(c=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:c.name,count:c.count})}),o.launchConfigFiles.forEach(c=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:c.name,count:c.count})}),o.configFiles.forEach(c=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:c.name,count:c.count})})}catch{}}}};e.DiagnosticsService=L=ve([J(0,E.ITelemetryService),J(1,p.IProductService)],L)}),define(oe[111],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class A{constructor(O){this.b=O}listen(O,T){throw new Error(`Event not found: ${T}`)}call(O,T,{eventName:k,data:I}){return this.b.forEach(v=>v.log(k,I)),Promise.resolve(null)}}e.TelemetryAppenderChannel=A;class N{constructor(O){this.b=O}log(O,T){return this.b.call("log",{eventName:O,data:T}).then(void 0,k=>`Failed to log telemetry: ${console.warn(k)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=N}),define(oe[46],ae([0,1,31,11,3,17,76,110,20]),function(ie,e,A,N,l,O,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class v{constructor(s){this.value=s,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=v;class R{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=R,e.NullTelemetryService=new R;class b{async publicLog(s,o,c){}async publicLogError(s,o,c){}}e.NullEndpointTelemetryService=b,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(i,s){return l.Event.debounce(s.onDidChangeConfiguration,(c,y)=>{const w=c?new Set([...c.affectedKeys,...y.affectedKeys]):y.affectedKeys;return{...y,affectedKeys:w}},1e3,!0)(c=>{c.source!==7&&i.publicLog2("updateConfiguration",{configurationSource:(0,O.ConfigurationTargetToString)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.configurationTelemetry=m;function g(i,s){return!s.isBuilt&&!s.disableTelemetry?!0:!(s.disableTelemetry||!i.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=g;function p(i,s){return!(s.isBuilt||s.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}e.isLoggingOnly=p;function E(i){const s=i.getValue(I.TELEMETRY_SETTING_ID),o=i.getValue(I.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(i.getValue(I.TELEMETRY_OLD_SETTING_ID)===!1||o===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=E;function a(i){const s={},o={},c={};d(i,c);for(let y in c){y=y.length>150?y.substr(y.length-149):y;const w=c[y];typeof w=="number"?o[y]=w:typeof w=="boolean"?o[y]=w?1:0:typeof w=="string"?(w.length>8192&&console.warn(`Telemetry property: ${y} has been trimmed to 8192, the original length is ${w.length}`),s[y]=w.substring(0,8191)):typeof w<"u"&&w!==null&&(s[y]=w)}return{properties:s,measurements:o}}e.validateTelemetryData=a;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function u(i){if(!i)return"none";const s=(0,T.getRemoteName)(i);return h.has(s)?s:"other"}e.cleanRemoteAuthority=u;function d(i,s,o=0,c){if(i)for(const y of Object.getOwnPropertyNames(i)){const w=i[y],f=c?c+y:y;Array.isArray(w)?s[f]=(0,A.safeStringify)(w):w instanceof Date?s[f]=w.toISOString():(0,N.isObject)(w)?o<2?d(w,s,o+1,f+"."):s[f]=(0,A.safeStringify)(w):s[f]=w}}function S(i,s){const o=i.msftInternalDomains||[],c=s.getValue("telemetry.internalTesting");return(0,k.verifyMicrosoftInternalDomain)(o)||c}e.isInternalTelemetry=S;function L(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}e.getPiiPathsFromEnvironment=L;function n(i,s){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let o=i;const c=[];for(const P of s)for(;;){const D=P.exec(i);if(!D)break;c.push([D.index,P.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,w=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(o="";;){const P=w.exec(i);if(!P)break;const D=c.some(([M,j])=>P.index<j&&M<w.lastIndex);!y.test(P[0])&&!D&&(o+=i.substring(f,P.index)+"<REDACTED: user-file-path>",f=w.lastIndex)}return f<i.length&&(o+=i.substr(f)),o}function r(i){if(!i)return i;const s=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const o of s)if(o.regex.test(i))return`<REDACTED: ${o.label}>`;return i}function t(i,s){return(0,A.cloneAndChange)(i,o=>{if(o instanceof v||Object.hasOwnProperty.call(o,"isTrustedTelemetryValue"))return o.value;if(typeof o=="string"){let c=o.replaceAll("%20"," ");c=n(c,s);for(const y of s)c=c.replace(y,"");return c=r(c),c}})}e.cleanData=t}),define(oe[33],ae([0,1,27,29,50,4,12,9,36,46]),function(ie,e,A,N,l,O,T,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function R(t,i){return t.uuid&&i.uuid?t.uuid===i.uuid:t.id===i.id?!0:(0,A.compareIgnoreCase)(t.id,i.id)===0}e.areSameExtensions=R;const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class m{static create(i){const s=i.manifest?i.manifest.version:i.version,o=i.manifest?i.targetPlatform:i.properties.targetPlatform;return new m(i.identifier,s,o)}static parse(i){const s=b.exec(i);return s&&s[1]&&s[2]?new m({id:s[1]},s[2],s[4]||void 0):null}constructor(i,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=i.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(i){return i instanceof m?R(this,i)&&this.version===i.version&&this.targetPlatform===i.targetPlatform:!1}}e.ExtensionKey=m;const g=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(t){const i=g.exec(t);return i&&i[1]?[a(i[1]),i[2]]:[a(t),void 0]}e.getIdAndVersion=p;function E(t,i){return`${t}.${i}`}e.getExtensionId=E;function a(t){return t.toLowerCase()}e.adoptToGalleryExtensionId=a;function h(t,i){return a(E(t??l.UNDEFINED_PUBLISHER,i))}e.getGalleryExtensionId=h;function u(t,i){const s=[],o=c=>{for(const y of s)if(y.some(w=>R(i(w),i(c))))return y;return null};for(const c of t){const y=o(c);y?y.push(c):s.push([c])}return s}e.groupByExtension=u;function d(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=d;function S(t){return{id:new v.TelemetryTrustedValue(t.identifier.id),name:new v.TelemetryTrustedValue(t.name),galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,isPreReleaseVersion:t.properties.isPreReleaseVersion,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),isSigned:t.isSigned,...t.telemetryData}}e.getGalleryExtensionTelemetryData=S,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function L(t,i){const s=[],o=i.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const c=o.shift();if(c&&s.every(y=>!R(y.identifier,{id:c}))){const y=t.filter(w=>R(w.identifier,{id:c}));y.length===1&&(s.push(y[0]),o.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}e.getExtensionDependencies=L;async function n(t,i){if(!O.isLinux)return!1;let s;try{s=(await t.readFile(T.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await t.readFile(T.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){i.debug("Error while getting the os-release file.",(0,k.getErrorMessage)(c))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(t,i){const s=await n(t,i),o=(0,N.getTargetPlatform)(s?"alpine":O.platform,I.arch);return i.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=r}),define(oe[227],ae([0,1,21,2,22,12,13,25,6,3,14,4,36,33]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractNativeExtensionTipsService=e.ExtensionTipsService=void 0;let p=e.ExtensionTipsService=class extends N.Disposable{constructor(d,S){super(),this.b=d,this.c=S,this.a=new Map,this.c.configBasedExtensionTips&&Object.entries(this.c.configBasedExtensionTips).forEach(([,L])=>this.a.set(L.configPath,L))}getConfigBasedTips(d){return this.f(d)}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async f(d){const S=[];for(const[L,n]of this.a)if(!(n.configScheme&&n.configScheme!==d.scheme))try{const r=(await this.b.readFile((0,l.joinPath)(d,L))).value.toString();for(const[t,i]of Object.entries(n.recommendations))(!i.contentPattern||new RegExp(i.contentPattern,"mig").test(r))&&S.push({extensionId:t,extensionName:i.name,configName:n.configName,important:!!i.important,isExtensionPack:!!i.isExtensionPack,whenNotInstalled:i.whenNotInstalled})}catch{}return S}};e.ExtensionTipsService=p=ve([J(0,T.IFileService),J(1,k.IProductService)],p);const E="extensionTips/promptedExecutableTips",a="extensionTips/lastPromptedMediumImpExeTime";class h extends p{constructor(d,S,L,n,r,t,i,s){super(i,s),this.m=d,this.n=S,this.r=L,this.s=n,this.t=r,this.u=t,this.g=new Map,this.h=new Map,this.j=new Map,this.k=new Map,this.l=new Map,s.exeBasedExtensionTips&&Object.entries(s.exeBasedExtensionTips).forEach(([o,c])=>{const y=[],w=[],f=[];Object.entries(c.recommendations).forEach(([P,D])=>{D.important?c.important?y.push({extensionId:P,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):w.push({extensionId:P,extensionName:D.name,isExtensionPack:!!D.isExtensionPack}):f.push({extensionId:P,extensionName:D.name,isExtensionPack:!!D.isExtensionPack})}),y.length&&this.g.set(o,{exeFriendlyName:c.friendlyName,windowsPath:c.windowsPath,recommendations:y}),w.length&&this.h.set(o,{exeFriendlyName:c.friendlyName,windowsPath:c.windowsPath,recommendations:w}),f.length&&this.j.set(o,{exeFriendlyName:c.friendlyName,windowsPath:c.windowsPath,recommendations:f})}),(0,I.timeout)(3e3).then(async()=>{await this.v(),this.z(),this.C()})}async getImportantExecutableBasedTips(){const d=await this.L(this.g),S=await this.L(this.h);return[...d,...S]}getOtherExecutableBasedTips(){return this.L(this.j)}async v(){const d=await this.L(this.g),S=await this.L(this.h),L=await this.s.getInstalled();this.k=this.w(d,L),this.l=this.w(S,L)}w(d,S){const L=new Map;d.forEach(s=>L.set(s.extensionId.toLowerCase(),s));const{installed:n,uninstalled:r}=this.J([...L.keys()],S);for(const s of n){const o=L.get(s);o&&this.r.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:s,exeName:o.exeName})}for(const s of r){const o=L.get(s);o&&this.r.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:s,exeName:o.exeName})}const t=this.H(),i=new Map;for(const s of r){const o=L.get(s);if(o&&(!t[o.exeName]||!t[o.exeName].includes(o.extensionId))){let c=i.get(o.exeName);c||(c=[],i.set(o.exeName,c)),c.push(o)}}return i}z(){if(this.k.size===0)return;const[d,S]=[...this.k.entries()][0];this.D(S).then(L=>{switch(L){case"reacted":this.I(S[0].exeName,S);break;case"ignored":this.k.delete(d);break;case"incompatibleWindow":{const n=v.Event.once(v.Event.latch(v.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(n(()=>this.z()));break}case"toomany":{const n=this.B((0,I.disposableTimeout)(()=>{n.dispose(),this.z()},36e5));break}}})}C(){if(this.l.size===0)return;const d=this.F(),S=Date.now()-d,L=7*24*60*60*1e3;if(S<L){const t=this.B((0,I.disposableTimeout)(()=>{t.dispose(),this.C()},L-S));return}const[n,r]=[...this.l.entries()][0];this.D(r).then(t=>{switch(t){case"reacted":{this.G(Date.now()),this.l.delete(n),this.I(r[0].exeName,r);const i=this.B((0,I.disposableTimeout)(()=>{i.dispose(),this.C()},L));break}case"ignored":this.l.delete(n),this.C();break;case"incompatibleWindow":{const i=v.Event.once(v.Event.latch(v.Event.any(this.n.onDidOpenWindow,this.n.onDidFocusWindow)));this.B(i(()=>this.C()));break}case"toomany":{const i=this.B((0,I.disposableTimeout)(()=>{i.dispose(),this.C()},36e5));break}}})}async D(d){const S=await this.s.getInstalled(1),L=d.filter(n=>!n.whenNotInstalled||n.whenNotInstalled.every(r=>S.every(t=>!(0,g.areSameExtensions)(t.identifier,{id:r})))).map(({extensionId:n})=>n.toLowerCase());return this.u.promptImportantExtensionsInstallNotification({extensions:L,source:3,name:d[0].exeFriendlyName,searchValue:`@exe:"${d[0].exeName}"`})}F(){let d=this.t.getNumber(a,-1);return d||(d=Date.now(),this.G(d)),d}G(d){this.t.store(a,d,-1,1)}H(){return JSON.parse(this.t.get(E,-1,"{}"))}I(d,S){const L=this.H();L[d]=S.map(({extensionId:n})=>n.toLowerCase()),this.t.store(E,JSON.stringify(L),-1,0)}J(d,S){const L=[],n=[],r=S.reduce((t,i)=>(t.add(i.identifier.id.toLowerCase()),t),new Set);return d.forEach(t=>{r.has(t.toLowerCase())?L.push(t):n.push(t)}),{installed:L,uninstalled:n}}async L(d){const S=[],L=new Map;for(const n of d.keys()){const r=d.get(n);if(!r||!(0,A.isNonEmptyArray)(r.recommendations))continue;const t=[];b.isWindows?r.windowsPath&&t.push(r.windowsPath.replace("%USERPROFILE%",()=>m.env.USERPROFILE).replace("%ProgramFiles(x86)%",()=>m.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",()=>m.env.ProgramFiles).replace("%APPDATA%",()=>m.env.APPDATA).replace("%WINDIR%",()=>m.env.WINDIR)):(t.push((0,R.join)("/usr/local/bin",n)),t.push((0,R.join)("/usr/bin",n)),t.push((0,R.join)(this.m.fsPath,n)));for(const i of t){let s=L.get(i);if(s===void 0&&(s=await this.b.exists(O.URI.file(i)),L.set(i,s)),s)for(const{extensionId:o,extensionName:c,isExtensionPack:y,whenNotInstalled:w}of r.recommendations)S.push({extensionId:o,extensionName:c,isExtensionPack:y,exeName:n,exeFriendlyName:r.exeFriendlyName,windowsPath:r.windowsPath,whenNotInstalled:w})}}return S}}e.AbstractNativeExtensionTipsService=h}),define(oe[228],ae([0,1,26,33]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function l(O,T,k,I,v){try{const R=await O.getExtensionsControlManifest();if(!R.deprecated)return;const b=await O.getInstalled(1);for(const[m,g]of Object.entries(R.deprecated)){if(!g?.extension)continue;const{id:p,autoMigrate:E,preRelease:a}=g.extension;if(!E)continue;const h=b.find(d=>(0,N.areSameExtensions)(d.identifier,{id:m}));if(!h)continue;const u=(await T.getExtensions([{id:p,preRelease:a}],{targetPlatform:await O.getTargetPlatform(),compatible:!0},A.CancellationToken.None))[0];if(!u){v.info(`Skipping migrating '${h.identifier.id}' extension because, the comaptible target '${p}' extension is not found`);continue}try{v.info(`Migrating '${h.identifier.id}' extension to '${p}' extension...`);const d=!I.getDisabledExtensions().some(L=>(0,N.areSameExtensions)(L,h.identifier));await O.uninstall(h),v.info(`Uninstalled the unsupported extension '${h.identifier.id}'`);let S=b.find(L=>(0,N.areSameExtensions)(L.identifier,{id:p}));(!S||!S.isPreReleaseVersion&&d)&&(S=await O.installFromGallery(u,{installPreReleaseVersion:!0,isMachineScoped:h.isMachineScoped,operation:4}),v.info(`Installed the pre-release extension '${S.identifier.id}'`),d||(await I.disableExtension(S.identifier),v.info(`Disabled the pre-release extension '${S.identifier.id}' because the unsupported extension '${h.identifier.id}' is disabled`)),E.storage&&(k.addToMigrationList((0,N.getExtensionId)(h.manifest.publisher,h.manifest.name),(0,N.getExtensionId)(S.manifest.publisher,S.manifest.name)),v.info("Added pre-release extension to the storage migration list"))),v.info(`Migrated '${h.identifier.id}' extension to '${p}' extension.`)}catch(d){v.error(d)}}}catch(R){v.error(R)}}e.migrateUnsupportedExtensions=l}),define(oe[229],ae([0,1,3,2,37,33,50]),function(ie,e,A,N,l,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class k extends N.Disposable{constructor(v,R,b,m,g,p,E){super(),this.f=v,this.g=R,this.h=b,this.i=m,this.j=g,this.k=p,this.l=E,this.a=this.B(new A.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new N.DisposableMap),this.m().then(null,a=>E.error(a))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(v=>this.p(v.added,v.removed))),this.B(this.i.onAddExtensions(v=>this.r(v))),this.B(this.i.onDidAddExtensions(v=>this.s(v))),this.B(this.i.onRemoveExtensions(v=>this.t(v))),this.B(this.i.onDidRemoveExtensions(v=>this.u(v))),this.B(this.k.onDidFilesChange(v=>this.v(v)))}async p(v,R){try{await Promise.all(R.map(b=>(this.c.deleteAndDispose(b.id),this.z(b.extensionsResource)))),v.length&&await Promise.all(v.map(b=>(this.c.set(b.id,(0,N.combinedDisposable)(this.k.watch(this.j.extUri.dirname(b.extensionsResource)),this.k.watch(b.extensionsResource))),this.y(b.extensionsResource))))}catch(b){throw this.l.error(b),b}}async r(v){for(const R of v.extensions)this.D(this.G(R.identifier,R.version),v.profileLocation)}async s(v){for(const R of v.extensions){const b=this.G(R.identifier,R.version);v.error?this.F(b,v.profileLocation):this.D(b,v.profileLocation)}}async t(v){for(const R of v.extensions)this.F(this.G(R.identifier,R.version),v.profileLocation)}async u(v){const R=[],b=[];for(const m of v.extensions){const g=this.G(m.identifier,m.version);v.error?this.D(g,v.profileLocation):(this.F(g,v.profileLocation),this.b.has(g)||(this.l.debug("Extension is removed from all profiles",m.identifier.id,m.version),b.push(this.f.scanInstalledExtensionAtLocation(m.location).then(p=>{p?R.push(p):this.l.info("Extension not found at the location",m.location.toString())},p=>this.l.error(p)))))}try{await Promise.all(b),R.length&&await this.C(R)}catch(m){this.l.error(m)}}v(v){for(const R of this.h.profiles)v.contains(R.extensionsResource,0,1)&&this.w(R.extensionsResource)}async w(v){const R=[],b=[],m=await this.i.scanProfileExtensions(v),g=new Set,p=new Set;for(const[E,a]of this.b)a.has(v)&&p.add(E);for(const E of m){const a=this.G(E.identifier,E.version);g.add(a),p.has(a)||(R.push(E.identifier),this.D(a,v))}for(const E of p)if(!g.has(E)){const a=this.H(E);a&&(b.push(a.identifier),this.F(E,v))}(R.length||b.length)&&this.a.fire({added:R.length?{extensions:R,profileLocation:v}:void 0,removed:b.length?{extensions:b,profileLocation:v}:void 0})}async y(v){const R=await this.i.scanProfileExtensions(v);for(const b of R)this.D(this.G(b.identifier,b.version),v)}async z(v){for(const R of[...this.b.keys()])this.F(R,v);await this.C()}async C(v){v||(v=(await this.f.scanAllUserInstalledExtensions()).filter(b=>!this.b.has(this.G(b.identifier,b.manifest.version)))),v.length&&await this.f.markAsUninstalled(...v)}D(v,R){let b=this.b.get(v);b||this.b.set(v,b=new l.ResourceSet(m=>this.j.extUri.getComparisonKey(m))),b.add(R)}F(v,R){const b=this.b.get(v);b&&b.delete(R),b?.size||this.b.delete(v)}G(v,R){return`${T.ExtensionIdentifier.toKey(v.id)}@${R}`}H(v){const[R,b]=(0,O.getIdAndVersion)(v);return b?{identifier:{id:R},version:b}:void 0}}e.ExtensionsWatcher=k}),define(oe[230],ae([0,1,44,46]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function l(O,T,k,I,v,R,b){const m={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${T.nameShort})`};if((0,N.supportsTelemetry)(T,k)&&(0,N.getTelemetryLevel)(I)===3){const g=await(0,A.getServiceMachineId)(k,v,R);m["X-Market-User-Id"]=g,m["VSCode-SessionId"]=b.machineId||g}return m}e.resolveMarketplaceHeaders=l}),define(oe[231],ae([0,1,71,21,6,2,24,14,28,15,29,33,10,74,12]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let E=e.NativeLanguagePackService=class extends g.LanguagePackBaseService{constructor(d,S,L,n){super(L),this.h=d,this.i=n,this.g=this.B(new a(S,n)),this.h.registerParticipant({postInstall:async r=>this.j(r),postUninstall:async r=>this.k(r)})}async getBuiltInExtensionTranslationsUri(d,S){const n=(await this.g.getLanguagePacks())[S];if(!n){this.i.warn(`No language pack found for ${S}`);return}const r=n.translations[d];return r?p.URI.file(r):void 0}async getInstalledLanguages(){const d=await this.g.getLanguagePacks(),S=Object.keys(d).map(L=>{const n=d[L];return{...this.f(L,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return S.push(this.f("en","English")),S.sort((L,n)=>L.label.localeCompare(n.label)),S}async j(d){d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",d.identifier.id),await this.update())}async k(d){const S=await this.g.getLanguagePacks();Object.keys(S).some(L=>S[L]&&S[L].extensions.some(n=>(0,b.areSameExtensions)(n.extensionIdentifier,d.identifier)))&&(this.i.info("Removing language packs from the extension",d.identifier.id),await this.update())}async update(){const[d,S]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),L=await this.g.update(S);return!(0,N.equals)(Object.keys(d),Object.keys(L))}};e.NativeLanguagePackService=E=ve([J(0,R.IExtensionManagementService),J(1,v.INativeEnvironmentService),J(2,R.IExtensionGalleryService),J(3,m.ILogService)],E);let a=class extends O.Disposable{constructor(d,S){super(),this.i=S,this.c={},this.f=(0,k.join)(d.userDataPath,"languagepacks.json"),this.g=new l.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(d){return this.m(S=>{Object.keys(S).forEach(L=>delete S[L]),this.j(S,...d)}).then(()=>this.c)}j(d,...S){for(const L of S)L&&L.manifest&&L.manifest.contributes&&L.manifest.contributes.localizations&&L.manifest.contributes.localizations.length&&this.k(d,L);Object.keys(d).forEach(L=>this.l(d[L]))}k(d,S){const L=S.identifier,n=S.manifest.contributes&&S.manifest.contributes.localizations?S.manifest.contributes.localizations:[];for(const r of n)if(S.location.scheme===T.Schemas.file&&h(r)){let t=d[r.languageId];t||(t={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},d[r.languageId]=t);const i=t.extensions.filter(s=>(0,b.areSameExtensions)(s.extensionIdentifier,L))[0];i?i.version=S.manifest.version:t.extensions.push({extensionIdentifier:L,version:S.manifest.version});for(const s of r.translations)t.translations[s.id]=(0,k.join)(S.location.fsPath,s.path)}}l(d){if(d){const S=(0,A.createHash)("md5");for(const L of d.extensions)S.update(L.extensionIdentifier.uuid||L.extensionIdentifier.id).update(L.version);d.hash=S.digest("hex")}}m(d=()=>null){return this.g.queue(()=>{let S=null;return I.Promises.readFile(this.f,"utf8").then(void 0,L=>L.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(L)).then(L=>{try{return JSON.parse(L)}catch{return{}}}).then(L=>(S=d(L),L)).then(L=>{for(const r of Object.keys(L))L[r]||delete L[r];this.c=L,this.h=!0;const n=JSON.stringify(this.c);return this.i.debug("Writing language packs",n),I.Promises.writeFile(this.f,n)}).then(()=>S,L=>this.i.error(L))})}};a=ve([J(0,v.INativeEnvironmentService),J(1,m.ILogService)],a);function h(u){if(typeof u.languageId!="string"||!Array.isArray(u.translations)||u.translations.length===0)return!1;for(const d of u.translations)if(typeof d.id!="string"||typeof d.path!="string")return!1;return!(u.languageName&&typeof u.languageName!="string"||u.localizedLanguageName&&typeof u.localizedLanguageName!="string")}}),define(oe[232],ae([0,1,9,31,46]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const O="https://0.0.0.0/OneCollector/1.0",T="https://0.0.0.0/ping";async function k(v,R,b){const m=await new Promise((h,u)=>{ie(["@microsoft/1ds-core-js"],h,u)}),g=await new Promise((h,u)=>{ie(["@microsoft/1ds-post-js"],h,u)}),p=new m.AppInsightsCore,E=new g.PostChannel,a={instrumentationKey:v,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[E]]};if(b){a.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:b};a.extensionConfig[E.identifier]=h}return p.initialize(a,[]),p.addTelemetryInitializer(h=>{R&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),p}class I{constructor(R,b,m,g,p){this.e=R,this.f=b,this.g=m,this.h=p,this.c=O,this.d=T,this.g||(this.g={}),typeof g=="function"?this.a=g():this.a=g,this.b=null}i(R){if(this.a){if(typeof this.a!="string"){R(this.a);return}this.b||(this.b=k(this.a,this.e,this.h)),this.b.then(b=>{R(b)},b=>{(0,A.onUnexpectedError)(b),console.error(b)})}}log(R,b){if(!this.a)return;b=(0,N.mixin)(b,this.g),b=(0,l.validateTelemetryData)(b);const m=this.f+"/"+R;try{this.i(g=>{g.pluginVersionString=b?.properties.version??"Unknown",g.track({name:m,baseData:{name:m,properties:b?.properties,measurements:b?.measurements}})})}catch{}}flush(){return this.a?new Promise(R=>{this.i(b=>{b.unload(!0,()=>{this.a=void 0,R(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=I}),define(oe[112],ae([0,1,2,171,15,10,25,46]),function(ie,e,A,N,l,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let I=e.TelemetryLogAppender=class extends A.Disposable{constructor(R,b,m,g,p=""){super(),this.b=p;const E=b.getLogger(k.telemetryLogId);if(E)this.a=this.B(E);else{const h=(0,k.isLoggingOnly)(g,m)?" (Not Sent)":"",u=()=>(0,k.supportsTelemetry)(g,m)&&R.getLevel()===O.LogLevel.Trace;this.a=this.B(b.createLogger(k.telemetryLogId,{name:(0,N.localize)(0,null,h),hidden:!u()})),this.B(R.onDidChangeLogLevel(()=>b.setVisibility(k.telemetryLogId,u()))),this.a.info("Below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.a.info("===========================================================")}}flush(){return Promise.resolve(void 0)}log(R,b){this.a.trace(`${this.b}telemetry/${R}`,(0,k.validateTelemetryData)(b))}};e.TelemetryLogAppender=I=ve([J(0,O.ILogService),J(1,O.ILoggerService),J(2,l.IEnvironmentService),J(3,T.IProductService)],I)}),define(oe[113],ae([0,1,2,31,4,27,172,17,45,106,25,39,20,46]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let p=e.TelemetryService=class{constructor(h,u,d){this.k=u,this.l=d,this.d={},this.i=new A.DisposableStore,this.j=[],this.b=h.appenders,this.c=h.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const S of this.f)this.j.push(new RegExp((0,O.escapeRegExpCharacters)(S),"gi")),S.indexOf("\\")>=0&&this.j.push(new RegExp((0,O.escapeRegExpCharacters)(S.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(S=>{(S.affectsConfiguration(m.TELEMETRY_SETTING_ID)||S.affectsConfiguration(m.TELEMETRY_OLD_SETTING_ID)||S.affectsConfiguration(m.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(h,u){this.d[h]=u}m(){let h=(0,g.getTelemetryLevel)(this.k);const u=this.l.enabledTelemetryLevels;if(u){this.h=this.sendErrorTelemetry?u.error:!1;const d=u.usage?3:u.error?2:0;h=Math.min(h,d)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(h,u,d){this.g<u||(d=(0,N.mixin)(d,this.d),d=(0,g.cleanData)(d,this.j),d=(0,N.mixin)(d,this.c),this.b.forEach(S=>S.log(h,d)))}publicLog(h,u){this.n(h,3,u)}publicLog2(h,u){this.publicLog(h,u)}publicLogError(h,u){this.h&&this.n(h,2,u)}publicLogError2(h,u){this.publicLogError(h,u)}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",e.TelemetryService=p=ve([J(1,k.IConfigurationService),J(2,R.IProductService)],p);function E(){const a=(0,T.localize)(0,null,v.default.nameLong),h=v.default.privacyStatementUrl?(0,T.localize)(2,null,"https://aka.ms/vscode-telemetry",v.default.privacyStatementUrl):(0,T.localize)(1,null,"https://aka.ms/vscode-telemetry"),u=l.isWeb?"":(0,T.localize)(3,null),d=(0,T.localize)(4,null),S=(0,T.localize)(5,null),L=(0,T.localize)(6,null),n=(0,T.localize)(7,null),r=`
|       | ${d} | ${S} | ${L} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,t=(0,T.localize)(8,null);return`
${a} ${h} ${u}

&nbsp;

${n}
${r}

&nbsp;

${t}
`}b.Registry.as(I.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,T.localize)(9,null),properties:{[m.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,T.localize)(10,null),(0,T.localize)(11,null),(0,T.localize)(12,null),(0,T.localize)(13,null)],markdownDescription:E(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.Registry.as(I.Extensions.Configuration).registerConfiguration({id:m.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,T.localize)(14,null),properties:{[m.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:v.default.privacyStatementUrl?(0,T.localize)(16,null,v.default.nameLong,v.default.privacyStatementUrl):(0,T.localize)(15,null,v.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,T.localize)(17,null,`\`#${m.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(oe[233],ae([0,1,287,232]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class l extends N.AbstractOneDataSystemAppender{constructor(T,k,I,v){const R={sendPOST:(b,m)=>{const g={method:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data)}};try{const p=A.request(b.urlString,g,E=>{E.on("data",function(a){m(E.statusCode??200,E.headers,a.toString())}),E.on("error",function(a){m(0,{})})});p.write(b.data),p.end()}catch{m(0,{})}}};super(T,k,I,v,R)}}e.OneDataSystemAppender=l}),define(oe[234],ae([0,1,24,66,17,15,10,25,20,111,112,113]),function(ie,e,A,N,l,O,T,k,I,v,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let m=e.CustomEndpointTelemetryService=class{constructor(p,E,a,h,u,d){this.b=p,this.c=E,this.d=a,this.e=h,this.f=u,this.g=d,this.a=new Map}h(p){if(!this.a.has(p.id)){const E=Object.create(null);E["common.vscodemachineid"]=this.c.machineId,E["common.vscodesessionid"]=this.c.sessionId;const a=[p.id,JSON.stringify(E),p.aiKey],u=new N.Client(A.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:a,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),d=[new v.TelemetryAppenderClient(u),new R.TelemetryLogAppender(this.d,this.e,this.f,this.g,`[${p.id}] `)];this.a.set(p.id,new b.TelemetryService({appenders:d,sendErrorTelemetry:p.sendErrorTelemetry},this.b,this.g))}return this.a.get(p.id)}publicLog(p,E,a){this.h(p).publicLog(E,a)}publicLogError(p,E,a){this.h(p).publicLogError(E,a)}};e.CustomEndpointTelemetryService=m=ve([J(0,l.IConfigurationService),J(1,I.ITelemetryService),J(2,T.ILogService),J(3,T.ILoggerService),J(4,O.IEnvironmentService),J(5,k.IProductService)],m)}),define(oe[114],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var A;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(A||(e.EnvironmentVariableMutatorType=A={}))}),define(oe[235],ae([0,1,4,114]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class l{constructor(v){this.collections=v,this.a=new Map,this.b=new Map,v.forEach((R,b)=>{this.c(R,b);const m=R.map.entries();let g=m.next();for(;!g.done;){const p=g.value[1],E=g.value[0];let a=this.a.get(E);if(a||(a=[],this.a.set(E,a)),a.length>0&&a[0].type===N.EnvironmentVariableMutatorType.Replace){g=m.next();continue}const h={extensionIdentifier:b,value:p.value,type:p.type,scope:p.scope,variable:p.variable};h.scope||delete h.scope,a.unshift(h),g=m.next()}})}async applyToProcessEnvironment(v,R,b){let m;A.isWindows&&(m={},Object.keys(v).forEach(g=>m[g.toLowerCase()]=g));for(const[g,p]of this.getVariableMap(R)){const E=A.isWindows&&m[g.toLowerCase()]||g;for(const a of p){const h=b?await b(a.value):a.value;switch(a.type){case N.EnvironmentVariableMutatorType.Append:v[E]=(v[E]||"")+h;break;case N.EnvironmentVariableMutatorType.Prepend:v[E]=h+(v[E]||"");break;case N.EnvironmentVariableMutatorType.Replace:v[E]=h;break}}}}diff(v,R){const b=new Map,m=new Map,g=new Map;if(v.getVariableMap(R).forEach((p,E)=>{const a=this.getVariableMap(R).get(E),h=T(p,a);h&&b.set(E,h)}),this.getVariableMap(R).forEach((p,E)=>{const a=v.getVariableMap(R).get(E),h=T(p,a);h&&g.set(E,h)}),this.getVariableMap(R).forEach((p,E)=>{const a=v.getVariableMap(R).get(E),h=k(p,a);h&&m.set(E,h)}),!(b.size===0&&m.size===0&&g.size===0))return{added:b,changed:m,removed:g}}getVariableMap(v){const R=new Map;return this.a.forEach((b,m)=>{const g=b.filter(p=>O(p,v));g.length>0&&R.set(g[0].variable,g)}),R}getDescriptionMap(v){const R=new Map;return this.b.forEach((b,m)=>{const g=b.filter(p=>O(p,v));g.length>0&&R.set(g[0].extensionIdentifier,g[0].description)}),R}c(v,R){if(!v.descriptionMap)return;const b=v.descriptionMap.entries();let m=b.next();for(;!m.done;){const g=m.value[1],p=m.value[0];let E=this.b.get(p);E||(E=[],this.b.set(p,E));const a={extensionIdentifier:R,scope:g.scope,description:g.description};a.scope||delete a.scope,E.push(a),m=b.next()}}}e.MergedEnvironmentVariableCollection=l;function O(I,v){return!!(!I.scope||I.scope.workspaceFolder&&v?.workspaceFolder&&I.scope.workspaceFolder.index===v.workspaceFolder.index)}function T(I,v){if(!v)return I;const R=new Set;v.forEach(m=>R.add(m.extensionIdentifier));const b=[];return I.forEach(m=>{R.has(m.extensionIdentifier)||b.push(m)}),b.length===0?void 0:b}function k(I,v){if(!v)return;const R=new Map;v.forEach(m=>R.set(m.extensionIdentifier,m));const b=[];return I.forEach(m=>{const g=R.get(m.extensionIdentifier);g&&(m.type!==g.type||m.value!==g.value||m.scope?.workspaceFolder?.index!==g.scope?.workspaceFolder?.index)&&b.push(g)}),b.length===0?void 0:b}}),define(oe[236],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function A(I){return[...I.entries()]}e.serializeEnvironmentVariableCollection=A;function N(I){return I?[...I.entries()]:[]}e.serializeEnvironmentDescriptionMap=N;function l(I){return new Map(I)}e.deserializeEnvironmentVariableCollection=l;function O(I){return new Map(I??[])}e.deserializeEnvironmentDescriptionMap=O;function T(I){return Array.from(I.entries()).map(v=>[v[0],A(v[1].map),N(v[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=T;function k(I){return new Map(I.map(v=>[v[0],{map:l(v[1]),descriptionMap:O(v[2])}]))}e.deserializeEnvironmentVariableCollections=k}),define(oe[237],ae([0,1,6,26,3,2,10]),function(ie,e,A,N,l,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let k=e.RequestStore=class extends O.Disposable{constructor(v,R){super(),this.h=R,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new l.Emitter),this.onCreateRequest=this.g.event,this.b=v===void 0?15e3:v}createRequest(v){return new Promise((R,b)=>{const m=++this.a;this.c.set(m,R),this.g.fire({requestId:m,...v});const g=new N.CancellationTokenSource;(0,A.timeout)(this.b,g.token).then(()=>b(`Request ${m} timed out (${this.b}ms)`)),this.f.set(m,[(0,O.toDisposable)(()=>g.cancel())])})}acceptReply(v,R){const b=this.c.get(v);b?(this.c.delete(v),(0,O.dispose)(this.f.get(v)||[]),this.f.delete(v),b(R)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${v}`)}};e.RequestStore=k=ve([J(1,T.ILogService)],k)}),define(oe[115],ae([0,1,5,70]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalSettingId=e.TerminalSettingPrefix=e.terminalTabFocusContextKey=void 0,e.terminalTabFocusContextKey=new N.RawContextKey("terminalTabFocusMode",!1,!0);var l;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(l||(e.TerminalSettingPrefix=l={}));var O;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.AutomationProfileLinux="terminal.integrated.automationProfile.linux",d.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",d.AutomationProfileWindows="terminal.integrated.automationProfile.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsDefaultColor="terminal.integrated.tabs.defaultColor",d.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsShowActions="terminal.integrated.tabs.showActions",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.TabStopWidth="terminal.integrated.tabStopWidth",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.DefaultLocation="terminal.integrated.defaultLocation",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.TerminalTitleSeparator="terminal.integrated.tabs.separator",d.TerminalTitle="terminal.integrated.tabs.title",d.TerminalDescription="terminal.integrated.tabs.description",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.ConfirmOnKill="terminal.integrated.confirmOnKill",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.TabFocusMode="terminal.integrated.tabFocusMode",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoEnabled="terminal.integrated.localEchoEnabled",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",d.CustomGlyphs="terminal.integrated.customGlyphs",d.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",d.InheritEnv="terminal.integrated.inheritEnv",d.ShowLinkHover="terminal.integrated.showLinkHover",d.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",d.AutoReplies="terminal.integrated.autoReplies",d.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",d.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",d.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",d.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",d.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",d.SmoothScrolling="terminal.integrated.smoothScrolling"})(O||(e.TerminalSettingId=O={}));var T;(function(d){d.PowerShell="pwsh",d.Bash="bash",d.Fish="fish",d.Sh="sh",d.Csh="csh",d.Ksh="ksh",d.Zsh="zsh"})(T||(e.PosixShellType=T={}));var k;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(k||(e.WindowsShellType=k={}));var I;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence",d[d.Config=3]="Config"})(I||(e.TitleEventSource=I={}));var v;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Logger="logger",d.Heartbeat="heartbeat"})(v||(e.TerminalIpcChannels=v={})),e.IPtyService=(0,A.createDecorator)("ptyService");var R;(function(d){d.Cwd="cwd",d.InitialCwd="initialCwd",d.FixedDimensions="fixedDimensions",d.Title="title",d.ShellType="shellType",d.HasChildProcesses="hasChildProcesses",d.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",d.OverrideDimensions="overrideDimensions",d.FailedShellIntegrationActivation="failedShellIntegrationActivation",d.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(R||(e.ProcessPropertyType=R={}));var b;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(b||(e.HeartbeatConstants=b={}));var m;(function(d){d[d.Panel=1]="Panel",d[d.Editor=2]="Editor"})(m||(e.TerminalLocation=m={}));var g;(function(d){d.TerminalView="view",d.Editor="editor"})(g||(e.TerminalLocationString=g={}));var p;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(p||(e.LocalReconnectConstants=p={}));var E;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(E||(e.FlowControlConstants=E={}));var a;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(a||(e.ProfileSource=a={}));var h;(function(d){d[d.Off=0]="Off",d[d.FinalTerm=1]="FinalTerm",d[d.VSCode=2]="VSCode"})(h||(e.ShellIntegrationStatus=h={}));var u;(function(d){d[d.Unknown=0]="Unknown",d[d.Shutdown=1]="Shutdown",d[d.Process=2]="Process",d[d.User=3]="User",d[d.Extension=4]="Extension"})(u||(e.TerminalExitReason=u={}))}),define(oe[238],ae([0,1,52,12,174,132]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function T(m,g){const p=[{name:null,description:(0,l.localize)(0,null)}];return p.push(...m.map(E=>({name:E.profileName,description:k(E)}))),g&&p.push(...g.map(E=>({name:E.title,description:I(E)}))),{values:p.map(E=>E.name),markdownDescriptions:p.map(E=>E.description)}}e.createProfileSchemaEnums=T;function k(m){let g=`$(${O.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:A.Codicon.terminal.id}) ${m.profileName}
- path: ${m.path}`;return m.args&&(typeof m.args=="string"?g+=`
- args: "${m.args}"`:g+=`
- args: [${m.args.length===0?"":`'${m.args.join("','")}'`}]`),m.overrideName!==void 0&&(g+=`
- overrideName: ${m.overrideName}`),m.color&&(g+=`
- color: ${m.color}`),m.env&&(g+=`
- env: ${JSON.stringify(m.env)}`),g}function I(m){return`$(${O.ThemeIcon.isThemeIcon(m.icon)?m.icon.id:m.icon?m.icon:A.Codicon.terminal.id}) ${m.title}
- extensionIdentifier: ${m.extensionIdentifier}`}function v(m,g){if(!m&&!g)return!0;if(typeof m=="string"&&typeof g=="string")return m===g;if(Array.isArray(m)&&Array.isArray(g)){if(m.length!==g.length)return!1;for(let p=0;p<m.length;p++)if(m[p]!==g[p])return!1;return!0}return!1}e.terminalProfileArgsMatch=v;function R(m,g){if(!m&&!g)return!0;if(!m||!g)return!1;if(O.ThemeIcon.isThemeIcon(m)&&O.ThemeIcon.isThemeIcon(g))return m.id===g.id&&m.color===g.color;if(typeof m=="object"&&"light"in m&&"dark"in m&&typeof g=="object"&&"light"in g&&"dark"in g){const p=m,E=g;if((N.URI.isUri(p.light)||b(p.light))&&(N.URI.isUri(p.dark)||b(p.dark))&&(N.URI.isUri(E.light)||b(E.light))&&(N.URI.isUri(E.dark)||b(E.dark)))return p.light.path===E.light.path&&p.dark.path===E.dark.path}if(N.URI.isUri(m)&&N.URI.isUri(g)||b(m)||b(g)){const p=m,E=g;return p.path===E.path&&p.scheme===E.scheme}return!1}e.terminalIconsEqual=R;function b(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}e.isUriComponents=b}),define(oe[239],ae([0,1,52,173,45,39,238]),function(ie,e,A,N,l,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,A.getAllCodicons)(),S=>S.id),markdownEnumDescriptions:Array.from((0,A.getAllCodicons)(),S=>`$(${S.id})`)};const k={args:{description:(0,N.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,N.localize)(1,null),type:"boolean"},icon:{description:(0,N.localize)(2,null),...e.terminalIconSchema},color:{description:(0,N.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,N.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},I={type:"object",required:["path"],properties:{path:{description:(0,N.localize)(5,null),type:["string","array"],items:{type:"string"}},...k}},v={type:"object",required:["path"],properties:{path:{description:(0,N.localize)(6,null),type:["string"],items:{type:"string"}},...k}},R=(0,N.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),b=(0,N.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),m=(0,N.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),g=(0,N.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),p=(0,N.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),E=(0,N.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),a={id:"terminal",order:100,title:(0,N.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,N.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:g},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,N.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,N.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,N.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,N.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,N.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},v],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,N.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:R},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,N.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:b},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,N.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,N.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:R},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,N.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:b},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,N.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,N.localize)(26,null)}},{type:"string",markdownDescription:(0,N.localize)(27,null)}],default:[],markdownDeprecationMessage:m},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,N.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,N.localize)(29,null),enum:["PowerShell","Git Bash"]},...k}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,N.localize)(30,null),type:"string"},id:{description:(0,N.localize)(31,null),type:"string"},title:{description:(0,N.localize)(32,null),type:"string"},...k}},{type:"null"},I]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,N.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,N.localize)(34,null),type:"string"},id:{description:(0,N.localize)(35,null),type:"string"},title:{description:(0,N.localize)(36,null),type:"string"},...k}},{type:"null"},I]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,N.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,N.localize)(38,null),type:"string"},id:{description:(0,N.localize)(39,null),type:"string"},title:{description:(0,N.localize)(40,null),type:"string"},...k}},{type:"null"},I]}},["terminal.integrated.useWslProfiles"]:{description:(0,N.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,N.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,N.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,N.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,N.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){O.Registry.as(l.Extensions.Configuration).registerConfiguration(a),d()}e.registerTerminalPlatformConfiguration=h;let u;function d(S,L){const n=O.Registry.as(l.Extensions.Configuration);let r;S&&(r=(0,T.createProfileSchemaEnums)(S?.profiles,L));const t=u;u={id:"terminal",order:100,title:(0,N.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,N.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:S?.os===3?r?.values:void 0,markdownEnumDescriptions:S?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,N.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:S?.os===2?r?.values:void 0,markdownEnumDescriptions:S?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,N.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:S?.os===1?r?.values:void 0,markdownEnumDescriptions:S?.os===1?r?.markdownDescriptions:void 0}}},n.updateConfigurations({add:[u],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=d}),define(oe[240],ae([0,1,5]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,A.createDecorator)("localPtyService")}),define(oe[241],ae([0,1,34,24,31,14,4,36,27,11,28,114,236,235]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function p(){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(A.release());let s=0;return i&&i.length===4&&(s=parseInt(i[3])),s}e.getWindowsBuildNumber=p;async function E(i,s,o,c=k.env,y=R.Promises.exists){if(O.isAbsolute(i))return await y(i)?i:void 0;if(s===void 0&&(s=k.cwd()),O.dirname(i)!=="."){const D=O.join(s,i);return await y(D)?D:void 0}const f=(0,l.getCaseInsensitive)(c,"PATH");if(o===void 0&&(0,v.isString)(f)&&(o=f.split(O.delimiter)),o===void 0||o.length===0){const D=O.join(s,i);return await y(D)?D:void 0}for(const D of o){let M;if(O.isAbsolute(D)?M=O.join(D,i):M=O.join(s,D,i),await y(M))return M;if(T.isWindows){let j=M+".com";if(await y(j)||(j=M+".exe",await y(j)))return j}}const P=O.join(s,i);return await y(P)?P:void 0}e.findExecutable=E;function a(i,s,o,c,y){const w=T.isWindows&&(!s.windowsEnableConpty||p()<18309);if(!s.shellIntegration.enabled||!i.executable||i.isFeatureTerminal||i.hideFromUser||i.ignoreShellIntegration||w)return;const f=i.args,P=k.platform==="win32"?O.basename(i.executable).toLowerCase():O.basename(i.executable),D=O.dirname(N.FileAccess.asFileUri("").fsPath);let M;const j={VSCODE_INJECTION:"1"};if(T.isWindows){if(P==="pwsh.exe"||P==="powershell.exe")return!f||r(f)?M=d.get(u.WindowsPwsh):n(f)&&(M=d.get(u.WindowsPwshLogin)),M?(M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],D,""),s.shellIntegration.suggestEnabled&&(j.VSCODE_SUGGEST="1"),{newArgs:M,envMixin:j}):void 0;c.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args);return}switch(P){case"bash":return!f||f.length===0?M=d.get(u.Bash):t(f)&&(j.VSCODE_SHELL_LOGIN="1",h(s,j),M=d.get(u.Bash)),M?(M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],D),{newArgs:M,envMixin:j}):void 0;case"fish":{const B=o?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",W=O.join(D,"out/vs/workbench/contrib/xdg_data");return j.XDG_DATA_DIRS=`${B}:${W}`,h(s,j),{newArgs:void 0,envMixin:j}}case"pwsh":return!f||r(f)?M=d.get(u.Pwsh):n(f)&&(M=d.get(u.PwshLogin)),M?(s.shellIntegration.suggestEnabled&&(j.VSCODE_SUGGEST="1"),M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],D,""),{newArgs:M,envMixin:j}):void 0;case"zsh":{if(!f||f.length===0?M=d.get(u.Zsh):t(f)?(M=d.get(u.ZshLogin),h(s,j)):(f===d.get(u.Zsh)||f===d.get(u.ZshLogin))&&(M=f),!M)return;M=[...M],M[M.length-1]=(0,I.format)(M[M.length-1],D);let B;try{B=A.userInfo().username}catch{B="unknown"}const W=O.join(A.tmpdir(),`${B}-${y.applicationName}-zsh`);j.ZDOTDIR=W;const H=o?.ZDOTDIR??A.homedir()??"~";j.USER_ZDOTDIR=H;const Q=[];return Q.push({source:O.join(D,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:O.join(W,".zshrc")}),Q.push({source:O.join(D,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:O.join(W,".zprofile")}),Q.push({source:O.join(D,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:O.join(W,".zshenv")}),Q.push({source:O.join(D,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:O.join(W,".zlogin")}),{newArgs:M,envMixin:j,filesToCopy:Q}}}c.warn(`Shell integration cannot be enabled for executable "${i.executable}" and args`,i.args)}e.getShellIntegrationInjection=a;function h(i,s){if(T.isMacintosh&&i.environmentVariableCollections){const o=(0,m.deserializeEnvironmentVariableCollections)(i.environmentVariableCollections),y=new g.MergedEnvironmentVariableCollection(o).getVariableMap({workspaceFolder:i.workspaceFolder}).get("PATH"),w=[];if(y)for(const f of y)f.type===b.EnvironmentVariableMutatorType.Prepend&&w.push(f.value);w.length>0&&(s.VSCODE_PATH_PREFIX=w.join(""))}}var u;(function(i){i.WindowsPwsh="windows-pwsh",i.WindowsPwshLogin="windows-pwsh-login",i.Pwsh="pwsh",i.PwshLogin="pwsh-login",i.Zsh="zsh",i.ZshLogin="zsh-login",i.Bash="bash"})(u||(u={}));const d=new Map;d.set(u.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(u.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),d.set(u.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),d.set(u.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),d.set(u.Zsh,["-i"]),d.set(u.ZshLogin,["-il"]),d.set(u.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],L=["-nol","-nologo"];function n(i){return typeof i=="string"?S.includes(i.toLowerCase()):i.length===1&&S.includes(i[0].toLowerCase())||i.length===2&&(S.includes(i[0].toLowerCase())||S.includes(i[1].toLowerCase()))&&(L.includes(i[0].toLowerCase())||L.includes(i[1].toLowerCase()))}function r(i){return typeof i=="string"?L.includes(i.toLowerCase()):i.length===0||i?.length===1&&L.includes(i[0].toLowerCase())}function t(i){return i==="string"&&S.includes(i.toLowerCase())||typeof i!="string"&&i.length===1&&S.includes(i[0].toLowerCase())}}),define(oe[242],ae([0,1,49,52,14,4,11,28,94,241,190]),function(ie,e,A,N,l,O,T,k,I,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let b,m=!0;function g(i,s,o,c,y=process.env,w,f,P,D){return w=w||{existsFile:k.SymlinkSupport.existsFile,readFile:k.Promises.readFile},O.isWindows?p(o,w,y,f,c.getValue("terminal.integrated.useWslProfiles")!==!1,i&&typeof i=="object"?{...i}:c.getValue("terminal.integrated.profiles.windows"),typeof s=="string"?s:c.getValue("terminal.integrated.defaultProfile.windows"),D,P):n(w,f,o,i&&typeof i=="object"?{...i}:c.getValue(O.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof s=="string"?s:c.getValue(O.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),D,P,y)}e.detectAvailableProfiles=g;async function p(i,s,o,c,y,w,f,P,D){const M=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),j=`${process.env.windir}\\${M?"Sysnative":"System32"}`;let B=!1;(0,v.getWindowsBuildNumber)()>=16299&&(B=!0),await h(P);const W=new Map;if(i){W.set("PowerShell",{source:"PowerShell",icon:N.Codicon.terminalPowershell,isAutoDetected:!0}),W.set("Windows PowerShell",{path:`${j}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:N.Codicon.terminalPowershell,isAutoDetected:!0}),W.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),W.set("Command Prompt",{path:`${j}\\cmd.exe`,icon:N.Codicon.terminalCmd,isAutoDetected:!0}),W.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),W.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:N.Codicon.terminalBash,isAutoDetected:!0});const Q=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;W.set("Cmder",{path:`${j}\\cmd.exe`,args:["/K",Q],requiresPath:process.env.CMDER_ROOT?Q:{path:Q,isUnsafe:!0},isAutoDetected:!0})}r(w,W);const H=await E(W.entries(),f,s,o,c,D);if(i||y)try{const Q=await S(`${j}\\${B?"wsl":"bash"}.exe`,f);for(const _ of Q)(!w||!(_.profileName in w))&&H.push(_)}catch{m&&(c?.info("WSL is not installed, so could not detect WSL profiles"),m=!1)}return H}async function E(i,s,o,c=process.env,y,w){const f=[];for(const[P,D]of i){if(D===null)continue;let M,j,B;if("source"in D){const _=b?.get(D.source);if(!_)continue;M=_.paths,j=D.args||_.args,D.icon?B=a(D.icon):_.icon&&(B=_.icon)}else M=Array.isArray(D.path)?D.path:[D.path],j=O.isWindows||Array.isArray(D.args)?D.args:void 0,B=a(D.icon);let W;if(w){const _=M.map($=>typeof $=="string"?$:$.path),Y=await w(_);W=new Array(M.length);for(let $=0;$<M.length;$++)typeof M[$]=="string"?W[$]=Y[$]:W[$]={path:Y[$],isUnsafe:!0}}else W=M.slice();let H;if(D.requiresPath){let _;if((0,T.isString)(D.requiresPath)?_=D.requiresPath:(_=D.requiresPath.path,D.requiresPath.isUnsafe&&(H=_)),!await o.existsFile(_))continue}const Q=await t(P,s,W,o,c,j,D.env,D.overrideName,D.isAutoDetected,H);Q?(Q.isAutoDetected=D.isAutoDetected,Q.icon=B,Q.color=D.color,f.push(Q)):y?.debug("Terminal profile not validated",P,M)}return y?.debug("Validated terminal profiles",f),f}function a(i){return typeof i=="string"?{id:i}:i}async function h(i){if(b&&!i)return;const[s,o]=await Promise.all([u(),i||d()]);b=new Map,b.set("Git Bash",{profileName:"Git Bash",paths:s,args:["--login","-i"]}),b.set("PowerShell",{profileName:"PowerShell",paths:o,icon:N.Codicon.terminalPowershell})}async function u(){const i=new Set,s=await(0,v.findExecutable)("git.exe");if(s){const y=(0,R.dirname)(s);i.add((0,R.resolve)(y,"../.."))}function o(y,w){w&&y.add(w)}o(i,process.env.ProgramW6432),o(i,process.env.ProgramFiles),o(i,process.env["ProgramFiles(X86)"]),o(i,`${process.env.LocalAppData}\\Program`);const c=[];for(const y of i)c.push(`${y}\\Git\\bin\\bash.exe`,`${y}\\Git\\usr\\bin\\bash.exe`,`${y}\\usr\\bin\\bash.exe`);return c.push(`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`),c}async function d(){const i=[];for await(const s of(0,I.enumeratePowerShellInstallations)())i.push(s.exePath);return i}async function S(i,s){const o=[],c=await new Promise((f,P)=>{A.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(D,M)=>{if(D)return P("Problem occurred when getting wsl distros");f(M)})});if(!c)return[];const y=new RegExp(/[\r?\n]/),w=c.split(y).filter(f=>f.trim().length>0&&f!=="");for(const f of w){if(f===""||f.startsWith("docker-desktop"))continue;const P=`${f} (WSL)`,D={profileName:P,path:i,args:["-d",`${f}`],isDefault:P===s,icon:L(f),isAutoDetected:!1};o.push(D)}return o}function L(i){return i.includes("Ubuntu")?N.Codicon.terminalUbuntu:i.includes("Debian")?N.Codicon.terminalDebian:N.Codicon.terminalLinux}async function n(i,s,o,c,y,w,f,P){const D=new Map;if(o){const M=(await i.readFile("/etc/shells")).toString(),j=w||M.split(`
`).filter(W=>W.trim().includes("#")&&W.trim().length>0),B=new Map;for(const W of j){let H=(0,l.basename)(W),Q=B.get(H)||0;Q++,Q>1&&(H=`${H} (${Q})`),B.set(H,Q),D.set(H,{path:W,isAutoDetected:!0})}}return r(c,D),await E(D.entries(),y,i,P,s,f)}function r(i,s){if(i)for(const[o,c]of Object.entries(i))c===null||typeof c!="object"||!("path"in c)&&!("source"in c)?s.delete(o):(c.icon=c.icon||s.get(o)?.icon,s.set(o,c))}async function t(i,s,o,c,y,w,f,P,D,M){if(o.length===0)return Promise.resolve(void 0);const j=o.shift();if(j==="")return t(i,s,o,c,y,w,f,P,D);const B=typeof j!="string"&&j.isUnsafe,W=typeof j=="string"?j:j.path,H={profileName:i,path:W,args:w,env:f,overrideName:P,isAutoDetected:D,isDefault:i===s,isUnsafePath:B,requiresUnsafePath:M};if((0,l.basename)(W)===W){const _=y.PATH?y.PATH.split(l.delimiter):void 0,Y=await(0,v.findExecutable)(W,void 0,_,void 0,c.existsFile);return Y?(H.path=Y,H.isFromPath=!0,H):t(i,s,o,c,y,w)}return await c.existsFile((0,l.normalize)(W))?H:t(i,s,o,c,y,w,f,P,D)}}),define(oe[243],ae([0,1,3,2,24,4,41,66,17,15,97,224,10,237,115,239,242,105]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var u;(function(L){L[L.MaxRestarts=5]="MaxRestarts"})(u||(u={}));let d=0,S=e.PtyHostService=class extends N.Disposable{constructor(n,r,t,i,s,o){super(),this.C=n,this.D=r,this.F=t,this.G=i,this.H=s,this.I=o,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new A.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new A.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new A.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new A.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new A.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new A.Emitter),this.onProcessData=this.s.event,this.t=this.B(new A.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new A.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new A.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new A.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new A.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new A.Emitter),this.onProcessExit=this.z.event,(0,E.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,N.toDisposable)(()=>this.O())),this.f=this.B(new g.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async c=>{c.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(O.isWindows)return process.env;try{return await(0,b.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(n){return this.H.error("ptyHost was unable to resolve shell environment",n),{}}}N(){const n={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsHome.fsPath],env:{VSCODE_LAST_PTY_ID:d,VSCODE_PTY_REMOTE:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},r=(0,R.parsePtyHostDebugPort)(this.G.args,this.G.isBuilt);r&&(r.break&&r.port?n.debugBrk=r.port:!r.break&&r.port&&(n.debug=r.port));const t=new k.Client(l.FileAccess.asFileUri("bootstrap-fork").fsPath,n);this.m.fire(),T.ProxyChannel.toService(t.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(t.onDidProcessExit(o=>{this.l.fire(o.code),this.i||(this.g<=u.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${o.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${o.code}, giving up`))})),this.B(new h.RemoteLoggerChannelClient(this.I,t.getChannel(p.TerminalIpcChannels.Logger)));const s=T.ProxyChannel.toService(t.getChannel(p.TerminalIpcChannels.PtyHost));return this.B(s.onProcessData(o=>this.s.fire(o))),this.B(s.onProcessReady(o=>this.t.fire(o))),this.B(s.onProcessExit(o=>this.z.fire(o))),this.B(s.onDidChangeProperty(o=>this.y.fire(o))),this.B(s.onProcessReplay(o=>this.u.fire(o))),this.B(s.onProcessOrphanQuestion(o=>this.v.fire(o))),this.B(s.onDidRequestDetach(o=>this.w.fire(o))),[t,s]}dispose(){this.i=!0,super.dispose()}async createProcess(n,r,t,i,s,o,c,y,w,f,P){const D=setTimeout(()=>this.S(),p.HeartbeatConstants.CreateProcessTimeout),M=await this.b.createProcess(n,r,t,i,s,o,c,y,w,f,P);return clearTimeout(D),d=Math.max(d,M),M}updateTitle(n,r,t){return this.b.updateTitle(n,r,t)}updateIcon(n,r,t,i){return this.b.updateIcon(n,r,t,i)}attachToProcess(n){return this.b.attachToProcess(n)}detachFromProcess(n,r){return this.b.detachFromProcess(n,r)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(n){return this.b.start(n)}shutdown(n,r){return this.b.shutdown(n,r)}input(n,r){return this.b.input(n,r)}processBinary(n,r){return this.b.processBinary(n,r)}resize(n,r,t){return this.b.resize(n,r,t)}acknowledgeDataEvent(n,r){return this.b.acknowledgeDataEvent(n,r)}setUnicodeVersion(n,r){return this.b.setUnicodeVersion(n,r)}getInitialCwd(n){return this.b.getInitialCwd(n)}getCwd(n){return this.b.getCwd(n)}getLatency(n){return this.b.getLatency(n)}orphanQuestionReply(n){return this.b.orphanQuestionReply(n)}installAutoReply(n,r){return this.b.installAutoReply(n,r)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(n){return this.b.uninstallAutoReply(n)}getDefaultSystemShell(n){return this.b.getDefaultSystemShell(n)}async getProfiles(n,r,t,i=!1){const s=await this.c;return(0,a.detectAvailableProfiles)(r,t,i,this.F,s,void 0,this.H,this.W.bind(this,n))}getEnvironment(){return this.b.getEnvironment()}getWslPath(n,r){return this.b.getWslPath(n,r)}getRevivedPtyNewId(n){return this.b.getRevivedPtyNewId(n)}setTerminalLayoutInfo(n){return this.b.setTerminalLayoutInfo(n)}async getTerminalLayoutInfo(n){return await this.b.getTerminalLayoutInfo(n)}async requestDetachInstance(n,r){return this.b.requestDetachInstance(n,r)}async acceptDetachInstanceReply(n,r){return this.b.acceptDetachInstanceReply(n,r)}async freePortKillProcess(n){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(n)}async serializeTerminalState(n){return this.b.serializeTerminalState(n)}async reviveTerminalProcesses(n,r){return this.b.reviveTerminalProcesses(n,r)}async refreshProperty(n,r){return this.b.refreshProperty(n,r)}async updateProperty(n,r,t){return this.b.updateProperty(n,r,t)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(n,r){return this.f.createRequest({workspaceId:n,originalText:r})}async acceptPtyHostResolvedVariables(n,r){this.f.acceptReply(n,r)}};e.PtyHostService=S=ve([J(2,I.IConfigurationService),J(3,v.IEnvironmentService),J(4,m.ILogService),J(5,m.ILoggerService)],S)}),define(oe[78],ae([0,1,3,17,5,10]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var T;(function(E){E.Http="http",E.Https="https"})(T||(e.TunnelProtocol=T={}));var k;(function(E){E.ConstantPrivate="constantPrivate",E.Private="private",E.Public="public"})(k||(e.TunnelPrivacyId=k={}));var I;(function(E){E[E.Notify=1]="Notify",E[E.OpenBrowser=2]="OpenBrowser",E[E.OpenPreview=3]="OpenPreview",E[E.Silent=4]="Silent",E[E.Ignore=5]="Ignore",E[E.OpenBrowserOnce=6]="OpenBrowserOnce"})(I||(e.ProvidedOnAutoForward=I={}));function v(E){if(E.scheme!=="http"&&E.scheme!=="https")return;const a=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(E.authority);if(a)return{address:a[1],port:+a[2]}}e.extractLocalHostUriMetaDataForPortMapping=v,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(E){return e.LOCALHOST_ADDRESSES.indexOf(E)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function b(E){return e.ALL_INTERFACES_ADDRESSES.indexOf(E)>=0}e.isAllInterfaces=b;function m(E,a,h,u){if(h===1)return!1;if(h===2&&b(a)){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(d?.length===4&&parseInt(d[1])>=18)return!1}return E<1024}e.isPortPrivileged=m;class g{constructor(a,h,u){this.remoteAddress=a,this.localAddress=h,this.b=u,this.a=new A.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=g;let p=e.AbstractTunnelService=class{constructor(a,h){this.i=a,this.j=h,this.a=new A.Emitter,this.onTunnelOpened=this.a.event,this.b=new A.Emitter,this.onTunnelClosed=this.b.event,this.c=new A.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const a=this.j.getValue("remote.localPortHost");return!a||a==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(a){return this.e=a,a?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(a){this.f=a.elevation,this.g=a.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const a=[],h=Array.from(this.d.values());for(const u of h){const d=Array.from(u.values());for(const S of d){const L=await S.value;L&&a.push(L)}}return a}async dispose(){for(const a of this.d.values()){for(const{value:h}of a.values())await h.then(u=>u?.dispose());a.clear()}this.d.clear()}setEnvironmentTunnel(a,h,u,d,S){this.o(a,h,Promise.resolve({tunnelRemoteHost:a,tunnelRemotePort:h,localAddress:u,privacy:d,protocol:S,dispose:()=>Promise.resolve()}))}async getExistingTunnel(a,h){(b(a)||R(a))&&(a=e.LOCALHOST_ADDRESSES[0]);const u=this.q(a,h);if(u)return++u.refcount,u.value}openTunnel(a,h,u,d,S,L=!1,n,r){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${u} on local port ${S}.`),!a)return;if(h||(h="localhost"),d||(d=this.k),this.e&&this.h.has(u)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const t=this.r(a,h,u,d,S,L,n,r);return t?t.then(i=>{if(!i){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,u);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.m(i);return(i.tunnelRemoteHost!==h||i.tunnelRemotePort!==u)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(s),s}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),t)}m(a){return{tunnelRemotePort:a.tunnelRemotePort,tunnelRemoteHost:a.tunnelRemoteHost,tunnelLocalPort:a.tunnelLocalPort,localAddress:a.localAddress,privacy:a.privacy,protocol:a.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${a.tunnelRemoteHost}:${a.tunnelRemotePort} `);const h=this.d.get(a.tunnelRemoteHost);if(h){const u=h.get(a.tunnelRemotePort);u&&(u.refcount--,await this.n(a.tunnelRemoteHost,a.tunnelRemotePort,u))}}}}async n(a,h,u){if(u.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${a}:${h}.`);const d=u.value.then(async S=>{S&&(await S.dispose(!0),this.b.fire({host:S.tunnelRemoteHost,port:S.tunnelRemotePort}))});return this.d.has(a)&&this.d.get(a).delete(h),d}}async closeTunnel(a,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${a}:${h} `);const u=this.d.get(a);if(u&&u.has(h)){const d=u.get(h);d.refcount=0,await this.n(a,h,d)}}o(a,h,u){this.d.has(a)||this.d.set(a,new Map),this.d.get(a).set(h,{refcount:1,value:u})}async p(a,h){const u=this.d.get(a);u&&(await u.get(h)||u.delete(h),u.size===0&&this.d.delete(a))}q(a,h){const u=[a];R(a)?(u.push(...e.LOCALHOST_ADDRESSES),u.push(...e.ALL_INTERFACES_ADDRESSES)):b(a)&&u.push(...e.ALL_INTERFACES_ADDRESSES);const d=u.map(S=>this.d.get(S));for(const S of d){const L=S?.get(h);if(L)return L}}canTunnel(a){return!!v(a)}s(a,h,u,d,S,L,n){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${u} on local port ${d}.`);const r=u;this.h.add(r);const t=d===void 0?u:d,i={elevationRequired:S?this.isPortPrivileged(t):!1},s={remoteAddress:{host:h,port:u},localAddressPort:d,privacy:L,public:L?L!==k.Private:void 0,protocol:n},o=a.forwardPort(s,i);return o?(this.o(h,u,o),o.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(r)})):this.h.delete(r),o}};e.AbstractTunnelService=p=ve([J(0,O.ILogService),J(1,N.IConfigurationService)],p)}),define(oe[244],ae([0,1,10,78,2,9,6]),function(ie,e,A,N,l,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class k extends l.Disposable{constructor(){super(),this.a=null,this.b=null}async getAddress(){return this.a?this.a:(this.b||(this.b=new T.DeferredPromise),this.b.p)}setAddress(R){this.a=R,this.b&&(this.b.complete(R),this.b=null)}setTunnel(R){this.B(R)}}let I=e.SharedProcessTunnelService=class Ct extends l.Disposable{constructor(R,b){super(),this.f=R,this.g=b,this.b=new Map,this.c=new Set}dispose(){super.dispose(),this.b.forEach(R=>R.dispose())}async createTunnel(){return{id:String(++Ct.a)}}async startTunnel(R,b,m,g,p,E,a){const h=new k,u=await Promise.resolve(this.f.openTunnel(R,h,m,g,p,E,a));if(!u)throw this.g.info(`[SharedProcessTunnelService] Could not create a tunnel to ${m}:${g} (remote).`),h.dispose(),new Error("Could not create tunnel");if(this.c.has(b))throw this.c.delete(b),h.dispose(),await u.dispose(),(0,O.canceled)();return h.setTunnel(u),this.b.set(b,h),this.g.info(`[SharedProcessTunnelService] Created tunnel ${b}: ${u.localAddress} (local) to ${m}:${g} (remote).`),{tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress}}async setAddress(R,b){const m=this.b.get(R);m&&m.setAddress(b)}async destroyTunnel(R){const b=this.b.get(R);if(b){this.g.info(`[SharedProcessTunnelService] Disposing tunnel ${R}.`),this.b.delete(R),await b.dispose();return}this.c.add(R)}};I.a=0,e.SharedProcessTunnelService=I=ve([J(0,N.ISharedTunnelsService),J(1,A.ILogService)],I)}),define(oe[30],ae([0,1,5]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,A.createDecorator)("IUriIdentityService")}),define(oe[245],ae([0,1,30,193,13,22,130,3,2]),function(ie,e,A,N,l,O,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class v{constructor(m){this.uri=m,this.time=v._clock++}touch(){return this.time=v._clock++,this}}v._clock=0;let R=e.UriIdentityService=class{constructor(m){this.g=m,this.c=new I.DisposableStore,this.f=2**16;const g=new Map,p=E=>{let a=g.get(E.scheme);return a===void 0&&(a=m.hasProvider(E)&&!this.g.hasCapability(E,1024),g.set(E.scheme,a)),a};this.c.add(k.Event.any(m.onDidChangeFileSystemProviderRegistrations,m.onDidChangeFileSystemProviderCapabilities)(E=>{g.delete(E.scheme)})),this.extUri=new O.ExtUri(p),this.d=new T.SkipList((E,a)=>this.extUri.compare(E,a,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(m){this.g.hasProvider(m)&&(m=(0,O.normalizePath)(m));const g=this.d.get(m);return g?g.touch().uri.with({fragment:m.fragment}):(this.d.set(m,new v(m)),this.h(),m)}h(){if(this.d.size<this.f)return;const m=[...this.d.entries()].sort((p,E)=>p[1].time<E[1].time?1:p[1].time>E[1].time?-1:0);v._clock=0,this.d.clear();const g=this.f*.5;for(let p=0;p<g;p++)this.d.set(m[p][0],m[p][1].touch())}};e.UriIdentityService=R=ve([J(0,l.IFileService)],R),(0,N.registerSingleton)(A.IUriIdentityService,R,1)}),define(oe[246],ae([0,1,3,2,13,43,48,16]),function(ie,e,A,N,l,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class I extends N.Disposable{get capabilities(){return this.f.capabilities&-5}constructor(R,b,m,g){super(),this.c=R,this.f=b,this.g=m,this.h=g,this.onDidChangeCapabilities=this.f.onDidChangeCapabilities,this.a=this.B(new A.Emitter),this.onDidChangeFile=this.a.event,this.b=T.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this.B(this.f.onDidChangeFile(p=>this.i(p)))}watch(R,b){this.b.set(R,R);const m=this.f.watch(this.j(R),b);return(0,N.toDisposable)(()=>{this.b.delete(R),m.dispose()})}stat(R){return this.f.stat(this.j(R))}mkdir(R){return this.f.mkdir(this.j(R))}rename(R,b,m){return this.f.rename(this.j(R),this.j(b),m)}readFile(R){return this.f.readFile(this.j(R),{atomic:!0})}readFileStream(R,b,m){const g=(0,O.newWriteableStream)(p=>k.VSBuffer.concat(p.map(E=>k.VSBuffer.wrap(E))).buffer);return(async()=>{try{const p=await this.readFile(R);g.end(p)}catch(p){g.error(p),g.end()}})(),g}readdir(R){return this.f.readdir(this.j(R))}writeFile(R,b,m){return this.f.writeFile(this.j(R),b,m)}delete(R,b){return this.f.delete(this.j(R),b)}copy(R,b,m){if((0,l.hasFileFolderCopyCapability)(this.f))return this.f.copy(this.j(R),this.j(b),m);throw new Error("copy not supported")}i(R){const b=[];for(const m of R){if(m.resource.scheme!==this.c)continue;const g=this.k(m.resource);this.b.findSubstr(g)&&b.push({resource:g,type:m.type})}b.length&&(this.h.debug("User data changed"),this.a.fire(b))}j(R){return R.with({scheme:this.c})}k(R){return R.with({scheme:this.g})}}e.FileUserDataProvider=I}),define(oe[59],ae([0,1,85]),function(ie,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function N(T,k,I,v){const R=(0,A.setProperty)(T,k,I,v)[0];return R&&(T=T.substring(0,R.offset)+R.content+T.substring(R.offset+R.length)),T}e.edit=N;function l(T,k,I){let v=I;for(;v>=0;){if(T.charAt(v)===k.charAt(k.length-1)&&k.length===1)return v+1;if(v--,k.length===2&&v>=0&&T.charAt(v)===k.charAt(0))return v+2}return 0}e.getLineStartOffset=l;function O(T,k,I){let v=I;for(;v>=0;)if(T.charAt(v)===k.charAt(k.length-1)&&k.length===1||(v++,k.length===2&&v>=0&&T.charAt(v)===k.charAt(1)))return v;return T.length-1}e.getLineEndOffset=O}),define(oe[247],ae([0,1,31,54,11]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function O(g,p,E,a,h,u){const d=[],S=[],L=[];if(!p){const W=g.filter(({identifier:H})=>h.every(Q=>Q.toLowerCase()!==H.id.toLowerCase()));return{local:{added:d,removed:S,updated:L},remote:W.length>0?{added:W,updated:[],removed:[],all:W}:null}}g=g.map(b),p=p.map(b),E=E?E.map(b):null;const n=new Map,r=W=>{W.uuid&&n.set(W.id.toLowerCase(),W.uuid)};g.forEach(({identifier:W})=>r(W)),p.forEach(({identifier:W})=>r(W)),E?.forEach(({identifier:W})=>r(W));const t=W=>{const H=W.identifier.uuid||n.get(W.identifier.id.toLowerCase());return H?`uuid:${H}`:`id:${W.identifier.id.toLowerCase()}`},i=(W,H)=>(W.set(t(H),H),W),s=g.reduce(i,new Map),o=p.reduce(i,new Map),c=p.reduce((W,H)=>i(W,(0,A.deepClone)(H)),new Map),y=E?E.reduce(i,new Map):null,w=a.reduce(i,new Map),f=h.reduce((W,H)=>{const Q=n.get(H.toLowerCase());return W.add(Q?`uuid:${Q}`:`id:${H.toLowerCase()}`)},new Set),P=u?u.reduce((W,{id:H,uuid:Q})=>(Q=Q??n.get(H.toLowerCase()),W.add(Q?`uuid:${Q}`:`id:${H.toLowerCase()}`)),new Set):null,D=T(s,o,f,!1);if(D.added.size>0||D.removed.size>0||D.updated.size>0){const W=T(y,s,f,!1),H=T(y,o,f,!0),Q=(_,Y,$,z)=>{let x,te,ne;return Y.installed?(x=z.pinned,ne=z.preRelease,x&&(te=z.version)):(x=$.pinned,ne=$.preRelease,x&&(te=$.version)),x===void 0&&(x=Y.pinned,x&&(te=Y.version)),ne===void 0&&(ne=Y.preRelease),{...z,installed:Y.installed||$.installed,pinned:x,preRelease:ne,version:te??($.version&&(!Y.installed||N.gt($.version,Y.version))?$.version:Y.version),state:I(Y,$,y?.get(_))}};for(const _ of H.removed.values()){const Y=s.get(_);if(!Y)continue;const $=(0,l.assertIsDefined)(y?.get(_)),z=P&&!P.has(_)&&$.installed;Y.installed&&z?S.push(Y.identifier):c.set(_,Y)}for(const _ of H.added.values()){const Y=(0,l.assertIsDefined)(o.get(_)),$=s.get(_);if($){if(D.updated.has(_)){const z=Q(_,$,Y,Y);k($,Y,!1,!1)||L.push(m(z,_)),c.set(_,z)}}else Y.installed&&d.push(m(Y,_))}for(const _ of H.updated.values()){const Y=(0,l.assertIsDefined)(o.get(_)),$=(0,l.assertIsDefined)(y?.get(_)),z=s.get(_);if(z)if(P&&!P.has(_)&&$.installed&&z.installed&&!Y.installed)S.push(z.identifier);else{const te=Q(_,z,Y,Y);L.push(m(te,_)),c.set(_,te)}else Y.installed&&d.push(m(Y,_))}for(const _ of W.added.values())H.added.has(_)||c.set(_,(0,l.assertIsDefined)(s.get(_)));for(const _ of W.updated.values()){if(H.removed.has(_)||H.updated.has(_))continue;const Y=(0,l.assertIsDefined)(s.get(_)),$=(0,l.assertIsDefined)(o.get(_));c.set(_,Q(_,Y,$,Y))}for(const _ of W.removed.values())H.updated.has(_)||H.removed.has(_)||w.has(_)||(0,l.assertIsDefined)(o.get(_)).installed&&P&&(P.has(_)||!(0,l.assertIsDefined)(y?.get(_)).installed||c.delete(_))}const M=[],j=T(o,c,new Set,!0),B=j.added.size>0||j.updated.size>0||j.removed.size>0;return B&&c.forEach((W,H)=>M.push(m(W,H))),{local:{added:d,removed:S,updated:L},remote:B?{added:[...j.added].map(W=>c.get(W)),updated:[...j.updated].map(W=>c.get(W)),removed:[...j.removed].map(W=>o.get(W)),all:M}:null}}e.merge=O;function T(g,p,E,a){const h=g?[...g.keys()].filter(n=>!E.has(n)):[],u=[...p.keys()].filter(n=>!E.has(n)),d=u.filter(n=>h.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),S=h.filter(n=>u.indexOf(n)===-1).reduce((n,r)=>(n.add(r),n),new Set),L=new Set;for(const n of h){if(S.has(n))continue;const r=g.get(n),t=p.get(n);(!t||!k(r,t,a,!0))&&L.add(n)}return{added:d,removed:S,updated:L}}function k(g,p,E,a){return!(g.disabled!==p.disabled||a&&g.installed!==p.installed||g.installed&&p.installed&&(g.preRelease!==p.preRelease||g.pinned!==p.pinned||p.pinned&&g.version!==p.version)||!R(g.state,p.state)||E&&g.version!==p.version)}function I(g,p,E){const a=g.state,h=p.state,u=E?.state;if(!p.version||a&&N.gt(g.version,p.version))return a;if(h&&N.gt(p.version,g.version)||!a)return h;if(!h)return a;const d=(0,A.deepClone)(a),S=u?v(u,h):{added:Object.keys(h).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set},L=u?v(u,a):{added:Object.keys(a).reduce((n,r)=>(n.add(r),n),new Set),removed:new Set,updated:new Set};for(const n of[...S.added.values(),...S.updated.values()])d[n]=h[n];for(const n of S.removed.values())L.updated.has(n)||delete d[n];return d}function v(g,p){const E=Object.keys(g),a=Object.keys(p),h=a.filter(S=>E.indexOf(S)===-1).reduce((S,L)=>(S.add(L),S),new Set),u=E.filter(S=>a.indexOf(S)===-1).reduce((S,L)=>(S.add(L),S),new Set),d=new Set;for(const S of E){if(u.has(S))continue;const L=g[S],n=p[S];(0,A.equals)(L,n)||d.add(S)}return{added:h,removed:u,updated:d}}function R(g={},p={}){const{added:E,removed:a,updated:h}=v(g,p);return E.size===0&&a.size===0&&h.size===0}function b(g){return{...g,disabled:!!g.disabled,installed:!!g.installed}}function m(g,p){const E={identifier:{id:g.identifier.id,uuid:p.startsWith("uuid:")?p.substring(5):void 0},version:g.version,preRelease:!!g.preRelease,pinned:!!g.pinned};return g.disabled&&(E.disabled=!0),g.installed&&(E.installed=!0),g.state&&(E.state=g.state),E}}),define(oe[116],ae([0,1,21,17,5]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,l.createDecorator)("IIgnoredExtensionsManagementService");let O=e.IgnoredExtensionsManagementService=class{constructor(k){this.a=k}hasToNeverSyncExtension(k){return this.b().includes(k.toLowerCase())}hasToAlwaysSyncExtension(k){return this.b().includes(`-${k.toLowerCase()}`)}updateIgnoredExtensions(k,I){let v=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return v=v.filter(R=>R!==k&&R!==`-${k}`),I&&v.push(k.toLowerCase()),this.a.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,2)}updateSynchronizedExtensions(k,I){let v=[...this.a.getValue("settingsSync.ignoredExtensions")].map(R=>R.toLowerCase());return v=v.filter(R=>R!==k&&R!==`-${k}`),I&&v.push(`-${k.toLowerCase()}`),this.a.updateValue("settingsSync.ignoredExtensions",v.length?v:void 0,2)}getIgnoredExtensions(k){const I=k.filter(m=>m.isMachineScoped).map(m=>m.identifier.id.toLowerCase()),v=this.b().map(m=>m.toLowerCase()),R=[],b=[];if(Array.isArray(v))for(const m of v)m.startsWith("-")?b.push(m.substring(1)):R.push(m);return(0,A.distinct)([...I,...R].filter(m=>b.indexOf(m)===-1))}b(){let k=this.a.inspect("settingsSync.ignoredExtensions").userValue;return k!==void 0||(k=this.a.inspect("sync.ignoredExtensions").userValue,k!==void 0)?k:(this.a.getValue("settingsSync.ignoredExtensions")||[]).map(I=>I.toLowerCase())}};e.IgnoredExtensionsManagementService=O=ve([J(0,N.IConfigurationService)],O)}),define(oe[248],ae([0,1,21,35,31,70,59]),function(ie,e,A,N,l,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(S){return(0,N.parse)(S)||[]}async function I(S,L,n,r,t){const i=k(S),s=k(L),o=n?k(n):null,c=[...i,...s,...o||[]].map(Q=>Q.key),y=await t.resolveUserBindings(c),w=R(i,s,o,y);if(!w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:S,hasChanges:!1,hasConflicts:!1};if(!w.hasLocalForwarded&&w.hasRemoteForwarded)return{mergeContent:L,hasChanges:!0,hasConflicts:!1};if(w.hasLocalForwarded&&!w.hasRemoteForwarded)return{mergeContent:S,hasChanges:!0,hasConflicts:!1};const f=m(i),P=m(s),D=o?m(o):null,M=p(f,P,y),j=D?p(D,f,y):{added:[...f.keys()].reduce((Q,_)=>(Q.add(_),Q),new Set),removed:new Set,updated:new Set},B=D?p(D,P,y):{added:[...P.keys()].reduce((Q,_)=>(Q.add(_),Q),new Set),removed:new Set,updated:new Set},W=v(M,j,B);let H=S;for(const Q of W.removed.values())W.conflicts.has(Q)||(H=u(H,Q,r));for(const Q of W.added.values()){if(W.conflicts.has(Q))continue;const _=P.get(Q);if(_.some(Y=>Y.command!==`-${Q}`&&w.conflicts.has(y[Y.key]))){W.conflicts.add(Q);continue}H=h(H,_,r)}for(const Q of W.updated.values()){if(W.conflicts.has(Q))continue;const _=P.get(Q);if(_.some(Y=>Y.command!==`-${Q}`&&w.conflicts.has(y[Y.key]))){W.conflicts.add(Q);continue}H=d(H,Q,_,r)}return{mergeContent:H,hasChanges:!0,hasConflicts:W.conflicts.size>0}}e.merge=I;function v(S,L,n){const r=new Set,t=new Set,i=new Set,s=new Set;for(const o of L.removed.values())n.updated.has(o)&&s.add(o);for(const o of n.removed.values())s.has(o)||(L.updated.has(o)?s.add(o):t.add(o));for(const o of L.added.values())s.has(o)||n.added.has(o)&&S.updated.has(o)&&s.add(o);for(const o of n.added.values())s.has(o)||(L.added.has(o)?S.updated.has(o)&&s.add(o):r.add(o));for(const o of L.updated.values())s.has(o)||n.updated.has(o)&&S.updated.has(o)&&s.add(o);for(const o of n.updated.values())s.has(o)||(L.updated.has(o)?S.updated.has(o)&&s.add(o):i.add(o));return{added:r,removed:t,updated:i,conflicts:s}}function R(S,L,n,r){const t=new Set,i=b(S,r),s=b(L,r),o=n?b(n,r):null,c=g(i,s);if(c.added.size===0&&c.removed.size===0&&c.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const y=o?g(o,i):{added:[...i.keys()].reduce((j,B)=>(j.add(B),j),new Set),removed:new Set,updated:new Set};if(y.added.size===0&&y.removed.size===0&&y.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const w=o?g(o,s):{added:[...s.keys()].reduce((j,B)=>(j.add(B),j),new Set),removed:new Set,updated:new Set};if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:f,removed:P,updated:D,conflicts:M}=v(c,y,w);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:f,removed:P,updated:D,conflicts:M}}function b(S,L){const n=new Map;for(const r of S){const t=L[r.key];let i=n.get(t);i||(i=[],n.set(t,i)),i.push(r)}return n}function m(S){const L=new Map;for(const n of S){const r=n.command[0]==="-"?n.command.substring(1):n.command;let t=L.get(r);t||(t=[],L.set(r,t)),t.push(n)}return L}function g(S,L){const n=[...S.keys()],r=[...L.keys()],t=r.filter(o=>n.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),i=n.filter(o=>r.indexOf(o)===-1).reduce((o,c)=>(o.add(c),o),new Set),s=new Set;for(const o of n){if(i.has(o))continue;const c=S.get(o).map(w=>({...w,key:o})),y=L.get(o).map(w=>({...w,key:o}));(0,A.equals)(c,y,(w,f)=>a(w,f))||s.add(o)}return{added:t,removed:i,updated:s}}function p(S,L,n){const r=[...S.keys()],t=[...L.keys()],i=t.filter(c=>r.indexOf(c)===-1).reduce((c,y)=>(c.add(y),c),new Set),s=r.filter(c=>t.indexOf(c)===-1).reduce((c,y)=>(c.add(y),c),new Set),o=new Set;for(const c of r){if(s.has(c))continue;const y=S.get(c).map(f=>({...f,key:n[f.key]})),w=L.get(c).map(f=>({...f,key:n[f.key]}));E(y,w)||o.add(c)}return{added:i,removed:s,updated:o}}function E(S,L){return!(!(0,A.equals)(S.filter(({command:n})=>n[0]!=="-"),L.filter(({command:n})=>n[0]!=="-"),(n,r)=>a(n,r))||!(0,A.equals)(S.filter(({command:n})=>n[0]==="-"),L.filter(({command:n})=>n[0]==="-"),(n,r)=>a(n,r)))}function a(S,L){if(S.command!==L.command||S.key!==L.key)return!1;const n=O.ContextKeyExpr.deserialize(S.when),r=O.ContextKeyExpr.deserialize(L.when);return!(n&&!r||!n&&r||n&&r&&!n.equals(r)||!l.equals(S.args,L.args))}function h(S,L,n){for(const r of L)S=T.edit(S,[-1],r,n);return S}function u(S,L,n){const r=k(S);for(let t=r.length-1;t>=0;t--)(r[t].command===L||r[t].command===`-${L}`)&&(S=T.edit(S,[t],void 0,n));return S}function d(S,L,n,r){const t=k(S),i=t.findIndex(s=>s.command===L||s.command===`-${L}`);for(let s=t.length-1;s>=0;s--)(t[s].command===L||t[s].command===`-${L}`)&&(S=T.edit(S,[s],void 0,r));for(let s=n.length-1;s>=0;s--)S=T.edit(S,[i],n[s],r);return S}}),define(oe[249],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function A(O,T,k){const I={},v={},R=new Set;if(!T)return{local:{added:I,updated:v,removed:[...R.values()]},remote:{added:O,updated:{},removed:[]},conflicts:[]};const b=N(O,T);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{local:{added:I,updated:v,removed:[...R.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const m=N(k,O),g=N(k,T),p={},E={},a=new Set,h=new Set;for(const u of m.removed.values())g.updated.has(u)?I[u]=T[u]:a.add(u);for(const u of g.removed.values())h.has(u)||(m.updated.has(u)?h.add(u):R.add(u));for(const u of m.updated.values())h.has(u)||(g.updated.has(u)?b.updated.has(u)&&h.add(u):E[u]=O[u]);for(const u of g.updated.values())h.has(u)||(m.updated.has(u)?b.updated.has(u)&&h.add(u):O[u]!==void 0&&(v[u]=T[u]));for(const u of m.added.values())h.has(u)||(g.added.has(u)?b.updated.has(u)&&h.add(u):p[u]=O[u]);for(const u of g.added.values())h.has(u)||(m.added.has(u)?b.updated.has(u)&&h.add(u):I[u]=T[u]);return{local:{added:I,removed:[...R.values()],updated:v},remote:{added:p,removed:[...a.values()],updated:E},conflicts:[...h.values()]}}e.merge=A;function N(O,T){const k=O?Object.keys(O):[],I=T?Object.keys(T):[],v=I.filter(m=>k.indexOf(m)===-1).reduce((m,g)=>(m.add(g),m),new Set),R=k.filter(m=>I.indexOf(m)===-1).reduce((m,g)=>(m.add(g),m),new Set),b=new Set;for(const m of k){if(R.has(m))continue;const g=O[m],p=T[m];g!==p&&b.add(m)}return{added:v,removed:R,updated:b}}function l(O,T){const{added:k,removed:I,updated:v}=N(O,T);return k.size===0&&I.size===0&&v.size===0}e.areSame=l}),define(oe[250],ae([0,1]),function(ie,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function A(l,O,T,k){const I={added:[],removed:[],updated:[]};let v={added:[],removed:[],updated:[]};if(!O){const b=l.filter(({id:m})=>!k.includes(m));return b.length?v.added=b:v=null,{local:I,remote:v}}const R=N(l,O,k);if(R.added.length>0||R.removed.length>0||R.updated.length>0){const b=N(T,l,k),m=N(T,O,k);for(const g of m.removed){const p=l.find(E=>E.id===g);p&&I.removed.push(p)}for(const g of m.added){const p=O.find(E=>E.id===g);b.added.includes(g)?R.updated.includes(g)&&I.updated.push(p):I.added.push(p)}for(const g of m.updated)I.updated.push(O.find(p=>p.id===g));for(const g of b.added)m.added.includes(g)||v.added.push(l.find(p=>p.id===g));for(const g of b.updated)m.removed.includes(g)||m.updated.includes(g)||v.updated.push(l.find(p=>p.id===g));for(const g of b.removed){const p=O.find(E=>E.id===g);p&&v.removed.push(p)}}return v.added.length===0&&v.removed.length===0&&v.updated.length===0&&(v=null),{local:I,remote:v}}e.merge=A;function N(l,O,T){l=l?l.filter(({id:m})=>!T.includes(m)):[],O=O.filter(({id:m})=>!T.includes(m));const k=l.map(({id:m})=>m),I=O.map(({id:m})=>m),v=I.filter(m=>k.indexOf(m)===-1),R=k.filter(m=>I.indexOf(m)===-1),b=[];for(const{id:m,name:g,shortName:p}of l){if(R.includes(m))continue;const E=O.find(a=>a.id===m);(!E||E.name!==g||E.shortName!==p)&&b.push(m)}return{added:v,removed:R,updated:b}}}),define(oe[23],ae([0,1,21,11,180,45,29,5,107,39]),function(ie,e,A,N,l,O,T,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.USER_DATA_SYNC_LOG_ID=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncResourceProviderService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.getPathSegments=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function R(){const s=v.Registry.as(O.Extensions.Configuration).getConfigurationProperties();return Object.keys(s).filter(o=>!!s[o].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=R;function b(){const s=v.Registry.as(O.Extensions.Configuration).getConfigurationProperties(),o=Object.keys(s).filter(w=>!!s[w].ignoreSync),c=Object.keys(s).filter(w=>s[w].scope===2||s[w].scope===6),y=R();return(0,A.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...o,...c,...y])}e.getDefaultIgnoredSettings=b,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync",e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM="settingsSync.keybindingsPerPlatform";function m(){const s="vscode://schemas/ignoredSettings",o=v.Registry.as(O.Extensions.Configuration);o.registerConfiguration({id:"settingsSync",order:30,title:(0,l.localize)(0,null),type:"object",properties:{[e.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM]:{type:"boolean",description:(0,l.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,l.localize)(2,null),items:[{type:"string",pattern:T.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,l.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,l.localize)(4,null),default:[],scope:1,$ref:s,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const c=v.Registry.as(I.Extensions.JSONContribution),y=()=>{const w=R(),f=b().filter(j=>j!==e.CONFIGURATION_SYNC_STORE_KEY),P=Object.keys(O.allSettings.properties).filter(j=>f.indexOf(j)===-1),D=f.filter(j=>w.indexOf(j)===-1),M={items:{type:"string",enum:[...P,...D.map(j=>`-${j}`)]}};c.registerSchema(s,M)};return o.onDidUpdateConfiguration(()=>y())}e.registerConfiguration=m;function g(s){return s&&(0,N.isObject)(s)&&(0,N.isString)(s.id)&&Array.isArray(s.scopes)}e.isAuthenticationProvider=g;var p;(function(s){s.Settings="settings",s.Keybindings="keybindings",s.Snippets="snippets",s.Tasks="tasks",s.Extensions="extensions",s.GlobalState="globalState",s.Profiles="profiles"})(p||(e.SyncResource=p={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState","profiles"];function E(s,...o){return s?[s,...o]:o}e.getPathSegments=E;function a(s,o,c,y){return y.joinPath(c.userDataSyncHome,...E(s,o,`lastSync${o}.json`))}e.getLastSyncResourceUri=a,e.IUserDataSyncStoreManagementService=(0,k.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,k.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,k.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function h(s){const o={};return o[e.HEADER_EXECUTION_ID]=s,o}e.createSyncHeaders=h;var u;(function(s){s.Unauthorized="Unauthorized",s.Forbidden="Forbidden",s.NotFound="NotFound",s.MethodNotFound="MethodNotFound",s.Conflict="Conflict",s.Gone="Gone",s.PreconditionFailed="PreconditionFailed",s.TooLarge="TooLarge",s.UpgradeRequired="UpgradeRequired",s.PreconditionRequired="PreconditionRequired",s.TooManyRequests="RemoteTooManyRequests",s.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",s.RequestFailed="RequestFailed",s.RequestCanceled="RequestCanceled",s.RequestTimeout="RequestTimeout",s.RequestProtocolNotSupported="RequestProtocolNotSupported",s.RequestPathNotEscaped="RequestPathNotEscaped",s.RequestHeadersNotObject="RequestHeadersNotObject",s.NoCollection="NoCollection",s.NoRef="NoRef",s.EmptyResponse="EmptyResponse",s.TurnedOff="TurnedOff",s.SessionExpired="SessionExpired",s.ServiceChanged="ServiceChanged",s.DefaultServiceChanged="DefaultServiceChanged",s.LocalTooManyProfiles="LocalTooManyProfiles",s.LocalTooManyRequests="LocalTooManyRequests",s.LocalPreconditionFailed="LocalPreconditionFailed",s.LocalInvalidContent="LocalInvalidContent",s.LocalError="LocalError",s.IncompatibleLocalContent="IncompatibleLocalContent",s.IncompatibleRemoteContent="IncompatibleRemoteContent",s.Unknown="Unknown"})(u||(e.UserDataSyncErrorCode=u={}));class d extends Error{constructor(o,c,y,w){super(o),this.code=c,this.resource=y,this.operationId=w,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=d;class S extends d{constructor(o,c,y,w,f){super(o,y,void 0,f),this.url=c,this.serverCode=w}}e.UserDataSyncStoreError=S;class L extends d{constructor(o,c){super(o,c)}}e.UserDataAutoSyncError=L,function(s){function o(c){if(c instanceof s)return c;const y=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(c.name);if(y&&y[1]){const w=y[2]==="unknown"?void 0:y[2],f=y[3]==="unknown"?void 0:y[3];return new s(c.message,y[1],w,f)}return new s(c.message,"Unknown")}s.toUserDataSyncError=o}(d||(e.UserDataSyncError=d={}));var n;(function(s){s.Uninitialized="uninitialized",s.Idle="idle",s.Syncing="syncing",s.HasConflicts="hasConflicts"})(n||(e.SyncStatus=n={}));var r;(function(s){s[s.None=0]="None",s[s.Added=1]="Added",s[s.Modified=2]="Modified",s[s.Deleted=3]="Deleted"})(r||(e.Change=r={}));var t;(function(s){s.Preview="preview",s.Conflict="conflict",s.Accepted="accepted"})(t||(e.MergeState=t={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(s){return`sync.enable.${s}`}e.getEnablementKey=i,e.IUserDataSyncEnablementService=(0,k.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,k.createDecorator)("IUserDataSyncService"),e.IUserDataSyncResourceProviderService=(0,k.createDecorator)("IUserDataSyncResourceProviderService"),e.IUserDataAutoSyncService=(0,k.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,k.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,k.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_LOG_ID="userDataSync",e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview"}),define(oe[251],ae([0,1,31,23]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function l(T,k,I,v,R){if(!k)return{remote:{added:Object.keys(T),removed:[],updated:[],all:Object.keys(T).length>0?T:null},local:{added:{},removed:[],updated:{}}};const b=O(T,k);if(b.added.size===0&&b.removed.size===0&&b.updated.size===0)return{remote:{added:[],removed:[],updated:[],all:null},local:{added:{},removed:[],updated:{}}};const m=I?O(I,k):{added:Object.keys(k).reduce((u,d)=>(u.add(d),u),new Set),removed:new Set,updated:new Set},g=I?O(I,T):{added:Object.keys(T).reduce((u,d)=>(u.add(d),u),new Set),removed:new Set,updated:new Set},p={added:{},removed:[],updated:{}},E=A.deepClone(k),a=!I;for(const u of g.added.values())u!==N.SYNC_SERVICE_URL_TYPE&&a&&m.added.has(u)||(E[u]=T[u]);for(const u of g.updated.values())E[u]=T[u];for(const u of g.removed.values())v.unregistered.includes(u)||delete E[u];for(const u of m.added.values()){const d=k[u];if(v.machine.includes(u)){R.info(`GlobalState: Skipped adding ${u} in local storage because it is declared as machine scoped.`);continue}if(I&&g.added.has(u))continue;const S=T[u];S&&S.value===d.value||u===N.SYNC_SERVICE_URL_TYPE&&a&&g.added.has(u)||(S?p.updated[u]=d:p.added[u]=d)}for(const u of m.updated.values()){const d=k[u];if(v.machine.includes(u)){R.info(`GlobalState: Skipped updating ${u} in local storage because it is declared as machine scoped.`);continue}if(g.updated.has(u)||g.removed.has(u))continue;const S=T[u];S&&S.value===d.value||(p.updated[u]=d)}for(const u of m.removed.values()){if(v.machine.includes(u)){R.trace(`GlobalState: Skipped removing ${u} in local storage because it is declared as machine scoped.`);continue}g.updated.has(u)||g.removed.has(u)||p.removed.push(u)}const h=O(k,E);return{local:p,remote:{added:[...h.added],updated:[...h.updated],removed:[...h.removed],all:h.added.size===0&&h.removed.size===0&&h.updated.size===0?null:E}}}e.merge=l;function O(T,k){const I=Object.keys(T),v=Object.keys(k),R=v.filter(g=>I.indexOf(g)===-1).reduce((g,p)=>(g.add(p),g),new Set),b=I.filter(g=>v.indexOf(g)===-1).reduce((g,p)=>(g.add(p),g),new Set),m=new Set;for(const g of I){if(b.has(g))continue;const p=T[g],E=k[g];A.equals(p,E)||m.add(g)}return{added:R,removed:b,updated:m}}}),define(oe[252],ae([0,1,21,35,85,42,31,59,23]),function(ie,e,A,N,l,O,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function v(c,y,w){let f=[];w?f=b(w):f=R(y);const P=[],D=[...(0,I.getDisallowedIgnoredSettings)()];if(Array.isArray(f))for(const M of f)M.startsWith("-")?D.push(M.substring(1)):P.push(M);return(0,A.distinct)([...c,...P].filter(M=>D.indexOf(M)===-1))}e.getIgnoredSettings=v;function R(c){let y=c.inspect("settingsSync.ignoredSettings").userValue;return y!==void 0||(y=c.inspect("sync.ignoredSettings").userValue,y!==void 0)?y:c.getValue("settingsSync.ignoredSettings")||[]}function b(c){const y=(0,N.parse)(c);return y?y["settingsSync.ignoredSettings"]||y["sync.ignoredSettings"]||[]:[]}function m(c,y){const w=(0,N.parse)(c)||{};let f="{}";for(const P of Object.keys(w)){const D=(0,l.setProperty)(f,[P],w[P],y);f=(0,l.applyEdits)(f,D)}return f}e.removeComments=m;function g(c,y,w,f){if(w.length){const P=o(y),D=(0,N.parse)(y)||{},M=(0,N.parse)(c);if(!M)return c;const j=[];for(const B of w){const W=D[B],H=M[B];W===void 0?c=k.edit(c,[B],void 0,f):H!==void 0?c=k.edit(c,[B],W,f):j.push(n(B,P))}j.sort((B,W)=>B.startOffset-W.startOffset),j.forEach(B=>c=u(B.setting.key,y,c,f))}return c}e.updateIgnoredSettings=g;function p(c,y,w,f,P,D){const M=g(c,y,f,D),j=w!==M,B=w!==y;if(!j&&!B)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(j&&!B)return{conflictsSettings:[],localContent:null,remoteContent:M,hasConflicts:!1};if(B&&!j)return{conflictsSettings:[],localContent:g(y,c,f,D),remoteContent:null,hasConflicts:!1};if(w===null&&a(c)){const U=E(c,y,f)?null:g(y,c,f,D);return{conflictsSettings:[],localContent:U,remoteContent:null,hasConflicts:!1}}let W=c,H=y;const Q=(0,N.parse)(c),_=(0,N.parse)(y),Y=w?(0,N.parse)(w):null,$=f.reduce((U,q)=>(U.add(q),U),new Set),z=h(Q,_,$),x=h(Y,Q,$),te=h(Y,_,$),ne=new Map,re=new Set,X=U=>{re.add(U);const q=P.filter(({key:G})=>G===U)[0];q?(W=k.edit(W,[U],q.value,D),H=k.edit(H,[U],q.value,D)):ne.set(U,{key:U,localValue:Q[U],remoteValue:_[U]})};for(const U of x.removed.values())te.updated.has(U)?X(U):H=k.edit(H,[U],void 0,D);for(const U of te.removed.values())re.has(U)||(x.updated.has(U)?X(U):W=k.edit(W,[U],void 0,D));for(const U of x.updated.values())re.has(U)||(te.updated.has(U)?z.updated.has(U)&&X(U):H=k.edit(H,[U],Q[U],D));for(const U of te.updated.values())re.has(U)||(x.updated.has(U)?z.updated.has(U)&&X(U):W=k.edit(W,[U],_[U],D));for(const U of x.added.values())re.has(U)||(te.added.has(U)?z.updated.has(U)&&X(U):H=u(U,W,H,D));for(const U of te.added.values())re.has(U)||(x.added.has(U)?z.updated.has(U)&&X(U):W=u(U,H,W,D));const K=ne.size>0||!E(W,H,f),F=K||!E(W,c,[]),C=K||!E(H,y,[]);return{localContent:F?W:null,remoteContent:C?H:null,conflictsSettings:[...ne.values()],hasConflicts:K}}e.merge=p;function E(c,y,w){if(c===y)return!0;const f=(0,N.parse)(c),P=(0,N.parse)(y),D=w.reduce((B,W)=>(B.add(W),B),new Set),M=o(c).filter(B=>!(B.setting&&D.has(B.setting.key))),j=o(y).filter(B=>!(B.setting&&D.has(B.setting.key)));if(M.length!==j.length)return!1;for(let B=0;B<M.length;B++){const W=M[B],H=j[B];if(W.setting&&H.setting){if(W.setting.key!==H.setting.key||!T.equals(f[W.setting.key],P[W.setting.key]))return!1}else if(!W.setting&&!H.setting){if(W.value!==H.value)return!1}else return!1}return!0}function a(c){return c?o(c).length===0:!0}e.isEmpty=a;function h(c,y,w){const f=c?Object.keys(c).filter(B=>!w.has(B)):[],P=Object.keys(y).filter(B=>!w.has(B)),D=P.filter(B=>f.indexOf(B)===-1).reduce((B,W)=>(B.add(W),B),new Set),M=f.filter(B=>P.indexOf(B)===-1).reduce((B,W)=>(B.add(W),B),new Set),j=new Set;if(c)for(const B of f){if(M.has(B))continue;const W=c[B],H=y[B];T.equals(W,H)||j.add(B)}return{added:D,removed:M,updated:j}}function u(c,y,w,f){const P=(0,N.parse)(y),D=o(y),M=o(w),j=d(c,D,M);return S(w,c,P[c],j,M,f)}e.addSetting=u;function d(c,y,w){const f=y.findIndex(D=>D.setting?.key===c),P=y[f-1];if(P){if(P.setting){const M=n(P.setting.key,w);if(M)return{index:w.indexOf(M),insertAfter:!0}}else{const M=r(f,y);if(M){const j=n(M.setting.key,w);if(j){const B=t(w.indexOf(j),w),W=i(y,M,y[f]);if(B){const H=i(w,j,B),Q=s(W,H);return Q?{index:w.indexOf(Q),insertAfter:!0}:{index:w.indexOf(B),insertAfter:!1}}else{const H=i(w,j,w[w.length-1]),Q=s(W,H);return Q?{index:w.indexOf(Q),insertAfter:!0}:{index:w.length-1,insertAfter:!0}}}}}const D=y[f+1];if(D)if(D.setting){const M=n(D.setting.key,w);if(M)return{index:w.indexOf(M),insertAfter:!1}}else{const M=t(f,y);if(M){const j=n(M.setting.key,w);if(j){const B=r(w.indexOf(j),w),W=i(y,y[f],M);if(B){const H=i(w,B,j),Q=s(W.reverse(),H.reverse());return Q?{index:w.indexOf(Q),insertAfter:!1}:{index:w.indexOf(B),insertAfter:!0}}else{const H=i(w,w[0],j),Q=s(W.reverse(),H.reverse());return Q?{index:w.indexOf(Q),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:w.length-1,insertAfter:!0}}function S(c,y,w,f,P,D){let M;return f.index===-1?M=(0,l.setProperty)(c,[y],w,D):M=L(c,y,w,f,P,D).map(j=>(0,l.withFormatting)(c,j,D)[0]),(0,l.applyEdits)(c,M)}function L(c,y,w,f,P,D){const M=`${JSON.stringify(y)}: ${JSON.stringify(w)}`,j=(0,O.getEOL)(D,c),B=P[f.index];if(f.insertAfter){const W=[];if(B.setting)W.push({offset:B.endOffset,length:0,content:","+M});else{const H=t(f.index,P),Q=r(f.index,P),_=Q?.setting?.commaOffset;Q&&_===void 0&&W.push({offset:Q.endOffset,length:0,content:","});const Y=_!==void 0&&_>B.endOffset;W.push({offset:Y?_+1:B.endOffset,length:0,content:H?j+M+",":j+M})}return W}else{if(B.setting)return[{offset:B.startOffset,length:0,content:M+","}];const W=(P[f.index-1]&&!P[f.index-1].setting?j:"")+M+(t(f.index,P)?",":"")+j;return[{offset:B.startOffset,length:0,content:W}]}}function n(c,y){return y.filter(w=>w.setting?.key===c)[0]}function r(c,y){for(let w=c-1;w>=0;w--)if(y[w].setting)return y[w]}function t(c,y){for(let w=c+1;w<y.length;w++)if(y[w].setting)return y[w]}function i(c,y,w){const f=c.indexOf(y),P=c.indexOf(w);return c.filter((D,M)=>f<M&&M<P)}function s(c,y){if(c.length&&y.length){let w=0;for(;w<y.length&&w<c.length;w++)if(c[w].value!==y[w].value)return y[w-1];return y[w-1]}}function o(c){const y=[];let w=-1,f,P;const D={onObjectBegin:M=>{w++},onObjectProperty:(M,j,B)=>{w===0&&(f=j,P=M)},onObjectEnd:(M,j)=>{w--,w===0&&y.push({startOffset:f,endOffset:M+j,value:c.substring(f,M+j),setting:{key:P,commaOffset:void 0}})},onArrayBegin:(M,j)=>{w++},onArrayEnd:(M,j)=>{w--,w===0&&y.push({startOffset:f,endOffset:M+j,value:c.substring(f,M+j),setting:{key:P,commaOffset:void 0}})},onLiteralValue:(M,j,B)=>{w===0&&y.push({startOffset:f,endOffset:j+B,value:c.substring(f,j+B),setting:{key:P,commaOffset:void 0}})},onSeparator:(M,j,B)=>{if(w===0&&M===","){let W=y.length-1;for(;W>=0&&!y[W].setting;W--);const H=y[W];H&&y.splice(W,1,{startOffset:H.startOffset,endOffset:H.endOffset,value:H.value,setting:{key:H.setting.key,commaOffset:j}})}},onComment:(M,j)=>{w===0&&y.push({startOffset:M,endOffset:M+j,value:c.substring(M,M+j)})}};return(0,N.visit)(c,D),y}}),define(oe[79],ae([0,1,3,2,5,23]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,l.createDecorator)("IUserDataSyncAccountService");let T=e.UserDataSyncAccountService=class extends N.Disposable{get account(){return this.a}constructor(I,v){super(),this.g=I,this.h=v,this.b=this.B(new A.Emitter),this.onDidChangeAccount=this.b.event,this.c=this.B(new A.Emitter),this.onTokenFailed=this.c.event,this.f=!1,this.B(I.onTokenFailed(R=>{this.h.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.f,R),this.updateAccount(void 0),R==="Forbidden"?this.c.fire(!0):this.c.fire(this.f),this.f=!0})),this.B(I.onTokenSucceed(()=>this.f=!1))}async updateAccount(I){(I&&this.a?I.token!==this.a.token||I.authenticationProviderId!==this.a.authenticationProviderId:I!==this.a)&&(this.a=I,this.a&&this.g.setAuthToken(this.a.token,this.a.authenticationProviderId),this.b.fire(I))}};e.UserDataSyncAccountService=T=ve([J(0,O.IUserDataSyncStoreService),J(1,O.IUserDataSyncLogService)],T)}),define(oe[253],ae([0,1,2,12]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class l{constructor(m){this.a=m}listen(m,g){switch(g){case"onError":return this.a.onError}throw new Error(`Event not found: ${g}`)}call(m,g,p){switch(g){case"triggerSync":return this.a.triggerSync(p[0],p[1],p[2]);case"turnOn":return this.a.turnOn();case"turnOff":return this.a.turnOff(p[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=l;class O{constructor(m){this.a=m}listen(m,g){throw new Error(`Event not found: ${g}`)}call(m,g,p){switch(g){case"resolveDefaultIgnoredSettings":return this.a.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.a.resolveUserBindings(p[0]);case"resolveFormattingOptions":return this.a.resolveFormattingOptions(N.URI.revive(p[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=O;class T{constructor(m){this.a=m}async resolveDefaultIgnoredSettings(){return this.a.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(m){return this.a.call("resolveUserKeybindings",[m])}async resolveFormattingOptions(m){return this.a.call("resolveFormattingOptions",[m])}}e.UserDataSyncUtilServiceClient=T;class k{constructor(m){this.a=m}listen(m,g){switch(g){case"onDidChange":return this.a.onDidChange}throw new Error(`Event not found: ${g}`)}async call(m,g,p){switch(g){case"getMachines":return this.a.getMachines();case"addCurrentMachine":return this.a.addCurrentMachine();case"removeCurrentMachine":return this.a.removeCurrentMachine();case"renameMachine":return this.a.renameMachine(p[0],p[1]);case"setEnablements":return this.a.setEnablements(p)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=k;class I{constructor(m){this.a=m}listen(m,g){switch(g){case"onDidChangeAccount":return this.a.onDidChangeAccount;case"onTokenFailed":return this.a.onTokenFailed}throw new Error(`Event not found: ${g}`)}call(m,g,p){switch(g){case"_getInitialData":return Promise.resolve(this.a.account);case"updateAccount":return this.a.updateAccount(p)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=I;class v{constructor(m){this.a=m}listen(m,g){switch(g){case"onDidChangeUserDataSyncStore":return this.a.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${g}`)}call(m,g,p){switch(g){case"switch":return this.a.switch(p[0]);case"getPreviousUserDataSyncStore":return this.a.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=v;class R extends A.Disposable{constructor(m){super(),this.a=m,this.onDidChangeUserDataSyncStore=this.a.listen("onDidChangeUserDataSyncStore")}async switch(m){return this.a.call("switch",[m])}async getPreviousUserDataSyncStore(){const m=await this.a.call("getPreviousUserDataSyncStore");return this.b(m)}b(m){return{url:N.URI.revive(m.url),type:m.type,defaultUrl:N.URI.revive(m.defaultUrl),insidersUrl:N.URI.revive(m.insidersUrl),stableUrl:N.URI.revive(m.stableUrl),canSwitch:m.canSwitch,authenticationProviders:m.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=R}),define(oe[254],ae([0,1,181,10,23]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let O=e.UserDataSyncLogService=class extends N.AbstractLogger{constructor(k){super(),this.g=this.B(k.createLogger(l.USER_DATA_SYNC_LOG_ID,{name:(0,A.localize)(0,null)}))}trace(k,...I){this.g.trace(k,...I)}debug(k,...I){this.g.debug(k,...I)}info(k,...I){this.g.info(k,...I)}warn(k,...I){this.g.warn(k,...I)}error(k,...I){this.g.error(k,...I)}flush(){this.g.flush()}};e.UserDataSyncLogService=O=ve([J(0,N.ILoggerService)],O)}),define(oe[255],ae([0,1,6,3,2]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class O extends l.Disposable{constructor({onDidOpenWindow:k,onDidFocusWindow:I,getActiveWindowId:v}){super(),this.a=this.B(new l.DisposableStore),N.Event.latch(N.Event.any(k,I))(this.f,this,this.a),this.b=(0,A.createCancelablePromise)(()=>v()),(async()=>{try{const b=await this.b;this.c=typeof this.c=="number"?this.c:b}catch{}finally{this.b=void 0}})()}f(k){this.b&&(this.b.cancel(),this.b=void 0),this.c=k}async getActiveClientId(){return`window:${this.b?await this.b:this.c}`}}e.ActiveWindowManager=O}),define(oe[117],ae([0,1,184,14,48,22,12,5,24]),function(ie,e,A,N,l,O,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,k.createDecorator)("contextService");function v(i){const s=i;return typeof s?.id=="string"&&T.URI.isUri(s.uri)}e.isSingleFolderWorkspaceIdentifier=v;function R(i){return typeof i?.id=="string"&&!v(i)&&!m(i)}e.isEmptyWorkspaceIdentifier=R,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function b(i,s){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,N.basename)(i)}:s?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=b;function m(i){const s=i;return typeof s?.id=="string"&&T.URI.isUri(s.configPath)}e.isWorkspaceIdentifier=m;function g(i){const s=i;if(s?.uri)return{id:s.id,uri:T.URI.revive(s.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:T.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=g;var p;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function E(i){const s=i;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}e.isWorkspace=E;function a(i){const s=i;return!!(s&&typeof s=="object"&&T.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}e.isWorkspaceFolder=a;class h{constructor(s,o,c,y,w){this.h=s,this.j=c,this.k=y,this.l=w,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class u{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,O.joinPath)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=u;function d(i){return new u({uri:i,index:0,name:(0,O.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=d,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,A.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(i,s){return O.extUriBiasedIgnorePathCase.isEqualOrParent(i,s.untitledWorkspacesHome)}e.isUntitledWorkspace=S;function L(i){let s;return T.URI.isUri(i)?s=i:s=i.configuration,s?.scheme===I.Schemas.tmp}e.isTemporaryWorkspace=L,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(i){return i.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=n;function r(i,s){return!S(i,s)&&!L(i)}e.isSavedWorkspace=r;function t(i){return(typeof i=="string"?(0,N.extname)(i):(0,O.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=t}),define(oe[18],ae([0,1,65,3,2,22,12,175,15,13,5,10,117,37,30,6,32,27,11]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function d(t){const i=t;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&typeof i.isDefault=="boolean"&&typeof i.name=="string"&&T.URI.isUri(i.location)&&T.URI.isUri(i.globalStorageHome)&&T.URI.isUri(i.settingsResource)&&T.URI.isUri(i.keybindingsResource)&&T.URI.isUri(i.tasksResource)&&T.URI.isUri(i.snippetsHome)&&T.URI.isUri(i.extensionsResource))}e.isUserDataProfile=d,e.IUserDataProfilesService=(0,R.createDecorator)("IUserDataProfilesService");function S(t,i){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,location:T.URI.revive(t.location).with({scheme:i}),globalStorageHome:T.URI.revive(t.globalStorageHome).with({scheme:i}),settingsResource:T.URI.revive(t.settingsResource).with({scheme:i}),keybindingsResource:T.URI.revive(t.keybindingsResource).with({scheme:i}),tasksResource:T.URI.revive(t.tasksResource).with({scheme:i}),snippetsHome:T.URI.revive(t.snippetsHome).with({scheme:i}),extensionsResource:T.URI.revive(t.extensionsResource).with({scheme:i}),cacheHome:T.URI.revive(t.cacheHome).with({scheme:i}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}e.reviveProfile=S;function L(t,i,s,o,c){return{id:t,name:i,location:s,isDefault:!1,shortName:c?.shortName,globalStorageHome:(0,O.joinPath)(s,"globalStorage"),settingsResource:(0,O.joinPath)(s,"settings.json"),keybindingsResource:(0,O.joinPath)(s,"keybindings.json"),tasksResource:(0,O.joinPath)(s,"tasks.json"),snippetsHome:(0,O.joinPath)(s,"snippets"),extensionsResource:(0,O.joinPath)(s,"extensions.json"),cacheHome:(0,O.joinPath)(o,t),useDefaultFlags:c?.useDefaultFlags,isTransient:c?.transient}}e.toUserDataProfile=L;let n=e.UserDataProfilesService=class extends l.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.v.profiles,...this.m.profiles]}constructor(i,s,o,c){super(),this.n=i,this.r=s,this.s=o,this.t=c,this.f=!0,this.h=this.B(new N.Emitter),this.onDidChangeProfiles=this.h.event,this.i=this.B(new N.Emitter),this.onWillCreateProfile=this.i.event,this.j=this.B(new N.Emitter),this.onWillRemoveProfile=this.j.event,this.k=this.B(new N.Emitter),this.onDidResetWorkspaces=this.k.event,this.l=new Map,this.m={profiles:[],workspaces:new g.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,O.joinPath)(this.n.userRoamingDataHome,"profiles"),this.g=(0,O.joinPath)(this.n.cacheHome,"CachedProfilesData")}init(){this.u=void 0}setEnablement(i){this.f!==i&&(this.u=void 0,this.f=i)}isEnabled(){return this.f}get v(){if(!this.u){const i=[];if(this.f)try{for(const y of this.J()){if(!y.name||!(0,u.isString)(y.name)||!y.location){this.t.warn("Skipping the invalid stored profile",y.location||y.name);continue}i.push(L((0,O.basename)(y.location),y.name,y.location,this.g,{shortName:y.shortName,useDefaultFlags:y.useDefaultFlags}))}}catch(y){this.t.error(y)}const s=new g.ResourceMap,o=new Map,c=this.w();if(i.unshift({...c,extensionsResource:this.O()??c.extensionsResource,isDefault:!0}),i.length)try{const y=this.M();if(y.workspaces)for(const[w,f]of Object.entries(y.workspaces)){const P=T.URI.parse(w),D=i.find(M=>M.id===f);D&&s.set(P,D)}if(y.emptyWindows)for(const[w,f]of Object.entries(y.emptyWindows)){const P=i.find(D=>D.id===f);P&&o.set(w,P)}}catch(y){this.t.error(y)}this.u={profiles:i,workspaces:s,emptyWindows:o}}return this.u}w(){return L("__default__profile__",(0,k.localize)(0,null),this.n.userRoamingDataHome,this.g)}async createTransientProfile(i){const s="Temp",o=new RegExp(`${(0,h.escapeRegExpCharacters)(s)}\\s(\\d+)`);let c=0;for(const w of this.profiles){const f=o.exec(w.name),P=f?parseInt(f[1]):0;c=P>c?P:c}const y=`${s} ${c+1}`;return this.createProfile((0,A.hash)((0,a.generateUuid)()).toString(16),y,{transient:!0},i)}async createNamedProfile(i,s,o){return this.createProfile((0,A.hash)((0,a.generateUuid)()).toString(16),i,s,o)}async createProfile(i,s,o,c){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const y=await this.y(i,s,o);return c&&await this.setProfileForWorkspace(c,y),y}async y(i,s,o){if(!(0,u.isString)(s)||!s)throw new Error("Name of the profile is mandatory and must be of type `string`");let c=this.l.get(s);return c||(c=(async()=>{try{const y=this.profiles.find(P=>P.name===s||P.id===i);if(y)return y;const w=L(i,s,(0,O.joinPath)(this.profilesHome,i),this.g,o);await this.r.createFolder(w.location);const f=[];return this.i.fire({profile:w,join(P){f.push(P)}}),await E.Promises.settled(f),this.D([w],[],[]),w}finally{this.l.delete(s)}})(),this.l.set(s,c)),c}async updateProfile(i,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let o=this.profiles.find(c=>c.id===i.id);if(!o)throw new Error(`Profile '${i.name}' does not exist`);return o=L(o.id,s.name??o.name,o.location,this.g,{shortName:s.shortName??o.shortName,transient:s.transient??o.isTransient,useDefaultFlags:s.useDefaultFlags??o.useDefaultFlags}),this.D([],[],[o]),o}async removeProfile(i){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(i.isDefault)throw new Error("Cannot remove default profile");const s=this.profiles.find(c=>c.id===i.id);if(!s)throw new Error(`Profile '${i.name}' does not exist`);const o=[];this.j.fire({profile:s,join(c){o.push(c)}});try{await Promise.allSettled(o)}catch(c){this.t.error(c)}for(const c of[...this.v.emptyWindows.keys()])s.id===this.v.emptyWindows.get(c)?.id&&this.v.emptyWindows.delete(c);for(const c of[...this.v.workspaces.keys()])s.id===this.v.workspaces.get(c)?.id&&this.v.workspaces.delete(c);this.H(),this.D([],[s],[]);try{await this.r.del(s.cacheHome,{recursive:!0})}catch(c){(0,v.toFileOperationResult)(c)!==1&&this.t.error(c)}try{this.profiles.length===1?await this.r.del(this.profilesHome,{recursive:!0}):await this.r.del(s.location,{recursive:!0})}catch(c){this.t.error(c)}}async setProfileForWorkspace(i,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const o=this.profiles.find(c=>c.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);this.G(i,o)}unsetWorkspace(i,s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.G(i,void 0,s)}async resetWorkspaces(){this.m.workspaces.clear(),this.m.emptyWindows.clear(),this.v.workspaces.clear(),this.v.emptyWindows.clear(),this.H(),this.k.fire()}async cleanUp(){if(this.f&&await this.r.exists(this.profilesHome)){const i=await this.r.resolve(this.profilesHome);await Promise.all((i.children||[]).filter(s=>s.isDirectory&&this.profiles.every(o=>!this.s.extUri.isEqual(o.location,s.resource))).map(s=>this.r.del(s.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const i=this.m.profiles.filter(s=>!this.C(s));await Promise.allSettled(i.map(s=>this.removeProfile(s)))}getProfileForWorkspace(i){const s=this.z(i);return T.URI.isUri(s)?this.m.workspaces.get(s)??this.v.workspaces.get(s):this.m.emptyWindows.get(s)??this.v.emptyWindows.get(s)}z(i){return(0,m.isSingleFolderWorkspaceIdentifier)(i)?i.uri:(0,m.isWorkspaceIdentifier)(i)?i.configPath:i.id}C(i){return!!([...this.m.emptyWindows.values()].some(s=>this.s.extUri.isEqual(s.location,i.location))||[...this.m.workspaces.values()].some(s=>this.s.extUri.isEqual(s.location,i.location))||[...this.v.emptyWindows.values()].some(s=>this.s.extUri.isEqual(s.location,i.location))||[...this.v.workspaces.values()].some(s=>this.s.extUri.isEqual(s.location,i.location)))}D(i,s,o){const c=[...this.profiles,...i],y=[];this.m.profiles=[];for(let w of c)w.isDefault||s.some(f=>w.id===f.id)||(w=o.find(f=>w.id===f.id)??w,w.isTransient?this.m.profiles.push(w):y.push({location:w.location,name:w.name,shortName:w.shortName,useDefaultFlags:w.useDefaultFlags}));this.L(y),this.u=void 0,this.F(i,s,o)}F(i,s,o){this.h.fire({added:i,removed:s,updated:o,all:this.profiles})}G(i,s,o){o=s?.isTransient?!0:o,o||this.G(i,void 0,!0);const c=this.z(i),y=o?this.m:this.v;T.URI.isUri(c)?(y.workspaces.delete(c),s&&y.workspaces.set(c,s)):(y.emptyWindows.delete(c),s&&y.emptyWindows.set(c,s)),o||this.H()}H(){const i={};for(const[o,c]of this.v.workspaces.entries())i[o.toString()]=c.id;const s={};for(const[o,c]of this.v.emptyWindows.entries())s[o.toString()]=c.id;this.N({workspaces:i,emptyWindows:s}),this.u=void 0}I(i){const s={},o=this.w();if(i.workspaces)for(const[y,w]of Object.entries(i.workspaces)){const f=T.URI.parse(w);s[y]=this.s.extUri.isEqual(f,o.location)?o.id:this.s.extUri.basename(f)}const c={};if(i.emptyWindows)for(const[y,w]of Object.entries(i.emptyWindows)){const f=T.URI.parse(w);c[y]=this.s.extUri.isEqual(f,o.location)?o.id:this.s.extUri.basename(f)}return{workspaces:s,emptyWindows:c}}J(){return[]}L(i){throw new Error("not implemented")}M(){return{}}N(i){throw new Error("not implemented")}O(){}};n.b="userDataProfiles",n.c="profileAssociations",e.UserDataProfilesService=n=ve([J(0,I.IEnvironmentService),J(1,v.IFileService),J(2,p.IUriIdentityService),J(3,b.ILogService)],n);class r extends n{constructor(){super(...arguments),this.a=[],this.R={}}J(){return this.a}L(i){this.a=i}M(){return this.R}N(i){this.R=i}}e.InMemoryUserDataProfilesService=r}),define(oe[256],ae([0,1,6,2,18]),function(ie,e,A,N,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesCleaner=void 0;let O=e.UserDataProfilesCleaner=class extends N.Disposable{constructor(k){super(),this.B(new A.RunOnceScheduler(()=>{k.cleanUp()},10*1e3)).schedule()}};e.UserDataProfilesCleaner=O=ve([J(0,l.IUserDataProfilesService)],O)}),define(oe[257],ae([0,1,21,6,26,9,3,2,4,11,12,155,29,33,50,10,25,20,18]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=void 0;let d=e.AbstractExtensionManagementService=class extends k.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(i,s,o,c,y){super(),this.t=i,this.u=s,this.v=o,this.w=c,this.y=y,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new T.Emitter),this.m=this.B(new T.Emitter),this.n=this.B(new T.Emitter),this.p=this.B(new T.Emitter),this.s=[],this.B((0,k.toDisposable)(()=>{this.j.forEach(({task:w})=>w.cancel()),this.k.forEach(w=>w.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(i){const s=await this.getTargetPlatform();return i.allTargetPlatforms.some(o=>(0,m.isTargetPlatformCompatible)(o,i.allTargetPlatforms,s))}async installFromGallery(i,s={}){try{if(!this.t.isEnabled())throw new m.ExtensionManagementError(b.localize(0,null),m.ExtensionManagementErrorCode.Internal);const o=await this.G(i,!!s.installGivenVersion,!!s.installPreReleaseVersion);return await this.z(o.manifest,o.extension,s)}catch(o){throw n(this.u,"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(i),error:o}),this.v.error("Failed to install extension.",i.identifier.id),this.v.error(o),L(o)}}async uninstall(i,s={}){return this.v.trace("ExtensionManagementService#uninstall",i.identifier.id),this.I(i,s)}getExtensionsControlManifest(){const i=new Date().getTime();return(!this.g||i-this.h>1e3*60*5)&&(this.g=this.O(),this.h=i),this.g}registerParticipant(i){this.s.push(i)}async z(i,s,o){const c=o.isApplicationScoped||o.isBuiltin||(0,p.isApplicationScopedExtension)(i),y={...o,installOnlyNewlyAddedFromExtensionPack:R.URI.isUri(s)?o.installOnlyNewlyAddedFromExtensionPack:!0,isApplicationScoped:c,profileLocation:c?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},w=B=>`${g.ExtensionKey.create(B).toString()}${y.profileLocation?`-${y.profileLocation.toString()}`:""}`;if(!R.URI.isUri(s)){const B=this.j.get(w(s));if(B)return this.v.info("Extensions is already requested to install",s.identifier.id),B.task.waitUntilTaskIsFinished()}const f=[],P=[],D=[],M=this.Q(i,s,y);R.URI.isUri(s)||this.j.set(w(s),{task:M,waitingTasks:[]}),this.l.fire({identifier:M.identifier,source:s,profileLocation:y.profileLocation}),this.v.info("Installing extension:",M.identifier.id),f.push({task:M,manifest:i});let j=!1;try{if(y.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",M.identifier.id);else try{const W=await this.F(M.identifier,i,!!y.installOnlyNewlyAddedFromExtensionPack,!!y.installPreReleaseVersion,y.profileLocation),H=await this.getInstalled(void 0,y.profileLocation);for(const{gallery:Q,manifest:_}of(0,A.distinct)(W,({gallery:Y})=>Y.identifier.id)){j=j||!!_.extensionDependencies?.some(z=>(0,g.areSameExtensions)({id:z},M.identifier));const Y=w(Q),$=this.j.get(Y);if($){if(this.C(M,$.task)){const z=$.task.identifier;this.v.info("Waiting for already requested installing extension",z.id,M.identifier.id),$.waitingTasks.push(M),P.push(T.Event.toPromise(T.Event.filter(this.onDidInstallExtensions,x=>x.some(te=>(0,g.areSameExtensions)(te.identifier,z)))).then(x=>{if(this.v.info("Finished waiting for already requested installing extension",z.id,M.identifier.id),!x.find(ne=>(0,g.areSameExtensions)(ne.identifier,z))?.local)throw new Error(`Extension ${z.id} is not installed`)}))}}else if(!H.some(({identifier:z})=>(0,g.areSameExtensions)(z,Q.identifier))){const z=this.Q(_,Q,{...y,donotIncludePackAndDependencies:!0});this.j.set(Y,{task:z,waitingTasks:[M]}),this.l.fire({identifier:z.identifier,source:Q,profileLocation:y.profileLocation}),this.v.info("Installing extension:",z.identifier.id,M.identifier.id),f.push({task:z,manifest:_})}}}catch(W){if(R.URI.isUri(M.source))(0,A.isNonEmptyArray)(i.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",M.identifier.id,W.message),(0,A.isNonEmptyArray)(i.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",M.identifier.id,W.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",M.identifier.id),W}const B=f.reduce((W,{task:H,manifest:Q})=>(W.set(H.identifier.id.toLowerCase(),{task:H,manifest:Q}),W),new Map);for(;B.size;){let W;const H=[...B.values()].filter(({manifest:Q})=>!Q.extensionDependencies?.some(_=>B.has(_.toLowerCase())));H.length?W=B.size===1?H:H.filter(({task:Q})=>!(Q===M&&!j)):(this.v.info("Found extensions with circular dependencies",H.map(({task:Q})=>Q.identifier.id)),W=[...B.values()]),await this.D(W.map(async({task:Q})=>{const _=new Date().getTime();try{const Y=await Q.run();if(await this.D(this.s.map($=>$.postInstall(Y,Q.source,y,l.CancellationToken.None))),!R.URI.isUri(Q.source)){const $=Q.operation===3,z=$?void 0:(new Date().getTime()-Q.source.lastUpdated)/1e3;if(n(this.u,$?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-_,durationSinceUpdate:z}),I.isWeb&&Q.operation!==3)try{await this.t.reportStatistic(Y.manifest.publisher,Y.manifest.name,Y.manifest.version,"install")}catch{}}D.push({local:Y,identifier:Q.identifier,operation:Q.operation,source:Q.source,context:y.context,profileLocation:Q.profileLocation,applicationScoped:Y.isApplicationScoped})}catch(Y){throw R.URI.isUri(Q.source)||n(this.u,Q.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,g.getGalleryExtensionTelemetryData)(Q.source),verificationStatus:Q.verificationStatus,duration:new Date().getTime()-_,error:Y}),this.v.error("Error while installing the extension:",Q.identifier.id),Y}finally{B.delete(Q.identifier.id.toLowerCase())}}))}return P.length&&await this.D(P),D.forEach(({identifier:W})=>this.v.info("Extension installed successfully:",W.id)),this.m.fire(D),D.filter(({identifier:W})=>(0,g.areSameExtensions)(W,M.identifier))[0].local}catch(B){if(f.forEach(({task:W})=>W.cancel()),D.length)try{const W=await Promise.allSettled(D.map(({local:H})=>this.R(H,{versionOnly:!0,profileLocation:y.profileLocation}).run()));for(let H=0;H<W.length;H++){const Q=W[H],{identifier:_}=D[H];Q.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",_.id):this.v.warn("Rollback: Error while uninstalling extension",_.id,(0,O.getErrorMessage)(Q.reason))}}catch(W){this.v.warn("Error while rolling back extensions",(0,O.getErrorMessage)(W),D.map(({identifier:H})=>H.id))}throw this.m.fire(f.map(({task:W})=>({identifier:W.identifier,operation:2,source:W.source,context:y.context,profileLocation:y.profileLocation}))),B}finally{for(const{task:B}of f)B.source&&!R.URI.isUri(B.source)&&this.j.delete(w(B.source))}}C(i,s){for(const[,{task:o,waitingTasks:c}]of this.j.entries())if(o===i&&(c.includes(s)||c.some(y=>this.C(y,s)))||o===s&&c[0]&&!this.C(i,c[0]))return!1;return!0}async D(i){const s=[],o=[],c=await Promise.allSettled(i);for(const y of c)y.status==="fulfilled"?s.push(y.value):o.push(y.reason);if(o.length)throw S(o);return s}async F(i,s,o,c,y){if(!this.t.isEnabled())return[];const w=await this.getInstalled(void 0,y),f=[],P=[],D=async(M,j)=>{f.push(M);const B=j.extensionDependencies||[],W=[...B];if(j.extensionPack){const H=o?w.find(Q=>(0,g.areSameExtensions)(Q.identifier,M)):void 0;for(const Q of j.extensionPack)H&&H.manifest.extensionPack&&H.manifest.extensionPack.some(_=>(0,g.areSameExtensions)({id:_},{id:Q}))||W.every(_=>!(0,g.areSameExtensions)({id:_},{id:Q}))&&W.push(Q)}if(W.length){const H=W.filter(Q=>f.every(_=>!(0,g.areSameExtensions)(_,{id:Q})));if(H.length){const Q=await this.t.getExtensions(H.map(_=>({id:_,preRelease:c})),l.CancellationToken.None);for(const _ of Q){if(f.find(z=>(0,g.areSameExtensions)(z,_.identifier)))continue;const Y=B.some(z=>(0,g.areSameExtensions)({id:z},_.identifier));let $;try{$=await this.G(_,!1,c)}catch(z){if(z instanceof m.ExtensionManagementError&&z.code===m.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!Y){this.v.info("Skipping the packed extension as it cannot be installed",_.identifier.id);continue}else throw z}P.push({gallery:$.extension,manifest:$.manifest}),await D($.extension.identifier,$.manifest)}}}};return await D(i,s),P}async G(i,s,o){if((await this.getExtensionsControlManifest()).malicious.some(f=>(0,g.areSameExtensions)(i.identifier,f)))throw new m.ExtensionManagementError(b.localize(1,null,i.identifier.id),m.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(i)){const f=await this.getTargetPlatform();throw new m.ExtensionManagementError(b.localize(2,null,i.identifier.id,this.w.nameLong,(0,m.TargetPlatformToString)(f)),m.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const y=await this.H(i,s,o);if(y){if(o&&!s&&i.hasPreReleaseVersion&&!y.properties.isPreReleaseVersion)throw new m.ExtensionManagementError(b.localize(3,null,i.identifier.id,this.w.nameLong,this.w.version),m.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&i.properties.isPreReleaseVersion&&(await this.t.getExtensions([i.identifier],l.CancellationToken.None))[0]?new m.ExtensionManagementError(b.localize(4,null,i.identifier.id),m.ExtensionManagementErrorCode.ReleaseVersionNotFound):new m.ExtensionManagementError(b.localize(5,null,i.identifier.id,this.w.nameLong,this.w.version),m.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",y.identifier.id);const w=await this.t.getManifest(y,l.CancellationToken.None);if(w===null)throw new m.ExtensionManagementError(`Missing manifest for extension ${i.identifier.id}`,m.ExtensionManagementErrorCode.Invalid);if(w.version!==y.version)throw new m.ExtensionManagementError(`Cannot install '${i.identifier.id}' extension because of version mismatch in Marketplace`,m.ExtensionManagementErrorCode.Invalid);return{extension:y,manifest:w}}async H(i,s,o){const c=await this.getTargetPlatform();let y=null;return!s&&i.hasPreReleaseVersion&&i.properties.isPreReleaseVersion!==o&&(y=(await this.t.getExtensions([{...i.identifier,preRelease:o}],{targetPlatform:c,compatible:!0},l.CancellationToken.None))[0]||null),!y&&await this.t.isExtensionCompatible(i,o,c)&&(y=i),y||(s?y=(await this.t.getExtensions([{...i.identifier,version:i.version}],{targetPlatform:c,compatible:!0},l.CancellationToken.None))[0]||null:y=await this.t.getCompatibleExtension(i,o,c)),y}async I(i,s){const o={...s,profileLocation:i.isApplicationScoped?this.y.defaultProfile.extensionsResource:s.profileLocation??this.P()},c=M=>`${M.id.toLowerCase()}${o.versionOnly?`-${i.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,y=this.k.get(c(i.identifier));if(y)return this.v.info("Extensions is already requested to uninstall",i.identifier.id),y.waitUntilTaskIsFinished();const w=M=>{const j=this.R(M,o);return this.k.set(c(j.extension.identifier),j),o.profileLocation?this.v.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.v.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this.n.fire({identifier:M.identifier,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped}),j},f=(M,j)=>{j?o.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString(),j.message):this.v.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,j.message):o.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,o.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),n(this.u,"extensionGallery:uninstall",{extensionData:(0,g.getLocalExtensionTelemetryData)(M),error:j}),this.p.fire({identifier:M.identifier,error:j?.code,profileLocation:o.profileLocation,applicationScoped:M.isApplicationScoped})},P=[],D=[];try{P.push(w(i));const M=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${i.identifier.id}@${i.manifest.version}`);else{const j=this.M(i,M);for(const B of j)this.k.has(c(B.identifier))?this.v.info("Extensions is already requested to uninstall",B.identifier.id):P.push(w(B))}o.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${i.identifier.id}@${i.manifest.version}`):this.J(P.map(j=>j.extension),M,i),await this.D(P.map(async j=>{try{if(await j.run(),await this.D(this.s.map(B=>B.postUninstall(j.extension,o,l.CancellationToken.None))),j.extension.identifier.uuid)try{await this.t.reportStatistic(j.extension.manifest.publisher,j.extension.manifest.name,j.extension.manifest.version,"uninstall")}catch{}f(j.extension)}catch(B){const W=B instanceof m.ExtensionManagementError?B:new m.ExtensionManagementError((0,O.getErrorMessage)(B),m.ExtensionManagementErrorCode.Internal);throw f(j.extension,W),W}finally{D.push(j)}}))}catch(M){const j=M instanceof m.ExtensionManagementError?M:new m.ExtensionManagementError((0,O.getErrorMessage)(M),m.ExtensionManagementErrorCode.Internal);for(const B of P){try{B.cancel()}catch{}D.includes(B)||f(B.extension,j)}throw j}finally{for(const M of P)this.k.delete(c(M.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}J(i,s,o){for(const c of i){const y=this.N(c,s);if(y.length){const w=y.filter(f=>!i.some(P=>(0,g.areSameExtensions)(P.identifier,f.identifier)));if(w.length)throw new Error(this.L(c,w,o))}}}L(i,s,o){return o===i?s.length===1?b.localize(6,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?b.localize(7,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):b.localize(8,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?b.localize(9,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?b.localize(10,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):b.localize(11,null,o.manifest.displayName||o.manifest.name,i.manifest.displayName||i.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}M(i,s,o=[]){if(o.indexOf(i)!==-1)return[];o.push(i);const c=i.manifest.extensionPack?i.manifest.extensionPack:[];if(c.length){const y=s.filter(f=>!f.isBuiltin&&c.some(P=>(0,g.areSameExtensions)({id:P},f.identifier))),w=[];for(const f of y)w.push(...this.M(f,s,o));return[...y,...w]}return[]}N(i,s){return s.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(c=>(0,g.areSameExtensions)({id:c},i.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const i=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",i),i}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};e.AbstractExtensionManagementService=d=ve([J(0,m.IExtensionGalleryService),J(1,h.ITelemetryService),J(2,E.ILogService),J(3,a.IProductService),J(4,u.IUserDataProfilesService)],d);function S(t){const i=Array.isArray(t)?t:[t];return i.length===1?i[0]instanceof Error?i[0]:new Error(i[0]):i.reduce((s,o)=>new Error(`${s.message}${s.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=S;function L(t){if(t instanceof m.ExtensionManagementError)return t;const i=new m.ExtensionManagementError(t.message,m.ExtensionManagementErrorCode.Internal);return i.stack=t.stack,i}function n(t,i,{extensionData:s,verificationStatus:o,duration:c,error:y,durationSinceUpdate:w}){let f,P;(0,v.isDefined)(o)&&(o===!0?o="Verified":(o===!1||(f=m.ExtensionManagementErrorCode.Signature,P=o),o="Unverified")),y&&(y instanceof m.ExtensionManagementError?(f=y.code,y.code===m.ExtensionManagementErrorCode.Signature&&(P=y.message)):f=m.ExtensionManagementErrorCode.Internal),t.publicLog(i,{...s,verificationStatus:o,success:!y,duration:c,errorcode:f,errorcodeDetail:P,durationSinceUpdate:w})}class r{constructor(){this.d=new N.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,N.createCancelablePromise)(i=>this.h(i))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,N.createCancelablePromise)(i=>new Promise((s,o)=>{const c=i.onCancellationRequested(()=>{c.dispose(),o(new O.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=r}),define(oe[51],ae([0,1,6,16,2,3,37,12,29,33,13,5,10,18,30,11,9,20]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var u;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(u||(e.ExtensionsProfileScanningErrorCode=u={}));class d extends Error{constructor(t,i){super(t),this.code=i}}e.ExtensionsProfileScanningError=d,e.IExtensionsProfileScannerService=(0,b.createDecorator)("IExtensionsProfileScannerService");let S=e.AbstractExtensionsProfileScannerService=class extends l.Disposable{constructor(t,i,s,o,c,y){super(),this.i=t,this.j=i,this.k=s,this.l=o,this.m=c,this.n=y,this.b=this.B(new O.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new O.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new O.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new O.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new T.ResourceMap}scanProfileExtensions(t,i){return this.p(t,void 0,i)}async addExtensionsToProfile(t,i){const s=[],o=[];try{return await this.p(i,c=>{const y=[];for(const w of c)t.some(([f])=>(0,v.areSameExtensions)(f.identifier,w.identifier)&&f.manifest.version!==w.version)?s.push(w):y.push(w);for(const[w,f]of t)if(!y.some(P=>(0,v.areSameExtensions)(P.identifier,w.identifier)&&P.version===w.manifest.version)){const P={identifier:w.identifier,version:w.manifest.version,location:w.location,metadata:f};o.push(P),y.push(P)}return o.length&&this.b.fire({extensions:o,profileLocation:i}),s.length&&this.f.fire({extensions:s,profileLocation:i}),y}),o.length&&this.c.fire({extensions:o,profileLocation:i}),s.length&&this.g.fire({extensions:s,profileLocation:i}),o}catch(c){throw o.length&&this.c.fire({extensions:o,error:c,profileLocation:i}),s.length&&this.g.fire({extensions:s,error:c,profileLocation:i}),c}}async updateMetadata(t,i){const s=[];return await this.p(i,o=>{const c=[];for(const y of o){const w=t.find(([f])=>(0,v.areSameExtensions)(f.identifier,y.identifier)&&f.manifest.version===y.version);w&&(y.metadata={...y.metadata,...w[1]},s.push(y)),c.push(y)}return c}),s}async removeExtensionFromProfile(t,i){const s=[];this.f.fire({extensions:s,profileLocation:i});try{await this.p(i,o=>{const c=[];for(const y of o)(0,v.areSameExtensions)(y.identifier,t.identifier)?s.push(y):c.push(y);return s.length&&this.f.fire({extensions:s,profileLocation:i}),c}),s.length&&this.g.fire({extensions:s,profileLocation:i})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:i}),o}}async p(t,i,s){return this.w(t).queue(async()=>{let o=[],c;try{const y=await this.j.readFile(t);c=JSON.parse(y.value.toString().trim()||"[]")}catch(y){if((0,R.toFileOperationResult)(y)!==1)throw y;if(this.l.extUri.isEqual(t,this.k.defaultProfile.extensionsResource)&&(c=await this.v()),!c&&s?.bailOutWhenFileNotFound)throw new d((0,a.getErrorMessage)(y),"ERROR_PROFILE_NOT_FOUND")}if(c){Array.isArray(c)||this.r(t);let y=!1;for(const w of c){L(w)||this.r(t);let f;if((0,E.isString)(w.relativeLocation)&&w.relativeLocation)f=this.t(w.relativeLocation);else if((0,E.isString)(w.location))f=this.t(w.location),y=!0,w.relativeLocation=w.location,w.location=f.toJSON();else{f=k.URI.revive(w.location);const P=this.s(f);P&&(y=!0,w.relativeLocation=P)}o.push({identifier:w.identifier,location:f,version:w.version,metadata:w.metadata})}y&&await this.j.writeFile(t,N.VSBuffer.fromString(JSON.stringify(c)))}if(i){o=i(o);const y=o.map(w=>({identifier:w.identifier,version:w.version,location:w.location.toJSON(),relativeLocation:this.s(w.location),metadata:w.metadata}));await this.j.writeFile(t,N.VSBuffer.fromString(JSON.stringify(y)))}return o})}r(t){const i=new d(`Invalid extensions content in ${t.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:i.code}),i}s(t){return this.l.extUri.isEqual(this.l.extUri.dirname(t),this.i)?this.l.extUri.basename(t):void 0}t(t){return this.l.extUri.joinPath(this.i,t)}async v(){return this.u||(this.u=(async()=>{const t=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),i=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let s;try{s=(await this.j.readFile(t)).value.toString()}catch(c){if((0,R.toFileOperationResult)(c)===1)return;throw c}this.n.info("Migrating extensions from old default profile location",t.toString());let o;try{const c=JSON.parse(s);Array.isArray(c)&&c.every(y=>L(y))?o=c:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",c)}catch(c){this.n.error(c)}if(o)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,N.VSBuffer.fromString(JSON.stringify(o)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",t.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(c){if((0,R.toFileOperationResult)(c)===3)this.n.info("Migration from old default profile location to new location is done by another window",t.toString(),this.k.defaultProfile.extensionsResource.toString());else throw c}try{await this.j.del(t)}catch(c){(0,R.toFileOperationResult)(c)!==1&&this.n.error(c)}try{await this.j.del(i)}catch(c){(0,R.toFileOperationResult)(c)!==1&&this.n.error(c)}return o})()),this.u}w(t){let i=this.h.get(t);return i||(i=new A.Queue,this.h.set(t,i)),i}};e.AbstractExtensionsProfileScannerService=S=ve([J(1,R.IFileService),J(2,g.IUserDataProfilesService),J(3,p.IUriIdentityService),J(4,h.ITelemetryService),J(5,m.ILogService)],S);function L(r){return(0,E.isObject)(r)&&(0,I.isIExtensionIdentifier)(r.identifier)&&(n(r.location)||(0,E.isString)(r.location)&&r.location)&&((0,E.isUndefined)(r.relativeLocation)||(0,E.isString)(r.relativeLocation))&&r.version&&(0,E.isString)(r.version)}function n(r){return r?(0,E.isString)(r.path)&&(0,E.isString)(r.scheme):!1}}),define(oe[80],ae([0,1,21,6,31,16,9,35,139,2,24,14,4,22,54,90,11,12,158,15,33,50,68,13,5,10,25,3,91,51,18,30,191]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u,d,S,L,n,r,t,i,s,o,c,y,w,f,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var D;(function(_){function Y($,z){if($===z)return!0;const x=Object.keys($),te=new Set;for(const ne of Object.keys(z))te.add(ne);if(x.length!==te.size)return!1;for(const ne of x){if($[ne]!==z[ne])return!1;te.delete(ne)}return te.size===0}_.equals=Y})(D||(e.Translations=D={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let M=e.AbstractExtensionsScannerService=class extends v.Disposable{constructor(Y,$,z,x,te,ne,re,X,K,F,C,U){super(),this.systemExtensionsLocation=Y,this.userExtensionsLocation=$,this.l=z,this.m=x,this.n=te,this.r=ne,this.s=re,this.t=X,this.u=K,this.v=F,this.w=C,this.y=U,this.g=this.B(new o.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,g.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.y.createInstance(W,this.m,this.h)),this.j=this.B(this.y.createInstance(W,this.m,this.h)),this.k=this.B(this.y.createInstance(B,this.h)),this.C=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.z||(this.z=(0,S.computeTargetPlatform)(this.s,this.t)),this.z}async scanAllExtensions(Y,$,z){const[x,te]=await Promise.all([this.scanSystemExtensions(Y),this.scanUserExtensions($)]),ne=z?await this.scanExtensionsUnderDevelopment(Y,[...x,...te]):[];return this.G(x,te,ne,await this.getTargetPlatform(),!0)}async scanSystemExtensions(Y){const $=[];$.push(this.H(!!Y.useCache,Y.language)),$.push(this.I(Y.language,!!Y.checkControlFile));const[z,x]=await Promise.all($);return this.F([...z,...x],0,Y,!1)}async scanUserExtensions(Y){const $=Y.profileLocation??this.userExtensionsLocation;this.t.trace("Started scanning user extensions",$);const z=this.w.extUri.isEqual(Y.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,x=await this.L($,!!Y.profileLocation,1,!Y.includeUninstalled,Y.language,!0,z),te=Y.useCache&&!x.devMode&&x.excludeObsolete?this.j:this.k;let ne;try{ne=await te.scanExtensions(x)}catch(re){if(re instanceof y.ExtensionsProfileScanningError&&re.code==="ERROR_PROFILE_NOT_FOUND")await this.D(),ne=await te.scanExtensions(x);else throw re}return ne=await this.F(ne,1,Y,!0),this.t.trace("Scanned user extensions:",ne.length),ne}async scanExtensionsUnderDevelopment(Y,$){if(this.u.isExtensionDevelopment&&this.u.extensionDevelopmentLocationURI){const z=(await Promise.all(this.u.extensionDevelopmentLocationURI.filter(x=>x.scheme===R.Schemas.file).map(async x=>{const te=await this.L(x,!1,1,!0,Y.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(te)).map(re=>(re.type=$.find(X=>(0,S.areSameExtensions)(X.identifier,re.identifier))?.type??re.type,this.k.validate(re,te)))}))).flat();return this.F(z,"development",Y,!0)}return[]}async scanExistingExtension(Y,$,z){const x=await this.L(Y,!1,$,!0,z.language,!0,void 0),te=await this.k.scanExtension(x);return!te||!z.includeInvalid&&!te.isValid?null:te}async scanOneOrMultipleExtensions(Y,$,z){const x=await this.L(Y,!1,$,!0,z.language,!0,void 0),te=await this.k.scanOneOrMultipleExtensions(x);return this.F(te,$,z,!0)}async scanMetadata(Y){const $=(0,g.joinPath)(Y,"package.json"),z=(await this.s.readFile($)).value.toString();return JSON.parse(z).__metadata}async updateMetadata(Y,$){const z=(0,g.joinPath)(Y,"package.json"),x=(await this.s.readFile(z)).value.toString(),te=JSON.parse(x);$.isMachineScoped=$.isMachineScoped||void 0,$.isBuiltin=$.isBuiltin||void 0,te.__metadata={...te.__metadata,...$},await this.s.writeFile((0,g.joinPath)(Y,"package.json"),O.VSBuffer.fromString(JSON.stringify(te,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.r.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(Y){if(Y instanceof y.ExtensionsProfileScanningError&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.D();else throw Y}}async D(){return this.C||(this.C=(async()=>{try{this.t.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const Y=await this.scanUserExtensions({includeInvalid:!0});if(Y.length)await this.r.addExtensionsToProfile(Y.map($=>[$,$.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.s.createFile(this.n.defaultProfile.extensionsResource,O.VSBuffer.fromString(JSON.stringify([])))}catch($){(0,r.toFileOperationResult)($)!==1&&this.t.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,T.getErrorMessage)($))}this.t.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(Y){this.t.error(Y)}finally{this.C=void 0}})()),this.C}async F(Y,$,z,x){return z.includeAllVersions||(Y=this.G($===0?Y:void 0,$===1?Y:void 0,$==="development"?Y:void 0,await this.getTargetPlatform(),x)),z.includeInvalid||(Y=Y.filter(te=>te.isValid)),Y.sort((te,ne)=>{const re=b.basename(te.location.fsPath),X=b.basename(ne.location.fsPath);return re<X?-1:re>X?1:0})}G(Y,$,z,x,te){const ne=(X,K,F)=>{if(X.isValid&&!K.isValid)return!1;if(X.isValid===K.isValid){if(te&&p.gt(X.manifest.version,K.manifest.version))return this.t.debug(`Skipping extension ${K.location.path} with lower version ${K.manifest.version} in favour of ${X.location.path} with version ${X.manifest.version}`),!1;if(p.eq(X.manifest.version,K.manifest.version)){if(X.type===0)return this.t.debug(`Skipping extension ${K.location.path} in favour of system extension ${X.location.path} with same version`),!1;if(X.targetPlatform===x)return this.t.debug(`Skipping extension ${K.location.path} from different target platform ${K.targetPlatform}`),!1}}return F?this.t.warn(`Overwriting user extension ${X.location.path} with ${K.location.path}.`):this.t.debug(`Overwriting user extension ${X.location.path} with ${K.location.path}.`),!0},re=new L.ExtensionIdentifierMap;return Y?.forEach(X=>{const K=re.get(X.identifier.id);(!K||ne(K,X,!1))&&re.set(X.identifier.id,X)}),$?.forEach(X=>{const K=re.get(X.identifier.id);if(!K&&Y&&X.type===0){this.t.debug(`Skipping obsolete system extension ${X.location.path}.`);return}(!K||ne(K,X,!1))&&re.set(X.identifier.id,X)}),z?.forEach(X=>{const K=re.get(X.identifier.id);(!K||ne(K,X,!0))&&re.set(X.identifier.id,X),re.set(X.identifier.id,X)}),[...re.values()]}async H(Y,$){this.t.trace("Started scanning system extensions");const z=await this.L(this.systemExtensionsLocation,!1,0,!0,$,!0,void 0),te=await(Y&&!z.devMode?this.i:this.k).scanExtensions(z);return this.t.trace("Scanned system extensions:",te.length),te}async I(Y,$){const z=this.u.isBuilt?[]:this.v.builtInExtensions;if(!z?.length)return[];this.t.trace("Started scanning dev system extensions");const x=$?await this.J():{},te=[],ne=h.URI.file(b.normalize(b.join(R.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const X of z){const K=x[X.name]||"marketplace";switch(K){case"disabled":break;case"marketplace":te.push((0,g.joinPath)(ne,X.name));break;default:te.push(h.URI.file(K));break}}const re=await Promise.all(te.map(async X=>this.k.scanExtension(await this.L(X,!1,0,!0,Y,!0,void 0))));return this.t.trace("Scanned dev system extensions:",re.length),(0,A.coalesce)(re)}async J(){try{const Y=await this.s.readFile(this.l);return JSON.parse(Y.value.toString())}catch{return{}}}async L(Y,$,z,x,te,ne,re){const X=await this.f(te??m.language),K=await this.M(Y),F=$&&!this.w.extUri.isEqual(Y,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,C=F?await this.M(F):void 0;return new j(Y,K,F,C,$,re,z,x,ne,this.v.version,this.v.date,this.v.commit,!this.u.isBuilt,te,X)}async M(Y){try{const $=await this.s.stat(Y);if(typeof $.mtime=="number")return $.mtime}catch{}}};e.AbstractExtensionsScannerService=M=ve([J(4,w.IUserDataProfilesService),J(5,y.IExtensionsProfileScannerService),J(6,r.IFileService),J(7,i.ILogService),J(8,d.IEnvironmentService),J(9,s.IProductService),J(10,f.IUriIdentityService),J(11,t.IInstantiationService)],M);class j{constructor(Y,$,z,x,te,ne,re,X,K,F,C,U,q,G,V){this.location=Y,this.mtime=$,this.applicationExtensionslocation=z,this.applicationExtensionslocationMtime=x,this.profile=te,this.profileScanOptions=ne,this.type=re,this.excludeObsolete=X,this.validate=K,this.productVersion=F,this.productDate=C,this.productCommit=U,this.devMode=q,this.language=G,this.translations=V}static createNlsConfiguration(Y){return{language:Y.language,pseudo:Y.language==="pseudo",devMode:Y.devMode,translations:Y.translations}}static equals(Y,$){return(0,g.isEqual)(Y.location,$.location)&&Y.mtime===$.mtime&&(0,g.isEqual)(Y.applicationExtensionslocation,$.applicationExtensionslocation)&&Y.applicationExtensionslocationMtime===$.applicationExtensionslocationMtime&&Y.profile===$.profile&&l.equals(Y.profileScanOptions,$.profileScanOptions)&&Y.type===$.type&&Y.excludeObsolete===$.excludeObsolete&&Y.validate===$.validate&&Y.productVersion===$.productVersion&&Y.productDate===$.productDate&&Y.productCommit===$.productCommit&&Y.devMode===$.devMode&&Y.language===$.language&&D.equals(Y.translations,$.translations)}}e.ExtensionScannerInput=j;let B=class extends v.Disposable{constructor(Y,$,z,x,te){super(),this.f=Y,this.g=$,this.h=z,this.i=x,this.j=te}async scanExtensions(Y){const $=Y.profile?await this.l(Y):await this.k(Y);let z={};if(Y.excludeObsolete&&Y.type===1)try{const x=(await this.i.readFile(this.f)).value.toString();z=JSON.parse(x)}catch{}return(0,a.isEmptyObject)(z)?$:$.filter(x=>!z[S.ExtensionKey.create(x).toString()])}async k(Y){const $=await this.i.resolve(Y.location);if(!$.children?.length)return[];const z=await Promise.all($.children.map(async x=>{if(!x.isDirectory||Y.type===1&&(0,g.basename)(x.resource).indexOf(".")===0)return null;const te=new j(x.resource,Y.mtime,Y.applicationExtensionslocation,Y.applicationExtensionslocationMtime,Y.profile,Y.profileScanOptions,Y.type,Y.excludeObsolete,Y.validate,Y.productVersion,Y.productDate,Y.productCommit,Y.devMode,Y.language,Y.translations);return this.scanExtension(te)}));return(0,A.coalesce)(z).sort((x,te)=>x.location.path<te.location.path?-1:1)}async l(Y){let $=await this.m(Y.location,()=>!0,Y);if(Y.applicationExtensionslocation&&!this.h.extUri.isEqual(Y.location,Y.applicationExtensionslocation)){$=$.filter(x=>!x.metadata?.isApplicationScoped);const z=await this.m(Y.applicationExtensionslocation,x=>!!x.metadata?.isBuiltin||!!x.metadata?.isApplicationScoped,Y);$.push(...z)}return $}async m(Y,$,z){const x=await this.g.scanProfileExtensions(Y,z.profileScanOptions);if(!x.length)return[];const te=await Promise.all(x.map(async ne=>{if($(ne)){const re=new j(ne.location,z.mtime,z.applicationExtensionslocation,z.applicationExtensionslocationMtime,z.profile,z.profileScanOptions,z.type,z.excludeObsolete,z.validate,z.productVersion,z.productDate,z.productCommit,z.devMode,z.language,z.translations);return this.scanExtension(re,ne.metadata)}return null}));return(0,A.coalesce)(te)}async scanOneOrMultipleExtensions(Y){try{if(await this.i.exists((0,g.joinPath)(Y.location,"package.json"))){const $=await this.scanExtension(Y);return $?[$]:[]}else return await this.scanExtensions(Y)}catch($){return this.j.error(`Error scanning extensions at ${Y.location.path}:`,(0,T.getErrorMessage)($)),[]}}async scanExtension(Y,$){try{let z=await this.scanExtensionManifest(Y.location);if(z){z.publisher||(z.publisher=L.UNDEFINED_PUBLISHER),$=$??z.__metadata,delete z.__metadata;const x=(0,S.getGalleryExtensionId)(z.publisher,z.name),te=$?.id?{id:x,uuid:$.id}:{id:x},ne=$?.isSystem?0:Y.type,re=ne===0||!!$?.isBuiltin;z=await this.n(Y.location,z,j.createNlsConfiguration(Y));const X={type:ne,identifier:te,manifest:z,location:Y.location,isBuiltin:re,targetPlatform:$?.targetPlatform??"undefined",metadata:$,isValid:!0,validations:[]};return Y.validate?this.validate(X,Y):X}}catch(z){Y.type!==0&&this.j.error(z)}return null}validate(Y,$){let z=!0;const x=(0,n.validateExtensionManifest)($.productVersion,$.productDate,$.location,Y.manifest,Y.isBuiltin);for(const[te,ne]of x)te===E.default.Error&&(z=!1,this.j.error(this.u($.location,ne)));return Y.isValid=z,Y.validations=x,Y}async scanExtensionManifest(Y){const $=(0,g.joinPath)(Y,"package.json");let z;try{z=(await this.i.readFile($)).value.toString()}catch(te){return(0,r.toFileOperationResult)(te)!==1&&this.j.error(this.u(Y,(0,u.localize)(0,null,$.path,te.message))),null}let x;try{x=JSON.parse(z)}catch{const ne=[];(0,k.parse)(z,ne);for(const re of ne)this.j.error(this.u(Y,(0,u.localize)(1,null,$.path,re.offset,re.length,(0,I.getParseErrorMessage)(re.error))));return null}return(0,k.getNodeType)(x)!=="object"?(this.j.error(this.u(Y,(0,u.localize)(2,null,$.path))),null):x}async n(Y,$,z){const x=await this.r(Y,$,z);if(x)try{const te=[],ne=await this.s(x.default,te);if(te.length>0)return te.forEach(X=>{this.j.error(this.u(Y,(0,u.localize)(3,null,x.default?.path,(0,I.getParseErrorMessage)(X.error))))}),$;if((0,k.getNodeType)(x)!=="object")return this.j.error(this.u(Y,(0,u.localize)(4,null,x.default?.path))),$;const re=x.values||Object.create(null);return(0,P.localizeManifest)($,re,ne)}catch{}return $}async r(Y,$,z){const x=(0,g.joinPath)(Y,"package.nls.json"),te=(K,F)=>{F.forEach(C=>{this.j.error(this.u(Y,(0,u.localize)(5,null,K?.path,(0,I.getParseErrorMessage)(C.error))))})},ne=K=>{this.j.error(this.u(Y,(0,u.localize)(6,null,K?.path)))},re=`${$.publisher}.${$.name}`,X=z.translations[re];if(X)try{const K=h.URI.file(X),F=(await this.i.readFile(K)).value.toString(),C=[],U=(0,k.parse)(F,C);return C.length>0?(te(K,C),{values:void 0,default:x}):(0,k.getNodeType)(U)!=="object"?(ne(K),{values:void 0,default:x}):{values:U.contents?U.contents.package:void 0,default:x}}catch{return{values:void 0,default:x}}else{if(!await this.i.exists(x))return;let F;try{F=await this.t(Y,z)}catch{return}if(!F.localized)return{values:void 0,default:F.original};try{const C=(await this.i.readFile(F.localized)).value.toString(),U=[],q=(0,k.parse)(C,U);return U.length>0?(te(F.localized,U),{values:void 0,default:F.original}):(0,k.getNodeType)(q)!=="object"?(ne(F.localized),{values:void 0,default:F.original}):{values:q,default:F.original}}catch{return{values:void 0,default:F.original}}}}async s(Y,$){if(Y)try{const z=(await this.i.readFile(Y)).value.toString();return(0,k.parse)(z,$)}catch{}}t(Y,$){return new Promise((z,x)=>{const te=ne=>{const re=(0,g.joinPath)(Y,`package.nls.${ne}.json`);this.i.exists(re).then(X=>{X&&z({localized:re,original:(0,g.joinPath)(Y,"package.nls.json")});const K=ne.lastIndexOf("-");K===-1?z({localized:(0,g.joinPath)(Y,"package.nls.json"),original:null}):(ne=ne.substring(0,K),te(ne))})};if($.devMode||$.pseudo||!$.language)return z({localized:(0,g.joinPath)(Y,"package.nls.json"),original:null});te($.language)})}u(Y,$){return`[${Y.path}]: ${$}`}};B=ve([J(1,y.IExtensionsProfileScannerService),J(2,f.IUriIdentityService),J(3,r.IFileService),J(4,i.ILogService)],B);let W=class extends B{constructor(Y,$,z,x,te,ne,re){super($,x,te,ne,re),this.z=Y,this.C=z,this.w=this.B(new N.ThrottledDelayer(3e3)),this.y=this.B(new o.Emitter),this.onDidChangeCache=this.y.event}async scanExtensions(Y){const $=this.H(Y),z=await this.D($);if(this.v=Y,z&&z.input&&j.equals(z.input,this.v))return this.j.debug("Using cached extensions scan result",Y.location.toString()),this.w.trigger(()=>this.G()),z.result.map(te=>(te.location=h.URI.revive(te.location),te));const x=await super.scanExtensions(Y);return await this.F($,{input:Y,result:x}),x}async D(Y){try{const $=await this.i.readFile(Y),z=JSON.parse($.value.toString());return{result:z.result,input:(0,c.revive)(z.input)}}catch($){this.j.debug("Error while reading the extension cache file:",Y.path,(0,T.getErrorMessage)($))}return null}async F(Y,$){try{await this.i.writeFile(Y,O.VSBuffer.fromString(JSON.stringify($)))}catch(z){this.j.debug("Error while writing the extension cache file:",Y.path,(0,T.getErrorMessage)(z))}}async G(){if(!this.v)return;const Y=this.H(this.v),$=await this.D(Y);if(!$)return;const z=$.result,x=JSON.parse(JSON.stringify(await super.scanExtensions(this.v)));if(!l.equals(x,z))try{this.j.info("Invalidating Cache",z,x),await this.i.del(Y),this.y.fire()}catch(te){this.j.error(te)}}H(Y){const $=this.I(Y);return this.h.extUri.joinPath($.cacheHome,Y.type===0?L.BUILTIN_MANIFEST_CACHE_FILE:L.USER_MANIFEST_CACHE_FILE)}I(Y){return Y.type===0?this.C.defaultProfile:Y.profile?this.h.extUri.isEqual(Y.location,this.z.extensionsResource)?this.z:this.C.profiles.find($=>this.h.extUri.isEqual(Y.location,$.extensionsResource))??this.z:this.C.defaultProfile}};W=ve([J(2,w.IUserDataProfilesService),J(3,y.IExtensionsProfileScannerService),J(4,f.IUriIdentityService),J(5,r.IFileService),J(6,i.ILogService)],W);function H(_,Y){const $=(0,S.getExtensionId)(_.manifest.publisher,_.manifest.name);return{id:$,identifier:new L.ExtensionIdentifier($),isBuiltin:_.type===0,isUserBuiltin:_.type===1&&_.isBuiltin,isUnderDevelopment:Y,extensionLocation:_.location,uuid:_.identifier.uuid,targetPlatform:_.targetPlatform,..._.manifest}}e.toExtensionDescription=H;class Q extends M{constructor(Y,$,z,x,te,ne,re,X,K,F,C,U){super(Y,$,(0,g.joinPath)(z,".vscode-oss-dev","extensions","control.json"),x,te,ne,re,X,K,F,C,U),this.N=(async()=>{if(m.translationsConfigFile)try{const q=await this.s.readFile(h.URI.file(m.translationsConfigFile));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}f(Y){return this.N}}e.NativeExtensionsScannerService=Q}),define(oe[258],ae([0,1,49,6,38,3,2,24,14,28,10,18]),function(ie,e,A,N,l,O,T,k,I,v,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let m=e.ExtensionsLifecycle=class extends T.Disposable{constructor(p,E){super(),this.b=p,this.f=E,this.a=new N.Limiter(5)}async postUninstall(p){const E=this.g(p,"uninstall");E&&(this.f.info(p.identifier.id,p.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(E.script,"uninstall",E.args,!0,p),this.f.info("Finished running post uninstall script",p.identifier.id,p.manifest.version)}catch(a){this.f.error("Failed to run post uninstall script",p.identifier.id,p.manifest.version),this.f.error(a)}}));try{await v.Promises.rm(this.j(p))}catch(a){this.f.error("Error while removing extension storage path",p.identifier.id),this.f.error(a)}}g(p,E){const a=`vscode:${E}`;if(p.location.scheme===k.Schemas.file&&p.manifest&&p.manifest.scripts&&typeof p.manifest.scripts[a]=="string"){const h=p.manifest.scripts[a].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(p.identifier.id,p.manifest.version,`${a} should be a node script`),null):{script:(0,I.join)(p.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(p,E,a,h,u){return new Promise((d,S)=>{const L=this.i(p,E,a,u);let n;const r=t=>{n&&(clearTimeout(n),n=null),t?S(t):d(void 0)};L.on("error",t=>{r((0,l.toErrorMessage)(t)||"Unknown")}),L.on("exit",(t,i)=>{r(t?`post-${E} process exited with code ${t}`:void 0)}),h&&(n=setTimeout(()=>{n=null,L.kill(),S("timed out")},5e3))})}i(p,E,a,h){const u={silent:!0,execArgv:void 0},d=(0,A.fork)(p,[`--type=extension-post-${E}`,...a],u);d.stdout.setEncoding("utf8"),d.stderr.setEncoding("utf8");const S=O.Event.fromNodeEventEmitter(d.stdout,"data"),L=O.Event.fromNodeEventEmitter(d.stderr,"data");S(t=>this.f.info(h.identifier.id,h.manifest.version,`post-${E}`,t)),L(t=>this.f.error(h.identifier.id,h.manifest.version,`post-${E}`,t));const n=O.Event.any(O.Event.map(S,t=>({data:`%c${t}`,format:[""]})),O.Event.map(L,t=>({data:`%c${t}`,format:["color: red"]})));return O.Event.debounce(n,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(h.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),d}j(p){return(0,I.join)(this.b.defaultProfile.globalStorageHome.fsPath,p.identifier.id.toLowerCase())}};e.ExtensionsLifecycle=m=ve([J(0,b.IUserDataProfilesService),J(1,R.ILogService)],m)}),define(oe[259],ae([0,1,10,18,30,20,51,13,15,12]),function(ie,e,A,N,l,O,T,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let R=e.ExtensionsProfileScannerService=class extends T.AbstractExtensionsProfileScannerService{constructor(m,g,p,E,a,h){super(v.URI.file(m.extensionsPath),g,p,E,a,h)}};e.ExtensionsProfileScannerService=R=ve([J(0,I.INativeEnvironmentService),J(1,k.IFileService),J(2,N.IUserDataProfilesService),J(3,l.IUriIdentityService),J(4,O.ITelemetryService),J(5,A.ILogService)],R)}),define(oe[260],ae([0,1,12,15,51,80,13,5,10,25,30,18]),function(ie,e,A,N,l,O,T,k,I,v,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let m=e.ExtensionsScannerService=class extends O.NativeExtensionsScannerService{constructor(p,E,a,h,u,d,S,L){super(A.URI.file(u.builtinExtensionsPath),A.URI.file(u.extensionsPath),u.userHome,p.defaultProfile,p,E,a,h,u,d,S,L)}};e.ExtensionsScannerService=m=ve([J(0,b.IUserDataProfilesService),J(1,l.IExtensionsProfileScannerService),J(2,T.IFileService),J(3,I.ILogService),J(4,N.INativeEnvironmentService),J(5,v.IProductService),J(6,R.IUriIdentityService),J(7,k.IInstantiationService)],m)}),define(oe[19],ae([0,1,6,3,2,103,11,67,5,18]),function(ie,e,A,N,l,O,T,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,I.createDecorator)("storageService");var R;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(R||(e.WillSaveStateReason=R={}));var b;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var m;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(m||(e.StorageTarget=m={}));function g(u){const d=u.get(e.TARGET_KEY);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}e.loadKeyTargets=g;class p extends l.Disposable{constructor(d={flushInterval:p.a}){super(),this.j=d,this.b=this.B(new N.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new N.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new A.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new l.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,A.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,l.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.J()}finally{(0,O.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(d,S){if(S===e.TARGET_KEY){switch(d){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:d})}else this.b.fire({scope:d,key:S,target:this.F(d)[S]})}r(d){this.f.fire({reason:d})}get(d,S,L){return this.L(S)?.get(d,L)}getBoolean(d,S,L){return this.L(S)?.getBoolean(d,L)}getNumber(d,S,L){return this.L(S)?.getNumber(d,L)}store(d,S,L,n){if((0,T.isUndefinedOrNull)(S)){this.remove(d,L);return}this.t(()=>{this.u(d,L,n),this.L(L)?.set(d,S)})}remove(d,S){this.t(()=>{this.u(d,S,void 0),this.L(S)?.delete(d)})}t(d){this.b.pause(),this.c.pause();try{d()}finally{this.b.resume(),this.c.resume()}}keys(d,S){const L=[],n=this.F(d);for(const r of Object.keys(n))n[r]===S&&L.push(r);return L}u(d,S,L){const n=this.F(S);typeof L=="number"?n[d]!==L&&(n[d]=L,this.L(S)?.set(e.TARGET_KEY,JSON.stringify(n))):typeof n[d]=="number"&&(delete n[d],this.L(S)?.set(e.TARGET_KEY,JSON.stringify(n)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(d){switch(d){case-1:return this.D;case 0:return this.z;default:return this.w}}G(d){const S=this.L(d);return S?g(S):Object.create(null)}isNew(d){return this.getBoolean(e.IS_NEW_KEY,d)===!0}async flush(d=R.NONE){this.f.fire({reason:d});const S=this.L(-1),L=this.L(0),n=this.L(1);switch(d){case R.NONE:await A.Promises.settled([S?.whenFlushed()??Promise.resolve(),L?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case R.SHUTDOWN:await A.Promises.settled([S?.flush(0)??Promise.resolve(),L?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const d=this.L(-1)?.items??new Map,S=this.L(0)?.items??new Map,L=this.L(1)?.items??new Map;return h(d,S,L,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(d,S){return this.r(R.NONE),(0,v.isUserDataProfile)(d)?this.N(d,S):this.O(d,S)}H(d,S){return!(d.id===S.id||E(S)&&E(d))}I(d,S,L,n){this.t(()=>{if(n)for(const[r,t]of d)S.set(r,t);else{const r=new Set;for(const[t,i]of d)r.add(t),S.get(t)!==i&&this.n(L,t);for(const[t]of S.items)r.has(t)||this.n(L,t)}})}}e.AbstractStorageService=p,p.a=60*1e3;function E(u){return u.isDefault||!!u.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=E;class a extends p{constructor(){super(),this.p=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new k.Storage(new k.InMemoryStorageDatabase,{hint:k.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(d=>this.n(1,d))),this.B(this.P.onDidChangeStorage(d=>this.n(0,d))),this.B(this.p.onDidChangeStorage(d=>this.n(-1,d)))}L(d){switch(d){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(d){switch(d){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(d){return!1}}e.InMemoryStorageService=a;async function h(u,d,S,L,n,r){const t=D=>{try{return JSON.parse(D)}catch{return D}},i=new Map,s=new Map;u.forEach((D,M)=>{i.set(M,D),s.set(M,t(D))});const o=new Map,c=new Map;d.forEach((D,M)=>{o.set(M,D),c.set(M,t(D))});const y=new Map,w=new Map;S.forEach((D,M)=>{y.set(M,D),w.set(M,t(D))}),console.group(L!==n?`Storage: Application (path: ${L})`:`Storage: Application & Profile (path: ${L}, default profile)`);const f=[];if(i.forEach((D,M)=>{f.push({key:M,value:D})}),console.table(f),console.groupEnd(),console.log(s),L!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const D=[];o.forEach((M,j)=>{D.push({key:j,value:M})}),console.table(D),console.groupEnd(),console.log(c)}console.group(`Storage: Workspace (path: ${r})`);const P=[];y.forEach((D,M)=>{P.push({key:M,value:D})}),console.table(P),console.groupEnd(),console.log(w)}e.logStorage=h}),define(oe[118],ae([0,1,3,2,11,29,33,19]),function(ie,e,A,N,l,O,T,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let I=e.GlobalExtensionEnablementService=class extends N.Disposable{constructor(b,m){super(),this.a=new A.Emitter,this.onDidChangeEnablement=this.a.event,this.b=this.B(new v(b)),this.B(this.b.onDidChange(g=>this.a.fire({extensions:g,source:"storage"}))),this.B(m.onDidInstallExtensions(g=>g.forEach(({local:p,operation:E})=>{p&&E===4&&this.f(p.identifier)})))}async enableExtension(b,m){return this.f(b)?(this.a.fire({extensions:[b],source:m}),!0):!1}async disableExtension(b,m){return this.c(b)?(this.a.fire({extensions:[b],source:m}),!0):!1}getDisabledExtensions(){return this.h(O.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}c(b){const m=this.getDisabledExtensions();return m.every(g=>!(0,T.areSameExtensions)(g,b))?(m.push(b),this.g(m),!0):!1}f(b){const m=this.getDisabledExtensions();for(let g=0;g<m.length;g++){const p=m[g];if((0,T.areSameExtensions)(p,b))return m.splice(g,1),this.g(m),!0}return!1}g(b){this.i(O.DISABLED_EXTENSIONS_STORAGE_PATH,b)}h(b){return this.b.get(b,0)}i(b,m){this.b.set(b,m,0)}};e.GlobalExtensionEnablementService=I=ve([J(0,k.IStorageService),J(1,O.IExtensionManagementService)],I);class v extends N.Disposable{constructor(b){super(),this.c=b,this.a=Object.create(null),this.b=this.B(new A.Emitter),this.onDidChange=this.b.event,this.B(b.onDidChangeValue(m=>this.f(m)))}get(b,m){let g;return m===0?((0,l.isUndefinedOrNull)(this.a[b])&&(this.a[b]=this.g(b,m)),g=this.a[b]):g=this.g(b,m),JSON.parse(g)}set(b,m,g){const p=JSON.stringify(m.map(({id:a,uuid:h})=>({id:a,uuid:h})));this.g(b,g)!==p&&(g===0&&(m.length?this.a[b]=p:delete this.a[b]),this.h(b,m.length?p:void 0,g))}f(b){if(b.scope===0&&!(0,l.isUndefinedOrNull)(this.a[b.key])&&this.g(b.key,b.scope)!==this.a[b.key]){const g=this.get(b.key,b.scope);delete this.a[b.key];const p=this.get(b.key,b.scope),E=g.filter(h=>!p.some(u=>(0,T.areSameExtensions)(h,u))),a=p.filter(h=>!g.some(u=>(0,T.areSameExtensions)(u,h)));(E.length||a.length)&&this.b.fire([...E,...a])}}g(b,m){return this.c.get(b,m,"[]")}h(b,m,g){m?this.c.store(b,m,g,1):this.c.remove(b,g)}}e.StorageManager=v}),define(oe[261],ae([0,1,21,26,9,4,36,11,12,17,15,29,33,68,13,10,25,58,230,19,20]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const L=O.isWeb?"web":(0,b.getTargetPlatform)(O.platform,T.arch),n="X-Market-Search-Activity-Id";var r;(function(F){F[F.None=0]="None",F[F.IncludeVersions=1]="IncludeVersions",F[F.IncludeFiles=2]="IncludeFiles",F[F.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",F[F.IncludeSharedAccounts=8]="IncludeSharedAccounts",F[F.IncludeVersionProperties=16]="IncludeVersionProperties",F[F.ExcludeNonValidated=32]="ExcludeNonValidated",F[F.IncludeInstallationTargets=64]="IncludeInstallationTargets",F[F.IncludeAssetUri=128]="IncludeAssetUri",F[F.IncludeStatistics=256]="IncludeStatistics",F[F.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",F[F.Unpublished=4096]="Unpublished",F[F.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function t(...F){return String(F.reduce((C,U)=>C|U,0))}var i;(function(F){F[F.Tag=1]="Tag",F[F.ExtensionId=4]="ExtensionId",F[F.Category=5]="Category",F[F.ExtensionName=7]="ExtensionName",F[F.Target=8]="Target",F[F.Featured=9]="Featured",F[F.SearchText=10]="SearchText",F[F.ExcludeWithFlags=12]="ExcludeWithFlags"})(i||(i={}));const s={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},y={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class w{constructor(C=y){this.d=C}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(C,U=this.d.pageSize){return new w({...this.d,pageNumber:C,pageSize:U})}withFilter(C,...U){const q=[...this.d.criteria,...U.length?U.map(G=>({filterType:C,value:G})):[{filterType:C}]];return new w({...this.d,criteria:q})}withSortBy(C){return new w({...this.d,sortBy:C})}withSortOrder(C){return new w({...this.d,sortOrder:C})}withFlags(...C){return new w({...this.d,flags:C.reduce((U,q)=>U|q,0)})}withAssetTypes(...C){return new w({...this.d,assetTypes:C})}withSource(C){return new w({...this.d,source:C})}get raw(){const{criteria:C,pageNumber:U,pageSize:q,sortBy:G,sortOrder:V,flags:Z,assetTypes:ee}=this.d;return{filters:[{criteria:C,pageNumber:U,pageSize:q,sortBy:G,sortOrder:V}],assetTypes:ee,flags:Z}}get searchText(){const C=this.d.criteria.filter(U=>U.filterType===i.SearchText)[0];return C&&C.value?C.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(C=>String(C.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function f(F,C){const U=(F||[]).filter(q=>q.statisticName===C)[0];return U?U.value:0}function P(F){const C="Microsoft.VisualStudio.Code.Translation.";return F.files.filter(q=>q.assetType.indexOf(C)===0).reduce((q,G)=>{const V=j(F,G.assetType);return V&&q.push([G.assetType.substring(C.length),V]),q},[])}function D(F){if(F.properties){const C=F.properties.filter(G=>G.key===s.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),q=C.filter(G=>U.test(G.value))[0];return q?{uri:q.value,fallbackUri:q.value}:null}return j(F,s.Repository)}function M(F){return{uri:`${F.fallbackAssetUri}/${s.VSIX}?redirect=true${F.targetPlatform?`&targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${s.VSIX}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}}function j(F,C){return F.files.filter(q=>q.assetType===C)[0]?{uri:`${F.assetUri}/${C}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`,fallbackUri:`${F.fallbackAssetUri}/${C}${F.targetPlatform?`?targetPlatform=${F.targetPlatform}`:""}`}:null}function B(F,C){const U=F.properties?F.properties.filter(G=>G.key===C):[],q=U.length>0&&U[0].value;return q?q.split(",").map(G=>(0,m.adoptToGalleryExtensionId)(G)):[]}function W(F){const C=F.properties?F.properties.filter(U=>U.key===o.Engine):[];return C.length>0&&C[0].value||""}function H(F){const C=F.properties?F.properties.filter(U=>U.key===o.PreRelease):[];return C.length>0&&C[0].value==="true"}function Q(F){const C=F.properties?F.properties.filter(q=>q.key===o.LocalizedLanguages):[],U=C.length>0&&C[0].value||"";return U?U.split(","):[]}function _(F){return F.properties?.find(C=>C.key===o.SponsorLink)?.value}function Y(F){return F.indexOf("preview")!==-1}function $(F){return F.targetPlatform?(0,b.toTargetPlatform)(F.targetPlatform):"undefined"}function z(F){const C=(0,A.distinct)(F.versions.map($)),U=!!F.tags?.includes(b.WEB_EXTENSION_TAG),q=C.indexOf("web");return U?q===-1&&C.push("web"):q!==-1&&C.splice(q,1),C}function x(F,C){const U=(0,b.getFallbackTargetPlarforms)(C);for(let q=0;q<F.length;q++){const G=F[q];if(G.version===F[q-1]?.version){let V=q;const Z=$(G);if(Z===C)for(;V>0&&F[V-1].version===G.version;)V--;else if(U.includes(Z))for(;V>0&&F[V-1].version===G.version&&$(F[V-1])!==C;)V--;V!==q&&(F.splice(q,1),F.splice(V,0,G))}}return F}e.sortExtensionVersions=x;function te(F,C,U){F.telemetryData={index:C,querySource:U,queryActivityId:F.queryContext?.[n]}}function ne(F,C,U,q){const G=F.versions[0],V={manifest:j(C,s.Manifest),readme:j(C,s.Details),changelog:j(C,s.Changelog),license:j(C,s.License),repository:D(C),download:M(C),icon:j(C,s.Icon),signature:j(C,s.Signature),coreTranslations:P(C)};return{identifier:{id:(0,m.getGalleryExtensionId)(F.publisher.publisherName,F.extensionName),uuid:F.extensionId},name:F.extensionName,version:C.version,displayName:F.displayName,publisherId:F.publisher.publisherId,publisher:F.publisher.publisherName,publisherDisplayName:F.publisher.displayName,publisherDomain:F.publisher.domain?{link:F.publisher.domain,verified:!!F.publisher.isDomainVerified}:void 0,publisherSponsorLink:_(G),description:F.shortDescription||"",installCount:f(F.statistics,"install"),rating:f(F.statistics,"averagerating"),ratingCount:f(F.statistics,"ratingcount"),categories:F.categories||[],tags:F.tags||[],releaseDate:Date.parse(F.releaseDate),lastUpdated:Date.parse(F.lastUpdated),allTargetPlatforms:U,assets:V,properties:{dependencies:B(C,o.Dependency),extensionPack:B(C,o.ExtensionPack),engine:W(C),localizedLanguages:Q(C),targetPlatform:$(C),isPreReleaseVersion:H(C)},hasPreReleaseVersion:H(G),hasReleaseVersion:!0,preview:Y(F.flags),isSigned:!!V.signature,queryContext:q}}let re=class{constructor(C,U,q,G,V,Z,ee,ce){this.k=U,this.l=q,this.n=G,this.o=V,this.q=Z,this.u=ee,this.w=ce;const ue=ee.extensionsGallery,de=ue?.servicePPEUrl&&ce.getValue("_extensionsGallery.enablePPE");this.d=de?ue.servicePPEUrl:ue?.serviceUrl,this.g=de?void 0:ue?.searchUrl,this.h=ue?.controlUrl,this.j=(0,u.resolveMarketplaceHeaders)(ee.version,ee,this.n,this.w,this.q,C,this.o)}x(C=""){return`${this.d}${C}`}isEnabled(){return!!this.d}async getExtensions(C,U,q){const G=N.CancellationToken.isCancellationToken(U)?{}:U,V=N.CancellationToken.isCancellationToken(U)?U:q,Z=[],ee=[],ce=[],ue=[];let de=!0;for(const Ee of C){Ee.uuid?ee.push(Ee.uuid):Z.push(Ee.id);const Re=!!(Ee.version||Ee.preRelease);ce.push({id:Ee.id,uuid:Ee.uuid,includePreRelease:Re}),Ee.version&&ue.push({id:Ee.id,uuid:Ee.uuid,version:Ee.version}),de=de&&!!Ee.hasPreRelease&&!Re}if(!ee.length&&!Z.length)return[];let ye=new w().withPage(1,C.length);ee.length&&(ye=ye.withFilter(i.ExtensionId,...ee)),Z.length&&(ye=ye.withFilter(i.ExtensionName,...Z)),(G.queryAllVersions||de)&&(ye=ye.withFlags(ye.flags,r.IncludeVersions)),G.source&&(ye=ye.withSource(G.source));const{extensions:Se}=await this.z(ye,{targetPlatform:G.targetPlatform??L,includePreRelease:ce,versions:ue,compatible:!!G.compatible},V);return G.source&&Se.forEach((Ee,Re)=>te(Ee,Re,G.source)),Se}async getCompatibleExtension(C,U,q){if((0,b.isNotWebExtensionInWebTargetPlatform)(C.allTargetPlatforms,q))return null;if(await this.isExtensionCompatible(C,U,q))return C;const G=new w().withFlags(r.IncludeVersions).withPage(1,1).withFilter(i.ExtensionId,C.identifier.uuid),{extensions:V}=await this.z(G,{targetPlatform:q,compatible:!0,includePreRelease:U},N.CancellationToken.None);return V[0]||null}async isExtensionCompatible(C,U,q){if(!(0,b.isTargetPlatformCompatible)(C.properties.targetPlatform,C.allTargetPlatforms,q)||!U&&C.properties.isPreReleaseVersion)return!1;let G=C.properties.engine;if(!G){const V=await this.getManifest(C,N.CancellationToken.None);if(!V)throw new Error("Manifest was not found");G=V.engines.vscode}return(0,g.isEngineValid)(G,this.u.version,this.u.date)}async y(C,U,q,G,V){if(!(0,b.isTargetPlatformCompatible)($(C),G,V)||U!=="any"&&H(C)!==(U==="prerelease"))return!1;if(q)try{const Z=await this.E(C);if(!(0,g.isEngineValid)(Z,this.u.version,this.u.date))return!1}catch(Z){return this.l.error(`Error while getting the engine for the version ${C.version}.`,(0,l.getErrorMessage)(Z)),!1}return!0}async query(C,U){let q=C.text||"";const G=C.pageSize??50;let V=new w().withPage(1,G);q?(q=q.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ye,Se)=>(V=V.withFilter(i.Category,Se||ye),"")),q=q.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(de,ye,Se)=>(V=V.withFilter(i.Tag,Se||ye),"")),q=q.replace(/\bfeatured(\s+|\b|$)/g,()=>(V=V.withFilter(i.Featured),"")),q=q.trim(),q&&(q=q.length<200?q:q.substring(0,200),V=V.withFilter(i.SearchText,q)),V=V.withSortBy(0)):C.ids?V=V.withFilter(i.ExtensionId,...C.ids):C.names?V=V.withFilter(i.ExtensionName,...C.names):V=V.withSortBy(4),typeof C.sortBy=="number"&&(V=V.withSortBy(C.sortBy)),typeof C.sortOrder=="number"&&(V=V.withSortOrder(C.sortOrder)),C.source&&(V=V.withSource(C.source));const Z=async(de,ye)=>{const{extensions:Se,total:Ee}=await this.z(de,{targetPlatform:L,compatible:!1,includePreRelease:!!C.includePreRelease},ye);return Se.forEach((Re,ke)=>te(Re,(de.pageNumber-1)*de.pageSize+ke,C.source)),{extensions:Se,total:Ee}},{extensions:ee,total:ce}=await Z(V,U),ue=async(de,ye)=>{if(ye.isCancellationRequested)throw new l.CancellationError;const{extensions:Se}=await Z(V.withPage(de+1),ye);return Se};return{firstPage:ee,total:ce,pageSize:V.pageSize,getPage:ue}}async z(C,U,q){const G=C.flags;C.flags&r.IncludeLatestVersionOnly&&C.flags&r.IncludeVersions&&(C=C.withFlags(C.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(C.flags&r.IncludeLatestVersionOnly)&&!(C.flags&r.IncludeVersions)&&(C=C.withFlags(C.flags,r.IncludeLatestVersionOnly)),U.versions?.length&&(C=C.withFlags(C.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),C=C.withFlags(C.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:V,total:Z,context:ee}=await this.B(C,q);if(!(C.flags&r.IncludeLatestVersionOnly)){const ye=[];for(const Se of V){const Ee=await this.A(Se,U,ee);Ee&&ye.push(Ee)}return{extensions:ye,total:Z}}const ue=[],de=new Map;for(let ye=0;ye<V.length;ye++){const Se=V[ye],Ee={id:(0,m.getGalleryExtensionId)(Se.publisher.publisherName,Se.extensionName),uuid:Se.extensionId},Re=(0,k.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(Be=>(0,m.areSameExtensions)(Be,Ee))?.includePreRelease;if(U.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(z(Se),U.targetPlatform))continue;const ke=await this.A(Se,U,ee);!ke||ke.properties.isPreReleaseVersion&&(!Re||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==U.targetPlatform&&ke.hasPreReleaseVersion?de.set(Se.extensionId,ye):ue.push([ye,ke])}if(de.size){const ye=new Date().getTime(),Se=new w().withFlags(G&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,de.size).withFilter(i.ExtensionId,...de.keys()),{extensions:Ee}=await this.z(Se,U,q);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ye,count:de.size});for(const Re of Ee){const ke=de.get(Re.identifier.uuid);ue.push([ke,Re])}}return{extensions:ue.sort((ye,Se)=>ye[0]-Se[0]).map(([,ye])=>ye),total:Z}}async A(C,U,q){const G={id:(0,m.getGalleryExtensionId)(C.publisher.publisherName,C.extensionName),uuid:C.extensionId},V=U.versions?.find(ue=>(0,m.areSameExtensions)(ue,G))?.version,Z=(0,k.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(ue=>(0,m.areSameExtensions)(ue,G))?.includePreRelease,ee=z(C),ce=x(C.versions,U.targetPlatform);if(U.compatible&&(0,b.isNotWebExtensionInWebTargetPlatform)(ee,U.targetPlatform))return null;for(let ue=0;ue<ce.length;ue++){const de=ce[ue];if(!(V&&de.version!==V)){if(await this.y(de,Z?"any":"release",U.compatible,ee,U.targetPlatform))return ne(C,de,ee,q);if(V&&de.version===V)return null}}return V||U.compatible?null:ne(C,C.versions[0],ee)}async B(C,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");C=C.withFlags(C.flags,r.ExcludeNonValidated).withFilter(i.Target,"Microsoft.VisualStudio.Code").withFilter(i.ExcludeWithFlags,t(r.Unpublished));const q=await this.j,G=JSON.stringify(C.raw),V={...q,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(G.length)},Z=new Date().getTime();let ee,ce,ue=0;try{if(ee=await this.k.request({type:"POST",url:this.g&&C.criteria.some(ye=>ye.filterType===i.SearchText)?this.g:this.x("/extensionquery"),data:G,headers:V},U),ee.res.statusCode&&ee.res.statusCode>=400&&ee.res.statusCode<500)return{galleryExtensions:[],total:ue};const de=await(0,h.asJson)(ee);if(de){const ye=de.results[0],Se=ye.extensions,Ee=ye.resultMetadata&&ye.resultMetadata.filter(Re=>Re.metadataType==="ResultCount")[0];return ue=Ee&&Ee.metadataItems.filter(Re=>Re.name==="TotalCount")[0].count||0,{galleryExtensions:Se,total:ue,context:{[n]:ee.res.headers.activityid}}}return{galleryExtensions:[],total:ue}}catch(de){throw ce=de,de}finally{this.o.publicLog2("galleryService:query",{...C.telemetryData,requestBodySize:String(G.length),duration:new Date().getTime()-Z,success:!!ee&&(0,h.isSuccess)(ee),responseBodySize:ee?.res.headers["Content-Length"],statusCode:ee?String(ee.res.statusCode):void 0,errorCode:ce?(0,l.isCancellationError)(ce)?"canceled":(0,l.getErrorMessage)(ce).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(C,U,q,G){if(!this.isEnabled())return;const V=O.isWeb?this.x(`/itemName/${C}.${U}/version/${q}/statType/${G==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${C}/extensions/${U}/${q}/stats?statType=${G}`),Z=O.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ce={...await this.j,Accept:Z};try{await this.k.request({type:"POST",url:V,headers:ce},N.CancellationToken.None)}catch{}}async download(C,U,q){this.l.trace("ExtensionGalleryService#download",C.identifier.id);const G=(0,m.getGalleryExtensionTelemetryData)(C),V=new Date().getTime(),Z=ye=>this.o.publicLog("galleryService:downloadVSIX",{...G,duration:ye}),ee=q===2?"install":q===3?"update":"",ce=ee?{uri:`${C.assets.download.uri}${I.URI.parse(C.assets.download.uri).query?"&":"?"}${ee}=true`,fallbackUri:`${C.assets.download.fallbackUri}${I.URI.parse(C.assets.download.fallbackUri).query?"&":"?"}${ee}=true`}:C.assets.download,ue=C.queryContext?.[n]?{[n]:C.queryContext[n]}:void 0,de=await this.D(ce,ue?{headers:ue}:void 0);await this.q.writeFile(U,de.stream),Z(new Date().getTime()-V)}async downloadSignatureArchive(C,U){if(!C.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",C.identifier.id);const q=await this.D(C.assets.signature);await this.q.writeFile(U,q.stream)}async getReadme(C,U){if(C.assets.readme){const q=await this.D(C.assets.readme,{},U);return await(0,h.asTextOrError)(q)||""}return""}async getManifest(C,U){if(C.assets.manifest){const q=await this.D(C.assets.manifest,{},U),G=await(0,h.asTextOrError)(q);return G?JSON.parse(G):null}return null}async C(C,U){const q=j(C,s.Manifest);if(!q)throw new Error("Manifest was not found");const G={"Accept-Encoding":"gzip"},V=await this.D(q,{headers:G});return await(0,h.asJson)(V)}async getCoreTranslation(C,U){const q=C.assets.coreTranslations.filter(G=>G[0]===U.toUpperCase())[0];if(q){const G=await this.D(q[1]),V=await(0,h.asTextOrError)(G);return V?JSON.parse(V):null}return null}async getChangelog(C,U){if(C.assets.changelog){const q=await this.D(C.assets.changelog,{},U);return await(0,h.asTextOrError)(q)||""}return""}async getAllCompatibleVersions(C,U,q){let G=new w().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);C.identifier.uuid?G=G.withFilter(i.ExtensionId,C.identifier.uuid):G=G.withFilter(i.ExtensionName,C.identifier.id);const{galleryExtensions:V}=await this.B(G,N.CancellationToken.None);if(!V.length)return[];const Z=z(V[0]);if((0,b.isNotWebExtensionInWebTargetPlatform)(Z,q))return[];const ee=[];await Promise.all(V[0].versions.map(async de=>{try{await this.y(de,U?"any":"release",!0,Z,q)&&ee.push(de)}catch{}}));const ce=[],ue=new Set;for(const de of x(ee,q))ue.has(de.version)||(ue.add(de.version),ce.push({version:de.version,date:de.lastUpdated,isPreReleaseVersion:H(de)}));return ce}async D(C,U={},q=N.CancellationToken.None){const G=await this.j,V={type:"GET"},Z={...G,...U.headers||{}};U={...U,...V,headers:Z};const ee=C.uri,ce=C.fallbackUri,ue={...U,url:ee};try{const de=await this.k.request(ue,q);if(de.res.statusCode===200)return de;const ye=await(0,h.asTextOrError)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${ye}`)}catch(de){if((0,l.isCancellationError)(de))throw de;const ye=(0,l.getErrorMessage)(de);this.o.publicLog2("galleryService:cdnFallback",{url:ee,message:ye});const Se={...U,url:ce};return this.k.request(Se,q)}}async E(C){let U=W(C);if(!U){const q=await this.C(C,N.CancellationToken.None);if(!q)throw new Error("Manifest was not found");U=q.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const C=await this.k.request({type:"GET",url:this.h},N.CancellationToken.None);if(C.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,h.asJson)(C),q=[],G={};if(U){for(const V of U.malicious)q.push({id:V});if(U.migrateToPreRelease)for(const[V,Z]of Object.entries(U.migrateToPreRelease))(!Z.engine||(0,g.isEngineValid)(Z.engine,this.u.version,this.u.date))&&(G[V.toLowerCase()]={disallowInstall:!0,extension:{id:Z.id,displayName:Z.displayName,autoMigrate:{storage:!!Z.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[V,Z]of Object.entries(U.deprecated))Z&&(G[V.toLowerCase()]=(0,k.isBoolean)(Z)?{}:Z)}return{malicious:q,deprecated:G}}};re=ve([J(1,h.IRequestService),J(2,E.ILogService),J(3,R.IEnvironmentService),J(4,S.ITelemetryService),J(5,p.IFileService),J(6,a.IProductService),J(7,v.IConfigurationService)],re);let X=e.ExtensionGalleryService=class extends re{constructor(C,U,q,G,V,Z,ee,ce){super(C,U,q,G,V,Z,ee,ce)}};e.ExtensionGalleryService=X=ve([J(0,d.IStorageService),J(1,h.IRequestService),J(2,E.ILogService),J(3,R.IEnvironmentService),J(4,S.ITelemetryService),J(5,p.IFileService),J(6,a.IProductService),J(7,v.IConfigurationService)],X);let K=e.ExtensionGalleryServiceWithNoStorageService=class extends re{constructor(C,U,q,G,V,Z,ee){super(void 0,C,U,q,G,V,Z,ee)}};e.ExtensionGalleryServiceWithNoStorageService=K=ve([J(0,h.IRequestService),J(1,E.ILogService),J(2,R.IEnvironmentService),J(3,S.ITelemetryService),J(4,p.IFileService),J(5,a.IProductService),J(6,v.IConfigurationService)],K)}),define(oe[81],ae([0,1,5,3,2,19,33,25,21,10,11]),function(ie,e,A,N,l,O,T,k,I,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,A.createDecorator)("IExtensionStorageService");const b=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let m=e.ExtensionStorageService=class Qe extends l.Disposable{static b(p){return`extensionKeys/${(0,T.adoptToGalleryExtensionId)(p.id)}@${p.version}`}static c(p){const E=b.exec(p);if(E&&E[1])return{id:E[1],version:E[2]}}static async removeOutdatedExtensionVersions(p,E){const a=await p.getInstalled(),h=[];for(const[u,d]of Qe.f(E)){const S=a.find(L=>(0,T.areSameExtensions)(L.identifier,{id:u}))?.manifest.version;for(const L of d)S!==L&&h.push(Qe.b({id:u,version:L}))}for(const u of h)E.remove(u,0)}static f(p){const E=new Map,a=p.keys(0,1);for(const h of a){const u=Qe.c(h);if(u){let d=E.get(u.id.toLowerCase());d||E.set(u.id.toLowerCase(),d=[]),d.push(u.version)}}return E}constructor(p,E,a){super(),this.i=p,this.j=E,this.k=a,this.g=this.B(new N.Emitter),this.onDidChangeExtensionStorageToSync=this.g.event,this.h=Qe.f(p),this.B(this.i.onDidChangeValue(h=>this.l(h)))}l(p){if(p.scope!==0)return;if(this.h.has(p.key.toLowerCase())){this.g.fire();return}const E=Qe.c(p.key);if(E){if(this.i.get(p.key,0)===void 0)this.h.delete(E.id.toLowerCase());else{let a=this.h.get(E.id.toLowerCase());a||this.h.set(E.id.toLowerCase(),a=[]),a.push(E.version),this.g.fire()}return}}m(p){if((0,R.isString)(p))return p;const E=p.manifest?p.manifest.publisher:p.publisher,a=p.manifest?p.manifest.name:p.name;return(0,T.getExtensionId)(E,a)}getExtensionState(p,E){const a=this.m(p),h=this.getExtensionStateRaw(p,E);if(h)try{return JSON.parse(h)}catch(u){this.k.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${a}, global: ${E}): ${u}`)}}getExtensionStateRaw(p,E){const a=this.m(p),h=this.i.get(a,E?0:1);return h&&h?.length>Qe.a&&this.k.warn(`[mainThreadStorage] large extension state detected (extensionId: ${a}, global: ${E}): ${h.length/1024}kb. Consider to use 'storageUri' or 'globalStorageUri' to store this data on disk instead.`),h}setExtensionState(p,E,a){const h=this.m(p);E===void 0?this.i.remove(h,a?0:1):this.i.store(h,JSON.stringify(E),a?0:1,1)}setKeysForSync(p,E){this.i.store(Qe.b(p),JSON.stringify(E),0,1)}getKeysForSync(p){const E=this.j.extensionSyncedKeys?.[p.id.toLowerCase()],a=this.i.get(Qe.b(p),0),h=a?JSON.parse(a):void 0;return h&&E?(0,I.distinct)([...h,...E]):h||E}addToMigrationList(p,E){if(p!==E){const a=this.n.filter(h=>!h.includes(p)&&!h.includes(E));a.push([p,E]),this.n=a}}getSourceExtensionToMigrate(p){const E=this.n.find(([,a])=>p===a);return E?E[0]:void 0}get n(){const p=this.i.get("extensionStorage.migrationList",-1,"[]");try{const E=JSON.parse(p);if(Array.isArray(E))return E}catch{}return[]}set n(p){p.length?this.i.store("extensionStorage.migrationList",JSON.stringify(p),-1,1):this.i.remove("extensionStorage.migrationList",-1)}};m.a=512*1024,e.ExtensionStorageService=m=ve([J(0,O.IStorageService),J(1,k.IProductService),J(2,v.ILogService)],m)}),define(oe[262],ae([0,1,29,13,25,15,101,56,19,20,227]),function(ie,e,A,N,l,O,T,k,I,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let b=e.ExtensionTipsService=class extends R.AbstractNativeExtensionTipsService{constructor(g,p,E,a,h,u,d,S){super(g.userHome,h,p,E,a,u,d,S)}};e.ExtensionTipsService=b=ve([J(0,O.INativeEnvironmentService),J(1,v.ITelemetryService),J(2,A.IExtensionManagementService),J(3,I.IStorageService),J(4,k.INativeHostService),J(5,T.IExtensionRecommendationNotificationService),J(6,N.IFileService),J(7,l.IProductService)],b)}),define(oe[263],ae([0,1,108,3,20,15,2,10,14,49,25,4,6,104,17,168,34,19,11]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTunnelService=void 0;const d=[A.CONFIGURATION_KEY_HOST_NAME,A.CONFIGURATION_KEY_PREVENT_SLEEP],S="remoteTunnelSession";let L=e.RemoteTunnelService=class extends T.Disposable{constructor(t,i,s,o,c,y,w){super(),this.s=t,this.t=i,this.u=s,this.v=y,this.w=w,this.b=new N.Emitter,this.onDidTokenFailed=this.b.event,this.f=new N.Emitter,this.onDidChangeTunnelStatus=this.f.event,this.g=new N.Emitter,this.onDidChangeSession=this.g.event,this.r=!1,this.h=this.B(o.createLogger(A.LOG_ID,{name:A.LOGGER_NAME})),this.n=new m.Delayer(100),this.B(this.h.onDidChangeLogLevel(f=>this.h.info("Log level changed to "+(0,k.LogLevelToString)(f)))),this.B(c.onWillShutdown(()=>{this.j?.cancel(),this.j=void 0,this.dispose()})),this.B(y.onDidChangeConfiguration(f=>{d.some(P=>f.affectsConfiguration(P))&&this.n.trigger(()=>this.D())})),this.i=this.I(),this.k=A.TunnelStates.uninitialized}async getTunnelStatus(){return this.k}y(t){this.k=t,this.f.fire(t)}z(t){n(t,this.i)||(this.i=t,this.g.fire(t),this.J(t),t?(this.h.info(`Session updated: ${t.accountLabel} (${t.providerId})`),t.token&&this.h.info(`Session token updated: ${t.accountLabel} (${t.providerId})`)):this.h.info("Session reset"))}async getSession(){return this.i}async initialize(t){if(this.r)return this.k;this.r=!0,this.z(t);try{await this.n.trigger(()=>this.D())}catch(i){this.h.error(i)}return this.k}C(){if(!this.p){let t;b.isMacintosh?t=this.u.appRoot:t=(0,I.dirname)((0,I.dirname)(this.u.appRoot)),this.p=(0,I.join)(t,"bin",`${this.t.tunnelApplicationName}${b.isWindows?".exe":""}`)}return this.p}async startTunnel(t){if(n(t,this.i))return this.k;this.z(t);try{await this.n.trigger(()=>this.D())}catch(i){this.h.error(i)}return this.k}async stopTunnel(){this.z(void 0),this.j&&(this.j.cancel(),this.j=void 0);const t=(i,s)=>{s?this.h.error(i):this.h.info(i)};try{await this.F("stop",["kill"],t)}catch(i){this.h.error(i)}this.y(A.TunnelStates.disconnected())}async D(){this.s.publicLog2("remoteTunnel.enablement",{enabled:!!this.i}),this.j&&(this.j.cancel(),this.j=void 0);let t=!1;const i=(f,P)=>{P?this.h.error(f):this.h.info(f),!this.u.isBuilt&&f.startsWith("   Compiling")&&this.y(A.TunnelStates.connecting((0,E.localize)(0,null)))},s=this.F("status",["status"],i);this.j=s;try{const f=await s;if(this.j!==s)return;if(t=f===0,this.h.info(t?"Other tunnel running, attaching...":"No other tunnel running"),!t&&!this.i){this.j=void 0,this.y(A.TunnelStates.disconnected());return}}catch(f){this.h.error(f),this.j=void 0,this.y(A.TunnelStates.disconnected());return}const o=this.i;if(o&&o.token){const f=o.token;this.y(A.TunnelStates.connecting((0,E.localize)(1,null,o.accountLabel,o.providerId)));const P=(M,j)=>{M=M.replaceAll(f,"*".repeat(4)),i(M,j)},D=this.F("login",["user","login","--provider",o.providerId,"--access-token",f,"--log",(0,k.LogLevelToString)(this.h.getLevel())],P);this.j=D;try{if(await D,this.j!==D)return}catch(M){this.h.error(M),this.j=void 0,this.b.fire(o),this.y(A.TunnelStates.disconnected(o));return}}const c=this.H();c?this.y(A.TunnelStates.connecting((0,E.localize)(2,null,c))):this.y(A.TunnelStates.connecting((0,E.localize)(3,null)));const y=["--parent-process-id",String(process.pid),"--accept-server-license-terms","--log",(0,k.LogLevelToString)(this.h.getLevel())];c?y.push("--name",c):y.push("--random-name"),this.G()&&y.push("--no-sleep");const w=this.F("tunnel",y,(f,P)=>{P?this.h.error(f):this.h.info(f);const D=f.match(/Open this link in your browser (https:\/\/([^\/\s]+)\/([^\/\s]+)\/([^\/\s]+))/);if(D){const M={link:D[1],domain:D[2],tunnelName:D[4],isAttached:t};this.y(A.TunnelStates.connected(M))}else f.match(/error refreshing token/)&&(w.cancel(),this.b.fire(o),this.y(A.TunnelStates.disconnected(o)))});this.j=w,w.finally(()=>{w===this.j&&(this.h.info("tunnel process terminated"),this.j=void 0,this.i=void 0,this.y(A.TunnelStates.disconnected()))})}F(t,i,s=()=>{}){return(0,m.createCancelablePromise)(o=>new Promise((c,y)=>{o.isCancellationRequested&&c(-1);let w;if(o.onCancellationRequested(()=>{w&&(this.h.info(`${t} terminating(${w.pid})`),w.kill())}),!this.u.isBuilt)s("Building tunnel CLI from sources and run",!1),s(`${t} Spawning: cargo run -- tunnel ${i.join(" ")}`,!1),w=(0,v.spawn)("cargo",["run","--","tunnel",...i],{cwd:(0,I.join)(this.u.appRoot,"cli")});else{s("Running tunnel CLI",!1);const f=this.C();s(`${t} Spawning: ${f} tunnel ${i.join(" ")}`,!1),w=(0,v.spawn)(f,["tunnel",...i],{cwd:(0,a.homedir)()})}w.stdout.on("data",f=>{if(w){const P=f.toString();s(P,!1)}}),w.stderr.on("data",f=>{if(w){const P=f.toString();s(P,!0)}}),w.on("exit",f=>{w&&(s(`${t} exit(${w.pid}): + ${f} `,!1),w=void 0,c(f||0))}),w.on("error",f=>{w&&(s(`${t} error(${w.pid}): + ${f} `,!0),w=void 0,y())})}))}async getTunnelName(){return this.H()}G(){return!!this.v.getValue(A.CONFIGURATION_KEY_PREVENT_SLEEP)}H(){let t=this.v.getValue(A.CONFIGURATION_KEY_HOST_NAME)||(0,a.hostname)();return t=t.replace(/^-+/g,"").replace(/[^\w-]/g,"").substring(0,20),t||void 0}I(){try{const t=this.w.get(S,-1);if(t){const i=JSON.parse(t);if(i&&(0,u.isString)(i.accountLabel)&&(0,u.isString)(i.sessionId)&&(0,u.isString)(i.providerId))return i;this.h.error("Problems restoring session from storage, invalid format",i)}}catch(t){this.h.error("Problems restoring session from storage",t)}}J(t){if(t){const i={providerId:t.providerId,sessionId:t.sessionId,accountLabel:t.accountLabel};this.w.store(S,JSON.stringify(i),-1,1)}else this.w.remove(S,-1)}};e.RemoteTunnelService=L=ve([J(0,l.ITelemetryService),J(1,R.IProductService),J(2,O.INativeEnvironmentService),J(3,k.ILoggerService),J(4,g.ISharedProcessLifecycleService),J(5,p.IConfigurationService),J(6,h.IStorageService)],L);function n(r,t){return r&&t?r.sessionId===t.sessionId&&r.providerId===t.providerId&&r.token===t.token:r===t}}),define(oe[264],ae([0,1,6,2,22,67,19,77,18]),function(ie,e,A,N,l,O,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteStorageService=void 0;class v extends T.AbstractStorageService{constructor(b,m,g,p){super(),this.X=b,this.Y=m,this.Z=g,this.ab=p,this.p=this.Y.defaultProfile,this.s=this.bb(),this.P=this.Y.currentProfile,this.Q=this.B(new N.DisposableStore),this.R=this.cb(this.P),this.S=this.X?.id,this.U=this.B(new N.DisposableStore),this.W=this.db(this.X)}bb(){const b=this.B(new k.ApplicationStorageDatabaseClient(this.Z.getChannel("storage"))),m=this.B(new O.Storage(b));return this.B(m.onDidChangeStorage(g=>this.n(-1,g))),m}cb(b){this.Q.clear(),this.P=b;let m;if((0,T.isProfileUsingDefaultStorage)(b))m=this.s;else{const g=this.Q.add(new k.ProfileStorageDatabaseClient(this.Z.getChannel("storage"),b));m=this.Q.add(new O.Storage(g))}return this.Q.add(m.onDidChangeStorage(g=>this.n(0,g))),m}db(b){this.U.clear(),this.S=b?.id;let m;if(b){const g=this.U.add(new k.WorkspaceStorageDatabaseClient(this.Z.getChannel("storage"),b));m=this.U.add(new O.Storage(g)),this.U.add(m.onDidChangeStorage(p=>this.n(1,p)))}return m}async J(){await A.Promises.settled([this.s.init(),this.R.init(),this.W?.init()??Promise.resolve()])}L(b){switch(b){case-1:return this.s;case 0:return this.R;default:return this.W}}M(b){switch(b){case-1:return this.p.globalStorageHome.fsPath;case 0:return this.P?.globalStorageHome.fsPath;default:return this.S?`${(0,l.joinPath)(this.ab.workspaceStorageHome,this.S,"state.vscdb").fsPath}`:void 0}}async close(){this.m(),this.r(T.WillSaveStateReason.SHUTDOWN),await A.Promises.settled([this.s.close(),this.R.close(),this.W?.close()??Promise.resolve()])}async N(b,m){if(!this.H(this.P,b))return;const g=this.R,p=g.items;g!==this.s&&await g.close(),this.R=this.cb(b),await this.R.init(),this.I(p,this.R,0,m)}async O(b,m){const g=this.W,p=g?.items??new Map;await g?.close(),this.W=this.db(b),await this.W.init(),this.I(p,this.W,1,m)}hasScope(b){return(0,I.isUserDataProfile)(b)?this.P.id===b.id:this.S===b.id}}e.RemoteStorageService=v}),define(oe[265],ae([0,1,3,2,18,93]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class T{constructor(v,R){this.a=v,this.b=R}listen(v,R){const b=this.b(v);switch(R){case"onDidChangeProfiles":return A.Event.map(this.a.onDidChangeProfiles,m=>({all:m.all.map(g=>(0,O.transformOutgoingURIs)({...g},b)),added:m.added.map(g=>(0,O.transformOutgoingURIs)({...g},b)),removed:m.removed.map(g=>(0,O.transformOutgoingURIs)({...g},b)),updated:m.updated.map(g=>(0,O.transformOutgoingURIs)({...g},b))}))}throw new Error(`Invalid listen ${R}`)}async call(v,R,b){const m=this.b(v);switch(R){case"createProfile":{const g=await this.a.createProfile(b[0],b[1],b[2]);return(0,O.transformOutgoingURIs)({...g},m)}case"updateProfile":{let g=(0,l.reviveProfile)((0,O.transformIncomingURIs)(b[0],m),this.a.profilesHome.scheme);return g=await this.a.updateProfile(g,b[1]),(0,O.transformOutgoingURIs)({...g},m)}case"removeProfile":{const g=(0,l.reviveProfile)((0,O.transformIncomingURIs)(b[0],m),this.a.profilesHome.scheme);return this.a.removeProfile(g)}}throw new Error(`Invalid call ${R}`)}}e.RemoteUserDataProfilesServiceChannel=T;class k extends N.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(v,R,b){super(),this.profilesHome=R,this.f=b,this.a=[],this.b=this.B(new A.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=v.map(m=>(0,l.reviveProfile)(m,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(m=>{const g=m.added.map(a=>(0,l.reviveProfile)(a,this.profilesHome.scheme)),p=m.removed.map(a=>(0,l.reviveProfile)(a,this.profilesHome.scheme)),E=m.updated.map(a=>(0,l.reviveProfile)(a,this.profilesHome.scheme));this.a=m.all.map(a=>(0,l.reviveProfile)(a,this.profilesHome.scheme)),this.b.fire({added:g,removed:p,updated:E,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(v){this.c=v}isEnabled(){return this.c}async createNamedProfile(v,R,b){const m=await this.f.call("createNamedProfile",[v,R,b]);return(0,l.reviveProfile)(m,this.profilesHome.scheme)}async createProfile(v,R,b,m){const g=await this.f.call("createProfile",[v,R,b,m]);return(0,l.reviveProfile)(g,this.profilesHome.scheme)}async createTransientProfile(v){const R=await this.f.call("createTransientProfile",[v]);return(0,l.reviveProfile)(R,this.profilesHome.scheme)}async setProfileForWorkspace(v,R){await this.f.call("setProfileForWorkspace",[v,R])}removeProfile(v){return this.f.call("removeProfile",[v])}async updateProfile(v,R){const b=await this.f.call("updateProfile",[v,R]);return(0,l.reviveProfile)(b,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=k}),define(oe[60],ae([0,1,2,67,5,19,3,77,18]),function(ie,e,A,N,l,O,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteUserDataProfileStorageService=e.AbstractUserDataProfileStorageService=e.IUserDataProfileStorageService=void 0,e.IUserDataProfileStorageService=(0,l.createDecorator)("IUserDataProfileStorageService");let v=e.AbstractUserDataProfileStorageService=class extends A.Disposable{constructor(g){super(),this.a=g}async readStorageData(g){return this.withProfileScopedStorageService(g,async p=>this.b(p))}async updateStorageData(g,p,E){return this.withProfileScopedStorageService(g,async a=>this.c(a,p,E))}async withProfileScopedStorageService(g,p){if(this.a.hasScope(g))return p(this.a);const E=await this.g(g),a=new b(E);try{await a.initialize();const h=await p(a);return await a.flush(),h}finally{a.dispose(),await this.f(E)}}b(g){const p=new Map,E=a=>{for(const h of g.keys(0,a))p.set(h,{value:g.get(h,0),target:a})};return E(0),E(1),p}c(g,p,E){for(const[a,h]of p)g.store(a,h,0,E)}async f(g){try{await g.close()}finally{(0,A.isDisposable)(g)&&g.dispose()}}};e.AbstractUserDataProfileStorageService=v=ve([J(0,O.IStorageService)],v);class R extends v{constructor(g,p,E,a){super(E),this.i=g;const h=g.getChannel("profileStorageListener"),u=this.B(new A.MutableDisposable);this.h=this.B(new T.Emitter({onWillAddFirstListener:()=>{u.value=h.listen("onDidChange")(d=>{a.trace("profile storage changes",d),this.h.fire({targetChanges:d.targetChanges.map(S=>(0,I.reviveProfile)(S,p.profilesHome.scheme)),valueChanges:d.valueChanges.map(S=>({...S,profile:(0,I.reviveProfile)(S.profile,p.profilesHome.scheme)}))})})},onDidRemoveLastListener:()=>u.value=void 0})),this.onDidChange=this.h.event}async g(g){const p=this.i.getChannel("storage");return(0,O.isProfileUsingDefaultStorage)(g)?new k.ApplicationStorageDatabaseClient(p):new k.ProfileStorageDatabaseClient(p,g)}}e.RemoteUserDataProfileStorageService=R;class b extends O.AbstractStorageService{constructor(g){super({flushInterval:100}),this.p=this.B(new N.Storage(g))}J(){return this.p.init()}L(g){return g===0?this.p:void 0}M(){}async N(){}async O(){}hasScope(){return!1}}}),define(oe[266],ae([0,1,19,10,18,73,60]),function(ie,e,A,N,l,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeUserDataProfileStorageService=void 0;let k=e.NativeUserDataProfileStorageService=class extends T.RemoteUserDataProfileStorageService{constructor(v,R,b,m){super(v,R,b,m)}};e.NativeUserDataProfileStorageService=k=ve([J(0,O.IMainProcessService),J(1,l.IUserDataProfilesService),J(2,A.IStorageService),J(3,N.ILogService)],k)}),define(oe[40],ae([0,1,21,6,16,26,3,35,2,27,11,176,17,15,13,10,44,19,20,30,23,18]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u,d,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.getSyncResourceLogLabel=e.isSyncData=e.isRemoteUserData=void 0;function n(y){return!!(y&&y.ref!==void 0&&typeof y.ref=="string"&&y.ref!==""&&y.syncData!==void 0&&(y.syncData===null||r(y.syncData)))}e.isRemoteUserData=n;function r(y){return!!(y&&y.version!==void 0&&typeof y.version=="number"&&y.content!==void 0&&typeof y.content=="string"&&(Object.keys(y).length===2||Object.keys(y).length===3&&y.machineId!==void 0&&typeof y.machineId=="string"))}e.isSyncData=r;function t(y,w){return`${(0,v.uppercaseFirstLetter)(y)}${w.isDefault?"":` (${w.name})`}`}e.getSyncResourceLogLabel=t;let i=e.AbstractSynchroniser=class extends I.Disposable{get status(){return this.k}get conflicts(){return{...this.syncResource,conflicts:this.m}}constructor(w,f,P,D,M,j,B,W,H,Q,_,Y){super(),this.syncResource=w,this.collection=f,this.C=P,this.D=D,this.F=M,this.G=j,this.H=B,this.I=W,this.J=H,this.L=Q,this.M=_,this.c=null,this.k="idle",this.l=this.B(new T.Emitter),this.onDidChangeStatus=this.l.event,this.m=[],this.n=this.B(new T.Emitter),this.onDidChangeConflicts=this.n.event,this.s=new N.ThrottledDelayer(50),this.t=this.B(new T.Emitter),this.onDidChangeLocal=this.t.event,this.v=`${this.collection?`${this.collection}.`:""}${this.syncResource.syncResource}.lastSyncUserData`,this.w=!1,this.z={},this.resource=this.syncResource.syncResource,this.y=t(w.syncResource,w.profile),this.h=Y.extUri,this.f=this.h.joinPath(D.userDataSyncHome,...(0,S.getPathSegments)(w.profile.isDefault?void 0:w.profile.id,w.syncResource)),this.g=this.h.joinPath(this.f,S.PREVIEW_DIR_NAME),this.u=(0,S.getLastSyncResourceUri)(w.profile.isDefault?void 0:w.profile.id,w.syncResource,D,this.h),this.j=(0,a.getServiceMachineId)(D,P,M)}N(){this.s.trigger(()=>this.O())}async O(){if(this.status==="hasConflicts"){this.L.info(`${this.y}: In conflicts state and local change detected. Syncing again...`);const w=await this.c;this.c=null;const f=await this.U(w.remoteUserData,w.lastSyncUserData,!0,this.mb());this.P(f)}else{this.L.trace(`${this.y}: Checking for local changes...`);const w=await this.getLastSyncUserData();(w?await this.sb(w):!0)&&this.t.fire()}}P(w){this.k!==w&&(this.k=w,this.l.fire(w))}async sync(w,f={}){await this.Q(w,!0,this.mb(),f)}async preview(w,f,P={}){return this.Q(w,!1,f,P)}async apply(w,f={}){try{this.z={...f};const P=await this.Y(w);return this.P(P),this.c}finally{this.z={}}}async Q(w,f,P,D){try{if(this.z={...D},this.status==="hasConflicts")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.c;if(this.status==="syncing")return this.L.info(`${this.y}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.c;this.L.trace(`${this.y}: Started synchronizing ${this.resource.toLowerCase()}...`),this.P("syncing");let M="idle";try{const j=await this.getLastSyncUserData(),B=await this.S(w,j);return M=await this.U(B,j,f,P),M==="hasConflicts"?this.L.info(`${this.y}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):M==="idle"&&this.L.trace(`${this.y}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.c||null}finally{this.P(M)}}finally{this.z={}}}async replace(w){const f=this.ib(w);if(!f)return!1;await this.stop();try{this.L.trace(`${this.y}: Started resetting ${this.resource.toLowerCase()}...`),this.P("syncing");const P=await this.getLastSyncUserData(),D=await this.S(null,P),M=await this.R(D),j=await this.ob({ref:D.ref,syncData:f},P,M,this.mb(),O.CancellationToken.None),B=[];for(const W of j){const H=await this.qb(W,W.remoteResource,void 0,O.CancellationToken.None),{remoteChange:Q}=await this.qb(W,W.previewResource,W.remoteContent,O.CancellationToken.None);B.push([W,{...H,remoteChange:Q!==0?Q:2}])}await this.rb(D,P,B,!1),this.L.info(`${this.y}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.P("idle")}return!0}async R(w){const f=await this.j;return!!w.syncData?.machineId&&w.syncData.machineId===f}async S(w,f){if(f){const P=w?w[this.resource]:void 0;if(f.ref===P||P===void 0&&f.syncData===null)return f}return this.getRemoteUserData(f)}async U(w,f,P,D){if(w.syncData&&w.syncData.version>this.nb)throw this.J.publicLog2("sync/incompatible",{source:this.resource}),new S.UserDataSyncError((0,b.localize)(0,null,this.resource,this.nb,w.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.W(w,f,P,D)}catch(M){if(M instanceof S.UserDataSyncError)switch(M.code){case"LocalPreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize ${this.y} as there is a new local version available. Synchronizing again...`),this.U(w,f,P,D);case"Conflict":case"PreconditionFailed":return this.L.info(`${this.y}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),w=await this.getRemoteUserData(null),f=await this.getLastSyncUserData(),this.U(w,f,P,D)}throw M}}async W(w,f,P,D){try{const M=await this.R(w),j=!M&&f===null&&this.eb()!==void 0,B=P&&!j;this.c||(this.c=(0,N.createCancelablePromise)(H=>this.cb(w,f,M,B,D,H)));let W=await this.c;if(P&&j){this.L.info(`${this.y}: Accepting remote because it was synced before and the last sync data is not available.`);for(const H of W.resourcePreviews)W=await this.accept(H.remoteResource)||W}return this.ab(W.resourcePreviews),W.resourcePreviews.some(({mergeState:H})=>H==="conflict")?"hasConflicts":P?await this.Y(!1):"syncing"}catch(M){throw this.c=null,M}}async merge(w){return await this.X(w,async f=>{const P=await this.pb(f,O.CancellationToken.None);await this.C.writeFile(f.previewResource,l.VSBuffer.fromString(P?.content||""));const D=P&&!P.hasConflicts?await this.qb(f,f.previewResource,void 0,O.CancellationToken.None):void 0;return f.acceptResult=D,f.mergeState=P.hasConflicts?"conflict":D?"accepted":"preview",f.localChange=D?D.localChange:P.localChange,f.remoteChange=D?D.remoteChange:P.remoteChange,f}),this.c}async accept(w,f){return await this.X(w,async P=>{const D=await this.qb(P,w,f,O.CancellationToken.None);return P.acceptResult=D,P.mergeState="accepted",P.localChange=D.localChange,P.remoteChange=D.remoteChange,P}),this.c}async discard(w){return await this.X(w,async f=>{const P=await this.pb(f,O.CancellationToken.None);return await this.C.writeFile(f.previewResource,l.VSBuffer.fromString(P.content||"")),f.acceptResult=void 0,f.mergeState="preview",f.localChange=P.localChange,f.remoteChange=P.remoteChange,f}),this.c}async X(w,f){if(!this.c)return;let P=await this.c;const D=P.resourcePreviews.findIndex(({localResource:M,remoteResource:j,previewResource:B})=>this.h.isEqual(M,w)||this.h.isEqual(j,w)||this.h.isEqual(B,w));D!==-1&&(this.c=(0,N.createCancelablePromise)(async M=>{const j=[...P.resourcePreviews];return j[D]=await f(j[D]),{...P,resourcePreviews:j}}),P=await this.c,this.ab(P.resourcePreviews),P.resourcePreviews.some(({mergeState:M})=>M==="conflict")?this.P("hasConflicts"):this.P("syncing"))}async Y(w){if(!this.c)return"idle";const f=await this.c;return f.resourcePreviews.some(({mergeState:P})=>P==="conflict")?"hasConflicts":f.resourcePreviews.some(({mergeState:P})=>P!=="accepted")?"syncing":(await this.rb(f.remoteUserData,f.lastSyncUserData,f.resourcePreviews.map(P=>[P,P.acceptResult]),w),this.c=null,await this.Z(),"idle")}async Z(){try{await this.C.del(this.g,{recursive:!0})}catch{}}ab(w){const f=w.filter(({mergeState:P})=>P==="conflict");(0,A.equals)(this.m,f,(P,D)=>this.h.isEqual(P.previewResource,D.previewResource))||(this.m=f,this.n.fire(this.conflicts))}async hasPreviouslySynced(){const w=await this.getLastSyncUserData();return!!w&&w.syncData!==null}async bb(w){const f=this.c?await this.c:null;if(f)for(const P of f.resourcePreviews){if(this.h.isEqual(P.acceptedResource,w))return P.acceptResult?P.acceptResult.content:null;if(this.h.isEqual(P.remoteResource,w))return P.remoteContent;if(this.h.isEqual(P.localResource,w))return P.localContent;if(this.h.isEqual(P.baseResource,w))return P.baseContent}return null}async resetLocal(){this.F.remove(this.v,-1);try{await this.C.del(this.u)}catch(w){(0,p.toFileOperationResult)(w)!==1&&this.L.error(w)}}async cb(w,f,P,D,M,j){const B=await this.ob(w,f,P,M,j),W=[];for(const H of B){const Q=H.previewResource.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(H.localChange===0&&H.remoteChange===0)W.push({...H,acceptedResource:Q,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const _=D?await this.pb(H,j):void 0;if(j.isCancellationRequested)break;await this.C.writeFile(H.previewResource,l.VSBuffer.fromString(_?.content||""));const Y=_&&!_.hasConflicts?await this.qb(H,H.previewResource,void 0,j):void 0;W.push({...H,acceptResult:Y,mergeState:_?.hasConflicts?"conflict":Y?"accepted":"preview",localChange:Y?Y.localChange:_?_.localChange:H.localChange,remoteChange:Y?Y.remoteChange:_?_.remoteChange:H.remoteChange})}}return{syncResource:this.resource,profile:this.syncResource.profile,remoteUserData:w,lastSyncUserData:f,resourcePreviews:W,isLastSyncFromCurrentMachine:P}}async getLastSyncUserData(){let w=this.eb();if(w||(w=await this.hb()),!w)return this.L.info(`${this.y}: Last sync data state does not exist.`),null;const f=JSON.parse(w),P=this.I.getResourceSyncStateVersion(this.resource);if(this.w=!!f.version&&!!P&&f.version!==P,this.w)return this.L.info(`${this.y}: Reset last sync state because last sync state version ${f.version} is not compatible with current sync state version ${P}.`),await this.resetLocal(),null;let D,M=1;for(;D===void 0&&M++<6;)try{const j=await this.fb();j&&(j.ref===f.ref?D=j.syncData:this.L.info(`${this.y}: Last sync data stored locally is not same as the last sync state.`));break}catch(j){if(j instanceof p.FileOperationError&&j.fileOperationResult===1){this.L.info(`${this.y}: Last sync resource does not exist locally.`);break}else{if(j instanceof S.UserDataSyncError)throw j;this.L.error(j,M)}}if(D===void 0)try{const j=await this.G.resolveResourceContent(this.resource,f.ref,this.collection,this.z);D=j===null?null:this.ib(j),await this.gb({ref:f.ref,syncData:D})}catch(j){if(j instanceof S.UserDataSyncError&&j.code==="NotFound")this.L.info(`${this.y}: Last sync resource does not exist remotely.`);else throw j}return D===void 0?null:{...f,syncData:D}}async db(w,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const P=this.I.getResourceSyncStateVersion(this.resource),D={ref:w.ref,version:P,...f};this.F.store(this.v,JSON.stringify(D),-1,1),await this.gb(w)}eb(){return this.F.get(this.v,-1)}async fb(){const w=(await this.C.readFile(this.u)).value.toString();try{const f=w?JSON.parse(w):void 0;if(n(f))return f}catch(f){this.L.error(f)}}async gb(w){await this.C.writeFile(this.u,l.VSBuffer.fromString(JSON.stringify(w)))}async hb(){try{const w=await this.C.readFile(this.u),f=JSON.parse(w.value.toString());await this.C.del(this.u),f.ref&&f.content!==void 0?(this.F.store(this.v,JSON.stringify({...f,content:void 0}),-1,1),await this.gb({ref:f.ref,syncData:f.content===null?null:JSON.parse(f.content)})):this.L.info(`${this.y}: Migrating last sync user data. Invalid data.`,f)}catch(w){w instanceof p.FileOperationError&&w.fileOperationResult===1?this.L.info(`${this.y}: Migrating last sync user data. Resource does not exist.`):this.L.error(w)}return this.F.get(this.v,-1)}async getRemoteUserData(w){const{ref:f,content:P}=await this.jb(w);let D=null;return P!==null&&(D=this.ib(P)),{ref:f,syncData:D}}ib(w){try{const f=JSON.parse(w);if(r(f))return f}catch(f){this.L.error(f)}throw new S.UserDataSyncError((0,b.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async jb(w){const f=w?{ref:w.ref,content:w.syncData?JSON.stringify(w.syncData):null}:null;return this.G.readResource(this.resource,f,this.collection,this.z)}async kb(w,f){const P=await this.j,D={version:this.nb,machineId:P,content:w};try{return f=await this.G.writeResource(this.resource,JSON.stringify(D),f,this.collection,this.z),{ref:f,syncData:D}}catch(M){throw M instanceof S.UserDataSyncError&&M.code==="TooLarge"&&(M=new S.UserDataSyncError(M.message,M.code,this.resource)),M}}async lb(w){const f={version:this.nb,content:w};return this.H.backup(this.syncResource.profile,this.resource,JSON.stringify(f))}async stop(){this.status!=="idle"&&(this.L.trace(`${this.y}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.c&&(this.c.cancel(),this.c=null),this.ab([]),await this.Z(),this.P("idle"),this.L.info(`${this.y}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}mb(){return this.M.getValue(S.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};e.AbstractSynchroniser=i=ve([J(2,p.IFileService),J(3,g.IEnvironmentService),J(4,h.IStorageService),J(5,S.IUserDataSyncStoreService),J(6,S.IUserDataSyncBackupStoreService),J(7,S.IUserDataSyncEnablementService),J(8,u.ITelemetryService),J(9,S.IUserDataSyncLogService),J(10,m.IConfigurationService),J(11,d.IUriIdentityService)],i);let s=e.AbstractFileSynchroniser=class extends i{constructor(w,f,P,D,M,j,B,W,H,Q,_,Y,$){super(f,P,D,M,j,B,W,H,Q,_,Y,$),this.i=w,this.B(this.C.watch(this.h.dirname(w))),this.B(this.C.onDidFilesChange(z=>this.ub(z)))}async p(){try{return await this.C.readFile(this.i)}catch{return null}}async r(w,f,P){try{f?await this.C.writeFile(this.i,l.VSBuffer.fromString(w),P?void 0:f):await this.C.createFile(this.i,l.VSBuffer.fromString(w),{overwrite:P})}catch(D){throw D instanceof p.FileOperationError&&D.fileOperationResult===1||D instanceof p.FileOperationError&&D.fileOperationResult===3?new S.UserDataSyncError(D.message,"LocalPreconditionFailed"):D}}async tb(){try{await this.C.del(this.i)}catch(w){if(!(w instanceof p.FileOperationError&&w.fileOperationResult===1))throw w}}ub(w){w.contains(this.i)&&this.N()}};e.AbstractFileSynchroniser=s=ve([J(3,p.IFileService),J(4,g.IEnvironmentService),J(5,h.IStorageService),J(6,S.IUserDataSyncStoreService),J(7,S.IUserDataSyncBackupStoreService),J(8,S.IUserDataSyncEnablementService),J(9,u.ITelemetryService),J(10,S.IUserDataSyncLogService),J(11,m.IConfigurationService),J(12,d.IUriIdentityService)],s);let o=e.AbstractJsonFileSynchroniser=class extends s{constructor(w,f,P,D,M,j,B,W,H,Q,_,Y,$,z){super(w,f,P,D,M,j,B,W,H,Q,_,$,z),this.vb=Y,this.xb=void 0}wb(w,f){const P=[],D=(0,k.parse)(w,P,{allowEmptyContent:!0,allowTrailingComma:!0});return P.length>0||!(0,R.isUndefined)(D)&&f!==Array.isArray(D)}yb(){return this.xb||(this.xb=this.vb.resolveFormattingOptions(this.i)),this.xb}};e.AbstractJsonFileSynchroniser=o=ve([J(3,p.IFileService),J(4,g.IEnvironmentService),J(5,h.IStorageService),J(6,S.IUserDataSyncStoreService),J(7,S.IUserDataSyncBackupStoreService),J(8,S.IUserDataSyncEnablementService),J(9,u.ITelemetryService),J(10,S.IUserDataSyncLogService),J(11,S.IUserDataSyncUtilService),J(12,m.IConfigurationService),J(13,d.IUriIdentityService)],o);let c=e.AbstractInitializer=class{constructor(w,f,P,D,M,j,B){this.resource=w,this.g=f,this.h=P,this.j=D,this.k=M,this.l=j,this.d=B.extUri,this.f=(0,S.getLastSyncResourceUri)(void 0,this.resource,P,this.d)}async initialize({ref:w,content:f}){if(!f){this.j.info("Remote content does not exist.",this.resource);return}const P=this.m(f);if(P)try{await this.o({ref:w,syncData:P})}catch(D){this.j.error(D)}}m(w){try{const f=JSON.parse(w);if(r(f))return f}catch(f){this.j.error(f)}this.j.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async n(w,f={}){if(f.ref||f.version)throw new Error("Cannot have core properties as additional");const P={ref:w.ref,version:void 0,...f};this.l.store(`${this.resource}.lastSyncUserData`,JSON.stringify(P),-1,1),await this.k.writeFile(this.f,l.VSBuffer.fromString(JSON.stringify(w)))}};e.AbstractInitializer=c=ve([J(1,L.IUserDataProfilesService),J(2,g.IEnvironmentService),J(3,E.ILogService),J(4,p.IFileService),J(5,h.IStorageService),J(6,d.IUriIdentityService)],c)}),define(oe[119],ae([0,1,6,26,9,3,42,2,27,17,15,118,29,33,81,13,5,72,10,19,20,30,18,40,247,116,23,60]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u,d,S,L,n,r,t,i,s,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.LocalExtensionsProvider=e.ExtensionsSynchroniser=e.stringify=e.parseExtensions=void 0;async function c(M,j){const B=JSON.parse(M.content);if(M.version===1||M.version===2){const W=(await j.getInstalled(0)).filter(H=>H.isBuiltin);for(const H of B)M.version===1&&(H.enabled===!1&&(H.disabled=!0),delete H.enabled),M.version===2&&W.every(Q=>!(0,g.areSameExtensions)(Q.identifier,H.identifier))&&(H.installed=!0)}return B}function y(M){return JSON.parse(M.content)}e.parseExtensions=y;function w(M,j){return M.sort((B,W)=>!B.identifier.uuid&&W.identifier.uuid?-1:B.identifier.uuid&&!W.identifier.uuid?1:(0,I.compare)(B.identifier.id,W.identifier.id)),j?(0,T.toFormattedString)(M,{}):JSON.stringify(M)}e.stringify=w;let f=e.ExtensionsSynchroniser=class extends r.AbstractSynchroniser{constructor(j,B,W,H,Q,_,Y,$,z,x,te,ne,re,X,K,F,C){super({syncResource:"extensions",profile:j},B,H,W,Q,_,Y,ne,re,x,te,K),this.zb=$,this.Ab=z,this.Bb=C,this.nb=5,this.tb=this.h.joinPath(this.g,"extensions.json"),this.ub=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"base"}),this.vb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"local"}),this.wb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.xb=this.tb.with({scheme:s.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.yb=this.Bb.createInstance(P),this.B(O.Event.any(O.Event.filter(this.zb.onDidInstallExtensions,U=>U.some(({local:q})=>!!q)),O.Event.filter(this.zb.onDidUninstallExtension,U=>!U.error),O.Event.filter(F.onDidChange,U=>U.valueChanges.some(({profile:q,changes:G})=>this.syncResource.profile.id===q.id&&G.some(V=>V.key===m.DISABLED_EXTENSIONS_STORAGE_PATH))),X.onDidChangeExtensionStorageToSync)(()=>this.N()))}async ob(j,B){const W=j.syncData?await c(j.syncData,this.zb):null,H=B?.skippedExtensions??[],Q=B?.builtinExtensions??null,_=B?.syncData?await c(B.syncData,this.zb):null,{localExtensions:Y,ignoredExtensions:$}=await this.yb.getLocalExtensions(this.syncResource.profile);W?this.L.trace(`${this.y}: Merging remote extensions with local extensions...`):this.L.trace(`${this.y}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:z,remote:x}=(0,t.merge)(Y,W,_,H,$,Q),te={local:z,remote:x,content:this.Eb(Y,z.added,z.updated,z.removed),localChange:z.added.length>0||z.removed.length>0||z.updated.length>0?2:0,remoteChange:x!==null?2:0},ne=this.Lb(Y,!1);return[{skippedExtensions:H,builtinExtensions:Q,baseResource:this.ub,baseContent:_?this.Lb(_,!1):ne,localResource:this.vb,localContent:ne,localExtensions:Y,remoteResource:this.wb,remoteExtensions:W,remoteContent:W?this.Lb(W,!1):null,previewResource:this.tb,previewResult:te,localChange:te.localChange,remoteChange:te.remoteChange,acceptedResource:this.xb}]}async sb(j){const B=j.syncData?await c(j.syncData,this.zb):null,{localExtensions:W,ignoredExtensions:H}=await this.yb.getLocalExtensions(this.syncResource.profile),{remote:Q}=(0,t.merge)(W,B,B,j.skippedExtensions||[],H,j.builtinExtensions||[]);return Q!==null}Eb(j,B,W,H){const Q=[...B,...W],_=new Set,Y=$=>{_.add($.id.toLowerCase()),$.uuid&&_.add($.uuid)};Q.forEach(({identifier:$})=>Y($)),H.forEach(Y);for(const $ of j)_.has($.identifier.id.toLowerCase())||$.identifier.uuid&&_.has($.identifier.uuid)||Q.push($);return this.Lb(Q,!1)}async pb(j,B){return{...j.previewResult,hasConflicts:!1}}async qb(j,B,W,H){if(this.h.isEqual(B,this.vb))return this.Hb(j);if(this.h.isEqual(B,this.wb))return this.Ib(j);if(this.h.isEqual(B,this.tb))return j.previewResult;throw new Error(`Invalid Resource: ${B.toString()}`)}async Hb(j){const B=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),W=this.Ab.getIgnoredExtensions(B),H=(0,t.merge)(j.localExtensions,null,null,j.skippedExtensions,W,j.builtinExtensions),{local:Q,remote:_}=H;return{content:j.localContent,local:Q,remote:_,localChange:Q.added.length>0||Q.removed.length>0||Q.updated.length>0?2:0,remoteChange:_!==null?2:0}}async Ib(j){const B=await this.zb.getInstalled(void 0,this.syncResource.profile.extensionsResource),W=this.Ab.getIgnoredExtensions(B),H=j.remoteContent?JSON.parse(j.remoteContent):null;if(H!==null){const Q=(0,t.merge)(j.localExtensions,H,j.localExtensions,[],W,j.builtinExtensions),{local:_,remote:Y}=Q;return{content:j.remoteContent,local:_,remote:Y,localChange:_.added.length>0||_.removed.length>0||_.updated.length>0?2:0,remoteChange:Y!==null?2:0}}else return{content:j.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(j,B,W,H){let{skippedExtensions:Q,builtinExtensions:_,localExtensions:Y}=W[0][0];const{local:$,remote:z,localChange:x,remoteChange:te}=W[0][1];if(x===0&&te===0&&this.L.info(`${this.y}: No changes found during synchronizing extensions.`),x!==0&&(await this.lb(JSON.stringify(Y)),Q=await this.yb.updateLocalExtensions($.added,$.removed,$.updated,Q,this.syncResource.profile)),z){this.L.trace(`${this.y}: Updating remote extensions...`);const ne=JSON.stringify(z.all);j=await this.kb(ne,H?null:j.ref),this.L.info(`${this.y}: Updated remote extensions.${z.added.length?` Added: ${JSON.stringify(z.added.map(re=>re.identifier.id))}.`:""}${z.updated.length?` Updated: ${JSON.stringify(z.updated.map(re=>re.identifier.id))}.`:""}${z.removed.length?` Removed: ${JSON.stringify(z.removed.map(re=>re.identifier.id))}.`:""}`)}B?.ref!==j.ref&&(this.L.trace(`${this.y}: Updating last synchronized extensions...`),_=this.Kb(Y,_),await this.db(j,{skippedExtensions:Q,builtinExtensions:_}),this.L.info(`${this.y}: Updated last synchronized extensions.${Q.length?` Skipped: ${JSON.stringify(Q.map(ne=>ne.identifier.id))}.`:""}`))}Kb(j,B){const W=new Set,H=[];for(const Q of j)W.add(Q.identifier.id.toLowerCase()),Q.installed||H.push(Q.identifier);if(B)for(const Q of B)W.has(Q.id.toLowerCase())||H.push(Q);return H}async resolveContent(j){if(this.h.isEqual(this.wb,j)||this.h.isEqual(this.ub,j)||this.h.isEqual(this.vb,j)||this.h.isEqual(this.xb,j)){const B=await this.bb(j);return B&&this.Lb(JSON.parse(B),!0)}return null}Lb(j,B){return w(j,B)}async hasLocalData(){try{const{localExtensions:j}=await this.yb.getLocalExtensions(this.syncResource.profile);if(j.some(B=>B.installed||B.disabled))return!0}catch{}return!1}};e.ExtensionsSynchroniser=f=ve([J(2,R.IEnvironmentService),J(3,E.IFileService),J(4,d.IStorageService),J(5,s.IUserDataSyncStoreService),J(6,s.IUserDataSyncBackupStoreService),J(7,m.IExtensionManagementService),J(8,i.IIgnoredExtensionsManagementService),J(9,s.IUserDataSyncLogService),J(10,v.IConfigurationService),J(11,s.IUserDataSyncEnablementService),J(12,S.ITelemetryService),J(13,p.IExtensionStorageService),J(14,L.IUriIdentityService),J(15,o.IUserDataProfileStorageService),J(16,a.IInstantiationService)],f);let P=e.LocalExtensionsProvider=class{constructor(j,B,W,H,Q,_){this.a=j,this.b=B,this.c=W,this.d=H,this.f=Q,this.g=_}async getLocalExtensions(j){const B=await this.a.getInstalled(void 0,j.extensionsResource),W=this.d.getIgnoredExtensions(B);return{localExtensions:await this.j(j,async(Q,_)=>{const Y=Q.getDisabledExtensions();return B.map($=>{const{identifier:z,isBuiltin:x,manifest:te,preRelease:ne,pinned:re}=$,X={identifier:z,preRelease:ne,version:te.version,pinned:!!re};Y.some(K=>(0,g.areSameExtensions)(K,z))&&(X.disabled=!0),x||(X.installed=!0);try{const K=_.getKeysForSync({id:z.id,version:te.version});if(K){const F=_.getExtensionState($,!0)||{};X.state=Object.keys(F).reduce((C,U)=>(K.includes(U)&&(C[U]=F[U]),C),{})}}catch(K){this.g.info(`${(0,r.getSyncResourceLogLabel)("extensions",j)}: Error while parsing extension state`,(0,l.getErrorMessage)(K))}return X})}),ignoredExtensions:W}}async updateLocalExtensions(j,B,W,H,Q){const _=(0,r.getSyncResourceLogLabel)("extensions",Q),Y=[],$=[],z=[],x=await this.a.getInstalled(void 0,Q.extensionsResource);if((j.length||W.length)&&await this.j(Q,async(ne,re)=>{await A.Promises.settled([...j,...W].map(async X=>{const K=x.find(U=>(0,g.areSameExtensions)(U.identifier,X.identifier));if(K&&K.isBuiltin){X.state&&K.manifest.version===X.version&&this.h(X.state,K,K.manifest.version,re),ne.getDisabledExtensions().some(q=>(0,g.areSameExtensions)(q,X.identifier))!==!!X.disabled&&(X.disabled?(this.g.trace(`${_}: Disabling extension...`,X.identifier.id),await ne.disableExtension(X.identifier),this.g.info(`${_}: Disabled extension`,X.identifier.id)):(this.g.trace(`${_}: Enabling extension...`,X.identifier.id),await ne.enableExtension(X.identifier),this.g.info(`${_}: Enabled extension`,X.identifier.id))),$.push(X.identifier);return}const F=X.pinned?X.version:void 0,C=(await this.c.getExtensions([{...X.identifier,version:F,preRelease:F?void 0:X.preRelease}],N.CancellationToken.None))[0];if(X.state&&(K?K.manifest.version===X.version:C)&&this.h(X.state,K||C,K?.manifest.version,re),C)try{ne.getDisabledExtensions().some(q=>(0,g.areSameExtensions)(q,X.identifier))!==!!X.disabled&&(X.disabled?(this.g.trace(`${_}: Disabling extension...`,X.identifier.id,C.version),await ne.disableExtension(C.identifier),this.g.info(`${_}: Disabled extension`,X.identifier.id,C.version)):(this.g.trace(`${_}: Enabling extension...`,X.identifier.id,C.version),await ne.enableExtension(C.identifier),this.g.info(`${_}: Enabled extension`,X.identifier.id,C.version))),(!K||K.preRelease!==X.preRelease||K.pinned!==X.pinned||F&&K.manifest.version!==F)&&(await this.a.canInstall(C)?Y.push([X,C]):(this.g.info(`${_}: Skipped synchronizing extension because it cannot be installed.`,C.displayName||C.identifier.id),z.push(X)))}catch(U){z.push(X),this.g.error(U),this.g.info(`${_}: Skipped synchronizing extension`,C.displayName||C.identifier.id)}else z.push(X),this.g.info(`${_}: Skipped synchronizing extension because the extension is not found.`,X.identifier.id)}))}),B.length){const ne=x.filter(({identifier:re,isBuiltin:X})=>!X&&B.some(K=>(0,g.areSameExtensions)(re,K)));await A.Promises.settled(ne.map(async re=>{this.g.trace(`${_}: Uninstalling local extension...`,re.identifier.id),await this.a.uninstall(re,{donotIncludePack:!0,donotCheckDependents:!0,profileLocation:Q.extensionsResource}),this.g.info(`${_}: Uninstalled local extension.`,re.identifier.id),$.push(re.identifier)}))}for(const[ne,re]of Y)try{this.g.trace(`${_}: Installing extension...`,re.identifier.id,re.version),await this.a.installFromGallery(re,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installGivenVersion:ne.pinned&&!!ne.version,installPreReleaseVersion:ne.preRelease,profileLocation:Q.extensionsResource,context:{[m.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT]:!0,[m.EXTENSION_INSTALL_SYNC_CONTEXT]:!0}}),this.g.info(`${_}: Installed extension.`,re.identifier.id,re.version),$.push(re.identifier)}catch(X){z.push(ne),X instanceof m.ExtensionManagementError&&[m.ExtensionManagementErrorCode.Incompatible,m.ExtensionManagementErrorCode.IncompatiblePreRelease,m.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(X.code)?this.g.info(`${_}: Skipped synchronizing extension because the compatible extension is not found.`,re.displayName||re.identifier.id):(this.g.error(X),this.g.info(`${_}: Skipped synchronizing extension`,re.displayName||re.identifier.id))}const te=[];for(const ne of H)$.some(re=>(0,g.areSameExtensions)(re,ne.identifier))||te.push(ne);for(const ne of z)te.some(re=>(0,g.areSameExtensions)(re.identifier,ne.identifier))||te.push(ne);return te}h(j,B,W,H){const Q=H.getExtensionState(B,!0)||{},_=W?H.getKeysForSync({id:B.identifier.id,version:W}):void 0;_?_.forEach(Y=>{Q[Y]=j[Y]}):Object.keys(j).forEach(Y=>Q[Y]=j[Y]),H.setExtensionState(B,Q,!0)}async j(j,B){return this.b.withProfileScopedStorageService(j,async W=>{const H=new k.DisposableStore,Q=this.f.createChild(new h.ServiceCollection([d.IStorageService,W])),_=H.add(Q.createInstance(b.GlobalExtensionEnablementService)),Y=H.add(Q.createInstance(p.ExtensionStorageService));try{return await B(_,Y)}finally{H.dispose()}})}};e.LocalExtensionsProvider=P=ve([J(0,m.IExtensionManagementService),J(1,o.IUserDataProfileStorageService),J(2,m.IExtensionGalleryService),J(3,i.IIgnoredExtensionsManagementService),J(4,a.IInstantiationService),J(5,s.IUserDataSyncLogService)],P);let D=e.AbstractExtensionsInitializer=class extends r.AbstractInitializer{constructor(j,B,W,H,Q,_,Y,$){super("extensions",H,Q,_,W,Y,$),this.p=j,this.q=B}async t(j){return j.syncData?await c(j.syncData,this.p):null}u(j,B){const W=[],H=[],Q=[];for(const _ of j){if(this.q.hasToNeverSyncExtension(_.identifier.id))continue;const Y=B.find($=>(0,g.areSameExtensions)($.identifier,_.identifier));Y?(W.push(Y),_.disabled&&Q.push(_.identifier)):_.installed&&(H.push({..._.identifier,preRelease:!!_.preRelease}),_.disabled&&Q.push(_.identifier))}return{installedExtensions:W,newExtensions:H,disabledExtensions:Q,remoteExtensions:j}}};e.AbstractExtensionsInitializer=D=ve([J(0,m.IExtensionManagementService),J(1,i.IIgnoredExtensionsManagementService),J(2,E.IFileService),J(3,n.IUserDataProfilesService),J(4,R.IEnvironmentService),J(5,u.ILogService),J(6,d.IStorageService),J(7,L.IUriIdentityService)],D)}),define(oe[120],ae([0,1,16,9,3,35,42,4,32,17,15,13,10,44,19,20,30,40,59,251,23,18,60,5]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u,d,S,L,n,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.LocalGlobalStateProvider=e.GlobalStateSynchroniser=e.stringify=void 0;const t="globalState.argv.",i=["locale"];function s(P,D){const M=P.storage?Object.keys(P.storage).sort():[],j={};return M.forEach(B=>j[B]=P.storage[B]),P.storage=j,D?(0,T.toFormattedString)(P,{}):JSON.stringify(P)}e.stringify=s;const o=1;let c=e.GlobalStateSynchroniser=class extends h.AbstractSynchroniser{constructor(D,M,j,B,W,H,Q,_,Y,$,z,x,te,ne){super({syncResource:"globalState",profile:D},M,B,_,x,W,H,Y,$,Q,z,te),this.xb=j,this.nb=o,this.p=this.h.joinPath(this.g,"globalState.json"),this.r=this.p.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"base"}),this.tb=this.p.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"local"}),this.ub=this.p.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.vb=this.p.with({scheme:S.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.wb=ne.createInstance(y),this.B(B.watch(this.h.dirname(this.D.argvResource))),this.B(l.Event.any(l.Event.filter(B.onDidFilesChange,re=>re.contains(this.D.argvResource)),l.Event.filter(j.onDidChange,re=>!!(re.targetChanges.some(X=>this.syncResource.profile.id===X.id)||re.valueChanges.some(({profile:X,changes:K})=>this.syncResource.profile.id===X.id&&K.some(F=>F.target===0)))))(()=>this.N()))}async ob(D,M,j){const B=D.syncData?JSON.parse(D.syncData.content):null;M=M===null&&j?D:M;const W=M&&M.syncData?JSON.parse(M.syncData.content):null,H=await this.wb.getLocalGlobalState(this.syncResource.profile);B?this.L.trace(`${this.y}: Merging remote ui state with local ui state...`):this.L.trace(`${this.y}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const Q=await this.Fb(W),{local:_,remote:Y}=(0,d.merge)(H.storage,B?B.storage:null,W?W.storage:null,Q,this.L),$={content:null,local:_,remote:Y,localChange:Object.keys(_.added).length>0||Object.keys(_.updated).length>0||_.removed.length>0?2:0,remoteChange:Y.all!==null?2:0},z=s(H,!1);return[{baseResource:this.r,baseContent:W?s(W,!1):z,localResource:this.tb,localContent:z,localUserData:H,remoteResource:this.ub,remoteContent:B?s(B,!1):null,previewResource:this.p,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.vb,storageKeys:Q}]}async sb(D){const M=D.syncData?JSON.parse(D.syncData.content):null;if(M===null)return!0;const j=await this.wb.getLocalGlobalState(this.syncResource.profile),B=await this.Fb(M),{remote:W}=(0,d.merge)(j.storage,M.storage,M.storage,B,this.L);return W.all!==null}async pb(D,M){return{...D.previewResult,hasConflicts:!1}}async qb(D,M,j,B){if(this.h.isEqual(M,this.tb))return this.Cb(D);if(this.h.isEqual(M,this.ub))return this.Db(D);if(this.h.isEqual(M,this.p))return D.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async Cb(D){return{content:D.localContent,local:{added:{},removed:[],updated:{}},remote:{added:Object.keys(D.localUserData.storage),removed:[],updated:[],all:D.localUserData.storage},localChange:0,remoteChange:2}}async Db(D){if(D.remoteContent!==null){const M=JSON.parse(D.remoteContent),{local:j,remote:B}=(0,d.merge)(D.localUserData.storage,M.storage,null,D.storageKeys,this.L);return{content:D.remoteContent,local:j,remote:B,localChange:Object.keys(j.added).length>0||Object.keys(j.updated).length>0||j.removed.length>0?2:0,remoteChange:B!==null?2:0}}else return{content:D.remoteContent,local:{added:{},removed:[],updated:{}},remote:{added:[],removed:[],updated:[],all:null},localChange:0,remoteChange:0}}async rb(D,M,j,B){const{localUserData:W}=j[0][0],{local:H,remote:Q,localChange:_,remoteChange:Y}=j[0][1];if(_===0&&Y===0&&this.L.info(`${this.y}: No changes found during synchronizing ui state.`),_!==0&&(this.L.trace(`${this.y}: Updating local ui state...`),await this.lb(JSON.stringify(W)),await this.wb.writeLocalGlobalState(H,this.syncResource.profile),this.L.info(`${this.y}: Updated local ui state`)),Y!==0){this.L.trace(`${this.y}: Updating remote ui state...`);const $=JSON.stringify({storage:Q.all});D=await this.kb($,B?null:D.ref),this.L.info(`${this.y}: Updated remote ui state.${Q.added.length?` Added: ${Q.added}.`:""}${Q.updated.length?` Updated: ${Q.updated}.`:""}${Q.removed.length?` Removed: ${Q.removed}.`:""}`)}M?.ref!==D.ref&&(this.L.trace(`${this.y}: Updating last synchronized ui state...`),await this.db(D),this.L.info(`${this.y}: Updated last synchronized ui state`))}async resolveContent(D){if(this.h.isEqual(this.ub,D)||this.h.isEqual(this.r,D)||this.h.isEqual(this.tb,D)||this.h.isEqual(this.vb,D)){const M=await this.bb(D);return M&&s(JSON.parse(M),!0)}return null}async hasLocalData(){try{const{storage:D}=await this.wb.getLocalGlobalState(this.syncResource.profile);if(Object.keys(D).length>1||D[`${t}.locale`]?.value!=="en")return!0}catch{}return!1}async Fb(D){const M=await this.xb.readStorageData(this.syncResource.profile),j=[],B=[];for(const[Q,_]of M)_.target===0?j.push(Q):_.target===1&&B.push(Q);const W=[...j,...B],H=D?.storage?Object.keys(D.storage).filter(Q=>!Q.startsWith(t)&&!W.includes(Q)&&M.get(Q)!==void 0):[];if(!k.isWeb){const Q=[...S.ALL_SYNC_RESOURCES.map(_=>(0,S.getEnablementKey)(_)),S.SYNC_SERVICE_URL_TYPE];H.push(...Q),B.push(...Q)}return{user:j,machine:B,unregistered:H}}};e.GlobalStateSynchroniser=c=ve([J(2,n.IUserDataProfileStorageService),J(3,b.IFileService),J(4,S.IUserDataSyncStoreService),J(5,S.IUserDataSyncBackupStoreService),J(6,S.IUserDataSyncLogService),J(7,R.IEnvironmentService),J(8,S.IUserDataSyncEnablementService),J(9,E.ITelemetryService),J(10,v.IConfigurationService),J(11,p.IStorageService),J(12,a.IUriIdentityService),J(13,r.IInstantiationService)],c);let y=e.LocalGlobalStateProvider=class{constructor(D,M,j,B){this.a=D,this.b=M,this.c=j,this.d=B}async getLocalGlobalState(D){const M={};if(D.isDefault){const B=await this.f(),W=(0,O.parse)(B);for(const H of i)W[H]!==void 0&&(M[`${t}${H}`]={version:1,value:W[H]})}const j=await this.c.readStorageData(D);for(const[B,W]of j)W.value&&W.target===0&&(M[B]={version:1,value:W.value});return{storage:M}}async f(){try{this.d.debug("GlobalStateSync#getLocalArgvContent",this.b.argvResource);const D=await this.a.readFile(this.b.argvResource);return this.d.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.b.argvResource),D.value.toString()}catch(D){this.d.debug((0,N.getErrorMessage)(D))}return"{}"}async writeLocalGlobalState({added:D,removed:M,updated:j},B){const W=(0,h.getSyncResourceLogLabel)("globalState",B),H={},Q=new Map,_=await this.c.readStorageData(B),Y=($,z)=>{for(const x of $){if(x.startsWith(t)){H[x.substring(t.length)]=z?z[x].value:void 0;continue}if(z){const te=z[x];te.value!==_.get(x)?.value&&Q.set(x,te.value)}else _.get(x)!==void 0&&Q.set(x,void 0)}};if(Y(Object.keys(D),D),Y(Object.keys(j),j),Y(M),Object.keys(H).length){this.d.trace(`${W}: Updating locale...`);const $=await this.f();let z=$;for(const x of Object.keys(H))z=(0,u.edit)(z,[x],H[x],{});$!==z&&(this.d.trace(`${W}: Updating locale...`),await this.a.writeFile(this.b.argvResource,A.VSBuffer.fromString(z)),this.d.info(`${W}: Updated locale.`)),this.d.info(`${W}: Updated locale`)}Q.size&&(this.d.trace(`${W}: Updating global state...`),await this.c.updateStorageData(B,Q,0),this.d.info(`${W}: Updated global state`,[...Q.keys()]))}};e.LocalGlobalStateProvider=y=ve([J(0,b.IFileService),J(1,R.IEnvironmentService),J(2,n.IUserDataProfileStorageService),J(3,S.IUserDataSyncLogService)],y);let w=e.GlobalStateInitializer=class extends h.AbstractInitializer{constructor(D,M,j,B,W,H){super("globalState",j,B,W,M,D,H)}async o(D){const M=D.syncData?JSON.parse(D.syncData.content):null;if(!M){this.j.info("Skipping initializing global state because remote global state does not exist.");return}const j={},B={};for(const W of Object.keys(M.storage))W.startsWith(t)?j[W.substring(t.length)]=M.storage[W].value:this.l.get(W,0)===void 0&&(B[W]=M.storage[W].value);if(Object.keys(j).length){let W="{}";try{W=(await this.k.readFile(this.h.argvResource)).value.toString()}catch{}for(const H of Object.keys(j))W=(0,u.edit)(W,[H],j[H],{});await this.k.writeFile(this.h.argvResource,A.VSBuffer.fromString(W))}if(Object.keys(B).length)for(const W of Object.keys(B))this.l.store(W,B[W],0,0)}};e.GlobalStateInitializer=w=ve([J(0,p.IStorageService),J(1,b.IFileService),J(2,L.IUserDataProfilesService),J(3,R.IEnvironmentService),J(4,S.IUserDataSyncLogService),J(5,a.IUriIdentityService)],w);let f=e.UserDataSyncStoreTypeSynchronizer=class{constructor(D,M,j,B,W){this.a=D,this.b=M,this.c=j,this.d=B,this.f=W}getSyncStoreType(D){return this.h(D)?.storage[S.SYNC_SERVICE_URL_TYPE]?.value}async sync(D){const M=(0,S.createSyncHeaders)((0,I.generateUuid)());try{return await this.g(D,M)}catch(j){if(j instanceof S.UserDataSyncError)switch(j.code){case"PreconditionFailed":return this.f.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.g(D,M)}throw j}}async g(D,M){const j=await this.a.readResource("globalState",null,void 0,M),B=this.h(j)||{storage:{}};B.storage[S.SYNC_SERVICE_URL_TYPE]={value:D,version:o};const W=await(0,g.getServiceMachineId)(this.c,this.d,this.b),H={version:o,machineId:W,content:s(B,!1)};await this.a.writeResource("globalState",JSON.stringify(H),j.ref,void 0,M)}h({content:D}){if(!D)return null;const M=JSON.parse(D);if((0,h.isSyncData)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};e.UserDataSyncStoreTypeSynchronizer=f=ve([J(1,p.IStorageService),J(2,R.IEnvironmentService),J(3,b.IFileService),J(4,m.ILogService)],f)}),define(oe[121],ae([0,1,21,16,3,35,4,11,177,17,15,13,19,20,30,18,40,248,23]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function d(n,r,t){try{const i=JSON.parse(n);if(!r)return(0,k.isUndefined)(i.all)?null:i.all;switch(T.OS){case 2:return(0,k.isUndefined)(i.mac)?null:i.mac;case 3:return(0,k.isUndefined)(i.linux)?null:i.linux;case 1:return(0,k.isUndefined)(i.windows)?null:i.windows}}catch(i){return t.error(i),null}}e.getKeybindingsContentFromSyncContent=d;let S=e.KeybindingsSynchroniser=class extends a.AbstractJsonFileSynchroniser{constructor(r,t,i,s,o,c,y,w,f,P,D,M,j){super(r.keybindingsResource,{syncResource:"keybindings",profile:r},t,w,f,P,i,s,y,M,o,D,c,j),this.nb=2,this.Ab=this.h.joinPath(this.g,"keybindings.json"),this.Bb=this.Ab.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.Cb=this.Ab.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.Db=this.Ab.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Eb=this.Ab.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.B(l.Event.filter(c.onDidChangeConfiguration,B=>B.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.N()))}async ob(r,t,i,s){const o=r.syncData?d(r.syncData.content,s.keybindingsPerPlatform??this.Mb(),this.L):null;t=t===null&&i?r:t;const c=t?this.Kb(t):null,y=await this.p(),w=await this.yb();let f=null,P=!1,D=!1,M=!1;if(o){let W=y?y.value.toString():"[]";if(W=W||"[]",this.wb(W,!0))throw new u.UserDataSyncError((0,I.localize)(0,null),"LocalInvalidContent",this.resource);if(!c||c!==W||c!==o){this.L.trace(`${this.y}: Merging remote keybindings with local keybindings...`);const H=await(0,h.merge)(W,o,c,w,this.vb);H.hasChanges&&(f=H.mergeContent,M=H.hasConflicts,P=M||H.mergeContent!==W,D=M||H.mergeContent!==o)}}else y&&(this.L.trace(`${this.y}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),f=y.value.toString(),D=!0);const j={content:M?c:f,localChange:P?y?2:1:0,remoteChange:D?2:0,hasConflicts:M},B=y?y.value.toString():null;return[{fileContent:y,baseResource:this.Bb,baseContent:c,localResource:this.Cb,localContent:B,localChange:j.localChange,remoteResource:this.Db,remoteContent:o,remoteChange:j.remoteChange,previewResource:this.Ab,previewResult:j,acceptedResource:this.Eb}]}async sb(r){const t=this.Kb(r);if(t===null)return!0;const i=await this.p(),s=i?i.value.toString():"",o=await this.yb(),c=await(0,h.merge)(s||"[]",t,t,o,this.vb);return c.hasConflicts||c.mergeContent!==t}async pb(r,t){return r.previewResult}async qb(r,t,i,s){if(this.h.isEqual(t,this.Cb))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.Db))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.Ab))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async rb(r,t,i,s){const{fileContent:o}=i[0][0];let{content:c,localChange:y,remoteChange:w}=i[0][1];if(y===0&&w===0&&this.L.info(`${this.y}: No changes found during synchronizing keybindings.`),c!==null&&(c=c.trim(),c=c||"[]",this.wb(c,!0)))throw new u.UserDataSyncError((0,I.localize)(1,null),"LocalInvalidContent",this.resource);if(y!==0&&(this.L.trace(`${this.y}: Updating local keybindings...`),o&&await this.lb(this.Lb(o.value.toString())),await this.r(c||"[]",o,s),this.L.info(`${this.y}: Updated local keybindings`)),w!==0){this.L.trace(`${this.y}: Updating remote keybindings...`);const f=this.Lb(c||"[]",r.syncData?.content);r=await this.kb(f,s?null:r.ref),this.L.info(`${this.y}: Updated remote keybindings`)}try{await this.C.del(this.Ab)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized keybindings...`),await this.db(r,{platformSpecific:this.Mb()}),this.L.info(`${this.y}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=(0,O.parse)(r.value.toString());if((0,A.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.Db,r)||this.h.isEqual(this.Bb,r)||this.h.isEqual(this.Cb,r)||this.h.isEqual(this.Eb,r)?this.bb(r):null}Kb(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.Mb()?null:d(r.syncData.content,this.Mb(),this.L)}Lb(r,t){let i={};try{i=JSON.parse(t||"{}")}catch(s){this.L.error(s)}switch(this.Mb()?delete i.all:i.all=r,T.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}Mb(){return!!this.M.getValue(u.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM)}};e.KeybindingsSynchroniser=S=ve([J(2,u.IUserDataSyncStoreService),J(3,u.IUserDataSyncBackupStoreService),J(4,u.IUserDataSyncLogService),J(5,v.IConfigurationService),J(6,u.IUserDataSyncEnablementService),J(7,b.IFileService),J(8,R.IEnvironmentService),J(9,m.IStorageService),J(10,u.IUserDataSyncUtilService),J(11,g.ITelemetryService),J(12,p.IUriIdentityService)],S);let L=e.KeybindingsInitializer=class extends a.AbstractInitializer{constructor(r,t,i,s,o,c){super("keybindings",t,i,s,r,o,c)}async o(r){const t=r.syncData?this.p(r.syncData.content):null;if(!t){this.j.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing keybindings because local keybindings exist.");return}await this.k.writeFile(this.g.defaultProfile.keybindingsResource,N.VSBuffer.fromString(t)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource),t=(0,O.parse)(r.value.toString());return!(0,A.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}p(r){try{return d(r,!0,this.j)}catch(t){return this.j.error(t),null}}};e.KeybindingsInitializer=L=ve([J(0,b.IFileService),J(1,E.IUserDataProfilesService),J(2,R.IEnvironmentService),J(3,u.IUserDataSyncLogService),J(4,m.IStorageService),J(5,p.IUriIdentityService)],L)}),define(oe[122],ae([0,1,16,3,178,17,75,15,29,13,19,20,30,18,40,59,252,23]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function u(n){return n&&n.settings&&typeof n.settings=="string"&&Object.keys(n).length===1}function d(n){const r=JSON.parse(n);return u(r)?r:{settings:n}}e.parseSettingsSyncContent=d;let S=e.SettingsSynchroniser=class extends p.AbstractJsonFileSynchroniser{constructor(r,t,i,s,o,c,y,w,f,P,D,M,j,B){super(r.settingsResource,{syncResource:"settings",profile:r},t,i,s,o,c,y,D,M,w,f,P,B),this.Ab=j,this.nb=2,this.previewResource=this.h.joinPath(this.g,"settings.json"),this.baseResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:h.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this.Kb=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),i=await this.S(r,t),s=this.Hb(i),o=new T.ConfigurationModelParser(h.USER_DATA_SYNC_CONFIGURATION_SCOPE);return s?.settings&&o.parse(s.settings),o.configurationModel.getValue(h.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async ob(r,t,i){const s=await this.p(),o=await this.yb(),c=this.Hb(r);t=t===null&&i?r:t;const y=t?this.Hb(t):null,w=await this.Lb();let f=null,P=!1,D=!1,M=!1;if(c){let H=s?s.value.toString().trim():"{}";H=H||"{}",this.Mb(H),this.L.trace(`${this.y}: Merging remote settings with local settings...`);const Q=(0,a.merge)(H,c.settings,y?y.settings:null,w,[],o);f=Q.localContent||Q.remoteContent,P=Q.localContent!==null,D=Q.remoteContent!==null,M=Q.hasConflicts}else s&&(this.L.trace(`${this.y}: Remote settings does not exist. Synchronizing settings for the first time.`),f=s.value.toString().trim()||"{}",this.Mb(f),D=!0);const j=s?s.value.toString():null,B=y?.settings??null,W={content:M?B:f,localChange:P?2:0,remoteChange:D?2:0,hasConflicts:M};return[{fileContent:s,baseResource:this.baseResource,baseContent:B,localResource:this.localResource,localContent:j,localChange:W.localChange,remoteResource:this.remoteResource,remoteContent:c?c.settings:null,remoteChange:W.remoteChange,previewResource:this.previewResource,previewResult:W,acceptedResource:this.acceptedResource}]}async sb(r){const t=this.Hb(r);if(t===null)return!0;const i=await this.p(),s=i?i.value.toString().trim():"",o=await this.Lb(),c=await this.yb();return(0,a.merge)(s||"{}",t.settings,t.settings,o,[],c).remoteContent!==null}async pb(r,t){const i=await this.yb(),s=await this.Lb();return{...r.previewResult,content:r.previewResult.content?(0,a.updateIgnoredSettings)(r.previewResult.content,"{}",s,i):null}}async qb(r,t,i,s){const o=await this.yb(),c=await this.Lb();if(this.h.isEqual(t,this.localResource))return{content:r.fileContent?(0,a.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",c,o):null,localChange:0,remoteChange:2};if(this.h.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,a.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",c,o):null,localChange:2,remoteChange:0};if(this.h.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,a.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",c,o):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async rb(r,t,i,s){const{fileContent:o}=i[0][0];let{content:c,localChange:y,remoteChange:w}=i[0][1];if(y===0&&w===0&&this.L.info(`${this.y}: No changes found during synchronizing settings.`),c=c?c.trim():"{}",c=c||"{}",this.Mb(c),y!==0&&(this.L.trace(`${this.y}: Updating local settings...`),o&&await this.lb(JSON.stringify(this.Jb(o.value.toString()))),await this.r(c,o,s),await this.M.reloadConfiguration(3),this.L.info(`${this.y}: Updated local settings`)),w!==0){const f=await this.yb(),P=this.Hb(r),D=await this.Lb(c);c=(0,a.updateIgnoredSettings)(c,P?P.settings:"{}",D,f),this.L.trace(`${this.y}: Updating remote settings...`),r=await this.kb(JSON.stringify(this.Jb(c)),s?null:r.ref),this.L.info(`${this.y}: Updated remote settings`)}try{await this.C.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.L.trace(`${this.y}: Updating last synchronized settings...`),await this.db(r),this.L.info(`${this.y}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.p();if(r){const t=await this.yb(),i=(0,E.edit)(r.value.toString(),[h.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,a.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async resolveContent(r){return this.h.isEqual(this.remoteResource,r)||this.h.isEqual(this.localResource,r)||this.h.isEqual(this.acceptedResource,r)||this.h.isEqual(this.baseResource,r)?this.bb(r):null}async bb(r){let t=await super.bb(r);if(t){const i=await this.yb(),s=await this.Lb();t=(0,a.updateIgnoredSettings)(t,"{}",s,i)}return t}Hb(r){return r.syncData?this.Ib(r.syncData.content):null}Ib(r){try{return d(r)}catch(t){this.L.error(t)}return null}Jb(r){return{settings:r}}async Lb(r){if(!this.Kb){this.Kb=this.vb.resolveDefaultIgnoredSettings();const i=N.Event.any(N.Event.filter(this.Ab.onDidInstallExtensions,s=>s.some(({local:o})=>!!o)),N.Event.filter(this.Ab.onDidUninstallExtension,s=>!s.error))(()=>{i.dispose(),this.Kb=void 0})}const t=await this.Kb;return(0,a.getIgnoredSettings)(t,this.M,r)}Mb(r){if(this.wb(r,!1))throw new h.UserDataSyncError((0,l.localize)(0,null),"LocalInvalidContent",this.resource)}};e.SettingsSynchroniser=S=ve([J(2,v.IFileService),J(3,k.IEnvironmentService),J(4,R.IStorageService),J(5,h.IUserDataSyncStoreService),J(6,h.IUserDataSyncBackupStoreService),J(7,h.IUserDataSyncLogService),J(8,h.IUserDataSyncUtilService),J(9,O.IConfigurationService),J(10,h.IUserDataSyncEnablementService),J(11,b.ITelemetryService),J(12,I.IExtensionManagementService),J(13,m.IUriIdentityService)],S);let L=e.SettingsInitializer=class extends p.AbstractInitializer{constructor(r,t,i,s,o,c){super("settings",t,i,s,r,o,c)}async o(r){const t=r.syncData?this.p(r.syncData.content):null;if(!t){this.j.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing settings because local settings exist.");return}await this.k.writeFile(this.g.defaultProfile.settingsResource,A.VSBuffer.fromString(t.settings)),await this.n(r)}async i(){try{const r=await this.k.readFile(this.g.defaultProfile.settingsResource);return(0,a.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}p(r){try{return d(r)}catch(t){this.j.error(t)}return null}};e.SettingsInitializer=L=ve([J(0,v.IFileService),J(1,g.IUserDataProfilesService),J(2,k.IEnvironmentService),J(3,h.IUserDataSyncLogService),J(4,R.IStorageService),J(5,m.IUriIdentityService)],L)}),define(oe[123],ae([0,1,16,3,31,17,15,13,19,20,30,18,40,249,23]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=e.parseSnippets=void 0;function E(u){return JSON.parse(u.content)}e.parseSnippets=E;let a=e.SnippetsSynchroniser=class extends m.AbstractSynchroniser{constructor(d,S,L,n,r,t,i,s,o,c,y,w){super({syncResource:"snippets",profile:d},S,n,L,r,t,i,c,y,s,o,w),this.nb=1,this.p=d.snippetsHome,this.B(this.C.watch(L.userRoamingDataHome)),this.B(this.C.watch(this.p)),this.B(N.Event.filter(this.C.onDidFilesChange,f=>f.affects(this.p))(()=>this.N()))}async ob(d,S,L){const n=await this.Db(),r=this.Cb(n),t=d.syncData?this.Bb(d.syncData):null;S=S===null&&L?d:S;const i=S&&S.syncData?this.Bb(S.syncData):null;t?this.L.trace(`${this.y}: Merging remote snippets with local snippets...`):this.L.trace(`${this.y}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const s=(0,g.merge)(r,t,i);return this.xb(s,n,t||{},i||{})}async sb(d){const S=d.syncData?this.Bb(d.syncData):null;if(S===null)return!0;const L=await this.Db(),n=this.Cb(L),r=(0,g.merge)(n,S,S);return Object.keys(r.remote.added).length>0||Object.keys(r.remote.updated).length>0||r.remote.removed.length>0||r.conflicts.length>0}async pb(d,S){return d.previewResult}async qb(d,S,L,n){if(this.h.isEqualOrParent(S,this.g.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:d.fileContent?d.fileContent.value.toString():null,localChange:0,remoteChange:d.fileContent?d.remoteContent!==null?2:1:3};if(this.h.isEqualOrParent(S,this.g.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:d.remoteContent,localChange:d.remoteContent!==null?d.fileContent?2:1:3,remoteChange:0};if(this.h.isEqualOrParent(S,this.g))return L===void 0?{content:d.previewResult.content,localChange:d.previewResult.localChange,remoteChange:d.previewResult.remoteChange}:{content:L,localChange:L===null?d.fileContent!==null?3:0:2,remoteChange:L===null?d.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${S.toString()}`)}async rb(d,S,L,n){const r=L.map(([t,i])=>({...t,acceptResult:i}));r.every(({localChange:t,remoteChange:i})=>t===0&&i===0)&&this.L.info(`${this.y}: No changes found during synchronizing snippets.`),r.some(({localChange:t})=>t!==0)&&(await this.yb(r),await this.zb(r,n)),r.some(({remoteChange:t})=>t!==0)&&(d=await this.Ab(r,d,n)),S?.ref!==d.ref&&(this.L.trace(`${this.y}: Updating last synchronized snippets...`),await this.db(d),this.L.info(`${this.y}: Updated last synchronized snippets`));for(const{previewResource:t}of r)try{await this.C.del(t)}catch{}}xb(d,S,L,n){const r=new Map;for(const t of Object.keys(d.local.added)){const i={content:d.local.added[t],hasConflicts:!1,localChange:1,remoteChange:0};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(d.local.updated)){const i={content:d.local.updated[t],hasConflicts:!1,localChange:2,remoteChange:0},s=S[t]?S[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of d.local.removed){const i={content:null,hasConflicts:!1,localChange:3,remoteChange:0},s=S[t]?S[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(d.remote.added)){const i={content:d.remote.added[t],hasConflicts:!1,localChange:0,remoteChange:1},s=S[t]?S[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(d.remote.updated)){const i={content:d.remote.updated[t],hasConflicts:!1,localChange:0,remoteChange:2},s=S[t]?S[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t],localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of d.remote.removed){const i={content:null,hasConflicts:!1,localChange:0,remoteChange:3};r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t],previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of d.conflicts){const i={content:n[t]??null,hasConflicts:!0,localChange:S[t]?2:1,remoteChange:L[t]?2:1},s=S[t]?S[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const t of Object.keys(S))if(!r.has(t)){const i={content:S[t]?S[t].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},s=S[t]?S[t].value.toString():null;r.set(t,{baseResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:n[t]??null,localResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:S[t]||null,localContent:s,remoteResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:L[t]||null,previewResource:this.h.joinPath(this.g,t),previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.h.joinPath(this.g,t).with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...r.values()]}async resolveContent(d){return this.h.isEqualOrParent(d,this.g.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.h.isEqualOrParent(d,this.g.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.h.isEqualOrParent(d,this.g.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.h.isEqualOrParent(d,this.g.with({scheme:p.USER_DATA_SYNC_SCHEME,authority:"accepted"}))?this.bb(d):null}async hasLocalData(){try{const d=await this.Db();if(Object.keys(d).length)return!0}catch{}return!1}async yb(d){const S={};for(const L of d)L.fileContent&&(S[this.h.basename(L.localResource)]=L.fileContent);await this.lb(JSON.stringify(this.Cb(S)))}async zb(d,S){for(const{fileContent:L,acceptResult:n,localResource:r,remoteResource:t,localChange:i}of d)if(i!==0){const s=t?this.h.basename(t):this.h.basename(r),o=this.h.joinPath(this.p,s);i===3?(this.L.trace(`${this.y}: Deleting snippet...`,this.h.basename(o)),await this.C.del(o),this.L.info(`${this.y}: Deleted snippet`,this.h.basename(o))):i===1?(this.L.trace(`${this.y}: Creating snippet...`,this.h.basename(o)),await this.C.createFile(o,A.VSBuffer.fromString(n.content),{overwrite:S}),this.L.info(`${this.y}: Created snippet`,this.h.basename(o))):(this.L.trace(`${this.y}: Updating snippet...`,this.h.basename(o)),await this.C.writeFile(o,A.VSBuffer.fromString(n.content),S?void 0:L),this.L.info(`${this.y}: Updated snippet`,this.h.basename(o)))}}async Ab(d,S,L){const n=S.syncData?this.Bb(S.syncData):{},r=(0,l.deepClone)(n);for(const{acceptResult:t,localResource:i,remoteResource:s,remoteChange:o}of d)if(o!==0){const c=i?this.h.basename(i):this.h.basename(s);o===3?delete r[c]:r[c]=t.content}return(0,g.areSame)(n,r)||(this.L.trace(`${this.y}: Updating remote snippets...`),S=await this.kb(JSON.stringify(r),L?null:S.ref),this.L.info(`${this.y}: Updated remote snippets`)),S}Bb(d){return E(d)}Cb(d){const S={};for(const L of Object.keys(d))S[L]=d[L].value.toString();return S}async Db(){const d={};let S;try{S=await this.C.resolve(this.p)}catch(L){if(L instanceof k.FileOperationError&&L.fileOperationResult===1)return d;throw L}for(const L of S.children||[]){const n=L.resource,r=this.h.extname(n);if(r===".json"||r===".code-snippets"){const t=this.h.relativePath(this.p,n),i=await this.C.readFile(n);d[t]=i}}return d}};e.SnippetsSynchroniser=a=ve([J(2,T.IEnvironmentService),J(3,k.IFileService),J(4,I.IStorageService),J(5,p.IUserDataSyncStoreService),J(6,p.IUserDataSyncBackupStoreService),J(7,p.IUserDataSyncLogService),J(8,O.IConfigurationService),J(9,p.IUserDataSyncEnablementService),J(10,v.ITelemetryService),J(11,R.IUriIdentityService)],a);let h=e.SnippetsInitializer=class extends m.AbstractInitializer{constructor(d,S,L,n,r,t){super("snippets",S,L,n,d,r,t)}async o(d){const S=d.syncData?JSON.parse(d.syncData.content):null;if(!S){this.j.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.i()){this.j.info("Skipping initializing snippets because local snippets exist.");return}for(const n of Object.keys(S)){const r=S[n];if(r){const t=this.d.joinPath(this.g.defaultProfile.snippetsHome,n);await this.k.createFile(t,A.VSBuffer.fromString(r)),this.j.info("Created snippet",this.d.basename(t))}}await this.n(d)}async i(){try{return!(await this.k.resolve(this.g.defaultProfile.snippetsHome)).children?.length}catch(d){return d.fileOperationResult===1}}};e.SnippetsInitializer=h=ve([J(0,k.IFileService),J(1,b.IUserDataProfilesService),J(2,T.IEnvironmentService),J(3,p.IUserDataSyncLogService),J(4,I.IStorageService),J(5,R.IUriIdentityService)],h)}),define(oe[124],ae([0,1,16,17,15,13,19,20,30,18,40,23]),function(ie,e,A,N,l,O,T,k,I,v,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function m(a,h){try{return JSON.parse(a).tasks??null}catch(u){return h.error(u),null}}e.getTasksContentFromSyncContent=m;let g=e.TasksSynchroniser=class extends R.AbstractFileSynchroniser{constructor(h,u,d,S,L,n,r,t,i,s,o,c){super(h.tasksResource,{syncResource:"tasks",profile:h},u,t,i,s,d,S,r,o,L,n,c),this.nb=1,this.wb=this.h.joinPath(this.g,"tasks.json"),this.xb=this.wb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"base"}),this.yb=this.wb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"local"}),this.zb=this.wb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.Ab=this.wb.with({scheme:b.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async ob(h,u,d,S){const L=h.syncData?m(h.syncData.content,this.L):null;u=u===null&&d?h:u;const n=u?.syncData?m(u.syncData.content,this.L):null,r=await this.p();let t=null,i=!1,s=!1,o=!1;if(h.syncData){const w=r?r.value.toString():null;if(!n||n!==w||n!==L){this.L.trace(`${this.y}: Merging remote tasks with local tasks...`);const f=E(w,L,n);t=f.content,o=f.hasConflicts,i=f.hasLocalChanged,s=f.hasRemoteChanged}}else r&&(this.L.trace(`${this.y}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),s=!0);const c={content:o?n:t,localChange:i?r?2:1:0,remoteChange:s?2:0,hasConflicts:o},y=r?r.value.toString():null;return[{fileContent:r,baseResource:this.xb,baseContent:n,localResource:this.yb,localContent:y,localChange:c.localChange,remoteResource:this.zb,remoteContent:L,remoteChange:c.remoteChange,previewResource:this.wb,previewResult:c,acceptedResource:this.Ab}]}async sb(h){const u=h?.syncData?m(h.syncData.content,this.L):null;if(u===null)return!0;const d=await this.p(),S=d?d.value.toString():null,L=E(S,u,u);return L.hasLocalChanged||L.hasRemoteChanged}async pb(h,u){return h.previewResult}async qb(h,u,d,S){if(this.h.isEqual(u,this.yb))return{content:h.fileContent?h.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.h.isEqual(u,this.zb))return{content:h.remoteContent,localChange:2,remoteChange:0};if(this.h.isEqual(u,this.wb))return d===void 0?{content:h.previewResult.content,localChange:h.previewResult.localChange,remoteChange:h.previewResult.remoteChange}:{content:d,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${u.toString()}`)}async rb(h,u,d,S){const{fileContent:L}=d[0][0],{content:n,localChange:r,remoteChange:t}=d[0][1];if(r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing tasks.`),r!==0&&(this.L.trace(`${this.y}: Updating local tasks...`),L&&await this.lb(JSON.stringify(this.Gb(L.value.toString()))),n?await this.r(n,L,S):await this.tb(),this.L.info(`${this.y}: Updated local tasks`)),t!==0){this.L.trace(`${this.y}: Updating remote tasks...`);const i=JSON.stringify(this.Gb(n));h=await this.kb(i,S?null:h.ref),this.L.info(`${this.y}: Updated remote tasks`)}try{await this.C.del(this.wb)}catch{}u?.ref!==h.ref&&(this.L.trace(`${this.y}: Updating last synchronized tasks...`),await this.db(h),this.L.info(`${this.y}: Updated last synchronized tasks`))}async hasLocalData(){return this.C.exists(this.i)}async resolveContent(h){return this.h.isEqual(this.zb,h)||this.h.isEqual(this.xb,h)||this.h.isEqual(this.yb,h)||this.h.isEqual(this.Ab,h)?this.bb(h):null}Gb(h){return h?{tasks:h}:{}}};e.TasksSynchroniser=g=ve([J(2,b.IUserDataSyncStoreService),J(3,b.IUserDataSyncBackupStoreService),J(4,b.IUserDataSyncLogService),J(5,N.IConfigurationService),J(6,b.IUserDataSyncEnablementService),J(7,O.IFileService),J(8,l.IEnvironmentService),J(9,T.IStorageService),J(10,k.ITelemetryService),J(11,I.IUriIdentityService)],g);let p=e.TasksInitializer=class extends R.AbstractInitializer{constructor(h,u,d,S,L,n){super("tasks",u,d,S,h,L,n),this.c=this.g.defaultProfile.tasksResource}async o(h){const u=h.syncData?m(h.syncData.content,this.j):null;if(!u){this.j.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.p()){this.j.info("Skipping initializing tasks because local tasks exist.");return}await this.k.writeFile(this.c,A.VSBuffer.fromString(u)),await this.n(h)}async p(){return this.k.exists(this.c)}};e.TasksInitializer=p=ve([J(0,O.IFileService),J(1,v.IUserDataProfilesService),J(2,l.IEnvironmentService),J(3,b.IUserDataSyncLogService),J(4,T.IStorageService),J(5,I.IUriIdentityService)],p);function E(a,h,u){if(a===null&&h===null&&u===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(a===h)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const d=u!==a,S=u!==h;return!d&&!S?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:d&&!S?{content:a,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:S&&!d?{content:h,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:a,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(oe[125],ae([0,1,42,17,15,13,19,20,30,18,40,250,23]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseUserDataProfilesManifest=e.stringifyLocalProfiles=e.UserDataProfilesManifestSynchroniser=void 0;let g=e.UserDataProfilesManifestSynchroniser=class extends R.AbstractSynchroniser{constructor(h,u,d,S,L,n,r,t,i,s,o,c,y){super({syncResource:"profiles",profile:h},u,S,L,n,r,t,o,c,i,s,y),this.r=d,this.nb=1,this.previewResource=this.h.joinPath(this.g,"profiles.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async getLastSyncedProfiles(){const h=await this.getLastSyncUserData();return h?.syncData?E(h.syncData):null}async getRemoteSyncedProfiles(h){const u=await this.getLastSyncUserData(),d=await this.S(h,u);return d?.syncData?E(d.syncData):null}async ob(h,u,d){if(!this.r.isEnabled())throw new m.UserDataSyncError("Cannot sync profiles because they are disabled","LocalError");const S=h.syncData?E(h.syncData):null,L=u?.syncData?E(u.syncData):null,n=this.Ab(),{local:r,remote:t}=(0,b.merge)(n,S,L,[]),i={local:r,remote:t,content:L?this.Bb(L):null,localChange:r.added.length>0||r.removed.length>0||r.updated.length>0?2:0,remoteChange:t!==null?2:0},s=p(n,!1);return[{baseResource:this.baseResource,baseContent:L?this.Bb(L):null,localResource:this.localResource,localContent:s,remoteResource:this.remoteResource,remoteContent:S?this.Bb(S):null,remoteProfiles:S,previewResource:this.previewResource,previewResult:i,localChange:i.localChange,remoteChange:i.remoteChange,acceptedResource:this.acceptedResource}]}async sb(h){const u=h?.syncData?E(h.syncData):null,d=this.Ab(),{remote:S}=(0,b.merge)(d,u,u,[]);return!!S?.added.length||!!S?.removed.length||!!S?.updated.length}async pb(h,u){return{...h.previewResult,hasConflicts:!1}}async qb(h,u,d,S){if(this.h.isEqual(u,this.localResource))return this.xb(h);if(this.h.isEqual(u,this.remoteResource))return this.yb(h);if(this.h.isEqual(u,this.previewResource))return h.previewResult;throw new Error(`Invalid Resource: ${u.toString()}`)}async xb(h){const u=this.Ab(),d=(0,b.merge)(u,null,null,[]),{local:S,remote:L}=d;return{content:h.localContent,local:S,remote:L,localChange:S.added.length>0||S.removed.length>0||S.updated.length>0?2:0,remoteChange:L!==null?2:0}}async yb(h){const u=h.remoteContent?JSON.parse(h.remoteContent):null,d=[],S=[];for(const L of this.Ab()){const n=u?.find(r=>r.id===L.id);n&&(d.push({id:L.id,name:L.name,collection:n.collection}),S.push(L))}if(u!==null){const L=(0,b.merge)(S,u,d,[]),{local:n,remote:r}=L;return{content:h.remoteContent,local:n,remote:r,localChange:n.added.length>0||n.removed.length>0||n.updated.length>0?2:0,remoteChange:r!==null?2:0}}else return{content:h.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async rb(h,u,d,S){const{local:L,remote:n,localChange:r,remoteChange:t}=d[0][1];r===0&&t===0&&this.L.info(`${this.y}: No changes found during synchronizing profiles.`);const i=d[0][0].remoteProfiles||[];if(i.length+(n?.added.length??0)-(n?.removed.length??0)>20)throw new m.UserDataSyncError("Too many profiles to sync. Please remove some profiles and try again.","LocalTooManyProfiles");if(r!==0){await this.lb(p(this.Ab(),!1));const s=[];for(const o of L.added)s.push((async()=>{this.L.trace(`${this.y}: Creating '${o.name}' profile...`),await this.r.createProfile(o.id,o.name,{shortName:o.shortName}),this.L.info(`${this.y}: Created profile '${o.name}'.`)})());for(const o of L.removed)s.push((async()=>{this.L.trace(`${this.y}: Removing '${o.name}' profile...`),await this.r.removeProfile(o),this.L.info(`${this.y}: Removed profile '${o.name}'.`)})());for(const o of L.updated){const c=this.r.profiles.find(y=>y.id===o.id);c?s.push((async()=>{this.L.trace(`${this.y}: Updating '${o.name}' profile...`),await this.r.updateProfile(c,{name:o.name,shortName:o.shortName}),this.L.info(`${this.y}: Updated profile '${o.name}'.`)})()):this.L.info(`${this.y}: Could not find profile with id '${o.id}' to update.`)}await Promise.all(s)}if(t!==0){this.L.trace(`${this.y}: Updating remote profiles...`);const s=[],o=i.length+(n?.added.length??0)<=20;if(o)for(const c of n?.added||[]){const y=await this.G.createCollection(this.z);s.push(y),i.push({id:c.id,name:c.name,collection:y,shortName:c.shortName})}else this.L.info(`${this.y}: Could not create remote profiles as there are too many profiles.`);for(const c of n?.removed||[])i.splice(i.findIndex(({id:y})=>c.id===y),1);for(const c of n?.updated||[]){const y=i.find(({id:w})=>c.id===w);y&&i.splice(i.indexOf(y),1,{id:c.id,name:c.name,collection:y.collection,shortName:c.shortName})}try{h=await this.updateRemoteProfiles(i,S?null:h.ref),this.L.info(`${this.y}: Updated remote profiles.${o&&n?.added.length?` Added: ${JSON.stringify(n.added.map(c=>c.name))}.`:""}${n?.updated.length?` Updated: ${JSON.stringify(n.updated.map(c=>c.name))}.`:""}${n?.removed.length?` Removed: ${JSON.stringify(n.removed.map(c=>c.name))}.`:""}`)}catch(c){if(s.length){this.L.info(`${this.y}: Failed to update remote profiles. Cleaning up added collections...`);for(const y of s)await this.G.deleteCollection(y,this.z)}throw c}for(const c of n?.removed||[])await this.G.deleteCollection(c.collection,this.z)}u?.ref!==h.ref&&(this.L.trace(`${this.y}: Updating last synchronized profiles...`),await this.db(h),this.L.info(`${this.y}: Updated last synchronized profiles.`))}async updateRemoteProfiles(h,u){return this.kb(this.Bb(h),u)}async hasLocalData(){return this.Ab().length>0}async resolveContent(h){if(this.h.isEqual(this.remoteResource,h)||this.h.isEqual(this.baseResource,h)||this.h.isEqual(this.localResource,h)||this.h.isEqual(this.acceptedResource,h)){const u=await this.bb(h);return u&&(0,A.toFormattedString)(JSON.parse(u),{})}return null}Ab(){return this.r.profiles.filter(h=>!h.isDefault&&!h.isTransient)}Bb(h){return JSON.stringify([...h].sort((u,d)=>u.name.localeCompare(d.name)))}};e.UserDataProfilesManifestSynchroniser=g=ve([J(2,v.IUserDataProfilesService),J(3,O.IFileService),J(4,l.IEnvironmentService),J(5,T.IStorageService),J(6,m.IUserDataSyncStoreService),J(7,m.IUserDataSyncBackupStoreService),J(8,m.IUserDataSyncLogService),J(9,N.IConfigurationService),J(10,m.IUserDataSyncEnablementService),J(11,k.ITelemetryService),J(12,I.IUriIdentityService)],g);function p(a,h){const u=[...a].sort((d,S)=>d.name.localeCompare(S.name)).map(d=>({id:d.id,name:d.name}));return h?(0,A.toFormattedString)(u,{}):JSON.stringify(u)}e.stringifyLocalProfiles=p;function E(a){return JSON.parse(a.content)}e.parseUserDataProfilesManifest=E}),define(oe[267],ae([0,1,6,16,64,2,22,17,15,13,18,23]),function(ie,e,A,N,l,O,T,k,I,v,R,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let m=e.UserDataSyncBackupStoreService=class extends O.Disposable{constructor(p,E,a,h,u){super(),this.a=p,this.b=E,this.c=a,this.f=h,this.g=u,this.h()}async h(){for(const E of this.g.profiles)for(const a of b.ALL_SYNC_RESOURCES)try{await this.j(this.i(E,a))}catch(h){this.f.error(h)}let p;try{p=await this.b.resolve(this.a.userDataSyncHome)}catch(E){(0,v.toFileOperationResult)(E)!==1&&this.f.error(E);return}if(p.children){for(const E of p.children)if(E.isDirectory&&!this.g.profiles.some(a=>a.id===E.name))try{this.f.info("Deleting non existing profile from backup",E.resource.path),await this.b.del(E.resource,{recursive:!0})}catch(a){this.f.error(a)}}}async getAllRefs(p,E){const a=this.i(p,E);try{const h=await this.b.resolve(a);if(h.children)return h.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort().reverse().map(d=>({ref:d.name,created:this.k(d)}))}catch(h){if((0,v.toFileOperationResult)(h)!==1)throw h}return[]}async resolveContent(p,E,a){const h=this.i(p,E),u=(0,T.joinPath)(h,a);try{return(await this.b.readFile(u)).value.toString()}catch(d){return this.f.error(d),null}}async backup(p,E,a){const h=this.i(p,E),u=(0,T.joinPath)(h,`${(0,l.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.b.writeFile(u,N.VSBuffer.fromString(a))}catch(d){this.f.error(d)}try{this.j(h)}catch{}}i(p,E){return(0,T.joinPath)(this.a.userDataSyncHome,...p.isDefault?[E]:[p.id,E])}async j(p){try{try{if(!await this.b.exists(p))return}catch{return}const E=await this.b.resolve(p);if(E.children){const a=E.children.filter(S=>S.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(S.name)).sort(),h=1e3*60*60*24*(this.c.getValue("sync.localBackupDuration")||30);let u=a.filter(S=>Date.now()-this.k(S)>h);const d=a.length-u.length;d<10&&(u=u.slice(10-d)),await A.Promises.settled(u.map(async S=>{this.f.info("Deleting from backup",S.resource.path),await this.b.del(S.resource)}))}}catch(E){this.f.error(E)}}k(p){return p.ctime||new Date(parseInt(p.name.substring(0,4)),parseInt(p.name.substring(4,6))-1,parseInt(p.name.substring(6,8)),parseInt(p.name.substring(9,11)),parseInt(p.name.substring(11,13)),parseInt(p.name.substring(13,15))).getTime()}};e.UserDataSyncBackupStoreService=m=ve([J(0,I.IEnvironmentService),J(1,v.IFileService),J(2,k.IConfigurationService),J(3,b.IUserDataSyncLogService),J(4,R.IUserDataProfilesService)],m)}),define(oe[268],ae([0,1,3,2,4,15,19,20,23]),function(ie,e,A,N,l,O,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const v="sync.enable";let R=e.UserDataSyncEnablementService=class extends N.Disposable{constructor(m,g,p,E){super(),this.c=m,this.f=g,this.g=p,this.h=E,this.a=new A.Emitter,this.onDidChangeEnablement=this.a.event,this.b=new A.Emitter,this.onDidChangeResourceEnablement=this.b.event,this.B(m.onDidChangeValue(a=>this.j(a)))}isEnabled(){switch(this.g.sync){case"on":return!0;case"off":return!1}return this.c.getBoolean(v,-1,!1)}canToggleEnablement(){return this.h.userDataSyncStore!==void 0&&this.g.sync===void 0}setEnablement(m){m&&!this.canToggleEnablement()||(this.f.publicLog2(v,{enabled:m}),this.c.store(v,m,-1,1))}isResourceEnabled(m){return this.c.getBoolean((0,I.getEnablementKey)(m),-1,!0)}setResourceEnablement(m,g){if(this.isResourceEnabled(m)!==g){const p=(0,I.getEnablementKey)(m);this.i(p,g)}}getResourceSyncStateVersion(m){}i(m,g){this.c.store(m,g,-1,l.isWeb?0:1)}j(m){if(m.scope!==-1)return;if(v===m.key){this.a.fire(this.isEnabled());return}const g=I.ALL_SYNC_RESOURCES.filter(p=>(0,I.getEnablementKey)(p)===m.key)[0];if(g){this.b.fire([g,this.isResourceEnabled(g)]);return}}};e.UserDataSyncEnablementService=R=ve([J(0,T.IStorageService),J(1,k.ITelemetryService),J(2,O.IEnvironmentService),J(3,I.IUserDataSyncStoreManagementService)],R)}),define(oe[82],ae([0,1,3,2,4,27,182,15,13,5,25,44,19,23]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,v.createDecorator)("IUserDataSyncMachinesService");const p="sync.currentMachineName",E="Safari",a="Chrome",h="Edge",u="Firefox",d="Android";function S(r){switch(r){case E:case a:case h:case u:case d:case(0,l.PlatformToString)(0):return!0}return!1}e.isWebPlatform=S;function L(){return l.isSafari?E:l.isChrome?a:l.isEdge?h:l.isFirefox?u:l.isAndroid?d:(0,l.PlatformToString)(l.isWeb?0:l.platform)}let n=e.UserDataSyncMachinesService=class it extends N.Disposable{constructor(t,i,s,o,c,y){super(),this.h=s,this.i=o,this.j=c,this.k=y,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.g=null,this.f=(0,b.getServiceMachineId)(t,i,s)}async getMachines(t){const i=await this.f;return(await this.m(t)).machines.map(o=>({...o,isCurrent:o.id===i}))}async addCurrentMachine(t){const i=await this.f,s=await this.m(t);s.machines.some(({id:o})=>o===i)||(s.machines.push({id:i,name:this.l(s.machines),platform:L()}),await this.n(s))}async removeCurrentMachine(t){const i=await this.f,s=await this.m(t),o=s.machines.filter(({id:c})=>c!==i);o.length!==s.machines.length&&(s.machines=o,await this.n(s))}async renameMachine(t,i,s){const o=await this.m(s),c=o.machines.find(({id:y})=>y===t);if(c){c.name=i,await this.n(o);const y=await this.f;t===y&&this.h.store(p,i,-1,1)}}async setEnablements(t){const i=await this.m();for(const[s,o]of t){const c=i.machines.find(y=>y.id===s);c&&(c.disabled=o?void 0:!0)}await this.n(i)}l(t){const i=this.h.get(p,-1);if(i)return i;const s=`${this.k.embedderIdentifier?`${this.k.embedderIdentifier} - `:""}${L()} (${this.k.nameShort})`,o=new RegExp(`${(0,O.escapeRegExpCharacters)(s)}\\s#(\\d+)`);let c=0;for(const y of t){const w=o.exec(y.name),f=w?parseInt(w[1]):0;c=f>c?f:c}return`${s} #${c+1}`}async m(t){this.g=await this.p(t);const i=this.r(this.g);if(i.version!==it.a)throw new Error((0,T.localize)(0,null,this.k.nameLong));return i}async n(t){const i=JSON.stringify(t),s=await this.i.writeResource(it.b,i,this.g?.ref||null);this.g={ref:s,content:i},this.c.fire()}async p(t){if(this.g){const i=t&&t.latest?t.latest[it.b]:void 0;if(this.g.ref===i)return this.g;if(i===void 0&&this.g.content===null)return this.g}return this.i.readResource(it.b,this.g)}r(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(i){this.j.error(i)}return{version:it.a,machines:[]}}};n.a=1,n.b="machines",e.UserDataSyncMachinesService=n=ve([J(0,k.IEnvironmentService),J(1,I.IFileService),J(2,m.IStorageService),J(3,g.IUserDataSyncStoreService),J(4,g.IUserDataSyncLogService),J(5,R.IProductService)],n)}),define(oe[269],ae([0,1,6,64,38,9,3,2,4,22,12,179,25,19,20,23,79,82]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const u="sync.disableMachineEventually",d="sync.sessionId",S="sync.storeUrl",L="sync.productQuality";let n=e.UserDataAutoSyncService=class extends k.Disposable{get j(){const i=this.z.get(S,-1);return i?R.URI.parse(i):void 0}set j(i){i?this.z.store(S,i.toString(),-1,1):this.z.remove(S,-1)}get l(){return this.z.get(L,-1)}set l(i){i?this.z.store(L,i,-1,1):this.z.remove(L,-1)}constructor(i,s,o,c,y,w,f,P,D,M){super(),this.n=s,this.p=o,this.r=c,this.s=y,this.u=w,this.v=f,this.w=P,this.y=D,this.z=M,this.a=this.B(new k.MutableDisposable),this.b=0,this.c=void 0,this.g=!1,this.h=this.B(new T.Emitter),this.onError=this.h.event,this.N=[],this.f=this.B(new A.ThrottledDelayer(this.O())),this.i=this.j,this.j=s.userDataSyncStore?.url,this.k=this.l,this.l=i.quality,this.j&&(this.u.info("Using settings sync service",this.j.toString()),this.B(s.onDidChangeUserDataSyncStore(()=>{(0,v.isEqual)(this.j,s.userDataSyncStore?.url)||(this.i=this.j,this.j=s.userDataSyncStore?.url,this.j&&this.u.info("Using settings sync service",this.j.toString()))})),this.r.isEnabled()?this.u.info("Auto Sync is enabled."):this.u.info("Auto Sync is disabled."),this.C(),this.L()&&this.J(),this.B(f.onDidChangeAccount(()=>this.C())),this.B(o.onDidChangeDonotMakeRequestsUntil(()=>this.C())),this.B(y.onDidChangeLocal(j=>this.triggerSync([j],!1,!1))),this.B(T.Event.filter(this.r.onDidChangeResourceEnablement,([,j])=>j)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this.B(this.n.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}C(){const{enabled:i,message:s}=this.F();i?this.a.value===void 0&&(this.a.value=new r(this.i,1e3*60*5,this.n,this.p,this.s,this.y,this.u,this.w,this.z),this.a.value.register(this.a.value.onDidStartSync(()=>this.c=new Date().getTime())),this.a.value.register(this.a.value.onDidFinishSync(o=>this.I(o))),this.D()&&this.a.value.start()):(this.f.cancel(),this.a.value!==void 0?(s&&this.u.info(s),this.a.clear()):s&&this.r.isEnabled()&&this.u.info(s))}D(){return!0}F(){return this.r.isEnabled()?this.v.account?this.p.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,N.toLocalISOString)(this.p.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.g?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.M(),this.i=this.j,this.G(!0)}async turnOff(i,s,o){try{this.v.account&&!o&&await this.y.removeCurrentMachine(),this.G(!1),this.z.remove(d,-1),i?(this.w.publicLog2("sync/turnOffEveryWhere"),await this.s.reset()):await this.s.resetLocal()}catch(c){if(this.u.error(c),s)this.G(!1);else throw c}}G(i){this.r.isEnabled()!==i&&(this.r.setEnablement(i),this.C())}H(){return!!this.k&&!!this.l&&this.k!==this.l}async I(i){if(!i){this.b=0;return}const s=E.UserDataSyncError.toUserDataSyncError(i);s instanceof E.UserDataAutoSyncError&&this.w.publicLog2("autosync/error",{code:s.code,service:this.n.userDataSyncStore.url.toString()}),s.code==="SessionExpired"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current session is expired")):s.code==="TurnedOff"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):s.code==="LocalTooManyRequests"?(this.g=!0,this.u.info("Auto Sync: Suspended sync because of making too many requests to server"),this.C()):s.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because of making too many requests to server")):s.code==="MethodNotFound"?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because current client is making requests to server that are not supported")):s.code==="UpgradeRequired"||s.code==="Gone"?(await this.turnOff(!1,!0,!0),this.J(),this.u.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):s.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with newer version than of client. Requires client upgrade.`)):s.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.u.info(`Auto Sync: Turned off sync because server has ${s.resource} content with older version than of client. Requires server reset.`)):s.code==="ServiceChanged"||s.code==="DefaultServiceChanged"?I.isWeb&&s.code==="DefaultServiceChanged"&&!this.H()?(await this.turnOff(!1,!0),this.u.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.u.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.u.error(s),this.b++),this.h.fire(s)}async J(){this.z.store(u,!0,-1,1),await(0,A.timeout)(1e3*60*10),this.L()&&(this.M(),!this.r.isEnabled()&&this.v.account&&await this.y.removeCurrentMachine())}L(){return this.z.getBoolean(u,-1,!1)}M(){this.z.remove(u,-1)}async triggerSync(i,s,o){if(this.a.value===void 0)return this.f.cancel();if(s&&this.c&&Math.round((new Date().getTime()-this.c)/1e3)<10){this.u.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.N.push(...i),this.f.trigger(async()=>{this.u.trace("activity sources",...this.N);const c=this.v.account?.authenticationProviderId||"";this.w.publicLog2("sync/triggered",{sources:this.N,providerId:c}),this.N=[],this.a.value&&await this.a.value.sync("Activity",o)},this.b?this.O()*1*Math.min(Math.pow(2,this.b),60):this.O())}O(){return 2e3}};e.UserDataAutoSyncService=n=ve([J(0,m.IProductService),J(1,E.IUserDataSyncStoreManagementService),J(2,E.IUserDataSyncStoreService),J(3,E.IUserDataSyncEnablementService),J(4,E.IUserDataSyncService),J(5,E.IUserDataSyncLogService),J(6,a.IUserDataSyncAccountService),J(7,p.ITelemetryService),J(8,h.IUserDataSyncMachinesService),J(9,g.IStorageService)],n);class r extends k.Disposable{constructor(i,s,o,c,y,w,f,P,D){super(),this.j=i,this.k=s,this.l=o,this.m=c,this.n=y,this.p=w,this.r=f,this.s=P,this.u=D,this.b=this.B(new k.MutableDisposable),this.c=this.B(new T.Emitter),this.onDidStartSync=this.c.event,this.f=this.B(new T.Emitter),this.onDidFinishSync=this.f.event,this.g=null}start(){this.B(this.onDidFinishSync(()=>this.v())),this.B((0,k.toDisposable)(()=>{this.i&&(this.i.cancel(),this.r.info("Auto sync: Cancelled sync that is in progress"),this.i=void 0),this.h?.stop(),this.r.info("Auto Sync: Stopped")})),this.sync(r.a,!1)}v(){this.b.value=(0,A.disposableTimeout)(()=>this.sync(r.a,!1),this.k)}sync(i,s){const o=(0,A.createCancelablePromise)(async c=>{if(this.i)try{this.r.debug("Auto Sync: Waiting until sync is finished."),await this.i}catch(y){if((0,O.isCancellationError)(y))return}return this.z(i,s,c)});return this.i=o,this.i.finally(()=>this.i=void 0),this.i}w(){return this.j!==void 0&&!(0,v.isEqual)(this.j,this.l.userDataSyncStore?.url)}async y(){const i=await this.l.getPreviousUserDataSyncStore(),s=this.l.userDataSyncStore;return!!s&&!!i&&(!(0,v.isEqual)(s.defaultUrl,i.defaultUrl)||!(0,v.isEqual)(s.insidersUrl,i.insidersUrl)||!(0,v.isEqual)(s.stableUrl,i.stableUrl))}async z(i,s,o){this.r.info(`Auto Sync: Triggered by ${i}`),this.c.fire();let c;try{await this.C(s,o)}catch(y){if(this.r.error(y),c=y,E.UserDataSyncError.toUserDataSyncError(y).code==="MethodNotFound")try{this.r.info("Auto Sync: Client is making invalid requests. Cleaning up data..."),await this.n.cleanUpRemoteData(),this.r.info("Auto Sync: Retrying sync..."),await this.C(s,o),c=void 0}catch(w){this.r.error(w),c=w}}this.f.fire(c)}async C(i,s){if(this.h=await this.n.createSyncTask(this.g,i),s.isCancellationRequested)return;if(this.g=this.h.manifest,this.g===null&&await this.n.hasPreviouslySynced())throw this.w()?await this.y()?new E.UserDataAutoSyncError((0,b.localize)(0,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,b.localize)(1,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,b.localize)(2,null),"TurnedOff");const o=this.u.get(d,-1);if(o&&this.g&&o!==this.g.session)throw this.w()?await this.y()?new E.UserDataAutoSyncError((0,b.localize)(3,null),"DefaultServiceChanged"):new E.UserDataAutoSyncError((0,b.localize)(4,null),"ServiceChanged"):new E.UserDataAutoSyncError((0,b.localize)(5,null),"SessionExpired");const c=await this.p.getMachines(this.g||void 0);if(s.isCancellationRequested)return;const y=c.find(f=>f.isCurrent);if(y?.disabled)throw new E.UserDataAutoSyncError((0,b.localize)(6,null),"TurnedOff");const w=new Date().getTime();if(await this.h.run(),this.s.publicLog2("settingsSync:sync",{duration:new Date().getTime()-w}),this.g===null)try{this.g=await this.m.manifest(null)}catch(f){throw new E.UserDataAutoSyncError((0,l.toErrorMessage)(f),f instanceof E.UserDataSyncError?f.code:"Unknown")}this.g&&this.g.session!==o&&this.u.store(d,this.g.session,-1,1),!s.isCancellationRequested&&(y||await this.p.addCurrentMachine(this.g||void 0))}register(i){return super.B(i)}}r.a="Interval"}),define(oe[270],ae([0,1,12,183,15,13,44,19,30,23,18,40,123,122,121,17,124,119,120,5,125,42]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u,d,S,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncResourceProviderService=void 0;let n=e.UserDataSyncResourceProviderService=class We{constructor(t,i,s,o,c,y,w,f,P,D){this.e=t,this.f=i,this.g=s,this.h=c,this.i=y,this.j=w,this.k=f,this.l=P,this.m=D,this.d=o.extUri}async getRemoteSyncedProfiles(){const t=await this.e.readResource("profiles",null,void 0);if(t.content){const i=this.K(t.content,"profiles");return(0,S.parseUserDataProfilesManifest)(i)}return[]}async getRemoteSyncResourceHandles(t,i){return(await this.e.getAllResourceRefs(t,i?.collection)).map(({created:o,ref:c})=>({created:o,uri:this.I({remote:!0,syncResource:t,profile:i?.id??this.k.defaultProfile.id,collection:i?.collection,ref:c,node:void 0})}))}async getLocalSyncResourceHandles(t,i){return(await this.f.getAllRefs(i,t)).map(({created:o,ref:c})=>({created:o,uri:this.I({remote:!1,syncResource:t,profile:i.id,collection:void 0,ref:c,node:void 0})}))}resolveUserDataSyncResource({uri:t}){const i=this.J(t),s=i?this.k.profiles.find(o=>o.id===i.profile):void 0;return i&&s?{profile:s,syncResource:i?.syncResource}:void 0}async getAssociatedResources({uri:t}){const i=this.J(t);if(!i)return[];const s=this.k.profiles.find(o=>o.id===i.profile);switch(i.syncResource){case"settings":return this.r(t,s);case"keybindings":return this.t(t,s);case"tasks":return this.v(t,s);case"snippets":return this.x(t,s);case"globalState":return this.C(t,s);case"extensions":return this.z(t,s);case"profiles":return this.F(t,s)}}async getMachineId({uri:t}){const i=this.J(t);if(i){if(i.remote){if(i.ref){const{content:s}=await this.L(i.syncResource,i.ref,i.collection);if(s)return this.K(s,i.syncResource)?.machineId}return}return(0,T.getServiceMachineId)(this.h,this.j,this.i)}}async resolveContent(t){const i=this.J(t);if(!i||i.node===We.a)return null;if(i.ref){const s=await this.n(i.remote,i.syncResource,i.profile,i.collection,i.ref);return i.node&&s?this.o(i.syncResource,s,i.node):s}return!i.remote&&!i.node?this.q(i.syncResource,i.profile):null}async n(t,i,s,o,c){if(t){const{content:w}=await this.L(i,c,o);return w}const y=this.k.profiles.find(w=>w.id===s);return y?this.f.resolveContent(y,i,c):null}o(t,i,s){const o=this.K(i,t);switch(t){case"settings":return this.s(o,s);case"keybindings":return this.u(o,s);case"tasks":return this.w(o,s);case"snippets":return this.y(o,s);case"globalState":return this.D(o,s);case"extensions":return this.A(o,s);case"profiles":return this.G(o,s)}}async q(t,i){const s=this.k.profiles.find(o=>o.id===i);if(!s)return null;switch(t){case"globalState":return this.E(s);case"extensions":return this.B(s);case"profiles":return this.H(s);case"settings":return null;case"keybindings":return null;case"tasks":return null;case"snippets":return null}}r(t,i){const s=this.d.joinPath(t,"settings.json"),o=i?i.settingsResource:this.d.joinPath(t,We.a);return[{resource:s,comparableResource:o}]}s(t,i){switch(i){case"settings.json":return(0,g.parseSettingsSyncContent)(t.content).settings}return null}t(t,i){const s=this.d.joinPath(t,"keybindings.json"),o=i?i.keybindingsResource:this.d.joinPath(t,We.a);return[{resource:s,comparableResource:o}]}u(t,i){switch(i){case"keybindings.json":return(0,p.getKeybindingsContentFromSyncContent)(t.content,!!this.l.getValue(v.CONFIG_SYNC_KEYBINDINGS_PER_PLATFORM),this.g)}return null}v(t,i){const s=this.d.joinPath(t,"tasks.json"),o=i?i.tasksResource:this.d.joinPath(t,We.a);return[{resource:s,comparableResource:o}]}w(t,i){switch(i){case"tasks.json":return(0,a.getTasksContentFromSyncContent)(t.content,this.g)}return null}async x(t,i){const s=await this.resolveContent(t);if(s){const o=this.K(s,"snippets");if(o){const c=(0,m.parseSnippets)(o),y=[];for(const w of Object.keys(c)){const f=this.d.joinPath(t,w),P=i?this.d.joinPath(i.snippetsHome,w):this.d.joinPath(t,We.a);y.push({resource:f,comparableResource:P})}return y}}return[]}y(t,i){return(0,m.parseSnippets)(t)[i]||null}z(t,i){const s=this.d.joinPath(t,"extensions.json"),o=i?this.I({remote:!1,syncResource:"extensions",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,We.a);return[{resource:s,comparableResource:o}]}A(t,i){switch(i){case"extensions.json":return(0,h.stringify)((0,h.parseExtensions)(t),!0)}return null}async B(t){const{localExtensions:i}=await this.m.createInstance(h.LocalExtensionsProvider).getLocalExtensions(t);return(0,h.stringify)(i,!0)}C(t,i){const s=this.d.joinPath(t,"globalState.json"),o=i?this.I({remote:!1,syncResource:"globalState",profile:i.id,collection:void 0,ref:void 0,node:void 0}):this.d.joinPath(t,We.a);return[{resource:s,comparableResource:o}]}D(t,i){switch(i){case"globalState.json":return(0,u.stringify)(JSON.parse(t.content),!0)}return null}async E(t){const i=await this.m.createInstance(u.LocalGlobalStateProvider).getLocalGlobalState(t);return(0,u.stringify)(i,!0)}F(t,i){const s=this.d.joinPath(t,"profiles.json"),o=this.I({remote:!1,syncResource:"profiles",profile:this.k.defaultProfile.id,collection:void 0,ref:void 0,node:void 0});return[{resource:s,comparableResource:o}]}G(t,i){switch(i){case"profiles.json":return(0,L.toFormattedString)(JSON.parse(t.content),{})}return null}async H(t){return(0,S.stringifyLocalProfiles)(this.k.profiles.filter(i=>!i.isDefault&&!i.isTransient),!0)}I(t){const i=t.remote?We.b:We.c,s=[t.syncResource,t.profile];return t.collection&&s.push(`collection:${t.collection}`),t.ref&&s.push(`ref:${t.ref}`),t.node&&s.push(t.node),this.d.joinPath(A.URI.from({scheme:v.USER_DATA_SYNC_SCHEME,authority:i,path:"/"}),...s)}J(t){if(t.scheme!==v.USER_DATA_SYNC_SCHEME||t.authority!==We.c&&t.authority!==We.b)return;const i=[];for(;t.path!=="/";)i.unshift(this.d.basename(t)),t=this.d.dirname(t);if(i.length<2)return;const s=t.authority===We.b,o=i.shift(),c=i.shift();let y,w,f;for(;i.length;){const P=i.shift();P.startsWith("collection:")?y=P.substring(11):P.startsWith("ref:")?w=P.substring(4):f=P}return{remote:s,syncResource:o,profile:c,collection:y,ref:w,node:f}}K(t,i){try{const s=JSON.parse(t);if((0,b.isSyncData)(s))return s}catch(s){this.g.error(s)}throw new v.UserDataSyncError((0,N.localize)(0,null),"IncompatibleRemoteContent",i)}async L(t,i,s){const o=await this.e.resolveResourceContent(t,i,s);return{ref:i,content:o}}};n.a="not-existing-resource",n.b="remote-backup",n.c="local-backup",e.UserDataSyncResourceProviderService=n=ve([J(0,v.IUserDataSyncStoreService),J(1,v.IUserDataSyncBackupStoreService),J(2,v.IUserDataSyncLogService),J(3,I.IUriIdentityService),J(4,l.IEnvironmentService),J(5,k.IStorageService),J(6,O.IFileService),J(7,R.IUserDataProfilesService),J(8,E.IConfigurationService),J(9,d.IInstantiationService)],n)}),define(oe[271],ae([0,1,21,6,26,38,3,2,22,11,32,17,29,5,19,20,18,119,120,121,122,123,124,125,23]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u,d,S,L,n,r,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const i="sync.lastSyncTime";let s=e.UserDataSyncService=class extends k.Disposable{get status(){return this.f}get conflicts(){return this.i}get lastSyncTime(){return this.m}constructor(f,P,D,M,j,B,W,H,Q){super(),this.v=f,this.w=P,this.y=D,this.z=M,this.C=j,this.D=B,this.F=W,this.G=H,this.H=Q,this.f="uninitialized",this.g=this.B(new T.Emitter),this.onDidChangeStatus=this.g.event,this.h=this.B(new T.Emitter),this.onDidChangeLocal=this.h.event,this.i=[],this.j=this.B(new T.Emitter),this.onDidChangeConflicts=this.j.event,this.k=[],this.l=this.B(new T.Emitter),this.onSyncErrors=this.l.event,this.m=void 0,this.n=this.B(new T.Emitter),this.onDidChangeLastSyncTime=this.n.event,this.r=this.B(new T.Emitter),this.onDidResetLocal=this.r.event,this.t=this.B(new T.Emitter),this.onDidResetRemote=this.t.event,this.u=new Map,this.f=P.userDataSyncStore?"idle":"uninitialized",this.m=this.D.getNumber(i,-1,void 0),this.B((0,k.toDisposable)(()=>this.W()))}async createSyncTask(f,P){this.X(),this.z.info("Sync started.");const D=new Date().getTime(),M=(0,R.generateUuid)();try{const H=(0,t.createSyncHeaders)(M);P&&(H["Cache-Control"]="no-cache"),f=await this.v.manifest(f,H)}catch(H){const Q=t.UserDataSyncError.toUserDataSyncError(H);throw y(Q,M,this.w,this.C),Q}const j=!1,B=this;let W;return{manifest:f,async run(){if(j)throw new Error("Can run a task only once");W=(0,N.createCancelablePromise)(H=>B.I(f,!1,M,H)),await W.finally(()=>W=void 0),B.z.info(`Sync done. Took ${new Date().getTime()-D}ms`),B.S()},stop(){return W?.cancel(),B.N()}}}async createManualSyncTask(){if(this.X(),this.F.isEnabled())throw new t.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");this.z.info("Sync started.");const f=new Date().getTime(),P=(0,R.generateUuid)(),D=(0,t.createSyncHeaders)(P);let M;try{M=await this.v.manifest(null,D)}catch(W){const H=t.UserDataSyncError.toUserDataSyncError(W);throw y(H,P,this.w,this.C),H}await this.resetLocal();const j=this,B=new l.CancellationTokenSource;return{id:P,async merge(){return j.I(M,!0,P,B.token)},async apply(){try{try{await j.L(M,P,B.token)}catch(W){if(t.UserDataSyncError.toUserDataSyncError(W).code==="MethodNotFound")j.z.info("Client is making invalid requests. Cleaning up data..."),await j.cleanUpRemoteData(),j.z.info("Applying manual sync again..."),await j.L(M,P,B.token);else throw W}}catch(W){throw j.z.error(W),W}j.z.info(`Sync done. Took ${new Date().getTime()-f}ms`),j.S()},async stop(){B.cancel(),await j.N(),await j.resetLocal()}}}async I(f,P,D,M){this.k=[];try{this.status!=="hasConflicts"&&this.Q("syncing");const j=this.getOrCreateActiveProfileSynchronizer(this.G.defaultProfile,void 0);this.k.push(...await this.M(j,f,P,D,M));const B=j.enabled.find(W=>W.resource==="profiles");if(B){const W=await B.getLastSyncedProfiles()||[];if(M.isCancellationRequested)return;await this.J(W,f,P,D,M)}}finally{this.l.fire(this.k)}}async J(f,P,D,M,j){for(const B of f){if(j.isCancellationRequested)return;const W=this.G.profiles.find(Q=>Q.id===B.id);if(!W){this.z.error(`Profile with id:${B.id} and name: ${B.name} does not exist locally to sync.`);continue}this.z.info("Syncing profile.",B.name);const H=this.getOrCreateActiveProfileSynchronizer(W,B);this.k.push(...await this.M(H,P,D,M,j))}for(const[B,W]of this.u.entries())this.G.profiles.some(H=>H.id===W[0].profile.id)||(W[1].dispose(),this.u.delete(B))}async L(f,P,D){const M=this.U();for(const Q of M){if(D.isCancellationRequested)return;await Q.apply(P,D)}const j=M.find(Q=>Q.profile.isDefault);if(!j)return;const B=j.enabled.find(Q=>Q.resource==="profiles");if(!B)return;const H=(await B.getRemoteSyncedProfiles(f?.latest??null)||[]).filter(Q=>M.every(_=>_.profile.id!==Q.id));H.length&&await this.J(H,f,!1,P,D)}async M(f,P,D,M,j){return(await f.sync(P,D,M,j)).map(([W,H])=>({profile:f.profile,syncResource:W,error:H}))}async N(){this.status!=="idle"&&await Promise.allSettled(this.U().map(f=>f.stop()))}async resolveContent(f){const P=await this.H.resolveContent(f);if(P)return P;for(const D of this.U())for(const M of D.enabled){const j=await M.resolveContent(f);if(j)return j}return null}async replace(f){this.X();const P=this.H.resolveUserDataSyncResource(f);if(!P)return;const D=await this.resolveContent(f.uri);D&&await this.O(P.profile,async M=>{if(P.syncResource===M.resource)return await M.replace(D),!0})}async accept(f,P,D,M){this.X(),await this.O(f.profile,async j=>{if(f.syncResource===j.resource)return await j.accept(P,D),M&&await j.apply((0,v.isBoolean)(M)?!1:M.force,(0,t.createSyncHeaders)((0,R.generateUuid)())),!0})}getRemoteProfiles(){return this.H.getRemoteSyncedProfiles()}getRemoteSyncResourceHandles(f,P){return this.H.getRemoteSyncResourceHandles(f,P)}async getLocalSyncResourceHandles(f,P){return this.H.getLocalSyncResourceHandles(f,P??this.G.defaultProfile)}async getAssociatedResources(f){return this.H.getAssociatedResources(f)}async getMachineId(f){return this.H.getMachineId(f)}async hasLocalData(){return!!await this.O(this.G.defaultProfile,async P=>{if(P.resource!=="globalState"&&await P.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.O(this.G.defaultProfile,async P=>{if(await P.hasPreviouslySynced())return!0})}async reset(){this.X(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.X();try{await this.v.clear(),this.z.info("Cleared data on server")}catch(f){this.z.error(f)}this.t.fire()}async resetLocal(){this.X(),this.m=void 0,this.D.remove(i,-1);for(const[f]of this.u.values())try{await f.resetLocal()}catch(P){this.z.error(P)}this.W(),this.r.fire(),this.z.info("Did reset the local sync state.")}async cleanUpRemoteData(){const f=await this.H.getRemoteSyncedProfiles(),P=f.map(B=>B.collection),D=await this.v.getAllCollections(),M=D.filter(B=>!P.includes(B));M.length&&(this.z.info(`Deleting ${M.length} redundant collections on server`),await Promise.allSettled(M.map(B=>this.v.deleteCollection(B))),this.z.info("Deleted redundant collections on server"));const j=f.filter(B=>D.includes(B.collection));if(j.length!==f.length){this.z.info("Updating remote profiles with invalid collections on server");const B=this.y.createInstance(r.UserDataProfilesManifestSynchroniser,this.G.defaultProfile,void 0);try{await B.updateRemoteProfiles(j,null),this.z.info("Updated remote profiles on server")}finally{B.dispose()}}}async O(f,P){const D=new k.DisposableStore;try{const M=this.u.get(f.id);if(M){const Q=await this.P(M[0],P,D);return(0,v.isUndefined)(Q)?null:Q}if(f.isDefault){const Q=D.add(this.y.createInstance(o,f,void 0)),_=await this.P(Q,P,D);return(0,v.isUndefined)(_)?null:_}if(this.G.isEnabled())return null;const j=D.add(this.y.createInstance(r.UserDataProfilesManifestSynchroniser,f,void 0)),B=await this.v.manifest(null),H=(await j.getRemoteSyncedProfiles(B?.latest??null)||[]).find(Q=>Q.id===f.id);if(H){const Q=D.add(this.y.createInstance(o,f,H.collection)),_=await this.P(Q,P,D);return(0,v.isUndefined)(_)?null:_}return null}finally{D.dispose()}}async P(f,P,D){const M=[...f.enabled,...f.disabled.map(j=>D.add(f.createSynchronizer(j)))];for(const j of M){const B=await P(j);if(!(0,v.isUndefined)(B))return B}}Q(f){const P=this.f;this.f!==f&&(this.f=f,this.g.fire(f),P==="hasConflicts"&&this.S())}R(){const f=this.U().map(P=>P.conflicts).flat();(0,A.equals)(this.i,f,(P,D)=>P.profile.id===D.profile.id&&P.syncResource===D.syncResource&&(0,A.equals)(P.conflicts,D.conflicts,(M,j)=>(0,I.isEqual)(M.previewResource,j.previewResource)))||(this.i=f,this.j.fire(f))}S(){this.status==="idle"&&(this.m=new Date().getTime(),this.D.store(i,this.m,-1,1),this.n.fire(this.m))}getOrCreateActiveProfileSynchronizer(f,P){let D=this.u.get(f.id);if(D&&D[0].collection!==P?.collection&&(this.z.error("Profile synchronizer collection does not match with the remote sync profile collection"),D[1].dispose(),D=void 0,this.u.delete(f.id)),!D){const M=new k.DisposableStore,j=M.add(this.y.createInstance(o,f,P?.collection));M.add(j.onDidChangeStatus(B=>this.Q(B))),M.add(j.onDidChangeConflicts(B=>this.R())),M.add(j.onDidChangeLocal(B=>this.h.fire(B))),this.u.set(f.id,D=[j,M])}return D[0]}U(){const f=[];for(const[P]of this.u.values())f.push(P);return f}W(){this.u.forEach(([,f])=>f.dispose()),this.u.clear()}X(){if(!this.w.userDataSyncStore)throw new Error("Not enabled")}};e.UserDataSyncService=s=ve([J(0,t.IUserDataSyncStoreService),J(1,t.IUserDataSyncStoreManagementService),J(2,g.IInstantiationService),J(3,t.IUserDataSyncLogService),J(4,E.ITelemetryService),J(5,p.IStorageService),J(6,t.IUserDataSyncEnablementService),J(7,a.IUserDataProfilesService),J(8,t.IUserDataSyncResourceProviderService)],s);let o=class extends k.Disposable{get enabled(){return this.f.sort((f,P)=>f[1]-P[1]).map(([f])=>f)}get disabled(){return t.ALL_SYNC_RESOURCES.filter(f=>!this.l.isResourceEnabled(f))}get status(){return this.g}get conflicts(){return this.j}constructor(f,P,D,M,j,B,W,H,Q,_){super(),this.profile=f,this.collection=P,this.l=D,this.m=M,this.n=j,this.r=B,this.t=W,this.u=H,this.v=Q,this.w=_,this.f=[],this.g="idle",this.h=this.B(new T.Emitter),this.onDidChangeStatus=this.h.event,this.i=this.B(new T.Emitter),this.onDidChangeLocal=this.i.event,this.j=[],this.k=this.B(new T.Emitter),this.onDidChangeConflicts=this.k.event,this.B(D.onDidChangeResourceEnablement(([Y,$])=>this.y(Y,$))),this.B((0,k.toDisposable)(()=>this.f.splice(0,this.f.length).forEach(([,,Y])=>Y.dispose())));for(const Y of t.ALL_SYNC_RESOURCES)D.isResourceEnabled(Y)&&this.z(Y)}y(f,P){P?this.z(f):this.C(f)}z(f){if(this.f.some(([j])=>j.resource===f))return;if(f==="extensions"&&!this.n.isEnabled()){this.u.info("Skipping extensions sync because gallery is not configured");return}if(f==="profiles"&&(!this.profile.isDefault||!this.v.isEnabled()))return;const P=new k.DisposableStore,D=P.add(this.createSynchronizer(f));P.add(D.onDidChangeStatus(()=>this.G())),P.add(D.onDidChangeConflicts(()=>this.H())),P.add(D.onDidChangeLocal(()=>this.i.fire(f)));const M=this.I(f);this.f.push([D,M,P])}C(f){const P=this.f.findIndex(([D])=>D.resource===f);if(P!==-1){const[[D,,M]]=this.f.splice(P,1);M.dispose(),this.G(),Promise.allSettled([D.stop(),D.resetLocal()]).then(null,j=>this.u.error(j))}}createSynchronizer(f){switch(f){case"settings":return this.m.createInstance(S.SettingsSynchroniser,this.profile,this.collection);case"keybindings":return this.m.createInstance(d.KeybindingsSynchroniser,this.profile,this.collection);case"snippets":return this.m.createInstance(L.SnippetsSynchroniser,this.profile,this.collection);case"tasks":return this.m.createInstance(n.TasksSynchroniser,this.profile,this.collection);case"globalState":return this.m.createInstance(u.GlobalStateSynchroniser,this.profile,this.collection);case"extensions":return this.m.createInstance(h.ExtensionsSynchroniser,this.profile,this.collection);case"profiles":return this.m.createInstance(r.UserDataProfilesManifestSynchroniser,this.profile,this.collection)}}async sync(f,P,D,M){if(M.isCancellationRequested)return[];const j=this.enabled;if(!j.length)return[];try{const B=[],W=(0,t.createSyncHeaders)(D),H=(this.collection?f?.collections?.[this.collection]?.latest:f?.latest)??null,Q=P?await this.D(H):{};for(const _ of j){if(M.isCancellationRequested)return[];if(!this.l.isResourceEnabled(_.resource))return[];try{if(P){const Y=await _.preview(H,Q,W);if(Y)for(const $ of Y.resourcePreviews)($.localChange!==0||$.remoteChange!==0)&&$.mergeState==="preview"&&await _.merge($.previewResource)}else await _.sync(H,W)}catch(Y){const $=t.UserDataSyncError.toUserDataSyncError(Y);if(y($,D,this.r,this.t),c(Y))throw $;this.u.error(Y),this.u.error(`${_.resource}: ${(0,O.toErrorMessage)(Y)}`),B.push([_.resource,$])}}return B}finally{this.G()}}async apply(f,P){const D=(0,t.createSyncHeaders)(f);for(const M of this.enabled){if(P.isCancellationRequested)return;try{await M.apply(!1,D)}catch(j){const B=t.UserDataSyncError.toUserDataSyncError(j);if(y(B,f,this.r,this.t),c(j))throw B;this.u.error(j),this.u.error(`${M.resource}: ${(0,O.toErrorMessage)(j)}`)}}}async stop(){for(const f of this.enabled)try{f.status!=="idle"&&await f.stop()}catch(P){this.u.error(P)}}async resetLocal(){for(const f of this.enabled)try{await f.resetLocal()}catch(P){this.u.error(`${f.resource}: ${(0,O.toErrorMessage)(P)}`),this.u.error(P)}}async D(f){if(!this.profile.isDefault)return{};const P=this.w.getValue(t.USER_DATA_SYNC_CONFIGURATION_SCOPE),D=this.enabled.find(M=>M instanceof S.SettingsSynchroniser);if(D){const M=await D.getRemoteUserDataSyncConfiguration(f);return{...P,...M}}return P}F(f){this.g!==f&&(this.g=f,this.h.fire(f))}G(){return this.H(),this.enabled.some(f=>f.status==="hasConflicts")?this.F("hasConflicts"):this.enabled.some(f=>f.status==="syncing")?this.F("syncing"):this.F("idle")}H(){const f=this.enabled.filter(P=>P.status==="hasConflicts").filter(P=>P.conflicts.conflicts.length>0).map(P=>P.conflicts);(0,A.equals)(this.j,f,(P,D)=>P.syncResource===D.syncResource&&(0,A.equals)(P.conflicts,D.conflicts,(M,j)=>(0,I.isEqual)(M.previewResource,j.previewResource)))||(this.j=f,this.k.fire(f))}I(f){switch(f){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5;case"profiles":return 6}}};o=ve([J(2,t.IUserDataSyncEnablementService),J(3,g.IInstantiationService),J(4,m.IExtensionGalleryService),J(5,t.IUserDataSyncStoreManagementService),J(6,E.ITelemetryService),J(7,t.IUserDataSyncLogService),J(8,a.IUserDataProfilesService),J(9,b.IConfigurationService)],o);function c(w){if(w instanceof t.UserDataSyncError)switch(w.code){case"MethodNotFound":case"TooLarge":case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"LocalTooManyProfiles":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":return!0}return!1}function y(w,f,P,D){D.publicLog2("sync/error",{code:w.code,serverCode:w instanceof t.UserDataSyncStoreError?String(w.serverCode):void 0,url:w instanceof t.UserDataSyncStoreError?w.url:void 0,resource:w.resource,executionId:f,service:P.userDataSyncStore.url.toString()})}}),define(oe[272],ae([0,1,3,2,12,18,23]),function(ie,e,A,N,l,O,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;function k(m,g){return{...m,profile:(0,O.reviveProfile)(m.profile,g.profilesHome.scheme)}}function I(m){return{created:m.created,uri:l.URI.revive(m.uri)}}class v{constructor(g,p,E){this.c=g,this.d=p,this.f=E,this.a=new Map,this.b=new A.Emitter}listen(g,p){switch(p){case"onDidChangeStatus":return this.c.onDidChangeStatus;case"onDidChangeConflicts":return this.c.onDidChangeConflicts;case"onDidChangeLocal":return this.c.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.c.onDidChangeLastSyncTime;case"onSyncErrors":return this.c.onSyncErrors;case"onDidResetLocal":return this.c.onDidResetLocal;case"onDidResetRemote":return this.c.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.b.event}throw new Error(`Event not found: ${p}`)}async call(g,p,E){try{return await this.g(g,p,E)}catch(a){throw this.f.error(a),a}}async g(g,p,E){switch(p){case"_getInitialData":return Promise.resolve([this.c.status,this.c.conflicts,this.c.lastSyncTime]);case"reset":return this.c.reset();case"resetRemote":return this.c.resetRemote();case"resetLocal":return this.c.resetLocal();case"hasPreviouslySynced":return this.c.hasPreviouslySynced();case"hasLocalData":return this.c.hasLocalData();case"resolveContent":return this.c.resolveContent(l.URI.revive(E[0]));case"accept":return this.c.accept(k(E[0],this.d),l.URI.revive(E[1]),E[2],E[3]);case"getRemoteProfiles":return this.c.getRemoteProfiles();case"getLocalSyncResourceHandles":return this.c.getLocalSyncResourceHandles(E[0],E[1]?(0,O.reviveProfile)(E[1],this.d.profilesHome.scheme):void 0);case"getRemoteSyncResourceHandles":return this.c.getRemoteSyncResourceHandles(E[0],E[1]);case"replace":return this.c.replace(I(E[0]));case"getAssociatedResources":return this.c.getAssociatedResources(I(E[0]));case"getMachineId":return this.c.getMachineId(I(E[0]));case"cleanUpRemoteData":return this.c.cleanUpRemoteData();case"createManualSyncTask":return this.i()}if(p.startsWith("manualSync/")){const a=p.substring(11),h=E[0],u=this.h(h);switch(E=E.slice(1),a){case"merge":return u.merge();case"apply":return u.apply().then(()=>this.a.delete(this.j(u.id)));case"stop":return u.stop().finally(()=>this.a.delete(this.j(u.id)))}}throw new Error("Invalid call")}h(g){const p=this.a.get(this.j(g));if(!p)throw new Error(`Manual sync taks not found: ${g}`);return p}async i(){const g=await this.c.createManualSyncTask();return this.a.set(this.j(g.id),g),g.id}j(g){return`manualSyncTask-${g}`}}e.UserDataSyncChannel=v;let R=e.UserDataSyncChannelClient=class extends N.Disposable{get status(){return this.b}get onDidChangeLocal(){return this.a.listen("onDidChangeLocal")}get conflicts(){return this.f}get lastSyncTime(){return this.h}get onDidResetLocal(){return this.a.listen("onDidResetLocal")}get onDidResetRemote(){return this.a.listen("onDidResetRemote")}constructor(g,p){super(),this.k=p,this.b="uninitialized",this.c=this.B(new A.Emitter),this.onDidChangeStatus=this.c.event,this.f=[],this.g=this.B(new A.Emitter),this.onDidChangeConflicts=this.g.event,this.h=void 0,this.i=this.B(new A.Emitter),this.onDidChangeLastSyncTime=this.i.event,this.j=this.B(new A.Emitter),this.onSyncErrors=this.j.event,this.a={call(E,a,h){return g.call(E,a,h).then(null,u=>{throw T.UserDataSyncError.toUserDataSyncError(u)})},listen(E,a){return g.listen(E,a)}},this.a.call("_getInitialData").then(([E,a,h])=>{this.l(E),this.m(a),h&&this.n(h),this.B(this.a.listen("onDidChangeStatus")(u=>this.l(u))),this.B(this.a.listen("onDidChangeLastSyncTime")(u=>this.n(u)))}),this.B(this.a.listen("onDidChangeConflicts")(E=>this.m(E))),this.B(this.a.listen("onSyncErrors")(E=>this.j.fire(E.map(a=>({...a,error:T.UserDataSyncError.toUserDataSyncError(a.error)})))))}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const g=await this.a.call("createManualSyncTask"),p=this;return new b(g,{async call(a,h,u){return p.a.call(`manualSync/${a}`,[g,...Array.isArray(h)?h:[h]],u)},listen(){throw new Error("not supported")}})}reset(){return this.a.call("reset")}resetRemote(){return this.a.call("resetRemote")}resetLocal(){return this.a.call("resetLocal")}hasPreviouslySynced(){return this.a.call("hasPreviouslySynced")}hasLocalData(){return this.a.call("hasLocalData")}accept(g,p,E,a){return this.a.call("accept",[g,p,E,a])}resolveContent(g){return this.a.call("resolveContent",[g])}getRemoteProfiles(){return this.a.call("getRemoteProfiles")}async getLocalSyncResourceHandles(g,p){return(await this.a.call("getLocalSyncResourceHandles",[g,p])).map(({created:a,uri:h})=>({created:a,uri:l.URI.revive(h)}))}async getRemoteSyncResourceHandles(g,p){return(await this.a.call("getRemoteSyncResourceHandles",[g,p])).map(({created:a,uri:h})=>({created:a,uri:l.URI.revive(h)}))}async getAssociatedResources(g){return(await this.a.call("getAssociatedResources",[g])).map(({resource:E,comparableResource:a})=>({resource:l.URI.revive(E),comparableResource:l.URI.revive(a)}))}getMachineId(g){return this.a.call("getMachineId",[g])}cleanUpRemoteData(){return this.a.call("cleanUpRemoteData")}replace(g){return this.a.call("replace",[g])}async l(g){this.b=g,this.c.fire(g)}async m(g){this.f=g.map(p=>({syncResource:p.syncResource,profile:(0,O.reviveProfile)(p.profile,this.k.profilesHome.scheme),conflicts:p.conflicts.map(E=>({...E,baseResource:l.URI.revive(E.baseResource),localResource:l.URI.revive(E.localResource),remoteResource:l.URI.revive(E.remoteResource),previewResource:l.URI.revive(E.previewResource)}))})),this.g.fire(this.f)}n(g){this.h!==g&&(this.h=g,this.i.fire(g))}};e.UserDataSyncChannelClient=R=ve([J(1,O.IUserDataProfilesService)],R);class b extends N.Disposable{constructor(g,p){super(),this.id=g,this.a=p}async merge(){return this.a.call("merge")}async apply(){return this.a.call("apply")}stop(){return this.a.call("stop")}dispose(){this.a.call("dispose")}}}),define(oe[273],ae([0,1,6,26,9,3,2,141,4,22,11,12,32,17,15,13,25,58,44,19,23]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u,d,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const L="sync.previous.store",n="sync.donot-make-requests-until",r="sync.user-session-id",t="sync.machine-session-id",i=100,s=1e3*60*5;let o=e.AbstractUserDataSyncStoreManagementService=class extends T.Disposable{get userDataSyncStore(){return this.b}get c(){return this.h.get(S.SYNC_SERVICE_URL_TYPE,-1)}set c(D){this.h.store(S.SYNC_SERVICE_URL_TYPE,D,-1,I.isWeb?0:1)}constructor(D,M,j){super(),this.f=D,this.g=M,this.h=j,this.a=this.B(new O.Emitter),this.onDidChangeUserDataSyncStore=this.a.event,this.i(),this.B(O.Event.filter(j.onDidChangeValue,B=>B.key===S.SYNC_SERVICE_URL_TYPE&&B.scope===-1&&this.c!==this.userDataSyncStore?.type)(()=>this.i()))}i(){this.b=this.j(this.f[S.CONFIGURATION_SYNC_STORE_KEY],this.g.getValue(S.CONFIGURATION_SYNC_STORE_KEY)),this.a.fire()}j(D,M){D=I.isWeb&&D?.web?{...D,...D.web}:D;const j={...D||{},...M||{}};if(j&&(0,R.isString)(j.url)&&(0,R.isObject)(j.authenticationProviders)&&Object.keys(j.authenticationProviders).every(B=>Array.isArray(j.authenticationProviders[B].scopes))){const B=j,W=!!B.canSwitch&&!M?.url,H=B.url===B.insidersUrl?"insiders":"stable",Q=(W?this.c:void 0)||H,_=M?.url||(Q==="insiders"?B.insidersUrl:Q==="stable"?B.stableUrl:B.url);return{url:b.URI.parse(_),type:Q,defaultType:H,defaultUrl:b.URI.parse(B.url),stableUrl:b.URI.parse(B.stableUrl),insidersUrl:b.URI.parse(B.insidersUrl),canSwitch:W,authenticationProviders:Object.keys(B.authenticationProviders).reduce((Y,$)=>(Y.push({id:$,scopes:B.authenticationProviders[$].scopes}),Y),[])}}}};e.AbstractUserDataSyncStoreManagementService=o=ve([J(0,a.IProductService),J(1,g.IConfigurationService),J(2,d.IStorageService)],o);let c=e.UserDataSyncStoreManagementService=class extends o{constructor(D,M,j){super(D,M,j);const B=this.h.get(L,-1);B&&(this.k=JSON.parse(B));const W=this.f[S.CONFIGURATION_SYNC_STORE_KEY];W?this.h.store(L,JSON.stringify(W),-1,1):this.h.remove(L,-1)}async switch(D){D!==this.c&&(this.c=D,this.i())}async getPreviousUserDataSyncStore(){return this.j(this.k)}};e.UserDataSyncStoreManagementService=c=ve([J(0,a.IProductService),J(1,g.IConfigurationService),J(2,d.IStorageService)],c);let y=e.UserDataSyncStoreClient=class extends T.Disposable{get donotMakeRequestsUntil(){return this.k}constructor(D,M,j,B,W,H,Q){super(),this.n=j,this.p=B,this.r=Q,this.i=this.B(new O.Emitter),this.onTokenFailed=this.i.event,this.j=this.B(new O.Emitter),this.onTokenSucceed=this.j.event,this.k=void 0,this.l=this.B(new O.Emitter),this.onDidChangeDonotMakeRequestsUntil=this.l.event,this.u=void 0,this.s(D),this.g=(0,u.getServiceMachineId)(W,H,Q).then(_=>{const Y={"X-Client-Name":`${M.applicationName}${I.isWeb?"-web":""}`,"X-Client-Version":M.version};return M.commit&&(Y["X-Client-Commit"]=M.commit),Y}),this.h=new f(i,s,this.n,this.p),this.t(),this.B((0,T.toDisposable)(()=>{this.u&&(this.u.cancel(),this.u=void 0)}))}setAuthToken(D,M){this.f={token:D,type:M}}s(D){this.c=D?(0,v.joinPath)(D,"v1"):void 0}t(){const D=this.r.getNumber(n,-1);D&&Date.now()<D&&this.v(new Date(D))}v(D){this.k?.getTime()!==D?.getTime()&&(this.k=D,this.u&&(this.u.cancel(),this.u=void 0),this.k?(this.r.store(n,this.k.getTime(),-1,1),this.u=(0,A.createCancelablePromise)(M=>(0,A.timeout)(this.k.getTime()-Date.now(),M).then(()=>this.v(void 0))),this.u.then(null,M=>null)):this.r.remove(n,-1),this.l.fire())}async getAllCollections(D={}){if(!this.c)throw new Error("No settings sync store url configured.");const M=(0,v.joinPath)(this.c,"collection").toString();D={...D},D["Content-Type"]="application/json";const j=await this.z(M,{type:"GET",headers:D},[],N.CancellationToken.None);return(await(0,h.asJson)(j))?.map(({id:B})=>B)||[]}async createCollection(D={}){if(!this.c)throw new Error("No settings sync store url configured.");const M=(0,v.joinPath)(this.c,"collection").toString();D={...D},D["Content-Type"]=k.Mimes.text;const j=await this.z(M,{type:"POST",headers:D},[],N.CancellationToken.None),B=await(0,h.asTextOrError)(j);if(!B)throw new S.UserDataSyncStoreError("Server did not return the collection id",M,"NoCollection",j.res.statusCode,j.res.headers[S.HEADER_OPERATION_ID]);return B}async deleteCollection(D,M={}){if(!this.c)throw new Error("No settings sync store url configured.");const j=D?(0,v.joinPath)(this.c,"collection",D).toString():(0,v.joinPath)(this.c,"collection").toString();M={...M},await this.z(j,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async getAllResourceRefs(D,M){if(!this.c)throw new Error("No settings sync store url configured.");const j=this.w(this.c,M,D),B={},W=await this.z(j.toString(),{type:"GET",headers:B},[],N.CancellationToken.None);return(await(0,h.asJson)(W)||[]).map(({url:Q,created:_})=>({ref:(0,v.relativePath)(j,j.with({path:Q})),created:_*1e3}))}async resolveResourceContent(D,M,j,B={}){if(!this.c)throw new Error("No settings sync store url configured.");const W=(0,v.joinPath)(this.w(this.c,j,D),M).toString();B={...B},B["Cache-Control"]="no-cache";const H=await this.z(W,{type:"GET",headers:B},[],N.CancellationToken.None);return await(0,h.asTextOrError)(H)}async deleteResource(D,M,j){if(!this.c)throw new Error("No settings sync store url configured.");const B=M!==null?(0,v.joinPath)(this.w(this.c,j,D),M).toString():this.w(this.c,j,D).toString(),W={};await this.z(B,{type:"DELETE",headers:W},[],N.CancellationToken.None)}async deleteResources(){if(!this.c)throw new Error("No settings sync store url configured.");const D=(0,v.joinPath)(this.c,"resource").toString(),M={"Content-Type":k.Mimes.text};await this.z(D,{type:"DELETE",headers:M},[],N.CancellationToken.None)}async readResource(D,M,j,B={}){if(!this.c)throw new Error("No settings sync store url configured.");const W=(0,v.joinPath)(this.w(this.c,j,D),"latest").toString();B={...B},B["Cache-Control"]="no-cache",M&&(B["If-None-Match"]=M.ref);const H=await this.z(W,{type:"GET",headers:B},[304],N.CancellationToken.None);let Q=null;if(H.res.statusCode===304&&(Q=M),Q===null){const _=H.res.headers.etag;if(!_)throw new S.UserDataSyncStoreError("Server did not return the ref",W,"NoRef",H.res.statusCode,H.res.headers[S.HEADER_OPERATION_ID]);const Y=await(0,h.asTextOrError)(H);if(!Y&&H.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",W,"EmptyResponse",H.res.statusCode,H.res.headers[S.HEADER_OPERATION_ID]);Q={ref:_,content:Y}}return Q}async writeResource(D,M,j,B,W={}){if(!this.c)throw new Error("No settings sync store url configured.");const H=this.w(this.c,B,D).toString();W={...W},W["Content-Type"]=k.Mimes.text,j&&(W["If-Match"]=j);const Q=await this.z(H,{type:"POST",data:M,headers:W},[],N.CancellationToken.None),_=Q.res.headers.etag;if(!_)throw new S.UserDataSyncStoreError("Server did not return the ref",H,"NoRef",Q.res.statusCode,Q.res.headers[S.HEADER_OPERATION_ID]);return _}async manifest(D,M={}){if(!this.c)throw new Error("No settings sync store url configured.");const j=(0,v.joinPath)(this.c,"manifest").toString();M={...M},M["Content-Type"]="application/json",D&&(M["If-None-Match"]=D.ref);const B=await this.z(j,{type:"GET",headers:M},[304],N.CancellationToken.None);let W=null;if(B.res.statusCode===304&&(W=D),!W){const Q=B.res.headers.etag;if(!Q)throw new S.UserDataSyncStoreError("Server did not return the ref",j,"NoRef",B.res.statusCode,B.res.headers[S.HEADER_OPERATION_ID]);const _=await(0,h.asTextOrError)(B);if(!_&&B.res.statusCode===304)throw new S.UserDataSyncStoreError("Empty response",j,"EmptyResponse",B.res.statusCode,B.res.headers[S.HEADER_OPERATION_ID]);_&&(W={...JSON.parse(_),ref:Q})}const H=this.r.get(r,-1);return H&&W&&H!==W.session&&this.y(),W===null&&H&&this.y(),W&&this.r.store(r,W.session,-1,1),W}async clear(){if(!this.c)throw new Error("No settings sync store url configured.");await this.deleteCollection(),await this.deleteResources(),this.y()}w(D,M,j){return M?(0,v.joinPath)(D,"collection",M,"resource",j):(0,v.joinPath)(D,"resource",j)}y(){this.r.remove(r,-1),this.r.remove(t,-1)}async z(D,M,j,B){if(!this.f)throw new S.UserDataSyncStoreError("No Auth Token Available",D,"Unauthorized",void 0,void 0);if(this.k&&Date.now()<this.k.getTime())throw new S.UserDataSyncStoreError(`${M.type} request '${D}' failed because of too many requests (429).`,D,"TooManyRequestsAndRetryAfter",void 0,void 0);this.v(void 0);const W=await this.g;M.headers={...M.headers||{},...W,"X-Account-Type":this.f.type,authorization:`Bearer ${this.f.token}`},this.C(M.headers),this.p.trace("Sending request to server",{url:D,type:M.type,headers:{...M.headers,authorization:void 0}});let H;try{H=await this.h.request(D,M,B)}catch(z){if(!(z instanceof S.UserDataSyncStoreError)){let x="RequestFailed";const te=(0,l.getErrorMessage)(z).toLowerCase();te.includes("xhr timeout")?x="RequestTimeout":te.includes("protocol")&&te.includes("not supported")?x="RequestProtocolNotSupported":te.includes("request path contains unescaped characters")?x="RequestPathNotEscaped":te.includes("headers must be an object")?x="RequestHeadersNotObject":(0,l.isCancellationError)(z)&&(x="RequestCanceled"),z=new S.UserDataSyncStoreError(`Connection refused for the request '${D}'.`,D,x,void 0,void 0)}throw this.p.info("Request failed",D),z}const Q=H.res.headers[S.HEADER_OPERATION_ID],_={url:D,status:H.res.statusCode,"execution-id":M.headers[S.HEADER_EXECUTION_ID],"operation-id":Q},Y=(0,h.isSuccess)(H)||H.res.statusCode&&j.indexOf(H.res.statusCode)!==-1;let $="";if(Y?this.p.trace("Request succeeded",_):(this.p.info("Request failed",_),$=await(0,h.asText)(H)||""),H.res.statusCode===401||H.res.statusCode===403){if(this.f=void 0,H.res.statusCode===401)throw this.i.fire("Unauthorized"),new S.UserDataSyncStoreError(`${M.type} request '${D}' failed because of Unauthorized (401).`,D,"Unauthorized",H.res.statusCode,Q);if(H.res.statusCode===403)throw this.i.fire("Forbidden"),new S.UserDataSyncStoreError(`${M.type} request '${D}' failed because the access is forbidden (403).`,D,"Forbidden",H.res.statusCode,Q)}if(this.j.fire(),H.res.statusCode===404)throw new S.UserDataSyncStoreError(`${M.type} request '${D}' failed because the requested resource is not found (404).`,D,"NotFound",H.res.statusCode,Q);if(H.res.statusCode===405)throw new S.UserDataSyncStoreError(`${M.type} request '${D}' failed because the requested endpoint is not found (405). ${$}`,D,"MethodNotFound",H.res.statusCode,Q);if(H.res.statusCode===409)throw new S.UserDataSyncStoreError(`${M.type} request '${D}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,D,"Conflict",H.res.statusCode,Q);if(H.res.statusCode===410)throw new S.UserDataSyncStoreError(`${M.type} request '${D}' failed because the requested resource is not longer available (410).`,D,"Gone",H.res.statusCode,Q);if(H.res.statusCode===412)throw new S.UserDataSyncStoreError(`${M.type} request '${D}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,D,"PreconditionFailed",H.res.statusCode,Q);if(H.res.statusCode===413)throw new S.UserDataSyncStoreError(`${M.type} request '${D}' failed because of too large payload (413).`,D,"TooLarge",H.res.statusCode,Q);if(H.res.statusCode===426)throw new S.UserDataSyncStoreError(`${M.type} request '${D}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,D,"UpgradeRequired",H.res.statusCode,Q);if(H.res.statusCode===429){const z=H.res.headers["retry-after"];throw z?(this.v(new Date(Date.now()+parseInt(z)*1e3)),new S.UserDataSyncStoreError(`${M.type} request '${D}' failed because of too many requests (429).`,D,"TooManyRequestsAndRetryAfter",H.res.statusCode,Q)):new S.UserDataSyncStoreError(`${M.type} request '${D}' failed because of too many requests (429).`,D,"RemoteTooManyRequests",H.res.statusCode,Q)}if(!Y)throw new S.UserDataSyncStoreError("Server returned "+H.res.statusCode,D,"Unknown",H.res.statusCode,Q);return H}C(D){let M=this.r.get(t,-1);M===void 0&&(M=(0,m.generateUuid)(),this.r.store(t,M,-1,1)),D["X-Machine-Session-Id"]=M;const j=this.r.get(r,-1);j!==void 0&&(D["X-User-Session-Id"]=j)}};e.UserDataSyncStoreClient=y=ve([J(1,a.IProductService),J(2,h.IRequestService),J(3,S.IUserDataSyncLogService),J(4,p.IEnvironmentService),J(5,E.IFileService),J(6,d.IStorageService)],y);let w=e.UserDataSyncStoreService=class extends y{constructor(D,M,j,B,W,H,Q){super(D.userDataSyncStore?.url,M,j,B,W,H,Q),this.B(D.onDidChangeUserDataSyncStore(()=>this.s(D.userDataSyncStore?.url)))}};e.UserDataSyncStoreService=w=ve([J(0,S.IUserDataSyncStoreManagementService),J(1,a.IProductService),J(2,h.IRequestService),J(3,S.IUserDataSyncLogService),J(4,p.IEnvironmentService),J(5,E.IFileService),J(6,d.IStorageService)],w);class f{constructor(D,M,j,B){this.c=D,this.d=M,this.f=j,this.g=B,this.a=[],this.b=void 0}request(D,M,j){if(this.h()&&this.i(),M.url=D,this.a.length>=this.c)throw this.g.info("Too many requests",...this.a),new S.UserDataSyncStoreError(`Too many requests. Only ${this.c} requests allowed in ${this.d/(1e3*60)} minutes.`,D,"LocalTooManyRequests",void 0,void 0);return this.b=this.b||new Date,this.a.push(D),this.f.request(M,j)}h(){return this.b!==void 0&&new Date().getTime()-this.b.getTime()>this.d}i(){this.a=[],this.b=void 0}}e.RequestsSession=f}),define(oe[274],ae([0,1,3,56,25,19,20,269,23,79,82]),function(ie,e,A,N,l,O,T,k,I,v,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let b=e.UserDataAutoSyncService=class extends k.UserDataAutoSyncService{constructor(g,p,E,a,h,u,d,S,L,n,r){super(g,p,E,a,h,d,S,L,n,r),this.B(A.Event.debounce(A.Event.any(A.Event.map(u.onDidFocusWindow,()=>"windowFocus"),A.Event.map(u.onDidOpenWindow,()=>"windowOpen")),(t,i)=>t?[...t,i]:[i],1e3)(t=>this.triggerSync(t,!0,!1)))}};e.UserDataAutoSyncService=b=ve([J(0,l.IProductService),J(1,I.IUserDataSyncStoreManagementService),J(2,I.IUserDataSyncStoreService),J(3,I.IUserDataSyncEnablementService),J(4,I.IUserDataSyncService),J(5,N.INativeHostService),J(6,I.IUserDataSyncLogService),J(7,v.IUserDataSyncAccountService),J(8,T.ITelemetryService),J(9,R.IUserDataSyncMachinesService),J(10,O.IStorageService)],b)}),define(oe[275],ae([0,1,71,24,4,22]),function(ie,e,A,N,l,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEmptyWorkspaceIdentifier=e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=e.NON_EMPTY_WORKSPACE_ID_LENGTH=void 0,e.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4;function T(v){function R(){let b=v.scheme===N.Schemas.file?(0,O.originalFSPath)(v):v.toString();return l.isLinux||(b=b.toLowerCase()),(0,A.createHash)("md5").update(b).digest("hex")}return{id:R(),configPath:v}}e.getWorkspaceIdentifier=T;function k(v,R){function b(){if(v.scheme!==N.Schemas.file)return(0,A.createHash)("md5").update(v.toString()).digest("hex");if(!R)return;let g;return l.isLinux?g=R.ino:l.isMacintosh?g=R.birthtime.getTime():l.isWindows&&(typeof R.birthtimeMs=="number"?g=Math.floor(R.birthtimeMs):g=R.birthtime.getTime()),(0,A.createHash)("md5").update(v.fsPath).update(g?String(g):"").digest("hex")}const m=b();if(typeof m=="string")return{id:m,uri:v}}e.getSingleFolderWorkspaceIdentifier=k;function I(){return{id:(Date.now()+Math.round(Math.random()*1e3)).toString()}}e.createEmptyWorkspaceIdentifier=I}),define(oe[276],ae([0,1,6,9,2,14,28,15,10,77,117,275,56,73]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UnusedWorkspaceStorageDataCleaner=void 0;let p=e.UnusedWorkspaceStorageDataCleaner=class extends l.Disposable{constructor(a,h,u,d){super(),this.a=a,this.b=h,this.c=u,this.f=d,this.B(new A.RunOnceScheduler(()=>{this.g()},30*1e3)).schedule()}async g(){this.b.trace("[storage cleanup]: Starting to clean up workspace storage folders for unused empty workspaces.");try{const a=await T.Promises.readdir(this.a.workspaceStorageHome.fsPath),h=new v.StorageClient(this.f.getChannel("storage"));await Promise.all(a.map(async u=>{const d=(0,O.join)(this.a.workspaceStorageHome.fsPath,u);u.length===b.NON_EMPTY_WORKSPACE_ID_LENGTH||u===R.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE.id||(await this.c.getWindows()).some(n=>n.workspace?.id===u)||await h.isUsed(d)||(this.b.trace(`[storage cleanup]: Deleting workspace storage folder ${u} as it seems to be an unused empty workspace.`),await T.Promises.rm(d))}))}catch(a){(0,N.onUnexpectedError)(a)}}};e.UnusedWorkspaceStorageDataCleaner=p=ve([J(0,k.INativeEnvironmentService),J(1,I.ILogService),J(2,m.INativeHostService),J(3,g.IMainProcessService)],p)}),define(oe[83],ae([0,1,53,6,14,11,28,149,288,289]),function(ie,e,A,N,l,O,T,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const R=new RegExp(e.CorruptZipMessage);class b extends Error{constructor(r,t){let i=t.message;switch(r){case"CorruptZip":i=`Corrupt ZIP: ${i}`;break}super(i),this.type=r,this.cause=t}}e.ExtractError=b;function m(n){const r=n.externalFileAttributes>>16||33188;return[448,56,7].map(t=>r&t).reduce((t,i)=>t+i,r&61440)}function g(n){if(n instanceof b)return n;let r;return R.test(n.message)&&(r="CorruptZip"),new b(r,n)}function p(n,r,t,i,s,o){const c=l.dirname(r),y=l.join(i,c);if(!y.startsWith(i))return Promise.reject(new Error(k.localize(0,null,r)));const w=l.join(i,r);let f;return o.onCancellationRequested(()=>{f?.destroy()}),Promise.resolve(T.Promises.mkdir(y,{recursive:!0})).then(()=>new Promise((P,D)=>{if(!o.isCancellationRequested)try{f=(0,A.createWriteStream)(w,{mode:t}),f.once("close",()=>P()),f.once("error",D),n.once("error",D),n.pipe(f)}catch(M){D(M)}}))}function E(n,r,t,i){let s=(0,N.createCancelablePromise)(()=>Promise.resolve()),o=0;return i.onCancellationRequested(()=>{s.cancel(),n.close()}),new Promise((c,y)=>{const w=new N.Sequencer,f=P=>{P.isCancellationRequested||(o++,n.readEntry())};n.once("error",y),n.once("close",()=>s.then(()=>{i.isCancellationRequested||n.entryCount===o?c():y(new b("Incomplete",new Error(k.localize(1,null,o,n.entryCount))))},y)),n.readEntry(),n.on("entry",P=>{if(i.isCancellationRequested)return;if(!t.sourcePathRegex.test(P.fileName)){f(i);return}const D=P.fileName.replace(t.sourcePathRegex,"");if(/\/$/.test(D)){const B=l.join(r,D);s=(0,N.createCancelablePromise)(W=>T.Promises.mkdir(B,{recursive:!0}).then(()=>f(W)).then(void 0,y));return}const M=h(n,P),j=m(P);s=(0,N.createCancelablePromise)(B=>w.queue(()=>M.then(W=>p(W,D,j,r,t,B).then(()=>f(B)))).then(null,y))})})}function a(n,r=!1){return new Promise((t,i)=>{(0,I.open)(n,r?{lazyEntries:!0}:void 0,(s,o)=>{s?i(g(s)):t((0,O.assertIsDefined)(o))})})}function h(n,r){return new Promise((t,i)=>{n.openReadStream(r,(s,o)=>{s?i(g(s)):t((0,O.assertIsDefined)(o))})})}function u(n,r){return new Promise((t,i)=>{const s=new v.ZipFile;r.forEach(c=>{c.contents?s.addBuffer(typeof c.contents=="string"?Buffer.from(c.contents,"utf8"):c.contents,c.path):c.localPath&&s.addFile(c.localPath,c.path)}),s.end();const o=(0,A.createWriteStream)(n);s.outputStream.pipe(o),s.outputStream.once("error",i),o.once("error",i),o.once("finish",()=>t(n))})}e.zip=u;function d(n,r,t={},i){const s=new RegExp(t.sourcePath?`^${t.sourcePath}`:"");let o=a(n,!0);return t.overwrite&&(o=o.then(c=>T.Promises.rm(r).then(()=>c))),o.then(c=>E(c,r,{sourcePathRegex:s},i))}e.extract=d;function S(n,r){return a(n).then(t=>new Promise((i,s)=>{t.on("entry",o=>{o.fileName===r&&h(t,o).then(c=>i(c),c=>s(c))}),t.once("close",()=>s(new Error(k.localize(2,null,r))))}))}function L(n,r){return S(n,r).then(t=>new Promise((i,s)=>{const o=[];t.once("error",s),t.on("data",c=>o.push(c)),t.on("end",()=>i(Buffer.concat(o)))}))}e.buffer=L}),define(oe[277],ae([0,1,6,9,2,24,4,22,54,11,32,28,83,17,15,29,33,100,13,10]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let S=e.ExtensionsDownloader=class pt extends l.Disposable{constructor(n,r,t,i,s,o){super(),this.h=r,this.i=t,this.j=i,this.k=s,this.l=o,this.extensionsDownloadDir=n.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(n,r,t){await this.g;const i=(0,k.joinPath)(this.extensionsDownloadDir,this.v(n));try{await this.r(n,i,o=>this.i.download(n,o,r))}catch(o){throw new E.ExtensionManagementError(o.message,E.ExtensionManagementErrorCode.Download)}let s=!1;if(t&&this.m(n)){const o=await this.n(n);try{s=await this.k.verify(i.fsPath,o.fsPath,this.l.getLevel()===d.LogLevel.Trace)}catch(c){const y=c;if(s=y.code,y.output&&this.l.trace(`Extension signature verification details for ${n.identifier.id} ${n.version}:
${y.output}`),s===E.ExtensionSignaturetErrorCode.PackageIsInvalidZip||s===E.ExtensionSignaturetErrorCode.SignatureArchiveIsInvalidZip)throw new E.ExtensionManagementError(m.CorruptZipMessage,E.ExtensionManagementErrorCode.CorruptZip)}finally{try{await this.delete(o)}catch(c){this.l.error(c)}}}return s===!0?this.l.info(`Extension signature is verified: ${n.identifier.id}`):s===!1?this.l.info(`Extension signature verification is not done: ${n.identifier.id}`):this.l.warn(`Extension signature verification failed with error '${s}': ${n.identifier.id}`),{location:i,verificationStatus:s}}m(n){if(!n.isSigned)return!1;const r=this.j.getValue("extensions.verifySignature");return(0,v.isBoolean)(r)?r:!0}async n(n){await this.g;const r=(0,k.joinPath)(this.extensionsDownloadDir,`${this.v(n)}${pt.c}`);return await this.r(n,r,t=>this.i.downloadSignatureArchive(n,t)),r}async r(n,r,t){if(await this.h.exists(r))return;if(r.scheme!==O.Schemas.file){await t(r);return}const i=(0,k.joinPath)(this.extensionsDownloadDir,`.${(0,R.generateUuid)()}`);await this.h.exists(i)||await t(i);try{await this.t(i,r,Date.now()+2*60*1e3)}catch(s){try{await this.h.del(i)}catch{}if(s.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",n.identifier.id,r.path);else throw this.l.info(`Rename failed because of ${(0,N.getErrorMessage)(s)}. Deleted the file from downloaded location`,i.path),s}}async delete(n){await this.g,await this.h.del(n)}async t(n,r,t){try{await b.Promises.rename(n.fsPath,r.fsPath)}catch(i){if(T.isWindows&&i&&i.code==="EPERM"&&Date.now()<t)return this.l.info(`Failed renaming ${n} to ${r} with 'EPERM' error. Trying again...`),this.t(n,r,t);throw i}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const n=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(n.children){const r=[],t=[],i=[];for(const c of n.children)if(c.name.endsWith(pt.c))i.push(c.resource);else{const y=a.ExtensionKey.parse(c.name);y&&t.push([y,c])}const s=(0,a.groupByExtension)(t,([c])=>c),o=[];for(const c of s)c.sort((y,w)=>I.rcompare(y[0].version,w[0].version)),r.push(...c.slice(1).map(y=>y[1].resource)),o.push(c[0][1]);o.sort((c,y)=>c.mtime-y.mtime),r.push(...o.slice(0,Math.max(0,o.length-this.f)).map(c=>c.resource)),r.push(...i),await A.Promises.settled(r.map(c=>(this.l.trace("Deleting from cache",c.path),this.h.del(c))))}}catch(n){this.l.error(n)}}v(n){return this.f?a.ExtensionKey.create(n).toString().toLowerCase():(0,R.generateUuid)()}};S.c=".sigzip",e.ExtensionsDownloader=S=ve([J(0,p.INativeEnvironmentService),J(1,u.IFileService),J(2,E.IExtensionGalleryService),J(3,g.IConfigurationService),J(4,h.IExtensionSignatureVerificationService),J(5,d.ILogService)],S)}),define(oe[278],ae([0,1,83,160]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function l(O){return(0,A.buffer)(O,"extension/package.json").then(T=>{try{return JSON.parse(T.toString("utf8"))}catch{throw new Error((0,N.localize)(0,null))}})}e.getManifest=l}),define(oe[126],ae([0,1,6,16,26,38,9,3,2,37,24,14,4,22,54,11,12,32,28,83,159,99,15,257,29,33,51,80,277,258,278,218,229,68,13,5,10,25,20,30,18]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u,d,S,L,n,r,t,i,s,o,c,y,w,f,P,D,M,j,B,W,H,Q,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,j.refineServiceDecorator)(t.IExtensionManagementService);let Y=e.ExtensionManagementService=class extends r.AbstractExtensionManagementService{constructor(X,K,F,C,U,q,G,V,Z,ee,ce,ue){super(X,K,F,ee,ue),this.Z=U,this.ab=q,this.bb=G,this.cb=Z,this.db=ce,this.X=this.B(new k.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new v.ResourceSet;const de=this.B(V.createInstance(y.ExtensionsLifecycle));this.S=this.B(V.createInstance($,Se=>de.postUninstall(Se))),this.U=this.B(new f.ExtensionsManifestCache(ue,Z,ce,this,this.v)),this.W=this.B(V.createInstance(c.ExtensionsDownloader));const ye=this.B(new P.ExtensionsWatcher(this,this.Z,ue,q,ce,Z,F));this.B(ye.onDidChangeExtensionsByAnotherSource(Se=>this.kb(Se))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,i.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(X){this.v.trace("ExtensionManagementService#zip",X.identifier.id);const K=await this.jb(X),F=await(0,d.zip)((0,g.joinPath)(this.W.extensionsDownloadDir,(0,h.generateUuid)()).fsPath,K);return a.URI.file(F)}async unzip(X){return this.v.trace("ExtensionManagementService#unzip",X.toString()),(await this.install(X)).identifier}async getManifest(X){const{location:K,cleanup:F}=await this.fb(X),C=b.resolve(K.fsPath);try{return await(0,w.getManifest)(C)}finally{await F()}}getInstalled(X,K=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(X??null,K)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(X){return this.S.scanUserExtensionAtLocation(X)}async install(X,K={}){this.v.trace("ExtensionManagementService#install",X.toString());const{location:F,cleanup:C}=await this.fb(X);try{const U=await(0,w.getManifest)(b.resolve(F.fsPath));if(U.engines&&U.engines.vscode&&!(0,D.isEngineValid)(U.engines.vscode,this.w.version,this.w.date))throw new Error(S.localize(0,null,(0,i.getGalleryExtensionId)(U.publisher,U.name),this.w.version));return await this.z(U,F,K)}finally{await C()}}async installFromLocation(X,K){this.v.trace("ExtensionManagementService#installFromLocation",X.toString());const F=await this.S.scanUserExtensionAtLocation(X);if(!F)throw new Error(`Cannot find a valid extension from the location ${X.toString()}`);return await this.ob([[F,void 0]],K),this.v.info("Successfully installed extension",F.identifier.id,K.toString()),F}async installExtensionsFromProfile(X,K,F){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",X,K.toString(),F.toString());const C=(await this.S.scanExtensions(1,K)).filter(U=>X.some(q=>(0,i.areSameExtensions)(q,U.identifier)));if(C.length){const U=await Promise.all(C.map(q=>this.S.scanMetadata(q,K)));await this.ob(C.map((q,G)=>[q,U[G]]),F),this.v.info("Successfully installed extensions",C.map(q=>q.identifier.id),F.toString())}return C}async updateMetadata(X,K,F=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",X.identifier.id),K.isPreReleaseVersion&&(K.preRelease=!0),K.isMachineScoped=K.isMachineScoped||void 0,K.isBuiltin=K.isBuiltin||void 0,K.pinned=K.pinned||void 0,X=await this.S.updateMetadata(X,K,F),this.U.invalidate(F),this.X.fire(X),X}async reinstallFromGallery(X){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",X.identifier.id),!this.t.isEnabled())throw new Error(S.localize(1,null));const K=await this.getTargetPlatform(),[F]=await this.t.getExtensions([{...X.identifier,preRelease:X.preRelease}],{targetPlatform:K,compatible:!0},l.CancellationToken.None);if(!F)throw new Error(S.localize(2,null));await this.S.setUninstalled(X);try{await this.S.removeUninstalledExtension(X)}catch(C){throw new Error(S.localize(3,null,(0,O.toErrorMessage)(C)))}return this.installFromGallery(F)}copyExtensions(X,K){return this.S.copyExtensions(X,K)}markAsUninstalled(...X){return this.S.setUninstalled(...X)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(X){this.v.error(X)}}async download(X,K,F){const{location:C}=await this.W.download(X,K,!F);return C}async fb(X){if(X.scheme===R.Schemas.file)return{location:X,async cleanup(){}};this.v.trace("Downloading extension from",X.toString());const K=(0,g.joinPath)(this.W.extensionsDownloadDir,(0,h.generateUuid)());return await this.bb.download(X,K),this.v.info("Downloaded extension to",K.toString()),{location:K,cleanup:async()=>{try{await this.cb.del(K)}catch(C){this.v.error(C)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(X,K,F){if(a.URI.isUri(K))return new te(X,K,F,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const C=i.ExtensionKey.create(K).toString();let U=this.Y.get(C);return U||(this.Y.set(C,U=new x(X,K,F,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),U.waitUntilTaskIsFinished().finally(()=>this.Y.delete(C))),U}R(X,K){return new ne(X,K.profileLocation,this.ab)}async jb(X){const K=async C=>{let U=await u.Promises.readdir(C);U=U.map(V=>b.join(C,V));const q=await Promise.all(U.map(V=>u.Promises.stat(V)));let G=Promise.resolve([]);return q.forEach((V,Z)=>{const ee=U[Z];V.isFile()&&(G=G.then(ce=>[...ce,ee])),V.isDirectory()&&(G=G.then(ce=>K(ee).then(ue=>[...ce,...ue])))}),G};return(await K(X.location.fsPath)).map(C=>({path:`extension/${b.relative(X.location.fsPath,C)}`,localPath:C}))}async kb({added:X,removed:K}){if(K)for(const F of K.extensions)this.v.info("Extensions removed from another source",F.id,K.profileLocation.toString()),this.p.fire({identifier:F,profileLocation:K.profileLocation});if(X){const C=(await this.S.scanExtensions(1,X.profileLocation)).filter(U=>X.extensions.some(q=>(0,i.areSameExtensions)(q,U.identifier)));this.m.fire(C.map(U=>(this.v.info("Extensions added from another source",U.identifier.id,X.profileLocation.toString()),{identifier:U.identifier,local:U,profileLocation:X.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(K=>this.lb.add(K)));const X=await this.cb.resolve(this.Z.userExtensionsLocation);for(const K of X.children??[])K.isDirectory&&this.lb.add(K.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(K=>this.nb(K)))}async nb(X){if(!X.affects(this.Z.userExtensionsLocation,1))return;const K=[];for(const F of X.rawAdded){if(this.lb.has(F)||!this.db.extUri.isEqual(this.db.extUri.dirname(F),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(F,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(F).startsWith(".")||!(await this.cb.stat(F)).isDirectory)continue;const C=await this.S.scanUserExtensionAtLocation(F);C&&C.installedTimestamp===void 0&&(this.lb.add(F),K.push(C))}K.length&&(await this.ob(K.map(F=>[F,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",K.map(F=>F.identifier.id)))}async ob(X,K){const F=X.map(C=>C[0]);await this.pb(F),await this.ab.addExtensionsToProfile(X,K),this.m.fire(F.map(C=>({local:C,identifier:C.identifier,operation:1,profileLocation:K})))}async pb(X){const K=await this.S.getUninstalledExtensions();for(const F of X){const C=i.ExtensionKey.create(F);K[C.toString()]&&(this.v.trace("Removing the extension from uninstalled list:",C.id),await this.S.setInstalled(C),this.v.info("Removed the extension from uninstalled list:",C.id))}}};e.ExtensionManagementService=Y=ve([J(0,t.IExtensionGalleryService),J(1,H.ITelemetryService),J(2,B.ILogService),J(3,n.INativeEnvironmentService),J(4,o.IExtensionsScannerService),J(5,s.IExtensionsProfileScannerService),J(6,L.IDownloadService),J(7,j.IInstantiationService),J(8,M.IFileService),J(9,W.IProductService),J(10,Q.IUriIdentityService),J(11,_.IUserDataProfilesService)],Y);let $=e.ExtensionsScanner=class extends I.Disposable{constructor(X,K,F,C,U,q){super(),this.k=X,this.l=K,this.m=F,this.n=C,this.p=U,this.s=q,this.h=this.B(new k.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,g.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new A.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(X,K){const F={includeInvalid:!0,profileLocation:K};let C=[];return X===null||X===0?C.push(...await this.m.scanAllExtensions({includeInvalid:!0},F,!1)):X===1&&C.push(...await this.m.scanUserExtensions(F)),C=X!==null?C.filter(U=>U.type===X):C,Promise.all(C.map(U=>this.y(U)))}async scanAllUserExtensions(X){const K=await this.m.scanUserExtensions({includeAllVersions:!X,includeInvalid:!0});return Promise.all(K.map(F=>this.y(F)))}async scanUserExtensionAtLocation(X){try{const K=await this.m.scanExistingExtension(X,1,{includeInvalid:!0});if(K)return await this.y(K)}catch(K){this.s.error(K)}return null}async extractUserExtension(X,K,F,C){await this.j.catch(()=>{});const U=X.toString(),q=b.join(this.m.userExtensionsLocation.fsPath,`.${(0,h.generateUuid)()}`),G=b.join(this.m.userExtensionsLocation.fsPath,U);try{await u.Promises.rm(G)}catch{throw new t.ExtensionManagementError(S.localize(4,null,G,X.id),t.ExtensionManagementErrorCode.Delete)}await this.u(X,K,q,C),await this.m.updateMetadata(a.URI.file(q),F);try{this.h.fire(a.URI.file(G)),await this.v(X,q,G,Date.now()+2*60*1e3),this.s.info("Renamed to",G)}catch(V){try{await u.Promises.rm(q)}catch{}if(V.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",X.id);else throw this.s.info(`Rename failed because of ${(0,T.getErrorMessage)(V)}. Deleted from extracted location`,q),V}return this.w(a.URI.file(G),1)}async scanMetadata(X,K){return K?(await this.n.scanProfileExtensions(K)).find(C=>(0,i.areSameExtensions)(C.identifier,X.identifier))?.metadata:this.m.scanMetadata(X.location)}async updateMetadata(X,K,F){return F?await this.n.updateMetadata([[X,K]],F):await this.m.updateMetadata(X.location,K),this.w(X.location,X.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...X){const K=X.map(F=>i.ExtensionKey.create(F));await this.t(F=>K.forEach(C=>{F[C.toString()]=!0,this.s.info("Marked extension as uninstalled",C.toString())}))}async setInstalled(X){await this.t(K=>delete K[X.toString()])}async removeExtension(X,K){this.s.trace(`Deleting ${K} extension from disk`,X.identifier.id,X.location.fsPath);const F=this.p.extUri.joinPath(this.p.extUri.dirname(X.location),`._${(0,h.generateUuid)()}`);await this.v(X.identifier,X.location.fsPath,F.fsPath,Date.now()+2*60*1e3),await this.l.del(F,{recursive:!0}),this.s.info("Deleted from disk",X.identifier.id,X.location.fsPath)}async removeUninstalledExtension(X){await this.removeExtension(X,"uninstalled"),await this.t(K=>delete K[i.ExtensionKey.create(X).toString()])}async copyExtensions(X,K){const F=await this.scanExtensions(1,X),C=await Promise.all(F.filter(U=>!U.isApplicationScoped).map(async U=>[U,await this.scanMetadata(U,X)]));await this.n.addExtensionsToProfile(C,K)}async t(X){return this.g.queue(async()=>{let K;try{K=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(C){if((0,M.toFileOperationResult)(C)!==1)throw C}let F={};if(K)try{F=JSON.parse(K)}catch{}return X&&(X(F),Object.keys(F).length?await this.l.writeFile(this.c,N.VSBuffer.fromString(JSON.stringify(F))):await this.l.del(this.c)),F})}async u(X,K,F,C){this.s.trace(`Started extracting the extension from ${K} to ${F}`);try{await u.Promises.rm(F)}catch(U){throw new t.ExtensionManagementError(this.D(U).message,t.ExtensionManagementErrorCode.Delete)}try{await(0,d.extract)(K,F,{sourcePath:"extension",overwrite:!0},C),this.s.info(`Extracted extension to ${F}:`,X.id)}catch(U){try{await u.Promises.rm(F)}catch{}let q=t.ExtensionManagementErrorCode.Extract;throw U instanceof d.ExtractError&&(U.type==="CorruptZip"?q=t.ExtensionManagementErrorCode.CorruptZip:U.type==="Incomplete"&&(q=t.ExtensionManagementErrorCode.IncompleteZip)),new t.ExtensionManagementError(U.message,q)}}async v(X,K,F,C){try{await u.Promises.rename(K,F)}catch(U){if(m.isWindows&&U&&U.code==="EPERM"&&Date.now()<C)return this.s.info(`Failed renaming ${K} to ${F} with 'EPERM' error. Trying again...`,X.id),this.v(X,K,F,C);throw new t.ExtensionManagementError(U.message||S.localize(5,null,K,F),U.code||t.ExtensionManagementErrorCode.Rename)}}async w(X,K){const F=await this.m.scanExistingExtension(X,K,{includeInvalid:!0});if(F)return this.y(F);throw new Error(S.localize(6,null,X.path))}async y(X){const K=await this.l.resolve(X.location);let F,C;return K.children&&(F=K.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,C=K.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:X.identifier,type:X.type,isBuiltin:X.isBuiltin||!!X.metadata?.isBuiltin,location:X.location,manifest:X.manifest,targetPlatform:X.targetPlatform,validations:X.validations,isValid:X.isValid,readmeUrl:F,changelogUrl:C,publisherDisplayName:X.metadata?.publisherDisplayName||null,publisherId:X.metadata?.publisherId||null,isApplicationScoped:!!X.metadata?.isApplicationScoped,isMachineScoped:!!X.metadata?.isMachineScoped,isPreReleaseVersion:!!X.metadata?.isPreReleaseVersion,preRelease:!!X.metadata?.preRelease,installedTimestamp:X.metadata?.installedTimestamp,updated:!!X.metadata?.updated,pinned:!!X.metadata?.pinned}}async z(){const X=await this.getUninstalledExtensions();if(Object.keys(X).length===0){this.s.debug("No uninstalled extensions found.");return}this.s.debug("Removing uninstalled extensions:",Object.keys(X));const K=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),F=new Set;for(const U of K)X[i.ExtensionKey.create(U).toString()]||F.add(U.identifier.id.toLowerCase());try{const U=(0,i.groupByExtension)(K,q=>q.identifier);await A.Promises.settled(U.map(async q=>{const G=q.sort((V,Z)=>p.rcompare(V.manifest.version,Z.manifest.version))[0];F.has(G.identifier.id.toLowerCase())||await this.k(await this.y(G))}))}catch(U){this.s.error(U)}const C=K.filter(U=>U.metadata&&X[i.ExtensionKey.create(U).toString()]);await Promise.allSettled(C.map(U=>this.removeUninstalledExtension(U)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const X=[];let K;try{K=await this.l.resolve(this.m.userExtensionsLocation)}catch(F){(0,M.toFileOperationResult)(F)!==1&&this.s.error(F)}for(const F of K?.children??[])F.isDirectory&&F.name.startsWith("._")&&(0,h.isUUID)(F.name.substring(2))&&X.push((async()=>{this.s.trace("Deleting the generated extension folder",F.resource.toString());try{await this.l.del(F.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",F.resource.toString())}catch(C){this.s.error(C)}})());await Promise.allSettled(X)}D(X){const K=Array.isArray(X)?X:[X];return K.length===1?K[0]instanceof Error?K[0]:new Error(K[0]):K.reduce((F,C)=>new Error(`${F.message}${F.message?",":""}${C instanceof Error?C.message:C}`),new Error(""))}};e.ExtensionsScanner=$=ve([J(1,M.IFileService),J(2,o.IExtensionsScannerService),J(3,s.IExtensionsProfileScannerService),J(4,Q.IUriIdentityService),J(5,B.ILogService)],$);class z extends r.AbstractExtensionTask{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,E.isUndefined)(this.m.operation)?this.l:this.m.operation}constructor(X,K,F,C,U,q,G,V,Z){super(),this.identifier=X,this.source=K,this.m=F,this.n=C,this.o=U,this.p=q,this.q=G,this.s=V,this.t=Z,this.j=this.m.profileLocation,this.k=!1,this.l=2}async h(X){const[K,F]=await this.y(X);return this.j=K.isBuiltin||K.isApplicationScoped?this.p.defaultProfile.extensionsResource:this.m.profileLocation,this.o.extUri.isEqual(this.p.defaultProfile.extensionsResource,this.j)&&await this.q.initializeDefaultProfileExtensions(),await this.s.addExtensionsToProfile([[K,F]],this.j),K}async v({zipPath:X,key:K,metadata:F},C){let U=await this.w(K);return U||(this.t.trace("Extracting extension...",K.id),U=await this.n.extractUserExtension(K,X,F,C),this.t.info("Extracting extension completed.",K.id)),U}async w(X){return await this.x(X)?(this.t.trace("Removing the extension from uninstalled list:",X.id),await this.n.setInstalled(X),this.t.info("Removed the extension from uninstalled list:",X.id),(await this.n.scanAllUserExtensions(!0)).find(C=>i.ExtensionKey.create(C).equals(X))):void 0}async x(X){return!!(await this.n.getUninstalledExtensions())[X.toString()]}}class x extends z{constructor(X,K,F,C,U,q,G,V,Z,ee){super(K.identifier,K,F,U,q,G,V,Z,ee),this.z=K,this.A=C}async y(X){const F=(await this.n.scanExtensions(null,this.m.profileLocation)).find(G=>(0,i.areSameExtensions)(G.identifier,this.z.identifier));F&&(this.l=3);const C={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:this.m.isApplicationScoped||F?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||F?.isMachineScoped,isBuiltin:this.m.isBuiltin||F?.isBuiltin,isSystem:F?.type===0?!0:void 0,updated:!!F,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,E.isBoolean)(this.m.installPreReleaseVersion)?this.m.installPreReleaseVersion:F?.preRelease)};if(F?.manifest.version===this.z.version)return[await this.n.updateMetadata(F,C),C];const{location:U,verificationStatus:q}=await this.A.download(this.z,this.l,!this.m.donotVerifySignature);try{return this.k=q,this.C(U.fsPath),[await this.v({zipPath:U.fsPath,key:i.ExtensionKey.create(this.z),metadata:C},X),C]}catch(G){try{await this.A.delete(U)}catch(V){this.t.warn("Error while deleting the downloaded file",U.toString(),(0,T.getErrorMessage)(V))}throw G}}async C(X){try{await(0,w.getManifest)(X)}catch(K){throw new t.ExtensionManagementError((0,r.joinErrors)(K).message,t.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=x;class te extends z{constructor(X,K,F,C,U,q,G,V,Z,ee){super({id:(0,i.getGalleryExtensionId)(X.publisher,X.name)},K,F,U,q,G,V,Z,ee),this.z=X,this.A=K,this.B=C}async h(X){const K=await super.h(X);return this.E(K,X),K}async y(X){const K=new i.ExtensionKey(this.identifier,this.z.version),C=(await this.n.scanExtensions(1,this.m.profileLocation)).find(G=>(0,i.areSameExtensions)(this.identifier,G.identifier)),U={isApplicationScoped:this.m.isApplicationScoped||C?.isApplicationScoped,isMachineScoped:this.m.isMachineScoped||C?.isMachineScoped,isBuiltin:this.m.isBuiltin||C?.isBuiltin,installedTimestamp:Date.now(),pinned:this.m.installGivenVersion?!0:void 0};if(C)if(this.l=3,K.equals(new i.ExtensionKey(C.identifier,C.manifest.version)))try{await this.n.removeExtension(C,"existing")}catch{throw new Error(S.localize(7,null,this.z.displayName||this.z.name))}else!this.m.profileLocation&&p.gt(C.manifest.version,this.z.version)&&await this.n.setUninstalled(C);else{const G=await this.w(K);if(G)try{await this.n.removeExtension(G,"existing")}catch{throw new Error(S.localize(8,null,this.z.displayName||this.z.name))}}return[await this.v({zipPath:b.resolve(this.A.fsPath),key:K,metadata:U},X),U]}async E(X,K){try{let[F]=await this.B.getExtensions([{id:X.identifier.id,version:X.manifest.version}],K);if(F||([F]=await this.B.getExtensions([{id:X.identifier.id}],K)),F){const C={id:F.identifier.uuid,publisherDisplayName:F.publisherDisplayName,publisherId:F.publisherId,isPreReleaseVersion:F.properties.isPreReleaseVersion,preRelease:F.properties.isPreReleaseVersion||this.m.installPreReleaseVersion};await this.n.updateMetadata(X,C,this.m.profileLocation)}}catch{}}}class ne extends r.AbstractExtensionTask{constructor(X,K,F){super(),this.extension=X,this.j=K,this.k=F}async h(X){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(oe[279],ae([0,1,2,29,81,228,126,10,19]),function(ie,e,A,N,l,O,T,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsContributions=void 0;let v=e.ExtensionsContributions=class extends A.Disposable{constructor(b,m,g,p,E,a){super(),b.cleanUp(),(0,O.migrateUnsupportedExtensions)(b,m,g,p,a),l.ExtensionStorageService.removeOutdatedExtensionVersions(b,E)}};e.ExtensionsContributions=v=ve([J(0,T.INativeServerExtensionManagementService),J(1,N.IExtensionGalleryService),J(2,l.IExtensionStorageService),J(3,N.IGlobalExtensionEnablementService),J(4,I.IStorageService),J(5,k.ILogService)],v)}),define(oe[280],ae([0,1,71,63,34,290,16,9,3,2,14,4,32,41,96]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class E{traceSocketEvent(f,P){p.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,P)}constructor(f,P=""){this.f=!0,this.debugLabel=P,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=D=>{if(this.traceSocketEvent("error",{code:D?.code,message:D?.message}),D){if(D.code==="EPIPE")return;(0,k.onUnexpectedError)(D)}},this.socket.on("error",this.a),this.b=D=>{this.traceSocketEvent("close",{hadError:D}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const P=D=>{this.traceSocketEvent("read",D),f(T.VSBuffer.wrap(D))};return this.socket.on("data",P),{dispose:()=>this.socket.off("data",P)}}onClose(f){const P=D=>{f({type:0,hadError:D,error:void 0})};return this.socket.on("close",P),{dispose:()=>this.socket.off("close",P)}}onEnd(f){const P=()=>{f()};return this.socket.on("end",P),{dispose:()=>this.socket.off("end",P)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,P=>{if(P){if(P.code==="EPIPE")return;(0,k.onUnexpectedError)(P)}})}catch(P){if(P.code==="EPIPE")return;(0,k.onUnexpectedError)(P)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,P)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const D=()=>{this.socket.off("close",D),this.socket.off("end",D),this.socket.off("error",D),this.socket.off("timeout",D),this.socket.off("drain",D),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",D),this.socket.on("end",D),this.socket.on("error",D),this.socket.on("timeout",D),this.socket.on("drain",D)})}}e.NodeSocket=E;var a;(function(w){w[w.MinHeaderByteSize=2]="MinHeaderByteSize",w[w.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(a||(a={}));var h;(function(w){w[w.PeekHeader=1]="PeekHeader",w[w.ReadHeader=2]="ReadHeader",w[w.ReadBody=3]="ReadBody",w[w.Fin=4]="Fin"})(h||(h={}));class u extends v.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,P){this.socket.traceSocketEvent(f,P)}constructor(f,P,D,M){super(),this.f=this.B(new I.Emitter),this.g=this.B(new I.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:P,inflateBytesLength:D?.byteLength||0,recordInflateBytes:M}),this.a=this.B(new d(this,P,D,M,this.f,(j,B)=>this.k(j,B))),this.B(this.a.onError(j=>{console.error(j),(0,k.onUnexpectedError)(j),this.g.fire({type:0,hadError:!0,error:j})})),this.b=new p.ChunkStream,this.B(this.socket.onData(j=>this.l(j))),this.B(this.socket.onClose(async j=>{this.a.isProcessingReadQueue()&&await I.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(j)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let P=0;for(;P<f.byteLength;)this.a.writeMessage(f.slice(P,Math.min(P+262144,f.byteLength))),P+=262144}k(f,P){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let D=2;f.byteLength<126?D+=0:f.byteLength<2**16?D+=2:D+=8;const M=T.VSBuffer.alloc(D);if(P?M.writeUInt8(194,0):M.writeUInt8(130,0),f.byteLength<126)M.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){M.writeUInt8(126,1);let j=1;M.writeUInt8(f.byteLength>>>8&255,++j),M.writeUInt8(f.byteLength>>>0&255,++j)}else{M.writeUInt8(127,1);let j=1;M.writeUInt8(0,++j),M.writeUInt8(0,++j),M.writeUInt8(0,++j),M.writeUInt8(0,++j),M.writeUInt8(f.byteLength>>>24&255,++j),M.writeUInt8(f.byteLength>>>16&255,++j),M.writeUInt8(f.byteLength>>>8&255,++j),M.writeUInt8(f.byteLength>>>0&255,++j)}this.socket.write(T.VSBuffer.concat([M,f]))}end(){this.h=!0,this.socket.end()}l(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const P=this.b.peek(this.j.readLen),D=P.readUInt8(0),M=(D&128)>>>7,j=(D&64)>>>6,B=P.readUInt8(1),W=(B&128)>>>7,H=B&127;this.j.state=2,this.j.readLen=2+(W?4:0)+(H===126?2:0)+(H===127?8:0),this.j.fin=M,this.j.firstFrameOfMessage&&(this.j.compressed=!!j),this.j.firstFrameOfMessage=!!M,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const P=this.b.read(this.j.readLen),D=P.readUInt8(1),M=(D&128)>>>7;let j=D&127,B=1;j===126?j=P.readUInt8(++B)*2**8+P.readUInt8(++B):j===127&&(j=P.readUInt8(++B)*0+P.readUInt8(++B)*0+P.readUInt8(++B)*0+P.readUInt8(++B)*0+P.readUInt8(++B)*2**24+P.readUInt8(++B)*2**16+P.readUInt8(++B)*2**8+P.readUInt8(++B));let W=0;M&&(W=P.readUInt8(++B)*2**24+P.readUInt8(++B)*2**16+P.readUInt8(++B)*2**8+P.readUInt8(++B)),this.j.state=3,this.j.readLen=j,this.j.mask=W,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const P=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",P),n(P,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",P),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(P,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await I.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=u;class d extends v.Disposable{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:T.VSBuffer.alloc(0)}constructor(f,P,D,M,j,B){super(),this.l=f,this.m=j,this.n=B,this.a=this.B(new I.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new I.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new I.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,P?(this.b=this.B(new S(this.l,M,D,{windowBits:15})),this.f=this.B(new L(this.l,{windowBits:15})),this.B(this.b.onError(W=>this.a.fire(W))),this.B(this.f.onError(W=>this.a.fire(W)))):(this.b=null,this.f=null)}writeMessage(f){this.g.push(f),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const f=this.g.shift();if(this.f){const P=await this.s(this.f,f);this.n(P,!0)}else this.n(f,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(f,P){return new Promise((D,M)=>{f.write(P),f.flush(j=>D(j))})}acceptFrame(f,P,D){this.h.push({data:f,isCompressed:P,isLastFrameOfMessage:D}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const P=await this.w(this.b,f.data,f.isLastFrameOfMessage);this.m.fire(P)}else this.m.fire(f.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(f,P,D){return new Promise((M,j)=>{f.write(P),D&&f.write(T.VSBuffer.fromByteArray([0,0,255,255])),f.flush(B=>M(B))})}}class S extends v.Disposable{get recordedInflateBytes(){return this.j?T.VSBuffer.concat(this.f):T.VSBuffer.alloc(0)}constructor(f,P,D,M){super(),this.h=f,this.j=P,this.a=this.B(new I.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,O.createInflateRaw)(M),this.b.on("error",j=>{this.h.traceSocketEvent("zlibInflateError",{message:j?.message,code:j?.code}),this.a.fire(j)}),this.b.on("data",j=>{this.h.traceSocketEvent("zlibInflateData",j),this.g.push(T.VSBuffer.wrap(j))}),D&&(this.h.traceSocketEvent("zlibInflateInitialWrite",D.buffer),this.b.write(D.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const P=T.VSBuffer.concat(this.g);this.g.length=0,f(P)})}}class L extends v.Disposable{constructor(f,P){super(),this.g=f,this.a=this.B(new I.Emitter),this.onError=this.a.event,this.f=[],this.b=(0,O.createDeflateRaw)({windowBits:15}),this.b.on("error",D=>{this.g.traceSocketEvent("zlibDeflateError",{message:D?.message,code:D?.code}),this.a.fire(D)}),this.b.on("data",D=>{this.g.traceSocketEvent("zlibDeflateData",D),this.f.push(T.VSBuffer.wrap(D))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let P=T.VSBuffer.concat(this.f);this.f.length=0,P=P.slice(0,P.byteLength-4),f(P)})}}function n(w,f){if(f===0)return;const P=w.byteLength>>>2;for(let H=0;H<P;H++){const Q=w.readUInt32BE(H*4);w.writeUInt32BE(Q^f,H*4)}const D=P*4,M=w.byteLength-D,j=f>>>24&255,B=f>>>16&255,W=f>>>8&255;M>=1&&w.writeUInt8(w.readUInt8(D)^j,D),M>=2&&w.writeUInt8(w.readUInt8(D+1)^B,D+1),M>=3&&w.writeUInt8(w.readUInt8(D+2)^W,D+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const r={[2]:107,[1]:103};function t(){const w=(0,m.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${w}-sock`;const f=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,l.tmpdir)(),P=(0,R.join)(f,`vscode-ipc-${w}.sock`);return s(P),P}e.createRandomIPCHandle=t;function i(w,f,P){const D=(0,A.createHash)("md5").update(w).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${D}-${P}-${f}-sock`;const M=P.substr(0,4),j=f.substr(0,6),B=D.substr(0,8);let W;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?W=(0,R.join)(e.XDG_RUNTIME_DIR,`vscode-${B}-${M}-${j}.sock`):W=(0,R.join)(w,`${M}-${j}.sock`),s(W),W}e.createStaticIPCHandle=i;function s(w){const f=r[b.platform];typeof f=="number"&&w.length>=f&&console.warn(`WARNING: IPC handle "${w}" is longer than ${f} chars, try a shorter --user-data-dir`)}class o extends g.IPCServer{static b(f){const P=I.Event.fromNodeEventEmitter(f,"connection");return I.Event.map(P,D=>({protocol:new p.Protocol(new E(D,"ipc-server-connection")),onDidClientDisconnect:I.Event.once(I.Event.fromNodeEventEmitter(D,"close"))}))}constructor(f){super(o.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=o;function c(w){return new Promise((f,P)=>{const D=(0,N.createServer)();D.on("error",P),D.listen(w,()=>{D.removeListener("error",P),f(new o(D))})})}e.serve=c;function y(w,f){return new Promise((P,D)=>{const M=(0,N.createConnection)(w,()=>{M.removeListener("error",D),P(p.Client.fromSocket(new E(M,`ipc-client${f}`),f))});M.once("error",D)})}e.connect=y}),define(oe[281],ae([0,1,63,280]),function(ie,e,A,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(l,O,T,k,I,v){const R=m=>v(m,void 0),b=A.createConnection({host:l,port:O},()=>{b.removeListener("error",R);const m=Buffer.alloc(16);for(let a=0;a<16;a++)m[a]=Math.round(Math.random()*256);const g=m.toString("base64"),p=[`GET ws://${/:/.test(l)?`[${l}]`:l}:${O}${T}?${k}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${g}`];b.write(p.join(`\r
`)+`\r
\r
`);const E=a=>{a.toString().indexOf(`\r
\r
`)>=0&&(b.off("data",E),v(void 0,new N.NodeSocket(b,I)))};b.on("data",E)});b.setNoDelay(!0),b.once("error",R)}}}),define(oe[282],ae([0,1,63,34,134,281,6,2,17,10,25,219,78,109,4]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function E(S,L,n,r,t){let i;for(let s=3;s&&(i?.dispose(),i=await new a(S,L,n,r,t).waitForReady(),!(t&&l.BROWSER_RESTRICTED_PORTS[t]||!l.BROWSER_RESTRICTED_PORTS[i.tunnelLocalPort]));s--);return i}class a extends k.Disposable{constructor(L,n,r,t,i){super(),this.j=n,this.k=i,this.privacy=m.TunnelPrivacyId.Private,this.i=new Map,this.a=L,this.b=A.createServer(),this.c=new T.Barrier,this.f=()=>this.c.open(),this.b.on("listening",this.f),this.g=s=>this.l(s),this.b.on("connection",this.g),this.h=()=>{},this.b.on("error",this.h),this.tunnelRemotePort=t,this.tunnelRemoteHost=r}async dispose(){super.dispose(),this.b.removeListener("listening",this.f),this.b.removeListener("connection",this.g),this.b.removeListener("error",this.h),this.b.close(),Array.from(this.i.values()).forEach(n=>{n()})}async waitForReady(){const L=this.k??this.tunnelRemotePort,n=(0,m.isAllInterfaces)(this.j)?"0.0.0.0":"127.0.0.1";let r=await(0,l.findFreePortFaster)(L,2,1e3,n),t=null;return this.b.listen(r,this.j),await this.c.wait(),t=this.b.address(),t||(r=0,this.b.listen(r,this.j),await this.c.wait(),t=this.b.address()),this.tunnelLocalPort=t.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${t.port}`,this}async l(L){L.pause();const n=(0,m.isLocalhost)(this.tunnelRemoteHost)||(0,m.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,r=await(0,b.connectRemoteAgentTunnel)(this.a,n,this.tunnelRemotePort),t=r.getSocket().socket,i=r.readEntireBuffer();r.dispose(),i.byteLength>0&&L.write(i.buffer),L.on("end",()=>{L.localAddress&&this.i.delete(L.localAddress),t.end()}),L.on("close",()=>t.end()),L.on("error",()=>{L.localAddress&&this.i.delete(L.localAddress),t.destroy()}),t.on("end",()=>L.end()),t.on("close",()=>L.end()),t.on("error",()=>{L.destroy()}),L.pipe(t),t.pipe(L),L.localAddress&&this.i.set(L.localAddress,()=>{L.end(),t.end()})}}let h=e.BaseTunnelService=class extends m.AbstractTunnelService{constructor(L,n,r,t,i){super(n,i),this.t=L,this.u=r,this.v=t}isPortPrivileged(L){return(0,m.isPortPrivileged)(L,this.k,p.OS,N.release())}r(L,n,r,t,i,s,o,c){const y=this.q(n,r);if(y)return++y.refcount,y.value;if(this.e)return this.s(this.e,n,r,i,s,o,c);{this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${n}:${r} on local port ${i}.`);const w={commit:this.v.commit,quality:this.v.quality,socketFactory:this.t,addressProvider:L,signService:this.u,logService:this.i,ipcLogger:null},f=E(w,t,n,r,i);return this.i.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.o(n,r,f),f}}};e.BaseTunnelService=h=ve([J(1,v.ILogService),J(2,g.ISignService),J(3,R.IProductService),J(4,I.IConfigurationService)],h);let u=e.TunnelService=class extends h{constructor(L,n,r,t){super(O.nodeSocketFactory,L,n,r,t)}};e.TunnelService=u=ve([J(0,v.ILogService),J(1,g.ISignService),J(2,R.IProductService),J(3,I.IConfigurationService)],u);let d=e.SharedTunnelsService=class extends k.Disposable{constructor(L,n,r,t){super(),this.b=L,this.c=n,this.f=r,this.g=t,this.a=new Map}async openTunnel(L,n,r,t,i,s,o,c,y){if(this.b.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${r}:${t} on local port ${s}.`),!this.a.has(L)){const w=new u(this.b,this.f,this.c,this.g);this.B(w),this.a.set(L,w),w.onTunnelClosed(async()=>{(await w.tunnels).length===0&&(w.dispose(),this.a.delete(L))})}return this.a.get(L).openTunnel(n,r,t,i,s,o,c,y)}};e.SharedTunnelsService=d=ve([J(0,v.ILogService),J(1,R.IProductService),J(2,g.ISignService),J(3,I.IConfigurationService)],d)}),define(oe[291],ae([0,1,240,34,38,9,2,24,12,41,148,211,212,204,205,276,195,197,17,216,98,226,99,221,15,223,118,261,29,100,196,126,101,13,207,208,69,5,203,72,74,231,10,105,106,25,58,19,110,20,111,112,113,46,234,115,243,81,116,23,79,267,253,254,82,268,271,272,273,60,266,255,109,225,78,282,220,244,30,245,4,246,198,214,213,80,260,18,51,210,57,265,233,256,108,270,279,7,209,104,263,259,222,192,56,274,262,73,264]),function(ie,e,A,N,l,O,T,k,I,v,R,b,m,g,p,E,a,h,u,d,S,L,n,r,t,i,s,o,c,y,w,f,P,D,M,j,B,W,H,Q,_,Y,$,z,x,te,ne,re,X,K,F,C,U,q,G,V,Z,ee,ce,ue,de,ye,Se,Ee,Re,ke,Be,Ye,le,fe,ge,Ie,Pe,Fe,Le,ze,Ne,je,Me,Ae,se,he,me,pe,we,Ce,De,Te,qe,Oe,$e,xe,et,nt,yt,It,Pt,Rt,Dt,vt,kt,Lt,At,Ot,Tt,Nt,Ut,St,Mt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class Ft extends T.Disposable{constructor(be){super(),this.c=be,this.a=this.B(new R.Server),this.b=void 0,this.f()}f(){let be=!1;const Ue=()=>{be||(be=!0,this.b?.fireOnWillShutdown(),this.dispose())};process.once("exit",Ue),(0,R.once)(process.parentPort,"vscode:electron-main->shared-process=exit",Ue)}async init(){const be=await this.g();(0,ue.registerConfiguration)(),be.invokeFunction(Ue=>{const Je=Ue.get($.ILogService);Je.trace("sharedProcess configuration",JSON.stringify(this.c)),this.h(Ue),this.i(Je)}),this.B((0,T.combinedDisposable)(be.createInstance(b.CodeCacheCleaner,this.c.codeCachePath),be.createInstance(m.LanguagePackCachedDataCleaner),be.createInstance(E.UnusedWorkspaceStorageDataCleaner),be.createInstance(p.LogsDataCleaner),be.createInstance(g.LocalizationsUpdater),be.createInstance(Pt.ExtensionsContributions),be.createInstance(nt.UserDataProfilesCleaner)))}async g(){const be=new Q.ServiceCollection,Ue={_serviceBrand:void 0,...x.default};be.set(te.IProductService,Ue);const Je=new v.StaticRouter(Ve=>Ve==="main"),Ke=new St.MainProcessService(this.a,Je);be.set(St.IMainProcessService,Ke);const at=this.c.policiesData?new Oe.PolicyChannelClient(this.c.policiesData,Ke.getChannel("policy")):new $e.NullPolicyService;be.set($e.IPolicyService,at);const He=new i.SharedProcessEnvironmentService(this.c.args,Ue);be.set(t.INativeEnvironmentService,He);const Ze=new z.LoggerChannelClient(void 0,this.c.logLevel,He.logsHome,this.c.loggers.map(Ve=>({...Ve,resource:I.URI.revive(Ve.resource)})),Ke.getChannel("logger"));be.set($.ILoggerService,Ze);const ct=this.B(Ze.createLogger("sharedprocess",{name:(0,Rt.localize)(0,null)})),ft=this.B(new $.ConsoleLogger(ct.getLevel())),Ge=this.B(new Dt.LogService(ct,[ft]));be.set($.ILogService,Ge),this.b=this.B(new vt.SharedProcessLifecycleService(Ge)),be.set(vt.ISharedProcessLifecycleService,this.b);const _e=this.B(new M.FileService(Ge));be.set(D.IFileService,_e);const dt=this.B(new j.DiskFileSystemProvider(Ge));_e.registerProvider(k.Schemas.file,dt);const gt=this.B(new he.FileUserDataProvider(k.Schemas.file,this.B(new me.DiskFileSystemProviderClient(Ke.getChannel(me.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:se.isLinux})),k.Schemas.vscodeUserData,Ge));_e.registerProvider(k.Schemas.vscodeUserData,gt);const tt=this.B(new xe.UserDataProfilesService(this.c.profiles.all,I.URI.revive(this.c.profiles.home).with({scheme:He.userRoamingDataHome.scheme}),Ke.getChannel("userDataProfiles")));be.set(Te.IUserDataProfilesService,tt);const Xe=this.B(new d.ConfigurationService(tt.defaultProfile.settingsResource,_e,at,Ge));be.set(u.IConfigurationService,Xe);const st=new Mt.RemoteStorageService(void 0,{defaultProfile:tt.defaultProfile,currentProfile:tt.defaultProfile},Ke,He);be.set(re.IStorageService,st),this.B((0,T.toDisposable)(()=>st.flush())),await Promise.all([Xe.initialize(),st.initialize()]);const mt=new Ae.UriIdentityService(_e);be.set(Me.IUriIdentityService,mt),be.set(ne.IRequestService,new At.RequestChannelClient(Ke.getChannel("request"))),be.set(a.IChecksumService,new B.SyncDescriptor(h.ChecksumService,void 0,!1)),be.set(we.IV8InspectProfilingService,new B.SyncDescriptor(pe.InspectProfilingService,void 0,!1));const lt=v.ProxyChannel.toService(Ke.getChannel("nativeHost"));be.set(Tt.INativeHostService,lt),be.set(n.IDownloadService,new B.SyncDescriptor(r.DownloadService,void 0,!0));const jt=this.B(new Ie.ActiveWindowManager(lt)),$t=new v.StaticRouter(Ve=>jt.getActiveClientId().then(ht=>Ve===ht));be.set(P.IExtensionRecommendationNotificationService,new Ot.ExtensionRecommendationNotificationServiceChannelClient(this.a.getChannel("extensionRecommendationNotification",$t)));let ut;const rt=[],bt=(0,q.isInternalTelemetry)(Ue,Xe);if((0,q.supportsTelemetry)(Ue,He)){const Ve=new C.TelemetryLogAppender(Ge,Ze,He,Ue);if(rt.push(Ve),Ue.aiConfig?.ariaKey){const ht=new et.OneDataSystemAppender(bt,"monacoworkbench",null,Ue.aiConfig.ariaKey);this.B((0,T.toDisposable)(()=>ht.flush())),rt.push(ht)}ut=new U.TelemetryService({appenders:rt,commonProperties:(0,X.resolveCommonProperties)((0,N.release)(),(0,N.hostname)(),process.arch,Ue.commit,Ue.version,this.c.machineId,bt),sendErrorTelemetry:!0,piiPaths:(0,q.getPiiPathsFromEnvironment)(He)},Xe,Ue)}else{ut=q.NullTelemetryService;const Ve=q.NullAppender;rt.push(Ve)}this.a.registerChannel("telemetryAppender",new F.TelemetryAppenderChannel(rt)),be.set(K.ITelemetryService,ut);const zt=new G.CustomEndpointTelemetryService(Xe,ut,Ge,Ze,He,Ue);be.set(K.ICustomEndpointTelemetryService,zt),be.set(qe.IExtensionsProfileScannerService,new B.SyncDescriptor(Lt.ExtensionsProfileScannerService,void 0,!0)),be.set(Ce.IExtensionsScannerService,new B.SyncDescriptor(De.ExtensionsScannerService,void 0,!0)),be.set(y.IExtensionSignatureVerificationService,new B.SyncDescriptor(y.ExtensionSignatureVerificationService,void 0,!0)),be.set(f.INativeServerExtensionManagementService,new B.SyncDescriptor(f.ExtensionManagementService,void 0,!0)),be.set(c.IExtensionGalleryService,new B.SyncDescriptor(o.ExtensionGalleryService,void 0,!0)),be.set(c.IExtensionTipsService,new B.SyncDescriptor(Ut.ExtensionTipsService,void 0,!1)),be.set(_.ILanguagePackService,new B.SyncDescriptor(Y.NativeLanguagePackService,void 0,!1)),be.set(S.IDiagnosticsService,new B.SyncDescriptor(L.DiagnosticsService,void 0,!1)),be.set(de.IUserDataSyncAccountService,new B.SyncDescriptor(de.UserDataSyncAccountService,void 0,!0)),be.set(ue.IUserDataSyncLogService,new B.SyncDescriptor(Ee.UserDataSyncLogService,void 0,!0)),be.set(ue.IUserDataSyncUtilService,new Se.UserDataSyncUtilServiceClient(this.a.getChannel("userDataSyncUtil",Ve=>Ve.ctx!=="main"))),be.set(c.IGlobalExtensionEnablementService,new B.SyncDescriptor(s.GlobalExtensionEnablementService,void 0,!1)),be.set(ce.IIgnoredExtensionsManagementService,new B.SyncDescriptor(ce.IgnoredExtensionsManagementService,void 0,!0)),be.set(ee.IExtensionStorageService,new B.SyncDescriptor(ee.ExtensionStorageService)),be.set(ue.IUserDataSyncStoreManagementService,new B.SyncDescriptor(le.UserDataSyncStoreManagementService,void 0,!0)),be.set(ue.IUserDataSyncStoreService,new B.SyncDescriptor(le.UserDataSyncStoreService,void 0,!0)),be.set(Re.IUserDataSyncMachinesService,new B.SyncDescriptor(Re.UserDataSyncMachinesService,void 0,!0)),be.set(ue.IUserDataSyncBackupStoreService,new B.SyncDescriptor(ye.UserDataSyncBackupStoreService,void 0,!1)),be.set(ue.IUserDataSyncEnablementService,new B.SyncDescriptor(ke.UserDataSyncEnablementService,void 0,!0)),be.set(ue.IUserDataSyncService,new B.SyncDescriptor(Be.UserDataSyncService,void 0,!1)),be.set(fe.IUserDataProfileStorageService,new B.SyncDescriptor(ge.NativeUserDataProfileStorageService,void 0,!0)),be.set(ue.IUserDataSyncResourceProviderService,new B.SyncDescriptor(It.UserDataSyncResourceProviderService,void 0,!0));const Et=new Z.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Xe.getValue("terminal.integrated.persistentSessionScrollback")??100},!1,Xe,He,Ge,Ze);return Et.initialize(),be.set(A.ILocalPtyService,this.B(Et)),be.set(Pe.ISignService,new B.SyncDescriptor(Fe.SignService,void 0,!1)),be.set(Le.ISharedTunnelsService,new B.SyncDescriptor(ze.SharedTunnelsService)),be.set(Ne.ISharedProcessTunnelService,new B.SyncDescriptor(je.SharedProcessTunnelService)),be.set(yt.IRemoteTunnelService,new B.SyncDescriptor(kt.RemoteTunnelService)),new H.InstantiationService(be)}h(be){const Ue=new w.ExtensionManagementChannel(be.get(c.IExtensionManagementService),()=>null);this.a.registerChannel("extensions",Ue);const Je=v.ProxyChannel.fromService(be.get(_.ILanguagePackService));this.a.registerChannel("languagePacks",Je);const Ke=v.ProxyChannel.fromService(be.get(S.IDiagnosticsService));this.a.registerChannel("diagnostics",Ke);const at=new w.ExtensionTipsChannel(be.get(c.IExtensionTipsService));this.a.registerChannel("extensionTipsService",at);const He=v.ProxyChannel.fromService(be.get(a.IChecksumService));this.a.registerChannel("checksum",He);const Ze=v.ProxyChannel.fromService(be.get(we.IV8InspectProfilingService));this.a.registerChannel("v8InspectProfiling",Ze);const ct=new Se.UserDataSyncMachinesServiceChannel(be.get(Re.IUserDataSyncMachinesService));this.a.registerChannel("userDataSyncMachines",ct);const ft=v.ProxyChannel.fromService(be.get(K.ICustomEndpointTelemetryService));this.a.registerChannel("customEndpointTelemetry",ft);const Ge=new Se.UserDataSyncAccountServiceChannel(be.get(de.IUserDataSyncAccountService));this.a.registerChannel("userDataSyncAccount",Ge);const _e=new Se.UserDataSyncStoreManagementServiceChannel(be.get(ue.IUserDataSyncStoreManagementService));this.a.registerChannel("userDataSyncStoreManagement",_e);const dt=new Ye.UserDataSyncChannel(be.get(ue.IUserDataSyncService),be.get(Te.IUserDataProfilesService),be.get($.ILogService));this.a.registerChannel("userDataSync",dt);const gt=this.B(be.get(W.IInstantiationService).createInstance(Nt.UserDataAutoSyncService)),tt=new Se.UserDataAutoSyncChannel(gt);this.a.registerChannel("userDataAutoSync",tt);const Xe=be.get(A.ILocalPtyService),st=v.ProxyChannel.fromService(Xe);this.a.registerChannel(V.TerminalIpcChannels.LocalPty,st);const mt=v.ProxyChannel.fromService(be.get(Ne.ISharedProcessTunnelService));this.a.registerChannel(Ne.ipcSharedProcessTunnelChannelName,mt);const lt=v.ProxyChannel.fromService(be.get(yt.IRemoteTunnelService));this.a.registerChannel("remoteTunnel",lt)}i(be){process.on("uncaughtException",Ue=>(0,O.onUnexpectedError)(Ue)),process.on("unhandledRejection",Ue=>(0,O.onUnexpectedError)(Ue)),(0,O.setUnexpectedErrorHandler)(Ue=>{const Je=(0,l.toErrorMessage)(Ue,!0);Je&&be.error(`[uncaught exception in sharedProcess]: ${Je}`)})}}async function wt(ot){const be=new Ft(ot);process.parentPort.postMessage("vscode:shared-process->electron-main=ipc-ready"),await be.init(),process.parentPort.postMessage("vscode:shared-process->electron-main=init-done")}e.main=wt,process.parentPort.once("message",ot=>{wt(ot.data)})})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/code/node/sharedProcess/sharedProcessMain.js.map
