/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Ce=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/errors","vs/base/common/strings","vs/base/common/types","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/platform","vs/base/common/path","vs/platform/log/common/log","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/editor/common/core/range","vs/base/common/extpath","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/stopwatch","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/iterator","vs/base/common/themables","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/codicons","vs/base/common/hash","vs/base/common/ternarySearchTree","vs/base/common/marshalling","fs","os","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/stream","vs/base/common/uint","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/base/common/comparers","vs/base/common/processes","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","net","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/parts/ipc/node/ipc.net","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/platform","vs/base/common/actions","vs/base/common/cache","vs/base/common/iconLabels","vs/editor/common/languageSelector","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostInteractiveSession","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/proxyResolver","http","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostInteractiveSession","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHostCLIServer","vs/workbench/api/node/extHostExtensionService","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","@vscode/proxy-agent","events","vscode-regexpp","crypto","zlib","vs/workbench/api/node/extensionHostProcess","minimist"],ke=function(ae){for(var e=[],o=0,R=ae.length;o<R;o++)e[o]=Ce[ae[o]];return e};define(Ce[62],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function o(A,P){const D=Object.create(null);for(const p of A){const O=P(p);let k=D[O];k||(k=D[O]=[]),k.push(p)}return D}e.groupBy=o;function R(A,P){const D=[],p=[];for(const O of A)P.has(O)||D.push(O);for(const O of P)A.has(O)||p.push(O);return{removed:D,added:p}}e.diffSets=R;function l(A,P){const D=[],p=[];for(const[O,k]of A)P.has(O)||D.push(k);for(const[O,k]of P)A.has(O)||p.push(k);return{removed:D,added:p}}e.diffMaps=l;class L{constructor(){this.a=new Map}add(P,D){let p=this.a.get(P);p||(p=new Set,this.a.set(P,p)),p.add(D)}delete(P,D){const p=this.a.get(P);p&&(p.delete(D),p.size===0&&this.a.delete(P))}forEach(P,D){const p=this.a.get(P);p&&p.forEach(D)}}e.SetMap=L}),define(Ce[63],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function o(A){return(P,D,p)=>{let O=null,k=null;if(typeof p.value=="function"?(O="value",k=p.value):typeof p.get=="function"&&(O="get",k=p.get),!k)throw new Error("not supported");p[O]=A(k,D)}}function R(A,P,D){let p=null,O=null;if(typeof D.value=="function"?(p="value",O=D.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof D.get=="function"&&(p="get",O=D.get),!O)throw new Error("not supported");const k=`$memoize$${P}`;D[p]=function(...E){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,E)}),this[k]}}e.memoize=R;function l(A,P,D){return o((p,O)=>{const k=`$debounce$${O}`,E=`$debounce$result$${O}`;return function(...T){this[E]||(this[E]=D?D():void 0),clearTimeout(this[k]),P&&(this[E]=P(this[E],...T),T=[this[E]]),this[k]=setTimeout(()=>{p.apply(this,T),this[E]=D?D():void 0},A)}})}e.debounce=l;function L(A,P,D){return o((p,O)=>{const k=`$throttle$timer$${O}`,E=`$throttle$result$${O}`,T=`$throttle$lastRun$${O}`,I=`$throttle$pending$${O}`;return function(...v){if(this[E]||(this[E]=D?D():void 0),(this[T]===null||this[T]===void 0)&&(this[T]=-Number.MAX_VALUE),P&&(this[E]=P(this[E],...v)),this[I])return;const i=this[T]+A;i<=Date.now()?(this[T]=Date.now(),p.apply(this,[this[E]]),this[E]=D?D():void 0):(this[I]=!0,this[k]=setTimeout(()=>{this[I]=!1,this[T]=Date.now(),p.apply(this,[this[E]]),this[E]=D?D():void 0},i-Date.now()))}})}e.throttle=L}),define(Ce[8],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class o{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?w.isErrorNoTelemetry(s)?new w(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(r=>{r(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.ErrorHandler=o,e.errorHandler=new o;function R(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=R;function l(t){if(!t||typeof t!="object")return!1;const s=t;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function L(t){p(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=L;function A(t){p(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=A;function P(t){if(t instanceof Error){const{name:s,message:r}=t,a=t.stacktrace||t.stack;return{$isError:!0,name:s,message:r,stack:a,noTelemetry:w.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=P;const D="Canceled";function p(t){return t instanceof O?!0:t instanceof Error&&t.name===D&&t.message===D}e.isCancellationError=p;class O extends Error{constructor(){super(D),this.name=this.message}}e.CancellationError=O;function k(){const t=new Error(D);return t.name=t.message,t}e.canceled=k;function E(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=E;function T(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=T;function I(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=I;function v(t){const s=new Error(`${t} has been disposed`);return s.name="DISPOSED",s}e.disposed=v;function i(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=i;class d extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=d;class h extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=h;class y extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=y;class w extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof w)return s;const r=new w;return r.message=s.message,r.stack=s.stack,r}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=w;class g extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype);debugger}}e.BugIndicatingError=g}),define(Ce[18],ke([1,0,8]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function R(re,ne=0){return re[re.length-(1+ne)]}e.tail=R;function l(re){if(re.length===0)throw new Error("Invalid tail call");return[re.slice(0,re.length-1),re[re.length-1]]}e.tail2=l;function L(re,ne,de=(ee,ce)=>ee===ce){if(re===ne)return!0;if(!re||!ne||re.length!==ne.length)return!1;for(let ee=0,ce=re.length;ee<ce;ee++)if(!de(re[ee],ne[ee]))return!1;return!0}e.equals=L;function A(re,ne){const de=re.length-1;ne<de&&(re[ne]=re[de]),re.pop()}e.removeFastWithoutKeepingOrder=A;function P(re,ne,de){return D(re.length,ee=>de(re[ee],ne))}e.binarySearch=P;function D(re,ne){let de=0,ee=re-1;for(;de<=ee;){const ce=(de+ee)/2|0,le=ne(ce);if(le<0)de=ce+1;else if(le>0)ee=ce-1;else return ce}return-(de+1)}e.binarySearch2=D;function p(re,ne){let de=0,ee=re.length;if(ee===0)return 0;for(;de<ee;){const ce=Math.floor((de+ee)/2);ne(re[ce])?ee=ce:de=ce+1}return de}e.findFirstInSorted=p;function O(re,ne,de){if(re=re|0,re>=ne.length)throw new TypeError("invalid index");const ee=ne[Math.floor(ne.length*Math.random())],ce=[],le=[],ue=[];for(const N of ne){const q=de(N,ee);q<0?ce.push(N):q>0?le.push(N):ue.push(N)}return re<ce.length?O(re,ce,de):re<ce.length+ue.length?ue[0]:O(re-(ce.length+ue.length),le,de)}e.quickSelect=O;function k(re,ne){const de=[];let ee;for(const ce of re.slice(0).sort(ne))!ee||ne(ee[0],ce)!==0?(ee=[ce],de.push(ee)):ee.push(ce);return de}e.groupBy=k;function E(re,ne,de){const ee=[];function ce(N,q,J){if(q===0&&J.length===0)return;const te=ee[ee.length-1];te&&te.start+te.deleteCount===N?(te.deleteCount+=q,te.toInsert.push(...J)):ee.push({start:N,deleteCount:q,toInsert:J})}let le=0,ue=0;for(;;){if(le===re.length){ce(le,0,ne.slice(ue));break}if(ue===ne.length){ce(le,re.length-le,[]);break}const N=re[le],q=ne[ue],J=de(N,q);J===0?(le+=1,ue+=1):J<0?(ce(le,1,[]),le+=1):J>0&&(ce(le,0,[q]),ue+=1)}return ee}e.sortedDiff=E;function T(re,ne,de){const ee=E(re,ne,de),ce=[],le=[];for(const ue of ee)ce.push(...re.slice(ue.start,ue.start+ue.deleteCount)),le.push(...ue.toInsert);return{removed:ce,added:le}}e.delta=T;function I(re,ne,de){if(de===0)return[];const ee=re.slice(0,de).sort(ne);return i(re,ne,ee,de,re.length),ee}e.top=I;function v(re,ne,de,ee,ce){return de===0?Promise.resolve([]):new Promise((le,ue)=>{(async()=>{const N=re.length,q=re.slice(0,de).sort(ne);for(let J=de,te=Math.min(de+ee,N);J<N;J=te,te=Math.min(te+ee,N)){if(J>de&&await new Promise(ve=>setTimeout(ve)),ce&&ce.isCancellationRequested)throw new o.CancellationError;i(re,ne,q,J,te)}return q})().then(le,ue)})}e.topAsync=v;function i(re,ne,de,ee,ce){for(const le=de.length;ee<ce;ee++){const ue=re[ee];if(ne(ue,de[le-1])<0){de.pop();const N=p(de,q=>ne(ue,q)<0);de.splice(N,0,ue)}}}function d(re){return re.filter(ne=>!!ne)}e.coalesce=d;function h(re){let ne=0;for(let de=0;de<re.length;de++)re[de]&&(re[ne]=re[de],ne+=1);re.length=ne}e.coalesceInPlace=h;function y(re,ne,de){re.splice(de,0,re.splice(ne,1)[0])}e.move=y;function w(re){return!Array.isArray(re)||re.length===0}e.isFalsyOrEmpty=w;function g(re){return Array.isArray(re)&&re.length>0}e.isNonEmptyArray=g;function t(re,ne=de=>de){const de=new Set;return re.filter(ee=>{const ce=ne(ee);return de.has(ce)?!1:(de.add(ce),!0)})}e.distinct=t;function s(re){const ne=new Set;return de=>{const ee=re(de);return ne.has(ee)?!1:(ne.add(ee),!0)}}e.uniqueFilter=s;function r(re,ne){const de=a(re,ne);if(de!==-1)return re[de]}e.findLast=r;function a(re,ne){for(let de=re.length-1;de>=0;de--){const ee=re[de];if(ne(ee))return de}return-1}e.lastIndex=a;function b(re,ne){return re.length>0?re[0]:ne}e.firstOrDefault=b;function S(re,ne){return re.length>0?re[re.length-1]:ne}e.lastOrDefault=S;function c(re,ne,de=(ee,ce)=>ee===ce){let ee=0;for(let ce=0,le=Math.min(re.length,ne.length);ce<le&&de(re[ce],ne[ce]);ce++)ee++;return ee}e.commonPrefixLength=c;function u(re){return[].concat(...re)}e.flatten=u;function m(re,ne){let de=typeof ne=="number"?re:0;typeof ne=="number"?de=re:(de=0,ne=re);const ee=[];if(de<=ne)for(let ce=de;ce<ne;ce++)ee.push(ce);else for(let ce=de;ce>ne;ce--)ee.push(ce);return ee}e.range=m;function f(re,ne,de){return re.reduce((ee,ce)=>(ee[ne(ce)]=de?de(ce):ce,ee),Object.create(null))}e.index=f;function n(re,ne){return re.push(ne),()=>C(re,ne)}e.insert=n;function C(re,ne){const de=re.indexOf(ne);if(de>-1)return re.splice(de,1),ne}e.remove=C;function M(re,ne,de){const ee=re.slice(0,ne),ce=re.slice(ne);return ee.concat(de,ce)}e.arrayInsert=M;function H(re,ne){let de;if(typeof ne=="number"){let ee=ne;de=()=>{const ce=Math.sin(ee++)*179426549;return ce-Math.floor(ce)}}else de=Math.random;for(let ee=re.length-1;ee>0;ee-=1){const ce=Math.floor(de()*(ee+1)),le=re[ee];re[ee]=re[ce],re[ce]=le}}e.shuffle=H;function V(re,ne){const de=re.indexOf(ne);de>-1&&(re.splice(de,1),re.unshift(ne))}e.pushToStart=V;function U(re,ne){const de=re.indexOf(ne);de>-1&&(re.splice(de,1),re.push(ne))}e.pushToEnd=U;function z(re,ne){for(const de of ne)re.push(de)}e.pushMany=z;function G(re,ne){return Array.isArray(re)?re.map(ne):ne(re)}e.mapArrayOrNot=G;function F(re){return Array.isArray(re)?re:[re]}e.asArray=F;function $(re){return re[Math.floor(Math.random()*re.length)]}e.getRandomElement=$;function Y(re,ne){for(const de of re){const ee=ne(de);if(ee!==void 0)return ee}}e.mapFind=Y;function _(re,ne,de){const ee=ie(re,ne),ce=re.length,le=de.length;re.length=ce+le;for(let ue=ce-1;ue>=ee;ue--)re[ue+le]=re[ue];for(let ue=0;ue<le;ue++)re[ue+ee]=de[ue]}e.insertInto=_;function Q(re,ne,de,ee){const ce=ie(re,ne),le=re.splice(ce,de);return _(re,ce,ee),le}e.splice=Q;function ie(re,ne){return ne<0?Math.max(ne+re.length,0):Math.min(ne,re.length)}var oe;(function(re){function ne(ce){return ce<0}re.isLessThan=ne;function de(ce){return ce>0}re.isGreaterThan=de;function ee(ce){return ce===0}re.isNeitherLessOrGreaterThan=ee,re.greaterThan=1,re.lessThan=-1,re.neitherLessOrGreaterThan=0})(oe||(e.CompareResult=oe={}));function Ee(re,ne){return(de,ee)=>ne(re(de),re(ee))}e.compareBy=Ee;function he(...re){return(ne,de)=>{for(const ee of re){const ce=ee(ne,de);if(!oe.isNeitherLessOrGreaterThan(ce))return ce}return oe.neitherLessOrGreaterThan}}e.tieBreakComparators=he;const fe=(re,ne)=>re-ne;e.numberComparator=fe;function x(re,ne){if(re.length===0)return;let de=re[0];for(let ee=1;ee<re.length;ee++){const ce=re[ee];ne(ce,de)>0&&(de=ce)}return de}e.findMaxBy=x;function B(re,ne){if(re.length===0)return;let de=re[0];for(let ee=1;ee<re.length;ee++){const ce=re[ee];ne(ce,de)>=0&&(de=ce)}return de}e.findLastMaxBy=B;function Z(re,ne){return x(re,(de,ee)=>-ne(de,ee))}e.findMinBy=Z;class pe{constructor(ne){this.f=ne,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(ne){let de=this.c;for(;de<this.f.length&&ne(this.f[de]);)de++;const ee=de===this.c?null:this.f.slice(this.c,de);return this.c=de,ee}takeFromEndWhile(ne){let de=this.d;for(;de>=0&&ne(this.f[de]);)de--;const ee=de===this.d?null:this.f.slice(de+1,this.d+1);return this.d=de,ee}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const ne=this.f[this.c];return this.c++,ne}removeLast(){const ne=this.f[this.d];return this.d--,ne}takeCount(ne){const de=this.f.slice(this.c,this.c+ne);return this.c+=ne,de}}e.ArrayQueue=pe;class Se{constructor(ne){this.iterate=ne}forEach(ne){this.iterate(de=>(ne(de),!0))}toArray(){const ne=[];return this.iterate(de=>(ne.push(de),!0)),ne}filter(ne){return new Se(de=>this.iterate(ee=>ne(ee)?de(ee):!0))}map(ne){return new Se(de=>this.iterate(ee=>de(ne(ee))))}some(ne){let de=!1;return this.iterate(ee=>(de=ne(ee),!de)),de}findFirst(ne){let de;return this.iterate(ee=>ne(ee)?(de=ee,!1):!0),de}findLast(ne){let de;return this.iterate(ee=>(ne(ee)&&(de=ee),!0)),de}findLastMaxBy(ne){let de,ee=!0;return this.iterate(ce=>((ee||oe.isGreaterThan(ne(ce,de)))&&(ee=!1,de=ce),!0)),de}}e.CallbackIterable=Se,Se.empty=new Se(re=>{})}),define(Ce[51],ke([1,0,8]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function R(D,p){if(!D)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}e.ok=R;function l(D,p="Unreachable"){throw new Error(p)}e.assertNever=l;function L(D){if(!D)throw new o.BugIndicatingError("Assertion Failed")}e.assert=L;function A(D){if(!D()){debugger;D(),(0,o.onUnexpectedError)(new o.BugIndicatingError("Assertion Failed"))}}e.assertFn=A;function P(D,p){let O=0;for(;O<D.length-1;){const k=D[O],E=D[O+1];if(!p(k,E))return!1;O++}return!0}e.checkAdjacentItems=P}),define(Ce[64],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function o(R){const l=this;let L=!1,A;return function(){return L||(L=!0,A=R.apply(l,arguments)),A}}e.once=o}),define(Ce[102],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class o{constructor(l){this.a=l,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=o,e.defaultGenerator=new o("id#")}),define(Ce[52],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var o;(function(R){function l(w){return w&&typeof w=="object"&&typeof w[Symbol.iterator]=="function"}R.is=l;const L=Object.freeze([]);function A(){return L}R.empty=A;function*P(w){yield w}R.single=P;function D(w){return l(w)?w:P(w)}R.wrap=D;function p(w){return w||L}R.from=p;function O(w){return!w||w[Symbol.iterator]().next().done===!0}R.isEmpty=O;function k(w){return w[Symbol.iterator]().next().value}R.first=k;function E(w,g){for(const t of w)if(g(t))return!0;return!1}R.some=E;function T(w,g){for(const t of w)if(g(t))return t}R.find=T;function*I(w,g){for(const t of w)g(t)&&(yield t)}R.filter=I;function*v(w,g){let t=0;for(const s of w)yield g(s,t++)}R.map=v;function*i(...w){for(const g of w)for(const t of g)yield t}R.concat=i;function d(w,g,t){let s=t;for(const r of w)s=g(s,r);return s}R.reduce=d;function*h(w,g,t=w.length){for(g<0&&(g+=w.length),t<0?t+=w.length:t>w.length&&(t=w.length);g<t;g++)yield w[g]}R.slice=h;function y(w,g=Number.POSITIVE_INFINITY){const t=[];if(g===0)return[t,w];const s=w[Symbol.iterator]();for(let r=0;r<g;r++){const a=s.next();if(a.done)return[t,R.empty()];t.push(a.value)}return[t,{[Symbol.iterator](){return s}}]}R.consume=y})(o||(e.Iterable=o={}))}),define(Ce[148],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var o;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(o||(e.ScanError=o={}));var R;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(R||(e.SyntaxKind=R={}));var l;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(l||(e.ParseErrorCode=l={}));var L;(function(t){t.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function A(t,s=!1){let r=0;const a=t.length;let b="",S=0,c=16,u=0;function m(U){let z=0,G=0;for(;z<U;){const F=t.charCodeAt(r);if(F>=48&&F<=57)G=G*16+F-48;else if(F>=65&&F<=70)G=G*16+F-65+10;else if(F>=97&&F<=102)G=G*16+F-97+10;else break;r++,z++}return z<U&&(G=-1),G}function f(U){r=U,b="",S=0,c=16,u=0}function n(){const U=r;if(t.charCodeAt(r)===48)r++;else for(r++;r<t.length&&p(t.charCodeAt(r));)r++;if(r<t.length&&t.charCodeAt(r)===46)if(r++,r<t.length&&p(t.charCodeAt(r)))for(r++;r<t.length&&p(t.charCodeAt(r));)r++;else return u=3,t.substring(U,r);let z=r;if(r<t.length&&(t.charCodeAt(r)===69||t.charCodeAt(r)===101))if(r++,(r<t.length&&t.charCodeAt(r)===43||t.charCodeAt(r)===45)&&r++,r<t.length&&p(t.charCodeAt(r))){for(r++;r<t.length&&p(t.charCodeAt(r));)r++;z=r}else u=3;return t.substring(U,z)}function C(){let U="",z=r;for(;;){if(r>=a){U+=t.substring(z,r),u=2;break}const G=t.charCodeAt(r);if(G===34){U+=t.substring(z,r),r++;break}if(G===92){if(U+=t.substring(z,r),r++,r>=a){u=2;break}switch(t.charCodeAt(r++)){case 34:U+='"';break;case 92:U+="\\";break;case 47:U+="/";break;case 98:U+="\b";break;case 102:U+="\f";break;case 110:U+=`
`;break;case 114:U+="\r";break;case 116:U+="	";break;case 117:{const $=m(4);$>=0?U+=String.fromCharCode($):u=4;break}default:u=5}z=r;continue}if(G>=0&&G<=31)if(D(G)){U+=t.substring(z,r),u=2;break}else u=6;r++}return U}function M(){if(b="",u=0,S=r,r>=a)return S=a,c=17;let U=t.charCodeAt(r);if(P(U)){do r++,b+=String.fromCharCode(U),U=t.charCodeAt(r);while(P(U));return c=15}if(D(U))return r++,b+=String.fromCharCode(U),U===13&&t.charCodeAt(r)===10&&(r++,b+=`
`),c=14;switch(U){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,b=C(),c=10;case 47:{const z=r-1;if(t.charCodeAt(r+1)===47){for(r+=2;r<a&&!D(t.charCodeAt(r));)r++;return b=t.substring(z,r),c=12}if(t.charCodeAt(r+1)===42){r+=2;const G=a-1;let F=!1;for(;r<G;){if(t.charCodeAt(r)===42&&t.charCodeAt(r+1)===47){r+=2,F=!0;break}r++}return F||(r++,u=1),b=t.substring(z,r),c=13}return b+=String.fromCharCode(U),r++,c=16}case 45:if(b+=String.fromCharCode(U),r++,r===a||!p(t.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return b+=n(),c=11;default:for(;r<a&&H(U);)r++,U=t.charCodeAt(r);if(S!==r){switch(b=t.substring(S,r),b){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return b+=String.fromCharCode(U),r++,c=16}}function H(U){if(P(U)||D(U))return!1;switch(U){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function V(){let U;do U=M();while(U>=12&&U<=15);return U}return{setPosition:f,getPosition:()=>r,scan:s?V:M,getToken:()=>c,getTokenValue:()=>b,getTokenOffset:()=>S,getTokenLength:()=>r-S,getTokenError:()=>u}}e.createScanner=A;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function D(t){return t===10||t===13||t===8232||t===8233}function p(t){return t>=48&&t<=57}var O;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(O||(O={}));function k(t,s){const r=[],a=new Object;let b;const S={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function u(m,f,n,C){S.value=m,S.offset=f,S.length=n,S.type=C,S.colonOffset=void 0,b=S}try{y(t,{onObjectBegin:(m,f)=>{if(s<=m)throw a;b=void 0,c=s>m,r.push("")},onObjectProperty:(m,f,n)=>{if(s<f||(u(m,f,n,"property"),r[r.length-1]=m,s<=f+n))throw a},onObjectEnd:(m,f)=>{if(s<=m)throw a;b=void 0,r.pop()},onArrayBegin:(m,f)=>{if(s<=m)throw a;b=void 0,r.push(0)},onArrayEnd:(m,f)=>{if(s<=m)throw a;b=void 0,r.pop()},onLiteralValue:(m,f,n)=>{if(s<f||(u(m,f,n,g(m)),s<=f+n))throw a},onSeparator:(m,f,n)=>{if(s<=f)throw a;if(m===":"&&b&&b.type==="property")b.colonOffset=f,c=!1,b=void 0;else if(m===","){const C=r[r.length-1];typeof C=="number"?r[r.length-1]=C+1:(c=!0,r[r.length-1]=""),b=void 0}}})}catch(m){if(m!==a)throw m}return{path:r,previousNode:b,isAtPropertyKey:c,matches:m=>{let f=0;for(let n=0;f<m.length&&n<r.length;n++)if(m[f]===r[n]||m[f]==="*")f++;else if(m[f]!=="**")return!1;return f===m.length}}}e.getLocation=k;function E(t,s=[],r=L.DEFAULT){let a=null,b=[];const S=[];function c(m){Array.isArray(b)?b.push(m):a!==null&&(b[a]=m)}return y(t,{onObjectBegin:()=>{const m={};c(m),S.push(b),b=m,a=null},onObjectProperty:m=>{a=m},onObjectEnd:()=>{b=S.pop()},onArrayBegin:()=>{const m=[];c(m),S.push(b),b=m,a=null},onArrayEnd:()=>{b=S.pop()},onLiteralValue:c,onError:(m,f,n)=>{s.push({error:m,offset:f,length:n})}},r),b[0]}e.parse=E;function T(t,s=[],r=L.DEFAULT){let a={type:"array",offset:-1,length:-1,children:[],parent:void 0};function b(m){a.type==="property"&&(a.length=m-a.offset,a=a.parent)}function S(m){return a.children.push(m),m}y(t,{onObjectBegin:m=>{a=S({type:"object",offset:m,length:-1,parent:a,children:[]})},onObjectProperty:(m,f,n)=>{a=S({type:"property",offset:f,length:-1,parent:a,children:[]}),a.children.push({type:"string",value:m,offset:f,length:n,parent:a})},onObjectEnd:(m,f)=>{a.length=m+f-a.offset,a=a.parent,b(m+f)},onArrayBegin:(m,f)=>{a=S({type:"array",offset:m,length:-1,parent:a,children:[]})},onArrayEnd:(m,f)=>{a.length=m+f-a.offset,a=a.parent,b(m+f)},onLiteralValue:(m,f,n)=>{S({type:g(m),offset:f,length:n,parent:a,value:m}),b(f+n)},onSeparator:(m,f,n)=>{a.type==="property"&&(m===":"?a.colonOffset=f:m===","&&b(f))},onError:(m,f,n)=>{s.push({error:m,offset:f,length:n})}},r);const u=a.children[0];return u&&delete u.parent,u}e.parseTree=T;function I(t,s){if(!t)return;let r=t;for(const a of s)if(typeof a=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let b=!1;for(const S of r.children)if(Array.isArray(S.children)&&S.children[0].value===a){r=S.children[1],b=!0;break}if(!b)return}else{const b=a;if(r.type!=="array"||b<0||!Array.isArray(r.children)||b>=r.children.length)return;r=r.children[b]}return r}e.findNodeAtLocation=I;function v(t){if(!t.parent||!t.parent.children)return[];const s=v(t.parent);if(t.parent.type==="property"){const r=t.parent.children[0].value;s.push(r)}else if(t.parent.type==="array"){const r=t.parent.children.indexOf(t);r!==-1&&s.push(r)}return s}e.getNodePath=v;function i(t){switch(t.type){case"array":return t.children.map(i);case"object":{const s=Object.create(null);for(const r of t.children){const a=r.children[1];a&&(s[r.children[0].value]=i(a))}return s}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=i;function d(t,s,r=!1){return s>=t.offset&&s<t.offset+t.length||r&&s===t.offset+t.length}e.contains=d;function h(t,s,r=!1){if(d(t,s,r)){const a=t.children;if(Array.isArray(a))for(let b=0;b<a.length&&a[b].offset<=s;b++){const S=h(a[b],s,r);if(S)return S}return t}}e.findNodeAtOffset=h;function y(t,s,r=L.DEFAULT){const a=A(t,!1);function b(Ee){return Ee?()=>Ee(a.getTokenOffset(),a.getTokenLength()):()=>!0}function S(Ee){return Ee?he=>Ee(he,a.getTokenOffset(),a.getTokenLength()):()=>!0}const c=b(s.onObjectBegin),u=S(s.onObjectProperty),m=b(s.onObjectEnd),f=b(s.onArrayBegin),n=b(s.onArrayEnd),C=S(s.onLiteralValue),M=S(s.onSeparator),H=b(s.onComment),V=S(s.onError),U=r&&r.disallowComments,z=r&&r.allowTrailingComma;function G(){for(;;){const Ee=a.scan();switch(a.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:U||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(Ee){case 12:case 13:U?F(10):H();break;case 16:F(1);break;case 15:case 14:break;default:return Ee}}}function F(Ee,he=[],fe=[]){if(V(Ee),he.length+fe.length>0){let x=a.getToken();for(;x!==17;){if(he.indexOf(x)!==-1){G();break}else if(fe.indexOf(x)!==-1)break;x=G()}}}function $(Ee){const he=a.getTokenValue();return Ee?C(he):u(he),G(),!0}function Y(){switch(a.getToken()){case 11:{let Ee=0;try{Ee=JSON.parse(a.getTokenValue()),typeof Ee!="number"&&(F(2),Ee=0)}catch{F(2)}C(Ee);break}case 7:C(null);break;case 8:C(!0);break;case 9:C(!1);break;default:return!1}return G(),!0}function _(){return a.getToken()!==10?(F(3,[],[2,5]),!1):($(!1),a.getToken()===6?(M(":"),G(),oe()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function Q(){c(),G();let Ee=!1;for(;a.getToken()!==2&&a.getToken()!==17;){if(a.getToken()===5){if(Ee||F(4,[],[]),M(","),G(),a.getToken()===2&&z)break}else Ee&&F(6,[],[]);_()||F(4,[],[2,5]),Ee=!0}return m(),a.getToken()!==2?F(7,[2],[]):G(),!0}function ie(){f(),G();let Ee=!1;for(;a.getToken()!==4&&a.getToken()!==17;){if(a.getToken()===5){if(Ee||F(4,[],[]),M(","),G(),a.getToken()===4&&z)break}else Ee&&F(6,[],[]);oe()||F(4,[],[4,5]),Ee=!0}return n(),a.getToken()!==4?F(8,[4],[]):G(),!0}function oe(){switch(a.getToken()){case 3:return ie();case 1:return Q();case 10:return $(!0);default:return Y()}}return G(),a.getToken()===17?r.allowEmptyContent?!0:(F(4,[],[]),!1):oe()?(a.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=y;function w(t,s){const r=A(t),a=[];let b,S=0,c;do switch(c=r.getPosition(),b=r.scan(),b){case 12:case 13:case 17:S!==c&&a.push(t.substring(S,c)),s!==void 0&&a.push(r.getTokenValue().replace(/[^\r\n]/g,s)),S=r.getPosition();break}while(b!==17);return a.join("")}e.stripComments=w;function g(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(Ce[65],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class o{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=o}),define(Ce[6],ke([1,0,64,52]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let L=null;function A(S){L=S}if(e.setDisposableTracker=A,l){const S="__is_disposable_tracked__";A(new class{trackDisposable(c){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{c[S]||console.log(u)},3e3)}setParent(c,u){if(c&&c!==h.None)try{c[S]=!0}catch{}}markAsDisposed(c){if(c&&c!==h.None)try{c[S]=!0}catch{}}markAsSingleton(c){}})}function P(S){return L?.trackDisposable(S),S}function D(S){L?.markAsDisposed(S)}function p(S,c){L?.setParent(S,c)}function O(S,c){if(L)for(const u of S)L.setParent(u,c)}function k(S){return L?.markAsSingleton(S),S}e.markAsSingleton=k;function E(S){return typeof S.dispose=="function"&&S.dispose.length===0}e.isDisposable=E;function T(S){if(R.Iterable.is(S)){const c=[];for(const u of S)if(u)try{u.dispose()}catch(m){c.push(m)}if(c.length===1)throw c[0];if(c.length>1)throw new AggregateError(c,"Encountered errors while disposing of store");return Array.isArray(S)?[]:S}else if(S)return S.dispose(),S}e.dispose=T;function I(S){for(const c of S)E(c)&&c.dispose();return[]}e.disposeIfDisposable=I;function v(...S){const c=i(()=>T(S));return O(S,c),c}e.combinedDisposable=v;function i(S){const c=P({dispose:(0,o.once)(()=>{D(c),S()})});return c}e.toDisposable=i;class d{constructor(){this.f=new Set,this.g=!1,P(this)}dispose(){this.g||(D(this),this.g=!0,this.clear())}get isDisposed(){return this.g}clear(){if(this.f.size!==0)try{T(this.f)}finally{this.f.clear()}}add(c){if(!c)return c;if(c===this)throw new Error("Cannot register a disposable on itself!");return p(c,this),this.g?d.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.f.add(c),c}}e.DisposableStore=d,d.DISABLE_DISPOSED_WARNING=!1;class h{constructor(){this.q=new d,P(this),p(this.q,this)}dispose(){D(this),this.q.dispose()}B(c){if(c===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(c)}}e.Disposable=h,h.None=Object.freeze({dispose(){}});class y{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(c){this.b||c===this.a||(this.a?.dispose(),c&&p(c,this),this.a=c)}clear(){this.value=void 0}dispose(){this.b=!0,D(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const c=this.a;return this.a=void 0,c&&p(c,null),c}}e.MutableDisposable=y;class w{constructor(c){this.b=c,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=w;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(c){let u=c;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,D(this))},this}}e.SafeDisposable=g;class t{constructor(){this.a=new Map}acquire(c,...u){let m=this.a.get(c);m||(m={counter:0,object:this.b(c,...u)},this.a.set(c,m));const{object:f}=m,n=(0,o.once)(()=>{--m.counter===0&&(this.c(c,m.object),this.a.delete(c))});return m.counter++,{object:f,dispose:n}}}e.ReferenceCollection=t;class s{constructor(c){this.a=c}async acquire(c,...u){const m=this.a.acquire(c,...u);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(f){throw m.dispose(),f}}}e.AsyncReferenceCollection=s;class r{constructor(c){this.object=c}dispose(){}}e.ImmortalReference=r;function a(S){const c=new d;try{S(c)}finally{c.dispose()}}e.disposeOnReturn=a;class b{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){D(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(this.a.size)try{T(this.a.values())}finally{this.a.clear()}}has(c){return this.a.has(c)}get(c){return this.a.get(c)}set(c,u,m=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),m||this.a.get(c)?.dispose(),this.a.set(c,u)}deleteAndDispose(c){this.a.get(c)?.dispose(),this.a.delete(c)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=b}),define(Ce[66],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class o{constructor(L){this.element=L,this.next=o.Undefined,this.prev=o.Undefined}}o.Undefined=new o(void 0);class R{constructor(){this.a=o.Undefined,this.b=o.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===o.Undefined}clear(){let L=this.a;for(;L!==o.Undefined;){const A=L.next;L.prev=o.Undefined,L.next=o.Undefined,L=A}this.a=o.Undefined,this.b=o.Undefined,this.c=0}unshift(L){return this.d(L,!1)}push(L){return this.d(L,!0)}d(L,A){const P=new o(L);if(this.a===o.Undefined)this.a=P,this.b=P;else if(A){const p=this.b;this.b=P,P.prev=p,p.next=P}else{const p=this.a;this.a=P,P.next=p,p.prev=P}this.c+=1;let D=!1;return()=>{D||(D=!0,this.e(P))}}shift(){if(this.a!==o.Undefined){const L=this.a.element;return this.e(this.a),L}}pop(){if(this.b!==o.Undefined){const L=this.b.element;return this.e(this.b),L}}e(L){if(L.prev!==o.Undefined&&L.next!==o.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===o.Undefined&&L.next===o.Undefined?(this.a=o.Undefined,this.b=o.Undefined):L.next===o.Undefined?(this.b=this.b.prev,this.b.next=o.Undefined):L.prev===o.Undefined&&(this.a=this.a.next,this.a.prev=o.Undefined);this.c-=1}*[Symbol.iterator](){let L=this.a;for(;L!==o.Undefined;)yield L.element,L=L.next}}e.LinkedList=R}),define(Ce[28],ke([1,0]),function(ae,e){"use strict";var o,R,l;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(v,i,d){let h=v.get(i);return h===void 0&&(h=d,v.set(i,h)),h}e.getOrSet=L;function A(v){const i=[];return v.forEach((d,h)=>{i.push(`${h} => ${d}`)}),`Map(${v.size}) {${i.join(", ")}}`}e.mapToString=A;function P(v){const i=[];return v.forEach(d=>{i.push(d)}),`Set(${v.size}) {${i.join(", ")}}`}e.setToString=P;class D{constructor(i,d){this.uri=i,this.value=d}}class p{constructor(i,d){this[o]="ResourceMap",i instanceof p?(this.b=new Map(i.b),this.c=d??p.a):(this.b=new Map,this.c=i??p.a)}set(i,d){return this.b.set(this.c(i),new D(i,d)),this}get(i){return this.b.get(this.c(i))?.value}has(i){return this.b.has(this.c(i))}get size(){return this.b.size}clear(){this.b.clear()}delete(i){return this.b.delete(this.c(i))}forEach(i,d){typeof d<"u"&&(i=i.bind(d));for(const[h,y]of this.b)i(y.value,y.uri,this)}*values(){for(const i of this.b.values())yield i.value}*keys(){for(const i of this.b.values())yield i.uri}*entries(){for(const i of this.b.values())yield[i.uri,i.value]}*[(o=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.b)yield[i.uri,i.value]}}e.ResourceMap=p,p.a=v=>v.toString();class O{constructor(i,d){this[R]="ResourceSet",!i||typeof i=="function"?this.a=new p(i):(this.a=new p(d),i.forEach(this.add,this))}get size(){return this.a.size}add(i){return this.a.set(i,i),this}clear(){this.a.clear()}delete(i){return this.a.delete(i)}forEach(i,d){this.a.forEach((h,y)=>i.call(d,y,y,this))}has(i){return this.a.has(i)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(R=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var k;(function(v){v[v.None=0]="None",v[v.AsOld=1]="AsOld",v[v.AsNew=2]="AsNew"})(k||(e.Touch=k={}));class E{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(i){return this.a.has(i)}get(i,d=0){const h=this.a.get(i);if(h)return d!==0&&this.j(h,d),h.value}set(i,d,h=0){let y=this.a.get(i);if(y)y.value=d,h!==0&&this.j(y,h);else{switch(y={key:i,value:d,next:void 0,previous:void 0},h){case 0:this.h(y);break;case 1:this.g(y);break;case 2:this.h(y);break;default:this.h(y);break}this.a.set(i,y),this.d++}return this}delete(i){return!!this.remove(i)}remove(i){const d=this.a.get(i);if(d)return this.a.delete(i),this.i(d),this.d--,d.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const i=this.b;return this.a.delete(i.key),this.i(i),this.d--,i.value}forEach(i,d){const h=this.e;let y=this.b;for(;y;){if(d?i.bind(d)(y.value,y.key,this):i(y.value,y.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");y=y.next}}keys(){const i=this,d=this.e;let h=this.b;const y={[Symbol.iterator](){return y},next(){if(i.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const w={value:h.key,done:!1};return h=h.next,w}else return{value:void 0,done:!0}}};return y}values(){const i=this,d=this.e;let h=this.b;const y={[Symbol.iterator](){return y},next(){if(i.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const w={value:h.value,done:!1};return h=h.next,w}else return{value:void 0,done:!0}}};return y}entries(){const i=this,d=this.e;let h=this.b;const y={[Symbol.iterator](){return y},next(){if(i.e!==d)throw new Error("LinkedMap got modified during iteration.");if(h){const w={value:[h.key,h.value],done:!1};return h=h.next,w}else return{value:void 0,done:!0}}};return y}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(i){if(i>=this.size)return;if(i===0){this.clear();return}let d=this.b,h=this.size;for(;d&&h>i;)this.a.delete(d.key),d=d.next,h--;this.b=d,this.d=h,d&&(d.previous=void 0),this.e++}g(i){if(!this.b&&!this.c)this.c=i;else if(this.b)i.next=this.b,this.b.previous=i;else throw new Error("Invalid list");this.b=i,this.e++}h(i){if(!this.b&&!this.c)this.b=i;else if(this.c)i.previous=this.c,this.c.next=i;else throw new Error("Invalid list");this.c=i,this.e++}i(i){if(i===this.b&&i===this.c)this.b=void 0,this.c=void 0;else if(i===this.b){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this.b=i.next}else if(i===this.c){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this.c=i.previous}else{const d=i.next,h=i.previous;if(!d||!h)throw new Error("Invalid list");d.previous=h,h.next=d}i.next=void 0,i.previous=void 0,this.e++}j(i,d){if(!this.b||!this.c)throw new Error("Invalid list");if(!(d!==1&&d!==2)){if(d===1){if(i===this.b)return;const h=i.next,y=i.previous;i===this.c?(y.next=void 0,this.c=y):(h.previous=y,y.next=h),i.previous=void 0,i.next=this.b,this.b.previous=i,this.b=i,this.e++}else if(d===2){if(i===this.c)return;const h=i.next,y=i.previous;i===this.b?(h.previous=void 0,this.b=h):(h.previous=y,y.next=h),i.next=void 0,i.previous=this.c,this.c.next=i,this.c=i,this.e++}}}toJSON(){const i=[];return this.forEach((d,h)=>{i.push([h,d])}),i}fromJSON(i){this.clear();for(const[d,h]of i)this.set(d,h)}}e.LinkedMap=E;class T extends E{constructor(i,d=1){super(),this.k=i,this.l=Math.min(Math.max(0,d),1)}get limit(){return this.k}set limit(i){this.k=i,this.m()}get ratio(){return this.l}set ratio(i){this.l=Math.min(Math.max(0,i),1),this.m()}get(i,d=2){return super.get(i,d)}peek(i){return super.get(i,0)}set(i,d){return super.set(i,d,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=T;class I{constructor(){this.a=new Map}add(i){return this.a.set(i,(this.a.get(i)||0)+1),this}delete(i){let d=this.a.get(i)||0;return d===0?!1:(d--,d===0?this.a.delete(i):this.a.set(i,d),!0)}has(i){return this.a.has(i)}}e.CounterSet=I}),function(ae,e){typeof define=="function"&&define.amd?define(Ce[149],ke([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(ae=typeof globalThis<"u"?globalThis:ae||self,e(ae.marked={}))}(this,function(ae){"use strict";function e(re,ne){for(var de=0;de<ne.length;de++){var ee=ne[de];ee.enumerable=ee.enumerable||!1,ee.configurable=!0,"value"in ee&&(ee.writable=!0),Object.defineProperty(re,ee.key,ee)}}function o(re,ne,de){return ne&&e(re.prototype,ne),de&&e(re,de),Object.defineProperty(re,"prototype",{writable:!1}),re}function R(re,ne){if(re){if(typeof re=="string")return l(re,ne);var de=Object.prototype.toString.call(re).slice(8,-1);if(de==="Object"&&re.constructor&&(de=re.constructor.name),de==="Map"||de==="Set")return Array.from(re);if(de==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(de))return l(re,ne)}}function l(re,ne){(ne==null||ne>re.length)&&(ne=re.length);for(var de=0,ee=new Array(ne);de<ne;de++)ee[de]=re[de];return ee}function L(re,ne){var de=typeof Symbol<"u"&&re[Symbol.iterator]||re["@@iterator"];if(de)return(de=de.call(re)).next.bind(de);if(Array.isArray(re)||(de=R(re))||ne&&re&&typeof re.length=="number"){de&&(re=de);var ee=0;return function(){return ee>=re.length?{done:!0}:{done:!1,value:re[ee++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}ae.defaults=A();function P(re){ae.defaults=re}var D=/[&<>"']/,p=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,k=/[<>"']|&(?!#?\w+;)/g,E={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},T=function(ne){return E[ne]};function I(re,ne){if(ne){if(D.test(re))return re.replace(p,T)}else if(O.test(re))return re.replace(k,T);return re}var v=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function i(re){return re.replace(v,function(ne,de){return de=de.toLowerCase(),de==="colon"?":":de.charAt(0)==="#"?de.charAt(1)==="x"?String.fromCharCode(parseInt(de.substring(2),16)):String.fromCharCode(+de.substring(1)):""})}var d=/(^|[^\[])\^/g;function h(re,ne){re=typeof re=="string"?re:re.source,ne=ne||"";var de={replace:function(ce,le){return le=le.source||le,le=le.replace(d,"$1"),re=re.replace(ce,le),de},getRegex:function(){return new RegExp(re,ne)}};return de}var y=/[^\w:]/g,w=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(re,ne,de){if(re){var ee;try{ee=decodeURIComponent(i(de)).replace(y,"").toLowerCase()}catch{return null}if(ee.indexOf("javascript:")===0||ee.indexOf("vbscript:")===0||ee.indexOf("data:")===0)return null}ne&&!w.test(de)&&(de=b(ne,de));try{de=encodeURI(de).replace(/%25/g,"%")}catch{return null}return de}var t={},s=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,a=/^([^:]+:\/*[^/]*)[\s\S]*$/;function b(re,ne){t[" "+re]||(s.test(re)?t[" "+re]=re+"/":t[" "+re]=m(re,"/",!0)),re=t[" "+re];var de=re.indexOf(":")===-1;return ne.substring(0,2)==="//"?de?ne:re.replace(r,"$1")+ne:ne.charAt(0)==="/"?de?ne:re.replace(a,"$1")+ne:re+ne}var S={exec:function(){}};function c(re){for(var ne=1,de,ee;ne<arguments.length;ne++){de=arguments[ne];for(ee in de)Object.prototype.hasOwnProperty.call(de,ee)&&(re[ee]=de[ee])}return re}function u(re,ne){var de=re.replace(/\|/g,function(le,ue,N){for(var q=!1,J=ue;--J>=0&&N[J]==="\\";)q=!q;return q?"|":" |"}),ee=de.split(/ \|/),ce=0;if(ee[0].trim()||ee.shift(),ee.length>0&&!ee[ee.length-1].trim()&&ee.pop(),ee.length>ne)ee.splice(ne);else for(;ee.length<ne;)ee.push("");for(;ce<ee.length;ce++)ee[ce]=ee[ce].trim().replace(/\\\|/g,"|");return ee}function m(re,ne,de){var ee=re.length;if(ee===0)return"";for(var ce=0;ce<ee;){var le=re.charAt(ee-ce-1);if(le===ne&&!de)ce++;else if(le!==ne&&de)ce++;else break}return re.slice(0,ee-ce)}function f(re,ne){if(re.indexOf(ne[1])===-1)return-1;for(var de=re.length,ee=0,ce=0;ce<de;ce++)if(re[ce]==="\\")ce++;else if(re[ce]===ne[0])ee++;else if(re[ce]===ne[1]&&(ee--,ee<0))return ce;return-1}function n(re){re&&re.sanitize&&!re.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function C(re,ne){if(ne<1)return"";for(var de="";ne>1;)ne&1&&(de+=re),ne>>=1,re+=re;return de+re}function M(re,ne,de,ee){var ce=ne.href,le=ne.title?I(ne.title):null,ue=re[1].replace(/\\([\[\]])/g,"$1");if(re[0].charAt(0)!=="!"){ee.state.inLink=!0;var N={type:"link",raw:de,href:ce,title:le,text:ue,tokens:ee.inlineTokens(ue)};return ee.state.inLink=!1,N}return{type:"image",raw:de,href:ce,title:le,text:I(ue)}}function H(re,ne){var de=re.match(/^(\s+)(?:```)/);if(de===null)return ne;var ee=de[1];return ne.split(`
`).map(function(ce){var le=ce.match(/^\s+/);if(le===null)return ce;var ue=le[0];return ue.length>=ee.length?ce.slice(ee.length):ce}).join(`
`)}var V=function(){function re(de){this.options=de||ae.defaults}var ne=re.prototype;return ne.space=function(ee){var ce=this.rules.block.newline.exec(ee);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},ne.code=function(ee){var ce=this.rules.block.code.exec(ee);if(ce){var le=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?le:m(le,`
`)}}},ne.fences=function(ee){var ce=this.rules.block.fences.exec(ee);if(ce){var le=ce[0],ue=H(le,ce[3]||"");return{type:"code",raw:le,lang:ce[2]?ce[2].trim():ce[2],text:ue}}},ne.heading=function(ee){var ce=this.rules.block.heading.exec(ee);if(ce){var le=ce[2].trim();if(/#$/.test(le)){var ue=m(le,"#");(this.options.pedantic||!ue||/ $/.test(ue))&&(le=ue.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:le,tokens:this.lexer.inline(le)}}},ne.hr=function(ee){var ce=this.rules.block.hr.exec(ee);if(ce)return{type:"hr",raw:ce[0]}},ne.blockquote=function(ee){var ce=this.rules.block.blockquote.exec(ee);if(ce){var le=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(le,[]),text:le}}},ne.list=function(ee){var ce=this.rules.block.list.exec(ee);if(ce){var le,ue,N,q,J,te,ve,De,me,Te,Pe,$e,Ve=ce[1].trim(),et=Ve.length>1,Ye={type:"list",raw:"",ordered:et,start:et?+Ve.slice(0,-1):"",loose:!1,items:[]};Ve=et?"\\d{1,9}\\"+Ve.slice(-1):"\\"+Ve,this.options.pedantic&&(Ve=et?Ve:"[*+-]");for(var Je=new RegExp("^( {0,3}"+Ve+")((?:[	 ][^\\n]*)?(?:\\n|$))");ee&&($e=!1,!(!(ce=Je.exec(ee))||this.rules.block.hr.test(ee)));){if(le=ce[0],ee=ee.substring(le.length),De=ce[2].split(`
`,1)[0],me=ee.split(`
`,1)[0],this.options.pedantic?(q=2,Pe=De.trimLeft()):(q=ce[2].search(/[^ ]/),q=q>4?1:q,Pe=De.slice(q),q+=ce[1].length),te=!1,!De&&/^ *$/.test(me)&&(le+=me+`
`,ee=ee.substring(me.length+1),$e=!0),!$e)for(var nt=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ct=new RegExp("^ {0,"+Math.min(3,q-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Fe=new RegExp("^ {0,"+Math.min(3,q-1)+"}(?:```|~~~)"),it=new RegExp("^ {0,"+Math.min(3,q-1)+"}#");ee&&(Te=ee.split(`
`,1)[0],De=Te,this.options.pedantic&&(De=De.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Fe.test(De)||it.test(De)||nt.test(De)||ct.test(ee)));){if(De.search(/[^ ]/)>=q||!De.trim())Pe+=`
`+De.slice(q);else if(!te)Pe+=`
`+De;else break;!te&&!De.trim()&&(te=!0),le+=Te+`
`,ee=ee.substring(Te.length+1)}Ye.loose||(ve?Ye.loose=!0:/\n *\n *$/.test(le)&&(ve=!0)),this.options.gfm&&(ue=/^\[[ xX]\] /.exec(Pe),ue&&(N=ue[0]!=="[ ] ",Pe=Pe.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:le,task:!!ue,checked:N,loose:!1,text:Pe}),Ye.raw+=le}Ye.items[Ye.items.length-1].raw=le.trimRight(),Ye.items[Ye.items.length-1].text=Pe.trimRight(),Ye.raw=Ye.raw.trimRight();var W=Ye.items.length;for(J=0;J<W;J++){this.lexer.state.top=!1,Ye.items[J].tokens=this.lexer.blockTokens(Ye.items[J].text,[]);var X=Ye.items[J].tokens.filter(function(Re){return Re.type==="space"}),ge=X.every(function(Re){for(var Me=Re.raw.split(""),Ge=0,je=L(Me),tt;!(tt=je()).done;){var pt=tt.value;if(pt===`
`&&(Ge+=1),Ge>1)return!0}return!1});!Ye.loose&&X.length&&ge&&(Ye.loose=!0,Ye.items[J].loose=!0)}return Ye}},ne.html=function(ee){var ce=this.rules.block.html.exec(ee);if(ce){var le={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var ue=this.options.sanitizer?this.options.sanitizer(ce[0]):I(ce[0]);le.type="paragraph",le.text=ue,le.tokens=this.lexer.inline(ue)}return le}},ne.def=function(ee){var ce=this.rules.block.def.exec(ee);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var le=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:le,raw:ce[0],href:ce[2],title:ce[3]}}},ne.table=function(ee){var ce=this.rules.block.table.exec(ee);if(ce){var le={type:"table",header:u(ce[1]).map(function(ve){return{text:ve}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(le.header.length===le.align.length){le.raw=ce[0];var ue=le.align.length,N,q,J,te;for(N=0;N<ue;N++)/^ *-+: *$/.test(le.align[N])?le.align[N]="right":/^ *:-+: *$/.test(le.align[N])?le.align[N]="center":/^ *:-+ *$/.test(le.align[N])?le.align[N]="left":le.align[N]=null;for(ue=le.rows.length,N=0;N<ue;N++)le.rows[N]=u(le.rows[N],le.header.length).map(function(ve){return{text:ve}});for(ue=le.header.length,q=0;q<ue;q++)le.header[q].tokens=this.lexer.inline(le.header[q].text);for(ue=le.rows.length,q=0;q<ue;q++)for(te=le.rows[q],J=0;J<te.length;J++)te[J].tokens=this.lexer.inline(te[J].text);return le}}},ne.lheading=function(ee){var ce=this.rules.block.lheading.exec(ee);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},ne.paragraph=function(ee){var ce=this.rules.block.paragraph.exec(ee);if(ce){var le=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:le,tokens:this.lexer.inline(le)}}},ne.text=function(ee){var ce=this.rules.block.text.exec(ee);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},ne.escape=function(ee){var ce=this.rules.inline.escape.exec(ee);if(ce)return{type:"escape",raw:ce[0],text:I(ce[1])}},ne.tag=function(ee){var ce=this.rules.inline.tag.exec(ee);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):I(ce[0]):ce[0]}},ne.link=function(ee){var ce=this.rules.inline.link.exec(ee);if(ce){var le=ce[2].trim();if(!this.options.pedantic&&/^</.test(le)){if(!/>$/.test(le))return;var ue=m(le.slice(0,-1),"\\");if((le.length-ue.length)%2===0)return}else{var N=f(ce[2],"()");if(N>-1){var q=ce[0].indexOf("!")===0?5:4,J=q+ce[1].length+N;ce[2]=ce[2].substring(0,N),ce[0]=ce[0].substring(0,J).trim(),ce[3]=""}}var te=ce[2],ve="";if(this.options.pedantic){var De=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(te);De&&(te=De[1],ve=De[3])}else ve=ce[3]?ce[3].slice(1,-1):"";return te=te.trim(),/^</.test(te)&&(this.options.pedantic&&!/>$/.test(le)?te=te.slice(1):te=te.slice(1,-1)),M(ce,{href:te&&te.replace(this.rules.inline._escapes,"$1"),title:ve&&ve.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},ne.reflink=function(ee,ce){var le;if((le=this.rules.inline.reflink.exec(ee))||(le=this.rules.inline.nolink.exec(ee))){var ue=(le[2]||le[1]).replace(/\s+/g," ");if(ue=ce[ue.toLowerCase()],!ue||!ue.href){var N=le[0].charAt(0);return{type:"text",raw:N,text:N}}return M(le,ue,le[0],this.lexer)}},ne.emStrong=function(ee,ce,le){le===void 0&&(le="");var ue=this.rules.inline.emStrong.lDelim.exec(ee);if(ue&&!(ue[3]&&le.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var N=ue[1]||ue[2]||"";if(!N||N&&(le===""||this.rules.inline.punctuation.exec(le))){var q=ue[0].length-1,J,te,ve=q,De=0,me=ue[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(me.lastIndex=0,ce=ce.slice(-1*ee.length+q);(ue=me.exec(ce))!=null;)if(J=ue[1]||ue[2]||ue[3]||ue[4]||ue[5]||ue[6],!!J){if(te=J.length,ue[3]||ue[4]){ve+=te;continue}else if((ue[5]||ue[6])&&q%3&&!((q+te)%3)){De+=te;continue}if(ve-=te,!(ve>0)){if(te=Math.min(te,te+ve+De),Math.min(q,te)%2){var Te=ee.slice(1,q+ue.index+te);return{type:"em",raw:ee.slice(0,q+ue.index+te+1),text:Te,tokens:this.lexer.inlineTokens(Te)}}var Pe=ee.slice(2,q+ue.index+te-1);return{type:"strong",raw:ee.slice(0,q+ue.index+te+1),text:Pe,tokens:this.lexer.inlineTokens(Pe)}}}}}},ne.codespan=function(ee){var ce=this.rules.inline.code.exec(ee);if(ce){var le=ce[2].replace(/\n/g," "),ue=/[^ ]/.test(le),N=/^ /.test(le)&&/ $/.test(le);return ue&&N&&(le=le.substring(1,le.length-1)),le=I(le,!0),{type:"codespan",raw:ce[0],text:le}}},ne.br=function(ee){var ce=this.rules.inline.br.exec(ee);if(ce)return{type:"br",raw:ce[0]}},ne.del=function(ee){var ce=this.rules.inline.del.exec(ee);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},ne.autolink=function(ee,ce){var le=this.rules.inline.autolink.exec(ee);if(le){var ue,N;return le[2]==="@"?(ue=I(this.options.mangle?ce(le[1]):le[1]),N="mailto:"+ue):(ue=I(le[1]),N=ue),{type:"link",raw:le[0],text:ue,href:N,tokens:[{type:"text",raw:ue,text:ue}]}}},ne.url=function(ee,ce){var le;if(le=this.rules.inline.url.exec(ee)){var ue,N;if(le[2]==="@")ue=I(this.options.mangle?ce(le[0]):le[0]),N="mailto:"+ue;else{var q;do q=le[0],le[0]=this.rules.inline._backpedal.exec(le[0])[0];while(q!==le[0]);ue=I(le[0]),le[1]==="www."?N="http://"+ue:N=ue}return{type:"link",raw:le[0],text:ue,href:N,tokens:[{type:"text",raw:ue,text:ue}]}}},ne.inlineText=function(ee,ce){var le=this.rules.inline.text.exec(ee);if(le){var ue;return this.lexer.state.inRawBlock?ue=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):I(le[0]):le[0]:ue=I(this.options.smartypants?ce(le[0]):le[0]),{type:"text",raw:le[0],text:ue}}},re}(),U={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:S,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};U._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,U._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,U.def=h(U.def).replace("label",U._label).replace("title",U._title).getRegex(),U.bullet=/(?:[*+-]|\d{1,9}[.)])/,U.listItemStart=h(/^( *)(bull) */).replace("bull",U.bullet).getRegex(),U.list=h(U.list).replace(/bull/g,U.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+U.def.source+")").getRegex(),U._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",U._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,U.html=h(U.html,"i").replace("comment",U._comment).replace("tag",U._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),U.paragraph=h(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.blockquote=h(U.blockquote).replace("paragraph",U.paragraph).getRegex(),U.normal=c({},U),U.gfm=c({},U.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),U.gfm.table=h(U.gfm.table).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.gfm.paragraph=h(U._paragraph).replace("hr",U.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",U.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",U._tag).getRegex(),U.pedantic=c({},U.normal,{html:h(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",U._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:S,paragraph:h(U.normal._paragraph).replace("hr",U.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",U.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var z={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:S,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:S,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};z._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",z.punctuation=h(z.punctuation).replace(/punctuation/g,z._punctuation).getRegex(),z.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,z.escapedEmSt=/\\\*|\\_/g,z._comment=h(U._comment).replace("(?:-->|$)","-->").getRegex(),z.emStrong.lDelim=h(z.emStrong.lDelim).replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimAst=h(z.emStrong.rDelimAst,"g").replace(/punct/g,z._punctuation).getRegex(),z.emStrong.rDelimUnd=h(z.emStrong.rDelimUnd,"g").replace(/punct/g,z._punctuation).getRegex(),z._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,z._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,z._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,z.autolink=h(z.autolink).replace("scheme",z._scheme).replace("email",z._email).getRegex(),z._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,z.tag=h(z.tag).replace("comment",z._comment).replace("attribute",z._attribute).getRegex(),z._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,z._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,z._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,z.link=h(z.link).replace("label",z._label).replace("href",z._href).replace("title",z._title).getRegex(),z.reflink=h(z.reflink).replace("label",z._label).replace("ref",U._label).getRegex(),z.nolink=h(z.nolink).replace("ref",U._label).getRegex(),z.reflinkSearch=h(z.reflinkSearch,"g").replace("reflink",z.reflink).replace("nolink",z.nolink).getRegex(),z.normal=c({},z),z.pedantic=c({},z.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",z._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",z._label).getRegex()}),z.gfm=c({},z.normal,{escape:h(z.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),z.gfm.url=h(z.gfm.url,"i").replace("email",z.gfm._extended_email).getRegex(),z.breaks=c({},z.gfm,{br:h(z.br).replace("{2,}","*").getRegex(),text:h(z.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function G(re){return re.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(re){var ne="",de,ee,ce=re.length;for(de=0;de<ce;de++)ee=re.charCodeAt(de),Math.random()>.5&&(ee="x"+ee.toString(16)),ne+="&#"+ee+";";return ne}var $=function(){function re(de){this.tokens=[],this.tokens.links=Object.create(null),this.options=de||ae.defaults,this.options.tokenizer=this.options.tokenizer||new V,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ee={block:U.normal,inline:z.normal};this.options.pedantic?(ee.block=U.pedantic,ee.inline=z.pedantic):this.options.gfm&&(ee.block=U.gfm,this.options.breaks?ee.inline=z.breaks:ee.inline=z.gfm),this.tokenizer.rules=ee}re.lex=function(ee,ce){var le=new re(ce);return le.lex(ee)},re.lexInline=function(ee,ce){var le=new re(ce);return le.inlineTokens(ee)};var ne=re.prototype;return ne.lex=function(ee){ee=ee.replace(/\r\n|\r/g,`
`),this.blockTokens(ee,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},ne.blockTokens=function(ee,ce){var le=this;ce===void 0&&(ce=[]),this.options.pedantic?ee=ee.replace(/\t/g,"    ").replace(/^ +$/gm,""):ee=ee.replace(/^( *)(\t+)/gm,function(ve,De,me){return De+"    ".repeat(me.length)});for(var ue,N,q,J;ee;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ve){return(ue=ve.call({lexer:le},ee,ce))?(ee=ee.substring(ue.raw.length),ce.push(ue),!0):!1}))){if(ue=this.tokenizer.space(ee)){ee=ee.substring(ue.raw.length),ue.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(ue);continue}if(ue=this.tokenizer.code(ee)){ee=ee.substring(ue.raw.length),N=ce[ce.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+ue.raw,N.text+=`
`+ue.text,this.inlineQueue[this.inlineQueue.length-1].src=N.text):ce.push(ue);continue}if(ue=this.tokenizer.fences(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.heading(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.hr(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.blockquote(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.list(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.html(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.def(ee)){ee=ee.substring(ue.raw.length),N=ce[ce.length-1],N&&(N.type==="paragraph"||N.type==="text")?(N.raw+=`
`+ue.raw,N.text+=`
`+ue.raw,this.inlineQueue[this.inlineQueue.length-1].src=N.text):this.tokens.links[ue.tag]||(this.tokens.links[ue.tag]={href:ue.href,title:ue.title});continue}if(ue=this.tokenizer.table(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.lheading(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(q=ee,this.options.extensions&&this.options.extensions.startBlock&&function(){var ve=1/0,De=ee.slice(1),me=void 0;le.options.extensions.startBlock.forEach(function(Te){me=Te.call({lexer:this},De),typeof me=="number"&&me>=0&&(ve=Math.min(ve,me))}),ve<1/0&&ve>=0&&(q=ee.substring(0,ve+1))}(),this.state.top&&(ue=this.tokenizer.paragraph(q))){N=ce[ce.length-1],J&&N.type==="paragraph"?(N.raw+=`
`+ue.raw,N.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):ce.push(ue),J=q.length!==ee.length,ee=ee.substring(ue.raw.length);continue}if(ue=this.tokenizer.text(ee)){ee=ee.substring(ue.raw.length),N=ce[ce.length-1],N&&N.type==="text"?(N.raw+=`
`+ue.raw,N.text+=`
`+ue.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=N.text):ce.push(ue);continue}if(ee){var te="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(te);break}else throw new Error(te)}}return this.state.top=!0,ce},ne.inline=function(ee,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:ee,tokens:ce}),ce},ne.inlineTokens=function(ee,ce){var le=this;ce===void 0&&(ce=[]);var ue,N,q,J=ee,te,ve,De;if(this.tokens.links){var me=Object.keys(this.tokens.links);if(me.length>0)for(;(te=this.tokenizer.rules.inline.reflinkSearch.exec(J))!=null;)me.includes(te[0].slice(te[0].lastIndexOf("[")+1,-1))&&(J=J.slice(0,te.index)+"["+C("a",te[0].length-2)+"]"+J.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(te=this.tokenizer.rules.inline.blockSkip.exec(J))!=null;)J=J.slice(0,te.index)+"["+C("a",te[0].length-2)+"]"+J.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(te=this.tokenizer.rules.inline.escapedEmSt.exec(J))!=null;)J=J.slice(0,te.index)+"++"+J.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ee;)if(ve||(De=""),ve=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(Pe){return(ue=Pe.call({lexer:le},ee,ce))?(ee=ee.substring(ue.raw.length),ce.push(ue),!0):!1}))){if(ue=this.tokenizer.escape(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.tag(ee)){ee=ee.substring(ue.raw.length),N=ce[ce.length-1],N&&ue.type==="text"&&N.type==="text"?(N.raw+=ue.raw,N.text+=ue.text):ce.push(ue);continue}if(ue=this.tokenizer.link(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.reflink(ee,this.tokens.links)){ee=ee.substring(ue.raw.length),N=ce[ce.length-1],N&&ue.type==="text"&&N.type==="text"?(N.raw+=ue.raw,N.text+=ue.text):ce.push(ue);continue}if(ue=this.tokenizer.emStrong(ee,J,De)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.codespan(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.br(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.del(ee)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(ue=this.tokenizer.autolink(ee,F)){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(!this.state.inLink&&(ue=this.tokenizer.url(ee,F))){ee=ee.substring(ue.raw.length),ce.push(ue);continue}if(q=ee,this.options.extensions&&this.options.extensions.startInline&&function(){var Pe=1/0,$e=ee.slice(1),Ve=void 0;le.options.extensions.startInline.forEach(function(et){Ve=et.call({lexer:this},$e),typeof Ve=="number"&&Ve>=0&&(Pe=Math.min(Pe,Ve))}),Pe<1/0&&Pe>=0&&(q=ee.substring(0,Pe+1))}(),ue=this.tokenizer.inlineText(q,G)){ee=ee.substring(ue.raw.length),ue.raw.slice(-1)!=="_"&&(De=ue.raw.slice(-1)),ve=!0,N=ce[ce.length-1],N&&N.type==="text"?(N.raw+=ue.raw,N.text+=ue.text):ce.push(ue);continue}if(ee){var Te="Infinite loop on byte: "+ee.charCodeAt(0);if(this.options.silent){console.error(Te);break}else throw new Error(Te)}}return ce},o(re,null,[{key:"rules",get:function(){return{block:U,inline:z}}}]),re}(),Y=function(){function re(de){this.options=de||ae.defaults}var ne=re.prototype;return ne.code=function(ee,ce,le){var ue=(ce||"").match(/\S*/)[0];if(this.options.highlight){var N=this.options.highlight(ee,ue);N!=null&&N!==ee&&(le=!0,ee=N)}return ee=ee.replace(/\n$/,"")+`
`,ue?'<pre><code class="'+this.options.langPrefix+I(ue,!0)+'">'+(le?ee:I(ee,!0))+`</code></pre>
`:"<pre><code>"+(le?ee:I(ee,!0))+`</code></pre>
`},ne.blockquote=function(ee){return`<blockquote>
`+ee+`</blockquote>
`},ne.html=function(ee){return ee},ne.heading=function(ee,ce,le,ue){if(this.options.headerIds){var N=this.options.headerPrefix+ue.slug(le);return"<h"+ce+' id="'+N+'">'+ee+"</h"+ce+`>
`}return"<h"+ce+">"+ee+"</h"+ce+`>
`},ne.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ne.list=function(ee,ce,le){var ue=ce?"ol":"ul",N=ce&&le!==1?' start="'+le+'"':"";return"<"+ue+N+`>
`+ee+"</"+ue+`>
`},ne.listitem=function(ee){return"<li>"+ee+`</li>
`},ne.checkbox=function(ee){return"<input "+(ee?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ne.paragraph=function(ee){return"<p>"+ee+`</p>
`},ne.table=function(ee,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+ee+`</thead>
`+ce+`</table>
`},ne.tablerow=function(ee){return`<tr>
`+ee+`</tr>
`},ne.tablecell=function(ee,ce){var le=ce.header?"th":"td",ue=ce.align?"<"+le+' align="'+ce.align+'">':"<"+le+">";return ue+ee+("</"+le+`>
`)},ne.strong=function(ee){return"<strong>"+ee+"</strong>"},ne.em=function(ee){return"<em>"+ee+"</em>"},ne.codespan=function(ee){return"<code>"+ee+"</code>"},ne.br=function(){return this.options.xhtml?"<br/>":"<br>"},ne.del=function(ee){return"<del>"+ee+"</del>"},ne.link=function(ee,ce,le){if(ee=g(this.options.sanitize,this.options.baseUrl,ee),ee===null)return le;var ue='<a href="'+I(ee)+'"';return ce&&(ue+=' title="'+ce+'"'),ue+=">"+le+"</a>",ue},ne.image=function(ee,ce,le){if(ee=g(this.options.sanitize,this.options.baseUrl,ee),ee===null)return le;var ue='<img src="'+ee+'" alt="'+le+'"';return ce&&(ue+=' title="'+ce+'"'),ue+=this.options.xhtml?"/>":">",ue},ne.text=function(ee){return ee},re}(),_=function(){function re(){}var ne=re.prototype;return ne.strong=function(ee){return ee},ne.em=function(ee){return ee},ne.codespan=function(ee){return ee},ne.del=function(ee){return ee},ne.html=function(ee){return ee},ne.text=function(ee){return ee},ne.link=function(ee,ce,le){return""+le},ne.image=function(ee,ce,le){return""+le},ne.br=function(){return""},re}(),Q=function(){function re(){this.seen={}}var ne=re.prototype;return ne.serialize=function(ee){return ee.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ne.getNextSafeSlug=function(ee,ce){var le=ee,ue=0;if(this.seen.hasOwnProperty(le)){ue=this.seen[ee];do ue++,le=ee+"-"+ue;while(this.seen.hasOwnProperty(le))}return ce||(this.seen[ee]=ue,this.seen[le]=0),le},ne.slug=function(ee,ce){ce===void 0&&(ce={});var le=this.serialize(ee);return this.getNextSafeSlug(le,ce.dryrun)},re}(),ie=function(){function re(de){this.options=de||ae.defaults,this.options.renderer=this.options.renderer||new Y,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new Q}re.parse=function(ee,ce){var le=new re(ce);return le.parse(ee)},re.parseInline=function(ee,ce){var le=new re(ce);return le.parseInline(ee)};var ne=re.prototype;return ne.parse=function(ee,ce){ce===void 0&&(ce=!0);var le="",ue,N,q,J,te,ve,De,me,Te,Pe,$e,Ve,et,Ye,Je,nt,ct,Fe,it,W=ee.length;for(ue=0;ue<W;ue++){if(Pe=ee[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Pe.type]&&(it=this.options.extensions.renderers[Pe.type].call({parser:this},Pe),it!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(Pe.type))){le+=it||"";continue}switch(Pe.type){case"space":continue;case"hr":{le+=this.renderer.hr();continue}case"heading":{le+=this.renderer.heading(this.parseInline(Pe.tokens),Pe.depth,i(this.parseInline(Pe.tokens,this.textRenderer)),this.slugger);continue}case"code":{le+=this.renderer.code(Pe.text,Pe.lang,Pe.escaped);continue}case"table":{for(me="",De="",J=Pe.header.length,N=0;N<J;N++)De+=this.renderer.tablecell(this.parseInline(Pe.header[N].tokens),{header:!0,align:Pe.align[N]});for(me+=this.renderer.tablerow(De),Te="",J=Pe.rows.length,N=0;N<J;N++){for(ve=Pe.rows[N],De="",te=ve.length,q=0;q<te;q++)De+=this.renderer.tablecell(this.parseInline(ve[q].tokens),{header:!1,align:Pe.align[q]});Te+=this.renderer.tablerow(De)}le+=this.renderer.table(me,Te);continue}case"blockquote":{Te=this.parse(Pe.tokens),le+=this.renderer.blockquote(Te);continue}case"list":{for($e=Pe.ordered,Ve=Pe.start,et=Pe.loose,J=Pe.items.length,Te="",N=0;N<J;N++)Je=Pe.items[N],nt=Je.checked,ct=Je.task,Ye="",Je.task&&(Fe=this.renderer.checkbox(nt),et?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=Fe+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=Fe+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:Fe}):Ye+=Fe),Ye+=this.parse(Je.tokens,et),Te+=this.renderer.listitem(Ye,ct,nt);le+=this.renderer.list(Te,$e,Ve);continue}case"html":{le+=this.renderer.html(Pe.text);continue}case"paragraph":{le+=this.renderer.paragraph(this.parseInline(Pe.tokens));continue}case"text":{for(Te=Pe.tokens?this.parseInline(Pe.tokens):Pe.text;ue+1<W&&ee[ue+1].type==="text";)Pe=ee[++ue],Te+=`
`+(Pe.tokens?this.parseInline(Pe.tokens):Pe.text);le+=ce?this.renderer.paragraph(Te):Te;continue}default:{var X='Token with "'+Pe.type+'" type was not found.';if(this.options.silent){console.error(X);return}else throw new Error(X)}}}return le},ne.parseInline=function(ee,ce){ce=ce||this.renderer;var le="",ue,N,q,J=ee.length;for(ue=0;ue<J;ue++){if(N=ee[ue],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[N.type]&&(q=this.options.extensions.renderers[N.type].call({parser:this},N),q!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(N.type))){le+=q||"";continue}switch(N.type){case"escape":{le+=ce.text(N.text);break}case"html":{le+=ce.html(N.text);break}case"link":{le+=ce.link(N.href,N.title,this.parseInline(N.tokens,ce));break}case"image":{le+=ce.image(N.href,N.title,N.text);break}case"strong":{le+=ce.strong(this.parseInline(N.tokens,ce));break}case"em":{le+=ce.em(this.parseInline(N.tokens,ce));break}case"codespan":{le+=ce.codespan(N.text);break}case"br":{le+=ce.br();break}case"del":{le+=ce.del(this.parseInline(N.tokens,ce));break}case"text":{le+=ce.text(N.text);break}default:{var te='Token with "'+N.type+'" type was not found.';if(this.options.silent){console.error(te);return}else throw new Error(te)}}}return le},re}();function oe(re,ne,de){if(typeof re>"u"||re===null)throw new Error("marked(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");if(typeof ne=="function"&&(de=ne,ne=null),ne=c({},oe.defaults,ne||{}),n(ne),de){var ee=ne.highlight,ce;try{ce=$.lex(re,ne)}catch(J){return de(J)}var le=function(te){var ve;if(!te)try{ne.walkTokens&&oe.walkTokens(ce,ne.walkTokens),ve=ie.parse(ce,ne)}catch(De){te=De}return ne.highlight=ee,te?de(te):de(null,ve)};if(!ee||ee.length<3||(delete ne.highlight,!ce.length))return le();var ue=0;oe.walkTokens(ce,function(J){J.type==="code"&&(ue++,setTimeout(function(){ee(J.text,J.lang,function(te,ve){if(te)return le(te);ve!=null&&ve!==J.text&&(J.text=ve,J.escaped=!0),ue--,ue===0&&le()})},0))}),ue===0&&le();return}function N(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+I(J.message+"",!0)+"</pre>";throw J}try{var q=$.lex(re,ne);if(ne.walkTokens){if(ne.async)return Promise.all(oe.walkTokens(q,ne.walkTokens)).then(function(){return ie.parse(q,ne)}).catch(N);oe.walkTokens(q,ne.walkTokens)}return ie.parse(q,ne)}catch(J){N(J)}}oe.options=oe.setOptions=function(re){return c(oe.defaults,re),P(oe.defaults),oe},oe.getDefaults=A,oe.defaults=ae.defaults,oe.use=function(){for(var re=arguments.length,ne=new Array(re),de=0;de<re;de++)ne[de]=arguments[de];var ee=c.apply(void 0,[{}].concat(ne)),ce=oe.defaults.extensions||{renderers:{},childTokens:{}},le;ne.forEach(function(ue){if(ue.extensions&&(le=!0,ue.extensions.forEach(function(q){if(!q.name)throw new Error("extension name required");if(q.renderer){var J=ce.renderers?ce.renderers[q.name]:null;J?ce.renderers[q.name]=function(){for(var te=arguments.length,ve=new Array(te),De=0;De<te;De++)ve[De]=arguments[De];var me=q.renderer.apply(this,ve);return me===!1&&(me=J.apply(this,ve)),me}:ce.renderers[q.name]=q.renderer}if(q.tokenizer){if(!q.level||q.level!=="block"&&q.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[q.level]?ce[q.level].unshift(q.tokenizer):ce[q.level]=[q.tokenizer],q.start&&(q.level==="block"?ce.startBlock?ce.startBlock.push(q.start):ce.startBlock=[q.start]:q.level==="inline"&&(ce.startInline?ce.startInline.push(q.start):ce.startInline=[q.start]))}q.childTokens&&(ce.childTokens[q.name]=q.childTokens)})),ue.renderer&&function(){var q=oe.defaults.renderer||new Y,J=function(De){var me=q[De];q[De]=function(){for(var Te=arguments.length,Pe=new Array(Te),$e=0;$e<Te;$e++)Pe[$e]=arguments[$e];var Ve=ue.renderer[De].apply(q,Pe);return Ve===!1&&(Ve=me.apply(q,Pe)),Ve}};for(var te in ue.renderer)J(te);ee.renderer=q}(),ue.tokenizer&&function(){var q=oe.defaults.tokenizer||new V,J=function(De){var me=q[De];q[De]=function(){for(var Te=arguments.length,Pe=new Array(Te),$e=0;$e<Te;$e++)Pe[$e]=arguments[$e];var Ve=ue.tokenizer[De].apply(q,Pe);return Ve===!1&&(Ve=me.apply(q,Pe)),Ve}};for(var te in ue.tokenizer)J(te);ee.tokenizer=q}(),ue.walkTokens){var N=oe.defaults.walkTokens;ee.walkTokens=function(q){var J=[];return J.push(ue.walkTokens.call(this,q)),N&&(J=J.concat(N.call(this,q))),J}}le&&(ee.extensions=ce),oe.setOptions(ee)})},oe.walkTokens=function(re,ne){for(var de=[],ee=function(){var N=le.value;switch(de=de.concat(ne.call(oe,N)),N.type){case"table":{for(var q=L(N.header),J;!(J=q()).done;){var te=J.value;de=de.concat(oe.walkTokens(te.tokens,ne))}for(var ve=L(N.rows),De;!(De=ve()).done;)for(var me=De.value,Te=L(me),Pe;!(Pe=Te()).done;){var $e=Pe.value;de=de.concat(oe.walkTokens($e.tokens,ne))}break}case"list":{de=de.concat(oe.walkTokens(N.items,ne));break}default:oe.defaults.extensions&&oe.defaults.extensions.childTokens&&oe.defaults.extensions.childTokens[N.type]?oe.defaults.extensions.childTokens[N.type].forEach(function(Ve){de=de.concat(oe.walkTokens(N[Ve],ne))}):N.tokens&&(de=de.concat(oe.walkTokens(N.tokens,ne)))}},ce=L(re),le;!(le=ce()).done;)ee();return de},oe.parseInline=function(re,ne){if(typeof re>"u"||re===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof re!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(re)+", string expected");ne=c({},oe.defaults,ne||{}),n(ne);try{var de=$.lexInline(re,ne);return ne.walkTokens&&oe.walkTokens(de,ne.walkTokens),ie.parseInline(de,ne)}catch(ee){if(ee.message+=`
Please report this to https://github.com/markedjs/marked.`,ne.silent)return"<p>An error occurred:</p><pre>"+I(ee.message+"",!0)+"</pre>";throw ee}},oe.Parser=ie,oe.parser=ie.parse,oe.Renderer=Y,oe.TextRenderer=_,oe.Lexer=$,oe.lexer=$.lex,oe.Tokenizer=V,oe.Slugger=Q,oe.parse=oe;var Ee=oe.options,he=oe.setOptions,fe=oe.use,x=oe.walkTokens,B=oe.parseInline,Z=oe,pe=ie.parse,Se=$.lex;ae.Lexer=$,ae.Parser=ie,ae.Renderer=Y,ae.Slugger=Q,ae.TextRenderer=_,ae.Tokenizer=V,ae.getDefaults=A,ae.lexer=Se,ae.marked=oe,ae.options=Ee,ae.parse=Z,ae.parseInline=B,ae.parser=pe,ae.setOptions=he,ae.use=fe,ae.walkTokens=x,Object.defineProperty(ae,"__esModule",{value:!0})}),define(Ce[88],ke([1,0,28]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const R=new o.LRUCache(1e4);function l(p){return D(p,"NFC",R)}e.normalizeNFC=l;const L=new o.LRUCache(1e4);function A(p){return D(p,"NFD",L)}e.normalizeNFD=A;const P=/[^\u0000-\u0080]/;function D(p,O,k){if(!p)return p;const E=k.get(p);if(E)return E;let T;return P.test(p)?T=p.normalize(O):T=p,k.set(p,T),T}e.removeAccents=function(){const p=/[\u0300-\u036f]/g;return function(O){return A(O).replace(p,"")}}()}),define(Ce[103],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function o(P,D,p){return Math.min(Math.max(P,D),p)}e.clamp=o;function R(P,D){return(D+P%D)%D}e.rot=R;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class L{constructor(){this.a=1,this.b=0}update(D){return this.b=this.b+(D-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=L;class A{constructor(D){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(D),this.c.fill(0,0,D)}update(D){const p=this.c[this.d];return this.c[this.d]=D,this.d=(this.d+1)%this.c.length,this.e-=p,this.e+=D,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=A}),function(){function ae(l){const L=[];typeof l=="number"&&L.push("code/timeOrigin",l);function A(D){L.push(D,Date.now())}function P(){const D=[];for(let p=0;p<L.length;p+=2)D.push({name:L[p],startTime:L[p+1]});return D}return{mark:A,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?ae():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(l+A.startTime)});return L}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return ae(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),ae()}function o(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var R;typeof global=="object"?R=global:typeof self=="object"?R=self:R={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(R)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(R):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),R.perf=o(R))}(),function(ae,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var o=e();for(var R in o)(typeof exports=="object"?exports:ae)[R]=o[R]}}(typeof self<"u"?self:this,function(){return function(ae){var e={};function o(R){if(e[R])return e[R].exports;var l=e[R]={i:R,l:!1,exports:{}};return ae[R].call(l.exports,l,l.exports,o),l.l=!0,l.exports}return o.m=ae,o.c=e,o.d=function(R,l,L){o.o(R,l)||Object.defineProperty(R,l,{enumerable:!0,get:L})},o.r=function(R){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(R,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(R,"__esModule",{value:!0})},o.t=function(R,l){if(1&l&&(R=o(R)),8&l||4&l&&typeof R=="object"&&R&&R.__esModule)return R;var L=Object.create(null);if(o.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:R}),2&l&&typeof R!="string")for(var A in R)o.d(L,A,function(P){return R[P]}.bind(null,A));return L},o.n=function(R){var l=R&&R.__esModule?function(){return R.default}:function(){return R};return o.d(l,"a",l),l},o.o=function(R,l){return Object.prototype.hasOwnProperty.call(R,l)},o.p="",o(o.s=0)}([function(ae,e,o){(function(R){var l;e=ae.exports=fe,l=typeof R=="object"&&R.env&&R.env.NODE_DEBUG&&/\bsemver\b/i.test(R.env.NODE_DEBUG)?function(){var me=Array.prototype.slice.call(arguments,0);me.unshift("SEMVER"),console.log.apply(console,me)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],D=e.src=[],p=0,O=p++;D[O]="0|[1-9]\\d*";var k=p++;D[k]="[0-9]+";var E=p++;D[E]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var T=p++;D[T]="("+D[O]+")\\.("+D[O]+")\\.("+D[O]+")";var I=p++;D[I]="("+D[k]+")\\.("+D[k]+")\\.("+D[k]+")";var v=p++;D[v]="(?:"+D[O]+"|"+D[E]+")";var i=p++;D[i]="(?:"+D[k]+"|"+D[E]+")";var d=p++;D[d]="(?:-("+D[v]+"(?:\\."+D[v]+")*))";var h=p++;D[h]="(?:-?("+D[i]+"(?:\\."+D[i]+")*))";var y=p++;D[y]="[0-9A-Za-z-]+";var w=p++;D[w]="(?:\\+("+D[y]+"(?:\\."+D[y]+")*))";var g=p++,t="v?"+D[T]+D[d]+"?"+D[w]+"?";D[g]="^"+t+"$";var s="[v=\\s]*"+D[I]+D[h]+"?"+D[w]+"?",r=p++;D[r]="^"+s+"$";var a=p++;D[a]="((?:<|>)?=?)";var b=p++;D[b]=D[k]+"|x|X|\\*";var S=p++;D[S]=D[O]+"|x|X|\\*";var c=p++;D[c]="[v=\\s]*("+D[S]+")(?:\\.("+D[S]+")(?:\\.("+D[S]+")(?:"+D[d]+")?"+D[w]+"?)?)?";var u=p++;D[u]="[v=\\s]*("+D[b]+")(?:\\.("+D[b]+")(?:\\.("+D[b]+")(?:"+D[h]+")?"+D[w]+"?)?)?";var m=p++;D[m]="^"+D[a]+"\\s*"+D[c]+"$";var f=p++;D[f]="^"+D[a]+"\\s*"+D[u]+"$";var n=p++;D[n]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var C=p++;D[C]="(?:~>?)";var M=p++;D[M]="(\\s*)"+D[C]+"\\s+",P[M]=new RegExp(D[M],"g");var H=p++;D[H]="^"+D[C]+D[c]+"$";var V=p++;D[V]="^"+D[C]+D[u]+"$";var U=p++;D[U]="(?:\\^)";var z=p++;D[z]="(\\s*)"+D[U]+"\\s+",P[z]=new RegExp(D[z],"g");var G=p++;D[G]="^"+D[U]+D[c]+"$";var F=p++;D[F]="^"+D[U]+D[u]+"$";var $=p++;D[$]="^"+D[a]+"\\s*("+s+")$|^$";var Y=p++;D[Y]="^"+D[a]+"\\s*("+t+")$|^$";var _=p++;D[_]="(\\s*)"+D[a]+"\\s*("+s+"|"+D[c]+")",P[_]=new RegExp(D[_],"g");var Q=p++;D[Q]="^\\s*("+D[c]+")\\s+-\\s+("+D[c]+")\\s*$";var ie=p++;D[ie]="^\\s*("+D[u]+")\\s+-\\s+("+D[u]+")\\s*$";var oe=p++;D[oe]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)l(Ee,D[Ee]),P[Ee]||(P[Ee]=new RegExp(D[Ee]));function he(me,Te){if(me instanceof fe)return me;if(typeof me!="string"||me.length>L||!(Te?P[r]:P[g]).test(me))return null;try{return new fe(me,Te)}catch{return null}}function fe(me,Te){if(me instanceof fe){if(me.loose===Te)return me;me=me.version}else if(typeof me!="string")throw new TypeError("Invalid Version: "+me);if(me.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof fe))return new fe(me,Te);l("SemVer",me,Te),this.loose=Te;var Pe=me.trim().match(Te?P[r]:P[g]);if(!Pe)throw new TypeError("Invalid Version: "+me);if(this.raw=me,this.major=+Pe[1],this.minor=+Pe[2],this.patch=+Pe[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");Pe[4]?this.prerelease=Pe[4].split(".").map(function($e){if(/^[0-9]+$/.test($e)){var Ve=+$e;if(Ve>=0&&Ve<A)return Ve}return $e}):this.prerelease=[],this.build=Pe[5]?Pe[5].split("."):[],this.format()}e.parse=he,e.valid=function(me,Te){var Pe=he(me,Te);return Pe?Pe.version:null},e.clean=function(me,Te){var Pe=he(me.trim().replace(/^[=v]+/,""),Te);return Pe?Pe.version:null},e.SemVer=fe,fe.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},fe.prototype.toString=function(){return this.version},fe.prototype.compare=function(me){return l("SemVer.compare",this.version,this.loose,me),me instanceof fe||(me=new fe(me,this.loose)),this.compareMain(me)||this.comparePre(me)},fe.prototype.compareMain=function(me){return me instanceof fe||(me=new fe(me,this.loose)),B(this.major,me.major)||B(this.minor,me.minor)||B(this.patch,me.patch)},fe.prototype.comparePre=function(me){if(me instanceof fe||(me=new fe(me,this.loose)),this.prerelease.length&&!me.prerelease.length)return-1;if(!this.prerelease.length&&me.prerelease.length)return 1;if(!this.prerelease.length&&!me.prerelease.length)return 0;var Te=0;do{var Pe=this.prerelease[Te],$e=me.prerelease[Te];if(l("prerelease compare",Te,Pe,$e),Pe===void 0&&$e===void 0)return 0;if($e===void 0)return 1;if(Pe===void 0)return-1;if(Pe!==$e)return B(Pe,$e)}while(++Te)},fe.prototype.inc=function(me,Te){switch(me){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Te);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Te);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Te),this.inc("pre",Te);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Te),this.inc("pre",Te);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var Pe=this.prerelease.length;--Pe>=0;)typeof this.prerelease[Pe]=="number"&&(this.prerelease[Pe]++,Pe=-2);Pe===-1&&this.prerelease.push(0)}Te&&(this.prerelease[0]===Te?isNaN(this.prerelease[1])&&(this.prerelease=[Te,0]):this.prerelease=[Te,0]);break;default:throw new Error("invalid increment argument: "+me)}return this.format(),this.raw=this.version,this},e.inc=function(me,Te,Pe,$e){typeof Pe=="string"&&($e=Pe,Pe=void 0);try{return new fe(me,Pe).inc(Te,$e).version}catch{return null}},e.diff=function(me,Te){if(re(me,Te))return null;var Pe=he(me),$e=he(Te);if(Pe.prerelease.length||$e.prerelease.length){for(var Ve in Pe)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Pe[Ve]!==$e[Ve])return"pre"+Ve;return"prerelease"}for(var Ve in Pe)if((Ve==="major"||Ve==="minor"||Ve==="patch")&&Pe[Ve]!==$e[Ve])return Ve},e.compareIdentifiers=B;var x=/^[0-9]+$/;function B(me,Te){var Pe=x.test(me),$e=x.test(Te);return Pe&&$e&&(me=+me,Te=+Te),Pe&&!$e?-1:$e&&!Pe?1:me<Te?-1:me>Te?1:0}function Z(me,Te,Pe){return new fe(me,Pe).compare(new fe(Te,Pe))}function pe(me,Te,Pe){return Z(me,Te,Pe)>0}function Se(me,Te,Pe){return Z(me,Te,Pe)<0}function re(me,Te,Pe){return Z(me,Te,Pe)===0}function ne(me,Te,Pe){return Z(me,Te,Pe)!==0}function de(me,Te,Pe){return Z(me,Te,Pe)>=0}function ee(me,Te,Pe){return Z(me,Te,Pe)<=0}function ce(me,Te,Pe,$e){var Ve;switch(Te){case"===":typeof me=="object"&&(me=me.version),typeof Pe=="object"&&(Pe=Pe.version),Ve=me===Pe;break;case"!==":typeof me=="object"&&(me=me.version),typeof Pe=="object"&&(Pe=Pe.version),Ve=me!==Pe;break;case"":case"=":case"==":Ve=re(me,Pe,$e);break;case"!=":Ve=ne(me,Pe,$e);break;case">":Ve=pe(me,Pe,$e);break;case">=":Ve=de(me,Pe,$e);break;case"<":Ve=Se(me,Pe,$e);break;case"<=":Ve=ee(me,Pe,$e);break;default:throw new TypeError("Invalid operator: "+Te)}return Ve}function le(me,Te){if(me instanceof le){if(me.loose===Te)return me;me=me.value}if(!(this instanceof le))return new le(me,Te);l("comparator",me,Te),this.loose=Te,this.parse(me),this.semver===ue?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(me,Te){return B(Te,me)},e.major=function(me,Te){return new fe(me,Te).major},e.minor=function(me,Te){return new fe(me,Te).minor},e.patch=function(me,Te){return new fe(me,Te).patch},e.compare=Z,e.compareLoose=function(me,Te){return Z(me,Te,!0)},e.rcompare=function(me,Te,Pe){return Z(Te,me,Pe)},e.sort=function(me,Te){return me.sort(function(Pe,$e){return e.compare(Pe,$e,Te)})},e.rsort=function(me,Te){return me.sort(function(Pe,$e){return e.rcompare(Pe,$e,Te)})},e.gt=pe,e.lt=Se,e.eq=re,e.neq=ne,e.gte=de,e.lte=ee,e.cmp=ce,e.Comparator=le;var ue={};function N(me,Te){if(me instanceof N)return me.loose===Te?me:new N(me.raw,Te);if(me instanceof le)return new N(me.value,Te);if(!(this instanceof N))return new N(me,Te);if(this.loose=Te,this.raw=me,this.set=me.split(/\s*\|\|\s*/).map(function(Pe){return this.parseRange(Pe.trim())},this).filter(function(Pe){return Pe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+me);this.format()}function q(me){return!me||me.toLowerCase()==="x"||me==="*"}function J(me,Te,Pe,$e,Ve,et,Ye,Je,nt,ct,Fe,it,W){return((Te=q(Pe)?"":q($e)?">="+Pe+".0.0":q(Ve)?">="+Pe+"."+$e+".0":">="+Te)+" "+(Je=q(nt)?"":q(ct)?"<"+(+nt+1)+".0.0":q(Fe)?"<"+nt+"."+(+ct+1)+".0":it?"<="+nt+"."+ct+"."+Fe+"-"+it:"<="+Je)).trim()}function te(me,Te){for(var Pe=0;Pe<me.length;Pe++)if(!me[Pe].test(Te))return!1;if(Te.prerelease.length){for(Pe=0;Pe<me.length;Pe++)if(l(me[Pe].semver),me[Pe].semver!==ue&&me[Pe].semver.prerelease.length>0){var $e=me[Pe].semver;if($e.major===Te.major&&$e.minor===Te.minor&&$e.patch===Te.patch)return!0}return!1}return!0}function ve(me,Te,Pe){try{Te=new N(Te,Pe)}catch{return!1}return Te.test(me)}function De(me,Te,Pe,$e){var Ve,et,Ye,Je,nt;switch(me=new fe(me,$e),Te=new N(Te,$e),Pe){case">":Ve=pe,et=ee,Ye=Se,Je=">",nt=">=";break;case"<":Ve=Se,et=de,Ye=pe,Je="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ve(me,Te,$e))return!1;for(var ct=0;ct<Te.set.length;++ct){var Fe=Te.set[ct],it=null,W=null;if(Fe.forEach(function(X){X.semver===ue&&(X=new le(">=0.0.0")),it=it||X,W=W||X,Ve(X.semver,it.semver,$e)?it=X:Ye(X.semver,W.semver,$e)&&(W=X)}),it.operator===Je||it.operator===nt||(!W.operator||W.operator===Je)&&et(me,W.semver)||W.operator===nt&&Ye(me,W.semver))return!1}return!0}le.prototype.parse=function(me){var Te=this.loose?P[$]:P[Y],Pe=me.match(Te);if(!Pe)throw new TypeError("Invalid comparator: "+me);this.operator=Pe[1],this.operator==="="&&(this.operator=""),Pe[2]?this.semver=new fe(Pe[2],this.loose):this.semver=ue},le.prototype.toString=function(){return this.value},le.prototype.test=function(me){return l("Comparator.test",me,this.loose),this.semver===ue||(typeof me=="string"&&(me=new fe(me,this.loose)),ce(me,this.operator,this.semver,this.loose))},le.prototype.intersects=function(me,Te){if(!(me instanceof le))throw new TypeError("a Comparator is required");var Pe;if(this.operator==="")return Pe=new N(me.value,Te),ve(this.value,Pe,Te);if(me.operator==="")return Pe=new N(this.value,Te),ve(me.semver,Pe,Te);var $e=!(this.operator!==">="&&this.operator!==">"||me.operator!==">="&&me.operator!==">"),Ve=!(this.operator!=="<="&&this.operator!=="<"||me.operator!=="<="&&me.operator!=="<"),et=this.semver.version===me.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||me.operator!==">="&&me.operator!=="<="),Je=ce(this.semver,"<",me.semver,Te)&&(this.operator===">="||this.operator===">")&&(me.operator==="<="||me.operator==="<"),nt=ce(this.semver,">",me.semver,Te)&&(this.operator==="<="||this.operator==="<")&&(me.operator===">="||me.operator===">");return $e||Ve||et&&Ye||Je||nt},e.Range=N,N.prototype.format=function(){return this.range=this.set.map(function(me){return me.join(" ").trim()}).join("||").trim(),this.range},N.prototype.toString=function(){return this.range},N.prototype.parseRange=function(me){var Te=this.loose;me=me.trim(),l("range",me,Te);var Pe=Te?P[ie]:P[Q];me=me.replace(Pe,J),l("hyphen replace",me),me=me.replace(P[_],"$1$2$3"),l("comparator trim",me,P[_]),me=(me=(me=me.replace(P[M],"$1~")).replace(P[z],"$1^")).split(/\s+/).join(" ");var $e=Te?P[$]:P[Y],Ve=me.split(" ").map(function(et){return function(Ye,Je){return l("comp",Ye),Ye=function(nt,ct){return nt.trim().split(/\s+/).map(function(Fe){return function(it,W){l("caret",it,W);var X=W?P[F]:P[G];return it.replace(X,function(ge,Re,Me,Ge,je){var tt;return l("caret",it,ge,Re,Me,Ge,je),q(Re)?tt="":q(Me)?tt=">="+Re+".0.0 <"+(+Re+1)+".0.0":q(Ge)?tt=Re==="0"?">="+Re+"."+Me+".0 <"+Re+"."+(+Me+1)+".0":">="+Re+"."+Me+".0 <"+(+Re+1)+".0.0":je?(l("replaceCaret pr",je),je.charAt(0)!=="-"&&(je="-"+je),tt=Re==="0"?Me==="0"?">="+Re+"."+Me+"."+Ge+je+" <"+Re+"."+Me+"."+(+Ge+1):">="+Re+"."+Me+"."+Ge+je+" <"+Re+"."+(+Me+1)+".0":">="+Re+"."+Me+"."+Ge+je+" <"+(+Re+1)+".0.0"):(l("no pr"),tt=Re==="0"?Me==="0"?">="+Re+"."+Me+"."+Ge+" <"+Re+"."+Me+"."+(+Ge+1):">="+Re+"."+Me+"."+Ge+" <"+Re+"."+(+Me+1)+".0":">="+Re+"."+Me+"."+Ge+" <"+(+Re+1)+".0.0"),l("caret return",tt),tt})}(Fe,ct)}).join(" ")}(Ye,Je),l("caret",Ye),Ye=function(nt,ct){return nt.trim().split(/\s+/).map(function(Fe){return function(it,W){var X=W?P[V]:P[H];return it.replace(X,function(ge,Re,Me,Ge,je){var tt;return l("tilde",it,ge,Re,Me,Ge,je),q(Re)?tt="":q(Me)?tt=">="+Re+".0.0 <"+(+Re+1)+".0.0":q(Ge)?tt=">="+Re+"."+Me+".0 <"+Re+"."+(+Me+1)+".0":je?(l("replaceTilde pr",je),je.charAt(0)!=="-"&&(je="-"+je),tt=">="+Re+"."+Me+"."+Ge+je+" <"+Re+"."+(+Me+1)+".0"):tt=">="+Re+"."+Me+"."+Ge+" <"+Re+"."+(+Me+1)+".0",l("tilde return",tt),tt})}(Fe,ct)}).join(" ")}(Ye,Je),l("tildes",Ye),Ye=function(nt,ct){return l("replaceXRanges",nt,ct),nt.split(/\s+/).map(function(Fe){return function(it,W){it=it.trim();var X=W?P[f]:P[m];return it.replace(X,function(ge,Re,Me,Ge,je,tt){l("xRange",it,ge,Re,Me,Ge,je,tt);var pt=q(Me),at=pt||q(Ge),bt=at||q(je);return Re==="="&&bt&&(Re=""),pt?ge=Re===">"||Re==="<"?"<0.0.0":"*":Re&&bt?(at&&(Ge=0),bt&&(je=0),Re===">"?(Re=">=",at?(Me=+Me+1,Ge=0,je=0):bt&&(Ge=+Ge+1,je=0)):Re==="<="&&(Re="<",at?Me=+Me+1:Ge=+Ge+1),ge=Re+Me+"."+Ge+"."+je):at?ge=">="+Me+".0.0 <"+(+Me+1)+".0.0":bt&&(ge=">="+Me+"."+Ge+".0 <"+Me+"."+(+Ge+1)+".0"),l("xRange return",ge),ge})}(Fe,ct)}).join(" ")}(Ye,Je),l("xrange",Ye),Ye=function(nt,ct){return l("replaceStars",nt,ct),nt.trim().replace(P[oe],"")}(Ye,Je),l("stars",Ye),Ye}(et,Te)}).join(" ").split(/\s+/);return this.loose&&(Ve=Ve.filter(function(et){return!!et.match($e)})),Ve=Ve.map(function(et){return new le(et,Te)})},N.prototype.intersects=function(me,Te){if(!(me instanceof N))throw new TypeError("a Range is required");return this.set.some(function(Pe){return Pe.every(function($e){return me.set.some(function(Ve){return Ve.every(function(et){return $e.intersects(et,Te)})})})})},e.toComparators=function(me,Te){return new N(me,Te).set.map(function(Pe){return Pe.map(function($e){return $e.value}).join(" ").trim().split(" ")})},N.prototype.test=function(me){if(!me)return!1;typeof me=="string"&&(me=new fe(me,this.loose));for(var Te=0;Te<this.set.length;Te++)if(te(this.set[Te],me))return!0;return!1},e.satisfies=ve,e.maxSatisfying=function(me,Te,Pe){var $e=null,Ve=null;try{var et=new N(Te,Pe)}catch{return null}return me.forEach(function(Ye){et.test(Ye)&&($e&&Ve.compare(Ye)!==-1||(Ve=new fe($e=Ye,Pe)))}),$e},e.minSatisfying=function(me,Te,Pe){var $e=null,Ve=null;try{var et=new N(Te,Pe)}catch{return null}return me.forEach(function(Ye){et.test(Ye)&&($e&&Ve.compare(Ye)!==1||(Ve=new fe($e=Ye,Pe)))}),$e},e.validRange=function(me,Te){try{return new N(me,Te).range||"*"}catch{return null}},e.ltr=function(me,Te,Pe){return De(me,Te,"<",Pe)},e.gtr=function(me,Te,Pe){return De(me,Te,">",Pe)},e.outside=De,e.prerelease=function(me,Te){var Pe=he(me,Te);return Pe&&Pe.prerelease.length?Pe.prerelease:null},e.intersects=function(me,Te,Pe){return me=new N(me,Pe),Te=new N(Te,Pe),me.intersects(Te)},e.coerce=function(me){if(me instanceof fe)return me;if(typeof me!="string")return null;var Te=me.match(P[n]);return Te==null?null:he((Te[1]||"0")+"."+(Te[2]||"0")+"."+(Te[3]||"0"))}}).call(this,o(1))},function(ae,e){var o,R,l=ae.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function P(i){if(o===setTimeout)return setTimeout(i,0);if((o===L||!o)&&setTimeout)return o=setTimeout,setTimeout(i,0);try{return o(i,0)}catch{try{return o.call(null,i,0)}catch{return o.call(this,i,0)}}}(function(){try{o=typeof setTimeout=="function"?setTimeout:L}catch{o=L}try{R=typeof clearTimeout=="function"?clearTimeout:A}catch{R=A}})();var D,p=[],O=!1,k=-1;function E(){O&&D&&(O=!1,D.length?p=D.concat(p):k=-1,p.length&&T())}function T(){if(!O){var i=P(E);O=!0;for(var d=p.length;d;){for(D=p,p=[];++k<d;)D&&D[k].run();k=-1,d=p.length}D=null,O=!1,function(h){if(R===clearTimeout)return clearTimeout(h);if((R===A||!R)&&clearTimeout)return R=clearTimeout,clearTimeout(h);try{R(h)}catch{try{return R.call(null,h)}catch{return R.call(this,h)}}}(i)}}function I(i,d){this.fun=i,this.array=d}function v(){}l.nextTick=function(i){var d=new Array(arguments.length-1);if(arguments.length>1)for(var h=1;h<arguments.length;h++)d[h-1]=arguments[h];p.push(new I(i,d)),p.length!==1||O||P(T)},I.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=v,l.addListener=v,l.once=v,l.off=v,l.removeListener=v,l.removeAllListeners=v,l.emit=v,l.prependListener=v,l.prependOnceListener=v,l.listeners=function(i){return[]},l.binding=function(i){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(i){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(Ce[104],ke([1,0,8,6]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(w){const g=w;return g?typeof g.read=="function":!1}e.isReadable=l;function L(w){const g=w;return g?[g.on,g.pause,g.resume,g.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=L;function A(w){const g=w;return g?L(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=A;function P(w,g){return new D(w,g)}e.newWriteableStream=P;class D{constructor(g,t){this.e=g,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(t=>t(g))}h(g){this.c.error.length===0?(0,o.onUnexpectedError)(g):this.c.error.slice(0).forEach(t=>t(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,t){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(g,t){if(this.a.destroyed)return;let s;switch(g){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const r=s.indexOf(t);r>=0&&s.splice(r,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function p(w,g){const t=[];let s;for(;(s=w.read())!==null;)t.push(s);return g(t)}e.consumeReadable=p;function O(w,g,t){const s=[];let r;for(;(r=w.read())!==null&&s.length<t;)s.push(r);return r===null&&s.length>0?g(s):{read:()=>{if(s.length>0)return s.shift();if(typeof r<"u"){const a=r;return r=void 0,a}return w.read()}}}e.peekReadable=O;function k(w,g){return new Promise((t,s)=>{const r=[];E(w,{onData:a=>{g&&r.push(a)},onError:a=>{g?s(a):t(void 0)},onEnd:()=>{t(g?g(r):void 0)}})})}e.consumeStream=k;function E(w,g){let t=!1;return w.on("error",s=>{t||g.onError(s)}),w.on("end",()=>{t||g.onEnd()}),w.on("data",s=>{t||g.onData(s)}),(0,R.toDisposable)(()=>t=!0)}e.listenStream=E;function T(w,g){return new Promise((t,s)=>{const r=new R.DisposableStore,a=[],b=u=>{if(a.push(u),a.length>g)return r.dispose(),w.pause(),t({stream:w,buffer:a,ended:!1})},S=u=>s(u),c=()=>t({stream:w,buffer:a,ended:!0});r.add((0,R.toDisposable)(()=>w.removeListener("error",S))),w.on("error",S),r.add((0,R.toDisposable)(()=>w.removeListener("end",c))),w.on("end",c),r.add((0,R.toDisposable)(()=>w.removeListener("data",b))),w.on("data",b)})}e.peekStream=T;function I(w,g){const t=P(g);return t.end(w),t}e.toStream=I;function v(){const w=P(()=>{throw new Error("not supported")});return w.end(),w}e.emptyStream=v;function i(w){let g=!1;return{read:()=>g?null:(g=!0,w)}}e.toReadable=i;function d(w,g,t){const s=P(t);return E(w,{onData:r=>s.write(g.data(r)),onError:r=>s.error(g.error?g.error(r):r),onEnd:()=>s.end()}),s}e.transform=d;function h(w,g,t){let s=!1;return{read:()=>{const r=g.read();return s?r:(s=!0,r!==null?t([w,r]):w)}}}e.prefixedReadable=h;function y(w,g,t){let s=!1;const r=P(t);return E(g,{onData:a=>s?r.write(a):(s=!0,r.write(t([w,a]))),onError:a=>r.error(a),onEnd:()=>{s||(s=!0,r.write(w)),r.end()}}),r}e.prefixedStream=y}),define(Ce[22],ke([1,0,104]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const R=typeof Buffer<"u";let l,L;class A{static alloc(u){return R?new A(Buffer.allocUnsafe(u)):new A(new Uint8Array(u))}static wrap(u){return R&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new A(u)}static fromString(u,m){return!(m?.dontUseNodeBuffer||!1)&&R?new A(Buffer.from(u)):(l||(l=new TextEncoder),new A(l.encode(u)))}static fromByteArray(u){const m=A.alloc(u.length);for(let f=0,n=u.length;f<n;f++)m.buffer[f]=u[f];return m}static concat(u,m){if(typeof m>"u"){m=0;for(let C=0,M=u.length;C<M;C++)m+=u[C].byteLength}const f=A.alloc(m);let n=0;for(let C=0,M=u.length;C<M;C++){const H=u[C];f.set(H,n),n+=H.byteLength}return f}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=A.alloc(this.byteLength);return u.set(this),u}toString(){return R?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(u,m){return new A(this.buffer.subarray(u,m))}set(u,m){if(u instanceof A)this.buffer.set(u.buffer,m);else if(u instanceof Uint8Array)this.buffer.set(u,m);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),m);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return p(this.buffer,u)}writeUInt32BE(u,m){O(this.buffer,u,m)}readUInt32LE(u){return k(this.buffer,u)}writeUInt32LE(u,m){E(this.buffer,u,m)}readUInt8(u){return T(this.buffer,u)}writeUInt8(u,m){I(this.buffer,u,m)}}e.VSBuffer=A;function P(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0}e.readUInt16LE=P;function D(c,u,m){c[m+0]=u&255,u=u>>>8,c[m+1]=u&255}e.writeUInt16LE=D;function p(c,u){return c[u]*2**24+c[u+1]*2**16+c[u+2]*2**8+c[u+3]}e.readUInt32BE=p;function O(c,u,m){c[m+3]=u,u=u>>>8,c[m+2]=u,u=u>>>8,c[m+1]=u,u=u>>>8,c[m]=u}e.writeUInt32BE=O;function k(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0|c[u+2]<<16>>>0|c[u+3]<<24>>>0}e.readUInt32LE=k;function E(c,u,m){c[m+0]=u&255,u=u>>>8,c[m+1]=u&255,u=u>>>8,c[m+2]=u&255,u=u>>>8,c[m+3]=u&255}e.writeUInt32LE=E;function T(c,u){return c[u]}e.readUInt8=T;function I(c,u,m){c[m]=u}e.writeUInt8=I;function v(c){return o.consumeReadable(c,u=>A.concat(u))}e.readableToBuffer=v;function i(c){return o.toReadable(c)}e.bufferToReadable=i;function d(c){return o.consumeStream(c,u=>A.concat(u))}e.streamToBuffer=d;async function h(c){return c.ended?A.concat(c.buffer):A.concat([...c.buffer,await d(c.stream)])}e.bufferedStreamToBuffer=h;function y(c){return o.toStream(c,u=>A.concat(u))}e.bufferToStream=y;function w(c){return o.transform(c,{data:u=>typeof u=="string"?A.fromString(u):A.wrap(u)},u=>A.concat(u))}e.streamToBufferReadableStream=w;function g(c){return o.newWriteableStream(u=>A.concat(u),c)}e.newWriteableBufferStream=g;function t(c,u){return o.prefixedReadable(c,u,m=>A.concat(m))}e.prefixedBufferReadable=t;function s(c,u){return o.prefixedStream(c,u,m=>A.concat(m))}e.prefixedBufferStream=s;function r(c){let u=0,m=0,f=0;const n=new Uint8Array(Math.floor(c.length/4*3)),C=H=>{switch(m){case 3:n[f++]=u|H,m=0;break;case 2:n[f++]=u|H>>>2,u=H<<6,m=3;break;case 1:n[f++]=u|H>>>4,u=H<<4,m=2;break;default:u=H<<2,m=1}};for(let H=0;H<c.length;H++){const V=c.charCodeAt(H);if(V>=65&&V<=90)C(V-65);else if(V>=97&&V<=122)C(V-97+26);else if(V>=48&&V<=57)C(V-48+52);else if(V===43||V===45)C(62);else if(V===47||V===95)C(63);else{if(V===61)break;throw new SyntaxError(`Unexpected base64 character ${c[H]}`)}}const M=f;for(;m>0;)C(0);return A.wrap(n).slice(0,M)}e.decodeBase64=r;const a="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",b="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:c},u=!0,m=!1){const f=m?b:a;let n="";const C=c.byteLength%3;let M=0;for(;M<c.byteLength-C;M+=3){const H=c[M+0],V=c[M+1],U=c[M+2];n+=f[H>>>2],n+=f[(H<<4|V>>>4)&63],n+=f[(V<<2|U>>>6)&63],n+=f[U&63]}if(C===1){const H=c[M+0];n+=f[H>>>2],n+=f[H<<4&63],u&&(n+="==")}else if(C===2){const H=c[M+0],V=c[M+1];n+=f[H>>>2],n+=f[(H<<4|V>>>4)&63],n+=f[V<<2&63],u&&(n+="=")}return n}e.encodeBase64=S}),define(Ce[150],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Ce[10],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function o(s){return typeof s=="string"}e.isString=o;function R(s){return Array.isArray(s)&&s.every(r=>o(r))}e.isStringArray=R;function l(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=l;function L(s){const r=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof r}e.isTypedArray=L;function A(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=A;function P(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=P;function D(s){return s===!0||s===!1}e.isBoolean=D;function p(s){return typeof s>"u"}e.isUndefined=p;function O(s){return!k(s)}e.isDefined=O;function k(s){return p(s)||s===null}e.isUndefinedOrNull=k;function E(s,r){if(!s)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=E;function T(s){if(k(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=T;function I(...s){const r=[];for(let a=0;a<s.length;a++){const b=s[a];if(k(b))throw new Error(`Assertion Failed: argument at index ${a} is undefined or null`);r.push(b)}return r}e.assertAllDefined=I;const v=Object.prototype.hasOwnProperty;function i(s){if(!l(s))return!1;for(const r in s)if(v.call(s,r))return!1;return!0}e.isEmptyObject=i;function d(s){return typeof s=="function"}e.isFunction=d;function h(...s){return s.length>0&&s.every(d)}e.areFunctions=h;function y(s,r){const a=Math.min(s.length,r.length);for(let b=0;b<a;b++)w(s[b],r[b])}e.validateConstraints=y;function w(s,r){if(o(r)){if(typeof s!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(d(r)){try{if(s instanceof r)return}catch{}if(!k(s)&&s.constructor===r||r.length===1&&r.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=w;function g(s){return s===null?void 0:s}e.withNullAsUndefined=g;function t(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=t}),define(Ce[67],ke([1,0,10]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const R=Object.create(null);function l(P,D){if((0,o.isString)(D)){const p=R[D];if(p===void 0)throw new Error(`${P} references an unknown codicon: ${D}`);D=p}return R[P]=D,{id:P}}function L(){return R}e.getCodiconFontCharacters=L;function A(){return Object.values(e.Codicon)}e.getAllCodicons=A,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),send:l("send",60431),sparkle:l("sparkle",60432),insert:l("insert",60433),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(Ce[23],ke([1,0,10]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function R(d){if(!d||typeof d!="object"||d instanceof RegExp)return d;const h=Array.isArray(d)?[]:{};return Object.entries(d).forEach(([y,w])=>{h[y]=w&&typeof w=="object"?R(w):w}),h}e.deepClone=R;function l(d){if(!d||typeof d!="object")return d;const h=[d];for(;h.length>0;){const y=h.shift();Object.freeze(y);for(const w in y)if(L.call(y,w)){const g=y[w];typeof g=="object"&&!Object.isFrozen(g)&&!(0,o.isTypedArray)(g)&&h.push(g)}}return d}e.deepFreeze=l;const L=Object.prototype.hasOwnProperty;function A(d,h){return P(d,h,new Set)}e.cloneAndChange=A;function P(d,h,y){if((0,o.isUndefinedOrNull)(d))return d;const w=h(d);if(typeof w<"u")return w;if(Array.isArray(d)){const g=[];for(const t of d)g.push(P(t,h,y));return g}if((0,o.isObject)(d)){if(y.has(d))throw new Error("Cannot clone recursive data-structure");y.add(d);const g={};for(const t in d)L.call(d,t)&&(g[t]=P(d[t],h,y));return y.delete(d),g}return d}function D(d,h,y=!0){return(0,o.isObject)(d)?((0,o.isObject)(h)&&Object.keys(h).forEach(w=>{w in d?y&&((0,o.isObject)(d[w])&&(0,o.isObject)(h[w])?D(d[w],h[w],y):d[w]=h[w]):d[w]=h[w]}),d):h}e.mixin=D;function p(d,h){if(d===h)return!0;if(d==null||h===null||h===void 0||typeof d!=typeof h||typeof d!="object"||Array.isArray(d)!==Array.isArray(h))return!1;let y,w;if(Array.isArray(d)){if(d.length!==h.length)return!1;for(y=0;y<d.length;y++)if(!p(d[y],h[y]))return!1}else{const g=[];for(w in d)g.push(w);g.sort();const t=[];for(w in h)t.push(w);if(t.sort(),!p(g,t))return!1;for(y=0;y<g.length;y++)if(!p(d[g[y]],h[g[y]]))return!1}return!0}e.equals=p;function O(d){const h=new Set;return JSON.stringify(d,(y,w)=>{if((0,o.isObject)(w)||Array.isArray(w)){if(h.has(w))return"[Circular]";h.add(w)}return w})}e.safeStringify=O;function k(d,h){const y=Object.create(null);return!d||!h||Object.keys(h).forEach(g=>{const t=d[g],s=h[g];p(t,s)||(y[g]=s)}),y}e.distinct=k;function E(d,h){const y=h.toLowerCase(),w=Object.keys(d).find(g=>g.toLowerCase()===y);return w?d[w]:d[h]}e.getCaseInsensitive=E;function T(d,h){const y=Object.create(null);for(const[w,g]of Object.entries(d))h(w,g)&&(y[w]=g);return y}e.filter=T;function I(d){let h=[],y=Object.getPrototypeOf(d);for(;Object.prototype!==y;)h=h.concat(Object.getOwnPropertyNames(y)),y=Object.getPrototypeOf(y);return h}e.getAllPropertyNames=I;function v(d){const h=[];for(const y of I(d))typeof d[y]=="function"&&h.push(y);return h}e.getAllMethodNames=v;function i(d,h){const y=g=>function(){const t=Array.prototype.slice.call(arguments,0);return h(g,t)},w={};for(const g of d)w[g]=y(g);return w}e.createProxyObject=i}),define(Ce[53],ke([1,0,67]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var R;(function(A){function P(D){return D&&typeof D=="object"&&typeof D.id=="string"}A.isThemeColor=P})(R||(e.ThemeColor=R={}));function l(A){return{id:A}}e.themeColorFromId=l;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function D(h){const y=P.exec(h.id);if(!y)return D(o.Codicon.error);const[,w,g]=y,t=["codicon","codicon-"+w];return g&&t.push("codicon-modifier-"+g.substring(1)),t}A.asClassNameArray=D;function p(h){return D(h).join(" ")}A.asClassName=p;function O(h){return"."+D(h).join(".")}A.asCSSSelector=O;function k(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(typeof h.color>"u"||R.isThemeColor(h.color))}A.isThemeIcon=k;const E=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function T(h){const y=E.exec(h);if(!y)return;const[,w]=y;return{id:w}}A.fromString=T;function I(h){return{id:h}}A.fromId=I;function v(h,y){let w=h.id;const g=w.lastIndexOf("~");return g!==-1&&(w=w.substring(0,g)),y&&(w=`${w}~${y}`),{id:w}}A.modify=v;function i(h){const y=h.id.lastIndexOf("~");if(y!==-1)return h.id.substring(y+1)}A.getModifier=i;function d(h,y){return h.id===y.id&&h.color?.id===y.color?.id}A.isEqual=d})(L||(e.ThemeIcon=L={}))}),define(Ce[105],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var o;(function(L){L[L.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",L[L.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",L[L.MAX_UINT_8=255]="MAX_UINT_8",L[L.MAX_UINT_16=65535]="MAX_UINT_16",L[L.MAX_UINT_32=4294967295]="MAX_UINT_32",L[L.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(o||(e.Constants=o={}));function R(L){return L<0?0:L>255?255:L|0}e.toUint8=R;function l(L){return L<0?0:L>4294967295?4294967295:L|0}e.toUint32=l}),define(Ce[30],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function R(l){return o.test(l)}e.isUUID=R,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(P){for(let D=0;D<P.length;D++)P[D]=Math.floor(Math.random()*256);return P};const L=new Uint8Array(16),A=[];for(let P=0;P<256;P++)A.push(P.toString(16).padStart(2,"0"));return function(){l(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let D=0,p="";return p+=A[L[D++]],p+=A[L[D++]],p+=A[L[D++]],p+=A[L[D++]],p+="-",p+=A[L[D++]],p+=A[L[D++]],p+="-",p+=A[L[D++]],p+=A[L[D++]],p+="-",p+=A[L[D++]],p+=A[L[D++]],p+="-",p+=A[L[D++]],p+=A[L[D++]],p+=A[L[D++]],p+=A[L[D++]],p+=A[L[D++]],p+=A[L[D++]],p}}()}),define(Ce[151],ke([1,0,18,52,30]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function L(D){return{id:(0,l.generateUuid)(),asString:async()=>D,asFile:()=>{},value:typeof D=="string"?D:void 0}}e.createStringDataTransferItem=L;function A(D,p,O){return{id:(0,l.generateUuid)(),asString:async()=>"",asFile:()=>({name:D,uri:p,data:O}),value:void 0}}e.createFileDataTransferItem=A;class P{constructor(){this.a=new Map}get size(){let p=0;return this.forEach(()=>p++),p}has(p){return this.a.has(this.b(p))}matches(p){if(this.has(p))return!0;if(p.toLowerCase()==="files")return R.Iterable.some(this.values(),I=>I.asFile());if(p==="*/*")return this.a.size>0;const O=this.b(p).match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!O)return!1;const[k,E,T]=O;return T==="*"?R.Iterable.some(this.a.keys(),I=>I.startsWith(E+"/")):!1}get(p){return this.a.get(this.b(p))?.[0]}append(p,O){const k=this.a.get(p);k?k.push(O):this.a.set(this.b(p),[O])}replace(p,O){this.a.set(this.b(p),[O])}delete(p){this.a.delete(this.b(p))}*entries(){for(const[p,O]of this.a.entries())for(const k of O)yield[p,k]}values(){return Array.from(this.a.values()).flat()}forEach(p){for(const[O,k]of this.entries())p(k,O)}b(p){return p.toLowerCase()}}e.VSDataTransfer=P,e.UriList=Object.freeze({create:D=>(0,o.distinct)(D.map(p=>p.toString())).join(`\r
`),split:D=>D.split(`\r
`),parse:D=>e.UriList.split(D).filter(p=>!p.startsWith("#"))})}),define(Ce[106],ke([1,0,105]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class R{constructor(P){const D=(0,o.toUint8)(P);this.c=D,this.a=R.d(D),this.b=new Map}static d(P){const D=new Uint8Array(256);return D.fill(P),D}set(P,D){const p=(0,o.toUint8)(D);P>=0&&P<256?this.a[P]=p:this.b.set(P,p)}get(P){return P>=0&&P<256?this.a[P]:this.b.get(P)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=R;var l;(function(A){A[A.False=0]="False",A[A.True=1]="True"})(l||(l={}));class L{constructor(){this.a=new R(0)}add(P){this.a.set(P,1)}has(P){return this.a.get(P)===1}clear(){return this.a.clear()}}e.CharacterSet=L}),define(Ce[54],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class o{constructor(l,L){this.lineNumber=l,this.column=L}with(l=this.lineNumber,L=this.column){return l===this.lineNumber&&L===this.column?this:new o(l,L)}delta(l=0,L=0){return this.with(this.lineNumber+l,this.column+L)}equals(l){return o.equals(this,l)}static equals(l,L){return!l&&!L?!0:!!l&&!!L&&l.lineNumber===L.lineNumber&&l.column===L.column}isBefore(l){return o.isBefore(this,l)}static isBefore(l,L){return l.lineNumber<L.lineNumber?!0:L.lineNumber<l.lineNumber?!1:l.column<L.column}isBeforeOrEqual(l){return o.isBeforeOrEqual(this,l)}static isBeforeOrEqual(l,L){return l.lineNumber<L.lineNumber?!0:L.lineNumber<l.lineNumber?!1:l.column<=L.column}static compare(l,L){const A=l.lineNumber|0,P=L.lineNumber|0;if(A===P){const D=l.column|0,p=L.column|0;return D-p}return A-P}clone(){return new o(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(l){return new o(l.lineNumber,l.column)}static isIPosition(l){return l&&typeof l.lineNumber=="number"&&typeof l.column=="number"}}e.Position=o}),define(Ce[32],ke([1,0,54]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class R{constructor(L,A,P,D){L>P||L===P&&A>D?(this.startLineNumber=P,this.startColumn=D,this.endLineNumber=L,this.endColumn=A):(this.startLineNumber=L,this.startColumn=A,this.endLineNumber=P,this.endColumn=D)}isEmpty(){return R.isEmpty(this)}static isEmpty(L){return L.startLineNumber===L.endLineNumber&&L.startColumn===L.endColumn}containsPosition(L){return R.containsPosition(this,L)}static containsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<L.startColumn||A.lineNumber===L.endLineNumber&&A.column>L.endColumn)}static strictContainsPosition(L,A){return!(A.lineNumber<L.startLineNumber||A.lineNumber>L.endLineNumber||A.lineNumber===L.startLineNumber&&A.column<=L.startColumn||A.lineNumber===L.endLineNumber&&A.column>=L.endColumn)}containsRange(L){return R.containsRange(this,L)}static containsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>L.endColumn)}strictContainsRange(L){return R.strictContainsRange(this,L)}static strictContainsRange(L,A){return!(A.startLineNumber<L.startLineNumber||A.endLineNumber<L.startLineNumber||A.startLineNumber>L.endLineNumber||A.endLineNumber>L.endLineNumber||A.startLineNumber===L.startLineNumber&&A.startColumn<=L.startColumn||A.endLineNumber===L.endLineNumber&&A.endColumn>=L.endColumn)}plusRange(L){return R.plusRange(this,L)}static plusRange(L,A){let P,D,p,O;return A.startLineNumber<L.startLineNumber?(P=A.startLineNumber,D=A.startColumn):A.startLineNumber===L.startLineNumber?(P=A.startLineNumber,D=Math.min(A.startColumn,L.startColumn)):(P=L.startLineNumber,D=L.startColumn),A.endLineNumber>L.endLineNumber?(p=A.endLineNumber,O=A.endColumn):A.endLineNumber===L.endLineNumber?(p=A.endLineNumber,O=Math.max(A.endColumn,L.endColumn)):(p=L.endLineNumber,O=L.endColumn),new R(P,D,p,O)}intersectRanges(L){return R.intersectRanges(this,L)}static intersectRanges(L,A){let P=L.startLineNumber,D=L.startColumn,p=L.endLineNumber,O=L.endColumn;const k=A.startLineNumber,E=A.startColumn,T=A.endLineNumber,I=A.endColumn;return P<k?(P=k,D=E):P===k&&(D=Math.max(D,E)),p>T?(p=T,O=I):p===T&&(O=Math.min(O,I)),P>p||P===p&&D>O?null:new R(P,D,p,O)}equalsRange(L){return R.equalsRange(this,L)}static equalsRange(L,A){return!L&&!A?!0:!!L&&!!A&&L.startLineNumber===A.startLineNumber&&L.startColumn===A.startColumn&&L.endLineNumber===A.endLineNumber&&L.endColumn===A.endColumn}getEndPosition(){return R.getEndPosition(this)}static getEndPosition(L){return new o.Position(L.endLineNumber,L.endColumn)}getStartPosition(){return R.getStartPosition(this)}static getStartPosition(L){return new o.Position(L.startLineNumber,L.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(L,A){return new R(this.startLineNumber,this.startColumn,L,A)}setStartPosition(L,A){return new R(L,A,this.endLineNumber,this.endColumn)}collapseToStart(){return R.collapseToStart(this)}static collapseToStart(L){return new R(L.startLineNumber,L.startColumn,L.startLineNumber,L.startColumn)}collapseToEnd(){return R.collapseToEnd(this)}static collapseToEnd(L){return new R(L.endLineNumber,L.endColumn,L.endLineNumber,L.endColumn)}delta(L){return new R(this.startLineNumber+L,this.startColumn,this.endLineNumber+L,this.endColumn)}static fromPositions(L,A=L){return new R(L.lineNumber,L.column,A.lineNumber,A.column)}static lift(L){return L?new R(L.startLineNumber,L.startColumn,L.endLineNumber,L.endColumn):null}static isIRange(L){return L&&typeof L.startLineNumber=="number"&&typeof L.startColumn=="number"&&typeof L.endLineNumber=="number"&&typeof L.endColumn=="number"}static areIntersectingOrTouching(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<L.startColumn)}static areIntersecting(L,A){return!(L.endLineNumber<A.startLineNumber||L.endLineNumber===A.startLineNumber&&L.endColumn<=A.startColumn||A.endLineNumber<L.startLineNumber||A.endLineNumber===L.startLineNumber&&A.endColumn<=L.startColumn)}static compareRangesUsingStarts(L,A){if(L&&A){const p=L.startLineNumber|0,O=A.startLineNumber|0;if(p===O){const k=L.startColumn|0,E=A.startColumn|0;if(k===E){const T=L.endLineNumber|0,I=A.endLineNumber|0;if(T===I){const v=L.endColumn|0,i=A.endColumn|0;return v-i}return T-I}return k-E}return p-O}return(L?1:0)-(A?1:0)}static compareRangesUsingEnds(L,A){return L.endLineNumber===A.endLineNumber?L.endColumn===A.endColumn?L.startLineNumber===A.startLineNumber?L.startColumn-A.startColumn:L.startLineNumber-A.startLineNumber:L.endColumn-A.endColumn:L.endLineNumber-A.endLineNumber}static spansMultipleLines(L){return L.endLineNumber>L.startLineNumber}toJSON(){return this}}e.Range=R}),define(Ce[152],ke([1,0,54,32]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var l;(function(A){A[A.LTR=0]="LTR",A[A.RTL=1]="RTL"})(l||(e.SelectionDirection=l={}));class L extends R.Range{constructor(P,D,p,O){super(P,D,p,O),this.selectionStartLineNumber=P,this.selectionStartColumn=D,this.positionLineNumber=p,this.positionColumn=O}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(P){return L.selectionsEqual(this,P)}static selectionsEqual(P,D){return P.selectionStartLineNumber===D.selectionStartLineNumber&&P.selectionStartColumn===D.selectionStartColumn&&P.positionLineNumber===D.positionLineNumber&&P.positionColumn===D.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(P,D){return this.getDirection()===0?new L(this.startLineNumber,this.startColumn,P,D):new L(P,D,this.startLineNumber,this.startColumn)}getPosition(){return new o.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new o.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(P,D){return this.getDirection()===0?new L(P,D,this.endLineNumber,this.endColumn):new L(this.endLineNumber,this.endColumn,P,D)}static fromPositions(P,D=P){return new L(P.lineNumber,P.column,D.lineNumber,D.column)}static fromRange(P,D){return D===0?new L(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn):new L(P.endLineNumber,P.endColumn,P.startLineNumber,P.startColumn)}static liftSelection(P){return new L(P.selectionStartLineNumber,P.selectionStartColumn,P.positionLineNumber,P.positionColumn)}static selectionsArrEqual(P,D){if(P&&!D||!P&&D)return!1;if(!P&&!D)return!0;if(P.length!==D.length)return!1;for(let p=0,O=P.length;p<O;p++)if(!this.selectionsEqual(P[p],D[p]))return!1;return!0}static isISelection(P){return P&&typeof P.selectionStartLineNumber=="number"&&typeof P.selectionStartColumn=="number"&&typeof P.positionLineNumber=="number"&&typeof P.positionColumn=="number"}static createWithDirection(P,D,p,O,k){return k===0?new L(P,D,p,O):new L(p,O,P,D)}}e.Selection=L}),define(Ce[153],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Ce[154],ke([1,0,106]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var R;(function(A){A[A.Regular=0]="Regular",A[A.Whitespace=1]="Whitespace",A[A.WordSeparator=2]="WordSeparator"})(R||(e.WordCharacterClass=R={}));class l extends o.CharacterClassifier{constructor(P){super(0);for(let D=0,p=P.length;D<p;D++)this.set(P.charCodeAt(D),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=l;function L(A){const P={};return D=>(P.hasOwnProperty(D)||(P[D]=A(D)),P[D])}e.getMapForWordSeparators=L(A=>new l(A))}),define(Ce[107],ke([1,0,52,6,66]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function L(k=""){let E="(-?\\d*\\.\\d\\w*)|([^";for(const T of e.USUAL_WORD_SEPARATORS)k.indexOf(T)>=0||(E+="\\"+T);return E+="\\s]+)",new RegExp(E,"g")}e.DEFAULT_WORD_REGEXP=L();function A(k){let E=e.DEFAULT_WORD_REGEXP;if(k&&k instanceof RegExp)if(k.global)E=k;else{let T="g";k.ignoreCase&&(T+="i"),k.multiline&&(T+="m"),k.unicode&&(T+="u"),E=new RegExp(k.source,T)}return E.lastIndex=0,E}e.ensureValidWordDefinition=A;const P=new l.LinkedList;P.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function D(k){const E=P.unshift(k);return(0,R.toDisposable)(E)}e.setDefaultGetWordAtTextConfig=D;function p(k,E,T,I,v){if(v||(v=o.Iterable.first(P)),T.length>v.maxLen){let w=k-v.maxLen/2;return w<0?w=0:I+=w,T=T.substring(w,k+v.maxLen/2),p(k,E,T,I,v)}const i=Date.now(),d=k-1-I;let h=-1,y=null;for(let w=1;!(Date.now()-i>=v.timeBudget);w++){const g=d-v.windowSize*w;E.lastIndex=Math.max(0,g);const t=O(E,T,d,h);if(!t&&y||(y=t,g<=0))break;h=g}if(y){const w={word:y[0],startColumn:I+1+y.index,endColumn:I+1+y.index+y[0].length};return E.lastIndex=0,w}return null}e.getWordAtText=p;function O(k,E,T,I){let v;for(;v=k.exec(E);){const i=v.index||0;if(i<=T&&k.lastIndex>=T)return v;if(I>0&&i>I)return null}return null}}),define(Ce[155],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var o;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(o||(e.IndentAction=o={}));class R{constructor(P){if(this.e=null,this.f=!1,this.open=P.open,this.close=P.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(P.notIn))for(let D=0,p=P.notIn.length;D<p;D++)switch(P.notIn[D]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(P){switch(P){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(P,D){if(P.getTokenCount()===0)return!0;const p=P.findTokenIndexAtOffset(D-2),O=P.getStandardTokenType(p);return this.isOK(O)}g(P,D){for(let p=P;p<=D;p++){const O=String.fromCharCode(p);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=R;class l{constructor(P){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const D of P)L(this.autoClosingPairsOpenByStart,D.open.charAt(0),D),L(this.autoClosingPairsOpenByEnd,D.open.charAt(D.open.length-1),D),L(this.autoClosingPairsCloseByStart,D.close.charAt(0),D),L(this.autoClosingPairsCloseByEnd,D.close.charAt(D.close.length-1),D),D.close.length===1&&D.open.length===1&&L(this.autoClosingPairsCloseSingleChar,D.close,D)}}e.AutoClosingPairs=l;function L(A,P,D){A.has(P)?A.get(P).push(D):A.set(P,[D])}}),define(Ce[156],ke([1,0,106]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var R;(function(T){T[T.Invalid=0]="Invalid",T[T.Start=1]="Start",T[T.H=2]="H",T[T.HT=3]="HT",T[T.HTT=4]="HTT",T[T.HTTP=5]="HTTP",T[T.F=6]="F",T[T.FI=7]="FI",T[T.FIL=8]="FIL",T[T.BeforeColon=9]="BeforeColon",T[T.AfterColon=10]="AfterColon",T[T.AlmostThere=11]="AlmostThere",T[T.End=12]="End",T[T.Accept=13]="Accept",T[T.LastKnownState=14]="LastKnownState"})(R||(e.State=R={}));class l{constructor(I,v,i){const d=new Uint8Array(I*v);for(let h=0,y=I*v;h<y;h++)d[h]=i;this.a=d,this.rows=I,this.cols=v}get(I,v){return this.a[I*this.cols+v]}set(I,v,i){this.a[I*this.cols+v]=i}}class L{constructor(I){let v=0,i=0;for(let h=0,y=I.length;h<y;h++){const[w,g,t]=I[h];g>v&&(v=g),w>i&&(i=w),t>i&&(i=t)}v++,i++;const d=new l(i,v,0);for(let h=0,y=I.length;h<y;h++){const[w,g,t]=I[h];d.set(w,g,t)}this.a=d,this.b=v}nextState(I,v){return v<0||v>=this.b?0:this.a.get(I,v)}}e.StateMachine=L;let A=null;function P(){return A===null&&(A=new L([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),A}var D;(function(T){T[T.None=0]="None",T[T.ForceTermination=1]="ForceTermination",T[T.CannotEndIn=2]="CannotEndIn"})(D||(D={}));let p=null;function O(){if(p===null){p=new o.CharacterClassifier(0);const T=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let v=0;v<T.length;v++)p.set(T.charCodeAt(v),1);const I=".,;:";for(let v=0;v<I.length;v++)p.set(I.charCodeAt(v),2)}return p}class k{static a(I,v,i,d,h){let y=h-1;do{const w=v.charCodeAt(y);if(I.get(w)!==2)break;y--}while(y>d);if(d>0){const w=v.charCodeAt(d-1),g=v.charCodeAt(y);(w===40&&g===41||w===91&&g===93||w===123&&g===125)&&y--}return{range:{startLineNumber:i,startColumn:d+1,endLineNumber:i,endColumn:y+2},url:v.substring(d,y+1)}}static computeLinks(I,v=P()){const i=O(),d=[];for(let h=1,y=I.getLineCount();h<=y;h++){const w=I.getLineContent(h),g=w.length;let t=0,s=0,r=0,a=1,b=!1,S=!1,c=!1,u=!1;for(;t<g;){let m=!1;const f=w.charCodeAt(t);if(a===13){let n;switch(f){case 40:b=!0,n=0;break;case 41:n=b?0:1;break;case 91:c=!0,S=!0,n=0;break;case 93:c=!1,n=S?0:1;break;case 123:u=!0,n=0;break;case 125:n=u?0:1;break;case 39:case 34:case 96:r===f?n=1:r===39||r===34||r===96?n=0:n=1;break;case 42:n=r===42?1:0;break;case 124:n=r===124?1:0;break;case 32:n=c?0:1;break;default:n=i.get(f)}n===1&&(d.push(k.a(i,w,h,s,t)),m=!0)}else if(a===12){let n;f===91?(S=!0,n=0):n=i.get(f),n===1?m=!0:a=13}else a=v.nextState(a,f),a===0&&(m=!0);m&&(a=1,b=!1,S=!1,u=!1,s=t+1,r=f),t++}a===13&&d.push(k.a(i,w,h,s,g))}return d}}e.LinkComputer=k;function E(T){return!T||typeof T.getLineCount!="function"||typeof T.getLineContent!="function"?[]:k.computeLinks(T)}e.computeLinks=E}),define(Ce[108],ke([1,0,23]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.GlyphMarginLane=e.OverviewRulerLane=void 0;var R;(function(w){w[w.Left=1]="Left",w[w.Center=2]="Center",w[w.Right=4]="Right",w[w.Full=7]="Full"})(R||(e.OverviewRulerLane=R={}));var l;(function(w){w[w.Left=1]="Left",w[w.Right=2]="Right"})(l||(e.GlyphMarginLane=l={}));var L;(function(w){w[w.Inline=1]="Inline",w[w.Gutter=2]="Gutter"})(L||(e.MinimapPosition=L={}));var A;(function(w){w[w.Both=0]="Both",w[w.Right=1]="Right",w[w.Left=2]="Left",w[w.None=3]="None"})(A||(e.InjectedTextCursorStops=A={}));var P;(function(w){w[w.TextDefined=0]="TextDefined",w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(P||(e.EndOfLinePreference=P={}));var D;(function(w){w[w.LF=1]="LF",w[w.CRLF=2]="CRLF"})(D||(e.DefaultEndOfLine=D={}));var p;(function(w){w[w.LF=0]="LF",w[w.CRLF=1]="CRLF"})(p||(e.EndOfLineSequence=p={}));class O{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(g){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,g.tabSize|0),g.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,g.indentSize|0),this.a=!1),this.insertSpaces=!!g.insertSpaces,this.defaultEOL=g.defaultEOL|0,this.trimAutoWhitespace=!!g.trimAutoWhitespace,this.bracketPairColorizationOptions=g.bracketPairColorizationOptions}equals(g){return this.tabSize===g.tabSize&&this.a===g.a&&this.indentSize===g.indentSize&&this.insertSpaces===g.insertSpaces&&this.defaultEOL===g.defaultEOL&&this.trimAutoWhitespace===g.trimAutoWhitespace&&(0,o.equals)(this.bracketPairColorizationOptions,g.bracketPairColorizationOptions)}createChangeEvent(g){return{tabSize:this.tabSize!==g.tabSize,indentSize:this.indentSize!==g.indentSize,insertSpaces:this.insertSpaces!==g.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==g.trimAutoWhitespace}}}e.TextModelResolvedOptions=O;class k{constructor(g,t){this._findMatchBrand=void 0,this.range=g,this.matches=t}}e.FindMatch=k;var E;(function(w){w[w.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",w[w.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",w[w.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",w[w.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(E||(e.TrackedRangeStickiness=E={}));function T(w){return w&&typeof w.read=="function"}e.isITextSnapshot=T;var I;(function(w){w[w.Left=0]="Left",w[w.Right=1]="Right",w[w.None=2]="None",w[w.LeftOfInjectedText=3]="LeftOfInjectedText",w[w.RightOfInjectedText=4]="RightOfInjectedText"})(I||(e.PositionAffinity=I={}));var v;(function(w){w[w.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(v||(e.ModelConstants=v={}));class i{constructor(g,t,s,r,a,b){this.identifier=g,this.range=t,this.text=s,this.forceMoveMarkers=r,this.isAutoWhitespaceEdit=a,this._isTracked=b}}e.ValidAnnotatedEditOperation=i;class d{constructor(g,t,s){this.regex=g,this.wordSeparators=t,this.simpleSearch=s}}e.SearchData=d;class h{constructor(g,t,s){this.reverseEdits=g,this.changes=t,this.trimAutoWhitespaceLineNumbers=s}}e.ApplyEditsResult=h;function y(w){return!w.isTooLargeForSyncing()&&!w.isForSimpleWidget}e.shouldSynchronizeModel=y}),define(Ce[157],ke([1,0,18,105]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class l{constructor(D){this.a=D,this.b=new Uint32Array(D.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(D,p){D=(0,R.toUint32)(D);const O=this.a,k=this.b,E=p.length;return E===0?!1:(this.a=new Uint32Array(O.length+E),this.a.set(O.subarray(0,D),0),this.a.set(O.subarray(D),D+E),this.a.set(p,D),D-1<this.c[0]&&(this.c[0]=D-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(k.subarray(0,this.c[0]+1)),!0)}setValue(D,p){return D=(0,R.toUint32)(D),p=(0,R.toUint32)(p),this.a[D]===p?!1:(this.a[D]=p,D-1<this.c[0]&&(this.c[0]=D-1),!0)}removeValues(D,p){D=(0,R.toUint32)(D),p=(0,R.toUint32)(p);const O=this.a,k=this.b;if(D>=O.length)return!1;const E=O.length-D;return p>=E&&(p=E),p===0?!1:(this.a=new Uint32Array(O.length-p),this.a.set(O.subarray(0,D),0),this.a.set(O.subarray(D+p),D),this.b=new Uint32Array(this.a.length),D-1<this.c[0]&&(this.c[0]=D-1),this.c[0]>=0&&this.b.set(k.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(D){return D<0?0:(D=(0,R.toUint32)(D),this.d(D))}d(D){if(D<=this.c[0])return this.b[D];let p=this.c[0]+1;p===0&&(this.b[0]=this.a[0],p++),D>=this.a.length&&(D=this.a.length-1);for(let O=p;O<=D;O++)this.b[O]=this.b[O-1]+this.a[O];return this.c[0]=Math.max(this.c[0],D),this.b[D]}getIndexOf(D){D=Math.floor(D),this.getTotalSum();let p=0,O=this.a.length-1,k=0,E=0,T=0;for(;p<=O;)if(k=p+(O-p)/2|0,E=this.b[k],T=E-this.a[k],D<T)O=k-1;else if(D>=E)p=k+1;else break;return new A(k,D-T)}}e.PrefixSumComputer=l;class L{constructor(D){this.a=D,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(D){return this.g(),D===0?0:this.d[D-1]}getIndexOf(D){this.g();const p=this.e[D],O=p>0?this.d[p-1]:0;return new A(p,D-O)}removeValues(D,p){this.a.splice(D,p),this.f(D)}insertValues(D,p){this.a=(0,o.arrayInsert)(this.a,D,p),this.f(D)}f(D){this.b=!1,this.c=Math.min(this.c,D-1)}g(){if(!this.b){for(let D=this.c+1,p=this.a.length;D<p;D++){const O=this.a[D],k=D>0?this.d[D-1]:0;this.d[D]=k+O;for(let E=0;E<O;E++)this.e[k+E]=D}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(D,p){this.a[D]!==p&&(this.a[D]=p,this.f(D))}}e.ConstantTimePrefixSumComputer=L;class A{constructor(D,p){this.index=D,this.remainder=p,this._prefixSumIndexOfResultBrand=void 0,this.index=D,this.remainder=p}}e.PrefixSumIndexOfResult=A}),define(Ce[158],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class o{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const A=this.a.get(L);return this.a.delete(L),A}}addDragOperationTransfer(L,A){this.a.set(L,A)}}e.TreeViewsDnDService=o;class R{constructor(L){this.identifier=L}}e.DraggedTreeItemsIdentifier=R}),define(Ce[159],ke([12,13]),function(ae,e){return ae.create("vs/base/common/actions",e)}),define(Ce[160],ke([12,13]),function(ae,e){return ae.create("vs/base/common/date",e)}),define(Ce[161],ke([1,0,160]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const R=60,l=R*60,L=l*24,A=L*7,P=L*30,D=L*365;function p(k,E,T,I){typeof k!="number"&&(k=k.getTime());const v=Math.round((new Date().getTime()-k)/1e3);if(v<-30)return(0,o.localize)(0,null,p(new Date().getTime()+v*1e3,!1));if(!I&&v<30)return(0,o.localize)(1,null);let i;return v<R?(i=v,E?i===1?T?(0,o.localize)(2,null,i):(0,o.localize)(3,null,i):T?(0,o.localize)(4,null,i):(0,o.localize)(5,null,i):i===1?T?(0,o.localize)(6,null,i):(0,o.localize)(7,null,i):T?(0,o.localize)(8,null,i):(0,o.localize)(9,null,i)):v<l?(i=Math.floor(v/R),E?i===1?T?(0,o.localize)(10,null,i):(0,o.localize)(11,null,i):T?(0,o.localize)(12,null,i):(0,o.localize)(13,null,i):i===1?T?(0,o.localize)(14,null,i):(0,o.localize)(15,null,i):T?(0,o.localize)(16,null,i):(0,o.localize)(17,null,i)):v<L?(i=Math.floor(v/l),E?i===1?T?(0,o.localize)(18,null,i):(0,o.localize)(19,null,i):T?(0,o.localize)(20,null,i):(0,o.localize)(21,null,i):i===1?T?(0,o.localize)(22,null,i):(0,o.localize)(23,null,i):T?(0,o.localize)(24,null,i):(0,o.localize)(25,null,i)):v<A?(i=Math.floor(v/L),E?i===1?(0,o.localize)(26,null,i):(0,o.localize)(27,null,i):i===1?(0,o.localize)(28,null,i):(0,o.localize)(29,null,i)):v<P?(i=Math.floor(v/A),E?i===1?T?(0,o.localize)(30,null,i):(0,o.localize)(31,null,i):T?(0,o.localize)(32,null,i):(0,o.localize)(33,null,i):i===1?T?(0,o.localize)(34,null,i):(0,o.localize)(35,null,i):T?(0,o.localize)(36,null,i):(0,o.localize)(37,null,i)):v<D?(i=Math.floor(v/P),E?i===1?T?(0,o.localize)(38,null,i):(0,o.localize)(39,null,i):T?(0,o.localize)(40,null,i):(0,o.localize)(41,null,i):i===1?T?(0,o.localize)(42,null,i):(0,o.localize)(43,null,i):T?(0,o.localize)(44,null,i):(0,o.localize)(45,null,i)):(i=Math.floor(v/D),E?i===1?T?(0,o.localize)(46,null,i):(0,o.localize)(47,null,i):T?(0,o.localize)(48,null,i):(0,o.localize)(49,null,i):i===1?T?(0,o.localize)(50,null,i):(0,o.localize)(51,null,i):T?(0,o.localize)(52,null,i):(0,o.localize)(53,null,i))}e.fromNow=p;function O(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Ce[162],ke([12,13]),function(ae,e){return ae.create("vs/base/common/errorMessage",e)}),define(Ce[46],ke([1,0,18,10,162]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(k,E){return E&&(k.stack||k.stacktrace)?l.localize(0,null,P(k),A(k.stack)||A(k.stacktrace)):P(k)}function A(k){return Array.isArray(k)?k.join(`
`):k}function P(k){return k.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${k.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?l.localize(1,null,k.message):k.message||l.localize(2,null)}function D(k=null,E=!1){if(!k)return l.localize(3,null);if(Array.isArray(k)){const T=o.coalesce(k),I=D(T[0],E);return T.length>1?l.localize(4,null,I,T.length):I}if(R.isString(k))return k;if(k.detail){const T=k.detail;if(T.error)return L(T.error,E);if(T.exception)return L(T.exception,E)}return k.stack?L(k,E):k.message?k.message:l.localize(5,null)}e.toErrorMessage=D;function p(k){const E=k;return E instanceof Error&&Array.isArray(E.actions)}e.isErrorWithActions=p;function O(k,E){let T;return typeof k=="string"?T=new Error(k):T=k,T.actions=E,T}e.createErrorWithActions=O}),define(Ce[163],ke([12,13]),function(ae,e){return ae.create("vs/base/common/platform",e)}),define(Ce[14],ke([1,0,163]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.platformLocale=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let R=!1,l=!1,L=!1,A=!1,P=!1,D=!1,p=!1,O=!1,k=!1,E=!1,T,I=e.LANGUAGE_DEFAULT,v=e.LANGUAGE_DEFAULT,i,d;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let h;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?h=e.globals.vscode.process:typeof process<"u"&&(h=process);const y=typeof h?.versions?.electron=="string",w=y&&h?.type==="renderer";if(typeof navigator=="object"&&!w)d=navigator.userAgent,R=d.indexOf("Windows")>=0,l=d.indexOf("Macintosh")>=0,O=(d.indexOf("Macintosh")>=0||d.indexOf("iPad")>=0||d.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,L=d.indexOf("Linux")>=0,E=d?.indexOf("Mobi")>=0,D=!0,T=o.getConfiguredDefaultLocale(o.localize(0,null))||e.LANGUAGE_DEFAULT,I=T,v=navigator.language;else if(typeof h=="object"){R=h.platform==="win32",l=h.platform==="darwin",L=h.platform==="linux",A=L&&!!h.env.SNAP&&!!h.env.SNAP_REVISION,p=y,k=!!h.env.CI||!!h.env.BUILD_ARTIFACTSTAGINGDIRECTORY,T=e.LANGUAGE_DEFAULT,I=e.LANGUAGE_DEFAULT;const u=h.env.VSCODE_NLS_CONFIG;if(u)try{const m=JSON.parse(u),f=m.availableLanguages["*"];T=m.locale,v=m.osLocale,I=f||e.LANGUAGE_DEFAULT,i=m._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var g;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(g||(e.Platform=g={}));function t(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=t;let s=0;l?s=1:R?s=3:L&&(s=2),e.isWindows=R,e.isMacintosh=l,e.isLinux=L,e.isLinuxSnap=A,e.isNative=P,e.isElectron=p,e.isWeb=D,e.isWebWorker=D&&typeof e.globals.importScripts=="function",e.isIOS=O,e.isMobile=E,e.isCI=k,e.platform=s,e.userAgent=d,e.language=I;var r;(function(u){function m(){return e.language}u.value=m;function f(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=f;function n(){return e.language==="en"}u.isDefault=n})(r||(e.Language=r={})),e.locale=T,e.platformLocale=v,e.translationsConfigFile=i,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const u=[];e.globals.addEventListener("message",f=>{if(f.data&&f.data.vscodeScheduleAsyncWork)for(let n=0,C=u.length;n<C;n++){const M=u[n];if(M.id===f.data.vscodeScheduleAsyncWork){u.splice(n,1),M.callback();return}}});let m=0;return f=>{const n=++m;u.push({id:n,callback:f}),e.globals.postMessage({vscodeScheduleAsyncWork:n},"*")}}return u=>setTimeout(u)})();var a;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(a||(e.OperatingSystem=a={})),e.OS=l||O?2:R?1:3;let b=!0,S=!1;function c(){if(!S){S=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,b=new Uint16Array(u.buffer)[0]===(2<<8)+1}return b}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(Ce[36],ke([1,0,14]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let R;if(typeof o.globals.vscode<"u"&&typeof o.globals.vscode.process<"u"){const l=o.globals.vscode.process;R={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?R={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:R={get platform(){return o.isWindows?"win32":o.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=R.cwd,e.env=R.env,e.platform=R.platform,e.arch=R.arch}),define(Ce[15],ke([1,0,36]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const R=65,l=97,L=90,A=122,P=46,D=47,p=92,O=58,k=63;class E extends Error{constructor(s,r,a){let b;typeof r=="string"&&r.indexOf("not ")===0?(b="must not be",r=r.replace(/^not /,"")):b="must be";const S=s.indexOf(".")!==-1?"property":"argument";let c=`The "${s}" ${S} ${b} of type ${r}`;c+=`. Received type ${typeof a}`,super(c),this.code="ERR_INVALID_ARG_TYPE"}}function T(t,s){if(t===null||typeof t!="object")throw new E(s,"Object",t)}function I(t,s){if(typeof t!="string")throw new E(s,"string",t)}const v=o.platform==="win32";function i(t){return t===D||t===p}function d(t){return t===D}function h(t){return t>=R&&t<=L||t>=l&&t<=A}function y(t,s,r,a){let b="",S=0,c=-1,u=0,m=0;for(let f=0;f<=t.length;++f){if(f<t.length)m=t.charCodeAt(f);else{if(a(m))break;m=D}if(a(m)){if(!(c===f-1||u===1))if(u===2){if(b.length<2||S!==2||b.charCodeAt(b.length-1)!==P||b.charCodeAt(b.length-2)!==P){if(b.length>2){const n=b.lastIndexOf(r);n===-1?(b="",S=0):(b=b.slice(0,n),S=b.length-1-b.lastIndexOf(r)),c=f,u=0;continue}else if(b.length!==0){b="",S=0,c=f,u=0;continue}}s&&(b+=b.length>0?`${r}..`:"..",S=2)}else b.length>0?b+=`${r}${t.slice(c+1,f)}`:b=t.slice(c+1,f),S=f-c-1;c=f,u=0}else m===P&&u!==-1?++u:u=-1}return b}function w(t,s){T(s,"pathObject");const r=s.dir||s.root,a=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${a}`:`${r}${t}${a}`:a}e.win32={resolve(...t){let s="",r="",a=!1;for(let b=t.length-1;b>=-1;b--){let S;if(b>=0){if(S=t[b],I(S,"path"),S.length===0)continue}else s.length===0?S=o.cwd():(S=o.env[`=${s}`]||o.cwd(),(S===void 0||S.slice(0,2).toLowerCase()!==s.toLowerCase()&&S.charCodeAt(2)===p)&&(S=`${s}\\`));const c=S.length;let u=0,m="",f=!1;const n=S.charCodeAt(0);if(c===1)i(n)&&(u=1,f=!0);else if(i(n))if(f=!0,i(S.charCodeAt(1))){let C=2,M=C;for(;C<c&&!i(S.charCodeAt(C));)C++;if(C<c&&C!==M){const H=S.slice(M,C);for(M=C;C<c&&i(S.charCodeAt(C));)C++;if(C<c&&C!==M){for(M=C;C<c&&!i(S.charCodeAt(C));)C++;(C===c||C!==M)&&(m=`\\\\${H}\\${S.slice(M,C)}`,u=C)}}}else u=1;else h(n)&&S.charCodeAt(1)===O&&(m=S.slice(0,2),u=2,c>2&&i(S.charCodeAt(2))&&(f=!0,u=3));if(m.length>0)if(s.length>0){if(m.toLowerCase()!==s.toLowerCase())continue}else s=m;if(a){if(s.length>0)break}else if(r=`${S.slice(u)}\\${r}`,a=f,f&&s.length>0)break}return r=y(r,!a,"\\",i),a?`${s}\\${r}`:`${s}${r}`||"."},normalize(t){I(t,"path");const s=t.length;if(s===0)return".";let r=0,a,b=!1;const S=t.charCodeAt(0);if(s===1)return d(S)?"\\":t;if(i(S))if(b=!0,i(t.charCodeAt(1))){let u=2,m=u;for(;u<s&&!i(t.charCodeAt(u));)u++;if(u<s&&u!==m){const f=t.slice(m,u);for(m=u;u<s&&i(t.charCodeAt(u));)u++;if(u<s&&u!==m){for(m=u;u<s&&!i(t.charCodeAt(u));)u++;if(u===s)return`\\\\${f}\\${t.slice(m)}\\`;u!==m&&(a=`\\\\${f}\\${t.slice(m,u)}`,r=u)}}}else r=1;else h(S)&&t.charCodeAt(1)===O&&(a=t.slice(0,2),r=2,s>2&&i(t.charCodeAt(2))&&(b=!0,r=3));let c=r<s?y(t.slice(r),!b,"\\",i):"";return c.length===0&&!b&&(c="."),c.length>0&&i(t.charCodeAt(s-1))&&(c+="\\"),a===void 0?b?`\\${c}`:c:b?`${a}\\${c}`:`${a}${c}`},isAbsolute(t){I(t,"path");const s=t.length;if(s===0)return!1;const r=t.charCodeAt(0);return i(r)||s>2&&h(r)&&t.charCodeAt(1)===O&&i(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let s,r;for(let S=0;S<t.length;++S){const c=t[S];I(c,"path"),c.length>0&&(s===void 0?s=r=c:s+=`\\${c}`)}if(s===void 0)return".";let a=!0,b=0;if(typeof r=="string"&&i(r.charCodeAt(0))){++b;const S=r.length;S>1&&i(r.charCodeAt(1))&&(++b,S>2&&(i(r.charCodeAt(2))?++b:a=!1))}if(a){for(;b<s.length&&i(s.charCodeAt(b));)b++;b>=2&&(s=`\\${s.slice(b)}`)}return e.win32.normalize(s)},relative(t,s){if(I(t,"from"),I(s,"to"),t===s)return"";const r=e.win32.resolve(t),a=e.win32.resolve(s);if(r===a||(t=r.toLowerCase(),s=a.toLowerCase(),t===s))return"";let b=0;for(;b<t.length&&t.charCodeAt(b)===p;)b++;let S=t.length;for(;S-1>b&&t.charCodeAt(S-1)===p;)S--;const c=S-b;let u=0;for(;u<s.length&&s.charCodeAt(u)===p;)u++;let m=s.length;for(;m-1>u&&s.charCodeAt(m-1)===p;)m--;const f=m-u,n=c<f?c:f;let C=-1,M=0;for(;M<n;M++){const V=t.charCodeAt(b+M);if(V!==s.charCodeAt(u+M))break;V===p&&(C=M)}if(M!==n){if(C===-1)return a}else{if(f>n){if(s.charCodeAt(u+M)===p)return a.slice(u+M+1);if(M===2)return a.slice(u+M)}c>n&&(t.charCodeAt(b+M)===p?C=M:M===2&&(C=3)),C===-1&&(C=0)}let H="";for(M=b+C+1;M<=S;++M)(M===S||t.charCodeAt(M)===p)&&(H+=H.length===0?"..":"\\..");return u+=C,H.length>0?`${H}${a.slice(u,m)}`:(a.charCodeAt(u)===p&&++u,a.slice(u,m))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const s=e.win32.resolve(t);if(s.length<=2)return t;if(s.charCodeAt(0)===p){if(s.charCodeAt(1)===p){const r=s.charCodeAt(2);if(r!==k&&r!==P)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(h(s.charCodeAt(0))&&s.charCodeAt(1)===O&&s.charCodeAt(2)===p)return`\\\\?\\${s}`;return t},dirname(t){I(t,"path");const s=t.length;if(s===0)return".";let r=-1,a=0;const b=t.charCodeAt(0);if(s===1)return i(b)?t:".";if(i(b)){if(r=a=1,i(t.charCodeAt(1))){let u=2,m=u;for(;u<s&&!i(t.charCodeAt(u));)u++;if(u<s&&u!==m){for(m=u;u<s&&i(t.charCodeAt(u));)u++;if(u<s&&u!==m){for(m=u;u<s&&!i(t.charCodeAt(u));)u++;if(u===s)return t;u!==m&&(r=a=u+1)}}}}else h(b)&&t.charCodeAt(1)===O&&(r=s>2&&i(t.charCodeAt(2))?3:2,a=r);let S=-1,c=!0;for(let u=s-1;u>=a;--u)if(i(t.charCodeAt(u))){if(!c){S=u;break}}else c=!1;if(S===-1){if(r===-1)return".";S=r}return t.slice(0,S)},basename(t,s){s!==void 0&&I(s,"ext"),I(t,"path");let r=0,a=-1,b=!0,S;if(t.length>=2&&h(t.charCodeAt(0))&&t.charCodeAt(1)===O&&(r=2),s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let c=s.length-1,u=-1;for(S=t.length-1;S>=r;--S){const m=t.charCodeAt(S);if(i(m)){if(!b){r=S+1;break}}else u===-1&&(b=!1,u=S+1),c>=0&&(m===s.charCodeAt(c)?--c===-1&&(a=S):(c=-1,a=u))}return r===a?a=u:a===-1&&(a=t.length),t.slice(r,a)}for(S=t.length-1;S>=r;--S)if(i(t.charCodeAt(S))){if(!b){r=S+1;break}}else a===-1&&(b=!1,a=S+1);return a===-1?"":t.slice(r,a)},extname(t){I(t,"path");let s=0,r=-1,a=0,b=-1,S=!0,c=0;t.length>=2&&t.charCodeAt(1)===O&&h(t.charCodeAt(0))&&(s=a=2);for(let u=t.length-1;u>=s;--u){const m=t.charCodeAt(u);if(i(m)){if(!S){a=u+1;break}continue}b===-1&&(S=!1,b=u+1),m===P?r===-1?r=u:c!==1&&(c=1):r!==-1&&(c=-1)}return r===-1||b===-1||c===0||c===1&&r===b-1&&r===a+1?"":t.slice(r,b)},format:w.bind(null,"\\"),parse(t){I(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.length;let a=0,b=t.charCodeAt(0);if(r===1)return i(b)?(s.root=s.dir=t,s):(s.base=s.name=t,s);if(i(b)){if(a=1,i(t.charCodeAt(1))){let C=2,M=C;for(;C<r&&!i(t.charCodeAt(C));)C++;if(C<r&&C!==M){for(M=C;C<r&&i(t.charCodeAt(C));)C++;if(C<r&&C!==M){for(M=C;C<r&&!i(t.charCodeAt(C));)C++;C===r?a=C:C!==M&&(a=C+1)}}}}else if(h(b)&&t.charCodeAt(1)===O){if(r<=2)return s.root=s.dir=t,s;if(a=2,i(t.charCodeAt(2))){if(r===3)return s.root=s.dir=t,s;a=3}}a>0&&(s.root=t.slice(0,a));let S=-1,c=a,u=-1,m=!0,f=t.length-1,n=0;for(;f>=a;--f){if(b=t.charCodeAt(f),i(b)){if(!m){c=f+1;break}continue}u===-1&&(m=!1,u=f+1),b===P?S===-1?S=f:n!==1&&(n=1):S!==-1&&(n=-1)}return u!==-1&&(S===-1||n===0||n===1&&S===u-1&&S===c+1?s.base=s.name=t.slice(c,u):(s.name=t.slice(c,S),s.base=t.slice(c,u),s.ext=t.slice(S,u))),c>0&&c!==a?s.dir=t.slice(0,c-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(v){const t=/\\/g;return()=>{const s=o.cwd().replace(t,"/");return s.slice(s.indexOf("/"))}}return()=>o.cwd()})();e.posix={resolve(...t){let s="",r=!1;for(let a=t.length-1;a>=-1&&!r;a--){const b=a>=0?t[a]:g();I(b,"path"),b.length!==0&&(s=`${b}/${s}`,r=b.charCodeAt(0)===D)}return s=y(s,!r,"/",d),r?`/${s}`:s.length>0?s:"."},normalize(t){if(I(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===D,r=t.charCodeAt(t.length-1)===D;return t=y(t,!s,"/",d),t.length===0?s?"/":r?"./":".":(r&&(t+="/"),s?`/${t}`:t)},isAbsolute(t){return I(t,"path"),t.length>0&&t.charCodeAt(0)===D},join(...t){if(t.length===0)return".";let s;for(let r=0;r<t.length;++r){const a=t[r];I(a,"path"),a.length>0&&(s===void 0?s=a:s+=`/${a}`)}return s===void 0?".":e.posix.normalize(s)},relative(t,s){if(I(t,"from"),I(s,"to"),t===s||(t=e.posix.resolve(t),s=e.posix.resolve(s),t===s))return"";const r=1,a=t.length,b=a-r,S=1,c=s.length-S,u=b<c?b:c;let m=-1,f=0;for(;f<u;f++){const C=t.charCodeAt(r+f);if(C!==s.charCodeAt(S+f))break;C===D&&(m=f)}if(f===u)if(c>u){if(s.charCodeAt(S+f)===D)return s.slice(S+f+1);if(f===0)return s.slice(S+f)}else b>u&&(t.charCodeAt(r+f)===D?m=f:f===0&&(m=0));let n="";for(f=r+m+1;f<=a;++f)(f===a||t.charCodeAt(f)===D)&&(n+=n.length===0?"..":"/..");return`${n}${s.slice(S+m)}`},toNamespacedPath(t){return t},dirname(t){if(I(t,"path"),t.length===0)return".";const s=t.charCodeAt(0)===D;let r=-1,a=!0;for(let b=t.length-1;b>=1;--b)if(t.charCodeAt(b)===D){if(!a){r=b;break}}else a=!1;return r===-1?s?"/":".":s&&r===1?"//":t.slice(0,r)},basename(t,s){s!==void 0&&I(s,"ext"),I(t,"path");let r=0,a=-1,b=!0,S;if(s!==void 0&&s.length>0&&s.length<=t.length){if(s===t)return"";let c=s.length-1,u=-1;for(S=t.length-1;S>=0;--S){const m=t.charCodeAt(S);if(m===D){if(!b){r=S+1;break}}else u===-1&&(b=!1,u=S+1),c>=0&&(m===s.charCodeAt(c)?--c===-1&&(a=S):(c=-1,a=u))}return r===a?a=u:a===-1&&(a=t.length),t.slice(r,a)}for(S=t.length-1;S>=0;--S)if(t.charCodeAt(S)===D){if(!b){r=S+1;break}}else a===-1&&(b=!1,a=S+1);return a===-1?"":t.slice(r,a)},extname(t){I(t,"path");let s=-1,r=0,a=-1,b=!0,S=0;for(let c=t.length-1;c>=0;--c){const u=t.charCodeAt(c);if(u===D){if(!b){r=c+1;break}continue}a===-1&&(b=!1,a=c+1),u===P?s===-1?s=c:S!==1&&(S=1):s!==-1&&(S=-1)}return s===-1||a===-1||S===0||S===1&&s===a-1&&s===r+1?"":t.slice(s,a)},format:w.bind(null,"/"),parse(t){I(t,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return s;const r=t.charCodeAt(0)===D;let a;r?(s.root="/",a=1):a=0;let b=-1,S=0,c=-1,u=!0,m=t.length-1,f=0;for(;m>=a;--m){const n=t.charCodeAt(m);if(n===D){if(!u){S=m+1;break}continue}c===-1&&(u=!1,c=m+1),n===P?b===-1?b=m:f!==1&&(f=1):b!==-1&&(f=-1)}if(c!==-1){const n=S===0&&r?1:S;b===-1||f===0||f===1&&b===c-1&&b===S+1?s.base=s.name=t.slice(n,c):(s.name=t.slice(n,b),s.base=t.slice(n,c),s.ext=t.slice(b,c))}return S>0?s.dir=t.slice(0,S-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=v?e.win32.normalize:e.posix.normalize,e.isAbsolute=v?e.win32.isAbsolute:e.posix.isAbsolute,e.join=v?e.win32.join:e.posix.join,e.resolve=v?e.win32.resolve:e.posix.resolve,e.relative=v?e.win32.relative:e.posix.relative,e.dirname=v?e.win32.dirname:e.posix.dirname,e.basename=v?e.win32.basename:e.posix.basename,e.extname=v?e.win32.extname:e.posix.extname,e.format=v?e.win32.format:e.posix.format,e.parse=v?e.win32.parse:e.posix.parse,e.toNamespacedPath=v?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=v?e.win32.sep:e.posix.sep,e.delimiter=v?e.win32.delimiter:e.posix.delimiter}),define(Ce[109],ke([1,0,65,15]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const l=new o.Lazy(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),L=new o.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new o.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function P(u,m,f=!1){const n=u||"",C=m||"",M=l.value.collator.compare(n,C);return l.value.collatorIsNumeric&&M===0&&n!==C?n<C?-1:1:M}e.compareFileNames=P;function D(u,m){const f=L.value.collator;return u=u||"",m=m||"",w(f,u,m)}e.compareFileNamesDefault=D;function p(u,m){const f=L.value.collator;return u=u||"",m=m||"",r(u,m)||w(f,u,m)}e.compareFileNamesUpper=p;function O(u,m){const f=L.value.collator;return u=u||"",m=m||"",s(u,m)||w(f,u,m)}e.compareFileNamesLower=O;function k(u,m){return u=u||"",m=m||"",u===m?0:u<m?-1:1}e.compareFileNamesUnicode=k;function E(u,m){const[f,n]=h(u),[C,M]=h(m);let H=l.value.collator.compare(n,M);if(H===0){if(l.value.collatorIsNumeric&&n!==M)return n<M?-1:1;if(H=l.value.collator.compare(f,C),l.value.collatorIsNumeric&&H===0&&f!==C)return f<C?-1:1}return H}e.compareFileExtensions=E;function T(u,m){u=u||"",m=m||"";const f=y(u),n=y(m),C=L.value.collator,M=A.value.collator;return w(M,f,n)||w(C,u,m)}e.compareFileExtensionsDefault=T;function I(u,m){u=u||"",m=m||"";const f=y(u),n=y(m),C=L.value.collator,M=A.value.collator;return w(M,f,n)||r(u,m)||w(C,u,m)}e.compareFileExtensionsUpper=I;function v(u,m){u=u||"",m=m||"";const f=y(u),n=y(m),C=L.value.collator,M=A.value.collator;return w(M,f,n)||s(u,m)||w(C,u,m)}e.compareFileExtensionsLower=v;function i(u,m){u=u||"",m=m||"";const f=y(u).toLowerCase(),n=y(m).toLowerCase();return f!==n?f<n?-1:1:u!==m?u<m?-1:1:0}e.compareFileExtensionsUnicode=i;const d=/^(.*?)(\.([^.]*))?$/;function h(u,m=!1){const f=u?d.exec(u):[];let n=[f&&f[1]||"",f&&f[3]||""];return m&&(!n[0]&&n[1]||n[0]&&n[0].charAt(0)===".")&&(n=[n[0]+"."+n[1],""]),n}function y(u){const m=u?d.exec(u):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function w(u,m,f){const n=u.compare(m,f);return n!==0?n:m.length!==f.length?m.length<f.length?-1:1:0}function g(u){const m=u.charAt(0);return m.toLocaleUpperCase()!==m}function t(u){const m=u.charAt(0);return m.toLocaleLowerCase()!==m}function s(u,m){return g(u)&&t(m)?-1:t(u)&&g(m)?1:0}function r(u,m){return t(u)&&g(m)?-1:g(u)&&t(m)?1:0}function a(u,m,f=!1){return f||(u=u&&u.toLowerCase(),m=m&&m.toLowerCase()),u===m?0:u<m?-1:1}function b(u,m,f=!1){const n=u.split(R.sep),C=m.split(R.sep),M=n.length-1,H=C.length-1;let V,U;for(let z=0;;z++){if(V=M===z,U=H===z,V&&U)return P(n[z],C[z],f);if(V)return-1;if(U)return 1;const G=a(n[z],C[z],f);if(G!==0)return G}}e.comparePaths=b;function S(u,m,f){const n=u.toLowerCase(),C=m.toLowerCase(),M=c(u,m,f);if(M)return M;const H=n.endsWith(f),V=C.endsWith(f);if(H!==V)return H?-1:1;const U=P(n,C);return U!==0?U:n.localeCompare(C)}e.compareAnything=S;function c(u,m,f){const n=u.toLowerCase(),C=m.toLowerCase(),M=n.startsWith(f),H=C.startsWith(f);if(M!==H)return M?-1:1;if(M&&H){if(n.length<C.length)return-1;if(n.length>C.length)return 1}return 0}e.compareByPrefix=c}),define(Ce[89],ke([1,0,15]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const R={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(O){const k=(0,o.extname)(O),E=R[k.toLowerCase()];return E!==void 0?E:A(O)}e.getMediaOrTextMime=L;function A(O){const k=(0,o.extname)(O);return l[k.toLowerCase()]}e.getMediaMime=A;function P(O){for(const k in l)if(l[k]===O)return k}e.getExtensionForMimeType=P;const D=/^(.+)\/(.+?)(;.+)?$/;function p(O,k){const E=D.exec(O);return E?`${E[1].toLowerCase()}/${E[2].toLowerCase()}${E[3]??""}`:k?void 0:O}e.normalizeMimeType=p}),define(Ce[110],ke([1,0,14]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var R;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(R||(e.Source=R={}));var l;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(l||(e.TerminateResponseCode=l={}));function L(P,...D){const p=D.reduce((E,T)=>(E[T]=!0,E),{}),O=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(E=>!p[E]).forEach(E=>{for(let T=0;T<O.length;T++)if(E.search(O[T])!==-1){delete P[E];break}})}e.sanitizeProcessEnvironment=L;function A(P){P&&(delete P.DEBUG,o.isMacintosh&&delete P.DYLD_LIBRARY_PATH,o.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(Ce[37],ke([1,0,14]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const R=o.globals.performance&&typeof o.globals.performance.now=="function";class l{static create(A=!0){return new l(A)}constructor(A){this.a=R&&A,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?o.globals.performance.now():Date.now()}}e.StopWatch=l}),define(Ce[3],ke([1,0,8,64,6,66,37]),function(ae,e,o,R,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,D=!1;var p;(function(S){S.None=()=>l.Disposable.None;function c(pe){if(D){const{onDidAddListener:Se}=pe,re=I.create();let ne=0;pe.onDidAddListener=()=>{++ne===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),re.print()),Se?.()}}}function u(pe,Se){return z(pe,()=>{},0,void 0,!0,void 0,Se)}S.defer=u;function m(pe){return(Se,re=null,ne)=>{let de=!1,ee;return ee=pe(ce=>{if(!de)return ee?ee.dispose():de=!0,Se.call(re,ce)},null,ne),de&&ee.dispose(),ee}}S.once=m;function f(pe,Se,re){return U((ne,de=null,ee)=>pe(ce=>ne.call(de,Se(ce)),null,ee),re)}S.map=f;function n(pe,Se,re){return U((ne,de=null,ee)=>pe(ce=>{Se(ce),ne.call(de,ce)},null,ee),re)}S.forEach=n;function C(pe,Se,re){return U((ne,de=null,ee)=>pe(ce=>Se(ce)&&ne.call(de,ce),null,ee),re)}S.filter=C;function M(pe){return pe}S.signal=M;function H(...pe){return(Se,re=null,ne)=>(0,l.combinedDisposable)(...pe.map(de=>de(ee=>Se.call(re,ee),null,ne)))}S.any=H;function V(pe,Se,re,ne){let de=re;return f(pe,ee=>(de=Se(de,ee),de),ne)}S.reduce=V;function U(pe,Se){let re;const ne={onWillAddFirstListener(){re=pe(de.fire,de)},onDidRemoveLastListener(){re?.dispose()}};Se||c(ne);const de=new i(ne);return Se?.add(de),de.event}function z(pe,Se,re=100,ne=!1,de=!1,ee,ce){let le,ue,N,q=0,J;const te={leakWarningThreshold:ee,onWillAddFirstListener(){le=pe(De=>{q++,ue=Se(ue,De),ne&&!N&&(ve.fire(ue),ue=void 0),J=()=>{const me=ue;ue=void 0,N=void 0,(!ne||q>1)&&ve.fire(me),q=0},typeof re=="number"?(clearTimeout(N),N=setTimeout(J,re)):N===void 0&&(N=0,queueMicrotask(J))})},onWillRemoveListener(){de&&q>0&&J?.()},onDidRemoveLastListener(){J=void 0,le.dispose()}};ce||c(te);const ve=new i(te);return ce?.add(ve),ve.event}S.debounce=z;function G(pe,Se=0,re){return S.debounce(pe,(ne,de)=>ne?(ne.push(de),ne):[de],Se,void 0,!0,void 0,re)}S.accumulate=G;function F(pe,Se=(ne,de)=>ne===de,re){let ne=!0,de;return C(pe,ee=>{const ce=ne||!Se(ee,de);return ne=!1,de=ee,ce},re)}S.latch=F;function $(pe,Se,re){return[S.filter(pe,Se,re),S.filter(pe,ne=>!Se(ne),re)]}S.split=$;function Y(pe,Se=!1,re=[]){let ne=re.slice(),de=pe(le=>{ne?ne.push(le):ce.fire(le)});const ee=()=>{ne?.forEach(le=>ce.fire(le)),ne=null},ce=new i({onWillAddFirstListener(){de||(de=pe(le=>ce.fire(le)))},onDidAddFirstListener(){ne&&(Se?setTimeout(ee):ee())},onDidRemoveLastListener(){de&&de.dispose(),de=null}});return ce.event}S.buffer=Y;class _{constructor(Se){this.event=Se,this.c=new l.DisposableStore}map(Se){return new _(f(this.event,Se,this.c))}forEach(Se){return new _(n(this.event,Se,this.c))}filter(Se){return new _(C(this.event,Se,this.c))}reduce(Se,re){return new _(V(this.event,Se,re,this.c))}latch(){return new _(F(this.event,void 0,this.c))}debounce(Se,re=100,ne=!1,de=!1,ee){return new _(z(this.event,Se,re,ne,de,ee,this.c))}on(Se,re,ne){return this.event(Se,re,ne)}once(Se,re,ne){return m(this.event)(Se,re,ne)}dispose(){this.c.dispose()}}function Q(pe){return new _(pe)}S.chain=Q;function ie(pe,Se,re=ne=>ne){const ne=(...le)=>ce.fire(re(...le)),de=()=>pe.on(Se,ne),ee=()=>pe.removeListener(Se,ne),ce=new i({onWillAddFirstListener:de,onDidRemoveLastListener:ee});return ce.event}S.fromNodeEventEmitter=ie;function oe(pe,Se,re=ne=>ne){const ne=(...le)=>ce.fire(re(...le)),de=()=>pe.addEventListener(Se,ne),ee=()=>pe.removeEventListener(Se,ne),ce=new i({onWillAddFirstListener:de,onDidRemoveLastListener:ee});return ce.event}S.fromDOMEventEmitter=oe;function Ee(pe){return new Promise(Se=>m(pe)(Se))}S.toPromise=Ee;function he(pe,Se){return Se(void 0),pe(re=>Se(re))}S.runAndSubscribe=he;function fe(pe,Se){let re=null;function ne(ee){re?.dispose(),re=new l.DisposableStore,Se(ee,re)}ne(void 0);const de=pe(ee=>ne(ee));return(0,l.toDisposable)(()=>{de.dispose(),re?.dispose()})}S.runAndSubscribeWithStore=fe;class x{constructor(Se,re){this._observable=Se,this.c=0,this.d=!1;const ne={onWillAddFirstListener:()=>{Se.addObserver(this)},onDidRemoveLastListener:()=>{Se.removeObserver(this)}};re||c(ne),this.emitter=new i(ne),re&&re.add(this.emitter)}beginUpdate(Se){this.c++}handlePossibleChange(Se){}handleChange(Se,re){this.d=!0}endUpdate(Se){this.c--,this.c===0&&(this._observable.reportChanges(),this.d&&(this.d=!1,this.emitter.fire(this._observable.get())))}}function B(pe,Se){return new x(pe,Se).emitter.event}S.fromObservable=B;function Z(pe){return Se=>{let re=0,ne=!1;const de={beginUpdate(){re++},endUpdate(){re--,re===0&&(pe.reportChanges(),ne&&(ne=!1,Se()))},handlePossibleChange(){},handleChange(){ne=!0}};return pe.addObserver(de),{dispose(){pe.removeObserver(de)}}}}S.fromObservableLight=Z})(p||(e.Event=p={}));class O{constructor(c){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${c}_${O.c++}`,O.all.add(this)}start(c){this.d=new A.StopWatch(!0),this.listenerCount=c}stop(){if(this.d){const c=this.d.elapsed();this.durations.push(c),this.elapsedOverall+=c,this.invocationCount+=1,this.d=void 0}}}e.EventProfiling=O,O.all=new Set,O.c=0;let k=-1;function E(S){const c=k;return k=S,{dispose(){k=c}}}e.setGlobalLeakWarningThreshold=E;class T{constructor(c,u=Math.random().toString(18).slice(2,5)){this.threshold=c,this.name=u,this.d=0}dispose(){this.c?.clear()}check(c,u){const m=this.threshold;if(m<=0||u<m)return;this.c||(this.c=new Map);const f=this.c.get(c.value)||0;if(this.c.set(c.value,f+1),this.d-=1,this.d<=0){this.d=m*.5;let n,C=0;for(const[M,H]of this.c)(!n||C<H)&&(n=M,C=H);console.warn(`[${this.name}] potential listener LEAK detected, having ${u} listeners already. MOST frequent listener (${C}):`),console.warn(n)}return()=>{const n=this.c.get(c.value)||0;this.c.set(c.value,n-1)}}}class I{static create(){return new I(new Error().stack??"")}constructor(c){this.value=c}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class v{constructor(c,u,m){this.callback=c,this.callbackThis=u,this.stack=m,this.subscription=new l.SafeDisposable}invoke(c){this.callback.call(this.callbackThis,c)}}class i{constructor(c){this.j=!1,this.d=c,this.f=k>0||this.d?.leakWarningThreshold?new T(this.d?.leakWarningThreshold??k):void 0,this.g=this.d?._profName?new O(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const c=Array.from(this.q);queueMicrotask(()=>{for(const u of c)u.subscription.isset()&&(u.subscription.unset(),u.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(c,u,m)=>{if(this.q||(this.q=new L.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const f=this.q.isEmpty();f&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let n,C;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(C=I.create(),n=this.f.check(C,this.q.size+1)),P&&(C=C??I.create());const M=new v(c,u,C),H=this.q.push(M);f&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,c,u);const V=M.subscription.set(()=>{n?.(),this.j||(this.d?.onWillRemoveListener?.(this),H(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return m instanceof l.DisposableStore?m.add(V):Array.isArray(m)&&m.push(V),V}),this.l}fire(c){if(this.q){this.m||(this.m=new h(this.d?.onListenerError));for(const u of this.q)this.m.push(this,u,c);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=i;class d{constructor(c=o.onUnexpectedError){this.d=c,this.c=new L.LinkedList}get size(){return this.c.size}push(c,u,m){this.c.push(new y(c,u,m))}clear(c){const u=new L.LinkedList;for(const m of this.c)m.emitter!==c&&u.push(m);this.c=u}deliver(){for(;this.c.size>0;){const c=this.c.shift();try{c.listener.invoke(c.event)}catch(u){this.d(u)}}}}e.EventDeliveryQueue=d;class h extends d{clear(c){this.c.clear()}}class y{constructor(c,u,m){this.emitter=c,this.listener=u,this.event=m}}class w extends i{async fireAsync(c,u,m){if(this.q){this.c||(this.c=new L.LinkedList);for(const f of this.q)this.c.push([f,c]);for(;this.c.size>0&&!u.isCancellationRequested;){const[f,n]=this.c.shift(),C=[],M={...n,token:u,waitUntil:H=>{if(Object.isFrozen(C))throw new Error("waitUntil can NOT be called asynchronous");m&&(H=m(H,f.callback)),C.push(H)}};try{f.invoke(M)}catch(H){(0,o.onUnexpectedError)(H);continue}Object.freeze(C),await Promise.allSettled(C).then(H=>{for(const V of H)V.status==="rejected"&&(0,o.onUnexpectedError)(V.reason)})}}}}e.AsyncEmitter=w;class g extends i{constructor(c){super(c),this.h=0,this.s=new L.LinkedList,this.t=c?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const c=Array.from(this.s);this.s.clear(),super.fire(this.t(c))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(c){this.q&&(this.h!==0?this.s.push(c):super.fire(c))}}e.PauseableEmitter=g;class t extends g{constructor(c){super(c),this.c=c.delay??100}fire(c){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(c)}}e.DebounceEmitter=t;class s extends i{constructor(c){super(c),this.c=[],this.h=c?.merge}fire(c){this.hasListeners()&&(this.c.push(c),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(u=>super.fire(u)),this.c=[]}))}}e.MicrotaskEmitter=s;class r{constructor(){this.d=!1,this.f=[],this.c=new i({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(c){const u={event:c,listener:null};this.f.push(u),this.d&&this.j(u);const m=()=>{this.d&&this.k(u);const f=this.f.indexOf(u);this.f.splice(f,1)};return(0,l.toDisposable)((0,R.once)(m))}g(){this.d=!0,this.f.forEach(c=>this.j(c))}h(){this.d=!1,this.f.forEach(c=>this.k(c))}j(c){c.listener=c.event(u=>this.c.fire(u))}k(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class a{constructor(){this.c=[]}wrapEvent(c){return(u,m,f)=>c(n=>{const C=this.c[this.c.length-1];C?C.push(()=>u.call(m,n)):u.call(m,n)},void 0,f)}bufferEvents(c){const u=[];this.c.push(u);const m=c();return this.c.pop(),u.forEach(f=>f()),m}}e.EventBufferer=a;class b{constructor(){this.c=!1,this.d=p.None,this.f=l.Disposable.None,this.g=new i({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(c){this.d=c,this.c&&(this.f.dispose(),this.f=c(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=b}),define(Ce[164],ke([1,0,3,6,159]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class L extends R.Disposable{constructor(E,T="",I="",v=!0,i){super(),this.h=this.B(new o.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=E,this.m=T,this.u=I,this.w=v,this.C=i}get id(){return this.j}get label(){return this.m}set label(E){this.D(E)}D(E){this.m!==E&&(this.m=E,this.h.fire({label:E}))}get tooltip(){return this.n||""}set tooltip(E){this.F(E)}F(E){this.n!==E&&(this.n=E,this.h.fire({tooltip:E}))}get class(){return this.u}set class(E){this.G(E)}G(E){this.u!==E&&(this.u=E,this.h.fire({class:E}))}get enabled(){return this.w}set enabled(E){this.H(E)}H(E){this.w!==E&&(this.w=E,this.h.fire({enabled:E}))}get checked(){return this.z}set checked(E){this.I(E)}I(E){this.z!==E&&(this.z=E,this.h.fire({checked:E}))}async run(E,T){this.C&&await this.C(E)}}e.Action=L;class A extends R.Disposable{constructor(){super(...arguments),this.f=this.B(new o.Emitter),this.onWillRun=this.f.event,this.h=this.B(new o.Emitter),this.onDidRun=this.h.event}async run(E,T){if(!E.enabled)return;this.f.fire({action:E});let I;try{await this.k(E,T)}catch(v){I=v}this.h.fire({action:E,error:I})}async k(E,T){await E.run(T)}}e.ActionRunner=A;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...E){let T=[];for(const I of E)I.length&&(T.length?T=[...T,new P,...I]:T=I);return T}async run(){}}e.Separator=P,P.ID="vs.actions.separator";class D{get actions(){return this.a}constructor(E,T,I,v){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=E,this.label=T,this.class=v,this.a=I}async run(){}}e.SubmenuAction=D;class p extends L{constructor(){super(p.ID,l.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=p,p.ID="vs.actions.empty";function O(k){return{id:k.id,label:k.label,class:void 0,enabled:k.enabled??!0,checked:k.checked??!1,run:async()=>k.run(),tooltip:k.label}}e.toAction=O}),define(Ce[21],ke([1,0,3]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const R=Object.freeze(function(P,D){const p=setTimeout(P.bind(D),0);return{dispose(){clearTimeout(p)}}});var l;(function(P){function D(p){return p===P.None||p===P.Cancelled||p instanceof L?!0:!p||typeof p!="object"?!1:typeof p.isCancellationRequested=="boolean"&&typeof p.onCancellationRequested=="function"}P.isCancellationToken=D,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:o.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:R})})(l||(e.CancellationToken=l={}));class L{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?R:(this.b||(this.b=new o.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class A{constructor(D){this.a=void 0,this.b=void 0,this.b=D&&D.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new L),this.a}cancel(){this.a?this.a instanceof L&&this.a.cancel():this.a=l.Cancelled}dispose(D=!1){D&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof L&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=A}),define(Ce[165],ke([1,0,21]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class R{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new o.CancellationTokenSource,D=this.b(P.token);return this.a={promise:D,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=R;class l{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const D=JSON.stringify(P);return this.b!==D&&(this.b=D,this.a=this.c(P)),this.a}}e.LRUCachedFunction=l;class L{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const D=this.b(P);return this.a.set(P,D),D}}e.CachedFunction=L}),define(Ce[9],ke([1,0,165,65]),function(ae,e,o,R){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(W){return!W||typeof W!="string"?!0:W.trim().length===0}e.isFalsyOrWhitespace=L;const A=/{(\d+)}/g;function P(W,...X){return X.length===0?W:W.replace(A,function(ge,Re){const Me=parseInt(Re,10);return isNaN(Me)||Me<0||Me>=X.length?ge:X[Me]})}e.format=P;const D=/{([^}]+)}/g;function p(W,X){return W.replace(D,(ge,Re)=>X[Re]??ge)}e.format2=p;function O(W){return W.replace(/[<>&]/g,function(X){switch(X){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return X}})}e.escape=O;function k(W){return W.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=k;function E(W,X){let ge=0;const Re=X.charCodeAt(0);for(let Me=W.length-1;Me>=0;Me--)W.charCodeAt(Me)===Re&&ge++;return ge}e.count=E;function T(W,X,ge="\u2026"){return W.length<=X?W:`${W.substr(0,X)}${ge}`}e.truncate=T;function I(W,X=" "){const ge=v(W,X);return i(ge,X)}e.trim=I;function v(W,X){if(!W||!X)return W;const ge=X.length;if(ge===0||W.length===0)return W;let Re=0;for(;W.indexOf(X,Re)===Re;)Re=Re+ge;return W.substring(Re)}e.ltrim=v;function i(W,X){if(!W||!X)return W;const ge=X.length,Re=W.length;if(ge===0||Re===0)return W;let Me=Re,Ge=-1;for(;Ge=W.lastIndexOf(X,Me-1),!(Ge===-1||Ge+ge!==Me);){if(Ge===0)return"";Me=Ge}return W.substring(0,Me)}e.rtrim=i;function d(W){return W.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function h(W){return W.replace(/\*/g,"")}e.stripWildcards=h;function y(W,X,ge={}){if(!W)throw new Error("Cannot create regex from empty string");X||(W=k(W)),ge.wholeWord&&(/\B/.test(W.charAt(0))||(W="\\b"+W),/\B/.test(W.charAt(W.length-1))||(W=W+"\\b"));let Re="";return ge.global&&(Re+="g"),ge.matchCase||(Re+="i"),ge.multiline&&(Re+="m"),ge.unicode&&(Re+="u"),new RegExp(W,Re)}e.createRegExp=y;function w(W){return W.source==="^"||W.source==="^$"||W.source==="$"||W.source==="^\\s*$"?!1:!!(W.exec("")&&W.lastIndex===0)}e.regExpLeadsToEndlessLoop=w;function g(W){return!!W.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function t(W){return(W.global?"g":"")+(W.ignoreCase?"i":"")+(W.multiline?"m":"")+(W.unicode?"u":"")}e.regExpFlags=t;function s(W){return W.split(/\r\n|\r|\n/)}e.splitLines=s;function r(W){for(let X=0,ge=W.length;X<ge;X++){const Re=W.charCodeAt(X);if(Re!==32&&Re!==9)return X}return-1}e.firstNonWhitespaceIndex=r;function a(W,X=0,ge=W.length){for(let Re=X;Re<ge;Re++){const Me=W.charCodeAt(Re);if(Me!==32&&Me!==9)return W.substring(X,Re)}return W.substring(X,ge)}e.getLeadingWhitespace=a;function b(W,X=W.length-1){for(let ge=X;ge>=0;ge--){const Re=W.charCodeAt(ge);if(Re!==32&&Re!==9)return ge}return-1}e.lastNonWhitespaceIndex=b;function S(W,X,ge){const Re=[];let Me=0;for(const Ge of W.matchAll(X)){if(Re.push(W.slice(Me,Ge.index)),Ge.index===void 0)throw new Error("match.index should be defined");Me=Ge.index+Ge[0].length,Re.push(ge(Ge[0],...Ge.slice(1),Ge.index,W,Ge.groups))}return Re.push(W.slice(Me)),Promise.all(Re).then(Ge=>Ge.join(""))}e.replaceAsync=S;function c(W,X){return W<X?-1:W>X?1:0}e.compare=c;function u(W,X,ge=0,Re=W.length,Me=0,Ge=X.length){for(;ge<Re&&Me<Ge;ge++,Me++){const pt=W.charCodeAt(ge),at=X.charCodeAt(Me);if(pt<at)return-1;if(pt>at)return 1}const je=Re-ge,tt=Ge-Me;return je<tt?-1:je>tt?1:0}e.compareSubstring=u;function m(W,X){return f(W,X,0,W.length,0,X.length)}e.compareIgnoreCase=m;function f(W,X,ge=0,Re=W.length,Me=0,Ge=X.length){for(;ge<Re&&Me<Ge;ge++,Me++){let pt=W.charCodeAt(ge),at=X.charCodeAt(Me);if(pt===at)continue;if(pt>=128||at>=128)return u(W.toLowerCase(),X.toLowerCase(),ge,Re,Me,Ge);C(pt)&&(pt-=32),C(at)&&(at-=32);const bt=pt-at;if(bt!==0)return bt}const je=Re-ge,tt=Ge-Me;return je<tt?-1:je>tt?1:0}e.compareSubstringIgnoreCase=f;function n(W){return W>=48&&W<=57}e.isAsciiDigit=n;function C(W){return W>=97&&W<=122}e.isLowerAsciiLetter=C;function M(W){return W>=65&&W<=90}e.isUpperAsciiLetter=M;function H(W,X){return W.length===X.length&&f(W,X)===0}e.equalsIgnoreCase=H;function V(W,X){const ge=X.length;return X.length>W.length?!1:f(W,X,0,ge)===0}e.startsWithIgnoreCase=V;function U(W,X){const ge=Math.min(W.length,X.length);let Re;for(Re=0;Re<ge;Re++)if(W.charCodeAt(Re)!==X.charCodeAt(Re))return Re;return ge}e.commonPrefixLength=U;function z(W,X){const ge=Math.min(W.length,X.length);let Re;const Me=W.length-1,Ge=X.length-1;for(Re=0;Re<ge;Re++)if(W.charCodeAt(Me-Re)!==X.charCodeAt(Ge-Re))return Re;return ge}e.commonSuffixLength=z;function G(W){return 55296<=W&&W<=56319}e.isHighSurrogate=G;function F(W){return 56320<=W&&W<=57343}e.isLowSurrogate=F;function $(W,X){return(W-55296<<10)+(X-56320)+65536}e.computeCodePoint=$;function Y(W,X,ge){const Re=W.charCodeAt(ge);if(G(Re)&&ge+1<X){const Me=W.charCodeAt(ge+1);if(F(Me))return $(Re,Me)}return Re}e.getNextCodePoint=Y;function _(W,X){const ge=W.charCodeAt(X-1);if(F(ge)&&X>1){const Re=W.charCodeAt(X-2);if(G(Re))return $(Re,ge)}return ge}class Q{get offset(){return this.e}constructor(X,ge=0){this.c=X,this.d=X.length,this.e=ge}setOffset(X){this.e=X}prevCodePoint(){const X=_(this.c,this.e);return this.e-=X>=65536?2:1,X}nextCodePoint(){const X=Y(this.c,this.d,this.e);return this.e+=X>=65536?2:1,X}eol(){return this.e>=this.d}}e.CodePointIterator=Q;class ie{get offset(){return this.c.offset}constructor(X,ge=0){this.c=new Q(X,ge)}nextGraphemeLength(){const X=Ve.getInstance(),ge=this.c,Re=ge.offset;let Me=X.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ge=ge.offset,je=X.getGraphemeBreakType(ge.nextCodePoint());if(Pe(Me,je)){ge.setOffset(Ge);break}Me=je}return ge.offset-Re}prevGraphemeLength(){const X=Ve.getInstance(),ge=this.c,Re=ge.offset;let Me=X.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ge=ge.offset,je=X.getGraphemeBreakType(ge.prevCodePoint());if(Pe(je,Me)){ge.setOffset(Ge);break}Me=je}return Re-ge.offset}eol(){return this.c.eol()}}e.GraphemeIterator=ie;function oe(W,X){return new ie(W,X).nextGraphemeLength()}e.nextCharLength=oe;function Ee(W,X){return new ie(W,X).prevGraphemeLength()}e.prevCharLength=Ee;function he(W,X){X>0&&F(W.charCodeAt(X))&&X--;const ge=X+oe(W,X);return[ge-Ee(W,ge),ge]}e.getCharContainingOffset=he;function fe(W){const X=new ie(W);let ge=0;for(;!X.eol();)ge++,X.nextGraphemeLength();return ge}e.charCount=fe;let x;function B(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function Z(W){return x||(x=B()),x.test(W)}e.containsRTL=Z;const pe=/^[\t\n\r\x20-\x7E]*$/;function Se(W){return pe.test(W)}e.isBasicASCII=Se,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function re(W){return e.UNUSUAL_LINE_TERMINATORS.test(W)}e.containsUnusualLineTerminators=re;function ne(W){return W>=11904&&W<=55215||W>=63744&&W<=64255||W>=65281&&W<=65374}e.isFullWidthCharacter=ne;function de(W){return W>=127462&&W<=127487||W===8986||W===8987||W===9200||W===9203||W>=9728&&W<=10175||W===11088||W===11093||W>=127744&&W<=128591||W>=128640&&W<=128764||W>=128992&&W<=129008||W>=129280&&W<=129535||W>=129648&&W<=129782}e.isEmojiImprecise=de;function ee(W,X){if(W.length<X)return W;const ge=/\b/g;let Re=0;for(;ge.test(W)&&!(W.length-ge.lastIndex<X);)Re=ge.lastIndex,ge.lastIndex+=1;return W.substring(Re).replace(/^\s/,"")}e.lcut=ee;const ce=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g,le=/\x1b\].*?\x07/g;function ue(W){return W&&(W=W.replace(ce,"").replace(le,"")),W}e.removeAnsiEscapeCodes=ue,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function N(W){return!!(W&&W.length>0&&W.charCodeAt(0)===65279)}e.startsWithUTF8BOM=N;function q(W){return N(W)?W.substr(1):W}e.stripUTF8BOM=q;function J(W,X){if(!W||!X||W.length<X.length)return!1;const ge=X.length,Re=W.toLowerCase();let Me=0,Ge=-1;for(;Me<ge;){const je=Re.indexOf(X[Me],Ge+1);if(je<0)return!1;Ge=je,Me++}return!0}e.fuzzyContains=J;function te(W,X=!1){return W?(X&&(W=W.replace(/\\./g,"")),W.toLowerCase()!==W):!1}e.containsUppercaseCharacter=te;function ve(W){return W.charAt(0).toUpperCase()+W.slice(1)}e.uppercaseFirstLetter=ve;function De(W,X=1){if(X===0)return"";let ge=-1;do ge=W.indexOf(`
`,ge+1),X--;while(X>0&&ge>=0);return ge===-1?W:(W[ge-1]==="\r"&&ge--,W.substr(0,ge))}e.getNLines=De;function me(W){return W=W%(2*26),W<26?String.fromCharCode(97+W):String.fromCharCode(65+W-26)}e.singleLetterHash=me;function Te(W){return Ve.getInstance().getGraphemeBreakType(W)}e.getGraphemeBreakType=Te;function Pe(W,X){return W===0?X!==5&&X!==7:W===2&&X===3?!1:W===4||W===2||W===3||X===4||X===2||X===3?!0:!(W===8&&(X===8||X===9||X===11||X===12)||(W===11||W===9)&&(X===9||X===10)||(W===12||W===10)&&X===10||X===5||X===13||X===7||W===1||W===13&&X===14||W===6&&X===6)}var $e;(function(W){W[W.Other=0]="Other",W[W.Prepend=1]="Prepend",W[W.CR=2]="CR",W[W.LF=3]="LF",W[W.Control=4]="Control",W[W.Extend=5]="Extend",W[W.Regional_Indicator=6]="Regional_Indicator",W[W.SpacingMark=7]="SpacingMark",W[W.L=8]="L",W[W.V=9]="V",W[W.T=10]="T",W[W.LV=11]="LV",W[W.LVT=12]="LVT",W[W.ZWJ=13]="ZWJ",W[W.Extended_Pictographic=14]="Extended_Pictographic"})($e||(e.GraphemeBreakType=$e={}));class Ve{static getInstance(){return Ve.c||(Ve.c=new Ve),Ve.c}constructor(){this.d=et()}getGraphemeBreakType(X){if(X<32)return X===10?3:X===13?2:4;if(X<127)return 0;const ge=this.d,Re=ge.length/3;let Me=1;for(;Me<=Re;)if(X<ge[3*Me])Me=2*Me;else if(X>ge[3*Me+1])Me=2*Me+1;else return ge[3*Me+2];return 0}}Ve.c=null;function et(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ye(W,X){if(W===0)return 0;const ge=Je(W,X);if(ge!==void 0)return ge;const Re=new Q(X,W);return Re.prevCodePoint(),Re.offset}e.getLeftDeleteOffset=Ye;function Je(W,X){const ge=new Q(X,W);let Re=ge.prevCodePoint();for(;nt(Re)||Re===65039||Re===8419;){if(ge.offset===0)return;Re=ge.prevCodePoint()}if(!de(Re))return;let Me=ge.offset;return Me>0&&ge.prevCodePoint()===8205&&(Me=ge.offset),Me}function nt(W){return 127995<=W&&W<=127999}var ct;(function(W){W[W.zwj=8205]="zwj",W[W.emojiVariantSelector=65039]="emojiVariantSelector",W[W.enclosingKeyCap=8419]="enclosingKeyCap"})(ct||(ct={})),e.noBreakWhitespace="\xA0";class Fe{static getInstance(X){return Fe.d.get(Array.from(X))}static getLocales(){return Fe.e.value}constructor(X){this.f=X}isAmbiguous(X){return this.f.has(X)}getPrimaryConfusable(X){return this.f.get(X)}getConfusableCodePoints(){return new Set(this.f.keys())}}e.AmbiguousCharacters=Fe,l=Fe,Fe.c=new R.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125,119846,109],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Fe.d=new o.LRUCachedFunction(W=>{function X(at){const bt=new Map;for(let Dt=0;Dt<at.length;Dt+=2)bt.set(at[Dt],at[Dt+1]);return bt}function ge(at,bt){const Dt=new Map(at);for(const[St,At]of bt)Dt.set(St,At);return Dt}function Re(at,bt){if(!at)return bt;const Dt=new Map;for(const[St,At]of at)bt.has(St)&&Dt.set(St,At);return Dt}const Me=l.c.value;let Ge=W.filter(at=>!at.startsWith("_")&&at in Me);Ge.length===0&&(Ge=["_default"]);let je;for(const at of Ge){const bt=X(Me[at]);je=Re(je,bt)}const tt=X(Me._common),pt=ge(tt,je);return new Fe(pt)}),Fe.e=new R.Lazy(()=>Object.keys(Fe.c.value).filter(W=>!W.startsWith("_")));class it{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(it.c())),this.d}static isInvisibleCharacter(X){return it.e().has(X)}static get codePoints(){return it.e()}}e.InvisibleCharacters=it,it.d=void 0}),define(Ce[33],ke([1,0,15,14,9,10]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(S){return S===47||S===92}e.isPathSeparator=A;function P(S){return S.replace(/[\\/]/g,o.posix.sep)}e.toSlashes=P;function D(S){return S.indexOf("/")===-1&&(S=P(S)),/^[a-zA-Z]:(\/|$)/.test(S)&&(S="/"+S),S}e.toPosixPath=D;function p(S,c=o.posix.sep){if(!S)return"";const u=S.length,m=S.charCodeAt(0);if(A(m)){if(A(S.charCodeAt(1))&&!A(S.charCodeAt(2))){let n=3;const C=n;for(;n<u&&!A(S.charCodeAt(n));n++);if(C!==n&&!A(S.charCodeAt(n+1))){for(n+=1;n<u;n++)if(A(S.charCodeAt(n)))return S.slice(0,n+1).replace(/[\\/]/g,c)}}return c}else if(d(m)&&S.charCodeAt(1)===58)return A(S.charCodeAt(2))?S.slice(0,2)+c:S.slice(0,2);let f=S.indexOf("://");if(f!==-1){for(f+=3;f<u;f++)if(A(S.charCodeAt(f)))return S.slice(0,f+1)}return""}e.getRoot=p;function O(S){if(!R.isWindows||!S||S.length<5)return!1;let c=S.charCodeAt(0);if(c!==92||(c=S.charCodeAt(1),c!==92))return!1;let u=2;const m=u;for(;u<S.length&&(c=S.charCodeAt(u),c!==92);u++);return!(m===u||(c=S.charCodeAt(u+1),isNaN(c)||c===92))}e.isUNC=O;const k=/[\\/:\*\?"<>\|]/g,E=/[\\/]/g,T=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function I(S,c=R.isWindows){const u=c?k:E;return!(!S||S.length===0||/^\s+$/.test(S)||(u.lastIndex=0,u.test(S))||c&&T.test(S)||S==="."||S===".."||c&&S[S.length-1]==="."||c&&S.length!==S.trim().length||S.length>255)}e.isValidBasename=I;function v(S,c,u){const m=S===c;return!u||m?m:!S||!c?!1:(0,l.equalsIgnoreCase)(S,c)}e.isEqual=v;function i(S,c,u,m=o.sep){if(S===c)return!0;if(!S||!c||c.length>S.length)return!1;if(u){if(!(0,l.startsWithIgnoreCase)(S,c))return!1;if(c.length===S.length)return!0;let n=c.length;return c.charAt(c.length-1)===m&&n--,S.charAt(n)===m}return c.charAt(c.length-1)!==m&&(c+=m),S.indexOf(c)===0}e.isEqualOrParent=i;function d(S){return S>=65&&S<=90||S>=97&&S<=122}e.isWindowsDriveLetter=d;function h(S,c){return R.isWindows&&S.endsWith(":")&&(S+=o.sep),(0,o.isAbsolute)(S)||(S=(0,o.join)(c,S)),S=(0,o.normalize)(S),R.isWindows?(S=(0,l.rtrim)(S,o.sep),S.endsWith(":")&&(S+=o.sep)):(S=(0,l.rtrim)(S,o.sep),S||(S=o.sep)),S}e.sanitizeFilePath=h;function y(S){const c=(0,o.normalize)(S);return R.isWindows?S.length>3?!1:w(c)&&(S.length===2||c.charCodeAt(2)===92):c===o.posix.sep}e.isRootOrDriveLetter=y;function w(S,c=R.isWindows){return c?d(S.charCodeAt(0))&&S.charCodeAt(1)===58:!1}e.hasDriveLetter=w;function g(S){return w(S)?S[0]:void 0}e.getDriveLetter=g;function t(S,c,u){return c.length>S.length?-1:S===c?0:(u&&(S=S.toLowerCase(),c=c.toLowerCase()),S.indexOf(c))}e.indexOfPath=t;function s(S){const c=S.split(":");let u,m,f;for(const n of c){const C=Number(n);(0,L.isNumber)(C)?m===void 0?m=C:f===void 0&&(f=C):u=u?[u,n].join(":"):n}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:m!==void 0?m:void 0,column:f!==void 0?f:m!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",a="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function b(S,c,u=8){let m="";for(let n=0;n<u;n++){let C;n===0&&R.isWindows&&!c&&(u===3||u===4)?C=a:C=r,m+=C.charAt(Math.floor(Math.random()*C.length))}let f;return c?f=`${c}-${m}`:f=m,S?(0,o.join)(S,f):f}e.randomPath=b}),define(Ce[111],ke([1,0,28,9]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function l(...le){return function(ue,N){for(let q=0,J=le.length;q<J;q++){const te=le[q](ue,N);if(te)return te}return null}}e.or=l,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(le,ue,N){if(!N||N.length<ue.length)return null;let q;return le?q=R.startsWithIgnoreCase(N,ue):q=N.indexOf(ue)===0,q?ue.length>0?[{start:0,end:ue.length}]:[]:null}function A(le,ue){const N=ue.toLowerCase().indexOf(le.toLowerCase());return N===-1?null:[{start:N,end:N+le.length}]}e.matchesContiguousSubString=A;function P(le,ue){return D(le.toLowerCase(),ue.toLowerCase(),0,0)}e.matchesSubString=P;function D(le,ue,N,q){if(N===le.length)return[];if(q===ue.length)return null;if(le[N]===ue[q]){let J=null;return(J=D(le,ue,N+1,q+1))?d({start:q,end:q+1},J):null}return D(le,ue,N,q+1)}function p(le){return 97<=le&&le<=122}function O(le){return 65<=le&&le<=90}e.isUpper=O;function k(le){return 48<=le&&le<=57}function E(le){return le===32||le===9||le===10||le===13}const T=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(le=>T.add(le.charCodeAt(0)));function I(le){return E(le)||T.has(le)}function v(le,ue){return le===ue||I(le)&&I(ue)}function i(le){return p(le)||O(le)||k(le)}function d(le,ue){return ue.length===0?ue=[le]:le.end===ue[0].start?ue[0].start=le.start:ue.unshift(le),ue}function h(le,ue){for(let N=ue;N<le.length;N++){const q=le.charCodeAt(N);if(O(q)||k(q)||N>0&&!i(le.charCodeAt(N-1)))return N}return le.length}function y(le,ue,N,q){if(N===le.length)return[];if(q===ue.length)return null;if(le[N]!==ue[q].toLowerCase())return null;{let J=null,te=q+1;for(J=y(le,ue,N+1,q+1);!J&&(te=h(ue,te))<ue.length;)J=y(le,ue,N+1,te),te++;return J===null?null:d({start:q,end:q+1},J)}}function w(le){let ue=0,N=0,q=0,J=0,te=0;for(let Pe=0;Pe<le.length;Pe++)te=le.charCodeAt(Pe),O(te)&&ue++,p(te)&&N++,i(te)&&q++,k(te)&&J++;const ve=ue/le.length,De=N/le.length,me=q/le.length,Te=J/le.length;return{upperPercent:ve,lowerPercent:De,alphaPercent:me,numericPercent:Te}}function g(le){const{upperPercent:ue,lowerPercent:N}=le;return N===0&&ue>.6}function t(le){const{upperPercent:ue,lowerPercent:N,alphaPercent:q,numericPercent:J}=le;return N>.2&&ue<.8&&q>.6&&J<.2}function s(le){let ue=0,N=0,q=0,J=0;for(let te=0;te<le.length;te++)q=le.charCodeAt(te),O(q)&&ue++,p(q)&&N++,E(q)&&J++;return(ue===0||N===0)&&J===0?le.length<=30:ue<=5}function r(le,ue){if(!ue||(ue=ue.trim(),ue.length===0)||!s(le)||ue.length>60)return null;const N=w(ue);if(!t(N)){if(!g(N))return null;ue=ue.toLowerCase()}let q=null,J=0;for(le=le.toLowerCase();J<ue.length&&(q=y(le,ue,0,J))===null;)J=h(ue,J+1);return q}e.matchesCamelCase=r;function a(le,ue,N=!1){if(!ue||ue.length===0)return null;let q=null,J=0;for(le=le.toLowerCase(),ue=ue.toLowerCase();J<ue.length&&(q=b(le,ue,0,J,N))===null;)J=S(ue,J+1);return q}e.matchesWords=a;function b(le,ue,N,q,J){if(N===le.length)return[];if(q===ue.length)return null;if(v(le.charCodeAt(N),ue.charCodeAt(q))){let te=null,ve=q+1;if(te=b(le,ue,N+1,q+1,J),!J)for(;!te&&(ve=S(ue,ve))<ue.length;)te=b(le,ue,N+1,ve,J),ve++;return te?le.charCodeAt(N)!==ue.charCodeAt(q)?te:d({start:q,end:q+1},te):null}else return null}function S(le,ue){for(let N=ue;N<le.length;N++)if(I(le.charCodeAt(N))||N>0&&I(le.charCodeAt(N-1)))return N;return le.length}const c=l(e.matchesPrefix,r,A),u=l(e.matchesPrefix,r,P),m=new o.LRUCache(1e4);function f(le,ue,N=!1){if(typeof le!="string"||typeof ue!="string")return null;let q=m.get(le);q||(q=new RegExp(R.convertSimple2RegExpPattern(le),"i"),m.set(le,q));const J=q.exec(ue);return J?[{start:J.index,end:J.index+J[0].length}]:N?u(le,ue):c(le,ue)}e.matchesFuzzy=f;function n(le,ue){const N=pe(le,le.toLowerCase(),0,ue,ue.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return N?M(N):null}e.matchesFuzzy2=n;function C(le,ue,N,q,J,te){const ve=Math.min(13,le.length);for(;N<ve;N++){const De=pe(le,ue,N,q,J,te,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(De)return De}return[0,te]}e.anyScore=C;function M(le){if(typeof le>"u")return[];const ue=[],N=le[1];for(let q=le.length-1;q>1;q--){const J=le[q]+N,te=ue[ue.length-1];te&&te.end===J?te.end=J+1:ue.push({start:J,end:J+1})}return ue}e.createMatches=M;const H=128;function V(){const le=[],ue=[];for(let N=0;N<=H;N++)ue[N]=0;for(let N=0;N<=H;N++)le.push(ue.slice(0));return le}function U(le){const ue=[];for(let N=0;N<=le;N++)ue[N]=0;return ue}const z=U(2*H),G=U(2*H),F=V(),$=V(),Y=V(),_=!1;function Q(le,ue,N,q,J){function te(De,me,Te=" "){for(;De.length<me;)De=Te+De;return De}let ve=` |   |${q.split("").map(De=>te(De,3)).join("|")}
`;for(let De=0;De<=N;De++)De===0?ve+=" |":ve+=`${ue[De-1]}|`,ve+=le[De].slice(0,J+1).map(me=>te(me.toString(),3)).join("|")+`
`;return ve}function ie(le,ue,N,q){le=le.substr(ue),N=N.substr(q),console.log(Q($,le,le.length,N,N.length)),console.log(Q(Y,le,le.length,N,N.length)),console.log(Q(F,le,le.length,N,N.length))}function oe(le,ue){if(ue<0||ue>=le.length)return!1;const N=le.codePointAt(ue);switch(N){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!R.isEmojiImprecise(N)}}function Ee(le,ue){if(ue<0||ue>=le.length)return!1;switch(le.charCodeAt(ue)){case 32:case 9:return!0;default:return!1}}function he(le,ue,N){return ue[le]!==N[le]}function fe(le,ue,N,q,J,te,ve=!1){for(;ue<N&&J<te;)le[ue]===q[J]&&(ve&&(z[ue]=J),ue+=1),J+=1;return ue===N}e.isPatternInWord=fe;var x;(function(le){le[le.Diag=1]="Diag",le[le.Left=2]="Left",le[le.LeftLeft=3]="LeftLeft"})(x||(x={}));var B;(function(le){le.Default=[-100,0];function ue(N){return!N||N.length===2&&N[0]===-100&&N[1]===0}le.isDefault=ue})(B||(e.FuzzyScore=B={}));class Z{constructor(ue,N){this.firstMatchCanBeWeak=ue,this.boostFullMatch=N}}e.FuzzyScoreOptions=Z,Z.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function pe(le,ue,N,q,J,te,ve=Z.default){const De=le.length>H?H:le.length,me=q.length>H?H:q.length;if(N>=De||te>=me||De-N>me-te||!fe(ue,N,De,J,te,me,!0))return;Se(De,me,N,te,ue,J);let Te=1,Pe=1,$e=N,Ve=te;const et=[!1];for(Te=1,$e=N;$e<De;Te++,$e++){const Fe=z[$e],it=G[$e],W=$e+1<De?G[$e+1]:me;for(Pe=Fe-te+1,Ve=Fe;Ve<W;Pe++,Ve++){let X=Number.MIN_SAFE_INTEGER,ge=!1;Ve<=it&&(X=re(le,ue,$e,N,q,J,Ve,me,te,F[Te-1][Pe-1]===0,et));let Re=0;X!==Number.MAX_SAFE_INTEGER&&(ge=!0,Re=X+$[Te-1][Pe-1]);const Me=Ve>Fe,Ge=Me?$[Te][Pe-1]+(F[Te][Pe-1]>0?-5:0):0,je=Ve>Fe+1&&F[Te][Pe-1]>0,tt=je?$[Te][Pe-2]+(F[Te][Pe-2]>0?-5:0):0;if(je&&(!Me||tt>=Ge)&&(!ge||tt>=Re))$[Te][Pe]=tt,Y[Te][Pe]=3,F[Te][Pe]=0;else if(Me&&(!ge||Ge>=Re))$[Te][Pe]=Ge,Y[Te][Pe]=2,F[Te][Pe]=0;else if(ge)$[Te][Pe]=Re,Y[Te][Pe]=1,F[Te][Pe]=F[Te-1][Pe-1]+1;else throw new Error("not possible")}}if(_&&ie(le,N,q,te),!et[0]&&!ve.firstMatchCanBeWeak)return;Te--,Pe--;const Ye=[$[Te][Pe],te];let Je=0,nt=0;for(;Te>=1;){let Fe=Pe;do{const it=Y[Te][Fe];if(it===3)Fe=Fe-2;else if(it===2)Fe=Fe-1;else break}while(Fe>=1);Je>1&&ue[N+Te-1]===J[te+Pe-1]&&!he(Fe+te-1,q,J)&&Je+1>F[Te][Fe]&&(Fe=Pe),Fe===Pe?Je++:Je=1,nt||(nt=Fe),Te--,Pe=Fe-1,Ye.push(Pe)}me===De&&ve.boostFullMatch&&(Ye[0]+=2);const ct=nt-De;return Ye[0]-=ct,Ye}e.fuzzyScore=pe;function Se(le,ue,N,q,J,te){let ve=le-1,De=ue-1;for(;ve>=N&&De>=q;)J[ve]===te[De]&&(G[ve]=De,ve--),De--}function re(le,ue,N,q,J,te,ve,De,me,Te,Pe){if(ue[N]!==te[ve])return Number.MIN_SAFE_INTEGER;let $e=1,Ve=!1;return ve===N-q?$e=le[N]===J[ve]?7:5:he(ve,J,te)&&(ve===0||!he(ve-1,J,te))?($e=le[N]===J[ve]?7:5,Ve=!0):oe(te,ve)&&(ve===0||!oe(te,ve-1))?$e=5:(oe(te,ve-1)||Ee(te,ve-1))&&($e=5,Ve=!0),$e>1&&N===q&&(Pe[0]=!0),Ve||(Ve=he(ve,J,te)||oe(te,ve-1)||Ee(te,ve-1)),N===q?ve>me&&($e-=Ve?3:5):Te?$e+=Ve?2:0:$e+=Ve?0:1,ve+1===De&&($e-=Ve?3:5),$e}function ne(le,ue,N,q,J,te,ve){return ee(le,ue,N,q,J,te,!0,ve)}e.fuzzyScoreGracefulAggressive=ne;function de(le,ue,N,q,J,te,ve){return ee(le,ue,N,q,J,te,!1,ve)}e.fuzzyScoreGraceful=de;function ee(le,ue,N,q,J,te,ve,De){let me=pe(le,ue,N,q,J,te,De);if(me&&!ve)return me;if(le.length>=3){const Te=Math.min(7,le.length-1);for(let Pe=N+1;Pe<Te;Pe++){const $e=ce(le,Pe);if($e){const Ve=pe($e,$e.toLowerCase(),N,q,J,te,De);Ve&&(Ve[0]-=3,(!me||Ve[0]>me[0])&&(me=Ve))}}}return me}function ce(le,ue){if(ue+1>=le.length)return;const N=le[ue],q=le[ue+1];if(N!==q)return le.slice(0,ue)+q+N+le.slice(ue+2)}}),define(Ce[68],ke([1,0,9]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function R(d){return l(d,0)}e.hash=R;function l(d,h){switch(typeof d){case"object":return d===null?L(349,h):Array.isArray(d)?D(d,h):p(d,h);case"string":return P(d,h);case"boolean":return A(d,h);case"number":return L(d,h);case"undefined":return L(937,h);default:return L(617,h)}}e.doHash=l;function L(d,h){return(h<<5)-h+d|0}e.numberHash=L;function A(d,h){return L(d?433:863,h)}function P(d,h){h=L(149417,h);for(let y=0,w=d.length;y<w;y++)h=L(d.charCodeAt(y),h);return h}e.stringHash=P;function D(d,h){return h=L(104579,h),d.reduce((y,w)=>l(w,y),h)}function p(d,h){return h=L(181387,h),Object.keys(d).sort().reduce((y,w)=>(y=P(w,y),l(d[w],y)),h)}class O{constructor(){this.g=0}get value(){return this.g}hash(h){return this.g=l(h,this.g),this.g}}e.Hasher=O;var k;(function(d){d[d.BLOCK_SIZE=64]="BLOCK_SIZE",d[d.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function E(d,h,y=32){const w=y-h,g=~((1<<w)-1);return(d<<h|(g&d)>>>w)>>>0}function T(d,h=0,y=d.byteLength,w=0){for(let g=0;g<y;g++)d[h+g]=w}function I(d,h,y="0"){for(;d.length<h;)d=y+d;return d}function v(d,h=32){return d instanceof ArrayBuffer?Array.from(new Uint8Array(d)).map(y=>y.toString(16).padStart(2,"0")).join(""):I((d>>>0).toString(16),h/4)}e.toHexString=v;class i{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(h){const y=h.length;if(y===0)return;const w=this.p;let g=this.r,t=this.u,s,r;for(t!==0?(s=t,r=-1,t=0):(s=h.charCodeAt(0),r=0);;){let a=s;if(o.isHighSurrogate(s))if(r+1<y){const b=h.charCodeAt(r+1);o.isLowSurrogate(b)?(r++,a=o.computeCodePoint(s,b)):a=65533}else{t=s;break}else o.isLowSurrogate(s)&&(a=65533);if(g=this.w(w,g,a),r++,r<y)s=h.charCodeAt(r);else break}this.r=g,this.u=t}w(h,y,w){return w<128?h[y++]=w:w<2048?(h[y++]=192|(w&1984)>>>6,h[y++]=128|(w&63)>>>0):w<65536?(h[y++]=224|(w&61440)>>>12,h[y++]=128|(w&4032)>>>6,h[y++]=128|(w&63)>>>0):(h[y++]=240|(w&1835008)>>>18,h[y++]=128|(w&258048)>>>12,h[y++]=128|(w&4032)>>>6,h[y++]=128|(w&63)>>>0),y>=64&&(this.y(),y-=64,this.t+=64,h[0]=h[64+0],h[1]=h[64+1],h[2]=h[64+2]),y}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),v(this.h)+v(this.l)+v(this.m)+v(this.n)+v(this.o)}x(){this.p[this.r++]=128,T(this.p,this.r),this.r>56&&(this.y(),T(this.p));const h=8*this.t;this.q.setUint32(56,Math.floor(h/4294967296),!1),this.q.setUint32(60,h%4294967296,!1),this.y()}y(){const h=i.g,y=this.q;for(let c=0;c<64;c+=4)h.setUint32(c,y.getUint32(c,!1),!1);for(let c=64;c<320;c+=4)h.setUint32(c,E(h.getUint32(c-12,!1)^h.getUint32(c-32,!1)^h.getUint32(c-56,!1)^h.getUint32(c-64,!1),1),!1);let w=this.h,g=this.l,t=this.m,s=this.n,r=this.o,a,b,S;for(let c=0;c<80;c++)c<20?(a=g&t|~g&s,b=1518500249):c<40?(a=g^t^s,b=1859775393):c<60?(a=g&t|g&s|t&s,b=2400959708):(a=g^t^s,b=3395469782),S=E(w,5)+a+r+b+h.getUint32(c*4,!1)&4294967295,r=s,s=t,t=E(g,30),g=w,w=S;this.h=this.h+w&4294967295,this.l=this.l+g&4294967295,this.m=this.m+t&4294967295,this.n=this.n+s&4294967295,this.o=this.o+r&4294967295}}e.StringSHA1=i,i.g=new DataView(new ArrayBuffer(320))}),define(Ce[112],ke([1,0,109,111,68,15,14,9]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const D=0,p=[D,[]];function O(F,$,Y,_){if(!F||!$)return p;const Q=F.length,ie=$.length;if(Q<ie)return p;const oe=F.toLowerCase();return k($,Y,ie,F,oe,Q,_)}e.scoreFuzzy=O;function k(F,$,Y,_,Q,ie,oe){const Ee=[],he=[];for(let Z=0;Z<Y;Z++){const pe=Z*ie,Se=pe-ie,re=Z>0,ne=F[Z],de=$[Z];for(let ee=0;ee<ie;ee++){const ce=ee>0,le=pe+ee,ue=le-1,N=Se+ee-1,q=ce?Ee[ue]:0,J=re&&ce?Ee[N]:0,te=re&&ce?he[N]:0;let ve;!J&&re?ve=0:ve=E(ne,de,_,Q,ee,te),ve&&J+ve>=q&&(oe||re||Q.startsWith($,ee))?(he[le]=te+1,Ee[le]=J+ve):(he[le]=D,Ee[le]=q)}}const fe=[];let x=Y-1,B=ie-1;for(;x>=0&&B>=0;){const Z=x*ie+B;he[Z]===D||(fe.push(B),x--),B--}return[Ee[Y*ie-1],fe.reverse()]}function E(F,$,Y,_,Q,ie){let oe=0;if(!T($,_[Q]))return oe;if(oe+=1,ie>0&&(oe+=ie*5),F===Y[Q]&&(oe+=1),Q===0)oe+=8;else{const Ee=I(Y.charCodeAt(Q-1));Ee?oe+=Ee:(0,R.isUpper)(Y.charCodeAt(Q))&&ie===0&&(oe+=2)}return oe}function T(F,$){return F===$?!0:F==="/"||F==="\\"?$==="/"||$==="\\":!1}function I(F){switch(F){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const v=[void 0,[]];function i(F,$,Y=0,_=0){const Q=$;return Q.values&&Q.values.length>1?d(F,Q.values,Y,_):h(F,$,Y,_)}e.scoreFuzzy2=i;function d(F,$,Y,_){let Q=0;const ie=[];for(const oe of $){const[Ee,he]=h(F,oe,Y,_);if(typeof Ee!="number")return v;Q+=Ee,ie.push(...he)}return[Q,u(ie)]}function h(F,$,Y,_){const Q=(0,R.fuzzyScore)($.original,$.originalLowercase,Y,F,F.toLowerCase(),_,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Q?[Q[0],(0,R.createMatches)(Q)]:v}const y=Object.freeze({score:0}),w=1<<18,g=1<<17,t=1<<16;function s(F,$,Y,_){const Q=_.values?_.values:[_];return(0,l.hash)({[_.normalized]:{values:Q.map(oe=>({value:oe.normalized,expectContiguousMatch:oe.expectContiguousMatch})),label:F,description:$,allowNonContiguousMatches:Y}})}function r(F,$,Y,_,Q){if(!F||!$.normalized)return y;const ie=_.getItemLabel(F);if(!ie)return y;const oe=_.getItemDescription(F),Ee=s(ie,oe,Y,$),he=Q[Ee];if(he)return he;const fe=a(ie,oe,_.getItemPath(F),$,Y);return Q[Ee]=fe,fe}e.scoreItemFuzzy=r;function a(F,$,Y,_,Q){const ie=!Y||!_.containsPathSeparator;return Y&&(A.isLinux?_.pathNormalized===Y:(0,P.equalsIgnoreCase)(_.pathNormalized,Y))?{score:w,labelMatch:[{start:0,end:F.length}],descriptionMatch:$?[{start:0,end:$.length}]:void 0}:_.values&&_.values.length>1?b(F,$,Y,_.values,ie,Q):S(F,$,Y,_,ie,Q)}function b(F,$,Y,_,Q,ie){let oe=0;const Ee=[],he=[];for(const fe of _){const{score:x,labelMatch:B,descriptionMatch:Z}=S(F,$,Y,fe,Q,ie);if(x===D)return y;oe+=x,B&&Ee.push(...B),Z&&he.push(...Z)}return{score:oe,labelMatch:u(Ee),descriptionMatch:u(he)}}function S(F,$,Y,_,Q,ie){if(Q||!$){const[oe,Ee]=O(F,_.normalized,_.normalizedLowercase,ie&&!_.expectContiguousMatch);if(oe){const he=(0,R.matchesPrefix)(_.normalized,F);let fe;if(he){fe=g;const x=Math.round(_.normalized.length/F.length*100);fe+=x}else fe=t;return{score:fe+oe,labelMatch:he||c(Ee)}}}if($){let oe=$;Y&&(oe=`${$}${L.sep}`);const Ee=oe.length,he=`${oe}${F}`,[fe,x]=O(he,_.normalized,_.normalizedLowercase,ie&&!_.expectContiguousMatch);if(fe){const B=c(x),Z=[],pe=[];return B.forEach(Se=>{Se.start<Ee&&Se.end>Ee?(Z.push({start:0,end:Se.end-Ee}),pe.push({start:Se.start,end:Ee})):Se.start>=Ee?Z.push({start:Se.start-Ee,end:Se.end-Ee}):pe.push(Se)}),{score:fe,labelMatch:Z,descriptionMatch:pe}}}return y}function c(F){const $=[];if(!F)return $;let Y;for(const _ of F)Y&&Y.end===_?Y.end+=1:(Y={start:_,end:_+1},$.push(Y));return $}function u(F){const $=F.sort((Q,ie)=>Q.start-ie.start),Y=[];let _;for(const Q of $)!_||!m(_,Q)?(_=Q,Y.push(Q)):(_.start=Math.min(_.start,Q.start),_.end=Math.max(_.end,Q.end));return Y}function m(F,$){return!(F.end<$.start||$.end<F.start)}function f(F,$,Y,_,Q,ie){const oe=r(F,Y,_,Q,ie),Ee=r($,Y,_,Q,ie),he=oe.score,fe=Ee.score;if((he===w||fe===w)&&he!==fe)return he===w?-1:1;if(he>t||fe>t){if(he!==fe)return he>fe?-1:1;if(he<g&&fe<g){const ne=C(oe.labelMatch,Ee.labelMatch);if(ne!==0)return ne}const Se=Q.getItemLabel(F)||"",re=Q.getItemLabel($)||"";if(Se.length!==re.length)return Se.length-re.length}if(he!==fe)return he>fe?-1:1;const x=Array.isArray(oe.labelMatch)&&oe.labelMatch.length>0,B=Array.isArray(Ee.labelMatch)&&Ee.labelMatch.length>0;if(x&&!B)return-1;if(B&&!x)return 1;const Z=n(F,oe,Q),pe=n($,Ee,Q);return Z&&pe&&Z!==pe?pe>Z?-1:1:M(F,$,Y,Q)}e.compareItemsByFuzzyScore=f;function n(F,$,Y){let _=-1,Q=-1;if($.descriptionMatch&&$.descriptionMatch.length?_=$.descriptionMatch[0].start:$.labelMatch&&$.labelMatch.length&&(_=$.labelMatch[0].start),$.labelMatch&&$.labelMatch.length){if(Q=$.labelMatch[$.labelMatch.length-1].end,$.descriptionMatch&&$.descriptionMatch.length){const ie=Y.getItemDescription(F);ie&&(Q+=ie.length)}}else $.descriptionMatch&&$.descriptionMatch.length&&(Q=$.descriptionMatch[$.descriptionMatch.length-1].end);return Q-_}function C(F,$){if(!F&&!$||(!F||!F.length)&&(!$||!$.length))return 0;if(!$||!$.length)return-1;if(!F||!F.length)return 1;const Y=F[0].start,Q=F[F.length-1].end-Y,ie=$[0].start,Ee=$[$.length-1].end-ie;return Q===Ee?0:Ee<Q?1:-1}function M(F,$,Y,_){const Q=_.getItemLabel(F)||"",ie=_.getItemLabel($)||"",oe=_.getItemDescription(F),Ee=_.getItemDescription($),he=Q.length+(oe?oe.length:0),fe=ie.length+(Ee?Ee.length:0);if(he!==fe)return he-fe;const x=_.getItemPath(F),B=_.getItemPath($);return x&&B&&x.length!==B.length?x.length-B.length:Q!==ie?(0,o.compareAnything)(Q,ie,Y.normalized):oe&&Ee&&oe!==Ee?(0,o.compareAnything)(oe,Ee,Y.normalized):x&&B&&x!==B?(0,o.compareAnything)(x,B,Y.normalized):0}function H(F){return F.startsWith('"')&&F.endsWith('"')}const V=" ";function U(F){typeof F!="string"&&(F="");const $=F.toLowerCase(),{pathNormalized:Y,normalized:_,normalizedLowercase:Q}=z(F),ie=Y.indexOf(L.sep)>=0,oe=H(F);let Ee;const he=F.split(V);if(he.length>1)for(const fe of he){const x=H(fe),{pathNormalized:B,normalized:Z,normalizedLowercase:pe}=z(fe);Z&&(Ee||(Ee=[]),Ee.push({original:fe,originalLowercase:fe.toLowerCase(),pathNormalized:B,normalized:Z,normalizedLowercase:pe,expectContiguousMatch:x}))}return{original:F,originalLowercase:$,pathNormalized:Y,normalized:_,normalizedLowercase:Q,values:Ee,containsPathSeparator:ie,expectContiguousMatch:oe}}e.prepareQuery=U;function z(F){let $;A.isWindows?$=F.replace(/\//g,L.sep):$=F.replace(/\\/g,L.sep);const Y=(0,P.stripWildcards)($).replace(/\s|"/g,"");return{pathNormalized:$,normalized:Y,normalizedLowercase:Y.toLowerCase()}}function G(F){return Array.isArray(F)?U(F.map($=>$.original).join(V)):U(F.original)}e.pieceToQuery=G}),define(Ce[166],ke([1,0,111,9,53]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const L="$(",A=new RegExp(`\\$\\(${l.ThemeIcon.iconNameExpression}(?:${l.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${A.source}`,"g");function D(d){return d.replace(P,(h,y)=>y?h:`\\${h}`)}e.escapeIcons=D;const p=new RegExp(`\\\\${A.source}`,"g");function O(d){return d.replace(p,h=>`\\${h}`)}e.markdownEscapeEscapedIcons=O;const k=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function E(d){return d.indexOf(L)===-1?d:d.replace(k,(h,y,w,g)=>w?h:y||g||"")}e.stripIcons=E;function T(d){return d?d.replace(/\$\((.*?)\)/g,(h,y)=>` ${y} `).trim():""}e.getCodiconAriaLabel=T;const I=new RegExp(`\\$\\(${l.ThemeIcon.iconNameCharacter}+\\)`,"g");function v(d){I.lastIndex=0;let h="";const y=[];let w=0;for(;;){const g=I.lastIndex,t=I.exec(d),s=d.substring(g,t?.index);if(s.length>0){h+=s;for(let r=0;r<s.length;r++)y.push(w)}if(!t)break;w+=t[0].length}return{text:h,iconOffsets:y}}e.parseLabelWithIcons=v;function i(d,h,y=!1){const{text:w,iconOffsets:g}=h;if(!g||g.length===0)return(0,o.matchesFuzzy)(d,w,y);const t=(0,R.ltrim)(w," "),s=w.length-t.length,r=(0,o.matchesFuzzy)(d,t,y);if(r)for(const a of r){const b=g[a.start+s]+s;a.start+=b,a.end+=b}return r}e.matchesFuzzyIconAware=i}),define(Ce[38],ke([1,0,9]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var R;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(R||(R={})),function(l){const L="error",A="warning",P="warn",D="info",p="ignore";function O(E){return E?o.equalsIgnoreCase(L,E)?l.Error:o.equalsIgnoreCase(A,E)||o.equalsIgnoreCase(P,E)?l.Warning:o.equalsIgnoreCase(D,E)?l.Info:l.Ignore:l.Ignore}l.fromValue=O;function k(E){switch(E){case l.Error:return L;case l.Warning:return A;case l.Info:return D;default:return p}}l.toString=k}(R||(R={})),e.default=R}),define(Ce[69],ke([1,0,18,9]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(T){return this.b=T,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(T){const I=T.charCodeAt(0),v=this.b.charCodeAt(this.c);return I-v}value(){return this.b[this.c]}}e.StringIterator=l;class L{constructor(T=!0){this.e=T}reset(T){return this.b=T,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let T=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(T)this.c++;else break;else T=!1;return this}cmp(T){return this.e?(0,R.compareSubstring)(T,this.b,0,T.length,this.c,this.d):(0,R.compareSubstringIgnoreCase)(T,this.b,0,T.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=L;class A{constructor(T=!0,I=!0){this.f=T,this.g=I}reset(T){this.d=0,this.e=0,this.b=T,this.c=T.length;for(let I=T.length-1;I>=0;I--,this.c--){const v=this.b.charCodeAt(I);if(!(v===47||this.f&&v===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let T=!0;for(;this.e<this.c;this.e++){const I=this.b.charCodeAt(this.e);if(I===47||this.f&&I===92)if(T)this.d++;else break;else T=!1}return this}cmp(T){return this.g?(0,R.compareSubstring)(T,this.b,0,T.length,this.d,this.e):(0,R.compareSubstringIgnoreCase)(T,this.b,0,T.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=A;var P;(function(E){E[E.Scheme=1]="Scheme",E[E.Authority=2]="Authority",E[E.Path=3]="Path",E[E.Query=4]="Query",E[E.Fragment=5]="Fragment"})(P||(P={}));class D{constructor(T,I){this.f=T,this.g=I,this.d=[],this.e=0}reset(T){return this.c=T,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(T)),this.b.reset(T.path),this.b.value()&&this.d.push(3)),this.g(T)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(T){if(this.d[this.e]===1)return(0,R.compareIgnoreCase)(T,this.c.scheme);if(this.d[this.e]===2)return(0,R.compareIgnoreCase)(T,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(T);if(this.d[this.e]===4)return(0,R.compare)(T,this.c.query);if(this.d[this.e]===5)return(0,R.compare)(T,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=D;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const T=this.right;return this.right=T.left,T.left=this,this.updateHeight(),T.updateHeight(),T}rotateRight(){const T=this.left;return this.left=T.right,T.right=this,this.updateHeight(),T.updateHeight(),T}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(E){E[E.Left=-1]="Left",E[E.Mid=0]="Mid",E[E.Right=1]="Right"})(O||(O={}));class k{static forUris(T=()=>!1,I=()=>!1){return new k(new D(T,I))}static forPaths(T=!1){return new k(new A(void 0,!T))}static forStrings(){return new k(new l)}static forConfigKeys(){return new k(new L)}constructor(T){this.b=T}clear(){this.c=void 0}fill(T,I){if(I){const v=I.slice(0);(0,o.shuffle)(v);for(const i of v)this.set(i,T)}else{const v=T.slice(0);(0,o.shuffle)(v);for(const i of v)this.set(i[0],i[1])}}set(T,I){const v=this.b.reset(T);let i;this.c||(this.c=new p,this.c.segment=v.value());const d=[];for(i=this.c;;){const y=v.cmp(i.segment);if(y>0)i.left||(i.left=new p,i.left.segment=v.value()),d.push([-1,i]),i=i.left;else if(y<0)i.right||(i.right=new p,i.right.segment=v.value()),d.push([1,i]),i=i.right;else if(v.hasNext())v.next(),i.mid||(i.mid=new p,i.mid.segment=v.value()),d.push([0,i]),i=i.mid;else break}const h=i.value;i.value=I,i.key=T;for(let y=d.length-1;y>=0;y--){const w=d[y][1];w.updateHeight();const g=w.balanceFactor();if(g<-1||g>1){const t=d[y][0],s=d[y+1][0];if(t===1&&s===1)d[y][1]=w.rotateLeft();else if(t===-1&&s===-1)d[y][1]=w.rotateRight();else if(t===1&&s===-1)w.right=d[y+1][1]=d[y+1][1].rotateRight(),d[y][1]=w.rotateLeft();else if(t===-1&&s===1)w.left=d[y+1][1]=d[y+1][1].rotateLeft(),d[y][1]=w.rotateRight();else throw new Error;if(y>0)switch(d[y-1][0]){case-1:d[y-1][1].left=d[y][1];break;case 1:d[y-1][1].right=d[y][1];break;case 0:d[y-1][1].mid=d[y][1];break}else this.c=d[0][1]}}return h}get(T){return this.d(T)?.value}d(T){const I=this.b.reset(T);let v=this.c;for(;v;){const i=I.cmp(v.segment);if(i>0)v=v.left;else if(i<0)v=v.right;else if(I.hasNext())I.next(),v=v.mid;else break}return v}has(T){const I=this.d(T);return!(I?.value===void 0&&I?.mid===void 0)}delete(T){return this.e(T,!1)}deleteSuperstr(T){return this.e(T,!0)}e(T,I){const v=this.b.reset(T),i=[];let d=this.c;for(;d;){const h=v.cmp(d.segment);if(h>0)i.push([-1,d]),d=d.left;else if(h<0)i.push([1,d]),d=d.right;else if(v.hasNext())v.next(),i.push([0,d]),d=d.mid;else break}if(d){if(I?(d.left=void 0,d.mid=void 0,d.right=void 0,d.height=1):(d.key=void 0,d.value=void 0),!d.mid&&!d.value)if(d.left&&d.right){const h=this.f(d.right);if(h.key){const{key:y,value:w,segment:g}=h;this.e(h.key,!1),d.key=y,d.value=w,d.segment=g}}else{const h=d.left??d.right;if(i.length>0){const[y,w]=i[i.length-1];switch(y){case-1:w.left=h;break;case 0:w.mid=h;break;case 1:w.right=h;break}}else this.c=h}for(let h=i.length-1;h>=0;h--){const y=i[h][1];y.updateHeight();const w=y.balanceFactor();if(w>1?(y.right.balanceFactor()>=0||(y.right=y.right.rotateRight()),i[h][1]=y.rotateLeft()):w<-1&&(y.left.balanceFactor()<=0||(y.left=y.left.rotateLeft()),i[h][1]=y.rotateRight()),h>0)switch(i[h-1][0]){case-1:i[h-1][1].left=i[h][1];break;case 1:i[h-1][1].right=i[h][1];break;case 0:i[h-1][1].mid=i[h][1];break}else this.c=i[0][1]}}}f(T){for(;T.left;)T=T.left;return T}findSubstr(T){const I=this.b.reset(T);let v=this.c,i;for(;v;){const d=I.cmp(v.segment);if(d>0)v=v.left;else if(d<0)v=v.right;else if(I.hasNext())I.next(),i=v.value||i,v=v.mid;else break}return v&&v.value||i}findSuperstr(T){return this.g(T,!1)}g(T,I){const v=this.b.reset(T);let i=this.c;for(;i;){const d=v.cmp(i.segment);if(d>0)i=i.left;else if(d<0)i=i.right;else if(v.hasNext())v.next(),i=i.mid;else return i.mid?this.h(i.mid):I?i.value:void 0}}hasElementOrSubtree(T){return this.g(T,!0)!==void 0}forEach(T){for(const[I,v]of this)T(v,I)}*[Symbol.iterator](){yield*this.h(this.c)}h(T){const I=[];return this.j(T,I),I[Symbol.iterator]()}j(T,I){T&&(T.left&&this.j(T.left,I),T.value&&I.push([T.key,T.value]),T.mid&&this.j(T.mid,I),T.right&&this.j(T.right,I))}_isBalanced(){const T=I=>{if(!I)return!0;const v=I.balanceFactor();return v<-1||v>1?!1:T(I.left)&&T(I.right)};return T(this.c)}}e.TernarySearchTree=k}),define(Ce[2],ke([1,0,15,14]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function P(r,a){if(!r.scheme&&a)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!l.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!L.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function D(r,a){return!r&&!a?"file":r}function p(r,a){switch(r){case"https":case"http":case"file":a?a[0]!==k&&(a=k+a):a=k;break}return a}const O="",k="/",E=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class T{static isUri(a){return a instanceof T?!0:a?typeof a.authority=="string"&&typeof a.fragment=="string"&&typeof a.path=="string"&&typeof a.query=="string"&&typeof a.scheme=="string"&&typeof a.fsPath=="string"&&typeof a.with=="function"&&typeof a.toString=="function":!1}constructor(a,b,S,c,u,m=!1){typeof a=="object"?(this.scheme=a.scheme||O,this.authority=a.authority||O,this.path=a.path||O,this.query=a.query||O,this.fragment=a.fragment||O):(this.scheme=D(a,m),this.authority=b||O,this.path=p(this.scheme,S||O),this.query=c||O,this.fragment=u||O,P(this,m))}get fsPath(){return y(this,!1)}with(a){if(!a)return this;let{scheme:b,authority:S,path:c,query:u,fragment:m}=a;return b===void 0?b=this.scheme:b===null&&(b=O),S===void 0?S=this.authority:S===null&&(S=O),c===void 0?c=this.path:c===null&&(c=O),u===void 0?u=this.query:u===null&&(u=O),m===void 0?m=this.fragment:m===null&&(m=O),b===this.scheme&&S===this.authority&&c===this.path&&u===this.query&&m===this.fragment?this:new v(b,S,c,u,m)}static parse(a,b=!1){const S=E.exec(a);return S?new v(S[2]||O,s(S[4]||O),s(S[5]||O),s(S[7]||O),s(S[9]||O),b):new v(O,O,O,O,O)}static file(a){let b=O;if(R.isWindows&&(a=a.replace(/\\/g,k)),a[0]===k&&a[1]===k){const S=a.indexOf(k,2);S===-1?(b=a.substring(2),a=k):(b=a.substring(2,S),a=a.substring(S)||k)}return new v("file",b,a,O,O)}static from(a){const b=new v(a.scheme,a.authority,a.path,a.query,a.fragment);return P(b,!0),b}static joinPath(a,...b){if(!a.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let S;return R.isWindows&&a.scheme==="file"?S=T.file(o.win32.join(y(a,!0),...b)).path:S=o.posix.join(a.path,...b),a.with({path:S})}toString(a=!1){return w(this,a)}toJSON(){return this}static revive(a){if(a){if(a instanceof T)return a;{const b=new v(a);return b._formatted=a.external,b._fsPath=a._sep===I?a.fsPath:null,b}}else return a}}e.URI=T;const I=R.isWindows?1:void 0;class v extends T{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=y(this,!1)),this._fsPath}toString(a=!1){return a?w(this,!0):(this._formatted||(this._formatted=w(this,!1)),this._formatted)}toJSON(){const a={$mid:1};return this._fsPath&&(a.fsPath=this._fsPath,a._sep=I),this._formatted&&(a.external=this._formatted),this.path&&(a.path=this.path),this.scheme&&(a.scheme=this.scheme),this.authority&&(a.authority=this.authority),this.query&&(a.query=this.query),this.fragment&&(a.fragment=this.fragment),a}}const i={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function d(r,a,b){let S,c=-1;for(let u=0;u<r.length;u++){const m=r.charCodeAt(u);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||a&&m===47||b&&m===91||b&&m===93||b&&m===58)c!==-1&&(S+=encodeURIComponent(r.substring(c,u)),c=-1),S!==void 0&&(S+=r.charAt(u));else{S===void 0&&(S=r.substr(0,u));const f=i[m];f!==void 0?(c!==-1&&(S+=encodeURIComponent(r.substring(c,u)),c=-1),S+=f):c===-1&&(c=u)}}return c!==-1&&(S+=encodeURIComponent(r.substring(c))),S!==void 0?S:r}function h(r){let a;for(let b=0;b<r.length;b++){const S=r.charCodeAt(b);S===35||S===63?(a===void 0&&(a=r.substr(0,b)),a+=i[S]):a!==void 0&&(a+=r[b])}return a!==void 0?a:r}function y(r,a){let b;return r.authority&&r.path.length>1&&r.scheme==="file"?b=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?a?b=r.path.substr(1):b=r.path[1].toLowerCase()+r.path.substr(2):b=r.path,R.isWindows&&(b=b.replace(/\//g,"\\")),b}e.uriToFsPath=y;function w(r,a){const b=a?h:d;let S="",{scheme:c,authority:u,path:m,query:f,fragment:n}=r;if(c&&(S+=c,S+=":"),(u||c==="file")&&(S+=k,S+=k),u){let C=u.indexOf("@");if(C!==-1){const M=u.substr(0,C);u=u.substr(C+1),C=M.lastIndexOf(":"),C===-1?S+=b(M,!1,!1):(S+=b(M.substr(0,C),!1,!1),S+=":",S+=b(M.substr(C+1),!1,!0)),S+="@"}u=u.toLowerCase(),C=u.lastIndexOf(":"),C===-1?S+=b(u,!1,!0):(S+=b(u.substr(0,C),!1,!0),S+=u.substr(C))}if(m){if(m.length>=3&&m.charCodeAt(0)===47&&m.charCodeAt(2)===58){const C=m.charCodeAt(1);C>=65&&C<=90&&(m=`/${String.fromCharCode(C+32)}:${m.substr(3)}`)}else if(m.length>=2&&m.charCodeAt(1)===58){const C=m.charCodeAt(0);C>=65&&C<=90&&(m=`${String.fromCharCode(C+32)}:${m.substr(2)}`)}S+=b(m,!0,!1)}return f&&(S+="?",S+=b(f,!1,!1)),n&&(S+="#",S+=a?n:d(n,!1,!1)),S}function g(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+g(r.substr(3)):r}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(t)?r.replace(t,a=>g(a)):r}}),define(Ce[70],ke([1,0,22,9,2]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(p){return JSON.stringify(p,P)}e.stringify=L;function A(p){let O=JSON.parse(p);return O=D(O),O}e.parse=A;function P(p,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,R.regExpFlags)(O)}:O}function D(p,O=0){if(!p||O>200)return p;if(typeof p=="object"){switch(p.$mid){case 1:return l.URI.revive(p);case 2:return new RegExp(p.source,p.flags);case 16:return new Date(p.source)}if(p instanceof o.VSBuffer||p instanceof Uint8Array)return p;if(Array.isArray(p))for(let k=0;k<p.length;++k)p[k]=D(p[k],O+1);else for(const k in p)Object.hasOwnProperty.call(p,k)&&(p[k]=D(p[k],O+1))}return p}e.revive=D}),define(Ce[17],ke([1,0,8,14,2]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(p){p.inMemory="inmemory",p.vscode="vscode",p.internal="private",p.walkThrough="walkThrough",p.walkThroughSnippet="walkThroughSnippet",p.http="http",p.https="https",p.file="file",p.mailto="mailto",p.untitled="untitled",p.data="data",p.command="command",p.vscodeRemote="vscode-remote",p.vscodeRemoteResource="vscode-remote-resource",p.vscodeUserData="vscode-userdata",p.vscodeCustomEditor="vscode-custom-editor",p.vscodeNotebookCell="vscode-notebook-cell",p.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",p.vscodeNotebookCellOutput="vscode-notebook-cell-output",p.vscodeInteractive="vscode-interactive",p.vscodeInteractiveInput="vscode-interactive-input",p.vscodeSettings="vscode-settings",p.vscodeWorkspaceTrust="vscode-workspace-trust",p.vscodeTerminal="vscode-terminal",p.vscodeInteractiveSesssion="vscode-chat-editor",p.webviewPanel="webview-panel",p.vscodeWebview="vscode-webview",p.extension="extension",p.vscodeFileResource="vscode-file",p.tmp="tmp",p.vsls="vsls",p.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class A{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(O){this.d=O}setDelegate(O){this.e=O}setServerRootPath(O){this.f=`${O}/${L.vscodeRemoteResource}`}set(O,k,E){this.a[O]=k,this.b[O]=E}setConnectionToken(O,k){this.c[O]=k}getPreferredWebSchema(){return this.d}rewrite(O){if(this.e)try{return this.e(O)}catch(i){return o.onUnexpectedError(i),O}const k=O.authority;let E=this.a[k];E&&E.indexOf(":")!==-1&&E.indexOf("[")===-1&&(E=`[${E}]`);const T=this.b[k],I=this.c[k];let v=`path=${encodeURIComponent(O.path)}`;return typeof I=="string"&&(v+=`&${e.connectionTokenQueryName}=${encodeURIComponent(I)}`),l.URI.from({scheme:R.isWeb?this.d:L.vscodeRemoteResource,authority:`${E}:${T}`,path:this.f,query:v})}}e.RemoteAuthorities=new A,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(O){const k=this.b(O,ae);return this.uriToBrowserUri(k)}uriToBrowserUri(O){return O.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===L.file&&(R.isNative||R.isWebWorker&&R.globals.origin===`${L.vscodeFileResource}://${P.a}`)?O.with({scheme:L.vscodeFileResource,authority:O.authority||P.a,query:null,fragment:null}):O}asFileUri(O){const k=this.b(O,ae);return this.uriToFileUri(k)}uriToFileUri(O){return O.scheme===L.vscodeFileResource?O.with({scheme:L.file,authority:O.authority!==P.a?O.authority:null,query:null,fragment:null}):O}b(O,k){return l.URI.isUri(O)?O:l.URI.parse(k.toUrl(O))}}P.a="vscode-app",e.FileAccess=new P;var D;(function(p){const O=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);p.CoopAndCoep=Object.freeze(O.get("3"));const k="vscode-coi";function E(I){let v;typeof I=="string"?v=new URL(I).searchParams:I instanceof URL?v=I.searchParams:l.URI.isUri(I)&&(v=new URL(I.toString(!0)).searchParams);const i=v?.get(k);if(i)return O.get(i)}p.getHeadersFromQuery=E;function T(I,v,i){if(!globalThis.crossOriginIsolated)return;const d=v&&i?"3":i?"2":"1";I instanceof URLSearchParams?I.set(k,d):I[k]=d}p.addSearchParam=T})(D||(e.COI=D={}))}),define(Ce[24],ke([1,0,33,17,15,14,9,2]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function D(T){return(0,P.uriToFsPath)(T,!0)}e.originalFSPath=D;class p{constructor(I){this.a=I}compare(I,v,i=!1){return I===v?0:(0,A.compare)(this.getComparisonKey(I,i),this.getComparisonKey(v,i))}isEqual(I,v,i=!1){return I===v?!0:!I||!v?!1:this.getComparisonKey(I,i)===this.getComparisonKey(v,i)}getComparisonKey(I,v=!1){return I.with({path:this.a(I)?I.path.toLowerCase():void 0,fragment:v?null:void 0}).toString()}ignorePathCasing(I){return this.a(I)}isEqualOrParent(I,v,i=!1){if(I.scheme===v.scheme){if(I.scheme===R.Schemas.file)return o.isEqualOrParent(D(I),D(v),this.a(I))&&I.query===v.query&&(i||I.fragment===v.fragment);if((0,e.isEqualAuthority)(I.authority,v.authority))return o.isEqualOrParent(I.path,v.path,this.a(I),"/")&&I.query===v.query&&(i||I.fragment===v.fragment)}return!1}joinPath(I,...v){return P.URI.joinPath(I,...v)}basenameOrAuthority(I){return(0,e.basename)(I)||I.authority}basename(I){return l.posix.basename(I.path)}extname(I){return l.posix.extname(I.path)}dirname(I){if(I.path.length===0)return I;let v;return I.scheme===R.Schemas.file?v=P.URI.file(l.dirname(D(I))).path:(v=l.posix.dirname(I.path),I.authority&&v.length&&v.charCodeAt(0)!==47&&(console.error(`dirname("${I.toString})) resulted in a relative path`),v="/")),I.with({path:v})}normalizePath(I){if(!I.path.length)return I;let v;return I.scheme===R.Schemas.file?v=P.URI.file(l.normalize(D(I))).path:v=l.posix.normalize(I.path),I.with({path:v})}relativePath(I,v){if(I.scheme!==v.scheme||!(0,e.isEqualAuthority)(I.authority,v.authority))return;if(I.scheme===R.Schemas.file){const h=l.relative(D(I),D(v));return L.isWindows?o.toSlashes(h):h}let i=I.path||"/";const d=v.path||"/";if(this.a(I)){let h=0;for(const y=Math.min(i.length,d.length);h<y&&!(i.charCodeAt(h)!==d.charCodeAt(h)&&i.charAt(h).toLowerCase()!==d.charAt(h).toLowerCase());h++);i=d.substr(0,h)+i.substr(h)}return l.posix.relative(i,d)}resolvePath(I,v){if(I.scheme===R.Schemas.file){const i=P.URI.file(l.resolve(D(I),v));return I.with({authority:i.authority,path:i.path})}return v=o.toPosixPath(v),I.with({path:l.posix.resolve(I.path,v)})}isAbsolutePath(I){return!!I.path&&I.path[0]==="/"}isEqualAuthority(I,v){return I===v||I!==void 0&&v!==void 0&&(0,A.equalsIgnoreCase)(I,v)}hasTrailingPathSeparator(I,v=l.sep){if(I.scheme===R.Schemas.file){const i=D(I);return i.length>o.getRoot(i).length&&i[i.length-1]===v}else{const i=I.path;return i.length>1&&i.charCodeAt(i.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(I.fsPath)}}removeTrailingPathSeparator(I,v=l.sep){return(0,e.hasTrailingPathSeparator)(I,v)?I.with({path:I.path.substr(0,I.path.length-1)}):I}addTrailingPathSeparator(I,v=l.sep){let i=!1;if(I.scheme===R.Schemas.file){const d=D(I);i=d!==void 0&&d.length===o.getRoot(d).length&&d[d.length-1]===v}else{v="/";const d=I.path;i=d.length===1&&d.charCodeAt(d.length-1)===47}return!i&&!(0,e.hasTrailingPathSeparator)(I,v)?I.with({path:I.path+"/"}):I}}e.ExtUri=p,e.extUri=new p(()=>!1),e.extUriBiasedIgnorePathCase=new p(T=>T.scheme===R.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new p(T=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(T,I){const v=[];for(let i=0;i<T.length;i++){const d=I(T[i]);T.some((h,y)=>y===i?!1:(0,e.isEqualOrParent)(d,I(h)))||v.push(T[i])}return v}e.distinctParents=O;var k;(function(T){T.META_DATA_LABEL="label",T.META_DATA_DESCRIPTION="description",T.META_DATA_SIZE="size",T.META_DATA_MIME="mime";function I(v){const i=new Map;v.path.substring(v.path.indexOf(";")+1,v.path.lastIndexOf(";")).split(";").forEach(y=>{const[w,g]=y.split(":");w&&g&&i.set(w,g)});const h=v.path.substring(0,v.path.indexOf(";"));return h&&i.set(T.META_DATA_MIME,h),i}T.parseMetaData=I})(k||(e.DataUri=k={}));function E(T,I,v){if(I){let i=T.path;return i&&i[0]!==l.posix.sep&&(i=l.posix.sep+i),T.with({scheme:v,authority:I,path:i})}return T.with({scheme:v})}e.toLocalResource=E}),define(Ce[19],ke([1,0,21,8,3,6,24,14,150]),function(ae,e,o,R,l,L,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function p(fe){return!!fe&&typeof fe.then=="function"}e.isThenable=p;function O(fe){const x=new o.CancellationTokenSource,B=fe(x.token),Z=new Promise((pe,Se)=>{const re=x.token.onCancellationRequested(()=>{re.dispose(),x.dispose(),Se(new R.CancellationError)});Promise.resolve(B).then(ne=>{re.dispose(),x.dispose(),pe(ne)},ne=>{re.dispose(),x.dispose(),Se(ne)})});return new class{cancel(){x.cancel()}then(pe,Se){return Z.then(pe,Se)}catch(pe){return this.then(void 0,pe)}finally(pe){return Z.finally(pe)}}}e.createCancelablePromise=O;function k(fe,x,B){return new Promise((Z,pe)=>{const Se=x.onCancellationRequested(()=>{Se.dispose(),Z(B)});fe.then(Z,pe).finally(()=>Se.dispose())})}e.raceCancellation=k;function E(fe,x){return new Promise((B,Z)=>{const pe=x.onCancellationRequested(()=>{pe.dispose(),Z(new R.CancellationError)});fe.then(B,Z).finally(()=>pe.dispose())})}e.raceCancellationError=E;async function T(fe){let x=-1;const B=fe.map((Z,pe)=>Z.then(Se=>(x=pe,Se)));try{return await Promise.race(B)}finally{fe.forEach((Z,pe)=>{pe!==x&&Z.cancel()})}}e.raceCancellablePromises=T;function I(fe,x,B){let Z;const pe=setTimeout(()=>{Z?.(void 0),B?.()},x);return Promise.race([fe.finally(()=>clearTimeout(pe)),new Promise(Se=>Z=Se)])}e.raceTimeout=I;function v(fe){return new Promise((x,B)=>{const Z=fe();p(Z)?Z.then(x,B):x(Z)})}e.asPromise=v;class i{constructor(){this.a=null,this.b=null,this.d=null}queue(x){if(this.a){if(this.d=x,!this.b){const B=()=>{this.b=null;const Z=this.queue(this.d);return this.d=null,Z};this.b=new Promise(Z=>{this.a.then(B,B).then(Z)})}return new Promise((B,Z)=>{this.b.then(B,Z)})}return this.a=x(),new Promise((B,Z)=>{this.a.then(pe=>{this.a=null,B(pe)},pe=>{this.a=null,Z(pe)})})}}e.Throttler=i;class d{constructor(){this.a=Promise.resolve(null)}queue(x){return this.a=this.a.then(()=>x(),()=>x())}}e.Sequencer=d;class h{constructor(){this.a=new Map}queue(x,B){const pe=(this.a.get(x)??Promise.resolve()).catch(()=>{}).then(B).finally(()=>{this.a.get(x)===pe&&this.a.delete(x)});return this.a.set(x,pe),pe}}e.SequencerByKey=h;const y=(fe,x)=>{let B=!0;const Z=setTimeout(()=>{B=!1,x()},fe);return{isTriggered:()=>B,dispose:()=>{clearTimeout(Z),B=!1}}},w=fe=>{let x=!0;return queueMicrotask(()=>{x&&(x=!1,fe())}),{isTriggered:()=>x,dispose:()=>{x=!1}}};class g{constructor(x){this.defaultDelay=x,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(x,B=this.defaultDelay){this.g=x,this.h(),this.b||(this.b=new Promise((pe,Se)=>{this.d=pe,this.f=Se}).then(()=>{if(this.b=null,this.d=null,this.g){const pe=this.g;return this.g=null,pe()}}));const Z=()=>{this.a=null,this.d?.(null)};return this.a=B===D.MicrotaskDelay?w(Z):y(B,Z),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new R.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=g;class t{constructor(x){this.a=new g(x),this.b=new i}trigger(x,B){return this.a.trigger(()=>this.b.queue(x),B)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class s{constructor(){this.a=!1,this.b=new Promise((x,B)=>{this.d=x})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class r extends s{constructor(x){super(),this.f=setTimeout(()=>this.open(),x)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function a(fe,x){return x?new Promise((B,Z)=>{const pe=setTimeout(()=>{Se.dispose(),B()},fe),Se=x.onCancellationRequested(()=>{clearTimeout(pe),Se.dispose(),Z(new R.CancellationError)})}):O(B=>a(fe,B))}e.timeout=a;function b(fe,x=0){const B=setTimeout(fe,x);return(0,L.toDisposable)(()=>clearTimeout(B))}e.disposableTimeout=b;function S(fe){const x=[];let B=0;const Z=fe.length;function pe(){return B<Z?fe[B++]():null}function Se(re){re!=null&&x.push(re);const ne=pe();return ne?ne.then(Se):Promise.resolve(x)}return Promise.resolve(null).then(Se)}e.sequence=S;function c(fe,x=Z=>!!Z,B=null){let Z=0;const pe=fe.length,Se=()=>{if(Z>=pe)return Promise.resolve(B);const re=fe[Z++];return Promise.resolve(re()).then(de=>x(de)?Promise.resolve(de):Se())};return Se()}e.first=c;function u(fe,x=Z=>!!Z,B=null){if(fe.length===0)return Promise.resolve(B);let Z=fe.length;const pe=()=>{Z=-1;for(const Se of fe)Se.cancel?.()};return new Promise((Se,re)=>{for(const ne of fe)ne.then(de=>{--Z>=0&&x(de)?(pe(),Se(de)):Z===0&&Se(B)}).catch(de=>{--Z>=0&&(pe(),re(de))})})}e.firstParallel=u;class m{constructor(x){this.a=0,this.d=x,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(x){return this.a++,new Promise((B,Z)=>{this.f.push({factory:x,c:B,e:Z}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const x=this.f.shift();this.b++;const B=x.factory();B.then(x.c,x.e),B.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=m;class f extends m{constructor(){super(1)}}e.Queue=f;class n{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const x=new _;return this.b.add(x),x.p}d(){for(const[,x]of this.a)if(x.size>0)return!1;return!0}queueFor(x,B=A.extUri){const Z=B.getComparisonKey(x);let pe=this.a.get(Z);return pe||(pe=new f,l.Event.once(pe.onDrained)(()=>{pe?.dispose(),this.a.delete(Z),this.f()}),this.a.set(Z,pe)),pe}f(){this.d()&&this.g()}g(){for(const x of this.b)x.complete();this.b.clear()}dispose(){for(const[,x]of this.a)x.dispose();this.a.clear(),this.g()}}e.ResourceQueue=n;class C{constructor(x,B){this.a=-1,typeof x=="function"&&typeof B=="number"&&this.setIfNotSet(x,B)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(x,B){this.cancel(),this.a=setTimeout(()=>{this.a=-1,x()},B)}setIfNotSet(x,B){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,x()},B))}}e.TimeoutTimer=C;class M{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(x,B){this.cancel(),this.a=setInterval(()=>{x()},B)}}e.IntervalTimer=M;class H{constructor(x,B){this.b=-1,this.a=x,this.d=B,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(x=this.d){this.cancel(),this.b=setTimeout(this.f,x)}get delay(){return this.d}set delay(x){this.d=x}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=H;class V{constructor(x,B){B%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.a=x,this.b=B,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(x=this.b){x%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${x}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(x/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=V;class U extends H{constructor(x,B){super(x,B),this.j=[]}work(x){this.j.push(x),this.isScheduled()||this.schedule()}h(){const x=this.j;this.j=[],this.a?.(x)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=U;class z extends L.Disposable{constructor(x,B){super(),this.g=x,this.h=B,this.a=[],this.b=this.B(new L.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(x){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+x.length>this.g.maxBufferedWork)return!1}else if(this.pending+x.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const B of x)this.a.push(B);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new H(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=z,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=fe=>{(0,P.setTimeout0)(()=>{if(x)return;const B=Date.now()+15;fe(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,B-Date.now())}}))});let x=!1;return{dispose(){x||(x=!0)}}}:e.runWhenIdle=(fe,x)=>{const B=requestIdleCallback(fe,typeof x=="number"?{timeout:x}:void 0);let Z=!1;return{dispose(){Z||(Z=!0,cancelIdleCallback(B))}}}}();class G{constructor(x){this.d=!1,this.a=()=>{try{this.f=x()}catch(B){this.g=B}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=G;async function F(fe,x,B){let Z;for(let pe=0;pe<B;pe++)try{return await fe()}catch(Se){Z=Se,await a(x)}throw Z}e.retry=F;class ${hasPending(x){return this.a?typeof x=="number"?this.a.taskId===x:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(x,B,Z){return this.a={taskId:x,cancel:()=>Z?.(),promise:B},B.then(()=>this.d(x),()=>this.d(x)),B}d(x){this.a&&x===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const x=this.b;this.b=void 0,x.run().then(x.promiseResolve,x.promiseReject)}}setNext(x){if(this.b)this.b.run=x;else{let B,Z;const pe=new Promise((Se,re)=>{B=Se,Z=re});this.b={run:x,promise:pe,promiseResolve:B,promiseReject:Z}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=$;class Y{constructor(x,B=()=>Date.now()){this.d=x,this.f=B,this.a=0,this.b=0}increment(){const x=this.f();return x-this.a>this.d&&(this.a=x,this.b=0),this.b++,this.b}}e.IntervalCounter=Y;class _{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((x,B)=>{this.a=x,this.b=B})}complete(x){return new Promise(B=>{this.a(x),this.f=!0,B()})}error(x){return new Promise(B=>{this.b(x),this.d=!0,B()})}cancel(){new Promise(x=>{this.b(new R.CancellationError),this.d=!0,x()})}}e.DeferredPromise=_;var Q;(function(fe){async function x(Z){let pe;const Se=await Promise.all(Z.map(re=>re.then(ne=>ne,ne=>{pe||(pe=ne)})));if(typeof pe<"u")throw pe;return Se}fe.settled=x;function B(Z){return new Promise(async(pe,Se)=>{try{await Z(pe,Se)}catch(re){Se(re)}})}fe.withAsyncBody=B})(Q||(e.Promises=Q={}));var ie;(function(fe){fe[fe.Initial=0]="Initial",fe[fe.DoneOK=1]="DoneOK",fe[fe.DoneError=2]="DoneError"})(ie||(ie={}));class oe{static fromArray(x){return new oe(B=>{B.emitMany(x)})}static fromPromise(x){return new oe(async B=>{B.emitMany(await x)})}static fromPromises(x){return new oe(async B=>{await Promise.all(x.map(async Z=>B.emitOne(await Z)))})}static merge(x){return new oe(async B=>{await Promise.all(x.map(async Z=>{for await(const pe of Z)B.emitOne(pe)}))})}constructor(x){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const B={emitOne:Z=>this.g(Z),emitMany:Z=>this.h(Z),reject:Z=>this.k(Z)};try{await Promise.resolve(x(B)),this.j()}catch(Z){this.k(Z)}finally{B.emitOne=void 0,B.emitMany=void 0,B.reject=void 0}})}[Symbol.asyncIterator](){let x=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(x<this.b.length)return{done:!1,value:this.b[x++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(x,B){return new oe(async Z=>{for await(const pe of x)Z.emitOne(B(pe))})}map(x){return oe.map(this,x)}static filter(x,B){return new oe(async Z=>{for await(const pe of x)B(pe)&&Z.emitOne(pe)})}filter(x){return oe.filter(this,x)}static coalesce(x){return oe.filter(x,B=>!!B)}coalesce(){return oe.coalesce(this)}static async toPromise(x){const B=[];for await(const Z of x)B.push(Z);return B}toPromise(){return oe.toPromise(this)}g(x){this.a===0&&(this.b.push(x),this.f.fire())}h(x){this.a===0&&(this.b=this.b.concat(x),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(x){this.a===0&&(this.a=2,this.d=x,this.f.fire())}}e.AsyncIterableObject=oe,oe.EMPTY=oe.fromArray([]);class Ee extends oe{constructor(x,B){super(B),this.l=x}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Ee;function he(fe){const x=new o.CancellationTokenSource,B=fe(x.token);return new Ee(x,async Z=>{const pe=x.token.onCancellationRequested(()=>{pe.dispose(),x.dispose(),Z.reject(new R.CancellationError)});try{for await(const Se of B){if(x.token.isCancellationRequested)return;Z.emitOne(Se)}pe.dispose(),x.dispose()}catch(Se){pe.dispose(),x.dispose(),Z.reject(Se)}})}e.createCancelableAsyncIterable=he}),define(Ce[39],ke([1,0,18,19,33,28,15,14,9]),function(ae,e,o,R,l,L,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function p(){return Object.create(null)}e.getEmptyExpression=p,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",k="[^/\\\\]",E=/\//g;function T(Y,_){switch(Y){case 0:return"";case 1:return`${k}*?`;default:return`(?:${O}|${k}+${O}${_?`|${O}${k}+`:""})*?`}}function I(Y,_){if(!Y)return[];const Q=[];let ie=!1,oe=!1,Ee="";for(const he of Y){switch(he){case _:if(!ie&&!oe){Q.push(Ee),Ee="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":oe=!0;break;case"]":oe=!1;break}Ee+=he}return Ee&&Q.push(Ee),Q}e.splitGlobAware=I;function v(Y){if(!Y)return"";let _="";const Q=I(Y,e.GLOB_SPLIT);if(Q.every(ie=>ie===e.GLOBSTAR))_=".*";else{let ie=!1;Q.forEach((oe,Ee)=>{if(oe===e.GLOBSTAR){if(ie)return;_+=T(2,Ee===Q.length-1)}else{let he=!1,fe="",x=!1,B="";for(const Z of oe){if(Z!=="}"&&he){fe+=Z;continue}if(x&&(Z!=="]"||!B)){let pe;Z==="-"?pe=Z:(Z==="^"||Z==="!")&&!B?pe="^":Z===e.GLOB_SPLIT?pe="":pe=(0,D.escapeRegExpCharacters)(Z),B+=pe;continue}switch(Z){case"{":he=!0;continue;case"[":x=!0;continue;case"}":{const Se=`(?:${I(fe,",").map(re=>v(re)).join("|")})`;_+=Se,he=!1,fe="";break}case"]":{_+="["+B+"]",x=!1,B="";break}case"?":_+=k;continue;case"*":_+=T(1);continue;default:_+=(0,D.escapeRegExpCharacters)(Z)}}Ee<Q.length-1&&(Q[Ee+1]!==e.GLOBSTAR||Ee+2<Q.length)&&(_+=O)}ie=oe===e.GLOBSTAR})}return _}const i=/^\*\*\/\*\.[\w\.-]+$/,d=/^\*\*\/([\w\.-]+)\/?$/,h=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,y=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,w=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new L.LRUCache(1e4),s=function(){return!1},r=function(){return null};function a(Y,_){if(!Y)return r;let Q;typeof Y!="string"?Q=Y.pattern:Q=Y,Q=Q.trim();const ie=`${Q}_${!!_.trimForExclusions}`;let oe=t.get(ie);if(oe)return b(oe,Y);let Ee;return i.test(Q)?oe=c(Q.substr(4),Q):(Ee=d.exec(S(Q,_)))?oe=u(Ee[1],Q):(_.trimForExclusions?y:h).test(Q)?oe=m(Q,_):(Ee=w.exec(S(Q,_)))?oe=f(Ee[1].substr(1),Q,!0):(Ee=g.exec(S(Q,_)))?oe=f(Ee[1],Q,!1):oe=n(Q),t.set(ie,oe),b(oe,Y)}function b(Y,_){if(typeof _=="string")return Y;const Q=function(ie,oe){return(0,l.isEqualOrParent)(ie,_.base,!P.isLinux)?Y((0,D.ltrim)(ie.substr(_.base.length),A.sep),oe):null};return Q.allBasenames=Y.allBasenames,Q.allPaths=Y.allPaths,Q.basenames=Y.basenames,Q.patterns=Y.patterns,Q}function S(Y,_){return _.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function c(Y,_){return function(Q,ie){return typeof Q=="string"&&Q.endsWith(Y)?_:null}}function u(Y,_){const Q=`/${Y}`,ie=`\\${Y}`,oe=function(he,fe){return typeof he!="string"?null:fe?fe===Y?_:null:he===Y||he.endsWith(Q)||he.endsWith(ie)?_:null},Ee=[Y];return oe.basenames=Ee,oe.patterns=[_],oe.allBasenames=Ee,oe}function m(Y,_){const Q=F(Y.slice(1,-1).split(",").map(fe=>a(fe,_)).filter(fe=>fe!==r),Y),ie=Q.length;if(!ie)return r;if(ie===1)return Q[0];const oe=function(fe,x){for(let B=0,Z=Q.length;B<Z;B++)if(Q[B](fe,x))return Y;return null},Ee=Q.find(fe=>!!fe.allBasenames);Ee&&(oe.allBasenames=Ee.allBasenames);const he=Q.reduce((fe,x)=>x.allPaths?fe.concat(x.allPaths):fe,[]);return he.length&&(oe.allPaths=he),oe}function f(Y,_,Q){const ie=A.sep===A.posix.sep,oe=ie?Y:Y.replace(E,A.sep),Ee=A.sep+oe,he=A.posix.sep+Y;let fe;return Q?fe=function(x,B){return typeof x=="string"&&(x===oe||x.endsWith(Ee)||!ie&&(x===Y||x.endsWith(he)))?_:null}:fe=function(x,B){return typeof x=="string"&&(x===oe||!ie&&x===Y)?_:null},fe.allPaths=[(Q?"*/":"./")+Y],fe}function n(Y){try{const _=new RegExp(`^${v(Y)}$`);return function(Q){return _.lastIndex=0,typeof Q=="string"&&_.test(Q)?Y:null}}catch{return r}}function C(Y,_,Q){return!Y||typeof _!="string"?!1:M(Y)(_,void 0,Q)}e.match=C;function M(Y,_={}){if(!Y)return s;if(typeof Y=="string"||H(Y)){const Q=a(Y,_);if(Q===r)return s;const ie=function(oe,Ee){return!!Q(oe,Ee)};return Q.allBasenames&&(ie.allBasenames=Q.allBasenames),Q.allPaths&&(ie.allPaths=Q.allPaths),ie}return z(Y,_)}e.parse=M;function H(Y){const _=Y;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}e.isRelativePattern=H;function V(Y){return Y.allBasenames||[]}e.getBasenameTerms=V;function U(Y){return Y.allPaths||[]}e.getPathTerms=U;function z(Y,_){const Q=F(Object.getOwnPropertyNames(Y).map(fe=>G(fe,Y[fe],_)).filter(fe=>fe!==r)),ie=Q.length;if(!ie)return r;if(!Q.some(fe=>!!fe.requiresSiblings)){if(ie===1)return Q[0];const fe=function(Z,pe){let Se;for(let re=0,ne=Q.length;re<ne;re++){const de=Q[re](Z,pe);if(typeof de=="string")return de;(0,R.isThenable)(de)&&(Se||(Se=[]),Se.push(de))}return Se?(async()=>{for(const re of Se){const ne=await re;if(typeof ne=="string")return ne}return null})():null},x=Q.find(Z=>!!Z.allBasenames);x&&(fe.allBasenames=x.allBasenames);const B=Q.reduce((Z,pe)=>pe.allPaths?Z.concat(pe.allPaths):Z,[]);return B.length&&(fe.allPaths=B),fe}const oe=function(fe,x,B){let Z,pe;for(let Se=0,re=Q.length;Se<re;Se++){const ne=Q[Se];ne.requiresSiblings&&B&&(x||(x=(0,A.basename)(fe)),Z||(Z=x.substr(0,x.length-(0,A.extname)(fe).length)));const de=ne(fe,x,Z,B);if(typeof de=="string")return de;(0,R.isThenable)(de)&&(pe||(pe=[]),pe.push(de))}return pe?(async()=>{for(const Se of pe){const re=await Se;if(typeof re=="string")return re}return null})():null},Ee=Q.find(fe=>!!fe.allBasenames);Ee&&(oe.allBasenames=Ee.allBasenames);const he=Q.reduce((fe,x)=>x.allPaths?fe.concat(x.allPaths):fe,[]);return he.length&&(oe.allPaths=he),oe}function G(Y,_,Q){if(_===!1)return r;const ie=a(Y,Q);if(ie===r)return r;if(typeof _=="boolean")return ie;if(_){const oe=_.when;if(typeof oe=="string"){const Ee=(he,fe,x,B)=>{if(!B||!ie(he,fe))return null;const Z=oe.replace("$(basename)",()=>x),pe=B(Z);return(0,R.isThenable)(pe)?pe.then(Se=>Se?Y:null):pe?Y:null};return Ee.requiresSiblings=!0,Ee}}return ie}function F(Y,_){const Q=Y.filter(fe=>!!fe.basenames);if(Q.length<2)return Y;const ie=Q.reduce((fe,x)=>{const B=x.basenames;return B?fe.concat(B):fe},[]);let oe;if(_){oe=[];for(let fe=0,x=ie.length;fe<x;fe++)oe.push(_)}else oe=Q.reduce((fe,x)=>{const B=x.patterns;return B?fe.concat(B):fe},[]);const Ee=function(fe,x){if(typeof fe!="string")return null;if(!x){let Z;for(Z=fe.length;Z>0;Z--){const pe=fe.charCodeAt(Z-1);if(pe===47||pe===92)break}x=fe.substr(Z)}const B=ie.indexOf(x);return B!==-1?oe[B]:null};Ee.basenames=ie,Ee.patterns=oe,Ee.allBasenames=ie;const he=Y.filter(fe=>!fe.basenames);return he.push(Ee),he}function $(Y,_){return(0,o.equals)(Y,_,(Q,ie)=>typeof Q=="string"&&typeof ie=="string"?Q===ie:typeof Q!="string"&&typeof ie!="string"?Q.base===ie.base&&Q.pattern===ie.pattern:!1)}e.patternsEquals=$}),define(Ce[113],ke([1,0,8,166,24,9,2]),function(ae,e,o,R,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(i){i[i.Paragraph=0]="Paragraph",i[i.Break=1]="Break"})(P||(e.MarkdownStringTextNewlineStyle=P={}));class D{constructor(d="",h=!1){if(this.value=d,typeof this.value!="string")throw(0,o.illegalArgument)("value");typeof h=="boolean"?(this.isTrusted=h,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=h.isTrusted??void 0,this.supportThemeIcons=h.supportThemeIcons??!1,this.supportHtml=h.supportHtml??!1)}appendText(d,h=0){return this.value+=E(this.supportThemeIcons?(0,R.escapeIcons)(d):d).replace(/([ \t]+)/g,(y,w)=>"&nbsp;".repeat(w.length)).replace(/\>/gm,"\\>").replace(/\n/g,h===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,h){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=h,this.value+="\n```\n",this}appendLink(d,h,y){return this.value+="[",this.value+=this.c(h,"]"),this.value+="](",this.value+=this.c(String(d),")"),y&&(this.value+=` "${this.c(this.c(y,'"'),")")}"`),this.value+=")",this}c(d,h){const y=new RegExp((0,L.escapeRegExpCharacters)(h),"g");return d.replace(y,(w,g)=>d.charAt(g-1)!=="\\"?`\\${w}`:w)}}e.MarkdownString=D;function p(i){return O(i)?!i.value:Array.isArray(i)?i.every(p):!0}e.isEmptyMarkdownString=p;function O(i){return i instanceof D?!0:i&&typeof i=="object"?typeof i.value=="string"&&(typeof i.isTrusted=="boolean"||typeof i.isTrusted=="object"||i.isTrusted===void 0)&&(typeof i.supportThemeIcons=="boolean"||i.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function k(i,d){return i===d?!0:!i||!d?!1:i.value===d.value&&i.isTrusted===d.isTrusted&&i.supportThemeIcons===d.supportThemeIcons&&i.supportHtml===d.supportHtml&&(i.baseUri===d.baseUri||!!i.baseUri&&!!d.baseUri&&(0,l.isEqual)(A.URI.from(i.baseUri),A.URI.from(d.baseUri)))}e.markdownStringEqual=k;function E(i){return i.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=E;function T(i){return i.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=T;function I(i){return i&&i.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=I;function v(i){const d=[],h=i.split("|").map(w=>w.trim());i=h[0];const y=h[1];if(y){const w=/height=(\d+)/.exec(y),g=/width=(\d+)/.exec(y),t=w?w[1]:"",s=g?g[1]:"",r=isFinite(parseInt(s)),a=isFinite(parseInt(t));r&&d.push(`width="${s}"`),a&&d.push(`height="${t}"`)}return{href:i,dimensions:d}}e.parseHrefAndDimensions=v}),define(Ce[114],ke([1,0,18,33,15,14,24,9]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function D(r,a){const{os:b,tildify:S,relative:c}=a;if(c){const f=p(r,c,b);if(typeof f=="string")return f}let u=r.fsPath;if(b===1&&!L.isWindows?u=u.replace(/\//g,"\\"):b!==1&&L.isWindows&&(u=u.replace(/\\/g,"/")),b!==1&&S?.userHome){const f=S.userHome.fsPath;let n;r.scheme!==S.userHome.scheme&&r.path.startsWith(l.posix.sep)?n=S.userHome.with({path:r.path}).fsPath:n=r.fsPath,u=E(n,f,b)}return(b===1?l.win32:l.posix).normalize(O(u,b===1))}e.getPathLabel=D;function p(r,a,b){const S=b===1?l.win32:l.posix,c=b===3?A.extUri:A.extUriIgnorePathCase,u=a.getWorkspace(),m=(0,o.firstOrDefault)(u.folders);if(!m)return;r.scheme!==m.uri.scheme&&r.path.startsWith(l.posix.sep)&&(r=m.uri.with({path:r.path}));const f=a.getWorkspaceFolder(r);if(!f)return;let n;if(c.isEqual(f.uri,r)?n="":n=c.relativePath(f.uri,r)??"",n&&(n=S.normalize(n)),u.folders.length>1&&!a.noPrefix){const C=f.name?f.name:c.basenameOrAuthority(f.uri);n=n?`${C} \u2022 ${n}`:C}return n}function O(r,a=L.isWindows){return(0,R.hasDriveLetter)(r,a)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=O;let k=Object.create(null);function E(r,a,b=L.OS){if(b===1||!r||!a)return r;let S=k.original===a?k.normalized:void 0;S||(S=a,L.isWindows&&(S=(0,R.toSlashes)(S)),S=`${(0,P.rtrim)(S,l.posix.sep)}${l.posix.sep}`,k={original:a,normalized:S});let c=r;return L.isWindows&&(c=(0,R.toSlashes)(c)),(b===3?c.startsWith(S):(0,P.startsWithIgnoreCase)(c,S))?`~/${c.substr(S.length)}`:r}e.tildify=E;function T(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=T;const I="\u2026",v="\\\\",i="~";function d(r,a=l.sep){const b=new Array(r.length);let S=!1;for(let c=0;c<r.length;c++){const u=r[c];if(u===""){b[c]=`.${a}`;continue}if(!u){b[c]=u;continue}S=!0;let m="",f=u;f.indexOf(v)===0?(m=f.substr(0,f.indexOf(v)+v.length),f=f.substr(f.indexOf(v)+v.length)):f.indexOf(a)===0?(m=f.substr(0,f.indexOf(a)+a.length),f=f.substr(f.indexOf(a)+a.length)):f.indexOf(i)===0&&(m=f.substr(0,f.indexOf(i)+i.length),f=f.substr(f.indexOf(i)+i.length));const n=f.split(a);for(let C=1;S&&C<=n.length;C++)for(let M=n.length-C;S&&M>=0;M--){S=!1;let H=n.slice(M,M+C).join(a);for(let V=0;!S&&V<r.length;V++)if(V!==c&&r[V]&&r[V].indexOf(H)>-1){const U=M+C===n.length,z=M>0&&r[V].indexOf(a)>-1?a+H:H,G=r[V].endsWith(z);S=!U||G}if(!S){let V="";(n[0].endsWith(":")||m!=="")&&(M===1&&(M=0,C++,H=n[0]+a+H),M>0&&(V=n[0]+a),V=m+V),M>0&&(V=V+I+a),V=V+H,M+C<n.length&&(V=V+a+I),b[c]=V}}S&&(b[c]=u)}return b}e.shorten=d;var h;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function y(r,a=Object.create(null)){const b=[];let S=!1,c="";for(const u of r)if(u==="$"||S&&u==="{")c&&b.push({value:c,type:h.TEXT}),c="",S=!0;else if(u==="}"&&S){const m=a[c];if(typeof m=="string")m.length&&b.push({value:m,type:h.VARIABLE});else if(m){const f=b[b.length-1];(!f||f.type!==h.SEPARATOR)&&b.push({value:m.label,type:h.SEPARATOR})}c="",S=!1}else c+=u;return c&&!S&&b.push({value:c,type:h.TEXT}),b.filter((u,m)=>{if(u.type===h.SEPARATOR){const f=b[m-1],n=b[m+1];return[f,n].every(C=>C&&(C.type===h.VARIABLE||C.type===h.TEXT)&&C.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=y;function w(r,a){return L.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):r.replace(/&&|&/g,b=>b==="&"?"&&":"&")}e.mnemonicMenuLabel=w;function g(r,a){return L.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):L.isWindows?r.replace(/&&|&/g,b=>b==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=g;function t(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=t;function s(r){const a=r.indexOf("/")!==-1?l.posix:l.win32,b=a.basename(r),S=a.dirname(r);return b.length?{name:b,parentPath:S}:{name:S,parentPath:""}}e.splitName=s}),define(Ce[115],ke([1,0,22,2]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(k){return k.toJSON()}class L{constructor(E){this.a=E}transformIncoming(E){const T=this.a.transformIncoming(E);return T===E?E:l(R.URI.from(T))}transformOutgoing(E){const T=this.a.transformOutgoing(E);return T===E?E:l(R.URI.from(T))}transformOutgoingURI(E){const T=this.a.transformOutgoing(E);return T===E?E:R.URI.from(T)}transformOutgoingScheme(E){return this.a.transformOutgoingScheme(E)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(k){return k}transformOutgoing(k){return k}transformOutgoingURI(k){return k}transformOutgoingScheme(k){return k}};function A(k,E,T){if(!k||T>200)return null;if(typeof k=="object"){if(k instanceof R.URI)return E.transformOutgoing(k);for(const I in k)if(Object.hasOwnProperty.call(k,I)){const v=A(k[I],E,T+1);v!==null&&(k[I]=v)}}return null}function P(k,E){const T=A(k,E,0);return T===null?k:T}e.transformOutgoingURIs=P;function D(k,E,T,I){if(!k||I>200)return null;if(typeof k=="object"){if(k.$mid===1)return T?R.URI.revive(E.transformIncoming(k)):E.transformIncoming(k);if(k instanceof o.VSBuffer)return null;for(const v in k)if(Object.hasOwnProperty.call(k,v)){const i=D(k[v],E,T,I+1);i!==null&&(k[v]=i)}}return null}function p(k,E){const T=D(k,E,!1,0);return T===null?k:T}e.transformIncomingURIs=p;function O(k,E){const T=D(k,E,!0,0);return T===null?k:T}e.transformAndReviveIncomingURIs=O}),define(Ce[29],ke([1,0,71,72,328,19,33,88,15,14,24,2]),function(ae,e,o,R,l,L,A,P,D,p,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var E;(function(z){z[z.UNLINK=0]="UNLINK",z[z.MOVE=1]="MOVE"})(E||(e.RimRafMode=E={}));async function T(z,G=E.UNLINK){if((0,A.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");return G===E.UNLINK?v(z):I(z)}async function I(z){try{const G=(0,A.randomPath)((0,R.tmpdir)());try{await o.promises.rename(z,G)}catch(F){return F.code==="ENOENT"?void 0:v(z)}v(G).catch(F=>{})}catch(G){if(G.code!=="ENOENT")throw G}}async function v(z){return(0,l.promisify)(o.rm)(z,{recursive:!0,force:!0,maxRetries:3})}function i(z){if((0,A.isRootOrDriveLetter)(z))throw new Error("rimraf - will refuse to recursively delete root");o.rmSync(z,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=i;async function d(z,G){return w(await(G?h(z):(0,l.promisify)(o.readdir)(z)))}async function h(z){try{return await(0,l.promisify)(o.readdir)(z,{withFileTypes:!0})}catch($){console.warn("[node.js fs] readdir with filetypes failed with error: ",$)}const G=[],F=await d(z);for(const $ of F){let Y=!1,_=!1,Q=!1;try{const ie=await e.Promises.lstat((0,D.join)(z,$));Y=ie.isFile(),_=ie.isDirectory(),Q=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}G.push({name:$,isFile:()=>Y,isDirectory:()=>_,isSymbolicLink:()=>Q})}return G}function y(z){return w(o.readdirSync(z))}e.readdirSync=y;function w(z){return z.map(G=>typeof G=="string"?p.isMacintosh?(0,P.normalizeNFC)(G):G:(G.name=p.isMacintosh?(0,P.normalizeNFC)(G.name):G.name,G))}async function g(z){const G=await d(z),F=[];for(const $ of G)await s.existsDirectory((0,D.join)(z,$))&&F.push($);return F}function t(z,G=1e3){return new Promise(F=>{let $=!1;const Y=setInterval(()=>{$||($=!0,o.access(z,_=>{$=!1,_&&(clearInterval(Y),F(void 0))}))},G)})}e.whenDeleted=t;var s;(function(z){async function G(Y){let _;try{if(_=await e.Promises.lstat(Y),!_.isSymbolicLink())return{stat:_}}catch{}try{return{stat:await e.Promises.stat(Y),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(Q){if(Q.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(p.isWindows&&Q.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Y)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw ie}throw Q}}z.stat=G;async function F(Y){try{const{stat:_,symbolicLink:Q}=await z.stat(Y);return _.isFile()&&Q?.dangling!==!0}catch{}return!1}z.existsFile=F;async function $(Y){try{const{stat:_,symbolicLink:Q}=await z.stat(Y);return _.isDirectory()&&Q?.dangling!==!0}catch{}return!1}z.existsDirectory=$})(s||(e.SymlinkSupport=s={}));const r=new L.ResourceQueue;function a(z,G,F){return r.queueFor(k.URI.file(z),O.extUriBiasedIgnorePathCase).queue(()=>{const $=m(F);return new Promise((Y,_)=>c(z,G,$,Q=>Q?_(Q):Y()))})}let b=!0;function S(z){b=z}e.configureFlushOnWrite=S;function c(z,G,F,$){if(!b)return o.writeFile(z,G,{mode:F.mode,flag:F.flag},$);o.open(z,F.flag,F.mode,(Y,_)=>{if(Y)return $(Y);o.writeFile(_,G,Q=>{if(Q)return o.close(_,()=>$(Q));o.fdatasync(_,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),S(!1)),o.close(_,oe=>$(oe))))})})}function u(z,G,F){const $=m(F);if(!b)return o.writeFileSync(z,G,{mode:$.mode,flag:$.flag});const Y=o.openSync(z,$.flag,$.mode);try{o.writeFileSync(Y,G);try{o.fdatasyncSync(Y)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),S(!1)}}finally{o.closeSync(Y)}}e.writeFileSync=u;function m(z){return z?{mode:typeof z.mode=="number"?z.mode:438,flag:typeof z.flag=="string"?z.flag:"w"}:{mode:438,flag:"w"}}async function f(z,G){if(z!==G)try{await e.Promises.rename(z,G)}catch(F){if(z.toLowerCase()!==G.toLowerCase()&&F.code==="EXDEV"||z.endsWith("."))await n(z,G,{preserveSymlinks:!1}),await T(z,E.MOVE);else throw F}}async function n(z,G,F){return M(z,G,{root:{source:z,target:G},options:F,handledSourcePaths:new Set})}const C=511;async function M(z,G,F){if(F.handledSourcePaths.has(z))return;F.handledSourcePaths.add(z);const{stat:$,symbolicLink:Y}=await s.stat(z);if(Y){if(F.options.preserveSymlinks)try{return await U(z,G,F)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(Y.dangling)return}return $.isDirectory()?H(z,G,$.mode&C,F):V(z,G,$.mode&C)}async function H(z,G,F,$){await e.Promises.mkdir(G,{recursive:!0,mode:F});const Y=await d(z);for(const _ of Y)await M((0,D.join)(z,_),(0,D.join)(G,_),$)}async function V(z,G,F){await e.Promises.copyFile(z,G),await e.Promises.chmod(G,F)}async function U(z,G,F){let $=await e.Promises.readlink(z);(0,A.isEqualOrParent)($,F.root.source,!p.isLinux)&&($=(0,D.join)(F.root.target,$.substr(F.root.source.length+1))),await e.Promises.symlink($,G)}e.Promises=new class{get access(){return(0,l.promisify)(o.access)}get stat(){return(0,l.promisify)(o.stat)}get lstat(){return(0,l.promisify)(o.lstat)}get utimes(){return(0,l.promisify)(o.utimes)}get read(){return(z,G,F,$,Y)=>new Promise((_,Q)=>{o.read(z,G,F,$,Y,(ie,oe,Ee)=>ie?Q(ie):_({bytesRead:oe,buffer:Ee}))})}get readFile(){return(0,l.promisify)(o.readFile)}get write(){return(z,G,F,$,Y)=>new Promise((_,Q)=>{o.write(z,G,F,$,Y,(ie,oe,Ee)=>ie?Q(ie):_({bytesWritten:oe,buffer:Ee}))})}get appendFile(){return(0,l.promisify)(o.appendFile)}get fdatasync(){return(0,l.promisify)(o.fdatasync)}get truncate(){return(0,l.promisify)(o.truncate)}get rename(){return(0,l.promisify)(o.rename)}get copyFile(){return(0,l.promisify)(o.copyFile)}get open(){return(0,l.promisify)(o.open)}get close(){return(0,l.promisify)(o.close)}get symlink(){return(0,l.promisify)(o.symlink)}get readlink(){return(0,l.promisify)(o.readlink)}get chmod(){return(0,l.promisify)(o.chmod)}get mkdir(){return(0,l.promisify)(o.mkdir)}get unlink(){return(0,l.promisify)(o.unlink)}get rmdir(){return(0,l.promisify)(o.rmdir)}get realpath(){return(0,l.promisify)(o.realpath)}async exists(z){try{return await e.Promises.access(z),!0}catch{return!1}}get readdir(){return d}get readDirsInDir(){return g}get writeFile(){return a}get rm(){return T}get move(){return f}get copy(){return n}}}),define(Ce[116],ke([1,0,71,15,14,9,29]),function(ae,e,o,R,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(E){if(l.isLinux)return E;const T=(0,R.dirname)(E);if(E===T)return E;const I=((0,R.basename)(E)||E).toLowerCase();try{const i=(0,A.readdirSync)(T).filter(d=>d.toLowerCase()===I);if(i.length===1){const d=P(T);if(d)return(0,R.join)(d,i[0])}else if(i.length>1){const d=i.indexOf(I);if(d>=0){const h=P(T);if(h)return(0,R.join)(h,i[d])}}}catch{}return null}e.realcaseSync=P;async function D(E){if(l.isLinux)return E;const T=(0,R.dirname)(E);if(E===T)return E;const I=((0,R.basename)(E)||E).toLowerCase();try{const i=(await A.Promises.readdir(T)).filter(d=>d.toLowerCase()===I);if(i.length===1){const d=await D(T);if(d)return(0,R.join)(d,i[0])}else if(i.length>1){const d=i.indexOf(I);if(d>=0){const h=await D(T);if(h)return(0,R.join)(h,i[d])}}}catch{}return null}e.realcase=D;async function p(E){try{return await A.Promises.realpath(E)}catch{const I=k(E);return await A.Promises.access(I,o.constants.R_OK),I}}e.realpath=p;function O(E){try{return o.realpathSync(E)}catch{const I=k(E);return o.accessSync(I,o.constants.R_OK),I}}e.realpathSync=O;function k(E){return(0,L.rtrim)((0,R.normalize)(E),R.sep)}}),define(Ce[117],ke([1,0,15,14,36,110,10,29]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function D(k=l.env){return k.comspec||"cmd.exe"}e.getWindowsShell=D;function p(k){let E=[],T=!1;const I=function(v){if(T){E.push(v);return}(!k.send(v,d=>{if(d&&console.error(d),T=!1,E.length>0){const h=E.slice(0);E=[],h.forEach(y=>I(y))}})||R.isWindows)&&(T=!0)};return{send:I}}e.createQueuedSender=p;var O;(function(k){async function E(T,I,v){if(o.isAbsolute(T))return T;if(I===void 0&&(I=l.cwd()),o.dirname(T)!=="."||(v===void 0&&A.isString(l.env.PATH)&&(v=l.env.PATH.split(o.delimiter)),v===void 0||v.length===0))return o.join(I,T);async function d(h){if(await P.Promises.exists(h)){let y;try{y=await P.Promises.stat(h)}catch(w){w.message.startsWith("EACCES")&&(y=await P.Promises.lstat(h))}return y?!y.isDirectory():!1}return!1}for(const h of v){let y;if(o.isAbsolute(h)?y=o.join(h,T):y=o.join(I,h,T),await d(y))return y;let w=y+".com";if(await d(w)||(w=y+".exe",await d(w)))return w}return o.join(I,T)}k.findExecutable=E})(O||(e.win32=O={}))});var xe=this&&this.__decorate||function(ae,e,o,R){var l=arguments.length,L=l<3?e:R===null?R=Object.getOwnPropertyDescriptor(e,o):R,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(ae,e,o,R);else for(var P=ae.length-1;P>=0;P--)(A=ae[P])&&(L=(l<3?A(L):l>3?A(e,o,L):A(e,o))||L);return l>3&&L&&Object.defineProperty(e,o,L),L};define(Ce[118],ke([1,0,18,19,22,21,63,8,3,6,70,9,10]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var T;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(T||(T={}));function I(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var v;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(v||(v={}));function i(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var d;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(d||(d={}));function h(_){let Q=0;for(let ie=0;;ie+=7){const oe=_.read(1);if(Q|=(oe.buffer[0]&127)<<ie,!(oe.buffer[0]&128))return Q}}const y=r(0);function w(_,Q){if(Q===0){_.write(y);return}let ie=0;for(let Ee=Q;Ee!==0;Ee=Ee>>>7)ie++;const oe=l.VSBuffer.alloc(ie);for(let Ee=0;Q!==0;Ee++)oe.buffer[Ee]=Q&127,Q=Q>>>7,Q>0&&(oe.buffer[Ee]|=128);_.write(oe)}class g{constructor(Q){this.b=Q,this.a=0}read(Q){const ie=this.b.slice(this.a,this.a+Q);return this.a+=ie.byteLength,ie}}e.BufferReader=g;class t{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write(Q){this.a.push(Q)}}e.BufferWriter=t;var s;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object",_[_.Int=6]="Int"})(s||(s={}));function r(_){const Q=l.VSBuffer.alloc(1);return Q.writeUInt8(_,0),Q}const a={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object),Uint:r(s.Int)},b=typeof Buffer<"u";function S(_,Q){if(typeof Q>"u")_.write(a.Undefined);else if(typeof Q=="string"){const ie=l.VSBuffer.fromString(Q);_.write(a.String),w(_,ie.byteLength),_.write(ie)}else if(b&&Buffer.isBuffer(Q)){const ie=l.VSBuffer.wrap(Q);_.write(a.Buffer),w(_,ie.byteLength),_.write(ie)}else if(Q instanceof l.VSBuffer)_.write(a.VSBuffer),w(_,Q.byteLength),_.write(Q);else if(Array.isArray(Q)){_.write(a.Array),w(_,Q.length);for(const ie of Q)S(_,ie)}else if(typeof Q=="number"&&(Q|0)===Q)_.write(a.Uint),w(_,Q);else{const ie=l.VSBuffer.fromString(JSON.stringify(Q));_.write(a.Object),w(_,ie.byteLength),_.write(ie)}}e.serialize=S;function c(_){switch(_.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return _.read(h(_)).toString();case s.Buffer:return _.read(h(_)).buffer;case s.VSBuffer:return _.read(h(_));case s.Array:{const ie=h(_),oe=[];for(let Ee=0;Ee<ie;Ee++)oe.push(c(_));return oe}case s.Object:return JSON.parse(_.read(h(_)).toString());case s.Int:return h(_)}}e.deserialize=c;class u{constructor(Q,ie,oe=null,Ee=1e3){this.h=Q,this.j=ie,this.k=oe,this.l=Ee,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(he=>this.q(he)),this.m({type:200})}registerChannel(Q,ie){this.b.set(Q,ie),setTimeout(()=>this.w(Q),0)}m(Q){switch(Q.type){case 200:{const ie=this.o([Q.type]);this.k?.logOutgoing(ie,0,1,i(Q.type));return}case 201:case 202:case 204:case 203:{const ie=this.o([Q.type,Q.id],Q.data);this.k?.logOutgoing(ie,Q.id,1,i(Q.type),Q.data);return}}}o(Q,ie=void 0){const oe=new t;return S(oe,Q),S(oe,ie),this.p(oe.buffer)}p(Q){try{return this.h.send(Q),Q.byteLength}catch{return 0}}q(Q){const ie=new g(Q),oe=c(ie),Ee=c(ie),he=oe[0];switch(he){case 100:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${I(he)}: ${oe[2]}.${oe[3]}`,Ee),this.s({type:he,id:oe[1],channelName:oe[2],name:oe[3],arg:Ee});case 102:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${I(he)}: ${oe[2]}.${oe[3]}`,Ee),this.t({type:he,id:oe[1],channelName:oe[2],name:oe[3],arg:Ee});case 101:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${I(he)}`),this.u({type:he,id:oe[1]});case 103:return this.k?.logIncoming(Q.byteLength,oe[1],1,`${I(he)}`),this.u({type:he,id:oe[1]})}}s(Q){const ie=this.b.get(Q.channelName);if(!ie){this.v(Q);return}const oe=new L.CancellationTokenSource;let Ee;try{Ee=ie.call(this.j,Q.name,Q.arg,oe.token)}catch(x){Ee=Promise.reject(x)}const he=Q.id;Ee.then(x=>{this.m({id:he,data:x,type:201}),this.d.delete(Q.id)},x=>{x instanceof Error?this.m({id:he,data:{message:x.message,name:x.name,stack:x.stack?x.stack.split?x.stack.split(`
`):x.stack:void 0},type:202}):this.m({id:he,data:x,type:203}),this.d.delete(Q.id)});const fe=(0,p.toDisposable)(()=>oe.cancel());this.d.set(Q.id,fe)}t(Q){const ie=this.b.get(Q.channelName);if(!ie){this.v(Q);return}const oe=Q.id,he=ie.listen(this.j,Q.name,Q.arg)(fe=>this.m({id:oe,data:fe,type:204}));this.d.set(Q.id,he)}u(Q){const ie=this.d.get(Q.id);ie&&(ie.dispose(),this.d.delete(Q.id))}v(Q){let ie=this.g.get(Q.channelName);ie||(ie=[],this.g.set(Q.channelName,ie));const oe=setTimeout(()=>{console.error(`Unknown channel: ${Q.channelName}`),Q.type===100&&this.m({id:Q.id,data:{name:"Unknown channel",message:`Channel name '${Q.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ie.push({request:Q,timeoutTimer:oe})}w(Q){const ie=this.g.get(Q);if(ie){for(const oe of ie)switch(clearTimeout(oe.timeoutTimer),oe.request.type){case 100:this.s(oe.request);break;case 102:this.t(oe.request);break}this.g.delete(Q)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,p.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=u;var m;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(m||(e.RequestInitiator=m={}));class f{constructor(Q,ie=null){this.l=Q,this.a=!1,this.b=d.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new D.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(oe=>this.s(oe)),this.j=ie}getChannel(Q){const ie=this;return{call(oe,Ee,he){return ie.a?Promise.reject(new P.CancellationError):ie.m(Q,oe,Ee,he)},listen(oe,Ee){return ie.a?D.Event.None:ie.o(Q,oe,Ee)}}}m(Q,ie,oe,Ee=L.CancellationToken.None){const he=this.g++,x={id:he,type:100,channelName:Q,name:ie,arg:oe};if(Ee.isCancellationRequested)return Promise.reject(new P.CancellationError);let B;return new Promise((pe,Se)=>{if(Ee.isCancellationRequested)return Se(new P.CancellationError);const re=()=>{const ce=le=>{switch(le.type){case 201:this.f.delete(he),pe(le.data);break;case 202:{this.f.delete(he);const ue=new Error(le.data.message);ue.stack=Array.isArray(le.data.stack)?le.data.stack.join(`
`):le.data.stack,ue.name=le.data.name,Se(ue);break}case 203:this.f.delete(he),Se(le.data);break}};this.f.set(he,ce),this.p(x)};let ne=null;this.b===d.Idle?re():(ne=(0,R.createCancelablePromise)(ce=>this.u()),ne.then(()=>{ne=null,re()}));const de=()=>{ne?(ne.cancel(),ne=null):this.p({id:he,type:101}),Se(new P.CancellationError)},ee=Ee.onCancellationRequested(de);B=(0,p.combinedDisposable)((0,p.toDisposable)(de),ee),this.d.add(B)}).finally(()=>{this.d.delete(B)})}o(Q,ie,oe){const Ee=this.g++,fe={id:Ee,type:102,channelName:Q,name:ie,arg:oe};let x=null;const B=new D.Emitter({onWillAddFirstListener:()=>{x=(0,R.createCancelablePromise)(pe=>this.u()),x.then(()=>{x=null,this.d.add(B),this.p(fe)})},onDidRemoveLastListener:()=>{x?(x.cancel(),x=null):(this.d.delete(B),this.p({id:Ee,type:103}))}}),Z=pe=>B.fire(pe.data);return this.f.set(Ee,Z),B.event}p(Q){switch(Q.type){case 100:case 102:{const ie=this.q([Q.type,Q.id,Q.channelName,Q.name],Q.arg);this.j?.logOutgoing(ie,Q.id,0,`${I(Q.type)}: ${Q.channelName}.${Q.name}`,Q.arg);return}case 101:case 103:{const ie=this.q([Q.type,Q.id]);this.j?.logOutgoing(ie,Q.id,0,I(Q.type));return}}}q(Q,ie=void 0){const oe=new t;return S(oe,Q),S(oe,ie),this.r(oe.buffer)}r(Q){try{return this.l.send(Q),Q.byteLength}catch{return 0}}s(Q){const ie=new g(Q),oe=c(ie),Ee=c(ie),he=oe[0];switch(he){case 200:return this.j?.logIncoming(Q.byteLength,0,0,i(he)),this.t({type:oe[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(Q.byteLength,oe[1],0,i(he),Ee),this.t({type:oe[0],id:oe[1],data:Ee})}}t(Q){if(Q.type===200){this.b=d.Idle,this.k.fire();return}this.f.get(Q.id)?.(Q)}get onDidInitializePromise(){return D.Event.toPromise(this.onDidInitialize)}u(){return this.b===d.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,p.dispose)(this.d.values()),this.d.clear()}}e.ChannelClient=f,xe([A.memoize],f.prototype,"onDidInitializePromise",null);class n{get connections(){const Q=[];return this.f.forEach(ie=>Q.push(ie)),Q}constructor(Q){this.a=new Map,this.f=new Set,this.g=new D.Emitter,this.onDidAddConnection=this.g.event,this.h=new D.Emitter,this.onDidRemoveConnection=this.h.event,Q(({protocol:ie,onDidClientDisconnect:oe})=>{D.Event.once(ie.onMessage)(he=>{const fe=new g(he),x=c(fe),B=new u(ie,x),Z=new f(ie);this.a.forEach((Se,re)=>B.registerChannel(re,Se));const pe={channelServer:B,channelClient:Z,ctx:x};this.f.add(pe),this.g.fire(pe),oe(()=>{B.dispose(),Z.dispose(),this.f.delete(pe),this.h.fire(pe)})})})}getChannel(Q,ie){const oe=this;return{call(Ee,he,fe){let x;if((0,E.isFunction)(ie)){const Z=(0,o.getRandomElement)(oe.connections.filter(ie));x=Z?Promise.resolve(Z):D.Event.toPromise(D.Event.filter(oe.onDidAddConnection,ie))}else x=ie.routeCall(oe,Ee,he);const B=x.then(Z=>Z.channelClient.getChannel(Q));return M(B).call(Ee,he,fe)},listen(Ee,he){if((0,E.isFunction)(ie))return oe.j(Q,ie,Ee,he);const fe=ie.routeEvent(oe,Ee,he).then(x=>x.channelClient.getChannel(Q));return M(fe).listen(Ee,he)}}}j(Q,ie,oe,Ee){const he=this;let fe=new p.DisposableStore;const x=new D.Emitter({onWillAddFirstListener:()=>{fe=new p.DisposableStore;const B=new D.EventMultiplexer,Z=new Map,pe=re=>{const de=re.channelClient.getChannel(Q).listen(oe,Ee),ee=B.add(de);Z.set(re,ee)},Se=re=>{const ne=Z.get(re);ne&&(ne.dispose(),Z.delete(re))};he.connections.filter(ie).forEach(pe),D.Event.filter(he.onDidAddConnection,ie)(pe,void 0,fe),he.onDidRemoveConnection(Se,void 0,fe),B.event(x.fire,x,fe),fe.add(B)},onDidRemoveLastListener:()=>{fe.dispose()}});return x.event}registerChannel(Q,ie){this.a.set(Q,ie),this.f.forEach(oe=>{oe.channelServer.registerChannel(Q,ie)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=n;class C{constructor(Q,ie,oe=null){const Ee=new t;S(Ee,ie),Q.send(Ee.buffer),this.a=new f(Q,oe),this.d=new u(Q,ie,oe)}getChannel(Q){return this.a.getChannel(Q)}registerChannel(Q,ie){this.d.registerChannel(Q,ie)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=C;function M(_){return{call(Q,ie,oe){return _.then(Ee=>Ee.call(Q,ie,oe))},listen(Q,ie){const oe=new D.Relay;return _.then(Ee=>oe.input=Ee.listen(Q,ie)),oe.event}}}e.getDelayedChannel=M;function H(_){let Q=!1;return{call(ie,oe,Ee){return Q?_.call(ie,oe,Ee):(0,R.timeout)(0).then(()=>Q=!0).then(()=>_.call(ie,oe,Ee))},listen(ie,oe){if(Q)return _.listen(ie,oe);const Ee=new D.Relay;return(0,R.timeout)(0).then(()=>Q=!0).then(()=>Ee.input=_.listen(ie,oe)),Ee.event}}}e.getNextTickChannel=H;class V{constructor(Q){this.a=Q}routeCall(Q){return this.b(Q)}routeEvent(Q){return this.b(Q)}async b(Q){for(const ie of Q.connections)if(await Promise.resolve(this.a(ie.ctx)))return Promise.resolve(ie);return await D.Event.toPromise(Q.onDidAddConnection),await this.b(Q)}}e.StaticRouter=V;var U;(function(_){function Q(he,fe){const x=he,B=fe&&fe.disableMarshalling,Z=new Map;for(const pe in x)oe(pe)&&Z.set(pe,D.Event.buffer(x[pe],!0));return new class{listen(pe,Se,re){const ne=Z.get(Se);if(ne)return ne;if(Ee(Se)){const de=x[Se];if(typeof de=="function")return de.call(x,re)}throw new Error(`Event not found: ${Se}`)}call(pe,Se,re){const ne=x[Se];if(typeof ne=="function"){if(!B&&Array.isArray(re))for(let de=0;de<re.length;de++)re[de]=(0,O.revive)(re[de]);return ne.apply(x,re)}throw new Error(`Method not found: ${Se}`)}}}_.fromService=Q;function ie(he,fe){const x=fe&&fe.disableMarshalling;return new Proxy({},{get(B,Z){if(typeof Z=="string")return fe?.properties?.has(Z)?fe.properties.get(Z):Ee(Z)?function(pe){return he.listen(Z,pe)}:oe(Z)?he.listen(Z):async function(...pe){let Se;fe&&!(0,E.isUndefinedOrNull)(fe.context)?Se=[fe.context,...pe]:Se=pe;const re=await he.call(Z,Se);return x?re:(0,O.revive)(re)};throw new Error(`Property not found: ${String(Z)}`)}})}_.toService=ie;function oe(he){return he[0]==="o"&&he[1]==="n"&&k.isUpperAsciiLetter(he.charCodeAt(2))}function Ee(he){return/^onDynamic/.test(he)&&k.isUpperAsciiLetter(he.charCodeAt(9))}})(U||(e.ProxyChannel=U={}));const z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function G(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const Q=_.toString();if(Q!=="[object Object]")return Q}return _}function F(_){return Array.isArray(_)?_.map(G):G(_)}function $(_,Q,ie,oe,Ee,he,fe){fe=F(fe);const x=z[Ee],B=x[oe%x.length];let Z=[`%c[${_}]%c[${String(Q).padStart(7," ")}]%c[len: ${String(ie).padStart(5," ")}]%c${String(oe).padStart(5," ")} - ${he}`,"color: darkgreen","color: grey","color: grey",`color: ${B}`];/\($/.test(he)?(Z=Z.concat(fe),Z.push(")")):Z.push(fe),console.log.apply(console,Z)}class Y{constructor(Q,ie){this.d=Q,this.f=ie,this.a=0,this.b=0}logOutgoing(Q,ie,oe,Ee,he){this.b+=Q,$(this.d,this.b,Q,ie,oe,Ee,he)}logIncoming(Q,ie,oe,Ee,he){this.a+=Q,$(this.f,this.a,Q,ie,oe,Ee,he)}}e.IPCLogger=Y}),define(Ce[119],ke([1,0,19,22,3,6,118]),function(ae,e,o,R,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(f){f.Created="created",f.Read="read",f.Write="write",f.Open="open",f.Error="error",f.Close="close",f.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",f.NodeEndReceived="nodeEndReceived",f.NodeEndSent="nodeEndSent",f.NodeDrainBegin="nodeDrainBegin",f.NodeDrainEnd="nodeDrainEnd",f.zlibInflateError="zlibInflateError",f.zlibInflateData="zlibInflateData",f.zlibInflateInitialWrite="zlibInflateInitialWrite",f.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",f.zlibInflateWrite="zlibInflateWrite",f.zlibInflateFlushFired="zlibInflateFlushFired",f.zlibDeflateError="zlibDeflateError",f.zlibDeflateData="zlibDeflateData",f.zlibDeflateWrite="zlibDeflateWrite",f.zlibDeflateFlushFired="zlibDeflateFlushFired",f.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",f.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",f.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",f.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",f.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",f.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",f.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",f.ProtocolHeaderRead="protocolHeaderRead",f.ProtocolMessageRead="protocolMessageRead",f.ProtocolHeaderWrite="protocolHeaderWrite",f.ProtocolMessageWrite="protocolMessageWrite",f.ProtocolWrite="protocolWrite"})(P||(e.SocketDiagnosticsEventType=P={}));var D;(function(f){f.enableDiagnostics=!1,f.records=[];const n=new WeakMap;let C=0;function M(V,U){if(!n.has(V)){const z=String(++C);n.set(V,z)}return n.get(V)}function H(V,U,z,G){if(!f.enableDiagnostics)return;const F=M(V,U);if(G instanceof R.VSBuffer||G instanceof Uint8Array||G instanceof ArrayBuffer||ArrayBuffer.isView(G)){const $=R.VSBuffer.alloc(G.byteLength);$.set(G),f.records.push({timestamp:Date.now(),id:F,label:U,type:z,buff:$})}else f.records.push({timestamp:Date.now(),id:F,label:U,type:z,data:G})}f.traceSocketEvent=H})(D||(e.SocketDiagnostics=D={}));var p;(function(f){f[f.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",f[f.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(p||(e.SocketCloseEventType=p={}));let O=null;function k(){return O||(O=R.VSBuffer.alloc(0)),O}class E{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(n){this.a.push(n),this.b+=n.byteLength}read(n){return this.c(n,!0)}peek(n){return this.c(n,!1)}c(n,C){if(n===0)return k();if(n>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===n){const U=this.a[0];return C&&(this.a.shift(),this.b-=n),U}if(this.a[0].byteLength>n){const U=this.a[0].slice(0,n);return C&&(this.a[0]=this.a[0].slice(n),this.b-=n),U}const M=R.VSBuffer.alloc(n);let H=0,V=0;for(;n>0;){const U=this.a[V];if(U.byteLength>n){const z=U.slice(0,n);M.set(z,H),H+=n,C&&(this.a[V]=U.slice(n),this.b-=n),n-=n}else M.set(U,H),H+=U.byteLength,C?(this.a.shift(),this.b-=U.byteLength):V++,n-=U.byteLength}return M}}e.ChunkStream=E;var T;(function(f){f[f.None=0]="None",f[f.Regular=1]="Regular",f[f.Control=2]="Control",f[f.Ack=3]="Ack",f[f.Disconnect=5]="Disconnect",f[f.ReplayRequest=6]="ReplayRequest",f[f.Pause=7]="Pause",f[f.Resume=8]="Resume",f[f.KeepAlive=9]="KeepAlive",f[f.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",f[f.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(T||(T={}));function I(f){switch(f){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var v;(function(f){f[f.HeaderLength=13]="HeaderLength",f[f.AcknowledgeTime=2e3]="AcknowledgeTime",f[f.TimeoutTime=2e4]="TimeoutTime",f[f.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",f[f.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",f[f.KeepAliveSendTime=5e3]="KeepAliveSendTime",f[f.LatencySampleTime=6e4]="LatencySampleTime",f[f.LatencySampleCount=5]="LatencySampleCount",f[f.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",f[f.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(v||(e.ProtocolConstants=v={}));class i{constructor(n,C,M,H){this.type=n,this.id=C,this.ack=M,this.data=H,this.writtenTime=0}get size(){return this.data.byteLength}}class d extends L.Disposable{constructor(n){super(),this.f=this.B(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=n,this.b=!1,this.c=new E,this.B(this.a.onData(C=>this.acceptChunk(C))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(n);this.c.byteLength>=this.g.readLen;){const C=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=C.readUInt32BE(9),this.g.messageType=C.readUInt8(0),this.g.id=C.readUInt32BE(1),this.g.ack=C.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:I(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const M=this.g.messageType,H=this.g.id,V=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",C),this.f.fire(new i(M,H,V,C)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class h{constructor(n){this.k=null,this.a=!1,this.b=!1,this.c=n,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(n){if(this.a)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const C=R.VSBuffer.alloc(13);C.writeUInt8(n.type,0),C.writeUInt32BE(n.id,1),C.writeUInt32BE(n.ack,5),C.writeUInt32BE(n.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:I(n.type),id:n.id,ack:n.ack,messageSize:n.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",n.data),this.j(C,n.data)}g(n,C){const M=this.f===0;return this.d.push(n,C),this.f+=n.byteLength+C.byteLength,M}h(){const n=R.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,n}j(n,C){this.g(n,C)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const n=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:n.byteLength}),this.c.write(n)}}class y extends L.Disposable{constructor(n){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=n,this.b=this.B(new h(this.a)),this.c=this.B(new d(this.a)),this.B(this.c.onMessage(C=>{C.type===1&&this.f.fire(C.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(n){this.b.write(new i(1,0,0,n))}}e.Protocol=y;class w extends A.IPCClient{static fromSocket(n,C){return new w(new y(n),C)}get onDidDispose(){return this.b.onDidDispose}constructor(n,C,M=null){super(n,C,M),this.b=n}dispose(){super.dispose();const n=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),n.end()}}e.Client=w;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(n){this.b?this.d.length>0?this.d.push(n):this.a.fire(n):this.d.push(n)}flushBuffer(){this.d=[]}}e.BufferedEmitter=g;class t{constructor(n){this.data=n,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let n=0,C=this.a;for(;C;)C=C.next,n++;return n}peek(){return this.a?this.a.data:null}toArray(){const n=[];let C=0,M=this.a;for(;M;)n[C++]=M.data,M=M.next;return n}pop(){if(this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(n){const C=new t(n);if(!this.a){this.a=C,this.b=C;return}this.b.next=C,this.b=C}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const n=Date.now();for(let C=0;C<r.a;C++)this.c[C]=n-1e3*C;setInterval(()=>{for(let C=r.a;C>=1;C--)this.c[C]=this.c[C-1];this.c[0]=Date.now()},1e3)}d(){const n=Date.now(),C=(1+r.a)*1e3;let M=0;for(let H=0;H<r.a;H++)n-this.c[H]<=C&&M++;return 1-M/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;var a;(function(f){f[f.Good=0]="Good",f[f.Poor=1]="Poor"})(a||(e.ConnectionHealth=a={}));function b(f){switch(f){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=b;class S{constructor(n){this.connectionHealth=n}}e.ConnectionHealthChangedEvent=S;class c{constructor(n,C){this.roundTripTime=n,this.recentHighRoundTripCount=C}}e.HighRoundTripTimeEvent=c;class u{get unacknowledgedCount(){return this.c-this.d}constructor(n){this.x=new g,this.onControlMessage=this.x.event,this.y=new g,this.onMessage=this.y.event,this.z=new g,this.onDidDispose=this.z.event,this.A=new g,this.onSocketClose=this.A.event,this.B=new g,this.onSocketTimeout=this.B.event,this.C=new g,this.onHighRoundTripTime=this.C.event,this.D=new g,this.onDidChangeConnectionHealth=this.D.event,this.u=n.loadEstimator??r.getInstance(),this.v=n.measureRoundTripTime??!1,this.w=n.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new L.DisposableStore,this.o=n.socket,this.p=this.t.add(new h(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage(C=>this.E(C))),this.t.add(this.o.onClose(C=>this.A.fire(C))),this.r=this.t.add(new m),this.t.add(this.r.onSendLatencyRequest(C=>this.J(C))),this.t.add(this.r.onHighRoundTripTime(C=>this.C.fire(C))),this.t.add(this.r.onDidChangeConnectionHealth(C=>this.D.fire(C))),this.v&&this.r.start(),n.initialChunk&&this.q.acceptChunk(n.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const n=new i(5,0,0,k());this.p.write(n),this.p.flush()}sendPause(){const n=new i(7,0,0,k());this.p.write(n)}sendResume(){const n=new i(8,0,0,k());this.p.write(n)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(n,C){this.a=!0,this.t.dispose(),this.t=new L.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=n,this.p=this.t.add(new h(this.o)),this.q=this.t.add(new d(this.o)),this.t.add(this.q.onMessage(M=>this.E(M))),this.t.add(this.o.onClose(M=>this.A.fire(M))),this.r=this.t.add(new m),this.t.add(this.r.onSendLatencyRequest(M=>this.J(M))),this.t.add(this.r.onHighRoundTripTime(M=>this.C.fire(M))),this.t.add(this.r.onDidChangeConnectionHealth(M=>this.D.fire(M))),this.q.acceptChunk(C)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const n=new i(3,0,this.h,k());this.p.write(n);const C=this.b.toArray();for(let M=0,H=C.length;M<H;M++)this.p.write(C[M]);this.G()}acceptDisconnect(){this.z.fire()}E(n){if(n.ack>this.d){this.d=n.ack;do{const C=this.b.peek();if(C&&C.id<=n.ack)this.b.pop();else break}while(!0)}switch(n.type){case 0:break;case 1:{if(n.id>this.g)if(n.id!==this.g+1){const C=Date.now();C-this.m>1e4&&(this.m=C,this.p.write(new i(6,0,0,k())))}else this.g=n.id,this.j=Date.now(),this.F(),this.y.fire(n.data);break}case 2:{this.x.fire(n.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const C=this.b.toArray();for(let M=0,H=C.length;M<H;M++)this.p.write(C[M]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(n.data);break}case 11:{this.r.handleResponse(n.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(n){const C=++this.c;this.h=this.g;const M=new i(1,C,this.h,n);this.b.push(M),this.a||(this.p.write(M),this.G())}sendControl(n){const C=new i(2,0,0,n);this.p.write(C)}F(){if(this.g<=this.h||this.k)return;const n=Date.now()-this.j;if(n>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-n+5)}G(){if(this.c<=this.d||this.f||this.a)return;const n=this.b.peek(),C=Date.now()-n.writtenTime,M=Date.now()-this.q.lastReadTime,H=Date.now()-this.n;if(C>=2e4&&M>=2e4&&H>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:C,timeSinceLastReceivedSomeData:M});return}const V=Math.max(2e4-C,2e4-M,2e4-H,500);this.f=setTimeout(()=>{this.f=null,this.G()},V)}H(){if(this.g<=this.h)return;this.h=this.g;const n=new i(3,0,this.h,k());this.p.write(n)}I(){this.h=this.g;const n=new i(9,0,this.h,k());this.p.write(n)}J(n){this.h=this.g;const C=new i(10,0,this.h,n);this.p.write(C)}K(n){this.h=this.g;const C=new i(11,0,this.h,n);this.p.write(C)}}e.PersistentProtocol=u;class m extends L.Disposable{constructor(){super(),this.a=this.B(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new o.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},n=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const n=++this.h,C=R.VSBuffer.alloc(4);C.writeUInt32BE(n,0),this.a.fire(C)},6e4)}handleResponse(n){if(n.byteLength!==4)return;const C=n.readUInt32BE(0);if(this.g<=0||C!==this.h)return;const M=Date.now()-this.g,H=this.k++;this.j[H%this.j.length]=M;const V=this.l,U=this.j.filter(z=>z>=1e3).length;this.l=U>=3?1:0,M>1e3&&this.b.fire(new c(M,U)),V!==this.l&&this.c.fire(this.l)}}}),define(Ce[167],ke([1,0,39,15]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function l(L,A,P,D,p,O){if(Array.isArray(L)){let k=0;for(const E of L){const T=l(E,A,P,D,p,O);if(T===10)return T;T>k&&(k=T)}return k}else{if(typeof L=="string")return D?L==="*"?5:L===P?10:0:0;if(L){const{language:k,pattern:E,scheme:T,hasAccessToAllModels:I,notebookType:v}=L;if(!D&&!I)return 0;v&&p&&(A=p);let i=0;if(T)if(T===A.scheme)i=10;else if(T==="*")i=5;else return 0;if(k)if(k===P)i=10;else if(k==="*")i=Math.max(i,5);else return 0;if(v)if(v===O)i=10;else if(v==="*"&&O!==void 0)i=Math.max(i,5);else return 0;if(E){let d;if(typeof E=="string"?d=E:d={...E,base:(0,R.normalize)(E.base)},d===A.fsPath||(0,o.match)(d,A.fsPath))i=10;else return 0}return i}else return 0}}e.score=l}),define(Ce[168],ke([1,0,9,54,157]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class L{constructor(P,D,p,O){this.d=P,this.f=D,this.g=p,this.h=O,this.j=null,this.k=null}dispose(){this.f.length=0}get version(){return this.h}getText(){return this.k===null&&(this.k=this.f.join(this.g)),this.k}onEvents(P){P.eol&&P.eol!==this.g&&(this.g=P.eol,this.j=null);const D=P.changes;for(const p of D)this.o(p.range),this.p(new R.Position(p.range.startLineNumber,p.range.startColumn),p.text);this.h=P.versionId,this.k=null}l(){if(!this.j){const P=this.g.length,D=this.f.length,p=new Uint32Array(D);for(let O=0;O<D;O++)p[O]=this.f[O].length+P;this.j=new l.PrefixSumComputer(p)}}n(P,D){this.f[P]=D,this.j&&this.j.setValue(P,this.f[P].length+this.g.length)}o(P){if(P.startLineNumber===P.endLineNumber){if(P.startColumn===P.endColumn)return;this.n(P.startLineNumber-1,this.f[P.startLineNumber-1].substring(0,P.startColumn-1)+this.f[P.startLineNumber-1].substring(P.endColumn-1));return}this.n(P.startLineNumber-1,this.f[P.startLineNumber-1].substring(0,P.startColumn-1)+this.f[P.endLineNumber-1].substring(P.endColumn-1)),this.f.splice(P.startLineNumber,P.endLineNumber-P.startLineNumber),this.j&&this.j.removeValues(P.startLineNumber,P.endLineNumber-P.startLineNumber)}p(P,D){if(D.length===0)return;const p=(0,o.splitLines)(D);if(p.length===1){this.n(P.lineNumber-1,this.f[P.lineNumber-1].substring(0,P.column-1)+p[0]+this.f[P.lineNumber-1].substring(P.column-1));return}p[p.length-1]+=this.f[P.lineNumber-1].substring(P.column-1),this.n(P.lineNumber-1,this.f[P.lineNumber-1].substring(0,P.column-1)+p[0]);const O=new Uint32Array(p.length-1);for(let k=1;k<p.length;k++)this.f.splice(P.lineNumber+k-1,0,p[k]),O[k-1]=p[k].length+this.g.length;this.j&&this.j.insertValues(P.lineNumber,O)}}e.MirrorTextModel=L}),define(Ce[169],ke([1,0,9,154,54,32,108]),function(ae,e,o,R,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const P=999;class D{constructor(h,y,w,g){this.searchString=h,this.isRegex=y,this.matchCase=w,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let h;this.isRegex?h=p(this.searchString):h=this.searchString.indexOf(`
`)>=0;let y=null;try{y=o.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:h,global:!0,unicode:!0})}catch{return null}if(!y)return null;let w=!this.isRegex&&!h;return w&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(w=this.matchCase),new A.SearchData(y,this.wordSeparators?(0,R.getMapForWordSeparators)(this.wordSeparators):null,w?this.searchString:null)}}e.SearchParams=D;function p(d){if(!d||d.length===0)return!1;for(let h=0,y=d.length;h<y;h++){const w=d.charCodeAt(h);if(w===10)return!0;if(w===92){if(h++,h>=y)break;const g=d.charCodeAt(h);if(g===110||g===114||g===87)return!0}}return!1}e.isMultilineRegexSource=p;function O(d,h,y){if(!y)return new A.FindMatch(d,null);const w=[];for(let g=0,t=h.length;g<t;g++)w[g]=h[g];return new A.FindMatch(d,w)}e.createFindMatch=O;class k{constructor(h){const y=[];let w=0;for(let g=0,t=h.length;g<t;g++)h.charCodeAt(g)===10&&(y[w++]=g);this.a=y}findLineFeedCountBeforeOffset(h){const y=this.a;let w=0,g=y.length-1;if(g===-1||h<=y[0])return 0;for(;w<g;){const t=w+((g-w)/2>>0);y[t]>=h?g=t-1:y[t+1]>=h?(w=t,g=t):w=t+1}return w+1}}class E{static findMatches(h,y,w,g,t){const s=y.parseSearchRequest();return s?s.regex.multiline?this.b(h,w,new i(s.wordSeparators,s.regex),g,t):this.c(h,w,s,g,t):[]}static a(h,y,w,g,t,s){let r,a=0;g?(a=g.findLineFeedCountBeforeOffset(t),r=y+t+a):r=y+t;let b;if(g){const m=g.findLineFeedCountBeforeOffset(t+s.length)-a;b=r+s.length+m}else b=r+s.length;const S=h.getPositionAt(r),c=h.getPositionAt(b);return new L.Range(S.lineNumber,S.column,c.lineNumber,c.column)}static b(h,y,w,g,t){const s=h.getOffsetAt(y.getStartPosition()),r=h.getValueInRange(y,1),a=h.getEOL()===`\r
`?new k(r):null,b=[];let S=0,c;for(w.reset(0);c=w.next(r);)if(b[S++]=O(this.a(h,s,r,a,c.index,c[0]),c,g),S>=t)return b;return b}static c(h,y,w,g,t){const s=[];let r=0;if(y.startLineNumber===y.endLineNumber){const b=h.getLineContent(y.startLineNumber).substring(y.startColumn-1,y.endColumn-1);return r=this.d(w,b,y.startLineNumber,y.startColumn-1,r,s,g,t),s}const a=h.getLineContent(y.startLineNumber).substring(y.startColumn-1);r=this.d(w,a,y.startLineNumber,y.startColumn-1,r,s,g,t);for(let b=y.startLineNumber+1;b<y.endLineNumber&&r<t;b++)r=this.d(w,h.getLineContent(b),b,0,r,s,g,t);if(r<t){const b=h.getLineContent(y.endLineNumber).substring(0,y.endColumn-1);r=this.d(w,b,y.endLineNumber,0,r,s,g,t)}return s}static d(h,y,w,g,t,s,r,a){const b=h.wordSeparators;if(!r&&h.simpleSearch){const u=h.simpleSearch,m=u.length,f=y.length;let n=-m;for(;(n=y.indexOf(u,n+m))!==-1;)if((!b||v(b,y,f,n,m))&&(s[t++]=new A.FindMatch(new L.Range(w,n+1+g,w,n+1+m+g),null),t>=a))return t;return t}const S=new i(h.wordSeparators,h.regex);let c;S.reset(0);do if(c=S.next(y),c&&(s[t++]=O(new L.Range(w,c.index+1+g,w,c.index+1+c[0].length+g),c,r),t>=a))return t;while(c);return t}static findNextMatch(h,y,w,g){const t=y.parseSearchRequest();if(!t)return null;const s=new i(t.wordSeparators,t.regex);return t.regex.multiline?this.e(h,w,s,g):this.f(h,w,s,g)}static e(h,y,w,g){const t=new l.Position(y.lineNumber,1),s=h.getOffsetAt(t),r=h.getLineCount(),a=h.getValueInRange(new L.Range(t.lineNumber,t.column,r,h.getLineMaxColumn(r)),1),b=h.getEOL()===`\r
`?new k(a):null;w.reset(y.column-1);const S=w.next(a);return S?O(this.a(h,s,a,b,S.index,S[0]),S,g):y.lineNumber!==1||y.column!==1?this.e(h,new l.Position(1,1),w,g):null}static f(h,y,w,g){const t=h.getLineCount(),s=y.lineNumber,r=h.getLineContent(s),a=this.g(w,r,s,y.column,g);if(a)return a;for(let b=1;b<=t;b++){const S=(s+b-1)%t,c=h.getLineContent(S+1),u=this.g(w,c,S+1,1,g);if(u)return u}return null}static g(h,y,w,g,t){h.reset(g-1);const s=h.next(y);return s?O(new L.Range(w,s.index+1,w,s.index+1+s[0].length),s,t):null}static findPreviousMatch(h,y,w,g){const t=y.parseSearchRequest();if(!t)return null;const s=new i(t.wordSeparators,t.regex);return t.regex.multiline?this.h(h,w,s,g):this.j(h,w,s,g)}static h(h,y,w,g){const t=this.b(h,new L.Range(1,1,y.lineNumber,y.column),w,g,10*P);if(t.length>0)return t[t.length-1];const s=h.getLineCount();return y.lineNumber!==s||y.column!==h.getLineMaxColumn(s)?this.h(h,new l.Position(s,h.getLineMaxColumn(s)),w,g):null}static j(h,y,w,g){const t=h.getLineCount(),s=y.lineNumber,r=h.getLineContent(s).substring(0,y.column-1),a=this.k(w,r,s,g);if(a)return a;for(let b=1;b<=t;b++){const S=(t+s-b-1)%t,c=h.getLineContent(S+1),u=this.k(w,c,S+1,g);if(u)return u}return null}static k(h,y,w,g){let t=null,s;for(h.reset(0);s=h.next(y);)t=O(new L.Range(w,s.index+1,w,s.index+1+s[0].length),s,g);return t}}e.TextModelSearch=E;function T(d,h,y,w,g){if(w===0)return!0;const t=h.charCodeAt(w-1);if(d.get(t)!==0||t===13||t===10)return!0;if(g>0){const s=h.charCodeAt(w);if(d.get(s)!==0)return!0}return!1}function I(d,h,y,w,g){if(w+g===y)return!0;const t=h.charCodeAt(w+g);if(d.get(t)!==0||t===13||t===10)return!0;if(g>0){const s=h.charCodeAt(w+g-1);if(d.get(s)!==0)return!0}return!1}function v(d,h,y,w,g){return T(d,h,y,w,g)&&I(d,h,y,w,g)}e.isValidMatch=v;class i{constructor(h,y){this._wordSeparators=h,this.a=y,this.b=-1,this.c=0}reset(h){this.a.lastIndex=h,this.b=-1,this.c=0}next(h){const y=h.length;let w;do{if(this.b+this.c===y||(w=this.a.exec(h),!w))return null;const g=w.index,t=w[0].length;if(g===this.b&&t===this.c){if(t===0){o.getNextCodePoint(h,y,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=g,this.c=t,!this._wordSeparators||v(this._wordSeparators,h,y,g,t))return w}while(w);return null}}e.Searcher=i}),define(Ce[120],ke([1,0,22,14]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var l;(function(k){k[k.Full=1]="Full",k[k.Delta=2]="Delta"})(l||(l={}));function L(k){for(let E=0,T=k.length;E<T;E+=4){const I=k[E+0],v=k[E+1],i=k[E+2],d=k[E+3];k[E+0]=d,k[E+1]=i,k[E+2]=v,k[E+3]=I}}function A(k){const E=new Uint8Array(k.buffer,k.byteOffset,k.length*4);return R.isLittleEndian()||L(E),o.VSBuffer.wrap(E)}function P(k){const E=k.buffer;if(R.isLittleEndian()||L(E),E.byteOffset%4===0)return new Uint32Array(E.buffer,E.byteOffset,E.length/4);{const T=new Uint8Array(E.byteLength);return T.set(E),new Uint32Array(T.buffer,T.byteOffset,T.length/4)}}function D(k){const E=new Uint32Array(p(k));let T=0;if(E[T++]=k.id,k.type==="full")E[T++]=1,E[T++]=k.data.length,E.set(k.data,T),T+=k.data.length;else{E[T++]=2,E[T++]=k.deltas.length;for(const I of k.deltas)E[T++]=I.start,E[T++]=I.deleteCount,I.data?(E[T++]=I.data.length,E.set(I.data,T),T+=I.data.length):E[T++]=0}return A(E)}e.encodeSemanticTokensDto=D;function p(k){let E=0;if(E+=1+1,k.type==="full")E+=1+k.data.length;else{E+=1,E+=(1+1+1)*k.deltas.length;for(const T of k.deltas)T.data&&(E+=T.data.length)}return E}function O(k){const E=P(k);let T=0;const I=E[T++];if(E[T++]===1){const h=E[T++],y=E.subarray(T,T+h);return T+=h,{id:I,type:"full",data:y}}const i=E[T++],d=[];for(let h=0;h<i;h++){const y=E[T++],w=E[T++],g=E[T++];let t;g>0&&(t=E.subarray(T,T+g),T+=g),d[h]={start:y,deleteCount:w,data:t}}return{id:I,type:"delta",deltas:d}}e.decodeSemanticTokensDto=O}),define(Ce[170],ke([1,0,3,6]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class l{constructor(){this.a=new Map,this.b=new Map,this.c=new o.Emitter,this.onDidChange=this.c.event,this.d=null}handleChange(P){this.c.fire({changedLanguages:P,changedColorMap:!1})}register(P,D){return this.a.set(P,D),this.handleChange([P]),(0,R.toDisposable)(()=>{this.a.get(P)===D&&(this.a.delete(P),this.handleChange([P]))})}get(P){return this.a.get(P)||null}registerFactory(P,D){this.b.get(P)?.dispose();const p=new L(this,P,D);return this.b.set(P,p),(0,R.toDisposable)(()=>{const O=this.b.get(P);!O||O!==p||(this.b.delete(P),O.dispose())})}async getOrCreate(P){const D=this.get(P);if(D)return D;const p=this.b.get(P);return!p||p.isResolved?null:(await p.resolve(),this.get(P))}isResolved(P){if(this.get(P))return!0;const p=this.b.get(P);return!!(!p||p.isResolved)}setColorMap(P){this.d=P,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=l;class L extends R.Disposable{get isResolved(){return this.c}constructor(P,D,p){super(),this.f=P,this.g=D,this.h=p,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const P=await this.h.tokenizationSupport;this.c=!0,P&&!this.a&&this.B(this.f.register(this.g,P))}}}),define(Ce[73],ke([1,0,67,2,32,170]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.LazyTokenizationSupport=e.InlayHintKind=e.CommentState=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.SelectedSuggestionInfo=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class A{constructor(C,M,H){this.offset=C,this.type=M,this.language=H,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=A;class P{constructor(C,M){this.tokens=C,this.endState=M,this._tokenizationResultBrand=void 0}}e.TokenizationResult=P;class D{constructor(C,M){this.tokens=C,this.endState=M,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=D;var p;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(p||(e.CompletionItemKind=p={}));var O;(function(n){const C=new Map;C.set(0,o.Codicon.symbolMethod),C.set(1,o.Codicon.symbolFunction),C.set(2,o.Codicon.symbolConstructor),C.set(3,o.Codicon.symbolField),C.set(4,o.Codicon.symbolVariable),C.set(5,o.Codicon.symbolClass),C.set(6,o.Codicon.symbolStruct),C.set(7,o.Codicon.symbolInterface),C.set(8,o.Codicon.symbolModule),C.set(9,o.Codicon.symbolProperty),C.set(10,o.Codicon.symbolEvent),C.set(11,o.Codicon.symbolOperator),C.set(12,o.Codicon.symbolUnit),C.set(13,o.Codicon.symbolValue),C.set(15,o.Codicon.symbolEnum),C.set(14,o.Codicon.symbolConstant),C.set(15,o.Codicon.symbolEnum),C.set(16,o.Codicon.symbolEnumMember),C.set(17,o.Codicon.symbolKeyword),C.set(27,o.Codicon.symbolSnippet),C.set(18,o.Codicon.symbolText),C.set(19,o.Codicon.symbolColor),C.set(20,o.Codicon.symbolFile),C.set(21,o.Codicon.symbolReference),C.set(22,o.Codicon.symbolCustomColor),C.set(23,o.Codicon.symbolFolder),C.set(24,o.Codicon.symbolTypeParameter),C.set(25,o.Codicon.account),C.set(26,o.Codicon.issues);function M(U){let z=C.get(U);return z||(console.info("No codicon found for CompletionItemKind "+U),z=o.Codicon.symbolProperty),z}n.toIcon=M;const H=new Map;H.set("method",0),H.set("function",1),H.set("constructor",2),H.set("field",3),H.set("variable",4),H.set("class",5),H.set("struct",6),H.set("interface",7),H.set("module",8),H.set("property",9),H.set("event",10),H.set("operator",11),H.set("unit",12),H.set("value",13),H.set("constant",14),H.set("enum",15),H.set("enum-member",16),H.set("enumMember",16),H.set("keyword",17),H.set("snippet",27),H.set("text",18),H.set("color",19),H.set("file",20),H.set("reference",21),H.set("customcolor",22),H.set("folder",23),H.set("type-parameter",24),H.set("typeParameter",24),H.set("account",25),H.set("issue",26);function V(U,z){let G=H.get(U);return typeof G>"u"&&!z&&(G=9),G}n.fromString=V})(O||(e.CompletionItemKinds=O={}));var k;(function(n){n[n.Deprecated=1]="Deprecated"})(k||(e.CompletionItemTag=k={}));var E;(function(n){n[n.None=0]="None",n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(E||(e.CompletionItemInsertTextRule=E={}));var T;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T||(e.CompletionTriggerKind=T={}));var I;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(I||(e.InlineCompletionTriggerKind=I={}));class v{constructor(C,M,H,V){this.range=C,this.text=M,this.completionKind=H,this.isSnippetText=V}equals(C){return l.Range.lift(this.range).equalsRange(C.range)&&this.text===C.text&&this.completionKind===C.completionKind&&this.isSnippetText===C.isSnippetText}}e.SelectedSuggestionInfo=v;var i;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(i||(e.CodeActionTriggerType=i={}));var d;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(d||(e.SignatureHelpTriggerKind=d={}));var h;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(h||(e.DocumentHighlightKind=h={}));function y(n){return n&&R.URI.isUri(n.uri)&&l.Range.isIRange(n.range)&&(l.Range.isIRange(n.originSelectionRange)||l.Range.isIRange(n.targetSelectionRange))}e.isLocationLink=y;var w;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(w||(e.SymbolKind=w={}));var g;(function(n){n[n.Deprecated=1]="Deprecated"})(g||(e.SymbolTag=g={}));var t;(function(n){const C=new Map;C.set(0,o.Codicon.symbolFile),C.set(1,o.Codicon.symbolModule),C.set(2,o.Codicon.symbolNamespace),C.set(3,o.Codicon.symbolPackage),C.set(4,o.Codicon.symbolClass),C.set(5,o.Codicon.symbolMethod),C.set(6,o.Codicon.symbolProperty),C.set(7,o.Codicon.symbolField),C.set(8,o.Codicon.symbolConstructor),C.set(9,o.Codicon.symbolEnum),C.set(10,o.Codicon.symbolInterface),C.set(11,o.Codicon.symbolFunction),C.set(12,o.Codicon.symbolVariable),C.set(13,o.Codicon.symbolConstant),C.set(14,o.Codicon.symbolString),C.set(15,o.Codicon.symbolNumber),C.set(16,o.Codicon.symbolBoolean),C.set(17,o.Codicon.symbolArray),C.set(18,o.Codicon.symbolObject),C.set(19,o.Codicon.symbolKey),C.set(20,o.Codicon.symbolNull),C.set(21,o.Codicon.symbolEnumMember),C.set(22,o.Codicon.symbolStruct),C.set(23,o.Codicon.symbolEvent),C.set(24,o.Codicon.symbolOperator),C.set(25,o.Codicon.symbolTypeParameter);function M(H){let V=C.get(H);return V||(console.info("No codicon found for SymbolKind "+H),V=o.Codicon.symbolProperty),V}n.toIcon=M})(t||(e.SymbolKinds=t={}));class s{static fromValue(C){switch(C){case"comment":return s.Comment;case"imports":return s.Imports;case"region":return s.Region}return new s(C)}constructor(C){this.value=C}}e.FoldingRangeKind=s,s.Comment=new s("comment"),s.Imports=new s("imports"),s.Region=new s("region");var r;(function(n){function C(M){return!M||typeof M!="object"?!1:typeof M.id=="string"&&typeof M.title=="string"}n.is=C})(r||(e.Command=r={}));var a;(function(n){n[n.Collapsed=0]="Collapsed",n[n.Expanded=1]="Expanded"})(a||(e.CommentThreadCollapsibleState=a={}));var b;(function(n){n[n.Unresolved=0]="Unresolved",n[n.Resolved=1]="Resolved"})(b||(e.CommentThreadState=b={}));var S;(function(n){n[n.Editing=0]="Editing",n[n.Preview=1]="Preview"})(S||(e.CommentMode=S={}));var c;(function(n){n[n.Published=0]="Published",n[n.Draft=1]="Draft"})(c||(e.CommentState=c={}));var u;(function(n){n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(u||(e.InlayHintKind=u={}));class m{constructor(C){this.b=C,this.a=null}dispose(){this.a&&this.a.then(C=>{C&&C.dispose()})}get tokenizationSupport(){return this.a||(this.a=this.b()),this.a}}e.LazyTokenizationSupport=m,e.TokenizationRegistry=new L.TokenizationRegistry;var f;(function(n){n[n.None=0]="None",n[n.Option=1]="Option",n[n.Default=2]="Default",n[n.Preferred=3]="Preferred"})(f||(e.ExternalUriOpenerPriority=f={}))}),define(Ce[171],ke([12,13]),function(ae,e){return ae.create("vs/editor/common/config/editorOptions",e)}),define(Ce[121],ke([1,0,171,14,107,18,23,153]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var D;(function(W){W[W.None=0]="None",W[W.Keep=1]="Keep",W[W.Brackets=2]="Brackets",W[W.Advanced=3]="Advanced",W[W.Full=4]="Full"})(D||(e.EditorAutoIndentStrategy=D={})),e.MINIMAP_GUTTER_WIDTH=8;class p{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=p;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class k{constructor(X,ge,Re,Me){this.id=X,this.name=ge,this.defaultValue=Re,this.schema=Me}applyUpdate(X,ge){return T(X,ge)}compute(X,ge,Re){return Re}}class E{constructor(X,ge){this.newValue=X,this.didChange=ge}}e.ApplyUpdateResult=E;function T(W,X){if(typeof W!="object"||typeof X!="object"||!W||!X)return new E(X,W!==X);if(Array.isArray(W)||Array.isArray(X)){const Re=Array.isArray(W)&&Array.isArray(X)&&L.equals(W,X);return new E(X,!Re)}let ge=!1;for(const Re in X)if(X.hasOwnProperty(Re)){const Me=T(W[Re],X[Re]);Me.didChange&&(W[Re]=Me.newValue,ge=!0)}return new E(W,ge)}class I{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,ge){return T(X,ge)}validate(X){return this.defaultValue}}class v{constructor(X,ge,Re,Me){this.id=X,this.name=ge,this.defaultValue=Re,this.schema=Me}applyUpdate(X,ge){return T(X,ge)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,ge,Re){return Re}}function i(W,X){return typeof W>"u"?X:W==="false"?!1:!!W}e.boolean=i;class d extends v{constructor(X,ge,Re,Me=void 0){typeof Me<"u"&&(Me.type="boolean",Me.default=Re),super(X,ge,Re,Me)}validate(X){return i(X,this.defaultValue)}}function h(W,X,ge,Re){if(typeof W>"u")return X;let Me=parseInt(W,10);return isNaN(Me)?X:(Me=Math.max(ge,Me),Me=Math.min(Re,Me),Me|0)}e.clampedInt=h;class y extends v{static clampedInt(X,ge,Re,Me){return h(X,ge,Re,Me)}constructor(X,ge,Re,Me,Ge,je=void 0){typeof je<"u"&&(je.type="integer",je.default=Re,je.minimum=Me,je.maximum=Ge),super(X,ge,Re,je),this.minimum=Me,this.maximum=Ge}validate(X){return y.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function w(W,X,ge,Re){if(typeof W>"u")return X;const Me=g.float(W,X);return g.clamp(Me,ge,Re)}e.clampedFloat=w;class g extends v{static clamp(X,ge,Re){return X<ge?ge:X>Re?Re:X}static float(X,ge){if(typeof X=="number")return X;if(typeof X>"u")return ge;const Re=parseFloat(X);return isNaN(Re)?ge:Re}constructor(X,ge,Re,Me,Ge){typeof Ge<"u"&&(Ge.type="number",Ge.default=Re),super(X,ge,Re,Ge),this.validationFn=Me}validate(X){return this.validationFn(g.float(X,this.defaultValue))}}class t extends v{static string(X,ge){return typeof X!="string"?ge:X}constructor(X,ge,Re,Me=void 0){typeof Me<"u"&&(Me.type="string",Me.default=Re),super(X,ge,Re,Me)}validate(X){return t.string(X,this.defaultValue)}}function s(W,X,ge,Re){return typeof W!="string"?X:Re&&W in Re?Re[W]:ge.indexOf(W)===-1?X:W}e.stringSet=s;class r extends v{constructor(X,ge,Re,Me,Ge=void 0){typeof Ge<"u"&&(Ge.type="string",Ge.enum=Me,Ge.default=Re),super(X,ge,Re,Ge),this.c=Me}validate(X){return s(X,this.defaultValue,this.c)}}class a extends k{constructor(X,ge,Re,Me,Ge,je,tt=void 0){typeof tt<"u"&&(tt.type="string",tt.enum=Ge,tt.default=Me),super(X,ge,Re,tt),this.c=Ge,this.d=je}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function b(W){switch(W){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class S extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",tags:["accessibility"],description:o.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,ge,Re){return Re===0?X.accessibilitySupport:Re}}class c extends k{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:o.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertSpace:i(ge.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:i(ge.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var u;(function(W){W[W.Hidden=0]="Hidden",W[W.Blink=1]="Blink",W[W.Smooth=2]="Smooth",W[W.Phase=3]="Phase",W[W.Expand=4]="Expand",W[W.Solid=5]="Solid"})(u||(e.TextEditorCursorBlinkingStyle=u={}));function m(W){switch(W){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var f;(function(W){W[W.Line=1]="Line",W[W.Block=2]="Block",W[W.Underline=3]="Underline",W[W.LineThin=4]="LineThin",W[W.BlockOutline=5]="BlockOutline",W[W.UnderlineThin=6]="UnderlineThin"})(f||(e.TextEditorCursorStyle=f={}));function n(W){switch(W){case f.Line:return"line";case f.Block:return"block";case f.Underline:return"underline";case f.LineThin:return"line-thin";case f.BlockOutline:return"block-outline";case f.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=n;function C(W){switch(W){case"line":return f.Line;case"block":return f.Block;case"underline":return f.Underline;case"line-thin":return f.LineThin;case"block-outline":return f.BlockOutline;case"underline-thin":return f.UnderlineThin}}class M extends I{constructor(){super(136)}compute(X,ge,Re){const Me=["monaco-editor"];return ge.get(37)&&Me.push(ge.get(37)),X.extraEditorClassName&&Me.push(X.extraEditorClassName),ge.get(71)==="default"?Me.push("mouse-default"):ge.get(71)==="copy"&&Me.push("mouse-copy"),ge.get(106)&&Me.push("showUnused"),ge.get(134)&&Me.push("showDeprecated"),Me.join(" ")}}class H extends d{constructor(){super(35,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute(X,ge,Re){return Re&&X.emptySelectionClipboard}}class V extends k{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:o.localize(16,null),included:R.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:o.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{cursorMoveOnType:i(ge.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":s(ge.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":s(ge.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:i(ge.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:i(ge.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:i(ge.loop,this.defaultValue.loop)}}}class U extends k{constructor(){super(49,"fontLigatures",U.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?U.OFF:X==="true"?U.ON:X:X?U.ON:U.OFF}}e.EditorFontLigatures=U,U.OFF='"liga" off, "calt" off',U.ON='"liga" on, "calt" on';class z extends k{constructor(){super(52,"fontVariations",z.OFF,{anyOf:[{type:"boolean",description:o.localize(22,null)},{type:"string",description:o.localize(23,null)}],description:o.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?z.OFF:X==="true"?z.TRANSLATE:X:X?z.TRANSLATE:z.OFF}compute(X,ge,Re){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=z,z.OFF="normal",z.TRANSLATE="translate";class G extends I{constructor(){super(48)}compute(X,ge,Re){return X.fontInfo}}class F extends v{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(25,null)})}validate(X){const ge=g.float(X,this.defaultValue);return ge===0?e.EDITOR_FONT_DEFAULTS.fontSize:g.clamp(ge,6,100)}compute(X,ge,Re){return X.fontInfo.fontSize}}class $ extends k{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:$.d,maximum:$.e,errorMessage:o.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:$.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(y.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,$.d,$.e))}}$.c=["normal","bold","100","200","300","400","500","600","700","800","900"],$.d=1,$.e=1e3;class Y extends k{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},ge={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[o.localize(28,null),o.localize(29,null),o.localize(30,null)]},Re=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(32,null),...ge},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(33,null),...ge},"editor.gotoLocation.multipleDeclarations":{description:o.localize(34,null),...ge},"editor.gotoLocation.multipleImplementations":{description:o.localize(35,null),...ge},"editor.gotoLocation.multipleReferences":{description:o.localize(36,null),...ge},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:Re,description:o.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:Re,description:o.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:Re,description:o.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:Re,description:o.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:Re,description:o.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{multiple:s(ge.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:ge.multipleDefinitions??s(ge.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:ge.multipleTypeDefinitions??s(ge.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:ge.multipleDeclarations??s(ge.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:ge.multipleImplementations??s(ge.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:ge.multipleReferences??s(ge.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:t.string(ge.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:t.string(ge.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:t.string(ge.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:t.string(ge.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:t.string(ge.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class _ extends k{constructor(){const X={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:o.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:o.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:o.localize(44,null)},"editor.hover.above":{type:"boolean",default:X.above,description:o.localize(45,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:i(ge.enabled,this.defaultValue.enabled),delay:y.clampedInt(ge.delay,this.defaultValue.delay,0,1e4),sticky:i(ge.sticky,this.defaultValue.sticky),above:i(ge.above,this.defaultValue.above)}}}var Q;(function(W){W[W.None=0]="None",W[W.Text=1]="Text",W[W.Blocks=2]="Blocks"})(Q||(e.RenderMinimap=Q={}));class ie extends I{constructor(){super(139)}compute(X,ge,Re){return ie.computeLayout(ge,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const ge=X.height/X.lineHeight,Re=Math.floor(X.paddingTop/X.lineHeight);let Me=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(Me=Math.max(Me,ge-1));const Ge=(Re+X.viewLineCount+Me)/(X.pixelRatio*X.height),je=Math.floor(X.viewLineCount/Ge);return{typicalViewportLineCount:ge,extraLinesBeforeFirstLine:Re,extraLinesBeyondLastLine:Me,desiredRatio:Ge,minimapLineCount:je}}static c(X,ge){const Re=X.outerWidth,Me=X.outerHeight,Ge=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Ge*Me),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Me};const je=ge.stableMinimapLayoutInput,tt=je&&X.outerHeight===je.outerHeight&&X.lineHeight===je.lineHeight&&X.typicalHalfwidthCharacterWidth===je.typicalHalfwidthCharacterWidth&&X.pixelRatio===je.pixelRatio&&X.scrollBeyondLastLine===je.scrollBeyondLastLine&&X.paddingTop===je.paddingTop&&X.paddingBottom===je.paddingBottom&&X.minimap.enabled===je.minimap.enabled&&X.minimap.side===je.minimap.side&&X.minimap.size===je.minimap.size&&X.minimap.showSlider===je.minimap.showSlider&&X.minimap.renderCharacters===je.minimap.renderCharacters&&X.minimap.maxColumn===je.minimap.maxColumn&&X.minimap.scale===je.minimap.scale&&X.verticalScrollbarWidth===je.verticalScrollbarWidth&&X.isViewportWrapping===je.isViewportWrapping,pt=X.lineHeight,at=X.typicalHalfwidthCharacterWidth,bt=X.scrollBeyondLastLine,Dt=X.minimap.renderCharacters;let St=Ge>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const At=X.minimap.maxColumn,Bt=X.minimap.size,qt=X.minimap.side,jt=X.verticalScrollbarWidth,Rt=X.viewLineCount,lt=X.remainingWidth,vt=X.isViewportWrapping,Ht=Dt?2:3;let zt=Math.floor(Ge*Me);const Tt=zt/Ge;let ft=!1,Pt=!1,Ft=Ht*St,Lt=St/Ge,Xe=1;if(Bt==="fill"||Bt==="fit"){const{typicalViewportLineCount:Qe,extraLinesBeforeFirstLine:qe,extraLinesBeyondLastLine:rt,desiredRatio:yt,minimapLineCount:wt}=ie.computeContainedMinimapLineCount({viewLineCount:Rt,scrollBeyondLastLine:bt,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:Me,lineHeight:pt,pixelRatio:Ge});if(Rt/wt>1)ft=!0,Pt=!0,St=1,Ft=1,Lt=St/Ge;else{let st=!1,dt=St+1;if(Bt==="fit"){const Nt=Math.ceil((qe+Rt+rt)*Ft);vt&&tt&&lt<=ge.stableFitRemainingWidth?(st=!0,dt=ge.stableFitMaxMinimapScale):st=Nt>zt}if(Bt==="fill"||st){ft=!0;const Nt=St;Ft=Math.min(pt*Ge,Math.max(1,Math.floor(1/yt))),vt&&tt&&lt<=ge.stableFitRemainingWidth&&(dt=ge.stableFitMaxMinimapScale),St=Math.min(dt,Math.max(1,Math.floor(Ft/Ht))),St>Nt&&(Xe=Math.min(2,St/Nt)),Lt=St/Ge/Xe,zt=Math.ceil(Math.max(Qe,qe+Rt+rt)*Ft),vt?(ge.stableMinimapLayoutInput=X,ge.stableFitRemainingWidth=lt,ge.stableFitMaxMinimapScale=St):(ge.stableMinimapLayoutInput=null,ge.stableFitRemainingWidth=0)}}}const Le=Math.floor(At*Lt),Oe=Math.min(Le,Math.max(0,Math.floor((lt-jt-2)*Lt/(at+Lt)))+e.MINIMAP_GUTTER_WIDTH);let Ie=Math.floor(Ge*Oe);const se=Ie/Ge;Ie=Math.floor(Ie*Xe);const Ne=Dt?1:2,He=qt==="left"?0:Re-Oe-jt;return{renderMinimap:Ne,minimapLeft:He,minimapWidth:Oe,minimapHeightIsEditorHeight:ft,minimapIsSampling:Pt,minimapScale:St,minimapLineHeight:Ft,minimapCanvasInnerWidth:Ie,minimapCanvasInnerHeight:zt,minimapCanvasOuterWidth:se,minimapCanvasOuterHeight:Tt}}static computeLayout(X,ge){const Re=ge.outerWidth|0,Me=ge.outerHeight|0,Ge=ge.lineHeight|0,je=ge.lineNumbersDigitCount|0,tt=ge.typicalHalfwidthCharacterWidth,pt=ge.maxDigitWidth,at=ge.pixelRatio,bt=ge.viewLineCount,Dt=X.get(131),St=Dt==="inherit"?X.get(130):Dt,At=St==="inherit"?X.get(126):St,Bt=X.get(129),qt=ge.isDominatedByLongLines,jt=X.get(55),Rt=X.get(65).renderType!==0,lt=X.get(66),vt=X.get(100),Ht=X.get(81),zt=X.get(70),Tt=X.get(98),ft=Tt.verticalScrollbarSize,Pt=Tt.verticalHasArrows,Ft=Tt.arrowSize,Lt=Tt.horizontalScrollbarSize,Xe=X.get(41),Le=X.get(105)!=="never";let Oe=X.get(63);Xe&&Le&&(Oe+=16);let Ie=0;if(Rt){const ai=Math.max(je,lt);Ie=Math.round(ai*pt)}let se=0;jt&&(se=Ge*ge.glyphMarginDecorationLaneCount);let Ne=0,He=Ne+se,Qe=He+Ie,qe=Qe+Oe;const rt=Re-se-Ie-Oe;let yt=!1,wt=!1,ht=-1;St==="inherit"&&qt?(yt=!0,wt=!0):At==="on"||At==="bounded"?wt=!0:At==="wordWrapColumn"&&(ht=Bt);const st=ie.c({outerWidth:Re,outerHeight:Me,lineHeight:Ge,typicalHalfwidthCharacterWidth:tt,pixelRatio:at,scrollBeyondLastLine:vt,paddingTop:Ht.top,paddingBottom:Ht.bottom,minimap:zt,verticalScrollbarWidth:ft,viewLineCount:bt,remainingWidth:rt,isViewportWrapping:wt},ge.memory||new O);st.renderMinimap!==0&&st.minimapLeft===0&&(Ne+=st.minimapWidth,He+=st.minimapWidth,Qe+=st.minimapWidth,qe+=st.minimapWidth);const dt=rt-st.minimapWidth,Nt=Math.max(1,Math.floor((dt-ft-2)/tt)),$t=Pt?Ft:0;return wt&&(ht=Math.max(1,Nt),At==="bounded"&&(ht=Math.min(ht,Bt))),{width:Re,height:Me,glyphMarginLeft:Ne,glyphMarginWidth:se,glyphMarginDecorationLaneCount:ge.glyphMarginDecorationLaneCount,lineNumbersLeft:He,lineNumbersWidth:Ie,decorationsLeft:Qe,decorationsWidth:Oe,contentLeft:qe,contentWidth:dt,minimap:st,viewportColumn:Nt,isWordWrapMinified:yt,isViewportWrapping:wt,wrappingColumn:ht,verticalScrollbarWidth:ft,horizontalScrollbarHeight:Lt,overviewRuler:{top:$t,width:ft,height:Me-2*$t,right:0}}}}e.EditorLayoutInfoComputer=ie;class oe extends k{constructor(){super(133,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[o.localize(46,null),o.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:o.localize(48,null)}})}validate(X){return s(X,"simple",["simple","advanced"])}compute(X,ge,Re){return ge.get(2)===2?"advanced":Re}}class Ee extends k{constructor(){const X={enabled:!0};super(62,"lightbulb",X,{"editor.lightbulb.enabled":{type:"boolean",default:X.enabled,description:o.localize(49,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:i(X.enabled,this.defaultValue.enabled)}}}class he extends k{constructor(){const X={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(110,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:o.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:10,description:o.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:o.localize(52,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:i(ge.enabled,this.defaultValue.enabled),maxLineCount:y.clampedInt(ge.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:s(ge.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class fe extends k{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(135,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:o.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(54,null),o.localize(55,null,R.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(56,null,R.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),o.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:o.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:o.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:o.localize(60,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return typeof ge.enabled=="boolean"&&(ge.enabled=ge.enabled?"on":"off"),{enabled:s(ge.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:y.clampedInt(ge.fontSize,this.defaultValue.fontSize,0,100),fontFamily:t.string(ge.fontFamily,this.defaultValue.fontFamily),padding:i(ge.padding,this.defaultValue.padding)}}}class x extends k{constructor(){super(63,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):y.clampedInt(X,this.defaultValue,0,1e3)}compute(X,ge,Re){return Re<0?y.clampedInt(-Re*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Re}}class B extends g{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>g.clamp(X,0,150),{markdownDescription:o.localize(61,null)})}compute(X,ge,Re){return X.fontInfo.lineHeight}}class Z extends k{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:o.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:o.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(64,null),o.localize(65,null),o.localize(66,null)],default:X.size,description:o.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:o.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:o.localize(69,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:o.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:o.localize(72,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:i(ge.enabled,this.defaultValue.enabled),autohide:i(ge.autohide,this.defaultValue.autohide),size:s(ge.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(ge.side,this.defaultValue.side,["right","left"]),showSlider:s(ge.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:i(ge.renderCharacters,this.defaultValue.renderCharacters),scale:y.clampedInt(ge.scale,1,1,3),maxColumn:y.clampedInt(ge.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function pe(W){return W==="ctrlCmd"?R.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Se extends k{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(74,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{top:y.clampedInt(ge.top,0,0,1e3),bottom:y.clampedInt(ge.bottom,0,0,1e3)}}}class re extends k{constructor(){const X={enabled:!0,cycle:!0};super(82,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:o.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:o.localize(76,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:i(ge.enabled,this.defaultValue.enabled),cycle:i(ge.cycle,this.defaultValue.cycle)}}}class ne extends I{constructor(){super(137)}compute(X,ge,Re){return X.pixelRatio}}class de extends k{constructor(){const X={other:"on",comments:"off",strings:"off"},ge=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(77,null),o.localize(78,null),o.localize(79,null)]}];super(85,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:ge,default:X.strings,description:o.localize(80,null)},comments:{anyOf:ge,default:X.comments,description:o.localize(81,null)},other:{anyOf:ge,default:X.other,description:o.localize(82,null)}},default:X,markdownDescription:o.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const at=X?"on":"off";return{comments:at,strings:at,other:at}}if(!X||typeof X!="object")return this.defaultValue;const{other:ge,comments:Re,strings:Me}=X,Ge=["on","inline","off"];let je,tt,pt;return typeof ge=="boolean"?je=ge?"on":"off":je=s(ge,this.defaultValue.other,Ge),typeof Re=="boolean"?tt=Re?"on":"off":tt=s(Re,this.defaultValue.comments,Ge),typeof Me=="boolean"?pt=Me?"on":"off":pt=s(Me,this.defaultValue.strings,Ge),{other:je,comments:tt,strings:pt}}}var ee;(function(W){W[W.Off=0]="Off",W[W.On=1]="On",W[W.Relative=2]="Relative",W[W.Interval=3]="Interval",W[W.Custom=4]="Custom"})(ee||(e.RenderLineNumbersType=ee={}));class ce extends k{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(84,null),o.localize(85,null),o.localize(86,null),o.localize(87,null)],default:"on",description:o.localize(88,null)})}validate(X){let ge=this.defaultValue.renderType,Re=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?(ge=4,Re=X):X==="interval"?ge=3:X==="relative"?ge=2:X==="on"?ge=1:ge=0),{renderType:ge,renderFn:Re}}}function le(W){const X=W.get(93);return X==="editable"?W.get(87):X!=="on"}e.filterValidationDecorations=le;class ue extends k{constructor(){const X=[],ge={type:"number",description:o.localize(89,null)};super(97,"rulers",X,{type:"array",items:{anyOf:[ge,{type:["object"],properties:{column:ge,color:{type:"string",description:o.localize(90,null),format:"color-hex"}}}]},default:X,description:o.localize(91,null)})}validate(X){if(Array.isArray(X)){const ge=[];for(const Re of X)if(typeof Re=="number")ge.push({column:y.clampedInt(Re,0,0,1e4),color:null});else if(Re&&typeof Re=="object"){const Me=Re;ge.push({column:y.clampedInt(Me.column,0,0,1e4),color:Me.color})}return ge.sort((Re,Me)=>Re.column-Me.column),ge}return this.defaultValue}}function N(W,X){if(typeof W!="string")return X;switch(W){case"hidden":return 2;case"visible":return 3;default:return 1}}class q extends k{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(98,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(92,null),o.localize(93,null),o.localize(94,null)],default:"auto",description:o.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(96,null),o.localize(97,null),o.localize(98,null)],default:"auto",description:o.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:o.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:o.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:o.localize(102,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X,Re=y.clampedInt(ge.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Me=y.clampedInt(ge.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:y.clampedInt(ge.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:N(ge.vertical,this.defaultValue.vertical),horizontal:N(ge.horizontal,this.defaultValue.horizontal),useShadows:i(ge.useShadows,this.defaultValue.useShadows),verticalHasArrows:i(ge.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:i(ge.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:i(ge.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:i(ge.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Re,horizontalSliderSize:y.clampedInt(ge.horizontalSliderSize,Re,0,1e3),verticalScrollbarSize:Me,verticalSliderSize:y.clampedInt(ge.verticalSliderSize,Me,0,1e3),scrollByPage:i(ge.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class J extends k{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(120,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:o.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:o.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:o.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:o.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:o.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:o.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:o.localize(109,null)}})}applyUpdate(X,ge){let Re=!1;ge.allowedCharacters&&X&&(A.equals(X.allowedCharacters,ge.allowedCharacters)||(X={...X,allowedCharacters:ge.allowedCharacters},Re=!0)),ge.allowedLocales&&X&&(A.equals(X.allowedLocales,ge.allowedLocales)||(X={...X,allowedLocales:ge.allowedLocales},Re=!0));const Me=super.applyUpdate(X,ge);return Re?new E(Me.newValue,!0):Me}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{nonBasicASCII:me(ge.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:i(ge.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:i(ge.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:me(ge.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:me(ge.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,ge){if(typeof X!="object"||!X)return ge;const Re={};for(const[Me,Ge]of Object.entries(X))Ge===!0&&(Re[Me]=!0);return Re}}class te extends k{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(60,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:o.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover"],enumDescriptions:[o.localize(111,null),o.localize(112,null)],description:o.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:o.localize(114,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:i(ge.enabled,this.defaultValue.enabled),mode:s(ge.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:s(ge.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:i(ge.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:i(ge.keepOnBlur,this.defaultValue.keepOnBlur)}}}class ve extends k{constructor(){const X={enabled:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:P.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:o.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:o.localize(116,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:i(ge.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:i(ge.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class De extends k{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(117,null),o.localize(118,null),o.localize(119,null)],default:X.bracketPairs,description:o.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(121,null),o.localize(122,null),o.localize(123,null)],default:X.bracketPairsHorizontal,description:o.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:o.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:o.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(127,null),o.localize(128,null),o.localize(129,null)],default:X.highlightActiveIndentation,description:o.localize(130,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{bracketPairs:me(ge.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:me(ge.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:i(ge.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:i(ge.indentation,this.defaultValue.indentation),highlightActiveIndentation:me(ge.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function me(W,X,ge){const Re=ge.indexOf(W);return Re===-1?X:ge[Re]}class Te extends k{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(113,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(131,null),o.localize(132,null)],default:X.insertMode,description:o.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:o.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:o.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:o.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[o.localize(137,null),o.localize(138,null),o.localize(139,null),o.localize(140,null)],default:X.selectionMode,markdownDescription:o.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:o.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:o.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:o.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:o.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:o.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:o.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(178,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{insertMode:s(ge.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:i(ge.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:i(ge.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:i(ge.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:i(ge.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:s(ge.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:i(ge.showIcons,this.defaultValue.showIcons),showStatusBar:i(ge.showStatusBar,this.defaultValue.showStatusBar),preview:i(ge.preview,this.defaultValue.preview),previewMode:s(ge.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:i(ge.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:i(ge.showMethods,this.defaultValue.showMethods),showFunctions:i(ge.showFunctions,this.defaultValue.showFunctions),showConstructors:i(ge.showConstructors,this.defaultValue.showConstructors),showDeprecated:i(ge.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:i(ge.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:i(ge.showFields,this.defaultValue.showFields),showVariables:i(ge.showVariables,this.defaultValue.showVariables),showClasses:i(ge.showClasses,this.defaultValue.showClasses),showStructs:i(ge.showStructs,this.defaultValue.showStructs),showInterfaces:i(ge.showInterfaces,this.defaultValue.showInterfaces),showModules:i(ge.showModules,this.defaultValue.showModules),showProperties:i(ge.showProperties,this.defaultValue.showProperties),showEvents:i(ge.showEvents,this.defaultValue.showEvents),showOperators:i(ge.showOperators,this.defaultValue.showOperators),showUnits:i(ge.showUnits,this.defaultValue.showUnits),showValues:i(ge.showValues,this.defaultValue.showValues),showConstants:i(ge.showConstants,this.defaultValue.showConstants),showEnums:i(ge.showEnums,this.defaultValue.showEnums),showEnumMembers:i(ge.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:i(ge.showKeywords,this.defaultValue.showKeywords),showWords:i(ge.showWords,this.defaultValue.showWords),showColors:i(ge.showColors,this.defaultValue.showColors),showFiles:i(ge.showFiles,this.defaultValue.showFiles),showReferences:i(ge.showReferences,this.defaultValue.showReferences),showFolders:i(ge.showFolders,this.defaultValue.showFolders),showTypeParameters:i(ge.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:i(ge.showSnippets,this.defaultValue.showSnippets),showUsers:i(ge.showUsers,this.defaultValue.showUsers),showIssues:i(ge.showIssues,this.defaultValue.showIssues)}}}class Pe extends k{constructor(){super(108,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(179,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:i(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var $e;(function(W){W[W.None=0]="None",W[W.Same=1]="Same",W[W.Indent=2]="Indent",W[W.DeepIndent=3]="DeepIndent"})($e||(e.WrappingIndent=$e={}));class Ve extends k{constructor(){super(132,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[o.localize(180,null),o.localize(181,null),o.localize(182,null),o.localize(183,null)],description:o.localize(184,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,ge,Re){return ge.get(2)===2?0:Re}}class et extends I{constructor(){super(140)}compute(X,ge,Re){const Me=ge.get(139);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:Me.isWordWrapMinified,isViewportWrapping:Me.isViewportWrapping,wrappingColumn:Me.wrappingColumn}}}class Ye extends k{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(34,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:o.localize(185,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:o.localize(186,null),enum:["afterDrop","never"],enumDescriptions:[o.localize(187,null),o.localize(188,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const ge=X;return{enabled:i(ge.enabled,this.defaultValue.enabled),showDropSelector:s(ge.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}const Je="Consolas, 'Courier New', monospace",nt="Menlo, Monaco, 'Courier New', monospace",ct="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:R.isMacintosh?nt:R.isLinux?ct:Je,fontWeight:"normal",fontSize:R.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Fe(W){return e.editorOptionsRegistry[W.id]=W,W}var it;(function(W){W[W.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",W[W.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",W[W.accessibilitySupport=2]="accessibilitySupport",W[W.accessibilityPageSize=3]="accessibilityPageSize",W[W.ariaLabel=4]="ariaLabel",W[W.autoClosingBrackets=5]="autoClosingBrackets",W[W.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",W[W.autoClosingDelete=7]="autoClosingDelete",W[W.autoClosingOvertype=8]="autoClosingOvertype",W[W.autoClosingQuotes=9]="autoClosingQuotes",W[W.autoIndent=10]="autoIndent",W[W.automaticLayout=11]="automaticLayout",W[W.autoSurround=12]="autoSurround",W[W.bracketPairColorization=13]="bracketPairColorization",W[W.guides=14]="guides",W[W.codeLens=15]="codeLens",W[W.codeLensFontFamily=16]="codeLensFontFamily",W[W.codeLensFontSize=17]="codeLensFontSize",W[W.colorDecorators=18]="colorDecorators",W[W.colorDecoratorsLimit=19]="colorDecoratorsLimit",W[W.columnSelection=20]="columnSelection",W[W.comments=21]="comments",W[W.contextmenu=22]="contextmenu",W[W.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",W[W.cursorBlinking=24]="cursorBlinking",W[W.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",W[W.cursorStyle=26]="cursorStyle",W[W.cursorSurroundingLines=27]="cursorSurroundingLines",W[W.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",W[W.cursorWidth=29]="cursorWidth",W[W.disableLayerHinting=30]="disableLayerHinting",W[W.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",W[W.domReadOnly=32]="domReadOnly",W[W.dragAndDrop=33]="dragAndDrop",W[W.dropIntoEditor=34]="dropIntoEditor",W[W.emptySelectionClipboard=35]="emptySelectionClipboard",W[W.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",W[W.extraEditorClassName=37]="extraEditorClassName",W[W.fastScrollSensitivity=38]="fastScrollSensitivity",W[W.find=39]="find",W[W.fixedOverflowWidgets=40]="fixedOverflowWidgets",W[W.folding=41]="folding",W[W.foldingStrategy=42]="foldingStrategy",W[W.foldingHighlight=43]="foldingHighlight",W[W.foldingImportsByDefault=44]="foldingImportsByDefault",W[W.foldingMaximumRegions=45]="foldingMaximumRegions",W[W.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",W[W.fontFamily=47]="fontFamily",W[W.fontInfo=48]="fontInfo",W[W.fontLigatures=49]="fontLigatures",W[W.fontSize=50]="fontSize",W[W.fontWeight=51]="fontWeight",W[W.fontVariations=52]="fontVariations",W[W.formatOnPaste=53]="formatOnPaste",W[W.formatOnType=54]="formatOnType",W[W.glyphMargin=55]="glyphMargin",W[W.gotoLocation=56]="gotoLocation",W[W.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",W[W.hover=58]="hover",W[W.inDiffEditor=59]="inDiffEditor",W[W.inlineSuggest=60]="inlineSuggest",W[W.letterSpacing=61]="letterSpacing",W[W.lightbulb=62]="lightbulb",W[W.lineDecorationsWidth=63]="lineDecorationsWidth",W[W.lineHeight=64]="lineHeight",W[W.lineNumbers=65]="lineNumbers",W[W.lineNumbersMinChars=66]="lineNumbersMinChars",W[W.linkedEditing=67]="linkedEditing",W[W.links=68]="links",W[W.matchBrackets=69]="matchBrackets",W[W.minimap=70]="minimap",W[W.mouseStyle=71]="mouseStyle",W[W.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",W[W.mouseWheelZoom=73]="mouseWheelZoom",W[W.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",W[W.multiCursorModifier=75]="multiCursorModifier",W[W.multiCursorPaste=76]="multiCursorPaste",W[W.multiCursorLimit=77]="multiCursorLimit",W[W.occurrencesHighlight=78]="occurrencesHighlight",W[W.overviewRulerBorder=79]="overviewRulerBorder",W[W.overviewRulerLanes=80]="overviewRulerLanes",W[W.padding=81]="padding",W[W.parameterHints=82]="parameterHints",W[W.peekWidgetDefaultFocus=83]="peekWidgetDefaultFocus",W[W.definitionLinkOpensInPeek=84]="definitionLinkOpensInPeek",W[W.quickSuggestions=85]="quickSuggestions",W[W.quickSuggestionsDelay=86]="quickSuggestionsDelay",W[W.readOnly=87]="readOnly",W[W.renameOnType=88]="renameOnType",W[W.renderControlCharacters=89]="renderControlCharacters",W[W.renderFinalNewline=90]="renderFinalNewline",W[W.renderLineHighlight=91]="renderLineHighlight",W[W.renderLineHighlightOnlyWhenFocus=92]="renderLineHighlightOnlyWhenFocus",W[W.renderValidationDecorations=93]="renderValidationDecorations",W[W.renderWhitespace=94]="renderWhitespace",W[W.revealHorizontalRightPadding=95]="revealHorizontalRightPadding",W[W.roundedSelection=96]="roundedSelection",W[W.rulers=97]="rulers",W[W.scrollbar=98]="scrollbar",W[W.scrollBeyondLastColumn=99]="scrollBeyondLastColumn",W[W.scrollBeyondLastLine=100]="scrollBeyondLastLine",W[W.scrollPredominantAxis=101]="scrollPredominantAxis",W[W.selectionClipboard=102]="selectionClipboard",W[W.selectionHighlight=103]="selectionHighlight",W[W.selectOnLineNumbers=104]="selectOnLineNumbers",W[W.showFoldingControls=105]="showFoldingControls",W[W.showUnused=106]="showUnused",W[W.snippetSuggestions=107]="snippetSuggestions",W[W.smartSelect=108]="smartSelect",W[W.smoothScrolling=109]="smoothScrolling",W[W.stickyScroll=110]="stickyScroll",W[W.stickyTabStops=111]="stickyTabStops",W[W.stopRenderingLineAfter=112]="stopRenderingLineAfter",W[W.suggest=113]="suggest",W[W.suggestFontSize=114]="suggestFontSize",W[W.suggestLineHeight=115]="suggestLineHeight",W[W.suggestOnTriggerCharacters=116]="suggestOnTriggerCharacters",W[W.suggestSelection=117]="suggestSelection",W[W.tabCompletion=118]="tabCompletion",W[W.tabIndex=119]="tabIndex",W[W.unicodeHighlighting=120]="unicodeHighlighting",W[W.unusualLineTerminators=121]="unusualLineTerminators",W[W.useShadowDOM=122]="useShadowDOM",W[W.useTabStops=123]="useTabStops",W[W.wordBreak=124]="wordBreak",W[W.wordSeparators=125]="wordSeparators",W[W.wordWrap=126]="wordWrap",W[W.wordWrapBreakAfterCharacters=127]="wordWrapBreakAfterCharacters",W[W.wordWrapBreakBeforeCharacters=128]="wordWrapBreakBeforeCharacters",W[W.wordWrapColumn=129]="wordWrapColumn",W[W.wordWrapOverride1=130]="wordWrapOverride1",W[W.wordWrapOverride2=131]="wordWrapOverride2",W[W.wrappingIndent=132]="wrappingIndent",W[W.wrappingStrategy=133]="wrappingStrategy",W[W.showDeprecated=134]="showDeprecated",W[W.inlayHints=135]="inlayHints",W[W.editorClassName=136]="editorClassName",W[W.pixelRatio=137]="pixelRatio",W[W.tabFocusMode=138]="tabFocusMode",W[W.layoutInfo=139]="layoutInfo",W[W.wrappingInfo=140]="wrappingInfo",W[W.defaultColorDecorators=141]="defaultColorDecorators"})(it||(e.EditorOption=it={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Fe(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(189,null)})),acceptSuggestionOnEnter:Fe(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(190,null),""],markdownDescription:o.localize(191,null)})),accessibilitySupport:Fe(new S),accessibilityPageSize:Fe(new y(3,"accessibilityPageSize",10,1,1073741824,{description:o.localize(192,null),tags:["accessibility"]})),ariaLabel:Fe(new t(4,"ariaLabel",o.localize(193,null))),screenReaderAnnounceInlineSuggestion:Fe(new d(6,"screenReaderAnnounceInlineSuggestion",!1,{description:o.localize(194,null),tags:["accessibility"]})),autoClosingBrackets:Fe(new r(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(195,null),o.localize(196,null),""],description:o.localize(197,null)})),autoClosingDelete:Fe(new r(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(198,null),""],description:o.localize(199,null)})),autoClosingOvertype:Fe(new r(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(200,null),""],description:o.localize(201,null)})),autoClosingQuotes:Fe(new r(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(202,null),o.localize(203,null),""],description:o.localize(204,null)})),autoIndent:Fe(new a(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],b,{enumDescriptions:[o.localize(205,null),o.localize(206,null),o.localize(207,null),o.localize(208,null),o.localize(209,null)],description:o.localize(210,null)})),automaticLayout:Fe(new d(11,"automaticLayout",!1)),autoSurround:Fe(new r(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(211,null),o.localize(212,null),o.localize(213,null),""],description:o.localize(214,null)})),bracketPairColorization:Fe(new ve),bracketPairGuides:Fe(new De),stickyTabStops:Fe(new d(111,"stickyTabStops",!1,{description:o.localize(215,null)})),codeLens:Fe(new d(15,"codeLens",!0,{description:o.localize(216,null)})),codeLensFontFamily:Fe(new t(16,"codeLensFontFamily","",{description:o.localize(217,null)})),codeLensFontSize:Fe(new y(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(218,null)})),colorDecorators:Fe(new d(18,"colorDecorators",!0,{description:o.localize(219,null)})),colorDecoratorsLimit:Fe(new y(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:o.localize(220,null)})),columnSelection:Fe(new d(20,"columnSelection",!1,{description:o.localize(221,null)})),comments:Fe(new c),contextmenu:Fe(new d(22,"contextmenu",!0)),copyWithSyntaxHighlighting:Fe(new d(23,"copyWithSyntaxHighlighting",!0,{description:o.localize(222,null)})),cursorBlinking:Fe(new a(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:o.localize(223,null)})),cursorSmoothCaretAnimation:Fe(new r(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[o.localize(224,null),o.localize(225,null),o.localize(226,null)],description:o.localize(227,null)})),cursorStyle:Fe(new a(26,"cursorStyle",f.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],C,{description:o.localize(228,null)})),cursorSurroundingLines:Fe(new y(27,"cursorSurroundingLines",0,0,1073741824,{description:o.localize(229,null)})),cursorSurroundingLinesStyle:Fe(new r(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(230,null),o.localize(231,null)],description:o.localize(232,null)})),cursorWidth:Fe(new y(29,"cursorWidth",0,0,1073741824,{markdownDescription:o.localize(233,null)})),disableLayerHinting:Fe(new d(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:Fe(new d(31,"disableMonospaceOptimizations",!1)),domReadOnly:Fe(new d(32,"domReadOnly",!1)),dragAndDrop:Fe(new d(33,"dragAndDrop",!0,{description:o.localize(234,null)})),emptySelectionClipboard:Fe(new H),dropIntoEditor:Fe(new Ye),stickyScroll:Fe(new he),experimentalWhitespaceRendering:Fe(new r(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[o.localize(235,null),o.localize(236,null),o.localize(237,null)],description:o.localize(238,null)})),extraEditorClassName:Fe(new t(37,"extraEditorClassName","")),fastScrollSensitivity:Fe(new g(38,"fastScrollSensitivity",5,W=>W<=0?5:W,{markdownDescription:o.localize(239,null)})),find:Fe(new V),fixedOverflowWidgets:Fe(new d(40,"fixedOverflowWidgets",!1)),folding:Fe(new d(41,"folding",!0,{description:o.localize(240,null)})),foldingStrategy:Fe(new r(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(241,null),o.localize(242,null)],description:o.localize(243,null)})),foldingHighlight:Fe(new d(43,"foldingHighlight",!0,{description:o.localize(244,null)})),foldingImportsByDefault:Fe(new d(44,"foldingImportsByDefault",!1,{description:o.localize(245,null)})),foldingMaximumRegions:Fe(new y(45,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(246,null)})),unfoldOnClickAfterEndOfLine:Fe(new d(46,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(247,null)})),fontFamily:Fe(new t(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(248,null)})),fontInfo:Fe(new G),fontLigatures2:Fe(new U),fontSize:Fe(new F),fontWeight:Fe(new $),fontVariations:Fe(new z),formatOnPaste:Fe(new d(53,"formatOnPaste",!1,{description:o.localize(249,null)})),formatOnType:Fe(new d(54,"formatOnType",!1,{description:o.localize(250,null)})),glyphMargin:Fe(new d(55,"glyphMargin",!0,{description:o.localize(251,null)})),gotoLocation:Fe(new Y),hideCursorInOverviewRuler:Fe(new d(57,"hideCursorInOverviewRuler",!1,{description:o.localize(252,null)})),hover:Fe(new _),inDiffEditor:Fe(new d(59,"inDiffEditor",!1)),letterSpacing:Fe(new g(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,W=>g.clamp(W,-5,20),{description:o.localize(253,null)})),lightbulb:Fe(new Ee),lineDecorationsWidth:Fe(new x),lineHeight:Fe(new B),lineNumbers:Fe(new ce),lineNumbersMinChars:Fe(new y(66,"lineNumbersMinChars",5,1,300)),linkedEditing:Fe(new d(67,"linkedEditing",!1,{description:o.localize(254,null)})),links:Fe(new d(68,"links",!0,{description:o.localize(255,null)})),matchBrackets:Fe(new r(69,"matchBrackets","always",["always","near","never"],{description:o.localize(256,null)})),minimap:Fe(new Z),mouseStyle:Fe(new r(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Fe(new g(72,"mouseWheelScrollSensitivity",1,W=>W===0?1:W,{markdownDescription:o.localize(257,null)})),mouseWheelZoom:Fe(new d(73,"mouseWheelZoom",!1,{markdownDescription:o.localize(258,null)})),multiCursorMergeOverlapping:Fe(new d(74,"multiCursorMergeOverlapping",!0,{description:o.localize(259,null)})),multiCursorModifier:Fe(new a(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],pe,{markdownEnumDescriptions:[o.localize(260,null),o.localize(261,null)],markdownDescription:o.localize(262,null)})),multiCursorPaste:Fe(new r(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(263,null),o.localize(264,null)],markdownDescription:o.localize(265,null)})),multiCursorLimit:Fe(new y(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:o.localize(266,null)})),occurrencesHighlight:Fe(new d(78,"occurrencesHighlight",!0,{description:o.localize(267,null)})),overviewRulerBorder:Fe(new d(79,"overviewRulerBorder",!0,{description:o.localize(268,null)})),overviewRulerLanes:Fe(new y(80,"overviewRulerLanes",3,0,3)),padding:Fe(new Se),parameterHints:Fe(new re),peekWidgetDefaultFocus:Fe(new r(83,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(269,null),o.localize(270,null)],description:o.localize(271,null)})),definitionLinkOpensInPeek:Fe(new d(84,"definitionLinkOpensInPeek",!1,{description:o.localize(272,null)})),quickSuggestions:Fe(new de),quickSuggestionsDelay:Fe(new y(86,"quickSuggestionsDelay",10,0,1073741824,{description:o.localize(273,null)})),readOnly:Fe(new d(87,"readOnly",!1)),renameOnType:Fe(new d(88,"renameOnType",!1,{description:o.localize(274,null),markdownDeprecationMessage:o.localize(275,null)})),renderControlCharacters:Fe(new d(89,"renderControlCharacters",!0,{description:o.localize(276,null),restricted:!0})),renderFinalNewline:Fe(new r(90,"renderFinalNewline",R.isLinux?"dimmed":"on",["off","on","dimmed"],{description:o.localize(277,null)})),renderLineHighlight:Fe(new r(91,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(278,null)],description:o.localize(279,null)})),renderLineHighlightOnlyWhenFocus:Fe(new d(92,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(280,null)})),renderValidationDecorations:Fe(new r(93,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Fe(new r(94,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(281,null),o.localize(282,null),o.localize(283,null),""],description:o.localize(284,null)})),revealHorizontalRightPadding:Fe(new y(95,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Fe(new d(96,"roundedSelection",!0,{description:o.localize(285,null)})),rulers:Fe(new ue),scrollbar:Fe(new q),scrollBeyondLastColumn:Fe(new y(99,"scrollBeyondLastColumn",4,0,1073741824,{description:o.localize(286,null)})),scrollBeyondLastLine:Fe(new d(100,"scrollBeyondLastLine",!0,{description:o.localize(287,null)})),scrollPredominantAxis:Fe(new d(101,"scrollPredominantAxis",!0,{description:o.localize(288,null)})),selectionClipboard:Fe(new d(102,"selectionClipboard",!0,{description:o.localize(289,null),included:R.isLinux})),selectionHighlight:Fe(new d(103,"selectionHighlight",!0,{description:o.localize(290,null)})),selectOnLineNumbers:Fe(new d(104,"selectOnLineNumbers",!0)),showFoldingControls:Fe(new r(105,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(291,null),o.localize(292,null),o.localize(293,null)],description:o.localize(294,null)})),showUnused:Fe(new d(106,"showUnused",!0,{description:o.localize(295,null)})),showDeprecated:Fe(new d(134,"showDeprecated",!0,{description:o.localize(296,null)})),inlayHints:Fe(new fe),snippetSuggestions:Fe(new r(107,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(297,null),o.localize(298,null),o.localize(299,null),o.localize(300,null)],description:o.localize(301,null)})),smartSelect:Fe(new Pe),smoothScrolling:Fe(new d(109,"smoothScrolling",!1,{description:o.localize(302,null)})),stopRenderingLineAfter:Fe(new y(112,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Fe(new Te),inlineSuggest:Fe(new te),suggestFontSize:Fe(new y(114,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(303,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Fe(new y(115,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(304,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Fe(new d(116,"suggestOnTriggerCharacters",!0,{description:o.localize(305,null)})),suggestSelection:Fe(new r(117,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(306,null),o.localize(307,null),o.localize(308,null)],description:o.localize(309,null)})),tabCompletion:Fe(new r(118,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(310,null),o.localize(311,null),o.localize(312,null)],description:o.localize(313,null)})),tabIndex:Fe(new y(119,"tabIndex",0,-1,1073741824)),unicodeHighlight:Fe(new J),unusualLineTerminators:Fe(new r(121,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(314,null),o.localize(315,null),o.localize(316,null)],description:o.localize(317,null)})),useShadowDOM:Fe(new d(122,"useShadowDOM",!0)),useTabStops:Fe(new d(123,"useTabStops",!0,{description:o.localize(318,null)})),wordBreak:Fe(new r(124,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[o.localize(319,null),o.localize(320,null)],description:o.localize(321,null)})),wordSeparators:Fe(new t(125,"wordSeparators",l.USUAL_WORD_SEPARATORS,{description:o.localize(322,null)})),wordWrap:Fe(new r(126,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(323,null),o.localize(324,null),o.localize(325,null),o.localize(326,null)],description:o.localize(327,null)})),wordWrapBreakAfterCharacters:Fe(new t(127,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Fe(new t(128,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Fe(new y(129,"wordWrapColumn",80,1,1073741824,{markdownDescription:o.localize(328,null)})),wordWrapOverride1:Fe(new r(130,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Fe(new r(131,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Fe(new M),defaultColorDecorators:Fe(new d(141,"defaultColorDecorators",!1,{markdownDescription:o.localize(329,null)})),pixelRatio:Fe(new ne),tabFocusMode:Fe(new d(138,"tabFocusMode",!1,{markdownDescription:o.localize(330,null)})),layoutInfo:Fe(new ie),wrappingInfo:Fe(new et),wrappingIndent:Fe(new Ve),wrappingStrategy:Fe(new oe)}}),define(Ce[172],ke([12,13]),function(ae,e){return ae.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Ce[173],ke([12,13]),function(ae,e){return ae.create("vs/platform/contextkey/common/contextkey",e)}),define(Ce[174],ke([12,13]),function(ae,e){return ae.create("vs/platform/contextkey/common/scanner",e)}),define(Ce[175],ke([12,13]),function(ae,e){return ae.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Ce[176],ke([12,13]),function(ae,e){return ae.create("vs/platform/extensions/common/extensionValidator",e)}),define(Ce[177],ke([12,13]),function(ae,e){return ae.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Ce[178],ke([12,13]),function(ae,e){return ae.create("vs/platform/files/common/files",e)}),define(Ce[179],ke([12,13]),function(ae,e){return ae.create("vs/platform/markers/common/markers",e)}),define(Ce[180],ke([12,13]),function(ae,e){return ae.create("vs/platform/theme/common/iconRegistry",e)}),define(Ce[181],ke([12,13]),function(ae,e){return ae.create("vs/platform/workspace/common/workspace",e)}),define(Ce[182],ke([12,13]),function(ae,e){return ae.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Ce[183],ke([12,13]),function(ae,e){return ae.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Ce[184],ke([12,13]),function(ae,e){return ae.create("vs/workbench/api/common/extHostInteractiveSession",e)}),define(Ce[185],ke([12,13]),function(ae,e){return ae.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Ce[186],ke([12,13]),function(ae,e){return ae.create("vs/workbench/api/common/extHostLogService",e)}),define(Ce[187],ke([12,13]),function(ae,e){return ae.create("vs/workbench/api/common/extHostProgress",e)}),define(Ce[188],ke([12,13]),function(ae,e){return ae.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Ce[189],ke([12,13]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Ce[190],ke([12,13]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Ce[191],ke([12,13]),function(ae,e){return ae.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Ce[192],ke([12,13]),function(ae,e){return ae.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Ce[193],ke([12,13]),function(ae,e){return ae.create("vs/workbench/api/node/extHostDebugService",e)}),define(Ce[194],ke([12,13]),function(ae,e){return ae.create("vs/workbench/api/node/extHostTunnelService",e)}),define(Ce[195],ke([12,13]),function(ae,e){return ae.create("vs/workbench/common/editor",e)}),define(Ce[196],ke([12,13]),function(ae,e){return ae.create("vs/workbench/common/views",e)}),define(Ce[197],ke([12,13]),function(ae,e){return ae.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Ce[198],ke([12,13]),function(ae,e){return ae.create("vs/workbench/contrib/debug/common/debug",e)}),define(Ce[199],ke([12,13]),function(ae,e){return ae.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(Ce[200],ke([12,13]),function(ae,e){return ae.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Ce[201],ke([12,13]),function(ae,e){return ae.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Ce[202],ke([12,13]),function(ae,e){return ae.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Ce[203],ke([12,13]),function(ae,e){return ae.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Ce[204],ke([12,13]),function(ae,e){return ae.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Ce[205],ke([1,0,8,174]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var l;(function(p){p[p.LParen=0]="LParen",p[p.RParen=1]="RParen",p[p.Neg=2]="Neg",p[p.Eq=3]="Eq",p[p.NotEq=4]="NotEq",p[p.Lt=5]="Lt",p[p.LtEq=6]="LtEq",p[p.Gt=7]="Gt",p[p.GtEq=8]="GtEq",p[p.RegexOp=9]="RegexOp",p[p.RegexStr=10]="RegexStr",p[p.True=11]="True",p[p.False=12]="False",p[p.In=13]="In",p[p.Not=14]="Not",p[p.And=15]="And",p[p.Or=16]="Or",p[p.Str=17]="Str",p[p.QuotedStr=18]="QuotedStr",p[p.Error=19]="Error",p[p.EOF=20]="EOF"})(l||(e.TokenType=l={}));function L(...p){switch(p.length){case 1:return(0,R.localize)(0,null,p[0]);case 2:return(0,R.localize)(1,null,p[0],p[1]);case 3:return(0,R.localize)(2,null,p[0],p[1],p[2]);default:return}}const A=(0,R.localize)(3,null),P=(0,R.localize)(4,null);class D{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(O){switch(O.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return O.isTripleEq?"===":"==";case 4:return O.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return O.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return O.lexeme;case 18:return O.lexeme;case 19:return O.lexeme;case 20:return"EOF";default:throw(0,o.illegalState)(`unhandled token type: ${JSON.stringify(O)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(O){return this.c=O,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const k=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:k})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const k=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:k})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(O){return this.r()||this.c.charCodeAt(this.e)!==O?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(O){this.f.push({type:O,offset:this.d})}l(O){const k=this.d,E=this.c.substring(this.d,this.e),T={type:19,offset:this.d,lexeme:E};this.g.push({offset:k,lexeme:E,additionalInfo:O}),this.f.push(T)}n(){this.m.lastIndex=this.d;const O=this.m.exec(this.c);if(O){this.e=this.d+O[0].length;const k=this.c.substring(this.d,this.e),E=D.b.get(k);E?this.k(E):this.f.push({type:17,lexeme:k,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let O=this.e,k=!1,E=!1;for(;;){if(O>=this.c.length){this.e=O,this.l(P);return}const I=this.c.charCodeAt(O);if(k)k=!1;else if(I===47&&!E){O++;break}else I===91?E=!0:I===92?k=!0:I===93&&(E=!1);O++}for(;O<this.c.length&&D.a.has(this.c.charCodeAt(O));)O++;this.e=O;const T=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:T,offset:this.d})}r(){return this.e>=this.c.length}}e.Scanner=D,D.a=new Set(["i","g","s","m","y","u"].map(p=>p.charCodeAt(0))),D.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Ce[206],ke([1,0,24,38,176,329]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function D(d){return d=d.trim(),d==="*"||A.test(d)}e.isValidVersionStr=D;function p(d){if(!D(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const h=d.match(A);return h?{hasCaret:h[1]==="^",hasGreaterEquals:h[1]===">=",majorBase:h[2]==="x"?0:parseInt(h[2],10),majorMustEqual:h[2]!=="x",minorBase:h[4]==="x"?0:parseInt(h[4],10),minorMustEqual:h[4]!=="x",patchBase:h[6]==="x"?0:parseInt(h[6],10),patchMustEqual:h[6]!=="x",preRelease:h[8]||null}:null}e.parseVersion=p;function O(d){if(!d)return null;const h=d.majorBase,y=d.majorMustEqual,w=d.minorBase;let g=d.minorMustEqual;const t=d.patchBase;let s=d.patchMustEqual;d.hasCaret&&(h===0||(g=!1),s=!1);let r=0;if(d.preRelease){const a=P.exec(d.preRelease);if(a){const[,b,S,c]=a;r=Date.UTC(Number(b),Number(S)-1,Number(c))}}return{majorBase:h,majorMustEqual:y,minorBase:w,minorMustEqual:g,patchBase:t,patchMustEqual:s,isMinimum:d.hasGreaterEquals,notBefore:r}}e.normalizeVersion=O;function k(d,h,y){let w;typeof d=="string"?w=O(p(d)):w=d;let g;h instanceof Date?g=h.getTime():typeof h=="string"&&(g=new Date(h).getTime());let t;if(typeof y=="string"?t=O(p(y)):t=y,!w||!t)return!1;const s=w.majorBase,r=w.minorBase,a=w.patchBase;let b=t.majorBase,S=t.minorBase,c=t.patchBase;const u=t.notBefore;let m=t.majorMustEqual,f=t.minorMustEqual,n=t.patchMustEqual;return t.isMinimum?s>b?!0:s<b?!1:r>S?!0:r<S||g&&g<u?!1:a>=c:(s===1&&b===0&&(!m||!f||!n)&&(b=1,S=0,c=0,m=!0,f=!1,n=!1),s<b?!1:s>b?!m:r<S?!1:r>S?!f:a<c?!1:a>c?!n:!(g&&g<u))}e.isValidVersion=k;function E(d,h,y,w,g){const t=[];if(typeof w.publisher<"u"&&typeof w.publisher!="string")return t.push([R.default.Error,l.localize(0,null)]),t;if(typeof w.name!="string")return t.push([R.default.Error,l.localize(1,null,"name")]),t;if(typeof w.version!="string")return t.push([R.default.Error,l.localize(2,null,"version")]),t;if(!w.engines)return t.push([R.default.Error,l.localize(3,null,"engines")]),t;if(typeof w.engines.vscode!="string")return t.push([R.default.Error,l.localize(4,null,"engines.vscode")]),t;if(typeof w.extensionDependencies<"u"&&!i(w.extensionDependencies))return t.push([R.default.Error,l.localize(5,null,"extensionDependencies")]),t;if(typeof w.activationEvents<"u"){if(!i(w.activationEvents))return t.push([R.default.Error,l.localize(6,null,"activationEvents")]),t;if(typeof w.main>"u"&&typeof w.browser>"u")return t.push([R.default.Error,l.localize(7,null,"activationEvents","main","browser")]),t}if(typeof w.extensionKind<"u"&&typeof w.main>"u"&&t.push([R.default.Warning,l.localize(8,null,"extensionKind")]),typeof w.main<"u"){if(typeof w.main!="string")return t.push([R.default.Error,l.localize(9,null,"main")]),t;{const a=(0,o.joinPath)(y,w.main);(0,o.isEqualOrParent)(a,y)||t.push([R.default.Warning,l.localize(10,null,a.path,y.path)])}}if(typeof w.browser<"u"){if(typeof w.browser!="string")return t.push([R.default.Error,l.localize(11,null,"browser")]),t;{const a=(0,o.joinPath)(y,w.browser);(0,o.isEqualOrParent)(a,y)||t.push([R.default.Warning,l.localize(12,null,a.path,y.path)])}}if(!L.valid(w.version))return t.push([R.default.Error,l.localize(13,null)]),t;const s=[];if(!T(d,h,w,g,s))for(const a of s)t.push([R.default.Error,a]);return t}e.validateExtensionManifest=E;function T(d,h,y,w,g){return w||typeof y.main>"u"&&typeof y.browser>"u"?!0:v(d,h,y.engines.vscode,g)}e.isValidExtensionVersion=T;function I(d,h,y){return d==="*"||v(h,y,d)}e.isEngineValid=I;function v(d,h,y,w=[]){const g=O(p(y));if(!g)return w.push(l.localize(14,null,y)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return w.push(l.localize(15,null,y)),!1}else if(!g.majorMustEqual)return w.push(l.localize(16,null,y)),!1;return k(d,h,g)?!0:(w.push(l.localize(17,null,d,y)),!1)}function i(d){if(!Array.isArray(d))return!1;for(let h=0,y=d.length;h<y;h++)if(typeof d[h]!="string")return!1;return!0}}),define(Ce[90],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class o{constructor(l,L=[],A=!1){this.ctor=l,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=o}),define(Ce[91],ke([1,0,90]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const R=[];var l;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(l||(e.InstantiationType=l={}));function L(P,D,p){D instanceof o.SyncDescriptor||(D=new o.SyncDescriptor(D,[],!!p)),R.push([P,D])}e.registerSingleton=L;function A(){return R}e.getSingletonServiceDescriptors=A}),define(Ce[207],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class o{constructor(L,A){this.key=L,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.Node=o;class R{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const A of this.a.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const P=this.lookupOrInsertNode(L),D=this.lookupOrInsertNode(A);P.outgoing.set(D.key,D),D.incoming.set(P.key,P)}removeNode(L){const A=this.b(L);this.a.delete(A);for(const P of this.a.values())P.outgoing.delete(A),P.incoming.delete(A)}lookupOrInsertNode(L){const A=this.b(L);let P=this.a.get(A);return P||(P=new o(A,L),this.a.set(A,P)),P}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[A,P]of this.a)L.push(`${A}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this.a){const P=new Set([L]),D=this.c(A,P);if(D)return D}}c(L,A){for(const[P,D]of L.outgoing){if(A.has(P))return[...A,P].join(" -> ");A.add(P);const p=this.c(D,A);if(p)return p;A.delete(P)}}}e.Graph=R}),define(Ce[4],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var o;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function P(D){return D[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=P})(o||(e._util=o={})),e.IInstantiationService=l("instantiationService");function R(A,P,D){P[o.DI_TARGET]===P?P[o.DI_DEPENDENCIES].push({id:A,index:D}):(P[o.DI_DEPENDENCIES]=[{id:A,index:D}],P[o.DI_TARGET]=P)}function l(A){if(o.serviceIds.has(A))return o.serviceIds.get(A);const P=function(D,p,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");R(P,D,O)};return P.toString=()=>A,o.serviceIds.set(A,P),P}e.createDecorator=l;function L(A){return A}e.refineServiceDecorator=L}),define(Ce[55],ke([1,0,10,2,4]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function L(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof R.URI)}e.isConfigurationOverrides=L;function A(i){return i&&typeof i=="object"&&(!i.overrideIdentifiers||Array.isArray(i.overrideIdentifiers))&&!i.overrideIdentifier&&(!i.resource||i.resource instanceof R.URI)}e.isConfigurationUpdateOverrides=A;var P;(function(i){i[i.APPLICATION=1]="APPLICATION",i[i.USER=2]="USER",i[i.USER_LOCAL=3]="USER_LOCAL",i[i.USER_REMOTE=4]="USER_REMOTE",i[i.WORKSPACE=5]="WORKSPACE",i[i.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",i[i.DEFAULT=7]="DEFAULT",i[i.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function D(i){switch(i){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=D;function p(i,d){const h=Object.create(null);for(const y in i)O(h,y,i[y],d);return h}e.toValuesTree=p;function O(i,d,h,y){const w=d.split("."),g=w.pop();let t=i;for(let s=0;s<w.length;s++){const r=w[s];let a=t[r];switch(typeof a){case"undefined":a=t[r]=Object.create(null);break;case"object":break;default:y(`Ignoring ${d} as ${w.slice(0,s+1).join(".")} is ${JSON.stringify(a)}`);return}t=a}if(typeof t=="object"&&t!==null)try{t[g]=h}catch{y(`Ignoring ${d} as ${w.join(".")} is ${JSON.stringify(t)}`)}else y(`Ignoring ${d} as ${w.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=O;function k(i,d){const h=d.split(".");E(i,h)}e.removeFromValueTree=k;function E(i,d){const h=d.shift();if(d.length===0){delete i[h];return}if(Object.keys(i).indexOf(h)!==-1){const y=i[h];typeof y=="object"&&!Array.isArray(y)&&(E(y,d),Object.keys(y).length===0&&delete i[h])}}function T(i,d,h){function y(t,s){let r=t;for(const a of s){if(typeof r!="object"||r===null)return;r=r[a]}return r}const w=d.split("."),g=y(i,w);return typeof g>"u"?h:g}e.getConfigurationValue=T;function I(i,d,h){Object.keys(d).forEach(y=>{y!=="__proto__"&&(y in i?o.isObject(i[y])&&o.isObject(d[y])?I(i[y],d[y],h):h&&(i[y]=d[y]):i[y]=d[y])})}e.merge=I;function v(i){return i.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=v}),define(Ce[44],ke([1,0,14,9,205,4,173,8]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const D=new Map;D.set("false",!1),D.set("true",!0),D.set("isMac",o.isMacintosh),D.set("isLinux",o.isLinux),D.set("isWindows",o.isWindows),D.set("isWeb",o.isWeb),D.set("isMacNative",o.isMacintosh&&!o.isWeb),D.set("isEdge",o.isEdge),D.set("isFirefox",o.isFirefox),D.set("isChrome",o.isChrome),D.set("isSafari",o.isSafari);function p(x,B){if(D.get(x)!==void 0)throw(0,P.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");D.set(x,B)}e.setConstant=p;const O=Object.prototype.hasOwnProperty;var k;(function(x){x[x.False=0]="False",x[x.True=1]="True",x[x.Defined=2]="Defined",x[x.Not=3]="Not",x[x.Equals=4]="Equals",x[x.NotEquals=5]="NotEquals",x[x.And=6]="And",x[x.Regex=7]="Regex",x[x.NotRegex=8]="NotRegex",x[x.Or=9]="Or",x[x.In=10]="In",x[x.NotIn=11]="NotIn",x[x.Greater=12]="Greater",x[x.GreaterEquals=13]="GreaterEquals",x[x.Smaller=14]="Smaller",x[x.SmallerEquals=15]="SmallerEquals"})(k||(e.ContextKeyExprType=k={}));const E={regexParsingWithErrorRecovery:!0},T=(0,A.localize)(0,null),I=(0,A.localize)(1,null),v=(0,A.localize)(2,null),i=(0,A.localize)(3,null),d=(0,A.localize)(4,null),h=(0,A.localize)(5,null),y=(0,A.localize)(6,null),w=(0,A.localize)(7,null);class g{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(B=E){this.k=B,this.d=new l.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(B){if(B===""){this.h.push({message:T,offset:0,lexeme:"",additionalInfo:I});return}this.f=this.d.reset(B).scan(),this.g=0,this.h=[];try{const Z=this.l();if(!this.E()){const pe=this.D(),Se=pe.type===17?h:void 0;throw this.h.push({message:d,offset:pe.offset,lexeme:l.Scanner.getLexeme(pe),additionalInfo:Se}),g.c}return Z}catch(Z){if(Z!==g.c)throw Z;return}}l(){return this.m()}m(){const B=[this.o()];for(;this.y(16);){const Z=this.o();B.push(Z)}return B.length===1?B[0]:t.or(...B)}o(){const B=[this.s()];for(;this.y(15);){const Z=this.s();B.push(Z)}return B.length===1?B[0]:t.and(...B)}s(){if(this.y(2)){const B=this.D();switch(B.type){case 11:return this.z(),b.INSTANCE;case 12:return this.z(),S.INSTANCE;case 0:{this.z();const Z=this.l();return this.A(1,i),Z?.negate()}case 17:return this.z(),C.create(B.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",B)}}return this.t()}t(){const B=this.D();switch(B.type){case 11:return this.z(),t.true();case 12:return this.z(),t.false();case 0:{this.z();const Z=this.l();return this.A(1,i),Z}case 17:{const Z=B.lexeme;if(this.z(),this.y(9)){const Se=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Se.type!==10)throw this.B("REGEX",Se);const re=Se.lexeme,ne=re.lastIndexOf("/"),de=ne===re.length-1?void 0:this.w(re.substring(ne+1));let ee;try{ee=new RegExp(re.substring(1,ne),de)}catch{throw this.B("REGEX",Se)}return G.create(Z,ee)}switch(Se.type){case 10:case 19:{const re=[Se.lexeme];this.z();let ne=this.D(),de=0;for(let N=0;N<Se.lexeme.length;N++)Se.lexeme.charCodeAt(N)===40?de++:Se.lexeme.charCodeAt(N)===41&&de--;for(;!this.E()&&ne.type!==15&&ne.type!==16;){switch(ne.type){case 0:de++;break;case 1:de--;break;case 10:case 18:for(let N=0;N<ne.lexeme.length;N++)ne.lexeme.charCodeAt(N)===40?de++:Se.lexeme.charCodeAt(N)===41&&de--}if(de<0)break;re.push(l.Scanner.getLexeme(ne)),this.z(),ne=this.D()}const ee=re.join(""),ce=ee.lastIndexOf("/"),le=ce===ee.length-1?void 0:this.w(ee.substring(ce+1));let ue;try{ue=new RegExp(ee.substring(1,ce),le)}catch{throw this.B("REGEX",Se)}return t.regex(Z,ue)}case 18:{const re=Se.lexeme;this.z();let ne=null;if(!(0,R.isFalsyOrWhitespace)(re)){const de=re.indexOf("/"),ee=re.lastIndexOf("/");if(de!==ee&&de>=0){const ce=re.slice(de+1,ee),le=re[ee+1]==="i"?"i":"";try{ne=new RegExp(ce,le)}catch{throw this.B("REGEX",Se)}}}if(ne===null)throw this.B("REGEX",Se);return G.create(Z,ne)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,v);const Se=this.u();return t.notIn(Z,Se)}switch(this.D().type){case 3:{this.z();const Se=this.u();if(this.x().type===18)return t.equals(Z,Se);switch(Se){case"true":return t.has(Z);case"false":return t.not(Z);default:return t.equals(Z,Se)}}case 4:{this.z();const Se=this.u();if(this.x().type===18)return t.notEquals(Z,Se);switch(Se){case"true":return t.not(Z);case"false":return t.has(Z);default:return t.notEquals(Z,Se)}}case 5:return this.z(),U.create(Z,this.u());case 6:return this.z(),z.create(Z,this.u());case 7:return this.z(),H.create(Z,this.u());case 8:return this.z(),V.create(Z,this.u());case 13:return this.z(),t.in(Z,this.u());default:return t.has(Z)}}case 20:throw this.h.push({message:y,offset:B.offset,lexeme:"",additionalInfo:w}),g.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const B=this.D();switch(B.type){case 17:case 18:return this.z(),B.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(B){return B.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(B){return this.C(B)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(B,Z){if(this.C(B))return this.z();throw this.B(Z,this.D())}B(B,Z,pe){const Se=(0,A.localize)(8,null,B,l.Scanner.getLexeme(Z)),re=Z.offset,ne=l.Scanner.getLexeme(Z);return this.h.push({message:Se,offset:re,lexeme:ne,additionalInfo:pe}),g.c}C(B){return this.D().type===B}D(){return this.f[this.g]}E(){return this.D().type===20}}e.Parser=g,g.c=new Error;class t{static false(){return b.INSTANCE}static true(){return S.INSTANCE}static has(B){return c.create(B)}static equals(B,Z){return u.create(B,Z)}static notEquals(B,Z){return n.create(B,Z)}static regex(B,Z){return G.create(B,Z)}static in(B,Z){return m.create(B,Z)}static notIn(B,Z){return f.create(B,Z)}static not(B){return C.create(B)}static and(...B){return Y.create(B,null,!0)}static or(...B){return _.create(B,null,!0)}static greater(B,Z){return H.create(B,Z)}static greaterEquals(B,Z){return V.create(B,Z)}static smaller(B,Z){return U.create(B,Z)}static smallerEquals(B,Z){return z.create(B,Z)}static deserialize(B){return B==null?void 0:this.c.parse(B)}}e.ContextKeyExpr=t,t.c=new g({regexParsingWithErrorRecovery:!1});function s(x){const B=new g({regexParsingWithErrorRecovery:!1});return x.map(Z=>(B.parse(Z),B.lexingErrors.length>0?B.lexingErrors.map(pe=>({errorMessage:pe.additionalInfo?(0,A.localize)(9,null,pe.additionalInfo):(0,A.localize)(10,null),offset:pe.offset,length:pe.lexeme.length})):B.parsingErrors.length>0?B.parsingErrors.map(pe=>({errorMessage:pe.additionalInfo?`${pe.message}. ${pe.additionalInfo}`:pe.message,offset:pe.offset,length:pe.lexeme.length})):[]))}e.validateWhenClauses=s;function r(x,B){const Z=x?x.substituteConstants():void 0,pe=B?B.substituteConstants():void 0;return!Z&&!pe?!0:!Z||!pe?!1:Z.equals(pe)}e.expressionsAreEqualWithConstantSubstitution=r;function a(x,B){return x.cmp(B)}class b{constructor(){this.type=0}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!1}serialize(){return"false"}keys(){return[]}map(B){return this}negate(){return S.INSTANCE}}e.ContextKeyFalseExpr=b,b.INSTANCE=new b;class S{constructor(){this.type=1}cmp(B){return this.type-B.type}equals(B){return B.type===this.type}substituteConstants(){return this}evaluate(B){return!0}serialize(){return"true"}keys(){return[]}map(B){return this}negate(){return b.INSTANCE}}e.ContextKeyTrueExpr=S,S.INSTANCE=new S;class c{static create(B,Z=null){const pe=D.get(B);return typeof pe=="boolean"?pe?S.INSTANCE:b.INSTANCE:new c(B,Z)}constructor(B,Z){this.key=B,this.c=Z,this.type=2}cmp(B){return B.type!==this.type?this.type-B.type:ie(this.key,B.key)}equals(B){return B.type===this.type?this.key===B.key:!1}substituteConstants(){const B=D.get(this.key);return typeof B=="boolean"?B?S.INSTANCE:b.INSTANCE:this}evaluate(B){return!!B.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(B){return B.mapDefined(this.key)}negate(){return this.c||(this.c=C.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=c;class u{static create(B,Z,pe=null){if(typeof Z=="boolean")return Z?c.create(B,pe):C.create(B,pe);const Se=D.get(B);return typeof Se=="boolean"?Z===(Se?"true":"false")?S.INSTANCE:b.INSTANCE:new u(B,Z,pe)}constructor(B,Z,pe){this.c=B,this.d=Z,this.f=pe,this.type=4}cmp(B){return B.type!==this.type?this.type-B.type:oe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=D.get(this.c);if(typeof B=="boolean"){const Z=B?"true":"false";return this.d===Z?S.INSTANCE:b.INSTANCE}return this}evaluate(B){return B.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(B){return B.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=u;class m{static create(B,Z){return new m(B,Z)}constructor(B,Z){this.d=B,this.f=Z,this.type=10,this.c=null}cmp(B){return B.type!==this.type?this.type-B.type:oe(this.d,this.f,B.d,B.f)}equals(B){return B.type===this.type?this.d===B.d&&this.f===B.f:!1}substituteConstants(){return this}evaluate(B){const Z=B.getValue(this.f),pe=B.getValue(this.d);return Array.isArray(Z)?Z.includes(pe):typeof pe=="string"&&typeof Z=="object"&&Z!==null?O.call(Z,pe):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(B){return B.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=m;class f{static create(B,Z){return new f(B,Z)}constructor(B,Z){this.d=B,this.f=Z,this.type=11,this.c=m.create(B,Z)}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(B){return B.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=f;class n{static create(B,Z,pe=null){if(typeof Z=="boolean")return Z?C.create(B,pe):c.create(B,pe);const Se=D.get(B);return typeof Se=="boolean"?Z===(Se?"true":"false")?b.INSTANCE:S.INSTANCE:new n(B,Z,pe)}constructor(B,Z,pe){this.c=B,this.d=Z,this.f=pe,this.type=5}cmp(B){return B.type!==this.type?this.type-B.type:oe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){const B=D.get(this.c);if(typeof B=="boolean"){const Z=B?"true":"false";return this.d===Z?b.INSTANCE:S.INSTANCE}return this}evaluate(B){return B.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(B){return B.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=n;class C{static create(B,Z=null){const pe=D.get(B);return typeof pe=="boolean"?pe?b.INSTANCE:S.INSTANCE:new C(B,Z)}constructor(B,Z){this.c=B,this.d=Z,this.type=3}cmp(B){return B.type!==this.type?this.type-B.type:ie(this.c,B.c)}equals(B){return B.type===this.type?this.c===B.c:!1}substituteConstants(){const B=D.get(this.c);return typeof B=="boolean"?B?b.INSTANCE:S.INSTANCE:this}evaluate(B){return!B.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(B){return B.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.ContextKeyNotExpr=C;function M(x,B){if(typeof x=="string"){const Z=parseFloat(x);isNaN(Z)||(x=Z)}return typeof x=="string"||typeof x=="number"?B(x):b.INSTANCE}class H{static create(B,Z,pe=null){return M(Z,Se=>new H(B,Se,pe))}constructor(B,Z,pe){this.c=B,this.d=Z,this.f=pe,this.type=12}cmp(B){return B.type!==this.type?this.type-B.type:oe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=z.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=H;class V{static create(B,Z,pe=null){return M(Z,Se=>new V(B,Se,pe))}constructor(B,Z,pe){this.c=B,this.d=Z,this.f=pe,this.type=13}cmp(B){return B.type!==this.type?this.type-B.type:oe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(B){return B.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=U.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=V;class U{static create(B,Z,pe=null){return M(Z,Se=>new U(B,Se,pe))}constructor(B,Z,pe){this.c=B,this.d=Z,this.f=pe,this.type=14}cmp(B){return B.type!==this.type?this.type-B.type:oe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=U;class z{static create(B,Z,pe=null){return M(Z,Se=>new z(B,Se,pe))}constructor(B,Z,pe){this.c=B,this.d=Z,this.f=pe,this.type=15}cmp(B){return B.type!==this.type?this.type-B.type:oe(this.c,this.d,B.c,B.d)}equals(B){return B.type===this.type?this.c===B.c&&this.d===B.d:!1}substituteConstants(){return this}evaluate(B){return typeof this.d=="string"?!1:parseFloat(B.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(B){return B.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=H.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=z;class G{static create(B,Z){return new G(B,Z)}constructor(B,Z){this.d=B,this.f=Z,this.type=7,this.c=null}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.d<B.d)return-1;if(this.d>B.d)return 1;const Z=this.f?this.f.source:"",pe=B.f?B.f.source:"";return Z<pe?-1:Z>pe?1:0}equals(B){if(B.type===this.type){const Z=this.f?this.f.source:"",pe=B.f?B.f.source:"";return this.d===B.d&&Z===pe}return!1}substituteConstants(){return this}evaluate(B){const Z=B.getValue(this.d);return this.f?this.f.test(Z):!1}serialize(){const B=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${B}`}keys(){return[this.d]}map(B){return B.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=F.create(this)),this.c}}e.ContextKeyRegexExpr=G;class F{static create(B){return new F(B)}constructor(B){this.c=B,this.type=8}cmp(B){return B.type!==this.type?this.type-B.type:this.c.cmp(B.c)}equals(B){return B.type===this.type?this.c.equals(B.c):!1}substituteConstants(){return this}evaluate(B){return!this.c.evaluate(B)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(B){return new F(this.c.map(B))}negate(){return this.c}}e.ContextKeyNotRegexExpr=F;function $(x){let B=null;for(let Z=0,pe=x.length;Z<pe;Z++){const Se=x[Z].substituteConstants();if(x[Z]!==Se&&B===null){B=[];for(let re=0;re<Z;re++)B[re]=x[re]}B!==null&&(B[Z]=Se)}return B===null?x:B}class Y{static create(B,Z,pe){return Y.d(B,Z,pe)}constructor(B,Z){this.expr=B,this.c=Z,this.type=6}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let Z=0,pe=this.expr.length;Z<pe;Z++){const Se=a(this.expr[Z],B.expr[Z]);if(Se!==0)return Se}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let Z=0,pe=this.expr.length;Z<pe;Z++)if(!this.expr[Z].equals(B.expr[Z]))return!1;return!0}return!1}substituteConstants(){const B=$(this.expr);return B===this.expr?this:Y.create(B,this.c,!1)}evaluate(B){for(let Z=0,pe=this.expr.length;Z<pe;Z++)if(!this.expr[Z].evaluate(B))return!1;return!0}static d(B,Z,pe){const Se=[];let re=!1;for(const ne of B)if(ne){if(ne.type===1){re=!0;continue}if(ne.type===0)return b.INSTANCE;if(ne.type===6){Se.push(...ne.expr);continue}Se.push(ne)}if(Se.length===0&&re)return S.INSTANCE;if(Se.length!==0){if(Se.length===1)return Se[0];Se.sort(a);for(let ne=1;ne<Se.length;ne++)Se[ne-1].equals(Se[ne])&&(Se.splice(ne,1),ne--);if(Se.length===1)return Se[0];for(;Se.length>1;){const ne=Se[Se.length-1];if(ne.type!==9)break;Se.pop();const de=Se.pop(),ee=Se.length===0,ce=_.create(ne.expr.map(le=>Y.create([le,de],null,pe)),null,ee);ce&&(Se.push(ce),Se.sort(a))}if(Se.length===1)return Se[0];if(pe){for(let ne=0;ne<Se.length;ne++)for(let de=ne+1;de<Se.length;de++)if(Se[ne].negate().equals(Se[de]))return b.INSTANCE;if(Se.length===1)return Se[0]}return new Y(Se,Z)}}serialize(){return this.expr.map(B=>B.serialize()).join(" && ")}keys(){const B=[];for(const Z of this.expr)B.push(...Z.keys());return B}map(B){return new Y(this.expr.map(Z=>Z.map(B)),null)}negate(){if(!this.c){const B=[];for(const Z of this.expr)B.push(Z.negate());this.c=_.create(B,this,!0)}return this.c}}e.ContextKeyAndExpr=Y;class _{static create(B,Z,pe){return _.d(B,Z,pe)}constructor(B,Z){this.expr=B,this.c=Z,this.type=9}cmp(B){if(B.type!==this.type)return this.type-B.type;if(this.expr.length<B.expr.length)return-1;if(this.expr.length>B.expr.length)return 1;for(let Z=0,pe=this.expr.length;Z<pe;Z++){const Se=a(this.expr[Z],B.expr[Z]);if(Se!==0)return Se}return 0}equals(B){if(B.type===this.type){if(this.expr.length!==B.expr.length)return!1;for(let Z=0,pe=this.expr.length;Z<pe;Z++)if(!this.expr[Z].equals(B.expr[Z]))return!1;return!0}return!1}substituteConstants(){const B=$(this.expr);return B===this.expr?this:_.create(B,this.c,!1)}evaluate(B){for(let Z=0,pe=this.expr.length;Z<pe;Z++)if(this.expr[Z].evaluate(B))return!0;return!1}static d(B,Z,pe){let Se=[],re=!1;if(B){for(let ne=0,de=B.length;ne<de;ne++){const ee=B[ne];if(ee){if(ee.type===0){re=!0;continue}if(ee.type===1)return S.INSTANCE;if(ee.type===9){Se=Se.concat(ee.expr);continue}Se.push(ee)}}if(Se.length===0&&re)return b.INSTANCE;Se.sort(a)}if(Se.length!==0){if(Se.length===1)return Se[0];for(let ne=1;ne<Se.length;ne++)Se[ne-1].equals(Se[ne])&&(Se.splice(ne,1),ne--);if(Se.length===1)return Se[0];if(pe){for(let ne=0;ne<Se.length;ne++)for(let de=ne+1;de<Se.length;de++)if(Se[ne].negate().equals(Se[de]))return S.INSTANCE;if(Se.length===1)return Se[0]}return new _(Se,Z)}}serialize(){return this.expr.map(B=>B.serialize()).join(" || ")}keys(){const B=[];for(const Z of this.expr)B.push(...Z.keys());return B}map(B){return new _(this.expr.map(Z=>Z.map(B)),null)}negate(){if(!this.c){const B=[];for(const Z of this.expr)B.push(Z.negate());for(;B.length>1;){const Z=B.shift(),pe=B.shift(),Se=[];for(const re of fe(Z))for(const ne of fe(pe))Se.push(Y.create([re,ne],null,!1));B.unshift(_.create(Se,null,!1))}this.c=_.create(B,this,!0)}return this.c}}e.ContextKeyOrExpr=_;class Q extends c{static all(){return Q.d.values()}constructor(B,Z,pe){super(B,null),this.f=Z,typeof pe=="object"?Q.d.push({...pe,key:B}):pe!==!0&&Q.d.push({key:B,description:pe,type:Z!=null?typeof Z:void 0})}bindTo(B){return B.createKey(this.key,this.f)}getValue(B){return B.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(B){return u.create(this.key,B)}notEqualsTo(B){return n.create(this.key,B)}}e.RawContextKey=Q,Q.d=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService");function ie(x,B){return x<B?-1:x>B?1:0}function oe(x,B,Z,pe){return x<Z?-1:x>Z?1:B<pe?-1:B>pe?1:0}function Ee(x,B){if(x.type===0||B.type===1)return!0;if(x.type===9)return B.type===9?he(x.expr,B.expr):!1;if(B.type===9){for(const Z of B.expr)if(Ee(x,Z))return!0;return!1}if(x.type===6){if(B.type===6)return he(B.expr,x.expr);for(const Z of x.expr)if(Ee(Z,B))return!0;return!1}return x.equals(B)}e.implies=Ee;function he(x,B){let Z=0,pe=0;for(;Z<x.length&&pe<B.length;){const Se=x[Z].cmp(B[pe]);if(Se<0)return!1;Se===0&&Z++,pe++}return Z===x.length}function fe(x){return x.type===9?x.expr:[x]}}),define(Ce[208],ke([1,0,4]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,o.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,o.refineServiceDecorator)(e.IEnvironmentService)}),define(Ce[122],ke([1,0,175,4]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function L(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function A(h,y){switch(h){case 3:return y==="x64"?"win32-x64":y==="ia32"?"win32-ia32":y==="arm64"?"win32-arm64":"unknown";case 2:return y==="x64"?"linux-x64":y==="arm64"?"linux-arm64":y==="arm"?"linux-armhf":"unknown";case"alpine":return y==="x64"?"alpine-x64":y==="arm64"?"alpine-arm64":"unknown";case 1:return y==="x64"?"darwin-x64":y==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function P(h,y){return y==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function D(h,y,w){return P(y,w)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===w?!0:p(w).includes(h)}e.isTargetPlatformCompatible=D;function p(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=p;function O(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=O;var k;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(k||(e.SortBy=k={}));var E;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(E||(e.SortOrder=E={}));var T;(function(h){h.Install="install",h.Uninstall="uninstall"})(T||(e.StatisticType=T={}));var I;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(I||(e.InstallOperation=I={})),e.IExtensionGalleryService=(0,R.createDecorator)("extensionGalleryService");var v;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Signature="Signature",h.Internal="Internal"})(v||(e.ExtensionManagementErrorCode=v={}));var i;(function(h){h.UnknownError="UnknownError",h.PackageIsInvalidZip="PackageIsInvalidZip",h.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(i||(e.ExtensionSignaturetErrorCode=i={}));class d extends Error{constructor(y,w){super(y),this.code=w,this.name=w}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,R.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,R.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,R.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,o.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,o.localize)(1,null),original:"Preferences"}}),define(Ce[209],ke([1,0,4]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,o.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,o.createDecorator)("externalTerminal")}),define(Ce[210],ke([1,0,47,17,15,14,110,29,117,177,209]),function(ae,e,o,R,l,L,A,P,D,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const k=p.localize(0,null);class E{async getDefaultTerminalForPlatforms(){return{windows:T.getDefaultTerminalWindows(),linux:await v.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class T extends E{openTerminal(w,g){return this.spawnTerminal(o,w,D.getWindowsShell(),g)}spawnTerminal(w,g,t,s){const r=g.windowsExec||T.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const a=l.basename(r,".exe").toLowerCase();if(a==="cmder")return w.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const b=["/c","start","/wait"];return r.indexOf(" ")>=0&&b.push('""'),b.push(r),a==="wt"&&b.push("-d ."),new Promise((S,c)=>{const u=i(process),m=w.spawn(t,b,{cwd:s,env:u});m.on("error",c),m.on("exit",()=>S())})}runInTerminal(w,g,t,s,r){const a="windowsExec"in r&&r.windowsExec?r.windowsExec:T.getDefaultTerminalWindows();return new Promise((b,S)=>{const c=`"${g} - ${k}"`,u=`""${t.join('" "')}" & pause"`,m=Object.assign({},i(process),s);Object.keys(m).filter(H=>m[H]===null).forEach(H=>delete m[H]);const f={cwd:g,env:m,windowsVerbatimArguments:!0};let n,C;l.basename(a,".exe")==="wt"?(n=a,C=["-d",".",T.b,"/c",u]):(n=T.b,C=["/c","start",c,"/wait",a,"/c",u]),o.spawn(n,C,f).on("error",H=>{S(d(H))}),b(void 0)})}static getDefaultTerminalWindows(){if(!T.d){const w=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");T.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${w?"Sysnative":"System32"}\\cmd.exe`}return T.d}}e.WindowsExternalTerminalService=T,T.b="cmd.exe";class I extends E{openTerminal(w,g){return this.spawnTerminal(o,w,g)}runInTerminal(w,g,t,s,r){const a=r.osxExec||O.DEFAULT_TERMINAL_OSX;return new Promise((b,S)=>{if(a===O.DEFAULT_TERMINAL_OSX||a==="iTerm.app"){const c=a===O.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",m=[R.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${c}.scpt`).fsPath,"-t",w||k,"-w",g];for(const C of t)m.push("-a"),m.push(C);if(s){const C=Object.assign({},i(process),s);for(const M in C){const H=C[M];H===null?(m.push("-u"),m.push(M)):(m.push("-e"),m.push(`${M}=${H}`))}}let f="";const n=o.spawn(I.b,m);n.on("error",C=>{S(d(C))}),n.stderr.on("data",C=>{f+=C.toString()}),n.on("exit",C=>{if(C===0)b(void 0);else if(f){const M=f.split(`
`,1);S(new Error(M[0]))}else S(new Error(p.localize(1,null,c,C)))})}else S(new Error(p.localize(2,null,a)))})}spawnTerminal(w,g,t){const s=g.osxExec||O.DEFAULT_TERMINAL_OSX;return new Promise((r,a)=>{const b=["-a",s];t&&b.push(t);const S=i(process),c=w.spawn("/usr/bin/open",b,{cwd:t,env:S});c.on("error",a),c.on("exit",()=>r())})}}e.MacExternalTerminalService=I,I.b="/usr/bin/osascript";class v extends E{openTerminal(w,g){return this.spawnTerminal(o,w,g)}runInTerminal(w,g,t,s,r){const a=r.linuxExec?Promise.resolve(r.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((b,S)=>{const c=[];a.then(u=>{u.indexOf("gnome-terminal")>=0?c.push("-x"):c.push("-e"),c.push("bash"),c.push("-c");const m=`${h(t)}; echo; read -p "${v.b}" -n1;`;c.push(`''${m}''`);const f=Object.assign({},i(process),s);Object.keys(f).filter(H=>f[H]===null).forEach(H=>delete f[H]);const n={cwd:g,env:f};let C="";const M=o.spawn(u,c,n);M.on("error",H=>{S(d(H))}),M.stderr.on("data",H=>{C+=H.toString()}),M.on("exit",H=>{if(H===0)b(void 0);else if(C){const V=C.split(`
`,1);S(new Error(V[0]))}else S(new Error(p.localize(4,null,u,H)))})})})}static async getDefaultTerminalLinuxReady(){if(!v.d)if(!L.isLinux)v.d=Promise.resolve("xterm");else{const w=await P.Promises.exists("/etc/debian_version");v.d=new Promise(g=>{w?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return v.d}spawnTerminal(w,g,t){const s=g.linuxExec?Promise.resolve(g.linuxExec):v.getDefaultTerminalLinuxReady();return new Promise((r,a)=>{s.then(b=>{const S=i(process),c=w.spawn(b,[],{cwd:t,env:S});c.on("error",a),c.on("exit",()=>r())})})}}e.LinuxExternalTerminalService=v,v.b=p.localize(3,null);function i(y){const w={...y.env};return(0,A.sanitizeProcessEnvironment)(w),w}function d(y){return"errno"in y&&y.errno==="ENOENT"&&"path"in y&&typeof y.path=="string"?new Error(p.localize(5,null,y.path)):y}function h(y){let w="";for(const g of y)g.indexOf(" ")>=0?w+='"'+g+'"':w+=g,w+=" ";return w}}),define(Ce[45],ke([1,0,69,15,9,10,2,178,4,14,17]),function(ae,e,o,R,l,L,A,P,D,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,D.createDecorator)("fileService");function k(Y){return Y.create===!0}e.isFileOpenForWriteOptions=k;var E;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(E||(e.FileType=E={}));var T;(function(Y){Y[Y.Readonly=1]="Readonly"})(T||(e.FilePermission=T={}));var I;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileClone=32768]="FileClone"})(I||(e.FileSystemProviderCapabilities=I={}));function v(Y){return!!(Y.capabilities&2)}e.hasReadWriteCapability=v;function i(Y){return!!(Y.capabilities&8)}e.hasFileFolderCopyCapability=i;function d(Y){return!!(Y.capabilities&32768)}e.hasFileCloneCapability=d;function h(Y){return!!(Y.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function y(Y){return!!(Y.capabilities&16)}e.hasFileReadStreamCapability=y;function w(Y){return v(Y)?!!(Y.capabilities&16384):!1}e.hasFileAtomicReadCapability=w;var g;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsStorageQuota="EntryExceedsStorageQuota",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(g||(e.FileSystemProviderErrorCode=g={}));class t extends Error{static create(_,Q){const ie=new t(_.toString(),Q);return a(ie,Q),ie}constructor(_,Q){super(_),this.code=Q}}e.FileSystemProviderError=t;function s(Y,_){return t.create(Y,_)}e.createFileSystemProviderError=s;function r(Y){return Y||s((0,P.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=r;function a(Y,_){return Y.name=_?`${_} (FileSystemError)`:"FileSystemError",Y}e.markAsFileSystemProviderError=a;function b(Y){if(!Y)return g.Unknown;if(Y instanceof t)return Y.code;const _=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!_)return g.Unknown;switch(_[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=b;function S(Y){if(Y instanceof C)return Y.fileOperationResult;switch(b(Y)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 9;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=S;var c;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(c||(e.FileOperation=c={}));class u{constructor(_,Q,ie){this.resource=_,this.operation=Q,this.target=ie}isOperation(_){return this.operation===_}}e.FileOperationEvent=u;var m;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(m||(e.FileChangeType=m={}));class f{constructor(_,Q){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ie=new Map;for(const oe of _){const Ee=ie.get(oe.type);switch(Ee?Ee.push([oe.resource,oe]):ie.set(oe.type,[[oe.resource,oe]]),oe.type){case 1:this.rawAdded.push(oe.resource);break;case 0:this.rawUpdated.push(oe.resource);break;case 2:this.rawDeleted.push(oe.resource);break}}for(const[oe,Ee]of ie)switch(oe){case 1:this.a=o.TernarySearchTree.forUris(()=>Q),this.a.fill(Ee);break;case 0:this.b=o.TernarySearchTree.forUris(()=>Q),this.b.fill(Ee);break;case 2:this.c=o.TernarySearchTree.forUris(()=>Q),this.c.fill(Ee);break}}contains(_,...Q){return this.d(_,{includeChildren:!1},...Q)}affects(_,...Q){return this.d(_,{includeChildren:!0},...Q)}d(_,Q,...ie){if(!_)return!1;const oe=ie.length>0;return!!((!oe||ie.includes(1))&&(this.a?.get(_)||Q.includeChildren&&this.a?.findSuperstr(_))||(!oe||ie.includes(0))&&(this.b?.get(_)||Q.includeChildren&&this.b?.findSuperstr(_))||(!oe||ie.includes(2))&&(this.c?.findSubstr(_)||Q.includeChildren&&this.c?.findSuperstr(_)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=f;function n(Y,_,Q){return!Y||!_||Y===_||_.length>Y.length?!1:(_.charAt(_.length-1)!==R.sep&&(_+=R.sep),Q?(0,l.startsWithIgnoreCase)(Y,_):Y.indexOf(_)===0)}e.isParent=n;class C extends Error{constructor(_,Q,ie){super(_),this.fileOperationResult=Q,this.options=ie}}e.FileOperationError=C;class M extends C{constructor(_,Q,ie,oe){super(_,Q,oe),this.fileOperationResult=Q,this.size=ie}}e.TooLargeFileOperationError=M;class H extends C{constructor(_,Q,ie){super(_,2,ie),this.stat=Q}}e.NotModifiedSinceFileOperationError=H;var V;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(V||(e.FileOperationResult=V={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var U;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})(U||(e.FileKind=U={})),e.ETAG_DISABLED="";function z(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}e.etag=z;async function G(Y,_){if(!_.hasProvider(A.URI.from({scheme:Y.scheme})))return new Promise(Q=>{const ie=_.onDidChangeFileSystemProviderRegistrations(oe=>{oe.scheme===Y.scheme&&oe.added&&(ie.dispose(),Q())})})}e.whenProviderRegistered=G;class F{static formatSize(_){return(0,L.isNumber)(_)||(_=0),_<F.KB?(0,P.localize)(1,null,_.toFixed(0)):_<F.MB?(0,P.localize)(2,null,(_/F.KB).toFixed(2)):_<F.GB?(0,P.localize)(3,null,(_/F.MB).toFixed(2)):_<F.TB?(0,P.localize)(4,null,(_/F.GB).toFixed(2)):(0,P.localize)(5,null,(_/F.TB).toFixed(2))}}e.ByteSize=F,F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB;function $(Y){const _=typeof Y=="string"||Y?.scheme===O.Schemas.vscodeRemote;return typeof Y!="string"&&Y?.scheme===O.Schemas.file?1024*F.MB:_?10*F.MB:p.isWeb?50*F.MB:1024*F.MB}e.getLargeFileConfirmationLimit=$}),define(Ce[92],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class o{constructor(...l){this.a=new Map;for(const[L,A]of l)this.set(L,A)}set(l,L){const A=this.a.get(l);return this.a.set(l,L),A}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=o}),define(Ce[211],ke([1,0,19,8,6,90,207,4,92,66]),function(ae,e,o,R,l,L,A,P,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class k extends Error{constructor(i){super("cyclic dependency between services"),this.message=i.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${i.toString()}`}}class E{constructor(i=new D.ServiceCollection,d=!1,h,y=O){this.f=i,this.g=d,this.h=h,this.i=y,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=y?h?._globalGraph??new A.Graph(w=>w):void 0}createChild(i){return new E(i,this.g,this,this.i)}invokeFunction(i,...d){const h=I.traceInvocation(this.i,i);let y=!1;try{return i({get:g=>{if(y)throw(0,R.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(g,h);if(!t)throw new Error(`[invokeFunction] unknown service '${g}'`);return t}},...d)}finally{y=!0,h.stop()}}createInstance(i,...d){let h,y;return i instanceof L.SyncDescriptor?(h=I.traceCreation(this.i,i.ctor),y=this.j(i.ctor,i.staticArguments.concat(d),h)):(h=I.traceCreation(this.i,i),y=this.j(i,d,h)),h.stop(),y}j(i,d=[],h){const y=P._util.getServiceDependencies(i).sort((t,s)=>t.index-s.index),w=[];for(const t of y){const s=this.m(t.id,h);s||this.u(`[createInstance] ${i.name} depends on UNKNOWN service ${t.id}.`,!1),w.push(s)}const g=y.length>0?y[0].index:d.length;if(d.length!==g){console.trace(`[createInstance] First service dependency of ${i.name} at position ${g+1} conflicts with ${d.length} static arguments`);const t=g-d.length;t>0?d=d.concat(new Array(t)):d=d.slice(0,g)}return Reflect.construct(i,d.concat(w))}k(i,d){if(this.f.get(i)instanceof L.SyncDescriptor)this.f.set(i,d);else if(this.h)this.h.k(i,d);else throw new Error("illegalState - setting UNKNOWN service instance")}l(i){const d=this.f.get(i);return!d&&this.h?this.h.l(i):d}m(i,d){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(i));const h=this.l(i);return h instanceof L.SyncDescriptor?this.q(i,h,d.branch(i,!0)):(d.branch(i,!1),h)}q(i,d,h){if(this.o.has(i))throw new Error(`illegal state - RECURSIVELY instantiating service '${i}'`);this.o.add(i);try{return this.r(i,d,h)}finally{this.o.delete(i)}}r(i,d,h){const y=new A.Graph(t=>t.id.toString());let w=0;const g=[{id:i,desc:d,_trace:h}];for(;g.length;){const t=g.pop();if(y.lookupOrInsertNode(t),w++>1e3)throw new k(y);for(const s of P._util.getServiceDependencies(t.desc.ctor)){const r=this.l(s.id);if(r||this.u(`[createInstance] ${i} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(s.id)),r instanceof L.SyncDescriptor){const a={id:s.id,desc:r,_trace:t._trace.branch(s.id,!0)};y.insertEdge(t,a),g.push(a)}}}for(;;){const t=y.roots();if(t.length===0){if(!y.isEmpty())throw new k(y);break}for(const{data:s}of t){if(this.l(s.id)instanceof L.SyncDescriptor){const a=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,a)}y.removeNode(s)}}return this.l(i)}s(i,d,h=[],y,w){if(this.f.get(i)instanceof L.SyncDescriptor)return this.t(i,d,h,y,w);if(this.h)return this.h.s(i,d,h,y,w);throw new Error(`illegalState - creating UNKNOWN service instance ${d.name}`)}t(i,d,h=[],y,w){if(y){const g=new E(void 0,this.g,this,this.i);g.c=String(i);const t=new Map,s=new o.IdleValue(()=>{const r=g.j(d,h,w);for(const[a,b]of t){const S=r[a];if(typeof S=="function")for(const c of b)S.apply(r,c)}return t.clear(),r});return new Proxy(Object.create(null),{get(r,a){if(!s.isInitialized&&typeof a=="string"&&(a.startsWith("onDid")||a.startsWith("onWill"))){let c=t.get(a);return c||(c=new p.LinkedList,t.set(a,c)),(m,f,n)=>{const C=c.push([m,f,n]);return(0,l.toDisposable)(C)}}if(a in r)return r[a];const b=s.value;let S=b[a];return typeof S!="function"||(S=S.bind(b),r[a]=S),S},set(r,a,b){return s.value[a]=b,!0},getPrototypeOf(r){return d.prototype}})}else return this.j(d,h,w)}u(i,d){if(d&&console.warn(i),this.g)throw new Error(i)}}e.InstantiationService=E;var T;(function(v){v[v.None=0]="None",v[v.Creation=1]="Creation",v[v.Invocation=2]="Invocation",v[v.Branch=3]="Branch"})(T||(T={}));class I{static traceInvocation(i,d){return i?new I(2,d.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):I.c}static traceCreation(i,d){return i?new I(1,d.name):I.c}constructor(i,d){this.type=i,this.name=d,this.g=Date.now(),this.h=[]}branch(i,d){const h=new I(3,i.toString());return this.h.push([i,d,h]),h}stop(){const i=Date.now()-this.g;I.f+=i;let d=!1;function h(w,g){const t=[],s=new Array(w+1).join("	");for(const[r,a,b]of g.h)if(a&&b){d=!0,t.push(`${s}CREATES -> ${r}`);const S=h(w+1,b);S&&t.push(S)}else t.push(`${s}uses -> ${r}`);return t.join(`
`)}const y=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${h(1,this)}`,`DONE, took ${i.toFixed(2)}ms (grand total ${I.f.toFixed(2)}ms)`];(i>2||d)&&I.all.add(y.join(`
`))}}e.Trace=I,I.all=new Set,I.c=new class extends I{constructor(){super(0,null)}stop(){}branch(){return this}},I.f=0}),define(Ce[16],ke([1,0,46,3,68,6,28,14,24,10,2,44,4]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,E.createDecorator)("logService"),e.ILoggerService=(0,E.createDecorator)("loggerService");function T(){return new Date().toISOString()}function I(m){return(0,p.isNumber)(m)}e.isLogLevel=I;var v;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(v||(e.LogLevel=v={})),e.DEFAULT_LOG_LEVEL=v.Info;function i(m,f,n){switch(f){case v.Trace:m.trace(n);break;case v.Debug:m.debug(n);break;case v.Info:m.info(n);break;case v.Warning:m.warn(n);break;case v.Error:m.error(n);break;case v.Off:break;default:throw new Error(`Invalid log level ${f}`)}}e.log=i;function d(m,f=!1){let n="";for(let C=0;C<m.length;C++){let M=m[C];if(M instanceof Error&&(M=(0,o.toErrorMessage)(M,f)),typeof M=="object")try{M=JSON.stringify(M)}catch{}n+=(C>0?" ":"")+M}return n}class h extends L.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new R.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(f){this.b!==f&&(this.b=f,this.c.fire(this.b))}getLevel(){return this.b}f(f){return this.b!==v.Off&&this.b<=f}}e.AbstractLogger=h;class y extends h{constructor(f){super(),this.h=f}f(f){return this.h||super.f(f)}trace(f,...n){this.f(v.Trace)&&this.g(v.Trace,d([f,...n],!0))}debug(f,...n){this.f(v.Debug)&&this.g(v.Debug,d([f,...n]))}info(f,...n){this.f(v.Info)&&this.g(v.Info,d([f,...n]))}warn(f,...n){this.f(v.Warning)&&this.g(v.Warning,d([f,...n]))}error(f,...n){if(this.f(v.Error))if(f instanceof Error){const C=Array.prototype.slice.call(arguments);C[0]=f.stack,this.g(v.Error,d(C))}else this.g(v.Error,d([f,...n]))}flush(){}}e.AbstractMessageLogger=y;class w extends h{constructor(f=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(f),this.g=!P.isWindows}trace(f,...n){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${T()}]\x1B[0m`,f,...n):console.log(`[main ${T()}]`,f,...n))}debug(f,...n){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${T()}]\x1B[0m`,f,...n):console.log(`[main ${T()}]`,f,...n))}info(f,...n){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${T()}]\x1B[0m`,f,...n):console.log(`[main ${T()}]`,f,...n))}warn(f,...n){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${T()}]\x1B[0m`,f,...n):console.warn(`[main ${T()}]`,f,...n))}error(f,...n){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${T()}]\x1B[0m`,f,...n):console.error(`[main ${T()}]`,f,...n))}dispose(){}flush(){}}e.ConsoleMainLogger=w;class g extends h{constructor(f=e.DEFAULT_LOG_LEVEL,n=!0){super(),this.g=n,this.setLevel(f)}trace(f,...n){this.f(v.Trace)&&(this.g?console.log("%cTRACE","color: #888",f,...n):console.log(f,...n))}debug(f,...n){this.f(v.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",f,...n):console.log(f,...n))}info(f,...n){this.f(v.Info)&&(this.g?console.log("%c INFO","color: #33f",f,...n):console.log(f,...n))}warn(f,...n){this.f(v.Warning)&&(this.g?console.log("%c WARN","color: #993",f,...n):console.log(f,...n))}error(f,...n){this.f(v.Error)&&(this.g?console.log("%c  ERR","color: #f33",f,...n):console.error(f,...n))}dispose(){}flush(){}}e.ConsoleLogger=g;class t extends h{constructor(f,n=e.DEFAULT_LOG_LEVEL){super(),this.g=f,this.setLevel(n)}trace(f,...n){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(f),...n])}debug(f,...n){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(f),...n])}info(f,...n){this.f(v.Info)&&this.g.log(v.Info,[this.h(f),...n])}warn(f,...n){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(f),...n])}error(f,...n){this.f(v.Error)&&this.g.log(v.Error,[this.h(f),...n])}h(f){return typeof f=="string"?f:(0,o.toErrorMessage)(f,this.f(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=t;class s extends h{constructor(f){super(),this.g=f,f.length&&this.setLevel(f[0].getLevel())}setLevel(f){for(const n of this.g)n.setLevel(f);super.setLevel(f)}trace(f,...n){for(const C of this.g)C.trace(f,...n)}debug(f,...n){for(const C of this.g)C.debug(f,...n)}info(f,...n){for(const C of this.g)C.info(f,...n)}warn(f,...n){for(const C of this.g)C.warn(f,...n)}error(f,...n){for(const C of this.g)C.error(f,...n)}flush(){for(const f of this.g)f.flush()}dispose(){for(const f of this.g)f.dispose()}}e.MultiplexLogger=s;class r extends L.Disposable{constructor(f,n,C){if(super(),this.h=f,this.j=n,this.b=new A.ResourceMap,this.c=this.B(new R.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new R.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new R.Emitter),this.onDidChangeVisibility=this.g.event,C)for(const M of C)this.b.set(M.resource,{logger:void 0,info:M})}k(f){return(0,p.isString)(f)?[...this.b.values()].find(n=>n.info.id===f):this.b.get(f)}getLogger(f){return this.k(f)?.logger}createLogger(f,n){const C=this.l(f),M=(0,p.isString)(f)?f:n?.id??(0,l.hash)(C.toString()).toString(16);let H=this.b.get(C)?.logger;const V=n?.logLevel==="always"?v.Trace:n?.logLevel;H||(H=this.m(C,V??this.getLogLevel(C)??this.h,{...n,id:M}));const U={logger:H,info:{resource:C,id:M,logLevel:V,name:n?.name,hidden:n?.hidden,extensionId:n?.extensionId,when:n?.when}};return this.registerLogger(U.info),this.b.set(C,U),H}l(f){return(0,p.isString)(f)?(0,D.joinPath)(this.j,`${f}.log`):f}setLogLevel(f,n){if(O.URI.isUri(f)){const C=f,M=n,H=this.b.get(C);H&&M!==H.info.logLevel&&(H.info.logLevel=M===this.h?void 0:M,H.logger?.setLevel(M),this.b.set(H.info.resource,H),this.f.fire([C,M]))}else{this.h=f;for(const[C,M]of this.b.entries())this.b.get(C)?.info.logLevel===void 0&&M.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(f,n){const C=this.k(f);C&&n!==!C.info.hidden&&(C.info.hidden=!n,this.b.set(C.info.resource,C),this.g.fire([C.info.resource,n]))}getLogLevel(f){let n;return f&&(n=this.b.get(f)?.info.logLevel),n??this.h}registerLogger(f){const n=this.b.get(f.resource);n?n.info.hidden!==f.hidden&&this.setVisibility(f.resource,!f.hidden):(this.b.set(f.resource,{info:f,logger:void 0}),this.c.fire({added:[f],removed:[]}))}deregisterLogger(f){const n=this.b.get(f);n&&(n.logger&&n.logger.dispose(),this.b.delete(f),this.c.fire({added:[],removed:[n.info]}))}*getRegisteredLoggers(){for(const f of this.b.values())yield f.info}getRegisteredLogger(f){return this.b.get(f)?.info}dispose(){this.b.forEach(f=>f.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=r;class a{constructor(){this.onDidChangeLogLevel=new R.Emitter().event}setLevel(f){}getLevel(){return v.Info}trace(f,...n){}debug(f,...n){}info(f,...n){}warn(f,...n){}error(f,...n){}critical(f,...n){}dispose(){}flush(){}}e.NullLogger=a;class b extends a{}e.NullLogService=b;function S(m){if(m.verbose)return v.Trace;if(typeof m.logLevel=="string"){const f=u(m.logLevel.toLowerCase());if(f!==void 0)return f}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=S;function c(m){switch(m){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=c;function u(m){switch(m){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=u,e.CONTEXT_LOG_LEVEL=new k.RawContextKey("logLevel",c(v.Info))}),define(Ce[212],ke([1,0,6,16]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends o.Disposable{constructor(A,P=[]){super(),this.a=new R.MultiplexLogger([A,...P]),this.B(A.onDidChangeLogLevel(D=>this.setLevel(D)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...P){this.a.trace(A,...P)}debug(A,...P){this.a.debug(A,...P)}info(A,...P){this.a.info(A,...P)}warn(A,...P){this.a.warn(A,...P)}error(A,...P){this.a.error(A,...P)}flush(){this.a.flush()}}e.LogService=l}),define(Ce[213],ke([1,0,45,16]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var l;(function(p){p[p.Trace=0]="Trace",p[p.Debug=1]="Debug",p[p.Info=2]="Info",p[p.Warning=3]="Warning",p[p.Error=4]="Error",p[p.Critical=5]="Critical",p[p.Off=6]="Off"})(l||(l={}));async function L(p,O,k,E,T){try{const I=await new Promise((i,d)=>{ae(["@vscode/spdlog"],i,d)});I.setFlushOn(l.Trace);const v=await I.createAsyncRotatingLogger(p,O,k,E);return T?v.clearFormatters():v.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),v}catch(I){console.error(I)}return null}function A(p,O,k){switch(O){case R.LogLevel.Trace:p.trace(k);break;case R.LogLevel.Debug:p.debug(k);break;case R.LogLevel.Info:p.info(k);break;case R.LogLevel.Warning:p.warn(k);break;case R.LogLevel.Error:p.error(k);break;case R.LogLevel.Off:break;default:throw new Error(`Invalid log level ${O}`)}}function P(p,O){switch(O){case R.LogLevel.Trace:p.setLevel(l.Trace);break;case R.LogLevel.Debug:p.setLevel(l.Debug);break;case R.LogLevel.Info:p.setLevel(l.Info);break;case R.LogLevel.Warning:p.setLevel(l.Warning);break;case R.LogLevel.Error:p.setLevel(l.Error);break;case R.LogLevel.Off:p.setLevel(l.Off);break;default:throw new Error(`Invalid log level ${O}`)}}class D extends R.AbstractMessageLogger{constructor(O,k,E,T,I){super(),this.k=[],this.setLevel(I),this.l=this.n(O,k,E,T),this.B(this.onDidChangeLogLevel(v=>{this.m&&P(this.m,v)}))}async n(O,k,E,T){const I=E?6:1,v=30/I*o.ByteSize.MB,i=await L(O,k,v,I,T);if(i){this.m=i,P(this.m,this.getLevel());for(const{level:d,message:h}of this.k)A(this.m,d,h);this.k=[]}}g(O,k){this.m?A(this.m,O,k):this.getLevel()<=O&&this.k.push({level:O,message:k})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=D}),define(Ce[123],ke([1,0,38,179,4]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(D){D[D.Unnecessary=1]="Unnecessary",D[D.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var A;(function(D){D[D.Hint=1]="Hint",D[D.Info=2]="Info",D[D.Warning=4]="Warning",D[D.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(D){function p(I,v){return v-I}D.compare=p;const O=Object.create(null);O[D.Error]=(0,R.localize)(0,null),O[D.Warning]=(0,R.localize)(1,null),O[D.Info]=(0,R.localize)(2,null);function k(I){return O[I]||""}D.toString=k;function E(I){switch(I){case o.default.Error:return D.Error;case o.default.Warning:return D.Warning;case o.default.Info:return D.Info;case o.default.Ignore:return D.Hint}}D.fromSeverity=E;function T(I){switch(I){case D.Error:return o.default.Error;case D.Warning:return o.default.Warning;case D.Info:return o.default.Info;case D.Hint:return o.default.Ignore}}D.toSeverity=T}(A||(e.MarkerSeverity=A={}));var P;(function(D){const p="";function O(E){return k(E,!0)}D.makeKey=O;function k(E,T){const I=[p];return E.source?I.push(E.source.replace("\xA6","\\\xA6")):I.push(p),E.code?typeof E.code=="string"?I.push(E.code.replace("\xA6","\\\xA6")):I.push(E.code.value.replace("\xA6","\\\xA6")):I.push(p),E.severity!==void 0&&E.severity!==null?I.push(A.toString(E.severity)):I.push(p),E.message&&T?I.push(E.message.replace("\xA6","\\\xA6")):I.push(p),E.startLineNumber!==void 0&&E.startLineNumber!==null?I.push(E.startLineNumber.toString()):I.push(p),E.startColumn!==void 0&&E.startColumn!==null?I.push(E.startColumn.toString()):I.push(p),E.endLineNumber!==void 0&&E.endLineNumber!==null?I.push(E.endLineNumber.toString()):I.push(p),E.endColumn!==void 0&&E.endColumn!==null?I.push(E.endColumn.toString()):I.push(p),I.push(p),I.join("\xA6")}D.makeKeyOptionalMessage=k})(P||(e.IMarkerData=P={})),e.IMarkerService=(0,l.createDecorator)("markerService")}),define(Ce[214],ke([1,0,3,38,4]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=R.default,e.INotificationService=(0,l.createDecorator)("notificationService");var L;(function(O){O[O.DEFAULT=0]="DEFAULT",O[O.SILENT=1]="SILENT",O[O.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var A;(function(O){O[O.WORKSPACE=0]="WORKSPACE",O[O.PROFILE=1]="PROFILE",O[O.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));var P;(function(O){O[O.OFF=0]="OFF",O[O.SILENT=1]="SILENT",O[O.ERROR=2]="ERROR"})(P||(e.NotificationsFilter=P={}));class D{constructor(){this.progress=new p,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(k){}updateMessage(k){}updateActions(k){}close(){}}e.NoOpNotification=D;class p{infinite(){}done(){}total(k){}worked(k){}}e.NoOpProgress=p}),define(Ce[124],ke([1,0,9,2,4]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,l.createDecorator)("openerService");function L(p,O){return R.URI.isUri(p)?(0,o.equalsIgnoreCase)(p.scheme,O):(0,o.startsWithIgnoreCase)(p,O+":")}e.matchesScheme=L;function A(p,...O){return O.some(k=>L(p,k))}e.matchesSomeScheme=A;function P(p,O){return p.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=P;function D(p){let O;const k=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(p.fragment);return k&&(O={startLineNumber:parseInt(k[1]),startColumn:k[2]?parseInt(k[2]):1,endLineNumber:k[4]?parseInt(k[4]):void 0,endColumn:k[4]?k[5]?parseInt(k[5]):1:void 0},p=p.with({fragment:""})),{selection:O,uri:p}}e.extractSelection=D}),define(Ce[215],ke([1,0,14,36]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof o.globals.vscode<"u"&&typeof o.globals.vscode.context<"u"){const L=o.globals.vscode.context.configuration();if(L)l=L.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,R.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const L=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:L.version})}}else l={},Object.keys(l).length===0&&Object.assign(l,{version:"1.78.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",serverLicenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(Ce[216],ke([1,0,4]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,o.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var We=this&&this.__param||function(ae,e){return function(o,R){e(o,R,ae)}};define(Ce[125],ke([1,0,19,21,6,4]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var A;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class P{get value(){return this.a}constructor(k){this.b=k}report(k){this.a=k,this.b(this.a)}}e.Progress=P,P.None=Object.freeze({report(){}});let D=e.UnmanagedProgress=class extends l.Disposable{constructor(k,E){super(),this.a=new o.DeferredPromise,E.withProgress(k,T=>(this.b=T,this.c&&T.report(this.c),this.a.p)),this.B((0,l.toDisposable)(()=>this.a.complete()))}report(k){this.b?this.b.report(k):this.c=k}};e.UnmanagedProgress=D=xe([We(1,e.IProgressService)],D);class p extends l.Disposable{constructor(k){super(),this.g=k,this.a=0,this.b=this.B(new l.DisposableStore)}start(k){this.stop();const E=++this.a,T=new R.CancellationTokenSource;return this.f=setTimeout(()=>{E===this.a&&(this.c=this.g.show(!0))},k),this.b.add((0,l.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,l.toDisposable)(()=>T.cancel())),this.b.add((0,l.toDisposable)(()=>this.c?this.c.done():void 0)),{id:E,token:T.token,stop:()=>this.h(E),isCurrent:()=>this.a===E}}stop(){this.h(this.a)}h(k){this.a===k&&this.b.clear()}}e.LongRunningOperation=p,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(Ce[40],ke([1,0,51,10]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(A,P){o.ok(R.isString(A)),o.ok(R.isObject(P)),o.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,P)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.Registry=new l}),define(Ce[93],ke([1,0,3,40]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this.b=new o.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(D,p){this.a[l(D)]=p,this.b.fire(D)}notifySchemaChanged(D){this.b.fire(D)}getSchemaContributions(){return{schemas:this.a}}}const A=new L;R.Registry.add(e.Extensions.JSONContribution,A)}),define(Ce[126],ke([1,0,18,3,10,172,55,93,40]),function(ae,e,o,R,l,L,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var p;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(p||(e.EditPresentationTypes=p={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O||(e.ConfigurationScope=O={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const k=D.Registry.as(P.Extensions.JSONContribution);class E{constructor(){this.h=new Set,this.i=new R.Emitter,this.onDidSchemaChange=this.i.event,this.j=new R.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,s=!0){this.registerConfigurations([t],s)}registerConfigurations(t,s=!0){const r=new Set;this.n(t,s,r),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(t){const s=new Set;this.o(t,s),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:t,remove:s}){const r=new Set;this.o(s,r),this.n(t,!1,r),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(t){const s=new Set;this.k(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(t,s){const r=[];for(const{overrides:a,source:b}of t)for(const S in a)if(s.add(S),e.OVERRIDE_PROPERTY_REGEX.test(S)){const c=this.a.get(S),u=c?.valuesSources??new Map;if(b)for(const C of Object.keys(a[S]))u.set(C,b);const m={...c?.value||{},...a[S]};this.a.set(S,{source:b,value:m,valuesSources:u});const f=(0,A.getLanguageTagSettingPlainKey)(S),n={type:"object",default:m,description:L.localize(1,null,f),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:l.isString(b)?void 0:b,defaultValueSource:b};r.push(...v(S)),this.d[S]=n,this.b.properties[S]=n}else{this.a.set(S,{value:a[S],source:b});const c=this.d[S];c&&(this.w(S,c),this.r(S,c))}this.m(r)}deregisterDefaultConfigurations(t){const s=new Set;this.l(t,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(t,s){for(const{overrides:r,source:a}of t)for(const b in r){const S=this.a.get(b),c=l.isString(a)?a:a?.id,u=l.isString(S?.source)?S?.source:S?.source?.id;if(c===u)if(s.add(b),this.a.delete(b),e.OVERRIDE_PROPERTY_REGEX.test(b))delete this.d[b],delete this.b.properties[b];else{const m=this.d[b];m&&(this.w(b,m),this.r(b,m))}}this.u()}deltaConfiguration(t){let s=!1;const r=new Set;t.removedDefaults&&(this.l(t.removedDefaults,r),s=!0),t.addedDefaults&&(this.k(t.addedDefaults,r),s=!0),t.removedConfigurations&&this.o(t.removedConfigurations,r),t.addedConfigurations&&this.n(t.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const s of t)this.h.add(s);this.u()}n(t,s,r){t.forEach(a=>{this.p(a,s,a.extensionInfo,a.restrictedProperties,void 0,r),this.c.push(a),this.q(a)})}o(t,s){const r=a=>{if(a.properties)for(const b in a.properties){s.add(b);const S=this.d[b];S?.policy?.name&&this.e.delete(S.policy.name),delete this.d[b],this.s(b,a.properties[b])}a.allOf?.forEach(b=>r(b))};for(const a of t){r(a);const b=this.c.indexOf(a);b!==-1&&this.c.splice(b,1)}}p(t,s=!0,r,a,b=3,S){b=l.isUndefinedOrNull(t.scope)?b:t.scope;const c=t.properties;if(c)for(const m in c){const f=c[m];if(s&&y(m,f)){delete c[m];continue}if(f.source=r,f.defaultDefaultValue=c[m].default,this.w(m,f),e.OVERRIDE_PROPERTY_REGEX.test(m)?f.scope=void 0:(f.scope=l.isUndefinedOrNull(f.scope)?b:f.scope,f.restricted=l.isUndefinedOrNull(f.restricted)?!!a?.includes(m):f.restricted),c[m].hasOwnProperty("included")&&!c[m].included){this.f[m]=c[m],delete c[m];continue}else this.d[m]=c[m],c[m].policy?.name&&this.e.set(c[m].policy.name,m);!c[m].deprecationMessage&&c[m].markdownDeprecationMessage&&(c[m].deprecationMessage=c[m].markdownDeprecationMessage),S.add(m)}const u=t.allOf;if(u)for(const m of u)this.p(m,s,r,a,b,S)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const s=r=>{const a=r.properties;if(a)for(const S in a)this.r(S,a[S]);r.allOf?.forEach(s)};s(t)}r(t,s){switch(e.allSettings.properties[t]=s,s.scope){case 1:e.applicationSettings.properties[t]=s;break;case 2:e.machineSettings.properties[t]=s;break;case 6:e.machineOverridableSettings.properties[t]=s;break;case 3:e.windowSettings.properties[t]=s;break;case 4:e.resourceSettings.properties[t]=s;break;case 5:e.resourceSettings.properties[t]=s,this.g.properties[t]=s;break}}s(t,s){switch(delete e.allSettings.properties[t],s.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const s=`[${t}]`,r={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,r),e.allSettings.properties[s]=r,e.applicationSettings.properties[s]=r,e.machineSettings.properties[s]=r,e.machineOverridableSettings.properties[s]=r,e.windowSettings.properties[s]=r,e.resourceSettings.properties[s]=r}}v(){const t={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,s){const r=this.a.get(t);let a=r?.value,b=r?.source;l.isUndefined(a)&&(a=s.defaultDefaultValue,b=void 0),l.isUndefined(a)&&(a=d(s.type)),s.default=a,s.defaultValueSource=b}}const T="\\[([^\\]]+)\\]",I=new RegExp(T,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${T})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function v(g){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let s=I.exec(g);for(;s?.length;){const r=s[1].trim();r&&t.push(r),s=I.exec(g)}}return(0,o.distinct)(t)}e.overrideIdentifiersFromKey=v;function i(g){return g.reduce((t,s)=>`${t}[${s}]`,"")}e.keyFromOverrideIdentifiers=i;function d(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const h=new E;D.Registry.add(e.Extensions.Configuration,h);function y(g,t){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?L.localize(7,null,g):h.getConfigurationProperties()[g]!==void 0?L.localize(8,null,g):t.policy?.name&&h.getPolicyConfigurations().get(t.policy?.name)!==void 0?L.localize(9,null,g,t.policy?.name,h.getPolicyConfigurations().get(t.policy?.name)):null:L.localize(6,null)}e.validateProperty=y;function w(){const g=[],t=h.getConfigurationProperties();for(const s of Object.keys(t))g.push([s,t[s].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=w}),define(Ce[217],ke([1,0,18,3,148,6,28,23,10,2,55,126,40]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function T(s){return Object.isFrozen(s)?s:P.deepFreeze(s)}class I{constructor(r={},a=[],b=[],S){this.b=r,this.c=a,this.d=b,this.raw=S,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(a=>{if(a instanceof I)return a;const b=new v("");return b.parseRaw(a),b.configurationModel});this.f=r.reduce((a,b)=>b===a?b:a.merge(b),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,O.getConfigurationValue)(this.contents,r):this.contents}inspect(r,a){const b=this.rawConfiguration.getValue(r),S=a?this.rawConfiguration.getOverrideValue(r,a):void 0,c=a?this.rawConfiguration.override(a).getValue(r):b;return{value:b,override:S,merged:c}}getOverrideValue(r,a){const b=this.i(a);return b?r?(0,O.getConfigurationValue)(b,r):b:void 0}getKeysForOverrideIdentifier(r){const a=[];for(const b of this.overrides)b.identifiers.includes(r)&&a.push(...b.keys);return o.distinct(a)}getAllOverrideIdentifiers(){const r=[];for(const a of this.overrides)r.push(...a.identifiers);return o.distinct(r)}override(r){let a=this.a.get(r);return a||(a=this.g(r),this.a.set(r,a)),a}merge(...r){const a=P.deepClone(this.contents),b=P.deepClone(this.overrides),S=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const u of r)if(c.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.h(a,u.contents);for(const m of u.overrides){const[f]=b.filter(n=>o.equals(n.identifiers,m.identifiers));f?(this.h(f.contents,m.contents),f.keys.push(...m.keys),f.keys=o.distinct(f.keys)):b.push(P.deepClone(m))}for(const m of u.keys)S.indexOf(m)===-1&&S.push(m)}return new I(a,S,b,c.every(u=>u instanceof I)?void 0:c)}g(r){const a=this.i(r);if(!a||typeof a!="object"||!Object.keys(a).length)return this;const b={};for(const S of o.distinct([...Object.keys(this.contents),...Object.keys(a)])){let c=this.contents[S];const u=a[S];u&&(typeof c=="object"&&typeof u=="object"?(c=P.deepClone(c),this.h(c,u)):c=u),b[S]=c}return new I(b,this.keys,this.overrides)}h(r,a){for(const b of Object.keys(a)){if(b in r&&D.isObject(r[b])&&D.isObject(a[b])){this.h(r[b],a[b]);continue}r[b]=P.deepClone(a[b])}}i(r){let a=null,b=null;const S=c=>{c&&(b?this.h(b,c):b=P.deepClone(c))};for(const c of this.overrides)o.equals(c.identifiers,[r])?a=c.contents:c.identifiers.includes(r)&&S(c.contents);return S(a),b}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,a){this.j(r,a,!0)}setValue(r,a){this.j(r,a,!1)}removeValue(r){const a=this.keys.indexOf(r);a!==-1&&(this.keys.splice(a,1),(0,O.removeFromValueTree)(this.contents,r),k.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(b=>o.equals(b.identifiers,(0,k.overrideIdentifiersFromKey)(r))),1))}j(r,a,b){(0,O.addToValueTree)(this.contents,r,a,S=>console.error(S)),b=b||this.keys.indexOf(r)===-1,b&&this.keys.push(r),k.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,k.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,O.toValuesTree)(this.contents[r],S=>console.error(S))})}}e.ConfigurationModel=I;class v{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new I}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,a){if(!D.isUndefinedOrNull(r)){const b=this.g(r);this.parseRaw(b,a)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,a){this.a=r;const{contents:b,keys:S,overrides:c,restricted:u,hasExcludedProperties:m}=this.h(r,a);this.b=new I(b,S,c,m?[r]:void 0),this.c=u||[]}g(r){let a={},b=null,S=[];const c=[],u=[];function m(n){Array.isArray(S)?S.push(n):b!==null&&(S[b]=n)}const f={onObjectBegin:()=>{const n={};m(n),c.push(S),S=n,b=null},onObjectProperty:n=>{b=n},onObjectEnd:()=>{S=c.pop()},onArrayBegin:()=>{const n=[];m(n),c.push(S),S=n,b=null},onArrayEnd:()=>{S=c.pop()},onLiteralValue:m,onError:(n,C,M)=>{u.push({error:n,offset:C,length:M})}};if(r)try{l.visit(r,f),a=S[0]||{}}catch(n){console.error(`Error while parsing settings file ${this.f}: ${n}`),this.d=[n]}return a}h(r,a){const b=E.Registry.as(k.Extensions.Configuration).getConfigurationProperties(),S=this.i(r,b,!0,a);r=S.raw;const c=(0,O.toValuesTree)(r,f=>console.error(`Conflict in settings file ${this.f}: ${f}`)),u=Object.keys(r),m=this.j(r,f=>console.error(`Conflict in settings file ${this.f}: ${f}`));return{contents:c,keys:u,overrides:m,restricted:S.restricted,hasExcludedProperties:S.hasExcludedProperties}}i(r,a,b,S){let c=!1;if(!S?.scopes&&!S?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const u={},m=[];for(const f in r)if(k.OVERRIDE_PROPERTY_REGEX.test(f)&&b){const n=this.i(r[f],a,!1,S);u[f]=n.raw,c=c||n.hasExcludedProperties,m.push(...n.restricted)}else{const n=a[f],C=n?typeof n.scope<"u"?n.scope:3:void 0;n?.restricted&&m.push(f),(C===void 0||S.scopes===void 0||S.scopes.includes(C))&&!(S.skipRestricted&&n?.restricted)?u[f]=r[f]:c=!0}return{raw:u,restricted:m,hasExcludedProperties:c}}j(r,a){const b=[];for(const S of Object.keys(r))if(k.OVERRIDE_PROPERTY_REGEX.test(S)){const c={};for(const u in r[S])c[u]=r[S][u];b.push({identifiers:(0,k.overrideIdentifiersFromKey)(S),keys:Object.keys(c),contents:(0,O.toValuesTree)(c,a)})}return b}}e.ConfigurationModelParser=v;class i extends L.Disposable{constructor(r,a,b,S){super(),this.f=r,this.g=a,this.h=S,this.c=this.B(new R.Emitter),this.onDidChange=this.c.event,this.a=new v(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(b.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(R.Event.any(R.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),R.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&b.isEqual(c.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new I}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=i;class d{constructor(r,a,b,S,c,u,m,f,n,C,M,H,V){this.a=r,this.b=a,this.c=b,this.overrideIdentifiers=S,this.d=c,this.f=u,this.g=m,this.h=f,this.i=n,this.j=C,this.k=M,this.l=H,this.m=V}get value(){return T(this.c)}n(r,a,b){const S=r.inspect(a,b);return{get value(){return T(S.value)},get override(){return T(S.override)},get merged(){return T(S.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class h{constructor(r,a,b,S,c=new I,u=new I,m=new A.ResourceMap,f=new I,n=new A.ResourceMap){this.c=r,this.d=a,this.f=b,this.g=S,this.h=c,this.i=u,this.j=m,this.l=f,this.m=n,this.a=null,this.b=new A.ResourceMap,this.n=null}getValue(r,a,b){return this.q(r,a,b).getValue(r)}updateValue(r,a,b={}){let S;b.resource?(S=this.m.get(b.resource),S||(S=new I,this.m.set(b.resource,S))):S=this.l,a===void 0?S.removeValue(r):S.setValue(r,a),b.resource||(this.a=null)}inspect(r,a,b){const S=this.q(r,a,b),c=this.u(a.resource,b),u=a.resource?this.m.get(a.resource)||this.l:this.l,m=new Set;for(const f of S.overrides)for(const n of f.identifiers)S.getOverrideValue(r,n)!==void 0&&m.add(n);return new d(r,a,S.getValue(r),m.size?[...m]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,b?this.i:void 0,c||void 0,u)}keys(r){const a=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:a?a.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,a){this.j.set(r,a),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,a){const b=[];if(!a){const{added:S,updated:c,removed:u}=g(this.c,r);a=[...S,...c,...u]}for(const S of a)for(const c of(0,k.overrideIdentifiersFromKey)(S)){const u=this.c.getKeysForOverrideIdentifier(c),m=r.getKeysForOverrideIdentifier(c),f=[...m.filter(n=>u.indexOf(n)===-1),...u.filter(n=>m.indexOf(n)===-1),...u.filter(n=>!P.equals(this.c.override(c).getValue(n),r.override(c).getValue(n)))];b.push([c,f])}return this.updateDefaultConfiguration(r),{keys:a,overrides:b}}compareAndUpdatePolicyConfiguration(r){const{added:a,updated:b,removed:S}=g(this.d,r),c=[...a,...b,...S];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:a,updated:b,removed:S,overrides:c}=g(this.applicationConfiguration,r),u=[...a,...b,...S];return u.length&&this.updateApplicationConfiguration(r),{keys:u,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:a,updated:b,removed:S,overrides:c}=g(this.localUserConfiguration,r),u=[...a,...b,...S];return u.length&&this.updateLocalUserConfiguration(r),{keys:u,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:a,updated:b,removed:S,overrides:c}=g(this.remoteUserConfiguration,r),u=[...a,...b,...S];return u.length&&this.updateRemoteUserConfiguration(r),{keys:u,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:a,updated:b,removed:S,overrides:c}=g(this.workspaceConfiguration,r),u=[...a,...b,...S];return u.length&&this.updateWorkspaceConfiguration(r),{keys:u,overrides:c}}compareAndUpdateFolderConfiguration(r,a){const b=this.p.get(r),{added:S,updated:c,removed:u,overrides:m}=g(b,a),f=[...S,...c,...u];return(f.length||!b)&&this.updateFolderConfiguration(r,a),{keys:f,overrides:m}}compareAndDeleteFolderConfiguration(r){const a=this.p.get(r);if(!a)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:b,updated:S,removed:c,overrides:u}=g(a,void 0);return{keys:[...b,...S,...c],overrides:u}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,a,b){let S=this.r(a,b);return a.overrideIdentifier&&(S=S.override(a.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(S=S.merge(this.d)),S}r({resource:r},a){let b=this.s();if(a&&r){const S=a.getFolder(r);S&&(b=this.t(S.uri)||b);const c=this.m.get(r);c&&(b=b.merge(c))}return b}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let a=this.b.get(r);if(!a){const b=this.s(),S=this.j.get(r);S?(a=b.merge(S),this.b.set(r,a)):a=b}return a}u(r,a){if(a&&r){const b=a.getFolder(r);if(b)return this.j.get(b.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,a)=>{const{contents:b,overrides:S,keys:c}=this.j.get(a);return r.push([a,{contents:b,overrides:S,keys:c}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(a=>r.add(a)),this.userConfiguration.keys.forEach(a=>r.add(a)),this.i.keys.forEach(a=>r.add(a)),this.j.forEach(a=>a.keys.forEach(b=>r.add(b))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.userConfiguration.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.i.getAllOverrideIdentifiers().forEach(a=>r.add(a)),this.j.forEach(a=>a.getAllOverrideIdentifiers().forEach(b=>r.add(b))),[...r.values()]}w(r){const a=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(b=>a.add(b)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(b=>a.add(b)),this.i.getKeysForOverrideIdentifier(r).forEach(b=>a.add(b)),this.j.forEach(b=>b.getKeysForOverrideIdentifier(r).forEach(S=>a.add(S))),[...a.values()]}static parse(r){const a=this.x(r.defaults),b=this.x(r.policy),S=this.x(r.application),c=this.x(r.user),u=this.x(r.workspace),m=r.folders.reduce((f,n)=>(f.set(p.URI.revive(n[0]),this.x(n[1])),f),new A.ResourceMap);return new h(a,b,S,c,new I,u,m,new I,new A.ResourceMap)}static x(r){return new I(r.contents,r.keys,r.overrides)}}e.Configuration=h;function y(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,a=new Map;for(const S of s)S.keys.forEach(c=>r.add(c)),S.overrides.forEach(([c,u])=>{const m=(0,A.getOrSet)(a,c,new Set);u.forEach(f=>m.add(f))});const b=[];return a.forEach((S,c)=>b.push([c,[...S.values()]])),{keys:[...r.values()],overrides:b}}e.mergeChanges=y;class w{constructor(r,a,b,S){this.change=r,this.f=a,this.g=b,this.h=S,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of r.keys)this.affectedKeys.add(c);for(const[,c]of r.overrides)for(const u of c)this.affectedKeys.add(u);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=h.parse(this.f.data)),this.i}affectsConfiguration(r,a){const b=this.a+r,S=this.d.indexOf(b);if(S<0)return!1;const c=S+b.length;if(c>=this.d.length)return!1;const u=this.d.charCodeAt(c);if(u!==this.b&&u!==this.c)return!1;if(a){const m=this.previousConfiguration?this.previousConfiguration.getValue(r,a,this.f?.workspace):void 0,f=this.g.getValue(r,a,this.h);return!P.equals(m,f)}return!0}}e.ConfigurationChangeEvent=w;function g(s,r){const{added:a,removed:b,updated:S}=t(r?.rawConfiguration,s?.rawConfiguration),c=[],u=s?.getAllOverrideIdentifiers()||[],m=r?.getAllOverrideIdentifiers()||[];if(r){const f=m.filter(n=>!u.includes(n));for(const n of f)c.push([n,r.getKeysForOverrideIdentifier(n)])}if(s){const f=u.filter(n=>!m.includes(n));for(const n of f)c.push([n,s.getKeysForOverrideIdentifier(n)])}if(r&&s){for(const f of u)if(m.includes(f)){const n=t({contents:s.getOverrideValue(void 0,f)||{},keys:s.getKeysForOverrideIdentifier(f)},{contents:r.getOverrideValue(void 0,f)||{},keys:r.getKeysForOverrideIdentifier(f)});c.push([f,[...n.added,...n.removed,...n.updated]])}}return{added:a,removed:b,updated:S,overrides:c}}function t(s,r){const a=s?r?s.keys.filter(c=>r.keys.indexOf(c)===-1):[...s.keys]:[],b=r?s?r.keys.filter(c=>s.keys.indexOf(c)===-1):[...r.keys]:[],S=[];if(s&&r){for(const c of r.keys)if(s.keys.indexOf(c)!==-1){const u=(0,O.getConfigurationValue)(r.contents,c),m=(0,O.getConfigurationValue)(s.contents,c);P.equals(u,m)||S.push(c)}}return{added:a,removed:b,updated:S}}}),define(Ce[127],ke([1,0,8,4]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,R.createDecorator)("remoteAuthorityResolverService");var l;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(l||(e.RemoteAuthorityResolverErrorCode=l={}));class L extends o.ErrorNoTelemetry{static isNotAvailable(D){return D instanceof L&&D._code===l.NotAvailable}static isTemporarilyNotAvailable(D){return D instanceof L&&D._code===l.TemporarilyNotAvailable}static isNoResolverFound(D){return D instanceof L&&D._code===l.NoResolverFound}static isHandled(D){return D instanceof L&&D.isHandled}constructor(D,p=l.Unknown,O){super(D),this._message=D,this._code=p,this._detail=O,this.isHandled=p===l.NotAvailable&&O===!0,Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L;function A(P){const D=P.indexOf("+");return D===-1?P:P.substring(0,D)}e.getRemoteAuthorityPrefix=A}),define(Ce[74],ke([1,0,17]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function R(p){return p.scheme===o.Schemas.vscodeRemote?p.authority:void 0}e.getRemoteAuthority=R;function l(p){if(!p)return;const O=p.indexOf("+");return O<0?p:p.substr(0,O)}e.getRemoteName=l;function L(p){return`/${p.quality??"oss"}-${p.commit??"dev"}`}e.getRemoteServerRootPath=L;function A(p){const{host:O,port:k}=D(p);if(typeof k>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:k}}e.parseAuthorityWithPort=A;function P(p,O){let{host:k,port:E}=D(p);return typeof E>"u"&&(E=O),{host:k,port:E}}e.parseAuthorityWithOptionalPort=P;function D(p){const O=p.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const k=p.match(/^(\[[0-9a-z:]+\])$/);if(k)return{host:k[1],port:void 0};const E=p.match(/(.*):(\d+)$/);return E?{host:E[1],port:parseInt(E[2],10)}:{host:p,port:void 0}}}),define(Ce[25],ke([1,0,9,4,74]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(v){if(typeof v=="object"&&v!==null&&v.supported!==!0)return v.description}e.getWorkspaceSupportTypeMessage=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var A;(function(v){v[v.System=0]="System",v[v.User=1]="User"})(A||(e.ExtensionType=A={}));var P;(function(v){v.WIN32_X64="win32-x64",v.WIN32_IA32="win32-ia32",v.WIN32_ARM64="win32-arm64",v.LINUX_X64="linux-x64",v.LINUX_ARM64="linux-arm64",v.LINUX_ARMHF="linux-armhf",v.ALPINE_X64="alpine-x64",v.ALPINE_ARM64="alpine-arm64",v.DARWIN_X64="darwin-x64",v.DARWIN_ARM64="darwin-arm64",v.WEB="web",v.UNIVERSAL="universal",v.UNKNOWN="unknown",v.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class D{constructor(i){this.value=i,this.c=i.toLowerCase()}static equals(i,d){if(typeof i>"u"||i===null)return typeof d>"u"||d===null;if(typeof d>"u"||d===null)return!1;if(typeof i=="string"||typeof d=="string"){const h=typeof i=="string"?i:i.value,y=typeof d=="string"?d:d.value;return o.equalsIgnoreCase(h,y)}return i.c===d.c}static toKey(i){return typeof i=="string"?i.toLowerCase():i.c}}e.ExtensionIdentifier=D;class p{get size(){return this.c.size}constructor(i){if(this.c=new Set,i)for(const d of i)this.add(d)}add(i){this.c.add(D.toKey(i))}delete(i){return this.c.delete(D.toKey(i))}has(i){return this.c.has(D.toKey(i))}}e.ExtensionIdentifierSet=p;class O{constructor(){this.c=new Map}clear(){this.c.clear()}delete(i){this.c.delete(D.toKey(i))}get(i){return this.c.get(D.toKey(i))}has(i){return this.c.has(D.toKey(i))}set(i,d){this.c.set(D.toKey(i),d)}values(){return this.c.values()}forEach(i){this.c.forEach(i)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=O;function k(v){return E(v)}e.isApplicationScopedExtension=k;function E(v){return v.contributes&&v.contributes.localizations?v.contributes.localizations.length>0:!1}e.isLanguagePackExtension=E;function T(v){return v.contributes&&v.contributes.authentication?v.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=T;function I(v,i){if(i){const d=`onResolveRemoteAuthority:${(0,l.getRemoteName)(i)}`;return!!v.activationEvents?.includes(d)}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,R.createDecorator)("IBuiltinExtensionsScannerService")}),define(Ce[128],ke([1,0,8,25]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class l{constructor(){this.a=new Map,this.b=new WeakMap}register(A,P){this.a.set(A,P)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const P=Object.create(null);for(const D of A){const p=this.readActivationEvents(D);p.length>0&&(P[R.ExtensionIdentifier.toKey(D.identifier)]=p)}return P}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const P=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];if(!A.contributes)return P;for(const D in A.contributes){const p=this.a.get(D);if(!p)continue;const O=A.contributes[D],k=Array.isArray(O)?O:[O];try{p(k,P)}catch(E){(0,o.onUnexpectedError)(E)}}return P}}e.ImplicitActivationEventsImpl=l,e.ImplicitActivationEvents=new l}),define(Ce[218],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class o{constructor(){this.b=new Map}c(){return new Promise((l,L)=>ae(["vsda"],l,L))}async createNewMessage(l){try{const L=await this.c(),A=new L.validator;if(A){const P=String(o.a++);return this.b.set(P,A),{id:P,data:A.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,L){if(!l.id)return!0;const A=this.b.get(l.id);if(!A)return!1;this.b.delete(l.id);try{return A.validate(L)==="ok"}catch{return!1}}async sign(l){try{const L=await this.c(),A=new L.signer;if(A)return A.sign(l)}catch{}return l}}e.SignService=o,o.a=1}),define(Ce[219],ke([1,0,14,36,30]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(D){if(o.platform===2&&/^penguin(\.|$)/i.test(D))return"chromebook"}function A(D,p,O,k,E,T,I,v){const i=Object.create(null);i["common.machineId"]=T,i.sessionID=(0,l.generateUuid)()+Date.now(),i.commitHash=k,i.version=E,i["common.platformVersion"]=(D||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),i["common.platform"]=(0,o.PlatformToString)(o.platform),i["common.nodePlatform"]=R.platform,i["common.nodeArch"]=O,i["common.product"]=v||"desktop",I&&(i["common.msftInternal"]=I);let d=0;const h=Date.now();Object.defineProperties(i,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-h,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),o.isLinuxSnap&&(i["common.snap"]="true");const y=L(p);return y&&(i["common.platformDetail"]=y),i}e.resolveCommonProperties=A;function P(D){const p=R.env.USERDNSDOMAIN;if(!p)return!1;const O=p.toLowerCase();return D.some(k=>O===k)}e.verifyMicrosoftInternalDomain=P}),define(Ce[220],ke([1,0,4]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,o.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,o.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var R;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(R||(e.TelemetryLevel=R={}));var l;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(l||(e.TelemetryConfiguration=l={}))}),define(Ce[75],ke([1,0,23,10,3,55,74,219,220]),function(ae,e,o,R,l,L,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class p{constructor(b){this.value=b,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=p;class O{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=O,e.NullTelemetryService=new O;class k{async publicLog(b,S,c){}async publicLogError(b,S,c){}}e.NullEndpointTelemetryService=k,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(a,b){return l.Event.debounce(b.onDidChangeConfiguration,(c,u)=>{const m=c?new Set([...c.affectedKeys,...u.affectedKeys]):u.affectedKeys;return{...u,affectedKeys:m}},1e3,!0)(c=>{c.source!==7&&a.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.configurationTelemetry=E;function T(a,b){return!b.isBuilt&&!b.disableTelemetry?!0:!(b.disableTelemetry||!a.enableTelemetry||b.extensionTestsLocationURI)}e.supportsTelemetry=T;function I(a,b){return!(b.isBuilt||b.disableTelemetry||a.enableTelemetry&&a.aiConfig?.ariaKey)}e.isLoggingOnly=I;function v(a){const b=a.getValue(D.TELEMETRY_SETTING_ID),S=a.getValue(D.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(a.getValue(D.TELEMETRY_OLD_SETTING_ID)===!1||S===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function i(a){const b={},S={},c={};y(a,c);for(let u in c){u=u.length>150?u.substr(u.length-149):u;const m=c[u];typeof m=="number"?S[u]=m:typeof m=="boolean"?S[u]=m?1:0:typeof m=="string"?(m.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${m.length}`),b[u]=m.substring(0,8191)):typeof m<"u"&&m!==null&&(b[u]=m)}return{properties:b,measurements:S}}e.validateTelemetryData=i;const d=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function h(a){if(!a)return"none";const b=(0,A.getRemoteName)(a);return d.has(b)?b:"other"}e.cleanRemoteAuthority=h;function y(a,b,S=0,c){if(a)for(const u of Object.getOwnPropertyNames(a)){const m=a[u],f=c?c+u:u;Array.isArray(m)?b[f]=(0,o.safeStringify)(m):m instanceof Date?b[f]=m.toISOString():(0,R.isObject)(m)?S<2?y(m,b,S+1,f+"."):b[f]=(0,o.safeStringify)(m):b[f]=m}}function w(a,b){const S=a.msftInternalDomains||[],c=b.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(S)||c}e.isInternalTelemetry=w;function g(a){return[a.appRoot,a.extensionsPath,a.userHome.fsPath,a.tmpDir.fsPath,a.userDataPath]}e.getPiiPathsFromEnvironment=g;function t(a,b){if(!a||!a.includes("/")&&!a.includes("\\"))return a;let S=a;const c=[];for(const n of b)for(;;){const C=n.exec(a);if(!C)break;c.push([C.index,n.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let f=0;for(S="";;){const n=m.exec(a);if(!n)break;const C=c.some(([M,H])=>n.index<H&&M<m.lastIndex);!u.test(n[0])&&!C&&(S+=a.substring(f,n.index)+"<REDACTED: user-file-path>",f=m.lastIndex)}return f<a.length&&(S+=a.substr(f)),S}function s(a){if(!a)return a;const b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const S of b)if(S.regex.test(a))return`<REDACTED: ${S.label}>`;return a}function r(a,b){return(0,o.cloneAndChange)(a,S=>{if(S instanceof p||Object.hasOwnProperty.call(S,"isTrustedTelemetryValue"))return S.value;if(typeof S=="string"){let c=S.replaceAll("%20"," ");c=t(c,b);for(const u of b)c=c.replace(u,"");return c=s(c),c}})}e.cleanData=r}),define(Ce[221],ke([1,0,9,122,25,14,2,8,36,75]),function(ae,e,o,R,l,L,A,P,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function O(r,a){return r.uuid&&a.uuid?r.uuid===a.uuid:r.id===a.id?!0:(0,o.compareIgnoreCase)(r.id,a.id)===0}e.areSameExtensions=O;const k=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class E{static create(a){const b=a.manifest?a.manifest.version:a.version,S=a.manifest?a.targetPlatform:a.properties.targetPlatform;return new E(a.identifier,b,S)}static parse(a){const b=k.exec(a);return b&&b[1]&&b[2]?new E({id:b[1]},b[2],b[4]||void 0):null}constructor(a,b,S="undefined"){this.version=b,this.targetPlatform=S,this.id=a.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(a){return a instanceof E?O(this,a)&&this.version===a.version&&this.targetPlatform===a.targetPlatform:!1}}e.ExtensionKey=E;const T=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(r){const a=T.exec(r);return a&&a[1]?[i(a[1]),a[2]]:[i(r),void 0]}e.getIdAndVersion=I;function v(r,a){return`${r}.${a}`}e.getExtensionId=v;function i(r){return r.toLowerCase()}e.adoptToGalleryExtensionId=i;function d(r,a){return i(v(r??l.UNDEFINED_PUBLISHER,a))}e.getGalleryExtensionId=d;function h(r,a){const b=[],S=c=>{for(const u of b)if(u.some(m=>O(a(m),a(c))))return u;return null};for(const c of r){const u=S(c);u?u.push(c):b.push([c])}return b}e.groupByExtension=h;function y(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=y;function w(r){return{id:new p.TelemetryTrustedValue(r.identifier.id),name:new p.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=w,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function g(r,a){const b=[],S=a.manifest.extensionDependencies?.slice(0)??[];for(;S.length;){const c=S.shift();if(c&&b.every(u=>!O(u.identifier,{id:c}))){const u=r.filter(m=>O(m.identifier,{id:c}));u.length===1&&(b.push(u[0]),S.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return b}e.getExtensionDependencies=g;async function t(r,a){if(!L.isLinux)return!1;let b;try{b=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{b=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){a.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(c))}}return!!b&&(b.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(r,a){const b=await t(r,a),S=(0,R.getTargetPlatform)(b?"alpine":L.platform,D.arch);return a.debug("ComputeTargetPlatform:",S),S}e.computeTargetPlatform=s}),define(Ce[222],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function o(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=o;function R(D){return D?[...D.entries()]:[]}e.serializeEnvironmentDescriptionMap=R;function l(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=l;function L(D){return new Map(D??[])}e.deserializeEnvironmentDescriptionMap=L;function A(D){return Array.from(D.entries()).map(p=>[p[0],o(p[1].map),R(p[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=A;function P(D){return new Map(D.map(p=>[p[0],{map:l(p[1]),descriptionMap:L(p[2])}]))}e.deserializeEnvironmentVariableCollections=P}),define(Ce[223],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class o{constructor(l){this.b=l,this.a=new Map}dispose(){for(const l of this.a.values())l.dispose()}startBuffering(l,L,A=5){const P=L(D=>{const p=typeof D=="string"?D:D.data;let O=this.a.get(l);if(O){O.data.push(p);return}const k=setTimeout(()=>this.flushBuffer(l),A);O={data:[p],timeoutId:k,dispose:()=>{clearTimeout(k),this.flushBuffer(l),P.dispose()}},this.a.set(l,O)});return P}stopBuffering(l){this.a.get(l)?.dispose()}flushBuffer(l){const L=this.a.get(l);L&&(this.a.delete(l),this.b(l,L.data.join("")))}}e.TerminalDataBufferer=o}),define(Ce[224],ke([1,0,19,67,53,3,10,2,180,93,40]),function(ae,e,o,R,l,L,A,P,D,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var k;(function(w){function g(t,s){let r=t.defaults;for(;l.ThemeIcon.isThemeIcon(r);){const a=I.getIcon(r.id);if(!a)return;r=a.defaults}return r}w.getDefinition=g})(k||(e.IconContribution=k={}));var E;(function(w){function g(s){return{weight:s.weight,style:s.style,src:s.src.map(r=>({format:r.format,location:r.location.toString()}))}}w.toJSONObject=g;function t(s){const r=a=>(0,A.isString)(a)?a:void 0;if(s&&Array.isArray(s.src)&&s.src.every(a=>(0,A.isString)(a.format)&&(0,A.isString)(a.location)))return{weight:r(s.weight),style:r(s.style),src:s.src.map(a=>({format:a.format,location:P.URI.parse(a.location)}))}}w.fromJSONObject=t})(E||(e.IconFontDefinition=E={}));class T{constructor(){this.a=new L.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${l.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,t,s,r){const a=this.b[g];if(a){if(s&&!a.description){a.description=s,this.d.properties[g].markdownDescription=`${s} $(${g})`;const c=this.e.enum.indexOf(g);c!==-1&&(this.e.enumDescriptions[c]=s),this.a.fire()}return a}const b={id:g,description:s,defaults:t,deprecationMessage:r};this.b[g]=b;const S={$ref:"#/definitions/icons"};return r&&(S.deprecationMessage=r),s&&(S.markdownDescription=`${s}: $(${g})`),this.d.properties[g]=S,this.e.enum.push(g),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const t=this.e.enum.indexOf(g);t!==-1&&(this.e.enum.splice(t,1),this.e.enumDescriptions.splice(t,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,t){const s=this.f[g];return s||(this.f[g]=t,this.a.fire(),t)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(a,b)=>a.id.localeCompare(b.id),t=a=>{for(;l.ThemeIcon.isThemeIcon(a.defaults);)a=this.b[a.defaults.id];return`codicon codicon-${a?a.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(a=>this.b[a]);for(const a of r.filter(b=>!!b.description).sort(g))s.push(`|<i class="${t(a)}"></i>|${a.id}|${l.ThemeIcon.isThemeIcon(a.defaults)?a.defaults.id:a.id}|${a.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const a of r.filter(b=>!l.ThemeIcon.isThemeIcon(b.defaults)).sort(g))s.push(`|<i class="${t(a)}"></i>|${a.id}|`);return s.join(`
`)}}const I=new T;O.Registry.add(e.Extensions.IconContribution,I);function v(w,g,t,s){return I.registerIcon(w,g,t,s)}e.registerIcon=v;function i(){return I}e.getIconRegistry=i;function d(){const w=(0,R.getCodiconFontCharacters)();for(const g in w){const t="\\"+w[g].toString(16);I.registerIcon(g,{fontCharacter:t})}}d(),e.iconsSchemaId="vscode://schemas/icons";const h=O.Registry.as(p.Extensions.JSONContribution);h.registerSchema(e.iconsSchemaId,I.getIconSchema());const y=new o.RunOnceScheduler(()=>h.notifySchemaChanged(e.iconsSchemaId),200);I.onDidChange(()=>{y.isScheduled()||y.schedule()}),e.widgetClose=v("widget-close",R.Codicon.close,(0,D.localize)(2,null)),e.gotoPreviousLocation=v("goto-previous-location",R.Codicon.arrowUp,(0,D.localize)(3,null)),e.gotoNextLocation=v("goto-next-location",R.Codicon.arrowDown,(0,D.localize)(4,null)),e.syncing=l.ThemeIcon.modify(R.Codicon.sync,"spin"),e.spinningLoading=l.ThemeIcon.modify(R.Codicon.loading,"spin")}),define(Ce[129],ke([1,0,3,55,4,16]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var A;(function(v){v.Http="http",v.Https="https"})(A||(e.TunnelProtocol=A={}));var P;(function(v){v.ConstantPrivate="constantPrivate",v.Private="private",v.Public="public"})(P||(e.TunnelPrivacyId=P={}));var D;(function(v){v[v.Notify=1]="Notify",v[v.OpenBrowser=2]="OpenBrowser",v[v.OpenPreview=3]="OpenPreview",v[v.Silent=4]="Silent",v[v.Ignore=5]="Ignore",v[v.OpenBrowserOnce=6]="OpenBrowserOnce"})(D||(e.ProvidedOnAutoForward=D={}));function p(v){if(v.scheme!=="http"&&v.scheme!=="https")return;const i=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(v.authority);if(i)return{address:i[1],port:+i[2]}}e.extractLocalHostUriMetaDataForPortMapping=p,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(v){return e.LOCALHOST_ADDRESSES.indexOf(v)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function k(v){return e.ALL_INTERFACES_ADDRESSES.indexOf(v)>=0}e.isAllInterfaces=k;function E(v,i,d,h){if(d===1)return!1;if(d===2&&k(i)){const y=/(\d+)\.(\d+)\.(\d+)/g.exec(h);if(y?.length===4&&parseInt(y[1])>=18)return!1}return v<1024}e.isPortPrivileged=E;class T{constructor(i,d,h){this.remoteAddress=i,this.localAddress=d,this.b=h,this.a=new o.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=T;let I=e.AbstractTunnelService=class{constructor(i,d){this.i=i,this.j=d,this.a=new o.Emitter,this.onTunnelOpened=this.a.event,this.b=new o.Emitter,this.onTunnelClosed=this.b.event,this.c=new o.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const i=this.j.getValue("remote.localPortHost");return!i||i==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(i){return this.e=i,i?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(i){this.f=i.elevation,this.g=i.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const i=[],d=Array.from(this.d.values());for(const h of d){const y=Array.from(h.values());for(const w of y){const g=await w.value;g&&i.push(g)}}return i}async dispose(){for(const i of this.d.values()){for(const{value:d}of i.values())await d.then(h=>h?.dispose());i.clear()}this.d.clear()}setEnvironmentTunnel(i,d,h,y,w){this.o(i,d,Promise.resolve({tunnelRemoteHost:i,tunnelRemotePort:d,localAddress:h,privacy:y,protocol:w,dispose:()=>Promise.resolve()}))}async getExistingTunnel(i,d){(k(i)||O(i))&&(i=e.LOCALHOST_ADDRESSES[0]);const h=this.q(i,d);if(h)return++h.refcount,h.value}openTunnel(i,d,h,y,w,g=!1,t,s){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${d}:${h} on local port ${w}.`),!i)return;if(d||(d="localhost"),y||(y=this.k),this.e&&this.h.has(h)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(i,d,h,y,w,g,t,s);return r?r.then(a=>{if(!a){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(d,h);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const b=this.m(a);return(a.tunnelRemoteHost!==d||a.tunnelRemotePort!==h)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(b),b}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(i){return{tunnelRemotePort:i.tunnelRemotePort,tunnelRemoteHost:i.tunnelRemoteHost,tunnelLocalPort:i.tunnelLocalPort,localAddress:i.localAddress,privacy:i.privacy,protocol:i.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${i.tunnelRemoteHost}:${i.tunnelRemotePort} `);const d=this.d.get(i.tunnelRemoteHost);if(d){const h=d.get(i.tunnelRemotePort);h&&(h.refcount--,await this.n(i.tunnelRemoteHost,i.tunnelRemotePort,h))}}}}async n(i,d,h){if(h.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${i}:${d}.`);const y=h.value.then(async w=>{w&&(await w.dispose(!0),this.b.fire({host:w.tunnelRemoteHost,port:w.tunnelRemotePort}))});return this.d.has(i)&&this.d.get(i).delete(d),y}}async closeTunnel(i,d){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${i}:${d} `);const h=this.d.get(i);if(h&&h.has(d)){const y=h.get(d);y.refcount=0,await this.n(i,d,y)}}o(i,d,h){this.d.has(i)||this.d.set(i,new Map),this.d.get(i).set(d,{refcount:1,value:h})}async p(i,d){const h=this.d.get(i);h&&(await h.get(d)||h.delete(d),h.size===0&&this.d.delete(i))}q(i,d){const h=[i];O(i)?(h.push(...e.LOCALHOST_ADDRESSES),h.push(...e.ALL_INTERFACES_ADDRESSES)):k(i)&&h.push(...e.ALL_INTERFACES_ADDRESSES);const y=h.map(w=>this.d.get(w));for(const w of y){const g=w?.get(d);if(g)return g}}canTunnel(i){return!!p(i)}s(i,d,h,y,w,g,t){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${d}:${h} on local port ${y}.`);const s=h;this.h.add(s);const r=y===void 0?h:y,a={elevationRequired:w?this.isPortPrivileged(r):!1},b={remoteAddress:{host:d,port:h},localAddressPort:y,privacy:g,public:g?g!==P.Private:void 0,protocol:t},S=i.forwardPort(b,a);return S?(this.o(d,h,S),S.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),S}};e.AbstractTunnelService=I=xe([We(0,L.ILogService),We(1,R.IConfigurationService)],I)}),define(Ce[225],ke([1,0,4]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,o.createDecorator)("editSessionIdentityService");var R;(function(l){l[l.Complete=100]="Complete",l[l.Partial=50]="Partial",l[l.None=0]="None"})(R||(e.EditSessionIdentityMatch=R={}))}),define(Ce[226],ke([1,0,17]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function R(D){return D.scheme!==o.Schemas.file&&D.scheme!==o.Schemas.vscodeRemote}e.isVirtualResource=R;function l(D){if(D.folders.length)return D.folders.every(p=>R(p.uri))?D.folders[0].uri:void 0;if(D.configuration&&R(D.configuration))return D.configuration}e.getVirtualWorkspaceLocation=l;function L(D){return l(D)?.scheme}e.getVirtualWorkspaceScheme=L;function A(D){return l(D)?.authority}e.getVirtualWorkspaceAuthority=A;function P(D){return l(D)!==void 0}e.isVirtualWorkspace=P}),define(Ce[48],ke([1,0,181,15,69,24,2,4,17]),function(ae,e,o,R,l,L,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function p(a){const b=a;return typeof b?.id=="string"&&A.URI.isUri(b.uri)}e.isSingleFolderWorkspaceIdentifier=p;function O(a){return typeof a?.id=="string"&&!p(a)&&!E(a)}e.isEmptyWorkspaceIdentifier=O,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function k(a,b){if(typeof a=="string"||typeof a>"u")return typeof a=="string"?{id:(0,R.basename)(a)}:b?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const S=a;return S.configuration?{id:S.id,configPath:S.configuration}:S.folders.length===1?{id:S.id,uri:S.folders[0].uri}:{id:S.id}}e.toWorkspaceIdentifier=k;function E(a){const b=a;return typeof b?.id=="string"&&A.URI.isUri(b.configPath)}e.isWorkspaceIdentifier=E;function T(a){const b=a;if(b?.uri)return{id:b.id,uri:A.URI.revive(b.uri)};const S=a;if(S?.configPath)return{id:S.id,configPath:A.URI.revive(S.configPath)};if(a?.id)return{id:a.id}}e.reviveIdentifier=T;var I;(function(a){a[a.EMPTY=1]="EMPTY",a[a.FOLDER=2]="FOLDER",a[a.WORKSPACE=3]="WORKSPACE"})(I||(e.WorkbenchState=I={}));function v(a){const b=a;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.isWorkspace=v;function i(a){const b=a;return!!(b&&typeof b=="object"&&A.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.isWorkspaceFolder=i;class d{constructor(b,S,c,u,m){this.h=b,this.j=c,this.k=u,this.l=m,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=S}update(b){this.h=b.id,this.k=b.configuration,this.j=b.transient,this.l=b.l,this.folders=b.folders}get folders(){return this.g}set folders(b){this.g=b,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(b){this.k=b}getFolder(b){return b&&this.c.findSubstr(b)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const b of this.folders)this.c.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class h{constructor(b,S){this.raw=S,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return(0,L.joinPath)(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=h;function y(a){return new h({uri:a,index:0,name:(0,L.basenameOrAuthority)(a)},{uri:a.toString()})}e.toWorkspaceFolder=y,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,o.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function w(a,b){return L.extUriBiasedIgnorePathCase.isEqualOrParent(a,b.untitledWorkspacesHome)}e.isUntitledWorkspace=w;function g(a){let b;return A.URI.isUri(a)?b=a:b=a.configuration,b?.scheme===D.Schemas.tmp}e.isTemporaryWorkspace=g,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function t(a){return a.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=t;function s(a,b){return!w(a,b)&&!g(a)}e.isSavedWorkspace=s;function r(a){return(typeof a=="string"?(0,R.extname)(a):(0,L.extname)(a))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(Ce[76],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class o{constructor(l){this.d=l,this.b=new Map,this.c=1}add(l){const L=this.c++;return this.b.set(L,l),this.e(),L}get(l,L){return this.b.has(l)?this.b.get(l)[L]:void 0}delete(l){this.b.delete(l),this.e()}e(){o.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=o,o.a=!1}),define(Ce[49],ke([1,0,17,24,4]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this.a=new Set(Object.keys(o.Schemas)),this.b=new Map,this.extUri=new R.ExtUri(P=>{const D=this.b.get(P.scheme);return!(D===void 0||D&1024)})}$acceptProviderInfos(P,D){D===null?this.b.delete(P.scheme):this.b.set(P.scheme,D)}isFreeScheme(P){return!this.b.has(P)&&!this.a.has(P)}getCapabilities(P){return this.b.get(P)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,l.createDecorator)("IExtHostFileSystemInfo")}),define(Ce[26],ke([1,0,4]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,o.createDecorator)("IExtHostInitDataService")}),define(Ce[227],ke([1,0,186,16,212,26]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let A=e.ExtHostLogService=class extends l.LogService{constructor(D,p,O){const k=O.remote.isRemote?"remoteexthost":D?"workerexthost":"exthost",E=O.remote.isRemote?(0,o.localize)(0,null):D?(0,o.localize)(1,null):(0,o.localize)(2,null);super(p.createLogger(k,{name:E}))}};e.ExtHostLogService=A=xe([We(1,R.ILoggerService),We(2,L.IExtHostInitDataService)],A)}),define(Ce[228],ke([1,0,19]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class R{constructor(A,P,D){this.h=new Map,this.a=A,this.b=P,this.c=D,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(p=>(this.f=p,this)),this.g=this.c.onDidChangeStorage(p=>{p.shared===this.b&&p.key===this.a&&(this.f=p.value)}),this.i=new o.RunOnceScheduler(()=>{const p=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of p.values())O.complete()}catch(O){for(const k of p.values())k.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,P){let D=this.f[A];return typeof D>"u"&&(D=P),D}update(A,P){this.f[A]=P;const D=this.h.get(A);if(D!==void 0)return D.p;const p=new o.DeferredPromise;return this.h.set(A,p),this.i.isScheduled()||this.i.schedule(),p.p}dispose(){this.g.dispose()}}e.ExtensionMemento=R;class l extends R{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,P){super(A.identifier.value,!0,P),this.j=A}}e.ExtensionGlobalMemento=l}),define(Ce[229],ke([1,0,3,2]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class l{constructor(A){this.c=A,this.a=new o.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new o.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,P,D,p){const k=this.c.getNotebookDocument(R.URI.revive(A)).acceptModelChanged(P.value,D,p);this.b.fire(k)}$acceptDirtyStateChanged(A,P){this.c.getNotebookDocument(R.URI.revive(A)).acceptDirty(P)}$acceptModelSaved(A){const P=this.c.getNotebookDocument(R.URI.revive(A));this.a.fire(P.apiNotebook)}}e.ExtHostNotebookDocuments=l}),define(Ce[20],ke([1,0,4]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,o.createDecorator)("IExtHostRpcService");class R{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=R});var _e=this&&this.__classPrivateFieldSet||function(ae,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!l:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(ae,o):l?l.value=o:e.set(ae,o),o},Be=this&&this.__classPrivateFieldGet||function(ae,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!R:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(ae):R?R.value:e.get(ae)};define(Ce[230],ke([1,0,25,3]),function(ae,e,o,R){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(P,D){l.set(this,void 0),this.b=new R.Emitter,this.onDidChange=this.b.event,this.a=o.ExtensionIdentifier.toKey(P.identifier),_e(this,l,D,"f"),Be(this,l,"f").onDidChangePassword(p=>{p.extensionId===this.a&&this.b.fire({key:p.key})})}get(P){return Be(this,l,"f").get(this.a,P)}store(P,D){return Be(this,l,"f").store(this.a,P,D)}delete(P){return Be(this,l,"f").delete(this.a,P)}}e.ExtensionSecrets=L,l=new WeakMap}),define(Ce[56],ke([1,0,4,129,3,20]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var A;(function(D){function p(k){return{remoteAddress:k.remoteAddress,localAddress:k.localAddress,public:!!k.public,privacy:k.privacy??(k.public?R.TunnelPrivacyId.Public:R.TunnelPrivacyId.Private),protocol:k.protocol}}D.fromApiTunnel=p;function O(k){return{remoteAddress:{host:k.tunnelRemoteHost,port:k.tunnelRemotePort},localAddress:k.localAddress,public:k.privacy!==R.TunnelPrivacyId.ConstantPrivate&&k.privacy!==R.TunnelPrivacyId.ConstantPrivate,privacy:k.privacy,protocol:k.protocol}}D.fromServiceTunnel=O})(A||(e.TunnelDtoConverter=A={})),e.IExtHostTunnelService=(0,o.createDecorator)("IExtHostTunnelService");let P=e.ExtHostTunnelService=class{constructor(p){this.onDidChangeTunnels=new l.Emitter().event}async $applyCandidateFilter(p){return p}async openTunnel(p,O){}async getTunnels(){return[]}async setTunnelFactory(p){return{dispose:()=>{}}}registerPortsAttributesProvider(p,O){return{dispose:()=>{}}}async $providePortAttributes(p,O,k,E,T){return[]}async $forwardPort(p,O){}async $closeTunnel(p){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};e.ExtHostTunnelService=P=xe([We(0,L.IExtHostRpcService)],P)}),define(Ce[57],ke([1,0,4]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,o.createDecorator)("IURITransformerService");class R{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.URITransformerService=R}),define(Ce[231],ke([1,0,22]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class R{constructor(){this.buffers=[]}add(D){let p=this.buffers.indexOf(D);return p<0&&(p=this.buffers.length,this.buffers.push(D)),p}}function l(P,D){if(D.serializeBuffersForPostMessage){const p=new R,k=JSON.stringify(P,(T,I)=>{if(I instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:p.add(I)};if(ArrayBuffer.isView(I)){const v=L(I);if(v)return{$$vscode_array_buffer_reference$$:!0,index:p.add(I.buffer),view:{type:v,byteLength:I.byteLength,byteOffset:I.byteOffset}}}return I}),E=p.buffers.map(T=>{const I=new Uint8Array(T);return o.VSBuffer.wrap(I)});return{message:k,buffers:E}}else return{message:JSON.stringify(P),buffers:[]}}e.serializeWebviewMessage=l;function L(P){switch(P.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(P,D){const p=D.map(E=>{const T=new ArrayBuffer(E.byteLength);return new Uint8Array(T).set(E.buffer),T}),O=D.length?(E,T)=>{if(T&&typeof T=="object"&&T.$$vscode_array_buffer_reference$$){const I=T,{index:v}=I,i=p[v];if(I.view)switch(I.view.type){case 1:return new Int8Array(i,I.view.byteOffset,I.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(i,I.view.byteOffset,I.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(i,I.view.byteOffset,I.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(i,I.view.byteOffset,I.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(i,I.view.byteOffset,I.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(i,I.view.byteOffset,I.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(i,I.view.byteOffset,I.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(i,I.view.byteOffset,I.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(i,I.view.byteOffset,I.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(i,I.view.byteOffset,I.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(i,I.view.byteOffset,I.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return i}return T}:void 0;return{message:JSON.parse(P,O),arrayBuffers:p}}e.deserializeWebviewMessage=A}),define(Ce[232],ke([1,0,233,330,331,2,332]),function(ae,e,o,R,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function P(k,E,T,I,v,i){const d=i.environment.useHostProxy,h=typeof d=="boolean"?d:!i.remote.isRemote,y=(0,A.createProxyResolver)({resolveProxy:g=>k.resolveProxy(g),getHttpProxySetting:()=>E.getConfiguration("http").get("proxy"),log:(g,t,...s)=>{switch(g){case A.LogLevel.Trace:I.trace(t,...s);break;case A.LogLevel.Debug:I.debug(t,...s);break;case A.LogLevel.Info:I.info(t,...s);break;case A.LogLevel.Warning:I.warn(t,...s);break;case A.LogLevel.Error:I.error(t,...s);break;case A.LogLevel.Critical:I.error(t,...s);break;case A.LogLevel.Off:break;default:r(g,t,s);break}function r(a,b,...S){I.error("Unknown log level",a),I.error(b,...S)}},getLogLevel:()=>I.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:h,env:process.env}),w=D(E,y);return O(T,w)}e.connectProxyResolver=P;function D(k,E){const T={config:k.getConfiguration("http").get("proxySupport")||"off"};k.onDidChangeConfiguration(v=>{T.config=k.getConfiguration("http").get("proxySupport")||"off"});const I={config:!!k.getConfiguration("http").get("systemCertificates")};return k.onDidChangeConfiguration(v=>{I.config=!!k.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},o,(0,A.createHttpPatch)(o,E,{config:"off"},I,!0)),on:Object.assign({},o,(0,A.createHttpPatch)(o,E,{config:"on"},I,!0)),override:Object.assign({},o,(0,A.createHttpPatch)(o,E,{config:"override"},I,!0)),onRequest:Object.assign({},o,(0,A.createHttpPatch)(o,E,T,I,!0)),default:Object.assign(o,(0,A.createHttpPatch)(o,E,T,I,!1))},https:{off:Object.assign({},R,(0,A.createHttpPatch)(R,E,{config:"off"},I,!0)),on:Object.assign({},R,(0,A.createHttpPatch)(R,E,{config:"on"},I,!0)),override:Object.assign({},R,(0,A.createHttpPatch)(R,E,{config:"override"},I,!0)),onRequest:Object.assign({},R,(0,A.createHttpPatch)(R,E,T,I,!0)),default:Object.assign(R,(0,A.createHttpPatch)(R,E,T,I,!1))},tls:Object.assign(l,(0,A.createTlsPatch)(l))}}const p=new Map;function O(k,E){return k.getExtensionPathIndex().then(T=>{const I=globalThis._VSCODE_NODE_MODULES.module,v=I._load;I._load=function(d,h,y){if(d==="tls")return E.tls;if(d!=="http"&&d!=="https")return v.apply(this,arguments);const w=E[d],g=T.findSubstr(L.URI.file(h.filename));let t=p.get(g);if(t||p.set(g,t={}),!t[d]){const s=w.default;t[d]={...s}}return t[d]}})}}),define(Ce[234],ke([1,0,115]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function R(L){return{transformIncoming:A=>A.scheme==="vscode-remote"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="file"?{scheme:"vscode-local",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoing:A=>A.scheme==="file"?{scheme:"vscode-remote",authority:L,path:A.path,query:A.query,fragment:A.fragment}:A.scheme==="vscode-local"?{scheme:"file",path:A.path,query:A.query,fragment:A.fragment}:A,transformOutgoingScheme:A=>A==="file"?"vscode-remote":A==="vscode-local"?"file":A}}function l(L){return new o.URITransformer(R(L))}e.createURITransformer=l}),define(Ce[130],ke([1,0,195,10,2,6,4,40,45,17,46,164,38]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var T;(function(he){he[he.PROGRAMMATIC=1]="PROGRAMMATIC",he[he.USER=2]="USER",he[he.EDIT=3]="EDIT",he[he.NAVIGATION=4]="NAVIGATION",he[he.JUMP=5]="JUMP"})(T||(e.EditorPaneSelectionChangeReason=T={}));var I;(function(he){he[he.IDENTICAL=1]="IDENTICAL",he[he.SIMILAR=2]="SIMILAR",he[he.DIFFERENT=3]="DIFFERENT"})(I||(e.EditorPaneSelectionCompareResult=I={}));function v(he){const fe=he;return!!fe&&typeof fe.getSelection=="function"&&!!fe.onDidChangeSelection}e.isEditorPaneWithSelection=v;function i(he,fe,x){for(const B of x.visibleEditorPanes)if(B.group.id===fe&&he.matches(B.input))return B.getViewState()}e.findViewStateForEditor=i;function d(he){if(u(he))return!1;const fe=he;return l.URI.isUri(fe?.resource)}e.isResourceEditorInput=d;function h(he){if(u(he))return!1;const fe=he;return fe?.original!==void 0&&fe.modified!==void 0}e.isResourceDiffEditorInput=h;function y(he){if(u(he)||h(he))return!1;const fe=he;return fe?.primary!==void 0&&fe.secondary!==void 0}e.isResourceSideBySideEditorInput=y;function w(he){if(u(he))return!1;const fe=he;return fe?fe.resource===void 0||fe.resource.scheme===p.Schemas.untitled||fe.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=w;const g=/Untitled-\d+/;function t(he){return he.scheme===p.Schemas.untitled&&he.path.length>1&&!g.test(he.path)}e.isUntitledWithAssociatedResource=t;function s(he){if(u(he))return!1;const fe=he;return l.URI.isUri(fe?.base?.resource)&&l.URI.isUri(fe?.input1?.resource)&&l.URI.isUri(fe?.input2?.resource)&&l.URI.isUri(fe?.result?.resource)}e.isResourceMergeEditorInput=s;var r;(function(he){he[he.SHORT=0]="SHORT",he[he.MEDIUM=1]="MEDIUM",he[he.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var a;(function(he){he[he.EXPLICIT=1]="EXPLICIT",he[he.AUTO=2]="AUTO",he[he.FOCUS_CHANGE=3]="FOCUS_CHANGE",he[he.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(a||(e.SaveReason=a={}));class b{constructor(){this.a=new Map}registerSource(fe,x){let B=this.a.get(fe);return B||(B={source:fe,label:x},this.a.set(fe,B)),B.source}getSourceLabel(fe){return this.a.get(fe)?.label??fe}}e.SaveSourceRegistry=new b;var S;(function(he){he[he.None=0]="None",he[he.Readonly=2]="Readonly",he[he.Untitled=4]="Untitled",he[he.Singleton=8]="Singleton",he[he.RequiresTrust=16]="RequiresTrust",he[he.CanSplitInGroup=32]="CanSplitInGroup",he[he.ForceDescription=64]="ForceDescription",he[he.CanDropIntoEditor=128]="CanDropIntoEditor",he[he.MultipleEditors=256]="MultipleEditors"})(S||(e.EditorInputCapabilities=S={}));class c extends L.Disposable{}e.AbstractEditorInput=c;function u(he){return he instanceof c}e.isEditorInput=u;function m(he){const fe=he;return l.URI.isUri(fe?.preferredResource)}function f(he){const fe=he;return u(fe?.primary)&&u(fe?.secondary)}e.isSideBySideEditorInput=f;function n(he){const fe=he;return u(fe?.modified)&&u(fe?.original)}e.isDiffEditorInput=n;function C(he,fe,x,B,Z){return Ee(B,[(0,k.toAction)({id:"workbench.action.openLargeFile",label:(0,o.localize)(2,null),run:()=>{const pe={...x,limits:{size:Number.MAX_VALUE}};he.openEditor(fe,pe)}}),(0,k.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,o.localize)(3,null),run:()=>Z.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:E.default.Warning})}e.createTooLargeFileError=C;function M(he){return u(he?.editor)}e.isEditorInputWithOptions=M;function H(he){const fe=he;return M(he)&&fe?.group!==void 0}e.isEditorInputWithOptionsAndGroup=H;function V(he){const fe=he;return typeof fe?.groupId=="number"&&u(fe.editor)}e.isEditorIdentifier=V;var U;(function(he){he[he.UNKNOWN=0]="UNKNOWN",he[he.REPLACE=1]="REPLACE",he[he.MOVE=2]="MOVE",he[he.UNPIN=3]="UNPIN"})(U||(e.EditorCloseContext=U={}));var z;(function(he){he[he.GROUP_ACTIVE=0]="GROUP_ACTIVE",he[he.GROUP_INDEX=1]="GROUP_INDEX",he[he.GROUP_LOCKED=2]="GROUP_LOCKED",he[he.EDITOR_OPEN=3]="EDITOR_OPEN",he[he.EDITOR_CLOSE=4]="EDITOR_CLOSE",he[he.EDITOR_MOVE=5]="EDITOR_MOVE",he[he.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",he[he.EDITOR_LABEL=7]="EDITOR_LABEL",he[he.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",he[he.EDITOR_PIN=9]="EDITOR_PIN",he[he.EDITOR_STICKY=10]="EDITOR_STICKY",he[he.EDITOR_DIRTY=11]="EDITOR_DIRTY",he[he.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(z||(e.GroupModelChangeKind=z={}));var G;(function(he){he[he.PRIMARY=1]="PRIMARY",he[he.SECONDARY=2]="SECONDARY",he[he.BOTH=3]="BOTH",he[he.ANY=4]="ANY"})(G||(e.SideBySideEditor=G={}));class F{getOriginalUri(fe,x){if(!fe)return;if(s(fe))return e.EditorResourceAccessor.getOriginalUri(fe.result,x);if(x?.supportSideBySide){const{primary:Z,secondary:pe}=this.a(fe);if(Z&&pe){if(x?.supportSideBySide===G.BOTH)return{primary:this.getOriginalUri(Z,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(pe,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===G.ANY)return this.getOriginalUri(Z,{filterByScheme:x.filterByScheme})??this.getOriginalUri(pe,{filterByScheme:x.filterByScheme});fe=x.supportSideBySide===G.PRIMARY?Z:pe}}if(h(fe)||y(fe)||s(fe))return;const B=m(fe)?fe.preferredResource:fe.resource;return!B||!x||!x.filterByScheme?B:this.b(B,x.filterByScheme)}a(fe){return f(fe)||y(fe)?{primary:fe.primary,secondary:fe.secondary}:n(fe)||h(fe)?{primary:fe.modified,secondary:fe.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(fe,x){if(!fe)return;if(s(fe))return e.EditorResourceAccessor.getCanonicalUri(fe.result,x);if(x?.supportSideBySide){const{primary:Z,secondary:pe}=this.a(fe);if(Z&&pe){if(x?.supportSideBySide===G.BOTH)return{primary:this.getCanonicalUri(Z,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(pe,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===G.ANY)return this.getCanonicalUri(Z,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(pe,{filterByScheme:x.filterByScheme});fe=x.supportSideBySide===G.PRIMARY?Z:pe}}if(h(fe)||y(fe)||s(fe))return;const B=fe.resource;return!B||!x||!x.filterByScheme?B:this.b(B,x.filterByScheme)}b(fe,x){if(Array.isArray(x)){if(x.some(B=>fe.scheme===B))return fe}else if(x===fe.scheme)return fe}}e.EditorResourceAccessor=new F;var $;(function(he){he[he.LEFT=0]="LEFT",he[he.RIGHT=1]="RIGHT"})($||(e.CloseDirection=$={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(fe){const x=this.a=fe.get(A.IInstantiationService);for(const[B,Z]of this.c)this.e(B,Z,x);this.c.clear()}e(fe,x,B){const Z=B.createInstance(x);this.d.set(fe,Z)}registerFileEditorFactory(fe){if(this.b)throw new Error("Can only register one file editor factory.");this.b=fe}getFileEditorFactory(){return(0,R.assertIsDefined)(this.b)}registerEditorSerializer(fe,x){if(this.c.has(fe)||this.d.has(fe))throw new Error(`A editor serializer with type ID '${fe}' was already registered.`);return this.a?this.e(fe,x,this.a):this.c.set(fe,x),(0,L.toDisposable)(()=>{this.c.delete(fe),this.d.delete(fe)})}getEditorSerializer(fe){return this.d.get(typeof fe=="string"?fe:fe.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new Y);async function _(he,fe,x){return!he||!he.length?[]:await Promise.all(he.map(async B=>{const Z=l.URI.revive(B.fileUri);if(!Z){x.info("Cannot resolve the path because it is not valid.",B);return}if(!await fe.canHandleResource(Z)){x.info("Cannot resolve the path because it cannot be handled",B);return}let Se=B.exists,re=B.type;if(typeof Se!="boolean"||typeof re!="number")try{re=(await fe.stat(Z)).isDirectory?D.FileType.Directory:D.FileType.Unknown,Se=!0}catch(de){x.error(de),Se=!1}if(!Se&&B.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",B);return}if(re===D.FileType.Directory){x.info("Cannot resolve the path because it is a directory",B);return}const ne={...B.options,pinned:!0};return Se?{resource:Z,options:ne}:{resource:Z,options:ne,forceUntitled:!0}}))}e.pathsToEditors=_;var Q;(function(he){he[he.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",he[he.SEQUENTIAL=1]="SEQUENTIAL"})(Q||(e.EditorsOrder=Q={}));function ie(he){const fe=he;if(!fe)return!1;const x=fe;if(x.modified)return ie(x.modified);const B=fe;return!!(B.contributionsState&&B.viewState&&Array.isArray(B.cursorState))}e.isTextEditorViewState=ie;function oe(he){return(0,O.isErrorWithActions)(he)}e.isEditorOpenError=oe;function Ee(he,fe,x){const B=(0,O.createErrorWithActions)(he,fe);return B.forceMessage=x?.forceMessage,B.forceSeverity=x?.forceSeverity,B.allowDialog=x?.allowDialog,B}e.createEditorOpenError=Ee}),define(Ce[235],ke([1,0,3,196,4,6,28,40,18,62,23,67,224]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,E.registerIcon)("default-view-icon",k.Codicon.window,(0,R.localize)(0,null));var T;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(T||(e.Extensions=T={}));var I;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(I||(e.ViewContainerLocation=I={})),e.ViewContainerLocations=[0,1,2];function v(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=v;class i extends L.Disposable{constructor(){super(...arguments),this.c=this.B(new o.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new o.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,D.flatten)([...this.g.values()])}registerViewContainer(a,b,S){const c=this.get(a.id);if(c)return c;const u=a;return u.openCommandActionDescriptor=S?.doNotRegisterOpenCommand?void 0:u.openCommandActionDescriptor??{id:u.id},(0,A.getOrSet)(this.g,b,[]).push(u),S?.isDefault&&this.h.push(u),this.c.fire({viewContainer:u,viewContainerLocation:b}),u}deregisterViewContainer(a){for(const b of this.g.keys()){const S=this.g.get(b),c=S?.indexOf(a);if(c!==-1){S?.splice(c,1),S.length===0&&this.g.delete(b),this.f.fire({viewContainer:a,viewContainerLocation:b});return}}}get(a){return this.all.filter(b=>b.id===a)[0]}getViewContainers(a){return[...this.g.get(a)||[]]}getViewContainerLocation(a){return[...this.g.keys()].filter(b=>this.getViewContainers(b).filter(S=>S?.id===a.id).length>0)[0]}getDefaultViewContainer(a){return this.h.find(b=>this.getViewContainerLocation(b)===a)}}P.Registry.add(T.ViewContainersRegistry,new i);var d;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(d||(e.ViewContentGroups=d={}));function h(r,a){const b=r.group??d.More,S=a.group??d.More;return b!==S?b.localeCompare(S):(r.order??5)-(a.order??5)}class y extends L.Disposable{constructor(){super(...arguments),this.c=this.B(new o.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new o.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new o.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new o.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new p.SetMap}registerViews(a,b){this.registerViews2([{views:a,viewContainer:b}])}registerViews2(a){a.forEach(({views:b,viewContainer:S})=>this.l(b,S)),this.c.fire(a)}deregisterViews(a,b){const S=this.m(a,b);S.length&&this.f.fire({views:S,viewContainer:b})}moveViews(a,b){for(const S of this.j.keys())if(S!==b){const c=this.m(a,S);c.length&&(this.l(c,b),this.g.fire({views:c,from:S,to:b}))}}getViews(a){return this.j.get(a)||[]}getView(a){for(const b of this.i){const S=(this.j.get(b)||[]).filter(c=>c.id===a)[0];if(S)return S}return null}getViewContainer(a){for(const b of this.i)if((this.j.get(b)||[]).filter(c=>c.id===a)[0])return b;return null}registerViewWelcomeContent(a,b){return this.k.add(a,b),this.h.fire(a),(0,L.toDisposable)(()=>{this.k.delete(a,b),this.h.fire(a)})}registerViewWelcomeContent2(a,b){const S=new Map;for(const[c,u]of b)this.k.add(a,u),S.set(c,(0,L.toDisposable)(()=>{this.k.delete(a,u),this.h.fire(a)}));return this.h.fire(a),S}getViewWelcomeContent(a){const b=[];return this.k.forEach(a,S=>b.push(S)),b.sort(h)}l(a,b){let S=this.j.get(b);S||(S=[],this.j.set(b,S),this.i.push(b));for(const c of a){if(this.getView(c.id)!==null)throw new Error((0,R.localize)(1,null,c.id));S.push(c)}}m(a,b){const S=this.j.get(b);if(!S)return[];const c=[],u=[];for(const m of S)a.includes(m)?c.push(m):u.push(m);return c.length&&(u.length?this.j.set(b,u):(this.j.delete(b),this.i.splice(this.i.indexOf(b),1))),c}}P.Registry.add(T.ViewsRegistry,new y),e.IViewsService=(0,l.createDecorator)("viewsService"),e.IViewDescriptorService=(0,l.createDecorator)("viewDescriptorService");var w;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(w||(e.ViewVisibilityState=w={}));var g;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(g||(e.TreeItemCollapsibleState=g={}));class t{constructor(a,b){this.c=!1,this.d=!1,(0,O.mixin)(this,a),this.d=!!b,this.resolve=async S=>{if(b&&!this.c){const c=await b(S);c&&(this.tooltip=this.tooltip??c.tooltip,this.command=this.command??c.command)}S.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=t;class s extends Error{constructor(a){super((0,R.localize)(2,null,a)),this.name="NoTreeViewError"}static is(a){return a.name==="NoTreeViewError"}}e.NoTreeViewError=s}),define(Ce[131],ke([1,0,3,19,197]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new o.Emitter,this.n=new o.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(P){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=P}onEvent(P){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=P}onRequest(P){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=P}sendResponse(P){P.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${P.command}`)):this.s("response",P)}sendRequest(P,D,p,O){const k={command:P};if(D&&Object.keys(D).length>0&&(k.arguments=D),this.s("request",k),typeof O=="number"){const E=setTimeout(()=>{clearTimeout(E);const T=this.f.get(k.seq);if(T){this.f.delete(k.seq);const I={type:"response",seq:0,request_seq:k.seq,success:!1,command:P,message:(0,l.localize)(0,null,O,P)};T(I)}},O)}return p&&this.f.set(k.seq,p),k.seq}acceptMessage(P){this.j?this.j(P):(this.k.push(P),this.k.length===1&&this.q())}o(P,D){return P.type!=="event"||D.type!=="event"}async q(){let P;for(;this.k.length;){if((!P||this.o(this.k[0],P))&&await(0,R.timeout)(0),P=this.k.shift(),!P)return;switch(P.type){case"event":this.i?.(P);break;case"request":this.g?.(P);break;case"response":{const D=P,p=this.f.get(D.request_seq);p&&(this.f.delete(D.request_seq),p(D));break}}}}s(P,D){D.type=P,D.seq=this.d++,this.sendMessage(D)}async u(){if(this.f.size===0)return Promise.resolve();const P=new Map;this.f.forEach((D,p)=>P.set(p,D)),await(0,R.timeout)(500),P.forEach((D,p)=>{D({type:"response",seq:0,request_seq:p,success:!1,command:"canceled",message:"canceled"}),this.f.delete(p)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=L}),define(Ce[236],ke([1,0,198,44,4]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new R.RawContextKey("debugType",void 0,{type:"string",description:o.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new R.RawContextKey("debugConfigurationType",void 0,{type:"string",description:o.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new R.RawContextKey("debugState","inactive",{type:"string",description:o.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new R.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:o.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new R.RawContextKey("hasDebugged",!1,{type:"boolean",description:o.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new R.RawContextKey("inDebugMode",!1,{type:"boolean",description:o.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new R.RawContextKey("inDebugRepl",!1,{type:"boolean",description:o.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new R.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:o.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new R.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:o.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new R.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:o.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new R.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:o.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new R.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:o.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new R.RawContextKey("variablesFocused",!0,{type:"boolean",description:o.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new R.RawContextKey("expressionSelected",!1,{type:"boolean",description:o.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new R.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:o.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new R.RawContextKey("callStackItemType",void 0,{type:"string",description:o.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new R.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:o.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new R.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:o.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new R.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:o.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new R.RawContextKey("watchItemType",void 0,{type:"string",description:o.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new R.RawContextKey("canViewMemory",void 0,{type:"boolean",description:o.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new R.RawContextKey("breakpointItemType",void 0,{type:"string",description:o.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new R.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:o.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new R.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:o.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new R.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:o.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new R.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:o.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new R.RawContextKey("stepBackSupported",!1,{type:"boolean",description:o.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new R.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:o.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new R.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:o.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new R.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:o.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new R.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:o.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new R.RawContextKey("breakpointsExist",!1,{type:"boolean",description:o.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new R.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:o.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new R.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:o.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new R.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:o.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new R.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:o.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new R.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:o.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new R.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:o.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new R.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:o.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new R.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:o.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new R.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:o.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new R.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:o.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new R.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:o.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new R.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:o.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new R.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:o.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new R.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:o.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new R.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:o.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new R.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:o.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new R.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:o.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new R.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:o.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new R.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:o.localize(50,null)});const L=E=>o.localize(51,null,E);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:o.localize(52,null)};var A;(function(E){E[E.Inactive=0]="Inactive",E[E.Initializing=1]="Initializing",E[E.Stopped=2]="Stopped",E[E.Running=3]="Running"})(A||(e.State=A={}));function P(E){switch(E){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=P;var D;(function(E){E[E.Valid=0]="Valid",E[E.Unreadable=1]="Unreadable",E[E.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var p;(function(E){E[E.Initial=1]="Initial",E[E.Dynamic=2]="Dynamic"})(p||(e.DebugConfigurationProviderTriggerKind=p={}));var O;(function(E){E.UnverifiedBreakpoints="unverifiedBreakpoints"})(O||(e.DebuggerString=O={})),e.IDebugService=(0,l.createDecorator)("debugService");var k;(function(E){E[E.CONDITION=0]="CONDITION",E[E.HIT_COUNT=1]="HIT_COUNT",E[E.LOG_MESSAGE=2]="LOG_MESSAGE"})(k||(e.BreakpointWidgetContext=k={}))}),define(Ce[237],ke([1,0,9,2,15,23,17,32,21,18]),function(ae,e,o,R,l,L,A,P,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const O=/{([^}]+)}/g;function k(c,u,m){return c.replace(O,function(f,n){return u&&n.length>0&&n[0]!=="_"?f:m&&m.hasOwnProperty(n)?m[n]:f})}e.formatPII=k;function E(c){const u={};for(const m of Object.keys(c))m.startsWith("!")||(u[m]=c[m]);return u}e.filterExceptionsFromTelemetry=E;function T(c){return c.configuration.request==="attach"&&!I(c)&&(!c.parentSession||T(c.parentSession))}e.isSessionAttach=T;function I(c){let u=c.configuration.type;if(u)return u==="vslsShare"&&(u=c.configuration.adapterProxy.configuration.type),(0,o.equalsIgnoreCase)(u,"extensionhost")||(0,o.equalsIgnoreCase)(u,"pwa-extensionhost")?c:c.parentSession?I(c.parentSession):void 0}e.getExtensionHostDebugSession=I;function v(c){return c.type&&(c.label||c.program||c.runtime)}e.isDebuggerMainContribution=v;function i(c,u,m){let f,n=0;const C=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let M=null;for(;M=C.exec(c);){const H=M.index+1,V=H+M[0].length;if(H<=u&&V>=m){f=M[0],n=H;break}}if(f){const H=/\w+/g;let V=null;for(;(V=H.exec(f))&&!(V.index+1+n+V[0].length>=m););V&&(f=f.substring(0,H.lastIndex))}return f?{start:n,end:n+f.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=i;async function d(c,u,m,f){if(c.evaluatableExpressionProvider.has(u)){const n=c.evaluatableExpressionProvider.ordered(u),C=(0,p.coalesce)(await Promise.all(n.map(async M=>{try{return await M.provideEvaluatableExpression(u,m,f??D.CancellationToken.None)}catch{return}})));if(C.length>0){let M=C[0].expression;const H=C[0].range;return M||(M=u.getLineContent(m.lineNumber).substring(H.startColumn-1,H.endColumn-1)),{range:H,matchingExpression:M}}}else{const n=u.getLineContent(m.lineNumber),{start:C,end:M}=i(n,m.column,m.column),H=n.substring(C-1,M);return{matchingExpression:H,range:new P.Range(m.lineNumber,C,m.lineNumber,C+H.length)}}return null}e.getEvaluatableExpressionAtPosition=d;const h=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function y(c){return!!(c&&c.match(h))}e.isUri=y;function w(c){if(typeof c.path=="string"&&!(typeof c.sourceReference=="number"&&c.sourceReference>0)){if(y(c.path))return R.URI.parse(c.path);if((0,l.isAbsolute)(c.path))return R.URI.file(c.path)}return c.path}function g(c){if(typeof c.path=="object"){const u=R.URI.revive(c.path);if(u)return u.scheme===A.Schemas.file?u.fsPath:u.toString()}return c.path}function t(c,u){const m=u?w:g,f=(0,L.deepClone)(c);return r(f,(n,C)=>{n&&C&&(C.path=m(C))}),f}e.convertToDAPaths=t;function s(c,u){const m=u?w:g,f=(0,L.deepClone)(c);return r(f,(n,C)=>{!n&&C&&(C.path=m(C))}),f}e.convertToVSCPaths=s;function r(c,u){switch(c.type){case"event":{const m=c;switch(m.event){case"output":u(!1,m.body.source);break;case"loadedSource":u(!1,m.body.source);break;case"breakpoint":u(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=c;switch(m.command){case"setBreakpoints":u(!0,m.arguments.source);break;case"breakpointLocations":u(!0,m.arguments.source);break;case"source":u(!0,m.arguments.source);break;case"gotoTargets":u(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(f=>u(!1,f));break;default:break}break}case"response":{const m=c;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(f=>u(!1,f.source));break;case"loadedSources":m.body.sources.forEach(f=>u(!1,f));break;case"scopes":m.body.scopes.forEach(f=>u(!1,f.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(f=>u(!1,f.source));break;case"setBreakpoints":m.body.breakpoints.forEach(f=>u(!1,f.source));break;case"disassemble":m.body?.instructions.forEach(n=>u(!1,n.location));break;default:break}break}}}function a(c){return c.filter(u=>!u.presentation?.hidden).sort((u,m)=>u.presentation?m.presentation?u.presentation.group?m.presentation.group?u.presentation.group!==m.presentation.group?u.presentation.group.localeCompare(m.presentation.group):b(u.presentation.order,m.presentation.order):-1:m.presentation.group?1:b(u.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.getVisibleAndSorted=a;function b(c,u){return typeof c!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:c-u}async function S(c,u){const m=c.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(m!=="none"&&(await u.saveAll(),m==="allEditorsInActiveGroup")){const f=u.activeEditorPane;f&&f.input.resource?.scheme===A.Schemas.untitled&&await u.save({editor:f.input,groupId:f.group.id})}await c.reloadConfiguration()}e.saveAllBeforeDebugStart=S}),define(Ce[238],ke([1,0,47,132,23,15,14,9,29,199,131]),function(ae,e,o,R,l,L,A,P,D,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class k extends O.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(d,h){this.p=h,this.r=Buffer.allocUnsafe(0),this.t=-1,d.on("data",y=>this.w(y))}sendMessage(d){if(this.p){const h=JSON.stringify(d);this.p.write(`Content-Length: ${Buffer.byteLength(h,"utf8")}${k.a}${h}`,"utf8")}}w(d){for(this.r=Buffer.concat([this.r,d]);;){if(this.t>=0){if(this.r.length>=this.t){const h=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,h.length>0)try{this.acceptMessage(JSON.parse(h))}catch(y){this.m.fire(new Error((y.message||y)+`
`+h))}continue}}else{const h=this.r.indexOf(k.a);if(h!==-1){const w=this.r.toString("utf8",0,h).split(k.b);for(const g of w){const t=g.split(k.l);t[0]==="Content-Length"&&(this.t=Number(t[1]))}this.r=this.r.slice(h+k.a.length);continue}}break}}}e.StreamDebugAdapter=k,k.a=`\r
\r
`,k.b=/\r?\n/,k.l=/: */;class E extends k{startSession(){return new Promise((d,h)=>{let y=!1;this.x=this.y(()=>{this.v(this.x,this.x),d(),y=!0}),this.x.on("close",()=>{y?this.m.fire(new Error("connection closed")):h(new Error("connection closed"))}),this.x.on("error",w=>{y?this.m.fire(w):h(w)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=E;class T extends E{constructor(d){super(),this.z=d}y(d){return R.createConnection(this.z.port,this.z.host||"127.0.0.1",d)}}e.SocketDebugAdapter=T;class I extends E{constructor(d){super(),this.z=d}y(d){return R.createConnection(this.z.path,d)}}e.NamedPipeDebugAdapter=I;class v extends k{constructor(d,h){super(),this.y=d,this.z=h}async startSession(){const d=this.y.command,h=this.y.args,y=this.y.options||{};try{if(d)if(L.isAbsolute(d)){if(!await D.Promises.exists(d))throw new Error(p.localize(0,null,d))}else d.indexOf("/")<0&&d.indexOf("\\")<0;else throw new Error(p.localize(1,null,this.z));let w=process.env;if(y.env&&Object.keys(y.env).length>0&&(w=l.mixin(l.deepClone(process.env),y.env)),d==="node")if(Array.isArray(h)&&h.length>0){const g=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,t={env:w,execArgv:g?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};y.cwd&&(t.cwd=y.cwd);const s=o.fork(h[0],h.slice(1),t);if(!s.pid)throw new Error(p.localize(2,null,h[0]));this.x=s}else throw new Error(p.localize(3,null));else{const g={env:w};y.cwd&&(g.cwd=y.cwd),this.x=o.spawn(d,h,g)}this.x.on("error",g=>{this.m.fire(g)}),this.x.on("exit",(g,t)=>{this.n.fire(g)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",g=>{this.m.fire(g)}),this.x.stdin.on("error",g=>{this.m.fire(g)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(w){this.m.fire(w)}}async stopSession(){return this.x?(await this.u(),A.isWindows?new Promise((d,h)=>{const y=o.exec(`taskkill /F /T /PID ${this.x.pid}`,function(w,g,t){if(w)return h(w)});y.on("exit",d),y.on("error",h)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(d,h){if(!d)return;const y=Object.create(null);d.runtime&&(d.runtime.indexOf("./")===0?y.runtime=L.join(h,d.runtime):y.runtime=d.runtime),d.runtimeArgs&&(y.runtimeArgs=d.runtimeArgs),d.program&&(L.isAbsolute(d.program)?y.program=d.program:y.program=L.join(h,d.program)),d.args&&(y.args=d.args);const w=d;return w.win&&(y.win=v.A(w.win,h)),w.winx86&&(y.winx86=v.A(w.winx86,h)),w.windows&&(y.windows=v.A(w.windows,h)),w.osx&&(y.osx=v.A(w.osx,h)),w.linux&&(y.linux=v.A(w.linux,h)),y}static platformAdapterExecutable(d,h){let y=Object.create(null);h=h.toLowerCase();for(const a of d)if(a.contributes){const b=a.contributes.debuggers;b&&b.length>0&&b.filter(S=>typeof S.type=="string"&&P.equalsIgnoreCase(S.type,h)).forEach(S=>{const c=v.A(S,a.extensionLocation.fsPath);y=l.mixin(y,c,a.isBuiltin)})}let w;A.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?w=y.winx86||y.win||y.windows:A.isWindows?w=y.win||y.windows:A.isMacintosh?w=y.osx:A.isLinux&&(w=y.linux),w=w||y;const g=w.program||y.program,t=w.args||y.args,s=w.runtime||y.runtime,r=w.runtimeArgs||y.runtimeArgs;if(s)return{type:"executable",command:s,args:(r||[]).concat(typeof g=="string"?[g]:[]).concat(t||[])};if(g)return{type:"executable",command:g,args:t||[]}}}e.ExecutableDebugAdapter=v}),define(Ce[239],ke([1,0,47,33,14]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function L(p,O){return new Promise((k,E)=>{let T="";const I=o.spawn(p,O);I.pid&&I.stdout.on("data",v=>{T+=v.toString()}),I.on("error",v=>{E(v)}),I.on("close",v=>{k(T)})})}async function A(p){if(p)if(l.isWindows){const O=await new Promise((k,E)=>{ae(["@vscode/windows-process-tree"],k,E)});return new Promise(k=>{O.getProcessTree(p,E=>{k(!!E&&E.children.length>0)})})}else return L("/usr/bin/pgrep",["-lP",String(p)]).then(O=>{const k=O.trim();return!(k.length===0||k.indexOf(" tmux")>=0)},O=>!0);return Promise.resolve(!0)}e.hasChildProcesses=A;var P;(function(p){p[p.cmd=0]="cmd",p[p.powershell=1]="powershell",p[p.bash=2]="bash"})(P||(P={}));function D(p,O,k,E,T){p=p.trim().toLowerCase();let I;p.indexOf("powershell")>=0||p.indexOf("pwsh")>=0?I=1:p.indexOf("cmd.exe")>=0?I=0:p.indexOf("bash")>=0?I=2:l.isWindows?I=0:I=2;let v,i=" ";switch(I){case 1:if(v=d=>(d=d.replace(/\'/g,"''"),d.length>0&&d.charAt(d.length-1)==="\\"?`'${d}\\'`:`'${d}'`),E){const d=(0,R.getDriveLetter)(E);d&&(i+=`${d}:; `),i+=`cd ${v(E)}; `}if(T)for(const d in T){const h=T[d];h===null?i+=`Remove-Item env:${d}; `:i+=`\${env:${d}}='${h}'; `}if(O.length>0){const d=O.shift(),h=k?d:v(d);i+=h[0]==="'"?`& ${h} `:`${h} `;for(const y of O)i+=y==="<"||y===">"||k?y:v(y),i+=" "}break;case 0:if(v=d=>(d=d.replace(/\"/g,'""'),d=d.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(h=>d.includes(h))||d.length===0?`"${d}"`:d),E){const d=(0,R.getDriveLetter)(E);d&&(i+=`${d}: && `),i+=`cd ${v(E)} && `}if(T){i+='cmd /C "';for(const d in T){let h=T[d];h===null?i+=`set "${d}=" && `:(h=h.replace(/[&^|<>]/g,y=>`^${y}`),i+=`set "${d}=${h}" && `)}}for(const d of O)i+=d==="<"||d===">"||k?d:v(d),i+=" ";T&&(i+='"');break;case 2:{v=h=>(h=h.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),h.length===0?'""':h);const d=h=>/[^\w@%\/+=,.:^-]/.test(h)?`'${h.replace(/'/g,"'\\''")}'`:h;if(E&&(i+=`cd ${v(E)} ; `),T){i+="/usr/bin/env";for(const h in T){const y=T[h];y===null?i+=` -u ${d(h)}`:i+=` ${d(`${h}=${y}`)}`}i+=" "}for(const h of O)i+=h==="<"||h===">"||k?h:v(h),i+=" ";break}}return i}e.prepareCommand=D}),define(Ce[94],ke([1,0,22,39,52,89,17,15,14,44]),function(ae,e,o,R,l,L,A,P,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function(F){F[F.Markup=1]="Markup",F[F.Code=2]="Code"})(O||(e.CellKind=O={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(F){F[F.Running=1]="Running",F[F.Idle=2]="Idle"})(k||(e.NotebookRunState=k={}));var E;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(E||(e.NotebookCellExecutionState=E={}));var T;(function(F){F[F.Unconfirmed=1]="Unconfirmed",F[F.Pending=2]="Pending",F[F.Executing=3]="Executing"})(T||(e.NotebookExecutionState=T={}));var I;(function(F){F[F.WithHardKernelDependency=0]="WithHardKernelDependency",F[F.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",F[F.Pure=2]="Pure",F[F.Never=3]="Never"})(I||(e.NotebookRendererMatch=I={}));var v;(function(F){F.Always="always",F.Never="never",F.Optional="optional"})(v||(e.RendererMessagingSpec=v={}));var i;(function(F){F[F.ModelChange=1]="ModelChange",F[F.Move=2]="Move",F[F.ChangeCellLanguage=5]="ChangeCellLanguage",F[F.Initialize=6]="Initialize",F[F.ChangeCellMetadata=7]="ChangeCellMetadata",F[F.Output=8]="Output",F[F.OutputItem=9]="OutputItem",F[F.ChangeCellContent=10]="ChangeCellContent",F[F.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",F[F.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",F[F.ChangeCellMime=13]="ChangeCellMime",F[F.Unknown=100]="Unknown"})(i||(e.NotebookCellsChangeType=i={}));var d;(function(F){F[F.Handle=0]="Handle",F[F.Index=1]="Index"})(d||(e.SelectionStateType=d={}));var h;(function(F){F[F.Replace=1]="Replace",F[F.Output=2]="Output",F[F.Metadata=3]="Metadata",F[F.CellLanguage=4]="CellLanguage",F[F.DocumentMetadata=5]="DocumentMetadata",F[F.Move=6]="Move",F[F.OutputItems=7]="OutputItems",F[F.PartialMetadata=8]="PartialMetadata",F[F.PartialInternalMetadata=9]="PartialInternalMetadata"})(h||(e.CellEditType=h={}));var y;(function(F){F.scheme=A.Schemas.vscodeNotebookCell;const $=["W","X","Y","Z","a","b","c","d","e","f"],Y=new RegExp(`^[${$.join("")}]+`),_=7;function Q(x,B){const Z=B.toString(_),Se=`${Z.length<$.length?$[Z.length-1]:"z"}${Z}s${(0,o.encodeBase64)(o.VSBuffer.fromString(x.scheme),!0,!0)}`;return x.with({scheme:F.scheme,fragment:Se})}F.generate=Q;function ie(x){if(x.scheme!==F.scheme)return;const B=x.fragment.indexOf("s");if(B<0)return;const Z=parseInt(x.fragment.substring(0,B).replace(Y,""),_),pe=(0,o.decodeBase64)(x.fragment.substring(B+1)).toString();if(!isNaN(Z))return{handle:Z,notebook:x.with({scheme:pe,fragment:null})}}F.parse=ie;function oe(x,B){return x.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${B??""},${x.scheme!==A.Schemas.file?x.scheme:""}`})}F.generateCellOutputUri=oe;function Ee(x){if(x.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const B=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(x.fragment);if(!B)return;const Z=B[1]&&B[1]!==""?B[1]:void 0,pe=B[2];return{outputId:Z,notebook:x.with({scheme:pe||A.Schemas.file,fragment:null})}}F.parseCellOutputUri=Ee;function he(x,B,Z){return F.generate(x,B).with({scheme:Z})}F.generateCellPropertyUri=he;function fe(x,B){if(x.scheme===B)return F.parse(x.with({scheme:F.scheme}))}F.parseCellPropertyUri=fe})(y||(e.CellUri=y={}));const w=F=>D.isWindows?F.replace(/\//g,"\\"):F;class g{constructor($=[],Y=e.NOTEBOOK_DISPLAY_ORDER){this.e=Y,this.d=[...new Set($)].map(_=>({pattern:_,matches:R.parse(w(_))}))}sort($){const Y=new Map(l.Iterable.map($,Q=>[Q,w(Q)]));let _=[];for(const{matches:Q}of this.d)for(const[ie,oe]of Y)if(Q(oe)){_.push(ie),Y.delete(ie);break}return Y.size&&(_=_.concat([...Y.keys()].sort((Q,ie)=>this.e.indexOf(Q)-this.e.indexOf(ie)))),_}prioritize($,Y){const _=this.f($);if(_===-1){this.d.unshift({pattern:$,matches:R.parse(w($))});return}const Q=new Set(Y.map(oe=>this.f(oe,_)));Q.delete(-1);const ie=Array.from(Q).sort();this.d.splice(_+1,0,...ie.map(oe=>this.d[oe]));for(let oe=ie.length-1;oe>=0;oe--)this.d.splice(ie[oe],1)}toArray(){return this.d.map($=>$.pattern)}f($,Y=this.d.length){const _=w($);for(let Q=0;Q<Y;Q++)if(this.d[Q].matches(_))return Q;return-1}}e.MimeTypeDisplayOrder=g;function t(F,$,Y,_=(Q,ie)=>Q===ie){const Q=[];function ie(he,fe,x){if(fe===0&&x.length===0)return;const B=Q[Q.length-1];B&&B.start+B.deleteCount===he?(B.deleteCount+=fe,B.toInsert.push(...x)):Q.push({start:he,deleteCount:fe,toInsert:x})}let oe=0,Ee=0;for(;;){if(oe===F.length){ie(oe,0,$.slice(Ee));break}if(Ee===$.length){ie(oe,F.length-oe,[]);break}const he=F[oe],fe=$[Ee];if(_(he,fe)){oe+=1,Ee+=1;continue}Y(fe)?(ie(oe,1,[]),oe+=1):(ie(oe,0,[fe]),Ee+=1)}return Q}e.diff=t,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new p.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(F){F.default="default",F.option="option"})(s||(e.NotebookEditorPriority=s={}));function r(F){const $=F;return!!((typeof $.include=="string"||R.isRelativePattern($.include))&&(typeof $.exclude=="string"||R.isRelativePattern($.exclude)))}e.isDocumentExcludePattern=r;function a(F,$,Y){if(Array.isArray(F.viewType)&&F.viewType.indexOf($)>=0||F.viewType===$)return!0;if(F.filenamePattern){const _=r(F.filenamePattern)?F.filenamePattern.include:F.filenamePattern,Q=r(F.filenamePattern)?F.filenamePattern.exclude:void 0;if(R.match(_,(0,P.basename)(Y.fsPath).toLowerCase()))return!(Q&&R.match(Q,(0,P.basename)(Y.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=a,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",codeActionsOnSave:"notebook.experimental.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var b;(function(F){F[F.Left=1]="Left",F[F.Right=2]="Right"})(b||(e.CellStatusbarAlignment=b={}));class S{static create($){return`${S.d}${$}`}static parse($){if($.startsWith(S.d))return $.substring(S.d.length)}}e.NotebookWorkingCopyTypeIdentifier=S,S.d="notebook/";function c(F){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(F)}e.isTextStreamMime=c;const u=new TextDecoder;function m(F){const $=[];let Y=!1;for(const _ of F)($.length===0||Y)&&($.push(_),Y=!0);return M($),G(o.VSBuffer.concat($.map(_=>o.VSBuffer.wrap(_))))}e.compressOutputItemStreams=m;const f=`${String.fromCharCode(27)}[A`,n=f.split("").map(F=>F.charCodeAt(0)),C=10;function M(F){F.forEach(($,Y)=>{if(Y===0||$.length<f.length)return;const _=F[Y-1],Q=$.subarray(0,f.length);if(Q[0]===n[0]&&Q[1]===n[1]&&Q[2]===n[2]){const ie=_.lastIndexOf(C);if(ie===-1)return;F[Y-1]=_.subarray(0,ie),F[Y]=$.subarray(f.length)}})}function H(F){let $=F;do F=$,$=F.replace(/[^\n]\x08/gm,"");while($.length<F.length);return F}function V(F){for(F=F.replace(/\r+\n/gm,`
`);F.search(/\r[^$]/g)>-1;){const $=F.match(/^(.*)\r+/m)[1];let Y=F.match(/\r+(.*)$/m)[1];Y=Y+$.slice(Y.length,$.length),F=F.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return F}const U="\b".charCodeAt(0),z="\r".charCodeAt(0);function G(F){return!F.buffer.includes(U)&&!F.buffer.includes(z)?F:o.VSBuffer.fromString(V(H(u.decode(F.buffer))))}}),define(Ce[240],ke([1,0,4]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var R;(function(l){l[l.Output=1]="Output",l[l.OutputItems=2]="OutputItems",l[l.ExecutionState=3]="ExecutionState"})(R||(e.CellExecutionUpdateType=R={})),e.INotebookExecutionService=(0,o.createDecorator)("INotebookExecutionService")}),define(Ce[58],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(L){L.Delimiter="\0"})(o||(e.TestIdPathParts=o={}));var R;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(R||(e.TestPosition=R={}));class l{static fromExtHostTestItem(A,P,D=A.parent){if(A._isRoot)return new l([P]);const p=[A.id];for(let O=D;O&&O.id!==P;O=O.parent)p.push(O.id);return p.push(P),new l(p.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const P=A.indexOf("\0");return P===-1?A:A.slice(0,P)}static fromString(A){return new l(A.split("\0"))}static join(A,P){return new l([...A.path,P])}static joinToString(A,P){return A.toString()+"\0"+P}static parentId(A){const P=A.lastIndexOf("\0");return P===-1?void 0:A.slice(0,P)}static localId(A){const P=A.lastIndexOf("\0");return P===-1?A:A.slice(P+1)}static isChild(A,P){return P.startsWith(A)&&P[A.length]==="\0"}static compare(A,P){return A===P?0:l.isChild(A,P)?2:l.isChild(P,A)?3:1}constructor(A,P=A.length){if(this.path=A,this.d=P,A.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new l(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new l(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new l(this.path,A)}compare(A){if(typeof A=="string")return l.compare(this.toString(),A);for(let P=0;P<A.d&&P<this.d;P++)if(A.path[P]!==this.path[P])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.TestId=l}),define(Ce[77],ke([1,0,2,32,58]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(u){u[u.Unset=0]="Unset",u[u.Queued=1]="Queued",u[u.Running=2]="Running",u[u.Passed=3]="Passed",u[u.Failed=4]="Failed",u[u.Skipped=5]="Skipped",u[u.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var A;(function(u){u[u.Run=1]="Run",u[u.Debug=2]="Debug",u[u.Coverage=3]="Coverage"})(A||(e.ExtTestRunProfileKind=A={}));var P;(function(u){u[u.Run=2]="Run",u[u.Debug=4]="Debug",u[u.Coverage=8]="Coverage",u[u.HasNonDefaultProfile=16]="HasNonDefaultProfile",u[u.HasConfigurable=32]="HasConfigurable",u[u.SupportsContinuousRun=64]="SupportsContinuousRun"})(P||(e.TestRunProfileBitset=P={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const D=u=>"runId"in u;e.isStartControllerTests=D;var p;(function(u){u.serialize=m=>({range:m.range.toJSON(),uri:m.uri.toJSON()}),u.deserialize=m=>({range:R.Range.lift(m.range),uri:o.URI.revive(m.uri)})})(p||(e.IRichLocation=p={}));var O;(function(u){u[u.Error=0]="Error",u[u.Output=1]="Output"})(O||(e.TestMessageType=O={}));var k;(function(u){u.serialize=m=>({message:m.message,type:0,expected:m.expected,actual:m.actual,location:m.location&&p.serialize(m.location)}),u.deserialize=m=>({message:m.message,type:0,expected:m.expected,actual:m.actual,location:m.location&&p.deserialize(m.location)})})(k||(e.ITestErrorMessage=k={}));const E=(u,m)=>`${m?"s":"e"}${u}`;e.getMarkId=E;var T;(function(u){u.serialize=m=>({message:m.message,type:1,offset:m.offset,length:m.length,location:m.location&&p.serialize(m.location)}),u.deserialize=m=>({message:m.message,type:1,offset:m.offset,length:m.length,location:m.location&&p.deserialize(m.location)})})(T||(e.ITestOutputMessage=T={}));var I;(function(u){u.serialize=m=>m.type===0?k.serialize(m):T.serialize(m),u.deserialize=m=>m.type===0?k.deserialize(m):T.deserialize(m)})(I||(e.ITestMessage=I={}));var v;(function(u){u.serializeWithoutMessages=m=>({state:m.state,duration:m.duration,messages:[]}),u.serialize=m=>({state:m.state,duration:m.duration,messages:m.messages.map(I.serialize)}),u.deserialize=m=>({state:m.state,duration:m.duration,messages:m.messages.map(I.deserialize)})})(v||(e.ITestTaskState=v={}));const i="\0",d=(u,m)=>u+i+m;e.namespaceTestTag=d;const h=u=>{const m=u.indexOf(i);return{ctrlId:u.slice(0,m),tagId:u.slice(m+1)}};e.denamespaceTestTag=h;var y;(function(u){u.serialize=m=>({extId:m.extId,label:m.label,tags:m.tags,busy:m.busy,children:void 0,uri:m.uri?.toJSON(),range:m.range?.toJSON()||null,description:m.description,error:m.error,sortText:m.sortText}),u.deserialize=m=>({extId:m.extId,label:m.label,tags:m.tags,busy:m.busy,children:void 0,uri:m.uri?o.URI.revive(m.uri):void 0,range:m.range?R.Range.lift(m.range):null,description:m.description,error:m.error,sortText:m.sortText})})(y||(e.ITestItem=y={}));var w;(function(u){u[u.NotExpandable=0]="NotExpandable",u[u.Expandable=1]="Expandable",u[u.BusyExpanding=2]="BusyExpanding",u[u.Expanded=3]="Expanded"})(w||(e.TestItemExpandState=w={}));var g;(function(u){u.serialize=m=>({expand:m.expand,item:y.serialize(m.item)}),u.deserialize=m=>({controllerId:l.TestId.root(m.item.extId),expand:m.expand,item:y.deserialize(m.item)})})(g||(e.InternalTestItem=g={}));var t;(function(u){u.serialize=m=>{let f;return m.item&&(f={},m.item.label!==void 0&&(f.label=m.item.label),m.item.tags!==void 0&&(f.tags=m.item.tags),m.item.busy!==void 0&&(f.busy=m.item.busy),m.item.uri!==void 0&&(f.uri=m.item.uri?.toJSON()),m.item.range!==void 0&&(f.range=m.item.range?.toJSON()),m.item.description!==void 0&&(f.description=m.item.description),m.item.error!==void 0&&(f.error=m.item.error),m.item.sortText!==void 0&&(f.sortText=m.item.sortText)),{extId:m.extId,expand:m.expand,item:f}},u.deserialize=m=>{let f;return m.item&&(f={},m.item.label!==void 0&&(f.label=m.item.label),m.item.tags!==void 0&&(f.tags=m.item.tags),m.item.busy!==void 0&&(f.busy=m.item.busy),m.item.range!==void 0&&(f.range=m.item.range?R.Range.lift(m.item.range):null),m.item.description!==void 0&&(f.description=m.item.description),m.item.error!==void 0&&(f.error=m.item.error),m.item.sortText!==void 0&&(f.sortText=m.item.sortText)),{extId:m.extId,expand:m.expand,item:f}}})(t||(e.ITestItemUpdate=t={}));const s=(u,m)=>{m.expand!==void 0&&(u.expand=m.expand),m.item!==void 0&&(u.item=u.item?Object.assign(u.item,m.item):m.item)};e.applyTestItemUpdate=s;var r;(function(u){u.serializeWithoutMessages=m=>({...g.serialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(v.serializeWithoutMessages),retired:m.retired}),u.serialize=m=>({...g.serialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(v.serialize),retired:m.retired}),u.deserialize=m=>({...g.deserialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(v.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var a;(function(u){u[u.Function=0]="Function",u[u.Statement=1]="Statement"})(a||(e.DetailType=a={}));var b;(function(u){u[u.Add=0]="Add",u[u.Update=1]="Update",u[u.DocumentSynced=2]="DocumentSynced",u[u.Remove=3]="Remove",u[u.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",u[u.Retire=5]="Retire",u[u.AddTag=6]="AddTag",u[u.RemoveTag=7]="RemoveTag"})(b||(e.TestDiffOpType=b={}));var S;(function(u){u.deserialize=m=>m.op===0?{op:m.op,item:g.deserialize(m.item)}:m.op===1?{op:m.op,item:t.deserialize(m.item)}:m.op===2?{op:m.op,uri:o.URI.revive(m.uri),docv:m.docv}:m,u.serialize=m=>m.op===0?{op:m.op,item:g.serialize(m.item)}:m.op===1?{op:m.op,item:t.serialize(m.item)}:m})(S||(e.TestsDiffOp=S={}));class c{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(m){const f=this.o();for(const n of m)switch(n.op){case 0:this.j(g.deserialize(n.item),f);break;case 1:this.k(t.deserialize(n.item),f);break;case 3:this.l(n.itemId,f);break;case 5:this.m(n.itemId);break;case 4:this.updatePendingRoots(n.amount);break;case 6:this.c.set(n.tag.id,n.tag);break;case 7:this.c.delete(n.id);break}f.complete?.()}j(m,f){const n=l.TestId.parentId(m.item.extId)?.toString();let C;if(!n)C=this.p(m),this.f.add(C),this.d.set(m.item.extId,C);else if(this.d.has(n)){const M=this.d.get(n);M.children.add(m.item.extId),C=this.p(m,M),this.d.set(m.item.extId,C)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(m)}`);return}return f.add?.(C),m.expand===2&&this.g++,C}k(m,f){const n=this.d.get(m.extId);if(n)return m.expand!==void 0&&(n.expand===2&&this.g--,m.expand===2&&this.g++),(0,e.applyTestItemUpdate)(n,m),f.update?.(n),n}l(m,f){const n=this.d.get(m);if(!n)return;const C=l.TestId.parentId(n.item.extId)?.toString();C?this.d.get(C).children.delete(n.item.extId):this.f.delete(n);const M=[[m]];for(;M.length;)for(const H of M.pop()){const V=this.d.get(H);V&&(M.push(V.children),this.d.delete(H),f.remove?.(V,V!==n),V.expand===2&&this.g--)}}m(m){}updatePendingRoots(m){this.h+=m}o(){return{}}}e.AbstractIncrementalTestCollection=c}),define(Ce[95],ke([1,0,19,3,6,51,77,58]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var D;(function(h){h[h.Upsert=0]="Upsert",h[h.SetTags=1]="SetTags",h[h.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",h[h.RemoveChild=3]="RemoveChild",h[h.SetProp=4]="SetProp",h[h.Bulk=5]="Bulk",h[h.DocumentSynced=6]="DocumentSynced"})(D||(e.TestItemEventOp=D={}));const p=(h,y)=>h===y,k=Object.entries({range:(h,y)=>h===y?!0:!h||!y?!1:h.equalsRange(y),busy:p,label:p,description:p,error:p,sortText:p,tags:(h,y)=>!(h.length!==y.length||h.some(w=>!y.includes(w)))}),E=(h,y)=>{let w;for(const[g,t]of k)t(h[g],y[g])||(w?w[g]=y[g]:w={[g]:y[g]});return w};class T extends l.Disposable{get root(){return this.m.root}constructor(y){super(),this.m=y,this.f=this.B(new o.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new R.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(y){this.h=y;for(const w of this.tree.values())this.G(w)}get resolveHandler(){return this.h}collectDiff(){const y=this.k;return this.k=[],y}pushDiff(y){switch(y.op){case 2:{for(const w of this.k)if(w.op===2&&w.uri===y.uri){w.docv=y.docv;return}break}case 1:{const w=this.k[this.k.length-1];if(w){if(w.op===1&&w.item.extId===y.item.extId){(0,A.applyTestItemUpdate)(w.item,y.item);return}if(w.op===0&&w.item.item.extId===y.item.extId){(0,A.applyTestItemUpdate)(w.item,y.item);return}}break}}this.k.push(y),this.f.isScheduled()||this.f.schedule()}expand(y,w){const g=this.tree.get(y);if(g){if((g.expandLevels===void 0||w>g.expandLevels)&&(g.expandLevels=w),g.expand===1){const t=this.I(g);return t.isOpen()?this.H(g,w-1):t.wait().then(()=>this.H(g,w-1))}else if(g.expand===3)return g.resolveBarrier?.isOpen()===!1?g.resolveBarrier.wait().then(()=>this.H(g,w-1)):this.H(g,w-1)}}dispose(){for(const y of this.tree.values())this.m.getApiFor(y.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(y,w){switch(w.op){case 3:this.L(P.TestId.joinToString(y.fullId,w.id));break;case 0:this.u(w.item,y);break;case 5:for(const g of w.ops)this.p(y,g);break;case 1:this.w(w.new,w.old,y.fullId.toString());break;case 2:this.G(y);break;case 4:this.pushDiff({op:1,item:{extId:y.fullId.toString(),item:w.update}});break;case 6:this.s(y.actual.uri);break;default:(0,L.assertNever)(w)}}s(y){y&&this.pushDiff({op:2,uri:y,docv:this.m.getDocumentVersion(y)})}u(y,w){const g=P.TestId.fromExtHostTestItem(y,this.root.id,w?.actual),t=this.m.getApiFor(y);t.parent&&t.parent!==w?.actual&&this.m.getChildren(t.parent).delete(y.id);let s=this.tree.get(g.toString());if(!s){s={fullId:g,actual:y,expandLevels:w?.expandLevels?w.expandLevels-1:void 0,expand:0},y.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.C(y,w),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(y)}}),this.F(y,s,w);return}if(s.actual===y){this.D(y,s,w);return}if(s.actual.uri?.toString()!==y.uri?.toString())return this.L(g.toString()),this.u(y,w);const r=this.m.getChildren(s.actual),a=s.actual,b=E(this.m.toITestItem(a),this.m.toITestItem(y));this.m.getApiFor(a).listener=void 0,s.actual=y,s.expand=0,b&&(b.hasOwnProperty("tags")&&(this.w(y.tags,a.tags,g.toString()),delete b.tags),this.p(s,{op:4,update:b})),this.F(y,s,w);for(const[S,c]of r)this.m.getChildren(y).get(c.id)||this.L(P.TestId.joinToString(g,c.id));this.s(s.actual.uri)}w(y,w,g){const t=new Set(w.map(s=>s.id));for(const s of y)t.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:g,item:{tags:y.map(s=>(0,A.namespaceTestTag)(this.m.controllerId,s.id))}}}),t.forEach(this.z,this)}y(y){const w=this.j.get(y.id);w?w.refCount++:(this.j.set(y.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.namespaceTestTag)(this.m.controllerId,y.id)}}))}z(y){const w=this.j.get(y);w&&!--w.refCount&&(this.j.delete(y),this.pushDiff({op:7,id:(0,A.namespaceTestTag)(this.m.controllerId,y)}))}C(y,w){this.m.getApiFor(y).parent=w&&w.actual!==this.root?w.actual:void 0}D(y,w,g){this.C(y,g);const t=this.m.getApiFor(y);t.parent=g?.actual,t.listener=s=>this.p(w,s),this.G(w)}F(y,w,g){this.D(y,w,g);for(const[t,s]of this.m.getChildren(y))this.u(s,w)}G(y){let w;this.h?y.resolveBarrier?w=y.resolveBarrier.isOpen()?3:2:w=y.actual.canResolveChildren?1:0:w=0,w!==y.expand&&(y.expand=w,this.pushDiff({op:1,item:{extId:y.fullId.toString(),expand:w}}),w===1&&y.expandLevels!==void 0&&this.I(y))}H(y,w){if(w<0)return;const g=[];for(const[t,s]of this.m.getChildren(y.actual)){const r=this.expand(P.TestId.joinToString(y.fullId,s.id),w);(0,o.isThenable)(r)&&g.push(r)}if(g.length)return Promise.all(g).then(()=>{})}I(y){if(y.resolveBarrier)return y.resolveBarrier;if(!this.h){const s=new o.Barrier;return s.open(),s}y.expand=2,this.J(y);const w=y.resolveBarrier=new o.Barrier,g=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let t;try{t=this.h(y.actual===this.root?void 0:y.actual)}catch(s){g(s)}return(0,o.isThenable)(t)?t.catch(g).then(()=>{w.open(),this.G(y)}):(w.open(),this.G(y)),y.resolveBarrier}J(y){this.pushDiff({op:1,item:{extId:y.fullId.toString(),expand:y.expand}})}L(y){const w=this.tree.get(y);if(!w)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:y});const g=[w];for(;g.length;){const t=g.pop();if(t){this.m.getApiFor(t.actual).listener=void 0;for(const s of t.actual.tags)this.z(s.id);this.tree.delete(t.fullId.toString());for(const[s,r]of this.m.getChildren(t.actual))g.push(this.tree.get(P.TestId.joinToString(t.fullId,r.id)))}}}flushDiff(){const y=this.collectDiff();y.length&&this.g.fire(y)}}e.TestItemCollection=T;class I extends Error{constructor(y){super(`Attempted to insert a duplicate test item ID ${y}`)}}e.DuplicateTestItemError=I;class v extends Error{constructor(y){super(`TestItem with ID "${y}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=v;class i extends Error{constructor(y,w,g){super(`TestItem with ID "${y}" is from controller "${w}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=i;const d=(h,y,w)=>{let g=new Map;return{get size(){return g.size},forEach(t,s){for(const r of g.values())t.call(s,r,this)},[Symbol.iterator](){return g.entries()},replace(t){const s=new Map,r=new Set(g.keys()),a={op:5,ops:[]};for(const b of t){if(!(b instanceof w))throw new v(b.id);const S=y(b).controllerId;if(S!==h.controllerId)throw new i(b.id,S,h.controllerId);if(s.has(b.id))throw new I(b.id);s.set(b.id,b),r.delete(b.id),a.ops.push({op:0,item:b})}for(const b of r.keys())a.ops.push({op:3,id:b});h.listener?.(a),g=s},add(t){if(!(t instanceof w))throw new v(t.id);g.set(t.id,t),h.listener?.({op:0,item:t})},delete(t){g.delete(t)&&h.listener?.({op:3,id:t})},get(t){return g.get(t)},toJSON(){return Array.from(g.values())}}};e.createTestItemChildren=d}),define(Ce[133],ke([1,0,95]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const R=new WeakMap,l=(A,P)=>{const D={controllerId:P};return R.set(A,D),D};e.createPrivateApiFor=l;const L=A=>{const P=R.get(A);if(!P)throw new o.InvalidTestItemError(A?.id||"<unknown>");return P};e.getPrivateApiFor=L}),define(Ce[96],ke([1,0,17,2]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function l(P,D){return P.scheme===o.Schemas.http||P.scheme===o.Schemas.https?P:(D&&D.authority&&D.isRemote&&P.scheme===o.Schemas.file&&(P=R.URI.from({scheme:o.Schemas.vscodeRemote,authority:D.authority,path:P.path})),R.URI.from({scheme:o.Schemas.https,authority:`${P.scheme}+${L(P.authority)}.${e.webviewRootResourceAuthority}`,path:P.path,fragment:P.fragment,query:P.query}))}e.asWebviewUri=l;function L(P){return P.replace(/./g,D=>{const p=D.charCodeAt(0);return p>=97&&p<=122||p>=65&&p<=90||p>=48&&p<=57?D:"-"+p.toString(16).padStart(4,"0")})}function A(P){return P.replace(/-([0-9a-f]{4})/g,(D,p)=>String.fromCharCode(parseInt(p,16)))}e.decodeAuthority=A}),define(Ce[241],ke([1,0,3,6,96]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(P,D,p){this.d=P,this.e=D,this.f=p,this.a=0,this.b=new R.DisposableStore,this.c=new Map,this.b.add(D.onDidChangeVisibleTextEditors(()=>{const O=D.getVisibleTextEditors();for(const k of this.c.values())O.indexOf(k.editor)<0&&k.inset.dispose()}))}dispose(){this.c.forEach(P=>P.inset.dispose()),this.b.dispose()}createWebviewEditorInset(P,D,p,O,k){let E;for(const y of this.e.getVisibleTextEditors(!0))if(y.value===P){E=y;break}if(!E)throw new Error("not a visible editor");const T=this,I=this.a++,v=new o.Emitter,i=new o.Emitter,d=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(y){return(0,l.asWebviewUri)(y,T.f)}get cspSource(){return l.webviewGenericCspSource}set options(y){this.b=y,T.d.$setOptions(I,y)}get options(){return this.b}set html(y){this.a=y,T.d.$setHtml(I,y)}get html(){return this.a}get onDidReceiveMessage(){return v.event}postMessage(y){return T.d.$postMessage(I,y)}},h=new class{constructor(){this.editor=P,this.line=D,this.height=p,this.webview=d,this.onDidDispose=i.event}dispose(){T.c.has(I)&&(T.c.delete(I),T.d.$disposeEditorInset(I),i.fire(),i.dispose(),v.dispose())}};return this.d.$createEditorInset(I,E.id,E.value.document.uri,D+1,p,O||{},k.identifier,k.extensionLocation),this.c.set(I,{editor:P,inset:h,onDidReceiveMessage:v}),h}$onDidDispose(P){const D=this.c.get(P);D&&D.inset.dispose()}$onDidReceiveMessage(P,D){this.c.get(P)?.onDidReceiveMessage.fire(D)}}e.ExtHostEditorInsets=L}),define(Ce[242],ke([1,0,4]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,o.createDecorator)("configurationResolverService");var R;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(R||(e.VariableKind=R={}));class l extends Error{constructor(A,P){super(P),this.variable=A}}e.VariableError=l}),define(Ce[243],ke([1,0,15,36,10,23,14,114,202,242,9]),function(ae,e,o,R,l,L,A,P,D,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(T,I,v,i){this.h=new Map,this.a=T,this.b=I,this.g=v,i&&(this.c=i.then(d=>this.i(d)))}i(T){if(A.isWindows){const I=Object.create(null);return Object.keys(T).forEach(v=>{I[v.toLowerCase()]=T[v]}),I}return T}resolveWithEnvironment(T,I,v){return this.l({env:this.i(T),userHome:void 0},I?I.uri:void 0,v)}async resolveAsync(T,I){const v={env:await this.c,userHome:await this.g};return this.l(v,T?T.uri:void 0,I)}async j(T,I,v,i){const d=L.deepClone(I);A.isWindows&&d.windows?Object.keys(d.windows).forEach(y=>d[y]=d.windows[y]):A.isMacintosh&&d.osx?Object.keys(d.osx).forEach(y=>d[y]=d.osx[y]):A.isLinux&&d.linux&&Object.keys(d.linux).forEach(y=>d[y]=d.linux[y]),delete d.windows,delete d.osx,delete d.linux;const h={env:await this.c,userHome:await this.g};return this.l(h,T?T.uri:void 0,d,v,i)}async resolveAnyAsync(T,I,v){return this.j(T,I,v)}async resolveAnyMap(T,I,v){const i=new Map;return{newConfig:await this.j(T,I,v,i),resolvedVariables:i}}resolveWithInteractionReplace(T,I,v,i){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(T,I,v,i){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(T,I){if(this.h.has(T))throw new Error("Variable "+T+" is contributed twice.");this.h.set(T,I)}async l(T,I,v,i,d){if(l.isString(v))return this.m(T,I,v,i,d);if(Array.isArray(v))return Promise.all(v.map(h=>this.l(T,I,h,i,d)));if(l.isObject(v)){const h=Object.create(null),y=await Promise.all(Object.keys(v).map(async w=>[await this.m(T,I,w,i,d),await this.l(T,I,v[w],i,d)]));for(const[w,g]of y)h[w]=g;return h}return v}m(T,I,v,i,d){return(0,O.replaceAsync)(v,k.VARIABLE_REGEXP,async(h,y)=>{if(y.includes(k.VARIABLE_LHS))return h;let w=await this.o(T,h,y,I,i);return d?.set(y,w),w!==h&&l.isString(w)&&w.match(k.VARIABLE_REGEXP)&&(w=await this.m(T,I,w,i,d)),w})}n(T){return this.b?this.b.getUriLabel(T,{noPrefix:!0}):T.fsPath}async o(T,I,v,i,d){let h;const y=v.split(":");y.length>1&&(v=y[0],h=y[1]);const w=s=>{const r=this.a.getFilePath();if(r)return(0,P.normalizeDriveLetter)(r);throw new p.VariableError(s,(0,D.localize)(0,null,I))},g=s=>{const r=w(s);if(this.a.getWorkspaceFolderPathForFile){const a=this.a.getWorkspaceFolderPathForFile();if(a)return(0,P.normalizeDriveLetter)(a)}throw new p.VariableError(s,(0,D.localize)(1,null,I,o.basename(r)))},t=s=>{if(h){const r=this.a.getFolderUri(h);if(r)return r;throw new p.VariableError(s,(0,D.localize)(2,null,I,h))}if(i)return i;throw this.a.getWorkspaceFolderCount()>1?new p.VariableError(s,(0,D.localize)(3,null,I)):new p.VariableError(s,(0,D.localize)(4,null,I))};switch(v){case"env":if(h){if(T.env){const s=T.env[A.isWindows?h.toLowerCase():h];if(l.isString(s))return s}return""}throw new p.VariableError(p.VariableKind.Env,(0,D.localize)(5,null,I));case"config":if(h){const s=this.a.getConfigurationValue(i,h);if(l.isUndefinedOrNull(s))throw new p.VariableError(p.VariableKind.Config,(0,D.localize)(6,null,I,h));if(l.isObject(s))throw new p.VariableError(p.VariableKind.Config,(0,D.localize)(7,null,I,h));return s}throw new p.VariableError(p.VariableKind.Config,(0,D.localize)(8,null,I));case"command":return this.p(p.VariableKind.Command,I,h,d,"command");case"input":return this.p(p.VariableKind.Input,I,h,d,"input");case"extensionInstallFolder":if(h){const s=await this.a.getExtension(h);if(!s)throw new p.VariableError(p.VariableKind.ExtensionInstallFolder,(0,D.localize)(9,null,I,h));return this.n(s.extensionLocation)}throw new p.VariableError(p.VariableKind.ExtensionInstallFolder,(0,D.localize)(10,null,I));default:switch(v){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.n(t(p.VariableKind.WorkspaceFolder)));case"cwd":return i||h?(0,P.normalizeDriveLetter)(this.n(t(p.VariableKind.Cwd))):R.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.normalizeDriveLetter)(o.basename(this.n(t(p.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(T.userHome)return T.userHome;throw new p.VariableError(p.VariableKind.UserHome,(0,D.localize)(11,null,I))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new p.VariableError(p.VariableKind.LineNumber,(0,D.localize)(12,null,I))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new p.VariableError(p.VariableKind.SelectedText,(0,D.localize)(13,null,I))}case"file":return w(p.VariableKind.File);case"fileWorkspaceFolder":return g(p.VariableKind.FileWorkspaceFolder);case"relativeFile":return i||h?o.relative(this.n(t(p.VariableKind.RelativeFile)),w(p.VariableKind.RelativeFile)):w(p.VariableKind.RelativeFile);case"relativeFileDirname":{const s=o.dirname(w(p.VariableKind.RelativeFileDirname));if(i||h){const r=o.relative(this.n(t(p.VariableKind.RelativeFileDirname)),s);return r.length===0?".":r}return s}case"fileDirname":return o.dirname(w(p.VariableKind.FileDirname));case"fileExtname":return o.extname(w(p.VariableKind.FileExtname));case"fileBasename":return o.basename(w(p.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=o.basename(w(p.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-o.extname(s).length)}case"fileDirnameBasename":return o.basename(o.dirname(w(p.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||I}case"execInstallFolder":{const s=this.a.getAppRoot();return s||I}case"pathSeparator":return o.sep;default:try{const s=h?`${v}:${h}`:v;return this.p(p.VariableKind.Unknown,I,s,d,void 0)}catch{return I}}}}p(T,I,v,i,d){if(v&&i){const h=d===void 0?i[v]:i[d+":"+v];if(typeof h=="string")return h;throw new p.VariableError(T,(0,D.localize)(14,null,I))}return I}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Ce[134],ke([1,0,4,130]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,o.createDecorator)("editorGroupsService");var l;(function(I){I[I.UP=0]="UP",I[I.DOWN=1]="DOWN",I[I.LEFT=2]="LEFT",I[I.RIGHT=3]="RIGHT"})(l||(e.GroupDirection=l={}));var L;(function(I){I[I.HORIZONTAL=0]="HORIZONTAL",I[I.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var A;(function(I){I[I.FIRST=0]="FIRST",I[I.LAST=1]="LAST",I[I.NEXT=2]="NEXT",I[I.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var P;(function(I){I[I.MAXIMIZE=0]="MAXIMIZE",I[I.EVEN=1]="EVEN",I[I.TOGGLE=2]="TOGGLE"})(P||(e.GroupsArrangement=P={}));var D;(function(I){I[I.COPY_EDITORS=0]="COPY_EDITORS",I[I.MOVE_EDITORS=1]="MOVE_EDITORS"})(D||(e.MergeGroupMode=D={}));function p(I){const v=I;return(0,R.isEditorInput)(v?.editor)&&(0,R.isEditorInput)(v?.replacement)}e.isEditorReplacement=p;var O;(function(I){I[I.CREATION_TIME=0]="CREATION_TIME",I[I.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",I[I.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O||(e.GroupsOrder=O={}));var k;(function(I){I[I.NEW_EDITOR=1]="NEW_EDITOR",I[I.MOVE_EDITOR=2]="MOVE_EDITOR",I[I.COPY_EDITOR=3]="COPY_EDITOR"})(k||(e.OpenEditorContext=k={}));function E(I){const v=I;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.isEditorGroup=E;function T(I){return I.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=T}),define(Ce[244],ke([1,0,4,134]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,o.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function l(L){const A=L;return typeof L=="number"||(0,R.isEditorGroup)(A)}e.isPreferredGroup=l}),define(Ce[245],ke([1,0,4,208]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,o.refineServiceDecorator)(R.IEnvironmentService)}),define(Ce[135],ke([1,0,25,3,15,6]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(i){this.removedDueToLooping=i}}e.DeltaExtensionsResult=A;class P{static isHostExtension(i,d,h){if(d.getExtensionDescription(i))return!1;const y=h.getExtensionDescription(i);return y?!!((y.main||y.browser)&&y.api==="none"):!1}constructor(i,d){this.h=i,this.c=new R.Emitter,this.onDidChange=this.c.event,this.d=d,this.j()}j(){this.d.sort(T),this.e=new o.ExtensionIdentifierMap,this.f=[],this.g=new Map;for(const i of this.d){if(this.e.has(i.identifier)){console.error("Extension `"+i.identifier.value+"` is already registered");continue}this.e.set(i.identifier,i),this.f.push(i);const d=this.h.readActivationEvents(i);if(Array.isArray(d))for(let h of d)h==="onUri"&&(h=`onUri:${o.ExtensionIdentifier.toKey(i.identifier)}`),this.g.has(h)||this.g.set(h,[]),this.g.get(h).push(i)}}set(i){this.d=i,this.j(),this.c.fire(void 0)}deltaExtensions(i,d){this.d=I(this.d,d),this.d=this.d.concat(i);const h=P.k(this.d);return this.d=I(this.d,h.map(y=>y.identifier)),this.j(),this.c.fire(void 0),new A(h)}static k(i){const d=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(t){this.d.has(t)||(this.d.add(t),this.e.push(t))}addArc(t,s){this.addNode(t),this.addNode(s),this.c.has(t)?this.c.get(t).push(s):this.c.set(t,[s])}getArcs(t){return this.c.has(t)?this.c.get(t):[]}hasOnlyGoodArcs(t,s){const r=d.getArcs(t);for(let a=0;a<r.length;a++)if(!s.has(r[a]))return!1;return!0}getNodes(){return this.e}},h=new o.ExtensionIdentifierMap;for(const t of i)if(h.set(t.identifier,t),t.extensionDependencies)for(const s of t.extensionDependencies)d.addArc(o.ExtensionIdentifier.toKey(t.identifier),o.ExtensionIdentifier.toKey(s));const y=new Set;d.getNodes().filter(t=>d.getArcs(t).length===0).forEach(t=>y.add(t));const w=d.getNodes().filter(t=>!y.has(t));let g;do{g=!1;for(let t=0;t<w.length;t++){const s=w[t];d.hasOnlyGoodArcs(s,y)&&(w.splice(t,1),t--,y.add(s),g=!0)}}while(g);return w.map(t=>h.get(t))}containsActivationEvent(i){return this.g.has(i)}containsExtension(i){return this.e.has(i)}getExtensionDescriptionsForActivationEvent(i){const d=this.g.get(i);return d?d.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(i){const d=this.e.get(i);return d||void 0}getExtensionDescriptionByUUID(i){for(const d of this.f)if(d.uuid===i)return d}getExtensionDescriptionByIdOrUUID(i,d){return this.getExtensionDescription(i)??(d?this.getExtensionDescriptionByUUID(d):void 0)}}e.ExtensionDescriptionRegistry=P,e.basicActivationEventsReader={readActivationEvents:v=>v.activationEvents};class D{constructor(i){this.d=new k,this.c=new P(i,[])}async acquireLock(i){const d=await this.d.acquire(i);return new p(this,d)}deltaExtensions(i,d,h){if(!i.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(d,h)}containsActivationEvent(i){return this.c.containsActivationEvent(i)}containsExtension(i){return this.c.containsExtension(i)}getExtensionDescriptionsForActivationEvent(i){return this.c.getExtensionDescriptionsForActivationEvent(i)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(i){return this.c.getExtensionDescription(i)}getExtensionDescriptionByUUID(i){return this.c.getExtensionDescriptionByUUID(i)}getExtensionDescriptionByIdOrUUID(i,d){return this.c.getExtensionDescriptionByIdOrUUID(i,d)}}e.LockableExtensionDescriptionRegistry=D;class p extends L.Disposable{constructor(i,d){super(),this.f=i,this.c=!1,this.B(d)}isAcquiredFor(i){return!this.c&&this.f===i}}e.ExtensionDescriptionRegistryLock=p;class O{constructor(i){this.name=i,this.promise=new Promise((d,h)=>{this.c=d})}resolve(i){this.c(i)}}class k{constructor(){this.c=[],this.d=!1}async acquire(i){const d=new O(i);return this.c.push(d),this.e(),d.promise}e(){if(this.d||this.c.length===0)return;const i=this.c.shift();this.d=!0;let d=!0;const h=setTimeout(()=>{d&&console.warn(`The customer named ${i.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),y=()=>{d&&(clearTimeout(h),d=!1,this.d=!1,this.e())};i.resolve((0,L.toDisposable)(y))}}var E;(function(v){v[v.Builtin=0]="Builtin",v[v.User=1]="User",v[v.Dev=2]="Dev"})(E||(E={}));function T(v,i){const d=v.isBuiltin?0:v.isUnderDevelopment?2:1,h=i.isBuiltin?0:i.isUnderDevelopment?2:1;if(d!==h)return d-h;const y=l.posix.basename(v.extensionLocation.path),w=l.posix.basename(i.extensionLocation.path);return y<w?-1:y>w?1:0}function I(v,i){const d=new o.ExtensionIdentifierSet(i);return v.filter(h=>!d.has(h.identifier))}}),define(Ce[246],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var o;(function(O){O[O.IPC=1]="IPC",O[O.Socket=2]="Socket",O[O.MessagePort=3]="MessagePort"})(o||(e.ExtHostConnectionType=o={}));class R{constructor(k){this.pipeName=k,this.type=1}serialize(k){k[R.ENV_KEY]=this.pipeName}}e.IPCExtHostConnection=R,R.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK";class l{constructor(){this.type=2}serialize(k){k[l.ENV_KEY]="1"}}e.SocketExtHostConnection=l,l.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET";class L{constructor(){this.type=3}serialize(k){k[L.ENV_KEY]="1"}}e.MessagePortExtHostConnection=L,L.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT";function A(O){delete O[R.ENV_KEY],delete O[l.ENV_KEY],delete O[L.ENV_KEY]}function P(O,k){A(k),O.serialize(k)}e.writeExtHostConnection=P;function D(O){if(O[R.ENV_KEY])return p(O,new R(O[R.ENV_KEY]));if(O[l.ENV_KEY])return p(O,new l);if(O[L.ENV_KEY])return p(O,new L);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=D;function p(O,k){return A(O),k}}),define(Ce[97],ke([1,0,22]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var R;(function(p){p[p.Desktop=1]="Desktop",p[p.Web=2]="Web"})(R||(e.UIKind=R={}));var l;(function(p){p[p.VersionMismatch=55]="VersionMismatch",p[p.UnexpectedError=81]="UnexpectedError"})(l||(e.ExtensionHostExitCode=l={}));var L;(function(p){p[p.Initialized=0]="Initialized",p[p.Ready=1]="Ready",p[p.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function A(p){const O=o.VSBuffer.alloc(1);switch(p){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=A;function P(p,O){if(p.byteLength!==1)return!1;switch(p.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=P;var D;(function(p){p.Start="START_NATIVE_LOG",p.End="END_NATIVE_LOG"})(D||(e.NativeLogMarkers=D={}))}),define(Ce[78],ke([1,0,4,3,16,26,97,74,75,23,2,6,189]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let T=e.ExtHostTelemetry=class extends k.Disposable{constructor(d,h){super(),this.n=d,this.p=h,this.a=this.B(new R.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new R.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=O.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=h.createLogger(this.j,{id:D.extensionTelemetryLogChannelId,name:(0,E.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(h.onDidChangeLogLevel(y=>{(0,l.isLogLevel)(y)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===l.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(d,h,y){const w=this.getTelemetryDetails(),g=new I(h,y,d,this.k,this.i,this.getBuiltInCommonProperties(d),{isUsageEnabled:w.isUsageEnabled,isErrorsEnabled:w.isErrorsEnabled}),t=this.m.get(d.identifier.value)??[];return this.m.set(d.identifier.value,[...t,g]),g.apiTelemetryLogger}$initializeTelemetryLevel(d,h,y){this.f=d,this.g=h,this.c=y??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(d){const h=Object.create(null);switch(h["common.extname"]=`${d.publisher}.${d.name}`,h["common.extversion"]=d.version,h["common.vscodemachineid"]=this.n.telemetryInfo.machineId,h["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,h["common.vscodeversion"]=this.n.version,h["common.isnewappinstall"]=v(this.n.telemetryInfo.firstSessionDate),h["common.product"]=this.n.environment.appHost,this.n.uiKind){case A.UIKind.Web:h["common.uikind"]="web";break;case A.UIKind.Desktop:h["common.uikind"]="desktop";break;default:h["common.uikind"]="unknown"}return h["common.remotename"]=(0,P.getRemoteName)((0,D.cleanRemoteAuthority)(this.n.remote.authority)),h}$onDidChangeTelemetryLevel(d){this.h=this.getTelemetryConfiguration(),this.f=d;const h=this.getTelemetryDetails();this.m.forEach((y,w)=>{const g=y.filter(t=>!t.isDisposed);g.length===0?this.m.delete(w):this.m.set(w,g)}),this.m.forEach(y=>{for(const w of y)w.updateTelemetryEnablements(h.isUsageEnabled,h.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(d,h){const w=this.m.get(d.value)?.filter(t=>!t.isDisposed);if(!w)return this.m.delete(d.value),!1;let g=!1;for(const t of w)t.ignoreUnhandledExtHostErrors||(t.logError(h),g=!0);return g}};e.ExtHostTelemetry=T=xe([We(0,L.IExtHostInitDataService),We(1,l.ILoggerService)],T);class I{static validateSender(d){if(typeof d!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof d.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof d.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof d.flush<"u"&&typeof d.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(d,h,y,w,g,t,s){this.g=y,this.h=w,this.i=g,this.j=t,this.a=new R.Emitter,this.ignoreUnhandledExtHostErrors=h?.ignoreUnhandledErrors??!1,this.b=h?.ignoreBuiltInCommonProperties??!1,this.c=h?.additionalCommonProperties,this.f=d,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(d,h){this.e&&(this.d={isUsageEnabled:d,isErrorsEnabled:h},this.a.fire(this.e))}mixInCommonPropsAndCleanData(d){let h="properties"in d?d.properties??{}:d;return h=(0,D.cleanData)(h,[]),this.c&&(h=(0,p.mixin)(h,this.c)),this.b||(h=(0,p.mixin)(h,this.j)),"properties"in d?d.properties=h:d=h,d}k(d,h){this.f&&(this.g.publisher==="vscode"?d=this.g.name+"/"+d:d=this.g.identifier.value+"/"+d,h=this.mixInCommonPropsAndCleanData(h||{}),this.i||this.f?.sendEventData(d,h),this.h.trace(d,h))}logUsage(d,h){this.d.isUsageEnabled&&this.k(d,h)}logError(d,h){!this.d.isErrorsEnabled||!this.f||(typeof d=="string"?this.k(d,h):this.f.sendErrorData(d,h))}get apiTelemetryLogger(){if(!this.e){const d=this,h={logUsage:d.logUsage.bind(d),get isUsageEnabled(){return d.d.isUsageEnabled},get isErrorsEnabled(){return d.d.isErrorsEnabled},logError:d.logError.bind(d),dispose:d.dispose.bind(d),onDidChangeEnableStates:d.a.event.bind(d)};this.e=Object.freeze(h)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let d=this.f;this.f=void 0,Promise.resolve(d.flush()).then(d=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=I;function v(i){const d=Date.now()-new Date(i).getTime();return isNaN(d)?!1:d<1e3*60*60*24}e.isNewAppInstall=v,e.IExtHostTelemetry=(0,o.createDecorator)("IExtHostTelemetry")}),define(Ce[27],ke([1,0,3,2,221,128,25,4]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:R.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,P.createDecorator)("extensionService");class D{constructor(g){this.dependency=g}}e.MissingExtensionDependency=D;var p;(function(w){w[w.EagerAutoStart=1]="EagerAutoStart",w[w.EagerManualStart=2]="EagerManualStart",w[w.Lazy=3]="Lazy"})(p||(e.ExtensionHostStartup=p={}));class O{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:L.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(g,t){const s=[],r=[],a=[],b=[],S=k(this.c),c=k(g),u=(M,H)=>M.extensionLocation.toString()===H.extensionLocation.toString()||M.isBuiltin===H.isBuiltin||M.isUserBuiltin===H.isUserBuiltin||M.isUnderDevelopment===H.isUnderDevelopment;for(const M of this.c){const H=c.get(M.identifier);if(!H){s.push(M.identifier),S.delete(M.identifier);continue}if(!u(M,H)){s.push(M.identifier),S.delete(M.identifier);continue}}for(const M of g){const H=S.get(M.identifier);if(!H){r.push(M);continue}if(!u(H,M)){s.push(H.identifier),S.delete(H.identifier);continue}}const m=new A.ExtensionIdentifierSet(this.d),f=new A.ExtensionIdentifierSet(t);for(const M of this.d)f.has(M)||a.push(M);for(const M of t)m.has(M)||b.push(M);const n=L.ImplicitActivationEvents.createActivationEventsMap(r),C={toRemove:s,toAdd:r,addActivationEvents:n,myToRemove:a,myToAdd:b};return this.delta(C),C}delta(g){const{toRemove:t,toAdd:s,myToRemove:r,myToAdd:a}=g,b=new A.ExtensionIdentifierSet(t),S=new A.ExtensionIdentifierSet(r);for(let c=0;c<this.c.length;c++)b.has(this.c[c].identifier)&&(this.c.splice(c,1),c--);for(let c=0;c<this.d.length;c++)S.has(this.d[c])&&(this.d.splice(c,1),c--);for(const c of s)this.c.push(c);for(const c of a)this.d.push(c)}containsExtension(g){for(const t of this.d)if(A.ExtensionIdentifier.equals(t,g))return!0;return!1}}e.ExtensionHostExtensions=O;function k(w){const g=new A.ExtensionIdentifierMap;for(const t of w)g.set(t.identifier,t);return g}function E(w,g){return w.enabledApiProposals?w.enabledApiProposals.includes(g):!1}e.isProposedApiEnabled=E;function T(w,g){if(!E(w,g))throw new Error(`Extension '${w.identifier.value}' CANNOT use API proposal: ${g}.
Its package.json#enabledApiProposals-property declares: ${w.enabledApiProposals?.join(", ")??"[]"} but NOT ${g}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${w.identifier.value}`)}e.checkProposedApiEnabled=T;class I{constructor(g,t,s,r){this.codeLoadingTime=g,this.activateCallTime=t,this.activateResolvedTime=s,this.activationReason=r}}e.ActivationTimes=I;class v{constructor(g,t){this.description=g,this.value=t}}e.ExtensionPointContribution=v;var i;(function(w){w[w.Normal=0]="Normal",w[w.Immediate=1]="Immediate"})(i||(e.ActivationKind=i={}));function d(w){return{type:w.isBuiltin?0:1,isBuiltin:w.isBuiltin||w.isUserBuiltin,identifier:{id:(0,l.getGalleryExtensionId)(w.publisher,w.name),uuid:w.uuid},manifest:w,location:w.extensionLocation,targetPlatform:w.targetPlatform,validations:[],isValid:!0}}e.toExtension=d;function h(w,g){return{identifier:new A.ExtensionIdentifier((0,l.getExtensionId)(w.manifest.publisher,w.manifest.name)),isBuiltin:w.type===0,isUserBuiltin:w.type===1&&w.isBuiltin,isUnderDevelopment:!!g,extensionLocation:w.location,...w.manifest,uuid:w.identifier.uuid,targetPlatform:w.targetPlatform}}e.toExtensionDescription=h;class y{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None,this.onWillStop=o.Event.None,this.extensions=[]}activateByEvent(g){return Promise.resolve(void 0)}activationEventIsDone(g){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(g){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(g,t){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(g){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=y}),define(Ce[247],ke([1,0,8,135,25,27,16,19]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class D{constructor(d,h,y,w){this.startup=d,this.codeLoadingTime=h,this.activateCallTime=y,this.activateResolvedTime=w}}e.ExtensionActivationTimes=D,D.NONE=new D(!1,-1,-1,-1);class p{constructor(d){this.a=d,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(d,h){return d===-1||h===-1?-1:h-d}build(){return new D(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=p;class O{constructor(d,h,y,w,g,t){this.activationFailed=d,this.activationFailedError=h,this.activationTimes=y,this.module=w,this.exports=g,this.subscriptions=t}}e.ActivatedExtension=O;class k extends O{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class E extends O{constructor(){super(!1,null,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=E;class T extends O{constructor(d){super(!0,d,D.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let I=e.ExtensionsActivator=class{constructor(d,h,y,w){this.g=w,this.a=d,this.b=h,this.c=y,this.d=new l.ExtensionIdentifierMap,this.f=Object.create(null)}dispose(){for(const[d,h]of this.d)h.dispose()}async waitForActivatingExtensions(){const d=[];for(const[h,y]of this.d)d.push(y.wait());await Promise.all(d)}isActivated(d){const h=this.d.get(d);return!!(h&&h.value)}getActivatedExtension(d){const h=this.d.get(d);if(!h||!h.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return h.value}async activateByEvent(d,h){if(this.f[d])return;const y=this.a.getExtensionDescriptionsForActivationEvent(d);await this.h(y.map(w=>({id:w.identifier,reason:{startup:h,extensionId:w.identifier,activationEvent:d}}))),this.f[d]=!0}activateById(d,h){const y=this.a.getExtensionDescription(d);if(!y)throw new Error(`Extension '${d}' is not known`);return this.h([{id:y.identifier,reason:h}])}async h(d){const h=d.filter(y=>!this.isActivated(y.id)).map(y=>this.j(y));await Promise.all(h.map(y=>y.wait()))}j(d){if(this.d.has(d.id))return this.d.get(d.id);if(this.l(d.id))return this.k(d,null,[],null);const h=this.a.getExtensionDescription(d.id);if(!h){const g=new Error(`Cannot activate unknown extension '${d.id.value}'`),t=this.k(d,null,[],new T(g));return this.c.onExtensionActivationError(d.id,g,new L.MissingExtensionDependency(d.id.value)),t}const y=[],w=typeof h.extensionDependencies>"u"?[]:h.extensionDependencies;for(const g of w){if(this.m(g))continue;const t=this.d.get(g);if(t){y.push(t);continue}if(this.l(g)){y.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:d.reason}));continue}const s=this.a.getExtensionDescription(g);if(s){if(!s.main&&!s.browser)continue;y.push(this.j({id:s.identifier,reason:d.reason}));continue}const r=h.displayName||h.identifier.value,a=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${g}'`),b=this.k(d,h.displayName,[],new T(a));return this.c.onExtensionActivationError(h.identifier,a,new L.MissingExtensionDependency(g)),b}return this.k(d,h.displayName,y,null)}k(d,h,y,w){const g=new v(d.id,h,d.reason,y,w,this.c,this.g);return this.d.set(d.id,g),g}l(d){return R.ExtensionDescriptionRegistry.isHostExtension(d,this.a,this.b)}m(d){const h=this.b.getExtensionDescription(d);return h?!h.main&&!h.browser:!1}};e.ExtensionsActivator=I=xe([We(3,A.ILogService)],I);let v=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(d,h,y,w,g,t,s){this.c=d,this.d=h,this.f=y,this.g=w,this.h=g,this.j=t,this.k=s,this.a=new P.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let d=0;d<this.g.length;d++){const h=this.g[d];if(h.value&&!h.value.activationFailed){this.g.splice(d,1),d--;continue}if(h.value&&h.value.activationFailed){const y=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${h.friendlyName}' failed to activate`);y.detail=h.value.activationFailedError,this.h=new T(y),this.j.onExtensionActivationError(this.c,y,null);return}}this.g.length>0&&await Promise.race(this.g.map(d=>d.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(d){const h=new Error;if(d&&d.name&&(h.name=d.name),d&&d.message?h.message=`Activating extension '${this.c.value}' failed: ${d.message}.`:h.message=`Activating extension '${this.c.value}' failed: ${d}.`,d&&d.stack&&(h.stack=d.stack),this.h=new T(h),this.b&&o.isCancellationError(d))return;this.j.onExtensionActivationError(this.c,h,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(d)}}};v=xe([We(6,A.ILogService)],v)});var _e=this&&this.__classPrivateFieldSet||function(ae,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!l:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(ae,o):l?l.value=o:e.set(ae,o),o},Be=this&&this.__classPrivateFieldGet||function(ae,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!R:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(ae):R?R.value:e.get(ae)};define(Ce[7],ke([1,0,18,8,113,28,89,9,10,2,30,45,127,94,27]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I){"use strict";var v,i,d,h,y,w,g,t,s,r,a,b,S,c,u,m,f,n,C,M,H,V,U,z,G;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function F(K){return Object.assign(K,{apply:function(){const we=arguments.length===1?[]:arguments[1];return Reflect.construct(K,we,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(K,[]);{const[we,...Ae]=arguments;return Reflect.construct(K,Ae,we.constructor)}}})}var $;(function(K){K[K.Top=0]="Top",K[K.Bottom=1]="Bottom"})($||(e.TerminalOutputAnchor=$={}));var Y;(function(K){K[K.Command=0]="Command",K[K.Opener=1]="Opener"})(Y||(e.TerminalQuickFixType=Y={}));let _=e.Disposable=t=class{static from(...j){let we=j;return new t(function(){if(we){for(const Ae of we)Ae&&typeof Ae.dispose=="function"&&Ae.dispose();we=void 0}})}constructor(j){v.set(this,void 0),_e(this,v,j,"f")}dispose(){typeof Be(this,v,"f")=="function"&&(Be(this,v,"f").call(this),_e(this,v,void 0,"f"))}};v=new WeakMap,e.Disposable=_=t=xe([F],_);let Q=e.Position=s=class{static Min(...j){if(j.length===0)throw new TypeError;let we=j[0];for(let Ae=1;Ae<j.length;Ae++){const Ke=j[Ae];Ke.isBefore(we)&&(we=Ke)}return we}static Max(...j){if(j.length===0)throw new TypeError;let we=j[0];for(let Ae=1;Ae<j.length;Ae++){const Ke=j[Ae];Ke.isAfter(we)&&(we=Ke)}return we}static isPosition(j){if(!j)return!1;if(j instanceof s)return!0;const{line:we,character:Ae}=j;return typeof we=="number"&&typeof Ae=="number"}static of(j){if(j instanceof s)return j;if(this.isPosition(j))return new s(j.line,j.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(j,we){if(j<0)throw(0,R.illegalArgument)("line must be non-negative");if(we<0)throw(0,R.illegalArgument)("character must be non-negative");this.c=j,this.e=we}isBefore(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<j.e}isBeforeOrEqual(j){return this.c<j.c?!0:j.c<this.c?!1:this.e<=j.e}isAfter(j){return!this.isBeforeOrEqual(j)}isAfterOrEqual(j){return!this.isBefore(j)}isEqual(j){return this.c===j.c&&this.e===j.e}compareTo(j){return this.c<j.c?-1:this.c>j.line?1:this.e<j.e?-1:this.e>j.e?1:0}translate(j,we=0){if(j===null||we===null)throw(0,R.illegalArgument)();let Ae;return typeof j>"u"?Ae=0:typeof j=="number"?Ae=j:(Ae=typeof j.lineDelta=="number"?j.lineDelta:0,we=typeof j.characterDelta=="number"?j.characterDelta:0),Ae===0&&we===0?this:new s(this.line+Ae,this.character+we)}with(j,we=this.character){if(j===null||we===null)throw(0,R.illegalArgument)();let Ae;return typeof j>"u"?Ae=this.line:typeof j=="number"?Ae=j:(Ae=typeof j.line=="number"?j.line:this.line,we=typeof j.character=="number"?j.character:this.character),Ae===this.line&&we===this.character?this:new s(Ae,we)}toJSON(){return{line:this.line,character:this.character}}};e.Position=Q=s=xe([F],Q);let ie=e.Range=r=class{static isRange(j){return j instanceof r?!0:j?Q.isPosition(j.start)&&Q.isPosition(j.end):!1}static of(j){if(j instanceof r)return j;if(this.isRange(j))return new r(j.start,j.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(j,we,Ae,Ke){let Ze,ut;if(typeof j=="number"&&typeof we=="number"&&typeof Ae=="number"&&typeof Ke=="number"?(Ze=new Q(j,we),ut=new Q(Ae,Ke)):Q.isPosition(j)&&Q.isPosition(we)&&(Ze=Q.of(j),ut=Q.of(we)),!Ze||!ut)throw new Error("Invalid arguments");Ze.isBefore(ut)?(this.c=Ze,this.e=ut):(this.c=ut,this.e=Ze)}contains(j){return r.isRange(j)?this.contains(j.start)&&this.contains(j.end):Q.isPosition(j)?!(Q.of(j).isBefore(this.c)||this.e.isBefore(j)):!1}isEqual(j){return this.c.isEqual(j.c)&&this.e.isEqual(j.e)}intersection(j){const we=Q.Max(j.start,this.c),Ae=Q.Min(j.end,this.e);if(!we.isAfter(Ae))return new r(we,Ae)}union(j){if(this.contains(j))return this;if(j.contains(this))return j;const we=Q.Min(j.start,this.c),Ae=Q.Max(j.end,this.end);return new r(we,Ae)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(j,we=this.end){if(j===null||we===null)throw(0,R.illegalArgument)();let Ae;return j?Q.isPosition(j)?Ae=j:(Ae=j.start||this.start,we=j.end||this.end):Ae=this.start,Ae.isEqual(this.c)&&we.isEqual(this.end)?this:new r(Ae,we)}toJSON(){return[this.start,this.end]}};e.Range=ie=r=xe([F],ie);let oe=e.Selection=a=class extends ie{static isSelection(j){return j instanceof a?!0:j?ie.isRange(j)&&Q.isPosition(j.anchor)&&Q.isPosition(j.active)&&typeof j.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(j,we,Ae,Ke){let Ze,ut;if(typeof j=="number"&&typeof we=="number"&&typeof Ae=="number"&&typeof Ke=="number"?(Ze=new Q(j,we),ut=new Q(Ae,Ke)):Q.isPosition(j)&&Q.isPosition(we)&&(Ze=Q.of(j),ut=Q.of(we)),!Ze||!ut)throw new Error("Invalid arguments");super(Ze,ut),this.f=Ze,this.g=ut}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=oe=a=xe([F],oe);class Ee{constructor(j,we,Ae){if(typeof j!="string"||j.length===0)throw(0,R.illegalArgument)("host");if(typeof we!="number"||we===0||Math.round(we)!==we)throw(0,R.illegalArgument)("port");if(typeof Ae<"u"&&(typeof Ae!="string"||Ae.length===0||!/^[0-9A-Za-z_\-]+$/.test(Ae)))throw(0,R.illegalArgument)("connectionToken");this.host=j,this.port=Math.round(we),this.connectionToken=Ae}}e.ResolvedAuthority=Ee;class he extends Error{static NotAvailable(j,we){return new he(j,E.RemoteAuthorityResolverErrorCode.NotAvailable,we)}static TemporarilyNotAvailable(j){return new he(j,E.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(j,we=E.RemoteAuthorityResolverErrorCode.Unknown,Ae){super(j),this._message=j,this._code=we,this._detail=Ae,Object.setPrototypeOf(this,he.prototype)}}e.RemoteAuthorityResolverError=he;var fe;(function(K){K[K.LF=1]="LF",K[K.CRLF=2]="CRLF"})(fe||(e.EndOfLine=fe={}));var x;(function(K){K[K.Replace=1]="Replace",K[K.Append=2]="Append",K[K.Prepend=3]="Prepend"})(x||(e.EnvironmentVariableMutatorType=x={}));let B=e.TextEdit=b=class{static isTextEdit(j){return j instanceof b?!0:j?ie.isRange(j)&&typeof j.newText=="string":!1}static replace(j,we){return new b(j,we)}static insert(j,we){return b.replace(new ie(j,j),we)}static delete(j){return b.replace(j,"")}static setEndOfLine(j){const we=new b(new ie(new Q(0,0),new Q(0,0)),"");return we.newEol=j,we}get range(){return this.c}set range(j){if(j&&!ie.isRange(j))throw(0,R.illegalArgument)("range");this.c=j}get newText(){return this.e||""}set newText(j){if(j&&typeof j!="string")throw(0,R.illegalArgument)("newText");this.e=j}get newEol(){return this.f}set newEol(j){if(j&&typeof j!="number")throw(0,R.illegalArgument)("newEol");this.f=j}constructor(j,we){this.c=j,this.e=we}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.TextEdit=B=b=xe([F],B);let Z=e.NotebookEdit=S=class{static isNotebookCellEdit(j){return j instanceof S?!0:j?Yt.isNotebookRange(j)&&Array.isArray(j.newCells):!1}static replaceCells(j,we){return new S(j,we)}static insertCells(j,we){return new S(new Yt(j,j),we)}static deleteCells(j){return new S(j,[])}static updateCellMetadata(j,we){const Ae=new S(new Yt(j,j),[]);return Ae.newCellMetadata=we,Ae}static updateNotebookMetadata(j){const we=new S(new Yt(0,0),[]);return we.newNotebookMetadata=j,we}constructor(j,we){this.range=j,this.newCells=we}};e.NotebookEdit=Z=S=xe([F],Z);class pe{static isSnippetTextEdit(j){return j instanceof pe?!0:j?ie.isRange(j.range)&&ne.isSnippetString(j.snippet):!1}static replace(j,we){return new pe(j,we)}static insert(j,we){return pe.replace(new ie(j,j),we)}constructor(j,we){this.range=j,this.snippet=we}}e.SnippetTextEdit=pe;var Se;(function(K){K[K.File=1]="File",K[K.Text=2]="Text",K[K.Cell=3]="Cell",K[K.CellReplace=5]="CellReplace",K[K.Snippet=6]="Snippet"})(Se||(e.FileEditType=Se={}));let re=e.WorkspaceEdit=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(j,we,Ae,Ke){this.c.push({_type:1,from:j,to:we,options:Ae,metadata:Ke})}createFile(j,we,Ae){this.c.push({_type:1,from:void 0,to:j,options:we,metadata:Ae})}deleteFile(j,we,Ae){this.c.push({_type:1,from:j,to:void 0,options:we,metadata:Ae})}e(j,we,Ae){this.c.push({_type:3,metadata:Ae,uri:j,edit:{editType:5,metadata:we},notebookMetadata:we})}f(j,we,Ae,Ke){const Ze=we.start,ut=we.end;(Ze!==ut||Ae.length>0)&&this.c.push({_type:5,uri:j,index:Ze,count:ut-Ze,cells:Ae,metadata:Ke})}g(j,we,Ae,Ke){this.c.push({_type:3,metadata:Ke,uri:j,edit:{editType:8,index:we,metadata:Ae}})}replace(j,we,Ae,Ke){this.c.push({_type:2,uri:j,edit:new B(we,Ae),metadata:Ke})}insert(j,we,Ae,Ke){this.replace(j,new ie(we,we),Ae,Ke)}delete(j,we,Ae){this.replace(j,we,"",Ae)}has(j){return this.c.some(we=>we._type===2&&we.uri.toString()===j.toString())}set(j,we){if(we)for(const Ae of we){if(!Ae)continue;let Ke,Ze;Array.isArray(Ae)?(Ke=Ae[0],Ze=Ae[1]):Ke=Ae,Z.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(j,Ke.range.start,Ke.newCellMetadata,Ze):Ke.newNotebookMetadata?this.e(j,Ke.newNotebookMetadata,Ze):this.f(j,Ke.range,Ke.newCells,Ze):pe.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:j,range:Ke.range,edit:Ke.snippet,metadata:Ze}):this.c.push({_type:2,uri:j,edit:Ke,metadata:Ze})}else{for(let Ae=0;Ae<this.c.length;Ae++){const Ke=this.c[Ae];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===j.toString()&&(this.c[Ae]=void 0);break}}(0,o.coalesceInPlace)(this.c)}}get(j){const we=[];for(const Ae of this.c)Ae._type===2&&Ae.uri.toString()===j.toString()&&we.push(Ae.edit);return we}entries(){const j=new L.ResourceMap;for(const we of this.c)if(we._type===2){let Ae=j.get(we.uri);Ae||(Ae=[we.uri,[]],j.set(we.uri,Ae)),Ae[1].push(we.edit)}return[...j.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=re=xe([F],re);let ne=e.SnippetString=c=class{static isSnippetString(j){return j instanceof c?!0:j?typeof j.value=="string":!1}static c(j){return j.replace(/\$|}|\\/g,"\\$&")}constructor(j){this.e=1,this.value=j||""}appendText(j){return this.value+=c.c(j),this}appendTabstop(j=this.e++){return this.value+="$",this.value+=j,this}appendPlaceholder(j,we=this.e++){if(typeof j=="function"){const Ae=new c;Ae.e=this.e,j(Ae),this.e=Ae.e,j=Ae.value}else j=c.c(j);return this.value+="${",this.value+=we,this.value+=":",this.value+=j,this.value+="}",this}appendChoice(j,we=this.e++){const Ae=j.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=we,this.value+="|",this.value+=Ae,this.value+="|}",this}appendVariable(j,we){if(typeof we=="function"){const Ae=new c;Ae.e=this.e,we(Ae),this.e=Ae.e,we=Ae.value}else typeof we=="string"&&(we=we.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=j,we&&(this.value+=":",this.value+=we),this.value+="}",this}};e.SnippetString=ne=c=xe([F],ne);var de;(function(K){K[K.Unnecessary=1]="Unnecessary",K[K.Deprecated=2]="Deprecated"})(de||(e.DiagnosticTag=de={}));var ee;(function(K){K[K.Hint=3]="Hint",K[K.Information=2]="Information",K[K.Warning=1]="Warning",K[K.Error=0]="Error"})(ee||(e.DiagnosticSeverity=ee={}));let ce=e.Location=u=class{static isLocation(j){return j instanceof u?!0:j?ie.isRange(j.range)&&p.URI.isUri(j.uri):!1}constructor(j,we){if(this.uri=j,we)if(ie.isRange(we))this.range=ie.of(we);else if(Q.isPosition(we))this.range=new ie(we,we);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=ce=u=xe([F],ce);let le=e.DiagnosticRelatedInformation=class{static is(j){return j?typeof j.message=="string"&&j.location&&ie.isRange(j.location.range)&&p.URI.isUri(j.location.uri):!1}constructor(j,we){this.location=j,this.message=we}static isEqual(j,we){return j===we?!0:!j||!we?!1:j.message===we.message&&j.location.range.isEqual(we.location.range)&&j.location.uri.toString()===we.location.uri.toString()}};e.DiagnosticRelatedInformation=le=xe([F],le);let ue=e.Diagnostic=class{constructor(j,we,Ae=ee.Error){if(!ie.isRange(j))throw new TypeError("range must be set");if(!we)throw new TypeError("message must be set");this.range=j,this.message=we,this.severity=Ae}toJSON(){return{severity:ee[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(j,we){return j===we?!0:!j||!we?!1:j.message===we.message&&j.severity===we.severity&&j.code===we.code&&j.severity===we.severity&&j.source===we.source&&j.range.isEqual(we.range)&&(0,o.equals)(j.tags,we.tags)&&(0,o.equals)(j.relatedInformation,we.relatedInformation,le.isEqual)}};e.Diagnostic=ue=xe([F],ue);let N=e.Hover=class{constructor(j,we){if(!j)throw new Error("Illegal argument, contents must be defined");Array.isArray(j)?this.contents=j:this.contents=[j],this.range=we}};e.Hover=N=xe([F],N);var q;(function(K){K[K.Text=0]="Text",K[K.Read=1]="Read",K[K.Write=2]="Write"})(q||(e.DocumentHighlightKind=q={}));let J=e.DocumentHighlight=class{constructor(j,we=q.Text){this.range=j,this.kind=we}toJSON(){return{range:this.range,kind:q[this.kind]}}};e.DocumentHighlight=J=xe([F],J);var te;(function(K){K[K.File=0]="File",K[K.Module=1]="Module",K[K.Namespace=2]="Namespace",K[K.Package=3]="Package",K[K.Class=4]="Class",K[K.Method=5]="Method",K[K.Property=6]="Property",K[K.Field=7]="Field",K[K.Constructor=8]="Constructor",K[K.Enum=9]="Enum",K[K.Interface=10]="Interface",K[K.Function=11]="Function",K[K.Variable=12]="Variable",K[K.Constant=13]="Constant",K[K.String=14]="String",K[K.Number=15]="Number",K[K.Boolean=16]="Boolean",K[K.Array=17]="Array",K[K.Object=18]="Object",K[K.Key=19]="Key",K[K.Null=20]="Null",K[K.EnumMember=21]="EnumMember",K[K.Struct=22]="Struct",K[K.Event=23]="Event",K[K.Operator=24]="Operator",K[K.TypeParameter=25]="TypeParameter"})(te||(e.SymbolKind=te={}));var ve;(function(K){K[K.Deprecated=1]="Deprecated"})(ve||(e.SymbolTag=ve={}));let De=e.SymbolInformation=m=class{static validate(j){if(!j.name)throw new Error("name must not be falsy")}constructor(j,we,Ae,Ke,Ze){this.name=j,this.kind=we,this.containerName=Ze,typeof Ae=="string"&&(this.containerName=Ae),Ke instanceof ce?this.location=Ke:Ae instanceof ie&&(this.location=new ce(Ke,Ae)),m.validate(this)}toJSON(){return{name:this.name,kind:te[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=De=m=xe([F],De);let me=e.DocumentSymbol=f=class{static validate(j){if(!j.name)throw new Error("name must not be falsy");if(!j.range.contains(j.selectionRange))throw new Error("selectionRange must be contained in fullRange");j.children?.forEach(f.validate)}constructor(j,we,Ae,Ke,Ze){this.name=j,this.detail=we,this.kind=Ae,this.range=Ke,this.selectionRange=Ze,this.children=[],f.validate(this)}};e.DocumentSymbol=me=f=xe([F],me);var Te;(function(K){K[K.Invoke=1]="Invoke",K[K.Automatic=2]="Automatic"})(Te||(e.CodeActionTriggerKind=Te={}));let Pe=e.CodeAction=class{constructor(j,we){this.title=j,this.kind=we}};e.CodeAction=Pe=xe([F],Pe);let $e=e.CodeActionKind=n=class{constructor(j){this.value=j}append(j){return new n(this.value?this.value+n.c+j:j)}intersects(j){return this.contains(j)||j.contains(this)}contains(j){return this.value===j.value||j.value.startsWith(this.value+n.c)}};$e.c=".",e.CodeActionKind=$e=n=xe([F],$e),$e.Empty=new $e(""),$e.QuickFix=$e.Empty.append("quickfix"),$e.Refactor=$e.Empty.append("refactor"),$e.RefactorExtract=$e.Refactor.append("extract"),$e.RefactorInline=$e.Refactor.append("inline"),$e.RefactorMove=$e.Refactor.append("move"),$e.RefactorRewrite=$e.Refactor.append("rewrite"),$e.Source=$e.Empty.append("source"),$e.SourceOrganizeImports=$e.Source.append("organizeImports"),$e.SourceFixAll=$e.Source.append("fixAll");let Ve=e.SelectionRange=class{constructor(j,we){if(this.range=j,this.parent=we,we&&!we.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=Ve=xe([F],Ve);class et{constructor(j,we,Ae,Ke,Ze,ut){this.kind=j,this.name=we,this.detail=Ae,this.uri=Ke,this.range=Ze,this.selectionRange=ut}}e.CallHierarchyItem=et;class Ye{constructor(j,we){this.fromRanges=we,this.from=j}}e.CallHierarchyIncomingCall=Ye;class Je{constructor(j,we){this.fromRanges=we,this.to=j}}e.CallHierarchyOutgoingCall=Je;var nt;(function(K){K[K.Information=0]="Information",K[K.Warning=1]="Warning",K[K.Error=2]="Error"})(nt||(e.LanguageStatusSeverity=nt={}));let ct=e.CodeLens=class{constructor(j,we){this.range=j,this.command=we}get isResolved(){return!!this.command}};e.CodeLens=ct=xe([F],ct);let Fe=e.MarkdownString=C=class{static isMarkdownString(j){return j instanceof C?!0:j&&j.appendCodeblock&&j.appendMarkdown&&j.appendText&&j.value!==void 0}constructor(j,we=!1){i.set(this,void 0),_e(this,i,new l.MarkdownString(j,{supportThemeIcons:we}),"f")}get value(){return Be(this,i,"f").value}set value(j){Be(this,i,"f").value=j}get isTrusted(){return Be(this,i,"f").isTrusted}set isTrusted(j){Be(this,i,"f").isTrusted=j}get supportThemeIcons(){return Be(this,i,"f").supportThemeIcons}set supportThemeIcons(j){Be(this,i,"f").supportThemeIcons=j}get supportHtml(){return Be(this,i,"f").supportHtml}set supportHtml(j){Be(this,i,"f").supportHtml=j}get baseUri(){return Be(this,i,"f").baseUri}set baseUri(j){Be(this,i,"f").baseUri=j}appendText(j){return Be(this,i,"f").appendText(j),this}appendMarkdown(j){return Be(this,i,"f").appendMarkdown(j),this}appendCodeblock(j,we){return Be(this,i,"f").appendCodeblock(we??"",j),this}};i=new WeakMap,e.MarkdownString=Fe=C=xe([F],Fe);let it=e.ParameterInformation=class{constructor(j,we){this.label=j,this.documentation=we}};e.ParameterInformation=it=xe([F],it);let W=e.SignatureInformation=class{constructor(j,we){this.label=j,this.documentation=we,this.parameters=[]}};e.SignatureInformation=W=xe([F],W);let X=e.SignatureHelp=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=X=xe([F],X);var ge;(function(K){K[K.Invoke=1]="Invoke",K[K.TriggerCharacter=2]="TriggerCharacter",K[K.ContentChange=3]="ContentChange"})(ge||(e.SignatureHelpTriggerKind=ge={}));var Re;(function(K){K[K.Type=1]="Type",K[K.Parameter=2]="Parameter"})(Re||(e.InlayHintKind=Re={}));let Me=e.InlayHintLabelPart=class{constructor(j){this.value=j}};e.InlayHintLabelPart=Me=xe([F],Me);let Ge=e.InlayHint=class{constructor(j,we,Ae){this.position=j,this.label=we,this.kind=Ae}};e.InlayHint=Ge=xe([F],Ge);var je;(function(K){K[K.Invoke=0]="Invoke",K[K.TriggerCharacter=1]="TriggerCharacter",K[K.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(je||(e.CompletionTriggerKind=je={}));var tt;(function(K){K[K.Text=0]="Text",K[K.Method=1]="Method",K[K.Function=2]="Function",K[K.Constructor=3]="Constructor",K[K.Field=4]="Field",K[K.Variable=5]="Variable",K[K.Class=6]="Class",K[K.Interface=7]="Interface",K[K.Module=8]="Module",K[K.Property=9]="Property",K[K.Unit=10]="Unit",K[K.Value=11]="Value",K[K.Enum=12]="Enum",K[K.Keyword=13]="Keyword",K[K.Snippet=14]="Snippet",K[K.Color=15]="Color",K[K.File=16]="File",K[K.Reference=17]="Reference",K[K.Folder=18]="Folder",K[K.EnumMember=19]="EnumMember",K[K.Constant=20]="Constant",K[K.Struct=21]="Struct",K[K.Event=22]="Event",K[K.Operator=23]="Operator",K[K.TypeParameter=24]="TypeParameter",K[K.User=25]="User",K[K.Issue=26]="Issue"})(tt||(e.CompletionItemKind=tt={}));var pt;(function(K){K[K.Deprecated=1]="Deprecated"})(pt||(e.CompletionItemTag=pt={}));let at=e.CompletionItem=class{constructor(j,we){this.label=j,this.kind=we}toJSON(){return{label:this.label,kind:this.kind&&tt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=at=xe([F],at);let bt=e.CompletionList=class{constructor(j=[],we=!1){this.items=j,this.isIncomplete=we}};e.CompletionList=bt=xe([F],bt);let Dt=e.InlineSuggestion=class{constructor(j,we,Ae){this.insertText=j,this.range=we,this.command=Ae}};e.InlineSuggestion=Dt=xe([F],Dt);let St=e.InlineSuggestionList=class{constructor(j){this.commands=void 0,this.suppressSuggestions=void 0,this.items=j}};e.InlineSuggestionList=St=xe([F],St);var At;(function(K){K[K.Active=-1]="Active",K[K.Beside=-2]="Beside",K[K.One=1]="One",K[K.Two=2]="Two",K[K.Three=3]="Three",K[K.Four=4]="Four",K[K.Five=5]="Five",K[K.Six=6]="Six",K[K.Seven=7]="Seven",K[K.Eight=8]="Eight",K[K.Nine=9]="Nine"})(At||(e.ViewColumn=At={}));var Bt;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Bt||(e.StatusBarAlignment=Bt={}));var qt;(function(K){K[K.Off=0]="Off",K[K.On=1]="On",K[K.Relative=2]="Relative"})(qt||(e.TextEditorLineNumbersStyle=qt={}));var jt;(function(K){K[K.Manual=1]="Manual",K[K.AfterDelay=2]="AfterDelay",K[K.FocusOut=3]="FocusOut"})(jt||(e.TextDocumentSaveReason=jt={}));var Rt;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(Rt||(e.TextEditorRevealType=Rt={}));var lt;(function(K){K[K.Keyboard=1]="Keyboard",K[K.Mouse=2]="Mouse",K[K.Command=3]="Command"})(lt||(e.TextEditorSelectionChangeKind=lt={}));var vt;(function(K){K[K.Undo=1]="Undo",K[K.Redo=2]="Redo"})(vt||(e.TextDocumentChangeReason=vt={}));var Ht;(function(K){K[K.OpenOpen=0]="OpenOpen",K[K.ClosedClosed=1]="ClosedClosed",K[K.OpenClosed=2]="OpenClosed",K[K.ClosedOpen=3]="ClosedOpen"})(Ht||(e.DecorationRangeBehavior=Ht={})),function(K){function j(we){switch(we){case"keyboard":return K.Keyboard;case"mouse":return K.Mouse;case"api":return K.Command}}K.fromValue=j}(lt||(e.TextEditorSelectionChangeKind=lt={}));let zt=e.DocumentLink=class{constructor(j,we){if(we&&!p.URI.isUri(we))throw(0,R.illegalArgument)("target");if(!ie.isRange(j)||j.isEmpty)throw(0,R.illegalArgument)("range");this.range=j,this.target=we}};e.DocumentLink=zt=xe([F],zt);let Tt=e.Color=class{constructor(j,we,Ae,Ke){this.red=j,this.green=we,this.blue=Ae,this.alpha=Ke}};e.Color=Tt=xe([F],Tt);let ft=e.ColorInformation=class{constructor(j,we){if(we&&!(we instanceof Tt))throw(0,R.illegalArgument)("color");if(!ie.isRange(j)||j.isEmpty)throw(0,R.illegalArgument)("range");this.range=j,this.color=we}};e.ColorInformation=ft=xe([F],ft);let Pt=e.ColorPresentation=class{constructor(j){if(!j||typeof j!="string")throw(0,R.illegalArgument)("label");this.label=j}};e.ColorPresentation=Pt=xe([F],Pt);var Ft;(function(K){K[K.RGB=0]="RGB",K[K.HEX=1]="HEX",K[K.HSL=2]="HSL"})(Ft||(e.ColorFormat=Ft={}));var Lt;(function(K){K[K.Error=0]="Error",K[K.Warning=1]="Warning",K[K.Information=2]="Information"})(Lt||(e.SourceControlInputBoxValidationType=Lt={}));var Xe;(function(K){K[K.Unknown=0]="Unknown",K[K.Shutdown=1]="Shutdown",K[K.Process=2]="Process",K[K.User=3]="User",K[K.Extension=4]="Extension"})(Xe||(e.TerminalExitReason=Xe={}));class Le{constructor(j,we,Ae){if(this.startIndex=j,this.length=we,this.tooltip=Ae,typeof j!="number"||j<0)throw(0,R.illegalArgument)("startIndex");if(typeof we!="number"||we<1)throw(0,R.illegalArgument)("length");if(Ae!==void 0&&typeof Ae!="string")throw(0,R.illegalArgument)("tooltip")}}e.TerminalLink=Le;class Oe{constructor(j){this.uri=j}}e.TerminalQuickFixOpener=Oe;class Ie{constructor(j){this.terminalCommand=j}}e.TerminalQuickFixCommand=Ie;var se;(function(K){K[K.Panel=1]="Panel",K[K.Editor=2]="Editor"})(se||(e.TerminalLocation=se={}));class Ne{constructor(j){if(this.options=j,typeof j!="object")throw(0,R.illegalArgument)("options")}}e.TerminalProfile=Ne;var He;(function(K){K[K.Always=1]="Always",K[K.Silent=2]="Silent",K[K.Never=3]="Never"})(He||(e.TaskRevealKind=He={}));var Qe;(function(K){K[K.Shared=1]="Shared",K[K.Dedicated=2]="Dedicated",K[K.New=3]="New"})(Qe||(e.TaskPanelKind=Qe={}));let qe=e.TaskGroup=M=class{static from(j){switch(j){case"clean":return M.Clean;case"build":return M.Build;case"rebuild":return M.Rebuild;case"test":return M.Test;default:return}}constructor(j,we){if(this.label=we,typeof j!="string"||typeof we!="string")throw(0,R.illegalArgument)("name");this.c=j}get id(){return this.c}};qe.Clean=new M("clean","Clean"),qe.Build=new M("build","Build"),qe.Rebuild=new M("rebuild","Rebuild"),qe.Test=new M("test","Test"),e.TaskGroup=qe=M=xe([F],qe);function rt(K){let j="";for(let we=0;we<K.length;we++)j+=K[we].replace(/,/g,",,")+",";return j}let yt=e.ProcessExecution=class{constructor(j,we,Ae){if(typeof j!="string")throw(0,R.illegalArgument)("process");this.e=[],this.c=j,we!==void 0&&(Array.isArray(we)?(this.e=we,this.f=Ae):this.f=we)}get process(){return this.c}set process(j){if(typeof j!="string")throw(0,R.illegalArgument)("process");this.c=j}get args(){return this.e}set args(j){Array.isArray(j)||(j=[]),this.e=j}get options(){return this.f}set options(j){this.f=j}computeId(){const j=[];if(j.push("process"),this.c!==void 0&&j.push(this.c),this.e&&this.e.length>0)for(const we of this.e)j.push(we);return rt(j)}};e.ProcessExecution=yt=xe([F],yt);let wt=e.ShellExecution=class{constructor(j,we,Ae){if(this.f=[],Array.isArray(we)){if(!j)throw(0,R.illegalArgument)("command can't be undefined or null");if(typeof j!="string"&&typeof j.value!="string")throw(0,R.illegalArgument)("command");this.e=j,this.f=we,this.g=Ae}else{if(typeof j!="string")throw(0,R.illegalArgument)("commandLine");this.c=j,this.g=we}}get commandLine(){return this.c}set commandLine(j){if(typeof j!="string")throw(0,R.illegalArgument)("commandLine");this.c=j}get command(){return this.e?this.e:""}set command(j){if(typeof j!="string"&&typeof j.value!="string")throw(0,R.illegalArgument)("command");this.e=j}get args(){return this.f}set args(j){this.f=j||[]}get options(){return this.g}set options(j){this.g=j}computeId(){const j=[];if(j.push("shell"),this.c!==void 0&&j.push(this.c),this.e!==void 0&&j.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const we of this.f)j.push(typeof we=="string"?we:we.value);return rt(j)}};e.ShellExecution=wt=xe([F],wt);var ht;(function(K){K[K.Escape=1]="Escape",K[K.Strong=2]="Strong",K[K.Weak=3]="Weak"})(ht||(e.ShellQuoting=ht={}));var st;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace"})(st||(e.TaskScope=st={}));class dt{constructor(j){this.c=j}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(j){this.c=j}get callback(){return this.c}}e.CustomExecution=dt;let Nt=e.Task=H=class{constructor(j,we,Ae,Ke,Ze,ut){this.j=!1,this.k=this.definition=j;let gt;typeof we=="string"?(this.m=this.name=we,this.t=this.source=Ae,this.execution=Ke,gt=Ze,this.j=!0):we===st.Global||we===st.Workspace?(this.target=we,this.m=this.name=Ae,this.t=this.source=Ke,this.execution=Ze,gt=ut):(this.target=we,this.m=this.name=Ae,this.t=this.source=Ke,this.execution=Ze,gt=ut),typeof gt=="string"?(this.o=[gt],this.q=!0):Array.isArray(gt)?(this.o=gt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(j){this.h=j}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof yt?this.k={type:H.e,id:this.n.computeId()}:this.n instanceof wt?this.k={type:H.f,id:this.n.computeId()}:this.n instanceof dt?this.k={type:H.c,id:this.n.computeId()}:this.k={type:H.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(j){if(j==null)throw(0,R.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=j}get scope(){return this.l}set target(j){this.y(),this.l=j}get name(){return this.m}set name(j){if(typeof j!="string")throw(0,R.illegalArgument)("name");this.y(),this.m=j}get execution(){return this.n}set execution(j){j===null&&(j=void 0),this.y(),this.n=j;const we=this.k.type;(H.g===we||H.e===we||H.f===we||H.c===we)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(j){if(Array.isArray(j))this.y(),this.o=j,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(j){j!==!0&&j!==!1&&(j=!1),this.y(),this.r=j}get source(){return this.t}set source(j){if(typeof j!="string"||j.length===0)throw(0,R.illegalArgument)("source must be a string of length > 0");this.y(),this.t=j}get group(){return this.u}set group(j){j===null&&(j=void 0),this.y(),this.u=j}get detail(){return this.x}set detail(j){j===null&&(j=void 0),this.x=j}get presentationOptions(){return this.v}set presentationOptions(j){j==null&&(j=Object.create(null)),this.y(),this.v=j}get runOptions(){return this.w}set runOptions(j){j==null&&(j=Object.create(null)),this.y(),this.w=j}};Nt.c="customExecution",Nt.e="process",Nt.f="shell",Nt.g="$empty",e.Task=Nt=H=xe([F],Nt);var $t;(function(K){K[K.SourceControl=1]="SourceControl",K[K.Window=10]="Window",K[K.Notification=15]="Notification"})($t||(e.ProgressLocation=$t={}));var ai;(function(K){function j(we){const Ae=we;return(0,D.isNumber)(Ae.value)?Ae.tooltip&&!(0,D.isString)(Ae.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ae.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ae.value),!1)}K.isViewBadge=j})(ai||(e.ViewBadge=ai={}));let ri=e.TreeItem=V=class{static isTreeItem(j,we){const Ae=j;if(Ae.checkboxState!==void 0){(0,I.checkProposedApiEnabled)(we,"treeItemCheckbox");const Ke=(0,D.isNumber)(Ae.checkboxState)?Ae.checkboxState:(0,D.isObject)(Ae.checkboxState)&&(0,D.isNumber)(Ae.checkboxState.state)?Ae.checkboxState.state:void 0,Ze=!(0,D.isNumber)(Ae.checkboxState)&&(0,D.isObject)(Ae.checkboxState)?Ae.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==kt.Checked&&Ke!==kt.Unchecked||Ze!==void 0&&!(0,D.isString)(Ze))return console.log("INVALID tree item, invalid checkboxState",Ae.checkboxState),!1}if(j instanceof V)return!0;if(Ae.label!==void 0&&!(0,D.isString)(Ae.label)&&!Ae.label?.label)return console.log("INVALID tree item, invalid label",Ae.label),!1;if(Ae.id!==void 0&&!(0,D.isString)(Ae.id))return console.log("INVALID tree item, invalid id",Ae.id),!1;if(Ae.iconPath!==void 0&&!(0,D.isString)(Ae.iconPath)&&!p.URI.isUri(Ae.iconPath)&&(!Ae.iconPath||!(0,D.isString)(Ae.iconPath.id))){const Ke=Ae.iconPath;if(!Ke||!(0,D.isString)(Ke.light)&&!p.URI.isUri(Ke.light)&&!(0,D.isString)(Ke.dark)&&!p.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ae.iconPath),!1}return Ae.description!==void 0&&!(0,D.isString)(Ae.description)&&typeof Ae.description!="boolean"?(console.log("INVALID tree item, invalid description",Ae.description),!1):Ae.resourceUri!==void 0&&!p.URI.isUri(Ae.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ae.resourceUri),!1):Ae.tooltip!==void 0&&!(0,D.isString)(Ae.tooltip)&&!(Ae.tooltip instanceof Fe)?(console.log("INVALID tree item, invalid tooltip",Ae.tooltip),!1):Ae.command!==void 0&&!Ae.command.command?(console.log("INVALID tree item, invalid command",Ae.command),!1):Ae.collapsibleState!==void 0&&Ae.collapsibleState<ei.None&&Ae.collapsibleState>ei.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ae.collapsibleState),!1):Ae.contextValue!==void 0&&!(0,D.isString)(Ae.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ae.contextValue),!1):Ae.accessibilityInformation!==void 0&&!Ae.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ae.accessibilityInformation),!1):!0}constructor(j,we=ei.None){this.collapsibleState=we,p.URI.isUri(j)?this.resourceUri=j:this.label=j}};e.TreeItem=ri=V=xe([F],ri);var ei;(function(K){K[K.None=0]="None",K[K.Collapsed=1]="Collapsed",K[K.Expanded=2]="Expanded"})(ei||(e.TreeItemCollapsibleState=ei={}));var kt;(function(K){K[K.Unchecked=0]="Unchecked",K[K.Checked=1]="Checked"})(kt||(e.TreeItemCheckboxState=kt={}));let Pi=e.DataTransferItem=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(j,we){this.value=j,this.id=we??(0,O.generateUuid)()}};e.DataTransferItem=Pi=xe([F],Pi);class Ji{constructor(j,we,Ae,Ke){this.name=j,this.uri=we,this._itemId=Ae,this.c=Ke}data(){return this.c()}}e.DataTransferFile=Ji;let Ct=e.DataTransfer=class{constructor(j){d.add(this),h.set(this,new Map);for(const[we,Ae]of j??[]){const Ke=Be(this,h,"f").get(Be(this,d,"m",y).call(this,we));Ke?Ke.push(Ae):Be(this,h,"f").set(Be(this,d,"m",y).call(this,we),[Ae])}}get(j){return Be(this,h,"f").get(Be(this,d,"m",y).call(this,j))?.[0]}set(j,we){Be(this,h,"f").set(Be(this,d,"m",y).call(this,j),[we])}forEach(j,we){for(const[Ae,Ke]of Be(this,h,"f"))for(const Ze of Ke)j.call(we,Ze,Ae,this)}*[(h=new WeakMap,d=new WeakSet,Symbol.iterator)](){for(const[j,we]of Be(this,h,"f"))for(const Ae of we)yield[j,Ae]}};y=function(j){return j.toLowerCase()},e.DataTransfer=Ct=xe([F],Ct);let gi=e.DocumentDropEdit=class{constructor(j){this.insertText=j}};e.DocumentDropEdit=gi=xe([F],gi);let pi=e.DocumentPasteEdit=class{constructor(j){this.insertText=j}};e.DocumentPasteEdit=pi=xe([F],pi);let Vt=e.ThemeIcon=class{constructor(j,we){this.id=j,this.color=we}static isThemeIcon(j){return typeof j.id!="string"?(console.log("INVALID ThemeIcon, invalid id",j.id),!1):!0}};e.ThemeIcon=Vt=xe([F],Vt),Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let Ai=e.ThemeColor=class{constructor(j){this.id=j}};e.ThemeColor=Ai=xe([F],Ai);var Ri;(function(K){K[K.Global=1]="Global",K[K.Workspace=2]="Workspace",K[K.WorkspaceFolder=3]="WorkspaceFolder"})(Ri||(e.ConfigurationTarget=Ri={}));let Mt=e.RelativePattern=class{get base(){return this.c}set base(j){this.c=j,this.e=p.URI.file(j)}get baseUri(){return this.e}set baseUri(j){this.e=j,this.c=j.fsPath}constructor(j,we){if(typeof j!="string"&&(!j||!p.URI.isUri(j)&&!p.URI.isUri(j.uri)))throw(0,R.illegalArgument)("base");if(typeof we!="string")throw(0,R.illegalArgument)("pattern");typeof j=="string"?this.baseUri=p.URI.file(j):p.URI.isUri(j)?this.baseUri=j:this.baseUri=j.uri,this.pattern=we}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Mt=xe([F],Mt);const bi=new WeakMap;function _i(K,j){bi.set(K,j)}e.setBreakpointId=_i;let Xt=e.Breakpoint=class{constructor(j,we,Ae,Ke){this.enabled=typeof j=="boolean"?j:!0,typeof we=="string"&&(this.condition=we),typeof Ae=="string"&&(this.hitCondition=Ae),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=bi.get(this)??(0,O.generateUuid)()),this.c}};e.Breakpoint=Xt=xe([F],Xt);let si=e.SourceBreakpoint=class extends Xt{constructor(j,we,Ae,Ke,Ze){if(super(we,Ae,Ke,Ze),j===null)throw(0,R.illegalArgument)("location");this.location=j}};e.SourceBreakpoint=si=xe([F],si);let mt=e.FunctionBreakpoint=class extends Xt{constructor(j,we,Ae,Ke,Ze){super(we,Ae,Ke,Ze),this.functionName=j}};e.FunctionBreakpoint=mt=xe([F],mt);let Li=e.DataBreakpoint=class extends Xt{constructor(j,we,Ae,Ke,Ze,ut,gt){if(super(Ke,Ze,ut,gt),!we)throw(0,R.illegalArgument)("dataId");this.label=j,this.dataId=we,this.canPersist=Ae}};e.DataBreakpoint=Li=xe([F],Li);let Qt=e.DebugAdapterExecutable=class{constructor(j,we,Ae){this.command=j,this.args=we||[],this.options=Ae}};e.DebugAdapterExecutable=Qt=xe([F],Qt);let ti=e.DebugAdapterServer=class{constructor(j,we){this.port=j,this.host=we}};e.DebugAdapterServer=ti=xe([F],ti);let vi=e.DebugAdapterNamedPipeServer=class{constructor(j){this.path=j}};e.DebugAdapterNamedPipeServer=vi=xe([F],vi);let Oi=e.DebugAdapterInlineImplementation=class{constructor(j){this.implementation=j}};e.DebugAdapterInlineImplementation=Oi=xe([F],Oi);let Ni=e.EvaluatableExpression=class{constructor(j,we){this.range=j,this.expression=we}};e.EvaluatableExpression=Ni=xe([F],Ni);var wi;(function(K){K[K.Invoke=0]="Invoke",K[K.Automatic=1]="Automatic"})(wi||(e.InlineCompletionTriggerKind=wi={}));let Fi=e.InlineValueText=class{constructor(j,we){this.range=j,this.text=we}};e.InlineValueText=Fi=xe([F],Fi);let Ei=e.InlineValueVariableLookup=class{constructor(j,we,Ae=!0){this.range=j,this.variableName=we,this.caseSensitiveLookup=Ae}};e.InlineValueVariableLookup=Ei=xe([F],Ei);let ii=e.InlineValueEvaluatableExpression=class{constructor(j,we){this.range=j,this.expression=we}};e.InlineValueEvaluatableExpression=ii=xe([F],ii);let Mi=e.InlineValueContext=class{constructor(j,we){this.frameId=j,this.stoppedLocation=we}};e.InlineValueContext=Mi=xe([F],Mi);var ci;(function(K){K[K.Changed=1]="Changed",K[K.Created=2]="Created",K[K.Deleted=3]="Deleted"})(ci||(e.FileChangeType=ci={}));let li=e.FileSystemError=U=class extends Error{static FileExists(j){return new U(j,k.FileSystemProviderErrorCode.FileExists,U.FileExists)}static FileNotFound(j){return new U(j,k.FileSystemProviderErrorCode.FileNotFound,U.FileNotFound)}static FileNotADirectory(j){return new U(j,k.FileSystemProviderErrorCode.FileNotADirectory,U.FileNotADirectory)}static FileIsADirectory(j){return new U(j,k.FileSystemProviderErrorCode.FileIsADirectory,U.FileIsADirectory)}static NoPermissions(j){return new U(j,k.FileSystemProviderErrorCode.NoPermissions,U.NoPermissions)}static Unavailable(j){return new U(j,k.FileSystemProviderErrorCode.Unavailable,U.Unavailable)}constructor(j,we=k.FileSystemProviderErrorCode.Unknown,Ae){super(p.URI.isUri(j)?j.toString(!0):j),this.code=Ae?.name??"Unknown",(0,k.markAsFileSystemProviderError)(this,we),Object.setPrototypeOf(this,U.prototype),typeof Error.captureStackTrace=="function"&&typeof Ae=="function"&&Error.captureStackTrace(this,Ae)}};e.FileSystemError=li=U=xe([F],li);let Ui=e.FoldingRange=class{constructor(j,we,Ae){this.start=j,this.end=we,this.kind=Ae}};e.FoldingRange=Ui=xe([F],Ui);var Bi;(function(K){K[K.Comment=1]="Comment",K[K.Imports=2]="Imports",K[K.Region=3]="Region"})(Bi||(e.FoldingRangeKind=Bi={}));var ni;(function(K){K[K.Collapsed=0]="Collapsed",K[K.Expanded=1]="Expanded"})(ni||(e.CommentThreadCollapsibleState=ni={}));var zi;(function(K){K[K.Editing=0]="Editing",K[K.Preview=1]="Preview"})(zi||(e.CommentMode=zi={}));var $i;(function(K){K[K.Published=0]="Published",K[K.Draft=1]="Draft"})($i||(e.CommentState=$i={}));var Wi;(function(K){K[K.Unresolved=0]="Unresolved",K[K.Resolved=1]="Resolved"})(Wi||(e.CommentThreadState=Wi={}));class ui{constructor(j,we=[]){this.tokenTypes=j,this.tokenModifiers=we}}e.SemanticTokensLegend=ui;function Zi(K){return typeof K>"u"||(0,D.isStringArray)(K)}class Si{constructor(j){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,j){this.l=!0;for(let we=0,Ae=j.tokenTypes.length;we<Ae;we++)this.j.set(j.tokenTypes[we],we);for(let we=0,Ae=j.tokenModifiers.length;we<Ae;we++)this.k.set(j.tokenModifiers[we],we)}}push(j,we,Ae,Ke,Ze){if(typeof j=="number"&&typeof we=="number"&&typeof Ae=="number"&&typeof Ke=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this.n(j,we,Ae,Ke,Ze);if(ie.isRange(j)&&typeof we=="string"&&Zi(Ae))return this.m(j,we,Ae);throw(0,R.illegalArgument)()}m(j,we,Ae){if(!this.l)throw new Error("Legend must be provided in constructor");if(j.start.line!==j.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(we))throw new Error("`tokenType` is not in the provided legend");const Ke=j.start.line,Ze=j.start.character,ut=j.end.character-j.start.character,gt=this.j.get(we);let Wt=0;if(Ae)for(const xt of Ae){if(!this.k.has(xt))throw new Error("`tokenModifier` is not in the provided legend");const Kt=this.k.get(xt);Wt|=1<<Kt>>>0}this.n(Ke,Ze,ut,gt,Wt)}n(j,we,Ae,Ke,Ze){if(this.f&&(j<this.c||j===this.c&&we<this.e)){this.f=!1;const Wt=this.g.length/5|0;let xt=0,Kt=0;for(let Jt=0;Jt<Wt;Jt++){let _t=this.g[5*Jt],ki=this.g[5*Jt+1];_t===0?(_t=xt,ki+=Kt):_t+=xt,this.g[5*Jt]=_t,this.g[5*Jt+1]=ki,xt=_t,Kt=ki}}let ut=j,gt=we;this.f&&this.h>0&&(ut-=this.c,ut===0&&(gt-=this.e)),this.g[this.h++]=ut,this.g[this.h++]=gt,this.g[this.h++]=Ae,this.g[this.h++]=Ke,this.g[this.h++]=Ze,this.c=j,this.e=we}static o(j){const we=[],Ae=j.length/5|0;for(let gt=0;gt<Ae;gt++)we[gt]=gt;we.sort((gt,Wt)=>{const xt=j[5*gt],Kt=j[5*Wt];if(xt===Kt){const Jt=j[5*gt+1],_t=j[5*Wt+1];return Jt-_t}return xt-Kt});const Ke=new Uint32Array(j.length);let Ze=0,ut=0;for(let gt=0;gt<Ae;gt++){const Wt=5*we[gt],xt=j[Wt+0],Kt=j[Wt+1],Jt=j[Wt+2],_t=j[Wt+3],ki=j[Wt+4],yn=xt-Ze,Bn=yn===0?Kt-ut:Kt,Ti=5*gt;Ke[Ti+0]=yn,Ke[Ti+1]=Bn,Ke[Ti+2]=Jt,Ke[Ti+3]=_t,Ke[Ti+4]=ki,Ze=xt,ut=Kt}return Ke}build(j){return this.f?new yi(new Uint32Array(this.g),j):new yi(Si.o(this.g),j)}}e.SemanticTokensBuilder=Si;class yi{constructor(j,we){this.resultId=we,this.data=j}}e.SemanticTokens=yi;class en{constructor(j,we,Ae){this.start=j,this.deleteCount=we,this.data=Ae}}e.SemanticTokensEdit=en;class tn{constructor(j,we){this.resultId=we,this.edits=j}}e.SemanticTokensEdits=tn;var di;(function(K){K[K.Separate=0]="Separate",K[K.MergeWithParent=1]="MergeWithParent"})(di||(e.DebugConsoleMode=di={}));let hi=e.QuickInputButtons=class{constructor(){}};hi.Back={iconPath:new Vt("arrow-left")},e.QuickInputButtons=hi=xe([F],hi);var Di;(function(K){K[K.Separator=-1]="Separator",K[K.Default=0]="Default"})(Di||(e.QuickPickItemKind=Di={}));var ze;(function(K){K[K.Info=1]="Info",K[K.Warning=2]="Warning",K[K.Error=3]="Error"})(ze||(e.InputBoxValidationSeverity=ze={}));var Gt;(function(K){K[K.UI=1]="UI",K[K.Workspace=2]="Workspace"})(Gt||(e.ExtensionKind=Gt={}));class Hi{static validate(j){if(typeof j.badge=="string"){let we=(0,P.nextCharLength)(j.badge,0);if(we<j.badge.length&&(we+=(0,P.nextCharLength)(j.badge,we)),j.badge.length>we)throw new Error("The 'badge'-property must be undefined or a short character")}else if(j.badge&&!Vt.isThemeIcon(j.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!j.color&&!j.badge&&!j.tooltip)throw new Error("The decoration is empty");return!0}constructor(j,we,Ae){this.badge=j,this.tooltip=we,this.color=Ae}}e.FileDecoration=Hi;let Et=e.ColorTheme=class{constructor(j){this.kind=j}};e.ColorTheme=Et=xe([F],Et);var ji;(function(K){K[K.Light=1]="Light",K[K.Dark=2]="Dark",K[K.HighContrast=3]="HighContrast",K[K.HighContrastLight=4]="HighContrastLight"})(ji||(e.ColorThemeKind=ji={}));class Yt{static isNotebookRange(j){return j instanceof Yt?!0:j?typeof j.start=="number"&&typeof j.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(j,we){if(j<0)throw(0,R.illegalArgument)("start must be positive");if(we<0)throw(0,R.illegalArgument)("end must be positive");j<=we?(this.c=j,this.e=we):(this.c=we,this.e=j)}with(j){let we=this.c,Ae=this.e;return j.start!==void 0&&(we=j.start),j.end!==void 0&&(Ae=j.end),we===this.c&&Ae===this.e?this:new Yt(we,Ae)}}e.NotebookRange=Yt;class oi{static validate(j){if(typeof j.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof j.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof j.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(j){return Array.isArray(j)&&j.every(we=>oi.isNotebookCellData(we))}static isNotebookCellData(j){return!0}constructor(j,we,Ae,Ke,Ze,ut,gt){this.kind=j,this.value=we,this.languageId=Ae,this.mime=Ke,this.outputs=Ze??[],this.metadata=ut,this.executionSummary=gt,oi.validate(this)}}e.NotebookCellData=oi;class nn{constructor(j){this.cells=j}}e.NotebookData=nn;class Ut{static isNotebookCellOutputItem(j){return j instanceof Ut?!0:j?typeof j.mime=="string"&&j.data instanceof Uint8Array:!1}static error(j){const we={name:j.name,message:j.message,stack:j.stack};return Ut.json(we,"application/vnd.code.notebook.error")}static stdout(j){return Ut.text(j,"application/vnd.code.notebook.stdout")}static stderr(j){return Ut.text(j,"application/vnd.code.notebook.stderr")}static bytes(j,we="application/octet-stream"){return new Ut(j,we)}static text(j,we=A.Mimes.text){const Ae=Be(Ut,w,"f",g).encode(String(j));return new Ut(Ae,we)}static json(j,we="text/x-json"){const Ae=JSON.stringify(j,void 0,"	");return Ut.text(Ae,we)}constructor(j,we){this.data=j,this.mime=we;const Ae=(0,A.normalizeMimeType)(we,!0);if(!Ae)throw new Error(`INVALID mime type: ${we}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ae}}e.NotebookCellOutputItem=Ut,w=Ut,g={value:new TextEncoder};class fi{static isNotebookCellOutput(j){return j instanceof fi?!0:!j||typeof j!="object"?!1:typeof j.id=="string"&&Array.isArray(j.items)}static ensureUniqueMimeTypes(j,we=!1){const Ae=new Set,Ke=new Set;for(let Ze=0;Ze<j.length;Ze++){const ut=j[Ze],gt=(0,A.normalizeMimeType)(ut.mime);if(!Ae.has(gt)||(0,T.isTextStreamMime)(gt)){Ae.add(gt);continue}Ke.add(Ze),we&&console.warn(`DUPLICATED mime type '${ut.mime}' will be dropped`)}return Ke.size===0?j:j.filter((Ze,ut)=>!Ke.has(ut))}constructor(j,we,Ae){this.items=fi.ensureUniqueMimeTypes(j,!0),typeof we=="string"?(this.id=we,this.metadata=Ae):(this.id=(0,O.generateUuid)(),this.metadata=we??Ae)}}e.NotebookCellOutput=fi;var Vi;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(Vi||(e.NotebookCellKind=Vi={}));var xi;(function(K){K[K.Idle=1]="Idle",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(xi||(e.NotebookCellExecutionState=xi={}));var Ii;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})(Ii||(e.NotebookCellStatusBarAlignment=Ii={}));var qi;(function(K){K[K.Default=0]="Default",K[K.InCenter=1]="InCenter",K[K.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",K[K.AtTop=3]="AtTop"})(qi||(e.NotebookEditorRevealType=qi={}));class rn{constructor(j,we){this.text=j,this.alignment=we}}e.NotebookCellStatusBarItem=rn;var Gi;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred"})(Gi||(e.NotebookControllerAffinity=Gi={}));var Ki;(function(K){K[K.Default=1]="Default",K[K.Preferred=2]="Preferred",K[K.Hidden=-1]="Hidden"})(Ki||(e.NotebookControllerAffinity2=Ki={}));class sn{constructor(j,we=[]){this.uri=j,this.provides=(0,o.asArray)(we)}}e.NotebookRendererScript=sn;class on{constructor(j){this.label=j}}e.NotebookKernelSourceAction=on;let Xi=e.TimelineItem=class{constructor(j,we){this.label=j,this.timestamp=we}};e.TimelineItem=Xi=xe([F],Xi);var Qi;(function(K){K[K.Production=1]="Production",K[K.Development=2]="Development",K[K.Test=3]="Test"})(Qi||(e.ExtensionMode=Qi={}));var be;(function(K){K[K.Node=1]="Node",K[K.Webworker=2]="Webworker"})(be||(e.ExtensionRuntime=be={}));var ye;(function(K){K[K.Other=0]="Other",K[K.Comment=1]="Comment",K[K.String=2]="String",K[K.RegEx=3]="RegEx"})(ye||(e.StandardTokenType=ye={}));class Ue{constructor(j,we){this.ranges=j,this.wordPattern=we}}e.LinkedEditingRanges=Ue;class ot{constructor(j,we){this.c=j,this.e=we}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=ot;var It;(function(K){K[K.Queued=1]="Queued",K[K.Running=2]="Running",K[K.Passed=3]="Passed",K[K.Failed=4]="Failed",K[K.Skipped=5]="Skipped",K[K.Errored=6]="Errored"})(It||(e.TestResultState=It={}));var Ot;(function(K){K[K.Run=1]="Run",K[K.Debug=2]="Debug",K[K.Coverage=3]="Coverage"})(Ot||(e.TestRunProfileKind=Ot={}));let an=e.TestRunRequest=class{constructor(j=void 0,we=void 0,Ae=void 0,Ke=!1){this.include=j,this.exclude=we,this.profile=Ae,this.continuous=Ke}};e.TestRunRequest=an=xe([F],an);let ln=e.TestRunRequest2=class extends an{};e.TestRunRequest2=ln=xe([F],ln);let un=e.TestMessage=z=class{static diff(j,we,Ae){const Ke=new z(j);return Ke.expectedOutput=we,Ke.actualOutput=Ae,Ke}constructor(j){this.message=j}};e.TestMessage=un=z=xe([F],un);let dn=e.TestTag=class{constructor(j){this.id=j}};e.TestTag=dn=xe([F],dn);let Ci=e.CoveredCount=class{constructor(j,we){this.covered=j,this.total=we}};e.CoveredCount=Ci=xe([F],Ci);let hn=e.FileCoverage=G=class{static fromDetails(j,we){const Ae=new Ci(0,0),Ke=new Ci(0,0),Ze=new Ci(0,0);for(const gt of we)if("branches"in gt){Ae.total+=1,Ae.covered+=gt.executionCount>0?1:0;for(const Wt of gt.branches)Ke.total+=1,Ke.covered+=Wt.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=gt.executionCount>0?1:0;const ut=new G(j,Ae,Ke.total>0?Ke:void 0,Ze.total>0?Ze:void 0);return ut.detailedCoverage=we,ut}constructor(j,we,Ae,Ke){this.uri=j,this.statementCoverage=we,this.branchCoverage=Ae,this.functionCoverage=Ke}};e.FileCoverage=hn=G=xe([F],hn);let fn=e.StatementCoverage=class{constructor(j,we,Ae=[]){this.executionCount=j,this.location=we,this.branches=Ae}};e.StatementCoverage=fn=xe([F],fn);let mn=e.BranchCoverage=class{constructor(j,we){this.executionCount=j,this.location=we}};e.BranchCoverage=mn=xe([F],mn);let gn=e.FunctionCoverage=class{constructor(j,we){this.executionCount=j,this.location=we}};e.FunctionCoverage=gn=xe([F],gn);var pn;(function(K){K[K.None=0]="None",K[K.Option=1]="Option",K[K.Default=2]="Default",K[K.Preferred=3]="Preferred"})(pn||(e.ExternalUriOpenerPriority=pn={}));var bn;(function(K){K[K.Untrusted=0]="Untrusted",K[K.Trusted=1]="Trusted",K[K.Unspecified=2]="Unspecified"})(bn||(e.WorkspaceTrustState=bn={}));var vn;(function(K){K[K.Notify=1]="Notify",K[K.OpenBrowser=2]="OpenBrowser",K[K.OpenPreview=3]="OpenPreview",K[K.Silent=4]="Silent",K[K.Ignore=5]="Ignore",K[K.OpenBrowserOnce=6]="OpenBrowserOnce"})(vn||(e.PortAutoForwardAction=vn={}));class Tn{constructor(j,we,Ae,Ke,Ze,ut){this.kind=j,this.name=we,this.detail=Ae,this.uri=Ke,this.range=Ze,this.selectionRange=ut}}e.TypeHierarchyItem=Tn;class Pn{constructor(j){this.uri=j}}e.TextTabInput=Pn;class An{constructor(j,we){this.original=j,this.modified=we}}e.TextDiffTabInput=An;class Rn{constructor(j,we,Ae,Ke){this.base=j,this.input1=we,this.input2=Ae,this.result=Ke}}e.TextMergeTabInput=Rn;class Ln{constructor(j,we){this.uri=j,this.viewType=we}}e.CustomEditorTabInput=Ln;class On{constructor(j){this.viewType=j}}e.WebviewEditorTabInput=On;class Nn{constructor(j,we){this.uri=j,this.notebookType=we}}e.NotebookEditorTabInput=Nn;class Fn{constructor(j,we,Ae){this.original=j,this.modified=we,this.notebookType=Ae}}e.NotebookDiffEditorTabInput=Fn;class Mn{constructor(){}}e.TerminalEditorTabInput=Mn;class Un{constructor(j,we){this.uri=j,this.inputBoxUri=we}}e.InteractiveWindowInput=Un;var wn;(function(K){K[K.Up=1]="Up",K[K.Down=2]="Down"})(wn||(e.InteractiveSessionVoteDirection=wn={}));var En;(function(K){K[K.Action=1]="Action",K[K.Toolbar=2]="Toolbar"})(En||(e.InteractiveSessionCopyKind=En={}));var Sn;(function(K){K[K.Unhelpful=0]="Unhelpful",K[K.Helpful=1]="Helpful",K[K.Undone=2]="Undone"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}))}),define(Ce[136],ke([1,0,51,17,9,168,107,7,18]),function(ae,e,o,R,l,L,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const p=new Map;function O(I,v){v?p.set(I,v):p.delete(I)}e.setWordDefinitionFor=O;function k(I){return p.get(I)}class E extends L.MirrorTextModel{constructor(v,i,d,h,y,w,g,t){super(i,d,h,y),this.c=v,this.m=w,this.q=g,this.notebook=t,this.b=!1}dispose(){(0,o.ok)(!this.b),this.b=!0,this.q=!1}equalLines(v){return(0,D.equals)(this.f,v)}get document(){if(!this.a){const v=this;this.a={get uri(){return v.d},get fileName(){return v.d.fsPath},get isUntitled(){return v.d.scheme===R.Schemas.untitled},get languageId(){return v.m},get version(){return v.h},get isClosed(){return v.b},get isDirty(){return v.q},save(){return v.r()},getText(i){return i?v.s(i):v.getText()},get eol(){return v.g===`
`?P.EndOfLine.LF:P.EndOfLine.CRLF},get lineCount(){return v.f.length},lineAt(i){return v.t(i)},offsetAt(i){return v.u(i)},positionAt(i){return v.v(i)},validateRange(i){return v.w(i)},validatePosition(i){return v.x(i)},getWordRangeAtPosition(i,d){return v.y(i,d)}}}return Object.freeze(this.a)}_acceptLanguageId(v){(0,o.ok)(!this.b),this.m=v}_acceptIsDirty(v){(0,o.ok)(!this.b),this.q=v}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(v){const i=this.w(v);if(i.isEmpty)return"";if(i.isSingleLine)return this.f[i.start.line].substring(i.start.character,i.end.character);const d=this.g,h=i.start.line,y=i.end.line,w=[];w.push(this.f[h].substring(i.start.character));for(let g=h+1;g<y;g++)w.push(this.f[g]);return w.push(this.f[y].substring(0,i.end.character)),w.join(d)}t(v){let i;if(v instanceof P.Position?i=v.line:typeof v=="number"&&(i=v),typeof i!="number"||i<0||i>=this.f.length||Math.floor(i)!==i)throw new Error("Illegal value for `line`");return new T(i,this.f[i],i===this.f.length-1)}u(v){return v=this.x(v),this.l(),this.j.getPrefixSum(v.line-1)+v.character}v(v){v=Math.floor(v),v=Math.max(0,v),this.l();const i=this.j.getIndexOf(v),d=this.f[i.index].length;return new P.Position(i.index,Math.min(i.remainder,d))}w(v){if(!(v instanceof P.Range))throw new Error("Invalid argument");const i=this.x(v.start),d=this.x(v.end);return i===v.start&&d===v.end?v:new P.Range(i.line,i.character,d.line,d.character)}x(v){if(!(v instanceof P.Position))throw new Error("Invalid argument");if(this.f.length===0)return v.with(0,0);let{line:i,character:d}=v,h=!1;if(i<0)i=0,d=0,h=!0;else if(i>=this.f.length)i=this.f.length-1,d=this.f[i].length,h=!0;else{const y=this.f[i].length;d<0?(d=0,h=!0):d>y&&(d=y,h=!0)}return h?new P.Position(i,d):v}y(v,i){const d=this.x(v);if(!i)i=k(this.m);else if((0,l.regExpLeadsToEndlessLoop)(i))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${i.source}' because it matches the empty string.`);const h=(0,A.getWordAtText)(d.character+1,(0,A.ensureValidWordDefinition)(i),this.f[d.line],0);if(h)return new P.Range(d.line,h.startColumn-1,d.line,h.endColumn-1)}}e.ExtHostDocumentData=E;class T{constructor(v,i,d){this.a=v,this.b=i,this.c=d}get lineNumber(){return this.a}get text(){return this.b}get range(){return new P.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new P.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=T}),define(Ce[248],ke([1,0,7,20,3]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=e.ExtHostTheming=class{constructor(P){this.a=new o.ColorTheme(o.ColorThemeKind.Dark),this.b=new l.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(P){let D;switch(P){case"light":D=o.ColorThemeKind.Light;break;case"hcDark":D=o.ColorThemeKind.HighContrast;break;case"hcLight":D=o.ColorThemeKind.HighContrastLight;break;default:D=o.ColorThemeKind.Dark}this.a=new o.ColorTheme(D),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.ExtHostTheming=L=xe([We(0,R.IExtHostRpcService)],L)}),define(Ce[11],ke([1,0,18,22,151,64,113,28,149,70,89,23,10,2,32,73,123,133,130,94,58,77,244,7]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d,h,y,w,g,t,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveSessionFollowup=e.InteractiveSessionReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Le){function Oe(se){const{selectionStartLineNumber:Ne,selectionStartColumn:He,positionLineNumber:Qe,positionColumn:qe}=se,rt=new s.Position(Ne-1,He-1),yt=new s.Position(Qe-1,qe-1);return new s.Selection(rt,yt)}Le.to=Oe;function Ie(se){const{anchor:Ne,active:He}=se;return{selectionStartLineNumber:Ne.line+1,selectionStartColumn:Ne.character+1,positionLineNumber:He.line+1,positionColumn:He.character+1}}Le.from=Ie})(r||(e.Selection=r={}));var a;(function(Le){function Oe(se){if(!se)return;const{start:Ne,end:He}=se;return{startLineNumber:Ne.line+1,startColumn:Ne.character+1,endLineNumber:He.line+1,endColumn:He.character+1}}Le.from=Oe;function Ie(se){if(!se)return;const{startLineNumber:Ne,startColumn:He,endLineNumber:Qe,endColumn:qe}=se;return new s.Range(Ne-1,He-1,Qe-1,qe-1)}Le.to=Ie})(a||(e.Range=a={}));var b;(function(Le){function Oe(Ie){switch(Ie){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Le.to=Oe})(b||(e.TokenType=b={}));var S;(function(Le){function Oe(se){return new s.Position(se.lineNumber-1,se.column-1)}Le.to=Oe;function Ie(se){return{lineNumber:se.line+1,column:se.character+1}}Le.from=Ie})(S||(e.Position=S={}));var c;(function(Le){function Oe(Ne,He,Qe){return(0,o.coalesce)((0,o.asArray)(Ne).map(qe=>Ie(qe,He,Qe)))}Le.from=Oe;function Ie(Ne,He,Qe){if(typeof Ne=="string")return{$serialized:!0,language:Ne,isBuiltin:Qe?.isBuiltin};if(Ne)return{$serialized:!0,language:Ne.language,scheme:se(Ne.scheme,He),pattern:X.from(Ne.pattern)??void 0,exclusive:Ne.exclusive,notebookType:Ne.notebookType,isBuiltin:Qe?.isBuiltin}}function se(Ne,He){return He&&typeof Ne=="string"?He.transformOutgoingScheme(Ne):Ne}})(c||(e.DocumentSelector=c={}));var u;(function(Le){function Oe(se){switch(se){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Le.from=Oe;function Ie(se){switch(se){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Le.to=Ie})(u||(e.DiagnosticTag=u={}));var m;(function(Le){function Oe(se){let Ne;return se.code&&((0,E.isString)(se.code)||(0,E.isNumber)(se.code)?Ne=String(se.code):Ne={value:String(se.code.value),target:se.code.target}),{...a.from(se.range),message:se.message,source:se.source,code:Ne,severity:n.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(f.from),tags:Array.isArray(se.tags)?(0,o.coalesce)(se.tags.map(u.from)):void 0}}Le.from=Oe;function Ie(se){const Ne=new s.Diagnostic(a.to(se),se.message,n.to(se.severity));return Ne.source=se.source,Ne.code=(0,E.isString)(se.code)?se.code:se.code?.value,Ne.relatedInformation=se.relatedInformation&&se.relatedInformation.map(f.to),Ne.tags=se.tags&&(0,o.coalesce)(se.tags.map(u.to)),Ne}Le.to=Ie})(m||(e.Diagnostic=m={}));var f;(function(Le){function Oe(se){return{...a.from(se.location.range),message:se.message,resource:se.location.uri}}Le.from=Oe;function Ie(se){return new s.DiagnosticRelatedInformation(new s.Location(se.resource,a.to(se)),se.message)}Le.to=Ie})(f||(e.DiagnosticRelatedInformation=f={}));var n;(function(Le){function Oe(se){switch(se){case s.DiagnosticSeverity.Error:return i.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return i.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return i.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return i.MarkerSeverity.Hint}return i.MarkerSeverity.Error}Le.from=Oe;function Ie(se){switch(se){case i.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case i.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case i.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case i.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Le.to=Ie})(n||(e.DiagnosticSeverity=n={}));var C;(function(Le){function Oe(se){return typeof se=="number"&&se>=s.ViewColumn.One?se-1:se===s.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Le.from=Oe;function Ie(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Le.to=Ie})(C||(e.ViewColumn=C={}));function M(Le){return typeof Le.range<"u"}function H(Le){return Le.length===0?!0:!!M(Le[0])}e.isDecorationOptionsArr=H;var V;(function(Le){function Oe(qe){return qe.map(Le.from)}Le.fromMany=Oe;function Ie(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function se(qe){let rt;if(Ie(qe)){const{language:st,value:dt}=qe;rt={value:"```"+st+`
`+dt+"\n```\n"}}else s.MarkdownString.isMarkdownString(qe)?rt={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?rt={value:qe}:rt={value:""};const yt=Object.create(null);rt.uris=yt;const wt=st=>{try{let dt=T.URI.parse(st,!0);dt=dt.with({query:Ne(dt.query,yt)}),yt[st]=dt}catch{}return""},ht=new D.marked.Renderer;return ht.link=wt,ht.image=st=>typeof st=="string"?wt(A.parseHrefAndDimensions(st).href):"",(0,D.marked)(rt.value,{renderer:ht}),rt}Le.from=se;function Ne(qe,rt){if(!qe)return qe;let yt;try{yt=(0,p.parse)(qe)}catch{}if(!yt)return qe;let wt=!1;return yt=(0,k.cloneAndChange)(yt,ht=>{if(T.URI.isUri(ht)){const st=`__uri_${Math.random().toString(16).slice(2,8)}`;return rt[st]=ht,wt=!0,st}else return}),wt?JSON.stringify(yt):qe}function He(qe){const rt=new s.MarkdownString(qe.value,qe.supportThemeIcons);return rt.isTrusted=qe.isTrusted,rt.supportHtml=qe.supportHtml,rt.baseUri=qe.baseUri?T.URI.from(qe.baseUri):void 0,rt}Le.to=He;function Qe(qe){if(qe)return typeof qe=="string"?qe:Le.from(qe)}Le.fromStrict=Qe})(V||(e.MarkdownString=V={}));function U(Le){return H(Le)?Le.map(Oe=>({range:a.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?V.fromMany(Oe.hoverMessage):Oe.hoverMessage?V.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Le.map(Oe=>({range:a.from(Oe)}))}e.fromRangeOrRangeWithMessage=U;function z(Le){return typeof Le>"u"?Le:typeof Le=="string"?T.URI.file(Le):Le}e.pathOrURIToURI=z;var G;(function(Le){function Oe(Ie){return typeof Ie>"u"?Ie:{contentText:Ie.contentText,contentIconPath:Ie.contentIconPath?z(Ie.contentIconPath):void 0,border:Ie.border,borderColor:Ie.borderColor,fontStyle:Ie.fontStyle,fontWeight:Ie.fontWeight,textDecoration:Ie.textDecoration,color:Ie.color,backgroundColor:Ie.backgroundColor,margin:Ie.margin,width:Ie.width,height:Ie.height}}Le.from=Oe})(G||(e.ThemableDecorationAttachmentRenderOptions=G={}));var F;(function(Le){function Oe(Ie){return typeof Ie>"u"?Ie:{backgroundColor:Ie.backgroundColor,outline:Ie.outline,outlineColor:Ie.outlineColor,outlineStyle:Ie.outlineStyle,outlineWidth:Ie.outlineWidth,border:Ie.border,borderColor:Ie.borderColor,borderRadius:Ie.borderRadius,borderSpacing:Ie.borderSpacing,borderStyle:Ie.borderStyle,borderWidth:Ie.borderWidth,fontStyle:Ie.fontStyle,fontWeight:Ie.fontWeight,textDecoration:Ie.textDecoration,cursor:Ie.cursor,color:Ie.color,opacity:Ie.opacity,letterSpacing:Ie.letterSpacing,gutterIconPath:Ie.gutterIconPath?z(Ie.gutterIconPath):void 0,gutterIconSize:Ie.gutterIconSize,overviewRulerColor:Ie.overviewRulerColor,before:Ie.before?G.from(Ie.before):void 0,after:Ie.after?G.from(Ie.after):void 0}}Le.from=Oe})(F||(e.ThemableDecorationRenderOptions=F={}));var $;(function(Le){function Oe(Ie){if(typeof Ie>"u")return Ie;switch(Ie){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Le.from=Oe})($||(e.DecorationRangeBehavior=$={}));var Y;(function(Le){function Oe(Ie){return{isWholeLine:Ie.isWholeLine,rangeBehavior:Ie.rangeBehavior?$.from(Ie.rangeBehavior):void 0,overviewRulerLane:Ie.overviewRulerLane,light:Ie.light?F.from(Ie.light):void 0,dark:Ie.dark?F.from(Ie.dark):void 0,backgroundColor:Ie.backgroundColor,outline:Ie.outline,outlineColor:Ie.outlineColor,outlineStyle:Ie.outlineStyle,outlineWidth:Ie.outlineWidth,border:Ie.border,borderColor:Ie.borderColor,borderRadius:Ie.borderRadius,borderSpacing:Ie.borderSpacing,borderStyle:Ie.borderStyle,borderWidth:Ie.borderWidth,fontStyle:Ie.fontStyle,fontWeight:Ie.fontWeight,textDecoration:Ie.textDecoration,cursor:Ie.cursor,color:Ie.color,opacity:Ie.opacity,letterSpacing:Ie.letterSpacing,gutterIconPath:Ie.gutterIconPath?z(Ie.gutterIconPath):void 0,gutterIconSize:Ie.gutterIconSize,overviewRulerColor:Ie.overviewRulerColor,before:Ie.before?G.from(Ie.before):void 0,after:Ie.after?G.from(Ie.after):void 0}}Le.from=Oe})(Y||(e.DecorationRenderOptions=Y={}));var _;(function(Le){function Oe(se){return{text:se.newText,eol:se.newEol&&nt.from(se.newEol),range:a.from(se.range)}}Le.from=Oe;function Ie(se){const Ne=new s.TextEdit(a.to(se.range),se.text);return Ne.newEol=typeof se.eol>"u"?void 0:nt.to(se.eol),Ne}Le.to=Ie})(_||(e.TextEdit=_={}));var Q;(function(Le){function Oe(se,Ne){const He={edits:[]};if(se instanceof s.WorkspaceEdit){const Qe=new P.ResourceSet;for(const qe of se._allEntries())qe._type===1&&T.URI.isUri(qe.to)&&qe.from===void 0&&Qe.add(qe.to);for(const qe of se._allEntries())if(qe._type===1){let rt;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?rt={type:"base64",value:(0,R.encodeBase64)(R.VSBuffer.wrap(qe.options.contents))}:rt={type:"dataTransferItem",id:qe.options.contents._itemId}),He.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:rt},metadata:qe.metadata})}else qe._type===2?He.edits.push({resource:qe.uri,textEdit:_.from(qe.edit),versionId:Qe.has(qe.uri)?void 0:Ne?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?He.edits.push({resource:qe.uri,textEdit:{range:a.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Qe.has(qe.uri)?void 0:Ne?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?He.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Ne?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&He.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Ne?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(pt.from)}})}return He}Le.from=Oe;function Ie(se){const Ne=new s.WorkspaceEdit,He=new P.ResourceMap;for(const Qe of se.edits)if(Qe.textEdit){const qe=Qe,rt=T.URI.revive(qe.resource),yt=a.to(qe.textEdit.range),wt=qe.textEdit.text,ht=qe.textEdit.insertAsSnippet;let st;ht?st=s.SnippetTextEdit.replace(yt,new s.SnippetString(wt)):st=s.TextEdit.replace(yt,wt);const dt=He.get(rt);dt?dt.push(st):He.set(rt,[st])}else Ne.renameFile(T.URI.revive(Qe.oldResource),T.URI.revive(Qe.newResource),Qe.options);for(const[Qe,qe]of He)Ne.set(Qe,qe);return Ne}Le.to=Ie})(Q||(e.WorkspaceEdit=Q={}));var ie;(function(Le){const Oe=Object.create(null);Oe[s.SymbolKind.File]=0,Oe[s.SymbolKind.Module]=1,Oe[s.SymbolKind.Namespace]=2,Oe[s.SymbolKind.Package]=3,Oe[s.SymbolKind.Class]=4,Oe[s.SymbolKind.Method]=5,Oe[s.SymbolKind.Property]=6,Oe[s.SymbolKind.Field]=7,Oe[s.SymbolKind.Constructor]=8,Oe[s.SymbolKind.Enum]=9,Oe[s.SymbolKind.Interface]=10,Oe[s.SymbolKind.Function]=11,Oe[s.SymbolKind.Variable]=12,Oe[s.SymbolKind.Constant]=13,Oe[s.SymbolKind.String]=14,Oe[s.SymbolKind.Number]=15,Oe[s.SymbolKind.Boolean]=16,Oe[s.SymbolKind.Array]=17,Oe[s.SymbolKind.Object]=18,Oe[s.SymbolKind.Key]=19,Oe[s.SymbolKind.Null]=20,Oe[s.SymbolKind.EnumMember]=21,Oe[s.SymbolKind.Struct]=22,Oe[s.SymbolKind.Event]=23,Oe[s.SymbolKind.Operator]=24,Oe[s.SymbolKind.TypeParameter]=25;function Ie(Ne){return typeof Oe[Ne]=="number"?Oe[Ne]:6}Le.from=Ie;function se(Ne){for(const He in Oe)if(Oe[He]===Ne)return Number(He);return s.SymbolKind.Property}Le.to=se})(ie||(e.SymbolKind=ie={}));var oe;(function(Le){function Oe(se){switch(se){case s.SymbolTag.Deprecated:return 1}}Le.from=Oe;function Ie(se){switch(se){case 1:return s.SymbolTag.Deprecated}}Le.to=Ie})(oe||(e.SymbolTag=oe={}));var Ee;(function(Le){function Oe(se){return{name:se.name,kind:ie.from(se.kind),tags:se.tags&&se.tags.map(oe.from),containerName:se.containerName,location:Z.from(se.location)}}Le.from=Oe;function Ie(se){const Ne=new s.SymbolInformation(se.name,ie.to(se.kind),se.containerName,Z.to(se.location));return Ne.tags=se.tags&&se.tags.map(oe.to),Ne}Le.to=Ie})(Ee||(e.WorkspaceSymbol=Ee={}));var he;(function(Le){function Oe(se){const Ne={name:se.name||"!!MISSING: name!!",detail:se.detail,range:a.from(se.range),selectionRange:a.from(se.selectionRange),kind:ie.from(se.kind),tags:se.tags?.map(oe.from)??[]};return se.children&&(Ne.children=se.children.map(Oe)),Ne}Le.from=Oe;function Ie(se){const Ne=new s.DocumentSymbol(se.name,se.detail,ie.to(se.kind),a.to(se.range),a.to(se.selectionRange));return(0,o.isNonEmptyArray)(se.tags)&&(Ne.tags=se.tags.map(oe.to)),se.children&&(Ne.children=se.children.map(Ie)),Ne}Le.to=Ie})(he||(e.DocumentSymbol=he={}));var fe;(function(Le){function Oe(se){const Ne=new s.CallHierarchyItem(ie.to(se.kind),se.name,se.detail||"",T.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Ne._sessionId=se._sessionId,Ne._itemId=se._itemId,Ne}Le.to=Oe;function Ie(se,Ne,He){if(Ne=Ne??se._sessionId,He=He??se._itemId,Ne===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:He,name:se.name,detail:se.detail,kind:ie.from(se.kind),uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(oe.from)}}Le.from=Ie})(fe||(e.CallHierarchyItem=fe={}));var x;(function(Le){function Oe(Ie){return new s.CallHierarchyIncomingCall(fe.to(Ie.from),Ie.fromRanges.map(se=>a.to(se)))}Le.to=Oe})(x||(e.CallHierarchyIncomingCall=x={}));var B;(function(Le){function Oe(Ie){return new s.CallHierarchyOutgoingCall(fe.to(Ie.to),Ie.fromRanges.map(se=>a.to(se)))}Le.to=Oe})(B||(e.CallHierarchyOutgoingCall=B={}));var Z;(function(Le){function Oe(se){return{range:se.range&&a.from(se.range),uri:se.uri}}Le.from=Oe;function Ie(se){return new s.Location(T.URI.revive(se.uri),a.to(se.range))}Le.to=Ie})(Z||(e.location=Z={}));var pe;(function(Le){function Oe(se){const Ne=se,He=se;return{originSelectionRange:Ne.originSelectionRange?a.from(Ne.originSelectionRange):void 0,uri:Ne.targetUri?Ne.targetUri:He.uri,range:a.from(Ne.targetRange?Ne.targetRange:He.range),targetSelectionRange:Ne.targetSelectionRange?a.from(Ne.targetSelectionRange):void 0}}Le.from=Oe;function Ie(se){return{targetUri:T.URI.revive(se.uri),targetRange:a.to(se.range),targetSelectionRange:se.targetSelectionRange?a.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?a.to(se.originSelectionRange):void 0}}Le.to=Ie})(pe||(e.DefinitionLink=pe={}));var Se;(function(Le){function Oe(se){return{range:a.from(se.range),contents:V.fromMany(se.contents)}}Le.from=Oe;function Ie(se){return new s.Hover(se.contents.map(V.to),a.to(se.range))}Le.to=Ie})(Se||(e.Hover=Se={}));var re;(function(Le){function Oe(se){return{range:a.from(se.range),expression:se.expression}}Le.from=Oe;function Ie(se){return new s.EvaluatableExpression(a.to(se.range),se.expression)}Le.to=Ie})(re||(e.EvaluatableExpression=re={}));var ne;(function(Le){function Oe(se){if(se instanceof s.InlineValueText)return{type:"text",range:a.from(se.range),text:se.text};if(se instanceof s.InlineValueVariableLookup)return{type:"variable",range:a.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:a.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Le.from=Oe;function Ie(se){switch(se.type){case"text":return{range:a.to(se.range),text:se.text};case"variable":return{range:a.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:a.to(se.range),expression:se.expression}}}Le.to=Ie})(ne||(e.InlineValue=ne={}));var de;(function(Le){function Oe(se){return{frameId:se.frameId,stoppedLocation:a.from(se.stoppedLocation)}}Le.from=Oe;function Ie(se){return new s.InlineValueContext(se.frameId,a.to(se.stoppedLocation))}Le.to=Ie})(de||(e.InlineValueContext=de={}));var ee;(function(Le){function Oe(se){return{range:a.from(se.range),kind:se.kind}}Le.from=Oe;function Ie(se){return new s.DocumentHighlight(a.to(se.range),se.kind)}Le.to=Ie})(ee||(e.DocumentHighlight=ee={}));var ce;(function(Le){function Oe(Ie){switch(Ie){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Le.to=Oe})(ce||(e.CompletionTriggerKind=ce={}));var le;(function(Le){function Oe(Ie){return{triggerKind:ce.to(Ie.triggerKind),triggerCharacter:Ie.triggerCharacter}}Le.to=Oe})(le||(e.CompletionContext=le={}));var ue;(function(Le){function Oe(se){switch(se){case s.CompletionItemTag.Deprecated:return 1}}Le.from=Oe;function Ie(se){switch(se){case 1:return s.CompletionItemTag.Deprecated}}Le.to=Ie})(ue||(e.CompletionItemTag=ue={}));var N;(function(Le){const Oe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Ie(He){return Oe.get(He)??9}Le.from=Ie;const se=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Ne(He){return se.get(He)??s.CompletionItemKind.Property}Le.to=Ne})(N||(e.CompletionItemKind=N={}));var q;(function(Le){function Oe(Ie,se){const Ne=new s.CompletionItem(Ie.label);return Ne.insertText=Ie.insertText,Ne.kind=N.to(Ie.kind),Ne.tags=Ie.tags?.map(ue.to),Ne.detail=Ie.detail,Ne.documentation=A.isMarkdownString(Ie.documentation)?V.to(Ie.documentation):Ie.documentation,Ne.sortText=Ie.sortText,Ne.filterText=Ie.filterText,Ne.preselect=Ie.preselect,Ne.commitCharacters=Ie.commitCharacters,I.Range.isIRange(Ie.range)?Ne.range=a.to(Ie.range):typeof Ie.range=="object"&&(Ne.range={inserting:a.to(Ie.range.insert),replacing:a.to(Ie.range.replace)}),Ne.keepWhitespace=typeof Ie.insertTextRules>"u"?!1:!!(Ie.insertTextRules&1),typeof Ie.insertTextRules<"u"&&Ie.insertTextRules&4?Ne.insertText=new s.SnippetString(Ie.insertText):(Ne.insertText=Ie.insertText,Ne.textEdit=Ne.range instanceof s.Range?new s.TextEdit(Ne.range,Ne.insertText):void 0),Ie.additionalTextEdits&&Ie.additionalTextEdits.length>0&&(Ne.additionalTextEdits=Ie.additionalTextEdits.map(He=>_.to(He))),Ne.command=se&&Ie.command?se.fromInternal(Ie.command):void 0,Ne}Le.to=Oe})(q||(e.CompletionItem=q={}));var J;(function(Le){function Oe(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:V.fromStrict(se.documentation)}}Le.from=Oe;function Ie(se){return{label:se.label,documentation:A.isMarkdownString(se.documentation)?V.to(se.documentation):se.documentation}}Le.to=Ie})(J||(e.ParameterInformation=J={}));var te;(function(Le){function Oe(se){return{label:se.label,documentation:V.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(J.from):[],activeParameter:se.activeParameter}}Le.from=Oe;function Ie(se){return{label:se.label,documentation:A.isMarkdownString(se.documentation)?V.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(J.to):[],activeParameter:se.activeParameter}}Le.to=Ie})(te||(e.SignatureInformation=te={}));var ve;(function(Le){function Oe(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(te.from):[]}}Le.from=Oe;function Ie(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(te.to):[]}}Le.to=Ie})(ve||(e.SignatureHelp=ve={}));var De;(function(Le){function Oe(Ie,se){const Ne=new s.InlayHint(S.to(se.position),typeof se.label=="string"?se.label:se.label.map(me.to.bind(void 0,Ie)),se.kind&&Te.to(se.kind));return Ne.textEdits=se.textEdits&&se.textEdits.map(_.to),Ne.tooltip=A.isMarkdownString(se.tooltip)?V.to(se.tooltip):se.tooltip,Ne.paddingLeft=se.paddingLeft,Ne.paddingRight=se.paddingRight,Ne}Le.to=Oe})(De||(e.InlayHint=De={}));var me;(function(Le){function Oe(Ie,se){const Ne=new s.InlayHintLabelPart(se.label);return Ne.tooltip=A.isMarkdownString(se.tooltip)?V.to(se.tooltip):se.tooltip,v.Command.is(se.command)&&(Ne.command=Ie.fromInternal(se.command)),se.location&&(Ne.location=Z.to(se.location)),Ne}Le.to=Oe})(me||(e.InlayHintLabelPart=me={}));var Te;(function(Le){function Oe(se){return se}Le.from=Oe;function Ie(se){return se}Le.to=Ie})(Te||(e.InlayHintKind=Te={}));var Pe;(function(Le){function Oe(se){return{range:a.from(se.range),url:se.target,tooltip:se.tooltip}}Le.from=Oe;function Ie(se){let Ne;if(se.url)try{Ne=typeof se.url=="string"?T.URI.parse(se.url,!0):T.URI.revive(se.url)}catch{}return new s.DocumentLink(a.to(se.range),Ne)}Le.to=Ie})(Pe||(e.DocumentLink=Pe={}));var $e;(function(Le){function Oe(se){const Ne=new s.ColorPresentation(se.label);return se.textEdit&&(Ne.textEdit=_.to(se.textEdit)),se.additionalTextEdits&&(Ne.additionalTextEdits=se.additionalTextEdits.map(He=>_.to(He))),Ne}Le.to=Oe;function Ie(se){return{label:se.label,textEdit:se.textEdit?_.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Ne=>_.from(Ne)):void 0}}Le.from=Ie})($e||(e.ColorPresentation=$e={}));var Ve;(function(Le){function Oe(se){return new s.Color(se[0],se[1],se[2],se[3])}Le.to=Oe;function Ie(se){return[se.red,se.green,se.blue,se.alpha]}Le.from=Ie})(Ve||(e.Color=Ve={}));var et;(function(Le){function Oe(se){return{range:a.from(se.range)}}Le.from=Oe;function Ie(se){return new s.SelectionRange(a.to(se.range))}Le.to=Ie})(et||(e.SelectionRange=et={}));var Ye;(function(Le){function Oe(Ie){switch(Ie){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Le.to=Oe})(Ye||(e.TextDocumentSaveReason=Ye={}));var Je;(function(Le){function Oe(se){switch(se){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Le.from=Oe;function Ie(se){switch(se){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Le.to=Ie})(Je||(e.TextEditorLineNumbersStyle=Je={}));var nt;(function(Le){function Oe(se){if(se===s.EndOfLine.CRLF)return 1;if(se===s.EndOfLine.LF)return 0}Le.from=Oe;function Ie(se){if(se===1)return s.EndOfLine.CRLF;if(se===0)return s.EndOfLine.LF}Le.to=Ie})(nt||(e.EndOfLine=nt={}));var ct;(function(Le){function Oe(Ie){if(typeof Ie=="object")return Ie.viewId;switch(Ie){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Le.from=Oe})(ct||(e.ProgressLocation=ct={}));var Fe;(function(Le){function Oe(se){const Ne={start:se.start+1,end:se.end+1};return se.kind&&(Ne.kind=it.from(se.kind)),Ne}Le.from=Oe;function Ie(se){const Ne={start:se.start-1,end:se.end-1};return se.kind&&(Ne.kind=it.to(se.kind)),Ne}Le.to=Ie})(Fe||(e.FoldingRange=Fe={}));var it;(function(Le){function Oe(se){if(se)switch(se){case s.FoldingRangeKind.Comment:return v.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return v.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return v.FoldingRangeKind.Region}}Le.from=Oe;function Ie(se){if(se)switch(se.value){case v.FoldingRangeKind.Comment.value:return s.FoldingRangeKind.Comment;case v.FoldingRangeKind.Imports.value:return s.FoldingRangeKind.Imports;case v.FoldingRangeKind.Region.value:return s.FoldingRangeKind.Region}}Le.to=Ie})(it||(e.FoldingRangeKind=it={}));var W;(function(Le){function Oe(Ie){if(Ie)return{pinned:typeof Ie.preview=="boolean"?!Ie.preview:void 0,inactive:Ie.background,preserveFocus:Ie.preserveFocus,selection:typeof Ie.selection=="object"?a.from(Ie.selection):void 0,override:typeof Ie.override=="boolean"?h.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Le.from=Oe})(W||(e.TextEditorOpenOptions=W={}));var X;(function(Le){function Oe(He){return He instanceof s.RelativePattern?He.toJSON():typeof He=="string"?He:Ie(He)||se(He)?new s.RelativePattern(He.baseUri??He.base,He.pattern).toJSON():He}Le.from=Oe;function Ie(He){const Qe=He;return Qe?T.URI.isUri(Qe.baseUri)&&typeof Qe.pattern=="string":!1}function se(He){const Qe=He;return Qe?typeof Qe.base=="string"&&typeof Qe.pattern=="string":!1}function Ne(He){return typeof He=="string"?He:new s.RelativePattern(T.URI.revive(He.baseUri),He.pattern)}Le.to=Ne})(X||(e.GlobPattern=X={}));var ge;(function(Le){function Oe(Ie){if(Ie){if(Array.isArray(Ie))return Ie.map(Oe);if(typeof Ie=="string")return Ie;{const se=Ie;return{language:se.language,scheme:se.scheme,pattern:X.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Le.from=Oe})(ge||(e.LanguageSelector=ge={}));var Re;(function(Le){function Oe(se){return{start:se.start,end:se.end}}Le.from=Oe;function Ie(se){return new s.NotebookRange(se.start,se.end)}Le.to=Ie})(Re||(e.NotebookRange=Re={}));var Me;(function(Le){function Oe(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Le.to=Oe;function Ie(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Le.from=Ie})(Me||(e.NotebookCellExecutionSummary=Me={}));var Ge;(function(Le){function Oe(Ie){if(Ie===y.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Ie===y.NotebookCellExecutionState.Pending)return;if(Ie===y.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Ie}`)}Le.to=Oe})(Ge||(e.NotebookCellExecutionState=Ge={}));var je;(function(Le){function Oe(se){switch(se){case s.NotebookCellKind.Markup:return y.CellKind.Markup;case s.NotebookCellKind.Code:default:return y.CellKind.Code}}Le.from=Oe;function Ie(se){switch(se){case y.CellKind.Markup:return s.NotebookCellKind.Markup;case y.CellKind.Code:default:return s.NotebookCellKind.Code}}Le.to=Ie})(je||(e.NotebookCellKind=je={}));var tt;(function(Le){function Oe(se){const Ne={metadata:se.metadata??Object.create(null),cells:[]};for(const He of se.cells)s.NotebookCellData.validate(He),Ne.cells.push(pt.from(He));return Ne}Le.from=Oe;function Ie(se){const Ne=new s.NotebookData(se.cells.map(pt.to));return(0,E.isEmptyObject)(se.metadata)||(Ne.metadata=se.metadata),Ne}Le.to=Ie})(tt||(e.NotebookData=tt={}));var pt;(function(Le){function Oe(se){return{cellKind:je.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:Me.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(bt.from):[]}}Le.from=Oe;function Ie(se){return new s.NotebookCellData(je.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(bt.to):void 0,se.metadata,se.internalMetadata?Me.to(se.internalMetadata):void 0)}Le.to=Ie})(pt||(e.NotebookCellData=pt={}));var at;(function(Le){function Oe(se){return{mime:se.mime,valueBytes:R.VSBuffer.wrap(se.data)}}Le.from=Oe;function Ie(se){return new s.NotebookCellOutputItem(se.valueBytes.buffer,se.mime)}Le.to=Ie})(at||(e.NotebookCellOutputItem=at={}));var bt;(function(Le){function Oe(se){return{outputId:se.id,items:se.items.map(at.from),metadata:se.metadata}}Le.from=Oe;function Ie(se){const Ne=se.items.map(at.to);return new s.NotebookCellOutput(Ne,se.outputId,se.metadata)}Le.to=Ie})(bt||(e.NotebookCellOutput=bt={}));var Dt;(function(Le){function Oe(Ne){return se(Ne)?{include:(0,E.withNullAsUndefined)(X.from(Ne.include)),exclude:(0,E.withNullAsUndefined)(X.from(Ne.exclude))}:(0,E.withNullAsUndefined)(X.from(Ne))}Le.from=Oe;function Ie(Ne){return se(Ne)?{include:X.to(Ne.include),exclude:X.to(Ne.exclude)}:X.to(Ne)}Le.to=Ie;function se(Ne){const He=Ne;return He?!(0,E.isUndefinedOrNull)(He.include)&&!(0,E.isUndefinedOrNull)(He.exclude):!1}})(Dt||(e.NotebookExclusiveDocumentPattern=Dt={}));var St;(function(Le){function Oe(Ie,se,Ne){const He=typeof Ie.command=="string"?{title:"",command:Ie.command}:Ie.command;return{alignment:Ie.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(He,Ne),text:Ie.text,tooltip:Ie.tooltip,accessibilityInformation:Ie.accessibilityInformation,priority:Ie.priority}}Le.from=Oe})(St||(e.NotebookStatusBarItem=St={}));var At;(function(Le){function Oe(Ie,se,Ne){const He=typeof Ie.command=="string"?{title:"",command:Ie.command}:Ie.command;return{command:se.toInternal(He,Ne),label:Ie.label,description:Ie.description,detail:Ie.detail,documentation:Ie.documentation}}Le.from=Oe})(At||(e.NotebookKernelSourceAction=At={}));var Bt;(function(Le){function Oe(Ie){return{transientOutputs:Ie?.transientOutputs??!1,transientCellMetadata:Ie?.transientCellMetadata??{},transientDocumentMetadata:Ie?.transientDocumentMetadata??{},cellContentMetadata:Ie?.cellContentMetadata??{}}}Le.from=Oe})(Bt||(e.NotebookDocumentContentOptions=Bt={}));var qt;(function(Le){function Oe(se){return{uri:se.uri,provides:se.provides}}Le.from=Oe;function Ie(se){return new s.NotebookRendererScript(T.URI.revive(se.uri),se.provides)}Le.to=Ie})(qt||(e.NotebookRendererScript=qt={}));var jt;(function(Le){function Oe(se){return{message:V.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,location:se.location&&{range:a.from(se.location.range),uri:se.location.uri}}}Le.from=Oe;function Ie(se){const Ne=new s.TestMessage(typeof se.message=="string"?se.message:V.to(se.message));return Ne.actualOutput=se.actual,Ne.expectedOutput=se.expected,Ne.location=se.location?Z.to(se.location):void 0,Ne}Le.to=Ie})(jt||(e.TestMessage=jt={}));var Rt;(function(Le){Le.namespace=g.namespaceTestTag,Le.denamespace=g.denamespaceTestTag})(Rt||(e.TestTag=Rt={}));var lt;(function(Le){function Oe(se){const Ne=(0,d.getPrivateApiFor)(se).controllerId;return{extId:w.TestId.fromExtHostTestItem(se,Ne).toString(),label:se.label,uri:T.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(He=>Rt.namespace(Ne,He.id)),range:I.Range.lift(a.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&V.fromStrict(se.error)||null}}Le.from=Oe;function Ie(se){return{parent:void 0,error:void 0,id:w.TestId.fromString(se.extId).localId,label:se.label,uri:T.URI.revive(se.uri),tags:(se.tags||[]).map(Ne=>{const{tagId:He}=Rt.denamespace(Ne);return new s.TestTag(He)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:a.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Le.toPlain=Ie})(lt||(e.TestItem=lt={})),function(Le){function Oe(se){return{id:se.id}}Le.from=Oe;function Ie(se){return new s.TestTag(se.id)}Le.to=Ie}(Rt||(e.TestTag=Rt={}));var vt;(function(Le){const Oe=(se,Ne)=>{const He=[];for(const[qe,rt]of Ne)w.TestId.compare(rt.item.extId,qe)===2&&(Ne.delete(qe),He.push(rt));const Qe={...lt.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(rt=>rt.type===0).map(jt.to)})),children:He.map(qe=>Oe(qe,Ne))};for(const qe of Qe.children)qe.parent=Qe;return Qe};function Ie(se){const Ne=[],He=new Map;for(const Qe of se.items){He.set(Qe.item.extId,Qe);const qe=w.TestId.root(Qe.item.extId);se.request.targets.some(rt=>rt.controllerId===qe&&rt.testIds.includes(Qe.item.extId))&&Ne.push(Qe)}return{completedAt:se.completedAt,results:Ne.map(Qe=>Oe(Qe,He))}}Le.to=Ie})(vt||(e.TestResults=vt={}));var Ht;(function(Le){function Oe(He){return{covered:He.covered,total:He.covered}}function Ie(He){return"line"in He?S.from(He):a.from(He)}function se(He){return"branches"in He?{count:He.executionCount,location:Ie(He.location),type:1,branches:He.branches.length?He.branches.map(Qe=>({count:Qe.executionCount,location:Qe.location&&Ie(Qe.location)})):void 0}:{type:0,count:He.executionCount,location:Ie(He.location)}}Le.fromDetailed=se;function Ne(He){return{uri:He.uri,statement:Oe(He.statementCoverage),branch:He.branchCoverage&&Oe(He.branchCoverage),function:He.functionCoverage&&Oe(He.functionCoverage),details:He.detailedCoverage?.map(se)}}Le.fromFile=Ne})(Ht||(e.TestCoverage=Ht={}));var zt;(function(Le){function Oe(Ie){switch(Ie){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Le.to=Oe})(zt||(e.CodeActionTriggerKind=zt={}));var Tt;(function(Le){function Oe(se){const Ne=new s.TypeHierarchyItem(ie.to(se.kind),se.name,se.detail||"",T.URI.revive(se.uri),a.to(se.range),a.to(se.selectionRange));return Ne._sessionId=se._sessionId,Ne._itemId=se._itemId,Ne}Le.to=Oe;function Ie(se,Ne,He){if(Ne=Ne??se._sessionId,He=He??se._itemId,Ne===void 0||He===void 0)throw new Error("invalid item");return{_sessionId:Ne,_itemId:He,kind:ie.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:a.from(se.range),selectionRange:a.from(se.selectionRange),tags:se.tags?.map(oe.from)}}Le.from=Ie})(Tt||(e.TypeHierarchyItem=Tt={}));var ft;(function(Le){function Oe(Ie){if(Ie)return{value:Ie.value,tooltip:Ie.tooltip}}Le.from=Oe})(ft||(e.ViewBadge=ft={}));var Pt;(function(Le){function Oe(He,Qe,qe){const rt=Qe.fileData;return rt?new class extends s.DataTransferItem{asFile(){return new s.DataTransferFile(rt.name,T.URI.revive(rt.uri),Qe.id,(0,L.once)(()=>qe()))}}("",Qe.id):He===O.Mimes.uriList&&Qe.uriListData?new s.DataTransferItem(Ne(Qe.uriListData)):new s.DataTransferItem(Qe.asString)}Le.to=Oe;async function Ie(He,Qe){const qe=await Qe.asString();if(He===O.Mimes.uriList)return{id:Qe.id,asString:qe,fileData:void 0,uriListData:se(qe)};const rt=Qe.asFile();return{id:Qe.id,asString:qe,fileData:rt?{name:rt.name,uri:rt.uri}:void 0}}Le.from=Ie;function se(He){return l.UriList.split(He).map(Qe=>{if(Qe.startsWith("#"))return Qe;try{return T.URI.parse(Qe)}catch{}return Qe})}function Ne(He){return l.UriList.create(He.map(Qe=>typeof Qe=="string"?Qe:T.URI.revive(Qe)))}})(Pt||(e.DataTransferItem=Pt={}));var Ft;(function(Le){function Oe(se,Ne){const He=se.items.map(([Qe,qe])=>[Qe,Pt.to(Qe,qe,()=>Ne(qe.id))]);return new s.DataTransfer(He)}Le.toDataTransfer=Oe;async function Ie(se){const Ne={items:[]},He=[];return se.forEach((Qe,qe)=>{He.push((async()=>{Ne.items.push([qe,await Pt.from(qe,Qe)])})())}),await Promise.all(He),Ne}Le.toDataTransferDTO=Ie})(Ft||(e.DataTransfer=Ft={}));var Lt;(function(Le){function Oe(se){return{message:se.message,metadata:se.metadata,title:se.title,tooltip:se.tooltip}}Le.to=Oe;function Ie(se){return{kind:"reply",message:se.message,metadata:se.metadata,title:se.title,tooltip:se.tooltip}}Le.from=Ie})(Lt||(e.InteractiveSessionReplyFollowup=Lt={}));var Xe;(function(Le){function Oe(Ie){return typeof Ie=="string"?{title:Ie,message:Ie,kind:"reply"}:"commandId"in Ie?{kind:"command",title:Ie.title??"",commandId:Ie.commandId??"",args:Ie.args}:Lt.from(Ie)}Le.from=Oe})(Xe||(e.InteractiveSessionFollowup=Xe={}))}),define(Ce[249],ke([1,0,2,8,7,11,66]),function(ae,e,o,R,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class P{constructor(p,O,k,E={timeout:1500,errors:3}){this.c=p,this.d=O,this.f=k,this.g=E,this.a=new A.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(p){return(O,k,E)=>{const I={dispose:this.a.push([O,k,p])};return Array.isArray(E)&&E.push(I),I}}async $participateInSave(p,O){const k=o.URI.revive(p);let E=!1;const T=setTimeout(()=>E=!0,this.g.timeout),I=[];try{for(const v of[...this.a]){if(E)break;const i=this.d.getDocument(k),d=await this.h(v,{document:i,reason:L.TextDocumentSaveReason.to(O)});I.push(d)}}finally{clearTimeout(T)}return I}h([p,O,k],E){const T=this.b.get(p);return typeof T=="number"&&T>this.g.errors?Promise.resolve(!1):this.i(k,p,O,E).then(()=>!0,I=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' threw ERROR`),this.c.error(I),!(I instanceof Error)||I.message!=="concurrent_edits"){const v=this.b.get(p);this.b.set(p,v?v+1:1),typeof v=="number"&&v>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(p,O,k,E){const T=[],I=Date.now(),{document:v,reason:i}=E,{version:d}=v,h=Object.freeze({document:v,reason:i,waitUntil(y){if(Object.isFrozen(T))throw(0,R.illegalState)("waitUntil can not be called async");T.push(Promise.resolve(y))}});try{O.apply(k,[h])}catch(y){return Promise.reject(y)}return Object.freeze(T),new Promise((y,w)=>{const g=setTimeout(()=>w(new Error("timeout")),this.g.timeout);return Promise.all(T).then(t=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${p.identifier.value}' finished after ${Date.now()-I}ms`),clearTimeout(g),y(t)}).catch(t=>{clearTimeout(g),w(t)})}).then(y=>{const w={edits:[]};for(const g of y)if(Array.isArray(g)&&g.every(t=>t instanceof l.TextEdit))for(const{newText:t,newEol:s,range:r}of g)w.edits.push({resource:v.uri,versionId:void 0,textEdit:{range:r&&L.Range.from(r),text:t,eol:s&&L.EndOfLine.from(s)}});if(w.edits.length!==0)return d===v.version?this.f.$tryApplyWorkspaceEdit(w):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=P}),define(Ce[250],ke([1,0,17,2,11,7,94]),function(ae,e,o,R,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class P{constructor(k,E,T,I){this.start=k,this.deletedCount=E,this.deletedItems=T,this.items=I}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(k=>k.apiCell),removedCells:this.deletedItems}}}class D{static asModelAddData(k,E){return{EOL:E.eol,lines:E.source,languageId:E.language,uri:E.uri,isDirty:!1,versionId:1,notebook:k}}constructor(k,E,T){this.notebook=k,this.h=E,this.j=T,this.handle=T.handle,this.uri=R.URI.revive(T.uri),this.cellKind=T.cellKind,this.a=T.outputs.map(l.NotebookCellOutput.to),this.e=T.internalMetadata??{},this.b=Object.freeze(T.metadata??{}),this.d=Object.freeze(l.NotebookCellExecutionSummary.to(T.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const k=this,E=this.h.getDocument(this.uri);if(!E)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const T={get index(){return k.notebook.getCellIndex(k)},notebook:k.notebook.apiNotebook,kind:l.NotebookCellKind.to(this.j.cellKind),document:E.document,get mime(){return k.g},set mime(I){k.g=I},get outputs(){return k.a.slice(0)},get metadata(){return k.b},get executionSummary(){return k.d}};this.f=Object.freeze(T)}return this.f}setOutputs(k){this.a=k.map(l.NotebookCellOutput.to)}setOutputItems(k,E,T){const I=T.map(l.NotebookCellOutputItem.to),v=this.a.find(i=>i.id===k);if(v&&(E||(v.items.length=0),v.items.push(...I),v.items.length>1&&v.items.every(i=>A.isTextStreamMime(i.mime)))){const i=new Map,d=[];v.items.forEach(h=>{let y;i.has(h.mime)?y=i.get(h.mime):(y=[],i.set(h.mime,y),d.push(h.mime)),y.push(h.data)}),v.items.length=0,d.forEach(h=>{const y=A.compressOutputItemStreams(i.get(h));v.items.push({mime:h,data:y.buffer})})}}setMetadata(k){this.b=Object.freeze(k)}setInternalMetadata(k){this.e=k,this.d=Object.freeze(l.NotebookCellExecutionSummary.to(k))}setMime(k){}}e.ExtHostCell=D;class p{constructor(k,E,T,I,v){this.k=k,this.l=E,this.m=T,this.uri=I,this.handle=p.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=v.viewType,this.f=Object.freeze(v.metadata??Object.create(null)),this.r([[0,0,v.cells]],!0,void 0),this.g=v.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const k=this,E={get uri(){return k.uri},get version(){return k.g},get notebookType(){return k.d},get isDirty(){return k.h},get isUntitled(){return k.uri.scheme===o.Schemas.untitled},get isClosed(){return k.j},get metadata(){return k.f},get cellCount(){return k.b.length},cellAt(T){return T=k.n(T),k.b[T].apiCell},getCells(T){return(T?k.p(T):k.b).map(v=>v.apiCell)},save(){return k.q()}};this.e=Object.freeze(E)}return this.e}acceptDocumentPropertiesChanged(k){k.metadata&&(this.f=Object.freeze({...this.f,...k.metadata}))}acceptDirty(k){this.h=k}acceptModelChanged(k,E,T){this.g=k.versionId,this.h=E,this.acceptDocumentPropertiesChanged({metadata:T});const I={notebook:this.apiNotebook,metadata:T,cellChanges:[],contentChanges:[]},v=[];for(const d of k.rawEvents)d.kind===A.NotebookCellsChangeType.ModelChange?this.r(d.changes,!1,I.contentChanges):d.kind===A.NotebookCellsChangeType.Move?this.s(d.index,d.length,d.newIdx,I.contentChanges):d.kind===A.NotebookCellsChangeType.Output?(this.t(d.index,d.outputs),v.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===A.NotebookCellsChangeType.OutputItem?(this.u(d.index,d.outputId,d.append,d.outputItems),v.push({cell:this.b[d.index].apiCell,outputs:this.b[d.index].apiCell.outputs})):d.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(d.index,d.language),v.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document})):d.kind===A.NotebookCellsChangeType.ChangeCellContent?v.push({cell:this.b[d.index].apiCell,document:this.b[d.index].apiCell.document}):d.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(d.index,d.mime):d.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(d.index,d.metadata),v.push({cell:this.b[d.index].apiCell,metadata:this.b[d.index].apiCell.metadata})):d.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(d.index,d.internalMetadata),v.push({cell:this.b[d.index].apiCell,executionSummary:this.b[d.index].apiCell.executionSummary}));const i=new Map;for(let d=0;d<v.length;d++){const h=v[d],y=i.get(h.cell);if(y===void 0){const w=I.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...h});i.set(h.cell,w-1)}else I.cellChanges[y]={...I.cellChanges[y],...h}}return Object.freeze(I),Object.freeze(I.cellChanges),Object.freeze(I.contentChanges),I}n(k){return k=k|0,k<0?0:k>=this.b.length?this.b.length-1:k}o(k){let E=k.start|0,T=k.end|0;return E<0&&(E=0),T>this.b.length&&(T=this.b.length),k.with({start:E,end:T})}p(k){k=this.o(k);const E=[];for(let T=k.start;T<k.end;T++)E.push(this.b[T]);return E}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(k,E,T){if(this.j)return;const I=[],v=[],i=[];if(k.reverse().forEach(d=>{const y=d[2].map(t=>{const s=new D(this,this.l,t);return E||v.push(D.asModelAddData(this.apiNotebook,t)),s}),w=new P(d[0],d[1],[],y),g=this.b.splice(d[0],d[1],...y);for(const t of g)i.push(t.uri),w.deletedItems.push(t.apiCell);I.push(w)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:v,removedDocuments:i}),T)for(const d of I)T.push(d.asApiEvent())}s(k,E,T,I){const v=this.b.splice(k,E);this.b.splice(T,0,...v);const i=[new P(k,E,v.map(d=>d.apiCell),[]),new P(T,0,[],v)];for(const d of i)I.push(d.asApiEvent())}t(k,E){this.b[k].setOutputs(E)}u(k,E,T,I){this.b[k].setOutputItems(E,T,I)}v(k,E){const T=this.b[k];T.apiCell.document.languageId!==E&&this.m.$acceptModelLanguageChanged(T.uri,E)}w(k,E){const T=this.b[k];T.apiCell.mime=E}x(k,E){this.b[k].setMetadata(E)}y(k,E){this.b[k].setInternalMetadata(E)}getCellFromApiCell(k){return this.b.find(E=>E.apiCell===k)}getCellFromIndex(k){return this.b[k]}getCell(k){return this.b.find(E=>E.handle===k)}getCellIndex(k){return this.b.indexOf(k)}}e.ExtHostNotebookDocument=p,p.a=0}),define(Ce[251],ke([1,0,3,2,11,7]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class A{constructor(D,p,O,k={timeout:1500,errors:3}){this.b=D,this.c=p,this.d=O,this.f=k,this.a=new o.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(p,O,k)=>{const E=function(I){p.call(O,I)};return E.extension=D,this.a.event(E,void 0,k)}}async $participateInSave(D,p,O){const k=R.URI.revive(D),E=this.c.getNotebookDocument(k);if(!E)throw new Error("Unable to resolve notebook document");const T=[];if(await this.a.fireAsync({notebook:E.apiNotebook,reason:l.TextDocumentSaveReason.to(p)},O,async(v,i)=>{const d=Date.now(),h=await await Promise.resolve(v);Date.now()-d>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",i.extension.identifier),!O.isCancellationRequested&&h&&(h instanceof L.WorkspaceEdit?T.push(h):this.b.warn("onWillSaveNotebookDocument-listener from extension",i.extension.identifier,"ignored due to invalid data"))}),O.isCancellationRequested)return!1;if(T.length===0)return!0;const I={edits:[]};for(const v of T){const{edits:i}=l.WorkspaceEdit.from(v);I.edits=I.edits.concat(i)}return this.d.$tryApplyWorkspaceEdit(I)}}e.ExtHostNotebookDocumentSaveParticipant=A}),define(Ce[137],ke([1,0,8,11,7]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(P,D,p,O,k,E){this.id=P,this.f=D,this.notebookData=p,this.a=[],this.b=[],this.d=!1,this.a=k,this.b=O,this.c=E}get apiEditor(){if(!this.e){const P=this;this.e={get notebook(){return P.notebookData.apiNotebook},get selection(){return P.a[0]},set selection(D){this.selections=[D]},get selections(){return P.a},set selections(D){if(!Array.isArray(D)||!D.every(l.NotebookRange.isNotebookRange))throw(0,o.illegalArgument)("selections");P.a=D,P.g(D)},get visibleRanges(){return P.b},revealRange(D,p){P.f.$tryRevealRange(P.id,R.NotebookRange.from(D),p??l.NotebookEditorRevealType.Default)},get viewColumn(){return P.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(P){this.d=P}_acceptVisibleRanges(P){this.b=P}_acceptSelections(P){this.a=P}g(P){this.f.$trySetSelections(this.id,P.map(R.NotebookRange.from))}_acceptViewColumn(P){this.c=P}}e.ExtHostNotebookEditor=L,L.apiEditorsToExtHost=new WeakMap}),define(Ce[252],ke([1,0,8,3,16,11]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let A=e.ExtHostNotebookEditors=class{constructor(D,p){this.c=D,this.d=p,this.a=new R.Emitter({onListenerError:o.onUnexpectedExternalError}),this.b=new R.Emitter({onListenerError:o.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(D,p){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",D,p);const O=this.d.getEditorById(D);p.visibleRanges&&O._acceptVisibleRanges(p.visibleRanges.ranges.map(L.NotebookRange.to)),p.selections&&O._acceptSelections(p.selections.selections.map(L.NotebookRange.to)),p.visibleRanges&&this.b.fire({notebookEditor:O.apiEditor,visibleRanges:O.apiEditor.visibleRanges}),p.selections&&this.a.fire(Object.freeze({notebookEditor:O.apiEditor,selections:O.apiEditor.selections}))}$acceptEditorViewColumns(D){for(const p in D)this.d.getEditorById(p)._acceptViewColumn(L.ViewColumn.to(D[p]))}};e.ExtHostNotebookEditors=A=xe([We(0,l.ILogService)],A)}),define(Ce[253],ke([1,0,11,125,187,21,63,8]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class D{constructor(E){this.b=0,this.c=new Map,this.a=E}async withProgress(E,T,I){const v=this.b++,{title:i,location:d,cancellable:h}=T,y={label:(0,l.localize)(0,null,E.displayName||E.name),id:E.identifier.value};return this.a.$startProgress(v,{location:o.ProgressLocation.from(d),title:i,source:y,cancellable:h},E.isUnderDevelopment?void 0:E.identifier.value).catch(P.onUnexpectedExternalError),this.d(v,I,!!h)}d(E,T,I){let v;I&&(v=new L.CancellationTokenSource,this.c.set(E,v));const i=h=>{this.a.$progressEnd(h),this.c.delete(h),v?.dispose()};let d;try{d=T(new O(this.a,E),I&&v?v.token:L.CancellationToken.None)}catch(h){throw i(E),h}return d.then(h=>i(E),h=>i(E)),d}$acceptProgressCanceled(E){const T=this.c.get(E);T&&(T.cancel(),this.c.delete(E))}}e.ExtHostProgress=D;function p(k,E){return k.message=E.message,typeof E.increment=="number"&&(typeof k.increment=="number"?k.increment+=E.increment:k.increment=E.increment),k}class O extends R.Progress{constructor(E,T){super(I=>this.throttledReport(I)),this.c=E,this.d=T}throttledReport(E){this.c.$progressReport(this.d,E)}}xe([(0,A.throttle)(100,(k,E)=>p(k,E),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Ce[138],ke([1,0,32,133,58,95,77,11,2]),function(ae,e,o,R,l,L,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const p=(y,w,g,t)=>{let s=w;return{enumerable:!0,configurable:!1,get(){return s},set(r){if(!g(s,r)){const a=s;s=r,y.listener?.(t(r,a))}}}},O=(y,w)=>y===w,k={range:(y,w)=>y===w?!0:!y||!w?!1:y.isEqual(w),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(y,w)=>!(y.length!==w.length||y.some(g=>!w.find(t=>g.id===t.id)))},E=y=>w=>({op:4,update:y(w)}),T=(y,w)=>({range:(()=>{let g;const t=E(s=>({range:o.Range.lift(P.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return g},set(s){y.listener?.({op:6}),k.range(g,s)||(g=s,y.listener?.(t(s)))}}})(),label:p(y,w,k.label,E(g=>({label:g}))),description:p(y,void 0,k.description,E(g=>({description:g}))),sortText:p(y,void 0,k.sortText,E(g=>({sortText:g}))),canResolveChildren:p(y,!1,k.canResolveChildren,g=>({op:2,state:g})),busy:p(y,!1,k.busy,E(g=>({busy:g}))),error:p(y,void 0,k.error,E(g=>({error:P.MarkdownString.fromStrict(g)||null}))),tags:p(y,[],k.tags,(g,t)=>({op:1,new:g.map(P.TestTag.from),old:t.map(P.TestTag.from)}))}),I=y=>{const w=l.TestId.fromString(y.extId),g=new i(w.controllerId,w.localId,y.label,D.URI.revive(y.uri)||void 0);return g.range=P.Range.to(y.range||void 0),g.description=y.description||void 0,g.sortText=y.sortText||void 0,g.tags=y.tags.map(t=>P.TestTag.to({id:(0,A.denamespaceTestTag)(t).tagId})),g},v=y=>{let w;for(const g of y.tests){const t=I(g.item);(0,R.getPrivateApiFor)(t).parent=w,w=t}return w};e.toItemFromContext=v;class i{constructor(w,g,t,s){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const r=(0,R.createPrivateApiFor)(this,w);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof d?void 0:r.parent}},children:{value:(0,L.createTestItemChildren)(r,R.getPrivateApiFor,i),enumerable:!0,writable:!1},...T(r,t)})}}e.TestItemImpl=i;class d extends i{constructor(w,g){super(w,w,g,void 0),this._isRoot=!0}}e.TestItemRootImpl=d;class h extends L.TestItemCollection{constructor(w,g,t){super({controllerId:w,getDocumentVersion:s=>s&&t.getDocument(s)?.version,getApiFor:R.getPrivateApiFor,getChildren:s=>s.children,root:new d(w,g),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=h}),define(Ce[139],ke([1,0,51,8,102,11,7]),function(ae,e,o,R,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class P{constructor(E,T,I){const v=P.c.nextId();E.$registerTextEditorDecorationType(T.identifier,v,L.DecorationRenderOptions.from(I)),this.value=Object.freeze({key:v,dispose(){E.$removeTextEditorDecorationType(v)}})}}e.TextEditorDecorationType=P,P.c=new l.IdGenerator("TextEditorDecorationType");class D{constructor(E,T){this.g=[],this.h=void 0,this.j=!1,this.c=E,this.d=E.version,this.e=T.undoStopBefore,this.f=T.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(E,T){this.k();let I=null;if(E instanceof A.Position)I=new A.Range(E,E);else if(E instanceof A.Range)I=E;else throw new Error("Unrecognized location");this.l(I,T,!1)}insert(E,T){this.k(),this.l(new A.Range(E,E),T,!0)}delete(E){this.k();let T=null;if(E instanceof A.Range)T=E;else throw new Error("Unrecognized location");this.l(T,null,!0)}l(E,T,I){const v=this.c.validateRange(E);this.g.push({range:v,text:T,forceMoveMarkers:I})}setEndOfLine(E){if(this.k(),E!==A.EndOfLine.LF&&E!==A.EndOfLine.CRLF)throw(0,R.illegalArgument)("endOfLine");this.h=E}}class p{constructor(E,T,I,v){this.c=E,this.d=T,this._accept(I),this.e=v;const i=this;this.value={get tabSize(){return i.f},set tabSize(d){i.m(d)},get indentSize(){return i.g},set indentSize(d){i.o(d)},get insertSpaces(){return i.h},set insertSpaces(d){i.q(d)},get cursorStyle(){return i.j},set cursorStyle(d){i.s(d)},get lineNumbers(){return i.k},set lineNumbers(d){i.t(d)}}}_accept(E){this.f=E.tabSize,this.g=E.indentSize,this.h=E.insertSpaces,this.j=E.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(E.lineNumbers)}l(E){if(E==="auto")return"auto";if(typeof E=="number"){const T=Math.floor(E);return T>0?T:null}if(typeof E=="string"){const T=parseInt(E,10);return isNaN(T)?null:T>0?T:null}return null}m(E){const T=this.l(E);if(T!==null){if(typeof T=="number"){if(this.f===T)return;this.f=T}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:T}))}}n(E){if(E==="tabSize")return"tabSize";if(typeof E=="number"){const T=Math.floor(E);return T>0?T:null}if(typeof E=="string"){const T=parseInt(E,10);return isNaN(T)?null:T>0?T:null}return null}o(E){const T=this.n(E);if(T!==null){if(typeof T=="number"){if(this.g===T)return;this.g=T}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:T}))}}p(E){return E==="auto"?"auto":E==="false"?!1:!!E}q(E){const T=this.p(E);if(typeof T=="boolean"){if(this.h===T)return;this.h=T}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:T}))}s(E){this.j!==E&&(this.j=E,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:E})))}t(E){this.k!==E&&(this.k=E,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(E)})))}assign(E){const T={};let I=!1;if(typeof E.tabSize<"u"){const v=this.l(E.tabSize);v==="auto"?(I=!0,T.tabSize=v):typeof v=="number"&&this.f!==v&&(this.f=v,I=!0,T.tabSize=v)}if(typeof E.indentSize<"u"){const v=this.n(E.indentSize);v==="tabSize"?(I=!0,T.indentSize=v):typeof v=="number"&&this.g!==v&&(this.g=v,I=!0,T.indentSize=v)}if(typeof E.insertSpaces<"u"){const v=this.p(E.insertSpaces);v==="auto"?(I=!0,T.insertSpaces=v):this.h!==v&&(this.h=v,I=!0,T.insertSpaces=v)}typeof E.cursorStyle<"u"&&this.j!==E.cursorStyle&&(this.j=E.cursorStyle,I=!0,T.cursorStyle=E.cursorStyle),typeof E.lineNumbers<"u"&&this.k!==E.lineNumbers&&(this.k=E.lineNumbers,I=!0,T.lineNumbers=L.TextEditorLineNumbersStyle.from(E.lineNumbers)),I&&this.u("setOptions",this.c.$trySetOptions(this.d,T))}u(E,T){T.catch(I=>{this.e.warn(`ExtHostTextEditorOptions '${E}' failed:'`),this.e.warn(I)})}}e.ExtHostTextEditorOptions=p;class O{constructor(E,T,I,v,i,d,h,y){this.id=E,this.j=T,this.k=I,this.g=!1,this.h=new Set,this.c=i,this.d=new p(this.j,this.id,d,I),this.e=h,this.f=y;const w=this;this.value=Object.freeze({get document(){return v.value},set document(g){throw(0,R.readonly)("document")},get selection(){return w.c&&w.c[0]},set selection(g){if(!(g instanceof A.Selection))throw(0,R.illegalArgument)("selection");w.c=[g],w.l()},get selections(){return w.c},set selections(g){if(!Array.isArray(g)||g.some(t=>!(t instanceof A.Selection)))throw(0,R.illegalArgument)("selections");w.c=g,w.l()},get visibleRanges(){return w.e},set visibleRanges(g){throw(0,R.readonly)("visibleRanges")},get options(){return w.d.value},set options(g){w.g||w.d.assign(g)},get viewColumn(){return w.f},set viewColumn(g){throw(0,R.readonly)("viewColumn")},edit(g,t={undoStopBefore:!0,undoStopAfter:!0}){if(w.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new D(v.value,t);return g(s),w.m(s)},insertSnippet(g,t,s={undoStopBefore:!0,undoStopAfter:!0}){if(w.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!t||Array.isArray(t)&&t.length===0)r=w.c.map(a=>L.Range.from(a));else if(t instanceof A.Position){const{lineNumber:a,column:b}=L.Position.from(t);r=[{startLineNumber:a,startColumn:b,endLineNumber:a,endColumn:b}]}else if(t instanceof A.Range)r=[L.Range.from(t)];else{r=[];for(const a of t)if(a instanceof A.Range)r.push(L.Range.from(a));else{const{lineNumber:b,column:S}=L.Position.from(a);r.push({startLineNumber:b,startColumn:S,endLineNumber:b,endColumn:S})}}return T.$tryInsertSnippet(E,v.value.version,g.value,r,s)},setDecorations(g,t){const s=t.length===0;s&&!w.h.has(g.key)||(s?w.h.delete(g.key):w.h.add(g.key),w.n(()=>{if(L.isDecorationOptionsArr(t))return T.$trySetDecorations(E,g.key,L.fromRangeOrRangeWithMessage(t));{const r=new Array(4*t.length);for(let a=0,b=t.length;a<b;a++){const S=t[a];r[4*a]=S.start.line+1,r[4*a+1]=S.start.character+1,r[4*a+2]=S.end.line+1,r[4*a+3]=S.end.character+1}return T.$trySetDecorationsFast(E,g.key,r)}}))},revealRange(g,t){w.n(()=>T.$tryRevealRange(E,L.Range.from(g),t||A.TextEditorRevealType.Default))},show(g){T.$tryShowEditor(E,L.ViewColumn.from(g))},hide(){T.$tryHideEditor(E)}})}dispose(){(0,o.ok)(!this.g),this.g=!0}_acceptOptions(E){(0,o.ok)(!this.g),this.d._accept(E)}_acceptVisibleRanges(E){(0,o.ok)(!this.g),this.e=E}_acceptViewColumn(E){(0,o.ok)(!this.g),this.f=E}_acceptSelections(E){(0,o.ok)(!this.g),this.c=E}async l(){const E=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,E)),this.value}m(E){const T=E.finalize();if(T.edits.length===0&&!T.setEndOfLine)return Promise.resolve(!0);const I=T.edits.map(i=>i.range);I.sort((i,d)=>i.end.line===d.end.line?i.end.character===d.end.character?i.start.line===d.start.line?i.start.character-d.start.character:i.start.line-d.start.line:i.end.character-d.end.character:i.end.line-d.end.line);for(let i=0,d=I.length-1;i<d;i++){const h=I[i].end;if(I[i+1].start.isBefore(h))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const v=T.edits.map(i=>({range:L.Range.from(i.range),text:i.text,forceMoveMarkers:i.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,T.documentVersionId,v,{setEndOfLine:typeof T.setEndOfLine=="number"?L.EndOfLine.from(T.setEndOfLine):void 0,undoStopBefore:T.undoStopBefore,undoStopAfter:T.undoStopAfter})}n(E){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):E().then(()=>this,T=>(T instanceof Error&&T.name==="DISPOSED"||this.k.warn(T),null))}}e.ExtHostTextEditor=O}),define(Ce[254],ke([1,0,191,7,24,2,3,6,235,19,7,10,18,11,21,27,158]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(w,g){if((0,k.isString)(w))return{label:w};if(w&&typeof w=="object"&&typeof w.label=="string"){let t;return Array.isArray(w.highlights)&&(t=w.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),t=t.length?t:void 0),{label:w.label,highlights:t}}}class h{constructor(g,t,s){this.d=g,this.e=t,this.f=s,this.a=new Map,this.b=new i.TreeViewsDnDService;function r(a){return a&&a.$treeViewId&&(a.$treeItemHandle||a.$selectedTreeItems||a.$focusedTreeItem)}t.registerArgumentProcessor({processArgument:a=>r(a)?this.i(a):Array.isArray(a)&&a.length>0?a.map(b=>r(b)?this.i(b):b):a})}registerTreeDataProvider(g,t,s){const r=this.createTreeView(g,{treeDataProvider:t},s);return{dispose:()=>r.dispose()}}createTreeView(g,t,s){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=t.dragAndDropController?.dropMimeTypes??[],a=t.dragAndDropController?.dragMimeTypes??[],b=!!t.dragAndDropController?.handleDrag,S=!!t.dragAndDropController?.handleDrop,c=this.h(g,t,s),u=this.d.$registerTreeViewDataProvider(g,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany,dropMimeTypes:r,dragMimeTypes:a,hasHandleDrag:b,hasHandleDrop:S});return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,v.checkProposedApiEnabled)(s,"treeItemCheckbox"),c.onDidChangeCheckboxState},get message(){return c.message},set message(m){c.message=m},get title(){return c.title},set title(m){c.title=m},get description(){return c.description},set description(m){c.description=m},get badge(){return c.badge},set badge(m){m!==void 0&&O.ViewBadge.isViewBadge(m)?c.badge={value:Math.floor(Math.abs(m.value)),tooltip:m.tooltip}:m===void 0&&(c.badge=void 0)},reveal:(m,f)=>c.reveal(m,f),dispose:async()=>{await u,this.a.delete(g),c.dispose()}}}$getChildren(g,t){const s=this.a.get(g);return s?s.getChildren(t):Promise.reject(new D.NoTreeViewError(g))}async $handleDrop(g,t,s,r,a,b,S,c){const u=this.a.get(g);if(!u)return Promise.reject(new D.NoTreeViewError(g));const m=T.DataTransfer.toDataTransfer(s,async f=>(await this.d.$resolveDropFileData(g,t,f)).buffer);return S===g&&c&&await this.g(m,u,c,a,b),u.onDrop(m,r,a)}async g(g,t,s,r,a){const b=this.b.removeDragOperationTransfer(a);if(b)(await b)?.forEach((S,c)=>{S&&g.set(c,S)});else if(a&&t.handleDrag){const S=t.handleDrag(s,g,r);this.b.addDragOperationTransfer(a,S),await S}return g}async $handleDrag(g,t,s,r){const a=this.a.get(g);if(!a)return Promise.reject(new D.NoTreeViewError(g));const b=await this.g(new R.DataTransfer,a,t,r,s);if(b)return T.DataTransfer.toDataTransferDTO(b)}async $hasResolve(g){const t=this.a.get(g);if(!t)throw new D.NoTreeViewError(g);return t.hasResolve}$resolve(g,t,s){const r=this.a.get(g);if(!r)throw new D.NoTreeViewError(g);return r.resolveTreeItem(t,s)}$setExpanded(g,t,s){const r=this.a.get(g);if(!r)throw new D.NoTreeViewError(g);r.setExpanded(t,s)}$setSelection(g,t){const s=this.a.get(g);if(!s)throw new D.NoTreeViewError(g);s.setSelection(t)}$setFocus(g,t){const s=this.a.get(g);if(!s)throw new D.NoTreeViewError(g);s.setFocus(t)}$setVisible(g,t){const s=this.a.get(g);if(!s)throw new D.NoTreeViewError(g);s.setVisible(t)}$changeCheckboxState(g,t){const s=this.a.get(g);if(!s)throw new D.NoTreeViewError(g);s.setCheckboxState(t)}h(g,t,s){const r=new y(g,t,this.d,this.e.converter,this.f,s);return this.a.set(g,r),r}i(g){const t=this.a.get(g.$treeViewId);return t&&"$treeItemHandle"in g?t.getExtensionElement(g.$treeItemHandle):t&&"$focusedTreeItem"in g&&g.$focusedTreeItem?t.focusedElement:null}}e.ExtHostTreeViews=h;class y extends P.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(g=>this.getExtensionElement(g)).filter(g=>!(0,k.isUndefinedOrNull)(g))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(g,t,s,r,a,b){if(super(),this.C=g,this.D=s,this.F=r,this.G=a,this.H=b,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new A.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new A.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new A.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new A.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new A.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new A.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new I.CancellationTokenSource,b.contributes&&b.contributes.views)for(const u in b.contributes.views)for(const m of b.contributes.views[u])m.id===g&&(this.J=m.name);this.f=t.treeDataProvider,this.g=t.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.w.fire({message:!1,element:u})));let S,c;this.B(A.Event.debounce(this.w.event,(u,m)=>(u||(u={message:!1,elements:[]}),m.element!==!1&&(S||(S=new Promise(f=>c=f),this.y=this.y.then(()=>S)),Array.isArray(m.element)?u.elements.push(...m.element):u.elements.push(m.element)),m.message&&(u.message=!0),u),200,!0)(({message:u,elements:m})=>{m.length&&(this.z=this.z.then(()=>{const f=c;return S=null,this.U(m).then(()=>f())})),u&&this.D.$setMessage(this.C,this.I)}))}async getChildren(g){const t=g?this.getExtensionElement(g):void 0;if(g&&!t)return this.G.error(`No tree item with id '${g}' found.`),Promise.resolve([]);let s=this.Q(g);return s||(s=await this.R(t)),s?s.map(r=>r.item):void 0}getExtensionElement(g){return this.i.get(g)}reveal(g,t){t=t||{select:!0,focus:!1};const s=(0,k.isUndefinedOrNull)(t.select)?!0:t.select,r=(0,k.isUndefinedOrNull)(t.focus)?!1:t.focus,a=(0,k.isUndefinedOrNull)(t.expand)?!1:t.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.y.then(()=>this.N(g)).then(b=>this.P(g,b[b.length-1]).then(S=>this.D.$reveal(this.C,{item:S.item,parentChain:b.map(c=>c.item)},{select:s,focus:r,expand:a})),b=>this.G.error(b)):this.D.$reveal(this.C,void 0,{select:s,focus:r,expand:a})}get message(){return this.I}set message(g){this.I=g,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(g){this.J=g,this.D.$setTitle(this.C,g,this.L)}get description(){return this.L}set description(g){this.L=g,this.D.$setTitle(this.C,this.J,g)}get badge(){return this.M}set badge(g){this.M?.value===g?.value&&this.M?.tooltip===g?.tooltip||(this.M=T.ViewBadge.from(g),this.D.$setBadge(this.C,g))}setExpanded(g,t){const s=this.getExtensionElement(g);s&&(t?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(g){(0,E.equals)(this.l,g)||(this.l=g,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(g){this.m=g}setVisible(g){g!==this.k&&(this.k=g,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(g){const t=(await Promise.all(g.map(async s=>{const r=this.getExtensionElement(s.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:s.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);t.forEach(s=>{s.treeItem.checkboxState=s.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}),this.v.fire({items:t.map(s=>[s.extensionItem,s.newState])})}async handleDrag(g,t,s){const r=[];for(const a of g){const b=this.getExtensionElement(a);b&&r.push(b)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,t,s),t}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(g,t,s){const r=t?this.getExtensionElement(t):void 0;if(!(!r&&t||!this.g?.handleDrop))return(0,p.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,g,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(g,t){if(!this.f.resolveTreeItem)return;const s=this.i.get(g);if(s){const r=this.j.get(s);if(r){const a=await this.f.resolveTreeItem(r.extensionItem,s,t)??r.extensionItem;return this.db(a),r.item.tooltip=this.ab(a.tooltip),r.item.command=this.bb(r.disposableStore,a.command),r.item}}}N(g){return this.O(g).then(t=>t?this.N(t).then(s=>this.P(t,s[s.length-1]).then(r=>(s.push(r),s))):Promise.resolve([]))}O(g){const t=this.j.get(g);return t?Promise.resolve(t.parent?this.i.get(t.parent.item.handle):void 0):(0,p.asPromise)(()=>this.f.getParent(g))}P(g,t){const s=this.j.get(g);return s?Promise.resolve(s):(0,p.asPromise)(()=>this.f.getTreeItem(g)).then(r=>this.gb(g,r,t,!0)).then(r=>this.getChildren(t?t.item.handle:void 0).then(()=>{const a=this.getExtensionElement(r);if(a){const b=this.j.get(a);if(b)return Promise.resolve(b)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(g){if(g){let t;if(typeof g=="string"){const s=this.getExtensionElement(g);t=s?this.j.get(s):void 0}else t=g;return t&&t.children||void 0}return this.h}async R(g){this.nb(g);const t=new I.CancellationTokenSource(this.S.token);try{const s=g?this.j.get(g):void 0,r=await this.f.getChildren(g);if(t.token.isCancellationRequested)return;const a=await Promise.all((0,E.coalesce)(r||[]).map(async b=>{const S=await this.f.getTreeItem(b);return S&&!t.token.isCancellationRequested?this.Z(b,S,s):null}));return t.token.isCancellationRequested?void 0:(0,E.coalesce)(a)}finally{t.dispose()}}U(g){if(g.some(s=>!s))return this.S.dispose(!0),this.S=new I.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const s=this.W(g);if(s.length)return this.X(s)}return Promise.resolve(void 0)}W(g){const t=new Set,s=g.map(a=>this.j.get(a));for(const a of s)if(a&&!t.has(a.item.handle)){let b=a;for(;b&&b.parent&&s.findIndex(S=>b&&b.parent&&S&&S.item.handle===b.parent.item.handle)===-1;){const S=this.i.get(b.parent.item.handle);b=S?this.j.get(S):void 0}b&&!b.parent&&t.add(a.item.handle)}const r=[];return t.forEach(a=>{const b=this.i.get(a);if(b){const S=this.j.get(b);S&&(!S.parent||!t.has(S.parent.item.handle))&&r.push(a)}}),r}X(g){const t={};return Promise.all(g.map(s=>this.Y(s).then(r=>{r&&(t[s]=r.item)}))).then(()=>Object.keys(t).length?this.D.$refresh(this.C,t):void 0)}Y(g){const t=this.getExtensionElement(g);if(t){const s=this.j.get(t);if(s)return this.nb(t),(0,p.asPromise)(()=>this.f.getTreeItem(t)).then(r=>{if(r){const a=this.eb(t,r,s.parent);return this.lb(t,a,s,s.parent),s.dispose(),a}return null})}return Promise.resolve(null)}Z(g,t,s){const r=this.eb(g,t,s);if(t.id&&this.i.has(r.item.handle))throw new Error((0,o.localize)(0,null,t.id));return this.kb(g,r),this.mb(r,s),r}ab(g){return O.MarkdownString.isMarkdownString(g)?T.MarkdownString.from(g):g}bb(g,t){return t?{...this.F.toInternal(t,g),originalId:t.command}:void 0}cb(g){if(!g.checkboxState)return;let t,s;return typeof g.checkboxState=="number"?t=g.checkboxState:(t=g.checkboxState.state,s=g.checkboxState.tooltip),{isChecked:t===O.TreeItemCheckboxState.Checked,tooltip:s}}db(g){if(!O.TreeItem.isTreeItem(g,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(g,t,s){this.db(t);const r=new P.DisposableStore,a=this.gb(g,t,s),b=this.hb(t);return{item:{handle:a,parentHandle:s?s.item.handle:void 0,label:d(t.label,this.H),description:t.description,resourceUri:t.resourceUri,tooltip:this.ab(t.tooltip),command:this.bb(r,t.command),contextValue:t.contextValue,icon:b,iconDark:this.ib(t)||b,themeIcon:this.fb(t),collapsibleState:(0,k.isUndefinedOrNull)(t.collapsibleState)?O.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation,checkbox:this.cb(t)},extensionItem:t,parent:s,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(g){return g.iconPath instanceof O.ThemeIcon?g.iconPath:void 0}gb(g,{id:t,label:s,resourceUri:r},a,b){if(t)return`${y.b}/${t}`;const S=d(s,this.H),c=a?a.item.handle:y.a;let u=S?S.label:r?(0,l.basename)(r):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const m=this.j.has(g)?this.j.get(g).item.handle:void 0,f=this.Q(a)||[];let n,C=0;do{if(n=`${c}/${C}:${u}`,b||!this.i.has(n)||m===n)break;C++}while(C<=f.length);return n}hb(g){if(g.iconPath&&!(g.iconPath instanceof O.ThemeIcon))return typeof g.iconPath=="string"||L.URI.isUri(g.iconPath)?this.jb(g.iconPath):this.jb(g.iconPath.light)}ib(g){if(g.iconPath&&!(g.iconPath instanceof O.ThemeIcon)&&g.iconPath.dark)return this.jb(g.iconPath.dark)}jb(g){return L.URI.isUri(g)?g:L.URI.file(g)}kb(g,t){this.i.set(t.item.handle,g),this.j.set(g,t)}lb(g,t,s,r){this.i.delete(t.item.handle),this.j.delete(g),t.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.kb(g,t);const a=this.Q(r)||[],b=a.filter(S=>S.item.handle===s.item.handle)[0];b&&a.splice(a.indexOf(b),1,t)}mb(g,t){t?(t.children||(t.children=[]),t.children.push(g)):(this.h||(this.h=[]),this.h.push(g))}nb(g){if(g){const t=this.j.get(g);if(t){if(t.children)for(const s of t.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}t.children=void 0}}else this.pb()}ob(g){const t=this.j.get(g);if(t){if(t.children)for(const s of t.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}this.j.delete(g),this.i.delete(t.item.handle),t.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(g=>g.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}y.a="0",y.b="1"}),define(Ce[255],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",getSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.getSessions.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Ce[256],ke([1,0,203,8,38,122,93,40,25,255,216,128]),function(ae,e,o,R,l,L,A,P,D,p,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const E=P.Registry.as(A.Extensions.JSONContribution);class T{constructor(g,t,s){this.a=g,this.b=t,this.c=s}d(g,t){this.a({type:g,message:t,extensionId:this.b.identifier,extensionPointId:this.c})}error(g){this.d(l.default.Error,g)}warn(g){this.d(l.default.Warning,g)}info(g){this.d(l.default.Info,g)}}e.ExtensionMessageCollector=T;class I{static a(g){const t=new D.ExtensionIdentifierSet;for(let s=0,r=g.length;s<r;s++)t.add(g[s].description.identifier);return t}static compute(g,t){if(!g||!g.length)return new I(t,[]);if(!t||!t.length)return new I([],g);const s=this.a(g),r=this.a(t),a=t.filter(S=>!s.has(S.description.identifier)),b=g.filter(S=>!r.has(S.description.identifier));return new I(a,b)}constructor(g,t){this.added=g,this.removed=t}}e.ExtensionPointUserDelta=I;class v{constructor(g,t){this.name=g,this.defaultExtensionKind=t,this.a=null,this.b=null,this.c=null}setHandler(g){if(this.a!==null)throw new Error("Handler already set!");this.a=g,this.d()}acceptUsers(g){this.c=I.compute(this.b,g),this.b=g,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(g){(0,R.onUnexpectedError)(g)}}}e.ExtensionPoint=v;const i={type:"string",enum:["ui","workspace"],enumDescriptions:[o.localize(0,null),o.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:o.localize(2,null),properties:{vscode:{type:"string",description:o.localize(3,null),default:"^1.22.0"}}},publisher:{description:o.localize(4,null),type:"string"},displayName:{description:o.localize(5,null),type:"string"},categories:{description:o.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:D.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:o.localize(7,null)}]}},galleryBanner:{type:"object",description:o.localize(8,null),properties:{color:{description:o.localize(9,null),type:"string"},theme:{description:o.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:o.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:o.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:o.localize(13,null)},enabledApiProposals:{markdownDescription:o.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(p.allApiProposals),markdownEnumDescriptions:Object.values(p.allApiProposals)}},api:{markdownDescription:o.localize(15,null),type:"string",enum:["none"],enumDescriptions:[o.localize(16,null)]},activationEvents:{description:o.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:o.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:o.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:o.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:o.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:o.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:o.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:o.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:o.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:o.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:o.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:o.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:o.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:o.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:o.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:o.localize(32,null)},{label:"onUri",body:"onUri",description:o.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:o.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:o.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:o.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:o.localize(37,null)},{label:"onRenderer",description:o.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:o.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:o.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:o.localize(41,null)},{label:"*",description:o.localize(42,null),body:"*"}]}},badges:{type:"array",description:o.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:o.localize(44,null)},href:{type:"string",description:o.localize(45,null)},description:{type:"string",description:o.localize(46,null)}}}},markdown:{type:"string",description:o.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:o.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:o.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:o.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:o.localize(51,null),type:"array",items:i,default:["workspace"],defaultSnippets:[{body:["ui"],description:o.localize(52,null)},{body:["workspace"],description:o.localize(53,null)},{body:["ui","workspace"],description:o.localize(54,null)},{body:["workspace","ui"],description:o.localize(55,null)},{body:[],description:o.localize(56,null)}]},capabilities:{description:o.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:o.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:o.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(60,null),o.localize(61,null),o.localize(62,null)]},description:{type:"string",markdownDescription:o.localize(63,null)}}},untrustedWorkspaces:{description:o.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:o.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(66,null),o.localize(67,null),o.localize(68,null)]},restrictedConfigurations:{description:o.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:o.localize(70,null)}}}}},sponsor:{description:o.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:o.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:o.localize(73,null),type:"string"},"vscode:uninstall":{description:o.localize(74,null),type:"string"}}},icon:{type:"string",description:o.localize(75,null)},l10n:{type:"string",description:o.localize(76,null)}}};class h{constructor(){this.a=new Map}registerExtensionPoint(g){if(this.a.has(g.extensionPoint))throw new Error("Duplicate extension point: "+g.extensionPoint);const t=new v(g.extensionPoint,g.defaultExtensionKind);return this.a.set(g.extensionPoint,t),g.activationEventsGenerator&&k.ImplicitActivationEvents.register(g.extensionPoint,g.activationEventsGenerator),e.schema.properties.contributes.properties[g.extensionPoint]=g.jsonSchema,E.registerSchema(d,e.schema),t}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=h;const y={ExtensionsRegistry:"ExtensionsRegistry"};P.Registry.add(y.ExtensionsRegistry,new h),e.ExtensionsRegistry=P.Registry.as(y.ExtensionsRegistry),E.registerSchema(d,e.schema),E.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:o.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(p.allApiProposals),markdownEnumDescriptions:Object.values(p.allApiProposals)}}]}}}})}),define(Ce[257],ke([1,0,200,10,23,256,44,3]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const D={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:o.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:o.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:o.localize(2,null),default:""}}};var p;(function(E){function T(I,v,i){if(!I)return;const d=R.isString(I.type)?I.type:void 0;if(!d||d.length===0){i.error(o.localize(3,null));return}const h=[];if(Array.isArray(I.required))for(const y of I.required)R.isString(y)&&h.push(y);return{extensionId:v.value,taskType:d,required:h,properties:I.properties?l.deepClone(I.properties):{},when:I.when?A.ContextKeyExpr.deserialize(I.when):void 0}}E.from=T})(p||(p={}));const O=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(E,T)=>{for(const I of E)I.type&&T.push(`onTaskType:${I.type}`)},jsonSchema:{description:o.localize(4,null),type:"array",items:D}});class k{constructor(){this.d=new P.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((T,I)=>{O.setHandler((v,i)=>{this.c=void 0;try{for(const d of i.removed){const h=d.value;for(const y of h)this.a&&y.type&&this.a[y.type]&&delete this.a[y.type]}for(const d of i.added){const h=d.value;for(const y of h){const w=p.from(y,d.description.identifier,d.collector);w&&(this.a[w.taskType]=w)}}(i.removed.length>0||i.added.length>0)&&this.d.fire()}catch{}T(void 0)})})}onReady(){return this.b}get(T){return this.a[T]}all(){return Object.keys(this.a).map(T=>this.a[T])}getJsonSchema(){if(this.c===void 0){const T=[];for(const I of this.all()){const v={type:"object",additionalProperties:!1};I.required.length>0&&(v.required=I.required.slice(0)),I.properties!==void 0?v.properties=l.deepClone(I.properties):v.properties=Object.create(null),v.properties.type={type:"string",enum:[I.taskType]},T.push(v)}this.c={oneOf:T}}return this.c}}e.TaskDefinitionRegistry=new k}),define(Ce[258],ke([1,0,201,10,24,23,44,257]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new A.RawContextKey("taskRunning",!1,o.localize(0,null)),e.TASKS_CATEGORY={value:o.localize(1,null),original:"Tasks"};var D;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(D||(e.ShellQuoting=D={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(z){function G(F){if(!F)return z.Strong;switch(F.toLowerCase()){case"escape":return z.Escape;case"strong":return z.Strong;case"weak":return z.Weak;default:return z.Strong}}z.from=G}(D||(e.ShellQuoting=D={}));var p;(function(z){z.defaults={cwd:"${workspaceFolder}"}})(p||(e.CommandOptions=p={}));var O;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(O||(e.RevealKind=O={})),function(z){function G(F){switch(F.toLowerCase()){case"always":return z.Always;case"silent":return z.Silent;case"never":return z.Never;default:return z.Always}}z.fromString=G}(O||(e.RevealKind=O={}));var k;(function(z){z[z.Never=1]="Never",z[z.OnProblem=2]="OnProblem",z[z.Always=3]="Always"})(k||(e.RevealProblemKind=k={})),function(z){function G(F){switch(F.toLowerCase()){case"always":return z.Always;case"never":return z.Never;case"onproblem":return z.OnProblem;default:return z.OnProblem}}z.fromString=G}(k||(e.RevealProblemKind=k={}));var E;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(E||(e.PanelKind=E={})),function(z){function G(F){switch(F.toLowerCase()){case"shared":return z.Shared;case"dedicated":return z.Dedicated;case"new":return z.New;default:return z.Shared}}z.fromString=G}(E||(e.PanelKind=E={}));var T;(function(z){z.defaults={echo:!0,reveal:O.Always,revealProblems:k.Never,focus:!1,panel:E.Shared,showReuseMessage:!0,clear:!1}})(T||(e.PresentationOptions=T={}));var I;(function(z){z[z.Shell=1]="Shell",z[z.Process=2]="Process",z[z.CustomExecution=3]="CustomExecution"})(I||(e.RuntimeType=I={})),function(z){function G($){switch($.toLowerCase()){case"shell":return z.Shell;case"process":return z.Process;case"customExecution":return z.CustomExecution;default:return z.Process}}z.fromString=G;function F($){switch($){case z.Shell:return"shell";case z.Process:return"process";case z.CustomExecution:return"customExecution";default:return"process"}}z.toString=F}(I||(e.RuntimeType=I={}));var v;(function(z){function G(F){return R.isString(F)?F:F.value}z.value=G})(v||(e.CommandString=v={}));var i;(function(z){z.Clean={_id:"clean",isDefault:!1},z.Build={_id:"build",isDefault:!1},z.Rebuild={_id:"rebuild",isDefault:!1},z.Test={_id:"test",isDefault:!1};function G($){return $===z.Clean._id||$===z.Build._id||$===z.Rebuild._id||$===z.Test._id}z.is=G;function F($){if($!==void 0)return R.isString($)?G($)?{_id:$,isDefault:!1}:void 0:$}z.from=F})(i||(e.TaskGroup=i={}));var d;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.Folder=3]="Folder"})(d||(e.TaskScope=d={}));var h;(function(z){z.Workspace="workspace",z.Extension="extension",z.InMemory="inMemory",z.WorkspaceFile="workspaceFile",z.User="user";function G(F){switch(F){case z.User:return 2;case z.WorkspaceFile:return 5;default:return 6}}z.toConfigurationTarget=G})(h||(e.TaskSourceKind=h={}));var y;(function(z){z.parallel="parallel",z.sequence="sequence"})(y||(e.DependsOrder=y={}));var w;(function(z){z[z.default=1]="default",z[z.folderOpen=2]="folderOpen"})(w||(e.RunOnOptions=w={}));var g;(function(z){z.defaults={reevaluateOnRerun:!0,runOn:w.default,instanceLimit:1}})(g||(e.RunOptions=g={}));class t{constructor(G,F,$,Y,_,Q){this._label="",this._id=G,F&&(this._label=F),$&&(this.type=$),this.runOptions=Y,this.configurationProperties=_,this._source=Q}getDefinition(G){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const G={folder:this.d(),id:this._id};return JSON.stringify(G)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(G,F=!1){if(G===void 0)return!1;if(R.isString(G))return G===this._label||G===this.configurationProperties.identifier||F&&G===this._id;const $=this.getDefinition(!0);return $!==void 0&&$._key===G._key}getQualifiedLabel(){const G=this.getWorkspaceFolder();return G?`${this._label} (${G.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(G){this.c===void 0&&(this.c=[]),G&&(this.c=this.c.concat(G))}get taskLoadMessages(){return this.c}}e.CommonTask=t;class s extends t{constructor(G,F,$,Y,_,Q,ie,oe){super(G,$,void 0,ie,oe,F),this.command={},this._source=F,this.hasDefinedMatchers=Q,_&&(this.command=_)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(G=!1){if(G&&this._source.customizes!==void 0)return this._source.customizes;{let F;switch(this.command?this.command.runtime:void 0){case I.Shell:F="shell";break;case I.Process:F="process";break;case I.CustomExecution:F="customExecution";break;case void 0:F="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:F,_key:this._id,id:this._id}}}static is(G){return G instanceof s}getMapKey(){const G=this._source.config.workspaceFolder;return G?`${G.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===h.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const G=this.d();if(!G)return;let F=this.configurationProperties.identifier;this._source.kind!==h.Workspace&&(F+=this._source.kind);const $={type:e.CUSTOMIZED_TASK_TYPE,folder:G,id:F};return JSON.stringify($)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(G){return new s(G._id,G._source,G._label,G.type,G.command,G.hasDefinedMatchers,G.runOptions,G.configurationProperties)}}e.CustomTask=s;class r extends t{constructor(G,F,$,Y,_,Q,ie){super(G,$,Y,Q,ie,F),this._source=F,this.configures=_}static is(G){return G instanceof r}f(G){return G}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===h.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const G=this.d();if(!G)return;let F=this.configurationProperties.identifier;this._source.kind!==h.Workspace&&(F+=this._source.kind);const $={type:e.CUSTOMIZED_TASK_TYPE,folder:G,id:F};return JSON.stringify($)}}e.ConfiguringTask=r;class a extends t{constructor(G,F,$,Y,_,Q,ie,oe,Ee){super(G,$,Y,oe,Ee,F),this.defines=_,this.hasDefinedMatchers=ie,this.command=Q,this.icon=Ee.icon,this.hide=Ee.hide}clone(){return new a(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(G){return G instanceof a}getMapKey(){const G=this._source.workspaceFolder;return G?`${this._source.scope.toString()}|${G.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const G={type:"contributed",scope:this._source.scope,id:this._id};return G.folder=this.d(),JSON.stringify(G)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(G){return new a(G._id,G._source,G._label,G.type,G.defines,G.command,G.hasDefinedMatchers,G.runOptions,G.configurationProperties)}}e.ContributedTask=a;class b extends t{constructor(G,F,$,Y,_,Q){super(G,$,Y,_,Q,F),this._source=F}clone(){return new b(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(G){return G instanceof b}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(G){return new b(G._id,G._source,G._label,G.type,G.runOptions,G.configurationProperties)}}e.InMemoryTask=b;var S;(function(z){z[z.Process=1]="Process",z[z.Terminal=2]="Terminal"})(S||(e.ExecutionEngine=S={})),function(z){z._default=z.Terminal}(S||(e.ExecutionEngine=S={}));var c;(function(z){z[z.V0_1_0=1]="V0_1_0",z[z.V2_0_0=2]="V2_0_0"})(c||(e.JsonSchemaVersion=c={}));class u{constructor(G){this.c=new Map;for(let F=0;F<G.length;F++)this.c.set(G[F].uri.toString(),F)}compare(G,F){const $=G.getWorkspaceFolder(),Y=F.getWorkspaceFolder();if($&&Y){let _=this.c.get($.uri.toString());_=_===void 0?0:_+1;let Q=this.c.get(Y.uri.toString());return Q=Q===void 0?0:Q+1,_===Q?G._label.localeCompare(F._label):_-Q}else return!$&&Y?-1:$&&!Y?1:0}}e.TaskSorter=u;var m;(function(z){z.DependsOnStarted="dependsOnStarted",z.AcquiredInput="acquiredInput",z.Start="start",z.ProcessStarted="processStarted",z.Active="active",z.Inactive="inactive",z.Changed="changed",z.Terminated="terminated",z.ProcessEnded="processEnded",z.End="end"})(m||(e.TaskEventKind=m={}));var f;(function(z){z.SingleRun="singleRun",z.Background="background"})(f||(e.TaskRunType=f={}));var n;(function(z){z[z.System=0]="System",z[z.User=1]="User",z[z.FolderOpen=2]="FolderOpen",z[z.ConfigurationChange=3]="ConfigurationChange",z[z.Reconnect=4]="Reconnect"})(n||(e.TaskRunSource=n={}));var C;(function(z){function G(F,$,Y,_){if($){const Q={kind:F,taskId:$._id,taskName:$.configurationProperties.name,runType:$.configurationProperties.isBackground?"background":"singleRun",group:$.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:Y,__task:$};return F==="start"?Q.resolvedVariables=_:F==="processStarted"?Q.processId=_:F==="processEnded"&&(Q.exitCode=_),Object.freeze(Q)}else return Object.freeze({kind:"changed"})}z.create=G})(C||(e.TaskEvent=C={}));var M;(function(z){function G($){const Y=Object.keys($).sort();let _="";for(const Q of Y){let ie=$[Q];ie instanceof Object?ie=G(ie):typeof ie=="string"&&(ie=ie.replace(/,/g,",,")),_+=Q+","+ie+","}return _}function F($){const _={_key:G($),type:$.taskType};return Object.assign(_,$),_}z.create=F})(M||(e.KeyedTaskIdentifier=M={}));var H;(function(z){z.AutoDetect="task.autoDetect",z.SaveBeforeRun="task.saveBeforeRun",z.ShowDecorations="task.showDecorations",z.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",z.SlowProviderWarning="task.slowProviderWarning",z.QuickOpenHistory="task.quickOpen.history",z.QuickOpenDetail="task.quickOpen.detail",z.QuickOpenSkip="task.quickOpen.skip",z.QuickOpenShowAll="task.quickOpen.showAll",z.AllowAutomaticTasks="task.allowAutomaticTasks",z.Reconnection="task.reconnection"})(H||(e.TaskSettingId=H={}));var V;(function(z){z.Tasks="tasks",z.SuppressTaskName="tasks.suppressTaskName",z.Windows="tasks.windows",z.Osx="tasks.osx",z.Linux="tasks.linux",z.ShowOutput="tasks.showOutput",z.IsShellCommand="tasks.isShellCommand",z.ServiceTestSetting="tasks.service.testSetting"})(V||(e.TasksSchemaProperties=V={}));var U;(function(z){function G(F,$){const Y=P.TaskDefinitionRegistry.get(F.type);if(Y===void 0){const oe=L.deepClone(F);return delete oe._key,M.create(oe)}const _=Object.create(null);_.type=Y.taskType;const Q=new Set;Y.required.forEach(oe=>Q.add(oe));const ie=Y.properties;for(const oe of Object.keys(ie)){const Ee=F[oe];if(Ee!=null)_[oe]=Ee;else if(Q.has(oe)){const he=ie[oe];if(he.default!==void 0)_[oe]=L.deepClone(he.default);else switch(he.type){case"boolean":_[oe]=!1;break;case"number":case"integer":_[oe]=0;break;case"string":_[oe]="";break;default:$.error(o.localize(2,null,JSON.stringify(F,void 0,0),oe));return}}}return M.create(_)}z.createTaskIdentifier=G})(U||(e.TaskDefinition=U={}))}),define(Ce[259],ke([1,0,8]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class R{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,P)=>{this.b=A,this.d=P,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,o.onUnexpectedError)(A))}then(A,P){return this.j().then(A,P)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.LazyPromise=R;class l extends R{constructor(){super(),this.h=!0,this.i=new o.CancellationError}}e.CanceledLazyPromise=l}),define(Ce[59],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class o{constructor(D){this._proxyIdentifierBrand=void 0,this.sid=D,this.nid=++o.count}}e.ProxyIdentifier=o,o.count=0;const R=[];function l(P){const D=new o(P);return R[D.nid]=D,D}e.createProxyIdentifier=l;function L(P){return R[P].sid}e.getStringIdentifierForProxy=L;class A{constructor(D){this.value=D}}e.SerializableObjectWithBuffers=A}),define(Ce[5],ke([1,0,59]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var R;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(R||(e.TextEditorRevealType=R={}));var l;(function(v){v[v.UnknownInput=0]="UnknownInput",v[v.TextInput=1]="TextInput",v[v.TextDiffInput=2]="TextDiffInput",v[v.TextMergeInput=3]="TextMergeInput",v[v.NotebookInput=4]="NotebookInput",v[v.NotebookDiffInput=5]="NotebookDiffInput",v[v.CustomEditorInput=6]="CustomEditorInput",v[v.WebviewEditorInput=7]="WebviewEditorInput",v[v.TerminalEditorInput=8]="TerminalEditorInput",v[v.InteractiveEditorInput=9]="InteractiveEditorInput"})(l||(e.TabInputKind=l={}));var L;(function(v){v[v.TAB_OPEN=0]="TAB_OPEN",v[v.TAB_CLOSE=1]="TAB_CLOSE",v[v.TAB_UPDATE=2]="TAB_UPDATE",v[v.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var A;(function(v){v[v.Editable=0]="Editable",v[v.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var P;(function(v){v[v.Int8Array=1]="Int8Array",v[v.Uint8Array=2]="Uint8Array",v[v.Uint8ClampedArray=3]="Uint8ClampedArray",v[v.Int16Array=4]="Int16Array",v[v.Uint16Array=5]="Uint16Array",v[v.Int32Array=6]="Int32Array",v[v.Uint32Array=7]="Uint32Array",v[v.Float32Array=8]="Float32Array",v[v.Float64Array=9]="Float64Array",v[v.BigInt64Array=10]="BigInt64Array",v[v.BigUint64Array=11]="BigUint64Array"})(P||(e.WebviewMessageArrayBufferViewType=P={}));var D;(function(v){v[v.Text=1]="Text",v[v.Error=2]="Error",v[v.Rich=3]="Rich"})(D||(e.CellOutputKind=D={}));var p;(function(v){v[v.Default=0]="Default",v[v.InCenter=1]="InCenter",v[v.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",v[v.AtTop=3]="AtTop"})(p||(e.NotebookEditorRevealType=p={}));var O;(function(v){v[v.None=0]="None",v[v.Process=1]="Process",v[v.Output=2]="Output"})(O||(e.CandidatePortSource=O={}));class k{static mixin(i){return i._id=k.a++,i}}e.IdObject=k,k.a=0;var E;(function(v){v.label="a",v.kind="b",v.detail="c",v.documentation="d",v.sortText="e",v.filterText="f",v.preselect="g",v.insertText="h",v.insertTextRules="i",v.range="j",v.commitCharacters="k",v.additionalTextEdits="l",v.kindModifier="m",v.commandIdent="n",v.commandId="o",v.commandArguments="p"})(E||(e.ISuggestDataDtoField=E={}));var T;(function(v){v.defaultRanges="a",v.completions="b",v.isIncomplete="c",v.duration="d"})(T||(e.ISuggestResultDtoField=T={}));var I;(function(v){v[v.Workspace=0]="Workspace",v[v.TextDocument=1]="TextDocument"})(I||(e.ExtHostTestingResource=I={})),e.MainContext={MainThreadAuthentication:(0,o.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,o.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,o.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,o.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,o.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,o.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,o.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,o.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,o.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,o.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,o.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,o.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,o.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,o.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,o.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,o.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,o.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,o.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,o.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,o.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,o.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,o.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,o.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,o.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,o.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,o.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,o.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,o.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,o.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,o.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,o.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,o.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,o.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,o.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,o.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,o.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,o.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,o.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,o.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,o.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,o.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,o.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,o.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,o.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,o.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,o.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,o.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,o.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,o.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,o.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,o.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,o.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,o.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,o.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,o.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,o.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,o.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,o.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,o.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,o.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,o.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,o.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,o.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,o.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,o.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,o.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,o.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,o.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,o.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,o.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,o.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,o.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,o.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,o.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,o.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,o.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,o.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,o.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,o.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,o.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,o.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,o.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,o.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,o.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,o.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,o.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,o.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,o.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,o.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,o.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,o.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,o.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,o.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,o.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,o.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,o.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,o.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,o.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,o.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,o.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,o.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,o.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,o.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,o.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,o.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,o.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,o.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,o.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,o.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,o.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,o.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,o.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,o.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostSemanticSimilarity:(0,o.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,o.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,o.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,o.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,o.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,o.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,o.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,o.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,o.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Ce[79],ke([1,0,4,16,5,20]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,o.createDecorator)("IExtHostApiDeprecationService");let A=e.ExtHostApiDeprecationService=class{constructor(D,p){this.c=p,this.a=new Set,this.b=D.getProxy(l.MainContext.MainThreadTelemetry)}report(D,p,O){const k=this.d(D,p);this.a.has(k)||(this.a.add(k),p.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${D}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:p.identifier.value,apiId:D}))}d(D,p){return`${D}-${p.identifier.value}`}};e.ExtHostApiDeprecationService=A=xe([We(0,L.IExtHostRpcService),We(1,R.ILogService)],A),e.NullApiDeprecationService=Object.freeze(new class{report(P,D,p){}})}),define(Ce[260],ke([1,0,3,5,7,25]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class A{constructor(p){this.b=new Map,this.c=[],this.d=new o.Emitter,this.onDidChangeSessions=this.d.event,this.f=new P,this.g=new P,this.a=p.getProxy(R.MainContext.MainThreadAuthentication)}$setProviders(p){return this.c=p,Promise.resolve()}async getSession(p,O,k,E={}){const T=L.ExtensionIdentifier.toKey(p.identifier),I=[...k].sort().join(" ");return await this.f.getOrCreate(`${T} ${O} ${I}`,async()=>{await this.a.$ensureProvider(O);const v=p.displayName||p.name;return this.a.$getSession(O,k,T,v,E)})}async getSessions(p,O,k){const E=L.ExtensionIdentifier.toKey(p.identifier),T=[...k].sort().join(" ");return await this.g.getOrCreate(`${E} ${T}`,async()=>{await this.a.$ensureProvider(O);const I=p.displayName||p.name;return this.a.$getSessions(O,k,E,I)})}async removeSession(p,O){const k=this.b.get(p);return k?k.provider.removeSession(O):this.a.$removeSession(p,O)}registerAuthenticationProvider(p,O,k,E){if(this.b.get(p))throw new Error(`An authentication provider with id '${p}' is already registered.`);this.b.set(p,{label:O,provider:k,options:E??{supportsMultipleAccounts:!1}}),this.c.find(I=>I.id===p)||this.c.push({id:p,label:O});const T=k.onDidChangeSessions(I=>{this.a.$sendDidChangeSessions(p,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this.a.$registerAuthenticationProvider(p,O,E?.supportsMultipleAccounts??!1),new l.Disposable(()=>{T.dispose(),this.b.delete(p);const I=this.c.findIndex(v=>v.id===p);I>-1&&this.c.splice(I),this.a.$unregisterAuthenticationProvider(p)})}$createSession(p,O){const k=this.b.get(p);if(k)return Promise.resolve(k.provider.createSession(O));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$removeSession(p,O){const k=this.b.get(p);if(k)return Promise.resolve(k.provider.removeSession(O));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$getSessions(p,O){const k=this.b.get(p);if(k)return Promise.resolve(k.provider.getSessions(O));throw new Error(`Unable to find authentication provider with handle: ${p}`)}$onDidChangeAuthenticationSessions(p,O){return this.d.fire({provider:{id:p,label:O}}),Promise.resolve()}}e.ExtHostAuthentication=A;class P{constructor(){this.a=new Map}getOrCreate(p,O){const k=this.a.get(p);if(k)return k;const E=O().finally(()=>this.a.delete(p));return this.a.set(p,E),E}}}),define(Ce[261],ke([1,0,5,20,11]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=e.ExtHostBulkEdits=class{constructor(P,D){this.a=P.getProxy(o.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:p=>D.getDocument(p)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(P,D,p){const O=l.WorkspaceEdit.from(P,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,p?.isRefactoring??!1)}};e.ExtHostBulkEdits=L=xe([We(0,R.IExtHostRpcService)],L)}),define(Ce[262],ke([1,0,5]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class R{constructor(L){const A=L.getProxy(o.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(P){return A.$writeText(P)}})}}e.ExtHostClipboard=R});var _e=this&&this.__classPrivateFieldSet||function(ae,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!l:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(ae,o):l?l.value=o:e.set(ae,o),o},Be=this&&this.__classPrivateFieldGet||function(ae,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!R:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(ae):R?R.value:e.get(ae)};define(Ce[41],ke([1,0,10,7,11,23,5,18,16,70,32,54,2,6,4,20,138,22,59,46,37,75,78]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d,h,y,w,g,t){"use strict";var s,r,a;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let b=e.ExtHostCommands=class{constructor(n,C,M){s.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),a.set(this,void 0),_e(this,s,n.getProxy(A.MainContext.MainThreadCommands),"f"),this.d=C,_e(this,a,M,"f"),_e(this,r,n.getProxy(A.MainContext.MainThreadTelemetry),"f"),this.converter=new S(this,H=>{const V=this.c.get(H);return V?.result===u.Void?V:void 0},C),this.f=[{processArgument(H){return(0,p.revive)(H)}},{processArgument(H){return(0,L.cloneAndChange)(H,function(V){if(O.Range.isIRange(V))return l.Range.to(V);if(k.Position.isIPosition(V))return l.Position.to(V);if(O.Range.isIRange(V.range)&&E.URI.isUri(V.uri))return l.location.to(V);if(V instanceof d.VSBuffer)return V.buffer.buffer;if(!Array.isArray(V))return V})}}]}registerArgumentProcessor(n){this.f.push(n)}registerApiCommand(n){const C=this.registerCommand(!1,n.id,async(...M)=>{const H=n.args.map((U,z)=>{if(!U.validate(M[z]))throw new Error(`Invalid argument '${U.name}' when running '${n.id}', received: ${M[z]}`);return U.convert(M[z])}),V=await this.executeCommand(n.internalId,...H);return n.result.convert(V,M,this.converter)},void 0,{description:n.description,args:n.args,returns:n.result.description});return this.c.set(n.id,n),new R.Disposable(()=>{C.dispose(),this.c.delete(n.id)})}registerCommand(n,C,M,H,V,U){if(this.d.trace("ExtHostCommands#registerCommand",C),!C.trim().length)throw new Error("invalid id");if(this.b.has(C))throw new Error(`command '${C}' already exists`);return this.b.set(C,{callback:M,thisArg:H,description:V,extension:U}),n&&Be(this,s,"f").$registerCommand(C),new R.Disposable(()=>{this.b.delete(C)&&n&&Be(this,s,"f").$unregisterCommand(C)})}executeCommand(n,...C){return this.d.trace("ExtHostCommands#executeCommand",n),this.g(n,C,!0)}async g(n,C,M){if(this.b.has(n))return Be(this,s,"f").$fireCommandActivationEvent(n),this.h(n,C,!1);{let H=!1;const V=(0,L.cloneAndChange)(C,function(U){if(U instanceof R.Position)return l.Position.from(U);if(U instanceof R.Range)return l.Range.from(U);if(U instanceof R.Location)return l.location.from(U);if(R.NotebookRange.isNotebookRange(U))return l.NotebookRange.from(U);if(U instanceof ArrayBuffer)return H=!0,d.VSBuffer.wrap(new Uint8Array(U));if(U instanceof Uint8Array)return H=!0,d.VSBuffer.wrap(U);if(U instanceof d.VSBuffer)return H=!0,U;if(!Array.isArray(U))return U});try{const U=await Be(this,s,"f").$executeCommand(n,H?new h.SerializableObjectWithBuffers(V):V,M);return(0,p.revive)(U)}catch(U){if(U instanceof Error&&U.message==="$executeCommand:retry")return this.g(n,C,!1);throw U}}}async h(n,C,M){const H=this.b.get(n);if(!H)throw new Error("Unknown command");const{callback:V,thisArg:U,description:z}=H;if(z)for(let F=0;F<z.args.length;F++)try{(0,o.validateConstraint)(C[F],z.args[F].constraint)}catch{throw new Error(`Running the contributed command: '${n}' failed. Illegal argument '${z.args[F].name}' - ${z.args[F].description}`)}const G=w.StopWatch.create();try{return await V.apply(U,C)}catch(F){if(n===this.converter.delegatingCommandId){const $=this.converter.getActualCommand(...C);$&&(n=$.command)}if(this.d.error(F,n,H.extension?.identifier),!M)throw F;if(H.extension?.identifier){const $=Be(this,a,"f").onExtensionError(H.extension.identifier,F);this.d.trace("forwarded error to extension?",$,H.extension?.identifier)}throw new class extends Error{constructor(){super((0,y.toErrorMessage)(F)),this.id=n,this.source=H.extension?.displayName??H.extension?.name}}}finally{this.j(H,n,G.elapsed())}}j(n,C,M){n.extension&&Be(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:n.extension.identifier.value,id:new g.TelemetryTrustedValue(C),duration:M})}$executeContributedCommand(n,...C){this.d.trace("ExtHostCommands#$executeContributedCommand",n);const M=this.b.get(n);return M?(C=C.map(H=>this.f.reduce((V,U)=>U.processArgument(V,M.extension?.identifier),H)),this.h(n,C,!0)):Promise.reject(new Error(`Contributed command '${n}' does not exist.`))}getCommands(n=!1){return this.d.trace("ExtHostCommands#getCommands",n),Be(this,s,"f").$getCommands().then(C=>(n&&(C=C.filter(M=>M[0]!=="_")),C))}$getContributedCommandHandlerDescriptions(){const n=Object.create(null);for(const[C,M]of this.b){const{description:H}=M;H&&(n[C]=H)}return Promise.resolve(n)}};s=new WeakMap,r=new WeakMap,a=new WeakMap,e.ExtHostCommands=b=xe([We(0,v.IExtHostRpcService),We(1,D.ILogService),We(2,t.IExtHostTelemetry)],b),e.IExtHostCommands=(0,I.createDecorator)("IExtHostCommands");class S{constructor(n,C,M){this.d=n,this.f=C,this.g=M,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(n,C){if(!n)return;const M={$ident:void 0,id:n.command,title:n.title,tooltip:n.tooltip};if(!n.command)return M;const H=this.f(n.command);if(H)M.id=H.internalId,M.arguments=H.args.map((V,U)=>V.convert(n.arguments&&n.arguments[U]));else if((0,P.isNonEmptyArray)(n.arguments)){const V=`${n.command}/${++this.c}`;this.b.set(V,n),C.add((0,T.toDisposable)(()=>{this.b.delete(V),this.g.trace("CommandsConverter#DISPOSE",V)})),M.$ident=V,M.id=this.delegatingCommandId,M.arguments=[V],this.g.trace("CommandsConverter#CREATE",n.command,V)}return M}fromInternal(n){return typeof n.$ident=="string"?this.b.get(n.$ident):{command:n.id,title:n.title,arguments:n.arguments}}getActualCommand(...n){return this.b.get(n[0])}h(...n){const C=this.getActualCommand(...n);return this.g.trace("CommandsConverter#EXECUTE",n[0],C?C.command:"MISSING"),C?this.d.executeCommand(C.command,...C.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${n[0]}`)}}e.CommandsConverter=S;class c{constructor(n,C,M,H){this.name=n,this.description=C,this.validate=M,this.convert=H}optional(){return new c(this.name,`(optional) ${this.description}`,n=>n==null||this.validate(n),n=>n===void 0?void 0:n===null?null:this.convert(n))}with(n,C){return new c(n??this.name,C??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",f=>E.URI.isUri(f),f=>f),c.Position=new c("position","A position in a text document",f=>R.Position.isPosition(f),l.Position.from),c.Range=new c("range","A range in a text document",f=>R.Range.isRange(f),l.Range.from),c.Selection=new c("selection","A selection in a text document",f=>R.Selection.isSelection(f),l.Selection.from),c.Number=new c("number","",f=>typeof f=="number",f=>f),c.String=new c("string","",f=>typeof f=="string",f=>f),c.CallHierarchyItem=new c("item","A call hierarchy item",f=>f instanceof R.CallHierarchyItem,l.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",f=>f instanceof R.TypeHierarchyItem,l.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VS Code TestItem",f=>f instanceof i.TestItemImpl,l.TestItem.from);class u{constructor(n,C){this.description=n,this.convert=C}}e.ApiCommandResult=u,u.Void=new u("no result",f=>f);class m{constructor(n,C,M,H,V){this.id=n,this.internalId=C,this.description=M,this.args=H,this.result=V}}e.ApiCommand=m}),define(Ce[263],ke([1,0,18,17,2,73,120,44,124,41,11,7]),function(ae,e,o,R,l,L,A,P,D,p,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const E=[new p.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",I(O.DocumentHighlight.to))),new p.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(i,d)=>{if((0,o.isFalsyOrEmpty)(i))return;class h extends k.SymbolInformation{static to(w){const g=new h(w.name,O.SymbolKind.to(w.kind),w.containerName||"",new k.Location(d[0],O.Range.to(w.range)));return g.detail=w.detail,g.range=g.location.range,g.selectionRange=O.Range.to(w.selectionRange),g.children=w.children?w.children.map(h.to):[],g}}return i.map(h.to)})),new p.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(O.TextEdit.to))),new p.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range,new p.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(O.TextEdit.to))),new p.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,new p.ApiCommandArgument("ch","Trigger character",i=>typeof i=="string",i=>i),new p.ApiCommandArgument("options","Formatting options",i=>!0,i=>i)],new p.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(O.TextEdit.to))),new p.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",v)),new p.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Location-instances.",I(O.location.to))),new p.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of Hover-instances.",I(O.Hover.to))),new p.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("position","A position in a text document",i=>Array.isArray(i)&&i.every(d=>k.Position.isPosition(d)),i=>i.map(O.Position.from))],new p.ApiCommandResult("A promise that resolves to an array of ranges.",i=>i.map(d=>{let h;for(const y of d.reverse())h=new k.SelectionRange(O.Range.to(y),h);return h}))),new p.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[p.ApiCommandArgument.String.with("query","Search string")],new p.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",i=>i.map(O.WorkspaceSymbol.to))),new p.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",i=>i.map(O.CallHierarchyItem.to))),new p.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",i=>i.map(O.CallHierarchyIncomingCall.to))),new p.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[p.ApiCommandArgument.CallHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",i=>i.map(O.CallHierarchyOutgoingCall.to))),new p.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to a range and placeholder text.",i=>{if(i)return{range:O.Range.to(i.range),placeholder:i.text}})),new p.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("newName","The new symbol name")],new p.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",i=>{if(i){if(i.rejectReason)throw new Error(i.rejectReason);return O.WorkspaceEdit.to(i)}})),new p.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new p.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",i=>i.map(O.DocumentLink.to))),new p.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(i)return new k.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const d=(0,A.decodeSemanticTokensDto)(i);if(d.type==="full")return new k.SemanticTokens(d.data,void 0)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range.optional()],new p.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",i=>{if(i)return new k.SemanticTokensLegend(i.tokenTypes,i.tokenModifiers)})),new p.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to SemanticTokens.",i=>{if(!i)return;const d=(0,A.decodeSemanticTokensDto)(i);if(d.type==="full")return new k.SemanticTokens(d.data,void 0)})),new p.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new p.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(i,d,h)=>{if(!i)return new k.CompletionList([]);const y=i.suggestions.map(w=>O.CompletionItem.to(w,h));return new k.CompletionList(y,i.incomplete)})),new p.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position,p.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new p.ApiCommandResult("A promise that resolves to SignatureHelp.",i=>{if(i)return O.SignatureHelp.to(i)})),new p.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new p.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(i,d,h)=>I(y=>new k.CodeLens(O.Range.to(y.range),y.command&&h.fromInternal(y.command)))(i))),new p.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[p.ApiCommandArgument.Uri,new p.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",i=>k.Range.isRange(i),i=>k.Selection.isSelection(i)?O.Selection.from(i):O.Range.from(i)),p.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),p.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new p.ApiCommandResult("A promise that resolves to an array of Command-instances.",(i,d,h)=>I(y=>{if(y._isSynthetic){if(!y.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(y.command)}else{const w=new k.CodeAction(y.title,y.kind?new k.CodeActionKind(y.kind):void 0);return y.edit&&(w.edit=O.WorkspaceEdit.to(y.edit)),y.command&&(w.command=h.fromInternal(y.command)),w.isPreferred=y.isPreferred,w}})(i))),new p.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",i=>i?i.map(d=>new k.ColorInformation(O.Range.to(d.range),O.Color.to(d.color))):[])),new p.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new p.ApiCommandArgument("color","The color to show and insert",i=>i instanceof k.Color,O.Color.from),new p.ApiCommandArgument("context","Context object with uri and range",i=>!0,i=>({uri:i.uri,range:O.Range.from(i.range)}))],new p.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",i=>i?i.map(O.ColorPresentation.to):[])),new p.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to an array of Inlay objects",(i,d,h)=>i.map(O.InlayHint.to.bind(void 0,h)))),new p.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[p.ApiCommandArgument.Uri],new p.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(i,d)=>{if(i)return i.map(O.FoldingRange.to)})),new p.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new p.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",I(i=>({viewType:i.viewType,displayName:i.displayName,options:{transientOutputs:i.options.transientOutputs,transientCellMetadata:i.options.transientCellMetadata,transientDocumentMetadata:i.options.transientDocumentMetadata},filenamePattern:i.filenamePattern.map(d=>O.NotebookExclusiveDocumentPattern.to(d))})))),new p.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Range],new p.ApiCommandResult("A promise that resolves to an array of InlineValue objects",i=>i.map(O.InlineValue.to))),new p.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new p.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",i=>l.URI.isUri(i)||typeof i=="string"&&(0,D.matchesSomeScheme)(i,R.Schemas.http,R.Schemas.https),i=>i),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[O.ViewColumn.from(i),void 0]:[O.ViewColumn.from(i.viewColumn),O.TextEditorOpenOptions.from(i)])).optional(),p.ApiCommandArgument.String.with("label","").optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[p.ApiCommandArgument.Uri.with("resource","Resource to open"),p.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="number"||typeof i=="object",i=>i&&(typeof i=="number"?[O.ViewColumn.from(i),void 0]:[O.ViewColumn.from(i.viewColumn),O.TextEditorOpenOptions.from(i)])).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[p.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),p.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),p.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new p.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",i=>i===void 0||typeof i=="object",i=>i&&[O.ViewColumn.from(i.viewColumn),O.TextEditorOpenOptions.from(i)]).optional()],p.ApiCommandResult.Void),new p.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[p.ApiCommandArgument.Uri,p.ApiCommandArgument.Position],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(O.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(O.TypeHierarchyItem.to))),new p.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[p.ApiCommandArgument.TypeHierarchyItem],new p.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",i=>i.map(O.TypeHierarchyItem.to))),new p.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[p.ApiCommandArgument.TestItem],p.ApiCommandResult.Void),new p.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[p.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],p.ApiCommandResult.Void),new p.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[p.ApiCommandArgument.String.with("name","The context key name"),new p.ApiCommandArgument("value","The context key value",()=>!0,i=>i)],p.ApiCommandResult.Void)];class T{static register(d){E.forEach(d.registerApiCommand,d),this.a(d)}static a(d){d.registerCommand(!1,"_validateWhenClauses",P.validateWhenClauses)}}e.ExtHostApiCommands=T;function I(i){return d=>{if(Array.isArray(d))return d.map(i)}}function v(i){if(!Array.isArray(i))return;const d=[];for(const h of i)L.isLocationLink(h)?d.push(O.DefinitionLink.to(h)):d.push(O.location.to(h));return d}}),define(Ce[264],ke([1,0,19,63,3,6,2,73,25,11,7,5,27,10]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function I(v,i,d){const h=v.getProxy(k.MainContext.MainThreadComments);class y{constructor(){this.b=new Map,this.c=new D.ExtensionIdentifierMap,i.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const u=this.b.get(c.handle);return u?u.value:c}else if(c&&c.$mid===7){const u=this.b.get(c.commentControlHandle);if(!u)return c;const m=u.getCommentThread(c.commentThreadHandle);return m?m.value:c}else if(c&&(c.$mid===9||c.$mid===8)){const u=this.b.get(c.thread.commentControlHandle);if(!u)return c;const m=u.getCommentThread(c.thread.commentThreadHandle);return m?c.$mid===8?m.value:{thread:m.value,text:c.text}:c}else if(c&&c.$mid===10){const u=this.b.get(c.thread.commentControlHandle);if(!u)return c;const m=u.getCommentThread(c.thread.commentThreadHandle);if(!m)return c;const f=c.commentUniqueId,n=m.getCommentByUniqueId(f);return n||c}else if(c&&c.$mid===11){const u=this.b.get(c.thread.commentControlHandle);if(!u)return c;const m=u.getCommentThread(c.thread.commentThreadHandle);if(!m)return c;const f=c.text,n=c.commentUniqueId,C=m.getCommentByUniqueId(n);return C?(typeof C.body=="string"?C.body=f:C.body=new O.MarkdownString(f),C):c}return c}})}createCommentController(c,u,m){const f=y.a++,n=new g(c,f,u,m);this.b.set(n.handle,n);const C=this.c.get(c.identifier)||[];return C.push(n),this.c.set(c.identifier,C),n.value}$createCommentThreadTemplate(c,u,m){const f=this.b.get(c);f&&f.$createCommentThreadTemplate(u,m)}async $updateCommentThreadTemplate(c,u,m){const f=this.b.get(c);f&&f.$updateCommentThreadTemplate(u,m)}$deleteCommentThread(c,u){this.b.get(c)?.$deleteCommentThread(u)}$provideCommentingRanges(c,u,m){const f=this.b.get(c);if(!f||!f.commentingRangeProvider)return Promise.resolve(void 0);const n=d.getDocument(A.URI.revive(u));return(0,o.asPromise)(async()=>{const C=await f.commentingRangeProvider.provideCommentingRanges(n,m);let M;return Array.isArray(C)?M={ranges:C,fileComments:!1}:C?M={ranges:C.ranges||[],fileComments:C.fileComments||!1}:M=(0,T.withNullAsUndefined)(C),M}).then(C=>{let M;return C&&(M={ranges:C.ranges.map(H=>p.Range.from(H)),fileComments:C.fileComments}),M})}$toggleReaction(c,u,m,f,n){const C=this.b.get(c);return!C||!C.reactionHandler?Promise.resolve(void 0):(0,o.asPromise)(()=>{const M=C.getCommentThread(u);if(M){const H=M.getCommentByUniqueId(f.uniqueIdInThread);if(C!==void 0&&H&&C.reactionHandler)return C.reactionHandler(H,r(n))}return Promise.resolve(void 0)})}}y.a=0;class w{set threadId(c){this.n=c}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(c){(c===void 0!=(this.p===void 0)||!c||!this.p||!c.isEqual(this.p))&&(this.p=c,this.b.range=c,this.c.fire())}get range(){return this.p}set canReply(c){this.d!==c&&(this.d=c,this.b.canReply=c,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(c){this.e=c,this.b.label=c,this.c.fire()}get contextValue(){return this.f}set contextValue(c){this.f=c,this.b.contextValue=c,this.c.fire()}get comments(){return this.q}set comments(c){this.q=c,this.b.comments=c,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(c){this.g=c,this.b.collapsibleState=c,this.c.fire()}get state(){return this.h}set state(c){this.h=c,this.b.state=c,this.c.fire()}get isDisposed(){return this.j}constructor(c,u,m,f,n,C,M,H){this.m=u,this.n=m,this.o=f,this.p=n,this.q=C,this.extensionDescription=M,this.r=H,this.handle=w.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new l.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.MutableDisposable,this.l.value=new L.DisposableStore,this.n===void 0&&(this.n=`${c}.${this.handle}`),h.$createCommentThread(u,this.handle,this.n,this.o,p.Range.from(this.p),M.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=C,this.i.push({dispose:()=>{h.$deleteCommentThread(u,this.handle)}});const V=this;this.value={get uri(){return V.uri},get range(){return V.range},set range(U){V.range=U},get comments(){return V.comments},set comments(U){V.comments=U},get collapsibleState(){return V.collapsibleState},set collapsibleState(U){V.collapsibleState=U},get canReply(){return V.canReply},set canReply(U){V.canReply=U},get contextValue(){return V.contextValue},set contextValue(U){V.contextValue=U},get label(){return V.label},set label(U){V.label=U},get state(){return V.state},set state(U){V.state=U},dispose:()=>{V.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.DisposableStore);const c=m=>Object.prototype.hasOwnProperty.call(this.b,m),u={};c("range")&&(u.range=p.Range.from(this.p)),c("label")&&(u.label=this.label),c("contextValue")&&(u.contextValue=this.contextValue??null),c("comments")&&(u.comments=this.q.map(m=>t(this,m,this.k,this.extensionDescription))),c("collapsibleState")&&(u.collapseState=a(this.g)),c("canReply")&&(u.canReply=this.canReply),c("state")&&(u.state=b(this.h)),c("isTemplate")&&(u.isTemplate=this.r),this.b={},h.$updateCommentThread(this.m,this.handle,this.n,this.o,u)}getCommentByUniqueId(c){for(const u of this.k){const m=u[0],f=u[1];if(c===f)return m}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(c=>c.dispose())}}w.a=0,xe([(0,R.debounce)(100)],w.prototype,"eventuallyUpdateCommentThread",null);class g{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(c){this.b=c,h.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(c){this.c=c,h.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this.d}set options(c){this.d=c,h.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(c,u,m,f){this.f=c,this.g=u,this.h=m,this.i=f,this.a=new Map,h.$registerCommentController(this.handle,m,f);const n=this;this.value=Object.freeze({id:n.id,label:n.label,get options(){return n.options},set options(C){n.options=C},get commentingRangeProvider(){return n.commentingRangeProvider},set commentingRangeProvider(C){n.commentingRangeProvider=C},get reactionHandler(){return n.reactionHandler},set reactionHandler(C){n.reactionHandler=C},createCommentThread(C,M,H){return n.createCommentThread(C,M,H).value},dispose:()=>{n.dispose()}}),this.e=[],this.e.push({dispose:()=>{h.$unregisterCommentController(this.handle)}})}createCommentThread(c,u,m){u===void 0&&(0,E.checkProposedApiEnabled)(this.f,"fileComments");const f=new w(this.id,this.handle,void 0,c,u,m,this.f,!1);return this.a.set(f.handle,f),f}$createCommentThreadTemplate(c,u){const m=new w(this.id,this.handle,void 0,A.URI.revive(c),p.Range.to(u),[],this.f,!0);return m.collapsibleState=P.CommentThreadCollapsibleState.Expanded,this.a.set(m.handle,m),m}$updateCommentThreadTemplate(c,u){const m=this.a.get(c);m&&(m.range=p.Range.to(u))}$deleteCommentThread(c){this.a.get(c)?.dispose(),this.a.delete(c)}getCommentThread(c){return this.a.get(c)}dispose(){this.a.forEach(c=>{c.dispose()}),this.e.forEach(c=>c.dispose())}}function t(S,c,u,m){let f=u.get(c);return f||(f=++S.commentHandle,u.set(c,f)),c.state!==void 0&&(0,E.checkProposedApiEnabled)(m,"commentsDraftState"),{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:f,body:typeof c.body=="string"?c.body:p.MarkdownString.from(c.body),userName:c.author.name,userIconPath:c.author.iconPath,label:c.label,commentReactions:c.reactions?c.reactions.map(n=>s(n)):void 0,state:c.state,timestamp:c.timestamp?.toJSON()}}function s(S){return{label:S.label,iconPath:S.iconPath?p.pathOrURIToURI(S.iconPath):void 0,count:S.count,hasReacted:S.authorHasReacted}}function r(S){return{label:S.label||"",count:S.count||0,iconPath:S.iconPath?A.URI.revive(S.iconPath):"",authorHasReacted:S.hasReacted||!1}}function a(S){if(S!==void 0)switch(S){case O.CommentThreadCollapsibleState.Expanded:return P.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return P.CommentThreadCollapsibleState.Collapsed}return P.CommentThreadCollapsibleState.Collapsed}function b(S){if(S!==void 0)switch(S){case O.CommentThreadState.Unresolved:return P.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return P.CommentThreadState.Resolved}return P.CommentThreadState.Unresolved}return new y}e.createExtHostComments=I}),define(Ce[265],ke([1,0,23,5,26,20]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let A=e.AbstractExtHostConsoleForwarder=class{constructor(O,k){this.a=O.getProxy(R.MainContext.MainThreadConsole),this.b=k.consoleForward.includeStack,this.c=k.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,k){const E=this,T=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){E.e(O,k,T,arguments)}})}e(O,k,E,T){this.a.$logExtensionHostMessage({type:"__$console",severity:k,arguments:D(T,this.b)}),this.c&&this.f(O,E,T)}};e.AbstractExtHostConsoleForwarder=A=xe([We(0,L.IExtHostRpcService),We(1,l.IExtHostInitDataService)],A);const P=1e5;function D(p,O){const k=[];if(p.length)for(let E=0;E<p.length;E++){let T=p[E];if(typeof T>"u")T="undefined";else if(T instanceof Error){const I=T;I.stack?T=I.stack:T=I.toString()}k.push(T)}if(O){const E=new Error().stack;E&&k.push({__$stack:E.split(`
`).slice(3).join(`
`)})}try{const E=(0,o.safeStringify)(k);return E.length>P?"Output omitted for a large object that exceeds the limits":E}catch(E){return`Output omitted for an object that cannot be inspected ('${E.toString()}')`}}}),define(Ce[140],ke([1,0,2,5,7,4,20,16,18,9,15,27]),function(ae,e,o,R,l,L,A,P,D,p,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let E=e.ExtHostDecorations=class Yi{constructor(I,v){this.h=v,this.f=new Map,this.g=I.getProxy(R.MainContext.MainThreadDecorations)}registerFileDecorationProvider(I,v){const i=Yi.c++;this.f.set(i,{provider:I,extensionDescription:v}),this.g.$registerDecorationProvider(i,v.identifier.value);const d=I.onDidChangeFileDecorations&&I.onDidChangeFileDecorations(h=>{if(!h){this.g.$onDidChange(i,null);return}const y=(0,D.asArray)(h);if(y.length<=Yi.d){this.g.$onDidChange(i,y);return}this.h.warn("[Decorations] CAPPING events from decorations provider",v.identifier.value,y.length);const w=y.map(s=>({uri:s,rank:(0,p.count)(s.path,"/")})),g=(0,D.groupBy)(w,(s,r)=>s.rank-r.rank||(0,p.compare)(s.uri.path,r.uri.path)),t=[];e:for(const s of g){let r;for(const a of s){const b=(0,O.dirname)(a.uri.path);if(r!==b&&(r=b,t.push(a.uri)>=Yi.d))break e}}this.g.$onDidChange(i,t)});return new l.Disposable(()=>{d?.dispose(),this.g.$unregisterDecorationProvider(i),this.f.delete(i)})}async $provideDecorations(I,v,i){if(!this.f.has(I))return Object.create(null);const d=Object.create(null),{provider:h,extensionDescription:y}=this.f.get(I);return await Promise.all(v.map(async w=>{try{const{uri:g,id:t}=w,s=await Promise.resolve(h.provideFileDecoration(o.URI.revive(g),i));if(!s)return;try{l.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,k.checkProposedApiEnabled)(y,"codiconDecoration"),d[t]=[s.propagate,s.tooltip,s.badge,s.color]}catch(r){this.h.warn(`INVALID decoration from extension '${y}': ${r}`)}}catch(g){this.h.error(g)}})),d}};E.c=0,E.d=250,e.ExtHostDecorations=E=xe([We(0,A.IExtHostRpcService),We(1,P.ILogService)],E),e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var _e=this&&this.__classPrivateFieldSet||function(ae,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!l:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(ae,o):l?l.value=o:e.set(ae,o),o},Be=this&&this.__classPrivateFieldGet||function(ae,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!R:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(ae):R?R.value:e.get(ae)};define(Ce[266],ke([1,0,182,123,2,5,7,11,3,16,28,49]),function(ae,e,o,R,l,L,A,P,D,p,O,k){"use strict";var E,T,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class v{constructor(h,y,w,g,t,s,r){this.d=h,this.e=y,this.f=w,this.g=g,E.set(this,void 0),T.set(this,void 0),I.set(this,void 0),this.c=!1,_e(this,I,new O.ResourceMap(a=>t.getComparisonKey(a)),"f"),_e(this,E,s,"f"),_e(this,T,r,"f")}dispose(){this.c||(Be(this,T,"f").fire([...Be(this,I,"f").keys()]),Be(this,E,"f")?.$clear(this.e),Be(this,I,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(h,y){if(!h){this.clear();return}this.h();let w=[];if(l.URI.isUri(h)){if(!y){this.delete(h);return}Be(this,I,"f").set(h,y.slice()),w=[h]}else if(Array.isArray(h)){w=[];let t;h=[...h].sort(v.j);for(const s of h){const[r,a]=s;if((!t||r.toString()!==t.toString())&&(t&&Be(this,I,"f").get(t).length===0&&Be(this,I,"f").delete(t),t=r,w.push(r),Be(this,I,"f").set(r,[])),a)Be(this,I,"f").get(r)?.push(...a);else{const b=Be(this,I,"f").get(r);b&&(b.length=0)}}}if(Be(this,T,"f").fire(w),!Be(this,E,"f"))return;const g=[];for(const t of w){let s=[];const r=Be(this,I,"f").get(t);if(r)if(r.length>this.f){s=[];const a=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let b=0;b<4;b++)for(const S of r)if(S.severity===a[b]&&s.push({...P.Diagnostic.from(S),modelVersionId:this.g(t)})===this.f)break e;s.push({severity:R.MarkerSeverity.Info,message:(0,o.localize)(0,null,r.length-this.f),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=r.map(a=>({...P.Diagnostic.from(a),modelVersionId:this.g(t)}));g.push([t,s])}Be(this,E,"f").$changeMany(this.e,g)}delete(h){this.h(),Be(this,T,"f").fire([h]),Be(this,I,"f").delete(h),Be(this,E,"f")?.$changeMany(this.e,[[h,void 0]])}clear(){this.h(),Be(this,T,"f").fire([...Be(this,I,"f").keys()]),Be(this,I,"f").clear(),Be(this,E,"f")?.$clear(this.e)}forEach(h,y){this.h();for(const[w,g]of this)h.call(y,w,g,this)}*[(E=new WeakMap,T=new WeakMap,I=new WeakMap,Symbol.iterator)](){this.h();for(const h of Be(this,I,"f").keys())yield[h,this.get(h)]}get(h){this.h();const y=Be(this,I,"f").get(h);return Array.isArray(y)?Object.freeze(y.slice(0)):[]}has(h){return this.h(),Array.isArray(Be(this,I,"f").get(h))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(h,y){return h[0].toString()<y[0].toString()?-1:h[0].toString()>y[0].toString()?1:0}}e.DiagnosticCollection=v;let i=e.ExtHostDiagnostics=class mi{static _mapper(h){const y=new O.ResourceMap;for(const w of h)y.set(w,w);return{uris:Object.freeze(Array.from(y.values()))}}constructor(h,y,w,g){this.h=y,this.j=w,this.k=g,this.f=new Map,this.g=new D.DebounceEmitter({merge:t=>t.flat(),delay:50}),this.onDidChangeDiagnostics=D.Event.map(this.g.event,mi._mapper),this.e=h.getProxy(L.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(h,y){const{f:w,e:g,g:t,h:s,j:r,k:a}=this,b=new class{$changeMany(u,m){g.$changeMany(u,m),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",h.value,u,m.length===0?"CLEARING":m)}$clear(u){g.$clear(u),s.trace("[DiagnosticCollection] remove all (extension, owner)",h.value,u)}dispose(){g.dispose()}};let S;if(!y)y="_generated_diagnostic_collection_name_#"+mi.c++,S=y;else if(!w.has(y))S=y;else{this.h.warn(`DiagnosticCollection with name '${y}' does already exist.`);do S=y+mi.c++;while(w.has(S))}return new class extends v{constructor(){super(y,S,mi.d,u=>a.getDocument(u)?.version,r.extUri,b,t),w.set(S,this)}dispose(){super.dispose(),w.delete(S)}}}getDiagnostics(h){if(h)return this.l(h);{const y=new Map,w=[];for(const g of this.f.values())g.forEach((t,s)=>{let r=y.get(t.toString());typeof r>"u"&&(r=w.length,y.set(t.toString(),r),w.push([t,[]])),w[r][1]=w[r][1].concat(...s)});return w}}l(h){let y=[];for(const w of this.f.values())w.has(h)&&(y=y.concat(w.get(h)));return y}$acceptMarkersChange(h){if(!this.m){const y="_generated_mirror",w=new v(y,y,mi.d,g=>{},this.j.extUri,void 0,this.g);this.f.set(y,w),this.m=w}for(const[y,w]of h)this.m.set(l.URI.revive(y),w.map(P.Diagnostic.to))}};i.c=0,i.d=1e3,e.ExtHostDiagnostics=i=xe([We(1,p.ILogService),We(2,k.IExtHostFileSystemInfo)],i)}),define(Ce[267],ke([1,0,2,5,27]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class L{constructor(P){this.a=P.getProxy(R.MainContext.MainThreadDialogs)}showOpenDialog(P,D){return D?.allowUIResources&&(0,l.checkProposedApiEnabled)(P,"showLocal"),this.a.$showOpenDialog(D).then(p=>p?p.map(O=>o.URI.revive(O)):void 0)}showSaveDialog(P){return this.a.$showSaveDialog(P).then(D=>D?o.URI.revive(D):void 0)}}e.ExtHostDialogs=L}),define(Ce[268],ke([1,0,8,2,7,5,17,21,9]),function(ae,e,o,R,l,L,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class p{constructor(k,E,T){this.d=E,this.e=T,this.b=new Map,this.c=k.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(k,E){if(Object.keys(A.Schemas).indexOf(k)>=0)throw new Error(`scheme '${k}' already registered`);const T=p.a++;this.b.set(T,E),this.c.$registerTextContentProvider(T,k);let I;return typeof E.onDidChange=="function"&&(I=E.onDidChange(v=>{if(v.scheme!==k){this.e.warn(`Provider for scheme '${k}' is firing event for schema '${v.scheme}' which will be IGNORED`);return}this.d.getDocument(v)&&this.$provideTextDocumentContent(T,v).then(i=>{if(!i&&typeof i!="string")return;const d=this.d.getDocument(v);if(!d)return;const h=(0,D.splitLines)(i);if(!d.equalLines(h))return this.c.$onVirtualDocumentChange(v,i)},o.onUnexpectedError)})),new l.Disposable(()=>{this.b.delete(T)&&this.c.$unregisterTextContentProvider(T),I&&(I.dispose(),I=void 0)})}$provideTextDocumentContent(k,E){const T=this.b.get(k);return T?Promise.resolve(T.provideTextDocumentContent(R.URI.revive(E),P.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${E.scheme}`))}}e.ExtHostDocumentContentProvider=p,p.a=0}),define(Ce[269],ke([1,0,3,6,2,5,136,11,10,23,7]),function(ae,e,o,R,l,L,A,P,D,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class k{constructor(T,I){this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter,this.d=new o.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new R.DisposableStore,this.h=new Map,this.f=T.getProxy(L.MainContext.MainThreadDocuments),this.g=I,this.g.onDidRemoveDocuments(v=>{for(const i of v)this.b.fire(i.document)},void 0,this.e),this.g.onDidAddDocuments(v=>{for(const i of v)this.a.fire(i.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(T){if(!T)return;const I=this.g.getDocument(T);if(I)return I}getDocument(T){const I=this.getDocumentData(T);if(!I?.document)throw new Error(`Unable to retrieve document from URI '${T}'`);return I.document}ensureDocumentData(T){const I=this.g.getDocument(T);if(I)return Promise.resolve(I);let v=this.h.get(T.toString());return v||(v=this.f.$tryOpenDocument(T).then(i=>{this.h.delete(T.toString());const d=l.URI.revive(i);return(0,D.assertIsDefined)(this.g.getDocument(d))},i=>(this.h.delete(T.toString()),Promise.reject(i))),this.h.set(T.toString(),v)),v}createDocumentData(T){return this.f.$tryCreateDocument(T).then(I=>l.URI.revive(I))}$acceptModelLanguageChanged(T,I){const v=l.URI.revive(T),i=this.g.getDocument(v);if(!i)throw new Error("unknown document");this.b.fire(i.document),i._acceptLanguageId(I),this.a.fire(i.document)}$acceptModelSaved(T){const I=l.URI.revive(T),v=this.g.getDocument(I);if(!v)throw new Error("unknown document");this.$acceptDirtyStateChanged(T,!1),this.d.fire(v.document)}$acceptDirtyStateChanged(T,I){const v=l.URI.revive(T),i=this.g.getDocument(v);if(!i)throw new Error("unknown document");i._acceptIsDirty(I),this.c.fire({document:i.document,contentChanges:[],reason:void 0})}$acceptModelChanged(T,I,v){const i=l.URI.revive(T),d=this.g.getDocument(i);if(!d)throw new Error("unknown document");d._acceptIsDirty(v),d.onEvents(I);let h;I.isUndoing?h=O.TextDocumentChangeReason.Undo:I.isRedoing&&(h=O.TextDocumentChangeReason.Redo),this.c.fire((0,p.deepFreeze)({document:d.document,contentChanges:I.changes.map(y=>({range:P.Range.to(y.range),rangeOffset:y.rangeOffset,rangeLength:y.rangeLength,text:y.text})),reason:h}))}setWordDefinitionFor(T,I){(0,A.setWordDefinitionFor)(T,I)}}e.ExtHostDocuments=k}),define(Ce[60],ke([1,0,51,3,6,2,4,5,136,20,139,11,16,28,17,52,65]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class d{constructor(w){this.value=w,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let h=e.ExtHostDocumentsAndEditors=class{constructor(w,g){this.h=w,this.i=g,this.a=null,this.b=new Map,this.c=new T.ResourceMap,this.d=new R.Emitter,this.e=new R.Emitter,this.f=new R.Emitter,this.g=new R.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(w){this.acceptDocumentsAndEditorsDelta(w)}acceptDocumentsAndEditorsDelta(w){const g=[],t=[],s=[];if(w.removedDocuments)for(const r of w.removedDocuments){const a=L.URI.revive(r),b=this.c.get(a);b?.unref()&&(this.c.delete(a),g.push(b.value))}if(w.addedDocuments)for(const r of w.addedDocuments){const a=L.URI.revive(r.uri);let b=this.c.get(a);if(b&&a.scheme!==I.Schemas.vscodeNotebookCell&&a.scheme!==I.Schemas.vscodeInteractiveInput)throw new Error(`document '${a} already exists!'`);b||(b=new d(new D.ExtHostDocumentData(this.h.getProxy(P.MainContext.MainThreadDocuments),a,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(a,b),t.push(b.value)),b.ref()}if(w.removedEditors)for(const r of w.removedEditors){const a=this.b.get(r);this.b.delete(r),a&&s.push(a)}if(w.addedEditors)for(const r of w.addedEditors){const a=L.URI.revive(r.documentUri);o.ok(this.c.has(a),`document '${a}' does not exist`),o.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const b=this.c.get(a).value,S=new O.ExtHostTextEditor(r.id,this.h.getProxy(P.MainContext.MainThreadTextEditors),this.i,new i.Lazy(()=>b.document),r.selections.map(k.Selection.to),r.options,r.visibleRanges.map(c=>k.Range.to(c)),typeof r.editorPosition=="number"?k.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,S)}w.newActiveEditor!==void 0&&(o.ok(w.newActiveEditor===null||this.b.has(w.newActiveEditor),`active editor '${w.newActiveEditor}' does not exist`),this.a=w.newActiveEditor),(0,l.dispose)(g),(0,l.dispose)(s),w.removedDocuments&&this.e.fire(g),w.addedDocuments&&this.d.fire(t),(w.removedEditors||w.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),w.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(w){return this.c.get(w)?.value}allDocuments(){return v.Iterable.map(this.c.values(),w=>w.value)}getEditor(w){return this.b.get(w)}activeEditor(w){if(!this.a)return;const g=this.b.get(this.a);return w?g:g?.value}allEditors(){return[...this.b.values()]}};e.ExtHostDocumentsAndEditors=h=xe([We(0,p.IExtHostRpcService),We(1,E.ILogService)],h),e.IExtHostDocumentsAndEditors=(0,A.createDecorator)("IExtHostDocumentsAndEditors")}),define(Ce[61],ke([1,0,11,5,2,3,4,7,20,10,62]),function(ae,e,o,R,l,L,A,P,D,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,A.createDecorator)("IExtHostEditorTabs");class k{constructor(i,d,h){this.e=h,this.d=d,this.acceptDtoUpdate(i)}get apiObject(){if(!this.a){const i=this,d={get isActive(){return i.b.id===i.e()},get label(){return i.b.label},get input(){return i.c},get isDirty(){return i.b.isDirty},get isPinned(){return i.b.isPinned},get isPreview(){return i.b.isPreview},get group(){return i.d.apiObject}};this.a=Object.freeze(d)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(i){this.b=i,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new P.TextTabInput(l.URI.revive(this.b.input.uri));case 2:return new P.TextDiffTabInput(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified));case 3:return new P.TextMergeTabInput(l.URI.revive(this.b.input.base),l.URI.revive(this.b.input.input1),l.URI.revive(this.b.input.input2),l.URI.revive(this.b.input.result));case 6:return new P.CustomEditorTabInput(l.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new P.WebviewEditorTabInput(this.b.input.viewType);case 4:return new P.NotebookEditorTabInput(l.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new P.NotebookDiffEditorTabInput(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new P.TerminalEditorTabInput;case 9:return new P.InteractiveWindowInput(l.URI.revive(this.b.input.uri),l.URI.revive(this.b.input.inputBoxUri));default:return}}}class E{constructor(i,d){this.c=[],this.d="",this.b=i,this.e=d;for(const h of i.tabs)h.isActive&&(this.d=h.id),this.c.push(new k(h,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const i=this,d={get isActive(){return i.b.groupId===i.e()},get viewColumn(){return o.ViewColumn.to(i.b.viewColumn)},get activeTab(){return i.c.find(h=>h.tabId===i.d)?.apiObject},get tabs(){return Object.freeze(i.c.map(h=>h.apiObject))}};this.a=Object.freeze(d)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(i){this.b=i}acceptTabOperation(i){if(i.kind===0){const h=new k(i.tabDto,this,()=>this.activeTabId());return this.c.splice(i.index,0,h),i.tabDto.isActive&&(this.d=h.tabId),h}else if(i.kind===1){const h=this.c.splice(i.index,1)[0];if(!h)throw new Error(`Tab close updated received for index ${i.index} which does not exist`);return h.tabId===this.d&&(this.d=""),h}else if(i.kind===3){if(i.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const h=this.c.splice(i.oldIndex,1)[0];if(!h)throw new Error(`Tab move updated received for index ${i.oldIndex} which does not exist`);return this.c.splice(i.index,0,h),h}const d=this.c.find(h=>h.tabId===i.tabDto.id);if(!d)throw new Error("INVALID tab");return i.tabDto.isActive?this.d=i.tabDto.id:this.d===i.tabDto.id&&!i.tabDto.isActive&&(this.d=""),d.acceptDtoUpdate(i.tabDto),d}activeTabId(){return this.d}}let T=e.ExtHostEditorTabs=class{constructor(i){this.b=new L.Emitter,this.c=new L.Emitter,this.e=[],this.a=i.getProxy(R.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const i=this,d={onDidChangeTabGroups:i.c.event,onDidChangeTabs:i.b.event,get all(){return Object.freeze(i.e.map(h=>h.apiObject))},get activeTabGroup(){const h=i.d;return(0,p.assertIsDefined)(i.e.find(w=>w.groupId===h)?.apiObject)},close:async(h,y)=>{const w=Array.isArray(h)?h:[h];return w.length?I(w[0])?this.j(w,y):this.i(w,y):!0}};this.f=Object.freeze(d)}return this.f}$acceptEditorTabModel(i){const d=new Set(this.e.map(r=>r.groupId)),h=new Set(i.map(r=>r.groupId)),y=(0,O.diffSets)(d,h),w=this.e.filter(r=>y.removed.includes(r.groupId)).map(r=>r.apiObject),g=[],t=[];this.e=i.map(r=>{const a=new E(r,()=>this.d);return y.added.includes(a.groupId)?g.push(a.apiObject):t.push(a.apiObject),a});const s=(0,p.assertIsDefined)(i.find(r=>r.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:g,closed:w,changed:t}))}$acceptTabGroupUpdate(i){const d=this.e.find(h=>h.groupId===i.groupId);if(!d)throw new Error("Update Group IPC call received before group creation.");d.acceptGroupDtoUpdate(i),i.isActive&&(this.d=i.groupId),this.c.fire(Object.freeze({changed:[d.apiObject],opened:[],closed:[]}))}$acceptTabOperation(i){const d=this.e.find(y=>y.groupId===i.groupId);if(!d)throw new Error("Update Tabs IPC call received before group creation.");const h=d.acceptTabOperation(i);switch(i.kind){case 0:this.b.fire(Object.freeze({opened:[h.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[h.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[h.apiObject]}));return}}g(i){for(const d of this.e)for(const h of d.tabs)if(h.apiObject===i)return h}h(i){return this.e.find(d=>d.apiObject===i)}async i(i,d){const h=[];for(const y of i){const w=this.g(y);if(!w)throw new Error("Tab close: Invalid tab not found!");h.push(w.tabId)}return this.a.$closeTab(h,d)}async j(i,d){const h=[];for(const y of i){const w=this.h(y);if(!w)throw new Error("Group close: Invalid group not found!");h.push(w.groupId)}return this.a.$closeGroup(h,d)}};e.ExtHostEditorTabs=T=xe([We(0,D.IExtHostRpcService)],T);function I(v){return v.tabs!==void 0}}),define(Ce[270],ke([1,0,2,5,6,7,11,156,9,22,27]),function(ae,e,o,R,l,L,A,P,D,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class k{constructor(){this.a=[]}add(I){this.b=void 0,this.a.push(I)}delete(I){const v=this.a.indexOf(I);v>=0&&(this.a.splice(v,1),this.b=void 0)}c(){if(!this.b){const I=this.a.sort(),v=[];let i,d,h=14,y=14;for(const w of I){let g=i?(0,D.commonPrefixLength)(i,w):0;for(g===0?d=1:d=y;g<w.length;g++)g+1===w.length?(h=y,y=9):y+=1,v.push([d,w.toUpperCase().charCodeAt(g),y]),v.push([d,w.toLowerCase().charCodeAt(g),y]),d=y;i=w,y=h}v.push([9,58,10]),v.push([10,47,12]),this.b=new P.StateMachine(v)}}provideDocumentLinks(I){this.c();const v=[],i=P.LinkComputer.computeLinks({getLineContent(d){return I.lineAt(d-1).text},getLineCount(){return I.lineCount}},this.b);for(const d of i){const h=A.DocumentLink.to(d);h.target&&v.push(h)}return v}}class E{constructor(I,v){this.i=v,this.b=new k,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=I.getProxy(R.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(I,v,i,d={}){if(E.j(i),this.d.has(v))throw new Error(`a provider for the scheme '${v}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(I,"*",this.b));const h=this.h++;this.b.add(v),this.d.add(v),this.c.set(h,i);let y=2;d.isCaseSensitive&&(y+=1024),d.isReadonly&&(y+=2048),typeof i.copy=="function"&&(y+=8),typeof i.open=="function"&&typeof i.close=="function"&&typeof i.read=="function"&&typeof i.write=="function"&&((0,O.checkProposedApiEnabled)(I,"fsChunks"),y+=4),this.a.$registerFileSystemProvider(h,v,y).catch(g=>{console.error(`FAILED to register filesystem provider of ${I.identifier.value}-extension for the scheme ${v}`),console.error(g)});const w=i.onDidChangeFile(g=>{const t=[];for(const s of g){const{uri:r,type:a}=s;if(r.scheme!==v)continue;let b;switch(a){case L.FileChangeType.Changed:b=0;break;case L.FileChangeType.Created:b=1;break;case L.FileChangeType.Deleted:b=2;break;default:throw new Error("Unknown FileChangeType")}t.push({resource:r,type:b})}this.a.$onFileSystemChange(h,t)});return(0,l.toDisposable)(()=>{w.dispose(),this.b.delete(v),this.d.delete(v),this.c.delete(h),this.a.$unregisterProvider(h)})}static j(I){if(!I)throw new Error("MISSING provider");if(typeof I.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof I.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof I.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof I.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof I.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof I.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof I.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof I.rename!="function")throw new Error("Provider does NOT implement rename")}static k(I){const{type:v,ctime:i,mtime:d,size:h,permissions:y}=I;return{type:v,ctime:i,mtime:d,size:h,permissions:y}}$stat(I,v){return Promise.resolve(this.l(I).stat(o.URI.revive(v))).then(i=>E.k(i))}$readdir(I,v){return Promise.resolve(this.l(I).readDirectory(o.URI.revive(v)))}$readFile(I,v){return Promise.resolve(this.l(I).readFile(o.URI.revive(v))).then(i=>p.VSBuffer.wrap(i))}$writeFile(I,v,i,d){return Promise.resolve(this.l(I).writeFile(o.URI.revive(v),i.buffer,d))}$delete(I,v,i){return Promise.resolve(this.l(I).delete(o.URI.revive(v),i))}$rename(I,v,i,d){return Promise.resolve(this.l(I).rename(o.URI.revive(v),o.URI.revive(i),d))}$copy(I,v,i,d){const h=this.l(I);if(!h.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(h.copy(o.URI.revive(v),o.URI.revive(i),d))}$mkdir(I,v){return Promise.resolve(this.l(I).createDirectory(o.URI.revive(v)))}$watch(I,v,i,d){const h=this.l(I).watch(o.URI.revive(i),d);this.f.set(v,h)}$unwatch(I,v){const i=this.f.get(v);i&&(i.dispose(),this.f.delete(v))}$open(I,v,i){const d=this.l(I);if(!d.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(d.open(o.URI.revive(v),i))}$close(I,v){const i=this.l(I);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(v))}$read(I,v,i,d){const h=this.l(I);if(!h.read)throw new Error('FileSystemProvider does not implement "read"');const y=p.VSBuffer.alloc(d);return Promise.resolve(h.read(v,i,y.buffer,0,d)).then(w=>y.slice(0,w))}$write(I,v,i,d){const h=this.l(I);if(!h.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(h.write(v,i,d.buffer,0,d.byteLength))}l(I){const v=this.c.get(I);if(!v){const i=new Error;throw i.name="ENOPRO",i.message="no provider",i}return v}}e.ExtHostFileSystem=E}),define(Ce[80],ke([1,0,5,45,7,22,4,20,49,6]),function(ae,e,o,R,l,L,A,P,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=e.ExtHostConsumerFileSystem=class Zt{constructor(E,T){this.b=new Map,this.a=E.getProxy(o.MainContext.MainThreadFileSystem);const I=this;this.value=Object.freeze({async stat(v){try{const i=I.b.get(v.scheme);if(!i)return await I.a.$stat(v);await I.a.$ensureActivation(v.scheme);const d=await i.stat(v);return{type:d.type,ctime:d.ctime,mtime:d.mtime,size:d.size,permissions:d.permissions}}catch(i){Zt.c(i)}},async readDirectory(v){try{const i=I.b.get(v.scheme);return i?(await I.a.$ensureActivation(v.scheme),(await i.readDirectory(v)).slice()):await I.a.$readdir(v)}catch(i){return Zt.c(i)}},async createDirectory(v){try{return await I.a.$mkdir(v)}catch(i){return Zt.c(i)}},async readFile(v){try{const i=I.b.get(v.scheme);return i?(await I.a.$ensureActivation(v.scheme),(await i.readFile(v)).slice()):(await I.a.$readFile(v)).buffer}catch(i){return Zt.c(i)}},async writeFile(v,i){try{return await I.a.$writeFile(v,L.VSBuffer.wrap(i))}catch(d){return Zt.c(d)}},async delete(v,i){try{const d=I.b.get(v.scheme);return d?(await I.a.$ensureActivation(v.scheme),await d.delete(v,{recursive:!1,...i})):await I.a.$delete(v,{recursive:!1,useTrash:!1,...i})}catch(d){return Zt.c(d)}},async rename(v,i,d){try{return await I.a.$rename(v,i,{overwrite:!1,...d})}catch(h){return Zt.c(h)}},async copy(v,i,d){try{return await I.a.$copy(v,i,{overwrite:!1,...d})}catch(h){return Zt.c(h)}},isWritableFileSystem(v){const i=T.getCapabilities(v);if(typeof i=="number")return!(i&2048)}})}static c(E){if(E instanceof l.FileSystemError)throw E;if(!(E instanceof Error))throw new l.FileSystemError(String(E));if(E.name==="ENOPRO"||E.message.includes("ENOPRO"))throw l.FileSystemError.Unavailable(E.message);switch(E.name){case R.FileSystemProviderErrorCode.FileExists:throw l.FileSystemError.FileExists(E.message);case R.FileSystemProviderErrorCode.FileNotFound:throw l.FileSystemError.FileNotFound(E.message);case R.FileSystemProviderErrorCode.FileNotADirectory:throw l.FileSystemError.FileNotADirectory(E.message);case R.FileSystemProviderErrorCode.FileIsADirectory:throw l.FileSystemError.FileIsADirectory(E.message);case R.FileSystemProviderErrorCode.NoPermissions:throw l.FileSystemError.NoPermissions(E.message);case R.FileSystemProviderErrorCode.Unavailable:throw l.FileSystemError.Unavailable(E.message);default:throw new l.FileSystemError(E.message,E.name)}}addFileSystemProvider(E,T){return this.b.set(E,T),(0,p.toDisposable)(()=>this.b.delete(E))}};e.ExtHostConsumerFileSystem=O=xe([We(0,P.IExtHostRpcService),We(1,D.IExtHostFileSystemInfo)],O),e.IExtHostConsumerFileSystem=(0,A.createDecorator)("IExtHostConsumerFileSystem")}),define(Ce[271],ke([1,0,3,39,2,5,11,7]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class D{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(k,E,T,I,v,i,d,h){this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter;const y=this.h(k,T,v);this.g=0,i&&(this.g+=1),d&&(this.g+=2),h&&(this.g+=4);const w=(0,R.parse)(v),g=typeof v=="string",t=I(s=>{if(!i)for(const r of s.created){const a=l.URI.revive(r);w(a.fsPath)&&(!g||E.getWorkspaceFolder(a))&&this.a.fire(a)}if(!d)for(const r of s.changed){const a=l.URI.revive(r);w(a.fsPath)&&(!g||E.getWorkspaceFolder(a))&&this.b.fire(a)}if(!h)for(const r of s.deleted){const a=l.URI.revive(r);w(a.fsPath)&&(!g||E.getWorkspaceFolder(a))&&this.c.fire(a)}});this.d=P.Disposable.from(y,this.a,this.b,this.c,t)}h(k,E,T){const I=P.Disposable.from();if(typeof T=="string")return I;const v=k.getProxy(L.MainContext.MainThreadFileSystem);let i=!1;(T.pattern.includes(R.GLOBSTAR)||T.pattern.includes(R.GLOB_SPLIT))&&(i=!0);const d=Math.random();return v.$watch(E.identifier.value,d,T.baseUri,{recursive:i,excludes:[]}),P.Disposable.from({dispose:()=>v.$unwatch(d)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class p{constructor(k,E,T){this.j=k,this.k=E,this.l=T,this.a=new o.Emitter,this.b=new o.Emitter,this.c=new o.Emitter,this.d=new o.Emitter,this.g=new o.AsyncEmitter,this.h=new o.AsyncEmitter,this.i=new o.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(k,E,T,I,v,i){return new D(this.j,k,E,this.a.event,A.GlobPattern.from(T),I,v,i)}$onFileEvent(k){this.a.fire(k)}$onDidRunFileOperation(k,E){switch(k){case 2:this.b.fire(Object.freeze({files:E.map(T=>({oldUri:l.URI.revive(T.source),newUri:l.URI.revive(T.target)}))}));break;case 1:this.d.fire(Object.freeze({files:E.map(T=>l.URI.revive(T.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:E.map(T=>l.URI.revive(T.target))}));break;default:}}getOnWillRenameFileEvent(k){return this.m(k,this.g)}getOnWillCreateFileEvent(k){return this.m(k,this.h)}getOnWillDeleteFileEvent(k){return this.m(k,this.i)}m(k,E){return(T,I,v)=>{const i=function(h){T.call(I,h)};return i.extension=k,E.event(i,void 0,v)}}async $onWillRunFileOperation(k,E,T,I){switch(k){case 2:return await this.n(this.g,{files:E.map(v=>({oldUri:l.URI.revive(v.source),newUri:l.URI.revive(v.target)}))},T,I);case 1:return await this.n(this.i,{files:E.map(v=>l.URI.revive(v.target))},T,I);case 0:case 3:return await this.n(this.h,{files:E.map(v=>l.URI.revive(v.target))},T,I)}}async n(k,E,T,I){const v=new Set,i=[];if(await k.fireAsync(E,I,async(h,y)=>{const w=Date.now(),g=await Promise.resolve(h);g instanceof P.WorkspaceEdit&&(i.push([y.extension,g]),v.add(y.extension.displayName??y.extension.identifier.value)),Date.now()-w>T&&this.k.warn("SLOW file-participant",y.extension.identifier)}),I.isCancellationRequested||i.length===0)return;const d={edits:[]};for(const[,h]of i){const{edits:y}=A.WorkspaceEdit.from(h,{getTextDocumentVersion:w=>this.l.getDocument(w)?.version,getNotebookDocumentVersion:()=>{}});d.edits=d.edits.concat(y)}return{edit:d,extensionNames:Array.from(v)}}}e.ExtHostFileSystemEventService=p}),define(Ce[272],ke([1,0,2,41]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class l{constructor(A,P,D,p,O){this.a=P,this.b=D,this.c=p;const k=new R.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new R.ApiCommandArgument("showOptions","Show Options",E=>!0,E=>E),new R.ApiCommandArgument("resource","Interactive resource Uri",E=>!0,E=>E),new R.ApiCommandArgument("controllerId","Notebook controller Id",E=>!0,E=>E),new R.ApiCommandArgument("title","Interactive editor title",E=>!0,E=>E)],new R.ApiCommandResult("Notebook and input URI",E=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",E.notebookEditorId),E.notebookEditorId!==void 0){const T=this.a.getEditorById(E.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",T.id),{notebookUri:o.URI.revive(E.notebookUri),inputUri:o.URI.revive(E.inputUri),notebookEditor:T.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",E.notebookUri,E.inputUri),{notebookUri:o.URI.revive(E.notebookUri),inputUri:o.URI.revive(E.inputUri)}}));this.c.registerApiCommand(k)}$willAddInteractiveDocument(A,P,D,p){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:P,lines:[""],languageId:D,uri:A,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(o.URI.revive(p))?.apiNotebook}]})}$willRemoveInteractiveDocument(A,P){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.ExtHostInteractive=l}),define(Ce[273],ke([1,0,6,2,5,11,7]),function(ae,e,o,R,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class P{constructor(k,E){this.extension=k,this.provider=E,this.handle=P.a++}}P.a=0;class D{constructor(k){this.session=k,this.responses=[]}}class p{constructor(k,E,T){this.e=E,this.f=T,this.b=new Map,this.c=new Map,this.d=k.getProxy(l.MainContext.MainThreadInteractiveEditor)}registerProvider(k,E){const T=new P(k,E);return this.b.set(T.handle,T),this.d.$registerInteractiveEditorProvider(T.handle,k.identifier.value,typeof E.handleInteractiveEditorResponseFeedback=="function"),(0,o.toDisposable)(()=>{this.d.$unregisterInteractiveEditorProvider(T.handle),this.b.delete(T.handle)})}async $prepareInteractiveSession(k,E,T,I){const v=this.b.get(k);if(!v){this.f.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const i=this.e.getDocument(R.URI.revive(E)),d=L.Selection.to(T),h=await v.provider.prepareInteractiveEditorSession({document:i,selection:d},I);if(!h)return;if(h.wholeRange&&!h.wholeRange.contains(d))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const y=p.a++;return this.c.set(y,new D(h)),{id:y,placeholder:h.placeholder,slashCommands:h.slashCommands,wholeRange:L.Range.from(h.wholeRange)}}async $provideResponse(k,E,T,I){const v=this.b.get(k);if(!v)return;const i=this.c.get(E.id);if(!i)return;const d=await v.provider.provideInteractiveEditorResponse({session:i.session,prompt:T.prompt,selection:L.Selection.to(T.selection),wholeRange:L.Range.to(T.wholeRange)},I);if(d){const h=i.responses.push(d)-1,y={wholeRange:L.Range.from(d.wholeRange),placeholder:d.placeholder};if(p.g(d))return{...y,id:h,type:"message",message:L.MarkdownString.from(d.contents)};const{edits:w}=d;if(w instanceof A.WorkspaceEdit)return{...y,id:h,type:"bulkEdit",edits:L.WorkspaceEdit.from(w)};if(Array.isArray(w))return{...y,id:h,type:"editorEdit",edits:w.map(L.TextEdit.from)}}}$handleFeedback(k,E,T,I){const v=this.b.get(k),i=this.c.get(E),d=i?.responses[T];if(v&&d){let h;switch(I){case 1:h=A.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:h=A.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:h=A.InteractiveEditorResponseFeedbackKind.Undone;break}v.provider.handleInteractiveEditorResponseFeedback?.(i.session,d,h)}}$releaseSession(k,E){const T=this.c.get(E),I=this.b.get(k);T&&I&&I.provider.releaseInteractiveEditorSession?.(T.session),this.c.delete(E)}static g(k){return typeof k=="object"&&typeof k.contents=="object"}}e.ExtHostInteractiveEditor=p,p.a=0}),define(Ce[274],ke([1,0,3,6,37,184,5,11]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveSession=void 0;class D{constructor(k,E){this.extension=k,this.provider=E,this.handle=D.a++}}D.a=0;class p{constructor(k,E){this.h=E,this.b=new Map,this.d=new Map,this.e=new o.Emitter,this.onDidPerformUserAction=this.e.event,this.g=k.getProxy(A.MainContext.MainThreadInteractiveSession)}registerInteractiveSessionProvider(k,E,T){const I=new D(k,T);return this.b.set(I.handle,I),this.g.$registerInteractiveSessionProvider(I.handle,E),(0,R.toDisposable)(()=>{this.g.$unregisterInteractiveSessionProvider(I.handle),this.b.delete(I.handle)})}addInteractiveSessionRequest(k){this.g.$addInteractiveSessionRequest(k)}sendInteractiveRequestToProvider(k,E){this.g.$sendInteractiveRequestToProvider(k,E)}async $prepareInteractiveSession(k,E,T){const I=this.b.get(k);if(!I)return;const v=await I.provider.prepareSession(E,T);if(!v)return;const i=p.a++;return this.d.set(i,v),{id:i,requesterUsername:v.requester?.name,requesterAvatarIconUri:v.requester?.icon,responderUsername:v.responder?.name,responderAvatarIconUri:v.responder?.icon,inputPlaceholder:v.inputPlaceholder}}async $resolveInteractiveRequest(k,E,T,I){const v=this.b.get(k);if(!v)return;const i=this.d.get(E);if(!i||!v.provider.resolveRequest)return;const d=await v.provider.resolveRequest(i,T,I);if(d)return{message:typeof d.message=="string"?d.message:P.InteractiveSessionReplyFollowup.from(d.message)}}async $provideWelcomeMessage(k,E){const T=this.b.get(k);if(!T||!T.provider.provideWelcomeMessage)return;const I=await T.provider.provideWelcomeMessage(E);if(I)return I.map(v=>typeof v=="string"?v:v.map(i=>P.InteractiveSessionReplyFollowup.from(i)))}async $provideFollowups(k,E,T){const I=this.b.get(k);if(!I)return;const v=this.d.get(E);return!v||!I.provider.provideFollowups?void 0:(await I.provider.provideFollowups(v,T))?.map(d=>P.InteractiveSessionFollowup.from(d))}async $provideInteractiveReply(k,E,T,I){const v=this.b.get(k);if(!v)return;const i=this.d.get(E);if(!i)return;const d={session:i,message:typeof T.message=="string"?T.message:P.InteractiveSessionReplyFollowup.to(T.message)},h=l.StopWatch.create(!1);let y;const w={report:s=>{I.isCancellationRequested||(typeof y>"u"&&(y=h.elapsed()),this.g.$acceptInteractiveResponseProgress(k,E,s))}};let g;try{g=await v.provider.provideResponseWithProgress(d,w,I),g||(g={errorDetails:{message:(0,L.localize)(0,null)}})}catch(s){g={errorDetails:{message:(0,L.localize)(1,null,s.message),responseIsIncomplete:!0}},this.h.error(s)}try{if(i.saveState&&this.d.has(E)){const s=i.saveState();this.g.$acceptInteractiveSessionState(E,s)}}catch(s){this.h.warn(s)}const t={firstProgress:y??0,totalElapsed:h.elapsed()};return{errorDetails:g.errorDetails,timings:t}}async $provideSlashCommands(k,E,T){const I=this.b.get(k);if(!I)return;const v=this.d.get(E);return!v||!I.provider.provideSlashCommands?void 0:(await I.provider.provideSlashCommands(v,T))?.map(d=>({...d,kind:P.CompletionItemKind.from(d.kind)}))}$releaseSession(k){this.d.delete(k)}async $onDidPerformUserAction(k){this.e.fire(k)}}e.ExtHostInteractiveSession=p,p.a=0}),define(Ce[275],ke([1,0,5,7]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class l{constructor(A){this.a=new Map,this.b=A.getProxy(o.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(A,P){if(this.a.size===0)throw new Error("No issue request handlers registered");const D=this.a.get(A);if(!D)throw new Error("Issue request handler not found");const p=await D.handleIssueUrlRequest();if(!p)throw new Error("Issue request handler returned no result");return p}registerIssueUriRequestHandler(A,P){const D=A.identifier.value;return this.a.set(D,P),this.b.$registerIssueUriRequestHandler(D),new R.Disposable(()=>{this.b.$unregisterIssueUriRequestHandler(D),this.a.delete(D)})}}e.ExtHostIssueReporter=l}),define(Ce[276],ke([1,0,6,5]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class l{constructor(A){this.b=0,this.a=A.getProxy(R.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(A){const P=this.b++;return this.a.$registerResourceLabelFormatter(P,A),(0,o.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(P)})}}e.ExtHostLabelService=l}),define(Ce[277],ke([1,0,2,23,11,7,73,5,9,32,18,10,152,21,6,120,102,76,37,8,19,27,185]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d,h,y,w,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class s{constructor(N,q){this.d=N,this.e=q}async provideDocumentSymbols(N,q){const J=this.d.getDocument(N),te=await this.e.provideDocumentSymbols(J,q);if(!(0,O.isFalsyOrEmpty)(te))return te[0]instanceof L.DocumentSymbol?te.map(l.DocumentSymbol.from):s.f(te)}static f(N){N=N.slice(0).sort((te,ve)=>{let De=te.location.range.start.compareTo(ve.location.range.start);return De===0&&(De=ve.location.range.end.compareTo(te.location.range.end)),De});const q=[],J=[];for(const te of N){const ve={name:te.name||"!!MISSING: name!!",kind:l.SymbolKind.from(te.kind),tags:te.tags?.map(l.SymbolTag.from)||[],detail:"",containerName:te.containerName,range:l.Range.from(te.location.range),selectionRange:l.Range.from(te.location.range),children:[]};for(;;){if(J.length===0){J.push(ve),q.push(ve);break}const De=J[J.length-1];if(p.Range.containsRange(De.range,ve.range)&&!p.Range.equalsRange(De.range,ve.range)){De.children?.push(ve),J.push(ve);break}J.pop()}}return q}}class r{constructor(N,q,J){this.g=N,this.h=q,this.j=J,this.e=new d.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(N,q){const J=this.g.getDocument(N),te=await this.j.provideCodeLenses(J,q);if(!te||q.isCancellationRequested)return;const ve=this.e.add(te),De=new I.DisposableStore;this.f.set(ve,De);const me={cacheId:ve,lenses:[]};for(let Te=0;Te<te.length;Te++)me.lenses.push({cacheId:[ve,Te],range:l.Range.from(te[Te].range),command:this.h.toInternal(te[Te].command,De)});return me}async resolveCodeLens(N,q){const J=N.cacheId&&this.e.get(...N.cacheId);if(!J)return;let te;if(typeof this.j.resolveCodeLens!="function"||J.isResolved?te=J:te=await this.j.resolveCodeLens(J,q),te||(te=J),q.isCancellationRequested)return;const ve=N.cacheId&&this.f.get(N.cacheId[0]);if(ve)return N.command=this.h.toInternal(te.command??r.d,ve),N}releaseCodeLenses(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}}r.d={command:"missing",title:"!!MISSING: command!!"};function a(ue){return Array.isArray(ue)?ue.map(l.DefinitionLink.from):ue?[l.DefinitionLink.from(ue)]:[]}class b{constructor(N,q){this.d=N,this.e=q}async provideDefinition(N,q,J){const te=this.d.getDocument(N),ve=l.Position.to(q),De=await this.e.provideDefinition(te,ve,J);return a(De)}}class S{constructor(N,q){this.d=N,this.e=q}async provideDeclaration(N,q,J){const te=this.d.getDocument(N),ve=l.Position.to(q),De=await this.e.provideDeclaration(te,ve,J);return a(De)}}class c{constructor(N,q){this.d=N,this.e=q}async provideImplementation(N,q,J){const te=this.d.getDocument(N),ve=l.Position.to(q),De=await this.e.provideImplementation(te,ve,J);return a(De)}}class u{constructor(N,q){this.d=N,this.e=q}async provideTypeDefinition(N,q,J){const te=this.d.getDocument(N),ve=l.Position.to(q),De=await this.e.provideTypeDefinition(te,ve,J);return a(De)}}class m{constructor(N,q){this.d=N,this.e=q}async provideHover(N,q,J){const te=this.d.getDocument(N),ve=l.Position.to(q),De=await this.e.provideHover(te,ve,J);if(!(!De||(0,O.isFalsyOrEmpty)(De.contents)))return De.range||(De.range=te.getWordRangeAtPosition(ve)),De.range||(De.range=new L.Range(ve,ve)),l.Hover.from(De)}}class f{constructor(N,q){this.d=N,this.e=q}async provideEvaluatableExpression(N,q,J){const te=this.d.getDocument(N),ve=l.Position.to(q),De=await this.e.provideEvaluatableExpression(te,ve,J);if(De)return l.EvaluatableExpression.from(De)}}class n{constructor(N,q){this.d=N,this.e=q}async provideInlineValues(N,q,J,te){const ve=this.d.getDocument(N),De=await this.e.provideInlineValues(ve,l.Range.to(q),l.InlineValueContext.to(J),te);if(Array.isArray(De))return De.map(me=>l.InlineValue.from(me))}}class C{constructor(N,q){this.d=N,this.e=q}async provideDocumentHighlights(N,q,J){const te=this.d.getDocument(N),ve=l.Position.to(q),De=await this.e.provideDocumentHighlights(te,ve,J);if(Array.isArray(De))return De.map(l.DocumentHighlight.from)}}class M{constructor(N,q){this.d=N,this.e=q}async provideLinkedEditingRanges(N,q,J){const te=this.d.getDocument(N),ve=l.Position.to(q),De=await this.e.provideLinkedEditingRanges(te,ve,J);if(De&&Array.isArray(De.ranges))return{ranges:(0,O.coalesce)(De.ranges.map(l.Range.from)),wordPattern:De.wordPattern}}}class H{constructor(N,q){this.d=N,this.e=q}async provideReferences(N,q,J,te){const ve=this.d.getDocument(N),De=l.Position.to(q),me=await this.e.provideReferences(ve,De,J,te);if(Array.isArray(me))return me.map(l.location.from)}}class V{constructor(N,q,J,te,ve,De,me){this.g=N,this.h=q,this.j=J,this.k=te,this.l=ve,this.m=De,this.n=me,this.e=new d.Cache("CodeAction"),this.f=new Map}async provideCodeActions(N,q,J,te){const ve=this.g.getDocument(N),De=E.Selection.isISelection(q)?l.Selection.to(q):l.Range.to(q),me=[];for(const Ye of this.j.getDiagnostics(N))if(De.intersection(Ye.range)&&me.push(Ye)>V.d)break;const Te={diagnostics:me,only:J.only?new L.CodeActionKind(J.only):void 0,triggerKind:l.CodeActionTriggerKind.to(J.trigger)},Pe=await this.k.provideCodeActions(ve,De,Te,te);if(!(0,O.isNonEmptyArray)(Pe)||te.isCancellationRequested)return;const $e=this.e.add(Pe),Ve=new I.DisposableStore;this.f.set($e,Ve);const et=[];for(let Ye=0;Ye<Pe.length;Ye++){const Je=Pe[Ye];Je&&(V.o(Je)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:Je.title,command:this.h.toInternal(Je,Ve)})):(Te.only&&(Je.kind?Te.only.contains(Je.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${Je.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[$e,Ye],title:Je.title,command:Je.command&&this.h.toInternal(Je.command,Ve),diagnostics:Je.diagnostics&&Je.diagnostics.map(l.Diagnostic.from),edit:Je.edit&&l.WorkspaceEdit.from(Je.edit,void 0),kind:Je.kind&&Je.kind.value,isPreferred:Je.isPreferred,disabled:Je.disabled?.reason})))}return{cacheId:$e,actions:et}}async resolveCodeAction(N,q){const[J,te]=N,ve=this.e.get(J,te);if(!ve||V.o(ve))return{};if(!this.k.resolveCodeAction)return{};const De=await this.k.resolveCodeAction(ve,q)??ve;let me;De.edit&&(me=l.WorkspaceEdit.from(De.edit,void 0));let Te;if(De.command){const Pe=this.f.get(J);Pe&&(Te=this.h.toInternal(De.command,Pe))}return{edit:me,command:Te}}releaseCodeActions(N){this.f.get(N)?.dispose(),this.f.delete(N),this.e.delete(N)}static o(N){return typeof N.command=="string"&&typeof N.title=="string"}}V.d=1e3;class U{constructor(N,q,J,te){this.d=N,this.e=q,this.f=J,this.g=te}async prepareDocumentPaste(N,q,J,te){if(!this.f.prepareDocumentPaste)return;const ve=this.e.getDocument(N),De=q.map(Te=>l.Range.to(Te)),me=l.DataTransfer.toDataTransfer(J,()=>{throw new y.NotImplementedError});return await this.f.prepareDocumentPaste(ve,De,me,te),l.DataTransfer.toDataTransferDTO(me)}async providePasteEdits(N,q,J,te,ve){const De=this.e.getDocument(q),me=J.map($e=>l.Range.to($e)),Te=l.DataTransfer.toDataTransfer(te,async $e=>(await this.d.$resolvePasteFileData(this.g,N,$e)).buffer),Pe=await this.f.provideDocumentPasteEdits(De,me,Te,ve);if(Pe)return{insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?l.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class z{constructor(N,q){this.d=N,this.e=q}async provideDocumentFormattingEdits(N,q,J){const te=this.d.getDocument(N),ve=await this.e.provideDocumentFormattingEdits(te,q,J);if(Array.isArray(ve))return ve.map(l.TextEdit.from)}}class G{constructor(N,q){this.d=N,this.e=q}async provideDocumentRangeFormattingEdits(N,q,J,te){const ve=this.d.getDocument(N),De=l.Range.to(q),me=await this.e.provideDocumentRangeFormattingEdits(ve,De,J,te);if(Array.isArray(me))return me.map(l.TextEdit.from)}async provideDocumentRangesFormattingEdits(N,q,J,te){(0,k.assertType)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ve=this.d.getDocument(N),De=q.map(l.Range.to),me=await this.e.provideDocumentRangesFormattingEdits(ve,De,J,te);if(Array.isArray(me))return me.map(l.TextEdit.from)}}class F{constructor(N,q){this.d=N,this.e=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(N,q,J,te,ve){const De=this.d.getDocument(N),me=l.Position.to(q),Te=await this.e.provideOnTypeFormattingEdits(De,me,J,te,ve);if(Array.isArray(Te))return Te.map(l.TextEdit.from)}}class ${constructor(N,q){this.e=N,this.f=q,this.d=new d.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(N,q){const J=await this.e.provideWorkspaceSymbols(N,q);if(!(0,O.isNonEmptyArray)(J))return{symbols:[]};const te=this.d.add(J),ve={cacheId:te,symbols:[]};for(let De=0;De<J.length;De++){const me=J[De];if(!me||!me.name){this.f.warn("INVALID SymbolInformation",me);continue}ve.symbols.push({...l.WorkspaceSymbol.from(me),cacheId:[te,De]})}return ve}async resolveWorkspaceSymbol(N,q){if(typeof this.e.resolveWorkspaceSymbol!="function"||!N.cacheId)return N;const J=this.d.get(...N.cacheId);if(J){const te=await this.e.resolveWorkspaceSymbol(J,q);return te&&(0,R.mixin)(N,l.WorkspaceSymbol.from(te),!0)}}releaseWorkspaceSymbols(N){this.d.delete(N)}}class Y{static supportsResolving(N){return typeof N.prepareRename=="function"}constructor(N,q,J){this.d=N,this.e=q,this.f=J}async provideRenameEdits(N,q,J,te){const ve=this.d.getDocument(N),De=l.Position.to(q);try{const me=await this.e.provideRenameEdits(ve,De,J,te);return me?l.WorkspaceEdit.from(me):void 0}catch(me){const Te=Y.g(me);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(me)}}async resolveRenameLocation(N,q,J){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const te=this.d.getDocument(N),ve=l.Position.to(q);try{const De=await this.e.prepareRename(te,ve,J);let me,Te;if(L.Range.isRange(De)?(me=De,Te=te.getText(De)):(0,k.isObject)(De)&&(me=De.range,Te=De.placeholder),!me||!Te)return;if(me.start.line>ve.line||me.end.line<ve.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:l.Range.from(me),text:Te}}catch(De){const me=Y.g(De);return me?{rejectReason:me,range:void 0,text:void 0}:Promise.reject(De)}}static g(N){return typeof N=="string"?N:N instanceof Error&&typeof N.message=="string"?N.message:void 0}}class _{constructor(N,q){this.resultId=N,this.tokens=q}}class Q{constructor(N,q){this.f=N,this.g=q,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(N,q,J){const te=this.f.getDocument(N),ve=q!==0?this.d.get(q):null;let De=typeof ve?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(te,ve.resultId,J):await this.g.provideDocumentSemanticTokens(te,J);return ve&&this.d.delete(q),De?(De=Q.h(De),this.o(Q.n(ve,De),De)):null}async releaseDocumentSemanticColoring(N){this.d.delete(N)}static h(N){return Q.j(N)?Q.k(N)?N:new L.SemanticTokens(new Uint32Array(N.data),N.resultId):Q.l(N)?Q.m(N)?N:new L.SemanticTokensEdits(N.edits.map(q=>new L.SemanticTokensEdit(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),N.resultId):N}static j(N){return N&&!!N.data}static k(N){return N.data instanceof Uint32Array}static l(N){return N&&Array.isArray(N.edits)}static m(N){for(const q of N.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static n(N,q){if(!Q.j(q)||!N||!N.tokens)return q;const J=N.tokens,te=J.length,ve=q.data,De=ve.length;let me=0;const Te=Math.min(te,De);for(;me<Te&&J[me]===ve[me];)me++;if(me===te&&me===De)return new L.SemanticTokensEdits([],q.resultId);let Pe=0;const $e=Te-me;for(;Pe<$e&&J[te-Pe-1]===ve[De-Pe-1];)Pe++;return new L.SemanticTokensEdits([{start:me,deleteCount:te-me-Pe,data:ve.subarray(me,De-Pe)}],q.resultId)}o(N,q){if(Q.j(N)){const J=this.e++;return this.d.set(J,new _(N.resultId,N.data)),(0,v.encodeSemanticTokensDto)({id:J,type:"full",data:N.data})}if(Q.l(N)){const J=this.e++;return Q.j(q)?this.d.set(J,new _(q.resultId,q.data)):this.d.set(J,new _(N.resultId)),(0,v.encodeSemanticTokensDto)({id:J,type:"delta",deltas:(N.edits||[]).map(te=>({start:te.start,deleteCount:te.deleteCount,data:te.data}))})}return null}}class ie{constructor(N,q){this.d=N,this.e=q}async provideDocumentRangeSemanticTokens(N,q,J){const te=this.d.getDocument(N),ve=await this.e.provideDocumentRangeSemanticTokens(te,l.Range.to(q),J);return ve?this.f(ve):null}f(N){return(0,v.encodeSemanticTokensDto)({id:0,type:"full",data:N.data})}}class oe{static supportsResolving(N){return typeof N.resolveCompletionItem=="function"}constructor(N,q,J,te,ve){this.f=N,this.g=q,this.h=J,this.j=te,this.k=ve,this.d=new d.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(N,q,J,te){const ve=this.f.getDocument(N),De=l.Position.to(q),me=ve.getWordRangeAtPosition(De)||new L.Range(De,De),Te=me.with({end:De}),Pe=new h.StopWatch(!0),$e=await this.h.provideCompletionItems(ve,De,te,l.CompletionContext.to(J));if(!$e||te.isCancellationRequested)return;const Ve=Array.isArray($e)?new L.CompletionList($e):$e,et=oe.supportsResolving(this.h)?this.d.add(Ve.items):this.d.add([]),Ye=new I.DisposableStore;this.e.set(et,Ye);const Je=[],nt={x:et,b:Je,a:{replace:l.Range.from(me),insert:l.Range.from(Te)},c:Ve.isIncomplete||void 0,d:Pe.elapsed()};for(let ct=0;ct<Ve.items.length;ct++){const Fe=Ve.items[ct],it=this.l(Fe,[et,ct],Te,me);Je.push(it)}return nt}async resolveCompletionItem(N,q){if(typeof this.h.resolveCompletionItem!="function")return;const J=this.d.get(...N);if(!J)return;const te=await this.h.resolveCompletionItem(J,q);if(te)return this.l(te,N)}releaseCompletionItems(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,q,J,te){const ve=this.e.get(q[0]);if(!ve)throw Error("DisposableStore is missing...");const De=this.g.toInternal(N.command,ve),me={x:q,a:N.label,b:N.kind!==void 0?l.CompletionItemKind.from(N.kind):void 0,m:N.tags&&N.tags.map(l.CompletionItemTag.from),c:N.detail,d:typeof N.documentation>"u"?void 0:l.MarkdownString.fromStrict(N.documentation),e:N.sortText!==N.label?N.sortText:void 0,f:N.filterText!==N.label?N.filterText:void 0,g:N.preselect||void 0,i:N.keepWhitespace?1:0,k:N.commitCharacters?.join(""),l:N.additionalTextEdits&&N.additionalTextEdits.map(l.TextEdit.from),n:De?.$ident,o:De?.id,p:De?.$ident?void 0:De?.arguments};N.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),me.h=N.textEdit.newText):typeof N.insertText=="string"?me.h=N.insertText:N.insertText instanceof L.SnippetString&&(me.h=N.insertText.value,me.i|=4);let Te;return N.textEdit?Te=N.textEdit.range:N.range&&(Te=N.range),L.Range.isRange(Te)?me.j=l.Range.from(Te):Te&&(!J?.isEqual(Te.inserting)||!te?.isEqual(Te.replacing))&&(me.j={insert:l.Range.from(Te.inserting),replace:l.Range.from(Te.replacing)}),me}}class Ee{async provideInlineCompletions(N,q,J,te){}disposeCompletions(N){}handleDidShowCompletionItem(N,q,J){}handlePartialAccept(N,q,J){}}class he extends Ee{constructor(N,q,J,te){super(),this.f=N,this.g=q,this.h=J,this.j=te,this.d=new fe,this.e=(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[A.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[A.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(N,q,J,te){const ve=this.g.getDocument(N),De=l.Position.to(q),me=await this.h.provideInlineCompletionItems(ve,De,{selectedCompletionInfo:J.selectedSuggestionInfo?{range:l.Range.to(J.selectedSuggestionInfo.range),text:J.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[J.triggerKind]},te);if(!me||te.isCancellationRequested)return;const Te=Array.isArray(me)?me:me.items,Pe=this.e?Array.isArray(me)?[]:me.commands||[]:[],$e=this.e&&!Array.isArray(me)?me.suppressSuggestions:void 0,Ve=this.e&&!Array.isArray(me)?me.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:Te}),items:Te.map((Je,nt)=>{let ct;Je.command&&(et||(et=new I.DisposableStore),ct=this.j.toInternal(Je.command,et));const Fe=Je.insertText;return{insertText:typeof Fe=="string"?Fe:{snippet:Fe.value},filterText:Je.filterText,range:Je.range?l.Range.from(Je.range):void 0,command:ct,idx:nt,completeBracketPairs:this.e?Je.completeBracketPairs:!1}}),commands:Pe.map(Je=>(et||(et=new I.DisposableStore),this.j.toInternal(Je,et))),suppressSuggestions:$e,enableForwardStability:Ve}}disposeCompletions(N){this.d.disposeReferenceId(N)?.dispose()}handleDidShowCompletionItem(N,q,J){const te=this.d.get(N)?.items[q];te&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(te,J)}handlePartialAccept(N,q,J){const te=this.d.get(N)?.items[q];te&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(te,J)}}class fe{constructor(){this.d=new Map,this.e=1}createReferenceId(N){const q=this.e++;return this.d.set(q,N),q}disposeReferenceId(N){const q=this.d.get(N);return this.d.delete(N),q}get(N){return this.d.get(N)}}class x{constructor(N,q){this.e=N,this.f=q,this.d=new d.Cache("SignatureHelp")}async provideSignatureHelp(N,q,J,te){const ve=this.e.getDocument(N),De=l.Position.to(q),me=this.g(J),Te=await this.f.provideSignatureHelp(ve,De,te,me);if(Te){const Pe=this.d.add([Te]);return{...l.SignatureHelp.from(Te),id:Pe}}}g(N){let q;if(N.activeSignatureHelp){const J=l.SignatureHelp.to(N.activeSignatureHelp),te=this.d.get(N.activeSignatureHelp.id,0);te?(q=te,q.activeSignature=J.activeSignature,q.activeParameter=J.activeParameter):q=J}return{...N,activeSignatureHelp:q}}releaseSignatureHelp(N){this.d.delete(N)}}class B{constructor(N,q,J,te,ve){this.f=N,this.g=q,this.h=J,this.j=te,this.k=ve,this.d=new d.Cache("InlayHints"),this.e=new Map}async provideInlayHints(N,q,J){const te=this.f.getDocument(N),ve=l.Range.to(q),De=await this.h.provideInlayHints(te,ve,J);if(!Array.isArray(De)||De.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${q}`);return}if(J.isCancellationRequested)return;const me=this.d.add(De);this.e.set(me,new I.DisposableStore);const Te={hints:[],cacheId:me};for(let Pe=0;Pe<De.length;Pe++)this.l(De[Pe],ve)&&Te.hints.push(this.m(De[Pe],[me,Pe]));return this.j.trace(`[InlayHints] ${Te.hints.length} inlay hints from '${this.k.identifier.value}' for ${q}`),Te}async resolveInlayHint(N,q){if(typeof this.h.resolveInlayHint!="function")return;const J=this.d.get(...N);if(!J)return;const te=await this.h.resolveInlayHint(J,q);if(te&&this.l(te))return this.m(te,N)}releaseHints(N){this.e.get(N)?.dispose(),this.e.delete(N),this.d.delete(N)}l(N,q){return N.label.length===0||Array.isArray(N.label)&&N.label.every(J=>J.value.length===0)?(console.log("INVALID inlay hint, empty label",N),!1):!(q&&!q.contains(N.position))}m(N,q){const J=this.e.get(q[0]);if(!J)throw Error("DisposableStore is missing...");const te={label:"",cacheId:q,tooltip:l.MarkdownString.fromStrict(N.tooltip),position:l.Position.from(N.position),textEdits:N.textEdits&&N.textEdits.map(l.TextEdit.from),kind:N.kind&&l.InlayHintKind.from(N.kind),paddingLeft:N.paddingLeft,paddingRight:N.paddingRight};return typeof N.label=="string"?te.label=N.label:te.label=N.label.map(ve=>{const De={label:ve.value};return De.tooltip=l.MarkdownString.fromStrict(ve.tooltip),L.Location.isLocation(ve.location)&&(De.location=l.location.from(ve.location)),ve.command&&(De.command=this.g.toInternal(ve.command,J)),De}),te}}class Z{constructor(N,q){this.e=N,this.f=q,this.d=new d.Cache("DocumentLink")}async provideLinks(N,q){const J=this.e.getDocument(N),te=await this.f.provideDocumentLinks(J,q);if(!(!Array.isArray(te)||te.length===0)&&!q.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:te.filter(Z.g).map(l.DocumentLink.from)};{const ve=this.d.add(te),De={links:[],cacheId:ve};for(let me=0;me<te.length;me++){if(!Z.g(te[me]))continue;const Te=l.DocumentLink.from(te[me]);Te.cacheId=[ve,me],De.links.push(Te)}return De}}}static g(N){return N.target&&N.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(N,q){if(typeof this.f.resolveDocumentLink!="function")return;const J=this.d.get(...N);if(!J)return;const te=await this.f.resolveDocumentLink(J,q);if(!(!te||!Z.g(te)))return l.DocumentLink.from(te)}releaseLinks(N){this.d.delete(N)}}class pe{constructor(N,q){this.d=N,this.e=q}async provideColors(N,q){const J=this.d.getDocument(N),te=await this.e.provideDocumentColors(J,q);return Array.isArray(te)?te.map(De=>({color:l.Color.from(De.color),range:l.Range.from(De.range)})):[]}async provideColorPresentations(N,q,J){const te=this.d.getDocument(N),ve=l.Range.to(q.range),De=l.Color.to(q.color),me=await this.e.provideColorPresentations(De,{document:te,range:ve},J);if(Array.isArray(me))return me.map(l.ColorPresentation.from)}}class Se{constructor(N,q){this.d=N,this.e=q}async provideFoldingRanges(N,q,J){const te=this.d.getDocument(N),ve=await this.e.provideFoldingRanges(te,q,J);if(Array.isArray(ve))return ve.map(l.FoldingRange.from)}}class re{constructor(N,q,J){this.d=N,this.e=q,this.f=J}async provideSelectionRanges(N,q,J){const te=this.d.getDocument(N),ve=q.map(l.Position.to),De=await this.e.provideSelectionRanges(te,ve,J);if(!(0,O.isNonEmptyArray)(De))return[];if(De.length!==ve.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const me=[];for(let Te=0;Te<ve.length;Te++){const Pe=[];me.push(Pe);let $e=ve[Te],Ve=De[Te];for(;;){if(!Ve.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(Pe.push(l.SelectionRange.from(Ve)),!Ve.parent)break;$e=Ve.range,Ve=Ve.parent}}return me}}class ne{constructor(N,q){this.f=N,this.g=q,this.d=new i.IdGenerator(""),this.e=new Map}async prepareSession(N,q,J){const te=this.f.getDocument(N),ve=l.Position.to(q),De=await this.g.prepareCallHierarchy(te,ve,J);if(!De)return;const me=this.d.nextId();return this.e.set(me,new Map),Array.isArray(De)?De.map(Te=>this.h(me,Te)):[this.h(me,De)]}async provideCallsTo(N,q,J){const te=this.j(N,q);if(!te)throw new Error("missing call hierarchy item");const ve=await this.g.provideCallHierarchyIncomingCalls(te,J);if(ve)return ve.map(De=>({from:this.h(N,De.from),fromRanges:De.fromRanges.map(me=>l.Range.from(me))}))}async provideCallsFrom(N,q,J){const te=this.j(N,q);if(!te)throw new Error("missing call hierarchy item");const ve=await this.g.provideCallHierarchyOutgoingCalls(te,J);if(ve)return ve.map(De=>({to:this.h(N,De.to),fromRanges:De.fromRanges.map(me=>l.Range.from(me))}))}releaseSession(N){this.e.delete(N)}h(N,q){const J=this.e.get(N),te=l.CallHierarchyItem.from(q,N,J.size.toString(36));return J.set(te._itemId,q),te}j(N,q){return this.e.get(N)?.get(q)}}class de{constructor(N,q){this.f=N,this.g=q,this.d=new i.IdGenerator(""),this.e=new Map}async prepareSession(N,q,J){const te=this.f.getDocument(N),ve=l.Position.to(q),De=await this.g.prepareTypeHierarchy(te,ve,J);if(!De)return;const me=this.d.nextId();return this.e.set(me,new Map),Array.isArray(De)?De.map(Te=>this.h(me,Te)):[this.h(me,De)]}async provideSupertypes(N,q,J){const te=this.j(N,q);if(!te)throw new Error("missing type hierarchy item");const ve=await this.g.provideTypeHierarchySupertypes(te,J);if(ve)return ve.map(De=>this.h(N,De))}async provideSubtypes(N,q,J){const te=this.j(N,q);if(!te)throw new Error("missing type hierarchy item");const ve=await this.g.provideTypeHierarchySubtypes(te,J);if(ve)return ve.map(De=>this.h(N,De))}releaseSession(N){this.e.delete(N)}h(N,q){const J=this.e.get(N),te=l.TypeHierarchyItem.from(q,N,J.size.toString(36));return J.set(te._itemId,q),te}j(N,q){return this.e.get(N)?.get(q)}}class ee{constructor(N,q,J,te,ve){this.d=N,this.e=q,this.f=J,this.g=te,this.h=ve}async provideDocumentOnDropEdits(N,q,J,te,ve){const De=this.e.getDocument(q),me=l.Position.to(J),Te=l.DataTransfer.toDataTransfer(te,async $e=>(await this.d.$resolveDocumentOnDropFileData(this.g,N,$e)).buffer),Pe=await this.f.provideDocumentDropEdits(De,me,Te,ve);if(Pe)return{label:Pe.label??(0,t.localize)(0,null,this.h.displayName||this.h.name),insertText:typeof Pe.insertText=="string"?Pe.insertText:{snippet:Pe.insertText.value},additionalEdit:Pe.additionalEdit?l.WorkspaceEdit.from(Pe.additionalEdit,void 0):void 0}}}class ce{constructor(N,q){this.adapter=N,this.extension=q}}class le{constructor(N,q,J,te,ve,De,me,Te){this.g=q,this.h=J,this.j=te,this.k=ve,this.l=De,this.m=me,this.n=Te,this.f=new Map,this.e=N.getProxy(P.MainContext.MainThreadLanguageFeatures)}o(N,q){return l.DocumentSelector.from(N,this.g,q)}p(N){return new L.Disposable(()=>{this.f.delete(N),this.e.$unregister(N)})}q(){return le.d++}async s(N,q,J,te,ve,De=!1){const me=this.f.get(N);if(!me||!(me.adapter instanceof q))return te;const Te=Date.now();De||this.l.trace(`[${me.extension.identifier.value}] INVOKE provider '${J.toString().replace(/[\r\n]/g,"")}'`);const Pe=J(me.adapter,me.extension);return Promise.resolve(Pe).catch($e=>{(0,y.isCancellationError)($e)||(this.l.error(`[${me.extension.identifier.value}] provider FAILED`),this.l.error($e),this.n.onExtensionError(me.extension.identifier,$e))}).finally(()=>{De||this.l.trace(`[${me.extension.identifier.value}] provider DONE after ${Date.now()-Te}ms`)}),T.CancellationToken.isCancellationToken(ve)?(0,w.raceCancellationError)(Pe,ve):Pe}t(N,q){const J=this.q();return this.f.set(J,new ce(N,q)),J}static u(N){return N.displayName||N.name}registerDocumentSymbolProvider(N,q,J,te){const ve=this.t(new s(this.h,J),N),De=te&&te.label||le.u(N);return this.e.$registerDocumentSymbolProvider(ve,this.o(q,N),De),this.p(ve)}$provideDocumentSymbols(N,q,J){return this.s(N,s,te=>te.provideDocumentSymbols(o.URI.revive(q),J),void 0,J)}registerCodeLensProvider(N,q,J){const te=this.q(),ve=typeof J.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(te,new ce(new r(this.h,this.j.converter,J),N)),this.e.$registerCodeLensSupport(te,this.o(q,N),ve);let De=this.p(te);if(ve!==void 0){const me=J.onDidChangeCodeLenses(Te=>this.e.$emitCodeLensEvent(ve));De=L.Disposable.from(De,me)}return De}$provideCodeLenses(N,q,J){return this.s(N,r,te=>te.provideCodeLenses(o.URI.revive(q),J),void 0,J)}$resolveCodeLens(N,q,J){return this.s(N,r,te=>te.resolveCodeLens(q,J),void 0,void 0)}$releaseCodeLenses(N,q){this.s(N,r,J=>Promise.resolve(J.releaseCodeLenses(q)),void 0,void 0)}registerDefinitionProvider(N,q,J){const te=this.t(new b(this.h,J),N);return this.e.$registerDefinitionSupport(te,this.o(q,N)),this.p(te)}$provideDefinition(N,q,J,te){return this.s(N,b,ve=>ve.provideDefinition(o.URI.revive(q),J,te),[],te)}registerDeclarationProvider(N,q,J){const te=this.t(new S(this.h,J),N);return this.e.$registerDeclarationSupport(te,this.o(q,N)),this.p(te)}$provideDeclaration(N,q,J,te){return this.s(N,S,ve=>ve.provideDeclaration(o.URI.revive(q),J,te),[],te)}registerImplementationProvider(N,q,J){const te=this.t(new c(this.h,J),N);return this.e.$registerImplementationSupport(te,this.o(q,N)),this.p(te)}$provideImplementation(N,q,J,te){return this.s(N,c,ve=>ve.provideImplementation(o.URI.revive(q),J,te),[],te)}registerTypeDefinitionProvider(N,q,J){const te=this.t(new u(this.h,J),N);return this.e.$registerTypeDefinitionSupport(te,this.o(q,N)),this.p(te)}$provideTypeDefinition(N,q,J,te){return this.s(N,u,ve=>ve.provideTypeDefinition(o.URI.revive(q),J,te),[],te)}registerHoverProvider(N,q,J,te){const ve=this.t(new m(this.h,J),N);return this.e.$registerHoverProvider(ve,this.o(q,N)),this.p(ve)}$provideHover(N,q,J,te){return this.s(N,m,ve=>ve.provideHover(o.URI.revive(q),J,te),void 0,te)}registerEvaluatableExpressionProvider(N,q,J,te){const ve=this.t(new f(this.h,J),N);return this.e.$registerEvaluatableExpressionProvider(ve,this.o(q,N)),this.p(ve)}$provideEvaluatableExpression(N,q,J,te){return this.s(N,f,ve=>ve.provideEvaluatableExpression(o.URI.revive(q),J,te),void 0,te)}registerInlineValuesProvider(N,q,J,te){const ve=typeof J.onDidChangeInlineValues=="function"?this.q():void 0,De=this.t(new n(this.h,J),N);this.e.$registerInlineValuesProvider(De,this.o(q,N),ve);let me=this.p(De);if(ve!==void 0){const Te=J.onDidChangeInlineValues(Pe=>this.e.$emitInlineValuesEvent(ve));me=L.Disposable.from(me,Te)}return me}$provideInlineValues(N,q,J,te,ve){return this.s(N,n,De=>De.provideInlineValues(o.URI.revive(q),J,te,ve),void 0,ve)}registerDocumentHighlightProvider(N,q,J){const te=this.t(new C(this.h,J),N);return this.e.$registerDocumentHighlightProvider(te,this.o(q,N)),this.p(te)}$provideDocumentHighlights(N,q,J,te){return this.s(N,C,ve=>ve.provideDocumentHighlights(o.URI.revive(q),J,te),void 0,te)}registerLinkedEditingRangeProvider(N,q,J){const te=this.t(new M(this.h,J),N);return this.e.$registerLinkedEditingRangeProvider(te,this.o(q,N)),this.p(te)}$provideLinkedEditingRanges(N,q,J,te){return this.s(N,M,async ve=>{const De=await ve.provideLinkedEditingRanges(o.URI.revive(q),J,te);if(De)return{ranges:De.ranges,wordPattern:De.wordPattern?le.w(De.wordPattern):void 0}},void 0,te)}registerReferenceProvider(N,q,J){const te=this.t(new H(this.h,J),N);return this.e.$registerReferenceSupport(te,this.o(q,N)),this.p(te)}$provideReferences(N,q,J,te,ve){return this.s(N,H,De=>De.provideReferences(o.URI.revive(q),J,te,ve),void 0,ve)}registerCodeActionProvider(N,q,J,te){const ve=new I.DisposableStore,De=this.t(new V(this.h,this.j.converter,this.k,J,this.l,N,this.m),N);return this.e.$registerQuickFixSupport(De,this.o(q,N),{providedKinds:te?.providedCodeActionKinds?.map(me=>me.value),documentation:te?.documentation?.map(me=>({kind:me.kind.value,command:this.j.converter.toInternal(me.command,ve)}))},le.u(N),!!J.resolveCodeAction),ve.add(this.p(De)),ve}$provideCodeActions(N,q,J,te,ve){return this.s(N,V,De=>De.provideCodeActions(o.URI.revive(q),J,te,ve),void 0,ve)}$resolveCodeAction(N,q,J){return this.s(N,V,te=>te.resolveCodeAction(q,J),{},void 0)}$releaseCodeActions(N,q){this.s(N,V,J=>Promise.resolve(J.releaseCodeActions(q)),void 0,void 0)}registerDocumentFormattingEditProvider(N,q,J){const te=this.t(new z(this.h,J),N);return this.e.$registerDocumentFormattingSupport(te,this.o(q,N),N.identifier,N.displayName||N.name),this.p(te)}$provideDocumentFormattingEdits(N,q,J,te){return this.s(N,z,ve=>ve.provideDocumentFormattingEdits(o.URI.revive(q),J,te),void 0,te)}registerDocumentRangeFormattingEditProvider(N,q,J){const te=typeof J.provideDocumentRangesFormattingEdits=="function";te&&(0,g.checkProposedApiEnabled)(N,"formatMultipleRanges");const ve=this.t(new G(this.h,J),N);return this.e.$registerRangeFormattingSupport(ve,this.o(q,N),N.identifier,N.displayName||N.name,te),this.p(ve)}$provideDocumentRangeFormattingEdits(N,q,J,te,ve){return this.s(N,G,De=>De.provideDocumentRangeFormattingEdits(o.URI.revive(q),J,te,ve),void 0,ve)}$provideDocumentRangesFormattingEdits(N,q,J,te,ve){return this.s(N,G,De=>De.provideDocumentRangesFormattingEdits(o.URI.revive(q),J,te,ve),void 0,ve)}registerOnTypeFormattingEditProvider(N,q,J,te){const ve=this.t(new F(this.h,J),N);return this.e.$registerOnTypeFormattingSupport(ve,this.o(q,N),te,N.identifier),this.p(ve)}$provideOnTypeFormattingEdits(N,q,J,te,ve,De){return this.s(N,F,me=>me.provideOnTypeFormattingEdits(o.URI.revive(q),J,te,ve,De),void 0,De)}registerWorkspaceSymbolProvider(N,q){const J=this.t(new $(q,this.l),N);return this.e.$registerNavigateTypeSupport(J,typeof q.resolveWorkspaceSymbol=="function"),this.p(J)}$provideWorkspaceSymbols(N,q,J){return this.s(N,$,te=>te.provideWorkspaceSymbols(q,J),{symbols:[]},J)}$resolveWorkspaceSymbol(N,q,J){return this.s(N,$,te=>te.resolveWorkspaceSymbol(q,J),void 0,void 0)}$releaseWorkspaceSymbols(N,q){this.s(N,$,J=>J.releaseWorkspaceSymbols(q),void 0,void 0)}registerRenameProvider(N,q,J){const te=this.t(new Y(this.h,J,this.l),N);return this.e.$registerRenameSupport(te,this.o(q,N),Y.supportsResolving(J)),this.p(te)}$provideRenameEdits(N,q,J,te,ve){return this.s(N,Y,De=>De.provideRenameEdits(o.URI.revive(q),J,te,ve),void 0,ve)}$resolveRenameLocation(N,q,J,te){return this.s(N,Y,ve=>ve.resolveRenameLocation(o.URI.revive(q),J,te),void 0,te)}registerDocumentSemanticTokensProvider(N,q,J,te){const ve=this.t(new Q(this.h,J),N),De=typeof J.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ve,this.o(q,N),te,De);let me=this.p(ve);if(De){const Te=J.onDidChangeSemanticTokens(Pe=>this.e.$emitDocumentSemanticTokensEvent(De));me=L.Disposable.from(me,Te)}return me}$provideDocumentSemanticTokens(N,q,J,te){return this.s(N,Q,ve=>ve.provideDocumentSemanticTokens(o.URI.revive(q),J,te),null,te)}$releaseDocumentSemanticTokens(N,q){this.s(N,Q,J=>J.releaseDocumentSemanticColoring(q),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(N,q,J,te){const ve=this.t(new ie(this.h,J),N);return this.e.$registerDocumentRangeSemanticTokensProvider(ve,this.o(q,N),te),this.p(ve)}$provideDocumentRangeSemanticTokens(N,q,J,te){return this.s(N,ie,ve=>ve.provideDocumentRangeSemanticTokens(o.URI.revive(q),J,te),null,te)}registerCompletionItemProvider(N,q,J,te){const ve=this.t(new oe(this.h,this.j.converter,J,this.m,N),N);return this.e.$registerCompletionsProvider(ve,this.o(q,N),te,oe.supportsResolving(J),`${N.identifier.value}(${te.join("")})`),this.p(ve)}$provideCompletionItems(N,q,J,te,ve){return this.s(N,oe,De=>De.provideCompletionItems(o.URI.revive(q),J,te,ve),void 0,ve)}$resolveCompletionItem(N,q,J){return this.s(N,oe,te=>te.resolveCompletionItem(q,J),void 0,J)}$releaseCompletionItems(N,q){this.s(N,oe,J=>J.releaseCompletionItems(q),void 0,void 0)}registerInlineCompletionsProvider(N,q,J){const te=new he(N,this.h,J,this.j.converter),ve=this.t(te,N);return this.e.$registerInlineCompletionsSupport(ve,this.o(q,N),te.supportsHandleEvents),this.p(ve)}$provideInlineCompletions(N,q,J,te,ve){return this.s(N,Ee,De=>De.provideInlineCompletions(o.URI.revive(q),J,te,ve),void 0,ve)}$handleInlineCompletionDidShow(N,q,J,te){this.s(N,Ee,async ve=>{ve.handleDidShowCompletionItem(q,J,te)},void 0,void 0)}$handleInlineCompletionPartialAccept(N,q,J,te){this.s(N,Ee,async ve=>{ve.handlePartialAccept(q,J,te)},void 0,void 0)}$freeInlineCompletionsList(N,q){this.s(N,Ee,async J=>{J.disposeCompletions(q)},void 0,void 0)}registerSignatureHelpProvider(N,q,J,te){const ve=Array.isArray(te)?{triggerCharacters:te,retriggerCharacters:[]}:te,De=this.t(new x(this.h,J),N);return this.e.$registerSignatureHelpProvider(De,this.o(q,N),ve),this.p(De)}$provideSignatureHelp(N,q,J,te,ve){return this.s(N,x,De=>De.provideSignatureHelp(o.URI.revive(q),J,te,ve),void 0,ve)}$releaseSignatureHelp(N,q){this.s(N,x,J=>J.releaseSignatureHelp(q),void 0,void 0)}registerInlayHintsProvider(N,q,J){const te=typeof J.onDidChangeInlayHints=="function"?this.q():void 0,ve=this.t(new B(this.h,this.j.converter,J,this.l,N),N);this.e.$registerInlayHintsProvider(ve,this.o(q,N),typeof J.resolveInlayHint=="function",te,le.u(N));let De=this.p(ve);if(te!==void 0){const me=J.onDidChangeInlayHints(Te=>this.e.$emitInlayHintsEvent(te));De=L.Disposable.from(De,me)}return De}$provideInlayHints(N,q,J,te){return this.s(N,B,ve=>ve.provideInlayHints(o.URI.revive(q),J,te),void 0,te)}$resolveInlayHint(N,q,J){return this.s(N,B,te=>te.resolveInlayHint(q,J),void 0,J)}$releaseInlayHints(N,q){this.s(N,B,J=>J.releaseHints(q),void 0,void 0)}registerDocumentLinkProvider(N,q,J){const te=this.t(new Z(this.h,J),N);return this.e.$registerDocumentLinkProvider(te,this.o(q,N),typeof J.resolveDocumentLink=="function"),this.p(te)}$provideDocumentLinks(N,q,J){return this.s(N,Z,te=>te.provideLinks(o.URI.revive(q),J),void 0,J,q.scheme==="output")}$resolveDocumentLink(N,q,J){return this.s(N,Z,te=>te.resolveLink(q,J),void 0,void 0,!0)}$releaseDocumentLinks(N,q){this.s(N,Z,J=>J.releaseLinks(q),void 0,void 0,!0)}registerColorProvider(N,q,J){const te=this.t(new pe(this.h,J),N);return this.e.$registerDocumentColorProvider(te,this.o(q,N)),this.p(te)}$provideDocumentColors(N,q,J){return this.s(N,pe,te=>te.provideColors(o.URI.revive(q),J),[],J)}$provideColorPresentations(N,q,J,te){return this.s(N,pe,ve=>ve.provideColorPresentations(o.URI.revive(q),J,te),void 0,te)}registerFoldingRangeProvider(N,q,J){const te=this.q(),ve=typeof J.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(te,new ce(new Se(this.h,J),N)),this.e.$registerFoldingRangeProvider(te,this.o(q,N),N.identifier,ve);let De=this.p(te);if(ve!==void 0){const me=J.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ve));De=L.Disposable.from(De,me)}return De}$provideFoldingRanges(N,q,J,te){return this.s(N,Se,ve=>ve.provideFoldingRanges(o.URI.revive(q),J,te),void 0,te)}registerSelectionRangeProvider(N,q,J){const te=this.t(new re(this.h,J,this.l),N);return this.e.$registerSelectionRangeProvider(te,this.o(q,N)),this.p(te)}$provideSelectionRanges(N,q,J,te){return this.s(N,re,ve=>ve.provideSelectionRanges(o.URI.revive(q),J,te),[],te)}registerCallHierarchyProvider(N,q,J){const te=this.t(new ne(this.h,J),N);return this.e.$registerCallHierarchyProvider(te,this.o(q,N)),this.p(te)}$prepareCallHierarchy(N,q,J,te){return this.s(N,ne,ve=>Promise.resolve(ve.prepareSession(o.URI.revive(q),J,te)),void 0,te)}$provideCallHierarchyIncomingCalls(N,q,J,te){return this.s(N,ne,ve=>ve.provideCallsTo(q,J,te),void 0,te)}$provideCallHierarchyOutgoingCalls(N,q,J,te){return this.s(N,ne,ve=>ve.provideCallsFrom(q,J,te),void 0,te)}$releaseCallHierarchy(N,q){this.s(N,ne,J=>Promise.resolve(J.releaseSession(q)),void 0,void 0)}registerTypeHierarchyProvider(N,q,J){const te=this.t(new de(this.h,J),N);return this.e.$registerTypeHierarchyProvider(te,this.o(q,N)),this.p(te)}$prepareTypeHierarchy(N,q,J,te){return this.s(N,de,ve=>Promise.resolve(ve.prepareSession(o.URI.revive(q),J,te)),void 0,te)}$provideTypeHierarchySupertypes(N,q,J,te){return this.s(N,de,ve=>ve.provideSupertypes(q,J,te),void 0,te)}$provideTypeHierarchySubtypes(N,q,J,te){return this.s(N,de,ve=>ve.provideSubtypes(q,J,te),void 0,te)}$releaseTypeHierarchy(N,q){this.s(N,de,J=>Promise.resolve(J.releaseSession(q)),void 0,void 0)}registerDocumentOnDropEditProvider(N,q,J,te){const ve=this.q();return this.f.set(ve,new ce(new ee(this.e,this.h,J,ve,N),N)),this.e.$registerDocumentOnDropEditProvider(ve,this.o(q,N),N.identifier,(0,g.isProposedApiEnabled)(N,"dropMetadata")?te:void 0),this.p(ve)}$provideDocumentOnDropEdits(N,q,J,te,ve,De){return this.s(N,ee,me=>Promise.resolve(me.provideDocumentOnDropEdits(q,o.URI.revive(J),te,ve,De)),void 0,void 0)}registerDocumentPasteEditProvider(N,q,J,te){const ve=this.q();return this.f.set(ve,new ce(new U(this.e,this.h,J,ve),N)),this.e.$registerPasteEditProvider(ve,this.o(q,N),!!J.prepareDocumentPaste,te.pasteMimeTypes),this.p(ve)}$prepareDocumentPaste(N,q,J,te,ve){return this.s(N,U,De=>De.prepareDocumentPaste(o.URI.revive(q),J,te,ve),void 0,ve)}$providePasteEdits(N,q,J,te,ve,De){return this.s(N,U,me=>me.providePasteEdits(q,o.URI.revive(J),te,ve,De),void 0,De)}static w(N){return{pattern:N.source,flags:(0,D.regExpFlags)(N)}}static y(N){return{decreaseIndentPattern:le.w(N.decreaseIndentPattern),increaseIndentPattern:le.w(N.increaseIndentPattern),indentNextLinePattern:N.indentNextLinePattern?le.w(N.indentNextLinePattern):void 0,unIndentedLinePattern:N.unIndentedLinePattern?le.w(N.unIndentedLinePattern):void 0}}static z(N){return{beforeText:le.w(N.beforeText),afterText:N.afterText?le.w(N.afterText):void 0,previousLineText:N.previousLineText?le.w(N.previousLineText):void 0,action:N.action}}static B(N){return N.map(le.z)}setLanguageConfiguration(N,q,J){const{wordPattern:te}=J;if(te&&(0,D.regExpLeadsToEndlessLoop)(te))throw new Error(`Invalid language configuration: wordPattern '${te}' is not allowed to match the empty string.`);te?this.h.setWordDefinitionFor(q,te):this.h.setWordDefinitionFor(q,void 0),J.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",N,"Do not use."),J.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",N,"Do not use.");const ve=this.q(),De={comments:J.comments,brackets:J.brackets,wordPattern:J.wordPattern?le.w(J.wordPattern):void 0,indentationRules:J.indentationRules?le.y(J.indentationRules):void 0,onEnterRules:J.onEnterRules?le.B(J.onEnterRules):void 0,__electricCharacterSupport:J.__electricCharacterSupport,__characterPairSupport:J.__characterPairSupport};return this.e.$setLanguageConfiguration(ve,q,De),this.p(ve)}$setWordDefinitions(N){for(const q of N)this.h.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.ExtHostLanguageFeatures=le,le.d=0}),define(Ce[278],ke([1,0,5,11,7,38,19,6]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class D{constructor(O,k,E,T){this.c=k,this.d=E,this.e=T,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(o.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,k){await this.a.$changeLanguage(O,k);const E=this.c.getDocumentData(O);if(!E)throw new Error(`document '${O.toString()}' NOT found`);return E.document}async tokenAtPosition(O,k){const E=O.version,T=R.Position.from(k),I=await this.a.$tokensAtPosition(O.uri,T),v={type:l.StandardTokenType.Other,range:O.getWordRangeAtPosition(k)??new l.Range(k.line,k.character,k.line,k.character)};if(!I)return v;const i={range:R.Range.to(I.range),type:R.TokenType.to(I.type)};return!i.range.contains(k)||E!==O.version?v:i}createLanguageStatusItem(O,k,E){const T=this.f++,I=this.a,v=this.g,i=`${O.identifier.value}/${k}`;if(v.has(i))throw new Error(`LanguageStatusItem with id '${k}' ALREADY exists`);v.add(i);const d={selector:E,id:k,name:O.displayName??O.name,severity:l.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let h;const y=new P.DisposableStore,w=()=>{h?.dispose(),h=(0,A.disposableTimeout)(()=>{y.clear(),this.a.$setLanguageStatus(T,{id:i,name:d.name??O.displayName??O.name,source:O.displayName??O.name,selector:R.DocumentSelector.from(d.selector,this.e),label:d.text,detail:d.detail??"",severity:d.severity===l.LanguageStatusSeverity.Error?L.default.Error:d.severity===l.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:d.command&&this.d.toInternal(d.command,y),accessibilityInfo:d.accessibilityInformation,busy:d.busy})},0)},g={dispose(){y.dispose(),h?.dispose(),I.$removeLanguageStatus(T),v.delete(i)},get id(){return d.id},get name(){return d.name},set name(t){d.name=t,w()},get selector(){return d.selector},set selector(t){d.selector=t,w()},get text(){return d.text},set text(t){d.text=t,w()},get detail(){return d.detail},set detail(t){d.detail=t,w()},get severity(){return d.severity},set severity(t){d.severity=t,w()},get accessibilityInformation(){return d.accessibilityInformation},set accessibilityInformation(t){d.accessibilityInformation=t,w()},get command(){return d.command},set command(t){d.command=t,w()},get busy(){return d.busy},set busy(t){d.busy=t,w()}};return w(),g}}e.ExtHostLanguages=D}),define(Ce[98],ke([1,0,14,9,2,4,16,5,26,20]),function(ae,e,o,R,l,L,A,P,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=e.ExtHostLocalizationService=class{constructor(E,T,I){this.f=I,this.d=new Map,this.a=T.getProxy(P.MainContext.MainThreadLocalization),this.b=E.environment.appLanguage,this.c=this.b===o.LANGUAGE_DEFAULT}getMessage(E,T){const{message:I,args:v,comment:i}=T;if(this.c)return(0,R.format2)(I,v??{});let d=I;i&&i.length>0&&(d+=`/${Array.isArray(i)?i.join(""):i}`);const h=this.d.get(E)?.contents[d];return h||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${d}`),(0,R.format2)(h??I,v??{})}getBundle(E){return this.d.get(E)?.contents}getBundleUri(E){return this.d.get(E)?.uri}async initializeLocalizedMessages(E){if(this.c||!E.l10n&&!E.isBuiltin||this.d.has(E.identifier.value))return;let T;const I=await this.g(E);if(!I){this.f.error(`No bundle location found for extension ${E.identifier.value}`);return}try{const v=await this.a.$fetchBundleContents(I),i=JSON.parse(v);T=E.isBuiltin?i.contents?.bundle:i}catch(v){this.f.error(`Failed to load translations for ${E.identifier.value} from ${I}: ${v.message}`);return}T&&this.d.set(E.identifier.value,{contents:T,uri:I})}async g(E){if(E.isBuiltin){const T=await this.a.$fetchBuiltInBundleUri(E.identifier.value,this.b);return l.URI.revive(T)}return E.l10n?l.URI.joinPath(E.extensionLocation,E.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.ExtHostLocalizationService=O=xe([We(0,D.IExtHostInitDataService),We(1,p.IExtHostRpcService),We(2,A.ILogService)],O),e.IExtHostLocalizationService=(0,L.createDecorator)("IExtHostLocalizationService")}),define(Ce[141],ke([1,0,16,5,26,20,2,70]),function(ae,e,o,R,l,L,A,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let D=e.ExtHostLoggerService=class extends o.AbstractLoggerService{constructor(k,E){super(E.logLevel,E.logsLocation,E.loggers.map(T=>(0,P.revive)(T))),this.n=k.getProxy(R.MainContext.MainThreadLogger)}$setLogLevel(k,E){E?this.setLogLevel(A.URI.revive(E),k):this.setLogLevel(k)}setVisibility(k,E){super.setVisibility(k,E),this.n.$setVisibility(k,E)}m(k,E,T){return new p(this.n,k,E,T)}};e.ExtHostLoggerService=D=xe([We(0,L.IExtHostRpcService),We(1,l.IExtHostInitDataService)],D);class p extends o.AbstractMessageLogger{constructor(k,E,T,I){super(I?.logLevel==="always"),this.m=k,this.n=E,this.k=!1,this.l=[],this.setLevel(T),this.m.$createLogger(E,I).then(()=>{this.r(this.l),this.k=!0})}g(k,E){const T=[[k,E]];this.k?this.r(T):this.l.push(...T)}r(k){this.m.$log(this.n,k)}flush(){this.m.$flush(this.n)}}}),define(Ce[279],ke([1,0,5,16,27]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(P){return P&&P.title}let A=e.ExtHostMessageService=class{constructor(D,p){this.b=p,this.a=D.getProxy(o.MainContext.MainThreadMessageService)}showMessage(D,p,O,k,E){const T={source:{identifier:D.identifier,label:D.displayName||D.name}};let I;typeof k=="string"||L(k)?I=[k,...E]:(T.modal=k?.modal,T.useCustom=k?.useCustom,T.detail=k?.detail,I=E),T.useCustom&&(0,l.checkProposedApiEnabled)(D,"resolvers");const v=[];for(let i=0;i<I.length;i++){const d=I[i];if(typeof d=="string")v.push({title:d,handle:i,isCloseAffordance:!1});else if(typeof d=="object"){const{title:h,isCloseAffordance:y}=d;v.push({title:h,isCloseAffordance:!!y,handle:i})}else this.b.warn("Invalid message item:",d)}return this.a.$showMessage(p,O,T,v).then(i=>{if(typeof i=="number")return I[i]})}};e.ExtHostMessageService=A=xe([We(1,R.ILogService)],A)}),define(Ce[280],ke([1,0,22,3,6,28,9,10,2,76,5,41,11,7,59,250,137,8]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(w=>w.apiEditor)}constructor(w,g,t,s){this.q=t,this.r=s,this.f=new Map,this.g=new L.ResourceMap,this.h=new Map,this.j=new R.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new R.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this.m.event,this.n=new R.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this.n.event,this.o=new R.Emitter({onListenerError:d.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new p.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=w.getProxy(O.MainContext.MainThreadNotebook),this.c=w.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=w.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=g.converter,g.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const a=r.notebookEditor?.notebookUri,b=r.cell.handle,c=this.g.get(a)?.getCell(b);if(c)return c.apiCell}if(r&&r.$mid===14){const a=r.uri,b=this.g.get(a);if(b)return b.apiNotebook}return r}}),h.x(g)}getEditorById(w){const g=this.h.get(w);if(!g)throw new Error(`unknown text editor: ${w}. known editors: ${[...this.h.keys()]} `);return g}getIdByEditor(w){for(const[g,t]of this.h)if(t.apiEditor===w)return g}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(w,g){const t=this.g.get(w);if(!t&&!g)throw new Error(`NO notebook document for '${w}'`);return t}static s(w,g){if(!g)return;const t=g.filenamePattern.map(s=>E.NotebookExclusiveDocumentPattern.from(s)).filter(s=>s!==void 0);if(g.filenamePattern&&!t){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:w.identifier,providerDisplayName:w.displayName||w.name,displayName:g.displayName,filenamePattern:t,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(w,g,t){const s=h.a++,r=typeof t.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(s,t),this.b.$registerNotebookCellStatusBarItemProvider(s,r,g);let a;return r!==void 0&&(a=t.onDidChangeCellStatusBarItems(b=>this.b.$emitCellStatusBarEvent(r))),new T.Disposable(()=>{this.f.delete(s),this.b.$unregisterNotebookCellStatusBarItemProvider(s,r),a?.dispose()})}async createNotebookDocument(w){const g=await this.c.$tryCreateNotebook({viewType:w.viewType,content:w.content&&E.NotebookData.from(w.content)});return D.URI.revive(g)}async openNotebookDocument(w){const g=this.g.get(w);if(g)return g.apiNotebook;const t=await this.c.$tryOpenNotebook(w),s=this.g.get(D.URI.revive(t));return(0,P.assertIsDefined)(s?.apiNotebook)}async showNotebookDocument(w,g){D.URI.isUri(w)&&(w=await this.openNotebookDocument(w));let t;typeof g=="object"?t={position:E.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(E.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:t={preserveFocus:!1};const s=await this.d.$tryShowNotebookDocument(w.uri,w.notebookType,t),r=s&&this.h.get(s)?.apiEditor;if(r)return r;throw s?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(w,g,t,s){const r=this.f.get(w),a=D.URI.revive(g),b=this.g.get(a);if(!b||!r)return;const S=b.getCellFromIndex(t);if(!S)return;const c=await r.provideCellStatusBarItems(S.apiCell,s);if(!c)return;const u=new l.DisposableStore,m=this.p.add([u]),n=(Array.isArray(c)?c:[c]).map(C=>E.NotebookStatusBarItem.from(C,this.i,u));return{cacheId:m,items:n}}$releaseNotebookCellStatusBarItems(w){this.p.delete(w)}registerNotebookSerializer(w,g,t,s,r){if((0,A.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");const a=this.t++;return this.u.set(a,t),this.b.$registerNotebookSerializer(a,{id:w.identifier,location:w.extensionLocation},g,E.NotebookDocumentContentOptions.from(s),h.s(w,r)),(0,l.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(a)})}async $dataToNotebook(w,g,t){const s=this.u.get(w);if(!s)throw new Error("NO serializer found");const r=await s.deserializeNotebook(g.buffer,t);return new I.SerializableObjectWithBuffers(E.NotebookData.from(r))}async $notebookToData(w,g,t){const s=this.u.get(w);if(!s)throw new Error("NO serializer found");const r=await s.serializeNotebook(E.NotebookData.to(g.value),t);return o.VSBuffer.wrap(r)}w(w,g,t){if(this.h.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const s=new i.ExtHostNotebookEditor(g,this.d,w,t.visibleRanges.map(E.NotebookRange.to),t.selections.map(E.NotebookRange.to),typeof t.viewColumn=="number"?E.ViewColumn.to(t.viewColumn):void 0);this.h.set(g,s)}$acceptDocumentAndEditorsDelta(w){if(w.value.removedDocuments)for(const t of w.value.removedDocuments){const s=D.URI.revive(t),r=this.g.get(s);r&&(r.dispose(),this.g.delete(s),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(a=>a.document.uri)}),this.n.fire(r.apiNotebook));for(const a of this.h.values())a.notebookData.uri.toString()===s.toString()&&this.h.delete(a.id)}if(w.value.addedDocuments){const t=[];for(const s of w.value.addedDocuments){const r=D.URI.revive(s.uri);if(this.g.has(r))throw new Error(`adding EXISTING notebook ${r} `);const a=new v.ExtHostNotebookDocument(this.c,this.q,this.r,r,s);t.push(...s.cells.map(b=>v.ExtHostCell.asModelAddData(a.apiNotebook,b))),this.g.get(r)?.dispose(),this.g.set(r,a),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:t}),this.m.fire(a.apiNotebook)}}if(w.value.addedEditors)for(const t of w.value.addedEditors){if(this.h.has(t.id))return;const s=D.URI.revive(t.documentUri),r=this.g.get(s);r&&this.w(r,t.id,t)}const g=[];if(w.value.removedEditors)for(const t of w.value.removedEditors){const s=this.h.get(t);s&&(this.h.delete(t),this.k?.id===s.id&&(this.k=void 0),g.push(s))}if(w.value.visibleEditors){this.l=w.value.visibleEditors.map(s=>this.h.get(s)).filter(s=>!!s);const t=new Set;this.l.forEach(s=>t.add(s.id));for(const s of this.h.values()){const r=t.has(s.id);s._acceptVisibility(r)}this.l=[...this.h.values()].map(s=>s).filter(s=>s.visible),this.o.fire(this.visibleNotebookEditors)}w.value.newActiveEditor===null?this.k=void 0:w.value.newActiveEditor&&(this.h.get(w.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${w.value.newActiveEditor}`),this.k=this.h.get(w.value.newActiveEditor)),w.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(w){const g=k.ApiCommandArgument.String.with("notebookType","A notebook type"),t=new k.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[g,new k.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>o.VSBuffer.wrap(r))],new k.ApiCommandResult("Notebook Data",r=>E.NotebookData.to(r.value))),s=new k.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[g,new k.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new I.SerializableObjectWithBuffers(E.NotebookData.from(r)))],new k.ApiCommandResult("Bytes",r=>r.buffer));w.registerApiCommand(t),w.registerApiCommand(s)}}e.ExtHostNotebookController=h,h.a=0}),define(Ce[281],ke([1,0,18,19,21,3,6,28,2,25,16,76,5,41,11,7,96,240,27,59]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d,h,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let w=e.ExtHostNotebookKernels=class{constructor(c,u,m,f,n){this.m=u,this.n=m,this.o=f,this.q=n,this.b=new P.ResourceMap,this.c=new P.ResourceMap,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new k.Cache("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=c.getProxy(E.MainContext.MainThreadNotebookKernels);const C=new T.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new T.ApiCommandArgument("options","Select kernel options",M=>!0,M=>{if(M&&"notebookEditor"in M&&"id"in M){const H=this.n.getIdByEditor(M.notebookEditor);return{id:M.id,extension:M.extension,notebookEditorId:H}}else if(M&&"notebookEditor"in M){const H=this.n.getIdByEditor(M.notebookEditor);if(H===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${M.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:H}}return M})],T.ApiCommandResult.Void);this.o.registerApiCommand(C)}createNotebookController(c,u,m,f,n,C){for(const he of this.j.values())if(he.controller.id===u&&p.ExtensionIdentifier.equals(c.identifier,he.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const M=this.k++,H=this;this.q.trace(`NotebookController[${M}], CREATED by ${c.identifier.value}, ${u}`);const V=()=>console.warn(`NO execute handler from notebook controller '${$.id}' of extension: '${c.identifier}'`);let U=!1;const z=new A.DisposableStore,G=new L.Emitter,F=new L.Emitter,$={id:b(c.identifier,u),notebookType:m,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:f||c.identifier.value,preloads:C?C.map(I.NotebookRendererScript.from):[]};let Y=n??V,_;this.a.$addKernel(M,$).catch(he=>{console.log(he),U=!0});let Q=0;const ie=()=>{if(U)return;const he=++Q;Promise.resolve().then(()=>{he===Q&&this.a.$updateKernel(M,$)})},oe=new P.ResourceMap,Ee={get id(){return u},get notebookType(){return $.notebookType},onDidChangeSelectedNotebooks:G.event,get label(){return $.label},set label(he){$.label=he??c.displayName??c.name,ie()},get detail(){return $.detail??""},set detail(he){$.detail=he,ie()},get description(){return $.description??""},set description(he){$.description=he,ie()},get supportedLanguages(){return $.supportedLanguages},set supportedLanguages(he){$.supportedLanguages=he,ie()},get supportsExecutionOrder(){return $.supportsExecutionOrder??!1},set supportsExecutionOrder(he){$.supportsExecutionOrder=he,ie()},get rendererScripts(){return $.preloads?$.preloads.map(I.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(he){Y=he??V},get interruptHandler(){return _},set interruptHandler(he){_=he,$.supportsInterrupt=!!he,ie()},createNotebookCellExecution(he){if(U)throw new Error("notebook controller is DISPOSED");if(!oe.has(he.notebook.uri))throw H.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(oe.keys()).map(fe=>fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${he.notebook.uri.toString()}`);return H._createNotebookCellExecution(he,b(c.identifier,this.id))},createNotebookExecution(he){if((0,h.checkProposedApiEnabled)(c,"notebookExecution"),U)throw new Error("notebook controller is DISPOSED");if(!oe.has(he.uri))throw H.q.trace(`NotebookController[${M}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(oe.keys()).map(fe=>fe.toString())),new Error(`notebook controller is NOT associated to notebook: ${he.uri.toString()}`);return H._createNotebookExecution(he,b(c.identifier,this.id))},dispose:()=>{U||(this.q.trace(`NotebookController[${M}], DISPOSED`),U=!0,this.j.delete(M),z.dispose(),G.dispose(),F.dispose(),this.a.$removeKernel(M))},updateNotebookAffinity(he,fe){fe===v.NotebookControllerAffinity2.Hidden&&(0,h.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),H.a.$updateNotebookPriority(M,he.uri,fe)},onDidReceiveMessage:F.event,postMessage(he,fe){return(0,h.checkProposedApiEnabled)(c,"notebookMessaging"),H.a.$postMessage(M,fe&&H.n.getIdByEditor(fe),he)},asWebviewUri(he){return(0,h.checkProposedApiEnabled)(c,"notebookMessaging"),(0,i.asWebviewUri)(he,H.m.remote)}};return this.j.set(M,{extensionId:c.identifier,controller:Ee,onDidReceiveMessage:F,onDidChangeSelection:G,associatedNotebooks:oe}),Ee}getIdByController(c){for(const[u,m]of this.j)if(m.controller===c)return b(m.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,u){const m=this.f++,f=this;this.q.trace(`NotebookControllerDetectionTask[${m}], CREATED by ${c.identifier.value}`),this.a.$addKernelDetectionTask(m,u);const n={dispose:()=>{this.e.delete(m),f.a.$removeKernelDetectionTask(m)}};return this.e.set(m,n),n}registerKernelSourceActionProvider(c,u,m){const f=this.h++,n=typeof m.onDidChangeNotebookKernelSourceActions=="function"?f:void 0,C=this;this.g.set(f,m),this.q.trace(`NotebookKernelSourceActionProvider[${f}], CREATED by ${c.identifier.value}`),this.a.$addKernelSourceActionProvider(f,f,u);let M;return n!==void 0&&(M=m.onDidChangeNotebookKernelSourceActions(H=>this.a.$emitNotebookKernelSourceActionsChangeEvent(n))),{dispose:()=>{this.g.delete(f),C.a.$removeKernelSourceActionProvider(f,f),M?.dispose()}}}async $provideKernelSourceActions(c,u){const m=this.g.get(c);if(m){const f=new A.DisposableStore;return this.i.add([f]),(await m.provideNotebookKernelSourceActions(u)??[]).map(C=>I.NotebookKernelSourceAction.from(C,this.o.converter,f))}return[]}$acceptNotebookAssociation(c,u,m){const f=this.j.get(c);if(f){const n=this.n.getNotebookDocument(D.URI.revive(u));m?f.associatedNotebooks.set(n.uri,!0):f.associatedNotebooks.delete(n.uri),this.q.trace(`NotebookController[${c}] ASSOCIATE notebook`,n.uri.toString(),m),f.onDidChangeSelection.fire({selected:m,notebook:n.apiNotebook})}}async $executeCells(c,u,m){const f=this.j.get(c);if(!f)return;const n=this.n.getNotebookDocument(D.URI.revive(u)),C=[];for(const M of m){const H=n.getCell(M);H&&C.push(H.apiCell)}try{this.q.trace(`NotebookController[${c}] EXECUTE cells`,n.uri.toString(),C.length),await f.controller.executeHandler.call(f.controller,C,n.apiNotebook,f.controller)}catch(M){this.q.error(`NotebookController[${c}] execute cells FAILED`,M),console.error(M)}}async $cancelCells(c,u,m){const f=this.j.get(c);if(!f)return;const n=this.n.getNotebookDocument(D.URI.revive(u));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,n.apiNotebook);else for(const C of m){const M=n.getCell(C);M&&this.b.get(M.uri)?.cancel()}if(f.controller.interruptHandler){const C=this.c.get(n.uri);m.length&&Array.isArray(C)&&C.length&&C.forEach(M=>M.dispose())}}$acceptKernelMessageFromRenderer(c,u,m){const f=this.j.get(c);if(!f)return;const n=this.n.getEditorById(u);f.onDidReceiveMessage.fire(Object.freeze({editor:n.apiEditor,message:m}))}$cellExecutionChanged(c,u,m){const n=this.n.getNotebookDocument(D.URI.revive(c)).getCell(u);if(n){const C=m?I.NotebookCellExecutionState.to(m):v.NotebookCellExecutionState.Idle;C!==void 0&&this.l.fire({cell:n.apiCell,state:C})}}_createNotebookCellExecution(c,u){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const f=this.n.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!f)throw new Error("invalid cell");if(this.b.has(f.uri))throw new Error(`duplicate execution for ${f.uri}`);const n=new t(u,f,this.a);this.b.set(f.uri,n);const C=n.onDidChangeState(()=>{n.state===g.Resolved&&(n.dispose(),C.dispose(),this.b.delete(f.uri))});return n.asApiObject()}_createNotebookExecution(c,u){const m=this.n.getNotebookDocument(c.uri),f=c.getCells().find(M=>{const H=m.getCellFromApiCell(M);return H&&this.b.has(H.uri)});if(f)throw new Error(`duplicate cell execution for ${f.document.uri}`);if(this.c.has(m.uri))throw new Error(`duplicate notebook execution for ${m.uri}`);const n=new r(u,m,this.a),C=n.onDidChangeState(()=>{n.state===s.Resolved&&(n.dispose(),C.dispose(),this.c.delete(m.uri))});return this.c.set(m.uri,[n,C]),n.asApiObject()}};e.ExtHostNotebookKernels=w=xe([We(4,O.ILogService)],w);var g;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(g||(g={}));class t extends A.Disposable{get state(){return this.f}constructor(c,u,m){super(),this.j=u,this.k=m,this.b=t.a++,this.c=new L.Emitter,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new l.CancellationTokenSource),this.h=new a(10,f=>this.m(f)),this.i=u.internalMetadata.executionOrder,this.k.$createExecution(this.b,c,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(c){await this.h.addItem(c)}async m(c){const u=Array.isArray(c)?c:[c];return this.k.$updateExecution(this.b,new y.SerializableObjectWithBuffers(u))}n(){if(this.f===g.Init)throw new Error("Must call start before modifying cell output");if(this.f===g.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(c){let u=this.j;if(c&&(u=this.j.notebook.getCellFromApiCell(c)),!u)throw new Error("INVALID cell");return u.handle}s(c){return c.map(u=>{const m=v.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return m===u.items?I.NotebookCellOutput.from(u):I.NotebookCellOutput.from({items:m,id:u.id,metadata:u.metadata})})}async t(c,u,m){const f=this.r(u),n=this.s((0,o.asArray)(c));return this.l({editType:d.CellExecutionUpdateType.Output,cellHandle:f,append:m,outputs:n})}async w(c,u,m){return c=v.NotebookCellOutput.ensureUniqueMimeTypes((0,o.asArray)(c),!0),this.l({editType:d.CellExecutionUpdateType.OutputItems,items:c.map(I.NotebookCellOutputItem.from),outputId:u.id,append:m})}asApiObject(){const c=this;return Object.freeze({get token(){return c.g.token},get cell(){return c.j.apiCell},get executionOrder(){return c.i},set executionOrder(m){c.i=m,c.m([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:c.i}])},start(m){if(c.f===g.Resolved||c.f===g.Started)throw new Error("Cannot call start again");c.f=g.Started,c.c.fire(),c.m({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:m})},end(m,f){if(c.f===g.Resolved)throw new Error("Cannot call resolve twice");c.f=g.Resolved,c.c.fire(),c.h.flush(),c.k.$completeExecution(c.b,new y.SerializableObjectWithBuffers({runEndTime:f,lastRunSuccess:m}))},clearOutput(m){return c.n(),c.t([],m,!1)},appendOutput(m,f){return c.n(),c.t(m,f,!0)},replaceOutput(m,f){return c.n(),c.t(m,f,!1)},appendOutputItems(m,f){return c.n(),c.w(m,f,!0)},replaceOutputItems(m,f){return c.n(),c.w(m,f,!1)}})}}t.a=0;var s;(function(S){S[S.Init=0]="Init",S[S.Started=1]="Started",S[S.Resolved=2]="Resolved"})(s||(s={}));class r extends A.Disposable{get state(){return this.f}constructor(c,u,m){super(),this.h=u,this.i=m,this.b=r.a++,this.c=new L.Emitter,this.onDidChangeState=this.c.event,this.f=s.Init,this.g=this.B(new l.CancellationTokenSource),this.i.$createNotebookExecution(this.b,c,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===s.Resolved||this.f===s.Started)throw new Error("Cannot call start again");this.f=s.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===s.Resolved)throw new Error("Cannot call resolve twice");this.f=s.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}r.a=0;class a{constructor(c,u){this.e=c,this.f=u,this.a=[],this.b=Date.now()}addItem(c){return this.a.push(c),this.c||(this.c=new R.DeferredPromise,this.b=Date.now(),(0,R.timeout)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const c=this.c;this.c=void 0;const u=this.a;return this.a=[],this.f(u).finally(()=>c.complete())}}function b(S,c){return`${S.value}/${c}`}e.createKernelId=b}),define(Ce[282],ke([1,0,3,5,137]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(P,D){this.c=D,this.a=new Map,this.b=P.getProxy(R.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(P,D,p){const O=this.c.getEditorById(P);this.a.get(D)?.fire({editor:O.apiEditor,message:p})}createRendererMessaging(P,D){if(!P.contributes?.notebookRenderer?.some(O=>O.id===D))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${D})`);return{onDidReceiveMessage:(O,k,E)=>this.d(D).event(O,k,E),postMessage:(O,k)=>{l.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,k]=[k,O]);const E=k&&l.ExtHostNotebookEditor.apiEditorsToExtHost.get(k);return this.b.$postMessage(E?.id,D,O)}}}d(P){let D=this.a.get(P);return D||(D=new o.Emitter({onDidRemoveLastListener:()=>{D?.dispose(),this.a.delete(P)}}),this.a.set(P,D),D)}}e.ExtHostNotebookRenderers=L}),define(Ce[283],ke([1,0,6,10,2,27,5]),function(ae,e,o,R,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class P{constructor(p){this.b=new Map,this.a=p.getProxy(A.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(p,O,k){if((0,L.checkProposedApiEnabled)(p,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,k),this.a.$registerProfileContentHandler(O,k.name,k.description,p.identifier.value),(0,o.toDisposable)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(p,O,k,E){const T=this.b.get(p);if(!T)throw new Error(`Unknown handler with id: ${p}`);return T.saveProfile(O,k,E)}async $readProfile(p,O,k){const E=this.b.get(p);if(!E)throw new Error(`Unknown handler with id: ${p}`);return E.readProfile((0,R.isString)(O)?O:l.URI.revive(O),k)}}e.ExtHostProfileContentHandlers=P}),define(Ce[284],ke([1,0,2,5,19,11]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class A{constructor(D,p){this.d=p,this.c=new Map,this.b=D.getProxy(R.MainContext.MainThreadQuickDiff)}$provideOriginalResource(D,p,O){const k=o.URI.revive(p),E=this.c.get(D);return E?(0,l.asPromise)(()=>E.provideOriginalResource(k,O)).then(T=>T||null):Promise.resolve(null)}registerQuickDiffProvider(D,p,O,k){const E=A.a++;return this.c.set(E,p),this.b.$registerQuickDiffProvider(E,L.DocumentSelector.from(D,this.d),O,k),{dispose:()=>{this.b.$unregisterQuickDiffProvider(E),this.c.delete(E)}}}}e.ExtHostQuickDiff=A,A.a=0}),define(Ce[285],ke([1,0,21,3,6,5,2,7,8,18,38,53,27,11]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function I(v,i,d){const h=v.getProxy(L.MainContext.MainThreadQuickOpen);class y{constructor(c,u){this.e=new Map,this.f=0,this.a=c,this.b=u}showQuickPick(c,u,m,f=o.CancellationToken.None){this.c=void 0;const n=Promise.resolve(u),C=++this.f,M=h.$show(C,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},f),H={},V=M.then(()=>H);return Promise.race([V,n]).then(U=>{if(U===H)return;const z=(0,E.isProposedApiEnabled)(c,"quickPickItemTooltip");return n.then(G=>{const F=[];for(let $=0;$<G.length;$++){const Y=G[$];typeof Y=="string"?F.push({label:Y,handle:$}):Y.kind===P.QuickPickItemKind.Separator?F.push({type:"separator",label:Y.label}):(Y.tooltip&&!z&&console.warn(`Extension '${c.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${c.identifier.value}`),F.push({label:Y.label,description:Y.description,detail:Y.detail,picked:Y.picked,alwaysShow:Y.alwaysShow,tooltip:z?T.MarkdownString.fromStrict(Y.tooltip):void 0,handle:$}))}return m&&typeof m.onDidSelectItem=="function"&&(this.c=$=>{m.onDidSelectItem(G[$])}),h.$setItems(C,F),M.then($=>{if(typeof $=="number")return G[$];if(Array.isArray($))return $.map(Y=>G[Y])})})}).then(void 0,U=>{if(!(0,D.isCancellationError)(U))return h.$setError(C,U),Promise.reject(U)})}$onItemSelected(c){this.c?.(c)}showInput(c,u=o.CancellationToken.None){return this.d=c?.validateInput,h.$input(c,typeof this.d=="function",u).then(void 0,m=>{if(!(0,D.isCancellationError)(m))return Promise.reject(m)})}async $validateInput(c){if(!this.d)return;const u=await this.d(c);if(!u||typeof u=="string")return u;let m;switch(u.severity){case P.InputBoxValidationSeverity.Info:m=O.default.Info;break;case P.InputBoxValidationSeverity.Warning:m=O.default.Warning;break;case P.InputBoxValidationSeverity.Error:m=O.default.Error;break;default:m=u.message?O.default.Error:O.default.Ignore;break}return{content:u.message,severity:m}}async showWorkspaceFolderPick(c,u=o.CancellationToken.None){const m=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!m)return;const f=await this.a.getWorkspaceFolders2();if(f)return f.find(n=>n.uri.toString()===m.uri.toString())}createQuickPick(c){const u=new a(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}createInputBox(c){const u=new b(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}$onDidChangeValue(c,u){this.e.get(c)?._fireDidChangeValue(u)}$onDidAccept(c){this.e.get(c)?._fireDidAccept()}$onDidChangeActive(c,u){const m=this.e.get(c);m instanceof a&&m._fireDidChangeActive(u)}$onDidChangeSelection(c,u){const m=this.e.get(c);m instanceof a&&m._fireDidChangeSelection(u)}$onDidTriggerButton(c,u){this.e.get(c)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(c,u,m){const f=this.e.get(c);f instanceof a&&f._fireDidTriggerItemButton(u,m)}$onDidHide(c){this.e.get(c)?._fireDidHide()}}class w{constructor(c,u){this.x=c,this.y=u,this._id=a.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new R.Emitter,this.q=new R.Emitter,this.r=new R.Emitter,this.s=new R.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(c){this.b=c,this.z({title:c})}get step(){return this.c}set step(c){this.c=c,this.z({step:c})}get totalSteps(){return this.d}set totalSteps(c){this.d=c,this.z({totalSteps:c})}get enabled(){return this.g}set enabled(c){this.g=c,this.z({enabled:c})}get busy(){return this.j}set busy(c){this.j=c,this.z({busy:c})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(c){this.k=c,this.z({ignoreFocusOut:c})}get value(){return this.l}set value(c){this.l=c,this.z({value:c})}get placeholder(){return this.m}set placeholder(c){this.m=c,this.z({placeholder:c})}get buttons(){return this.n}set buttons(c){this.n=c.slice(),this.o.clear(),c.forEach((u,m)=>{const f=u===P.QuickInputButtons.Back?-1:m;this.o.set(f,u)}),this.z({buttons:c.map((u,m)=>({...r(u),tooltip:u.tooltip,handle:u===P.QuickInputButtons.Back?-1:m}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(c){this.l=c,this.q.fire(c)}_fireDidTriggerButton(c){const u=this.o.get(c);u&&this.r.fire(u)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,l.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),h.$dispose(this._id))}z(c){if(!this.v){for(const u of Object.keys(c)){const m=c[u];this.u[u]=m===void 0?null:m}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){h.$createOrUpdate(this.u),this.u={id:this._id}}}w.a=1;function g(S){if(S instanceof P.ThemeIcon)return{id:S.id};const c=s(S),u=t(S);return{dark:typeof c=="string"?A.URI.file(c):c,light:typeof u=="string"?A.URI.file(u):u}}function t(S){return typeof S=="object"&&"light"in S?S.light:S}function s(S){return typeof S=="object"&&"dark"in S?S.dark:S}function r(S){const c=g(S.iconPath);let u,m;return"id"in c?m=k.ThemeIcon.asClassName(c):u=c,{iconPath:u,iconClass:m}}class a extends w{constructor(c,u){super(c.identifier,u),this.O=c,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new R.Emitter,this.L=[],this.M=new R.Emitter,this.N=new R.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(c){this.B=c.slice(),this.C.clear(),this.D.clear(),c.forEach((f,n)=>{this.C.set(n,f),this.D.set(f,n)});const u=(0,E.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),m=[];for(let f=0;f<c.length;f++){const n=c[f];n.kind===P.QuickPickItemKind.Separator?m.push({type:"separator",label:n.label}):(n.tooltip&&!u&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),m.push({handle:f,label:n.label,description:n.description,detail:n.detail,picked:n.picked,alwaysShow:n.alwaysShow,tooltip:u?T.MarkdownString.fromStrict(n.tooltip):void 0,buttons:n.buttons?.map((C,M)=>({...r(C),tooltip:C.tooltip,handle:M}))}))}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(c){this.E=c,this.z({canSelectMany:c})}get matchOnDescription(){return this.F}set matchOnDescription(c){this.F=c,this.z({matchOnDescription:c})}get matchOnDetail(){return this.G}set matchOnDetail(c){this.G=c,this.z({matchOnDetail:c})}get sortByLabel(){return this.H}set sortByLabel(c){this.H=c,this.z({sortByLabel:c})}get keepScrollPosition(){return this.I}set keepScrollPosition(c){this.I=c,this.z({keepScrollPosition:c})}get activeItems(){return this.J}set activeItems(c){this.J=c.filter(u=>this.D.has(u)),this.z({activeItems:this.J.map(u=>this.D.get(u))})}get selectedItems(){return this.L}set selectedItems(c){this.L=c.filter(u=>this.D.has(u)),this.z({selectedItems:this.L.map(u=>this.D.get(u))})}_fireDidChangeActive(c){const u=(0,p.coalesce)(c.map(m=>this.C.get(m)));this.J=u,this.K.fire(u)}_fireDidChangeSelection(c){const u=(0,p.coalesce)(c.map(m=>this.C.get(m)));this.L=u,this.M.fire(u)}_fireDidTriggerItemButton(c,u){const m=this.C.get(c);if(!m||!m.buttons||!m.buttons.length)return;const f=m.buttons[u];f&&this.N.fire({button:f,item:m})}}class b extends w{constructor(c,u){super(c.identifier,u),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(c){this.B=c,this.z({password:c})}get prompt(){return this.C}set prompt(c){this.C=c,this.z({prompt:c})}get valueSelection(){return this.D}set valueSelection(c){this.D=c,this.z({valueSelection:c})}get validationMessage(){return this.E}set validationMessage(c){this.E=c,c?typeof c=="string"?this.z({validationMessage:c,severity:O.default.Error}):this.z({validationMessage:c.message,severity:c.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new y(i,d)}e.createExtHostQuickOpen=I});var Be=this&&this.__classPrivateFieldGet||function(ae,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!R:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(ae):R?R.value:e.get(ae)},_e=this&&this.__classPrivateFieldSet||function(ae,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!l:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(ae,o):l?l.value=o:e.set(ae,o),o};define(Ce[286],ke([1,0,2,3,63,6,19,5,18,109,16,25,53,11,27,17]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v){"use strict";var i,d,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function y(f){if(f)return typeof f.iconPath=="string"?o.URI.file(f.iconPath):o.URI.isUri(f.iconPath)||E.ThemeIcon.isThemeIcon(f.iconPath)?f.iconPath:void 0}function w(f,n){if(!f.iconPath&&!n.iconPath)return 0;if(f.iconPath){if(!n.iconPath)return 1}else return-1;const C=typeof f.iconPath=="string"?f.iconPath:o.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id,M=typeof n.iconPath=="string"?n.iconPath:o.URI.isUri(n.iconPath)?n.iconPath.fsPath:n.iconPath.id;return(0,p.comparePaths)(C,M)}function g(f,n){let C=0;if(f.strikeThrough!==n.strikeThrough)return f.strikeThrough?1:-1;if(f.faded!==n.faded)return f.faded?1:-1;if(f.tooltip!==n.tooltip)return(f.tooltip||"").localeCompare(n.tooltip||"");if(C=w(f,n),C!==0)return C;if(f.light&&n.light)C=w(f.light,n.light);else{if(f.light)return 1;if(n.light)return-1}if(C!==0)return C;if(f.dark&&n.dark)C=w(f.dark,n.dark);else{if(f.dark)return 1;if(n.dark)return-1}return C}function t(f,n){if(f.command!==n.command)return f.command<n.command?-1:1;if(f.title!==n.title)return f.title<n.title?-1:1;if(f.tooltip!==n.tooltip){if(f.tooltip!==void 0&&n.tooltip!==void 0)return f.tooltip<n.tooltip?-1:1;if(f.tooltip!==void 0)return 1;if(n.tooltip!==void 0)return-1}if(f.arguments===n.arguments)return 0;if(f.arguments)if(n.arguments){if(f.arguments.length!==n.arguments.length)return f.arguments.length-n.arguments.length}else return 1;else return-1;for(let C=0;C<f.arguments.length;C++){const M=f.arguments[C],H=n.arguments[C];if(M!==H)return M<H?-1:1}return 0}function s(f,n){let C=(0,p.comparePaths)(f.resourceUri.fsPath,n.resourceUri.fsPath,!0);if(C!==0)return C;if(f.command&&n.command)C=t(f.command,n.command);else{if(f.command)return 1;if(n.command)return-1}if(C!==0)return C;if(f.decorations&&n.decorations)C=g(f.decorations,n.decorations);else{if(f.decorations)return 1;if(n.decorations)return-1}return C}function r(f,n){for(let C=0;C<f.length;C++)if(f[C]!==n[C])return!1;return!0}function a(f,n){return f.command===n.command&&f.title===n.title&&f.tooltip===n.tooltip&&(f.arguments&&n.arguments?r(f.arguments,n.arguments):f.arguments===n.arguments)}function b(f,n){return(0,D.equals)(f,n,a)}class S{get value(){return this.d}set value(n){n=n??"",Be(this,i,"f").$setInputBoxValue(this.l,n),this.n(n)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(n){Be(this,i,"f").$setInputBoxPlaceholder(this.l,n),this.f=n}get validateInput(){return(0,I.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(n){if((0,I.checkProposedApiEnabled)(this.k,"scmValidation"),n&&typeof n!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=n,Be(this,i,"f").$setValidationProviderIsEnabled(this.l,!!n)}get enabled(){return this.h}set enabled(n){n=!!n,this.h!==n&&(this.h=n,Be(this,i,"f").$setInputBoxEnablement(this.l,n))}get visible(){return this.j}set visible(n){n=!!n,this.j!==n&&(this.j=n,Be(this,i,"f").$setInputBoxVisibility(this.l,n))}get document(){return(0,I.checkProposedApiEnabled)(this.k,"scmTextDocument"),Be(this,d,"f").getDocument(this.m)}constructor(n,C,M,H,V){this.k=n,this.l=H,this.m=V,i.set(this,void 0),d.set(this,void 0),this.d="",this.e=new R.Emitter,this.f="",this.h=!0,this.j=!0,_e(this,d,C,"f"),_e(this,i,M,"f")}showValidationMessage(n,C){(0,I.checkProposedApiEnabled)(this.k,"scmValidation"),Be(this,i,"f").$showValidationMessage(this.l,n,C)}$onInputBoxValueChange(n){this.n(n)}n(n){this.d=n,this.e.fire(n)}}e.ExtHostSCMInputBox=S,i=new WeakMap,d=new WeakMap;class c{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(n){this.v=n,this.q.$updateGroupLabel(this.t,this.handle,n)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(n){this.p=n,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(n){this.f=[...n],this.k.fire()}constructor(n,C,M,H,V){this.q=n,this.s=C,this.t=M,this.u=H,this.v=V,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new R.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new R.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(n){return this.g.get(n)}$executeResourceCommand(n,C){const M=this.h.get(n);return M?(0,A.asPromise)(()=>this.s.executeCommand(M.command,...M.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const n=[...this.f].sort(s),M=(0,D.sortedDiff)(this.o,n,s).map(U=>{const z=U.toInsert.map(G=>{const F=this.e++;this.g.set(F,G);const $=G.resourceUri;let Y;if(G.command)if(G.command.command==="vscode.open"||G.command.command==="vscode.diff"){const Z=new L.DisposableStore;Y=this.s.converter.toInternal(G.command,Z),this.j.set(F,Z)}else this.h.set(F,G.command);const _=y(G.decorations),Q=G.decorations&&y(G.decorations.light)||_,ie=G.decorations&&y(G.decorations.dark)||_,oe=[Q,ie],Ee=G.decorations&&G.decorations.tooltip||"",he=G.decorations&&!!G.decorations.strikeThrough,fe=G.decorations&&!!G.decorations.faded,x=G.contextValue||"";return{rawResource:[F,$,oe,Ee,he,fe,x,Y],handle:F}});return{start:U.start,deleteCount:U.deleteCount,toInsert:z}}),H=M.map(({start:U,deleteCount:z,toInsert:G})=>[U,z,G.map(F=>F.rawResource)]),V=M.reverse();for(const{start:U,deleteCount:z,toInsert:G}of V){const F=G.map(Y=>Y.handle),$=this.n.splice(U,z,...F);for(const Y of $)this.g.delete(Y),this.h.delete(Y),this.j.get(Y)?.dispose(),this.j.delete(Y)}return this.o=n,H}dispose(){this.l=!0,this.m.fire()}}c.d=0;class u{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(n){this.g!==n&&(this.g=n,Be(this,h,"f").$updateSourceControl(this.t,{count:n}))}get quickDiffProvider(){return this.h}set quickDiffProvider(n){this.h=n;let C;(0,I.isProposedApiEnabled)(this.u,"quickDiffProvider")&&(C=n?.label),Be(this,h,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!n,quickDiffLabel:C})}get commitTemplate(){return this.j}set commitTemplate(n){n!==this.j&&(this.j=n,Be(this,h,"f").$updateSourceControl(this.t,{commitTemplate:n}))}get acceptInputCommand(){return this.l}set acceptInputCommand(n){this.k.value=new L.DisposableStore,this.l=n;const C=this.v.converter.toInternal(n,this.k.value);Be(this,h,"f").$updateSourceControl(this.t,{acceptInputCommand:C})}get actionButton(){return(0,I.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(n){(0,I.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new L.DisposableStore,this.n=n;const C=n!==void 0?{command:this.v.converter.toInternal(n.command,this.m.value),secondaryCommands:n.secondaryCommands?.map(M=>M.map(H=>this.v.converter.toInternal(H,this.m.value))),description:n.description,enabled:n.enabled}:void 0;Be(this,h,"f").$updateSourceControl(this.t,{actionButton:C??null})}get statusBarCommands(){return this.p}set statusBarCommands(n){if(this.p&&n&&b(this.p,n))return;this.o.value=new L.DisposableStore,this.p=n;const C=(n||[]).map(M=>this.v.converter.toInternal(M,this.o.value));Be(this,h,"f").$updateSourceControl(this.t,{statusBarCommands:C})}get selected(){return this.q}constructor(n,C,M,H,V,U,z){this.u=n,this.v=H,this.w=V,this.x=U,this.y=z,h.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.MutableDisposable,this.l=void 0,this.m=new L.MutableDisposable,this.o=new L.MutableDisposable,this.p=void 0,this.q=!1,this.s=new R.Emitter,this.onDidChangeSelection=this.s.event,this.t=u.d++,this.z=new Map,this.A=new Set,_e(this,h,M,"f");const G=o.URI.from({scheme:v.Schemas.vscodeSourceControl,path:`${V}/scm${this.t}/input`,query:z?`rootUri=${encodeURIComponent(z.toString())}`:void 0});this.f=new S(n,C,Be(this,h,"f"),this.t,G),Be(this,h,"f").$registerSourceControl(this.t,V,U,z,G)}createResourceGroup(n,C){const M=new c(Be(this,h,"f"),this.v,this.t,n,C),H=R.Event.once(M.onDidDispose)(()=>this.z.delete(M));return this.z.set(M,H),this.eventuallyAddResourceGroups(),M}eventuallyAddResourceGroups(){const n=[],C=[];for(const[M,H]of this.z){H.dispose();const V=M.onDidUpdateResourceStates(()=>{this.A.add(M),this.eventuallyUpdateResourceStates()});R.Event.once(M.onDidDispose)(()=>{this.A.delete(M),V.dispose(),this.e.delete(M.handle),Be(this,h,"f").$unregisterGroup(this.t,M.handle)}),n.push([M.handle,M.id,M.label,M.features]);const U=M._takeResourceStateSnapshot();U.length>0&&C.push([M.handle,U]),this.e.set(M.handle,M)}Be(this,h,"f").$registerGroups(this.t,n,C),this.z.clear()}eventuallyUpdateResourceStates(){const n=[];this.A.forEach(C=>{const M=C._takeResourceStateSnapshot();M.length!==0&&n.push([C.handle,M])}),n.length>0&&Be(this,h,"f").$spliceResourceStates(this.t,n),this.A.clear()}getResourceGroup(n){return this.e.get(n)}setSelectionState(n){this.q=n,this.s.fire(n)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(n=>n.dispose()),Be(this,h,"f").$unregisterSourceControl(this.t)}}h=new WeakMap,u.d=0,xe([(0,l.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),xe([(0,l.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let m=e.ExtHostSCM=class Dn{get onDidChangeActiveProvider(){return this.j.event}constructor(n,C,M,H){this.l=C,this.m=M,this.n=H,this.g=new Map,this.h=new k.ExtensionIdentifierMap,this.j=new R.Emitter,this.e=n.getProxy(P.MainContext.MainThreadSCM),this.f=n.getProxy(P.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:V=>{if(V&&V.$mid===3){const U=this.g.get(V.sourceControlHandle);if(!U)return V;const z=U.getResourceGroup(V.groupHandle);return z?z.getResourceState(V.handle):V}else if(V&&V.$mid===4){const U=this.g.get(V.sourceControlHandle);return U?U.getResourceGroup(V.groupHandle):V}else if(V&&V.$mid===5){const U=this.g.get(V.handle);return U||V}return V}})}createSourceControl(n,C,M,H){this.n.trace("ExtHostSCM#createSourceControl",n.identifier.value,C,M,H),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:n.identifier.value});const V=Dn.d++,U=new u(n,this.m,this.e,this.l,C,M,H);this.g.set(V,U);const z=this.h.get(n.identifier)||[];return z.push(U),this.h.set(n.identifier,z),U}getLastInputBox(n){this.n.trace("ExtHostSCM#getLastInputBox",n.identifier.value);const C=this.h.get(n.identifier),M=C&&C[C.length-1];return M&&M.inputBox}$provideOriginalResource(n,C,M){const H=o.URI.revive(C);this.n.trace("ExtHostSCM#$provideOriginalResource",n,H.toString());const V=this.g.get(n);return!V||!V.quickDiffProvider||!V.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.asPromise)(()=>V.quickDiffProvider.provideOriginalResource(H,M)).then(U=>U||null)}$onInputBoxValueChange(n,C){this.n.trace("ExtHostSCM#$onInputBoxValueChange",n);const M=this.g.get(n);return M&&M.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(n,C,M,H){this.n.trace("ExtHostSCM#$executeResourceCommand",n,C,M);const V=this.g.get(n);if(!V)return Promise.resolve(void 0);const U=V.getResourceGroup(C);return U?U.$executeResourceCommand(M,H):Promise.resolve(void 0)}$validateInput(n,C,M){this.n.trace("ExtHostSCM#$validateInput",n);const H=this.g.get(n);return!H||!H.inputBox.validateInput?Promise.resolve(void 0):(0,A.asPromise)(()=>H.inputBox.validateInput(C,M)).then(V=>{if(!V)return Promise.resolve(void 0);const U=T.MarkdownString.fromStrict(V.message);return U?Promise.resolve([U,V.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(n){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",n),n!==void 0&&this.g.get(n)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=n,Promise.resolve(void 0)}};m.d=0,e.ExtHostSCM=m=xe([We(3,O.ILogService)],m)}),define(Ce[99],ke([1,0,5,3,4]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(P){this.b=new R.Emitter,this.onDidChangePassword=this.b.event,this.a=P.getProxy(o.MainContext.MainThreadSecretState)}async $onDidChangePassword(P){this.b.fire(P)}get(P,D){return this.a.$getPassword(P,D)}store(P,D,p){return this.a.$setPassword(P,D,p)}delete(P,D){return this.a.$deletePassword(P,D)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,l.createDecorator)("IExtHostSecretState")}),define(Ce[287],ke([1,0,5,7]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSemanticSimilarity=void 0;class l{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(o.MainContext.MainThreadSemanticSimilarity)}async $provideSimilarityScore(A,P,D,p){if(this.a.size===0)throw new Error("No semantic similarity providers registered");const O=this.a.get(A);if(!O)throw new Error("Semantic similarity provider not found");return await O.provideSimilarityScore(P,D,p)}registerSemanticSimilarityProvider(A,P){const D=this.b;return this.b++,this.a.set(D,P),this.c.$registerSemanticSimilarityProvider(D),new R.Disposable(()=>{this.c.$unregisterSemanticSimilarityProvider(D),this.a.delete(D)})}}e.ExtHostSemanticSimilarity=l});var _e=this&&this.__classPrivateFieldSet||function(ae,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!l:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(ae,o):l?l.value=o:e.set(ae,o),o},Be=this&&this.__classPrivateFieldGet||function(ae,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!R:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(ae):R?R.value:e.get(ae)};define(Ce[288],ke([1,0,7,5,188,6,11,10]),function(ae,e,o,R,l,L,A,P){"use strict";var D,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(I,v,i,d,h=o.StatusBarAlignment.Left,y){D.set(this,void 0),p.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new L.DisposableStore,_e(this,D,I,"f"),_e(this,p,v,"f"),this.c=O.a++,this.e=i,this.f=d,this.g=h,this.h=this.u(y)}u(I){if((0,P.isNumber)(I))return I===Number.POSITIVE_INFINITY?Number.MAX_VALUE:I===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:I}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(I){this.k=I,this.v()}set name(I){this.m=I,this.v()}set tooltip(I){this.l=I,this.v()}set color(I){this.n=I,this.v()}set backgroundColor(I){I&&!O.b.has(I.id)&&(I=void 0),this.o=I,this.v()}set command(I){this.r?.fromApi!==I&&(this.p&&this.q.add(this.p),this.p=new L.DisposableStore,typeof I=="string"?this.r={fromApi:I,internal:Be(this,p,"f").toInternal({title:"",command:I},this.p)}:I?this.r={fromApi:I,internal:Be(this,p,"f").toInternal(I,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(I){this.t=I,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Be(this,D,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let I;this.e?this.f?I=`${this.e.identifier.value}.${this.f}`:I=this.e.identifier.value:I=this.f;let v;this.m?v=this.m:v=(0,l.localize)(0,null,this.e.displayName||this.e.name);let i=this.n;this.o&&(i=O.b.get(this.o.id));const d=A.MarkdownString.fromStrict(this.l);Be(this,D,"f").$setEntry(this.c,I,this.e?.identifier.value,v,this.k,d,this.r?.internal,i,this.o,this.g===o.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=O,D=new WeakMap,p=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new o.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.ThemeColor("statusBarItem.warningForeground")]]);class k{constructor(I){this.b=[],this.a=I.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,l.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(I){const v={message:I};return this.b.unshift(v),this.c(),new o.Disposable(()=>{const i=this.b.indexOf(v);i>=0&&(this.b.splice(i,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class E{constructor(I,v){this.a=I.getProxy(R.MainContext.MainThreadStatusBar),this.b=v,this.c=new k(this)}createStatusBarEntry(I,v,i,d){return new O(this.a,this.b,I,v,i,d)}setStatusBarMessage(I,v){const i=this.c.setMessage(I);let d;return typeof v=="number"?d=setTimeout(()=>i.dispose(),v):typeof v<"u"&&v.then(()=>i.dispose(),()=>i.dispose()),new o.Disposable(()=>{i.dispose(),clearTimeout(d)})}}e.ExtHostStatusBar=E}),define(Ce[100],ke([1,0,5,3,4]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(P,D){this.c=D,this.b=new R.Emitter,this.onDidChangeStorage=this.b.event,this.a=P.getProxy(o.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(P,D){this.a.$registerExtensionStorageKeysToSync(P,D)}async initializeExtensionStorage(P,D,p){const O=await this.a.$initializeExtensionStorage(P,D);let k;return O&&(k=this.d(P,D,O)),k||p}setValue(P,D,p){return this.a.$setValue(P,D,p)}$acceptValue(P,D,p){const O=this.d(P,D,p);O&&this.b.fire({shared:P,key:D,value:O})}d(P,D,p){try{return JSON.parse(p)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${D}, global: ${P}): ${O}`)}}}e.ExtHostStorage=L,e.IExtHostStorage=(0,l.createDecorator)("IExtHostStorage")}),define(Ce[81],ke([1,0,4,26,16,80,2]),function(ae,e,o,R,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,o.createDecorator)("IExtensionStoragePaths");let P=e.ExtensionStoragePaths=class{constructor(p,O,k){this.d=O,this.f=k,this.a=p.workspace??void 0,this.b=p.environment,this.whenReady=this.h().then(E=>this.c=E)}async g(p){return A.URI.joinPath(this.b.workspaceStorageHome,p)}async h(){if(!this.a)return Promise.resolve(void 0);const p=this.a.id,O=await this.g(p);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(A.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(k){this.d.error("[ExtHostStorage]",k);return}}workspaceValue(p){if(this.c)return A.URI.joinPath(this.c,p.identifier.value)}globalValue(p){return A.URI.joinPath(this.b.globalStorageHome,p.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=P=xe([We(0,R.IExtHostInitDataService),We(1,l.ILogService),We(2,L.IExtHostConsumerFileSystem)],P)}),define(Ce[42],ke([1,0,3,5,4,2,20,6,7,190,8,222,21,30,223,53,10,19,11]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,l.createDecorator)("IExtHostTerminalService");class y{constructor(u,m,f,n){this.k=u,this._id=m,this.l=f,this.m=n,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(M=>this.f=M);const C=this;this.value={get name(){return C.m||""},get processId(){return C.b},get creationOptions(){return C.l},get exitStatus(){return C.h},get state(){return C.j},sendText(M,H=!0){C.o(),C.k.$sendText(C._id,M,H)},show(M){C.o(),C.k.$show(C._id,M)},hide(){C.o(),C.k.$hide(C._id)},dispose(){C.a||(C.a=!0,C.k.$dispose(C._id))},get dimensions(){if(!(C.d===void 0||C.g===void 0))return{columns:C.d,rows:C.g}}}}async create(u,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:u.name,shellPath:(0,i.withNullAsUndefined)(u.shellPath),shellArgs:(0,i.withNullAsUndefined)(u.shellArgs),cwd:(0,i.withNullAsUndefined)(u.cwd),env:(0,i.withNullAsUndefined)(u.env),icon:(0,i.withNullAsUndefined)(a(u.iconPath)),color:v.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,i.withNullAsUndefined)(u.message),strictEnv:(0,i.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,i.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,i.withNullAsUndefined)(m?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,i.withNullAsUndefined)(m?.useShellEnvironment),location:m?.location||this.n(u.location,m?.resolvedExtHostIdentifier),isTransient:(0,i.withNullAsUndefined)(u.isTransient)})}async createExtensionTerminal(u,m,f,n){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:f,color:v.ThemeColor.isThemeColor(n)?n.id:void 0,location:this.n(u,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(u,m){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in u?{viewColumn:h.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.m=u}setExitStatus(u,m){this.h=Object.freeze({code:u,reason:m})}setDimensions(u,m){return u===this.d&&m===this.g||u===0||m===0?!1:(this.d=u,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(m=>{m!==u&&(this.b=Promise.resolve(u))})}}e.ExtHostTerminal=y;class w{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new o.Emitter,this.onProcessData=this.a.event,this.b=new o.Emitter,this.d=new o.Emitter,this.onDidChangeProperty=this.d.event,this.f=new o.Emitter,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,m){this.g.setDimensions?.({columns:u,rows:m})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:""})}}let g=1,t=e.BaseExtHostTerminalService=class extends P.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}get onDidWriteTerminalData(){return this.I.event}constructor(u,m){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new o.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new o.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new o.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new o.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new o.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new o.Emitter,this.onDidChangeShell=this.J.event,this.a=m.getProxy(R.MainContext.MainThreadTerminalService),this.s=new I.TerminalDataBufferer(this.a.$sendProcessData),this.I=new o.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(u),this.B({dispose:()=>{for(const[f,n]of this.g)n.shutdown(!0)}})}getDefaultShell(u){return(u?this.n:this.m)?.path||""}getDefaultShellArgs(u){return(u?this.n:this.m)?.args||[]}createExtensionTerminal(u,m){const f=new y(this.a,(0,T.generateUuid)(),u,u.name),n=new w(u.pty);return f.createExtensionTerminal(u.location,this.L(u,m).resolvedExtHostIdentifier,a(u.iconPath),b(u.color)).then(C=>{const M=this.M(C,n);this.h[C]=M}),this.f.push(f),f.value}L(u,m){if(m=m||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const f=u.location.parentTerminal;if(f){const n=this.f.find(C=>C.value===f);n&&(m.resolvedExtHostIdentifier=n._id)}}else u.location&&typeof u.location!="object"?m.location=u.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(u,m){if(!this.O(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const n=new w(m),C=this.M(u,n);this.h[u]=C}async $acceptActiveTerminalChanged(u){const m=this.b;if(u===null){this.b=void 0,m!==this.b&&this.F.fire(this.b);return}const f=this.O(u);f&&(this.b=f,m!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(u,m){const f=this.O(u);f&&this.I.fire({terminal:f.value,data:m})}async $acceptTerminalDimensions(u,m,f){const n=this.O(u);n&&n.setDimensions(m,f)&&this.G.fire({terminal:n.value,dimensions:n.value.dimensions})}async $acceptTerminalMaximumDimensions(u,m,f){this.g.get(u)?.resize(m,f)}async $acceptTerminalTitleChange(u,m){const f=this.O(u);f&&(f.name=m)}async $acceptTerminalClosed(u,m,f){const n=this.Q(this.f,u);if(n!==null){const C=this.f.splice(n,1)[0];C.setExitStatus(m,f),this.C.fire(C.value)}}$acceptTerminalOpened(u,m,f,n){if(m){const H=this.Q(this.f,m);if(H!==null){this.f[H]._id=u,this.D.fire(this.terminals[H]),this.f[H].isOpen=!0;return}}const C={name:n.name,shellPath:n.executable,shellArgs:n.args,cwd:typeof n.cwd=="string"?n.cwd:L.URI.revive(n.cwd),env:n.env,hideFromUser:n.hideFromUser},M=new y(this.a,u,C,f);this.f.push(M),this.D.fire(M.value),M.isOpen=!0}async $acceptTerminalProcessId(u,m){this.O(u)?._setProcessId(m)}async $startExtensionTerminal(u,m){const f=this.O(u);if(!f)return{message:(0,p.localize)(0,null,u)};f.isOpen||await new Promise(C=>{const M=this.onDidOpenTerminal(async H=>{H===f.value&&(M.dispose(),C())})});const n=this.g.get(u);n?n.startSendingEvents(m):this.j[u]={initialDimensions:m}}M(u,m){const f=new P.DisposableStore;f.add(m.onProcessReady(C=>this.a.$sendProcessReady(u,C.pid,C.cwd))),f.add(m.onDidChangeProperty(C=>this.a.$sendProcessProperty(u,C))),this.s.startBuffering(u,m.onProcessData),f.add(m.onProcessExit(C=>this.N(u,C))),this.g.set(u,m);const n=this.j[u];return n&&m instanceof w&&(m.startSendingEvents(n.initialDimensions),delete this.j[u]),f}$acceptProcessAckDataEvent(u,m){this.g.get(u)?.acknowledgeDataEvent(m)}$acceptProcessInput(u,m){this.g.get(u)?.input(m)}$acceptTerminalInteraction(u){const m=this.O(u);m?.setInteractedWith()&&this.H.fire(m.value)}$acceptProcessResize(u,m,f){try{this.g.get(u)?.resize(m,f)}catch(n){if(n.code!=="EPIPE"&&n.code!=="ERR_IPC_CHANNEL_CLOSED")throw n}}$acceptProcessShutdown(u,m){this.g.get(u)?.shutdown(m)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(m=>this.a.$sendProcessProperty(u,{type:"cwd",value:m}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.u.add(u),this.u.size===1&&this.a.$startLinkProvider(),new D.Disposable(()=>{this.u.delete(u),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,m,f){if(this.v.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.v.set(m,f),this.a.$registerProfileProvider(m,u.identifier.value),new D.Disposable(()=>{this.v.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(u,m,f){if(this.w.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.w.set(u,f),this.a.$registerQuickFixProvider(u,m),new D.Disposable(()=>{this.w.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,m){const f=new E.CancellationTokenSource().token;if(f.isCancellationRequested)return;const n=this.w.get(u);if(!n)return;const C=await n.provideTerminalQuickFixes(m,f);if(C!==null)return C}async $createContributedProfileTerminal(u,m){const f=new E.CancellationTokenSource().token;let n=await this.v.get(u)?.provideTerminalProfile(f);if(!f.isCancellationRequested){if(n&&!("options"in n)&&(n={options:n}),!n||!("options"in n))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in n.options){this.createExtensionTerminal(n.options,m);return}this.createTerminalFromOptions(n.options,m)}}async $provideLinks(u,m){const f=this.O(u);if(!f)return[];this.y.delete(u),this.z.get(u)?.dispose(!0);const C=new E.CancellationTokenSource;this.z.set(u,C);const M=[],H={terminal:f.value,line:m},V=[];for(const G of this.u)V.push(d.Promises.withAsyncBody(async F=>{C.token.onCancellationRequested(()=>F({provider:G,links:[]}));const $=await G.provideTerminalLinks(H,C.token)||[];C.token.isCancellationRequested||F({provider:G,links:$})}));const U=await Promise.all(V);if(C.token.isCancellationRequested)return[];const z=new Map;for(const G of U)G&&G.links.length>0&&M.push(...G.links.map(F=>{const $={id:g++,startIndex:F.startIndex,length:F.length,label:F.tooltip};return z.set($.id,{provider:G.provider,link:F}),$}));return this.y.set(u,z),M}$activateLink(u,m){const f=this.y.get(u)?.get(m);f&&f.provider.handleTerminalLink(f.link)}N(u,m){this.s.stopBuffering(u),this.g.delete(u),delete this.j[u];const f=this.h[u];f&&(f.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,m)}O(u){return this.P(this.f,u)}P(u,m){const f=this.Q(u,m);return f!==null?u[f]:null}Q(u,m){let f=null;return u.some((n,C)=>n._id===m?(f=C,!0):!1),f}getEnvironmentVariableCollection(u){let m=this.l.get(u.identifier.value);return m||(m=new s,this.S(u.identifier.value,m)),m}R(u,m){const f=(0,k.serializeEnvironmentVariableCollection)(m.map),n=(0,k.serializeEnvironmentDescriptionMap)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(u,m.persistent,f.length===0?void 0:f,n)}$initEnvironmentVariableCollections(u){u.forEach(m=>{const f=m[0],n=new s(m[1]);this.S(f,n)})}$acceptDefaultProfile(u,m){const f=this.m;this.m=u,this.n=m,f?.path!==u.path&&this.J.fire(u.path)}S(u,m){this.l.set(u,m),m.onDidChangeCollection(()=>{this.R(u,m)})}};e.BaseExtHostTerminalService=t=xe([We(1,A.IExtHostRpcService)],t);class s{get persistent(){return this.a}set persistent(u){this.a=u,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(u){this.map=new Map,this.descriptionMap=new Map,this.a=!0,this.b=new o.Emitter,this.map=new Map(u)}get size(){return this.map.size}replace(u,m,f){this.d(u,{value:m,type:D.EnvironmentVariableMutatorType.Replace,scope:f})}append(u,m,f){this.d(u,{value:m,type:D.EnvironmentVariableMutatorType.Append,scope:f})}prepend(u,m,f){this.d(u,{value:m,type:D.EnvironmentVariableMutatorType.Prepend,scope:f})}d(u,m){m.scope||delete m.scope;const f=this.f(u,m.scope),n=this.map.get(f);if(!n||n.value!==m.value||n.type!==m.type||n.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const C=this.f(u,m.scope),M={variable:u,...m};this.map.set(C,M),this.b.fire()}}get(u,m){const f=this.f(u,m),n=this.map.get(f);return n?S(n):void 0}f(u,m){const f=this.g(m?.workspaceFolder);return f?`${u}:::${f}`:u}g(u){return u?u.uri.toString():void 0}forEach(u,m){this.map.forEach((f,n)=>u.call(m,f.variable,S(f),this))}[Symbol.iterator](){const u=new Map;return this.map.forEach((m,f)=>{m.scope||u.set(m.variable,S(m))}),u.entries()}delete(u,m){const f=this.f(u,m);this.map.delete(f),this.b.fire()}clear(u){if(u?.workspaceFolder){for(const[m,f]of this.map)f.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(m);this.h(u)}else this.map.clear(),this.descriptionMap.clear();this.b.fire()}setDescription(u,m){const f=this.f("",m),n=this.descriptionMap.get(f);if(!n||n.description!==u){let C;typeof u=="string"?C=u:C=u?.value.split(`

`)[0];const M={description:C,scope:m};this.descriptionMap.set(f,M),this.b.fire()}}h(u){const m=this.f("",u);this.descriptionMap.delete(m)}}let r=e.WorkerExtHostTerminalService=class extends t{constructor(u){super(!1,u)}createTerminal(u,m,f){throw new O.NotSupportedError}createTerminalFromOptions(u,m){throw new O.NotSupportedError}};e.WorkerExtHostTerminalService=r=xe([We(0,A.IExtHostRpcService)],r);function a(c){if(!(!c||typeof c=="string"))return"id"in c?{id:c.id,color:c.color}:c}function b(c){return v.ThemeColor.isThemeColor(c)?c:void 0}function S(c){const u={...c};return u.scope=u.scope??void 0,delete u.variable,u}});var Be=this&&this.__classPrivateFieldGet||function(ae,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!R:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(ae):R?R.value:e.get(ae)},_e=this&&this.__classPrivateFieldSet||function(ae,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!l:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(ae,o):l?l.value=o:e.set(ae,o),o};define(Ce[289],ke([1,0,18,19,22,21,3,64,68,6,23,10,30,5,20,138,11,7,58,95,77]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d,h,y,w){"use strict";var g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=e.ExtHostTesting=class{constructor(U,z,G){this.j=G,this.c=new A.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=U.getProxy(T.MainContext.MainThreadTesting),this.h=new C(this.f),this.g=new S(this.f),z.registerArgumentProcessor({processArgument:F=>{if(F?.$mid!==15)return F;const $=F,Y=$.tests[$.tests.length-1].item.extId;return this.d.get(h.TestId.root(Y))?.collection.tree.get(Y)?.actual??(0,v.toItemFromContext)(F)}}),z.registerCommand(!1,"testing.getExplorerSelection",async()=>{const F=await z.executeCommand("_testing.getExplorerSelection"),$=Y=>{const _=this.d.get(h.TestId.root(Y));if(_)return h.TestId.isRoot(Y)?_.controller:_.collection.tree.get(Y)?.actual};return{include:F?.include.map($).filter(k.isDefined)||[],exclude:F?.exclude.map($).filter(k.isDefined)||[]}})}createTestController(U,z,G,F){if(this.d.has(z))throw new Error(`Attempt to insert a duplicate controller with ID "${z}"`);const $=new p.DisposableStore,Y=$.add(new v.ExtHostTestItemCollection(z,G,this.j));Y.root.label=G;const _=new Map,Q=this.f,ie={items:Y.root.children,get label(){return G},set label(Ee){G=Ee,Y.root.label=Ee,Q.$updateController(z,{label:G})},get refreshHandler(){return F},set refreshHandler(Ee){F=Ee,Q.$updateController(z,{canRefresh:!!Ee})},get id(){return z},createRunProfile:(Ee,he,fe,x,B,Z)=>{let pe=(0,D.hash)(Ee);for(;_.has(pe);)pe++;return new M(this.f,_,z,pe,Ee,he,fe,x,B,Z)},createTestItem(Ee,he,fe){return new v.TestItemImpl(z,Ee,he,fe)},createTestRun:(Ee,he,fe=!0)=>this.g.createTestRun(z,Y,Ee,he,fe),set resolveHandler(Ee){Y.resolveHandler=Ee},get resolveHandler(){return Y.resolveHandler},dispose:()=>{$.dispose()}};Q.$registerTestController(z,G,!!F),$.add((0,p.toDisposable)(()=>Q.$unregisterTestController(z)));const oe={controller:ie,collection:Y,profiles:_};return this.d.set(z,oe),$.add((0,p.toDisposable)(()=>this.d.delete(z))),$.add(Y.onDidGenerateDiff(Ee=>Q.$publishDiff(z,Ee.map(w.TestsDiffOp.serialize)))),ie}createTestObserver(){return this.h.checkout()}async runTests(U,z=L.CancellationToken.None){const G=c(U);if(!G)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const F=this.d.get(G.controllerId);if(!F)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map($=>h.TestId.fromExtHostTestItem($,F.collection.root.id).toString())??[F.collection.root.id],profileGroup:H[G.kind],profileId:G.profileId,controllerId:G.controllerId}],exclude:U.exclude?.map($=>$.id)},z)}$syncTests(){for(const{collection:U}of this.d.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,z,G){return(0,o.mapFind)(this.g.trackers,$=>$.id===U?$.getCoverage(z):void 0)?.provideFileCoverage(G)??Promise.resolve([])}$resolveFileCoverage(U,z,G,F){return(0,o.mapFind)(this.g.trackers,Y=>Y.id===U?Y.getCoverage(z):void 0)?.resolveFileCoverage(G,F)??Promise.resolve([])}$configureRunProfile(U,z){this.d.get(U)?.profiles.get(z)?.configureHandler?.()}async $refreshTests(U,z){await this.d.get(U)?.controller.refreshHandler?.(z)}$publishTestResults(U){this.results=Object.freeze(U.map(z=>(0,O.deepFreeze)(i.TestResults.to(z))).concat(this.results).sort((z,G)=>G.completedAt-z.completedAt).slice(0,32)),this.c.fire()}async $expandTest(U,z){const G=this.d.get(h.TestId.fromString(U).controllerId)?.collection;G&&(await G.expand(U,z<0?1/0:z),G.flushDiff())}$acceptDiff(U){this.h.applyDiff(U.map(w.TestsDiffOp.deserialize))}async $runControllerTests(U,z){return Promise.all(U.map(G=>this.k(G,!1,z)))}async $startContinuousRun(U,z){const G=new L.CancellationTokenSource(z),F=await Promise.all(U.map($=>this.k($,!0,G.token)));return!z.isCancellationRequested&&!F.some($=>$.error)&&await new Promise($=>z.onCancellationRequested($)),G.dispose(!0),F}async k(U,z,G){const F=this.d.get(U.controllerId);if(!F)return{};const{collection:$,profiles:Y}=F,_=Y.get(U.profileId);if(!_)return{};const Q=U.testIds.map(he=>$.tree.get(he)).filter(k.isDefined),ie=U.excludeExtIds.map(he=>F.collection.tree.get(he)).filter(k.isDefined).filter(he=>Q.some(fe=>fe.fullId.compare(he.fullId)===2));if(!Q.length)return{};const oe=new d.TestRunRequest(Q.some(he=>he.actual instanceof v.TestItemRootImpl)?void 0:Q.map(he=>he.actual),ie.map(he=>he.actual),_,z),Ee=(0,w.isStartControllerTests)(U)&&this.g.prepareForMainThreadTestRun(oe,u.fromInternal(U,F.collection),G);try{return await _.runHandler(oe,G),{}}catch(he){return{error:String(he)}}finally{Ee&&(Ee.hasRunningTasks&&!G.isCancellationRequested&&await A.Event.toPromise(Ee.onEnd),Ee.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.g.cancelAllRuns():this.g.cancelRunById(U)}};e.ExtHostTesting=s=xe([We(0,I.IExtHostRpcService)],s);const r=1e4;var a;(function(V){V[V.Running=0]="Running",V[V.Cancelling=1]="Cancelling",V[V.Ended=2]="Ended"})(a||(a={}));class b extends p.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(U,z,G){super(),this.k=U,this.l=z,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new A.Emitter),this.onEnd=this.j.event,this.h=this.B(new L.CancellationTokenSource(G));const F=this.B(new R.RunOnceScheduler(()=>this.m(),r));this.B(this.h.token.onCancellationRequested(()=>F.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const z=this.k.id,G=this.k.controllerId,F=(0,E.generateUuid)(),$=new m(this.l,z,F),Y=oe=>(Ee,...he)=>{if(Q){console.warn(`Setting the state of test "${Ee.id}" is a no-op after the run ends.`);return}this.k.isIncluded(Ee)&&(this.s(Ee),oe(Ee,...he))},_=(oe,Ee)=>{const he=Ee instanceof Array?Ee.map(i.TestMessage.from):[i.TestMessage.from(Ee)];if(oe.uri&&oe.range){const fe={range:i.Range.from(oe.range),uri:oe.uri};for(const x of he)x.location=x.location||fe}this.l.$appendTestMessagesInRun(z,F,h.TestId.fromExtHostTestItem(oe,G).toString(),he)};let Q=!1;const ie={isPersisted:this.k.isPersisted,token:this.h.token,name:U,get coverageProvider(){return $.coverageProvider},set coverageProvider(oe){$.coverageProvider=oe},enqueued:Y(oe=>{this.l.$updateTestStateInRun(z,F,h.TestId.fromExtHostTestItem(oe,G).toString(),1)}),skipped:Y(oe=>{this.l.$updateTestStateInRun(z,F,h.TestId.fromExtHostTestItem(oe,G).toString(),5)}),started:Y(oe=>{this.l.$updateTestStateInRun(z,F,h.TestId.fromExtHostTestItem(oe,G).toString(),2)}),errored:Y((oe,Ee,he)=>{_(oe,Ee),this.l.$updateTestStateInRun(z,F,h.TestId.fromExtHostTestItem(oe,G).toString(),6,he)}),failed:Y((oe,Ee,he)=>{_(oe,Ee),this.l.$updateTestStateInRun(z,F,h.TestId.fromExtHostTestItem(oe,G).toString(),4,he)}),passed:Y((oe,Ee)=>{this.l.$updateTestStateInRun(z,F,h.TestId.fromExtHostTestItem(oe,this.k.controllerId).toString(),3,Ee)}),appendOutput:(oe,Ee,he)=>{Q||(he&&(this.k.isIncluded(he)?this.s(he):he=void 0),this.l.$appendOutputToRun(z,F,l.VSBuffer.fromString(oe),Ee&&i.location.from(Ee),he&&h.TestId.fromExtHostTestItem(he,G).toString()))},end:()=>{Q||(Q=!0,this.l.$finishedTestRunTask(z,F),this.f.delete(F),this.f.size||this.p())}};return this.f.set(F,{run:ie,coverage:$}),this.l.$startedTestRunTask(z,{id:F,name:U,running:!0}),ie}m(){for(const{run:U}of this.f.values())U.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(U){if(!(U instanceof v.TestItemImpl))throw new y.InvalidTestItemError(U.id);if(this.g.has(h.TestId.fromExtHostTestItem(U,this.k.controllerId).toString()))return;const z=[],G=this.k.colllection.root;for(;;){const F=i.TestItem.from(U);if(z.unshift(F),this.g.has(F.extId)||(this.g.add(F.extId),U===G))break;U=U.parent||G}this.l.$addTestsToRun(this.k.controllerId,this.k.id,z)}}class S{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,z,G){return this.f(U,z,G)}cancelRunById(U){for(const z of this.c.values())if(z.id===U){z.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,z,G,F,$){const Y=this.c.get(G);if(Y)return Y.createRun(F);const _=u.fromPublic(U,z,G,$),Q=c(G);this.d.$startedExtensionTestRun({controllerId:U,continuous:!!G.continuous,profile:Q&&{group:H[Q.kind],id:Q.profileId},exclude:G.exclude?.map(oe=>h.TestId.fromExtHostTestItem(oe,z.root.id).toString())??[],id:_.id,include:G.include?.map(oe=>h.TestId.fromExtHostTestItem(oe,z.root.id).toString())??[z.root.id],persist:$});const ie=this.f(G,_);return ie.onEnd(()=>{this.d.$finishedExtensionTestRun(_.id),ie.dispose()}),ie.createRun(F)}f(U,z,G){const F=new b(z,this.d,G);return this.c.set(U,F),F.onEnd(()=>this.c.delete(U)),F}}e.TestRunCoordinator=S;const c=V=>{if(V.profile){if(!(V.profile instanceof M))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return V.profile}};class u{static fromPublic(U,z,G,F){return new u(U,(0,E.generateUuid)(),G.include?.map($=>h.TestId.fromExtHostTestItem($,U).toString())??[U],G.exclude?.map($=>h.TestId.fromExtHostTestItem($,U).toString())??[],F,z)}static fromInternal(U,z){return new u(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,z)}constructor(U,z,G,F,$,Y){this.controllerId=U,this.id=z,this.isPersisted=$,this.colllection=Y,this.c=G.map(_=>_+"\0"),this.d=F.map(_=>_+"\0")}isIncluded(U){const z=h.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const G of this.d)if(z===G||z.startsWith(G))return!1;for(const G of this.c)if(z===G||z.startsWith(G))return!0;return!1}}e.TestRunDto=u;class m{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");U&&(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,z,G){this.f=U,this.g=z,this.h=G}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(i.TestCoverage.fromFile)??[]}catch(z){throw this.d=void 0,z}}async resolveFileCoverage(U,z){const G=await this.d;let F=G?.[U];return!this.c||!G||!F?[]:(F.detailedCoverage||(F=G[U]=await this.c.resolveFileCoverage?.(F,z)??F),F.detailedCoverage?.map(i.TestCoverage.fromDetailed)??[])}}class f{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,i.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const z=h.TestId.parentId(U.item.extId);if(z&&this.g.has(z.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:z,f:G}=this;return{get added(){return[...U].map(F=>F.revived)},get updated(){return[...z].map(F=>F.revived)},get removed(){return[...G].map(F=>F.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class n extends w.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new A.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,z){return{...U,revived:i.TestItem.toPlain(U.item),depth:z?z.depth+1:0,children:new Set}}o(){return new f(this.q)}}class C{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(z=>z.revived)},dispose:(0,P.once)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new n;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class M{get label(){return this.d}set label(U){U!==this.d&&(this.d=U,Be(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,Be(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,Be(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Be(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?i.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,Be(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,z,G,F,$,Y,_,Q=!1,ie=void 0,oe=!1){this.controllerId=G,this.profileId=F,this.d=$,this.kind=Y,this.runHandler=_,this.f=Q,this._tag=ie,this.g=oe,g.set(this,void 0),t.set(this,void 0),_e(this,g,U,"f"),_e(this,t,z,"f"),z.set(F,this);const Ee=H[Y];if(typeof Ee!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);Be(this,g,"f").$publishTestRunProfile({profileId:F,controllerId:G,tag:ie?i.TestTag.namespace(this.controllerId,ie.id):null,label:$,group:Ee,isDefault:Q,hasConfigurationHandler:!1,supportsContinuousRun:oe})}dispose(){Be(this,t,"f")?.delete(this.profileId)&&(_e(this,t,void 0,"f"),Be(this,g,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=M,g=new WeakMap,t=new WeakMap;const H={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(Ce[290],ke([1,0,18,8,3,5,139,11,7]),function(ae,e,o,R,l,L,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class p{constructor(k,E){this.i=E,this.a=new l.Emitter({onListenerError:R.onUnexpectedExternalError}),this.b=new l.Emitter({onListenerError:R.onUnexpectedExternalError}),this.c=new l.Emitter({onListenerError:R.onUnexpectedExternalError}),this.d=new l.Emitter({onListenerError:R.onUnexpectedExternalError}),this.f=new l.Emitter({onListenerError:R.onUnexpectedExternalError}),this.g=new l.Emitter({onListenerError:R.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=k.getProxy(L.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(T=>this.g.fire(T)),this.i.onDidChangeActiveTextEditor(T=>this.f.fire(T))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(k){const E=this.i.allEditors();return k?E:E.map(T=>T.value)}async showTextDocument(k,E,T){let I;typeof E=="number"?I={position:P.ViewColumn.from(E),preserveFocus:T}:typeof E=="object"?I={position:P.ViewColumn.from(E.viewColumn),preserveFocus:E.preserveFocus,selection:typeof E.selection=="object"?P.Range.from(E.selection):void 0,pinned:typeof E.preview=="boolean"?!E.preview:void 0}:I={preserveFocus:!1};const v=await this.h.$tryShowTextDocument(k.uri,I),i=v&&this.i.getEditor(v);if(i)return i.value;throw v?new Error(`Could NOT open editor for "${k.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${k.uri.toString()}".`)}createTextEditorDecorationType(k,E){return new A.TextEditorDecorationType(this.h,k,E).value}$acceptEditorPropertiesChanged(k,E){const T=this.i.getEditor(k);if(!T)throw new Error("unknown text editor");if(E.options&&T._acceptOptions(E.options),E.selections){const I=E.selections.selections.map(P.Selection.to);T._acceptSelections(I)}if(E.visibleRanges){const I=o.coalesce(E.visibleRanges.map(P.Range.to));T._acceptVisibleRanges(I)}if(E.options&&this.b.fire({textEditor:T.value,options:{...E.options,lineNumbers:P.TextEditorLineNumbersStyle.to(E.options.lineNumbers)}}),E.selections){const I=D.TextEditorSelectionChangeKind.fromValue(E.selections.source),v=E.selections.selections.map(P.Selection.to);this.a.fire({textEditor:T.value,selections:v,kind:I})}if(E.visibleRanges){const I=o.coalesce(E.visibleRanges.map(P.Range.to));this.c.fire({textEditor:T.value,visibleRanges:I})}}$acceptEditorPositionData(k){for(const E in k){const T=this.i.getEditor(E);if(!T)throw new Error("Unknown text editor");const I=P.ViewColumn.to(k[E]);T.value.viewColumn!==I&&(T._acceptViewColumn(I),this.d.fire({textEditor:T.value,viewColumn:I}))}}getDiffInformation(k){return Promise.resolve(this.h.$getDiffInformation(k))}}e.ExtHostEditors=p}),define(Ce[291],ke([1,0,2,4,5,6,7,11,25,10]),function(ae,e,o,R,l,L,A,P,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,R.createDecorator)("IExtHostTimeline");class O{constructor(T,I){this.b=new Map,this.c=new Map,this.a=T.getProxy(l.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:(v,i)=>{if(v&&v.$mid===12)if(this.b.get(v.source)&&D.ExtensionIdentifier.equals(i,this.b.get(v.source)?.extension)){const d=v.uri===void 0?void 0:o.URI.revive(v.uri);return this.c.get(v.source)?.get(k(d))?.get(v.handle)}else return;return v}})}async $getTimeline(T,I,v,i){return this.b.get(T)?.provider.provideTimeline(o.URI.revive(I),v,i)}registerTimelineProvider(T,I,v,i){const d=new L.DisposableStore,h=this.d(I.id,i,d).bind(this);let y;I.onDidChange&&(y=I.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:I.id}),this));const w=this.c;return this.f({...I,scheme:T,onDidChange:void 0,async provideTimeline(g,t,s){t?.resetCache&&(d.clear(),w.get(I.id)?.clear());const r=await I.provideTimeline(g,t,s);if(r==null)return;const a=h(g,t);return{...r,source:I.id,items:r.items.map(a)}},dispose(){for(const g of w.values())g.get(I.id)?.clear();y?.dispose(),d.dispose()}},v)}d(T,I,v){return(i,d)=>{let h;if(d?.cacheResults){let y=this.c.get(T);y===void 0&&(y=new Map,this.c.set(T,y));const w=k(i);h=y.get(w),h===void 0&&(h=new Map,y.set(w,h))}return y=>{const{iconPath:w,...g}=y,t=`${T}|${y.id??y.timestamp}`;h?.set(t,y);let s,r,a;y.iconPath&&(w instanceof A.ThemeIcon?a={id:w.id,color:w.color}:o.URI.isUri(w)?(s=w,r=w):{light:s,dark:r}=w);let b;return A.MarkdownString.isMarkdownString(g.tooltip)?b=P.MarkdownString.from(g.tooltip):(0,p.isString)(g.tooltip)?b=g.tooltip:A.MarkdownString.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=P.MarkdownString.from(g.detail)):(0,p.isString)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),b=g.detail),{...g,id:g.id??void 0,handle:t,source:T,command:y.command?I.toInternal(y.command,v):void 0,icon:s,iconDark:r,themeIcon:a,tooltip:b,accessibilityInformation:y.accessibilityInformation}}}}f(T,I){if(this.b.get(T.id))throw new Error(`Timeline Provider ${T.id} already exists.`);return this.a.$registerTimelineProvider({id:T.id,label:T.label,scheme:T.scheme}),this.b.set(T.id,{provider:T,extension:I}),(0,L.toDisposable)(()=>{for(const i of this.c.values())i.get(T.id)?.clear();this.b.delete(T.id),this.a.$unregisterTimelineProvider(T.id),T.dispose()})}}e.ExtHostTimeline=O;function k(E){return E?.toString()}}),define(Ce[292],ke([1,0,6,17,2,5]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class A{constructor(D){this.c=new Map,this.b=D.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(D,p,O,k){if(this.c.has(p))throw new Error(`Opener with id '${p}' already registered`);const E=k.schemes.find(T=>!A.a.has(T));if(E)throw new Error(`Scheme '${E}' is not supported. Only http and https are currently supported.`);return this.c.set(p,O),this.b.$registerUriOpener(p,k.schemes,D,k.label),(0,o.toDisposable)(()=>{this.c.delete(p),this.b.$unregisterUriOpener(p)})}async $canOpenUri(D,p,O){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener with id: ${D}`);const E=l.URI.revive(p);return k.canOpenExternalUri(E,O)}async $openUri(D,p,O){const k=this.c.get(D);if(!k)throw new Error(`Unknown opener id: '${D}'`);return k.openExternalUri(l.URI.revive(p.resolvedUri),{sourceUri:l.URI.revive(p.sourceUri)},O)}}e.ExtHostUriOpeners=A,A.a=new Set([R.Schemas.http,R.Schemas.https])}),define(Ce[293],ke([1,0,5,2,6,8,25]),function(ae,e,o,R,l,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class P{constructor(p){this.c=new A.ExtensionIdentifierSet,this.d=new Map,this.b=p.getProxy(o.MainContext.MainThreadUrls)}registerUriHandler(p,O){if(this.c.has(p))throw new Error(`Protocol handler already registered for extension ${p}`);const k=P.a++;return this.c.add(p),this.d.set(k,O),this.b.$registerUriHandler(k,p),(0,l.toDisposable)(()=>{this.c.delete(p),this.d.delete(k),this.b.$unregisterUriHandler(k)})}$handleExternalUri(p,O){const k=this.d.get(p);if(!k)return Promise.resolve(void 0);try{k.handleUri(R.URI.revive(O))}catch(E){(0,L.onUnexpectedError)(E)}return Promise.resolve(void 0)}async createAppUri(p){return R.URI.revive(await this.b.$createAppUri(p))}}e.ExtHostUrls=P,P.a=0});var _e=this&&this.__classPrivateFieldSet||function(ae,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!l:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(ae,o):l?l.value=o:e.set(ae,o),o},Be=this&&this.__classPrivateFieldGet||function(ae,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!R:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(ae):R?R.value:e.get(ae)};define(Ce[82],ke([1,0,3,17,23,2,206,231,96,5]),function(ae,e,o,R,l,L,A,P,D,p){"use strict";var O,k,E,T,I,v,i,d,h,y,w,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(n,C,M,H,V,U,z){O.set(this,void 0),k.set(this,void 0),E.set(this,void 0),T.set(this,void 0),I.set(this,void 0),v.set(this,void 0),i.set(this,""),d.set(this,void 0),h.set(this,!1),y.set(this,!1),w.set(this,void 0),g.set(this,void 0),this._onMessageEmitter=new o.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,t.set(this,new o.Emitter),this._onDidDispose=Be(this,t,"f").event,_e(this,O,n,"f"),_e(this,k,C,"f"),_e(this,d,M,"f"),_e(this,T,H,"f"),_e(this,I,V,"f"),_e(this,v,U,"f"),_e(this,w,r(U),"f"),_e(this,g,a(U),"f"),_e(this,E,z,"f")}dispose(){_e(this,h,!0,"f"),Be(this,t,"f").fire(),Be(this,t,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(n){return _e(this,y,!0,"f"),(0,D.asWebviewUri)(n,Be(this,T,"f"))}get cspSource(){const n=Be(this,v,"f").extensionLocation;if(n.scheme===R.Schemas.https||n.scheme===R.Schemas.http){let C=n.toString();return C.endsWith("/")||(C+="/"),C+" "+D.webviewGenericCspSource}return D.webviewGenericCspSource}get html(){return this.a(),Be(this,i,"f")}set html(n){this.a(),Be(this,i,"f")!==n&&(_e(this,i,n,"f"),Be(this,g,"f")&&!Be(this,y,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(n)&&(_e(this,y,!0,"f"),Be(this,E,"f").report("Webview vscode-resource: uris",Be(this,v,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Be(this,k,"f").$setHtml(Be(this,O,"f"),this.b(n)))}get options(){return this.a(),Be(this,d,"f")}set options(n){this.a(),l.equals(Be(this,d,"f"),n)||Be(this,k,"f").$setOptions(Be(this,O,"f"),c(Be(this,v,"f"),Be(this,I,"f"),n)),_e(this,d,n,"f")}async postMessage(n){if(Be(this,h,"f"))return!1;const C=(0,P.serializeWebviewMessage)(n,{serializeBuffersForPostMessage:Be(this,w,"f")});return Be(this,k,"f").$postMessage(Be(this,O,"f"),C.message,...C.buffers)}a(){if(Be(this,h,"f"))throw new Error("Webview is disposed")}b(n){if(!Be(this,g,"f"))return n;const C=Be(this,v,"f").extensionLocation?.scheme===R.Schemas.vscodeRemote,M=Be(this,v,"f").extensionLocation.scheme===R.Schemas.vscodeRemote?Be(this,v,"f").extensionLocation.authority:void 0;return n.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(H,V,U,z,G,F)=>{const $=L.URI.from({scheme:z||"file",path:decodeURIComponent(G)}),Y=(0,D.asWebviewUri)($,{isRemote:C,authority:M}).toString();return`${V}${Y}${F}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(H,V,U,z,G,F)=>{const $=L.URI.from({scheme:z||"file",path:decodeURIComponent(G)}),Y=(0,D.asWebviewUri)($,{isRemote:C,authority:M}).toString();return`${V}${Y}${F}`})}}e.ExtHostWebview=s,O=new WeakMap,k=new WeakMap,E=new WeakMap,T=new WeakMap,I=new WeakMap,v=new WeakMap,i=new WeakMap,d=new WeakMap,h=new WeakMap,y=new WeakMap,w=new WeakMap,g=new WeakMap,t=new WeakMap;function r(f){try{const n=(0,A.normalizeVersion)((0,A.parseVersion)(f.engines.vscode));return!!n&&n.majorBase>=1&&n.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function a(f){try{const n=(0,A.normalizeVersion)((0,A.parseVersion)(f.engines.vscode));return n?n.majorBase<1||n.majorBase===1&&n.minorBase<60:!1}catch{return!1}}class b{constructor(n,C,M,H,V){this.c=C,this.d=M,this.e=H,this.f=V,this.b=new Map,this.a=n.getProxy(p.MainContext.MainThreadWebviews)}$onMessage(n,C,M){const H=this.g(n);if(H){const{message:V}=(0,P.deserializeWebviewMessage)(C,M.value);H._onMessageEmitter.fire(V)}}$onMissingCsp(n,C){this.e.warn(`${C} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(n,C,M){const H=new s(n,this.a,u(C),this.c,this.d,M,this.f);return this.b.set(n,H),H._onDidDispose(()=>{this.b.delete(n)}),H}deleteWebview(n){this.b.delete(n)}g(n){return this.b.get(n)}}e.ExtHostWebviews=b;function S(f){return{id:f.identifier,location:f.extensionLocation}}e.toExtensionData=S;function c(f,n,C){return{enableCommandUris:C.enableCommandUris,enableScripts:C.enableScripts,enableForms:C.enableForms,portMapping:C.portMapping,localResourceRoots:C.localResourceRoots||m(f,n)}}e.serializeWebviewOptions=c;function u(f){return{enableCommandUris:f.enableCommandUris,enableScripts:f.enableScripts,enableForms:f.enableForms,portMapping:f.portMapping,localResourceRoots:f.localResourceRoots?.map(n=>L.URI.from(n))}}function m(f,n){return[...(n?.getWorkspaceFolders()||[]).map(C=>C.uri),f.extensionLocation]}}),define(Ce[294],ke([1,0,21,68,6,17,24,2,11,82,76,5,7]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class T{constructor(s,r){this.document=s,this.b=r,this.a=1,this.c=new O.Cache("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,r){await this.f(s).undo(),r||this.disposeBackup()}async redo(s,r){await this.f(s).redo(),r||this.disposeBackup()}disposeEdits(s){for(const r of s)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=g(this.document.uri)+this.a++;return(0,A.joinPath)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const r=this.c.get(s,0);if(!r)throw new Error("No edit found");return r}}class I{constructor(){this.a=new Map}get(s,r){return this.a.get(this.b(s,r))}add(s,r,a){const b=this.b(s,r.uri);if(this.a.has(b))throw new Error(`Document already exists for viewType:${s} resource:${r.uri}`);const S=new T(r,a);return this.a.set(b,S),S}delete(s,r){const a=this.b(s,r.uri);this.a.delete(a)}b(s,r){return`${s}@@@${r}`}}var v;(function(t){t[t.Text=0]="Text",t[t.Custom=1]="Custom"})(v||(v={}));class i{constructor(){this.a=new Map}addTextProvider(s,r,a){return this.b(0,s,r,a)}addCustomProvider(s,r,a){return this.b(1,s,r,a)}get(s){return this.a.get(s)}b(s,r,a,b){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:s,extension:a,provider:b}),new E.Disposable(()=>this.a.delete(r))}}class d{constructor(s,r,a,b,S){this.d=r,this.f=a,this.g=b,this.h=S,this.b=new i,this.c=new I,this.a=s.getProxy(k.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,r,a,b){const S=new l.DisposableStore;return y(a)?(S.add(this.b.addTextProvider(r,s,a)),this.a.$registerTextEditorProvider((0,p.toExtensionData)(s),r,b.webviewOptions||{},{supportsMove:!!a.moveCustomTextEditor},(0,p.shouldSerializeBuffersForPostMessage)(s))):(S.add(this.b.addCustomProvider(r,s,a)),h(a)&&S.add(a.onDidChangeCustomDocument(c=>{const u=this.i(r,c.document.uri);if(w(c)){const m=u.addEdit(c);this.a.$onDidEdit(c.document.uri,r,m,c.label)}else this.a.$onContentChange(c.document.uri,r)})),this.a.$registerCustomEditorProvider((0,p.toExtensionData)(s),r,b.webviewOptions||{},!!b.supportsMultipleEditorsPerDocument,(0,p.shouldSerializeBuffersForPostMessage)(s))),E.Disposable.from(S,new E.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(s,r,a,b,S){const c=this.b.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${r}'`);const u=P.URI.revive(s),m=await c.provider.openCustomDocument(u,{backupId:a,untitledDocumentData:b?.buffer},S);let f;return h(c.provider)&&this.f&&(f=this.f.workspaceValue(c.extension)??this.f.globalValue(c.extension)),this.c.add(r,m,f),{editable:h(c.provider)}}async $disposeCustomDocument(s,r){const a=this.b.get(r);if(!a)throw new Error(`No provider found for '${r}'`);if(a.type!==1)throw new Error(`Invalid provider type for '${r}'`);const b=P.URI.revive(s),{document:S}=this.i(r,b);this.c.delete(r,S),S.dispose()}async $resolveCustomEditor(s,r,a,b,S,c){const u=this.b.get(a);if(!u)throw new Error(`No provider found for '${a}'`);const m=D.ViewColumn.to(S),f=this.g.createNewWebview(r,b.contentOptions,u.extension),n=this.h.createNewWebviewPanel(r,a,b.title,m,b.options,f,!0),C=P.URI.revive(s);switch(u.type){case 1:{const{document:M}=this.i(a,C);return u.provider.resolveCustomEditor(M,n,c)}case 0:{const M=this.d.getDocument(C);return u.provider.resolveCustomTextEditor(M,n,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,r,a){this.i(r,s).disposeEdits(a)}async $onMoveCustomEditor(s,r,a){const b=this.b.get(a);if(!b)throw new Error(`No provider found for '${a}'`);if(!b.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${a}'`);const S=this.h.getWebviewPanel(s);if(!S)throw new Error("No webview found");const c=P.URI.revive(r),u=this.d.getDocument(c);await b.provider.moveCustomTextEditor(u,S,o.CancellationToken.None)}async $undo(s,r,a,b){return this.i(r,s).undo(a,b)}async $redo(s,r,a,b){return this.i(r,s).redo(a,b)}async $revert(s,r,a){const b=this.i(r,s);await this.j(r).revertCustomDocument(b.document,a),b.disposeBackup()}async $onSave(s,r,a){const b=this.i(r,s);await this.j(r).saveCustomDocument(b.document,a),b.disposeBackup()}async $onSaveAs(s,r,a,b){const S=this.i(r,s);return this.j(r).saveCustomDocumentAs(S.document,P.URI.revive(a),b)}async $backup(s,r,a){const b=this.i(r,s),c=await this.j(r).backupCustomDocument(b.document,{destination:b.getNewBackupUri()},a);return b.updateBackup(c),c.id}i(s,r){const a=this.c.get(s,P.URI.revive(r));if(!a)throw new Error("No custom document found");return a}j(s){const a=this.b.get(s)?.provider;if(!a||!h(a))throw new Error("Custom document is not editable");return a}}e.ExtHostCustomEditors=d;function h(t){return!!t.onDidChangeCustomDocument}function y(t){return typeof t.resolveCustomTextEditor=="function"}function w(t){return typeof t.undo=="function"&&typeof t.redo=="function"}function g(t){const s=t.scheme===L.Schemas.file||t.scheme===L.Schemas.untitled?t.fsPath:t.toString();return(0,R.hash)(s)+""}});var _e=this&&this.__classPrivateFieldSet||function(ae,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!l:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(ae,o):l?l.value=o:e.set(ae,o),o},Be=this&&this.__classPrivateFieldGet||function(ae,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!R:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(ae):R?R.value:e.get(ae)};define(Ce[295],ke([1,0,3,6,2,30,11,82,5,7]),function(ae,e,o,R,l,L,A,P,D,p){"use strict";var O,k,E,T,I,v,i,d,h,y,w,g,t;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends R.Disposable{constructor(S,c,u,m){super(),O.set(this,void 0),k.set(this,void 0),E.set(this,void 0),T.set(this,void 0),I.set(this,void 0),v.set(this,void 0),i.set(this,void 0),d.set(this,void 0),h.set(this,!0),y.set(this,void 0),w.set(this,!1),g.set(this,this.B(new o.Emitter)),this.onDidDispose=Be(this,g,"f").event,t.set(this,this.B(new o.Emitter)),this.onDidChangeViewState=Be(this,t,"f").event,_e(this,O,S,"f"),_e(this,k,c,"f"),_e(this,T,u,"f"),_e(this,E,m.viewType,"f"),_e(this,I,m.panelOptions,"f"),_e(this,d,m.viewColumn,"f"),_e(this,v,m.title,"f"),_e(this,y,m.active,"f")}dispose(){Be(this,w,"f")||(_e(this,w,!0,"f"),Be(this,g,"f").fire(),Be(this,k,"f").$disposeWebview(Be(this,O,"f")),Be(this,T,"f").dispose(),super.dispose())}get webview(){return this.c(),Be(this,T,"f")}get viewType(){return this.c(),Be(this,E,"f")}get title(){return this.c(),Be(this,v,"f")}set title(S){this.c(),Be(this,v,"f")!==S&&(_e(this,v,S,"f"),Be(this,k,"f").$setTitle(Be(this,O,"f"),S))}get iconPath(){return this.c(),Be(this,i,"f")}set iconPath(S){this.c(),Be(this,i,"f")!==S&&(_e(this,i,S,"f"),Be(this,k,"f").$setIconPath(Be(this,O,"f"),l.URI.isUri(S)?{light:S,dark:S}:S))}get options(){return Be(this,I,"f")}get viewColumn(){if(this.c(),!(typeof Be(this,d,"f")=="number"&&Be(this,d,"f")<0))return Be(this,d,"f")}get active(){return this.c(),Be(this,y,"f")}get visible(){return this.c(),Be(this,h,"f")}_updateViewState(S){Be(this,w,"f")||(this.active!==S.active||this.visible!==S.visible||this.viewColumn!==S.viewColumn)&&(_e(this,y,S.active,"f"),_e(this,h,S.visible,"f"),_e(this,d,S.viewColumn,"f"),Be(this,t,"f").fire({webviewPanel:this}))}reveal(S,c){this.c(),Be(this,k,"f").$reveal(Be(this,O,"f"),{viewColumn:typeof S>"u"?void 0:A.ViewColumn.from(S),preserveFocus:!!c})}c(){if(Be(this,w,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,k=new WeakMap,E=new WeakMap,T=new WeakMap,I=new WeakMap,v=new WeakMap,i=new WeakMap,d=new WeakMap,h=new WeakMap,y=new WeakMap,w=new WeakMap,g=new WeakMap,t=new WeakMap;class r{static c(){return(0,L.generateUuid)()}constructor(S,c,u){this.g=c,this.h=u,this.e=new Map,this.f=new Map,this.d=S.getProxy(D.MainContext.MainThreadWebviewPanels)}createWebviewPanel(S,c,u,m,f={}){const n=typeof m=="object"?m.viewColumn:m,C={viewColumn:A.ViewColumn.from(n),preserveFocus:typeof m=="object"&&!!m.preserveFocus},M=(0,P.shouldSerializeBuffersForPostMessage)(S),H=r.c();this.d.$createWebviewPanel((0,P.toExtensionData)(S),H,c,{title:u,panelOptions:a(f),webviewOptions:(0,P.serializeWebviewOptions)(S,this.h,f),serializeBuffersForPostMessage:M},C);const V=this.g.createNewWebview(H,f,S);return this.createNewWebviewPanel(H,c,u,n,f,V,!0)}$onDidChangeWebviewPanelViewStates(S){const c=Object.keys(S);c.sort((u,m)=>{const f=S[u],n=S[m];return f.active?1:n.active?-1:+f.visible-+n.visible});for(const u of c){const m=this.getWebviewPanel(u);if(!m)continue;const f=S[u];m._updateViewState({active:f.active,visible:f.visible,viewColumn:A.ViewColumn.to(f.position)})}}async $onDidDisposeWebviewPanel(S){this.getWebviewPanel(S)?.dispose(),this.e.delete(S),this.g.deleteWebview(S)}registerWebviewPanelSerializer(S,c,u){if(this.f.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.f.set(c,{serializer:u,extension:S}),this.d.$registerSerializer(c,{serializeBuffersForPostMessage:(0,P.shouldSerializeBuffersForPostMessage)(S)}),new p.Disposable(()=>{this.f.delete(c),this.d.$unregisterSerializer(c)})}async $deserializeWebviewPanel(S,c,u,m){const f=this.f.get(c);if(!f)throw new Error(`No serializer found for '${c}'`);const{serializer:n,extension:C}=f,M=this.g.createNewWebview(S,u.webviewOptions,C),H=this.createNewWebviewPanel(S,c,u.title,m,u.panelOptions,M,u.active);await n.deserializeWebviewPanel(H,u.state)}createNewWebviewPanel(S,c,u,m,f,n,C){const M=new s(S,this.d,n,{viewType:c,title:u,viewColumn:m,panelOptions:f,active:C});return this.e.set(S,M),M}getWebviewPanel(S){return this.e.get(S)}}e.ExtHostWebviewPanels=r;function a(b){return{enableFindWidget:b.enableFindWidget,retainContextWhenHidden:b.retainContextWhenHidden}}});var _e=this&&this.__classPrivateFieldSet||function(ae,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!l:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(ae,o):l?l.value=o:e.set(ae,o),o},Be=this&&this.__classPrivateFieldGet||function(ae,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!R:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(ae):R?R.value:e.get(ae)};define(Ce[296],ke([1,0,3,6,82,11,5,7]),function(ae,e,o,R,l,L,A,P){"use strict";var D,p,O,k,E,T,I,v,i,d,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class y extends R.Disposable{constructor(t,s,r,a,b,S){super(),D.set(this,void 0),p.set(this,void 0),O.set(this,void 0),k.set(this,void 0),E.set(this,!1),T.set(this,void 0),I.set(this,void 0),v.set(this,void 0),i.set(this,void 0),d.set(this,this.B(new o.Emitter)),this.onDidChangeVisibility=Be(this,d,"f").event,h.set(this,this.B(new o.Emitter)),this.onDidDispose=Be(this,h,"f").event,_e(this,O,r,"f"),_e(this,I,a,"f"),_e(this,D,t,"f"),_e(this,p,s,"f"),_e(this,k,b,"f"),_e(this,T,S,"f")}dispose(){Be(this,E,"f")||(_e(this,E,!0,"f"),Be(this,h,"f").fire(),Be(this,k,"f").dispose(),super.dispose())}get title(){return this.a(),Be(this,I,"f")}set title(t){this.a(),Be(this,I,"f")!==t&&(_e(this,I,t,"f"),Be(this,p,"f").$setWebviewViewTitle(Be(this,D,"f"),t))}get description(){return this.a(),Be(this,v,"f")}set description(t){this.a(),Be(this,v,"f")!==t&&(_e(this,v,t,"f"),Be(this,p,"f").$setWebviewViewDescription(Be(this,D,"f"),t))}get visible(){return Be(this,T,"f")}get webview(){return Be(this,k,"f")}get viewType(){return Be(this,O,"f")}_setVisible(t){t===Be(this,T,"f")||Be(this,E,"f")||(_e(this,T,t,"f"),Be(this,d,"f").fire())}get badge(){return this.a(),Be(this,i,"f")}set badge(t){this.a(),!(t?.value===Be(this,i,"f")?.value&&t?.tooltip===Be(this,i,"f")?.tooltip)&&(_e(this,i,L.ViewBadge.from(t),"f"),Be(this,p,"f").$setWebviewViewBadge(Be(this,D,"f"),t))}show(t){this.a(),Be(this,p,"f").$show(Be(this,D,"f"),!!t)}a(){if(Be(this,E,"f"))throw new Error("Webview is disposed")}}D=new WeakMap,p=new WeakMap,O=new WeakMap,k=new WeakMap,E=new WeakMap,T=new WeakMap,I=new WeakMap,v=new WeakMap,i=new WeakMap,d=new WeakMap,h=new WeakMap;class w{constructor(t,s){this.d=s,this.b=new Map,this.c=new Map,this.a=t.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(t,s,r,a){if(this.b.has(s))throw new Error(`View provider for '${s}' already registered`);return this.b.set(s,{provider:r,extension:t}),this.a.$registerWebviewViewProvider((0,l.toExtensionData)(t),s,{retainContextWhenHidden:a?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,l.shouldSerializeBuffersForPostMessage)(t)}),new P.Disposable(()=>{this.b.delete(s),this.a.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(t,s,r,a,b){const S=this.b.get(s);if(!S)throw new Error(`No view provider found for '${s}'`);const{provider:c,extension:u}=S,m=this.d.createNewWebview(t,{},u),f=new y(t,this.a,s,r,m,!0);this.c.set(t,f),await c.resolveWebviewView(f,{state:a},b)}async $onDidChangeWebviewViewVisibility(t,s){this.e(t)._setVisible(s)}async $disposeWebviewView(t){const s=this.e(t);this.c.delete(t),s.dispose(),this.d.deleteWebview(t)}e(t){const s=this.c.get(t);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=w}),define(Ce[142],ke([1,0,3,5,2,17,9,4,20]),function(ae,e,o,R,l,L,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let p=e.ExtHostWindow=class In{get state(){return this.d}constructor(k){this.c=new o.Emitter,this.onDidChangeWindowState=this.c.event,this.d=In.a,this.b=k.getProxy(R.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(E=>this.$onDidChangeWindowFocus(E))}$onDidChangeWindowFocus(k){k!==this.d.focused&&(this.d={...this.d,focused:k},this.c.fire(this.d))}openUri(k,E){let T;if(typeof k=="string"){T=k;try{k=l.URI.parse(k)}catch{return Promise.reject(`Invalid uri - '${k}'`)}}return(0,A.isFalsyOrWhitespace)(k.scheme)?Promise.reject("Invalid scheme - cannot be empty"):k.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${k.scheme}'`):this.b.$openUri(k,T,E)}async asExternalUri(k,E){if((0,A.isFalsyOrWhitespace)(k.scheme))return Promise.reject("Invalid scheme - cannot be empty");const T=await this.b.$asExternalUri(k,E);return l.URI.from(T)}};p.a={focused:!0},e.ExtHostWindow=p=xe([We(0,D.IExtHostRpcService)],p),e.IExtHostWindow=(0,P.createDecorator)("IExtHostWindow")}),define(Ce[297],ke([1,0,265,26,20]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const L=1024*1024;let A=e.ExtHostConsoleForwarder=class extends o.AbstractExtHostConsoleForwarder{constructor(D,p){super(D,p),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(D,p,O){const k=D==="error"||D==="warn"?process.stderr:process.stdout;this.g=!0,k.write(`
START_NATIVE_LOG
`),p.apply(console,O),k.write(`
END_NATIVE_LOG
`),this.g=!1}j(D,p){const O=process[D],k=O.write;let E="";Object.defineProperty(O,"write",{set:()=>{},get:()=>(T,I,v)=>{if(!this.g){E+=T.toString(I);const i=E.length>L?E.length:E.lastIndexOf(`
`);i!==-1&&(console[p](E.slice(0,i)),E=E.slice(i+1))}k.call(O,T,I,v)}})}};e.ExtHostConsoleForwarder=A=xe([We(0,l.IExtHostRpcService),We(1,R.IExtHostInitDataService)],A)}),define(Ce[298],ke([1,0,15,72,30,41,6,5,2,20]),function(ae,e,o,R,l,L,A,P,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let O=e.ExtHostDownloadService=class extends A.Disposable{constructor(E,T){super();const I=E.getProxy(P.MainContext.MainThreadDownloadService);T.registerCommand(!1,"_workbench.downloadResource",async v=>{const i=D.URI.file((0,o.join)((0,R.tmpdir)(),(0,l.generateUuid)()));return await I.$download(v,i),i})}};e.ExtHostDownloadService=O=xe([We(0,p.IExtHostRpcService),We(1,L.IExtHostCommands)],O)}),define(Ce[299],ke([1,0,141,17,213,30]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class A extends o.ExtHostLoggerService{m(D,p,O){return D.scheme===R.Schemas.file?new l.SpdLogLogger(O?.name||(0,L.generateUuid)(),D.fsPath,!O?.donotRotate,!!O?.donotUseFormatters,p):super.m(D,p,O)}registerLogger(D){super.registerLogger(D),this.n.$registerLogger(D)}deregisterLogger(D){super.deregisterLogger(D),this.n.$deregisterLogger(D)}}e.ExtHostLoggerService=A}),define(Ce[300],ke([1,0,71,15,2,81,6,17,19,29]),function(ae,e,o,R,l,L,A,P,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class O extends L.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(t){const s=await super.g(t);if(s.scheme!==P.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const r=s.fsPath;let a=0;do{let b;a===0?b=r:b=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${a}`:`${r}-${a}`,await k(b);const S=R.join(b,"vscode.lock"),c=await v(this.d,S,!1);if(c)return this.i=c,process.on("exit",()=>{c.dispose()}),l.URI.file(b);a++}while(a<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=O;async function k(g){try{await p.Promises.stat(g);return}catch{}try{await p.Promises.mkdir(g,{recursive:!0})}catch{}}const E=1e3,T=10*60*1e3;class I extends A.Disposable{constructor(t,s){super(),this.b=t,this.c=s,this.a=this.B(new D.IntervalTimer),this.a.cancelAndSet(async()=>{const r=await i(t,s);(!r||r.pid!==process.pid)&&(t.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await p.Promises.utimes(s,new Date,new Date)}catch(a){t.error(a),t.info(`Lock '${s}': Could not update mtime.`)}},E)}dispose(){super.dispose();try{o.unlinkSync(this.c)}catch{}}async setWillRelease(t){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${t} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+t};await p.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function v(g,t,s){try{const a={pid:process.pid,willReleaseAt:0};await p.Promises.writeFile(t,JSON.stringify(a),{flag:"wx"})}catch(a){g.error(a)}const r=await i(g,t);return!r||r.pid!==process.pid?s?(g.info(`Lock '${t}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${t}': Could not acquire lock, checking if the file is stale.`),y(g,t)):(g.info(`Lock '${t}': Lock acquired.`),new I(g,t))}async function i(g,t){let s;try{s=await p.Promises.readFile(t)}catch(r){return g.error(r),null}try{return JSON.parse(String(s))}catch(r){return g.error(r),null}}async function d(g,t){let s;try{s=await p.Promises.stat(t)}catch(r){return g.error(r),0}return s.mtime.getTime()}function h(g){try{return process.kill(g,0),!0}catch{return!1}}async function y(g,t){const s=await i(g,t);if(!s)return g.info(`Lock '${t}': Could not read pid of lock holder.`),w(g,t);if(s.willReleaseAt){let c=s.willReleaseAt-Date.now();if(c<5e3){for(c>0?g.info(`Lock '${t}': The lockfile is scheduled to be released in ${c} ms.`):g.info(`Lock '${t}': The lockfile is scheduled to have been released.`);c>0;){if(await(0,D.timeout)(Math.min(100,c)),await d(g,t)===0)return w(g,t);c=s.willReleaseAt-Date.now()}return w(g,t)}}if(!h(s.pid))return g.info(`Lock '${t}': The pid ${s.pid} appears to be gone.`),w(g,t);const r=await d(g,t),a=Date.now()-r;if(a<=T)return g.info(`Lock '${t}': The lock does not look stale, elapsed: ${a} ms, giving up.`),null;g.info(`Lock '${t}': The lock looks stale, waiting for 2s.`),await(0,D.timeout)(2e3);const b=await d(g,t),S=Date.now()-b;return S<=T?(g.info(`Lock '${t}': The lock does not look stale, elapsed: ${S} ms, giving up.`),null):(g.info(`Lock '${t}': The lock looks stale even after waiting for 2s.`),w(g,t))}async function w(g,t){g.info(`Lock '${t}': Deleting a stale lock.`);try{await p.Promises.unlink(t)}catch{}return v(g,t,!0)}}),define(Ce[301],ke([1,0,30,20,42]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let L=e.ExtHostTerminalService=class extends l.BaseExtHostTerminalService{constructor(P){super(!0,P)}createTerminal(P,D,p){return this.createTerminalFromOptions({name:P,shellPath:D,shellArgs:p})}createTerminalFromOptions(P,D){const p=new l.ExtHostTerminal(this.a,(0,o.generateUuid)(),P,P.name);return this.f.push(p),p.create(P,this.L(P,D)),p.value}};e.ExtHostTerminalService=L=xe([We(0,R.IExtHostRpcService)],L)}),define(Ce[302],ke([1,0,5,20,194,6,26,2,47,24,29,7,14,56,3,129,103,16]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.parseIpAddress=e.loadListeningPorts=e.getSockets=void 0;class h extends v.DisposableTunnel{}function y(c){const u=c.trim().split(`
`),m=[];return u.forEach(n=>{const C=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(n);C&&C.length>=3&&m.push({pid:parseInt(C[1],10),socket:parseInt(C[2],10)})}),m.reduce((n,C)=>(n[C.socket]=C,n),{})}e.getSockets=y;function w(...c){const u=[].concat(...c.map(t));return[...new Map(u.filter(m=>m.st==="0A").map(m=>{const f=m.local_address.split(":");return{socket:parseInt(m.inode,10),ip:g(f[0]),port:parseInt(f[1],16)}}).map(m=>[m.ip+":"+m.port,m])).values()]}e.loadListeningPorts=w;function g(c){let u="";if(c.length===8)for(let m=c.length-2;m>=0;m-=2)u+=parseInt(c.substr(m,2),16),m!==0&&(u+=".");else for(let m=0;m<c.length;m+=8){const f=c.substring(m,m+8);let n="";for(let C=8;C>=2;C-=2)n+=f.substring(C-2,C),(C===6||C===2)&&(n=parseInt(n,16).toString(16),u+=`${n}`,n="",m+C!==c.length-6&&(u+=":"))}return u}e.parseIpAddress=g;function t(c){const u=c.trim().split(`
`),m=u.shift().trim().split(/\s+/).filter(n=>n!=="rx_queue"&&n!=="tm->when");return u.map(n=>n.trim().split(/\s+/).reduce((C,M,H)=>(C[m[H]||H]=M,C),{}))}e.loadConnectionTable=t;function s(c){return!!c.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||c.indexOf("out/server-main.js")!==-1||c.indexOf("_productName=VSCode")!==-1}function r(c){const u=c.trim().split(`
`),m=[];return u.forEach(f=>{const n=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(f);n&&n.length>=4&&m.push({pid:parseInt(n[1],10),ppid:parseInt(n[2]),cmd:n[3]})}),m}e.getRootProcesses=r;async function a(c,u,m){const f=m.reduce((C,M)=>(C[M.pid]=M,C),{}),n=[];return c.forEach(({socket:C,ip:M,port:H})=>{const V=u[C]?u[C].pid:void 0,U=V?f[V]?.cmd:void 0;V&&U&&!s(U)&&n.push({host:M,port:H,detail:U,pid:V})}),n}e.findPorts=a;function b(c,u,m){const f=new Map,n=r(u);for(const C of c){const M=m.get(C.port);if(M){f.set(C.port,M);continue}const H=n.find(V=>V.cmd.includes(`${C.port}`));if(H){let V=H,U;do U=n.find(z=>z.ppid===V.pid),U&&(V=U);while(U);f.set(C.port,{host:C.ip,port:C.port,pid:V.pid,detail:V.cmd,ppid:V.ppid})}else f.set(C.port,{host:C.ip,port:C.port,ppid:Number.MAX_VALUE})}return f}e.tryFindRootPorts=b;let S=e.ExtHostTunnelService=class extends L.Disposable{constructor(u,m,f){super(),this.s=f,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new I.Emitter,this.onDidChangeTunnels=this.h.event,this.k=!1,this.l=new Map,this.n=void 0,this.p=0,this.r=new Map,this.a=u.getProxy(o.MainContext.MainThreadTunnelService),E.isLinux&&m.remote.isRemote&&m.remote.authority&&(this.a.$setRemoteTunnelService(process.pid),this.t())}async openTunnel(u,m){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${u.identifier.value} called openTunnel API for ${m.remoteAddress.host}:${m.remoteAddress.port}.`);const f=await this.a.$openTunnel(m,u.displayName);if(f){const n=new h(f.remoteAddress,f.localAddress,()=>this.a.$closeTunnel(f.remoteAddress));return this.B(n),n}}async t(){this.n=await this.w(),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) Initial candidates found: ${this.n.map(u=>u.port).join(", ")}`)}async getTunnels(){return this.a.$getTunnels()}u(u){return Math.max(u*20,2e3)}v(){return this.p++}registerPortsAttributesProvider(u,m){const f=this.v();return this.r.set(f,{selector:u,provider:m}),this.a.$registerPortsAttributesProvider(u,f),new k.Disposable(()=>{this.r.delete(f),this.a.$unregisterPortsAttributesProvider(f)})}async $providePortAttributes(u,m,f,n,C){const M=[];for(const V of u){const U=this.r.get(V);if(!U)return[];M.push(...await Promise.all(m.map(async z=>U.provider.providePortAttributes(z,f,n,C))))}const H=M.filter(V=>!!V);return H.length>0?H.map(V=>({autoForwardAction:V.autoForwardAction,port:V.port})):[]}async $registerCandidateFinder(u){if(u&&this.k)return;this.k=u;let m;this.n&&(m=this.n,await this.a.$onFoundNewCandidates(this.n));const f=new i.MovingAverage;let n=0;for(;this.k;){const C=new Date().getTime(),M=(await this.w()).filter(U=>(0,v.isLocalhost)(U.host)||(0,v.isAllInterfaces)(U.host));this.s.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${M.map(U=>U.port).join(", ")}`);const H=new Date().getTime()-C;this.s.trace(`ForwardedPorts: (ExtHostTunnelService) candidate port scan took ${H} ms.`),n++>3&&f.update(H),(!m||JSON.stringify(m)!==JSON.stringify(M))&&(m=M,await this.a.$onFoundNewCandidates(m));const V=this.u(f.value);this.s.trace(`ForwardedPorts: (ExtHostTunnelService) next candidate port scan in ${V} ms.`),await new Promise(U=>setTimeout(()=>U(),V))}}async setTunnelFactory(u){if(u){if(u.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(u.candidatePortSource),u.showCandidatePort&&(this.f=u.showCandidatePort,this.a.$setCandidateFilter()),u.tunnelFactory){this.b=u.tunnelFactory;let m=u.tunnelFeatures?.privacyOptions??[];u.tunnelFeatures?.public&&m.length===0&&(m=[{id:"private",label:l.localize(0,null),themeIcon:"lock"},{id:"public",label:l.localize(1,null),themeIcon:"eye"}]);const f=u.tunnelFeatures?{elevation:!!u.tunnelFeatures?.elevation,public:!!u.tunnelFeatures?.public,privacyOptions:m}:void 0;this.a.$setTunnelProvider(f)}}else this.b=void 0;return(0,L.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(u,m){if(this.g.has(u.host)){const f=this.g.get(u.host);f.has(u.port)&&(m&&f.get(u.port).disposeListener.dispose(),await f.get(u.port).tunnel.dispose(),f.delete(u.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(u,m){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const f=this.b(u,m);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),f!==void 0){const n=await f;this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.g.has(u.remoteAddress.host)||this.g.set(u.remoteAddress.host,new Map);const C=this.B(n.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(n.remoteAddress))));return this.g.get(u.remoteAddress.host).set(u.remoteAddress.port,{tunnel:n,disposeListener:C}),T.TunnelDtoConverter.fromApiTunnel(n)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(u){const m=await Promise.all(u.map(n=>this.f(n.host,n.port,n.detail??""))),f=u.filter((n,C)=>m[C]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${u.map(n=>n.port).join(", ")} to ${f.map(n=>n.port).join(", ")}`),f}async w(){let u="",m="";try{u=await O.Promises.readFile("/proc/net/tcp","utf8"),m=await O.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const f=w(u,m),n=await new Promise(F=>{(0,D.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",($,Y,_)=>{F(Y)})}),C=y(n),M=await O.Promises.readdir("/proc"),H=[];for(const F of M)try{const $=Number(F),Y=p.joinPath(P.URI.file("/proc"),F);if((await O.Promises.stat(Y.fsPath)).isDirectory()&&!isNaN($)){const Q=await O.Promises.readlink(p.joinPath(Y,"cwd").fsPath),ie=await O.Promises.readFile(p.joinPath(Y,"cmdline").fsPath,"utf8");H.push({pid:$,cwd:Q,cmd:ie})}}catch{}const V=[],U=f.filter(F=>{const $=C[F.socket];return $||V.push(F),$}),z=a(U,C,H);let G;if(this.s.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${V.length}`),V.length>0){const F=await new Promise($=>{(0,D.exec)("ps -F -A -l | grep root",(Y,_,Q)=>{$(_)})});this.l=b(V,F,this.l),G=Array.from(this.l.values()),this.s.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${G.map($=>$.port).join(", ")}`)}return z.then(F=>G?F.concat(G):F)}};e.ExtHostTunnelService=S=xe([We(0,R.IExtHostRpcService),We(1,A.IExtHostInitDataService),We(2,d.ILogService)],S)}),define(Ce[303],ke([1,0,19,22,21,8,3,6,115,259,59]),function(ae,e,o,R,l,L,A,P,D,p,O){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function E(f,n){try{return JSON.stringify(f,n)}catch{return"null"}}const T="$$ref$$",I={[T]:-1};class v{constructor(n,C){this.jsonString=n,this.referencedBuffers=C}}function i(f,n=null,C=!1){const M=[];return{jsonString:(C?E:JSON.stringify)(f,(V,U)=>{if(typeof U>"u")return I;if(typeof U=="object"){if(U instanceof R.VSBuffer){const z=M.push(U)-1;return{[T]:z}}if(n)return n(V,U)}return U}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=i;function d(f,n,C){return JSON.parse(f,(M,H)=>{if(H){const V=H[T];if(typeof V=="number")return n[V];if(C&&H.$mid===1)return C.transformIncoming(H)}return H})}e.parseJsonAndRestoreBufferRefs=d;function h(f,n){return JSON.stringify(f,n)}function y(f){return f?(n,C)=>C&&C.$mid===1?f.transformOutgoing(C):C:null}var w;(function(f){f[f.LocalSide=0]="LocalSide",f[f.OtherSide=1]="OtherSide"})(w||(e.RequestInitiator=w={}));var g;(function(f){f[f.Responsive=0]="Responsive",f[f.Unresponsive=1]="Unresponsive"})(g||(e.ResponsiveState=g={}));const t=()=>{},s=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class a extends P.Disposable{constructor(n,C=null,M=null){super(),this[k]=!0,this.b=this.B(new A.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=n,this.f=C,this.g=M,this.h=y(this.g),this.j=!1,this.k=[],this.l=[];for(let H=0,V=O.ProxyIdentifier.count;H<V;H++)this.k[H]=null,this.l[H]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new o.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(H=>this.G(H))}dispose(){this.j=!0,Object.keys(this.s).forEach(n=>{this.s[n].resolveErr(L.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(n){this.u===0&&(this.v=Date.now()+a.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(n){this.v=Date.now()+a.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(n){this.t!==n&&(this.t=n,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(n){return this.g?(0,D.transformIncomingURIs)(n,this.g):n}getProxy(n){const{nid:C,sid:M}=n;return this.l[C]||(this.l[C]=this.F(C,M)),this.l[C]}F(n,C){const M={get:(H,V)=>(typeof V=="string"&&!H[V]&&V.charCodeAt(0)===36&&(H[V]=(...U)=>this.O(n,V,U)),V===r?C:H[V])};return new Proxy(Object.create(null),M)}set(n,C){return this.k[n.nid]=C,C}assertRegistered(n){for(let C=0,M=n.length;C<M;C++){const H=n[C];if(!this.k[H.nid])throw new Error(`Missing proxy instance ${H.sid}`)}}G(n){if(this.j)return;const C=n.byteLength,M=b.read(n,0),H=M.readUInt8(),V=M.readUInt32();switch(H){case 1:case 2:{let{rpcId:U,method:z,args:G}=c.deserializeRequestJSONArgs(M);this.g&&(G=(0,D.transformIncomingURIs)(G,this.g)),this.H(C,V,U,z,G,H===2);break}case 3:case 4:{let{rpcId:U,method:z,args:G}=c.deserializeRequestMixedArgs(M);this.g&&(G=(0,D.transformIncomingURIs)(G,this.g)),this.H(C,V,U,z,G,H===4);break}case 5:{this.f?.logIncoming(C,V,0,"ack"),this.z(V);break}case 6:{this.I(C,V);break}case 7:{this.J(C,V,void 0);break}case 9:{let U=c.deserializeReplyOKJSON(M);this.g&&(U=(0,D.transformIncomingURIs)(U,this.g)),this.J(C,V,U);break}case 10:{const U=c.deserializeReplyOKJSONWithBuffers(M,this.g);this.J(C,V,U);break}case 8:{const U=c.deserializeReplyOKVSBuffer(M);this.J(C,V,U);break}case 11:{let U=c.deserializeReplyErrError(M);this.g&&(U=(0,D.transformIncomingURIs)(U,this.g)),this.L(C,V,U);break}case 12:{this.L(C,V,void 0);break}default:console.error("received unexpected message"),console.error(n)}}H(n,C,M,H,V,U){this.f?.logIncoming(n,C,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(M)}.${H}(`,V);const z=String(C);let G,F;if(U){const Y=new l.CancellationTokenSource;V.push(Y.token),G=this.M(M,H,V),F=()=>Y.cancel()}else G=this.M(M,H,V),F=t;this.p[z]=F;const $=c.serializeAcknowledged(C);this.f?.logOutgoing($.byteLength,C,1,"ack"),this.c.send($),G.then(Y=>{delete this.p[z];const _=c.serializeReplyOK(C,Y,this.h);this.f?.logOutgoing(_.byteLength,C,1,"reply:",Y),this.c.send(_)},Y=>{delete this.p[z];const _=c.serializeReplyErr(C,Y);this.f?.logOutgoing(_.byteLength,C,1,"replyErr:",Y),this.c.send(_)})}I(n,C){this.f?.logIncoming(n,C,1,"receiveCancel");const M=String(C);this.p[M]?.()}J(n,C,M){this.f?.logIncoming(n,C,0,"receiveReply:",M);const H=String(C);if(!this.s.hasOwnProperty(H))return;const V=this.s[H];delete this.s[H],V.resolveOk(M)}L(n,C,M){this.f?.logIncoming(n,C,0,"receiveReplyErr:",M);const H=String(C);if(!this.s.hasOwnProperty(H))return;const V=this.s[H];delete this.s[H];let U;M&&(M.$isError?(U=new Error,U.name=M.name,U.message=M.message,U.stack=M.stack):U=M),V.resolveErr(U)}M(n,C,M){try{return Promise.resolve(this.N(n,C,M))}catch(H){return Promise.reject(H)}}N(n,C,M){const H=this.k[n];if(!H)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(n));const V=H[C];if(typeof V!="function")throw new Error("Unknown method "+C+" on actor "+(0,O.getStringIdentifierForProxy)(n));return V.apply(H,M)}O(n,C,M){if(this.j)return new p.CanceledLazyPromise;let H=null;if(M.length>0&&l.CancellationToken.isCancellationToken(M[M.length-1])&&(H=M.pop()),H&&H.isCancellationRequested)return Promise.reject(L.canceled());const V=c.serializeRequestArguments(M,this.h),U=++this.m,z=String(U),G=new p.LazyPromise;H&&H.onCancellationRequested(()=>{const $=c.serializeCancel(U);this.f?.logOutgoing($.byteLength,U,0,"cancel"),this.c.send(c.serializeCancel(U))}),this.s[z]=G,this.y(U);const F=c.serializeRequest(U,n,C,V,!!H);return this.f?.logOutgoing(F.byteLength,U,0,`request: ${(0,O.getStringIdentifierForProxy)(n)}.${C}(`,M),this.c.send(F),G}}e.RPCProtocol=a,k=s,a.a=3*1e3;class b{static alloc(n,C,M){const H=new b(R.VSBuffer.alloc(M+1+4),0);return H.writeUInt8(n),H.writeUInt32(C),H}static read(n,C){return new b(n,C)}get buffer(){return this.a}constructor(n,C){this.a=n,this.b=C}static sizeUInt8(){return 1}writeUInt8(n){this.a.writeUInt8(n,this.b),this.b+=1}readUInt8(){const n=this.a.readUInt8(this.b);return this.b+=1,n}writeUInt32(n){this.a.writeUInt32BE(n,this.b),this.b+=4}readUInt32(){const n=this.a.readUInt32BE(this.b);return this.b+=4,n}static sizeShortString(n){return 1+n.byteLength}writeShortString(n){this.a.writeUInt8(n.byteLength,this.b),this.b+=1,this.a.set(n,this.b),this.b+=n.byteLength}readShortString(){const n=this.a.readUInt8(this.b);this.b+=1;const M=this.a.slice(this.b,this.b+n).toString();return this.b+=n,M}static sizeLongString(n){return 4+n.byteLength}writeLongString(n){this.a.writeUInt32BE(n.byteLength,this.b),this.b+=4,this.a.set(n,this.b),this.b+=n.byteLength}readLongString(){const n=this.a.readUInt32BE(this.b);this.b+=4;const M=this.a.slice(this.b,this.b+n).toString();return this.b+=n,M}writeBuffer(n){this.a.writeUInt32BE(n.byteLength,this.b),this.b+=4,this.a.set(n,this.b),this.b+=n.byteLength}static sizeVSBuffer(n){return 4+n.byteLength}writeVSBuffer(n){this.a.writeUInt32BE(n.byteLength,this.b),this.b+=4,this.a.set(n,this.b),this.b+=n.byteLength}readVSBuffer(){const n=this.a.readUInt32BE(this.b);this.b+=4;const C=this.a.slice(this.b,this.b+n);return this.b+=n,C}static sizeMixedArray(n){let C=0;C+=1;for(let M=0,H=n.length;M<H;M++){const V=n[M];switch(C+=1,V.type){case 1:C+=this.sizeLongString(V.value);break;case 2:C+=this.sizeVSBuffer(V.value);break;case 3:C+=this.sizeUInt32,C+=this.sizeLongString(V.value);for(let U=0;U<V.buffers.length;++U)C+=this.sizeVSBuffer(V.buffers[U]);break;case 4:break}}return C}writeMixedArray(n){this.a.writeUInt8(n.length,this.b),this.b+=1;for(let C=0,M=n.length;C<M;C++){const H=n[C];switch(H.type){case 1:this.writeUInt8(1),this.writeLongString(H.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(H.value);break;case 3:this.writeUInt8(3),this.writeUInt32(H.buffers.length),this.writeLongString(H.value);for(let V=0;V<H.buffers.length;++V)this.writeBuffer(H.buffers[V]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const n=this.a.readUInt8(this.b);this.b+=1;const C=new Array(n);for(let M=0;M<n;M++)switch(this.readUInt8()){case 1:C[M]=this.readLongString();break;case 2:C[M]=this.readVSBuffer();break;case 3:{const V=this.readUInt32(),U=this.readLongString(),z=[];for(let G=0;G<V;++G)z.push(this.readVSBuffer());C[M]=new O.SerializableObjectWithBuffers(d(U,z,null));break}case 4:C[M]=void 0;break}return C}}b.sizeUInt32=4;var S;(function(f){f[f.Simple=0]="Simple",f[f.Mixed=1]="Mixed"})(S||(S={}));class c{static a(n){for(let C=0,M=n.length;C<M;C++)if(n[C]instanceof R.VSBuffer||n[C]instanceof O.SerializableObjectWithBuffers||typeof n[C]>"u")return!0;return!1}static serializeRequestArguments(n,C){if(this.a(n)){const M=[];for(let H=0,V=n.length;H<V;H++){const U=n[H];if(U instanceof R.VSBuffer)M[H]={type:2,value:U};else if(typeof U>"u")M[H]={type:4};else if(U instanceof O.SerializableObjectWithBuffers){const{jsonString:z,referencedBuffers:G}=i(U.value,C);M[H]={type:3,value:R.VSBuffer.fromString(z),buffers:G}}else M[H]={type:1,value:R.VSBuffer.fromString(h(U,C))}}return{type:1,args:M}}return{type:0,args:h(n,C)}}static serializeRequest(n,C,M,H,V){switch(H.type){case 0:return this.b(n,C,M,H.args,V);case 1:return this.c(n,C,M,H.args,V)}}static b(n,C,M,H,V){const U=R.VSBuffer.fromString(M),z=R.VSBuffer.fromString(H);let G=0;G+=b.sizeUInt8(),G+=b.sizeShortString(U),G+=b.sizeLongString(z);const F=b.alloc(V?2:1,n,G);return F.writeUInt8(C),F.writeShortString(U),F.writeLongString(z),F.buffer}static deserializeRequestJSONArgs(n){const C=n.readUInt8(),M=n.readShortString(),H=n.readLongString();return{rpcId:C,method:M,args:JSON.parse(H)}}static c(n,C,M,H,V){const U=R.VSBuffer.fromString(M);let z=0;z+=b.sizeUInt8(),z+=b.sizeShortString(U),z+=b.sizeMixedArray(H);const G=b.alloc(V?4:3,n,z);return G.writeUInt8(C),G.writeShortString(U),G.writeMixedArray(H),G.buffer}static deserializeRequestMixedArgs(n){const C=n.readUInt8(),M=n.readShortString(),H=n.readMixedArray(),V=new Array(H.length);for(let U=0,z=H.length;U<z;U++){const G=H[U];typeof G=="string"?V[U]=JSON.parse(G):V[U]=G}return{rpcId:C,method:M,args:V}}static serializeAcknowledged(n){return b.alloc(5,n,0).buffer}static serializeCancel(n){return b.alloc(6,n,0).buffer}static serializeReplyOK(n,C,M){if(typeof C>"u")return this.d(n);if(C instanceof R.VSBuffer)return this.e(n,C);if(C instanceof O.SerializableObjectWithBuffers){const{jsonString:H,referencedBuffers:V}=i(C.value,M,!0);return this.g(n,H,V)}else return this.f(n,E(C,M))}static d(n){return b.alloc(7,n,0).buffer}static e(n,C){let M=0;M+=b.sizeVSBuffer(C);const H=b.alloc(8,n,M);return H.writeVSBuffer(C),H.buffer}static deserializeReplyOKVSBuffer(n){return n.readVSBuffer()}static f(n,C){const M=R.VSBuffer.fromString(C);let H=0;H+=b.sizeLongString(M);const V=b.alloc(9,n,H);return V.writeLongString(M),V.buffer}static g(n,C,M){const H=R.VSBuffer.fromString(C);let V=0;V+=b.sizeUInt32,V+=b.sizeLongString(H);for(const z of M)V+=b.sizeVSBuffer(z);const U=b.alloc(10,n,V);U.writeUInt32(M.length),U.writeLongString(H);for(const z of M)U.writeBuffer(z);return U.buffer}static deserializeReplyOKJSON(n){const C=n.readLongString();return JSON.parse(C)}static deserializeReplyOKJSONWithBuffers(n,C){const M=n.readUInt32(),H=n.readLongString(),V=[];for(let U=0;U<M;++U)V.push(n.readVSBuffer());return new O.SerializableObjectWithBuffers(d(H,V,C))}static serializeReplyErr(n,C){const M=C?E(L.transformErrorForSerialization(C),null):void 0;if(typeof M!="string")return this.h(n);const H=R.VSBuffer.fromString(M);let V=0;V+=b.sizeLongString(H);const U=b.alloc(11,n,V);return U.writeLongString(H),U.buffer}static deserializeReplyErrError(n){const C=n.readLongString();return JSON.parse(C)}static h(n){return b.alloc(12,n,0).buffer}}var u;(function(f){f[f.RequestJSONArgs=1]="RequestJSONArgs",f[f.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",f[f.RequestMixedArgs=3]="RequestMixedArgs",f[f.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",f[f.Acknowledged=5]="Acknowledged",f[f.Cancel=6]="Cancel",f[f.ReplyOKEmpty=7]="ReplyOKEmpty",f[f.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",f[f.ReplyOKJSON=9]="ReplyOKJSON",f[f.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",f[f.ReplyErrError=11]="ReplyErrError",f[f.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var m;(function(f){f[f.String=1]="String",f[f.VSBuffer=2]="VSBuffer",f[f.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",f[f.Undefined=4]="Undefined"})(m||(m={}))}),define(Ce[304],ke([1,0,3,40,44,4]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new l.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new l.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new l.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)("outputService");var A;(function(D){D[D.Append=1]="Append",D[D.Replace=2]="Replace",D[D.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class P{constructor(){this.a=new Map,this.b=new o.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new o.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(p){this.a.has(p.id)||(this.a.set(p.id,p),this.b.fire(p.id))}getChannels(){const p=[];return this.a.forEach(O=>p.push(O)),p}getChannel(p){return this.a.get(p)}removeChannel(p){this.a.delete(p),this.c.fire(p)}}R.Registry.add(e.Extensions.OutputChannels,new P),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new l.RawContextKey("activeOutputChannel","")}),define(Ce[143],ke([1,0,5,4,20,25,16,304,80,26,49,161,22,10,45,3,6]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class d extends A.AbstractMessageLogger{get disposed(){return this.l}constructor(g,t,s,r,a){super(),this.id=g,this.name=t,this.m=s,this.n=r,this.extension=a,this.k=0,this.l=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(b=>this.setLevel(b)))}get logLevel(){return this.getLevel()}appendLine(g){this.append(g+`
`)}append(g){this.info(g)}clear(){const g=this.k;this.m.flush(),this.n.$update(this.id,P.OutputChannelUpdateMode.Clear,g)}replace(g){const t=this.k;this.info(g),this.n.$update(this.id,P.OutputChannelUpdateMode.Replace,t),this.visible&&this.m.flush()}show(g,t){this.m.flush(),this.n.$reveal(this.id,!!(typeof g=="boolean"?g:t))}hide(){this.n.$close(this.id)}g(g,t){this.k+=E.VSBuffer.fromString(t).byteLength,(0,A.log)(this.m,g,t),this.visible&&(this.m.flush(),this.n.$update(this.id,P.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class h extends d{appendLine(g){this.append(g)}}let y=e.ExtHostOutputService=class{constructor(g,t,s,r,a,b){this.i=t,this.j=s,this.k=r,this.l=a,this.m=b,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=g.getProxy(o.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(t.logsLocation,`output_logging_${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.h=g;for(const[t,s]of this.g)s.visible=t===this.h}createOutputChannel(g,t,s){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const r=typeof t=="object"&&t.log,a=(0,T.isString)(t)?t:void 0;if((0,T.isString)(a)&&!a.trim())throw new Error("illegal argument `languageId`. must not be empty");let b;const S=this.i.environment.extensionLogLevel?.find(([u])=>L.ExtensionIdentifier.equals(s.identifier,u))?.[1];S&&(b=(0,A.parseLogLevel)(S));const c=r?this.o(g,b,s):this.n(g,a,s);return c.then(u=>{this.g.set(u.id,u),u.visible=u.id===this.h}),r?this.r(g,b??this.m.getLevel(),c):this.q(g,c)}async n(g,t,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,a=this.k.extUri.joinPath(r,`${this.f++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),b=this.l.createLogger(a,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),S=await this.a.$register(g,a,t,s.identifier.value);return new d(S,g,b,this.a,s)}async o(g,t,s){const r=await this.p(s),a=g.replace(/[\\/:\*\?"<>\|]/g,""),b=this.k.extUri.joinPath(r,`${a}.log`),S=`${s.identifier.value}.${a}`,c=this.l.createLogger(b,{id:S,name:g,logLevel:t,extensionId:s.identifier.value});return new h(S,g,c,this.a,s)}p(g){let t=this.d.get(g.identifier.value);if(!t){const s=this.k.extUri.joinPath(this.i.logsLocation,g.identifier.value);this.d.set(g.identifier.value,t=(async()=>{try{await this.j.value.createDirectory(s)}catch(r){if((0,I.toFileSystemProviderErrorCode)(r)!==I.FileSystemProviderErrorCode.FileExists)throw r}return s})())}return t}q(g,t){let s=!1;const r=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return g},append(a){r(),t.then(b=>b.append(a))},appendLine(a){r(),t.then(b=>b.appendLine(a))},clear(){r(),t.then(a=>a.clear())},replace(a){r(),t.then(b=>b.replace(a))},show(a,b){r(),t.then(S=>S.show(a,b))},hide(){r(),t.then(a=>a.hide())},dispose(){s=!0,t.then(a=>a.dispose())}}}r(g,t,s){const r=new i.DisposableStore,a=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},b=r.add(new v.Emitter);function S(c){t=c,b.fire(c)}return s.then(c=>{r.add(c),c.logLevel!==t&&S(c.logLevel),r.add(c.onDidChangeLogLevel(u=>S(u)))}),{...this.q(g,s),get logLevel(){return t},onDidChangeLogLevel:b.event,trace(c,...u){a(),s.then(m=>m.trace(c,...u))},debug(c,...u){a(),s.then(m=>m.debug(c,...u))},info(c,...u){a(),s.then(m=>m.info(c,...u))},warn(c,...u){a(),s.then(m=>m.warn(c,...u))},error(c,...u){a(),s.then(m=>m.error(c,...u))},dispose(){r.dispose()}}}};e.ExtHostOutputService=y=xe([We(0,l.IExtHostRpcService),We(1,p.IExtHostInitDataService),We(2,D.IExtHostConsumerFileSystem),We(3,O.IExtHostFileSystemInfo),We(4,A.ILoggerService),We(5,A.ILogService)],y),e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(Ce[305],ke([1,0,4]),function(ae,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,o.createDecorator)("remoteAgentService")}),define(Ce[306],ke([1,0,33,17,15,14,24,2,4,226,48,245,305]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,D.createDecorator)("pathService");let T=e.AbstractPathService=class Cn{constructor(v,i,d,h){this.d=v,this.e=i,this.f=d,this.g=h,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const y=await this.e.getEnvironment();return this.c=y?.userHome??v})()}hasValidBasename(v,i,d){return typeof i=="string"||typeof i>"u"?this.a.then(h=>this.h(v,h,i)):this.h(v,i,d)}h(v,i,d){return v.scheme===R.Schemas.file||v.scheme===R.Schemas.vscodeRemote?(0,o.isValidBasename)(d??(0,A.basename)(v),i===1):!0}get defaultUriScheme(){return Cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(v,i){if(v.remoteAuthority)return R.Schemas.vscodeRemote;const d=(0,p.getVirtualWorkspaceScheme)(i.getWorkspace());if(d)return d;const h=i.getWorkspace().folders[0];if(h)return h.uri.scheme;const y=i.getWorkspace().configuration;return y?y.scheme:R.Schemas.file}userHome(v){return v?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(v=>v===1?l.win32:l.posix)}async fileURI(v){let i="";if(await this.a===1&&(v=v.replace(/\\/g,"/")),v[0]==="/"&&v[1]==="/"){const h=v.indexOf("/",2);h===-1?(i=v.substring(2),v="/"):(i=v.substring(2,h),v=v.substring(h)||"/")}return P.URI.from({scheme:R.Schemas.file,authority:i,path:v,query:"",fragment:""})}};e.AbstractPathService=T=xe([We(1,E.IRemoteAgentService),We(2,k.IWorkbenchEnvironmentService),We(3,O.IWorkspaceContextService)],T)}),define(Ce[83],ke([1,0]),function(ae,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class o{constructor(A,P){this.line=A,this.character=P}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,P){return new o(0,0)}with(A){return new o(0,0)}}e.Position=o;class R{constructor(A,P,D,p){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(A,P),this.end=new o(D,p)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new R(0,0,0,0)}with(A){return new R(0,0,0,0)}}e.Range=R;var l;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(l||(e.TextSearchCompleteMessageType=l={}))}),define(Ce[31],ke([1,0,18,39,23,33,9,4,15,8,83,19]),function(ae,e,o,R,l,L,A,P,D,p,O,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const E="\u27EA ",T=" characters skipped \u27EB",I=(E.length+T.length+5)*2;e.ISearchService=(0,P.createDecorator)("searchService");var v;(function(ie){ie[ie.file=0]="file",ie[ie.text=1]="text"})(v||(e.SearchProviderType=v={}));var i;(function(ie){ie[ie.File=1]="File",ie[ie.Text=2]="Text"})(i||(e.QueryType=i={}));function d(ie){return!!ie.preview}e.resultIsMatch=d;function h(ie){return!!ie.resource}e.isFileMatch=h;function y(ie){return!!ie.message}e.isProgressMessage=y;var w;(function(ie){ie[ie.Normal=0]="Normal",ie[ie.NewSearchStarted=1]="NewSearchStarted"})(w||(e.SearchCompletionExitCode=w={}));class g{constructor(oe){this.resource=oe,this.results=[]}}e.FileMatch=g;class t{constructor(oe,Ee,he,fe){this.ranges=Ee,this.webviewIndex=fe;const x=Array.isArray(Ee)?Ee:[Ee];if(he&&he.matchLines===1&&s(x)){oe=(0,A.getNLines)(oe,he.matchLines);let B="",Z=0,pe=0;const Se=Math.floor(he.charsPerLine/5),re=[];for(const ne of x){const de=Math.max(ne.startColumn-Se,0),ee=ne.startColumn+he.charsPerLine;if(de>pe+Se+I){const ce=E+(de-pe)+T;B+=ce+oe.slice(de,ee),Z+=de-(pe+ce.length)}else B+=oe.slice(pe,ee);re.push(new a(0,ne.startColumn-Z,ne.endColumn-Z)),pe=ee}this.preview={text:B,matches:Array.isArray(this.ranges)?re:re[0]}}else{const B=Array.isArray(Ee)?Ee[0].startLineNumber:Ee.startLineNumber;this.preview={text:oe,matches:(0,o.mapArrayOrNot)(Ee,Z=>new r(Z.startLineNumber-B,Z.startColumn,Z.endLineNumber-B,Z.endColumn))}}}}e.TextSearchMatch=t;function s(ie){const oe=ie[0].startLineNumber;for(const Ee of ie)if(Ee.startLineNumber!==oe||Ee.endLineNumber!==oe)return!1;return!0}class r{constructor(oe,Ee,he,fe){this.startLineNumber=oe,this.startColumn=Ee,this.endLineNumber=he,this.endColumn=fe}}e.SearchRange=r;class a extends r{constructor(oe,Ee,he){super(oe,Ee,oe,he)}}e.OneLineRange=a;var b;(function(ie){ie.List="list",ie.Tree="tree"})(b||(e.ViewMode=b={}));var S;(function(ie){ie.Default="default",ie.FileNames="fileNames",ie.Type="type",ie.Modified="modified",ie.CountDescending="countDescending",ie.CountAscending="countAscending"})(S||(e.SearchSortOrder=S={}));function c(ie,oe=!0){const Ee=ie&&ie.files&&ie.files.exclude,he=oe&&ie&&ie.search&&ie.search.exclude;if(!Ee&&!he)return;if(!Ee||!he)return Ee||he;let fe=Object.create(null);return fe=l.mixin(fe,l.deepClone(Ee)),fe=l.mixin(fe,l.deepClone(he),!0),fe}e.getExcludes=c;function u(ie,oe){return ie.excludePattern&&R.match(ie.excludePattern,oe)?!1:ie.includePattern||ie.usingSearchPaths?ie.includePattern&&R.match(ie.includePattern,oe)?!0:ie.usingSearchPaths?!!ie.folderQueries&&ie.folderQueries.some(Ee=>{const he=Ee.folder.fsPath;if(L.isEqualOrParent(oe,he)){const fe=D.relative(he,oe);return!Ee.includePattern||!!R.match(Ee.includePattern,fe)}else return!1}):!1:!0}e.pathIncludedInQuery=u;var m;(function(ie){ie[ie.unknownEncoding=1]="unknownEncoding",ie[ie.regexParseError=2]="regexParseError",ie[ie.globParseError=3]="globParseError",ie[ie.invalidLiteral=4]="invalidLiteral",ie[ie.rgProcessError=5]="rgProcessError",ie[ie.other=6]="other",ie[ie.canceled=7]="canceled"})(m||(e.SearchErrorCode=m={}));class f extends Error{constructor(oe,Ee){super(oe),this.code=Ee}}e.SearchError=f;function n(ie){const oe=ie.message;if((0,p.isCancellationError)(ie))return new f(oe,m.canceled);try{const Ee=JSON.parse(oe);return new f(Ee.message,Ee.code)}catch{return new f(oe,m.other)}}e.deserializeSearchError=n;function C(ie){const oe={message:ie.message,code:ie.code};return new Error(JSON.stringify(oe))}e.serializeSearchError=C;function M(ie){return ie.type==="error"?!0:ie.type==="success"}e.isSerializedSearchComplete=M;function H(ie){return ie.type==="success"}e.isSerializedSearchSuccess=H;function V(ie){return!!ie.path}e.isSerializedFileMatch=V;function U(ie,oe){const Ee=ie.searchPath?ie.searchPath:ie.relativePath;return(0,A.fuzzyContains)(Ee,oe)}e.isFilePatternMatch=U;class z{constructor(oe){this.path=oe,this.results=[]}addMatch(oe){this.results.push(oe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=z;function G(ie,oe){const Ee={...ie||{},...oe||{}};return Object.keys(Ee).filter(he=>{const fe=Ee[he];return typeof fe=="boolean"&&fe})}e.resolvePatternsForProvider=G;class F{constructor(oe,Ee){this.c=null,this.a={...oe.excludePattern||{},...Ee.excludePattern||{}},this.b=R.parse(this.a);let he=oe.includePattern;Ee.includePattern&&(he?he={...he,...Ee.includePattern}:he=Ee.includePattern),he&&(this.c=R.parse(he))}matchesExcludesSync(oe,Ee,he){return!!(this.b&&this.b(oe,Ee,he))}includedInQuerySync(oe,Ee,he){return!(this.b&&this.b(oe,Ee,he)||this.c&&!this.c(oe,Ee,he))}includedInQuery(oe,Ee,he){const fe=this.b(oe,Ee,he),x=()=>this.c?!!this.c(oe,Ee,he):!0;return(0,k.isThenable)(fe)?fe.then(B=>B?!1:x()):x()}hasSiblingExcludeClauses(){return $(this.a)}}e.QueryGlobTester=F;function $(ie){for(const oe in ie)if(typeof ie[oe]!="boolean")return!0;return!1}function Y(ie){if(!ie)return;let oe;return Ee=>(oe||(oe=(ie()||Promise.resolve([])).then(he=>he?Q(he):{})),oe.then(he=>!!he[Ee]))}e.hasSiblingPromiseFn=Y;function _(ie){if(!ie)return;let oe;return Ee=>{if(!oe){const he=ie();oe=he?Q(he):{}}return!!oe[Ee]}}e.hasSiblingFn=_;function Q(ie){const oe={};for(const Ee of ie)oe[Ee]=!0;return oe}}),define(Ce[34],ke([1,0,18,19,21,3,6,69,17,103,24,9,10,2,192,4,16,214,48,49,26,20,11,7,57,31,5]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d,h,y,w,g,t,s,r,a,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function S(H,V,U){return new O.ExtUri(z=>f(z,U)).isEqual(H,V)}function c(H,V,U){return S(H.uri,V.uri,U)?0:(0,k.compare)(H.uri.toString(),V.uri.toString())}function u(H,V,U){return H.index!==V.index?H.index<V.index?-1:1:S(H.uri,V.uri,U)?(0,k.compare)(H.name,V.name):(0,k.compare)(H.uri.toString(),V.uri.toString())}function m(H,V,U,z){const G=H.slice(0).sort(($,Y)=>U($,Y,z)),F=V.slice(0).sort(($,Y)=>U($,Y,z));return(0,o.delta)(G,F,($,Y)=>U($,Y,z))}function f(H,V){const U=V.getCapabilities(H.scheme);return!(U&&U&1024)}class n extends h.Workspace{static toExtHostWorkspace(V,U,z,G){if(!V)return{workspace:null,added:[],removed:[]};const{id:F,name:$,folders:Y,configuration:_,transient:Q,isUntitled:ie}=V,oe=[],Ee=U;U?Y.forEach((B,Z)=>{const pe=T.URI.revive(B.uri),Se=n.o(z||U,pe,G);Se?(Se.name=B.name,Se.index=B.index,oe.push(Se)):oe.push({uri:pe,name:B.name,index:Z})}):oe.push(...Y.map(({uri:B,name:Z,index:pe})=>({uri:T.URI.revive(B),name:Z,index:pe}))),oe.sort((B,Z)=>B.index<Z.index?-1:1);const he=new n(F,$,oe,!!Q,_?T.URI.revive(_):null,!!ie,B=>f(B,G)),{added:fe,removed:x}=m(Ee?Ee.workspaceFolders:[],he.workspaceFolders,c,G);return{workspace:he,added:fe,removed:x}}static o(V,U,z){for(let G=0;G<V.folders.length;G++){const F=V.workspaceFolders[G];if(S(F.uri,U,z))return F}}constructor(V,U,z,G,F,$,Y){super(V,z.map(_=>new h.WorkspaceFolder(_)),G,F,Y),this.t=U,this.u=$,this.q=[],this.s=P.TernarySearchTree.forUris(Y),z.forEach(_=>{this.q.push(_),this.s.set(_.uri,_)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(V,U){return U&&this.s.get(V)&&(V=(0,O.dirname)(V)),this.s.findSubstr(V)}resolveWorkspaceFolder(V){return this.s.get(V)}}let C=e.ExtHostWorkspace=class{constructor(V,U,z,G,F){this.c=new L.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new L.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.AsyncEmitter,this.h=G,this.s=z,this.t=F,this.j=new p.Counter,this.k=new R.Barrier,this.o=V.getProxy(b.MainContext.MainThreadWorkspace),this.q=V.getProxy(b.MainContext.MainThreadMessageService);const $=U.workspace;this.l=$?new n($.id,$.name,[],!!$.transient,$.configuration?T.URI.revive($.configuration):null,!!$.isUntitled,Y=>f(Y,z)):void 0}$initializeWorkspace(V,U){this.v=U,this.$acceptWorkspaceData(V),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?T.URI.from({scheme:D.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(V,U,z,...G){const F=[];if(Array.isArray(G)&&G.forEach(ie=>{T.URI.isUri(ie.uri)&&!F.some(oe=>S(oe.uri,ie.uri,this.s))&&F.push({uri:ie.uri,name:ie.name||(0,O.basenameOrAuthority)(ie.uri)})}),this.n||[U,z].some(ie=>typeof ie!="number"||ie<0)||z===0&&F.length===0)return!1;const $=this.x?this.x.workspaceFolders:[];if(U+z>$.length)return!1;const Y=$.slice(0);Y.splice(U,z,...F.map(ie=>({uri:ie.uri,name:ie.name||(0,O.basenameOrAuthority)(ie.uri),index:void 0})));for(let ie=0;ie<Y.length;ie++){const oe=Y[ie];if(Y.some((Ee,he)=>he!==ie&&S(oe.uri,Ee.uri,this.s)))return!1}Y.forEach((ie,oe)=>ie.index=oe);const{added:_,removed:Q}=m($,Y,u,this.s);if(_.length===0&&Q.length===0)return!1;if(this.o){const ie=V.displayName||V.name;this.o.$updateWorkspaceFolders(ie,U,z,F).then(void 0,oe=>{this.n=void 0;const Ee={source:{identifier:V.identifier,label:V.displayName||V.name}};this.q.$showMessage(d.Severity.Error,(0,I.localize)(0,null,ie,oe.toString()),Ee,[])})}return this.y(Y),!0}getWorkspaceFolder(V,U){if(this.x)return this.x.getWorkspaceFolder(V,U)}async getWorkspaceFolder2(V,U){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(V,U)}async resolveWorkspaceFolder(V){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(V)}getPath(){if(!this.x)return;const{folders:V}=this.x;if(V.length!==0)return V[0].uri.fsPath}getRelativePath(V,U){let z,G="";if(typeof V=="string"?(z=T.URI.file(V),G=V):typeof V<"u"&&(z=V,G=V.fsPath),!z)return G;const F=this.getWorkspaceFolder(z,!0);if(!F)return G;typeof U>"u"&&this.x&&(U=this.x.folders.length>1);let $=(0,O.relativePath)(F.uri,z);return U&&F.name&&($=`${F.name}/${$}`),$}y(V){this.x&&(this.n=n.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:V,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(V){const{workspace:U,added:z,removed:G}=n.toExtHostWorkspace(V,this.l,this.n,this.s);this.l=U||void 0,this.n=void 0,this.c.fire(Object.freeze({added:z,removed:G}))}findFiles(V,U,z,G,F=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${G.value}, entryPoint: findFiles`);let $;if(U===null?$=!1:U&&(typeof U=="string"?$=U:$=U.pattern),F&&F.isCancellationRequested)return Promise.resolve([]);const{includePattern:Y,folder:_}=M(t.GlobPattern.from(V));return this.o.$startFileSearch((0,E.withUndefinedAsNull)(Y),(0,E.withUndefinedAsNull)(_),(0,E.withUndefinedAsNull)($),(0,E.withUndefinedAsNull)(z),F).then(Q=>Array.isArray(Q)?Q.map(ie=>T.URI.revive(ie)):[])}async findTextInFiles(V,U,z,G,F=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${G.value}, entryPoint: findTextInFiles`);const $=this.j.getNext(),Y=typeof U.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:U.previewOptions,{includePattern:_,folder:Q}=M(t.GlobPattern.from(U.include)),ie=typeof U.exclude=="string"?U.exclude:U.exclude?U.exclude.pattern:void 0,oe={ignoreSymlinks:typeof U.followSymlinks=="boolean"?!U.followSymlinks:void 0,disregardIgnoreFiles:typeof U.useIgnoreFiles=="boolean"?!U.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof U.useGlobalIgnoreFiles=="boolean"?!U.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof U.useParentIgnoreFiles=="boolean"?!U.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof U.useDefaultExcludes=="boolean"?!U.useDefaultExcludes:!0,fileEncoding:U.encoding,maxResults:U.maxResults,previewOptions:Y,afterContext:U.afterContext,beforeContext:U.beforeContext,includePattern:_,excludePattern:ie},Ee=!1;if(this.u[$]=he=>{if(Ee)return;const fe=T.URI.revive(he.resource);he.results.forEach(x=>{(0,a.resultIsMatch)(x)?z({uri:fe,preview:{text:x.preview.text,matches:(0,o.mapArrayOrNot)(x.preview.matches,B=>new s.Range(B.startLineNumber,B.startColumn,B.endLineNumber,B.endColumn))},ranges:(0,o.mapArrayOrNot)(x.ranges,B=>new s.Range(B.startLineNumber,B.startColumn,B.endLineNumber,B.endColumn))}):z({uri:fe,text:x.text,lineNumber:x.lineNumber})})},F.isCancellationRequested)return{};try{const he=await this.o.$startTextSearch(V,(0,E.withUndefinedAsNull)(Q),oe,$,F);return delete this.u[$],he||{}}catch(he){throw delete this.u[$],he}}$handleTextSearchResult(V,U){this.u[U]?.(V)}async save(V){const U=await this.o.$save(V,{saveAs:!1});return T.URI.revive(U)}async saveAs(V){const U=await this.o.$save(V,{saveAs:!0});return T.URI.revive(U)}saveAll(V){return this.o.$saveAll(V)}resolveProxy(V){return this.o.$resolveProxy(V)}get trusted(){return this.v}requestWorkspaceTrust(V){return this.o.$requestWorkspaceTrust(V)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(V,U){if(this.w.has(V))throw new Error(`A provider has already been registered for scheme ${V}`);this.w.set(V,U);const z=this.t.transformOutgoingScheme(V),G=this.z++;return this.o.$registerEditSessionIdentityProvider(G,z),(0,A.toDisposable)(()=>{this.w.delete(V),this.o.$unregisterEditSessionIdentityProvider(G)})}async $getEditSessionIdentifier(V,U){this.h.info("Getting edit session identifier for workspaceFolder",V);const z=await this.resolveWorkspaceFolder(T.URI.revive(V));if(!z){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",z);const G=this.w.get(z.uri.scheme);if(this.h.info(`Provider for scheme ${z.uri.scheme} is defined: `,!!G),!G)return;const F=await G.provideEditSessionIdentity(z,U);if(this.h.info("Provider returned edit session identifier: ",F),!!F)return F}async $provideEditSessionIdentityMatch(V,U,z,G){this.h.info("Getting edit session identifier for workspaceFolder",V);const F=await this.resolveWorkspaceFolder(T.URI.revive(V));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const $=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!$),!$)return;const Y=await $.provideEditSessionIdentityMatch?.(U,z,G);if(this.h.info("Provider returned edit session identifier match result: ",Y),!!Y)return Y}getOnWillCreateEditSessionIdentityEvent(V){return(U,z,G)=>{const F=function(Y){U.call(z,Y)};return F.extension=V,this.A.event(F,void 0,G)}}async $onWillCreateEditSessionIdentity(V,U,z){const G=await this.resolveWorkspaceFolder(T.URI.revive(V));if(G===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:G},U,async(F,$)=>{const Y=Date.now();await Promise.resolve(F),Date.now()-Y>z&&this.h.warn("SLOW edit session create-participant",$.extension.identifier)}),U.isCancellationRequested}};e.ExtHostWorkspace=C=xe([We(0,g.IExtHostRpcService),We(1,w.IExtHostInitDataService),We(2,y.IExtHostFileSystemInfo),We(3,i.ILogService),We(4,r.IURITransformerService)],C),e.IExtHostWorkspace=(0,v.createDecorator)("IExtHostWorkspace");function M(H){let V,U;return H&&(typeof H=="string"?V=H:(V=H.pattern,U=T.URI.revive(H.baseUri))),{includePattern:V,folder:U}}}),define(Ce[35],ke([1,0,23,3,34,5,7,217,126,10,19,4,20,16,2]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function v(s,r){if(r){const a=r.split(".");let b=s;for(let S=0;b&&S<a.length;S++)b=b[a[S]];return b}}function i(s){return s instanceof I.URI}function d(s){return s&&s.uri instanceof I.URI&&s.languageId&&typeof s.languageId=="string"}function h(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function y(s){return s&&s.uri instanceof I.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function w(s){if(i(s))return{resource:s};if(d(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(h(s))return{overrideIdentifier:s.languageId};if(y(s))return{resource:s.uri};if(s===null)return{resource:null}}let g=e.ExtHostConfiguration=class{constructor(r,a,b){this.a=r.getProxy(L.MainContext.MainThreadConfiguration),this.c=a,this.b=b,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new t(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,a){this.getConfigProvider().then(b=>b.$acceptConfigurationChanged(r,a))}};e.ExtHostConfiguration=g=xe([We(0,E.IExtHostRpcService),We(1,l.IExtHostWorkspace),We(2,T.ILogService)],g);class t{constructor(r,a,b,S){this.a=new R.Emitter,this.b=r,this.f=S,this.c=a,this.e=P.Configuration.parse(b),this.d=this.k(b.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,a){const b={data:this.e.toData(),workspace:this.c.workspace};this.e=P.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(a,b))}getConfiguration(r,a,b){const S=w(a)||{},c=this.g(r?v(this.e.getValue(void 0,S,this.c.workspace),r):this.e.getValue(void 0,S,this.c.workspace));r&&this.h(r,S,b?.identifier);function u(f){if(f==null)return null;if(typeof f=="boolean")return f?2:5;switch(f){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(f){return typeof v(c,f)<"u"},get:(f,n)=>{this.h(r?`${r}.${f}`:f,S,b?.identifier);let C=v(c,f);if(typeof C>"u")C=n;else{let M;const H=(V,U)=>{if((0,p.isObject)(V)){let z;const G=()=>{M=M||(0,o.deepClone)(c),z=z||v(M,U)};return new Proxy(V,{get:(F,$)=>{if(typeof $=="string"&&$.toLowerCase()==="tojson")return G(),()=>z;if(M)return z=z||v(M,U),z[$];const Y=F[$];return typeof $=="string"?H(Y,`${U}.${$}`):Y},set:(F,$,Y)=>(G(),z&&(z[$]=Y),!0),deleteProperty:(F,$)=>(G(),z&&delete z[$],!0),defineProperty:(F,$,Y)=>(G(),z&&Object.defineProperty(z,$,Y),!0)})}return Array.isArray(V)?(0,o.deepClone)(V):V};C=H(C,f)}return C},update:(f,n,C,M)=>{f=r?`${r}.${f}`:f;const H=u(C);return n!==void 0?this.b.$updateConfigurationOption(H,f,n,S,M):this.b.$removeConfigurationOption(H,f,S,M)},inspect:f=>{f=r?`${r}.${f}`:f;const n=this.e.inspect(f,S,this.c.workspace);if(n)return{key:f,defaultValue:(0,o.deepClone)(n.policy?.value??n.default?.value),globalValue:(0,o.deepClone)(n.user?.value??n.application?.value),workspaceValue:(0,o.deepClone)(n.workspace?.value),workspaceFolderValue:(0,o.deepClone)(n.workspaceFolder?.value),defaultLanguageValue:(0,o.deepClone)(n.default?.override),globalLanguageValue:(0,o.deepClone)(n.user?.override??n.application?.override),workspaceLanguageValue:(0,o.deepClone)(n.workspace?.override),workspaceFolderLanguageValue:(0,o.deepClone)(n.workspaceFolder?.override),languageIds:(0,o.deepClone)(n.overrideIdentifiers)}}};return typeof c=="object"&&(0,o.mixin)(m,c,!1),Object.freeze(m)}g(r){const a=b=>(0,p.isObject)(b)?new Proxy(b,{get:(S,c)=>a(S[c]),set:(S,c,u)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(S,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(S,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:S=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):b;return a(r)}h(r,a,b){const S=D.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),c=b?`[${b.value}] `:"";if(S===4){typeof a?.resource>"u"&&this.f.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(S===3){a?.resource&&this.f.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,a){const b=new P.ConfigurationChangeEvent(r,a,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(S,c)=>b.affectsConfiguration(S,w(c))})}k(r){return r.reduce((a,b)=>(a.set(b[0],b[1]),a),new Map)}}e.ExtHostConfigProvider=t,e.IExtHostConfiguration=(0,k.createDecorator)("IExtHostConfiguration")});var _e=this&&this.__classPrivateFieldSet||function(ae,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!l:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(ae,o):l?l.value=o:e.set(ae,o),o},Be=this&&this.__classPrivateFieldGet||function(ae,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!R:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(ae):R?R.value:e.get(ae)};define(Ce[84],ke([1,0,2,19,3,5,7,34,60,35,21,42,20,26,4,17,14,16,79,258,8]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d,h,y,w){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var t;(function(V){function U(G){if(G!=null)return G}V.from=U;function z(G){if(G!=null)return G}V.to=z})(t||(t={}));var s;(function(V){function U(G){if(G!=null)return G}V.from=U;function z(G){if(G!=null)return G}V.to=z})(s||(s={}));var r;(function(V){function U(G){if(G!=null)return G}V.from=U;function z(G){if(G!=null)return G}V.to=z})(r||(r={}));var a;(function(V){function U(F){if(F){const $=F;return $&&!!$.process}else return!1}V.is=U;function z(F){if(F==null)return;const $={process:F.process,args:F.args};return F.options&&($.options=r.from(F.options)),$}V.from=z;function G(F){if(F!=null)return new A.ProcessExecution(F.process,F.args,F.options)}V.to=G})(a||(a={}));var b;(function(V){function U(G){if(G!=null)return G}V.from=U;function z(G){if(G!=null)return G}V.to=z})(b||(b={}));var S;(function(V){function U(F){if(F){const $=F;return $&&(!!$.commandLine||!!$.command)}else return!1}V.is=U;function z(F){if(F==null)return;const $={};return F.commandLine!==void 0?$.commandLine=F.commandLine:($.command=F.command,$.args=F.args),F.options&&($.options=b.from(F.options)),$}V.from=z;function G(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new A.ShellExecution(F.commandLine,F.options):new A.ShellExecution(F.command,F.args?F.args:[],F.options)}V.to=G})(S||(S={}));var c;(function(V){function U(F){if(F){const $=F;return $&&$.customExecution==="customExecution"}else return!1}V.is=U;function z(F){return{customExecution:"customExecution"}}V.from=z;function G(F,$){return $.get(F)}V.to=G})(c||(e.CustomExecutionDTO=c={}));var u;(function(V){function U(z,G){let F;return z.scope!==void 0&&typeof z.scope!="number"?F=z.scope.uri:z.scope!==void 0&&typeof z.scope=="number"&&(z.scope===A.TaskScope.Workspace&&G&&G.workspaceFile?F=G.workspaceFile:F=y.USER_TASKS_GROUP_KEY),{id:z._id,workspaceFolder:F}}V.from=U})(u||(e.TaskHandleDTO=u={}));var m;(function(V){function U(z){if(z!=null)return{_id:z.id,isDefault:z.isDefault}}V.from=U})(m||(m={}));var f;(function(V){function U(F,$){if(F==null)return[];const Y=[];for(const _ of F){const Q=z(_,$);Q&&Y.push(Q)}return Y}V.fromMany=U;function z(F,$){if(F==null)return;let Y;F.execution instanceof A.ProcessExecution?Y=a.from(F.execution):F.execution instanceof A.ShellExecution?Y=S.from(F.execution):F.execution&&F.execution instanceof A.CustomExecution&&(Y=c.from(F.execution));const _=t.from(F.definition);let Q;return F.scope?typeof F.scope=="number"?Q=F.scope:Q=F.scope.uri:Q=A.TaskScope.Workspace,!_||!Q?void 0:{_id:F._id,definition:_,name:F.name,source:{extensionId:$.identifier.value,label:F.source,scope:Q},execution:Y,isBackground:F.isBackground,group:m.from(F.group),presentationOptions:s.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}V.from=z;async function G(F,$,Y){if(F==null)return;let _;a.is(F.execution)?_=a.to(F.execution):S.is(F.execution)?_=S.to(F.execution):c.is(F.execution)&&(_=c.to(F._id,Y));const Q=t.to(F.definition);let ie;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?ie=F.source.scope:ie=await $.resolveWorkspaceFolder(o.URI.revive(F.source.scope)):ie=A.TaskScope.Workspace),!Q||!ie)return;const oe=new A.Task(Q,ie,F.name,F.source.label,_,F.problemMatchers);return F.isBackground!==void 0&&(oe.isBackground=F.isBackground),F.group!==void 0&&(oe.group=A.TaskGroup.from(F.group._id),oe.group&&F.group.isDefault&&(oe.group=new A.TaskGroup(oe.group.id,oe.group.label),F.group.isDefault===!0&&(oe.group.isDefault=F.group.isDefault))),F.presentationOptions&&(oe.presentationOptions=s.to(F.presentationOptions)),F._id&&(oe._id=F._id),F.detail&&(oe.detail=F.detail),oe}V.to=G})(f||(e.TaskDTO=f={}));var n;(function(V){function U(G){return G}V.from=U;function z(G){if(G)return Object.assign(Object.create(null),G)}V.to=z})(n||(n={}));class C{constructor(U,z,G){this._id=z,this.a=G,g.set(this,void 0),_e(this,g,U,"f")}get task(){return this.a}terminate(){Be(this,g,"f").terminateTask(this)}fireDidStartProcess(U){}fireDidEndProcess(U){}}g=new WeakMap;let M=e.ExtHostTaskBase=class{constructor(U,z,G,F,$,Y,_,Q){this.q=new l.Emitter,this.r=new l.Emitter,this.s=new l.Emitter,this.t=new l.Emitter,this.a=U.getProxy(L.MainContext.MainThreadTask),this.b=G,this.c=F,this.d=$,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=_,this.g=Q,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(U,z,G){if(!G)return new A.Disposable(()=>{});const F=this.w();return this.j.set(F,{type:z,provider:G,extension:U}),this.a.$registerTaskProvider(F,z),new A.Disposable(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(U,z){this.a.$registerTaskSystem(U,z)}fetchTasks(U){return this.a.$fetchTasks(n.from(U)).then(async z=>{const G=[];for(const F of z){const $=await f.to(F,this.b,this.m);$&&G.push($)}return G})}get taskExecutions(){const U=[];return this.k.forEach(z=>U.push(z)),U}terminateTask(U){if(!(U instanceof C))throw new Error("No valid task execution provided");return this.a.$terminateTask(U._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(U,z,G){const F=this.m.get(U.id);F&&(this.o.set(U.id,F),this.e.attachPtyToTerminal(z,await F.callback(G))),this.p=U.id,this.q.fire({execution:await this.y(U)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(U){const z=await this.y(U);this.l.delete(U.id),this.k.delete(U.id),this.A(U),this.r.fire({execution:z})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(U){const z=await this.y(U.id);this.s.fire({execution:z,processId:U.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(U){const z=await this.y(U.id);this.t.fire({execution:z,exitCode:U.exitCode})}$provideTasks(U,z){const G=this.j.get(U);if(!G)return Promise.reject(new Error("no handler found"));const F=[],$=(0,R.asPromise)(()=>G.provider.provideTasks(O.CancellationToken.None)).then(Y=>this.u(z,F,G,Y));return new Promise(Y=>{$.then(_=>{Promise.all(F).then(()=>{Y(_)})})})}async $resolveTask(U,z){const G=this.j.get(U);if(!G)return Promise.reject(new Error("no handler found"));if(z.definition.type!==G.type)throw new Error(`Unexpected: Task of type [${z.definition.type}] cannot be resolved by provider of type [${G.type}].`);const F=await f.to(z,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const $=await G.provider.resolveTask(F,O.CancellationToken.None);if(!$)return;this.z($,G);const Y=f.from($,G.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if($.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(Y.execution)&&await this.x(Y,$,!0),await this.v(Y)}w(){return this.h++}async x(U,z,G){const F=await this.a.$createTaskId(U);!G&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,z.execution)),this.m.set(F,z.execution)}async y(U,z){if(typeof U=="string"){const $=this.l.get(U);if(!$)throw new w.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return $}const G=this.l.get(U.id);if(G)return G;const F=new Promise(($,Y)=>{function _(Q,ie,oe){oe?$(new C(Q,ie.id,oe)):Y("Unexpected: Task does not exist.")}z?_(this,U,z):f.to(U.task,this.b,this.m).then(Q=>_(this,U,Q))});return this.l.set(U.id,F),F.then($=>(this.k.set(U.id,$),$),$=>Promise.reject($))}z(U,z){U._deprecated&&this.g.report("Task.constructor",z.extension,"Use the Task constructor that takes a `scope` instead.")}A(U){this.o.get(U.id)&&this.o.delete(U.id),this.n.has(U.id)&&this.p!==U.id&&(this.m.delete(U.id),this.n.delete(U.id));const G=this.n.values();let F=G.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=G.next()}};e.ExtHostTaskBase=M=xe([We(0,E.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,p.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,d.ILogService),We(7,h.IExtHostApiDeprecationService)],M);let H=e.WorkerExtHostTask=class extends M{constructor(U,z,G,F,$,Y,_,Q){super(U,z,G,F,$,Y,_,Q),this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:i.PlatformToString(0)})}async executeTask(U,z){if(!z.execution)throw new Error("Tasks to execute must include an execution");const G=f.from(z,U);if(G===void 0)throw new Error("Task is not valid");if(c.is(G.execution))await this.x(G,z,!1);else throw new w.NotSupportedError;const F=await this.y(await this.a.$getTaskExecution(G),z);return this.a.$executeTask(G).catch($=>{throw new Error($)}),F}u(U,z,G,F){const $=[];if(F)for(const Y of F){this.z(Y,G),(!Y.definition||!U[Y.definition.type])&&this.f.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const _=f.from(Y,G.extension);_&&c.is(_.execution)?($.push(_),z.push(this.x(_,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:$,extension:G.extension}}async v(U){if(c.is(U.execution))return U;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(U,z){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(U,z,G){}};e.WorkerExtHostTask=H=xe([We(0,E.IExtHostRpcService),We(1,T.IExtHostInitDataService),We(2,P.IExtHostWorkspace),We(3,D.IExtHostDocumentsAndEditors),We(4,p.IExtHostConfiguration),We(5,k.IExtHostTerminalService),We(6,d.ILogService),We(7,h.IExtHostApiDeprecationService)],H),e.IExtHostTask=(0,I.createDecorator)("IExtHostTask")}),define(Ce[307],ke([1,0,15,21,46,39,24,37,31]),function(ae,e,o,R,l,L,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class p{constructor(E,T,I){this.k=E,this.l=T,this.o=I,this.e=!1,this.f=0,this.g=!1,this.a=E.filePattern,this.b=E.includePattern&&L.parse(E.includePattern),this.c=E.maxResults||void 0,this.d=E.exists,this.h=new Set,this.j=E.excludePattern&&L.parse(E.excludePattern)}cancel(){this.g=!0,this.h.forEach(E=>E.cancel()),this.h=new Set}search(E){const T=this.k.folderQueries||[];return new Promise((I,v)=>{const i=d=>{this.f++,E(d)};if(this.g)return I({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(d=>{const h=d.toString(),y=o.basename(h);this.j&&this.j(h,y)||this.v(i,{base:d,basename:y})}),Promise.all(T.map(d=>this.p(d,i))).then(d=>{I({limitHit:this.e,stats:d[0]||void 0})},d=>{v(new Error((0,l.toErrorMessage)(d)))})})}async p(E,T){const I=new R.CancellationTokenSource,v=this.q(E),i=this.r(),d=new D.QueryGlobTester(this.k,E),h=!d.hasSiblingExcludeClauses();let y;try{this.h.add(I),y=P.StopWatch.create();const w=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},v,I.token),g=y.elapsed(),t=P.StopWatch.create();return this.g&&!this.e||(w&&w.forEach(s=>{const r=o.posix.relative(E.folder.path,s.path);if(h){const a=o.basename(s.path);this.v(T,{base:E.folder,relativePath:r,basename:a});return}this.s(i,E.folder,r,T)}),this.g&&!this.e)?null:(this.u(i,d,T),{providerTime:g,postProcessTime:t.elapsed()})}finally{I.dispose(),this.h.delete(I)}}q(E){const T=(0,D.resolvePatternsForProvider)(this.k.includePattern,E.includePattern),I=(0,D.resolvePatternsForProvider)(this.k.excludePattern,E.excludePattern);return{folder:E.folder,excludes:I,includes:T,useIgnoreFiles:!E.disregardIgnoreFiles,useGlobalIgnoreFiles:!E.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!E.disregardParentIgnoreFiles,followSymlinks:!E.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const E={rootEntries:[],pathToEntries:Object.create(null)};return E.pathToEntries["."]=E.rootEntries,E}s({pathToEntries:E},T,I,v){if(I===this.a){const d=o.basename(this.a);this.v(v,{base:T,relativePath:this.a,basename:d})}function i(d){const h=o.basename(d),y=o.dirname(d);let w=E[y];w||(w=E[y]=[],i(y)),w.push({base:T,relativePath:d,basename:h})}i(I)}u({rootEntries:E,pathToEntries:T},I,v){const i=this,d=this.a;function h(y){const w=(0,D.hasSiblingFn)(()=>y.map(g=>g.basename));for(let g=0,t=y.length;g<t;g++){const s=y[g],{relativePath:r,basename:a}=s;if(I.matchesExcludesSync(r,a,d!==a?w:void 0))continue;const b=T[r];if(b)h(b);else{if(r===d)continue;i.v(v,s)}if(i.e)break}}h(E)}v(E,T){(!this.b||T.relativePath&&this.b(T.relativePath,T.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||E(T))}}class O{constructor(){this.b=new Map}fileSearch(E,T,I,v){const i=this.c(E.cacheKey),d=new p(E,T,i&&i.token);let h=0;const y=w=>{h+=w.length,I(w.map(g=>this.d(g)))};return this.e(d,O.a,y,v).then(w=>({limitHit:w.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:h,detailStats:w.stats}}))}clearCache(E){this.c(E)?.cancel()}c(E){if(E)return this.b.has(E)||this.b.set(E,new R.CancellationTokenSource),this.b.get(E)}d(E){return E.relativePath?{resource:A.joinPath(E.base,E.relativePath)}:{resource:E.base}}e(E,T,I,v){v.onCancellationRequested(()=>{E.cancel()});const i=h=>{h&&(d.push(h),T>0&&d.length>=T&&(I(d),d=[]))};let d=[];return E.search(i).then(h=>(d.length&&I(d),h),h=>(d.length&&I(d),Promise.reject(h)))}}e.FileSearchManager=O,O.a=512}),define(Ce[308],ke([1,0,18,62,39,114,28,17,15,24,9,10,2,169,204,55,16,48,134,306,31]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d,h,y,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=e.QueryBuilder=class{constructor(f,n,C,M,H){this.a=f,this.b=n,this.c=C,this.d=M,this.e=H}text(f,n,C={}){f=this.f(f,C);const M=this.a.getValue(),H=n&&n.some(U=>!this.a.getValue({resource:U}).search.useRipgrep);return{...this.h(n?.map(d.toWorkspaceFolder),C),type:2,contentPattern:f,previewOptions:C.previewOptions,maxFileSize:C.maxFileSize,usePCRE2:M.search.usePCRE2||H||!1,beforeContext:C.beforeContext,afterContext:C.afterContext,userDisabledExcludesAndIgnoreFiles:C.disregardExcludeSettings&&C.disregardIgnoreFiles}}f(f,n){const C=this.a.getValue();f.isRegExp&&(f.pattern=f.pattern.replace(/\r?\n/g,"\\n"));const M={...f,wordSeparators:C.editor.wordSeparators};return this.j(f,n)&&(M.isCaseSensitive=!0),this.k(f)&&(M.isMultiline=!0),n.notebookSearchConfig?.includeMarkupInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookMarkdownInput=n.notebookSearchConfig.includeMarkupInput),n.notebookSearchConfig?.includeCodeInput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellInput=n.notebookSearchConfig.includeCodeInput),n.notebookSearchConfig?.includeOutput&&(M.notebookInfo||(M.notebookInfo={}),M.notebookInfo.isInNotebookCellOutput=n.notebookSearchConfig.includeOutput),M}file(f,n={}){return{...this.h(f,n),type:1,filePattern:n.filePattern?n.filePattern.trim():n.filePattern,exists:n.exists,sortByScore:n.sortByScore,cacheKey:n.cacheKey}}g(f,n){return f?(f=Array.isArray(f)?f.map(b):b(f),n?this.parseSearchPaths(f):{pattern:s(...Array.isArray(f)?f:[f])}):{}}h(f=[],n={}){const C=this.g(n.includePattern,n.expandPatterns),M=this.g(n.excludePattern,n.expandPatterns),H=f.length>1,V=(C.searchPaths&&C.searchPaths.length?C.searchPaths.map(G=>this.q(G,n,M)):f.map(G=>this.r(G,n,M,H))).filter(G=>!!G),U={_reason:n._reason,folderQueries:V,usingSearchPaths:!!(C.searchPaths&&C.searchPaths.length),extraFileResources:n.extraFileResources,excludePattern:M.pattern,includePattern:C.pattern,onlyOpenEditors:n.onlyOpenEditors,maxResults:n.maxResults};if(n.onlyOpenEditors){const G=o.coalesce(o.flatten(this.c.groups.map(Y=>Y.editors.map(_=>_.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(G));const F=G.filter(Y=>(0,w.pathIncludedInQuery)(U,Y.fsPath)),$=this.i(F);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify($)),{...U,...$}}const z=n.extraFileResources&&n.extraFileResources.filter(G=>(0,w.pathIncludedInQuery)(U,G.fsPath));return U.extraFileResources=z&&z.length?z:void 0,U}i(f){const n=[],C=new A.ResourceMap,M={};let H=!1;return f.forEach(V=>{if(V.scheme===P.Schemas.walkThrough)return;if((0,p.isAbsolutePath)(V)){const z=this.b.getWorkspaceFolder(V)?.uri??V.with({path:D.dirname(V.fsPath)});let G=C.get(z);G||(H=!0,G={folder:z,includePattern:{}},n.push(G),C.set(z,G));const F=D.relative(z.fsPath,V.fsPath);(0,k.assertIsDefined)(G.includePattern)[F.replace(/\\/g,"/")]=!0}else V.fsPath&&(H=!0,M[V.fsPath]=!0)}),{folderQueries:n,includePattern:M,usingSearchPaths:!0,excludePattern:H?void 0:{"**/*":!0}}}j(f,n){if(n.isSmartCase){if(f.isRegExp){if(O.containsUppercaseCharacter(f.pattern,!0))return!0}else if(O.containsUppercaseCharacter(f.pattern))return!0}return!!f.isCaseSensitive}k(f){return f.isMultiline||f.isRegExp&&(0,T.isMultilineRegexSource)(f.pattern)||f.pattern.indexOf(`
`)>=0?!0:!!f.isMultiline}parseSearchPaths(f){const n=$=>D.isAbsolute($)||/^\.\.?([\/\\]|$)/.test($),M=(Array.isArray(f)?f:r(f)).map($=>{const Y=this.e.resolvedUserHome;return Y?(0,L.untildify)($,Y.scheme===P.Schemas.file?Y.fsPath:Y.path):$}),H=R.groupBy(M,$=>n($)?"searchPaths":"exprSegments"),V=(H.exprSegments||[]).map($=>O.rtrim($,"/")).map($=>O.rtrim($,"\\")).map($=>($[0]==="."&&($="*"+$),a($))),U={},z=this.m(H.searchPaths||[]);z&&z.length&&(U.searchPaths=z);const G=o.flatten(V),F=s(...G);return F&&(U.pattern=F),U}l(f,n){return n.disregardExcludeSettings?void 0:(0,w.getExcludes)(f,!n.disregardSearchExcludeSettings)}m(f){if(!f||!f.length)return[];const n=f.flatMap(M=>{let{pathPortion:H,globPortion:V}=t(M);return V&&(V=S(V)),this.n(H).flatMap(z=>this.o(z,V))}),C=new Map;return n.forEach(M=>{const H=M.searchPath.toString(),V=C.get(H);V?M.pattern&&(V.pattern=V.pattern||{},V.pattern[M.pattern]=!0):C.set(H,{searchPath:M.searchPath,pattern:M.pattern?s(M.pattern):void 0})}),Array.from(C.values())}n(f){if(D.isAbsolute(f)){const n=this.b.getWorkspace().folders;return n[0]&&n[0].uri.scheme!==P.Schemas.file?[{searchPath:n[0].uri.with({path:f})}]:[{searchPath:E.URI.file(D.normalize(f))}]}if(this.b.getWorkbenchState()===2){const n=this.b.getWorkspace().folders[0].uri;if(f=b(f),f.startsWith("../")||f===".."){const M=D.posix.resolve(n.path,f);return[{searchPath:n.with({path:M})}]}const C=S(f);return[{searchPath:n,pattern:C}]}else{if(f==="./"||f===".\\")return[];{const n=f.replace(/^\.[\/\\]/,""),M=this.b.getWorkspace().folders.map(H=>{const V=n.match(new RegExp(`^${O.escapeRegExpCharacters(H.name)}(?:/(.*)|$)`));return V?{match:V,folder:H}:null}).filter(k.isDefined);if(M.length)return M.map(H=>{const V=H.match[1];return{searchPath:H.folder.uri,pattern:V&&S(V)}});{const H=f.match(/\.[\/\\](.+)[\/\\]?/),V=H?H[1]:f,U=I.localize(0,null,V);throw new Error(U)}}}}o(f,n){const C=f.pattern&&n?`${f.pattern}/${n}`:f.pattern||n,M=[{searchPath:f.searchPath,pattern:C}];return C&&!C.endsWith("**")&&M.push({searchPath:f.searchPath,pattern:C+"/**"}),M}q(f,n,C){const M=this.r((0,d.toWorkspaceFolder)(f.searchPath),n,C,!1);return M?{...M,includePattern:f.pattern}:null}r(f,n,C,M){let H;const V=E.URI.isUri(f)?f:f.uri;if(C.searchPaths){const $=C.searchPaths.filter(Y=>(0,p.isEqual)(Y.searchPath,V))[0];if($&&!$.pattern)return null;$&&(H=$.pattern)}const U=this.a.getValue({resource:V}),G={...this.l(U,n)||{},...H||{}},F=E.URI.isUri(f)?(0,p.basename)(f):f.name;return{folder:V,folderName:M?F:void 0,excludePattern:Object.keys(G).length>0?G:void 0,fileEncoding:U.files&&U.files.encoding,disregardIgnoreFiles:typeof n.disregardIgnoreFiles=="boolean"?n.disregardIgnoreFiles:!U.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof n.disregardGlobalIgnoreFiles=="boolean"?n.disregardGlobalIgnoreFiles:!U.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof n.disregardParentIgnoreFiles=="boolean"?n.disregardParentIgnoreFiles:!U.search.useParentIgnoreFiles,ignoreSymlinks:typeof n.ignoreSymlinks=="boolean"?n.ignoreSymlinks:!U.search.followSymlinks}}};e.QueryBuilder=g=xe([We(0,v.IConfigurationService),We(1,d.IWorkspaceContextService),We(2,h.IEditorGroupsService),We(3,i.ILogService),We(4,y.IPathService)],g);function t(m){const f=m.match(/[\*\{\}\(\)\[\]\?]/);if(f){const n=f.index,C=m.substr(0,n).match(/[/|\\][^/\\]*$/);if(C){let M=m.substr(0,C.index);return M.match(/[/\\]/)||(M+="/"),{pathPortion:M,globPortion:m.substr((C.index||0)+1)}}}return{pathPortion:m}}function s(...m){return m.length?m.reduce((f,n)=>(f[n]=!0,f),Object.create(null)):void 0}function r(m){return l.splitGlobAware(m,",").map(f=>f.trim()).filter(f=>!!f.length)}function a(m){return[`**/${m}/**`,`**/${m}`].map(n=>n.replace(/\*\*\/\*\*/g,"**"))}function b(m){return m.replace(/\\/g,"/")}function S(m){return b(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(m){return m.replace(/([?*[\]])/g,"[$1]")}function u(m,f){m=o.distinct(m,M=>M.toString());const n=[],C=f.getWorkspace();return m&&m.forEach(M=>{let H;if(f.getWorkbenchState()===2)H=(0,p.relativePath)(C.folders[0].uri,M),H&&H!=="."&&(H="./"+H);else{const V=f.getWorkspaceFolder(M);if(V){const U=V.name;if(C.folders.filter(G=>G.name===U).length===1){const G=(0,p.relativePath)(V.uri,M);G===""?H=`./${V.name}`:H=`./${V.name}/${G}`}else H=M.fsPath}}H&&n.push(c(H))}),n}e.resolveResourcesForSearchIncludes=u}),define(Ce[309],ke([1,0,24,2,21,8,4,308,31,48]),function(ae,e,o,R,l,L,A,P,D,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function k(v,i){const d=i.activationEvents;if(!d)return Promise.resolve(void 0);const h=[],y=[];for(const a of d)if(/^workspaceContains:/.test(a)){const b=a.substr(18);b.indexOf("*")>=0||b.indexOf("?")>=0||v.forceUsingSearch?y.push(b):h.push(b)}if(h.length===0&&y.length===0)return Promise.resolve(void 0);let w;const g=new Promise((a,b)=>{w=a}),t=a=>w({activationEvent:a}),s=Promise.all(h.map(a=>E(v,a,t))).then(()=>{}),r=T(v,i.identifier,y,t);return Promise.all([s,r]).then(()=>{w(void 0)}),g}e.checkActivateWorkspaceContainsExtension=k;async function E(v,i,d){for(const h of v.folders)if(await v.exists(o.joinPath(R.URI.revive(h),i))){d(`workspaceContains:${i}`);return}}async function T(v,i,d,h){if(d.length===0)return Promise.resolve(void 0);const y=new l.CancellationTokenSource,w=v.checkExists(v.folders,d,y.token),g=setTimeout(async()=>{y.cancel(),v.logService.info(`Not activating extension '${i.value}': Timed out while searching for 'workspaceContains' pattern ${d.join(",")}`)},O);let t=!1;try{t=await w}catch(s){L.isCancellationError(s)||L.onUnexpectedError(s)}y.dispose(),clearTimeout(g),t&&h(`workspaceContains:${d.join(",")}`)}function I(v,i,d,h){const y=v.get(A.IInstantiationService),w=v.get(D.ISearchService),t=y.createInstance(P.QueryBuilder).file(i.map(s=>(0,p.toWorkspaceFolder)(R.URI.revive(s))),{_reason:"checkExists",includePattern:d,exists:!0});return w.fileSearch(t,h).then(s=>!!s.limitHit,s=>L.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=I});var _e=this&&this.__classPrivateFieldSet||function(ae,e,o,R,l){if(R==="m")throw new TypeError("Private method is not writable");if(R==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?ae!==e||!l:!e.has(ae))throw new TypeError("Cannot write private member to an object whose class did not declare it");return R==="a"?l.call(ae,o):l?l.value=o:e.set(ae,o),o},Be=this&&this.__classPrivateFieldGet||function(ae,e,o,R){if(o==="a"&&!R)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?ae!==e||!R:!e.has(ae))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?R:o==="a"?R.call(ae):R?R.value:e.get(ae)};define(Ce[43],ke([1,0,183,15,85,24,19,6,69,2,16,5,35,247,100,34,27,135,8,25,22,228,7,127,4,26,81,20,92,56,42,3,309,99,230,17,98,37,14]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d,h,y,w,g,t,s,r,a,b,S,c,u,m,f,n,C,M,H,V,U,z){"use strict";var G,F,$;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let Y=e.AbstractExtHostExtensionService=class kn extends P.Disposable{constructor(x,B,Z,pe,Se,re,ne,de,ee,ce,le){super(),this.a=this.B(new f.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=B,this.g=Z,this.f=ne,this.j=pe,this.k=Se,this.l=re,this.m=ee,this.p=ce,this.s=le,this.t=this.g.getProxy(k.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(k.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(k.MainContext.MainThreadExtensionService),this.w=new A.Barrier,this.y=new A.Barrier,this.z=new A.Barrier,this.C=new A.Barrier,this.D=new he(this.f.activationEvents),this.G=new d.ExtensionDescriptionRegistry(this.D,this.f.allExtensions);const ue=new y.ExtensionIdentifierSet(this.f.myExtensions);this.F=new d.ExtensionDescriptionRegistry(this.D,oe(this.G,ue)),this.H=new I.ExtHostStorage(this.g,this.l),this.I=new C.ExtHostSecretState(this.g),this.J=de,this.h=x.createChild(new c.ServiceCollection([I.IExtHostStorage,this.H],[C.IExtHostSecretState,this.I])),this.L=this.B(new T.ExtensionsActivator(this.F,this.G,{onExtensionActivationError:(N,q,J)=>{this.v.$onExtensionActivationError(N,h.transformErrorForSerialization(q),J)},actualActivateExtension:async(N,q)=>{if(d.ExtensionDescriptionRegistry.isHostExtension(N,this.F,this.G))return await this.v.$activateExtension(N,q),new T.HostExtension;const J=this.F.getExtensionDescription(N);return this.Z(J,q)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),l.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(x){h.onUnexpectedError(x)}}async R(){this.J.onWillDeactivateAll();let x=[];try{x=this.F.getAllExtensionDescriptions().map(Se=>Se.identifier).filter(Se=>this.isActivated(Se)).map(Se=>this.Y(Se))}catch{}await Promise.all(x)}terminate(x,B=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${x}`),this.l.flush(),this.p.dispose(),this.L.dispose(),h.setUnexpectedErrorHandler(pe=>{this.l.error(pe)}),this.g.dispose();const Z=this.R();Promise.race([(0,A.timeout)(5e3),Z]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${B}`):this.l.info(`Extension host exiting with code ${B}`),this.l.flush(),this.l.dispose(),this.c.exit(B)})}isActivated(x){return this.z.isOpen()?this.L.isActivated(x):!1}async getExtension(x){const B=await this.v.$getExtension(x);return B&&{...B,identifier:new y.ExtensionIdentifier(B.identifier.value),extensionLocation:p.URI.revive(B.extensionLocation)}}S(x,B){return this.L.activateByEvent(x,B)}U(x,B){return this.L.activateById(x,B)}activateByIdWithErrors(x,B){return this.U(x,B).then(()=>{const Z=this.L.getActivatedExtension(x);if(Z.activationFailed)return Promise.reject(Z.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(x=>this.F)}getExtensionExports(x){return this.z.isOpen()?this.L.getActivatedExtension(x).exports:null}async W(x){if(x.scheme!==H.Schemas.file)return x;const B=await this.c.realpath(x.fsPath);return p.URI.file(B)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(x=>new Ee(x))),this.M}async X(x){const B=D.TernarySearchTree.forUris(Z=>L.extUriBiasedIgnorePathCase.ignorePathCasing(Z));return await Promise.all(x.map(async Z=>{if(this.qb(Z)){const pe=await this.W(Z.extensionLocation);B.set(pe,Z)}})),B}Y(x){let B=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(x))return B;const Z=this.L.getActivatedExtension(x);if(!Z)return B;try{typeof Z.module.deactivate=="function"&&(B=Promise.resolve(Z.module.deactivate()).then(void 0,pe=>(this.l.error(pe),Promise.resolve(void 0))))}catch(pe){this.l.error(`An error occurred when deactivating the extension '${x.value}':`),this.l.error(pe)}try{(0,P.dispose)(Z.subscriptions)}catch(pe){this.l.error(`An error occurred when deactivating the subscriptions for extension '${x.value}':`),this.l.error(pe)}return B}async Z(x,B){return this.f.remote.isRemote?this.v.$onWillActivateExtension(x.identifier):await this.v.$onWillActivateExtension(x.identifier),this.bb(x,B).then(Z=>{const pe=Z.activationTimes;return this.v.$onDidActivateExtension(x.identifier,pe.codeLoadingTime,pe.activateCallTime,pe.activateResolvedTime,B),this.ab(x,B,"success",pe),Z},Z=>{throw this.ab(x,B,"failure"),Z})}ab(x,B,Z,pe){const Se=Q(x,B);this.u.$publicLog2("extensionActivationTimes",{...Se,...pe||{},outcome:Z})}bb(x,B){const Z=Q(x,B);this.u.$publicLog2("activatePlugin",Z);const pe=this.qb(x);if(!pe)return Promise.resolve(new T.EmptyExtension(T.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${x.identifier.value}, startup: ${B.startup}, activationEvent: '${B.activationEvent}'${x.identifier.value!==B.extensionId.value?`, root cause: ${B.extensionId.value}`:""}`),this.l.flush();const Se=new T.ExtensionActivationTimesBuilder(B.startup);return Promise.all([this.rb(x,(0,L.joinPath)(x.extensionLocation,pe),Se),this.cb(x)]).then(re=>(l.mark(`code/extHost/willActivateExtension/${x.identifier.value}`),kn.db(this.l,x.identifier,re[0],re[1],Se))).then(re=>(l.mark(`code/extHost/didActivateExtension/${x.identifier.value}`),re))}cb(x){const B=new g.ExtensionGlobalMemento(x,this.H),Z=new g.ExtensionMemento(x.identifier.value,!1,this.H),pe=new M.ExtensionSecrets(x,this.I),Se=x.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?t.ExtensionMode.Test:t.ExtensionMode.Development:t.ExtensionMode.Production,re=this.f.remote.isRemote?t.ExtensionKind.Workspace:t.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${x.identifier.value}`),Promise.all([B.whenReady,Z.whenReady,this.J.whenReady]).then(()=>{const ne=this;let de,ee;const ce=(0,i.isProposedApiEnabled)(x,"ipc")?this.f.messagePorts?.get(y.ExtensionIdentifier.toKey(x.identifier)):void 0;return Object.freeze({globalState:B,workspaceState:Z,secrets:pe,subscriptions:[],get extensionUri(){return x.extensionLocation},get extensionPath(){return x.extensionLocation.fsPath},asAbsolutePath(le){return R.join(x.extensionLocation.fsPath,le)},get storagePath(){return ne.J.workspaceValue(x)?.fsPath},get globalStoragePath(){return ne.J.globalValue(x).fsPath},get logPath(){return R.join(ne.f.logsLocation.fsPath,x.identifier.value)},get logUri(){return p.URI.joinPath(ne.f.logsLocation,x.identifier.value)},get storageUri(){return ne.J.workspaceValue(x)},get globalStorageUri(){return ne.J.globalValue(x)},get extensionMode(){return Se},get extension(){return de===void 0&&(de=new ie(ne,x.identifier,x,re,!1)),de},get extensionRuntime(){return(0,i.checkProposedApiEnabled)(x,"extensionRuntime"),ne.extensionRuntime},get environmentVariableCollection(){return ne.p.getEnvironmentVariableCollection(x)},get messagePassingProtocol(){if(!ee){if(!ce)return;const le=f.Event.buffer(f.Event.fromDOMEventEmitter(ce,"message",ue=>ue.data));ce.start(),ee={onDidReceiveMessage:le,postMessage:ce.postMessage.bind(ce)}}return ee}})})}static db(x,B,Z,pe,Se){return Z=Z||{activate:void 0,deactivate:void 0},this.eb(x,B,Z,pe,Se).then(re=>new T.ActivatedExtension(!1,null,Se.build(),Z,re,pe.subscriptions))}static eb(x,B,Z,pe,Se){if(typeof Z.activate=="function")try{Se.activateCallStart(),x.trace(`ExtensionService#_callActivateOptional ${B.value}`);const re=typeof global=="object"?global:self,ne=Z.activate.apply(re,[pe]);return Se.activateCallStop(),Se.activateResolveStart(),Promise.resolve(ne).then(de=>(Se.activateResolveStop(),de))}catch(re){return Promise.reject(re)}else return Promise.resolve(Z)}fb(x,B){this.U(x.identifier,{startup:!1,extensionId:x.identifier,activationEvent:B}).then(void 0,Z=>{this.l.error(Z)})}gb(x,B=0){const pe=Date.now();(0,z.setTimeout0)(()=>{for(let Se=B;Se<x.length;Se+=1){const re=x[Se];for(const ne of re.activationEvents??[])if(ne==="onStartupFinished")if(Date.now()-pe>50){this.gb(x,Se);break}else this.fb(re,ne)}})}hb(){this.v.$setPerformanceMarks(l.getMarks()),this.k.getConfigProvider().then(x=>{const B=x.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Z=this.F.getAllExtensionDescriptions();if(B)this.gb(Z);else for(const pe of Z)if(pe.activationEvents)for(const Se of pe.activationEvents)Se==="onStartupFinished"&&this.fb(pe,Se)})}ib(){const x=this.S("*",!0).then(void 0,re=>{this.l.error(re)});this.B(this.j.onDidChangeWorkspace(re=>this.jb(re.added)));const B=this.j.workspace?this.j.workspace.folders:[],Z=this.jb(B),pe=this.lb(),Se=Promise.all([pe,x,Z]).then(()=>{});return Promise.race([Se,(0,A.timeout)(1e4)]).then(()=>{this.hb()}),Se}jb(x){return x.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(B=>this.kb(x,B))).then(()=>{})}async kb(x,B){if(this.isActivated(B.identifier))return;const Z=!this.f.remote.isRemote&&!!this.f.remote.authority,pe={logService:this.l,folders:x.map(re=>re.uri),forceUsingSearch:Z,exists:re=>this.c.exists(re.fsPath),checkExists:(re,ne,de)=>this.t.$checkExists(re,ne,de)},Se=await(0,n.checkActivateWorkspaceContainsExtension)(pe,B);if(Se)return this.U(B.identifier,{startup:!0,extensionId:B.identifier,activationEvent:Se.activationEvent}).then(void 0,re=>this.l.error(re))}async lb(){if(this.f.remote.authority)return this.S(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(x){throw console.error(x),x}}async mb(){const{extensionDevelopmentLocationURI:x,extensionTestsLocationURI:B}=this.f.environment;if(!x||!B)throw new Error(o.localize(0,null));const Z=await this.rb(null,B,new T.ExtensionActivationTimesBuilder(!1));if(!Z||typeof Z.run!="function")throw new Error(o.localize(1,null,B.toString()));return new Promise((pe,Se)=>{const re=(ee,ce)=>{ee?Se(ee):pe(typeof ce=="number"&&ce>0?1:0)},ne=(0,L.originalFSPath)(B),de=Z.run(ne,re);de&&de.then&&de.then(()=>{pe(0)}).catch(ee=>{Se(ee instanceof Error&&ee.stack?ee.stack:String(ee))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,A.timeout)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(x,B){return this.N[x]=B,(0,P.toDisposable)(()=>{delete this.N[x]})}async ob(x){const B=x.indexOf("+");if(B===-1)throw new Error("Not an authority that can be resolved!");const Z=x.substr(0,B);return await this.w.wait(),await this.S(`onResolveRemoteAuthority:${Z}`,!1),{authorityPrefix:Z,resolver:this.N[Z]}}async $resolveAuthority(x,B){const Z=U.StopWatch.create(!1),pe=()=>`[resolveAuthority(${(0,s.getRemoteAuthorityPrefix)(x)},${B})][${Z.elapsed()}ms] `,Se=ce=>this.l.info(`${pe()}${ce}`),re=(ce,le=void 0)=>this.l.error(`${pe()}${ce}`,le);Se("activating resolver...");const{authorityPrefix:ne,resolver:de}=await this.ob(x);if(!de)return re("no resolver"),{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${ne}.`,detail:void 0}};const ee=new A.IntervalTimer;try{Se("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(de)),ee.cancelAndSet(()=>Se("waiting..."),1e3),Se("invoking resolve()..."),l.mark(`code/extHost/willResolveAuthority/${ne}`);const ce=await de.resolve(x,{resolveAttempt:B});l.mark(`code/extHost/didResolveAuthorityOK/${ne}`),ee.dispose(),Se(`returned ${ce.host}:${ce.port}`);const le={authority:x,host:ce.host,port:ce.port,connectionToken:ce.connectionToken},ue={extensionHostEnv:ce.extensionHostEnv,isTrusted:ce.isTrusted,authenticationSession:ce.authenticationSessionForInitializingExtensions?{id:ce.authenticationSessionForInitializingExtensions.id,providerId:ce.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:le,options:ue,tunnelInformation:{environmentTunnels:ce.environmentTunnels,features:ce.tunnelFeatures}}}}catch(ce){if(l.mark(`code/extHost/didResolveAuthorityError/${ne}`),ee.dispose(),re("returned an error",ce),ce instanceof t.RemoteAuthorityResolverError)return{type:"error",error:{code:ce._code,message:ce._message,detail:ce._detail}};throw ce}}async $getCanonicalURI(x,B){this.l.info(`$getCanonicalURI invoked for authority (${(0,s.getRemoteAuthorityPrefix)(x)})`);const{resolver:Z}=await this.ob(x);if(!Z)return null;const pe=p.URI.revive(B);if(typeof Z.getCanonicalURI>"u")return pe;const Se=await(0,A.asPromise)(()=>Z.getCanonicalURI(pe));return Se||pe}$startExtensionHost(x){x.toAdd.forEach(pe=>pe.extensionLocation=p.URI.revive(pe.extensionLocation));const{globalRegistry:B,myExtensions:Z}=_(this.D,this.G,this.F,x);return this.G.set(B.getAllExtensionDescriptions()),this.F.set(Z),this.nb()}$activateByEvent(x,B){return B===1?this.S(x,!1):this.z.wait().then(Z=>this.S(x,!1))}async $activate(x,B){return await this.z.wait(),this.F.getExtensionDescription(x)?(await this.U(x,B),!0):!1}async $deltaExtensions(x){x.toAdd.forEach(re=>re.extensionLocation=p.URI.revive(re.extensionLocation));const{globalRegistry:B,myExtensions:Z}=_(this.D,this.G,this.F,x),pe=await this.X(Z);return(await this.getExtensionPathIndex()).setSearchTree(pe),this.G.set(B.getAllExtensionDescriptions()),this.F.set(Z),Promise.resolve(void 0)}async $test_latency(x){return x}async $test_up(x){return x.byteLength}async $test_down(x){const B=w.VSBuffer.alloc(x),Z=Math.random()%256;for(let pe=0;pe<x;pe++)B.writeUInt8(Z,pe);return B}async $updateRemoteConnectionData(x){this.Q=x,this.a.fire()}};e.AbstractExtHostExtensionService=Y=xe([We(0,r.IInstantiationService),We(1,e.IHostUtils),We(2,S.IExtHostRpcService),We(3,v.IExtHostWorkspace),We(4,E.IExtHostConfiguration),We(5,O.ILogService),We(6,a.IExtHostInitDataService),We(7,b.IExtensionStoragePaths),We(8,u.IExtHostTunnelService),We(9,m.IExtHostTerminalService),We(10,V.IExtHostLocalizationService)],Y);function _(fe,x,B,Z){fe.addActivationEvents(Z.addActivationEvents);const pe=new d.ExtensionDescriptionRegistry(fe,x.getAllExtensionDescriptions());pe.deltaExtensions(Z.toAdd,Z.toRemove);const Se=new y.ExtensionIdentifierSet(B.getAllExtensionDescriptions().map(ne=>ne.identifier));for(const ne of Z.myToRemove)Se.delete(ne);for(const ne of Z.myToAdd)Se.add(ne);const re=oe(pe,Se);return{globalRegistry:pe,myExtensions:re}}function Q(fe,x){return{id:fe.identifier.value,name:fe.name,extensionVersion:fe.version,publisherDisplayName:fe.publisher,activationEvents:fe.activationEvents?fe.activationEvents.join(","):null,isBuiltin:fe.isBuiltin,reason:x.activationEvent,reasonId:x.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class ie{constructor(x,B,Z,pe,Se){G.set(this,void 0),F.set(this,void 0),$.set(this,void 0),_e(this,G,x,"f"),_e(this,F,B,"f"),_e(this,$,Z.identifier,"f"),this.id=Z.identifier.value,this.extensionUri=Z.extensionLocation,this.extensionPath=R.normalize((0,L.originalFSPath)(Z.extensionLocation)),this.packageJSON=Z,this.extensionKind=pe,this.isFromDifferentExtensionHost=Se}get isActive(){return Be(this,G,"f").isActivated(Be(this,$,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Be(this,G,"f").getExtensionExports(Be(this,$,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Be(this,G,"f").activateByIdWithErrors(Be(this,$,"f"),{startup:!1,extensionId:Be(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=ie,G=new WeakMap,F=new WeakMap,$=new WeakMap;function oe(fe,x){return fe.getAllExtensionDescriptions().filter(B=>x.has(B.identifier))}class Ee{constructor(x){this.a=x}setSearchTree(x){this.a=x}findSubstr(x){return this.a.findSubstr(x)}forEach(x){return this.a.forEach(x)}}e.ExtensionPaths=Ee;class he{constructor(x){this.a=new y.ExtensionIdentifierMap,this.addActivationEvents(x)}readActivationEvents(x){return this.a.get(x.identifier)}addActivationEvents(x){for(const B of Object.keys(x))this.a.set(B,x[B])}}}),define(Ce[310],ke([1,0,85,2,5,35,27,25,20,26,4,43,36,16,9]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let v=e.RequireInterceptor=class{constructor(g,t,s,r,a,b,S){this.c=g,this.d=t,this.e=s,this.f=r,this.g=a,this.h=b,this.i=S,this.a=new Map,this.b=[]}async install(){this.j(),o.mark("code/extHost/willWaitForConfig");const g=await this.f.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const t=await this.g.getExtensionPathIndex();this.register(new d(this.c,t,this.d,g,this.i)),this.register(this.e.createInstance(h,t)),this.register(this.e.createInstance(i)),this.h.remote.isRemote&&this.register(this.e.createInstance(y,t,this.h.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const t of g.nodeModuleName)this.a.set(t,g);else this.a.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this.b.push(t=>g.alternativeModuleName(t))}};e.RequireInterceptor=v=xe([We(2,O.IInstantiationService),We(3,L.IExtHostConfiguration),We(4,k.IExtHostExtensionService),We(5,p.IExtHostInitDataService),We(6,T.ILogService)],v);let i=class cn{constructor(g){if(g.environment.appRoot&&cn.a.size){const t=(0,I.escapeRegExpCharacters)(this.c(g.environment.appRoot.fsPath)),s="[a-z0-9_.-]",r=`@${s}+\\/${s}+|${s}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${t}/${a}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(g){if(!this.b)return;const t=this.b.exec(this.c(g));if(!t)return;const[,s,r,a]=t,b=cn.a.get(r);if(b!==void 0)return console.warn(`${r} as been renamed to ${b}, please update your imports`),s+b+a}c(g){return g.replace(/\\/g,"/")}};i.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),i=xe([We(0,p.IExtHostInitDataService)],i);class d{constructor(g,t,s,r,a){this.c=g,this.d=t,this.e=s,this.f=r,this.g=a,this.nodeModuleName="vscode",this.a=new P.ExtensionIdentifierMap}load(g,t){const s=this.d.findSubstr(t);if(s){let r=this.a.get(s.identifier);return r||(r=this.c(s,this.e,this.f),this.a.set(s.identifier,r)),r}if(!this.b){let r="";this.d.forEach((a,b)=>r+=`	${b} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${t}. These are the extension path mappings: 
${r}`),this.b=this.c(A.nullExtensionDescription,this.e,this.f)}return this.b}}let h=class{constructor(g,t,s){this.d=g,this.nodeModuleName="keytar",this.a=t.getProxy(l.MainContext.MainThreadTelemetry);const{environment:r}=s,a=t.getProxy(l.MainContext.MainThreadKeytar);if(r.appRoot){let b=r.appRoot.fsPath;E.platform==="win32"&&(b=b.replace(/\\/g,"/")),b[b.length-1]==="/"&&(b=b.substr(0,b.length-1)),this.b=new Set,this.b.add(`${b}/node_modules.asar/keytar`),this.b.add(`${b}/node_modules/keytar`)}this.c={getPassword:(b,S)=>a.$getPassword(b,S),setPassword:(b,S,c)=>a.$setPassword(b,S,c),deletePassword:(b,S)=>a.$deletePassword(b,S),findPassword:b=>a.$findPassword(b),findCredentials(b){return a.$findCredentials(b)}}}load(g,t){const s=this.d.findSubstr(t);return this.a.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(g){const t=g.length;if(t<=7||!this.b)return;const s=t-7;if((g.charAt(s)==="/"||g.charAt(s)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.b.has(g)))return"keytar"}};h=xe([We(1,D.IExtHostRpcService),We(2,p.IExtHostInitDataService)],h);let y=class{constructor(g,t,s){this.e=g,this.f=t,this.nodeModuleName=["open","opn"],this.d=s.getProxy(l.MainContext.MainThreadTelemetry);const r=s.getProxy(l.MainContext.MainThreadWindow);this.c=(a,b)=>{const S=R.URI.parse(a);return b?this.g(a,b):S.scheme==="http"||S.scheme==="https"?r.$openUri(S,a,{allowTunneling:!0}):S.scheme==="mailto"||S.scheme===this.f?r.$openUri(S,a,{}):this.g(a,b)}}load(g,t,s){const r=this.e.findSubstr(t);return r&&(this.a=r.identifier.value,this.h()),this.b=s(g),this.c}g(g,t){return this.i(),this.b(g,t)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};y=xe([We(2,D.IExtHostRpcService)],y)}),define(Ce[50],ke([1,0,65,6,15,36,4,60,61,43,7,34,243,35]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,A.createDecorator)("IExtHostVariableResolverProvider");class I extends E.AbstractVariableResolverService{constructor(d,h,y,w,g,t,s){function r(){if(y){const a=y.activeEditor();if(a)return a.document.uri;const b=w.tabGroups.all.find(S=>S.isActive)?.activeTab;if(b!==void 0){if(b.input instanceof O.TextDiffTabInput||b.input instanceof O.NotebookDiffEditorTabInput)return b.input.modified;if(b.input instanceof O.TextTabInput||b.input instanceof O.NotebookEditorTabInput||b.input instanceof O.CustomEditorTabInput)return b.input.uri}}}super({getFolderUri:a=>{const b=t.folders.filter(S=>S.name===a);if(b&&b.length>0)return b[0].uri},getWorkspaceFolderCount:()=>t.folders.length,getConfigurationValue:(a,b)=>g.getConfiguration(void 0,a).get(b),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const a=r();if(a)return l.normalize(a.fsPath)},getWorkspaceFolderPathForFile:()=>{if(h){const a=r();if(a){const b=h.getWorkspaceFolder(a);if(b)return l.normalize(b.uri.fsPath)}}},getSelectedText:()=>{if(y){const a=y.activeEditor();if(a&&!a.selection.isEmpty)return a.document.getText(a.selection)}},getLineNumber:()=>{if(y){const a=y.activeEditor();if(a)return String(a.selection.end.line+1)}},getExtension:a=>d.getExtension(a)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(L.env))}}let v=e.ExtHostVariableResolverProviderService=class extends R.Disposable{constructor(d,h,y,w,g){super(),this.b=d,this.c=h,this.g=y,this.h=w,this.i=g,this.a=new o.Lazy(async()=>{const t=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async a=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new I(this.b,this.c,this.g,this.i,t,r,this.j())})}getResolver(){return this.a.value}j(){}};e.ExtHostVariableResolverProviderService=v=xe([We(0,p.IExtHostExtensionService),We(1,k.IExtHostWorkspace),We(2,P.IExtHostDocumentsAndEditors),We(3,T.IExtHostConfiguration),We(4,D.IExtHostEditorTabs)],v)}),define(Ce[86],ke([1,0,19,3,10,2,4,5,61,43,20,7,34,131,237,35,50]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,A.createDecorator)("IExtHostDebugService");let d=e.ExtHostDebugServiceBase=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,a,b,S,c,u){this.F=a,this.G=b,this.H=S,this.I=c,this.J=u,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new R.Emitter,this.n=new R.Emitter,this.o=new R.Emitter,this.u=new R.Emitter,this.k=r.getProxy(P.MainContext.MainThreadDebugService),this.z=new R.Emitter({onWillAddFirstListener:()=>{this.V()}}),this.B=new R.Emitter,this.v=new y(this.k),this.w=new Map,this.y=!1,this.G.getExtensionRegistry().then(m=>{m.onDidChange(f=>{this.K(m)}),this.K(m)})}asDebugSourceUri(r,a){const b=r;if(typeof b.sourceReference=="number"&&b.sourceReference>0){let S=`debug:${encodeURIComponent(b.path||"")}`,c="?";return a&&(S+=`${c}session=${encodeURIComponent(a.id)}`,c="&"),S+=`${c}ref=${b.sourceReference}`,L.URI.parse(S)}else{if(b.path)return L.URI.file(b.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}K(r){const a=[];for(const b of r.getAllExtensionDescriptions())if(b.contributes){const S=b.contributes.debuggers;if(S&&S.length>0)for(const c of S)(0,I.isDebuggerMainContribution)(c)&&a.push(c.type)}this.k.$registerDebugTypes(a)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.V();const r=[];return this.w.forEach(a=>r.push(a)),r}addBreakpoints(r){this.V();const a=r.filter(c=>{const u=c.id;return this.w.has(u)?!1:(this.w.set(u,c),!0)});this.W(a,[],[]);const b=[],S=new Map;for(const c of a)if(c instanceof k.SourceBreakpoint){let u=S.get(c.location.uri.toString());u||(u={type:"sourceMulti",uri:c.location.uri,lines:[]},S.set(c.location.uri.toString(),u),b.push(u)),u.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof k.FunctionBreakpoint&&b.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this.k.$registerBreakpoints(b)}removeBreakpoints(r){this.V();const a=r.filter(u=>this.w.delete(u.id));this.W([],a,[]);const b=a.filter(u=>u instanceof k.SourceBreakpoint).map(u=>u.id),S=a.filter(u=>u instanceof k.FunctionBreakpoint).map(u=>u.id),c=a.filter(u=>u instanceof k.DataBreakpoint).map(u=>u.id);return this.k.$unregisterBreakpoints(b,S,c)}startDebugging(r,a,b){return this.k.$startDebugging(r?r.uri:void 0,a,{parentSessionID:b.parentSession?b.parentSession.id:void 0,lifecycleManagedByParent:b.lifecycleManagedByParent,repl:b.consoleMode===k.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:b.noDebug,compact:b.compact,suppressSaveBeforeStart:b.suppressSaveBeforeStart,suppressDebugStatusbar:b.suppressDebugStatusbar??b.debugUI?.simple,suppressDebugToolbar:b.suppressDebugToolbar??b.debugUI?.simple,suppressDebugView:b.suppressDebugView??b.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,a,b){if(!a)return new k.Disposable(()=>{});const S=this.d++;return this.f.push({type:r,handle:S,provider:a}),this.k.$registerDebugConfigurationProvider(r,b,!!a.provideDebugConfigurations,!!a.resolveDebugConfiguration,!!a.resolveDebugConfigurationWithSubstitutedVariables,S),new k.Disposable(()=>{this.f=this.f.filter(c=>c.provider!==a),this.k.$unregisterDebugConfigurationProvider(S)})}registerDebugAdapterDescriptorFactory(r,a,b){if(!b)return new k.Disposable(()=>{});if(!this.R(r,a))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${a}' debugger.`);if(this.O(a))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const S=this.g++;return this.h.push({type:a,handle:S,factory:b}),this.k.$registerDebugAdapterDescriptorFactory(a,S),new k.Disposable(()=>{this.h=this.h.filter(c=>c.factory!==b),this.k.$unregisterDebugAdapterDescriptorFactory(S)})}registerDebugAdapterTrackerFactory(r,a){if(!a)return new k.Disposable(()=>{});const b=this.i++;return this.j.push({type:r,handle:b,factory:a}),new k.Disposable(()=>{this.j=this.j.filter(S=>S.factory!==a)})}async $runInTerminal(r,a){return Promise.resolve(void 0)}async $substituteVariables(r,a){let b;const S=await this.Y(r);return S&&(b={uri:S.uri,name:S.name,index:S.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.J.getResolver()).resolveAnyAsync(b,a)}L(r,a){if(r.type==="implementation")return new g(r.implementation)}M(){}async $startDASession(r,a){const b=this,S=await this.X(a);return this.T(this.O(S.type),S).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}' (extension might have failed to activate)`);const u=this.N(c),m=this.L(u,S);if(!m)throw new Error(`Couldn't create a debug adapter for type '${S.type}'.`);const f=m;return this.C.set(r,f),this.S(S).then(n=>(n&&this.D.set(r,n),f.onMessage(async C=>{if(C.type==="request"&&C.command==="handshake"){const M=C,H={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this.E||(this.E=this.M());try{if(this.E){const V=await this.E.sign(M.arguments.value);H.body={signature:V},f.sendResponse(H)}else throw new Error("no signer")}catch(V){H.success=!1,H.message=V.message,f.sendResponse(H)}}else n&&n.onDidSendMessage&&n.onDidSendMessage(C),C=(0,I.convertToVSCPaths)(C,!0),b.k.$acceptDAMessage(r,C)}),f.onError(C=>{n&&n.onError&&n.onError(C),this.k.$acceptDAError(r,C.name,C.message,C.stack)}),f.onExit(C=>{n&&n.onExit&&n.onExit((0,l.withNullAsUndefined)(C),void 0),this.k.$acceptDAExit(r,(0,l.withNullAsUndefined)(C),void 0)}),n&&n.onWillStartSession&&n.onWillStartSession(),f.startSession()))})}$sendDAMessage(r,a){a=(0,I.convertToDAPaths)(a,!1);const b=this.D.get(r);b&&b.onWillReceiveMessage&&b.onWillReceiveMessage(a),this.C.get(r)?.sendMessage(a)}$stopDASession(r){const a=this.D.get(r);this.D.delete(r),a&&a.onWillStopSession&&a.onWillStopSession();const b=this.C.get(r);return this.C.delete(r),b?b.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const a=[],b=[],S=[];if(r.added)for(const c of r.added){const u=c.id;if(u&&!this.w.has(u)){let m;if(c.type==="function")m=new k.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")m=new k.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const f=L.URI.revive(c.uri);m=new k.SourceBreakpoint(new k.Location(f,new k.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}(0,k.setBreakpointId)(m,u),this.w.set(u,m),a.push(m)}}if(r.removed)for(const c of r.removed){const u=this.w.get(c);u&&(this.w.delete(c),b.push(u))}if(r.changed){for(const c of r.changed)if(c.id){const u=this.w.get(c.id);if(u){if(u instanceof k.FunctionBreakpoint&&c.type==="function"){const m=u;m.enabled=c.enabled,m.condition=c.condition,m.hitCondition=c.hitCondition,m.logMessage=c.logMessage,m.functionName=c.functionName}else if(u instanceof k.SourceBreakpoint&&c.type==="source"){const m=u;m.enabled=c.enabled,m.condition=c.condition,m.hitCondition=c.hitCondition,m.logMessage=c.logMessage,m.location=new k.Location(L.URI.revive(c.uri),new k.Position(c.line,c.character))}S.push(u)}}}this.W(a,b,S)}async $acceptStackFrameFocus(r){let a;const b=r.sessionId?await this.X(r.sessionId):void 0;if(!b)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?a={kind:r.kind,threadId:r.threadId,session:b}:a={kind:r.kind,threadId:r.threadId,frameId:r.frameId,session:b},this.A=a,this.B.fire(a)}$provideDebugConfigurations(r,a,b){return(0,o.asPromise)(async()=>{const S=this.Q(r);if(!S)throw new Error("no DebugConfigurationProvider found");if(!S.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.Y(a);return S.provideDebugConfigurations(c,b)}).then(S=>{if(!S)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return S})}$resolveDebugConfiguration(r,a,b,S){return(0,o.asPromise)(async()=>{const c=this.Q(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const u=await this.Y(a);return c.resolveDebugConfiguration(u,b,S)})}$resolveDebugConfigurationWithSubstitutedVariables(r,a,b,S){return(0,o.asPromise)(async()=>{const c=this.Q(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const u=await this.Y(a);return c.resolveDebugConfigurationWithSubstitutedVariables(u,b,S)})}async $provideDebugAdapter(r,a){const b=this.P(r);if(!b)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const S=await this.X(a);return this.T(b,S).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${S.type}'`);return this.N(c)})}async $acceptDebugSessionStarted(r){const a=await this.X(r);this.m.fire(a)}async $acceptDebugSessionTerminated(r){const a=await this.X(r);a&&(this.n.fire(a),this.l.delete(a.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.X(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,a){(await this.X(r))?._acceptNameChanged(a)}async $acceptDebugSessionCustomEvent(r,a){const S={session:await this.X(r),event:a.event,body:a.body};this.u.fire(S)}N(r){if(r instanceof k.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof k.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof k.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof k.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}O(r){const a=this.h.filter(b=>b.type===r);if(a.length>0)return a[0].factory}P(r){const a=this.h.filter(b=>b.handle===r);if(a.length>0)return a[0].factory}Q(r){const a=this.f.filter(b=>b.handle===r);if(a.length>0)return a[0].provider}R(r,a){if(r.contributes){const b=r.contributes.debuggers;if(b&&b.length>0){for(const S of b)if(S.label&&S.type&&S.type===a)return!0}}return!1}S(r){const b=r.configuration.type,S=this.j.filter(c=>c.type===b||c.type==="*").map(c=>(0,o.asPromise)(()=>c.factory.createDebugAdapterTracker(r)).then(u=>u,u=>null));return Promise.race([Promise.all(S).then(c=>{const u=c.filter(m=>!!m);if(u.length>0)return new w(u)}),new Promise(c=>setTimeout(()=>c(void 0),1e3))]).catch(c=>{})}async T(r,a){const b=a.configuration.debugServer;if(typeof b=="number")return Promise.resolve(new k.DebugAdapterServer(b));if(r){const c=await this.G.getExtensionRegistry();return(0,o.asPromise)(()=>r.createDebugAdapterDescriptor(a,this.U(a,c))).then(u=>{if(u)return u})}const S=await this.G.getExtensionRegistry();return Promise.resolve(this.U(a,S))}U(r,a){}V(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}W(r,a,b){(r.length>0||a.length>0||b.length>0)&&this.z.fire(Object.freeze({added:r,removed:a,changed:b}))}async X(r){if(r)if(typeof r=="string"){const a=this.l.get(r);if(a)return a}else{let a=this.l.get(r.id);if(!a){const b=await this.Y(r.folderUri),S=r.parent?this.l.get(r.parent):void 0;a=new h(this.k,r.id,r.type,r.name,b,r.configuration,S),this.l.set(a.id,a),this.k.$sessionCached(a.id)}return a}throw new Error("cannot find session")}Y(r){if(r){const a=L.URI.revive(r);return this.F.resolveWorkspaceFolder(a)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=d=xe([We(0,O.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,p.IExtHostExtensionService),We(3,v.IExtHostConfiguration),We(4,D.IExtHostEditorTabs),We(5,i.IExtHostVariableResolverProvider)],d);class h{constructor(r,a,b,S,c,u,m){this.d=r,this.f=a,this.g=b,this.h=S,this.i=c,this.j=u,this.k=m}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,a){return this.d.$customDebugAdapterRequest(this.f,r,a)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=h;class y{constructor(r){this.value=Object.freeze({append(a){r.$appendDebugConsole(a)},appendLine(a){this.append(a+`
`)}})}}e.ExtHostDebugConsole=y;class w{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(a=>a.onWillReceiveMessage?a.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(a=>a.onDidSendMessage?a.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(a=>a.onError?a.onError(r):void 0)}onExit(r,a){this.d.forEach(b=>b.onExit?b.onExit(r,a):void 0)}}class g extends T.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(a=>{this.acceptMessage(a)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let t=e.WorkerExtHostDebugService=class extends d{constructor(r,a,b,S,c,u){super(r,a,b,S,c,u)}};e.WorkerExtHostDebugService=t=xe([We(0,O.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,p.IExtHostExtensionService),We(3,v.IExtHostConfiguration),We(4,D.IExtHostEditorTabs),We(5,i.IExtHostVariableResolverProvider)],t)}),define(Ce[311],ke([1,0,8,85,2,5,303,16,91,92,26,211,20,57,43,78]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class i{static async installEarlyHandler(y){const w=y.get(P.ILogService),t=y.get(E.IExtHostRpcService).getProxy(L.MainContext.MainThreadErrors);o.setUnexpectedErrorHandler(s=>{w.error(s);const r=o.transformErrorForSerialization(s);t.$onUnexpectedError(r)})}static async installFullHandler(y){const w=y.get(P.ILogService),g=y.get(E.IExtHostRpcService),t=y.get(I.IExtHostExtensionService),s=y.get(v.IExtHostTelemetry),r=g.getProxy(L.MainContext.MainThreadExtensionService),a=g.getProxy(L.MainContext.MainThreadErrors),b=await t.getExtensionPathIndex(),S=new WeakMap;function c(m,f){let n="",C,M;for(const H of f)n+=`
	at ${H.toString()}`,M=H.getFileName(),!C&&M&&(C=b.findSubstr(l.URI.file(M)));return S.set(m,C?.identifier),`${m.name||"Error"}: ${m.message||""}${n}`}let u=c;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(m){u=function(f,n){return c(f,n),m.call(Error,f,n)}}}),o.setUnexpectedErrorHandler(m=>{w.error(m);const f=o.transformErrorForSerialization(m),n=S.get(m);if(!n){a.$onUnexpectedError(f);return}r.$onExtensionRuntimeError(n,f);const C=s.onExtensionError(n,m);w.trace("forwarded error to extension?",C,n)})}}Error.stackTraceLimit=100;class d{constructor(y,w,g,t,s){this.a=g,this.b=new A.RPCProtocol(y,null,t),w=d.e(w,this.b);const r=new p.ServiceCollection(...(0,D.getSingletonServiceDescriptors)());r.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...w,messagePorts:s}),r.set(E.IExtHostRpcService,new E.ExtHostRpcService(this.b)),r.set(T.IURITransformerService,new T.URITransformerService(t)),r.set(I.IHostUtils,g);const a=new k.InstantiationService(r,!0);a.invokeFunction(i.installEarlyHandler),this.d=a.invokeFunction(b=>b.get(P.ILogService)),R.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",w),this.c=a.invokeFunction(b=>b.get(I.IExtHostExtensionService)),this.c.initialize(),a.invokeFunction(i.installFullHandler)}async asBrowserUri(y){const w=this.b.getProxy(L.MainContext.MainThreadExtensionService);return l.URI.revive(await w.$asBrowserUri(y))}terminate(y){this.c.terminate(y)}static e(y,w){y.allExtensions.forEach(t=>{t.extensionLocation=l.URI.revive(w.transformIncomingURIs(t.extensionLocation))}),y.environment.appRoot=l.URI.revive(w.transformIncomingURIs(y.environment.appRoot));const g=y.environment.extensionDevelopmentLocationURI;return g&&(y.environment.extensionDevelopmentLocationURI=g.map(t=>l.URI.revive(w.transformIncomingURIs(t)))),y.environment.extensionTestsLocationURI=l.URI.revive(w.transformIncomingURIs(y.environment.extensionTestsLocationURI)),y.environment.globalStorageHome=l.URI.revive(w.transformIncomingURIs(y.environment.globalStorageHome)),y.environment.workspaceStorageHome=l.URI.revive(w.transformIncomingURIs(y.environment.workspaceStorageHome)),y.environment.extensionTelemetryLogResource=l.URI.revive(w.transformIncomingURIs(y.environment.extensionTelemetryLogResource)),y.nlsBaseUrl=l.URI.revive(w.transformIncomingURIs(y.nlsBaseUrl)),y.logsLocation=l.URI.revive(w.transformIncomingURIs(y.logsLocation)),y.workspace=w.transformIncomingURIs(y.workspace),y}}e.ExtensionHostMain=d}),define(Ce[312],ke([1,0,19,14,193,210,218,86,61,43,20,42,7,50,34,238,239,35]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let h=e.ExtHostDebugService=class extends P.ExtHostDebugServiceBase{constructor(s,r,a,b,S,c,u){super(s,r,a,b,c,u),this.bb=S,this.Z=new g}L(s,r){switch(s.type){case"server":return new v.SocketDebugAdapter(s);case"pipeServer":return new v.NamedPipeDebugAdapter(s);case"executable":return new v.ExecutableDebugAdapter(s,r.type)}return super.L(s,r)}U(s,r){const a=v.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),s.type);if(a)return new E.DebugAdapterExecutable(a.command,a.args,a.options)}M(){return new A.SignService}async $runInTerminal(s,r){if(s.kind==="integrated"){this.ab||(this.ab=this.bb.onDidCloseTerminal(V=>{this.Z.onTerminalClosed(V)}));const a=await this.H.getConfigProvider(),b=this.bb.getDefaultShell(!0),S=this.bb.getDefaultShellArgs(!0),c=s.title||l.localize(0,null),u=JSON.stringify({shell:b,shellArgs:S});let m=await this.Z.checkout(u,c),f,n=!1;if(m)f=s.cwd;else{const V={shellPath:b,shellArgs:S,cwd:s.cwd,name:c,iconPath:new E.ThemeIcon("debug")};n=!0,m=this.bb.createTerminalFromOptions(V,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.Z.insert(m,u)}m.show(!0);const C=await m.processId;n?await new Promise(V=>setTimeout(V,1e3)):a.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(b.indexOf("powershell")>=0||b.indexOf("pwsh")>=0||b.indexOf("cmd.exe")>=0?m.sendText("cls"):b.indexOf("bash")>=0?m.sendText("clear"):R.isWindows?m.sendText("cls"):m.sendText("clear"));const M=(0,i.prepareCommand)(b,s.args,!!s.argsCanBeInterpretedByShell,f,s.env);m.sendText(M);const H=this.onDidTerminateDebugSession(V=>{V.id===r&&(this.Z.free(m),H.dispose())});return C}else if(s.kind==="external")return w(s,await this.H.getConfigProvider());return super.$runInTerminal(s,r)}};e.ExtHostDebugService=h=xe([We(0,O.IExtHostRpcService),We(1,I.IExtHostWorkspace),We(2,p.IExtHostExtensionService),We(3,d.IExtHostConfiguration),We(4,k.IExtHostTerminalService),We(5,D.IExtHostEditorTabs),We(6,T.IExtHostVariableResolverProvider)],h);let y;function w(t,s){if(!y)if(R.isWindows)y=new L.WindowsExternalTerminalService;else if(R.isMacintosh)y=new L.MacExternalTerminalService;else if(R.isLinux)y=new L.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=s.getConfiguration("terminal");return y.runInTerminal(t.title,t.cwd,t.args,t.env||{},r.external||{})}class g{constructor(){this.b=new Map}async checkout(s,r){const b=[...this.b.entries()].map(([S,c])=>(0,o.createCancelablePromise)(async u=>{if(S.name!==r||c.lastUsedAt!==-1&&await(0,i.hasChildProcesses)(await S.processId))return null;const m=Date.now();return c.lastUsedAt+g.a>m||u.isCancellationRequested||c.config!==s?null:(c.lastUsedAt=m,S)}));return await(0,o.firstParallel)(b,S=>!!S)}insert(s,r){this.b.set(s,{lastUsedAt:Date.now(),config:r})}free(s){const r=this.b.get(s);r&&(r.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}g.a=1e3}),define(Ce[313],ke([1,0,15,2,117,34,60,35,48,42,20,26,84,17,16,79,24,72,50]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let y=e.ExtHostTask=class extends E.ExtHostTaskBase{constructor(g,t,s,r,a,b,S,c,u){super(g,t,s,r,a,b,S,c),this.B=s,this.C=u,t.remote.isRemote&&t.remote.authority?this.registerTaskSystem(T.Schemas.vscodeRemote,{scheme:T.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform}):this.registerTaskSystem(T.Schemas.file,{scheme:T.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(g,t){const s=t;if(!t.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const r=E.TaskHandleDTO.from(s,this.B),a=await this.a.$getTaskExecution(r);if(a.task===void 0)throw new Error("Task from execution DTO is undefined");const b=await this.y(a,t);return this.a.$executeTask(r).catch(()=>{}),b}else{const r=E.TaskDTO.from(t,g);if(r===void 0)return Promise.reject(new Error("Task is not valid"));E.CustomExecutionDTO.is(r.execution)&&await this.x(r,t,!1);const a=await this.y(await this.a.$getTaskExecution(r),t);return this.a.$executeTask(r).catch(()=>{}),a}}u(g,t,s,r){const a=[];if(r)for(const b of r){this.z(b,s),(!b.definition||!g[b.definition.type])&&this.f.warn(`The task [${b.source}, ${b.name}] uses an undefined task type. The task will be ignored in the future.`);const S=E.TaskDTO.from(b,s.extension);S&&(a.push(S),E.CustomExecutionDTO.is(S.execution)&&t.push(this.x(S,b,!0)))}return{tasks:a,extension:s.extension}}async v(g){return g}async F(g){let t=g&&g.length>0?g[0]:void 0;if(!t){const s=R.URI.file((0,d.homedir)());t=new D.WorkspaceFolder({uri:s,name:i.basename(s),index:0})}return{uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(g,t){const s=R.URI.revive(g),r={process:void 0,variables:Object.create(null)},a=await this.b.resolveWorkspaceFolder(s),b=await this.b.getWorkspaceFolders2()??[],S=await this.C.getResolver(),c=a?{uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(b);for(const u of t.variables)r.variables[u]=await S.resolveAsync(c,u);if(t.process!==void 0){let u;if(t.process.path!==void 0){u=t.process.path.split(o.delimiter);for(let m=0;m<u.length;m++)u[m]=await S.resolveAsync(c,u[m])}r.process=await l.win32.findExecutable(await S.resolveAsync(c,t.process.name),t.process.cwd!==void 0?await S.resolveAsync(c,t.process.cwd):void 0,u)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(g,t,s){return l.win32.findExecutable(g,t,s)}};e.ExtHostTask=y=xe([We(0,O.IExtHostRpcService),We(1,k.IExtHostInitDataService),We(2,L.IExtHostWorkspace),We(3,A.IExtHostDocumentsAndEditors),We(4,P.IExtHostConfiguration),We(5,p.IExtHostTerminalService),We(6,I.ILogService),We(7,v.IExtHostApiDeprecationService),We(8,h.IExtHostVariableResolverProvider)],y)}),define(Ce[314],ke([1,0,72,50]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class l extends R.ExtHostVariableResolverProviderService{j(){return(0,o.homedir)()}}e.NodeExtHostVariableResolverProviderService=l}),define(Ce[144],ke([1,0,18,19,21,46,17,15,24,2,31]),function(ae,e,o,R,l,L,A,P,D,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class k{constructor(h,y,w,g){this.d=h,this.e=y,this.f=w,this.g=g,this.a=null,this.b=!1,this.c=0}search(h,y){const w=this.d.folderQueries||[],g=new l.CancellationTokenSource;return y.onCancellationRequested(()=>g.cancel()),new Promise((t,s)=>{this.a=new T(h);let r=!1;const a=(b,S)=>{if(!r&&!this.b){const c=this.h(b);v(b)&&typeof this.d.maxResults=="number"&&this.c+c>this.d.maxResults&&(this.b=!0,r=!0,g.cancel(),b=this.j(b,this.d.maxResults-this.c));const u=this.h(b);this.c+=u,(u>0||!v(b))&&this.a.add(b,S)}};Promise.all(w.map((b,S)=>this.k(b,c=>a(c,S),g.token))).then(b=>{g.dispose(),this.a.flush();const S=b.some(c=>!!c&&!!c.limitHit);t({limitHit:this.b||S,messages:(0,o.flatten)(b.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.g}})},b=>{g.dispose();const S=(0,L.toErrorMessage)(b);s(new Error(S))})})}h(h){return v(h)?Array.isArray(h.ranges)?h.ranges.length:1:0}j(h,y){const w=Array.isArray(h.ranges)?h.ranges:[h.ranges],g=Array.isArray(h.preview.matches)?h.preview.matches:[h.preview.matches];return{ranges:w.slice(0,y),preview:{matches:g.slice(0,y),text:h.preview.text},uri:h.uri}}async k(h,y,w){const g=new O.QueryGlobTester(this.d,h),t=[],s={report:b=>{if(!this.l(b))return;const S=h.folder.scheme===A.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(D.dirname(b.uri))):void 0,c=D.relativePath(h.folder,b.uri);if(c){const u=g.includedInQuery(c,P.basename(c),S);(0,R.isThenable)(u)?t.push(u.then(m=>{m&&y(b)})):u&&y(b)}}},r=this.n(h),a=await this.e.provideTextSearchResults(E(this.d.contentPattern),r,s,w);return t.length&&await Promise.all(t),a}l(h){if(v(h)){if(Array.isArray(h.ranges)){if(!Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(h.preview.matches.length!==h.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(h.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(h){const y=(0,O.resolvePatternsForProvider)(this.d.includePattern,h.includePattern),w=(0,O.resolvePatternsForProvider)(this.d.excludePattern,h.excludePattern),g={folder:p.URI.from(h.folder),excludes:w,includes:y,useIgnoreFiles:!h.disregardIgnoreFiles,useGlobalIgnoreFiles:!h.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!h.disregardParentIgnoreFiles,followSymlinks:!h.ignoreSymlinks,encoding:h.fileEncoding&&this.f.toCanonicalName(h.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return g.usePCRE2=this.d.usePCRE2,g}}e.TextSearchManager=k;function E(d){return{isCaseSensitive:d.isCaseSensitive||!1,isRegExp:d.isRegExp||!1,isWordMatch:d.isWordMatch||!1,isMultiline:d.isMultiline||!1,pattern:d.pattern}}class T{constructor(h){this.e=h,this.b=-1,this.d=null,this.a=new i(512,y=>this.g(y))}add(h,y){this.d&&(this.b!==y||!D.isEqual(this.c,h.uri))&&(this.f(),this.d=null),this.d||(this.b=y,this.d={resource:h.uri,results:[]}),this.d.results.push(I(h))}f(){const h=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,h)}flush(){this.f(),this.a.flush()}g(h){this.e(h)}}e.TextSearchResultsCollector=T;function I(d){return v(d)?{preview:{matches:(0,o.mapArrayOrNot)(d.preview.matches,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character})),text:d.preview.text},ranges:(0,o.mapArrayOrNot)(d.ranges,h=>({startLineNumber:h.start.line,startColumn:h.start.character,endLineNumber:h.end.line,endColumn:h.end.character}))}:{text:d.text,lineNumber:d.lineNumber}}function v(d){return!!d.preview}e.extensionResultIsMatch=v;class i{constructor(h,y){this.g=h,this.h=y,this.c=0,this.d=[],this.e=0}addItem(h,y){h&&this.j(h,y)}addItems(h,y){h&&this.k(h,y)}j(h,y){this.d.push(h),this.e+=y,this.l()}k(h,y){this.d=this.d.concat(h),this.e+=y,this.l()}l(){this.c<i.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},i.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=i,i.a=4e3,i.b=50}),define(Ce[87],ke([1,0,6,5,4,307,20,57,16,2,144]),function(ae,e,o,R,l,L,A,P,D,p,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,l.createDecorator)("IExtHostSearch");let k=e.ExtHostSearch=class{constructor(v,i,d){this.k=v,this.l=i,this.n=d,this.c=this.k.getProxy(R.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.FileSearchManager}o(v){return this.l.transformOutgoingScheme(v)}registerTextSearchProvider(v,i){if(this.g.has(v))throw new Error(`a text search provider for the scheme '${v}' is already registered`);this.g.add(v);const d=this.d++;return this.e.set(d,i),this.c.$registerTextSearchProvider(d,this.o(v)),(0,o.toDisposable)(()=>{this.g.delete(v),this.e.delete(d),this.c.$unregisterProvider(d)})}registerFileSearchProvider(v,i){if(this.i.has(v))throw new Error(`a file search provider for the scheme '${v}' is already registered`);this.i.add(v);const d=this.d++;return this.h.set(d,i),this.c.$registerFileSearchProvider(d,this.o(v)),(0,o.toDisposable)(()=>{this.i.delete(v),this.h.delete(d),this.c.$unregisterProvider(d)})}$provideFileSearchResults(v,i,d,h){const y=E(d),w=this.h.get(v);if(w)return this.j.fileSearch(y,w,g=>{this.c.$handleFileMatch(v,i,g.map(t=>t.resource))},h);throw new Error("unknown provider: "+v)}$clearCache(v){return this.j.clearCache(v),Promise.resolve(void 0)}$provideTextSearchResults(v,i,d,h){const y=this.e.get(v);if(!y||!y.provideTextSearchResults)throw new Error(`Unknown provider ${v}`);const w=E(d);return this.q(w,y).search(t=>this.c.$handleTextMatch(v,i,t),h)}$enableExtensionHostSearch(){}q(v,i){return new O.TextSearchManager(v,i,{readdir:d=>Promise.resolve([]),toCanonicalName:d=>d},"textSearchProvider")}};e.ExtHostSearch=k=xe([We(0,A.IExtHostRpcService),We(1,P.IURITransformerService),We(2,D.ILogService)],k);function E(I){return{...I,folderQueries:I.folderQueries&&I.folderQueries.map(T),extraFileResources:I.extraFileResources&&I.extraFileResources.map(v=>p.URI.revive(v))}}e.reviveQuery=E;function T(I){return{...I,folder:p.URI.revive(I.folder)}}}),define(Ce[315],ke([1,0,21,8,3,38,2,121,108,155,167,45,5,97,263,262,41,264,35,266,267,268,249,269,60,43,270,271,277,278,279,143,253,285,286,288,100,42,290,254,11,7,75,293,82,142,34,25,241,276,74,140,84,86,87,16,57,20,26,280,248,56,79,260,291,81,80,296,294,295,261,49,289,292,99,61,78,281,83,282,17,124,252,229,272,6,27,236,98,225,283,284,274,273,251,287,275]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d,h,y,w,g,t,s,r,a,b,S,c,u,m,f,n,C,M,H,V,U,z,G,F,$,Y,_,Q,ie,oe,Ee,he,fe,x,B,Z,pe,Se,re,ne,de,ee,ce,le,ue,N,q,J,te,ve,De,me,Te,Pe,$e,Ve,et,Ye,Je,nt,ct,Fe,it,W,X,ge,Re,Me,Ge,je,tt,pt,at,bt,Dt,St,At,Bt,qt,jt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Rt(lt){const vt=lt.get(ee.IExtHostInitDataService),Ht=lt.get($e.IExtHostFileSystemInfo),zt=lt.get(ve.IExtHostConsumerFileSystem),Tt=lt.get(a.IExtHostExtensionService),ft=lt.get(oe.IExtHostWorkspace),Pt=lt.get(nt.IExtHostTelemetry),Ft=lt.get(h.IExtHostConfiguration),Lt=lt.get(ne.IURITransformerService),Xe=lt.get(de.IExtHostRpcService),Le=lt.get(V.IExtHostStorage),Oe=lt.get(te.IExtensionStoragePaths),Ie=lt.get(re.ILoggerService),se=lt.get(re.ILogService),Ne=lt.get(ue.IExtHostTunnelService),He=lt.get(N.IExtHostApiDeprecationService),Qe=lt.get(ie.IExtHostWindow),qe=lt.get(Ye.IExtHostSecretState),rt=lt.get(Je.IExtHostEditorTabs);Xe.set(E.ExtHostContext.ExtHostFileSystemInfo,Ht),Xe.set(E.ExtHostContext.ExtHostLogLevelServiceShape,Ie),Xe.set(E.ExtHostContext.ExtHostWorkspace,ft),Xe.set(E.ExtHostContext.ExtHostConfiguration,Ft),Xe.set(E.ExtHostContext.ExtHostExtensionService,Tt),Xe.set(E.ExtHostContext.ExtHostStorage,Le),Xe.set(E.ExtHostContext.ExtHostTunnelService,Ne),Xe.set(E.ExtHostContext.ExtHostWindow,Qe),Xe.set(E.ExtHostContext.ExtHostSecretState,qe),Xe.set(E.ExtHostContext.ExtHostTelemetry,Pt),Xe.set(E.ExtHostContext.ExtHostEditorTabs,rt);const yt=Xe.set(E.ExtHostContext.ExtHostDecorations,lt.get(B.IExtHostDecorations)),wt=Xe.set(E.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(r.IExtHostDocumentsAndEditors)),ht=Xe.set(E.ExtHostContext.ExtHostCommands,lt.get(i.IExtHostCommands)),st=Xe.set(E.ExtHostContext.ExtHostTerminalService,lt.get(U.IExtHostTerminalService)),dt=Xe.set(E.ExtHostContext.ExtHostDebugService,lt.get(pe.IExtHostDebugService)),Nt=Xe.set(E.ExtHostContext.ExtHostSearch,lt.get(Se.IExtHostSearch)),$t=Xe.set(E.ExtHostContext.ExtHostTask,lt.get(Z.IExtHostTask)),ai=Xe.set(E.ExtHostContext.ExtHostOutputService,lt.get(f.IExtHostOutputService)),ri=Xe.set(E.ExtHostContext.ExtHostLocalization,lt.get(pt.IExtHostLocalizationService)),ei=Xe.set(E.ExtHostContext.ExtHostUrls,new _.ExtHostUrls(Xe)),kt=Xe.set(E.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(Xe,wt)),Pi=Xe.set(E.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(Xe,wt,se)),Ji=Xe.set(E.ExtHostContext.ExtHostDocumentSaveParticipant,new t.ExtHostDocumentSaveParticipant(se,kt,Xe.getProxy(E.MainContext.MainThreadBulkEdits))),Ct=Xe.set(E.ExtHostContext.ExtHostNotebook,new ce.ExtHostNotebookController(Xe,ht,wt,kt)),gi=Xe.set(E.ExtHostContext.ExtHostNotebookDocuments,new Re.ExtHostNotebookDocuments(Ct)),pi=Xe.set(E.ExtHostContext.ExtHostNotebookEditors,new ge.ExtHostNotebookEditors(se,Ct)),Vt=Xe.set(E.ExtHostContext.ExtHostNotebookKernels,new ct.ExtHostNotebookKernels(Xe,vt,Ct,ht,se)),Ai=Xe.set(E.ExtHostContext.ExtHostNotebookRenderers,new it.ExtHostNotebookRenderers(Xe,Ct)),Ri=Xe.set(E.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new Bt.ExtHostNotebookDocumentSaveParticipant(se,Ct,Xe.getProxy(E.MainContext.MainThreadBulkEdits))),Mt=Xe.set(E.ExtHostContext.ExtHostEditors,new z.ExtHostEditors(Xe,wt)),bi=Xe.set(E.ExtHostContext.ExtHostTreeViews,new G.ExtHostTreeViews(Xe.getProxy(E.MainContext.MainThreadTreeViews),ht,se)),_i=Xe.set(E.ExtHostContext.ExtHostEditorInsets,new he.ExtHostEditorInsets(Xe.getProxy(E.MainContext.MainThreadEditorInsets),Mt,vt.remote)),Xt=Xe.set(E.ExtHostContext.ExtHostDiagnostics,new y.ExtHostDiagnostics(Xe,se,Ht,wt)),si=Xe.set(E.ExtHostContext.ExtHostLanguages,new u.ExtHostLanguages(Xe,kt,ht.converter,Lt)),mt=Xe.set(E.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Xe,Lt,kt,ht,Xt,se,He,Pt)),Li=Xe.set(E.ExtHostContext.ExtHostFileSystem,new b.ExtHostFileSystem(Xe,mt)),Qt=Xe.set(E.ExtHostContext.ExtHostFileSystemEventService,new S.ExtHostFileSystemEventService(Xe,se,wt)),ti=Xe.set(E.ExtHostContext.ExtHostQuickOpen,(0,C.createExtHostQuickOpen)(Xe,ft,ht)),vi=Xe.set(E.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(Xe,ht,kt,se)),Oi=Xe.set(E.ExtHostContext.ExtHostQuickDiff,new Dt.ExtHostQuickDiff(Xe,Lt)),Ni=Xe.set(E.ExtHostContext.ExtHostComments,(0,d.createExtHostComments)(Xe,ht,kt)),wi=Xe.set(E.ExtHostContext.ExtHostProgress,new n.ExtHostProgress(Xe.getProxy(E.MainContext.MainThreadProgress))),Fi=Xe.set(E.ExtHostContext.ExtHosLabelService,new fe.ExtHostLabelService(Xe)),Ei=Xe.set(E.ExtHostContext.ExtHostTheming,new le.ExtHostTheming(Xe)),ii=Xe.set(E.ExtHostContext.ExtHostAuthentication,new q.ExtHostAuthentication(Xe)),Mi=Xe.set(E.ExtHostContext.ExtHostTimeline,new J.ExtHostTimeline(Xe,ht)),ci=Xe.set(E.ExtHostContext.ExtHostWebviews,new Q.ExtHostWebviews(Xe,vt.remote,ft,se,He)),li=Xe.set(E.ExtHostContext.ExtHostWebviewPanels,new Te.ExtHostWebviewPanels(Xe,ci,ft)),Ui=Xe.set(E.ExtHostContext.ExtHostCustomEditors,new me.ExtHostCustomEditors(Xe,kt,Oe,ci,li)),Bi=Xe.set(E.ExtHostContext.ExtHostWebviewViews,new De.ExtHostWebviewViews(Xe,ci)),ni=Xe.set(E.ExtHostContext.ExtHostTesting,new Ve.ExtHostTesting(Xe,ht,wt)),zi=Xe.set(E.ExtHostContext.ExtHostUriOpeners,new et.ExtHostUriOpeners(Xe)),$i=Xe.set(E.ExtHostContext.ExtHostProfileContentHandlers,new bt.ExtHostProfileContentHandlers(Xe));Xe.set(E.ExtHostContext.ExtHostInteractive,new Me.ExtHostInteractive(Xe,Ct,wt,ht,se));const Wi=Xe.set(E.ExtHostContext.ExtHostInteractiveEditor,new At.ExtHostInteractiveEditor(Xe,kt,se)),ui=Xe.set(E.ExtHostContext.ExtHostInteractiveSession,new St.ExtHostInteractiveSession(Xe,se)),Zi=Xe.set(E.ExtHostContext.ExtHostSemanticSimilarity,new qt.ExtHostSemanticSimilarity(Xe)),Si=Xe.set(E.ExtHostContext.ExtHostIssueReporter,new jt.ExtHostIssueReporter(Xe)),yi=Object.values(E.ExtHostContext);Xe.assertRegistered(yi);const en=new Pe.ExtHostBulkEdits(Xe,wt),tn=new v.ExtHostClipboard(Xe),di=new m.ExtHostMessageService(Xe,se),hi=new w.ExtHostDialogs(Xe),Di=new H.ExtHostStatusBar(Xe,ht.converter);return I.ExtHostApiCommands.register(ht),function(ze,Gt,Hi){const Et=function(){let be=!ze.isUnderDevelopment;function ye(){be||(se.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),be=!0)}return function Ue(ot){if(Array.isArray(ot))ot.forEach(Ue);else if(typeof ot=="string")ye();else{const It=ot;typeof It.scheme>"u"&&ye(),typeof It.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)(ze,"documentFiltersExclusive")}return ot}}(),ji={getSession(be,ye,Ue){return ii.getSession(ze,be,ye,Ue)},getSessions(be,ye){return(0,je.checkProposedApiEnabled)(ze,"getSessions"),ii.getSessions(ze,be,ye)},async hasSession(be,ye){return(0,je.checkProposedApiEnabled)(ze,"authSession"),!!await ii.getSession(ze,be,ye,{silent:!0})},get onDidChangeSessions(){return ii.onDidChangeSessions},registerAuthenticationProvider(be,ye,Ue,ot){return ii.registerAuthenticationProvider(be,ye,Ue,ot)}},Yt={registerCommand(be,ye,Ue){return ht.registerCommand(!0,be,ye,Ue,void 0,ze)},registerTextEditorCommand(be,ye,Ue){return ht.registerCommand(!0,be,(...ot)=>{const It=Mt.getActiveTextEditor();if(!It){se.warn("Cannot execute "+be+" because there is no active text editor.");return}return It.edit(Ot=>{ye.apply(Ue,[It,Ot,...ot])}).then(Ot=>{Ot||se.warn("Edits from command "+be+" were not applied.")},Ot=>{se.warn("An error occurred while running command "+be,Ot)})},void 0,void 0,ze)},registerDiffInformationCommand:(be,ye,Ue)=>((0,je.checkProposedApiEnabled)(ze,"diffCommand"),ht.registerCommand(!0,be,async(...ot)=>{const It=wt.activeEditor(!0);if(!It){se.warn("Cannot execute "+be+" because there is no active text editor.");return}const Ot=await Mt.getDiffInformation(It.id);ye.apply(Ue,[Ot,...ot])},void 0,void 0,ze)),executeCommand(be,...ye){return ht.executeCommand(be,...ye)},getCommands(be=!1){return ht.getCommands(be)}},oi={get machineId(){return vt.telemetryInfo.machineId},get sessionId(){return vt.telemetryInfo.sessionId},get language(){return vt.environment.appLanguage},get appName(){return vt.environment.appName},get appRoot(){return vt.environment.appRoot?.fsPath??""},get appHost(){return vt.environment.appHost},get uriScheme(){return vt.environment.appUriScheme},get clipboard(){return tn.value},get shell(){return st.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)(ze,"envShellEvent"),st.onDidChangeShell},get isTelemetryEnabled(){return Pt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Pt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)(ze,"telemetry"),Pt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)(ze,"telemetry"),Pt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,nt.isNewAppInstall)(vt.telemetryInfo.firstSessionDate)},createTelemetryLogger(be,ye){return nt.ExtHostTelemetryLogger.validateSender(be),Pt.instantiateLogger(ze,be,ye)},openExternal(be,ye){return Qe.openUri(be,{allowTunneling:!!vt.remote.authority,allowContributedOpeners:ye?.allowContributedOpeners})},async asExternalUri(be){if(be.scheme===vt.environment.appUriScheme)return ei.createAppUri(be);try{return await Qe.asExternalUri(be,{allowTunneling:!!vt.remote.authority})}catch(ye){if((0,X.matchesScheme)(be,W.Schemas.http)||(0,X.matchesScheme)(be,W.Schemas.https))return be;throw ye}},get remoteName(){return(0,x.getRemoteName)(vt.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)(ze,"resolvers"),vt.remote.authority},get uiKind(){return vt.uiKind},get logLevel(){return se.getLevel()},get onDidChangeLogLevel(){return se.onDidChangeLogLevel},registerIssueUriRequestHandler(be){return(0,je.checkProposedApiEnabled)(ze,"handleIssueUri"),Si.registerIssueUriRequestHandler(ze,be)}};vt.environment.extensionTestsLocationURI||Object.freeze(oi);const nn={createTestController(be,ye,Ue){return ni.createTestController(ze,be,ye,Ue)},createTestObserver(){return(0,je.checkProposedApiEnabled)(ze,"testObserver"),ni.createTestObserver()},runTests(be){return(0,je.checkProposedApiEnabled)(ze,"testObserver"),ni.runTests(be)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)(ze,"testObserver"),ni.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)(ze,"testObserver"),ni.results}},Ut=vt.remote.isRemote?$.ExtensionKind.Workspace:$.ExtensionKind.UI,fi={getExtension(be,ye){(0,je.isProposedApiEnabled)(ze,"extensionsAny")||(ye=!1);const Ue=Gt.mine.getExtensionDescription(be);if(Ue)return new a.Extension(Tt,ze.identifier,Ue,Ut,!1);if(ye){const ot=Gt.all.getExtensionDescription(be);if(ot)return new a.Extension(Tt,ze.identifier,ot,Ut,!0)}},get all(){const be=[];for(const ye of Gt.mine.getAllExtensionDescriptions())be.push(new a.Extension(Tt,ze.identifier,ye,Ut,!1));return be},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)(ze,"extensionsAny");const be=new Ee.ExtensionIdentifierSet(Gt.mine.getAllExtensionDescriptions().map(Ue=>Ue.identifier)),ye=[];for(const Ue of Gt.all.getAllExtensionDescriptions()){const ot=!be.has(Ue.identifier);ye.push(new a.Extension(Tt,ze.identifier,Ue,Ut,ot))}return ye},get onDidChange(){return(0,je.isProposedApiEnabled)(ze,"extensionsAny")?l.Event.any(Gt.mine.onDidChange,Gt.all.onDidChange):Gt.mine.onDidChange}},Vi={createDiagnosticCollection(be){return Xt.createDiagnosticCollection(ze.identifier,be)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:be=>Xt.getDiagnostics(be),getLanguages(){return si.getLanguages()},setTextDocumentLanguage(be,ye){return si.changeLanguage(be.uri,ye)},match(be,ye){const Ue=kt.getDocumentData(ye.uri)?.notebook;return(0,O.score)(F.LanguageSelector.from(be),ye.uri,ye.languageId,!0,Ue?.uri,Ue?.notebookType)},registerCodeActionsProvider(be,ye,Ue){return mt.registerCodeActionProvider(ze,Et(be),ye,Ue)},registerDocumentPasteEditProvider(be,ye,Ue){return(0,je.checkProposedApiEnabled)(ze,"documentPaste"),mt.registerDocumentPasteEditProvider(ze,Et(be),ye,Ue)},registerCodeLensProvider(be,ye){return mt.registerCodeLensProvider(ze,Et(be),ye)},registerDefinitionProvider(be,ye){return mt.registerDefinitionProvider(ze,Et(be),ye)},registerDeclarationProvider(be,ye){return mt.registerDeclarationProvider(ze,Et(be),ye)},registerImplementationProvider(be,ye){return mt.registerImplementationProvider(ze,Et(be),ye)},registerTypeDefinitionProvider(be,ye){return mt.registerTypeDefinitionProvider(ze,Et(be),ye)},registerHoverProvider(be,ye){return mt.registerHoverProvider(ze,Et(be),ye,ze.identifier)},registerEvaluatableExpressionProvider(be,ye){return mt.registerEvaluatableExpressionProvider(ze,Et(be),ye,ze.identifier)},registerInlineValuesProvider(be,ye){return mt.registerInlineValuesProvider(ze,Et(be),ye,ze.identifier)},registerDocumentHighlightProvider(be,ye){return mt.registerDocumentHighlightProvider(ze,Et(be),ye)},registerLinkedEditingRangeProvider(be,ye){return mt.registerLinkedEditingRangeProvider(ze,Et(be),ye)},registerReferenceProvider(be,ye){return mt.registerReferenceProvider(ze,Et(be),ye)},registerRenameProvider(be,ye){return mt.registerRenameProvider(ze,Et(be),ye)},registerDocumentSymbolProvider(be,ye,Ue){return mt.registerDocumentSymbolProvider(ze,Et(be),ye,Ue)},registerWorkspaceSymbolProvider(be){return mt.registerWorkspaceSymbolProvider(ze,be)},registerDocumentFormattingEditProvider(be,ye){return mt.registerDocumentFormattingEditProvider(ze,Et(be),ye)},registerDocumentRangeFormattingEditProvider(be,ye){return mt.registerDocumentRangeFormattingEditProvider(ze,Et(be),ye)},registerOnTypeFormattingEditProvider(be,ye,Ue,...ot){return mt.registerOnTypeFormattingEditProvider(ze,Et(be),ye,[Ue].concat(ot))},registerDocumentSemanticTokensProvider(be,ye,Ue){return mt.registerDocumentSemanticTokensProvider(ze,Et(be),ye,Ue)},registerDocumentRangeSemanticTokensProvider(be,ye,Ue){return mt.registerDocumentRangeSemanticTokensProvider(ze,Et(be),ye,Ue)},registerSignatureHelpProvider(be,ye,Ue,...ot){return typeof Ue=="object"?mt.registerSignatureHelpProvider(ze,Et(be),ye,Ue):mt.registerSignatureHelpProvider(ze,Et(be),ye,typeof Ue>"u"?[]:[Ue,...ot])},registerCompletionItemProvider(be,ye,...Ue){return mt.registerCompletionItemProvider(ze,Et(be),ye,Ue)},registerInlineCompletionItemProvider(be,ye){return ye.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),ye.handleDidPartiallyAcceptCompletionItem&&(0,je.checkProposedApiEnabled)(ze,"inlineCompletionsAdditions"),mt.registerInlineCompletionsProvider(ze,Et(be),ye)},registerDocumentLinkProvider(be,ye){return mt.registerDocumentLinkProvider(ze,Et(be),ye)},registerColorProvider(be,ye){return mt.registerColorProvider(ze,Et(be),ye)},registerFoldingRangeProvider(be,ye){return mt.registerFoldingRangeProvider(ze,Et(be),ye)},registerSelectionRangeProvider(be,ye){return mt.registerSelectionRangeProvider(ze,be,ye)},registerCallHierarchyProvider(be,ye){return mt.registerCallHierarchyProvider(ze,be,ye)},registerTypeHierarchyProvider(be,ye){return mt.registerTypeHierarchyProvider(ze,be,ye)},setLanguageConfiguration:(be,ye)=>mt.setLanguageConfiguration(ze,be,ye),getTokenInformationAtPosition(be,ye){return(0,je.checkProposedApiEnabled)(ze,"tokenInformation"),si.tokenAtPosition(be,ye)},registerInlayHintsProvider(be,ye){return mt.registerInlayHintsProvider(ze,be,ye)},createLanguageStatusItem(be,ye){return si.createLanguageStatusItem(ze,be,ye)},registerDocumentDropEditProvider(be,ye,Ue){return mt.registerDocumentOnDropEditProvider(ze,be,ye,(0,je.isProposedApiEnabled)(ze,"dropMetadata")?Ue:void 0)}},xi={get activeTextEditor(){return Mt.getActiveTextEditor()},get visibleTextEditors(){return Mt.getVisibleTextEditors()},get activeTerminal(){return st.activeTerminal},get terminals(){return st.terminals},async showTextDocument(be,ye,Ue){const ot=await(A.URI.isUri(be)?Promise.resolve(Ii.openTextDocument(be)):Promise.resolve(be));return Mt.showTextDocument(ot,ye,Ue)},createTextEditorDecorationType(be){return Mt.createTextEditorDecorationType(ze,be)},onDidChangeActiveTextEditor(be,ye,Ue){return Mt.onDidChangeActiveTextEditor(be,ye,Ue)},onDidChangeVisibleTextEditors(be,ye,Ue){return Mt.onDidChangeVisibleTextEditors(be,ye,Ue)},onDidChangeTextEditorSelection(be,ye,Ue){return Mt.onDidChangeTextEditorSelection(be,ye,Ue)},onDidChangeTextEditorOptions(be,ye,Ue){return Mt.onDidChangeTextEditorOptions(be,ye,Ue)},onDidChangeTextEditorVisibleRanges(be,ye,Ue){return Mt.onDidChangeTextEditorVisibleRanges(be,ye,Ue)},onDidChangeTextEditorViewColumn(be,ye,Ue){return Mt.onDidChangeTextEditorViewColumn(be,ye,Ue)},onDidCloseTerminal(be,ye,Ue){return st.onDidCloseTerminal(be,ye,Ue)},onDidOpenTerminal(be,ye,Ue){return st.onDidOpenTerminal(be,ye,Ue)},onDidChangeActiveTerminal(be,ye,Ue){return st.onDidChangeActiveTerminal(be,ye,Ue)},onDidChangeTerminalDimensions(be,ye,Ue){return(0,je.checkProposedApiEnabled)(ze,"terminalDimensions"),st.onDidChangeTerminalDimensions(be,ye,Ue)},onDidChangeTerminalState(be,ye,Ue){return st.onDidChangeTerminalState(be,ye,Ue)},onDidWriteTerminalData(be,ye,Ue){return(0,je.checkProposedApiEnabled)(ze,"terminalDataWriteEvent"),st.onDidWriteTerminalData(be,ye,Ue)},get state(){return Qe.state},onDidChangeWindowState(be,ye,Ue){return Qe.onDidChangeWindowState(be,ye,Ue)},showInformationMessage(be,...ye){return di.showMessage(ze,L.default.Info,be,ye[0],ye.slice(1))},showWarningMessage(be,...ye){return di.showMessage(ze,L.default.Warning,be,ye[0],ye.slice(1))},showErrorMessage(be,...ye){return di.showMessage(ze,L.default.Error,be,ye[0],ye.slice(1))},showQuickPick(be,ye,Ue){return ti.showQuickPick(ze,be,ye,Ue)},showWorkspaceFolderPick(be){return ti.showWorkspaceFolderPick(be)},showInputBox(be,ye){return ti.showInput(be,ye)},showOpenDialog(be){return hi.showOpenDialog(ze,be)},showSaveDialog(be){return hi.showSaveDialog(be)},createStatusBarItem(be,ye,Ue){let ot,It,Ot;return typeof be=="string"?(ot=be,It=ye,Ot=Ue):(It=be,Ot=ye),Di.createStatusBarEntry(ze,ot,It,Ot)},setStatusBarMessage(be,ye){return Di.setStatusBarMessage(be,ye)},withScmProgress(be){return He.report("window.withScmProgress",ze,"Use 'withProgress' instead."),wi.withProgress(ze,{location:$.ProgressLocation.SourceControl},(ye,Ue)=>be({report(ot){}}))},withProgress(be,ye){return wi.withProgress(ze,be,ye)},createOutputChannel(be,ye){return ai.createOutputChannel(be,ye,ze)},createWebviewPanel(be,ye,Ue,ot){return li.createWebviewPanel(ze,be,ye,Ue,ot)},createWebviewTextEditorInset(be,ye,Ue,ot){return(0,je.checkProposedApiEnabled)(ze,"editorInsets"),_i.createWebviewEditorInset(be,ye,Ue,ot,ze)},createTerminal(be,ye,Ue){return typeof be=="object"?"pty"in be?st.createExtensionTerminal(be):st.createTerminalFromOptions(be):st.createTerminal(be,ye,Ue)},registerTerminalLinkProvider(be){return st.registerLinkProvider(be)},registerTerminalProfileProvider(be,ye){return st.registerProfileProvider(ze,be,ye)},registerTerminalQuickFixProvider(be,ye){return(0,je.checkProposedApiEnabled)(ze,"terminalQuickFixProvider"),st.registerTerminalQuickFixProvider(be,ze.identifier.value,ye)},registerTreeDataProvider(be,ye){return bi.registerTreeDataProvider(be,ye,ze)},createTreeView(be,ye){return bi.createTreeView(be,ye,ze)},registerWebviewPanelSerializer:(be,ye)=>li.registerWebviewPanelSerializer(ze,be,ye),registerCustomEditorProvider:(be,ye,Ue={})=>Ui.registerCustomEditorProvider(ze,be,ye,Ue),registerFileDecorationProvider(be){return yt.registerFileDecorationProvider(be,ze)},registerUriHandler(be){return ei.registerUriHandler(ze.identifier,be)},createQuickPick(){return ti.createQuickPick(ze)},createInputBox(){return ti.createInputBox(ze)},get activeColorTheme(){return Ei.activeColorTheme},onDidChangeActiveColorTheme(be,ye,Ue){return Ei.onDidChangeActiveColorTheme(be,ye,Ue)},registerWebviewViewProvider(be,ye,Ue){return Bi.registerWebviewViewProvider(ze,be,ye,Ue?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(be,ye,Ue){return Ct.onDidChangeActiveNotebookEditor(be,ye,Ue)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Ct.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(be,ye,Ue){return pi.onDidChangeNotebookEditorSelection(be,ye,Ue)},onDidChangeNotebookEditorVisibleRanges(be,ye,Ue){return pi.onDidChangeNotebookEditorVisibleRanges(be,ye,Ue)},showNotebookDocument(be,ye){return Ct.showNotebookDocument(be,ye)},registerExternalUriOpener(be,ye,Ue){return(0,je.checkProposedApiEnabled)(ze,"externalUriOpener"),zi.registerExternalUriOpener(ze.identifier,be,ye,Ue)},registerProfileContentHandler(be,ye){return(0,je.checkProposedApiEnabled)(ze,"profileContentHandlers"),$i.registrProfileContentHandler(ze,be,ye)},registerQuickDiffProvider(be,ye,Ue,ot){return(0,je.checkProposedApiEnabled)(ze,"quickDiffProvider"),Oi.registerQuickDiffProvider(Et(be),ye,Ue,ot)},get tabGroups(){return rt.tabGroups}},Ii={get rootPath(){return He.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(be){throw R.readonly()},getWorkspaceFolder(be){return ft.getWorkspaceFolder(be)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(be){throw R.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(be){throw R.readonly()},updateWorkspaceFolders:(be,ye,...Ue)=>ft.updateWorkspaceFolders(ze,be,ye||0,...Ue),onDidChangeWorkspaceFolders:function(be,ye,Ue){return ft.onDidChangeWorkspace(be,ye,Ue)},asRelativePath:(be,ye)=>ft.getRelativePath(be,ye),findFiles:(be,ye,Ue,ot)=>ft.findFiles(be,ye,Ue,ze.identifier,ot),findTextInFiles:(be,ye,Ue,ot)=>{(0,je.checkProposedApiEnabled)(ze,"findTextInFiles");let It,Ot;return typeof ye=="object"?(It=ye,Ot=Ue):(It={},Ot=ye,ot=Ue),ft.findTextInFiles(be,It||{},Ot,ze.identifier,ot)},save:be=>((0,je.checkProposedApiEnabled)(ze,"saveEditor"),ft.save(be)),saveAs:be=>((0,je.checkProposedApiEnabled)(ze,"saveEditor"),ft.saveAs(be)),saveAll:be=>ft.saveAll(be),applyEdit(be,ye){return en.applyWorkspaceEdit(be,ze,ye)},createFileSystemWatcher:(be,ye,Ue,ot)=>Qt.createFileSystemWatcher(ft,ze,be,ye,Ue,ot),get textDocuments(){return kt.getAllDocumentData().map(be=>be.document)},set textDocuments(be){throw R.readonly()},openTextDocument(be){let ye;const Ue=be;if(typeof be=="string")ye=Promise.resolve(A.URI.file(be));else if(A.URI.isUri(be))ye=Promise.resolve(be);else if(!Ue||typeof Ue=="object")ye=kt.createDocumentData(Ue);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ye.then(ot=>kt.ensureDocumentData(ot).then(It=>It.document))},onDidOpenTextDocument:(be,ye,Ue)=>kt.onDidAddDocument(be,ye,Ue),onDidCloseTextDocument:(be,ye,Ue)=>kt.onDidRemoveDocument(be,ye,Ue),onDidChangeTextDocument:(be,ye,Ue)=>kt.onDidChangeDocument(be,ye,Ue),onDidSaveTextDocument:(be,ye,Ue)=>kt.onDidSaveDocument(be,ye,Ue),onWillSaveTextDocument:(be,ye,Ue)=>Ji.getOnWillSaveTextDocumentEvent(ze)(be,ye,Ue),get notebookDocuments(){return Ct.notebookDocuments.map(be=>be.apiNotebook)},async openNotebookDocument(be,ye){let Ue;if(A.URI.isUri(be))Ue=be,await Ct.openNotebookDocument(be);else if(typeof be=="string")Ue=A.URI.revive(await Ct.createNotebookDocument({viewType:be,content:ye}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Ue).apiNotebook},onDidSaveNotebookDocument(be,ye,Ue){return gi.onDidSaveNotebookDocument(be,ye,Ue)},onDidChangeNotebookDocument(be,ye,Ue){return gi.onDidChangeNotebookDocument(be,ye,Ue)},onWillSaveNotebookDocument(be,ye,Ue){return Ri.getOnWillSaveNotebookDocumentEvent(ze)(be,ye,Ue)},get onDidOpenNotebookDocument(){return Ct.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Ct.onDidCloseNotebookDocument},registerNotebookSerializer(be,ye,Ue,ot){return Ct.registerNotebookSerializer(ze,be,ye,Ue,(0,je.isProposedApiEnabled)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(be,ye,Ue)=>Hi.onDidChangeConfiguration(be,ye,Ue),getConfiguration(be,ye){return ye=arguments.length===1?void 0:ye,Hi.getConfiguration(be,ye,ze)},registerTextDocumentContentProvider(be,ye){return Pi.registerTextDocumentContentProvider(be,ye)},registerTaskProvider:(be,ye)=>(He.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),$t.registerTaskProvider(ze,be,ye)),registerFileSystemProvider(be,ye,Ue){return(0,Ge.combinedDisposable)(Li.registerFileSystemProvider(ze,be,ye,Ue),zt.addFileSystemProvider(be,ye))},get fs(){return zt.value},registerFileSearchProvider:(be,ye)=>((0,je.checkProposedApiEnabled)(ze,"fileSearchProvider"),Nt.registerFileSearchProvider(be,ye)),registerTextSearchProvider:(be,ye)=>((0,je.checkProposedApiEnabled)(ze,"textSearchProvider"),Nt.registerTextSearchProvider(be,ye)),registerRemoteAuthorityResolver:(be,ye)=>((0,je.checkProposedApiEnabled)(ze,"resolvers"),Tt.registerRemoteAuthorityResolver(be,ye)),registerResourceLabelFormatter:be=>((0,je.checkProposedApiEnabled)(ze,"resolvers"),Fi.$registerResourceLabelFormatter(be)),onDidCreateFiles:(be,ye,Ue)=>Qt.onDidCreateFile(be,ye,Ue),onDidDeleteFiles:(be,ye,Ue)=>Qt.onDidDeleteFile(be,ye,Ue),onDidRenameFiles:(be,ye,Ue)=>Qt.onDidRenameFile(be,ye,Ue),onWillCreateFiles:(be,ye,Ue)=>Qt.getOnWillCreateFileEvent(ze)(be,ye,Ue),onWillDeleteFiles:(be,ye,Ue)=>Qt.getOnWillDeleteFileEvent(ze)(be,ye,Ue),onWillRenameFiles:(be,ye,Ue)=>Qt.getOnWillRenameFileEvent(ze)(be,ye,Ue),openTunnel:be=>((0,je.checkProposedApiEnabled)(ze,"tunnels"),Ne.openTunnel(ze,be).then(ye=>{if(!ye)throw new Error("cannot open tunnel");return ye})),get tunnels(){return(0,je.checkProposedApiEnabled)(ze,"tunnels"),Ne.getTunnels()},onDidChangeTunnels:(be,ye,Ue)=>((0,je.checkProposedApiEnabled)(ze,"tunnels"),Ne.onDidChangeTunnels(be,ye,Ue)),registerPortAttributesProvider:(be,ye)=>((0,je.checkProposedApiEnabled)(ze,"portsAttributes"),Ne.registerPortsAttributesProvider(be,ye)),registerTimelineProvider:(be,ye)=>((0,je.checkProposedApiEnabled)(ze,"timeline"),Mi.registerTimelineProvider(be,ye,ze.identifier,ht.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:be=>((0,je.checkProposedApiEnabled)(ze,"workspaceTrust"),ft.requestWorkspaceTrust(be)),onDidGrantWorkspaceTrust:(be,ye,Ue)=>ft.onDidGrantWorkspaceTrust(be,ye,Ue),registerEditSessionIdentityProvider:(be,ye)=>((0,je.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(be,ye)),onWillCreateEditSessionIdentity:(be,ye,Ue)=>((0,je.checkProposedApiEnabled)(ze,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent(ze)(be,ye,Ue))},qi={get inputBox(){return He.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),vi.getLastInputBox(ze)},createSourceControl(be,ye,Ue){return vi.createSourceControl(ze,be,ye,Ue)}},rn={createCommentController(be,ye){return Ni.createCommentController(ze,be,ye)}},Gi={get activeDebugSession(){return dt.activeDebugSession},get activeDebugConsole(){return dt.activeDebugConsole},get breakpoints(){return dt.breakpoints},get stackFrameFocus(){return dt.stackFrameFocus},onDidStartDebugSession(be,ye,Ue){return dt.onDidStartDebugSession(be,ye,Ue)},onDidTerminateDebugSession(be,ye,Ue){return dt.onDidTerminateDebugSession(be,ye,Ue)},onDidChangeActiveDebugSession(be,ye,Ue){return dt.onDidChangeActiveDebugSession(be,ye,Ue)},onDidReceiveDebugSessionCustomEvent(be,ye,Ue){return dt.onDidReceiveDebugSessionCustomEvent(be,ye,Ue)},onDidChangeBreakpoints(be,ye,Ue){return dt.onDidChangeBreakpoints(be,ye,Ue)},onDidChangeStackFrameFocus(be,ye,Ue){return(0,je.checkProposedApiEnabled)(ze,"debugFocus"),dt.onDidChangeStackFrameFocus(be,ye,Ue)},registerDebugConfigurationProvider(be,ye,Ue){return dt.registerDebugConfigurationProvider(be,ye,Ue||tt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(be,ye){return dt.registerDebugAdapterDescriptorFactory(ze,be,ye)},registerDebugAdapterTrackerFactory(be,ye){return dt.registerDebugAdapterTrackerFactory(be,ye)},startDebugging(be,ye,Ue){return!Ue||typeof Ue=="object"&&"configuration"in Ue?dt.startDebugging(be,ye,{parentSession:Ue}):dt.startDebugging(be,ye,Ue||{})},stopDebugging(be){return dt.stopDebugging(be)},addBreakpoints(be){return dt.addBreakpoints(be)},removeBreakpoints(be){return dt.removeBreakpoints(be)},asDebugSourceUri(be,ye){return dt.asDebugSourceUri(be,ye)}},Ki={registerTaskProvider:(be,ye)=>$t.registerTaskProvider(ze,be,ye),fetchTasks:be=>$t.fetchTasks(be),executeTask:be=>$t.executeTask(ze,be),get taskExecutions(){return $t.taskExecutions},onDidStartTask:(be,ye,Ue)=>$t.onDidStartTask(be,ye,Ue),onDidEndTask:(be,ye,Ue)=>$t.onDidEndTask(be,ye,Ue),onDidStartTaskProcess:(be,ye,Ue)=>$t.onDidStartTaskProcess(be,ye,Ue),onDidEndTaskProcess:(be,ye,Ue)=>$t.onDidEndTaskProcess(be,ye,Ue)},sn={createNotebookController(be,ye,Ue,ot,It){return Vt.createNotebookController(ze,be,ye,Ue,ot,(0,je.isProposedApiEnabled)(ze,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(be,ye)=>Ct.registerNotebookCellStatusBarItemProvider(ze,be,ye),createRendererMessaging(be){return Ai.createRendererMessaging(ze,be)},createNotebookControllerDetectionTask(be){return(0,je.checkProposedApiEnabled)(ze,"notebookKernelSource"),Vt.createNotebookControllerDetectionTask(ze,be)},registerKernelSourceActionProvider(be,ye){return(0,je.checkProposedApiEnabled)(ze,"notebookKernelSource"),Vt.registerKernelSourceActionProvider(ze,be,ye)},onDidChangeNotebookCellExecutionState(be,ye,Ue){return(0,je.checkProposedApiEnabled)(ze,"notebookCellExecutionState"),Vt.onDidChangeNotebookCellExecutionState(be,ye,Ue)}},on={t(...be){if(typeof be[0]=="string"){const ye=be.shift(),Ue=!be||typeof be[0]!="object"?be:be[0];return ri.getMessage(ze.identifier.value,{message:ye,args:Ue})}return ri.getMessage(ze.identifier.value,be[0])},get bundle(){return ri.getBundle(ze.identifier.value)},get uri(){return ri.getBundleUri(ze.identifier.value)}},Xi={_version:1,registerInteractiveEditorSessionProvider(be){return(0,je.checkProposedApiEnabled)(ze,"interactive"),Wi.registerProvider(ze,be)},registerInteractiveSessionProvider(be,ye){return(0,je.checkProposedApiEnabled)(ze,"interactive"),ui.registerInteractiveSessionProvider(ze,be,ye)},addInteractiveRequest(be){return(0,je.checkProposedApiEnabled)(ze,"interactive"),ui.addInteractiveSessionRequest(be)},sendInteractiveRequestToProvider(be,ye){return(0,je.checkProposedApiEnabled)(ze,"interactive"),ui.sendInteractiveRequestToProvider(be,ye)},get onDidPerformUserAction(){return ui.onDidPerformUserAction}},Qi={registerSemanticSimilarityProvider(be){return(0,je.checkProposedApiEnabled)(ze,"semanticSimilarity"),Zi.registerSemanticSimilarityProvider(ze,be)}};return{version:vt.version,ai:Qi,authentication:ji,commands:Yt,comments:rn,debug:Gi,env:oi,extensions:fi,interactive:Xi,l10n:on,languages:Vi,notebooks:sn,scm:qi,tasks:Ki,tests:nn,window:xi,workspace:Ii,Breakpoint:$.Breakpoint,TerminalOutputAnchor:$.TerminalOutputAnchor,CallHierarchyIncomingCall:$.CallHierarchyIncomingCall,CallHierarchyItem:$.CallHierarchyItem,CallHierarchyOutgoingCall:$.CallHierarchyOutgoingCall,CancellationError:R.CancellationError,CancellationTokenSource:o.CancellationTokenSource,CandidatePortSource:E.CandidatePortSource,CodeAction:$.CodeAction,CodeActionKind:$.CodeActionKind,CodeActionTriggerKind:$.CodeActionTriggerKind,CodeLens:$.CodeLens,Color:$.Color,ColorInformation:$.ColorInformation,ColorPresentation:$.ColorPresentation,ColorThemeKind:$.ColorThemeKind,CommentMode:$.CommentMode,CommentState:$.CommentState,CommentThreadCollapsibleState:$.CommentThreadCollapsibleState,CommentThreadState:$.CommentThreadState,CompletionItem:$.CompletionItem,CompletionItemKind:$.CompletionItemKind,CompletionItemTag:$.CompletionItemTag,CompletionList:$.CompletionList,CompletionTriggerKind:$.CompletionTriggerKind,ConfigurationTarget:$.ConfigurationTarget,CustomExecution:$.CustomExecution,DebugAdapterExecutable:$.DebugAdapterExecutable,DebugAdapterInlineImplementation:$.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:$.DebugAdapterNamedPipeServer,DebugAdapterServer:$.DebugAdapterServer,DebugConfigurationProviderTriggerKind:tt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:$.DebugConsoleMode,DecorationRangeBehavior:$.DecorationRangeBehavior,Diagnostic:$.Diagnostic,DiagnosticRelatedInformation:$.DiagnosticRelatedInformation,DiagnosticSeverity:$.DiagnosticSeverity,DiagnosticTag:$.DiagnosticTag,Disposable:$.Disposable,DocumentHighlight:$.DocumentHighlight,DocumentHighlightKind:$.DocumentHighlightKind,DocumentLink:$.DocumentLink,DocumentSymbol:$.DocumentSymbol,EndOfLine:$.EndOfLine,EnvironmentVariableMutatorType:$.EnvironmentVariableMutatorType,EvaluatableExpression:$.EvaluatableExpression,InlineValueText:$.InlineValueText,InlineValueVariableLookup:$.InlineValueVariableLookup,InlineValueEvaluatableExpression:$.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:$.InlineCompletionTriggerKind,EventEmitter:l.Emitter,ExtensionKind:$.ExtensionKind,ExtensionMode:$.ExtensionMode,ExternalUriOpenerPriority:$.ExternalUriOpenerPriority,FileChangeType:$.FileChangeType,FileDecoration:$.FileDecoration,FileDecoration2:$.FileDecoration,FileSystemError:$.FileSystemError,FileType:k.FileType,FilePermission:k.FilePermission,FoldingRange:$.FoldingRange,FoldingRangeKind:$.FoldingRangeKind,FunctionBreakpoint:$.FunctionBreakpoint,InlineCompletionItem:$.InlineSuggestion,InlineCompletionList:$.InlineSuggestionList,Hover:$.Hover,IndentAction:p.IndentAction,Location:$.Location,MarkdownString:$.MarkdownString,OverviewRulerLane:D.OverviewRulerLane,ParameterInformation:$.ParameterInformation,PortAutoForwardAction:$.PortAutoForwardAction,Position:$.Position,ProcessExecution:$.ProcessExecution,ProgressLocation:$.ProgressLocation,QuickInputButtons:$.QuickInputButtons,Range:$.Range,RelativePattern:$.RelativePattern,Selection:$.Selection,SelectionRange:$.SelectionRange,SemanticTokens:$.SemanticTokens,SemanticTokensBuilder:$.SemanticTokensBuilder,SemanticTokensEdit:$.SemanticTokensEdit,SemanticTokensEdits:$.SemanticTokensEdits,SemanticTokensLegend:$.SemanticTokensLegend,ShellExecution:$.ShellExecution,ShellQuoting:$.ShellQuoting,SignatureHelp:$.SignatureHelp,SignatureHelpTriggerKind:$.SignatureHelpTriggerKind,SignatureInformation:$.SignatureInformation,SnippetString:$.SnippetString,SourceBreakpoint:$.SourceBreakpoint,StandardTokenType:$.StandardTokenType,StatusBarAlignment:$.StatusBarAlignment,SymbolInformation:$.SymbolInformation,SymbolKind:$.SymbolKind,SymbolTag:$.SymbolTag,Task:$.Task,TaskGroup:$.TaskGroup,TaskPanelKind:$.TaskPanelKind,TaskRevealKind:$.TaskRevealKind,TaskScope:$.TaskScope,TerminalLink:$.TerminalLink,TerminalQuickFixCommand:$.TerminalQuickFixCommand,TerminalQuickFixOpener:$.TerminalQuickFixOpener,TerminalLocation:$.TerminalLocation,TerminalProfile:$.TerminalProfile,TerminalExitReason:$.TerminalExitReason,TerminalQuickFixType:$.TerminalQuickFixType,TextDocumentSaveReason:$.TextDocumentSaveReason,TextEdit:$.TextEdit,SnippetTextEdit:$.SnippetTextEdit,TextEditorCursorStyle:P.TextEditorCursorStyle,TextEditorLineNumbersStyle:$.TextEditorLineNumbersStyle,TextEditorRevealType:$.TextEditorRevealType,TextEditorSelectionChangeKind:$.TextEditorSelectionChangeKind,TextDocumentChangeReason:$.TextDocumentChangeReason,ThemeColor:$.ThemeColor,ThemeIcon:$.ThemeIcon,TreeItem:$.TreeItem,TreeItem2:$.TreeItem,TreeItemCheckboxState:$.TreeItemCheckboxState,TreeItemCollapsibleState:$.TreeItemCollapsibleState,TypeHierarchyItem:$.TypeHierarchyItem,UIKind:T.UIKind,Uri:A.URI,ViewColumn:$.ViewColumn,WorkspaceEdit:$.WorkspaceEdit,DocumentDropEdit:$.DocumentDropEdit,DocumentPasteEdit:$.DocumentPasteEdit,InlayHint:$.InlayHint,InlayHintLabelPart:$.InlayHintLabelPart,InlayHintKind:$.InlayHintKind,RemoteAuthorityResolverError:$.RemoteAuthorityResolverError,ResolvedAuthority:$.ResolvedAuthority,SourceControlInputBoxValidationType:$.SourceControlInputBoxValidationType,ExtensionRuntime:$.ExtensionRuntime,TimelineItem:$.TimelineItem,NotebookRange:$.NotebookRange,NotebookCellKind:$.NotebookCellKind,NotebookCellExecutionState:$.NotebookCellExecutionState,NotebookCellData:$.NotebookCellData,NotebookData:$.NotebookData,NotebookRendererScript:$.NotebookRendererScript,NotebookCellStatusBarAlignment:$.NotebookCellStatusBarAlignment,NotebookEditorRevealType:$.NotebookEditorRevealType,NotebookCellOutput:$.NotebookCellOutput,NotebookCellOutputItem:$.NotebookCellOutputItem,NotebookCellStatusBarItem:$.NotebookCellStatusBarItem,NotebookControllerAffinity:$.NotebookControllerAffinity,NotebookControllerAffinity2:$.NotebookControllerAffinity2,NotebookEdit:$.NotebookEdit,NotebookKernelSourceAction:$.NotebookKernelSourceAction,PortAttributes:$.PortAttributes,LinkedEditingRanges:$.LinkedEditingRanges,TestResultState:$.TestResultState,TestRunRequest:$.TestRunRequest,TestRunRequest2:$.TestRunRequest2,TestMessage:$.TestMessage,TestTag:$.TestTag,TestRunProfileKind:$.TestRunProfileKind,TextSearchCompleteMessageType:Fe.TextSearchCompleteMessageType,DataTransfer:$.DataTransfer,DataTransferItem:$.DataTransferItem,CoveredCount:$.CoveredCount,FileCoverage:$.FileCoverage,StatementCoverage:$.StatementCoverage,BranchCoverage:$.BranchCoverage,FunctionCoverage:$.FunctionCoverage,WorkspaceTrustState:$.WorkspaceTrustState,LanguageStatusSeverity:$.LanguageStatusSeverity,QuickPickItemKind:$.QuickPickItemKind,InputBoxValidationSeverity:$.InputBoxValidationSeverity,TabInputText:$.TextTabInput,TabInputTextDiff:$.TextDiffTabInput,TabInputTextMerge:$.TextMergeTabInput,TabInputCustom:$.CustomEditorTabInput,TabInputNotebook:$.NotebookEditorTabInput,TabInputNotebookDiff:$.NotebookDiffEditorTabInput,TabInputWebview:$.WebviewEditorTabInput,TabInputTerminal:$.TerminalEditorTabInput,TabInputInteractiveWindow:$.InteractiveWindowInput,TelemetryTrustedValue:Y.TelemetryTrustedValue,LogLevel:re.LogLevel,EditSessionIdentityMatch:at.EditSessionIdentityMatch,InteractiveSessionVoteDirection:$.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:$.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:$.InteractiveEditorResponseFeedbackKind}}}e.createApiFactoryAndRegisterActors=Rt}),define(Ce[316],ke([1,0,91,143,34,140,35,41,60,42,84,86,87,100,56,79,142,80,49,99,78,61,141,16,50,98]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d,h,y,w,g,t,s,r,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(a.IExtHostLocalizationService,a.ExtHostLocalizationService,1),(0,o.registerSingleton)(s.ILoggerService,t.ExtHostLoggerService,1),(0,o.registerSingleton)(v.IExtHostApiDeprecationService,v.ExtHostApiDeprecationService,1),(0,o.registerSingleton)(P.IExtHostCommands,P.ExtHostCommands,0),(0,o.registerSingleton)(A.IExtHostConfiguration,A.ExtHostConfiguration,0),(0,o.registerSingleton)(d.IExtHostConsumerFileSystem,d.ExtHostConsumerFileSystem,0),(0,o.registerSingleton)(k.IExtHostDebugService,k.WorkerExtHostDebugService,0),(0,o.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,0),(0,o.registerSingleton)(D.IExtHostDocumentsAndEditors,D.ExtHostDocumentsAndEditors,0),(0,o.registerSingleton)(h.IExtHostFileSystemInfo,h.ExtHostFileSystemInfo,0),(0,o.registerSingleton)(R.IExtHostOutputService,R.ExtHostOutputService,1),(0,o.registerSingleton)(E.IExtHostSearch,E.ExtHostSearch,0),(0,o.registerSingleton)(T.IExtHostStorage,T.ExtHostStorage,0),(0,o.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,o.registerSingleton)(p.IExtHostTerminalService,p.WorkerExtHostTerminalService,0),(0,o.registerSingleton)(I.IExtHostTunnelService,I.ExtHostTunnelService,0),(0,o.registerSingleton)(i.IExtHostWindow,i.ExtHostWindow,0),(0,o.registerSingleton)(l.IExtHostWorkspace,l.ExtHostWorkspace,0),(0,o.registerSingleton)(y.IExtHostSecretState,y.ExtHostSecretState,0),(0,o.registerSingleton)(w.IExtHostTelemetry,w.ExtHostTelemetry,0),(0,o.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs,0),(0,o.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,0)}),define(Ce[101],ke([1,0,18,16,31,83]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function A(k){return k.startsWith("**")||k.startsWith("/")?k:`/${k}`}e.anchorGlob=A;function P(k,E,T,I){const v=(0,o.mapArrayOrNot)(T,D),i=new l.TextSearchMatch(E,v,I),d=i.preview.matches;return{ranges:(0,o.mapArrayOrNot)(v,p),uri:k,preview:{text:i.preview.text,matches:(0,o.mapArrayOrNot)(d,p)}}}e.createTextSearchResult=P;function D(k){return new l.SearchRange(k.start.line,k.start.character,k.end.line,k.end.character)}function p(k){return new L.Range(k.startLineNumber,k.startColumn,k.endLineNumber,k.endColumn)}let O=e.OutputChannel=class{constructor(E,T){this.a=E,this.b=T}appendLine(E){this.b.debug(`${this.a}#search`,E)}};e.OutputChannel=O=xe([We(1,R.ILogService)],O)}),define(Ce[317],ke([1,0,47,15,88,33,14,9,101]),function(ae,e,o,R,l,L,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const O="/bin/rg".replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function k(y,w,g,t){const s=E(y,w,g,t),r=w.folder.fsPath;return{cmd:o.spawn(O,s.args,{cwd:r}),rgDiskPath:O,siblingClauses:s.siblingClauses,rgArgs:s,cwd:r}}e.spawnRipgrepCmd=k;function E(y,w,g,t){const s=["--files","--hidden","--case-sensitive"];I([w],g,!1).forEach(a=>{const b=(0,D.anchorGlob)(a);if(s.push("-g",b),A.isMacintosh){const S=(0,l.normalizeNFD)(b);S!==b&&s.push("-g",S)}});const r=T([w],t,void 0,!1);return r.globArgs.forEach(a=>{const b=`!${(0,D.anchorGlob)(a)}`;if(s.push("-g",b),A.isMacintosh){const S=(0,l.normalizeNFD)(b);S!==b&&s.push("-g",S)}}),w.disregardIgnoreFiles!==!1?s.push("--no-ignore"):w.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),w.ignoreSymlinks||s.push("--follow"),y.exists&&s.push("--quiet"),s.push("--no-config"),w.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:r.siblingClauses}}function T(y,w,g,t=!0){const s=[];let r={};return y.forEach(a=>{const b=Object.assign({},a.excludePattern||{},w||{}),S=v(b,t?a.folder.fsPath:void 0,g);s.push(...S.globArgs),S.siblingClauses&&(r=Object.assign(r,S.siblingClauses))}),{globArgs:s,siblingClauses:r}}function I(y,w,g=!0){const t=[];return y.forEach(s=>{const r=Object.assign({},w||{},s.includePattern||{}),a=v(r,g?s.folder.fsPath:void 0);t.push(...a.globArgs)}),t}function v(y,w,g){const t=[],s={};return Object.keys(y).forEach(r=>{if(g&&g.has(r)||!r)return;const a=y[r];r=d(w?i(w,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof a=="boolean"&&a?(r.startsWith("\\\\")&&(r+="**"),t.push(h(r))):a&&a.when&&(s[r]=a)}),{globArgs:t,siblingClauses:s}}function i(y,w){return R.isAbsolute(w)?w:R.join(y,w)}e.getAbsoluteGlob=i;function d(y){return y=P.rtrim(y,"\\"),P.rtrim(y,"/")}function h(y){return L.getRoot(y).toLowerCase()==="c:/"?y.replace(/^c:[/\\]/i,"/"):y}e.fixDriveC=h}),define(Ce[318],ke([1,0,47,71,15,319,18,46,39,88,33,14,37,9,10,29,31,317,112]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const y=new Set;process.on("exit",()=>{y.forEach(r=>r())});class w{constructor(a){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=a,this.b=a.filePattern||"",this.d=a.includePattern&&D.parse(a.includePattern),this.f=a.maxResults||null,this.g=!!a.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,h.prepareQuery)(this.b).normalizedLowercase),this.u=a.excludePattern&&D.parse(a.excludePattern),this.t=new Map,a.folderQueries.forEach(b=>{const S=Object.assign({},b.excludePattern||{},this.a.excludePattern||{}),c=b.folder.fsPath;a.folderQueries.map(u=>u.folder.fsPath).filter(u=>u!==c).forEach(u=>{(0,O.isEqualOrParent)(u,c)&&(S[l.relative(c,u)]=!0)}),this.t.set(c,new t(S,c))})}cancel(){this.l=!0,y.forEach(a=>a())}walk(a,b,S,c,u){if(this.m=E.StopWatch.create(!1),this.l)return u(null,this.j);b.forEach(m=>{const f=l.basename(m.fsPath);this.u&&this.u(m.fsPath,f)||this.J(S,{relativePath:m.fsPath,searchPath:void 0})}),this.r=E.StopWatch.create(!1),this.w(a,(m,f)=>{this.x(this.y,this,m,S,c,n=>{if(n){const C=(0,P.toErrorMessage)(n);console.error(C),this.q.push(C),f(n,void 0)}else f(null,void 0)})},(m,f)=>{this.m.stop();const n=m?A.coalesce(m)[0]:null;u(n,this.j)})}w(a,b,S){const c=new Array(a.length),u=new Array(a.length);let m=!1,f=0;if(a.length===0)return S(null,[]);a.forEach((n,C)=>{b(n,(M,H)=>{if(M?(m=!0,c[C]=null,u[C]=M):(c[C]=H,u[C]=null),++f===a.length)return S(m?u:null,c)})})}x(a,b,...S){try{a.apply(b,S)}catch(c){S[S.length-1](c)}}y(a,b,S,c){const u=a.folder.fsPath,m=k.isMacintosh,f=()=>V&&V.kill();y.add(f);let n=F=>{y.delete(f),n=()=>{},c(F)},C="";const M=this.D(),H=(0,d.spawnRipgrepCmd)(this.a,a,this.a.includePattern,this.t.get(a.folder.fsPath).expression),V=H.cmd,U=!Object.keys(H.siblingClauses).length,z=H.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let G=`${H.rgDiskPath} ${z}
 - cwd: ${H.cwd}`;H.rgArgs.siblingClauses&&(G+=`
 - Sibling clauses: ${JSON.stringify(H.rgArgs.siblingClauses)}`),S({message:G}),this.s=0,this.z(V,"utf8",S,(F,$,Y)=>{if(F){n(F);return}if(this.j){n();return}const Q=(C+(m?p.normalizeNFC($||""):$)).split(`
`);if(Y){const ie=Q.length;Q[ie-1]=Q[ie-1].trim(),Q[ie-1]||Q.pop()}else C=Q.pop()||"";if(Q.length&&Q[0].indexOf(`
`)!==-1){n(new Error("Splitting up files failed"));return}if(this.s+=Q.length,U){for(const ie of Q)if(this.J(b,{base:u,relativePath:ie,searchPath:this.N(a,ie)}),this.j){f();break}(Y||this.j)&&n();return}this.G(a,M,u,Q,b),Y&&(this.H(M,u,b),n())})}spawnFindCmd(a){const b=this.t.get(a.folder.fsPath),S=b.getBasenameTerms(),c=b.getPathTerms(),u=["-L","."];if(S.length||c.length){u.push("-not","(","(");for(const m of S)u.push("-name",m),u.push("-o");for(const m of c)u.push("-path",m),u.push("-o");u.pop(),u.push(")","-prune",")")}return u.push("-type","f"),o.spawn("find",u,{cwd:a.folder.fsPath})}readStdout(a,b,S){let c="";this.z(a,b,()=>{},(u,m,f)=>{if(u){S(u);return}c+=m,f&&S(null,c)})}z(a,b,S,c){let u=(n,C,M)=>{(n||M)&&(u=()=>{},this.r?.stop()),c(n,C,M)},m=!1;a.stdout?(this.A(a.stdout,b,u),a.stdout.once("data",()=>m=!0)):S({message:"stdout is null"});let f;a.stderr?f=this.B(a.stderr):S({message:"stderr is null"}),a.on("error",n=>{u(n)}),a.on("close",n=>{let C;!m&&(C=this.C(f,b))&&s(C)?u(new Error(`command failed with error code ${n}: ${this.C(f,b)}`)):(this.g&&n===0&&(this.j=!0),u(null,"",!0))})}A(a,b,S){const c=new L.StringDecoder(b);return a.on("data",u=>{S(null,c.write(u))}),c}B(a){const b=[];return a.on("data",S=>{b.push(S)}),b}C(a,b){const S=new L.StringDecoder(b);return a.map(c=>S.write(c)).join("")}D(){const a={rootEntries:[],pathToEntries:Object.create(null)};return a.pathToEntries["."]=a.rootEntries,a}G(a,{pathToEntries:b},S,c,u){c.indexOf(this.b)!==-1&&this.J(u,{base:S,relativePath:this.b,searchPath:this.N(a,this.b)});const m=f=>{const n=l.basename(f),C=l.dirname(f);let M=b[C];M||(M=b[C]=[],m(C)),M.push({base:S,relativePath:f,basename:n,searchPath:this.N(a,f)})};c.forEach(m)}H({rootEntries:a,pathToEntries:b},S,c){const u=this,m=this.t.get(S),f=this.b;function n(C){u.o++;const M=(0,i.hasSiblingFn)(()=>C.map(H=>H.basename));for(let H=0,V=C.length;H<V;H++){const U=C[H],{relativePath:z,basename:G}=U;if(m.test(z,G,f!==G?M:void 0))continue;const F=b[z];if(F)n(F);else{if(u.p++,z===f)continue;u.J(c,U)}if(u.j)break}}n(a)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(a,b,S,c,u){const m=a.folder,f=(0,i.hasSiblingFn)(()=>S);this.w(S,(n,C)=>{if(this.l||this.j)return C(null);const M=b?[b,n].join(l.sep):n;if(this.t.get(a.folder.fsPath).test(M,n,this.a.filePattern!==n?f:void 0))return C(null);const H=[m.fsPath,M].join(l.sep);R.lstat(H,(V,U)=>{if(V||this.l||this.j)return C(null);this.L(H,U,(z,G)=>z||this.l||this.j?C(null):G.isDirectory()?(this.o++,this.M(H,U,(F,$)=>F||this.l||this.j||($=$||"",this.v[$])?C(null):(this.v[$]=!0,v.Promises.readdir(H).then(Y=>{if(this.l||this.j)return C(null);this.I(a,M,Y,c,_=>C(_||null))},Y=>{C(null)})))):(this.p++,M===this.b||this.h&&I.isNumber(G.size)&&G.size>this.h||this.J(c,{base:m.fsPath,relativePath:M,searchPath:this.N(a,M)}),C(null,void 0)))})},n=>{const C=n&&A.coalesce(n);return u(C&&C.length>0?C[0]:void 0)})}J(a,b){this.K(b)&&(!this.d||this.d(b.relativePath,l.basename(b.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||a(b))}K(a){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,i.isFilePatternMatch)(a,this.c)}return!0}L(a,b,S){return b.isSymbolicLink()?R.stat(a,S):S(null,b)}M(a,b,S){return b.isSymbolicLink()?R.realpath(a,(c,u)=>c?S(c):S(null,u)):S(null,a)}N(a,b){return a.folderName?l.join(a.folderName,b):b}}e.FileWalker=w;class g{constructor(a){this.a=a.folderQueries,this.b=a.extraFileResources||[],this.c=new w(a)}search(a,b,S){this.c.walk(this.a,this.b,a,b,(c,u)=>{S(c,{limitHit:u,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=g;class t{constructor(a,b){this.expression=a,this.c=b,this.d(a)}d(a){let b,S;Object.keys(a).filter(c=>a[c]).forEach(c=>{l.isAbsolute(c)?(b=b||D.getEmptyExpression(),b[c]=a[c]):(S=S||D.getEmptyExpression(),S[c]=a[c])}),this.a=b&&D.parse(b,{trimForExclusions:!0}),this.b=S&&D.parse(S,{trimForExclusions:!0})}test(a,b,S){return this.b&&this.b(a,b,S)||this.a&&this.a(l.join(this.c,a),b,S)}getBasenameTerms(){const a=[];return this.a&&a.push(...D.getBasenameTerms(this.a)),this.b&&a.push(...D.getBasenameTerms(this.b)),a}getPathTerms(){const a=[];return this.a&&a.push(...D.getPathTerms(this.a)),this.b&&a.push(...D.getPathTerms(this.b)),a}}function s(r){const a=r.trim().split(`
`),b=a[0].trim();if(b.startsWith("Error parsing regex"))return b;if(b.startsWith("regex parse error"))return T.uppercaseFirstLetter(a[a.length-1].trim());if(b.startsWith("error parsing glob")||b.startsWith("unsupported encoding"))return b.charAt(0).toUpperCase()+b.substr(1);if(b==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(b.startsWith("Literal "))return b}}),define(Ce[320],ke([1,0,104,22]),function(ae,e,o,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function l(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(a=>a===r)}e.isUTFEncoding=l,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const L=512,A=512,P=512*8,D=512*128;var p;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(p||(e.DecodeStreamErrorKind=p={}));class O extends Error{constructor(a,b){super(a),this.decodeStreamErrorKind=b}}e.DecodeStreamError=O;class k{static async create(a){let b;if(a!==e.UTF8)b=(await new Promise((c,u)=>{ae(["@vscode/iconv-lite-umd"],c,u)})).getDecoder(v(a));else{const S=new TextDecoder;b={write(c){return S.decode(c,{stream:!0})},end(){return S.decode()}}}return new k(b)}constructor(a){this.a=a}write(a){return this.a.write(a)}end(){return this.a.end()}}function E(r,a){const b=a.minBytesRequiredForDetection??a.guessEncoding?P:A;return new Promise((S,c)=>{const u=(0,o.newWriteableStream)(H=>H.join("")),m=[];let f=0,n;const C=async()=>{try{const H=await s({buffer:R.VSBuffer.concat(m),bytesRead:f},a.guessEncoding);if(H.seemsBinary&&a.acceptTextOnly)throw new O("Stream is binary but only text is accepted for decoding",1);H.encoding=await a.overwriteEncoding(H.encoding),n=await k.create(H.encoding);const V=n.write(R.VSBuffer.concat(m).buffer);u.write(V),m.length=0,f=0,S({stream:u,detected:H})}catch(H){M?.dispose(),u.destroy(),c(H)}},M=(0,o.listenStream)(r,{onData:async H=>{n?u.write(n.write(H.buffer)):(m.push(H),f+=H.byteLength,f>=b&&(r.pause(),await C(),setTimeout(()=>r.resume())))},onError:H=>u.error(H),onEnd:async()=>{n||await C(),u.end(n?.end())}})})}e.toDecodeStream=E;async function T(r,a,b){const c=(await new Promise((f,n)=>{ae(["@vscode/iconv-lite-umd"],f,n)})).getEncoder(v(a),b);let u=!1,m=!1;return{read(){if(m)return null;const f=r.read();if(typeof f!="string"){if(m=!0,!u&&b?.addBOM)switch(a){case e.UTF8:case e.UTF8_with_bom:return R.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return R.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const n=c.end();return n&&n.length>0?(u=!0,R.VSBuffer.wrap(n)):null}return u=!0,R.VSBuffer.wrap(c.write(f))}}}e.toEncodeReadable=T;async function I(r){return(await new Promise((b,S)=>{ae(["@vscode/iconv-lite-umd"],b,S)})).encodingExists(v(r))}e.encodingExists=I;function v(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=v;function i(r,a){if(!r||a<e.UTF16be_BOM.length)return null;const b=r.readUInt8(0),S=r.readUInt8(1);if(b===e.UTF16be_BOM[0]&&S===e.UTF16be_BOM[1])return e.UTF16be;if(b===e.UTF16le_BOM[0]&&S===e.UTF16le_BOM[1])return e.UTF16le;if(a<e.UTF8_BOM.length)return null;const c=r.readUInt8(2);return b===e.UTF8_BOM[0]&&S===e.UTF8_BOM[1]&&c===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=i;const d=["ascii","utf-16","utf-32"];async function h(r){const a=await new Promise((m,f)=>{ae(["jschardet"],m,f)}),b=r.slice(0,D),S=g(b.buffer),c=a.detect(S);if(!c||!c.encoding)return null;const u=c.encoding.toLowerCase();return 0<=d.indexOf(u)?null:w(c.encoding)}const y={ibm866:"cp866",big5:"cp950"};function w(r){const a=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return y[a]||a}function g(r){let a="";for(let b=0;b<r.length;b++)a+=String.fromCharCode(r[b]);return a}function t(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const a=r.match(/windows(\d+)/);return a?"windows-"+a[1]:r}}}e.toCanonicalName=t;function s({buffer:r,bytesRead:a},b){let S=i(r,a),c=!1;if(S!==e.UTF16be&&S!==e.UTF16le&&r){let u=!0,m=!0,f=!1;for(let n=0;n<a&&n<L;n++){const C=n%2===1,M=r.readUInt8(n)===0;if(M&&(f=!0),u&&(C&&!M||!C&&M)&&(u=!1),m&&(C&&M||!C&&!M)&&(m=!1),M&&!u&&!m)break}f&&(u?S=e.UTF16le:m?S=e.UTF16be:c=!0)}return b&&!c&&!S&&r?h(r.slice(0,a)).then(u=>({seemsBinary:!1,encoding:u})):{seemsBinary:c,encoding:S}}e.detectEncodingFromBuffer=s,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(Ce[145],ke([1,0,320,29,144]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class L extends l.TextSearchManager{constructor(P,D,p=R,O="searchProcess"){super(P,D,{readdir:k=>p.Promises.readdir(k.fsPath),toCanonicalName:k=>(0,o.toCanonicalName)(k)},O)}}e.NativeTextSearchManager=L}),define(Ce[146],ke([1,0,47,333,319,18,62,39,15,9,2,31,83,334,101]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const i="/bin/rg".replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class d{constructor(n){this.a=n}provideTextSearchResults(n,C,M,H){return this.a.appendLine(`provideTextSearchResults ${n.pattern}, ${JSON.stringify({...C,folder:C.folder.toString()})}`),new Promise((V,U)=>{H.onCancellationRequested(()=>ie());const z=s(n,C),G=C.folder.fsPath,F=z.map(x=>x.match(/^-/)?x:`'${x}'`).join(" ");this.a.appendLine(`${i} ${F}
 - cwd: ${G}`);let $=o.spawn(i,z,{cwd:G});$.on("error",x=>{console.error(x),this.a.appendLine("Error: "+(x&&x.message)),U((0,k.serializeSearchError)(new k.SearchError(x&&x.message,k.SearchErrorCode.rgProcessError)))});let Y=!1;const _=new w(C.maxResults,G,C.previewOptions);_.on("result",x=>{Y=!0,Ee="",M.report(x)});let Q=!1;const ie=()=>{Q=!0,$?.kill(),_?.cancel()};let oe=!1;_.on("hitLimit",()=>{oe=!0,ie()});let Ee="";$.stdout.on("data",x=>{_.handleData(x),Y||(Ee+=x)});let he=!1;$.stdout.once("data",()=>he=!0);let fe="";$.stderr.on("data",x=>{const B=x.toString();this.a.appendLine(B),fe.length+B.length<1e6&&(fe+=B)}),$.on("close",()=>{if(this.a.appendLine(he?"Got data from stdout":"No data from stdout"),this.a.appendLine(Y?"Got result from parser":"No result from parser"),Ee&&this.a.appendLine(`Got data without result: ${Ee}`),this.a.appendLine(""),Q)V({limitHit:oe});else{_.flush(),$=null;let x;fe&&!he&&(x=h(fe))?U((0,k.serializeSearchError)(new k.SearchError(x.message,x.code))):V({limitHit:oe})}})})}}e.RipgrepTextSearchEngine=d;function h(f){const n=f.split(`
`),C=n[0].trim();if(n.some(H=>H.startsWith("regex parse error")))return new k.SearchError(y(n),k.SearchErrorCode.regexParseError);const M=C.match(/grep config error: unknown encoding: (.*)/);if(M)return new k.SearchError(`Unknown encoding: ${M[1]}`,k.SearchErrorCode.unknownEncoding);if(C.startsWith("error parsing glob"))return new k.SearchError(C.charAt(0).toUpperCase()+C.substr(1),k.SearchErrorCode.globParseError);if(C.startsWith("the literal"))return new k.SearchError(C.charAt(0).toUpperCase()+C.substr(1),k.SearchErrorCode.invalidLiteral);if(C.startsWith("PCRE2: error compiling pattern"))return new k.SearchError(C,k.SearchErrorCode.regexParseError)}function y(f){const n=["Regex parse error"],C=f.filter(M=>M.startsWith("PCRE2:"));if(C.length>=1){const M=C[0].replace("PCRE2:","");if(M.indexOf(":")!==-1&&M.split(":").length>=2){const H=M.split(":")[1];n.push(":"+H)}}return n.join("")}class w extends R.EventEmitter{constructor(n,C,M){super(),this.g=n,this.h=C,this.j=M,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new l.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(n,C){return super.on(n,C),this}handleData(n){if(this.b)return;const C=typeof n=="string"?n:this.d.write(n);this.k(C)}k(n){let C=n.indexOf(`
`);const M=this.a+n;if(C>=0)C+=this.a.length;else{this.a=M;return}let H=0;for(;C>=0;)this.m(M.substring(H,C).trim()),H=C+1,C=M.indexOf(`
`,H);this.a=M.substring(H)}m(n){if(this.b||!n)return;let C;try{C=JSON.parse(n)}catch{throw new Error(`malformed line from rg: ${n}`)}if(C.type==="match"){const M=g(C.data.path),H=O.URI.file(D.join(this.h,M)),V=this.n(C.data,H);this.p(V),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(C.type==="context"){const M=g(C.data.path),H=O.URI.file(D.join(this.h,M));this.o(C.data,H).forEach(U=>this.p(U))}}n(n,C){const M=n.line_number-1,H=g(n.lines),V=Buffer.from(H);let U=0,z=0,G=M;n.submatches.length===0&&n.submatches.push(H.length?{start:0,end:1,match:{text:H[0]}}:{start:0,end:0,match:{text:""}});const F=(0,L.coalesce)(n.submatches.map(($,Y)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const _=g($.match),Q=V.slice(U,$.start).toString(),ie=t(Q),oe=ie.numLines>0?ie.lastLineLength:ie.lastLineLength+z,Ee=t(_),he=ie.numLines+G,fe=Ee.numLines+he,x=Ee.numLines>0?Ee.lastLineLength:Ee.lastLineLength+oe;return U=$.end,z=x,G=fe,new E.Range(he,oe,fe,x)}));return(0,I.createTextSearchResult)(C,H,F,this.j)}o(n,C){const M=g(n.lines),H=n.line_number;return M.replace(/\r?\n$/,"").split(`
`).map((V,U)=>({text:V,uri:C,lineNumber:H+U}))}p(n){this.emit("result",n)}}e.RipgrepParser=w;function g(f){return f.bytes?Buffer.from(f.bytes,"base64").toString():f.text}function t(f){const n=/\n/g;let C=0,M=-1,H;for(;H=n.exec(f);)C++,M=H.index;const V=M>=0?f.length-M-1:f.length;return{numLines:C,lastLineLength:V}}function s(f,n){const C=["--hidden"];C.push(f.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:M,otherIncludes:H}=(0,A.groupBy)(n.includes,U=>U.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(H&&H.length){const U=new Set;H.forEach(z=>{U.add(z)}),C.push("-g","!*"),U.forEach(z=>{r(z).map(I.anchorGlob).forEach(G=>{C.push("-g",G)})})}M&&M.length&&M.forEach(U=>{C.push("-g",U)}),n.excludes.map(I.anchorGlob).forEach(U=>C.push("-g",`!${U}`)),n.maxFileSize&&C.push("--max-filesize",n.maxFileSize+""),n.useIgnoreFiles?n.useParentIgnoreFiles||C.push("--no-ignore-parent"):C.push("--no-ignore"),n.followSymlinks&&C.push("--follow"),n.encoding&&n.encoding!=="utf8"&&C.push("--encoding",n.encoding),f.pattern==="--"&&(f.isRegExp=!0,f.pattern="\\-\\-"),f.isMultiline&&!f.isRegExp&&(f.pattern=(0,p.escapeRegExpCharacters)(f.pattern),f.isRegExp=!0),n.usePCRE2&&C.push("--pcre2"),C.push("--crlf"),f.isRegExp&&(f.pattern=a(f.pattern),C.push("--engine","auto"));let V;if(f.isWordMatch){const z=(0,p.createRegExp)(f.pattern,!!f.isRegExp,{wholeWord:f.isWordMatch}).source.replace(/\\\//g,"/");C.push("--regexp",z)}else if(f.isRegExp){let U=S(f.pattern);U=c(U),C.push("--regexp",U)}else V=f.pattern,C.push("--fixed-strings");return C.push("--no-config"),n.useGlobalIgnoreFiles||C.push("--no-ignore-global"),C.push("--json"),f.isMultiline&&C.push("--multiline"),n.beforeContext&&C.push("--before-context",n.beforeContext+""),n.afterContext&&C.push("--after-context",n.afterContext+""),C.push("--"),V&&C.push(V),C.push("."),C}e.getRgArgs=s;function r(f){return m(f).flatMap(C=>{const M=(0,P.splitGlobAware)(C,"/");return M.map((H,V)=>M.slice(0,V+1).join("/"))})}function a(f){const n=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;f.match(n);)f=f.replace(n,"$1\\x{$2}");const C=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;f.match(C);)f=f.replace(C,"$1\\x{$2}");return f}e.unicodeEscapesToPCRE2=a;const b=f=>f.type==="Assertion"&&f.kind==="lookbehind";function S(f){let n;try{n=new T.RegExpParser().parsePattern(f)}catch{return f}let C="",M=0;const H=(z,G,F)=>{C+=f.slice(M,z)+F,M=G},V=[];return new T.RegExpVisitor({onCharacterEnter(z){if(z.raw!=="\\n")return;const G=V[0];if(!G)H(z.start,z.end,"\\r?\\n");else if(!V.some(b))if(G.type==="CharacterClass")if(G.negate){const F=f.slice(G.start+2,z.start)+f.slice(z.end,G.end-1);G.parent?.type==="Quantifier"?H(G.start,G.end,F?`[^${F}]`:"."):H(G.start,G.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=f.slice(G.start+1,z.start)+f.slice(z.end,G.end-1);H(G.start,G.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else G.type==="Quantifier"&&H(z.start,z.end,"(?:\\r?\\n)")},onQuantifierEnter(z){V.unshift(z)},onQuantifierLeave(){V.shift()},onCharacterClassRangeEnter(z){V.unshift(z)},onCharacterClassRangeLeave(){V.shift()},onCharacterClassEnter(z){V.unshift(z)},onCharacterClassLeave(){V.shift()},onAssertionEnter(z){b(z)&&V.push(z)},onAssertionLeave(z){V[0]===z&&V.shift()}}).visit(n),C+=f.slice(M),C}e.fixRegexNewline=S;function c(f){return f.replace(/\n/g,"\\r?\\n")}e.fixNewline=c;function u(f){let n=!1,C=!1,M="",H="";for(let V=0;V<f.length;V++){const U=f[V];switch(U){case"\\":C?(n?H+="\\"+U:M+="\\"+U,C=!1):C=!0;break;case"{":if(C)n?H+=U:M+=U,C=!1;else{if(n)return{strInBraces:M+"{"+H+"{"+f.substring(V+1)};n=!0}break;case"}":if(C)n?H+=U:M+=U,C=!1;else{if(n)return{fixedStart:M,strInBraces:H,fixedEnd:f.substring(V+1)};M+=U}break;default:n?H+=(C?"\\":"")+U:M+=(C?"\\":"")+U,C=!1;break}}return{strInBraces:M+(n?"{"+H:"")}}function m(f){const{fixedStart:n,strInBraces:C,fixedEnd:M}=u(f);if(n===void 0||M===void 0)return[C];let H=(0,P.splitGlobAware)(C,",");H.length||(H=[""]);const V=m(M);return H.flatMap(U=>{const z=n+U;return V.map(G=>z+G)})}e.performBraceExpansionForRipgrep=m}),define(Ce[321],ke([1,0,21,146,125,17]),function(ae,e,o,R,l,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class A{constructor(p){this.b=p,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(p,O,k,E){const T=new R.RipgrepTextSearchEngine(this.b);if(O.folder.scheme===L.Schemas.vscodeUserData){const I={...O,folder:O.folder.with({scheme:L.Schemas.file})},v=new l.Progress(i=>k.report({...i,uri:i.uri.with({scheme:O.folder.scheme})}));return this.c(E,i=>T.provideTextSearchResults(p,I,v,i))}else return this.c(E,I=>T.provideTextSearchResults(p,O,k,I))}async c(p,O){const k=P(p);this.a.add(k);const E=await O(k.token);return this.a.delete(k),E}d(){this.a.forEach(p=>p.cancel())}}e.RipgrepSearchProvider=A;function P(D){const p=new o.CancellationTokenSource;return D.onCancellationRequested(()=>p.cancel()),p}}),define(Ce[322],ke([1,0,29,146,145]),function(ae,e,o,R,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class L{constructor(D){this.a=D}search(D,p,O){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const k={appendLine(T){O({message:T})}},E=new l.NativeTextSearchManager(this.a,new R.RipgrepTextSearchEngine(k),o);return new Promise((T,I)=>E.search(v=>{p(v.map(A))},D).then(v=>T({limitHit:v.limitHit,type:"success",stats:v.stats}),I))}}e.TextSearchEngineAdapter=L;function A(P){return{path:P.resource&&P.resource.fsPath,results:P.results,numMatches:(P.results||[]).reduce((D,p)=>{if(p.ranges){const O=p;return D+(Array.isArray(O.ranges)?O.ranges.length:1)}else return D+1},0)}}}),define(Ce[323],ke([1,0,18,19,8,3,112,15,37,2,45,31,318,322]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class I{constructor(w="searchProcess"){this.d=w,this.b=Object.create(null)}fileSearch(w){let g;const t=d(w),s=new L.Emitter({onDidAddFirstListener:()=>{g=(0,R.createCancelablePromise)(r=>this.doFileSearchWithEngine(E.Engine,t,a=>s.fire(a),r)),g.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return s.event}textSearch(w){let g;const t=d(w),s=new L.Emitter({onDidAddFirstListener:()=>{g=(0,R.createCancelablePromise)(r=>this.f(t,a=>s.fire(a),r)),g.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return s.event}f(w,g,t){return w.maxFileSize=this.g().maxFileSize,new T.TextSearchEngineAdapter(w).search(t,g,g)}g(){return{maxFileSize:process.arch==="ia32"?300*O.ByteSize.MB:16*O.ByteSize.GB}}doFileSearch(w,g,t){return this.doFileSearchWithEngine(E.Engine,w,g,t)}doFileSearchWithEngine(w,g,t,s,r=I.a){let a=0;const b=c=>{Array.isArray(c)?(a+=c.length,t(c.map(u=>this.h(u)))):c.relativePath?(a++,t(this.h(c))):t(c)};if(g.sortByScore){let c=this.l(g,b,s);if(!c){const u=g.maxResults?Object.assign({},g,{maxResults:null}):g,m=new w(u);c=this.j(m,g,t,b,s)}return new Promise((u,m)=>{c.then(([f,n])=>{const C=n.map(M=>this.h(M));this.o(C,t,r),u(f)},m)})}const S=new w(g);return this.r(S,b,r,s).then(c=>({limitHit:c.limitHit,type:"success",stats:{detailStats:c.stats,type:this.d,fromCache:!1,resultCount:a,sortingTime:void 0}}))}h(w){return{path:w.base?(0,P.join)(w.base,w.relativePath):w.relativePath}}j(w,g,t,s,r){const a=new L.Emitter;let b=(0,R.createCancelablePromise)(c=>{let u=[];const m=f=>{Array.isArray(f)?u=f:(s(f),a.fire(f))};return this.r(w,m,-1,c).then(f=>[f,u])}),S;if(g.cacheKey){S=this.k(g.cacheKey);const c={promise:b,event:a.event,resolved:!1};S.resultsToSearchCache[g.filePattern||""]=c,b.then(()=>{c.resolved=!0},u=>{delete S.resultsToSearchCache[g.filePattern||""]}),b=this.s(b)}return b.then(([c,u])=>{const m=S?S.scorerCache:Object.create(null),f=(typeof g.maxResults!="number"||g.maxResults>0)&&D.StopWatch.create(!1);return this.n(g,u,m,r).then(n=>{const C=f?f.elapsed():-1;return[{type:"success",stats:{detailStats:c.stats,sortingTime:C,fromCache:!1,type:this.d,workspaceFolderCount:g.folderQueries.length,resultCount:n.length},messages:c.messages,limitHit:c.limitHit||typeof g.maxResults=="number"&&u.length>g.maxResults},n]})})}k(w){const g=this.b[w];return g||(this.b[w]=new v)}l(w,g,t){const s=w.cacheKey&&this.b[w.cacheKey];if(!s)return;const r=this.q(s,w.filePattern||"",g,t);if(r)return r.then(([a,b,S])=>{const c=D.StopWatch.create(!1);return this.n(w,b,s.scorerCache,t).then(u=>{const m=c.elapsed(),f={fromCache:!0,detailStats:S,type:this.d,resultCount:b.length,sortingTime:m};return[{type:"success",limitHit:a.limitHit||typeof w.maxResults=="number"&&b.length>w.maxResults,stats:f},u]})})}n(w,g,t,s){const r=(0,A.prepareQuery)(w.filePattern||""),a=(S,c)=>(0,A.compareItemsByFuzzyScore)(S,c,r,!0,i,t),b=typeof w.maxResults=="number"?w.maxResults:Number.MAX_VALUE;return o.topAsync(g,a,b,1e4,s)}o(w,g,t){if(t&&t>0)for(let s=0;s<w.length;s+=t)g(w.slice(s,s+t));else g(w)}q(w,g,t,s){const r=D.StopWatch.create(!1),a=g.indexOf(P.sep)>=0;let b;for(const m in w.resultsToSearchCache)if(g.startsWith(m)){if(a&&m.indexOf(P.sep)<0&&m!=="")continue;const f=w.resultsToSearchCache[m];b={promise:this.s(f.promise),event:f.event,resolved:f.resolved};break}if(!b)return null;const S=r.elapsed(),c=D.StopWatch.create(!1),u=b.event(t);return s&&s.onCancellationRequested(()=>{u.dispose()}),b.promise.then(([m,f])=>{if(s&&s.isCancellationRequested)throw(0,l.canceled)();const n=[],C=(0,A.prepareQuery)(g).normalizedLowercase;for(const M of f)(0,k.isFilePatternMatch)(M,C)&&n.push(M);return[m,n,{cacheWasResolved:b.resolved,cacheLookupTime:S,cacheFilterTime:c.elapsed(),cacheEntryCount:f.length}]})}r(w,g,t,s){return new Promise((r,a)=>{let b=[];s?.onCancellationRequested(()=>w.cancel()),w.search(S=>{S&&(t?(b.push(S),t>0&&b.length>=t&&(g(b),b=[])):g(S))},S=>{g(S)},(S,c)=>{b.length&&g(b),S?a(S):r(c)})})}clearCache(w){return delete this.b[w],Promise.resolve(void 0)}s(w){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,t){return w.then(g,t)}catch(g){return this.then(void 0,g)}finally(g){return w.finally(g)}}}}e.SearchService=I,I.a=512;class v{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const i=new class{getItemLabel(y){return(0,P.basename)(y.relativePath)}getItemDescription(y){return(0,P.dirname)(y.relativePath)}getItemPath(y){return y.relativePath}};function d(y){return{...y,folderQueries:y.folderQueries&&y.folderQueries.map(h),extraFileResources:y.extraFileResources&&y.extraFileResources.map(w=>p.URI.revive(w))}}function h(y){return{...y,folder:p.URI.revive(y.folder)}}}),define(Ce[324],ke([1,0,6,17,2,29,16,26,20,87,57,31,323,321,101,145]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let i=e.NativeExtHostSearch=class extends p.ExtHostSearch{constructor(h,y,w,g){super(h,w,g),this.s=L,this.t=-1,this.v=null,this.w=!1;const t=new I.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(R.Schemas.vscodeUserData,new T.RipgrepSearchProvider(t)),y.remote.isRemote&&y.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const h=new I.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(R.Schemas.file,new T.RipgrepSearchProvider(h)),this.y(R.Schemas.file,new E.SearchService("fileSearchProvider"))}y(h,y){const w=this.d++;return this.v=y,this.t=w,this.c.$registerFileSearchProvider(w,this.o(h)),(0,o.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(w)})}$provideFileSearchResults(h,y,w,g){const t=(0,p.reviveQuery)(w);return h===this.t?this.z(h,y,t,g):super.$provideFileSearchResults(h,y,w,g)}z(h,y,w,g){const t=s=>{if((0,k.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this.c.$handleFileMatch(h,y,s.map(r=>l.URI.file(r.path)));return}s.message&&this.n.debug("ExtHostSearch",s.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(w,t,g)}$clearCache(h){return this.v?.clearCache(h),super.$clearCache(h)}q(h,y){return new v.NativeTextSearchManager(h,y,void 0,"textSearchProvider")}};e.NativeExtHostSearch=i=xe([We(0,D.IExtHostRpcService),We(1,P.IExtHostInitDataService),We(2,O.IURITransformerService),We(3,A.ILogService)],i)}),define(Ce[147],ke([1,0,335,132,72,336,22,8,3,6,15,14,30,118,119]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class v{traceSocketEvent(f,n){I.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,f,n)}constructor(f,n=""){this.f=!0,this.debugLabel=n,this.socket=f,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,P.onUnexpectedError)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(f){const n=C=>{this.traceSocketEvent("read",C),f(A.VSBuffer.wrap(C))};return this.socket.on("data",n),{dispose:()=>this.socket.off("data",n)}}onClose(f){const n=C=>{f({type:0,hadError:C,error:void 0})};return this.socket.on("close",n),{dispose:()=>this.socket.off("close",n)}}onEnd(f){const n=()=>{f()};return this.socket.on("end",n),{dispose:()=>this.socket.off("end",n)}}write(f){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",f),this.socket.write(f.buffer,n=>{if(n){if(n.code==="EPIPE")return;(0,P.onUnexpectedError)(n)}})}catch(n){if(n.code==="EPIPE")return;(0,P.onUnexpectedError)(n)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((f,n)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),f();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),f()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.NodeSocket=v;var i;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(i||(i={}));var d;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(d||(d={}));class h extends p.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(f,n){this.socket.traceSocketEvent(f,n)}constructor(f,n,C,M){super(),this.f=this.B(new D.Emitter),this.g=this.B(new D.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=f,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:n,inflateBytesLength:C?.byteLength||0,recordInflateBytes:M}),this.a=this.B(new y(this,n,C,M,this.f,(H,V)=>this.k(H,V))),this.B(this.a.onError(H=>{console.error(H),(0,P.onUnexpectedError)(H),this.g.fire({type:0,hadError:!0,error:H})})),this.b=new I.ChunkStream,this.B(this.socket.onData(H=>this.l(H))),this.B(this.socket.onClose(async H=>{this.a.isProcessingReadQueue()&&await D.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(H)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(f){return this.f.event(f)}onClose(f){return this.g.event(f)}onEnd(f){return this.socket.onEnd(f)}write(f){let n=0;for(;n<f.byteLength;)this.a.writeMessage(f.slice(n,Math.min(n+262144,f.byteLength))),n+=262144}k(f,n){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",f);let C=2;f.byteLength<126?C+=0:f.byteLength<2**16?C+=2:C+=8;const M=A.VSBuffer.alloc(C);if(n?M.writeUInt8(194,0):M.writeUInt8(130,0),f.byteLength<126)M.writeUInt8(f.byteLength,1);else if(f.byteLength<2**16){M.writeUInt8(126,1);let H=1;M.writeUInt8(f.byteLength>>>8&255,++H),M.writeUInt8(f.byteLength>>>0&255,++H)}else{M.writeUInt8(127,1);let H=1;M.writeUInt8(0,++H),M.writeUInt8(0,++H),M.writeUInt8(0,++H),M.writeUInt8(0,++H),M.writeUInt8(f.byteLength>>>24&255,++H),M.writeUInt8(f.byteLength>>>16&255,++H),M.writeUInt8(f.byteLength>>>8&255,++H),M.writeUInt8(f.byteLength>>>0&255,++H)}this.socket.write(A.VSBuffer.concat([M,f]))}end(){this.h=!0,this.socket.end()}l(f){if(f.byteLength!==0){for(this.b.acceptChunk(f);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const n=this.b.peek(this.j.readLen),C=n.readUInt8(0),M=(C&128)>>>7,H=(C&64)>>>6,V=n.readUInt8(1),U=(V&128)>>>7,z=V&127;this.j.state=2,this.j.readLen=2+(U?4:0)+(z===126?2:0)+(z===127?8:0),this.j.fin=M,this.j.firstFrameOfMessage&&(this.j.compressed=!!H),this.j.firstFrameOfMessage=!!M,this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const n=this.b.read(this.j.readLen),C=n.readUInt8(1),M=(C&128)>>>7;let H=C&127,V=1;H===126?H=n.readUInt8(++V)*2**8+n.readUInt8(++V):H===127&&(H=n.readUInt8(++V)*0+n.readUInt8(++V)*0+n.readUInt8(++V)*0+n.readUInt8(++V)*0+n.readUInt8(++V)*2**24+n.readUInt8(++V)*2**16+n.readUInt8(++V)*2**8+n.readUInt8(++V));let U=0;M&&(U=n.readUInt8(++V)*2**24+n.readUInt8(++V)*2**16+n.readUInt8(++V)*2**8+n.readUInt8(++V)),this.j.state=3,this.j.readLen=H,this.j.mask=U,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const n=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",n),t(n,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",n),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(n,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await D.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=h;class y extends p.Disposable{get permessageDeflate(){return!!(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:A.VSBuffer.alloc(0)}constructor(f,n,C,M,H,V){super(),this.l=f,this.m=H,this.n=V,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new D.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new D.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,n?(this.b=this.B(new w(this.l,M,C,{windowBits:15})),this.f=this.B(new g(this.l,{windowBits:15})),this.B(this.b.onError(U=>this.a.fire(U))),this.B(this.f.onError(U=>this.a.fire(U)))):(this.b=null,this.f=null)}writeMessage(f){this.g.push(f),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const f=this.g.shift();if(this.f){const n=await this.s(this.f,f);this.n(n,!0)}else this.n(f,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(f,n){return new Promise((C,M)=>{f.write(n),f.flush(H=>C(H))})}acceptFrame(f,n,C){this.h.push({data:f,isCompressed:n,isLastFrameOfMessage:C}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const f=this.h.shift();if(this.b&&f.isCompressed){const n=await this.w(this.b,f.data,f.isLastFrameOfMessage);this.m.fire(n)}else this.m.fire(f.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(f,n,C){return new Promise((M,H)=>{f.write(n),C&&f.write(A.VSBuffer.fromByteArray([0,0,255,255])),f.flush(V=>M(V))})}}class w extends p.Disposable{get recordedInflateBytes(){return this.j?A.VSBuffer.concat(this.f):A.VSBuffer.alloc(0)}constructor(f,n,C,M){super(),this.h=f,this.j=n,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=(0,L.createInflateRaw)(M),this.b.on("error",H=>{this.h.traceSocketEvent("zlibInflateError",{message:H?.message,code:H?.code}),this.a.fire(H)}),this.b.on("data",H=>{this.h.traceSocketEvent("zlibInflateData",H),this.g.push(A.VSBuffer.wrap(H))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(f){this.j&&this.f.push(f.clone()),this.h.traceSocketEvent("zlibInflateWrite",f),this.b.write(f.buffer)}flush(f){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const n=A.VSBuffer.concat(this.g);this.g.length=0,f(n)})}}class g extends p.Disposable{constructor(f,n){super(),this.g=f,this.a=this.B(new D.Emitter),this.onError=this.a.event,this.f=[],this.b=(0,L.createDeflateRaw)({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(A.VSBuffer.wrap(C))})}write(f){this.g.traceSocketEvent("zlibDeflateWrite",f.buffer),this.b.write(f.buffer)}flush(f){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let n=A.VSBuffer.concat(this.f);this.f.length=0,n=n.slice(0,n.byteLength-4),f(n)})}}function t(m,f){if(f===0)return;const n=m.byteLength>>>2;for(let z=0;z<n;z++){const G=m.readUInt32BE(z*4);m.writeUInt32BE(G^f,z*4)}const C=n*4,M=m.byteLength-C,H=f>>>24&255,V=f>>>16&255,U=f>>>8&255;M>=1&&m.writeUInt8(m.readUInt8(C)^H,C),M>=2&&m.writeUInt8(m.readUInt8(C+1)^V,C+1),M>=3&&m.writeUInt8(m.readUInt8(C+2)^U,C+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const s={[2]:107,[1]:103};function r(){const m=(0,E.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;const f=process.platform!=="darwin"&&e.XDG_RUNTIME_DIR?e.XDG_RUNTIME_DIR:(0,l.tmpdir)(),n=(0,O.join)(f,`vscode-ipc-${m}.sock`);return b(n),n}e.createRandomIPCHandle=r;function a(m,f,n){const C=(0,o.createHash)("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${C}-${n}-${f}-sock`;const M=n.substr(0,4),H=f.substr(0,6),V=C.substr(0,8);let U;return process.platform!=="darwin"&&e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?U=(0,O.join)(e.XDG_RUNTIME_DIR,`vscode-${V}-${M}-${H}.sock`):U=(0,O.join)(m,`${M}-${H}.sock`),b(U),U}e.createStaticIPCHandle=a;function b(m){const f=s[k.platform];typeof f=="number"&&m.length>=f&&console.warn(`WARNING: IPC handle "${m}" is longer than ${f} chars, try a shorter --user-data-dir`)}class S extends T.IPCServer{static b(f){const n=D.Event.fromNodeEventEmitter(f,"connection");return D.Event.map(n,C=>({protocol:new I.Protocol(new v(C,"ipc-server-connection")),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(C,"close"))}))}constructor(f){super(S.b(f)),this.d=f}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=S;function c(m){return new Promise((f,n)=>{const C=(0,R.createServer)();C.on("error",n),C.listen(m,()=>{C.removeListener("error",n),f(new S(C))})})}e.serve=c;function u(m,f){return new Promise((n,C)=>{const M=(0,R.createConnection)(m,()=>{M.removeListener("error",C),n(I.Client.fromSocket(new v(M,`ipc-client${f}`),f))});M.once("error",C)})}e.connect=u}),define(Ce[325],ke([1,0,147,233,71,41,2,16,48]),function(ae,e,o,R,l,L,A,P,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class p{constructor(E,T,I){this.b=E,this.c=T,this.f=I,this.a=R.createServer((v,i)=>this.h(v,i)),this.g().catch(v=>(T.error(v),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",E=>this.c.error(E))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(E,T){const I=(i,d)=>{T.writeHead(i,{"content-type":"application/json"}),T.end(JSON.stringify(d||null),h=>h&&this.c.error(h))},v=[];E.setEncoding("utf8"),E.on("data",i=>v.push(i)),E.on("end",async()=>{try{const i=JSON.parse(v.join(""));let d;switch(i.type){case"open":d=await this.i(i);break;case"openExternal":d=await this.j(i);break;case"status":d=await this.l(i);break;case"extensionManagement":d=await this.k(i);break;default:I(404,`Unknown message type: ${i.type}`);break}I(200,d)}catch(i){const d=i instanceof Error?i.message:JSON.stringify(i);I(500,d),this.c.error("Error while processing pipe request",i)}})}async i(E){const{fileURIs:T,folderURIs:I,forceNewWindow:v,diffMode:i,mergeMode:d,addMode:h,forceReuseWindow:y,gotoLineMode:w,waitMarkerFilePath:g,remoteAuthority:t}=E,s=[];if(Array.isArray(I))for(const S of I)try{s.push({folderUri:A.URI.parse(S)})}catch{}if(Array.isArray(T))for(const S of T)try{(0,D.hasWorkspaceFileExtension)(S)?s.push({workspaceUri:A.URI.parse(S)}):s.push({fileUri:A.URI.parse(S)})}catch{}const r=g?A.URI.file(g):void 0,b={forceNewWindow:v,diffMode:i,mergeMode:d,addMode:h,gotoLineMode:w,forceReuseWindow:y,preferNewWindow:!y&&!r&&!h,waitMarkerFileURI:r,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",s,b),""}async j(E){for(const T of E.uris){const I=A.URI.parse(T),v=I.scheme==="file"?I:T;await this.b.executeCommand("_remoteCLI.openExternal",v)}}async k(E){const T=v=>v?.map(i=>/\.vsix$/i.test(i)?A.URI.parse(i):i),I={list:E.list,install:T(E.install),uninstall:T(E.uninstall),force:E.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",I)}async l(E){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&l.existsSync(this.f)&&l.unlinkSync(this.f)}}e.CLIServerBase=p;let O=e.CLIServer=class extends p{constructor(E,T){super(E,T,(0,o.createRandomIPCHandle)())}};e.CLIServer=O=xe([We(0,L.IExtHostCommands),We(1,P.ILogService)],O)}),define(Ce[326],ke([1,0,85,315,310,232,43,298,2,17,7,325,116,297]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class I extends l.RequireInterceptor{j(){const d=this,h=globalThis._VSCODE_NODE_MODULES.module,y=h._load;h._load=function(s,r,a){return s=g(s),d.a.has(s)?d.a.get(s).load(s,D.URI.file((0,E.realpathSync)(r.filename)),b=>y.apply(this,[b,r,a])):y.apply(this,arguments)};const w=h._resolveLookupPaths;h._resolveLookupPaths=(t,s)=>w.call(this,g(t),s);const g=t=>{for(const s of d.b){const r=s(t);if(r){t=r;break}}return t}}}class v extends A.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=O.ExtensionRuntime.Node}async pb(){this.h.createInstance(T.ExtHostConsoleForwarder);const d=this.h.invokeFunction(R.createApiFactoryAndRegisterActors);if(this.h.createInstance(P.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const w=this.h.createInstance(k.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=w.ipcHandlePath}await this.h.createInstance(I,d,{mine:this.F,all:this.G}).install(),o.mark("code/extHost/didInitAPI");const y=await this.k.getConfigProvider();await(0,L.connectProxyResolver)(this.j,y,this,this.l,this.u,this.f),o.mark("code/extHost/didInitProxyResolver")}qb(d){return d.main}async rb(d,h,y){if(h.scheme!==p.Schemas.file)throw new Error(`Cannot load URI: '${h}', must be of file-scheme`);let w=null;y.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${h.toString(!0)}`),this.l.flush();const g=d?.identifier.value;d&&await this.s.initializeLocalizedMessages(d);try{g&&o.mark(`code/extHost/willLoadExtensionCode/${g}`),w=ae.__$__nodeRequire(h.fsPath)}finally{g&&o.mark(`code/extHost/didLoadExtensionCode/${g}`),y.codeLoadingStop()}return w}async $setRemoteEnvironment(d){if(this.f.remote.isRemote)for(const h in d){const y=d[h];y===null?delete process.env[h]:process.env[h]=y}}}e.ExtHostExtensionService=v}),define(Ce[327],ke([1,0,91,301,313,312,324,326,302,86,43,87,84,42,56,81,300,299,16,314,50,227,90]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d,h,y,w,g,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(O.IExtHostExtensionService,P.ExtHostExtensionService,0),(0,o.registerSingleton)(h.ILoggerService,d.ExtHostLoggerService,1),(0,o.registerSingleton)(h.ILogService,new t.SyncDescriptor(g.ExtHostLogService,[!1],!0)),(0,o.registerSingleton)(v.IExtensionStoragePaths,i.ExtensionStoragePaths,0),(0,o.registerSingleton)(p.IExtHostDebugService,L.ExtHostDebugService,0),(0,o.registerSingleton)(k.IExtHostSearch,A.NativeExtHostSearch,0),(0,o.registerSingleton)(E.IExtHostTask,l.ExtHostTask,0),(0,o.registerSingleton)(T.IExtHostTerminalService,R.ExtHostTerminalService,0),(0,o.registerSingleton)(I.IExtHostTunnelService,D.ExtHostTunnelService,0),(0,o.registerSingleton)(w.IExtHostVariableResolverProvider,y.NodeExtHostVariableResolverProviderService,0)}),define(Ce[337],ke([1,0,132,338,85,8,119,147,215,97,311,22,29,116,19,121,234,246,316,327]),function(ae,e,o,R,l,L,A,P,D,p,O,k,E,T,I,v,i,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let S=0;S<process.execArgv.length;S++)process.execArgv[S]==="--inspect-port=0"&&(process.execArgv.splice(S,1),S--)}();const h=R(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const b=globalThis._VSCODE_NODE_MODULES.module,S=b._load;b._load=function(c){if(c==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return S.apply(this,arguments)}})();const y=process.exit.bind(process);function w(b){process.exit=function(S){if(b)y(S);else{const c=new Error("An extension called process.exit() and this was prevented.");console.warn(c.stack)}},process.crash=function(){const S=new Error("An extension called process.crash() and this was prevented.");console.warn(S.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let g=function(b){y()};function t(){const b=(0,d.readExtHostConnection)(process.env);if(b.type===3)return new Promise((S,c)=>{const u=m=>{const f=m[0],n=new A.BufferedEmitter;f.on("message",C=>n.fire(k.VSBuffer.wrap(C.data))),f.on("close",()=>{g("renderer closed the MessagePort")}),f.start(),S({onMessage:n.event,send:C=>f.postMessage(C.buffer)})};process.parentPort.on("message",m=>u(m.ports))});if(b.type===2)return new Promise((S,c)=>{let u=null;const m=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),f=108e5,n=3e5,C=new I.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (1)"),f),M=new I.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (2)"),n);process.on("message",(V,U)=>{if(V&&V.type==="VSCODE_EXTHOST_IPC_SOCKET"){U.setNoDelay(!0);const z=k.VSBuffer.wrap(Buffer.from(V.initialDataChunk,"base64"));let G;if(V.skipWebSocketFrames)G=new P.NodeSocket(U,"extHost-socket");else{const F=k.VSBuffer.wrap(Buffer.from(V.inflateBytes,"base64"));G=new P.WebSocketNodeSocket(new P.NodeSocket(U,"extHost-socket"),V.permessageDeflate,F,!1)}u?(C.cancel(),M.cancel(),u.beginAcceptReconnection(G,z),u.endAcceptReconnection(),u.sendResume()):(clearTimeout(m),u=new A.PersistentProtocol({socket:G,initialChunk:z}),u.sendResume(),u.onDidDispose(()=>g("renderer disconnected")),S(u),u.onSocketClose(()=>{C.schedule()}))}if(V&&V.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(M.isScheduled())return;C.isScheduled()&&M.schedule()}});const H={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(H)});{const S=b.pipeName;return new Promise((c,u)=>{const m=o.createConnection(S,()=>{m.removeListener("error",u);const f=new A.PersistentProtocol({socket:new P.NodeSocket(m,"extHost-renderer")});f.sendResume(),c(f)});m.once("error",u),m.on("close",()=>{g("renderer closed the socket")})})}}async function s(){const b=await t();return new class{constructor(){this.a=new A.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,b.onMessage(S=>{(0,p.isMessageOfType)(S,2)?(this.b=!0,g("received terminate message from renderer")):this.a.fire(S)})}send(S){this.b||b.send(S)}async drain(){if(b.drain)return b.drain()}}}function r(b){return new Promise(S=>{const c=b.onMessage(u=>{c.dispose();const m=JSON.parse(u.toString()),f=m.commit,n=D.default.commit;if(f&&n&&f!==n&&y(55),m.parentPid){let C=0;setInterval(function(){try{process.kill(m.parentPid,0),C=0}catch(H){H&&H.code==="EPERM"?(C++,C>=3&&g(`parent process ${m.parentPid} does not exist anymore (3 x EPERM): ${H.message} (code: ${H.code}) (errno: ${H.errno})`)):g(`parent process ${m.parentPid} does not exist anymore: ${H.message} (code: ${H.code}) (errno: ${H.errno})`)}},1e3);let M;try{M=globalThis._VSCODE_NODE_MODULES["native-watchdog"],M.start(m.parentPid)}catch(H){(0,L.onUnexpectedError)(H)}}b.send((0,p.createMessageOfType)(0)),S({protocol:b,initData:m})});b.send((0,p.createMessageOfType)(1))})}async function a(){const b=[];process.on("unhandledRejection",(C,M)=>{b.push(M),setTimeout(()=>{const H=b.indexOf(M);H>=0&&M.catch(V=>{b.splice(H,1),(0,L.isCancellationError)(V)||(console.warn(`rejected promise not handled within 1 second: ${V}`),V&&V.stack&&console.warn(`stack trace: ${V.stack}`),C&&(0,L.onUnexpectedError)(C))})},1e3)}),process.on("rejectionHandled",C=>{const M=b.indexOf(C);M>=0&&b.splice(M,1)}),process.on("uncaughtException",function(C){(0,L.isSigPipeError)(C)||(0,L.onUnexpectedError)(C)}),l.mark("code/extHost/willConnectToRenderer");const S=await s();l.mark("code/extHost/didConnectToRenderer");const c=await r(S);l.mark("code/extHost/didWaitForInitData");const{initData:u}=c;w(!!u.environment.extensionTestsLocationURI),u.environment.useHostProxy=h.useHostProxy!==void 0?h.useHostProxy!=="false":void 0,u.environment.skipWorkspaceStorageLock=(0,v.boolean)(h.skipWorkspaceStorageLock,!1);const m=new class{constructor(){this.pid=process.pid}exit(M){y(M)}exists(M){return E.Promises.exists(M)}realpath(M){return(0,T.realpath)(M)}};let f=null;u.remote.authority&&h.transformURIs&&(f=(0,i.createURITransformer)(u.remote.authority));const n=new O.ExtensionHostMain(c.protocol,u,m,f);g=C=>n.terminate(C)}a().catch(b=>console.log(b))})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/workbench/api/node/extensionHostProcess.js.map
