/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Pe=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/base/common/errors","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/types","vs/base/common/strings","vs/platform/log/common/log","vs/base/common/network","vs/base/common/arrays","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/base/common/path","vs/base/common/platform","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/severity","vs/platform/registry/common/platform","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/uuid","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/errorMessage","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/files/common/files","vs/editor/common/core/range","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/ternarySearchTree","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/base/common/process","vs/platform/telemetry/common/telemetryUtils","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/base/common/stopwatch","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/mime","vs/base/common/marshalling","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/api/common/extHostTunnelService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/editor/common/languages","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/idGenerator","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/extensionManagement/common/extensionManagement","vs/base/common/hash","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/base/common/symbols","vs/base/common/dataTransfer","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostInteractiveSession","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostInteractiveEditor","vs/workbench/api/common/extHostInteractiveSession","vs/workbench/api/common/extHostIssueReporter","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostSemanticSimilarity","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ae=function(te){for(var e=[],n=0,P=te.length;n<P;n++)e[n]=Pe[te[n]];return e};define(Pe[64],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function n(R,A){const y=Object.create(null);for(const h of R){const O=A(h);let w=y[O];w||(w=y[O]=[]),w.push(h)}return y}e.groupBy=n;function P(R,A){const y=[],h=[];for(const O of R)A.has(O)||y.push(O);for(const O of A)R.has(O)||h.push(O);return{removed:y,added:h}}e.diffSets=P;function I(R,A){const y=[],h=[];for(const[O,w]of R)A.has(O)||y.push(w);for(const[O,w]of A)R.has(O)||h.push(w);return{removed:y,added:h}}e.diffMaps=I;class L{constructor(){this.a=new Map}add(A,y){let h=this.a.get(A);h||(h=new Set,this.a.set(A,h)),h.add(y)}delete(A,y){const h=this.a.get(A);h&&(h.delete(y),h.size===0&&this.a.delete(A))}forEach(A,y){const h=this.a.get(A);h&&h.forEach(y)}}e.SetMap=L}),define(Pe[65],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function n(R){return(A,y,h)=>{let O=null,w=null;if(typeof h.value=="function"?(O="value",w=h.value):typeof h.get=="function"&&(O="get",w=h.get),!w)throw new Error("not supported");h[O]=R(w,y)}}function P(R,A,y){let h=null,O=null;if(typeof y.value=="function"?(h="value",O=y.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(h="get",O=y.get),!O)throw new Error("not supported");const w=`$memoize$${A}`;y[h]=function(...g){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,g)}),this[w]}}e.memoize=P;function I(R,A,y){return n((h,O)=>{const w=`$debounce$${O}`,g=`$debounce$result$${O}`;return function(...S){this[g]||(this[g]=y?y():void 0),clearTimeout(this[w]),A&&(this[g]=A(this[g],...S),S=[this[g]]),this[w]=setTimeout(()=>{h.apply(this,S),this[g]=y?y():void 0},R)}})}e.debounce=I;function L(R,A,y){return n((h,O)=>{const w=`$throttle$timer$${O}`,g=`$throttle$result$${O}`,S=`$throttle$lastRun$${O}`,p=`$throttle$pending$${O}`;return function(...l){if(this[g]||(this[g]=y?y():void 0),(this[S]===null||this[S]===void 0)&&(this[S]=-Number.MAX_VALUE),A&&(this[g]=A(this[g],...l)),this[p])return;const t=this[S]+R;t<=Date.now()?(this[S]=Date.now(),h.apply(this,[this[g]]),this[g]=y?y():void 0):(this[p]=!0,this[w]=setTimeout(()=>{this[p]=!1,this[S]=Date.now(),h.apply(this,[this[g]]),this[g]=y?y():void 0},t-Date.now()))}})}e.throttle=L}),define(Pe[84],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class n{constructor(I){this.a=I,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=n,e.defaultGenerator=new n("id#")}),define(Pe[114],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var n;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(n||(e.ScanError=n={}));var P;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(P||(e.SyntaxKind=P={}));var I;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var L;(function(i){i.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function R(i,a=!1){let r=0;const s=i.length;let E="",k=0,c=16,u=0;function m($){let B=0,X=0;for(;B<$;){const U=i.charCodeAt(r);if(U>=48&&U<=57)X=X*16+U-48;else if(U>=65&&U<=70)X=X*16+U-65+10;else if(U>=97&&U<=102)X=X*16+U-97+10;else break;r++,B++}return B<$&&(X=-1),X}function b($){r=$,E="",k=0,c=16,u=0}function f(){const $=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&h(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&h(i.charCodeAt(r)))for(r++;r<i.length&&h(i.charCodeAt(r));)r++;else return u=3,i.substring($,r);let B=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&h(i.charCodeAt(r))){for(r++;r<i.length&&h(i.charCodeAt(r));)r++;B=r}else u=3;return i.substring($,B)}function N(){let $="",B=r;for(;;){if(r>=s){$+=i.substring(B,r),u=2;break}const X=i.charCodeAt(r);if(X===34){$+=i.substring(B,r),r++;break}if(X===92){if($+=i.substring(B,r),r++,r>=s){u=2;break}switch(i.charCodeAt(r++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const j=m(4);j>=0?$+=String.fromCharCode(j):u=4;break}default:u=5}B=r;continue}if(X>=0&&X<=31)if(y(X)){$+=i.substring(B,r),u=2;break}else u=6;r++}return $}function V(){if(E="",u=0,k=r,r>=s)return k=s,c=17;let $=i.charCodeAt(r);if(A($)){do r++,E+=String.fromCharCode($),$=i.charCodeAt(r);while(A($));return c=15}if(y($))return r++,E+=String.fromCharCode($),$===13&&i.charCodeAt(r)===10&&(r++,E+=`
`),c=14;switch($){case 123:return r++,c=1;case 125:return r++,c=2;case 91:return r++,c=3;case 93:return r++,c=4;case 58:return r++,c=6;case 44:return r++,c=5;case 34:return r++,E=N(),c=10;case 47:{const B=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<s&&!y(i.charCodeAt(r));)r++;return E=i.substring(B,r),c=12}if(i.charCodeAt(r+1)===42){r+=2;const X=s-1;let U=!1;for(;r<X;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,U=!0;break}r++}return U||(r++,u=1),E=i.substring(B,r),c=13}return E+=String.fromCharCode($),r++,c=16}case 45:if(E+=String.fromCharCode($),r++,r===s||!h(i.charCodeAt(r)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return E+=f(),c=11;default:for(;r<s&&_($);)r++,$=i.charCodeAt(r);if(k!==r){switch(E=i.substring(k,r),E){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return E+=String.fromCharCode($),r++,c=16}}function _($){if(A($)||y($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function G(){let $;do $=V();while($>=12&&$<=15);return $}return{setPosition:b,getPosition:()=>r,scan:a?G:V,getToken:()=>c,getTokenValue:()=>E,getTokenOffset:()=>k,getTokenLength:()=>r-k,getTokenError:()=>u}}e.createScanner=R;function A(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function y(i){return i===10||i===13||i===8232||i===8233}function h(i){return i>=48&&i<=57}var O;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(O||(O={}));function w(i,a){const r=[],s=new Object;let E;const k={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function u(m,b,f,N){k.value=m,k.offset=b,k.length=f,k.type=N,k.colonOffset=void 0,E=k}try{D(i,{onObjectBegin:(m,b)=>{if(a<=m)throw s;E=void 0,c=a>m,r.push("")},onObjectProperty:(m,b,f)=>{if(a<b||(u(m,b,f,"property"),r[r.length-1]=m,a<=b+f))throw s},onObjectEnd:(m,b)=>{if(a<=m)throw s;E=void 0,r.pop()},onArrayBegin:(m,b)=>{if(a<=m)throw s;E=void 0,r.push(0)},onArrayEnd:(m,b)=>{if(a<=m)throw s;E=void 0,r.pop()},onLiteralValue:(m,b,f)=>{if(a<b||(u(m,b,f,v(m)),a<=b+f))throw s},onSeparator:(m,b,f)=>{if(a<=b)throw s;if(m===":"&&E&&E.type==="property")E.colonOffset=b,c=!1,E=void 0;else if(m===","){const N=r[r.length-1];typeof N=="number"?r[r.length-1]=N+1:(c=!0,r[r.length-1]=""),E=void 0}}})}catch(m){if(m!==s)throw m}return{path:r,previousNode:E,isAtPropertyKey:c,matches:m=>{let b=0;for(let f=0;b<m.length&&f<r.length;f++)if(m[b]===r[f]||m[b]==="*")b++;else if(m[b]!=="**")return!1;return b===m.length}}}e.getLocation=w;function g(i,a=[],r=L.DEFAULT){let s=null,E=[];const k=[];function c(m){Array.isArray(E)?E.push(m):s!==null&&(E[s]=m)}return D(i,{onObjectBegin:()=>{const m={};c(m),k.push(E),E=m,s=null},onObjectProperty:m=>{s=m},onObjectEnd:()=>{E=k.pop()},onArrayBegin:()=>{const m=[];c(m),k.push(E),E=m,s=null},onArrayEnd:()=>{E=k.pop()},onLiteralValue:c,onError:(m,b,f)=>{a.push({error:m,offset:b,length:f})}},r),E[0]}e.parse=g;function S(i,a=[],r=L.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function E(m){s.type==="property"&&(s.length=m-s.offset,s=s.parent)}function k(m){return s.children.push(m),m}D(i,{onObjectBegin:m=>{s=k({type:"object",offset:m,length:-1,parent:s,children:[]})},onObjectProperty:(m,b,f)=>{s=k({type:"property",offset:b,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:m,offset:b,length:f,parent:s})},onObjectEnd:(m,b)=>{s.length=m+b-s.offset,s=s.parent,E(m+b)},onArrayBegin:(m,b)=>{s=k({type:"array",offset:m,length:-1,parent:s,children:[]})},onArrayEnd:(m,b)=>{s.length=m+b-s.offset,s=s.parent,E(m+b)},onLiteralValue:(m,b,f)=>{k({type:v(m),offset:b,length:f,parent:s,value:m}),E(b+f)},onSeparator:(m,b,f)=>{s.type==="property"&&(m===":"?s.colonOffset=b:m===","&&E(b))},onError:(m,b,f)=>{a.push({error:m,offset:b,length:f})}},r);const u=s.children[0];return u&&delete u.parent,u}e.parseTree=S;function p(i,a){if(!i)return;let r=i;for(const s of a)if(typeof s=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let E=!1;for(const k of r.children)if(Array.isArray(k.children)&&k.children[0].value===s){r=k.children[1],E=!0;break}if(!E)return}else{const E=s;if(r.type!=="array"||E<0||!Array.isArray(r.children)||E>=r.children.length)return;r=r.children[E]}return r}e.findNodeAtLocation=p;function l(i){if(!i.parent||!i.parent.children)return[];const a=l(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;a.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&a.push(r)}return a}e.getNodePath=l;function t(i){switch(i.type){case"array":return i.children.map(t);case"object":{const a=Object.create(null);for(const r of i.children){const s=r.children[1];s&&(a[r.children[0].value]=t(s))}return a}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=t;function o(i,a,r=!1){return a>=i.offset&&a<i.offset+i.length||r&&a===i.offset+i.length}e.contains=o;function d(i,a,r=!1){if(o(i,a,r)){const s=i.children;if(Array.isArray(s))for(let E=0;E<s.length&&s[E].offset<=a;E++){const k=d(s[E],a,r);if(k)return k}return i}}e.findNodeAtOffset=d;function D(i,a,r=L.DEFAULT){const s=R(i,!1);function E(Re){return Re?()=>Re(s.getTokenOffset(),s.getTokenLength()):()=>!0}function k(Re){return Re?le=>Re(le,s.getTokenOffset(),s.getTokenLength()):()=>!0}const c=E(a.onObjectBegin),u=k(a.onObjectProperty),m=E(a.onObjectEnd),b=E(a.onArrayBegin),f=E(a.onArrayEnd),N=k(a.onLiteralValue),V=k(a.onSeparator),_=E(a.onComment),G=k(a.onError),$=r&&r.disallowComments,B=r&&r.allowTrailingComma;function X(){for(;;){const Re=s.scan();switch(s.getTokenError()){case 4:U(14);break;case 5:U(15);break;case 3:U(13);break;case 1:$||U(11);break;case 2:U(12);break;case 6:U(16);break}switch(Re){case 12:case 13:$?U(10):_();break;case 16:U(1);break;case 15:case 14:break;default:return Re}}}function U(Re,le=[],ue=[]){if(G(Re),le.length+ue.length>0){let H=s.getToken();for(;H!==17;){if(le.indexOf(H)!==-1){X();break}else if(ue.indexOf(H)!==-1)break;H=X()}}}function j(Re){const le=s.getTokenValue();return Re?N(le):u(le),X(),!0}function Y(){switch(s.getToken()){case 11:{let Re=0;try{Re=JSON.parse(s.getTokenValue()),typeof Re!="number"&&(U(2),Re=0)}catch{U(2)}N(Re);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return X(),!0}function pe(){return s.getToken()!==10?(U(3,[],[2,5]),!1):(j(!1),s.getToken()===6?(V(":"),X(),de()||U(4,[],[2,5])):U(5,[],[2,5]),!0)}function Ee(){c(),X();let Re=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(Re||U(4,[],[]),V(","),X(),s.getToken()===2&&B)break}else Re&&U(6,[],[]);pe()||U(4,[],[2,5]),Re=!0}return m(),s.getToken()!==2?U(7,[2],[]):X(),!0}function he(){b(),X();let Re=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(Re||U(4,[],[]),V(","),X(),s.getToken()===4&&B)break}else Re&&U(6,[],[]);de()||U(4,[],[4,5]),Re=!0}return f(),s.getToken()!==4?U(8,[4],[]):X(),!0}function de(){switch(s.getToken()){case 3:return he();case 1:return Ee();case 10:return j(!0);default:return Y()}}return X(),s.getToken()===17?r.allowEmptyContent?!0:(U(4,[],[]),!1):de()?(s.getToken()!==17&&U(9,[],[]),!0):(U(4,[],[]),!1)}e.visit=D;function T(i,a){const r=R(i),s=[];let E,k=0,c;do switch(c=r.getPosition(),E=r.scan(),E){case 12:case 13:case 17:k!==c&&s.push(i.substring(k,c)),a!==void 0&&s.push(r.getTokenValue().replace(/[^\r\n]/g,a)),k=r.getPosition();break}while(E!==17);return s.join("")}e.stripComments=T;function v(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=v}),define(Pe[28],Ae([1,0]),function(te,e){"use strict";var n,P,I;Object.defineProperty(e,"__esModule",{value:!0}),e.CounterSet=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function L(l,t,o){let d=l.get(t);return d===void 0&&(d=o,l.set(t,d)),d}e.getOrSet=L;function R(l){const t=[];return l.forEach((o,d)=>{t.push(`${d} => ${o}`)}),`Map(${l.size}) {${t.join(", ")}}`}e.mapToString=R;function A(l){const t=[];return l.forEach(o=>{t.push(o)}),`Set(${l.size}) {${t.join(", ")}}`}e.setToString=A;class y{constructor(t,o){this.uri=t,this.value=o}}class h{constructor(t,o){this[n]="ResourceMap",t instanceof h?(this.b=new Map(t.b),this.c=o??h.a):(this.b=new Map,this.c=t??h.a)}set(t,o){return this.b.set(this.c(t),new y(t,o)),this}get(t){return this.b.get(this.c(t))?.value}has(t){return this.b.has(this.c(t))}get size(){return this.b.size}clear(){this.b.clear()}delete(t){return this.b.delete(this.c(t))}forEach(t,o){typeof o<"u"&&(t=t.bind(o));for(const[d,D]of this.b)t(D.value,D.uri,this)}*values(){for(const t of this.b.values())yield t.value}*keys(){for(const t of this.b.values())yield t.uri}*entries(){for(const t of this.b.values())yield[t.uri,t.value]}*[(n=Symbol.toStringTag,Symbol.iterator)](){for(const[,t]of this.b)yield[t.uri,t.value]}}e.ResourceMap=h,h.a=l=>l.toString();class O{constructor(t,o){this[P]="ResourceSet",!t||typeof t=="function"?this.a=new h(t):(this.a=new h(o),t.forEach(this.add,this))}get size(){return this.a.size}add(t){return this.a.set(t,t),this}clear(){this.a.clear()}delete(t){return this.a.delete(t)}forEach(t,o){this.a.forEach((d,D)=>t.call(o,D,D,this))}has(t){return this.a.has(t)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var w;(function(l){l[l.None=0]="None",l[l.AsOld=1]="AsOld",l[l.AsNew=2]="AsNew"})(w||(e.Touch=w={}));class g{constructor(){this[I]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(t){return this.a.has(t)}get(t,o=0){const d=this.a.get(t);if(d)return o!==0&&this.j(d,o),d.value}set(t,o,d=0){let D=this.a.get(t);if(D)D.value=o,d!==0&&this.j(D,d);else{switch(D={key:t,value:o,next:void 0,previous:void 0},d){case 0:this.h(D);break;case 1:this.g(D);break;case 2:this.h(D);break;default:this.h(D);break}this.a.set(t,D),this.d++}return this}delete(t){return!!this.remove(t)}remove(t){const o=this.a.get(t);if(o)return this.a.delete(t),this.i(o),this.d--,o.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const t=this.b;return this.a.delete(t.key),this.i(t),this.d--,t.value}forEach(t,o){const d=this.e;let D=this.b;for(;D;){if(o?t.bind(o)(D.value,D.key,this):t(D.value,D.key,this),this.e!==d)throw new Error("LinkedMap got modified during iteration.");D=D.next}}keys(){const t=this,o=this.e;let d=this.b;const D={[Symbol.iterator](){return D},next(){if(t.e!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const T={value:d.key,done:!1};return d=d.next,T}else return{value:void 0,done:!0}}};return D}values(){const t=this,o=this.e;let d=this.b;const D={[Symbol.iterator](){return D},next(){if(t.e!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const T={value:d.value,done:!1};return d=d.next,T}else return{value:void 0,done:!0}}};return D}entries(){const t=this,o=this.e;let d=this.b;const D={[Symbol.iterator](){return D},next(){if(t.e!==o)throw new Error("LinkedMap got modified during iteration.");if(d){const T={value:[d.key,d.value],done:!1};return d=d.next,T}else return{value:void 0,done:!0}}};return D}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(t){if(t>=this.size)return;if(t===0){this.clear();return}let o=this.b,d=this.size;for(;o&&d>t;)this.a.delete(o.key),o=o.next,d--;this.b=o,this.d=d,o&&(o.previous=void 0),this.e++}g(t){if(!this.b&&!this.c)this.c=t;else if(this.b)t.next=this.b,this.b.previous=t;else throw new Error("Invalid list");this.b=t,this.e++}h(t){if(!this.b&&!this.c)this.b=t;else if(this.c)t.previous=this.c,this.c.next=t;else throw new Error("Invalid list");this.c=t,this.e++}i(t){if(t===this.b&&t===this.c)this.b=void 0,this.c=void 0;else if(t===this.b){if(!t.next)throw new Error("Invalid list");t.next.previous=void 0,this.b=t.next}else if(t===this.c){if(!t.previous)throw new Error("Invalid list");t.previous.next=void 0,this.c=t.previous}else{const o=t.next,d=t.previous;if(!o||!d)throw new Error("Invalid list");o.previous=d,d.next=o}t.next=void 0,t.previous=void 0,this.e++}j(t,o){if(!this.b||!this.c)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(t===this.b)return;const d=t.next,D=t.previous;t===this.c?(D.next=void 0,this.c=D):(d.previous=D,D.next=d),t.previous=void 0,t.next=this.b,this.b.previous=t,this.b=t,this.e++}else if(o===2){if(t===this.c)return;const d=t.next,D=t.previous;t===this.b?(d.previous=void 0,this.b=d):(d.previous=D,D.next=d),t.next=void 0,t.previous=this.c,this.c.next=t,this.c=t,this.e++}}}toJSON(){const t=[];return this.forEach((o,d)=>{t.push([d,o])}),t}fromJSON(t){this.clear();for(const[o,d]of t)this.set(o,d)}}e.LinkedMap=g;class S extends g{constructor(t,o=1){super(),this.k=t,this.l=Math.min(Math.max(0,o),1)}get limit(){return this.k}set limit(t){this.k=t,this.m()}get ratio(){return this.l}set ratio(t){this.l=Math.min(Math.max(0,t),1),this.m()}get(t,o=2){return super.get(t,o)}peek(t){return super.get(t,0)}set(t,o){return super.set(t,o,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=S;class p{constructor(){this.a=new Map}add(t){return this.a.set(t,(this.a.get(t)||0)+1),this}delete(t){let o=this.a.get(t)||0;return o===0?!1:(o--,o===0?this.a.delete(t):this.a.set(t,o),!0)}has(t){return this.a.has(t)}}e.CounterSet=p}),function(te,e){typeof define=="function"&&define.amd?define(Pe[115],Ae([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(te=typeof globalThis<"u"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(De,be){for(var ke=0;ke<be.length;ke++){var oe=be[ke];oe.enumerable=oe.enumerable||!1,oe.configurable=!0,"value"in oe&&(oe.writable=!0),Object.defineProperty(De,oe.key,oe)}}function n(De,be,ke){return be&&e(De.prototype,be),ke&&e(De,ke),Object.defineProperty(De,"prototype",{writable:!1}),De}function P(De,be){if(De){if(typeof De=="string")return I(De,be);var ke=Object.prototype.toString.call(De).slice(8,-1);if(ke==="Object"&&De.constructor&&(ke=De.constructor.name),ke==="Map"||ke==="Set")return Array.from(De);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return I(De,be)}}function I(De,be){(be==null||be>De.length)&&(be=De.length);for(var ke=0,oe=new Array(be);ke<be;ke++)oe[ke]=De[ke];return oe}function L(De,be){var ke=typeof Symbol<"u"&&De[Symbol.iterator]||De["@@iterator"];if(ke)return(ke=ke.call(De)).next.bind(ke);if(Array.isArray(De)||(ke=P(De))||be&&De&&typeof De.length=="number"){ke&&(De=ke);var oe=0;return function(){return oe>=De.length?{done:!0}:{done:!1,value:De[oe++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function R(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=R();function A(De){te.defaults=De}var y=/[&<>"']/,h=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,w=/[<>"']|&(?!#?\w+;)/g,g={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},S=function(be){return g[be]};function p(De,be){if(be){if(y.test(De))return De.replace(h,S)}else if(O.test(De))return De.replace(w,S);return De}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function t(De){return De.replace(l,function(be,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var o=/(^|[^\[])\^/g;function d(De,be){De=typeof De=="string"?De:De.source,be=be||"";var ke={replace:function(ce,ie){return ie=ie.source||ie,ie=ie.replace(o,"$1"),De=De.replace(ce,ie),ke},getRegex:function(){return new RegExp(De,be)}};return ke}var D=/[^\w:]/g,T=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function v(De,be,ke){if(De){var oe;try{oe=decodeURIComponent(t(ke)).replace(D,"").toLowerCase()}catch{return null}if(oe.indexOf("javascript:")===0||oe.indexOf("vbscript:")===0||oe.indexOf("data:")===0)return null}be&&!T.test(ke)&&(ke=E(be,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch{return null}return ke}var i={},a=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,s=/^([^:]+:\/*[^/]*)[\s\S]*$/;function E(De,be){i[" "+De]||(a.test(De)?i[" "+De]=De+"/":i[" "+De]=m(De,"/",!0)),De=i[" "+De];var ke=De.indexOf(":")===-1;return be.substring(0,2)==="//"?ke?be:De.replace(r,"$1")+be:be.charAt(0)==="/"?ke?be:De.replace(s,"$1")+be:De+be}var k={exec:function(){}};function c(De){for(var be=1,ke,oe;be<arguments.length;be++){ke=arguments[be];for(oe in ke)Object.prototype.hasOwnProperty.call(ke,oe)&&(De[oe]=ke[oe])}return De}function u(De,be){var ke=De.replace(/\|/g,function(ie,ne,C){for(var W=!1,q=ne;--q>=0&&C[q]==="\\";)W=!W;return W?"|":" |"}),oe=ke.split(/ \|/),ce=0;if(oe[0].trim()||oe.shift(),oe.length>0&&!oe[oe.length-1].trim()&&oe.pop(),oe.length>be)oe.splice(be);else for(;oe.length<be;)oe.push("");for(;ce<oe.length;ce++)oe[ce]=oe[ce].trim().replace(/\\\|/g,"|");return oe}function m(De,be,ke){var oe=De.length;if(oe===0)return"";for(var ce=0;ce<oe;){var ie=De.charAt(oe-ce-1);if(ie===be&&!ke)ce++;else if(ie!==be&&ke)ce++;else break}return De.slice(0,oe-ce)}function b(De,be){if(De.indexOf(be[1])===-1)return-1;for(var ke=De.length,oe=0,ce=0;ce<ke;ce++)if(De[ce]==="\\")ce++;else if(De[ce]===be[0])oe++;else if(De[ce]===be[1]&&(oe--,oe<0))return ce;return-1}function f(De){De&&De.sanitize&&!De.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(De,be){if(be<1)return"";for(var ke="";be>1;)be&1&&(ke+=De),be>>=1,De+=De;return ke+De}function V(De,be,ke,oe){var ce=be.href,ie=be.title?p(be.title):null,ne=De[1].replace(/\\([\[\]])/g,"$1");if(De[0].charAt(0)!=="!"){oe.state.inLink=!0;var C={type:"link",raw:ke,href:ce,title:ie,text:ne,tokens:oe.inlineTokens(ne)};return oe.state.inLink=!1,C}return{type:"image",raw:ke,href:ce,title:ie,text:p(ne)}}function _(De,be){var ke=De.match(/^(\s+)(?:```)/);if(ke===null)return be;var oe=ke[1];return be.split(`
`).map(function(ce){var ie=ce.match(/^\s+/);if(ie===null)return ce;var ne=ie[0];return ne.length>=oe.length?ce.slice(oe.length):ce}).join(`
`)}var G=function(){function De(ke){this.options=ke||te.defaults}var be=De.prototype;return be.space=function(oe){var ce=this.rules.block.newline.exec(oe);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},be.code=function(oe){var ce=this.rules.block.code.exec(oe);if(ce){var ie=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?ie:m(ie,`
`)}}},be.fences=function(oe){var ce=this.rules.block.fences.exec(oe);if(ce){var ie=ce[0],ne=_(ie,ce[3]||"");return{type:"code",raw:ie,lang:ce[2]?ce[2].trim():ce[2],text:ne}}},be.heading=function(oe){var ce=this.rules.block.heading.exec(oe);if(ce){var ie=ce[2].trim();if(/#$/.test(ie)){var ne=m(ie,"#");(this.options.pedantic||!ne||/ $/.test(ne))&&(ie=ne.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:ie,tokens:this.lexer.inline(ie)}}},be.hr=function(oe){var ce=this.rules.block.hr.exec(oe);if(ce)return{type:"hr",raw:ce[0]}},be.blockquote=function(oe){var ce=this.rules.block.blockquote.exec(oe);if(ce){var ie=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(ie,[]),text:ie}}},be.list=function(oe){var ce=this.rules.block.list.exec(oe);if(ce){var ie,ne,C,W,q,x,ae,ge,ee,we,ye,ze,je=ce[1].trim(),et=je.length>1,Ye={type:"list",raw:"",ordered:et,start:et?+je.slice(0,-1):"",loose:!1,items:[]};je=et?"\\d{1,9}\\"+je.slice(-1):"\\"+je,this.options.pedantic&&(je=et?je:"[*+-]");for(var Je=new RegExp("^( {0,3}"+je+")((?:[	 ][^\\n]*)?(?:\\n|$))");oe&&(ze=!1,!(!(ce=Je.exec(oe))||this.rules.block.hr.test(oe)));){if(ie=ce[0],oe=oe.substring(ie.length),ge=ce[2].split(`
`,1)[0],ee=oe.split(`
`,1)[0],this.options.pedantic?(W=2,ye=ge.trimLeft()):(W=ce[2].search(/[^ ]/),W=W>4?1:W,ye=ge.slice(W),W+=ce[1].length),x=!1,!ge&&/^ *$/.test(ee)&&(ie+=ee+`
`,oe=oe.substring(ee.length+1),ze=!0),!ze)for(var rt=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),ut=new RegExp("^ {0,"+Math.min(3,W-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Me=new RegExp("^ {0,"+Math.min(3,W-1)+"}(?:```|~~~)"),st=new RegExp("^ {0,"+Math.min(3,W-1)+"}#");oe&&(we=oe.split(`
`,1)[0],ge=we,this.options.pedantic&&(ge=ge.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Me.test(ge)||st.test(ge)||rt.test(ge)||ut.test(oe)));){if(ge.search(/[^ ]/)>=W||!ge.trim())ye+=`
`+ge.slice(W);else if(!x)ye+=`
`+ge;else break;!x&&!ge.trim()&&(x=!0),ie+=we+`
`,oe=oe.substring(we.length+1)}Ye.loose||(ae?Ye.loose=!0:/\n *\n *$/.test(ie)&&(ae=!0)),this.options.gfm&&(ne=/^\[[ xX]\] /.exec(ye),ne&&(C=ne[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ye.items.push({type:"list_item",raw:ie,task:!!ne,checked:C,loose:!1,text:ye}),Ye.raw+=ie}Ye.items[Ye.items.length-1].raw=ie.trimRight(),Ye.items[Ye.items.length-1].text=ye.trimRight(),Ye.raw=Ye.raw.trimRight();var Z=Ye.items.length;for(q=0;q<Z;q++){this.lexer.state.top=!1,Ye.items[q].tokens=this.lexer.blockTokens(Ye.items[q].text,[]);var J=Ye.items[q].tokens.filter(function(Ue){return Ue.type==="space"}),Se=J.every(function(Ue){for(var We=Ue.raw.split(""),Qe=0,Ve=L(We),it;!(it=Ve()).done;){var Et=it.value;if(Et===`
`&&(Qe+=1),Qe>1)return!0}return!1});!Ye.loose&&J.length&&Se&&(Ye.loose=!0,Ye.items[q].loose=!0)}return Ye}},be.html=function(oe){var ce=this.rules.block.html.exec(oe);if(ce){var ie={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var ne=this.options.sanitizer?this.options.sanitizer(ce[0]):p(ce[0]);ie.type="paragraph",ie.text=ne,ie.tokens=this.lexer.inline(ne)}return ie}},be.def=function(oe){var ce=this.rules.block.def.exec(oe);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var ie=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ie,raw:ce[0],href:ce[2],title:ce[3]}}},be.table=function(oe){var ce=this.rules.block.table.exec(oe);if(ce){var ie={type:"table",header:u(ce[1]).map(function(ae){return{text:ae}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(ie.header.length===ie.align.length){ie.raw=ce[0];var ne=ie.align.length,C,W,q,x;for(C=0;C<ne;C++)/^ *-+: *$/.test(ie.align[C])?ie.align[C]="right":/^ *:-+: *$/.test(ie.align[C])?ie.align[C]="center":/^ *:-+ *$/.test(ie.align[C])?ie.align[C]="left":ie.align[C]=null;for(ne=ie.rows.length,C=0;C<ne;C++)ie.rows[C]=u(ie.rows[C],ie.header.length).map(function(ae){return{text:ae}});for(ne=ie.header.length,W=0;W<ne;W++)ie.header[W].tokens=this.lexer.inline(ie.header[W].text);for(ne=ie.rows.length,W=0;W<ne;W++)for(x=ie.rows[W],q=0;q<x.length;q++)x[q].tokens=this.lexer.inline(x[q].text);return ie}}},be.lheading=function(oe){var ce=this.rules.block.lheading.exec(oe);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},be.paragraph=function(oe){var ce=this.rules.block.paragraph.exec(oe);if(ce){var ie=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:ie,tokens:this.lexer.inline(ie)}}},be.text=function(oe){var ce=this.rules.block.text.exec(oe);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},be.escape=function(oe){var ce=this.rules.inline.escape.exec(oe);if(ce)return{type:"escape",raw:ce[0],text:p(ce[1])}},be.tag=function(oe){var ce=this.rules.inline.tag.exec(oe);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):p(ce[0]):ce[0]}},be.link=function(oe){var ce=this.rules.inline.link.exec(oe);if(ce){var ie=ce[2].trim();if(!this.options.pedantic&&/^</.test(ie)){if(!/>$/.test(ie))return;var ne=m(ie.slice(0,-1),"\\");if((ie.length-ne.length)%2===0)return}else{var C=b(ce[2],"()");if(C>-1){var W=ce[0].indexOf("!")===0?5:4,q=W+ce[1].length+C;ce[2]=ce[2].substring(0,C),ce[0]=ce[0].substring(0,q).trim(),ce[3]=""}}var x=ce[2],ae="";if(this.options.pedantic){var ge=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(x);ge&&(x=ge[1],ae=ge[3])}else ae=ce[3]?ce[3].slice(1,-1):"";return x=x.trim(),/^</.test(x)&&(this.options.pedantic&&!/>$/.test(ie)?x=x.slice(1):x=x.slice(1,-1)),V(ce,{href:x&&x.replace(this.rules.inline._escapes,"$1"),title:ae&&ae.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},be.reflink=function(oe,ce){var ie;if((ie=this.rules.inline.reflink.exec(oe))||(ie=this.rules.inline.nolink.exec(oe))){var ne=(ie[2]||ie[1]).replace(/\s+/g," ");if(ne=ce[ne.toLowerCase()],!ne||!ne.href){var C=ie[0].charAt(0);return{type:"text",raw:C,text:C}}return V(ie,ne,ie[0],this.lexer)}},be.emStrong=function(oe,ce,ie){ie===void 0&&(ie="");var ne=this.rules.inline.emStrong.lDelim.exec(oe);if(ne&&!(ne[3]&&ie.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var C=ne[1]||ne[2]||"";if(!C||C&&(ie===""||this.rules.inline.punctuation.exec(ie))){var W=ne[0].length-1,q,x,ae=W,ge=0,ee=ne[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ee.lastIndex=0,ce=ce.slice(-1*oe.length+W);(ne=ee.exec(ce))!=null;)if(q=ne[1]||ne[2]||ne[3]||ne[4]||ne[5]||ne[6],!!q){if(x=q.length,ne[3]||ne[4]){ae+=x;continue}else if((ne[5]||ne[6])&&W%3&&!((W+x)%3)){ge+=x;continue}if(ae-=x,!(ae>0)){if(x=Math.min(x,x+ae+ge),Math.min(W,x)%2){var we=oe.slice(1,W+ne.index+x);return{type:"em",raw:oe.slice(0,W+ne.index+x+1),text:we,tokens:this.lexer.inlineTokens(we)}}var ye=oe.slice(2,W+ne.index+x-1);return{type:"strong",raw:oe.slice(0,W+ne.index+x+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},be.codespan=function(oe){var ce=this.rules.inline.code.exec(oe);if(ce){var ie=ce[2].replace(/\n/g," "),ne=/[^ ]/.test(ie),C=/^ /.test(ie)&&/ $/.test(ie);return ne&&C&&(ie=ie.substring(1,ie.length-1)),ie=p(ie,!0),{type:"codespan",raw:ce[0],text:ie}}},be.br=function(oe){var ce=this.rules.inline.br.exec(oe);if(ce)return{type:"br",raw:ce[0]}},be.del=function(oe){var ce=this.rules.inline.del.exec(oe);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},be.autolink=function(oe,ce){var ie=this.rules.inline.autolink.exec(oe);if(ie){var ne,C;return ie[2]==="@"?(ne=p(this.options.mangle?ce(ie[1]):ie[1]),C="mailto:"+ne):(ne=p(ie[1]),C=ne),{type:"link",raw:ie[0],text:ne,href:C,tokens:[{type:"text",raw:ne,text:ne}]}}},be.url=function(oe,ce){var ie;if(ie=this.rules.inline.url.exec(oe)){var ne,C;if(ie[2]==="@")ne=p(this.options.mangle?ce(ie[0]):ie[0]),C="mailto:"+ne;else{var W;do W=ie[0],ie[0]=this.rules.inline._backpedal.exec(ie[0])[0];while(W!==ie[0]);ne=p(ie[0]),ie[1]==="www."?C="http://"+ne:C=ne}return{type:"link",raw:ie[0],text:ne,href:C,tokens:[{type:"text",raw:ne,text:ne}]}}},be.inlineText=function(oe,ce){var ie=this.rules.inline.text.exec(oe);if(ie){var ne;return this.lexer.state.inRawBlock?ne=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ie[0]):p(ie[0]):ie[0]:ne=p(this.options.smartypants?ce(ie[0]):ie[0]),{type:"text",raw:ie[0],text:ne}}},De}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:k,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=d($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=d(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=d($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=d($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=d($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=d($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=c({},$),$.gfm=c({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=d($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=d($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=c({},$.normal,{html:d(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:k,paragraph:d($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var B={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:k,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:k,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};B._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",B.punctuation=d(B.punctuation).replace(/punctuation/g,B._punctuation).getRegex(),B.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,B.escapedEmSt=/\\\*|\\_/g,B._comment=d($._comment).replace("(?:-->|$)","-->").getRegex(),B.emStrong.lDelim=d(B.emStrong.lDelim).replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimAst=d(B.emStrong.rDelimAst,"g").replace(/punct/g,B._punctuation).getRegex(),B.emStrong.rDelimUnd=d(B.emStrong.rDelimUnd,"g").replace(/punct/g,B._punctuation).getRegex(),B._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,B._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,B._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,B.autolink=d(B.autolink).replace("scheme",B._scheme).replace("email",B._email).getRegex(),B._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,B.tag=d(B.tag).replace("comment",B._comment).replace("attribute",B._attribute).getRegex(),B._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,B._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,B._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,B.link=d(B.link).replace("label",B._label).replace("href",B._href).replace("title",B._title).getRegex(),B.reflink=d(B.reflink).replace("label",B._label).replace("ref",$._label).getRegex(),B.nolink=d(B.nolink).replace("ref",$._label).getRegex(),B.reflinkSearch=d(B.reflinkSearch,"g").replace("reflink",B.reflink).replace("nolink",B.nolink).getRegex(),B.normal=c({},B),B.pedantic=c({},B.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:d(/^!?\[(label)\]\((.*?)\)/).replace("label",B._label).getRegex(),reflink:d(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",B._label).getRegex()}),B.gfm=c({},B.normal,{escape:d(B.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),B.gfm.url=d(B.gfm.url,"i").replace("email",B.gfm._extended_email).getRegex(),B.breaks=c({},B.gfm,{br:d(B.br).replace("{2,}","*").getRegex(),text:d(B.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function X(De){return De.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function U(De){var be="",ke,oe,ce=De.length;for(ke=0;ke<ce;ke++)oe=De.charCodeAt(ke),Math.random()>.5&&(oe="x"+oe.toString(16)),be+="&#"+oe+";";return be}var j=function(){function De(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||te.defaults,this.options.tokenizer=this.options.tokenizer||new G,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var oe={block:$.normal,inline:B.normal};this.options.pedantic?(oe.block=$.pedantic,oe.inline=B.pedantic):this.options.gfm&&(oe.block=$.gfm,this.options.breaks?oe.inline=B.breaks:oe.inline=B.gfm),this.tokenizer.rules=oe}De.lex=function(oe,ce){var ie=new De(ce);return ie.lex(oe)},De.lexInline=function(oe,ce){var ie=new De(ce);return ie.inlineTokens(oe)};var be=De.prototype;return be.lex=function(oe){oe=oe.replace(/\r\n|\r/g,`
`),this.blockTokens(oe,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},be.blockTokens=function(oe,ce){var ie=this;ce===void 0&&(ce=[]),this.options.pedantic?oe=oe.replace(/\t/g,"    ").replace(/^ +$/gm,""):oe=oe.replace(/^( *)(\t+)/gm,function(ae,ge,ee){return ge+"    ".repeat(ee.length)});for(var ne,C,W,q;oe;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(ae){return(ne=ae.call({lexer:ie},oe,ce))?(oe=oe.substring(ne.raw.length),ce.push(ne),!0):!1}))){if(ne=this.tokenizer.space(oe)){oe=oe.substring(ne.raw.length),ne.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(ne);continue}if(ne=this.tokenizer.code(oe)){oe=oe.substring(ne.raw.length),C=ce[ce.length-1],C&&(C.type==="paragraph"||C.type==="text")?(C.raw+=`
`+ne.raw,C.text+=`
`+ne.text,this.inlineQueue[this.inlineQueue.length-1].src=C.text):ce.push(ne);continue}if(ne=this.tokenizer.fences(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.heading(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.hr(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.blockquote(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.list(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.html(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.def(oe)){oe=oe.substring(ne.raw.length),C=ce[ce.length-1],C&&(C.type==="paragraph"||C.type==="text")?(C.raw+=`
`+ne.raw,C.text+=`
`+ne.raw,this.inlineQueue[this.inlineQueue.length-1].src=C.text):this.tokens.links[ne.tag]||(this.tokens.links[ne.tag]={href:ne.href,title:ne.title});continue}if(ne=this.tokenizer.table(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.lheading(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(W=oe,this.options.extensions&&this.options.extensions.startBlock&&function(){var ae=1/0,ge=oe.slice(1),ee=void 0;ie.options.extensions.startBlock.forEach(function(we){ee=we.call({lexer:this},ge),typeof ee=="number"&&ee>=0&&(ae=Math.min(ae,ee))}),ae<1/0&&ae>=0&&(W=oe.substring(0,ae+1))}(),this.state.top&&(ne=this.tokenizer.paragraph(W))){C=ce[ce.length-1],q&&C.type==="paragraph"?(C.raw+=`
`+ne.raw,C.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=C.text):ce.push(ne),q=W.length!==oe.length,oe=oe.substring(ne.raw.length);continue}if(ne=this.tokenizer.text(oe)){oe=oe.substring(ne.raw.length),C=ce[ce.length-1],C&&C.type==="text"?(C.raw+=`
`+ne.raw,C.text+=`
`+ne.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=C.text):ce.push(ne);continue}if(oe){var x="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(x);break}else throw new Error(x)}}return this.state.top=!0,ce},be.inline=function(oe,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:oe,tokens:ce}),ce},be.inlineTokens=function(oe,ce){var ie=this;ce===void 0&&(ce=[]);var ne,C,W,q=oe,x,ae,ge;if(this.tokens.links){var ee=Object.keys(this.tokens.links);if(ee.length>0)for(;(x=this.tokenizer.rules.inline.reflinkSearch.exec(q))!=null;)ee.includes(x[0].slice(x[0].lastIndexOf("[")+1,-1))&&(q=q.slice(0,x.index)+"["+N("a",x[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(x=this.tokenizer.rules.inline.blockSkip.exec(q))!=null;)q=q.slice(0,x.index)+"["+N("a",x[0].length-2)+"]"+q.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(x=this.tokenizer.rules.inline.escapedEmSt.exec(q))!=null;)q=q.slice(0,x.index)+"++"+q.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;oe;)if(ae||(ge=""),ae=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(ne=ye.call({lexer:ie},oe,ce))?(oe=oe.substring(ne.raw.length),ce.push(ne),!0):!1}))){if(ne=this.tokenizer.escape(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.tag(oe)){oe=oe.substring(ne.raw.length),C=ce[ce.length-1],C&&ne.type==="text"&&C.type==="text"?(C.raw+=ne.raw,C.text+=ne.text):ce.push(ne);continue}if(ne=this.tokenizer.link(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.reflink(oe,this.tokens.links)){oe=oe.substring(ne.raw.length),C=ce[ce.length-1],C&&ne.type==="text"&&C.type==="text"?(C.raw+=ne.raw,C.text+=ne.text):ce.push(ne);continue}if(ne=this.tokenizer.emStrong(oe,q,ge)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.codespan(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.br(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.del(oe)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(ne=this.tokenizer.autolink(oe,U)){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(!this.state.inLink&&(ne=this.tokenizer.url(oe,U))){oe=oe.substring(ne.raw.length),ce.push(ne);continue}if(W=oe,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,ze=oe.slice(1),je=void 0;ie.options.extensions.startInline.forEach(function(et){je=et.call({lexer:this},ze),typeof je=="number"&&je>=0&&(ye=Math.min(ye,je))}),ye<1/0&&ye>=0&&(W=oe.substring(0,ye+1))}(),ne=this.tokenizer.inlineText(W,X)){oe=oe.substring(ne.raw.length),ne.raw.slice(-1)!=="_"&&(ge=ne.raw.slice(-1)),ae=!0,C=ce[ce.length-1],C&&C.type==="text"?(C.raw+=ne.raw,C.text+=ne.text):ce.push(ne);continue}if(oe){var we="Infinite loop on byte: "+oe.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return ce},n(De,null,[{key:"rules",get:function(){return{block:$,inline:B}}}]),De}(),Y=function(){function De(ke){this.options=ke||te.defaults}var be=De.prototype;return be.code=function(oe,ce,ie){var ne=(ce||"").match(/\S*/)[0];if(this.options.highlight){var C=this.options.highlight(oe,ne);C!=null&&C!==oe&&(ie=!0,oe=C)}return oe=oe.replace(/\n$/,"")+`
`,ne?'<pre><code class="'+this.options.langPrefix+p(ne,!0)+'">'+(ie?oe:p(oe,!0))+`</code></pre>
`:"<pre><code>"+(ie?oe:p(oe,!0))+`</code></pre>
`},be.blockquote=function(oe){return`<blockquote>
`+oe+`</blockquote>
`},be.html=function(oe){return oe},be.heading=function(oe,ce,ie,ne){if(this.options.headerIds){var C=this.options.headerPrefix+ne.slug(ie);return"<h"+ce+' id="'+C+'">'+oe+"</h"+ce+`>
`}return"<h"+ce+">"+oe+"</h"+ce+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(oe,ce,ie){var ne=ce?"ol":"ul",C=ce&&ie!==1?' start="'+ie+'"':"";return"<"+ne+C+`>
`+oe+"</"+ne+`>
`},be.listitem=function(oe){return"<li>"+oe+`</li>
`},be.checkbox=function(oe){return"<input "+(oe?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(oe){return"<p>"+oe+`</p>
`},be.table=function(oe,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+oe+`</thead>
`+ce+`</table>
`},be.tablerow=function(oe){return`<tr>
`+oe+`</tr>
`},be.tablecell=function(oe,ce){var ie=ce.header?"th":"td",ne=ce.align?"<"+ie+' align="'+ce.align+'">':"<"+ie+">";return ne+oe+("</"+ie+`>
`)},be.strong=function(oe){return"<strong>"+oe+"</strong>"},be.em=function(oe){return"<em>"+oe+"</em>"},be.codespan=function(oe){return"<code>"+oe+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(oe){return"<del>"+oe+"</del>"},be.link=function(oe,ce,ie){if(oe=v(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ie;var ne='<a href="'+p(oe)+'"';return ce&&(ne+=' title="'+ce+'"'),ne+=">"+ie+"</a>",ne},be.image=function(oe,ce,ie){if(oe=v(this.options.sanitize,this.options.baseUrl,oe),oe===null)return ie;var ne='<img src="'+oe+'" alt="'+ie+'"';return ce&&(ne+=' title="'+ce+'"'),ne+=this.options.xhtml?"/>":">",ne},be.text=function(oe){return oe},De}(),pe=function(){function De(){}var be=De.prototype;return be.strong=function(oe){return oe},be.em=function(oe){return oe},be.codespan=function(oe){return oe},be.del=function(oe){return oe},be.html=function(oe){return oe},be.text=function(oe){return oe},be.link=function(oe,ce,ie){return""+ie},be.image=function(oe,ce,ie){return""+ie},be.br=function(){return""},De}(),Ee=function(){function De(){this.seen={}}var be=De.prototype;return be.serialize=function(oe){return oe.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(oe,ce){var ie=oe,ne=0;if(this.seen.hasOwnProperty(ie)){ne=this.seen[oe];do ne++,ie=oe+"-"+ne;while(this.seen.hasOwnProperty(ie))}return ce||(this.seen[oe]=ne,this.seen[ie]=0),ie},be.slug=function(oe,ce){ce===void 0&&(ce={});var ie=this.serialize(oe);return this.getNextSafeSlug(ie,ce.dryrun)},De}(),he=function(){function De(ke){this.options=ke||te.defaults,this.options.renderer=this.options.renderer||new Y,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new pe,this.slugger=new Ee}De.parse=function(oe,ce){var ie=new De(ce);return ie.parse(oe)},De.parseInline=function(oe,ce){var ie=new De(ce);return ie.parseInline(oe)};var be=De.prototype;return be.parse=function(oe,ce){ce===void 0&&(ce=!0);var ie="",ne,C,W,q,x,ae,ge,ee,we,ye,ze,je,et,Ye,Je,rt,ut,Me,st,Z=oe.length;for(ne=0;ne<Z;ne++){if(ye=oe[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(st=this.options.extensions.renderers[ye.type].call({parser:this},ye),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){ie+=st||"";continue}switch(ye.type){case"space":continue;case"hr":{ie+=this.renderer.hr();continue}case"heading":{ie+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,t(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{ie+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ee="",ge="",q=ye.header.length,C=0;C<q;C++)ge+=this.renderer.tablecell(this.parseInline(ye.header[C].tokens),{header:!0,align:ye.align[C]});for(ee+=this.renderer.tablerow(ge),we="",q=ye.rows.length,C=0;C<q;C++){for(ae=ye.rows[C],ge="",x=ae.length,W=0;W<x;W++)ge+=this.renderer.tablecell(this.parseInline(ae[W].tokens),{header:!1,align:ye.align[W]});we+=this.renderer.tablerow(ge)}ie+=this.renderer.table(ee,we);continue}case"blockquote":{we=this.parse(ye.tokens),ie+=this.renderer.blockquote(we);continue}case"list":{for(ze=ye.ordered,je=ye.start,et=ye.loose,q=ye.items.length,we="",C=0;C<q;C++)Je=ye.items[C],rt=Je.checked,ut=Je.task,Ye="",Je.task&&(Me=this.renderer.checkbox(rt),et?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=Me+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=Me+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:Me}):Ye+=Me),Ye+=this.parse(Je.tokens,et),we+=this.renderer.listitem(Ye,ut,rt);ie+=this.renderer.list(we,ze,je);continue}case"html":{ie+=this.renderer.html(ye.text);continue}case"paragraph":{ie+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(we=ye.tokens?this.parseInline(ye.tokens):ye.text;ne+1<Z&&oe[ne+1].type==="text";)ye=oe[++ne],we+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);ie+=ce?this.renderer.paragraph(we):we;continue}default:{var J='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(J);return}else throw new Error(J)}}}return ie},be.parseInline=function(oe,ce){ce=ce||this.renderer;var ie="",ne,C,W,q=oe.length;for(ne=0;ne<q;ne++){if(C=oe[ne],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[C.type]&&(W=this.options.extensions.renderers[C.type].call({parser:this},C),W!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(C.type))){ie+=W||"";continue}switch(C.type){case"escape":{ie+=ce.text(C.text);break}case"html":{ie+=ce.html(C.text);break}case"link":{ie+=ce.link(C.href,C.title,this.parseInline(C.tokens,ce));break}case"image":{ie+=ce.image(C.href,C.title,C.text);break}case"strong":{ie+=ce.strong(this.parseInline(C.tokens,ce));break}case"em":{ie+=ce.em(this.parseInline(C.tokens,ce));break}case"codespan":{ie+=ce.codespan(C.text);break}case"br":{ie+=ce.br();break}case"del":{ie+=ce.del(this.parseInline(C.tokens,ce));break}case"text":{ie+=ce.text(C.text);break}default:{var x='Token with "'+C.type+'" type was not found.';if(this.options.silent){console.error(x);return}else throw new Error(x)}}}return ie},De}();function de(De,be,ke){if(typeof De>"u"||De===null)throw new Error("marked(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");if(typeof be=="function"&&(ke=be,be=null),be=c({},de.defaults,be||{}),f(be),ke){var oe=be.highlight,ce;try{ce=j.lex(De,be)}catch(q){return ke(q)}var ie=function(x){var ae;if(!x)try{be.walkTokens&&de.walkTokens(ce,be.walkTokens),ae=he.parse(ce,be)}catch(ge){x=ge}return be.highlight=oe,x?ke(x):ke(null,ae)};if(!oe||oe.length<3||(delete be.highlight,!ce.length))return ie();var ne=0;de.walkTokens(ce,function(q){q.type==="code"&&(ne++,setTimeout(function(){oe(q.text,q.lang,function(x,ae){if(x)return ie(x);ae!=null&&ae!==q.text&&(q.text=ae,q.escaped=!0),ne--,ne===0&&ie()})},0))}),ne===0&&ie();return}function C(q){if(q.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+p(q.message+"",!0)+"</pre>";throw q}try{var W=j.lex(De,be);if(be.walkTokens){if(be.async)return Promise.all(de.walkTokens(W,be.walkTokens)).then(function(){return he.parse(W,be)}).catch(C);de.walkTokens(W,be.walkTokens)}return he.parse(W,be)}catch(q){C(q)}}de.options=de.setOptions=function(De){return c(de.defaults,De),A(de.defaults),de},de.getDefaults=R,de.defaults=te.defaults,de.use=function(){for(var De=arguments.length,be=new Array(De),ke=0;ke<De;ke++)be[ke]=arguments[ke];var oe=c.apply(void 0,[{}].concat(be)),ce=de.defaults.extensions||{renderers:{},childTokens:{}},ie;be.forEach(function(ne){if(ne.extensions&&(ie=!0,ne.extensions.forEach(function(W){if(!W.name)throw new Error("extension name required");if(W.renderer){var q=ce.renderers?ce.renderers[W.name]:null;q?ce.renderers[W.name]=function(){for(var x=arguments.length,ae=new Array(x),ge=0;ge<x;ge++)ae[ge]=arguments[ge];var ee=W.renderer.apply(this,ae);return ee===!1&&(ee=q.apply(this,ae)),ee}:ce.renderers[W.name]=W.renderer}if(W.tokenizer){if(!W.level||W.level!=="block"&&W.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[W.level]?ce[W.level].unshift(W.tokenizer):ce[W.level]=[W.tokenizer],W.start&&(W.level==="block"?ce.startBlock?ce.startBlock.push(W.start):ce.startBlock=[W.start]:W.level==="inline"&&(ce.startInline?ce.startInline.push(W.start):ce.startInline=[W.start]))}W.childTokens&&(ce.childTokens[W.name]=W.childTokens)})),ne.renderer&&function(){var W=de.defaults.renderer||new Y,q=function(ge){var ee=W[ge];W[ge]=function(){for(var we=arguments.length,ye=new Array(we),ze=0;ze<we;ze++)ye[ze]=arguments[ze];var je=ne.renderer[ge].apply(W,ye);return je===!1&&(je=ee.apply(W,ye)),je}};for(var x in ne.renderer)q(x);oe.renderer=W}(),ne.tokenizer&&function(){var W=de.defaults.tokenizer||new G,q=function(ge){var ee=W[ge];W[ge]=function(){for(var we=arguments.length,ye=new Array(we),ze=0;ze<we;ze++)ye[ze]=arguments[ze];var je=ne.tokenizer[ge].apply(W,ye);return je===!1&&(je=ee.apply(W,ye)),je}};for(var x in ne.tokenizer)q(x);oe.tokenizer=W}(),ne.walkTokens){var C=de.defaults.walkTokens;oe.walkTokens=function(W){var q=[];return q.push(ne.walkTokens.call(this,W)),C&&(q=q.concat(C.call(this,W))),q}}ie&&(oe.extensions=ce),de.setOptions(oe)})},de.walkTokens=function(De,be){for(var ke=[],oe=function(){var C=ie.value;switch(ke=ke.concat(be.call(de,C)),C.type){case"table":{for(var W=L(C.header),q;!(q=W()).done;){var x=q.value;ke=ke.concat(de.walkTokens(x.tokens,be))}for(var ae=L(C.rows),ge;!(ge=ae()).done;)for(var ee=ge.value,we=L(ee),ye;!(ye=we()).done;){var ze=ye.value;ke=ke.concat(de.walkTokens(ze.tokens,be))}break}case"list":{ke=ke.concat(de.walkTokens(C.items,be));break}default:de.defaults.extensions&&de.defaults.extensions.childTokens&&de.defaults.extensions.childTokens[C.type]?de.defaults.extensions.childTokens[C.type].forEach(function(je){ke=ke.concat(de.walkTokens(C[je],be))}):C.tokens&&(ke=ke.concat(de.walkTokens(C.tokens,be)))}},ce=L(De),ie;!(ie=ce()).done;)oe();return ke},de.parseInline=function(De,be){if(typeof De>"u"||De===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof De!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(De)+", string expected");be=c({},de.defaults,be||{}),f(be);try{var ke=j.lexInline(De,be);return be.walkTokens&&de.walkTokens(ke,be.walkTokens),he.parseInline(ke,be)}catch(oe){if(oe.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+p(oe.message+"",!0)+"</pre>";throw oe}},de.Parser=he,de.parser=he.parse,de.Renderer=Y,de.TextRenderer=pe,de.Lexer=j,de.lexer=j.lex,de.Tokenizer=G,de.Slugger=Ee,de.parse=de;var Re=de.options,le=de.setOptions,ue=de.use,H=de.walkTokens,F=de.parseInline,Q=de,me=he.parse,Ce=j.lex;te.Lexer=j,te.Parser=he,te.Renderer=Y,te.Slugger=Ee,te.TextRenderer=pe,te.Tokenizer=G,te.getDefaults=R,te.lexer=Ce,te.marked=de,te.options=Re,te.parse=Q,te.parseInline=F,te.parser=me,te.setOptions=le,te.use=ue,te.walkTokens=H,Object.defineProperty(te,"__esModule",{value:!0})}),define(Pe[116],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function n(A,y,h){return Math.min(Math.max(A,y),h)}e.clamp=n;function P(A,y){return(y+A%y)%y}e.rot=P;class I{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=I;class L{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=L;class R{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const h=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=h,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=R}),function(){function te(I){const L=[];typeof I=="number"&&L.push("code/timeOrigin",I);function R(y){L.push(y,Date.now())}function A(){const y=[];for(let h=0;h<L.length;h+=2)y.push({name:L[h],startTime:L[h+1]});return y}return{mark:R,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const R of performance.getEntriesByType("mark"))L.push({name:R.name,startTime:Math.round(I+R.startTime)});return L}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function n(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return n(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=n(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=n(P))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var n=e();for(var P in n)(typeof exports=="object"?exports:te)[P]=n[P]}}(typeof self<"u"?self:this,function(){return function(te){var e={};function n(P){if(e[P])return e[P].exports;var I=e[P]={i:P,l:!1,exports:{}};return te[P].call(I.exports,I,I.exports,n),I.l=!0,I.exports}return n.m=te,n.c=e,n.d=function(P,I,L){n.o(P,I)||Object.defineProperty(P,I,{enumerable:!0,get:L})},n.r=function(P){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},n.t=function(P,I){if(1&I&&(P=n(P)),8&I||4&I&&typeof P=="object"&&P&&P.__esModule)return P;var L=Object.create(null);if(n.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:P}),2&I&&typeof P!="string")for(var R in P)n.d(L,R,function(A){return P[A]}.bind(null,R));return L},n.n=function(P){var I=P&&P.__esModule?function(){return P.default}:function(){return P};return n.d(I,"a",I),I},n.o=function(P,I){return Object.prototype.hasOwnProperty.call(P,I)},n.p="",n(n.s=0)}([function(te,e,n){(function(P){var I;e=te.exports=ue,I=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var ee=Array.prototype.slice.call(arguments,0);ee.unshift("SEMVER"),console.log.apply(console,ee)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,R=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],h=0,O=h++;y[O]="0|[1-9]\\d*";var w=h++;y[w]="[0-9]+";var g=h++;y[g]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var S=h++;y[S]="("+y[O]+")\\.("+y[O]+")\\.("+y[O]+")";var p=h++;y[p]="("+y[w]+")\\.("+y[w]+")\\.("+y[w]+")";var l=h++;y[l]="(?:"+y[O]+"|"+y[g]+")";var t=h++;y[t]="(?:"+y[w]+"|"+y[g]+")";var o=h++;y[o]="(?:-("+y[l]+"(?:\\."+y[l]+")*))";var d=h++;y[d]="(?:-?("+y[t]+"(?:\\."+y[t]+")*))";var D=h++;y[D]="[0-9A-Za-z-]+";var T=h++;y[T]="(?:\\+("+y[D]+"(?:\\."+y[D]+")*))";var v=h++,i="v?"+y[S]+y[o]+"?"+y[T]+"?";y[v]="^"+i+"$";var a="[v=\\s]*"+y[p]+y[d]+"?"+y[T]+"?",r=h++;y[r]="^"+a+"$";var s=h++;y[s]="((?:<|>)?=?)";var E=h++;y[E]=y[w]+"|x|X|\\*";var k=h++;y[k]=y[O]+"|x|X|\\*";var c=h++;y[c]="[v=\\s]*("+y[k]+")(?:\\.("+y[k]+")(?:\\.("+y[k]+")(?:"+y[o]+")?"+y[T]+"?)?)?";var u=h++;y[u]="[v=\\s]*("+y[E]+")(?:\\.("+y[E]+")(?:\\.("+y[E]+")(?:"+y[d]+")?"+y[T]+"?)?)?";var m=h++;y[m]="^"+y[s]+"\\s*"+y[c]+"$";var b=h++;y[b]="^"+y[s]+"\\s*"+y[u]+"$";var f=h++;y[f]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=h++;y[N]="(?:~>?)";var V=h++;y[V]="(\\s*)"+y[N]+"\\s+",A[V]=new RegExp(y[V],"g");var _=h++;y[_]="^"+y[N]+y[c]+"$";var G=h++;y[G]="^"+y[N]+y[u]+"$";var $=h++;y[$]="(?:\\^)";var B=h++;y[B]="(\\s*)"+y[$]+"\\s+",A[B]=new RegExp(y[B],"g");var X=h++;y[X]="^"+y[$]+y[c]+"$";var U=h++;y[U]="^"+y[$]+y[u]+"$";var j=h++;y[j]="^"+y[s]+"\\s*("+a+")$|^$";var Y=h++;y[Y]="^"+y[s]+"\\s*("+i+")$|^$";var pe=h++;y[pe]="(\\s*)"+y[s]+"\\s*("+a+"|"+y[c]+")",A[pe]=new RegExp(y[pe],"g");var Ee=h++;y[Ee]="^\\s*("+y[c]+")\\s+-\\s+("+y[c]+")\\s*$";var he=h++;y[he]="^\\s*("+y[u]+")\\s+-\\s+("+y[u]+")\\s*$";var de=h++;y[de]="(<|>)?=?\\s*\\*";for(var Re=0;Re<35;Re++)I(Re,y[Re]),A[Re]||(A[Re]=new RegExp(y[Re]));function le(ee,we){if(ee instanceof ue)return ee;if(typeof ee!="string"||ee.length>L||!(we?A[r]:A[v]).test(ee))return null;try{return new ue(ee,we)}catch{return null}}function ue(ee,we){if(ee instanceof ue){if(ee.loose===we)return ee;ee=ee.version}else if(typeof ee!="string")throw new TypeError("Invalid Version: "+ee);if(ee.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof ue))return new ue(ee,we);I("SemVer",ee,we),this.loose=we;var ye=ee.trim().match(we?A[r]:A[v]);if(!ye)throw new TypeError("Invalid Version: "+ee);if(this.raw=ee,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>R||this.major<0)throw new TypeError("Invalid major version");if(this.minor>R||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>R||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(ze){if(/^[0-9]+$/.test(ze)){var je=+ze;if(je>=0&&je<R)return je}return ze}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=le,e.valid=function(ee,we){var ye=le(ee,we);return ye?ye.version:null},e.clean=function(ee,we){var ye=le(ee.trim().replace(/^[=v]+/,""),we);return ye?ye.version:null},e.SemVer=ue,ue.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ue.prototype.toString=function(){return this.version},ue.prototype.compare=function(ee){return I("SemVer.compare",this.version,this.loose,ee),ee instanceof ue||(ee=new ue(ee,this.loose)),this.compareMain(ee)||this.comparePre(ee)},ue.prototype.compareMain=function(ee){return ee instanceof ue||(ee=new ue(ee,this.loose)),F(this.major,ee.major)||F(this.minor,ee.minor)||F(this.patch,ee.patch)},ue.prototype.comparePre=function(ee){if(ee instanceof ue||(ee=new ue(ee,this.loose)),this.prerelease.length&&!ee.prerelease.length)return-1;if(!this.prerelease.length&&ee.prerelease.length)return 1;if(!this.prerelease.length&&!ee.prerelease.length)return 0;var we=0;do{var ye=this.prerelease[we],ze=ee.prerelease[we];if(I("prerelease compare",we,ye,ze),ye===void 0&&ze===void 0)return 0;if(ze===void 0)return 1;if(ye===void 0)return-1;if(ye!==ze)return F(ye,ze)}while(++we)},ue.prototype.inc=function(ee,we){switch(ee){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",we);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",we);break;case"prepatch":this.prerelease.length=0,this.inc("patch",we),this.inc("pre",we);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",we),this.inc("pre",we);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}we&&(this.prerelease[0]===we?isNaN(this.prerelease[1])&&(this.prerelease=[we,0]):this.prerelease=[we,0]);break;default:throw new Error("invalid increment argument: "+ee)}return this.format(),this.raw=this.version,this},e.inc=function(ee,we,ye,ze){typeof ye=="string"&&(ze=ye,ye=void 0);try{return new ue(ee,ye).inc(we,ze).version}catch{return null}},e.diff=function(ee,we){if(De(ee,we))return null;var ye=le(ee),ze=le(we);if(ye.prerelease.length||ze.prerelease.length){for(var je in ye)if((je==="major"||je==="minor"||je==="patch")&&ye[je]!==ze[je])return"pre"+je;return"prerelease"}for(var je in ye)if((je==="major"||je==="minor"||je==="patch")&&ye[je]!==ze[je])return je},e.compareIdentifiers=F;var H=/^[0-9]+$/;function F(ee,we){var ye=H.test(ee),ze=H.test(we);return ye&&ze&&(ee=+ee,we=+we),ye&&!ze?-1:ze&&!ye?1:ee<we?-1:ee>we?1:0}function Q(ee,we,ye){return new ue(ee,ye).compare(new ue(we,ye))}function me(ee,we,ye){return Q(ee,we,ye)>0}function Ce(ee,we,ye){return Q(ee,we,ye)<0}function De(ee,we,ye){return Q(ee,we,ye)===0}function be(ee,we,ye){return Q(ee,we,ye)!==0}function ke(ee,we,ye){return Q(ee,we,ye)>=0}function oe(ee,we,ye){return Q(ee,we,ye)<=0}function ce(ee,we,ye,ze){var je;switch(we){case"===":typeof ee=="object"&&(ee=ee.version),typeof ye=="object"&&(ye=ye.version),je=ee===ye;break;case"!==":typeof ee=="object"&&(ee=ee.version),typeof ye=="object"&&(ye=ye.version),je=ee!==ye;break;case"":case"=":case"==":je=De(ee,ye,ze);break;case"!=":je=be(ee,ye,ze);break;case">":je=me(ee,ye,ze);break;case">=":je=ke(ee,ye,ze);break;case"<":je=Ce(ee,ye,ze);break;case"<=":je=oe(ee,ye,ze);break;default:throw new TypeError("Invalid operator: "+we)}return je}function ie(ee,we){if(ee instanceof ie){if(ee.loose===we)return ee;ee=ee.value}if(!(this instanceof ie))return new ie(ee,we);I("comparator",ee,we),this.loose=we,this.parse(ee),this.semver===ne?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(ee,we){return F(we,ee)},e.major=function(ee,we){return new ue(ee,we).major},e.minor=function(ee,we){return new ue(ee,we).minor},e.patch=function(ee,we){return new ue(ee,we).patch},e.compare=Q,e.compareLoose=function(ee,we){return Q(ee,we,!0)},e.rcompare=function(ee,we,ye){return Q(we,ee,ye)},e.sort=function(ee,we){return ee.sort(function(ye,ze){return e.compare(ye,ze,we)})},e.rsort=function(ee,we){return ee.sort(function(ye,ze){return e.rcompare(ye,ze,we)})},e.gt=me,e.lt=Ce,e.eq=De,e.neq=be,e.gte=ke,e.lte=oe,e.cmp=ce,e.Comparator=ie;var ne={};function C(ee,we){if(ee instanceof C)return ee.loose===we?ee:new C(ee.raw,we);if(ee instanceof ie)return new C(ee.value,we);if(!(this instanceof C))return new C(ee,we);if(this.loose=we,this.raw=ee,this.set=ee.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ee);this.format()}function W(ee){return!ee||ee.toLowerCase()==="x"||ee==="*"}function q(ee,we,ye,ze,je,et,Ye,Je,rt,ut,Me,st,Z){return((we=W(ye)?"":W(ze)?">="+ye+".0.0":W(je)?">="+ye+"."+ze+".0":">="+we)+" "+(Je=W(rt)?"":W(ut)?"<"+(+rt+1)+".0.0":W(Me)?"<"+rt+"."+(+ut+1)+".0":st?"<="+rt+"."+ut+"."+Me+"-"+st:"<="+Je)).trim()}function x(ee,we){for(var ye=0;ye<ee.length;ye++)if(!ee[ye].test(we))return!1;if(we.prerelease.length){for(ye=0;ye<ee.length;ye++)if(I(ee[ye].semver),ee[ye].semver!==ne&&ee[ye].semver.prerelease.length>0){var ze=ee[ye].semver;if(ze.major===we.major&&ze.minor===we.minor&&ze.patch===we.patch)return!0}return!1}return!0}function ae(ee,we,ye){try{we=new C(we,ye)}catch{return!1}return we.test(ee)}function ge(ee,we,ye,ze){var je,et,Ye,Je,rt;switch(ee=new ue(ee,ze),we=new C(we,ze),ye){case">":je=me,et=oe,Ye=Ce,Je=">",rt=">=";break;case"<":je=Ce,et=ke,Ye=me,Je="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(ae(ee,we,ze))return!1;for(var ut=0;ut<we.set.length;++ut){var Me=we.set[ut],st=null,Z=null;if(Me.forEach(function(J){J.semver===ne&&(J=new ie(">=0.0.0")),st=st||J,Z=Z||J,je(J.semver,st.semver,ze)?st=J:Ye(J.semver,Z.semver,ze)&&(Z=J)}),st.operator===Je||st.operator===rt||(!Z.operator||Z.operator===Je)&&et(ee,Z.semver)||Z.operator===rt&&Ye(ee,Z.semver))return!1}return!0}ie.prototype.parse=function(ee){var we=this.loose?A[j]:A[Y],ye=ee.match(we);if(!ye)throw new TypeError("Invalid comparator: "+ee);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new ue(ye[2],this.loose):this.semver=ne},ie.prototype.toString=function(){return this.value},ie.prototype.test=function(ee){return I("Comparator.test",ee,this.loose),this.semver===ne||(typeof ee=="string"&&(ee=new ue(ee,this.loose)),ce(ee,this.operator,this.semver,this.loose))},ie.prototype.intersects=function(ee,we){if(!(ee instanceof ie))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new C(ee.value,we),ae(this.value,ye,we);if(ee.operator==="")return ye=new C(this.value,we),ae(ee.semver,ye,we);var ze=!(this.operator!==">="&&this.operator!==">"||ee.operator!==">="&&ee.operator!==">"),je=!(this.operator!=="<="&&this.operator!=="<"||ee.operator!=="<="&&ee.operator!=="<"),et=this.semver.version===ee.semver.version,Ye=!(this.operator!==">="&&this.operator!=="<="||ee.operator!==">="&&ee.operator!=="<="),Je=ce(this.semver,"<",ee.semver,we)&&(this.operator===">="||this.operator===">")&&(ee.operator==="<="||ee.operator==="<"),rt=ce(this.semver,">",ee.semver,we)&&(this.operator==="<="||this.operator==="<")&&(ee.operator===">="||ee.operator===">");return ze||je||et&&Ye||Je||rt},e.Range=C,C.prototype.format=function(){return this.range=this.set.map(function(ee){return ee.join(" ").trim()}).join("||").trim(),this.range},C.prototype.toString=function(){return this.range},C.prototype.parseRange=function(ee){var we=this.loose;ee=ee.trim(),I("range",ee,we);var ye=we?A[he]:A[Ee];ee=ee.replace(ye,q),I("hyphen replace",ee),ee=ee.replace(A[pe],"$1$2$3"),I("comparator trim",ee,A[pe]),ee=(ee=(ee=ee.replace(A[V],"$1~")).replace(A[B],"$1^")).split(/\s+/).join(" ");var ze=we?A[j]:A[Y],je=ee.split(" ").map(function(et){return function(Ye,Je){return I("comp",Ye),Ye=function(rt,ut){return rt.trim().split(/\s+/).map(function(Me){return function(st,Z){I("caret",st,Z);var J=Z?A[U]:A[X];return st.replace(J,function(Se,Ue,We,Qe,Ve){var it;return I("caret",st,Se,Ue,We,Qe,Ve),W(Ue)?it="":W(We)?it=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":W(Qe)?it=Ue==="0"?">="+Ue+"."+We+".0 <"+Ue+"."+(+We+1)+".0":">="+Ue+"."+We+".0 <"+(+Ue+1)+".0.0":Ve?(I("replaceCaret pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),it=Ue==="0"?We==="0"?">="+Ue+"."+We+"."+Qe+Ve+" <"+Ue+"."+We+"."+(+Qe+1):">="+Ue+"."+We+"."+Qe+Ve+" <"+Ue+"."+(+We+1)+".0":">="+Ue+"."+We+"."+Qe+Ve+" <"+(+Ue+1)+".0.0"):(I("no pr"),it=Ue==="0"?We==="0"?">="+Ue+"."+We+"."+Qe+" <"+Ue+"."+We+"."+(+Qe+1):">="+Ue+"."+We+"."+Qe+" <"+Ue+"."+(+We+1)+".0":">="+Ue+"."+We+"."+Qe+" <"+(+Ue+1)+".0.0"),I("caret return",it),it})}(Me,ut)}).join(" ")}(Ye,Je),I("caret",Ye),Ye=function(rt,ut){return rt.trim().split(/\s+/).map(function(Me){return function(st,Z){var J=Z?A[G]:A[_];return st.replace(J,function(Se,Ue,We,Qe,Ve){var it;return I("tilde",st,Se,Ue,We,Qe,Ve),W(Ue)?it="":W(We)?it=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":W(Qe)?it=">="+Ue+"."+We+".0 <"+Ue+"."+(+We+1)+".0":Ve?(I("replaceTilde pr",Ve),Ve.charAt(0)!=="-"&&(Ve="-"+Ve),it=">="+Ue+"."+We+"."+Qe+Ve+" <"+Ue+"."+(+We+1)+".0"):it=">="+Ue+"."+We+"."+Qe+" <"+Ue+"."+(+We+1)+".0",I("tilde return",it),it})}(Me,ut)}).join(" ")}(Ye,Je),I("tildes",Ye),Ye=function(rt,ut){return I("replaceXRanges",rt,ut),rt.split(/\s+/).map(function(Me){return function(st,Z){st=st.trim();var J=Z?A[b]:A[m];return st.replace(J,function(Se,Ue,We,Qe,Ve,it){I("xRange",st,Se,Ue,We,Qe,Ve,it);var Et=W(We),yt=Et||W(Qe),Tt=yt||W(Ve);return Ue==="="&&Tt&&(Ue=""),Et?Se=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&Tt?(yt&&(Qe=0),Tt&&(Ve=0),Ue===">"?(Ue=">=",yt?(We=+We+1,Qe=0,Ve=0):Tt&&(Qe=+Qe+1,Ve=0)):Ue==="<="&&(Ue="<",yt?We=+We+1:Qe=+Qe+1),Se=Ue+We+"."+Qe+"."+Ve):yt?Se=">="+We+".0.0 <"+(+We+1)+".0.0":Tt&&(Se=">="+We+"."+Qe+".0 <"+We+"."+(+Qe+1)+".0"),I("xRange return",Se),Se})}(Me,ut)}).join(" ")}(Ye,Je),I("xrange",Ye),Ye=function(rt,ut){return I("replaceStars",rt,ut),rt.trim().replace(A[de],"")}(Ye,Je),I("stars",Ye),Ye}(et,we)}).join(" ").split(/\s+/);return this.loose&&(je=je.filter(function(et){return!!et.match(ze)})),je=je.map(function(et){return new ie(et,we)})},C.prototype.intersects=function(ee,we){if(!(ee instanceof C))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(ze){return ee.set.some(function(je){return je.every(function(et){return ze.intersects(et,we)})})})})},e.toComparators=function(ee,we){return new C(ee,we).set.map(function(ye){return ye.map(function(ze){return ze.value}).join(" ").trim().split(" ")})},C.prototype.test=function(ee){if(!ee)return!1;typeof ee=="string"&&(ee=new ue(ee,this.loose));for(var we=0;we<this.set.length;we++)if(x(this.set[we],ee))return!0;return!1},e.satisfies=ae,e.maxSatisfying=function(ee,we,ye){var ze=null,je=null;try{var et=new C(we,ye)}catch{return null}return ee.forEach(function(Ye){et.test(Ye)&&(ze&&je.compare(Ye)!==-1||(je=new ue(ze=Ye,ye)))}),ze},e.minSatisfying=function(ee,we,ye){var ze=null,je=null;try{var et=new C(we,ye)}catch{return null}return ee.forEach(function(Ye){et.test(Ye)&&(ze&&je.compare(Ye)!==1||(je=new ue(ze=Ye,ye)))}),ze},e.validRange=function(ee,we){try{return new C(ee,we).range||"*"}catch{return null}},e.ltr=function(ee,we,ye){return ge(ee,we,"<",ye)},e.gtr=function(ee,we,ye){return ge(ee,we,">",ye)},e.outside=ge,e.prerelease=function(ee,we){var ye=le(ee,we);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ee,we,ye){return ee=new C(ee,ye),we=new C(we,ye),ee.intersects(we)},e.coerce=function(ee){if(ee instanceof ue)return ee;if(typeof ee!="string")return null;var we=ee.match(A[f]);return we==null?null:le((we[1]||"0")+"."+(we[2]||"0")+"."+(we[3]||"0"))}}).call(this,n(1))},function(te,e){var n,P,I=te.exports={};function L(){throw new Error("setTimeout has not been defined")}function R(){throw new Error("clearTimeout has not been defined")}function A(t){if(n===setTimeout)return setTimeout(t,0);if((n===L||!n)&&setTimeout)return n=setTimeout,setTimeout(t,0);try{return n(t,0)}catch{try{return n.call(null,t,0)}catch{return n.call(this,t,0)}}}(function(){try{n=typeof setTimeout=="function"?setTimeout:L}catch{n=L}try{P=typeof clearTimeout=="function"?clearTimeout:R}catch{P=R}})();var y,h=[],O=!1,w=-1;function g(){O&&y&&(O=!1,y.length?h=y.concat(h):w=-1,h.length&&S())}function S(){if(!O){var t=A(g);O=!0;for(var o=h.length;o;){for(y=h,h=[];++w<o;)y&&y[w].run();w=-1,o=h.length}y=null,O=!1,function(d){if(P===clearTimeout)return clearTimeout(d);if((P===R||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(d);try{P(d)}catch{try{return P.call(null,d)}catch{return P.call(this,d)}}}(t)}}function p(t,o){this.fun=t,this.array=o}function l(){}I.nextTick=function(t){var o=new Array(arguments.length-1);if(arguments.length>1)for(var d=1;d<arguments.length;d++)o[d-1]=arguments[d];h.push(new p(t,o)),h.length!==1||O||A(S)},p.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=l,I.addListener=l,I.once=l,I.off=l,I.removeListener=l,I.removeAllListeners=l,I.emit=l,I.prependListener=l,I.prependOnceListener=l,I.listeners=function(t){return[]},I.binding=function(t){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(t){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(Pe[117],Ae([1,0,9,6]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function I(T){const v=T;return v?typeof v.read=="function":!1}e.isReadable=I;function L(T){const v=T;return v?[v.on,v.pause,v.resume,v.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=L;function R(T){const v=T;return v?L(v.stream)&&Array.isArray(v.buffer)&&typeof v.ended=="boolean":!1}e.isReadableBufferedStream=R;function A(T,v){return new y(T,v)}e.newWriteableStream=A;class y{constructor(v,i){this.e=v,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(v){if(!this.a.destroyed){if(this.a.flowing)this.g(v);else if(this.b.data.push(v),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(v){this.a.destroyed||(this.a.flowing?this.h(v):this.b.error.push(v))}end(v){this.a.destroyed||(typeof v<"u"&&this.write(v),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(v){this.c.data.slice(0).forEach(i=>i(v))}h(v){this.c.error.length===0?(0,n.onUnexpectedError)(v):this.c.error.slice(0).forEach(i=>i(v))}i(){this.c.end.slice(0).forEach(v=>v())}on(v,i){if(!this.a.destroyed)switch(v){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(v,i){if(this.a.destroyed)return;let a;switch(v){case"data":a=this.c.data;break;case"end":a=this.c.end;break;case"error":a=this.c.error;break}if(a){const r=a.indexOf(i);r>=0&&a.splice(r,1)}}j(){if(this.b.data.length>0){const v=this.e(this.b.data);this.g(v),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(a=>a())}}k(){if(this.c.error.length>0){for(const v of this.b.error)this.h(v);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function h(T,v){const i=[];let a;for(;(a=T.read())!==null;)i.push(a);return v(i)}e.consumeReadable=h;function O(T,v,i){const a=[];let r;for(;(r=T.read())!==null&&a.length<i;)a.push(r);return r===null&&a.length>0?v(a):{read:()=>{if(a.length>0)return a.shift();if(typeof r<"u"){const s=r;return r=void 0,s}return T.read()}}}e.peekReadable=O;function w(T,v){return new Promise((i,a)=>{const r=[];g(T,{onData:s=>{v&&r.push(s)},onError:s=>{v?a(s):i(void 0)},onEnd:()=>{i(v?v(r):void 0)}})})}e.consumeStream=w;function g(T,v){let i=!1;return T.on("error",a=>{i||v.onError(a)}),T.on("end",()=>{i||v.onEnd()}),T.on("data",a=>{i||v.onData(a)}),(0,P.toDisposable)(()=>i=!0)}e.listenStream=g;function S(T,v){return new Promise((i,a)=>{const r=new P.DisposableStore,s=[],E=u=>{if(s.push(u),s.length>v)return r.dispose(),T.pause(),i({stream:T,buffer:s,ended:!1})},k=u=>a(u),c=()=>i({stream:T,buffer:s,ended:!0});r.add((0,P.toDisposable)(()=>T.removeListener("error",k))),T.on("error",k),r.add((0,P.toDisposable)(()=>T.removeListener("end",c))),T.on("end",c),r.add((0,P.toDisposable)(()=>T.removeListener("data",E))),T.on("data",E)})}e.peekStream=S;function p(T,v){const i=A(v);return i.end(T),i}e.toStream=p;function l(){const T=A(()=>{throw new Error("not supported")});return T.end(),T}e.emptyStream=l;function t(T){let v=!1;return{read:()=>v?null:(v=!0,T)}}e.toReadable=t;function o(T,v,i){const a=A(i);return g(T,{onData:r=>a.write(v.data(r)),onError:r=>a.error(v.error?v.error(r):r),onEnd:()=>a.end()}),a}e.transform=o;function d(T,v,i){let a=!1;return{read:()=>{const r=v.read();return a?r:(a=!0,r!==null?i([T,r]):T)}}}e.prefixedReadable=d;function D(T,v,i){let a=!1;const r=A(i);return g(v,{onData:s=>a?r.write(s):(a=!0,r.write(i([T,s]))),onError:s=>r.error(s),onEnd:()=>{a||(a=!0,r.write(T)),r.end()}}),r}e.prefixedStream=D}),define(Pe[25],Ae([1,0,117]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const P=typeof Buffer<"u";let I,L;class R{static alloc(u){return P?new R(Buffer.allocUnsafe(u)):new R(new Uint8Array(u))}static wrap(u){return P&&!Buffer.isBuffer(u)&&(u=Buffer.from(u.buffer,u.byteOffset,u.byteLength)),new R(u)}static fromString(u,m){return!(m?.dontUseNodeBuffer||!1)&&P?new R(Buffer.from(u)):(I||(I=new TextEncoder),new R(I.encode(u)))}static fromByteArray(u){const m=R.alloc(u.length);for(let b=0,f=u.length;b<f;b++)m.buffer[b]=u[b];return m}static concat(u,m){if(typeof m>"u"){m=0;for(let N=0,V=u.length;N<V;N++)m+=u[N].byteLength}const b=R.alloc(m);let f=0;for(let N=0,V=u.length;N<V;N++){const _=u[N];b.set(_,f),f+=_.byteLength}return b}constructor(u){this.buffer=u,this.byteLength=this.buffer.byteLength}clone(){const u=R.alloc(this.byteLength);return u.set(this),u}toString(){return P?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(u,m){return new R(this.buffer.subarray(u,m))}set(u,m){if(u instanceof R)this.buffer.set(u.buffer,m);else if(u instanceof Uint8Array)this.buffer.set(u,m);else if(u instanceof ArrayBuffer)this.buffer.set(new Uint8Array(u),m);else if(ArrayBuffer.isView(u))this.buffer.set(new Uint8Array(u.buffer,u.byteOffset,u.byteLength),m);else throw new Error("Unknown argument 'array'")}readUInt32BE(u){return h(this.buffer,u)}writeUInt32BE(u,m){O(this.buffer,u,m)}readUInt32LE(u){return w(this.buffer,u)}writeUInt32LE(u,m){g(this.buffer,u,m)}readUInt8(u){return S(this.buffer,u)}writeUInt8(u,m){p(this.buffer,u,m)}}e.VSBuffer=R;function A(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0}e.readUInt16LE=A;function y(c,u,m){c[m+0]=u&255,u=u>>>8,c[m+1]=u&255}e.writeUInt16LE=y;function h(c,u){return c[u]*2**24+c[u+1]*2**16+c[u+2]*2**8+c[u+3]}e.readUInt32BE=h;function O(c,u,m){c[m+3]=u,u=u>>>8,c[m+2]=u,u=u>>>8,c[m+1]=u,u=u>>>8,c[m]=u}e.writeUInt32BE=O;function w(c,u){return c[u+0]<<0>>>0|c[u+1]<<8>>>0|c[u+2]<<16>>>0|c[u+3]<<24>>>0}e.readUInt32LE=w;function g(c,u,m){c[m+0]=u&255,u=u>>>8,c[m+1]=u&255,u=u>>>8,c[m+2]=u&255,u=u>>>8,c[m+3]=u&255}e.writeUInt32LE=g;function S(c,u){return c[u]}e.readUInt8=S;function p(c,u,m){c[m]=u}e.writeUInt8=p;function l(c){return n.consumeReadable(c,u=>R.concat(u))}e.readableToBuffer=l;function t(c){return n.toReadable(c)}e.bufferToReadable=t;function o(c){return n.consumeStream(c,u=>R.concat(u))}e.streamToBuffer=o;async function d(c){return c.ended?R.concat(c.buffer):R.concat([...c.buffer,await o(c.stream)])}e.bufferedStreamToBuffer=d;function D(c){return n.toStream(c,u=>R.concat(u))}e.bufferToStream=D;function T(c){return n.transform(c,{data:u=>typeof u=="string"?R.fromString(u):R.wrap(u)},u=>R.concat(u))}e.streamToBufferReadableStream=T;function v(c){return n.newWriteableStream(u=>R.concat(u),c)}e.newWriteableBufferStream=v;function i(c,u){return n.prefixedReadable(c,u,m=>R.concat(m))}e.prefixedBufferReadable=i;function a(c,u){return n.prefixedStream(c,u,m=>R.concat(m))}e.prefixedBufferStream=a;function r(c){let u=0,m=0,b=0;const f=new Uint8Array(Math.floor(c.length/4*3)),N=_=>{switch(m){case 3:f[b++]=u|_,m=0;break;case 2:f[b++]=u|_>>>2,u=_<<6,m=3;break;case 1:f[b++]=u|_>>>4,u=_<<4,m=2;break;default:u=_<<2,m=1}};for(let _=0;_<c.length;_++){const G=c.charCodeAt(_);if(G>=65&&G<=90)N(G-65);else if(G>=97&&G<=122)N(G-97+26);else if(G>=48&&G<=57)N(G-48+52);else if(G===43||G===45)N(62);else if(G===47||G===95)N(63);else{if(G===61)break;throw new SyntaxError(`Unexpected base64 character ${c[_]}`)}}const V=b;for(;m>0;)N(0);return R.wrap(f).slice(0,V)}e.decodeBase64=r;const s="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",E="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function k({buffer:c},u=!0,m=!1){const b=m?E:s;let f="";const N=c.byteLength%3;let V=0;for(;V<c.byteLength-N;V+=3){const _=c[V+0],G=c[V+1],$=c[V+2];f+=b[_>>>2],f+=b[(_<<4|G>>>4)&63],f+=b[(G<<2|$>>>6)&63],f+=b[$&63]}if(N===1){const _=c[V+0];f+=b[_>>>2],f+=b[_<<4&63],u&&(f+="==")}else if(N===2){const _=c[V+0],G=c[V+1];f+=b[_>>>2],f+=b[(_<<4|G>>>4)&63],f+=b[G<<2&63],u&&(f+="=")}return f}e.encodeBase64=k}),define(Pe[118],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(Pe[39],Ae([1,0,85]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var P;(function(R){function A(y){return y&&typeof y=="object"&&typeof y.id=="string"}R.isThemeColor=A})(P||(e.ThemeColor=P={}));function I(R){return{id:R}}e.themeColorFromId=I;var L;(function(R){R.iconNameSegment="[A-Za-z0-9]+",R.iconNameExpression="[A-Za-z0-9-]+",R.iconModifierExpression="~[A-Za-z]+",R.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${R.iconNameExpression})(${R.iconModifierExpression})?$`);function y(d){const D=A.exec(d.id);if(!D)return y(n.Codicon.error);const[,T,v]=D,i=["codicon","codicon-"+T];return v&&i.push("codicon-modifier-"+v.substring(1)),i}R.asClassNameArray=y;function h(d){return y(d).join(" ")}R.asClassName=h;function O(d){return"."+y(d).join(".")}R.asCSSSelector=O;function w(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(typeof d.color>"u"||P.isThemeColor(d.color))}R.isThemeIcon=w;const g=new RegExp(`^\\$\\((${R.iconNameExpression}(?:${R.iconModifierExpression})?)\\)$`);function S(d){const D=g.exec(d);if(!D)return;const[,T]=D;return{id:T}}R.fromString=S;function p(d){return{id:d}}R.fromId=p;function l(d,D){let T=d.id;const v=T.lastIndexOf("~");return v!==-1&&(T=T.substring(0,v)),D&&(T=`${T}~${D}`),{id:T}}R.modify=l;function t(d){const D=d.id.lastIndexOf("~");if(D!==-1)return d.id.substring(D+1)}R.getModifier=t;function o(d,D){return d.id===D.id&&d.color?.id===D.color?.id}R.isEqual=o})(L||(e.ThemeIcon=L={}))}),define(Pe[35],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const n=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(I){return n.test(I)}e.isUUID=P,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const L=new Uint8Array(16),R=[];for(let A=0;A<256;A++)R.push(A.toString(16).padStart(2,"0"));return function(){I(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let y=0,h="";return h+=R[L[y++]],h+=R[L[y++]],h+=R[L[y++]],h+=R[L[y++]],h+="-",h+=R[L[y++]],h+=R[L[y++]],h+="-",h+=R[L[y++]],h+=R[L[y++]],h+="-",h+=R[L[y++]],h+=R[L[y++]],h+="-",h+=R[L[y++]],h+=R[L[y++]],h+=R[L[y++]],h+=R[L[y++]],h+=R[L[y++]],h+=R[L[y++]],h}}()}),define(Pe[119],Ae([1,0,16,86,35]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function L(y){return{id:(0,I.generateUuid)(),asString:async()=>y,asFile:()=>{},value:typeof y=="string"?y:void 0}}e.createStringDataTransferItem=L;function R(y,h,O){return{id:(0,I.generateUuid)(),asString:async()=>"",asFile:()=>({name:y,uri:h,data:O}),value:void 0}}e.createFileDataTransferItem=R;class A{constructor(){this.a=new Map}get size(){let h=0;return this.forEach(()=>h++),h}has(h){return this.a.has(this.b(h))}matches(h){if(this.has(h))return!0;if(h.toLowerCase()==="files")return P.Iterable.some(this.values(),p=>p.asFile());if(h==="*/*")return this.a.size>0;const O=this.b(h).match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!O)return!1;const[w,g,S]=O;return S==="*"?P.Iterable.some(this.a.keys(),p=>p.startsWith(g+"/")):!1}get(h){return this.a.get(this.b(h))?.[0]}append(h,O){const w=this.a.get(h);w?w.push(O):this.a.set(this.b(h),[O])}replace(h,O){this.a.set(this.b(h),[O])}delete(h){this.a.delete(this.b(h))}*entries(){for(const[h,O]of this.a.entries())for(const w of O)yield[h,w]}values(){return Array.from(this.a.values()).flat()}forEach(h){for(const[O,w]of this.entries())h(w,O)}b(h){return h.toLowerCase()}}e.VSDataTransfer=A,e.UriList=Object.freeze({create:y=>(0,n.distinct)(y.map(h=>h.toString())).join(`\r
`),split:y=>y.split(`\r
`),parse:y=>e.UriList.split(y).filter(h=>!h.startsWith("#"))})}),define(Pe[120],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Pe[121],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var n;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(n||(e.IndentAction=n={}));class P{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let y=0,h=A.notIn.length;y<h;y++)switch(A.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const h=A.findTokenIndexAtOffset(y-2),O=A.getStandardTokenType(h);return this.isOK(O)}g(A,y){for(let h=A;h<=y;h++){const O=String.fromCharCode(h);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=P;class I{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)L(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),L(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),L(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),L(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&L(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=I;function L(R,A,y){R.has(A)?R.get(A).push(y):R.set(A,[y])}}),define(Pe[122],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DraggedTreeItemsIdentifier=e.TreeViewsDnDService=void 0;class n{constructor(){this.a=new Map}removeDragOperationTransfer(L){if(L&&this.a.has(L)){const R=this.a.get(L);return this.a.delete(L),R}}addDragOperationTransfer(L,R){this.a.set(L,R)}}e.TreeViewsDnDService=n;class P{constructor(L){this.identifier=L}}e.DraggedTreeItemsIdentifier=P}),define(Pe[123],Ae([10,11]),function(te,e){return te.create("vs/base/common/actions",e)}),define(Pe[124],Ae([10,11]),function(te,e){return te.create("vs/base/common/date",e)}),define(Pe[125],Ae([1,0,124]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const P=60,I=P*60,L=I*24,R=L*7,A=L*30,y=L*365;function h(w,g,S,p){typeof w!="number"&&(w=w.getTime());const l=Math.round((new Date().getTime()-w)/1e3);if(l<-30)return(0,n.localize)(0,null,h(new Date().getTime()+l*1e3,!1));if(!p&&l<30)return(0,n.localize)(1,null);let t;return l<P?(t=l,g?t===1?S?(0,n.localize)(2,null,t):(0,n.localize)(3,null,t):S?(0,n.localize)(4,null,t):(0,n.localize)(5,null,t):t===1?S?(0,n.localize)(6,null,t):(0,n.localize)(7,null,t):S?(0,n.localize)(8,null,t):(0,n.localize)(9,null,t)):l<I?(t=Math.floor(l/P),g?t===1?S?(0,n.localize)(10,null,t):(0,n.localize)(11,null,t):S?(0,n.localize)(12,null,t):(0,n.localize)(13,null,t):t===1?S?(0,n.localize)(14,null,t):(0,n.localize)(15,null,t):S?(0,n.localize)(16,null,t):(0,n.localize)(17,null,t)):l<L?(t=Math.floor(l/I),g?t===1?S?(0,n.localize)(18,null,t):(0,n.localize)(19,null,t):S?(0,n.localize)(20,null,t):(0,n.localize)(21,null,t):t===1?S?(0,n.localize)(22,null,t):(0,n.localize)(23,null,t):S?(0,n.localize)(24,null,t):(0,n.localize)(25,null,t)):l<R?(t=Math.floor(l/L),g?t===1?(0,n.localize)(26,null,t):(0,n.localize)(27,null,t):t===1?(0,n.localize)(28,null,t):(0,n.localize)(29,null,t)):l<A?(t=Math.floor(l/R),g?t===1?S?(0,n.localize)(30,null,t):(0,n.localize)(31,null,t):S?(0,n.localize)(32,null,t):(0,n.localize)(33,null,t):t===1?S?(0,n.localize)(34,null,t):(0,n.localize)(35,null,t):S?(0,n.localize)(36,null,t):(0,n.localize)(37,null,t)):l<y?(t=Math.floor(l/A),g?t===1?S?(0,n.localize)(38,null,t):(0,n.localize)(39,null,t):S?(0,n.localize)(40,null,t):(0,n.localize)(41,null,t):t===1?S?(0,n.localize)(42,null,t):(0,n.localize)(43,null,t):S?(0,n.localize)(44,null,t):(0,n.localize)(45,null,t)):(t=Math.floor(l/y),g?t===1?S?(0,n.localize)(46,null,t):(0,n.localize)(47,null,t):S?(0,n.localize)(48,null,t):(0,n.localize)(49,null,t):t===1?S?(0,n.localize)(50,null,t):(0,n.localize)(51,null,t):S?(0,n.localize)(52,null,t):(0,n.localize)(53,null,t))}e.fromNow=h;function O(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(Pe[126],Ae([10,11]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(Pe[40],Ae([1,0,16,12,126]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(w,g){return g&&(w.stack||w.stacktrace)?I.localize(0,null,A(w),R(w.stack)||R(w.stacktrace)):A(w)}function R(w){return Array.isArray(w)?w.join(`
`):w}function A(w){return w.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${w.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?I.localize(1,null,w.message):w.message||I.localize(2,null)}function y(w=null,g=!1){if(!w)return I.localize(3,null);if(Array.isArray(w)){const S=n.coalesce(w),p=y(S[0],g);return S.length>1?I.localize(4,null,p,S.length):p}if(P.isString(w))return w;if(w.detail){const S=w.detail;if(S.error)return L(S.error,g);if(S.exception)return L(S.exception,g)}return w.stack?L(w,g):w.message?w.message:I.localize(5,null)}e.toErrorMessage=y;function h(w){const g=w;return g instanceof Error&&Array.isArray(g.actions)}e.isErrorWithActions=h;function O(w,g){let S;return typeof w=="string"?S=new Error(w):S=w,S.actions=g,S}e.createErrorWithActions=O}),define(Pe[127],Ae([1,0,87,19]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const I=new n.Lazy(()=>{const u=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:u,collatorIsNumeric:u.resolvedOptions().numeric}}),L=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new n.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(u,m,b=!1){const f=u||"",N=m||"",V=I.value.collator.compare(f,N);return I.value.collatorIsNumeric&&V===0&&f!==N?f<N?-1:1:V}e.compareFileNames=A;function y(u,m){const b=L.value.collator;return u=u||"",m=m||"",T(b,u,m)}e.compareFileNamesDefault=y;function h(u,m){const b=L.value.collator;return u=u||"",m=m||"",r(u,m)||T(b,u,m)}e.compareFileNamesUpper=h;function O(u,m){const b=L.value.collator;return u=u||"",m=m||"",a(u,m)||T(b,u,m)}e.compareFileNamesLower=O;function w(u,m){return u=u||"",m=m||"",u===m?0:u<m?-1:1}e.compareFileNamesUnicode=w;function g(u,m){const[b,f]=d(u),[N,V]=d(m);let _=I.value.collator.compare(f,V);if(_===0){if(I.value.collatorIsNumeric&&f!==V)return f<V?-1:1;if(_=I.value.collator.compare(b,N),I.value.collatorIsNumeric&&_===0&&b!==N)return b<N?-1:1}return _}e.compareFileExtensions=g;function S(u,m){u=u||"",m=m||"";const b=D(u),f=D(m),N=L.value.collator,V=R.value.collator;return T(V,b,f)||T(N,u,m)}e.compareFileExtensionsDefault=S;function p(u,m){u=u||"",m=m||"";const b=D(u),f=D(m),N=L.value.collator,V=R.value.collator;return T(V,b,f)||r(u,m)||T(N,u,m)}e.compareFileExtensionsUpper=p;function l(u,m){u=u||"",m=m||"";const b=D(u),f=D(m),N=L.value.collator,V=R.value.collator;return T(V,b,f)||a(u,m)||T(N,u,m)}e.compareFileExtensionsLower=l;function t(u,m){u=u||"",m=m||"";const b=D(u).toLowerCase(),f=D(m).toLowerCase();return b!==f?b<f?-1:1:u!==m?u<m?-1:1:0}e.compareFileExtensionsUnicode=t;const o=/^(.*?)(\.([^.]*))?$/;function d(u,m=!1){const b=u?o.exec(u):[];let f=[b&&b[1]||"",b&&b[3]||""];return m&&(!f[0]&&f[1]||f[0]&&f[0].charAt(0)===".")&&(f=[f[0]+"."+f[1],""]),f}function D(u){const m=u?o.exec(u):[];return m&&m[1]&&m[1].charAt(0)!=="."&&m[3]||""}function T(u,m,b){const f=u.compare(m,b);return f!==0?f:m.length!==b.length?m.length<b.length?-1:1:0}function v(u){const m=u.charAt(0);return m.toLocaleUpperCase()!==m}function i(u){const m=u.charAt(0);return m.toLocaleLowerCase()!==m}function a(u,m){return v(u)&&i(m)?-1:i(u)&&v(m)?1:0}function r(u,m){return i(u)&&v(m)?-1:v(u)&&i(m)?1:0}function s(u,m,b=!1){return b||(u=u&&u.toLowerCase(),m=m&&m.toLowerCase()),u===m?0:u<m?-1:1}function E(u,m,b=!1){const f=u.split(P.sep),N=m.split(P.sep),V=f.length-1,_=N.length-1;let G,$;for(let B=0;;B++){if(G=V===B,$=_===B,G&&$)return A(f[B],N[B],b);if(G)return-1;if($)return 1;const X=s(f[B],N[B],b);if(X!==0)return X}}e.comparePaths=E;function k(u,m,b){const f=u.toLowerCase(),N=m.toLowerCase(),V=c(u,m,b);if(V)return V;const _=f.endsWith(b),G=N.endsWith(b);if(_!==G)return _?-1:1;const $=A(f,N);return $!==0?$:f.localeCompare(N)}e.compareAnything=k;function c(u,m,b){const f=u.toLowerCase(),N=m.toLowerCase(),V=f.startsWith(b),_=N.startsWith(b);if(V!==_)return V?-1:1;if(V&&_){if(f.length<N.length)return-1;if(f.length>N.length)return 1}return 0}e.compareByPrefix=c}),define(Pe[66],Ae([1,0,19]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const P={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},I={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(O){const w=(0,n.extname)(O),g=P[w.toLowerCase()];return g!==void 0?g:R(O)}e.getMediaOrTextMime=L;function R(O){const w=(0,n.extname)(O);return I[w.toLowerCase()]}e.getMediaMime=R;function A(O){for(const w in I)if(I[w]===O)return w}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function h(O,w){const g=y.exec(O);return g?`${g[1].toLowerCase()}/${g[2].toLowerCase()}${g[3]??""}`:w?void 0:O}e.normalizeMimeType=h}),define(Pe[128],Ae([1,0,5,6,123]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class L extends P.Disposable{constructor(g,S="",p="",l=!0,t){super(),this.h=this.B(new n.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=g,this.m=S,this.u=p,this.w=l,this.C=t}get id(){return this.j}get label(){return this.m}set label(g){this.D(g)}D(g){this.m!==g&&(this.m=g,this.h.fire({label:g}))}get tooltip(){return this.n||""}set tooltip(g){this.F(g)}F(g){this.n!==g&&(this.n=g,this.h.fire({tooltip:g}))}get class(){return this.u}set class(g){this.G(g)}G(g){this.u!==g&&(this.u=g,this.h.fire({class:g}))}get enabled(){return this.w}set enabled(g){this.H(g)}H(g){this.w!==g&&(this.w=g,this.h.fire({enabled:g}))}get checked(){return this.z}set checked(g){this.I(g)}I(g){this.z!==g&&(this.z=g,this.h.fire({checked:g}))}async run(g,S){this.C&&await this.C(g)}}e.Action=L;class R extends P.Disposable{constructor(){super(...arguments),this.f=this.B(new n.Emitter),this.onWillRun=this.f.event,this.h=this.B(new n.Emitter),this.onDidRun=this.h.event}async run(g,S){if(!g.enabled)return;this.f.fire({action:g});let p;try{await this.k(g,S)}catch(l){p=l}this.h.fire({action:g,error:p})}async k(g,S){await g.run(S)}}e.ActionRunner=R;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...g){let S=[];for(const p of g)p.length&&(S.length?S=[...S,new A,...p]:S=p);return S}async run(){}}e.Separator=A,A.ID="vs.actions.separator";class y{get actions(){return this.a}constructor(g,S,p,l){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=g,this.label=S,this.class=l,this.a=p}async run(){}}e.SubmenuAction=y;class h extends L{constructor(){super(h.ID,I.localize(0,null),void 0,!1)}}e.EmptySubmenuAction=h,h.ID="vs.actions.empty";function O(w){return{id:w.id,label:w.label,class:void 0,enabled:w.enabled??!0,checked:w.checked??!1,run:async()=>w.run(),tooltip:w.label}}e.toAction=O}),define(Pe[41],Ae([1,0,19,20,13,12]),function(te,e,n,P,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(k){return k===47||k===92}e.isPathSeparator=R;function A(k){return k.replace(/[\\/]/g,n.posix.sep)}e.toSlashes=A;function y(k){return k.indexOf("/")===-1&&(k=A(k)),/^[a-zA-Z]:(\/|$)/.test(k)&&(k="/"+k),k}e.toPosixPath=y;function h(k,c=n.posix.sep){if(!k)return"";const u=k.length,m=k.charCodeAt(0);if(R(m)){if(R(k.charCodeAt(1))&&!R(k.charCodeAt(2))){let f=3;const N=f;for(;f<u&&!R(k.charCodeAt(f));f++);if(N!==f&&!R(k.charCodeAt(f+1))){for(f+=1;f<u;f++)if(R(k.charCodeAt(f)))return k.slice(0,f+1).replace(/[\\/]/g,c)}}return c}else if(o(m)&&k.charCodeAt(1)===58)return R(k.charCodeAt(2))?k.slice(0,2)+c:k.slice(0,2);let b=k.indexOf("://");if(b!==-1){for(b+=3;b<u;b++)if(R(k.charCodeAt(b)))return k.slice(0,b+1)}return""}e.getRoot=h;function O(k){if(!P.isWindows||!k||k.length<5)return!1;let c=k.charCodeAt(0);if(c!==92||(c=k.charCodeAt(1),c!==92))return!1;let u=2;const m=u;for(;u<k.length&&(c=k.charCodeAt(u),c!==92);u++);return!(m===u||(c=k.charCodeAt(u+1),isNaN(c)||c===92))}e.isUNC=O;const w=/[\\/:\*\?"<>\|]/g,g=/[\\/]/g,S=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function p(k,c=P.isWindows){const u=c?w:g;return!(!k||k.length===0||/^\s+$/.test(k)||(u.lastIndex=0,u.test(k))||c&&S.test(k)||k==="."||k===".."||c&&k[k.length-1]==="."||c&&k.length!==k.trim().length||k.length>255)}e.isValidBasename=p;function l(k,c,u){const m=k===c;return!u||m?m:!k||!c?!1:(0,I.equalsIgnoreCase)(k,c)}e.isEqual=l;function t(k,c,u,m=n.sep){if(k===c)return!0;if(!k||!c||c.length>k.length)return!1;if(u){if(!(0,I.startsWithIgnoreCase)(k,c))return!1;if(c.length===k.length)return!0;let f=c.length;return c.charAt(c.length-1)===m&&f--,k.charAt(f)===m}return c.charAt(c.length-1)!==m&&(c+=m),k.indexOf(c)===0}e.isEqualOrParent=t;function o(k){return k>=65&&k<=90||k>=97&&k<=122}e.isWindowsDriveLetter=o;function d(k,c){return P.isWindows&&k.endsWith(":")&&(k+=n.sep),(0,n.isAbsolute)(k)||(k=(0,n.join)(c,k)),k=(0,n.normalize)(k),P.isWindows?(k=(0,I.rtrim)(k,n.sep),k.endsWith(":")&&(k+=n.sep)):(k=(0,I.rtrim)(k,n.sep),k||(k=n.sep)),k}e.sanitizeFilePath=d;function D(k){const c=(0,n.normalize)(k);return P.isWindows?k.length>3?!1:T(c)&&(k.length===2||c.charCodeAt(2)===92):c===n.posix.sep}e.isRootOrDriveLetter=D;function T(k,c=P.isWindows){return c?o(k.charCodeAt(0))&&k.charCodeAt(1)===58:!1}e.hasDriveLetter=T;function v(k){return T(k)?k[0]:void 0}e.getDriveLetter=v;function i(k,c,u){return c.length>k.length?-1:k===c?0:(u&&(k=k.toLowerCase(),c=c.toLowerCase()),k.indexOf(c))}e.indexOfPath=i;function a(k){const c=k.split(":");let u,m,b;for(const f of c){const N=Number(f);(0,L.isNumber)(N)?m===void 0?m=N:b===void 0&&(b=N):u=u?[u,f].join(":"):f}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:m!==void 0?m:void 0,column:b!==void 0?b:m!==void 0?1:void 0}}e.parseLineAndColumnAware=a;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",s="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function E(k,c,u=8){let m="";for(let f=0;f<u;f++){let N;f===0&&P.isWindows&&!c&&(u===3||u===4)?N=s:N=r,m+=N.charAt(Math.floor(Math.random()*N.length))}let b;return c?b=`${c}-${m}`:b=m,k?(0,n.join)(k,b):b}e.randomPath=E}),define(Pe[129],Ae([1,0,28,13]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function I(...ie){return function(ne,C){for(let W=0,q=ie.length;W<q;W++){const x=ie[W](ne,C);if(x)return x}return null}}e.or=I,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(ie,ne,C){if(!C||C.length<ne.length)return null;let W;return ie?W=P.startsWithIgnoreCase(C,ne):W=C.indexOf(ne)===0,W?ne.length>0?[{start:0,end:ne.length}]:[]:null}function R(ie,ne){const C=ne.toLowerCase().indexOf(ie.toLowerCase());return C===-1?null:[{start:C,end:C+ie.length}]}e.matchesContiguousSubString=R;function A(ie,ne){return y(ie.toLowerCase(),ne.toLowerCase(),0,0)}e.matchesSubString=A;function y(ie,ne,C,W){if(C===ie.length)return[];if(W===ne.length)return null;if(ie[C]===ne[W]){let q=null;return(q=y(ie,ne,C+1,W+1))?o({start:W,end:W+1},q):null}return y(ie,ne,C,W+1)}function h(ie){return 97<=ie&&ie<=122}function O(ie){return 65<=ie&&ie<=90}e.isUpper=O;function w(ie){return 48<=ie&&ie<=57}function g(ie){return ie===32||ie===9||ie===10||ie===13}const S=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(ie=>S.add(ie.charCodeAt(0)));function p(ie){return g(ie)||S.has(ie)}function l(ie,ne){return ie===ne||p(ie)&&p(ne)}function t(ie){return h(ie)||O(ie)||w(ie)}function o(ie,ne){return ne.length===0?ne=[ie]:ie.end===ne[0].start?ne[0].start=ie.start:ne.unshift(ie),ne}function d(ie,ne){for(let C=ne;C<ie.length;C++){const W=ie.charCodeAt(C);if(O(W)||w(W)||C>0&&!t(ie.charCodeAt(C-1)))return C}return ie.length}function D(ie,ne,C,W){if(C===ie.length)return[];if(W===ne.length)return null;if(ie[C]!==ne[W].toLowerCase())return null;{let q=null,x=W+1;for(q=D(ie,ne,C+1,W+1);!q&&(x=d(ne,x))<ne.length;)q=D(ie,ne,C+1,x),x++;return q===null?null:o({start:W,end:W+1},q)}}function T(ie){let ne=0,C=0,W=0,q=0,x=0;for(let ye=0;ye<ie.length;ye++)x=ie.charCodeAt(ye),O(x)&&ne++,h(x)&&C++,t(x)&&W++,w(x)&&q++;const ae=ne/ie.length,ge=C/ie.length,ee=W/ie.length,we=q/ie.length;return{upperPercent:ae,lowerPercent:ge,alphaPercent:ee,numericPercent:we}}function v(ie){const{upperPercent:ne,lowerPercent:C}=ie;return C===0&&ne>.6}function i(ie){const{upperPercent:ne,lowerPercent:C,alphaPercent:W,numericPercent:q}=ie;return C>.2&&ne<.8&&W>.6&&q<.2}function a(ie){let ne=0,C=0,W=0,q=0;for(let x=0;x<ie.length;x++)W=ie.charCodeAt(x),O(W)&&ne++,h(W)&&C++,g(W)&&q++;return(ne===0||C===0)&&q===0?ie.length<=30:ne<=5}function r(ie,ne){if(!ne||(ne=ne.trim(),ne.length===0)||!a(ie)||ne.length>60)return null;const C=T(ne);if(!i(C)){if(!v(C))return null;ne=ne.toLowerCase()}let W=null,q=0;for(ie=ie.toLowerCase();q<ne.length&&(W=D(ie,ne,0,q))===null;)q=d(ne,q+1);return W}e.matchesCamelCase=r;function s(ie,ne,C=!1){if(!ne||ne.length===0)return null;let W=null,q=0;for(ie=ie.toLowerCase(),ne=ne.toLowerCase();q<ne.length&&(W=E(ie,ne,0,q,C))===null;)q=k(ne,q+1);return W}e.matchesWords=s;function E(ie,ne,C,W,q){if(C===ie.length)return[];if(W===ne.length)return null;if(l(ie.charCodeAt(C),ne.charCodeAt(W))){let x=null,ae=W+1;if(x=E(ie,ne,C+1,W+1,q),!q)for(;!x&&(ae=k(ne,ae))<ne.length;)x=E(ie,ne,C+1,ae,q),ae++;return x?ie.charCodeAt(C)!==ne.charCodeAt(W)?x:o({start:W,end:W+1},x):null}else return null}function k(ie,ne){for(let C=ne;C<ie.length;C++)if(p(ie.charCodeAt(C))||C>0&&p(ie.charCodeAt(C-1)))return C;return ie.length}const c=I(e.matchesPrefix,r,R),u=I(e.matchesPrefix,r,A),m=new n.LRUCache(1e4);function b(ie,ne,C=!1){if(typeof ie!="string"||typeof ne!="string")return null;let W=m.get(ie);W||(W=new RegExp(P.convertSimple2RegExpPattern(ie),"i"),m.set(ie,W));const q=W.exec(ne);return q?[{start:q.index,end:q.index+q[0].length}]:C?u(ie,ne):c(ie,ne)}e.matchesFuzzy=b;function f(ie,ne){const C=me(ie,ie.toLowerCase(),0,ne,ne.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return C?V(C):null}e.matchesFuzzy2=f;function N(ie,ne,C,W,q,x){const ae=Math.min(13,ie.length);for(;C<ae;C++){const ge=me(ie,ne,C,W,q,x,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(ge)return ge}return[0,x]}e.anyScore=N;function V(ie){if(typeof ie>"u")return[];const ne=[],C=ie[1];for(let W=ie.length-1;W>1;W--){const q=ie[W]+C,x=ne[ne.length-1];x&&x.end===q?x.end=q+1:ne.push({start:q,end:q+1})}return ne}e.createMatches=V;const _=128;function G(){const ie=[],ne=[];for(let C=0;C<=_;C++)ne[C]=0;for(let C=0;C<=_;C++)ie.push(ne.slice(0));return ie}function $(ie){const ne=[];for(let C=0;C<=ie;C++)ne[C]=0;return ne}const B=$(2*_),X=$(2*_),U=G(),j=G(),Y=G(),pe=!1;function Ee(ie,ne,C,W,q){function x(ge,ee,we=" "){for(;ge.length<ee;)ge=we+ge;return ge}let ae=` |   |${W.split("").map(ge=>x(ge,3)).join("|")}
`;for(let ge=0;ge<=C;ge++)ge===0?ae+=" |":ae+=`${ne[ge-1]}|`,ae+=ie[ge].slice(0,q+1).map(ee=>x(ee.toString(),3)).join("|")+`
`;return ae}function he(ie,ne,C,W){ie=ie.substr(ne),C=C.substr(W),console.log(Ee(j,ie,ie.length,C,C.length)),console.log(Ee(Y,ie,ie.length,C,C.length)),console.log(Ee(U,ie,ie.length,C,C.length))}function de(ie,ne){if(ne<0||ne>=ie.length)return!1;const C=ie.codePointAt(ne);switch(C){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!P.isEmojiImprecise(C)}}function Re(ie,ne){if(ne<0||ne>=ie.length)return!1;switch(ie.charCodeAt(ne)){case 32:case 9:return!0;default:return!1}}function le(ie,ne,C){return ne[ie]!==C[ie]}function ue(ie,ne,C,W,q,x,ae=!1){for(;ne<C&&q<x;)ie[ne]===W[q]&&(ae&&(B[ne]=q),ne+=1),q+=1;return ne===C}e.isPatternInWord=ue;var H;(function(ie){ie[ie.Diag=1]="Diag",ie[ie.Left=2]="Left",ie[ie.LeftLeft=3]="LeftLeft"})(H||(H={}));var F;(function(ie){ie.Default=[-100,0];function ne(C){return!C||C.length===2&&C[0]===-100&&C[1]===0}ie.isDefault=ne})(F||(e.FuzzyScore=F={}));class Q{constructor(ne,C){this.firstMatchCanBeWeak=ne,this.boostFullMatch=C}}e.FuzzyScoreOptions=Q,Q.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function me(ie,ne,C,W,q,x,ae=Q.default){const ge=ie.length>_?_:ie.length,ee=W.length>_?_:W.length;if(C>=ge||x>=ee||ge-C>ee-x||!ue(ne,C,ge,q,x,ee,!0))return;Ce(ge,ee,C,x,ne,q);let we=1,ye=1,ze=C,je=x;const et=[!1];for(we=1,ze=C;ze<ge;we++,ze++){const Me=B[ze],st=X[ze],Z=ze+1<ge?X[ze+1]:ee;for(ye=Me-x+1,je=Me;je<Z;ye++,je++){let J=Number.MIN_SAFE_INTEGER,Se=!1;je<=st&&(J=De(ie,ne,ze,C,W,q,je,ee,x,U[we-1][ye-1]===0,et));let Ue=0;J!==Number.MAX_SAFE_INTEGER&&(Se=!0,Ue=J+j[we-1][ye-1]);const We=je>Me,Qe=We?j[we][ye-1]+(U[we][ye-1]>0?-5:0):0,Ve=je>Me+1&&U[we][ye-1]>0,it=Ve?j[we][ye-2]+(U[we][ye-2]>0?-5:0):0;if(Ve&&(!We||it>=Qe)&&(!Se||it>=Ue))j[we][ye]=it,Y[we][ye]=3,U[we][ye]=0;else if(We&&(!Se||Qe>=Ue))j[we][ye]=Qe,Y[we][ye]=2,U[we][ye]=0;else if(Se)j[we][ye]=Ue,Y[we][ye]=1,U[we][ye]=U[we-1][ye-1]+1;else throw new Error("not possible")}}if(pe&&he(ie,C,W,x),!et[0]&&!ae.firstMatchCanBeWeak)return;we--,ye--;const Ye=[j[we][ye],x];let Je=0,rt=0;for(;we>=1;){let Me=ye;do{const st=Y[we][Me];if(st===3)Me=Me-2;else if(st===2)Me=Me-1;else break}while(Me>=1);Je>1&&ne[C+we-1]===q[x+ye-1]&&!le(Me+x-1,W,q)&&Je+1>U[we][Me]&&(Me=ye),Me===ye?Je++:Je=1,rt||(rt=Me),we--,ye=Me-1,Ye.push(ye)}ee===ge&&ae.boostFullMatch&&(Ye[0]+=2);const ut=rt-ge;return Ye[0]-=ut,Ye}e.fuzzyScore=me;function Ce(ie,ne,C,W,q,x){let ae=ie-1,ge=ne-1;for(;ae>=C&&ge>=W;)q[ae]===x[ge]&&(X[ae]=ge,ae--),ge--}function De(ie,ne,C,W,q,x,ae,ge,ee,we,ye){if(ne[C]!==x[ae])return Number.MIN_SAFE_INTEGER;let ze=1,je=!1;return ae===C-W?ze=ie[C]===q[ae]?7:5:le(ae,q,x)&&(ae===0||!le(ae-1,q,x))?(ze=ie[C]===q[ae]?7:5,je=!0):de(x,ae)&&(ae===0||!de(x,ae-1))?ze=5:(de(x,ae-1)||Re(x,ae-1))&&(ze=5,je=!0),ze>1&&C===W&&(ye[0]=!0),je||(je=le(ae,q,x)||de(x,ae-1)||Re(x,ae-1)),C===W?ae>ee&&(ze-=je?3:5):we?ze+=je?2:0:ze+=je?0:1,ae+1===ge&&(ze-=je?3:5),ze}function be(ie,ne,C,W,q,x,ae){return oe(ie,ne,C,W,q,x,!0,ae)}e.fuzzyScoreGracefulAggressive=be;function ke(ie,ne,C,W,q,x,ae){return oe(ie,ne,C,W,q,x,!1,ae)}e.fuzzyScoreGraceful=ke;function oe(ie,ne,C,W,q,x,ae,ge){let ee=me(ie,ne,C,W,q,x,ge);if(ee&&!ae)return ee;if(ie.length>=3){const we=Math.min(7,ie.length-1);for(let ye=C+1;ye<we;ye++){const ze=ce(ie,ye);if(ze){const je=me(ze,ze.toLowerCase(),C,W,q,x,ge);je&&(je[0]-=3,(!ee||je[0]>ee[0])&&(ee=je))}}}return ee}function ce(ie,ne){if(ne+1>=ie.length)return;const C=ie[ne],W=ie[ne+1];if(C!==W)return ie.slice(0,ne)+W+C+ie.slice(ne+2)}}),define(Pe[130],Ae([1,0,129,13,39]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const L="$(",R=new RegExp(`\\$\\(${I.ThemeIcon.iconNameExpression}(?:${I.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${R.source}`,"g");function y(o){return o.replace(A,(d,D)=>D?d:`\\${d}`)}e.escapeIcons=y;const h=new RegExp(`\\\\${R.source}`,"g");function O(o){return o.replace(h,d=>`\\${d}`)}e.markdownEscapeEscapedIcons=O;const w=new RegExp(`(\\s)?(\\\\)?${R.source}(\\s)?`,"g");function g(o){return o.indexOf(L)===-1?o:o.replace(w,(d,D,T,v)=>T?d:D||v||"")}e.stripIcons=g;function S(o){return o?o.replace(/\$\((.*?)\)/g,(d,D)=>` ${D} `).trim():""}e.getCodiconAriaLabel=S;const p=new RegExp(`\\$\\(${I.ThemeIcon.iconNameCharacter}+\\)`,"g");function l(o){p.lastIndex=0;let d="";const D=[];let T=0;for(;;){const v=p.lastIndex,i=p.exec(o),a=o.substring(v,i?.index);if(a.length>0){d+=a;for(let r=0;r<a.length;r++)D.push(T)}if(!i)break;T+=i[0].length}return{text:d,iconOffsets:D}}e.parseLabelWithIcons=l;function t(o,d,D=!1){const{text:T,iconOffsets:v}=d;if(!v||v.length===0)return(0,n.matchesFuzzy)(o,T,D);const i=(0,P.ltrim)(T," "),a=T.length-i.length,r=(0,n.matchesFuzzy)(o,i,D);if(r)for(const s of r){const E=v[s.start+a]+a;s.start+=E,s.end+=E}return r}e.matchesFuzzyIconAware=t}),define(Pe[29],Ae([1,0,13]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var P;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(P||(P={})),function(I){const L="error",R="warning",A="warn",y="info",h="ignore";function O(g){return g?n.equalsIgnoreCase(L,g)?I.Error:n.equalsIgnoreCase(R,g)||n.equalsIgnoreCase(A,g)?I.Warning:n.equalsIgnoreCase(y,g)?I.Info:I.Ignore:I.Ignore}I.fromValue=O;function w(g){switch(g){case I.Error:return L;case I.Warning:return R;case I.Info:return y;default:return h}}I.toString=w}(P||(P={})),e.default=P}),define(Pe[48],Ae([1,0,16,13]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class I{constructor(){this.b="",this.c=0}reset(S){return this.b=S,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(S){const p=S.charCodeAt(0),l=this.b.charCodeAt(this.c);return p-l}value(){return this.b[this.c]}}e.StringIterator=I;class L{constructor(S=!0){this.e=S}reset(S){return this.b=S,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let S=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(S)this.c++;else break;else S=!1;return this}cmp(S){return this.e?(0,P.compareSubstring)(S,this.b,0,S.length,this.c,this.d):(0,P.compareSubstringIgnoreCase)(S,this.b,0,S.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=L;class R{constructor(S=!0,p=!0){this.f=S,this.g=p}reset(S){this.d=0,this.e=0,this.b=S,this.c=S.length;for(let p=S.length-1;p>=0;p--,this.c--){const l=this.b.charCodeAt(p);if(!(l===47||this.f&&l===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let S=!0;for(;this.e<this.c;this.e++){const p=this.b.charCodeAt(this.e);if(p===47||this.f&&p===92)if(S)this.d++;else break;else S=!1}return this}cmp(S){return this.g?(0,P.compareSubstring)(S,this.b,0,S.length,this.d,this.e):(0,P.compareSubstringIgnoreCase)(S,this.b,0,S.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=R;var A;(function(g){g[g.Scheme=1]="Scheme",g[g.Authority=2]="Authority",g[g.Path=3]="Path",g[g.Query=4]="Query",g[g.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(S,p){this.f=S,this.g=p,this.d=[],this.e=0}reset(S){return this.c=S,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new R(!1,!this.f(S)),this.b.reset(S.path),this.b.value()&&this.d.push(3)),this.g(S)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(S){if(this.d[this.e]===1)return(0,P.compareIgnoreCase)(S,this.c.scheme);if(this.d[this.e]===2)return(0,P.compareIgnoreCase)(S,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(S);if(this.d[this.e]===4)return(0,P.compare)(S,this.c.query);if(this.d[this.e]===5)return(0,P.compare)(S,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const S=this.right;return this.right=S.left,S.left=this,this.updateHeight(),S.updateHeight(),S}rotateRight(){const S=this.left;return this.left=S.right,S.right=this,this.updateHeight(),S.updateHeight(),S}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(g){g[g.Left=-1]="Left",g[g.Mid=0]="Mid",g[g.Right=1]="Right"})(O||(O={}));class w{static forUris(S=()=>!1,p=()=>!1){return new w(new y(S,p))}static forPaths(S=!1){return new w(new R(void 0,!S))}static forStrings(){return new w(new I)}static forConfigKeys(){return new w(new L)}constructor(S){this.b=S}clear(){this.c=void 0}fill(S,p){if(p){const l=p.slice(0);(0,n.shuffle)(l);for(const t of l)this.set(t,S)}else{const l=S.slice(0);(0,n.shuffle)(l);for(const t of l)this.set(t[0],t[1])}}set(S,p){const l=this.b.reset(S);let t;this.c||(this.c=new h,this.c.segment=l.value());const o=[];for(t=this.c;;){const D=l.cmp(t.segment);if(D>0)t.left||(t.left=new h,t.left.segment=l.value()),o.push([-1,t]),t=t.left;else if(D<0)t.right||(t.right=new h,t.right.segment=l.value()),o.push([1,t]),t=t.right;else if(l.hasNext())l.next(),t.mid||(t.mid=new h,t.mid.segment=l.value()),o.push([0,t]),t=t.mid;else break}const d=t.value;t.value=p,t.key=S;for(let D=o.length-1;D>=0;D--){const T=o[D][1];T.updateHeight();const v=T.balanceFactor();if(v<-1||v>1){const i=o[D][0],a=o[D+1][0];if(i===1&&a===1)o[D][1]=T.rotateLeft();else if(i===-1&&a===-1)o[D][1]=T.rotateRight();else if(i===1&&a===-1)T.right=o[D+1][1]=o[D+1][1].rotateRight(),o[D][1]=T.rotateLeft();else if(i===-1&&a===1)T.left=o[D+1][1]=o[D+1][1].rotateLeft(),o[D][1]=T.rotateRight();else throw new Error;if(D>0)switch(o[D-1][0]){case-1:o[D-1][1].left=o[D][1];break;case 1:o[D-1][1].right=o[D][1];break;case 0:o[D-1][1].mid=o[D][1];break}else this.c=o[0][1]}}return d}get(S){return this.d(S)?.value}d(S){const p=this.b.reset(S);let l=this.c;for(;l;){const t=p.cmp(l.segment);if(t>0)l=l.left;else if(t<0)l=l.right;else if(p.hasNext())p.next(),l=l.mid;else break}return l}has(S){const p=this.d(S);return!(p?.value===void 0&&p?.mid===void 0)}delete(S){return this.e(S,!1)}deleteSuperstr(S){return this.e(S,!0)}e(S,p){const l=this.b.reset(S),t=[];let o=this.c;for(;o;){const d=l.cmp(o.segment);if(d>0)t.push([-1,o]),o=o.left;else if(d<0)t.push([1,o]),o=o.right;else if(l.hasNext())l.next(),t.push([0,o]),o=o.mid;else break}if(o){if(p?(o.left=void 0,o.mid=void 0,o.right=void 0,o.height=1):(o.key=void 0,o.value=void 0),!o.mid&&!o.value)if(o.left&&o.right){const d=this.f(o.right);if(d.key){const{key:D,value:T,segment:v}=d;this.e(d.key,!1),o.key=D,o.value=T,o.segment=v}}else{const d=o.left??o.right;if(t.length>0){const[D,T]=t[t.length-1];switch(D){case-1:T.left=d;break;case 0:T.mid=d;break;case 1:T.right=d;break}}else this.c=d}for(let d=t.length-1;d>=0;d--){const D=t[d][1];D.updateHeight();const T=D.balanceFactor();if(T>1?(D.right.balanceFactor()>=0||(D.right=D.right.rotateRight()),t[d][1]=D.rotateLeft()):T<-1&&(D.left.balanceFactor()<=0||(D.left=D.left.rotateLeft()),t[d][1]=D.rotateRight()),d>0)switch(t[d-1][0]){case-1:t[d-1][1].left=t[d][1];break;case 1:t[d-1][1].right=t[d][1];break;case 0:t[d-1][1].mid=t[d][1];break}else this.c=t[0][1]}}}f(S){for(;S.left;)S=S.left;return S}findSubstr(S){const p=this.b.reset(S);let l=this.c,t;for(;l;){const o=p.cmp(l.segment);if(o>0)l=l.left;else if(o<0)l=l.right;else if(p.hasNext())p.next(),t=l.value||t,l=l.mid;else break}return l&&l.value||t}findSuperstr(S){return this.g(S,!1)}g(S,p){const l=this.b.reset(S);let t=this.c;for(;t;){const o=l.cmp(t.segment);if(o>0)t=t.left;else if(o<0)t=t.right;else if(l.hasNext())l.next(),t=t.mid;else return t.mid?this.h(t.mid):p?t.value:void 0}}hasElementOrSubtree(S){return this.g(S,!0)!==void 0}forEach(S){for(const[p,l]of this)S(l,p)}*[Symbol.iterator](){yield*this.h(this.c)}h(S){const p=[];return this.j(S,p),p[Symbol.iterator]()}j(S,p){S&&(S.left&&this.j(S.left,p),S.value&&p.push([S.key,S.value]),S.mid&&this.j(S.mid,p),S.right&&this.j(S.right,p))}_isBalanced(){const S=p=>{if(!p)return!0;const l=p.balanceFactor();return l<-1||l>1?!1:S(p.left)&&S(p.right)};return S(this.c)}}e.TernarySearchTree=w}),define(Pe[67],Ae([1,0,25,13,2]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(h){return JSON.stringify(h,A)}e.stringify=L;function R(h){let O=JSON.parse(h);return O=y(O),O}e.parse=R;function A(h,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,P.regExpFlags)(O)}:O}function y(h,O=0){if(!h||O>200)return h;if(typeof h=="object"){switch(h.$mid){case 1:return I.URI.revive(h);case 2:return new RegExp(h.source,h.flags);case 16:return new Date(h.source)}if(h instanceof n.VSBuffer||h instanceof Uint8Array)return h;if(Array.isArray(h))for(let w=0;w<h.length;++w)h[w]=y(h[w],O+1);else for(const w in h)Object.hasOwnProperty.call(h,w)&&(h[w]=y(h[w],O+1))}return h}e.revive=y}),define(Pe[15],Ae([1,0,9,20,2]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var L;(function(h){h.inMemory="inmemory",h.vscode="vscode",h.internal="private",h.walkThrough="walkThrough",h.walkThroughSnippet="walkThroughSnippet",h.http="http",h.https="https",h.file="file",h.mailto="mailto",h.untitled="untitled",h.data="data",h.command="command",h.vscodeRemote="vscode-remote",h.vscodeRemoteResource="vscode-remote-resource",h.vscodeUserData="vscode-userdata",h.vscodeCustomEditor="vscode-custom-editor",h.vscodeNotebookCell="vscode-notebook-cell",h.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",h.vscodeNotebookCellOutput="vscode-notebook-cell-output",h.vscodeInteractive="vscode-interactive",h.vscodeInteractiveInput="vscode-interactive-input",h.vscodeSettings="vscode-settings",h.vscodeWorkspaceTrust="vscode-workspace-trust",h.vscodeTerminal="vscode-terminal",h.vscodeInteractiveSesssion="vscode-chat-editor",h.webviewPanel="webview-panel",h.vscodeWebview="vscode-webview",h.extension="extension",h.vscodeFileResource="vscode-file",h.tmp="tmp",h.vsls="vsls",h.vscodeSourceControl="vscode-scm"})(L||(e.Schemas=L={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class R{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${L.vscodeRemoteResource}`}setPreferredWebSchema(O){this.d=O}setDelegate(O){this.e=O}setServerRootPath(O){this.f=`${O}/${L.vscodeRemoteResource}`}set(O,w,g){this.a[O]=w,this.b[O]=g}setConnectionToken(O,w){this.c[O]=w}getPreferredWebSchema(){return this.d}rewrite(O){if(this.e)try{return this.e(O)}catch(t){return n.onUnexpectedError(t),O}const w=O.authority;let g=this.a[w];g&&g.indexOf(":")!==-1&&g.indexOf("[")===-1&&(g=`[${g}]`);const S=this.b[w],p=this.c[w];let l=`path=${encodeURIComponent(O.path)}`;return typeof p=="string"&&(l+=`&${e.connectionTokenQueryName}=${encodeURIComponent(p)}`),I.URI.from({scheme:P.isWeb?this.d:L.vscodeRemoteResource,authority:`${g}:${S}`,path:this.f,query:l})}}e.RemoteAuthorities=new R,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(O){const w=this.b(O,te);return this.uriToBrowserUri(w)}uriToBrowserUri(O){return O.scheme===L.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===L.file&&(P.isNative||P.isWebWorker&&P.globals.origin===`${L.vscodeFileResource}://${A.a}`)?O.with({scheme:L.vscodeFileResource,authority:O.authority||A.a,query:null,fragment:null}):O}asFileUri(O){const w=this.b(O,te);return this.uriToFileUri(w)}uriToFileUri(O){return O.scheme===L.vscodeFileResource?O.with({scheme:L.file,authority:O.authority!==A.a?O.authority:null,query:null,fragment:null}):O}b(O,w){return I.URI.isUri(O)?O:I.URI.parse(w.toUrl(O))}}A.a="vscode-app",e.FileAccess=new A;var y;(function(h){const O=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);h.CoopAndCoep=Object.freeze(O.get("3"));const w="vscode-coi";function g(p){let l;typeof p=="string"?l=new URL(p).searchParams:p instanceof URL?l=p.searchParams:I.URI.isUri(p)&&(l=new URL(p.toString(!0)).searchParams);const t=l?.get(w);if(t)return O.get(t)}h.getHeadersFromQuery=g;function S(p,l,t){if(!globalThis.crossOriginIsolated)return;const o=l&&t?"3":t?"2":"1";p instanceof URLSearchParams?p.set(w,o):p[w]=o}h.addSearchParam=S})(y||(e.COI=y={}))}),define(Pe[22],Ae([1,0,41,15,19,20,13,2]),function(te,e,n,P,I,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(S){return(0,A.uriToFsPath)(S,!0)}e.originalFSPath=y;class h{constructor(p){this.a=p}compare(p,l,t=!1){return p===l?0:(0,R.compare)(this.getComparisonKey(p,t),this.getComparisonKey(l,t))}isEqual(p,l,t=!1){return p===l?!0:!p||!l?!1:this.getComparisonKey(p,t)===this.getComparisonKey(l,t)}getComparisonKey(p,l=!1){return p.with({path:this.a(p)?p.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(p){return this.a(p)}isEqualOrParent(p,l,t=!1){if(p.scheme===l.scheme){if(p.scheme===P.Schemas.file)return n.isEqualOrParent(y(p),y(l),this.a(p))&&p.query===l.query&&(t||p.fragment===l.fragment);if((0,e.isEqualAuthority)(p.authority,l.authority))return n.isEqualOrParent(p.path,l.path,this.a(p),"/")&&p.query===l.query&&(t||p.fragment===l.fragment)}return!1}joinPath(p,...l){return A.URI.joinPath(p,...l)}basenameOrAuthority(p){return(0,e.basename)(p)||p.authority}basename(p){return I.posix.basename(p.path)}extname(p){return I.posix.extname(p.path)}dirname(p){if(p.path.length===0)return p;let l;return p.scheme===P.Schemas.file?l=A.URI.file(I.dirname(y(p))).path:(l=I.posix.dirname(p.path),p.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${p.toString})) resulted in a relative path`),l="/")),p.with({path:l})}normalizePath(p){if(!p.path.length)return p;let l;return p.scheme===P.Schemas.file?l=A.URI.file(I.normalize(y(p))).path:l=I.posix.normalize(p.path),p.with({path:l})}relativePath(p,l){if(p.scheme!==l.scheme||!(0,e.isEqualAuthority)(p.authority,l.authority))return;if(p.scheme===P.Schemas.file){const d=I.relative(y(p),y(l));return L.isWindows?n.toSlashes(d):d}let t=p.path||"/";const o=l.path||"/";if(this.a(p)){let d=0;for(const D=Math.min(t.length,o.length);d<D&&!(t.charCodeAt(d)!==o.charCodeAt(d)&&t.charAt(d).toLowerCase()!==o.charAt(d).toLowerCase());d++);t=o.substr(0,d)+t.substr(d)}return I.posix.relative(t,o)}resolvePath(p,l){if(p.scheme===P.Schemas.file){const t=A.URI.file(I.resolve(y(p),l));return p.with({authority:t.authority,path:t.path})}return l=n.toPosixPath(l),p.with({path:I.posix.resolve(p.path,l)})}isAbsolutePath(p){return!!p.path&&p.path[0]==="/"}isEqualAuthority(p,l){return p===l||p!==void 0&&l!==void 0&&(0,R.equalsIgnoreCase)(p,l)}hasTrailingPathSeparator(p,l=I.sep){if(p.scheme===P.Schemas.file){const t=y(p);return t.length>n.getRoot(t).length&&t[t.length-1]===l}else{const t=p.path;return t.length>1&&t.charCodeAt(t.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(p.fsPath)}}removeTrailingPathSeparator(p,l=I.sep){return(0,e.hasTrailingPathSeparator)(p,l)?p.with({path:p.path.substr(0,p.path.length-1)}):p}addTrailingPathSeparator(p,l=I.sep){let t=!1;if(p.scheme===P.Schemas.file){const o=y(p);t=o!==void 0&&o.length===n.getRoot(o).length&&o[o.length-1]===l}else{l="/";const o=p.path;t=o.length===1&&o.charCodeAt(o.length-1)===47}return!t&&!(0,e.hasTrailingPathSeparator)(p,l)?p.with({path:p.path+"/"}):p}}e.ExtUri=h,e.extUri=new h(()=>!1),e.extUriBiasedIgnorePathCase=new h(S=>S.scheme===P.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new h(S=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(S,p){const l=[];for(let t=0;t<S.length;t++){const o=p(S[t]);S.some((d,D)=>D===t?!1:(0,e.isEqualOrParent)(o,p(d)))||l.push(S[t])}return l}e.distinctParents=O;var w;(function(S){S.META_DATA_LABEL="label",S.META_DATA_DESCRIPTION="description",S.META_DATA_SIZE="size",S.META_DATA_MIME="mime";function p(l){const t=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(D=>{const[T,v]=D.split(":");T&&v&&t.set(T,v)});const d=l.path.substring(0,l.path.indexOf(";"));return d&&t.set(S.META_DATA_MIME,d),t}S.parseMetaData=p})(w||(e.DataUri=w={}));function g(S,p,l){if(p){let t=S.path;return t&&t[0]!==I.posix.sep&&(t=I.posix.sep+t),S.with({scheme:l,authority:p,path:t})}return S.with({scheme:l})}e.toLocalResource=g}),define(Pe[17],Ae([1,0,21,9,5,6,22,20,118]),function(te,e,n,P,I,L,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function h(ue){return!!ue&&typeof ue.then=="function"}e.isThenable=h;function O(ue){const H=new n.CancellationTokenSource,F=ue(H.token),Q=new Promise((me,Ce)=>{const De=H.token.onCancellationRequested(()=>{De.dispose(),H.dispose(),Ce(new P.CancellationError)});Promise.resolve(F).then(be=>{De.dispose(),H.dispose(),me(be)},be=>{De.dispose(),H.dispose(),Ce(be)})});return new class{cancel(){H.cancel()}then(me,Ce){return Q.then(me,Ce)}catch(me){return this.then(void 0,me)}finally(me){return Q.finally(me)}}}e.createCancelablePromise=O;function w(ue,H,F){return new Promise((Q,me)=>{const Ce=H.onCancellationRequested(()=>{Ce.dispose(),Q(F)});ue.then(Q,me).finally(()=>Ce.dispose())})}e.raceCancellation=w;function g(ue,H){return new Promise((F,Q)=>{const me=H.onCancellationRequested(()=>{me.dispose(),Q(new P.CancellationError)});ue.then(F,Q).finally(()=>me.dispose())})}e.raceCancellationError=g;async function S(ue){let H=-1;const F=ue.map((Q,me)=>Q.then(Ce=>(H=me,Ce)));try{return await Promise.race(F)}finally{ue.forEach((Q,me)=>{me!==H&&Q.cancel()})}}e.raceCancellablePromises=S;function p(ue,H,F){let Q;const me=setTimeout(()=>{Q?.(void 0),F?.()},H);return Promise.race([ue.finally(()=>clearTimeout(me)),new Promise(Ce=>Q=Ce)])}e.raceTimeout=p;function l(ue){return new Promise((H,F)=>{const Q=ue();h(Q)?Q.then(H,F):H(Q)})}e.asPromise=l;class t{constructor(){this.a=null,this.b=null,this.d=null}queue(H){if(this.a){if(this.d=H,!this.b){const F=()=>{this.b=null;const Q=this.queue(this.d);return this.d=null,Q};this.b=new Promise(Q=>{this.a.then(F,F).then(Q)})}return new Promise((F,Q)=>{this.b.then(F,Q)})}return this.a=H(),new Promise((F,Q)=>{this.a.then(me=>{this.a=null,F(me)},me=>{this.a=null,Q(me)})})}}e.Throttler=t;class o{constructor(){this.a=Promise.resolve(null)}queue(H){return this.a=this.a.then(()=>H(),()=>H())}}e.Sequencer=o;class d{constructor(){this.a=new Map}queue(H,F){const me=(this.a.get(H)??Promise.resolve()).catch(()=>{}).then(F).finally(()=>{this.a.get(H)===me&&this.a.delete(H)});return this.a.set(H,me),me}}e.SequencerByKey=d;const D=(ue,H)=>{let F=!0;const Q=setTimeout(()=>{F=!1,H()},ue);return{isTriggered:()=>F,dispose:()=>{clearTimeout(Q),F=!1}}},T=ue=>{let H=!0;return queueMicrotask(()=>{H&&(H=!1,ue())}),{isTriggered:()=>H,dispose:()=>{H=!1}}};class v{constructor(H){this.defaultDelay=H,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(H,F=this.defaultDelay){this.g=H,this.h(),this.b||(this.b=new Promise((me,Ce)=>{this.d=me,this.f=Ce}).then(()=>{if(this.b=null,this.d=null,this.g){const me=this.g;return this.g=null,me()}}));const Q=()=>{this.a=null,this.d?.(null)};return this.a=F===y.MicrotaskDelay?T(Q):D(F,Q),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new P.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=v;class i{constructor(H){this.a=new v(H),this.b=new t}trigger(H,F){return this.a.trigger(()=>this.b.queue(H),F)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=i;class a{constructor(){this.a=!1,this.b=new Promise((H,F)=>{this.d=H})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=a;class r extends a{constructor(H){super(),this.f=setTimeout(()=>this.open(),H)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function s(ue,H){return H?new Promise((F,Q)=>{const me=setTimeout(()=>{Ce.dispose(),F()},ue),Ce=H.onCancellationRequested(()=>{clearTimeout(me),Ce.dispose(),Q(new P.CancellationError)})}):O(F=>s(ue,F))}e.timeout=s;function E(ue,H=0){const F=setTimeout(ue,H);return(0,L.toDisposable)(()=>clearTimeout(F))}e.disposableTimeout=E;function k(ue){const H=[];let F=0;const Q=ue.length;function me(){return F<Q?ue[F++]():null}function Ce(De){De!=null&&H.push(De);const be=me();return be?be.then(Ce):Promise.resolve(H)}return Promise.resolve(null).then(Ce)}e.sequence=k;function c(ue,H=Q=>!!Q,F=null){let Q=0;const me=ue.length,Ce=()=>{if(Q>=me)return Promise.resolve(F);const De=ue[Q++];return Promise.resolve(De()).then(ke=>H(ke)?Promise.resolve(ke):Ce())};return Ce()}e.first=c;function u(ue,H=Q=>!!Q,F=null){if(ue.length===0)return Promise.resolve(F);let Q=ue.length;const me=()=>{Q=-1;for(const Ce of ue)Ce.cancel?.()};return new Promise((Ce,De)=>{for(const be of ue)be.then(ke=>{--Q>=0&&H(ke)?(me(),Ce(ke)):Q===0&&Ce(F)}).catch(ke=>{--Q>=0&&(me(),De(ke))})})}e.firstParallel=u;class m{constructor(H){this.a=0,this.d=H,this.f=[],this.b=0,this.g=new I.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(H){return this.a++,new Promise((F,Q)=>{this.f.push({factory:H,c:F,e:Q}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const H=this.f.shift();this.b++;const F=H.factory();F.then(H.c,H.e),F.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=m;class b extends m{constructor(){super(1)}}e.Queue=b;class f{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const H=new pe;return this.b.add(H),H.p}d(){for(const[,H]of this.a)if(H.size>0)return!1;return!0}queueFor(H,F=R.extUri){const Q=F.getComparisonKey(H);let me=this.a.get(Q);return me||(me=new b,I.Event.once(me.onDrained)(()=>{me?.dispose(),this.a.delete(Q),this.f()}),this.a.set(Q,me)),me}f(){this.d()&&this.g()}g(){for(const H of this.b)H.complete();this.b.clear()}dispose(){for(const[,H]of this.a)H.dispose();this.a.clear(),this.g()}}e.ResourceQueue=f;class N{constructor(H,F){this.a=-1,typeof H=="function"&&typeof F=="number"&&this.setIfNotSet(H,F)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(H,F){this.cancel(),this.a=setTimeout(()=>{this.a=-1,H()},F)}setIfNotSet(H,F){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,H()},F))}}e.TimeoutTimer=N;class V{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(H,F){this.cancel(),this.a=setInterval(()=>{H()},F)}}e.IntervalTimer=V;class _{constructor(H,F){this.b=-1,this.a=H,this.d=F,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(H=this.d){this.cancel(),this.b=setTimeout(this.f,H)}get delay(){return this.d}set delay(H){this.d=H}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=_;class G{constructor(H,F){F%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${F}ms is not a multiple of 1000ms.`),this.a=H,this.b=F,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(H=this.b){H%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${H}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(H/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=G;class $ extends _{constructor(H,F){super(H,F),this.j=[]}work(H){this.j.push(H),this.isScheduled()||this.schedule()}h(){const H=this.j;this.j=[],this.a?.(H)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=$;class B extends L.Disposable{constructor(H,F){super(),this.g=H,this.h=F,this.a=[],this.b=this.B(new L.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(H){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+H.length>this.g.maxBufferedWork)return!1}else if(this.pending+H.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const F of H)this.a.push(F);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new _(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=B,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=ue=>{(0,A.setTimeout0)(()=>{if(H)return;const F=Date.now()+15;ue(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,F-Date.now())}}))});let H=!1;return{dispose(){H||(H=!0)}}}:e.runWhenIdle=(ue,H)=>{const F=requestIdleCallback(ue,typeof H=="number"?{timeout:H}:void 0);let Q=!1;return{dispose(){Q||(Q=!0,cancelIdleCallback(F))}}}}();class X{constructor(H){this.d=!1,this.a=()=>{try{this.f=H()}catch(F){this.g=F}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=X;async function U(ue,H,F){let Q;for(let me=0;me<F;me++)try{return await ue()}catch(Ce){Q=Ce,await s(H)}throw Q}e.retry=U;class j{hasPending(H){return this.a?typeof H=="number"?this.a.taskId===H:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(H,F,Q){return this.a={taskId:H,cancel:()=>Q?.(),promise:F},F.then(()=>this.d(H),()=>this.d(H)),F}d(H){this.a&&H===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const H=this.b;this.b=void 0,H.run().then(H.promiseResolve,H.promiseReject)}}setNext(H){if(this.b)this.b.run=H;else{let F,Q;const me=new Promise((Ce,De)=>{F=Ce,Q=De});this.b={run:H,promise:me,promiseResolve:F,promiseReject:Q}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=j;class Y{constructor(H,F=()=>Date.now()){this.d=H,this.f=F,this.a=0,this.b=0}increment(){const H=this.f();return H-this.a>this.d&&(this.a=H,this.b=0),this.b++,this.b}}e.IntervalCounter=Y;class pe{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((H,F)=>{this.a=H,this.b=F})}complete(H){return new Promise(F=>{this.a(H),this.f=!0,F()})}error(H){return new Promise(F=>{this.b(H),this.d=!0,F()})}cancel(){new Promise(H=>{this.b(new P.CancellationError),this.d=!0,H()})}}e.DeferredPromise=pe;var Ee;(function(ue){async function H(Q){let me;const Ce=await Promise.all(Q.map(De=>De.then(be=>be,be=>{me||(me=be)})));if(typeof me<"u")throw me;return Ce}ue.settled=H;function F(Q){return new Promise(async(me,Ce)=>{try{await Q(me,Ce)}catch(De){Ce(De)}})}ue.withAsyncBody=F})(Ee||(e.Promises=Ee={}));var he;(function(ue){ue[ue.Initial=0]="Initial",ue[ue.DoneOK=1]="DoneOK",ue[ue.DoneError=2]="DoneError"})(he||(he={}));class de{static fromArray(H){return new de(F=>{F.emitMany(H)})}static fromPromise(H){return new de(async F=>{F.emitMany(await H)})}static fromPromises(H){return new de(async F=>{await Promise.all(H.map(async Q=>F.emitOne(await Q)))})}static merge(H){return new de(async F=>{await Promise.all(H.map(async Q=>{for await(const me of Q)F.emitOne(me)}))})}constructor(H){this.a=0,this.b=[],this.d=null,this.f=new I.Emitter,queueMicrotask(async()=>{const F={emitOne:Q=>this.g(Q),emitMany:Q=>this.h(Q),reject:Q=>this.k(Q)};try{await Promise.resolve(H(F)),this.j()}catch(Q){this.k(Q)}finally{F.emitOne=void 0,F.emitMany=void 0,F.reject=void 0}})}[Symbol.asyncIterator](){let H=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(H<this.b.length)return{done:!1,value:this.b[H++]};if(this.a===1)return{done:!0,value:void 0};await I.Event.toPromise(this.f.event)}while(!0)}}}static map(H,F){return new de(async Q=>{for await(const me of H)Q.emitOne(F(me))})}map(H){return de.map(this,H)}static filter(H,F){return new de(async Q=>{for await(const me of H)F(me)&&Q.emitOne(me)})}filter(H){return de.filter(this,H)}static coalesce(H){return de.filter(H,F=>!!F)}coalesce(){return de.coalesce(this)}static async toPromise(H){const F=[];for await(const Q of H)F.push(Q);return F}toPromise(){return de.toPromise(this)}g(H){this.a===0&&(this.b.push(H),this.f.fire())}h(H){this.a===0&&(this.b=this.b.concat(H),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(H){this.a===0&&(this.a=2,this.d=H,this.f.fire())}}e.AsyncIterableObject=de,de.EMPTY=de.fromArray([]);class Re extends de{constructor(H,F){super(F),this.l=H}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=Re;function le(ue){const H=new n.CancellationTokenSource,F=ue(H.token);return new Re(H,async Q=>{const me=H.token.onCancellationRequested(()=>{me.dispose(),H.dispose(),Q.reject(new P.CancellationError)});try{for await(const Ce of F){if(H.token.isCancellationRequested)return;Q.emitOne(Ce)}me.dispose(),H.dispose()}catch(Ce){me.dispose(),H.dispose(),Q.reject(Ce)}})}e.createCancelableAsyncIterable=le}),define(Pe[36],Ae([1,0,16,17,41,28,19,20,13]),function(te,e,n,P,I,L,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function h(){return Object.create(null)}e.getEmptyExpression=h,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",w="[^/\\\\]",g=/\//g;function S(Y,pe){switch(Y){case 0:return"";case 1:return`${w}*?`;default:return`(?:${O}|${w}+${O}${pe?`|${O}${w}+`:""})*?`}}function p(Y,pe){if(!Y)return[];const Ee=[];let he=!1,de=!1,Re="";for(const le of Y){switch(le){case pe:if(!he&&!de){Ee.push(Re),Re="";continue}break;case"{":he=!0;break;case"}":he=!1;break;case"[":de=!0;break;case"]":de=!1;break}Re+=le}return Re&&Ee.push(Re),Ee}e.splitGlobAware=p;function l(Y){if(!Y)return"";let pe="";const Ee=p(Y,e.GLOB_SPLIT);if(Ee.every(he=>he===e.GLOBSTAR))pe=".*";else{let he=!1;Ee.forEach((de,Re)=>{if(de===e.GLOBSTAR){if(he)return;pe+=S(2,Re===Ee.length-1)}else{let le=!1,ue="",H=!1,F="";for(const Q of de){if(Q!=="}"&&le){ue+=Q;continue}if(H&&(Q!=="]"||!F)){let me;Q==="-"?me=Q:(Q==="^"||Q==="!")&&!F?me="^":Q===e.GLOB_SPLIT?me="":me=(0,y.escapeRegExpCharacters)(Q),F+=me;continue}switch(Q){case"{":le=!0;continue;case"[":H=!0;continue;case"}":{const Ce=`(?:${p(ue,",").map(De=>l(De)).join("|")})`;pe+=Ce,le=!1,ue="";break}case"]":{pe+="["+F+"]",H=!1,F="";break}case"?":pe+=w;continue;case"*":pe+=S(1);continue;default:pe+=(0,y.escapeRegExpCharacters)(Q)}}Re<Ee.length-1&&(Ee[Re+1]!==e.GLOBSTAR||Re+2<Ee.length)&&(pe+=O)}he=de===e.GLOBSTAR})}return pe}const t=/^\*\*\/\*\.[\w\.-]+$/,o=/^\*\*\/([\w\.-]+)\/?$/,d=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,D=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,T=/^\*\*((\/[\w\.-]+)+)\/?$/,v=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new L.LRUCache(1e4),a=function(){return!1},r=function(){return null};function s(Y,pe){if(!Y)return r;let Ee;typeof Y!="string"?Ee=Y.pattern:Ee=Y,Ee=Ee.trim();const he=`${Ee}_${!!pe.trimForExclusions}`;let de=i.get(he);if(de)return E(de,Y);let Re;return t.test(Ee)?de=c(Ee.substr(4),Ee):(Re=o.exec(k(Ee,pe)))?de=u(Re[1],Ee):(pe.trimForExclusions?D:d).test(Ee)?de=m(Ee,pe):(Re=T.exec(k(Ee,pe)))?de=b(Re[1].substr(1),Ee,!0):(Re=v.exec(k(Ee,pe)))?de=b(Re[1],Ee,!1):de=f(Ee),i.set(he,de),E(de,Y)}function E(Y,pe){if(typeof pe=="string")return Y;const Ee=function(he,de){return(0,I.isEqualOrParent)(he,pe.base,!A.isLinux)?Y((0,y.ltrim)(he.substr(pe.base.length),R.sep),de):null};return Ee.allBasenames=Y.allBasenames,Ee.allPaths=Y.allPaths,Ee.basenames=Y.basenames,Ee.patterns=Y.patterns,Ee}function k(Y,pe){return pe.trimForExclusions&&Y.endsWith("/**")?Y.substr(0,Y.length-2):Y}function c(Y,pe){return function(Ee,he){return typeof Ee=="string"&&Ee.endsWith(Y)?pe:null}}function u(Y,pe){const Ee=`/${Y}`,he=`\\${Y}`,de=function(le,ue){return typeof le!="string"?null:ue?ue===Y?pe:null:le===Y||le.endsWith(Ee)||le.endsWith(he)?pe:null},Re=[Y];return de.basenames=Re,de.patterns=[pe],de.allBasenames=Re,de}function m(Y,pe){const Ee=U(Y.slice(1,-1).split(",").map(ue=>s(ue,pe)).filter(ue=>ue!==r),Y),he=Ee.length;if(!he)return r;if(he===1)return Ee[0];const de=function(ue,H){for(let F=0,Q=Ee.length;F<Q;F++)if(Ee[F](ue,H))return Y;return null},Re=Ee.find(ue=>!!ue.allBasenames);Re&&(de.allBasenames=Re.allBasenames);const le=Ee.reduce((ue,H)=>H.allPaths?ue.concat(H.allPaths):ue,[]);return le.length&&(de.allPaths=le),de}function b(Y,pe,Ee){const he=R.sep===R.posix.sep,de=he?Y:Y.replace(g,R.sep),Re=R.sep+de,le=R.posix.sep+Y;let ue;return Ee?ue=function(H,F){return typeof H=="string"&&(H===de||H.endsWith(Re)||!he&&(H===Y||H.endsWith(le)))?pe:null}:ue=function(H,F){return typeof H=="string"&&(H===de||!he&&H===Y)?pe:null},ue.allPaths=[(Ee?"*/":"./")+Y],ue}function f(Y){try{const pe=new RegExp(`^${l(Y)}$`);return function(Ee){return pe.lastIndex=0,typeof Ee=="string"&&pe.test(Ee)?Y:null}}catch{return r}}function N(Y,pe,Ee){return!Y||typeof pe!="string"?!1:V(Y)(pe,void 0,Ee)}e.match=N;function V(Y,pe={}){if(!Y)return a;if(typeof Y=="string"||_(Y)){const Ee=s(Y,pe);if(Ee===r)return a;const he=function(de,Re){return!!Ee(de,Re)};return Ee.allBasenames&&(he.allBasenames=Ee.allBasenames),Ee.allPaths&&(he.allPaths=Ee.allPaths),he}return B(Y,pe)}e.parse=V;function _(Y){const pe=Y;return pe?typeof pe.base=="string"&&typeof pe.pattern=="string":!1}e.isRelativePattern=_;function G(Y){return Y.allBasenames||[]}e.getBasenameTerms=G;function $(Y){return Y.allPaths||[]}e.getPathTerms=$;function B(Y,pe){const Ee=U(Object.getOwnPropertyNames(Y).map(ue=>X(ue,Y[ue],pe)).filter(ue=>ue!==r)),he=Ee.length;if(!he)return r;if(!Ee.some(ue=>!!ue.requiresSiblings)){if(he===1)return Ee[0];const ue=function(Q,me){let Ce;for(let De=0,be=Ee.length;De<be;De++){const ke=Ee[De](Q,me);if(typeof ke=="string")return ke;(0,P.isThenable)(ke)&&(Ce||(Ce=[]),Ce.push(ke))}return Ce?(async()=>{for(const De of Ce){const be=await De;if(typeof be=="string")return be}return null})():null},H=Ee.find(Q=>!!Q.allBasenames);H&&(ue.allBasenames=H.allBasenames);const F=Ee.reduce((Q,me)=>me.allPaths?Q.concat(me.allPaths):Q,[]);return F.length&&(ue.allPaths=F),ue}const de=function(ue,H,F){let Q,me;for(let Ce=0,De=Ee.length;Ce<De;Ce++){const be=Ee[Ce];be.requiresSiblings&&F&&(H||(H=(0,R.basename)(ue)),Q||(Q=H.substr(0,H.length-(0,R.extname)(ue).length)));const ke=be(ue,H,Q,F);if(typeof ke=="string")return ke;(0,P.isThenable)(ke)&&(me||(me=[]),me.push(ke))}return me?(async()=>{for(const Ce of me){const De=await Ce;if(typeof De=="string")return De}return null})():null},Re=Ee.find(ue=>!!ue.allBasenames);Re&&(de.allBasenames=Re.allBasenames);const le=Ee.reduce((ue,H)=>H.allPaths?ue.concat(H.allPaths):ue,[]);return le.length&&(de.allPaths=le),de}function X(Y,pe,Ee){if(pe===!1)return r;const he=s(Y,Ee);if(he===r)return r;if(typeof pe=="boolean")return he;if(pe){const de=pe.when;if(typeof de=="string"){const Re=(le,ue,H,F)=>{if(!F||!he(le,ue))return null;const Q=de.replace("$(basename)",()=>H),me=F(Q);return(0,P.isThenable)(me)?me.then(Ce=>Ce?Y:null):me?Y:null};return Re.requiresSiblings=!0,Re}}return he}function U(Y,pe){const Ee=Y.filter(ue=>!!ue.basenames);if(Ee.length<2)return Y;const he=Ee.reduce((ue,H)=>{const F=H.basenames;return F?ue.concat(F):ue},[]);let de;if(pe){de=[];for(let ue=0,H=he.length;ue<H;ue++)de.push(pe)}else de=Ee.reduce((ue,H)=>{const F=H.patterns;return F?ue.concat(F):ue},[]);const Re=function(ue,H){if(typeof ue!="string")return null;if(!H){let Q;for(Q=ue.length;Q>0;Q--){const me=ue.charCodeAt(Q-1);if(me===47||me===92)break}H=ue.substr(Q)}const F=he.indexOf(H);return F!==-1?de[F]:null};Re.basenames=he,Re.patterns=de,Re.allBasenames=he;const le=Y.filter(ue=>!ue.basenames);return le.push(Re),le}function j(Y,pe){return(0,n.equals)(Y,pe,(Ee,he)=>typeof Ee=="string"&&typeof he=="string"?Ee===he:typeof Ee!="string"&&typeof he!="string"?Ee.base===he.base&&Ee.pattern===he.pattern:!1)}e.patternsEquals=j}),define(Pe[88],Ae([1,0,9,130,22,13,2]),function(te,e,n,P,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(t){t[t.Paragraph=0]="Paragraph",t[t.Break=1]="Break"})(A||(e.MarkdownStringTextNewlineStyle=A={}));class y{constructor(o="",d=!1){if(this.value=o,typeof this.value!="string")throw(0,n.illegalArgument)("value");typeof d=="boolean"?(this.isTrusted=d,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=d.isTrusted??void 0,this.supportThemeIcons=d.supportThemeIcons??!1,this.supportHtml=d.supportHtml??!1)}appendText(o,d=0){return this.value+=g(this.supportThemeIcons?(0,P.escapeIcons)(o):o).replace(/([ \t]+)/g,(D,T)=>"&nbsp;".repeat(T.length)).replace(/\>/gm,"\\>").replace(/\n/g,d===1?`\\
`:`

`),this}appendMarkdown(o){return this.value+=o,this}appendCodeblock(o,d){return this.value+="\n```",this.value+=o,this.value+=`
`,this.value+=d,this.value+="\n```\n",this}appendLink(o,d,D){return this.value+="[",this.value+=this.c(d,"]"),this.value+="](",this.value+=this.c(String(o),")"),D&&(this.value+=` "${this.c(this.c(D,'"'),")")}"`),this.value+=")",this}c(o,d){const D=new RegExp((0,L.escapeRegExpCharacters)(d),"g");return o.replace(D,(T,v)=>o.charAt(v-1)!=="\\"?`\\${T}`:T)}}e.MarkdownString=y;function h(t){return O(t)?!t.value:Array.isArray(t)?t.every(h):!0}e.isEmptyMarkdownString=h;function O(t){return t instanceof y?!0:t&&typeof t=="object"?typeof t.value=="string"&&(typeof t.isTrusted=="boolean"||typeof t.isTrusted=="object"||t.isTrusted===void 0)&&(typeof t.supportThemeIcons=="boolean"||t.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function w(t,o){return t===o?!0:!t||!o?!1:t.value===o.value&&t.isTrusted===o.isTrusted&&t.supportThemeIcons===o.supportThemeIcons&&t.supportHtml===o.supportHtml&&(t.baseUri===o.baseUri||!!t.baseUri&&!!o.baseUri&&(0,I.isEqual)(R.URI.from(t.baseUri),R.URI.from(o.baseUri)))}e.markdownStringEqual=w;function g(t){return t.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=g;function S(t){return t.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=S;function p(t){return t&&t.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=p;function l(t){const o=[],d=t.split("|").map(T=>T.trim());t=d[0];const D=d[1];if(D){const T=/height=(\d+)/.exec(D),v=/width=(\d+)/.exec(D),i=T?T[1]:"",a=v?v[1]:"",r=isFinite(parseInt(a)),s=isFinite(parseInt(i));r&&o.push(`width="${a}"`),s&&o.push(`height="${i}"`)}return{href:t,dimensions:o}}e.parseHrefAndDimensions=l}),define(Pe[89],Ae([1,0,16,41,19,20,22,13]),function(te,e,n,P,I,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(r,s){const{os:E,tildify:k,relative:c}=s;if(c){const b=h(r,c,E);if(typeof b=="string")return b}let u=r.fsPath;if(E===1&&!L.isWindows?u=u.replace(/\//g,"\\"):E!==1&&L.isWindows&&(u=u.replace(/\\/g,"/")),E!==1&&k?.userHome){const b=k.userHome.fsPath;let f;r.scheme!==k.userHome.scheme&&r.path.startsWith(I.posix.sep)?f=k.userHome.with({path:r.path}).fsPath:f=r.fsPath,u=g(f,b,E)}return(E===1?I.win32:I.posix).normalize(O(u,E===1))}e.getPathLabel=y;function h(r,s,E){const k=E===1?I.win32:I.posix,c=E===3?R.extUri:R.extUriIgnorePathCase,u=s.getWorkspace(),m=(0,n.firstOrDefault)(u.folders);if(!m)return;r.scheme!==m.uri.scheme&&r.path.startsWith(I.posix.sep)&&(r=m.uri.with({path:r.path}));const b=s.getWorkspaceFolder(r);if(!b)return;let f;if(c.isEqual(b.uri,r)?f="":f=c.relativePath(b.uri,r)??"",f&&(f=k.normalize(f)),u.folders.length>1&&!s.noPrefix){const N=b.name?b.name:c.basenameOrAuthority(b.uri);f=f?`${N} \u2022 ${f}`:N}return f}function O(r,s=L.isWindows){return(0,P.hasDriveLetter)(r,s)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=O;let w=Object.create(null);function g(r,s,E=L.OS){if(E===1||!r||!s)return r;let k=w.original===s?w.normalized:void 0;k||(k=s,L.isWindows&&(k=(0,P.toSlashes)(k)),k=`${(0,A.rtrim)(k,I.posix.sep)}${I.posix.sep}`,w={original:s,normalized:k});let c=r;return L.isWindows&&(c=(0,P.toSlashes)(c)),(E===3?c.startsWith(k):(0,A.startsWithIgnoreCase)(c,k))?`~/${c.substr(k.length)}`:r}e.tildify=g;function S(r,s){return r.replace(/^~($|\/|\\)/,`${s}$1`)}e.untildify=S;const p="\u2026",l="\\\\",t="~";function o(r,s=I.sep){const E=new Array(r.length);let k=!1;for(let c=0;c<r.length;c++){const u=r[c];if(u===""){E[c]=`.${s}`;continue}if(!u){E[c]=u;continue}k=!0;let m="",b=u;b.indexOf(l)===0?(m=b.substr(0,b.indexOf(l)+l.length),b=b.substr(b.indexOf(l)+l.length)):b.indexOf(s)===0?(m=b.substr(0,b.indexOf(s)+s.length),b=b.substr(b.indexOf(s)+s.length)):b.indexOf(t)===0&&(m=b.substr(0,b.indexOf(t)+t.length),b=b.substr(b.indexOf(t)+t.length));const f=b.split(s);for(let N=1;k&&N<=f.length;N++)for(let V=f.length-N;k&&V>=0;V--){k=!1;let _=f.slice(V,V+N).join(s);for(let G=0;!k&&G<r.length;G++)if(G!==c&&r[G]&&r[G].indexOf(_)>-1){const $=V+N===f.length,B=V>0&&r[G].indexOf(s)>-1?s+_:_,X=r[G].endsWith(B);k=!$||X}if(!k){let G="";(f[0].endsWith(":")||m!=="")&&(V===1&&(V=0,N++,_=f[0]+s+_),V>0&&(G=f[0]+s),G=m+G),V>0&&(G=G+p+s),G=G+_,V+N<f.length&&(G=G+s+p),E[c]=G}}k&&(E[c]=u)}return E}e.shorten=o;var d;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(d||(d={}));function D(r,s=Object.create(null)){const E=[];let k=!1,c="";for(const u of r)if(u==="$"||k&&u==="{")c&&E.push({value:c,type:d.TEXT}),c="",k=!0;else if(u==="}"&&k){const m=s[c];if(typeof m=="string")m.length&&E.push({value:m,type:d.VARIABLE});else if(m){const b=E[E.length-1];(!b||b.type!==d.SEPARATOR)&&E.push({value:m.label,type:d.SEPARATOR})}c="",k=!1}else c+=u;return c&&!k&&E.push({value:c,type:d.TEXT}),E.filter((u,m)=>{if(u.type===d.SEPARATOR){const b=E[m-1],f=E[m+1];return[b,f].every(N=>N&&(N.type===d.VARIABLE||N.type===d.TEXT)&&N.value.length>0)}return!0}).map(u=>u.value).join("")}e.template=D;function T(r,s){return L.isMacintosh||s?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):r.replace(/&&|&/g,E=>E==="&"?"&&":"&")}e.mnemonicMenuLabel=T;function v(r,s){return L.isMacintosh||s?r.replace(/\(&&\w\)|&&/g,""):L.isWindows?r.replace(/&&|&/g,E=>E==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=v;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function a(r){const s=r.indexOf("/")!==-1?I.posix:I.win32,E=s.basename(r),k=s.dirname(r);return E.length?{name:E,parentPath:k}:{name:k,parentPath:""}}e.splitName=a}),define(Pe[131],Ae([1,0,25,2]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function I(w){return w.toJSON()}class L{constructor(g){this.a=g}transformIncoming(g){const S=this.a.transformIncoming(g);return S===g?g:I(P.URI.from(S))}transformOutgoing(g){const S=this.a.transformOutgoing(g);return S===g?g:I(P.URI.from(S))}transformOutgoingURI(g){const S=this.a.transformOutgoing(g);return S===g?g:P.URI.from(S)}transformOutgoingScheme(g){return this.a.transformOutgoingScheme(g)}}e.URITransformer=L,e.DefaultURITransformer=new class{transformIncoming(w){return w}transformOutgoing(w){return w}transformOutgoingURI(w){return w}transformOutgoingScheme(w){return w}};function R(w,g,S){if(!w||S>200)return null;if(typeof w=="object"){if(w instanceof P.URI)return g.transformOutgoing(w);for(const p in w)if(Object.hasOwnProperty.call(w,p)){const l=R(w[p],g,S+1);l!==null&&(w[p]=l)}}return null}function A(w,g){const S=R(w,g,0);return S===null?w:S}e.transformOutgoingURIs=A;function y(w,g,S,p){if(!w||p>200)return null;if(typeof w=="object"){if(w.$mid===1)return S?P.URI.revive(g.transformIncoming(w)):g.transformIncoming(w);if(w instanceof n.VSBuffer)return null;for(const l in w)if(Object.hasOwnProperty.call(w,l)){const t=y(w[l],g,S,p+1);t!==null&&(w[l]=t)}}return null}function h(w,g){const S=y(w,g,!1,0);return S===null?w:S}e.transformIncomingURIs=h;function O(w,g){const S=y(w,g,!0,0);return S===null?w:S}e.transformAndReviveIncomingURIs=O}),define(Pe[132],Ae([1,0,36,19]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function I(L,R,A,y,h,O){if(Array.isArray(L)){let w=0;for(const g of L){const S=I(g,R,A,y,h,O);if(S===10)return S;S>w&&(w=S)}return w}else{if(typeof L=="string")return y?L==="*"?5:L===A?10:0:0;if(L){const{language:w,pattern:g,scheme:S,hasAccessToAllModels:p,notebookType:l}=L;if(!y&&!p)return 0;l&&h&&(R=h);let t=0;if(S)if(S===R.scheme)t=10;else if(S==="*")t=5;else return 0;if(w)if(w===A)t=10;else if(w==="*")t=Math.max(t,5);else return 0;if(l)if(l===O)t=10;else if(l==="*"&&O!==void 0)t=Math.max(t,5);else return 0;if(g){let o;if(typeof g=="string"?o=g:o={...g,base:(0,P.normalize)(g.base)},o===R.fsPath||(0,n.match)(o,R.fsPath))t=10;else return 0}return t}else return 0}}e.score=I}),define(Pe[90],Ae([1,0,25,20]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var I;(function(w){w[w.Full=1]="Full",w[w.Delta=2]="Delta"})(I||(I={}));function L(w){for(let g=0,S=w.length;g<S;g+=4){const p=w[g+0],l=w[g+1],t=w[g+2],o=w[g+3];w[g+0]=o,w[g+1]=t,w[g+2]=l,w[g+3]=p}}function R(w){const g=new Uint8Array(w.buffer,w.byteOffset,w.length*4);return P.isLittleEndian()||L(g),n.VSBuffer.wrap(g)}function A(w){const g=w.buffer;if(P.isLittleEndian()||L(g),g.byteOffset%4===0)return new Uint32Array(g.buffer,g.byteOffset,g.length/4);{const S=new Uint8Array(g.byteLength);return S.set(g),new Uint32Array(S.buffer,S.byteOffset,S.length/4)}}function y(w){const g=new Uint32Array(h(w));let S=0;if(g[S++]=w.id,w.type==="full")g[S++]=1,g[S++]=w.data.length,g.set(w.data,S),S+=w.data.length;else{g[S++]=2,g[S++]=w.deltas.length;for(const p of w.deltas)g[S++]=p.start,g[S++]=p.deleteCount,p.data?(g[S++]=p.data.length,g.set(p.data,S),S+=p.data.length):g[S++]=0}return R(g)}e.encodeSemanticTokensDto=y;function h(w){let g=0;if(g+=1+1,w.type==="full")g+=1+w.data.length;else{g+=1,g+=(1+1+1)*w.deltas.length;for(const S of w.deltas)S.data&&(g+=S.data.length)}return g}function O(w){const g=A(w);let S=0;const p=g[S++];if(g[S++]===1){const d=g[S++],D=g.subarray(S,S+d);return S+=d,{id:p,type:"full",data:D}}const t=g[S++],o=[];for(let d=0;d<t;d++){const D=g[S++],T=g[S++],v=g[S++];let i;v>0&&(i=g.subarray(S,S+v),S+=v),o[d]={start:D,deleteCount:T,data:i}}return{id:p,type:"delta",deltas:o}}e.decodeSemanticTokensDto=O}),define(Pe[133],Ae([10,11]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(Pe[134],Ae([1,0,133,20,135,16,23,120]),function(te,e,n,P,I,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedFloat=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(y||(e.EditorAutoIndentStrategy=y={})),e.MINIMAP_GUTTER_WIDTH=8;class h{constructor(J){this.c=J}hasChanged(J){return this.c[J]}}e.ConfigurationChangedEvent=h;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class w{constructor(J,Se,Ue,We){this.id=J,this.name=Se,this.defaultValue=Ue,this.schema=We}applyUpdate(J,Se){return S(J,Se)}compute(J,Se,Ue){return Ue}}class g{constructor(J,Se){this.newValue=J,this.didChange=Se}}e.ApplyUpdateResult=g;function S(Z,J){if(typeof Z!="object"||typeof J!="object"||!Z||!J)return new g(J,Z!==J);if(Array.isArray(Z)||Array.isArray(J)){const Ue=Array.isArray(Z)&&Array.isArray(J)&&L.equals(Z,J);return new g(J,!Ue)}let Se=!1;for(const Ue in J)if(J.hasOwnProperty(Ue)){const We=S(Z[Ue],J[Ue]);We.didChange&&(Z[Ue]=We.newValue,Se=!0)}return new g(Z,Se)}class p{constructor(J){this.schema=void 0,this.id=J,this.name="_never_",this.defaultValue=void 0}applyUpdate(J,Se){return S(J,Se)}validate(J){return this.defaultValue}}class l{constructor(J,Se,Ue,We){this.id=J,this.name=Se,this.defaultValue=Ue,this.schema=We}applyUpdate(J,Se){return S(J,Se)}validate(J){return typeof J>"u"?this.defaultValue:J}compute(J,Se,Ue){return Ue}}function t(Z,J){return typeof Z>"u"?J:Z==="false"?!1:!!Z}e.boolean=t;class o extends l{constructor(J,Se,Ue,We=void 0){typeof We<"u"&&(We.type="boolean",We.default=Ue),super(J,Se,Ue,We)}validate(J){return t(J,this.defaultValue)}}function d(Z,J,Se,Ue){if(typeof Z>"u")return J;let We=parseInt(Z,10);return isNaN(We)?J:(We=Math.max(Se,We),We=Math.min(Ue,We),We|0)}e.clampedInt=d;class D extends l{static clampedInt(J,Se,Ue,We){return d(J,Se,Ue,We)}constructor(J,Se,Ue,We,Qe,Ve=void 0){typeof Ve<"u"&&(Ve.type="integer",Ve.default=Ue,Ve.minimum=We,Ve.maximum=Qe),super(J,Se,Ue,Ve),this.minimum=We,this.maximum=Qe}validate(J){return D.clampedInt(J,this.defaultValue,this.minimum,this.maximum)}}function T(Z,J,Se,Ue){if(typeof Z>"u")return J;const We=v.float(Z,J);return v.clamp(We,Se,Ue)}e.clampedFloat=T;class v extends l{static clamp(J,Se,Ue){return J<Se?Se:J>Ue?Ue:J}static float(J,Se){if(typeof J=="number")return J;if(typeof J>"u")return Se;const Ue=parseFloat(J);return isNaN(Ue)?Se:Ue}constructor(J,Se,Ue,We,Qe){typeof Qe<"u"&&(Qe.type="number",Qe.default=Ue),super(J,Se,Ue,Qe),this.validationFn=We}validate(J){return this.validationFn(v.float(J,this.defaultValue))}}class i extends l{static string(J,Se){return typeof J!="string"?Se:J}constructor(J,Se,Ue,We=void 0){typeof We<"u"&&(We.type="string",We.default=Ue),super(J,Se,Ue,We)}validate(J){return i.string(J,this.defaultValue)}}function a(Z,J,Se,Ue){return typeof Z!="string"?J:Ue&&Z in Ue?Ue[Z]:Se.indexOf(Z)===-1?J:Z}e.stringSet=a;class r extends l{constructor(J,Se,Ue,We,Qe=void 0){typeof Qe<"u"&&(Qe.type="string",Qe.enum=We,Qe.default=Ue),super(J,Se,Ue,Qe),this.c=We}validate(J){return a(J,this.defaultValue,this.c)}}class s extends w{constructor(J,Se,Ue,We,Qe,Ve,it=void 0){typeof it<"u"&&(it.type="string",it.enum=Qe,it.default=We),super(J,Se,Ue,it),this.c=Qe,this.d=Ve}validate(J){return typeof J!="string"?this.defaultValue:this.c.indexOf(J)===-1?this.defaultValue:this.d(J)}}function E(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class k extends w{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[n.localize(0,null),n.localize(1,null),n.localize(2,null)],default:"auto",tags:["accessibility"],description:n.localize(3,null)})}validate(J){switch(J){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(J,Se,Ue){return Ue===0?J.accessibilitySupport:Ue}}class c extends w{constructor(){const J={insertSpace:!0,ignoreEmptyLines:!0};super(21,"comments",J,{"editor.comments.insertSpace":{type:"boolean",default:J.insertSpace,description:n.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:J.ignoreEmptyLines,description:n.localize(5,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J;return{insertSpace:t(Se.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:t(Se.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var u;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(u||(e.TextEditorCursorBlinkingStyle=u={}));function m(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var b;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(b||(e.TextEditorCursorStyle=b={}));function f(Z){switch(Z){case b.Line:return"line";case b.Block:return"block";case b.Underline:return"underline";case b.LineThin:return"line-thin";case b.BlockOutline:return"block-outline";case b.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function N(Z){switch(Z){case"line":return b.Line;case"block":return b.Block;case"underline":return b.Underline;case"line-thin":return b.LineThin;case"block-outline":return b.BlockOutline;case"underline-thin":return b.UnderlineThin}}class V extends p{constructor(){super(136)}compute(J,Se,Ue){const We=["monaco-editor"];return Se.get(37)&&We.push(Se.get(37)),J.extraEditorClassName&&We.push(J.extraEditorClassName),Se.get(71)==="default"?We.push("mouse-default"):Se.get(71)==="copy"&&We.push("mouse-copy"),Se.get(106)&&We.push("showUnused"),Se.get(134)&&We.push("showDeprecated"),We.join(" ")}}class _ extends o{constructor(){super(35,"emptySelectionClipboard",!0,{description:n.localize(6,null)})}compute(J,Se,Ue){return Ue&&J.emptySelectionClipboard}}class G extends w{constructor(){const J={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(39,"find",J,{"editor.find.cursorMoveOnType":{type:"boolean",default:J.cursorMoveOnType,description:n.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:J.seedSearchStringFromSelection,enumDescriptions:[n.localize(8,null),n.localize(9,null),n.localize(10,null)],description:n.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:J.autoFindInSelection,enumDescriptions:[n.localize(12,null),n.localize(13,null),n.localize(14,null)],description:n.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:J.globalFindClipboard,description:n.localize(16,null),included:P.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:J.addExtraSpaceOnTop,description:n.localize(17,null)},"editor.find.loop":{type:"boolean",default:J.loop,description:n.localize(18,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J;return{cursorMoveOnType:t(Se.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof J.seedSearchStringFromSelection=="boolean"?J.seedSearchStringFromSelection?"always":"never":a(Se.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof J.autoFindInSelection=="boolean"?J.autoFindInSelection?"always":"never":a(Se.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:t(Se.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:t(Se.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:t(Se.loop,this.defaultValue.loop)}}}class $ extends w{constructor(){super(49,"fontLigatures",$.OFF,{anyOf:[{type:"boolean",description:n.localize(19,null)},{type:"string",description:n.localize(20,null)}],description:n.localize(21,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?$.OFF:J==="true"?$.ON:J:J?$.ON:$.OFF}}e.EditorFontLigatures=$,$.OFF='"liga" off, "calt" off',$.ON='"liga" on, "calt" on';class B extends w{constructor(){super(52,"fontVariations",B.OFF,{anyOf:[{type:"boolean",description:n.localize(22,null)},{type:"string",description:n.localize(23,null)}],description:n.localize(24,null),default:!1})}validate(J){return typeof J>"u"?this.defaultValue:typeof J=="string"?J==="false"?B.OFF:J==="true"?B.TRANSLATE:J:J?B.TRANSLATE:B.OFF}compute(J,Se,Ue){return J.fontInfo.fontVariationSettings}}e.EditorFontVariations=B,B.OFF="normal",B.TRANSLATE="translate";class X extends p{constructor(){super(48)}compute(J,Se,Ue){return J.fontInfo}}class U extends l{constructor(){super(50,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:n.localize(25,null)})}validate(J){const Se=v.float(J,this.defaultValue);return Se===0?e.EDITOR_FONT_DEFAULTS.fontSize:v.clamp(Se,6,100)}compute(J,Se,Ue){return J.fontInfo.fontSize}}class j extends w{constructor(){super(51,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:j.d,maximum:j.e,errorMessage:n.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:j.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:n.localize(27,null)})}validate(J){return J==="normal"||J==="bold"?J:String(D.clampedInt(J,e.EDITOR_FONT_DEFAULTS.fontWeight,j.d,j.e))}}j.c=["normal","bold","100","200","300","400","500","600","700","800","900"],j.d=1,j.e=1e3;class Y extends w{constructor(){const J={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},Se={type:"string",enum:["peek","gotoAndPeek","goto"],default:J.multiple,enumDescriptions:[n.localize(28,null),n.localize(29,null),n.localize(30,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(56,"gotoLocation",J,{"editor.gotoLocation.multiple":{deprecationMessage:n.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:n.localize(32,null),...Se},"editor.gotoLocation.multipleTypeDefinitions":{description:n.localize(33,null),...Se},"editor.gotoLocation.multipleDeclarations":{description:n.localize(34,null),...Se},"editor.gotoLocation.multipleImplementations":{description:n.localize(35,null),...Se},"editor.gotoLocation.multipleReferences":{description:n.localize(36,null),...Se},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:J.alternativeDefinitionCommand,enum:Ue,description:n.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:J.alternativeTypeDefinitionCommand,enum:Ue,description:n.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:J.alternativeDeclarationCommand,enum:Ue,description:n.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:J.alternativeImplementationCommand,enum:Ue,description:n.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:J.alternativeReferenceCommand,enum:Ue,description:n.localize(41,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J;return{multiple:a(Se.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:Se.multipleDefinitions??a(Se.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:Se.multipleTypeDefinitions??a(Se.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:Se.multipleDeclarations??a(Se.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:Se.multipleImplementations??a(Se.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:Se.multipleReferences??a(Se.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string(Se.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string(Se.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string(Se.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string(Se.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string(Se.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class pe extends w{constructor(){const J={enabled:!0,delay:300,sticky:!0,above:!0};super(58,"hover",J,{"editor.hover.enabled":{type:"boolean",default:J.enabled,description:n.localize(42,null)},"editor.hover.delay":{type:"number",default:J.delay,minimum:0,maximum:1e4,description:n.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:J.sticky,description:n.localize(44,null)},"editor.hover.above":{type:"boolean",default:J.above,description:n.localize(45,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J;return{enabled:t(Se.enabled,this.defaultValue.enabled),delay:D.clampedInt(Se.delay,this.defaultValue.delay,0,1e4),sticky:t(Se.sticky,this.defaultValue.sticky),above:t(Se.above,this.defaultValue.above)}}}var Ee;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(Ee||(e.RenderMinimap=Ee={}));class he extends p{constructor(){super(139)}compute(J,Se,Ue){return he.computeLayout(Se,{memory:J.memory,outerWidth:J.outerWidth,outerHeight:J.outerHeight,isDominatedByLongLines:J.isDominatedByLongLines,lineHeight:J.fontInfo.lineHeight,viewLineCount:J.viewLineCount,lineNumbersDigitCount:J.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:J.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:J.fontInfo.maxDigitWidth,pixelRatio:J.pixelRatio,glyphMarginDecorationLaneCount:J.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(J){const Se=J.height/J.lineHeight,Ue=Math.floor(J.paddingTop/J.lineHeight);let We=Math.floor(J.paddingBottom/J.lineHeight);J.scrollBeyondLastLine&&(We=Math.max(We,Se-1));const Qe=(Ue+J.viewLineCount+We)/(J.pixelRatio*J.height),Ve=Math.floor(J.viewLineCount/Qe);return{typicalViewportLineCount:Se,extraLinesBeforeFirstLine:Ue,extraLinesBeyondLastLine:We,desiredRatio:Qe,minimapLineCount:Ve}}static c(J,Se){const Ue=J.outerWidth,We=J.outerHeight,Qe=J.pixelRatio;if(!J.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(Qe*We),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:We};const Ve=Se.stableMinimapLayoutInput,it=Ve&&J.outerHeight===Ve.outerHeight&&J.lineHeight===Ve.lineHeight&&J.typicalHalfwidthCharacterWidth===Ve.typicalHalfwidthCharacterWidth&&J.pixelRatio===Ve.pixelRatio&&J.scrollBeyondLastLine===Ve.scrollBeyondLastLine&&J.paddingTop===Ve.paddingTop&&J.paddingBottom===Ve.paddingBottom&&J.minimap.enabled===Ve.minimap.enabled&&J.minimap.side===Ve.minimap.side&&J.minimap.size===Ve.minimap.size&&J.minimap.showSlider===Ve.minimap.showSlider&&J.minimap.renderCharacters===Ve.minimap.renderCharacters&&J.minimap.maxColumn===Ve.minimap.maxColumn&&J.minimap.scale===Ve.minimap.scale&&J.verticalScrollbarWidth===Ve.verticalScrollbarWidth&&J.isViewportWrapping===Ve.isViewportWrapping,Et=J.lineHeight,yt=J.typicalHalfwidthCharacterWidth,Tt=J.scrollBeyondLastLine,Ht=J.minimap.renderCharacters;let wt=Qe>=2?Math.round(J.minimap.scale*2):J.minimap.scale;const Bt=J.minimap.maxColumn,Mt=J.minimap.size,xt=J.minimap.side,Vt=J.verticalScrollbarWidth,Pt=J.viewLineCount,at=J.remainingWidth,gt=J.isViewportWrapping,Wt=Ht?2:3;let Ut=Math.floor(Qe*We);const kt=Ut/Qe;let ht=!1,Ct=!1,Ft=Wt*wt,At=wt/Qe,Ke=1;if(Mt==="fill"||Mt==="fit"){const{typicalViewportLineCount:Xe,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:tt,desiredRatio:bt,minimapLineCount:pt}=he.computeContainedMinimapLineCount({viewLineCount:Pt,scrollBeyondLastLine:Tt,paddingTop:J.paddingTop,paddingBottom:J.paddingBottom,height:We,lineHeight:Et,pixelRatio:Qe});if(Pt/pt>1)ht=!0,Ct=!0,wt=1,Ft=1,At=wt/Qe;else{let nt=!1,lt=wt+1;if(Mt==="fit"){const Ot=Math.ceil((He+Pt+tt)*Ft);gt&&it&&at<=Se.stableFitRemainingWidth?(nt=!0,lt=Se.stableFitMaxMinimapScale):nt=Ot>Ut}if(Mt==="fill"||nt){ht=!0;const Ot=wt;Ft=Math.min(Et*Qe,Math.max(1,Math.floor(1/bt))),gt&&it&&at<=Se.stableFitRemainingWidth&&(lt=Se.stableFitMaxMinimapScale),wt=Math.min(lt,Math.max(1,Math.floor(Ft/Wt))),wt>Ot&&(Ke=Math.min(2,wt/Ot)),At=wt/Qe/Ke,Ut=Math.ceil(Math.max(Xe,He+Pt+tt)*Ft),gt?(Se.stableMinimapLayoutInput=J,Se.stableFitRemainingWidth=at,Se.stableFitMaxMinimapScale=wt):(Se.stableMinimapLayoutInput=null,Se.stableFitRemainingWidth=0)}}}const Te=Math.floor(Bt*At),Oe=Math.min(Te,Math.max(0,Math.floor((at-Vt-2)*At/(yt+At)))+e.MINIMAP_GUTTER_WIDTH);let ve=Math.floor(Qe*Oe);const K=ve/Qe;ve=Math.floor(ve*Ke);const Fe=Ht?1:2,Be=xt==="left"?0:Ue-Oe-Vt;return{renderMinimap:Fe,minimapLeft:Be,minimapWidth:Oe,minimapHeightIsEditorHeight:ht,minimapIsSampling:Ct,minimapScale:wt,minimapLineHeight:Ft,minimapCanvasInnerWidth:ve,minimapCanvasInnerHeight:Ut,minimapCanvasOuterWidth:K,minimapCanvasOuterHeight:kt}}static computeLayout(J,Se){const Ue=Se.outerWidth|0,We=Se.outerHeight|0,Qe=Se.lineHeight|0,Ve=Se.lineNumbersDigitCount|0,it=Se.typicalHalfwidthCharacterWidth,Et=Se.maxDigitWidth,yt=Se.pixelRatio,Tt=Se.viewLineCount,Ht=J.get(131),wt=Ht==="inherit"?J.get(130):Ht,Bt=wt==="inherit"?J.get(126):wt,Mt=J.get(129),xt=Se.isDominatedByLongLines,Vt=J.get(55),Pt=J.get(65).renderType!==0,at=J.get(66),gt=J.get(100),Wt=J.get(81),Ut=J.get(70),kt=J.get(98),ht=kt.verticalScrollbarSize,Ct=kt.verticalHasArrows,Ft=kt.arrowSize,At=kt.horizontalScrollbarSize,Ke=J.get(41),Te=J.get(105)!=="never";let Oe=J.get(63);Ke&&Te&&(Oe+=16);let ve=0;if(Pt){const ai=Math.max(Ve,at);ve=Math.round(ai*Et)}let K=0;Vt&&(K=Qe*Se.glyphMarginDecorationLaneCount);let Fe=0,Be=Fe+K,Xe=Be+ve,He=Xe+Oe;const tt=Ue-K-ve-Oe;let bt=!1,pt=!1,dt=-1;wt==="inherit"&&xt?(bt=!0,pt=!0):Bt==="on"||Bt==="bounded"?pt=!0:Bt==="wordWrapColumn"&&(dt=Mt);const nt=he.c({outerWidth:Ue,outerHeight:We,lineHeight:Qe,typicalHalfwidthCharacterWidth:it,pixelRatio:yt,scrollBeyondLastLine:gt,paddingTop:Wt.top,paddingBottom:Wt.bottom,minimap:Ut,verticalScrollbarWidth:ht,viewLineCount:Tt,remainingWidth:tt,isViewportWrapping:pt},Se.memory||new O);nt.renderMinimap!==0&&nt.minimapLeft===0&&(Fe+=nt.minimapWidth,Be+=nt.minimapWidth,Xe+=nt.minimapWidth,He+=nt.minimapWidth);const lt=tt-nt.minimapWidth,Ot=Math.max(1,Math.floor((lt-ht-2)/it)),$t=Ct?Ft:0;return pt&&(dt=Math.max(1,Ot),Bt==="bounded"&&(dt=Math.min(dt,Mt))),{width:Ue,height:We,glyphMarginLeft:Fe,glyphMarginWidth:K,glyphMarginDecorationLaneCount:Se.glyphMarginDecorationLaneCount,lineNumbersLeft:Be,lineNumbersWidth:ve,decorationsLeft:Xe,decorationsWidth:Oe,contentLeft:He,contentWidth:lt,minimap:nt,viewportColumn:Ot,isWordWrapMinified:bt,isViewportWrapping:pt,wrappingColumn:dt,verticalScrollbarWidth:ht,horizontalScrollbarHeight:At,overviewRuler:{top:$t,width:ht,height:We-2*$t,right:0}}}}e.EditorLayoutInfoComputer=he;class de extends w{constructor(){super(133,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[n.localize(46,null),n.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:n.localize(48,null)}})}validate(J){return a(J,"simple",["simple","advanced"])}compute(J,Se,Ue){return Se.get(2)===2?"advanced":Ue}}class Re extends w{constructor(){const J={enabled:!0};super(62,"lightbulb",J,{"editor.lightbulb.enabled":{type:"boolean",default:J.enabled,description:n.localize(49,null)}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{enabled:t(J.enabled,this.defaultValue.enabled)}}}class le extends w{constructor(){const J={enabled:!1,maxLineCount:5,defaultModel:"outlineModel"};super(110,"stickyScroll",J,{"editor.stickyScroll.enabled":{type:"boolean",default:J.enabled,description:n.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:J.maxLineCount,minimum:1,maximum:10,description:n.localize(51,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:J.defaultModel,description:n.localize(52,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J;return{enabled:t(Se.enabled,this.defaultValue.enabled),maxLineCount:D.clampedInt(Se.maxLineCount,this.defaultValue.maxLineCount,1,10),defaultModel:a(Se.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"])}}}class ue extends w{constructor(){const J={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(135,"inlayHints",J,{"editor.inlayHints.enabled":{type:"string",default:J.enabled,description:n.localize(53,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[n.localize(54,null),n.localize(55,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(56,null,P.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),n.localize(57,null)]},"editor.inlayHints.fontSize":{type:"number",default:J.fontSize,markdownDescription:n.localize(58,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:J.fontFamily,markdownDescription:n.localize(59,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:J.padding,description:n.localize(60,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J;return typeof Se.enabled=="boolean"&&(Se.enabled=Se.enabled?"on":"off"),{enabled:a(Se.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:D.clampedInt(Se.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string(Se.fontFamily,this.defaultValue.fontFamily),padding:t(Se.padding,this.defaultValue.padding)}}}class H extends w{constructor(){super(63,"lineDecorationsWidth",10)}validate(J){return typeof J=="string"&&/^\d+(\.\d+)?ch$/.test(J)?-parseFloat(J.substring(0,J.length-2)):D.clampedInt(J,this.defaultValue,0,1e3)}compute(J,Se,Ue){return Ue<0?D.clampedInt(-Ue*J.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Ue}}class F extends v{constructor(){super(64,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,J=>v.clamp(J,0,150),{markdownDescription:n.localize(61,null)})}compute(J,Se,Ue){return J.fontInfo.lineHeight}}class Q extends w{constructor(){const J={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(70,"minimap",J,{"editor.minimap.enabled":{type:"boolean",default:J.enabled,description:n.localize(62,null)},"editor.minimap.autohide":{type:"boolean",default:J.autohide,description:n.localize(63,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[n.localize(64,null),n.localize(65,null),n.localize(66,null)],default:J.size,description:n.localize(67,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:J.side,description:n.localize(68,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:J.showSlider,description:n.localize(69,null)},"editor.minimap.scale":{type:"number",default:J.scale,minimum:1,maximum:3,enum:[1,2,3],description:n.localize(70,null)},"editor.minimap.renderCharacters":{type:"boolean",default:J.renderCharacters,description:n.localize(71,null)},"editor.minimap.maxColumn":{type:"number",default:J.maxColumn,description:n.localize(72,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J;return{enabled:t(Se.enabled,this.defaultValue.enabled),autohide:t(Se.autohide,this.defaultValue.autohide),size:a(Se.size,this.defaultValue.size,["proportional","fill","fit"]),side:a(Se.side,this.defaultValue.side,["right","left"]),showSlider:a(Se.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:t(Se.renderCharacters,this.defaultValue.renderCharacters),scale:D.clampedInt(Se.scale,1,1,3),maxColumn:D.clampedInt(Se.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function me(Z){return Z==="ctrlCmd"?P.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ce extends w{constructor(){super(81,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(73,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:n.localize(74,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J;return{top:D.clampedInt(Se.top,0,0,1e3),bottom:D.clampedInt(Se.bottom,0,0,1e3)}}}class De extends w{constructor(){const J={enabled:!0,cycle:!0};super(82,"parameterHints",J,{"editor.parameterHints.enabled":{type:"boolean",default:J.enabled,description:n.localize(75,null)},"editor.parameterHints.cycle":{type:"boolean",default:J.cycle,description:n.localize(76,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J;return{enabled:t(Se.enabled,this.defaultValue.enabled),cycle:t(Se.cycle,this.defaultValue.cycle)}}}class be extends p{constructor(){super(137)}compute(J,Se,Ue){return J.pixelRatio}}class ke extends w{constructor(){const J={other:"on",comments:"off",strings:"off"},Se=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[n.localize(77,null),n.localize(78,null),n.localize(79,null)]}];super(85,"quickSuggestions",J,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:Se,default:J.strings,description:n.localize(80,null)},comments:{anyOf:Se,default:J.comments,description:n.localize(81,null)},other:{anyOf:Se,default:J.other,description:n.localize(82,null)}},default:J,markdownDescription:n.localize(83,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=J}validate(J){if(typeof J=="boolean"){const yt=J?"on":"off";return{comments:yt,strings:yt,other:yt}}if(!J||typeof J!="object")return this.defaultValue;const{other:Se,comments:Ue,strings:We}=J,Qe=["on","inline","off"];let Ve,it,Et;return typeof Se=="boolean"?Ve=Se?"on":"off":Ve=a(Se,this.defaultValue.other,Qe),typeof Ue=="boolean"?it=Ue?"on":"off":it=a(Ue,this.defaultValue.comments,Qe),typeof We=="boolean"?Et=We?"on":"off":Et=a(We,this.defaultValue.strings,Qe),{other:Ve,comments:it,strings:Et}}}var oe;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(oe||(e.RenderLineNumbersType=oe={}));class ce extends w{constructor(){super(65,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[n.localize(84,null),n.localize(85,null),n.localize(86,null),n.localize(87,null)],default:"on",description:n.localize(88,null)})}validate(J){let Se=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof J<"u"&&(typeof J=="function"?(Se=4,Ue=J):J==="interval"?Se=3:J==="relative"?Se=2:J==="on"?Se=1:Se=0),{renderType:Se,renderFn:Ue}}}function ie(Z){const J=Z.get(93);return J==="editable"?Z.get(87):J!=="on"}e.filterValidationDecorations=ie;class ne extends w{constructor(){const J=[],Se={type:"number",description:n.localize(89,null)};super(97,"rulers",J,{type:"array",items:{anyOf:[Se,{type:["object"],properties:{column:Se,color:{type:"string",description:n.localize(90,null),format:"color-hex"}}}]},default:J,description:n.localize(91,null)})}validate(J){if(Array.isArray(J)){const Se=[];for(const Ue of J)if(typeof Ue=="number")Se.push({column:D.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const We=Ue;Se.push({column:D.clampedInt(We.column,0,0,1e4),color:We.color})}return Se.sort((Ue,We)=>Ue.column-We.column),Se}return this.defaultValue}}function C(Z,J){if(typeof Z!="string")return J;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class W extends w{constructor(){const J={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(98,"scrollbar",J,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(92,null),n.localize(93,null),n.localize(94,null)],default:"auto",description:n.localize(95,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[n.localize(96,null),n.localize(97,null),n.localize(98,null)],default:"auto",description:n.localize(99,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:J.verticalScrollbarSize,description:n.localize(100,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:J.horizontalScrollbarSize,description:n.localize(101,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:J.scrollByPage,description:n.localize(102,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J,Ue=D.clampedInt(Se.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),We=D.clampedInt(Se.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:D.clampedInt(Se.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:C(Se.vertical,this.defaultValue.vertical),horizontal:C(Se.horizontal,this.defaultValue.horizontal),useShadows:t(Se.useShadows,this.defaultValue.useShadows),verticalHasArrows:t(Se.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:t(Se.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:t(Se.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:t(Se.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:D.clampedInt(Se.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:We,verticalSliderSize:D.clampedInt(Se.verticalSliderSize,We,0,1e3),scrollByPage:t(Se.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class q extends w{constructor(){const J={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(120,"unicodeHighlight",J,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.nonBasicASCII,description:n.localize(103,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:J.invisibleCharacters,description:n.localize(104,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:J.ambiguousCharacters,description:n.localize(105,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeComments,description:n.localize(106,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:J.includeStrings,description:n.localize(107,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:J.allowedCharacters,description:n.localize(108,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:J.allowedLocales,description:n.localize(109,null)}})}applyUpdate(J,Se){let Ue=!1;Se.allowedCharacters&&J&&(R.equals(J.allowedCharacters,Se.allowedCharacters)||(J={...J,allowedCharacters:Se.allowedCharacters},Ue=!0)),Se.allowedLocales&&J&&(R.equals(J.allowedLocales,Se.allowedLocales)||(J={...J,allowedLocales:Se.allowedLocales},Ue=!0));const We=super.applyUpdate(J,Se);return Ue?new g(We.newValue,!0):We}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J;return{nonBasicASCII:ee(Se.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:t(Se.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:t(Se.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:ee(Se.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:ee(Se.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(J.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(J.allowedLocales,this.defaultValue.allowedLocales)}}c(J,Se){if(typeof J!="object"||!J)return Se;const Ue={};for(const[We,Qe]of Object.entries(J))Qe===!0&&(Ue[We]=!0);return Ue}}class x extends w{constructor(){const J={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1};super(60,"inlineSuggest",J,{"editor.inlineSuggest.enabled":{type:"boolean",default:J.enabled,description:n.localize(110,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:J.showToolbar,enum:["always","onHover"],enumDescriptions:[n.localize(111,null),n.localize(112,null)],description:n.localize(113,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:J.suppressSuggestions,description:n.localize(114,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J;return{enabled:t(Se.enabled,this.defaultValue.enabled),mode:a(Se.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:a(Se.showToolbar,this.defaultValue.showToolbar,["always","onHover"]),suppressSuggestions:t(Se.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:t(Se.keepOnBlur,this.defaultValue.keepOnBlur)}}}class ae extends w{constructor(){const J={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(13,"bracketPairColorization",J,{"editor.bracketPairColorization.enabled":{type:"boolean",default:J.enabled,markdownDescription:n.localize(115,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:J.independentColorPoolPerBracketType,description:n.localize(116,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J;return{enabled:t(Se.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:t(Se.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class ge extends w{constructor(){const J={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(14,"guides",J,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(117,null),n.localize(118,null),n.localize(119,null)],default:J.bracketPairs,description:n.localize(120,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[n.localize(121,null),n.localize(122,null),n.localize(123,null)],default:J.bracketPairsHorizontal,description:n.localize(124,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:J.highlightActiveBracketPair,description:n.localize(125,null)},"editor.guides.indentation":{type:"boolean",default:J.indentation,description:n.localize(126,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[n.localize(127,null),n.localize(128,null),n.localize(129,null)],default:J.highlightActiveIndentation,description:n.localize(130,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J;return{bracketPairs:ee(Se.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:ee(Se.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:t(Se.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:t(Se.indentation,this.defaultValue.indentation),highlightActiveIndentation:ee(Se.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function ee(Z,J,Se){const Ue=Se.indexOf(Z);return Ue===-1?J:Se[Ue]}class we extends w{constructor(){const J={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(113,"suggest",J,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[n.localize(131,null),n.localize(132,null)],default:J.insertMode,description:n.localize(133,null)},"editor.suggest.filterGraceful":{type:"boolean",default:J.filterGraceful,description:n.localize(134,null)},"editor.suggest.localityBonus":{type:"boolean",default:J.localityBonus,description:n.localize(135,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:J.shareSuggestSelections,markdownDescription:n.localize(136,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[n.localize(137,null),n.localize(138,null),n.localize(139,null),n.localize(140,null)],default:J.selectionMode,markdownDescription:n.localize(141,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:J.snippetsPreventQuickSuggestions,description:n.localize(142,null)},"editor.suggest.showIcons":{type:"boolean",default:J.showIcons,description:n.localize(143,null)},"editor.suggest.showStatusBar":{type:"boolean",default:J.showStatusBar,description:n.localize(144,null)},"editor.suggest.preview":{type:"boolean",default:J.preview,description:n.localize(145,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:J.showInlineDetails,description:n.localize(146,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:n.localize(147,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:n.localize(148,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:n.localize(149,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:n.localize(150,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:n.localize(151,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:n.localize(152,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:n.localize(153,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:n.localize(154,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:n.localize(155,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:n.localize(156,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:n.localize(157,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:n.localize(158,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:n.localize(159,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:n.localize(160,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:n.localize(161,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:n.localize(162,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:n.localize(163,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:n.localize(164,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:n.localize(165,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:n.localize(166,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:n.localize(167,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:n.localize(168,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:n.localize(169,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:n.localize(170,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:n.localize(171,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:n.localize(172,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:n.localize(173,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:n.localize(174,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:n.localize(175,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:n.localize(176,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:n.localize(177,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:n.localize(178,null)}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J;return{insertMode:a(Se.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:t(Se.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:t(Se.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:t(Se.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:t(Se.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:a(Se.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:t(Se.showIcons,this.defaultValue.showIcons),showStatusBar:t(Se.showStatusBar,this.defaultValue.showStatusBar),preview:t(Se.preview,this.defaultValue.preview),previewMode:a(Se.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:t(Se.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:t(Se.showMethods,this.defaultValue.showMethods),showFunctions:t(Se.showFunctions,this.defaultValue.showFunctions),showConstructors:t(Se.showConstructors,this.defaultValue.showConstructors),showDeprecated:t(Se.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:t(Se.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:t(Se.showFields,this.defaultValue.showFields),showVariables:t(Se.showVariables,this.defaultValue.showVariables),showClasses:t(Se.showClasses,this.defaultValue.showClasses),showStructs:t(Se.showStructs,this.defaultValue.showStructs),showInterfaces:t(Se.showInterfaces,this.defaultValue.showInterfaces),showModules:t(Se.showModules,this.defaultValue.showModules),showProperties:t(Se.showProperties,this.defaultValue.showProperties),showEvents:t(Se.showEvents,this.defaultValue.showEvents),showOperators:t(Se.showOperators,this.defaultValue.showOperators),showUnits:t(Se.showUnits,this.defaultValue.showUnits),showValues:t(Se.showValues,this.defaultValue.showValues),showConstants:t(Se.showConstants,this.defaultValue.showConstants),showEnums:t(Se.showEnums,this.defaultValue.showEnums),showEnumMembers:t(Se.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:t(Se.showKeywords,this.defaultValue.showKeywords),showWords:t(Se.showWords,this.defaultValue.showWords),showColors:t(Se.showColors,this.defaultValue.showColors),showFiles:t(Se.showFiles,this.defaultValue.showFiles),showReferences:t(Se.showReferences,this.defaultValue.showReferences),showFolders:t(Se.showFolders,this.defaultValue.showFolders),showTypeParameters:t(Se.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:t(Se.showSnippets,this.defaultValue.showSnippets),showUsers:t(Se.showUsers,this.defaultValue.showUsers),showIssues:t(Se.showIssues,this.defaultValue.showIssues)}}}class ye extends w{constructor(){super(108,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:n.localize(179,null),default:!0,type:"boolean"}})}validate(J){return!J||typeof J!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:t(J.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var ze;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(ze||(e.WrappingIndent=ze={}));class je extends w{constructor(){super(132,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[n.localize(180,null),n.localize(181,null),n.localize(182,null),n.localize(183,null)],description:n.localize(184,null),default:"same"}})}validate(J){switch(J){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(J,Se,Ue){return Se.get(2)===2?0:Ue}}class et extends p{constructor(){super(140)}compute(J,Se,Ue){const We=Se.get(139);return{isDominatedByLongLines:J.isDominatedByLongLines,isWordWrapMinified:We.isWordWrapMinified,isViewportWrapping:We.isViewportWrapping,wrappingColumn:We.wrappingColumn}}}class Ye extends w{constructor(){const J={enabled:!0,showDropSelector:"afterDrop"};super(34,"dropIntoEditor",J,{"editor.dropIntoEditor.enabled":{type:"boolean",default:J.enabled,markdownDescription:n.localize(185,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:n.localize(186,null),enum:["afterDrop","never"],enumDescriptions:[n.localize(187,null),n.localize(188,null)],default:"afterDrop"}})}validate(J){if(!J||typeof J!="object")return this.defaultValue;const Se=J;return{enabled:t(Se.enabled,this.defaultValue.enabled),showDropSelector:a(Se.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}const Je="Consolas, 'Courier New', monospace",rt="Menlo, Monaco, 'Courier New', monospace",ut="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:P.isMacintosh?rt:P.isLinux?ut:Je,fontWeight:"normal",fontSize:P.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Me(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var st;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.autoClosingBrackets=5]="autoClosingBrackets",Z[Z.screenReaderAnnounceInlineSuggestion=6]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=7]="autoClosingDelete",Z[Z.autoClosingOvertype=8]="autoClosingOvertype",Z[Z.autoClosingQuotes=9]="autoClosingQuotes",Z[Z.autoIndent=10]="autoIndent",Z[Z.automaticLayout=11]="automaticLayout",Z[Z.autoSurround=12]="autoSurround",Z[Z.bracketPairColorization=13]="bracketPairColorization",Z[Z.guides=14]="guides",Z[Z.codeLens=15]="codeLens",Z[Z.codeLensFontFamily=16]="codeLensFontFamily",Z[Z.codeLensFontSize=17]="codeLensFontSize",Z[Z.colorDecorators=18]="colorDecorators",Z[Z.colorDecoratorsLimit=19]="colorDecoratorsLimit",Z[Z.columnSelection=20]="columnSelection",Z[Z.comments=21]="comments",Z[Z.contextmenu=22]="contextmenu",Z[Z.copyWithSyntaxHighlighting=23]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=24]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=25]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=26]="cursorStyle",Z[Z.cursorSurroundingLines=27]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=28]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=29]="cursorWidth",Z[Z.disableLayerHinting=30]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=31]="disableMonospaceOptimizations",Z[Z.domReadOnly=32]="domReadOnly",Z[Z.dragAndDrop=33]="dragAndDrop",Z[Z.dropIntoEditor=34]="dropIntoEditor",Z[Z.emptySelectionClipboard=35]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=36]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=37]="extraEditorClassName",Z[Z.fastScrollSensitivity=38]="fastScrollSensitivity",Z[Z.find=39]="find",Z[Z.fixedOverflowWidgets=40]="fixedOverflowWidgets",Z[Z.folding=41]="folding",Z[Z.foldingStrategy=42]="foldingStrategy",Z[Z.foldingHighlight=43]="foldingHighlight",Z[Z.foldingImportsByDefault=44]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=45]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=46]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=47]="fontFamily",Z[Z.fontInfo=48]="fontInfo",Z[Z.fontLigatures=49]="fontLigatures",Z[Z.fontSize=50]="fontSize",Z[Z.fontWeight=51]="fontWeight",Z[Z.fontVariations=52]="fontVariations",Z[Z.formatOnPaste=53]="formatOnPaste",Z[Z.formatOnType=54]="formatOnType",Z[Z.glyphMargin=55]="glyphMargin",Z[Z.gotoLocation=56]="gotoLocation",Z[Z.hideCursorInOverviewRuler=57]="hideCursorInOverviewRuler",Z[Z.hover=58]="hover",Z[Z.inDiffEditor=59]="inDiffEditor",Z[Z.inlineSuggest=60]="inlineSuggest",Z[Z.letterSpacing=61]="letterSpacing",Z[Z.lightbulb=62]="lightbulb",Z[Z.lineDecorationsWidth=63]="lineDecorationsWidth",Z[Z.lineHeight=64]="lineHeight",Z[Z.lineNumbers=65]="lineNumbers",Z[Z.lineNumbersMinChars=66]="lineNumbersMinChars",Z[Z.linkedEditing=67]="linkedEditing",Z[Z.links=68]="links",Z[Z.matchBrackets=69]="matchBrackets",Z[Z.minimap=70]="minimap",Z[Z.mouseStyle=71]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=72]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=73]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=74]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=75]="multiCursorModifier",Z[Z.multiCursorPaste=76]="multiCursorPaste",Z[Z.multiCursorLimit=77]="multiCursorLimit",Z[Z.occurrencesHighlight=78]="occurrencesHighlight",Z[Z.overviewRulerBorder=79]="overviewRulerBorder",Z[Z.overviewRulerLanes=80]="overviewRulerLanes",Z[Z.padding=81]="padding",Z[Z.parameterHints=82]="parameterHints",Z[Z.peekWidgetDefaultFocus=83]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=84]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=85]="quickSuggestions",Z[Z.quickSuggestionsDelay=86]="quickSuggestionsDelay",Z[Z.readOnly=87]="readOnly",Z[Z.renameOnType=88]="renameOnType",Z[Z.renderControlCharacters=89]="renderControlCharacters",Z[Z.renderFinalNewline=90]="renderFinalNewline",Z[Z.renderLineHighlight=91]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=92]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=93]="renderValidationDecorations",Z[Z.renderWhitespace=94]="renderWhitespace",Z[Z.revealHorizontalRightPadding=95]="revealHorizontalRightPadding",Z[Z.roundedSelection=96]="roundedSelection",Z[Z.rulers=97]="rulers",Z[Z.scrollbar=98]="scrollbar",Z[Z.scrollBeyondLastColumn=99]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=100]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=101]="scrollPredominantAxis",Z[Z.selectionClipboard=102]="selectionClipboard",Z[Z.selectionHighlight=103]="selectionHighlight",Z[Z.selectOnLineNumbers=104]="selectOnLineNumbers",Z[Z.showFoldingControls=105]="showFoldingControls",Z[Z.showUnused=106]="showUnused",Z[Z.snippetSuggestions=107]="snippetSuggestions",Z[Z.smartSelect=108]="smartSelect",Z[Z.smoothScrolling=109]="smoothScrolling",Z[Z.stickyScroll=110]="stickyScroll",Z[Z.stickyTabStops=111]="stickyTabStops",Z[Z.stopRenderingLineAfter=112]="stopRenderingLineAfter",Z[Z.suggest=113]="suggest",Z[Z.suggestFontSize=114]="suggestFontSize",Z[Z.suggestLineHeight=115]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=116]="suggestOnTriggerCharacters",Z[Z.suggestSelection=117]="suggestSelection",Z[Z.tabCompletion=118]="tabCompletion",Z[Z.tabIndex=119]="tabIndex",Z[Z.unicodeHighlighting=120]="unicodeHighlighting",Z[Z.unusualLineTerminators=121]="unusualLineTerminators",Z[Z.useShadowDOM=122]="useShadowDOM",Z[Z.useTabStops=123]="useTabStops",Z[Z.wordBreak=124]="wordBreak",Z[Z.wordSeparators=125]="wordSeparators",Z[Z.wordWrap=126]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=127]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=128]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=129]="wordWrapColumn",Z[Z.wordWrapOverride1=130]="wordWrapOverride1",Z[Z.wordWrapOverride2=131]="wordWrapOverride2",Z[Z.wrappingIndent=132]="wrappingIndent",Z[Z.wrappingStrategy=133]="wrappingStrategy",Z[Z.showDeprecated=134]="showDeprecated",Z[Z.inlayHints=135]="inlayHints",Z[Z.editorClassName=136]="editorClassName",Z[Z.pixelRatio=137]="pixelRatio",Z[Z.tabFocusMode=138]="tabFocusMode",Z[Z.layoutInfo=139]="layoutInfo",Z[Z.wrappingInfo=140]="wrappingInfo",Z[Z.defaultColorDecorators=141]="defaultColorDecorators"})(st||(e.EditorOption=st={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Me(new o(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:n.localize(189,null)})),acceptSuggestionOnEnter:Me(new r(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",n.localize(190,null),""],markdownDescription:n.localize(191,null)})),accessibilitySupport:Me(new k),accessibilityPageSize:Me(new D(3,"accessibilityPageSize",10,1,1073741824,{description:n.localize(192,null),tags:["accessibility"]})),ariaLabel:Me(new i(4,"ariaLabel",n.localize(193,null))),screenReaderAnnounceInlineSuggestion:Me(new o(6,"screenReaderAnnounceInlineSuggestion",!1,{description:n.localize(194,null),tags:["accessibility"]})),autoClosingBrackets:Me(new r(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(195,null),n.localize(196,null),""],description:n.localize(197,null)})),autoClosingDelete:Me(new r(7,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",n.localize(198,null),""],description:n.localize(199,null)})),autoClosingOvertype:Me(new r(8,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",n.localize(200,null),""],description:n.localize(201,null)})),autoClosingQuotes:Me(new r(9,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",n.localize(202,null),n.localize(203,null),""],description:n.localize(204,null)})),autoIndent:Me(new s(10,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],E,{enumDescriptions:[n.localize(205,null),n.localize(206,null),n.localize(207,null),n.localize(208,null),n.localize(209,null)],description:n.localize(210,null)})),automaticLayout:Me(new o(11,"automaticLayout",!1)),autoSurround:Me(new r(12,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[n.localize(211,null),n.localize(212,null),n.localize(213,null),""],description:n.localize(214,null)})),bracketPairColorization:Me(new ae),bracketPairGuides:Me(new ge),stickyTabStops:Me(new o(111,"stickyTabStops",!1,{description:n.localize(215,null)})),codeLens:Me(new o(15,"codeLens",!0,{description:n.localize(216,null)})),codeLensFontFamily:Me(new i(16,"codeLensFontFamily","",{description:n.localize(217,null)})),codeLensFontSize:Me(new D(17,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:n.localize(218,null)})),colorDecorators:Me(new o(18,"colorDecorators",!0,{description:n.localize(219,null)})),colorDecoratorsLimit:Me(new D(19,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:n.localize(220,null)})),columnSelection:Me(new o(20,"columnSelection",!1,{description:n.localize(221,null)})),comments:Me(new c),contextmenu:Me(new o(22,"contextmenu",!0)),copyWithSyntaxHighlighting:Me(new o(23,"copyWithSyntaxHighlighting",!0,{description:n.localize(222,null)})),cursorBlinking:Me(new s(24,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],m,{description:n.localize(223,null)})),cursorSmoothCaretAnimation:Me(new r(25,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[n.localize(224,null),n.localize(225,null),n.localize(226,null)],description:n.localize(227,null)})),cursorStyle:Me(new s(26,"cursorStyle",b.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],N,{description:n.localize(228,null)})),cursorSurroundingLines:Me(new D(27,"cursorSurroundingLines",0,0,1073741824,{description:n.localize(229,null)})),cursorSurroundingLinesStyle:Me(new r(28,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[n.localize(230,null),n.localize(231,null)],description:n.localize(232,null)})),cursorWidth:Me(new D(29,"cursorWidth",0,0,1073741824,{markdownDescription:n.localize(233,null)})),disableLayerHinting:Me(new o(30,"disableLayerHinting",!1)),disableMonospaceOptimizations:Me(new o(31,"disableMonospaceOptimizations",!1)),domReadOnly:Me(new o(32,"domReadOnly",!1)),dragAndDrop:Me(new o(33,"dragAndDrop",!0,{description:n.localize(234,null)})),emptySelectionClipboard:Me(new _),dropIntoEditor:Me(new Ye),stickyScroll:Me(new le),experimentalWhitespaceRendering:Me(new r(36,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[n.localize(235,null),n.localize(236,null),n.localize(237,null)],description:n.localize(238,null)})),extraEditorClassName:Me(new i(37,"extraEditorClassName","")),fastScrollSensitivity:Me(new v(38,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:n.localize(239,null)})),find:Me(new G),fixedOverflowWidgets:Me(new o(40,"fixedOverflowWidgets",!1)),folding:Me(new o(41,"folding",!0,{description:n.localize(240,null)})),foldingStrategy:Me(new r(42,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[n.localize(241,null),n.localize(242,null)],description:n.localize(243,null)})),foldingHighlight:Me(new o(43,"foldingHighlight",!0,{description:n.localize(244,null)})),foldingImportsByDefault:Me(new o(44,"foldingImportsByDefault",!1,{description:n.localize(245,null)})),foldingMaximumRegions:Me(new D(45,"foldingMaximumRegions",5e3,10,65e3,{description:n.localize(246,null)})),unfoldOnClickAfterEndOfLine:Me(new o(46,"unfoldOnClickAfterEndOfLine",!1,{description:n.localize(247,null)})),fontFamily:Me(new i(47,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:n.localize(248,null)})),fontInfo:Me(new X),fontLigatures2:Me(new $),fontSize:Me(new U),fontWeight:Me(new j),fontVariations:Me(new B),formatOnPaste:Me(new o(53,"formatOnPaste",!1,{description:n.localize(249,null)})),formatOnType:Me(new o(54,"formatOnType",!1,{description:n.localize(250,null)})),glyphMargin:Me(new o(55,"glyphMargin",!0,{description:n.localize(251,null)})),gotoLocation:Me(new Y),hideCursorInOverviewRuler:Me(new o(57,"hideCursorInOverviewRuler",!1,{description:n.localize(252,null)})),hover:Me(new pe),inDiffEditor:Me(new o(59,"inDiffEditor",!1)),letterSpacing:Me(new v(61,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>v.clamp(Z,-5,20),{description:n.localize(253,null)})),lightbulb:Me(new Re),lineDecorationsWidth:Me(new H),lineHeight:Me(new F),lineNumbers:Me(new ce),lineNumbersMinChars:Me(new D(66,"lineNumbersMinChars",5,1,300)),linkedEditing:Me(new o(67,"linkedEditing",!1,{description:n.localize(254,null)})),links:Me(new o(68,"links",!0,{description:n.localize(255,null)})),matchBrackets:Me(new r(69,"matchBrackets","always",["always","near","never"],{description:n.localize(256,null)})),minimap:Me(new Q),mouseStyle:Me(new r(71,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Me(new v(72,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:n.localize(257,null)})),mouseWheelZoom:Me(new o(73,"mouseWheelZoom",!1,{markdownDescription:n.localize(258,null)})),multiCursorMergeOverlapping:Me(new o(74,"multiCursorMergeOverlapping",!0,{description:n.localize(259,null)})),multiCursorModifier:Me(new s(75,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],me,{markdownEnumDescriptions:[n.localize(260,null),n.localize(261,null)],markdownDescription:n.localize(262,null)})),multiCursorPaste:Me(new r(76,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[n.localize(263,null),n.localize(264,null)],markdownDescription:n.localize(265,null)})),multiCursorLimit:Me(new D(77,"multiCursorLimit",1e4,1,1e5,{markdownDescription:n.localize(266,null)})),occurrencesHighlight:Me(new o(78,"occurrencesHighlight",!0,{description:n.localize(267,null)})),overviewRulerBorder:Me(new o(79,"overviewRulerBorder",!0,{description:n.localize(268,null)})),overviewRulerLanes:Me(new D(80,"overviewRulerLanes",3,0,3)),padding:Me(new Ce),parameterHints:Me(new De),peekWidgetDefaultFocus:Me(new r(83,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[n.localize(269,null),n.localize(270,null)],description:n.localize(271,null)})),definitionLinkOpensInPeek:Me(new o(84,"definitionLinkOpensInPeek",!1,{description:n.localize(272,null)})),quickSuggestions:Me(new ke),quickSuggestionsDelay:Me(new D(86,"quickSuggestionsDelay",10,0,1073741824,{description:n.localize(273,null)})),readOnly:Me(new o(87,"readOnly",!1)),renameOnType:Me(new o(88,"renameOnType",!1,{description:n.localize(274,null),markdownDeprecationMessage:n.localize(275,null)})),renderControlCharacters:Me(new o(89,"renderControlCharacters",!0,{description:n.localize(276,null),restricted:!0})),renderFinalNewline:Me(new r(90,"renderFinalNewline",P.isLinux?"dimmed":"on",["off","on","dimmed"],{description:n.localize(277,null)})),renderLineHighlight:Me(new r(91,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",n.localize(278,null)],description:n.localize(279,null)})),renderLineHighlightOnlyWhenFocus:Me(new o(92,"renderLineHighlightOnlyWhenFocus",!1,{description:n.localize(280,null)})),renderValidationDecorations:Me(new r(93,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Me(new r(94,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",n.localize(281,null),n.localize(282,null),n.localize(283,null),""],description:n.localize(284,null)})),revealHorizontalRightPadding:Me(new D(95,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Me(new o(96,"roundedSelection",!0,{description:n.localize(285,null)})),rulers:Me(new ne),scrollbar:Me(new W),scrollBeyondLastColumn:Me(new D(99,"scrollBeyondLastColumn",4,0,1073741824,{description:n.localize(286,null)})),scrollBeyondLastLine:Me(new o(100,"scrollBeyondLastLine",!0,{description:n.localize(287,null)})),scrollPredominantAxis:Me(new o(101,"scrollPredominantAxis",!0,{description:n.localize(288,null)})),selectionClipboard:Me(new o(102,"selectionClipboard",!0,{description:n.localize(289,null),included:P.isLinux})),selectionHighlight:Me(new o(103,"selectionHighlight",!0,{description:n.localize(290,null)})),selectOnLineNumbers:Me(new o(104,"selectOnLineNumbers",!0)),showFoldingControls:Me(new r(105,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[n.localize(291,null),n.localize(292,null),n.localize(293,null)],description:n.localize(294,null)})),showUnused:Me(new o(106,"showUnused",!0,{description:n.localize(295,null)})),showDeprecated:Me(new o(134,"showDeprecated",!0,{description:n.localize(296,null)})),inlayHints:Me(new ue),snippetSuggestions:Me(new r(107,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[n.localize(297,null),n.localize(298,null),n.localize(299,null),n.localize(300,null)],description:n.localize(301,null)})),smartSelect:Me(new ye),smoothScrolling:Me(new o(109,"smoothScrolling",!1,{description:n.localize(302,null)})),stopRenderingLineAfter:Me(new D(112,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Me(new we),inlineSuggest:Me(new x),suggestFontSize:Me(new D(114,"suggestFontSize",0,0,1e3,{markdownDescription:n.localize(303,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Me(new D(115,"suggestLineHeight",0,0,1e3,{markdownDescription:n.localize(304,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Me(new o(116,"suggestOnTriggerCharacters",!0,{description:n.localize(305,null)})),suggestSelection:Me(new r(117,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[n.localize(306,null),n.localize(307,null),n.localize(308,null)],description:n.localize(309,null)})),tabCompletion:Me(new r(118,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[n.localize(310,null),n.localize(311,null),n.localize(312,null)],description:n.localize(313,null)})),tabIndex:Me(new D(119,"tabIndex",0,-1,1073741824)),unicodeHighlight:Me(new q),unusualLineTerminators:Me(new r(121,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[n.localize(314,null),n.localize(315,null),n.localize(316,null)],description:n.localize(317,null)})),useShadowDOM:Me(new o(122,"useShadowDOM",!0)),useTabStops:Me(new o(123,"useTabStops",!0,{description:n.localize(318,null)})),wordBreak:Me(new r(124,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[n.localize(319,null),n.localize(320,null)],description:n.localize(321,null)})),wordSeparators:Me(new i(125,"wordSeparators",I.USUAL_WORD_SEPARATORS,{description:n.localize(322,null)})),wordWrap:Me(new r(126,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[n.localize(323,null),n.localize(324,null),n.localize(325,null),n.localize(326,null)],description:n.localize(327,null)})),wordWrapBreakAfterCharacters:Me(new i(127,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Me(new i(128,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Me(new D(129,"wordWrapColumn",80,1,1073741824,{markdownDescription:n.localize(328,null)})),wordWrapOverride1:Me(new r(130,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Me(new r(131,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Me(new V),defaultColorDecorators:Me(new o(141,"defaultColorDecorators",!1,{markdownDescription:n.localize(329,null)})),pixelRatio:Me(new be),tabFocusMode:Me(new o(138,"tabFocusMode",!1,{markdownDescription:n.localize(330,null)})),layoutInfo:Me(new he),wrappingInfo:Me(new et),wrappingIndent:Me(new je),wrappingStrategy:Me(new de)}}),define(Pe[136],Ae([10,11]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Pe[137],Ae([10,11]),function(te,e){return te.create("vs/platform/contextkey/common/contextkey",e)}),define(Pe[138],Ae([10,11]),function(te,e){return te.create("vs/platform/contextkey/common/scanner",e)}),define(Pe[139],Ae([10,11]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Pe[140],Ae([10,11]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(Pe[141],Ae([10,11]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(Pe[142],Ae([10,11]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(Pe[143],Ae([10,11]),function(te,e){return te.create("vs/platform/theme/common/iconRegistry",e)}),define(Pe[144],Ae([10,11]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(Pe[145],Ae([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Pe[146],Ae([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Pe[147],Ae([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostInteractiveSession",e)}),define(Pe[148],Ae([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Pe[149],Ae([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostLogService",e)}),define(Pe[150],Ae([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(Pe[151],Ae([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Pe[152],Ae([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Pe[153],Ae([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Pe[154],Ae([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Pe[155],Ae([10,11]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Pe[156],Ae([10,11]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(Pe[157],Ae([10,11]),function(te,e){return te.create("vs/workbench/common/views",e)}),define(Pe[158],Ae([10,11]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Pe[159],Ae([10,11]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(Pe[160],Ae([10,11]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Pe[161],Ae([10,11]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Pe[162],Ae([10,11]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Pe[163],Ae([10,11]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Pe[164],Ae([10,11]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Pe[165],Ae([1,0,9,138]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var I;(function(h){h[h.LParen=0]="LParen",h[h.RParen=1]="RParen",h[h.Neg=2]="Neg",h[h.Eq=3]="Eq",h[h.NotEq=4]="NotEq",h[h.Lt=5]="Lt",h[h.LtEq=6]="LtEq",h[h.Gt=7]="Gt",h[h.GtEq=8]="GtEq",h[h.RegexOp=9]="RegexOp",h[h.RegexStr=10]="RegexStr",h[h.True=11]="True",h[h.False=12]="False",h[h.In=13]="In",h[h.Not=14]="Not",h[h.And=15]="And",h[h.Or=16]="Or",h[h.Str=17]="Str",h[h.QuotedStr=18]="QuotedStr",h[h.Error=19]="Error",h[h.EOF=20]="EOF"})(I||(e.TokenType=I={}));function L(...h){switch(h.length){case 1:return(0,P.localize)(0,null,h[0]);case 2:return(0,P.localize)(1,null,h[0],h[1]);case 3:return(0,P.localize)(2,null,h[0],h[1],h[2]);default:return}}const R=(0,P.localize)(3,null),A=(0,P.localize)(4,null);class y{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(O){switch(O.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return O.isTripleEq?"===":"==";case 4:return O.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return O.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return O.lexeme;case 18:return O.lexeme;case 19:return O.lexeme;case 20:return"EOF";default:throw(0,n.illegalState)(`unhandled token type: ${JSON.stringify(O)}; have you forgotten to add a case?`)}}get errors(){return this.g}reset(O){return this.c=O,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const w=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:w})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const w=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:w})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(O){return this.r()||this.c.charCodeAt(this.e)!==O?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(O){this.f.push({type:O,offset:this.d})}l(O){const w=this.d,g=this.c.substring(this.d,this.e),S={type:19,offset:this.d,lexeme:g};this.g.push({offset:w,lexeme:g,additionalInfo:O}),this.f.push(S)}n(){this.m.lastIndex=this.d;const O=this.m.exec(this.c);if(O){this.e=this.d+O[0].length;const w=this.c.substring(this.d,this.e),g=y.b.get(w);g?this.k(g):this.f.push({type:17,lexeme:w,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(R);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let O=this.e,w=!1,g=!1;for(;;){if(O>=this.c.length){this.e=O,this.l(A);return}const p=this.c.charCodeAt(O);if(w)w=!1;else if(p===47&&!g){O++;break}else p===91?g=!0:p===92?w=!0:p===93&&(g=!1);O++}for(;O<this.c.length&&y.a.has(this.c.charCodeAt(O));)O++;this.e=O;const S=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:S,offset:this.d})}r(){return this.e>=this.c.length}}e.Scanner=y,y.a=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0))),y.b=new Map([["not",14],["in",13],["false",12],["true",11]])}),define(Pe[166],Ae([1,0,22,29,140,268]),function(te,e,n,P,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const R=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(o){return o=o.trim(),o==="*"||R.test(o)}e.isValidVersionStr=y;function h(o){if(!y(o))return null;if(o=o.trim(),o==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const d=o.match(R);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=h;function O(o){if(!o)return null;const d=o.majorBase,D=o.majorMustEqual,T=o.minorBase;let v=o.minorMustEqual;const i=o.patchBase;let a=o.patchMustEqual;o.hasCaret&&(d===0||(v=!1),a=!1);let r=0;if(o.preRelease){const s=A.exec(o.preRelease);if(s){const[,E,k,c]=s;r=Date.UTC(Number(E),Number(k)-1,Number(c))}}return{majorBase:d,majorMustEqual:D,minorBase:T,minorMustEqual:v,patchBase:i,patchMustEqual:a,isMinimum:o.hasGreaterEquals,notBefore:r}}e.normalizeVersion=O;function w(o,d,D){let T;typeof o=="string"?T=O(h(o)):T=o;let v;d instanceof Date?v=d.getTime():typeof d=="string"&&(v=new Date(d).getTime());let i;if(typeof D=="string"?i=O(h(D)):i=D,!T||!i)return!1;const a=T.majorBase,r=T.minorBase,s=T.patchBase;let E=i.majorBase,k=i.minorBase,c=i.patchBase;const u=i.notBefore;let m=i.majorMustEqual,b=i.minorMustEqual,f=i.patchMustEqual;return i.isMinimum?a>E?!0:a<E?!1:r>k?!0:r<k||v&&v<u?!1:s>=c:(a===1&&E===0&&(!m||!b||!f)&&(E=1,k=0,c=0,m=!0,b=!1,f=!1),a<E?!1:a>E?!m:r<k?!1:r>k?!b:s<c?!1:s>c?!f:!(v&&v<u))}e.isValidVersion=w;function g(o,d,D,T,v){const i=[];if(typeof T.publisher<"u"&&typeof T.publisher!="string")return i.push([P.default.Error,I.localize(0,null)]),i;if(typeof T.name!="string")return i.push([P.default.Error,I.localize(1,null,"name")]),i;if(typeof T.version!="string")return i.push([P.default.Error,I.localize(2,null,"version")]),i;if(!T.engines)return i.push([P.default.Error,I.localize(3,null,"engines")]),i;if(typeof T.engines.vscode!="string")return i.push([P.default.Error,I.localize(4,null,"engines.vscode")]),i;if(typeof T.extensionDependencies<"u"&&!t(T.extensionDependencies))return i.push([P.default.Error,I.localize(5,null,"extensionDependencies")]),i;if(typeof T.activationEvents<"u"){if(!t(T.activationEvents))return i.push([P.default.Error,I.localize(6,null,"activationEvents")]),i;if(typeof T.main>"u"&&typeof T.browser>"u")return i.push([P.default.Error,I.localize(7,null,"activationEvents","main","browser")]),i}if(typeof T.extensionKind<"u"&&typeof T.main>"u"&&i.push([P.default.Warning,I.localize(8,null,"extensionKind")]),typeof T.main<"u"){if(typeof T.main!="string")return i.push([P.default.Error,I.localize(9,null,"main")]),i;{const s=(0,n.joinPath)(D,T.main);(0,n.isEqualOrParent)(s,D)||i.push([P.default.Warning,I.localize(10,null,s.path,D.path)])}}if(typeof T.browser<"u"){if(typeof T.browser!="string")return i.push([P.default.Error,I.localize(11,null,"browser")]),i;{const s=(0,n.joinPath)(D,T.browser);(0,n.isEqualOrParent)(s,D)||i.push([P.default.Warning,I.localize(12,null,s.path,D.path)])}}if(!L.valid(T.version))return i.push([P.default.Error,I.localize(13,null)]),i;const a=[];if(!S(o,d,T,v,a))for(const s of a)i.push([P.default.Error,s]);return i}e.validateExtensionManifest=g;function S(o,d,D,T,v){return T||typeof D.main>"u"&&typeof D.browser>"u"?!0:l(o,d,D.engines.vscode,v)}e.isValidExtensionVersion=S;function p(o,d,D){return o==="*"||l(d,D,o)}e.isEngineValid=p;function l(o,d,D,T=[]){const v=O(h(D));if(!v)return T.push(I.localize(14,null,D)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return T.push(I.localize(15,null,D)),!1}else if(!v.majorMustEqual)return T.push(I.localize(16,null,D)),!1;return w(o,d,v)?!0:(T.push(I.localize(17,null,o,D)),!1)}function t(o){if(!Array.isArray(o))return!1;for(let d=0,D=o.length;d<D;d++)if(typeof o[d]!="string")return!1;return!0}}),define(Pe[68],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class n{constructor(I,L=[],R=!1){this.ctor=I,this.staticArguments=L,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=n}),define(Pe[69],Ae([1,0,68]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const P=[];var I;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function L(A,y,h){y instanceof n.SyncDescriptor||(y=new n.SyncDescriptor(y,[],!!h)),P.push([A,y])}e.registerSingleton=L;function R(){return P}e.getSingletonServiceDescriptors=R}),define(Pe[167],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class n{constructor(L,R){this.key=L,this.data=R,this.incoming=new Map,this.outgoing=new Map}}e.Node=n;class P{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const R of this.a.values())R.outgoing.size===0&&L.push(R);return L}insertEdge(L,R){const A=this.lookupOrInsertNode(L),y=this.lookupOrInsertNode(R);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(L){const R=this.b(L);this.a.delete(R);for(const A of this.a.values())A.outgoing.delete(R),A.incoming.delete(R)}lookupOrInsertNode(L){const R=this.b(L);let A=this.a.get(R);return A||(A=new n(R,L),this.a.set(R,A)),A}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[R,A]of this.a)L.push(`${R}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,R]of this.a){const A=new Set([L]),y=this.c(R,A);if(y)return y}}c(L,R){for(const[A,y]of L.outgoing){if(R.has(A))return[...R,A].join(" -> ");R.add(A);const h=this.c(y,R);if(h)return h;R.delete(A)}}}e.Graph=P}),define(Pe[3],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var n;(function(R){R.serviceIds=new Map,R.DI_TARGET="$di$target",R.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[R.DI_DEPENDENCIES]||[]}R.getServiceDependencies=A})(n||(e._util=n={})),e.IInstantiationService=I("instantiationService");function P(R,A,y){A[n.DI_TARGET]===A?A[n.DI_DEPENDENCIES].push({id:R,index:y}):(A[n.DI_DEPENDENCIES]=[{id:R,index:y}],A[n.DI_TARGET]=A)}function I(R){if(n.serviceIds.has(R))return n.serviceIds.get(R);const A=function(y,h,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(A,y,O)};return A.toString=()=>R,n.serviceIds.set(R,A),A}e.createDecorator=I;function L(R){return R}e.refineServiceDecorator=L}),define(Pe[42],Ae([1,0,12,2,3]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,I.createDecorator)("configurationService");function L(t){return t&&typeof t=="object"&&(!t.overrideIdentifier||typeof t.overrideIdentifier=="string")&&(!t.resource||t.resource instanceof P.URI)}e.isConfigurationOverrides=L;function R(t){return t&&typeof t=="object"&&(!t.overrideIdentifiers||Array.isArray(t.overrideIdentifiers))&&!t.overrideIdentifier&&(!t.resource||t.resource instanceof P.URI)}e.isConfigurationUpdateOverrides=R;var A;(function(t){t[t.APPLICATION=1]="APPLICATION",t[t.USER=2]="USER",t[t.USER_LOCAL=3]="USER_LOCAL",t[t.USER_REMOTE=4]="USER_REMOTE",t[t.WORKSPACE=5]="WORKSPACE",t[t.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",t[t.DEFAULT=7]="DEFAULT",t[t.MEMORY=8]="MEMORY"})(A||(e.ConfigurationTarget=A={}));function y(t){switch(t){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function h(t,o){const d=Object.create(null);for(const D in t)O(d,D,t[D],o);return d}e.toValuesTree=h;function O(t,o,d,D){const T=o.split("."),v=T.pop();let i=t;for(let a=0;a<T.length;a++){const r=T[a];let s=i[r];switch(typeof s){case"undefined":s=i[r]=Object.create(null);break;case"object":break;default:D(`Ignoring ${o} as ${T.slice(0,a+1).join(".")} is ${JSON.stringify(s)}`);return}i=s}if(typeof i=="object"&&i!==null)try{i[v]=d}catch{D(`Ignoring ${o} as ${T.join(".")} is ${JSON.stringify(i)}`)}else D(`Ignoring ${o} as ${T.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=O;function w(t,o){const d=o.split(".");g(t,d)}e.removeFromValueTree=w;function g(t,o){const d=o.shift();if(o.length===0){delete t[d];return}if(Object.keys(t).indexOf(d)!==-1){const D=t[d];typeof D=="object"&&!Array.isArray(D)&&(g(D,o),Object.keys(D).length===0&&delete t[d])}}function S(t,o,d){function D(i,a){let r=i;for(const s of a){if(typeof r!="object"||r===null)return;r=r[s]}return r}const T=o.split("."),v=D(t,T);return typeof v>"u"?d:v}e.getConfigurationValue=S;function p(t,o,d){Object.keys(o).forEach(D=>{D!=="__proto__"&&(D in t?n.isObject(t[D])&&n.isObject(o[D])?p(t[D],o[D],d):d&&(t[D]=o[D]):t[D]=o[D])})}e.merge=p;function l(t){return t.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=l}),define(Pe[31],Ae([1,0,20,13,165,3,137,9]),function(te,e,n,P,I,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.validateWhenClauses=e.ContextKeyExpr=e.Parser=e.ContextKeyExprType=e.setConstant=void 0;const y=new Map;y.set("false",!1),y.set("true",!0),y.set("isMac",n.isMacintosh),y.set("isLinux",n.isLinux),y.set("isWindows",n.isWindows),y.set("isWeb",n.isWeb),y.set("isMacNative",n.isMacintosh&&!n.isWeb),y.set("isEdge",n.isEdge),y.set("isFirefox",n.isFirefox),y.set("isChrome",n.isChrome),y.set("isSafari",n.isSafari);function h(H,F){if(y.get(H)!==void 0)throw(0,A.illegalArgument)("contextkey.setConstant(k, v) invoked with already set constant `k`");y.set(H,F)}e.setConstant=h;const O=Object.prototype.hasOwnProperty;var w;(function(H){H[H.False=0]="False",H[H.True=1]="True",H[H.Defined=2]="Defined",H[H.Not=3]="Not",H[H.Equals=4]="Equals",H[H.NotEquals=5]="NotEquals",H[H.And=6]="And",H[H.Regex=7]="Regex",H[H.NotRegex=8]="NotRegex",H[H.Or=9]="Or",H[H.In=10]="In",H[H.NotIn=11]="NotIn",H[H.Greater=12]="Greater",H[H.GreaterEquals=13]="GreaterEquals",H[H.Smaller=14]="Smaller",H[H.SmallerEquals=15]="SmallerEquals"})(w||(e.ContextKeyExprType=w={}));const g={regexParsingWithErrorRecovery:!0},S=(0,R.localize)(0,null),p=(0,R.localize)(1,null),l=(0,R.localize)(2,null),t=(0,R.localize)(3,null),o=(0,R.localize)(4,null),d=(0,R.localize)(5,null),D=(0,R.localize)(6,null),T=(0,R.localize)(7,null);class v{get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(F=g){this.k=F,this.d=new I.Scanner,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(F){if(F===""){this.h.push({message:S,offset:0,lexeme:"",additionalInfo:p});return}this.f=this.d.reset(F).scan(),this.g=0,this.h=[];try{const Q=this.l();if(!this.E()){const me=this.D(),Ce=me.type===17?d:void 0;throw this.h.push({message:o,offset:me.offset,lexeme:I.Scanner.getLexeme(me),additionalInfo:Ce}),v.c}return Q}catch(Q){if(Q!==v.c)throw Q;return}}l(){return this.m()}m(){const F=[this.o()];for(;this.y(16);){const Q=this.o();F.push(Q)}return F.length===1?F[0]:i.or(...F)}o(){const F=[this.s()];for(;this.y(15);){const Q=this.s();F.push(Q)}return F.length===1?F[0]:i.and(...F)}s(){if(this.y(2)){const F=this.D();switch(F.type){case 11:return this.z(),E.INSTANCE;case 12:return this.z(),k.INSTANCE;case 0:{this.z();const Q=this.l();return this.A(1,t),Q?.negate()}case 17:return this.z(),N.create(F.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",F)}}return this.t()}t(){const F=this.D();switch(F.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const Q=this.l();return this.A(1,t),Q}case 17:{const Q=F.lexeme;if(this.z(),this.y(9)){const Ce=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Ce.type!==10)throw this.B("REGEX",Ce);const De=Ce.lexeme,be=De.lastIndexOf("/"),ke=be===De.length-1?void 0:this.w(De.substring(be+1));let oe;try{oe=new RegExp(De.substring(1,be),ke)}catch{throw this.B("REGEX",Ce)}return X.create(Q,oe)}switch(Ce.type){case 10:case 19:{const De=[Ce.lexeme];this.z();let be=this.D(),ke=0;for(let C=0;C<Ce.lexeme.length;C++)Ce.lexeme.charCodeAt(C)===40?ke++:Ce.lexeme.charCodeAt(C)===41&&ke--;for(;!this.E()&&be.type!==15&&be.type!==16;){switch(be.type){case 0:ke++;break;case 1:ke--;break;case 10:case 18:for(let C=0;C<be.lexeme.length;C++)be.lexeme.charCodeAt(C)===40?ke++:Ce.lexeme.charCodeAt(C)===41&&ke--}if(ke<0)break;De.push(I.Scanner.getLexeme(be)),this.z(),be=this.D()}const oe=De.join(""),ce=oe.lastIndexOf("/"),ie=ce===oe.length-1?void 0:this.w(oe.substring(ce+1));let ne;try{ne=new RegExp(oe.substring(1,ce),ie)}catch{throw this.B("REGEX",Ce)}return i.regex(Q,ne)}case 18:{const De=Ce.lexeme;this.z();let be=null;if(!(0,P.isFalsyOrWhitespace)(De)){const ke=De.indexOf("/"),oe=De.lastIndexOf("/");if(ke!==oe&&ke>=0){const ce=De.slice(ke+1,oe),ie=De[oe+1]==="i"?"i":"";try{be=new RegExp(ce,ie)}catch{throw this.B("REGEX",Ce)}}}if(be===null)throw this.B("REGEX",Ce);return X.create(Q,be)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,l);const Ce=this.u();return i.notIn(Q,Ce)}switch(this.D().type){case 3:{this.z();const Ce=this.u();if(this.x().type===18)return i.equals(Q,Ce);switch(Ce){case"true":return i.has(Q);case"false":return i.not(Q);default:return i.equals(Q,Ce)}}case 4:{this.z();const Ce=this.u();if(this.x().type===18)return i.notEquals(Q,Ce);switch(Ce){case"true":return i.not(Q);case"false":return i.has(Q);default:return i.notEquals(Q,Ce)}}case 5:return this.z(),$.create(Q,this.u());case 6:return this.z(),B.create(Q,this.u());case 7:return this.z(),_.create(Q,this.u());case 8:return this.z(),G.create(Q,this.u());case 13:return this.z(),i.in(Q,this.u());default:return i.has(Q)}}case 20:throw this.h.push({message:D,offset:F.offset,lexeme:"",additionalInfo:T}),v.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const F=this.D();switch(F.type){case 17:case 18:return this.z(),F.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(F){return F.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(F){return this.C(F)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(F,Q){if(this.C(F))return this.z();throw this.B(Q,this.D())}B(F,Q,me){const Ce=(0,R.localize)(8,null,F,I.Scanner.getLexeme(Q)),De=Q.offset,be=I.Scanner.getLexeme(Q);return this.h.push({message:Ce,offset:De,lexeme:be,additionalInfo:me}),v.c}C(F){return this.D().type===F}D(){return this.f[this.g]}E(){return this.D().type===20}}e.Parser=v,v.c=new Error;class i{static false(){return E.INSTANCE}static true(){return k.INSTANCE}static has(F){return c.create(F)}static equals(F,Q){return u.create(F,Q)}static notEquals(F,Q){return f.create(F,Q)}static regex(F,Q){return X.create(F,Q)}static in(F,Q){return m.create(F,Q)}static notIn(F,Q){return b.create(F,Q)}static not(F){return N.create(F)}static and(...F){return Y.create(F,null,!0)}static or(...F){return pe.create(F,null,!0)}static greater(F,Q){return _.create(F,Q)}static greaterEquals(F,Q){return G.create(F,Q)}static smaller(F,Q){return $.create(F,Q)}static smallerEquals(F,Q){return B.create(F,Q)}static deserialize(F){return F==null?void 0:this.c.parse(F)}}e.ContextKeyExpr=i,i.c=new v({regexParsingWithErrorRecovery:!1});function a(H){const F=new v({regexParsingWithErrorRecovery:!1});return H.map(Q=>(F.parse(Q),F.lexingErrors.length>0?F.lexingErrors.map(me=>({errorMessage:me.additionalInfo?(0,R.localize)(9,null,me.additionalInfo):(0,R.localize)(10,null),offset:me.offset,length:me.lexeme.length})):F.parsingErrors.length>0?F.parsingErrors.map(me=>({errorMessage:me.additionalInfo?`${me.message}. ${me.additionalInfo}`:me.message,offset:me.offset,length:me.lexeme.length})):[]))}e.validateWhenClauses=a;function r(H,F){const Q=H?H.substituteConstants():void 0,me=F?F.substituteConstants():void 0;return!Q&&!me?!0:!Q||!me?!1:Q.equals(me)}e.expressionsAreEqualWithConstantSubstitution=r;function s(H,F){return H.cmp(F)}class E{constructor(){this.type=0}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!1}serialize(){return"false"}keys(){return[]}map(F){return this}negate(){return k.INSTANCE}}e.ContextKeyFalseExpr=E,E.INSTANCE=new E;class k{constructor(){this.type=1}cmp(F){return this.type-F.type}equals(F){return F.type===this.type}substituteConstants(){return this}evaluate(F){return!0}serialize(){return"true"}keys(){return[]}map(F){return this}negate(){return E.INSTANCE}}e.ContextKeyTrueExpr=k,k.INSTANCE=new k;class c{static create(F,Q=null){const me=y.get(F);return typeof me=="boolean"?me?k.INSTANCE:E.INSTANCE:new c(F,Q)}constructor(F,Q){this.key=F,this.c=Q,this.type=2}cmp(F){return F.type!==this.type?this.type-F.type:he(this.key,F.key)}equals(F){return F.type===this.type?this.key===F.key:!1}substituteConstants(){const F=y.get(this.key);return typeof F=="boolean"?F?k.INSTANCE:E.INSTANCE:this}evaluate(F){return!!F.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(F){return F.mapDefined(this.key)}negate(){return this.c||(this.c=N.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=c;class u{static create(F,Q,me=null){if(typeof Q=="boolean")return Q?c.create(F,me):N.create(F,me);const Ce=y.get(F);return typeof Ce=="boolean"?Q===(Ce?"true":"false")?k.INSTANCE:E.INSTANCE:new u(F,Q,me)}constructor(F,Q,me){this.c=F,this.d=Q,this.f=me,this.type=4}cmp(F){return F.type!==this.type?this.type-F.type:de(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=y.get(this.c);if(typeof F=="boolean"){const Q=F?"true":"false";return this.d===Q?k.INSTANCE:E.INSTANCE}return this}evaluate(F){return F.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(F){return F.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=f.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=u;class m{static create(F,Q){return new m(F,Q)}constructor(F,Q){this.d=F,this.f=Q,this.type=10,this.c=null}cmp(F){return F.type!==this.type?this.type-F.type:de(this.d,this.f,F.d,F.f)}equals(F){return F.type===this.type?this.d===F.d&&this.f===F.f:!1}substituteConstants(){return this}evaluate(F){const Q=F.getValue(this.f),me=F.getValue(this.d);return Array.isArray(Q)?Q.includes(me):typeof me=="string"&&typeof Q=="object"&&Q!==null?O.call(Q,me):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(F){return F.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=m;class b{static create(F,Q){return new b(F,Q)}constructor(F,Q){this.d=F,this.f=Q,this.type=11,this.c=m.create(F,Q)}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(F){return F.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=b;class f{static create(F,Q,me=null){if(typeof Q=="boolean")return Q?N.create(F,me):c.create(F,me);const Ce=y.get(F);return typeof Ce=="boolean"?Q===(Ce?"true":"false")?E.INSTANCE:k.INSTANCE:new f(F,Q,me)}constructor(F,Q,me){this.c=F,this.d=Q,this.f=me,this.type=5}cmp(F){return F.type!==this.type?this.type-F.type:de(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){const F=y.get(this.c);if(typeof F=="boolean"){const Q=F?"true":"false";return this.d===Q?E.INSTANCE:k.INSTANCE}return this}evaluate(F){return F.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(F){return F.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=u.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=f;class N{static create(F,Q=null){const me=y.get(F);return typeof me=="boolean"?me?E.INSTANCE:k.INSTANCE:new N(F,Q)}constructor(F,Q){this.c=F,this.d=Q,this.type=3}cmp(F){return F.type!==this.type?this.type-F.type:he(this.c,F.c)}equals(F){return F.type===this.type?this.c===F.c:!1}substituteConstants(){const F=y.get(this.c);return typeof F=="boolean"?F?E.INSTANCE:k.INSTANCE:this}evaluate(F){return!F.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(F){return F.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.ContextKeyNotExpr=N;function V(H,F){if(typeof H=="string"){const Q=parseFloat(H);isNaN(Q)||(H=Q)}return typeof H=="string"||typeof H=="number"?F(H):E.INSTANCE}class _{static create(F,Q,me=null){return V(Q,Ce=>new _(F,Ce,me))}constructor(F,Q,me){this.c=F,this.d=Q,this.f=me,this.type=12}cmp(F){return F.type!==this.type?this.type-F.type:de(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=B.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=_;class G{static create(F,Q,me=null){return V(Q,Ce=>new G(F,Ce,me))}constructor(F,Q,me){this.c=F,this.d=Q,this.f=me,this.type=13}cmp(F){return F.type!==this.type?this.type-F.type:de(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(F){return F.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=$.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=G;class ${static create(F,Q,me=null){return V(Q,Ce=>new $(F,Ce,me))}constructor(F,Q,me){this.c=F,this.d=Q,this.f=me,this.type=14}cmp(F){return F.type!==this.type?this.type-F.type:de(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=G.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=$;class B{static create(F,Q,me=null){return V(Q,Ce=>new B(F,Ce,me))}constructor(F,Q,me){this.c=F,this.d=Q,this.f=me,this.type=15}cmp(F){return F.type!==this.type?this.type-F.type:de(this.c,this.d,F.c,F.d)}equals(F){return F.type===this.type?this.c===F.c&&this.d===F.d:!1}substituteConstants(){return this}evaluate(F){return typeof this.d=="string"?!1:parseFloat(F.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(F){return F.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=_.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=B;class X{static create(F,Q){return new X(F,Q)}constructor(F,Q){this.d=F,this.f=Q,this.type=7,this.c=null}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.d<F.d)return-1;if(this.d>F.d)return 1;const Q=this.f?this.f.source:"",me=F.f?F.f.source:"";return Q<me?-1:Q>me?1:0}equals(F){if(F.type===this.type){const Q=this.f?this.f.source:"",me=F.f?F.f.source:"";return this.d===F.d&&Q===me}return!1}substituteConstants(){return this}evaluate(F){const Q=F.getValue(this.d);return this.f?this.f.test(Q):!1}serialize(){const F=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${F}`}keys(){return[this.d]}map(F){return F.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=U.create(this)),this.c}}e.ContextKeyRegexExpr=X;class U{static create(F){return new U(F)}constructor(F){this.c=F,this.type=8}cmp(F){return F.type!==this.type?this.type-F.type:this.c.cmp(F.c)}equals(F){return F.type===this.type?this.c.equals(F.c):!1}substituteConstants(){return this}evaluate(F){return!this.c.evaluate(F)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(F){return new U(this.c.map(F))}negate(){return this.c}}e.ContextKeyNotRegexExpr=U;function j(H){let F=null;for(let Q=0,me=H.length;Q<me;Q++){const Ce=H[Q].substituteConstants();if(H[Q]!==Ce&&F===null){F=[];for(let De=0;De<Q;De++)F[De]=H[De]}F!==null&&(F[Q]=Ce)}return F===null?H:F}class Y{static create(F,Q,me){return Y.d(F,Q,me)}constructor(F,Q){this.expr=F,this.c=Q,this.type=6}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let Q=0,me=this.expr.length;Q<me;Q++){const Ce=s(this.expr[Q],F.expr[Q]);if(Ce!==0)return Ce}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let Q=0,me=this.expr.length;Q<me;Q++)if(!this.expr[Q].equals(F.expr[Q]))return!1;return!0}return!1}substituteConstants(){const F=j(this.expr);return F===this.expr?this:Y.create(F,this.c,!1)}evaluate(F){for(let Q=0,me=this.expr.length;Q<me;Q++)if(!this.expr[Q].evaluate(F))return!1;return!0}static d(F,Q,me){const Ce=[];let De=!1;for(const be of F)if(be){if(be.type===1){De=!0;continue}if(be.type===0)return E.INSTANCE;if(be.type===6){Ce.push(...be.expr);continue}Ce.push(be)}if(Ce.length===0&&De)return k.INSTANCE;if(Ce.length!==0){if(Ce.length===1)return Ce[0];Ce.sort(s);for(let be=1;be<Ce.length;be++)Ce[be-1].equals(Ce[be])&&(Ce.splice(be,1),be--);if(Ce.length===1)return Ce[0];for(;Ce.length>1;){const be=Ce[Ce.length-1];if(be.type!==9)break;Ce.pop();const ke=Ce.pop(),oe=Ce.length===0,ce=pe.create(be.expr.map(ie=>Y.create([ie,ke],null,me)),null,oe);ce&&(Ce.push(ce),Ce.sort(s))}if(Ce.length===1)return Ce[0];if(me){for(let be=0;be<Ce.length;be++)for(let ke=be+1;ke<Ce.length;ke++)if(Ce[be].negate().equals(Ce[ke]))return E.INSTANCE;if(Ce.length===1)return Ce[0]}return new Y(Ce,Q)}}serialize(){return this.expr.map(F=>F.serialize()).join(" && ")}keys(){const F=[];for(const Q of this.expr)F.push(...Q.keys());return F}map(F){return new Y(this.expr.map(Q=>Q.map(F)),null)}negate(){if(!this.c){const F=[];for(const Q of this.expr)F.push(Q.negate());this.c=pe.create(F,this,!0)}return this.c}}e.ContextKeyAndExpr=Y;class pe{static create(F,Q,me){return pe.d(F,Q,me)}constructor(F,Q){this.expr=F,this.c=Q,this.type=9}cmp(F){if(F.type!==this.type)return this.type-F.type;if(this.expr.length<F.expr.length)return-1;if(this.expr.length>F.expr.length)return 1;for(let Q=0,me=this.expr.length;Q<me;Q++){const Ce=s(this.expr[Q],F.expr[Q]);if(Ce!==0)return Ce}return 0}equals(F){if(F.type===this.type){if(this.expr.length!==F.expr.length)return!1;for(let Q=0,me=this.expr.length;Q<me;Q++)if(!this.expr[Q].equals(F.expr[Q]))return!1;return!0}return!1}substituteConstants(){const F=j(this.expr);return F===this.expr?this:pe.create(F,this.c,!1)}evaluate(F){for(let Q=0,me=this.expr.length;Q<me;Q++)if(this.expr[Q].evaluate(F))return!0;return!1}static d(F,Q,me){let Ce=[],De=!1;if(F){for(let be=0,ke=F.length;be<ke;be++){const oe=F[be];if(oe){if(oe.type===0){De=!0;continue}if(oe.type===1)return k.INSTANCE;if(oe.type===9){Ce=Ce.concat(oe.expr);continue}Ce.push(oe)}}if(Ce.length===0&&De)return E.INSTANCE;Ce.sort(s)}if(Ce.length!==0){if(Ce.length===1)return Ce[0];for(let be=1;be<Ce.length;be++)Ce[be-1].equals(Ce[be])&&(Ce.splice(be,1),be--);if(Ce.length===1)return Ce[0];if(me){for(let be=0;be<Ce.length;be++)for(let ke=be+1;ke<Ce.length;ke++)if(Ce[be].negate().equals(Ce[ke]))return k.INSTANCE;if(Ce.length===1)return Ce[0]}return new pe(Ce,Q)}}serialize(){return this.expr.map(F=>F.serialize()).join(" || ")}keys(){const F=[];for(const Q of this.expr)F.push(...Q.keys());return F}map(F){return new pe(this.expr.map(Q=>Q.map(F)),null)}negate(){if(!this.c){const F=[];for(const Q of this.expr)F.push(Q.negate());for(;F.length>1;){const Q=F.shift(),me=F.shift(),Ce=[];for(const De of ue(Q))for(const be of ue(me))Ce.push(Y.create([De,be],null,!1));F.unshift(pe.create(Ce,null,!1))}this.c=pe.create(F,this,!0)}return this.c}}e.ContextKeyOrExpr=pe;class Ee extends c{static all(){return Ee.d.values()}constructor(F,Q,me){super(F,null),this.f=Q,typeof me=="object"?Ee.d.push({...me,key:F}):me!==!0&&Ee.d.push({key:F,description:me,type:Q!=null?typeof Q:void 0})}bindTo(F){return F.createKey(this.key,this.f)}getValue(F){return F.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(F){return u.create(this.key,F)}notEqualsTo(F){return f.create(this.key,F)}}e.RawContextKey=Ee,Ee.d=[],e.IContextKeyService=(0,L.createDecorator)("contextKeyService");function he(H,F){return H<F?-1:H>F?1:0}function de(H,F,Q,me){return H<Q?-1:H>Q?1:F<me?-1:F>me?1:0}function Re(H,F){if(H.type===0||F.type===1)return!0;if(H.type===9)return F.type===9?le(H.expr,F.expr):!1;if(F.type===9){for(const Q of F.expr)if(Re(H,Q))return!0;return!1}if(H.type===6){if(F.type===6)return le(F.expr,H.expr);for(const Q of H.expr)if(Re(Q,F))return!0;return!1}return H.equals(F)}e.implies=Re;function le(H,F){let Q=0,me=0;for(;Q<H.length&&me<F.length;){const Ce=H[Q].cmp(F[me]);if(Ce<0)return!1;Ce===0&&Q++,me++}return Q===H.length}function ue(H){return H.type===9?H.expr:[H]}}),define(Pe[168],Ae([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,n.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,n.refineServiceDecorator)(e.IEnvironmentService)}),define(Pe[91],Ae([1,0,139,3]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionSignaturetErrorCode=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function I(d){switch(d){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=I;function L(d){switch(d){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function R(d,D){switch(d){case 3:return D==="x64"?"win32-x64":D==="ia32"?"win32-ia32":D==="arm64"?"win32-arm64":"unknown";case 2:return D==="x64"?"linux-x64":D==="arm64"?"linux-arm64":D==="arm"?"linux-armhf":"unknown";case"alpine":return D==="x64"?"alpine-x64":D==="arm64"?"alpine-arm64":"unknown";case 1:return D==="x64"?"darwin-x64":D==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=R;function A(d,D){return D==="web"&&!d.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(d,D,T){return A(D,T)?!1:d==="undefined"||d==="universal"?!0:d==="unknown"?!1:d===T?!0:h(T).includes(d)}e.isTargetPlatformCompatible=y;function h(d){switch(d){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=h;function O(d){return d&&typeof d=="object"&&typeof d.id=="string"&&(!d.uuid||typeof d.uuid=="string")}e.isIExtensionIdentifier=O;var w;(function(d){d[d.NoneOrRelevance=0]="NoneOrRelevance",d[d.LastUpdatedDate=1]="LastUpdatedDate",d[d.Title=2]="Title",d[d.PublisherName=3]="PublisherName",d[d.InstallCount=4]="InstallCount",d[d.PublishedDate=10]="PublishedDate",d[d.AverageRating=6]="AverageRating",d[d.WeightedRating=12]="WeightedRating"})(w||(e.SortBy=w={}));var g;(function(d){d[d.Default=0]="Default",d[d.Ascending=1]="Ascending",d[d.Descending=2]="Descending"})(g||(e.SortOrder=g={}));var S;(function(d){d.Install="install",d.Uninstall="uninstall"})(S||(e.StatisticType=S={}));var p;(function(d){d[d.None=1]="None",d[d.Install=2]="Install",d[d.Update=3]="Update",d[d.Migrate=4]="Migrate"})(p||(e.InstallOperation=p={})),e.IExtensionGalleryService=(0,P.createDecorator)("extensionGalleryService");var l;(function(d){d.Unsupported="Unsupported",d.Deprecated="Deprecated",d.Malicious="Malicious",d.Incompatible="Incompatible",d.IncompatiblePreRelease="IncompatiblePreRelease",d.IncompatibleTargetPlatform="IncompatibleTargetPlatform",d.ReleaseVersionNotFound="ReleaseVersionNotFound",d.Invalid="Invalid",d.Download="Download",d.Extract="Extract",d.Delete="Delete",d.Rename="Rename",d.CorruptZip="CorruptZip",d.IncompleteZip="IncompleteZip",d.Signature="Signature",d.Internal="Internal"})(l||(e.ExtensionManagementErrorCode=l={}));var t;(function(d){d.UnknownError="UnknownError",d.PackageIsInvalidZip="PackageIsInvalidZip",d.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip"})(t||(e.ExtensionSignaturetErrorCode=t={}));class o extends Error{constructor(D,T){super(D),this.code=T,this.name=T}}e.ExtensionManagementError=o,e.IExtensionManagementService=(0,P.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,P.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,P.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,n.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,n.localize)(1,null),original:"Preferences"}}),define(Pe[43],Ae([1,0,48,19,13,12,2,141,3,20,15]),function(te,e,n,P,I,L,R,A,y,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.ByteSize=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function w(Y){return Y.create===!0}e.isFileOpenForWriteOptions=w;var g;(function(Y){Y[Y.Unknown=0]="Unknown",Y[Y.File=1]="File",Y[Y.Directory=2]="Directory",Y[Y.SymbolicLink=64]="SymbolicLink"})(g||(e.FileType=g={}));var S;(function(Y){Y[Y.Readonly=1]="Readonly"})(S||(e.FilePermission=S={}));var p;(function(Y){Y[Y.None=0]="None",Y[Y.FileReadWrite=2]="FileReadWrite",Y[Y.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",Y[Y.FileReadStream=16]="FileReadStream",Y[Y.FileFolderCopy=8]="FileFolderCopy",Y[Y.PathCaseSensitive=1024]="PathCaseSensitive",Y[Y.Readonly=2048]="Readonly",Y[Y.Trash=4096]="Trash",Y[Y.FileWriteUnlock=8192]="FileWriteUnlock",Y[Y.FileAtomicRead=16384]="FileAtomicRead",Y[Y.FileClone=32768]="FileClone"})(p||(e.FileSystemProviderCapabilities=p={}));function l(Y){return!!(Y.capabilities&2)}e.hasReadWriteCapability=l;function t(Y){return!!(Y.capabilities&8)}e.hasFileFolderCopyCapability=t;function o(Y){return!!(Y.capabilities&32768)}e.hasFileCloneCapability=o;function d(Y){return!!(Y.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function D(Y){return!!(Y.capabilities&16)}e.hasFileReadStreamCapability=D;function T(Y){return l(Y)?!!(Y.capabilities&16384):!1}e.hasFileAtomicReadCapability=T;var v;(function(Y){Y.FileExists="EntryExists",Y.FileNotFound="EntryNotFound",Y.FileNotADirectory="EntryNotADirectory",Y.FileIsADirectory="EntryIsADirectory",Y.FileExceedsStorageQuota="EntryExceedsStorageQuota",Y.FileTooLarge="EntryTooLarge",Y.FileWriteLocked="EntryWriteLocked",Y.NoPermissions="NoPermissions",Y.Unavailable="Unavailable",Y.Unknown="Unknown"})(v||(e.FileSystemProviderErrorCode=v={}));class i extends Error{static create(pe,Ee){const he=new i(pe.toString(),Ee);return s(he,Ee),he}constructor(pe,Ee){super(pe),this.code=Ee}}e.FileSystemProviderError=i;function a(Y,pe){return i.create(Y,pe)}e.createFileSystemProviderError=a;function r(Y){return Y||a((0,A.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=r;function s(Y,pe){return Y.name=pe?`${pe} (FileSystemError)`:"FileSystemError",Y}e.markAsFileSystemProviderError=s;function E(Y){if(!Y)return v.Unknown;if(Y instanceof i)return Y.code;const pe=/^(.+) \(FileSystemError\)$/.exec(Y.name);if(!pe)return v.Unknown;switch(pe[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=E;function k(Y){if(Y instanceof N)return Y.fileOperationResult;switch(E(Y)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 9;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileTooLarge:return 7;default:return 10}}e.toFileOperationResult=k;var c;(function(Y){Y[Y.CREATE=0]="CREATE",Y[Y.DELETE=1]="DELETE",Y[Y.MOVE=2]="MOVE",Y[Y.COPY=3]="COPY",Y[Y.WRITE=4]="WRITE"})(c||(e.FileOperation=c={}));class u{constructor(pe,Ee,he){this.resource=pe,this.operation=Ee,this.target=he}isOperation(pe){return this.operation===pe}}e.FileOperationEvent=u;var m;(function(Y){Y[Y.UPDATED=0]="UPDATED",Y[Y.ADDED=1]="ADDED",Y[Y.DELETED=2]="DELETED"})(m||(e.FileChangeType=m={}));class b{constructor(pe,Ee){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const he=new Map;for(const de of pe){const Re=he.get(de.type);switch(Re?Re.push([de.resource,de]):he.set(de.type,[[de.resource,de]]),de.type){case 1:this.rawAdded.push(de.resource);break;case 0:this.rawUpdated.push(de.resource);break;case 2:this.rawDeleted.push(de.resource);break}}for(const[de,Re]of he)switch(de){case 1:this.a=n.TernarySearchTree.forUris(()=>Ee),this.a.fill(Re);break;case 0:this.b=n.TernarySearchTree.forUris(()=>Ee),this.b.fill(Re);break;case 2:this.c=n.TernarySearchTree.forUris(()=>Ee),this.c.fill(Re);break}}contains(pe,...Ee){return this.d(pe,{includeChildren:!1},...Ee)}affects(pe,...Ee){return this.d(pe,{includeChildren:!0},...Ee)}d(pe,Ee,...he){if(!pe)return!1;const de=he.length>0;return!!((!de||he.includes(1))&&(this.a?.get(pe)||Ee.includeChildren&&this.a?.findSuperstr(pe))||(!de||he.includes(0))&&(this.b?.get(pe)||Ee.includeChildren&&this.b?.findSuperstr(pe))||(!de||he.includes(2))&&(this.c?.findSubstr(pe)||Ee.includeChildren&&this.c?.findSuperstr(pe)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=b;function f(Y,pe,Ee){return!Y||!pe||Y===pe||pe.length>Y.length?!1:(pe.charAt(pe.length-1)!==P.sep&&(pe+=P.sep),Ee?(0,I.startsWithIgnoreCase)(Y,pe):Y.indexOf(pe)===0)}e.isParent=f;class N extends Error{constructor(pe,Ee,he){super(pe),this.fileOperationResult=Ee,this.options=he}}e.FileOperationError=N;class V extends N{constructor(pe,Ee,he,de){super(pe,Ee,de),this.fileOperationResult=Ee,this.size=he}}e.TooLargeFileOperationError=V;class _ extends N{constructor(pe,Ee,he){super(pe,2,he),this.stat=Ee}}e.NotModifiedSinceFileOperationError=_;var G;(function(Y){Y[Y.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",Y[Y.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",Y[Y.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",Y[Y.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",Y[Y.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",Y[Y.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",Y[Y.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",Y[Y.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",Y[Y.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",Y[Y.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",Y[Y.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(G||(e.FileOperationResult=G={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var $;(function(Y){Y[Y.FILE=0]="FILE",Y[Y.FOLDER=1]="FOLDER",Y[Y.ROOT_FOLDER=2]="ROOT_FOLDER"})($||(e.FileKind=$={})),e.ETAG_DISABLED="";function B(Y){if(!(typeof Y.size!="number"||typeof Y.mtime!="number"))return Y.mtime.toString(29)+Y.size.toString(31)}e.etag=B;async function X(Y,pe){if(!pe.hasProvider(R.URI.from({scheme:Y.scheme})))return new Promise(Ee=>{const he=pe.onDidChangeFileSystemProviderRegistrations(de=>{de.scheme===Y.scheme&&de.added&&(he.dispose(),Ee())})})}e.whenProviderRegistered=X;class U{static formatSize(pe){return(0,L.isNumber)(pe)||(pe=0),pe<U.KB?(0,A.localize)(1,null,pe.toFixed(0)):pe<U.MB?(0,A.localize)(2,null,(pe/U.KB).toFixed(2)):pe<U.GB?(0,A.localize)(3,null,(pe/U.MB).toFixed(2)):pe<U.TB?(0,A.localize)(4,null,(pe/U.GB).toFixed(2)):(0,A.localize)(5,null,(pe/U.TB).toFixed(2))}}e.ByteSize=U,U.KB=1024,U.MB=U.KB*U.KB,U.GB=U.MB*U.KB,U.TB=U.GB*U.KB;function j(Y){const pe=typeof Y=="string"||Y?.scheme===O.Schemas.vscodeRemote;return typeof Y!="string"&&Y?.scheme===O.Schemas.file?1024*U.MB:pe?10*U.MB:h.isWeb?50*U.MB:1024*U.MB}e.getLargeFileConfirmationLimit=j}),define(Pe[70],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class n{constructor(...I){this.a=new Map;for(const[L,R]of I)this.set(L,R)}set(I,L){const R=this.a.get(I);return this.a.set(I,L),R}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.ServiceCollection=n}),define(Pe[169],Ae([1,0,17,9,6,68,167,3,70,170]),function(te,e,n,P,I,L,R,A,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class w extends Error{constructor(t){super("cyclic dependency between services"),this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class g{constructor(t=new y.ServiceCollection,o=!1,d,D=O){this.f=t,this.g=o,this.h=d,this.i=D,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=D?d?._globalGraph??new R.Graph(T=>T):void 0}createChild(t){return new g(t,this.g,this,this.i)}invokeFunction(t,...o){const d=p.traceInvocation(this.i,t);let D=!1;try{return t({get:v=>{if(D)throw(0,P.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(v,d);if(!i)throw new Error(`[invokeFunction] unknown service '${v}'`);return i}},...o)}finally{D=!0,d.stop()}}createInstance(t,...o){let d,D;return t instanceof L.SyncDescriptor?(d=p.traceCreation(this.i,t.ctor),D=this.j(t.ctor,t.staticArguments.concat(o),d)):(d=p.traceCreation(this.i,t),D=this.j(t,o,d)),d.stop(),D}j(t,o=[],d){const D=A._util.getServiceDependencies(t).sort((i,a)=>i.index-a.index),T=[];for(const i of D){const a=this.m(i.id,d);a||this.u(`[createInstance] ${t.name} depends on UNKNOWN service ${i.id}.`,!1),T.push(a)}const v=D.length>0?D[0].index:o.length;if(o.length!==v){console.trace(`[createInstance] First service dependency of ${t.name} at position ${v+1} conflicts with ${o.length} static arguments`);const i=v-o.length;i>0?o=o.concat(new Array(i)):o=o.slice(0,v)}return Reflect.construct(t,o.concat(T))}k(t,o){if(this.f.get(t)instanceof L.SyncDescriptor)this.f.set(t,o);else if(this.h)this.h.k(t,o);else throw new Error("illegalState - setting UNKNOWN service instance")}l(t){const o=this.f.get(t);return!o&&this.h?this.h.l(t):o}m(t,o){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(t));const d=this.l(t);return d instanceof L.SyncDescriptor?this.q(t,d,o.branch(t,!0)):(o.branch(t,!1),d)}q(t,o,d){if(this.o.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this.o.add(t);try{return this.r(t,o,d)}finally{this.o.delete(t)}}r(t,o,d){const D=new R.Graph(i=>i.id.toString());let T=0;const v=[{id:t,desc:o,_trace:d}];for(;v.length;){const i=v.pop();if(D.lookupOrInsertNode(i),T++>1e3)throw new w(D);for(const a of A._util.getServiceDependencies(i.desc.ctor)){const r=this.l(a.id);if(r||this.u(`[createInstance] ${t} depends on ${a.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(a.id)),r instanceof L.SyncDescriptor){const s={id:a.id,desc:r,_trace:i._trace.branch(a.id,!0)};D.insertEdge(i,s),v.push(s)}}}for(;;){const i=D.roots();if(i.length===0){if(!D.isEmpty())throw new w(D);break}for(const{data:a}of i){if(this.l(a.id)instanceof L.SyncDescriptor){const s=this.s(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this.k(a.id,s)}D.removeNode(a)}}return this.l(t)}s(t,o,d=[],D,T){if(this.f.get(t)instanceof L.SyncDescriptor)return this.t(t,o,d,D,T);if(this.h)return this.h.s(t,o,d,D,T);throw new Error(`illegalState - creating UNKNOWN service instance ${o.name}`)}t(t,o,d=[],D,T){if(D){const v=new g(void 0,this.g,this,this.i);v.c=String(t);const i=new Map,a=new n.IdleValue(()=>{const r=v.j(o,d,T);for(const[s,E]of i){const k=r[s];if(typeof k=="function")for(const c of E)k.apply(r,c)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,s){if(!a.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let c=i.get(s);return c||(c=new h.LinkedList,i.set(s,c)),(m,b,f)=>{const N=c.push([m,b,f]);return(0,I.toDisposable)(N)}}if(s in r)return r[s];const E=a.value;let k=E[s];return typeof k!="function"||(k=k.bind(E),r[s]=k),k},set(r,s,E){return a.value[s]=E,!0},getPrototypeOf(r){return o.prototype}})}else return this.j(o,d,T)}u(t,o){if(o&&console.warn(t),this.g)throw new Error(t)}}e.InstantiationService=g;var S;(function(l){l[l.None=0]="None",l[l.Creation=1]="Creation",l[l.Invocation=2]="Invocation",l[l.Branch=3]="Branch"})(S||(S={}));class p{static traceInvocation(t,o){return t?new p(2,o.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):p.c}static traceCreation(t,o){return t?new p(1,o.name):p.c}constructor(t,o){this.type=t,this.name=o,this.g=Date.now(),this.h=[]}branch(t,o){const d=new p(3,t.toString());return this.h.push([t,o,d]),d}stop(){const t=Date.now()-this.g;p.f+=t;let o=!1;function d(T,v){const i=[],a=new Array(T+1).join("	");for(const[r,s,E]of v.h)if(s&&E){o=!0,i.push(`${a}CREATES -> ${r}`);const k=d(T+1,E);k&&i.push(k)}else i.push(`${a}uses -> ${r}`);return i.join(`
`)}const D=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${p.f.toFixed(2)}ms)`];(t>2||o)&&p.all.add(D.join(`
`))}}e.Trace=p,p.all=new Set,p.c=new class extends p{constructor(){super(0,null)}stop(){}branch(){return this}},p.f=0}),define(Pe[14],Ae([1,0,40,5,92,6,28,20,22,12,2,31,3]),function(te,e,n,P,I,L,R,A,y,h,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_LOG_LEVEL=e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,g.createDecorator)("logService"),e.ILoggerService=(0,g.createDecorator)("loggerService");function S(){return new Date().toISOString()}function p(m){return(0,h.isNumber)(m)}e.isLogLevel=p;var l;(function(m){m[m.Off=0]="Off",m[m.Trace=1]="Trace",m[m.Debug=2]="Debug",m[m.Info=3]="Info",m[m.Warning=4]="Warning",m[m.Error=5]="Error"})(l||(e.LogLevel=l={})),e.DEFAULT_LOG_LEVEL=l.Info;function t(m,b,f){switch(b){case l.Trace:m.trace(f);break;case l.Debug:m.debug(f);break;case l.Info:m.info(f);break;case l.Warning:m.warn(f);break;case l.Error:m.error(f);break;case l.Off:break;default:throw new Error(`Invalid log level ${b}`)}}e.log=t;function o(m,b=!1){let f="";for(let N=0;N<m.length;N++){let V=m[N];if(V instanceof Error&&(V=(0,n.toErrorMessage)(V,b)),typeof V=="object")try{V=JSON.stringify(V)}catch{}f+=(N>0?" ":"")+V}return f}class d extends L.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new P.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(b){this.b!==b&&(this.b=b,this.c.fire(this.b))}getLevel(){return this.b}f(b){return this.b!==l.Off&&this.b<=b}}e.AbstractLogger=d;class D extends d{constructor(b){super(),this.h=b}f(b){return this.h||super.f(b)}trace(b,...f){this.f(l.Trace)&&this.g(l.Trace,o([b,...f],!0))}debug(b,...f){this.f(l.Debug)&&this.g(l.Debug,o([b,...f]))}info(b,...f){this.f(l.Info)&&this.g(l.Info,o([b,...f]))}warn(b,...f){this.f(l.Warning)&&this.g(l.Warning,o([b,...f]))}error(b,...f){if(this.f(l.Error))if(b instanceof Error){const N=Array.prototype.slice.call(arguments);N[0]=b.stack,this.g(l.Error,o(N))}else this.g(l.Error,o([b,...f]))}flush(){}}e.AbstractMessageLogger=D;class T extends d{constructor(b=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(b),this.g=!A.isWindows}trace(b,...f){this.f(l.Trace)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,b,...f):console.log(`[main ${S()}]`,b,...f))}debug(b,...f){this.f(l.Debug)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,b,...f):console.log(`[main ${S()}]`,b,...f))}info(b,...f){this.f(l.Info)&&(this.g?console.log(`\x1B[90m[main ${S()}]\x1B[0m`,b,...f):console.log(`[main ${S()}]`,b,...f))}warn(b,...f){this.f(l.Warning)&&(this.g?console.warn(`\x1B[93m[main ${S()}]\x1B[0m`,b,...f):console.warn(`[main ${S()}]`,b,...f))}error(b,...f){this.f(l.Error)&&(this.g?console.error(`\x1B[91m[main ${S()}]\x1B[0m`,b,...f):console.error(`[main ${S()}]`,b,...f))}dispose(){}flush(){}}e.ConsoleMainLogger=T;class v extends d{constructor(b=e.DEFAULT_LOG_LEVEL,f=!0){super(),this.g=f,this.setLevel(b)}trace(b,...f){this.f(l.Trace)&&(this.g?console.log("%cTRACE","color: #888",b,...f):console.log(b,...f))}debug(b,...f){this.f(l.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",b,...f):console.log(b,...f))}info(b,...f){this.f(l.Info)&&(this.g?console.log("%c INFO","color: #33f",b,...f):console.log(b,...f))}warn(b,...f){this.f(l.Warning)&&(this.g?console.log("%c WARN","color: #993",b,...f):console.log(b,...f))}error(b,...f){this.f(l.Error)&&(this.g?console.log("%c  ERR","color: #f33",b,...f):console.error(b,...f))}dispose(){}flush(){}}e.ConsoleLogger=v;class i extends d{constructor(b,f=e.DEFAULT_LOG_LEVEL){super(),this.g=b,this.setLevel(f)}trace(b,...f){this.f(l.Trace)&&this.g.log(l.Trace,[this.h(b),...f])}debug(b,...f){this.f(l.Debug)&&this.g.log(l.Debug,[this.h(b),...f])}info(b,...f){this.f(l.Info)&&this.g.log(l.Info,[this.h(b),...f])}warn(b,...f){this.f(l.Warning)&&this.g.log(l.Warning,[this.h(b),...f])}error(b,...f){this.f(l.Error)&&this.g.log(l.Error,[this.h(b),...f])}h(b){return typeof b=="string"?b:(0,n.toErrorMessage)(b,this.f(l.Trace))}dispose(){}flush(){}}e.AdapterLogger=i;class a extends d{constructor(b){super(),this.g=b,b.length&&this.setLevel(b[0].getLevel())}setLevel(b){for(const f of this.g)f.setLevel(b);super.setLevel(b)}trace(b,...f){for(const N of this.g)N.trace(b,...f)}debug(b,...f){for(const N of this.g)N.debug(b,...f)}info(b,...f){for(const N of this.g)N.info(b,...f)}warn(b,...f){for(const N of this.g)N.warn(b,...f)}error(b,...f){for(const N of this.g)N.error(b,...f)}flush(){for(const b of this.g)b.flush()}dispose(){for(const b of this.g)b.dispose()}}e.MultiplexLogger=a;class r extends L.Disposable{constructor(b,f,N){if(super(),this.h=b,this.j=f,this.b=new R.ResourceMap,this.c=this.B(new P.Emitter),this.onDidChangeLoggers=this.c.event,this.f=this.B(new P.Emitter),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new P.Emitter),this.onDidChangeVisibility=this.g.event,N)for(const V of N)this.b.set(V.resource,{logger:void 0,info:V})}k(b){return(0,h.isString)(b)?[...this.b.values()].find(f=>f.info.id===b):this.b.get(b)}getLogger(b){return this.k(b)?.logger}createLogger(b,f){const N=this.l(b),V=(0,h.isString)(b)?b:f?.id??(0,I.hash)(N.toString()).toString(16);let _=this.b.get(N)?.logger;const G=f?.logLevel==="always"?l.Trace:f?.logLevel;_||(_=this.m(N,G??this.getLogLevel(N)??this.h,{...f,id:V}));const $={logger:_,info:{resource:N,id:V,logLevel:G,name:f?.name,hidden:f?.hidden,extensionId:f?.extensionId,when:f?.when}};return this.registerLogger($.info),this.b.set(N,$),_}l(b){return(0,h.isString)(b)?(0,y.joinPath)(this.j,`${b}.log`):b}setLogLevel(b,f){if(O.URI.isUri(b)){const N=b,V=f,_=this.b.get(N);_&&V!==_.info.logLevel&&(_.info.logLevel=V===this.h?void 0:V,_.logger?.setLevel(V),this.b.set(_.info.resource,_),this.f.fire([N,V]))}else{this.h=b;for(const[N,V]of this.b.entries())this.b.get(N)?.info.logLevel===void 0&&V.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(b,f){const N=this.k(b);N&&f!==!N.info.hidden&&(N.info.hidden=!f,this.b.set(N.info.resource,N),this.g.fire([N.info.resource,f]))}getLogLevel(b){let f;return b&&(f=this.b.get(b)?.info.logLevel),f??this.h}registerLogger(b){const f=this.b.get(b.resource);f?f.info.hidden!==b.hidden&&this.setVisibility(b.resource,!b.hidden):(this.b.set(b.resource,{info:b,logger:void 0}),this.c.fire({added:[b],removed:[]}))}deregisterLogger(b){const f=this.b.get(b);f&&(f.logger&&f.logger.dispose(),this.b.delete(b),this.c.fire({added:[],removed:[f.info]}))}*getRegisteredLoggers(){for(const b of this.b.values())yield b.info}getRegisteredLogger(b){return this.b.get(b)?.info}dispose(){this.b.forEach(b=>b.logger?.dispose()),this.b.clear(),super.dispose()}}e.AbstractLoggerService=r;class s{constructor(){this.onDidChangeLogLevel=new P.Emitter().event}setLevel(b){}getLevel(){return l.Info}trace(b,...f){}debug(b,...f){}info(b,...f){}warn(b,...f){}error(b,...f){}critical(b,...f){}dispose(){}flush(){}}e.NullLogger=s;class E extends s{}e.NullLogService=E;function k(m){if(m.verbose)return l.Trace;if(typeof m.logLevel=="string"){const b=u(m.logLevel.toLowerCase());if(b!==void 0)return b}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=k;function c(m){switch(m){case l.Trace:return"trace";case l.Debug:return"debug";case l.Info:return"info";case l.Warning:return"warn";case l.Error:return"error";case l.Off:return"off"}}e.LogLevelToString=c;function u(m){switch(m){case"trace":return l.Trace;case"debug":return l.Debug;case"info":return l.Info;case"warn":return l.Warning;case"error":return l.Error;case"critical":return l.Error;case"off":return l.Off}}e.parseLogLevel=u,e.CONTEXT_LOG_LEVEL=new w.RawContextKey("logLevel",c(l.Info))}),define(Pe[171],Ae([1,0,6,14]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class I extends n.Disposable{constructor(R,A=[]){super(),this.a=new P.MultiplexLogger([R,...A]),this.B(R.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(R){this.a.setLevel(R)}getLevel(){return this.a.getLevel()}trace(R,...A){this.a.trace(R,...A)}debug(R,...A){this.a.debug(R,...A)}info(R,...A){this.a.info(R,...A)}warn(R,...A){this.a.warn(R,...A)}error(R,...A){this.a.error(R,...A)}flush(){this.a.flush()}}e.LogService=I}),define(Pe[93],Ae([1,0,29,142,3]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(L||(e.MarkerTag=L={}));var R;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(R||(e.MarkerSeverity=R={})),function(y){function h(p,l){return l-p}y.compare=h;const O=Object.create(null);O[y.Error]=(0,P.localize)(0,null),O[y.Warning]=(0,P.localize)(1,null),O[y.Info]=(0,P.localize)(2,null);function w(p){return O[p]||""}y.toString=w;function g(p){switch(p){case n.default.Error:return y.Error;case n.default.Warning:return y.Warning;case n.default.Info:return y.Info;case n.default.Ignore:return y.Hint}}y.fromSeverity=g;function S(p){switch(p){case y.Error:return n.default.Error;case y.Warning:return n.default.Warning;case y.Info:return n.default.Info;case y.Hint:return n.default.Ignore}}y.toSeverity=S}(R||(e.MarkerSeverity=R={}));var A;(function(y){const h="";function O(g){return w(g,!0)}y.makeKey=O;function w(g,S){const p=[h];return g.source?p.push(g.source.replace("\xA6","\\\xA6")):p.push(h),g.code?typeof g.code=="string"?p.push(g.code.replace("\xA6","\\\xA6")):p.push(g.code.value.replace("\xA6","\\\xA6")):p.push(h),g.severity!==void 0&&g.severity!==null?p.push(R.toString(g.severity)):p.push(h),g.message&&S?p.push(g.message.replace("\xA6","\\\xA6")):p.push(h),g.startLineNumber!==void 0&&g.startLineNumber!==null?p.push(g.startLineNumber.toString()):p.push(h),g.startColumn!==void 0&&g.startColumn!==null?p.push(g.startColumn.toString()):p.push(h),g.endLineNumber!==void 0&&g.endLineNumber!==null?p.push(g.endLineNumber.toString()):p.push(h),g.endColumn!==void 0&&g.endColumn!==null?p.push(g.endColumn.toString()):p.push(h),p.push(h),p.join("\xA6")}y.makeKeyOptionalMessage=w})(A||(e.IMarkerData=A={})),e.IMarkerService=(0,I.createDecorator)("markerService")}),define(Pe[172],Ae([1,0,5,29,3]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.INotificationService=e.Severity=void 0,e.Severity=P.default,e.INotificationService=(0,I.createDecorator)("notificationService");var L;(function(O){O[O.DEFAULT=0]="DEFAULT",O[O.SILENT=1]="SILENT",O[O.URGENT=2]="URGENT"})(L||(e.NotificationPriority=L={}));var R;(function(O){O[O.WORKSPACE=0]="WORKSPACE",O[O.PROFILE=1]="PROFILE",O[O.APPLICATION=2]="APPLICATION"})(R||(e.NeverShowAgainScope=R={}));var A;(function(O){O[O.OFF=0]="OFF",O[O.SILENT=1]="SILENT",O[O.ERROR=2]="ERROR"})(A||(e.NotificationsFilter=A={}));class y{constructor(){this.progress=new h,this.onDidClose=n.Event.None,this.onDidChangeVisibility=n.Event.None}updateSeverity(w){}updateMessage(w){}updateActions(w){}close(){}}e.NoOpNotification=y;class h{infinite(){}done(){}total(w){}worked(w){}}e.NoOpProgress=h}),define(Pe[94],Ae([1,0,13,2,3]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,I.createDecorator)("openerService");function L(h,O){return P.URI.isUri(h)?(0,n.equalsIgnoreCase)(h.scheme,O):(0,n.startsWithIgnoreCase)(h,O+":")}e.matchesScheme=L;function R(h,...O){return O.some(w=>L(h,w))}e.matchesSomeScheme=R;function A(h,O){return h.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=A;function y(h){let O;const w=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(h.fragment);return w&&(O={startLineNumber:parseInt(w[1]),startColumn:w[2]?parseInt(w[2]):1,endLineNumber:w[4]?parseInt(w[4]):void 0,endColumn:w[4]?w[5]?parseInt(w[5]):1:void 0},h=h.with({fragment:""})),{selection:O,uri:h}}e.extractSelection=y}),define(Pe[173],Ae([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,n.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var xe=this&&this.__decorate||function(te,e,n,P){var I=arguments.length,L=I<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,n):P,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(te,e,n,P);else for(var A=te.length-1;A>=0;A--)(R=te[A])&&(L=(I<3?R(L):I>3?R(e,n,L):R(e,n))||L);return I>3&&L&&Object.defineProperty(e,n,L),L},qe=this&&this.__param||function(te,e){return function(n,P){e(n,P,te)}};define(Pe[174],Ae([1,0,17,21,6,3]),function(te,e,n,P,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var R;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(R||(e.ProgressLocation=R={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(w){this.b=w}report(w){this.a=w,this.b(this.a)}}e.Progress=A,A.None=Object.freeze({report(){}});let y=e.UnmanagedProgress=class extends I.Disposable{constructor(w,g){super(),this.a=new n.DeferredPromise,g.withProgress(w,S=>(this.b=S,this.c&&S.report(this.c),this.a.p)),this.B((0,I.toDisposable)(()=>this.a.complete()))}report(w){this.b?this.b.report(w):this.c=w}};e.UnmanagedProgress=y=xe([qe(1,e.IProgressService)],y);class h extends I.Disposable{constructor(w){super(),this.g=w,this.a=0,this.b=this.B(new I.DisposableStore)}start(w){this.stop();const g=++this.a,S=new P.CancellationTokenSource;return this.f=setTimeout(()=>{g===this.a&&(this.c=this.g.show(!0))},w),this.b.add((0,I.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,I.toDisposable)(()=>S.cancel())),this.b.add((0,I.toDisposable)(()=>this.c?this.c.done():void 0)),{id:g,token:S.token,stop:()=>this.h(g),isCurrent:()=>this.a===g}}stop(){this.h(this.a)}h(w){this.a===w&&this.b.clear()}}e.LongRunningOperation=h,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(Pe[30],Ae([1,0,49,12]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class I{constructor(){this.a=new Map}add(R,A){n.ok(P.isString(R)),n.ok(P.isObject(A)),n.ok(!this.a.has(R),"There is already an extension with this id"),this.a.set(R,A)}knows(R){return this.a.has(R)}as(R){return this.a.get(R)||null}}e.Registry=new I}),define(Pe[71],Ae([1,0,5,30]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function I(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class L{constructor(){this.b=new n.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,h){this.a[I(y)]=h,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const R=new L;P.Registry.add(e.Extensions.JSONContribution,R)}),define(Pe[95],Ae([1,0,16,5,12,136,42,71,30]),function(te,e,n,P,I,L,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var h;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(h||(e.EditPresentationTypes=h={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O||(e.ConfigurationScope=O={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=y.Registry.as(A.Extensions.JSONContribution);class g{constructor(){this.h=new Set,this.i=new P.Emitter,this.onDidSchemaChange=this.i.event,this.j=new P.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,a=!0){this.registerConfigurations([i],a)}registerConfigurations(i,a=!0){const r=new Set;this.n(i,a,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const a=new Set;this.o(i,a),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:a})}updateConfigurations({add:i,remove:a}){const r=new Set;this.o(a,r),this.n(i,!1,r),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(i){const a=new Set;this.k(i,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}k(i,a){const r=[];for(const{overrides:s,source:E}of i)for(const k in s)if(a.add(k),e.OVERRIDE_PROPERTY_REGEX.test(k)){const c=this.a.get(k),u=c?.valuesSources??new Map;if(E)for(const N of Object.keys(s[k]))u.set(N,E);const m={...c?.value||{},...s[k]};this.a.set(k,{source:E,value:m,valuesSources:u});const b=(0,R.getLanguageTagSettingPlainKey)(k),f={type:"object",default:m,description:L.localize(1,null,b),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:m,source:I.isString(E)?void 0:E,defaultValueSource:E};r.push(...l(k)),this.d[k]=f,this.b.properties[k]=f}else{this.a.set(k,{value:s[k],source:E});const c=this.d[k];c&&(this.w(k,c),this.r(k,c))}this.m(r)}deregisterDefaultConfigurations(i){const a=new Set;this.l(i,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:!0})}l(i,a){for(const{overrides:r,source:s}of i)for(const E in r){const k=this.a.get(E),c=I.isString(s)?s:s?.id,u=I.isString(k?.source)?k?.source:k?.source?.id;if(c===u)if(a.add(E),this.a.delete(E),e.OVERRIDE_PROPERTY_REGEX.test(E))delete this.d[E],delete this.b.properties[E];else{const m=this.d[E];m&&(this.w(E,m),this.r(E,m))}}this.u()}deltaConfiguration(i){let a=!1;const r=new Set;i.removedDefaults&&(this.l(i.removedDefaults,r),a=!0),i.addedDefaults&&(this.k(i.addedDefaults,r),a=!0),i.removedConfigurations&&this.o(i.removedConfigurations,r),i.addedConfigurations&&this.n(i.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:a})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const a of i)this.h.add(a);this.u()}n(i,a,r){i.forEach(s=>{this.p(s,a,s.extensionInfo,s.restrictedProperties,void 0,r),this.c.push(s),this.q(s)})}o(i,a){const r=s=>{if(s.properties)for(const E in s.properties){a.add(E);const k=this.d[E];k?.policy?.name&&this.e.delete(k.policy.name),delete this.d[E],this.s(E,s.properties[E])}s.allOf?.forEach(E=>r(E))};for(const s of i){r(s);const E=this.c.indexOf(s);E!==-1&&this.c.splice(E,1)}}p(i,a=!0,r,s,E=3,k){E=I.isUndefinedOrNull(i.scope)?E:i.scope;const c=i.properties;if(c)for(const m in c){const b=c[m];if(a&&D(m,b)){delete c[m];continue}if(b.source=r,b.defaultDefaultValue=c[m].default,this.w(m,b),e.OVERRIDE_PROPERTY_REGEX.test(m)?b.scope=void 0:(b.scope=I.isUndefinedOrNull(b.scope)?E:b.scope,b.restricted=I.isUndefinedOrNull(b.restricted)?!!s?.includes(m):b.restricted),c[m].hasOwnProperty("included")&&!c[m].included){this.f[m]=c[m],delete c[m];continue}else this.d[m]=c[m],c[m].policy?.name&&this.e.set(c[m].policy.name,m);!c[m].deprecationMessage&&c[m].markdownDeprecationMessage&&(c[m].deprecationMessage=c[m].markdownDeprecationMessage),k.add(m)}const u=i.allOf;if(u)for(const m of u)this.p(m,a,r,s,E,k)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const a=r=>{const s=r.properties;if(s)for(const k in s)this.r(k,s[k]);r.allOf?.forEach(a)};a(i)}r(i,a){switch(e.allSettings.properties[i]=a,a.scope){case 1:e.applicationSettings.properties[i]=a;break;case 2:e.machineSettings.properties[i]=a;break;case 6:e.machineOverridableSettings.properties[i]=a;break;case 3:e.windowSettings.properties[i]=a;break;case 4:e.resourceSettings.properties[i]=a;break;case 5:e.resourceSettings.properties[i]=a,this.g.properties[i]=a;break}}s(i,a){switch(delete e.allSettings.properties[i],a.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const a=`[${i}]`,r={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(a,r),e.allSettings.properties[a]=r,e.applicationSettings.properties[a]=r,e.machineSettings.properties[a]=r,e.machineOverridableSettings.properties[a]=r,e.windowSettings.properties[a]=r,e.resourceSettings.properties[a]=r}}v(){const i={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,a){const r=this.a.get(i);let s=r?.value,E=r?.source;I.isUndefined(s)&&(s=a.defaultDefaultValue,E=void 0),I.isUndefined(s)&&(s=o(a.type)),a.default=s,a.defaultValueSource=E}}const S="\\[([^\\]]+)\\]",p=new RegExp(S,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${S})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function l(v){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(v)){let a=p.exec(v);for(;a?.length;){const r=a[1].trim();r&&i.push(r),a=p.exec(v)}}return(0,n.distinct)(i)}e.overrideIdentifiersFromKey=l;function t(v){return v.reduce((i,a)=>`${i}[${a}]`,"")}e.keyFromOverrideIdentifiers=t;function o(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=o;const d=new g;y.Registry.add(e.Extensions.Configuration,d);function D(v,i){return v.trim()?e.OVERRIDE_PROPERTY_REGEX.test(v)?L.localize(7,null,v):d.getConfigurationProperties()[v]!==void 0?L.localize(8,null,v):i.policy?.name&&d.getPolicyConfigurations().get(i.policy?.name)!==void 0?L.localize(9,null,v,i.policy?.name,d.getPolicyConfigurations().get(i.policy?.name)):null:L.localize(6,null)}e.validateProperty=D;function T(){const v=[],i=d.getConfigurationProperties();for(const a of Object.keys(i))v.push([a,i[a].scope]);return v.push(["launch",4]),v.push(["task",4]),v}e.getScopes=T}),define(Pe[175],Ae([1,0,16,5,114,6,28,23,12,2,42,95,30]),function(te,e,n,P,I,L,R,A,y,h,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function S(a){return Object.isFrozen(a)?a:A.deepFreeze(a)}class p{constructor(r={},s=[],E=[],k){this.b=r,this.c=s,this.d=E,this.raw=k,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(s=>{if(s instanceof p)return s;const E=new l("");return E.parseRaw(s),E.configurationModel});this.f=r.reduce((s,E)=>E===s?E:s.merge(E),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,O.getConfigurationValue)(this.contents,r):this.contents}inspect(r,s){const E=this.rawConfiguration.getValue(r),k=s?this.rawConfiguration.getOverrideValue(r,s):void 0,c=s?this.rawConfiguration.override(s).getValue(r):E;return{value:E,override:k,merged:c}}getOverrideValue(r,s){const E=this.i(s);return E?r?(0,O.getConfigurationValue)(E,r):E:void 0}getKeysForOverrideIdentifier(r){const s=[];for(const E of this.overrides)E.identifiers.includes(r)&&s.push(...E.keys);return n.distinct(s)}getAllOverrideIdentifiers(){const r=[];for(const s of this.overrides)r.push(...s.identifiers);return n.distinct(r)}override(r){let s=this.a.get(r);return s||(s=this.g(r),this.a.set(r,s)),s}merge(...r){const s=A.deepClone(this.contents),E=A.deepClone(this.overrides),k=[...this.keys],c=this.raw?.length?[...this.raw]:[this];for(const u of r)if(c.push(...u.raw?.length?u.raw:[u]),!u.isEmpty()){this.h(s,u.contents);for(const m of u.overrides){const[b]=E.filter(f=>n.equals(f.identifiers,m.identifiers));b?(this.h(b.contents,m.contents),b.keys.push(...m.keys),b.keys=n.distinct(b.keys)):E.push(A.deepClone(m))}for(const m of u.keys)k.indexOf(m)===-1&&k.push(m)}return new p(s,k,E,c.every(u=>u instanceof p)?void 0:c)}g(r){const s=this.i(r);if(!s||typeof s!="object"||!Object.keys(s).length)return this;const E={};for(const k of n.distinct([...Object.keys(this.contents),...Object.keys(s)])){let c=this.contents[k];const u=s[k];u&&(typeof c=="object"&&typeof u=="object"?(c=A.deepClone(c),this.h(c,u)):c=u),E[k]=c}return new p(E,this.keys,this.overrides)}h(r,s){for(const E of Object.keys(s)){if(E in r&&y.isObject(r[E])&&y.isObject(s[E])){this.h(r[E],s[E]);continue}r[E]=A.deepClone(s[E])}}i(r){let s=null,E=null;const k=c=>{c&&(E?this.h(E,c):E=A.deepClone(c))};for(const c of this.overrides)n.equals(c.identifiers,[r])?s=c.contents:c.identifiers.includes(r)&&k(c.contents);return k(s),E}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,s){this.j(r,s,!0)}setValue(r,s){this.j(r,s,!1)}removeValue(r){const s=this.keys.indexOf(r);s!==-1&&(this.keys.splice(s,1),(0,O.removeFromValueTree)(this.contents,r),w.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(E=>n.equals(E.identifiers,(0,w.overrideIdentifiersFromKey)(r))),1))}j(r,s,E){(0,O.addToValueTree)(this.contents,r,s,k=>console.error(k)),E=E||this.keys.indexOf(r)===-1,E&&this.keys.push(r),w.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,w.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,O.toValuesTree)(this.contents[r],k=>console.error(k))})}}e.ConfigurationModel=p;class l{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new p}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,s){if(!y.isUndefinedOrNull(r)){const E=this.g(r);this.parseRaw(E,s)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,s){this.a=r;const{contents:E,keys:k,overrides:c,restricted:u,hasExcludedProperties:m}=this.h(r,s);this.b=new p(E,k,c,m?[r]:void 0),this.c=u||[]}g(r){let s={},E=null,k=[];const c=[],u=[];function m(f){Array.isArray(k)?k.push(f):E!==null&&(k[E]=f)}const b={onObjectBegin:()=>{const f={};m(f),c.push(k),k=f,E=null},onObjectProperty:f=>{E=f},onObjectEnd:()=>{k=c.pop()},onArrayBegin:()=>{const f=[];m(f),c.push(k),k=f,E=null},onArrayEnd:()=>{k=c.pop()},onLiteralValue:m,onError:(f,N,V)=>{u.push({error:f,offset:N,length:V})}};if(r)try{I.visit(r,b),s=k[0]||{}}catch(f){console.error(`Error while parsing settings file ${this.f}: ${f}`),this.d=[f]}return s}h(r,s){const E=g.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),k=this.i(r,E,!0,s);r=k.raw;const c=(0,O.toValuesTree)(r,b=>console.error(`Conflict in settings file ${this.f}: ${b}`)),u=Object.keys(r),m=this.j(r,b=>console.error(`Conflict in settings file ${this.f}: ${b}`));return{contents:c,keys:u,overrides:m,restricted:k.restricted,hasExcludedProperties:k.hasExcludedProperties}}i(r,s,E,k){let c=!1;if(!k?.scopes&&!k?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:c};const u={},m=[];for(const b in r)if(w.OVERRIDE_PROPERTY_REGEX.test(b)&&E){const f=this.i(r[b],s,!1,k);u[b]=f.raw,c=c||f.hasExcludedProperties,m.push(...f.restricted)}else{const f=s[b],N=f?typeof f.scope<"u"?f.scope:3:void 0;f?.restricted&&m.push(b),(N===void 0||k.scopes===void 0||k.scopes.includes(N))&&!(k.skipRestricted&&f?.restricted)?u[b]=r[b]:c=!0}return{raw:u,restricted:m,hasExcludedProperties:c}}j(r,s){const E=[];for(const k of Object.keys(r))if(w.OVERRIDE_PROPERTY_REGEX.test(k)){const c={};for(const u in r[k])c[u]=r[k][u];E.push({identifiers:(0,w.overrideIdentifiersFromKey)(k),keys:Object.keys(c),contents:(0,O.toValuesTree)(c,s)})}return E}}e.ConfigurationModelParser=l;class t extends L.Disposable{constructor(r,s,E,k){super(),this.f=r,this.g=s,this.h=k,this.c=this.B(new P.Emitter),this.onDidChange=this.c.event,this.a=new l(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(E.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(P.Event.any(P.Event.filter(this.h.onDidFilesChange,c=>c.contains(this.f)),P.Event.filter(this.h.onDidRunOperation,c=>(c.isOperation(0)||c.isOperation(3)||c.isOperation(1)||c.isOperation(4))&&E.isEqual(c.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new p}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=t;class o{constructor(r,s,E,k,c,u,m,b,f,N,V,_,G){this.a=r,this.b=s,this.c=E,this.overrideIdentifiers=k,this.d=c,this.f=u,this.g=m,this.h=b,this.i=f,this.j=N,this.k=V,this.l=_,this.m=G}get value(){return S(this.c)}n(r,s,E){const k=r.inspect(s,E);return{get value(){return S(k.value)},get override(){return S(k.override)},get merged(){return S(k.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class d{constructor(r,s,E,k,c=new p,u=new p,m=new R.ResourceMap,b=new p,f=new R.ResourceMap){this.c=r,this.d=s,this.f=E,this.g=k,this.h=c,this.i=u,this.j=m,this.l=b,this.m=f,this.a=null,this.b=new R.ResourceMap,this.n=null}getValue(r,s,E){return this.q(r,s,E).getValue(r)}updateValue(r,s,E={}){let k;E.resource?(k=this.m.get(E.resource),k||(k=new p,this.m.set(E.resource,k))):k=this.l,s===void 0?k.removeValue(r):k.setValue(r,s),E.resource||(this.a=null)}inspect(r,s,E){const k=this.q(r,s,E),c=this.u(s.resource,E),u=s.resource?this.m.get(s.resource)||this.l:this.l,m=new Set;for(const b of k.overrides)for(const f of b.identifiers)k.getOverrideValue(r,f)!==void 0&&m.add(f);return new o(r,s,k.getValue(r),m.size?[...m]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,E?this.i:void 0,c||void 0,u)}keys(r){const s=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:s?s.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,s){this.j.set(r,s),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,s){const E=[];if(!s){const{added:k,updated:c,removed:u}=v(this.c,r);s=[...k,...c,...u]}for(const k of s)for(const c of(0,w.overrideIdentifiersFromKey)(k)){const u=this.c.getKeysForOverrideIdentifier(c),m=r.getKeysForOverrideIdentifier(c),b=[...m.filter(f=>u.indexOf(f)===-1),...u.filter(f=>m.indexOf(f)===-1),...u.filter(f=>!A.equals(this.c.override(c).getValue(f),r.override(c).getValue(f)))];E.push([c,b])}return this.updateDefaultConfiguration(r),{keys:s,overrides:E}}compareAndUpdatePolicyConfiguration(r){const{added:s,updated:E,removed:k}=v(this.d,r),c=[...s,...E,...k];return c.length&&this.updatePolicyConfiguration(r),{keys:c,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:s,updated:E,removed:k,overrides:c}=v(this.applicationConfiguration,r),u=[...s,...E,...k];return u.length&&this.updateApplicationConfiguration(r),{keys:u,overrides:c}}compareAndUpdateLocalUserConfiguration(r){const{added:s,updated:E,removed:k,overrides:c}=v(this.localUserConfiguration,r),u=[...s,...E,...k];return u.length&&this.updateLocalUserConfiguration(r),{keys:u,overrides:c}}compareAndUpdateRemoteUserConfiguration(r){const{added:s,updated:E,removed:k,overrides:c}=v(this.remoteUserConfiguration,r),u=[...s,...E,...k];return u.length&&this.updateRemoteUserConfiguration(r),{keys:u,overrides:c}}compareAndUpdateWorkspaceConfiguration(r){const{added:s,updated:E,removed:k,overrides:c}=v(this.workspaceConfiguration,r),u=[...s,...E,...k];return u.length&&this.updateWorkspaceConfiguration(r),{keys:u,overrides:c}}compareAndUpdateFolderConfiguration(r,s){const E=this.p.get(r),{added:k,updated:c,removed:u,overrides:m}=v(E,s),b=[...k,...c,...u];return(b.length||!E)&&this.updateFolderConfiguration(r,s),{keys:b,overrides:m}}compareAndDeleteFolderConfiguration(r){const s=this.p.get(r);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:E,updated:k,removed:c,overrides:u}=v(s,void 0);return{keys:[...E,...k,...c],overrides:u}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,s,E){let k=this.r(s,E);return s.overrideIdentifier&&(k=k.override(s.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(k=k.merge(this.d)),k}r({resource:r},s){let E=this.s();if(s&&r){const k=s.getFolder(r);k&&(E=this.t(k.uri)||E);const c=this.m.get(r);c&&(E=E.merge(c))}return E}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let s=this.b.get(r);if(!s){const E=this.s(),k=this.j.get(r);k?(s=E.merge(k),this.b.set(r,s)):s=E}return s}u(r,s){if(s&&r){const E=s.getFolder(r);if(E)return this.j.get(E.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,s)=>{const{contents:E,overrides:k,keys:c}=this.j.get(s);return r.push([s,{contents:E,overrides:k,keys:c}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(s=>r.add(s)),this.userConfiguration.keys.forEach(s=>r.add(s)),this.i.keys.forEach(s=>r.add(s)),this.j.forEach(s=>s.keys.forEach(E=>r.add(E))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(s=>r.add(s)),this.userConfiguration.getAllOverrideIdentifiers().forEach(s=>r.add(s)),this.i.getAllOverrideIdentifiers().forEach(s=>r.add(s)),this.j.forEach(s=>s.getAllOverrideIdentifiers().forEach(E=>r.add(E))),[...r.values()]}w(r){const s=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(E=>s.add(E)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(E=>s.add(E)),this.i.getKeysForOverrideIdentifier(r).forEach(E=>s.add(E)),this.j.forEach(E=>E.getKeysForOverrideIdentifier(r).forEach(k=>s.add(k))),[...s.values()]}static parse(r){const s=this.x(r.defaults),E=this.x(r.policy),k=this.x(r.application),c=this.x(r.user),u=this.x(r.workspace),m=r.folders.reduce((b,f)=>(b.set(h.URI.revive(f[0]),this.x(f[1])),b),new R.ResourceMap);return new d(s,E,k,c,new p,u,m,new p,new R.ResourceMap)}static x(r){return new p(r.contents,r.keys,r.overrides)}}e.Configuration=d;function D(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const r=new Set,s=new Map;for(const k of a)k.keys.forEach(c=>r.add(c)),k.overrides.forEach(([c,u])=>{const m=(0,R.getOrSet)(s,c,new Set);u.forEach(b=>m.add(b))});const E=[];return s.forEach((k,c)=>E.push([c,[...k.values()]])),{keys:[...r.values()],overrides:E}}e.mergeChanges=D;class T{constructor(r,s,E,k){this.change=r,this.f=s,this.g=E,this.h=k,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const c of r.keys)this.affectedKeys.add(c);for(const[,c]of r.overrides)for(const u of c)this.affectedKeys.add(u);this.d=this.a;for(const c of this.affectedKeys)this.d+=c+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=d.parse(this.f.data)),this.i}affectsConfiguration(r,s){const E=this.a+r,k=this.d.indexOf(E);if(k<0)return!1;const c=k+E.length;if(c>=this.d.length)return!1;const u=this.d.charCodeAt(c);if(u!==this.b&&u!==this.c)return!1;if(s){const m=this.previousConfiguration?this.previousConfiguration.getValue(r,s,this.f?.workspace):void 0,b=this.g.getValue(r,s,this.h);return!A.equals(m,b)}return!0}}e.ConfigurationChangeEvent=T;function v(a,r){const{added:s,removed:E,updated:k}=i(r?.rawConfiguration,a?.rawConfiguration),c=[],u=a?.getAllOverrideIdentifiers()||[],m=r?.getAllOverrideIdentifiers()||[];if(r){const b=m.filter(f=>!u.includes(f));for(const f of b)c.push([f,r.getKeysForOverrideIdentifier(f)])}if(a){const b=u.filter(f=>!m.includes(f));for(const f of b)c.push([f,a.getKeysForOverrideIdentifier(f)])}if(r&&a){for(const b of u)if(m.includes(b)){const f=i({contents:a.getOverrideValue(void 0,b)||{},keys:a.getKeysForOverrideIdentifier(b)},{contents:r.getOverrideValue(void 0,b)||{},keys:r.getKeysForOverrideIdentifier(b)});c.push([b,[...f.added,...f.removed,...f.updated]])}}return{added:s,removed:E,updated:k,overrides:c}}function i(a,r){const s=a?r?a.keys.filter(c=>r.keys.indexOf(c)===-1):[...a.keys]:[],E=r?a?r.keys.filter(c=>a.keys.indexOf(c)===-1):[...r.keys]:[],k=[];if(a&&r){for(const c of r.keys)if(a.keys.indexOf(c)!==-1){const u=(0,O.getConfigurationValue)(r.contents,c),m=(0,O.getConfigurationValue)(a.contents,c);A.equals(u,m)||k.push(c)}}return{added:s,removed:E,updated:k}}}),define(Pe[96],Ae([1,0,9,3]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,P.createDecorator)("remoteAuthorityResolverService");var I;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(I||(e.RemoteAuthorityResolverErrorCode=I={}));class L extends n.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof L&&y._code===I.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof L&&y._code===I.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof L&&y._code===I.NoResolverFound}static isHandled(y){return y instanceof L&&y.isHandled}constructor(y,h=I.Unknown,O){super(y),this._message=y,this._code=h,this._detail=O,this.isHandled=h===I.NotAvailable&&O===!0,Object.setPrototypeOf(this,L.prototype)}}e.RemoteAuthorityResolverError=L;function R(A){const y=A.indexOf("+");return y===-1?A:A.substring(0,y)}e.getRemoteAuthorityPrefix=R}),define(Pe[50],Ae([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function P(h){return h.scheme===n.Schemas.vscodeRemote?h.authority:void 0}e.getRemoteAuthority=P;function I(h){if(!h)return;const O=h.indexOf("+");return O<0?h:h.substr(0,O)}e.getRemoteName=I;function L(h){return`/${h.quality??"oss"}-${h.commit??"dev"}`}e.getRemoteServerRootPath=L;function R(h){const{host:O,port:w}=y(h);if(typeof w>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:w}}e.parseAuthorityWithPort=R;function A(h,O){let{host:w,port:g}=y(h);return typeof g>"u"&&(g=O),{host:w,port:g}}e.parseAuthorityWithOptionalPort=A;function y(h){const O=h.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const w=h.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const g=h.match(/(.*):(\d+)$/);return g?{host:g[1],port:parseInt(g[2],10)}:{host:h,port:void 0}}}),define(Pe[24],Ae([1,0,13,3,50]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifierMap=e.ExtensionIdentifierSet=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=void 0,e.USER_MANIFEST_CACHE_FILE="extensions.user.cache",e.BUILTIN_MANIFEST_CACHE_FILE="extensions.builtin.cache",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(l){if(typeof l=="object"&&l!==null&&l.supported!==!0)return l.description}e.getWorkspaceSupportTypeMessage=L,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(l){l[l.System=0]="System",l[l.User=1]="User"})(R||(e.ExtensionType=R={}));var A;(function(l){l.WIN32_X64="win32-x64",l.WIN32_IA32="win32-ia32",l.WIN32_ARM64="win32-arm64",l.LINUX_X64="linux-x64",l.LINUX_ARM64="linux-arm64",l.LINUX_ARMHF="linux-armhf",l.ALPINE_X64="alpine-x64",l.ALPINE_ARM64="alpine-arm64",l.DARWIN_X64="darwin-x64",l.DARWIN_ARM64="darwin-arm64",l.WEB="web",l.UNIVERSAL="universal",l.UNKNOWN="unknown",l.UNDEFINED="undefined"})(A||(e.TargetPlatform=A={}));class y{constructor(t){this.value=t,this.c=t.toLowerCase()}static equals(t,o){if(typeof t>"u"||t===null)return typeof o>"u"||o===null;if(typeof o>"u"||o===null)return!1;if(typeof t=="string"||typeof o=="string"){const d=typeof t=="string"?t:t.value,D=typeof o=="string"?o:o.value;return n.equalsIgnoreCase(d,D)}return t.c===o.c}static toKey(t){return typeof t=="string"?t.toLowerCase():t.c}}e.ExtensionIdentifier=y;class h{get size(){return this.c.size}constructor(t){if(this.c=new Set,t)for(const o of t)this.add(o)}add(t){this.c.add(y.toKey(t))}delete(t){return this.c.delete(y.toKey(t))}has(t){return this.c.has(y.toKey(t))}}e.ExtensionIdentifierSet=h;class O{constructor(){this.c=new Map}clear(){this.c.clear()}delete(t){this.c.delete(y.toKey(t))}get(t){return this.c.get(y.toKey(t))}has(t){return this.c.has(y.toKey(t))}set(t,o){this.c.set(y.toKey(t),o)}values(){return this.c.values()}forEach(t){this.c.forEach(t)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.ExtensionIdentifierMap=O;function w(l){return g(l)}e.isApplicationScopedExtension=w;function g(l){return l.contributes&&l.contributes.localizations?l.contributes.localizations.length>0:!1}e.isLanguagePackExtension=g;function S(l){return l.contributes&&l.contributes.authentication?l.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=S;function p(l,t){if(t){const o=`onResolveRemoteAuthority:${(0,I.getRemoteName)(t)}`;return!!l.activationEvents?.includes(o)}return!1}e.isResolverExtension=p,e.IBuiltinExtensionsScannerService=(0,P.createDecorator)("IBuiltinExtensionsScannerService")}),define(Pe[97],Ae([1,0,9,24]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class I{constructor(){this.a=new Map,this.b=new WeakMap}register(R,A){this.a.set(R,A)}readActivationEvents(R){return this.b.has(R)||this.b.set(R,this.c(R)),this.b.get(R)}createActivationEventsMap(R){const A=Object.create(null);for(const y of R){const h=this.readActivationEvents(y);h.length>0&&(A[P.ExtensionIdentifier.toKey(y.identifier)]=h)}return A}c(R){if(typeof R.main>"u"&&typeof R.browser>"u")return[];const A=Array.isArray(R.activationEvents)?R.activationEvents.slice(0):[];if(!R.contributes)return A;for(const y in R.contributes){const h=this.a.get(y);if(!h)continue;const O=R.contributes[y],w=Array.isArray(O)?O:[O];try{h(w,A)}catch(g){(0,n.onUnexpectedError)(g)}}return A}}e.ImplicitActivationEventsImpl=I,e.ImplicitActivationEvents=new I}),define(Pe[176],Ae([1,0,20,51,35]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function L(y){if(n.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}function R(y,h,O,w,g,S,p,l){const t=Object.create(null);t["common.machineId"]=S,t.sessionID=(0,I.generateUuid)()+Date.now(),t.commitHash=w,t.version=g,t["common.platformVersion"]=(y||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),t["common.platform"]=(0,n.PlatformToString)(n.platform),t["common.nodePlatform"]=P.platform,t["common.nodeArch"]=O,t["common.product"]=l||"desktop",p&&(t["common.msftInternal"]=p);let o=0;const d=Date.now();Object.defineProperties(t,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-d,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),n.isLinuxSnap&&(t["common.snap"]="true");const D=L(h);return D&&(t["common.platformDetail"]=D),t}e.resolveCommonProperties=R;function A(y){const h=P.env.USERDNSDOMAIN;if(!h)return!1;const O=h.toLowerCase();return y.some(w=>O===w)}e.verifyMicrosoftInternalDomain=A}),define(Pe[177],Ae([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,n.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,n.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var P;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(P||(e.TelemetryLevel=P={}));var I;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(Pe[52],Ae([1,0,23,12,5,42,50,176,177]),function(te,e,n,P,I,L,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class h{constructor(E){this.value=E,this.isTrustedTelemetryValue=!0}}e.TelemetryTrustedValue=h;class O{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.NullTelemetryServiceShape=O,e.NullTelemetryService=new O;class w{async publicLog(E,k,c){}async publicLogError(E,k,c){}}e.NullEndpointTelemetryService=w,e.telemetryLogId="telemetry",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function g(s,E){return I.Event.debounce(E.onDidChangeConfiguration,(c,u)=>{const m=c?new Set([...c.affectedKeys,...u.affectedKeys]):u.affectedKeys;return{...u,affectedKeys:m}},1e3,!0)(c=>{c.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(c.source),configurationKeys:Array.from(c.affectedKeys)})})}e.configurationTelemetry=g;function S(s,E){return!E.isBuilt&&!E.disableTelemetry?!0:!(E.disableTelemetry||!s.enableTelemetry||E.extensionTestsLocationURI)}e.supportsTelemetry=S;function p(s,E){return!(E.isBuilt||E.disableTelemetry||s.enableTelemetry&&s.aiConfig?.ariaKey)}e.isLoggingOnly=p;function l(s){const E=s.getValue(y.TELEMETRY_SETTING_ID),k=s.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(s.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||k===!1)return 0;switch(E??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=l;function t(s){const E={},k={},c={};D(s,c);for(let u in c){u=u.length>150?u.substr(u.length-149):u;const m=c[u];typeof m=="number"?k[u]=m:typeof m=="boolean"?k[u]=m?1:0:typeof m=="string"?(m.length>8192&&console.warn(`Telemetry property: ${u} has been trimmed to 8192, the original length is ${m.length}`),E[u]=m.substring(0,8191)):typeof m<"u"&&m!==null&&(E[u]=m)}return{properties:E,measurements:k}}e.validateTelemetryData=t;const o=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function d(s){if(!s)return"none";const E=(0,R.getRemoteName)(s);return o.has(E)?E:"other"}e.cleanRemoteAuthority=d;function D(s,E,k=0,c){if(s)for(const u of Object.getOwnPropertyNames(s)){const m=s[u],b=c?c+u:u;Array.isArray(m)?E[b]=(0,n.safeStringify)(m):m instanceof Date?E[b]=m.toISOString():(0,P.isObject)(m)?k<2?D(m,E,k+1,b+"."):E[b]=(0,n.safeStringify)(m):E[b]=m}}function T(s,E){const k=s.msftInternalDomains||[],c=E.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(k)||c}e.isInternalTelemetry=T;function v(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}e.getPiiPathsFromEnvironment=v;function i(s,E){if(!s||!s.includes("/")&&!s.includes("\\"))return s;let k=s;const c=[];for(const f of E)for(;;){const N=f.exec(s);if(!N)break;c.push([N.index,f.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,m=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let b=0;for(k="";;){const f=m.exec(s);if(!f)break;const N=c.some(([V,_])=>f.index<_&&V<m.lastIndex);!u.test(f[0])&&!N&&(k+=s.substring(b,f.index)+"<REDACTED: user-file-path>",b=m.lastIndex)}return b<s.length&&(k+=s.substr(b)),k}function a(s){if(!s)return s;const E=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const k of E)if(k.regex.test(s))return`<REDACTED: ${k.label}>`;return s}function r(s,E){return(0,n.cloneAndChange)(s,k=>{if(k instanceof h||Object.hasOwnProperty.call(k,"isTrustedTelemetryValue"))return k.value;if(typeof k=="string"){let c=k.replaceAll("%20"," ");c=i(c,E);for(const u of E)c=c.replace(u,"");return c=a(c),c}})}e.cleanData=r}),define(Pe[178],Ae([1,0,13,91,24,20,2,9,51,52]),function(te,e,n,P,I,L,R,A,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function O(r,s){return r.uuid&&s.uuid?r.uuid===s.uuid:r.id===s.id?!0:(0,n.compareIgnoreCase)(r.id,s.id)===0}e.areSameExtensions=O;const w=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class g{static create(s){const E=s.manifest?s.manifest.version:s.version,k=s.manifest?s.targetPlatform:s.properties.targetPlatform;return new g(s.identifier,E,k)}static parse(s){const E=w.exec(s);return E&&E[1]&&E[2]?new g({id:E[1]},E[2],E[4]||void 0):null}constructor(s,E,k="undefined"){this.version=E,this.targetPlatform=k,this.id=s.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(s){return s instanceof g?O(this,s)&&this.version===s.version&&this.targetPlatform===s.targetPlatform:!1}}e.ExtensionKey=g;const S=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function p(r){const s=S.exec(r);return s&&s[1]?[t(s[1]),s[2]]:[t(r),void 0]}e.getIdAndVersion=p;function l(r,s){return`${r}.${s}`}e.getExtensionId=l;function t(r){return r.toLowerCase()}e.adoptToGalleryExtensionId=t;function o(r,s){return t(l(r??I.UNDEFINED_PUBLISHER,s))}e.getGalleryExtensionId=o;function d(r,s){const E=[],k=c=>{for(const u of E)if(u.some(m=>O(s(m),s(c))))return u;return null};for(const c of r){const u=k(c);u?u.push(c):E.push([c])}return E}e.groupByExtension=d;function D(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=D;function T(r){return{id:new h.TelemetryTrustedValue(r.identifier.id),name:new h.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=T,e.BetterMergeId=new I.ExtensionIdentifier("pprice.better-merge");function v(r,s){const E=[],k=s.manifest.extensionDependencies?.slice(0)??[];for(;k.length;){const c=k.shift();if(c&&E.every(u=>!O(u.identifier,{id:c}))){const u=r.filter(m=>O(m.identifier,{id:c}));u.length===1&&(E.push(u[0]),k.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=v;async function i(r,s){if(!L.isLinux)return!1;let E;try{E=(await r.readFile(R.URI.file("/etc/os-release"))).value.toString()}catch{try{E=(await r.readFile(R.URI.file("/usr/lib/os-release"))).value.toString()}catch(c){s.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(c))}}return!!E&&(E.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function a(r,s){const E=await i(r,s),k=(0,P.getTargetPlatform)(E?"alpine":L.platform,y.arch);return s.debug("ComputeTargetPlatform:",k),k}e.computeTargetPlatform=a}),define(Pe[179],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentDescriptionMap=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentDescriptionMap=e.serializeEnvironmentVariableCollection=void 0;function n(y){return[...y.entries()]}e.serializeEnvironmentVariableCollection=n;function P(y){return y?[...y.entries()]:[]}e.serializeEnvironmentDescriptionMap=P;function I(y){return new Map(y)}e.deserializeEnvironmentVariableCollection=I;function L(y){return new Map(y??[])}e.deserializeEnvironmentDescriptionMap=L;function R(y){return Array.from(y.entries()).map(h=>[h[0],n(h[1].map),P(h[1].descriptionMap)])}e.serializeEnvironmentVariableCollections=R;function A(y){return new Map(y.map(h=>[h[0],{map:I(h[1]),descriptionMap:L(h[2])}]))}e.deserializeEnvironmentVariableCollections=A}),define(Pe[180],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class n{constructor(I){this.b=I,this.a=new Map}dispose(){for(const I of this.a.values())I.dispose()}startBuffering(I,L,R=5){const A=L(y=>{const h=typeof y=="string"?y:y.data;let O=this.a.get(I);if(O){O.data.push(h);return}const w=setTimeout(()=>this.flushBuffer(I),R);O={data:[h],timeoutId:w,dispose:()=>{clearTimeout(w),this.flushBuffer(I),A.dispose()}},this.a.set(I,O)});return A}stopBuffering(I){this.a.get(I)?.dispose()}flushBuffer(I){const L=this.a.get(I);L&&(this.a.delete(I),this.b(I,L.data.join("")))}}e.TerminalDataBufferer=n}),define(Pe[181],Ae([1,0,17,85,39,5,12,2,143,71,30]),function(te,e,n,P,I,L,R,A,y,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var w;(function(T){function v(i,a){let r=i.defaults;for(;I.ThemeIcon.isThemeIcon(r);){const s=p.getIcon(r.id);if(!s)return;r=s.defaults}return r}T.getDefinition=v})(w||(e.IconContribution=w={}));var g;(function(T){function v(a){return{weight:a.weight,style:a.style,src:a.src.map(r=>({format:r.format,location:r.location.toString()}))}}T.toJSONObject=v;function i(a){const r=s=>(0,R.isString)(s)?s:void 0;if(a&&Array.isArray(a.src)&&a.src.every(s=>(0,R.isString)(s.format)&&(0,R.isString)(s.location)))return{weight:r(a.weight),style:r(a.style),src:a.src.map(s=>({format:s.format,location:A.URI.parse(s.location)}))}}T.fromJSONObject=i})(g||(e.IconFontDefinition=g={}));class S{constructor(){this.a=new L.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${I.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(v,i,a,r){const s=this.b[v];if(s){if(a&&!s.description){s.description=a,this.d.properties[v].markdownDescription=`${a} $(${v})`;const c=this.e.enum.indexOf(v);c!==-1&&(this.e.enumDescriptions[c]=a),this.a.fire()}return s}const E={id:v,description:a,defaults:i,deprecationMessage:r};this.b[v]=E;const k={$ref:"#/definitions/icons"};return r&&(k.deprecationMessage=r),a&&(k.markdownDescription=`${a}: $(${v})`),this.d.properties[v]=k,this.e.enum.push(v),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:v}}deregisterIcon(v){delete this.b[v],delete this.d.properties[v];const i=this.e.enum.indexOf(v);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(v=>this.b[v])}getIcon(v){return this.b[v]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(v,i){const a=this.f[v];return a||(this.f[v]=i,this.a.fire(),i)}deregisterIconFont(v){delete this.f[v]}getIconFont(v){return this.f[v]}toString(){const v=(s,E)=>s.id.localeCompare(E.id),i=s=>{for(;I.ThemeIcon.isThemeIcon(s.defaults);)s=this.b[s.defaults.id];return`codicon codicon-${s?s.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(s=>this.b[s]);for(const s of r.filter(E=>!!E.description).sort(v))a.push(`|<i class="${i(s)}"></i>|${s.id}|${I.ThemeIcon.isThemeIcon(s.defaults)?s.defaults.id:s.id}|${s.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const s of r.filter(E=>!I.ThemeIcon.isThemeIcon(E.defaults)).sort(v))a.push(`|<i class="${i(s)}"></i>|${s.id}|`);return a.join(`
`)}}const p=new S;O.Registry.add(e.Extensions.IconContribution,p);function l(T,v,i,a){return p.registerIcon(T,v,i,a)}e.registerIcon=l;function t(){return p}e.getIconRegistry=t;function o(){const T=(0,P.getCodiconFontCharacters)();for(const v in T){const i="\\"+T[v].toString(16);p.registerIcon(v,{fontCharacter:i})}}o(),e.iconsSchemaId="vscode://schemas/icons";const d=O.Registry.as(h.Extensions.JSONContribution);d.registerSchema(e.iconsSchemaId,p.getIconSchema());const D=new n.RunOnceScheduler(()=>d.notifySchemaChanged(e.iconsSchemaId),200);p.onDidChange(()=>{D.isScheduled()||D.schedule()}),e.widgetClose=l("widget-close",P.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=l("goto-previous-location",P.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=l("goto-next-location",P.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=I.ThemeIcon.modify(P.Codicon.sync,"spin"),e.spinningLoading=I.ThemeIcon.modify(P.Codicon.loading,"spin")}),define(Pe[182],Ae([1,0,5,42,3,14]),function(te,e,n,P,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,I.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,I.createDecorator)("sharedTunnelsService");var R;(function(l){l.Http="http",l.Https="https"})(R||(e.TunnelProtocol=R={}));var A;(function(l){l.ConstantPrivate="constantPrivate",l.Private="private",l.Public="public"})(A||(e.TunnelPrivacyId=A={}));var y;(function(l){l[l.Notify=1]="Notify",l[l.OpenBrowser=2]="OpenBrowser",l[l.OpenPreview=3]="OpenPreview",l[l.Silent=4]="Silent",l[l.Ignore=5]="Ignore",l[l.OpenBrowserOnce=6]="OpenBrowserOnce"})(y||(e.ProvidedOnAutoForward=y={}));function h(l){if(l.scheme!=="http"&&l.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(l.authority);if(t)return{address:t[1],port:+t[2]}}e.extractLocalHostUriMetaDataForPortMapping=h,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(l){return e.LOCALHOST_ADDRESSES.indexOf(l)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(l){return e.ALL_INTERFACES_ADDRESSES.indexOf(l)>=0}e.isAllInterfaces=w;function g(l,t,o,d){if(o===1)return!1;if(o===2&&w(t)){const D=/(\d+)\.(\d+)\.(\d+)/g.exec(d);if(D?.length===4&&parseInt(D[1])>=18)return!1}return l<1024}e.isPortPrivileged=g;class S{constructor(t,o,d){this.remoteAddress=t,this.localAddress=o,this.b=d,this.a=new n.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=S;let p=e.AbstractTunnelService=class{constructor(t,o){this.i=t,this.j=o,this.a=new n.Emitter,this.onTunnelOpened=this.a.event,this.b=new n.Emitter,this.onTunnelClosed=this.b.event,this.c=new n.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const t=this.j.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.e=t,t?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.f=t.elevation,this.g=t.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const t=[],o=Array.from(this.d.values());for(const d of o){const D=Array.from(d.values());for(const T of D){const v=await T.value;v&&t.push(v)}}return t}async dispose(){for(const t of this.d.values()){for(const{value:o}of t.values())await o.then(d=>d?.dispose());t.clear()}this.d.clear()}setEnvironmentTunnel(t,o,d,D,T){this.o(t,o,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:o,localAddress:d,privacy:D,protocol:T,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,o){(w(t)||O(t))&&(t=e.LOCALHOST_ADDRESSES[0]);const d=this.q(t,o);if(d)return++d.refcount,d.value}openTunnel(t,o,d,D,T,v=!1,i,a){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${o}:${d} on local port ${T}.`),!t)return;if(o||(o="localhost"),D||(D=this.k),this.e&&this.h.has(d)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(t,o,d,D,T,v,i,a);return r?r.then(s=>{if(!s){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(o,d);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const E=this.m(s);return(s.tunnelRemoteHost!==o||s.tunnelRemotePort!==d)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(E),E}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const o=this.d.get(t.tunnelRemoteHost);if(o){const d=o.get(t.tunnelRemotePort);d&&(d.refcount--,await this.n(t.tunnelRemoteHost,t.tunnelRemotePort,d))}}}}async n(t,o,d){if(d.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${o}.`);const D=d.value.then(async T=>{T&&(await T.dispose(!0),this.b.fire({host:T.tunnelRemoteHost,port:T.tunnelRemotePort}))});return this.d.has(t)&&this.d.get(t).delete(o),D}}async closeTunnel(t,o){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${o} `);const d=this.d.get(t);if(d&&d.has(o)){const D=d.get(o);D.refcount=0,await this.n(t,o,D)}}o(t,o,d){this.d.has(t)||this.d.set(t,new Map),this.d.get(t).set(o,{refcount:1,value:d})}async p(t,o){const d=this.d.get(t);d&&(await d.get(o)||d.delete(o),d.size===0&&this.d.delete(t))}q(t,o){const d=[t];O(t)?(d.push(...e.LOCALHOST_ADDRESSES),d.push(...e.ALL_INTERFACES_ADDRESSES)):w(t)&&d.push(...e.ALL_INTERFACES_ADDRESSES);const D=d.map(T=>this.d.get(T));for(const T of D){const v=T?.get(o);if(v)return v}}canTunnel(t){return!!h(t)}s(t,o,d,D,T,v,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${o}:${d} on local port ${D}.`);const a=d;this.h.add(a);const r=D===void 0?d:D,s={elevationRequired:T?this.isPortPrivileged(r):!1},E={remoteAddress:{host:o,port:d},localAddressPort:D,privacy:v,public:v?v!==A.Private:void 0,protocol:i},k=t.forwardPort(E,s);return k?(this.o(o,d,k),k.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(a)})):this.h.delete(a),k}};e.AbstractTunnelService=p=xe([qe(0,L.ILogService),qe(1,P.IConfigurationService)],p)}),define(Pe[183],Ae([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,n.createDecorator)("editSessionIdentityService");var P;(function(I){I[I.Complete=100]="Complete",I[I.Partial=50]="Partial",I[I.None=0]="None"})(P||(e.EditSessionIdentityMatch=P={}))}),define(Pe[184],Ae([1,0,15]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function P(y){return y.scheme!==n.Schemas.file&&y.scheme!==n.Schemas.vscodeRemote}e.isVirtualResource=P;function I(y){if(y.folders.length)return y.folders.every(h=>P(h.uri))?y.folders[0].uri:void 0;if(y.configuration&&P(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=I;function L(y){return I(y)?.scheme}e.getVirtualWorkspaceScheme=L;function R(y){return I(y)?.authority}e.getVirtualWorkspaceAuthority=R;function A(y){return I(y)!==void 0}e.isVirtualWorkspace=A}),define(Pe[53],Ae([1,0,144,19,48,22,2,3,15]),function(te,e,n,P,I,L,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isStandaloneEditorWorkspace=e.STANDALONE_EDITOR_WORKSPACE_ID=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function h(s){const E=s;return typeof E?.id=="string"&&R.URI.isUri(E.uri)}e.isSingleFolderWorkspaceIdentifier=h;function O(s){return typeof s?.id=="string"&&!h(s)&&!g(s)}e.isEmptyWorkspaceIdentifier=O,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function w(s,E){if(typeof s=="string"||typeof s>"u")return typeof s=="string"?{id:(0,P.basename)(s)}:E?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const k=s;return k.configuration?{id:k.id,configPath:k.configuration}:k.folders.length===1?{id:k.id,uri:k.folders[0].uri}:{id:k.id}}e.toWorkspaceIdentifier=w;function g(s){const E=s;return typeof E?.id=="string"&&R.URI.isUri(E.configPath)}e.isWorkspaceIdentifier=g;function S(s){const E=s;if(E?.uri)return{id:E.id,uri:R.URI.revive(E.uri)};const k=s;if(k?.configPath)return{id:k.id,configPath:R.URI.revive(k.configPath)};if(s?.id)return{id:s.id}}e.reviveIdentifier=S;var p;(function(s){s[s.EMPTY=1]="EMPTY",s[s.FOLDER=2]="FOLDER",s[s.WORKSPACE=3]="WORKSPACE"})(p||(e.WorkbenchState=p={}));function l(s){const E=s;return!!(E&&typeof E=="object"&&typeof E.id=="string"&&Array.isArray(E.folders))}e.isWorkspace=l;function t(s){const E=s;return!!(E&&typeof E=="object"&&R.URI.isUri(E.uri)&&typeof E.name=="string"&&typeof E.toResource=="function")}e.isWorkspaceFolder=t;class o{constructor(E,k,c,u,m){this.h=E,this.j=c,this.k=u,this.l=m,this.c=I.TernarySearchTree.forUris(this.l,()=>!0),this.folders=k}update(E){this.h=E.id,this.k=E.configuration,this.j=E.transient,this.l=E.l,this.folders=E.folders}get folders(){return this.g}set folders(E){this.g=E,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(E){this.k=E}getFolder(E){return E&&this.c.findSubstr(E)||null}n(){this.c=I.TernarySearchTree.forUris(this.l,()=>!0);for(const E of this.folders)this.c.set(E.uri,E)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=o;class d{constructor(E,k){this.raw=k,this.uri=E.uri,this.index=E.index,this.name=E.name}toResource(E){return(0,L.joinPath)(this.uri,E)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=d;function D(s){return new d({uri:s,index:0,name:(0,L.basenameOrAuthority)(s)},{uri:s.toString()})}e.toWorkspaceFolder=D,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,n.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function T(s,E){return L.extUriBiasedIgnorePathCase.isEqualOrParent(s,E.untitledWorkspacesHome)}e.isUntitledWorkspace=T;function v(s){let E;return R.URI.isUri(s)?E=s:E=s.configuration,E?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=v,e.STANDALONE_EDITOR_WORKSPACE_ID="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(s){return s.id===e.STANDALONE_EDITOR_WORKSPACE_ID}e.isStandaloneEditorWorkspace=i;function a(s,E){return!T(s,E)&&!v(s)}e.isSavedWorkspace=a;function r(s){return(typeof s=="string"?(0,P.extname)(s):(0,L.extname)(s))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(Pe[54],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class n{constructor(I){this.d=I,this.b=new Map,this.c=1}add(I){const L=this.c++;return this.b.set(L,I),this.e(),L}get(I,L){return this.b.has(I)?this.b.get(I)[L]:void 0}delete(I){this.b.delete(I),this.e()}e(){n.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.Cache=n,n.a=!1}),define(Pe[37],Ae([1,0,15,22,3]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this.a=new Set(Object.keys(n.Schemas)),this.b=new Map,this.extUri=new P.ExtUri(A=>{const y=this.b.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this.b.delete(A.scheme):this.b.set(A.scheme,y)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,I.createDecorator)("IExtHostFileSystemInfo")}),define(Pe[27],Ae([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,n.createDecorator)("IExtHostInitDataService")}),define(Pe[185],Ae([1,0,149,14,171,27]),function(te,e,n,P,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=e.ExtHostLogService=class extends I.LogService{constructor(y,h,O){const w=O.remote.isRemote?"remoteexthost":y?"workerexthost":"exthost",g=O.remote.isRemote?(0,n.localize)(0,null):y?(0,n.localize)(1,null):(0,n.localize)(2,null);super(h.createLogger(w,{name:g}))}};e.ExtHostLogService=R=xe([qe(1,P.ILoggerService),qe(2,L.IExtHostInitDataService)],R)}),define(Pe[186],Ae([1,0,17]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class P{constructor(R,A,y){this.h=new Map,this.a=R,this.b=A,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(h=>(this.f=h,this)),this.g=this.c.onDidChangeStorage(h=>{h.shared===this.b&&h.key===this.a&&(this.f=h.value)}),this.i=new n.RunOnceScheduler(()=>{const h=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of h.values())O.complete()}catch(O){for(const w of h.values())w.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this.d}get(R,A){let y=this.f[R];return typeof y>"u"&&(y=A),y}update(R,A){this.f[R]=A;const y=this.h.get(R);if(y!==void 0)return y.p;const h=new n.DeferredPromise;return this.h.set(R,h),this.i.isScheduled()||this.i.schedule(),h.p}dispose(){this.g.dispose()}}e.ExtensionMemento=P;class I extends P{setKeysForSync(R){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},R)}constructor(R,A){super(R.identifier.value,!0,A),this.j=R}}e.ExtensionGlobalMemento=I}),define(Pe[187],Ae([1,0,5,2]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class I{constructor(R){this.c=R,this.a=new n.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new n.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(R,A,y,h){const w=this.c.getNotebookDocument(P.URI.revive(R)).acceptModelChanged(A.value,y,h);this.b.fire(w)}$acceptDirtyStateChanged(R,A){this.c.getNotebookDocument(P.URI.revive(R)).acceptDirty(A)}$acceptModelSaved(R){const A=this.c.getNotebookDocument(P.URI.revive(R));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=I}),define(Pe[18],Ae([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,n.createDecorator)("IExtHostRpcService");class P{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=P});var _e=this&&this.__classPrivateFieldSet||function(te,e,n,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(te,n):I?I.value=n:e.set(te,n),n},Ne=this&&this.__classPrivateFieldGet||function(te,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(te):P?P.value:e.get(te)};define(Pe[188],Ae([1,0,24,5]),function(te,e,n,P){"use strict";var I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(A,y){I.set(this,void 0),this.b=new P.Emitter,this.onDidChange=this.b.event,this.a=n.ExtensionIdentifier.toKey(A.identifier),_e(this,I,y,"f"),Ne(this,I,"f").onDidChangePassword(h=>{h.extensionId===this.a&&this.b.fire({key:h.key})})}get(A){return Ne(this,I,"f").get(this.a,A)}store(A,y){return Ne(this,I,"f").store(this.a,A,y)}delete(A){return Ne(this,I,"f").delete(this.a,A)}}e.ExtensionSecrets=L,I=new WeakMap}),define(Pe[72],Ae([1,0,3,182,5,18]),function(te,e,n,P,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var R;(function(y){function h(w){return{remoteAddress:w.remoteAddress,localAddress:w.localAddress,public:!!w.public,privacy:w.privacy??(w.public?P.TunnelPrivacyId.Public:P.TunnelPrivacyId.Private),protocol:w.protocol}}y.fromApiTunnel=h;function O(w){return{remoteAddress:{host:w.tunnelRemoteHost,port:w.tunnelRemotePort},localAddress:w.localAddress,public:w.privacy!==P.TunnelPrivacyId.ConstantPrivate&&w.privacy!==P.TunnelPrivacyId.ConstantPrivate,privacy:w.privacy,protocol:w.protocol}}y.fromServiceTunnel=O})(R||(e.TunnelDtoConverter=R={})),e.IExtHostTunnelService=(0,n.createDecorator)("IExtHostTunnelService");let A=e.ExtHostTunnelService=class{constructor(h){this.onDidChangeTunnels=new I.Emitter().event}async $applyCandidateFilter(h){return h}async openTunnel(h,O){}async getTunnels(){return[]}async setTunnelFactory(h){return{dispose:()=>{}}}registerPortsAttributesProvider(h,O){return{dispose:()=>{}}}async $providePortAttributes(h,O,w,g,S){return[]}async $forwardPort(h,O){}async $closeTunnel(h){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};e.ExtHostTunnelService=A=xe([qe(0,L.IExtHostRpcService)],A)}),define(Pe[55],Ae([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,n.createDecorator)("IURITransformerService");class P{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=P}),define(Pe[189],Ae([1,0,25]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class P{constructor(){this.buffers=[]}add(y){let h=this.buffers.indexOf(y);return h<0&&(h=this.buffers.length,this.buffers.push(y)),h}}function I(A,y){if(y.serializeBuffersForPostMessage){const h=new P,w=JSON.stringify(A,(S,p)=>{if(p instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:h.add(p)};if(ArrayBuffer.isView(p)){const l=L(p);if(l)return{$$vscode_array_buffer_reference$$:!0,index:h.add(p.buffer),view:{type:l,byteLength:p.byteLength,byteOffset:p.byteOffset}}}return p}),g=h.buffers.map(S=>{const p=new Uint8Array(S);return n.VSBuffer.wrap(p)});return{message:w,buffers:g}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=I;function L(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(A,y){const h=y.map(g=>{const S=new ArrayBuffer(g.byteLength);return new Uint8Array(S).set(g.buffer),S}),O=y.length?(g,S)=>{if(S&&typeof S=="object"&&S.$$vscode_array_buffer_reference$$){const p=S,{index:l}=p,t=h[l];if(p.view)switch(p.view.type){case 1:return new Int8Array(t,p.view.byteOffset,p.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(t,p.view.byteOffset,p.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(t,p.view.byteOffset,p.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(t,p.view.byteOffset,p.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(t,p.view.byteOffset,p.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(t,p.view.byteOffset,p.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(t,p.view.byteOffset,p.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(t,p.view.byteOffset,p.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(t,p.view.byteOffset,p.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(t,p.view.byteOffset,p.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(t,p.view.byteOffset,p.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return t}return S}:void 0;return{message:JSON.parse(A,O),arrayBuffers:h}}e.deserializeWebviewMessage=R}),define(Pe[98],Ae([1,0,156,12,2,6,3,30,43,15,40,128,29]),function(te,e,n,P,I,L,R,A,y,h,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,n.localize)(0,null),providerDisplayName:(0,n.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var S;(function(le){le[le.PROGRAMMATIC=1]="PROGRAMMATIC",le[le.USER=2]="USER",le[le.EDIT=3]="EDIT",le[le.NAVIGATION=4]="NAVIGATION",le[le.JUMP=5]="JUMP"})(S||(e.EditorPaneSelectionChangeReason=S={}));var p;(function(le){le[le.IDENTICAL=1]="IDENTICAL",le[le.SIMILAR=2]="SIMILAR",le[le.DIFFERENT=3]="DIFFERENT"})(p||(e.EditorPaneSelectionCompareResult=p={}));function l(le){const ue=le;return!!ue&&typeof ue.getSelection=="function"&&!!ue.onDidChangeSelection}e.isEditorPaneWithSelection=l;function t(le,ue,H){for(const F of H.visibleEditorPanes)if(F.group.id===ue&&le.matches(F.input))return F.getViewState()}e.findViewStateForEditor=t;function o(le){if(u(le))return!1;const ue=le;return I.URI.isUri(ue?.resource)}e.isResourceEditorInput=o;function d(le){if(u(le))return!1;const ue=le;return ue?.original!==void 0&&ue.modified!==void 0}e.isResourceDiffEditorInput=d;function D(le){if(u(le)||d(le))return!1;const ue=le;return ue?.primary!==void 0&&ue.secondary!==void 0}e.isResourceSideBySideEditorInput=D;function T(le){if(u(le))return!1;const ue=le;return ue?ue.resource===void 0||ue.resource.scheme===h.Schemas.untitled||ue.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=T;const v=/Untitled-\d+/;function i(le){return le.scheme===h.Schemas.untitled&&le.path.length>1&&!v.test(le.path)}e.isUntitledWithAssociatedResource=i;function a(le){if(u(le))return!1;const ue=le;return I.URI.isUri(ue?.base?.resource)&&I.URI.isUri(ue?.input1?.resource)&&I.URI.isUri(ue?.input2?.resource)&&I.URI.isUri(ue?.result?.resource)}e.isResourceMergeEditorInput=a;var r;(function(le){le[le.SHORT=0]="SHORT",le[le.MEDIUM=1]="MEDIUM",le[le.LONG=2]="LONG"})(r||(e.Verbosity=r={}));var s;(function(le){le[le.EXPLICIT=1]="EXPLICIT",le[le.AUTO=2]="AUTO",le[le.FOCUS_CHANGE=3]="FOCUS_CHANGE",le[le.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(s||(e.SaveReason=s={}));class E{constructor(){this.a=new Map}registerSource(ue,H){let F=this.a.get(ue);return F||(F={source:ue,label:H},this.a.set(ue,F)),F.source}getSourceLabel(ue){return this.a.get(ue)?.label??ue}}e.SaveSourceRegistry=new E;var k;(function(le){le[le.None=0]="None",le[le.Readonly=2]="Readonly",le[le.Untitled=4]="Untitled",le[le.Singleton=8]="Singleton",le[le.RequiresTrust=16]="RequiresTrust",le[le.CanSplitInGroup=32]="CanSplitInGroup",le[le.ForceDescription=64]="ForceDescription",le[le.CanDropIntoEditor=128]="CanDropIntoEditor",le[le.MultipleEditors=256]="MultipleEditors"})(k||(e.EditorInputCapabilities=k={}));class c extends L.Disposable{}e.AbstractEditorInput=c;function u(le){return le instanceof c}e.isEditorInput=u;function m(le){const ue=le;return I.URI.isUri(ue?.preferredResource)}function b(le){const ue=le;return u(ue?.primary)&&u(ue?.secondary)}e.isSideBySideEditorInput=b;function f(le){const ue=le;return u(ue?.modified)&&u(ue?.original)}e.isDiffEditorInput=f;function N(le,ue,H,F,Q){return Re(F,[(0,w.toAction)({id:"workbench.action.openLargeFile",label:(0,n.localize)(2,null),run:()=>{const me={...H,limits:{size:Number.MAX_VALUE}};le.openEditor(ue,me)}}),(0,w.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,n.localize)(3,null),run:()=>Q.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:g.default.Warning})}e.createTooLargeFileError=N;function V(le){return u(le?.editor)}e.isEditorInputWithOptions=V;function _(le){const ue=le;return V(le)&&ue?.group!==void 0}e.isEditorInputWithOptionsAndGroup=_;function G(le){const ue=le;return typeof ue?.groupId=="number"&&u(ue.editor)}e.isEditorIdentifier=G;var $;(function(le){le[le.UNKNOWN=0]="UNKNOWN",le[le.REPLACE=1]="REPLACE",le[le.MOVE=2]="MOVE",le[le.UNPIN=3]="UNPIN"})($||(e.EditorCloseContext=$={}));var B;(function(le){le[le.GROUP_ACTIVE=0]="GROUP_ACTIVE",le[le.GROUP_INDEX=1]="GROUP_INDEX",le[le.GROUP_LOCKED=2]="GROUP_LOCKED",le[le.EDITOR_OPEN=3]="EDITOR_OPEN",le[le.EDITOR_CLOSE=4]="EDITOR_CLOSE",le[le.EDITOR_MOVE=5]="EDITOR_MOVE",le[le.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",le[le.EDITOR_LABEL=7]="EDITOR_LABEL",le[le.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",le[le.EDITOR_PIN=9]="EDITOR_PIN",le[le.EDITOR_STICKY=10]="EDITOR_STICKY",le[le.EDITOR_DIRTY=11]="EDITOR_DIRTY",le[le.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(B||(e.GroupModelChangeKind=B={}));var X;(function(le){le[le.PRIMARY=1]="PRIMARY",le[le.SECONDARY=2]="SECONDARY",le[le.BOTH=3]="BOTH",le[le.ANY=4]="ANY"})(X||(e.SideBySideEditor=X={}));class U{getOriginalUri(ue,H){if(!ue)return;if(a(ue))return e.EditorResourceAccessor.getOriginalUri(ue.result,H);if(H?.supportSideBySide){const{primary:Q,secondary:me}=this.a(ue);if(Q&&me){if(H?.supportSideBySide===X.BOTH)return{primary:this.getOriginalUri(Q,{filterByScheme:H.filterByScheme}),secondary:this.getOriginalUri(me,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===X.ANY)return this.getOriginalUri(Q,{filterByScheme:H.filterByScheme})??this.getOriginalUri(me,{filterByScheme:H.filterByScheme});ue=H.supportSideBySide===X.PRIMARY?Q:me}}if(d(ue)||D(ue)||a(ue))return;const F=m(ue)?ue.preferredResource:ue.resource;return!F||!H||!H.filterByScheme?F:this.b(F,H.filterByScheme)}a(ue){return b(ue)||D(ue)?{primary:ue.primary,secondary:ue.secondary}:f(ue)||d(ue)?{primary:ue.modified,secondary:ue.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ue,H){if(!ue)return;if(a(ue))return e.EditorResourceAccessor.getCanonicalUri(ue.result,H);if(H?.supportSideBySide){const{primary:Q,secondary:me}=this.a(ue);if(Q&&me){if(H?.supportSideBySide===X.BOTH)return{primary:this.getCanonicalUri(Q,{filterByScheme:H.filterByScheme}),secondary:this.getCanonicalUri(me,{filterByScheme:H.filterByScheme})};if(H?.supportSideBySide===X.ANY)return this.getCanonicalUri(Q,{filterByScheme:H.filterByScheme})??this.getCanonicalUri(me,{filterByScheme:H.filterByScheme});ue=H.supportSideBySide===X.PRIMARY?Q:me}}if(d(ue)||D(ue)||a(ue))return;const F=ue.resource;return!F||!H||!H.filterByScheme?F:this.b(F,H.filterByScheme)}b(ue,H){if(Array.isArray(H)){if(H.some(F=>ue.scheme===F))return ue}else if(H===ue.scheme)return ue}}e.EditorResourceAccessor=new U;var j;(function(le){le[le.LEFT=0]="LEFT",le[le.RIGHT=1]="RIGHT"})(j||(e.CloseDirection=j={}));class Y{constructor(){this.c=new Map,this.d=new Map}start(ue){const H=this.a=ue.get(R.IInstantiationService);for(const[F,Q]of this.c)this.e(F,Q,H);this.c.clear()}e(ue,H,F){const Q=F.createInstance(H);this.d.set(ue,Q)}registerFileEditorFactory(ue){if(this.b)throw new Error("Can only register one file editor factory.");this.b=ue}getFileEditorFactory(){return(0,P.assertIsDefined)(this.b)}registerEditorSerializer(ue,H){if(this.c.has(ue)||this.d.has(ue))throw new Error(`A editor serializer with type ID '${ue}' was already registered.`);return this.a?this.e(ue,H,this.a):this.c.set(ue,H),(0,L.toDisposable)(()=>{this.c.delete(ue),this.d.delete(ue)})}getEditorSerializer(ue){return this.d.get(typeof ue=="string"?ue:ue.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new Y);async function pe(le,ue,H){return!le||!le.length?[]:await Promise.all(le.map(async F=>{const Q=I.URI.revive(F.fileUri);if(!Q){H.info("Cannot resolve the path because it is not valid.",F);return}if(!await ue.canHandleResource(Q)){H.info("Cannot resolve the path because it cannot be handled",F);return}let Ce=F.exists,De=F.type;if(typeof Ce!="boolean"||typeof De!="number")try{De=(await ue.stat(Q)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Ce=!0}catch(ke){H.error(ke),Ce=!1}if(!Ce&&F.openOnlyIfExists){H.info("Cannot resolve the path because it does not exist",F);return}if(De===y.FileType.Directory){H.info("Cannot resolve the path because it is a directory",F);return}const be={...F.options,pinned:!0};return Ce?{resource:Q,options:be}:{resource:Q,options:be,forceUntitled:!0}}))}e.pathsToEditors=pe;var Ee;(function(le){le[le.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",le[le.SEQUENTIAL=1]="SEQUENTIAL"})(Ee||(e.EditorsOrder=Ee={}));function he(le){const ue=le;if(!ue)return!1;const H=ue;if(H.modified)return he(H.modified);const F=ue;return!!(F.contributionsState&&F.viewState&&Array.isArray(F.cursorState))}e.isTextEditorViewState=he;function de(le){return(0,O.isErrorWithActions)(le)}e.isEditorOpenError=de;function Re(le,ue,H){const F=(0,O.createErrorWithActions)(le,ue);return F.forceMessage=H?.forceMessage,F.forceSeverity=H?.forceSeverity,F.allowDialog=H?.allowDialog,F}e.createEditorOpenError=Re}),define(Pe[190],Ae([1,0,5,157,3,6,28,30,16,64,23,85,181]),function(te,e,n,P,I,L,R,A,y,h,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,g.registerIcon)("default-view-icon",w.Codicon.window,(0,P.localize)(0,null));var S;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var p;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(p||(e.ViewContainerLocation=p={})),e.ViewContainerLocations=[0,1,2];function l(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=l;class t extends L.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new n.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(s,E,k){const c=this.get(s.id);if(c)return c;const u=s;return u.openCommandActionDescriptor=k?.doNotRegisterOpenCommand?void 0:u.openCommandActionDescriptor??{id:u.id},(0,R.getOrSet)(this.g,E,[]).push(u),k?.isDefault&&this.h.push(u),this.c.fire({viewContainer:u,viewContainerLocation:E}),u}deregisterViewContainer(s){for(const E of this.g.keys()){const k=this.g.get(E),c=k?.indexOf(s);if(c!==-1){k?.splice(c,1),k.length===0&&this.g.delete(E),this.f.fire({viewContainer:s,viewContainerLocation:E});return}}}get(s){return this.all.filter(E=>E.id===s)[0]}getViewContainers(s){return[...this.g.get(s)||[]]}getViewContainerLocation(s){return[...this.g.keys()].filter(E=>this.getViewContainers(E).filter(k=>k?.id===s.id).length>0)[0]}getDefaultViewContainer(s){return this.h.find(E=>this.getViewContainerLocation(E)===s)}}A.Registry.add(S.ViewContainersRegistry,new t);var o;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(o||(e.ViewContentGroups=o={}));function d(r,s){const E=r.group??o.More,k=s.group??o.More;return E!==k?E.localeCompare(k):(r.order??5)-(s.order??5)}class D extends L.Disposable{constructor(){super(...arguments),this.c=this.B(new n.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new n.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new n.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new n.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new h.SetMap}registerViews(s,E){this.registerViews2([{views:s,viewContainer:E}])}registerViews2(s){s.forEach(({views:E,viewContainer:k})=>this.l(E,k)),this.c.fire(s)}deregisterViews(s,E){const k=this.m(s,E);k.length&&this.f.fire({views:k,viewContainer:E})}moveViews(s,E){for(const k of this.j.keys())if(k!==E){const c=this.m(s,k);c.length&&(this.l(c,E),this.g.fire({views:c,from:k,to:E}))}}getViews(s){return this.j.get(s)||[]}getView(s){for(const E of this.i){const k=(this.j.get(E)||[]).filter(c=>c.id===s)[0];if(k)return k}return null}getViewContainer(s){for(const E of this.i)if((this.j.get(E)||[]).filter(c=>c.id===s)[0])return E;return null}registerViewWelcomeContent(s,E){return this.k.add(s,E),this.h.fire(s),(0,L.toDisposable)(()=>{this.k.delete(s,E),this.h.fire(s)})}registerViewWelcomeContent2(s,E){const k=new Map;for(const[c,u]of E)this.k.add(s,u),k.set(c,(0,L.toDisposable)(()=>{this.k.delete(s,u),this.h.fire(s)}));return this.h.fire(s),k}getViewWelcomeContent(s){const E=[];return this.k.forEach(s,k=>E.push(k)),E.sort(d)}l(s,E){let k=this.j.get(E);k||(k=[],this.j.set(E,k),this.i.push(E));for(const c of s){if(this.getView(c.id)!==null)throw new Error((0,P.localize)(1,null,c.id));k.push(c)}}m(s,E){const k=this.j.get(E);if(!k)return[];const c=[],u=[];for(const m of k)s.includes(m)?c.push(m):u.push(m);return c.length&&(u.length?this.j.set(E,u):(this.j.delete(E),this.i.splice(this.i.indexOf(E),1))),c}}A.Registry.add(S.ViewsRegistry,new D),e.IViewsService=(0,I.createDecorator)("viewsService"),e.IViewDescriptorService=(0,I.createDecorator)("viewDescriptorService");var T;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(T||(e.ViewVisibilityState=T={}));var v;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(v||(e.TreeItemCollapsibleState=v={}));class i{constructor(s,E){this.c=!1,this.d=!1,(0,O.mixin)(this,s),this.d=!!E,this.resolve=async k=>{if(E&&!this.c){const c=await E(k);c&&(this.tooltip=this.tooltip??c.tooltip,this.command=this.command??c.command)}k.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class a extends Error{constructor(s){super((0,P.localize)(2,null,s)),this.name="NoTreeViewError"}static is(s){return s.name==="NoTreeViewError"}}e.NoTreeViewError=a}),define(Pe[191],Ae([1,0,5,17,158]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.f=new Map,this.k=[],this.m=new n.Emitter,this.n=new n.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,y,h,O){const w={command:A};if(y&&Object.keys(y).length>0&&(w.arguments=y),this.s("request",w),typeof O=="number"){const g=setTimeout(()=>{clearTimeout(g);const S=this.f.get(w.seq);if(S){this.f.delete(w.seq);const p={type:"response",seq:0,request_seq:w.seq,success:!1,command:A,message:(0,I.localize)(0,null,O,A)};S(p)}},O)}return h&&this.f.set(w.seq,h),w.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,y){return A.type!=="event"||y.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,P.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const y=A,h=this.f.get(y.request_seq);h&&(this.f.delete(y.request_seq),h(y));break}}}}s(A,y){y.type=A,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((y,h)=>A.set(h,y)),await(0,P.timeout)(500),A.forEach((y,h)=>{y({type:"response",seq:0,request_seq:h,success:!1,command:"canceled",message:"canceled"}),this.f.delete(h)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=L}),define(Pe[192],Ae([1,0,159,31,3]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new P.RawContextKey("debugType",void 0,{type:"string",description:n.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new P.RawContextKey("debugConfigurationType",void 0,{type:"string",description:n.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new P.RawContextKey("debugState","inactive",{type:"string",description:n.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new P.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:n.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new P.RawContextKey("hasDebugged",!1,{type:"boolean",description:n.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new P.RawContextKey("inDebugMode",!1,{type:"boolean",description:n.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new P.RawContextKey("inDebugRepl",!1,{type:"boolean",description:n.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new P.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:n.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new P.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:n.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new P.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:n.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new P.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:n.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new P.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:n.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new P.RawContextKey("variablesFocused",!0,{type:"boolean",description:n.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new P.RawContextKey("expressionSelected",!1,{type:"boolean",description:n.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new P.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:n.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new P.RawContextKey("callStackItemType",void 0,{type:"string",description:n.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new P.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:n.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new P.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:n.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new P.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:n.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new P.RawContextKey("watchItemType",void 0,{type:"string",description:n.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new P.RawContextKey("canViewMemory",void 0,{type:"boolean",description:n.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new P.RawContextKey("breakpointItemType",void 0,{type:"string",description:n.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new P.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:n.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new P.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:n.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new P.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:n.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new P.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:n.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new P.RawContextKey("stepBackSupported",!1,{type:"boolean",description:n.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new P.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:n.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new P.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:n.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new P.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:n.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new P.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:n.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new P.RawContextKey("breakpointsExist",!1,{type:"boolean",description:n.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new P.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:n.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new P.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:n.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new P.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:n.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new P.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:n.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new P.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:n.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new P.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:n.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new P.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:n.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new P.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:n.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new P.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:n.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new P.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:n.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new P.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:n.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new P.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:n.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new P.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:n.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new P.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:n.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new P.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:n.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new P.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:n.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new P.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:n.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new P.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:n.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new P.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:n.localize(50,null)});const L=g=>n.localize(51,null,g);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:n.localize(52,null)};var R;(function(g){g[g.Inactive=0]="Inactive",g[g.Initializing=1]="Initializing",g[g.Stopped=2]="Stopped",g[g.Running=3]="Running"})(R||(e.State=R={}));function A(g){switch(g){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(g){g[g.Valid=0]="Valid",g[g.Unreadable=1]="Unreadable",g[g.Error=2]="Error"})(y||(e.MemoryRangeType=y={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var h;(function(g){g[g.Initial=1]="Initial",g[g.Dynamic=2]="Dynamic"})(h||(e.DebugConfigurationProviderTriggerKind=h={}));var O;(function(g){g.UnverifiedBreakpoints="unverifiedBreakpoints"})(O||(e.DebuggerString=O={})),e.IDebugService=(0,I.createDecorator)("debugService");var w;(function(g){g[g.CONDITION=0]="CONDITION",g[g.HIT_COUNT=1]="HIT_COUNT",g[g.LOG_MESSAGE=2]="LOG_MESSAGE"})(w||(e.BreakpointWidgetContext=w={}))}),define(Pe[193],Ae([1,0,13,2,19,23,15,44,21,16]),function(te,e,n,P,I,L,R,A,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const O=/{([^}]+)}/g;function w(c,u,m){return c.replace(O,function(b,f){return u&&f.length>0&&f[0]!=="_"?b:m&&m.hasOwnProperty(f)?m[f]:b})}e.formatPII=w;function g(c){const u={};for(const m of Object.keys(c))m.startsWith("!")||(u[m]=c[m]);return u}e.filterExceptionsFromTelemetry=g;function S(c){return c.configuration.request==="attach"&&!p(c)&&(!c.parentSession||S(c.parentSession))}e.isSessionAttach=S;function p(c){let u=c.configuration.type;if(u)return u==="vslsShare"&&(u=c.configuration.adapterProxy.configuration.type),(0,n.equalsIgnoreCase)(u,"extensionhost")||(0,n.equalsIgnoreCase)(u,"pwa-extensionhost")?c:c.parentSession?p(c.parentSession):void 0}e.getExtensionHostDebugSession=p;function l(c){return c.type&&(c.label||c.program||c.runtime)}e.isDebuggerMainContribution=l;function t(c,u,m){let b,f=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=N.exec(c);){const _=V.index+1,G=_+V[0].length;if(_<=u&&G>=m){b=V[0],f=_;break}}if(b){const _=/\w+/g;let G=null;for(;(G=_.exec(b))&&!(G.index+1+f+G[0].length>=m););G&&(b=b.substring(0,_.lastIndex))}return b?{start:f,end:f+b.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=t;async function o(c,u,m,b){if(c.evaluatableExpressionProvider.has(u)){const f=c.evaluatableExpressionProvider.ordered(u),N=(0,h.coalesce)(await Promise.all(f.map(async V=>{try{return await V.provideEvaluatableExpression(u,m,b??y.CancellationToken.None)}catch{return}})));if(N.length>0){let V=N[0].expression;const _=N[0].range;return V||(V=u.getLineContent(m.lineNumber).substring(_.startColumn-1,_.endColumn-1)),{range:_,matchingExpression:V}}}else{const f=u.getLineContent(m.lineNumber),{start:N,end:V}=t(f,m.column,m.column),_=f.substring(N-1,V);return{matchingExpression:_,range:new A.Range(m.lineNumber,N,m.lineNumber,N+_.length)}}return null}e.getEvaluatableExpressionAtPosition=o;const d=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function D(c){return!!(c&&c.match(d))}e.isUri=D;function T(c){if(typeof c.path=="string"&&!(typeof c.sourceReference=="number"&&c.sourceReference>0)){if(D(c.path))return P.URI.parse(c.path);if((0,I.isAbsolute)(c.path))return P.URI.file(c.path)}return c.path}function v(c){if(typeof c.path=="object"){const u=P.URI.revive(c.path);if(u)return u.scheme===R.Schemas.file?u.fsPath:u.toString()}return c.path}function i(c,u){const m=u?T:v,b=(0,L.deepClone)(c);return r(b,(f,N)=>{f&&N&&(N.path=m(N))}),b}e.convertToDAPaths=i;function a(c,u){const m=u?T:v,b=(0,L.deepClone)(c);return r(b,(f,N)=>{!f&&N&&(N.path=m(N))}),b}e.convertToVSCPaths=a;function r(c,u){switch(c.type){case"event":{const m=c;switch(m.event){case"output":u(!1,m.body.source);break;case"loadedSource":u(!1,m.body.source);break;case"breakpoint":u(!1,m.body.breakpoint.source);break;default:break}break}case"request":{const m=c;switch(m.command){case"setBreakpoints":u(!0,m.arguments.source);break;case"breakpointLocations":u(!0,m.arguments.source);break;case"source":u(!0,m.arguments.source);break;case"gotoTargets":u(!0,m.arguments.source);break;case"launchVSCode":m.arguments.args.forEach(b=>u(!1,b));break;default:break}break}case"response":{const m=c;if(m.success&&m.body)switch(m.command){case"stackTrace":m.body.stackFrames.forEach(b=>u(!1,b.source));break;case"loadedSources":m.body.sources.forEach(b=>u(!1,b));break;case"scopes":m.body.scopes.forEach(b=>u(!1,b.source));break;case"setFunctionBreakpoints":m.body.breakpoints.forEach(b=>u(!1,b.source));break;case"setBreakpoints":m.body.breakpoints.forEach(b=>u(!1,b.source));break;case"disassemble":m.body?.instructions.forEach(f=>u(!1,f.location));break;default:break}break}}}function s(c){return c.filter(u=>!u.presentation?.hidden).sort((u,m)=>u.presentation?m.presentation?u.presentation.group?m.presentation.group?u.presentation.group!==m.presentation.group?u.presentation.group.localeCompare(m.presentation.group):E(u.presentation.order,m.presentation.order):-1:m.presentation.group?1:E(u.presentation.order,m.presentation.order):-1:m.presentation?1:0)}e.getVisibleAndSorted=s;function E(c,u){return typeof c!="number"?typeof u!="number"?0:1:typeof u!="number"?-1:c-u}async function k(c,u){const m=c.getValue("debug.saveBeforeStart",{overrideIdentifier:u.activeTextEditorLanguageId});if(m!=="none"&&(await u.saveAll(),m==="allEditorsInActiveGroup")){const b=u.activeEditorPane;b&&b.input.resource?.scheme===R.Schemas.untitled&&await u.save({editor:b.input,groupId:b.group.id})}await c.reloadConfiguration()}e.saveAllBeforeDebugStart=k}),define(Pe[73],Ae([1,0,25,36,86,66,15,19,20,31]),function(te,e,n,P,I,L,R,A,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function(U){U[U.Markup=1]="Markup",U[U.Code=2]="Code"})(O||(e.CellKind=O={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",L.Mimes.text],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var w;(function(U){U[U.Running=1]="Running",U[U.Idle=2]="Idle"})(w||(e.NotebookRunState=w={}));var g;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(g||(e.NotebookCellExecutionState=g={}));var S;(function(U){U[U.Unconfirmed=1]="Unconfirmed",U[U.Pending=2]="Pending",U[U.Executing=3]="Executing"})(S||(e.NotebookExecutionState=S={}));var p;(function(U){U[U.WithHardKernelDependency=0]="WithHardKernelDependency",U[U.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",U[U.Pure=2]="Pure",U[U.Never=3]="Never"})(p||(e.NotebookRendererMatch=p={}));var l;(function(U){U.Always="always",U.Never="never",U.Optional="optional"})(l||(e.RendererMessagingSpec=l={}));var t;(function(U){U[U.ModelChange=1]="ModelChange",U[U.Move=2]="Move",U[U.ChangeCellLanguage=5]="ChangeCellLanguage",U[U.Initialize=6]="Initialize",U[U.ChangeCellMetadata=7]="ChangeCellMetadata",U[U.Output=8]="Output",U[U.OutputItem=9]="OutputItem",U[U.ChangeCellContent=10]="ChangeCellContent",U[U.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",U[U.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",U[U.ChangeCellMime=13]="ChangeCellMime",U[U.Unknown=100]="Unknown"})(t||(e.NotebookCellsChangeType=t={}));var o;(function(U){U[U.Handle=0]="Handle",U[U.Index=1]="Index"})(o||(e.SelectionStateType=o={}));var d;(function(U){U[U.Replace=1]="Replace",U[U.Output=2]="Output",U[U.Metadata=3]="Metadata",U[U.CellLanguage=4]="CellLanguage",U[U.DocumentMetadata=5]="DocumentMetadata",U[U.Move=6]="Move",U[U.OutputItems=7]="OutputItems",U[U.PartialMetadata=8]="PartialMetadata",U[U.PartialInternalMetadata=9]="PartialInternalMetadata"})(d||(e.CellEditType=d={}));var D;(function(U){U.scheme=R.Schemas.vscodeNotebookCell;const j=["W","X","Y","Z","a","b","c","d","e","f"],Y=new RegExp(`^[${j.join("")}]+`),pe=7;function Ee(H,F){const Q=F.toString(pe),Ce=`${Q.length<j.length?j[Q.length-1]:"z"}${Q}s${(0,n.encodeBase64)(n.VSBuffer.fromString(H.scheme),!0,!0)}`;return H.with({scheme:U.scheme,fragment:Ce})}U.generate=Ee;function he(H){if(H.scheme!==U.scheme)return;const F=H.fragment.indexOf("s");if(F<0)return;const Q=parseInt(H.fragment.substring(0,F).replace(Y,""),pe),me=(0,n.decodeBase64)(H.fragment.substring(F+1)).toString();if(!isNaN(Q))return{handle:Q,notebook:H.with({scheme:me,fragment:null})}}U.parse=he;function de(H,F){return H.with({scheme:R.Schemas.vscodeNotebookCellOutput,fragment:`op${F??""},${H.scheme!==R.Schemas.file?H.scheme:""}`})}U.generateCellOutputUri=de;function Re(H){if(H.scheme!==R.Schemas.vscodeNotebookCellOutput)return;const F=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(H.fragment);if(!F)return;const Q=F[1]&&F[1]!==""?F[1]:void 0,me=F[2];return{outputId:Q,notebook:H.with({scheme:me||R.Schemas.file,fragment:null})}}U.parseCellOutputUri=Re;function le(H,F,Q){return U.generate(H,F).with({scheme:Q})}U.generateCellPropertyUri=le;function ue(H,F){if(H.scheme===F)return U.parse(H.with({scheme:U.scheme}))}U.parseCellPropertyUri=ue})(D||(e.CellUri=D={}));const T=U=>y.isWindows?U.replace(/\//g,"\\"):U;class v{constructor(j=[],Y=e.NOTEBOOK_DISPLAY_ORDER){this.e=Y,this.d=[...new Set(j)].map(pe=>({pattern:pe,matches:P.parse(T(pe))}))}sort(j){const Y=new Map(I.Iterable.map(j,Ee=>[Ee,T(Ee)]));let pe=[];for(const{matches:Ee}of this.d)for(const[he,de]of Y)if(Ee(de)){pe.push(he),Y.delete(he);break}return Y.size&&(pe=pe.concat([...Y.keys()].sort((Ee,he)=>this.e.indexOf(Ee)-this.e.indexOf(he)))),pe}prioritize(j,Y){const pe=this.f(j);if(pe===-1){this.d.unshift({pattern:j,matches:P.parse(T(j))});return}const Ee=new Set(Y.map(de=>this.f(de,pe)));Ee.delete(-1);const he=Array.from(Ee).sort();this.d.splice(pe+1,0,...he.map(de=>this.d[de]));for(let de=he.length-1;de>=0;de--)this.d.splice(he[de],1)}toArray(){return this.d.map(j=>j.pattern)}f(j,Y=this.d.length){const pe=T(j);for(let Ee=0;Ee<Y;Ee++)if(this.d[Ee].matches(pe))return Ee;return-1}}e.MimeTypeDisplayOrder=v;function i(U,j,Y,pe=(Ee,he)=>Ee===he){const Ee=[];function he(le,ue,H){if(ue===0&&H.length===0)return;const F=Ee[Ee.length-1];F&&F.start+F.deleteCount===le?(F.deleteCount+=ue,F.toInsert.push(...H)):Ee.push({start:le,deleteCount:ue,toInsert:H})}let de=0,Re=0;for(;;){if(de===U.length){he(de,0,j.slice(Re));break}if(Re===j.length){he(de,U.length-de,[]);break}const le=U[de],ue=j[Re];if(pe(le,ue)){de+=1,Re+=1;continue}Y(ue)?(he(de,1,[]),de+=1):(he(de,0,[ue]),Re+=1)}return Ee}e.diff=i,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new h.RawContextKey("notebookEditorCursorAtBoundary","none");var a;(function(U){U.default="default",U.option="option"})(a||(e.NotebookEditorPriority=a={}));function r(U){const j=U;return!!((typeof j.include=="string"||P.isRelativePattern(j.include))&&(typeof j.exclude=="string"||P.isRelativePattern(j.exclude)))}e.isDocumentExcludePattern=r;function s(U,j,Y){if(Array.isArray(U.viewType)&&U.viewType.indexOf(j)>=0||U.viewType===j)return!0;if(U.filenamePattern){const pe=r(U.filenamePattern)?U.filenamePattern.include:U.filenamePattern,Ee=r(U.filenamePattern)?U.filenamePattern.exclude:void 0;if(P.match(pe,(0,A.basename)(Y.fsPath).toLowerCase()))return!(Ee&&P.match(Ee,(0,A.basename)(Y.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=s,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",formatOnSave:"notebook.formatOnSave.enabled",codeActionsOnSave:"notebook.experimental.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell"};var E;(function(U){U[U.Left=1]="Left",U[U.Right=2]="Right"})(E||(e.CellStatusbarAlignment=E={}));class k{static create(j){return`${k.d}${j}`}static parse(j){if(j.startsWith(k.d))return j.substring(k.d.length)}}e.NotebookWorkingCopyTypeIdentifier=k,k.d="notebook/";function c(U){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(U)}e.isTextStreamMime=c;const u=new TextDecoder;function m(U){const j=[];let Y=!1;for(const pe of U)(j.length===0||Y)&&(j.push(pe),Y=!0);return V(j),X(n.VSBuffer.concat(j.map(pe=>n.VSBuffer.wrap(pe))))}e.compressOutputItemStreams=m;const b=`${String.fromCharCode(27)}[A`,f=b.split("").map(U=>U.charCodeAt(0)),N=10;function V(U){U.forEach((j,Y)=>{if(Y===0||j.length<b.length)return;const pe=U[Y-1],Ee=j.subarray(0,b.length);if(Ee[0]===f[0]&&Ee[1]===f[1]&&Ee[2]===f[2]){const he=pe.lastIndexOf(N);if(he===-1)return;U[Y-1]=pe.subarray(0,he),U[Y]=j.subarray(b.length)}})}function _(U){let j=U;do U=j,j=U.replace(/[^\n]\x08/gm,"");while(j.length<U.length);return U}function G(U){for(U=U.replace(/\r+\n/gm,`
`);U.search(/\r[^$]/g)>-1;){const j=U.match(/^(.*)\r+/m)[1];let Y=U.match(/\r+(.*)$/m)[1];Y=Y+j.slice(Y.length,j.length),U=U.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,Y)}return U}const $="\b".charCodeAt(0),B="\r".charCodeAt(0);function X(U){return!U.buffer.includes($)&&!U.buffer.includes(B)?U:n.VSBuffer.fromString(G(_(u.decode(U.buffer))))}}),define(Pe[194],Ae([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var P;(function(I){I[I.Output=1]="Output",I[I.OutputItems=2]="OutputItems",I[I.ExecutionState=3]="ExecutionState"})(P||(e.CellExecutionUpdateType=P={})),e.INotebookExecutionService=(0,n.createDecorator)("INotebookExecutionService")}),define(Pe[45],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var n;(function(L){L.Delimiter="\0"})(n||(e.TestIdPathParts=n={}));var P;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(P||(e.TestPosition=P={}));class I{static fromExtHostTestItem(R,A,y=R.parent){if(R._isRoot)return new I([A]);const h=[R.id];for(let O=y;O&&O.id!==A;O=O.parent)h.push(O.id);return h.push(A),new I(h.reverse())}static isRoot(R){return!R.includes("\0")}static root(R){const A=R.indexOf("\0");return A===-1?R:R.slice(0,A)}static fromString(R){return new I(R.split("\0"))}static join(R,A){return new I([...R.path,A])}static joinToString(R,A){return R.toString()+"\0"+A}static parentId(R){const A=R.lastIndexOf("\0");return A===-1?void 0:R.slice(0,A)}static localId(R){const A=R.lastIndexOf("\0");return A===-1?R:R.slice(A+1)}static isChild(R,A){return A.startsWith(R)&&A[R.length]==="\0"}static compare(R,A){return R===A?0:I.isChild(R,A)?2:I.isChild(A,R)?3:1}constructor(R,A=R.length){if(this.path=R,this.d=A,R.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new I(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let R=1;R<=this.d;R++)yield new I(this.path,R)}*idsToRoot(){for(let R=this.d;R>0;R--)yield new I(this.path,R)}compare(R){if(typeof R=="string")return I.compare(this.toString(),R);for(let A=0;A<R.d&&A<this.d;A++)if(R.path[A]!==this.path[A])return 1;return R.d>this.d?2:R.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let R=1;R<this.d;R++)this.c+="\0",this.c+=this.path[R]}return this.c}}e.TestId=I}),define(Pe[56],Ae([1,0,2,44,45]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.TestResultState=void 0;var L;(function(u){u[u.Unset=0]="Unset",u[u.Queued=1]="Queued",u[u.Running=2]="Running",u[u.Passed=3]="Passed",u[u.Failed=4]="Failed",u[u.Skipped=5]="Skipped",u[u.Errored=6]="Errored"})(L||(e.TestResultState=L={}));var R;(function(u){u[u.Run=1]="Run",u[u.Debug=2]="Debug",u[u.Coverage=3]="Coverage"})(R||(e.ExtTestRunProfileKind=R={}));var A;(function(u){u[u.Run=2]="Run",u[u.Debug=4]="Debug",u[u.Coverage=8]="Coverage",u[u.HasNonDefaultProfile=16]="HasNonDefaultProfile",u[u.HasConfigurable=32]="HasConfigurable",u[u.SupportsContinuousRun=64]="SupportsContinuousRun"})(A||(e.TestRunProfileBitset=A={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const y=u=>"runId"in u;e.isStartControllerTests=y;var h;(function(u){u.serialize=m=>({range:m.range.toJSON(),uri:m.uri.toJSON()}),u.deserialize=m=>({range:P.Range.lift(m.range),uri:n.URI.revive(m.uri)})})(h||(e.IRichLocation=h={}));var O;(function(u){u[u.Error=0]="Error",u[u.Output=1]="Output"})(O||(e.TestMessageType=O={}));var w;(function(u){u.serialize=m=>({message:m.message,type:0,expected:m.expected,actual:m.actual,location:m.location&&h.serialize(m.location)}),u.deserialize=m=>({message:m.message,type:0,expected:m.expected,actual:m.actual,location:m.location&&h.deserialize(m.location)})})(w||(e.ITestErrorMessage=w={}));const g=(u,m)=>`${m?"s":"e"}${u}`;e.getMarkId=g;var S;(function(u){u.serialize=m=>({message:m.message,type:1,offset:m.offset,length:m.length,location:m.location&&h.serialize(m.location)}),u.deserialize=m=>({message:m.message,type:1,offset:m.offset,length:m.length,location:m.location&&h.deserialize(m.location)})})(S||(e.ITestOutputMessage=S={}));var p;(function(u){u.serialize=m=>m.type===0?w.serialize(m):S.serialize(m),u.deserialize=m=>m.type===0?w.deserialize(m):S.deserialize(m)})(p||(e.ITestMessage=p={}));var l;(function(u){u.serializeWithoutMessages=m=>({state:m.state,duration:m.duration,messages:[]}),u.serialize=m=>({state:m.state,duration:m.duration,messages:m.messages.map(p.serialize)}),u.deserialize=m=>({state:m.state,duration:m.duration,messages:m.messages.map(p.deserialize)})})(l||(e.ITestTaskState=l={}));const t="\0",o=(u,m)=>u+t+m;e.namespaceTestTag=o;const d=u=>{const m=u.indexOf(t);return{ctrlId:u.slice(0,m),tagId:u.slice(m+1)}};e.denamespaceTestTag=d;var D;(function(u){u.serialize=m=>({extId:m.extId,label:m.label,tags:m.tags,busy:m.busy,children:void 0,uri:m.uri?.toJSON(),range:m.range?.toJSON()||null,description:m.description,error:m.error,sortText:m.sortText}),u.deserialize=m=>({extId:m.extId,label:m.label,tags:m.tags,busy:m.busy,children:void 0,uri:m.uri?n.URI.revive(m.uri):void 0,range:m.range?P.Range.lift(m.range):null,description:m.description,error:m.error,sortText:m.sortText})})(D||(e.ITestItem=D={}));var T;(function(u){u[u.NotExpandable=0]="NotExpandable",u[u.Expandable=1]="Expandable",u[u.BusyExpanding=2]="BusyExpanding",u[u.Expanded=3]="Expanded"})(T||(e.TestItemExpandState=T={}));var v;(function(u){u.serialize=m=>({expand:m.expand,item:D.serialize(m.item)}),u.deserialize=m=>({controllerId:I.TestId.root(m.item.extId),expand:m.expand,item:D.deserialize(m.item)})})(v||(e.InternalTestItem=v={}));var i;(function(u){u.serialize=m=>{let b;return m.item&&(b={},m.item.label!==void 0&&(b.label=m.item.label),m.item.tags!==void 0&&(b.tags=m.item.tags),m.item.busy!==void 0&&(b.busy=m.item.busy),m.item.uri!==void 0&&(b.uri=m.item.uri?.toJSON()),m.item.range!==void 0&&(b.range=m.item.range?.toJSON()),m.item.description!==void 0&&(b.description=m.item.description),m.item.error!==void 0&&(b.error=m.item.error),m.item.sortText!==void 0&&(b.sortText=m.item.sortText)),{extId:m.extId,expand:m.expand,item:b}},u.deserialize=m=>{let b;return m.item&&(b={},m.item.label!==void 0&&(b.label=m.item.label),m.item.tags!==void 0&&(b.tags=m.item.tags),m.item.busy!==void 0&&(b.busy=m.item.busy),m.item.range!==void 0&&(b.range=m.item.range?P.Range.lift(m.item.range):null),m.item.description!==void 0&&(b.description=m.item.description),m.item.error!==void 0&&(b.error=m.item.error),m.item.sortText!==void 0&&(b.sortText=m.item.sortText)),{extId:m.extId,expand:m.expand,item:b}}})(i||(e.ITestItemUpdate=i={}));const a=(u,m)=>{m.expand!==void 0&&(u.expand=m.expand),m.item!==void 0&&(u.item=u.item?Object.assign(u.item,m.item):m.item)};e.applyTestItemUpdate=a;var r;(function(u){u.serializeWithoutMessages=m=>({...v.serialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(l.serializeWithoutMessages),retired:m.retired}),u.serialize=m=>({...v.serialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(l.serialize),retired:m.retired}),u.deserialize=m=>({...v.deserialize(m),ownComputedState:m.ownComputedState,computedState:m.computedState,tasks:m.tasks.map(l.deserialize),retired:!0})})(r||(e.TestResultItem=r={}));var s;(function(u){u[u.Function=0]="Function",u[u.Statement=1]="Statement"})(s||(e.DetailType=s={}));var E;(function(u){u[u.Add=0]="Add",u[u.Update=1]="Update",u[u.DocumentSynced=2]="DocumentSynced",u[u.Remove=3]="Remove",u[u.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",u[u.Retire=5]="Retire",u[u.AddTag=6]="AddTag",u[u.RemoveTag=7]="RemoveTag"})(E||(e.TestDiffOpType=E={}));var k;(function(u){u.deserialize=m=>m.op===0?{op:m.op,item:v.deserialize(m.item)}:m.op===1?{op:m.op,item:i.deserialize(m.item)}:m.op===2?{op:m.op,uri:n.URI.revive(m.uri),docv:m.docv}:m,u.serialize=m=>m.op===0?{op:m.op,item:v.serialize(m.item)}:m.op===1?{op:m.op,item:i.serialize(m.item)}:m})(k||(e.TestsDiffOp=k={}));class c{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(m){const b=this.o();for(const f of m)switch(f.op){case 0:this.j(v.deserialize(f.item),b);break;case 1:this.k(i.deserialize(f.item),b);break;case 3:this.l(f.itemId,b);break;case 5:this.m(f.itemId);break;case 4:this.updatePendingRoots(f.amount);break;case 6:this.c.set(f.tag.id,f.tag);break;case 7:this.c.delete(f.id);break}b.complete?.()}j(m,b){const f=I.TestId.parentId(m.item.extId)?.toString();let N;if(!f)N=this.p(m),this.f.add(N),this.d.set(m.item.extId,N);else if(this.d.has(f)){const V=this.d.get(f);V.children.add(m.item.extId),N=this.p(m,V),this.d.set(m.item.extId,N)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(m)}`);return}return b.add?.(N),m.expand===2&&this.g++,N}k(m,b){const f=this.d.get(m.extId);if(f)return m.expand!==void 0&&(f.expand===2&&this.g--,m.expand===2&&this.g++),(0,e.applyTestItemUpdate)(f,m),b.update?.(f),f}l(m,b){const f=this.d.get(m);if(!f)return;const N=I.TestId.parentId(f.item.extId)?.toString();N?this.d.get(N).children.delete(f.item.extId):this.f.delete(f);const V=[[m]];for(;V.length;)for(const _ of V.pop()){const G=this.d.get(_);G&&(V.push(G.children),this.d.delete(_),b.remove?.(G,G!==f),G.expand===2&&this.g--)}}m(m){}updatePendingRoots(m){this.h+=m}o(){return{}}}e.AbstractIncrementalTestCollection=c}),define(Pe[74],Ae([1,0,17,5,6,49,56,45]),function(te,e,n,P,I,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(d){d[d.Upsert=0]="Upsert",d[d.SetTags=1]="SetTags",d[d.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",d[d.RemoveChild=3]="RemoveChild",d[d.SetProp=4]="SetProp",d[d.Bulk=5]="Bulk",d[d.DocumentSynced=6]="DocumentSynced"})(y||(e.TestItemEventOp=y={}));const h=(d,D)=>d===D,w=Object.entries({range:(d,D)=>d===D?!0:!d||!D?!1:d.equalsRange(D),busy:h,label:h,description:h,error:h,sortText:h,tags:(d,D)=>!(d.length!==D.length||d.some(T=>!D.includes(T)))}),g=(d,D)=>{let T;for(const[v,i]of w)i(d[v],D[v])||(T?T[v]=D[v]:T={[v]:D[v]});return T};class S extends I.Disposable{get root(){return this.m.root}constructor(D){super(),this.m=D,this.f=this.B(new n.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new P.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(D){this.h=D;for(const T of this.tree.values())this.G(T)}get resolveHandler(){return this.h}collectDiff(){const D=this.k;return this.k=[],D}pushDiff(D){switch(D.op){case 2:{for(const T of this.k)if(T.op===2&&T.uri===D.uri){T.docv=D.docv;return}break}case 1:{const T=this.k[this.k.length-1];if(T){if(T.op===1&&T.item.extId===D.item.extId){(0,R.applyTestItemUpdate)(T.item,D.item);return}if(T.op===0&&T.item.item.extId===D.item.extId){(0,R.applyTestItemUpdate)(T.item,D.item);return}}break}}this.k.push(D),this.f.isScheduled()||this.f.schedule()}expand(D,T){const v=this.tree.get(D);if(v){if((v.expandLevels===void 0||T>v.expandLevels)&&(v.expandLevels=T),v.expand===1){const i=this.I(v);return i.isOpen()?this.H(v,T-1):i.wait().then(()=>this.H(v,T-1))}else if(v.expand===3)return v.resolveBarrier?.isOpen()===!1?v.resolveBarrier.wait().then(()=>this.H(v,T-1)):this.H(v,T-1)}}dispose(){for(const D of this.tree.values())this.m.getApiFor(D.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(D,T){switch(T.op){case 3:this.L(A.TestId.joinToString(D.fullId,T.id));break;case 0:this.u(T.item,D);break;case 5:for(const v of T.ops)this.p(D,v);break;case 1:this.w(T.new,T.old,D.fullId.toString());break;case 2:this.G(D);break;case 4:this.pushDiff({op:1,item:{extId:D.fullId.toString(),item:T.update}});break;case 6:this.s(D.actual.uri);break;default:(0,L.assertNever)(T)}}s(D){D&&this.pushDiff({op:2,uri:D,docv:this.m.getDocumentVersion(D)})}u(D,T){const v=A.TestId.fromExtHostTestItem(D,this.root.id,T?.actual),i=this.m.getApiFor(D);i.parent&&i.parent!==T?.actual&&this.m.getChildren(i.parent).delete(D.id);let a=this.tree.get(v.toString());if(!a){a={fullId:v,actual:D,expandLevels:T?.expandLevels?T.expandLevels-1:void 0,expand:0},D.tags.forEach(this.y,this),this.tree.set(a.fullId.toString(),a),this.C(D,T),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:a.expand,item:this.m.toITestItem(D)}}),this.F(D,a,T);return}if(a.actual===D){this.D(D,a,T);return}if(a.actual.uri?.toString()!==D.uri?.toString())return this.L(v.toString()),this.u(D,T);const r=this.m.getChildren(a.actual),s=a.actual,E=g(this.m.toITestItem(s),this.m.toITestItem(D));this.m.getApiFor(s).listener=void 0,a.actual=D,a.expand=0,E&&(E.hasOwnProperty("tags")&&(this.w(D.tags,s.tags,v.toString()),delete E.tags),this.p(a,{op:4,update:E})),this.F(D,a,T);for(const[k,c]of r)this.m.getChildren(D).get(c.id)||this.L(A.TestId.joinToString(v,c.id));this.s(a.actual.uri)}w(D,T,v){const i=new Set(T.map(a=>a.id));for(const a of D)i.delete(a.id)||this.y(a);this.pushDiff({op:1,item:{extId:v,item:{tags:D.map(a=>(0,R.namespaceTestTag)(this.m.controllerId,a.id))}}}),i.forEach(this.z,this)}y(D){const T=this.j.get(D.id);T?T.refCount++:(this.j.set(D.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,R.namespaceTestTag)(this.m.controllerId,D.id)}}))}z(D){const T=this.j.get(D);T&&!--T.refCount&&(this.j.delete(D),this.pushDiff({op:7,id:(0,R.namespaceTestTag)(this.m.controllerId,D)}))}C(D,T){this.m.getApiFor(D).parent=T&&T.actual!==this.root?T.actual:void 0}D(D,T,v){this.C(D,v);const i=this.m.getApiFor(D);i.parent=v?.actual,i.listener=a=>this.p(T,a),this.G(T)}F(D,T,v){this.D(D,T,v);for(const[i,a]of this.m.getChildren(D))this.u(a,T)}G(D){let T;this.h?D.resolveBarrier?T=D.resolveBarrier.isOpen()?3:2:T=D.actual.canResolveChildren?1:0:T=0,T!==D.expand&&(D.expand=T,this.pushDiff({op:1,item:{extId:D.fullId.toString(),expand:T}}),T===1&&D.expandLevels!==void 0&&this.I(D))}H(D,T){if(T<0)return;const v=[];for(const[i,a]of this.m.getChildren(D.actual)){const r=this.expand(A.TestId.joinToString(D.fullId,a.id),T);(0,n.isThenable)(r)&&v.push(r)}if(v.length)return Promise.all(v).then(()=>{})}I(D){if(D.resolveBarrier)return D.resolveBarrier;if(!this.h){const a=new n.Barrier;return a.open(),a}D.expand=2,this.J(D);const T=D.resolveBarrier=new n.Barrier,v=a=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,a)};let i;try{i=this.h(D.actual===this.root?void 0:D.actual)}catch(a){v(a)}return(0,n.isThenable)(i)?i.catch(v).then(()=>{T.open(),this.G(D)}):(T.open(),this.G(D)),D.resolveBarrier}J(D){this.pushDiff({op:1,item:{extId:D.fullId.toString(),expand:D.expand}})}L(D){const T=this.tree.get(D);if(!T)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:D});const v=[T];for(;v.length;){const i=v.pop();if(i){this.m.getApiFor(i.actual).listener=void 0;for(const a of i.actual.tags)this.z(a.id);this.tree.delete(i.fullId.toString());for(const[a,r]of this.m.getChildren(i.actual))v.push(this.tree.get(A.TestId.joinToString(i.fullId,r.id)))}}}flushDiff(){const D=this.collectDiff();D.length&&this.g.fire(D)}}e.TestItemCollection=S;class p extends Error{constructor(D){super(`Attempted to insert a duplicate test item ID ${D}`)}}e.DuplicateTestItemError=p;class l extends Error{constructor(D){super(`TestItem with ID "${D}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=l;class t extends Error{constructor(D,T,v){super(`TestItem with ID "${D}" is from controller "${T}" and cannot be added as a child of an item from controller "${v}".`)}}e.MixedTestItemController=t;const o=(d,D,T)=>{let v=new Map;return{get size(){return v.size},forEach(i,a){for(const r of v.values())i.call(a,r,this)},[Symbol.iterator](){return v.entries()},replace(i){const a=new Map,r=new Set(v.keys()),s={op:5,ops:[]};for(const E of i){if(!(E instanceof T))throw new l(E.id);const k=D(E).controllerId;if(k!==d.controllerId)throw new t(E.id,k,d.controllerId);if(a.has(E.id))throw new p(E.id);a.set(E.id,E),r.delete(E.id),s.ops.push({op:0,item:E})}for(const E of r.keys())s.ops.push({op:3,id:E});d.listener?.(s),v=a},add(i){if(!(i instanceof T))throw new l(i.id);v.set(i.id,i),d.listener?.({op:0,item:i})},delete(i){v.delete(i)&&d.listener?.({op:3,id:i})},get(i){return v.get(i)},toJSON(){return Array.from(v.values())}}};e.createTestItemChildren=o}),define(Pe[99],Ae([1,0,74]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const P=new WeakMap,I=(R,A)=>{const y={controllerId:A};return P.set(R,y),y};e.createPrivateApiFor=I;const L=R=>{const A=P.get(R);if(!A)throw new n.InvalidTestItemError(R?.id||"<unknown>");return A};e.getPrivateApiFor=L}),define(Pe[75],Ae([1,0,15,2]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function I(A,y){return A.scheme===n.Schemas.http||A.scheme===n.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===n.Schemas.file&&(A=P.URI.from({scheme:n.Schemas.vscodeRemote,authority:y.authority,path:A.path})),P.URI.from({scheme:n.Schemas.https,authority:`${A.scheme}+${L(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=I;function L(A){return A.replace(/./g,y=>{const h=y.charCodeAt(0);return h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57?y:"-"+h.toString(16).padStart(4,"0")})}function R(A){return A.replace(/-([0-9a-f]{4})/g,(y,h)=>String.fromCharCode(parseInt(h,16)))}e.decodeAuthority=R}),define(Pe[195],Ae([1,0,5,6,75]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(A,y,h){this.d=A,this.e=y,this.f=h,this.a=0,this.b=new P.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const O=y.getVisibleTextEditors();for(const w of this.c.values())O.indexOf(w.editor)<0&&w.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,y,h,O,w){let g;for(const D of this.e.getVisibleTextEditors(!0))if(D.value===A){g=D;break}if(!g)throw new Error("not a visible editor");const S=this,p=this.a++,l=new n.Emitter,t=new n.Emitter,o=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(D){return(0,I.asWebviewUri)(D,S.f)}get cspSource(){return I.webviewGenericCspSource}set options(D){this.b=D,S.d.$setOptions(p,D)}get options(){return this.b}set html(D){this.a=D,S.d.$setHtml(p,D)}get html(){return this.a}get onDidReceiveMessage(){return l.event}postMessage(D){return S.d.$postMessage(p,D)}},d=new class{constructor(){this.editor=A,this.line=y,this.height=h,this.webview=o,this.onDidDispose=t.event}dispose(){S.c.has(p)&&(S.c.delete(p),S.d.$disposeEditorInset(p),t.fire(),t.dispose(),l.dispose())}};return this.d.$createEditorInset(p,g.id,g.value.document.uri,y+1,h,O||{},w.identifier,w.extensionLocation),this.c.set(p,{editor:A,inset:d,onDidReceiveMessage:l}),d}$onDidDispose(A){const y=this.c.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this.c.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=L}),define(Pe[196],Ae([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,n.createDecorator)("configurationResolverService");var P;(function(L){L.Unknown="unknown",L.Env="env",L.Config="config",L.Command="command",L.Input="input",L.ExtensionInstallFolder="extensionInstallFolder",L.WorkspaceFolder="workspaceFolder",L.Cwd="cwd",L.WorkspaceFolderBasename="workspaceFolderBasename",L.UserHome="userHome",L.LineNumber="lineNumber",L.SelectedText="selectedText",L.File="file",L.FileWorkspaceFolder="fileWorkspaceFolder",L.RelativeFile="relativeFile",L.RelativeFileDirname="relativeFileDirname",L.FileDirname="fileDirname",L.FileExtname="fileExtname",L.FileBasename="fileBasename",L.FileBasenameNoExtension="fileBasenameNoExtension",L.FileDirnameBasename="fileDirnameBasename",L.ExecPath="execPath",L.ExecInstallFolder="execInstallFolder",L.PathSeparator="pathSeparator"})(P||(e.VariableKind=P={}));class I extends Error{constructor(R,A){super(A),this.variable=R}}e.VariableError=I}),define(Pe[197],Ae([1,0,19,51,12,23,20,89,162,196,13]),function(te,e,n,P,I,L,R,A,y,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class w{constructor(S,p,l,t){this.h=new Map,this.a=S,this.b=p,this.g=l,t&&(this.c=t.then(o=>this.i(o)))}i(S){if(R.isWindows){const p=Object.create(null);return Object.keys(S).forEach(l=>{p[l.toLowerCase()]=S[l]}),p}return S}resolveWithEnvironment(S,p,l){return this.l({env:this.i(S),userHome:void 0},p?p.uri:void 0,l)}async resolveAsync(S,p){const l={env:await this.c,userHome:await this.g};return this.l(l,S?S.uri:void 0,p)}async j(S,p,l,t){const o=L.deepClone(p);R.isWindows&&o.windows?Object.keys(o.windows).forEach(D=>o[D]=o.windows[D]):R.isMacintosh&&o.osx?Object.keys(o.osx).forEach(D=>o[D]=o.osx[D]):R.isLinux&&o.linux&&Object.keys(o.linux).forEach(D=>o[D]=o.linux[D]),delete o.windows,delete o.osx,delete o.linux;const d={env:await this.c,userHome:await this.g};return this.l(d,S?S.uri:void 0,o,l,t)}async resolveAnyAsync(S,p,l){return this.j(S,p,l)}async resolveAnyMap(S,p,l){const t=new Map;return{newConfig:await this.j(S,p,l,t),resolvedVariables:t}}resolveWithInteractionReplace(S,p,l,t){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(S,p,l,t){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(S,p){if(this.h.has(S))throw new Error("Variable "+S+" is contributed twice.");this.h.set(S,p)}async l(S,p,l,t,o){if(I.isString(l))return this.m(S,p,l,t,o);if(Array.isArray(l))return Promise.all(l.map(d=>this.l(S,p,d,t,o)));if(I.isObject(l)){const d=Object.create(null),D=await Promise.all(Object.keys(l).map(async T=>[await this.m(S,p,T,t,o),await this.l(S,p,l[T],t,o)]));for(const[T,v]of D)d[T]=v;return d}return l}m(S,p,l,t,o){return(0,O.replaceAsync)(l,w.VARIABLE_REGEXP,async(d,D)=>{if(D.includes(w.VARIABLE_LHS))return d;let T=await this.o(S,d,D,p,t);return o?.set(D,T),T!==d&&I.isString(T)&&T.match(w.VARIABLE_REGEXP)&&(T=await this.m(S,p,T,t,o)),T})}n(S){return this.b?this.b.getUriLabel(S,{noPrefix:!0}):S.fsPath}async o(S,p,l,t,o){let d;const D=l.split(":");D.length>1&&(l=D[0],d=D[1]);const T=a=>{const r=this.a.getFilePath();if(r)return(0,A.normalizeDriveLetter)(r);throw new h.VariableError(a,(0,y.localize)(0,null,p))},v=a=>{const r=T(a);if(this.a.getWorkspaceFolderPathForFile){const s=this.a.getWorkspaceFolderPathForFile();if(s)return(0,A.normalizeDriveLetter)(s)}throw new h.VariableError(a,(0,y.localize)(1,null,p,n.basename(r)))},i=a=>{if(d){const r=this.a.getFolderUri(d);if(r)return r;throw new h.VariableError(a,(0,y.localize)(2,null,p,d))}if(t)return t;throw this.a.getWorkspaceFolderCount()>1?new h.VariableError(a,(0,y.localize)(3,null,p)):new h.VariableError(a,(0,y.localize)(4,null,p))};switch(l){case"env":if(d){if(S.env){const a=S.env[R.isWindows?d.toLowerCase():d];if(I.isString(a))return a}return""}throw new h.VariableError(h.VariableKind.Env,(0,y.localize)(5,null,p));case"config":if(d){const a=this.a.getConfigurationValue(t,d);if(I.isUndefinedOrNull(a))throw new h.VariableError(h.VariableKind.Config,(0,y.localize)(6,null,p,d));if(I.isObject(a))throw new h.VariableError(h.VariableKind.Config,(0,y.localize)(7,null,p,d));return a}throw new h.VariableError(h.VariableKind.Config,(0,y.localize)(8,null,p));case"command":return this.p(h.VariableKind.Command,p,d,o,"command");case"input":return this.p(h.VariableKind.Input,p,d,o,"input");case"extensionInstallFolder":if(d){const a=await this.a.getExtension(d);if(!a)throw new h.VariableError(h.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,p,d));return this.n(a.extensionLocation)}throw new h.VariableError(h.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,p));default:switch(l){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.n(i(h.VariableKind.WorkspaceFolder)));case"cwd":return t||d?(0,A.normalizeDriveLetter)(this.n(i(h.VariableKind.Cwd))):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(n.basename(this.n(i(h.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(S.userHome)return S.userHome;throw new h.VariableError(h.VariableKind.UserHome,(0,y.localize)(11,null,p))}case"lineNumber":{const a=this.a.getLineNumber();if(a)return a;throw new h.VariableError(h.VariableKind.LineNumber,(0,y.localize)(12,null,p))}case"selectedText":{const a=this.a.getSelectedText();if(a)return a;throw new h.VariableError(h.VariableKind.SelectedText,(0,y.localize)(13,null,p))}case"file":return T(h.VariableKind.File);case"fileWorkspaceFolder":return v(h.VariableKind.FileWorkspaceFolder);case"relativeFile":return t||d?n.relative(this.n(i(h.VariableKind.RelativeFile)),T(h.VariableKind.RelativeFile)):T(h.VariableKind.RelativeFile);case"relativeFileDirname":{const a=n.dirname(T(h.VariableKind.RelativeFileDirname));if(t||d){const r=n.relative(this.n(i(h.VariableKind.RelativeFileDirname)),a);return r.length===0?".":r}return a}case"fileDirname":return n.dirname(T(h.VariableKind.FileDirname));case"fileExtname":return n.extname(T(h.VariableKind.FileExtname));case"fileBasename":return n.basename(T(h.VariableKind.FileBasename));case"fileBasenameNoExtension":{const a=n.basename(T(h.VariableKind.FileBasenameNoExtension));return a.slice(0,a.length-n.extname(a).length)}case"fileDirnameBasename":return n.basename(n.dirname(T(h.VariableKind.FileDirnameBasename)));case"execPath":{const a=this.a.getExecPath();return a||p}case"execInstallFolder":{const a=this.a.getAppRoot();return a||p}case"pathSeparator":return n.sep;default:try{const a=d?`${l}:${d}`:l;return this.p(h.VariableKind.Unknown,p,a,o,void 0)}catch{return p}}}}p(S,p,l,t,o){if(l&&t){const d=o===void 0?t[l]:t[o+":"+l];if(typeof d=="string")return d;throw new h.VariableError(S,(0,y.localize)(14,null,p))}return p}}e.AbstractVariableResolverService=w,w.VARIABLE_LHS="${",w.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(Pe[100],Ae([1,0,3,98]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,n.createDecorator)("editorGroupsService");var I;(function(p){p[p.UP=0]="UP",p[p.DOWN=1]="DOWN",p[p.LEFT=2]="LEFT",p[p.RIGHT=3]="RIGHT"})(I||(e.GroupDirection=I={}));var L;(function(p){p[p.HORIZONTAL=0]="HORIZONTAL",p[p.VERTICAL=1]="VERTICAL"})(L||(e.GroupOrientation=L={}));var R;(function(p){p[p.FIRST=0]="FIRST",p[p.LAST=1]="LAST",p[p.NEXT=2]="NEXT",p[p.PREVIOUS=3]="PREVIOUS"})(R||(e.GroupLocation=R={}));var A;(function(p){p[p.MAXIMIZE=0]="MAXIMIZE",p[p.EVEN=1]="EVEN",p[p.TOGGLE=2]="TOGGLE"})(A||(e.GroupsArrangement=A={}));var y;(function(p){p[p.COPY_EDITORS=0]="COPY_EDITORS",p[p.MOVE_EDITORS=1]="MOVE_EDITORS"})(y||(e.MergeGroupMode=y={}));function h(p){const l=p;return(0,P.isEditorInput)(l?.editor)&&(0,P.isEditorInput)(l?.replacement)}e.isEditorReplacement=h;var O;(function(p){p[p.CREATION_TIME=0]="CREATION_TIME",p[p.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",p[p.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O||(e.GroupsOrder=O={}));var w;(function(p){p[p.NEW_EDITOR=1]="NEW_EDITOR",p[p.MOVE_EDITOR=2]="MOVE_EDITOR",p[p.COPY_EDITOR=3]="COPY_EDITOR"})(w||(e.OpenEditorContext=w={}));function g(p){const l=p;return!!l&&typeof l.id=="number"&&Array.isArray(l.editors)}e.isEditorGroup=g;function S(p){return p.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=S}),define(Pe[198],Ae([1,0,3,100]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,n.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function I(L){const R=L;return typeof L=="number"||(0,P.isEditorGroup)(R)}e.isPreferredGroup=I}),define(Pe[199],Ae([1,0,3,168]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,n.refineServiceDecorator)(P.IEnvironmentService)}),define(Pe[101],Ae([1,0,24,5,19,6]),function(te,e,n,P,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistryLock=e.LockableExtensionDescriptionRegistry=e.basicActivationEventsReader=e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=R;class A{static isHostExtension(t,o,d){if(o.getExtensionDescription(t))return!1;const D=d.getExtensionDescription(t);return D?!!((D.main||D.browser)&&D.api==="none"):!1}constructor(t,o){this.h=t,this.c=new P.Emitter,this.onDidChange=this.c.event,this.d=o,this.j()}j(){this.d.sort(S),this.e=new n.ExtensionIdentifierMap,this.f=[],this.g=new Map;for(const t of this.d){if(this.e.has(t.identifier)){console.error("Extension `"+t.identifier.value+"` is already registered");continue}this.e.set(t.identifier,t),this.f.push(t);const o=this.h.readActivationEvents(t);if(Array.isArray(o))for(let d of o)d==="onUri"&&(d=`onUri:${n.ExtensionIdentifier.toKey(t.identifier)}`),this.g.has(d)||this.g.set(d,[]),this.g.get(d).push(t)}}set(t){this.d=t,this.j(),this.c.fire(void 0)}deltaExtensions(t,o){this.d=p(this.d,o),this.d=this.d.concat(t);const d=A.k(this.d);return this.d=p(this.d,d.map(D=>D.identifier)),this.j(),this.c.fire(void 0),new R(d)}static k(t){const o=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(i){this.d.has(i)||(this.d.add(i),this.e.push(i))}addArc(i,a){this.addNode(i),this.addNode(a),this.c.has(i)?this.c.get(i).push(a):this.c.set(i,[a])}getArcs(i){return this.c.has(i)?this.c.get(i):[]}hasOnlyGoodArcs(i,a){const r=o.getArcs(i);for(let s=0;s<r.length;s++)if(!a.has(r[s]))return!1;return!0}getNodes(){return this.e}},d=new n.ExtensionIdentifierMap;for(const i of t)if(d.set(i.identifier,i),i.extensionDependencies)for(const a of i.extensionDependencies)o.addArc(n.ExtensionIdentifier.toKey(i.identifier),n.ExtensionIdentifier.toKey(a));const D=new Set;o.getNodes().filter(i=>o.getArcs(i).length===0).forEach(i=>D.add(i));const T=o.getNodes().filter(i=>!D.has(i));let v;do{v=!1;for(let i=0;i<T.length;i++){const a=T[i];o.hasOnlyGoodArcs(a,D)&&(T.splice(i,1),i--,D.add(a),v=!0)}}while(v);return T.map(i=>d.get(i))}containsActivationEvent(t){return this.g.has(t)}containsExtension(t){return this.e.has(t)}getExtensionDescriptionsForActivationEvent(t){const o=this.g.get(t);return o?o.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(t){const o=this.e.get(t);return o||void 0}getExtensionDescriptionByUUID(t){for(const o of this.f)if(o.uuid===t)return o}getExtensionDescriptionByIdOrUUID(t,o){return this.getExtensionDescription(t)??(o?this.getExtensionDescriptionByUUID(o):void 0)}}e.ExtensionDescriptionRegistry=A,e.basicActivationEventsReader={readActivationEvents:l=>l.activationEvents};class y{constructor(t){this.d=new w,this.c=new A(t,[])}async acquireLock(t){const o=await this.d.acquire(t);return new h(this,o)}deltaExtensions(t,o,d){if(!t.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(o,d)}containsActivationEvent(t){return this.c.containsActivationEvent(t)}containsExtension(t){return this.c.containsExtension(t)}getExtensionDescriptionsForActivationEvent(t){return this.c.getExtensionDescriptionsForActivationEvent(t)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getExtensionDescription(t){return this.c.getExtensionDescription(t)}getExtensionDescriptionByUUID(t){return this.c.getExtensionDescriptionByUUID(t)}getExtensionDescriptionByIdOrUUID(t,o){return this.c.getExtensionDescriptionByIdOrUUID(t,o)}}e.LockableExtensionDescriptionRegistry=y;class h extends L.Disposable{constructor(t,o){super(),this.f=t,this.c=!1,this.B(o)}isAcquiredFor(t){return!this.c&&this.f===t}}e.ExtensionDescriptionRegistryLock=h;class O{constructor(t){this.name=t,this.promise=new Promise((o,d)=>{this.c=o})}resolve(t){this.c(t)}}class w{constructor(){this.c=[],this.d=!1}async acquire(t){const o=new O(t);return this.c.push(o),this.e(),o.promise}e(){if(this.d||this.c.length===0)return;const t=this.c.shift();this.d=!0;let o=!0;const d=setTimeout(()=>{o&&console.warn(`The customer named ${t.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),D=()=>{o&&(clearTimeout(d),o=!1,this.d=!1,this.e())};t.resolve((0,L.toDisposable)(D))}}var g;(function(l){l[l.Builtin=0]="Builtin",l[l.User=1]="User",l[l.Dev=2]="Dev"})(g||(g={}));function S(l,t){const o=l.isBuiltin?0:l.isUnderDevelopment?2:1,d=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(o!==d)return o-d;const D=I.posix.basename(l.extensionLocation.path),T=I.posix.basename(t.extensionLocation.path);return D<T?-1:D>T?1:0}function p(l,t){const o=new n.ExtensionIdentifierSet(t);return l.filter(d=>!o.has(d.identifier))}}),define(Pe[76],Ae([1,0,25]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var P;(function(h){h[h.Desktop=1]="Desktop",h[h.Web=2]="Web"})(P||(e.UIKind=P={}));var I;(function(h){h[h.VersionMismatch=55]="VersionMismatch",h[h.UnexpectedError=81]="UnexpectedError"})(I||(e.ExtensionHostExitCode=I={}));var L;(function(h){h[h.Initialized=0]="Initialized",h[h.Ready=1]="Ready",h[h.Terminate=2]="Terminate"})(L||(e.MessageType=L={}));function R(h){const O=n.VSBuffer.alloc(1);switch(h){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=R;function A(h,O){if(h.byteLength!==1)return!1;switch(h.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=A;var y;(function(h){h.Start="START_NATIVE_LOG",h.End="END_NATIVE_LOG"})(y||(e.NativeLogMarkers=y={}))}),define(Pe[57],Ae([1,0,3,5,14,27,76,50,52,23,2,6,152]),function(te,e,n,P,I,L,R,A,y,h,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let S=e.ExtHostTelemetry=class extends w.Disposable{constructor(o,d){super(),this.n=o,this.p=d,this.a=this.B(new P.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new P.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.m=new Map,this.j=O.URI.revive(this.n.environment.extensionTelemetryLogResource),this.i=this.n.environment.isExtensionTelemetryLoggingOnly,this.k=d.createLogger(this.j,{id:y.extensionTelemetryLogChannelId,name:(0,g.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(d.onDidChangeLogLevel(D=>{(0,I.isLogLevel)(D)&&this.r()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}r(){this.p.setVisibility(this.j,this.g&&this.p.getLogLevel()===I.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(o,d,D){const T=this.getTelemetryDetails(),v=new p(d,D,o,this.k,this.i,this.getBuiltInCommonProperties(o),{isUsageEnabled:T.isUsageEnabled,isErrorsEnabled:T.isErrorsEnabled}),i=this.m.get(o.identifier.value)??[];return this.m.set(o.identifier.value,[...i,v]),v.apiTelemetryLogger}$initializeTelemetryLevel(o,d,D){this.f=o,this.g=d,this.c=D??{usage:!0,error:!0},this.r()}getBuiltInCommonProperties(o){const d=Object.create(null);switch(d["common.extname"]=`${o.publisher}.${o.name}`,d["common.extversion"]=o.version,d["common.vscodemachineid"]=this.n.telemetryInfo.machineId,d["common.vscodesessionid"]=this.n.telemetryInfo.sessionId,d["common.vscodeversion"]=this.n.version,d["common.isnewappinstall"]=l(this.n.telemetryInfo.firstSessionDate),d["common.product"]=this.n.environment.appHost,this.n.uiKind){case R.UIKind.Web:d["common.uikind"]="web";break;case R.UIKind.Desktop:d["common.uikind"]="desktop";break;default:d["common.uikind"]="unknown"}return d["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.n.remote.authority)),d}$onDidChangeTelemetryLevel(o){this.h=this.getTelemetryConfiguration(),this.f=o;const d=this.getTelemetryDetails();this.m.forEach((D,T)=>{const v=D.filter(i=>!i.isDisposed);v.length===0?this.m.delete(T):this.m.set(T,v)}),this.m.forEach(D=>{for(const T of D)T.updateTelemetryEnablements(d.isUsageEnabled,d.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.r()}onExtensionError(o,d){const T=this.m.get(o.value)?.filter(i=>!i.isDisposed);if(!T)return this.m.delete(o.value),!1;let v=!1;for(const i of T)i.ignoreUnhandledExtHostErrors||(i.logError(d),v=!0);return v}};e.ExtHostTelemetry=S=xe([qe(0,L.IExtHostInitDataService),qe(1,I.ILoggerService)],S);class p{static validateSender(o){if(typeof o!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof o.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof o.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof o.flush<"u"&&typeof o.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(o,d,D,T,v,i,a){this.g=D,this.h=T,this.i=v,this.j=i,this.a=new P.Emitter,this.ignoreUnhandledExtHostErrors=d?.ignoreUnhandledErrors??!1,this.b=d?.ignoreBuiltInCommonProperties??!1,this.c=d?.additionalCommonProperties,this.f=o,this.d={isUsageEnabled:a.isUsageEnabled,isErrorsEnabled:a.isErrorsEnabled}}updateTelemetryEnablements(o,d){this.e&&(this.d={isUsageEnabled:o,isErrorsEnabled:d},this.a.fire(this.e))}mixInCommonPropsAndCleanData(o){let d="properties"in o?o.properties??{}:o;return d=(0,y.cleanData)(d,[]),this.c&&(d=(0,h.mixin)(d,this.c)),this.b||(d=(0,h.mixin)(d,this.j)),"properties"in o?o.properties=d:o=d,o}k(o,d){this.f&&(this.g.publisher==="vscode"?o=this.g.name+"/"+o:o=this.g.identifier.value+"/"+o,d=this.mixInCommonPropsAndCleanData(d||{}),this.i||this.f?.sendEventData(o,d),this.h.trace(o,d))}logUsage(o,d){this.d.isUsageEnabled&&this.k(o,d)}logError(o,d){!this.d.isErrorsEnabled||!this.f||(typeof o=="string"?this.k(o,d):this.f.sendErrorData(o,d))}get apiTelemetryLogger(){if(!this.e){const o=this,d={logUsage:o.logUsage.bind(o),get isUsageEnabled(){return o.d.isUsageEnabled},get isErrorsEnabled(){return o.d.isErrorsEnabled},logError:o.logError.bind(o),dispose:o.dispose.bind(o),onDidChangeEnableStates:o.a.event.bind(o)};this.e=Object.freeze(d)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let o=this.f;this.f=void 0,Promise.resolve(o.flush()).then(o=void 0),this.e=void 0}else this.f=void 0}}e.ExtHostTelemetryLogger=p;function l(t){const o=Date.now()-new Date(t).getTime();return isNaN(o)?!1:o<1e3*60*60*24}e.isNewAppInstall=l,e.IExtHostTelemetry=(0,n.createDecorator)("IExtHostTelemetry")}),define(Pe[26],Ae([1,0,5,2,178,97,24,3]),function(te,e,n,P,I,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.ExtensionHostExtensions=e.ExtensionHostStartup=e.MissingExtensionDependency=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:P.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,A.createDecorator)("extensionService");class y{constructor(v){this.dependency=v}}e.MissingExtensionDependency=y;var h;(function(T){T[T.EagerAutoStart=1]="EagerAutoStart",T[T.EagerManualStart=2]="EagerManualStart",T[T.Lazy=3]="Lazy"})(h||(e.ExtensionHostStartup=h={}));class O{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,addActivationEvents:L.ImplicitActivationEvents.createActivationEventsMap(this.c),myToRemove:[],myToAdd:this.d}}set(v,i){const a=[],r=[],s=[],E=[],k=w(this.c),c=w(v),u=(V,_)=>V.extensionLocation.toString()===_.extensionLocation.toString()||V.isBuiltin===_.isBuiltin||V.isUserBuiltin===_.isUserBuiltin||V.isUnderDevelopment===_.isUnderDevelopment;for(const V of this.c){const _=c.get(V.identifier);if(!_){a.push(V.identifier),k.delete(V.identifier);continue}if(!u(V,_)){a.push(V.identifier),k.delete(V.identifier);continue}}for(const V of v){const _=k.get(V.identifier);if(!_){r.push(V);continue}if(!u(_,V)){a.push(_.identifier),k.delete(_.identifier);continue}}const m=new R.ExtensionIdentifierSet(this.d),b=new R.ExtensionIdentifierSet(i);for(const V of this.d)b.has(V)||s.push(V);for(const V of i)m.has(V)||E.push(V);const f=L.ImplicitActivationEvents.createActivationEventsMap(r),N={toRemove:a,toAdd:r,addActivationEvents:f,myToRemove:s,myToAdd:E};return this.delta(N),N}delta(v){const{toRemove:i,toAdd:a,myToRemove:r,myToAdd:s}=v,E=new R.ExtensionIdentifierSet(i),k=new R.ExtensionIdentifierSet(r);for(let c=0;c<this.c.length;c++)E.has(this.c[c].identifier)&&(this.c.splice(c,1),c--);for(let c=0;c<this.d.length;c++)k.has(this.d[c])&&(this.d.splice(c,1),c--);for(const c of a)this.c.push(c);for(const c of s)this.d.push(c)}containsExtension(v){for(const i of this.d)if(R.ExtensionIdentifier.equals(i,v))return!0;return!1}}e.ExtensionHostExtensions=O;function w(T){const v=new R.ExtensionIdentifierMap;for(const i of T)v.set(i.identifier,i);return v}function g(T,v){return T.enabledApiProposals?T.enabledApiProposals.includes(v):!1}e.isProposedApiEnabled=g;function S(T,v){if(!g(T,v))throw new Error(`Extension '${T.identifier.value}' CANNOT use API proposal: ${v}.
Its package.json#enabledApiProposals-property declares: ${T.enabledApiProposals?.join(", ")??"[]"} but NOT ${v}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${T.identifier.value}`)}e.checkProposedApiEnabled=S;class p{constructor(v,i,a,r){this.codeLoadingTime=v,this.activateCallTime=i,this.activateResolvedTime=a,this.activationReason=r}}e.ActivationTimes=p;class l{constructor(v,i){this.description=v,this.value=i}}e.ExtensionPointContribution=l;var t;(function(T){T[T.Normal=0]="Normal",T[T.Immediate=1]="Immediate"})(t||(e.ActivationKind=t={}));function o(T){return{type:T.isBuiltin?0:1,isBuiltin:T.isBuiltin||T.isUserBuiltin,identifier:{id:(0,I.getGalleryExtensionId)(T.publisher,T.name),uuid:T.uuid},manifest:T,location:T.extensionLocation,targetPlatform:T.targetPlatform,validations:[],isValid:!0}}e.toExtension=o;function d(T,v){return{identifier:new R.ExtensionIdentifier((0,I.getExtensionId)(T.manifest.publisher,T.manifest.name)),isBuiltin:T.type===0,isUserBuiltin:T.type===1&&T.isBuiltin,isUnderDevelopment:!!v,extensionLocation:T.location,...T.manifest,uuid:T.identifier.uuid,targetPlatform:T.targetPlatform}}e.toExtensionDescription=d;class D{constructor(){this.onDidRegisterExtensions=n.Event.None,this.onDidChangeExtensionsStatus=n.Event.None,this.onDidChangeExtensions=n.Event.None,this.onWillActivateByEvent=n.Event.None,this.onDidChangeResponsiveChange=n.Event.None,this.onWillStop=n.Event.None,this.extensions=[]}activateByEvent(v){return Promise.resolve(void 0)}activationEventIsDone(v){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(v){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(v,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(v){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=D}),define(Pe[200],Ae([1,0,9,101,24,26,14,17]),function(te,e,n,P,I,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(o,d,D,T){this.startup=o,this.codeLoadingTime=d,this.activateCallTime=D,this.activateResolvedTime=T}}e.ExtensionActivationTimes=y,y.NONE=new y(!1,-1,-1,-1);class h{constructor(o){this.a=o,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(o,d){return o===-1||d===-1?-1:d-o}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=h;class O{constructor(o,d,D,T,v,i){this.activationFailed=o,this.activationFailedError=d,this.activationTimes=D,this.module=T,this.exports=v,this.subscriptions=i}}e.ActivatedExtension=O;class w extends O{constructor(o){super(!1,null,o,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=w;class g extends O{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=g;class S extends O{constructor(o){super(!0,o,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let p=e.ExtensionsActivator=class{constructor(o,d,D,T){this.g=T,this.a=o,this.b=d,this.c=D,this.d=new I.ExtensionIdentifierMap,this.f=Object.create(null)}dispose(){for(const[o,d]of this.d)d.dispose()}async waitForActivatingExtensions(){const o=[];for(const[d,D]of this.d)o.push(D.wait());await Promise.all(o)}isActivated(o){const d=this.d.get(o);return!!(d&&d.value)}getActivatedExtension(o){const d=this.d.get(o);if(!d||!d.value)throw new Error(`Extension '${o.value}' is not known or not activated`);return d.value}async activateByEvent(o,d){if(this.f[o])return;const D=this.a.getExtensionDescriptionsForActivationEvent(o);await this.h(D.map(T=>({id:T.identifier,reason:{startup:d,extensionId:T.identifier,activationEvent:o}}))),this.f[o]=!0}activateById(o,d){const D=this.a.getExtensionDescription(o);if(!D)throw new Error(`Extension '${o}' is not known`);return this.h([{id:D.identifier,reason:d}])}async h(o){const d=o.filter(D=>!this.isActivated(D.id)).map(D=>this.j(D));await Promise.all(d.map(D=>D.wait()))}j(o){if(this.d.has(o.id))return this.d.get(o.id);if(this.l(o.id))return this.k(o,null,[],null);const d=this.a.getExtensionDescription(o.id);if(!d){const v=new Error(`Cannot activate unknown extension '${o.id.value}'`),i=this.k(o,null,[],new S(v));return this.c.onExtensionActivationError(o.id,v,new L.MissingExtensionDependency(o.id.value)),i}const D=[],T=typeof d.extensionDependencies>"u"?[]:d.extensionDependencies;for(const v of T){if(this.m(v))continue;const i=this.d.get(v);if(i){D.push(i);continue}if(this.l(v)){D.push(this.j({id:this.b.getExtensionDescription(v).identifier,reason:o.reason}));continue}const a=this.a.getExtensionDescription(v);if(a){if(!a.main&&!a.browser)continue;D.push(this.j({id:a.identifier,reason:o.reason}));continue}const r=d.displayName||d.identifier.value,s=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${v}'`),E=this.k(o,d.displayName,[],new S(s));return this.c.onExtensionActivationError(d.identifier,s,new L.MissingExtensionDependency(v)),E}return this.k(o,d.displayName,D,null)}k(o,d,D,T){const v=new l(o.id,d,o.reason,D,T,this.c,this.g);return this.d.set(o.id,v),v}l(o){return P.ExtensionDescriptionRegistry.isHostExtension(o,this.a,this.b)}m(o){const d=this.b.getExtensionDescription(o);return d?!d.main&&!d.browser:!1}};e.ExtensionsActivator=p=xe([qe(3,R.ILogService)],p);let l=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(o,d,D,T,v,i,a){this.c=o,this.d=d,this.f=D,this.g=T,this.h=v,this.j=i,this.k=a,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let o=0;o<this.g.length;o++){const d=this.g[o];if(d.value&&!d.value.activationFailed){this.g.splice(o,1),o--;continue}if(d.value&&d.value.activationFailed){const D=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${d.friendlyName}' failed to activate`);D.detail=d.value.activationFailedError,this.h=new S(D),this.j.onExtensionActivationError(this.c,D,null);return}}this.g.length>0&&await Promise.race(this.g.map(o=>o.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(o){const d=new Error;if(o&&o.name&&(d.name=o.name),o&&o.message?d.message=`Activating extension '${this.c.value}' failed: ${o.message}.`:d.message=`Activating extension '${this.c.value}' failed: ${o}.`,o&&o.stack&&(d.stack=o.stack),this.h=new S(d),this.b&&n.isCancellationError(o))return;this.j.onExtensionActivationError(this.c,d,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(o)}}};l=xe([qe(6,R.ILogService)],l)});var _e=this&&this.__classPrivateFieldSet||function(te,e,n,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(te,n):I?I.value=n:e.set(te,n),n},Ne=this&&this.__classPrivateFieldGet||function(te,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(te):P?P.value:e.get(te)};define(Pe[7],Ae([1,0,16,9,88,28,66,13,12,2,35,43,96,73,26]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p){"use strict";var l,t,o,d,D,T,v,i,a,r,s,E,k,c,u,m,b,f,N,V,_,G,$,B,X;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveEditorResponseFeedbackKind=e.InteractiveSessionCopyKind=e.InteractiveSessionVoteDirection=e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferFile=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function U(z){return Object.assign(z,{apply:function(){const se=arguments.length===1?[]:arguments[1];return Reflect.construct(z,se,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(z,[]);{const[se,...Ie]=arguments;return Reflect.construct(z,Ie,se.constructor)}}})}var j;(function(z){z[z.Top=0]="Top",z[z.Bottom=1]="Bottom"})(j||(e.TerminalOutputAnchor=j={}));var Y;(function(z){z[z.Command=0]="Command",z[z.Opener=1]="Opener"})(Y||(e.TerminalQuickFixType=Y={}));let pe=e.Disposable=i=class{static from(...M){let se=M;return new i(function(){if(se){for(const Ie of se)Ie&&typeof Ie.dispose=="function"&&Ie.dispose();se=void 0}})}constructor(M){l.set(this,void 0),_e(this,l,M,"f")}dispose(){typeof Ne(this,l,"f")=="function"&&(Ne(this,l,"f").call(this),_e(this,l,void 0,"f"))}};l=new WeakMap,e.Disposable=pe=i=xe([U],pe);let Ee=e.Position=a=class{static Min(...M){if(M.length===0)throw new TypeError;let se=M[0];for(let Ie=1;Ie<M.length;Ie++){const Ge=M[Ie];Ge.isBefore(se)&&(se=Ge)}return se}static Max(...M){if(M.length===0)throw new TypeError;let se=M[0];for(let Ie=1;Ie<M.length;Ie++){const Ge=M[Ie];Ge.isAfter(se)&&(se=Ge)}return se}static isPosition(M){if(!M)return!1;if(M instanceof a)return!0;const{line:se,character:Ie}=M;return typeof se=="number"&&typeof Ie=="number"}static of(M){if(M instanceof a)return M;if(this.isPosition(M))return new a(M.line,M.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(M,se){if(M<0)throw(0,P.illegalArgument)("line must be non-negative");if(se<0)throw(0,P.illegalArgument)("character must be non-negative");this.c=M,this.e=se}isBefore(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<M.e}isBeforeOrEqual(M){return this.c<M.c?!0:M.c<this.c?!1:this.e<=M.e}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this.c===M.c&&this.e===M.e}compareTo(M){return this.c<M.c?-1:this.c>M.line?1:this.e<M.e?-1:this.e>M.e?1:0}translate(M,se=0){if(M===null||se===null)throw(0,P.illegalArgument)();let Ie;return typeof M>"u"?Ie=0:typeof M=="number"?Ie=M:(Ie=typeof M.lineDelta=="number"?M.lineDelta:0,se=typeof M.characterDelta=="number"?M.characterDelta:0),Ie===0&&se===0?this:new a(this.line+Ie,this.character+se)}with(M,se=this.character){if(M===null||se===null)throw(0,P.illegalArgument)();let Ie;return typeof M>"u"?Ie=this.line:typeof M=="number"?Ie=M:(Ie=typeof M.line=="number"?M.line:this.line,se=typeof M.character=="number"?M.character:this.character),Ie===this.line&&se===this.character?this:new a(Ie,se)}toJSON(){return{line:this.line,character:this.character}}};e.Position=Ee=a=xe([U],Ee);let he=e.Range=r=class{static isRange(M){return M instanceof r?!0:M?Ee.isPosition(M.start)&&Ee.isPosition(M.end):!1}static of(M){if(M instanceof r)return M;if(this.isRange(M))return new r(M.start,M.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(M,se,Ie,Ge){let Ze,ct;if(typeof M=="number"&&typeof se=="number"&&typeof Ie=="number"&&typeof Ge=="number"?(Ze=new Ee(M,se),ct=new Ee(Ie,Ge)):Ee.isPosition(M)&&Ee.isPosition(se)&&(Ze=Ee.of(M),ct=Ee.of(se)),!Ze||!ct)throw new Error("Invalid arguments");Ze.isBefore(ct)?(this.c=Ze,this.e=ct):(this.c=ct,this.e=Ze)}contains(M){return r.isRange(M)?this.contains(M.start)&&this.contains(M.end):Ee.isPosition(M)?!(Ee.of(M).isBefore(this.c)||this.e.isBefore(M)):!1}isEqual(M){return this.c.isEqual(M.c)&&this.e.isEqual(M.e)}intersection(M){const se=Ee.Max(M.start,this.c),Ie=Ee.Min(M.end,this.e);if(!se.isAfter(Ie))return new r(se,Ie)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const se=Ee.Min(M.start,this.c),Ie=Ee.Max(M.end,this.end);return new r(se,Ie)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(M,se=this.end){if(M===null||se===null)throw(0,P.illegalArgument)();let Ie;return M?Ee.isPosition(M)?Ie=M:(Ie=M.start||this.start,se=M.end||this.end):Ie=this.start,Ie.isEqual(this.c)&&se.isEqual(this.end)?this:new r(Ie,se)}toJSON(){return[this.start,this.end]}};e.Range=he=r=xe([U],he);let de=e.Selection=s=class extends he{static isSelection(M){return M instanceof s?!0:M?he.isRange(M)&&Ee.isPosition(M.anchor)&&Ee.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(M,se,Ie,Ge){let Ze,ct;if(typeof M=="number"&&typeof se=="number"&&typeof Ie=="number"&&typeof Ge=="number"?(Ze=new Ee(M,se),ct=new Ee(Ie,Ge)):Ee.isPosition(M)&&Ee.isPosition(se)&&(Ze=Ee.of(M),ct=Ee.of(se)),!Ze||!ct)throw new Error("Invalid arguments");super(Ze,ct),this.f=Ze,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.Selection=de=s=xe([U],de);class Re{constructor(M,se,Ie){if(typeof M!="string"||M.length===0)throw(0,P.illegalArgument)("host");if(typeof se!="number"||se===0||Math.round(se)!==se)throw(0,P.illegalArgument)("port");if(typeof Ie<"u"&&(typeof Ie!="string"||Ie.length===0||!/^[0-9A-Za-z_\-]+$/.test(Ie)))throw(0,P.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(se),this.connectionToken=Ie}}e.ResolvedAuthority=Re;class le extends Error{static NotAvailable(M,se){return new le(M,g.RemoteAuthorityResolverErrorCode.NotAvailable,se)}static TemporarilyNotAvailable(M){return new le(M,g.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(M,se=g.RemoteAuthorityResolverErrorCode.Unknown,Ie){super(M),this._message=M,this._code=se,this._detail=Ie,Object.setPrototypeOf(this,le.prototype)}}e.RemoteAuthorityResolverError=le;var ue;(function(z){z[z.LF=1]="LF",z[z.CRLF=2]="CRLF"})(ue||(e.EndOfLine=ue={}));var H;(function(z){z[z.Replace=1]="Replace",z[z.Append=2]="Append",z[z.Prepend=3]="Prepend"})(H||(e.EnvironmentVariableMutatorType=H={}));let F=e.TextEdit=E=class{static isTextEdit(M){return M instanceof E?!0:M?he.isRange(M)&&typeof M.newText=="string":!1}static replace(M,se){return new E(M,se)}static insert(M,se){return E.replace(new he(M,M),se)}static delete(M){return E.replace(M,"")}static setEndOfLine(M){const se=new E(new he(new Ee(0,0),new Ee(0,0)),"");return se.newEol=M,se}get range(){return this.c}set range(M){if(M&&!he.isRange(M))throw(0,P.illegalArgument)("range");this.c=M}get newText(){return this.e||""}set newText(M){if(M&&typeof M!="string")throw(0,P.illegalArgument)("newText");this.e=M}get newEol(){return this.f}set newEol(M){if(M&&typeof M!="number")throw(0,P.illegalArgument)("newEol");this.f=M}constructor(M,se){this.c=M,this.e=se}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.TextEdit=F=E=xe([U],F);let Q=e.NotebookEdit=k=class{static isNotebookCellEdit(M){return M instanceof k?!0:M?Yt.isNotebookRange(M)&&Array.isArray(M.newCells):!1}static replaceCells(M,se){return new k(M,se)}static insertCells(M,se){return new k(new Yt(M,M),se)}static deleteCells(M){return new k(M,[])}static updateCellMetadata(M,se){const Ie=new k(new Yt(M,M),[]);return Ie.newCellMetadata=se,Ie}static updateNotebookMetadata(M){const se=new k(new Yt(0,0),[]);return se.newNotebookMetadata=M,se}constructor(M,se){this.range=M,this.newCells=se}};e.NotebookEdit=Q=k=xe([U],Q);class me{static isSnippetTextEdit(M){return M instanceof me?!0:M?he.isRange(M.range)&&be.isSnippetString(M.snippet):!1}static replace(M,se){return new me(M,se)}static insert(M,se){return me.replace(new he(M,M),se)}constructor(M,se){this.range=M,this.snippet=se}}e.SnippetTextEdit=me;var Ce;(function(z){z[z.File=1]="File",z[z.Text=2]="Text",z[z.Cell=3]="Cell",z[z.CellReplace=5]="CellReplace",z[z.Snippet=6]="Snippet"})(Ce||(e.FileEditType=Ce={}));let De=e.WorkspaceEdit=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(M,se,Ie,Ge){this.c.push({_type:1,from:M,to:se,options:Ie,metadata:Ge})}createFile(M,se,Ie){this.c.push({_type:1,from:void 0,to:M,options:se,metadata:Ie})}deleteFile(M,se,Ie){this.c.push({_type:1,from:M,to:void 0,options:se,metadata:Ie})}e(M,se,Ie){this.c.push({_type:3,metadata:Ie,uri:M,edit:{editType:5,metadata:se},notebookMetadata:se})}f(M,se,Ie,Ge){const Ze=se.start,ct=se.end;(Ze!==ct||Ie.length>0)&&this.c.push({_type:5,uri:M,index:Ze,count:ct-Ze,cells:Ie,metadata:Ge})}g(M,se,Ie,Ge){this.c.push({_type:3,metadata:Ge,uri:M,edit:{editType:8,index:se,metadata:Ie}})}replace(M,se,Ie,Ge){this.c.push({_type:2,uri:M,edit:new F(se,Ie),metadata:Ge})}insert(M,se,Ie,Ge){this.replace(M,new he(se,se),Ie,Ge)}delete(M,se,Ie){this.replace(M,se,"",Ie)}has(M){return this.c.some(se=>se._type===2&&se.uri.toString()===M.toString())}set(M,se){if(se)for(const Ie of se){if(!Ie)continue;let Ge,Ze;Array.isArray(Ie)?(Ge=Ie[0],Ze=Ie[1]):Ge=Ie,Q.isNotebookCellEdit(Ge)?Ge.newCellMetadata?this.g(M,Ge.range.start,Ge.newCellMetadata,Ze):Ge.newNotebookMetadata?this.e(M,Ge.newNotebookMetadata,Ze):this.f(M,Ge.range,Ge.newCells,Ze):me.isSnippetTextEdit(Ge)?this.c.push({_type:6,uri:M,range:Ge.range,edit:Ge.snippet,metadata:Ze}):this.c.push({_type:2,uri:M,edit:Ge,metadata:Ze})}else{for(let Ie=0;Ie<this.c.length;Ie++){const Ge=this.c[Ie];switch(Ge._type){case 2:case 6:case 3:case 5:Ge.uri.toString()===M.toString()&&(this.c[Ie]=void 0);break}}(0,n.coalesceInPlace)(this.c)}}get(M){const se=[];for(const Ie of this.c)Ie._type===2&&Ie.uri.toString()===M.toString()&&se.push(Ie.edit);return se}entries(){const M=new L.ResourceMap;for(const se of this.c)if(se._type===2){let Ie=M.get(se.uri);Ie||(Ie=[se.uri,[]],M.set(se.uri,Ie)),Ie[1].push(se.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.WorkspaceEdit=De=xe([U],De);let be=e.SnippetString=c=class{static isSnippetString(M){return M instanceof c?!0:M?typeof M.value=="string":!1}static c(M){return M.replace(/\$|}|\\/g,"\\$&")}constructor(M){this.e=1,this.value=M||""}appendText(M){return this.value+=c.c(M),this}appendTabstop(M=this.e++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,se=this.e++){if(typeof M=="function"){const Ie=new c;Ie.e=this.e,M(Ie),this.e=Ie.e,M=Ie.value}else M=c.c(M);return this.value+="${",this.value+=se,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,se=this.e++){const Ie=M.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=se,this.value+="|",this.value+=Ie,this.value+="|}",this}appendVariable(M,se){if(typeof se=="function"){const Ie=new c;Ie.e=this.e,se(Ie),this.e=Ie.e,se=Ie.value}else typeof se=="string"&&(se=se.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,se&&(this.value+=":",this.value+=se),this.value+="}",this}};e.SnippetString=be=c=xe([U],be);var ke;(function(z){z[z.Unnecessary=1]="Unnecessary",z[z.Deprecated=2]="Deprecated"})(ke||(e.DiagnosticTag=ke={}));var oe;(function(z){z[z.Hint=3]="Hint",z[z.Information=2]="Information",z[z.Warning=1]="Warning",z[z.Error=0]="Error"})(oe||(e.DiagnosticSeverity=oe={}));let ce=e.Location=u=class{static isLocation(M){return M instanceof u?!0:M?he.isRange(M.range)&&h.URI.isUri(M.uri):!1}constructor(M,se){if(this.uri=M,se)if(he.isRange(se))this.range=he.of(se);else if(Ee.isPosition(se))this.range=new he(se,se);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.Location=ce=u=xe([U],ce);let ie=e.DiagnosticRelatedInformation=class{static is(M){return M?typeof M.message=="string"&&M.location&&he.isRange(M.location.range)&&h.URI.isUri(M.location.uri):!1}constructor(M,se){this.location=M,this.message=se}static isEqual(M,se){return M===se?!0:!M||!se?!1:M.message===se.message&&M.location.range.isEqual(se.location.range)&&M.location.uri.toString()===se.location.uri.toString()}};e.DiagnosticRelatedInformation=ie=xe([U],ie);let ne=e.Diagnostic=class{constructor(M,se,Ie=oe.Error){if(!he.isRange(M))throw new TypeError("range must be set");if(!se)throw new TypeError("message must be set");this.range=M,this.message=se,this.severity=Ie}toJSON(){return{severity:oe[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,se){return M===se?!0:!M||!se?!1:M.message===se.message&&M.severity===se.severity&&M.code===se.code&&M.severity===se.severity&&M.source===se.source&&M.range.isEqual(se.range)&&(0,n.equals)(M.tags,se.tags)&&(0,n.equals)(M.relatedInformation,se.relatedInformation,ie.isEqual)}};e.Diagnostic=ne=xe([U],ne);let C=e.Hover=class{constructor(M,se){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=se}};e.Hover=C=xe([U],C);var W;(function(z){z[z.Text=0]="Text",z[z.Read=1]="Read",z[z.Write=2]="Write"})(W||(e.DocumentHighlightKind=W={}));let q=e.DocumentHighlight=class{constructor(M,se=W.Text){this.range=M,this.kind=se}toJSON(){return{range:this.range,kind:W[this.kind]}}};e.DocumentHighlight=q=xe([U],q);var x;(function(z){z[z.File=0]="File",z[z.Module=1]="Module",z[z.Namespace=2]="Namespace",z[z.Package=3]="Package",z[z.Class=4]="Class",z[z.Method=5]="Method",z[z.Property=6]="Property",z[z.Field=7]="Field",z[z.Constructor=8]="Constructor",z[z.Enum=9]="Enum",z[z.Interface=10]="Interface",z[z.Function=11]="Function",z[z.Variable=12]="Variable",z[z.Constant=13]="Constant",z[z.String=14]="String",z[z.Number=15]="Number",z[z.Boolean=16]="Boolean",z[z.Array=17]="Array",z[z.Object=18]="Object",z[z.Key=19]="Key",z[z.Null=20]="Null",z[z.EnumMember=21]="EnumMember",z[z.Struct=22]="Struct",z[z.Event=23]="Event",z[z.Operator=24]="Operator",z[z.TypeParameter=25]="TypeParameter"})(x||(e.SymbolKind=x={}));var ae;(function(z){z[z.Deprecated=1]="Deprecated"})(ae||(e.SymbolTag=ae={}));let ge=e.SymbolInformation=m=class{static validate(M){if(!M.name)throw new Error("name must not be falsy")}constructor(M,se,Ie,Ge,Ze){this.name=M,this.kind=se,this.containerName=Ze,typeof Ie=="string"&&(this.containerName=Ie),Ge instanceof ce?this.location=Ge:Ie instanceof he&&(this.location=new ce(Ge,Ie)),m.validate(this)}toJSON(){return{name:this.name,kind:x[this.kind],location:this.location,containerName:this.containerName}}};e.SymbolInformation=ge=m=xe([U],ge);let ee=e.DocumentSymbol=b=class{static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children?.forEach(b.validate)}constructor(M,se,Ie,Ge,Ze){this.name=M,this.detail=se,this.kind=Ie,this.range=Ge,this.selectionRange=Ze,this.children=[],b.validate(this)}};e.DocumentSymbol=ee=b=xe([U],ee);var we;(function(z){z[z.Invoke=1]="Invoke",z[z.Automatic=2]="Automatic"})(we||(e.CodeActionTriggerKind=we={}));let ye=e.CodeAction=class{constructor(M,se){this.title=M,this.kind=se}};e.CodeAction=ye=xe([U],ye);let ze=e.CodeActionKind=f=class{constructor(M){this.value=M}append(M){return new f(this.value?this.value+f.c+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+f.c)}};ze.c=".",e.CodeActionKind=ze=f=xe([U],ze),ze.Empty=new ze(""),ze.QuickFix=ze.Empty.append("quickfix"),ze.Refactor=ze.Empty.append("refactor"),ze.RefactorExtract=ze.Refactor.append("extract"),ze.RefactorInline=ze.Refactor.append("inline"),ze.RefactorMove=ze.Refactor.append("move"),ze.RefactorRewrite=ze.Refactor.append("rewrite"),ze.Source=ze.Empty.append("source"),ze.SourceOrganizeImports=ze.Source.append("organizeImports"),ze.SourceFixAll=ze.Source.append("fixAll");let je=e.SelectionRange=class{constructor(M,se){if(this.range=M,this.parent=se,se&&!se.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.SelectionRange=je=xe([U],je);class et{constructor(M,se,Ie,Ge,Ze,ct){this.kind=M,this.name=se,this.detail=Ie,this.uri=Ge,this.range=Ze,this.selectionRange=ct}}e.CallHierarchyItem=et;class Ye{constructor(M,se){this.fromRanges=se,this.from=M}}e.CallHierarchyIncomingCall=Ye;class Je{constructor(M,se){this.fromRanges=se,this.to=M}}e.CallHierarchyOutgoingCall=Je;var rt;(function(z){z[z.Information=0]="Information",z[z.Warning=1]="Warning",z[z.Error=2]="Error"})(rt||(e.LanguageStatusSeverity=rt={}));let ut=e.CodeLens=class{constructor(M,se){this.range=M,this.command=se}get isResolved(){return!!this.command}};e.CodeLens=ut=xe([U],ut);let Me=e.MarkdownString=N=class{static isMarkdownString(M){return M instanceof N?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}constructor(M,se=!1){t.set(this,void 0),_e(this,t,new I.MarkdownString(M,{supportThemeIcons:se}),"f")}get value(){return Ne(this,t,"f").value}set value(M){Ne(this,t,"f").value=M}get isTrusted(){return Ne(this,t,"f").isTrusted}set isTrusted(M){Ne(this,t,"f").isTrusted=M}get supportThemeIcons(){return Ne(this,t,"f").supportThemeIcons}set supportThemeIcons(M){Ne(this,t,"f").supportThemeIcons=M}get supportHtml(){return Ne(this,t,"f").supportHtml}set supportHtml(M){Ne(this,t,"f").supportHtml=M}get baseUri(){return Ne(this,t,"f").baseUri}set baseUri(M){Ne(this,t,"f").baseUri=M}appendText(M){return Ne(this,t,"f").appendText(M),this}appendMarkdown(M){return Ne(this,t,"f").appendMarkdown(M),this}appendCodeblock(M,se){return Ne(this,t,"f").appendCodeblock(se??"",M),this}};t=new WeakMap,e.MarkdownString=Me=N=xe([U],Me);let st=e.ParameterInformation=class{constructor(M,se){this.label=M,this.documentation=se}};e.ParameterInformation=st=xe([U],st);let Z=e.SignatureInformation=class{constructor(M,se){this.label=M,this.documentation=se,this.parameters=[]}};e.SignatureInformation=Z=xe([U],Z);let J=e.SignatureHelp=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.SignatureHelp=J=xe([U],J);var Se;(function(z){z[z.Invoke=1]="Invoke",z[z.TriggerCharacter=2]="TriggerCharacter",z[z.ContentChange=3]="ContentChange"})(Se||(e.SignatureHelpTriggerKind=Se={}));var Ue;(function(z){z[z.Type=1]="Type",z[z.Parameter=2]="Parameter"})(Ue||(e.InlayHintKind=Ue={}));let We=e.InlayHintLabelPart=class{constructor(M){this.value=M}};e.InlayHintLabelPart=We=xe([U],We);let Qe=e.InlayHint=class{constructor(M,se,Ie){this.position=M,this.label=se,this.kind=Ie}};e.InlayHint=Qe=xe([U],Qe);var Ve;(function(z){z[z.Invoke=0]="Invoke",z[z.TriggerCharacter=1]="TriggerCharacter",z[z.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ve||(e.CompletionTriggerKind=Ve={}));var it;(function(z){z[z.Text=0]="Text",z[z.Method=1]="Method",z[z.Function=2]="Function",z[z.Constructor=3]="Constructor",z[z.Field=4]="Field",z[z.Variable=5]="Variable",z[z.Class=6]="Class",z[z.Interface=7]="Interface",z[z.Module=8]="Module",z[z.Property=9]="Property",z[z.Unit=10]="Unit",z[z.Value=11]="Value",z[z.Enum=12]="Enum",z[z.Keyword=13]="Keyword",z[z.Snippet=14]="Snippet",z[z.Color=15]="Color",z[z.File=16]="File",z[z.Reference=17]="Reference",z[z.Folder=18]="Folder",z[z.EnumMember=19]="EnumMember",z[z.Constant=20]="Constant",z[z.Struct=21]="Struct",z[z.Event=22]="Event",z[z.Operator=23]="Operator",z[z.TypeParameter=24]="TypeParameter",z[z.User=25]="User",z[z.Issue=26]="Issue"})(it||(e.CompletionItemKind=it={}));var Et;(function(z){z[z.Deprecated=1]="Deprecated"})(Et||(e.CompletionItemTag=Et={}));let yt=e.CompletionItem=class{constructor(M,se){this.label=M,this.kind=se}toJSON(){return{label:this.label,kind:this.kind&&it[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.CompletionItem=yt=xe([U],yt);let Tt=e.CompletionList=class{constructor(M=[],se=!1){this.items=M,this.isIncomplete=se}};e.CompletionList=Tt=xe([U],Tt);let Ht=e.InlineSuggestion=class{constructor(M,se,Ie){this.insertText=M,this.range=se,this.command=Ie}};e.InlineSuggestion=Ht=xe([U],Ht);let wt=e.InlineSuggestionList=class{constructor(M){this.commands=void 0,this.suppressSuggestions=void 0,this.items=M}};e.InlineSuggestionList=wt=xe([U],wt);var Bt;(function(z){z[z.Active=-1]="Active",z[z.Beside=-2]="Beside",z[z.One=1]="One",z[z.Two=2]="Two",z[z.Three=3]="Three",z[z.Four=4]="Four",z[z.Five=5]="Five",z[z.Six=6]="Six",z[z.Seven=7]="Seven",z[z.Eight=8]="Eight",z[z.Nine=9]="Nine"})(Bt||(e.ViewColumn=Bt={}));var Mt;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Mt||(e.StatusBarAlignment=Mt={}));var xt;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative"})(xt||(e.TextEditorLineNumbersStyle=xt={}));var Vt;(function(z){z[z.Manual=1]="Manual",z[z.AfterDelay=2]="AfterDelay",z[z.FocusOut=3]="FocusOut"})(Vt||(e.TextDocumentSaveReason=Vt={}));var Pt;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(Pt||(e.TextEditorRevealType=Pt={}));var at;(function(z){z[z.Keyboard=1]="Keyboard",z[z.Mouse=2]="Mouse",z[z.Command=3]="Command"})(at||(e.TextEditorSelectionChangeKind=at={}));var gt;(function(z){z[z.Undo=1]="Undo",z[z.Redo=2]="Redo"})(gt||(e.TextDocumentChangeReason=gt={}));var Wt;(function(z){z[z.OpenOpen=0]="OpenOpen",z[z.ClosedClosed=1]="ClosedClosed",z[z.OpenClosed=2]="OpenClosed",z[z.ClosedOpen=3]="ClosedOpen"})(Wt||(e.DecorationRangeBehavior=Wt={})),function(z){function M(se){switch(se){case"keyboard":return z.Keyboard;case"mouse":return z.Mouse;case"api":return z.Command}}z.fromValue=M}(at||(e.TextEditorSelectionChangeKind=at={}));let Ut=e.DocumentLink=class{constructor(M,se){if(se&&!h.URI.isUri(se))throw(0,P.illegalArgument)("target");if(!he.isRange(M)||M.isEmpty)throw(0,P.illegalArgument)("range");this.range=M,this.target=se}};e.DocumentLink=Ut=xe([U],Ut);let kt=e.Color=class{constructor(M,se,Ie,Ge){this.red=M,this.green=se,this.blue=Ie,this.alpha=Ge}};e.Color=kt=xe([U],kt);let ht=e.ColorInformation=class{constructor(M,se){if(se&&!(se instanceof kt))throw(0,P.illegalArgument)("color");if(!he.isRange(M)||M.isEmpty)throw(0,P.illegalArgument)("range");this.range=M,this.color=se}};e.ColorInformation=ht=xe([U],ht);let Ct=e.ColorPresentation=class{constructor(M){if(!M||typeof M!="string")throw(0,P.illegalArgument)("label");this.label=M}};e.ColorPresentation=Ct=xe([U],Ct);var Ft;(function(z){z[z.RGB=0]="RGB",z[z.HEX=1]="HEX",z[z.HSL=2]="HSL"})(Ft||(e.ColorFormat=Ft={}));var At;(function(z){z[z.Error=0]="Error",z[z.Warning=1]="Warning",z[z.Information=2]="Information"})(At||(e.SourceControlInputBoxValidationType=At={}));var Ke;(function(z){z[z.Unknown=0]="Unknown",z[z.Shutdown=1]="Shutdown",z[z.Process=2]="Process",z[z.User=3]="User",z[z.Extension=4]="Extension"})(Ke||(e.TerminalExitReason=Ke={}));class Te{constructor(M,se,Ie){if(this.startIndex=M,this.length=se,this.tooltip=Ie,typeof M!="number"||M<0)throw(0,P.illegalArgument)("startIndex");if(typeof se!="number"||se<1)throw(0,P.illegalArgument)("length");if(Ie!==void 0&&typeof Ie!="string")throw(0,P.illegalArgument)("tooltip")}}e.TerminalLink=Te;class Oe{constructor(M){this.uri=M}}e.TerminalQuickFixOpener=Oe;class ve{constructor(M){this.terminalCommand=M}}e.TerminalQuickFixCommand=ve;var K;(function(z){z[z.Panel=1]="Panel",z[z.Editor=2]="Editor"})(K||(e.TerminalLocation=K={}));class Fe{constructor(M){if(this.options=M,typeof M!="object")throw(0,P.illegalArgument)("options")}}e.TerminalProfile=Fe;var Be;(function(z){z[z.Always=1]="Always",z[z.Silent=2]="Silent",z[z.Never=3]="Never"})(Be||(e.TaskRevealKind=Be={}));var Xe;(function(z){z[z.Shared=1]="Shared",z[z.Dedicated=2]="Dedicated",z[z.New=3]="New"})(Xe||(e.TaskPanelKind=Xe={}));let He=e.TaskGroup=V=class{static from(M){switch(M){case"clean":return V.Clean;case"build":return V.Build;case"rebuild":return V.Rebuild;case"test":return V.Test;default:return}}constructor(M,se){if(this.label=se,typeof M!="string"||typeof se!="string")throw(0,P.illegalArgument)("name");this.c=M}get id(){return this.c}};He.Clean=new V("clean","Clean"),He.Build=new V("build","Build"),He.Rebuild=new V("rebuild","Rebuild"),He.Test=new V("test","Test"),e.TaskGroup=He=V=xe([U],He);function tt(z){let M="";for(let se=0;se<z.length;se++)M+=z[se].replace(/,/g,",,")+",";return M}let bt=e.ProcessExecution=class{constructor(M,se,Ie){if(typeof M!="string")throw(0,P.illegalArgument)("process");this.e=[],this.c=M,se!==void 0&&(Array.isArray(se)?(this.e=se,this.f=Ie):this.f=se)}get process(){return this.c}set process(M){if(typeof M!="string")throw(0,P.illegalArgument)("process");this.c=M}get args(){return this.e}set args(M){Array.isArray(M)||(M=[]),this.e=M}get options(){return this.f}set options(M){this.f=M}computeId(){const M=[];if(M.push("process"),this.c!==void 0&&M.push(this.c),this.e&&this.e.length>0)for(const se of this.e)M.push(se);return tt(M)}};e.ProcessExecution=bt=xe([U],bt);let pt=e.ShellExecution=class{constructor(M,se,Ie){if(this.f=[],Array.isArray(se)){if(!M)throw(0,P.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,P.illegalArgument)("command");this.e=M,this.f=se,this.g=Ie}else{if(typeof M!="string")throw(0,P.illegalArgument)("commandLine");this.c=M,this.g=se}}get commandLine(){return this.c}set commandLine(M){if(typeof M!="string")throw(0,P.illegalArgument)("commandLine");this.c=M}get command(){return this.e?this.e:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,P.illegalArgument)("command");this.e=M}get args(){return this.f}set args(M){this.f=M||[]}get options(){return this.g}set options(M){this.g=M}computeId(){const M=[];if(M.push("shell"),this.c!==void 0&&M.push(this.c),this.e!==void 0&&M.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const se of this.f)M.push(typeof se=="string"?se:se.value);return tt(M)}};e.ShellExecution=pt=xe([U],pt);var dt;(function(z){z[z.Escape=1]="Escape",z[z.Strong=2]="Strong",z[z.Weak=3]="Weak"})(dt||(e.ShellQuoting=dt={}));var nt;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace"})(nt||(e.TaskScope=nt={}));class lt{constructor(M){this.c=M}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(M){this.c=M}get callback(){return this.c}}e.CustomExecution=lt;let Ot=e.Task=_=class{constructor(M,se,Ie,Ge,Ze,ct){this.j=!1,this.k=this.definition=M;let mt;typeof se=="string"?(this.m=this.name=se,this.t=this.source=Ie,this.execution=Ge,mt=Ze,this.j=!0):se===nt.Global||se===nt.Workspace?(this.target=se,this.m=this.name=Ie,this.t=this.source=Ge,this.execution=Ze,mt=ct):(this.target=se,this.m=this.name=Ie,this.t=this.source=Ge,this.execution=Ze,mt=ct),typeof mt=="string"?(this.o=[mt],this.q=!0):Array.isArray(mt)?(this.o=mt,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(M){this.h=M}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof bt?this.k={type:_.e,id:this.n.computeId()}:this.n instanceof pt?this.k={type:_.f,id:this.n.computeId()}:this.n instanceof lt?this.k={type:_.c,id:this.n.computeId()}:this.k={type:_.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(M){if(M==null)throw(0,P.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=M}get scope(){return this.l}set target(M){this.y(),this.l=M}get name(){return this.m}set name(M){if(typeof M!="string")throw(0,P.illegalArgument)("name");this.y(),this.m=M}get execution(){return this.n}set execution(M){M===null&&(M=void 0),this.y(),this.n=M;const se=this.k.type;(_.g===se||_.e===se||_.f===se||_.c===se)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(M){if(Array.isArray(M))this.y(),this.o=M,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.y(),this.r=M}get source(){return this.t}set source(M){if(typeof M!="string"||M.length===0)throw(0,P.illegalArgument)("source must be a string of length > 0");this.y(),this.t=M}get group(){return this.u}set group(M){M===null&&(M=void 0),this.y(),this.u=M}get detail(){return this.x}set detail(M){M===null&&(M=void 0),this.x=M}get presentationOptions(){return this.v}set presentationOptions(M){M==null&&(M=Object.create(null)),this.y(),this.v=M}get runOptions(){return this.w}set runOptions(M){M==null&&(M=Object.create(null)),this.y(),this.w=M}};Ot.c="customExecution",Ot.e="process",Ot.f="shell",Ot.g="$empty",e.Task=Ot=_=xe([U],Ot);var $t;(function(z){z[z.SourceControl=1]="SourceControl",z[z.Window=10]="Window",z[z.Notification=15]="Notification"})($t||(e.ProgressLocation=$t={}));var ai;(function(z){function M(se){const Ie=se;return(0,y.isNumber)(Ie.value)?Ie.tooltip&&!(0,y.isString)(Ie.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ie.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ie.value),!1)}z.isViewBadge=M})(ai||(e.ViewBadge=ai={}));let ri=e.TreeItem=G=class{static isTreeItem(M,se){const Ie=M;if(Ie.checkboxState!==void 0){(0,p.checkProposedApiEnabled)(se,"treeItemCheckbox");const Ge=(0,y.isNumber)(Ie.checkboxState)?Ie.checkboxState:(0,y.isObject)(Ie.checkboxState)&&(0,y.isNumber)(Ie.checkboxState.state)?Ie.checkboxState.state:void 0,Ze=!(0,y.isNumber)(Ie.checkboxState)&&(0,y.isObject)(Ie.checkboxState)?Ie.checkboxState.tooltip:void 0;if(Ge===void 0||Ge!==It.Checked&&Ge!==It.Unchecked||Ze!==void 0&&!(0,y.isString)(Ze))return console.log("INVALID tree item, invalid checkboxState",Ie.checkboxState),!1}if(M instanceof G)return!0;if(Ie.label!==void 0&&!(0,y.isString)(Ie.label)&&!Ie.label?.label)return console.log("INVALID tree item, invalid label",Ie.label),!1;if(Ie.id!==void 0&&!(0,y.isString)(Ie.id))return console.log("INVALID tree item, invalid id",Ie.id),!1;if(Ie.iconPath!==void 0&&!(0,y.isString)(Ie.iconPath)&&!h.URI.isUri(Ie.iconPath)&&(!Ie.iconPath||!(0,y.isString)(Ie.iconPath.id))){const Ge=Ie.iconPath;if(!Ge||!(0,y.isString)(Ge.light)&&!h.URI.isUri(Ge.light)&&!(0,y.isString)(Ge.dark)&&!h.URI.isUri(Ge.dark))return console.log("INVALID tree item, invalid iconPath",Ie.iconPath),!1}return Ie.description!==void 0&&!(0,y.isString)(Ie.description)&&typeof Ie.description!="boolean"?(console.log("INVALID tree item, invalid description",Ie.description),!1):Ie.resourceUri!==void 0&&!h.URI.isUri(Ie.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ie.resourceUri),!1):Ie.tooltip!==void 0&&!(0,y.isString)(Ie.tooltip)&&!(Ie.tooltip instanceof Me)?(console.log("INVALID tree item, invalid tooltip",Ie.tooltip),!1):Ie.command!==void 0&&!Ie.command.command?(console.log("INVALID tree item, invalid command",Ie.command),!1):Ie.collapsibleState!==void 0&&Ie.collapsibleState<ei.None&&Ie.collapsibleState>ei.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ie.collapsibleState),!1):Ie.contextValue!==void 0&&!(0,y.isString)(Ie.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ie.contextValue),!1):Ie.accessibilityInformation!==void 0&&!Ie.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ie.accessibilityInformation),!1):!0}constructor(M,se=ei.None){this.collapsibleState=se,h.URI.isUri(M)?this.resourceUri=M:this.label=M}};e.TreeItem=ri=G=xe([U],ri);var ei;(function(z){z[z.None=0]="None",z[z.Collapsed=1]="Collapsed",z[z.Expanded=2]="Expanded"})(ei||(e.TreeItemCollapsibleState=ei={}));var It;(function(z){z[z.Unchecked=0]="Unchecked",z[z.Checked=1]="Checked"})(It||(e.TreeItemCheckboxState=It={}));let Pi=e.DataTransferItem=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(M,se){this.value=M,this.id=se??(0,O.generateUuid)()}};e.DataTransferItem=Pi=xe([U],Pi);class Ji{constructor(M,se,Ie,Ge){this.name=M,this.uri=se,this._itemId=Ie,this.c=Ge}data(){return this.c()}}e.DataTransferFile=Ji;let Dt=e.DataTransfer=class{constructor(M){o.add(this),d.set(this,new Map);for(const[se,Ie]of M??[]){const Ge=Ne(this,d,"f").get(Ne(this,o,"m",D).call(this,se));Ge?Ge.push(Ie):Ne(this,d,"f").set(Ne(this,o,"m",D).call(this,se),[Ie])}}get(M){return Ne(this,d,"f").get(Ne(this,o,"m",D).call(this,M))?.[0]}set(M,se){Ne(this,d,"f").set(Ne(this,o,"m",D).call(this,M),[se])}forEach(M,se){for(const[Ie,Ge]of Ne(this,d,"f"))for(const Ze of Ge)M.call(se,Ze,Ie,this)}*[(d=new WeakMap,o=new WeakSet,Symbol.iterator)](){for(const[M,se]of Ne(this,d,"f"))for(const Ie of se)yield[M,Ie]}};D=function(M){return M.toLowerCase()},e.DataTransfer=Dt=xe([U],Dt);let gi=e.DocumentDropEdit=class{constructor(M){this.insertText=M}};e.DocumentDropEdit=gi=xe([U],gi);let pi=e.DocumentPasteEdit=class{constructor(M){this.insertText=M}};e.DocumentPasteEdit=pi=xe([U],pi);let jt=e.ThemeIcon=class{constructor(M,se){this.id=M,this.color=se}static isThemeIcon(M){return typeof M.id!="string"?(console.log("INVALID ThemeIcon, invalid id",M.id),!1):!0}};e.ThemeIcon=jt=xe([U],jt),jt.File=new jt("file"),jt.Folder=new jt("folder");let Ai=e.ThemeColor=class{constructor(M){this.id=M}};e.ThemeColor=Ai=xe([U],Ai);var Ri;(function(z){z[z.Global=1]="Global",z[z.Workspace=2]="Workspace",z[z.WorkspaceFolder=3]="WorkspaceFolder"})(Ri||(e.ConfigurationTarget=Ri={}));let Lt=e.RelativePattern=class{get base(){return this.c}set base(M){this.c=M,this.e=h.URI.file(M)}get baseUri(){return this.e}set baseUri(M){this.e=M,this.c=M.fsPath}constructor(M,se){if(typeof M!="string"&&(!M||!h.URI.isUri(M)&&!h.URI.isUri(M.uri)))throw(0,P.illegalArgument)("base");if(typeof se!="string")throw(0,P.illegalArgument)("pattern");typeof M=="string"?this.baseUri=h.URI.file(M):h.URI.isUri(M)?this.baseUri=M:this.baseUri=M.uri,this.pattern=se}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.RelativePattern=Lt=xe([U],Lt);const vi=new WeakMap;function _i(z,M){vi.set(z,M)}e.setBreakpointId=_i;let Xt=e.Breakpoint=class{constructor(M,se,Ie,Ge){this.enabled=typeof M=="boolean"?M:!0,typeof se=="string"&&(this.condition=se),typeof Ie=="string"&&(this.hitCondition=Ie),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this.c||(this.c=vi.get(this)??(0,O.generateUuid)()),this.c}};e.Breakpoint=Xt=xe([U],Xt);let si=e.SourceBreakpoint=class extends Xt{constructor(M,se,Ie,Ge,Ze){if(super(se,Ie,Ge,Ze),M===null)throw(0,P.illegalArgument)("location");this.location=M}};e.SourceBreakpoint=si=xe([U],si);let ft=e.FunctionBreakpoint=class extends Xt{constructor(M,se,Ie,Ge,Ze){super(se,Ie,Ge,Ze),this.functionName=M}};e.FunctionBreakpoint=ft=xe([U],ft);let Oi=e.DataBreakpoint=class extends Xt{constructor(M,se,Ie,Ge,Ze,ct,mt){if(super(Ge,Ze,ct,mt),!se)throw(0,P.illegalArgument)("dataId");this.label=M,this.dataId=se,this.canPersist=Ie}};e.DataBreakpoint=Oi=xe([U],Oi);let Qt=e.DebugAdapterExecutable=class{constructor(M,se,Ie){this.command=M,this.args=se||[],this.options=Ie}};e.DebugAdapterExecutable=Qt=xe([U],Qt);let ti=e.DebugAdapterServer=class{constructor(M,se){this.port=M,this.host=se}};e.DebugAdapterServer=ti=xe([U],ti);let bi=e.DebugAdapterNamedPipeServer=class{constructor(M){this.path=M}};e.DebugAdapterNamedPipeServer=bi=xe([U],bi);let Fi=e.DebugAdapterInlineImplementation=class{constructor(M){this.implementation=M}};e.DebugAdapterInlineImplementation=Fi=xe([U],Fi);let Li=e.EvaluatableExpression=class{constructor(M,se){this.range=M,this.expression=se}};e.EvaluatableExpression=Li=xe([U],Li);var Ei;(function(z){z[z.Invoke=0]="Invoke",z[z.Automatic=1]="Automatic"})(Ei||(e.InlineCompletionTriggerKind=Ei={}));let Ni=e.InlineValueText=class{constructor(M,se){this.range=M,this.text=se}};e.InlineValueText=Ni=xe([U],Ni);let wi=e.InlineValueVariableLookup=class{constructor(M,se,Ie=!0){this.range=M,this.variableName=se,this.caseSensitiveLookup=Ie}};e.InlineValueVariableLookup=wi=xe([U],wi);let ii=e.InlineValueEvaluatableExpression=class{constructor(M,se){this.range=M,this.expression=se}};e.InlineValueEvaluatableExpression=ii=xe([U],ii);let Mi=e.InlineValueContext=class{constructor(M,se){this.frameId=M,this.stoppedLocation=se}};e.InlineValueContext=Mi=xe([U],Mi);var ci;(function(z){z[z.Changed=1]="Changed",z[z.Created=2]="Created",z[z.Deleted=3]="Deleted"})(ci||(e.FileChangeType=ci={}));let ui=e.FileSystemError=$=class extends Error{static FileExists(M){return new $(M,w.FileSystemProviderErrorCode.FileExists,$.FileExists)}static FileNotFound(M){return new $(M,w.FileSystemProviderErrorCode.FileNotFound,$.FileNotFound)}static FileNotADirectory(M){return new $(M,w.FileSystemProviderErrorCode.FileNotADirectory,$.FileNotADirectory)}static FileIsADirectory(M){return new $(M,w.FileSystemProviderErrorCode.FileIsADirectory,$.FileIsADirectory)}static NoPermissions(M){return new $(M,w.FileSystemProviderErrorCode.NoPermissions,$.NoPermissions)}static Unavailable(M){return new $(M,w.FileSystemProviderErrorCode.Unavailable,$.Unavailable)}constructor(M,se=w.FileSystemProviderErrorCode.Unknown,Ie){super(h.URI.isUri(M)?M.toString(!0):M),this.code=Ie?.name??"Unknown",(0,w.markAsFileSystemProviderError)(this,se),Object.setPrototypeOf(this,$.prototype),typeof Error.captureStackTrace=="function"&&typeof Ie=="function"&&Error.captureStackTrace(this,Ie)}};e.FileSystemError=ui=$=xe([U],ui);let Ui=e.FoldingRange=class{constructor(M,se,Ie){this.start=M,this.end=se,this.kind=Ie}};e.FoldingRange=Ui=xe([U],Ui);var $i;(function(z){z[z.Comment=1]="Comment",z[z.Imports=2]="Imports",z[z.Region=3]="Region"})($i||(e.FoldingRangeKind=$i={}));var ni;(function(z){z[z.Collapsed=0]="Collapsed",z[z.Expanded=1]="Expanded"})(ni||(e.CommentThreadCollapsibleState=ni={}));var zi;(function(z){z[z.Editing=0]="Editing",z[z.Preview=1]="Preview"})(zi||(e.CommentMode=zi={}));var Bi;(function(z){z[z.Published=0]="Published",z[z.Draft=1]="Draft"})(Bi||(e.CommentState=Bi={}));var Wi;(function(z){z[z.Unresolved=0]="Unresolved",z[z.Resolved=1]="Resolved"})(Wi||(e.CommentThreadState=Wi={}));class li{constructor(M,se=[]){this.tokenTypes=M,this.tokenModifiers=se}}e.SemanticTokensLegend=li;function Zi(z){return typeof z>"u"||(0,y.isStringArray)(z)}class Si{constructor(M){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,M){this.l=!0;for(let se=0,Ie=M.tokenTypes.length;se<Ie;se++)this.j.set(M.tokenTypes[se],se);for(let se=0,Ie=M.tokenModifiers.length;se<Ie;se++)this.k.set(M.tokenModifiers[se],se)}}push(M,se,Ie,Ge,Ze){if(typeof M=="number"&&typeof se=="number"&&typeof Ie=="number"&&typeof Ge=="number"&&(typeof Ze=="number"||typeof Ze>"u"))return typeof Ze>"u"&&(Ze=0),this.n(M,se,Ie,Ge,Ze);if(he.isRange(M)&&typeof se=="string"&&Zi(Ie))return this.m(M,se,Ie);throw(0,P.illegalArgument)()}m(M,se,Ie){if(!this.l)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(se))throw new Error("`tokenType` is not in the provided legend");const Ge=M.start.line,Ze=M.start.character,ct=M.end.character-M.start.character,mt=this.j.get(se);let zt=0;if(Ie)for(const qt of Ie){if(!this.k.has(qt))throw new Error("`tokenModifier` is not in the provided legend");const Kt=this.k.get(qt);zt|=1<<Kt>>>0}this.n(Ge,Ze,ct,mt,zt)}n(M,se,Ie,Ge,Ze){if(this.f&&(M<this.c||M===this.c&&se<this.e)){this.f=!1;const zt=this.g.length/5|0;let qt=0,Kt=0;for(let Jt=0;Jt<zt;Jt++){let _t=this.g[5*Jt],Ci=this.g[5*Jt+1];_t===0?(_t=qt,Ci+=Kt):_t+=qt,this.g[5*Jt]=_t,this.g[5*Jt+1]=Ci,qt=_t,Kt=Ci}}let ct=M,mt=se;this.f&&this.h>0&&(ct-=this.c,ct===0&&(mt-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=mt,this.g[this.h++]=Ie,this.g[this.h++]=Ge,this.g[this.h++]=Ze,this.c=M,this.e=se}static o(M){const se=[],Ie=M.length/5|0;for(let mt=0;mt<Ie;mt++)se[mt]=mt;se.sort((mt,zt)=>{const qt=M[5*mt],Kt=M[5*zt];if(qt===Kt){const Jt=M[5*mt+1],_t=M[5*zt+1];return Jt-_t}return qt-Kt});const Ge=new Uint32Array(M.length);let Ze=0,ct=0;for(let mt=0;mt<Ie;mt++){const zt=5*se[mt],qt=M[zt+0],Kt=M[zt+1],Jt=M[zt+2],_t=M[zt+3],Ci=M[zt+4],yn=qt-Ze,$n=yn===0?Kt-ct:Kt,Ti=5*mt;Ge[Ti+0]=yn,Ge[Ti+1]=$n,Ge[Ti+2]=Jt,Ge[Ti+3]=_t,Ge[Ti+4]=Ci,Ze=qt,ct=Kt}return Ge}build(M){return this.f?new yi(new Uint32Array(this.g),M):new yi(Si.o(this.g),M)}}e.SemanticTokensBuilder=Si;class yi{constructor(M,se){this.resultId=se,this.data=M}}e.SemanticTokens=yi;class en{constructor(M,se,Ie){this.start=M,this.deleteCount=se,this.data=Ie}}e.SemanticTokensEdit=en;class tn{constructor(M,se){this.resultId=se,this.edits=M}}e.SemanticTokensEdits=tn;var di;(function(z){z[z.Separate=0]="Separate",z[z.MergeWithParent=1]="MergeWithParent"})(di||(e.DebugConsoleMode=di={}));let hi=e.QuickInputButtons=class{constructor(){}};hi.Back={iconPath:new jt("arrow-left")},e.QuickInputButtons=hi=xe([U],hi);var Di;(function(z){z[z.Separator=-1]="Separator",z[z.Default=0]="Default"})(Di||(e.QuickPickItemKind=Di={}));var $e;(function(z){z[z.Info=1]="Info",z[z.Warning=2]="Warning",z[z.Error=3]="Error"})($e||(e.InputBoxValidationSeverity=$e={}));var Gt;(function(z){z[z.UI=1]="UI",z[z.Workspace=2]="Workspace"})(Gt||(e.ExtensionKind=Gt={}));class Hi{static validate(M){if(typeof M.badge=="string"){let se=(0,A.nextCharLength)(M.badge,0);if(se<M.badge.length&&(se+=(0,A.nextCharLength)(M.badge,se)),M.badge.length>se)throw new Error("The 'badge'-property must be undefined or a short character")}else if(M.badge&&!jt.isThemeIcon(M.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty");return!0}constructor(M,se,Ie){this.badge=M,this.tooltip=se,this.color=Ie}}e.FileDecoration=Hi;let vt=e.ColorTheme=class{constructor(M){this.kind=M}};e.ColorTheme=vt=xe([U],vt);var Vi;(function(z){z[z.Light=1]="Light",z[z.Dark=2]="Dark",z[z.HighContrast=3]="HighContrast",z[z.HighContrastLight=4]="HighContrastLight"})(Vi||(e.ColorThemeKind=Vi={}));class Yt{static isNotebookRange(M){return M instanceof Yt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(M,se){if(M<0)throw(0,P.illegalArgument)("start must be positive");if(se<0)throw(0,P.illegalArgument)("end must be positive");M<=se?(this.c=M,this.e=se):(this.c=se,this.e=M)}with(M){let se=this.c,Ie=this.e;return M.start!==void 0&&(se=M.start),M.end!==void 0&&(Ie=M.end),se===this.c&&Ie===this.e?this:new Yt(se,Ie)}}e.NotebookRange=Yt;class oi{static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(se=>oi.isNotebookCellData(se))}static isNotebookCellData(M){return!0}constructor(M,se,Ie,Ge,Ze,ct,mt){this.kind=M,this.value=se,this.languageId=Ie,this.mime=Ge,this.outputs=Ze??[],this.metadata=ct,this.executionSummary=mt,oi.validate(this)}}e.NotebookCellData=oi;class nn{constructor(M){this.cells=M}}e.NotebookData=nn;class Nt{static isNotebookCellOutputItem(M){return M instanceof Nt?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const se={name:M.name,message:M.message,stack:M.stack};return Nt.json(se,"application/vnd.code.notebook.error")}static stdout(M){return Nt.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Nt.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,se="application/octet-stream"){return new Nt(M,se)}static text(M,se=R.Mimes.text){const Ie=Ne(Nt,T,"f",v).encode(String(M));return new Nt(Ie,se)}static json(M,se="text/x-json"){const Ie=JSON.stringify(M,void 0,"	");return Nt.text(Ie,se)}constructor(M,se){this.data=M,this.mime=se;const Ie=(0,R.normalizeMimeType)(se,!0);if(!Ie)throw new Error(`INVALID mime type: ${se}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ie}}e.NotebookCellOutputItem=Nt,T=Nt,v={value:new TextEncoder};class fi{static isNotebookCellOutput(M){return M instanceof fi?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&Array.isArray(M.items)}static ensureUniqueMimeTypes(M,se=!1){const Ie=new Set,Ge=new Set;for(let Ze=0;Ze<M.length;Ze++){const ct=M[Ze],mt=(0,R.normalizeMimeType)(ct.mime);if(!Ie.has(mt)||(0,S.isTextStreamMime)(mt)){Ie.add(mt);continue}Ge.add(Ze),se&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ge.size===0?M:M.filter((Ze,ct)=>!Ge.has(ct))}constructor(M,se,Ie){this.items=fi.ensureUniqueMimeTypes(M,!0),typeof se=="string"?(this.id=se,this.metadata=Ie):(this.id=(0,O.generateUuid)(),this.metadata=se??Ie)}}e.NotebookCellOutput=fi;var ji;(function(z){z[z.Markup=1]="Markup",z[z.Code=2]="Code"})(ji||(e.NotebookCellKind=ji={}));var qi;(function(z){z[z.Idle=1]="Idle",z[z.Pending=2]="Pending",z[z.Executing=3]="Executing"})(qi||(e.NotebookCellExecutionState=qi={}));var Ii;(function(z){z[z.Left=1]="Left",z[z.Right=2]="Right"})(Ii||(e.NotebookCellStatusBarAlignment=Ii={}));var xi;(function(z){z[z.Default=0]="Default",z[z.InCenter=1]="InCenter",z[z.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",z[z.AtTop=3]="AtTop"})(xi||(e.NotebookEditorRevealType=xi={}));class rn{constructor(M,se){this.text=M,this.alignment=se}}e.NotebookCellStatusBarItem=rn;var Gi;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred"})(Gi||(e.NotebookControllerAffinity=Gi={}));var Ki;(function(z){z[z.Default=1]="Default",z[z.Preferred=2]="Preferred",z[z.Hidden=-1]="Hidden"})(Ki||(e.NotebookControllerAffinity2=Ki={}));class sn{constructor(M,se=[]){this.uri=M,this.provides=(0,n.asArray)(se)}}e.NotebookRendererScript=sn;class on{constructor(M){this.label=M}}e.NotebookKernelSourceAction=on;let Xi=e.TimelineItem=class{constructor(M,se){this.label=M,this.timestamp=se}};e.TimelineItem=Xi=xe([U],Xi);var Qi;(function(z){z[z.Production=1]="Production",z[z.Development=2]="Development",z[z.Test=3]="Test"})(Qi||(e.ExtensionMode=Qi={}));var re;(function(z){z[z.Node=1]="Node",z[z.Webworker=2]="Webworker"})(re||(e.ExtensionRuntime=re={}));var fe;(function(z){z[z.Other=0]="Other",z[z.Comment=1]="Comment",z[z.String=2]="String",z[z.RegEx=3]="RegEx"})(fe||(e.StandardTokenType=fe={}));class Le{constructor(M,se){this.ranges=M,this.wordPattern=se}}e.LinkedEditingRanges=Le;class ot{constructor(M,se){this.c=M,this.e=se}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=ot;var St;(function(z){z[z.Queued=1]="Queued",z[z.Running=2]="Running",z[z.Passed=3]="Passed",z[z.Failed=4]="Failed",z[z.Skipped=5]="Skipped",z[z.Errored=6]="Errored"})(St||(e.TestResultState=St={}));var Rt;(function(z){z[z.Run=1]="Run",z[z.Debug=2]="Debug",z[z.Coverage=3]="Coverage"})(Rt||(e.TestRunProfileKind=Rt={}));let an=e.TestRunRequest=class{constructor(M=void 0,se=void 0,Ie=void 0,Ge=!1){this.include=M,this.exclude=se,this.profile=Ie,this.continuous=Ge}};e.TestRunRequest=an=xe([U],an);let un=e.TestRunRequest2=class extends an{};e.TestRunRequest2=un=xe([U],un);let ln=e.TestMessage=B=class{static diff(M,se,Ie){const Ge=new B(M);return Ge.expectedOutput=se,Ge.actualOutput=Ie,Ge}constructor(M){this.message=M}};e.TestMessage=ln=B=xe([U],ln);let dn=e.TestTag=class{constructor(M){this.id=M}};e.TestTag=dn=xe([U],dn);let ki=e.CoveredCount=class{constructor(M,se){this.covered=M,this.total=se}};e.CoveredCount=ki=xe([U],ki);let hn=e.FileCoverage=X=class{static fromDetails(M,se){const Ie=new ki(0,0),Ge=new ki(0,0),Ze=new ki(0,0);for(const mt of se)if("branches"in mt){Ie.total+=1,Ie.covered+=mt.executionCount>0?1:0;for(const zt of mt.branches)Ge.total+=1,Ge.covered+=zt.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=mt.executionCount>0?1:0;const ct=new X(M,Ie,Ge.total>0?Ge:void 0,Ze.total>0?Ze:void 0);return ct.detailedCoverage=se,ct}constructor(M,se,Ie,Ge){this.uri=M,this.statementCoverage=se,this.branchCoverage=Ie,this.functionCoverage=Ge}};e.FileCoverage=hn=X=xe([U],hn);let fn=e.StatementCoverage=class{constructor(M,se,Ie=[]){this.executionCount=M,this.location=se,this.branches=Ie}};e.StatementCoverage=fn=xe([U],fn);let mn=e.BranchCoverage=class{constructor(M,se){this.executionCount=M,this.location=se}};e.BranchCoverage=mn=xe([U],mn);let gn=e.FunctionCoverage=class{constructor(M,se){this.executionCount=M,this.location=se}};e.FunctionCoverage=gn=xe([U],gn);var pn;(function(z){z[z.None=0]="None",z[z.Option=1]="Option",z[z.Default=2]="Default",z[z.Preferred=3]="Preferred"})(pn||(e.ExternalUriOpenerPriority=pn={}));var vn;(function(z){z[z.Untrusted=0]="Untrusted",z[z.Trusted=1]="Trusted",z[z.Unspecified=2]="Unspecified"})(vn||(e.WorkspaceTrustState=vn={}));var bn;(function(z){z[z.Notify=1]="Notify",z[z.OpenBrowser=2]="OpenBrowser",z[z.OpenPreview=3]="OpenPreview",z[z.Silent=4]="Silent",z[z.Ignore=5]="Ignore",z[z.OpenBrowserOnce=6]="OpenBrowserOnce"})(bn||(e.PortAutoForwardAction=bn={}));class Tn{constructor(M,se,Ie,Ge,Ze,ct){this.kind=M,this.name=se,this.detail=Ie,this.uri=Ge,this.range=Ze,this.selectionRange=ct}}e.TypeHierarchyItem=Tn;class Pn{constructor(M){this.uri=M}}e.TextTabInput=Pn;class An{constructor(M,se){this.original=M,this.modified=se}}e.TextDiffTabInput=An;class Rn{constructor(M,se,Ie,Ge){this.base=M,this.input1=se,this.input2=Ie,this.result=Ge}}e.TextMergeTabInput=Rn;class On{constructor(M,se){this.uri=M,this.viewType=se}}e.CustomEditorTabInput=On;class Fn{constructor(M){this.viewType=M}}e.WebviewEditorTabInput=Fn;class Ln{constructor(M,se){this.uri=M,this.notebookType=se}}e.NotebookEditorTabInput=Ln;class Nn{constructor(M,se,Ie){this.original=M,this.modified=se,this.notebookType=Ie}}e.NotebookDiffEditorTabInput=Nn;class Mn{constructor(){}}e.TerminalEditorTabInput=Mn;class Un{constructor(M,se){this.uri=M,this.inputBoxUri=se}}e.InteractiveWindowInput=Un;var En;(function(z){z[z.Up=1]="Up",z[z.Down=2]="Down"})(En||(e.InteractiveSessionVoteDirection=En={}));var wn;(function(z){z[z.Action=1]="Action",z[z.Toolbar=2]="Toolbar"})(wn||(e.InteractiveSessionCopyKind=wn={}));var Sn;(function(z){z[z.Unhelpful=0]="Unhelpful",z[z.Helpful=1]="Helpful",z[z.Undone=2]="Undone"})(Sn||(e.InteractiveEditorResponseFeedbackKind=Sn={}))}),define(Pe[102],Ae([1,0,49,15,13,269,135,7,16]),function(te,e,n,P,I,L,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const h=new Map;function O(p,l){l?h.set(p,l):h.delete(p)}e.setWordDefinitionFor=O;function w(p){return h.get(p)}class g extends L.MirrorTextModel{constructor(l,t,o,d,D,T,v,i){super(t,o,d,D),this.c=l,this.m=T,this.q=v,this.notebook=i,this.b=!1}dispose(){(0,n.ok)(!this.b),this.b=!0,this.q=!1}equalLines(l){return(0,y.equals)(this.f,l)}get document(){if(!this.a){const l=this;this.a={get uri(){return l.d},get fileName(){return l.d.fsPath},get isUntitled(){return l.d.scheme===P.Schemas.untitled},get languageId(){return l.m},get version(){return l.h},get isClosed(){return l.b},get isDirty(){return l.q},save(){return l.r()},getText(t){return t?l.s(t):l.getText()},get eol(){return l.g===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return l.f.length},lineAt(t){return l.t(t)},offsetAt(t){return l.u(t)},positionAt(t){return l.v(t)},validateRange(t){return l.w(t)},validatePosition(t){return l.x(t)},getWordRangeAtPosition(t,o){return l.y(t,o)}}}return Object.freeze(this.a)}_acceptLanguageId(l){(0,n.ok)(!this.b),this.m=l}_acceptIsDirty(l){(0,n.ok)(!this.b),this.q=l}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(l){const t=this.w(l);if(t.isEmpty)return"";if(t.isSingleLine)return this.f[t.start.line].substring(t.start.character,t.end.character);const o=this.g,d=t.start.line,D=t.end.line,T=[];T.push(this.f[d].substring(t.start.character));for(let v=d+1;v<D;v++)T.push(this.f[v]);return T.push(this.f[D].substring(0,t.end.character)),T.join(o)}t(l){let t;if(l instanceof A.Position?t=l.line:typeof l=="number"&&(t=l),typeof t!="number"||t<0||t>=this.f.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new S(t,this.f[t],t===this.f.length-1)}u(l){return l=this.x(l),this.l(),this.j.getPrefixSum(l.line-1)+l.character}v(l){l=Math.floor(l),l=Math.max(0,l),this.l();const t=this.j.getIndexOf(l),o=this.f[t.index].length;return new A.Position(t.index,Math.min(t.remainder,o))}w(l){if(!(l instanceof A.Range))throw new Error("Invalid argument");const t=this.x(l.start),o=this.x(l.end);return t===l.start&&o===l.end?l:new A.Range(t.line,t.character,o.line,o.character)}x(l){if(!(l instanceof A.Position))throw new Error("Invalid argument");if(this.f.length===0)return l.with(0,0);let{line:t,character:o}=l,d=!1;if(t<0)t=0,o=0,d=!0;else if(t>=this.f.length)t=this.f.length-1,o=this.f[t].length,d=!0;else{const D=this.f[t].length;o<0?(o=0,d=!0):o>D&&(o=D,d=!0)}return d?new A.Position(t,o):l}y(l,t){const o=this.x(l);if(!t)t=w(this.m);else if((0,I.regExpLeadsToEndlessLoop)(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`);const d=(0,R.getWordAtText)(o.character+1,(0,R.ensureValidWordDefinition)(t),this.f[o.line],0);if(d)return new A.Range(o.line,d.startColumn-1,o.line,d.endColumn-1)}}e.ExtHostDocumentData=g;class S{constructor(l,t,o){this.a=l,this.b=t,this.c=o}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=S}),define(Pe[201],Ae([1,0,7,18,5]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=e.ExtHostTheming=class{constructor(A){this.a=new n.ColorTheme(n.ColorThemeKind.Dark),this.b=new I.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let y;switch(A){case"light":y=n.ColorThemeKind.Light;break;case"hcDark":y=n.ColorThemeKind.HighContrast;break;case"hcLight":y=n.ColorThemeKind.HighContrastLight;break;default:y=n.ColorThemeKind.Dark}this.a=new n.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.ExtHostTheming=L=xe([qe(0,P.IExtHostRpcService)],L)}),define(Pe[8],Ae([1,0,16,25,119,202,88,28,115,67,66,23,12,2,44,77,93,99,98,73,45,56,198,7]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t,o,d,D,T,v,i,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveSessionFollowup=e.InteractiveSessionReplyFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Te){function Oe(K){const{selectionStartLineNumber:Fe,selectionStartColumn:Be,positionLineNumber:Xe,positionColumn:He}=K,tt=new a.Position(Fe-1,Be-1),bt=new a.Position(Xe-1,He-1);return new a.Selection(tt,bt)}Te.to=Oe;function ve(K){const{anchor:Fe,active:Be}=K;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:Be.line+1,positionColumn:Be.character+1}}Te.from=ve})(r||(e.Selection=r={}));var s;(function(Te){function Oe(K){if(!K)return;const{start:Fe,end:Be}=K;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:Be.line+1,endColumn:Be.character+1}}Te.from=Oe;function ve(K){if(!K)return;const{startLineNumber:Fe,startColumn:Be,endLineNumber:Xe,endColumn:He}=K;return new a.Range(Fe-1,Be-1,Xe-1,He-1)}Te.to=ve})(s||(e.Range=s={}));var E;(function(Te){function Oe(ve){switch(ve){case 1:return a.StandardTokenType.Comment;case 0:return a.StandardTokenType.Other;case 3:return a.StandardTokenType.RegEx;case 2:return a.StandardTokenType.String}}Te.to=Oe})(E||(e.TokenType=E={}));var k;(function(Te){function Oe(K){return new a.Position(K.lineNumber-1,K.column-1)}Te.to=Oe;function ve(K){return{lineNumber:K.line+1,column:K.character+1}}Te.from=ve})(k||(e.Position=k={}));var c;(function(Te){function Oe(Fe,Be,Xe){return(0,n.coalesce)((0,n.asArray)(Fe).map(He=>ve(He,Be,Xe)))}Te.from=Oe;function ve(Fe,Be,Xe){if(typeof Fe=="string")return{$serialized:!0,language:Fe,isBuiltin:Xe?.isBuiltin};if(Fe)return{$serialized:!0,language:Fe.language,scheme:K(Fe.scheme,Be),pattern:J.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType,isBuiltin:Xe?.isBuiltin}}function K(Fe,Be){return Be&&typeof Fe=="string"?Be.transformOutgoingScheme(Fe):Fe}})(c||(e.DocumentSelector=c={}));var u;(function(Te){function Oe(K){switch(K){case a.DiagnosticTag.Unnecessary:return 1;case a.DiagnosticTag.Deprecated:return 2}}Te.from=Oe;function ve(K){switch(K){case 1:return a.DiagnosticTag.Unnecessary;case 2:return a.DiagnosticTag.Deprecated;default:return}}Te.to=ve})(u||(e.DiagnosticTag=u={}));var m;(function(Te){function Oe(K){let Fe;return K.code&&((0,g.isString)(K.code)||(0,g.isNumber)(K.code)?Fe=String(K.code):Fe={value:String(K.code.value),target:K.code.target}),{...s.from(K.range),message:K.message,source:K.source,code:Fe,severity:f.from(K.severity),relatedInformation:K.relatedInformation&&K.relatedInformation.map(b.from),tags:Array.isArray(K.tags)?(0,n.coalesce)(K.tags.map(u.from)):void 0}}Te.from=Oe;function ve(K){const Fe=new a.Diagnostic(s.to(K),K.message,f.to(K.severity));return Fe.source=K.source,Fe.code=(0,g.isString)(K.code)?K.code:K.code?.value,Fe.relatedInformation=K.relatedInformation&&K.relatedInformation.map(b.to),Fe.tags=K.tags&&(0,n.coalesce)(K.tags.map(u.to)),Fe}Te.to=ve})(m||(e.Diagnostic=m={}));var b;(function(Te){function Oe(K){return{...s.from(K.location.range),message:K.message,resource:K.location.uri}}Te.from=Oe;function ve(K){return new a.DiagnosticRelatedInformation(new a.Location(K.resource,s.to(K)),K.message)}Te.to=ve})(b||(e.DiagnosticRelatedInformation=b={}));var f;(function(Te){function Oe(K){switch(K){case a.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case a.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case a.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case a.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}Te.from=Oe;function ve(K){switch(K){case t.MarkerSeverity.Info:return a.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return a.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return a.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return a.DiagnosticSeverity.Hint;default:return a.DiagnosticSeverity.Error}}Te.to=ve})(f||(e.DiagnosticSeverity=f={}));var N;(function(Te){function Oe(K){return typeof K=="number"&&K>=a.ViewColumn.One?K-1:K===a.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Te.from=Oe;function ve(K){if(typeof K=="number"&&K>=0)return K+1;throw new Error("invalid 'EditorGroupColumn'")}Te.to=ve})(N||(e.ViewColumn=N={}));function V(Te){return typeof Te.range<"u"}function _(Te){return Te.length===0?!0:!!V(Te[0])}e.isDecorationOptionsArr=_;var G;(function(Te){function Oe(He){return He.map(Te.from)}Te.fromMany=Oe;function ve(He){return He&&typeof He=="object"&&typeof He.language=="string"&&typeof He.value=="string"}function K(He){let tt;if(ve(He)){const{language:nt,value:lt}=He;tt={value:"```"+nt+`
`+lt+"\n```\n"}}else a.MarkdownString.isMarkdownString(He)?tt={value:He.value,isTrusted:He.isTrusted,supportThemeIcons:He.supportThemeIcons,supportHtml:He.supportHtml,baseUri:He.baseUri}:typeof He=="string"?tt={value:He}:tt={value:""};const bt=Object.create(null);tt.uris=bt;const pt=nt=>{try{let lt=S.URI.parse(nt,!0);lt=lt.with({query:Fe(lt.query,bt)}),bt[nt]=lt}catch{}return""},dt=new y.marked.Renderer;return dt.link=pt,dt.image=nt=>typeof nt=="string"?pt(R.parseHrefAndDimensions(nt).href):"",(0,y.marked)(tt.value,{renderer:dt}),tt}Te.from=K;function Fe(He,tt){if(!He)return He;let bt;try{bt=(0,h.parse)(He)}catch{}if(!bt)return He;let pt=!1;return bt=(0,w.cloneAndChange)(bt,dt=>{if(S.URI.isUri(dt)){const nt=`__uri_${Math.random().toString(16).slice(2,8)}`;return tt[nt]=dt,pt=!0,nt}else return}),pt?JSON.stringify(bt):He}function Be(He){const tt=new a.MarkdownString(He.value,He.supportThemeIcons);return tt.isTrusted=He.isTrusted,tt.supportHtml=He.supportHtml,tt.baseUri=He.baseUri?S.URI.from(He.baseUri):void 0,tt}Te.to=Be;function Xe(He){if(He)return typeof He=="string"?He:Te.from(He)}Te.fromStrict=Xe})(G||(e.MarkdownString=G={}));function $(Te){return _(Te)?Te.map(Oe=>({range:s.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?G.fromMany(Oe.hoverMessage):Oe.hoverMessage?G.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Te.map(Oe=>({range:s.from(Oe)}))}e.fromRangeOrRangeWithMessage=$;function B(Te){return typeof Te>"u"?Te:typeof Te=="string"?S.URI.file(Te):Te}e.pathOrURIToURI=B;var X;(function(Te){function Oe(ve){return typeof ve>"u"?ve:{contentText:ve.contentText,contentIconPath:ve.contentIconPath?B(ve.contentIconPath):void 0,border:ve.border,borderColor:ve.borderColor,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,color:ve.color,backgroundColor:ve.backgroundColor,margin:ve.margin,width:ve.width,height:ve.height}}Te.from=Oe})(X||(e.ThemableDecorationAttachmentRenderOptions=X={}));var U;(function(Te){function Oe(ve){return typeof ve>"u"?ve:{backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?B(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?X.from(ve.before):void 0,after:ve.after?X.from(ve.after):void 0}}Te.from=Oe})(U||(e.ThemableDecorationRenderOptions=U={}));var j;(function(Te){function Oe(ve){if(typeof ve>"u")return ve;switch(ve){case a.DecorationRangeBehavior.OpenOpen:return 0;case a.DecorationRangeBehavior.ClosedClosed:return 1;case a.DecorationRangeBehavior.OpenClosed:return 2;case a.DecorationRangeBehavior.ClosedOpen:return 3}}Te.from=Oe})(j||(e.DecorationRangeBehavior=j={}));var Y;(function(Te){function Oe(ve){return{isWholeLine:ve.isWholeLine,rangeBehavior:ve.rangeBehavior?j.from(ve.rangeBehavior):void 0,overviewRulerLane:ve.overviewRulerLane,light:ve.light?U.from(ve.light):void 0,dark:ve.dark?U.from(ve.dark):void 0,backgroundColor:ve.backgroundColor,outline:ve.outline,outlineColor:ve.outlineColor,outlineStyle:ve.outlineStyle,outlineWidth:ve.outlineWidth,border:ve.border,borderColor:ve.borderColor,borderRadius:ve.borderRadius,borderSpacing:ve.borderSpacing,borderStyle:ve.borderStyle,borderWidth:ve.borderWidth,fontStyle:ve.fontStyle,fontWeight:ve.fontWeight,textDecoration:ve.textDecoration,cursor:ve.cursor,color:ve.color,opacity:ve.opacity,letterSpacing:ve.letterSpacing,gutterIconPath:ve.gutterIconPath?B(ve.gutterIconPath):void 0,gutterIconSize:ve.gutterIconSize,overviewRulerColor:ve.overviewRulerColor,before:ve.before?X.from(ve.before):void 0,after:ve.after?X.from(ve.after):void 0}}Te.from=Oe})(Y||(e.DecorationRenderOptions=Y={}));var pe;(function(Te){function Oe(K){return{text:K.newText,eol:K.newEol&&rt.from(K.newEol),range:s.from(K.range)}}Te.from=Oe;function ve(K){const Fe=new a.TextEdit(s.to(K.range),K.text);return Fe.newEol=typeof K.eol>"u"?void 0:rt.to(K.eol),Fe}Te.to=ve})(pe||(e.TextEdit=pe={}));var Ee;(function(Te){function Oe(K,Fe){const Be={edits:[]};if(K instanceof a.WorkspaceEdit){const Xe=new A.ResourceSet;for(const He of K._allEntries())He._type===1&&S.URI.isUri(He.to)&&He.from===void 0&&Xe.add(He.to);for(const He of K._allEntries())if(He._type===1){let tt;He.options?.contents&&(ArrayBuffer.isView(He.options.contents)?tt={type:"base64",value:(0,P.encodeBase64)(P.VSBuffer.wrap(He.options.contents))}:tt={type:"dataTransferItem",id:He.options.contents._itemId}),Be.edits.push({oldResource:He.from,newResource:He.to,options:{...He.options,contents:tt},metadata:He.metadata})}else He._type===2?Be.edits.push({resource:He.uri,textEdit:pe.from(He.edit),versionId:Xe.has(He.uri)?void 0:Fe?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===6?Be.edits.push({resource:He.uri,textEdit:{range:s.from(He.range),text:He.edit.value,insertAsSnippet:!0},versionId:Xe.has(He.uri)?void 0:Fe?.getTextDocumentVersion(He.uri),metadata:He.metadata}):He._type===3?Be.edits.push({metadata:He.metadata,resource:He.uri,cellEdit:He.edit,notebookMetadata:He.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(He.uri)}):He._type===5&&Be.edits.push({metadata:He.metadata,resource:He.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(He.uri),cellEdit:{editType:1,index:He.index,count:He.count,cells:He.cells.map(Et.from)}})}return Be}Te.from=Oe;function ve(K){const Fe=new a.WorkspaceEdit,Be=new A.ResourceMap;for(const Xe of K.edits)if(Xe.textEdit){const He=Xe,tt=S.URI.revive(He.resource),bt=s.to(He.textEdit.range),pt=He.textEdit.text,dt=He.textEdit.insertAsSnippet;let nt;dt?nt=a.SnippetTextEdit.replace(bt,new a.SnippetString(pt)):nt=a.TextEdit.replace(bt,pt);const lt=Be.get(tt);lt?lt.push(nt):Be.set(tt,[nt])}else Fe.renameFile(S.URI.revive(Xe.oldResource),S.URI.revive(Xe.newResource),Xe.options);for(const[Xe,He]of Be)Fe.set(Xe,He);return Fe}Te.to=ve})(Ee||(e.WorkspaceEdit=Ee={}));var he;(function(Te){const Oe=Object.create(null);Oe[a.SymbolKind.File]=0,Oe[a.SymbolKind.Module]=1,Oe[a.SymbolKind.Namespace]=2,Oe[a.SymbolKind.Package]=3,Oe[a.SymbolKind.Class]=4,Oe[a.SymbolKind.Method]=5,Oe[a.SymbolKind.Property]=6,Oe[a.SymbolKind.Field]=7,Oe[a.SymbolKind.Constructor]=8,Oe[a.SymbolKind.Enum]=9,Oe[a.SymbolKind.Interface]=10,Oe[a.SymbolKind.Function]=11,Oe[a.SymbolKind.Variable]=12,Oe[a.SymbolKind.Constant]=13,Oe[a.SymbolKind.String]=14,Oe[a.SymbolKind.Number]=15,Oe[a.SymbolKind.Boolean]=16,Oe[a.SymbolKind.Array]=17,Oe[a.SymbolKind.Object]=18,Oe[a.SymbolKind.Key]=19,Oe[a.SymbolKind.Null]=20,Oe[a.SymbolKind.EnumMember]=21,Oe[a.SymbolKind.Struct]=22,Oe[a.SymbolKind.Event]=23,Oe[a.SymbolKind.Operator]=24,Oe[a.SymbolKind.TypeParameter]=25;function ve(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Te.from=ve;function K(Fe){for(const Be in Oe)if(Oe[Be]===Fe)return Number(Be);return a.SymbolKind.Property}Te.to=K})(he||(e.SymbolKind=he={}));var de;(function(Te){function Oe(K){switch(K){case a.SymbolTag.Deprecated:return 1}}Te.from=Oe;function ve(K){switch(K){case 1:return a.SymbolTag.Deprecated}}Te.to=ve})(de||(e.SymbolTag=de={}));var Re;(function(Te){function Oe(K){return{name:K.name,kind:he.from(K.kind),tags:K.tags&&K.tags.map(de.from),containerName:K.containerName,location:Q.from(K.location)}}Te.from=Oe;function ve(K){const Fe=new a.SymbolInformation(K.name,he.to(K.kind),K.containerName,Q.to(K.location));return Fe.tags=K.tags&&K.tags.map(de.to),Fe}Te.to=ve})(Re||(e.WorkspaceSymbol=Re={}));var le;(function(Te){function Oe(K){const Fe={name:K.name||"!!MISSING: name!!",detail:K.detail,range:s.from(K.range),selectionRange:s.from(K.selectionRange),kind:he.from(K.kind),tags:K.tags?.map(de.from)??[]};return K.children&&(Fe.children=K.children.map(Oe)),Fe}Te.from=Oe;function ve(K){const Fe=new a.DocumentSymbol(K.name,K.detail,he.to(K.kind),s.to(K.range),s.to(K.selectionRange));return(0,n.isNonEmptyArray)(K.tags)&&(Fe.tags=K.tags.map(de.to)),K.children&&(Fe.children=K.children.map(ve)),Fe}Te.to=ve})(le||(e.DocumentSymbol=le={}));var ue;(function(Te){function Oe(K){const Fe=new a.CallHierarchyItem(he.to(K.kind),K.name,K.detail||"",S.URI.revive(K.uri),s.to(K.range),s.to(K.selectionRange));return Fe._sessionId=K._sessionId,Fe._itemId=K._itemId,Fe}Te.to=Oe;function ve(K,Fe,Be){if(Fe=Fe??K._sessionId,Be=Be??K._itemId,Fe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Be,name:K.name,detail:K.detail,kind:he.from(K.kind),uri:K.uri,range:s.from(K.range),selectionRange:s.from(K.selectionRange),tags:K.tags?.map(de.from)}}Te.from=ve})(ue||(e.CallHierarchyItem=ue={}));var H;(function(Te){function Oe(ve){return new a.CallHierarchyIncomingCall(ue.to(ve.from),ve.fromRanges.map(K=>s.to(K)))}Te.to=Oe})(H||(e.CallHierarchyIncomingCall=H={}));var F;(function(Te){function Oe(ve){return new a.CallHierarchyOutgoingCall(ue.to(ve.to),ve.fromRanges.map(K=>s.to(K)))}Te.to=Oe})(F||(e.CallHierarchyOutgoingCall=F={}));var Q;(function(Te){function Oe(K){return{range:K.range&&s.from(K.range),uri:K.uri}}Te.from=Oe;function ve(K){return new a.Location(S.URI.revive(K.uri),s.to(K.range))}Te.to=ve})(Q||(e.location=Q={}));var me;(function(Te){function Oe(K){const Fe=K,Be=K;return{originSelectionRange:Fe.originSelectionRange?s.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:Be.uri,range:s.from(Fe.targetRange?Fe.targetRange:Be.range),targetSelectionRange:Fe.targetSelectionRange?s.from(Fe.targetSelectionRange):void 0}}Te.from=Oe;function ve(K){return{targetUri:S.URI.revive(K.uri),targetRange:s.to(K.range),targetSelectionRange:K.targetSelectionRange?s.to(K.targetSelectionRange):void 0,originSelectionRange:K.originSelectionRange?s.to(K.originSelectionRange):void 0}}Te.to=ve})(me||(e.DefinitionLink=me={}));var Ce;(function(Te){function Oe(K){return{range:s.from(K.range),contents:G.fromMany(K.contents)}}Te.from=Oe;function ve(K){return new a.Hover(K.contents.map(G.to),s.to(K.range))}Te.to=ve})(Ce||(e.Hover=Ce={}));var De;(function(Te){function Oe(K){return{range:s.from(K.range),expression:K.expression}}Te.from=Oe;function ve(K){return new a.EvaluatableExpression(s.to(K.range),K.expression)}Te.to=ve})(De||(e.EvaluatableExpression=De={}));var be;(function(Te){function Oe(K){if(K instanceof a.InlineValueText)return{type:"text",range:s.from(K.range),text:K.text};if(K instanceof a.InlineValueVariableLookup)return{type:"variable",range:s.from(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};if(K instanceof a.InlineValueEvaluatableExpression)return{type:"expression",range:s.from(K.range),expression:K.expression};throw new Error("Unknown 'InlineValue' type")}Te.from=Oe;function ve(K){switch(K.type){case"text":return{range:s.to(K.range),text:K.text};case"variable":return{range:s.to(K.range),variableName:K.variableName,caseSensitiveLookup:K.caseSensitiveLookup};case"expression":return{range:s.to(K.range),expression:K.expression}}}Te.to=ve})(be||(e.InlineValue=be={}));var ke;(function(Te){function Oe(K){return{frameId:K.frameId,stoppedLocation:s.from(K.stoppedLocation)}}Te.from=Oe;function ve(K){return new a.InlineValueContext(K.frameId,s.to(K.stoppedLocation))}Te.to=ve})(ke||(e.InlineValueContext=ke={}));var oe;(function(Te){function Oe(K){return{range:s.from(K.range),kind:K.kind}}Te.from=Oe;function ve(K){return new a.DocumentHighlight(s.to(K.range),K.kind)}Te.to=ve})(oe||(e.DocumentHighlight=oe={}));var ce;(function(Te){function Oe(ve){switch(ve){case 1:return a.CompletionTriggerKind.TriggerCharacter;case 2:return a.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return a.CompletionTriggerKind.Invoke}}Te.to=Oe})(ce||(e.CompletionTriggerKind=ce={}));var ie;(function(Te){function Oe(ve){return{triggerKind:ce.to(ve.triggerKind),triggerCharacter:ve.triggerCharacter}}Te.to=Oe})(ie||(e.CompletionContext=ie={}));var ne;(function(Te){function Oe(K){switch(K){case a.CompletionItemTag.Deprecated:return 1}}Te.from=Oe;function ve(K){switch(K){case 1:return a.CompletionItemTag.Deprecated}}Te.to=ve})(ne||(e.CompletionItemTag=ne={}));var C;(function(Te){const Oe=new Map([[a.CompletionItemKind.Method,0],[a.CompletionItemKind.Function,1],[a.CompletionItemKind.Constructor,2],[a.CompletionItemKind.Field,3],[a.CompletionItemKind.Variable,4],[a.CompletionItemKind.Class,5],[a.CompletionItemKind.Interface,7],[a.CompletionItemKind.Struct,6],[a.CompletionItemKind.Module,8],[a.CompletionItemKind.Property,9],[a.CompletionItemKind.Unit,12],[a.CompletionItemKind.Value,13],[a.CompletionItemKind.Constant,14],[a.CompletionItemKind.Enum,15],[a.CompletionItemKind.EnumMember,16],[a.CompletionItemKind.Keyword,17],[a.CompletionItemKind.Snippet,27],[a.CompletionItemKind.Text,18],[a.CompletionItemKind.Color,19],[a.CompletionItemKind.File,20],[a.CompletionItemKind.Reference,21],[a.CompletionItemKind.Folder,23],[a.CompletionItemKind.Event,10],[a.CompletionItemKind.Operator,11],[a.CompletionItemKind.TypeParameter,24],[a.CompletionItemKind.Issue,26],[a.CompletionItemKind.User,25]]);function ve(Be){return Oe.get(Be)??9}Te.from=ve;const K=new Map([[0,a.CompletionItemKind.Method],[1,a.CompletionItemKind.Function],[2,a.CompletionItemKind.Constructor],[3,a.CompletionItemKind.Field],[4,a.CompletionItemKind.Variable],[5,a.CompletionItemKind.Class],[7,a.CompletionItemKind.Interface],[6,a.CompletionItemKind.Struct],[8,a.CompletionItemKind.Module],[9,a.CompletionItemKind.Property],[12,a.CompletionItemKind.Unit],[13,a.CompletionItemKind.Value],[14,a.CompletionItemKind.Constant],[15,a.CompletionItemKind.Enum],[16,a.CompletionItemKind.EnumMember],[17,a.CompletionItemKind.Keyword],[27,a.CompletionItemKind.Snippet],[18,a.CompletionItemKind.Text],[19,a.CompletionItemKind.Color],[20,a.CompletionItemKind.File],[21,a.CompletionItemKind.Reference],[23,a.CompletionItemKind.Folder],[10,a.CompletionItemKind.Event],[11,a.CompletionItemKind.Operator],[24,a.CompletionItemKind.TypeParameter],[25,a.CompletionItemKind.User],[26,a.CompletionItemKind.Issue]]);function Fe(Be){return K.get(Be)??a.CompletionItemKind.Property}Te.to=Fe})(C||(e.CompletionItemKind=C={}));var W;(function(Te){function Oe(ve,K){const Fe=new a.CompletionItem(ve.label);return Fe.insertText=ve.insertText,Fe.kind=C.to(ve.kind),Fe.tags=ve.tags?.map(ne.to),Fe.detail=ve.detail,Fe.documentation=R.isMarkdownString(ve.documentation)?G.to(ve.documentation):ve.documentation,Fe.sortText=ve.sortText,Fe.filterText=ve.filterText,Fe.preselect=ve.preselect,Fe.commitCharacters=ve.commitCharacters,p.Range.isIRange(ve.range)?Fe.range=s.to(ve.range):typeof ve.range=="object"&&(Fe.range={inserting:s.to(ve.range.insert),replacing:s.to(ve.range.replace)}),Fe.keepWhitespace=typeof ve.insertTextRules>"u"?!1:!!(ve.insertTextRules&1),typeof ve.insertTextRules<"u"&&ve.insertTextRules&4?Fe.insertText=new a.SnippetString(ve.insertText):(Fe.insertText=ve.insertText,Fe.textEdit=Fe.range instanceof a.Range?new a.TextEdit(Fe.range,Fe.insertText):void 0),ve.additionalTextEdits&&ve.additionalTextEdits.length>0&&(Fe.additionalTextEdits=ve.additionalTextEdits.map(Be=>pe.to(Be))),Fe.command=K&&ve.command?K.fromInternal(ve.command):void 0,Fe}Te.to=Oe})(W||(e.CompletionItem=W={}));var q;(function(Te){function Oe(K){if(typeof K.label!="string"&&!Array.isArray(K.label))throw new TypeError("Invalid label");return{label:K.label,documentation:G.fromStrict(K.documentation)}}Te.from=Oe;function ve(K){return{label:K.label,documentation:R.isMarkdownString(K.documentation)?G.to(K.documentation):K.documentation}}Te.to=ve})(q||(e.ParameterInformation=q={}));var x;(function(Te){function Oe(K){return{label:K.label,documentation:G.fromStrict(K.documentation),parameters:Array.isArray(K.parameters)?K.parameters.map(q.from):[],activeParameter:K.activeParameter}}Te.from=Oe;function ve(K){return{label:K.label,documentation:R.isMarkdownString(K.documentation)?G.to(K.documentation):K.documentation,parameters:Array.isArray(K.parameters)?K.parameters.map(q.to):[],activeParameter:K.activeParameter}}Te.to=ve})(x||(e.SignatureInformation=x={}));var ae;(function(Te){function Oe(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(x.from):[]}}Te.from=Oe;function ve(K){return{activeSignature:K.activeSignature,activeParameter:K.activeParameter,signatures:Array.isArray(K.signatures)?K.signatures.map(x.to):[]}}Te.to=ve})(ae||(e.SignatureHelp=ae={}));var ge;(function(Te){function Oe(ve,K){const Fe=new a.InlayHint(k.to(K.position),typeof K.label=="string"?K.label:K.label.map(ee.to.bind(void 0,ve)),K.kind&&we.to(K.kind));return Fe.textEdits=K.textEdits&&K.textEdits.map(pe.to),Fe.tooltip=R.isMarkdownString(K.tooltip)?G.to(K.tooltip):K.tooltip,Fe.paddingLeft=K.paddingLeft,Fe.paddingRight=K.paddingRight,Fe}Te.to=Oe})(ge||(e.InlayHint=ge={}));var ee;(function(Te){function Oe(ve,K){const Fe=new a.InlayHintLabelPart(K.label);return Fe.tooltip=R.isMarkdownString(K.tooltip)?G.to(K.tooltip):K.tooltip,l.Command.is(K.command)&&(Fe.command=ve.fromInternal(K.command)),K.location&&(Fe.location=Q.to(K.location)),Fe}Te.to=Oe})(ee||(e.InlayHintLabelPart=ee={}));var we;(function(Te){function Oe(K){return K}Te.from=Oe;function ve(K){return K}Te.to=ve})(we||(e.InlayHintKind=we={}));var ye;(function(Te){function Oe(K){return{range:s.from(K.range),url:K.target,tooltip:K.tooltip}}Te.from=Oe;function ve(K){let Fe;if(K.url)try{Fe=typeof K.url=="string"?S.URI.parse(K.url,!0):S.URI.revive(K.url)}catch{}return new a.DocumentLink(s.to(K.range),Fe)}Te.to=ve})(ye||(e.DocumentLink=ye={}));var ze;(function(Te){function Oe(K){const Fe=new a.ColorPresentation(K.label);return K.textEdit&&(Fe.textEdit=pe.to(K.textEdit)),K.additionalTextEdits&&(Fe.additionalTextEdits=K.additionalTextEdits.map(Be=>pe.to(Be))),Fe}Te.to=Oe;function ve(K){return{label:K.label,textEdit:K.textEdit?pe.from(K.textEdit):void 0,additionalTextEdits:K.additionalTextEdits?K.additionalTextEdits.map(Fe=>pe.from(Fe)):void 0}}Te.from=ve})(ze||(e.ColorPresentation=ze={}));var je;(function(Te){function Oe(K){return new a.Color(K[0],K[1],K[2],K[3])}Te.to=Oe;function ve(K){return[K.red,K.green,K.blue,K.alpha]}Te.from=ve})(je||(e.Color=je={}));var et;(function(Te){function Oe(K){return{range:s.from(K.range)}}Te.from=Oe;function ve(K){return new a.SelectionRange(s.to(K.range))}Te.to=ve})(et||(e.SelectionRange=et={}));var Ye;(function(Te){function Oe(ve){switch(ve){case 2:return a.TextDocumentSaveReason.AfterDelay;case 1:return a.TextDocumentSaveReason.Manual;case 3:case 4:return a.TextDocumentSaveReason.FocusOut}}Te.to=Oe})(Ye||(e.TextDocumentSaveReason=Ye={}));var Je;(function(Te){function Oe(K){switch(K){case a.TextEditorLineNumbersStyle.Off:return 0;case a.TextEditorLineNumbersStyle.Relative:return 2;case a.TextEditorLineNumbersStyle.On:default:return 1}}Te.from=Oe;function ve(K){switch(K){case 0:return a.TextEditorLineNumbersStyle.Off;case 2:return a.TextEditorLineNumbersStyle.Relative;case 1:default:return a.TextEditorLineNumbersStyle.On}}Te.to=ve})(Je||(e.TextEditorLineNumbersStyle=Je={}));var rt;(function(Te){function Oe(K){if(K===a.EndOfLine.CRLF)return 1;if(K===a.EndOfLine.LF)return 0}Te.from=Oe;function ve(K){if(K===1)return a.EndOfLine.CRLF;if(K===0)return a.EndOfLine.LF}Te.to=ve})(rt||(e.EndOfLine=rt={}));var ut;(function(Te){function Oe(ve){if(typeof ve=="object")return ve.viewId;switch(ve){case a.ProgressLocation.SourceControl:return 3;case a.ProgressLocation.Window:return 10;case a.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Te.from=Oe})(ut||(e.ProgressLocation=ut={}));var Me;(function(Te){function Oe(K){const Fe={start:K.start+1,end:K.end+1};return K.kind&&(Fe.kind=st.from(K.kind)),Fe}Te.from=Oe;function ve(K){const Fe={start:K.start-1,end:K.end-1};return K.kind&&(Fe.kind=st.to(K.kind)),Fe}Te.to=ve})(Me||(e.FoldingRange=Me={}));var st;(function(Te){function Oe(K){if(K)switch(K){case a.FoldingRangeKind.Comment:return l.FoldingRangeKind.Comment;case a.FoldingRangeKind.Imports:return l.FoldingRangeKind.Imports;case a.FoldingRangeKind.Region:return l.FoldingRangeKind.Region}}Te.from=Oe;function ve(K){if(K)switch(K.value){case l.FoldingRangeKind.Comment.value:return a.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports.value:return a.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region.value:return a.FoldingRangeKind.Region}}Te.to=ve})(st||(e.FoldingRangeKind=st={}));var Z;(function(Te){function Oe(ve){if(ve)return{pinned:typeof ve.preview=="boolean"?!ve.preview:void 0,inactive:ve.background,preserveFocus:ve.preserveFocus,selection:typeof ve.selection=="object"?s.from(ve.selection):void 0,override:typeof ve.override=="boolean"?d.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Te.from=Oe})(Z||(e.TextEditorOpenOptions=Z={}));var J;(function(Te){function Oe(Be){return Be instanceof a.RelativePattern?Be.toJSON():typeof Be=="string"?Be:ve(Be)||K(Be)?new a.RelativePattern(Be.baseUri??Be.base,Be.pattern).toJSON():Be}Te.from=Oe;function ve(Be){const Xe=Be;return Xe?S.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function K(Be){const Xe=Be;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Fe(Be){return typeof Be=="string"?Be:new a.RelativePattern(S.URI.revive(Be.baseUri),Be.pattern)}Te.to=Fe})(J||(e.GlobPattern=J={}));var Se;(function(Te){function Oe(ve){if(ve){if(Array.isArray(ve))return ve.map(Oe);if(typeof ve=="string")return ve;{const K=ve;return{language:K.language,scheme:K.scheme,pattern:J.from(K.pattern),exclusive:K.exclusive,notebookType:K.notebookType}}}else return}Te.from=Oe})(Se||(e.LanguageSelector=Se={}));var Ue;(function(Te){function Oe(K){return{start:K.start,end:K.end}}Te.from=Oe;function ve(K){return new a.NotebookRange(K.start,K.end)}Te.to=ve})(Ue||(e.NotebookRange=Ue={}));var We;(function(Te){function Oe(K){return{timing:typeof K.runStartTime=="number"&&typeof K.runEndTime=="number"?{startTime:K.runStartTime,endTime:K.runEndTime}:void 0,executionOrder:K.executionOrder,success:K.lastRunSuccess}}Te.to=Oe;function ve(K){return{lastRunSuccess:K.success,runStartTime:K.timing?.startTime,runEndTime:K.timing?.endTime,executionOrder:K.executionOrder}}Te.from=ve})(We||(e.NotebookCellExecutionSummary=We={}));var Qe;(function(Te){function Oe(ve){if(ve===D.NotebookCellExecutionState.Unconfirmed)return a.NotebookCellExecutionState.Pending;if(ve===D.NotebookCellExecutionState.Pending)return;if(ve===D.NotebookCellExecutionState.Executing)return a.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ve}`)}Te.to=Oe})(Qe||(e.NotebookCellExecutionState=Qe={}));var Ve;(function(Te){function Oe(K){switch(K){case a.NotebookCellKind.Markup:return D.CellKind.Markup;case a.NotebookCellKind.Code:default:return D.CellKind.Code}}Te.from=Oe;function ve(K){switch(K){case D.CellKind.Markup:return a.NotebookCellKind.Markup;case D.CellKind.Code:default:return a.NotebookCellKind.Code}}Te.to=ve})(Ve||(e.NotebookCellKind=Ve={}));var it;(function(Te){function Oe(K){const Fe={metadata:K.metadata??Object.create(null),cells:[]};for(const Be of K.cells)a.NotebookCellData.validate(Be),Fe.cells.push(Et.from(Be));return Fe}Te.from=Oe;function ve(K){const Fe=new a.NotebookData(K.cells.map(Et.to));return(0,g.isEmptyObject)(K.metadata)||(Fe.metadata=K.metadata),Fe}Te.to=ve})(it||(e.NotebookData=it={}));var Et;(function(Te){function Oe(K){return{cellKind:Ve.from(K.kind),language:K.languageId,mime:K.mime,source:K.value,metadata:K.metadata,internalMetadata:We.from(K.executionSummary??{}),outputs:K.outputs?K.outputs.map(Tt.from):[]}}Te.from=Oe;function ve(K){return new a.NotebookCellData(Ve.to(K.cellKind),K.source,K.language,K.mime,K.outputs?K.outputs.map(Tt.to):void 0,K.metadata,K.internalMetadata?We.to(K.internalMetadata):void 0)}Te.to=ve})(Et||(e.NotebookCellData=Et={}));var yt;(function(Te){function Oe(K){return{mime:K.mime,valueBytes:P.VSBuffer.wrap(K.data)}}Te.from=Oe;function ve(K){return new a.NotebookCellOutputItem(K.valueBytes.buffer,K.mime)}Te.to=ve})(yt||(e.NotebookCellOutputItem=yt={}));var Tt;(function(Te){function Oe(K){return{outputId:K.id,items:K.items.map(yt.from),metadata:K.metadata}}Te.from=Oe;function ve(K){const Fe=K.items.map(yt.to);return new a.NotebookCellOutput(Fe,K.outputId,K.metadata)}Te.to=ve})(Tt||(e.NotebookCellOutput=Tt={}));var Ht;(function(Te){function Oe(Fe){return K(Fe)?{include:(0,g.withNullAsUndefined)(J.from(Fe.include)),exclude:(0,g.withNullAsUndefined)(J.from(Fe.exclude))}:(0,g.withNullAsUndefined)(J.from(Fe))}Te.from=Oe;function ve(Fe){return K(Fe)?{include:J.to(Fe.include),exclude:J.to(Fe.exclude)}:J.to(Fe)}Te.to=ve;function K(Fe){const Be=Fe;return Be?!(0,g.isUndefinedOrNull)(Be.include)&&!(0,g.isUndefinedOrNull)(Be.exclude):!1}})(Ht||(e.NotebookExclusiveDocumentPattern=Ht={}));var wt;(function(Te){function Oe(ve,K,Fe){const Be=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{alignment:ve.alignment===a.NotebookCellStatusBarAlignment.Left?1:2,command:K.toInternal(Be,Fe),text:ve.text,tooltip:ve.tooltip,accessibilityInformation:ve.accessibilityInformation,priority:ve.priority}}Te.from=Oe})(wt||(e.NotebookStatusBarItem=wt={}));var Bt;(function(Te){function Oe(ve,K,Fe){const Be=typeof ve.command=="string"?{title:"",command:ve.command}:ve.command;return{command:K.toInternal(Be,Fe),label:ve.label,description:ve.description,detail:ve.detail,documentation:ve.documentation}}Te.from=Oe})(Bt||(e.NotebookKernelSourceAction=Bt={}));var Mt;(function(Te){function Oe(ve){return{transientOutputs:ve?.transientOutputs??!1,transientCellMetadata:ve?.transientCellMetadata??{},transientDocumentMetadata:ve?.transientDocumentMetadata??{},cellContentMetadata:ve?.cellContentMetadata??{}}}Te.from=Oe})(Mt||(e.NotebookDocumentContentOptions=Mt={}));var xt;(function(Te){function Oe(K){return{uri:K.uri,provides:K.provides}}Te.from=Oe;function ve(K){return new a.NotebookRendererScript(S.URI.revive(K.uri),K.provides)}Te.to=ve})(xt||(e.NotebookRendererScript=xt={}));var Vt;(function(Te){function Oe(K){return{message:G.fromStrict(K.message)||"",type:0,expected:K.expectedOutput,actual:K.actualOutput,location:K.location&&{range:s.from(K.location.range),uri:K.location.uri}}}Te.from=Oe;function ve(K){const Fe=new a.TestMessage(typeof K.message=="string"?K.message:G.to(K.message));return Fe.actualOutput=K.actual,Fe.expectedOutput=K.expected,Fe.location=K.location?Q.to(K.location):void 0,Fe}Te.to=ve})(Vt||(e.TestMessage=Vt={}));var Pt;(function(Te){Te.namespace=v.namespaceTestTag,Te.denamespace=v.denamespaceTestTag})(Pt||(e.TestTag=Pt={}));var at;(function(Te){function Oe(K){const Fe=(0,o.getPrivateApiFor)(K).controllerId;return{extId:T.TestId.fromExtHostTestItem(K,Fe).toString(),label:K.label,uri:S.URI.revive(K.uri),busy:K.busy,tags:K.tags.map(Be=>Pt.namespace(Fe,Be.id)),range:p.Range.lift(s.from(K.range)),description:K.description||null,sortText:K.sortText||null,error:K.error&&G.fromStrict(K.error)||null}}Te.from=Oe;function ve(K){return{parent:void 0,error:void 0,id:T.TestId.fromString(K.extId).localId,label:K.label,uri:S.URI.revive(K.uri),tags:(K.tags||[]).map(Fe=>{const{tagId:Be}=Pt.denamespace(Fe);return new a.TestTag(Be)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:s.to(K.range||void 0),canResolveChildren:!1,busy:K.busy,description:K.description||void 0,sortText:K.sortText||void 0}}Te.toPlain=ve})(at||(e.TestItem=at={})),function(Te){function Oe(K){return{id:K.id}}Te.from=Oe;function ve(K){return new a.TestTag(K.id)}Te.to=ve}(Pt||(e.TestTag=Pt={}));var gt;(function(Te){const Oe=(K,Fe)=>{const Be=[];for(const[He,tt]of Fe)T.TestId.compare(tt.item.extId,He)===2&&(Fe.delete(He),Be.push(tt));const Xe={...at.toPlain(K.item),parent:void 0,taskStates:K.tasks.map(He=>({state:He.state,duration:He.duration,messages:He.messages.filter(tt=>tt.type===0).map(Vt.to)})),children:Be.map(He=>Oe(He,Fe))};for(const He of Xe.children)He.parent=Xe;return Xe};function ve(K){const Fe=[],Be=new Map;for(const Xe of K.items){Be.set(Xe.item.extId,Xe);const He=T.TestId.root(Xe.item.extId);K.request.targets.some(tt=>tt.controllerId===He&&tt.testIds.includes(Xe.item.extId))&&Fe.push(Xe)}return{completedAt:K.completedAt,results:Fe.map(Xe=>Oe(Xe,Be))}}Te.to=ve})(gt||(e.TestResults=gt={}));var Wt;(function(Te){function Oe(Be){return{covered:Be.covered,total:Be.covered}}function ve(Be){return"line"in Be?k.from(Be):s.from(Be)}function K(Be){return"branches"in Be?{count:Be.executionCount,location:ve(Be.location),type:1,branches:Be.branches.length?Be.branches.map(Xe=>({count:Xe.executionCount,location:Xe.location&&ve(Xe.location)})):void 0}:{type:0,count:Be.executionCount,location:ve(Be.location)}}Te.fromDetailed=K;function Fe(Be){return{uri:Be.uri,statement:Oe(Be.statementCoverage),branch:Be.branchCoverage&&Oe(Be.branchCoverage),function:Be.functionCoverage&&Oe(Be.functionCoverage),details:Be.detailedCoverage?.map(K)}}Te.fromFile=Fe})(Wt||(e.TestCoverage=Wt={}));var Ut;(function(Te){function Oe(ve){switch(ve){case 1:return a.CodeActionTriggerKind.Invoke;case 2:return a.CodeActionTriggerKind.Automatic}}Te.to=Oe})(Ut||(e.CodeActionTriggerKind=Ut={}));var kt;(function(Te){function Oe(K){const Fe=new a.TypeHierarchyItem(he.to(K.kind),K.name,K.detail||"",S.URI.revive(K.uri),s.to(K.range),s.to(K.selectionRange));return Fe._sessionId=K._sessionId,Fe._itemId=K._itemId,Fe}Te.to=Oe;function ve(K,Fe,Be){if(Fe=Fe??K._sessionId,Be=Be??K._itemId,Fe===void 0||Be===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:Be,kind:he.from(K.kind),name:K.name,detail:K.detail??"",uri:K.uri,range:s.from(K.range),selectionRange:s.from(K.selectionRange),tags:K.tags?.map(de.from)}}Te.from=ve})(kt||(e.TypeHierarchyItem=kt={}));var ht;(function(Te){function Oe(ve){if(ve)return{value:ve.value,tooltip:ve.tooltip}}Te.from=Oe})(ht||(e.ViewBadge=ht={}));var Ct;(function(Te){function Oe(Be,Xe,He){const tt=Xe.fileData;return tt?new class extends a.DataTransferItem{asFile(){return new a.DataTransferFile(tt.name,S.URI.revive(tt.uri),Xe.id,(0,L.once)(()=>He()))}}("",Xe.id):Be===O.Mimes.uriList&&Xe.uriListData?new a.DataTransferItem(Fe(Xe.uriListData)):new a.DataTransferItem(Xe.asString)}Te.to=Oe;async function ve(Be,Xe){const He=await Xe.asString();if(Be===O.Mimes.uriList)return{id:Xe.id,asString:He,fileData:void 0,uriListData:K(He)};const tt=Xe.asFile();return{id:Xe.id,asString:He,fileData:tt?{name:tt.name,uri:tt.uri}:void 0}}Te.from=ve;function K(Be){return I.UriList.split(Be).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return S.URI.parse(Xe)}catch{}return Xe})}function Fe(Be){return I.UriList.create(Be.map(Xe=>typeof Xe=="string"?Xe:S.URI.revive(Xe)))}})(Ct||(e.DataTransferItem=Ct={}));var Ft;(function(Te){function Oe(K,Fe){const Be=K.items.map(([Xe,He])=>[Xe,Ct.to(Xe,He,()=>Fe(He.id))]);return new a.DataTransfer(Be)}Te.toDataTransfer=Oe;async function ve(K){const Fe={items:[]},Be=[];return K.forEach((Xe,He)=>{Be.push((async()=>{Fe.items.push([He,await Ct.from(He,Xe)])})())}),await Promise.all(Be),Fe}Te.toDataTransferDTO=ve})(Ft||(e.DataTransfer=Ft={}));var At;(function(Te){function Oe(K){return{message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}Te.to=Oe;function ve(K){return{kind:"reply",message:K.message,metadata:K.metadata,title:K.title,tooltip:K.tooltip}}Te.from=ve})(At||(e.InteractiveSessionReplyFollowup=At={}));var Ke;(function(Te){function Oe(ve){return typeof ve=="string"?{title:ve,message:ve,kind:"reply"}:"commandId"in ve?{kind:"command",title:ve.title??"",commandId:ve.commandId??"",args:ve.args}:At.from(ve)}Te.from=Oe})(Ke||(e.InteractiveSessionFollowup=Ke={}))}),define(Pe[203],Ae([1,0,2,9,7,8,170]),function(te,e,n,P,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(h,O,w,g={timeout:1500,errors:3}){this.c=h,this.d=O,this.f=w,this.g=g,this.a=new R.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(h){return(O,w,g)=>{const p={dispose:this.a.push([O,w,h])};return Array.isArray(g)&&g.push(p),p}}async $participateInSave(h,O){const w=n.URI.revive(h);let g=!1;const S=setTimeout(()=>g=!0,this.g.timeout),p=[];try{for(const l of[...this.a]){if(g)break;const t=this.d.getDocument(w),o=await this.h(l,{document:t,reason:L.TextDocumentSaveReason.to(O)});p.push(o)}}finally{clearTimeout(S)}return p}h([h,O,w],g){const S=this.b.get(h);return typeof S=="number"&&S>this.g.errors?Promise.resolve(!1):this.i(w,h,O,g).then(()=>!0,p=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' threw ERROR`),this.c.error(p),!(p instanceof Error)||p.message!=="concurrent_edits"){const l=this.b.get(h);this.b.set(h,l?l+1:1),typeof l=="number"&&l>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${w.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(h,O,w,g){const S=[],p=Date.now(),{document:l,reason:t}=g,{version:o}=l,d=Object.freeze({document:l,reason:t,waitUntil(D){if(Object.isFrozen(S))throw(0,P.illegalState)("waitUntil can not be called async");S.push(Promise.resolve(D))}});try{O.apply(w,[d])}catch(D){return Promise.reject(D)}return Object.freeze(S),new Promise((D,T)=>{const v=setTimeout(()=>T(new Error("timeout")),this.g.timeout);return Promise.all(S).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${h.identifier.value}' finished after ${Date.now()-p}ms`),clearTimeout(v),D(i)}).catch(i=>{clearTimeout(v),T(i)})}).then(D=>{const T={edits:[]};for(const v of D)if(Array.isArray(v)&&v.every(i=>i instanceof I.TextEdit))for(const{newText:i,newEol:a,range:r}of v)T.edits.push({resource:l.uri,versionId:void 0,textEdit:{range:r&&L.Range.from(r),text:i,eol:a&&L.EndOfLine.from(a)}});if(T.edits.length!==0)return o===l.version?this.f.$tryApplyWorkspaceEdit(T):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(Pe[204],Ae([1,0,15,2,8,7,73]),function(te,e,n,P,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(w,g,S,p){this.start=w,this.deletedCount=g,this.deletedItems=S,this.items=p}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(w=>w.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(w,g){return{EOL:g.eol,lines:g.source,languageId:g.language,uri:g.uri,isDirty:!1,versionId:1,notebook:w}}constructor(w,g,S){this.notebook=w,this.h=g,this.j=S,this.handle=S.handle,this.uri=P.URI.revive(S.uri),this.cellKind=S.cellKind,this.a=S.outputs.map(I.NotebookCellOutput.to),this.e=S.internalMetadata??{},this.b=Object.freeze(S.metadata??{}),this.d=Object.freeze(I.NotebookCellExecutionSummary.to(S.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const w=this,g=this.h.getDocument(this.uri);if(!g)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const S={get index(){return w.notebook.getCellIndex(w)},notebook:w.notebook.apiNotebook,kind:I.NotebookCellKind.to(this.j.cellKind),document:g.document,get mime(){return w.g},set mime(p){w.g=p},get outputs(){return w.a.slice(0)},get metadata(){return w.b},get executionSummary(){return w.d}};this.f=Object.freeze(S)}return this.f}setOutputs(w){this.a=w.map(I.NotebookCellOutput.to)}setOutputItems(w,g,S){const p=S.map(I.NotebookCellOutputItem.to),l=this.a.find(t=>t.id===w);if(l&&(g||(l.items.length=0),l.items.push(...p),l.items.length>1&&l.items.every(t=>R.isTextStreamMime(t.mime)))){const t=new Map,o=[];l.items.forEach(d=>{let D;t.has(d.mime)?D=t.get(d.mime):(D=[],t.set(d.mime,D),o.push(d.mime)),D.push(d.data)}),l.items.length=0,o.forEach(d=>{const D=R.compressOutputItemStreams(t.get(d));l.items.push({mime:d,data:D.buffer})})}}setMetadata(w){this.b=Object.freeze(w)}setInternalMetadata(w){this.e=w,this.d=Object.freeze(I.NotebookCellExecutionSummary.to(w))}setMime(w){}}e.ExtHostCell=y;class h{constructor(w,g,S,p,l){this.k=w,this.l=g,this.m=S,this.uri=p,this.handle=h.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=l.viewType,this.f=Object.freeze(l.metadata??Object.create(null)),this.r([[0,0,l.cells]],!0,void 0),this.g=l.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const w=this,g={get uri(){return w.uri},get version(){return w.g},get notebookType(){return w.d},get isDirty(){return w.h},get isUntitled(){return w.uri.scheme===n.Schemas.untitled},get isClosed(){return w.j},get metadata(){return w.f},get cellCount(){return w.b.length},cellAt(S){return S=w.n(S),w.b[S].apiCell},getCells(S){return(S?w.p(S):w.b).map(l=>l.apiCell)},save(){return w.q()}};this.e=Object.freeze(g)}return this.e}acceptDocumentPropertiesChanged(w){w.metadata&&(this.f=Object.freeze({...this.f,...w.metadata}))}acceptDirty(w){this.h=w}acceptModelChanged(w,g,S){this.g=w.versionId,this.h=g,this.acceptDocumentPropertiesChanged({metadata:S});const p={notebook:this.apiNotebook,metadata:S,cellChanges:[],contentChanges:[]},l=[];for(const o of w.rawEvents)o.kind===R.NotebookCellsChangeType.ModelChange?this.r(o.changes,!1,p.contentChanges):o.kind===R.NotebookCellsChangeType.Move?this.s(o.index,o.length,o.newIdx,p.contentChanges):o.kind===R.NotebookCellsChangeType.Output?(this.t(o.index,o.outputs),l.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.OutputItem?(this.u(o.index,o.outputId,o.append,o.outputItems),l.push({cell:this.b[o.index].apiCell,outputs:this.b[o.index].apiCell.outputs})):o.kind===R.NotebookCellsChangeType.ChangeCellLanguage?(this.v(o.index,o.language),l.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document})):o.kind===R.NotebookCellsChangeType.ChangeCellContent?l.push({cell:this.b[o.index].apiCell,document:this.b[o.index].apiCell.document}):o.kind===R.NotebookCellsChangeType.ChangeCellMime?this.w(o.index,o.mime):o.kind===R.NotebookCellsChangeType.ChangeCellMetadata?(this.x(o.index,o.metadata),l.push({cell:this.b[o.index].apiCell,metadata:this.b[o.index].apiCell.metadata})):o.kind===R.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(o.index,o.internalMetadata),l.push({cell:this.b[o.index].apiCell,executionSummary:this.b[o.index].apiCell.executionSummary}));const t=new Map;for(let o=0;o<l.length;o++){const d=l[o],D=t.get(d.cell);if(D===void 0){const T=p.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...d});t.set(d.cell,T-1)}else p.cellChanges[D]={...p.cellChanges[D],...d}}return Object.freeze(p),Object.freeze(p.cellChanges),Object.freeze(p.contentChanges),p}n(w){return w=w|0,w<0?0:w>=this.b.length?this.b.length-1:w}o(w){let g=w.start|0,S=w.end|0;return g<0&&(g=0),S>this.b.length&&(S=this.b.length),w.with({start:g,end:S})}p(w){w=this.o(w);const g=[];for(let S=w.start;S<w.end;S++)g.push(this.b[S]);return g}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(w,g,S){if(this.j)return;const p=[],l=[],t=[];if(w.reverse().forEach(o=>{const D=o[2].map(i=>{const a=new y(this,this.l,i);return g||l.push(y.asModelAddData(this.apiNotebook,i)),a}),T=new A(o[0],o[1],[],D),v=this.b.splice(o[0],o[1],...D);for(const i of v)t.push(i.uri),T.deletedItems.push(i.apiCell);p.push(T)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:t}),S)for(const o of p)S.push(o.asApiEvent())}s(w,g,S,p){const l=this.b.splice(w,g);this.b.splice(S,0,...l);const t=[new A(w,g,l.map(o=>o.apiCell),[]),new A(S,0,[],l)];for(const o of t)p.push(o.asApiEvent())}t(w,g){this.b[w].setOutputs(g)}u(w,g,S,p){this.b[w].setOutputItems(g,S,p)}v(w,g){const S=this.b[w];S.apiCell.document.languageId!==g&&this.m.$acceptModelLanguageChanged(S.uri,g)}w(w,g){const S=this.b[w];S.apiCell.mime=g}x(w,g){this.b[w].setMetadata(g)}y(w,g){this.b[w].setInternalMetadata(g)}getCellFromApiCell(w){return this.b.find(g=>g.apiCell===w)}getCellFromIndex(w){return this.b[w]}getCell(w){return this.b.find(g=>g.handle===w)}getCellIndex(w){return this.b.indexOf(w)}}e.ExtHostNotebookDocument=h,h.a=0}),define(Pe[205],Ae([1,0,5,2,8,7]),function(te,e,n,P,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocumentSaveParticipant=void 0;class R{constructor(y,h,O,w={timeout:1500,errors:3}){this.b=y,this.c=h,this.d=O,this.f=w,this.a=new n.AsyncEmitter}dispose(){}getOnWillSaveNotebookDocumentEvent(y){return(h,O,w)=>{const g=function(p){h.call(O,p)};return g.extension=y,this.a.event(g,void 0,w)}}async $participateInSave(y,h,O){const w=P.URI.revive(y),g=this.c.getNotebookDocument(w);if(!g)throw new Error("Unable to resolve notebook document");const S=[];if(await this.a.fireAsync({notebook:g.apiNotebook,reason:I.TextDocumentSaveReason.to(h)},O,async(l,t)=>{const o=Date.now(),d=await await Promise.resolve(l);Date.now()-o>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier),!O.isCancellationRequested&&d&&(d instanceof L.WorkspaceEdit?S.push(d):this.b.warn("onWillSaveNotebookDocument-listener from extension",t.extension.identifier,"ignored due to invalid data"))}),O.isCancellationRequested)return!1;if(S.length===0)return!0;const p={edits:[]};for(const l of S){const{edits:t}=I.WorkspaceEdit.from(l);p.edits=p.edits.concat(t)}return this.d.$tryApplyWorkspaceEdit(p)}}e.ExtHostNotebookDocumentSaveParticipant=R}),define(Pe[103],Ae([1,0,9,8,7]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(A,y,h,O,w,g){this.id=A,this.f=y,this.notebookData=h,this.a=[],this.b=[],this.d=!1,this.a=w,this.b=O,this.c=g}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(y){this.selections=[y]},get selections(){return A.a},set selections(y){if(!Array.isArray(y)||!y.every(I.NotebookRange.isNotebookRange))throw(0,n.illegalArgument)("selections");A.a=y,A.g(y)},get visibleRanges(){return A.b},revealRange(y,h){A.f.$tryRevealRange(A.id,P.NotebookRange.from(y),h??I.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},L.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(P.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}e.ExtHostNotebookEditor=L,L.apiEditorsToExtHost=new WeakMap}),define(Pe[206],Ae([1,0,9,5,14,8]),function(te,e,n,P,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=e.ExtHostNotebookEditors=class{constructor(y,h){this.c=y,this.d=h,this.a=new P.Emitter({onListenerError:n.onUnexpectedExternalError}),this.b=new P.Emitter({onListenerError:n.onUnexpectedExternalError}),this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(y,h){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",y,h);const O=this.d.getEditorById(y);h.visibleRanges&&O._acceptVisibleRanges(h.visibleRanges.ranges.map(L.NotebookRange.to)),h.selections&&O._acceptSelections(h.selections.selections.map(L.NotebookRange.to)),h.visibleRanges&&this.b.fire({notebookEditor:O.apiEditor,visibleRanges:O.apiEditor.visibleRanges}),h.selections&&this.a.fire(Object.freeze({notebookEditor:O.apiEditor,selections:O.apiEditor.selections}))}$acceptEditorViewColumns(y){for(const h in y)this.d.getEditorById(h)._acceptViewColumn(L.ViewColumn.to(y[h]))}};e.ExtHostNotebookEditors=R=xe([qe(0,I.ILogService)],R)}),define(Pe[207],Ae([1,0,8,174,150,21,65,9]),function(te,e,n,P,I,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(g){this.b=0,this.c=new Map,this.a=g}async withProgress(g,S,p){const l=this.b++,{title:t,location:o,cancellable:d}=S,D={label:(0,I.localize)(0,null,g.displayName||g.name),id:g.identifier.value};return this.a.$startProgress(l,{location:n.ProgressLocation.from(o),title:t,source:D,cancellable:d},g.isUnderDevelopment?void 0:g.identifier.value).catch(A.onUnexpectedExternalError),this.d(l,p,!!d)}d(g,S,p){let l;p&&(l=new L.CancellationTokenSource,this.c.set(g,l));const t=d=>{this.a.$progressEnd(d),this.c.delete(d),l?.dispose()};let o;try{o=S(new O(this.a,g),p&&l?l.token:L.CancellationToken.None)}catch(d){throw t(g),d}return o.then(d=>t(g),d=>t(g)),o}$acceptProgressCanceled(g){const S=this.c.get(g);S&&(S.cancel(),this.c.delete(g))}}e.ExtHostProgress=y;function h(w,g){return w.message=g.message,typeof g.increment=="number"&&(typeof w.increment=="number"?w.increment+=g.increment:w.increment=g.increment),w}class O extends P.Progress{constructor(g,S){super(p=>this.throttledReport(p)),this.c=g,this.d=S}throttledReport(g){this.c.$progressReport(this.d,g)}}xe([(0,R.throttle)(100,(w,g)=>h(w,g),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(Pe[104],Ae([1,0,44,99,45,74,56,8,2]),function(te,e,n,P,I,L,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const h=(D,T,v,i)=>{let a=T;return{enumerable:!0,configurable:!1,get(){return a},set(r){if(!v(a,r)){const s=a;a=r,D.listener?.(i(r,s))}}}},O=(D,T)=>D===T,w={range:(D,T)=>D===T?!0:!D||!T?!1:D.isEqual(T),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(D,T)=>!(D.length!==T.length||D.some(v=>!T.find(i=>v.id===i.id)))},g=D=>T=>({op:4,update:D(T)}),S=(D,T)=>({range:(()=>{let v;const i=g(a=>({range:n.Range.lift(A.Range.from(a))}));return{enumerable:!0,configurable:!1,get(){return v},set(a){D.listener?.({op:6}),w.range(v,a)||(v=a,D.listener?.(i(a)))}}})(),label:h(D,T,w.label,g(v=>({label:v}))),description:h(D,void 0,w.description,g(v=>({description:v}))),sortText:h(D,void 0,w.sortText,g(v=>({sortText:v}))),canResolveChildren:h(D,!1,w.canResolveChildren,v=>({op:2,state:v})),busy:h(D,!1,w.busy,g(v=>({busy:v}))),error:h(D,void 0,w.error,g(v=>({error:A.MarkdownString.fromStrict(v)||null}))),tags:h(D,[],w.tags,(v,i)=>({op:1,new:v.map(A.TestTag.from),old:i.map(A.TestTag.from)}))}),p=D=>{const T=I.TestId.fromString(D.extId),v=new t(T.controllerId,T.localId,D.label,y.URI.revive(D.uri)||void 0);return v.range=A.Range.to(D.range||void 0),v.description=D.description||void 0,v.sortText=D.sortText||void 0,v.tags=D.tags.map(i=>A.TestTag.to({id:(0,R.denamespaceTestTag)(i).tagId})),v},l=D=>{let T;for(const v of D.tests){const i=p(v.item);(0,P.getPrivateApiFor)(i).parent=T,T=i}return T};e.toItemFromContext=l;class t{constructor(T,v,i,a){if(v.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(v)} symbol`);const r=(0,P.createPrivateApiFor)(this,T);Object.defineProperties(this,{id:{value:v,enumerable:!0,writable:!1},uri:{value:a,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof o?void 0:r.parent}},children:{value:(0,L.createTestItemChildren)(r,P.getPrivateApiFor,t),enumerable:!0,writable:!1},...S(r,i)})}}e.TestItemImpl=t;class o extends t{constructor(T,v){super(T,T,v,void 0),this._isRoot=!0}}e.TestItemRootImpl=o;class d extends L.TestItemCollection{constructor(T,v,i){super({controllerId:T,getDocumentVersion:a=>a&&i.getDocument(a)?.version,getApiFor:P.getPrivateApiFor,getChildren:a=>a.children,root:new o(T,v),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=d}),define(Pe[105],Ae([1,0,49,9,84,8,7]),function(te,e,n,P,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(g,S,p){const l=A.c.nextId();g.$registerTextEditorDecorationType(S.identifier,l,L.DecorationRenderOptions.from(p)),this.value=Object.freeze({key:l,dispose(){g.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=A,A.c=new I.IdGenerator("TextEditorDecorationType");class y{constructor(g,S){this.g=[],this.h=void 0,this.j=!1,this.c=g,this.d=g.version,this.e=S.undoStopBefore,this.f=S.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(g,S){this.k();let p=null;if(g instanceof R.Position)p=new R.Range(g,g);else if(g instanceof R.Range)p=g;else throw new Error("Unrecognized location");this.l(p,S,!1)}insert(g,S){this.k(),this.l(new R.Range(g,g),S,!0)}delete(g){this.k();let S=null;if(g instanceof R.Range)S=g;else throw new Error("Unrecognized location");this.l(S,null,!0)}l(g,S,p){const l=this.c.validateRange(g);this.g.push({range:l,text:S,forceMoveMarkers:p})}setEndOfLine(g){if(this.k(),g!==R.EndOfLine.LF&&g!==R.EndOfLine.CRLF)throw(0,P.illegalArgument)("endOfLine");this.h=g}}class h{constructor(g,S,p,l){this.c=g,this.d=S,this._accept(p),this.e=l;const t=this;this.value={get tabSize(){return t.f},set tabSize(o){t.m(o)},get indentSize(){return t.g},set indentSize(o){t.o(o)},get insertSpaces(){return t.h},set insertSpaces(o){t.q(o)},get cursorStyle(){return t.j},set cursorStyle(o){t.s(o)},get lineNumbers(){return t.k},set lineNumbers(o){t.t(o)}}}_accept(g){this.f=g.tabSize,this.g=g.indentSize,this.h=g.insertSpaces,this.j=g.cursorStyle,this.k=L.TextEditorLineNumbersStyle.to(g.lineNumbers)}l(g){if(g==="auto")return"auto";if(typeof g=="number"){const S=Math.floor(g);return S>0?S:null}if(typeof g=="string"){const S=parseInt(g,10);return isNaN(S)?null:S>0?S:null}return null}m(g){const S=this.l(g);if(S!==null){if(typeof S=="number"){if(this.f===S)return;this.f=S}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:S}))}}n(g){if(g==="tabSize")return"tabSize";if(typeof g=="number"){const S=Math.floor(g);return S>0?S:null}if(typeof g=="string"){const S=parseInt(g,10);return isNaN(S)?null:S>0?S:null}return null}o(g){const S=this.n(g);if(S!==null){if(typeof S=="number"){if(this.g===S)return;this.g=S}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:S}))}}p(g){return g==="auto"?"auto":g==="false"?!1:!!g}q(g){const S=this.p(g);if(typeof S=="boolean"){if(this.h===S)return;this.h=S}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:S}))}s(g){this.j!==g&&(this.j=g,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:g})))}t(g){this.k!==g&&(this.k=g,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:L.TextEditorLineNumbersStyle.from(g)})))}assign(g){const S={};let p=!1;if(typeof g.tabSize<"u"){const l=this.l(g.tabSize);l==="auto"?(p=!0,S.tabSize=l):typeof l=="number"&&this.f!==l&&(this.f=l,p=!0,S.tabSize=l)}if(typeof g.indentSize<"u"){const l=this.n(g.indentSize);l==="tabSize"?(p=!0,S.indentSize=l):typeof l=="number"&&this.g!==l&&(this.g=l,p=!0,S.indentSize=l)}if(typeof g.insertSpaces<"u"){const l=this.p(g.insertSpaces);l==="auto"?(p=!0,S.insertSpaces=l):this.h!==l&&(this.h=l,p=!0,S.insertSpaces=l)}typeof g.cursorStyle<"u"&&this.j!==g.cursorStyle&&(this.j=g.cursorStyle,p=!0,S.cursorStyle=g.cursorStyle),typeof g.lineNumbers<"u"&&this.k!==g.lineNumbers&&(this.k=g.lineNumbers,p=!0,S.lineNumbers=L.TextEditorLineNumbersStyle.from(g.lineNumbers)),p&&this.u("setOptions",this.c.$trySetOptions(this.d,S))}u(g,S){S.catch(p=>{this.e.warn(`ExtHostTextEditorOptions '${g}' failed:'`),this.e.warn(p)})}}e.ExtHostTextEditorOptions=h;class O{constructor(g,S,p,l,t,o,d,D){this.id=g,this.j=S,this.k=p,this.g=!1,this.h=new Set,this.c=t,this.d=new h(this.j,this.id,o,p),this.e=d,this.f=D;const T=this;this.value=Object.freeze({get document(){return l.value},set document(v){throw(0,P.readonly)("document")},get selection(){return T.c&&T.c[0]},set selection(v){if(!(v instanceof R.Selection))throw(0,P.illegalArgument)("selection");T.c=[v],T.l()},get selections(){return T.c},set selections(v){if(!Array.isArray(v)||v.some(i=>!(i instanceof R.Selection)))throw(0,P.illegalArgument)("selections");T.c=v,T.l()},get visibleRanges(){return T.e},set visibleRanges(v){throw(0,P.readonly)("visibleRanges")},get options(){return T.d.value},set options(v){T.g||T.d.assign(v)},get viewColumn(){return T.f},set viewColumn(v){throw(0,P.readonly)("viewColumn")},edit(v,i={undoStopBefore:!0,undoStopAfter:!0}){if(T.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const a=new y(l.value,i);return v(a),T.m(a)},insertSnippet(v,i,a={undoStopBefore:!0,undoStopAfter:!0}){if(T.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=T.c.map(s=>L.Range.from(s));else if(i instanceof R.Position){const{lineNumber:s,column:E}=L.Position.from(i);r=[{startLineNumber:s,startColumn:E,endLineNumber:s,endColumn:E}]}else if(i instanceof R.Range)r=[L.Range.from(i)];else{r=[];for(const s of i)if(s instanceof R.Range)r.push(L.Range.from(s));else{const{lineNumber:E,column:k}=L.Position.from(s);r.push({startLineNumber:E,startColumn:k,endLineNumber:E,endColumn:k})}}return S.$tryInsertSnippet(g,l.value.version,v.value,r,a)},setDecorations(v,i){const a=i.length===0;a&&!T.h.has(v.key)||(a?T.h.delete(v.key):T.h.add(v.key),T.n(()=>{if(L.isDecorationOptionsArr(i))return S.$trySetDecorations(g,v.key,L.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let s=0,E=i.length;s<E;s++){const k=i[s];r[4*s]=k.start.line+1,r[4*s+1]=k.start.character+1,r[4*s+2]=k.end.line+1,r[4*s+3]=k.end.character+1}return S.$trySetDecorationsFast(g,v.key,r)}}))},revealRange(v,i){T.n(()=>S.$tryRevealRange(g,L.Range.from(v),i||R.TextEditorRevealType.Default))},show(v){S.$tryShowEditor(g,L.ViewColumn.from(v))},hide(){S.$tryHideEditor(g)}})}dispose(){(0,n.ok)(!this.g),this.g=!0}_acceptOptions(g){(0,n.ok)(!this.g),this.d._accept(g)}_acceptVisibleRanges(g){(0,n.ok)(!this.g),this.e=g}_acceptViewColumn(g){(0,n.ok)(!this.g),this.f=g}_acceptSelections(g){(0,n.ok)(!this.g),this.c=g}async l(){const g=this.c.map(L.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,g)),this.value}m(g){const S=g.finalize();if(S.edits.length===0&&!S.setEndOfLine)return Promise.resolve(!0);const p=S.edits.map(t=>t.range);p.sort((t,o)=>t.end.line===o.end.line?t.end.character===o.end.character?t.start.line===o.start.line?t.start.character-o.start.character:t.start.line-o.start.line:t.end.character-o.end.character:t.end.line-o.end.line);for(let t=0,o=p.length-1;t<o;t++){const d=p[t].end;if(p[t+1].start.isBefore(d))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=S.edits.map(t=>({range:L.Range.from(t.range),text:t.text,forceMoveMarkers:t.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,S.documentVersionId,l,{setEndOfLine:typeof S.setEndOfLine=="number"?L.EndOfLine.from(S.setEndOfLine):void 0,undoStopBefore:S.undoStopBefore,undoStopAfter:S.undoStopAfter})}n(g){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):g().then(()=>this,S=>(S instanceof Error&&S.name==="DISPOSED"||this.k.warn(S),null))}}e.ExtHostTextEditor=O}),define(Pe[208],Ae([1,0,154,7,22,2,5,6,190,17,7,12,16,8,21,26,122]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function o(T,v){if((0,w.isString)(T))return{label:T};if(T&&typeof T=="object"&&typeof T.label=="string"){let i;return Array.isArray(T.highlights)&&(i=T.highlights.filter(a=>a.length===2&&typeof a[0]=="number"&&typeof a[1]=="number"),i=i.length?i:void 0),{label:T.label,highlights:i}}}class d{constructor(v,i,a){this.d=v,this.e=i,this.f=a,this.a=new Map,this.b=new t.TreeViewsDnDService;function r(s){return s&&s.$treeViewId&&(s.$treeItemHandle||s.$selectedTreeItems||s.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:s=>r(s)?this.i(s):Array.isArray(s)&&s.length>0?s.map(E=>r(E)?this.i(E):E):s})}registerTreeDataProvider(v,i,a){const r=this.createTreeView(v,{treeDataProvider:i},a);return{dispose:()=>r.dispose()}}createTreeView(v,i,a){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=i.dragAndDropController?.dropMimeTypes??[],s=i.dragAndDropController?.dragMimeTypes??[],E=!!i.dragAndDropController?.handleDrag,k=!!i.dragAndDropController?.handleDrop,c=this.h(v,i,a),u=this.d.$registerTreeViewDataProvider(v,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:r,dragMimeTypes:s,hasHandleDrag:E,hasHandleDrop:k});return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,l.checkProposedApiEnabled)(a,"treeItemCheckbox"),c.onDidChangeCheckboxState},get message(){return c.message},set message(m){c.message=m},get title(){return c.title},set title(m){c.title=m},get description(){return c.description},set description(m){c.description=m},get badge(){return c.badge},set badge(m){m!==void 0&&O.ViewBadge.isViewBadge(m)?c.badge={value:Math.floor(Math.abs(m.value)),tooltip:m.tooltip}:m===void 0&&(c.badge=void 0)},reveal:(m,b)=>c.reveal(m,b),dispose:async()=>{await u,this.a.delete(v),c.dispose()}}}$getChildren(v,i){const a=this.a.get(v);return a?a.getChildren(i):Promise.reject(new y.NoTreeViewError(v))}async $handleDrop(v,i,a,r,s,E,k,c){const u=this.a.get(v);if(!u)return Promise.reject(new y.NoTreeViewError(v));const m=S.DataTransfer.toDataTransfer(a,async b=>(await this.d.$resolveDropFileData(v,i,b)).buffer);return k===v&&c&&await this.g(m,u,c,s,E),u.onDrop(m,r,s)}async g(v,i,a,r,s){const E=this.b.removeDragOperationTransfer(s);if(E)(await E)?.forEach((k,c)=>{k&&v.set(c,k)});else if(s&&i.handleDrag){const k=i.handleDrag(a,v,r);this.b.addDragOperationTransfer(s,k),await k}return v}async $handleDrag(v,i,a,r){const s=this.a.get(v);if(!s)return Promise.reject(new y.NoTreeViewError(v));const E=await this.g(new P.DataTransfer,s,i,r,a);if(E)return S.DataTransfer.toDataTransferDTO(E)}async $hasResolve(v){const i=this.a.get(v);if(!i)throw new y.NoTreeViewError(v);return i.hasResolve}$resolve(v,i,a){const r=this.a.get(v);if(!r)throw new y.NoTreeViewError(v);return r.resolveTreeItem(i,a)}$setExpanded(v,i,a){const r=this.a.get(v);if(!r)throw new y.NoTreeViewError(v);r.setExpanded(i,a)}$setSelection(v,i){const a=this.a.get(v);if(!a)throw new y.NoTreeViewError(v);a.setSelection(i)}$setFocus(v,i){const a=this.a.get(v);if(!a)throw new y.NoTreeViewError(v);a.setFocus(i)}$setVisible(v,i){const a=this.a.get(v);if(!a)throw new y.NoTreeViewError(v);a.setVisible(i)}$changeCheckboxState(v,i){const a=this.a.get(v);if(!a)throw new y.NoTreeViewError(v);a.setCheckboxState(i)}h(v,i,a){const r=new D(v,i,this.d,this.e.converter,this.f,a);return this.a.set(v,r),r}i(v){const i=this.a.get(v.$treeViewId);return i&&"$treeItemHandle"in v?i.getExtensionElement(v.$treeItemHandle):i&&"$focusedTreeItem"in v&&v.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=d;class D extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(v=>this.getExtensionElement(v)).filter(v=>!(0,w.isUndefinedOrNull)(v))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(v,i,a,r,s,E){if(super(),this.C=v,this.D=a,this.F=r,this.G=s,this.H=E,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new R.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new R.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new R.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new R.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new R.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new R.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new p.CancellationTokenSource,E.contributes&&E.contributes.views)for(const u in E.contributes.views)for(const m of E.contributes.views[u])m.id===v&&(this.J=m.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(u=>this.w.fire({message:!1,element:u})));let k,c;this.B(R.Event.debounce(this.w.event,(u,m)=>(u||(u={message:!1,elements:[]}),m.element!==!1&&(k||(k=new Promise(b=>c=b),this.y=this.y.then(()=>k)),Array.isArray(m.element)?u.elements.push(...m.element):u.elements.push(m.element)),m.message&&(u.message=!0),u),200,!0)(({message:u,elements:m})=>{m.length&&(this.z=this.z.then(()=>{const b=c;return k=null,this.U(m).then(()=>b())})),u&&this.D.$setMessage(this.C,this.I)}))}async getChildren(v){const i=v?this.getExtensionElement(v):void 0;if(v&&!i)return this.G.error(`No tree item with id '${v}' found.`),Promise.resolve([]);let a=this.Q(v);return a||(a=await this.R(i)),a?a.map(r=>r.item):void 0}getExtensionElement(v){return this.i.get(v)}reveal(v,i){i=i||{select:!0,focus:!1};const a=(0,w.isUndefinedOrNull)(i.select)?!0:i.select,r=(0,w.isUndefinedOrNull)(i.focus)?!1:i.focus,s=(0,w.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):v?this.y.then(()=>this.N(v)).then(E=>this.P(v,E[E.length-1]).then(k=>this.D.$reveal(this.C,{item:k.item,parentChain:E.map(c=>c.item)},{select:a,focus:r,expand:s})),E=>this.G.error(E)):this.D.$reveal(this.C,void 0,{select:a,focus:r,expand:s})}get message(){return this.I}set message(v){this.I=v,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(v){this.J=v,this.D.$setTitle(this.C,v,this.L)}get description(){return this.L}set description(v){this.L=v,this.D.$setTitle(this.C,this.J,v)}get badge(){return this.M}set badge(v){this.M?.value===v?.value&&this.M?.tooltip===v?.tooltip||(this.M=S.ViewBadge.from(v),this.D.$setBadge(this.C,v))}setExpanded(v,i){const a=this.getExtensionElement(v);a&&(i?this.r.fire(Object.freeze({element:a})):this.s.fire(Object.freeze({element:a})))}setSelection(v){(0,g.equals)(this.l,v)||(this.l=v,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(v){this.m=v}setVisible(v){v!==this.k&&(this.k=v,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(v){const i=(await Promise.all(v.map(async a=>{const r=this.getExtensionElement(a.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:a.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(a=>a!==void 0);i.forEach(a=>{a.treeItem.checkboxState=a.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}),this.v.fire({items:i.map(a=>[a.extensionItem,a.newState])})}async handleDrag(v,i,a){const r=[];for(const s of v){const E=this.getExtensionElement(s);E&&r.push(E)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,i,a),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(v,i,a){const r=i?this.getExtensionElement(i):void 0;if(!(!r&&i||!this.g?.handleDrop))return(0,h.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,v,a):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(v,i){if(!this.f.resolveTreeItem)return;const a=this.i.get(v);if(a){const r=this.j.get(a);if(r){const s=await this.f.resolveTreeItem(r.extensionItem,a,i)??r.extensionItem;return this.db(s),r.item.tooltip=this.ab(s.tooltip),r.item.command=this.bb(r.disposableStore,s.command),r.item}}}N(v){return this.O(v).then(i=>i?this.N(i).then(a=>this.P(i,a[a.length-1]).then(r=>(a.push(r),a))):Promise.resolve([]))}O(v){const i=this.j.get(v);return i?Promise.resolve(i.parent?this.i.get(i.parent.item.handle):void 0):(0,h.asPromise)(()=>this.f.getParent(v))}P(v,i){const a=this.j.get(v);return a?Promise.resolve(a):(0,h.asPromise)(()=>this.f.getTreeItem(v)).then(r=>this.gb(v,r,i,!0)).then(r=>this.getChildren(i?i.item.handle:void 0).then(()=>{const s=this.getExtensionElement(r);if(s){const E=this.j.get(s);if(E)return Promise.resolve(E)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(v){if(v){let i;if(typeof v=="string"){const a=this.getExtensionElement(v);i=a?this.j.get(a):void 0}else i=v;return i&&i.children||void 0}return this.h}async R(v){this.nb(v);const i=new p.CancellationTokenSource(this.S.token);try{const a=v?this.j.get(v):void 0,r=await this.f.getChildren(v);if(i.token.isCancellationRequested)return;const s=await Promise.all((0,g.coalesce)(r||[]).map(async E=>{const k=await this.f.getTreeItem(E);return k&&!i.token.isCancellationRequested?this.Z(E,k,a):null}));return i.token.isCancellationRequested?void 0:(0,g.coalesce)(s)}finally{i.dispose()}}U(v){if(v.some(a=>!a))return this.S.dispose(!0),this.S=new p.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const a=this.W(v);if(a.length)return this.X(a)}return Promise.resolve(void 0)}W(v){const i=new Set,a=v.map(s=>this.j.get(s));for(const s of a)if(s&&!i.has(s.item.handle)){let E=s;for(;E&&E.parent&&a.findIndex(k=>E&&E.parent&&k&&k.item.handle===E.parent.item.handle)===-1;){const k=this.i.get(E.parent.item.handle);E=k?this.j.get(k):void 0}E&&!E.parent&&i.add(s.item.handle)}const r=[];return i.forEach(s=>{const E=this.i.get(s);if(E){const k=this.j.get(E);k&&(!k.parent||!i.has(k.parent.item.handle))&&r.push(s)}}),r}X(v){const i={};return Promise.all(v.map(a=>this.Y(a).then(r=>{r&&(i[a]=r.item)}))).then(()=>Object.keys(i).length?this.D.$refresh(this.C,i):void 0)}Y(v){const i=this.getExtensionElement(v);if(i){const a=this.j.get(i);if(a)return this.nb(i),(0,h.asPromise)(()=>this.f.getTreeItem(i)).then(r=>{if(r){const s=this.eb(i,r,a.parent);return this.lb(i,s,a,a.parent),a.dispose(),s}return null})}return Promise.resolve(null)}Z(v,i,a){const r=this.eb(v,i,a);if(i.id&&this.i.has(r.item.handle))throw new Error((0,n.localize)(0,null,i.id));return this.kb(v,r),this.mb(r,a),r}ab(v){return O.MarkdownString.isMarkdownString(v)?S.MarkdownString.from(v):v}bb(v,i){return i?{...this.F.toInternal(i,v),originalId:i.command}:void 0}cb(v){if(!v.checkboxState)return;let i,a;return typeof v.checkboxState=="number"?i=v.checkboxState:(i=v.checkboxState.state,a=v.checkboxState.tooltip),{isChecked:i===O.TreeItemCheckboxState.Checked,tooltip:a}}db(v){if(!O.TreeItem.isTreeItem(v,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(v,i,a){this.db(i);const r=new A.DisposableStore,s=this.gb(v,i,a),E=this.hb(i);return{item:{handle:s,parentHandle:a?a.item.handle:void 0,label:o(i.label,this.H),description:i.description,resourceUri:i.resourceUri,tooltip:this.ab(i.tooltip),command:this.bb(r,i.command),contextValue:i.contextValue,icon:E,iconDark:this.ib(i)||E,themeIcon:this.fb(i),collapsibleState:(0,w.isUndefinedOrNull)(i.collapsibleState)?O.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.cb(i)},extensionItem:i,parent:a,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(v){return v.iconPath instanceof O.ThemeIcon?v.iconPath:void 0}gb(v,{id:i,label:a,resourceUri:r},s,E){if(i)return`${D.b}/${i}`;const k=o(a,this.H),c=s?s.item.handle:D.a;let u=k?k.label:r?(0,I.basename)(r):"";u=u.indexOf("/")!==-1?u.replace("/","//"):u;const m=this.j.has(v)?this.j.get(v).item.handle:void 0,b=this.Q(s)||[];let f,N=0;do{if(f=`${c}/${N}:${u}`,E||!this.i.has(f)||m===f)break;N++}while(N<=b.length);return f}hb(v){if(v.iconPath&&!(v.iconPath instanceof O.ThemeIcon))return typeof v.iconPath=="string"||L.URI.isUri(v.iconPath)?this.jb(v.iconPath):this.jb(v.iconPath.light)}ib(v){if(v.iconPath&&!(v.iconPath instanceof O.ThemeIcon)&&v.iconPath.dark)return this.jb(v.iconPath.dark)}jb(v){return L.URI.isUri(v)?v:L.URI.file(v)}kb(v,i){this.i.set(i.item.handle,v),this.j.set(v,i)}lb(v,i,a,r){this.i.delete(i.item.handle),this.j.delete(v),i.item.handle!==a.item.handle&&this.i.delete(a.item.handle),this.kb(v,i);const s=this.Q(r)||[],E=s.filter(k=>k.item.handle===a.item.handle)[0];E&&s.splice(s.indexOf(E),1,i)}mb(v,i){i?(i.children||(i.children=[]),i.children.push(v)):(this.h||(this.h=[]),this.h.push(v))}nb(v){if(v){const i=this.j.get(v);if(i){if(i.children)for(const a of i.children){const r=this.i.get(a.item.handle);r&&this.ob(r)}i.children=void 0}}else this.pb()}ob(v){const i=this.j.get(v);if(i){if(i.children)for(const a of i.children){const r=this.i.get(a.item.handle);r&&this.ob(r)}this.j.delete(v),this.i.delete(i.item.handle),i.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(v=>v.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}D.a="0",D.b="1"}),define(Pe[209],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugFocus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugFocus.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",dropMetadata:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.dropMetadata.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envCollectionWorkspace:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envCollectionWorkspace.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",formatMultipleRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.formatMultipleRanges.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",getSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.getSessions.d.ts",handleIssueUri:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.handleIssueUri.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",saveEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.saveEditor.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",semanticSimilarity:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.semanticSimilarity.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Pe[210],Ae([1,0,163,9,29,91,71,30,24,209,173,97]),function(te,e,n,P,I,L,R,A,y,h,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const g=A.Registry.as(R.Extensions.JSONContribution);class S{constructor(v,i,a){this.a=v,this.b=i,this.c=a}d(v,i){this.a({type:v,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(v){this.d(I.default.Error,v)}warn(v){this.d(I.default.Warning,v)}info(v){this.d(I.default.Info,v)}}e.ExtensionMessageCollector=S;class p{static a(v){const i=new y.ExtensionIdentifierSet;for(let a=0,r=v.length;a<r;a++)i.add(v[a].description.identifier);return i}static compute(v,i){if(!v||!v.length)return new p(i,[]);if(!i||!i.length)return new p([],v);const a=this.a(v),r=this.a(i),s=i.filter(k=>!a.has(k.description.identifier)),E=v.filter(k=>!r.has(k.description.identifier));return new p(s,E)}constructor(v,i){this.added=v,this.removed=i}}e.ExtensionPointUserDelta=p;class l{constructor(v,i){this.name=v,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(v){if(this.a!==null)throw new Error("Handler already set!");this.a=v,this.d()}acceptUsers(v){this.c=p.compute(this.b,v),this.b=v,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(v){(0,P.onUnexpectedError)(v)}}}e.ExtensionPoint=l;const t={type:"string",enum:["ui","workspace"],enumDescriptions:[n.localize(0,null),n.localize(1,null)]},o="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:n.localize(2,null),properties:{vscode:{type:"string",description:n.localize(3,null),default:"^1.22.0"}}},publisher:{description:n.localize(4,null),type:"string"},displayName:{description:n.localize(5,null),type:"string"},categories:{description:n.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:n.localize(7,null)}]}},galleryBanner:{type:"object",description:n.localize(8,null),properties:{color:{description:n.localize(9,null),type:"string"},theme:{description:n.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:n.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:n.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:n.localize(13,null)},enabledApiProposals:{markdownDescription:n.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(h.allApiProposals),markdownEnumDescriptions:Object.values(h.allApiProposals)}},api:{markdownDescription:n.localize(15,null),type:"string",enum:["none"],enumDescriptions:[n.localize(16,null)]},activationEvents:{description:n.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:n.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:n.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:n.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:n.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:n.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:n.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:n.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:n.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:n.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:n.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:n.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:n.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:n.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:n.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:n.localize(32,null)},{label:"onUri",body:"onUri",description:n.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:n.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:n.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:n.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:n.localize(37,null)},{label:"onRenderer",description:n.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:n.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:n.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:n.localize(41,null)},{label:"*",description:n.localize(42,null),body:"*"}]}},badges:{type:"array",description:n.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:n.localize(44,null)},href:{type:"string",description:n.localize(45,null)},description:{type:"string",description:n.localize(46,null)}}}},markdown:{type:"string",description:n.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:n.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:n.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:n.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:n.localize(51,null),type:"array",items:t,default:["workspace"],defaultSnippets:[{body:["ui"],description:n.localize(52,null)},{body:["workspace"],description:n.localize(53,null)},{body:["ui","workspace"],description:n.localize(54,null)},{body:["workspace","ui"],description:n.localize(55,null)},{body:[],description:n.localize(56,null)}]},capabilities:{description:n.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:n.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:n.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(60,null),n.localize(61,null),n.localize(62,null)]},description:{type:"string",markdownDescription:n.localize(63,null)}}},untrustedWorkspaces:{description:n.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:n.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[n.localize(66,null),n.localize(67,null),n.localize(68,null)]},restrictedConfigurations:{description:n.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:n.localize(70,null)}}}}},sponsor:{description:n.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:n.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:n.localize(73,null),type:"string"},"vscode:uninstall":{description:n.localize(74,null),type:"string"}}},icon:{type:"string",description:n.localize(75,null)},l10n:{type:"string",description:n.localize(76,null)}}};class d{constructor(){this.a=new Map}registerExtensionPoint(v){if(this.a.has(v.extensionPoint))throw new Error("Duplicate extension point: "+v.extensionPoint);const i=new l(v.extensionPoint,v.defaultExtensionKind);return this.a.set(v.extensionPoint,i),v.activationEventsGenerator&&w.ImplicitActivationEvents.register(v.extensionPoint,v.activationEventsGenerator),e.schema.properties.contributes.properties[v.extensionPoint]=v.jsonSchema,g.registerSchema(o,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=d;const D={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(D.ExtensionsRegistry,new d),e.ExtensionsRegistry=A.Registry.as(D.ExtensionsRegistry),g.registerSchema(o,e.schema),g.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:n.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(h.allApiProposals),markdownEnumDescriptions:Object.values(h.allApiProposals)}}]}}}})}),define(Pe[211],Ae([1,0,160,12,23,210,31,5]),function(te,e,n,P,I,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:n.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:n.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:n.localize(2,null),default:""}}};var h;(function(g){function S(p,l,t){if(!p)return;const o=P.isString(p.type)?p.type:void 0;if(!o||o.length===0){t.error(n.localize(3,null));return}const d=[];if(Array.isArray(p.required))for(const D of p.required)P.isString(D)&&d.push(D);return{extensionId:l.value,taskType:o,required:d,properties:p.properties?I.deepClone(p.properties):{},when:p.when?R.ContextKeyExpr.deserialize(p.when):void 0}}g.from=S})(h||(h={}));const O=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(g,S)=>{for(const p of g)p.type&&S.push(`onTaskType:${p.type}`)},jsonSchema:{description:n.localize(4,null),type:"array",items:y}});class w{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((S,p)=>{O.setHandler((l,t)=>{this.c=void 0;try{for(const o of t.removed){const d=o.value;for(const D of d)this.a&&D.type&&this.a[D.type]&&delete this.a[D.type]}for(const o of t.added){const d=o.value;for(const D of d){const T=h.from(D,o.description.identifier,o.collector);T&&(this.a[T.taskType]=T)}}(t.removed.length>0||t.added.length>0)&&this.d.fire()}catch{}S(void 0)})})}onReady(){return this.b}get(S){return this.a[S]}all(){return Object.keys(this.a).map(S=>this.a[S])}getJsonSchema(){if(this.c===void 0){const S=[];for(const p of this.all()){const l={type:"object",additionalProperties:!1};p.required.length>0&&(l.required=p.required.slice(0)),p.properties!==void 0?l.properties=I.deepClone(p.properties):l.properties=Object.create(null),l.properties.type={type:"string",enum:[p.taskType]},S.push(l)}this.c={oneOf:S}}return this.c}}e.TaskDefinitionRegistry=new w}),define(Pe[212],Ae([1,0,161,12,22,23,31,211]),function(te,e,n,P,I,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new R.RawContextKey("taskRunning",!1,n.localize(0,null)),e.TASKS_CATEGORY={value:n.localize(1,null),original:"Tasks"};var y;(function(B){B[B.Escape=1]="Escape",B[B.Strong=2]="Strong",B[B.Weak=3]="Weak"})(y||(e.ShellQuoting=y={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(B){function X(U){if(!U)return B.Strong;switch(U.toLowerCase()){case"escape":return B.Escape;case"strong":return B.Strong;case"weak":return B.Weak;default:return B.Strong}}B.from=X}(y||(e.ShellQuoting=y={}));var h;(function(B){B.defaults={cwd:"${workspaceFolder}"}})(h||(e.CommandOptions=h={}));var O;(function(B){B[B.Always=1]="Always",B[B.Silent=2]="Silent",B[B.Never=3]="Never"})(O||(e.RevealKind=O={})),function(B){function X(U){switch(U.toLowerCase()){case"always":return B.Always;case"silent":return B.Silent;case"never":return B.Never;default:return B.Always}}B.fromString=X}(O||(e.RevealKind=O={}));var w;(function(B){B[B.Never=1]="Never",B[B.OnProblem=2]="OnProblem",B[B.Always=3]="Always"})(w||(e.RevealProblemKind=w={})),function(B){function X(U){switch(U.toLowerCase()){case"always":return B.Always;case"never":return B.Never;case"onproblem":return B.OnProblem;default:return B.OnProblem}}B.fromString=X}(w||(e.RevealProblemKind=w={}));var g;(function(B){B[B.Shared=1]="Shared",B[B.Dedicated=2]="Dedicated",B[B.New=3]="New"})(g||(e.PanelKind=g={})),function(B){function X(U){switch(U.toLowerCase()){case"shared":return B.Shared;case"dedicated":return B.Dedicated;case"new":return B.New;default:return B.Shared}}B.fromString=X}(g||(e.PanelKind=g={}));var S;(function(B){B.defaults={echo:!0,reveal:O.Always,revealProblems:w.Never,focus:!1,panel:g.Shared,showReuseMessage:!0,clear:!1}})(S||(e.PresentationOptions=S={}));var p;(function(B){B[B.Shell=1]="Shell",B[B.Process=2]="Process",B[B.CustomExecution=3]="CustomExecution"})(p||(e.RuntimeType=p={})),function(B){function X(j){switch(j.toLowerCase()){case"shell":return B.Shell;case"process":return B.Process;case"customExecution":return B.CustomExecution;default:return B.Process}}B.fromString=X;function U(j){switch(j){case B.Shell:return"shell";case B.Process:return"process";case B.CustomExecution:return"customExecution";default:return"process"}}B.toString=U}(p||(e.RuntimeType=p={}));var l;(function(B){function X(U){return P.isString(U)?U:U.value}B.value=X})(l||(e.CommandString=l={}));var t;(function(B){B.Clean={_id:"clean",isDefault:!1},B.Build={_id:"build",isDefault:!1},B.Rebuild={_id:"rebuild",isDefault:!1},B.Test={_id:"test",isDefault:!1};function X(j){return j===B.Clean._id||j===B.Build._id||j===B.Rebuild._id||j===B.Test._id}B.is=X;function U(j){if(j!==void 0)return P.isString(j)?X(j)?{_id:j,isDefault:!1}:void 0:j}B.from=U})(t||(e.TaskGroup=t={}));var o;(function(B){B[B.Global=1]="Global",B[B.Workspace=2]="Workspace",B[B.Folder=3]="Folder"})(o||(e.TaskScope=o={}));var d;(function(B){B.Workspace="workspace",B.Extension="extension",B.InMemory="inMemory",B.WorkspaceFile="workspaceFile",B.User="user";function X(U){switch(U){case B.User:return 2;case B.WorkspaceFile:return 5;default:return 6}}B.toConfigurationTarget=X})(d||(e.TaskSourceKind=d={}));var D;(function(B){B.parallel="parallel",B.sequence="sequence"})(D||(e.DependsOrder=D={}));var T;(function(B){B[B.default=1]="default",B[B.folderOpen=2]="folderOpen"})(T||(e.RunOnOptions=T={}));var v;(function(B){B.defaults={reevaluateOnRerun:!0,runOn:T.default,instanceLimit:1}})(v||(e.RunOptions=v={}));class i{constructor(X,U,j,Y,pe,Ee){this._label="",this._id=X,U&&(this._label=U),j&&(this.type=j),this.runOptions=Y,this.configurationProperties=pe,this._source=Ee}getDefinition(X){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const X={folder:this.d(),id:this._id};return JSON.stringify(X)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(X,U=!1){if(X===void 0)return!1;if(P.isString(X))return X===this._label||X===this.configurationProperties.identifier||U&&X===this._id;const j=this.getDefinition(!0);return j!==void 0&&j._key===X._key}getQualifiedLabel(){const X=this.getWorkspaceFolder();return X?`${this._label} (${X.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(X){this.c===void 0&&(this.c=[]),X&&(this.c=this.c.concat(X))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class a extends i{constructor(X,U,j,Y,pe,Ee,he,de){super(X,j,void 0,he,de,U),this.command={},this._source=U,this.hasDefinedMatchers=Ee,pe&&(this.command=pe)}clone(){return new a(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(X=!1){if(X&&this._source.customizes!==void 0)return this._source.customizes;{let U;switch(this.command?this.command.runtime:void 0){case p.Shell:U="shell";break;case p.Process:U="process";break;case p.CustomExecution:U="customExecution";break;case void 0:U="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:U,_key:this._id,id:this._id}}}static is(X){return X instanceof a}getMapKey(){const X=this._source.config.workspaceFolder;return X?`${X.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===d.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const X=this.d();if(!X)return;let U=this.configurationProperties.identifier;this._source.kind!==d.Workspace&&(U+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:X,id:U};return JSON.stringify(j)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(X){return new a(X._id,X._source,X._label,X.type,X.command,X.hasDefinedMatchers,X.runOptions,X.configurationProperties)}}e.CustomTask=a;class r extends i{constructor(X,U,j,Y,pe,Ee,he){super(X,j,Y,Ee,he,U),this._source=U,this.configures=pe}static is(X){return X instanceof r}f(X){return X}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?I.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===d.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const X=this.d();if(!X)return;let U=this.configurationProperties.identifier;this._source.kind!==d.Workspace&&(U+=this._source.kind);const j={type:e.CUSTOMIZED_TASK_TYPE,folder:X,id:U};return JSON.stringify(j)}}e.ConfiguringTask=r;class s extends i{constructor(X,U,j,Y,pe,Ee,he,de,Re){super(X,j,Y,de,Re,U),this.defines=pe,this.hasDefinedMatchers=he,this.command=Ee,this.icon=Re.icon,this.hide=Re.hide}clone(){return new s(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(X){return X instanceof s}getMapKey(){const X=this._source.workspaceFolder;return X?`${this._source.scope.toString()}|${X.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const X={type:"contributed",scope:this._source.scope,id:this._id};return X.folder=this.d(),JSON.stringify(X)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(X){return new s(X._id,X._source,X._label,X.type,X.defines,X.command,X.hasDefinedMatchers,X.runOptions,X.configurationProperties)}}e.ContributedTask=s;class E extends i{constructor(X,U,j,Y,pe,Ee){super(X,j,Y,pe,Ee,U),this._source=U}clone(){return new E(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(X){return X instanceof E}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(X){return new E(X._id,X._source,X._label,X.type,X.runOptions,X.configurationProperties)}}e.InMemoryTask=E;var k;(function(B){B[B.Process=1]="Process",B[B.Terminal=2]="Terminal"})(k||(e.ExecutionEngine=k={})),function(B){B._default=B.Terminal}(k||(e.ExecutionEngine=k={}));var c;(function(B){B[B.V0_1_0=1]="V0_1_0",B[B.V2_0_0=2]="V2_0_0"})(c||(e.JsonSchemaVersion=c={}));class u{constructor(X){this.c=new Map;for(let U=0;U<X.length;U++)this.c.set(X[U].uri.toString(),U)}compare(X,U){const j=X.getWorkspaceFolder(),Y=U.getWorkspaceFolder();if(j&&Y){let pe=this.c.get(j.uri.toString());pe=pe===void 0?0:pe+1;let Ee=this.c.get(Y.uri.toString());return Ee=Ee===void 0?0:Ee+1,pe===Ee?X._label.localeCompare(U._label):pe-Ee}else return!j&&Y?-1:j&&!Y?1:0}}e.TaskSorter=u;var m;(function(B){B.DependsOnStarted="dependsOnStarted",B.AcquiredInput="acquiredInput",B.Start="start",B.ProcessStarted="processStarted",B.Active="active",B.Inactive="inactive",B.Changed="changed",B.Terminated="terminated",B.ProcessEnded="processEnded",B.End="end"})(m||(e.TaskEventKind=m={}));var b;(function(B){B.SingleRun="singleRun",B.Background="background"})(b||(e.TaskRunType=b={}));var f;(function(B){B[B.System=0]="System",B[B.User=1]="User",B[B.FolderOpen=2]="FolderOpen",B[B.ConfigurationChange=3]="ConfigurationChange",B[B.Reconnect=4]="Reconnect"})(f||(e.TaskRunSource=f={}));var N;(function(B){function X(U,j,Y,pe){if(j){const Ee={kind:U,taskId:j._id,taskName:j.configurationProperties.name,runType:j.configurationProperties.isBackground?"background":"singleRun",group:j.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:Y,__task:j};return U==="start"?Ee.resolvedVariables=pe:U==="processStarted"?Ee.processId=pe:U==="processEnded"&&(Ee.exitCode=pe),Object.freeze(Ee)}else return Object.freeze({kind:"changed"})}B.create=X})(N||(e.TaskEvent=N={}));var V;(function(B){function X(j){const Y=Object.keys(j).sort();let pe="";for(const Ee of Y){let he=j[Ee];he instanceof Object?he=X(he):typeof he=="string"&&(he=he.replace(/,/g,",,")),pe+=Ee+","+he+","}return pe}function U(j){const pe={_key:X(j),type:j.taskType};return Object.assign(pe,j),pe}B.create=U})(V||(e.KeyedTaskIdentifier=V={}));var _;(function(B){B.AutoDetect="task.autoDetect",B.SaveBeforeRun="task.saveBeforeRun",B.ShowDecorations="task.showDecorations",B.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",B.SlowProviderWarning="task.slowProviderWarning",B.QuickOpenHistory="task.quickOpen.history",B.QuickOpenDetail="task.quickOpen.detail",B.QuickOpenSkip="task.quickOpen.skip",B.QuickOpenShowAll="task.quickOpen.showAll",B.AllowAutomaticTasks="task.allowAutomaticTasks",B.Reconnection="task.reconnection"})(_||(e.TaskSettingId=_={}));var G;(function(B){B.Tasks="tasks",B.SuppressTaskName="tasks.suppressTaskName",B.Windows="tasks.windows",B.Osx="tasks.osx",B.Linux="tasks.linux",B.ShowOutput="tasks.showOutput",B.IsShellCommand="tasks.isShellCommand",B.ServiceTestSetting="tasks.service.testSetting"})(G||(e.TasksSchemaProperties=G={}));var $;(function(B){function X(U,j){const Y=A.TaskDefinitionRegistry.get(U.type);if(Y===void 0){const de=L.deepClone(U);return delete de._key,V.create(de)}const pe=Object.create(null);pe.type=Y.taskType;const Ee=new Set;Y.required.forEach(de=>Ee.add(de));const he=Y.properties;for(const de of Object.keys(he)){const Re=U[de];if(Re!=null)pe[de]=Re;else if(Ee.has(de)){const le=he[de];if(le.default!==void 0)pe[de]=L.deepClone(le.default);else switch(le.type){case"boolean":pe[de]=!1;break;case"number":case"integer":pe[de]=0;break;case"string":pe[de]="";break;default:j.error(n.localize(2,null,JSON.stringify(U,void 0,0),de));return}}}return V.create(pe)}B.createTaskIdentifier=X})($||(e.TaskDefinition=$={}))}),define(Pe[213],Ae([1,0,9]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class P{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((R,A)=>{this.b=R,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(R){this.f||this.h||(this.f=!0,this.g=R,this.a&&this.b(R))}resolveErr(R){this.f||this.h||(this.h=!0,this.i=R,this.a?this.d(R):(0,n.onUnexpectedError)(R))}then(R,A){return this.j().then(R,A)}catch(R){return this.j().then(void 0,R)}finally(R){return this.j().finally(R)}}e.LazyPromise=P;class I extends P{constructor(){super(),this.h=!0,this.i=new n.CancellationError}}e.CanceledLazyPromise=I}),define(Pe[46],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class n{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++n.count}}e.ProxyIdentifier=n,n.count=0;const P=[];function I(A){const y=new n(A);return P[y.nid]=y,y}e.createProxyIdentifier=I;function L(A){return P[A].sid}e.getStringIdentifierForProxy=L;class R{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=R}),define(Pe[4],Ae([1,0,46]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var P;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(P||(e.TextEditorRevealType=P={}));var I;(function(l){l[l.UnknownInput=0]="UnknownInput",l[l.TextInput=1]="TextInput",l[l.TextDiffInput=2]="TextDiffInput",l[l.TextMergeInput=3]="TextMergeInput",l[l.NotebookInput=4]="NotebookInput",l[l.NotebookDiffInput=5]="NotebookDiffInput",l[l.CustomEditorInput=6]="CustomEditorInput",l[l.WebviewEditorInput=7]="WebviewEditorInput",l[l.TerminalEditorInput=8]="TerminalEditorInput",l[l.InteractiveEditorInput=9]="InteractiveEditorInput"})(I||(e.TabInputKind=I={}));var L;(function(l){l[l.TAB_OPEN=0]="TAB_OPEN",l[l.TAB_CLOSE=1]="TAB_CLOSE",l[l.TAB_UPDATE=2]="TAB_UPDATE",l[l.TAB_MOVE=3]="TAB_MOVE"})(L||(e.TabModelOperationKind=L={}));var R;(function(l){l[l.Editable=0]="Editable",l[l.SupportsHotExit=1]="SupportsHotExit"})(R||(e.WebviewEditorCapabilities=R={}));var A;(function(l){l[l.Int8Array=1]="Int8Array",l[l.Uint8Array=2]="Uint8Array",l[l.Uint8ClampedArray=3]="Uint8ClampedArray",l[l.Int16Array=4]="Int16Array",l[l.Uint16Array=5]="Uint16Array",l[l.Int32Array=6]="Int32Array",l[l.Uint32Array=7]="Uint32Array",l[l.Float32Array=8]="Float32Array",l[l.Float64Array=9]="Float64Array",l[l.BigInt64Array=10]="BigInt64Array",l[l.BigUint64Array=11]="BigUint64Array"})(A||(e.WebviewMessageArrayBufferViewType=A={}));var y;(function(l){l[l.Text=1]="Text",l[l.Error=2]="Error",l[l.Rich=3]="Rich"})(y||(e.CellOutputKind=y={}));var h;(function(l){l[l.Default=0]="Default",l[l.InCenter=1]="InCenter",l[l.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",l[l.AtTop=3]="AtTop"})(h||(e.NotebookEditorRevealType=h={}));var O;(function(l){l[l.None=0]="None",l[l.Process=1]="Process",l[l.Output=2]="Output"})(O||(e.CandidatePortSource=O={}));class w{static mixin(t){return t._id=w.a++,t}}e.IdObject=w,w.a=0;var g;(function(l){l.label="a",l.kind="b",l.detail="c",l.documentation="d",l.sortText="e",l.filterText="f",l.preselect="g",l.insertText="h",l.insertTextRules="i",l.range="j",l.commitCharacters="k",l.additionalTextEdits="l",l.kindModifier="m",l.commandIdent="n",l.commandId="o",l.commandArguments="p"})(g||(e.ISuggestDataDtoField=g={}));var S;(function(l){l.defaultRanges="a",l.completions="b",l.isIncomplete="c",l.duration="d"})(S||(e.ISuggestResultDtoField=S={}));var p;(function(l){l[l.Workspace=0]="Workspace",l[l.TextDocument=1]="TextDocument"})(p||(e.ExtHostTestingResource=p={})),e.MainContext={MainThreadAuthentication:(0,n.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,n.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,n.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,n.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,n.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,n.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,n.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,n.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,n.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,n.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,n.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,n.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,n.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,n.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,n.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,n.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,n.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,n.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,n.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,n.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,n.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,n.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,n.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,n.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,n.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,n.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,n.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,n.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,n.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,n.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,n.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,n.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,n.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,n.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,n.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,n.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,n.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,n.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,n.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,n.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,n.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,n.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,n.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,n.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,n.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,n.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,n.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,n.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,n.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,n.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,n.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,n.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,n.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,n.createProxyIdentifier)("MainThreadInteractive"),MainThreadInteractiveSession:(0,n.createProxyIdentifier)("MainThreadInteractiveSession"),MainThreadInteractiveEditor:(0,n.createProxyIdentifier)("MainThreadInteractiveEditor"),MainThreadTheming:(0,n.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,n.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,n.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,n.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,n.createProxyIdentifier)("MainThreadLocalizationShape"),MainThreadSemanticSimilarity:(0,n.createProxyIdentifier)("MainThreadSemanticSimilarity"),MainThreadIssueReporter:(0,n.createProxyIdentifier)("MainThreadIssueReporter")},e.ExtHostContext={ExtHostCommands:(0,n.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,n.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,n.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,n.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,n.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,n.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,n.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,n.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,n.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,n.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,n.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,n.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,n.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,n.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,n.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,n.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,n.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,n.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,n.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,n.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,n.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,n.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,n.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,n.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,n.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,n.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,n.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,n.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,n.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,n.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,n.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,n.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,n.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,n.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,n.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,n.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,n.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,n.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,n.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,n.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,n.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,n.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,n.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,n.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,n.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,n.createProxyIdentifier)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,n.createProxyIdentifier)("ExtHostInteractive"),ExtHostInteractiveEditor:(0,n.createProxyIdentifier)("ExtHostInteractiveEditor"),ExtHostInteractiveSession:(0,n.createProxyIdentifier)("ExtHostInteractiveSession"),ExtHostSemanticSimilarity:(0,n.createProxyIdentifier)("ExtHostSemanticSimilarity"),ExtHostTheming:(0,n.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,n.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,n.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,n.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,n.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,n.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,n.createProxyIdentifier)("ExtHostLocalization"),ExtHostIssueReporter:(0,n.createProxyIdentifier)("ExtHostIssueReporter")}}),define(Pe[78],Ae([1,0,3,14,4,18]),function(te,e,n,P,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,n.createDecorator)("IExtHostApiDeprecationService");let R=e.ExtHostApiDeprecationService=class{constructor(y,h){this.c=h,this.a=new Set,this.b=y.getProxy(I.MainContext.MainThreadTelemetry)}report(y,h,O){const w=this.d(y,h);this.a.has(w)||(this.a.add(w),h.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:h.identifier.value,apiId:y}))}d(y,h){return`${y}-${h.identifier.value}`}};e.ExtHostApiDeprecationService=R=xe([qe(0,L.IExtHostRpcService),qe(1,P.ILogService)],R),e.NullApiDeprecationService=Object.freeze(new class{report(A,y,h){}})}),define(Pe[214],Ae([1,0,5,4,7,24]),function(te,e,n,P,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(h){this.b=new Map,this.c=[],this.d=new n.Emitter,this.onDidChangeSessions=this.d.event,this.f=new A,this.g=new A,this.a=h.getProxy(P.MainContext.MainThreadAuthentication)}$setProviders(h){return this.c=h,Promise.resolve()}async getSession(h,O,w,g={}){const S=L.ExtensionIdentifier.toKey(h.identifier),p=[...w].sort().join(" ");return await this.f.getOrCreate(`${S} ${O} ${p}`,async()=>{await this.a.$ensureProvider(O);const l=h.displayName||h.name;return this.a.$getSession(O,w,S,l,g)})}async getSessions(h,O,w){const g=L.ExtensionIdentifier.toKey(h.identifier),S=[...w].sort().join(" ");return await this.g.getOrCreate(`${g} ${S}`,async()=>{await this.a.$ensureProvider(O);const p=h.displayName||h.name;return this.a.$getSessions(O,w,g,p)})}async removeSession(h,O){const w=this.b.get(h);return w?w.provider.removeSession(O):this.a.$removeSession(h,O)}registerAuthenticationProvider(h,O,w,g){if(this.b.get(h))throw new Error(`An authentication provider with id '${h}' is already registered.`);this.b.set(h,{label:O,provider:w,options:g??{supportsMultipleAccounts:!1}}),this.c.find(p=>p.id===h)||this.c.push({id:h,label:O});const S=w.onDidChangeSessions(p=>{this.a.$sendDidChangeSessions(h,{added:p.added??[],changed:p.changed??[],removed:p.removed??[]})});return this.a.$registerAuthenticationProvider(h,O,g?.supportsMultipleAccounts??!1),new I.Disposable(()=>{S.dispose(),this.b.delete(h);const p=this.c.findIndex(l=>l.id===h);p>-1&&this.c.splice(p),this.a.$unregisterAuthenticationProvider(h)})}$createSession(h,O){const w=this.b.get(h);if(w)return Promise.resolve(w.provider.createSession(O));throw new Error(`Unable to find authentication provider with handle: ${h}`)}$removeSession(h,O){const w=this.b.get(h);if(w)return Promise.resolve(w.provider.removeSession(O));throw new Error(`Unable to find authentication provider with handle: ${h}`)}$getSessions(h,O){const w=this.b.get(h);if(w)return Promise.resolve(w.provider.getSessions(O));throw new Error(`Unable to find authentication provider with handle: ${h}`)}$onDidChangeAuthenticationSessions(h,O){return this.d.fire({provider:{id:h,label:O}}),Promise.resolve()}}e.ExtHostAuthentication=R;class A{constructor(){this.a=new Map}getOrCreate(h,O){const w=this.a.get(h);if(w)return w;const g=O().finally(()=>this.a.delete(h));return this.a.set(h,g),g}}}),define(Pe[215],Ae([1,0,4,18,8]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let L=e.ExtHostBulkEdits=class{constructor(A,y){this.a=A.getProxy(n.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:h=>y.getDocument(h)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,h){const O=I.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,h?.isRefactoring??!1)}};e.ExtHostBulkEdits=L=xe([qe(0,P.IExtHostRpcService)],L)}),define(Pe[216],Ae([1,0,4]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class P{constructor(L){const R=L.getProxy(n.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(A){return R.$writeText(A)}})}}e.ExtHostClipboard=P});var _e=this&&this.__classPrivateFieldSet||function(te,e,n,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(te,n):I?I.value=n:e.set(te,n),n},Ne=this&&this.__classPrivateFieldGet||function(te,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(te):P?P.value:e.get(te)};define(Pe[38],Ae([1,0,12,7,8,23,4,16,14,67,44,270,2,6,3,18,104,25,46,40,58,52,57]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t,o,d,D,T,v,i){"use strict";var a,r,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let E=e.ExtHostCommands=class{constructor(f,N,V){a.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),s.set(this,void 0),_e(this,a,f.getProxy(R.MainContext.MainThreadCommands),"f"),this.d=N,_e(this,s,V,"f"),_e(this,r,f.getProxy(R.MainContext.MainThreadTelemetry),"f"),this.converter=new k(this,_=>{const G=this.c.get(_);return G?.result===u.Void?G:void 0},N),this.f=[{processArgument(_){return(0,h.revive)(_)}},{processArgument(_){return(0,L.cloneAndChange)(_,function(G){if(O.Range.isIRange(G))return I.Range.to(G);if(w.Position.isIPosition(G))return I.Position.to(G);if(O.Range.isIRange(G.range)&&g.URI.isUri(G.uri))return I.location.to(G);if(G instanceof o.VSBuffer)return G.buffer.buffer;if(!Array.isArray(G))return G})}}]}registerArgumentProcessor(f){this.f.push(f)}registerApiCommand(f){const N=this.registerCommand(!1,f.id,async(...V)=>{const _=f.args.map(($,B)=>{if(!$.validate(V[B]))throw new Error(`Invalid argument '${$.name}' when running '${f.id}', received: ${V[B]}`);return $.convert(V[B])}),G=await this.executeCommand(f.internalId,..._);return f.result.convert(G,V,this.converter)},void 0,{description:f.description,args:f.args,returns:f.result.description});return this.c.set(f.id,f),new P.Disposable(()=>{N.dispose(),this.c.delete(f.id)})}registerCommand(f,N,V,_,G,$){if(this.d.trace("ExtHostCommands#registerCommand",N),!N.trim().length)throw new Error("invalid id");if(this.b.has(N))throw new Error(`command '${N}' already exists`);return this.b.set(N,{callback:V,thisArg:_,description:G,extension:$}),f&&Ne(this,a,"f").$registerCommand(N),new P.Disposable(()=>{this.b.delete(N)&&f&&Ne(this,a,"f").$unregisterCommand(N)})}executeCommand(f,...N){return this.d.trace("ExtHostCommands#executeCommand",f),this.g(f,N,!0)}async g(f,N,V){if(this.b.has(f))return Ne(this,a,"f").$fireCommandActivationEvent(f),this.h(f,N,!1);{let _=!1;const G=(0,L.cloneAndChange)(N,function($){if($ instanceof P.Position)return I.Position.from($);if($ instanceof P.Range)return I.Range.from($);if($ instanceof P.Location)return I.location.from($);if(P.NotebookRange.isNotebookRange($))return I.NotebookRange.from($);if($ instanceof ArrayBuffer)return _=!0,o.VSBuffer.wrap(new Uint8Array($));if($ instanceof Uint8Array)return _=!0,o.VSBuffer.wrap($);if($ instanceof o.VSBuffer)return _=!0,$;if(!Array.isArray($))return $});try{const $=await Ne(this,a,"f").$executeCommand(f,_?new d.SerializableObjectWithBuffers(G):G,V);return(0,h.revive)($)}catch($){if($ instanceof Error&&$.message==="$executeCommand:retry")return this.g(f,N,!1);throw $}}}async h(f,N,V){const _=this.b.get(f);if(!_)throw new Error("Unknown command");const{callback:G,thisArg:$,description:B}=_;if(B)for(let U=0;U<B.args.length;U++)try{(0,n.validateConstraint)(N[U],B.args[U].constraint)}catch{throw new Error(`Running the contributed command: '${f}' failed. Illegal argument '${B.args[U].name}' - ${B.args[U].description}`)}const X=T.StopWatch.create();try{return await G.apply($,N)}catch(U){if(f===this.converter.delegatingCommandId){const j=this.converter.getActualCommand(...N);j&&(f=j.command)}if(this.d.error(U,f,_.extension?.identifier),!V)throw U;if(_.extension?.identifier){const j=Ne(this,s,"f").onExtensionError(_.extension.identifier,U);this.d.trace("forwarded error to extension?",j,_.extension?.identifier)}throw new class extends Error{constructor(){super((0,D.toErrorMessage)(U)),this.id=f,this.source=_.extension?.displayName??_.extension?.name}}}finally{this.j(_,f,X.elapsed())}}j(f,N,V){f.extension&&Ne(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:f.extension.identifier.value,id:new v.TelemetryTrustedValue(N),duration:V})}$executeContributedCommand(f,...N){this.d.trace("ExtHostCommands#$executeContributedCommand",f);const V=this.b.get(f);return V?(N=N.map(_=>this.f.reduce((G,$)=>$.processArgument(G,V.extension?.identifier),_)),this.h(f,N,!0)):Promise.reject(new Error(`Contributed command '${f}' does not exist.`))}getCommands(f=!1){return this.d.trace("ExtHostCommands#getCommands",f),Ne(this,a,"f").$getCommands().then(N=>(f&&(N=N.filter(V=>V[0]!=="_")),N))}$getContributedCommandHandlerDescriptions(){const f=Object.create(null);for(const[N,V]of this.b){const{description:_}=V;_&&(f[N]=_)}return Promise.resolve(f)}};a=new WeakMap,r=new WeakMap,s=new WeakMap,e.ExtHostCommands=E=xe([qe(0,l.IExtHostRpcService),qe(1,y.ILogService),qe(2,i.IExtHostTelemetry)],E),e.IExtHostCommands=(0,p.createDecorator)("IExtHostCommands");class k{constructor(f,N,V){this.d=f,this.f=N,this.g=V,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(f,N){if(!f)return;const V={$ident:void 0,id:f.command,title:f.title,tooltip:f.tooltip};if(!f.command)return V;const _=this.f(f.command);if(_)V.id=_.internalId,V.arguments=_.args.map((G,$)=>G.convert(f.arguments&&f.arguments[$]));else if((0,A.isNonEmptyArray)(f.arguments)){const G=`${f.command}/${++this.c}`;this.b.set(G,f),N.add((0,S.toDisposable)(()=>{this.b.delete(G),this.g.trace("CommandsConverter#DISPOSE",G)})),V.$ident=G,V.id=this.delegatingCommandId,V.arguments=[G],this.g.trace("CommandsConverter#CREATE",f.command,G)}return V}fromInternal(f){return typeof f.$ident=="string"?this.b.get(f.$ident):{command:f.id,title:f.title,arguments:f.arguments}}getActualCommand(...f){return this.b.get(f[0])}h(...f){const N=this.getActualCommand(...f);return this.g.trace("CommandsConverter#EXECUTE",f[0],N?N.command:"MISSING"),N?this.d.executeCommand(N.command,...N.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${f[0]}`)}}e.CommandsConverter=k;class c{constructor(f,N,V,_){this.name=f,this.description=N,this.validate=V,this.convert=_}optional(){return new c(this.name,`(optional) ${this.description}`,f=>f==null||this.validate(f),f=>f===void 0?void 0:f===null?null:this.convert(f))}with(f,N){return new c(f??this.name,N??this.description,this.validate,this.convert)}}e.ApiCommandArgument=c,c.Uri=new c("uri","Uri of a text document",b=>g.URI.isUri(b),b=>b),c.Position=new c("position","A position in a text document",b=>P.Position.isPosition(b),I.Position.from),c.Range=new c("range","A range in a text document",b=>P.Range.isRange(b),I.Range.from),c.Selection=new c("selection","A selection in a text document",b=>P.Selection.isSelection(b),I.Selection.from),c.Number=new c("number","",b=>typeof b=="number",b=>b),c.String=new c("string","",b=>typeof b=="string",b=>b),c.CallHierarchyItem=new c("item","A call hierarchy item",b=>b instanceof P.CallHierarchyItem,I.CallHierarchyItem.from),c.TypeHierarchyItem=new c("item","A type hierarchy item",b=>b instanceof P.TypeHierarchyItem,I.TypeHierarchyItem.from),c.TestItem=new c("testItem","A VS Code TestItem",b=>b instanceof t.TestItemImpl,I.TestItem.from);class u{constructor(f,N){this.description=f,this.convert=N}}e.ApiCommandResult=u,u.Void=new u("no result",b=>b);class m{constructor(f,N,V,_,G){this.id=f,this.internalId=N,this.description=V,this.args=_,this.result=G}}e.ApiCommand=m}),define(Pe[217],Ae([1,0,16,15,2,77,90,31,94,38,8,7]),function(te,e,n,P,I,L,R,A,y,h,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const g=[new h.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",p(O.DocumentHighlight.to))),new h.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(t,o)=>{if((0,n.isFalsyOrEmpty)(t))return;class d extends w.SymbolInformation{static to(T){const v=new d(T.name,O.SymbolKind.to(T.kind),T.containerName||"",new w.Location(o[0],O.Range.to(T.range)));return v.detail=T.detail,v.range=v.location.range,v.selectionRange=O.Range.to(T.selectionRange),v.children=T.children?T.children.map(d.to):[],v}}return t.map(d.to)})),new h.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(O.TextEdit.to))),new h.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range,new h.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(O.TextEdit.to))),new h.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,new h.ApiCommandArgument("ch","Trigger character",t=>typeof t=="string",t=>t),new h.ApiCommandArgument("options","Formatting options",t=>!0,t=>t)],new h.ApiCommandResult("A promise that resolves to an array of TextEdits.",p(O.TextEdit.to))),new h.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new h.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new h.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new h.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",l)),new h.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Location-instances.",p(O.location.to))),new h.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of Hover-instances.",p(O.Hover.to))),new h.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("position","A position in a text document",t=>Array.isArray(t)&&t.every(o=>w.Position.isPosition(o)),t=>t.map(O.Position.from))],new h.ApiCommandResult("A promise that resolves to an array of ranges.",t=>t.map(o=>{let d;for(const D of o.reverse())d=new w.SelectionRange(O.Range.to(D),d);return d}))),new h.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[h.ApiCommandArgument.String.with("query","Search string")],new h.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",t=>t.map(O.WorkspaceSymbol.to))),new h.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",t=>t.map(O.CallHierarchyItem.to))),new h.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[h.ApiCommandArgument.CallHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",t=>t.map(O.CallHierarchyIncomingCall.to))),new h.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[h.ApiCommandArgument.CallHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",t=>t.map(O.CallHierarchyOutgoingCall.to))),new h.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to a range and placeholder text.",t=>{if(t)return{range:O.Range.to(t.range),placeholder:t.text}})),new h.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("newName","The new symbol name")],new h.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",t=>{if(t){if(t.rejectReason)throw new Error(t.rejectReason);return O.WorkspaceEdit.to(t)}})),new h.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new h.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",t=>t.map(O.DocumentLink.to))),new h.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new w.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new h.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const o=(0,R.decodeSemanticTokensDto)(t);if(o.type==="full")return new w.SemanticTokens(o.data,void 0)})),new h.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range.optional()],new h.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",t=>{if(t)return new w.SemanticTokensLegend(t.tokenTypes,t.tokenModifiers)})),new h.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to SemanticTokens.",t=>{if(!t)return;const o=(0,R.decodeSemanticTokensDto)(t);if(o.type==="full")return new w.SemanticTokens(o.data,void 0)})),new h.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),h.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new h.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(t,o,d)=>{if(!t)return new w.CompletionList([]);const D=t.suggestions.map(T=>O.CompletionItem.to(T,d));return new w.CompletionList(D,t.incomplete)})),new h.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position,h.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new h.ApiCommandResult("A promise that resolves to SignatureHelp.",t=>{if(t)return O.SignatureHelp.to(t)})),new h.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new h.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(t,o,d)=>p(D=>new w.CodeLens(O.Range.to(D.range),D.command&&d.fromInternal(D.command)))(t))),new h.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[h.ApiCommandArgument.Uri,new h.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",t=>w.Range.isRange(t),t=>w.Selection.isSelection(t)?O.Selection.from(t):O.Range.from(t)),h.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),h.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new h.ApiCommandResult("A promise that resolves to an array of Command-instances.",(t,o,d)=>p(D=>{if(D._isSynthetic){if(!D.command)throw new Error("Synthetic code actions must have a command");return d.fromInternal(D.command)}else{const T=new w.CodeAction(D.title,D.kind?new w.CodeActionKind(D.kind):void 0);return D.edit&&(T.edit=O.WorkspaceEdit.to(D.edit)),D.command&&(T.command=d.fromInternal(D.command)),T.isPreferred=D.isPreferred,T}})(t))),new h.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",t=>t?t.map(o=>new w.ColorInformation(O.Range.to(o.range),O.Color.to(o.color))):[])),new h.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new h.ApiCommandArgument("color","The color to show and insert",t=>t instanceof w.Color,O.Color.from),new h.ApiCommandArgument("context","Context object with uri and range",t=>!0,t=>({uri:t.uri,range:O.Range.from(t.range)}))],new h.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",t=>t?t.map(O.ColorPresentation.to):[])),new h.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to an array of Inlay objects",(t,o,d)=>t.map(O.InlayHint.to.bind(void 0,d)))),new h.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[h.ApiCommandArgument.Uri],new h.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(t,o)=>{if(t)return t.map(O.FoldingRange.to)})),new h.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new h.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",p(t=>({viewType:t.viewType,displayName:t.displayName,options:{transientOutputs:t.options.transientOutputs,transientCellMetadata:t.options.transientCellMetadata,transientDocumentMetadata:t.options.transientDocumentMetadata},filenamePattern:t.filenamePattern.map(o=>O.NotebookExclusiveDocumentPattern.to(o))})))),new h.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Range],new h.ApiCommandResult("A promise that resolves to an array of InlineValue objects",t=>t.map(O.InlineValue.to))),new h.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new h.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",t=>I.URI.isUri(t)||typeof t=="string"&&(0,y.matchesSomeScheme)(t,P.Schemas.http,P.Schemas.https),t=>t),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[O.ViewColumn.from(t),void 0]:[O.ViewColumn.from(t.viewColumn),O.TextEditorOpenOptions.from(t)])).optional(),h.ApiCommandArgument.String.with("label","").optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[h.ApiCommandArgument.Uri.with("resource","Resource to open"),h.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="number"||typeof t=="object",t=>t&&(typeof t=="number"?[O.ViewColumn.from(t),void 0]:[O.ViewColumn.from(t.viewColumn),O.TextEditorOpenOptions.from(t)])).optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[h.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),h.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),h.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new h.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",t=>t===void 0||typeof t=="object",t=>t&&[O.ViewColumn.from(t.viewColumn),O.TextEditorOpenOptions.from(t)]).optional()],h.ApiCommandResult.Void),new h.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[h.ApiCommandArgument.Uri,h.ApiCommandArgument.Position],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(O.TypeHierarchyItem.to))),new h.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[h.ApiCommandArgument.TypeHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(O.TypeHierarchyItem.to))),new h.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[h.ApiCommandArgument.TypeHierarchyItem],new h.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",t=>t.map(O.TypeHierarchyItem.to))),new h.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[h.ApiCommandArgument.TestItem],h.ApiCommandResult.Void),new h.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[h.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],h.ApiCommandResult.Void),new h.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[h.ApiCommandArgument.String.with("name","The context key name"),new h.ApiCommandArgument("value","The context key value",()=>!0,t=>t)],h.ApiCommandResult.Void)];class S{static register(o){g.forEach(o.registerApiCommand,o),this.a(o)}static a(o){o.registerCommand(!1,"_validateWhenClauses",A.validateWhenClauses)}}e.ExtHostApiCommands=S;function p(t){return o=>{if(Array.isArray(o))return o.map(t)}}function l(t){if(!Array.isArray(t))return;const o=[];for(const d of t)L.isLocationLink(d)?o.push(O.DefinitionLink.to(d)):o.push(O.location.to(d));return o}}),define(Pe[218],Ae([1,0,17,65,5,6,2,77,24,8,7,4,26,12]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function p(l,t,o){const d=l.getProxy(w.MainContext.MainThreadComments);class D{constructor(){this.b=new Map,this.c=new y.ExtensionIdentifierMap,t.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const u=this.b.get(c.handle);return u?u.value:c}else if(c&&c.$mid===7){const u=this.b.get(c.commentControlHandle);if(!u)return c;const m=u.getCommentThread(c.commentThreadHandle);return m?m.value:c}else if(c&&(c.$mid===9||c.$mid===8)){const u=this.b.get(c.thread.commentControlHandle);if(!u)return c;const m=u.getCommentThread(c.thread.commentThreadHandle);return m?c.$mid===8?m.value:{thread:m.value,text:c.text}:c}else if(c&&c.$mid===10){const u=this.b.get(c.thread.commentControlHandle);if(!u)return c;const m=u.getCommentThread(c.thread.commentThreadHandle);if(!m)return c;const b=c.commentUniqueId,f=m.getCommentByUniqueId(b);return f||c}else if(c&&c.$mid===11){const u=this.b.get(c.thread.commentControlHandle);if(!u)return c;const m=u.getCommentThread(c.thread.commentThreadHandle);if(!m)return c;const b=c.text,f=c.commentUniqueId,N=m.getCommentByUniqueId(f);return N?(typeof N.body=="string"?N.body=b:N.body=new O.MarkdownString(b),N):c}return c}})}createCommentController(c,u,m){const b=D.a++,f=new v(c,b,u,m);this.b.set(f.handle,f);const N=this.c.get(c.identifier)||[];return N.push(f),this.c.set(c.identifier,N),f.value}$createCommentThreadTemplate(c,u,m){const b=this.b.get(c);b&&b.$createCommentThreadTemplate(u,m)}async $updateCommentThreadTemplate(c,u,m){const b=this.b.get(c);b&&b.$updateCommentThreadTemplate(u,m)}$deleteCommentThread(c,u){this.b.get(c)?.$deleteCommentThread(u)}$provideCommentingRanges(c,u,m){const b=this.b.get(c);if(!b||!b.commentingRangeProvider)return Promise.resolve(void 0);const f=o.getDocument(R.URI.revive(u));return(0,n.asPromise)(async()=>{const N=await b.commentingRangeProvider.provideCommentingRanges(f,m);let V;return Array.isArray(N)?V={ranges:N,fileComments:!1}:N?V={ranges:N.ranges||[],fileComments:N.fileComments||!1}:V=(0,S.withNullAsUndefined)(N),V}).then(N=>{let V;return N&&(V={ranges:N.ranges.map(_=>h.Range.from(_)),fileComments:N.fileComments}),V})}$toggleReaction(c,u,m,b,f){const N=this.b.get(c);return!N||!N.reactionHandler?Promise.resolve(void 0):(0,n.asPromise)(()=>{const V=N.getCommentThread(u);if(V){const _=V.getCommentByUniqueId(b.uniqueIdInThread);if(N!==void 0&&_&&N.reactionHandler)return N.reactionHandler(_,r(f))}return Promise.resolve(void 0)})}}D.a=0;class T{set threadId(c){this.n=c}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(c){(c===void 0!=(this.p===void 0)||!c||!this.p||!c.isEqual(this.p))&&(this.p=c,this.b.range=c,this.c.fire())}get range(){return this.p}set canReply(c){this.d!==c&&(this.d=c,this.b.canReply=c,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(c){this.e=c,this.b.label=c,this.c.fire()}get contextValue(){return this.f}set contextValue(c){this.f=c,this.b.contextValue=c,this.c.fire()}get comments(){return this.q}set comments(c){this.q=c,this.b.comments=c,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(c){this.g=c,this.b.collapsibleState=c,this.c.fire()}get state(){return this.h}set state(c){this.h=c,this.b.state=c,this.c.fire()}get isDisposed(){return this.j}constructor(c,u,m,b,f,N,V,_){this.m=u,this.n=m,this.o=b,this.p=f,this.q=N,this.extensionDescription=V,this.r=_,this.handle=T.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new I.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new L.MutableDisposable,this.l.value=new L.DisposableStore,this.n===void 0&&(this.n=`${c}.${this.handle}`),d.$createCommentThread(u,this.handle,this.n,this.o,h.Range.from(this.p),V.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=N,this.i.push({dispose:()=>{d.$deleteCommentThread(u,this.handle)}});const G=this;this.value={get uri(){return G.uri},get range(){return G.range},set range($){G.range=$},get comments(){return G.comments},set comments($){G.comments=$},get collapsibleState(){return G.collapsibleState},set collapsibleState($){G.collapsibleState=$},get canReply(){return G.canReply},set canReply($){G.canReply=$},get contextValue(){return G.contextValue},set contextValue($){G.contextValue=$},get label(){return G.label},set label($){G.label=$},get state(){return G.state},set state($){G.state=$},dispose:()=>{G.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new L.DisposableStore);const c=m=>Object.prototype.hasOwnProperty.call(this.b,m),u={};c("range")&&(u.range=h.Range.from(this.p)),c("label")&&(u.label=this.label),c("contextValue")&&(u.contextValue=this.contextValue??null),c("comments")&&(u.comments=this.q.map(m=>i(this,m,this.k,this.extensionDescription))),c("collapsibleState")&&(u.collapseState=s(this.g)),c("canReply")&&(u.canReply=this.canReply),c("state")&&(u.state=E(this.h)),c("isTemplate")&&(u.isTemplate=this.r),this.b={},d.$updateCommentThread(this.m,this.handle,this.n,this.o,u)}getCommentByUniqueId(c){for(const u of this.k){const m=u[0],b=u[1];if(c===b)return m}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(c=>c.dispose())}}T.a=0,xe([(0,P.debounce)(100)],T.prototype,"eventuallyUpdateCommentThread",null);class v{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(c){this.b=c,d.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(c){this.c=c,d.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this.d}set options(c){this.d=c,d.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(c,u,m,b){this.f=c,this.g=u,this.h=m,this.i=b,this.a=new Map,d.$registerCommentController(this.handle,m,b);const f=this;this.value=Object.freeze({id:f.id,label:f.label,get options(){return f.options},set options(N){f.options=N},get commentingRangeProvider(){return f.commentingRangeProvider},set commentingRangeProvider(N){f.commentingRangeProvider=N},get reactionHandler(){return f.reactionHandler},set reactionHandler(N){f.reactionHandler=N},createCommentThread(N,V,_){return f.createCommentThread(N,V,_).value},dispose:()=>{f.dispose()}}),this.e=[],this.e.push({dispose:()=>{d.$unregisterCommentController(this.handle)}})}createCommentThread(c,u,m){u===void 0&&(0,g.checkProposedApiEnabled)(this.f,"fileComments");const b=new T(this.id,this.handle,void 0,c,u,m,this.f,!1);return this.a.set(b.handle,b),b}$createCommentThreadTemplate(c,u){const m=new T(this.id,this.handle,void 0,R.URI.revive(c),h.Range.to(u),[],this.f,!0);return m.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(m.handle,m),m}$updateCommentThreadTemplate(c,u){const m=this.a.get(c);m&&(m.range=h.Range.to(u))}$deleteCommentThread(c){this.a.get(c)?.dispose(),this.a.delete(c)}getCommentThread(c){return this.a.get(c)}dispose(){this.a.forEach(c=>{c.dispose()}),this.e.forEach(c=>c.dispose())}}function i(k,c,u,m){let b=u.get(c);return b||(b=++k.commentHandle,u.set(c,b)),c.state!==void 0&&(0,g.checkProposedApiEnabled)(m,"commentsDraftState"),{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:b,body:typeof c.body=="string"?c.body:h.MarkdownString.from(c.body),userName:c.author.name,userIconPath:c.author.iconPath,label:c.label,commentReactions:c.reactions?c.reactions.map(f=>a(f)):void 0,state:c.state,timestamp:c.timestamp?.toJSON()}}function a(k){return{label:k.label,iconPath:k.iconPath?h.pathOrURIToURI(k.iconPath):void 0,count:k.count,hasReacted:k.authorHasReacted}}function r(k){return{label:k.label||"",count:k.count||0,iconPath:k.iconPath?R.URI.revive(k.iconPath):"",authorHasReacted:k.hasReacted||!1}}function s(k){if(k!==void 0)switch(k){case O.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function E(k){if(k!==void 0)switch(k){case O.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new D}e.createExtHostComments=p}),define(Pe[219],Ae([1,0,23,4,27,18]),function(te,e,n,P,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let R=e.AbstractExtHostConsoleForwarder=class{constructor(O,w){this.a=O.getProxy(P.MainContext.MainThreadConsole),this.b=w.consoleForward.includeStack,this.c=w.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,w){const g=this,S=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){g.e(O,w,S,arguments)}})}e(O,w,g,S){this.a.$logExtensionHostMessage({type:"__$console",severity:w,arguments:y(S,this.b)}),this.c&&this.f(O,g,S)}};e.AbstractExtHostConsoleForwarder=R=xe([qe(0,L.IExtHostRpcService),qe(1,I.IExtHostInitDataService)],R);const A=1e5;function y(h,O){const w=[];if(h.length)for(let g=0;g<h.length;g++){let S=h[g];if(typeof S>"u")S="undefined";else if(S instanceof Error){const p=S;p.stack?S=p.stack:S=p.toString()}w.push(S)}if(O){const g=new Error().stack;g&&w.push({__$stack:g.split(`
`).slice(3).join(`
`)})}try{const g=(0,n.safeStringify)(w);return g.length>A?"Output omitted for a large object that exceeds the limits":g}catch(g){return`Output omitted for an object that cannot be inspected ('${g.toString()}')`}}}),define(Pe[106],Ae([1,0,2,4,7,3,18,14,16,13,19,26]),function(te,e,n,P,I,L,R,A,y,h,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let g=e.ExtHostDecorations=class Yi{constructor(p,l){this.h=l,this.f=new Map,this.g=p.getProxy(P.MainContext.MainThreadDecorations)}registerFileDecorationProvider(p,l){const t=Yi.c++;this.f.set(t,{provider:p,extensionDescription:l}),this.g.$registerDecorationProvider(t,l.identifier.value);const o=p.onDidChangeFileDecorations&&p.onDidChangeFileDecorations(d=>{if(!d){this.g.$onDidChange(t,null);return}const D=(0,y.asArray)(d);if(D.length<=Yi.d){this.g.$onDidChange(t,D);return}this.h.warn("[Decorations] CAPPING events from decorations provider",l.identifier.value,D.length);const T=D.map(a=>({uri:a,rank:(0,h.count)(a.path,"/")})),v=(0,y.groupBy)(T,(a,r)=>a.rank-r.rank||(0,h.compare)(a.uri.path,r.uri.path)),i=[];e:for(const a of v){let r;for(const s of a){const E=(0,O.dirname)(s.uri.path);if(r!==E&&(r=E,i.push(s.uri)>=Yi.d))break e}}this.g.$onDidChange(t,i)});return new I.Disposable(()=>{o?.dispose(),this.g.$unregisterDecorationProvider(t),this.f.delete(t)})}async $provideDecorations(p,l,t){if(!this.f.has(p))return Object.create(null);const o=Object.create(null),{provider:d,extensionDescription:D}=this.f.get(p);return await Promise.all(l.map(async T=>{try{const{uri:v,id:i}=T,a=await Promise.resolve(d.provideFileDecoration(n.URI.revive(v),t));if(!a)return;try{I.FileDecoration.validate(a),a.badge&&typeof a.badge!="string"&&(0,w.checkProposedApiEnabled)(D,"codiconDecoration"),o[i]=[a.propagate,a.tooltip,a.badge,a.color]}catch(r){this.h.warn(`INVALID decoration from extension '${D}': ${r}`)}}catch(v){this.h.error(v)}})),o}};g.c=0,g.d=250,e.ExtHostDecorations=g=xe([qe(0,R.IExtHostRpcService),qe(1,A.ILogService)],g),e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var _e=this&&this.__classPrivateFieldSet||function(te,e,n,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(te,n):I?I.value=n:e.set(te,n),n},Ne=this&&this.__classPrivateFieldGet||function(te,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(te):P?P.value:e.get(te)};define(Pe[220],Ae([1,0,145,93,2,4,7,8,5,14,28,37]),function(te,e,n,P,I,L,R,A,y,h,O,w){"use strict";var g,S,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class l{constructor(d,D,T,v,i,a,r){this.d=d,this.e=D,this.f=T,this.g=v,g.set(this,void 0),S.set(this,void 0),p.set(this,void 0),this.c=!1,_e(this,p,new O.ResourceMap(s=>i.getComparisonKey(s)),"f"),_e(this,g,a,"f"),_e(this,S,r,"f")}dispose(){this.c||(Ne(this,S,"f").fire([...Ne(this,p,"f").keys()]),Ne(this,g,"f")?.$clear(this.e),Ne(this,p,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(d,D){if(!d){this.clear();return}this.h();let T=[];if(I.URI.isUri(d)){if(!D){this.delete(d);return}Ne(this,p,"f").set(d,D.slice()),T=[d]}else if(Array.isArray(d)){T=[];let i;d=[...d].sort(l.j);for(const a of d){const[r,s]=a;if((!i||r.toString()!==i.toString())&&(i&&Ne(this,p,"f").get(i).length===0&&Ne(this,p,"f").delete(i),i=r,T.push(r),Ne(this,p,"f").set(r,[])),s)Ne(this,p,"f").get(r)?.push(...s);else{const E=Ne(this,p,"f").get(r);E&&(E.length=0)}}}if(Ne(this,S,"f").fire(T),!Ne(this,g,"f"))return;const v=[];for(const i of T){let a=[];const r=Ne(this,p,"f").get(i);if(r)if(r.length>this.f){a=[];const s=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let E=0;E<4;E++)for(const k of r)if(k.severity===s[E]&&a.push({...A.Diagnostic.from(k),modelVersionId:this.g(i)})===this.f)break e;a.push({severity:P.MarkerSeverity.Info,message:(0,n.localize)(0,null,r.length-this.f),startLineNumber:a[a.length-1].startLineNumber,startColumn:a[a.length-1].startColumn,endLineNumber:a[a.length-1].endLineNumber,endColumn:a[a.length-1].endColumn})}else a=r.map(s=>({...A.Diagnostic.from(s),modelVersionId:this.g(i)}));v.push([i,a])}Ne(this,g,"f").$changeMany(this.e,v)}delete(d){this.h(),Ne(this,S,"f").fire([d]),Ne(this,p,"f").delete(d),Ne(this,g,"f")?.$changeMany(this.e,[[d,void 0]])}clear(){this.h(),Ne(this,S,"f").fire([...Ne(this,p,"f").keys()]),Ne(this,p,"f").clear(),Ne(this,g,"f")?.$clear(this.e)}forEach(d,D){this.h();for(const[T,v]of this)d.call(D,T,v,this)}*[(g=new WeakMap,S=new WeakMap,p=new WeakMap,Symbol.iterator)](){this.h();for(const d of Ne(this,p,"f").keys())yield[d,this.get(d)]}get(d){this.h();const D=Ne(this,p,"f").get(d);return Array.isArray(D)?Object.freeze(D.slice(0)):[]}has(d){return this.h(),Array.isArray(Ne(this,p,"f").get(d))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(d,D){return d[0].toString()<D[0].toString()?-1:d[0].toString()>D[0].toString()?1:0}}e.DiagnosticCollection=l;let t=e.ExtHostDiagnostics=class mi{static _mapper(d){const D=new O.ResourceMap;for(const T of d)D.set(T,T);return{uris:Object.freeze(Array.from(D.values()))}}constructor(d,D,T,v){this.h=D,this.j=T,this.k=v,this.f=new Map,this.g=new y.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,mi._mapper),this.e=d.getProxy(L.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(d,D){const{f:T,e:v,g:i,h:a,j:r,k:s}=this,E=new class{$changeMany(u,m){v.$changeMany(u,m),a.trace("[DiagnosticCollection] change many (extension, owner, uris)",d.value,u,m.length===0?"CLEARING":m)}$clear(u){v.$clear(u),a.trace("[DiagnosticCollection] remove all (extension, owner)",d.value,u)}dispose(){v.dispose()}};let k;if(!D)D="_generated_diagnostic_collection_name_#"+mi.c++,k=D;else if(!T.has(D))k=D;else{this.h.warn(`DiagnosticCollection with name '${D}' does already exist.`);do k=D+mi.c++;while(T.has(k))}return new class extends l{constructor(){super(D,k,mi.d,u=>s.getDocument(u)?.version,r.extUri,E,i),T.set(k,this)}dispose(){super.dispose(),T.delete(k)}}}getDiagnostics(d){if(d)return this.l(d);{const D=new Map,T=[];for(const v of this.f.values())v.forEach((i,a)=>{let r=D.get(i.toString());typeof r>"u"&&(r=T.length,D.set(i.toString(),r),T.push([i,[]])),T[r][1]=T[r][1].concat(...a)});return T}}l(d){let D=[];for(const T of this.f.values())T.has(d)&&(D=D.concat(T.get(d)));return D}$acceptMarkersChange(d){if(!this.m){const D="_generated_mirror",T=new l(D,D,mi.d,v=>{},this.j.extUri,void 0,this.g);this.f.set(D,T),this.m=T}for(const[D,T]of d)this.m.set(I.URI.revive(D),T.map(A.Diagnostic.to))}};t.c=0,t.d=1e3,e.ExtHostDiagnostics=t=xe([qe(1,h.ILogService),qe(2,w.IExtHostFileSystemInfo)],t)}),define(Pe[221],Ae([1,0,2,4,26]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class L{constructor(A){this.a=A.getProxy(P.MainContext.MainThreadDialogs)}showOpenDialog(A,y){return y?.allowUIResources&&(0,I.checkProposedApiEnabled)(A,"showLocal"),this.a.$showOpenDialog(y).then(h=>h?h.map(O=>n.URI.revive(O)):void 0)}showSaveDialog(A){return this.a.$showSaveDialog(A).then(y=>y?n.URI.revive(y):void 0)}}e.ExtHostDialogs=L}),define(Pe[222],Ae([1,0,9,2,7,4,15,21,13]),function(te,e,n,P,I,L,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class h{constructor(w,g,S){this.d=g,this.e=S,this.b=new Map,this.c=w.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(w,g){if(Object.keys(R.Schemas).indexOf(w)>=0)throw new Error(`scheme '${w}' already registered`);const S=h.a++;this.b.set(S,g),this.c.$registerTextContentProvider(S,w);let p;return typeof g.onDidChange=="function"&&(p=g.onDidChange(l=>{if(l.scheme!==w){this.e.warn(`Provider for scheme '${w}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this.d.getDocument(l)&&this.$provideTextDocumentContent(S,l).then(t=>{if(!t&&typeof t!="string")return;const o=this.d.getDocument(l);if(!o)return;const d=(0,y.splitLines)(t);if(!o.equalLines(d))return this.c.$onVirtualDocumentChange(l,t)},n.onUnexpectedError)})),new I.Disposable(()=>{this.b.delete(S)&&this.c.$unregisterTextContentProvider(S),p&&(p.dispose(),p=void 0)})}$provideTextDocumentContent(w,g){const S=this.b.get(w);return S?Promise.resolve(S.provideTextDocumentContent(P.URI.revive(g),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${g.scheme}`))}}e.ExtHostDocumentContentProvider=h,h.a=0}),define(Pe[223],Ae([1,0,5,6,2,4,102,8,12,23,7]),function(te,e,n,P,I,L,R,A,y,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class w{constructor(S,p){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new P.DisposableStore,this.h=new Map,this.f=S.getProxy(L.MainContext.MainThreadDocuments),this.g=p,this.g.onDidRemoveDocuments(l=>{for(const t of l)this.b.fire(t.document)},void 0,this.e),this.g.onDidAddDocuments(l=>{for(const t of l)this.a.fire(t.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(S){if(!S)return;const p=this.g.getDocument(S);if(p)return p}getDocument(S){const p=this.getDocumentData(S);if(!p?.document)throw new Error(`Unable to retrieve document from URI '${S}'`);return p.document}ensureDocumentData(S){const p=this.g.getDocument(S);if(p)return Promise.resolve(p);let l=this.h.get(S.toString());return l||(l=this.f.$tryOpenDocument(S).then(t=>{this.h.delete(S.toString());const o=I.URI.revive(t);return(0,y.assertIsDefined)(this.g.getDocument(o))},t=>(this.h.delete(S.toString()),Promise.reject(t))),this.h.set(S.toString(),l)),l}createDocumentData(S){return this.f.$tryCreateDocument(S).then(p=>I.URI.revive(p))}$acceptModelLanguageChanged(S,p){const l=I.URI.revive(S),t=this.g.getDocument(l);if(!t)throw new Error("unknown document");this.b.fire(t.document),t._acceptLanguageId(p),this.a.fire(t.document)}$acceptModelSaved(S){const p=I.URI.revive(S),l=this.g.getDocument(p);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(S,!1),this.d.fire(l.document)}$acceptDirtyStateChanged(S,p){const l=I.URI.revive(S),t=this.g.getDocument(l);if(!t)throw new Error("unknown document");t._acceptIsDirty(p),this.c.fire({document:t.document,contentChanges:[],reason:void 0})}$acceptModelChanged(S,p,l){const t=I.URI.revive(S),o=this.g.getDocument(t);if(!o)throw new Error("unknown document");o._acceptIsDirty(l),o.onEvents(p);let d;p.isUndoing?d=O.TextDocumentChangeReason.Undo:p.isRedoing&&(d=O.TextDocumentChangeReason.Redo),this.c.fire((0,h.deepFreeze)({document:o.document,contentChanges:p.changes.map(D=>({range:A.Range.to(D.range),rangeOffset:D.rangeOffset,rangeLength:D.rangeLength,text:D.text})),reason:d}))}setWordDefinitionFor(S,p){(0,R.setWordDefinitionFor)(S,p)}}e.ExtHostDocuments=w}),define(Pe[59],Ae([1,0,49,5,6,2,3,4,102,18,105,8,14,28,15,86,87]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class o{constructor(T){this.value=T,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let d=e.ExtHostDocumentsAndEditors=class{constructor(T,v){this.h=T,this.i=v,this.a=null,this.b=new Map,this.c=new S.ResourceMap,this.d=new P.Emitter,this.e=new P.Emitter,this.f=new P.Emitter,this.g=new P.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(T){this.acceptDocumentsAndEditorsDelta(T)}acceptDocumentsAndEditorsDelta(T){const v=[],i=[],a=[];if(T.removedDocuments)for(const r of T.removedDocuments){const s=L.URI.revive(r),E=this.c.get(s);E?.unref()&&(this.c.delete(s),v.push(E.value))}if(T.addedDocuments)for(const r of T.addedDocuments){const s=L.URI.revive(r.uri);let E=this.c.get(s);if(E&&s.scheme!==p.Schemas.vscodeNotebookCell&&s.scheme!==p.Schemas.vscodeInteractiveInput)throw new Error(`document '${s} already exists!'`);E||(E=new o(new y.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),s,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(s,E),i.push(E.value)),E.ref()}if(T.removedEditors)for(const r of T.removedEditors){const s=this.b.get(r);this.b.delete(r),s&&a.push(s)}if(T.addedEditors)for(const r of T.addedEditors){const s=L.URI.revive(r.documentUri);n.ok(this.c.has(s),`document '${s}' does not exist`),n.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const E=this.c.get(s).value,k=new O.ExtHostTextEditor(r.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new t.Lazy(()=>E.document),r.selections.map(w.Selection.to),r.options,r.visibleRanges.map(c=>w.Range.to(c)),typeof r.editorPosition=="number"?w.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,k)}T.newActiveEditor!==void 0&&(n.ok(T.newActiveEditor===null||this.b.has(T.newActiveEditor),`active editor '${T.newActiveEditor}' does not exist`),this.a=T.newActiveEditor),(0,I.dispose)(v),(0,I.dispose)(a),T.removedDocuments&&this.e.fire(v),T.addedDocuments&&this.d.fire(i),(T.removedEditors||T.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),T.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(T){return this.c.get(T)?.value}allDocuments(){return l.Iterable.map(this.c.values(),T=>T.value)}getEditor(T){return this.b.get(T)}activeEditor(T){if(!this.a)return;const v=this.b.get(this.a);return T?v:v?.value}allEditors(){return[...this.b.values()]}};e.ExtHostDocumentsAndEditors=d=xe([qe(0,h.IExtHostRpcService),qe(1,g.ILogService)],d),e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(Pe[60],Ae([1,0,8,4,2,5,3,7,18,12,64]),function(te,e,n,P,I,L,R,A,y,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,R.createDecorator)("IExtHostEditorTabs");class w{constructor(t,o,d){this.e=d,this.d=o,this.acceptDtoUpdate(t)}get apiObject(){if(!this.a){const t=this,o={get isActive(){return t.b.id===t.e()},get label(){return t.b.label},get input(){return t.c},get isDirty(){return t.b.isDirty},get isPinned(){return t.b.isPinned},get isPreview(){return t.b.isPreview},get group(){return t.d.apiObject}};this.a=Object.freeze(o)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(t){this.b=t,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(I.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(I.URI.revive(this.b.input.base),I.URI.revive(this.b.input.input1),I.URI.revive(this.b.input.input2),I.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(I.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(I.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(I.URI.revive(this.b.input.original),I.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(I.URI.revive(this.b.input.uri),I.URI.revive(this.b.input.inputBoxUri));default:return}}}class g{constructor(t,o){this.c=[],this.d="",this.b=t,this.e=o;for(const d of t.tabs)d.isActive&&(this.d=d.id),this.c.push(new w(d,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const t=this,o={get isActive(){return t.b.groupId===t.e()},get viewColumn(){return n.ViewColumn.to(t.b.viewColumn)},get activeTab(){return t.c.find(d=>d.tabId===t.d)?.apiObject},get tabs(){return Object.freeze(t.c.map(d=>d.apiObject))}};this.a=Object.freeze(o)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(t){this.b=t}acceptTabOperation(t){if(t.kind===0){const d=new w(t.tabDto,this,()=>this.activeTabId());return this.c.splice(t.index,0,d),t.tabDto.isActive&&(this.d=d.tabId),d}else if(t.kind===1){const d=this.c.splice(t.index,1)[0];if(!d)throw new Error(`Tab close updated received for index ${t.index} which does not exist`);return d.tabId===this.d&&(this.d=""),d}else if(t.kind===3){if(t.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const d=this.c.splice(t.oldIndex,1)[0];if(!d)throw new Error(`Tab move updated received for index ${t.oldIndex} which does not exist`);return this.c.splice(t.index,0,d),d}const o=this.c.find(d=>d.tabId===t.tabDto.id);if(!o)throw new Error("INVALID tab");return t.tabDto.isActive?this.d=t.tabDto.id:this.d===t.tabDto.id&&!t.tabDto.isActive&&(this.d=""),o.acceptDtoUpdate(t.tabDto),o}activeTabId(){return this.d}}let S=e.ExtHostEditorTabs=class{constructor(t){this.b=new L.Emitter,this.c=new L.Emitter,this.e=[],this.a=t.getProxy(P.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const t=this,o={onDidChangeTabGroups:t.c.event,onDidChangeTabs:t.b.event,get all(){return Object.freeze(t.e.map(d=>d.apiObject))},get activeTabGroup(){const d=t.d;return(0,h.assertIsDefined)(t.e.find(T=>T.groupId===d)?.apiObject)},close:async(d,D)=>{const T=Array.isArray(d)?d:[d];return T.length?p(T[0])?this.j(T,D):this.i(T,D):!0}};this.f=Object.freeze(o)}return this.f}$acceptEditorTabModel(t){const o=new Set(this.e.map(r=>r.groupId)),d=new Set(t.map(r=>r.groupId)),D=(0,O.diffSets)(o,d),T=this.e.filter(r=>D.removed.includes(r.groupId)).map(r=>r.apiObject),v=[],i=[];this.e=t.map(r=>{const s=new g(r,()=>this.d);return D.added.includes(s.groupId)?v.push(s.apiObject):i.push(s.apiObject),s});const a=(0,h.assertIsDefined)(t.find(r=>r.isActive===!0)?.groupId);a!==void 0&&this.d!==a&&(this.d=a),this.c.fire(Object.freeze({opened:v,closed:T,changed:i}))}$acceptTabGroupUpdate(t){const o=this.e.find(d=>d.groupId===t.groupId);if(!o)throw new Error("Update Group IPC call received before group creation.");o.acceptGroupDtoUpdate(t),t.isActive&&(this.d=t.groupId),this.c.fire(Object.freeze({changed:[o.apiObject],opened:[],closed:[]}))}$acceptTabOperation(t){const o=this.e.find(D=>D.groupId===t.groupId);if(!o)throw new Error("Update Tabs IPC call received before group creation.");const d=o.acceptTabOperation(t);switch(t.kind){case 0:this.b.fire(Object.freeze({opened:[d.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[d.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[d.apiObject]}));return}}g(t){for(const o of this.e)for(const d of o.tabs)if(d.apiObject===t)return d}h(t){return this.e.find(o=>o.apiObject===t)}async i(t,o){const d=[];for(const D of t){const T=this.g(D);if(!T)throw new Error("Tab close: Invalid tab not found!");d.push(T.tabId)}return this.a.$closeTab(d,o)}async j(t,o){const d=[];for(const D of t){const T=this.h(D);if(!T)throw new Error("Group close: Invalid group not found!");d.push(T.groupId)}return this.a.$closeGroup(d,o)}};e.ExtHostEditorTabs=S=xe([qe(0,y.IExtHostRpcService)],S);function p(l){return l.tabs!==void 0}}),define(Pe[224],Ae([1,0,2,4,6,7,8,271,13,25,26]),function(te,e,n,P,I,L,R,A,y,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class w{constructor(){this.a=[]}add(p){this.b=void 0,this.a.push(p)}delete(p){const l=this.a.indexOf(p);l>=0&&(this.a.splice(l,1),this.b=void 0)}c(){if(!this.b){const p=this.a.sort(),l=[];let t,o,d=14,D=14;for(const T of p){let v=t?(0,y.commonPrefixLength)(t,T):0;for(v===0?o=1:o=D;v<T.length;v++)v+1===T.length?(d=D,D=9):D+=1,l.push([o,T.toUpperCase().charCodeAt(v),D]),l.push([o,T.toLowerCase().charCodeAt(v),D]),o=D;t=T,D=d}l.push([9,58,10]),l.push([10,47,12]),this.b=new A.StateMachine(l)}}provideDocumentLinks(p){this.c();const l=[],t=A.LinkComputer.computeLinks({getLineContent(o){return p.lineAt(o-1).text},getLineCount(){return p.lineCount}},this.b);for(const o of t){const d=R.DocumentLink.to(o);d.target&&l.push(d)}return l}}class g{constructor(p,l){this.i=l,this.b=new w,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=p.getProxy(P.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(p,l,t,o={}){if(g.j(t),this.d.has(l))throw new Error(`a provider for the scheme '${l}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(p,"*",this.b));const d=this.h++;this.b.add(l),this.d.add(l),this.c.set(d,t);let D=2;o.isCaseSensitive&&(D+=1024),o.isReadonly&&(D+=2048),typeof t.copy=="function"&&(D+=8),typeof t.open=="function"&&typeof t.close=="function"&&typeof t.read=="function"&&typeof t.write=="function"&&((0,O.checkProposedApiEnabled)(p,"fsChunks"),D+=4),this.a.$registerFileSystemProvider(d,l,D).catch(v=>{console.error(`FAILED to register filesystem provider of ${p.identifier.value}-extension for the scheme ${l}`),console.error(v)});const T=t.onDidChangeFile(v=>{const i=[];for(const a of v){const{uri:r,type:s}=a;if(r.scheme!==l)continue;let E;switch(s){case L.FileChangeType.Changed:E=0;break;case L.FileChangeType.Created:E=1;break;case L.FileChangeType.Deleted:E=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:r,type:E})}this.a.$onFileSystemChange(d,i)});return(0,I.toDisposable)(()=>{T.dispose(),this.b.delete(l),this.d.delete(l),this.c.delete(d),this.a.$unregisterProvider(d)})}static j(p){if(!p)throw new Error("MISSING provider");if(typeof p.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof p.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof p.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof p.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof p.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof p.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof p.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof p.rename!="function")throw new Error("Provider does NOT implement rename")}static k(p){const{type:l,ctime:t,mtime:o,size:d,permissions:D}=p;return{type:l,ctime:t,mtime:o,size:d,permissions:D}}$stat(p,l){return Promise.resolve(this.l(p).stat(n.URI.revive(l))).then(t=>g.k(t))}$readdir(p,l){return Promise.resolve(this.l(p).readDirectory(n.URI.revive(l)))}$readFile(p,l){return Promise.resolve(this.l(p).readFile(n.URI.revive(l))).then(t=>h.VSBuffer.wrap(t))}$writeFile(p,l,t,o){return Promise.resolve(this.l(p).writeFile(n.URI.revive(l),t.buffer,o))}$delete(p,l,t){return Promise.resolve(this.l(p).delete(n.URI.revive(l),t))}$rename(p,l,t,o){return Promise.resolve(this.l(p).rename(n.URI.revive(l),n.URI.revive(t),o))}$copy(p,l,t,o){const d=this.l(p);if(!d.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(d.copy(n.URI.revive(l),n.URI.revive(t),o))}$mkdir(p,l){return Promise.resolve(this.l(p).createDirectory(n.URI.revive(l)))}$watch(p,l,t,o){const d=this.l(p).watch(n.URI.revive(t),o);this.f.set(l,d)}$unwatch(p,l){const t=this.f.get(l);t&&(t.dispose(),this.f.delete(l))}$open(p,l,t){const o=this.l(p);if(!o.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(o.open(n.URI.revive(l),t))}$close(p,l){const t=this.l(p);if(!t.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(t.close(l))}$read(p,l,t,o){const d=this.l(p);if(!d.read)throw new Error('FileSystemProvider does not implement "read"');const D=h.VSBuffer.alloc(o);return Promise.resolve(d.read(l,t,D.buffer,0,o)).then(T=>D.slice(0,T))}$write(p,l,t,o){const d=this.l(p);if(!d.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(d.write(l,t,o.buffer,0,o.byteLength))}l(p){const l=this.c.get(p);if(!l){const t=new Error;throw t.name="ENOPRO",t.message="no provider",t}return l}}e.ExtHostFileSystem=g}),define(Pe[61],Ae([1,0,4,43,7,25,3,18,37,6]),function(te,e,n,P,I,L,R,A,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=e.ExtHostConsumerFileSystem=class Zt{constructor(g,S){this.b=new Map,this.a=g.getProxy(n.MainContext.MainThreadFileSystem);const p=this;this.value=Object.freeze({async stat(l){try{const t=p.b.get(l.scheme);if(!t)return await p.a.$stat(l);await p.a.$ensureActivation(l.scheme);const o=await t.stat(l);return{type:o.type,ctime:o.ctime,mtime:o.mtime,size:o.size,permissions:o.permissions}}catch(t){Zt.c(t)}},async readDirectory(l){try{const t=p.b.get(l.scheme);return t?(await p.a.$ensureActivation(l.scheme),(await t.readDirectory(l)).slice()):await p.a.$readdir(l)}catch(t){return Zt.c(t)}},async createDirectory(l){try{return await p.a.$mkdir(l)}catch(t){return Zt.c(t)}},async readFile(l){try{const t=p.b.get(l.scheme);return t?(await p.a.$ensureActivation(l.scheme),(await t.readFile(l)).slice()):(await p.a.$readFile(l)).buffer}catch(t){return Zt.c(t)}},async writeFile(l,t){try{return await p.a.$writeFile(l,L.VSBuffer.wrap(t))}catch(o){return Zt.c(o)}},async delete(l,t){try{const o=p.b.get(l.scheme);return o?(await p.a.$ensureActivation(l.scheme),await o.delete(l,{recursive:!1,...t})):await p.a.$delete(l,{recursive:!1,useTrash:!1,...t})}catch(o){return Zt.c(o)}},async rename(l,t,o){try{return await p.a.$rename(l,t,{overwrite:!1,...o})}catch(d){return Zt.c(d)}},async copy(l,t,o){try{return await p.a.$copy(l,t,{overwrite:!1,...o})}catch(d){return Zt.c(d)}},isWritableFileSystem(l){const t=S.getCapabilities(l);if(typeof t=="number")return!(t&2048)}})}static c(g){if(g instanceof I.FileSystemError)throw g;if(!(g instanceof Error))throw new I.FileSystemError(String(g));if(g.name==="ENOPRO"||g.message.includes("ENOPRO"))throw I.FileSystemError.Unavailable(g.message);switch(g.name){case P.FileSystemProviderErrorCode.FileExists:throw I.FileSystemError.FileExists(g.message);case P.FileSystemProviderErrorCode.FileNotFound:throw I.FileSystemError.FileNotFound(g.message);case P.FileSystemProviderErrorCode.FileNotADirectory:throw I.FileSystemError.FileNotADirectory(g.message);case P.FileSystemProviderErrorCode.FileIsADirectory:throw I.FileSystemError.FileIsADirectory(g.message);case P.FileSystemProviderErrorCode.NoPermissions:throw I.FileSystemError.NoPermissions(g.message);case P.FileSystemProviderErrorCode.Unavailable:throw I.FileSystemError.Unavailable(g.message);default:throw new I.FileSystemError(g.message,g.name)}}addFileSystemProvider(g,S){return this.b.set(g,S),(0,h.toDisposable)(()=>this.b.delete(g))}};e.ExtHostConsumerFileSystem=O=xe([qe(0,A.IExtHostRpcService),qe(1,y.IExtHostFileSystemInfo)],O),e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(Pe[225],Ae([1,0,5,36,2,4,8,7]),function(te,e,n,P,I,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return!!(this.g&1)}get ignoreChangeEvents(){return!!(this.g&2)}get ignoreDeleteEvents(){return!!(this.g&4)}constructor(w,g,S,p,l,t,o,d){this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter;const D=this.h(w,S,l);this.g=0,t&&(this.g+=1),o&&(this.g+=2),d&&(this.g+=4);const T=(0,P.parse)(l),v=typeof l=="string",i=p(a=>{if(!t)for(const r of a.created){const s=I.URI.revive(r);T(s.fsPath)&&(!v||g.getWorkspaceFolder(s))&&this.a.fire(s)}if(!o)for(const r of a.changed){const s=I.URI.revive(r);T(s.fsPath)&&(!v||g.getWorkspaceFolder(s))&&this.b.fire(s)}if(!d)for(const r of a.deleted){const s=I.URI.revive(r);T(s.fsPath)&&(!v||g.getWorkspaceFolder(s))&&this.c.fire(s)}});this.d=A.Disposable.from(D,this.a,this.b,this.c,i)}h(w,g,S){const p=A.Disposable.from();if(typeof S=="string")return p;const l=w.getProxy(L.MainContext.MainThreadFileSystem);let t=!1;(S.pattern.includes(P.GLOBSTAR)||S.pattern.includes(P.GLOB_SPLIT))&&(t=!0);const o=Math.random();return l.$watch(g.identifier.value,o,S.baseUri,{recursive:t,excludes:[]}),A.Disposable.from({dispose:()=>l.$unwatch(o)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class h{constructor(w,g,S){this.j=w,this.k=g,this.l=S,this.a=new n.Emitter,this.b=new n.Emitter,this.c=new n.Emitter,this.d=new n.Emitter,this.g=new n.AsyncEmitter,this.h=new n.AsyncEmitter,this.i=new n.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,g,S,p,l,t){return new y(this.j,w,g,this.a.event,R.GlobPattern.from(S),p,l,t)}$onFileEvent(w){this.a.fire(w)}$onDidRunFileOperation(w,g){switch(w){case 2:this.b.fire(Object.freeze({files:g.map(S=>({oldUri:I.URI.revive(S.source),newUri:I.URI.revive(S.target)}))}));break;case 1:this.d.fire(Object.freeze({files:g.map(S=>I.URI.revive(S.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:g.map(S=>I.URI.revive(S.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,g){return(S,p,l)=>{const t=function(d){S.call(p,d)};return t.extension=w,g.event(t,void 0,l)}}async $onWillRunFileOperation(w,g,S,p){switch(w){case 2:return await this.n(this.g,{files:g.map(l=>({oldUri:I.URI.revive(l.source),newUri:I.URI.revive(l.target)}))},S,p);case 1:return await this.n(this.i,{files:g.map(l=>I.URI.revive(l.target))},S,p);case 0:case 3:return await this.n(this.h,{files:g.map(l=>I.URI.revive(l.target))},S,p)}}async n(w,g,S,p){const l=new Set,t=[];if(await w.fireAsync(g,p,async(d,D)=>{const T=Date.now(),v=await Promise.resolve(d);v instanceof A.WorkspaceEdit&&(t.push([D.extension,v]),l.add(D.extension.displayName??D.extension.identifier.value)),Date.now()-T>S&&this.k.warn("SLOW file-participant",D.extension.identifier)}),p.isCancellationRequested||t.length===0)return;const o={edits:[]};for(const[,d]of t){const{edits:D}=R.WorkspaceEdit.from(d,{getTextDocumentVersion:T=>this.l.getDocument(T)?.version,getNotebookDocumentVersion:()=>{}});o.edits=o.edits.concat(D)}return{edit:o,extensionNames:Array.from(l)}}}e.ExtHostFileSystemEventService=h}),define(Pe[226],Ae([1,0,2,38]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class I{constructor(R,A,y,h,O){this.a=A,this.b=y,this.c=h;const w=new P.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new P.ApiCommandArgument("showOptions","Show Options",g=>!0,g=>g),new P.ApiCommandArgument("resource","Interactive resource Uri",g=>!0,g=>g),new P.ApiCommandArgument("controllerId","Notebook controller Id",g=>!0,g=>g),new P.ApiCommandArgument("title","Interactive editor title",g=>!0,g=>g)],new P.ApiCommandResult("Notebook and input URI",g=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",g.notebookEditorId),g.notebookEditorId!==void 0){const S=this.a.getEditorById(g.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",S.id),{notebookUri:n.URI.revive(g.notebookUri),inputUri:n.URI.revive(g.inputUri),notebookEditor:S.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",g.notebookUri,g.inputUri),{notebookUri:n.URI.revive(g.notebookUri),inputUri:n.URI.revive(g.inputUri)}}));this.c.registerApiCommand(w)}$willAddInteractiveDocument(R,A,y,h){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:R,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(n.URI.revive(h))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=I}),define(Pe[227],Ae([1,0,6,2,4,8,7]),function(te,e,n,P,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveEditor=void 0;class A{constructor(w,g){this.extension=w,this.provider=g,this.handle=A.a++}}A.a=0;class y{constructor(w){this.session=w,this.responses=[]}}class h{constructor(w,g,S){this.e=g,this.f=S,this.b=new Map,this.c=new Map,this.d=w.getProxy(I.MainContext.MainThreadInteractiveEditor)}registerProvider(w,g){const S=new A(w,g);return this.b.set(S.handle,S),this.d.$registerInteractiveEditorProvider(S.handle,w.identifier.value,typeof g.handleInteractiveEditorResponseFeedback=="function"),(0,n.toDisposable)(()=>{this.d.$unregisterInteractiveEditorProvider(S.handle),this.b.delete(S.handle)})}async $prepareInteractiveSession(w,g,S,p){const l=this.b.get(w);if(!l){this.f.warn("CANNOT prepare session because the PROVIDER IS GONE");return}const t=this.e.getDocument(P.URI.revive(g)),o=L.Selection.to(S),d=await l.provider.prepareInteractiveEditorSession({document:t,selection:o},p);if(!d)return;if(d.wholeRange&&!d.wholeRange.contains(o))throw new Error("InteractiveEditorSessionProvider returned a wholeRange that does not contain the selection.");const D=h.a++;return this.c.set(D,new y(d)),{id:D,placeholder:d.placeholder,slashCommands:d.slashCommands,wholeRange:L.Range.from(d.wholeRange)}}async $provideResponse(w,g,S,p){const l=this.b.get(w);if(!l)return;const t=this.c.get(g.id);if(!t)return;const o=await l.provider.provideInteractiveEditorResponse({session:t.session,prompt:S.prompt,selection:L.Selection.to(S.selection),wholeRange:L.Range.to(S.wholeRange)},p);if(o){const d=t.responses.push(o)-1,D={wholeRange:L.Range.from(o.wholeRange),placeholder:o.placeholder};if(h.g(o))return{...D,id:d,type:"message",message:L.MarkdownString.from(o.contents)};const{edits:T}=o;if(T instanceof R.WorkspaceEdit)return{...D,id:d,type:"bulkEdit",edits:L.WorkspaceEdit.from(T)};if(Array.isArray(T))return{...D,id:d,type:"editorEdit",edits:T.map(L.TextEdit.from)}}}$handleFeedback(w,g,S,p){const l=this.b.get(w),t=this.c.get(g),o=t?.responses[S];if(l&&o){let d;switch(p){case 1:d=R.InteractiveEditorResponseFeedbackKind.Helpful;break;case 0:d=R.InteractiveEditorResponseFeedbackKind.Unhelpful;break;case 2:d=R.InteractiveEditorResponseFeedbackKind.Undone;break}l.provider.handleInteractiveEditorResponseFeedback?.(t.session,o,d)}}$releaseSession(w,g){const S=this.c.get(g),p=this.b.get(w);S&&p&&p.provider.releaseInteractiveEditorSession?.(S.session),this.c.delete(g)}static g(w){return typeof w=="object"&&typeof w.contents=="object"}}e.ExtHostInteractiveEditor=h,h.a=0}),define(Pe[228],Ae([1,0,5,6,58,147,4,8]),function(te,e,n,P,I,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractiveSession=void 0;class y{constructor(w,g){this.extension=w,this.provider=g,this.handle=y.a++}}y.a=0;class h{constructor(w,g){this.h=g,this.b=new Map,this.d=new Map,this.e=new n.Emitter,this.onDidPerformUserAction=this.e.event,this.g=w.getProxy(R.MainContext.MainThreadInteractiveSession)}registerInteractiveSessionProvider(w,g,S){const p=new y(w,S);return this.b.set(p.handle,p),this.g.$registerInteractiveSessionProvider(p.handle,g),(0,P.toDisposable)(()=>{this.g.$unregisterInteractiveSessionProvider(p.handle),this.b.delete(p.handle)})}addInteractiveSessionRequest(w){this.g.$addInteractiveSessionRequest(w)}sendInteractiveRequestToProvider(w,g){this.g.$sendInteractiveRequestToProvider(w,g)}async $prepareInteractiveSession(w,g,S){const p=this.b.get(w);if(!p)return;const l=await p.provider.prepareSession(g,S);if(!l)return;const t=h.a++;return this.d.set(t,l),{id:t,requesterUsername:l.requester?.name,requesterAvatarIconUri:l.requester?.icon,responderUsername:l.responder?.name,responderAvatarIconUri:l.responder?.icon,inputPlaceholder:l.inputPlaceholder}}async $resolveInteractiveRequest(w,g,S,p){const l=this.b.get(w);if(!l)return;const t=this.d.get(g);if(!t||!l.provider.resolveRequest)return;const o=await l.provider.resolveRequest(t,S,p);if(o)return{message:typeof o.message=="string"?o.message:A.InteractiveSessionReplyFollowup.from(o.message)}}async $provideWelcomeMessage(w,g){const S=this.b.get(w);if(!S||!S.provider.provideWelcomeMessage)return;const p=await S.provider.provideWelcomeMessage(g);if(p)return p.map(l=>typeof l=="string"?l:l.map(t=>A.InteractiveSessionReplyFollowup.from(t)))}async $provideFollowups(w,g,S){const p=this.b.get(w);if(!p)return;const l=this.d.get(g);return!l||!p.provider.provideFollowups?void 0:(await p.provider.provideFollowups(l,S))?.map(o=>A.InteractiveSessionFollowup.from(o))}async $provideInteractiveReply(w,g,S,p){const l=this.b.get(w);if(!l)return;const t=this.d.get(g);if(!t)return;const o={session:t,message:typeof S.message=="string"?S.message:A.InteractiveSessionReplyFollowup.to(S.message)},d=I.StopWatch.create(!1);let D;const T={report:a=>{p.isCancellationRequested||(typeof D>"u"&&(D=d.elapsed()),this.g.$acceptInteractiveResponseProgress(w,g,a))}};let v;try{v=await l.provider.provideResponseWithProgress(o,T,p),v||(v={errorDetails:{message:(0,L.localize)(0,null)}})}catch(a){v={errorDetails:{message:(0,L.localize)(1,null,a.message),responseIsIncomplete:!0}},this.h.error(a)}try{if(t.saveState&&this.d.has(g)){const a=t.saveState();this.g.$acceptInteractiveSessionState(g,a)}}catch(a){this.h.warn(a)}const i={firstProgress:D??0,totalElapsed:d.elapsed()};return{errorDetails:v.errorDetails,timings:i}}async $provideSlashCommands(w,g,S){const p=this.b.get(w);if(!p)return;const l=this.d.get(g);return!l||!p.provider.provideSlashCommands?void 0:(await p.provider.provideSlashCommands(l,S))?.map(o=>({...o,kind:A.CompletionItemKind.from(o.kind)}))}$releaseSession(w){this.d.delete(w)}async $onDidPerformUserAction(w){this.e.fire(w)}}e.ExtHostInteractiveSession=h,h.a=0}),define(Pe[229],Ae([1,0,4,7]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostIssueReporter=void 0;class I{constructor(R){this.a=new Map,this.b=R.getProxy(n.MainContext.MainThreadIssueReporter)}async $getIssueReporterUri(R,A){if(this.a.size===0)throw new Error("No issue request handlers registered");const y=this.a.get(R);if(!y)throw new Error("Issue request handler not found");const h=await y.handleIssueUrlRequest();if(!h)throw new Error("Issue request handler returned no result");return h}registerIssueUriRequestHandler(R,A){const y=R.identifier.value;return this.a.set(y,A),this.b.$registerIssueUriRequestHandler(y),new P.Disposable(()=>{this.b.$unregisterIssueUriRequestHandler(y),this.a.delete(y)})}}e.ExtHostIssueReporter=I}),define(Pe[230],Ae([1,0,6,4]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class I{constructor(R){this.b=0,this.a=R.getProxy(P.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,R),(0,n.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=I}),define(Pe[231],Ae([1,0,2,23,8,7,77,4,13,44,16,12,272,21,6,90,84,54,58,9,17,26,148]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t,o,d,D,T,v,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class a{constructor(C,W){this.d=C,this.e=W}async provideDocumentSymbols(C,W){const q=this.d.getDocument(C),x=await this.e.provideDocumentSymbols(q,W);if(!(0,O.isFalsyOrEmpty)(x))return x[0]instanceof L.DocumentSymbol?x.map(I.DocumentSymbol.from):a.f(x)}static f(C){C=C.slice(0).sort((x,ae)=>{let ge=x.location.range.start.compareTo(ae.location.range.start);return ge===0&&(ge=ae.location.range.end.compareTo(x.location.range.end)),ge});const W=[],q=[];for(const x of C){const ae={name:x.name||"!!MISSING: name!!",kind:I.SymbolKind.from(x.kind),tags:x.tags?.map(I.SymbolTag.from)||[],detail:"",containerName:x.containerName,range:I.Range.from(x.location.range),selectionRange:I.Range.from(x.location.range),children:[]};for(;;){if(q.length===0){q.push(ae),W.push(ae);break}const ge=q[q.length-1];if(h.Range.containsRange(ge.range,ae.range)&&!h.Range.equalsRange(ge.range,ae.range)){ge.children?.push(ae),q.push(ae);break}q.pop()}}return W}}class r{constructor(C,W,q){this.g=C,this.h=W,this.j=q,this.e=new o.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(C,W){const q=this.g.getDocument(C),x=await this.j.provideCodeLenses(q,W);if(!x||W.isCancellationRequested)return;const ae=this.e.add(x),ge=new p.DisposableStore;this.f.set(ae,ge);const ee={cacheId:ae,lenses:[]};for(let we=0;we<x.length;we++)ee.lenses.push({cacheId:[ae,we],range:I.Range.from(x[we].range),command:this.h.toInternal(x[we].command,ge)});return ee}async resolveCodeLens(C,W){const q=C.cacheId&&this.e.get(...C.cacheId);if(!q)return;let x;if(typeof this.j.resolveCodeLens!="function"||q.isResolved?x=q:x=await this.j.resolveCodeLens(q,W),x||(x=q),W.isCancellationRequested)return;const ae=C.cacheId&&this.f.get(C.cacheId[0]);if(ae)return C.command=this.h.toInternal(x.command??r.d,ae),C}releaseCodeLenses(C){this.f.get(C)?.dispose(),this.f.delete(C),this.e.delete(C)}}r.d={command:"missing",title:"!!MISSING: command!!"};function s(ne){return Array.isArray(ne)?ne.map(I.DefinitionLink.from):ne?[I.DefinitionLink.from(ne)]:[]}class E{constructor(C,W){this.d=C,this.e=W}async provideDefinition(C,W,q){const x=this.d.getDocument(C),ae=I.Position.to(W),ge=await this.e.provideDefinition(x,ae,q);return s(ge)}}class k{constructor(C,W){this.d=C,this.e=W}async provideDeclaration(C,W,q){const x=this.d.getDocument(C),ae=I.Position.to(W),ge=await this.e.provideDeclaration(x,ae,q);return s(ge)}}class c{constructor(C,W){this.d=C,this.e=W}async provideImplementation(C,W,q){const x=this.d.getDocument(C),ae=I.Position.to(W),ge=await this.e.provideImplementation(x,ae,q);return s(ge)}}class u{constructor(C,W){this.d=C,this.e=W}async provideTypeDefinition(C,W,q){const x=this.d.getDocument(C),ae=I.Position.to(W),ge=await this.e.provideTypeDefinition(x,ae,q);return s(ge)}}class m{constructor(C,W){this.d=C,this.e=W}async provideHover(C,W,q){const x=this.d.getDocument(C),ae=I.Position.to(W),ge=await this.e.provideHover(x,ae,q);if(!(!ge||(0,O.isFalsyOrEmpty)(ge.contents)))return ge.range||(ge.range=x.getWordRangeAtPosition(ae)),ge.range||(ge.range=new L.Range(ae,ae)),I.Hover.from(ge)}}class b{constructor(C,W){this.d=C,this.e=W}async provideEvaluatableExpression(C,W,q){const x=this.d.getDocument(C),ae=I.Position.to(W),ge=await this.e.provideEvaluatableExpression(x,ae,q);if(ge)return I.EvaluatableExpression.from(ge)}}class f{constructor(C,W){this.d=C,this.e=W}async provideInlineValues(C,W,q,x){const ae=this.d.getDocument(C),ge=await this.e.provideInlineValues(ae,I.Range.to(W),I.InlineValueContext.to(q),x);if(Array.isArray(ge))return ge.map(ee=>I.InlineValue.from(ee))}}class N{constructor(C,W){this.d=C,this.e=W}async provideDocumentHighlights(C,W,q){const x=this.d.getDocument(C),ae=I.Position.to(W),ge=await this.e.provideDocumentHighlights(x,ae,q);if(Array.isArray(ge))return ge.map(I.DocumentHighlight.from)}}class V{constructor(C,W){this.d=C,this.e=W}async provideLinkedEditingRanges(C,W,q){const x=this.d.getDocument(C),ae=I.Position.to(W),ge=await this.e.provideLinkedEditingRanges(x,ae,q);if(ge&&Array.isArray(ge.ranges))return{ranges:(0,O.coalesce)(ge.ranges.map(I.Range.from)),wordPattern:ge.wordPattern}}}class _{constructor(C,W){this.d=C,this.e=W}async provideReferences(C,W,q,x){const ae=this.d.getDocument(C),ge=I.Position.to(W),ee=await this.e.provideReferences(ae,ge,q,x);if(Array.isArray(ee))return ee.map(I.location.from)}}class G{constructor(C,W,q,x,ae,ge,ee){this.g=C,this.h=W,this.j=q,this.k=x,this.l=ae,this.m=ge,this.n=ee,this.e=new o.Cache("CodeAction"),this.f=new Map}async provideCodeActions(C,W,q,x){const ae=this.g.getDocument(C),ge=g.Selection.isISelection(W)?I.Selection.to(W):I.Range.to(W),ee=[];for(const Ye of this.j.getDiagnostics(C))if(ge.intersection(Ye.range)&&ee.push(Ye)>G.d)break;const we={diagnostics:ee,only:q.only?new L.CodeActionKind(q.only):void 0,triggerKind:I.CodeActionTriggerKind.to(q.trigger)},ye=await this.k.provideCodeActions(ae,ge,we,x);if(!(0,O.isNonEmptyArray)(ye)||x.isCancellationRequested)return;const ze=this.e.add(ye),je=new p.DisposableStore;this.f.set(ze,je);const et=[];for(let Ye=0;Ye<ye.length;Ye++){const Je=ye[Ye];Je&&(G.o(Je)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:Je.title,command:this.h.toInternal(Je,je)})):(we.only&&(Je.kind?we.only.contains(Je.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action is of kind '${Je.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${we.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),et.push({cacheId:[ze,Ye],title:Je.title,command:Je.command&&this.h.toInternal(Je.command,je),diagnostics:Je.diagnostics&&Je.diagnostics.map(I.Diagnostic.from),edit:Je.edit&&I.WorkspaceEdit.from(Je.edit,void 0),kind:Je.kind&&Je.kind.value,isPreferred:Je.isPreferred,disabled:Je.disabled?.reason})))}return{cacheId:ze,actions:et}}async resolveCodeAction(C,W){const[q,x]=C,ae=this.e.get(q,x);if(!ae||G.o(ae))return{};if(!this.k.resolveCodeAction)return{};const ge=await this.k.resolveCodeAction(ae,W)??ae;let ee;ge.edit&&(ee=I.WorkspaceEdit.from(ge.edit,void 0));let we;if(ge.command){const ye=this.f.get(q);ye&&(we=this.h.toInternal(ge.command,ye))}return{edit:ee,command:we}}releaseCodeActions(C){this.f.get(C)?.dispose(),this.f.delete(C),this.e.delete(C)}static o(C){return typeof C.command=="string"&&typeof C.title=="string"}}G.d=1e3;class ${constructor(C,W,q,x){this.d=C,this.e=W,this.f=q,this.g=x}async prepareDocumentPaste(C,W,q,x){if(!this.f.prepareDocumentPaste)return;const ae=this.e.getDocument(C),ge=W.map(we=>I.Range.to(we)),ee=I.DataTransfer.toDataTransfer(q,()=>{throw new D.NotImplementedError});return await this.f.prepareDocumentPaste(ae,ge,ee,x),I.DataTransfer.toDataTransferDTO(ee)}async providePasteEdits(C,W,q,x,ae){const ge=this.e.getDocument(W),ee=q.map(ze=>I.Range.to(ze)),we=I.DataTransfer.toDataTransfer(x,async ze=>(await this.d.$resolvePasteFileData(this.g,C,ze)).buffer),ye=await this.f.provideDocumentPasteEdits(ge,ee,we,ae);if(ye)return{insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?I.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class B{constructor(C,W){this.d=C,this.e=W}async provideDocumentFormattingEdits(C,W,q){const x=this.d.getDocument(C),ae=await this.e.provideDocumentFormattingEdits(x,W,q);if(Array.isArray(ae))return ae.map(I.TextEdit.from)}}class X{constructor(C,W){this.d=C,this.e=W}async provideDocumentRangeFormattingEdits(C,W,q,x){const ae=this.d.getDocument(C),ge=I.Range.to(W),ee=await this.e.provideDocumentRangeFormattingEdits(ae,ge,q,x);if(Array.isArray(ee))return ee.map(I.TextEdit.from)}async provideDocumentRangesFormattingEdits(C,W,q,x){(0,w.assertType)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const ae=this.d.getDocument(C),ge=W.map(I.Range.to),ee=await this.e.provideDocumentRangesFormattingEdits(ae,ge,q,x);if(Array.isArray(ee))return ee.map(I.TextEdit.from)}}class U{constructor(C,W){this.d=C,this.e=W,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(C,W,q,x,ae){const ge=this.d.getDocument(C),ee=I.Position.to(W),we=await this.e.provideOnTypeFormattingEdits(ge,ee,q,x,ae);if(Array.isArray(we))return we.map(I.TextEdit.from)}}class j{constructor(C,W){this.e=C,this.f=W,this.d=new o.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(C,W){const q=await this.e.provideWorkspaceSymbols(C,W);if(!(0,O.isNonEmptyArray)(q))return{symbols:[]};const x=this.d.add(q),ae={cacheId:x,symbols:[]};for(let ge=0;ge<q.length;ge++){const ee=q[ge];if(!ee||!ee.name){this.f.warn("INVALID SymbolInformation",ee);continue}ae.symbols.push({...I.WorkspaceSymbol.from(ee),cacheId:[x,ge]})}return ae}async resolveWorkspaceSymbol(C,W){if(typeof this.e.resolveWorkspaceSymbol!="function"||!C.cacheId)return C;const q=this.d.get(...C.cacheId);if(q){const x=await this.e.resolveWorkspaceSymbol(q,W);return x&&(0,P.mixin)(C,I.WorkspaceSymbol.from(x),!0)}}releaseWorkspaceSymbols(C){this.d.delete(C)}}class Y{static supportsResolving(C){return typeof C.prepareRename=="function"}constructor(C,W,q){this.d=C,this.e=W,this.f=q}async provideRenameEdits(C,W,q,x){const ae=this.d.getDocument(C),ge=I.Position.to(W);try{const ee=await this.e.provideRenameEdits(ae,ge,q,x);return ee?I.WorkspaceEdit.from(ee):void 0}catch(ee){const we=Y.g(ee);return we?{rejectReason:we,edits:void 0}:Promise.reject(ee)}}async resolveRenameLocation(C,W,q){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const x=this.d.getDocument(C),ae=I.Position.to(W);try{const ge=await this.e.prepareRename(x,ae,q);let ee,we;if(L.Range.isRange(ge)?(ee=ge,we=x.getText(ge)):(0,w.isObject)(ge)&&(ee=ge.range,we=ge.placeholder),!ee||!we)return;if(ee.start.line>ae.line||ee.end.line<ae.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:I.Range.from(ee),text:we}}catch(ge){const ee=Y.g(ge);return ee?{rejectReason:ee,range:void 0,text:void 0}:Promise.reject(ge)}}static g(C){return typeof C=="string"?C:C instanceof Error&&typeof C.message=="string"?C.message:void 0}}class pe{constructor(C,W){this.resultId=C,this.tokens=W}}class Ee{constructor(C,W){this.f=C,this.g=W,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(C,W,q){const x=this.f.getDocument(C),ae=W!==0?this.d.get(W):null;let ge=typeof ae?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(x,ae.resultId,q):await this.g.provideDocumentSemanticTokens(x,q);return ae&&this.d.delete(W),ge?(ge=Ee.h(ge),this.o(Ee.n(ae,ge),ge)):null}async releaseDocumentSemanticColoring(C){this.d.delete(C)}static h(C){return Ee.j(C)?Ee.k(C)?C:new L.SemanticTokens(new Uint32Array(C.data),C.resultId):Ee.l(C)?Ee.m(C)?C:new L.SemanticTokensEdits(C.edits.map(W=>new L.SemanticTokensEdit(W.start,W.deleteCount,W.data?new Uint32Array(W.data):W.data)),C.resultId):C}static j(C){return C&&!!C.data}static k(C){return C.data instanceof Uint32Array}static l(C){return C&&Array.isArray(C.edits)}static m(C){for(const W of C.edits)if(!(W.data instanceof Uint32Array))return!1;return!0}static n(C,W){if(!Ee.j(W)||!C||!C.tokens)return W;const q=C.tokens,x=q.length,ae=W.data,ge=ae.length;let ee=0;const we=Math.min(x,ge);for(;ee<we&&q[ee]===ae[ee];)ee++;if(ee===x&&ee===ge)return new L.SemanticTokensEdits([],W.resultId);let ye=0;const ze=we-ee;for(;ye<ze&&q[x-ye-1]===ae[ge-ye-1];)ye++;return new L.SemanticTokensEdits([{start:ee,deleteCount:x-ee-ye,data:ae.subarray(ee,ge-ye)}],W.resultId)}o(C,W){if(Ee.j(C)){const q=this.e++;return this.d.set(q,new pe(C.resultId,C.data)),(0,l.encodeSemanticTokensDto)({id:q,type:"full",data:C.data})}if(Ee.l(C)){const q=this.e++;return Ee.j(W)?this.d.set(q,new pe(W.resultId,W.data)):this.d.set(q,new pe(C.resultId)),(0,l.encodeSemanticTokensDto)({id:q,type:"delta",deltas:(C.edits||[]).map(x=>({start:x.start,deleteCount:x.deleteCount,data:x.data}))})}return null}}class he{constructor(C,W){this.d=C,this.e=W}async provideDocumentRangeSemanticTokens(C,W,q){const x=this.d.getDocument(C),ae=await this.e.provideDocumentRangeSemanticTokens(x,I.Range.to(W),q);return ae?this.f(ae):null}f(C){return(0,l.encodeSemanticTokensDto)({id:0,type:"full",data:C.data})}}class de{static supportsResolving(C){return typeof C.resolveCompletionItem=="function"}constructor(C,W,q,x,ae){this.f=C,this.g=W,this.h=q,this.j=x,this.k=ae,this.d=new o.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(C,W,q,x){const ae=this.f.getDocument(C),ge=I.Position.to(W),ee=ae.getWordRangeAtPosition(ge)||new L.Range(ge,ge),we=ee.with({end:ge}),ye=new d.StopWatch(!0),ze=await this.h.provideCompletionItems(ae,ge,x,I.CompletionContext.to(q));if(!ze||x.isCancellationRequested)return;const je=Array.isArray(ze)?new L.CompletionList(ze):ze,et=de.supportsResolving(this.h)?this.d.add(je.items):this.d.add([]),Ye=new p.DisposableStore;this.e.set(et,Ye);const Je=[],rt={x:et,b:Je,a:{replace:I.Range.from(ee),insert:I.Range.from(we)},c:je.isIncomplete||void 0,d:ye.elapsed()};for(let ut=0;ut<je.items.length;ut++){const Me=je.items[ut],st=this.l(Me,[et,ut],we,ee);Je.push(st)}return rt}async resolveCompletionItem(C,W){if(typeof this.h.resolveCompletionItem!="function")return;const q=this.d.get(...C);if(!q)return;const x=await this.h.resolveCompletionItem(q,W);if(x)return this.l(x,C)}releaseCompletionItems(C){this.e.get(C)?.dispose(),this.e.delete(C),this.d.delete(C)}l(C,W,q,x){const ae=this.e.get(W[0]);if(!ae)throw Error("DisposableStore is missing...");const ge=this.g.toInternal(C.command,ae),ee={x:W,a:C.label,b:C.kind!==void 0?I.CompletionItemKind.from(C.kind):void 0,m:C.tags&&C.tags.map(I.CompletionItemTag.from),c:C.detail,d:typeof C.documentation>"u"?void 0:I.MarkdownString.fromStrict(C.documentation),e:C.sortText!==C.label?C.sortText:void 0,f:C.filterText!==C.label?C.filterText:void 0,g:C.preselect||void 0,i:C.keepWhitespace?1:0,k:C.commitCharacters?.join(""),l:C.additionalTextEdits&&C.additionalTextEdits.map(I.TextEdit.from),n:ge?.$ident,o:ge?.id,p:ge?.$ident?void 0:ge?.arguments};C.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ee.h=C.textEdit.newText):typeof C.insertText=="string"?ee.h=C.insertText:C.insertText instanceof L.SnippetString&&(ee.h=C.insertText.value,ee.i|=4);let we;return C.textEdit?we=C.textEdit.range:C.range&&(we=C.range),L.Range.isRange(we)?ee.j=I.Range.from(we):we&&(!q?.isEqual(we.inserting)||!x?.isEqual(we.replacing))&&(ee.j={insert:I.Range.from(we.inserting),replace:I.Range.from(we.replacing)}),ee}}class Re{async provideInlineCompletions(C,W,q,x){}disposeCompletions(C){}handleDidShowCompletionItem(C,W,q){}handlePartialAccept(C,W,q){}}class le extends Re{constructor(C,W,q,x){super(),this.f=C,this.g=W,this.h=q,this.j=x,this.d=new ue,this.e=(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[R.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[R.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,v.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(C,W,q,x){const ae=this.g.getDocument(C),ge=I.Position.to(W),ee=await this.h.provideInlineCompletionItems(ae,ge,{selectedCompletionInfo:q.selectedSuggestionInfo?{range:I.Range.to(q.selectedSuggestionInfo.range),text:q.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[q.triggerKind]},x);if(!ee||x.isCancellationRequested)return;const we=Array.isArray(ee)?ee:ee.items,ye=this.e?Array.isArray(ee)?[]:ee.commands||[]:[],ze=this.e&&!Array.isArray(ee)?ee.suppressSuggestions:void 0,je=this.e&&!Array.isArray(ee)?ee.enableForwardStability:void 0;let et;return{pid:this.d.createReferenceId({dispose(){et?.dispose()},items:we}),items:we.map((Je,rt)=>{let ut;Je.command&&(et||(et=new p.DisposableStore),ut=this.j.toInternal(Je.command,et));const Me=Je.insertText;return{insertText:typeof Me=="string"?Me:{snippet:Me.value},filterText:Je.filterText,range:Je.range?I.Range.from(Je.range):void 0,command:ut,idx:rt,completeBracketPairs:this.e?Je.completeBracketPairs:!1}}),commands:ye.map(Je=>(et||(et=new p.DisposableStore),this.j.toInternal(Je,et))),suppressSuggestions:ze,enableForwardStability:je}}disposeCompletions(C){this.d.disposeReferenceId(C)?.dispose()}handleDidShowCompletionItem(C,W,q){const x=this.d.get(C)?.items[W];x&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(x,q)}handlePartialAccept(C,W,q){const x=this.d.get(C)?.items[W];x&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(x,q)}}class ue{constructor(){this.d=new Map,this.e=1}createReferenceId(C){const W=this.e++;return this.d.set(W,C),W}disposeReferenceId(C){const W=this.d.get(C);return this.d.delete(C),W}get(C){return this.d.get(C)}}class H{constructor(C,W){this.e=C,this.f=W,this.d=new o.Cache("SignatureHelp")}async provideSignatureHelp(C,W,q,x){const ae=this.e.getDocument(C),ge=I.Position.to(W),ee=this.g(q),we=await this.f.provideSignatureHelp(ae,ge,x,ee);if(we){const ye=this.d.add([we]);return{...I.SignatureHelp.from(we),id:ye}}}g(C){let W;if(C.activeSignatureHelp){const q=I.SignatureHelp.to(C.activeSignatureHelp),x=this.d.get(C.activeSignatureHelp.id,0);x?(W=x,W.activeSignature=q.activeSignature,W.activeParameter=q.activeParameter):W=q}return{...C,activeSignatureHelp:W}}releaseSignatureHelp(C){this.d.delete(C)}}class F{constructor(C,W,q,x,ae){this.f=C,this.g=W,this.h=q,this.j=x,this.k=ae,this.d=new o.Cache("InlayHints"),this.e=new Map}async provideInlayHints(C,W,q){const x=this.f.getDocument(C),ae=I.Range.to(W),ge=await this.h.provideInlayHints(x,ae,q);if(!Array.isArray(ge)||ge.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${W}`);return}if(q.isCancellationRequested)return;const ee=this.d.add(ge);this.e.set(ee,new p.DisposableStore);const we={hints:[],cacheId:ee};for(let ye=0;ye<ge.length;ye++)this.l(ge[ye],ae)&&we.hints.push(this.m(ge[ye],[ee,ye]));return this.j.trace(`[InlayHints] ${we.hints.length} inlay hints from '${this.k.identifier.value}' for ${W}`),we}async resolveInlayHint(C,W){if(typeof this.h.resolveInlayHint!="function")return;const q=this.d.get(...C);if(!q)return;const x=await this.h.resolveInlayHint(q,W);if(x&&this.l(x))return this.m(x,C)}releaseHints(C){this.e.get(C)?.dispose(),this.e.delete(C),this.d.delete(C)}l(C,W){return C.label.length===0||Array.isArray(C.label)&&C.label.every(q=>q.value.length===0)?(console.log("INVALID inlay hint, empty label",C),!1):!(W&&!W.contains(C.position))}m(C,W){const q=this.e.get(W[0]);if(!q)throw Error("DisposableStore is missing...");const x={label:"",cacheId:W,tooltip:I.MarkdownString.fromStrict(C.tooltip),position:I.Position.from(C.position),textEdits:C.textEdits&&C.textEdits.map(I.TextEdit.from),kind:C.kind&&I.InlayHintKind.from(C.kind),paddingLeft:C.paddingLeft,paddingRight:C.paddingRight};return typeof C.label=="string"?x.label=C.label:x.label=C.label.map(ae=>{const ge={label:ae.value};return ge.tooltip=I.MarkdownString.fromStrict(ae.tooltip),L.Location.isLocation(ae.location)&&(ge.location=I.location.from(ae.location)),ae.command&&(ge.command=this.g.toInternal(ae.command,q)),ge}),x}}class Q{constructor(C,W){this.e=C,this.f=W,this.d=new o.Cache("DocumentLink")}async provideLinks(C,W){const q=this.e.getDocument(C),x=await this.f.provideDocumentLinks(q,W);if(!(!Array.isArray(x)||x.length===0)&&!W.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:x.filter(Q.g).map(I.DocumentLink.from)};{const ae=this.d.add(x),ge={links:[],cacheId:ae};for(let ee=0;ee<x.length;ee++){if(!Q.g(x[ee]))continue;const we=I.DocumentLink.from(x[ee]);we.cacheId=[ae,ee],ge.links.push(we)}return ge}}}static g(C){return C.target&&C.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(C,W){if(typeof this.f.resolveDocumentLink!="function")return;const q=this.d.get(...C);if(!q)return;const x=await this.f.resolveDocumentLink(q,W);if(!(!x||!Q.g(x)))return I.DocumentLink.from(x)}releaseLinks(C){this.d.delete(C)}}class me{constructor(C,W){this.d=C,this.e=W}async provideColors(C,W){const q=this.d.getDocument(C),x=await this.e.provideDocumentColors(q,W);return Array.isArray(x)?x.map(ge=>({color:I.Color.from(ge.color),range:I.Range.from(ge.range)})):[]}async provideColorPresentations(C,W,q){const x=this.d.getDocument(C),ae=I.Range.to(W.range),ge=I.Color.to(W.color),ee=await this.e.provideColorPresentations(ge,{document:x,range:ae},q);if(Array.isArray(ee))return ee.map(I.ColorPresentation.from)}}class Ce{constructor(C,W){this.d=C,this.e=W}async provideFoldingRanges(C,W,q){const x=this.d.getDocument(C),ae=await this.e.provideFoldingRanges(x,W,q);if(Array.isArray(ae))return ae.map(I.FoldingRange.from)}}class De{constructor(C,W,q){this.d=C,this.e=W,this.f=q}async provideSelectionRanges(C,W,q){const x=this.d.getDocument(C),ae=W.map(I.Position.to),ge=await this.e.provideSelectionRanges(x,ae,q);if(!(0,O.isNonEmptyArray)(ge))return[];if(ge.length!==ae.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const ee=[];for(let we=0;we<ae.length;we++){const ye=[];ee.push(ye);let ze=ae[we],je=ge[we];for(;;){if(!je.range.contains(ze))throw new Error("INVALID selection range, must contain the previous range");if(ye.push(I.SelectionRange.from(je)),!je.parent)break;ze=je.range,je=je.parent}}return ee}}class be{constructor(C,W){this.f=C,this.g=W,this.d=new t.IdGenerator(""),this.e=new Map}async prepareSession(C,W,q){const x=this.f.getDocument(C),ae=I.Position.to(W),ge=await this.g.prepareCallHierarchy(x,ae,q);if(!ge)return;const ee=this.d.nextId();return this.e.set(ee,new Map),Array.isArray(ge)?ge.map(we=>this.h(ee,we)):[this.h(ee,ge)]}async provideCallsTo(C,W,q){const x=this.j(C,W);if(!x)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyIncomingCalls(x,q);if(ae)return ae.map(ge=>({from:this.h(C,ge.from),fromRanges:ge.fromRanges.map(ee=>I.Range.from(ee))}))}async provideCallsFrom(C,W,q){const x=this.j(C,W);if(!x)throw new Error("missing call hierarchy item");const ae=await this.g.provideCallHierarchyOutgoingCalls(x,q);if(ae)return ae.map(ge=>({to:this.h(C,ge.to),fromRanges:ge.fromRanges.map(ee=>I.Range.from(ee))}))}releaseSession(C){this.e.delete(C)}h(C,W){const q=this.e.get(C),x=I.CallHierarchyItem.from(W,C,q.size.toString(36));return q.set(x._itemId,W),x}j(C,W){return this.e.get(C)?.get(W)}}class ke{constructor(C,W){this.f=C,this.g=W,this.d=new t.IdGenerator(""),this.e=new Map}async prepareSession(C,W,q){const x=this.f.getDocument(C),ae=I.Position.to(W),ge=await this.g.prepareTypeHierarchy(x,ae,q);if(!ge)return;const ee=this.d.nextId();return this.e.set(ee,new Map),Array.isArray(ge)?ge.map(we=>this.h(ee,we)):[this.h(ee,ge)]}async provideSupertypes(C,W,q){const x=this.j(C,W);if(!x)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySupertypes(x,q);if(ae)return ae.map(ge=>this.h(C,ge))}async provideSubtypes(C,W,q){const x=this.j(C,W);if(!x)throw new Error("missing type hierarchy item");const ae=await this.g.provideTypeHierarchySubtypes(x,q);if(ae)return ae.map(ge=>this.h(C,ge))}releaseSession(C){this.e.delete(C)}h(C,W){const q=this.e.get(C),x=I.TypeHierarchyItem.from(W,C,q.size.toString(36));return q.set(x._itemId,W),x}j(C,W){return this.e.get(C)?.get(W)}}class oe{constructor(C,W,q,x,ae){this.d=C,this.e=W,this.f=q,this.g=x,this.h=ae}async provideDocumentOnDropEdits(C,W,q,x,ae){const ge=this.e.getDocument(W),ee=I.Position.to(q),we=I.DataTransfer.toDataTransfer(x,async ze=>(await this.d.$resolveDocumentOnDropFileData(this.g,C,ze)).buffer),ye=await this.f.provideDocumentDropEdits(ge,ee,we,ae);if(ye)return{label:ye.label??(0,i.localize)(0,null,this.h.displayName||this.h.name),insertText:typeof ye.insertText=="string"?ye.insertText:{snippet:ye.insertText.value},additionalEdit:ye.additionalEdit?I.WorkspaceEdit.from(ye.additionalEdit,void 0):void 0}}}class ce{constructor(C,W){this.adapter=C,this.extension=W}}class ie{constructor(C,W,q,x,ae,ge,ee,we){this.g=W,this.h=q,this.j=x,this.k=ae,this.l=ge,this.m=ee,this.n=we,this.f=new Map,this.e=C.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(C,W){return I.DocumentSelector.from(C,this.g,W)}p(C){return new L.Disposable(()=>{this.f.delete(C),this.e.$unregister(C)})}q(){return ie.d++}async s(C,W,q,x,ae,ge=!1){const ee=this.f.get(C);if(!ee||!(ee.adapter instanceof W))return x;const we=Date.now();ge||this.l.trace(`[${ee.extension.identifier.value}] INVOKE provider '${q.toString().replace(/[\r\n]/g,"")}'`);const ye=q(ee.adapter,ee.extension);return Promise.resolve(ye).catch(ze=>{(0,D.isCancellationError)(ze)||(this.l.error(`[${ee.extension.identifier.value}] provider FAILED`),this.l.error(ze),this.n.onExtensionError(ee.extension.identifier,ze))}).finally(()=>{ge||this.l.trace(`[${ee.extension.identifier.value}] provider DONE after ${Date.now()-we}ms`)}),S.CancellationToken.isCancellationToken(ae)?(0,T.raceCancellationError)(ye,ae):ye}t(C,W){const q=this.q();return this.f.set(q,new ce(C,W)),q}static u(C){return C.displayName||C.name}registerDocumentSymbolProvider(C,W,q,x){const ae=this.t(new a(this.h,q),C),ge=x&&x.label||ie.u(C);return this.e.$registerDocumentSymbolProvider(ae,this.o(W,C),ge),this.p(ae)}$provideDocumentSymbols(C,W,q){return this.s(C,a,x=>x.provideDocumentSymbols(n.URI.revive(W),q),void 0,q)}registerCodeLensProvider(C,W,q){const x=this.q(),ae=typeof q.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(x,new ce(new r(this.h,this.j.converter,q),C)),this.e.$registerCodeLensSupport(x,this.o(W,C),ae);let ge=this.p(x);if(ae!==void 0){const ee=q.onDidChangeCodeLenses(we=>this.e.$emitCodeLensEvent(ae));ge=L.Disposable.from(ge,ee)}return ge}$provideCodeLenses(C,W,q){return this.s(C,r,x=>x.provideCodeLenses(n.URI.revive(W),q),void 0,q)}$resolveCodeLens(C,W,q){return this.s(C,r,x=>x.resolveCodeLens(W,q),void 0,void 0)}$releaseCodeLenses(C,W){this.s(C,r,q=>Promise.resolve(q.releaseCodeLenses(W)),void 0,void 0)}registerDefinitionProvider(C,W,q){const x=this.t(new E(this.h,q),C);return this.e.$registerDefinitionSupport(x,this.o(W,C)),this.p(x)}$provideDefinition(C,W,q,x){return this.s(C,E,ae=>ae.provideDefinition(n.URI.revive(W),q,x),[],x)}registerDeclarationProvider(C,W,q){const x=this.t(new k(this.h,q),C);return this.e.$registerDeclarationSupport(x,this.o(W,C)),this.p(x)}$provideDeclaration(C,W,q,x){return this.s(C,k,ae=>ae.provideDeclaration(n.URI.revive(W),q,x),[],x)}registerImplementationProvider(C,W,q){const x=this.t(new c(this.h,q),C);return this.e.$registerImplementationSupport(x,this.o(W,C)),this.p(x)}$provideImplementation(C,W,q,x){return this.s(C,c,ae=>ae.provideImplementation(n.URI.revive(W),q,x),[],x)}registerTypeDefinitionProvider(C,W,q){const x=this.t(new u(this.h,q),C);return this.e.$registerTypeDefinitionSupport(x,this.o(W,C)),this.p(x)}$provideTypeDefinition(C,W,q,x){return this.s(C,u,ae=>ae.provideTypeDefinition(n.URI.revive(W),q,x),[],x)}registerHoverProvider(C,W,q,x){const ae=this.t(new m(this.h,q),C);return this.e.$registerHoverProvider(ae,this.o(W,C)),this.p(ae)}$provideHover(C,W,q,x){return this.s(C,m,ae=>ae.provideHover(n.URI.revive(W),q,x),void 0,x)}registerEvaluatableExpressionProvider(C,W,q,x){const ae=this.t(new b(this.h,q),C);return this.e.$registerEvaluatableExpressionProvider(ae,this.o(W,C)),this.p(ae)}$provideEvaluatableExpression(C,W,q,x){return this.s(C,b,ae=>ae.provideEvaluatableExpression(n.URI.revive(W),q,x),void 0,x)}registerInlineValuesProvider(C,W,q,x){const ae=typeof q.onDidChangeInlineValues=="function"?this.q():void 0,ge=this.t(new f(this.h,q),C);this.e.$registerInlineValuesProvider(ge,this.o(W,C),ae);let ee=this.p(ge);if(ae!==void 0){const we=q.onDidChangeInlineValues(ye=>this.e.$emitInlineValuesEvent(ae));ee=L.Disposable.from(ee,we)}return ee}$provideInlineValues(C,W,q,x,ae){return this.s(C,f,ge=>ge.provideInlineValues(n.URI.revive(W),q,x,ae),void 0,ae)}registerDocumentHighlightProvider(C,W,q){const x=this.t(new N(this.h,q),C);return this.e.$registerDocumentHighlightProvider(x,this.o(W,C)),this.p(x)}$provideDocumentHighlights(C,W,q,x){return this.s(C,N,ae=>ae.provideDocumentHighlights(n.URI.revive(W),q,x),void 0,x)}registerLinkedEditingRangeProvider(C,W,q){const x=this.t(new V(this.h,q),C);return this.e.$registerLinkedEditingRangeProvider(x,this.o(W,C)),this.p(x)}$provideLinkedEditingRanges(C,W,q,x){return this.s(C,V,async ae=>{const ge=await ae.provideLinkedEditingRanges(n.URI.revive(W),q,x);if(ge)return{ranges:ge.ranges,wordPattern:ge.wordPattern?ie.w(ge.wordPattern):void 0}},void 0,x)}registerReferenceProvider(C,W,q){const x=this.t(new _(this.h,q),C);return this.e.$registerReferenceSupport(x,this.o(W,C)),this.p(x)}$provideReferences(C,W,q,x,ae){return this.s(C,_,ge=>ge.provideReferences(n.URI.revive(W),q,x,ae),void 0,ae)}registerCodeActionProvider(C,W,q,x){const ae=new p.DisposableStore,ge=this.t(new G(this.h,this.j.converter,this.k,q,this.l,C,this.m),C);return this.e.$registerQuickFixSupport(ge,this.o(W,C),{providedKinds:x?.providedCodeActionKinds?.map(ee=>ee.value),documentation:x?.documentation?.map(ee=>({kind:ee.kind.value,command:this.j.converter.toInternal(ee.command,ae)}))},ie.u(C),!!q.resolveCodeAction),ae.add(this.p(ge)),ae}$provideCodeActions(C,W,q,x,ae){return this.s(C,G,ge=>ge.provideCodeActions(n.URI.revive(W),q,x,ae),void 0,ae)}$resolveCodeAction(C,W,q){return this.s(C,G,x=>x.resolveCodeAction(W,q),{},void 0)}$releaseCodeActions(C,W){this.s(C,G,q=>Promise.resolve(q.releaseCodeActions(W)),void 0,void 0)}registerDocumentFormattingEditProvider(C,W,q){const x=this.t(new B(this.h,q),C);return this.e.$registerDocumentFormattingSupport(x,this.o(W,C),C.identifier,C.displayName||C.name),this.p(x)}$provideDocumentFormattingEdits(C,W,q,x){return this.s(C,B,ae=>ae.provideDocumentFormattingEdits(n.URI.revive(W),q,x),void 0,x)}registerDocumentRangeFormattingEditProvider(C,W,q){const x=typeof q.provideDocumentRangesFormattingEdits=="function";x&&(0,v.checkProposedApiEnabled)(C,"formatMultipleRanges");const ae=this.t(new X(this.h,q),C);return this.e.$registerRangeFormattingSupport(ae,this.o(W,C),C.identifier,C.displayName||C.name,x),this.p(ae)}$provideDocumentRangeFormattingEdits(C,W,q,x,ae){return this.s(C,X,ge=>ge.provideDocumentRangeFormattingEdits(n.URI.revive(W),q,x,ae),void 0,ae)}$provideDocumentRangesFormattingEdits(C,W,q,x,ae){return this.s(C,X,ge=>ge.provideDocumentRangesFormattingEdits(n.URI.revive(W),q,x,ae),void 0,ae)}registerOnTypeFormattingEditProvider(C,W,q,x){const ae=this.t(new U(this.h,q),C);return this.e.$registerOnTypeFormattingSupport(ae,this.o(W,C),x,C.identifier),this.p(ae)}$provideOnTypeFormattingEdits(C,W,q,x,ae,ge){return this.s(C,U,ee=>ee.provideOnTypeFormattingEdits(n.URI.revive(W),q,x,ae,ge),void 0,ge)}registerWorkspaceSymbolProvider(C,W){const q=this.t(new j(W,this.l),C);return this.e.$registerNavigateTypeSupport(q,typeof W.resolveWorkspaceSymbol=="function"),this.p(q)}$provideWorkspaceSymbols(C,W,q){return this.s(C,j,x=>x.provideWorkspaceSymbols(W,q),{symbols:[]},q)}$resolveWorkspaceSymbol(C,W,q){return this.s(C,j,x=>x.resolveWorkspaceSymbol(W,q),void 0,void 0)}$releaseWorkspaceSymbols(C,W){this.s(C,j,q=>q.releaseWorkspaceSymbols(W),void 0,void 0)}registerRenameProvider(C,W,q){const x=this.t(new Y(this.h,q,this.l),C);return this.e.$registerRenameSupport(x,this.o(W,C),Y.supportsResolving(q)),this.p(x)}$provideRenameEdits(C,W,q,x,ae){return this.s(C,Y,ge=>ge.provideRenameEdits(n.URI.revive(W),q,x,ae),void 0,ae)}$resolveRenameLocation(C,W,q,x){return this.s(C,Y,ae=>ae.resolveRenameLocation(n.URI.revive(W),q,x),void 0,x)}registerDocumentSemanticTokensProvider(C,W,q,x){const ae=this.t(new Ee(this.h,q),C),ge=typeof q.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(ae,this.o(W,C),x,ge);let ee=this.p(ae);if(ge){const we=q.onDidChangeSemanticTokens(ye=>this.e.$emitDocumentSemanticTokensEvent(ge));ee=L.Disposable.from(ee,we)}return ee}$provideDocumentSemanticTokens(C,W,q,x){return this.s(C,Ee,ae=>ae.provideDocumentSemanticTokens(n.URI.revive(W),q,x),null,x)}$releaseDocumentSemanticTokens(C,W){this.s(C,Ee,q=>q.releaseDocumentSemanticColoring(W),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(C,W,q,x){const ae=this.t(new he(this.h,q),C);return this.e.$registerDocumentRangeSemanticTokensProvider(ae,this.o(W,C),x),this.p(ae)}$provideDocumentRangeSemanticTokens(C,W,q,x){return this.s(C,he,ae=>ae.provideDocumentRangeSemanticTokens(n.URI.revive(W),q,x),null,x)}registerCompletionItemProvider(C,W,q,x){const ae=this.t(new de(this.h,this.j.converter,q,this.m,C),C);return this.e.$registerCompletionsProvider(ae,this.o(W,C),x,de.supportsResolving(q),`${C.identifier.value}(${x.join("")})`),this.p(ae)}$provideCompletionItems(C,W,q,x,ae){return this.s(C,de,ge=>ge.provideCompletionItems(n.URI.revive(W),q,x,ae),void 0,ae)}$resolveCompletionItem(C,W,q){return this.s(C,de,x=>x.resolveCompletionItem(W,q),void 0,q)}$releaseCompletionItems(C,W){this.s(C,de,q=>q.releaseCompletionItems(W),void 0,void 0)}registerInlineCompletionsProvider(C,W,q){const x=new le(C,this.h,q,this.j.converter),ae=this.t(x,C);return this.e.$registerInlineCompletionsSupport(ae,this.o(W,C),x.supportsHandleEvents),this.p(ae)}$provideInlineCompletions(C,W,q,x,ae){return this.s(C,Re,ge=>ge.provideInlineCompletions(n.URI.revive(W),q,x,ae),void 0,ae)}$handleInlineCompletionDidShow(C,W,q,x){this.s(C,Re,async ae=>{ae.handleDidShowCompletionItem(W,q,x)},void 0,void 0)}$handleInlineCompletionPartialAccept(C,W,q,x){this.s(C,Re,async ae=>{ae.handlePartialAccept(W,q,x)},void 0,void 0)}$freeInlineCompletionsList(C,W){this.s(C,Re,async q=>{q.disposeCompletions(W)},void 0,void 0)}registerSignatureHelpProvider(C,W,q,x){const ae=Array.isArray(x)?{triggerCharacters:x,retriggerCharacters:[]}:x,ge=this.t(new H(this.h,q),C);return this.e.$registerSignatureHelpProvider(ge,this.o(W,C),ae),this.p(ge)}$provideSignatureHelp(C,W,q,x,ae){return this.s(C,H,ge=>ge.provideSignatureHelp(n.URI.revive(W),q,x,ae),void 0,ae)}$releaseSignatureHelp(C,W){this.s(C,H,q=>q.releaseSignatureHelp(W),void 0,void 0)}registerInlayHintsProvider(C,W,q){const x=typeof q.onDidChangeInlayHints=="function"?this.q():void 0,ae=this.t(new F(this.h,this.j.converter,q,this.l,C),C);this.e.$registerInlayHintsProvider(ae,this.o(W,C),typeof q.resolveInlayHint=="function",x,ie.u(C));let ge=this.p(ae);if(x!==void 0){const ee=q.onDidChangeInlayHints(we=>this.e.$emitInlayHintsEvent(x));ge=L.Disposable.from(ge,ee)}return ge}$provideInlayHints(C,W,q,x){return this.s(C,F,ae=>ae.provideInlayHints(n.URI.revive(W),q,x),void 0,x)}$resolveInlayHint(C,W,q){return this.s(C,F,x=>x.resolveInlayHint(W,q),void 0,q)}$releaseInlayHints(C,W){this.s(C,F,q=>q.releaseHints(W),void 0,void 0)}registerDocumentLinkProvider(C,W,q){const x=this.t(new Q(this.h,q),C);return this.e.$registerDocumentLinkProvider(x,this.o(W,C),typeof q.resolveDocumentLink=="function"),this.p(x)}$provideDocumentLinks(C,W,q){return this.s(C,Q,x=>x.provideLinks(n.URI.revive(W),q),void 0,q,W.scheme==="output")}$resolveDocumentLink(C,W,q){return this.s(C,Q,x=>x.resolveLink(W,q),void 0,void 0,!0)}$releaseDocumentLinks(C,W){this.s(C,Q,q=>q.releaseLinks(W),void 0,void 0,!0)}registerColorProvider(C,W,q){const x=this.t(new me(this.h,q),C);return this.e.$registerDocumentColorProvider(x,this.o(W,C)),this.p(x)}$provideDocumentColors(C,W,q){return this.s(C,me,x=>x.provideColors(n.URI.revive(W),q),[],q)}$provideColorPresentations(C,W,q,x){return this.s(C,me,ae=>ae.provideColorPresentations(n.URI.revive(W),q,x),void 0,x)}registerFoldingRangeProvider(C,W,q){const x=this.q(),ae=typeof q.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(x,new ce(new Ce(this.h,q),C)),this.e.$registerFoldingRangeProvider(x,this.o(W,C),C.identifier,ae);let ge=this.p(x);if(ae!==void 0){const ee=q.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(ae));ge=L.Disposable.from(ge,ee)}return ge}$provideFoldingRanges(C,W,q,x){return this.s(C,Ce,ae=>ae.provideFoldingRanges(n.URI.revive(W),q,x),void 0,x)}registerSelectionRangeProvider(C,W,q){const x=this.t(new De(this.h,q,this.l),C);return this.e.$registerSelectionRangeProvider(x,this.o(W,C)),this.p(x)}$provideSelectionRanges(C,W,q,x){return this.s(C,De,ae=>ae.provideSelectionRanges(n.URI.revive(W),q,x),[],x)}registerCallHierarchyProvider(C,W,q){const x=this.t(new be(this.h,q),C);return this.e.$registerCallHierarchyProvider(x,this.o(W,C)),this.p(x)}$prepareCallHierarchy(C,W,q,x){return this.s(C,be,ae=>Promise.resolve(ae.prepareSession(n.URI.revive(W),q,x)),void 0,x)}$provideCallHierarchyIncomingCalls(C,W,q,x){return this.s(C,be,ae=>ae.provideCallsTo(W,q,x),void 0,x)}$provideCallHierarchyOutgoingCalls(C,W,q,x){return this.s(C,be,ae=>ae.provideCallsFrom(W,q,x),void 0,x)}$releaseCallHierarchy(C,W){this.s(C,be,q=>Promise.resolve(q.releaseSession(W)),void 0,void 0)}registerTypeHierarchyProvider(C,W,q){const x=this.t(new ke(this.h,q),C);return this.e.$registerTypeHierarchyProvider(x,this.o(W,C)),this.p(x)}$prepareTypeHierarchy(C,W,q,x){return this.s(C,ke,ae=>Promise.resolve(ae.prepareSession(n.URI.revive(W),q,x)),void 0,x)}$provideTypeHierarchySupertypes(C,W,q,x){return this.s(C,ke,ae=>ae.provideSupertypes(W,q,x),void 0,x)}$provideTypeHierarchySubtypes(C,W,q,x){return this.s(C,ke,ae=>ae.provideSubtypes(W,q,x),void 0,x)}$releaseTypeHierarchy(C,W){this.s(C,ke,q=>Promise.resolve(q.releaseSession(W)),void 0,void 0)}registerDocumentOnDropEditProvider(C,W,q,x){const ae=this.q();return this.f.set(ae,new ce(new oe(this.e,this.h,q,ae,C),C)),this.e.$registerDocumentOnDropEditProvider(ae,this.o(W,C),C.identifier,(0,v.isProposedApiEnabled)(C,"dropMetadata")?x:void 0),this.p(ae)}$provideDocumentOnDropEdits(C,W,q,x,ae,ge){return this.s(C,oe,ee=>Promise.resolve(ee.provideDocumentOnDropEdits(W,n.URI.revive(q),x,ae,ge)),void 0,void 0)}registerDocumentPasteEditProvider(C,W,q,x){const ae=this.q();return this.f.set(ae,new ce(new $(this.e,this.h,q,ae),C)),this.e.$registerPasteEditProvider(ae,this.o(W,C),!!q.prepareDocumentPaste,x.pasteMimeTypes),this.p(ae)}$prepareDocumentPaste(C,W,q,x,ae){return this.s(C,$,ge=>ge.prepareDocumentPaste(n.URI.revive(W),q,x,ae),void 0,ae)}$providePasteEdits(C,W,q,x,ae,ge){return this.s(C,$,ee=>ee.providePasteEdits(W,n.URI.revive(q),x,ae,ge),void 0,ge)}static w(C){return{pattern:C.source,flags:(0,y.regExpFlags)(C)}}static y(C){return{decreaseIndentPattern:ie.w(C.decreaseIndentPattern),increaseIndentPattern:ie.w(C.increaseIndentPattern),indentNextLinePattern:C.indentNextLinePattern?ie.w(C.indentNextLinePattern):void 0,unIndentedLinePattern:C.unIndentedLinePattern?ie.w(C.unIndentedLinePattern):void 0}}static z(C){return{beforeText:ie.w(C.beforeText),afterText:C.afterText?ie.w(C.afterText):void 0,previousLineText:C.previousLineText?ie.w(C.previousLineText):void 0,action:C.action}}static B(C){return C.map(ie.z)}setLanguageConfiguration(C,W,q){const{wordPattern:x}=q;if(x&&(0,y.regExpLeadsToEndlessLoop)(x))throw new Error(`Invalid language configuration: wordPattern '${x}' is not allowed to match the empty string.`);x?this.h.setWordDefinitionFor(W,x):this.h.setWordDefinitionFor(W,void 0),q.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",C,"Do not use."),q.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",C,"Do not use.");const ae=this.q(),ge={comments:q.comments,brackets:q.brackets,wordPattern:q.wordPattern?ie.w(q.wordPattern):void 0,indentationRules:q.indentationRules?ie.y(q.indentationRules):void 0,onEnterRules:q.onEnterRules?ie.B(q.onEnterRules):void 0,__electricCharacterSupport:q.__electricCharacterSupport,__characterPairSupport:q.__characterPairSupport};return this.e.$setLanguageConfiguration(ae,W,ge),this.p(ae)}$setWordDefinitions(C){for(const W of C)this.h.setWordDefinitionFor(W.languageId,new RegExp(W.regexSource,W.regexFlags))}}e.ExtHostLanguageFeatures=ie,ie.d=0}),define(Pe[232],Ae([1,0,4,8,7,29,17,6]),function(te,e,n,P,I,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(O,w,g,S){this.c=w,this.d=g,this.e=S,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(n.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,w){await this.a.$changeLanguage(O,w);const g=this.c.getDocumentData(O);if(!g)throw new Error(`document '${O.toString()}' NOT found`);return g.document}async tokenAtPosition(O,w){const g=O.version,S=P.Position.from(w),p=await this.a.$tokensAtPosition(O.uri,S),l={type:I.StandardTokenType.Other,range:O.getWordRangeAtPosition(w)??new I.Range(w.line,w.character,w.line,w.character)};if(!p)return l;const t={range:P.Range.to(p.range),type:P.TokenType.to(p.type)};return!t.range.contains(w)||g!==O.version?l:t}createLanguageStatusItem(O,w,g){const S=this.f++,p=this.a,l=this.g,t=`${O.identifier.value}/${w}`;if(l.has(t))throw new Error(`LanguageStatusItem with id '${w}' ALREADY exists`);l.add(t);const o={selector:g,id:w,name:O.displayName??O.name,severity:I.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let d;const D=new A.DisposableStore,T=()=>{d?.dispose(),d=(0,R.disposableTimeout)(()=>{D.clear(),this.a.$setLanguageStatus(S,{id:t,name:o.name??O.displayName??O.name,source:O.displayName??O.name,selector:P.DocumentSelector.from(o.selector,this.e),label:o.text,detail:o.detail??"",severity:o.severity===I.LanguageStatusSeverity.Error?L.default.Error:o.severity===I.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:o.command&&this.d.toInternal(o.command,D),accessibilityInfo:o.accessibilityInformation,busy:o.busy})},0)},v={dispose(){D.dispose(),d?.dispose(),p.$removeLanguageStatus(S),l.delete(t)},get id(){return o.id},get name(){return o.name},set name(i){o.name=i,T()},get selector(){return o.selector},set selector(i){o.selector=i,T()},get text(){return o.text},set text(i){o.text=i,T()},get detail(){return o.detail},set detail(i){o.detail=i,T()},get severity(){return o.severity},set severity(i){o.severity=i,T()},get accessibilityInformation(){return o.accessibilityInformation},set accessibilityInformation(i){o.accessibilityInformation=i,T()},get command(){return o.command},set command(i){o.command=i,T()},get busy(){return o.busy},set busy(i){o.busy=i,T()}};return T(),v}}e.ExtHostLanguages=y}),define(Pe[79],Ae([1,0,20,13,2,3,14,4,27,18]),function(te,e,n,P,I,L,R,A,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=e.ExtHostLocalizationService=class{constructor(g,S,p){this.f=p,this.d=new Map,this.a=S.getProxy(A.MainContext.MainThreadLocalization),this.b=g.environment.appLanguage,this.c=this.b===n.LANGUAGE_DEFAULT}getMessage(g,S){const{message:p,args:l,comment:t}=S;if(this.c)return(0,P.format2)(p,l??{});let o=p;t&&t.length>0&&(o+=`/${Array.isArray(t)?t.join(""):t}`);const d=this.d.get(g)?.contents[o];return d||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${o}`),(0,P.format2)(d??p,l??{})}getBundle(g){return this.d.get(g)?.contents}getBundleUri(g){return this.d.get(g)?.uri}async initializeLocalizedMessages(g){if(this.c||!g.l10n&&!g.isBuiltin||this.d.has(g.identifier.value))return;let S;const p=await this.g(g);if(!p){this.f.error(`No bundle location found for extension ${g.identifier.value}`);return}try{const l=await this.a.$fetchBundleContents(p),t=JSON.parse(l);S=g.isBuiltin?t.contents?.bundle:t}catch(l){this.f.error(`Failed to load translations for ${g.identifier.value} from ${p}: ${l.message}`);return}S&&this.d.set(g.identifier.value,{contents:S,uri:p})}async g(g){if(g.isBuiltin){const S=await this.a.$fetchBuiltInBundleUri(g.identifier.value,this.b);return I.URI.revive(S)}return g.l10n?I.URI.joinPath(g.extensionLocation,g.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.ExtHostLocalizationService=O=xe([qe(0,y.IExtHostInitDataService),qe(1,h.IExtHostRpcService),qe(2,R.ILogService)],O),e.IExtHostLocalizationService=(0,L.createDecorator)("IExtHostLocalizationService")}),define(Pe[233],Ae([1,0,14,4,27,18,2,67]),function(te,e,n,P,I,L,R,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=e.ExtHostLoggerService=class extends n.AbstractLoggerService{constructor(w,g){super(g.logLevel,g.logsLocation,g.loggers.map(S=>(0,A.revive)(S))),this.n=w.getProxy(P.MainContext.MainThreadLogger)}$setLogLevel(w,g){g?this.setLogLevel(R.URI.revive(g),w):this.setLogLevel(w)}setVisibility(w,g){super.setVisibility(w,g),this.n.$setVisibility(w,g)}m(w,g,S){return new h(this.n,w,g,S)}};e.ExtHostLoggerService=y=xe([qe(0,L.IExtHostRpcService),qe(1,I.IExtHostInitDataService)],y);class h extends n.AbstractMessageLogger{constructor(w,g,S,p){super(p?.logLevel==="always"),this.m=w,this.n=g,this.k=!1,this.l=[],this.setLevel(S),this.m.$createLogger(g,p).then(()=>{this.r(this.l),this.k=!0})}g(w,g){const S=[[w,g]];this.k?this.r(S):this.l.push(...S)}r(w){this.m.$log(this.n,w)}flush(){this.m.$flush(this.n)}}}),define(Pe[234],Ae([1,0,4,14,26]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(A){return A&&A.title}let R=e.ExtHostMessageService=class{constructor(y,h){this.b=h,this.a=y.getProxy(n.MainContext.MainThreadMessageService)}showMessage(y,h,O,w,g){const S={source:{identifier:y.identifier,label:y.displayName||y.name}};let p;typeof w=="string"||L(w)?p=[w,...g]:(S.modal=w?.modal,S.useCustom=w?.useCustom,S.detail=w?.detail,p=g),S.useCustom&&(0,I.checkProposedApiEnabled)(y,"resolvers");const l=[];for(let t=0;t<p.length;t++){const o=p[t];if(typeof o=="string")l.push({title:o,handle:t,isCloseAffordance:!1});else if(typeof o=="object"){const{title:d,isCloseAffordance:D}=o;l.push({title:d,isCloseAffordance:!!D,handle:t})}else this.b.warn("Invalid message item:",o)}return this.a.$showMessage(h,O,S,l).then(t=>{if(typeof t=="number")return p[t]})}};e.ExtHostMessageService=R=xe([qe(1,P.ILogService)],R)}),define(Pe[235],Ae([1,0,25,5,6,28,13,12,2,54,4,38,8,7,46,204,103,9]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class d{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(T=>T.apiEditor)}constructor(T,v,i,a){this.q=i,this.r=a,this.f=new Map,this.g=new L.ResourceMap,this.h=new Map,this.j=new P.Emitter({onListenerError:o.onUnexpectedExternalError}),this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new P.Emitter({onListenerError:o.onUnexpectedExternalError}),this.onDidOpenNotebookDocument=this.m.event,this.n=new P.Emitter({onListenerError:o.onUnexpectedExternalError}),this.onDidCloseNotebookDocument=this.n.event,this.o=new P.Emitter({onListenerError:o.onUnexpectedExternalError}),this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new h.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=T.getProxy(O.MainContext.MainThreadNotebook),this.c=T.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=T.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=v.converter,v.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===13){const s=r.notebookEditor?.notebookUri,E=r.cell.handle,c=this.g.get(s)?.getCell(E);if(c)return c.apiCell}if(r&&r.$mid===14){const s=r.uri,E=this.g.get(s);if(E)return E.apiNotebook}return r}}),d.x(v)}getEditorById(T){const v=this.h.get(T);if(!v)throw new Error(`unknown text editor: ${T}. known editors: ${[...this.h.keys()]} `);return v}getIdByEditor(T){for(const[v,i]of this.h)if(i.apiEditor===T)return v}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(T,v){const i=this.g.get(T);if(!i&&!v)throw new Error(`NO notebook document for '${T}'`);return i}static s(T,v){if(!v)return;const i=v.filenamePattern.map(a=>g.NotebookExclusiveDocumentPattern.from(a)).filter(a=>a!==void 0);if(v.filenamePattern&&!i){console.warn(`Notebook content provider view options file name pattern is invalid ${v.filenamePattern}`);return}return{extension:T.identifier,providerDisplayName:T.displayName||T.name,displayName:v.displayName,filenamePattern:i,exclusive:v.exclusive||!1}}registerNotebookCellStatusBarItemProvider(T,v,i){const a=d.a++,r=typeof i.onDidChangeCellStatusBarItems=="function"?d.a++:void 0;this.f.set(a,i),this.b.$registerNotebookCellStatusBarItemProvider(a,r,v);let s;return r!==void 0&&(s=i.onDidChangeCellStatusBarItems(E=>this.b.$emitCellStatusBarEvent(r))),new S.Disposable(()=>{this.f.delete(a),this.b.$unregisterNotebookCellStatusBarItemProvider(a,r),s?.dispose()})}async createNotebookDocument(T){const v=await this.c.$tryCreateNotebook({viewType:T.viewType,content:T.content&&g.NotebookData.from(T.content)});return y.URI.revive(v)}async openNotebookDocument(T){const v=this.g.get(T);if(v)return v.apiNotebook;const i=await this.c.$tryOpenNotebook(T),a=this.g.get(y.URI.revive(i));return(0,A.assertIsDefined)(a?.apiNotebook)}async showNotebookDocument(T,v){y.URI.isUri(T)&&(T=await this.openNotebookDocument(T));let i;typeof v=="object"?i={position:g.ViewColumn.from(v.viewColumn),preserveFocus:v.preserveFocus,selections:v.selections&&v.selections.map(g.NotebookRange.from),pinned:typeof v.preview=="boolean"?!v.preview:void 0}:i={preserveFocus:!1};const a=await this.d.$tryShowNotebookDocument(T.uri,T.notebookType,i),r=a&&this.h.get(a)?.apiEditor;if(r)return r;throw a?new Error(`Could NOT open editor for "${T.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${T.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(T,v,i,a){const r=this.f.get(T),s=y.URI.revive(v),E=this.g.get(s);if(!E||!r)return;const k=E.getCellFromIndex(i);if(!k)return;const c=await r.provideCellStatusBarItems(k.apiCell,a);if(!c)return;const u=new I.DisposableStore,m=this.p.add([u]),f=(Array.isArray(c)?c:[c]).map(N=>g.NotebookStatusBarItem.from(N,this.i,u));return{cacheId:m,items:f}}$releaseNotebookCellStatusBarItems(T){this.p.delete(T)}registerNotebookSerializer(T,v,i,a,r){if((0,R.isFalsyOrWhitespace)(v))throw new Error("viewType cannot be empty or just whitespace");const s=this.t++;return this.u.set(s,i),this.b.$registerNotebookSerializer(s,{id:T.identifier,location:T.extensionLocation},v,g.NotebookDocumentContentOptions.from(a),d.s(T,r)),(0,I.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(s)})}async $dataToNotebook(T,v,i){const a=this.u.get(T);if(!a)throw new Error("NO serializer found");const r=await a.deserializeNotebook(v.buffer,i);return new p.SerializableObjectWithBuffers(g.NotebookData.from(r))}async $notebookToData(T,v,i){const a=this.u.get(T);if(!a)throw new Error("NO serializer found");const r=await a.serializeNotebook(g.NotebookData.to(v.value),i);return n.VSBuffer.wrap(r)}w(T,v,i){if(this.h.has(v))throw new Error(`editor with id ALREADY EXSIST: ${v}`);const a=new t.ExtHostNotebookEditor(v,this.d,T,i.visibleRanges.map(g.NotebookRange.to),i.selections.map(g.NotebookRange.to),typeof i.viewColumn=="number"?g.ViewColumn.to(i.viewColumn):void 0);this.h.set(v,a)}$acceptDocumentAndEditorsDelta(T){if(T.value.removedDocuments)for(const i of T.value.removedDocuments){const a=y.URI.revive(i),r=this.g.get(a);r&&(r.dispose(),this.g.delete(a),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:r.apiNotebook.getCells().map(s=>s.document.uri)}),this.n.fire(r.apiNotebook));for(const s of this.h.values())s.notebookData.uri.toString()===a.toString()&&this.h.delete(s.id)}if(T.value.addedDocuments){const i=[];for(const a of T.value.addedDocuments){const r=y.URI.revive(a.uri);if(this.g.has(r))throw new Error(`adding EXISTING notebook ${r} `);const s=new l.ExtHostNotebookDocument(this.c,this.q,this.r,r,a);i.push(...a.cells.map(E=>l.ExtHostCell.asModelAddData(s.apiNotebook,E))),this.g.get(r)?.dispose(),this.g.set(r,s),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:i}),this.m.fire(s.apiNotebook)}}if(T.value.addedEditors)for(const i of T.value.addedEditors){if(this.h.has(i.id))return;const a=y.URI.revive(i.documentUri),r=this.g.get(a);r&&this.w(r,i.id,i)}const v=[];if(T.value.removedEditors)for(const i of T.value.removedEditors){const a=this.h.get(i);a&&(this.h.delete(i),this.k?.id===a.id&&(this.k=void 0),v.push(a))}if(T.value.visibleEditors){this.l=T.value.visibleEditors.map(a=>this.h.get(a)).filter(a=>!!a);const i=new Set;this.l.forEach(a=>i.add(a.id));for(const a of this.h.values()){const r=i.has(a.id);a._acceptVisibility(r)}this.l=[...this.h.values()].map(a=>a).filter(a=>a.visible),this.o.fire(this.visibleNotebookEditors)}T.value.newActiveEditor===null?this.k=void 0:T.value.newActiveEditor&&(this.h.get(T.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${T.value.newActiveEditor}`),this.k=this.h.get(T.value.newActiveEditor)),T.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(T){const v=w.ApiCommandArgument.String.with("notebookType","A notebook type"),i=new w.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[v,new w.ApiCommandArgument("data","Bytes to convert to data",r=>r instanceof Uint8Array,r=>n.VSBuffer.wrap(r))],new w.ApiCommandResult("Notebook Data",r=>g.NotebookData.to(r.value))),a=new w.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[v,new w.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",r=>!0,r=>new p.SerializableObjectWithBuffers(g.NotebookData.from(r)))],new w.ApiCommandResult("Bytes",r=>r.buffer));T.registerApiCommand(i),T.registerApiCommand(a)}}e.ExtHostNotebookController=d,d.a=0}),define(Pe[236],Ae([1,0,16,17,21,5,6,28,2,24,14,54,4,38,8,7,75,194,26,46]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t,o,d,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let T=e.ExtHostNotebookKernels=class{constructor(c,u,m,b,f){this.m=u,this.n=m,this.o=b,this.q=f,this.b=new A.ResourceMap,this.c=new A.ResourceMap,this.e=new Map,this.f=0,this.g=new Map,this.h=0,this.i=new w.Cache("NotebookKernelSourceActionProviderCache"),this.j=new Map,this.k=0,this.l=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this.l.event,this.a=c.getProxy(g.MainContext.MainThreadNotebookKernels);const N=new S.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new S.ApiCommandArgument("options","Select kernel options",V=>!0,V=>{if(V&&"notebookEditor"in V&&"id"in V){const _=this.n.getIdByEditor(V.notebookEditor);return{id:V.id,extension:V.extension,notebookEditorId:_}}else if(V&&"notebookEditor"in V){const _=this.n.getIdByEditor(V.notebookEditor);if(_===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${V.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:_}}return V})],S.ApiCommandResult.Void);this.o.registerApiCommand(N)}createNotebookController(c,u,m,b,f,N){for(const le of this.j.values())if(le.controller.id===u&&h.ExtensionIdentifier.equals(c.identifier,le.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const V=this.k++,_=this;this.q.trace(`NotebookController[${V}], CREATED by ${c.identifier.value}, ${u}`);const G=()=>console.warn(`NO execute handler from notebook controller '${j.id}' of extension: '${c.identifier}'`);let $=!1;const B=new R.DisposableStore,X=new L.Emitter,U=new L.Emitter,j={id:E(c.identifier,u),notebookType:m,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:b||c.identifier.value,preloads:N?N.map(p.NotebookRendererScript.from):[]};let Y=f??G,pe;this.a.$addKernel(V,j).catch(le=>{console.log(le),$=!0});let Ee=0;const he=()=>{if($)return;const le=++Ee;Promise.resolve().then(()=>{le===Ee&&this.a.$updateKernel(V,j)})},de=new A.ResourceMap,Re={get id(){return u},get notebookType(){return j.notebookType},onDidChangeSelectedNotebooks:X.event,get label(){return j.label},set label(le){j.label=le??c.displayName??c.name,he()},get detail(){return j.detail??""},set detail(le){j.detail=le,he()},get description(){return j.description??""},set description(le){j.description=le,he()},get supportedLanguages(){return j.supportedLanguages},set supportedLanguages(le){j.supportedLanguages=le,he()},get supportsExecutionOrder(){return j.supportsExecutionOrder??!1},set supportsExecutionOrder(le){j.supportsExecutionOrder=le,he()},get rendererScripts(){return j.preloads?j.preloads.map(p.NotebookRendererScript.to):[]},get executeHandler(){return Y},set executeHandler(le){Y=le??G},get interruptHandler(){return pe},set interruptHandler(le){pe=le,j.supportsInterrupt=!!le,he()},createNotebookCellExecution(le){if($)throw new Error("notebook controller is DISPOSED");if(!de.has(le.notebook.uri))throw _.q.trace(`NotebookController[${V}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.notebook.uri.toString()}`);return _._createNotebookCellExecution(le,E(c.identifier,this.id))},createNotebookExecution(le){if((0,d.checkProposedApiEnabled)(c,"notebookExecution"),$)throw new Error("notebook controller is DISPOSED");if(!de.has(le.uri))throw _.q.trace(`NotebookController[${V}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(de.keys()).map(ue=>ue.toString())),new Error(`notebook controller is NOT associated to notebook: ${le.uri.toString()}`);return _._createNotebookExecution(le,E(c.identifier,this.id))},dispose:()=>{$||(this.q.trace(`NotebookController[${V}], DISPOSED`),$=!0,this.j.delete(V),B.dispose(),X.dispose(),U.dispose(),this.a.$removeKernel(V))},updateNotebookAffinity(le,ue){ue===l.NotebookControllerAffinity2.Hidden&&(0,d.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),_.a.$updateNotebookPriority(V,le.uri,ue)},onDidReceiveMessage:U.event,postMessage(le,ue){return(0,d.checkProposedApiEnabled)(c,"notebookMessaging"),_.a.$postMessage(V,ue&&_.n.getIdByEditor(ue),le)},asWebviewUri(le){return(0,d.checkProposedApiEnabled)(c,"notebookMessaging"),(0,t.asWebviewUri)(le,_.m.remote)}};return this.j.set(V,{extensionId:c.identifier,controller:Re,onDidReceiveMessage:U,onDidChangeSelection:X,associatedNotebooks:de}),Re}getIdByController(c){for(const[u,m]of this.j)if(m.controller===c)return E(m.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,u){const m=this.f++,b=this;this.q.trace(`NotebookControllerDetectionTask[${m}], CREATED by ${c.identifier.value}`),this.a.$addKernelDetectionTask(m,u);const f={dispose:()=>{this.e.delete(m),b.a.$removeKernelDetectionTask(m)}};return this.e.set(m,f),f}registerKernelSourceActionProvider(c,u,m){const b=this.h++,f=typeof m.onDidChangeNotebookKernelSourceActions=="function"?b:void 0,N=this;this.g.set(b,m),this.q.trace(`NotebookKernelSourceActionProvider[${b}], CREATED by ${c.identifier.value}`),this.a.$addKernelSourceActionProvider(b,b,u);let V;return f!==void 0&&(V=m.onDidChangeNotebookKernelSourceActions(_=>this.a.$emitNotebookKernelSourceActionsChangeEvent(f))),{dispose:()=>{this.g.delete(b),N.a.$removeKernelSourceActionProvider(b,b),V?.dispose()}}}async $provideKernelSourceActions(c,u){const m=this.g.get(c);if(m){const b=new R.DisposableStore;return this.i.add([b]),(await m.provideNotebookKernelSourceActions(u)??[]).map(N=>p.NotebookKernelSourceAction.from(N,this.o.converter,b))}return[]}$acceptNotebookAssociation(c,u,m){const b=this.j.get(c);if(b){const f=this.n.getNotebookDocument(y.URI.revive(u));m?b.associatedNotebooks.set(f.uri,!0):b.associatedNotebooks.delete(f.uri),this.q.trace(`NotebookController[${c}] ASSOCIATE notebook`,f.uri.toString(),m),b.onDidChangeSelection.fire({selected:m,notebook:f.apiNotebook})}}async $executeCells(c,u,m){const b=this.j.get(c);if(!b)return;const f=this.n.getNotebookDocument(y.URI.revive(u)),N=[];for(const V of m){const _=f.getCell(V);_&&N.push(_.apiCell)}try{this.q.trace(`NotebookController[${c}] EXECUTE cells`,f.uri.toString(),N.length),await b.controller.executeHandler.call(b.controller,N,f.apiNotebook,b.controller)}catch(V){this.q.error(`NotebookController[${c}] execute cells FAILED`,V),console.error(V)}}async $cancelCells(c,u,m){const b=this.j.get(c);if(!b)return;const f=this.n.getNotebookDocument(y.URI.revive(u));if(b.controller.interruptHandler)await b.controller.interruptHandler.call(b.controller,f.apiNotebook);else for(const N of m){const V=f.getCell(N);V&&this.b.get(V.uri)?.cancel()}if(b.controller.interruptHandler){const N=this.c.get(f.uri);m.length&&Array.isArray(N)&&N.length&&N.forEach(V=>V.dispose())}}$acceptKernelMessageFromRenderer(c,u,m){const b=this.j.get(c);if(!b)return;const f=this.n.getEditorById(u);b.onDidReceiveMessage.fire(Object.freeze({editor:f.apiEditor,message:m}))}$cellExecutionChanged(c,u,m){const f=this.n.getNotebookDocument(y.URI.revive(c)).getCell(u);if(f){const N=m?p.NotebookCellExecutionState.to(m):l.NotebookCellExecutionState.Idle;N!==void 0&&this.l.fire({cell:f.apiCell,state:N})}}_createNotebookCellExecution(c,u){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const b=this.n.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!b)throw new Error("invalid cell");if(this.b.has(b.uri))throw new Error(`duplicate execution for ${b.uri}`);const f=new i(u,b,this.a);this.b.set(b.uri,f);const N=f.onDidChangeState(()=>{f.state===v.Resolved&&(f.dispose(),N.dispose(),this.b.delete(b.uri))});return f.asApiObject()}_createNotebookExecution(c,u){const m=this.n.getNotebookDocument(c.uri),b=c.getCells().find(V=>{const _=m.getCellFromApiCell(V);return _&&this.b.has(_.uri)});if(b)throw new Error(`duplicate cell execution for ${b.document.uri}`);if(this.c.has(m.uri))throw new Error(`duplicate notebook execution for ${m.uri}`);const f=new r(u,m,this.a),N=f.onDidChangeState(()=>{f.state===a.Resolved&&(f.dispose(),N.dispose(),this.c.delete(m.uri))});return this.c.set(m.uri,[f,N]),f.asApiObject()}};e.ExtHostNotebookKernels=T=xe([qe(4,O.ILogService)],T);var v;(function(k){k[k.Init=0]="Init",k[k.Started=1]="Started",k[k.Resolved=2]="Resolved"})(v||(v={}));class i extends R.Disposable{get state(){return this.f}constructor(c,u,m){super(),this.j=u,this.k=m,this.b=i.a++,this.c=new L.Emitter,this.onDidChangeState=this.c.event,this.f=v.Init,this.g=this.B(new I.CancellationTokenSource),this.h=new s(10,b=>this.m(b)),this.i=u.internalMetadata.executionOrder,this.k.$createExecution(this.b,c,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(c){await this.h.addItem(c)}async m(c){const u=Array.isArray(c)?c:[c];return this.k.$updateExecution(this.b,new D.SerializableObjectWithBuffers(u))}n(){if(this.f===v.Init)throw new Error("Must call start before modifying cell output");if(this.f===v.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(c){let u=this.j;if(c&&(u=this.j.notebook.getCellFromApiCell(c)),!u)throw new Error("INVALID cell");return u.handle}s(c){return c.map(u=>{const m=l.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return m===u.items?p.NotebookCellOutput.from(u):p.NotebookCellOutput.from({items:m,id:u.id,metadata:u.metadata})})}async t(c,u,m){const b=this.r(u),f=this.s((0,n.asArray)(c));return this.l({editType:o.CellExecutionUpdateType.Output,cellHandle:b,append:m,outputs:f})}async w(c,u,m){return c=l.NotebookCellOutput.ensureUniqueMimeTypes((0,n.asArray)(c),!0),this.l({editType:o.CellExecutionUpdateType.OutputItems,items:c.map(p.NotebookCellOutputItem.from),outputId:u.id,append:m})}asApiObject(){const c=this;return Object.freeze({get token(){return c.g.token},get cell(){return c.j.apiCell},get executionOrder(){return c.i},set executionOrder(m){c.i=m,c.m([{editType:o.CellExecutionUpdateType.ExecutionState,executionOrder:c.i}])},start(m){if(c.f===v.Resolved||c.f===v.Started)throw new Error("Cannot call start again");c.f=v.Started,c.c.fire(),c.m({editType:o.CellExecutionUpdateType.ExecutionState,runStartTime:m})},end(m,b){if(c.f===v.Resolved)throw new Error("Cannot call resolve twice");c.f=v.Resolved,c.c.fire(),c.h.flush(),c.k.$completeExecution(c.b,new D.SerializableObjectWithBuffers({runEndTime:b,lastRunSuccess:m}))},clearOutput(m){return c.n(),c.t([],m,!1)},appendOutput(m,b){return c.n(),c.t(m,b,!0)},replaceOutput(m,b){return c.n(),c.t(m,b,!1)},appendOutputItems(m,b){return c.n(),c.w(m,b,!0)},replaceOutputItems(m,b){return c.n(),c.w(m,b,!1)}})}}i.a=0;var a;(function(k){k[k.Init=0]="Init",k[k.Started=1]="Started",k[k.Resolved=2]="Resolved"})(a||(a={}));class r extends R.Disposable{get state(){return this.f}constructor(c,u,m){super(),this.h=u,this.i=m,this.b=r.a++,this.c=new L.Emitter,this.onDidChangeState=this.c.event,this.f=a.Init,this.g=this.B(new I.CancellationTokenSource),this.i.$createNotebookExecution(this.b,c,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===a.Resolved||this.f===a.Started)throw new Error("Cannot call start again");this.f=a.Started,this.c.fire(),this.i.$beginNotebookExecution(this.b)},end:()=>{if(this.f===a.Resolved)throw new Error("Cannot call resolve twice");this.f=a.Resolved,this.c.fire(),this.i.$completeNotebookExecution(this.b)}})}}r.a=0;class s{constructor(c,u){this.e=c,this.f=u,this.a=[],this.b=Date.now()}addItem(c){return this.a.push(c),this.c||(this.c=new P.DeferredPromise,this.b=Date.now(),(0,P.timeout)(this.e).then(()=>this.flush())),Date.now()-this.b>this.e?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const c=this.c;this.c=void 0;const u=this.a;return this.a=[],this.f(u).finally(()=>c.complete())}}function E(k,c){return`${k.value}/${c}`}e.createKernelId=E}),define(Pe[237],Ae([1,0,5,4,103]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(A,y){this.c=y,this.a=new Map,this.b=A.getProxy(P.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,h){const O=this.c.getEditorById(A);this.a.get(y)?.fire({editor:O.apiEditor,message:h})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(O=>O.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(O,w,g)=>this.d(y).event(O,w,g),postMessage:(O,w)=>{I.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,w]=[w,O]);const g=w&&I.ExtHostNotebookEditor.apiEditorsToExtHost.get(w);return this.b.$postMessage(g?.id,y,O)}}}d(A){let y=this.a.get(A);return y||(y=new n.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(A)}}),this.a.set(A,y),y)}}e.ExtHostNotebookRenderers=L}),define(Pe[238],Ae([1,0,6,12,2,26,4]),function(te,e,n,P,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(h){this.b=new Map,this.a=h.getProxy(R.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(h,O,w){if((0,L.checkProposedApiEnabled)(h,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,w),this.a.$registerProfileContentHandler(O,w.name,w.description,h.identifier.value),(0,n.toDisposable)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(h,O,w,g){const S=this.b.get(h);if(!S)throw new Error(`Unknown handler with id: ${h}`);return S.saveProfile(O,w,g)}async $readProfile(h,O,w){const g=this.b.get(h);if(!g)throw new Error(`Unknown handler with id: ${h}`);return g.readProfile((0,P.isString)(O)?O:I.URI.revive(O),w)}}e.ExtHostProfileContentHandlers=A}),define(Pe[239],Ae([1,0,2,4,17,8]),function(te,e,n,P,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class R{constructor(y,h){this.d=h,this.c=new Map,this.b=y.getProxy(P.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,h,O){const w=n.URI.revive(h),g=this.c.get(y);return g?(0,I.asPromise)(()=>g.provideOriginalResource(w,O)).then(S=>S||null):Promise.resolve(null)}registerQuickDiffProvider(y,h,O,w){const g=R.a++;return this.c.set(g,h),this.b.$registerQuickDiffProvider(g,L.DocumentSelector.from(y,this.d),O,w),{dispose:()=>{this.b.$unregisterQuickDiffProvider(g),this.c.delete(g)}}}}e.ExtHostQuickDiff=R,R.a=0}),define(Pe[240],Ae([1,0,21,5,6,4,2,7,9,16,29,39,26,8]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function p(l,t,o){const d=l.getProxy(L.MainContext.MainThreadQuickOpen);class D{constructor(c,u){this.e=new Map,this.f=0,this.a=c,this.b=u}showQuickPick(c,u,m,b=n.CancellationToken.None){this.c=void 0;const f=Promise.resolve(u),N=++this.f,V=d.$show(N,{title:m?.title,placeHolder:m?.placeHolder,matchOnDescription:m?.matchOnDescription,matchOnDetail:m?.matchOnDetail,ignoreFocusLost:m?.ignoreFocusOut,canPickMany:m?.canPickMany},b),_={},G=V.then(()=>_);return Promise.race([G,f]).then($=>{if($===_)return;const B=(0,g.isProposedApiEnabled)(c,"quickPickItemTooltip");return f.then(X=>{const U=[];for(let j=0;j<X.length;j++){const Y=X[j];typeof Y=="string"?U.push({label:Y,handle:j}):Y.kind===A.QuickPickItemKind.Separator?U.push({type:"separator",label:Y.label}):(Y.tooltip&&!B&&console.warn(`Extension '${c.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${c.identifier.value}`),U.push({label:Y.label,description:Y.description,detail:Y.detail,picked:Y.picked,alwaysShow:Y.alwaysShow,tooltip:B?S.MarkdownString.fromStrict(Y.tooltip):void 0,handle:j}))}return m&&typeof m.onDidSelectItem=="function"&&(this.c=j=>{m.onDidSelectItem(X[j])}),d.$setItems(N,U),V.then(j=>{if(typeof j=="number")return X[j];if(Array.isArray(j))return j.map(Y=>X[Y])})})}).then(void 0,$=>{if(!(0,y.isCancellationError)($))return d.$setError(N,$),Promise.reject($)})}$onItemSelected(c){this.c?.(c)}showInput(c,u=n.CancellationToken.None){return this.d=c?.validateInput,d.$input(c,typeof this.d=="function",u).then(void 0,m=>{if(!(0,y.isCancellationError)(m))return Promise.reject(m)})}async $validateInput(c){if(!this.d)return;const u=await this.d(c);if(!u||typeof u=="string")return u;let m;switch(u.severity){case A.InputBoxValidationSeverity.Info:m=O.default.Info;break;case A.InputBoxValidationSeverity.Warning:m=O.default.Warning;break;case A.InputBoxValidationSeverity.Error:m=O.default.Error;break;default:m=u.message?O.default.Error:O.default.Ignore;break}return{content:u.message,severity:m}}async showWorkspaceFolderPick(c,u=n.CancellationToken.None){const m=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[c]);if(!m)return;const b=await this.a.getWorkspaceFolders2();if(b)return b.find(f=>f.uri.toString()===m.uri.toString())}createQuickPick(c){const u=new s(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}createInputBox(c){const u=new E(c,()=>this.e.delete(u._id));return this.e.set(u._id,u),u}$onDidChangeValue(c,u){this.e.get(c)?._fireDidChangeValue(u)}$onDidAccept(c){this.e.get(c)?._fireDidAccept()}$onDidChangeActive(c,u){const m=this.e.get(c);m instanceof s&&m._fireDidChangeActive(u)}$onDidChangeSelection(c,u){const m=this.e.get(c);m instanceof s&&m._fireDidChangeSelection(u)}$onDidTriggerButton(c,u){this.e.get(c)?._fireDidTriggerButton(u)}$onDidTriggerItemButton(c,u,m){const b=this.e.get(c);b instanceof s&&b._fireDidTriggerItemButton(u,m)}$onDidHide(c){this.e.get(c)?._fireDidHide()}}class T{constructor(c,u){this.x=c,this.y=u,this._id=s.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new P.Emitter,this.q=new P.Emitter,this.r=new P.Emitter,this.s=new P.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(c){this.b=c,this.z({title:c})}get step(){return this.c}set step(c){this.c=c,this.z({step:c})}get totalSteps(){return this.d}set totalSteps(c){this.d=c,this.z({totalSteps:c})}get enabled(){return this.g}set enabled(c){this.g=c,this.z({enabled:c})}get busy(){return this.j}set busy(c){this.j=c,this.z({busy:c})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(c){this.k=c,this.z({ignoreFocusOut:c})}get value(){return this.l}set value(c){this.l=c,this.z({value:c})}get placeholder(){return this.m}set placeholder(c){this.m=c,this.z({placeholder:c})}get buttons(){return this.n}set buttons(c){this.n=c.slice(),this.o.clear(),c.forEach((u,m)=>{const b=u===A.QuickInputButtons.Back?-1:m;this.o.set(b,u)}),this.z({buttons:c.map((u,m)=>({...r(u),tooltip:u.tooltip,handle:u===A.QuickInputButtons.Back?-1:m}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(c){this.l=c,this.q.fire(c)}_fireDidTriggerButton(c){const u=this.o.get(c);u&&this.r.fire(u)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,I.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),d.$dispose(this._id))}z(c){if(!this.v){for(const u of Object.keys(c)){const m=c[u];this.u[u]=m===void 0?null:m}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){d.$createOrUpdate(this.u),this.u={id:this._id}}}T.a=1;function v(k){if(k instanceof A.ThemeIcon)return{id:k.id};const c=a(k),u=i(k);return{dark:typeof c=="string"?R.URI.file(c):c,light:typeof u=="string"?R.URI.file(u):u}}function i(k){return typeof k=="object"&&"light"in k?k.light:k}function a(k){return typeof k=="object"&&"dark"in k?k.dark:k}function r(k){const c=v(k.iconPath);let u,m;return"id"in c?m=w.ThemeIcon.asClassName(c):u=c,{iconPath:u,iconClass:m}}class s extends T{constructor(c,u){super(c.identifier,u),this.O=c,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new P.Emitter,this.L=[],this.M=new P.Emitter,this.N=new P.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(c){this.B=c.slice(),this.C.clear(),this.D.clear(),c.forEach((b,f)=>{this.C.set(f,b),this.D.set(b,f)});const u=(0,g.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),m=[];for(let b=0;b<c.length;b++){const f=c[b];f.kind===A.QuickPickItemKind.Separator?m.push({type:"separator",label:f.label}):(f.tooltip&&!u&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),m.push({handle:b,label:f.label,description:f.description,detail:f.detail,picked:f.picked,alwaysShow:f.alwaysShow,tooltip:u?S.MarkdownString.fromStrict(f.tooltip):void 0,buttons:f.buttons?.map((N,V)=>({...r(N),tooltip:N.tooltip,handle:V}))}))}this.z({items:m})}get canSelectMany(){return this.E}set canSelectMany(c){this.E=c,this.z({canSelectMany:c})}get matchOnDescription(){return this.F}set matchOnDescription(c){this.F=c,this.z({matchOnDescription:c})}get matchOnDetail(){return this.G}set matchOnDetail(c){this.G=c,this.z({matchOnDetail:c})}get sortByLabel(){return this.H}set sortByLabel(c){this.H=c,this.z({sortByLabel:c})}get keepScrollPosition(){return this.I}set keepScrollPosition(c){this.I=c,this.z({keepScrollPosition:c})}get activeItems(){return this.J}set activeItems(c){this.J=c.filter(u=>this.D.has(u)),this.z({activeItems:this.J.map(u=>this.D.get(u))})}get selectedItems(){return this.L}set selectedItems(c){this.L=c.filter(u=>this.D.has(u)),this.z({selectedItems:this.L.map(u=>this.D.get(u))})}_fireDidChangeActive(c){const u=(0,h.coalesce)(c.map(m=>this.C.get(m)));this.J=u,this.K.fire(u)}_fireDidChangeSelection(c){const u=(0,h.coalesce)(c.map(m=>this.C.get(m)));this.L=u,this.M.fire(u)}_fireDidTriggerItemButton(c,u){const m=this.C.get(c);if(!m||!m.buttons||!m.buttons.length)return;const b=m.buttons[u];b&&this.N.fire({button:b,item:m})}}class E extends T{constructor(c,u){super(c.identifier,u),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(c){this.B=c,this.z({password:c})}get prompt(){return this.C}set prompt(c){this.C=c,this.z({prompt:c})}get valueSelection(){return this.D}set valueSelection(c){this.D=c,this.z({valueSelection:c})}get validationMessage(){return this.E}set validationMessage(c){this.E=c,c?typeof c=="string"?this.z({validationMessage:c,severity:O.default.Error}):this.z({validationMessage:c.message,severity:c.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new D(t,o)}e.createExtHostQuickOpen=p});var Ne=this&&this.__classPrivateFieldGet||function(te,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(te):P?P.value:e.get(te)},_e=this&&this.__classPrivateFieldSet||function(te,e,n,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(te,n):I?I.value=n:e.set(te,n),n};define(Pe[241],Ae([1,0,2,5,65,6,17,4,16,127,14,24,39,8,26,15]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l){"use strict";var t,o,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function D(b){if(b)return typeof b.iconPath=="string"?n.URI.file(b.iconPath):n.URI.isUri(b.iconPath)||g.ThemeIcon.isThemeIcon(b.iconPath)?b.iconPath:void 0}function T(b,f){if(!b.iconPath&&!f.iconPath)return 0;if(b.iconPath){if(!f.iconPath)return 1}else return-1;const N=typeof b.iconPath=="string"?b.iconPath:n.URI.isUri(b.iconPath)?b.iconPath.fsPath:b.iconPath.id,V=typeof f.iconPath=="string"?f.iconPath:n.URI.isUri(f.iconPath)?f.iconPath.fsPath:f.iconPath.id;return(0,h.comparePaths)(N,V)}function v(b,f){let N=0;if(b.strikeThrough!==f.strikeThrough)return b.strikeThrough?1:-1;if(b.faded!==f.faded)return b.faded?1:-1;if(b.tooltip!==f.tooltip)return(b.tooltip||"").localeCompare(f.tooltip||"");if(N=T(b,f),N!==0)return N;if(b.light&&f.light)N=T(b.light,f.light);else{if(b.light)return 1;if(f.light)return-1}if(N!==0)return N;if(b.dark&&f.dark)N=T(b.dark,f.dark);else{if(b.dark)return 1;if(f.dark)return-1}return N}function i(b,f){if(b.command!==f.command)return b.command<f.command?-1:1;if(b.title!==f.title)return b.title<f.title?-1:1;if(b.tooltip!==f.tooltip){if(b.tooltip!==void 0&&f.tooltip!==void 0)return b.tooltip<f.tooltip?-1:1;if(b.tooltip!==void 0)return 1;if(f.tooltip!==void 0)return-1}if(b.arguments===f.arguments)return 0;if(b.arguments)if(f.arguments){if(b.arguments.length!==f.arguments.length)return b.arguments.length-f.arguments.length}else return 1;else return-1;for(let N=0;N<b.arguments.length;N++){const V=b.arguments[N],_=f.arguments[N];if(V!==_)return V<_?-1:1}return 0}function a(b,f){let N=(0,h.comparePaths)(b.resourceUri.fsPath,f.resourceUri.fsPath,!0);if(N!==0)return N;if(b.command&&f.command)N=i(b.command,f.command);else{if(b.command)return 1;if(f.command)return-1}if(N!==0)return N;if(b.decorations&&f.decorations)N=v(b.decorations,f.decorations);else{if(b.decorations)return 1;if(f.decorations)return-1}return N}function r(b,f){for(let N=0;N<b.length;N++)if(b[N]!==f[N])return!1;return!0}function s(b,f){return b.command===f.command&&b.title===f.title&&b.tooltip===f.tooltip&&(b.arguments&&f.arguments?r(b.arguments,f.arguments):b.arguments===f.arguments)}function E(b,f){return(0,y.equals)(b,f,s)}class k{get value(){return this.d}set value(f){f=f??"",Ne(this,t,"f").$setInputBoxValue(this.l,f),this.n(f)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(f){Ne(this,t,"f").$setInputBoxPlaceholder(this.l,f),this.f=f}get validateInput(){return(0,p.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(f){if((0,p.checkProposedApiEnabled)(this.k,"scmValidation"),f&&typeof f!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=f,Ne(this,t,"f").$setValidationProviderIsEnabled(this.l,!!f)}get enabled(){return this.h}set enabled(f){f=!!f,this.h!==f&&(this.h=f,Ne(this,t,"f").$setInputBoxEnablement(this.l,f))}get visible(){return this.j}set visible(f){f=!!f,this.j!==f&&(this.j=f,Ne(this,t,"f").$setInputBoxVisibility(this.l,f))}get document(){return(0,p.checkProposedApiEnabled)(this.k,"scmTextDocument"),Ne(this,o,"f").getDocument(this.m)}constructor(f,N,V,_,G){this.k=f,this.l=_,this.m=G,t.set(this,void 0),o.set(this,void 0),this.d="",this.e=new P.Emitter,this.f="",this.h=!0,this.j=!0,_e(this,o,N,"f"),_e(this,t,V,"f")}showValidationMessage(f,N){(0,p.checkProposedApiEnabled)(this.k,"scmValidation"),Ne(this,t,"f").$showValidationMessage(this.l,f,N)}$onInputBoxValueChange(f){this.n(f)}n(f){this.d=f,this.e.fire(f)}}e.ExtHostSCMInputBox=k,t=new WeakMap,o=new WeakMap;class c{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(f){this.v=f,this.q.$updateGroupLabel(this.t,this.handle,f)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(f){this.p=f,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(f){this.f=[...f],this.k.fire()}constructor(f,N,V,_,G){this.q=f,this.s=N,this.t=V,this.u=_,this.v=G,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new P.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new P.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(f){return this.g.get(f)}$executeResourceCommand(f,N){const V=this.h.get(f);return V?(0,R.asPromise)(()=>this.s.executeCommand(V.command,...V.arguments||[],N)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const f=[...this.f].sort(a),V=(0,y.sortedDiff)(this.o,f,a).map($=>{const B=$.toInsert.map(X=>{const U=this.e++;this.g.set(U,X);const j=X.resourceUri;let Y;if(X.command)if(X.command.command==="vscode.open"||X.command.command==="vscode.diff"){const Q=new L.DisposableStore;Y=this.s.converter.toInternal(X.command,Q),this.j.set(U,Q)}else this.h.set(U,X.command);const pe=D(X.decorations),Ee=X.decorations&&D(X.decorations.light)||pe,he=X.decorations&&D(X.decorations.dark)||pe,de=[Ee,he],Re=X.decorations&&X.decorations.tooltip||"",le=X.decorations&&!!X.decorations.strikeThrough,ue=X.decorations&&!!X.decorations.faded,H=X.contextValue||"";return{rawResource:[U,j,de,Re,le,ue,H,Y],handle:U}});return{start:$.start,deleteCount:$.deleteCount,toInsert:B}}),_=V.map(({start:$,deleteCount:B,toInsert:X})=>[$,B,X.map(U=>U.rawResource)]),G=V.reverse();for(const{start:$,deleteCount:B,toInsert:X}of G){const U=X.map(Y=>Y.handle),j=this.n.splice($,B,...U);for(const Y of j)this.g.delete(Y),this.h.delete(Y),this.j.get(Y)?.dispose(),this.j.delete(Y)}return this.o=f,_}dispose(){this.l=!0,this.m.fire()}}c.d=0;class u{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(f){this.g!==f&&(this.g=f,Ne(this,d,"f").$updateSourceControl(this.t,{count:f}))}get quickDiffProvider(){return this.h}set quickDiffProvider(f){this.h=f;let N;(0,p.isProposedApiEnabled)(this.u,"quickDiffProvider")&&(N=f?.label),Ne(this,d,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!f,quickDiffLabel:N})}get commitTemplate(){return this.j}set commitTemplate(f){f!==this.j&&(this.j=f,Ne(this,d,"f").$updateSourceControl(this.t,{commitTemplate:f}))}get acceptInputCommand(){return this.l}set acceptInputCommand(f){this.k.value=new L.DisposableStore,this.l=f;const N=this.v.converter.toInternal(f,this.k.value);Ne(this,d,"f").$updateSourceControl(this.t,{acceptInputCommand:N})}get actionButton(){return(0,p.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(f){(0,p.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new L.DisposableStore,this.n=f;const N=f!==void 0?{command:this.v.converter.toInternal(f.command,this.m.value),secondaryCommands:f.secondaryCommands?.map(V=>V.map(_=>this.v.converter.toInternal(_,this.m.value))),description:f.description,enabled:f.enabled}:void 0;Ne(this,d,"f").$updateSourceControl(this.t,{actionButton:N??null})}get statusBarCommands(){return this.p}set statusBarCommands(f){if(this.p&&f&&E(this.p,f))return;this.o.value=new L.DisposableStore,this.p=f;const N=(f||[]).map(V=>this.v.converter.toInternal(V,this.o.value));Ne(this,d,"f").$updateSourceControl(this.t,{statusBarCommands:N})}get selected(){return this.q}constructor(f,N,V,_,G,$,B){this.u=f,this.v=_,this.w=G,this.x=$,this.y=B,d.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new L.MutableDisposable,this.l=void 0,this.m=new L.MutableDisposable,this.o=new L.MutableDisposable,this.p=void 0,this.q=!1,this.s=new P.Emitter,this.onDidChangeSelection=this.s.event,this.t=u.d++,this.z=new Map,this.A=new Set,_e(this,d,V,"f");const X=n.URI.from({scheme:l.Schemas.vscodeSourceControl,path:`${G}/scm${this.t}/input`,query:B?`rootUri=${encodeURIComponent(B.toString())}`:void 0});this.f=new k(f,N,Ne(this,d,"f"),this.t,X),Ne(this,d,"f").$registerSourceControl(this.t,G,$,B,X)}createResourceGroup(f,N){const V=new c(Ne(this,d,"f"),this.v,this.t,f,N),_=P.Event.once(V.onDidDispose)(()=>this.z.delete(V));return this.z.set(V,_),this.eventuallyAddResourceGroups(),V}eventuallyAddResourceGroups(){const f=[],N=[];for(const[V,_]of this.z){_.dispose();const G=V.onDidUpdateResourceStates(()=>{this.A.add(V),this.eventuallyUpdateResourceStates()});P.Event.once(V.onDidDispose)(()=>{this.A.delete(V),G.dispose(),this.e.delete(V.handle),Ne(this,d,"f").$unregisterGroup(this.t,V.handle)}),f.push([V.handle,V.id,V.label,V.features]);const $=V._takeResourceStateSnapshot();$.length>0&&N.push([V.handle,$]),this.e.set(V.handle,V)}Ne(this,d,"f").$registerGroups(this.t,f,N),this.z.clear()}eventuallyUpdateResourceStates(){const f=[];this.A.forEach(N=>{const V=N._takeResourceStateSnapshot();V.length!==0&&f.push([N.handle,V])}),f.length>0&&Ne(this,d,"f").$spliceResourceStates(this.t,f),this.A.clear()}getResourceGroup(f){return this.e.get(f)}setSelectionState(f){this.q=f,this.s.fire(f)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(f=>f.dispose()),Ne(this,d,"f").$unregisterSourceControl(this.t)}}d=new WeakMap,u.d=0,xe([(0,I.debounce)(100)],u.prototype,"eventuallyAddResourceGroups",null),xe([(0,I.debounce)(100)],u.prototype,"eventuallyUpdateResourceStates",null);let m=e.ExtHostSCM=class Dn{get onDidChangeActiveProvider(){return this.j.event}constructor(f,N,V,_){this.l=N,this.m=V,this.n=_,this.g=new Map,this.h=new w.ExtensionIdentifierMap,this.j=new P.Emitter,this.e=f.getProxy(A.MainContext.MainThreadSCM),this.f=f.getProxy(A.MainContext.MainThreadTelemetry),N.registerArgumentProcessor({processArgument:G=>{if(G&&G.$mid===3){const $=this.g.get(G.sourceControlHandle);if(!$)return G;const B=$.getResourceGroup(G.groupHandle);return B?B.getResourceState(G.handle):G}else if(G&&G.$mid===4){const $=this.g.get(G.sourceControlHandle);return $?$.getResourceGroup(G.groupHandle):G}else if(G&&G.$mid===5){const $=this.g.get(G.handle);return $||G}return G}})}createSourceControl(f,N,V,_){this.n.trace("ExtHostSCM#createSourceControl",f.identifier.value,N,V,_),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:f.identifier.value});const G=Dn.d++,$=new u(f,this.m,this.e,this.l,N,V,_);this.g.set(G,$);const B=this.h.get(f.identifier)||[];return B.push($),this.h.set(f.identifier,B),$}getLastInputBox(f){this.n.trace("ExtHostSCM#getLastInputBox",f.identifier.value);const N=this.h.get(f.identifier),V=N&&N[N.length-1];return V&&V.inputBox}$provideOriginalResource(f,N,V){const _=n.URI.revive(N);this.n.trace("ExtHostSCM#$provideOriginalResource",f,_.toString());const G=this.g.get(f);return!G||!G.quickDiffProvider||!G.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>G.quickDiffProvider.provideOriginalResource(_,V)).then($=>$||null)}$onInputBoxValueChange(f,N){this.n.trace("ExtHostSCM#$onInputBoxValueChange",f);const V=this.g.get(f);return V&&V.inputBox.$onInputBoxValueChange(N),Promise.resolve(void 0)}$executeResourceCommand(f,N,V,_){this.n.trace("ExtHostSCM#$executeResourceCommand",f,N,V);const G=this.g.get(f);if(!G)return Promise.resolve(void 0);const $=G.getResourceGroup(N);return $?$.$executeResourceCommand(V,_):Promise.resolve(void 0)}$validateInput(f,N,V){this.n.trace("ExtHostSCM#$validateInput",f);const _=this.g.get(f);return!_||!_.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>_.inputBox.validateInput(N,V)).then(G=>{if(!G)return Promise.resolve(void 0);const $=S.MarkdownString.fromStrict(G.message);return $?Promise.resolve([$,G.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(f){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",f),f!==void 0&&this.g.get(f)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=f,Promise.resolve(void 0)}};m.d=0,e.ExtHostSCM=m=xe([qe(3,O.ILogService)],m)}),define(Pe[80],Ae([1,0,4,5,3]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(A){this.b=new P.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(n.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,y){return this.a.$getPassword(A,y)}store(A,y,h){return this.a.$setPassword(A,y,h)}delete(A,y){return this.a.$deletePassword(A,y)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,I.createDecorator)("IExtHostSecretState")}),define(Pe[242],Ae([1,0,4,7]),function(te,e,n,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSemanticSimilarity=void 0;class I{constructor(R){this.a=new Map,this.b=0,this.c=R.getProxy(n.MainContext.MainThreadSemanticSimilarity)}async $provideSimilarityScore(R,A,y,h){if(this.a.size===0)throw new Error("No semantic similarity providers registered");const O=this.a.get(R);if(!O)throw new Error("Semantic similarity provider not found");return await O.provideSimilarityScore(A,y,h)}registerSemanticSimilarityProvider(R,A){const y=this.b;return this.b++,this.a.set(y,A),this.c.$registerSemanticSimilarityProvider(y),new P.Disposable(()=>{this.c.$unregisterSemanticSimilarityProvider(y),this.a.delete(y)})}}e.ExtHostSemanticSimilarity=I});var _e=this&&this.__classPrivateFieldSet||function(te,e,n,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(te,n):I?I.value=n:e.set(te,n),n},Ne=this&&this.__classPrivateFieldGet||function(te,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(te):P?P.value:e.get(te)};define(Pe[243],Ae([1,0,7,4,151,6,8,12]),function(te,e,n,P,I,L,R,A){"use strict";var y,h;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(p,l,t,o,d=n.StatusBarAlignment.Left,D){y.set(this,void 0),h.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new L.DisposableStore,_e(this,y,p,"f"),_e(this,h,l,"f"),this.c=O.a++,this.e=t,this.f=o,this.g=d,this.h=this.u(D)}u(p){if((0,A.isNumber)(p))return p===Number.POSITIVE_INFINITY?Number.MAX_VALUE:p===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:p}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(p){this.k=p,this.v()}set name(p){this.m=p,this.v()}set tooltip(p){this.l=p,this.v()}set color(p){this.n=p,this.v()}set backgroundColor(p){p&&!O.b.has(p.id)&&(p=void 0),this.o=p,this.v()}set command(p){this.r?.fromApi!==p&&(this.p&&this.q.add(this.p),this.p=new L.DisposableStore,typeof p=="string"?this.r={fromApi:p,internal:Ne(this,h,"f").toInternal({title:"",command:p},this.p)}:p?this.r={fromApi:p,internal:Ne(this,h,"f").toInternal(p,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(p){this.t=p,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ne(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let p;this.e?this.f?p=`${this.e.identifier.value}.${this.f}`:p=this.e.identifier.value:p=this.f;let l;this.m?l=this.m:l=(0,I.localize)(0,null,this.e.displayName||this.e.name);let t=this.n;this.o&&(t=O.b.get(this.o.id));const o=R.MarkdownString.fromStrict(this.l);Ne(this,y,"f").$setEntry(this.c,p,this.e?.identifier.value,l,this.k,o,this.r?.internal,t,this.o,this.g===n.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.ExtHostStatusBarEntry=O,y=new WeakMap,h=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new n.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new n.ThemeColor("statusBarItem.warningForeground")]]);class w{constructor(p){this.b=[],this.a=p.createStatusBarEntry(void 0,"status.extensionMessage",n.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,I.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(p){const l={message:p};return this.b.unshift(l),this.c(),new n.Disposable(()=>{const t=this.b.indexOf(l);t>=0&&(this.b.splice(t,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class g{constructor(p,l){this.a=p.getProxy(P.MainContext.MainThreadStatusBar),this.b=l,this.c=new w(this)}createStatusBarEntry(p,l,t,o){return new O(this.a,this.b,p,l,t,o)}setStatusBarMessage(p,l){const t=this.c.setMessage(p);let o;return typeof l=="number"?o=setTimeout(()=>t.dispose(),l):typeof l<"u"&&l.then(()=>t.dispose(),()=>t.dispose()),new n.Disposable(()=>{t.dispose(),clearTimeout(o)})}}e.ExtHostStatusBar=g}),define(Pe[81],Ae([1,0,4,5,3]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(A,y){this.c=y,this.b=new P.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(n.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this.a.$registerExtensionStorageKeysToSync(A,y)}async initializeExtensionStorage(A,y,h){const O=await this.a.$initializeExtensionStorage(A,y);let w;return O&&(w=this.d(A,y,O)),w||h}setValue(A,y,h){return this.a.$setValue(A,y,h)}$acceptValue(A,y,h){const O=this.d(A,y,h);O&&this.b.fire({shared:A,key:y,value:O})}d(A,y,h){try{return JSON.parse(h)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${A}): ${O}`)}}}e.ExtHostStorage=L,e.IExtHostStorage=(0,I.createDecorator)("IExtHostStorage")}),define(Pe[82],Ae([1,0,3,27,14,61,2]),function(te,e,n,P,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,n.createDecorator)("IExtensionStoragePaths");let A=e.ExtensionStoragePaths=class{constructor(h,O,w){this.d=O,this.f=w,this.a=h.workspace??void 0,this.b=h.environment,this.whenReady=this.h().then(g=>this.c=g)}async g(h){return R.URI.joinPath(this.b.workspaceStorageHome,h)}async h(){if(!this.a)return Promise.resolve(void 0);const h=this.a.id,O=await this.g(h);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(R.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:R.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(w){this.d.error("[ExtHostStorage]",w);return}}workspaceValue(h){if(this.c)return R.URI.joinPath(this.c,h.identifier.value)}globalValue(h){return R.URI.joinPath(this.b.globalStorageHome,h.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.ExtensionStoragePaths=A=xe([qe(0,P.IExtHostInitDataService),qe(1,I.ILogService),qe(2,L.IExtHostConsumerFileSystem)],A)}),define(Pe[62],Ae([1,0,5,4,3,2,18,6,7,153,9,179,21,35,180,39,12,17,8]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t,o,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,I.createDecorator)("IExtHostTerminalService");class D{constructor(u,m,b,f){this.k=u,this._id=m,this.l=b,this.m=f,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(V=>this.f=V);const N=this;this.value={get name(){return N.m||""},get processId(){return N.b},get creationOptions(){return N.l},get exitStatus(){return N.h},get state(){return N.j},sendText(V,_=!0){N.o(),N.k.$sendText(N._id,V,_)},show(V){N.o(),N.k.$show(N._id,V)},hide(){N.o(),N.k.$hide(N._id)},dispose(){N.a||(N.a=!0,N.k.$dispose(N._id))},get dimensions(){if(!(N.d===void 0||N.g===void 0))return{columns:N.d,rows:N.g}}}}async create(u,m){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:u.name,shellPath:(0,t.withNullAsUndefined)(u.shellPath),shellArgs:(0,t.withNullAsUndefined)(u.shellArgs),cwd:(0,t.withNullAsUndefined)(u.cwd),env:(0,t.withNullAsUndefined)(u.env),icon:(0,t.withNullAsUndefined)(s(u.iconPath)),color:l.ThemeColor.isThemeColor(u.color)?u.color.id:void 0,initialText:(0,t.withNullAsUndefined)(u.message),strictEnv:(0,t.withNullAsUndefined)(u.strictEnv),hideFromUser:(0,t.withNullAsUndefined)(u.hideFromUser),isFeatureTerminal:(0,t.withNullAsUndefined)(m?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,t.withNullAsUndefined)(m?.useShellEnvironment),location:m?.location||this.n(u.location,m?.resolvedExtHostIdentifier),isTransient:(0,t.withNullAsUndefined)(u.isTransient)})}async createExtensionTerminal(u,m,b,f){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:b,color:l.ThemeColor.isThemeColor(f)?f.id:void 0,location:this.n(u,m),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(u,m){return typeof u=="object"?"parentTerminal"in u&&u.parentTerminal&&m?{parentTerminal:m}:"viewColumn"in u?{viewColumn:d.ViewColumn.from(u.viewColumn),preserveFocus:u.preserveFocus}:void 0:u}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(u){this.m=u}setExitStatus(u,m){this.h=Object.freeze({code:u,reason:m})}setDimensions(u,m){return u===this.d&&m===this.g||u===0||m===0?!1:(this.d=u,this.g=m,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(u){this.f?(this.f(u),this.f=void 0):this.b.then(m=>{m!==u&&(this.b=Promise.resolve(u))})}}e.ExtHostTerminal=D;class T{get onProcessReady(){return this.b.event}constructor(u){this.g=u,this.id=0,this.shouldPersist=!1,this.a=new n.Emitter,this.onProcessData=this.a.event,this.b=new n.Emitter,this.d=new n.Emitter,this.onDidChangeProperty=this.d.event,this.f=new n.Emitter,this.onProcessExit=this.f.event}refreshProperty(u){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${u}`)}updateProperty(u,m){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${u}, value: ${m}`)}async start(){}shutdown(){this.g.close()}input(u){this.g.handleInput?.(u)}resize(u,m){this.g.setDimensions?.({columns:u,rows:m})}async processBinary(u){}acknowledgeDataEvent(u){}async setUnicodeVersion(u){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(u){this.g.onDidWrite(m=>this.a.fire(m)),this.g.onDidClose?.((m=void 0)=>{this.f.fire(m===void 0?void 0:m)}),this.g.onDidOverrideDimensions?.(m=>{m&&this.d.fire({type:"overrideDimensions",value:{cols:m.columns,rows:m.rows}})}),this.g.onDidChangeName?.(m=>{this.d.fire({type:"title",value:m})}),this.g.open(u||void 0),u&&this.g.setDimensions?.(u),this.b.fire({pid:-1,cwd:""})}}let v=1,i=e.BaseExtHostTerminalService=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(u=>u.value)}get onDidWriteTerminalData(){return this.I.event}constructor(u,m){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new n.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new n.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new n.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new n.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new n.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new n.Emitter,this.onDidChangeShell=this.J.event,this.a=m.getProxy(P.MainContext.MainThreadTerminalService),this.s=new p.TerminalDataBufferer(this.a.$sendProcessData),this.I=new n.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(u),this.B({dispose:()=>{for(const[b,f]of this.g)f.shutdown(!0)}})}getDefaultShell(u){return(u?this.n:this.m)?.path||""}getDefaultShellArgs(u){return(u?this.n:this.m)?.args||[]}createExtensionTerminal(u,m){const b=new D(this.a,(0,S.generateUuid)(),u,u.name),f=new T(u.pty);return b.createExtensionTerminal(u.location,this.L(u,m).resolvedExtHostIdentifier,s(u.iconPath),E(u.color)).then(N=>{const V=this.M(N,f);this.h[N]=V}),this.f.push(b),b.value}L(u,m){if(m=m||{},u.location&&typeof u.location=="object"&&"parentTerminal"in u.location){const b=u.location.parentTerminal;if(b){const f=this.f.find(N=>N.value===b);f&&(m.resolvedExtHostIdentifier=f._id)}}else u.location&&typeof u.location!="object"?m.location=u.location:m.location&&typeof m.location=="object"&&"splitActiveTerminal"in m.location&&(m.location={splitActiveTerminal:!0});return m}attachPtyToTerminal(u,m){if(!this.O(u))throw new Error(`Cannot resolve terminal with id ${u} for virtual process`);const f=new T(m),N=this.M(u,f);this.h[u]=N}async $acceptActiveTerminalChanged(u){const m=this.b;if(u===null){this.b=void 0,m!==this.b&&this.F.fire(this.b);return}const b=this.O(u);b&&(this.b=b,m!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(u,m){const b=this.O(u);b&&this.I.fire({terminal:b.value,data:m})}async $acceptTerminalDimensions(u,m,b){const f=this.O(u);f&&f.setDimensions(m,b)&&this.G.fire({terminal:f.value,dimensions:f.value.dimensions})}async $acceptTerminalMaximumDimensions(u,m,b){this.g.get(u)?.resize(m,b)}async $acceptTerminalTitleChange(u,m){const b=this.O(u);b&&(b.name=m)}async $acceptTerminalClosed(u,m,b){const f=this.Q(this.f,u);if(f!==null){const N=this.f.splice(f,1)[0];N.setExitStatus(m,b),this.C.fire(N.value)}}$acceptTerminalOpened(u,m,b,f){if(m){const _=this.Q(this.f,m);if(_!==null){this.f[_]._id=u,this.D.fire(this.terminals[_]),this.f[_].isOpen=!0;return}}const N={name:f.name,shellPath:f.executable,shellArgs:f.args,cwd:typeof f.cwd=="string"?f.cwd:L.URI.revive(f.cwd),env:f.env,hideFromUser:f.hideFromUser},V=new D(this.a,u,N,b);this.f.push(V),this.D.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(u,m){this.O(u)?._setProcessId(m)}async $startExtensionTerminal(u,m){const b=this.O(u);if(!b)return{message:(0,h.localize)(0,null,u)};b.isOpen||await new Promise(N=>{const V=this.onDidOpenTerminal(async _=>{_===b.value&&(V.dispose(),N())})});const f=this.g.get(u);f?f.startSendingEvents(m):this.j[u]={initialDimensions:m}}M(u,m){const b=new A.DisposableStore;b.add(m.onProcessReady(N=>this.a.$sendProcessReady(u,N.pid,N.cwd))),b.add(m.onDidChangeProperty(N=>this.a.$sendProcessProperty(u,N))),this.s.startBuffering(u,m.onProcessData),b.add(m.onProcessExit(N=>this.N(u,N))),this.g.set(u,m);const f=this.j[u];return f&&m instanceof T&&(m.startSendingEvents(f.initialDimensions),delete this.j[u]),b}$acceptProcessAckDataEvent(u,m){this.g.get(u)?.acknowledgeDataEvent(m)}$acceptProcessInput(u,m){this.g.get(u)?.input(m)}$acceptTerminalInteraction(u){const m=this.O(u);m?.setInteractedWith()&&this.H.fire(m.value)}$acceptProcessResize(u,m,b){try{this.g.get(u)?.resize(m,b)}catch(f){if(f.code!=="EPIPE"&&f.code!=="ERR_IPC_CHANNEL_CLOSED")throw f}}$acceptProcessShutdown(u,m){this.g.get(u)?.shutdown(m)}$acceptProcessRequestInitialCwd(u){this.g.get(u)?.getInitialCwd().then(m=>this.a.$sendProcessProperty(u,{type:"initialCwd",value:m}))}$acceptProcessRequestCwd(u){this.g.get(u)?.getCwd().then(m=>this.a.$sendProcessProperty(u,{type:"cwd",value:m}))}$acceptProcessRequestLatency(u){return Promise.resolve(u)}registerLinkProvider(u){return this.u.add(u),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(u),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(u,m,b){if(this.v.has(m))throw new Error(`Terminal profile provider "${m}" already registered`);return this.v.set(m,b),this.a.$registerProfileProvider(m,u.identifier.value),new y.Disposable(()=>{this.v.delete(m),this.a.$unregisterProfileProvider(m)})}registerTerminalQuickFixProvider(u,m,b){if(this.w.has(u))throw new Error(`Terminal quick fix provider "${u}" is already registered`);return this.w.set(u,b),this.a.$registerQuickFixProvider(u,m),new y.Disposable(()=>{this.w.delete(u),this.a.$unregisterQuickFixProvider(u)})}async $provideTerminalQuickFixes(u,m){const b=new g.CancellationTokenSource().token;if(b.isCancellationRequested)return;const f=this.w.get(u);if(!f)return;const N=await f.provideTerminalQuickFixes(m,b);if(N!==null)return N}async $createContributedProfileTerminal(u,m){const b=new g.CancellationTokenSource().token;let f=await this.v.get(u)?.provideTerminalProfile(b);if(!b.isCancellationRequested){if(f&&!("options"in f)&&(f={options:f}),!f||!("options"in f))throw new Error(`No terminal profile options provided for id "${u}"`);if("pty"in f.options){this.createExtensionTerminal(f.options,m);return}this.createTerminalFromOptions(f.options,m)}}async $provideLinks(u,m){const b=this.O(u);if(!b)return[];this.y.delete(u),this.z.get(u)?.dispose(!0);const N=new g.CancellationTokenSource;this.z.set(u,N);const V=[],_={terminal:b.value,line:m},G=[];for(const X of this.u)G.push(o.Promises.withAsyncBody(async U=>{N.token.onCancellationRequested(()=>U({provider:X,links:[]}));const j=await X.provideTerminalLinks(_,N.token)||[];N.token.isCancellationRequested||U({provider:X,links:j})}));const $=await Promise.all(G);if(N.token.isCancellationRequested)return[];const B=new Map;for(const X of $)X&&X.links.length>0&&V.push(...X.links.map(U=>{const j={id:v++,startIndex:U.startIndex,length:U.length,label:U.tooltip};return B.set(j.id,{provider:X.provider,link:U}),j}));return this.y.set(u,B),V}$activateLink(u,m){const b=this.y.get(u)?.get(m);b&&b.provider.handleTerminalLink(b.link)}N(u,m){this.s.stopBuffering(u),this.g.delete(u),delete this.j[u];const b=this.h[u];b&&(b.dispose(),delete this.h[u]),this.a.$sendProcessExit(u,m)}O(u){return this.P(this.f,u)}P(u,m){const b=this.Q(u,m);return b!==null?u[b]:null}Q(u,m){let b=null;return u.some((f,N)=>f._id===m?(b=N,!0):!1),b}getEnvironmentVariableCollection(u){let m=this.l.get(u.identifier.value);return m||(m=new a,this.S(u.identifier.value,m)),m}R(u,m){const b=(0,w.serializeEnvironmentVariableCollection)(m.map),f=(0,w.serializeEnvironmentDescriptionMap)(m.descriptionMap);this.a.$setEnvironmentVariableCollection(u,m.persistent,b.length===0?void 0:b,f)}$initEnvironmentVariableCollections(u){u.forEach(m=>{const b=m[0],f=new a(m[1]);this.S(b,f)})}$acceptDefaultProfile(u,m){const b=this.m;this.m=u,this.n=m,b?.path!==u.path&&this.J.fire(u.path)}S(u,m){this.l.set(u,m),m.onDidChangeCollection(()=>{this.R(u,m)})}};e.BaseExtHostTerminalService=i=xe([qe(1,R.IExtHostRpcService)],i);class a{get persistent(){return this.a}set persistent(u){this.a=u,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(u){this.map=new Map,this.descriptionMap=new Map,this.a=!0,this.b=new n.Emitter,this.map=new Map(u)}get size(){return this.map.size}replace(u,m,b){this.d(u,{value:m,type:y.EnvironmentVariableMutatorType.Replace,scope:b})}append(u,m,b){this.d(u,{value:m,type:y.EnvironmentVariableMutatorType.Append,scope:b})}prepend(u,m,b){this.d(u,{value:m,type:y.EnvironmentVariableMutatorType.Prepend,scope:b})}d(u,m){m.scope||delete m.scope;const b=this.f(u,m.scope),f=this.map.get(b);if(!f||f.value!==m.value||f.type!==m.type||f.scope?.workspaceFolder?.index!==m.scope?.workspaceFolder?.index){const N=this.f(u,m.scope),V={variable:u,...m};this.map.set(N,V),this.b.fire()}}get(u,m){const b=this.f(u,m),f=this.map.get(b);return f?k(f):void 0}f(u,m){const b=this.g(m?.workspaceFolder);return b?`${u}:::${b}`:u}g(u){return u?u.uri.toString():void 0}forEach(u,m){this.map.forEach((b,f)=>u.call(m,b.variable,k(b),this))}[Symbol.iterator](){const u=new Map;return this.map.forEach((m,b)=>{m.scope||u.set(m.variable,k(m))}),u.entries()}delete(u,m){const b=this.f(u,m);this.map.delete(b),this.b.fire()}clear(u){if(u?.workspaceFolder){for(const[m,b]of this.map)b.scope?.workspaceFolder?.index===u.workspaceFolder.index&&this.map.delete(m);this.h(u)}else this.map.clear(),this.descriptionMap.clear();this.b.fire()}setDescription(u,m){const b=this.f("",m),f=this.descriptionMap.get(b);if(!f||f.description!==u){let N;typeof u=="string"?N=u:N=u?.value.split(`

`)[0];const V={description:N,scope:m};this.descriptionMap.set(b,V),this.b.fire()}}h(u){const m=this.f("",u);this.descriptionMap.delete(m)}}let r=e.WorkerExtHostTerminalService=class extends i{constructor(u){super(!1,u)}createTerminal(u,m,b){throw new O.NotSupportedError}createTerminalFromOptions(u,m){throw new O.NotSupportedError}};e.WorkerExtHostTerminalService=r=xe([qe(0,R.IExtHostRpcService)],r);function s(c){if(!(!c||typeof c=="string"))return"id"in c?{id:c.id,color:c.color}:c}function E(c){return l.ThemeColor.isThemeColor(c)?c:void 0}function k(c){const u={...c};return u.scope=u.scope??void 0,delete u.variable,u}});var Ne=this&&this.__classPrivateFieldGet||function(te,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(te):P?P.value:e.get(te)},_e=this&&this.__classPrivateFieldSet||function(te,e,n,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(te,n):I?I.value=n:e.set(te,n),n};define(Pe[244],Ae([1,0,16,17,25,21,5,202,92,6,23,12,35,4,18,104,8,7,45,74,56]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t,o,d,D,T){"use strict";var v,i;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let a=e.ExtHostTesting=class{constructor($,B,X){this.j=X,this.c=new R.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=$.getProxy(S.MainContext.MainThreadTesting),this.h=new N(this.f),this.g=new k(this.f),B.registerArgumentProcessor({processArgument:U=>{if(U?.$mid!==15)return U;const j=U,Y=j.tests[j.tests.length-1].item.extId;return this.d.get(d.TestId.root(Y))?.collection.tree.get(Y)?.actual??(0,l.toItemFromContext)(U)}}),B.registerCommand(!1,"testing.getExplorerSelection",async()=>{const U=await B.executeCommand("_testing.getExplorerSelection"),j=Y=>{const pe=this.d.get(d.TestId.root(Y));if(pe)return d.TestId.isRoot(Y)?pe.controller:pe.collection.tree.get(Y)?.actual};return{include:U?.include.map(j).filter(w.isDefined)||[],exclude:U?.exclude.map(j).filter(w.isDefined)||[]}})}createTestController($,B,X,U){if(this.d.has(B))throw new Error(`Attempt to insert a duplicate controller with ID "${B}"`);const j=new h.DisposableStore,Y=j.add(new l.ExtHostTestItemCollection(B,X,this.j));Y.root.label=X;const pe=new Map,Ee=this.f,he={items:Y.root.children,get label(){return X},set label(Re){X=Re,Y.root.label=Re,Ee.$updateController(B,{label:X})},get refreshHandler(){return U},set refreshHandler(Re){U=Re,Ee.$updateController(B,{canRefresh:!!Re})},get id(){return B},createRunProfile:(Re,le,ue,H,F,Q)=>{let me=(0,y.hash)(Re);for(;pe.has(me);)me++;return new V(this.f,pe,B,me,Re,le,ue,H,F,Q)},createTestItem(Re,le,ue){return new l.TestItemImpl(B,Re,le,ue)},createTestRun:(Re,le,ue=!0)=>this.g.createTestRun(B,Y,Re,le,ue),set resolveHandler(Re){Y.resolveHandler=Re},get resolveHandler(){return Y.resolveHandler},dispose:()=>{j.dispose()}};Ee.$registerTestController(B,X,!!U),j.add((0,h.toDisposable)(()=>Ee.$unregisterTestController(B)));const de={controller:he,collection:Y,profiles:pe};return this.d.set(B,de),j.add((0,h.toDisposable)(()=>this.d.delete(B))),j.add(Y.onDidGenerateDiff(Re=>Ee.$publishDiff(B,Re.map(T.TestsDiffOp.serialize)))),he}createTestObserver(){return this.h.checkout()}async runTests($,B=L.CancellationToken.None){const X=c($);if(!X)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const U=this.d.get(X.controllerId);if(!U)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:$.include?.map(j=>d.TestId.fromExtHostTestItem(j,U.collection.root.id).toString())??[U.collection.root.id],profileGroup:_[X.kind],profileId:X.profileId,controllerId:X.controllerId}],exclude:$.exclude?.map(j=>j.id)},B)}$syncTests(){for(const{collection:$}of this.d.values())$.flushDiff();return Promise.resolve()}$provideFileCoverage($,B,X){return(0,n.mapFind)(this.g.trackers,j=>j.id===$?j.getCoverage(B):void 0)?.provideFileCoverage(X)??Promise.resolve([])}$resolveFileCoverage($,B,X,U){return(0,n.mapFind)(this.g.trackers,Y=>Y.id===$?Y.getCoverage(B):void 0)?.resolveFileCoverage(X,U)??Promise.resolve([])}$configureRunProfile($,B){this.d.get($)?.profiles.get(B)?.configureHandler?.()}async $refreshTests($,B){await this.d.get($)?.controller.refreshHandler?.(B)}$publishTestResults($){this.results=Object.freeze($.map(B=>(0,O.deepFreeze)(t.TestResults.to(B))).concat(this.results).sort((B,X)=>X.completedAt-B.completedAt).slice(0,32)),this.c.fire()}async $expandTest($,B){const X=this.d.get(d.TestId.fromString($).controllerId)?.collection;X&&(await X.expand($,B<0?1/0:B),X.flushDiff())}$acceptDiff($){this.h.applyDiff($.map(T.TestsDiffOp.deserialize))}async $runControllerTests($,B){return Promise.all($.map(X=>this.k(X,!1,B)))}async $startContinuousRun($,B){const X=new L.CancellationTokenSource(B),U=await Promise.all($.map(j=>this.k(j,!0,X.token)));return!B.isCancellationRequested&&!U.some(j=>j.error)&&await new Promise(j=>B.onCancellationRequested(j)),X.dispose(!0),U}async k($,B,X){const U=this.d.get($.controllerId);if(!U)return{};const{collection:j,profiles:Y}=U,pe=Y.get($.profileId);if(!pe)return{};const Ee=$.testIds.map(le=>j.tree.get(le)).filter(w.isDefined),he=$.excludeExtIds.map(le=>U.collection.tree.get(le)).filter(w.isDefined).filter(le=>Ee.some(ue=>ue.fullId.compare(le.fullId)===2));if(!Ee.length)return{};const de=new o.TestRunRequest(Ee.some(le=>le.actual instanceof l.TestItemRootImpl)?void 0:Ee.map(le=>le.actual),he.map(le=>le.actual),pe,B),Re=(0,T.isStartControllerTests)($)&&this.g.prepareForMainThreadTestRun(de,u.fromInternal($,U.collection),X);try{return await pe.runHandler(de,X),{}}catch(le){return{error:String(le)}}finally{Re&&(Re.hasRunningTasks&&!X.isCancellationRequested&&await R.Event.toPromise(Re.onEnd),Re.dispose())}}$cancelExtensionTestRun($){$===void 0?this.g.cancelAllRuns():this.g.cancelRunById($)}};e.ExtHostTesting=a=xe([qe(0,p.IExtHostRpcService)],a);const r=1e4;var s;(function(G){G[G.Running=0]="Running",G[G.Cancelling=1]="Cancelling",G[G.Ended=2]="Ended"})(s||(s={}));class E extends h.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor($,B,X){super(),this.k=$,this.l=B,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new R.Emitter),this.onEnd=this.j.event,this.h=this.B(new L.CancellationTokenSource(X));const U=this.B(new P.RunOnceScheduler(()=>this.m(),r));this.B(this.h.token.onCancellationRequested(()=>U.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage($){return this.f.get($)?.coverage}createRun($){const B=this.k.id,X=this.k.controllerId,U=(0,g.generateUuid)(),j=new m(this.l,B,U),Y=de=>(Re,...le)=>{if(Ee){console.warn(`Setting the state of test "${Re.id}" is a no-op after the run ends.`);return}this.k.isIncluded(Re)&&(this.s(Re),de(Re,...le))},pe=(de,Re)=>{const le=Re instanceof Array?Re.map(t.TestMessage.from):[t.TestMessage.from(Re)];if(de.uri&&de.range){const ue={range:t.Range.from(de.range),uri:de.uri};for(const H of le)H.location=H.location||ue}this.l.$appendTestMessagesInRun(B,U,d.TestId.fromExtHostTestItem(de,X).toString(),le)};let Ee=!1;const he={isPersisted:this.k.isPersisted,token:this.h.token,name:$,get coverageProvider(){return j.coverageProvider},set coverageProvider(de){j.coverageProvider=de},enqueued:Y(de=>{this.l.$updateTestStateInRun(B,U,d.TestId.fromExtHostTestItem(de,X).toString(),1)}),skipped:Y(de=>{this.l.$updateTestStateInRun(B,U,d.TestId.fromExtHostTestItem(de,X).toString(),5)}),started:Y(de=>{this.l.$updateTestStateInRun(B,U,d.TestId.fromExtHostTestItem(de,X).toString(),2)}),errored:Y((de,Re,le)=>{pe(de,Re),this.l.$updateTestStateInRun(B,U,d.TestId.fromExtHostTestItem(de,X).toString(),6,le)}),failed:Y((de,Re,le)=>{pe(de,Re),this.l.$updateTestStateInRun(B,U,d.TestId.fromExtHostTestItem(de,X).toString(),4,le)}),passed:Y((de,Re)=>{this.l.$updateTestStateInRun(B,U,d.TestId.fromExtHostTestItem(de,this.k.controllerId).toString(),3,Re)}),appendOutput:(de,Re,le)=>{Ee||(le&&(this.k.isIncluded(le)?this.s(le):le=void 0),this.l.$appendOutputToRun(B,U,I.VSBuffer.fromString(de),Re&&t.location.from(Re),le&&d.TestId.fromExtHostTestItem(le,X).toString()))},end:()=>{Ee||(Ee=!0,this.l.$finishedTestRunTask(B,U),this.f.delete(U),this.f.size||this.p())}};return this.f.set(U,{run:he,coverage:j}),this.l.$startedTestRunTask(B,{id:U,name:$,running:!0}),he}m(){for(const{run:$}of this.f.values())$.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s($){if(!($ instanceof l.TestItemImpl))throw new D.InvalidTestItemError($.id);if(this.g.has(d.TestId.fromExtHostTestItem($,this.k.controllerId).toString()))return;const B=[],X=this.k.colllection.root;for(;;){const U=t.TestItem.from($);if(B.unshift(U),this.g.has(U.extId)||(this.g.add(U.extId),$===X))break;$=$.parent||X}this.l.$addTestsToRun(this.k.controllerId,this.k.id,B)}}class k{get trackers(){return this.c.values()}constructor($){this.d=$,this.c=new Map}prepareForMainThreadTestRun($,B,X){return this.f($,B,X)}cancelRunById($){for(const B of this.c.values())if(B.id===$){B.cancel();return}}cancelAllRuns(){for(const $ of this.c.values())$.cancel()}createTestRun($,B,X,U,j){const Y=this.c.get(X);if(Y)return Y.createRun(U);const pe=u.fromPublic($,B,X,j),Ee=c(X);this.d.$startedExtensionTestRun({controllerId:$,continuous:!!X.continuous,profile:Ee&&{group:_[Ee.kind],id:Ee.profileId},exclude:X.exclude?.map(de=>d.TestId.fromExtHostTestItem(de,B.root.id).toString())??[],id:pe.id,include:X.include?.map(de=>d.TestId.fromExtHostTestItem(de,B.root.id).toString())??[B.root.id],persist:j});const he=this.f(X,pe);return he.onEnd(()=>{this.d.$finishedExtensionTestRun(pe.id),he.dispose()}),he.createRun(U)}f($,B,X){const U=new E(B,this.d,X);return this.c.set($,U),U.onEnd(()=>this.c.delete($)),U}}e.TestRunCoordinator=k;const c=G=>{if(G.profile){if(!(G.profile instanceof V))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return G.profile}};class u{static fromPublic($,B,X,U){return new u($,(0,g.generateUuid)(),X.include?.map(j=>d.TestId.fromExtHostTestItem(j,$).toString())??[$],X.exclude?.map(j=>d.TestId.fromExtHostTestItem(j,$).toString())??[],U,B)}static fromInternal($,B){return new u($.controllerId,$.runId,$.testIds,$.excludeExtIds,!0,B)}constructor($,B,X,U,j,Y){this.controllerId=$,this.id=B,this.isPersisted=j,this.colllection=Y,this.c=X.map(pe=>pe+"\0"),this.d=U.map(pe=>pe+"\0")}isIncluded($){const B=d.TestId.fromExtHostTestItem($,this.controllerId).toString()+"\0";for(const X of this.d)if(B===X||B.startsWith(X))return!1;for(const X of this.c)if(B===X||B.startsWith(X))return!0;return!1}}e.TestRunDto=u;class m{set coverageProvider($){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");$&&(this.c=$,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor($,B,X){this.f=$,this.g=B,this.h=X}async provideFileCoverage($){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage($))());try{return(await this.d)?.map(t.TestCoverage.fromFile)??[]}catch(B){throw this.d=void 0,B}}async resolveFileCoverage($,B){const X=await this.d;let U=X?.[$];return!this.c||!X||!U?[]:(U.detailedCoverage||(U=X[$]=await this.c.resolveFileCoverage?.(U,B)??U),U.detailedCoverage?.map(t.TestCoverage.fromDetailed)??[])}}class b{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor($){this.h=$,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add($){this.c.add($)}update($){Object.assign($.revived,t.TestItem.toPlain($.item)),this.c.has($)||this.d.add($)}remove($){if(this.c.has($)){this.c.delete($);return}this.d.delete($);const B=d.TestId.parentId($.item.extId);if(B&&this.g.has(B.toString())){this.g.add($.item.extId);return}this.f.add($)}getChangeEvent(){const{c:$,d:B,f:X}=this;return{get added(){return[...$].map(U=>U.revived)},get updated(){return[...B].map(U=>U.revived)},get removed(){return[...X].map(U=>U.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class f extends T.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new R.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById($){return this.d.get($)}getMirroredTestDataByReference($){return this.d.get($.id)}p($,B){return{...$,revived:t.TestItem.toPlain($.item),depth:B?B.depth+1:0,children:new Set}}o(){return new b(this.q)}}class N{constructor($){this.d=$}checkout(){this.c||(this.c=this.f());const $=this.c;return $.observers++,{onDidChangeTest:$.tests.onDidChangeTests,get tests(){return[...$.tests.rootTests].map(B=>B.revived)},dispose:(0,A.once)(()=>{--$.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference($){return this.c?.tests.getMirroredTestDataByReference($)}applyDiff($){this.c?.tests.apply($)}f(){const $=new f;return this.d.$subscribeToDiffs(),{observers:0,tests:$}}}class V{get label(){return this.d}set label($){$!==this.d&&(this.d=$,Ne(this,v,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:$}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun($){$!==this.g&&(this.g=$,Ne(this,v,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:$}))}get isDefault(){return this.f}set isDefault($){$!==this.f&&(this.f=$,Ne(this,v,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:$}))}get tag(){return this._tag}set tag($){$?.id!==this._tag?.id&&(this._tag=$,Ne(this,v,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:$?t.TestTag.namespace(this.controllerId,$.id):null}))}get configureHandler(){return this.c}set configureHandler($){$!==this.c&&(this.c=$,Ne(this,v,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!$}))}constructor($,B,X,U,j,Y,pe,Ee=!1,he=void 0,de=!1){this.controllerId=X,this.profileId=U,this.d=j,this.kind=Y,this.runHandler=pe,this.f=Ee,this._tag=he,this.g=de,v.set(this,void 0),i.set(this,void 0),_e(this,v,$,"f"),_e(this,i,B,"f"),B.set(U,this);const Re=_[Y];if(typeof Re!="number")throw new Error(`Unknown TestRunProfile.group ${Y}`);Ne(this,v,"f").$publishTestRunProfile({profileId:U,controllerId:X,tag:he?t.TestTag.namespace(this.controllerId,he.id):null,label:j,group:Re,isDefault:Ee,hasConfigurationHandler:!1,supportsContinuousRun:de})}dispose(){Ne(this,i,"f")?.delete(this.profileId)&&(_e(this,i,void 0,"f"),Ne(this,v,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=V,v=new WeakMap,i=new WeakMap;const _={[o.TestRunProfileKind.Coverage]:8,[o.TestRunProfileKind.Debug]:4,[o.TestRunProfileKind.Run]:2}}),define(Pe[245],Ae([1,0,16,9,5,4,105,8,7]),function(te,e,n,P,I,L,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class h{constructor(w,g){this.i=g,this.a=new I.Emitter({onListenerError:P.onUnexpectedExternalError}),this.b=new I.Emitter({onListenerError:P.onUnexpectedExternalError}),this.c=new I.Emitter({onListenerError:P.onUnexpectedExternalError}),this.d=new I.Emitter({onListenerError:P.onUnexpectedExternalError}),this.f=new I.Emitter({onListenerError:P.onUnexpectedExternalError}),this.g=new I.Emitter({onListenerError:P.onUnexpectedExternalError}),this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=w.getProxy(L.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(S=>this.g.fire(S)),this.i.onDidChangeActiveTextEditor(S=>this.f.fire(S))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(w){const g=this.i.allEditors();return w?g:g.map(S=>S.value)}async showTextDocument(w,g,S){let p;typeof g=="number"?p={position:A.ViewColumn.from(g),preserveFocus:S}:typeof g=="object"?p={position:A.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selection:typeof g.selection=="object"?A.Range.from(g.selection):void 0,pinned:typeof g.preview=="boolean"?!g.preview:void 0}:p={preserveFocus:!1};const l=await this.h.$tryShowTextDocument(w.uri,p),t=l&&this.i.getEditor(l);if(t)return t.value;throw l?new Error(`Could NOT open editor for "${w.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${w.uri.toString()}".`)}createTextEditorDecorationType(w,g){return new R.TextEditorDecorationType(this.h,w,g).value}$acceptEditorPropertiesChanged(w,g){const S=this.i.getEditor(w);if(!S)throw new Error("unknown text editor");if(g.options&&S._acceptOptions(g.options),g.selections){const p=g.selections.selections.map(A.Selection.to);S._acceptSelections(p)}if(g.visibleRanges){const p=n.coalesce(g.visibleRanges.map(A.Range.to));S._acceptVisibleRanges(p)}if(g.options&&this.b.fire({textEditor:S.value,options:{...g.options,lineNumbers:A.TextEditorLineNumbersStyle.to(g.options.lineNumbers)}}),g.selections){const p=y.TextEditorSelectionChangeKind.fromValue(g.selections.source),l=g.selections.selections.map(A.Selection.to);this.a.fire({textEditor:S.value,selections:l,kind:p})}if(g.visibleRanges){const p=n.coalesce(g.visibleRanges.map(A.Range.to));this.c.fire({textEditor:S.value,visibleRanges:p})}}$acceptEditorPositionData(w){for(const g in w){const S=this.i.getEditor(g);if(!S)throw new Error("Unknown text editor");const p=A.ViewColumn.to(w[g]);S.value.viewColumn!==p&&(S._acceptViewColumn(p),this.d.fire({textEditor:S.value,viewColumn:p}))}}getDiffInformation(w){return Promise.resolve(this.h.$getDiffInformation(w))}}e.ExtHostEditors=h}),define(Pe[246],Ae([1,0,2,3,4,6,7,8,24,12]),function(te,e,n,P,I,L,R,A,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,P.createDecorator)("IExtHostTimeline");class O{constructor(S,p){this.b=new Map,this.c=new Map,this.a=S.getProxy(I.MainContext.MainThreadTimeline),p.registerArgumentProcessor({processArgument:(l,t)=>{if(l&&l.$mid===12)if(this.b.get(l.source)&&y.ExtensionIdentifier.equals(t,this.b.get(l.source)?.extension)){const o=l.uri===void 0?void 0:n.URI.revive(l.uri);return this.c.get(l.source)?.get(w(o))?.get(l.handle)}else return;return l}})}async $getTimeline(S,p,l,t){return this.b.get(S)?.provider.provideTimeline(n.URI.revive(p),l,t)}registerTimelineProvider(S,p,l,t){const o=new L.DisposableStore,d=this.d(p.id,t,o).bind(this);let D;p.onDidChange&&(D=p.onDidChange(v=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...v,id:p.id}),this));const T=this.c;return this.f({...p,scheme:S,onDidChange:void 0,async provideTimeline(v,i,a){i?.resetCache&&(o.clear(),T.get(p.id)?.clear());const r=await p.provideTimeline(v,i,a);if(r==null)return;const s=d(v,i);return{...r,source:p.id,items:r.items.map(s)}},dispose(){for(const v of T.values())v.get(p.id)?.clear();D?.dispose(),o.dispose()}},l)}d(S,p,l){return(t,o)=>{let d;if(o?.cacheResults){let D=this.c.get(S);D===void 0&&(D=new Map,this.c.set(S,D));const T=w(t);d=D.get(T),d===void 0&&(d=new Map,D.set(T,d))}return D=>{const{iconPath:T,...v}=D,i=`${S}|${D.id??D.timestamp}`;d?.set(i,D);let a,r,s;D.iconPath&&(T instanceof R.ThemeIcon?s={id:T.id,color:T.color}:n.URI.isUri(T)?(a=T,r=T):{light:a,dark:r}=T);let E;return R.MarkdownString.isMarkdownString(v.tooltip)?E=A.MarkdownString.from(v.tooltip):(0,h.isString)(v.tooltip)?E=v.tooltip:R.MarkdownString.isMarkdownString(v.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=A.MarkdownString.from(v.detail)):(0,h.isString)(v.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),E=v.detail),{...v,id:v.id??void 0,handle:i,source:S,command:D.command?p.toInternal(D.command,l):void 0,icon:a,iconDark:r,themeIcon:s,tooltip:E,accessibilityInformation:D.accessibilityInformation}}}}f(S,p){if(this.b.get(S.id))throw new Error(`Timeline Provider ${S.id} already exists.`);return this.a.$registerTimelineProvider({id:S.id,label:S.label,scheme:S.scheme}),this.b.set(S.id,{provider:S,extension:p}),(0,L.toDisposable)(()=>{for(const t of this.c.values())t.get(S.id)?.clear();this.b.delete(S.id),this.a.$unregisterTimelineProvider(S.id),S.dispose()})}}e.ExtHostTimeline=O;function w(g){return g?.toString()}}),define(Pe[247],Ae([1,0,6,15,2,4]),function(te,e,n,P,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(y){this.c=new Map,this.b=y.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,h,O,w){if(this.c.has(h))throw new Error(`Opener with id '${h}' already registered`);const g=w.schemes.find(S=>!R.a.has(S));if(g)throw new Error(`Scheme '${g}' is not supported. Only http and https are currently supported.`);return this.c.set(h,O),this.b.$registerUriOpener(h,w.schemes,y,w.label),(0,n.toDisposable)(()=>{this.c.delete(h),this.b.$unregisterUriOpener(h)})}async $canOpenUri(y,h,O){const w=this.c.get(y);if(!w)throw new Error(`Unknown opener with id: ${y}`);const g=I.URI.revive(h);return w.canOpenExternalUri(g,O)}async $openUri(y,h,O){const w=this.c.get(y);if(!w)throw new Error(`Unknown opener id: '${y}'`);return w.openExternalUri(I.URI.revive(h.resolvedUri),{sourceUri:I.URI.revive(h.sourceUri)},O)}}e.ExtHostUriOpeners=R,R.a=new Set([P.Schemas.http,P.Schemas.https])}),define(Pe[248],Ae([1,0,4,2,6,9,24]),function(te,e,n,P,I,L,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(h){this.c=new R.ExtensionIdentifierSet,this.d=new Map,this.b=h.getProxy(n.MainContext.MainThreadUrls)}registerUriHandler(h,O){if(this.c.has(h))throw new Error(`Protocol handler already registered for extension ${h}`);const w=A.a++;return this.c.add(h),this.d.set(w,O),this.b.$registerUriHandler(w,h),(0,I.toDisposable)(()=>{this.c.delete(h),this.d.delete(w),this.b.$unregisterUriHandler(w)})}$handleExternalUri(h,O){const w=this.d.get(h);if(!w)return Promise.resolve(void 0);try{w.handleUri(P.URI.revive(O))}catch(g){(0,L.onUnexpectedError)(g)}return Promise.resolve(void 0)}async createAppUri(h){return P.URI.revive(await this.b.$createAppUri(h))}}e.ExtHostUrls=A,A.a=0});var _e=this&&this.__classPrivateFieldSet||function(te,e,n,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(te,n):I?I.value=n:e.set(te,n),n},Ne=this&&this.__classPrivateFieldGet||function(te,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(te):P?P.value:e.get(te)};define(Pe[63],Ae([1,0,5,15,23,2,166,189,75,4]),function(te,e,n,P,I,L,R,A,y,h){"use strict";var O,w,g,S,p,l,t,o,d,D,T,v,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class a{constructor(f,N,V,_,G,$,B){O.set(this,void 0),w.set(this,void 0),g.set(this,void 0),S.set(this,void 0),p.set(this,void 0),l.set(this,void 0),t.set(this,""),o.set(this,void 0),d.set(this,!1),D.set(this,!1),T.set(this,void 0),v.set(this,void 0),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new n.Emitter),this._onDidDispose=Ne(this,i,"f").event,_e(this,O,f,"f"),_e(this,w,N,"f"),_e(this,o,V,"f"),_e(this,S,_,"f"),_e(this,p,G,"f"),_e(this,l,$,"f"),_e(this,T,r($),"f"),_e(this,v,s($),"f"),_e(this,g,B,"f")}dispose(){_e(this,d,!0,"f"),Ne(this,i,"f").fire(),Ne(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(f){return _e(this,D,!0,"f"),(0,y.asWebviewUri)(f,Ne(this,S,"f"))}get cspSource(){const f=Ne(this,l,"f").extensionLocation;if(f.scheme===P.Schemas.https||f.scheme===P.Schemas.http){let N=f.toString();return N.endsWith("/")||(N+="/"),N+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Ne(this,t,"f")}set html(f){this.a(),Ne(this,t,"f")!==f&&(_e(this,t,f,"f"),Ne(this,v,"f")&&!Ne(this,D,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(f)&&(_e(this,D,!0,"f"),Ne(this,g,"f").report("Webview vscode-resource: uris",Ne(this,l,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ne(this,w,"f").$setHtml(Ne(this,O,"f"),this.b(f)))}get options(){return this.a(),Ne(this,o,"f")}set options(f){this.a(),I.equals(Ne(this,o,"f"),f)||Ne(this,w,"f").$setOptions(Ne(this,O,"f"),c(Ne(this,l,"f"),Ne(this,p,"f"),f)),_e(this,o,f,"f")}async postMessage(f){if(Ne(this,d,"f"))return!1;const N=(0,A.serializeWebviewMessage)(f,{serializeBuffersForPostMessage:Ne(this,T,"f")});return Ne(this,w,"f").$postMessage(Ne(this,O,"f"),N.message,...N.buffers)}a(){if(Ne(this,d,"f"))throw new Error("Webview is disposed")}b(f){if(!Ne(this,v,"f"))return f;const N=Ne(this,l,"f").extensionLocation?.scheme===P.Schemas.vscodeRemote,V=Ne(this,l,"f").extensionLocation.scheme===P.Schemas.vscodeRemote?Ne(this,l,"f").extensionLocation.authority:void 0;return f.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(_,G,$,B,X,U)=>{const j=L.URI.from({scheme:B||"file",path:decodeURIComponent(X)}),Y=(0,y.asWebviewUri)(j,{isRemote:N,authority:V}).toString();return`${G}${Y}${U}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(_,G,$,B,X,U)=>{const j=L.URI.from({scheme:B||"file",path:decodeURIComponent(X)}),Y=(0,y.asWebviewUri)(j,{isRemote:N,authority:V}).toString();return`${G}${Y}${U}`})}}e.ExtHostWebview=a,O=new WeakMap,w=new WeakMap,g=new WeakMap,S=new WeakMap,p=new WeakMap,l=new WeakMap,t=new WeakMap,o=new WeakMap,d=new WeakMap,D=new WeakMap,T=new WeakMap,v=new WeakMap,i=new WeakMap;function r(b){try{const f=(0,R.normalizeVersion)((0,R.parseVersion)(b.engines.vscode));return!!f&&f.majorBase>=1&&f.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function s(b){try{const f=(0,R.normalizeVersion)((0,R.parseVersion)(b.engines.vscode));return f?f.majorBase<1||f.majorBase===1&&f.minorBase<60:!1}catch{return!1}}class E{constructor(f,N,V,_,G){this.c=N,this.d=V,this.e=_,this.f=G,this.b=new Map,this.a=f.getProxy(h.MainContext.MainThreadWebviews)}$onMessage(f,N,V){const _=this.g(f);if(_){const{message:G}=(0,A.deserializeWebviewMessage)(N,V.value);_._onMessageEmitter.fire(G)}}$onMissingCsp(f,N){this.e.warn(`${N} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(f,N,V){const _=new a(f,this.a,u(N),this.c,this.d,V,this.f);return this.b.set(f,_),_._onDidDispose(()=>{this.b.delete(f)}),_}deleteWebview(f){this.b.delete(f)}g(f){return this.b.get(f)}}e.ExtHostWebviews=E;function k(b){return{id:b.identifier,location:b.extensionLocation}}e.toExtensionData=k;function c(b,f,N){return{enableCommandUris:N.enableCommandUris,enableScripts:N.enableScripts,enableForms:N.enableForms,portMapping:N.portMapping,localResourceRoots:N.localResourceRoots||m(b,f)}}e.serializeWebviewOptions=c;function u(b){return{enableCommandUris:b.enableCommandUris,enableScripts:b.enableScripts,enableForms:b.enableForms,portMapping:b.portMapping,localResourceRoots:b.localResourceRoots?.map(f=>L.URI.from(f))}}function m(b,f){return[...(f?.getWorkspaceFolders()||[]).map(N=>N.uri),b.extensionLocation]}}),define(Pe[249],Ae([1,0,21,92,6,15,22,2,8,63,54,4,7]),function(te,e,n,P,I,L,R,A,y,h,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class S{constructor(a,r){this.document=a,this.b=r,this.a=1,this.c=new O.Cache("custom documents")}addEdit(a){return this.c.add([a])}async undo(a,r){await this.f(a).undo(),r||this.disposeBackup()}async redo(a,r){await this.f(a).redo(),r||this.disposeBackup()}disposeEdits(a){for(const r of a)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const a=v(this.document.uri)+this.a++;return(0,R.joinPath)(this.b,a)}updateBackup(a){this.d?.delete(),this.d=a}disposeBackup(){this.d?.delete(),this.d=void 0}f(a){const r=this.c.get(a,0);if(!r)throw new Error("No edit found");return r}}class p{constructor(){this.a=new Map}get(a,r){return this.a.get(this.b(a,r))}add(a,r,s){const E=this.b(a,r.uri);if(this.a.has(E))throw new Error(`Document already exists for viewType:${a} resource:${r.uri}`);const k=new S(r,s);return this.a.set(E,k),k}delete(a,r){const s=this.b(a,r.uri);this.a.delete(s)}b(a,r){return`${a}@@@${r}`}}var l;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(l||(l={}));class t{constructor(){this.a=new Map}addTextProvider(a,r,s){return this.b(0,a,r,s)}addCustomProvider(a,r,s){return this.b(1,a,r,s)}get(a){return this.a.get(a)}b(a,r,s,E){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:a,extension:s,provider:E}),new g.Disposable(()=>this.a.delete(r))}}class o{constructor(a,r,s,E,k){this.d=r,this.f=s,this.g=E,this.h=k,this.b=new t,this.c=new p,this.a=a.getProxy(w.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(a,r,s,E){const k=new I.DisposableStore;return D(s)?(k.add(this.b.addTextProvider(r,a,s)),this.a.$registerTextEditorProvider((0,h.toExtensionData)(a),r,E.webviewOptions||{},{supportsMove:!!s.moveCustomTextEditor},(0,h.shouldSerializeBuffersForPostMessage)(a))):(k.add(this.b.addCustomProvider(r,a,s)),d(s)&&k.add(s.onDidChangeCustomDocument(c=>{const u=this.i(r,c.document.uri);if(T(c)){const m=u.addEdit(c);this.a.$onDidEdit(c.document.uri,r,m,c.label)}else this.a.$onContentChange(c.document.uri,r)})),this.a.$registerCustomEditorProvider((0,h.toExtensionData)(a),r,E.webviewOptions||{},!!E.supportsMultipleEditorsPerDocument,(0,h.shouldSerializeBuffersForPostMessage)(a))),g.Disposable.from(k,new g.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(a,r,s,E,k){const c=this.b.get(r);if(!c)throw new Error(`No provider found for '${r}'`);if(c.type!==1)throw new Error(`Invalid provide type for '${r}'`);const u=A.URI.revive(a),m=await c.provider.openCustomDocument(u,{backupId:s,untitledDocumentData:E?.buffer},k);let b;return d(c.provider)&&this.f&&(b=this.f.workspaceValue(c.extension)??this.f.globalValue(c.extension)),this.c.add(r,m,b),{editable:d(c.provider)}}async $disposeCustomDocument(a,r){const s=this.b.get(r);if(!s)throw new Error(`No provider found for '${r}'`);if(s.type!==1)throw new Error(`Invalid provider type for '${r}'`);const E=A.URI.revive(a),{document:k}=this.i(r,E);this.c.delete(r,k),k.dispose()}async $resolveCustomEditor(a,r,s,E,k,c){const u=this.b.get(s);if(!u)throw new Error(`No provider found for '${s}'`);const m=y.ViewColumn.to(k),b=this.g.createNewWebview(r,E.contentOptions,u.extension),f=this.h.createNewWebviewPanel(r,s,E.title,m,E.options,b,!0),N=A.URI.revive(a);switch(u.type){case 1:{const{document:V}=this.i(s,N);return u.provider.resolveCustomEditor(V,f,c)}case 0:{const V=this.d.getDocument(N);return u.provider.resolveCustomTextEditor(V,f,c)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(a,r,s){this.i(r,a).disposeEdits(s)}async $onMoveCustomEditor(a,r,s){const E=this.b.get(s);if(!E)throw new Error(`No provider found for '${s}'`);if(!E.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${s}'`);const k=this.h.getWebviewPanel(a);if(!k)throw new Error("No webview found");const c=A.URI.revive(r),u=this.d.getDocument(c);await E.provider.moveCustomTextEditor(u,k,n.CancellationToken.None)}async $undo(a,r,s,E){return this.i(r,a).undo(s,E)}async $redo(a,r,s,E){return this.i(r,a).redo(s,E)}async $revert(a,r,s){const E=this.i(r,a);await this.j(r).revertCustomDocument(E.document,s),E.disposeBackup()}async $onSave(a,r,s){const E=this.i(r,a);await this.j(r).saveCustomDocument(E.document,s),E.disposeBackup()}async $onSaveAs(a,r,s,E){const k=this.i(r,a);return this.j(r).saveCustomDocumentAs(k.document,A.URI.revive(s),E)}async $backup(a,r,s){const E=this.i(r,a),c=await this.j(r).backupCustomDocument(E.document,{destination:E.getNewBackupUri()},s);return E.updateBackup(c),c.id}i(a,r){const s=this.c.get(a,A.URI.revive(r));if(!s)throw new Error("No custom document found");return s}j(a){const s=this.b.get(a)?.provider;if(!s||!d(s))throw new Error("Custom document is not editable");return s}}e.ExtHostCustomEditors=o;function d(i){return!!i.onDidChangeCustomDocument}function D(i){return typeof i.resolveCustomTextEditor=="function"}function T(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function v(i){const a=i.scheme===L.Schemas.file||i.scheme===L.Schemas.untitled?i.fsPath:i.toString();return(0,P.hash)(a)+""}});var _e=this&&this.__classPrivateFieldSet||function(te,e,n,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(te,n):I?I.value=n:e.set(te,n),n},Ne=this&&this.__classPrivateFieldGet||function(te,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(te):P?P.value:e.get(te)};define(Pe[250],Ae([1,0,5,6,2,35,8,63,4,7]),function(te,e,n,P,I,L,R,A,y,h){"use strict";var O,w,g,S,p,l,t,o,d,D,T,v,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class a extends P.Disposable{constructor(k,c,u,m){super(),O.set(this,void 0),w.set(this,void 0),g.set(this,void 0),S.set(this,void 0),p.set(this,void 0),l.set(this,void 0),t.set(this,void 0),o.set(this,void 0),d.set(this,!0),D.set(this,void 0),T.set(this,!1),v.set(this,this.B(new n.Emitter)),this.onDidDispose=Ne(this,v,"f").event,i.set(this,this.B(new n.Emitter)),this.onDidChangeViewState=Ne(this,i,"f").event,_e(this,O,k,"f"),_e(this,w,c,"f"),_e(this,S,u,"f"),_e(this,g,m.viewType,"f"),_e(this,p,m.panelOptions,"f"),_e(this,o,m.viewColumn,"f"),_e(this,l,m.title,"f"),_e(this,D,m.active,"f")}dispose(){Ne(this,T,"f")||(_e(this,T,!0,"f"),Ne(this,v,"f").fire(),Ne(this,w,"f").$disposeWebview(Ne(this,O,"f")),Ne(this,S,"f").dispose(),super.dispose())}get webview(){return this.c(),Ne(this,S,"f")}get viewType(){return this.c(),Ne(this,g,"f")}get title(){return this.c(),Ne(this,l,"f")}set title(k){this.c(),Ne(this,l,"f")!==k&&(_e(this,l,k,"f"),Ne(this,w,"f").$setTitle(Ne(this,O,"f"),k))}get iconPath(){return this.c(),Ne(this,t,"f")}set iconPath(k){this.c(),Ne(this,t,"f")!==k&&(_e(this,t,k,"f"),Ne(this,w,"f").$setIconPath(Ne(this,O,"f"),I.URI.isUri(k)?{light:k,dark:k}:k))}get options(){return Ne(this,p,"f")}get viewColumn(){if(this.c(),!(typeof Ne(this,o,"f")=="number"&&Ne(this,o,"f")<0))return Ne(this,o,"f")}get active(){return this.c(),Ne(this,D,"f")}get visible(){return this.c(),Ne(this,d,"f")}_updateViewState(k){Ne(this,T,"f")||(this.active!==k.active||this.visible!==k.visible||this.viewColumn!==k.viewColumn)&&(_e(this,D,k.active,"f"),_e(this,d,k.visible,"f"),_e(this,o,k.viewColumn,"f"),Ne(this,i,"f").fire({webviewPanel:this}))}reveal(k,c){this.c(),Ne(this,w,"f").$reveal(Ne(this,O,"f"),{viewColumn:typeof k>"u"?void 0:R.ViewColumn.from(k),preserveFocus:!!c})}c(){if(Ne(this,T,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,w=new WeakMap,g=new WeakMap,S=new WeakMap,p=new WeakMap,l=new WeakMap,t=new WeakMap,o=new WeakMap,d=new WeakMap,D=new WeakMap,T=new WeakMap,v=new WeakMap,i=new WeakMap;class r{static c(){return(0,L.generateUuid)()}constructor(k,c,u){this.g=c,this.h=u,this.e=new Map,this.f=new Map,this.d=k.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(k,c,u,m,b={}){const f=typeof m=="object"?m.viewColumn:m,N={viewColumn:R.ViewColumn.from(f),preserveFocus:typeof m=="object"&&!!m.preserveFocus},V=(0,A.shouldSerializeBuffersForPostMessage)(k),_=r.c();this.d.$createWebviewPanel((0,A.toExtensionData)(k),_,c,{title:u,panelOptions:s(b),webviewOptions:(0,A.serializeWebviewOptions)(k,this.h,b),serializeBuffersForPostMessage:V},N);const G=this.g.createNewWebview(_,b,k);return this.createNewWebviewPanel(_,c,u,f,b,G,!0)}$onDidChangeWebviewPanelViewStates(k){const c=Object.keys(k);c.sort((u,m)=>{const b=k[u],f=k[m];return b.active?1:f.active?-1:+b.visible-+f.visible});for(const u of c){const m=this.getWebviewPanel(u);if(!m)continue;const b=k[u];m._updateViewState({active:b.active,visible:b.visible,viewColumn:R.ViewColumn.to(b.position)})}}async $onDidDisposeWebviewPanel(k){this.getWebviewPanel(k)?.dispose(),this.e.delete(k),this.g.deleteWebview(k)}registerWebviewPanelSerializer(k,c,u){if(this.f.has(c))throw new Error(`Serializer for '${c}' already registered`);return this.f.set(c,{serializer:u,extension:k}),this.d.$registerSerializer(c,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(k)}),new h.Disposable(()=>{this.f.delete(c),this.d.$unregisterSerializer(c)})}async $deserializeWebviewPanel(k,c,u,m){const b=this.f.get(c);if(!b)throw new Error(`No serializer found for '${c}'`);const{serializer:f,extension:N}=b,V=this.g.createNewWebview(k,u.webviewOptions,N),_=this.createNewWebviewPanel(k,c,u.title,m,u.panelOptions,V,u.active);await f.deserializeWebviewPanel(_,u.state)}createNewWebviewPanel(k,c,u,m,b,f,N){const V=new a(k,this.d,f,{viewType:c,title:u,viewColumn:m,panelOptions:b,active:N});return this.e.set(k,V),V}getWebviewPanel(k){return this.e.get(k)}}e.ExtHostWebviewPanels=r;function s(E){return{enableFindWidget:E.enableFindWidget,retainContextWhenHidden:E.retainContextWhenHidden}}});var _e=this&&this.__classPrivateFieldSet||function(te,e,n,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(te,n):I?I.value=n:e.set(te,n),n},Ne=this&&this.__classPrivateFieldGet||function(te,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(te):P?P.value:e.get(te)};define(Pe[251],Ae([1,0,5,6,63,8,4,7]),function(te,e,n,P,I,L,R,A){"use strict";var y,h,O,w,g,S,p,l,t,o,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class D extends P.Disposable{constructor(i,a,r,s,E,k){super(),y.set(this,void 0),h.set(this,void 0),O.set(this,void 0),w.set(this,void 0),g.set(this,!1),S.set(this,void 0),p.set(this,void 0),l.set(this,void 0),t.set(this,void 0),o.set(this,this.B(new n.Emitter)),this.onDidChangeVisibility=Ne(this,o,"f").event,d.set(this,this.B(new n.Emitter)),this.onDidDispose=Ne(this,d,"f").event,_e(this,O,r,"f"),_e(this,p,s,"f"),_e(this,y,i,"f"),_e(this,h,a,"f"),_e(this,w,E,"f"),_e(this,S,k,"f")}dispose(){Ne(this,g,"f")||(_e(this,g,!0,"f"),Ne(this,d,"f").fire(),Ne(this,w,"f").dispose(),super.dispose())}get title(){return this.a(),Ne(this,p,"f")}set title(i){this.a(),Ne(this,p,"f")!==i&&(_e(this,p,i,"f"),Ne(this,h,"f").$setWebviewViewTitle(Ne(this,y,"f"),i))}get description(){return this.a(),Ne(this,l,"f")}set description(i){this.a(),Ne(this,l,"f")!==i&&(_e(this,l,i,"f"),Ne(this,h,"f").$setWebviewViewDescription(Ne(this,y,"f"),i))}get visible(){return Ne(this,S,"f")}get webview(){return Ne(this,w,"f")}get viewType(){return Ne(this,O,"f")}_setVisible(i){i===Ne(this,S,"f")||Ne(this,g,"f")||(_e(this,S,i,"f"),Ne(this,o,"f").fire())}get badge(){return this.a(),Ne(this,t,"f")}set badge(i){this.a(),!(i?.value===Ne(this,t,"f")?.value&&i?.tooltip===Ne(this,t,"f")?.tooltip)&&(_e(this,t,L.ViewBadge.from(i),"f"),Ne(this,h,"f").$setWebviewViewBadge(Ne(this,y,"f"),i))}show(i){this.a(),Ne(this,h,"f").$show(Ne(this,y,"f"),!!i)}a(){if(Ne(this,g,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,h=new WeakMap,O=new WeakMap,w=new WeakMap,g=new WeakMap,S=new WeakMap,p=new WeakMap,l=new WeakMap,t=new WeakMap,o=new WeakMap,d=new WeakMap;class T{constructor(i,a){this.d=a,this.b=new Map,this.c=new Map,this.a=i.getProxy(R.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,a,r,s){if(this.b.has(a))throw new Error(`View provider for '${a}' already registered`);return this.b.set(a,{provider:r,extension:i}),this.a.$registerWebviewViewProvider((0,I.toExtensionData)(i),a,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(i)}),new A.Disposable(()=>{this.b.delete(a),this.a.$unregisterWebviewViewProvider(a)})}async $resolveWebviewView(i,a,r,s,E){const k=this.b.get(a);if(!k)throw new Error(`No view provider found for '${a}'`);const{provider:c,extension:u}=k,m=this.d.createNewWebview(i,{},u),b=new D(i,this.a,a,r,m,!0);this.c.set(i,b),await c.resolveWebviewView(b,{state:s},E)}async $onDidChangeWebviewViewVisibility(i,a){this.e(i)._setVisible(a)}async $disposeWebviewView(i){const a=this.e(i);this.c.delete(i),a.dispose(),this.d.deleteWebview(i)}e(i){const a=this.c.get(i);if(!a)throw new Error("No webview found");return a}}e.ExtHostWebviewViews=T}),define(Pe[107],Ae([1,0,5,4,2,15,13,3,18]),function(te,e,n,P,I,L,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let h=e.ExtHostWindow=class In{get state(){return this.d}constructor(w){this.c=new n.Emitter,this.onDidChangeWindowState=this.c.event,this.d=In.a,this.b=w.getProxy(P.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(g=>this.$onDidChangeWindowFocus(g))}$onDidChangeWindowFocus(w){w!==this.d.focused&&(this.d={...this.d,focused:w},this.c.fire(this.d))}openUri(w,g){let S;if(typeof w=="string"){S=w;try{w=I.URI.parse(w)}catch{return Promise.reject(`Invalid uri - '${w}'`)}}return(0,R.isFalsyOrWhitespace)(w.scheme)?Promise.reject("Invalid scheme - cannot be empty"):w.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${w.scheme}'`):this.b.$openUri(w,S,g)}async asExternalUri(w,g){if((0,R.isFalsyOrWhitespace)(w.scheme))return Promise.reject("Invalid scheme - cannot be empty");const S=await this.b.$asExternalUri(w,g);return I.URI.from(S)}};h.a={focused:!0},e.ExtHostWindow=h=xe([qe(0,y.IExtHostRpcService)],h),e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(Pe[252],Ae([1,0,219,27,18]),function(te,e,n,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let L=e.ExtHostConsoleForwarder=class extends n.AbstractExtHostConsoleForwarder{constructor(A,y){super(A,y)}f(A,y,h){y.apply(console,h)}};e.ExtHostConsoleForwarder=L=xe([qe(0,I.IExtHostRpcService),qe(1,P.IExtHostInitDataService)],L)}),define(Pe[253],Ae([1,0,17,25,21,9,5,6,131,213,46]),function(te,e,n,P,I,L,R,A,y,h,O){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function g(b,f){try{return JSON.stringify(b,f)}catch{return"null"}}const S="$$ref$$",p={[S]:-1};class l{constructor(f,N){this.jsonString=f,this.referencedBuffers=N}}function t(b,f=null,N=!1){const V=[];return{jsonString:(N?g:JSON.stringify)(b,(G,$)=>{if(typeof $>"u")return p;if(typeof $=="object"){if($ instanceof P.VSBuffer){const B=V.push($)-1;return{[S]:B}}if(f)return f(G,$)}return $}),referencedBuffers:V}}e.stringifyJsonWithBufferRefs=t;function o(b,f,N){return JSON.parse(b,(V,_)=>{if(_){const G=_[S];if(typeof G=="number")return f[G];if(N&&_.$mid===1)return N.transformIncoming(_)}return _})}e.parseJsonAndRestoreBufferRefs=o;function d(b,f){return JSON.stringify(b,f)}function D(b){return b?(f,N)=>N&&N.$mid===1?b.transformOutgoing(N):N:null}var T;(function(b){b[b.LocalSide=0]="LocalSide",b[b.OtherSide=1]="OtherSide"})(T||(e.RequestInitiator=T={}));var v;(function(b){b[b.Responsive=0]="Responsive",b[b.Unresponsive=1]="Unresponsive"})(v||(e.ResponsiveState=v={}));const i=()=>{},a=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class s extends A.Disposable{constructor(f,N=null,V=null){super(),this[w]=!0,this.b=this.B(new R.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=f,this.f=N,this.g=V,this.h=D(this.g),this.j=!1,this.k=[],this.l=[];for(let _=0,G=O.ProxyIdentifier.count;_<G;_++)this.k[_]=null,this.l[_]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new n.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(_=>this.G(_))}dispose(){this.j=!0,Object.keys(this.s).forEach(f=>{this.s[f].resolveErr(L.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(f){this.u===0&&(this.v=Date.now()+s.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(f){this.v=Date.now()+s.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(f){this.t!==f&&(this.t=f,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(f){return this.g?(0,y.transformIncomingURIs)(f,this.g):f}getProxy(f){const{nid:N,sid:V}=f;return this.l[N]||(this.l[N]=this.F(N,V)),this.l[N]}F(f,N){const V={get:(_,G)=>(typeof G=="string"&&!_[G]&&G.charCodeAt(0)===36&&(_[G]=(...$)=>this.O(f,G,$)),G===r?N:_[G])};return new Proxy(Object.create(null),V)}set(f,N){return this.k[f.nid]=N,N}assertRegistered(f){for(let N=0,V=f.length;N<V;N++){const _=f[N];if(!this.k[_.nid])throw new Error(`Missing proxy instance ${_.sid}`)}}G(f){if(this.j)return;const N=f.byteLength,V=E.read(f,0),_=V.readUInt8(),G=V.readUInt32();switch(_){case 1:case 2:{let{rpcId:$,method:B,args:X}=c.deserializeRequestJSONArgs(V);this.g&&(X=(0,y.transformIncomingURIs)(X,this.g)),this.H(N,G,$,B,X,_===2);break}case 3:case 4:{let{rpcId:$,method:B,args:X}=c.deserializeRequestMixedArgs(V);this.g&&(X=(0,y.transformIncomingURIs)(X,this.g)),this.H(N,G,$,B,X,_===4);break}case 5:{this.f?.logIncoming(N,G,0,"ack"),this.z(G);break}case 6:{this.I(N,G);break}case 7:{this.J(N,G,void 0);break}case 9:{let $=c.deserializeReplyOKJSON(V);this.g&&($=(0,y.transformIncomingURIs)($,this.g)),this.J(N,G,$);break}case 10:{const $=c.deserializeReplyOKJSONWithBuffers(V,this.g);this.J(N,G,$);break}case 8:{const $=c.deserializeReplyOKVSBuffer(V);this.J(N,G,$);break}case 11:{let $=c.deserializeReplyErrError(V);this.g&&($=(0,y.transformIncomingURIs)($,this.g)),this.L(N,G,$);break}case 12:{this.L(N,G,void 0);break}default:console.error("received unexpected message"),console.error(f)}}H(f,N,V,_,G,$){this.f?.logIncoming(f,N,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(V)}.${_}(`,G);const B=String(N);let X,U;if($){const Y=new I.CancellationTokenSource;G.push(Y.token),X=this.M(V,_,G),U=()=>Y.cancel()}else X=this.M(V,_,G),U=i;this.p[B]=U;const j=c.serializeAcknowledged(N);this.f?.logOutgoing(j.byteLength,N,1,"ack"),this.c.send(j),X.then(Y=>{delete this.p[B];const pe=c.serializeReplyOK(N,Y,this.h);this.f?.logOutgoing(pe.byteLength,N,1,"reply:",Y),this.c.send(pe)},Y=>{delete this.p[B];const pe=c.serializeReplyErr(N,Y);this.f?.logOutgoing(pe.byteLength,N,1,"replyErr:",Y),this.c.send(pe)})}I(f,N){this.f?.logIncoming(f,N,1,"receiveCancel");const V=String(N);this.p[V]?.()}J(f,N,V){this.f?.logIncoming(f,N,0,"receiveReply:",V);const _=String(N);if(!this.s.hasOwnProperty(_))return;const G=this.s[_];delete this.s[_],G.resolveOk(V)}L(f,N,V){this.f?.logIncoming(f,N,0,"receiveReplyErr:",V);const _=String(N);if(!this.s.hasOwnProperty(_))return;const G=this.s[_];delete this.s[_];let $;V&&(V.$isError?($=new Error,$.name=V.name,$.message=V.message,$.stack=V.stack):$=V),G.resolveErr($)}M(f,N,V){try{return Promise.resolve(this.N(f,N,V))}catch(_){return Promise.reject(_)}}N(f,N,V){const _=this.k[f];if(!_)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(f));const G=_[N];if(typeof G!="function")throw new Error("Unknown method "+N+" on actor "+(0,O.getStringIdentifierForProxy)(f));return G.apply(_,V)}O(f,N,V){if(this.j)return new h.CanceledLazyPromise;let _=null;if(V.length>0&&I.CancellationToken.isCancellationToken(V[V.length-1])&&(_=V.pop()),_&&_.isCancellationRequested)return Promise.reject(L.canceled());const G=c.serializeRequestArguments(V,this.h),$=++this.m,B=String($),X=new h.LazyPromise;_&&_.onCancellationRequested(()=>{const j=c.serializeCancel($);this.f?.logOutgoing(j.byteLength,$,0,"cancel"),this.c.send(c.serializeCancel($))}),this.s[B]=X,this.y($);const U=c.serializeRequest($,f,N,G,!!_);return this.f?.logOutgoing(U.byteLength,$,0,`request: ${(0,O.getStringIdentifierForProxy)(f)}.${N}(`,V),this.c.send(U),X}}e.RPCProtocol=s,w=a,s.a=3*1e3;class E{static alloc(f,N,V){const _=new E(P.VSBuffer.alloc(V+1+4),0);return _.writeUInt8(f),_.writeUInt32(N),_}static read(f,N){return new E(f,N)}get buffer(){return this.a}constructor(f,N){this.a=f,this.b=N}static sizeUInt8(){return 1}writeUInt8(f){this.a.writeUInt8(f,this.b),this.b+=1}readUInt8(){const f=this.a.readUInt8(this.b);return this.b+=1,f}writeUInt32(f){this.a.writeUInt32BE(f,this.b),this.b+=4}readUInt32(){const f=this.a.readUInt32BE(this.b);return this.b+=4,f}static sizeShortString(f){return 1+f.byteLength}writeShortString(f){this.a.writeUInt8(f.byteLength,this.b),this.b+=1,this.a.set(f,this.b),this.b+=f.byteLength}readShortString(){const f=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+f).toString();return this.b+=f,V}static sizeLongString(f){return 4+f.byteLength}writeLongString(f){this.a.writeUInt32BE(f.byteLength,this.b),this.b+=4,this.a.set(f,this.b),this.b+=f.byteLength}readLongString(){const f=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+f).toString();return this.b+=f,V}writeBuffer(f){this.a.writeUInt32BE(f.byteLength,this.b),this.b+=4,this.a.set(f,this.b),this.b+=f.byteLength}static sizeVSBuffer(f){return 4+f.byteLength}writeVSBuffer(f){this.a.writeUInt32BE(f.byteLength,this.b),this.b+=4,this.a.set(f,this.b),this.b+=f.byteLength}readVSBuffer(){const f=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+f);return this.b+=f,N}static sizeMixedArray(f){let N=0;N+=1;for(let V=0,_=f.length;V<_;V++){const G=f[V];switch(N+=1,G.type){case 1:N+=this.sizeLongString(G.value);break;case 2:N+=this.sizeVSBuffer(G.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(G.value);for(let $=0;$<G.buffers.length;++$)N+=this.sizeVSBuffer(G.buffers[$]);break;case 4:break}}return N}writeMixedArray(f){this.a.writeUInt8(f.length,this.b),this.b+=1;for(let N=0,V=f.length;N<V;N++){const _=f[N];switch(_.type){case 1:this.writeUInt8(1),this.writeLongString(_.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(_.value);break;case 3:this.writeUInt8(3),this.writeUInt32(_.buffers.length),this.writeLongString(_.value);for(let G=0;G<_.buffers.length;++G)this.writeBuffer(_.buffers[G]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const f=this.a.readUInt8(this.b);this.b+=1;const N=new Array(f);for(let V=0;V<f;V++)switch(this.readUInt8()){case 1:N[V]=this.readLongString();break;case 2:N[V]=this.readVSBuffer();break;case 3:{const G=this.readUInt32(),$=this.readLongString(),B=[];for(let X=0;X<G;++X)B.push(this.readVSBuffer());N[V]=new O.SerializableObjectWithBuffers(o($,B,null));break}case 4:N[V]=void 0;break}return N}}E.sizeUInt32=4;var k;(function(b){b[b.Simple=0]="Simple",b[b.Mixed=1]="Mixed"})(k||(k={}));class c{static a(f){for(let N=0,V=f.length;N<V;N++)if(f[N]instanceof P.VSBuffer||f[N]instanceof O.SerializableObjectWithBuffers||typeof f[N]>"u")return!0;return!1}static serializeRequestArguments(f,N){if(this.a(f)){const V=[];for(let _=0,G=f.length;_<G;_++){const $=f[_];if($ instanceof P.VSBuffer)V[_]={type:2,value:$};else if(typeof $>"u")V[_]={type:4};else if($ instanceof O.SerializableObjectWithBuffers){const{jsonString:B,referencedBuffers:X}=t($.value,N);V[_]={type:3,value:P.VSBuffer.fromString(B),buffers:X}}else V[_]={type:1,value:P.VSBuffer.fromString(d($,N))}}return{type:1,args:V}}return{type:0,args:d(f,N)}}static serializeRequest(f,N,V,_,G){switch(_.type){case 0:return this.b(f,N,V,_.args,G);case 1:return this.c(f,N,V,_.args,G)}}static b(f,N,V,_,G){const $=P.VSBuffer.fromString(V),B=P.VSBuffer.fromString(_);let X=0;X+=E.sizeUInt8(),X+=E.sizeShortString($),X+=E.sizeLongString(B);const U=E.alloc(G?2:1,f,X);return U.writeUInt8(N),U.writeShortString($),U.writeLongString(B),U.buffer}static deserializeRequestJSONArgs(f){const N=f.readUInt8(),V=f.readShortString(),_=f.readLongString();return{rpcId:N,method:V,args:JSON.parse(_)}}static c(f,N,V,_,G){const $=P.VSBuffer.fromString(V);let B=0;B+=E.sizeUInt8(),B+=E.sizeShortString($),B+=E.sizeMixedArray(_);const X=E.alloc(G?4:3,f,B);return X.writeUInt8(N),X.writeShortString($),X.writeMixedArray(_),X.buffer}static deserializeRequestMixedArgs(f){const N=f.readUInt8(),V=f.readShortString(),_=f.readMixedArray(),G=new Array(_.length);for(let $=0,B=_.length;$<B;$++){const X=_[$];typeof X=="string"?G[$]=JSON.parse(X):G[$]=X}return{rpcId:N,method:V,args:G}}static serializeAcknowledged(f){return E.alloc(5,f,0).buffer}static serializeCancel(f){return E.alloc(6,f,0).buffer}static serializeReplyOK(f,N,V){if(typeof N>"u")return this.d(f);if(N instanceof P.VSBuffer)return this.e(f,N);if(N instanceof O.SerializableObjectWithBuffers){const{jsonString:_,referencedBuffers:G}=t(N.value,V,!0);return this.g(f,_,G)}else return this.f(f,g(N,V))}static d(f){return E.alloc(7,f,0).buffer}static e(f,N){let V=0;V+=E.sizeVSBuffer(N);const _=E.alloc(8,f,V);return _.writeVSBuffer(N),_.buffer}static deserializeReplyOKVSBuffer(f){return f.readVSBuffer()}static f(f,N){const V=P.VSBuffer.fromString(N);let _=0;_+=E.sizeLongString(V);const G=E.alloc(9,f,_);return G.writeLongString(V),G.buffer}static g(f,N,V){const _=P.VSBuffer.fromString(N);let G=0;G+=E.sizeUInt32,G+=E.sizeLongString(_);for(const B of V)G+=E.sizeVSBuffer(B);const $=E.alloc(10,f,G);$.writeUInt32(V.length),$.writeLongString(_);for(const B of V)$.writeBuffer(B);return $.buffer}static deserializeReplyOKJSON(f){const N=f.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(f,N){const V=f.readUInt32(),_=f.readLongString(),G=[];for(let $=0;$<V;++$)G.push(f.readVSBuffer());return new O.SerializableObjectWithBuffers(o(_,G,N))}static serializeReplyErr(f,N){const V=N?g(L.transformErrorForSerialization(N),null):void 0;if(typeof V!="string")return this.h(f);const _=P.VSBuffer.fromString(V);let G=0;G+=E.sizeLongString(_);const $=E.alloc(11,f,G);return $.writeLongString(_),$.buffer}static deserializeReplyErrError(f){const N=f.readLongString();return JSON.parse(N)}static h(f){return E.alloc(12,f,0).buffer}}var u;(function(b){b[b.RequestJSONArgs=1]="RequestJSONArgs",b[b.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",b[b.RequestMixedArgs=3]="RequestMixedArgs",b[b.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",b[b.Acknowledged=5]="Acknowledged",b[b.Cancel=6]="Cancel",b[b.ReplyOKEmpty=7]="ReplyOKEmpty",b[b.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",b[b.ReplyOKJSON=9]="ReplyOKJSON",b[b.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",b[b.ReplyErrError=11]="ReplyErrError",b[b.ReplyErrEmpty=12]="ReplyErrEmpty"})(u||(u={}));var m;(function(b){b[b.String=1]="String",b[b.VSBuffer=2]="VSBuffer",b[b.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",b[b.Undefined=4]="Undefined"})(m||(m={}))}),define(Pe[254],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const n=function(L){const R=A=>{globalThis.removeEventListener("message",R);const y=A.data;Object.defineProperties(globalThis,{postMessage:{value(h,O){y.postMessage(h,O)}},onmessage:{get(){return y.onmessage},set(h){y.onmessage=h}}}),y.addEventListener("message",h=>{globalThis.dispatchEvent(new MessageEvent("message",{data:h.data,ports:h.ports?[...h.ports]:void 0}))}),y.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};globalThis.addEventListener("message",R)}.toString();class P extends EventTarget{constructor(L,R,A){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${n})('${R}'))`,h=new Blob([y],{type:"application/javascript"}),O=URL.createObjectURL(h),w=new MessageChannel,g=O,S={type:"_newWorker",id:g,port:w.port2,url:O,options:A};L(S,[w.port2]),this.postMessage=w.port1.postMessage.bind(w.port1),this.terminate=()=>{L({type:"_terminateWorker",id:g}),URL.revokeObjectURL(O),w.port1.close(),w.port2.close()},Object.defineProperties(this,{onmessage:{get(){return w.port1.onmessage},set(p){w.port1.onmessage=p}},onmessageerror:{get(){return w.port1.onmessageerror},set(p){w.port1.onmessageerror=p}}}),w.port1.addEventListener("messageerror",p=>{const l=new MessageEvent("messageerror",{data:p.data});this.dispatchEvent(l)}),w.port1.addEventListener("message",p=>{const l=new MessageEvent("message",{data:p.data});this.dispatchEvent(l)}),w.port1.start()}}e.NestedWorker=P}),define(Pe[255],Ae([1,0,5,30,31,3]),function(te,e,n,P,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new I.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new I.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new I.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)("outputService");var R;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(R||(e.OutputChannelUpdateMode=R={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.a=new Map,this.b=new n.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new n.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(h){this.a.has(h.id)||(this.a.set(h.id,h),this.b.fire(h.id))}getChannels(){const h=[];return this.a.forEach(O=>h.push(O)),h}getChannel(h){return this.a.get(h)}removeChannel(h){this.a.delete(h),this.c.fire(h)}}P.Registry.add(e.Extensions.OutputChannels,new A),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new I.RawContextKey("activeOutputChannel","")}),define(Pe[108],Ae([1,0,4,3,18,24,14,255,61,27,37,125,25,12,43,5,6]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class o extends R.AbstractMessageLogger{get disposed(){return this.l}constructor(v,i,a,r,s){super(),this.id=v,this.name=i,this.m=a,this.n=r,this.extension=s,this.k=0,this.l=!1,this.visible=!1,this.setLevel(a.getLevel()),this.B(a.onDidChangeLogLevel(E=>this.setLevel(E)))}get logLevel(){return this.getLevel()}appendLine(v){this.append(v+`
`)}append(v){this.info(v)}clear(){const v=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,v)}replace(v){const i=this.k;this.info(v),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(v,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof v=="boolean"?v:i))}hide(){this.n.$close(this.id)}g(v,i){this.k+=g.VSBuffer.fromString(i).byteLength,(0,R.log)(this.m,v,i),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class d extends o{appendLine(v){this.append(v)}}let D=e.ExtHostOutputService=class{constructor(v,i,a,r,s,E){this.i=i,this.j=a,this.k=r,this.l=s,this.m=E,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=v.getProxy(n.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,w.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(v){this.h=v;for(const[i,a]of this.g)a.visible=i===this.h}createOutputChannel(v,i,a){if(v=v.trim(),!v)throw new Error("illegal argument `name`. must not be falsy");const r=typeof i=="object"&&i.log,s=(0,S.isString)(i)?i:void 0;if((0,S.isString)(s)&&!s.trim())throw new Error("illegal argument `languageId`. must not be empty");let E;const k=this.i.environment.extensionLogLevel?.find(([u])=>L.ExtensionIdentifier.equals(a.identifier,u))?.[1];k&&(E=(0,R.parseLogLevel)(k));const c=r?this.o(v,E,a):this.n(v,s,a);return c.then(u=>{this.g.set(u.id,u),u.visible=u.id===this.h}),r?this.r(v,E??this.m.getLevel(),c):this.q(v,c)}async n(v,i,a){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,s=this.k.extUri.joinPath(r,`${this.f++}-${v.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),E=this.l.createLogger(s,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),k=await this.a.$register(v,s,i,a.identifier.value);return new o(k,v,E,this.a,a)}async o(v,i,a){const r=await this.p(a),s=v.replace(/[\\/:\*\?"<>\|]/g,""),E=this.k.extUri.joinPath(r,`${s}.log`),k=`${a.identifier.value}.${s}`,c=this.l.createLogger(E,{id:k,name:v,logLevel:i,extensionId:a.identifier.value});return new d(k,v,c,this.a,a)}p(v){let i=this.d.get(v.identifier.value);if(!i){const a=this.k.extUri.joinPath(this.i.logsLocation,v.identifier.value);this.d.set(v.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(a)}catch(r){if((0,p.toFileSystemProviderErrorCode)(r)!==p.FileSystemProviderErrorCode.FileExists)throw r}return a})())}return i}q(v,i){let a=!1;const r=()=>{if(a)throw new Error("Channel has been closed")};return{get name(){return v},append(s){r(),i.then(E=>E.append(s))},appendLine(s){r(),i.then(E=>E.appendLine(s))},clear(){r(),i.then(s=>s.clear())},replace(s){r(),i.then(E=>E.replace(s))},show(s,E){r(),i.then(k=>k.show(s,E))},hide(){r(),i.then(s=>s.hide())},dispose(){a=!0,i.then(s=>s.dispose())}}}r(v,i,a){const r=new t.DisposableStore,s=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},E=r.add(new l.Emitter);function k(c){i=c,E.fire(c)}return a.then(c=>{r.add(c),c.logLevel!==i&&k(c.logLevel),r.add(c.onDidChangeLogLevel(u=>k(u)))}),{...this.q(v,a),get logLevel(){return i},onDidChangeLogLevel:E.event,trace(c,...u){s(),a.then(m=>m.trace(c,...u))},debug(c,...u){s(),a.then(m=>m.debug(c,...u))},info(c,...u){s(),a.then(m=>m.info(c,...u))},warn(c,...u){s(),a.then(m=>m.warn(c,...u))},error(c,...u){s(),a.then(m=>m.error(c,...u))},dispose(){r.dispose()}}}};e.ExtHostOutputService=D=xe([qe(0,I.IExtHostRpcService),qe(1,h.IExtHostInitDataService),qe(2,y.IExtHostConsumerFileSystem),qe(3,O.IExtHostFileSystemInfo),qe(4,R.ILoggerService),qe(5,R.ILogService)],D),e.IExtHostOutputService=(0,P.createDecorator)("IExtHostOutputService")}),define(Pe[256],Ae([1,0,3]),function(te,e,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=void 0,e.IRemoteAgentService=(0,n.createDecorator)("remoteAgentService")}),define(Pe[257],Ae([1,0,41,15,19,20,22,2,3,184,53,199,256]),function(te,e,n,P,I,L,R,A,y,h,O,w,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let S=e.AbstractPathService=class kn{constructor(l,t,o,d){this.d=l,this.e=t,this.f=o,this.g=d,this.a=(async()=>(await this.e.getEnvironment())?.os||L.OS)(),this.b=(async()=>{const D=await this.e.getEnvironment();return this.c=D?.userHome??l})()}hasValidBasename(l,t,o){return typeof t=="string"||typeof t>"u"?this.a.then(d=>this.h(l,d,t)):this.h(l,t,o)}h(l,t,o){return l.scheme===P.Schemas.file||l.scheme===P.Schemas.vscodeRemote?(0,n.isValidBasename)(o??(0,R.basename)(l),t===1):!0}get defaultUriScheme(){return kn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(l,t){if(l.remoteAuthority)return P.Schemas.vscodeRemote;const o=(0,h.getVirtualWorkspaceScheme)(t.getWorkspace());if(o)return o;const d=t.getWorkspace().folders[0];if(d)return d.uri.scheme;const D=t.getWorkspace().configuration;return D?D.scheme:P.Schemas.file}userHome(l){return l?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(l=>l===1?I.win32:I.posix)}async fileURI(l){let t="";if(await this.a===1&&(l=l.replace(/\\/g,"/")),l[0]==="/"&&l[1]==="/"){const d=l.indexOf("/",2);d===-1?(t=l.substring(2),l="/"):(t=l.substring(2,d),l=l.substring(d)||"/")}return A.URI.from({scheme:P.Schemas.file,authority:t,path:l,query:"",fragment:""})}};e.AbstractPathService=S=xe([qe(1,g.IRemoteAgentService),qe(2,w.IWorkbenchEnvironmentService),qe(3,O.IWorkspaceContextService)],S)}),define(Pe[109],Ae([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class n{constructor(R,A){this.line=R,this.character=A}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,A){return new n(0,0)}with(R){return new n(0,0)}}e.Position=n;class P{constructor(R,A,y,h){this.isEmpty=!1,this.isSingleLine=!1,this.start=new n(R,A),this.end=new n(y,h)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new P(0,0,0,0)}with(R){return new P(0,0,0,0)}}e.Range=P;var I;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(I||(e.TextSearchCompleteMessageType=I={}))}),define(Pe[47],Ae([1,0,16,36,23,41,13,3,19,9,109,17]),function(te,e,n,P,I,L,R,A,y,h,O,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const g="\u27EA ",S=" characters skipped \u27EB",p=(g.length+S.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var l;(function(he){he[he.file=0]="file",he[he.text=1]="text"})(l||(e.SearchProviderType=l={}));var t;(function(he){he[he.File=1]="File",he[he.Text=2]="Text"})(t||(e.QueryType=t={}));function o(he){return!!he.preview}e.resultIsMatch=o;function d(he){return!!he.resource}e.isFileMatch=d;function D(he){return!!he.message}e.isProgressMessage=D;var T;(function(he){he[he.Normal=0]="Normal",he[he.NewSearchStarted=1]="NewSearchStarted"})(T||(e.SearchCompletionExitCode=T={}));class v{constructor(de){this.resource=de,this.results=[]}}e.FileMatch=v;class i{constructor(de,Re,le,ue){this.ranges=Re,this.webviewIndex=ue;const H=Array.isArray(Re)?Re:[Re];if(le&&le.matchLines===1&&a(H)){de=(0,R.getNLines)(de,le.matchLines);let F="",Q=0,me=0;const Ce=Math.floor(le.charsPerLine/5),De=[];for(const be of H){const ke=Math.max(be.startColumn-Ce,0),oe=be.startColumn+le.charsPerLine;if(ke>me+Ce+p){const ce=g+(ke-me)+S;F+=ce+de.slice(ke,oe),Q+=ke-(me+ce.length)}else F+=de.slice(me,oe);De.push(new s(0,be.startColumn-Q,be.endColumn-Q)),me=oe}this.preview={text:F,matches:Array.isArray(this.ranges)?De:De[0]}}else{const F=Array.isArray(Re)?Re[0].startLineNumber:Re.startLineNumber;this.preview={text:de,matches:(0,n.mapArrayOrNot)(Re,Q=>new r(Q.startLineNumber-F,Q.startColumn,Q.endLineNumber-F,Q.endColumn))}}}}e.TextSearchMatch=i;function a(he){const de=he[0].startLineNumber;for(const Re of he)if(Re.startLineNumber!==de||Re.endLineNumber!==de)return!1;return!0}class r{constructor(de,Re,le,ue){this.startLineNumber=de,this.startColumn=Re,this.endLineNumber=le,this.endColumn=ue}}e.SearchRange=r;class s extends r{constructor(de,Re,le){super(de,Re,de,le)}}e.OneLineRange=s;var E;(function(he){he.List="list",he.Tree="tree"})(E||(e.ViewMode=E={}));var k;(function(he){he.Default="default",he.FileNames="fileNames",he.Type="type",he.Modified="modified",he.CountDescending="countDescending",he.CountAscending="countAscending"})(k||(e.SearchSortOrder=k={}));function c(he,de=!0){const Re=he&&he.files&&he.files.exclude,le=de&&he&&he.search&&he.search.exclude;if(!Re&&!le)return;if(!Re||!le)return Re||le;let ue=Object.create(null);return ue=I.mixin(ue,I.deepClone(Re)),ue=I.mixin(ue,I.deepClone(le),!0),ue}e.getExcludes=c;function u(he,de){return he.excludePattern&&P.match(he.excludePattern,de)?!1:he.includePattern||he.usingSearchPaths?he.includePattern&&P.match(he.includePattern,de)?!0:he.usingSearchPaths?!!he.folderQueries&&he.folderQueries.some(Re=>{const le=Re.folder.fsPath;if(L.isEqualOrParent(de,le)){const ue=y.relative(le,de);return!Re.includePattern||!!P.match(Re.includePattern,ue)}else return!1}):!1:!0}e.pathIncludedInQuery=u;var m;(function(he){he[he.unknownEncoding=1]="unknownEncoding",he[he.regexParseError=2]="regexParseError",he[he.globParseError=3]="globParseError",he[he.invalidLiteral=4]="invalidLiteral",he[he.rgProcessError=5]="rgProcessError",he[he.other=6]="other",he[he.canceled=7]="canceled"})(m||(e.SearchErrorCode=m={}));class b extends Error{constructor(de,Re){super(de),this.code=Re}}e.SearchError=b;function f(he){const de=he.message;if((0,h.isCancellationError)(he))return new b(de,m.canceled);try{const Re=JSON.parse(de);return new b(Re.message,Re.code)}catch{return new b(de,m.other)}}e.deserializeSearchError=f;function N(he){const de={message:he.message,code:he.code};return new Error(JSON.stringify(de))}e.serializeSearchError=N;function V(he){return he.type==="error"?!0:he.type==="success"}e.isSerializedSearchComplete=V;function _(he){return he.type==="success"}e.isSerializedSearchSuccess=_;function G(he){return!!he.path}e.isSerializedFileMatch=G;function $(he,de){const Re=he.searchPath?he.searchPath:he.relativePath;return(0,R.fuzzyContains)(Re,de)}e.isFilePatternMatch=$;class B{constructor(de){this.path=de,this.results=[]}addMatch(de){this.results.push(de)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=B;function X(he,de){const Re={...he||{},...de||{}};return Object.keys(Re).filter(le=>{const ue=Re[le];return typeof ue=="boolean"&&ue})}e.resolvePatternsForProvider=X;class U{constructor(de,Re){this.c=null,this.a={...de.excludePattern||{},...Re.excludePattern||{}},this.b=P.parse(this.a);let le=de.includePattern;Re.includePattern&&(le?le={...le,...Re.includePattern}:le=Re.includePattern),le&&(this.c=P.parse(le))}matchesExcludesSync(de,Re,le){return!!(this.b&&this.b(de,Re,le))}includedInQuerySync(de,Re,le){return!(this.b&&this.b(de,Re,le)||this.c&&!this.c(de,Re,le))}includedInQuery(de,Re,le){const ue=this.b(de,Re,le),H=()=>this.c?!!this.c(de,Re,le):!0;return(0,w.isThenable)(ue)?ue.then(F=>F?!1:H()):H()}hasSiblingExcludeClauses(){return j(this.a)}}e.QueryGlobTester=U;function j(he){for(const de in he)if(typeof he[de]!="boolean")return!0;return!1}function Y(he){if(!he)return;let de;return Re=>(de||(de=(he()||Promise.resolve([])).then(le=>le?Ee(le):{})),de.then(le=>!!le[Re]))}e.hasSiblingPromiseFn=Y;function pe(he){if(!he)return;let de;return Re=>{if(!de){const le=he();de=le?Ee(le):{}}return!!de[Re]}}e.hasSiblingFn=pe;function Ee(he){const de={};for(const Re of he)de[Re]=!0;return de}}),define(Pe[32],Ae([1,0,16,17,21,5,6,48,15,116,22,13,12,2,155,3,14,172,53,37,27,18,8,7,55,47,4]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t,o,d,D,T,v,i,a,r,s,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function k(_,G,$){return new O.ExtUri(B=>b(B,$)).isEqual(_,G)}function c(_,G,$){return k(_.uri,G.uri,$)?0:(0,w.compare)(_.uri.toString(),G.uri.toString())}function u(_,G,$){return _.index!==G.index?_.index<G.index?-1:1:k(_.uri,G.uri,$)?(0,w.compare)(_.name,G.name):(0,w.compare)(_.uri.toString(),G.uri.toString())}function m(_,G,$,B){const X=_.slice(0).sort((j,Y)=>$(j,Y,B)),U=G.slice(0).sort((j,Y)=>$(j,Y,B));return(0,n.delta)(X,U,(j,Y)=>$(j,Y,B))}function b(_,G){const $=G.getCapabilities(_.scheme);return!($&&$&1024)}class f extends d.Workspace{static toExtHostWorkspace(G,$,B,X){if(!G)return{workspace:null,added:[],removed:[]};const{id:U,name:j,folders:Y,configuration:pe,transient:Ee,isUntitled:he}=G,de=[],Re=$;$?Y.forEach((F,Q)=>{const me=S.URI.revive(F.uri),Ce=f.o(B||$,me,X);Ce?(Ce.name=F.name,Ce.index=F.index,de.push(Ce)):de.push({uri:me,name:F.name,index:Q})}):de.push(...Y.map(({uri:F,name:Q,index:me})=>({uri:S.URI.revive(F),name:Q,index:me}))),de.sort((F,Q)=>F.index<Q.index?-1:1);const le=new f(U,j,de,!!Ee,pe?S.URI.revive(pe):null,!!he,F=>b(F,X)),{added:ue,removed:H}=m(Re?Re.workspaceFolders:[],le.workspaceFolders,c,X);return{workspace:le,added:ue,removed:H}}static o(G,$,B){for(let X=0;X<G.folders.length;X++){const U=G.workspaceFolders[X];if(k(U.uri,$,B))return U}}constructor(G,$,B,X,U,j,Y){super(G,B.map(pe=>new d.WorkspaceFolder(pe)),X,U,Y),this.t=$,this.u=j,this.q=[],this.s=A.TernarySearchTree.forUris(Y),B.forEach(pe=>{this.q.push(pe),this.s.set(pe.uri,pe)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(G,$){return $&&this.s.get(G)&&(G=(0,O.dirname)(G)),this.s.findSubstr(G)}resolveWorkspaceFolder(G){return this.s.get(G)}}let N=e.ExtHostWorkspace=class{constructor(G,$,B,X,U){this.c=new L.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new L.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new L.AsyncEmitter,this.h=X,this.s=B,this.t=U,this.j=new h.Counter,this.k=new P.Barrier,this.o=G.getProxy(E.MainContext.MainThreadWorkspace),this.q=G.getProxy(E.MainContext.MainThreadMessageService);const j=$.workspace;this.l=j?new f(j.id,j.name,[],!!j.transient,j.configuration?S.URI.revive(j.configuration):null,!!j.isUntitled,Y=>b(Y,B)):void 0}$initializeWorkspace(G,$){this.v=$,this.$acceptWorkspaceData(G),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?S.URI.from({scheme:y.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(G,$,B,...X){const U=[];if(Array.isArray(X)&&X.forEach(he=>{S.URI.isUri(he.uri)&&!U.some(de=>k(de.uri,he.uri,this.s))&&U.push({uri:he.uri,name:he.name||(0,O.basenameOrAuthority)(he.uri)})}),this.n||[$,B].some(he=>typeof he!="number"||he<0)||B===0&&U.length===0)return!1;const j=this.x?this.x.workspaceFolders:[];if($+B>j.length)return!1;const Y=j.slice(0);Y.splice($,B,...U.map(he=>({uri:he.uri,name:he.name||(0,O.basenameOrAuthority)(he.uri),index:void 0})));for(let he=0;he<Y.length;he++){const de=Y[he];if(Y.some((Re,le)=>le!==he&&k(de.uri,Re.uri,this.s)))return!1}Y.forEach((he,de)=>he.index=de);const{added:pe,removed:Ee}=m(j,Y,u,this.s);if(pe.length===0&&Ee.length===0)return!1;if(this.o){const he=G.displayName||G.name;this.o.$updateWorkspaceFolders(he,$,B,U).then(void 0,de=>{this.n=void 0;const Re={source:{identifier:G.identifier,label:G.displayName||G.name}};this.q.$showMessage(o.Severity.Error,(0,p.localize)(0,null,he,de.toString()),Re,[])})}return this.y(Y),!0}getWorkspaceFolder(G,$){if(this.x)return this.x.getWorkspaceFolder(G,$)}async getWorkspaceFolder2(G,$){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(G,$)}async resolveWorkspaceFolder(G){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(G)}getPath(){if(!this.x)return;const{folders:G}=this.x;if(G.length!==0)return G[0].uri.fsPath}getRelativePath(G,$){let B,X="";if(typeof G=="string"?(B=S.URI.file(G),X=G):typeof G<"u"&&(B=G,X=G.fsPath),!B)return X;const U=this.getWorkspaceFolder(B,!0);if(!U)return X;typeof $>"u"&&this.x&&($=this.x.folders.length>1);let j=(0,O.relativePath)(U.uri,B);return $&&U.name&&(j=`${U.name}/${j}`),j}y(G){this.x&&(this.n=f.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:G,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(G){const{workspace:$,added:B,removed:X}=f.toExtHostWorkspace(G,this.l,this.n,this.s);this.l=$||void 0,this.n=void 0,this.c.fire(Object.freeze({added:B,removed:X}))}findFiles(G,$,B,X,U=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${X.value}, entryPoint: findFiles`);let j;if($===null?j=!1:$&&(typeof $=="string"?j=$:j=$.pattern),U&&U.isCancellationRequested)return Promise.resolve([]);const{includePattern:Y,folder:pe}=V(i.GlobPattern.from(G));return this.o.$startFileSearch((0,g.withUndefinedAsNull)(Y),(0,g.withUndefinedAsNull)(pe),(0,g.withUndefinedAsNull)(j),(0,g.withUndefinedAsNull)(B),U).then(Ee=>Array.isArray(Ee)?Ee.map(he=>S.URI.revive(he)):[])}async findTextInFiles(G,$,B,X,U=I.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${X.value}, entryPoint: findTextInFiles`);const j=this.j.getNext(),Y=typeof $.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:$.previewOptions,{includePattern:pe,folder:Ee}=V(i.GlobPattern.from($.include)),he=typeof $.exclude=="string"?$.exclude:$.exclude?$.exclude.pattern:void 0,de={ignoreSymlinks:typeof $.followSymlinks=="boolean"?!$.followSymlinks:void 0,disregardIgnoreFiles:typeof $.useIgnoreFiles=="boolean"?!$.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof $.useGlobalIgnoreFiles=="boolean"?!$.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof $.useParentIgnoreFiles=="boolean"?!$.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof $.useDefaultExcludes=="boolean"?!$.useDefaultExcludes:!0,fileEncoding:$.encoding,maxResults:$.maxResults,previewOptions:Y,afterContext:$.afterContext,beforeContext:$.beforeContext,includePattern:pe,excludePattern:he},Re=!1;if(this.u[j]=le=>{if(Re)return;const ue=S.URI.revive(le.resource);le.results.forEach(H=>{(0,s.resultIsMatch)(H)?B({uri:ue,preview:{text:H.preview.text,matches:(0,n.mapArrayOrNot)(H.preview.matches,F=>new a.Range(F.startLineNumber,F.startColumn,F.endLineNumber,F.endColumn))},ranges:(0,n.mapArrayOrNot)(H.ranges,F=>new a.Range(F.startLineNumber,F.startColumn,F.endLineNumber,F.endColumn))}):B({uri:ue,text:H.text,lineNumber:H.lineNumber})})},U.isCancellationRequested)return{};try{const le=await this.o.$startTextSearch(G,(0,g.withUndefinedAsNull)(Ee),de,j,U);return delete this.u[j],le||{}}catch(le){throw delete this.u[j],le}}$handleTextSearchResult(G,$){this.u[$]?.(G)}async save(G){const $=await this.o.$save(G,{saveAs:!1});return S.URI.revive($)}async saveAs(G){const $=await this.o.$save(G,{saveAs:!0});return S.URI.revive($)}saveAll(G){return this.o.$saveAll(G)}resolveProxy(G){return this.o.$resolveProxy(G)}get trusted(){return this.v}requestWorkspaceTrust(G){return this.o.$requestWorkspaceTrust(G)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(G,$){if(this.w.has(G))throw new Error(`A provider has already been registered for scheme ${G}`);this.w.set(G,$);const B=this.t.transformOutgoingScheme(G),X=this.z++;return this.o.$registerEditSessionIdentityProvider(X,B),(0,R.toDisposable)(()=>{this.w.delete(G),this.o.$unregisterEditSessionIdentityProvider(X)})}async $getEditSessionIdentifier(G,$){this.h.info("Getting edit session identifier for workspaceFolder",G);const B=await this.resolveWorkspaceFolder(S.URI.revive(G));if(!B){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",B);const X=this.w.get(B.uri.scheme);if(this.h.info(`Provider for scheme ${B.uri.scheme} is defined: `,!!X),!X)return;const U=await X.provideEditSessionIdentity(B,$);if(this.h.info("Provider returned edit session identifier: ",U),!!U)return U}async $provideEditSessionIdentityMatch(G,$,B,X){this.h.info("Getting edit session identifier for workspaceFolder",G);const U=await this.resolveWorkspaceFolder(S.URI.revive(G));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const j=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!j),!j)return;const Y=await j.provideEditSessionIdentityMatch?.($,B,X);if(this.h.info("Provider returned edit session identifier match result: ",Y),!!Y)return Y}getOnWillCreateEditSessionIdentityEvent(G){return($,B,X)=>{const U=function(Y){$.call(B,Y)};return U.extension=G,this.A.event(U,void 0,X)}}async $onWillCreateEditSessionIdentity(G,$,B){const X=await this.resolveWorkspaceFolder(S.URI.revive(G));if(X===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:X},$,async(U,j)=>{const Y=Date.now();await Promise.resolve(U),Date.now()-Y>B&&this.h.warn("SLOW edit session create-participant",j.extension.identifier)}),$.isCancellationRequested}};e.ExtHostWorkspace=N=xe([qe(0,v.IExtHostRpcService),qe(1,T.IExtHostInitDataService),qe(2,D.IExtHostFileSystemInfo),qe(3,t.ILogService),qe(4,r.IURITransformerService)],N),e.IExtHostWorkspace=(0,l.createDecorator)("IExtHostWorkspace");function V(_){let G,$;return _&&(typeof _=="string"?G=_:(G=_.pattern,$=S.URI.revive(_.baseUri))),{includePattern:G,folder:$}}}),define(Pe[33],Ae([1,0,23,5,32,4,7,175,95,12,17,3,18,14,2]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(a,r){if(r){const s=r.split(".");let E=a;for(let k=0;E&&k<s.length;k++)E=E[s[k]];return E}}function t(a){return a instanceof p.URI}function o(a){return a&&a.uri instanceof p.URI&&a.languageId&&typeof a.languageId=="string"}function d(a){return a&&!a.uri&&a.languageId&&typeof a.languageId=="string"}function D(a){return a&&a.uri instanceof p.URI&&(!a.name||typeof a.name=="string")&&(!a.index||typeof a.index=="number")}function T(a){if(t(a))return{resource:a};if(o(a))return{resource:a.uri,overrideIdentifier:a.languageId};if(d(a))return{overrideIdentifier:a.languageId};if(D(a))return{resource:a.uri};if(a===null)return{resource:null}}let v=e.ExtHostConfiguration=class{constructor(r,s,E){this.a=r.getProxy(L.MainContext.MainThreadConfiguration),this.c=s,this.b=E,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new i(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,s){this.getConfigProvider().then(E=>E.$acceptConfigurationChanged(r,s))}};e.ExtHostConfiguration=v=xe([qe(0,g.IExtHostRpcService),qe(1,I.IExtHostWorkspace),qe(2,S.ILogService)],v);class i{constructor(r,s,E,k){this.a=new P.Emitter,this.b=r,this.f=k,this.c=s,this.e=A.Configuration.parse(E),this.d=this.k(E.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,s){const E={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(s,E))}getConfiguration(r,s,E){const k=T(s)||{},c=this.g(r?l(this.e.getValue(void 0,k,this.c.workspace),r):this.e.getValue(void 0,k,this.c.workspace));r&&this.h(r,k,E?.identifier);function u(b){if(b==null)return null;if(typeof b=="boolean")return b?2:5;switch(b){case R.ConfigurationTarget.Global:return 2;case R.ConfigurationTarget.Workspace:return 5;case R.ConfigurationTarget.WorkspaceFolder:return 6}}const m={has(b){return typeof l(c,b)<"u"},get:(b,f)=>{this.h(r?`${r}.${b}`:b,k,E?.identifier);let N=l(c,b);if(typeof N>"u")N=f;else{let V;const _=(G,$)=>{if((0,h.isObject)(G)){let B;const X=()=>{V=V||(0,n.deepClone)(c),B=B||l(V,$)};return new Proxy(G,{get:(U,j)=>{if(typeof j=="string"&&j.toLowerCase()==="tojson")return X(),()=>B;if(V)return B=B||l(V,$),B[j];const Y=U[j];return typeof j=="string"?_(Y,`${$}.${j}`):Y},set:(U,j,Y)=>(X(),B&&(B[j]=Y),!0),deleteProperty:(U,j)=>(X(),B&&delete B[j],!0),defineProperty:(U,j,Y)=>(X(),B&&Object.defineProperty(B,j,Y),!0)})}return Array.isArray(G)?(0,n.deepClone)(G):G};N=_(N,b)}return N},update:(b,f,N,V)=>{b=r?`${r}.${b}`:b;const _=u(N);return f!==void 0?this.b.$updateConfigurationOption(_,b,f,k,V):this.b.$removeConfigurationOption(_,b,k,V)},inspect:b=>{b=r?`${r}.${b}`:b;const f=this.e.inspect(b,k,this.c.workspace);if(f)return{key:b,defaultValue:(0,n.deepClone)(f.policy?.value??f.default?.value),globalValue:(0,n.deepClone)(f.user?.value??f.application?.value),workspaceValue:(0,n.deepClone)(f.workspace?.value),workspaceFolderValue:(0,n.deepClone)(f.workspaceFolder?.value),defaultLanguageValue:(0,n.deepClone)(f.default?.override),globalLanguageValue:(0,n.deepClone)(f.user?.override??f.application?.override),workspaceLanguageValue:(0,n.deepClone)(f.workspace?.override),workspaceFolderLanguageValue:(0,n.deepClone)(f.workspaceFolder?.override),languageIds:(0,n.deepClone)(f.overrideIdentifiers)}}};return typeof c=="object"&&(0,n.mixin)(m,c,!1),Object.freeze(m)}g(r){const s=E=>(0,h.isObject)(E)?new Proxy(E,{get:(k,c)=>s(k[c]),set:(k,c,u)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(k,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(k,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:k=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):E;return s(r)}h(r,s,E){const k=y.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),c=E?`[${E.value}] `:"";if(k===4){typeof s?.resource>"u"&&this.f.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(k===3){s?.resource&&this.f.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,s){const E=new A.ConfigurationChangeEvent(r,s,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(k,c)=>E.affectsConfiguration(k,T(c))})}k(r){return r.reduce((s,E)=>(s.set(E[0],E[1]),s),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,w.createDecorator)("IExtHostConfiguration")});var _e=this&&this.__classPrivateFieldSet||function(te,e,n,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(te,n):I?I.value=n:e.set(te,n),n},Ne=this&&this.__classPrivateFieldGet||function(te,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(te):P?P.value:e.get(te)};define(Pe[110],Ae([1,0,2,17,5,4,7,32,59,33,21,62,18,27,3,15,20,14,78,212,9]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t,o,d,D,T){"use strict";var v;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(G){function $(X){if(X!=null)return X}G.from=$;function B(X){if(X!=null)return X}G.to=B})(i||(i={}));var a;(function(G){function $(X){if(X!=null)return X}G.from=$;function B(X){if(X!=null)return X}G.to=B})(a||(a={}));var r;(function(G){function $(X){if(X!=null)return X}G.from=$;function B(X){if(X!=null)return X}G.to=B})(r||(r={}));var s;(function(G){function $(U){if(U){const j=U;return j&&!!j.process}else return!1}G.is=$;function B(U){if(U==null)return;const j={process:U.process,args:U.args};return U.options&&(j.options=r.from(U.options)),j}G.from=B;function X(U){if(U!=null)return new R.ProcessExecution(U.process,U.args,U.options)}G.to=X})(s||(s={}));var E;(function(G){function $(X){if(X!=null)return X}G.from=$;function B(X){if(X!=null)return X}G.to=B})(E||(E={}));var k;(function(G){function $(U){if(U){const j=U;return j&&(!!j.commandLine||!!j.command)}else return!1}G.is=$;function B(U){if(U==null)return;const j={};return U.commandLine!==void 0?j.commandLine=U.commandLine:(j.command=U.command,j.args=U.args),U.options&&(j.options=E.from(U.options)),j}G.from=B;function X(U){if(!(U==null||U.command===void 0&&U.commandLine===void 0))return U.commandLine?new R.ShellExecution(U.commandLine,U.options):new R.ShellExecution(U.command,U.args?U.args:[],U.options)}G.to=X})(k||(k={}));var c;(function(G){function $(U){if(U){const j=U;return j&&j.customExecution==="customExecution"}else return!1}G.is=$;function B(U){return{customExecution:"customExecution"}}G.from=B;function X(U,j){return j.get(U)}G.to=X})(c||(e.CustomExecutionDTO=c={}));var u;(function(G){function $(B,X){let U;return B.scope!==void 0&&typeof B.scope!="number"?U=B.scope.uri:B.scope!==void 0&&typeof B.scope=="number"&&(B.scope===R.TaskScope.Workspace&&X&&X.workspaceFile?U=X.workspaceFile:U=D.USER_TASKS_GROUP_KEY),{id:B._id,workspaceFolder:U}}G.from=$})(u||(e.TaskHandleDTO=u={}));var m;(function(G){function $(B){if(B!=null)return{_id:B.id,isDefault:B.isDefault}}G.from=$})(m||(m={}));var b;(function(G){function $(U,j){if(U==null)return[];const Y=[];for(const pe of U){const Ee=B(pe,j);Ee&&Y.push(Ee)}return Y}G.fromMany=$;function B(U,j){if(U==null)return;let Y;U.execution instanceof R.ProcessExecution?Y=s.from(U.execution):U.execution instanceof R.ShellExecution?Y=k.from(U.execution):U.execution&&U.execution instanceof R.CustomExecution&&(Y=c.from(U.execution));const pe=i.from(U.definition);let Ee;return U.scope?typeof U.scope=="number"?Ee=U.scope:Ee=U.scope.uri:Ee=R.TaskScope.Workspace,!pe||!Ee?void 0:{_id:U._id,definition:pe,name:U.name,source:{extensionId:j.identifier.value,label:U.source,scope:Ee},execution:Y,isBackground:U.isBackground,group:m.from(U.group),presentationOptions:a.from(U.presentationOptions),problemMatchers:U.problemMatchers,hasDefinedMatchers:U.hasDefinedMatchers,runOptions:U.runOptions?U.runOptions:{reevaluateOnRerun:!0},detail:U.detail}}G.from=B;async function X(U,j,Y){if(U==null)return;let pe;s.is(U.execution)?pe=s.to(U.execution):k.is(U.execution)?pe=k.to(U.execution):c.is(U.execution)&&(pe=c.to(U._id,Y));const Ee=i.to(U.definition);let he;if(U.source&&(U.source.scope!==void 0?typeof U.source.scope=="number"?he=U.source.scope:he=await j.resolveWorkspaceFolder(n.URI.revive(U.source.scope)):he=R.TaskScope.Workspace),!Ee||!he)return;const de=new R.Task(Ee,he,U.name,U.source.label,pe,U.problemMatchers);return U.isBackground!==void 0&&(de.isBackground=U.isBackground),U.group!==void 0&&(de.group=R.TaskGroup.from(U.group._id),de.group&&U.group.isDefault&&(de.group=new R.TaskGroup(de.group.id,de.group.label),U.group.isDefault===!0&&(de.group.isDefault=U.group.isDefault))),U.presentationOptions&&(de.presentationOptions=a.to(U.presentationOptions)),U._id&&(de._id=U._id),U.detail&&(de.detail=U.detail),de}G.to=X})(b||(e.TaskDTO=b={}));var f;(function(G){function $(X){return X}G.from=$;function B(X){if(X)return Object.assign(Object.create(null),X)}G.to=B})(f||(f={}));class N{constructor($,B,X){this._id=B,this.a=X,v.set(this,void 0),_e(this,v,$,"f")}get task(){return this.a}terminate(){Ne(this,v,"f").terminateTask(this)}fireDidStartProcess($){}fireDidEndProcess($){}}v=new WeakMap;let V=e.ExtHostTaskBase=class{constructor($,B,X,U,j,Y,pe,Ee){this.q=new I.Emitter,this.r=new I.Emitter,this.s=new I.Emitter,this.t=new I.Emitter,this.a=$.getProxy(L.MainContext.MainThreadTask),this.b=X,this.c=U,this.d=j,this.e=Y,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=pe,this.g=Ee,this.a.$registerSupportedExecutions(!0)}registerTaskProvider($,B,X){if(!X)return new R.Disposable(()=>{});const U=this.w();return this.j.set(U,{type:B,provider:X,extension:$}),this.a.$registerTaskProvider(U,B),new R.Disposable(()=>{this.j.delete(U),this.a.$unregisterTaskProvider(U)})}registerTaskSystem($,B){this.a.$registerTaskSystem($,B)}fetchTasks($){return this.a.$fetchTasks(f.from($)).then(async B=>{const X=[];for(const U of B){const j=await b.to(U,this.b,this.m);j&&X.push(j)}return X})}get taskExecutions(){const $=[];return this.k.forEach(B=>$.push(B)),$}terminateTask($){if(!($ instanceof N))throw new Error("No valid task execution provided");return this.a.$terminateTask($._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask($,B,X){const U=this.m.get($.id);U&&(this.o.set($.id,U),this.e.attachPtyToTerminal(B,await U.callback(X))),this.p=$.id,this.q.fire({execution:await this.y($)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask($){const B=await this.y($);this.l.delete($.id),this.k.delete($.id),this.A($),this.r.fire({execution:B})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess($){const B=await this.y($.id);this.s.fire({execution:B,processId:$.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess($){const B=await this.y($.id);this.t.fire({execution:B,exitCode:$.exitCode})}$provideTasks($,B){const X=this.j.get($);if(!X)return Promise.reject(new Error("no handler found"));const U=[],j=(0,P.asPromise)(()=>X.provider.provideTasks(O.CancellationToken.None)).then(Y=>this.u(B,U,X,Y));return new Promise(Y=>{j.then(pe=>{Promise.all(U).then(()=>{Y(pe)})})})}async $resolveTask($,B){const X=this.j.get($);if(!X)return Promise.reject(new Error("no handler found"));if(B.definition.type!==X.type)throw new Error(`Unexpected: Task of type [${B.definition.type}] cannot be resolved by provider of type [${X.type}].`);const U=await b.to(B,this.b,this.m);if(!U)throw new Error("Unexpected: Task cannot be resolved.");const j=await X.provider.resolveTask(U,O.CancellationToken.None);if(!j)return;this.z(j,X);const Y=b.from(j,X.extension);if(!Y)throw new Error("Unexpected: Task cannot be resolved.");if(j.definition!==U.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(Y.execution)&&await this.x(Y,j,!0),await this.v(Y)}w(){return this.h++}async x($,B,X){const U=await this.a.$createTaskId($);!X&&!this.m.has(U)&&(this.n.add(U),this.o.set(U,B.execution)),this.m.set(U,B.execution)}async y($,B){if(typeof $=="string"){const j=this.l.get($);if(!j)throw new T.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return j}const X=this.l.get($.id);if(X)return X;const U=new Promise((j,Y)=>{function pe(Ee,he,de){de?j(new N(Ee,he.id,de)):Y("Unexpected: Task does not exist.")}B?pe(this,$,B):b.to($.task,this.b,this.m).then(Ee=>pe(this,$,Ee))});return this.l.set($.id,U),U.then(j=>(this.k.set($.id,j),j),j=>Promise.reject(j))}z($,B){$._deprecated&&this.g.report("Task.constructor",B.extension,"Use the Task constructor that takes a `scope` instead.")}A($){this.o.get($.id)&&this.o.delete($.id),this.n.has($.id)&&this.p!==$.id&&(this.m.delete($.id),this.n.delete($.id));const X=this.n.values();let U=X.next();for(;!U.done;)!this.o.has(U.value)&&this.p!==U.value&&(this.m.delete(U.value),this.n.delete(U.value)),U=X.next()}};e.ExtHostTaskBase=V=xe([qe(0,g.IExtHostRpcService),qe(1,S.IExtHostInitDataService),qe(2,A.IExtHostWorkspace),qe(3,y.IExtHostDocumentsAndEditors),qe(4,h.IExtHostConfiguration),qe(5,w.IExtHostTerminalService),qe(6,o.ILogService),qe(7,d.IExtHostApiDeprecationService)],V);let _=e.WorkerExtHostTask=class extends V{constructor($,B,X,U,j,Y,pe,Ee){super($,B,X,U,j,Y,pe,Ee),this.registerTaskSystem(l.Schemas.vscodeRemote,{scheme:l.Schemas.vscodeRemote,authority:"",platform:t.PlatformToString(0)})}async executeTask($,B){if(!B.execution)throw new Error("Tasks to execute must include an execution");const X=b.from(B,$);if(X===void 0)throw new Error("Task is not valid");if(c.is(X.execution))await this.x(X,B,!1);else throw new T.NotSupportedError;const U=await this.y(await this.a.$getTaskExecution(X),B);return this.a.$executeTask(X).catch(j=>{throw new Error(j)}),U}u($,B,X,U){const j=[];if(U)for(const Y of U){this.z(Y,X),(!Y.definition||!$[Y.definition.type])&&this.f.warn(`The task [${Y.source}, ${Y.name}] uses an undefined task type. The task will be ignored in the future.`);const pe=b.from(Y,X.extension);pe&&c.is(pe.execution)?(j.push(pe),B.push(this.x(pe,Y,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:j,extension:X.extension}}async v($){if(c.is($.execution))return $;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables($,B){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable($,B,X){}};e.WorkerExtHostTask=_=xe([qe(0,g.IExtHostRpcService),qe(1,S.IExtHostInitDataService),qe(2,A.IExtHostWorkspace),qe(3,y.IExtHostDocumentsAndEditors),qe(4,h.IExtHostConfiguration),qe(5,w.IExtHostTerminalService),qe(6,o.ILogService),qe(7,d.IExtHostApiDeprecationService)],_),e.IExtHostTask=(0,p.createDecorator)("IExtHostTask")}),define(Pe[258],Ae([1,0,19,21,40,36,22,58,47]),function(te,e,n,P,I,L,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class h{constructor(g,S,p){this.k=g,this.l=S,this.o=p,this.e=!1,this.f=0,this.g=!1,this.a=g.filePattern,this.b=g.includePattern&&L.parse(g.includePattern),this.c=g.maxResults||void 0,this.d=g.exists,this.h=new Set,this.j=g.excludePattern&&L.parse(g.excludePattern)}cancel(){this.g=!0,this.h.forEach(g=>g.cancel()),this.h=new Set}search(g){const S=this.k.folderQueries||[];return new Promise((p,l)=>{const t=o=>{this.f++,g(o)};if(this.g)return p({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(o=>{const d=o.toString(),D=n.basename(d);this.j&&this.j(d,D)||this.v(t,{base:o,basename:D})}),Promise.all(S.map(o=>this.p(o,t))).then(o=>{p({limitHit:this.e,stats:o[0]||void 0})},o=>{l(new Error((0,I.toErrorMessage)(o)))})})}async p(g,S){const p=new P.CancellationTokenSource,l=this.q(g),t=this.r(),o=new y.QueryGlobTester(this.k,g),d=!o.hasSiblingExcludeClauses();let D;try{this.h.add(p),D=A.StopWatch.create();const T=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},l,p.token),v=D.elapsed(),i=A.StopWatch.create();return this.g&&!this.e||(T&&T.forEach(a=>{const r=n.posix.relative(g.folder.path,a.path);if(d){const s=n.basename(a.path);this.v(S,{base:g.folder,relativePath:r,basename:s});return}this.s(t,g.folder,r,S)}),this.g&&!this.e)?null:(this.u(t,o,S),{providerTime:v,postProcessTime:i.elapsed()})}finally{p.dispose(),this.h.delete(p)}}q(g){const S=(0,y.resolvePatternsForProvider)(this.k.includePattern,g.includePattern),p=(0,y.resolvePatternsForProvider)(this.k.excludePattern,g.excludePattern);return{folder:g.folder,excludes:p,includes:S,useIgnoreFiles:!g.disregardIgnoreFiles,useGlobalIgnoreFiles:!g.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!g.disregardParentIgnoreFiles,followSymlinks:!g.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const g={rootEntries:[],pathToEntries:Object.create(null)};return g.pathToEntries["."]=g.rootEntries,g}s({pathToEntries:g},S,p,l){if(p===this.a){const o=n.basename(this.a);this.v(l,{base:S,relativePath:this.a,basename:o})}function t(o){const d=n.basename(o),D=n.dirname(o);let T=g[D];T||(T=g[D]=[],t(D)),T.push({base:S,relativePath:o,basename:d})}t(p)}u({rootEntries:g,pathToEntries:S},p,l){const t=this,o=this.a;function d(D){const T=(0,y.hasSiblingFn)(()=>D.map(v=>v.basename));for(let v=0,i=D.length;v<i;v++){const a=D[v],{relativePath:r,basename:s}=a;if(p.matchesExcludesSync(r,s,o!==s?T:void 0))continue;const E=S[r];if(E)d(E);else{if(r===o)continue;t.v(l,a)}if(t.e)break}}d(g)}v(g,S){(!this.b||S.relativePath&&this.b(S.relativePath,S.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||g(S))}}class O{constructor(){this.b=new Map}fileSearch(g,S,p,l){const t=this.c(g.cacheKey),o=new h(g,S,t&&t.token);let d=0;const D=T=>{d+=T.length,p(T.map(v=>this.d(v)))};return this.e(o,O.a,D,l).then(T=>({limitHit:T.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:d,detailStats:T.stats}}))}clearCache(g){this.c(g)?.cancel()}c(g){if(g)return this.b.has(g)||this.b.set(g,new P.CancellationTokenSource),this.b.get(g)}d(g){return g.relativePath?{resource:R.joinPath(g.base,g.relativePath)}:{resource:g.base}}e(g,S,p,l){l.onCancellationRequested(()=>{g.cancel()});const t=d=>{d&&(o.push(d),S>0&&o.length>=S&&(p(o),o=[]))};let o=[];return g.search(t).then(d=>(o.length&&p(o),d),d=>(o.length&&p(o),Promise.reject(d)))}}e.FileSearchManager=O,O.a=512}),define(Pe[259],Ae([1,0,16,64,36,89,28,15,19,22,13,12,2,273,164,42,14,53,100,257,47]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t,o,d,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let v=e.QueryBuilder=class{constructor(b,f,N,V,_){this.a=b,this.b=f,this.c=N,this.d=V,this.e=_}text(b,f,N={}){b=this.f(b,N);const V=this.a.getValue(),_=f&&f.some($=>!this.a.getValue({resource:$}).search.useRipgrep);return{...this.h(f?.map(o.toWorkspaceFolder),N),type:2,contentPattern:b,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:V.search.usePCRE2||_||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}f(b,f){const N=this.a.getValue();b.isRegExp&&(b.pattern=b.pattern.replace(/\r?\n/g,"\\n"));const V={...b,wordSeparators:N.editor.wordSeparators};return this.j(b,f)&&(V.isCaseSensitive=!0),this.k(b)&&(V.isMultiline=!0),f.notebookSearchConfig?.includeMarkupInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookMarkdownInput=f.notebookSearchConfig.includeMarkupInput),f.notebookSearchConfig?.includeCodeInput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellInput=f.notebookSearchConfig.includeCodeInput),f.notebookSearchConfig?.includeOutput&&(V.notebookInfo||(V.notebookInfo={}),V.notebookInfo.isInNotebookCellOutput=f.notebookSearchConfig.includeOutput),V}file(b,f={}){return{...this.h(b,f),type:1,filePattern:f.filePattern?f.filePattern.trim():f.filePattern,exists:f.exists,sortByScore:f.sortByScore,cacheKey:f.cacheKey}}g(b,f){return b?(b=Array.isArray(b)?b.map(E):E(b),f?this.parseSearchPaths(b):{pattern:a(...Array.isArray(b)?b:[b])}):{}}h(b=[],f={}){const N=this.g(f.includePattern,f.expandPatterns),V=this.g(f.excludePattern,f.expandPatterns),_=b.length>1,G=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(X=>this.q(X,f,V)):b.map(X=>this.r(X,f,V,_))).filter(X=>!!X),$={_reason:f._reason,folderQueries:G,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:f.extraFileResources,excludePattern:V.pattern,includePattern:N.pattern,onlyOpenEditors:f.onlyOpenEditors,maxResults:f.maxResults};if(f.onlyOpenEditors){const X=n.coalesce(n.flatten(this.c.groups.map(Y=>Y.editors.map(pe=>pe.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(X));const U=X.filter(Y=>(0,T.pathIncludedInQuery)($,Y.fsPath)),j=this.i(U);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(j)),{...$,...j}}const B=f.extraFileResources&&f.extraFileResources.filter(X=>(0,T.pathIncludedInQuery)($,X.fsPath));return $.extraFileResources=B&&B.length?B:void 0,$}i(b){const f=[],N=new R.ResourceMap,V={};let _=!1;return b.forEach(G=>{if(G.scheme===A.Schemas.walkThrough)return;if((0,h.isAbsolutePath)(G)){const B=this.b.getWorkspaceFolder(G)?.uri??G.with({path:y.dirname(G.fsPath)});let X=N.get(B);X||(_=!0,X={folder:B,includePattern:{}},f.push(X),N.set(B,X));const U=y.relative(B.fsPath,G.fsPath);(0,w.assertIsDefined)(X.includePattern)[U.replace(/\\/g,"/")]=!0}else G.fsPath&&(_=!0,V[G.fsPath]=!0)}),{folderQueries:f,includePattern:V,usingSearchPaths:!0,excludePattern:_?void 0:{"**/*":!0}}}j(b,f){if(f.isSmartCase){if(b.isRegExp){if(O.containsUppercaseCharacter(b.pattern,!0))return!0}else if(O.containsUppercaseCharacter(b.pattern))return!0}return!!b.isCaseSensitive}k(b){return b.isMultiline||b.isRegExp&&(0,S.isMultilineRegexSource)(b.pattern)||b.pattern.indexOf(`
`)>=0?!0:!!b.isMultiline}parseSearchPaths(b){const f=j=>y.isAbsolute(j)||/^\.\.?([\/\\]|$)/.test(j),V=(Array.isArray(b)?b:r(b)).map(j=>{const Y=this.e.resolvedUserHome;return Y?(0,L.untildify)(j,Y.scheme===A.Schemas.file?Y.fsPath:Y.path):j}),_=P.groupBy(V,j=>f(j)?"searchPaths":"exprSegments"),G=(_.exprSegments||[]).map(j=>O.rtrim(j,"/")).map(j=>O.rtrim(j,"\\")).map(j=>(j[0]==="."&&(j="*"+j),s(j))),$={},B=this.m(_.searchPaths||[]);B&&B.length&&($.searchPaths=B);const X=n.flatten(G),U=a(...X);return U&&($.pattern=U),$}l(b,f){return f.disregardExcludeSettings?void 0:(0,T.getExcludes)(b,!f.disregardSearchExcludeSettings)}m(b){if(!b||!b.length)return[];const f=b.flatMap(V=>{let{pathPortion:_,globPortion:G}=i(V);return G&&(G=k(G)),this.n(_).flatMap(B=>this.o(B,G))}),N=new Map;return f.forEach(V=>{const _=V.searchPath.toString(),G=N.get(_);G?V.pattern&&(G.pattern=G.pattern||{},G.pattern[V.pattern]=!0):N.set(_,{searchPath:V.searchPath,pattern:V.pattern?a(V.pattern):void 0})}),Array.from(N.values())}n(b){if(y.isAbsolute(b)){const f=this.b.getWorkspace().folders;return f[0]&&f[0].uri.scheme!==A.Schemas.file?[{searchPath:f[0].uri.with({path:b})}]:[{searchPath:g.URI.file(y.normalize(b))}]}if(this.b.getWorkbenchState()===2){const f=this.b.getWorkspace().folders[0].uri;if(b=E(b),b.startsWith("../")||b===".."){const V=y.posix.resolve(f.path,b);return[{searchPath:f.with({path:V})}]}const N=k(b);return[{searchPath:f,pattern:N}]}else{if(b==="./"||b===".\\")return[];{const f=b.replace(/^\.[\/\\]/,""),V=this.b.getWorkspace().folders.map(_=>{const G=f.match(new RegExp(`^${O.escapeRegExpCharacters(_.name)}(?:/(.*)|$)`));return G?{match:G,folder:_}:null}).filter(w.isDefined);if(V.length)return V.map(_=>{const G=_.match[1];return{searchPath:_.folder.uri,pattern:G&&k(G)}});{const _=b.match(/\.[\/\\](.+)[\/\\]?/),G=_?_[1]:b,$=p.localize(0,null,G);throw new Error($)}}}}o(b,f){const N=b.pattern&&f?`${b.pattern}/${f}`:b.pattern||f,V=[{searchPath:b.searchPath,pattern:N}];return N&&!N.endsWith("**")&&V.push({searchPath:b.searchPath,pattern:N+"/**"}),V}q(b,f,N){const V=this.r((0,o.toWorkspaceFolder)(b.searchPath),f,N,!1);return V?{...V,includePattern:b.pattern}:null}r(b,f,N,V){let _;const G=g.URI.isUri(b)?b:b.uri;if(N.searchPaths){const j=N.searchPaths.filter(Y=>(0,h.isEqual)(Y.searchPath,G))[0];if(j&&!j.pattern)return null;j&&(_=j.pattern)}const $=this.a.getValue({resource:G}),X={...this.l($,f)||{},..._||{}},U=g.URI.isUri(b)?(0,h.basename)(b):b.name;return{folder:G,folderName:V?U:void 0,excludePattern:Object.keys(X).length>0?X:void 0,fileEncoding:$.files&&$.files.encoding,disregardIgnoreFiles:typeof f.disregardIgnoreFiles=="boolean"?f.disregardIgnoreFiles:!$.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof f.disregardGlobalIgnoreFiles=="boolean"?f.disregardGlobalIgnoreFiles:!$.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof f.disregardParentIgnoreFiles=="boolean"?f.disregardParentIgnoreFiles:!$.search.useParentIgnoreFiles,ignoreSymlinks:typeof f.ignoreSymlinks=="boolean"?f.ignoreSymlinks:!$.search.followSymlinks}}};e.QueryBuilder=v=xe([qe(0,l.IConfigurationService),qe(1,o.IWorkspaceContextService),qe(2,d.IEditorGroupsService),qe(3,t.ILogService),qe(4,D.IPathService)],v);function i(m){const b=m.match(/[\*\{\}\(\)\[\]\?]/);if(b){const f=b.index,N=m.substr(0,f).match(/[/|\\][^/\\]*$/);if(N){let V=m.substr(0,N.index);return V.match(/[/\\]/)||(V+="/"),{pathPortion:V,globPortion:m.substr((N.index||0)+1)}}}return{pathPortion:m}}function a(...m){return m.length?m.reduce((b,f)=>(b[f]=!0,b),Object.create(null)):void 0}function r(m){return I.splitGlobAware(m,",").map(b=>b.trim()).filter(b=>!!b.length)}function s(m){return[`**/${m}/**`,`**/${m}`].map(f=>f.replace(/\*\*\/\*\*/g,"**"))}function E(m){return m.replace(/\\/g,"/")}function k(m){return E(m).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(m){return m.replace(/([?*[\]])/g,"[$1]")}function u(m,b){m=n.distinct(m,V=>V.toString());const f=[],N=b.getWorkspace();return m&&m.forEach(V=>{let _;if(b.getWorkbenchState()===2)_=(0,h.relativePath)(N.folders[0].uri,V),_&&_!=="."&&(_="./"+_);else{const G=b.getWorkspaceFolder(V);if(G){const $=G.name;if(N.folders.filter(X=>X.name===$).length===1){const X=(0,h.relativePath)(G.uri,V);X===""?_=`./${G.name}`:_=`./${G.name}/${X}`}else _=V.fsPath}}_&&f.push(c(_))}),f}e.resolveResourcesForSearchIncludes=u}),define(Pe[260],Ae([1,0,22,2,21,9,3,259,47,53]),function(te,e,n,P,I,L,R,A,y,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function w(l,t){const o=t.activationEvents;if(!o)return Promise.resolve(void 0);const d=[],D=[];for(const s of o)if(/^workspaceContains:/.test(s)){const E=s.substr(18);E.indexOf("*")>=0||E.indexOf("?")>=0||l.forceUsingSearch?D.push(E):d.push(E)}if(d.length===0&&D.length===0)return Promise.resolve(void 0);let T;const v=new Promise((s,E)=>{T=s}),i=s=>T({activationEvent:s}),a=Promise.all(d.map(s=>g(l,s,i))).then(()=>{}),r=S(l,t.identifier,D,i);return Promise.all([a,r]).then(()=>{T(void 0)}),v}e.checkActivateWorkspaceContainsExtension=w;async function g(l,t,o){for(const d of l.folders)if(await l.exists(n.joinPath(P.URI.revive(d),t))){o(`workspaceContains:${t}`);return}}async function S(l,t,o,d){if(o.length===0)return Promise.resolve(void 0);const D=new I.CancellationTokenSource,T=l.checkExists(l.folders,o,D.token),v=setTimeout(async()=>{D.cancel(),l.logService.info(`Not activating extension '${t.value}': Timed out while searching for 'workspaceContains' pattern ${o.join(",")}`)},O);let i=!1;try{i=await T}catch(a){L.isCancellationError(a)||L.onUnexpectedError(a)}D.dispose(),clearTimeout(v),i&&d(`workspaceContains:${o.join(",")}`)}function p(l,t,o,d){const D=l.get(R.IInstantiationService),T=l.get(y.ISearchService),i=D.createInstance(A.QueryBuilder).file(t.map(a=>(0,h.toWorkspaceFolder)(P.URI.revive(a))),{_reason:"checkExists",includePattern:o,exists:!0});return T.fileSearch(i,d).then(a=>!!a.limitHit,a=>L.isCancellationError(a)?!1:Promise.reject(a))}e.checkGlobFileExists=p});var _e=this&&this.__classPrivateFieldSet||function(te,e,n,P,I){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!I)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!I:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?I.call(te,n):I?I.value=n:e.set(te,n),n},Ne=this&&this.__classPrivateFieldGet||function(te,e,n,P){if(n==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!P:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return n==="m"?P:n==="a"?P.call(te):P?P.value:e.get(te)};define(Pe[34],Ae([1,0,146,19,83,22,17,6,48,2,14,4,33,200,81,32,26,101,9,24,25,186,7,96,3,27,82,18,70,72,62,5,260,80,188,15,79,58,20]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t,o,d,D,T,v,i,a,r,s,E,k,c,u,m,b,f,N,V,_,G,$,B){"use strict";var X,U,j;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let Y=e.AbstractExtHostExtensionService=class Cn extends A.Disposable{constructor(H,F,Q,me,Ce,De,be,ke,oe,ce,ie){super(),this.a=this.B(new b.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.P=!1,this.c=F,this.g=Q,this.f=be,this.j=me,this.k=Ce,this.l=De,this.m=oe,this.p=ce,this.s=ie,this.t=this.g.getProxy(w.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(w.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(w.MainContext.MainThreadExtensionService),this.w=new R.Barrier,this.y=new R.Barrier,this.z=new R.Barrier,this.C=new R.Barrier,this.D=new le(this.f.activationEvents),this.G=new o.ExtensionDescriptionRegistry(this.D,this.f.allExtensions);const ne=new D.ExtensionIdentifierSet(this.f.myExtensions);this.F=new o.ExtensionDescriptionRegistry(this.D,de(this.G,ne)),this.H=new p.ExtHostStorage(this.g,this.l),this.I=new N.ExtHostSecretState(this.g),this.J=ke,this.h=H.createChild(new c.ServiceCollection([p.IExtHostStorage,this.H],[N.IExtHostSecretState,this.I])),this.L=this.B(new S.ExtensionsActivator(this.F,this.G,{onExtensionActivationError:(C,W,q)=>{this.v.$onExtensionActivationError(C,d.transformErrorForSerialization(W),q)},actualActivateExtension:async(C,W)=>{if(o.ExtensionDescriptionRegistry.isHostExtension(C,this.F,this.G))return await this.v.$activateExtension(C,W),new S.HostExtension;const q=this.F.getExtensionDescription(C);return this.Z(q,W)}},this.l)),this.M=null,this.N=Object.create(null),this.O=!1,this.Q=this.f.remote.connectionData}getRemoteConnectionData(){return this.Q}async initialize(){try{await this.pb(),this.w.open(),await this.j.waitForInitializeCall(),I.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.nb()}catch(H){d.onUnexpectedError(H)}}async R(){this.J.onWillDeactivateAll();let H=[];try{H=this.F.getAllExtensionDescriptions().map(Ce=>Ce.identifier).filter(Ce=>this.isActivated(Ce)).map(Ce=>this.Y(Ce))}catch{}await Promise.all(H)}terminate(H,F=0){if(this.P)return;this.P=!0,this.l.info(`Extension host terminating: ${H}`),this.l.flush(),this.p.dispose(),this.L.dispose(),d.setUnexpectedErrorHandler(me=>{this.l.error(me)}),this.g.dispose();const Q=this.R();Promise.race([(0,R.timeout)(5e3),Q]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${F}`):this.l.info(`Extension host exiting with code ${F}`),this.l.flush(),this.l.dispose(),this.c.exit(F)})}isActivated(H){return this.z.isOpen()?this.L.isActivated(H):!1}async getExtension(H){const F=await this.v.$getExtension(H);return F&&{...F,identifier:new D.ExtensionIdentifier(F.identifier.value),extensionLocation:h.URI.revive(F.extensionLocation)}}S(H,F){return this.L.activateByEvent(H,F)}U(H,F){return this.L.activateById(H,F)}activateByIdWithErrors(H,F){return this.U(H,F).then(()=>{const Q=this.L.getActivatedExtension(H);if(Q.activationFailed)return Promise.reject(Q.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(H=>this.F)}getExtensionExports(H){return this.z.isOpen()?this.L.getActivatedExtension(H).exports:null}async W(H){if(H.scheme!==_.Schemas.file)return H;const F=await this.c.realpath(H.fsPath);return h.URI.file(F)}async getExtensionPathIndex(){return this.M||(this.M=this.X(this.F.getAllExtensionDescriptions()).then(H=>new Re(H))),this.M}async X(H){const F=y.TernarySearchTree.forUris(Q=>L.extUriBiasedIgnorePathCase.ignorePathCasing(Q));return await Promise.all(H.map(async Q=>{if(this.qb(Q)){const me=await this.W(Q.extensionLocation);F.set(me,Q)}})),F}Y(H){let F=Promise.resolve(void 0);if(!this.z.isOpen()||!this.L.isActivated(H))return F;const Q=this.L.getActivatedExtension(H);if(!Q)return F;try{typeof Q.module.deactivate=="function"&&(F=Promise.resolve(Q.module.deactivate()).then(void 0,me=>(this.l.error(me),Promise.resolve(void 0))))}catch(me){this.l.error(`An error occurred when deactivating the extension '${H.value}':`),this.l.error(me)}try{(0,A.dispose)(Q.subscriptions)}catch(me){this.l.error(`An error occurred when deactivating the subscriptions for extension '${H.value}':`),this.l.error(me)}return F}async Z(H,F){return this.f.remote.isRemote?this.v.$onWillActivateExtension(H.identifier):await this.v.$onWillActivateExtension(H.identifier),this.bb(H,F).then(Q=>{const me=Q.activationTimes;return this.v.$onDidActivateExtension(H.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,F),this.ab(H,F,"success",me),Q},Q=>{throw this.ab(H,F,"failure"),Q})}ab(H,F,Q,me){const Ce=Ee(H,F);this.u.$publicLog2("extensionActivationTimes",{...Ce,...me||{},outcome:Q})}bb(H,F){const Q=Ee(H,F);this.u.$publicLog2("activatePlugin",Q);const me=this.qb(H);if(!me)return Promise.resolve(new S.EmptyExtension(S.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${H.identifier.value}, startup: ${F.startup}, activationEvent: '${F.activationEvent}'${H.identifier.value!==F.extensionId.value?`, root cause: ${F.extensionId.value}`:""}`),this.l.flush();const Ce=new S.ExtensionActivationTimesBuilder(F.startup);return Promise.all([this.rb(H,(0,L.joinPath)(H.extensionLocation,me),Ce),this.cb(H)]).then(De=>(I.mark(`code/extHost/willActivateExtension/${H.identifier.value}`),Cn.db(this.l,H.identifier,De[0],De[1],Ce))).then(De=>(I.mark(`code/extHost/didActivateExtension/${H.identifier.value}`),De))}cb(H){const F=new v.ExtensionGlobalMemento(H,this.H),Q=new v.ExtensionMemento(H.identifier.value,!1,this.H),me=new V.ExtensionSecrets(H,this.I),Ce=H.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,De=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${H.identifier.value}`),Promise.all([F.whenReady,Q.whenReady,this.J.whenReady]).then(()=>{const be=this;let ke,oe;const ce=(0,t.isProposedApiEnabled)(H,"ipc")?this.f.messagePorts?.get(D.ExtensionIdentifier.toKey(H.identifier)):void 0;return Object.freeze({globalState:F,workspaceState:Q,secrets:me,subscriptions:[],get extensionUri(){return H.extensionLocation},get extensionPath(){return H.extensionLocation.fsPath},asAbsolutePath(ie){return P.join(H.extensionLocation.fsPath,ie)},get storagePath(){return be.J.workspaceValue(H)?.fsPath},get globalStoragePath(){return be.J.globalValue(H).fsPath},get logPath(){return P.join(be.f.logsLocation.fsPath,H.identifier.value)},get logUri(){return h.URI.joinPath(be.f.logsLocation,H.identifier.value)},get storageUri(){return be.J.workspaceValue(H)},get globalStorageUri(){return be.J.globalValue(H)},get extensionMode(){return Ce},get extension(){return ke===void 0&&(ke=new he(be,H.identifier,H,De,!1)),ke},get extensionRuntime(){return(0,t.checkProposedApiEnabled)(H,"extensionRuntime"),be.extensionRuntime},get environmentVariableCollection(){return be.p.getEnvironmentVariableCollection(H)},get messagePassingProtocol(){if(!oe){if(!ce)return;const ie=b.Event.buffer(b.Event.fromDOMEventEmitter(ce,"message",ne=>ne.data));ce.start(),oe={onDidReceiveMessage:ie,postMessage:ce.postMessage.bind(ce)}}return oe}})})}static db(H,F,Q,me,Ce){return Q=Q||{activate:void 0,deactivate:void 0},this.eb(H,F,Q,me,Ce).then(De=>new S.ActivatedExtension(!1,null,Ce.build(),Q,De,me.subscriptions))}static eb(H,F,Q,me,Ce){if(typeof Q.activate=="function")try{Ce.activateCallStart(),H.trace(`ExtensionService#_callActivateOptional ${F.value}`);const De=typeof global=="object"?global:self,be=Q.activate.apply(De,[me]);return Ce.activateCallStop(),Ce.activateResolveStart(),Promise.resolve(be).then(ke=>(Ce.activateResolveStop(),ke))}catch(De){return Promise.reject(De)}else return Promise.resolve(Q)}fb(H,F){this.U(H.identifier,{startup:!1,extensionId:H.identifier,activationEvent:F}).then(void 0,Q=>{this.l.error(Q)})}gb(H,F=0){const me=Date.now();(0,B.setTimeout0)(()=>{for(let Ce=F;Ce<H.length;Ce+=1){const De=H[Ce];for(const be of De.activationEvents??[])if(be==="onStartupFinished")if(Date.now()-me>50){this.gb(H,Ce);break}else this.fb(De,be)}})}hb(){this.v.$setPerformanceMarks(I.getMarks()),this.k.getConfigProvider().then(H=>{const F=H.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),Q=this.F.getAllExtensionDescriptions();if(F)this.gb(Q);else for(const me of Q)if(me.activationEvents)for(const Ce of me.activationEvents)Ce==="onStartupFinished"&&this.fb(me,Ce)})}ib(){const H=this.S("*",!0).then(void 0,De=>{this.l.error(De)});this.B(this.j.onDidChangeWorkspace(De=>this.jb(De.added)));const F=this.j.workspace?this.j.workspace.folders:[],Q=this.jb(F),me=this.lb(),Ce=Promise.all([me,H,Q]).then(()=>{});return Promise.race([Ce,(0,R.timeout)(1e4)]).then(()=>{this.hb()}),Ce}jb(H){return H.length===0?Promise.resolve(void 0):Promise.all(this.F.getAllExtensionDescriptions().map(F=>this.kb(H,F))).then(()=>{})}async kb(H,F){if(this.isActivated(F.identifier))return;const Q=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.l,folders:H.map(De=>De.uri),forceUsingSearch:Q,exists:De=>this.c.exists(De.fsPath),checkExists:(De,be,ke)=>this.t.$checkExists(De,be,ke)},Ce=await(0,f.checkActivateWorkspaceContainsExtension)(me,F);if(Ce)return this.U(F.identifier,{startup:!0,extensionId:F.identifier,activationEvent:Ce.activationEvent}).then(void 0,De=>this.l.error(De))}async lb(){if(this.f.remote.authority)return this.S(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.C.wait();try{return await this.mb()}catch(H){throw console.error(H),H}}async mb(){const{extensionDevelopmentLocationURI:H,extensionTestsLocationURI:F}=this.f.environment;if(!H||!F)throw new Error(n.localize(0,null));const Q=await this.rb(null,F,new S.ExtensionActivationTimesBuilder(!1));if(!Q||typeof Q.run!="function")throw new Error(n.localize(1,null,F.toString()));return new Promise((me,Ce)=>{const De=(oe,ce)=>{oe?Ce(oe):me(typeof ce=="number"&&ce>0?1:0)},be=(0,L.originalFSPath)(F),ke=Q.run(be,De);ke&&ke.then&&ke.then(()=>{me(0)}).catch(oe=>{Ce(oe instanceof Error&&oe.stack?oe.stack:String(oe))})})}nb(){if(this.O)throw new Error("Extension host is already started!");return this.O=!0,this.y.wait().then(()=>this.z.open()).then(()=>Promise.race([this.L.waitForActivatingExtensions(),(0,R.timeout)(1e3)])).then(()=>this.ib()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(H,F){return this.N[H]=F,(0,A.toDisposable)(()=>{delete this.N[H]})}async ob(H){const F=H.indexOf("+");if(F===-1)throw new Error("Not an authority that can be resolved!");const Q=H.substr(0,F);return await this.w.wait(),await this.S(`onResolveRemoteAuthority:${Q}`,!1),{authorityPrefix:Q,resolver:this.N[Q]}}async $resolveAuthority(H,F){const Q=$.StopWatch.create(!1),me=()=>`[resolveAuthority(${(0,a.getRemoteAuthorityPrefix)(H)},${F})][${Q.elapsed()}ms] `,Ce=ce=>this.l.info(`${me()}${ce}`),De=(ce,ie=void 0)=>this.l.error(`${me()}${ce}`,ie);Ce("activating resolver...");const{authorityPrefix:be,resolver:ke}=await this.ob(H);if(!ke)return De("no resolver"),{type:"error",error:{code:a.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${be}.`,detail:void 0}};const oe=new R.IntervalTimer;try{Ce("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(ke)),oe.cancelAndSet(()=>Ce("waiting..."),1e3),Ce("invoking resolve()..."),I.mark(`code/extHost/willResolveAuthority/${be}`);const ce=await ke.resolve(H,{resolveAttempt:F});I.mark(`code/extHost/didResolveAuthorityOK/${be}`),oe.dispose(),Ce(`returned ${ce.host}:${ce.port}`);const ie={authority:H,host:ce.host,port:ce.port,connectionToken:ce.connectionToken},ne={extensionHostEnv:ce.extensionHostEnv,isTrusted:ce.isTrusted,authenticationSession:ce.authenticationSessionForInitializingExtensions?{id:ce.authenticationSessionForInitializingExtensions.id,providerId:ce.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ie,options:ne,tunnelInformation:{environmentTunnels:ce.environmentTunnels,features:ce.tunnelFeatures}}}}catch(ce){if(I.mark(`code/extHost/didResolveAuthorityError/${be}`),oe.dispose(),De("returned an error",ce),ce instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ce._code,message:ce._message,detail:ce._detail}};throw ce}}async $getCanonicalURI(H,F){this.l.info(`$getCanonicalURI invoked for authority (${(0,a.getRemoteAuthorityPrefix)(H)})`);const{resolver:Q}=await this.ob(H);if(!Q)return null;const me=h.URI.revive(F);if(typeof Q.getCanonicalURI>"u")return me;const Ce=await(0,R.asPromise)(()=>Q.getCanonicalURI(me));return Ce||me}$startExtensionHost(H){H.toAdd.forEach(me=>me.extensionLocation=h.URI.revive(me.extensionLocation));const{globalRegistry:F,myExtensions:Q}=pe(this.D,this.G,this.F,H);return this.G.set(F.getAllExtensionDescriptions()),this.F.set(Q),this.nb()}$activateByEvent(H,F){return F===1?this.S(H,!1):this.z.wait().then(Q=>this.S(H,!1))}async $activate(H,F){return await this.z.wait(),this.F.getExtensionDescription(H)?(await this.U(H,F),!0):!1}async $deltaExtensions(H){H.toAdd.forEach(De=>De.extensionLocation=h.URI.revive(De.extensionLocation));const{globalRegistry:F,myExtensions:Q}=pe(this.D,this.G,this.F,H),me=await this.X(Q);return(await this.getExtensionPathIndex()).setSearchTree(me),this.G.set(F.getAllExtensionDescriptions()),this.F.set(Q),Promise.resolve(void 0)}async $test_latency(H){return H}async $test_up(H){return H.byteLength}async $test_down(H){const F=T.VSBuffer.alloc(H),Q=Math.random()%256;for(let me=0;me<H;me++)F.writeUInt8(Q,me);return F}async $updateRemoteConnectionData(H){this.Q=H,this.a.fire()}};e.AbstractExtHostExtensionService=Y=xe([qe(0,r.IInstantiationService),qe(1,e.IHostUtils),qe(2,k.IExtHostRpcService),qe(3,l.IExtHostWorkspace),qe(4,g.IExtHostConfiguration),qe(5,O.ILogService),qe(6,s.IExtHostInitDataService),qe(7,E.IExtensionStoragePaths),qe(8,u.IExtHostTunnelService),qe(9,m.IExtHostTerminalService),qe(10,G.IExtHostLocalizationService)],Y);function pe(ue,H,F,Q){ue.addActivationEvents(Q.addActivationEvents);const me=new o.ExtensionDescriptionRegistry(ue,H.getAllExtensionDescriptions());me.deltaExtensions(Q.toAdd,Q.toRemove);const Ce=new D.ExtensionIdentifierSet(F.getAllExtensionDescriptions().map(be=>be.identifier));for(const be of Q.myToRemove)Ce.delete(be);for(const be of Q.myToAdd)Ce.add(be);const De=de(me,Ce);return{globalRegistry:me,myExtensions:De}}function Ee(ue,H){return{id:ue.identifier.value,name:ue.name,extensionVersion:ue.version,publisherDisplayName:ue.publisher,activationEvents:ue.activationEvents?ue.activationEvents.join(","):null,isBuiltin:ue.isBuiltin,reason:H.activationEvent,reasonId:H.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class he{constructor(H,F,Q,me,Ce){X.set(this,void 0),U.set(this,void 0),j.set(this,void 0),_e(this,X,H,"f"),_e(this,U,F,"f"),_e(this,j,Q.identifier,"f"),this.id=Q.identifier.value,this.extensionUri=Q.extensionLocation,this.extensionPath=P.normalize((0,L.originalFSPath)(Q.extensionLocation)),this.packageJSON=Q,this.extensionKind=me,this.isFromDifferentExtensionHost=Ce}get isActive(){return Ne(this,X,"f").isActivated(Ne(this,j,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ne(this,X,"f").getExtensionExports(Ne(this,j,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ne(this,X,"f").activateByIdWithErrors(Ne(this,j,"f"),{startup:!1,extensionId:Ne(this,U,"f"),activationEvent:"api"}),this.exports}}e.Extension=he,X=new WeakMap,U=new WeakMap,j=new WeakMap;function de(ue,H){return ue.getAllExtensionDescriptions().filter(F=>H.has(F.identifier))}class Re{constructor(H){this.a=H}setSearchTree(H){this.a=H}findSubstr(H){return this.a.findSubstr(H)}forEach(H){return this.a.forEach(H)}}e.ExtensionPaths=Re;class le{constructor(H){this.a=new D.ExtensionIdentifierMap,this.addActivationEvents(H)}readActivationEvents(H){return this.a.get(H.identifier)}addActivationEvents(H){for(const F of Object.keys(H))this.a.set(F,H[F])}}}),define(Pe[261],Ae([1,0,83,2,4,33,26,24,18,27,3,34,51,14,13]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let l=e.RequireInterceptor=class{constructor(v,i,a,r,s,E,k){this.c=v,this.d=i,this.e=a,this.f=r,this.g=s,this.h=E,this.i=k,this.a=new Map,this.b=[]}async install(){this.j(),n.mark("code/extHost/willWaitForConfig");const v=await this.f.getConfigProvider();n.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new o(this.c,i,this.d,v,this.i)),this.register(this.e.createInstance(d,i)),this.register(this.e.createInstance(t)),this.h.remote.isRemote&&this.register(this.e.createInstance(D,i,this.h.environment.appUriScheme))}register(v){if("nodeModuleName"in v)if(Array.isArray(v.nodeModuleName))for(const i of v.nodeModuleName)this.a.set(i,v);else this.a.set(v.nodeModuleName,v);typeof v.alternativeModuleName=="function"&&this.b.push(i=>v.alternativeModuleName(i))}};e.RequireInterceptor=l=xe([qe(2,O.IInstantiationService),qe(3,L.IExtHostConfiguration),qe(4,w.IExtHostExtensionService),qe(5,h.IExtHostInitDataService),qe(6,S.ILogService)],l);let t=class cn{constructor(v){if(v.environment.appRoot&&cn.a.size){const i=(0,p.escapeRegExpCharacters)(this.c(v.environment.appRoot.fsPath)),a="[a-z0-9_.-]",r=`@${a}+\\/${a}+|${a}+`,s="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${s}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(v){if(!this.b)return;const i=this.b.exec(this.c(v));if(!i)return;const[,a,r,s]=i,E=cn.a.get(r);if(E!==void 0)return console.warn(`${r} as been renamed to ${E}, please update your imports`),a+E+s}c(v){return v.replace(/\\/g,"/")}};t.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),t=xe([qe(0,h.IExtHostInitDataService)],t);class o{constructor(v,i,a,r,s){this.c=v,this.d=i,this.e=a,this.f=r,this.g=s,this.nodeModuleName="vscode",this.a=new A.ExtensionIdentifierMap}load(v,i){const a=this.d.findSubstr(i);if(a){let r=this.a.get(a.identifier);return r||(r=this.c(a,this.e,this.f),this.a.set(a.identifier,r)),r}if(!this.b){let r="";this.d.forEach((s,E)=>r+=`	${E} -> ${s.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${r}`),this.b=this.c(R.nullExtensionDescription,this.e,this.f)}return this.b}}let d=class{constructor(v,i,a){this.d=v,this.nodeModuleName="keytar",this.a=i.getProxy(I.MainContext.MainThreadTelemetry);const{environment:r}=a,s=i.getProxy(I.MainContext.MainThreadKeytar);if(r.appRoot){let E=r.appRoot.fsPath;g.platform==="win32"&&(E=E.replace(/\\/g,"/")),E[E.length-1]==="/"&&(E=E.substr(0,E.length-1)),this.b=new Set,this.b.add(`${E}/node_modules.asar/keytar`),this.b.add(`${E}/node_modules/keytar`)}this.c={getPassword:(E,k)=>s.$getPassword(E,k),setPassword:(E,k,c)=>s.$setPassword(E,k,c),deletePassword:(E,k)=>s.$deletePassword(E,k),findPassword:E=>s.$findPassword(E),findCredentials(E){return s.$findCredentials(E)}}}load(v,i){const a=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:a?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(v){const i=v.length;if(i<=7||!this.b)return;const a=i-7;if((v.charAt(a)==="/"||v.charAt(a)==="\\")&&v.endsWith("keytar")&&(v=v.replace(/\\/g,"/"),this.b.has(v)))return"keytar"}};d=xe([qe(1,y.IExtHostRpcService),qe(2,h.IExtHostInitDataService)],d);let D=class{constructor(v,i,a){this.e=v,this.f=i,this.nodeModuleName=["open","opn"],this.d=a.getProxy(I.MainContext.MainThreadTelemetry);const r=a.getProxy(I.MainContext.MainThreadWindow);this.c=(s,E)=>{const k=P.URI.parse(s);return E?this.g(s,E):k.scheme==="http"||k.scheme==="https"?r.$openUri(k,s,{allowTunneling:!0}):k.scheme==="mailto"||k.scheme===this.f?r.$openUri(k,s,{}):this.g(s,E)}}load(v,i,a){const r=this.e.findSubstr(i);return r&&(this.a=r.identifier.value,this.h()),this.b=a(v),this.c}g(v,i){return this.i(),this.b(v,i)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};D=xe([qe(2,y.IExtHostRpcService)],D)}),define(Pe[111],Ae([1,0,87,6,19,51,3,59,60,34,7,32,197,33]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,R.createDecorator)("IExtHostVariableResolverProvider");class p extends g.AbstractVariableResolverService{constructor(o,d,D,T,v,i,a){function r(){if(D){const s=D.activeEditor();if(s)return s.document.uri;const E=T.tabGroups.all.find(k=>k.isActive)?.activeTab;if(E!==void 0){if(E.input instanceof O.TextDiffTabInput||E.input instanceof O.NotebookDiffEditorTabInput)return E.input.modified;if(E.input instanceof O.TextTabInput||E.input instanceof O.NotebookEditorTabInput||E.input instanceof O.CustomEditorTabInput)return E.input.uri}}}super({getFolderUri:s=>{const E=i.folders.filter(k=>k.name===s);if(E&&E.length>0)return E[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(s,E)=>v.getConfiguration(void 0,s).get(E),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const s=r();if(s)return I.normalize(s.fsPath)},getWorkspaceFolderPathForFile:()=>{if(d){const s=r();if(s){const E=d.getWorkspaceFolder(s);if(E)return I.normalize(E.uri.fsPath)}}},getSelectedText:()=>{if(D){const s=D.activeEditor();if(s&&!s.selection.isEmpty)return s.document.getText(s.selection)}},getLineNumber:()=>{if(D){const s=D.activeEditor();if(s)return String(s.selection.end.line+1)}},getExtension:s=>o.getExtension(s)},void 0,a?Promise.resolve(a):void 0,Promise.resolve(L.env))}}let l=e.ExtHostVariableResolverProviderService=class extends P.Disposable{constructor(o,d,D,T,v){super(),this.b=o,this.c=d,this.g=D,this.h=T,this.i=v,this.a=new n.Lazy(async()=>{const i=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async s=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new p(this.b,this.c,this.g,this.i,i,r,this.j())})}getResolver(){return this.a.value}j(){}};e.ExtHostVariableResolverProviderService=l=xe([qe(0,h.IExtHostExtensionService),qe(1,w.IExtHostWorkspace),qe(2,A.IExtHostDocumentsAndEditors),qe(3,S.IExtHostConfiguration),qe(4,y.IExtHostEditorTabs)],l)}),define(Pe[112],Ae([1,0,17,5,12,2,3,4,60,34,18,7,32,191,193,33,111]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,R.createDecorator)("IExtHostDebugService");let o=e.ExtHostDebugServiceBase=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,s,E,k,c,u){this.F=s,this.G=E,this.H=k,this.I=c,this.J=u,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.C=new Map,this.D=new Map,this.m=new P.Emitter,this.n=new P.Emitter,this.o=new P.Emitter,this.u=new P.Emitter,this.k=r.getProxy(A.MainContext.MainThreadDebugService),this.z=new P.Emitter({onWillAddFirstListener:()=>{this.V()}}),this.B=new P.Emitter,this.v=new D(this.k),this.w=new Map,this.y=!1,this.G.getExtensionRegistry().then(m=>{m.onDidChange(b=>{this.K(m)}),this.K(m)})}asDebugSourceUri(r,s){const E=r;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let k=`debug:${encodeURIComponent(E.path||"")}`,c="?";return s&&(k+=`${c}session=${encodeURIComponent(s.id)}`,c="&"),k+=`${c}ref=${E.sourceReference}`,L.URI.parse(k)}else{if(E.path)return L.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}K(r){const s=[];for(const E of r.getAllExtensionDescriptions())if(E.contributes){const k=E.contributes.debuggers;if(k&&k.length>0)for(const c of k)(0,p.isDebuggerMainContribution)(c)&&s.push(c.type)}this.k.$registerDebugTypes(s)}get stackFrameFocus(){return this.A}get onDidChangeStackFrameFocus(){return this.B.event}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.V();const r=[];return this.w.forEach(s=>r.push(s)),r}addBreakpoints(r){this.V();const s=r.filter(c=>{const u=c.id;return this.w.has(u)?!1:(this.w.set(u,c),!0)});this.W(s,[],[]);const E=[],k=new Map;for(const c of s)if(c instanceof w.SourceBreakpoint){let u=k.get(c.location.uri.toString());u||(u={type:"sourceMulti",uri:c.location.uri,lines:[]},k.set(c.location.uri.toString(),u),E.push(u)),u.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof w.FunctionBreakpoint&&E.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this.k.$registerBreakpoints(E)}removeBreakpoints(r){this.V();const s=r.filter(u=>this.w.delete(u.id));this.W([],s,[]);const E=s.filter(u=>u instanceof w.SourceBreakpoint).map(u=>u.id),k=s.filter(u=>u instanceof w.FunctionBreakpoint).map(u=>u.id),c=s.filter(u=>u instanceof w.DataBreakpoint).map(u=>u.id);return this.k.$unregisterBreakpoints(E,k,c)}startDebugging(r,s,E){return this.k.$startDebugging(r?r.uri:void 0,s,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===w.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,suppressSaveBeforeStart:E.suppressSaveBeforeStart,suppressDebugStatusbar:E.suppressDebugStatusbar??E.debugUI?.simple,suppressDebugToolbar:E.suppressDebugToolbar??E.debugUI?.simple,suppressDebugView:E.suppressDebugView??E.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,s,E){if(!s)return new w.Disposable(()=>{});const k=this.d++;return this.f.push({type:r,handle:k,provider:s}),this.k.$registerDebugConfigurationProvider(r,E,!!s.provideDebugConfigurations,!!s.resolveDebugConfiguration,!!s.resolveDebugConfigurationWithSubstitutedVariables,k),new w.Disposable(()=>{this.f=this.f.filter(c=>c.provider!==s),this.k.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(r,s,E){if(!E)return new w.Disposable(()=>{});if(!this.R(r,s))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${s}' debugger.`);if(this.O(s))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:s,handle:k,factory:E}),this.k.$registerDebugAdapterDescriptorFactory(s,k),new w.Disposable(()=>{this.h=this.h.filter(c=>c.factory!==E),this.k.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(r,s){if(!s)return new w.Disposable(()=>{});const E=this.i++;return this.j.push({type:r,handle:E,factory:s}),new w.Disposable(()=>{this.j=this.j.filter(k=>k.factory!==s)})}async $runInTerminal(r,s){return Promise.resolve(void 0)}async $substituteVariables(r,s){let E;const k=await this.Y(r);return k&&(E={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.J.getResolver()).resolveAnyAsync(E,s)}L(r,s){if(r.type==="implementation")return new v(r.implementation)}M(){}async $startDASession(r,s){const E=this,k=await this.X(s);return this.T(this.O(k.type),k).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const u=this.N(c),m=this.L(u,k);if(!m)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const b=m;return this.C.set(r,b),this.S(k).then(f=>(f&&this.D.set(r,f),b.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const V=N,_={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this.E||(this.E=this.M());try{if(this.E){const G=await this.E.sign(V.arguments.value);_.body={signature:G},b.sendResponse(_)}else throw new Error("no signer")}catch(G){_.success=!1,_.message=G.message,b.sendResponse(_)}}else f&&f.onDidSendMessage&&f.onDidSendMessage(N),N=(0,p.convertToVSCPaths)(N,!0),E.k.$acceptDAMessage(r,N)}),b.onError(N=>{f&&f.onError&&f.onError(N),this.k.$acceptDAError(r,N.name,N.message,N.stack)}),b.onExit(N=>{f&&f.onExit&&f.onExit((0,I.withNullAsUndefined)(N),void 0),this.k.$acceptDAExit(r,(0,I.withNullAsUndefined)(N),void 0)}),f&&f.onWillStartSession&&f.onWillStartSession(),b.startSession()))})}$sendDAMessage(r,s){s=(0,p.convertToDAPaths)(s,!1);const E=this.D.get(r);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(s),this.C.get(r)?.sendMessage(s)}$stopDASession(r){const s=this.D.get(r);this.D.delete(r),s&&s.onWillStopSession&&s.onWillStopSession();const E=this.C.get(r);return this.C.delete(r),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const s=[],E=[],k=[];if(r.added)for(const c of r.added){const u=c.id;if(u&&!this.w.has(u)){let m;if(c.type==="function")m=new w.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")m=new w.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const b=L.URI.revive(c.uri);m=new w.SourceBreakpoint(new w.Location(b,new w.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}(0,w.setBreakpointId)(m,u),this.w.set(u,m),s.push(m)}}if(r.removed)for(const c of r.removed){const u=this.w.get(c);u&&(this.w.delete(c),E.push(u))}if(r.changed){for(const c of r.changed)if(c.id){const u=this.w.get(c.id);if(u){if(u instanceof w.FunctionBreakpoint&&c.type==="function"){const m=u;m.enabled=c.enabled,m.condition=c.condition,m.hitCondition=c.hitCondition,m.logMessage=c.logMessage,m.functionName=c.functionName}else if(u instanceof w.SourceBreakpoint&&c.type==="source"){const m=u;m.enabled=c.enabled,m.condition=c.condition,m.hitCondition=c.hitCondition,m.logMessage=c.logMessage,m.location=new w.Location(L.URI.revive(c.uri),new w.Position(c.line,c.character))}k.push(u)}}}this.W(s,E,k)}async $acceptStackFrameFocus(r){let s;const E=r.sessionId?await this.X(r.sessionId):void 0;if(!E)throw new Error("no DebugSession found for debug focus context");r.kind==="thread"?s={kind:r.kind,threadId:r.threadId,session:E}:s={kind:r.kind,threadId:r.threadId,frameId:r.frameId,session:E},this.A=s,this.B.fire(s)}$provideDebugConfigurations(r,s,E){return(0,n.asPromise)(async()=>{const k=this.Q(r);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.Y(s);return k.provideDebugConfigurations(c,E)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(r,s,E,k){return(0,n.asPromise)(async()=>{const c=this.Q(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const u=await this.Y(s);return c.resolveDebugConfiguration(u,E,k)})}$resolveDebugConfigurationWithSubstitutedVariables(r,s,E,k){return(0,n.asPromise)(async()=>{const c=this.Q(r);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const u=await this.Y(s);return c.resolveDebugConfigurationWithSubstitutedVariables(u,E,k)})}async $provideDebugAdapter(r,s){const E=this.P(r);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.X(s);return this.T(E,k).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.N(c)})}async $acceptDebugSessionStarted(r){const s=await this.X(r);this.m.fire(s)}async $acceptDebugSessionTerminated(r){const s=await this.X(r);s&&(this.n.fire(s),this.l.delete(s.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.X(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,s){(await this.X(r))?._acceptNameChanged(s)}async $acceptDebugSessionCustomEvent(r,s){const k={session:await this.X(r),event:s.event,body:s.body};this.u.fire(k)}N(r){if(r instanceof w.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof w.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof w.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof w.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}O(r){const s=this.h.filter(E=>E.type===r);if(s.length>0)return s[0].factory}P(r){const s=this.h.filter(E=>E.handle===r);if(s.length>0)return s[0].factory}Q(r){const s=this.f.filter(E=>E.handle===r);if(s.length>0)return s[0].provider}R(r,s){if(r.contributes){const E=r.contributes.debuggers;if(E&&E.length>0){for(const k of E)if(k.label&&k.type&&k.type===s)return!0}}return!1}S(r){const E=r.configuration.type,k=this.j.filter(c=>c.type===E||c.type==="*").map(c=>(0,n.asPromise)(()=>c.factory.createDebugAdapterTracker(r)).then(u=>u,u=>null));return Promise.race([Promise.all(k).then(c=>{const u=c.filter(m=>!!m);if(u.length>0)return new T(u)}),new Promise(c=>setTimeout(()=>c(void 0),1e3))]).catch(c=>{})}async T(r,s){const E=s.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new w.DebugAdapterServer(E));if(r){const c=await this.G.getExtensionRegistry();return(0,n.asPromise)(()=>r.createDebugAdapterDescriptor(s,this.U(s,c))).then(u=>{if(u)return u})}const k=await this.G.getExtensionRegistry();return Promise.resolve(this.U(s,k))}U(r,s){}V(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}W(r,s,E){(r.length>0||s.length>0||E.length>0)&&this.z.fire(Object.freeze({added:r,removed:s,changed:E}))}async X(r){if(r)if(typeof r=="string"){const s=this.l.get(r);if(s)return s}else{let s=this.l.get(r.id);if(!s){const E=await this.Y(r.folderUri),k=r.parent?this.l.get(r.parent):void 0;s=new d(this.k,r.id,r.type,r.name,E,r.configuration,k),this.l.set(s.id,s),this.k.$sessionCached(s.id)}return s}throw new Error("cannot find session")}Y(r){if(r){const s=L.URI.revive(r);return this.F.resolveWorkspaceFolder(s)}return Promise.resolve(void 0)}};e.ExtHostDebugServiceBase=o=xe([qe(0,O.IExtHostRpcService),qe(1,g.IExtHostWorkspace),qe(2,h.IExtHostExtensionService),qe(3,l.IExtHostConfiguration),qe(4,y.IExtHostEditorTabs),qe(5,t.IExtHostVariableResolverProvider)],o);class d{constructor(r,s,E,k,c,u,m){this.d=r,this.f=s,this.g=E,this.h=k,this.i=c,this.j=u,this.k=m}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,s){return this.d.$customDebugAdapterRequest(this.f,r,s)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=d;class D{constructor(r){this.value=Object.freeze({append(s){r.$appendDebugConsole(s)},appendLine(s){this.append(s+`
`)}})}}e.ExtHostDebugConsole=D;class T{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(s=>s.onWillReceiveMessage?s.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(s=>s.onDidSendMessage?s.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(s=>s.onError?s.onError(r):void 0)}onExit(r,s){this.d.forEach(E=>E.onExit?E.onExit(r,s):void 0)}}class v extends S.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(s=>{this.acceptMessage(s)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=e.WorkerExtHostDebugService=class extends o{constructor(r,s,E,k,c,u){super(r,s,E,k,c,u)}};e.WorkerExtHostDebugService=i=xe([qe(0,O.IExtHostRpcService),qe(1,g.IExtHostWorkspace),qe(2,h.IExtHostExtensionService),qe(3,l.IExtHostConfiguration),qe(4,y.IExtHostEditorTabs),qe(5,t.IExtHostVariableResolverProvider)],i)}),define(Pe[262],Ae([1,0,9,83,2,4,253,14,69,70,27,169,18,55,34,57]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class t{static async installEarlyHandler(D){const T=D.get(A.ILogService),i=D.get(g.IExtHostRpcService).getProxy(L.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(a=>{T.error(a);const r=n.transformErrorForSerialization(a);i.$onUnexpectedError(r)})}static async installFullHandler(D){const T=D.get(A.ILogService),v=D.get(g.IExtHostRpcService),i=D.get(p.IExtHostExtensionService),a=D.get(l.IExtHostTelemetry),r=v.getProxy(L.MainContext.MainThreadExtensionService),s=v.getProxy(L.MainContext.MainThreadErrors),E=await i.getExtensionPathIndex(),k=new WeakMap;function c(m,b){let f="",N,V;for(const _ of b)f+=`
	at ${_.toString()}`,V=_.getFileName(),!N&&V&&(N=E.findSubstr(I.URI.file(V)));return k.set(m,N?.identifier),`${m.name||"Error"}: ${m.message||""}${f}`}let u=c;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return u},set(m){u=function(b,f){return c(b,f),m.call(Error,b,f)}}}),n.setUnexpectedErrorHandler(m=>{T.error(m);const b=n.transformErrorForSerialization(m),f=k.get(m);if(!f){s.$onUnexpectedError(b);return}r.$onExtensionRuntimeError(f,b);const N=a.onExtensionError(f,m);T.trace("forwarded error to extension?",N,f)})}}Error.stackTraceLimit=100;class o{constructor(D,T,v,i,a){this.a=v,this.b=new R.RPCProtocol(D,null,i),T=o.e(T,this.b);const r=new h.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());r.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...T,messagePorts:a}),r.set(g.IExtHostRpcService,new g.ExtHostRpcService(this.b)),r.set(S.IURITransformerService,new S.URITransformerService(i)),r.set(p.IHostUtils,v);const s=new w.InstantiationService(r,!0);s.invokeFunction(t.installEarlyHandler),this.d=s.invokeFunction(E=>E.get(A.ILogService)),P.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",T),this.c=s.invokeFunction(E=>E.get(p.IExtHostExtensionService)),this.c.initialize(),s.invokeFunction(t.installFullHandler)}async asBrowserUri(D){const T=this.b.getProxy(L.MainContext.MainThreadExtensionService);return I.URI.revive(await T.$asBrowserUri(D))}terminate(D){this.c.terminate(D)}static e(D,T){D.allExtensions.forEach(i=>{i.extensionLocation=I.URI.revive(T.transformIncomingURIs(i.extensionLocation))}),D.environment.appRoot=I.URI.revive(T.transformIncomingURIs(D.environment.appRoot));const v=D.environment.extensionDevelopmentLocationURI;return v&&(D.environment.extensionDevelopmentLocationURI=v.map(i=>I.URI.revive(T.transformIncomingURIs(i)))),D.environment.extensionTestsLocationURI=I.URI.revive(T.transformIncomingURIs(D.environment.extensionTestsLocationURI)),D.environment.globalStorageHome=I.URI.revive(T.transformIncomingURIs(D.environment.globalStorageHome)),D.environment.workspaceStorageHome=I.URI.revive(T.transformIncomingURIs(D.environment.workspaceStorageHome)),D.environment.extensionTelemetryLogResource=I.URI.revive(T.transformIncomingURIs(D.environment.extensionTelemetryLogResource)),D.nlsBaseUrl=I.URI.revive(T.transformIncomingURIs(D.nlsBaseUrl)),D.logsLocation=I.URI.revive(T.transformIncomingURIs(D.logsLocation)),D.workspace=T.transformIncomingURIs(D.workspace),D}}e.ExtensionHostMain=o}),define(Pe[263],Ae([1,0,16,17,21,40,15,19,22,2,47]),function(te,e,n,P,I,L,R,A,y,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class w{constructor(d,D,T,v){this.d=d,this.e=D,this.f=T,this.g=v,this.a=null,this.b=!1,this.c=0}search(d,D){const T=this.d.folderQueries||[],v=new I.CancellationTokenSource;return D.onCancellationRequested(()=>v.cancel()),new Promise((i,a)=>{this.a=new S(d);let r=!1;const s=(E,k)=>{if(!r&&!this.b){const c=this.h(E);l(E)&&typeof this.d.maxResults=="number"&&this.c+c>this.d.maxResults&&(this.b=!0,r=!0,v.cancel(),E=this.j(E,this.d.maxResults-this.c));const u=this.h(E);this.c+=u,(u>0||!l(E))&&this.a.add(E,k)}};Promise.all(T.map((E,k)=>this.k(E,c=>s(c,k),v.token))).then(E=>{v.dispose(),this.a.flush();const k=E.some(c=>!!c&&!!c.limitHit);i({limitHit:this.b||k,messages:(0,n.flatten)(E.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.g}})},E=>{v.dispose();const k=(0,L.toErrorMessage)(E);a(new Error(k))})})}h(d){return l(d)?Array.isArray(d.ranges)?d.ranges.length:1:0}j(d,D){const T=Array.isArray(d.ranges)?d.ranges:[d.ranges],v=Array.isArray(d.preview.matches)?d.preview.matches:[d.preview.matches];return{ranges:T.slice(0,D),preview:{matches:v.slice(0,D),text:d.preview.text},uri:d.uri}}async k(d,D,T){const v=new O.QueryGlobTester(this.d,d),i=[],a={report:E=>{if(!this.l(E))return;const k=d.folder.scheme===R.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(E.uri))):void 0,c=y.relativePath(d.folder,E.uri);if(c){const u=v.includedInQuery(c,A.basename(c),k);(0,P.isThenable)(u)?i.push(u.then(m=>{m&&D(E)})):u&&D(E)}}},r=this.n(d),s=await this.e.provideTextSearchResults(g(this.d.contentPattern),r,a,T);return i.length&&await Promise.all(i),s}l(d){if(l(d)){if(Array.isArray(d.ranges)){if(!Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(d.preview.matches.length!==d.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(d.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(d){const D=(0,O.resolvePatternsForProvider)(this.d.includePattern,d.includePattern),T=(0,O.resolvePatternsForProvider)(this.d.excludePattern,d.excludePattern),v={folder:h.URI.from(d.folder),excludes:T,includes:D,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,encoding:d.fileEncoding&&this.f.toCanonicalName(d.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return v.usePCRE2=this.d.usePCRE2,v}}e.TextSearchManager=w;function g(o){return{isCaseSensitive:o.isCaseSensitive||!1,isRegExp:o.isRegExp||!1,isWordMatch:o.isWordMatch||!1,isMultiline:o.isMultiline||!1,pattern:o.pattern}}class S{constructor(d){this.e=d,this.b=-1,this.d=null,this.a=new t(512,D=>this.g(D))}add(d,D){this.d&&(this.b!==D||!y.isEqual(this.c,d.uri))&&(this.f(),this.d=null),this.d||(this.b=D,this.d={resource:d.uri,results:[]}),this.d.results.push(p(d))}f(){const d=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,d)}flush(){this.f(),this.a.flush()}g(d){this.e(d)}}e.TextSearchResultsCollector=S;function p(o){return l(o)?{preview:{matches:(0,n.mapArrayOrNot)(o.preview.matches,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character})),text:o.preview.text},ranges:(0,n.mapArrayOrNot)(o.ranges,d=>({startLineNumber:d.start.line,startColumn:d.start.character,endLineNumber:d.end.line,endColumn:d.end.character}))}:{text:o.text,lineNumber:o.lineNumber}}function l(o){return!!o.preview}e.extensionResultIsMatch=l;class t{constructor(d,D){this.g=d,this.h=D,this.c=0,this.d=[],this.e=0}addItem(d,D){d&&this.j(d,D)}addItems(d,D){d&&this.k(d,D)}j(d,D){this.d.push(d),this.e+=D,this.l()}k(d,D){this.d=this.d.concat(d),this.e+=D,this.l()}l(){this.c<t.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},t.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.BatchedCollector=t,t.a=4e3,t.b=50}),define(Pe[113],Ae([1,0,6,4,3,258,18,55,14,2,263]),function(te,e,n,P,I,L,R,A,y,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,I.createDecorator)("IExtHostSearch");let w=e.ExtHostSearch=class{constructor(l,t,o){this.k=l,this.l=t,this.n=o,this.c=this.k.getProxy(P.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new L.FileSearchManager}o(l){return this.l.transformOutgoingScheme(l)}registerTextSearchProvider(l,t){if(this.g.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this.g.add(l);const o=this.d++;return this.e.set(o,t),this.c.$registerTextSearchProvider(o,this.o(l)),(0,n.toDisposable)(()=>{this.g.delete(l),this.e.delete(o),this.c.$unregisterProvider(o)})}registerFileSearchProvider(l,t){if(this.i.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this.i.add(l);const o=this.d++;return this.h.set(o,t),this.c.$registerFileSearchProvider(o,this.o(l)),(0,n.toDisposable)(()=>{this.i.delete(l),this.h.delete(o),this.c.$unregisterProvider(o)})}$provideFileSearchResults(l,t,o,d){const D=g(o),T=this.h.get(l);if(T)return this.j.fileSearch(D,T,v=>{this.c.$handleFileMatch(l,t,v.map(i=>i.resource))},d);throw new Error("unknown provider: "+l)}$clearCache(l){return this.j.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,t,o,d){const D=this.e.get(l);if(!D||!D.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const T=g(o);return this.q(T,D).search(i=>this.c.$handleTextMatch(l,t,i),d)}$enableExtensionHostSearch(){}q(l,t){return new O.TextSearchManager(l,t,{readdir:o=>Promise.resolve([]),toCanonicalName:o=>o},"textSearchProvider")}};e.ExtHostSearch=w=xe([qe(0,R.IExtHostRpcService),qe(1,A.IURITransformerService),qe(2,y.ILogService)],w);function g(p){return{...p,folderQueries:p.folderQueries&&p.folderQueries.map(S),extraFileResources:p.extraFileResources&&p.extraFileResources.map(l=>h.URI.revive(l))}}e.reviveQuery=g;function S(p){return{...p,folder:h.URI.revive(p.folder)}}}),define(Pe[264],Ae([1,0,21,9,5,29,2,134,274,121,132,43,4,76,217,216,38,218,33,220,221,222,203,223,59,34,224,225,231,232,234,108,207,240,241,243,81,62,245,208,8,7,52,248,63,107,32,24,195,230,50,106,110,112,113,14,55,18,27,235,201,72,78,214,246,82,61,251,249,250,215,37,244,247,80,60,57,236,109,237,15,94,206,187,226,6,26,192,79,183,238,239,228,227,205,242,229]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t,o,d,D,T,v,i,a,r,s,E,k,c,u,m,b,f,N,V,_,G,$,B,X,U,j,Y,pe,Ee,he,de,Re,le,ue,H,F,Q,me,Ce,De,be,ke,oe,ce,ie,ne,C,W,q,x,ae,ge,ee,we,ye,ze,je,et,Ye,Je,rt,ut,Me,st,Z,J,Se,Ue,We,Qe,Ve,it,Et,yt,Tt,Ht,wt,Bt,Mt,xt,Vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Pt(at){const gt=at.get(oe.IExtHostInitDataService),Wt=at.get(ze.IExtHostFileSystemInfo),Ut=at.get(ae.IExtHostConsumerFileSystem),kt=at.get(s.IExtHostExtensionService),ht=at.get(de.IExtHostWorkspace),Ct=at.get(rt.IExtHostTelemetry),Ft=at.get(d.IExtHostConfiguration),At=at.get(be.IURITransformerService),Ke=at.get(ke.IExtHostRpcService),Te=at.get(G.IExtHostStorage),Oe=at.get(x.IExtensionStoragePaths),ve=at.get(De.ILoggerService),K=at.get(De.ILogService),Fe=at.get(ne.IExtHostTunnelService),Be=at.get(C.IExtHostApiDeprecationService),Xe=at.get(he.IExtHostWindow),He=at.get(Ye.IExtHostSecretState),tt=at.get(Je.IExtHostEditorTabs);Ke.set(g.ExtHostContext.ExtHostFileSystemInfo,Wt),Ke.set(g.ExtHostContext.ExtHostLogLevelServiceShape,ve),Ke.set(g.ExtHostContext.ExtHostWorkspace,ht),Ke.set(g.ExtHostContext.ExtHostConfiguration,Ft),Ke.set(g.ExtHostContext.ExtHostExtensionService,kt),Ke.set(g.ExtHostContext.ExtHostStorage,Te),Ke.set(g.ExtHostContext.ExtHostTunnelService,Fe),Ke.set(g.ExtHostContext.ExtHostWindow,Xe),Ke.set(g.ExtHostContext.ExtHostSecretState,He),Ke.set(g.ExtHostContext.ExtHostTelemetry,Ct),Ke.set(g.ExtHostContext.ExtHostEditorTabs,tt);const bt=Ke.set(g.ExtHostContext.ExtHostDecorations,at.get(F.IExtHostDecorations)),pt=Ke.set(g.ExtHostContext.ExtHostDocumentsAndEditors,at.get(r.IExtHostDocumentsAndEditors)),dt=Ke.set(g.ExtHostContext.ExtHostCommands,at.get(t.IExtHostCommands)),nt=Ke.set(g.ExtHostContext.ExtHostTerminalService,at.get($.IExtHostTerminalService)),lt=Ke.set(g.ExtHostContext.ExtHostDebugService,at.get(me.IExtHostDebugService)),Ot=Ke.set(g.ExtHostContext.ExtHostSearch,at.get(Ce.IExtHostSearch)),$t=Ke.set(g.ExtHostContext.ExtHostTask,at.get(Q.IExtHostTask)),ai=Ke.set(g.ExtHostContext.ExtHostOutputService,at.get(b.IExtHostOutputService)),ri=Ke.set(g.ExtHostContext.ExtHostLocalization,at.get(Et.IExtHostLocalizationService)),ei=Ke.set(g.ExtHostContext.ExtHostUrls,new pe.ExtHostUrls(Ke)),It=Ke.set(g.ExtHostContext.ExtHostDocuments,new a.ExtHostDocuments(Ke,pt)),Pi=Ke.set(g.ExtHostContext.ExtHostDocumentContentProviders,new v.ExtHostDocumentContentProvider(Ke,pt,K)),Ji=Ke.set(g.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(K,It,Ke.getProxy(g.MainContext.MainThreadBulkEdits))),Dt=Ke.set(g.ExtHostContext.ExtHostNotebook,new ce.ExtHostNotebookController(Ke,dt,pt,It)),gi=Ke.set(g.ExtHostContext.ExtHostNotebookDocuments,new Ue.ExtHostNotebookDocuments(Dt)),pi=Ke.set(g.ExtHostContext.ExtHostNotebookEditors,new Se.ExtHostNotebookEditors(K,Dt)),jt=Ke.set(g.ExtHostContext.ExtHostNotebookKernels,new ut.ExtHostNotebookKernels(Ke,gt,Dt,dt,K)),Ai=Ke.set(g.ExtHostContext.ExtHostNotebookRenderers,new st.ExtHostNotebookRenderers(Ke,Dt)),Ri=Ke.set(g.ExtHostContext.ExtHostNotebookDocumentSaveParticipant,new Mt.ExtHostNotebookDocumentSaveParticipant(K,Dt,Ke.getProxy(g.MainContext.MainThreadBulkEdits))),Lt=Ke.set(g.ExtHostContext.ExtHostEditors,new B.ExtHostEditors(Ke,pt)),vi=Ke.set(g.ExtHostContext.ExtHostTreeViews,new X.ExtHostTreeViews(Ke.getProxy(g.MainContext.MainThreadTreeViews),dt,K)),_i=Ke.set(g.ExtHostContext.ExtHostEditorInsets,new le.ExtHostEditorInsets(Ke.getProxy(g.MainContext.MainThreadEditorInsets),Lt,gt.remote)),Xt=Ke.set(g.ExtHostContext.ExtHostDiagnostics,new D.ExtHostDiagnostics(Ke,K,Wt,pt)),si=Ke.set(g.ExtHostContext.ExtHostLanguages,new u.ExtHostLanguages(Ke,It,dt.converter,At)),ft=Ke.set(g.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ke,At,It,dt,Xt,K,Be,Ct)),Oi=Ke.set(g.ExtHostContext.ExtHostFileSystem,new E.ExtHostFileSystem(Ke,ft)),Qt=Ke.set(g.ExtHostContext.ExtHostFileSystemEventService,new k.ExtHostFileSystemEventService(Ke,K,pt)),ti=Ke.set(g.ExtHostContext.ExtHostQuickOpen,(0,N.createExtHostQuickOpen)(Ke,ht,dt)),bi=Ke.set(g.ExtHostContext.ExtHostSCM,new V.ExtHostSCM(Ke,dt,It,K)),Fi=Ke.set(g.ExtHostContext.ExtHostQuickDiff,new Ht.ExtHostQuickDiff(Ke,At)),Li=Ke.set(g.ExtHostContext.ExtHostComments,(0,o.createExtHostComments)(Ke,dt,It)),Ei=Ke.set(g.ExtHostContext.ExtHostProgress,new f.ExtHostProgress(Ke.getProxy(g.MainContext.MainThreadProgress))),Ni=Ke.set(g.ExtHostContext.ExtHosLabelService,new ue.ExtHostLabelService(Ke)),wi=Ke.set(g.ExtHostContext.ExtHostTheming,new ie.ExtHostTheming(Ke)),ii=Ke.set(g.ExtHostContext.ExtHostAuthentication,new W.ExtHostAuthentication(Ke)),Mi=Ke.set(g.ExtHostContext.ExtHostTimeline,new q.ExtHostTimeline(Ke,dt)),ci=Ke.set(g.ExtHostContext.ExtHostWebviews,new Ee.ExtHostWebviews(Ke,gt.remote,ht,K,Be)),ui=Ke.set(g.ExtHostContext.ExtHostWebviewPanels,new we.ExtHostWebviewPanels(Ke,ci,ht)),Ui=Ke.set(g.ExtHostContext.ExtHostCustomEditors,new ee.ExtHostCustomEditors(Ke,It,Oe,ci,ui)),$i=Ke.set(g.ExtHostContext.ExtHostWebviewViews,new ge.ExtHostWebviewViews(Ke,ci)),ni=Ke.set(g.ExtHostContext.ExtHostTesting,new je.ExtHostTesting(Ke,dt,pt)),zi=Ke.set(g.ExtHostContext.ExtHostUriOpeners,new et.ExtHostUriOpeners(Ke)),Bi=Ke.set(g.ExtHostContext.ExtHostProfileContentHandlers,new Tt.ExtHostProfileContentHandlers(Ke));Ke.set(g.ExtHostContext.ExtHostInteractive,new We.ExtHostInteractive(Ke,Dt,pt,dt,K));const Wi=Ke.set(g.ExtHostContext.ExtHostInteractiveEditor,new Bt.ExtHostInteractiveEditor(Ke,It,K)),li=Ke.set(g.ExtHostContext.ExtHostInteractiveSession,new wt.ExtHostInteractiveSession(Ke,K)),Zi=Ke.set(g.ExtHostContext.ExtHostSemanticSimilarity,new xt.ExtHostSemanticSimilarity(Ke)),Si=Ke.set(g.ExtHostContext.ExtHostIssueReporter,new Vt.ExtHostIssueReporter(Ke)),yi=Object.values(g.ExtHostContext);Ke.assertRegistered(yi);const en=new ye.ExtHostBulkEdits(Ke,pt),tn=new l.ExtHostClipboard(Ke),di=new m.ExtHostMessageService(Ke,K),hi=new T.ExtHostDialogs(Ke),Di=new _.ExtHostStatusBar(Ke,dt.converter);return p.ExtHostApiCommands.register(dt),function($e,Gt,Hi){const vt=function(){let re=!$e.isUnderDevelopment;function fe(){re||(K.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),re=!0)}return function Le(ot){if(Array.isArray(ot))ot.forEach(Le);else if(typeof ot=="string")fe();else{const St=ot;typeof St.scheme>"u"&&fe(),typeof St.exclusive=="boolean"&&(0,Ve.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return ot}}(),Vi={getSession(re,fe,Le){return ii.getSession($e,re,fe,Le)},getSessions(re,fe){return(0,Ve.checkProposedApiEnabled)($e,"getSessions"),ii.getSessions($e,re,fe)},async hasSession(re,fe){return(0,Ve.checkProposedApiEnabled)($e,"authSession"),!!await ii.getSession($e,re,fe,{silent:!0})},get onDidChangeSessions(){return ii.onDidChangeSessions},registerAuthenticationProvider(re,fe,Le,ot){return ii.registerAuthenticationProvider(re,fe,Le,ot)}},Yt={registerCommand(re,fe,Le){return dt.registerCommand(!0,re,fe,Le,void 0,$e)},registerTextEditorCommand(re,fe,Le){return dt.registerCommand(!0,re,(...ot)=>{const St=Lt.getActiveTextEditor();if(!St){K.warn("Cannot execute "+re+" because there is no active text editor.");return}return St.edit(Rt=>{fe.apply(Le,[St,Rt,...ot])}).then(Rt=>{Rt||K.warn("Edits from command "+re+" were not applied.")},Rt=>{K.warn("An error occurred while running command "+re,Rt)})},void 0,void 0,$e)},registerDiffInformationCommand:(re,fe,Le)=>((0,Ve.checkProposedApiEnabled)($e,"diffCommand"),dt.registerCommand(!0,re,async(...ot)=>{const St=pt.activeEditor(!0);if(!St){K.warn("Cannot execute "+re+" because there is no active text editor.");return}const Rt=await Lt.getDiffInformation(St.id);fe.apply(Le,[Rt,...ot])},void 0,void 0,$e)),executeCommand(re,...fe){return dt.executeCommand(re,...fe)},getCommands(re=!1){return dt.getCommands(re)}},oi={get machineId(){return gt.telemetryInfo.machineId},get sessionId(){return gt.telemetryInfo.sessionId},get language(){return gt.environment.appLanguage},get appName(){return gt.environment.appName},get appRoot(){return gt.environment.appRoot?.fsPath??""},get appHost(){return gt.environment.appHost},get uriScheme(){return gt.environment.appUriScheme},get clipboard(){return tn.value},get shell(){return nt.getDefaultShell(!1)},get onDidChangeShell(){return(0,Ve.checkProposedApiEnabled)($e,"envShellEvent"),nt.onDidChangeShell},get isTelemetryEnabled(){return Ct.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Ct.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)($e,"telemetry"),Ct.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ve.checkProposedApiEnabled)($e,"telemetry"),Ct.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,rt.isNewAppInstall)(gt.telemetryInfo.firstSessionDate)},createTelemetryLogger(re,fe){return rt.ExtHostTelemetryLogger.validateSender(re),Ct.instantiateLogger($e,re,fe)},openExternal(re,fe){return Xe.openUri(re,{allowTunneling:!!gt.remote.authority,allowContributedOpeners:fe?.allowContributedOpeners})},async asExternalUri(re){if(re.scheme===gt.environment.appUriScheme)return ei.createAppUri(re);try{return await Xe.asExternalUri(re,{allowTunneling:!!gt.remote.authority})}catch(fe){if((0,J.matchesScheme)(re,Z.Schemas.http)||(0,J.matchesScheme)(re,Z.Schemas.https))return re;throw fe}},get remoteName(){return(0,H.getRemoteName)(gt.remote.authority)},get remoteAuthority(){return(0,Ve.checkProposedApiEnabled)($e,"resolvers"),gt.remote.authority},get uiKind(){return gt.uiKind},get logLevel(){return K.getLevel()},get onDidChangeLogLevel(){return K.onDidChangeLogLevel},registerIssueUriRequestHandler(re){return(0,Ve.checkProposedApiEnabled)($e,"handleIssueUri"),Si.registerIssueUriRequestHandler($e,re)}};gt.environment.extensionTestsLocationURI||Object.freeze(oi);const nn={createTestController(re,fe,Le){return ni.createTestController($e,re,fe,Le)},createTestObserver(){return(0,Ve.checkProposedApiEnabled)($e,"testObserver"),ni.createTestObserver()},runTests(re){return(0,Ve.checkProposedApiEnabled)($e,"testObserver"),ni.runTests(re)},get onDidChangeTestResults(){return(0,Ve.checkProposedApiEnabled)($e,"testObserver"),ni.onResultsChanged},get testResults(){return(0,Ve.checkProposedApiEnabled)($e,"testObserver"),ni.results}},Nt=gt.remote.isRemote?j.ExtensionKind.Workspace:j.ExtensionKind.UI,fi={getExtension(re,fe){(0,Ve.isProposedApiEnabled)($e,"extensionsAny")||(fe=!1);const Le=Gt.mine.getExtensionDescription(re);if(Le)return new s.Extension(kt,$e.identifier,Le,Nt,!1);if(fe){const ot=Gt.all.getExtensionDescription(re);if(ot)return new s.Extension(kt,$e.identifier,ot,Nt,!0)}},get all(){const re=[];for(const fe of Gt.mine.getAllExtensionDescriptions())re.push(new s.Extension(kt,$e.identifier,fe,Nt,!1));return re},get allAcrossExtensionHosts(){(0,Ve.checkProposedApiEnabled)($e,"extensionsAny");const re=new Re.ExtensionIdentifierSet(Gt.mine.getAllExtensionDescriptions().map(Le=>Le.identifier)),fe=[];for(const Le of Gt.all.getAllExtensionDescriptions()){const ot=!re.has(Le.identifier);fe.push(new s.Extension(kt,$e.identifier,Le,Nt,ot))}return fe},get onDidChange(){return(0,Ve.isProposedApiEnabled)($e,"extensionsAny")?I.Event.any(Gt.mine.onDidChange,Gt.all.onDidChange):Gt.mine.onDidChange}},ji={createDiagnosticCollection(re){return Xt.createDiagnosticCollection($e.identifier,re)},get onDidChangeDiagnostics(){return Xt.onDidChangeDiagnostics},getDiagnostics:re=>Xt.getDiagnostics(re),getLanguages(){return si.getLanguages()},setTextDocumentLanguage(re,fe){return si.changeLanguage(re.uri,fe)},match(re,fe){const Le=It.getDocumentData(fe.uri)?.notebook;return(0,O.score)(U.LanguageSelector.from(re),fe.uri,fe.languageId,!0,Le?.uri,Le?.notebookType)},registerCodeActionsProvider(re,fe,Le){return ft.registerCodeActionProvider($e,vt(re),fe,Le)},registerDocumentPasteEditProvider(re,fe,Le){return(0,Ve.checkProposedApiEnabled)($e,"documentPaste"),ft.registerDocumentPasteEditProvider($e,vt(re),fe,Le)},registerCodeLensProvider(re,fe){return ft.registerCodeLensProvider($e,vt(re),fe)},registerDefinitionProvider(re,fe){return ft.registerDefinitionProvider($e,vt(re),fe)},registerDeclarationProvider(re,fe){return ft.registerDeclarationProvider($e,vt(re),fe)},registerImplementationProvider(re,fe){return ft.registerImplementationProvider($e,vt(re),fe)},registerTypeDefinitionProvider(re,fe){return ft.registerTypeDefinitionProvider($e,vt(re),fe)},registerHoverProvider(re,fe){return ft.registerHoverProvider($e,vt(re),fe,$e.identifier)},registerEvaluatableExpressionProvider(re,fe){return ft.registerEvaluatableExpressionProvider($e,vt(re),fe,$e.identifier)},registerInlineValuesProvider(re,fe){return ft.registerInlineValuesProvider($e,vt(re),fe,$e.identifier)},registerDocumentHighlightProvider(re,fe){return ft.registerDocumentHighlightProvider($e,vt(re),fe)},registerLinkedEditingRangeProvider(re,fe){return ft.registerLinkedEditingRangeProvider($e,vt(re),fe)},registerReferenceProvider(re,fe){return ft.registerReferenceProvider($e,vt(re),fe)},registerRenameProvider(re,fe){return ft.registerRenameProvider($e,vt(re),fe)},registerDocumentSymbolProvider(re,fe,Le){return ft.registerDocumentSymbolProvider($e,vt(re),fe,Le)},registerWorkspaceSymbolProvider(re){return ft.registerWorkspaceSymbolProvider($e,re)},registerDocumentFormattingEditProvider(re,fe){return ft.registerDocumentFormattingEditProvider($e,vt(re),fe)},registerDocumentRangeFormattingEditProvider(re,fe){return ft.registerDocumentRangeFormattingEditProvider($e,vt(re),fe)},registerOnTypeFormattingEditProvider(re,fe,Le,...ot){return ft.registerOnTypeFormattingEditProvider($e,vt(re),fe,[Le].concat(ot))},registerDocumentSemanticTokensProvider(re,fe,Le){return ft.registerDocumentSemanticTokensProvider($e,vt(re),fe,Le)},registerDocumentRangeSemanticTokensProvider(re,fe,Le){return ft.registerDocumentRangeSemanticTokensProvider($e,vt(re),fe,Le)},registerSignatureHelpProvider(re,fe,Le,...ot){return typeof Le=="object"?ft.registerSignatureHelpProvider($e,vt(re),fe,Le):ft.registerSignatureHelpProvider($e,vt(re),fe,typeof Le>"u"?[]:[Le,...ot])},registerCompletionItemProvider(re,fe,...Le){return ft.registerCompletionItemProvider($e,vt(re),fe,Le)},registerInlineCompletionItemProvider(re,fe){return fe.handleDidShowCompletionItem&&(0,Ve.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),fe.handleDidPartiallyAcceptCompletionItem&&(0,Ve.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),ft.registerInlineCompletionsProvider($e,vt(re),fe)},registerDocumentLinkProvider(re,fe){return ft.registerDocumentLinkProvider($e,vt(re),fe)},registerColorProvider(re,fe){return ft.registerColorProvider($e,vt(re),fe)},registerFoldingRangeProvider(re,fe){return ft.registerFoldingRangeProvider($e,vt(re),fe)},registerSelectionRangeProvider(re,fe){return ft.registerSelectionRangeProvider($e,re,fe)},registerCallHierarchyProvider(re,fe){return ft.registerCallHierarchyProvider($e,re,fe)},registerTypeHierarchyProvider(re,fe){return ft.registerTypeHierarchyProvider($e,re,fe)},setLanguageConfiguration:(re,fe)=>ft.setLanguageConfiguration($e,re,fe),getTokenInformationAtPosition(re,fe){return(0,Ve.checkProposedApiEnabled)($e,"tokenInformation"),si.tokenAtPosition(re,fe)},registerInlayHintsProvider(re,fe){return ft.registerInlayHintsProvider($e,re,fe)},createLanguageStatusItem(re,fe){return si.createLanguageStatusItem($e,re,fe)},registerDocumentDropEditProvider(re,fe,Le){return ft.registerDocumentOnDropEditProvider($e,re,fe,(0,Ve.isProposedApiEnabled)($e,"dropMetadata")?Le:void 0)}},qi={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return nt.activeTerminal},get terminals(){return nt.terminals},async showTextDocument(re,fe,Le){const ot=await(R.URI.isUri(re)?Promise.resolve(Ii.openTextDocument(re)):Promise.resolve(re));return Lt.showTextDocument(ot,fe,Le)},createTextEditorDecorationType(re){return Lt.createTextEditorDecorationType($e,re)},onDidChangeActiveTextEditor(re,fe,Le){return Lt.onDidChangeActiveTextEditor(re,fe,Le)},onDidChangeVisibleTextEditors(re,fe,Le){return Lt.onDidChangeVisibleTextEditors(re,fe,Le)},onDidChangeTextEditorSelection(re,fe,Le){return Lt.onDidChangeTextEditorSelection(re,fe,Le)},onDidChangeTextEditorOptions(re,fe,Le){return Lt.onDidChangeTextEditorOptions(re,fe,Le)},onDidChangeTextEditorVisibleRanges(re,fe,Le){return Lt.onDidChangeTextEditorVisibleRanges(re,fe,Le)},onDidChangeTextEditorViewColumn(re,fe,Le){return Lt.onDidChangeTextEditorViewColumn(re,fe,Le)},onDidCloseTerminal(re,fe,Le){return nt.onDidCloseTerminal(re,fe,Le)},onDidOpenTerminal(re,fe,Le){return nt.onDidOpenTerminal(re,fe,Le)},onDidChangeActiveTerminal(re,fe,Le){return nt.onDidChangeActiveTerminal(re,fe,Le)},onDidChangeTerminalDimensions(re,fe,Le){return(0,Ve.checkProposedApiEnabled)($e,"terminalDimensions"),nt.onDidChangeTerminalDimensions(re,fe,Le)},onDidChangeTerminalState(re,fe,Le){return nt.onDidChangeTerminalState(re,fe,Le)},onDidWriteTerminalData(re,fe,Le){return(0,Ve.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),nt.onDidWriteTerminalData(re,fe,Le)},get state(){return Xe.state},onDidChangeWindowState(re,fe,Le){return Xe.onDidChangeWindowState(re,fe,Le)},showInformationMessage(re,...fe){return di.showMessage($e,L.default.Info,re,fe[0],fe.slice(1))},showWarningMessage(re,...fe){return di.showMessage($e,L.default.Warning,re,fe[0],fe.slice(1))},showErrorMessage(re,...fe){return di.showMessage($e,L.default.Error,re,fe[0],fe.slice(1))},showQuickPick(re,fe,Le){return ti.showQuickPick($e,re,fe,Le)},showWorkspaceFolderPick(re){return ti.showWorkspaceFolderPick(re)},showInputBox(re,fe){return ti.showInput(re,fe)},showOpenDialog(re){return hi.showOpenDialog($e,re)},showSaveDialog(re){return hi.showSaveDialog(re)},createStatusBarItem(re,fe,Le){let ot,St,Rt;return typeof re=="string"?(ot=re,St=fe,Rt=Le):(St=re,Rt=fe),Di.createStatusBarEntry($e,ot,St,Rt)},setStatusBarMessage(re,fe){return Di.setStatusBarMessage(re,fe)},withScmProgress(re){return Be.report("window.withScmProgress",$e,"Use 'withProgress' instead."),Ei.withProgress($e,{location:j.ProgressLocation.SourceControl},(fe,Le)=>re({report(ot){}}))},withProgress(re,fe){return Ei.withProgress($e,re,fe)},createOutputChannel(re,fe){return ai.createOutputChannel(re,fe,$e)},createWebviewPanel(re,fe,Le,ot){return ui.createWebviewPanel($e,re,fe,Le,ot)},createWebviewTextEditorInset(re,fe,Le,ot){return(0,Ve.checkProposedApiEnabled)($e,"editorInsets"),_i.createWebviewEditorInset(re,fe,Le,ot,$e)},createTerminal(re,fe,Le){return typeof re=="object"?"pty"in re?nt.createExtensionTerminal(re):nt.createTerminalFromOptions(re):nt.createTerminal(re,fe,Le)},registerTerminalLinkProvider(re){return nt.registerLinkProvider(re)},registerTerminalProfileProvider(re,fe){return nt.registerProfileProvider($e,re,fe)},registerTerminalQuickFixProvider(re,fe){return(0,Ve.checkProposedApiEnabled)($e,"terminalQuickFixProvider"),nt.registerTerminalQuickFixProvider(re,$e.identifier.value,fe)},registerTreeDataProvider(re,fe){return vi.registerTreeDataProvider(re,fe,$e)},createTreeView(re,fe){return vi.createTreeView(re,fe,$e)},registerWebviewPanelSerializer:(re,fe)=>ui.registerWebviewPanelSerializer($e,re,fe),registerCustomEditorProvider:(re,fe,Le={})=>Ui.registerCustomEditorProvider($e,re,fe,Le),registerFileDecorationProvider(re){return bt.registerFileDecorationProvider(re,$e)},registerUriHandler(re){return ei.registerUriHandler($e.identifier,re)},createQuickPick(){return ti.createQuickPick($e)},createInputBox(){return ti.createInputBox($e)},get activeColorTheme(){return wi.activeColorTheme},onDidChangeActiveColorTheme(re,fe,Le){return wi.onDidChangeActiveColorTheme(re,fe,Le)},registerWebviewViewProvider(re,fe,Le){return $i.registerWebviewViewProvider($e,re,fe,Le?.webviewOptions)},get activeNotebookEditor(){return Dt.activeNotebookEditor},onDidChangeActiveNotebookEditor(re,fe,Le){return Dt.onDidChangeActiveNotebookEditor(re,fe,Le)},get visibleNotebookEditors(){return Dt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Dt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(re,fe,Le){return pi.onDidChangeNotebookEditorSelection(re,fe,Le)},onDidChangeNotebookEditorVisibleRanges(re,fe,Le){return pi.onDidChangeNotebookEditorVisibleRanges(re,fe,Le)},showNotebookDocument(re,fe){return Dt.showNotebookDocument(re,fe)},registerExternalUriOpener(re,fe,Le){return(0,Ve.checkProposedApiEnabled)($e,"externalUriOpener"),zi.registerExternalUriOpener($e.identifier,re,fe,Le)},registerProfileContentHandler(re,fe){return(0,Ve.checkProposedApiEnabled)($e,"profileContentHandlers"),Bi.registrProfileContentHandler($e,re,fe)},registerQuickDiffProvider(re,fe,Le,ot){return(0,Ve.checkProposedApiEnabled)($e,"quickDiffProvider"),Fi.registerQuickDiffProvider(vt(re),fe,Le,ot)},get tabGroups(){return tt.tabGroups}},Ii={get rootPath(){return Be.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ht.getPath()},set rootPath(re){throw P.readonly()},getWorkspaceFolder(re){return ht.getWorkspaceFolder(re)},get workspaceFolders(){return ht.getWorkspaceFolders()},get name(){return ht.name},set name(re){throw P.readonly()},get workspaceFile(){return ht.workspaceFile},set workspaceFile(re){throw P.readonly()},updateWorkspaceFolders:(re,fe,...Le)=>ht.updateWorkspaceFolders($e,re,fe||0,...Le),onDidChangeWorkspaceFolders:function(re,fe,Le){return ht.onDidChangeWorkspace(re,fe,Le)},asRelativePath:(re,fe)=>ht.getRelativePath(re,fe),findFiles:(re,fe,Le,ot)=>ht.findFiles(re,fe,Le,$e.identifier,ot),findTextInFiles:(re,fe,Le,ot)=>{(0,Ve.checkProposedApiEnabled)($e,"findTextInFiles");let St,Rt;return typeof fe=="object"?(St=fe,Rt=Le):(St={},Rt=fe,ot=Le),ht.findTextInFiles(re,St||{},Rt,$e.identifier,ot)},save:re=>((0,Ve.checkProposedApiEnabled)($e,"saveEditor"),ht.save(re)),saveAs:re=>((0,Ve.checkProposedApiEnabled)($e,"saveEditor"),ht.saveAs(re)),saveAll:re=>ht.saveAll(re),applyEdit(re,fe){return en.applyWorkspaceEdit(re,$e,fe)},createFileSystemWatcher:(re,fe,Le,ot)=>Qt.createFileSystemWatcher(ht,$e,re,fe,Le,ot),get textDocuments(){return It.getAllDocumentData().map(re=>re.document)},set textDocuments(re){throw P.readonly()},openTextDocument(re){let fe;const Le=re;if(typeof re=="string")fe=Promise.resolve(R.URI.file(re));else if(R.URI.isUri(re))fe=Promise.resolve(re);else if(!Le||typeof Le=="object")fe=It.createDocumentData(Le);else throw new Error("illegal argument - uriOrFileNameOrOptions");return fe.then(ot=>It.ensureDocumentData(ot).then(St=>St.document))},onDidOpenTextDocument:(re,fe,Le)=>It.onDidAddDocument(re,fe,Le),onDidCloseTextDocument:(re,fe,Le)=>It.onDidRemoveDocument(re,fe,Le),onDidChangeTextDocument:(re,fe,Le)=>It.onDidChangeDocument(re,fe,Le),onDidSaveTextDocument:(re,fe,Le)=>It.onDidSaveDocument(re,fe,Le),onWillSaveTextDocument:(re,fe,Le)=>Ji.getOnWillSaveTextDocumentEvent($e)(re,fe,Le),get notebookDocuments(){return Dt.notebookDocuments.map(re=>re.apiNotebook)},async openNotebookDocument(re,fe){let Le;if(R.URI.isUri(re))Le=re,await Dt.openNotebookDocument(re);else if(typeof re=="string")Le=R.URI.revive(await Dt.createNotebookDocument({viewType:re,content:fe}));else throw new Error("Invalid arguments");return Dt.getNotebookDocument(Le).apiNotebook},onDidSaveNotebookDocument(re,fe,Le){return gi.onDidSaveNotebookDocument(re,fe,Le)},onDidChangeNotebookDocument(re,fe,Le){return gi.onDidChangeNotebookDocument(re,fe,Le)},onWillSaveNotebookDocument(re,fe,Le){return Ri.getOnWillSaveNotebookDocumentEvent($e)(re,fe,Le)},get onDidOpenNotebookDocument(){return Dt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Dt.onDidCloseNotebookDocument},registerNotebookSerializer(re,fe,Le,ot){return Dt.registerNotebookSerializer($e,re,fe,Le,(0,Ve.isProposedApiEnabled)($e,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(re,fe,Le)=>Hi.onDidChangeConfiguration(re,fe,Le),getConfiguration(re,fe){return fe=arguments.length===1?void 0:fe,Hi.getConfiguration(re,fe,$e)},registerTextDocumentContentProvider(re,fe){return Pi.registerTextDocumentContentProvider(re,fe)},registerTaskProvider:(re,fe)=>(Be.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),$t.registerTaskProvider($e,re,fe)),registerFileSystemProvider(re,fe,Le){return(0,Qe.combinedDisposable)(Oi.registerFileSystemProvider($e,re,fe,Le),Ut.addFileSystemProvider(re,fe))},get fs(){return Ut.value},registerFileSearchProvider:(re,fe)=>((0,Ve.checkProposedApiEnabled)($e,"fileSearchProvider"),Ot.registerFileSearchProvider(re,fe)),registerTextSearchProvider:(re,fe)=>((0,Ve.checkProposedApiEnabled)($e,"textSearchProvider"),Ot.registerTextSearchProvider(re,fe)),registerRemoteAuthorityResolver:(re,fe)=>((0,Ve.checkProposedApiEnabled)($e,"resolvers"),kt.registerRemoteAuthorityResolver(re,fe)),registerResourceLabelFormatter:re=>((0,Ve.checkProposedApiEnabled)($e,"resolvers"),Ni.$registerResourceLabelFormatter(re)),onDidCreateFiles:(re,fe,Le)=>Qt.onDidCreateFile(re,fe,Le),onDidDeleteFiles:(re,fe,Le)=>Qt.onDidDeleteFile(re,fe,Le),onDidRenameFiles:(re,fe,Le)=>Qt.onDidRenameFile(re,fe,Le),onWillCreateFiles:(re,fe,Le)=>Qt.getOnWillCreateFileEvent($e)(re,fe,Le),onWillDeleteFiles:(re,fe,Le)=>Qt.getOnWillDeleteFileEvent($e)(re,fe,Le),onWillRenameFiles:(re,fe,Le)=>Qt.getOnWillRenameFileEvent($e)(re,fe,Le),openTunnel:re=>((0,Ve.checkProposedApiEnabled)($e,"tunnels"),Fe.openTunnel($e,re).then(fe=>{if(!fe)throw new Error("cannot open tunnel");return fe})),get tunnels(){return(0,Ve.checkProposedApiEnabled)($e,"tunnels"),Fe.getTunnels()},onDidChangeTunnels:(re,fe,Le)=>((0,Ve.checkProposedApiEnabled)($e,"tunnels"),Fe.onDidChangeTunnels(re,fe,Le)),registerPortAttributesProvider:(re,fe)=>((0,Ve.checkProposedApiEnabled)($e,"portsAttributes"),Fe.registerPortsAttributesProvider(re,fe)),registerTimelineProvider:(re,fe)=>((0,Ve.checkProposedApiEnabled)($e,"timeline"),Mi.registerTimelineProvider(re,fe,$e.identifier,dt.converter)),get isTrusted(){return ht.trusted},requestWorkspaceTrust:re=>((0,Ve.checkProposedApiEnabled)($e,"workspaceTrust"),ht.requestWorkspaceTrust(re)),onDidGrantWorkspaceTrust:(re,fe,Le)=>ht.onDidGrantWorkspaceTrust(re,fe,Le),registerEditSessionIdentityProvider:(re,fe)=>((0,Ve.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),ht.registerEditSessionIdentityProvider(re,fe)),onWillCreateEditSessionIdentity:(re,fe,Le)=>((0,Ve.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),ht.getOnWillCreateEditSessionIdentityEvent($e)(re,fe,Le))},xi={get inputBox(){return Be.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),bi.getLastInputBox($e)},createSourceControl(re,fe,Le){return bi.createSourceControl($e,re,fe,Le)}},rn={createCommentController(re,fe){return Li.createCommentController($e,re,fe)}},Gi={get activeDebugSession(){return lt.activeDebugSession},get activeDebugConsole(){return lt.activeDebugConsole},get breakpoints(){return lt.breakpoints},get stackFrameFocus(){return lt.stackFrameFocus},onDidStartDebugSession(re,fe,Le){return lt.onDidStartDebugSession(re,fe,Le)},onDidTerminateDebugSession(re,fe,Le){return lt.onDidTerminateDebugSession(re,fe,Le)},onDidChangeActiveDebugSession(re,fe,Le){return lt.onDidChangeActiveDebugSession(re,fe,Le)},onDidReceiveDebugSessionCustomEvent(re,fe,Le){return lt.onDidReceiveDebugSessionCustomEvent(re,fe,Le)},onDidChangeBreakpoints(re,fe,Le){return lt.onDidChangeBreakpoints(re,fe,Le)},onDidChangeStackFrameFocus(re,fe,Le){return(0,Ve.checkProposedApiEnabled)($e,"debugFocus"),lt.onDidChangeStackFrameFocus(re,fe,Le)},registerDebugConfigurationProvider(re,fe,Le){return lt.registerDebugConfigurationProvider(re,fe,Le||it.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(re,fe){return lt.registerDebugAdapterDescriptorFactory($e,re,fe)},registerDebugAdapterTrackerFactory(re,fe){return lt.registerDebugAdapterTrackerFactory(re,fe)},startDebugging(re,fe,Le){return!Le||typeof Le=="object"&&"configuration"in Le?lt.startDebugging(re,fe,{parentSession:Le}):lt.startDebugging(re,fe,Le||{})},stopDebugging(re){return lt.stopDebugging(re)},addBreakpoints(re){return lt.addBreakpoints(re)},removeBreakpoints(re){return lt.removeBreakpoints(re)},asDebugSourceUri(re,fe){return lt.asDebugSourceUri(re,fe)}},Ki={registerTaskProvider:(re,fe)=>$t.registerTaskProvider($e,re,fe),fetchTasks:re=>$t.fetchTasks(re),executeTask:re=>$t.executeTask($e,re),get taskExecutions(){return $t.taskExecutions},onDidStartTask:(re,fe,Le)=>$t.onDidStartTask(re,fe,Le),onDidEndTask:(re,fe,Le)=>$t.onDidEndTask(re,fe,Le),onDidStartTaskProcess:(re,fe,Le)=>$t.onDidStartTaskProcess(re,fe,Le),onDidEndTaskProcess:(re,fe,Le)=>$t.onDidEndTaskProcess(re,fe,Le)},sn={createNotebookController(re,fe,Le,ot,St){return jt.createNotebookController($e,re,fe,Le,ot,(0,Ve.isProposedApiEnabled)($e,"notebookMessaging")?St:void 0)},registerNotebookCellStatusBarItemProvider:(re,fe)=>Dt.registerNotebookCellStatusBarItemProvider($e,re,fe),createRendererMessaging(re){return Ai.createRendererMessaging($e,re)},createNotebookControllerDetectionTask(re){return(0,Ve.checkProposedApiEnabled)($e,"notebookKernelSource"),jt.createNotebookControllerDetectionTask($e,re)},registerKernelSourceActionProvider(re,fe){return(0,Ve.checkProposedApiEnabled)($e,"notebookKernelSource"),jt.registerKernelSourceActionProvider($e,re,fe)},onDidChangeNotebookCellExecutionState(re,fe,Le){return(0,Ve.checkProposedApiEnabled)($e,"notebookCellExecutionState"),jt.onDidChangeNotebookCellExecutionState(re,fe,Le)}},on={t(...re){if(typeof re[0]=="string"){const fe=re.shift(),Le=!re||typeof re[0]!="object"?re:re[0];return ri.getMessage($e.identifier.value,{message:fe,args:Le})}return ri.getMessage($e.identifier.value,re[0])},get bundle(){return ri.getBundle($e.identifier.value)},get uri(){return ri.getBundleUri($e.identifier.value)}},Xi={_version:1,registerInteractiveEditorSessionProvider(re){return(0,Ve.checkProposedApiEnabled)($e,"interactive"),Wi.registerProvider($e,re)},registerInteractiveSessionProvider(re,fe){return(0,Ve.checkProposedApiEnabled)($e,"interactive"),li.registerInteractiveSessionProvider($e,re,fe)},addInteractiveRequest(re){return(0,Ve.checkProposedApiEnabled)($e,"interactive"),li.addInteractiveSessionRequest(re)},sendInteractiveRequestToProvider(re,fe){return(0,Ve.checkProposedApiEnabled)($e,"interactive"),li.sendInteractiveRequestToProvider(re,fe)},get onDidPerformUserAction(){return li.onDidPerformUserAction}},Qi={registerSemanticSimilarityProvider(re){return(0,Ve.checkProposedApiEnabled)($e,"semanticSimilarity"),Zi.registerSemanticSimilarityProvider($e,re)}};return{version:gt.version,ai:Qi,authentication:Vi,commands:Yt,comments:rn,debug:Gi,env:oi,extensions:fi,interactive:Xi,l10n:on,languages:ji,notebooks:sn,scm:xi,tasks:Ki,tests:nn,window:qi,workspace:Ii,Breakpoint:j.Breakpoint,TerminalOutputAnchor:j.TerminalOutputAnchor,CallHierarchyIncomingCall:j.CallHierarchyIncomingCall,CallHierarchyItem:j.CallHierarchyItem,CallHierarchyOutgoingCall:j.CallHierarchyOutgoingCall,CancellationError:P.CancellationError,CancellationTokenSource:n.CancellationTokenSource,CandidatePortSource:g.CandidatePortSource,CodeAction:j.CodeAction,CodeActionKind:j.CodeActionKind,CodeActionTriggerKind:j.CodeActionTriggerKind,CodeLens:j.CodeLens,Color:j.Color,ColorInformation:j.ColorInformation,ColorPresentation:j.ColorPresentation,ColorThemeKind:j.ColorThemeKind,CommentMode:j.CommentMode,CommentState:j.CommentState,CommentThreadCollapsibleState:j.CommentThreadCollapsibleState,CommentThreadState:j.CommentThreadState,CompletionItem:j.CompletionItem,CompletionItemKind:j.CompletionItemKind,CompletionItemTag:j.CompletionItemTag,CompletionList:j.CompletionList,CompletionTriggerKind:j.CompletionTriggerKind,ConfigurationTarget:j.ConfigurationTarget,CustomExecution:j.CustomExecution,DebugAdapterExecutable:j.DebugAdapterExecutable,DebugAdapterInlineImplementation:j.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:j.DebugAdapterNamedPipeServer,DebugAdapterServer:j.DebugAdapterServer,DebugConfigurationProviderTriggerKind:it.DebugConfigurationProviderTriggerKind,DebugConsoleMode:j.DebugConsoleMode,DecorationRangeBehavior:j.DecorationRangeBehavior,Diagnostic:j.Diagnostic,DiagnosticRelatedInformation:j.DiagnosticRelatedInformation,DiagnosticSeverity:j.DiagnosticSeverity,DiagnosticTag:j.DiagnosticTag,Disposable:j.Disposable,DocumentHighlight:j.DocumentHighlight,DocumentHighlightKind:j.DocumentHighlightKind,DocumentLink:j.DocumentLink,DocumentSymbol:j.DocumentSymbol,EndOfLine:j.EndOfLine,EnvironmentVariableMutatorType:j.EnvironmentVariableMutatorType,EvaluatableExpression:j.EvaluatableExpression,InlineValueText:j.InlineValueText,InlineValueVariableLookup:j.InlineValueVariableLookup,InlineValueEvaluatableExpression:j.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:j.InlineCompletionTriggerKind,EventEmitter:I.Emitter,ExtensionKind:j.ExtensionKind,ExtensionMode:j.ExtensionMode,ExternalUriOpenerPriority:j.ExternalUriOpenerPriority,FileChangeType:j.FileChangeType,FileDecoration:j.FileDecoration,FileDecoration2:j.FileDecoration,FileSystemError:j.FileSystemError,FileType:w.FileType,FilePermission:w.FilePermission,FoldingRange:j.FoldingRange,FoldingRangeKind:j.FoldingRangeKind,FunctionBreakpoint:j.FunctionBreakpoint,InlineCompletionItem:j.InlineSuggestion,InlineCompletionList:j.InlineSuggestionList,Hover:j.Hover,IndentAction:h.IndentAction,Location:j.Location,MarkdownString:j.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:j.ParameterInformation,PortAutoForwardAction:j.PortAutoForwardAction,Position:j.Position,ProcessExecution:j.ProcessExecution,ProgressLocation:j.ProgressLocation,QuickInputButtons:j.QuickInputButtons,Range:j.Range,RelativePattern:j.RelativePattern,Selection:j.Selection,SelectionRange:j.SelectionRange,SemanticTokens:j.SemanticTokens,SemanticTokensBuilder:j.SemanticTokensBuilder,SemanticTokensEdit:j.SemanticTokensEdit,SemanticTokensEdits:j.SemanticTokensEdits,SemanticTokensLegend:j.SemanticTokensLegend,ShellExecution:j.ShellExecution,ShellQuoting:j.ShellQuoting,SignatureHelp:j.SignatureHelp,SignatureHelpTriggerKind:j.SignatureHelpTriggerKind,SignatureInformation:j.SignatureInformation,SnippetString:j.SnippetString,SourceBreakpoint:j.SourceBreakpoint,StandardTokenType:j.StandardTokenType,StatusBarAlignment:j.StatusBarAlignment,SymbolInformation:j.SymbolInformation,SymbolKind:j.SymbolKind,SymbolTag:j.SymbolTag,Task:j.Task,TaskGroup:j.TaskGroup,TaskPanelKind:j.TaskPanelKind,TaskRevealKind:j.TaskRevealKind,TaskScope:j.TaskScope,TerminalLink:j.TerminalLink,TerminalQuickFixCommand:j.TerminalQuickFixCommand,TerminalQuickFixOpener:j.TerminalQuickFixOpener,TerminalLocation:j.TerminalLocation,TerminalProfile:j.TerminalProfile,TerminalExitReason:j.TerminalExitReason,TerminalQuickFixType:j.TerminalQuickFixType,TextDocumentSaveReason:j.TextDocumentSaveReason,TextEdit:j.TextEdit,SnippetTextEdit:j.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:j.TextEditorLineNumbersStyle,TextEditorRevealType:j.TextEditorRevealType,TextEditorSelectionChangeKind:j.TextEditorSelectionChangeKind,TextDocumentChangeReason:j.TextDocumentChangeReason,ThemeColor:j.ThemeColor,ThemeIcon:j.ThemeIcon,TreeItem:j.TreeItem,TreeItem2:j.TreeItem,TreeItemCheckboxState:j.TreeItemCheckboxState,TreeItemCollapsibleState:j.TreeItemCollapsibleState,TypeHierarchyItem:j.TypeHierarchyItem,UIKind:S.UIKind,Uri:R.URI,ViewColumn:j.ViewColumn,WorkspaceEdit:j.WorkspaceEdit,DocumentDropEdit:j.DocumentDropEdit,DocumentPasteEdit:j.DocumentPasteEdit,InlayHint:j.InlayHint,InlayHintLabelPart:j.InlayHintLabelPart,InlayHintKind:j.InlayHintKind,RemoteAuthorityResolverError:j.RemoteAuthorityResolverError,ResolvedAuthority:j.ResolvedAuthority,SourceControlInputBoxValidationType:j.SourceControlInputBoxValidationType,ExtensionRuntime:j.ExtensionRuntime,TimelineItem:j.TimelineItem,NotebookRange:j.NotebookRange,NotebookCellKind:j.NotebookCellKind,NotebookCellExecutionState:j.NotebookCellExecutionState,NotebookCellData:j.NotebookCellData,NotebookData:j.NotebookData,NotebookRendererScript:j.NotebookRendererScript,NotebookCellStatusBarAlignment:j.NotebookCellStatusBarAlignment,NotebookEditorRevealType:j.NotebookEditorRevealType,NotebookCellOutput:j.NotebookCellOutput,NotebookCellOutputItem:j.NotebookCellOutputItem,NotebookCellStatusBarItem:j.NotebookCellStatusBarItem,NotebookControllerAffinity:j.NotebookControllerAffinity,NotebookControllerAffinity2:j.NotebookControllerAffinity2,NotebookEdit:j.NotebookEdit,NotebookKernelSourceAction:j.NotebookKernelSourceAction,PortAttributes:j.PortAttributes,LinkedEditingRanges:j.LinkedEditingRanges,TestResultState:j.TestResultState,TestRunRequest:j.TestRunRequest,TestRunRequest2:j.TestRunRequest2,TestMessage:j.TestMessage,TestTag:j.TestTag,TestRunProfileKind:j.TestRunProfileKind,TextSearchCompleteMessageType:Me.TextSearchCompleteMessageType,DataTransfer:j.DataTransfer,DataTransferItem:j.DataTransferItem,CoveredCount:j.CoveredCount,FileCoverage:j.FileCoverage,StatementCoverage:j.StatementCoverage,BranchCoverage:j.BranchCoverage,FunctionCoverage:j.FunctionCoverage,WorkspaceTrustState:j.WorkspaceTrustState,LanguageStatusSeverity:j.LanguageStatusSeverity,QuickPickItemKind:j.QuickPickItemKind,InputBoxValidationSeverity:j.InputBoxValidationSeverity,TabInputText:j.TextTabInput,TabInputTextDiff:j.TextDiffTabInput,TabInputTextMerge:j.TextMergeTabInput,TabInputCustom:j.CustomEditorTabInput,TabInputNotebook:j.NotebookEditorTabInput,TabInputNotebookDiff:j.NotebookDiffEditorTabInput,TabInputWebview:j.WebviewEditorTabInput,TabInputTerminal:j.TerminalEditorTabInput,TabInputInteractiveWindow:j.InteractiveWindowInput,TelemetryTrustedValue:Y.TelemetryTrustedValue,LogLevel:De.LogLevel,EditSessionIdentityMatch:yt.EditSessionIdentityMatch,InteractiveSessionVoteDirection:j.InteractiveSessionVoteDirection,InteractiveSessionCopyKind:j.InteractiveSessionCopyKind,InteractiveEditorResponseFeedbackKind:j.InteractiveEditorResponseFeedbackKind}}}e.createApiFactoryAndRegisterActors=Pt}),define(Pe[265],Ae([1,0,69,108,32,106,33,38,59,62,110,112,113,81,72,78,107,61,37,80,57,60,233,14,111,79]),function(te,e,n,P,I,L,R,A,y,h,O,w,g,S,p,l,t,o,d,D,T,v,i,a,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,n.registerSingleton)(s.IExtHostLocalizationService,s.ExtHostLocalizationService,1),(0,n.registerSingleton)(a.ILoggerService,i.ExtHostLoggerService,1),(0,n.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService,1),(0,n.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,n.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration,0),(0,n.registerSingleton)(o.IExtHostConsumerFileSystem,o.ExtHostConsumerFileSystem,0),(0,n.registerSingleton)(w.IExtHostDebugService,w.WorkerExtHostDebugService,0),(0,n.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations,0),(0,n.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,n.registerSingleton)(d.IExtHostFileSystemInfo,d.ExtHostFileSystemInfo,0),(0,n.registerSingleton)(P.IExtHostOutputService,P.ExtHostOutputService,1),(0,n.registerSingleton)(g.IExtHostSearch,g.ExtHostSearch,0),(0,n.registerSingleton)(S.IExtHostStorage,S.ExtHostStorage,0),(0,n.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,n.registerSingleton)(h.IExtHostTerminalService,h.WorkerExtHostTerminalService,0),(0,n.registerSingleton)(p.IExtHostTunnelService,p.ExtHostTunnelService,0),(0,n.registerSingleton)(t.IExtHostWindow,t.ExtHostWindow,0),(0,n.registerSingleton)(I.IExtHostWorkspace,I.ExtHostWorkspace,0),(0,n.registerSingleton)(D.IExtHostSecretState,D.ExtHostSecretState,0),(0,n.registerSingleton)(T.IExtHostTelemetry,T.ExtHostTelemetry,0),(0,n.registerSingleton)(v.IExtHostEditorTabs,v.ExtHostEditorTabs,0),(0,n.registerSingleton)(r.IExtHostVariableResolverProvider,r.ExtHostVariableResolverProviderService,0)}),define(Pe[266],Ae([1,0,264,34,2,261,7,17,252]),function(te,e,n,P,I,L,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends L.RequireInterceptor{j(){}getModule(S,p){for(const l of this.b){const t=l(S);if(t){S=t;break}}if(this.a.has(S))return this.a.get(S).load(S,p,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends P.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=R.ExtensionRuntime.Webworker}async pb(){this.h.createInstance(y.ExtHostConsoleForwarder);const S=this.h.invokeFunction(n.createApiFactoryAndRegisterActors);this.r=this.h.createInstance(h,S,{mine:this.F,all:this.G}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.vb()}qb(S){return S.browser}async rb(S,p,l){p=p.with({path:w(p.path,".js")});const t=S?.identifier.value;t&&performance.mark(`code/extHost/willFetchExtensionCode/${t}`);const o=I.URI.revive(await this.v.$asBrowserUri(p)),d=await fetch(o.toString(!0));if(t&&performance.mark(`code/extHost/didFetchExtensionCode/${t}`),d.status!==200)throw new Error(d.statusText);const D=await d.text(),T=`${p.toString(!0)}#vscode-extension`,v=`${D}
//# sourceURL=${T}`;let i;try{i=new Function("module","exports","require",v)}catch(E){throw console.error(t?`Loading code for extension ${t} failed: ${E.message}`:`Loading code failed: ${E.message}`),console.error(`${p.toString(!0)}${typeof E.line=="number"?` line ${E.line}`:""}${typeof E.column=="number"?` column ${E.column}`:""}`),console.error(E),E}S&&await this.s.initializeLocalizedMessages(S);const a={},r={exports:a},s=E=>{const k=this.r.getModule(E,p);if(k===void 0)throw new Error(`Cannot load module '${E}'`);return k};try{return l.codeLoadingStart(),t&&performance.mark(`code/extHost/willLoadExtensionCode/${t}`),i(r,a,s),r.exports!==a?r.exports:a}finally{t&&performance.mark(`code/extHost/didLoadExtensionCode/${t}`),l.codeLoadingStop()}}async $setRemoteEnvironment(S){}async vb(S=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const p=Date.now()+S;for(;Date.now()<p&&!("__jsDebugIsReady"in globalThis);)await(0,A.timeout)(10)}}e.ExtHostExtensionService=O;function w(g,S){return g.endsWith(S)?g:g+S}}),define(Pe[267],Ae([1,0,68,69,14,34,185,82,266]),function(te,e,n,P,I,L,R,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,P.registerSingleton)(I.ILogService,new n.SyncDescriptor(R.ExtHostLogService,[!0],!0)),(0,P.registerSingleton)(L.IExtHostExtensionService,y.ExtHostExtensionService,0),(0,P.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths,0)}),define(Pe[275],Ae([1,0,25,5,76,262,254,19,83,15,2,265,267]),function(te,e,n,P,I,L,R,A,y,h,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const w=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const g=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function S(i){return/^(file|vscode-remote):/i.test(i)}const p=fetch.bind(self);function l(i){self.fetch=async function(a,r){return a instanceof Request||S(String(a))&&(a=(await i(O.URI.parse(String(a)))).toString(!0)),p(a,r)},self.XMLHttpRequest=class extends XMLHttpRequest{open(a,r,s,E,k){(async()=>(S(r.toString())&&(r=(await i(O.URI.parse(r.toString()))).toString(!0)),super.open(a,r,s??!0,E,k)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(a,r){if(/^file:/i.test(a.toString()))a=h.FileAccess.uriToBrowserUri(O.URI.parse(a.toString())).toString(!0);else if(/^vscode-remote:/i.test(a.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const E=`(${function(m){function b(V){return typeof V=="string"||V instanceof URL?String(V).replace(/^file:\/\//i,"vscode-file://vscode-app"):V}const f=fetch.bind(self);self.fetch=function(V,_){return V instanceof Request?f(V,_):f(b(V),_)},self.XMLHttpRequest=class extends XMLHttpRequest{open(V,_,G,$,B){return super.open(V,b(_),G??!0,$,B)}};const N=importScripts.bind(self);self.importScripts=(...V)=>{N(...V.map(b))},N(m)}.toString()}('${a}'))`;r=r||{},r.name=r.name||A.basename(a.toString());const k=new Blob([E],{type:"application/javascript"}),c=URL.createObjectURL(k);return new i(c,r)}}else self.Worker=class extends R.NestedWorker{constructor(i,a){super(g,i,{name:A.basename(i.toString()),...a})}};const t=new class{constructor(){this.pid=void 0}exit(i){w()}async exists(i){return!0}async realpath(i){return i}};class o{constructor(){const a=new MessageChannel,r=new P.Emitter;let s=!1;g(a.port2,[a.port2]),a.port1.onmessage=E=>{const{data:k}=E;if(!(k instanceof ArrayBuffer)){console.warn("UNKNOWN data received",k);return}const c=n.VSBuffer.wrap(new Uint8Array(k,0,k.byteLength));if((0,I.isMessageOfType)(c,2)){s=!0,D("received terminate message from renderer");return}r.fire(c)},this.protocol={onMessage:r.event,send:E=>{if(!s){const k=E.buffer.buffer.slice(E.buffer.byteOffset,E.buffer.byteOffset+E.buffer.byteLength);a.port1.postMessage(k,[k])}}}}}function d(i){return new Promise(a=>{const r=i.onMessage(s=>{r.dispose();const E=JSON.parse(s.toString());i.send((0,I.createMessageOfType)(0)),a({protocol:i,initData:E})});i.send((0,I.createMessageOfType)(1))})}let D=i=>w();function T(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function v(){y.mark("code/extHost/willConnectToRenderer");const i=new o;return{onmessage(a){T(a)&&d(i.protocol).then(r=>{y.mark("code/extHost/didWaitForInitData");const s=new L.ExtensionHostMain(r.protocol,r.initData,t,null,a.data);l(E=>s.asBrowserUri(E)),D=E=>s.terminate(E)})}}}e.create=v})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/workbench/api/worker/extensionHostWorker.js.map
