/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var W=["require","exports","vs/base/common/lifecycle","vs/base/common/observableImpl/logging","vs/base/common/errors","vs/base/common/platform","vs/base/common/observableImpl/base","vs/editor/common/tokens/lineTokens","vs/base/common/observableImpl/autorun","vs/base/common/observableImpl/derived","vs/base/common/observable","vs/base/common/buffer","vs/editor/common/core/eolCounter","vs/editor/common/encodedTokenAttributes","vs/editor/common/core/lineRange","vs/editor/common/tokens/contiguousMultilineTokensBuilder","vs/base/common/uri","vs/base/common/resources","vs/base/common/async","vs/editor/common/languages/nullTokenize","vs/base/common/observableImpl/utils","vs/base/common/stream","vs/base/common/symbols","vs/editor/common/model/fixedArray","vs/base/common/arrays","vs/editor/common/tokens/contiguousTokensEditing","vs/editor/common/tokens/contiguousMultilineTokens","vs/base/common/extpath","vs/base/common/path","vs/base/common/strings","vs/base/common/network","vs/base/common/event","vs/editor/common/languages","vs/editor/common/model/textModelTokens","vs/workbench/services/textMate/browser/tokenizationSupport/textMateTokenizationSupport","vs/workbench/services/textMate/browser/tokenizationSupport/tokenizationSupportWithLineLimit","vs/workbench/services/textMate/common/TMScopeRegistry","vs/workbench/services/textMate/common/TMGrammarFactory","vs/workbench/services/textMate/browser/worker/textMateWorkerModel","vs/editor/common/core/position","vs/base/common/types","vs/base/common/cancellation","vs/base/common/stopwatch","vs/editor/common/core/offsetRange","vs/editor/common/model/mirrorTextModel","vscode-textmate","vs/workbench/services/textMate/browser/worker/textMate.worker"],p=function(F){for(var e=[],E=0,k=F.length;E<k;E++)e[E]=W[F[E]];return e};define(W[3],p([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConsoleObservableLogger=e.getLogger=e.setLogger=void 0;let E;function k(a){E=a}e.setLogger=k;function T(){return E}e.getLogger=T;class I{constructor(){this.a=0,this.d=new WeakMap}b(h){return n([c(w("|  ",this.a)),h])}c(h){return h.didChange?[c(" "),i(r(h.oldValue,70),{color:"red",strikeThrough:!0}),c(" "),i(r(h.newValue,60),{color:"green"})]:[c(" (unchanged)")]}handleObservableChanged(h,O){console.log(...this.b([t("observable value changed"),i(h.debugName,{color:"BlueViolet"}),...this.c(O)]))}formatChanges(h){if(h.size!==0)return i(" (changed deps: "+[...h].map(O=>O.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(h){const O=h.handleChange;this.d.set(h,new Set),h.handleChange=(A,B)=>(this.d.get(h).add(A),O.apply(h,[A,B]))}handleDerivedRecomputed(h,O){const A=this.d.get(h);console.log(...this.b([t("derived recomputed"),i(h.debugName,{color:"BlueViolet"}),...this.c(O),this.formatChanges(A)])),A.clear()}handleFromEventObservableTriggered(h,O){console.log(...this.b([t("observable from event triggered"),i(h.debugName,{color:"BlueViolet"}),...this.c(O)]))}handleAutorunCreated(h){const O=h.handleChange;this.d.set(h,new Set),h.handleChange=(A,B)=>(this.d.get(h).add(A),O.apply(h,[A,B]))}handleAutorunTriggered(h){const O=this.d.get(h);console.log(...this.b([t("autorun"),i(h.debugName,{color:"BlueViolet"}),this.formatChanges(O)])),O.clear()}handleBeginTransaction(h){let O=h.getDebugName();O===void 0&&(O=""),console.log(...this.b([t("transaction"),i(O,{color:"BlueViolet"})])),this.a++}handleEndTransaction(){this.a--}}e.ConsoleObservableLogger=I;function n(a){const h=new Array,A={};let B="";function R(f){if("length"in f)for(const b of f)b&&R(b);else"text"in f?(B+=`%c${f.text}`,h.push(f.style),f.data&&Object.assign(A,f.data)):"data"in f&&Object.assign(A,f.data)}R(a);const y=[B,...h];return Object.keys(A).length>0&&y.push(A),y}function c(a){return i(a,{color:"black"})}function t(a){return i(u(`${a}: `,10),{color:"black",bold:!0})}function i(a,h={color:"black"}){function O(B){return Object.entries(B).reduce((R,[y,f])=>`${R}${y}:${f};`,"")}const A={color:h.color};return h.strikeThrough&&(A["text-decoration"]="line-through"),h.bold&&(A["font-weight"]="bold"),{text:a,style:O(A)}}function r(a,h){switch(typeof a){case"number":return""+a;case"string":return a.length+2<=h?`"${a}"`:`"${a.substr(0,h-7)}"+...`;case"boolean":return a?"true":"false";case"undefined":return"undefined";case"object":return a===null?"null":Array.isArray(a)?s(a,h):m(a,h);case"symbol":return a.toString();case"function":return`[[Function${a.name?" "+a.name:""}]]`;default:return""+a}}function s(a,h){let O="[ ",A=!0;for(const B of a){if(A||(O+=", "),O.length-5>h){O+="...";break}A=!1,O+=`${r(B,h-O.length)}`}return O+=" ]",O}function m(a,h){let O="{ ",A=!0;for(const[B,R]of Object.entries(a)){if(A||(O+=", "),O.length-5>h){O+="...";break}A=!1,O+=`${B}: ${r(R,h-O.length)}`}return O+=" }",O}function w(a,h){let O="";for(let A=1;A<=h;A++)O+=a;return O}function u(a,h){for(;a.length<h;)a+=" ";return a}}),define(W[8],p([0,1,2,3]),function(F,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunDelta=e.AutorunObserver=e.autorunWithStore=e.autorunHandleChanges=e.autorun=void 0;function T(r,s){return new t(r,s,void 0)}e.autorun=T;function I(r,s,m){return new t(r,m,s.handleChange)}e.autorunHandleChanges=I;function n(r,s){const m=new E.DisposableStore,w=T(s,u=>{m.clear(),r(u,m)});return(0,E.toDisposable)(()=>{w.dispose(),m.dispose()})}e.autorunWithStore=n;var c;(function(r){r[r.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",r[r.stale=2]="stale",r[r.upToDate=3]="upToDate"})(c||(c={}));class t{constructor(s,m,w){this.debugName=s,this.g=m,this.h=w,this.a=2,this.b=0,this.c=!1,this.e=new Set,this.f=new Set,(0,k.getLogger)()?.handleAutorunCreated(this),this.i()}dispose(){this.c=!0;for(const s of this.e)s.removeObserver(this);this.e.clear()}i(){if(this.a===3)return;const s=this.f;this.f=this.e,this.e=s,this.a=3,(0,k.getLogger)()?.handleAutorunTriggered(this);try{this.g(this)}finally{for(const m of this.f)m.removeObserver(this);this.f.clear()}}toString(){return`Autorun<${this.debugName}>`}beginUpdate(){this.a===3&&(this.a=1),this.b++}endUpdate(){if(this.b===1)do{if(this.a===1){this.a=3;for(const s of this.e)if(s.reportChanges(),this.a===2)break}this.i()}while(this.a!==3);this.b--}handlePossibleChange(s){this.a===3&&this.e.has(s)&&(this.a=1)}handleChange(s,m){this.e.has(s)&&(!this.h||this.h({changedObservable:s,change:m,didChange:u=>u===s}))&&(this.a=2)}readObservable(s){if(this.c)return s.get();s.addObserver(this);const m=s.get();return this.e.add(s),this.f.delete(s),m}}e.AutorunObserver=t,function(r){r.Observer=t}(T||(e.autorun=T={}));function i(r,s,m){let w;return T(r,u=>{const a=s.read(u),h=w;w=a,m({lastValue:h,newValue:a})})}e.autorunDelta=i}),define(W[6],p([0,1,3]),function(F,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableObservableValue=e.disposableObservableValue=e.ObservableValue=e.observableValue=e.getFunctionName=e.TransactionImpl=e.transaction=e.BaseObservable=e.ConvenientObservable=e._setDerived=void 0;let k;function T(u){k=u}e._setDerived=T;class I{get TChange(){return null}reportChanges(){this.get()}read(a){return a?a.readObservable(this):this.get()}map(a){return k(()=>{const h=i(a);return h!==void 0?h:`${this.debugName} (mapped)`},h=>a(this.read(h),h))}}e.ConvenientObservable=I;class n extends I{constructor(){super(...arguments),this.a=new Set}addObserver(a){const h=this.a.size;this.a.add(a),h===0&&this.b()}removeObserver(a){this.a.delete(a)&&this.a.size===0&&this.c()}b(){}c(){}}e.BaseObservable=n;function c(u,a){const h=new t(u,a);try{(0,E.getLogger)()?.handleBeginTransaction(h),u(h)}finally{h.finish(),(0,E.getLogger)()?.handleEndTransaction()}}e.transaction=c;class t{constructor(a,h){this.b=a,this.c=h,this.a=[]}getDebugName(){return this.c?this.c():i(this.b)}updateObserver(a,h){this.a.push({observer:a,observable:h}),a.beginUpdate(h)}finish(){const a=this.a;this.a=null;for(const{observer:h,observable:O}of a)h.endUpdate(O)}}e.TransactionImpl=t;function i(u){const a=u.toString(),O=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(a);return(O?O[1]:void 0)?.trim()}e.getFunctionName=i;function r(u,a){return new s(u,a)}e.observableValue=r;class s extends n{constructor(a,h){super(),this.debugName=a,this.d=h}get(){return this.d}set(a,h,O){if(this.d===a)return;let A;h||(h=A=new t(()=>{},()=>`Setting ${this.debugName}`));try{const B=this.d;this.e(a),(0,E.getLogger)()?.handleObservableChanged(this,{oldValue:B,newValue:a,change:O,didChange:!0});for(const R of this.a)h.updateObserver(R,this),R.handleChange(this,O)}finally{A&&A.finish()}}toString(){return`${this.debugName}: ${this.d}`}e(a){this.d=a}}e.ObservableValue=s;function m(u,a){return new w(u,a)}e.disposableObservableValue=m;class w extends s{e(a){this.d!==a&&(this.d&&this.d.dispose(),this.d=a)}dispose(){this.d?.dispose()}}e.DisposableObservableValue=w}),define(W[9],p([0,1,4,6,3]),function(F,e,E,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Derived=e.derived=void 0;function I(t,i){return new c(t,i)}e.derived=I,(0,k._setDerived)(I);var n;(function(t){t[t.initial=0]="initial",t[t.dependenciesMightHaveChanged=1]="dependenciesMightHaveChanged",t[t.stale=2]="stale",t[t.upToDate=3]="upToDate"})(n||(n={}));class c extends k.BaseObservable{get debugName(){return typeof this.j=="function"?this.j():this.j}constructor(i,r){super(),this.j=i,this.k=r,this.e=0,this.f=void 0,this.g=0,this.h=new Set,this.i=new Set,(0,T.getLogger)()?.handleDerivedCreated(this)}c(){this.e=0,this.f=void 0;for(const i of this.h)i.removeObserver(this);this.h.clear()}get(){if(this.a.size===0){const i=this.k(this);return this.c(),i}else{do{if(this.e===1){this.e=3;for(const i of this.h)if(i.reportChanges(),this.e===2)break}this.m()}while(this.e!==3);return this.f}}m(){if(this.e===3)return;const i=this.i;this.i=this.h,this.h=i;const r=this.e!==0,s=this.f;this.e=3;try{this.f=this.k(this)}finally{for(const w of this.i)w.removeObserver(this);this.i.clear()}const m=r&&s!==this.f;if((0,T.getLogger)()?.handleDerivedRecomputed(this,{oldValue:s,newValue:this.f,change:void 0,didChange:m}),m)for(const w of this.a)w.handleChange(this,void 0)}toString(){return`LazyDerived<${this.debugName}>`}beginUpdate(){this.g++;const i=this.g===1;if(this.e===3&&(this.e=1,!i))for(const r of this.a)r.handlePossibleChange(this);if(i)for(const r of this.a)r.beginUpdate(this)}endUpdate(){if(this.g--,this.g===0){const i=[...this.a];for(const r of i)r.endUpdate(this)}if(this.g<0)throw new E.BugIndicatingError}handlePossibleChange(i){if(this.e===3&&this.h.has(i)){this.e=1;for(const r of this.a)r.handlePossibleChange(this)}}handleChange(i,r){const s=this.e===3;if((this.e===1||s)&&this.h.has(i)&&(this.e=2,s))for(const m of this.a)m.handlePossibleChange(this)}readObservable(i){i.addObserver(this);const r=i.get();return this.h.add(i),this.i.delete(i),r}}e.Derived=c}),define(W[20],p([0,1,2,8,6,9,3]),function(F,e,E,k,T,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.derivedObservableWithWritableCache=e.derivedObservableWithCache=e.keepAlive=e.wasEventTriggeredRecently=e.debouncedObservable=e.observableSignal=e.observableSignalFromEvent=e.FromEventObservable=e.observableFromEvent=e.waitForState=e.observableFromPromise=e.constObservable=void 0;function c(b){return new t(b)}e.constObservable=c;class t extends T.ConvenientObservable{constructor(v){super(),this.a=v}get debugName(){return this.toString()}get(){return this.a}addObserver(v){}removeObserver(v){}toString(){return`Const: ${this.a}`}}function i(b){const v=(0,T.observableValue)("promiseValue",{});return b.then(L=>{v.set({value:L},void 0)}),v}e.observableFromPromise=i;function r(b,v){return new Promise(L=>{let U=!1,d=!1;const g=(0,k.autorun)("waitForState",l=>{const C=b.read(l);v(C)&&(U?g.dispose():d=!0,L(C))});U=!0,d&&g.dispose()})}e.waitForState=r;function s(b,v){return new m(b,v)}e.observableFromEvent=s;class m extends T.BaseObservable{constructor(v,L){super(),this.h=v,this.i=L,this.f=!1,this.l=U=>{const d=this.i(U),g=!this.f||this.e!==d;(0,n.getLogger)()?.handleFromEventObservableTriggered(this,{oldValue:this.e,newValue:d,change:void 0,didChange:g}),g&&(this.e=d,this.f&&(0,T.transaction)(l=>{for(const C of this.a)l.updateObserver(C,this),C.handleChange(this,void 0)},()=>{const l=this.j();return"Event fired"+(l?`: ${l}`:"")}),this.f=!0)}}j(){return(0,T.getFunctionName)(this.i)}get debugName(){const v=this.j();return"From Event"+(v?`: ${v}`:"")}b(){this.g=this.h(this.l)}c(){this.g.dispose(),this.g=void 0,this.f=!1,this.e=void 0}get(){return this.g?(this.f||this.l(void 0),this.e):this.i(void 0)}}e.FromEventObservable=m,function(b){b.Observer=m}(s||(e.observableFromEvent=s={}));function w(b,v){return new u(b,v)}e.observableSignalFromEvent=w;class u extends T.BaseObservable{constructor(v,L){super(),this.debugName=v,this.f=L,this.h=()=>{(0,T.transaction)(U=>{for(const d of this.a)U.updateObserver(d,this),d.handleChange(this,void 0)},()=>this.debugName)}}b(){this.e=this.f(this.h)}c(){this.e.dispose(),this.e=void 0}get(){}}function a(b){return new h(b)}e.observableSignal=a;class h extends T.BaseObservable{constructor(v){super(),this.debugName=v}trigger(v,L){if(!v){(0,T.transaction)(U=>{this.trigger(U,L)},()=>`Trigger signal ${this.debugName}`);return}for(const U of this.a)v.updateObserver(U,this),U.handleChange(this,L)}get(){}}function O(b,v,L){const U=(0,T.observableValue)("debounced",void 0);let d;return L.add((0,k.autorun)("debounce",g=>{const l=b.read(g);d&&clearTimeout(d),d=setTimeout(()=>{(0,T.transaction)(C=>{U.set(l,C)})},v)})),U}e.debouncedObservable=O;function A(b,v,L){const U=(0,T.observableValue)("triggeredRecently",!1);let d;return L.add(b(()=>{U.set(!0,void 0),d&&clearTimeout(d),d=setTimeout(()=>{U.set(!1,void 0)},v)})),U}e.wasEventTriggeredRecently=A;function B(b){const v=new R;return b.addObserver(v),(0,E.toDisposable)(()=>{b.removeObserver(v)})}e.keepAlive=B;class R{beginUpdate(v){}endUpdate(v){}handlePossibleChange(v){}handleChange(v,L){}}function y(b,v){let L;return(0,I.derived)(b,d=>(L=v(d,L),L))}e.derivedObservableWithCache=y;function f(b,v){let L;const U=(0,T.observableValue)("derivedObservableWithWritableCache.counter",0),d=(0,I.derived)(b,g=>(U.read(g),L=v(g,L),L));return Object.assign(d,{clearCache:g=>{L=void 0,U.set(U.get()+1,g)}})}e.derivedObservableWithWritableCache=f});var ee=this&&this.__createBinding||(Object.create?function(F,e,E,k){k===void 0&&(k=E);var T=Object.getOwnPropertyDescriptor(e,E);(!T||("get"in T?!e.__esModule:T.writable||T.configurable))&&(T={enumerable:!0,get:function(){return e[E]}}),Object.defineProperty(F,k,T)}:function(F,e,E,k){k===void 0&&(k=E),F[k]=e[E]}),te=this&&this.__exportStar||function(F,e){for(var E in F)E!=="default"&&!Object.prototype.hasOwnProperty.call(e,E)&&ee(e,F,E)};define(W[10],p([0,1,6,9,8,20,3]),function(F,e,E,k,T,I,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.autorunWithStore=e.autorunHandleChanges=e.autorunDelta=e.autorun=e.derived=e.transaction=e.observableValue=void 0,Object.defineProperty(e,"observableValue",{enumerable:!0,get:function(){return E.observableValue}}),Object.defineProperty(e,"transaction",{enumerable:!0,get:function(){return E.transaction}}),Object.defineProperty(e,"derived",{enumerable:!0,get:function(){return k.derived}}),Object.defineProperty(e,"autorun",{enumerable:!0,get:function(){return T.autorun}}),Object.defineProperty(e,"autorunDelta",{enumerable:!0,get:function(){return T.autorunDelta}}),Object.defineProperty(e,"autorunHandleChanges",{enumerable:!0,get:function(){return T.autorunHandleChanges}}),Object.defineProperty(e,"autorunWithStore",{enumerable:!0,get:function(){return T.autorunWithStore}}),te(I,e),!1&&(0,n.setLogger)(new n.ConsoleObservableLogger)}),define(W[21],p([0,1,4,2]),function(F,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function T(R){const y=R;return y?typeof y.read=="function":!1}e.isReadable=T;function I(R){const y=R;return y?[y.on,y.pause,y.resume,y.destroy].every(f=>typeof f=="function"):!1}e.isReadableStream=I;function n(R){const y=R;return y?I(y.stream)&&Array.isArray(y.buffer)&&typeof y.ended=="boolean":!1}e.isReadableBufferedStream=n;function c(R,y){return new t(R,y)}e.newWriteableStream=c;class t{constructor(y,f){this.e=y,this.f=f,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(y){if(!this.a.destroyed){if(this.a.flowing)this.g(y);else if(this.b.data.push(y),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(f=>this.d.push(f))}}error(y){this.a.destroyed||(this.a.flowing?this.h(y):this.b.error.push(y))}end(y){this.a.destroyed||(typeof y<"u"&&this.write(y),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(y){this.c.data.slice(0).forEach(f=>f(y))}h(y){this.c.error.length===0?(0,E.onUnexpectedError)(y):this.c.error.slice(0).forEach(f=>f(y))}i(){this.c.end.slice(0).forEach(y=>y())}on(y,f){if(!this.a.destroyed)switch(y){case"data":this.c.data.push(f),this.resume();break;case"end":this.c.end.push(f),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(f),this.a.flowing&&this.k();break}}removeListener(y,f){if(this.a.destroyed)return;let b;switch(y){case"data":b=this.c.data;break;case"end":b=this.c.end;break;case"error":b=this.c.error;break}if(b){const v=b.indexOf(f);v>=0&&b.splice(v,1)}}j(){if(this.b.data.length>0){const y=this.e(this.b.data);this.g(y),this.b.data.length=0;const f=[...this.d];this.d.length=0,f.forEach(b=>b())}}k(){if(this.c.error.length>0){for(const y of this.b.error)this.h(y);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function i(R,y){const f=[];let b;for(;(b=R.read())!==null;)f.push(b);return y(f)}e.consumeReadable=i;function r(R,y,f){const b=[];let v;for(;(v=R.read())!==null&&b.length<f;)b.push(v);return v===null&&b.length>0?y(b):{read:()=>{if(b.length>0)return b.shift();if(typeof v<"u"){const L=v;return v=void 0,L}return R.read()}}}e.peekReadable=r;function s(R,y){return new Promise((f,b)=>{const v=[];m(R,{onData:L=>{y&&v.push(L)},onError:L=>{y?b(L):f(void 0)},onEnd:()=>{f(y?y(v):void 0)}})})}e.consumeStream=s;function m(R,y){let f=!1;return R.on("error",b=>{f||y.onError(b)}),R.on("end",()=>{f||y.onEnd()}),R.on("data",b=>{f||y.onData(b)}),(0,k.toDisposable)(()=>f=!0)}e.listenStream=m;function w(R,y){return new Promise((f,b)=>{const v=new k.DisposableStore,L=[],U=l=>{if(L.push(l),L.length>y)return v.dispose(),R.pause(),f({stream:R,buffer:L,ended:!1})},d=l=>b(l),g=()=>f({stream:R,buffer:L,ended:!0});v.add((0,k.toDisposable)(()=>R.removeListener("error",d))),R.on("error",d),v.add((0,k.toDisposable)(()=>R.removeListener("end",g))),R.on("end",g),v.add((0,k.toDisposable)(()=>R.removeListener("data",U))),R.on("data",U)})}e.peekStream=w;function u(R,y){const f=c(y);return f.end(R),f}e.toStream=u;function a(){const R=c(()=>{throw new Error("not supported")});return R.end(),R}e.emptyStream=a;function h(R){let y=!1;return{read:()=>y?null:(y=!0,R)}}e.toReadable=h;function O(R,y,f){const b=c(f);return m(R,{onData:v=>b.write(y.data(v)),onError:v=>b.error(y.error?y.error(v):v),onEnd:()=>b.end()}),b}e.transform=O;function A(R,y,f){let b=!1;return{read:()=>{const v=y.read();return b?v:(b=!0,v!==null?f([R,v]):R)}}}e.prefixedReadable=A;function B(R,y,f){let b=!1;const v=c(f);return m(y,{onData:L=>b?v.write(L):(b=!0,v.write(f([R,L]))),onError:L=>v.error(L),onEnd:()=>{b||(b=!0,v.write(R)),v.end()}}),v}e.prefixedStream=B}),define(W[11],p([0,1,21]),function(F,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const k=typeof Buffer<"u";let T,I;class n{static alloc(l){return k?new n(Buffer.allocUnsafe(l)):new n(new Uint8Array(l))}static wrap(l){return k&&!Buffer.isBuffer(l)&&(l=Buffer.from(l.buffer,l.byteOffset,l.byteLength)),new n(l)}static fromString(l,C){return!(C?.dontUseNodeBuffer||!1)&&k?new n(Buffer.from(l)):(T||(T=new TextEncoder),new n(T.encode(l)))}static fromByteArray(l){const C=n.alloc(l.length);for(let z=0,D=l.length;z<D;z++)C.buffer[z]=l[z];return C}static concat(l,C){if(typeof C>"u"){C=0;for(let q=0,$=l.length;q<$;q++)C+=l[q].byteLength}const z=n.alloc(C);let D=0;for(let q=0,$=l.length;q<$;q++){const _=l[q];z.set(_,D),D+=_.byteLength}return z}constructor(l){this.buffer=l,this.byteLength=this.buffer.byteLength}clone(){const l=n.alloc(this.byteLength);return l.set(this),l}toString(){return k?this.buffer.toString():(I||(I=new TextDecoder),I.decode(this.buffer))}slice(l,C){return new n(this.buffer.subarray(l,C))}set(l,C){if(l instanceof n)this.buffer.set(l.buffer,C);else if(l instanceof Uint8Array)this.buffer.set(l,C);else if(l instanceof ArrayBuffer)this.buffer.set(new Uint8Array(l),C);else if(ArrayBuffer.isView(l))this.buffer.set(new Uint8Array(l.buffer,l.byteOffset,l.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(l){return i(this.buffer,l)}writeUInt32BE(l,C){r(this.buffer,l,C)}readUInt32LE(l){return s(this.buffer,l)}writeUInt32LE(l,C){m(this.buffer,l,C)}readUInt8(l){return w(this.buffer,l)}writeUInt8(l,C){u(this.buffer,l,C)}}e.VSBuffer=n;function c(g,l){return g[l+0]<<0>>>0|g[l+1]<<8>>>0}e.readUInt16LE=c;function t(g,l,C){g[C+0]=l&255,l=l>>>8,g[C+1]=l&255}e.writeUInt16LE=t;function i(g,l){return g[l]*2**24+g[l+1]*2**16+g[l+2]*2**8+g[l+3]}e.readUInt32BE=i;function r(g,l,C){g[C+3]=l,l=l>>>8,g[C+2]=l,l=l>>>8,g[C+1]=l,l=l>>>8,g[C]=l}e.writeUInt32BE=r;function s(g,l){return g[l+0]<<0>>>0|g[l+1]<<8>>>0|g[l+2]<<16>>>0|g[l+3]<<24>>>0}e.readUInt32LE=s;function m(g,l,C){g[C+0]=l&255,l=l>>>8,g[C+1]=l&255,l=l>>>8,g[C+2]=l&255,l=l>>>8,g[C+3]=l&255}e.writeUInt32LE=m;function w(g,l){return g[l]}e.readUInt8=w;function u(g,l,C){g[C]=l}e.writeUInt8=u;function a(g){return E.consumeReadable(g,l=>n.concat(l))}e.readableToBuffer=a;function h(g){return E.toReadable(g)}e.bufferToReadable=h;function O(g){return E.consumeStream(g,l=>n.concat(l))}e.streamToBuffer=O;async function A(g){return g.ended?n.concat(g.buffer):n.concat([...g.buffer,await O(g.stream)])}e.bufferedStreamToBuffer=A;function B(g){return E.toStream(g,l=>n.concat(l))}e.bufferToStream=B;function R(g){return E.transform(g,{data:l=>typeof l=="string"?n.fromString(l):n.wrap(l)},l=>n.concat(l))}e.streamToBufferReadableStream=R;function y(g){return E.newWriteableStream(l=>n.concat(l),g)}e.newWriteableBufferStream=y;function f(g,l){return E.prefixedReadable(g,l,C=>n.concat(C))}e.prefixedBufferReadable=f;function b(g,l){return E.prefixedStream(g,l,C=>n.concat(C))}e.prefixedBufferStream=b;function v(g){let l=0,C=0,z=0;const D=new Uint8Array(Math.floor(g.length/4*3)),q=_=>{switch(C){case 3:D[z++]=l|_,C=0;break;case 2:D[z++]=l|_>>>2,l=_<<6,C=3;break;case 1:D[z++]=l|_>>>4,l=_<<4,C=2;break;default:l=_<<2,C=1}};for(let _=0;_<g.length;_++){const K=g.charCodeAt(_);if(K>=65&&K<=90)q(K-65);else if(K>=97&&K<=122)q(K-97+26);else if(K>=48&&K<=57)q(K-48+52);else if(K===43||K===45)q(62);else if(K===47||K===95)q(63);else{if(K===61)break;throw new SyntaxError(`Unexpected base64 character ${g[_]}`)}}const $=z;for(;C>0;)q(0);return n.wrap(D).slice(0,$)}e.decodeBase64=v;const L="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",U="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function d({buffer:g},l=!0,C=!1){const z=C?U:L;let D="";const q=g.byteLength%3;let $=0;for(;$<g.byteLength-q;$+=3){const _=g[$+0],K=g[$+1],Q=g[$+2];D+=z[_>>>2],D+=z[(_<<4|K>>>4)&63],D+=z[(K<<2|Q>>>6)&63],D+=z[Q&63]}if(q===1){const _=g[$+0];D+=z[_>>>2],D+=z[_<<4&63],l&&(D+="==")}else if(q===2){const _=g[$+0],K=g[$+1];D+=z[_>>>2],D+=z[(_<<4|K>>>4)&63],D+=z[K<<2&63],l&&(D+="=")}return D}e.encodeBase64=d}),define(W[22],p([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(W[12],p([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.countEOL=e.StringEOL=void 0;var E;(function(T){T[T.Unknown=0]="Unknown",T[T.Invalid=3]="Invalid",T[T.LF=1]="LF",T[T.CRLF=2]="CRLF"})(E||(e.StringEOL=E={}));function k(T){let I=0,n=0,c=0,t=0;for(let i=0,r=T.length;i<r;i++){const s=T.charCodeAt(i);s===13?(I===0&&(n=i),I++,i+1<r&&T.charCodeAt(i+1)===10?(t|=2,i++):t|=3,c=i+1):s===10&&(t|=1,I===0&&(n=i),I++,c=i+1)}return I===0&&(n=T.length),[I,n,T.length-c,t]}e.countEOL=k}),define(W[13],p([0,1]),function(F,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageId=void 0;var E;(function(t){t[t.Null=0]="Null",t[t.PlainText=1]="PlainText"})(E||(e.LanguageId=E={}));var k;(function(t){t[t.NotSet=-1]="NotSet",t[t.None=0]="None",t[t.Italic=1]="Italic",t[t.Bold=2]="Bold",t[t.Underline=4]="Underline",t[t.Strikethrough=8]="Strikethrough"})(k||(e.FontStyle=k={}));var T;(function(t){t[t.None=0]="None",t[t.DefaultForeground=1]="DefaultForeground",t[t.DefaultBackground=2]="DefaultBackground"})(T||(e.ColorId=T={}));var I;(function(t){t[t.Other=0]="Other",t[t.Comment=1]="Comment",t[t.String=2]="String",t[t.RegEx=3]="RegEx"})(I||(e.StandardTokenType=I={}));var n;(function(t){t[t.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",t[t.TOKEN_TYPE_MASK=768]="TOKEN_TYPE_MASK",t[t.BALANCED_BRACKETS_MASK=1024]="BALANCED_BRACKETS_MASK",t[t.FONT_STYLE_MASK=30720]="FONT_STYLE_MASK",t[t.FOREGROUND_MASK=16744448]="FOREGROUND_MASK",t[t.BACKGROUND_MASK=4278190080]="BACKGROUND_MASK",t[t.ITALIC_MASK=2048]="ITALIC_MASK",t[t.BOLD_MASK=4096]="BOLD_MASK",t[t.UNDERLINE_MASK=8192]="UNDERLINE_MASK",t[t.STRIKETHROUGH_MASK=16384]="STRIKETHROUGH_MASK",t[t.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",t[t.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",t[t.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",t[t.SEMANTIC_USE_STRIKETHROUGH=8]="SEMANTIC_USE_STRIKETHROUGH",t[t.SEMANTIC_USE_FOREGROUND=16]="SEMANTIC_USE_FOREGROUND",t[t.SEMANTIC_USE_BACKGROUND=32]="SEMANTIC_USE_BACKGROUND",t[t.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",t[t.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",t[t.BALANCED_BRACKETS_OFFSET=10]="BALANCED_BRACKETS_OFFSET",t[t.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",t[t.FOREGROUND_OFFSET=15]="FOREGROUND_OFFSET",t[t.BACKGROUND_OFFSET=24]="BACKGROUND_OFFSET"})(n||(e.MetadataConsts=n={}));class c{static getLanguageId(i){return(i&255)>>>0}static getTokenType(i){return(i&768)>>>8}static containsBalancedBrackets(i){return(i&1024)!==0}static getFontStyle(i){return(i&30720)>>>11}static getForeground(i){return(i&16744448)>>>15}static getBackground(i){return(i&4278190080)>>>24}static getClassNameFromMetadata(i){let s="mtk"+this.getForeground(i);const m=this.getFontStyle(i);return m&1&&(s+=" mtki"),m&2&&(s+=" mtkb"),m&4&&(s+=" mtku"),m&8&&(s+=" mtks"),s}static getInlineStyleFromMetadata(i,r){const s=this.getForeground(i),m=this.getFontStyle(i);let w=`color: ${r[s]};`;m&1&&(w+="font-style: italic;"),m&2&&(w+="font-weight: bold;");let u="";return m&4&&(u+=" underline"),m&8&&(u+=" line-through"),u&&(w+=`text-decoration:${u};`),w}static getPresentationFromMetadata(i){const r=this.getForeground(i),s=this.getFontStyle(i);return{foreground:r,italic:!!(s&1),bold:!!(s&2),underline:!!(s&4),strikethrough:!!(s&8)}}}e.TokenMetadata=c}),define(W[23],p([0,1,24]),function(F,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FixedArray=void 0;class k{constructor(n){this.b=n,this.a=[]}get(n){return n<this.a.length?this.a[n]:this.b}set(n,c){for(;n>=this.a.length;)this.a[this.a.length]=this.b;this.a[n]=c}replace(n,c,t){if(n>=this.a.length)return;if(c===0){this.insert(n,t);return}else if(t===0){this.delete(n,c);return}const i=this.a.slice(0,n),r=this.a.slice(n+c),s=T(t,this.b);this.a=i.concat(s,r)}delete(n,c){c===0||n>=this.a.length||this.a.splice(n,c)}insert(n,c){if(c===0||n>=this.a.length)return;const t=[];for(let i=0;i<c;i++)t[i]=this.b;this.a=(0,E.arrayInsert)(this.a,n,t)}}e.FixedArray=k;function T(I,n){const c=[];for(let t=0;t<I;t++)c[t]=n;return c}}),define(W[7],p([0,1,13]),function(F,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineTokens=void 0;class k{static createEmpty(n,c){const t=k.defaultTokenMetadata,i=new Uint32Array(2);return i[0]=n.length,i[1]=t,new k(i,n,c)}constructor(n,c,t){this._lineTokensBrand=void 0,this.a=n,this.b=this.a.length>>>1,this.c=c,this.d=t}equals(n){return n instanceof k?this.slicedEquals(n,0,this.b):!1}slicedEquals(n,c,t){if(this.c!==n.c||this.b!==n.b)return!1;const i=c<<1,r=i+(t<<1);for(let s=i;s<r;s++)if(this.a[s]!==n.a[s])return!1;return!0}getLineContent(){return this.c}getCount(){return this.b}getStartOffset(n){return n>0?this.a[n-1<<1]:0}getMetadata(n){return this.a[(n<<1)+1]}getLanguageId(n){const c=this.a[(n<<1)+1],t=E.TokenMetadata.getLanguageId(c);return this.d.decodeLanguageId(t)}getStandardTokenType(n){const c=this.a[(n<<1)+1];return E.TokenMetadata.getTokenType(c)}getForeground(n){const c=this.a[(n<<1)+1];return E.TokenMetadata.getForeground(c)}getClassName(n){const c=this.a[(n<<1)+1];return E.TokenMetadata.getClassNameFromMetadata(c)}getInlineStyle(n,c){const t=this.a[(n<<1)+1];return E.TokenMetadata.getInlineStyleFromMetadata(t,c)}getPresentation(n){const c=this.a[(n<<1)+1];return E.TokenMetadata.getPresentationFromMetadata(c)}getEndOffset(n){return this.a[n<<1]}findTokenIndexAtOffset(n){return k.findIndexInTokensArray(this.a,n)}inflate(){return this}sliceAndInflate(n,c,t){return new T(this,n,c,t)}static convertToEndOffset(n,c){const i=(n.length>>>1)-1;for(let r=0;r<i;r++)n[r<<1]=n[r+1<<1];n[i<<1]=c}static findIndexInTokensArray(n,c){if(n.length<=2)return 0;let t=0,i=(n.length>>>1)-1;for(;t<i;){const r=t+Math.floor((i-t)/2),s=n[r<<1];if(s===c)return r+1;s<c?t=r+1:s>c&&(i=r)}return t}withInserted(n){if(n.length===0)return this;let c=0,t=0,i="";const r=new Array;let s=0;for(;;){const m=c<this.b?this.a[c<<1]:-1,w=t<n.length?n[t]:null;if(m!==-1&&(w===null||m<=w.offset)){i+=this.c.substring(s,m);const u=this.a[(c<<1)+1];r.push(i.length,u),c++,s=m}else if(w){if(w.offset>s){i+=this.c.substring(s,w.offset);const u=this.a[(c<<1)+1];r.push(i.length,u),s=w.offset}i+=w.text,r.push(i.length,w.tokenMetadata),t++}else break}return new k(new Uint32Array(r),i,this.d)}}e.LineTokens=k,k.defaultTokenMetadata=(0<<11|1<<15|2<<24)>>>0;class T{constructor(n,c,t,i){this.a=n,this.b=c,this.c=t,this.d=i,this.e=n.findTokenIndexAtOffset(c),this.f=0;for(let r=this.e,s=n.getCount();r<s&&!(n.getStartOffset(r)>=t);r++)this.f++}getMetadata(n){return this.a.getMetadata(this.e+n)}getLanguageId(n){return this.a.getLanguageId(this.e+n)}getLineContent(){return this.a.getLineContent().substring(this.b,this.c)}equals(n){return n instanceof T?this.b===n.b&&this.c===n.c&&this.d===n.d&&this.a.slicedEquals(n.a,this.e,this.f):!1}getCount(){return this.f}getForeground(n){return this.a.getForeground(this.e+n)}getEndOffset(n){const c=this.a.getEndOffset(this.e+n);return Math.min(this.c,c)-this.b+this.d}getClassName(n){return this.a.getClassName(this.e+n)}getInlineStyle(n,c){return this.a.getInlineStyle(this.e+n,c)}getPresentation(n){return this.a.getPresentation(this.e+n)}findTokenIndexAtOffset(n){return this.a.findTokenIndexAtOffset(n+this.b-this.d)-this.e}}}),define(W[25],p([0,1,7]),function(F,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32Array=e.ContiguousTokensEditing=e.EMPTY_LINE_TOKENS=void 0,e.EMPTY_LINE_TOKENS=new Uint32Array(0).buffer;class k{static deleteBeginning(n,c){return n===null||n===e.EMPTY_LINE_TOKENS?n:k.delete(n,0,c)}static deleteEnding(n,c){if(n===null||n===e.EMPTY_LINE_TOKENS)return n;const t=T(n),i=t[t.length-2];return k.delete(n,c,i)}static delete(n,c,t){if(n===null||n===e.EMPTY_LINE_TOKENS||c===t)return n;const i=T(n),r=i.length>>>1;if(c===0&&i[i.length-2]===t)return e.EMPTY_LINE_TOKENS;const s=E.LineTokens.findIndexInTokensArray(i,c),m=s>0?i[s-1<<1]:0,w=i[s<<1];if(t<w){const A=t-c;for(let B=s;B<r;B++)i[B<<1]-=A;return n}let u,a;m!==c?(i[s<<1]=c,u=s+1<<1,a=c):(u=s<<1,a=m);const h=t-c;for(let A=s+1;A<r;A++){const B=i[A<<1]-h;B>a&&(i[u++]=B,i[u++]=i[(A<<1)+1],a=B)}if(u===i.length)return n;const O=new Uint32Array(u);return O.set(i.subarray(0,u),0),O.buffer}static append(n,c){if(c===e.EMPTY_LINE_TOKENS)return n;if(n===e.EMPTY_LINE_TOKENS)return c;if(n===null)return n;if(c===null)return null;const t=T(n),i=T(c),r=i.length>>>1,s=new Uint32Array(t.length+i.length);s.set(t,0);let m=t.length;const w=t[t.length-2];for(let u=0;u<r;u++)s[m++]=i[u<<1]+w,s[m++]=i[(u<<1)+1];return s.buffer}static insert(n,c,t){if(n===null||n===e.EMPTY_LINE_TOKENS)return n;const i=T(n),r=i.length>>>1;let s=E.LineTokens.findIndexInTokensArray(i,c);s>0&&i[s-1<<1]===c&&s--;for(let m=s;m<r;m++)i[m<<1]+=t;return n}}e.ContiguousTokensEditing=k;function T(I){return I instanceof Uint32Array?I:new Uint32Array(I)}e.toUint32Array=T}),define(W[26],p([0,1,24,11,39,12,25,14]),function(F,e,E,k,T,I,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokens=void 0;class t{static deserialize(r,s,m){const w=new Uint32Array(r.buffer),u=(0,k.readUInt32BE)(r,s);s+=4;const a=(0,k.readUInt32BE)(r,s);s+=4;const h=[];for(let O=0;O<a;O++){const A=(0,k.readUInt32BE)(r,s);s+=4,h.push(w.subarray(s/4,s/4+A/4)),s+=A}return m.push(new t(u,h)),s}get startLineNumber(){return this.a}get endLineNumber(){return this.a+this.b.length-1}constructor(r,s){this.a=r,this.b=s}getLineRange(){return new c.LineRange(this.a,this.a+this.b.length)}getLineTokens(r){return this.b[r-this.a]}appendLineTokens(r){this.b.push(r)}serializeSize(){let r=0;r+=4,r+=4;for(let s=0;s<this.b.length;s++){const m=this.b[s];if(!(m instanceof Uint32Array))throw new Error("Not supported!");r+=4,r+=m.byteLength}return r}serialize(r,s){(0,k.writeUInt32BE)(r,this.a,s),s+=4,(0,k.writeUInt32BE)(r,this.b.length,s),s+=4;for(let m=0;m<this.b.length;m++){const w=this.b[m];if(!(w instanceof Uint32Array))throw new Error("Not supported!");(0,k.writeUInt32BE)(r,w.byteLength,s),s+=4,r.set(new Uint8Array(w.buffer),s),s+=w.byteLength}return s}applyEdit(r,s){const[m,w]=(0,I.countEOL)(s);this.c(r),this.d(new T.Position(r.startLineNumber,r.startColumn),m,w)}c(r){if(r.startLineNumber===r.endLineNumber&&r.startColumn===r.endColumn)return;const s=r.startLineNumber-this.a,m=r.endLineNumber-this.a;if(m<0){const w=m-s;this.a-=w;return}if(!(s>=this.b.length)){if(s<0&&m>=this.b.length){this.a=0,this.b=[];return}if(s===m){this.b[s]=n.ContiguousTokensEditing.delete(this.b[s],r.startColumn-1,r.endColumn-1);return}if(s>=0)if(this.b[s]=n.ContiguousTokensEditing.deleteEnding(this.b[s],r.startColumn-1),m<this.b.length){const w=n.ContiguousTokensEditing.deleteBeginning(this.b[m],r.endColumn-1);this.b[s]=n.ContiguousTokensEditing.append(this.b[s],w),this.b.splice(s+1,m-s)}else this.b[s]=n.ContiguousTokensEditing.append(this.b[s],null),this.b=this.b.slice(0,s+1);else{const w=-s;this.a-=w,this.b[m]=n.ContiguousTokensEditing.deleteBeginning(this.b[m],r.endColumn-1),this.b=this.b.slice(m)}}}d(r,s,m){if(s===0&&m===0)return;const w=r.lineNumber-this.a;if(w<0){this.a+=s;return}if(!(w>=this.b.length)){if(s===0){this.b[w]=n.ContiguousTokensEditing.insert(this.b[w],r.column-1,m);return}this.b[w]=n.ContiguousTokensEditing.deleteEnding(this.b[w],r.column-1),this.b[w]=n.ContiguousTokensEditing.insert(this.b[w],r.column-1,m),this.e(r.lineNumber,s)}}e(r,s){if(s===0)return;const m=[];for(let w=0;w<s;w++)m[w]=null;this.b=E.arrayInsert(this.b,r,m)}}e.ContiguousMultilineTokens=t}),define(W[15],p([0,1,11,26]),function(F,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ContiguousMultilineTokensBuilder=void 0;class T{static deserialize(n){let c=0;const t=(0,E.readUInt32BE)(n,c);c+=4;const i=[];for(let r=0;r<t;r++)c=k.ContiguousMultilineTokens.deserialize(n,c,i);return i}constructor(){this.a=[]}add(n,c){if(this.a.length>0){const t=this.a[this.a.length-1];if(t.endLineNumber+1===n){t.appendLineTokens(c);return}}this.a.push(new k.ContiguousMultilineTokens(n,[c]))}finalize(){return this.a}serialize(){const n=this.b(),c=new Uint8Array(n);return this.c(c),c}b(){let n=0;n+=4;for(let c=0;c<this.a.length;c++)n+=this.a[c].serializeSize();return n}c(n){let c=0;(0,E.writeUInt32BE)(n,this.a.length,c),c+=4;for(let t=0;t<this.a.length;t++)c=this.a[t].serialize(n,c)}}e.ContiguousMultilineTokensBuilder=T}),define(W[27],p([0,1,28,5,29,40]),function(F,e,E,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function n(d){return d===47||d===92}e.isPathSeparator=n;function c(d){return d.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=c;function t(d){return d.indexOf("/")===-1&&(d=c(d)),/^[a-zA-Z]:(\/|$)/.test(d)&&(d="/"+d),d}e.toPosixPath=t;function i(d,g=E.posix.sep){if(!d)return"";const l=d.length,C=d.charCodeAt(0);if(n(C)){if(n(d.charCodeAt(1))&&!n(d.charCodeAt(2))){let D=3;const q=D;for(;D<l&&!n(d.charCodeAt(D));D++);if(q!==D&&!n(d.charCodeAt(D+1))){for(D+=1;D<l;D++)if(n(d.charCodeAt(D)))return d.slice(0,D+1).replace(/[\\/]/g,g)}}return g}else if(O(C)&&d.charCodeAt(1)===58)return n(d.charCodeAt(2))?d.slice(0,2)+g:d.slice(0,2);let z=d.indexOf("://");if(z!==-1){for(z+=3;z<l;z++)if(n(d.charCodeAt(z)))return d.slice(0,z+1)}return""}e.getRoot=i;function r(d){if(!k.isWindows||!d||d.length<5)return!1;let g=d.charCodeAt(0);if(g!==92||(g=d.charCodeAt(1),g!==92))return!1;let l=2;const C=l;for(;l<d.length&&(g=d.charCodeAt(l),g!==92);l++);return!(C===l||(g=d.charCodeAt(l+1),isNaN(g)||g===92))}e.isUNC=r;const s=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function u(d,g=k.isWindows){const l=g?s:m;return!(!d||d.length===0||/^\s+$/.test(d)||(l.lastIndex=0,l.test(d))||g&&w.test(d)||d==="."||d===".."||g&&d[d.length-1]==="."||g&&d.length!==d.trim().length||d.length>255)}e.isValidBasename=u;function a(d,g,l){const C=d===g;return!l||C?C:!d||!g?!1:(0,T.equalsIgnoreCase)(d,g)}e.isEqual=a;function h(d,g,l,C=E.sep){if(d===g)return!0;if(!d||!g||g.length>d.length)return!1;if(l){if(!(0,T.startsWithIgnoreCase)(d,g))return!1;if(g.length===d.length)return!0;let D=g.length;return g.charAt(g.length-1)===C&&D--,d.charAt(D)===C}return g.charAt(g.length-1)!==C&&(g+=C),d.indexOf(g)===0}e.isEqualOrParent=h;function O(d){return d>=65&&d<=90||d>=97&&d<=122}e.isWindowsDriveLetter=O;function A(d,g){return k.isWindows&&d.endsWith(":")&&(d+=E.sep),(0,E.isAbsolute)(d)||(d=(0,E.join)(g,d)),d=(0,E.normalize)(d),k.isWindows?(d=(0,T.rtrim)(d,E.sep),d.endsWith(":")&&(d+=E.sep)):(d=(0,T.rtrim)(d,E.sep),d||(d=E.sep)),d}e.sanitizeFilePath=A;function B(d){const g=(0,E.normalize)(d);return k.isWindows?d.length>3?!1:R(g)&&(d.length===2||g.charCodeAt(2)===92):g===E.posix.sep}e.isRootOrDriveLetter=B;function R(d,g=k.isWindows){return g?O(d.charCodeAt(0))&&d.charCodeAt(1)===58:!1}e.hasDriveLetter=R;function y(d){return R(d)?d[0]:void 0}e.getDriveLetter=y;function f(d,g,l){return g.length>d.length?-1:d===g?0:(l&&(d=d.toLowerCase(),g=g.toLowerCase()),d.indexOf(g))}e.indexOfPath=f;function b(d){const g=d.split(":");let l,C,z;for(const D of g){const q=Number(D);(0,I.isNumber)(q)?C===void 0?C=q:z===void 0&&(z=q):l=l?[l,D].join(":"):D}if(!l)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:l,line:C!==void 0?C:void 0,column:z!==void 0?z:C!==void 0?1:void 0}}e.parseLineAndColumnAware=b;const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",L="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function U(d,g,l=8){let C="";for(let D=0;D<l;D++){let q;D===0&&k.isWindows&&!g&&(l===3||l===4)?q=L:q=v,C+=q.charAt(Math.floor(Math.random()*q.length))}let z;return g?z=`${g}-${C}`:z=C,d?(0,E.join)(d,z):z}e.randomPath=U}),define(W[30],p([0,1,4,5,16]),function(F,e,E,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var I;(function(i){i.inMemory="inmemory",i.vscode="vscode",i.internal="private",i.walkThrough="walkThrough",i.walkThroughSnippet="walkThroughSnippet",i.http="http",i.https="https",i.file="file",i.mailto="mailto",i.untitled="untitled",i.data="data",i.command="command",i.vscodeRemote="vscode-remote",i.vscodeRemoteResource="vscode-remote-resource",i.vscodeUserData="vscode-userdata",i.vscodeCustomEditor="vscode-custom-editor",i.vscodeNotebookCell="vscode-notebook-cell",i.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",i.vscodeNotebookCellOutput="vscode-notebook-cell-output",i.vscodeInteractive="vscode-interactive",i.vscodeInteractiveInput="vscode-interactive-input",i.vscodeSettings="vscode-settings",i.vscodeWorkspaceTrust="vscode-workspace-trust",i.vscodeTerminal="vscode-terminal",i.vscodeInteractiveSesssion="vscode-chat-editor",i.webviewPanel="webview-panel",i.vscodeWebview="vscode-webview",i.extension="extension",i.vscodeFileResource="vscode-file",i.tmp="tmp",i.vsls="vsls",i.vscodeSourceControl="vscode-scm"})(I||(e.Schemas=I={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class n{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${I.vscodeRemoteResource}`}setPreferredWebSchema(r){this.d=r}setDelegate(r){this.e=r}setServerRootPath(r){this.f=`${r}/${I.vscodeRemoteResource}`}set(r,s,m){this.a[r]=s,this.b[r]=m}setConnectionToken(r,s){this.c[r]=s}getPreferredWebSchema(){return this.d}rewrite(r){if(this.e)try{return this.e(r)}catch(h){return E.onUnexpectedError(h),r}const s=r.authority;let m=this.a[s];m&&m.indexOf(":")!==-1&&m.indexOf("[")===-1&&(m=`[${m}]`);const w=this.b[s],u=this.c[s];let a=`path=${encodeURIComponent(r.path)}`;return typeof u=="string"&&(a+=`&${e.connectionTokenQueryName}=${encodeURIComponent(u)}`),T.URI.from({scheme:k.isWeb?this.d:I.vscodeRemoteResource,authority:`${m}:${w}`,path:this.f,query:a})}}e.RemoteAuthorities=new n,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class c{asBrowserUri(r){const s=this.b(r,F);return this.uriToBrowserUri(s)}uriToBrowserUri(r){return r.scheme===I.vscodeRemote?e.RemoteAuthorities.rewrite(r):r.scheme===I.file&&(k.isNative||k.isWebWorker&&k.globals.origin===`${I.vscodeFileResource}://${c.a}`)?r.with({scheme:I.vscodeFileResource,authority:r.authority||c.a,query:null,fragment:null}):r}asFileUri(r){const s=this.b(r,F);return this.uriToFileUri(s)}uriToFileUri(r){return r.scheme===I.vscodeFileResource?r.with({scheme:I.file,authority:r.authority!==c.a?r.authority:null,query:null,fragment:null}):r}b(r,s){return T.URI.isUri(r)?r:T.URI.parse(s.toUrl(r))}}c.a="vscode-app",e.FileAccess=new c;var t;(function(i){const r=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);i.CoopAndCoep=Object.freeze(r.get("3"));const s="vscode-coi";function m(u){let a;typeof u=="string"?a=new URL(u).searchParams:u instanceof URL?a=u.searchParams:T.URI.isUri(u)&&(a=new URL(u.toString(!0)).searchParams);const h=a?.get(s);if(h)return r.get(h)}i.getHeadersFromQuery=m;function w(u,a,h){if(!globalThis.crossOriginIsolated)return;const O=a&&h?"3":h?"2":"1";u instanceof URLSearchParams?u.set(s,O):u[s]=O}i.addSearchParam=w})(t||(e.COI=t={}))}),define(W[17],p([0,1,27,30,28,5,29,16]),function(F,e,E,k,T,I,n,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function t(w){return(0,c.uriToFsPath)(w,!0)}e.originalFSPath=t;class i{constructor(u){this.a=u}compare(u,a,h=!1){return u===a?0:(0,n.compare)(this.getComparisonKey(u,h),this.getComparisonKey(a,h))}isEqual(u,a,h=!1){return u===a?!0:!u||!a?!1:this.getComparisonKey(u,h)===this.getComparisonKey(a,h)}getComparisonKey(u,a=!1){return u.with({path:this.a(u)?u.path.toLowerCase():void 0,fragment:a?null:void 0}).toString()}ignorePathCasing(u){return this.a(u)}isEqualOrParent(u,a,h=!1){if(u.scheme===a.scheme){if(u.scheme===k.Schemas.file)return E.isEqualOrParent(t(u),t(a),this.a(u))&&u.query===a.query&&(h||u.fragment===a.fragment);if((0,e.isEqualAuthority)(u.authority,a.authority))return E.isEqualOrParent(u.path,a.path,this.a(u),"/")&&u.query===a.query&&(h||u.fragment===a.fragment)}return!1}joinPath(u,...a){return c.URI.joinPath(u,...a)}basenameOrAuthority(u){return(0,e.basename)(u)||u.authority}basename(u){return T.posix.basename(u.path)}extname(u){return T.posix.extname(u.path)}dirname(u){if(u.path.length===0)return u;let a;return u.scheme===k.Schemas.file?a=c.URI.file(T.dirname(t(u))).path:(a=T.posix.dirname(u.path),u.authority&&a.length&&a.charCodeAt(0)!==47&&(console.error(`dirname("${u.toString})) resulted in a relative path`),a="/")),u.with({path:a})}normalizePath(u){if(!u.path.length)return u;let a;return u.scheme===k.Schemas.file?a=c.URI.file(T.normalize(t(u))).path:a=T.posix.normalize(u.path),u.with({path:a})}relativePath(u,a){if(u.scheme!==a.scheme||!(0,e.isEqualAuthority)(u.authority,a.authority))return;if(u.scheme===k.Schemas.file){const A=T.relative(t(u),t(a));return I.isWindows?E.toSlashes(A):A}let h=u.path||"/";const O=a.path||"/";if(this.a(u)){let A=0;for(const B=Math.min(h.length,O.length);A<B&&!(h.charCodeAt(A)!==O.charCodeAt(A)&&h.charAt(A).toLowerCase()!==O.charAt(A).toLowerCase());A++);h=O.substr(0,A)+h.substr(A)}return T.posix.relative(h,O)}resolvePath(u,a){if(u.scheme===k.Schemas.file){const h=c.URI.file(T.resolve(t(u),a));return u.with({authority:h.authority,path:h.path})}return a=E.toPosixPath(a),u.with({path:T.posix.resolve(u.path,a)})}isAbsolutePath(u){return!!u.path&&u.path[0]==="/"}isEqualAuthority(u,a){return u===a||u!==void 0&&a!==void 0&&(0,n.equalsIgnoreCase)(u,a)}hasTrailingPathSeparator(u,a=T.sep){if(u.scheme===k.Schemas.file){const h=t(u);return h.length>E.getRoot(h).length&&h[h.length-1]===a}else{const h=u.path;return h.length>1&&h.charCodeAt(h.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(u.fsPath)}}removeTrailingPathSeparator(u,a=T.sep){return(0,e.hasTrailingPathSeparator)(u,a)?u.with({path:u.path.substr(0,u.path.length-1)}):u}addTrailingPathSeparator(u,a=T.sep){let h=!1;if(u.scheme===k.Schemas.file){const O=t(u);h=O!==void 0&&O.length===E.getRoot(O).length&&O[O.length-1]===a}else{a="/";const O=u.path;h=O.length===1&&O.charCodeAt(O.length-1)===47}return!h&&!(0,e.hasTrailingPathSeparator)(u,a)?u.with({path:u.path+"/"}):u}}e.ExtUri=i,e.extUri=new i(()=>!1),e.extUriBiasedIgnorePathCase=new i(w=>w.scheme===k.Schemas.file?!I.isLinux:!0),e.extUriIgnorePathCase=new i(w=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function r(w,u){const a=[];for(let h=0;h<w.length;h++){const O=u(w[h]);w.some((A,B)=>B===h?!1:(0,e.isEqualOrParent)(O,u(A)))||a.push(w[h])}return a}e.distinctParents=r;var s;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function u(a){const h=new Map;a.path.substring(a.path.indexOf(";")+1,a.path.lastIndexOf(";")).split(";").forEach(B=>{const[R,y]=B.split(":");R&&y&&h.set(R,y)});const A=a.path.substring(0,a.path.indexOf(";"));return A&&h.set(w.META_DATA_MIME,A),h}w.parseMetaData=u})(s||(e.DataUri=s={}));function m(w,u,a){if(u){let h=w.path;return h&&h[0]!==T.posix.sep&&(h=T.posix.sep+h),w.with({scheme:a,authority:u,path:h})}return w.with({scheme:a})}e.toLocalResource=m}),define(W[18],p([0,1,41,4,31,2,17,5,22]),function(F,e,E,k,T,I,n,c,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function i(M){return!!M&&typeof M.then=="function"}e.isThenable=i;function r(M){const o=new E.CancellationTokenSource,S=M(o.token),P=new Promise((N,j)=>{const G=o.token.onCancellationRequested(()=>{G.dispose(),o.dispose(),j(new k.CancellationError)});Promise.resolve(S).then(H=>{G.dispose(),o.dispose(),N(H)},H=>{G.dispose(),o.dispose(),j(H)})});return new class{cancel(){o.cancel()}then(N,j){return P.then(N,j)}catch(N){return this.then(void 0,N)}finally(N){return P.finally(N)}}}e.createCancelablePromise=r;function s(M,o,S){return new Promise((P,N)=>{const j=o.onCancellationRequested(()=>{j.dispose(),P(S)});M.then(P,N).finally(()=>j.dispose())})}e.raceCancellation=s;function m(M,o){return new Promise((S,P)=>{const N=o.onCancellationRequested(()=>{N.dispose(),P(new k.CancellationError)});M.then(S,P).finally(()=>N.dispose())})}e.raceCancellationError=m;async function w(M){let o=-1;const S=M.map((P,N)=>P.then(j=>(o=N,j)));try{return await Promise.race(S)}finally{M.forEach((P,N)=>{N!==o&&P.cancel()})}}e.raceCancellablePromises=w;function u(M,o,S){let P;const N=setTimeout(()=>{P?.(void 0),S?.()},o);return Promise.race([M.finally(()=>clearTimeout(N)),new Promise(j=>P=j)])}e.raceTimeout=u;function a(M){return new Promise((o,S)=>{const P=M();i(P)?P.then(o,S):o(P)})}e.asPromise=a;class h{constructor(){this.a=null,this.b=null,this.d=null}queue(o){if(this.a){if(this.d=o,!this.b){const S=()=>{this.b=null;const P=this.queue(this.d);return this.d=null,P};this.b=new Promise(P=>{this.a.then(S,S).then(P)})}return new Promise((S,P)=>{this.b.then(S,P)})}return this.a=o(),new Promise((S,P)=>{this.a.then(N=>{this.a=null,S(N)},N=>{this.a=null,P(N)})})}}e.Throttler=h;class O{constructor(){this.a=Promise.resolve(null)}queue(o){return this.a=this.a.then(()=>o(),()=>o())}}e.Sequencer=O;class A{constructor(){this.a=new Map}queue(o,S){const N=(this.a.get(o)??Promise.resolve()).catch(()=>{}).then(S).finally(()=>{this.a.get(o)===N&&this.a.delete(o)});return this.a.set(o,N),N}}e.SequencerByKey=A;const B=(M,o)=>{let S=!0;const P=setTimeout(()=>{S=!1,o()},M);return{isTriggered:()=>S,dispose:()=>{clearTimeout(P),S=!1}}},R=M=>{let o=!0;return queueMicrotask(()=>{o&&(o=!1,M())}),{isTriggered:()=>o,dispose:()=>{o=!1}}};class y{constructor(o){this.defaultDelay=o,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(o,S=this.defaultDelay){this.g=o,this.h(),this.b||(this.b=new Promise((N,j)=>{this.d=N,this.f=j}).then(()=>{if(this.b=null,this.d=null,this.g){const N=this.g;return this.g=null,N()}}));const P=()=>{this.a=null,this.d?.(null)};return this.a=S===t.MicrotaskDelay?R(P):B(S,P),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new k.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=y;class f{constructor(o){this.a=new y(o),this.b=new h}trigger(o,S){return this.a.trigger(()=>this.b.queue(o),S)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=f;class b{constructor(){this.a=!1,this.b=new Promise((o,S)=>{this.d=o})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=b;class v extends b{constructor(o){super(),this.f=setTimeout(()=>this.open(),o)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=v;function L(M,o){return o?new Promise((S,P)=>{const N=setTimeout(()=>{j.dispose(),S()},M),j=o.onCancellationRequested(()=>{clearTimeout(N),j.dispose(),P(new k.CancellationError)})}):r(S=>L(M,S))}e.timeout=L;function U(M,o=0){const S=setTimeout(M,o);return(0,I.toDisposable)(()=>clearTimeout(S))}e.disposableTimeout=U;function d(M){const o=[];let S=0;const P=M.length;function N(){return S<P?M[S++]():null}function j(G){G!=null&&o.push(G);const H=N();return H?H.then(j):Promise.resolve(o)}return Promise.resolve(null).then(j)}e.sequence=d;function g(M,o=P=>!!P,S=null){let P=0;const N=M.length,j=()=>{if(P>=N)return Promise.resolve(S);const G=M[P++];return Promise.resolve(G()).then(Y=>o(Y)?Promise.resolve(Y):j())};return j()}e.first=g;function l(M,o=P=>!!P,S=null){if(M.length===0)return Promise.resolve(S);let P=M.length;const N=()=>{P=-1;for(const j of M)j.cancel?.()};return new Promise((j,G)=>{for(const H of M)H.then(Y=>{--P>=0&&o(Y)?(N(),j(Y)):P===0&&j(S)}).catch(Y=>{--P>=0&&(N(),G(Y))})})}e.firstParallel=l;class C{constructor(o){this.a=0,this.d=o,this.f=[],this.b=0,this.g=new T.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(o){return this.a++,new Promise((S,P)=>{this.f.push({factory:o,c:S,e:P}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const o=this.f.shift();this.b++;const S=o.factory();S.then(o.c,o.e),S.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=C;class z extends C{constructor(){super(1)}}e.Queue=z;class D{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const o=new Z;return this.b.add(o),o.p}d(){for(const[,o]of this.a)if(o.size>0)return!1;return!0}queueFor(o,S=n.extUri){const P=S.getComparisonKey(o);let N=this.a.get(P);return N||(N=new z,T.Event.once(N.onDrained)(()=>{N?.dispose(),this.a.delete(P),this.f()}),this.a.set(P,N)),N}f(){this.d()&&this.g()}g(){for(const o of this.b)o.complete();this.b.clear()}dispose(){for(const[,o]of this.a)o.dispose();this.a.clear(),this.g()}}e.ResourceQueue=D;class q{constructor(o,S){this.a=-1,typeof o=="function"&&typeof S=="number"&&this.setIfNotSet(o,S)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(o,S){this.cancel(),this.a=setTimeout(()=>{this.a=-1,o()},S)}setIfNotSet(o,S){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,o()},S))}}e.TimeoutTimer=q;class ${constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(o,S){this.cancel(),this.a=setInterval(()=>{o()},S)}}e.IntervalTimer=$;class _{constructor(o,S){this.b=-1,this.a=o,this.d=S,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(o=this.d){this.cancel(),this.b=setTimeout(this.f,o)}get delay(){return this.d}set delay(o){this.d=o}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=_;class K{constructor(o,S){S%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${S}ms is not a multiple of 1000ms.`),this.a=o,this.b=S,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(o=this.b){o%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${o}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(o/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=K;class Q extends _{constructor(o,S){super(o,S),this.j=[]}work(o){this.j.push(o),this.isScheduled()||this.schedule()}h(){const o=this.j;this.j=[],this.a?.(o)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=Q;class ne extends I.Disposable{constructor(o,S){super(),this.g=o,this.h=S,this.a=[],this.b=this.B(new I.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(o){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+o.length>this.g.maxBufferedWork)return!1}else if(this.pending+o.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const S of o)this.a.push(S);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new _(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=ne,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=M=>{(0,c.setTimeout0)(()=>{if(o)return;const S=Date.now()+15;M(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,S-Date.now())}}))});let o=!1;return{dispose(){o||(o=!0)}}}:e.runWhenIdle=(M,o)=>{const S=requestIdleCallback(M,typeof o=="number"?{timeout:o}:void 0);let P=!1;return{dispose(){P||(P=!0,cancelIdleCallback(S))}}}}();class ie{constructor(o){this.d=!1,this.a=()=>{try{this.f=o()}catch(S){this.g=S}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=ie;async function re(M,o,S){let P;for(let N=0;N<S;N++)try{return await M()}catch(j){P=j,await L(o)}throw P}e.retry=re;class se{hasPending(o){return this.a?typeof o=="number"?this.a.taskId===o:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(o,S,P){return this.a={taskId:o,cancel:()=>P?.(),promise:S},S.then(()=>this.d(o),()=>this.d(o)),S}d(o){this.a&&o===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const o=this.b;this.b=void 0,o.run().then(o.promiseResolve,o.promiseReject)}}setNext(o){if(this.b)this.b.run=o;else{let S,P;const N=new Promise((j,G)=>{S=j,P=G});this.b={run:o,promise:N,promiseResolve:S,promiseReject:P}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=se;class ae{constructor(o,S=()=>Date.now()){this.d=o,this.f=S,this.a=0,this.b=0}increment(){const o=this.f();return o-this.a>this.d&&(this.a=o,this.b=0),this.b++,this.b}}e.IntervalCounter=ae;class Z{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((o,S)=>{this.a=o,this.b=S})}complete(o){return new Promise(S=>{this.a(o),this.f=!0,S()})}error(o){return new Promise(S=>{this.b(o),this.d=!0,S()})}cancel(){new Promise(o=>{this.b(new k.CancellationError),this.d=!0,o()})}}e.DeferredPromise=Z;var X;(function(M){async function o(P){let N;const j=await Promise.all(P.map(G=>G.then(H=>H,H=>{N||(N=H)})));if(typeof N<"u")throw N;return j}M.settled=o;function S(P){return new Promise(async(N,j)=>{try{await P(N,j)}catch(G){j(G)}})}M.withAsyncBody=S})(X||(e.Promises=X={}));var J;(function(M){M[M.Initial=0]="Initial",M[M.DoneOK=1]="DoneOK",M[M.DoneError=2]="DoneError"})(J||(J={}));class V{static fromArray(o){return new V(S=>{S.emitMany(o)})}static fromPromise(o){return new V(async S=>{S.emitMany(await o)})}static fromPromises(o){return new V(async S=>{await Promise.all(o.map(async P=>S.emitOne(await P)))})}static merge(o){return new V(async S=>{await Promise.all(o.map(async P=>{for await(const N of P)S.emitOne(N)}))})}constructor(o){this.a=0,this.b=[],this.d=null,this.f=new T.Emitter,queueMicrotask(async()=>{const S={emitOne:P=>this.g(P),emitMany:P=>this.h(P),reject:P=>this.k(P)};try{await Promise.resolve(o(S)),this.j()}catch(P){this.k(P)}finally{S.emitOne=void 0,S.emitMany=void 0,S.reject=void 0}})}[Symbol.asyncIterator](){let o=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(o<this.b.length)return{done:!1,value:this.b[o++]};if(this.a===1)return{done:!0,value:void 0};await T.Event.toPromise(this.f.event)}while(!0)}}}static map(o,S){return new V(async P=>{for await(const N of o)P.emitOne(S(N))})}map(o){return V.map(this,o)}static filter(o,S){return new V(async P=>{for await(const N of o)S(N)&&P.emitOne(N)})}filter(o){return V.filter(this,o)}static coalesce(o){return V.filter(o,S=>!!S)}coalesce(){return V.coalesce(this)}static async toPromise(o){const S=[];for await(const P of o)S.push(P);return S}toPromise(){return V.toPromise(this)}g(o){this.a===0&&(this.b.push(o),this.f.fire())}h(o){this.a===0&&(this.b=this.b.concat(o),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(o){this.a===0&&(this.a=2,this.d=o,this.f.fire())}}e.AsyncIterableObject=V,V.EMPTY=V.fromArray([]);class x extends V{constructor(o,S){super(S),this.l=o}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=x;function oe(M){const o=new E.CancellationTokenSource,S=M(o.token);return new x(o,async P=>{const N=o.token.onCancellationRequested(()=>{N.dispose(),o.dispose(),P.reject(new k.CancellationError)});try{for await(const j of S){if(o.token.isCancellationRequested)return;P.emitOne(j)}N.dispose(),o.dispose()}catch(j){N.dispose(),o.dispose(),P.reject(j)}})}e.createCancelableAsyncIterable=oe}),define(W[19],p([0,1,32]),function(F,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nullTokenizeEncoded=e.nullTokenize=e.NullState=void 0,e.NullState=new class{clone(){return this}equals(I){return this===I}};function k(I,n){return new E.TokenizationResult([new E.Token(0,"",I)],n)}e.nullTokenize=k;function T(I,n){const c=new Uint32Array(2);return c[0]=0,c[1]=(I<<0|0<<8|0<<11|1<<15|2<<24)>>>0,new E.EncodedTokenizationResult(c,n===null?e.NullState:n)}e.nullTokenizeEncoded=T}),define(W[33],p([0,1,18,4,5,42,12,14,43,19,23,15,7]),function(F,e,E,k,T,I,n,c,t,i,r,s,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultBackgroundTokenizer=e.RangePriorityQueueImpl=e.TokenizationStateStore=e.TrackingTokenizationStateStore=e.TokenizerWithStateStoreAndTextModel=e.TokenizerWithStateStore=void 0;var w;(function(y){y[y.CHEAP_TOKENIZATION_LENGTH_LIMIT=2048]="CHEAP_TOKENIZATION_LENGTH_LIMIT"})(w||(w={}));class u{constructor(f,b){this.tokenizationSupport=b,this.a=this.tokenizationSupport.getInitialState(),this.store=new h(f)}getStartState(f){return f===1?this.a:this.store.getEndState(f-1)}}e.TokenizerWithStateStore=u;class a extends u{constructor(f,b,v,L){super(f,b),this._textModel=v,this._languageIdCodec=L}updateTokensUntilLine(f,b){const v=this._textModel.getLanguageId();for(;;){const L=this.store.getFirstInvalidEndStateLineNumber();if(!L||L>b)break;const U=this._textModel.getLineContent(L),d=this.getStartState(L),g=B(this._languageIdCodec,v,this.tokenizationSupport,U,!0,d);f.add(L,g.tokens),this.store.setEndState(L,g.endState)}}getTokenTypeIfInsertingCharacter(f,b){const v=this.getStartState(f.lineNumber);if(!v)return 0;const L=this._textModel.getLanguageId(),U=this._textModel.getLineContent(f.lineNumber),d=U.substring(0,f.column-1)+b+U.substring(f.column-1),g=B(this._languageIdCodec,L,this.tokenizationSupport,d,!0,v),l=new m.LineTokens(g.tokens,d,this._languageIdCodec);if(l.getCount()===0)return 0;const C=l.findTokenIndexAtOffset(f.column-1);return l.getStandardTokenType(C)}tokenizeLineWithEdit(f,b,v){const L=f.lineNumber,U=f.column,d=this.getStartState(L);if(!d)return null;const g=this._textModel.getLineContent(L),l=g.substring(0,U-1)+v+g.substring(U-1+b),C=this._textModel.getLanguageIdAtPosition(L,0),z=B(this._languageIdCodec,C,this.tokenizationSupport,l,!0,d);return new m.LineTokens(z.tokens,l,this._languageIdCodec)}isCheapToTokenize(f){const b=this.store.getFirstInvalidEndStateLineNumberOrMax();return f<b||f===b&&this._textModel.getLineLength(f)<2048}tokenizeHeuristically(f,b,v){if(v<=this.store.getFirstInvalidEndStateLineNumberOrMax())return{heuristicTokens:!1};if(b<=this.store.getFirstInvalidEndStateLineNumberOrMax())return this.updateTokensUntilLine(f,v),{heuristicTokens:!1};let L=this.b(b);const U=this._textModel.getLanguageId();for(let d=b;d<=v;d++){const g=this._textModel.getLineContent(d),l=B(this._languageIdCodec,U,this.tokenizationSupport,g,!0,L);f.add(d,l.tokens),L=l.endState}return{heuristicTokens:!0}}b(f){let b=this._textModel.getLineFirstNonWhitespaceColumn(f);const v=[];let L=null;for(let g=f-1;b>1&&g>=1;g--){const l=this._textModel.getLineFirstNonWhitespaceColumn(g);if(l!==0&&l<b&&(v.push(this._textModel.getLineContent(g)),b=l,L=this.getStartState(g),L))break}L||(L=this.tokenizationSupport.getInitialState()),v.reverse();const U=this._textModel.getLanguageId();let d=L;for(const g of v)d=B(this._languageIdCodec,U,this.tokenizationSupport,g,!1,d).endState;return d}}e.TokenizerWithStateStoreAndTextModel=a;class h{constructor(f){this.d=f,this.a=new O,this.b=new A,this.b.addRange(new t.OffsetRange(1,f+1))}getEndState(f){return this.a.getEndState(f)}setEndState(f,b){for(;;){const L=this.b.min;if(L!==null&&L<=f)this.b.removeMin();else break}const v=this.a.setEndState(f,b);return v&&f<this.d&&this.b.addRange(new t.OffsetRange(f+1,f+2)),v}acceptChange(f,b){this.d+=b-f.length,this.a.acceptChange(f,b),this.b.addRangeAndResize(new t.OffsetRange(f.startLineNumber,f.endLineNumberExclusive),b)}acceptChanges(f){for(const b of f){const[v]=(0,n.countEOL)(b.text);this.acceptChange(new c.LineRange(b.range.startLineNumber,b.range.endLineNumber+1),v+1)}}invalidateEndStateRange(f){this.b.addRange(new t.OffsetRange(f.startLineNumber,f.endLineNumberExclusive))}getFirstInvalidEndStateLineNumber(){return this.b.min}getFirstInvalidEndStateLineNumberOrMax(){return this.b.min||Number.MAX_SAFE_INTEGER}isTokenizationComplete(){return this.b.min===null}}e.TrackingTokenizationStateStore=h;class O{constructor(){this.a=new r.FixedArray(null)}getEndState(f){return this.a.get(f)}setEndState(f,b){const v=this.a.get(f);return v&&v.equals(b)?!1:(this.a.set(f,b),!0)}acceptChange(f,b){let v=f.length;b>0&&v>0&&(v--,b--),this.a.replace(f.startLineNumber,v,b)}acceptChanges(f){for(const b of f){const[v]=(0,n.countEOL)(b.text);this.acceptChange(new c.LineRange(b.range.startLineNumber,b.range.endLineNumber+1),v+1)}}}e.TokenizationStateStore=O;class A{constructor(){this.a=[]}getRanges(){return this.a}get min(){return this.a.length===0?null:this.a[0].start}removeMin(){if(this.a.length===0)return null;const f=this.a[0];return f.start+1===f.endExclusive?this.a.shift():this.a[0]=new t.OffsetRange(f.start+1,f.endExclusive),f.start}addRange(f){t.OffsetRange.addRange(f,this.a)}addRangeAndResize(f,b){let v=0;for(;!(v>=this.a.length||f.start<=this.a[v].endExclusive);)v++;let L=v;for(;!(L>=this.a.length||f.endExclusive<this.a[L].start);)L++;const U=b-f.length;for(let d=L;d<this.a.length;d++)this.a[d]=this.a[d].delta(U);if(v===L){const d=new t.OffsetRange(f.start,f.start+b);d.isEmpty||this.a.splice(v,0,d)}else{const d=Math.min(f.start,this.a[v].start),g=Math.max(f.endExclusive,this.a[L-1].endExclusive),l=new t.OffsetRange(d,g+U);l.isEmpty?this.a.splice(v,L-v):this.a.splice(v,L-v,l)}}toString(){return this.a.map(f=>f.toString()).join(" + ")}}e.RangePriorityQueueImpl=A;function B(y,f,b,v,L,U){let d=null;if(b)try{d=b.tokenizeEncoded(v,L,U.clone())}catch(g){(0,k.onUnexpectedError)(g)}return d||(d=(0,i.nullTokenizeEncoded)(y.encodeLanguageId(f),U)),m.LineTokens.convertToEndOffset(d.tokens,v.length),d}class R{constructor(f,b){this.b=f,this.d=b,this.a=!1,this.f=!1}dispose(){this.a=!0}handleChanges(){this.g()}g(){this.f||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.f=!0,(0,E.runWhenIdle)(f=>{this.f=!1,this.h(f)}))}h(f){const b=Date.now()+f.timeRemaining(),v=()=>{this.a||!this.b._textModel.isAttachedToEditor()||!this.k()||(this.j(),Date.now()<b?(0,T.setTimeout0)(v):this.g())};v()}j(){const f=this.b._textModel.getLineCount(),b=new s.ContiguousMultilineTokensBuilder,v=I.StopWatch.create(!1);do if(v.elapsed()>1||this.l(b)>=f)break;while(this.k());this.d.setTokens(b.finalize()),this.checkFinished()}k(){return this.b?!this.b.store.isTokenizationComplete():!1}l(f){if(!this.b||!this.k())return this.b._textModel.getLineCount()+1;const b=this.b.store.getFirstInvalidEndStateLineNumber();return this.b.updateTokensUntilLine(f,b),b}checkFinished(){this.a||this.b.store.isTokenizationComplete()&&this.d.backgroundTokenizationFinished()}requestTokens(f,b){this.b.store.invalidateEndStateRange(new c.LineRange(f,b))}}e.DefaultBackgroundTokenizer=R}),define(W[34],p([0,1,31,2,13,32]),function(F,e,E,k,T,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateTokenizationSupport=void 0;class n extends k.Disposable{constructor(t,i,r,s,m=()=>!1){super(),this.c=t,this.f=i,this.g=r,this.h=s,this.j=m,this.a=[],this.b=this.B(new E.Emitter),this.onDidEncounterLanguage=this.b.event}get backgroundTokenizerShouldOnlyVerifyTokens(){return this.j()}getInitialState(){return this.f}tokenize(t,i,r){throw new Error("Not supported!")}createBackgroundTokenizer(t,i){if(this.h)return this.h(t,i)}tokenizeEncoded(t,i,r){const s=this.c.tokenizeLine2(t,r,500);if(s.stoppedEarly)return console.warn(`Time limit reached when tokenizing line: ${t.substring(0,100)}`),new I.EncodedTokenizationResult(s.tokens,r);if(this.g){const w=this.a,u=s.tokens;for(let a=0,h=u.length>>>1;a<h;a++){const O=u[(a<<1)+1],A=T.TokenMetadata.getLanguageId(O);w[A]||(w[A]=!0,this.b.fire(A))}}let m;return r.equals(s.ruleStack)?m=r:m=s.ruleStack,new I.EncodedTokenizationResult(s.tokens,m)}}e.TextMateTokenizationSupport=n}),define(W[35],p([0,1,19,2,10]),function(F,e,E,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationSupportWithLineLimit=void 0;class I extends k.Disposable{get backgroundTokenizerShouldOnlyVerifyTokens(){return this.b.backgroundTokenizerShouldOnlyVerifyTokens}constructor(c,t,i){super(),this.a=c,this.b=t,this.c=i,this.B((0,T.keepAlive)(this.c))}getInitialState(){return this.b.getInitialState()}tokenize(c,t,i){throw new Error("Not supported!")}tokenizeEncoded(c,t,i){return c.length>=this.c.get()?(0,E.nullTokenizeEncoded)(this.a,i):this.b.tokenizeEncoded(c,t,i)}createBackgroundTokenizer(c,t){if(this.b.createBackgroundTokenizer)return this.b.createBackgroundTokenizer(c,t)}}e.TokenizationSupportWithLineLimit=I}),define(W[36],p([0,1,17]),function(F,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMScopeRegistry=void 0;class k{constructor(){this.a=Object.create(null)}reset(){this.a=Object.create(null)}register(I){if(this.a[I.scopeName]){const n=this.a[I.scopeName];E.isEqual(n.location,I.location)||console.warn(`Overwriting grammar scope name to file mapping for scope ${I.scopeName}.
Old grammar file: ${n.location.toString()}.
New grammar file: ${I.location.toString()}`)}this.a[I.scopeName]=I}getGrammarDefinition(I){return this.a[I]||null}}e.TMScopeRegistry=k}),define(W[37],p([0,1,2,36]),function(F,e,E,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TMGrammarFactory=e.missingTMGrammarErrorMessage=void 0,e.missingTMGrammarErrorMessage="No TM Grammar registered for this language.";class T extends E.Disposable{constructor(n,c,t,i){super(),this.a=n,this.b=t.INITIAL,this.c=new k.TMScopeRegistry,this.f={},this.g={},this.h=new Map,this.j=this.B(new t.Registry({onigLib:i,loadGrammar:async r=>{const s=this.c.getGrammarDefinition(r);if(!s)return this.a.logTrace(`No grammar found for scope ${r}`),null;const m=s.location;try{const w=await this.a.readFile(m);return t.parseRawGrammar(w,m.path)}catch(w){return this.a.logError(`Unable to load and parse grammar for scope ${r} from ${m}`,w),null}},getInjections:r=>{const s=r.split(".");let m=[];for(let w=1;w<=s.length;w++){const u=s.slice(0,w).join(".");m=[...m,...this.f[u]||[]]}return m}}));for(const r of c){if(this.c.register(r),r.injectTo){for(const s of r.injectTo){let m=this.f[s];m||(this.f[s]=m=[]),m.push(r.scopeName)}if(r.embeddedLanguages)for(const s of r.injectTo){let m=this.g[s];m||(this.g[s]=m=[]),m.push(r.embeddedLanguages)}}r.language&&this.h.set(r.language,r.scopeName)}}has(n){return this.h.has(n)}setTheme(n,c){this.j.setTheme(n,c)}getColorMap(){return this.j.getColorMap()}async createGrammar(n,c){const t=this.h.get(n);if(typeof t!="string")throw new Error(e.missingTMGrammarErrorMessage);const i=this.c.getGrammarDefinition(t);if(!i)throw new Error(e.missingTMGrammarErrorMessage);const r=i.embeddedLanguages;if(this.g[t]){const w=this.g[t];for(const u of w)for(const a of Object.keys(u))r[a]=u[a]}const s=Object.keys(r).length>0;let m;try{m=await this.j.loadGrammarWithConfiguration(t,c,{embeddedLanguages:r,tokenTypes:i.tokenTypes,balancedBracketSelectors:i.balancedBracketSelectors,unbalancedBracketSelectors:i.unbalancedBracketSelectors})}catch(w){throw w.message&&w.message.startsWith("No grammar provided for")?new Error(e.missingTMGrammarErrorMessage):w}return{languageId:n,grammar:m,initialState:this.b,containsEmbeddedLanguages:s}}}e.TMGrammarFactory=T}),define(W[38],p([0,1,44,33,45,15,7,34,18,10,35,14]),function(F,e,E,k,T,I,n,c,t,i,r,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextMateWorkerModel=void 0;class m extends E.MirrorTextModel{constructor(a,h,O,A,B,R,y,f){super(a,h,O,A),this.m=B,this.q=R,this.s=y,this.a=null,this.b=!1,this.c=(0,i.observableValue)("_maxTokenizationLineLength",-1),this.t=new t.RunOnceScheduler(()=>this.v(),10),this.c.set(f,void 0),this.u()}dispose(){this.b=!0,super.dispose()}onLanguageId(a,h){this.q=a,this.s=h,this.u()}onEvents(a){super.onEvents(a),this.a&&this.a.store.acceptChanges(a.changes),this.t.schedule()}acceptMaxTokenizationLineLength(a){this.c.set(a,void 0)}retokenize(a,h){this.a&&(this.a.store.invalidateEndStateRange(new s.LineRange(a,h)),this.t.schedule())}u(){this.a=null;const a=this.q,h=this.s;this.m.getOrCreateGrammar(a,h).then(O=>{if(!(this.b||a!==this.q||h!==this.s||!O)){if(O.grammar){const A=new r.TokenizationSupportWithLineLimit(this.s,new c.TextMateTokenizationSupport(O.grammar,O.initialState,!1),this.c);this.a=new k.TokenizerWithStateStore(this.f.length,A)}else this.a=null;this.v()}})}v(){if(this.b||!this.a)return;const a=new Date().getTime();for(;;){let h=0;const O=new I.ContiguousMultilineTokensBuilder,A=new w;for(;;){const y=this.a.store.getFirstInvalidEndStateLineNumber();if(y===null||h>200)break;h++;const f=this.f[y-1],b=this.a.getStartState(y),v=this.a.tokenizationSupport.tokenizeEncoded(f,!0,b);if(this.a.store.setEndState(y,v.endState)){const U=(0,T.diffStateStacksRefEq)(b,v.endState);A.setState(y,U)}else A.setState(y,null);if(n.LineTokens.convertToEndOffset(v.tokens,f.length),O.add(y,v.tokens),new Date().getTime()-a>20)break}if(h===0)break;const B=A.getStateDeltas();if(this.m.setTokensAndStates(this.d,this.h,O.serialize(),B),new Date().getTime()-a>20){setTimeout(()=>this.v(),3);return}}}}e.TextMateWorkerModel=m;class w{constructor(){this.a=-1,this.b=[]}setState(a,h){a===this.a+1?this.b[this.b.length-1].stateDeltas.push(h):this.b.push({startLineNumber:a,stateDeltas:[h]}),this.a=a}getStateDeltas(){return this.b}}}),define(W[46],p([0,1,16,37,38]),function(F,e,E,k,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=e.TextMateTokenizationWorker=void 0;class I{constructor(t,i){this.f=i,this.b=Object.create(null),this.c=[],this.a=t.host;const r=i.grammarDefinitions.map(s=>({location:E.URI.revive(s.location),language:s.language,scopeName:s.scopeName,embeddedLanguages:s.embeddedLanguages,tokenTypes:s.tokenTypes,injectTo:s.injectTo,balancedBracketSelectors:s.balancedBracketSelectors,unbalancedBracketSelectors:s.unbalancedBracketSelectors}));this.d=this.g(r)}async g(t){const i=this.f.textmateMainUri,r=await new Promise((a,h)=>{F([i],a,h)}),s=await new Promise((a,h)=>{F([this.f.onigurumaMainUri],a,h)}),w=await(await fetch(this.f.onigurumaWASMUri)).arrayBuffer();await s.loadWASM(w);const u=Promise.resolve({createOnigScanner:a=>s.createOnigScanner(a),createOnigString:a=>s.createOnigString(a)});return new k.TMGrammarFactory({logTrace:a=>{},logError:(a,h)=>console.error(a,h),readFile:a=>this.a.readFile(a)},t,r,u)}acceptNewModel(t){const i=E.URI.revive(t.uri),r=i.toString();this.b[r]=new T.TextMateWorkerModel(i,t.lines,t.EOL,t.versionId,this,t.languageId,t.encodedLanguageId,t.maxTokenizationLineLength)}acceptModelChanged(t,i){this.b[t].onEvents(i)}retokenize(t,i,r){this.b[t].retokenize(i,r)}acceptModelLanguageChanged(t,i,r){this.b[t].onLanguageId(i,r)}acceptRemovedModel(t){this.b[t]&&(this.b[t].dispose(),delete this.b[t])}async acceptTheme(t,i){(await this.d)?.setTheme(t,i)}acceptMaxTokenizationLineLength(t,i){this.b[t].acceptMaxTokenizationLineLength(i)}async getOrCreateGrammar(t,i){const r=await this.d;return r?(this.c[i]||(this.c[i]=r.createGrammar(t,i)),this.c[i]):Promise.resolve(null)}setTokensAndStates(t,i,r,s){this.a.setTokensAndStates(t,i,r,s)}}e.TextMateTokenizationWorker=I;function n(c,t){return new I(c,t)}e.create=n})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/undefined/core/vs/workbench/services/textMate/browser/worker/textMate.worker.js.map
